/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var re=["require","exports","vs/base/common/lifecycle","vs/base/common/event","vs/base/common/platform","vs/platform/instantiation/common/instantiation","vs/base/common/async","vs/base/common/uri","vs/platform/log/common/log","vs/base/common/errors","vs/base/common/path","vs/nls","vs/nls!vs/code/electron-browser/sharedProcess/sharedProcessMain","vs/platform/files/common/files","vs/platform/environment/common/environment","vs/base/common/types","vs/base/common/buffer","vs/base/common/resources","vs/base/common/arrays","vs/platform/configuration/common/configuration","vs/base/common/network","vs/base/common/cancellation","vs/platform/telemetry/common/telemetry","vs/platform/storage/common/storage","vs/platform/product/common/productService","vs/platform/userDataSync/common/userDataSync","vs/base/common/strings","vs/base/node/pfs","vs/platform/extensionManagement/common/extensionManagement","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/uuid","vs/base/common/objects","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/map","vs/base/common/json","vs/base/common/process","os","vs/base/common/errorMessage","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/common/stream","vs/platform/configuration/common/configurationRegistry","vs/platform/extensions/common/extensions","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/request/common/request","vs/platform/userDataSync/common/abstractSynchronizer","vs/base/common/extpath","vs/platform/externalServices/common/serviceMachineId","vs/platform/telemetry/common/telemetryUtils","vs/base/common/codicons","vs/base/common/iterator","vs/base/common/jsonFormatter","fs","child_process","vs/base/common/semver/semver","vs/platform/instantiation/common/descriptors","vs/platform/files/common/watcher","vs/platform/policy/common/policy","vs/platform/userDataSync/common/content","vs/base/common/decorators","vs/base/common/date","vs/base/common/hash","vs/base/common/marshalling","vs/base/parts/ipc/node/ipc.cp","vs/platform/extensions/common/extensionValidator","vs/platform/languagePacks/common/languagePacks","vs/platform/native/electron-sandbox/native","vs/platform/configuration/common/configurationModels","vs/platform/tunnel/common/tunnel","vs/platform/userDataSync/common/userDataSyncAccount","vs/platform/extensionManagement/common/extensionsScannerService","vs/platform/extensionManagement/common/extensionStorage","vs/platform/userDataSync/common/userDataSyncMachines","vs/base/common/functional","vs/base/common/jsonEdit","net","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/normalization","vs/base/common/severity","vs/base/common/glob","vs/base/node/powershell","vs/base/node/processes","vs/base/parts/ipc/common/ipc.net","electron","vs/base/parts/storage/common/storage","vs/platform/environment/common/environmentService","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/download/common/download","vs/platform/extensionRecommendations/common/extensionRecommendations","vs/platform/files/common/io","vs/platform/instantiation/common/serviceCollection","vs/platform/ipc/electron-sandbox/services","vs/platform/log/common/logIpc","vs/platform/product/common/product","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/remote/common/remoteHosts","vs/platform/sharedProcess/common/sharedProcessWorkerService","vs/platform/sign/common/sign","vs/platform/telemetry/common/commonProperties","vs/platform/telemetry/common/telemetryIpc","vs/platform/telemetry/common/telemetryLogAppender","vs/platform/telemetry/common/telemetryService","vs/platform/terminal/common/terminal","vs/platform/theme/common/themeService","vs/platform/userDataSync/common/ignoredExtensions","vs/base/node/zip","vs/platform/extensionManagement/node/extensionManagementService","vs/base/common/assert","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/skipList","vs/base/node/macAddress","vs/base/node/ports","vs/base/parts/request/common/request","vs/base/parts/request/browser/request","vs/nls!vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/nls!vs/base/common/platform","vs/base/common/mime","vs/base/common/stopwatch","vs/base/common/cache","vs/base/common/console","vs/base/common/uriIpc","vs/base/node/id","vs/base/node/extpath","vs/base/node/ps","vs/base/node/shell","vs/base/parts/ipc/common/ipc.mp","vs/base/parts/ipc/electron-browser/ipc.mp","vs/base/parts/ipc/node/ipc.net","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/environment/node/argv","vs/nls!vs/platform/environment/node/argvHelper","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/terminal/common/terminalPlatformConfiguration","vs/nls!vs/platform/terminal/common/terminalProfiles","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/userDataSync/common/abstractSynchronizer","vs/nls!vs/platform/userDataSync/common/keybindingsSync","vs/nls!vs/platform/userDataSync/common/settingsSync","vs/nls!vs/platform/userDataSync/common/userDataAutoSyncService","vs/nls!vs/platform/userDataSync/common/userDataSync","vs/nls!vs/platform/userDataSync/common/userDataSyncMachines","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/node/argv","vs/platform/environment/node/argvHelper","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/extensionManagement/common/configRemotes","vs/platform/extensionRecommendations/electron-sandbox/extensionRecommendationsIpc","vs/platform/instantiation/common/graph","vs/platform/checksum/common/checksumService","vs/platform/contextkey/common/contextkey","vs/platform/extensionManagement/common/extensionManagementIpc","vs/platform/checksum/node/checksumService","crypto","vs/platform/files/common/diskFileSystemProviderClient","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/ipc/electron-browser/mainProcessService","vs/code/electron-browser/sharedProcess/contrib/localizationsUpdater","vs/code/electron-browser/sharedProcess/contrib/logsDataCleaner","vs/code/electron-browser/sharedProcess/contrib/storageDataCleaner","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","vs/platform/policy/common/policyIpc","vs/code/electron-browser/sharedProcess/contrib/codeCacheCleaner","vs/code/electron-browser/sharedProcess/contrib/languagePackCachedDataCleaner","vs/platform/profiling/common/profiling","vs/platform/profiling/node/profilingService","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/extensionManagement/common/unsupportedExtensionsMigration","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/remote/common/remoteAgentConnection","vs/platform/remote/common/sharedProcessTunnelService","vs/platform/remote/node/nodeSocketFactory","vs/platform/request/browser/requestService","vs/platform/download/common/downloadService","vs/platform/extensionManagement/common/extensionTipsService","vs/platform/request/common/requestIpc","vs/platform/request/electron-browser/sharedProcessRequestService","vs/platform/sharedProcess/electron-browser/sharedProcessWorker","vs/platform/sharedProcess/electron-browser/sharedProcessWorkerService","vs/platform/sharedProcess/node/sharedProcessEnvironmentService","vs/platform/shell/node/shellEnv","vs/platform/sign/node/signService","vs/platform/storage/common/storageIpc","vs/platform/diagnostics/node/diagnosticsService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/browser/1dsAppender","vs/platform/telemetry/node/customEndpointTelemetryService","vs/platform/terminal/common/requestStore","vs/platform/terminal/electron-sandbox/terminal","vs/platform/terminal/node/terminalEnvironment","vs/platform/theme/common/theme","vs/platform/terminal/common/terminalProfiles","vs/platform/terminal/common/terminalPlatformConfiguration","vs/platform/terminal/node/terminalProfiles","vs/platform/terminal/node/ptyHostService","vs/platform/tunnel/node/sharedProcessTunnelService","vs/platform/tunnel/node/tunnelService","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/userData/common/fileUserDataProvider","vs/platform/userDataSync/common/extensionsMerge","vs/platform/userDataSync/common/keybindingsMerge","vs/platform/userDataSync/common/snippetsMerge","vs/platform/userDataSync/common/globalStateMerge","vs/platform/userDataSync/common/settingsMerge","vs/platform/userDataSync/common/userDataSyncBackupStoreService","vs/platform/userDataSync/common/userDataSyncIpc","vs/platform/userDataSync/common/userDataSyncLog","vs/platform/userDataSync/common/userDataSyncServiceIpc","vs/platform/windows/node/windowTracker","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/electron-sandbox/defaultExtensionsProfileInit","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/extensionManagement/common/extensionEnablementService","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/extensionManagement/electron-sandbox/extensionTipsService","vs/platform/storage/electron-sandbox/storageService","vs/platform/userDataProfile/electron-sandbox/userDataProfile","vs/platform/userDataSync/common/extensionsSync","vs/platform/userDataSync/common/globalStateSync","vs/platform/userDataSync/common/keybindingsSync","vs/platform/userDataSync/common/settingsSync","vs/platform/userDataSync/common/snippetsSync","vs/platform/userDataSync/common/tasksSync","vs/platform/userDataSync/common/userDataSyncEnablementService","vs/platform/userDataSync/common/userDataAutoSyncService","vs/platform/userDataSync/common/userDataSyncService","vs/platform/userDataSync/common/userDataSyncStoreService","vs/platform/userDataSync/electron-sandbox/userDataAutoSyncService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/code/electron-browser/sharedProcess/contrib/extensionsCleaner","util","minimist","assert","path","graceful-fs","yauzl","yazl","vs/code/electron-browser/sharedProcess/sharedProcessMain"],se=function(X){for(var e=[],D=0,n=X.length;D<n;D++)e[D]=re[X[D]];return e};define(re[110],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.assertNever=e.ok=void 0;function D(k,L){if(!k)throw new Error(L?`Assertion failed (${L})`:"Assertion Failed")}e.ok=D;function n(k,L="Unreachable"){throw new Error(L)}e.assertNever=n}),define(re[50],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CSSIcon=e.getClassNamesArray=e.Codicon=e.getCodiconAriaLabel=void 0;function D(A){return A?A.replace(/\$\((.*?)\)/g,(b,P)=>` ${P} `).trim():""}e.getCodiconAriaLabel=D;class n{constructor(b,P,I){this.id=b,this.definition=P,this.description=I,n._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return n._allCodicons}}e.Codicon=n,n._allCodicons=[],n.add=new n("add",{fontCharacter:"\\ea60"}),n.plus=new n("plus",n.add.definition),n.gistNew=new n("gist-new",n.add.definition),n.repoCreate=new n("repo-create",n.add.definition),n.lightbulb=new n("lightbulb",{fontCharacter:"\\ea61"}),n.lightBulb=new n("light-bulb",{fontCharacter:"\\ea61"}),n.repo=new n("repo",{fontCharacter:"\\ea62"}),n.repoDelete=new n("repo-delete",{fontCharacter:"\\ea62"}),n.gistFork=new n("gist-fork",{fontCharacter:"\\ea63"}),n.repoForked=new n("repo-forked",{fontCharacter:"\\ea63"}),n.gitPullRequest=new n("git-pull-request",{fontCharacter:"\\ea64"}),n.gitPullRequestAbandoned=new n("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),n.recordKeys=new n("record-keys",{fontCharacter:"\\ea65"}),n.keyboard=new n("keyboard",{fontCharacter:"\\ea65"}),n.tag=new n("tag",{fontCharacter:"\\ea66"}),n.tagAdd=new n("tag-add",{fontCharacter:"\\ea66"}),n.tagRemove=new n("tag-remove",{fontCharacter:"\\ea66"}),n.person=new n("person",{fontCharacter:"\\ea67"}),n.personFollow=new n("person-follow",{fontCharacter:"\\ea67"}),n.personOutline=new n("person-outline",{fontCharacter:"\\ea67"}),n.personFilled=new n("person-filled",{fontCharacter:"\\ea67"}),n.gitBranch=new n("git-branch",{fontCharacter:"\\ea68"}),n.gitBranchCreate=new n("git-branch-create",{fontCharacter:"\\ea68"}),n.gitBranchDelete=new n("git-branch-delete",{fontCharacter:"\\ea68"}),n.sourceControl=new n("source-control",{fontCharacter:"\\ea68"}),n.mirror=new n("mirror",{fontCharacter:"\\ea69"}),n.mirrorPublic=new n("mirror-public",{fontCharacter:"\\ea69"}),n.star=new n("star",{fontCharacter:"\\ea6a"}),n.starAdd=new n("star-add",{fontCharacter:"\\ea6a"}),n.starDelete=new n("star-delete",{fontCharacter:"\\ea6a"}),n.starEmpty=new n("star-empty",{fontCharacter:"\\ea6a"}),n.comment=new n("comment",{fontCharacter:"\\ea6b"}),n.commentAdd=new n("comment-add",{fontCharacter:"\\ea6b"}),n.alert=new n("alert",{fontCharacter:"\\ea6c"}),n.warning=new n("warning",{fontCharacter:"\\ea6c"}),n.search=new n("search",{fontCharacter:"\\ea6d"}),n.searchSave=new n("search-save",{fontCharacter:"\\ea6d"}),n.logOut=new n("log-out",{fontCharacter:"\\ea6e"}),n.signOut=new n("sign-out",{fontCharacter:"\\ea6e"}),n.logIn=new n("log-in",{fontCharacter:"\\ea6f"}),n.signIn=new n("sign-in",{fontCharacter:"\\ea6f"}),n.eye=new n("eye",{fontCharacter:"\\ea70"}),n.eyeUnwatch=new n("eye-unwatch",{fontCharacter:"\\ea70"}),n.eyeWatch=new n("eye-watch",{fontCharacter:"\\ea70"}),n.circleFilled=new n("circle-filled",{fontCharacter:"\\ea71"}),n.primitiveDot=new n("primitive-dot",n.circleFilled.definition),n.closeDirty=new n("close-dirty",n.circleFilled.definition),n.terminalDecorationSuccess=new n("terminal-decoration-success",n.circleFilled.definition),n.debugBreakpoint=new n("debug-breakpoint",n.circleFilled.definition),n.debugBreakpointDisabled=new n("debug-breakpoint-disabled",n.circleFilled.definition),n.debugHint=new n("debug-hint",n.circleFilled.definition),n.primitiveSquare=new n("primitive-square",{fontCharacter:"\\ea72"}),n.edit=new n("edit",{fontCharacter:"\\ea73"}),n.pencil=new n("pencil",{fontCharacter:"\\ea73"}),n.info=new n("info",{fontCharacter:"\\ea74"}),n.issueOpened=new n("issue-opened",{fontCharacter:"\\ea74"}),n.gistPrivate=new n("gist-private",{fontCharacter:"\\ea75"}),n.gitForkPrivate=new n("git-fork-private",{fontCharacter:"\\ea75"}),n.lock=new n("lock",{fontCharacter:"\\ea75"}),n.mirrorPrivate=new n("mirror-private",{fontCharacter:"\\ea75"}),n.close=new n("close",{fontCharacter:"\\ea76"}),n.removeClose=new n("remove-close",{fontCharacter:"\\ea76"}),n.x=new n("x",{fontCharacter:"\\ea76"}),n.repoSync=new n("repo-sync",{fontCharacter:"\\ea77"}),n.sync=new n("sync",{fontCharacter:"\\ea77"}),n.clone=new n("clone",{fontCharacter:"\\ea78"}),n.desktopDownload=new n("desktop-download",{fontCharacter:"\\ea78"}),n.beaker=new n("beaker",{fontCharacter:"\\ea79"}),n.microscope=new n("microscope",{fontCharacter:"\\ea79"}),n.vm=new n("vm",{fontCharacter:"\\ea7a"}),n.deviceDesktop=new n("device-desktop",{fontCharacter:"\\ea7a"}),n.file=new n("file",{fontCharacter:"\\ea7b"}),n.fileText=new n("file-text",{fontCharacter:"\\ea7b"}),n.more=new n("more",{fontCharacter:"\\ea7c"}),n.ellipsis=new n("ellipsis",{fontCharacter:"\\ea7c"}),n.kebabHorizontal=new n("kebab-horizontal",{fontCharacter:"\\ea7c"}),n.mailReply=new n("mail-reply",{fontCharacter:"\\ea7d"}),n.reply=new n("reply",{fontCharacter:"\\ea7d"}),n.organization=new n("organization",{fontCharacter:"\\ea7e"}),n.organizationFilled=new n("organization-filled",{fontCharacter:"\\ea7e"}),n.organizationOutline=new n("organization-outline",{fontCharacter:"\\ea7e"}),n.newFile=new n("new-file",{fontCharacter:"\\ea7f"}),n.fileAdd=new n("file-add",{fontCharacter:"\\ea7f"}),n.newFolder=new n("new-folder",{fontCharacter:"\\ea80"}),n.fileDirectoryCreate=new n("file-directory-create",{fontCharacter:"\\ea80"}),n.trash=new n("trash",{fontCharacter:"\\ea81"}),n.trashcan=new n("trashcan",{fontCharacter:"\\ea81"}),n.history=new n("history",{fontCharacter:"\\ea82"}),n.clock=new n("clock",{fontCharacter:"\\ea82"}),n.folder=new n("folder",{fontCharacter:"\\ea83"}),n.fileDirectory=new n("file-directory",{fontCharacter:"\\ea83"}),n.symbolFolder=new n("symbol-folder",{fontCharacter:"\\ea83"}),n.logoGithub=new n("logo-github",{fontCharacter:"\\ea84"}),n.markGithub=new n("mark-github",{fontCharacter:"\\ea84"}),n.github=new n("github",{fontCharacter:"\\ea84"}),n.terminal=new n("terminal",{fontCharacter:"\\ea85"}),n.console=new n("console",{fontCharacter:"\\ea85"}),n.repl=new n("repl",{fontCharacter:"\\ea85"}),n.zap=new n("zap",{fontCharacter:"\\ea86"}),n.symbolEvent=new n("symbol-event",{fontCharacter:"\\ea86"}),n.error=new n("error",{fontCharacter:"\\ea87"}),n.stop=new n("stop",{fontCharacter:"\\ea87"}),n.variable=new n("variable",{fontCharacter:"\\ea88"}),n.symbolVariable=new n("symbol-variable",{fontCharacter:"\\ea88"}),n.array=new n("array",{fontCharacter:"\\ea8a"}),n.symbolArray=new n("symbol-array",{fontCharacter:"\\ea8a"}),n.symbolModule=new n("symbol-module",{fontCharacter:"\\ea8b"}),n.symbolPackage=new n("symbol-package",{fontCharacter:"\\ea8b"}),n.symbolNamespace=new n("symbol-namespace",{fontCharacter:"\\ea8b"}),n.symbolObject=new n("symbol-object",{fontCharacter:"\\ea8b"}),n.symbolMethod=new n("symbol-method",{fontCharacter:"\\ea8c"}),n.symbolFunction=new n("symbol-function",{fontCharacter:"\\ea8c"}),n.symbolConstructor=new n("symbol-constructor",{fontCharacter:"\\ea8c"}),n.symbolBoolean=new n("symbol-boolean",{fontCharacter:"\\ea8f"}),n.symbolNull=new n("symbol-null",{fontCharacter:"\\ea8f"}),n.symbolNumeric=new n("symbol-numeric",{fontCharacter:"\\ea90"}),n.symbolNumber=new n("symbol-number",{fontCharacter:"\\ea90"}),n.symbolStructure=new n("symbol-structure",{fontCharacter:"\\ea91"}),n.symbolStruct=new n("symbol-struct",{fontCharacter:"\\ea91"}),n.symbolParameter=new n("symbol-parameter",{fontCharacter:"\\ea92"}),n.symbolTypeParameter=new n("symbol-type-parameter",{fontCharacter:"\\ea92"}),n.symbolKey=new n("symbol-key",{fontCharacter:"\\ea93"}),n.symbolText=new n("symbol-text",{fontCharacter:"\\ea93"}),n.symbolReference=new n("symbol-reference",{fontCharacter:"\\ea94"}),n.goToFile=new n("go-to-file",{fontCharacter:"\\ea94"}),n.symbolEnum=new n("symbol-enum",{fontCharacter:"\\ea95"}),n.symbolValue=new n("symbol-value",{fontCharacter:"\\ea95"}),n.symbolRuler=new n("symbol-ruler",{fontCharacter:"\\ea96"}),n.symbolUnit=new n("symbol-unit",{fontCharacter:"\\ea96"}),n.activateBreakpoints=new n("activate-breakpoints",{fontCharacter:"\\ea97"}),n.archive=new n("archive",{fontCharacter:"\\ea98"}),n.arrowBoth=new n("arrow-both",{fontCharacter:"\\ea99"}),n.arrowDown=new n("arrow-down",{fontCharacter:"\\ea9a"}),n.arrowLeft=new n("arrow-left",{fontCharacter:"\\ea9b"}),n.arrowRight=new n("arrow-right",{fontCharacter:"\\ea9c"}),n.arrowSmallDown=new n("arrow-small-down",{fontCharacter:"\\ea9d"}),n.arrowSmallLeft=new n("arrow-small-left",{fontCharacter:"\\ea9e"}),n.arrowSmallRight=new n("arrow-small-right",{fontCharacter:"\\ea9f"}),n.arrowSmallUp=new n("arrow-small-up",{fontCharacter:"\\eaa0"}),n.arrowUp=new n("arrow-up",{fontCharacter:"\\eaa1"}),n.bell=new n("bell",{fontCharacter:"\\eaa2"}),n.bold=new n("bold",{fontCharacter:"\\eaa3"}),n.book=new n("book",{fontCharacter:"\\eaa4"}),n.bookmark=new n("bookmark",{fontCharacter:"\\eaa5"}),n.debugBreakpointConditionalUnverified=new n("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),n.debugBreakpointConditional=new n("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),n.debugBreakpointConditionalDisabled=new n("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),n.debugBreakpointDataUnverified=new n("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),n.debugBreakpointData=new n("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),n.debugBreakpointDataDisabled=new n("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),n.debugBreakpointLogUnverified=new n("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),n.debugBreakpointLog=new n("debug-breakpoint-log",{fontCharacter:"\\eaab"}),n.debugBreakpointLogDisabled=new n("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),n.briefcase=new n("briefcase",{fontCharacter:"\\eaac"}),n.broadcast=new n("broadcast",{fontCharacter:"\\eaad"}),n.browser=new n("browser",{fontCharacter:"\\eaae"}),n.bug=new n("bug",{fontCharacter:"\\eaaf"}),n.calendar=new n("calendar",{fontCharacter:"\\eab0"}),n.caseSensitive=new n("case-sensitive",{fontCharacter:"\\eab1"}),n.check=new n("check",{fontCharacter:"\\eab2"}),n.checklist=new n("checklist",{fontCharacter:"\\eab3"}),n.chevronDown=new n("chevron-down",{fontCharacter:"\\eab4"}),n.dropDownButton=new n("drop-down-button",n.chevronDown.definition),n.chevronLeft=new n("chevron-left",{fontCharacter:"\\eab5"}),n.chevronRight=new n("chevron-right",{fontCharacter:"\\eab6"}),n.chevronUp=new n("chevron-up",{fontCharacter:"\\eab7"}),n.chromeClose=new n("chrome-close",{fontCharacter:"\\eab8"}),n.chromeMaximize=new n("chrome-maximize",{fontCharacter:"\\eab9"}),n.chromeMinimize=new n("chrome-minimize",{fontCharacter:"\\eaba"}),n.chromeRestore=new n("chrome-restore",{fontCharacter:"\\eabb"}),n.circle=new n("circle",{fontCharacter:"\\eabc"}),n.circleOutline=new n("circle-outline",n.circle.definition),n.terminalDecorationIncomplete=new n("terminal-decoration-incomplete",n.circle.definition),n.debugBreakpointUnverified=new n("debug-breakpoint-unverified",n.circle.definition),n.circleSlash=new n("circle-slash",{fontCharacter:"\\eabd"}),n.circuitBoard=new n("circuit-board",{fontCharacter:"\\eabe"}),n.clearAll=new n("clear-all",{fontCharacter:"\\eabf"}),n.clippy=new n("clippy",{fontCharacter:"\\eac0"}),n.closeAll=new n("close-all",{fontCharacter:"\\eac1"}),n.cloudDownload=new n("cloud-download",{fontCharacter:"\\eac2"}),n.cloudUpload=new n("cloud-upload",{fontCharacter:"\\eac3"}),n.code=new n("code",{fontCharacter:"\\eac4"}),n.collapseAll=new n("collapse-all",{fontCharacter:"\\eac5"}),n.colorMode=new n("color-mode",{fontCharacter:"\\eac6"}),n.commentDiscussion=new n("comment-discussion",{fontCharacter:"\\eac7"}),n.compareChanges=new n("compare-changes",{fontCharacter:"\\eafd"}),n.creditCard=new n("credit-card",{fontCharacter:"\\eac9"}),n.dash=new n("dash",{fontCharacter:"\\eacc"}),n.dashboard=new n("dashboard",{fontCharacter:"\\eacd"}),n.database=new n("database",{fontCharacter:"\\eace"}),n.debugContinue=new n("debug-continue",{fontCharacter:"\\eacf"}),n.debugDisconnect=new n("debug-disconnect",{fontCharacter:"\\ead0"}),n.debugPause=new n("debug-pause",{fontCharacter:"\\ead1"}),n.debugRestart=new n("debug-restart",{fontCharacter:"\\ead2"}),n.debugStart=new n("debug-start",{fontCharacter:"\\ead3"}),n.debugStepInto=new n("debug-step-into",{fontCharacter:"\\ead4"}),n.debugStepOut=new n("debug-step-out",{fontCharacter:"\\ead5"}),n.debugStepOver=new n("debug-step-over",{fontCharacter:"\\ead6"}),n.debugStop=new n("debug-stop",{fontCharacter:"\\ead7"}),n.debug=new n("debug",{fontCharacter:"\\ead8"}),n.deviceCameraVideo=new n("device-camera-video",{fontCharacter:"\\ead9"}),n.deviceCamera=new n("device-camera",{fontCharacter:"\\eada"}),n.deviceMobile=new n("device-mobile",{fontCharacter:"\\eadb"}),n.diffAdded=new n("diff-added",{fontCharacter:"\\eadc"}),n.diffIgnored=new n("diff-ignored",{fontCharacter:"\\eadd"}),n.diffModified=new n("diff-modified",{fontCharacter:"\\eade"}),n.diffRemoved=new n("diff-removed",{fontCharacter:"\\eadf"}),n.diffRenamed=new n("diff-renamed",{fontCharacter:"\\eae0"}),n.diff=new n("diff",{fontCharacter:"\\eae1"}),n.discard=new n("discard",{fontCharacter:"\\eae2"}),n.editorLayout=new n("editor-layout",{fontCharacter:"\\eae3"}),n.emptyWindow=new n("empty-window",{fontCharacter:"\\eae4"}),n.exclude=new n("exclude",{fontCharacter:"\\eae5"}),n.extensions=new n("extensions",{fontCharacter:"\\eae6"}),n.eyeClosed=new n("eye-closed",{fontCharacter:"\\eae7"}),n.fileBinary=new n("file-binary",{fontCharacter:"\\eae8"}),n.fileCode=new n("file-code",{fontCharacter:"\\eae9"}),n.fileMedia=new n("file-media",{fontCharacter:"\\eaea"}),n.filePdf=new n("file-pdf",{fontCharacter:"\\eaeb"}),n.fileSubmodule=new n("file-submodule",{fontCharacter:"\\eaec"}),n.fileSymlinkDirectory=new n("file-symlink-directory",{fontCharacter:"\\eaed"}),n.fileSymlinkFile=new n("file-symlink-file",{fontCharacter:"\\eaee"}),n.fileZip=new n("file-zip",{fontCharacter:"\\eaef"}),n.files=new n("files",{fontCharacter:"\\eaf0"}),n.filter=new n("filter",{fontCharacter:"\\eaf1"}),n.flame=new n("flame",{fontCharacter:"\\eaf2"}),n.foldDown=new n("fold-down",{fontCharacter:"\\eaf3"}),n.foldUp=new n("fold-up",{fontCharacter:"\\eaf4"}),n.fold=new n("fold",{fontCharacter:"\\eaf5"}),n.folderActive=new n("folder-active",{fontCharacter:"\\eaf6"}),n.folderOpened=new n("folder-opened",{fontCharacter:"\\eaf7"}),n.gear=new n("gear",{fontCharacter:"\\eaf8"}),n.gift=new n("gift",{fontCharacter:"\\eaf9"}),n.gistSecret=new n("gist-secret",{fontCharacter:"\\eafa"}),n.gist=new n("gist",{fontCharacter:"\\eafb"}),n.gitCommit=new n("git-commit",{fontCharacter:"\\eafc"}),n.gitCompare=new n("git-compare",{fontCharacter:"\\eafd"}),n.gitMerge=new n("git-merge",{fontCharacter:"\\eafe"}),n.githubAction=new n("github-action",{fontCharacter:"\\eaff"}),n.githubAlt=new n("github-alt",{fontCharacter:"\\eb00"}),n.globe=new n("globe",{fontCharacter:"\\eb01"}),n.grabber=new n("grabber",{fontCharacter:"\\eb02"}),n.graph=new n("graph",{fontCharacter:"\\eb03"}),n.gripper=new n("gripper",{fontCharacter:"\\eb04"}),n.heart=new n("heart",{fontCharacter:"\\eb05"}),n.home=new n("home",{fontCharacter:"\\eb06"}),n.horizontalRule=new n("horizontal-rule",{fontCharacter:"\\eb07"}),n.hubot=new n("hubot",{fontCharacter:"\\eb08"}),n.inbox=new n("inbox",{fontCharacter:"\\eb09"}),n.issueClosed=new n("issue-closed",{fontCharacter:"\\eba4"}),n.issueReopened=new n("issue-reopened",{fontCharacter:"\\eb0b"}),n.issues=new n("issues",{fontCharacter:"\\eb0c"}),n.italic=new n("italic",{fontCharacter:"\\eb0d"}),n.jersey=new n("jersey",{fontCharacter:"\\eb0e"}),n.json=new n("json",{fontCharacter:"\\eb0f"}),n.kebabVertical=new n("kebab-vertical",{fontCharacter:"\\eb10"}),n.key=new n("key",{fontCharacter:"\\eb11"}),n.law=new n("law",{fontCharacter:"\\eb12"}),n.lightbulbAutofix=new n("lightbulb-autofix",{fontCharacter:"\\eb13"}),n.linkExternal=new n("link-external",{fontCharacter:"\\eb14"}),n.link=new n("link",{fontCharacter:"\\eb15"}),n.listOrdered=new n("list-ordered",{fontCharacter:"\\eb16"}),n.listUnordered=new n("list-unordered",{fontCharacter:"\\eb17"}),n.liveShare=new n("live-share",{fontCharacter:"\\eb18"}),n.loading=new n("loading",{fontCharacter:"\\eb19"}),n.location=new n("location",{fontCharacter:"\\eb1a"}),n.mailRead=new n("mail-read",{fontCharacter:"\\eb1b"}),n.mail=new n("mail",{fontCharacter:"\\eb1c"}),n.markdown=new n("markdown",{fontCharacter:"\\eb1d"}),n.megaphone=new n("megaphone",{fontCharacter:"\\eb1e"}),n.mention=new n("mention",{fontCharacter:"\\eb1f"}),n.milestone=new n("milestone",{fontCharacter:"\\eb20"}),n.mortarBoard=new n("mortar-board",{fontCharacter:"\\eb21"}),n.move=new n("move",{fontCharacter:"\\eb22"}),n.multipleWindows=new n("multiple-windows",{fontCharacter:"\\eb23"}),n.mute=new n("mute",{fontCharacter:"\\eb24"}),n.noNewline=new n("no-newline",{fontCharacter:"\\eb25"}),n.note=new n("note",{fontCharacter:"\\eb26"}),n.octoface=new n("octoface",{fontCharacter:"\\eb27"}),n.openPreview=new n("open-preview",{fontCharacter:"\\eb28"}),n.package_=new n("package",{fontCharacter:"\\eb29"}),n.paintcan=new n("paintcan",{fontCharacter:"\\eb2a"}),n.pin=new n("pin",{fontCharacter:"\\eb2b"}),n.play=new n("play",{fontCharacter:"\\eb2c"}),n.run=new n("run",{fontCharacter:"\\eb2c"}),n.plug=new n("plug",{fontCharacter:"\\eb2d"}),n.preserveCase=new n("preserve-case",{fontCharacter:"\\eb2e"}),n.preview=new n("preview",{fontCharacter:"\\eb2f"}),n.project=new n("project",{fontCharacter:"\\eb30"}),n.pulse=new n("pulse",{fontCharacter:"\\eb31"}),n.question=new n("question",{fontCharacter:"\\eb32"}),n.quote=new n("quote",{fontCharacter:"\\eb33"}),n.radioTower=new n("radio-tower",{fontCharacter:"\\eb34"}),n.reactions=new n("reactions",{fontCharacter:"\\eb35"}),n.references=new n("references",{fontCharacter:"\\eb36"}),n.refresh=new n("refresh",{fontCharacter:"\\eb37"}),n.regex=new n("regex",{fontCharacter:"\\eb38"}),n.remoteExplorer=new n("remote-explorer",{fontCharacter:"\\eb39"}),n.remote=new n("remote",{fontCharacter:"\\eb3a"}),n.remove=new n("remove",{fontCharacter:"\\eb3b"}),n.replaceAll=new n("replace-all",{fontCharacter:"\\eb3c"}),n.replace=new n("replace",{fontCharacter:"\\eb3d"}),n.repoClone=new n("repo-clone",{fontCharacter:"\\eb3e"}),n.repoForcePush=new n("repo-force-push",{fontCharacter:"\\eb3f"}),n.repoPull=new n("repo-pull",{fontCharacter:"\\eb40"}),n.repoPush=new n("repo-push",{fontCharacter:"\\eb41"}),n.report=new n("report",{fontCharacter:"\\eb42"}),n.requestChanges=new n("request-changes",{fontCharacter:"\\eb43"}),n.rocket=new n("rocket",{fontCharacter:"\\eb44"}),n.rootFolderOpened=new n("root-folder-opened",{fontCharacter:"\\eb45"}),n.rootFolder=new n("root-folder",{fontCharacter:"\\eb46"}),n.rss=new n("rss",{fontCharacter:"\\eb47"}),n.ruby=new n("ruby",{fontCharacter:"\\eb48"}),n.saveAll=new n("save-all",{fontCharacter:"\\eb49"}),n.saveAs=new n("save-as",{fontCharacter:"\\eb4a"}),n.save=new n("save",{fontCharacter:"\\eb4b"}),n.screenFull=new n("screen-full",{fontCharacter:"\\eb4c"}),n.screenNormal=new n("screen-normal",{fontCharacter:"\\eb4d"}),n.searchStop=new n("search-stop",{fontCharacter:"\\eb4e"}),n.server=new n("server",{fontCharacter:"\\eb50"}),n.settingsGear=new n("settings-gear",{fontCharacter:"\\eb51"}),n.settings=new n("settings",{fontCharacter:"\\eb52"}),n.shield=new n("shield",{fontCharacter:"\\eb53"}),n.smiley=new n("smiley",{fontCharacter:"\\eb54"}),n.sortPrecedence=new n("sort-precedence",{fontCharacter:"\\eb55"}),n.splitHorizontal=new n("split-horizontal",{fontCharacter:"\\eb56"}),n.splitVertical=new n("split-vertical",{fontCharacter:"\\eb57"}),n.squirrel=new n("squirrel",{fontCharacter:"\\eb58"}),n.starFull=new n("star-full",{fontCharacter:"\\eb59"}),n.starHalf=new n("star-half",{fontCharacter:"\\eb5a"}),n.symbolClass=new n("symbol-class",{fontCharacter:"\\eb5b"}),n.symbolColor=new n("symbol-color",{fontCharacter:"\\eb5c"}),n.symbolCustomColor=new n("symbol-customcolor",{fontCharacter:"\\eb5c"}),n.symbolConstant=new n("symbol-constant",{fontCharacter:"\\eb5d"}),n.symbolEnumMember=new n("symbol-enum-member",{fontCharacter:"\\eb5e"}),n.symbolField=new n("symbol-field",{fontCharacter:"\\eb5f"}),n.symbolFile=new n("symbol-file",{fontCharacter:"\\eb60"}),n.symbolInterface=new n("symbol-interface",{fontCharacter:"\\eb61"}),n.symbolKeyword=new n("symbol-keyword",{fontCharacter:"\\eb62"}),n.symbolMisc=new n("symbol-misc",{fontCharacter:"\\eb63"}),n.symbolOperator=new n("symbol-operator",{fontCharacter:"\\eb64"}),n.symbolProperty=new n("symbol-property",{fontCharacter:"\\eb65"}),n.wrench=new n("wrench",{fontCharacter:"\\eb65"}),n.wrenchSubaction=new n("wrench-subaction",{fontCharacter:"\\eb65"}),n.symbolSnippet=new n("symbol-snippet",{fontCharacter:"\\eb66"}),n.tasklist=new n("tasklist",{fontCharacter:"\\eb67"}),n.telescope=new n("telescope",{fontCharacter:"\\eb68"}),n.textSize=new n("text-size",{fontCharacter:"\\eb69"}),n.threeBars=new n("three-bars",{fontCharacter:"\\eb6a"}),n.thumbsdown=new n("thumbsdown",{fontCharacter:"\\eb6b"}),n.thumbsup=new n("thumbsup",{fontCharacter:"\\eb6c"}),n.tools=new n("tools",{fontCharacter:"\\eb6d"}),n.triangleDown=new n("triangle-down",{fontCharacter:"\\eb6e"}),n.triangleLeft=new n("triangle-left",{fontCharacter:"\\eb6f"}),n.triangleRight=new n("triangle-right",{fontCharacter:"\\eb70"}),n.triangleUp=new n("triangle-up",{fontCharacter:"\\eb71"}),n.twitter=new n("twitter",{fontCharacter:"\\eb72"}),n.unfold=new n("unfold",{fontCharacter:"\\eb73"}),n.unlock=new n("unlock",{fontCharacter:"\\eb74"}),n.unmute=new n("unmute",{fontCharacter:"\\eb75"}),n.unverified=new n("unverified",{fontCharacter:"\\eb76"}),n.verified=new n("verified",{fontCharacter:"\\eb77"}),n.versions=new n("versions",{fontCharacter:"\\eb78"}),n.vmActive=new n("vm-active",{fontCharacter:"\\eb79"}),n.vmOutline=new n("vm-outline",{fontCharacter:"\\eb7a"}),n.vmRunning=new n("vm-running",{fontCharacter:"\\eb7b"}),n.watch=new n("watch",{fontCharacter:"\\eb7c"}),n.whitespace=new n("whitespace",{fontCharacter:"\\eb7d"}),n.wholeWord=new n("whole-word",{fontCharacter:"\\eb7e"}),n.window=new n("window",{fontCharacter:"\\eb7f"}),n.wordWrap=new n("word-wrap",{fontCharacter:"\\eb80"}),n.zoomIn=new n("zoom-in",{fontCharacter:"\\eb81"}),n.zoomOut=new n("zoom-out",{fontCharacter:"\\eb82"}),n.listFilter=new n("list-filter",{fontCharacter:"\\eb83"}),n.listFlat=new n("list-flat",{fontCharacter:"\\eb84"}),n.listSelection=new n("list-selection",{fontCharacter:"\\eb85"}),n.selection=new n("selection",{fontCharacter:"\\eb85"}),n.listTree=new n("list-tree",{fontCharacter:"\\eb86"}),n.debugBreakpointFunctionUnverified=new n("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),n.debugBreakpointFunction=new n("debug-breakpoint-function",{fontCharacter:"\\eb88"}),n.debugBreakpointFunctionDisabled=new n("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),n.debugStackframeActive=new n("debug-stackframe-active",{fontCharacter:"\\eb89"}),n.circleSmallFilled=new n("circle-small-filled",{fontCharacter:"\\eb8a"}),n.debugStackframeDot=new n("debug-stackframe-dot",n.circleSmallFilled.definition),n.terminalDecorationMark=new n("terminal-decoration-mark",n.circleSmallFilled.definition),n.debugStackframe=new n("debug-stackframe",{fontCharacter:"\\eb8b"}),n.debugStackframeFocused=new n("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),n.debugBreakpointUnsupported=new n("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),n.symbolString=new n("symbol-string",{fontCharacter:"\\eb8d"}),n.debugReverseContinue=new n("debug-reverse-continue",{fontCharacter:"\\eb8e"}),n.debugStepBack=new n("debug-step-back",{fontCharacter:"\\eb8f"}),n.debugRestartFrame=new n("debug-restart-frame",{fontCharacter:"\\eb90"}),n.callIncoming=new n("call-incoming",{fontCharacter:"\\eb92"}),n.callOutgoing=new n("call-outgoing",{fontCharacter:"\\eb93"}),n.menu=new n("menu",{fontCharacter:"\\eb94"}),n.expandAll=new n("expand-all",{fontCharacter:"\\eb95"}),n.feedback=new n("feedback",{fontCharacter:"\\eb96"}),n.groupByRefType=new n("group-by-ref-type",{fontCharacter:"\\eb97"}),n.ungroupByRefType=new n("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),n.account=new n("account",{fontCharacter:"\\eb99"}),n.bellDot=new n("bell-dot",{fontCharacter:"\\eb9a"}),n.debugConsole=new n("debug-console",{fontCharacter:"\\eb9b"}),n.library=new n("library",{fontCharacter:"\\eb9c"}),n.output=new n("output",{fontCharacter:"\\eb9d"}),n.runAll=new n("run-all",{fontCharacter:"\\eb9e"}),n.syncIgnored=new n("sync-ignored",{fontCharacter:"\\eb9f"}),n.pinned=new n("pinned",{fontCharacter:"\\eba0"}),n.githubInverted=new n("github-inverted",{fontCharacter:"\\eba1"}),n.debugAlt=new n("debug-alt",{fontCharacter:"\\eb91"}),n.serverProcess=new n("server-process",{fontCharacter:"\\eba2"}),n.serverEnvironment=new n("server-environment",{fontCharacter:"\\eba3"}),n.pass=new n("pass",{fontCharacter:"\\eba4"}),n.stopCircle=new n("stop-circle",{fontCharacter:"\\eba5"}),n.playCircle=new n("play-circle",{fontCharacter:"\\eba6"}),n.record=new n("record",{fontCharacter:"\\eba7"}),n.debugAltSmall=new n("debug-alt-small",{fontCharacter:"\\eba8"}),n.vmConnect=new n("vm-connect",{fontCharacter:"\\eba9"}),n.cloud=new n("cloud",{fontCharacter:"\\ebaa"}),n.merge=new n("merge",{fontCharacter:"\\ebab"}),n.exportIcon=new n("export",{fontCharacter:"\\ebac"}),n.graphLeft=new n("graph-left",{fontCharacter:"\\ebad"}),n.magnet=new n("magnet",{fontCharacter:"\\ebae"}),n.notebook=new n("notebook",{fontCharacter:"\\ebaf"}),n.redo=new n("redo",{fontCharacter:"\\ebb0"}),n.checkAll=new n("check-all",{fontCharacter:"\\ebb1"}),n.pinnedDirty=new n("pinned-dirty",{fontCharacter:"\\ebb2"}),n.passFilled=new n("pass-filled",{fontCharacter:"\\ebb3"}),n.circleLargeFilled=new n("circle-large-filled",{fontCharacter:"\\ebb4"}),n.circleLarge=new n("circle-large",{fontCharacter:"\\ebb5"}),n.circleLargeOutline=new n("circle-large-outline",n.circleLarge.definition),n.combine=new n("combine",{fontCharacter:"\\ebb6"}),n.gather=new n("gather",{fontCharacter:"\\ebb6"}),n.table=new n("table",{fontCharacter:"\\ebb7"}),n.variableGroup=new n("variable-group",{fontCharacter:"\\ebb8"}),n.typeHierarchy=new n("type-hierarchy",{fontCharacter:"\\ebb9"}),n.typeHierarchySub=new n("type-hierarchy-sub",{fontCharacter:"\\ebba"}),n.typeHierarchySuper=new n("type-hierarchy-super",{fontCharacter:"\\ebbb"}),n.gitPullRequestCreate=new n("git-pull-request-create",{fontCharacter:"\\ebbc"}),n.runAbove=new n("run-above",{fontCharacter:"\\ebbd"}),n.runBelow=new n("run-below",{fontCharacter:"\\ebbe"}),n.notebookTemplate=new n("notebook-template",{fontCharacter:"\\ebbf"}),n.debugRerun=new n("debug-rerun",{fontCharacter:"\\ebc0"}),n.workspaceTrusted=new n("workspace-trusted",{fontCharacter:"\\ebc1"}),n.workspaceUntrusted=new n("workspace-untrusted",{fontCharacter:"\\ebc2"}),n.workspaceUnspecified=new n("workspace-unspecified",{fontCharacter:"\\ebc3"}),n.terminalCmd=new n("terminal-cmd",{fontCharacter:"\\ebc4"}),n.terminalDebian=new n("terminal-debian",{fontCharacter:"\\ebc5"}),n.terminalLinux=new n("terminal-linux",{fontCharacter:"\\ebc6"}),n.terminalPowershell=new n("terminal-powershell",{fontCharacter:"\\ebc7"}),n.terminalTmux=new n("terminal-tmux",{fontCharacter:"\\ebc8"}),n.terminalUbuntu=new n("terminal-ubuntu",{fontCharacter:"\\ebc9"}),n.terminalBash=new n("terminal-bash",{fontCharacter:"\\ebca"}),n.arrowSwap=new n("arrow-swap",{fontCharacter:"\\ebcb"}),n.copy=new n("copy",{fontCharacter:"\\ebcc"}),n.personAdd=new n("person-add",{fontCharacter:"\\ebcd"}),n.filterFilled=new n("filter-filled",{fontCharacter:"\\ebce"}),n.wand=new n("wand",{fontCharacter:"\\ebcf"}),n.debugLineByLine=new n("debug-line-by-line",{fontCharacter:"\\ebd0"}),n.inspect=new n("inspect",{fontCharacter:"\\ebd1"}),n.layers=new n("layers",{fontCharacter:"\\ebd2"}),n.layersDot=new n("layers-dot",{fontCharacter:"\\ebd3"}),n.layersActive=new n("layers-active",{fontCharacter:"\\ebd4"}),n.compass=new n("compass",{fontCharacter:"\\ebd5"}),n.compassDot=new n("compass-dot",{fontCharacter:"\\ebd6"}),n.compassActive=new n("compass-active",{fontCharacter:"\\ebd7"}),n.azure=new n("azure",{fontCharacter:"\\ebd8"}),n.issueDraft=new n("issue-draft",{fontCharacter:"\\ebd9"}),n.gitPullRequestClosed=new n("git-pull-request-closed",{fontCharacter:"\\ebda"}),n.gitPullRequestDraft=new n("git-pull-request-draft",{fontCharacter:"\\ebdb"}),n.debugAll=new n("debug-all",{fontCharacter:"\\ebdc"}),n.debugCoverage=new n("debug-coverage",{fontCharacter:"\\ebdd"}),n.runErrors=new n("run-errors",{fontCharacter:"\\ebde"}),n.folderLibrary=new n("folder-library",{fontCharacter:"\\ebdf"}),n.debugContinueSmall=new n("debug-continue-small",{fontCharacter:"\\ebe0"}),n.beakerStop=new n("beaker-stop",{fontCharacter:"\\ebe1"}),n.graphLine=new n("graph-line",{fontCharacter:"\\ebe2"}),n.graphScatter=new n("graph-scatter",{fontCharacter:"\\ebe3"}),n.pieChart=new n("pie-chart",{fontCharacter:"\\ebe4"}),n.bracket=new n("bracket",n.json.definition),n.bracketDot=new n("bracket-dot",{fontCharacter:"\\ebe5"}),n.bracketError=new n("bracket-error",{fontCharacter:"\\ebe6"}),n.lockSmall=new n("lock-small",{fontCharacter:"\\ebe7"}),n.azureDevops=new n("azure-devops",{fontCharacter:"\\ebe8"}),n.verifiedFilled=new n("verified-filled",{fontCharacter:"\\ebe9"}),n.newLine=new n("newline",{fontCharacter:"\\ebea"}),n.layout=new n("layout",{fontCharacter:"\\ebeb"}),n.layoutActivitybarLeft=new n("layout-activitybar-left",{fontCharacter:"\\ebec"}),n.layoutActivitybarRight=new n("layout-activitybar-right",{fontCharacter:"\\ebed"}),n.layoutPanelLeft=new n("layout-panel-left",{fontCharacter:"\\ebee"}),n.layoutPanelCenter=new n("layout-panel-center",{fontCharacter:"\\ebef"}),n.layoutPanelJustify=new n("layout-panel-justify",{fontCharacter:"\\ebf0"}),n.layoutPanelRight=new n("layout-panel-right",{fontCharacter:"\\ebf1"}),n.layoutPanel=new n("layout-panel",{fontCharacter:"\\ebf2"}),n.layoutSidebarLeft=new n("layout-sidebar-left",{fontCharacter:"\\ebf3"}),n.layoutSidebarRight=new n("layout-sidebar-right",{fontCharacter:"\\ebf4"}),n.layoutStatusbar=new n("layout-statusbar",{fontCharacter:"\\ebf5"}),n.layoutMenubar=new n("layout-menubar",{fontCharacter:"\\ebf6"}),n.layoutCentered=new n("layout-centered",{fontCharacter:"\\ebf7"}),n.layoutSidebarRightOff=new n("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),n.layoutPanelOff=new n("layout-panel-off",{fontCharacter:"\\ec01"}),n.layoutSidebarLeftOff=new n("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),n.target=new n("target",{fontCharacter:"\\ebf8"}),n.indent=new n("indent",{fontCharacter:"\\ebf9"}),n.recordSmall=new n("record-small",{fontCharacter:"\\ebfa"}),n.errorSmall=new n("error-small",{fontCharacter:"\\ebfb"}),n.terminalDecorationError=new n("terminal-decoration-error",n.errorSmall.definition),n.arrowCircleDown=new n("arrow-circle-down",{fontCharacter:"\\ebfc"}),n.arrowCircleLeft=new n("arrow-circle-left",{fontCharacter:"\\ebfd"}),n.arrowCircleRight=new n("arrow-circle-right",{fontCharacter:"\\ebfe"}),n.arrowCircleUp=new n("arrow-circle-up",{fontCharacter:"\\ebff"}),n.heartFilled=new n("heart-filled",{fontCharacter:"\\ec04"}),n.map=new n("map",{fontCharacter:"\\ec05"}),n.mapFilled=new n("map-filled",{fontCharacter:"\\ec06"}),n.circleSmall=new n("circle-small",{fontCharacter:"\\ec07"}),n.bellSlash=new n("bell-slash",{fontCharacter:"\\ec08"}),n.bellSlashDot=new n("bell-slash-dot",{fontCharacter:"\\ec09"}),n.commentUnresolved=new n("comment-unresolved",{fontCharacter:"\\ec0a"}),n.gitPullRequestGoToChanges=new n("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),n.gitPullRequestNewChanges=new n("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),n.dialogError=new n("dialog-error",n.error.definition),n.dialogWarning=new n("dialog-warning",n.warning.definition),n.dialogInfo=new n("dialog-info",n.info.definition),n.dialogClose=new n("dialog-close",n.close.definition),n.treeItemExpanded=new n("tree-item-expanded",n.chevronDown.definition),n.treeFilterOnTypeOn=new n("tree-filter-on-type-on",n.listFilter.definition),n.treeFilterOnTypeOff=new n("tree-filter-on-type-off",n.listSelection.definition),n.treeFilterClear=new n("tree-filter-clear",n.close.definition),n.treeItemLoading=new n("tree-item-loading",n.loading.definition),n.menuSelection=new n("menu-selection",n.check.definition),n.menuSubmenu=new n("menu-submenu",n.chevronRight.definition),n.menuBarMore=new n("menubar-more",n.more.definition),n.scrollbarButtonLeft=new n("scrollbar-button-left",n.triangleLeft.definition),n.scrollbarButtonRight=new n("scrollbar-button-right",n.triangleRight.definition),n.scrollbarButtonUp=new n("scrollbar-button-up",n.triangleUp.definition),n.scrollbarButtonDown=new n("scrollbar-button-down",n.triangleDown.definition),n.toolBarMore=new n("toolbar-more",n.more.definition),n.quickInputBack=new n("quick-input-back",n.arrowLeft.definition);function k(A,b){const P=["codicon","codicon-"+A];return b&&P.push("codicon-modifier-"+b),P}e.getClassNamesArray=k;var L;(function(A){A.iconNameSegment="[A-Za-z0-9]+",A.iconNameExpression="[A-Za-z0-9-]+",A.iconModifierExpression="~[A-Za-z]+",A.iconNameCharacter="[A-Za-z0-9~-]";const b=new RegExp(`^(${A.iconNameExpression})(${A.iconModifierExpression})?$`);function P(w){if(w instanceof n)return["codicon","codicon-"+w.id];const v=b.exec(w.id);if(!v)return P(n.error);const[,y,f]=v,S=["codicon","codicon-"+y];return f&&S.push("codicon-modifier-"+f.substr(1)),S}A.asClassNameArray=P;function I(w){return P(w).join(" ")}A.asClassName=I;function E(w){return"."+P(w).join(".")}A.asCSSSelector=E})(L=e.CSSIcon||(e.CSSIcon={}))}),define(re[60],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function D(A){return(b,P,I)=>{let E=null,w=null;if(typeof I.value=="function"?(E="value",w=I.value):typeof I.get=="function"&&(E="get",w=I.get),!w)throw new Error("not supported");I[E]=A(w,P)}}e.createDecorator=D;function n(A,b,P){let I=null,E=null;if(typeof P.value=="function"?(I="value",E=P.value,E.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof P.get=="function"&&(I="get",E=P.get),!E)throw new Error("not supported");const w=`$memoize$${b}`;P[I]=function(...v){return this.hasOwnProperty(w)||Object.defineProperty(this,w,{configurable:!1,enumerable:!1,writable:!1,value:E.apply(this,v)}),this[w]}}e.memoize=n;function k(A,b,P){return D((I,E)=>{const w=`$debounce$${E}`,v=`$debounce$result$${E}`;return function(...y){this[v]||(this[v]=P?P():void 0),clearTimeout(this[w]),b&&(this[v]=b(this[v],...y),y=[this[v]]),this[w]=setTimeout(()=>{I.apply(this,y),this[v]=P?P():void 0},A)}})}e.debounce=k;function L(A,b,P){return D((I,E)=>{const w=`$throttle$timer$${E}`,v=`$throttle$result$${E}`,y=`$throttle$lastRun$${E}`,f=`$throttle$pending$${E}`;return function(...S){if(this[v]||(this[v]=P?P():void 0),(this[y]===null||this[y]===void 0)&&(this[y]=-Number.MAX_VALUE),b&&(this[v]=b(this[v],...S)),this[f])return;const C=this[y]+A;C<=Date.now()?(this[y]=Date.now(),I.apply(this,[this[v]]),this[v]=P?P():void 0):(this[f]=!0,this[w]=setTimeout(()=>{this[f]=!1,this[y]=Date.now(),I.apply(this,[this[v]]),this[v]=P?P():void 0},C-Date.now()))}})}e.throttle=L}),define(re[9],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BugIndicatingError=e.ErrorNoTelemetry=e.ExpectedError=e.NotSupportedError=e.NotImplementedError=e.getErrorMessage=e.disposed=e.readonly=e.illegalState=e.illegalArgument=e.canceled=e.CancellationError=e.isCancellationError=e.transformErrorForSerialization=e.onUnexpectedExternalError=e.onUnexpectedError=e.setUnexpectedErrorHandler=e.errorHandler=e.ErrorHandler=void 0;class D{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(s){setTimeout(()=>{throw s.stack?c.isErrorNoTelemetry(s)?new c(s.message+`

`+s.stack):new Error(s.message+`

`+s.stack):s},0)}}addListener(s){return this.listeners.push(s),()=>{this._removeListener(s)}}emit(s){this.listeners.forEach(r=>{r(s)})}_removeListener(s){this.listeners.splice(this.listeners.indexOf(s),1)}setUnexpectedErrorHandler(s){this.unexpectedErrorHandler=s}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(s){this.unexpectedErrorHandler(s),this.emit(s)}onUnexpectedExternalError(s){this.unexpectedErrorHandler(s)}}e.ErrorHandler=D,e.errorHandler=new D;function n(u){e.errorHandler.setUnexpectedErrorHandler(u)}e.setUnexpectedErrorHandler=n;function k(u){P(u)||e.errorHandler.onUnexpectedError(u)}e.onUnexpectedError=k;function L(u){P(u)||e.errorHandler.onUnexpectedExternalError(u)}e.onUnexpectedExternalError=L;function A(u){if(u instanceof Error){const{name:s,message:r}=u,t=u.stacktrace||u.stack;return{$isError:!0,name:s,message:r,stack:t,noTelemetry:c.isErrorNoTelemetry(u)}}return u}e.transformErrorForSerialization=A;const b="Canceled";function P(u){return u instanceof I?!0:u instanceof Error&&u.name===b&&u.message===b}e.isCancellationError=P;class I extends Error{constructor(){super(b);this.name=this.message}}e.CancellationError=I;function E(){const u=new Error(b);return u.name=u.message,u}e.canceled=E;function w(u){return u?new Error(`Illegal argument: ${u}`):new Error("Illegal argument")}e.illegalArgument=w;function v(u){return u?new Error(`Illegal state: ${u}`):new Error("Illegal state")}e.illegalState=v;function y(u){return u?new Error(`readonly property '${u} cannot be changed'`):new Error("readonly property cannot be changed")}e.readonly=y;function f(u){const s=new Error(`${u} has been disposed`);return s.name="DISPOSED",s}e.disposed=f;function S(u){return u?u.message?u.message:u.stack?u.stack.split(`
`)[0]:String(u):"Error"}e.getErrorMessage=S;class C extends Error{constructor(s){super("NotImplemented");s&&(this.message=s)}}e.NotImplementedError=C;class m extends Error{constructor(s){super("NotSupported");s&&(this.message=s)}}e.NotSupportedError=m;class g extends Error{constructor(){super(...arguments);this.isExpected=!0}}e.ExpectedError=g;class c extends Error{constructor(s){super(s);this.name="ErrorNoTelemetry"}static fromError(s){if(s instanceof c)return s;const r=new c;return r.message=s.message,r.stack=s.stack,r}static isErrorNoTelemetry(s){return s.name==="ErrorNoTelemetry"}}e.ErrorNoTelemetry=c;class d extends Error{constructor(s){super(s||"An unexpected bug occurred.");Object.setPrototypeOf(this,d.prototype);debugger}}e.BugIndicatingError=d}),define(re[18],se([0,1,9]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CallbackIterable=e.ArrayQueue=e.findMinBy=e.findLastMaxBy=e.findMaxBy=e.numberComparator=e.tieBreakComparators=e.compareBy=e.CompareResult=e.splice=e.insertInto=e.mapFind=e.getRandomElement=e.asArray=e.mapArrayOrNot=e.pushMany=e.pushToEnd=e.pushToStart=e.shuffle=e.arrayInsert=e.remove=e.insert=e.index=e.range=e.flatten=e.commonPrefixLength=e.lastOrDefault=e.firstOrDefault=e.lastIndex=e.findLast=e.uniqueFilter=e.distinct=e.isNonEmptyArray=e.isFalsyOrEmpty=e.move=e.coalesceInPlace=e.coalesce=e.topAsync=e.top=e.delta=e.sortedDiff=e.groupBy=e.quickSelect=e.findFirstInSorted=e.binarySearch2=e.binarySearch=e.removeFastWithoutKeepingOrder=e.equals=e.tail2=e.tail=void 0;function n(Q,te=0){return Q[Q.length-(1+te)]}e.tail=n;function k(Q){if(Q.length===0)throw new Error("Invalid tail call");return[Q.slice(0,Q.length-1),Q[Q.length-1]]}e.tail2=k;function L(Q,te,ne=(ue,he)=>ue===he){if(Q===te)return!0;if(!Q||!te||Q.length!==te.length)return!1;for(let ue=0,he=Q.length;ue<he;ue++)if(!ne(Q[ue],te[ue]))return!1;return!0}e.equals=L;function A(Q,te){const ne=Q.length-1;te<ne&&(Q[te]=Q[ne]),Q.pop()}e.removeFastWithoutKeepingOrder=A;function b(Q,te,ne){return P(Q.length,ue=>ne(Q[ue],te))}e.binarySearch=b;function P(Q,te){let ne=0,ue=Q-1;for(;ne<=ue;){const he=(ne+ue)/2|0,pe=te(he);if(pe<0)ne=he+1;else if(pe>0)ue=he-1;else return he}return-(ne+1)}e.binarySearch2=P;function I(Q,te){let ne=0,ue=Q.length;if(ue===0)return 0;for(;ne<ue;){const he=Math.floor((ne+ue)/2);te(Q[he])?ue=he:ne=he+1}return ne}e.findFirstInSorted=I;function E(Q,te,ne){if(Q=Q|0,Q>=te.length)throw new TypeError("invalid index");const ue=te[Math.floor(te.length*Math.random())],he=[],pe=[],we=[];for(const Ce of te){const Pe=ne(Ce,ue);Pe<0?he.push(Ce):Pe>0?pe.push(Ce):we.push(Ce)}return Q<he.length?E(Q,he,ne):Q<he.length+we.length?we[0]:E(Q-(he.length+we.length),pe,ne)}e.quickSelect=E;function w(Q,te){const ne=[];let ue;for(const he of Q.slice(0).sort(te))!ue||te(ue[0],he)!==0?(ue=[he],ne.push(ue)):ue.push(he);return ne}e.groupBy=w;function v(Q,te,ne){const ue=[];function he(Ce,Pe,Ue){if(Pe===0&&Ue.length===0)return;const We=ue[ue.length-1];We&&We.start+We.deleteCount===Ce?(We.deleteCount+=Pe,We.toInsert.push(...Ue)):ue.push({start:Ce,deleteCount:Pe,toInsert:Ue})}let pe=0,we=0;for(;;){if(pe===Q.length){he(pe,0,te.slice(we));break}if(we===te.length){he(pe,Q.length-pe,[]);break}const Ce=Q[pe],Pe=te[we],Ue=ne(Ce,Pe);Ue===0?(pe+=1,we+=1):Ue<0?(he(pe,1,[]),pe+=1):Ue>0&&(he(pe,0,[Pe]),we+=1)}return ue}e.sortedDiff=v;function y(Q,te,ne){const ue=v(Q,te,ne),he=[],pe=[];for(const we of ue)he.push(...Q.slice(we.start,we.start+we.deleteCount)),pe.push(...we.toInsert);return{removed:he,added:pe}}e.delta=y;function f(Q,te,ne){if(ne===0)return[];const ue=Q.slice(0,ne).sort(te);return C(Q,te,ue,ne,Q.length),ue}e.top=f;function S(Q,te,ne,ue,he){return ne===0?Promise.resolve([]):new Promise((pe,we)=>{(async()=>{const Ce=Q.length,Pe=Q.slice(0,ne).sort(te);for(let Ue=ne,We=Math.min(ne+ue,Ce);Ue<Ce;Ue=We,We=Math.min(We+ue,Ce)){if(Ue>ne&&await new Promise(Be=>setTimeout(Be)),he&&he.isCancellationRequested)throw new D.CancellationError;C(Q,te,Pe,Ue,We)}return Pe})().then(pe,we)})}e.topAsync=S;function C(Q,te,ne,ue,he){for(const pe=ne.length;ue<he;ue++){const we=Q[ue];if(te(we,ne[pe-1])<0){ne.pop();const Ce=I(ne,Pe=>te(we,Pe)<0);ne.splice(Ce,0,we)}}}function m(Q){return Q.filter(te=>!!te)}e.coalesce=m;function g(Q){let te=0;for(let ne=0;ne<Q.length;ne++)Q[ne]&&(Q[te]=Q[ne],te+=1);Q.length=te}e.coalesceInPlace=g;function c(Q,te,ne){Q.splice(ne,0,Q.splice(te,1)[0])}e.move=c;function d(Q){return!Array.isArray(Q)||Q.length===0}e.isFalsyOrEmpty=d;function u(Q){return Array.isArray(Q)&&Q.length>0}e.isNonEmptyArray=u;function s(Q,te=ne=>ne){const ne=new Set;return Q.filter(ue=>{const he=te(ue);return ne.has(he)?!1:(ne.add(he),!0)})}e.distinct=s;function r(Q){const te=new Set;return ne=>{const ue=Q(ne);return te.has(ue)?!1:(te.add(ue),!0)}}e.uniqueFilter=r;function t(Q,te){const ne=i(Q,te);if(ne!==-1)return Q[ne]}e.findLast=t;function i(Q,te){for(let ne=Q.length-1;ne>=0;ne--){const ue=Q[ne];if(te(ue))return ne}return-1}e.lastIndex=i;function o(Q,te){return Q.length>0?Q[0]:te}e.firstOrDefault=o;function l(Q,te){return Q.length>0?Q[Q.length-1]:te}e.lastOrDefault=l;function a(Q,te,ne=(ue,he)=>ue===he){let ue=0;for(let he=0,pe=Math.min(Q.length,te.length);he<pe&&ne(Q[he],te[he]);he++)ue++;return ue}e.commonPrefixLength=a;function h(Q){return[].concat(...Q)}e.flatten=h;function p(Q,te){let ne=typeof te=="number"?Q:0;typeof te=="number"?ne=Q:(ne=0,te=Q);const ue=[];if(ne<=te)for(let he=ne;he<te;he++)ue.push(he);else for(let he=ne;he>te;he--)ue.push(he);return ue}e.range=p;function R(Q,te,ne){return Q.reduce((ue,he)=>(ue[te(he)]=ne?ne(he):he,ue),Object.create(null))}e.index=R;function M(Q,te){return Q.push(te),()=>O(Q,te)}e.insert=M;function O(Q,te){const ne=Q.indexOf(te);if(ne>-1)return Q.splice(ne,1),te}e.remove=O;function F(Q,te,ne){const ue=Q.slice(0,te),he=Q.slice(te);return ue.concat(ne,he)}e.arrayInsert=F;function T(Q,te){let ne;if(typeof te=="number"){let ue=te;ne=()=>{const he=Math.sin(ue++)*179426549;return he-Math.floor(he)}}else ne=Math.random;for(let ue=Q.length-1;ue>0;ue-=1){const he=Math.floor(ne()*(ue+1)),pe=Q[ue];Q[ue]=Q[he],Q[he]=pe}}e.shuffle=T;function N(Q,te){const ne=Q.indexOf(te);ne>-1&&(Q.splice(ne,1),Q.unshift(te))}e.pushToStart=N;function W(Q,te){const ne=Q.indexOf(te);ne>-1&&(Q.splice(ne,1),Q.push(te))}e.pushToEnd=W;function V(Q,te){for(const ne of te)Q.push(ne)}e.pushMany=V;function Y(Q,te){return Array.isArray(Q)?Q.map(te):te(Q)}e.mapArrayOrNot=Y;function $(Q){return Array.isArray(Q)?Q:[Q]}e.asArray=$;function J(Q){return Q[Math.floor(Math.random()*Q.length)]}e.getRandomElement=J;function H(Q,te){for(const ne of Q){const ue=te(ne);if(ue!==void 0)return ue}}e.mapFind=H;function B(Q,te,ne){const ue=ie(Q,te),he=Q.length,pe=ne.length;Q.length=he+pe;for(let we=he-1;we>=ue;we--)Q[we+pe]=Q[we];for(let we=0;we<pe;we++)Q[we+ue]=ne[we]}e.insertInto=B;function K(Q,te,ne,ue){const he=ie(Q,te),pe=Q.splice(he,ne);return B(Q,he,ue),pe}e.splice=K;function ie(Q,te){return te<0?Math.max(te+Q.length,0):Math.min(te,Q.length)}var ce;(function(Q){function te(he){return he<0}Q.isLessThan=te;function ne(he){return he>0}Q.isGreaterThan=ne;function ue(he){return he===0}Q.isNeitherLessOrGreaterThan=ue,Q.greaterThan=1,Q.lessThan=-1,Q.neitherLessOrGreaterThan=0})(ce=e.CompareResult||(e.CompareResult={}));function z(Q,te){return(ne,ue)=>te(Q(ne),Q(ue))}e.compareBy=z;function x(...Q){return(te,ne)=>{for(const ue of Q){const he=ue(te,ne);if(!ce.isNeitherLessOrGreaterThan(he))return he}return ce.neitherLessOrGreaterThan}}e.tieBreakComparators=x;const _=(Q,te)=>Q-te;e.numberComparator=_;function U(Q,te){if(Q.length===0)return;let ne=Q[0];for(let ue=1;ue<Q.length;ue++){const he=Q[ue];te(he,ne)>0&&(ne=he)}return ne}e.findMaxBy=U;function q(Q,te){if(Q.length===0)return;let ne=Q[0];for(let ue=1;ue<Q.length;ue++){const he=Q[ue];te(he,ne)>=0&&(ne=he)}return ne}e.findLastMaxBy=q;function j(Q,te){return U(Q,(ne,ue)=>-te(ne,ue))}e.findMinBy=j;class Z{constructor(te){this.items=te,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(te){let ne=this.firstIdx;for(;ne<this.items.length&&te(this.items[ne]);)ne++;const ue=ne===this.firstIdx?null:this.items.slice(this.firstIdx,ne);return this.firstIdx=ne,ue}takeFromEndWhile(te){let ne=this.lastIdx;for(;ne>=0&&te(this.items[ne]);)ne--;const ue=ne===this.lastIdx?null:this.items.slice(ne+1,this.lastIdx+1);return this.lastIdx=ne,ue}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const te=this.items[this.firstIdx];return this.firstIdx++,te}removeLast(){const te=this.items[this.lastIdx];return this.lastIdx--,te}takeCount(te){const ne=this.items.slice(this.firstIdx,this.firstIdx+te);return this.firstIdx+=te,ne}}e.ArrayQueue=Z;class oe{constructor(te){this.iterate=te}forEach(te){this.iterate(ne=>(te(ne),!0))}toArray(){const te=[];return this.iterate(ne=>(te.push(ne),!0)),te}filter(te){return new oe(ne=>this.iterate(ue=>te(ue)?ne(ue):!0))}map(te){return new oe(ne=>this.iterate(ue=>ne(te(ue))))}some(te){let ne=!1;return this.iterate(ue=>(ne=te(ue),!ne)),ne}findFirst(te){let ne;return this.iterate(ue=>te(ue)?(ne=ue,!1):!0),ne}findLast(te){let ne;return this.iterate(ue=>(te(ue)&&(ne=ue),!0)),ne}findLastMaxBy(te){let ne,ue=!0;return this.iterate(he=>((ue||ce.isGreaterThan(te(he,ne)))&&(ue=!1,ne=he),!0)),ne}}e.CallbackIterable=oe,oe.empty=new oe(Q=>{})}),define(re[74],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.once=void 0;function D(n){const k=this;let L=!1,A;return function(){return L||(L=!0,A=n.apply(k,arguments)),A}}e.once=D}),define(re[51],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Iterable=void 0;var D;(function(n){function k(r){return r&&typeof r=="object"&&typeof r[Symbol.iterator]=="function"}n.is=k;const L=Object.freeze([]);function A(){return L}n.empty=A;function*b(r){yield r}n.single=b;function P(r){return r||L}n.from=P;function I(r){return!r||r[Symbol.iterator]().next().done===!0}n.isEmpty=I;function E(r){return r[Symbol.iterator]().next().value}n.first=E;function w(r,t){for(const i of r)if(t(i))return!0;return!1}n.some=w;function v(r,t){for(const i of r)if(t(i))return i}n.find=v;function*y(r,t){for(const i of r)t(i)&&(yield i)}n.filter=y;function*f(r,t){let i=0;for(const o of r)yield t(o,i++)}n.map=f;function*S(...r){for(const t of r)for(const i of t)yield i}n.concat=S;function*C(r){for(const t of r)for(const i of t)yield i}n.concatNested=C;function m(r,t,i){let o=i;for(const l of r)o=t(o,l);return o}n.reduce=m;function g(r,t){let i=0;for(const o of r)t(o,i++)}n.forEach=g;function*c(r,t,i=r.length){for(t<0&&(t+=r.length),i<0?i+=r.length:i>r.length&&(i=r.length);t<i;t++)yield r[t]}n.slice=c;function d(r,t=Number.POSITIVE_INFINITY){const i=[];if(t===0)return[i,r];const o=r[Symbol.iterator]();for(let l=0;l<t;l++){const a=o.next();if(a.done)return[i,n.empty()];i.push(a.value)}return[i,{[Symbol.iterator](){return o}}]}n.consume=d;function u(r){return d(r)[0]}n.collect=u;function s(r,t,i=(o,l)=>o===l){const o=r[Symbol.iterator](),l=t[Symbol.iterator]();for(;;){const a=o.next(),h=l.next();if(a.done!==h.done)return!1;if(a.done)return!0;if(!i(a.value,h.value))return!1}}n.equals=s})(D=e.Iterable||(e.Iterable={}))}),define(re[35],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var D;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(D=e.ScanError||(e.ScanError={}));var n;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(n=e.SyntaxKind||(e.SyntaxKind={}));var k;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(k=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function A(s,r=!1){let t=0;const i=s.length;let o="",l=0,a=16,h=0;function p(W){let V=0,Y=0;for(;V<W;){const $=s.charCodeAt(t);if($>=48&&$<=57)Y=Y*16+$-48;else if($>=65&&$<=70)Y=Y*16+$-65+10;else if($>=97&&$<=102)Y=Y*16+$-97+10;else break;t++,V++}return V<W&&(Y=-1),Y}function R(W){t=W,o="",l=0,a=16,h=0}function M(){const W=t;if(s.charCodeAt(t)===48)t++;else for(t++;t<s.length&&I(s.charCodeAt(t));)t++;if(t<s.length&&s.charCodeAt(t)===46)if(t++,t<s.length&&I(s.charCodeAt(t)))for(t++;t<s.length&&I(s.charCodeAt(t));)t++;else return h=3,s.substring(W,t);let V=t;if(t<s.length&&(s.charCodeAt(t)===69||s.charCodeAt(t)===101))if(t++,(t<s.length&&s.charCodeAt(t)===43||s.charCodeAt(t)===45)&&t++,t<s.length&&I(s.charCodeAt(t))){for(t++;t<s.length&&I(s.charCodeAt(t));)t++;V=t}else h=3;return s.substring(W,V)}function O(){let W="",V=t;for(;;){if(t>=i){W+=s.substring(V,t),h=2;break}const Y=s.charCodeAt(t);if(Y===34){W+=s.substring(V,t),t++;break}if(Y===92){if(W+=s.substring(V,t),t++,t>=i){h=2;break}switch(s.charCodeAt(t++)){case 34:W+='"';break;case 92:W+="\\";break;case 47:W+="/";break;case 98:W+="\b";break;case 102:W+="\f";break;case 110:W+=`
`;break;case 114:W+="\r";break;case 116:W+="	";break;case 117:{const J=p(4);J>=0?W+=String.fromCharCode(J):h=4;break}default:h=5}V=t;continue}if(Y>=0&&Y<=31)if(P(Y)){W+=s.substring(V,t),h=2;break}else h=6;t++}return W}function F(){if(o="",h=0,l=t,t>=i)return l=i,a=17;let W=s.charCodeAt(t);if(b(W)){do t++,o+=String.fromCharCode(W),W=s.charCodeAt(t);while(b(W));return a=15}if(P(W))return t++,o+=String.fromCharCode(W),W===13&&s.charCodeAt(t)===10&&(t++,o+=`
`),a=14;switch(W){case 123:return t++,a=1;case 125:return t++,a=2;case 91:return t++,a=3;case 93:return t++,a=4;case 58:return t++,a=6;case 44:return t++,a=5;case 34:return t++,o=O(),a=10;case 47:{const V=t-1;if(s.charCodeAt(t+1)===47){for(t+=2;t<i&&!P(s.charCodeAt(t));)t++;return o=s.substring(V,t),a=12}if(s.charCodeAt(t+1)===42){t+=2;const Y=i-1;let $=!1;for(;t<Y;){if(s.charCodeAt(t)===42&&s.charCodeAt(t+1)===47){t+=2,$=!0;break}t++}return $||(t++,h=1),o=s.substring(V,t),a=13}return o+=String.fromCharCode(W),t++,a=16}case 45:if(o+=String.fromCharCode(W),t++,t===i||!I(s.charCodeAt(t)))return a=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=M(),a=11;default:for(;t<i&&T(W);)t++,W=s.charCodeAt(t);if(l!==t){switch(o=s.substring(l,t),o){case"true":return a=8;case"false":return a=9;case"null":return a=7}return a=16}return o+=String.fromCharCode(W),t++,a=16}}function T(W){if(b(W)||P(W))return!1;switch(W){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function N(){let W;do W=F();while(W>=12&&W<=15);return W}return{setPosition:R,getPosition:()=>t,scan:r?N:F,getToken:()=>a,getTokenValue:()=>o,getTokenOffset:()=>l,getTokenLength:()=>t-l,getTokenError:()=>h}}e.createScanner=A;function b(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function P(s){return s===10||s===13||s===8232||s===8233}function I(s){return s>=48&&s<=57}var E;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(E||(E={}));function w(s,r){const t=[],i=new Object;let o;const l={value:{},offset:0,length:0,type:"object",parent:void 0};let a=!1;function h(p,R,M,O){l.value=p,l.offset=R,l.length=M,l.type=O,l.colonOffset=void 0,o=l}try{c(s,{onObjectBegin:(p,R)=>{if(r<=p)throw i;o=void 0,a=r>p,t.push("")},onObjectProperty:(p,R,M)=>{if(r<R||(h(p,R,M,"property"),t[t.length-1]=p,r<=R+M))throw i},onObjectEnd:(p,R)=>{if(r<=p)throw i;o=void 0,t.pop()},onArrayBegin:(p,R)=>{if(r<=p)throw i;o=void 0,t.push(0)},onArrayEnd:(p,R)=>{if(r<=p)throw i;o=void 0,t.pop()},onLiteralValue:(p,R,M)=>{if(r<R||(h(p,R,M,u(p)),r<=R+M))throw i},onSeparator:(p,R,M)=>{if(r<=R)throw i;if(p===":"&&o&&o.type==="property")o.colonOffset=R,a=!1,o=void 0;else if(p===","){const O=t[t.length-1];typeof O=="number"?t[t.length-1]=O+1:(a=!0,t[t.length-1]=""),o=void 0}}})}catch(p){if(p!==i)throw p}return{path:t,previousNode:o,isAtPropertyKey:a,matches:p=>{let R=0;for(let M=0;R<p.length&&M<t.length;M++)if(p[R]===t[M]||p[R]==="*")R++;else if(p[R]!=="**")return!1;return R===p.length}}}e.getLocation=w;function v(s,r=[],t=L.DEFAULT){let i=null,o=[];const l=[];function a(p){Array.isArray(o)?o.push(p):i!==null&&(o[i]=p)}return c(s,{onObjectBegin:()=>{const p={};a(p),l.push(o),o=p,i=null},onObjectProperty:p=>{i=p},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const p=[];a(p),l.push(o),o=p,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:a,onError:(p,R,M)=>{r.push({error:p,offset:R,length:M})}},t),o[0]}e.parse=v;function y(s,r=[],t=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(p){i.type==="property"&&(i.length=p-i.offset,i=i.parent)}function l(p){return i.children.push(p),p}c(s,{onObjectBegin:p=>{i=l({type:"object",offset:p,length:-1,parent:i,children:[]})},onObjectProperty:(p,R,M)=>{i=l({type:"property",offset:R,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:p,offset:R,length:M,parent:i})},onObjectEnd:(p,R)=>{i.length=p+R-i.offset,i=i.parent,o(p+R)},onArrayBegin:(p,R)=>{i=l({type:"array",offset:p,length:-1,parent:i,children:[]})},onArrayEnd:(p,R)=>{i.length=p+R-i.offset,i=i.parent,o(p+R)},onLiteralValue:(p,R,M)=>{l({type:u(p),offset:R,length:M,parent:i,value:p}),o(R+M)},onSeparator:(p,R,M)=>{i.type==="property"&&(p===":"?i.colonOffset=R:p===","&&o(R))},onError:(p,R,M)=>{r.push({error:p,offset:R,length:M})}},t);const h=i.children[0];return h&&delete h.parent,h}e.parseTree=y;function f(s,r){if(!s)return;let t=s;for(const i of r)if(typeof i=="string"){if(t.type!=="object"||!Array.isArray(t.children))return;let o=!1;for(const l of t.children)if(Array.isArray(l.children)&&l.children[0].value===i){t=l.children[1],o=!0;break}if(!o)return}else{const o=i;if(t.type!=="array"||o<0||!Array.isArray(t.children)||o>=t.children.length)return;t=t.children[o]}return t}e.findNodeAtLocation=f;function S(s){if(!s.parent||!s.parent.children)return[];const r=S(s.parent);if(s.parent.type==="property"){const t=s.parent.children[0].value;r.push(t)}else if(s.parent.type==="array"){const t=s.parent.children.indexOf(s);t!==-1&&r.push(t)}return r}e.getNodePath=S;function C(s){switch(s.type){case"array":return s.children.map(C);case"object":{const r=Object.create(null);for(const t of s.children){const i=t.children[1];i&&(r[t.children[0].value]=C(i))}return r}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=C;function m(s,r,t=!1){return r>=s.offset&&r<s.offset+s.length||t&&r===s.offset+s.length}e.contains=m;function g(s,r,t=!1){if(m(s,r,t)){const i=s.children;if(Array.isArray(i))for(let o=0;o<i.length&&i[o].offset<=r;o++){const l=g(i[o],r,t);if(l)return l}return s}}e.findNodeAtOffset=g;function c(s,r,t=L.DEFAULT){const i=A(s,!1);function o(z){return z?()=>z(i.getTokenOffset(),i.getTokenLength()):()=>!0}function l(z){return z?x=>z(x,i.getTokenOffset(),i.getTokenLength()):()=>!0}const a=o(r.onObjectBegin),h=l(r.onObjectProperty),p=o(r.onObjectEnd),R=o(r.onArrayBegin),M=o(r.onArrayEnd),O=l(r.onLiteralValue),F=l(r.onSeparator),T=o(r.onComment),N=l(r.onError),W=t&&t.disallowComments,V=t&&t.allowTrailingComma;function Y(){for(;;){const z=i.scan();switch(i.getTokenError()){case 4:$(14);break;case 5:$(15);break;case 3:$(13);break;case 1:W||$(11);break;case 2:$(12);break;case 6:$(16);break}switch(z){case 12:case 13:W?$(10):T();break;case 16:$(1);break;case 15:case 14:break;default:return z}}}function $(z,x=[],_=[]){if(N(z),x.length+_.length>0){let U=i.getToken();for(;U!==17;){if(x.indexOf(U)!==-1){Y();break}else if(_.indexOf(U)!==-1)break;U=Y()}}}function J(z){const x=i.getTokenValue();return z?O(x):h(x),Y(),!0}function H(){switch(i.getToken()){case 11:{let z=0;try{z=JSON.parse(i.getTokenValue()),typeof z!="number"&&($(2),z=0)}catch{$(2)}O(z);break}case 7:O(null);break;case 8:O(!0);break;case 9:O(!1);break;default:return!1}return Y(),!0}function B(){return i.getToken()!==10?($(3,[],[2,5]),!1):(J(!1),i.getToken()===6?(F(":"),Y(),ce()||$(4,[],[2,5])):$(5,[],[2,5]),!0)}function K(){a(),Y();let z=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(z||$(4,[],[]),F(","),Y(),i.getToken()===2&&V)break}else z&&$(6,[],[]);B()||$(4,[],[2,5]),z=!0}return p(),i.getToken()!==2?$(7,[2],[]):Y(),!0}function ie(){R(),Y();let z=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(z||$(4,[],[]),F(","),Y(),i.getToken()===4&&V)break}else z&&$(6,[],[]);ce()||$(4,[],[4,5]),z=!0}return M(),i.getToken()!==4?$(8,[4],[]):Y(),!0}function ce(){switch(i.getToken()){case 3:return ie();case 1:return K();case 10:return J(!0);default:return H()}}return Y(),i.getToken()===17?t.allowEmptyContent?!0:($(4,[],[]),!1):ce()?(i.getToken()!==17&&$(9,[],[]),!0):($(4,[],[]),!1)}e.visit=c;function d(s,r){const t=A(s),i=[];let o,l=0,a;do switch(a=t.getPosition(),o=t.scan(),o){case 12:case 13:case 17:l!==a&&i.push(s.substring(l,a)),r!==void 0&&i.push(t.getTokenValue().replace(/[^\r\n]/g,r)),l=t.getPosition();break}while(o!==17);return i.join("")}e.stripComments=d;function u(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=u}),define(re[52],se([0,1,35]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEOL=e.getEOL=e.toFormattedString=e.format=void 0;function n(I,E,w){let v,y,f,S,C;if(E){for(S=E.offset,C=S+E.length,f=S;f>0&&!P(I,f-1);)f--;let a=C;for(;a<I.length&&!P(I,a);)a++;y=I.substring(f,a),v=A(y,w)}else y=I,v=0,f=0,S=0,C=I.length;const m=b(w,I);let g=!1,c=0,d;w.insertSpaces?d=L(" ",w.tabSize||4):d="	";const u=(0,D.createScanner)(y,!1);let s=!1;function r(){return m+L(d,v+c)}function t(){let a=u.scan();for(g=!1;a===15||a===14;)g=g||a===14,a=u.scan();return s=a===16||u.getTokenError()!==0,a}const i=[];function o(a,h,p){!s&&h<C&&p>S&&I.substring(h,p)!==a&&i.push({offset:h,length:p-h,content:a})}let l=t();if(l!==17){const a=u.getTokenOffset()+f,h=L(d,v);o(h,f,a)}for(;l!==17;){let a=u.getTokenOffset()+u.getTokenLength()+f,h=t(),p="";for(;!g&&(h===12||h===13);){const M=u.getTokenOffset()+f;o(" ",a,M),a=u.getTokenOffset()+u.getTokenLength()+f,p=h===12?r():"",h=t()}if(h===2)l!==1&&(c--,p=r());else if(h===4)l!==3&&(c--,p=r());else{switch(l){case 3:case 1:c++,p=r();break;case 5:case 12:p=r();break;case 13:g?p=r():p=" ";break;case 6:p=" ";break;case 10:if(h===6){p="";break}case 7:case 8:case 9:case 11:case 2:case 4:h===12||h===13?p=" ":h!==5&&h!==17&&(s=!0);break;case 16:s=!0;break}g&&(h===12||h===13)&&(p=r())}const R=u.getTokenOffset()+f;o(p,a,R),l=h}return i}e.format=n;function k(I,E){const w=JSON.stringify(I,void 0,E.insertSpaces?E.tabSize||4:"	");return E.eol!==void 0?w.replace(/\r\n|\r|\n/g,E.eol):w}e.toFormattedString=k;function L(I,E){let w="";for(let v=0;v<E;v++)w+=I;return w}function A(I,E){let w=0,v=0;const y=E.tabSize||4;for(;w<I.length;){const f=I.charAt(w);if(f===" ")v++;else if(f==="	")v+=y;else break;w++}return Math.floor(v/y)}function b(I,E){for(let w=0;w<E.length;w++){const v=E.charAt(w);if(v==="\r")return w+1<E.length&&E.charAt(w+1)===`
`?`\r
`:"\r";if(v===`
`)return`
`}return I&&I.eol||`
`}e.getEOL=b;function P(I,E){return`\r
`.indexOf(I.charAt(E))!==-1}e.isEOL=P}),define(re[75],se([0,1,35,52]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.applyEdits=e.applyEdit=e.withFormatting=e.setProperty=e.removeProperty=void 0;function k(I,E,w){return L(I,E,void 0,w)}e.removeProperty=k;function L(I,E,w,v,y){const f=E.slice(),S=[],C=(0,D.parseTree)(I,S);let m,g;for(;f.length>0&&(g=f.pop(),m=(0,D.findNodeAtLocation)(C,f),m===void 0&&w!==void 0);)typeof g=="string"?w={[g]:w}:w=[w];if(m)if(m.type==="object"&&typeof g=="string"&&Array.isArray(m.children)){const c=(0,D.findNodeAtLocation)(m,[g]);if(c!==void 0)if(w===void 0){if(!c.parent)throw new Error("Malformed AST");const d=m.children.indexOf(c.parent);let u,s=c.parent.offset+c.parent.length;if(d>0){const r=m.children[d-1];u=r.offset+r.length}else u=m.offset+1,m.children.length>1&&(s=m.children[1].offset);return A(I,{offset:u,length:s-u,content:""},v)}else return A(I,{offset:c.offset,length:c.length,content:JSON.stringify(w)},v);else{if(w===void 0)return[];const d=`${JSON.stringify(g)}: ${JSON.stringify(w)}`,u=y?y(m.children.map(r=>r.children[0].value)):m.children.length;let s;if(u>0){const r=m.children[u-1];s={offset:r.offset+r.length,length:0,content:","+d}}else m.children.length===0?s={offset:m.offset+1,length:0,content:d}:s={offset:m.offset+1,length:0,content:d+","};return A(I,s,v)}}else if(m.type==="array"&&typeof g=="number"&&Array.isArray(m.children))if(w!==void 0){const c=`${JSON.stringify(w)}`;let d;if(m.children.length===0||g===0)d={offset:m.offset+1,length:0,content:m.children.length===0?c:c+","};else{const u=g===-1||g>m.children.length?m.children.length:g,s=m.children[u-1];d={offset:s.offset+s.length,length:0,content:","+c}}return A(I,d,v)}else{const c=g,d=m.children[c];let u;if(m.children.length===1)u={offset:m.offset+1,length:m.length-2,content:""};else if(m.children.length-1===c){const s=m.children[c-1],r=s.offset+s.length,t=m.offset+m.length;u={offset:r,length:t-2-r,content:""}}else u={offset:d.offset,length:m.children[c+1].offset-d.offset,content:""};return A(I,u,v)}else throw new Error(`Can not add ${typeof g!="number"?"index":"property"} to parent of type ${m.type}`);else{if(w===void 0)throw new Error("Can not delete in empty document");return A(I,{offset:C?C.offset:0,length:C?C.length:0,content:JSON.stringify(w)},v)}}e.setProperty=L;function A(I,E,w){let v=b(I,E),y=E.offset,f=E.offset+E.content.length;if(E.length===0||E.content.length===0){for(;y>0&&!(0,n.isEOL)(v,y-1);)y--;for(;f<v.length&&!(0,n.isEOL)(v,f);)f++}const S=(0,n.format)(v,{offset:y,length:f-y},w);for(let m=S.length-1;m>=0;m--){const g=S[m];v=b(v,g),y=Math.min(y,g.offset),f=Math.max(f,g.offset+g.length),f+=g.content.length-g.length}const C=I.length-(v.length-f)-y;return[{offset:y,length:C,content:v.substring(y,f)}]}e.withFormatting=A;function b(I,E){return I.substring(0,E.offset)+E.content+I.substring(E.offset+E.length)}e.applyEdit=b;function P(I,E){const w=E.slice(0).sort((y,f)=>{const S=y.offset-f.offset;return S===0?y.length-f.length:S});let v=I.length;for(let y=w.length-1;y>=0;y--){const f=w[y];if(f.offset+f.length<=v)I=b(I,f);else throw new Error("Overlapping edit");v=f.offset}return I}e.applyEdits=P}),define(re[111],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Lazy=void 0;class D{constructor(k){this.executor=k,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(k){this._error=k}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(k){return new D(()=>k(this.getValue()))}}e.Lazy=D}),define(re[2],se([0,1,74,51]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.disposeOnReturn=e.ImmortalReference=e.AsyncReferenceCollection=e.ReferenceCollection=e.SafeDisposable=e.RefCountedDisposable=e.MutableDisposable=e.Disposable=e.DisposableStore=e.toDisposable=e.combinedDisposable=e.dispose=e.isDisposable=e.MultiDisposeError=e.markAsSingleton=e.setDisposableTracker=void 0;const k=!1;let L=null;function A(o){L=o}if(e.setDisposableTracker=A,k){const o="__is_disposable_tracked__";A(new class{trackDisposable(l){const a=new Error("Potentially leaked disposable").stack;setTimeout(()=>{l[o]||console.log(a)},3e3)}setParent(l,a){if(l&&l!==g.None)try{l[o]=!0}catch{}}markAsDisposed(l){if(l&&l!==g.None)try{l[o]=!0}catch{}}markAsSingleton(l){}})}function b(o){return L?.trackDisposable(o),o}function P(o){L?.markAsDisposed(o)}function I(o,l){L?.setParent(o,l)}function E(o,l){if(!!L)for(const a of o)L.setParent(a,l)}function w(o){return L?.markAsSingleton(o),o}e.markAsSingleton=w;class v extends Error{constructor(l){super(`Encountered errors while disposing of store. Errors: [${l.join(", ")}]`);this.errors=l}}e.MultiDisposeError=v;function y(o){return typeof o.dispose=="function"&&o.dispose.length===0}e.isDisposable=y;function f(o){if(n.Iterable.is(o)){const l=[];for(const a of o)if(a)try{a.dispose()}catch(h){l.push(h)}if(l.length===1)throw l[0];if(l.length>1)throw new v(l);return Array.isArray(o)?[]:o}else if(o)return o.dispose(),o}e.dispose=f;function S(...o){const l=C(()=>f(o));return E(o,l),l}e.combinedDisposable=S;function C(o){const l=b({dispose:(0,D.once)(()=>{P(l),o()})});return l}e.toDisposable=C;class m{constructor(){this._toDispose=new Set,this._isDisposed=!1,b(this)}dispose(){this._isDisposed||(P(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{f(this._toDispose.values())}finally{this._toDispose.clear()}}add(l){if(!l)return l;if(l===this)throw new Error("Cannot register a disposable on itself!");return I(l,this),this._isDisposed?m.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(l),l}}e.DisposableStore=m,m.DISABLE_DISPOSED_WARNING=!1;class g{constructor(){this._store=new m,b(this),I(this._store,this)}dispose(){P(this),this._store.dispose()}_register(l){if(l===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(l)}}e.Disposable=g,g.None=Object.freeze({dispose(){}});class c{constructor(){this._isDisposed=!1,b(this)}get value(){return this._isDisposed?void 0:this._value}set value(l){this._isDisposed||l===this._value||(this._value?.dispose(),l&&I(l,this),this._value=l)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,P(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const l=this._value;return this._value=void 0,l&&I(l,null),l}}e.MutableDisposable=c;class d{constructor(l){this._disposable=l,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}e.RefCountedDisposable=d;class u{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,b(this)}set(l){let a=l;return this.unset=()=>a=void 0,this.isset=()=>a!==void 0,this.dispose=()=>{a&&(a(),a=void 0,P(this))},this}}e.SafeDisposable=u;class s{constructor(){this.references=new Map}acquire(l,...a){let h=this.references.get(l);h||(h={counter:0,object:this.createReferencedObject(l,...a)},this.references.set(l,h));const{object:p}=h,R=(0,D.once)(()=>{--h.counter==0&&(this.destroyReferencedObject(l,h.object),this.references.delete(l))});return h.counter++,{object:p,dispose:R}}}e.ReferenceCollection=s;class r{constructor(l){this.referenceCollection=l}async acquire(l,...a){const h=this.referenceCollection.acquire(l,...a);try{return{object:await h.object,dispose:()=>h.dispose()}}catch(p){throw h.dispose(),p}}}e.AsyncReferenceCollection=r;class t{constructor(l){this.object=l}dispose(){}}e.ImmortalReference=t;function i(o){const l=new m;try{o(l)}finally{l.dispose()}}e.disposeOnReturn=i}),define(re[112],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LinkedList=void 0;class D{constructor(L){this.element=L,this.next=D.Undefined,this.prev=D.Undefined}}D.Undefined=new D(void 0);class n{constructor(){this._first=D.Undefined,this._last=D.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===D.Undefined}clear(){let L=this._first;for(;L!==D.Undefined;){const A=L.next;L.prev=D.Undefined,L.next=D.Undefined,L=A}this._first=D.Undefined,this._last=D.Undefined,this._size=0}unshift(L){return this._insert(L,!1)}push(L){return this._insert(L,!0)}_insert(L,A){const b=new D(L);if(this._first===D.Undefined)this._first=b,this._last=b;else if(A){const I=this._last;this._last=b,b.prev=I,I.next=b}else{const I=this._first;this._first=b,b.next=I,I.prev=b}this._size+=1;let P=!1;return()=>{P||(P=!0,this._remove(b))}}shift(){if(this._first!==D.Undefined){const L=this._first.element;return this._remove(this._first),L}}pop(){if(this._last!==D.Undefined){const L=this._last.element;return this._remove(this._last),L}}_remove(L){if(L.prev!==D.Undefined&&L.next!==D.Undefined){const A=L.prev;A.next=L.next,L.next.prev=A}else L.prev===D.Undefined&&L.next===D.Undefined?(this._first=D.Undefined,this._last=D.Undefined):L.next===D.Undefined?(this._last=this._last.prev,this._last.next=D.Undefined):L.prev===D.Undefined&&(this._first=this._first.next,this._first.prev=D.Undefined);this._size-=1}*[Symbol.iterator](){let L=this._first;for(;L!==D.Undefined;)yield L.element,L=L.next}}e.LinkedList=n}),function(){function X(k){const L=[];typeof k=="number"&&L.push("code/timeOrigin",k);function A(P){L.push(P,Date.now())}function b(){const P=[];for(let I=0;I<L.length;I+=2)P.push({name:L[I],startTime:L[I+1]});return P}return{mark:A,getMarks:b}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?X():{mark(k){performance.mark(k)},getMarks(){let k=performance.timeOrigin;typeof k!="number"&&(k=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(k)}];for(const A of performance.getEntriesByType("mark"))L.push({name:A.name,startTime:Math.round(k+A.startTime)});return L}};if(typeof process=="object"){const k=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return X(k)}else return console.trace("perf-util loaded in UNKNOWN environment"),X()}function D(k){return k.MonacoPerformanceMarks||(k.MonacoPerformanceMarks=e()),k.MonacoPerformanceMarks}var n;typeof global=="object"?n=global:typeof self=="object"?n=self:n={},typeof define=="function"?define("vs/base/common/performance",[],function(){return D(n)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=D(n):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),n.perf=D(n))}(),function(X,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var D=e();for(var n in D)(typeof exports=="object"?exports:X)[n]=D[n]}}(typeof self!="undefined"?self:this,function(){return function(X){var e={};function D(n){if(e[n])return e[n].exports;var k=e[n]={i:n,l:!1,exports:{}};return X[n].call(k.exports,k,k.exports,D),k.l=!0,k.exports}return D.m=X,D.c=e,D.d=function(n,k,L){D.o(n,k)||Object.defineProperty(n,k,{enumerable:!0,get:L})},D.r=function(n){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(n,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(n,"__esModule",{value:!0})},D.t=function(n,k){if(1&k&&(n=D(n)),8&k||4&k&&typeof n=="object"&&n&&n.__esModule)return n;var L=Object.create(null);if(D.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:n}),2&k&&typeof n!="string")for(var A in n)D.d(L,A,function(b){return n[b]}.bind(null,A));return L},D.n=function(n){var k=n&&n.__esModule?function(){return n.default}:function(){return n};return D.d(k,"a",k),k},D.o=function(n,k){return Object.prototype.hasOwnProperty.call(n,k)},D.p="",D(D.s=0)}([function(X,e,D){(function(n){var k;e=X.exports=_,k=typeof n=="object"&&n.env&&n.env.NODE_DEBUG&&/\bsemver\b/i.test(n.env.NODE_DEBUG)?function(){var ae=Array.prototype.slice.call(arguments,0);ae.unshift("SEMVER"),console.log.apply(console,ae)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,b=e.re=[],P=e.src=[],I=0,E=I++;P[E]="0|[1-9]\\d*";var w=I++;P[w]="[0-9]+";var v=I++;P[v]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var y=I++;P[y]="("+P[E]+")\\.("+P[E]+")\\.("+P[E]+")";var f=I++;P[f]="("+P[w]+")\\.("+P[w]+")\\.("+P[w]+")";var S=I++;P[S]="(?:"+P[E]+"|"+P[v]+")";var C=I++;P[C]="(?:"+P[w]+"|"+P[v]+")";var m=I++;P[m]="(?:-("+P[S]+"(?:\\."+P[S]+")*))";var g=I++;P[g]="(?:-?("+P[C]+"(?:\\."+P[C]+")*))";var c=I++;P[c]="[0-9A-Za-z-]+";var d=I++;P[d]="(?:\\+("+P[c]+"(?:\\."+P[c]+")*))";var u=I++,s="v?"+P[y]+P[m]+"?"+P[d]+"?";P[u]="^"+s+"$";var r="[v=\\s]*"+P[f]+P[g]+"?"+P[d]+"?",t=I++;P[t]="^"+r+"$";var i=I++;P[i]="((?:<|>)?=?)";var o=I++;P[o]=P[w]+"|x|X|\\*";var l=I++;P[l]=P[E]+"|x|X|\\*";var a=I++;P[a]="[v=\\s]*("+P[l]+")(?:\\.("+P[l]+")(?:\\.("+P[l]+")(?:"+P[m]+")?"+P[d]+"?)?)?";var h=I++;P[h]="[v=\\s]*("+P[o]+")(?:\\.("+P[o]+")(?:\\.("+P[o]+")(?:"+P[g]+")?"+P[d]+"?)?)?";var p=I++;P[p]="^"+P[i]+"\\s*"+P[a]+"$";var R=I++;P[R]="^"+P[i]+"\\s*"+P[h]+"$";var M=I++;P[M]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var O=I++;P[O]="(?:~>?)";var F=I++;P[F]="(\\s*)"+P[O]+"\\s+",b[F]=new RegExp(P[F],"g");var T=I++;P[T]="^"+P[O]+P[a]+"$";var N=I++;P[N]="^"+P[O]+P[h]+"$";var W=I++;P[W]="(?:\\^)";var V=I++;P[V]="(\\s*)"+P[W]+"\\s+",b[V]=new RegExp(P[V],"g");var Y=I++;P[Y]="^"+P[W]+P[a]+"$";var $=I++;P[$]="^"+P[W]+P[h]+"$";var J=I++;P[J]="^"+P[i]+"\\s*("+r+")$|^$";var H=I++;P[H]="^"+P[i]+"\\s*("+s+")$|^$";var B=I++;P[B]="(\\s*)"+P[i]+"\\s*("+r+"|"+P[a]+")",b[B]=new RegExp(P[B],"g");var K=I++;P[K]="^\\s*("+P[a]+")\\s+-\\s+("+P[a]+")\\s*$";var ie=I++;P[ie]="^\\s*("+P[h]+")\\s+-\\s+("+P[h]+")\\s*$";var ce=I++;P[ce]="(<|>)?=?\\s*\\*";for(var z=0;z<35;z++)k(z,P[z]),b[z]||(b[z]=new RegExp(P[z]));function x(ae,de){if(ae instanceof _)return ae;if(typeof ae!="string"||ae.length>L||!(de?b[t]:b[u]).test(ae))return null;try{return new _(ae,de)}catch{return null}}function _(ae,de){if(ae instanceof _){if(ae.loose===de)return ae;ae=ae.version}else if(typeof ae!="string")throw new TypeError("Invalid Version: "+ae);if(ae.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof _))return new _(ae,de);k("SemVer",ae,de),this.loose=de;var fe=ae.trim().match(de?b[t]:b[u]);if(!fe)throw new TypeError("Invalid Version: "+ae);if(this.raw=ae,this.major=+fe[1],this.minor=+fe[2],this.patch=+fe[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");fe[4]?this.prerelease=fe[4].split(".").map(function(be){if(/^[0-9]+$/.test(be)){var Ie=+be;if(Ie>=0&&Ie<A)return Ie}return be}):this.prerelease=[],this.build=fe[5]?fe[5].split("."):[],this.format()}e.parse=x,e.valid=function(ae,de){var fe=x(ae,de);return fe?fe.version:null},e.clean=function(ae,de){var fe=x(ae.trim().replace(/^[=v]+/,""),de);return fe?fe.version:null},e.SemVer=_,_.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},_.prototype.toString=function(){return this.version},_.prototype.compare=function(ae){return k("SemVer.compare",this.version,this.loose,ae),ae instanceof _||(ae=new _(ae,this.loose)),this.compareMain(ae)||this.comparePre(ae)},_.prototype.compareMain=function(ae){return ae instanceof _||(ae=new _(ae,this.loose)),q(this.major,ae.major)||q(this.minor,ae.minor)||q(this.patch,ae.patch)},_.prototype.comparePre=function(ae){if(ae instanceof _||(ae=new _(ae,this.loose)),this.prerelease.length&&!ae.prerelease.length)return-1;if(!this.prerelease.length&&ae.prerelease.length)return 1;if(!this.prerelease.length&&!ae.prerelease.length)return 0;var de=0;do{var fe=this.prerelease[de],be=ae.prerelease[de];if(k("prerelease compare",de,fe,be),fe===void 0&&be===void 0)return 0;if(be===void 0)return 1;if(fe===void 0)return-1;if(fe!==be)return q(fe,be)}while(++de)},_.prototype.inc=function(ae,de){switch(ae){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",de);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",de);break;case"prepatch":this.prerelease.length=0,this.inc("patch",de),this.inc("pre",de);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",de),this.inc("pre",de);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var fe=this.prerelease.length;--fe>=0;)typeof this.prerelease[fe]=="number"&&(this.prerelease[fe]++,fe=-2);fe===-1&&this.prerelease.push(0)}de&&(this.prerelease[0]===de?isNaN(this.prerelease[1])&&(this.prerelease=[de,0]):this.prerelease=[de,0]);break;default:throw new Error("invalid increment argument: "+ae)}return this.format(),this.raw=this.version,this},e.inc=function(ae,de,fe,be){typeof fe=="string"&&(be=fe,fe=void 0);try{return new _(ae,fe).inc(de,be).version}catch{return null}},e.diff=function(ae,de){if(Q(ae,de))return null;var fe=x(ae),be=x(de);if(fe.prerelease.length||be.prerelease.length){for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==be[Ie])return"pre"+Ie;return"prerelease"}for(var Ie in fe)if((Ie==="major"||Ie==="minor"||Ie==="patch")&&fe[Ie]!==be[Ie])return Ie},e.compareIdentifiers=q;var U=/^[0-9]+$/;function q(ae,de){var fe=U.test(ae),be=U.test(de);return fe&&be&&(ae=+ae,de=+de),fe&&!be?-1:be&&!fe?1:ae<de?-1:ae>de?1:0}function j(ae,de,fe){return new _(ae,fe).compare(new _(de,fe))}function Z(ae,de,fe){return j(ae,de,fe)>0}function oe(ae,de,fe){return j(ae,de,fe)<0}function Q(ae,de,fe){return j(ae,de,fe)===0}function te(ae,de,fe){return j(ae,de,fe)!==0}function ne(ae,de,fe){return j(ae,de,fe)>=0}function ue(ae,de,fe){return j(ae,de,fe)<=0}function he(ae,de,fe,be){var Ie;switch(de){case"===":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae===fe;break;case"!==":typeof ae=="object"&&(ae=ae.version),typeof fe=="object"&&(fe=fe.version),Ie=ae!==fe;break;case"":case"=":case"==":Ie=Q(ae,fe,be);break;case"!=":Ie=te(ae,fe,be);break;case">":Ie=Z(ae,fe,be);break;case">=":Ie=ne(ae,fe,be);break;case"<":Ie=oe(ae,fe,be);break;case"<=":Ie=ue(ae,fe,be);break;default:throw new TypeError("Invalid operator: "+de)}return Ie}function pe(ae,de){if(ae instanceof pe){if(ae.loose===de)return ae;ae=ae.value}if(!(this instanceof pe))return new pe(ae,de);k("comparator",ae,de),this.loose=de,this.parse(ae),this.semver===we?this.value="":this.value=this.operator+this.semver.version,k("comp",this)}e.rcompareIdentifiers=function(ae,de){return q(de,ae)},e.major=function(ae,de){return new _(ae,de).major},e.minor=function(ae,de){return new _(ae,de).minor},e.patch=function(ae,de){return new _(ae,de).patch},e.compare=j,e.compareLoose=function(ae,de){return j(ae,de,!0)},e.rcompare=function(ae,de,fe){return j(de,ae,fe)},e.sort=function(ae,de){return ae.sort(function(fe,be){return e.compare(fe,be,de)})},e.rsort=function(ae,de){return ae.sort(function(fe,be){return e.rcompare(fe,be,de)})},e.gt=Z,e.lt=oe,e.eq=Q,e.neq=te,e.gte=ne,e.lte=ue,e.cmp=he,e.Comparator=pe;var we={};function Ce(ae,de){if(ae instanceof Ce)return ae.loose===de?ae:new Ce(ae.raw,de);if(ae instanceof pe)return new Ce(ae.value,de);if(!(this instanceof Ce))return new Ce(ae,de);if(this.loose=de,this.raw=ae,this.set=ae.split(/\s*\|\|\s*/).map(function(fe){return this.parseRange(fe.trim())},this).filter(function(fe){return fe.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+ae);this.format()}function Pe(ae){return!ae||ae.toLowerCase()==="x"||ae==="*"}function Ue(ae,de,fe,be,Ie,Me,De,$e,Ae,Te,Ne,ee,le){return((de=Pe(fe)?"":Pe(be)?">="+fe+".0.0":Pe(Ie)?">="+fe+"."+be+".0":">="+de)+" "+($e=Pe(Ae)?"":Pe(Te)?"<"+(+Ae+1)+".0.0":Pe(Ne)?"<"+Ae+"."+(+Te+1)+".0":ee?"<="+Ae+"."+Te+"."+Ne+"-"+ee:"<="+$e)).trim()}function We(ae,de){for(var fe=0;fe<ae.length;fe++)if(!ae[fe].test(de))return!1;if(de.prerelease.length){for(fe=0;fe<ae.length;fe++)if(k(ae[fe].semver),ae[fe].semver!==we&&ae[fe].semver.prerelease.length>0){var be=ae[fe].semver;if(be.major===de.major&&be.minor===de.minor&&be.patch===de.patch)return!0}return!1}return!0}function Be(ae,de,fe){try{de=new Ce(de,fe)}catch{return!1}return de.test(ae)}function qe(ae,de,fe,be){var Ie,Me,De,$e,Ae;switch(ae=new _(ae,be),de=new Ce(de,be),fe){case">":Ie=Z,Me=ue,De=oe,$e=">",Ae=">=";break;case"<":Ie=oe,Me=ne,De=Z,$e="<",Ae="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Be(ae,de,be))return!1;for(var Te=0;Te<de.set.length;++Te){var Ne=de.set[Te],ee=null,le=null;if(Ne.forEach(function(ge){ge.semver===we&&(ge=new pe(">=0.0.0")),ee=ee||ge,le=le||ge,Ie(ge.semver,ee.semver,be)?ee=ge:De(ge.semver,le.semver,be)&&(le=ge)}),ee.operator===$e||ee.operator===Ae||(!le.operator||le.operator===$e)&&Me(ae,le.semver)||le.operator===Ae&&De(ae,le.semver))return!1}return!0}pe.prototype.parse=function(ae){var de=this.loose?b[J]:b[H],fe=ae.match(de);if(!fe)throw new TypeError("Invalid comparator: "+ae);this.operator=fe[1],this.operator==="="&&(this.operator=""),fe[2]?this.semver=new _(fe[2],this.loose):this.semver=we},pe.prototype.toString=function(){return this.value},pe.prototype.test=function(ae){return k("Comparator.test",ae,this.loose),this.semver===we||(typeof ae=="string"&&(ae=new _(ae,this.loose)),he(ae,this.operator,this.semver,this.loose))},pe.prototype.intersects=function(ae,de){if(!(ae instanceof pe))throw new TypeError("a Comparator is required");var fe;if(this.operator==="")return fe=new Ce(ae.value,de),Be(this.value,fe,de);if(ae.operator==="")return fe=new Ce(this.value,de),Be(ae.semver,fe,de);var be=!(this.operator!==">="&&this.operator!==">"||ae.operator!==">="&&ae.operator!==">"),Ie=!(this.operator!=="<="&&this.operator!=="<"||ae.operator!=="<="&&ae.operator!=="<"),Me=this.semver.version===ae.semver.version,De=!(this.operator!==">="&&this.operator!=="<="||ae.operator!==">="&&ae.operator!=="<="),$e=he(this.semver,"<",ae.semver,de)&&(this.operator===">="||this.operator===">")&&(ae.operator==="<="||ae.operator==="<"),Ae=he(this.semver,">",ae.semver,de)&&(this.operator==="<="||this.operator==="<")&&(ae.operator===">="||ae.operator===">");return be||Ie||Me&&De||$e||Ae},e.Range=Ce,Ce.prototype.format=function(){return this.range=this.set.map(function(ae){return ae.join(" ").trim()}).join("||").trim(),this.range},Ce.prototype.toString=function(){return this.range},Ce.prototype.parseRange=function(ae){var de=this.loose;ae=ae.trim(),k("range",ae,de);var fe=de?b[ie]:b[K];ae=ae.replace(fe,Ue),k("hyphen replace",ae),ae=ae.replace(b[B],"$1$2$3"),k("comparator trim",ae,b[B]),ae=(ae=(ae=ae.replace(b[F],"$1~")).replace(b[V],"$1^")).split(/\s+/).join(" ");var be=de?b[J]:b[H],Ie=ae.split(" ").map(function(Me){return function(De,$e){return k("comp",De),De=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(ee,le){k("caret",ee,le);var ge=le?b[$]:b[Y];return ee.replace(ge,function(Se,ve,Ee,Re,ke){var Le;return k("caret",ee,Se,ve,Ee,Re,ke),Pe(ve)?Le="":Pe(Ee)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":Pe(Re)?Le=ve==="0"?">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+".0 <"+(+ve+1)+".0.0":ke?(k("replaceCaret pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+ke+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+ke+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+ke+" <"+(+ve+1)+".0.0"):(k("no pr"),Le=ve==="0"?Ee==="0"?">="+ve+"."+Ee+"."+Re+" <"+ve+"."+Ee+"."+(+Re+1):">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0":">="+ve+"."+Ee+"."+Re+" <"+(+ve+1)+".0.0"),k("caret return",Le),Le})}(Ne,Te)}).join(" ")}(De,$e),k("caret",De),De=function(Ae,Te){return Ae.trim().split(/\s+/).map(function(Ne){return function(ee,le){var ge=le?b[N]:b[T];return ee.replace(ge,function(Se,ve,Ee,Re,ke){var Le;return k("tilde",ee,Se,ve,Ee,Re,ke),Pe(ve)?Le="":Pe(Ee)?Le=">="+ve+".0.0 <"+(+ve+1)+".0.0":Pe(Re)?Le=">="+ve+"."+Ee+".0 <"+ve+"."+(+Ee+1)+".0":ke?(k("replaceTilde pr",ke),ke.charAt(0)!=="-"&&(ke="-"+ke),Le=">="+ve+"."+Ee+"."+Re+ke+" <"+ve+"."+(+Ee+1)+".0"):Le=">="+ve+"."+Ee+"."+Re+" <"+ve+"."+(+Ee+1)+".0",k("tilde return",Le),Le})}(Ne,Te)}).join(" ")}(De,$e),k("tildes",De),De=function(Ae,Te){return k("replaceXRanges",Ae,Te),Ae.split(/\s+/).map(function(Ne){return function(ee,le){ee=ee.trim();var ge=le?b[R]:b[p];return ee.replace(ge,function(Se,ve,Ee,Re,ke,Le){k("xRange",ee,Se,ve,Ee,Re,ke,Le);var _e=Pe(Ee),Fe=_e||Pe(Re),ze=Fe||Pe(ke);return ve==="="&&ze&&(ve=""),_e?Se=ve===">"||ve==="<"?"<0.0.0":"*":ve&&ze?(Fe&&(Re=0),ze&&(ke=0),ve===">"?(ve=">=",Fe?(Ee=+Ee+1,Re=0,ke=0):ze&&(Re=+Re+1,ke=0)):ve==="<="&&(ve="<",Fe?Ee=+Ee+1:Re=+Re+1),Se=ve+Ee+"."+Re+"."+ke):Fe?Se=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":ze&&(Se=">="+Ee+"."+Re+".0 <"+Ee+"."+(+Re+1)+".0"),k("xRange return",Se),Se})}(Ne,Te)}).join(" ")}(De,$e),k("xrange",De),De=function(Ae,Te){return k("replaceStars",Ae,Te),Ae.trim().replace(b[ce],"")}(De,$e),k("stars",De),De}(Me,de)}).join(" ").split(/\s+/);return this.loose&&(Ie=Ie.filter(function(Me){return!!Me.match(be)})),Ie=Ie.map(function(Me){return new pe(Me,de)})},Ce.prototype.intersects=function(ae,de){if(!(ae instanceof Ce))throw new TypeError("a Range is required");return this.set.some(function(fe){return fe.every(function(be){return ae.set.some(function(Ie){return Ie.every(function(Me){return be.intersects(Me,de)})})})})},e.toComparators=function(ae,de){return new Ce(ae,de).set.map(function(fe){return fe.map(function(be){return be.value}).join(" ").trim().split(" ")})},Ce.prototype.test=function(ae){if(!ae)return!1;typeof ae=="string"&&(ae=new _(ae,this.loose));for(var de=0;de<this.set.length;de++)if(We(this.set[de],ae))return!0;return!1},e.satisfies=Be,e.maxSatisfying=function(ae,de,fe){var be=null,Ie=null;try{var Me=new Ce(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(be&&Ie.compare(De)!==-1||(Ie=new _(be=De,fe)))}),be},e.minSatisfying=function(ae,de,fe){var be=null,Ie=null;try{var Me=new Ce(de,fe)}catch{return null}return ae.forEach(function(De){Me.test(De)&&(be&&Ie.compare(De)!==1||(Ie=new _(be=De,fe)))}),be},e.validRange=function(ae,de){try{return new Ce(ae,de).range||"*"}catch{return null}},e.ltr=function(ae,de,fe){return qe(ae,de,"<",fe)},e.gtr=function(ae,de,fe){return qe(ae,de,">",fe)},e.outside=qe,e.prerelease=function(ae,de){var fe=x(ae,de);return fe&&fe.prerelease.length?fe.prerelease:null},e.intersects=function(ae,de,fe){return ae=new Ce(ae,fe),de=new Ce(de,fe),ae.intersects(de)},e.coerce=function(ae){if(ae instanceof _)return ae;if(typeof ae!="string")return null;var de=ae.match(b[M]);return de==null?null:x((de[1]||"0")+"."+(de[2]||"0")+"."+(de[3]||"0"))}}).call(this,D(1))},function(X,e){var D,n,k=X.exports={};function L(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function b(C){if(D===setTimeout)return setTimeout(C,0);if((D===L||!D)&&setTimeout)return D=setTimeout,setTimeout(C,0);try{return D(C,0)}catch{try{return D.call(null,C,0)}catch{return D.call(this,C,0)}}}(function(){try{D=typeof setTimeout=="function"?setTimeout:L}catch{D=L}try{n=typeof clearTimeout=="function"?clearTimeout:A}catch{n=A}})();var P,I=[],E=!1,w=-1;function v(){E&&P&&(E=!1,P.length?I=P.concat(I):w=-1,I.length&&y())}function y(){if(!E){var C=b(v);E=!0;for(var m=I.length;m;){for(P=I,I=[];++w<m;)P&&P[w].run();w=-1,m=I.length}P=null,E=!1,function(g){if(n===clearTimeout)return clearTimeout(g);if((n===A||!n)&&clearTimeout)return n=clearTimeout,clearTimeout(g);try{n(g)}catch{try{return n.call(null,g)}catch{return n.call(this,g)}}}(C)}}function f(C,m){this.fun=C,this.array=m}function S(){}k.nextTick=function(C){var m=new Array(arguments.length-1);if(arguments.length>1)for(var g=1;g<arguments.length;g++)m[g-1]=arguments[g];I.push(new f(C,m)),I.length!==1||E||b(y)},f.prototype.run=function(){this.fun.apply(null,this.array)},k.title="browser",k.browser=!0,k.env={},k.argv=[],k.version="",k.versions={},k.on=S,k.addListener=S,k.once=S,k.off=S,k.removeListener=S,k.removeAllListeners=S,k.emit=S,k.prependListener=S,k.prependOnceListener=S,k.listeners=function(C){return[]},k.binding=function(C){throw new Error("process.binding is not supported")},k.cwd=function(){return"/"},k.chdir=function(C){throw new Error("process.chdir is not supported")},k.umask=function(){return 0}}])}),define(re[113],se([0,1]),function(X,e){"use strict";var D;Object.defineProperty(e,"__esModule",{value:!0}),e.SkipList=void 0;class n{constructor(b,P,I){this.level=b,this.key=P,this.value=I,this.forward=[]}}const k=void 0;class L{constructor(b,P=2**16){this.comparator=b,this[D]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(P)|0),this._header=new n(this._maxLevel,k,k)}get size(){return this._size}clear(){this._header=new n(this._maxLevel,k,k)}has(b){return Boolean(L._search(this,b,this.comparator))}get(b){return L._search(this,b,this.comparator)?.value}set(b,P){return L._insert(this,b,P,this.comparator)&&(this._size+=1),this}delete(b){const P=L._delete(this,b,this.comparator);return P&&(this._size-=1),P}forEach(b,P){let I=this._header.forward[0];for(;I;)b.call(P,I.value,I.key,this),I=I.forward[0]}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let b=this._header.forward[0];for(;b;)yield[b.key,b.value],b=b.forward[0]}*keys(){let b=this._header.forward[0];for(;b;)yield b.key,b=b.forward[0]}*values(){let b=this._header.forward[0];for(;b;)yield b.value,b=b.forward[0]}toString(){let b="[SkipList]:",P=this._header.forward[0];for(;P;)b+=`node(${P.key}, ${P.value}, lvl:${P.level})`,P=P.forward[0];return b}static _search(b,P,I){let E=b._header;for(let w=b._level-1;w>=0;w--)for(;E.forward[w]&&I(E.forward[w].key,P)<0;)E=E.forward[w];if(E=E.forward[0],E&&I(E.key,P)===0)return E}static _insert(b,P,I,E){const w=[];let v=b._header;for(let y=b._level-1;y>=0;y--){for(;v.forward[y]&&E(v.forward[y].key,P)<0;)v=v.forward[y];w[y]=v}if(v=v.forward[0],v&&E(v.key,P)===0)return v.value=I,!1;{const y=L._randomLevel(b);if(y>b._level){for(let f=b._level;f<y;f++)w[f]=b._header;b._level=y}v=new n(y,P,I);for(let f=0;f<y;f++)v.forward[f]=w[f].forward[f],w[f].forward[f]=v;return!0}}static _randomLevel(b,P=.5){let I=1;for(;Math.random()<P&&I<b._maxLevel;)I+=1;return I}static _delete(b,P,I){const E=[];let w=b._header;for(let v=b._level-1;v>=0;v--){for(;w.forward[v]&&I(w.forward[v].key,P)<0;)w=w.forward[v];E[v]=w}if(w=w.forward[0],!w||I(w.key,P)!==0)return!1;for(let v=0;v<b._level&&E[v].forward[v]===w;v++)E[v].forward[v]=w.forward[v];for(;b._level>0&&b._header.forward[b._level-1]===k;)b._level-=1;return!0}}e.SkipList=L}),define(re[41],se([0,1,9,2]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function k(d){const u=d;return u?typeof u.read=="function":!1}e.isReadable=k;function L(d){const u=d;return u?[u.on,u.pause,u.resume,u.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function A(d){const u=d;return u?L(u.stream)&&Array.isArray(u.buffer)&&typeof u.ended=="boolean":!1}e.isReadableBufferedStream=A;function b(d,u){return new P(d,u)}e.newWriteableStream=b;class P{constructor(u,s){this.reducer=u,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(u){if(!this.state.destroyed){if(this.state.flowing)this.emitData(u);else if(this.buffer.data.push(u),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(u){this.state.destroyed||(this.state.flowing?this.emitError(u):this.buffer.error.push(u))}end(u){this.state.destroyed||(typeof u!="undefined"&&this.write(u),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(u){this.listeners.data.slice(0).forEach(s=>s(u))}emitError(u){this.listeners.error.length===0?(0,D.onUnexpectedError)(u):this.listeners.error.slice(0).forEach(s=>s(u))}emitEnd(){this.listeners.end.slice(0).forEach(u=>u())}on(u,s){if(!this.state.destroyed)switch(u){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(u,s){if(this.state.destroyed)return;let r;switch(u){case"data":r=this.listeners.data;break;case"end":r=this.listeners.end;break;case"error":r=this.listeners.error;break}if(r){const t=r.indexOf(s);t>=0&&r.splice(t,1)}}flowData(){if(this.buffer.data.length>0){const u=this.reducer(this.buffer.data);this.emitData(u),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(r=>r())}}flowErrors(){if(this.listeners.error.length>0){for(const u of this.buffer.error)this.emitError(u);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function I(d,u){const s=[];let r;for(;(r=d.read())!==null;)s.push(r);return u(s)}e.consumeReadable=I;function E(d,u,s){const r=[];let t;for(;(t=d.read())!==null&&r.length<s;)r.push(t);return t===null&&r.length>0?u(r):{read:()=>{if(r.length>0)return r.shift();if(typeof t!="undefined"){const i=t;return t=void 0,i}return d.read()}}}e.peekReadable=E;function w(d,u){return new Promise((s,r)=>{const t=[];v(d,{onData:i=>{u&&t.push(i)},onError:i=>{u?r(i):s(void 0)},onEnd:()=>{s(u?u(t):void 0)}})})}e.consumeStream=w;function v(d,u){let s=!1;return d.on("error",r=>{s||u.onError(r)}),d.on("end",()=>{s||u.onEnd()}),d.on("data",r=>{s||u.onData(r)}),(0,n.toDisposable)(()=>s=!0)}e.listenStream=v;function y(d,u){return new Promise((s,r)=>{const t=new n.DisposableStore,i=[],o=h=>{if(i.push(h),i.length>u)return t.dispose(),d.pause(),s({stream:d,buffer:i,ended:!1})},l=h=>r(h),a=()=>s({stream:d,buffer:i,ended:!0});t.add((0,n.toDisposable)(()=>d.removeListener("error",l))),d.on("error",l),t.add((0,n.toDisposable)(()=>d.removeListener("end",a))),d.on("end",a),t.add((0,n.toDisposable)(()=>d.removeListener("data",o))),d.on("data",o)})}e.peekStream=y;function f(d,u){const s=b(u);return s.end(d),s}e.toStream=f;function S(){const d=b(()=>{throw new Error("not supported")});return d.end(),d}e.emptyStream=S;function C(d){let u=!1;return{read:()=>u?null:(u=!0,d)}}e.toReadable=C;function m(d,u,s){const r=b(s);return v(d,{onData:t=>r.write(u.data(t)),onError:t=>r.error(u.error?u.error(t):t),onEnd:()=>r.end()}),r}e.transform=m;function g(d,u,s){let r=!1;return{read:()=>{const t=u.read();return r?t:(r=!0,t!==null?s([d,t]):d)}}}e.prefixedReadable=g;function c(d,u,s){let r=!1;const t=b(s);return v(u,{onData:i=>r?t.write(i):(r=!0,t.write(s([d,i]))),onError:i=>t.error(i),onEnd:()=>{r||(r=!0,t.write(d)),t.end()}}),t}e.prefixedStream=c}),define(re[16],se([0,1,41]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const n=typeof Buffer!="undefined";let k,L;class A{constructor(h){this.buffer=h,this.byteLength=this.buffer.byteLength}static alloc(h){return n?new A(Buffer.allocUnsafe(h)):new A(new Uint8Array(h))}static wrap(h){return n&&!Buffer.isBuffer(h)&&(h=Buffer.from(h.buffer,h.byteOffset,h.byteLength)),new A(h)}static fromString(h,p){return!(p?.dontUseNodeBuffer||!1)&&n?new A(Buffer.from(h)):(k||(k=new TextEncoder),new A(k.encode(h)))}static fromByteArray(h){const p=A.alloc(h.length);for(let R=0,M=h.length;R<M;R++)p.buffer[R]=h[R];return p}static concat(h,p){if(typeof p=="undefined"){p=0;for(let O=0,F=h.length;O<F;O++)p+=h[O].byteLength}const R=A.alloc(p);let M=0;for(let O=0,F=h.length;O<F;O++){const T=h[O];R.set(T,M),M+=T.byteLength}return R}clone(){const h=A.alloc(this.byteLength);return h.set(this),h}toString(){return n?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(h,p){return new A(this.buffer.subarray(h,p))}set(h,p){if(h instanceof A)this.buffer.set(h.buffer,p);else if(h instanceof Uint8Array)this.buffer.set(h,p);else if(h instanceof ArrayBuffer)this.buffer.set(new Uint8Array(h),p);else if(ArrayBuffer.isView(h))this.buffer.set(new Uint8Array(h.buffer,h.byteOffset,h.byteLength),p);else throw new Error("Unknown argument 'array'")}readUInt32BE(h){return I(this.buffer,h)}writeUInt32BE(h,p){E(this.buffer,h,p)}readUInt32LE(h){return w(this.buffer,h)}writeUInt32LE(h,p){v(this.buffer,h,p)}readUInt8(h){return y(this.buffer,h)}writeUInt8(h,p){f(this.buffer,h,p)}}e.VSBuffer=A;function b(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0}e.readUInt16LE=b;function P(a,h,p){a[p+0]=h&255,h=h>>>8,a[p+1]=h&255}e.writeUInt16LE=P;function I(a,h){return a[h]*2**24+a[h+1]*2**16+a[h+2]*2**8+a[h+3]}e.readUInt32BE=I;function E(a,h,p){a[p+3]=h,h=h>>>8,a[p+2]=h,h=h>>>8,a[p+1]=h,h=h>>>8,a[p]=h}e.writeUInt32BE=E;function w(a,h){return a[h+0]<<0>>>0|a[h+1]<<8>>>0|a[h+2]<<16>>>0|a[h+3]<<24>>>0}e.readUInt32LE=w;function v(a,h,p){a[p+0]=h&255,h=h>>>8,a[p+1]=h&255,h=h>>>8,a[p+2]=h&255,h=h>>>8,a[p+3]=h&255}e.writeUInt32LE=v;function y(a,h){return a[h]}e.readUInt8=y;function f(a,h,p){a[p]=h}e.writeUInt8=f;function S(a){return D.consumeReadable(a,h=>A.concat(h))}e.readableToBuffer=S;function C(a){return D.toReadable(a)}e.bufferToReadable=C;function m(a){return D.consumeStream(a,h=>A.concat(h))}e.streamToBuffer=m;async function g(a){return a.ended?A.concat(a.buffer):A.concat([...a.buffer,await m(a.stream)])}e.bufferedStreamToBuffer=g;function c(a){return D.toStream(a,h=>A.concat(h))}e.bufferToStream=c;function d(a){return D.transform(a,{data:h=>typeof h=="string"?A.fromString(h):A.wrap(h)},h=>A.concat(h))}e.streamToBufferReadableStream=d;function u(a){return D.newWriteableStream(h=>A.concat(h),a)}e.newWriteableBufferStream=u;function s(a,h){return D.prefixedReadable(a,h,p=>A.concat(p))}e.prefixedBufferReadable=s;function r(a,h){return D.prefixedStream(a,h,p=>A.concat(p))}e.prefixedBufferStream=r;function t(a){let h=0,p=0,R=0;const M=new Uint8Array(Math.floor(a.length/4*3)),O=T=>{switch(p){case 3:M[R++]=h|T,p=0;break;case 2:M[R++]=h|T>>>2,h=T<<6,p=3;break;case 1:M[R++]=h|T>>>4,h=T<<4,p=2;break;default:h=T<<2,p=1}};for(let T=0;T<a.length;T++){const N=a.charCodeAt(T);if(N>=65&&N<=90)O(N-65);else if(N>=97&&N<=122)O(N-97+26);else if(N>=48&&N<=57)O(N-48+52);else if(N===43||N===45)O(62);else if(N===47||N===95)O(63);else{if(N===61)break;throw new SyntaxError(`Unexpected base64 character ${a[T]}`)}}const F=R;for(;p>0;)O(0);return A.wrap(M).slice(0,F)}e.decodeBase64=t;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function l({buffer:a},h=!0,p=!1){const R=p?o:i;let M="";const O=a.byteLength%3;let F=0;for(;F<a.byteLength-O;F+=3){const T=a[F+0],N=a[F+1],W=a[F+2];M+=R[T>>>2],M+=R[(T<<4|N>>>4)&63],M+=R[(N<<2|W>>>6)&63],M+=R[W&63]}if(O===1){const T=a[F+0];M+=R[T>>>2],M+=R[T<<4&63],h&&(M+="==")}else if(O===2){const T=a[F+0],N=a[F+1];M+=R[T>>>2],M+=R[(T<<4|N>>>4)&63],M+=R[N<<2&63],h&&(M+="=")}return M}e.encodeBase64=l}),define(re[15],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.withUndefinedAsNull=e.withNullAsUndefined=e.validateConstraint=e.validateConstraints=e.areFunctions=e.isFunction=e.isEmptyObject=e.assertAllDefined=e.assertIsDefined=e.assertType=e.isUndefinedOrNull=e.isDefined=e.isUndefined=e.isBoolean=e.isIterable=e.isNumber=e.isTypedArray=e.isObject=e.isStringArray=e.isString=void 0;function D(r){return typeof r=="string"}e.isString=D;function n(r){return Array.isArray(r)&&r.every(t=>D(t))}e.isStringArray=n;function k(r){return typeof r=="object"&&r!==null&&!Array.isArray(r)&&!(r instanceof RegExp)&&!(r instanceof Date)}e.isObject=k;function L(r){const t=Object.getPrototypeOf(Uint8Array);return typeof r=="object"&&r instanceof t}e.isTypedArray=L;function A(r){return typeof r=="number"&&!isNaN(r)}e.isNumber=A;function b(r){return!!r&&typeof r[Symbol.iterator]=="function"}e.isIterable=b;function P(r){return r===!0||r===!1}e.isBoolean=P;function I(r){return typeof r=="undefined"}e.isUndefined=I;function E(r){return!w(r)}e.isDefined=E;function w(r){return I(r)||r===null}e.isUndefinedOrNull=w;function v(r,t){if(!r)throw new Error(t?`Unexpected type, expected '${t}'`:"Unexpected type")}e.assertType=v;function y(r){if(w(r))throw new Error("Assertion Failed: argument is undefined or null");return r}e.assertIsDefined=y;function f(...r){const t=[];for(let i=0;i<r.length;i++){const o=r[i];if(w(o))throw new Error(`Assertion Failed: argument at index ${i} is undefined or null`);t.push(o)}return t}e.assertAllDefined=f;const S=Object.prototype.hasOwnProperty;function C(r){if(!k(r))return!1;for(const t in r)if(S.call(r,t))return!1;return!0}e.isEmptyObject=C;function m(r){return typeof r=="function"}e.isFunction=m;function g(...r){return r.length>0&&r.every(m)}e.areFunctions=g;function c(r,t){const i=Math.min(r.length,t.length);for(let o=0;o<i;o++)d(r[o],t[o])}e.validateConstraints=c;function d(r,t){if(D(t)){if(typeof r!==t)throw new Error(`argument does not match constraint: typeof ${t}`)}else if(m(t)){try{if(r instanceof t)return}catch{}if(!w(r)&&r.constructor===t||t.length===1&&t.call(void 0,r)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}e.validateConstraint=d;function u(r){return r===null?void 0:r}e.withNullAsUndefined=u;function s(r){return typeof r=="undefined"?null:r}e.withUndefinedAsNull=s}),define(re[31],se([0,1,15]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createProxyObject=e.getAllMethodNames=e.getAllPropertyNames=e.filter=e.getCaseInsensitive=e.distinct=e.safeStringify=e.equals=e.mixin=e.cloneAndChange=e.deepFreeze=e.deepClone=void 0;function n(m){if(!m||typeof m!="object"||m instanceof RegExp)return m;const g=Array.isArray(m)?[]:{};return Object.keys(m).forEach(c=>{m[c]&&typeof m[c]=="object"?g[c]=n(m[c]):g[c]=m[c]}),g}e.deepClone=n;function k(m){if(!m||typeof m!="object")return m;const g=[m];for(;g.length>0;){const c=g.shift();Object.freeze(c);for(const d in c)if(L.call(c,d)){const u=c[d];typeof u=="object"&&!Object.isFrozen(u)&&!(0,D.isTypedArray)(u)&&g.push(u)}}return m}e.deepFreeze=k;const L=Object.prototype.hasOwnProperty;function A(m,g){return b(m,g,new Set)}e.cloneAndChange=A;function b(m,g,c){if((0,D.isUndefinedOrNull)(m))return m;const d=g(m);if(typeof d!="undefined")return d;if(Array.isArray(m)){const u=[];for(const s of m)u.push(b(s,g,c));return u}if((0,D.isObject)(m)){if(c.has(m))throw new Error("Cannot clone recursive data-structure");c.add(m);const u={};for(const s in m)L.call(m,s)&&(u[s]=b(m[s],g,c));return c.delete(m),u}return m}function P(m,g,c=!0){return(0,D.isObject)(m)?((0,D.isObject)(g)&&Object.keys(g).forEach(d=>{d in m?c&&((0,D.isObject)(m[d])&&(0,D.isObject)(g[d])?P(m[d],g[d],c):m[d]=g[d]):m[d]=g[d]}),m):g}e.mixin=P;function I(m,g){if(m===g)return!0;if(m==null||g===null||g===void 0||typeof m!=typeof g||typeof m!="object"||Array.isArray(m)!==Array.isArray(g))return!1;let c,d;if(Array.isArray(m)){if(m.length!==g.length)return!1;for(c=0;c<m.length;c++)if(!I(m[c],g[c]))return!1}else{const u=[];for(d in m)u.push(d);u.sort();const s=[];for(d in g)s.push(d);if(s.sort(),!I(u,s))return!1;for(c=0;c<u.length;c++)if(!I(m[u[c]],g[u[c]]))return!1}return!0}e.equals=I;function E(m){const g=new Set;return JSON.stringify(m,(c,d)=>{if((0,D.isObject)(d)||Array.isArray(d)){if(g.has(d))return"[Circular]";g.add(d)}return d})}e.safeStringify=E;function w(m,g){const c=Object.create(null);return!m||!g||Object.keys(g).forEach(u=>{const s=m[u],r=g[u];I(s,r)||(c[u]=r)}),c}e.distinct=w;function v(m,g){const c=g.toLowerCase(),d=Object.keys(m).find(u=>u.toLowerCase()===c);return d?m[d]:m[g]}e.getCaseInsensitive=v;function y(m,g){const c=Object.create(null);for(const[d,u]of Object.entries(m))g(d,u)&&(c[d]=u);return c}e.filter=y;function f(m){let g=[],c=Object.getPrototypeOf(m);for(;Object.prototype!==c;)g=g.concat(Object.getOwnPropertyNames(c)),c=Object.getPrototypeOf(c);return g}e.getAllPropertyNames=f;function S(m){const g=[];for(const c of f(m))typeof m[c]=="function"&&g.push(c);return g}e.getAllMethodNames=S;function C(m,g){const c=u=>function(){const s=Array.prototype.slice.call(arguments,0);return g(u,s)},d={};for(const u of m)d[u]=c(u);return d}e.createProxyObject=C}),define(re[30],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const D=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function n(k){return D.test(k)}e.isUUID=n,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let k;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?k=crypto.getRandomValues.bind(crypto):k=function(b){for(let P=0;P<b.length;P++)b[P]=Math.floor(Math.random()*256);return b};const L=new Uint8Array(16),A=[];for(let b=0;b<256;b++)A.push(b.toString(16).padStart(2,"0"));return function(){k(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let P=0,I="";return I+=A[L[P++]],I+=A[L[P++]],I+=A[L[P++]],I+=A[L[P++]],I+="-",I+=A[L[P++]],I+=A[L[P++]],I+="-",I+=A[L[P++]],I+=A[L[P++]],I+="-",I+=A[L[P++]],I+=A[L[P++]],I+="-",I+=A[L[P++]],I+=A[L[P++]],I+=A[L[P++]],I+=A[L[P++]],I+=A[L[P++]],I+=A[L[P++]],I}}()}),define(re[114],se([0,1,37]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMac=void 0;const n=new Set(["00:00:00:00:00:00","ff:ff:ff:ff:ff:ff","ac:de:48:00:11:22"]);function k(A){const b=A.replace(/\-/g,":").toLowerCase();return!n.has(b)}function L(){const A=(0,D.networkInterfaces)();for(const b in A){const P=A[b];if(P){for(const{mac:I}of P)if(k(I))return I}}throw new Error("Unable to retrieve mac address (unexpected format)")}e.getMac=L}),define(re[115],se([0,1,76]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.findFreePortFaster=e.BROWSER_RESTRICTED_PORTS=e.findFreePort=void 0;function n(b,P,I,E=1){let w=!1;return new Promise(v=>{const y=setTimeout(()=>{if(!w)return w=!0,v(0)},I);k(b,P,E,f=>{if(!w)return w=!0,clearTimeout(y),v(f)})})}e.findFreePort=n;function k(b,P,I,E){if(P===0)return E(0);const w=new D.Socket;w.once("connect",()=>(A(w),k(b+I,P-1,I,E))),w.once("data",()=>{}),w.once("error",v=>(A(w),v.code!=="ECONNREFUSED"?k(b+I,P-1,I,E):E(b))),w.connect(b,"127.0.0.1")}e.BROWSER_RESTRICTED_PORTS={1:!0,7:!0,9:!0,11:!0,13:!0,15:!0,17:!0,19:!0,20:!0,21:!0,22:!0,23:!0,25:!0,37:!0,42:!0,43:!0,53:!0,69:!0,77:!0,79:!0,87:!0,95:!0,101:!0,102:!0,103:!0,104:!0,109:!0,110:!0,111:!0,113:!0,115:!0,117:!0,119:!0,123:!0,135:!0,137:!0,139:!0,143:!0,161:!0,179:!0,389:!0,427:!0,465:!0,512:!0,513:!0,514:!0,515:!0,526:!0,530:!0,531:!0,532:!0,540:!0,548:!0,554:!0,556:!0,563:!0,587:!0,601:!0,636:!0,989:!0,990:!0,993:!0,995:!0,1719:!0,1720:!0,1723:!0,2049:!0,3659:!0,4045:!0,5060:!0,5061:!0,6e3:!0,6566:!0,6665:!0,6666:!0,6667:!0,6668:!0,6669:!0,6697:!0,10080:!0};function L(b,P,I){let E=!1,w,v=1;const y=D.createServer({pauseOnConnect:!0});function f(S,C){E||(E=!0,y.removeAllListeners(),y.close(),w&&clearTimeout(w),C(S))}return new Promise(S=>{w=setTimeout(()=>{f(0,S)},I),y.on("listening",()=>{f(b,S)}),y.on("error",C=>{C&&(C.code==="EADDRINUSE"||C.code==="EACCES")&&v<P?(b++,v++,y.listen(b,"127.0.0.1")):f(0,S)}),y.on("close",()=>{f(0,S)}),y.listen(b,"127.0.0.1")})}e.findFreePortFaster=L;function A(b){try{b.removeAllListeners("connect"),b.removeAllListeners("error"),b.end(),b.destroy(),b.unref()}catch(P){console.error(P)}}}),define(re[116],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OfflineError=e.isOfflineError=void 0;const D="Offline";function n(L){return L instanceof k?!0:L instanceof Error&&L.name===D&&L.message===D}e.isOfflineError=n;class k extends Error{constructor(){super(D);this.name=this.message}}e.OfflineError=k}),define(re[117],se([0,1,16,9,116]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.request=void 0;function L(P,I){if(!navigator.onLine)throw new k.OfflineError;P.proxyAuthorization&&(P.headers={...P.headers||{},"Proxy-Authorization":P.proxyAuthorization});const E=new XMLHttpRequest;return new Promise((w,v)=>{E.open(P.type||"GET",P.url||"",!0,P.user,P.password),A(E,P),E.responseType="arraybuffer",E.onerror=y=>v(new Error(E.statusText&&"XHR failed: "+E.statusText||"XHR failed")),E.onload=y=>{w({res:{statusCode:E.status,headers:b(E)},stream:(0,D.bufferToStream)(D.VSBuffer.wrap(new Uint8Array(E.response)))})},E.ontimeout=y=>v(new Error(`XHR timeout: ${P.timeout}ms`)),P.timeout&&(E.timeout=P.timeout),E.send(P.data),I.onCancellationRequested(()=>{E.abort(),v((0,n.canceled)())})})}e.request=L;function A(P,I){if(I.headers){e:for(const E in I.headers){switch(E){case"User-Agent":case"Accept-Encoding":case"Content-Length":continue e}P.setRequestHeader(E,I.headers[E])}}}function b(P){const I=Object.create(null);for(const E of P.getAllResponseHeaders().split(/\r\n|\n|\r/g))if(E){const w=E.indexOf(":");I[E.substr(0,w).trim().toLowerCase()]=E.substr(w+1).trim()}return I}}),define(re[118],se([11,12]),function(X,e){return X.create("vs/base/common/date",e)}),define(re[61],se([0,1,118]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const n=60,k=n*60,L=k*24,A=L*7,b=L*30,P=L*365;function I(w,v,y){typeof w!="number"&&(w=w.getTime());const f=Math.round((new Date().getTime()-w)/1e3);if(f<-30)return(0,D.localize)(0,null,I(new Date().getTime()+f*1e3,!1));if(f<30)return(0,D.localize)(1,null);let S;return f<n?(S=f,v?S===1?y?(0,D.localize)(2,null,S):(0,D.localize)(3,null,S):y?(0,D.localize)(4,null,S):(0,D.localize)(5,null,S):S===1?y?(0,D.localize)(6,null,S):(0,D.localize)(7,null,S):y?(0,D.localize)(8,null,S):(0,D.localize)(9,null,S)):f<k?(S=Math.floor(f/n),v?S===1?y?(0,D.localize)(10,null,S):(0,D.localize)(11,null,S):y?(0,D.localize)(12,null,S):(0,D.localize)(13,null,S):S===1?y?(0,D.localize)(14,null,S):(0,D.localize)(15,null,S):y?(0,D.localize)(16,null,S):(0,D.localize)(17,null,S)):f<L?(S=Math.floor(f/k),v?S===1?y?(0,D.localize)(18,null,S):(0,D.localize)(19,null,S):y?(0,D.localize)(20,null,S):(0,D.localize)(21,null,S):S===1?y?(0,D.localize)(22,null,S):(0,D.localize)(23,null,S):y?(0,D.localize)(24,null,S):(0,D.localize)(25,null,S)):f<A?(S=Math.floor(f/L),v?S===1?(0,D.localize)(26,null,S):(0,D.localize)(27,null,S):S===1?(0,D.localize)(28,null,S):(0,D.localize)(29,null,S)):f<b?(S=Math.floor(f/A),v?S===1?y?(0,D.localize)(30,null,S):(0,D.localize)(31,null,S):y?(0,D.localize)(32,null,S):(0,D.localize)(33,null,S):S===1?y?(0,D.localize)(34,null,S):(0,D.localize)(35,null,S):y?(0,D.localize)(36,null,S):(0,D.localize)(37,null,S)):f<P?(S=Math.floor(f/b),v?S===1?y?(0,D.localize)(38,null,S):(0,D.localize)(39,null,S):y?(0,D.localize)(40,null,S):(0,D.localize)(41,null,S):S===1?y?(0,D.localize)(42,null,S):(0,D.localize)(43,null,S):y?(0,D.localize)(44,null,S):(0,D.localize)(45,null,S)):(S=Math.floor(f/P),v?S===1?y?(0,D.localize)(46,null,S):(0,D.localize)(47,null,S):y?(0,D.localize)(48,null,S):(0,D.localize)(49,null,S):S===1?y?(0,D.localize)(50,null,S):(0,D.localize)(51,null,S):y?(0,D.localize)(52,null,S):(0,D.localize)(53,null,S))}e.fromNow=I;function E(w){return w.getFullYear()+"-"+String(w.getMonth()+1).padStart(2,"0")+"-"+String(w.getDate()).padStart(2,"0")+"T"+String(w.getHours()).padStart(2,"0")+":"+String(w.getMinutes()).padStart(2,"0")+":"+String(w.getSeconds()).padStart(2,"0")+"."+(w.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=E}),define(re[119],se([11,12]),function(X,e){return X.create("vs/base/common/errorMessage",e)}),define(re[38],se([0,1,18,15,119]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(w,v){return v&&(w.stack||w.stacktrace)?k.localize(0,null,b(w),A(w.stack)||A(w.stacktrace)):b(w)}function A(w){return Array.isArray(w)?w.join(`
`):w}function b(w){return typeof w.code=="string"&&typeof w.errno=="number"&&typeof w.syscall=="string"?k.localize(1,null,w.message):w.message||k.localize(2,null)}function P(w=null,v=!1){if(!w)return k.localize(3,null);if(Array.isArray(w)){const y=D.coalesce(w),f=P(y[0],v);return y.length>1?k.localize(4,null,f,y.length):f}if(n.isString(w))return w;if(w.detail){const y=w.detail;if(y.error)return L(y.error,v);if(y.exception)return L(y.exception,v)}return w.stack?L(w,v):w.message?w.message:k.localize(5,null)}e.toErrorMessage=P;function I(w){const v=w;return v instanceof Error&&Array.isArray(v.actions)}e.isErrorWithActions=I;function E(w,v){let y;return typeof w=="string"?y=new Error(w):y=w,y.actions=v,y}e.createErrorWithActions=E}),define(re[120],se([11,12]),function(X,e){return X.create("vs/base/common/jsonErrorMessages",e)}),define(re[121],se([0,1,120]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getParseErrorMessage=void 0;function n(k){switch(k){case 1:return(0,D.localize)(0,null);case 2:return(0,D.localize)(1,null);case 3:return(0,D.localize)(2,null);case 4:return(0,D.localize)(3,null);case 5:return(0,D.localize)(4,null);case 6:return(0,D.localize)(5,null);case 7:return(0,D.localize)(6,null);case 8:return(0,D.localize)(7,null);case 9:return(0,D.localize)(8,null);default:return""}}e.getParseErrorMessage=n}),define(re[122],se([11,12]),function(X,e){return X.create("vs/base/common/platform",e)}),define(re[4],se([0,1,122]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isAndroid=e.isEdge=e.isSafari=e.isFirefox=e.isChrome=e.isLittleEndian=e.OS=e.OperatingSystem=e.setTimeout0=e.setTimeout0IsFaster=e.translationsConfigFile=e.locale=e.Language=e.language=e.userAgent=e.platform=e.isCI=e.isIOS=e.isWebWorker=e.isWeb=e.isElectron=e.isNative=e.isLinuxSnap=e.isLinux=e.isMacintosh=e.isWindows=e.PlatformToString=e.Platform=e.globals=void 0;const n="en";let k=!1,L=!1,A=!1,b=!1,P=!1,I=!1,E=!1,w=!1,v=!1,y,f=n,S,C;e.globals=typeof self=="object"?self:typeof global=="object"?global:{};let m;typeof e.globals.vscode!="undefined"&&typeof e.globals.vscode.process!="undefined"?m=e.globals.vscode.process:typeof process!="undefined"&&(m=process);const g=typeof m?.versions?.electron=="string",c=g&&m?.type==="renderer";if(typeof navigator=="object"&&!c)C=navigator.userAgent,k=C.indexOf("Windows")>=0,L=C.indexOf("Macintosh")>=0,w=(C.indexOf("Macintosh")>=0||C.indexOf("iPad")>=0||C.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,A=C.indexOf("Linux")>=0,I=!0,y=D.getConfiguredDefaultLocale(D.localize(0,null))||n,f=y;else if(typeof m=="object"){k=m.platform==="win32",L=m.platform==="darwin",A=m.platform==="linux",b=A&&!!m.env.SNAP&&!!m.env.SNAP_REVISION,E=g,v=!!m.env.CI||!!m.env.BUILD_ARTIFACTSTAGINGDIRECTORY,y=n,f=n;const a=m.env.VSCODE_NLS_CONFIG;if(a)try{const h=JSON.parse(a),p=h.availableLanguages["*"];y=h.locale,f=p||n,S=h._translationsConfigFile}catch{}P=!0}else console.error("Unable to resolve platform.");var d;(function(a){a[a.Web=0]="Web",a[a.Mac=1]="Mac",a[a.Linux=2]="Linux",a[a.Windows=3]="Windows"})(d=e.Platform||(e.Platform={}));function u(a){switch(a){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}e.PlatformToString=u;let s=0;L?s=1:k?s=3:A&&(s=2),e.isWindows=k,e.isMacintosh=L,e.isLinux=A,e.isLinuxSnap=b,e.isNative=P,e.isElectron=E,e.isWeb=I,e.isWebWorker=I&&typeof e.globals.importScripts=="function",e.isIOS=w,e.isCI=v,e.platform=s,e.userAgent=C,e.language=f;var r;(function(a){function h(){return e.language}a.value=h;function p(){return e.language.length===2?e.language==="en":e.language.length>=3?e.language[0]==="e"&&e.language[1]==="n"&&e.language[2]==="-":!1}a.isDefaultVariant=p;function R(){return e.language==="en"}a.isDefault=R})(r=e.Language||(e.Language={})),e.locale=y,e.translationsConfigFile=S,e.setTimeout0IsFaster=typeof e.globals.postMessage=="function"&&!e.globals.importScripts,e.setTimeout0=(()=>{if(e.setTimeout0IsFaster){const a=[];e.globals.addEventListener("message",p=>{if(p.data&&p.data.vscodeScheduleAsyncWork)for(let R=0,M=a.length;R<M;R++){const O=a[R];if(O.id===p.data.vscodeScheduleAsyncWork){a.splice(R,1),O.callback();return}}});let h=0;return p=>{const R=++h;a.push({id:R,callback:p}),e.globals.postMessage({vscodeScheduleAsyncWork:R},"*")}}return a=>setTimeout(a)})();var t;(function(a){a[a.Windows=1]="Windows",a[a.Macintosh=2]="Macintosh",a[a.Linux=3]="Linux"})(t=e.OperatingSystem||(e.OperatingSystem={})),e.OS=L||w?2:k?1:3;let i=!0,o=!1;function l(){if(!o){o=!0;const a=new Uint8Array(2);a[0]=1,a[1]=2,i=new Uint16Array(a.buffer)[0]===(2<<8)+1}return i}e.isLittleEndian=l,e.isChrome=!!(e.userAgent&&e.userAgent.indexOf("Chrome")>=0),e.isFirefox=!!(e.userAgent&&e.userAgent.indexOf("Firefox")>=0),e.isSafari=!!(!e.isChrome&&e.userAgent&&e.userAgent.indexOf("Safari")>=0),e.isEdge=!!(e.userAgent&&e.userAgent.indexOf("Edg/")>=0),e.isAndroid=!!(e.userAgent&&e.userAgent.indexOf("Android")>=0)}),define(re[36],se([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.arch=e.platform=e.env=e.cwd=void 0;let n;if(typeof D.globals.vscode!="undefined"&&typeof D.globals.vscode.process!="undefined"){const k=D.globals.vscode.process;n={get platform(){return k.platform},get arch(){return k.arch},get env(){return k.env},cwd(){return k.cwd()}}}else typeof process!="undefined"?n={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:n={get platform(){return D.isWindows?"win32":D.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};e.cwd=n.cwd,e.env=n.env,e.platform=n.platform,e.arch=n.arch}),define(re[10],se([0,1,36]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.delimiter=e.sep=e.toNamespacedPath=e.parse=e.format=e.extname=e.basename=e.dirname=e.relative=e.resolve=e.join=e.isAbsolute=e.normalize=e.posix=e.win32=void 0;const n=65,k=97,L=90,A=122,b=46,P=47,I=92,E=58,w=63;class v extends Error{constructor(d,u,s){let r;typeof u=="string"&&u.indexOf("not ")===0?(r="must not be",u=u.replace(/^not /,"")):r="must be";const t=d.indexOf(".")!==-1?"property":"argument";let i=`The "${d}" ${t} ${r} of type ${u}`;i+=`. Received type ${typeof s}`;super(i);this.code="ERR_INVALID_ARG_TYPE"}}function y(c,d){if(typeof c!="string")throw new v(d,"string",c)}function f(c){return c===P||c===I}function S(c){return c===P}function C(c){return c>=n&&c<=L||c>=k&&c<=A}function m(c,d,u,s){let r="",t=0,i=-1,o=0,l=0;for(let a=0;a<=c.length;++a){if(a<c.length)l=c.charCodeAt(a);else{if(s(l))break;l=P}if(s(l)){if(!(i===a-1||o===1))if(o===2){if(r.length<2||t!==2||r.charCodeAt(r.length-1)!==b||r.charCodeAt(r.length-2)!==b){if(r.length>2){const h=r.lastIndexOf(u);h===-1?(r="",t=0):(r=r.slice(0,h),t=r.length-1-r.lastIndexOf(u)),i=a,o=0;continue}else if(r.length!==0){r="",t=0,i=a,o=0;continue}}d&&(r+=r.length>0?`${u}..`:"..",t=2)}else r.length>0?r+=`${u}${c.slice(i+1,a)}`:r=c.slice(i+1,a),t=a-i-1;i=a,o=0}else l===b&&o!==-1?++o:o=-1}return r}function g(c,d){if(d===null||typeof d!="object")throw new v("pathObject","Object",d);const u=d.dir||d.root,s=d.base||`${d.name||""}${d.ext||""}`;return u?u===d.root?`${u}${s}`:`${u}${c}${s}`:s}e.win32={resolve(...c){let d="",u="",s=!1;for(let r=c.length-1;r>=-1;r--){let t;if(r>=0){if(t=c[r],y(t,"path"),t.length===0)continue}else d.length===0?t=D.cwd():(t=D.env[`=${d}`]||D.cwd(),(t===void 0||t.slice(0,2).toLowerCase()!==d.toLowerCase()&&t.charCodeAt(2)===I)&&(t=`${d}\\`));const i=t.length;let o=0,l="",a=!1;const h=t.charCodeAt(0);if(i===1)f(h)&&(o=1,a=!0);else if(f(h))if(a=!0,f(t.charCodeAt(1))){let p=2,R=p;for(;p<i&&!f(t.charCodeAt(p));)p++;if(p<i&&p!==R){const M=t.slice(R,p);for(R=p;p<i&&f(t.charCodeAt(p));)p++;if(p<i&&p!==R){for(R=p;p<i&&!f(t.charCodeAt(p));)p++;(p===i||p!==R)&&(l=`\\\\${M}\\${t.slice(R,p)}`,o=p)}}}else o=1;else C(h)&&t.charCodeAt(1)===E&&(l=t.slice(0,2),o=2,i>2&&f(t.charCodeAt(2))&&(a=!0,o=3));if(l.length>0)if(d.length>0){if(l.toLowerCase()!==d.toLowerCase())continue}else d=l;if(s){if(d.length>0)break}else if(u=`${t.slice(o)}\\${u}`,s=a,a&&d.length>0)break}return u=m(u,!s,"\\",f),s?`${d}\\${u}`:`${d}${u}`||"."},normalize(c){y(c,"path");const d=c.length;if(d===0)return".";let u=0,s,r=!1;const t=c.charCodeAt(0);if(d===1)return S(t)?"\\":c;if(f(t))if(r=!0,f(c.charCodeAt(1))){let o=2,l=o;for(;o<d&&!f(c.charCodeAt(o));)o++;if(o<d&&o!==l){const a=c.slice(l,o);for(l=o;o<d&&f(c.charCodeAt(o));)o++;if(o<d&&o!==l){for(l=o;o<d&&!f(c.charCodeAt(o));)o++;if(o===d)return`\\\\${a}\\${c.slice(l)}\\`;o!==l&&(s=`\\\\${a}\\${c.slice(l,o)}`,u=o)}}}else u=1;else C(t)&&c.charCodeAt(1)===E&&(s=c.slice(0,2),u=2,d>2&&f(c.charCodeAt(2))&&(r=!0,u=3));let i=u<d?m(c.slice(u),!r,"\\",f):"";return i.length===0&&!r&&(i="."),i.length>0&&f(c.charCodeAt(d-1))&&(i+="\\"),s===void 0?r?`\\${i}`:i:r?`${s}\\${i}`:`${s}${i}`},isAbsolute(c){y(c,"path");const d=c.length;if(d===0)return!1;const u=c.charCodeAt(0);return f(u)||d>2&&C(u)&&c.charCodeAt(1)===E&&f(c.charCodeAt(2))},join(...c){if(c.length===0)return".";let d,u;for(let t=0;t<c.length;++t){const i=c[t];y(i,"path"),i.length>0&&(d===void 0?d=u=i:d+=`\\${i}`)}if(d===void 0)return".";let s=!0,r=0;if(typeof u=="string"&&f(u.charCodeAt(0))){++r;const t=u.length;t>1&&f(u.charCodeAt(1))&&(++r,t>2&&(f(u.charCodeAt(2))?++r:s=!1))}if(s){for(;r<d.length&&f(d.charCodeAt(r));)r++;r>=2&&(d=`\\${d.slice(r)}`)}return e.win32.normalize(d)},relative(c,d){if(y(c,"from"),y(d,"to"),c===d)return"";const u=e.win32.resolve(c),s=e.win32.resolve(d);if(u===s||(c=u.toLowerCase(),d=s.toLowerCase(),c===d))return"";let r=0;for(;r<c.length&&c.charCodeAt(r)===I;)r++;let t=c.length;for(;t-1>r&&c.charCodeAt(t-1)===I;)t--;const i=t-r;let o=0;for(;o<d.length&&d.charCodeAt(o)===I;)o++;let l=d.length;for(;l-1>o&&d.charCodeAt(l-1)===I;)l--;const a=l-o,h=i<a?i:a;let p=-1,R=0;for(;R<h;R++){const O=c.charCodeAt(r+R);if(O!==d.charCodeAt(o+R))break;O===I&&(p=R)}if(R!==h){if(p===-1)return s}else{if(a>h){if(d.charCodeAt(o+R)===I)return s.slice(o+R+1);if(R===2)return s.slice(o+R)}i>h&&(c.charCodeAt(r+R)===I?p=R:R===2&&(p=3)),p===-1&&(p=0)}let M="";for(R=r+p+1;R<=t;++R)(R===t||c.charCodeAt(R)===I)&&(M+=M.length===0?"..":"\\..");return o+=p,M.length>0?`${M}${s.slice(o,l)}`:(s.charCodeAt(o)===I&&++o,s.slice(o,l))},toNamespacedPath(c){if(typeof c!="string")return c;if(c.length===0)return"";const d=e.win32.resolve(c);if(d.length<=2)return c;if(d.charCodeAt(0)===I){if(d.charCodeAt(1)===I){const u=d.charCodeAt(2);if(u!==w&&u!==b)return`\\\\?\\UNC\\${d.slice(2)}`}}else if(C(d.charCodeAt(0))&&d.charCodeAt(1)===E&&d.charCodeAt(2)===I)return`\\\\?\\${d}`;return c},dirname(c){y(c,"path");const d=c.length;if(d===0)return".";let u=-1,s=0;const r=c.charCodeAt(0);if(d===1)return f(r)?c:".";if(f(r)){if(u=s=1,f(c.charCodeAt(1))){let o=2,l=o;for(;o<d&&!f(c.charCodeAt(o));)o++;if(o<d&&o!==l){for(l=o;o<d&&f(c.charCodeAt(o));)o++;if(o<d&&o!==l){for(l=o;o<d&&!f(c.charCodeAt(o));)o++;if(o===d)return c;o!==l&&(u=s=o+1)}}}}else C(r)&&c.charCodeAt(1)===E&&(u=d>2&&f(c.charCodeAt(2))?3:2,s=u);let t=-1,i=!0;for(let o=d-1;o>=s;--o)if(f(c.charCodeAt(o))){if(!i){t=o;break}}else i=!1;if(t===-1){if(u===-1)return".";t=u}return c.slice(0,t)},basename(c,d){d!==void 0&&y(d,"ext"),y(c,"path");let u=0,s=-1,r=!0,t;if(c.length>=2&&C(c.charCodeAt(0))&&c.charCodeAt(1)===E&&(u=2),d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let i=d.length-1,o=-1;for(t=c.length-1;t>=u;--t){const l=c.charCodeAt(t);if(f(l)){if(!r){u=t+1;break}}else o===-1&&(r=!1,o=t+1),i>=0&&(l===d.charCodeAt(i)?--i==-1&&(s=t):(i=-1,s=o))}return u===s?s=o:s===-1&&(s=c.length),c.slice(u,s)}for(t=c.length-1;t>=u;--t)if(f(c.charCodeAt(t))){if(!r){u=t+1;break}}else s===-1&&(r=!1,s=t+1);return s===-1?"":c.slice(u,s)},extname(c){y(c,"path");let d=0,u=-1,s=0,r=-1,t=!0,i=0;c.length>=2&&c.charCodeAt(1)===E&&C(c.charCodeAt(0))&&(d=s=2);for(let o=c.length-1;o>=d;--o){const l=c.charCodeAt(o);if(f(l)){if(!t){s=o+1;break}continue}r===-1&&(t=!1,r=o+1),l===b?u===-1?u=o:i!==1&&(i=1):u!==-1&&(i=-1)}return u===-1||r===-1||i===0||i===1&&u===r-1&&u===s+1?"":c.slice(u,r)},format:g.bind(null,"\\"),parse(c){y(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const u=c.length;let s=0,r=c.charCodeAt(0);if(u===1)return f(r)?(d.root=d.dir=c,d):(d.base=d.name=c,d);if(f(r)){if(s=1,f(c.charCodeAt(1))){let p=2,R=p;for(;p<u&&!f(c.charCodeAt(p));)p++;if(p<u&&p!==R){for(R=p;p<u&&f(c.charCodeAt(p));)p++;if(p<u&&p!==R){for(R=p;p<u&&!f(c.charCodeAt(p));)p++;p===u?s=p:p!==R&&(s=p+1)}}}}else if(C(r)&&c.charCodeAt(1)===E){if(u<=2)return d.root=d.dir=c,d;if(s=2,f(c.charCodeAt(2))){if(u===3)return d.root=d.dir=c,d;s=3}}s>0&&(d.root=c.slice(0,s));let t=-1,i=s,o=-1,l=!0,a=c.length-1,h=0;for(;a>=s;--a){if(r=c.charCodeAt(a),f(r)){if(!l){i=a+1;break}continue}o===-1&&(l=!1,o=a+1),r===b?t===-1?t=a:h!==1&&(h=1):t!==-1&&(h=-1)}return o!==-1&&(t===-1||h===0||h===1&&t===o-1&&t===i+1?d.base=d.name=c.slice(i,o):(d.name=c.slice(i,t),d.base=c.slice(i,o),d.ext=c.slice(t,o))),i>0&&i!==s?d.dir=c.slice(0,i-1):d.dir=d.root,d},sep:"\\",delimiter:";",win32:null,posix:null},e.posix={resolve(...c){let d="",u=!1;for(let s=c.length-1;s>=-1&&!u;s--){const r=s>=0?c[s]:D.cwd();y(r,"path"),r.length!==0&&(d=`${r}/${d}`,u=r.charCodeAt(0)===P)}return d=m(d,!u,"/",S),u?`/${d}`:d.length>0?d:"."},normalize(c){if(y(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===P,u=c.charCodeAt(c.length-1)===P;return c=m(c,!d,"/",S),c.length===0?d?"/":u?"./":".":(u&&(c+="/"),d?`/${c}`:c)},isAbsolute(c){return y(c,"path"),c.length>0&&c.charCodeAt(0)===P},join(...c){if(c.length===0)return".";let d;for(let u=0;u<c.length;++u){const s=c[u];y(s,"path"),s.length>0&&(d===void 0?d=s:d+=`/${s}`)}return d===void 0?".":e.posix.normalize(d)},relative(c,d){if(y(c,"from"),y(d,"to"),c===d||(c=e.posix.resolve(c),d=e.posix.resolve(d),c===d))return"";const u=1,s=c.length,r=s-u,t=1,i=d.length-t,o=r<i?r:i;let l=-1,a=0;for(;a<o;a++){const p=c.charCodeAt(u+a);if(p!==d.charCodeAt(t+a))break;p===P&&(l=a)}if(a===o)if(i>o){if(d.charCodeAt(t+a)===P)return d.slice(t+a+1);if(a===0)return d.slice(t+a)}else r>o&&(c.charCodeAt(u+a)===P?l=a:a===0&&(l=0));let h="";for(a=u+l+1;a<=s;++a)(a===s||c.charCodeAt(a)===P)&&(h+=h.length===0?"..":"/..");return`${h}${d.slice(t+l)}`},toNamespacedPath(c){return c},dirname(c){if(y(c,"path"),c.length===0)return".";const d=c.charCodeAt(0)===P;let u=-1,s=!0;for(let r=c.length-1;r>=1;--r)if(c.charCodeAt(r)===P){if(!s){u=r;break}}else s=!1;return u===-1?d?"/":".":d&&u===1?"//":c.slice(0,u)},basename(c,d){d!==void 0&&y(d,"ext"),y(c,"path");let u=0,s=-1,r=!0,t;if(d!==void 0&&d.length>0&&d.length<=c.length){if(d===c)return"";let i=d.length-1,o=-1;for(t=c.length-1;t>=0;--t){const l=c.charCodeAt(t);if(l===P){if(!r){u=t+1;break}}else o===-1&&(r=!1,o=t+1),i>=0&&(l===d.charCodeAt(i)?--i==-1&&(s=t):(i=-1,s=o))}return u===s?s=o:s===-1&&(s=c.length),c.slice(u,s)}for(t=c.length-1;t>=0;--t)if(c.charCodeAt(t)===P){if(!r){u=t+1;break}}else s===-1&&(r=!1,s=t+1);return s===-1?"":c.slice(u,s)},extname(c){y(c,"path");let d=-1,u=0,s=-1,r=!0,t=0;for(let i=c.length-1;i>=0;--i){const o=c.charCodeAt(i);if(o===P){if(!r){u=i+1;break}continue}s===-1&&(r=!1,s=i+1),o===b?d===-1?d=i:t!==1&&(t=1):d!==-1&&(t=-1)}return d===-1||s===-1||t===0||t===1&&d===s-1&&d===u+1?"":c.slice(d,s)},format:g.bind(null,"/"),parse(c){y(c,"path");const d={root:"",dir:"",base:"",ext:"",name:""};if(c.length===0)return d;const u=c.charCodeAt(0)===P;let s;u?(d.root="/",s=1):s=0;let r=-1,t=0,i=-1,o=!0,l=c.length-1,a=0;for(;l>=s;--l){const h=c.charCodeAt(l);if(h===P){if(!o){t=l+1;break}continue}i===-1&&(o=!1,i=l+1),h===b?r===-1?r=l:a!==1&&(a=1):r!==-1&&(a=-1)}if(i!==-1){const h=t===0&&u?1:t;r===-1||a===0||a===1&&r===i-1&&r===t+1?d.base=d.name=c.slice(h,i):(d.name=c.slice(h,r),d.base=c.slice(h,i),d.ext=c.slice(r,i))}return t>0?d.dir=c.slice(0,t-1):u&&(d.dir="/"),d},sep:"/",delimiter:":",win32:null,posix:null},e.posix.win32=e.win32.win32=e.win32,e.posix.posix=e.win32.posix=e.posix,e.normalize=D.platform==="win32"?e.win32.normalize:e.posix.normalize,e.isAbsolute=D.platform==="win32"?e.win32.isAbsolute:e.posix.isAbsolute,e.join=D.platform==="win32"?e.win32.join:e.posix.join,e.resolve=D.platform==="win32"?e.win32.resolve:e.posix.resolve,e.relative=D.platform==="win32"?e.win32.relative:e.posix.relative,e.dirname=D.platform==="win32"?e.win32.dirname:e.posix.dirname,e.basename=D.platform==="win32"?e.win32.basename:e.posix.basename,e.extname=D.platform==="win32"?e.win32.extname:e.posix.extname,e.format=D.platform==="win32"?e.win32.format:e.posix.format,e.parse=D.platform==="win32"?e.win32.parse:e.posix.parse,e.toNamespacedPath=D.platform==="win32"?e.win32.toNamespacedPath:e.posix.toNamespacedPath,e.sep=D.platform==="win32"?e.win32.sep:e.posix.sep,e.delimiter=D.platform==="win32"?e.win32.delimiter:e.posix.delimiter}),define(re[123],se([0,1,10]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const n={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},k={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(E){const w=(0,D.extname)(E),v=n[w.toLowerCase()];return v!==void 0?v:A(E)}e.getMediaOrTextMime=L;function A(E){const w=(0,D.extname)(E);return k[w.toLowerCase()]}e.getMediaMime=A;function b(E){for(const w in k)if(k[w]===E)return w}e.getExtensionForMimeType=b;const P=/^(.+)\/(.+?)(;.+)?$/;function I(E,w){const v=P.exec(E);return v?`${v[1].toLowerCase()}/${v[2].toLowerCase()}${v[3]??""}`:w?void 0:E}e.normalizeMimeType=I}),define(re[77],se([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeDangerousEnvVariables=e.sanitizeProcessEnvironment=e.TerminateResponseCode=e.Source=void 0;var n;(function(b){b[b.stdout=0]="stdout",b[b.stderr=1]="stderr"})(n=e.Source||(e.Source={}));var k;(function(b){b[b.Success=0]="Success",b[b.Unknown=1]="Unknown",b[b.AccessDenied=2]="AccessDenied",b[b.ProcessNotFound=3]="ProcessNotFound"})(k=e.TerminateResponseCode||(e.TerminateResponseCode={}));function L(b,...P){const I=P.reduce((v,y)=>(v[y]=!0,v),{}),E=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(b).filter(v=>!I[v]).forEach(v=>{for(let y=0;y<E.length;y++)if(v.search(E[y])!==-1){delete b[v];break}})}e.sanitizeProcessEnvironment=L;function A(b){!b||(delete b.DEBUG,D.isMacintosh&&delete b.DYLD_LIBRARY_PATH,D.isLinux&&delete b.LD_PRELOAD)}e.removeDangerousEnvVariables=A}),define(re[124],se([0,1,4]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StopWatch=void 0;const n=D.globals.performance&&typeof D.globals.performance.now=="function";class k{constructor(A){this._highResolution=n&&A,this._startTime=this._now(),this._stopTime=-1}static create(A=!0){return new k(A)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?D.globals.performance.now():Date.now()}}e.StopWatch=k}),define(re[3],se([0,1,9,74,2,112,124]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Relay=e.EventBufferer=e.EventMultiplexer=e.MicrotaskEmitter=e.DebounceEmitter=e.PauseableEmitter=e.AsyncEmitter=e.EventDeliveryQueue=e.Emitter=e.setGlobalLeakWarningThreshold=e.Event=void 0;const b=!1,P=!1;var I;(function(l){l.None=()=>k.Disposable.None;function a(U){if(P){const{onListenerDidAdd:q}=U,j=f.create();let Z=0;U.onListenerDidAdd=()=>{++Z==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),j.print()),q?.()}}}function h(U){return(q,j=null,Z)=>{let oe=!1,Q;return Q=U(te=>{if(!oe)return Q?Q.dispose():oe=!0,q.call(j,te)},null,Z),oe&&Q.dispose(),Q}}l.once=h;function p(U,q,j){return N((Z,oe=null,Q)=>U(te=>Z.call(oe,q(te)),null,Q),j)}l.map=p;function R(U,q,j){return N((Z,oe=null,Q)=>U(te=>{q(te),Z.call(oe,te)},null,Q),j)}l.forEach=R;function M(U,q,j){return N((Z,oe=null,Q)=>U(te=>q(te)&&Z.call(oe,te),null,Q),j)}l.filter=M;function O(U){return U}l.signal=O;function F(...U){return(q,j=null,Z)=>(0,k.combinedDisposable)(...U.map(oe=>oe(Q=>q.call(j,Q),null,Z)))}l.any=F;function T(U,q,j,Z){let oe=j;return p(U,Q=>(oe=q(oe,Q),oe),Z)}l.reduce=T;function N(U,q){let j;const Z={onFirstListenerAdd(){j=U(oe.fire,oe)},onLastListenerRemove(){j?.dispose()}};q||a(Z);const oe=new C(Z);return q?.add(oe),oe.event}function W(U,q,j=100,Z=!1,oe,Q){let te,ne,ue,he=0;const pe={leakWarningThreshold:oe,onFirstListenerAdd(){te=U(Ce=>{he++,ne=q(ne,Ce),Z&&!ue&&(we.fire(ne),ne=void 0),clearTimeout(ue),ue=setTimeout(()=>{const Pe=ne;ne=void 0,ue=void 0,(!Z||he>1)&&we.fire(Pe),he=0},j)})},onLastListenerRemove(){te.dispose()}};Q||a(pe);const we=new C(pe);return Q?.add(we),we.event}l.debounce=W;function V(U,q=(Z,oe)=>Z===oe,j){let Z=!0,oe;return M(U,Q=>{const te=Z||!q(Q,oe);return Z=!1,oe=Q,te},j)}l.latch=V;function Y(U,q,j){return[l.filter(U,q,j),l.filter(U,Z=>!q(Z),j)]}l.split=Y;function $(U,q=!1,j=[]){let Z=j.slice(),oe=U(ne=>{Z?Z.push(ne):te.fire(ne)});const Q=()=>{Z?.forEach(ne=>te.fire(ne)),Z=null},te=new C({onFirstListenerAdd(){oe||(oe=U(ne=>te.fire(ne)))},onFirstListenerDidAdd(){Z&&(q?setTimeout(Q):Q())},onLastListenerRemove(){oe&&oe.dispose(),oe=null}});return te.event}l.buffer=$;class J{constructor(q){this.event=q,this.disposables=new k.DisposableStore}map(q){return new J(p(this.event,q,this.disposables))}forEach(q){return new J(R(this.event,q,this.disposables))}filter(q){return new J(M(this.event,q,this.disposables))}reduce(q,j){return new J(T(this.event,q,j,this.disposables))}latch(){return new J(V(this.event,void 0,this.disposables))}debounce(q,j=100,Z=!1,oe){return new J(W(this.event,q,j,Z,oe,this.disposables))}on(q,j,Z){return this.event(q,j,Z)}once(q,j,Z){return h(this.event)(q,j,Z)}dispose(){this.disposables.dispose()}}function H(U){return new J(U)}l.chain=H;function B(U,q,j=Z=>Z){const Z=(...ne)=>te.fire(j(...ne)),oe=()=>U.on(q,Z),Q=()=>U.removeListener(q,Z),te=new C({onFirstListenerAdd:oe,onLastListenerRemove:Q});return te.event}l.fromNodeEventEmitter=B;function K(U,q,j=Z=>Z){const Z=(...ne)=>te.fire(j(...ne)),oe=()=>U.addEventListener(q,Z),Q=()=>U.removeEventListener(q,Z),te=new C({onFirstListenerAdd:oe,onLastListenerRemove:Q});return te.event}l.fromDOMEventEmitter=K;function ie(U){return new Promise(q=>h(U)(q))}l.toPromise=ie;function ce(U,q){return q(void 0),U(j=>q(j))}l.runAndSubscribe=ce;function z(U,q){let j=null;function Z(Q){j?.dispose(),j=new k.DisposableStore,q(Q,j)}Z(void 0);const oe=U(Q=>Z(Q));return(0,k.toDisposable)(()=>{oe.dispose(),j?.dispose()})}l.runAndSubscribeWithStore=z;class x{constructor(q,j){this.obs=q,this._counter=0,this._hasChanged=!1;const Z={onFirstListenerAdd:()=>{q.addObserver(this)},onLastListenerRemove:()=>{q.removeObserver(this)}};j||a(Z),this.emitter=new C(Z),j&&j.add(this.emitter)}beginUpdate(q){this._counter++}handleChange(q,j){this._hasChanged=!0}endUpdate(q){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function _(U,q){return new x(U,q).emitter.event}l.fromObservable=_})(I=e.Event||(e.Event={}));class E{constructor(a){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${a}_${E._idPool++}`}start(a){this._stopWatch=new A.StopWatch(!0),this._listenerCount=a}stop(){if(this._stopWatch){const a=this._stopWatch.elapsed();this._elapsedOverall+=a,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${a.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}E._idPool=0;let w=-1;function v(l){const a=w;return w=l,{dispose(){w=a}}}e.setGlobalLeakWarningThreshold=v;class y{constructor(a,h=Math.random().toString(18).slice(2,5)){this.customThreshold=a,this.name=h,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(a,h){let p=w;if(typeof this.customThreshold=="number"&&(p=this.customThreshold),p<=0||h<p)return;this._stacks||(this._stacks=new Map);const R=this._stacks.get(a.value)||0;if(this._stacks.set(a.value,R+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=p*.5;let M,O=0;for(const[F,T]of this._stacks)(!M||O<T)&&(M=F,O=T);console.warn(`[${this.name}] potential listener LEAK detected, having ${h} listeners already. MOST frequent listener (${O}):`),console.warn(M)}return()=>{const M=this._stacks.get(a.value)||0;this._stacks.set(a.value,M-1)}}}class f{constructor(a){this.value=a}static create(){return new f(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class S{constructor(a,h,p){this.callback=a,this.callbackThis=h,this.stack=p,this.subscription=new k.SafeDisposable}invoke(a){this.callback.call(this.callbackThis,a)}}class C{constructor(a){this._disposed=!1,this._options=a,this._leakageMon=w>0?new y(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new E(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(b){const a=Array.from(this._listeners);queueMicrotask(()=>{for(const h of a)h.subscription.isset()&&(h.subscription.unset(),h.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(a,h,p)=>{this._listeners||(this._listeners=new L.LinkedList);const R=this._listeners.isEmpty();R&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let M,O;this._leakageMon&&this._listeners.size>=30&&(O=f.create(),M=this._leakageMon.check(O,this._listeners.size+1)),b&&(O=O??f.create());const F=new S(a,h,O),T=this._listeners.push(F);R&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,a,h);const N=F.subscription.set(()=>{M?.(),this._disposed||(T(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return p instanceof k.DisposableStore?p.add(N):Array.isArray(p)&&p.push(N),N}),this._event}fire(a){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new g);for(const h of this._listeners)this._deliveryQueue.push(this,h,a);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}e.Emitter=C;class m{constructor(){this._queue=new L.LinkedList}get size(){return this._queue.size}push(a,h,p){this._queue.push(new c(a,h,p))}clear(a){const h=new L.LinkedList;for(const p of this._queue)p.emitter!==a&&h.push(p);this._queue=h}deliver(){for(;this._queue.size>0;){const a=this._queue.shift();try{a.listener.invoke(a.event)}catch(h){(0,D.onUnexpectedError)(h)}}}}e.EventDeliveryQueue=m;class g extends m{clear(a){this._queue.clear()}}class c{constructor(a,h,p){this.emitter=a,this.listener=h,this.event=p}}class d extends C{async fireAsync(a,h,p){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new L.LinkedList);for(const R of this._listeners)this._asyncDeliveryQueue.push([R,a]);for(;this._asyncDeliveryQueue.size>0&&!h.isCancellationRequested;){const[R,M]=this._asyncDeliveryQueue.shift(),O=[],F={...M,token:h,waitUntil:T=>{if(Object.isFrozen(O))throw new Error("waitUntil can NOT be called asynchronous");p&&(T=p(T,R.callback)),O.push(T)}};try{R.invoke(F)}catch(T){(0,D.onUnexpectedError)(T);continue}Object.freeze(O),await Promise.allSettled(O).then(T=>{for(const N of T)N.status==="rejected"&&(0,D.onUnexpectedError)(N.reason)})}}}}e.AsyncEmitter=d;class u extends C{constructor(a){super(a);this._isPaused=0,this._eventQueue=new L.LinkedList,this._mergeFn=a?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const a=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(a))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(a){this._listeners&&(this._isPaused!==0?this._eventQueue.push(a):super.fire(a))}}e.PauseableEmitter=u;class s extends u{constructor(a){super(a);this._delay=a.delay??100}fire(a){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(a)}}e.DebounceEmitter=s;class r extends C{constructor(a){super(a);this._queuedEvents=[],this._mergeFn=a?.merge}fire(a){this._queuedEvents.push(a),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(h=>super.fire(h)),this._queuedEvents=[]})}}e.MicrotaskEmitter=r;class t{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new C({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(a){const h={event:a,listener:null};this.events.push(h),this.hasListeners&&this.hook(h);const p=()=>{this.hasListeners&&this.unhook(h);const R=this.events.indexOf(h);this.events.splice(R,1)};return(0,k.toDisposable)((0,n.once)(p))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(a=>this.hook(a))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(a=>this.unhook(a))}hook(a){a.listener=a.event(h=>this.emitter.fire(h))}unhook(a){a.listener&&a.listener.dispose(),a.listener=null}dispose(){this.emitter.dispose()}}e.EventMultiplexer=t;class i{constructor(){this.buffers=[]}wrapEvent(a){return(h,p,R)=>a(M=>{const O=this.buffers[this.buffers.length-1];O?O.push(()=>h.call(p,M)):h.call(p,M)},void 0,R)}bufferEvents(a){const h=[];this.buffers.push(h);const p=a();return this.buffers.pop(),h.forEach(R=>R()),p}}e.EventBufferer=i;class o{constructor(){this.listening=!1,this.inputEvent=I.None,this.inputEventListener=k.Disposable.None,this.emitter=new C({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(a){this.inputEvent=a,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=a(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}e.Relay=o}),define(re[21],se([0,1,3]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CancellationTokenSource=e.CancellationToken=void 0;const n=Object.freeze(function(b,P){const I=setTimeout(b.bind(P),0);return{dispose(){clearTimeout(I)}}});var k;(function(b){function P(I){return I===b.None||I===b.Cancelled||I instanceof L?!0:!I||typeof I!="object"?!1:typeof I.isCancellationRequested=="boolean"&&typeof I.onCancellationRequested=="function"}b.isCancellationToken=P,b.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:D.Event.None}),b.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:n})})(k=e.CancellationToken||(e.CancellationToken={}));class L{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?n:(this._emitter||(this._emitter=new D.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class A{constructor(P){this._token=void 0,this._parentListener=void 0,this._parentListener=P&&P.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new L),this._token}cancel(){this._token?this._token instanceof L&&this._token.cancel():this._token=k.Cancelled}dispose(P=!1){P&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof L&&this._token.dispose():this._token=k.None}}e.CancellationTokenSource=A}),define(re[125],se([0,1,21]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CachedFunction=e.LRUCachedFunction=e.Cache=void 0;class n{constructor(b){this.task=b,this.result=null}get(){if(this.result)return this.result;const b=new D.CancellationTokenSource,P=this.task(b.token);return this.result={promise:P,dispose:()=>{this.result=null,b.cancel(),b.dispose()}},this.result}}e.Cache=n;class k{constructor(b){this.fn=b,this.lastCache=void 0,this.lastArgKey=void 0}get(b){const P=JSON.stringify(b);return this.lastArgKey!==P&&(this.lastArgKey=P,this.lastCache=this.fn(b)),this.lastCache}}e.LRUCachedFunction=k;class L{constructor(b){this.fn=b,this._map=new Map}get cachedValues(){return this._map}get(b){if(this._map.has(b))return this._map.get(b);const P=this.fn(b);return this._map.set(b,P),P}}e.CachedFunction=L}),define(re[78],se([0,1,3,2]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MutableObservableValue=e.staticObservableValue=void 0;const k=A=>({onDidChange:D.Event.None,value:A});e.staticObservableValue=k;class L extends n.Disposable{constructor(b){super();this._value=b,this.changeEmitter=this._register(new D.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(b){b!==this._value&&(this._value=b,this.changeEmitter.fire(b))}}e.MutableObservableValue=L}),define(re[26],se([0,1,125,111]),function(X,e,D,n){"use strict";var k;Object.defineProperty(e,"__esModule",{value:!0}),e.InvisibleCharacters=e.AmbiguousCharacters=e.noBreakWhitespace=e.getLeftDeleteOffset=e.GraphemeBreakType=e.getGraphemeBreakType=e.singleLetterHash=e.getNLines=e.uppercaseFirstLetter=e.containsUppercaseCharacter=e.fuzzyContains=e.stripUTF8BOM=e.startsWithUTF8BOM=e.UTF8_BOM_CHARACTER=e.removeAnsiEscapeCodes=e.lcut=e.isEmojiImprecise=e.isFullWidthCharacter=e.containsUnusualLineTerminators=e.UNUSUAL_LINE_TERMINATORS=e.isBasicASCII=e.containsRTL=e.getCharContainingOffset=e.prevCharLength=e.nextCharLength=e.GraphemeIterator=e.CodePointIterator=e.getNextCodePoint=e.computeCodePoint=e.isLowSurrogate=e.isHighSurrogate=e.commonSuffixLength=e.commonPrefixLength=e.startsWithIgnoreCase=e.equalsIgnoreCase=e.isUpperAsciiLetter=e.isLowerAsciiLetter=e.isAsciiDigit=e.compareSubstringIgnoreCase=e.compareIgnoreCase=e.compareSubstring=e.compare=e.replaceAsync=e.lastNonWhitespaceIndex=e.getLeadingWhitespace=e.firstNonWhitespaceIndex=e.splitLines=e.regExpFlags=e.regExpContainsBackreference=e.regExpLeadsToEndlessLoop=e.createRegExp=e.stripWildcards=e.convertSimple2RegExpPattern=e.rtrim=e.ltrim=e.trim=e.truncate=e.count=e.escapeRegExpCharacters=e.escape=e.format2=e.format=e.isFalsyOrWhitespace=void 0;function L(ee){return!ee||typeof ee!="string"?!0:ee.trim().length===0}e.isFalsyOrWhitespace=L;const A=/{(\d+)}/g;function b(ee,...le){return le.length===0?ee:ee.replace(A,function(ge,Se){const ve=parseInt(Se,10);return isNaN(ve)||ve<0||ve>=le.length?ge:le[ve]})}e.format=b;const P=/{([^}]+)}/g;function I(ee,le){return ee.replace(P,(ge,Se)=>le[Se]??ge)}e.format2=I;function E(ee){return ee.replace(/[<>&]/g,function(le){switch(le){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return le}})}e.escape=E;function w(ee){return ee.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}e.escapeRegExpCharacters=w;function v(ee,le){let ge=0;const Se=le.charCodeAt(0);for(let ve=ee.length-1;ve>=0;ve--)ee.charCodeAt(ve)===Se&&ge++;return ge}e.count=v;function y(ee,le,ge="\u2026"){return ee.length<=le?ee:`${ee.substr(0,le)}${ge}`}e.truncate=y;function f(ee,le=" "){const ge=S(ee,le);return C(ge,le)}e.trim=f;function S(ee,le){if(!ee||!le)return ee;const ge=le.length;if(ge===0||ee.length===0)return ee;let Se=0;for(;ee.indexOf(le,Se)===Se;)Se=Se+ge;return ee.substring(Se)}e.ltrim=S;function C(ee,le){if(!ee||!le)return ee;const ge=le.length,Se=ee.length;if(ge===0||Se===0)return ee;let ve=Se,Ee=-1;for(;Ee=ee.lastIndexOf(le,ve-1),!(Ee===-1||Ee+ge!==ve);){if(Ee===0)return"";ve=Ee}return ee.substring(0,ve)}e.rtrim=C;function m(ee){return ee.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}e.convertSimple2RegExpPattern=m;function g(ee){return ee.replace(/\*/g,"")}e.stripWildcards=g;function c(ee,le,ge={}){if(!ee)throw new Error("Cannot create regex from empty string");le||(ee=w(ee)),ge.wholeWord&&(/\B/.test(ee.charAt(0))||(ee="\\b"+ee),/\B/.test(ee.charAt(ee.length-1))||(ee=ee+"\\b"));let Se="";return ge.global&&(Se+="g"),ge.matchCase||(Se+="i"),ge.multiline&&(Se+="m"),ge.unicode&&(Se+="u"),new RegExp(ee,Se)}e.createRegExp=c;function d(ee){return ee.source==="^"||ee.source==="^$"||ee.source==="$"||ee.source==="^\\s*$"?!1:!!(ee.exec("")&&ee.lastIndex===0)}e.regExpLeadsToEndlessLoop=d;function u(ee){return!!ee.match(/([^\\]|^)(\\\\)*\\\d+/)}e.regExpContainsBackreference=u;function s(ee){return(ee.global?"g":"")+(ee.ignoreCase?"i":"")+(ee.multiline?"m":"")+(ee.unicode?"u":"")}e.regExpFlags=s;function r(ee){return ee.split(/\r\n|\r|\n/)}e.splitLines=r;function t(ee){for(let le=0,ge=ee.length;le<ge;le++){const Se=ee.charCodeAt(le);if(Se!==32&&Se!==9)return le}return-1}e.firstNonWhitespaceIndex=t;function i(ee,le=0,ge=ee.length){for(let Se=le;Se<ge;Se++){const ve=ee.charCodeAt(Se);if(ve!==32&&ve!==9)return ee.substring(le,Se)}return ee.substring(le,ge)}e.getLeadingWhitespace=i;function o(ee,le=ee.length-1){for(let ge=le;ge>=0;ge--){const Se=ee.charCodeAt(ge);if(Se!==32&&Se!==9)return ge}return-1}e.lastNonWhitespaceIndex=o;function l(ee,le,ge){const Se=[];let ve=0;for(const Ee of ee.matchAll(le)){if(Se.push(ee.slice(ve,Ee.index)),Ee.index===void 0)throw new Error("match.index should be defined");ve=Ee.index+Ee[0].length,Se.push(ge(Ee[0],...Ee.slice(1),Ee.index,ee,Ee.groups))}return Se.push(ee.slice(ve)),Promise.all(Se).then(Ee=>Ee.join(""))}e.replaceAsync=l;function a(ee,le){return ee<le?-1:ee>le?1:0}e.compare=a;function h(ee,le,ge=0,Se=ee.length,ve=0,Ee=le.length){for(;ge<Se&&ve<Ee;ge++,ve++){const Le=ee.charCodeAt(ge),_e=le.charCodeAt(ve);if(Le<_e)return-1;if(Le>_e)return 1}const Re=Se-ge,ke=Ee-ve;return Re<ke?-1:Re>ke?1:0}e.compareSubstring=h;function p(ee,le){return R(ee,le,0,ee.length,0,le.length)}e.compareIgnoreCase=p;function R(ee,le,ge=0,Se=ee.length,ve=0,Ee=le.length){for(;ge<Se&&ve<Ee;ge++,ve++){let Le=ee.charCodeAt(ge),_e=le.charCodeAt(ve);if(Le===_e)continue;if(Le>=128||_e>=128)return h(ee.toLowerCase(),le.toLowerCase(),ge,Se,ve,Ee);O(Le)&&(Le-=32),O(_e)&&(_e-=32);const Fe=Le-_e;if(Fe!==0)return Fe}const Re=Se-ge,ke=Ee-ve;return Re<ke?-1:Re>ke?1:0}e.compareSubstringIgnoreCase=R;function M(ee){return ee>=48&&ee<=57}e.isAsciiDigit=M;function O(ee){return ee>=97&&ee<=122}e.isLowerAsciiLetter=O;function F(ee){return ee>=65&&ee<=90}e.isUpperAsciiLetter=F;function T(ee,le){return ee.length===le.length&&R(ee,le)===0}e.equalsIgnoreCase=T;function N(ee,le){const ge=le.length;return le.length>ee.length?!1:R(ee,le,0,ge)===0}e.startsWithIgnoreCase=N;function W(ee,le){const ge=Math.min(ee.length,le.length);let Se;for(Se=0;Se<ge;Se++)if(ee.charCodeAt(Se)!==le.charCodeAt(Se))return Se;return ge}e.commonPrefixLength=W;function V(ee,le){const ge=Math.min(ee.length,le.length);let Se;const ve=ee.length-1,Ee=le.length-1;for(Se=0;Se<ge;Se++)if(ee.charCodeAt(ve-Se)!==le.charCodeAt(Ee-Se))return Se;return ge}e.commonSuffixLength=V;function Y(ee){return 55296<=ee&&ee<=56319}e.isHighSurrogate=Y;function $(ee){return 56320<=ee&&ee<=57343}e.isLowSurrogate=$;function J(ee,le){return(ee-55296<<10)+(le-56320)+65536}e.computeCodePoint=J;function H(ee,le,ge){const Se=ee.charCodeAt(ge);if(Y(Se)&&ge+1<le){const ve=ee.charCodeAt(ge+1);if($(ve))return J(Se,ve)}return Se}e.getNextCodePoint=H;function B(ee,le){const ge=ee.charCodeAt(le-1);if($(ge)&&le>1){const Se=ee.charCodeAt(le-2);if(Y(Se))return J(Se,ge)}return ge}class K{constructor(le,ge=0){this._str=le,this._len=le.length,this._offset=ge}get offset(){return this._offset}setOffset(le){this._offset=le}prevCodePoint(){const le=B(this._str,this._offset);return this._offset-=le>=65536?2:1,le}nextCodePoint(){const le=H(this._str,this._len,this._offset);return this._offset+=le>=65536?2:1,le}eol(){return this._offset>=this._len}}e.CodePointIterator=K;class ie{constructor(le,ge=0){this._iterator=new K(le,ge)}get offset(){return this._iterator.offset}nextGraphemeLength(){const le=be.getInstance(),ge=this._iterator,Se=ge.offset;let ve=le.getGraphemeBreakType(ge.nextCodePoint());for(;!ge.eol();){const Ee=ge.offset,Re=le.getGraphemeBreakType(ge.nextCodePoint());if(de(ve,Re)){ge.setOffset(Ee);break}ve=Re}return ge.offset-Se}prevGraphemeLength(){const le=be.getInstance(),ge=this._iterator,Se=ge.offset;let ve=le.getGraphemeBreakType(ge.prevCodePoint());for(;ge.offset>0;){const Ee=ge.offset,Re=le.getGraphemeBreakType(ge.prevCodePoint());if(de(Re,ve)){ge.setOffset(Ee);break}ve=Re}return Se-ge.offset}eol(){return this._iterator.eol()}}e.GraphemeIterator=ie;function ce(ee,le){return new ie(ee,le).nextGraphemeLength()}e.nextCharLength=ce;function z(ee,le){return new ie(ee,le).prevGraphemeLength()}e.prevCharLength=z;function x(ee,le){le>0&&$(ee.charCodeAt(le))&&le--;const ge=le+ce(ee,le);return[ge-z(ee,ge),ge]}e.getCharContainingOffset=x;const _=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function U(ee){return _.test(ee)}e.containsRTL=U;const q=/^[\t\n\r\x20-\x7E]*$/;function j(ee){return q.test(ee)}e.isBasicASCII=j,e.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function Z(ee){return e.UNUSUAL_LINE_TERMINATORS.test(ee)}e.containsUnusualLineTerminators=Z;function oe(ee){return ee>=11904&&ee<=55215||ee>=63744&&ee<=64255||ee>=65281&&ee<=65374}e.isFullWidthCharacter=oe;function Q(ee){return ee>=127462&&ee<=127487||ee===8986||ee===8987||ee===9200||ee===9203||ee>=9728&&ee<=10175||ee===11088||ee===11093||ee>=127744&&ee<=128591||ee>=128640&&ee<=128764||ee>=128992&&ee<=129008||ee>=129280&&ee<=129535||ee>=129648&&ee<=129782}e.isEmojiImprecise=Q;function te(ee,le){if(ee.length<le)return ee;const ge=/\b/g;let Se=0;for(;ge.test(ee)&&!(ee.length-ge.lastIndex<le);)Se=ge.lastIndex,ge.lastIndex+=1;return ee.substring(Se).replace(/^\s/,"")}e.lcut=te;const ne=/\x1B\x5B[12]?K/g,ue=/\x1b\[\d+m/g,he=/\x1b\[0?m/g;function pe(ee){return ee&&(ee=ee.replace(ne,""),ee=ee.replace(ue,""),ee=ee.replace(he,"")),ee}e.removeAnsiEscapeCodes=pe,e.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function we(ee){return!!(ee&&ee.length>0&&ee.charCodeAt(0)===65279)}e.startsWithUTF8BOM=we;function Ce(ee){return we(ee)?ee.substr(1):ee}e.stripUTF8BOM=Ce;function Pe(ee,le){if(!ee||!le||ee.length<le.length)return!1;const ge=le.length,Se=ee.toLowerCase();let ve=0,Ee=-1;for(;ve<ge;){const Re=Se.indexOf(le[ve],Ee+1);if(Re<0)return!1;Ee=Re,ve++}return!0}e.fuzzyContains=Pe;function Ue(ee,le=!1){return ee?(le&&(ee=ee.replace(/\\./g,"")),ee.toLowerCase()!==ee):!1}e.containsUppercaseCharacter=Ue;function We(ee){return ee.charAt(0).toUpperCase()+ee.slice(1)}e.uppercaseFirstLetter=We;function Be(ee,le=1){if(le===0)return"";let ge=-1;do ge=ee.indexOf(`
`,ge+1),le--;while(le>0&&ge>=0);return ge===-1?ee:(ee[ge-1]==="\r"&&ge--,ee.substr(0,ge))}e.getNLines=Be;function qe(ee){const le=90-65+1;return ee=ee%(2*le),ee<le?String.fromCharCode(97+ee):String.fromCharCode(65+ee-le)}e.singleLetterHash=qe;function ae(ee){return be.getInstance().getGraphemeBreakType(ee)}e.getGraphemeBreakType=ae;function de(ee,le){return ee===0?le!==5&&le!==7:ee===2&&le===3?!1:ee===4||ee===2||ee===3||le===4||le===2||le===3?!0:!(ee===8&&(le===8||le===9||le===11||le===12)||(ee===11||ee===9)&&(le===9||le===10)||(ee===12||ee===10)&&le===10||le===5||le===13||le===7||ee===1||ee===13&&le===14||ee===6&&le===6)}var fe;(function(ee){ee[ee.Other=0]="Other",ee[ee.Prepend=1]="Prepend",ee[ee.CR=2]="CR",ee[ee.LF=3]="LF",ee[ee.Control=4]="Control",ee[ee.Extend=5]="Extend",ee[ee.Regional_Indicator=6]="Regional_Indicator",ee[ee.SpacingMark=7]="SpacingMark",ee[ee.L=8]="L",ee[ee.V=9]="V",ee[ee.T=10]="T",ee[ee.LV=11]="LV",ee[ee.LVT=12]="LVT",ee[ee.ZWJ=13]="ZWJ",ee[ee.Extended_Pictographic=14]="Extended_Pictographic"})(fe=e.GraphemeBreakType||(e.GraphemeBreakType={}));class be{constructor(){this._data=Ie()}static getInstance(){return be._INSTANCE||(be._INSTANCE=new be),be._INSTANCE}getGraphemeBreakType(le){if(le<32)return le===10?3:le===13?2:4;if(le<127)return 0;const ge=this._data,Se=ge.length/3;let ve=1;for(;ve<=Se;)if(le<ge[3*ve])ve=2*ve;else if(le>ge[3*ve+1])ve=2*ve+1;else return ge[3*ve+2];return 0}}be._INSTANCE=null;function Ie(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Me(ee,le){if(ee===0)return 0;const ge=De(ee,le);if(ge!==void 0)return ge;const Se=new K(le,ee);return Se.prevCodePoint(),Se.offset}e.getLeftDeleteOffset=Me;function De(ee,le){const ge=new K(le,ee);let Se=ge.prevCodePoint();for(;$e(Se)||Se===65039||Se===8419;){if(ge.offset===0)return;Se=ge.prevCodePoint()}if(!Q(Se))return;let ve=ge.offset;return ve>0&&ge.prevCodePoint()===8205&&(ve=ge.offset),ve}function $e(ee){return 127995<=ee&&ee<=127999}var Ae;(function(ee){ee[ee.zwj=8205]="zwj",ee[ee.emojiVariantSelector=65039]="emojiVariantSelector",ee[ee.enclosingKeyCap=8419]="enclosingKeyCap"})(Ae||(Ae={})),e.noBreakWhitespace="\xA0";class Te{constructor(le){this.confusableDictionary=le}static getInstance(le){return Te.cache.get(Array.from(le))}static getLocales(){return Te._locales.getValue()}isAmbiguous(le){return this.confusableDictionary.has(le)}getPrimaryConfusable(le){return this.confusableDictionary.get(le)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}e.AmbiguousCharacters=Te,k=Te,Te.ambiguousCharacterData=new n.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),Te.cache=new D.LRUCachedFunction(ee=>{function le(_e){const Fe=new Map;for(let ze=0;ze<_e.length;ze+=2)Fe.set(_e[ze],_e[ze+1]);return Fe}function ge(_e,Fe){const ze=new Map(_e);for(const[Qe,it]of Fe)ze.set(Qe,it);return ze}function Se(_e,Fe){if(!_e)return Fe;const ze=new Map;for(const[Qe,it]of _e)Fe.has(Qe)&&ze.set(Qe,it);return ze}const ve=k.ambiguousCharacterData.getValue();let Ee=ee.filter(_e=>!_e.startsWith("_")&&_e in ve);Ee.length===0&&(Ee=["_default"]);let Re;for(const _e of Ee){const Fe=le(ve[_e]);Re=Se(Re,Fe)}const ke=le(ve._common),Le=ge(ke,Re);return new Te(Le)}),Te._locales=new n.Lazy(()=>Object.keys(Te.ambiguousCharacterData.getValue()).filter(ee=>!ee.startsWith("_")));class Ne{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Ne.getRawData())),this._data}static isInvisibleCharacter(le){return Ne.getData().has(le)}static get codePoints(){return Ne.getData()}}e.InvisibleCharacters=Ne,Ne._data=void 0}),define(re[47],se([0,1,10,4,26,15]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function A(o){return o===47||o===92}e.isPathSeparator=A;function b(o){return o.replace(/[\\/]/g,D.posix.sep)}e.toSlashes=b;function P(o){return o.indexOf("/")===-1&&(o=b(o)),/^[a-zA-Z]:(\/|$)/.test(o)&&(o="/"+o),o}e.toPosixPath=P;function I(o,l=D.posix.sep){if(!o)return"";const a=o.length,h=o.charCodeAt(0);if(A(h)){if(A(o.charCodeAt(1))&&!A(o.charCodeAt(2))){let R=3;const M=R;for(;R<a&&!A(o.charCodeAt(R));R++);if(M!==R&&!A(o.charCodeAt(R+1))){for(R+=1;R<a;R++)if(A(o.charCodeAt(R)))return o.slice(0,R+1).replace(/[\\/]/g,l)}}return l}else if(m(h)&&o.charCodeAt(1)===58)return A(o.charCodeAt(2))?o.slice(0,2)+l:o.slice(0,2);let p=o.indexOf("://");if(p!==-1){for(p+=3;p<a;p++)if(A(o.charCodeAt(p)))return o.slice(0,p+1)}return""}e.getRoot=I;function E(o){if(!n.isWindows||!o||o.length<5)return!1;let l=o.charCodeAt(0);if(l!==92||(l=o.charCodeAt(1),l!==92))return!1;let a=2;const h=a;for(;a<o.length&&(l=o.charCodeAt(a),l!==92);a++);return!(h===a||(l=o.charCodeAt(a+1),isNaN(l)||l===92))}e.isUNC=E;const w=/[\\/:\*\?"<>\|]/g,v=/[\\/]/g,y=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(o,l=n.isWindows){const a=l?w:v;return!(!o||o.length===0||/^\s+$/.test(o)||(a.lastIndex=0,a.test(o))||l&&y.test(o)||o==="."||o===".."||l&&o[o.length-1]==="."||l&&o.length!==o.trim().length||o.length>255)}e.isValidBasename=f;function S(o,l,a){const h=o===l;return!a||h?h:!o||!l?!1:(0,k.equalsIgnoreCase)(o,l)}e.isEqual=S;function C(o,l,a,h=D.sep){if(o===l)return!0;if(!o||!l||l.length>o.length)return!1;if(a){if(!(0,k.startsWithIgnoreCase)(o,l))return!1;if(l.length===o.length)return!0;let R=l.length;return l.charAt(l.length-1)===h&&R--,o.charAt(R)===h}return l.charAt(l.length-1)!==h&&(l+=h),o.indexOf(l)===0}e.isEqualOrParent=C;function m(o){return o>=65&&o<=90||o>=97&&o<=122}e.isWindowsDriveLetter=m;function g(o,l){return n.isWindows&&o.endsWith(":")&&(o+=D.sep),(0,D.isAbsolute)(o)||(o=(0,D.join)(l,o)),o=(0,D.normalize)(o),n.isWindows?(o=(0,k.rtrim)(o,D.sep),o.endsWith(":")&&(o+=D.sep)):(o=(0,k.rtrim)(o,D.sep),o||(o=D.sep)),o}e.sanitizeFilePath=g;function c(o){const l=(0,D.normalize)(o);return n.isWindows?o.length>3?!1:d(l)&&(o.length===2||l.charCodeAt(2)===92):l===D.posix.sep}e.isRootOrDriveLetter=c;function d(o,l=n.isWindows){return l?m(o.charCodeAt(0))&&o.charCodeAt(1)===58:!1}e.hasDriveLetter=d;function u(o){return d(o)?o[0]:void 0}e.getDriveLetter=u;function s(o,l,a){return l.length>o.length?-1:o===l?0:(a&&(o=o.toLowerCase(),l=l.toLowerCase()),o.indexOf(l))}e.indexOfPath=s;function r(o){const l=o.split(":");let a,h,p;for(const R of l){const M=Number(R);(0,L.isNumber)(M)?h===void 0?h=M:p===void 0&&(p=M):a=a?[a,R].join(":"):R}if(!a)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:a,line:h!==void 0?h:void 0,column:p!==void 0?p:h!==void 0?1:void 0}}e.parseLineAndColumnAware=r;const t="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(o,l,a=8){let h="";for(let R=0;R<a;R++)h+=t.charAt(Math.floor(Math.random()*t.length));let p;return l?p=`${l}-${h}`:p=h,o?(0,D.join)(o,p):p}e.randomPath=i}),define(re[62],se([0,1,26]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StringSHA1=e.toHexString=e.Hasher=e.stringHash=e.numberHash=e.doHash=e.hash=void 0;function n(m){return k(m,0)}e.hash=n;function k(m,g){switch(typeof m){case"object":return m===null?L(349,g):Array.isArray(m)?P(m,g):I(m,g);case"string":return b(m,g);case"boolean":return A(m,g);case"number":return L(m,g);case"undefined":return L(937,g);default:return L(617,g)}}e.doHash=k;function L(m,g){return(g<<5)-g+m|0}e.numberHash=L;function A(m,g){return L(m?433:863,g)}function b(m,g){g=L(149417,g);for(let c=0,d=m.length;c<d;c++)g=L(m.charCodeAt(c),g);return g}e.stringHash=b;function P(m,g){return g=L(104579,g),m.reduce((c,d)=>k(d,c),g)}function I(m,g){return g=L(181387,g),Object.keys(m).sort().reduce((c,d)=>(c=b(d,c),k(m[d],c)),g)}class E{constructor(){this._value=0}get value(){return this._value}hash(g){return this._value=k(g,this._value),this._value}}e.Hasher=E;var w;(function(m){m[m.BLOCK_SIZE=64]="BLOCK_SIZE",m[m.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(w||(w={}));function v(m,g,c=32){const d=c-g,u=~((1<<d)-1);return(m<<g|(u&m)>>>d)>>>0}function y(m,g=0,c=m.byteLength,d=0){for(let u=0;u<c;u++)m[g+u]=d}function f(m,g,c="0"){for(;m.length<g;)m=c+m;return m}function S(m,g=32){return m instanceof ArrayBuffer?Array.from(new Uint8Array(m)).map(c=>c.toString(16).padStart(2,"0")).join(""):f((m>>>0).toString(16),g/4)}e.toHexString=S;class C{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(g){const c=g.length;if(c===0)return;const d=this._buff;let u=this._buffLen,s=this._leftoverHighSurrogate,r,t;for(s!==0?(r=s,t=-1,s=0):(r=g.charCodeAt(0),t=0);;){let i=r;if(D.isHighSurrogate(r))if(t+1<c){const o=g.charCodeAt(t+1);D.isLowSurrogate(o)?(t++,i=D.computeCodePoint(r,o)):i=65533}else{s=r;break}else D.isLowSurrogate(r)&&(i=65533);if(u=this._push(d,u,i),t++,t<c)r=g.charCodeAt(t);else break}this._buffLen=u,this._leftoverHighSurrogate=s}_push(g,c,d){return d<128?g[c++]=d:d<2048?(g[c++]=192|(d&1984)>>>6,g[c++]=128|(d&63)>>>0):d<65536?(g[c++]=224|(d&61440)>>>12,g[c++]=128|(d&4032)>>>6,g[c++]=128|(d&63)>>>0):(g[c++]=240|(d&1835008)>>>18,g[c++]=128|(d&258048)>>>12,g[c++]=128|(d&4032)>>>6,g[c++]=128|(d&63)>>>0),c>=64&&(this._step(),c-=64,this._totalLen+=64,g[0]=g[64+0],g[1]=g[64+1],g[2]=g[64+2]),c}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),S(this._h0)+S(this._h1)+S(this._h2)+S(this._h3)+S(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,y(this._buff,this._buffLen),this._buffLen>56&&(this._step(),y(this._buff));const g=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(g/4294967296),!1),this._buffDV.setUint32(60,g%4294967296,!1),this._step()}_step(){const g=C._bigBlock32,c=this._buffDV;for(let a=0;a<64;a+=4)g.setUint32(a,c.getUint32(a,!1),!1);for(let a=64;a<320;a+=4)g.setUint32(a,v(g.getUint32(a-12,!1)^g.getUint32(a-32,!1)^g.getUint32(a-56,!1)^g.getUint32(a-64,!1),1),!1);let d=this._h0,u=this._h1,s=this._h2,r=this._h3,t=this._h4,i,o,l;for(let a=0;a<80;a++)a<20?(i=u&s|~u&r,o=1518500249):a<40?(i=u^s^r,o=1859775393):a<60?(i=u&s|u&r|s&r,o=2400959708):(i=u^s^r,o=3395469782),l=v(d,5)+i+t+o+g.getUint32(a*4,!1)&4294967295,t=r,r=s,s=v(u,30),u=d,d=l;this._h0=this._h0+d&4294967295,this._h1=this._h1+u&4294967295,this._h2=this._h2+s&4294967295,this._h3=this._h3+r&4294967295,this._h4=this._h4+t&4294967295}}e.StringSHA1=C,C._bigBlock32=new DataView(new ArrayBuffer(320))}),define(re[34],se([0,1,18,26]),function(X,e,D,n){"use strict";var k,L,A;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function b(t,i,o){let l=t.get(i);return l===void 0&&(l=o,t.set(i,l)),l}e.getOrSet=b;function P(t){const i=[];return t.forEach((o,l)=>{i.push(`${l} => ${o}`)}),`Map(${t.size}) {${i.join(", ")}}`}e.mapToString=P;function I(t){const i=[];return t.forEach(o=>{i.push(o)}),`Set(${t.size}) {${i.join(", ")}}`}e.setToString=I;class E{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const o=i.charCodeAt(0),l=this._value.charCodeAt(this._pos);return o-l}value(){return this._value[this._pos]}}e.StringIterator=E;class w{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=w;class v{constructor(i=!0,o=!0){this._splitOnBackslash=i,this._caseSensitive=o}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let o=i.length-1;o>=0;o--,this._valueLen--){const l=this._value.charCodeAt(o);if(!(l===47||this._splitOnBackslash&&l===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const o=this._value.charCodeAt(this._to);if(o===47||this._splitOnBackslash&&o===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,n.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,n.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=v;var y;(function(t){t[t.Scheme=1]="Scheme",t[t.Authority=2]="Authority",t[t.Path=3]="Path",t[t.Query=4]="Query",t[t.Fragment=5]="Fragment"})(y||(y={}));class f{constructor(i,o){this._ignorePathCasing=i,this._ignoreQueryAndFragment=o,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new v(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,n.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,n.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,n.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,n.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class S{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var C;(function(t){t[t.Left=-1]="Left",t[t.Mid=0]="Mid",t[t.Right=1]="Right"})(C||(C={}));class m{constructor(i){this._iter=i}static forUris(i=()=>!1,o=()=>!1){return new m(new f(i,o))}static forPaths(i=!1){return new m(new v(void 0,!i))}static forStrings(){return new m(new E)}static forConfigKeys(){return new m(new w)}clear(){this._root=void 0}fill(i,o){if(o){const l=o.slice(0);(0,D.shuffle)(l);for(const a of l)this.set(a,i)}else{const l=i.slice(0);(0,D.shuffle)(l);for(const a of l)this.set(a[0],a[1])}}set(i,o){const l=this._iter.reset(i);let a;this._root||(this._root=new S,this._root.segment=l.value());const h=[];for(a=this._root;;){const R=l.cmp(a.segment);if(R>0)a.left||(a.left=new S,a.left.segment=l.value()),h.push([-1,a]),a=a.left;else if(R<0)a.right||(a.right=new S,a.right.segment=l.value()),h.push([1,a]),a=a.right;else if(l.hasNext())l.next(),a.mid||(a.mid=new S,a.mid.segment=l.value()),h.push([0,a]),a=a.mid;else break}const p=a.value;a.value=o,a.key=i;for(let R=h.length-1;R>=0;R--){const M=h[R][1];M.updateHeight();const O=M.balanceFactor();if(O<-1||O>1){const F=h[R][0],T=h[R+1][0];if(F===1&&T===1)h[R][1]=M.rotateLeft();else if(F===-1&&T===-1)h[R][1]=M.rotateRight();else if(F===1&&T===-1)M.right=h[R+1][1]=h[R+1][1].rotateRight(),h[R][1]=M.rotateLeft();else if(F===-1&&T===1)M.left=h[R+1][1]=h[R+1][1].rotateLeft(),h[R][1]=M.rotateRight();else throw new Error;if(R>0)switch(h[R-1][0]){case-1:h[R-1][1].left=h[R][1];break;case 1:h[R-1][1].right=h[R][1];break;case 0:h[R-1][1].mid=h[R][1];break}else this._root=h[0][1]}}return p}get(i){return this._getNode(i)?.value}_getNode(i){const o=this._iter.reset(i);let l=this._root;for(;l;){const a=o.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else break}return l}has(i){const o=this._getNode(i);return!(o?.value===void 0&&o?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,o){const l=this._iter.reset(i),a=[];let h=this._root;for(;h;){const p=l.cmp(h.segment);if(p>0)a.push([-1,h]),h=h.left;else if(p<0)a.push([1,h]),h=h.right;else if(l.hasNext())l.next(),a.push([0,h]),h=h.mid;else break}if(!!h){if(o?(h.left=void 0,h.mid=void 0,h.right=void 0,h.height=1):(h.key=void 0,h.value=void 0),!h.mid&&!h.value)if(h.left&&h.right){const p=this._min(h.right),{key:R,value:M,segment:O}=p;this._delete(p.key,!1),h.key=R,h.value=M,h.segment=O}else{const p=h.left??h.right;if(a.length>0){const[R,M]=a[a.length-1];switch(R){case-1:M.left=p;break;case 0:M.mid=p;break;case 1:M.right=p;break}}else this._root=p}for(let p=a.length-1;p>=0;p--){const R=a[p][1];R.updateHeight();const M=R.balanceFactor();if(M>1?(R.right.balanceFactor()>=0||(R.right=R.right.rotateRight()),a[p][1]=R.rotateLeft()):M<-1&&(R.left.balanceFactor()<=0||(R.left=R.left.rotateLeft()),a[p][1]=R.rotateRight()),p>0)switch(a[p-1][0]){case-1:a[p-1][1].left=a[p][1];break;case 1:a[p-1][1].right=a[p][1];break;case 0:a[p-1][1].mid=a[p][1];break}else this._root=a[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const o=this._iter.reset(i);let l=this._root,a;for(;l;){const h=o.cmp(l.segment);if(h>0)l=l.left;else if(h<0)l=l.right;else if(o.hasNext())o.next(),a=l.value||a,l=l.mid;else break}return l&&l.value||a}findSuperstr(i){const o=this._iter.reset(i);let l=this._root;for(;l;){const a=o.cmp(l.segment);if(a>0)l=l.left;else if(a<0)l=l.right;else if(o.hasNext())o.next(),l=l.mid;else return l.mid?this._entries(l.mid):void 0}}forEach(i){for(const[o,l]of this)i(l,o)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const o=[];return this._dfsEntries(i,o),o[Symbol.iterator]()}_dfsEntries(i,o){!i||(i.left&&this._dfsEntries(i.left,o),i.value&&o.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,o),i.right&&this._dfsEntries(i.right,o))}_isBalanced(){const i=o=>{if(!o)return!0;const l=o.balanceFactor();return l<-1||l>1?!1:i(o.left)&&i(o.right)};return i(this._root)}}e.TernarySearchTree=m;class g{constructor(i,o){this.uri=i,this.value=o}}class c{constructor(i,o){this[k]="ResourceMap",i instanceof c?(this.map=new Map(i.map),this.toKey=o??c.defaultToKey):(this.map=new Map,this.toKey=i??c.defaultToKey)}set(i,o){return this.map.set(this.toKey(i),new g(i,o)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,o){typeof o!="undefined"&&(i=i.bind(o));for(const[l,a]of this.map)i(a.value,a.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(k=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=c,c.defaultToKey=t=>t.toString();class d{constructor(i,o){this[L]="ResourceSet",!i||typeof i=="function"?this._map=new c(i):(this._map=new c(o),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,o){this._map.forEach((l,a)=>i.call(o,a,a,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=d;var u;(function(t){t[t.None=0]="None",t[t.AsOld=1]="AsOld",t[t.AsNew=2]="AsNew"})(u=e.Touch||(e.Touch={}));class s{constructor(){this[A]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,o=0){const l=this._map.get(i);if(!!l)return o!==0&&this.touch(l,o),l.value}set(i,o,l=0){let a=this._map.get(i);if(a)a.value=o,l!==0&&this.touch(a,l);else{switch(a={key:i,value:o,next:void 0,previous:void 0},l){case 0:this.addItemLast(a);break;case 1:this.addItemFirst(a);break;case 2:this.addItemLast(a);break;default:this.addItemLast(a);break}this._map.set(i,a),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const o=this._map.get(i);if(!!o)return this._map.delete(i),this.removeItem(o),this._size--,o.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,o){const l=this._state;let a=this._head;for(;a;){if(o?i.bind(o)(a.value,a.key,this):i(a.value,a.key,this),this._state!==l)throw new Error("LinkedMap got modified during iteration.");a=a.next}}keys(){const i=this,o=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:l.key,done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return a}values(){const i=this,o=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:l.value,done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return a}entries(){const i=this,o=this._state;let l=this._head;const a={[Symbol.iterator](){return a},next(){if(i._state!==o)throw new Error("LinkedMap got modified during iteration.");if(l){const h={value:[l.key,l.value],done:!1};return l=l.next,h}else return{value:void 0,done:!0}}};return a}[(A=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let o=this._head,l=this.size;for(;o&&l>i;)this._map.delete(o.key),o=o.next,l--;this._head=o,this._size=l,o&&(o.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const o=i.next,l=i.previous;if(!o||!l)throw new Error("Invalid list");o.previous=l,l.next=o}i.next=void 0,i.previous=void 0,this._state++}touch(i,o){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(o!==1&&o!==2)){if(o===1){if(i===this._head)return;const l=i.next,a=i.previous;i===this._tail?(a.next=void 0,this._tail=a):(l.previous=a,a.next=l),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(o===2){if(i===this._tail)return;const l=i.next,a=i.previous;i===this._head?(l.previous=void 0,this._head=l):(l.previous=a,a.next=l),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((o,l)=>{i.push([l,o])}),i}fromJSON(i){this.clear();for(const[o,l]of i)this.set(o,l)}}e.LinkedMap=s;class r extends s{constructor(i,o=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,o),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,o=2){return super.get(i,o)}peek(i){return super.get(i,0)}set(i,o){return super.set(i,o,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=r}),define(re[79],se([0,1,34]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.removeAccents=e.normalizeNFD=e.normalizeNFC=void 0;const n=new D.LRUCache(1e4);function k(I){return P(I,"NFC",n)}e.normalizeNFC=k;const L=new D.LRUCache(1e4);function A(I){return P(I,"NFD",L)}e.normalizeNFD=A;const b=/[^\u0000-\u0080]/;function P(I,E,w){if(!I)return I;const v=w.get(I);if(v)return v;let y;return b.test(I)?y=I.normalize(E):y=I,w.set(I,y),y}e.removeAccents=function(){const I=/[\u0300-\u036f]/g;return function(E){return A(E).replace(I,"")}}()}),define(re[80],se([0,1,26]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var n;(function(k){k[k.Ignore=0]="Ignore",k[k.Info=1]="Info",k[k.Warning=2]="Warning",k[k.Error=3]="Error"})(n||(n={})),function(k){const L="error",A="warning",b="warn",P="info",I="ignore";function E(v){return v?D.equalsIgnoreCase(L,v)?k.Error:D.equalsIgnoreCase(A,v)||D.equalsIgnoreCase(b,v)?k.Warning:D.equalsIgnoreCase(P,v)?k.Info:k.Ignore:k.Ignore}k.fromValue=E;function w(v){switch(v){case k.Error:return L;case k.Warning:return A;case k.Info:return P;default:return I}}k.toString=w}(n||(n={})),e.default=n}),define(re[7],se([0,1,10,4]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.uriToFsPath=e.URI=void 0;const k=/^\w[\w\d+.-]*$/,L=/^\//,A=/^\/\//;function b(t,i){if(!t.scheme&&i)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${t.authority}", path: "${t.path}", query: "${t.query}", fragment: "${t.fragment}"}`);if(t.scheme&&!k.test(t.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(t.path){if(t.authority){if(!L.test(t.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(A.test(t.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function P(t,i){return!t&&!i?"file":t}function I(t,i){switch(t){case"https":case"http":case"file":i?i[0]!==w&&(i=w+i):i=w;break}return i}const E="",w="/",v=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class y{constructor(i,o,l,a,h,p=!1){typeof i=="object"?(this.scheme=i.scheme||E,this.authority=i.authority||E,this.path=i.path||E,this.query=i.query||E,this.fragment=i.fragment||E):(this.scheme=P(i,p),this.authority=o||E,this.path=I(this.scheme,l||E),this.query=a||E,this.fragment=h||E,b(this,p))}static isUri(i){return i instanceof y?!0:i?typeof i.authority=="string"&&typeof i.fragment=="string"&&typeof i.path=="string"&&typeof i.query=="string"&&typeof i.scheme=="string"&&typeof i.fsPath=="string"&&typeof i.with=="function"&&typeof i.toString=="function":!1}get fsPath(){return c(this,!1)}with(i){if(!i)return this;let{scheme:o,authority:l,path:a,query:h,fragment:p}=i;return o===void 0?o=this.scheme:o===null&&(o=E),l===void 0?l=this.authority:l===null&&(l=E),a===void 0?a=this.path:a===null&&(a=E),h===void 0?h=this.query:h===null&&(h=E),p===void 0?p=this.fragment:p===null&&(p=E),o===this.scheme&&l===this.authority&&a===this.path&&h===this.query&&p===this.fragment?this:new S(o,l,a,h,p)}static parse(i,o=!1){const l=v.exec(i);return l?new S(l[2]||E,r(l[4]||E),r(l[5]||E),r(l[7]||E),r(l[9]||E),o):new S(E,E,E,E,E)}static file(i){let o=E;if(n.isWindows&&(i=i.replace(/\\/g,w)),i[0]===w&&i[1]===w){const l=i.indexOf(w,2);l===-1?(o=i.substring(2),i=w):(o=i.substring(2,l),i=i.substring(l)||w)}return new S("file",o,i,E,E)}static from(i){const o=new S(i.scheme,i.authority,i.path,i.query,i.fragment);return b(o,!0),o}static joinPath(i,...o){if(!i.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let l;return n.isWindows&&i.scheme==="file"?l=y.file(D.win32.join(c(i,!0),...o)).path:l=D.posix.join(i.path,...o),i.with({path:l})}toString(i=!1){return d(this,i)}toJSON(){return this}static revive(i){if(i){if(i instanceof y)return i;{const o=new S(i);return o._formatted=i.external,o._fsPath=i._sep===f?i.fsPath:null,o}}else return i}}e.URI=y;const f=n.isWindows?1:void 0;class S extends y{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=c(this,!1)),this._fsPath}toString(i=!1){return i?d(this,!0):(this._formatted||(this._formatted=d(this,!1)),this._formatted)}toJSON(){const i={$mid:1};return this._fsPath&&(i.fsPath=this._fsPath,i._sep=f),this._formatted&&(i.external=this._formatted),this.path&&(i.path=this.path),this.scheme&&(i.scheme=this.scheme),this.authority&&(i.authority=this.authority),this.query&&(i.query=this.query),this.fragment&&(i.fragment=this.fragment),i}}const C={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function m(t,i){let o,l=-1;for(let a=0;a<t.length;a++){const h=t.charCodeAt(a);if(h>=97&&h<=122||h>=65&&h<=90||h>=48&&h<=57||h===45||h===46||h===95||h===126||i&&h===47)l!==-1&&(o+=encodeURIComponent(t.substring(l,a)),l=-1),o!==void 0&&(o+=t.charAt(a));else{o===void 0&&(o=t.substr(0,a));const p=C[h];p!==void 0?(l!==-1&&(o+=encodeURIComponent(t.substring(l,a)),l=-1),o+=p):l===-1&&(l=a)}}return l!==-1&&(o+=encodeURIComponent(t.substring(l))),o!==void 0?o:t}function g(t){let i;for(let o=0;o<t.length;o++){const l=t.charCodeAt(o);l===35||l===63?(i===void 0&&(i=t.substr(0,o)),i+=C[l]):i!==void 0&&(i+=t[o])}return i!==void 0?i:t}function c(t,i){let o;return t.authority&&t.path.length>1&&t.scheme==="file"?o=`//${t.authority}${t.path}`:t.path.charCodeAt(0)===47&&(t.path.charCodeAt(1)>=65&&t.path.charCodeAt(1)<=90||t.path.charCodeAt(1)>=97&&t.path.charCodeAt(1)<=122)&&t.path.charCodeAt(2)===58?i?o=t.path.substr(1):o=t.path[1].toLowerCase()+t.path.substr(2):o=t.path,n.isWindows&&(o=o.replace(/\//g,"\\")),o}e.uriToFsPath=c;function d(t,i){const o=i?g:m;let l="",{scheme:a,authority:h,path:p,query:R,fragment:M}=t;if(a&&(l+=a,l+=":"),(h||a==="file")&&(l+=w,l+=w),h){let O=h.indexOf("@");if(O!==-1){const F=h.substr(0,O);h=h.substr(O+1),O=F.indexOf(":"),O===-1?l+=o(F,!1):(l+=o(F.substr(0,O),!1),l+=":",l+=o(F.substr(O+1),!1)),l+="@"}h=h.toLowerCase(),O=h.indexOf(":"),O===-1?l+=o(h,!1):(l+=o(h.substr(0,O),!1),l+=h.substr(O))}if(p){if(p.length>=3&&p.charCodeAt(0)===47&&p.charCodeAt(2)===58){const O=p.charCodeAt(1);O>=65&&O<=90&&(p=`/${String.fromCharCode(O+32)}:${p.substr(3)}`)}else if(p.length>=2&&p.charCodeAt(1)===58){const O=p.charCodeAt(0);O>=65&&O<=90&&(p=`${String.fromCharCode(O+32)}:${p.substr(2)}`)}l+=o(p,!0)}return R&&(l+="?",l+=o(R,!1)),M&&(l+="#",l+=i?M:m(M,!1)),l}function u(t){try{return decodeURIComponent(t)}catch{return t.length>3?t.substr(0,3)+u(t.substr(3)):t}}const s=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function r(t){return t.match(s)?t.replace(s,i=>u(i)):t}}),define(re[126],se([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.log=e.getFirstFrame=e.parse=e.isRemoteConsoleLog=void 0;function n(I){const E=I;return E&&typeof E.type=="string"&&typeof E.severity=="string"}e.isRemoteConsoleLog=n;function k(I){const E=[];let w;try{const v=JSON.parse(I.arguments),y=v[v.length-1];y&&y.__$stack&&(v.pop(),w=y.__$stack),E.push(...v)}catch{E.push("Unable to log remote console arguments",I.arguments)}return{args:E,stack:w}}e.parse=k;function L(I){if(typeof I!="string")return L(k(I).stack);const E=I;if(E){const w=A(E),v=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(w||"");if(v&&v.length===4)return{uri:D.URI.file(v[1]),line:Number(v[2]),column:Number(v[3])}}}e.getFirstFrame=L;function A(I){if(!I)return I;const E=I.indexOf(`
`);return E===-1?I:I.substring(0,E)}function b(I,E){const{args:w,stack:v}=k(I),y=typeof w[0]=="string"&&w.length===1;let f=A(v);f&&(f=`(${f.trim()})`);let S=[];if(typeof w[0]=="string"?f&&y?S=[`%c[${E}] %c${w[0]} %c${f}`,P("blue"),P(""),P("grey")]:S=[`%c[${E}] %c${w[0]}`,P("blue"),P(""),...w.slice(1)]:S=[`%c[${E}]%`,P("blue"),...w],f&&!y&&S.push(f),typeof console[I.severity]!="function")throw new Error("Unknown console method");console[I.severity].apply(console,S)}e.log=b;function P(I){return`color: ${I}`}}),define(re[63],se([0,1,16,26,7]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(I){return JSON.stringify(I,b)}e.stringify=L;function A(I){let E=JSON.parse(I);return E=P(E),E}e.parse=A;function b(I,E){return E instanceof RegExp?{$mid:2,source:E.source,flags:(0,n.regExpFlags)(E)}:E}function P(I,E=0){if(!I||E>200)return I;if(typeof I=="object"){switch(I.$mid){case 1:return k.URI.revive(I);case 2:return new RegExp(I.source,I.flags);case 14:return new Date(I.source)}if(I instanceof D.VSBuffer||I instanceof Uint8Array)return I;if(Array.isArray(I))for(let w=0;w<I.length;++w)I[w]=P(I[w],E+1);else for(const w in I)Object.hasOwnProperty.call(I,w)&&(I[w]=P(I[w],E+1))}return I}e.revive=P}),define(re[20],se([0,1,4,7]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var k;(function(b){b.inMemory="inmemory",b.vscode="vscode",b.internal="private",b.walkThrough="walkThrough",b.walkThroughSnippet="walkThroughSnippet",b.http="http",b.https="https",b.file="file",b.mailto="mailto",b.untitled="untitled",b.data="data",b.command="command",b.vscodeRemote="vscode-remote",b.vscodeRemoteResource="vscode-remote-resource",b.vscodeUserData="vscode-userdata",b.vscodeCustomEditor="vscode-custom-editor",b.vscodeNotebook="vscode-notebook",b.vscodeNotebookCell="vscode-notebook-cell",b.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",b.vscodeNotebookCellOutput="vscode-notebook-cell-output",b.vscodeInteractive="vscode-interactive",b.vscodeInteractiveInput="vscode-interactive-input",b.vscodeSettings="vscode-settings",b.vscodeWorkspaceTrust="vscode-workspace-trust",b.vscodeTerminal="vscode-terminal",b.webviewPanel="webview-panel",b.vscodeWebview="vscode-webview",b.extension="extension",b.vscodeFileResource="vscode-file",b.tmp="tmp",b.vsls="vsls",b.vscodeSourceControl="vscode-scm"})(k=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${k.vscodeRemoteResource}`}setPreferredWebSchema(P){this._preferredWebSchema=P}setDelegate(P){this._delegate=P}setServerRootPath(P){this._remoteResourcesPath=`${P}/${k.vscodeRemoteResource}`}set(P,I,E){this._hosts[P]=I,this._ports[P]=E}setConnectionToken(P,I){this._connectionTokens[P]=I}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(P){if(this._delegate)return this._delegate(P);const I=P.authority;let E=this._hosts[I];E&&E.indexOf(":")!==-1&&(E=`[${E}]`);const w=this._ports[I],v=this._connectionTokens[I];let y=`path=${encodeURIComponent(P.path)}`;return typeof v=="string"&&(y+=`&${e.connectionTokenQueryName}=${encodeURIComponent(v)}`),n.URI.from({scheme:D.isWeb?this._preferredWebSchema:k.vscodeRemoteResource,authority:`${E}:${w}`,path:this._remoteResourcesPath,query:y})}}e.RemoteAuthorities=new L;class A{asBrowserUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeRemote?e.RemoteAuthorities.rewrite(E):E.scheme===k.file&&(D.isNative||D.isWebWorker&&D.globals.origin===`${k.vscodeFileResource}://${A.FALLBACK_AUTHORITY}`)?E.with({scheme:k.vscodeFileResource,authority:E.authority||A.FALLBACK_AUTHORITY,query:null,fragment:null}):E}asFileUri(P,I){const E=this.toUri(P,I);return E.scheme===k.vscodeFileResource?E.with({scheme:k.file,authority:E.authority!==A.FALLBACK_AUTHORITY?E.authority:null,query:null,fragment:null}):E}toUri(P,I){return n.URI.isUri(P)?P:n.URI.parse(I.toUrl(P))}}A.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new A}),define(re[17],se([0,1,47,20,10,4,26,7]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function P(y){return(0,b.uriToFsPath)(y,!0)}e.originalFSPath=P;class I{constructor(f){this._ignorePathCasing=f}compare(f,S,C=!1){return f===S?0:(0,A.compare)(this.getComparisonKey(f,C),this.getComparisonKey(S,C))}isEqual(f,S,C=!1){return f===S?!0:!f||!S?!1:this.getComparisonKey(f,C)===this.getComparisonKey(S,C)}getComparisonKey(f,S=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:S?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,S,C=!1){if(f.scheme===S.scheme){if(f.scheme===n.Schemas.file)return D.isEqualOrParent(P(f),P(S),this._ignorePathCasing(f))&&f.query===S.query&&(C||f.fragment===S.fragment);if((0,e.isEqualAuthority)(f.authority,S.authority))return D.isEqualOrParent(f.path,S.path,this._ignorePathCasing(f),"/")&&f.query===S.query&&(C||f.fragment===S.fragment)}return!1}joinPath(f,...S){return b.URI.joinPath(f,...S)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return k.posix.basename(f.path)}extname(f){return k.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let S;return f.scheme===n.Schemas.file?S=b.URI.file(k.dirname(P(f))).path:(S=k.posix.dirname(f.path),f.authority&&S.length&&S.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),S="/")),f.with({path:S})}normalizePath(f){if(!f.path.length)return f;let S;return f.scheme===n.Schemas.file?S=b.URI.file(k.normalize(P(f))).path:S=k.posix.normalize(f.path),f.with({path:S})}relativePath(f,S){if(f.scheme!==S.scheme||!(0,e.isEqualAuthority)(f.authority,S.authority))return;if(f.scheme===n.Schemas.file){const g=k.relative(P(f),P(S));return L.isWindows?D.toSlashes(g):g}let C=f.path||"/";const m=S.path||"/";if(this._ignorePathCasing(f)){let g=0;for(const c=Math.min(C.length,m.length);g<c&&!(C.charCodeAt(g)!==m.charCodeAt(g)&&C.charAt(g).toLowerCase()!==m.charAt(g).toLowerCase());g++);C=m.substr(0,g)+C.substr(g)}return k.posix.relative(C,m)}resolvePath(f,S){if(f.scheme===n.Schemas.file){const C=b.URI.file(k.resolve(P(f),S));return f.with({authority:C.authority,path:C.path})}return S=D.toPosixPath(S),f.with({path:k.posix.resolve(f.path,S)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,S){return f===S||f!==void 0&&S!==void 0&&(0,A.equalsIgnoreCase)(f,S)}hasTrailingPathSeparator(f,S=k.sep){if(f.scheme===n.Schemas.file){const C=P(f);return C.length>D.getRoot(C).length&&C[C.length-1]===S}else{const C=f.path;return C.length>1&&C.charCodeAt(C.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,S=k.sep){return(0,e.hasTrailingPathSeparator)(f,S)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,S=k.sep){let C=!1;if(f.scheme===n.Schemas.file){const m=P(f);C=m!==void 0&&m.length===D.getRoot(m).length&&m[m.length-1]===S}else{S="/";const m=f.path;C=m.length===1&&m.charCodeAt(m.length-1)===47}return!C&&!(0,e.hasTrailingPathSeparator)(f,S)?f.with({path:f.path+"/"}):f}}e.ExtUri=I,e.extUri=new I(()=>!1),e.extUriBiasedIgnorePathCase=new I(y=>y.scheme===n.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new I(y=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function E(y,f){const S=[];for(let C=0;C<y.length;C++){const m=f(y[C]);y.some((g,c)=>c===C?!1:(0,e.isEqualOrParent)(m,f(g)))||S.push(y[C])}return S}e.distinctParents=E;var w;(function(y){y.META_DATA_LABEL="label",y.META_DATA_DESCRIPTION="description",y.META_DATA_SIZE="size",y.META_DATA_MIME="mime";function f(S){const C=new Map;S.path.substring(S.path.indexOf(";")+1,S.path.lastIndexOf(";")).split(";").forEach(c=>{const[d,u]=c.split(":");d&&u&&C.set(d,u)});const g=S.path.substring(0,S.path.indexOf(";"));return g&&C.set(y.META_DATA_MIME,g),C}y.parseMetaData=f})(w=e.DataUri||(e.DataUri={}));function v(y,f,S){if(f){let C=y.path;return C&&C[0]!==k.posix.sep&&(C=k.posix.sep+C),y.with({scheme:S,authority:f,path:C})}return y.with({scheme:S})}e.toLocalResource=v}),define(re[6],se([0,1,21,9,3,2,17,4]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function P(x){return!!x&&typeof x.then=="function"}e.isThenable=P;function I(x){const _=new D.CancellationTokenSource,U=x(_.token),q=new Promise((j,Z)=>{const oe=_.token.onCancellationRequested(()=>{oe.dispose(),_.dispose(),Z(new n.CancellationError)});Promise.resolve(U).then(Q=>{oe.dispose(),_.dispose(),j(Q)},Q=>{oe.dispose(),_.dispose(),Z(Q)})});return new class{cancel(){_.cancel()}then(j,Z){return q.then(j,Z)}catch(j){return this.then(void 0,j)}finally(j){return q.finally(j)}}}e.createCancelablePromise=I;function E(x,_,U){return new Promise((q,j)=>{const Z=_.onCancellationRequested(()=>{Z.dispose(),q(U)});x.then(q,j).finally(()=>Z.dispose())})}e.raceCancellation=E;function w(x,_){return new Promise((U,q)=>{const j=_.onCancellationRequested(()=>{j.dispose(),q(new n.CancellationError)});x.then(U,q).finally(()=>j.dispose())})}e.raceCancellationError=w;async function v(x){let _=-1;const U=x.map((j,Z)=>j.then(oe=>(_=Z,oe))),q=await Promise.race(U);return x.forEach((j,Z)=>{Z!==_&&j.cancel()}),q}e.raceCancellablePromises=v;function y(x,_,U){let q;const j=setTimeout(()=>{q?.(void 0),U?.()},_);return Promise.race([x.finally(()=>clearTimeout(j)),new Promise(Z=>q=Z)])}e.raceTimeout=y;function f(x){return new Promise((_,U)=>{const q=x();P(q)?q.then(_,U):_(q)})}e.asPromise=f;class S{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(_){if(this.activePromise){if(this.queuedPromiseFactory=_,!this.queuedPromise){const U=()=>{this.queuedPromise=null;const q=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,q};this.queuedPromise=new Promise(q=>{this.activePromise.then(U,U).then(q)})}return new Promise((U,q)=>{this.queuedPromise.then(U,q)})}return this.activePromise=_(),new Promise((U,q)=>{this.activePromise.then(j=>{this.activePromise=null,U(j)},j=>{this.activePromise=null,q(j)})})}}e.Throttler=S;class C{constructor(){this.current=Promise.resolve(null)}queue(_){return this.current=this.current.then(()=>_(),()=>_())}}e.Sequencer=C;class m{constructor(){this.promiseMap=new Map}queue(_,U){const j=(this.promiseMap.get(_)??Promise.resolve()).catch(()=>{}).then(U).finally(()=>{this.promiseMap.get(_)===j&&this.promiseMap.delete(_)});return this.promiseMap.set(_,j),j}}e.SequencerByKey=m;const g=(x,_)=>{let U=!0;const q=setTimeout(()=>{U=!1,_()},x);return{isTriggered:()=>U,dispose:()=>{clearTimeout(q),U=!1}}},c=x=>{let _=!0;return queueMicrotask(()=>{_&&(_=!1,x())}),{isTriggered:()=>_,dispose:()=>{_=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class d{constructor(_){this.defaultDelay=_,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(_,U=this.defaultDelay){this.task=_,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((j,Z)=>{this.doResolve=j,this.doReject=Z}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const j=this.task;return this.task=null,j()}}));const q=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=U===e.MicrotaskDelay?c(q):g(U,q),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new n.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=d;class u{constructor(_){this.delayer=new d(_),this.throttler=new S}trigger(_,U){return this.delayer.trigger(()=>this.throttler.queue(_),U)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=u;class s{constructor(){this._isOpen=!1,this._promise=new Promise((_,U)=>{this._completePromise=_})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class r extends s{constructor(_){super();this._timeout=setTimeout(()=>this.open(),_)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=r;function t(x,_){return _?new Promise((U,q)=>{const j=setTimeout(()=>{Z.dispose(),U()},x),Z=_.onCancellationRequested(()=>{clearTimeout(j),Z.dispose(),q(new n.CancellationError)})}):I(U=>t(x,U))}e.timeout=t;function i(x,_=0){const U=setTimeout(x,_);return(0,L.toDisposable)(()=>clearTimeout(U))}e.disposableTimeout=i;function o(x){const _=[];let U=0;const q=x.length;function j(){return U<q?x[U++]():null}function Z(oe){oe!=null&&_.push(oe);const Q=j();return Q?Q.then(Z):Promise.resolve(_)}return Promise.resolve(null).then(Z)}e.sequence=o;function l(x,_=q=>!!q,U=null){let q=0;const j=x.length,Z=()=>{if(q>=j)return Promise.resolve(U);const oe=x[q++];return Promise.resolve(oe()).then(te=>_(te)?Promise.resolve(te):Z())};return Z()}e.first=l;function a(x,_=q=>!!q,U=null){if(x.length===0)return Promise.resolve(U);let q=x.length;const j=()=>{q=-1;for(const Z of x)Z.cancel?.()};return new Promise((Z,oe)=>{for(const Q of x)Q.then(te=>{--q>=0&&_(te)?(j(),Z(te)):q===0&&Z(U)}).catch(te=>{--q>=0&&(j(),oe(te))})})}e.firstParallel=a;class h{constructor(_){this._size=0,this.maxDegreeOfParalellism=_,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new k.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(_){return this._size++,new Promise((U,q)=>{this.outstandingPromises.push({factory:_,c:U,e:q}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const _=this.outstandingPromises.shift();this.runningPromises++;const U=_.factory();U.then(_.c,_.e),U.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=h;class p extends h{constructor(){super(1)}}e.Queue=p;class R{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const _=new H;return this.drainers.add(_),_.p}isDrained(){for(const[,_]of this.queues)if(_.size>0)return!1;return!0}queueFor(_,U=A.extUri){const q=U.getComparisonKey(_);let j=this.queues.get(q);return j||(j=new p,k.Event.once(j.onDrained)(()=>{j?.dispose(),this.queues.delete(q),this.onDidQueueDrain()}),this.queues.set(q,j)),j}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const _ of this.drainers)_.complete();this.drainers.clear()}dispose(){for(const[,_]of this.queues)_.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=R;class M{constructor(_,U){this._token=-1,typeof _=="function"&&typeof U=="number"&&this.setIfNotSet(_,U)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setTimeout(()=>{this._token=-1,_()},U)}setIfNotSet(_,U){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,_()},U))}}e.TimeoutTimer=M;class O{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(_,U){this.cancel(),this._token=setInterval(()=>{_()},U)}}e.IntervalTimer=O;class F{constructor(_,U){this.timeoutToken=-1,this.runner=_,this.timeout=U,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(_=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,_)}get delay(){return this.timeout}set delay(_){this.timeout=_}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=F;class T{constructor(_,U){U%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${U}ms is not a multiple of 1000ms.`),this.runner=_,this.timeout=U,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(_=this.timeout){_%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${_}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(_/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=T;class N extends F{constructor(_,U){super(_,U);this.units=[]}work(_){this.units.push(_),this.isScheduled()||this.schedule()}doRun(){const _=this.units;this.units=[],this.runner?.(_)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=N;class W extends L.Disposable{constructor(_,U){super();this.options=_,this.handler=U,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(_){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+_.length>this.options.maxBufferedWork)return!1}else if(this.pending+_.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(..._),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new F(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=W,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=x=>{(0,b.setTimeout0)(()=>{if(_)return;const U=Date.now()+15;x(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,U-Date.now())}}))});let _=!1;return{dispose(){_||(_=!0)}}}:e.runWhenIdle=(x,_)=>{const U=requestIdleCallback(x,typeof _=="number"?{timeout:_}:void 0);let q=!1;return{dispose(){q||(q=!0,cancelIdleCallback(U))}}}}();class V{constructor(_){this._didRun=!1,this._executor=()=>{try{this._value=_()}catch(U){this._error=U}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=V;async function Y(x,_,U){let q;for(let j=0;j<U;j++)try{return await x()}catch(Z){q=Z,await t(_)}throw q}e.retry=Y;class ${hasPending(_){return this._pending?typeof _=="number"?this._pending.taskId===_:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(_,U,q){return this._pending={taskId:_,cancel:()=>q?.(),promise:U},U.then(()=>this.donePending(_),()=>this.donePending(_)),U}donePending(_){this._pending&&_===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const _=this._next;this._next=void 0,_.run().then(_.promiseResolve,_.promiseReject)}}setNext(_){if(this._next)this._next.run=_;else{let U,q;const j=new Promise((Z,oe)=>{U=Z,q=oe});this._next={run:_,promise:j,promiseResolve:U,promiseReject:q}}return this._next.promise}}e.TaskSequentializer=$;class J{constructor(_,U=()=>Date.now()){this.interval=_,this.nowFn=U,this.lastIncrementTime=0,this.value=0}increment(){const _=this.nowFn();return _-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=_,this.value=0),this.value++,this.value}}e.IntervalCounter=J;class H{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((_,U)=>{this.completeCallback=_,this.errorCallback=U})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(_){return new Promise(U=>{this.completeCallback(_),this.resolved=!0,U()})}error(_){return new Promise(U=>{this.errorCallback(_),this.rejected=!0,U()})}cancel(){new Promise(_=>{this.errorCallback(new n.CancellationError),this.rejected=!0,_()})}}e.DeferredPromise=H;var B;(function(x){async function _(q){let j;const Z=await Promise.all(q.map(oe=>oe.then(Q=>Q,Q=>{j||(j=Q)})));if(typeof j!="undefined")throw j;return Z}x.settled=_;function U(q){return new Promise(async(j,Z)=>{try{await q(j,Z)}catch(oe){Z(oe)}})}x.withAsyncBody=U})(B=e.Promises||(e.Promises={}));var K;(function(x){x[x.Initial=0]="Initial",x[x.DoneOK=1]="DoneOK",x[x.DoneError=2]="DoneError"})(K||(K={}));class ie{constructor(_){this._state=0,this._results=[],this._error=null,this._onStateChanged=new k.Emitter,queueMicrotask(async()=>{const U={emitOne:q=>this.emitOne(q),emitMany:q=>this.emitMany(q),reject:q=>this.reject(q)};try{await Promise.resolve(_(U)),this.resolve()}catch(q){this.reject(q)}finally{U.emitOne=void 0,U.emitMany=void 0,U.reject=void 0}})}static fromArray(_){return new ie(U=>{U.emitMany(_)})}static fromPromise(_){return new ie(async U=>{U.emitMany(await _)})}static fromPromises(_){return new ie(async U=>{await Promise.all(_.map(async q=>U.emitOne(await q)))})}static merge(_){return new ie(async U=>{await Promise.all(_.map(async q=>{for await(const j of q)U.emitOne(j)}))})}[Symbol.asyncIterator](){let _=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(_<this._results.length)return{done:!1,value:this._results[_++]};if(this._state===1)return{done:!0,value:void 0};await k.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(_,U){return new ie(async q=>{for await(const j of _)q.emitOne(U(j))})}map(_){return ie.map(this,_)}static filter(_,U){return new ie(async q=>{for await(const j of _)U(j)&&q.emitOne(j)})}filter(_){return ie.filter(this,_)}static coalesce(_){return ie.filter(_,U=>!!U)}coalesce(){return ie.coalesce(this)}static async toPromise(_){const U=[];for await(const q of _)U.push(q);return U}toPromise(){return ie.toPromise(this)}emitOne(_){this._state===0&&(this._results.push(_),this._onStateChanged.fire())}emitMany(_){this._state===0&&(this._results=this._results.concat(_),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(_){this._state===0&&(this._state=2,this._error=_,this._onStateChanged.fire())}}e.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class ce extends ie{constructor(_,U){super(U);this._source=_}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ce;function z(x){const _=new D.CancellationTokenSource,U=x(_.token);return new ce(_,async q=>{const j=_.token.onCancellationRequested(()=>{j.dispose(),_.dispose(),q.reject(new n.CancellationError)});try{for await(const Z of U){if(_.token.isCancellationRequested)return;q.emitOne(Z)}j.dispose(),_.dispose()}catch(Z){j.dispose(),_.dispose(),q.reject(Z)}})}e.createCancelableAsyncIterable=z}),define(re[81],se([0,1,18,6,47,34,10,4,26]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function I(){return Object.create(null)}e.getEmptyExpression=I,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const E="[/\\\\]",w="[^/\\\\]",v=/\//g;function y(H,B){switch(H){case 0:return"";case 1:return`${w}*?`;default:return`(?:${E}|${w}+${E}${B?`|${E}${w}+`:""})*?`}}function f(H,B){if(!H)return[];const K=[];let ie=!1,ce=!1,z="";for(const x of H){switch(x){case B:if(!ie&&!ce){K.push(z),z="";continue}break;case"{":ie=!0;break;case"}":ie=!1;break;case"[":ce=!0;break;case"]":ce=!1;break}z+=x}return z&&K.push(z),K}e.splitGlobAware=f;function S(H){if(!H)return"";let B="";const K=f(H,e.GLOB_SPLIT);if(K.every(ie=>ie===e.GLOBSTAR))B=".*";else{let ie=!1;K.forEach((ce,z)=>{if(ce===e.GLOBSTAR){if(ie)return;B+=y(2,z===K.length-1)}else{let x=!1,_="",U=!1,q="";for(const j of ce){if(j!=="}"&&x){_+=j;continue}if(U&&(j!=="]"||!q)){let Z;j==="-"?Z=j:(j==="^"||j==="!")&&!q?Z="^":j===e.GLOB_SPLIT?Z="":Z=(0,P.escapeRegExpCharacters)(j),q+=Z;continue}switch(j){case"{":x=!0;continue;case"[":U=!0;continue;case"}":{B+=`(?:${f(_,",").map(Q=>S(Q)).join("|")})`,x=!1,_="";break}case"]":{B+="["+q+"]",U=!1,q="";break}case"?":B+=w;continue;case"*":B+=y(1);continue;default:B+=(0,P.escapeRegExpCharacters)(j)}}z<K.length-1&&(K[z+1]!==e.GLOBSTAR||z+2<K.length)&&(B+=E)}ie=ce===e.GLOBSTAR})}return B}const C=/^\*\*\/\*\.[\w\.-]+$/,m=/^\*\*\/([\w\.-]+)\/?$/,g=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,c=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,d=/^\*\*((\/[\w\.-]+)+)\/?$/,u=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.LRUCache(1e4),r=function(){return!1},t=function(){return null};function i(H,B){if(!H)return t;let K;typeof H!="string"?K=H.pattern:K=H,K=K.trim();const ie=`${K}_${!!B.trimForExclusions}`;let ce=s.get(ie);if(ce)return o(ce,H);let z;return C.test(K)?ce=a(K.substr(4),K):(z=m.exec(l(K,B)))?ce=h(z[1],K):(B.trimForExclusions?c:g).test(K)?ce=p(K,B):(z=d.exec(l(K,B)))?ce=R(z[1].substr(1),K,!0):(z=u.exec(l(K,B)))?ce=R(z[1],K,!1):ce=M(K),s.set(ie,ce),o(ce,H)}function o(H,B){if(typeof B=="string")return H;const K=function(ie,ce){return(0,k.isEqualOrParent)(ie,B.base,!b.isLinux)?H(ie.substr(B.base.length+1),ce):null};return K.allBasenames=H.allBasenames,K.allPaths=H.allPaths,K.basenames=H.basenames,K.patterns=H.patterns,K}function l(H,B){return B.trimForExclusions&&H.endsWith("/**")?H.substr(0,H.length-2):H}function a(H,B){return function(K,ie){return typeof K=="string"&&K.endsWith(H)?B:null}}function h(H,B){const K=`/${H}`,ie=`\\${H}`,ce=function(x,_){return typeof x!="string"?null:_?_===H?B:null:x===H||x.endsWith(K)||x.endsWith(ie)?B:null},z=[H];return ce.basenames=z,ce.patterns=[B],ce.allBasenames=z,ce}function p(H,B){const K=$(H.slice(1,-1).split(",").map(_=>i(_,B)).filter(_=>_!==t),H),ie=K.length;if(!ie)return t;if(ie===1)return K[0];const ce=function(_,U){for(let q=0,j=K.length;q<j;q++)if(K[q](_,U))return H;return null},z=K.find(_=>!!_.allBasenames);z&&(ce.allBasenames=z.allBasenames);const x=K.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return x.length&&(ce.allPaths=x),ce}function R(H,B,K){const ie=A.sep===A.posix.sep,ce=ie?H:H.replace(v,A.sep),z=A.sep+ce,x=A.posix.sep+H;let _;return K?_=function(U,q){return typeof U=="string"&&(U===ce||U.endsWith(z)||!ie&&(U===H||U.endsWith(x)))?B:null}:_=function(U,q){return typeof U=="string"&&(U===ce||!ie&&U===H)?B:null},_.allPaths=[(K?"*/":"./")+H],_}function M(H){try{const B=new RegExp(`^${S(H)}$`);return function(K){return B.lastIndex=0,typeof K=="string"&&B.test(K)?H:null}}catch{return t}}function O(H,B,K){return!H||typeof B!="string"?!1:F(H)(B,void 0,K)}e.match=O;function F(H,B={}){if(!H)return r;if(typeof H=="string"||T(H)){const K=i(H,B);if(K===t)return r;const ie=function(ce,z){return!!K(ce,z)};return K.allBasenames&&(ie.allBasenames=K.allBasenames),K.allPaths&&(ie.allPaths=K.allPaths),ie}return V(H,B)}e.parse=F;function T(H){const B=H;return B?typeof B.base=="string"&&typeof B.pattern=="string":!1}e.isRelativePattern=T;function N(H){return H.allBasenames||[]}e.getBasenameTerms=N;function W(H){return H.allPaths||[]}e.getPathTerms=W;function V(H,B){const K=$(Object.getOwnPropertyNames(H).map(_=>Y(_,H[_],B)).filter(_=>_!==t)),ie=K.length;if(!ie)return t;if(!K.some(_=>!!_.requiresSiblings)){if(ie===1)return K[0];const _=function(j,Z){let oe;for(let Q=0,te=K.length;Q<te;Q++){const ne=K[Q](j,Z);if(typeof ne=="string")return ne;(0,n.isThenable)(ne)&&(oe||(oe=[]),oe.push(ne))}return oe?(async()=>{for(const Q of oe){const te=await Q;if(typeof te=="string")return te}return null})():null},U=K.find(j=>!!j.allBasenames);U&&(_.allBasenames=U.allBasenames);const q=K.reduce((j,Z)=>Z.allPaths?j.concat(Z.allPaths):j,[]);return q.length&&(_.allPaths=q),_}const ce=function(_,U,q){let j,Z;for(let oe=0,Q=K.length;oe<Q;oe++){const te=K[oe];te.requiresSiblings&&q&&(U||(U=(0,A.basename)(_)),j||(j=U.substr(0,U.length-(0,A.extname)(_).length)));const ne=te(_,U,j,q);if(typeof ne=="string")return ne;(0,n.isThenable)(ne)&&(Z||(Z=[]),Z.push(ne))}return Z?(async()=>{for(const oe of Z){const Q=await oe;if(typeof Q=="string")return Q}return null})():null},z=K.find(_=>!!_.allBasenames);z&&(ce.allBasenames=z.allBasenames);const x=K.reduce((_,U)=>U.allPaths?_.concat(U.allPaths):_,[]);return x.length&&(ce.allPaths=x),ce}function Y(H,B,K){if(B===!1)return t;const ie=i(H,K);if(ie===t)return t;if(typeof B=="boolean")return ie;if(B){const ce=B.when;if(typeof ce=="string"){const z=(x,_,U,q)=>{if(!q||!ie(x,_))return null;const j=ce.replace("$(basename)",U),Z=q(j);return(0,n.isThenable)(Z)?Z.then(oe=>oe?H:null):Z?H:null};return z.requiresSiblings=!0,z}}return ie}function $(H,B){const K=H.filter(_=>!!_.basenames);if(K.length<2)return H;const ie=K.reduce((_,U)=>{const q=U.basenames;return q?_.concat(q):_},[]);let ce;if(B){ce=[];for(let _=0,U=ie.length;_<U;_++)ce.push(B)}else ce=K.reduce((_,U)=>{const q=U.patterns;return q?_.concat(q):_},[]);const z=function(_,U){if(typeof _!="string")return null;if(!U){let j;for(j=_.length;j>0;j--){const Z=_.charCodeAt(j-1);if(Z===47||Z===92)break}U=_.substr(j)}const q=ie.indexOf(U);return q!==-1?ce[q]:null};z.basenames=ie,z.patterns=ce,z.allBasenames=ie;const x=H.filter(_=>!_.basenames);return x.push(z),x}function J(H,B){return(0,D.equals)(H,B,(K,ie)=>typeof K=="string"&&typeof ie=="string"?K===ie:typeof K!="string"&&typeof ie!="string"?K.base===ie.base&&K.pattern===ie.pattern:!1)}e.patternsEquals=J}),define(re[127],se([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function n(E){return E.toJSON()}class k{constructor(w){this._uriTransformer=w}transformIncoming(w){const v=this._uriTransformer.transformIncoming(w);return v===w?w:n(D.URI.from(v))}transformOutgoing(w){const v=this._uriTransformer.transformOutgoing(w);return v===w?w:n(D.URI.from(v))}transformOutgoingURI(w){const v=this._uriTransformer.transformOutgoing(w);return v===w?w:D.URI.from(v)}transformOutgoingScheme(w){return this._uriTransformer.transformOutgoingScheme(w)}}e.URITransformer=k,e.DefaultURITransformer=new class{transformIncoming(E){return E}transformOutgoing(E){return E}transformOutgoingURI(E){return E}transformOutgoingScheme(E){return E}};function L(E,w,v){if(!E||v>200)return null;if(typeof E=="object"){if(E instanceof D.URI)return w.transformOutgoing(E);for(const y in E)if(Object.hasOwnProperty.call(E,y)){const f=L(E[y],w,v+1);f!==null&&(E[y]=f)}}return null}function A(E,w){const v=L(E,w,0);return v===null?E:v}e.transformOutgoingURIs=A;function b(E,w,v,y){if(!E||y>200)return null;if(typeof E=="object"){if(E.$mid===1)return v?D.URI.revive(w.transformIncoming(E)):w.transformIncoming(E);for(const f in E)if(Object.hasOwnProperty.call(E,f)){const S=b(E[f],w,v,y+1);S!==null&&(E[f]=S)}}return null}function P(E,w){const v=b(E,w,!1,0);return v===null?E:v}e.transformIncomingURIs=P;function I(E,w){const v=b(E,w,!0,0);return v===null?E:v}e.transformAndReviveIncomingURIs=I}),define(re[128],se([0,1,37,9,34,30,114]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getMachineId=e.virtualMachineHint=void 0,e.virtualMachineHint=new class{_isVirtualMachineMacAddress(E){return this._virtualMachineOUIs||(this._virtualMachineOUIs=k.TernarySearchTree.forStrings(),this._virtualMachineOUIs.set("00-50-56",!0),this._virtualMachineOUIs.set("00-0C-29",!0),this._virtualMachineOUIs.set("00-05-69",!0),this._virtualMachineOUIs.set("00-03-FF",!0),this._virtualMachineOUIs.set("00-1C-42",!0),this._virtualMachineOUIs.set("00-16-3E",!0),this._virtualMachineOUIs.set("08-00-27",!0),this._virtualMachineOUIs.set("00:50:56",!0),this._virtualMachineOUIs.set("00:0C:29",!0),this._virtualMachineOUIs.set("00:05:69",!0),this._virtualMachineOUIs.set("00:03:FF",!0),this._virtualMachineOUIs.set("00:1C:42",!0),this._virtualMachineOUIs.set("00:16:3E",!0),this._virtualMachineOUIs.set("08:00:27",!0)),!!this._virtualMachineOUIs.findSubstr(E)}value(){if(this._value===void 0){let E=0,w=0;const v=(0,D.networkInterfaces)();for(const y in v){const f=v[y];if(f)for(const{mac:S,internal:C}of f)C||(w+=1,this._isVirtualMachineMacAddress(S.toUpperCase())&&(E+=1))}this._value=w>0?E/w:0}return this._value}};let b;async function P(){return b||(b=(async()=>await I()||L.generateUuid())()),b}e.getMachineId=P;async function I(){try{const E=await new Promise((v,y)=>{X(["crypto"],v,y)}),w=(0,A.getMac)();return E.createHash("sha256").update(w,"utf8").digest("hex")}catch(E){n.onUnexpectedError(E);return}}}),define(re[27],se([0,1,53,37,267,6,47,79,10,4,17,7]),function(X,e,D,n,k,L,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Promises=e.writeFileSync=e.configureFlushOnWrite=e.SymlinkSupport=e.whenDeleted=e.readdirSync=e.rimrafSync=e.RimRafMode=void 0;var v;(function(V){V[V.UNLINK=0]="UNLINK",V[V.MOVE=1]="MOVE"})(v=e.RimRafMode||(e.RimRafMode={}));async function y(V,Y=v.UNLINK){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");return Y===v.UNLINK?S(V):f(V)}async function f(V){try{const Y=(0,A.randomPath)((0,n.tmpdir)());try{await D.promises.rename(V,Y)}catch{return S(V)}S(Y).catch($=>{})}catch(Y){if(Y.code!=="ENOENT")throw Y}}async function S(V){return(0,k.promisify)(D.rm)(V,{recursive:!0,force:!0,maxRetries:3})}function C(V){if((0,A.isRootOrDriveLetter)(V))throw new Error("rimraf - will refuse to recursively delete root");D.rmSync(V,{recursive:!0,force:!0,maxRetries:3})}e.rimrafSync=C;async function m(V,Y){return d(await(Y?g(V):(0,k.promisify)(D.readdir)(V)))}async function g(V){try{return await(0,k.promisify)(D.readdir)(V,{withFileTypes:!0})}catch(J){console.warn("[node.js fs] readdir with filetypes failed with error: ",J)}const Y=[],$=await m(V);for(const J of $){let H=!1,B=!1,K=!1;try{const ie=await e.Promises.lstat((0,P.join)(V,J));H=ie.isFile(),B=ie.isDirectory(),K=ie.isSymbolicLink()}catch(ie){console.warn("[node.js fs] unexpected error from lstat after readdir: ",ie)}Y.push({name:J,isFile:()=>H,isDirectory:()=>B,isSymbolicLink:()=>K})}return Y}function c(V){return d(D.readdirSync(V))}e.readdirSync=c;function d(V){return V.map(Y=>typeof Y=="string"?I.isMacintosh?(0,b.normalizeNFC)(Y):Y:(Y.name=I.isMacintosh?(0,b.normalizeNFC)(Y.name):Y.name,Y))}async function u(V){const Y=await m(V),$=[];for(const J of Y)await r.existsDirectory((0,P.join)(V,J))&&$.push(J);return $}function s(V,Y=1e3){return new Promise($=>{let J=!1;const H=setInterval(()=>{J||(J=!0,D.access(V,B=>{J=!1,B&&(clearInterval(H),$(void 0))}))},Y)})}e.whenDeleted=s;var r;(function(V){async function Y(H){let B;try{if(B=await e.Promises.lstat(H),!B.isSymbolicLink())return{stat:B}}catch{}try{return{stat:await e.Promises.stat(H),symbolicLink:B?.isSymbolicLink()?{dangling:!1}:void 0}}catch(K){if(K.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};if(I.isWindows&&K.code==="EACCES")try{return{stat:await e.Promises.stat(await e.Promises.readlink(H)),symbolicLink:{dangling:!1}}}catch(ie){if(ie.code==="ENOENT"&&B)return{stat:B,symbolicLink:{dangling:!0}};throw ie}throw K}}V.stat=Y;async function $(H){try{const{stat:B,symbolicLink:K}=await V.stat(H);return B.isFile()&&K?.dangling!==!0}catch{}return!1}V.existsFile=$;async function J(H){try{const{stat:B,symbolicLink:K}=await V.stat(H);return B.isDirectory()&&K?.dangling!==!0}catch{}return!1}V.existsDirectory=J})(r=e.SymlinkSupport||(e.SymlinkSupport={}));const t=new L.ResourceQueue;function i(V,Y,$){return t.queueFor(w.URI.file(V),E.extUriBiasedIgnorePathCase).queue(()=>{const J=p($);return new Promise((H,B)=>a(V,Y,J,K=>K?B(K):H()))})}let o=!0;function l(V){o=V}e.configureFlushOnWrite=l;function a(V,Y,$,J){if(!o)return D.writeFile(V,Y,{mode:$.mode,flag:$.flag},J);D.open(V,$.flag,$.mode,(H,B)=>{if(H)return J(H);D.writeFile(B,Y,K=>{if(K)return D.close(B,()=>J(K));D.fdatasync(B,ie=>(ie&&(console.warn("[node.js fs] fdatasync is now disabled for this session because it failed: ",ie),l(!1)),D.close(B,ce=>J(ce))))})})}function h(V,Y,$){const J=p($);if(!o)return D.writeFileSync(V,Y,{mode:J.mode,flag:J.flag});const H=D.openSync(V,J.flag,J.mode);try{D.writeFileSync(H,Y);try{D.fdatasyncSync(H)}catch(B){console.warn("[node.js fs] fdatasyncSync is now disabled for this session because it failed: ",B),l(!1)}}finally{D.closeSync(H)}}e.writeFileSync=h;function p(V){return V?{mode:typeof V.mode=="number"?V.mode:438,flag:typeof V.flag=="string"?V.flag:"w"}:{mode:438,flag:"w"}}async function R(V,Y){if(V!==Y)try{await e.Promises.rename(V,Y)}catch($){if(V.toLowerCase()!==Y.toLowerCase()&&$.code==="EXDEV"||V.endsWith("."))await M(V,Y,{preserveSymlinks:!1}),await y(V,v.MOVE);else throw $}}async function M(V,Y,$){return F(V,Y,{root:{source:V,target:Y},options:$,handledSourcePaths:new Set})}const O=511;async function F(V,Y,$){if($.handledSourcePaths.has(V))return;$.handledSourcePaths.add(V);const{stat:J,symbolicLink:H}=await r.stat(V);if(H){if($.options.preserveSymlinks)try{return await W(V,Y,$)}catch(B){console.warn("[node.js fs] copy of symlink failed: ",B)}if(H.dangling)return}return J.isDirectory()?T(V,Y,J.mode&O,$):N(V,Y,J.mode&O)}async function T(V,Y,$,J){await e.Promises.mkdir(Y,{recursive:!0,mode:$});const H=await m(V);for(const B of H)await F((0,P.join)(V,B),(0,P.join)(Y,B),J)}async function N(V,Y,$){await e.Promises.copyFile(V,Y),await e.Promises.chmod(Y,$)}async function W(V,Y,$){let J=await e.Promises.readlink(V);(0,A.isEqualOrParent)(J,$.root.source,!I.isLinux)&&(J=(0,P.join)($.root.target,J.substr($.root.source.length+1))),await e.Promises.symlink(J,Y)}e.Promises=new class{get access(){return(0,k.promisify)(D.access)}get stat(){return(0,k.promisify)(D.stat)}get lstat(){return(0,k.promisify)(D.lstat)}get utimes(){return(0,k.promisify)(D.utimes)}get read(){return(V,Y,$,J,H)=>new Promise((B,K)=>{D.read(V,Y,$,J,H,(ie,ce,z)=>ie?K(ie):B({bytesRead:ce,buffer:z}))})}get readFile(){return(0,k.promisify)(D.readFile)}get write(){return(V,Y,$,J,H)=>new Promise((B,K)=>{D.write(V,Y,$,J,H,(ie,ce,z)=>ie?K(ie):B({bytesWritten:ce,buffer:z}))})}get appendFile(){return(0,k.promisify)(D.appendFile)}get fdatasync(){return(0,k.promisify)(D.fdatasync)}get truncate(){return(0,k.promisify)(D.truncate)}get rename(){return(0,k.promisify)(D.rename)}get copyFile(){return(0,k.promisify)(D.copyFile)}get open(){return(0,k.promisify)(D.open)}get close(){return(0,k.promisify)(D.close)}get symlink(){return(0,k.promisify)(D.symlink)}get readlink(){return(0,k.promisify)(D.readlink)}get chmod(){return(0,k.promisify)(D.chmod)}get mkdir(){return(0,k.promisify)(D.mkdir)}get unlink(){return(0,k.promisify)(D.unlink)}get rmdir(){return(0,k.promisify)(D.rmdir)}get realpath(){return(0,k.promisify)(D.realpath)}async exists(V){try{return await e.Promises.access(V),!0}catch{return!1}}get readdir(){return m}get readDirsInDir(){return u}get writeFile(){return i}get rm(){return y}get move(){return R}get copy(){return M}}}),define(re[129],se([0,1,53,10,4,26,27]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.realpathSync=e.realpath=e.realcase=e.realcaseSync=void 0;function b(v){if(k.isLinux)return v;const y=(0,n.dirname)(v);if(v===y)return v;const f=((0,n.basename)(v)||v).toLowerCase();try{const C=(0,A.readdirSync)(y).filter(m=>m.toLowerCase()===f);if(C.length===1){const m=b(y);if(m)return(0,n.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(f);if(m>=0){const g=b(y);if(g)return(0,n.join)(g,C[m])}}}catch{}return null}e.realcaseSync=b;async function P(v){if(k.isLinux)return v;const y=(0,n.dirname)(v);if(v===y)return v;const f=((0,n.basename)(v)||v).toLowerCase();try{const C=(await A.Promises.readdir(y)).filter(m=>m.toLowerCase()===f);if(C.length===1){const m=await P(y);if(m)return(0,n.join)(m,C[0])}else if(C.length>1){const m=C.indexOf(f);if(m>=0){const g=await P(y);if(g)return(0,n.join)(g,C[m])}}}catch{}return null}e.realcase=P;async function I(v){try{return await A.Promises.realpath(v)}catch{const f=w(v);return await A.Promises.access(f,D.constants.R_OK),f}}e.realpath=I;function E(v){try{return D.realpathSync(v)}catch{const f=w(v);return D.accessSync(f,D.constants.R_OK),f}}e.realpathSync=E;function w(v){return(0,L.rtrim)((0,n.normalize)(v),n.sep)}}),define(re[82],se([0,1,37,10,27]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getFirstAvailablePowerShellInstallation=e.enumeratePowerShellInstallations=void 0;const L=/^\d+$/,A=/^Microsoft.PowerShell_.*/,b=/^Microsoft.PowerShellPreview_.*/;var P;(function(d){d[d.x64=0]="x64",d[d.x86=1]="x86",d[d.ARM=2]="ARM"})(P||(P={}));let I;switch(process.arch){case"ia32":case"x32":I=1;break;case"arm":case"arm64":I=2;break;default:I=0;break}let E;process.env.PROCESSOR_ARCHITEW6432?E=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?E=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?E=1:E=0;class w{constructor(u,s,r){this.exePath=u,this.displayName=s,this.knownToExist=r}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await k.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function v({useAlternateBitness:d=!1}={}){return d?I===0?process.env["ProgramFiles(x86)"]||null:E===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function y({useAlternateBitness:d=!1,findPreview:u=!1}={}){const s=v({useAlternateBitness:d});if(!s)return null;const r=n.join(s,"PowerShell");if(!await k.SymlinkSupport.existsDirectory(r))return null;let t=-1,i=null;for(const a of await k.Promises.readdir(r)){let h=-1;if(u){const R=a.indexOf("-");if(R<0)continue;const M=a.substring(0,R);if(!L.test(M)||a.substring(R+1)!=="preview")continue;h=parseInt(M,10)}else{if(!L.test(a))continue;h=parseInt(a,10)}if(h<=t)continue;const p=n.join(r,a,"pwsh.exe");!await k.SymlinkSupport.existsFile(p)||(i=p,t=h)}if(!i)return null;const o=s.includes("x86")?" (x86)":"",l=u?" Preview":"";return new w(i,`PowerShell${l}${o}`,!0)}async function f({findPreview:d}={}){if(!process.env.LOCALAPPDATA)return null;const u=n.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await k.SymlinkSupport.existsDirectory(u))return null;const{pwshMsixDirRegex:s,pwshMsixName:r}=d?{pwshMsixDirRegex:b,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const t of await k.Promises.readdir(u))if(s.test(t)){const i=n.join(u,t,"pwsh.exe");return new w(i,r)}return null}function S(){const d=n.join(D.homedir(),".dotnet","tools","pwsh.exe");return new w(d,".NET Core PowerShell Global Tool")}function C(){const d=n.join(process.env.windir,I===1&&E!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new w(d,"Windows PowerShell",!0)}async function*m(){let d=await y();d&&(yield d),d=await y({useAlternateBitness:!0}),d&&(yield d),d=await f(),d&&(yield d),d=S(),d&&(yield d),d=await y({findPreview:!0}),d&&(yield d),d=await f({findPreview:!0}),d&&(yield d),d=await y({useAlternateBitness:!0,findPreview:!0}),d&&(yield d),d=C(),d&&(yield d)}async function*g(){for await(const d of m())await d.exists()&&(yield d)}e.enumeratePowerShellInstallations=g;async function c(){for await(const d of g())return d;return null}e.getFirstAvailablePowerShellInstallation=c}),define(re[83],se([0,1,10,4,36,77,15,27]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.win32=e.createQueuedSender=e.getWindowsShell=e.TerminateResponseCode=e.Source=void 0,Object.defineProperty(e,"Source",{enumerable:!0,get:function(){return L.Source}}),Object.defineProperty(e,"TerminateResponseCode",{enumerable:!0,get:function(){return L.TerminateResponseCode}});function P(w=k.env){return w.comspec||"cmd.exe"}e.getWindowsShell=P;function I(w){let v=[],y=!1;const f=function(S){if(y){v.push(S);return}(!w.send(S,m=>{if(m&&console.error(m),y=!1,v.length>0){const g=v.slice(0);v=[],g.forEach(c=>f(c))}})||n.isWindows)&&(y=!0)};return{send:f}}e.createQueuedSender=I;var E;(function(w){async function v(y,f,S){if(D.isAbsolute(y))return y;if(f===void 0&&(f=k.cwd()),D.dirname(y)!=="."||(S===void 0&&A.isString(k.env.PATH)&&(S=k.env.PATH.split(D.delimiter)),S===void 0||S.length===0))return D.join(f,y);async function m(g){if(await b.Promises.exists(g)){let c;try{c=await b.Promises.stat(g)}catch(d){d.message.startsWith("EACCES")&&(c=await b.Promises.lstat(g))}return c?!c.isDirectory():!1}return!1}for(const g of S){let c;if(D.isAbsolute(g)?c=D.join(g,y):c=D.join(f,g,y),await m(c))return c;let d=c+".com";if(await m(d)||(d=c+".exe",await m(d)))return d}return D.join(f,y)}w.findExecutable=v})(E=e.win32||(e.win32={}))}),define(re[130],se([0,1,54,20]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.listProcesses=void 0;function k(A){return new Promise((b,P)=>{let I;const E=new Map;function w(y,f,S,C,m){const g=E.get(f);if(y===A||g){const c={name:v(S),cmd:S,pid:y,ppid:f,load:C,mem:m};E.set(y,c),y===A&&(I=c),g&&(g.children||(g.children=[]),g.children.push(c),g.children.length>1&&(g.children=g.children.sort((d,u)=>d.pid-u.pid)))}}function v(y){const f=/--vscode-window-kind=shared-process/,S=/--vscode-window-kind=issue-reporter/,C=/--vscode-window-kind=process-explorer/,m=/--utility-sub-type=network/,g=/--utility-sub-type=node.mojom.NodeService/,c=/--crashes-directory/,d=/\\pipe\\winpty-control/,u=/conhost\.exe/,s=/--type=([a-zA-Z-]+)/;if(c.exec(y))return"electron-crash-reporter";if(d.exec(y))return"winpty-process";if(u.exec(y))return"console-window-host (Windows internal process)";let r=s.exec(y);if(r&&r.length===2){if(r[1]==="renderer")return f.exec(y)?"shared-process":S.exec(y)?"issue-reporter":C.exec(y)?"process-explorer":"window";if(r[1]==="utility"){if(m.exec(y))return"utility-network-service";if(g.exec(y))return"extension-host"}return r[1]}const t=/[a-zA-Z-]+\.js/g;let i="";do r=t.exec(y),r&&(i+=r+" ");while(r);return i&&y.indexOf("node ")<0&&y.indexOf("node.exe")<0?`electron_node ${i}`:y}if(process.platform==="win32"){const y=f=>f.indexOf("\\\\?\\")===0||f.indexOf("\\??\\")===0?f.substr(4):f.indexOf('"\\\\?\\')===0||f.indexOf('"\\??\\')===0?'"'+f.substr(5):f;new Promise((f,S)=>{X(["windows-process-tree"],f,S)}).then(f=>{f.getProcessList(A,S=>{if(!S){P(new Error(`Root process ${A} not found`));return}f.getProcessCpuUsage(S,C=>{const m=new Map;C.forEach(g=>{const c=y(g.commandLine||"");m.set(g.pid,{name:v(c),cmd:c,pid:g.pid,ppid:g.ppid,load:g.cpu||0,mem:g.memory||0})}),I=m.get(A),I?(m.forEach(g=>{const c=m.get(g.ppid);c&&(c.children||(c.children=[]),c.children.push(g))}),m.forEach(g=>{g.children&&(g.children=g.children.sort((c,d)=>c.pid-d.pid))}),b(I)):P(new Error(`Root process ${A} not found`))})},f.ProcessDataFlag.CommandLine|f.ProcessDataFlag.Memory)})}else{let y=function(){let f=[I];const S=[];for(;f.length;){const m=f.shift();m&&(S.push(m.pid),m.children&&(f=f.concat(m.children)))}let C=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/cpuUsage.sh",X).fsPath);C+=" "+S.join(" "),(0,D.exec)(C,{},(m,g,c)=>{if(m||c)P(m||new Error(c.toString()));else{const d=g.toString().split(`
`);for(let u=0;u<S.length;u++){const s=E.get(S[u]);s.load=parseFloat(d[u])}if(!I){P(new Error(`Root process ${A} not found`));return}b(I)}})};(0,D.exec)("which ps",{},(f,S,C)=>{if(f||C)if(process.platform!=="linux")P(f||new Error(C.toString()));else{const m=JSON.stringify(n.FileAccess.asFileUri("vs/base/node/ps.sh",X).fsPath);(0,D.exec)(m,{},(g,c,d)=>{g||d?P(g||new Error(d.toString())):(L(c,w),y())})}else{const m=S.toString().trim(),g="-ax -o pid=,ppid=,pcpu=,pmem=,command=";(0,D.exec)(`${m} ${g}`,{maxBuffer:1e3*1024,env:{LC_NUMERIC:"en_US.UTF-8"}},(c,d,u)=>{c||u&&!u.includes("screen size is bogus")?P(c||new Error(u.toString())):(L(d,w),process.platform==="linux"?y():I?b(I):P(new Error(`Root process ${A} not found`)))})}})}})}e.listProcesses=k;function L(A,b){const P=/^\s*([0-9]+)\s+([0-9]+)\s+([0-9]+\.[0-9]+)\s+([0-9]+\.[0-9]+)\s+(.+)$/,I=A.toString().split(`
`);for(const E of I){const w=P.exec(E.trim());w&&w.length===6&&b(parseInt(w[1]),parseInt(w[2]),w[5],parseFloat(w[3]),parseFloat(w[4]))}}}),define(re[131],se([0,1,37,4,82,83]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSystemShellSync=e.getSystemShell=void 0;async function A(y,f){return y===1?n.isWindows?w():L.getWindowsShell(f):I(y,f)}e.getSystemShell=A;function b(y,f){return y===1?n.isWindows?v(f):L.getWindowsShell(f):I(y,f)}e.getSystemShellSync=b;let P=null;function I(y,f){if(n.isLinux&&y===2||n.isMacintosh&&y===3)return"/bin/bash";if(!P){let S;if(n.isWindows)S="/bin/bash";else{if(S=f.SHELL,!S)try{S=(0,D.userInfo)().shell}catch{}S||(S="sh"),S==="/bin/false"&&(S="/bin/bash")}P=S}return P}let E=null;async function w(){return E||(E=(await(0,k.getFirstAvailablePowerShellInstallation)()).exePath),E}function v(y){if(E)return E;const f=n.isWindows&&parseFloat((0,D.release)())>=10,S=y.hasOwnProperty("PROCESSOR_ARCHITEW6432"),C=`${y.windir}\\${S?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?C:L.getWindowsShell(y)}});var me=this&&this.__decorate||function(X,e,D,n){var k=arguments.length,L=k<3?e:n===null?n=Object.getOwnPropertyDescriptor(e,D):n,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(X,e,D,n);else for(var b=X.length-1;b>=0;b--)(A=X[b])&&(L=(k<3?A(L):k>3?A(e,D,L):A(e,D))||L);return k>3&&L&&Object.defineProperty(e,D,L),L};define(re[39],se([0,1,18,6,16,21,60,9,3,2,63,26,15]),function(X,e,D,n,k,L,A,b,P,I,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IPCLogger=e.logWithColors=e.ProxyChannel=e.StaticRouter=e.getNextTickChannel=e.getDelayedChannel=e.IPCClient=e.IPCServer=e.ChannelClient=e.RequestInitiator=e.ChannelServer=e.ResponseType=e.RequestType=void 0;var y;(function(H){H[H.Promise=100]="Promise",H[H.PromiseCancel=101]="PromiseCancel",H[H.EventListen=102]="EventListen",H[H.EventDispose=103]="EventDispose"})(y=e.RequestType||(e.RequestType={}));function f(H){switch(H){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var S;(function(H){H[H.Initialize=200]="Initialize",H[H.PromiseSuccess=201]="PromiseSuccess",H[H.PromiseError=202]="PromiseError",H[H.PromiseErrorObj=203]="PromiseErrorObj",H[H.EventFire=204]="EventFire"})(S=e.ResponseType||(e.ResponseType={}));function C(H){switch(H){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var m;(function(H){H[H.Uninitialized=0]="Uninitialized",H[H.Idle=1]="Idle"})(m||(m={}));class g{constructor(B){this.buffer=B,this.pos=0}read(B){const K=this.buffer.slice(this.pos,this.pos+B);return this.pos+=K.byteLength,K}}class c{constructor(){this.buffers=[]}get buffer(){return k.VSBuffer.concat(this.buffers)}write(B){this.buffers.push(B)}}var d;(function(H){H[H.Undefined=0]="Undefined",H[H.String=1]="String",H[H.Buffer=2]="Buffer",H[H.VSBuffer=3]="VSBuffer",H[H.Array=4]="Array",H[H.Object=5]="Object"})(d||(d={}));function u(H){const B=k.VSBuffer.alloc(4);return B.writeUInt32BE(H,0),B}function s(H){return H.read(4).readUInt32BE(0)}function r(H){const B=k.VSBuffer.alloc(1);return B.writeUInt8(H,0),B}const t={Undefined:r(d.Undefined),String:r(d.String),Buffer:r(d.Buffer),VSBuffer:r(d.VSBuffer),Array:r(d.Array),Object:r(d.Object)},i=typeof Buffer!="undefined";function o(H,B){if(typeof B=="undefined")H.write(t.Undefined);else if(typeof B=="string"){const K=k.VSBuffer.fromString(B);H.write(t.String),H.write(u(K.byteLength)),H.write(K)}else if(i&&Buffer.isBuffer(B)){const K=k.VSBuffer.wrap(B);H.write(t.Buffer),H.write(u(K.byteLength)),H.write(K)}else if(B instanceof k.VSBuffer)H.write(t.VSBuffer),H.write(u(B.byteLength)),H.write(B);else if(Array.isArray(B)){H.write(t.Array),H.write(u(B.length));for(const K of B)o(H,K)}else{const K=k.VSBuffer.fromString(JSON.stringify(B));H.write(t.Object),H.write(u(K.byteLength)),H.write(K)}}function l(H){switch(H.read(1).readUInt8(0)){case d.Undefined:return;case d.String:return H.read(s(H)).toString();case d.Buffer:return H.read(s(H)).buffer;case d.VSBuffer:return H.read(s(H));case d.Array:{const K=s(H),ie=[];for(let ce=0;ce<K;ce++)ie.push(l(H));return ie}case d.Object:return JSON.parse(H.read(s(H)).toString())}}class a{constructor(B,K,ie=null,ce=1e3){this.protocol=B,this.ctx=K,this.logger=ie,this.timeoutDelay=ce,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(z=>this.onRawMessage(z)),this.sendResponse({type:200})}registerChannel(B,K){this.channels.set(B,K),setTimeout(()=>this.flushPendingRequests(B),0)}sendResponse(B){switch(B.type){case 200:{const K=this.send([B.type]);this.logger?.logOutgoing(K,0,1,C(B.type));return}case 201:case 202:case 204:case 203:{const K=this.send([B.type,B.id],B.data);this.logger?.logOutgoing(K,B.id,1,C(B.type),B.data);return}}}send(B,K=void 0){const ie=new c;return o(ie,B),o(ie,K),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onRawMessage(B){const K=new g(B),ie=l(K),ce=l(K),z=ie[0];switch(z){case 100:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${f(z)}: ${ie[2]}.${ie[3]}`,ce),this.onPromise({type:z,id:ie[1],channelName:ie[2],name:ie[3],arg:ce});case 102:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${f(z)}: ${ie[2]}.${ie[3]}`,ce),this.onEventListen({type:z,id:ie[1],channelName:ie[2],name:ie[3],arg:ce});case 101:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${f(z)}`),this.disposeActiveRequest({type:z,id:ie[1]});case 103:return this.logger?.logIncoming(B.byteLength,ie[1],1,`${f(z)}`),this.disposeActiveRequest({type:z,id:ie[1]})}}onPromise(B){const K=this.channels.get(B.channelName);if(!K){this.collectPendingRequest(B);return}const ie=new L.CancellationTokenSource;let ce;try{ce=K.call(this.ctx,B.name,B.arg,ie.token)}catch(_){ce=Promise.reject(_)}const z=B.id;ce.then(_=>{this.sendResponse({id:z,data:_,type:201}),this.activeRequests.delete(B.id)},_=>{_ instanceof Error?this.sendResponse({id:z,data:{message:_.message,name:_.name,stack:_.stack?_.stack.split?_.stack.split(`
`):_.stack:void 0},type:202}):this.sendResponse({id:z,data:_,type:203}),this.activeRequests.delete(B.id)});const x=(0,I.toDisposable)(()=>ie.cancel());this.activeRequests.set(B.id,x)}onEventListen(B){const K=this.channels.get(B.channelName);if(!K){this.collectPendingRequest(B);return}const ie=B.id,z=K.listen(this.ctx,B.name,B.arg)(x=>this.sendResponse({id:ie,data:x,type:204}));this.activeRequests.set(B.id,z)}disposeActiveRequest(B){const K=this.activeRequests.get(B.id);K&&(K.dispose(),this.activeRequests.delete(B.id))}collectPendingRequest(B){let K=this.pendingRequests.get(B.channelName);K||(K=[],this.pendingRequests.set(B.channelName,K));const ie=setTimeout(()=>{console.error(`Unknown channel: ${B.channelName}`),B.type===100&&this.sendResponse({id:B.id,data:{name:"Unknown channel",message:`Channel name '${B.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);K.push({request:B,timeoutTimer:ie})}flushPendingRequests(B){const K=this.pendingRequests.get(B);if(K){for(const ie of K)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(B)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}e.ChannelServer=a;var h;(function(H){H[H.LocalSide=0]="LocalSide",H[H.OtherSide=1]="OtherSide"})(h=e.RequestInitiator||(e.RequestInitiator={}));class p{constructor(B,K=null){this.protocol=B,this.isDisposed=!1,this.state=m.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new P.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=K}getChannel(B){const K=this;return{call(ie,ce,z){return K.isDisposed?Promise.reject(b.canceled()):K.requestPromise(B,ie,ce,z)},listen(ie,ce){return K.isDisposed?P.Event.None:K.requestEvent(B,ie,ce)}}}requestPromise(B,K,ie,ce=L.CancellationToken.None){const z=this.lastRequestId++,_={id:z,type:100,channelName:B,name:K,arg:ie};if(ce.isCancellationRequested)return Promise.reject(b.canceled());let U;return new Promise((j,Z)=>{if(ce.isCancellationRequested)return Z(b.canceled());const oe=()=>{const ue=he=>{switch(he.type){case 201:this.handlers.delete(z),j(he.data);break;case 202:{this.handlers.delete(z);const pe=new Error(he.data.message);pe.stack=he.data.stack,pe.name=he.data.name,Z(pe);break}case 203:this.handlers.delete(z),Z(he.data);break}};this.handlers.set(z,ue),this.sendRequest(_)};let Q=null;this.state===m.Idle?oe():(Q=(0,n.createCancelablePromise)(ue=>this.whenInitialized()),Q.then(()=>{Q=null,oe()}));const te=()=>{Q?(Q.cancel(),Q=null):this.sendRequest({id:z,type:101}),Z(b.canceled())},ne=ce.onCancellationRequested(te);U=(0,I.combinedDisposable)((0,I.toDisposable)(te),ne),this.activeRequests.add(U)}).finally(()=>{this.activeRequests.delete(U)})}requestEvent(B,K,ie){const ce=this.lastRequestId++,x={id:ce,type:102,channelName:B,name:K,arg:ie};let _=null;const U=new P.Emitter({onFirstListenerAdd:()=>{_=(0,n.createCancelablePromise)(j=>this.whenInitialized()),_.then(()=>{_=null,this.activeRequests.add(U),this.sendRequest(x)})},onLastListenerRemove:()=>{_?(_.cancel(),_=null):(this.activeRequests.delete(U),this.sendRequest({id:ce,type:103}))}}),q=j=>U.fire(j.data);return this.handlers.set(ce,q),U.event}sendRequest(B){switch(B.type){case 100:case 102:{const K=this.send([B.type,B.id,B.channelName,B.name],B.arg);this.logger?.logOutgoing(K,B.id,0,`${f(B.type)}: ${B.channelName}.${B.name}`,B.arg);return}case 101:case 103:{const K=this.send([B.type,B.id]);this.logger?.logOutgoing(K,B.id,0,f(B.type));return}}}send(B,K=void 0){const ie=new c;return o(ie,B),o(ie,K),this.sendBuffer(ie.buffer)}sendBuffer(B){try{return this.protocol.send(B),B.byteLength}catch{return 0}}onBuffer(B){const K=new g(B),ie=l(K),ce=l(K),z=ie[0];switch(z){case 200:return this.logger?.logIncoming(B.byteLength,0,0,C(z)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(B.byteLength,ie[1],0,C(z),ce),this.onResponse({type:ie[0],id:ie[1],data:ce})}}onResponse(B){if(B.type===200){this.state=m.Idle,this._onDidInitialize.fire();return}this.handlers.get(B.id)?.(B)}get onDidInitializePromise(){return P.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===m.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,I.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}me([A.memoize],p.prototype,"onDidInitializePromise",null),e.ChannelClient=p;class R{constructor(B){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new P.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new P.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,B(({protocol:K,onDidClientDisconnect:ie})=>{P.Event.once(K.onMessage)(z=>{const x=new g(z),_=l(x),U=new a(K,_),q=new p(K);this.channels.forEach((Z,oe)=>U.registerChannel(oe,Z));const j={channelServer:U,channelClient:q,ctx:_};this._connections.add(j),this._onDidAddConnection.fire(j),ie(()=>{U.dispose(),q.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const B=[];return this._connections.forEach(K=>B.push(K)),B}getChannel(B,K){const ie=this;return{call(ce,z,x){let _;if((0,v.isFunction)(K)){const q=(0,D.getRandomElement)(ie.connections.filter(K));_=q?Promise.resolve(q):P.Event.toPromise(P.Event.filter(ie.onDidAddConnection,K))}else _=K.routeCall(ie,ce,z);const U=_.then(q=>q.channelClient.getChannel(B));return O(U).call(ce,z,x)},listen(ce,z){if((0,v.isFunction)(K))return ie.getMulticastEvent(B,K,ce,z);const x=K.routeEvent(ie,ce,z).then(_=>_.channelClient.getChannel(B));return O(x).listen(ce,z)}}}getMulticastEvent(B,K,ie,ce){const z=this;let x=new I.DisposableStore;const _=new P.Emitter({onFirstListenerAdd:()=>{x=new I.DisposableStore;const U=new P.EventMultiplexer,q=new Map,j=oe=>{const te=oe.channelClient.getChannel(B).listen(ie,ce),ne=U.add(te);q.set(oe,ne)},Z=oe=>{const Q=q.get(oe);!Q||(Q.dispose(),q.delete(oe))};z.connections.filter(K).forEach(j),P.Event.filter(z.onDidAddConnection,K)(j,void 0,x),z.onDidRemoveConnection(Z,void 0,x),U.event(_.fire,_,x),x.add(U)},onLastListenerRemove:()=>{x.dispose()}});return _.event}registerChannel(B,K){this.channels.set(B,K),this._connections.forEach(ie=>{ie.channelServer.registerChannel(B,K)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}e.IPCServer=R;class M{constructor(B,K,ie=null){const ce=new c;o(ce,K),B.send(ce.buffer),this.channelClient=new p(B,ie),this.channelServer=new a(B,K,ie)}getChannel(B){return this.channelClient.getChannel(B)}registerChannel(B,K){this.channelServer.registerChannel(B,K)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}e.IPCClient=M;function O(H){return{call(B,K,ie){return H.then(ce=>ce.call(B,K,ie))},listen(B,K){const ie=new P.Relay;return H.then(ce=>ie.input=ce.listen(B,K)),ie.event}}}e.getDelayedChannel=O;function F(H){let B=!1;return{call(K,ie,ce){return B?H.call(K,ie,ce):(0,n.timeout)(0).then(()=>B=!0).then(()=>H.call(K,ie,ce))},listen(K,ie){if(B)return H.listen(K,ie);const ce=new P.Relay;return(0,n.timeout)(0).then(()=>B=!0).then(()=>ce.input=H.listen(K,ie)),ce.event}}}e.getNextTickChannel=F;class T{constructor(B){this.fn=B}routeCall(B){return this.route(B)}routeEvent(B){return this.route(B)}async route(B){for(const K of B.connections)if(await Promise.resolve(this.fn(K.ctx)))return Promise.resolve(K);return await P.Event.toPromise(B.onDidAddConnection),await this.route(B)}}e.StaticRouter=T;var N;(function(H){function B(z,x){const _=z,U=x&&x.disableMarshalling,q=new Map;for(const j in _)ie(j)&&q.set(j,P.Event.buffer(_[j],!0));return new class{listen(j,Z,oe){const Q=q.get(Z);if(Q)return Q;if(ce(Z)){const te=_[Z];if(typeof te=="function")return te.call(_,oe)}throw new Error(`Event not found: ${Z}`)}call(j,Z,oe){const Q=_[Z];if(typeof Q=="function"){if(!U&&Array.isArray(oe))for(let te=0;te<oe.length;te++)oe[te]=(0,E.revive)(oe[te]);return Q.apply(_,oe)}throw new Error(`Method not found: ${Z}`)}}}H.fromService=B;function K(z,x){const _=x&&x.disableMarshalling;return new Proxy({},{get(U,q){if(typeof q=="string")return x?.properties?.has(q)?x.properties.get(q):ce(q)?function(j){return z.listen(q,j)}:ie(q)?z.listen(q):async function(...j){let Z;x&&!(0,v.isUndefinedOrNull)(x.context)?Z=[x.context,...j]:Z=j;const oe=await z.call(q,Z);return _?oe:(0,E.revive)(oe)};throw new Error(`Property not found: ${String(q)}`)}})}H.toService=K;function ie(z){return z[0]==="o"&&z[1]==="n"&&w.isUpperAsciiLetter(z.charCodeAt(2))}function ce(z){return/^onDynamic/.test(z)&&w.isUpperAsciiLetter(z.charCodeAt(9))}})(N=e.ProxyChannel||(e.ProxyChannel={}));const W=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function V(H){if(Array.isArray(H))return H;if(H&&typeof H=="object"&&typeof H.toString=="function"){const B=H.toString();if(B!=="[object Object]")return B}return H}function Y(H){return Array.isArray(H)?H.map(V):V(H)}function $(H,B,K,ie,ce,z,x){x=Y(x);const _=W[ce],U=_[ie%_.length];let q=[`%c[${H}]%c[${String(B).padStart(7," ")}]%c[len: ${String(K).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${z}`,"color: darkgreen","color: grey","color: grey",`color: ${U}`];/\($/.test(z)?(q=q.concat(x),q.push(")")):q.push(x),console.log.apply(console,q)}e.logWithColors=$;class J{constructor(B,K){this._outgoingPrefix=B,this._incomingPrefix=K,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(B,K,ie,ce,z){this._totalOutgoing+=B,$(this._outgoingPrefix,this._totalOutgoing,B,K,ie,ce,z)}logIncoming(B,K,ie,ce,z){this._totalIncoming+=B,$(this._incomingPrefix,this._totalIncoming,B,K,ie,ce,z)}}e.IPCLogger=J}),define(re[132],se([0,1,16,3,39]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Protocol=void 0;class L{constructor(P){this.port=P,this.onMessage=n.Event.fromDOMEventEmitter(this.port,"message",I=>D.VSBuffer.wrap(I.data)),P.start()}send(P){this.port.postMessage(P.buffer)}disconnect(){this.port.close()}}e.Protocol=L;class A extends k.IPCClient{constructor(P,I){const E=new L(P);super(E,I);this.protocol=E}dispose(){this.protocol.disconnect()}}e.Client=A}),define(re[84],se([0,1,16,3,2,39]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PersistentProtocol=e.BufferedEmitter=e.Client=e.Protocol=e.ProtocolConstants=e.ChunkStream=e.SocketCloseEventType=e.SocketDiagnostics=e.SocketDiagnosticsEventType=void 0;var A;(function(i){i.Created="created",i.Read="read",i.Write="write",i.Open="open",i.Error="error",i.Close="close",i.BrowserWebSocketBlobReceived="browserWebSocketBlobReceived",i.NodeEndReceived="nodeEndReceived",i.NodeEndSent="nodeEndSent",i.NodeDrainBegin="nodeDrainBegin",i.NodeDrainEnd="nodeDrainEnd",i.zlibInflateError="zlibInflateError",i.zlibInflateData="zlibInflateData",i.zlibInflateInitialWrite="zlibInflateInitialWrite",i.zlibInflateInitialFlushFired="zlibInflateInitialFlushFired",i.zlibInflateWrite="zlibInflateWrite",i.zlibInflateFlushFired="zlibInflateFlushFired",i.zlibDeflateError="zlibDeflateError",i.zlibDeflateData="zlibDeflateData",i.zlibDeflateWrite="zlibDeflateWrite",i.zlibDeflateFlushFired="zlibDeflateFlushFired",i.WebSocketNodeSocketWrite="webSocketNodeSocketWrite",i.WebSocketNodeSocketPeekedHeader="webSocketNodeSocketPeekedHeader",i.WebSocketNodeSocketReadHeader="webSocketNodeSocketReadHeader",i.WebSocketNodeSocketReadData="webSocketNodeSocketReadData",i.WebSocketNodeSocketUnmaskedData="webSocketNodeSocketUnmaskedData",i.WebSocketNodeSocketDrainBegin="webSocketNodeSocketDrainBegin",i.WebSocketNodeSocketDrainEnd="webSocketNodeSocketDrainEnd",i.ProtocolHeaderRead="protocolHeaderRead",i.ProtocolMessageRead="protocolMessageRead",i.ProtocolHeaderWrite="protocolHeaderWrite",i.ProtocolMessageWrite="protocolMessageWrite",i.ProtocolWrite="protocolWrite"})(A=e.SocketDiagnosticsEventType||(e.SocketDiagnosticsEventType={}));var b;(function(i){i.enableDiagnostics=!1,i.records=[];const o=new WeakMap;let l=0;function a(p,R){if(!o.has(p)){const M=String(++l);o.set(p,M)}return o.get(p)}function h(p,R,M,O){if(!i.enableDiagnostics)return;const F=a(p,R);if(O instanceof D.VSBuffer||O instanceof Uint8Array||O instanceof ArrayBuffer||ArrayBuffer.isView(O)){const T=D.VSBuffer.alloc(O.byteLength);T.set(O),i.records.push({timestamp:Date.now(),id:F,label:R,type:M,buff:T})}else i.records.push({timestamp:Date.now(),id:F,label:R,type:M,data:O})}i.traceSocketEvent=h})(b=e.SocketDiagnostics||(e.SocketDiagnostics={}));var P;(function(i){i[i.NodeSocketCloseEvent=0]="NodeSocketCloseEvent",i[i.WebSocketCloseEvent=1]="WebSocketCloseEvent"})(P=e.SocketCloseEventType||(e.SocketCloseEventType={}));let I=null;function E(){return I||(I=D.VSBuffer.alloc(0)),I}class w{constructor(){this._chunks=[],this._totalLength=0}get byteLength(){return this._totalLength}acceptChunk(o){this._chunks.push(o),this._totalLength+=o.byteLength}read(o){return this._read(o,!0)}peek(o){return this._read(o,!1)}_read(o,l){if(o===0)return E();if(o>this._totalLength)throw new Error("Cannot read so many bytes!");if(this._chunks[0].byteLength===o){const R=this._chunks[0];return l&&(this._chunks.shift(),this._totalLength-=o),R}if(this._chunks[0].byteLength>o){const R=this._chunks[0].slice(0,o);return l&&(this._chunks[0]=this._chunks[0].slice(o),this._totalLength-=o),R}const a=D.VSBuffer.alloc(o);let h=0,p=0;for(;o>0;){const R=this._chunks[p];if(R.byteLength>o){const M=R.slice(0,o);a.set(M,h),h+=o,l&&(this._chunks[p]=R.slice(o),this._totalLength-=o),o-=o}else a.set(R,h),h+=R.byteLength,l?(this._chunks.shift(),this._totalLength-=R.byteLength):p++,o-=R.byteLength}return a}}e.ChunkStream=w;var v;(function(i){i[i.None=0]="None",i[i.Regular=1]="Regular",i[i.Control=2]="Control",i[i.Ack=3]="Ack",i[i.Disconnect=5]="Disconnect",i[i.ReplayRequest=6]="ReplayRequest",i[i.Pause=7]="Pause",i[i.Resume=8]="Resume"})(v||(v={}));function y(i){switch(i){case 0:return"None";case 1:return"Regular";case 2:return"Control";case 3:return"Ack";case 5:return"Disconnect";case 6:return"ReplayRequest";case 7:return"PauseWriting";case 8:return"ResumeWriting"}}var f;(function(i){i[i.HeaderLength=13]="HeaderLength",i[i.AcknowledgeTime=2e3]="AcknowledgeTime",i[i.TimeoutTime=2e4]="TimeoutTime",i[i.ReconnectionGraceTime=108e5]="ReconnectionGraceTime",i[i.ReconnectionShortGraceTime=3e5]="ReconnectionShortGraceTime"})(f=e.ProtocolConstants||(e.ProtocolConstants={}));class S{constructor(o,l,a,h){this.type=o,this.id=l,this.ack=a,this.data=h,this.writtenTime=0}get size(){return this.data.byteLength}}class C extends k.Disposable{constructor(o){super();this._onMessage=this._register(new n.Emitter),this.onMessage=this._onMessage.event,this._state={readHead:!0,readLen:13,messageType:0,id:0,ack:0},this._socket=o,this._isDisposed=!1,this._incomingData=new w,this._register(this._socket.onData(l=>this.acceptChunk(l))),this.lastReadTime=Date.now()}acceptChunk(o){if(!(!o||o.byteLength===0))for(this.lastReadTime=Date.now(),this._incomingData.acceptChunk(o);this._incomingData.byteLength>=this._state.readLen;){const l=this._incomingData.read(this._state.readLen);if(this._state.readHead)this._state.readHead=!1,this._state.readLen=l.readUInt32BE(9),this._state.messageType=l.readUInt8(0),this._state.id=l.readUInt32BE(1),this._state.ack=l.readUInt32BE(5),this._socket.traceSocketEvent("protocolHeaderRead",{messageType:y(this._state.messageType),id:this._state.id,ack:this._state.ack,messageSize:this._state.readLen});else{const a=this._state.messageType,h=this._state.id,p=this._state.ack;if(this._state.readHead=!0,this._state.readLen=13,this._state.messageType=0,this._state.id=0,this._state.ack=0,this._socket.traceSocketEvent("protocolMessageRead",l),this._onMessage.fire(new S(a,h,p,l)),this._isDisposed)break}}}readEntireBuffer(){return this._incomingData.read(this._incomingData.byteLength)}dispose(){this._isDisposed=!0,super.dispose()}}class m{constructor(o){this._writeNowTimeout=null,this._isDisposed=!1,this._isPaused=!1,this._socket=o,this._data=[],this._totalLength=0,this.lastWriteTime=0}dispose(){try{this.flush()}catch{}this._isDisposed=!0}drain(){return this.flush(),this._socket.drain()}flush(){this._writeNow()}pause(){this._isPaused=!0}resume(){this._isPaused=!1,this._scheduleWriting()}write(o){if(this._isDisposed)return;o.writtenTime=Date.now(),this.lastWriteTime=Date.now();const l=D.VSBuffer.alloc(13);l.writeUInt8(o.type,0),l.writeUInt32BE(o.id,1),l.writeUInt32BE(o.ack,5),l.writeUInt32BE(o.data.byteLength,9),this._socket.traceSocketEvent("protocolHeaderWrite",{messageType:y(o.type),id:o.id,ack:o.ack,messageSize:o.data.byteLength}),this._socket.traceSocketEvent("protocolMessageWrite",o.data),this._writeSoon(l,o.data)}_bufferAdd(o,l){const a=this._totalLength===0;return this._data.push(o,l),this._totalLength+=o.byteLength+l.byteLength,a}_bufferTake(){const o=D.VSBuffer.concat(this._data,this._totalLength);return this._data.length=0,this._totalLength=0,o}_writeSoon(o,l){this._bufferAdd(o,l)&&this._scheduleWriting()}_scheduleWriting(){this._writeNowTimeout||(this._writeNowTimeout=setTimeout(()=>{this._writeNowTimeout=null,this._writeNow()}))}_writeNow(){if(this._totalLength===0||this._isPaused)return;const o=this._bufferTake();this._socket.traceSocketEvent("protocolWrite",{byteLength:o.byteLength}),this._socket.write(o)}}class g extends k.Disposable{constructor(o){super();this._onMessage=new n.Emitter,this.onMessage=this._onMessage.event,this._onDidDispose=new n.Emitter,this.onDidDispose=this._onDidDispose.event,this._socket=o,this._socketWriter=this._register(new m(this._socket)),this._socketReader=this._register(new C(this._socket)),this._register(this._socketReader.onMessage(l=>{l.type===1&&this._onMessage.fire(l.data)})),this._register(this._socket.onClose(()=>this._onDidDispose.fire()))}drain(){return this._socketWriter.drain()}getSocket(){return this._socket}sendDisconnect(){}send(o){this._socketWriter.write(new S(1,0,0,o))}}e.Protocol=g;class c extends L.IPCClient{constructor(o,l,a=null){super(o,l,a);this.protocol=o}static fromSocket(o,l){return new c(new g(o),l)}get onDidDispose(){return this.protocol.onDidDispose}dispose(){super.dispose();const o=this.protocol.getSocket();this.protocol.sendDisconnect(),this.protocol.dispose(),o.end()}}e.Client=c;class d{constructor(){this._hasListeners=!1,this._isDeliveringMessages=!1,this._bufferedMessages=[],this._emitter=new n.Emitter({onFirstListenerAdd:()=>{this._hasListeners=!0,queueMicrotask(()=>this._deliverMessages())},onLastListenerRemove:()=>{this._hasListeners=!1}}),this.event=this._emitter.event}_deliverMessages(){if(!this._isDeliveringMessages){for(this._isDeliveringMessages=!0;this._hasListeners&&this._bufferedMessages.length>0;)this._emitter.fire(this._bufferedMessages.shift());this._isDeliveringMessages=!1}}fire(o){this._hasListeners?this._bufferedMessages.length>0?this._bufferedMessages.push(o):this._emitter.fire(o):this._bufferedMessages.push(o)}flushBuffer(){this._bufferedMessages=[]}}e.BufferedEmitter=d;class u{constructor(o){this.data=o,this.next=null}}class s{constructor(){this._first=null,this._last=null}length(){let o=0,l=this._first;for(;l;)l=l.next,o++;return o}peek(){return this._first?this._first.data:null}toArray(){const o=[];let l=0,a=this._first;for(;a;)o[l++]=a.data,a=a.next;return o}pop(){if(!!this._first){if(this._first===this._last){this._first=null,this._last=null;return}this._first=this._first.next}}push(o){const l=new u(o);if(!this._first){this._first=l,this._last=l;return}this._last.next=l,this._last=l}}class r{constructor(){this.lastRuns=[];const o=Date.now();for(let l=0;l<r._HISTORY_LENGTH;l++)this.lastRuns[l]=o-1e3*l;setInterval(()=>{for(let l=r._HISTORY_LENGTH;l>=1;l--)this.lastRuns[l]=this.lastRuns[l-1];this.lastRuns[0]=Date.now()},1e3)}static getInstance(){return r._INSTANCE||(r._INSTANCE=new r),r._INSTANCE}load(){const o=Date.now(),l=(1+r._HISTORY_LENGTH)*1e3;let a=0;for(let h=0;h<r._HISTORY_LENGTH;h++)o-this.lastRuns[h]<=l&&a++;return 1-a/r._HISTORY_LENGTH}hasHighLoad(){return this.load()>=.5}}r._HISTORY_LENGTH=10,r._INSTANCE=null;class t{constructor(o,l=null,a=r.getInstance()){this._onControlMessage=new d,this.onControlMessage=this._onControlMessage.event,this._onMessage=new d,this.onMessage=this._onMessage.event,this._onDidDispose=new d,this.onDidDispose=this._onDidDispose.event,this._onSocketClose=new d,this.onSocketClose=this._onSocketClose.event,this._onSocketTimeout=new d,this.onSocketTimeout=this._onSocketTimeout.event,this._loadEstimator=a,this._isReconnecting=!1,this._outgoingUnackMsg=new s,this._outgoingMsgId=0,this._outgoingAckId=0,this._outgoingAckTimeout=null,this._incomingMsgId=0,this._incomingAckId=0,this._incomingMsgLastTime=0,this._incomingAckTimeout=null,this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socketDisposables=[],this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(h=>this._receiveMessage(h))),this._socketDisposables.push(this._socket.onClose(h=>this._onSocketClose.fire(h))),l&&this._socketReader.acceptChunk(l)}get unacknowledgedCount(){return this._outgoingMsgId-this._outgoingAckId}dispose(){this._outgoingAckTimeout&&(clearTimeout(this._outgoingAckTimeout),this._outgoingAckTimeout=null),this._incomingAckTimeout&&(clearTimeout(this._incomingAckTimeout),this._incomingAckTimeout=null),this._socketDisposables=(0,k.dispose)(this._socketDisposables)}drain(){return this._socketWriter.drain()}sendDisconnect(){const o=new S(5,0,0,E());this._socketWriter.write(o),this._socketWriter.flush()}sendPause(){const o=new S(7,0,0,E());this._socketWriter.write(o)}sendResume(){const o=new S(8,0,0,E());this._socketWriter.write(o)}pauseSocketWriting(){this._socketWriter.pause()}getSocket(){return this._socket}getMillisSinceLastIncomingData(){return Date.now()-this._socketReader.lastReadTime}beginAcceptReconnection(o,l){this._isReconnecting=!0,this._socketDisposables=(0,k.dispose)(this._socketDisposables),this._onControlMessage.flushBuffer(),this._onSocketClose.flushBuffer(),this._onSocketTimeout.flushBuffer(),this._socket.dispose(),this._lastReplayRequestTime=0,this._lastSocketTimeoutTime=Date.now(),this._socket=o,this._socketWriter=new m(this._socket),this._socketDisposables.push(this._socketWriter),this._socketReader=new C(this._socket),this._socketDisposables.push(this._socketReader),this._socketDisposables.push(this._socketReader.onMessage(a=>this._receiveMessage(a))),this._socketDisposables.push(this._socket.onClose(a=>this._onSocketClose.fire(a))),this._socketReader.acceptChunk(l)}endAcceptReconnection(){this._isReconnecting=!1,this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o);const l=this._outgoingUnackMsg.toArray();for(let a=0,h=l.length;a<h;a++)this._socketWriter.write(l[a]);this._recvAckCheck()}acceptDisconnect(){this._onDidDispose.fire()}_receiveMessage(o){if(o.ack>this._outgoingAckId){this._outgoingAckId=o.ack;do{const l=this._outgoingUnackMsg.peek();if(l&&l.id<=o.ack)this._outgoingUnackMsg.pop();else break}while(!0)}switch(o.type){case 0:break;case 1:{if(o.id>this._incomingMsgId)if(o.id!==this._incomingMsgId+1){const l=Date.now();l-this._lastReplayRequestTime>1e4&&(this._lastReplayRequestTime=l,this._socketWriter.write(new S(6,0,0,E())))}else this._incomingMsgId=o.id,this._incomingMsgLastTime=Date.now(),this._sendAckCheck(),this._onMessage.fire(o.data);break}case 2:{this._onControlMessage.fire(o.data);break}case 3:break;case 5:{this._onDidDispose.fire();break}case 6:{const l=this._outgoingUnackMsg.toArray();for(let a=0,h=l.length;a<h;a++)this._socketWriter.write(l[a]);this._recvAckCheck();break}case 7:{this._socketWriter.pause();break}case 8:{this._socketWriter.resume();break}}}readEntireBuffer(){return this._socketReader.readEntireBuffer()}flush(){this._socketWriter.flush()}send(o){const l=++this._outgoingMsgId;this._incomingAckId=this._incomingMsgId;const a=new S(1,l,this._incomingAckId,o);this._outgoingUnackMsg.push(a),this._isReconnecting||(this._socketWriter.write(a),this._recvAckCheck())}sendControl(o){const l=new S(2,0,0,o);this._socketWriter.write(l)}_sendAckCheck(){if(this._incomingMsgId<=this._incomingAckId||this._incomingAckTimeout)return;const o=Date.now()-this._incomingMsgLastTime;if(o>=2e3){this._sendAck();return}this._incomingAckTimeout=setTimeout(()=>{this._incomingAckTimeout=null,this._sendAckCheck()},2e3-o+5)}_recvAckCheck(){if(this._outgoingMsgId<=this._outgoingAckId||this._outgoingAckTimeout||this._isReconnecting)return;const o=this._outgoingUnackMsg.peek(),l=Date.now()-o.writtenTime,a=Date.now()-this._socketReader.lastReadTime,h=Date.now()-this._lastSocketTimeoutTime;if(l>=2e4&&a>=2e4&&h>=2e4&&!this._loadEstimator.hasHighLoad()){this._lastSocketTimeoutTime=Date.now(),this._onSocketTimeout.fire({unacknowledgedMsgCount:this._outgoingUnackMsg.length(),timeSinceOldestUnacknowledgedMsg:l,timeSinceLastReceivedSomeData:a});return}const p=Math.max(2e4-l,2e4-a,2e4-h,500);this._outgoingAckTimeout=setTimeout(()=>{this._outgoingAckTimeout=null,this._recvAckCheck()},p)}_sendAck(){if(this._incomingMsgId<=this._incomingAckId)return;this._incomingAckId=this._incomingMsgId;const o=new S(3,0,this._incomingAckId,E());this._socketWriter.write(o)}}e.PersistentProtocol=t}),define(re[133],se([0,1,85,3,39,132]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Server=void 0;class A extends k.IPCServer{static getOnDidClientConnect(){const P=n.Event.fromNodeEventEmitter(D.ipcRenderer,"vscode:createMessageChannel",(I,E)=>E);return n.Event.map(P,I=>{const{port1:E,port2:w}=new MessageChannel,y={protocol:new L.Protocol(E),onDidClientDisconnect:n.Event.fromDOMEventEmitter(E,"close")};return D.ipcRenderer.postMessage("vscode:createMessageChannelResult",I,[w]),y})}constructor(){super(A.getOnDidClientConnect())}}e.Server=A}),define(re[64],se([0,1,54,6,16,21,126,9,3,2,31,83,77,39]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Client=e.Server=void 0;class f extends y.ChannelServer{constructor(m){super({send:g=>{try{process.send?.(g.buffer.toString("base64"))}catch{}},onMessage:P.Event.fromNodeEventEmitter(process,"message",g=>k.VSBuffer.wrap(Buffer.from(g,"base64")))},m);process.once("disconnect",()=>this.dispose())}}e.Server=f;class S{constructor(m,g){this.modulePath=m,this.options=g,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new P.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const c=g&&g.timeout?g.timeout:6e4;this.disposeDelayer=new n.Delayer(c),this.child=null,this._client=null}getChannel(m){const g=this;return{call(c,d,u){return g.requestPromise(m,c,d,u)},listen(c,d){return g.requestEvent(m,c,d)}}}requestPromise(m,g,c,d=L.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(d.isCancellationRequested)return Promise.reject(b.canceled());this.disposeDelayer.cancel();const u=this.getCachedChannel(m),s=(0,n.createCancelablePromise)(i=>u.call(g,c,i)),r=d.onCancellationRequested(()=>s.cancel()),t=(0,I.toDisposable)(()=>s.cancel());return this.activeRequests.add(t),s.finally(()=>{r.dispose(),this.activeRequests.delete(t),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),s}requestEvent(m,g,c){if(!this.disposeDelayer)return P.Event.None;this.disposeDelayer.cancel();let d;const u=new P.Emitter({onFirstListenerAdd:()=>{d=this.getCachedChannel(m).listen(g,c)(u.fire,u),this.activeRequests.add(d)},onLastListenerRemove:()=>{this.activeRequests.delete(d),d.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return u.event}get client(){if(!this._client){const m=this.options&&this.options.args?this.options.args:[],g=Object.create(null);g.env={...(0,E.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(g.env={...g.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(g.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(g.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(g.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),g.execArgv===void 0&&(g.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,v.removeDangerousEnvVariables)(g.env),this.child=(0,D.fork)(this.modulePath,m,g);const c=new P.Emitter;P.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}c.fire(k.VSBuffer.wrap(Buffer.from(o,"base64")))});const u=this.options.useQueue?(0,w.createQueuedSender)(this.child):this.child,s=o=>this.child&&this.child.connected&&u.send(o.buffer.toString("base64")),r=c.event,t={send:s,onMessage:r};this._client=new y.ChannelClient(t);const i=()=>this.disposeClient();process.once("exit",i),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,l)=>{process.removeListener("exit",i),this.activeRequests.forEach(a=>(0,I.dispose)(a)),this.activeRequests.clear(),o!==0&&l!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+l),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:l})})}return this._client}getCachedChannel(m){let g=this.channels.get(m);return g||(g=this.client.getChannel(m),this.channels.set(m,g)),g}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}e.Client=S}),define(re[134],se([0,1,16,9,3,2,10,4,30,39,84]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.connect=e.serve=e.Server=e.createStaticIPCHandle=e.createRandomIPCHandle=e.XDG_RUNTIME_DIR=e.WebSocketNodeSocket=e.NodeSocket=void 0;function w(){return{crypto:X.__$__nodeRequire("crypto"),zlib:X.__$__nodeRequire("zlib"),net:X.__$__nodeRequire("net"),os:X.__$__nodeRequire("os")}}class v{constructor(a,h=""){this.debugLabel=h,this.socket=a,this.traceSocketEvent("created",{type:"NodeSocket"}),this._errorListener=p=>{if(this.traceSocketEvent("error",{code:p?.code,message:p?.message}),p){if(p.code==="EPIPE")return;(0,n.onUnexpectedError)(p)}},this.socket.on("error",this._errorListener)}traceSocketEvent(a,h){E.SocketDiagnostics.traceSocketEvent(this.socket,this.debugLabel,a,h)}dispose(){this.socket.off("error",this._errorListener),this.socket.destroy()}onData(a){const h=p=>{this.traceSocketEvent("read",p),a(D.VSBuffer.wrap(p))};return this.socket.on("data",h),{dispose:()=>this.socket.off("data",h)}}onClose(a){const h=p=>{this.traceSocketEvent("close",{hadError:p}),a({type:0,hadError:p,error:void 0})};return this.socket.on("close",h),{dispose:()=>this.socket.off("close",h)}}onEnd(a){const h=()=>{this.traceSocketEvent("nodeEndReceived"),a()};return this.socket.on("end",h),{dispose:()=>this.socket.off("end",h)}}write(a){if(!this.socket.destroyed)try{this.traceSocketEvent("write",a),this.socket.write(a.buffer,h=>{if(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}})}catch(h){if(h.code==="EPIPE")return;(0,n.onUnexpectedError)(h)}}end(){this.traceSocketEvent("nodeEndSent"),this.socket.end()}drain(){return this.traceSocketEvent("nodeDrainBegin"),new Promise((a,h)=>{if(this.socket.bufferSize===0){this.traceSocketEvent("nodeDrainEnd"),a();return}const p=()=>{this.socket.off("close",p),this.socket.off("end",p),this.socket.off("error",p),this.socket.off("timeout",p),this.socket.off("drain",p),this.traceSocketEvent("nodeDrainEnd"),a()};this.socket.on("close",p),this.socket.on("end",p),this.socket.on("error",p),this.socket.on("timeout",p),this.socket.on("drain",p)})}}e.NodeSocket=v;var y;(function(l){l[l.MinHeaderByteSize=2]="MinHeaderByteSize"})(y||(y={}));var f;(function(l){l[l.PeekHeader=1]="PeekHeader",l[l.ReadHeader=2]="ReadHeader",l[l.ReadBody=3]="ReadBody",l[l.Fin=4]="Fin"})(f||(f={}));class S extends L.Disposable{constructor(a,h,p,R){super();this._onData=this._register(new k.Emitter),this._onClose=this._register(new k.Emitter),this._isEnded=!1,this._state={state:1,readLen:2,fin:0,compressed:!1,firstFrameOfMessage:!0,mask:0},this.socket=a,this.traceSocketEvent("created",{type:"WebSocketNodeSocket",permessageDeflate:h,inflateBytesLength:p?.byteLength||0,recordInflateBytes:R}),this._flowManager=this._register(new C(this,h,p,R,this._onData,(M,O)=>this._write(M,O))),this._register(this._flowManager.onError(M=>{console.error(M),(0,n.onUnexpectedError)(M),this._onClose.fire({type:0,hadError:!0,error:M})})),this._incomingData=new E.ChunkStream,this._register(this.socket.onData(M=>this._acceptChunk(M))),this._register(this.socket.onClose(M=>this._onClose.fire(M)))}get permessageDeflate(){return this._flowManager.permessageDeflate}get recordedInflateBytes(){return this._flowManager.recordedInflateBytes}traceSocketEvent(a,h){this.socket.traceSocketEvent(a,h)}dispose(){this._flowManager.isProcessingWriteQueue()?this._register(this._flowManager.onDidFinishProcessingWriteQueue(()=>{this.dispose()})):(this.socket.dispose(),super.dispose())}onData(a){return this._onData.event(a)}onClose(a){return this._onClose.event(a)}onEnd(a){return this.socket.onEnd(a)}write(a){this._flowManager.writeMessage(a)}_write(a,h){if(this._isEnded)return;this.traceSocketEvent("webSocketNodeSocketWrite",a);let p=2;a.byteLength<126?p+=0:a.byteLength<2**16?p+=2:p+=8;const R=D.VSBuffer.alloc(p);if(h?R.writeUInt8(194,0):R.writeUInt8(130,0),a.byteLength<126)R.writeUInt8(a.byteLength,1);else if(a.byteLength<2**16){R.writeUInt8(126,1);let M=1;R.writeUInt8(a.byteLength>>>8&255,++M),R.writeUInt8(a.byteLength>>>0&255,++M)}else{R.writeUInt8(127,1);let M=1;R.writeUInt8(0,++M),R.writeUInt8(0,++M),R.writeUInt8(0,++M),R.writeUInt8(0,++M),R.writeUInt8(a.byteLength>>>24&255,++M),R.writeUInt8(a.byteLength>>>16&255,++M),R.writeUInt8(a.byteLength>>>8&255,++M),R.writeUInt8(a.byteLength>>>0&255,++M)}this.socket.write(D.VSBuffer.concat([R,a]))}end(){this._isEnded=!0,this.socket.end()}_acceptChunk(a){if(a.byteLength!==0){for(this._incomingData.acceptChunk(a);this._incomingData.byteLength>=this._state.readLen;)if(this._state.state===1){const h=this._incomingData.peek(this._state.readLen),p=h.readUInt8(0),R=(p&128)>>>7,M=(p&64)>>>6,O=h.readUInt8(1),F=(O&128)>>>7,T=O&127;this._state.state=2,this._state.readLen=2+(F?4:0)+(T===126?2:0)+(T===127?8:0),this._state.fin=R,this._state.firstFrameOfMessage&&(this._state.compressed=Boolean(M)),this._state.firstFrameOfMessage=Boolean(R),this._state.mask=0,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{headerSize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin})}else if(this._state.state===2){const h=this._incomingData.read(this._state.readLen),p=h.readUInt8(1),R=(p&128)>>>7;let M=p&127,O=1;M===126?M=h.readUInt8(++O)*2**8+h.readUInt8(++O):M===127&&(M=h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*0+h.readUInt8(++O)*2**24+h.readUInt8(++O)*2**16+h.readUInt8(++O)*2**8+h.readUInt8(++O));let F=0;R&&(F=h.readUInt8(++O)*2**24+h.readUInt8(++O)*2**16+h.readUInt8(++O)*2**8+h.readUInt8(++O)),this._state.state=3,this._state.readLen=M,this._state.mask=F,this.traceSocketEvent("webSocketNodeSocketPeekedHeader",{bodySize:this._state.readLen,compressed:this._state.compressed,fin:this._state.fin,mask:this._state.mask})}else if(this._state.state===3){const h=this._incomingData.read(this._state.readLen);this.traceSocketEvent("webSocketNodeSocketReadData",h),c(h,this._state.mask),this.traceSocketEvent("webSocketNodeSocketUnmaskedData",h),this._state.state=1,this._state.readLen=2,this._state.mask=0,this._flowManager.acceptFrame(h,this._state.compressed,!!this._state.fin)}}}async drain(){this.traceSocketEvent("webSocketNodeSocketDrainBegin"),this._flowManager.isProcessingWriteQueue()&&await k.Event.toPromise(this._flowManager.onDidFinishProcessingWriteQueue),await this.socket.drain(),this.traceSocketEvent("webSocketNodeSocketDrainEnd")}}e.WebSocketNodeSocket=S;class C extends L.Disposable{constructor(a,h,p,R,M,O){super();this._tracer=a,this._onData=M,this._writeFn=O,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._writeQueue=[],this._readQueue=[],this._onDidFinishProcessingWriteQueue=this._register(new k.Emitter),this.onDidFinishProcessingWriteQueue=this._onDidFinishProcessingWriteQueue.event,this._isProcessingWriteQueue=!1,this._isProcessingReadQueue=!1,h?(this._zlibInflateStream=this._register(new m(this._tracer,R,p,{windowBits:15})),this._zlibDeflateStream=this._register(new g(this._tracer,{windowBits:15})),this._register(this._zlibInflateStream.onError(F=>this._onError.fire(F))),this._register(this._zlibDeflateStream.onError(F=>this._onError.fire(F)))):(this._zlibInflateStream=null,this._zlibDeflateStream=null)}get permessageDeflate(){return Boolean(this._zlibInflateStream&&this._zlibDeflateStream)}get recordedInflateBytes(){return this._zlibInflateStream?this._zlibInflateStream.recordedInflateBytes:D.VSBuffer.alloc(0)}writeMessage(a){this._writeQueue.push(a),this._processWriteQueue()}async _processWriteQueue(){if(!this._isProcessingWriteQueue){for(this._isProcessingWriteQueue=!0;this._writeQueue.length>0;){const a=this._writeQueue.shift();if(this._zlibDeflateStream){const h=await this._deflateMessage(this._zlibDeflateStream,a);this._writeFn(h,!0)}else this._writeFn(a,!1)}this._isProcessingWriteQueue=!1,this._onDidFinishProcessingWriteQueue.fire()}}isProcessingWriteQueue(){return this._isProcessingWriteQueue}_deflateMessage(a,h){return new Promise((p,R)=>{a.write(h),a.flush(M=>p(M))})}acceptFrame(a,h,p){this._readQueue.push({data:a,isCompressed:h,isLastFrameOfMessage:p}),this._processReadQueue()}async _processReadQueue(){if(!this._isProcessingReadQueue){for(this._isProcessingReadQueue=!0;this._readQueue.length>0;){const a=this._readQueue.shift();if(this._zlibInflateStream&&a.isCompressed){const h=await this._inflateFrame(this._zlibInflateStream,a.data,a.isLastFrameOfMessage);this._onData.fire(h)}else this._onData.fire(a.data)}this._isProcessingReadQueue=!1}}_inflateFrame(a,h,p){return new Promise((R,M)=>{a.write(h),p&&a.write(D.VSBuffer.fromByteArray([0,0,255,255])),a.flush(O=>R(O))})}}class m extends L.Disposable{constructor(a,h,p,R){super();this._tracer=a,this._recordInflateBytes=h,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._recordedInflateBytes=[],this._pendingInflateData=[],this._zlibInflate=w().zlib.createInflateRaw(R),this._zlibInflate.on("error",M=>{this._tracer.traceSocketEvent("zlibInflateError",{message:M?.message,code:M?.code}),this._onError.fire(M)}),this._zlibInflate.on("data",M=>{this._tracer.traceSocketEvent("zlibInflateData",M),this._pendingInflateData.push(D.VSBuffer.wrap(M))}),p&&(this._tracer.traceSocketEvent("zlibInflateInitialWrite",p.buffer),this._zlibInflate.write(p.buffer),this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateInitialFlushFired"),this._pendingInflateData.length=0}))}get recordedInflateBytes(){return this._recordInflateBytes?D.VSBuffer.concat(this._recordedInflateBytes):D.VSBuffer.alloc(0)}write(a){this._recordInflateBytes&&this._recordedInflateBytes.push(a.clone()),this._tracer.traceSocketEvent("zlibInflateWrite",a),this._zlibInflate.write(a.buffer)}flush(a){this._zlibInflate.flush(()=>{this._tracer.traceSocketEvent("zlibInflateFlushFired");const h=D.VSBuffer.concat(this._pendingInflateData);this._pendingInflateData.length=0,a(h)})}}class g extends L.Disposable{constructor(a,h){super();this._tracer=a,this._onError=this._register(new k.Emitter),this.onError=this._onError.event,this._pendingDeflateData=[],this._zlibDeflate=w().zlib.createDeflateRaw({windowBits:15}),this._zlibDeflate.on("error",p=>{this._tracer.traceSocketEvent("zlibDeflateError",{message:p?.message,code:p?.code}),this._onError.fire(p)}),this._zlibDeflate.on("data",p=>{this._tracer.traceSocketEvent("zlibDeflateData",p),this._pendingDeflateData.push(D.VSBuffer.wrap(p))})}write(a){this._tracer.traceSocketEvent("zlibDeflateWrite",a.buffer),this._zlibDeflate.write(a.buffer)}flush(a){this._zlibDeflate.flush(2,()=>{this._tracer.traceSocketEvent("zlibDeflateFlushFired");let h=D.VSBuffer.concat(this._pendingDeflateData);this._pendingDeflateData.length=0,h=h.slice(0,h.byteLength-4),a(h)})}}function c(l,a){if(a===0)return;const h=l.byteLength>>>2;for(let T=0;T<h;T++){const N=l.readUInt32BE(T*4);l.writeUInt32BE(N^a,T*4)}const p=h*4,R=l.byteLength-p,M=a>>>24&255,O=a>>>16&255,F=a>>>8&255;R>=1&&l.writeUInt8(l.readUInt8(p)^M,p),R>=2&&l.writeUInt8(l.readUInt8(p+1)^O,p+1),R>=3&&l.writeUInt8(l.readUInt8(p+2)^F,p+2)}e.XDG_RUNTIME_DIR=typeof process!="undefined"?process.env.XDG_RUNTIME_DIR:void 0;const d={[2]:107,[1]:103};function u(){const l=(0,P.generateUuid)();if(process.platform==="win32")return`\\\\.\\pipe\\vscode-ipc-${l}-sock`;let a;return e.XDG_RUNTIME_DIR?a=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-ipc-${l}.sock`):a=(0,A.join)(w().os.tmpdir(),`vscode-ipc-${l}.sock`),r(a),a}e.createRandomIPCHandle=u;function s(l,a,h){const p=w().crypto.createHash("md5").update(l).digest("hex");if(process.platform==="win32")return`\\\\.\\pipe\\${p}-${h}-${a}-sock`;let R;return e.XDG_RUNTIME_DIR&&!process.env.VSCODE_PORTABLE?R=(0,A.join)(e.XDG_RUNTIME_DIR,`vscode-${p.substr(0,8)}-${h}-${a}.sock`):R=(0,A.join)(l,`${h}-${a}.sock`),r(R),R}e.createStaticIPCHandle=s;function r(l){const a=d[b.platform];typeof a=="number"&&l.length>=a&&console.warn(`WARNING: IPC handle "${l}" is longer than ${a} chars, try a shorter --user-data-dir`)}class t extends I.IPCServer{constructor(a){super(t.toClientConnectionEvent(a));this.server=a}static toClientConnectionEvent(a){const h=k.Event.fromNodeEventEmitter(a,"connection");return k.Event.map(h,p=>({protocol:new E.Protocol(new v(p,"ipc-server-connection")),onDidClientDisconnect:k.Event.once(k.Event.fromNodeEventEmitter(p,"close"))}))}dispose(){super.dispose(),this.server&&(this.server.close(),this.server=null)}}e.Server=t;function i(l){return new Promise((a,h)=>{const p=w().net.createServer();p.on("error",h),p.listen(l,()=>{p.removeListener("error",h),a(new t(p))})})}e.serve=i;function o(l,a){return new Promise((h,p)=>{const R=w().net.createConnection(l,()=>{R.removeListener("error",p),h(E.Client.fromSocket(new v(R,`ipc-client${a}`),a))});R.once("error",p)})}e.connect=o}),define(re[86],se([0,1,6,3,2,15]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InMemoryStorageDatabase=e.Storage=e.StorageState=e.isStorageItemsChangeEvent=e.StorageHint=void 0;var A;(function(w){w[w.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=e.StorageHint||(e.StorageHint={}));function b(w){const v=w;return v?.changed instanceof Map||v?.deleted instanceof Set}e.isStorageItemsChangeEvent=b;var P;(function(w){w[w.None=0]="None",w[w.Initialized=1]="Initialized",w[w.Closed=2]="Closed"})(P=e.StorageState||(e.StorageState={}));class I extends k.Disposable{constructor(v,y=Object.create(null)){super();this.database=v,this.options=y,this._onDidChangeStorage=this._register(new n.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=P.None,this.cache=new Map,this.flushDelayer=new D.ThrottledDelayer(I.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(v=>this.onDidChangeItemsExternal(v)))}onDidChangeItemsExternal(v){v.changed?.forEach((y,f)=>this.accept(f,y)),v.deleted?.forEach(y=>this.accept(y,void 0))}accept(v,y){if(this.state===P.Closed)return;let f=!1;(0,L.isUndefinedOrNull)(y)?f=this.cache.delete(v):this.cache.get(v)!==y&&(this.cache.set(v,y),f=!0),f&&this._onDidChangeStorage.fire(v)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===P.None&&(this.state=P.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(v,y){const f=this.cache.get(v);return(0,L.isUndefinedOrNull)(f)?y:f}getBoolean(v,y){const f=this.get(v);return(0,L.isUndefinedOrNull)(f)?y:f==="true"}getNumber(v,y){const f=this.get(v);return(0,L.isUndefinedOrNull)(f)?y:parseInt(f,10)}async set(v,y){if(this.state===P.Closed)return;if((0,L.isUndefinedOrNull)(y))return this.delete(v);const f=String(y);if(this.cache.get(v)!==f)return this.cache.set(v,f),this.pendingInserts.set(v,f),this.pendingDeletes.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async delete(v){if(!(this.state===P.Closed||!this.cache.delete(v)))return this.pendingDeletes.has(v)||this.pendingDeletes.add(v),this.pendingInserts.delete(v),this._onDidChangeStorage.fire(v),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=P.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const v={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(v).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(v){if(!!this.hasPending)return this.doFlush(v)}async doFlush(v){return this.flushDelayer.trigger(()=>this.flushPending(),v)}async whenFlushed(){if(!!this.hasPending)return new Promise(v=>this.whenFlushedCallbacks.push(v))}dispose(){this.flushDelayer.dispose(),super.dispose()}}e.Storage=I,I.DEFAULT_FLUSH_DELAY=100;class E{constructor(){this.onDidChangeItemsExternal=n.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(v){v.insert?.forEach((y,f)=>this.items.set(f,y)),v.delete?.forEach(y=>this.items.delete(y))}async close(){}}e.InMemoryStorageDatabase=E}),define(re[135],se([11,12]),function(X,e){return X.create("vs/base/node/zip",e)}),define(re[136],se([11,12]),function(X,e){return X.create("vs/platform/configuration/common/configurationRegistry",e)}),define(re[137],se([11,12]),function(X,e){return X.create("vs/platform/environment/node/argv",e)}),define(re[138],se([11,12]),function(X,e){return X.create("vs/platform/environment/node/argvHelper",e)}),define(re[139],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",e)}),define(re[140],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(re[141],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/common/extensionsScannerService",e)}),define(re[142],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/electron-sandbox/extensionTipsService",e)}),define(re[143],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementService",e)}),define(re[144],se([11,12]),function(X,e){return X.create("vs/platform/extensionManagement/node/extensionManagementUtil",e)}),define(re[145],se([11,12]),function(X,e){return X.create("vs/platform/extensions/common/extensionValidator",e)}),define(re[146],se([11,12]),function(X,e){return X.create("vs/platform/files/common/fileService",e)}),define(re[147],se([11,12]),function(X,e){return X.create("vs/platform/files/common/files",e)}),define(re[148],se([11,12]),function(X,e){return X.create("vs/platform/files/common/io",e)}),define(re[149],se([11,12]),function(X,e){return X.create("vs/platform/files/node/diskFileSystemProvider",e)}),define(re[150],se([11,12]),function(X,e){return X.create("vs/platform/languagePacks/common/languagePacks",e)}),define(re[151],se([11,12]),function(X,e){return X.create("vs/platform/request/common/request",e)}),define(re[152],se([11,12]),function(X,e){return X.create("vs/platform/shell/node/shellEnv",e)}),define(re[153],se([11,12]),function(X,e){return X.create("vs/platform/telemetry/common/telemetryService",e)}),define(re[154],se([11,12]),function(X,e){return X.create("vs/platform/terminal/common/terminalPlatformConfiguration",e)}),define(re[155],se([11,12]),function(X,e){return X.create("vs/platform/terminal/common/terminalProfiles",e)}),define(re[156],se([11,12]),function(X,e){return X.create("vs/platform/userDataProfile/common/userDataProfile",e)}),define(re[157],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/abstractSynchronizer",e)}),define(re[158],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/keybindingsSync",e)}),define(re[159],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/settingsSync",e)}),define(re[160],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataAutoSyncService",e)}),define(re[161],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSync",e)}),define(re[162],se([11,12]),function(X,e){return X.create("vs/platform/userDataSync/common/userDataSyncMachines",e)}),define(re[163],se([11,12]),function(X,e){return X.create("vs/platform/workspace/common/workspace",e)}),define(re[87],se([0,1,61,60,20,10,36,17,7]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parsePtyHostPort=e.parseSearchPort=e.parseExtensionHostPort=e.AbstractNativeEnvironmentService=void 0;class I{constructor(S,C,m){this._args=S,this.paths=C,this.productService=m,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,L.dirname)(k.FileAccess.asFileUri("",X).fsPath)}get userHome(){return P.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return P.URI.file((0,L.join)(this.userDataPath,"User"))}get tmpDir(){return P.URI.file(this.paths.tmpDir)}get cacheHome(){return P.URI.file(this.userDataPath)}get stateResource(){return(0,b.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,b.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const S=(0,D.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,L.join)(this.userDataPath,"logs",S)}return this.args.logsPath}get userDataSyncLogResource(){return P.URI.file((0,L.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return P.URI.file((0,L.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,b.joinPath)(P.URI.file((0,L.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,b.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,b.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,b.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,L.join)(S,"argv.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return P.URI.file((0,L.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,L.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const S=this.args["builtin-extensions-dir"];return S?(0,L.resolve)(S):(0,L.normalize)((0,L.join)(k.FileAccess.asFileUri("",X).fsPath,"..","extensions"))}get extensionsDownloadPath(){const S=this.args["extensions-download-dir"];return S?(0,L.resolve)(S):(0,L.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const S=this.args["extensions-dir"];if(S)return(0,L.resolve)(S);const C=A.env.VSCODE_EXTENSIONS;if(C)return C;const m=A.env.VSCODE_PORTABLE;return m?(0,L.join)(m,"extensions"):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const S=this.args.extensionDevelopmentPath;if(Array.isArray(S))return S.map(C=>/^[^:/?#]+?:\/\//.test(C)?P.URI.parse(C):P.URI.file((0,L.normalize)(C)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(S=>S==="ui"||S==="workspace"||S==="web"?S:"workspace")}get extensionTestsLocationURI(){const S=this.args.extensionTestsPath;if(S)return/^[^:/?#]+?:\/\//.test(S)?P.URI.parse(S):P.URI.file((0,L.normalize)(S))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const S=this.args["disable-extension"];if(S){if(typeof S=="string")return[S];if(Array.isArray(S)&&S.length>0)return S}return!1}get debugExtensionHost(){return E(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,b.joinPath)(P.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return P.URI.file((0,L.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const S=A.env.VSCODE_PORTABLE;return S?P.URI.file((0,L.join)(S,"policy.json")):(0,b.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}me([n.memoize],I.prototype,"appRoot",null),me([n.memoize],I.prototype,"userHome",null),me([n.memoize],I.prototype,"userDataPath",null),me([n.memoize],I.prototype,"appSettingsHome",null),me([n.memoize],I.prototype,"tmpDir",null),me([n.memoize],I.prototype,"cacheHome",null),me([n.memoize],I.prototype,"stateResource",null),me([n.memoize],I.prototype,"userRoamingDataHome",null),me([n.memoize],I.prototype,"userDataSyncHome",null),me([n.memoize],I.prototype,"userDataSyncLogResource",null),me([n.memoize],I.prototype,"editSessionsLogResource",null),me([n.memoize],I.prototype,"sync",null),me([n.memoize],I.prototype,"machineSettingsResource",null),me([n.memoize],I.prototype,"workspaceStorageHome",null),me([n.memoize],I.prototype,"localHistoryHome",null),me([n.memoize],I.prototype,"keyboardLayoutResource",null),me([n.memoize],I.prototype,"argvResource",null),me([n.memoize],I.prototype,"isExtensionDevelopment",null),me([n.memoize],I.prototype,"untitledWorkspacesHome",null),me([n.memoize],I.prototype,"installSourcePath",null),me([n.memoize],I.prototype,"builtinExtensionsPath",null),me([n.memoize],I.prototype,"extensionsPath",null),me([n.memoize],I.prototype,"extensionDevelopmentLocationURI",null),me([n.memoize],I.prototype,"extensionDevelopmentKind",null),me([n.memoize],I.prototype,"extensionTestsLocationURI",null),me([n.memoize],I.prototype,"debugExtensionHost",null),me([n.memoize],I.prototype,"serviceMachineIdResource",null),me([n.memoize],I.prototype,"telemetryLogResource",null),me([n.memoize],I.prototype,"disableWorkspaceTrust",null),me([n.memoize],I.prototype,"policyFile",null),e.AbstractNativeEnvironmentService=I;function E(f,S){return y(f["inspect-extensions"],f["inspect-brk-extensions"],5870,S,f.debugId,f.extensionEnvironment)}e.parseExtensionHostPort=E;function w(f,S){return y(f["inspect-search"],f["inspect-brk-search"],5876,S,f.extensionEnvironment)}e.parseSearchPort=w;function v(f,S){return y(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,S,f.extensionEnvironment)}e.parsePtyHostPort=v;function y(f,S,C,m,g,c){const u=Number(S||f)||(m?null:C),s=u?Boolean(!!S):!1;let r;if(c)try{r=JSON.parse(c)}catch{}return{port:u,break:s,debugId:g,env:r}}}),define(re[164],se([0,1,268,4,137]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buildVersionMessage=e.buildHelpMessage=e.formatOptions=e.parseArgs=e.OPTIONS=void 0;const L={o:(0,k.localize)(0,null),e:(0,k.localize)(1,null),t:(0,k.localize)(2,null)};e.OPTIONS={diff:{type:"boolean",cat:"o",alias:"d",args:["file","file"],description:(0,k.localize)(3,null)},merge:{type:"boolean",cat:"o",alias:"m",args:["path1","path2","base","result"],description:(0,k.localize)(4,null)},add:{type:"boolean",cat:"o",alias:"a",args:"folder",description:(0,k.localize)(5,null)},goto:{type:"boolean",cat:"o",alias:"g",args:"file:line[:character]",description:(0,k.localize)(6,null)},"new-window":{type:"boolean",cat:"o",alias:"n",description:(0,k.localize)(7,null)},"reuse-window":{type:"boolean",cat:"o",alias:"r",description:(0,k.localize)(8,null)},wait:{type:"boolean",cat:"o",alias:"w",description:(0,k.localize)(9,null)},waitMarkerFilePath:{type:"string"},locale:{type:"string",cat:"o",args:"locale",description:(0,k.localize)(10,null)},"user-data-dir":{type:"string",cat:"o",args:"dir",description:(0,k.localize)(11,null)},help:{type:"boolean",cat:"o",alias:"h",description:(0,k.localize)(12,null)},"extensions-dir":{type:"string",deprecates:["extensionHomePath"],cat:"e",args:"dir",description:(0,k.localize)(13,null)},"extensions-download-dir":{type:"string"},"builtin-extensions-dir":{type:"string"},"list-extensions":{type:"boolean",cat:"e",description:(0,k.localize)(14,null)},"show-versions":{type:"boolean",cat:"e",description:(0,k.localize)(15,null)},category:{type:"string",cat:"e",description:(0,k.localize)(16,null),args:"category"},"install-extension":{type:"string[]",cat:"e",args:"ext-id | path",description:(0,k.localize)(17,null)},"pre-release":{type:"boolean",cat:"e",description:(0,k.localize)(18,null)},"uninstall-extension":{type:"string[]",cat:"e",args:"ext-id",description:(0,k.localize)(19,null)},"enable-proposed-api":{type:"string[]",allowEmptyValue:!0,cat:"e",args:"ext-id",description:(0,k.localize)(20,null)},version:{type:"boolean",cat:"t",alias:"v",description:(0,k.localize)(21,null)},verbose:{type:"boolean",cat:"t",description:(0,k.localize)(22,null)},log:{type:"string",cat:"t",args:"level",description:(0,k.localize)(23,null)},status:{type:"boolean",alias:"s",cat:"t",description:(0,k.localize)(24,null)},"prof-startup":{type:"boolean",cat:"t",description:(0,k.localize)(25,null)},"prof-append-timers":{type:"string"},"no-cached-data":{type:"boolean"},"prof-startup-prefix":{type:"string"},"prof-v8-extensions":{type:"boolean"},"disable-extensions":{type:"boolean",deprecates:["disableExtensions"],cat:"t",description:(0,k.localize)(26,null)},"disable-extension":{type:"string[]",cat:"t",args:"ext-id",description:(0,k.localize)(27,null)},sync:{type:"string",cat:"t",description:(0,k.localize)(28,null),args:["on | off"]},"inspect-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugPluginHost"],args:"port",cat:"t",description:(0,k.localize)(29,null)},"inspect-brk-extensions":{type:"string",allowEmptyValue:!0,deprecates:["debugBrkPluginHost"],args:"port",cat:"t",description:(0,k.localize)(30,null)},"disable-gpu":{type:"boolean",cat:"t",description:(0,k.localize)(31,null)},"ms-enable-electron-run-as-node":{type:"boolean"},"max-memory":{type:"string",cat:"t",description:(0,k.localize)(32,null),args:"memory"},telemetry:{type:"boolean",cat:"t",description:(0,k.localize)(33,null)},remote:{type:"string",allowEmptyValue:!0},"folder-uri":{type:"string[]",cat:"o",args:"uri"},"file-uri":{type:"string[]",cat:"o",args:"uri"},"locate-extension":{type:"string[]"},extensionDevelopmentPath:{type:"string[]"},extensionDevelopmentKind:{type:"string[]"},extensionTestsPath:{type:"string"},extensionEnvironment:{type:"string"},debugId:{type:"string"},debugRenderer:{type:"boolean"},"inspect-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-brk-ptyhost":{type:"string",allowEmptyValue:!0},"inspect-search":{type:"string",deprecates:["debugSearch"],allowEmptyValue:!0},"inspect-brk-search":{type:"string",deprecates:["debugBrkSearch"],allowEmptyValue:!0},"export-default-configuration":{type:"string"},"install-source":{type:"string"},"enable-smoke-test-driver":{type:"boolean"},logExtensionHostCommunication:{type:"boolean"},"skip-release-notes":{type:"boolean"},"skip-welcome":{type:"boolean"},"disable-telemetry":{type:"boolean"},"disable-updates":{type:"boolean"},"disable-keytar":{type:"boolean"},"disable-workspace-trust":{type:"boolean"},"disable-crash-reporter":{type:"boolean"},"crash-reporter-directory":{type:"string"},"crash-reporter-id":{type:"string"},"skip-add-to-recently-opened":{type:"boolean"},"unity-launch":{type:"boolean"},"open-url":{type:"boolean"},"file-write":{type:"boolean"},"file-chmod":{type:"boolean"},"install-builtin-extension":{type:"string[]"},force:{type:"boolean"},"do-not-sync":{type:"boolean"},trace:{type:"boolean"},"trace-category-filter":{type:"string"},"trace-options":{type:"string"},"force-user-env":{type:"boolean"},"force-disable-user-env":{type:"boolean"},"open-devtools":{type:"boolean"},logsPath:{type:"string"},"__enable-file-policy":{type:"boolean"},editSessionId:{type:"string"},"locate-shell-integration-path":{type:"string",args:["bash","pwsh","zsh"]},"no-proxy-server":{type:"boolean"},"no-sandbox":{type:"boolean",alias:"sandbox"},"proxy-server":{type:"string"},"proxy-bypass-list":{type:"string"},"proxy-pac-url":{type:"string"},"js-flags":{type:"string"},inspect:{type:"string",allowEmptyValue:!0},"inspect-brk":{type:"string",allowEmptyValue:!0},nolazy:{type:"boolean"},"force-device-scale-factor":{type:"string"},"force-renderer-accessibility":{type:"boolean"},"ignore-certificate-errors":{type:"boolean"},"allow-insecure-localhost":{type:"boolean"},"log-net-log":{type:"string"},vmodule:{type:"string"},_urls:{type:"string[]"},"disable-dev-shm-usage":{type:"boolean"},_:{type:"string[]"}};const A={onUnknownOption:()=>{},onMultipleValues:()=>{},onEmptyValue:()=>{},onDeprecatedOption:()=>{}};function b(f,S,C=A){const m={},g=["_"],c=[];for(const r in S){const t=S[r];t.alias&&(m[r]=t.alias),t.type==="string"||t.type==="string[]"?(g.push(r),t.deprecates&&g.push(...t.deprecates)):t.type==="boolean"&&(c.push(r),t.deprecates&&c.push(...t.deprecates))}const d=D(f,{string:g,boolean:c,alias:m}),u={},s=d;u._=d._.map(r=>String(r)).filter(r=>r.length>0),delete s._;for(const r in S){const t=S[r];t.alias&&delete s[t.alias];let i=s[r];if(t.deprecates)for(const o of t.deprecates)s.hasOwnProperty(o)&&(i||(i=s[o],i&&C.onDeprecatedOption(o,t.deprecationMessage||(0,k.localize)(34,null,r))),delete s[o]);if(typeof i!="undefined"){if(t.type==="string[]"){if(Array.isArray(i)||(i=[i]),!t.allowEmptyValue){const o=i.filter(l=>l.length>0);o.length!==i.length&&(C.onEmptyValue(r),i=o.length>0?o:void 0)}}else t.type==="string"&&(Array.isArray(i)?(i=i.pop(),C.onMultipleValues(r,i)):!i&&!t.allowEmptyValue&&(C.onEmptyValue(r),i=void 0));u[r]=i,t.deprecationMessage&&C.onDeprecatedOption(r,t.deprecationMessage)}delete s[r]}for(const r in s)C.onUnknownOption(r);return u}e.parseArgs=b;function P(f,S){let C="";return S.args&&(Array.isArray(S.args)?C=` <${S.args.join("> <")}>`:C=` <${S.args}>`),S.alias?`-${S.alias} --${f}${C}`:`--${f}${C}`}function I(f,S){let C=0;const m=[];for(const u in f){const s=f[u],r=P(u,s);C=Math.max(C,r.length),m.push([r,s.description])}const g=C+2+1;if(S-g<25)return m.reduce((u,s)=>u.concat([`  ${s[0]}`,`      ${s[1]}`]),[]);const c=S-g-1,d=[];for(const u of m){const s=u[0],r=w(u[1],c),t=E(g-s.length-2);d.push("  "+s+t+r[0]);for(let i=1;i<r.length;i++)d.push(E(g)+r[i])}return d}e.formatOptions=I;function E(f){return" ".repeat(f)}function w(f,S){const C=[];for(;f.length;){const m=f.length<S?f.length:f.lastIndexOf(" ",S),g=f.slice(0,m).trim();f=f.slice(m),C.push(g)}return C}function v(f,S,C,m,g){const c=process.stdout.isTTY&&process.stdout.columns||80,d=g?.noInputFiles!==!0?`[${(0,k.localize)(35,null)}...]`:"",u=[`${f} ${C}`];u.push(""),u.push(`${(0,k.localize)(36,null)}: ${S} [${(0,k.localize)(37,null)}]${d}`),u.push(""),g?.noPipe!==!0&&(n.isWindows?u.push((0,k.localize)(38,null,S)):u.push((0,k.localize)(39,null,S)),u.push(""));const s={};for(const r in m){const t=m[r];if(t.description&&t.cat){let i=s[t.cat];i||(s[t.cat]=i={}),i[r]=t}}for(const r in s){const t=r,i=s[t];i&&(u.push(L[t]),u.push(...I(i,c)),u.push(""))}return u.join(`
`)}e.buildHelpMessage=v;function y(f,S){return`${f||(0,k.localize)(40,null)}
${S||(0,k.localize)(41,null)}
${process.arch}`}e.buildVersionMessage=y}),define(re[165],se([0,1,269,138,164]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isLaunchedFromCli=e.addArg=e.parseCLIProcessArgv=e.parseMainProcessArgv=void 0;const L=2048;function A(v,y){const f={onUnknownOption:C=>{console.warn((0,n.localize)(0,null,C))},onMultipleValues:(C,m)=>{console.warn((0,n.localize)(1,null,C,m))},onEmptyValue:C=>{console.warn((0,n.localize)(2,null,C))},onDeprecatedOption:(C,m)=>{console.warn((0,n.localize)(3,null,C,m))}},S=(0,k.parseArgs)(v,k.OPTIONS,y?f:void 0);return S.goto&&S._.forEach(C=>D(/^(\w:)?[^:]+(:\d*){0,2}$/.test(C),(0,n.localize)(4,null))),S["max-memory"]&&D(parseInt(S["max-memory"])>=L,`The max-memory argument cannot be specified lower than ${L} MB.`),S}function b(v){const y=v.findIndex(f=>!/^-/.test(f));if(y>-1)return[...v.slice(0,y),...v.slice(y+1)]}function P(v){let[,...y]=v;process.env.VSCODE_DEV&&(y=b(y)||[]);const f=!w(process.env);return A(y,f)}e.parseMainProcessArgv=P;function I(v){const[,,...y]=v;return A(y,!0)}e.parseCLIProcessArgv=I;function E(v,...y){const f=v.indexOf("--");return f===-1?v.push(...y):v.splice(f,0,...y),v}e.addArg=E;function w(v){return v.VSCODE_CLI==="1"}e.isLaunchedFromCli=w}),function(){"use strict";function X(e,D,n,k){function L(b){const P=A(b),I=[P];return e.isAbsolute(P)||I.unshift(k),e.resolve(...I)}function A(b){const P=process.env.VSCODE_PORTABLE;if(P)return e.join(P,"user-data");let I=process.env.VSCODE_APPDATA;if(I)return e.join(I,n);const E=b["user-data-dir"];if(E)return E;switch(process.platform){case"win32":if(I=process.env.APPDATA,!I){const w=process.env.USERPROFILE;if(typeof w!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");I=e.join(w,"AppData","Roaming")}break;case"darwin":I=e.join(D.homedir(),"Library","Application Support");break;case"linux":I=process.env.XDG_CONFIG_HOME||e.join(D.homedir(),".config");break;default:throw new Error("Platform not supported")}return e.join(I,n)}return{getUserDataPath:L}}if(typeof define=="function")define(re[166],se([0,270,37,20,17,36]),function(e,D,n,k,L,A){const b=L.dirname(k.FileAccess.asFileUri("",e)),P=e.__$__nodeRequire(L.joinPath(b,"package.json").fsPath);return X(D,n,P.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const e=require("../../../../../package.json"),D=require("path"),n=require("os");module.exports=X(D,n,e.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(re[167],se([0,1,37,87,166]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeEnvironmentService=void 0;class L extends n.AbstractNativeEnvironmentService{constructor(b,P){super(b,{homeDir:(0,D.homedir)(),tmpDir:(0,D.tmpdir)(),userDataDir:(0,k.getUserDataPath)(b)},P)}}e.NativeEnvironmentService=L}),define(re[168],se([0,1,7]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getRemotes=e.getDomainsOfRemotes=e.AllowedSecondLevelDomains=void 0;const n=/^([^@:]+@)?([^:]+):/,k=/^([^@:]+@)?([^:]+):(.+)$/,L=/^([^@]+@)?([^:]+)(:\d+)?$/,A=/([^@:.]+\.[^@:.]+)(:\d+)?$/,b=/^\s*url\s*=\s*(.+\S)\s*$/mg,P=/[^.]/g;e.AllowedSecondLevelDomains=["github.com","bitbucket.org","visualstudio.com","gitlab.com","heroku.com","azurewebsites.net","ibm.com","amazon.com","amazonaws.com","cloudapp.net","rhcloud.com","google.com","azure.com"];function I(C){const m=C.match(A);return m?m[1]:null}function E(C){if(C.indexOf("://")===-1){const m=C.match(n);return m?I(m[2]):null}try{const m=D.URI.parse(C);if(m.authority)return I(m.authority)}catch{}return null}function w(C,m){const g=new Set;let c;for(;c=b.exec(C);){const u=E(c[1]);u&&g.add(u)}const d=new Set(m);return Array.from(g).map(u=>d.has(u)?u:u.replace(P,"a"))}e.getDomainsOfRemotes=w;function v(C){const m=C.match(L);return m?m[2]:null}function y(C,m,g){return C&&m?(g&&m.endsWith(".git")&&(m=m.substr(0,m.length-4)),m.indexOf("/")===0?`${C}${m}`:`${C}/${m}`):null}function f(C,m){if(C.indexOf("://")===-1){const g=C.match(k);if(g)return y(g[2],g[3],m)}try{const g=D.URI.parse(C);if(g.authority)return y(v(g.authority),g.path,m)}catch{}return null}function S(C,m=!1){const g=[];let c;for(;c=b.exec(C);){const d=f(c[1],m);d&&g.push(d)}return g}e.getRemotes=S}),define(re[169],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionRecommendationNotificationServiceChannel=e.ExtensionRecommendationNotificationServiceChannelClient=void 0;class D{constructor(L){this.channel=L}get ignoredRecommendations(){throw new Error("not supported")}promptImportantExtensionsInstallNotification(L,A,b,P){return this.channel.call("promptImportantExtensionsInstallNotification",[L,A,b,P])}promptWorkspaceRecommendations(L){throw new Error("not supported")}hasToIgnoreRecommendationNotifications(){throw new Error("not supported")}}e.ExtensionRecommendationNotificationServiceChannelClient=D;class n{constructor(L){this.service=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,b){switch(A){case"promptImportantExtensionsInstallNotification":return this.service.promptImportantExtensionsInstallNotification(b[0],b[1],b[2],b[3])}throw new Error(`Call not found: ${A}`)}}e.ExtensionRecommendationNotificationServiceChannel=n}),define(re[65],se([0,1,17,80,145,55]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,b=/^-(\d{4})(\d{2})(\d{2})$/;function P(m){return m=m.trim(),m==="*"||A.test(m)}e.isValidVersionStr=P;function I(m){if(!P(m))return null;if(m=m.trim(),m==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const g=m.match(A);return g?{hasCaret:g[1]==="^",hasGreaterEquals:g[1]===">=",majorBase:g[2]==="x"?0:parseInt(g[2],10),majorMustEqual:g[2]!=="x",minorBase:g[4]==="x"?0:parseInt(g[4],10),minorMustEqual:g[4]!=="x",patchBase:g[6]==="x"?0:parseInt(g[6],10),patchMustEqual:g[6]!=="x",preRelease:g[8]||null}:null}e.parseVersion=I;function E(m){if(!m)return null;const g=m.majorBase,c=m.majorMustEqual,d=m.minorBase;let u=m.minorMustEqual;const s=m.patchBase;let r=m.patchMustEqual;m.hasCaret&&(g===0||(u=!1),r=!1);let t=0;if(m.preRelease){const i=b.exec(m.preRelease);if(i){const[,o,l,a]=i;t=Date.UTC(Number(o),Number(l)-1,Number(a))}}return{majorBase:g,majorMustEqual:c,minorBase:d,minorMustEqual:u,patchBase:s,patchMustEqual:r,isMinimum:m.hasGreaterEquals,notBefore:t}}e.normalizeVersion=E;function w(m,g,c){let d;typeof m=="string"?d=E(I(m)):d=m;let u;g instanceof Date?u=g.getTime():typeof g=="string"&&(u=new Date(g).getTime());let s;if(typeof c=="string"?s=E(I(c)):s=c,!d||!s)return!1;const r=d.majorBase,t=d.minorBase,i=d.patchBase;let o=s.majorBase,l=s.minorBase,a=s.patchBase;const h=s.notBefore;let p=s.majorMustEqual,R=s.minorMustEqual,M=s.patchMustEqual;return s.isMinimum?r>o?!0:r<o?!1:t>l?!0:t<l||u&&u<h?!1:i>=a:(r===1&&o===0&&(!p||!R||!M)&&(o=1,l=0,a=0,p=!0,R=!1,M=!1),r<o?!1:r>o?!p:t<l?!1:t>l?!R:i<a?!1:i>a?!M:!(u&&u<h))}e.isValidVersion=w;function v(m,g,c,d,u){const s=[];if(typeof d.publisher!="undefined"&&typeof d.publisher!="string")return s.push([n.default.Error,k.localize(0,null)]),s;if(typeof d.name!="string")return s.push([n.default.Error,k.localize(1,null,"name")]),s;if(typeof d.version!="string")return s.push([n.default.Error,k.localize(2,null,"version")]),s;if(!d.engines)return s.push([n.default.Error,k.localize(3,null,"engines")]),s;if(typeof d.engines.vscode!="string")return s.push([n.default.Error,k.localize(4,null,"engines.vscode")]),s;if(typeof d.extensionDependencies!="undefined"&&!C(d.extensionDependencies))return s.push([n.default.Error,k.localize(5,null,"extensionDependencies")]),s;if(typeof d.activationEvents!="undefined"){if(!C(d.activationEvents))return s.push([n.default.Error,k.localize(6,null,"activationEvents")]),s;if(typeof d.main=="undefined"&&typeof d.browser=="undefined")return s.push([n.default.Error,k.localize(7,null,"activationEvents","main")]),s}if(typeof d.extensionKind!="undefined"&&typeof d.main=="undefined"&&s.push([n.default.Warning,k.localize(8,null,"extensionKind")]),typeof d.main!="undefined"){if(typeof d.main!="string")return s.push([n.default.Error,k.localize(9,null,"main")]),s;{const i=(0,D.joinPath)(c,d.main);(0,D.isEqualOrParent)(i,c)||s.push([n.default.Warning,k.localize(10,null,i.path,c.path)])}if(typeof d.activationEvents=="undefined")return s.push([n.default.Error,k.localize(11,null,"activationEvents","main")]),s}if(typeof d.browser!="undefined"){if(typeof d.browser!="string")return s.push([n.default.Error,k.localize(12,null,"browser")]),s;{const i=(0,D.joinPath)(c,d.browser);(0,D.isEqualOrParent)(i,c)||s.push([n.default.Warning,k.localize(13,null,i.path,c.path)])}if(typeof d.activationEvents=="undefined")return s.push([n.default.Error,k.localize(14,null,"activationEvents","browser")]),s}if(!L.valid(d.version))return s.push([n.default.Error,k.localize(15,null)]),s;const r=[];if(!y(m,g,d,u,r))for(const i of r)s.push([n.default.Error,i]);return s}e.validateExtensionManifest=v;function y(m,g,c,d,u){return d||typeof c.main=="undefined"&&typeof c.browser=="undefined"?!0:S(m,g,c.engines.vscode,u)}e.isValidExtensionVersion=y;function f(m,g,c){return m==="*"||S(g,c,m)}e.isEngineValid=f;function S(m,g,c,d=[]){const u=E(I(c));if(!u)return d.push(k.localize(16,null,c)),!1;if(u.majorBase===0){if(!u.majorMustEqual||!u.minorMustEqual)return d.push(k.localize(17,null,c)),!1}else if(!u.majorMustEqual)return d.push(k.localize(18,null,c)),!1;return w(m,g,u)?!0:(d.push(k.localize(19,null,m,c)),!1)}function C(m){if(!Array.isArray(m))return!1;for(let g=0,c=m.length;g<c;g++)if(typeof m[g]!="string")return!1;return!0}}),define(re[48],se([0,1,16,30]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getServiceMachineId=void 0;async function k(L,A,b){let P=b&&b.get("storage.serviceMachineId",-1)||null;if(P)return P;try{const E=(await A.readFile(L.serviceMachineIdResource)).value.toString();P=(0,n.isUUID)(E)?E:null}catch{P=null}if(!P){P=(0,n.generateUuid)();try{await A.writeFile(L.serviceMachineIdResource,D.VSBuffer.fromString(P))}catch{}}return b?.store("storage.serviceMachineId",P,-1,1),P}e.getServiceMachineId=k}),define(re[56],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class D{constructor(k,L=[],A=!1){this.ctor=k,this.staticArguments=L,this.supportsDelayedInstantiation=A}}e.SyncDescriptor=D}),define(re[88],se([0,1,56]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const n=[];function k(A,b,P){b instanceof D.SyncDescriptor||(b=new D.SyncDescriptor(b,[],P)),n.push([A,b])}e.registerSingleton=k;function L(){return n}e.getSingletonServiceDescriptors=L}),define(re[170],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class D{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=D;class n{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const A of this._nodes.values())A.outgoing.size===0&&L.push(A);return L}insertEdge(L,A){const b=this.lookupOrInsertNode(L),P=this.lookupOrInsertNode(A);b.outgoing.set(this._hashFn(A),P),P.incoming.set(this._hashFn(L),b)}removeNode(L){const A=this._hashFn(L);this._nodes.delete(A);for(const b of this._nodes.values())b.outgoing.delete(A),b.incoming.delete(A)}lookupOrInsertNode(L){const A=this._hashFn(L);let b=this._nodes.get(A);return b||(b=new D(L),this._nodes.set(A,b)),b}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[A,b]of this._nodes)L.push(`${A}, (incoming)[${[...b.incoming.keys()].join(", ")}], (outgoing)[${[...b.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,A]of this._nodes){const b=new Set([L]),P=this._findCycle(A,b);if(P)return P}}_findCycle(L,A){for(const[b,P]of L.outgoing){if(A.has(b))return[...A,b].join(" -> ");A.add(b);const I=this._findCycle(P,A);if(I)return I;A.delete(b)}}}e.Graph=n}),define(re[5],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var D;(function(A){A.serviceIds=new Map,A.DI_TARGET="$di$target",A.DI_DEPENDENCIES="$di$dependencies";function b(P){return P[A.DI_DEPENDENCIES]||[]}A.getServiceDependencies=b})(D=e._util||(e._util={})),e.IInstantiationService=k("instantiationService");function n(A,b,P){b[D.DI_TARGET]===b?b[D.DI_DEPENDENCIES].push({id:A,index:P}):(b[D.DI_DEPENDENCIES]=[{id:A,index:P}],b[D.DI_TARGET]=b)}function k(A){if(D.serviceIds.has(A))return D.serviceIds.get(A);const b=function(P,I,E){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");n(b,P,E)};return b.toString=()=>A,D.serviceIds.set(A,b),b}e.createDecorator=k;function L(A){return A}e.refineServiceDecorator=L}),define(re[171],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IChecksumService=void 0,e.IChecksumService=(0,D.createDecorator)("checksumService")}),define(re[19],se([0,1,15,7,5]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,k.createDecorator)("configurationService");function L(m){return m&&typeof m=="object"&&(!m.overrideIdentifier||typeof m.overrideIdentifier=="string")&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationOverrides=L;function A(m){return m&&typeof m=="object"&&(!m.overrideIdentifiers||Array.isArray(m.overrideIdentifiers))&&!m.overrideIdentifier&&(!m.resource||m.resource instanceof n.URI)}e.isConfigurationUpdateOverrides=A;var b;(function(m){m[m.APPLICATION=1]="APPLICATION",m[m.USER=2]="USER",m[m.USER_LOCAL=3]="USER_LOCAL",m[m.USER_REMOTE=4]="USER_REMOTE",m[m.WORKSPACE=5]="WORKSPACE",m[m.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",m[m.DEFAULT=7]="DEFAULT",m[m.MEMORY=8]="MEMORY"})(b=e.ConfigurationTarget||(e.ConfigurationTarget={}));function P(m){switch(m){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=P;function I(m,g){const c=Object.create(null);for(const d in m)E(c,d,m[d],g);return c}e.toValuesTree=I;function E(m,g,c,d){const u=g.split("."),s=u.pop();let r=m;for(let t=0;t<u.length;t++){const i=u[t];let o=r[i];switch(typeof o){case"undefined":o=r[i]=Object.create(null);break;case"object":break;default:d(`Ignoring ${g} as ${u.slice(0,t+1).join(".")} is ${JSON.stringify(o)}`);return}r=o}if(typeof r=="object"&&r!==null)try{r[s]=c}catch{d(`Ignoring ${g} as ${u.join(".")} is ${JSON.stringify(r)}`)}else d(`Ignoring ${g} as ${u.join(".")} is ${JSON.stringify(r)}`)}e.addToValueTree=E;function w(m,g){const c=g.split(".");v(m,c)}e.removeFromValueTree=w;function v(m,g){const c=g.shift();if(g.length===0){delete m[c];return}if(Object.keys(m).indexOf(c)!==-1){const d=m[c];typeof d=="object"&&!Array.isArray(d)&&(v(d,g),Object.keys(d).length===0&&delete m[c])}}function y(m,g,c){function d(r,t){let i=r;for(const o of t){if(typeof i!="object"||i===null)return;i=i[o]}return i}const u=g.split("."),s=d(m,u);return typeof s=="undefined"?c:s}e.getConfigurationValue=y;function f(m,g,c){Object.keys(g).forEach(d=>{d!=="__proto__"&&(d in m?D.isObject(m[d])&&D.isObject(g[d])?f(m[d],g[d],c):c&&(m[d]=g[d]):m[d]=g[d])})}e.merge=f;function S(m,g,c){const d=m.inspect(g),u=m.inspect(c);return typeof d.userValue!="undefined"||typeof d.workspaceValue!="undefined"||typeof d.workspaceFolderValue!="undefined"?d.value:typeof u.userValue!="undefined"||typeof u.workspaceValue!="undefined"||typeof u.workspaceFolderValue!="undefined"?u.value:d.defaultValue}e.getMigratedSettingValue=S;function C(m){return m.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=C}),define(re[172],se([0,1,4,26,5]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",D.isMacintosh),L.set("isLinux",D.isLinux),L.set("isWindows",D.isWindows),L.set("isWeb",D.isWeb),L.set("isMacNative",D.isMacintosh&&!D.isWeb),L.set("isEdge",D.isEdge),L.set("isFirefox",D.isFirefox),L.set("isChrome",D.isChrome),L.set("isSafari",D.isSafari);const A=Object.prototype.hasOwnProperty;var b;(function(F){F[F.False=0]="False",F[F.True=1]="True",F[F.Defined=2]="Defined",F[F.Not=3]="Not",F[F.Equals=4]="Equals",F[F.NotEquals=5]="NotEquals",F[F.And=6]="And",F[F.Regex=7]="Regex",F[F.NotRegex=8]="NotRegex",F[F.Or=9]="Or",F[F.In=10]="In",F[F.NotIn=11]="NotIn",F[F.Greater=12]="Greater",F[F.GreaterEquals=13]="GreaterEquals",F[F.Smaller=14]="Smaller",F[F.SmallerEquals=15]="SmallerEquals"})(b=e.ContextKeyExprType||(e.ContextKeyExprType={}));class P{static false(){return w.INSTANCE}static true(){return v.INSTANCE}static has(T){return y.create(T)}static equals(T,N){return f.create(T,N)}static notEquals(T,N){return m.create(T,N)}static regex(T,N){return t.create(T,N)}static in(T,N){return S.create(T,N)}static notIn(T,N){return C.create(T,N)}static not(T){return g.create(T)}static and(...T){return l.create(T,null)}static or(...T){return a.create(T,null,!0)}static greater(T,N){return d.create(T,N)}static greaterEquals(T,N){return u.create(T,N)}static smaller(T,N){return s.create(T,N)}static smallerEquals(T,N){return r.create(T,N)}static deserialize(T,N=!1){if(!!T)return this._deserializeOrExpression(T,N)}static _deserializeOrExpression(T,N){const W=T.split("||");return a.create(W.map(V=>this._deserializeAndExpression(V,N)),null,!0)}static _deserializeAndExpression(T,N){const W=T.split("&&");return l.create(W.map(V=>this._deserializeOne(V,N)),null)}static _deserializeOne(T,N){if(T=T.trim(),T.indexOf("!=")>=0){const W=T.split("!=");return m.create(W[0].trim(),this._deserializeValue(W[1],N))}if(T.indexOf("==")>=0){const W=T.split("==");return f.create(W[0].trim(),this._deserializeValue(W[1],N))}if(T.indexOf("=~")>=0){const W=T.split("=~");return t.create(W[0].trim(),this._deserializeRegexValue(W[1],N))}if(T.indexOf(" not in ")>=0){const W=T.split(" not in ");return C.create(W[0].trim(),W[1].trim())}if(T.indexOf(" in ")>=0){const W=T.split(" in ");return S.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(T)){const W=T.split(">=");return u.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(T)){const W=T.split(">");return d.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(T)){const W=T.split("<=");return r.create(W[0].trim(),W[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(T)){const W=T.split("<");return s.create(W[0].trim(),W[1].trim())}return/^\!\s*/.test(T)?g.create(T.substr(1).trim()):y.create(T)}static _deserializeValue(T,N){if(T=T.trim(),T==="true")return!0;if(T==="false")return!1;const W=/^'([^']*)'$/.exec(T);return W?W[1].trim():T}static _deserializeRegexValue(T,N){if((0,n.isFalsyOrWhitespace)(T)){if(N)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const W=T.indexOf("/"),V=T.lastIndexOf("/");if(W===V||W<0){if(N)throw new Error(`bad regexp-value '${T}', missing /-enclosure`);return console.warn(`bad regexp-value '${T}', missing /-enclosure`),null}const Y=T.slice(W+1,V),$=T[V+1]==="i"?"i":"";try{return new RegExp(Y,$)}catch(J){if(N)throw new Error(`bad regexp-value '${T}', parse error: ${J}`);return console.warn(`bad regexp-value '${T}', parse error: ${J}`),null}}}e.ContextKeyExpr=P;function I(F,T){const N=F?F.substituteConstants():void 0,W=T?T.substituteConstants():void 0;return!N&&!W?!0:!N||!W?!1:N.equals(W)}e.expressionsAreEqualWithConstantSubstitution=I;function E(F,T){return F.cmp(T)}class w{constructor(){this.type=0}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!1}serialize(){return"false"}keys(){return[]}map(T){return this}negate(){return v.INSTANCE}}e.ContextKeyFalseExpr=w,w.INSTANCE=new w;class v{constructor(){this.type=1}cmp(T){return this.type-T.type}equals(T){return T.type===this.type}substituteConstants(){return this}evaluate(T){return!0}serialize(){return"true"}keys(){return[]}map(T){return this}negate(){return w.INSTANCE}}e.ContextKeyTrueExpr=v,v.INSTANCE=new v;class y{constructor(T,N){this.key=T,this.negated=N,this.type=2}static create(T,N=null){const W=L.get(T);return typeof W=="boolean"?W?v.INSTANCE:w.INSTANCE:new y(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:p(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=L.get(this.key);return typeof T=="boolean"?T?v.INSTANCE:w.INSTANCE:this}evaluate(T){return!!T.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(T){return T.mapDefined(this.key)}negate(){return this.negated||(this.negated=g.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=y;class f{constructor(T,N,W){this.key=T,this.value=N,this.negated=W,this.type=4}static create(T,N,W=null){if(typeof N=="boolean")return N?y.create(T,W):g.create(T,W);const V=L.get(T);return typeof V=="boolean"?N===(V?"true":"false")?v.INSTANCE:w.INSTANCE:new f(T,N,W)}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=L.get(this.key);if(typeof T=="boolean"){const N=T?"true":"false";return this.value===N?v.INSTANCE:w.INSTANCE}return this}evaluate(T){return T.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(T){return T.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=m.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class S{constructor(T,N){this.key=T,this.valueKey=N,this.type=10,this.negated=null}static create(T,N){return new S(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.valueKey,T.key,T.valueKey)}equals(T){return T.type===this.type?this.key===T.key&&this.valueKey===T.valueKey:!1}substituteConstants(){return this}evaluate(T){const N=T.getValue(this.valueKey),W=T.getValue(this.key);return Array.isArray(N)?N.includes(W):typeof W=="string"&&typeof N=="object"&&N!==null?A.call(N,W):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(T){return T.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=C.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=S;class C{constructor(T,N){this.key=T,this.valueKey=N,this.type=11,this._negated=S.create(T,N)}static create(T,N){return new C(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:this._negated.cmp(T._negated)}equals(T){return T.type===this.type?this._negated.equals(T._negated):!1}substituteConstants(){return this}evaluate(T){return!this._negated.evaluate(T)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(T){return T.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=C;class m{constructor(T,N,W){this.key=T,this.value=N,this.negated=W,this.type=5}static create(T,N,W=null){if(typeof N=="boolean")return N?g.create(T,W):y.create(T,W);const V=L.get(T);return typeof V=="boolean"?N===(V?"true":"false")?w.INSTANCE:v.INSTANCE:new m(T,N,W)}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){const T=L.get(this.key);if(typeof T=="boolean"){const N=T?"true":"false";return this.value===N?w.INSTANCE:v.INSTANCE}return this}evaluate(T){return T.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(T){return T.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=m;class g{constructor(T,N){this.key=T,this.negated=N,this.type=3}static create(T,N=null){const W=L.get(T);return typeof W=="boolean"?W?w.INSTANCE:v.INSTANCE:new g(T,N)}cmp(T){return T.type!==this.type?this.type-T.type:p(this.key,T.key)}equals(T){return T.type===this.type?this.key===T.key:!1}substituteConstants(){const T=L.get(this.key);return typeof T=="boolean"?T?w.INSTANCE:v.INSTANCE:this}evaluate(T){return!T.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(T){return T.mapNot(this.key)}negate(){return this.negated||(this.negated=y.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=g;function c(F,T){if(typeof F=="string"){const N=parseFloat(F);isNaN(N)||(F=N)}return typeof F=="string"||typeof F=="number"?T(F):w.INSTANCE}class d{constructor(T,N,W){this.key=T,this.value=N,this.negated=W,this.type=12}static create(T,N,W=null){return c(N,V=>new d(T,V,W))}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=r.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=d;class u{constructor(T,N,W){this.key=T,this.value=N,this.negated=W,this.type=13}static create(T,N,W=null){return c(N,V=>new u(T,V,W))}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(T){return T.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=u;class s{constructor(T,N,W){this.key=T,this.value=N,this.negated=W,this.type=14}static create(T,N,W=null){return c(N,V=>new s(T,V,W))}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class r{constructor(T,N,W){this.key=T,this.value=N,this.negated=W,this.type=15}static create(T,N,W=null){return c(N,V=>new r(T,V,W))}cmp(T){return T.type!==this.type?this.type-T.type:R(this.key,this.value,T.key,T.value)}equals(T){return T.type===this.type?this.key===T.key&&this.value===T.value:!1}substituteConstants(){return this}evaluate(T){return typeof this.value=="string"?!1:parseFloat(T.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(T){return T.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=d.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=r;class t{constructor(T,N){this.key=T,this.regexp=N,this.type=7,this.negated=null}static create(T,N){return new t(T,N)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.key<T.key)return-1;if(this.key>T.key)return 1;const N=this.regexp?this.regexp.source:"",W=T.regexp?T.regexp.source:"";return N<W?-1:N>W?1:0}equals(T){if(T.type===this.type){const N=this.regexp?this.regexp.source:"",W=T.regexp?T.regexp.source:"";return this.key===T.key&&N===W}return!1}substituteConstants(){return this}evaluate(T){const N=T.getValue(this.key);return this.regexp?this.regexp.test(N):!1}serialize(){const T=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${T}`}keys(){return[this.key]}map(T){return T.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=t;class i{constructor(T){this._actual=T,this.type=8}static create(T){return new i(T)}cmp(T){return T.type!==this.type?this.type-T.type:this._actual.cmp(T._actual)}equals(T){return T.type===this.type?this._actual.equals(T._actual):!1}substituteConstants(){return this}evaluate(T){return!this._actual.evaluate(T)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(T){return new i(this._actual.map(T))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function o(F){let T=null;for(let N=0,W=F.length;N<W;N++){const V=F[N].substituteConstants();if(F[N]!==V&&T===null){T=[];for(let Y=0;Y<N;Y++)T[Y]=F[Y]}T!==null&&(T[N]=V)}return T===null?F:T}class l{constructor(T,N){this.expr=T,this.negated=N,this.type=6}static create(T,N){return l._normalizeArr(T,N)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const V=E(this.expr[N],T.expr[N]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(T.expr[N]))return!1;return!0}return!1}substituteConstants(){const T=o(this.expr);return T===this.expr?this:l.create(T,this.negated)}evaluate(T){for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].evaluate(T))return!1;return!0}static _normalizeArr(T,N){const W=[];let V=!1;for(const Y of T)if(!!Y){if(Y.type===1){V=!0;continue}if(Y.type===0)return w.INSTANCE;if(Y.type===6){W.push(...Y.expr);continue}W.push(Y)}if(W.length===0&&V)return v.INSTANCE;if(W.length!==0){if(W.length===1)return W[0];W.sort(E);for(let Y=1;Y<W.length;Y++)W[Y-1].equals(W[Y])&&(W.splice(Y,1),Y--);if(W.length===1)return W[0];for(;W.length>1;){const Y=W[W.length-1];if(Y.type!==9)break;W.pop();const $=W.pop(),J=W.length===0,H=a.create(Y.expr.map(B=>l.create([B,$],null)),null,J);H&&(W.push(H),W.sort(E))}return W.length===1?W[0]:new l(W,N)}}serialize(){return this.expr.map(T=>T.serialize()).join(" && ")}keys(){const T=[];for(const N of this.expr)T.push(...N.keys());return T}map(T){return new l(this.expr.map(N=>N.map(T)),null)}negate(){if(!this.negated){const T=[];for(const N of this.expr)T.push(N.negate());this.negated=a.create(T,this,!0)}return this.negated}}class a{constructor(T,N){this.expr=T,this.negated=N,this.type=9}static create(T,N,W){return a._normalizeArr(T,N,W)}cmp(T){if(T.type!==this.type)return this.type-T.type;if(this.expr.length<T.expr.length)return-1;if(this.expr.length>T.expr.length)return 1;for(let N=0,W=this.expr.length;N<W;N++){const V=E(this.expr[N],T.expr[N]);if(V!==0)return V}return 0}equals(T){if(T.type===this.type){if(this.expr.length!==T.expr.length)return!1;for(let N=0,W=this.expr.length;N<W;N++)if(!this.expr[N].equals(T.expr[N]))return!1;return!0}return!1}substituteConstants(){const T=o(this.expr);return T===this.expr?this:a.create(T,this.negated,!1)}evaluate(T){for(let N=0,W=this.expr.length;N<W;N++)if(this.expr[N].evaluate(T))return!0;return!1}static _normalizeArr(T,N,W){let V=[],Y=!1;if(T){for(let $=0,J=T.length;$<J;$++){const H=T[$];if(!!H){if(H.type===0){Y=!0;continue}if(H.type===1)return v.INSTANCE;if(H.type===9){V=V.concat(H.expr);continue}V.push(H)}}if(V.length===0&&Y)return w.INSTANCE;V.sort(E)}if(V.length!==0){if(V.length===1)return V[0];for(let $=1;$<V.length;$++)V[$-1].equals(V[$])&&(V.splice($,1),$--);if(V.length===1)return V[0];if(W){for(let $=0;$<V.length;$++)for(let J=$+1;J<V.length;J++)M(V[$],V[J])&&(V.splice(J,1),J--);if(V.length===1)return V[0]}return new a(V,N)}}serialize(){return this.expr.map(T=>T.serialize()).join(" || ")}keys(){const T=[];for(const N of this.expr)T.push(...N.keys());return T}map(T){return new a(this.expr.map(N=>N.map(T)),null)}negate(){if(!this.negated){const T=[];for(const N of this.expr)T.push(N.negate());for(;T.length>1;){const N=T.shift(),W=T.shift(),V=[];for(const $ of O(N))for(const J of O(W))V.push(l.create([$,J],null));const Y=T.length===0;T.unshift(a.create(V,null,Y))}this.negated=T[0]}return this.negated}}class h extends y{constructor(T,N,W){super(T,null);this._defaultValue=N,typeof W=="object"?h._info.push({...W,key:T}):W!==!0&&h._info.push({key:T,description:W,type:N!=null?typeof N:void 0})}static all(){return h._info.values()}bindTo(T){return T.createKey(this.key,this._defaultValue)}getValue(T){return T.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(T){return f.create(this.key,T)}notEqualsTo(T){return m.create(this.key,T)}}e.RawContextKey=h,h._info=[],e.IContextKeyService=(0,k.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function p(F,T){return F<T?-1:F>T?1:0}function R(F,T,N,W){return F<N?-1:F>N?1:T<W?-1:T>W?1:0}function M(F,T){if(T.type===6&&F.type!==9&&F.type!==6){for(const V of T.expr)if(F.equals(V))return!0}const N=F.negate(),W=O(N).concat(O(T));W.sort(E);for(let V=0;V<W.length;V++){const $=W[V].negate();for(let J=V+1;J<W.length;J++){const H=W[J];if($.equals(H))return!0}}return!1}e.implies=M;function O(F){return F.type===9?F.expr:[F]}}),define(re[89],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullDiagnosticsService=e.isRemoteDiagnosticError=e.IDiagnosticsService=e.ID=void 0,e.ID="diagnosticsService",e.IDiagnosticsService=(0,D.createDecorator)(e.ID);function n(L){return!!L.hostName&&!!L.errorMessage}e.isRemoteDiagnosticError=n;class k{async getPerformanceInfo(A,b){return{}}async getSystemInfo(A,b){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(A,b){return""}async getWorkspaceFileExtensions(A){return{extensions:[]}}async reportWorkspaceStats(A){}}e.NullDiagnosticsService=k}),define(re[90],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDownloadService=void 0,e.IDownloadService=(0,D.createDecorator)("downloadService")}),define(re[14],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,D.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,D.refineServiceDecorator)(e.IEnvironmentService)}),define(re[28],se([0,1,140,5]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function k(m){switch(m){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=k;function L(m){switch(m){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function A(m,g){switch(m){case 3:return g==="x64"?"win32-x64":g==="ia32"?"win32-ia32":g==="arm64"?"win32-arm64":"unknown";case 2:return g==="x64"?"linux-x64":g==="arm64"?"linux-arm64":g==="arm"?"linux-armhf":"unknown";case"alpine":return g==="x64"?"alpine-x64":g==="arm64"?"alpine-arm64":"unknown";case 1:return g==="x64"?"darwin-x64":g==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=A;function b(m,g){return g==="web"&&!m.includes("web")}e.isNotWebExtensionInWebTargetPlatform=b;function P(m,g,c){return b(g,c)?!1:m==="undefined"||m==="universal"?!0:m==="unknown"?!1:m===c?!0:I(c).includes(m)}e.isTargetPlatformCompatible=P;function I(m){switch(m){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=I;function E(m){return m&&typeof m=="object"&&typeof m.id=="string"&&(!m.uuid||typeof m.uuid=="string")}e.isIExtensionIdentifier=E;var w;(function(m){m[m.NoneOrRelevance=0]="NoneOrRelevance",m[m.LastUpdatedDate=1]="LastUpdatedDate",m[m.Title=2]="Title",m[m.PublisherName=3]="PublisherName",m[m.InstallCount=4]="InstallCount",m[m.PublishedDate=10]="PublishedDate",m[m.AverageRating=6]="AverageRating",m[m.WeightedRating=12]="WeightedRating"})(w=e.SortBy||(e.SortBy={}));var v;(function(m){m[m.Default=0]="Default",m[m.Ascending=1]="Ascending",m[m.Descending=2]="Descending"})(v=e.SortOrder||(e.SortOrder={}));var y;(function(m){m.Install="install",m.Uninstall="uninstall"})(y=e.StatisticType||(e.StatisticType={}));var f;(function(m){m[m.None=1]="None",m[m.Install=2]="Install",m[m.Update=3]="Update",m[m.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,n.createDecorator)("extensionGalleryService");var S;(function(m){m.Unsupported="Unsupported",m.Deprecated="Deprecated",m.Malicious="Malicious",m.Incompatible="Incompatible",m.IncompatiblePreRelease="IncompatiblePreRelease",m.IncompatibleTargetPlatform="IncompatibleTargetPlatform",m.ReleaseVersionNotFound="ReleaseVersionNotFound",m.Invalid="Invalid",m.Download="Download",m.Extract="Extract",m.Delete="Delete",m.Rename="Rename",m.CorruptZip="CorruptZip",m.IncompleteZip="IncompleteZip",m.Internal="Internal"})(S=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class C extends Error{constructor(g,c){super(g);this.code=c,this.name=c}}e.ExtensionManagementError=C,e.IExtensionManagementService=(0,n.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,n.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,n.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,n.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,D.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,D.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,n.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,n.createDecorator)("IDefaultExtensionsProfileInitService")}),define(re[173],se([0,1,3,2,63,31,7,127,28]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsChannel=e.ExtensionManagementChannelClient=e.ExtensionManagementChannel=void 0;function I(C,m){return A.URI.revive(m?m.transformIncoming(C):C)}function E(C,m){return m?m.transformOutgoingURI(C):C}function w(C,m){m=m||b.DefaultURITransformer;const g=C.manifest;return{...(0,b.transformAndReviveIncomingURIs)({...C,manifest:void 0},m),manifest:g}}function v(C,m){return m?(0,L.cloneAndChange)(C,g=>g instanceof A.URI?m.transformOutgoingURI(g):void 0):C}class y{constructor(m,g){this.service=m,this.getUriTransformer=g,this.onInstallExtension=D.Event.buffer(m.onInstallExtension,!0),this.onDidInstallExtensions=D.Event.buffer(m.onDidInstallExtensions,!0),this.onUninstallExtension=D.Event.buffer(m.onUninstallExtension,!0),this.onDidUninstallExtension=D.Event.buffer(m.onDidUninstallExtension,!0)}listen(m,g){const c=this.getUriTransformer(m);switch(g){case"onInstallExtension":return this.onInstallExtension;case"onDidInstallExtensions":return D.Event.map(this.onDidInstallExtensions,d=>d.map(u=>({...u,local:u.local?v(u.local,c):u.local})));case"onUninstallExtension":return this.onUninstallExtension;case"onDidUninstallExtension":return this.onDidUninstallExtension}throw new Error("Invalid listen")}call(m,g,c){const d=this.getUriTransformer(m);switch(g){case"zip":return this.service.zip(w(c[0],d)).then(u=>E(u,d));case"unzip":return this.service.unzip(I(c[0],d));case"install":return this.service.install(I(c[0],d),(0,k.revive)(c[1]));case"getManifest":return this.service.getManifest(I(c[0],d));case"getTargetPlatform":return this.service.getTargetPlatform();case"canInstall":return this.service.canInstall(c[0]);case"installFromGallery":return this.service.installFromGallery(c[0],(0,k.revive)(c[1]));case"uninstall":return this.service.uninstall(w(c[0],d),(0,k.revive)(c[1]));case"reinstallFromGallery":return this.service.reinstallFromGallery(w(c[0],d));case"getInstalled":return this.service.getInstalled(c[0],A.URI.revive(c[1])).then(u=>u.map(s=>v(s,d)));case"getMetadata":return this.service.getMetadata(w(c[0],d));case"updateMetadata":return this.service.updateMetadata(w(c[0],d),c[1]).then(u=>v(u,d));case"updateExtensionScope":return this.service.updateExtensionScope(w(c[0],d),c[1]).then(u=>v(u,d));case"getExtensionsControlManifest":return this.service.getExtensionsControlManifest()}throw new Error("Invalid call")}}e.ExtensionManagementChannel=y;class f extends n.Disposable{constructor(m){super();this.channel=m,this._onInstallExtension=this._register(new D.Emitter),this._onDidInstallExtensions=this._register(new D.Emitter),this._onUninstallExtension=this._register(new D.Emitter),this._onDidUninstallExtension=this._register(new D.Emitter),this._register(this.channel.listen("onInstallExtension")(g=>this._onInstallExtension.fire({identifier:g.identifier,source:this.isUriComponents(g.source)?A.URI.revive(g.source):g.source,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidInstallExtensions")(g=>this._onDidInstallExtensions.fire(g.map(c=>({...c,local:c.local?w(c.local,null):c.local,source:this.isUriComponents(c.source)?A.URI.revive(c.source):c.source,profileLocation:A.URI.revive(c.profileLocation)}))))),this._register(this.channel.listen("onUninstallExtension")(g=>this._onUninstallExtension.fire({identifier:g.identifier,profileLocation:A.URI.revive(g.profileLocation)}))),this._register(this.channel.listen("onDidUninstallExtension")(g=>this._onDidUninstallExtension.fire({...g,profileLocation:A.URI.revive(g.profileLocation)})))}get onInstallExtension(){return this._onInstallExtension.event}get onDidInstallExtensions(){return this._onDidInstallExtensions.event}get onUninstallExtension(){return this._onUninstallExtension.event}get onDidUninstallExtension(){return this._onDidUninstallExtension.event}isUriComponents(m){return m?typeof m.path=="string"&&typeof m.scheme=="string":!1}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=this.channel.call("getTargetPlatform")),this._targetPlatformPromise}async canInstall(m){const g=await this.getTargetPlatform();return m.allTargetPlatforms.some(c=>(0,P.isTargetPlatformCompatible)(c,m.allTargetPlatforms,g))}zip(m){return Promise.resolve(this.channel.call("zip",[m]).then(g=>A.URI.revive(g)))}unzip(m){return Promise.resolve(this.channel.call("unzip",[m]))}install(m,g){return Promise.resolve(this.channel.call("install",[m,g])).then(c=>w(c,null))}getManifest(m){return Promise.resolve(this.channel.call("getManifest",[m]))}installFromGallery(m,g){return Promise.resolve(this.channel.call("installFromGallery",[m,g])).then(c=>w(c,null))}uninstall(m,g){return Promise.resolve(this.channel.call("uninstall",[m,g]))}reinstallFromGallery(m){return Promise.resolve(this.channel.call("reinstallFromGallery",[m]))}getInstalled(m=null,g){return Promise.resolve(this.channel.call("getInstalled",[m,g])).then(c=>c.map(d=>w(d,null)))}getMetadata(m){return Promise.resolve(this.channel.call("getMetadata",[m]))}updateMetadata(m,g){return Promise.resolve(this.channel.call("updateMetadata",[m,g])).then(c=>w(c,null))}updateExtensionScope(m,g){return Promise.resolve(this.channel.call("updateExtensionScope",[m,g])).then(c=>w(c,null))}getExtensionsControlManifest(){return Promise.resolve(this.channel.call("getExtensionsControlManifest"))}registerParticipant(){throw new Error("Not Supported")}}e.ExtensionManagementChannelClient=f;class S{constructor(m){this.service=m}listen(m,g){throw new Error("Invalid listen")}call(m,g,c){switch(g){case"getConfigBasedTips":return this.service.getConfigBasedTips(A.URI.revive(c[0]));case"getImportantExecutableBasedTips":return this.service.getImportantExecutableBasedTips();case"getOtherExecutableBasedTips":return this.service.getOtherExecutableBasedTips();case"getAllWorkspacesTips":return this.service.getAllWorkspacesTips()}throw new Error("Invalid call")}}e.ExtensionTipsChannel=S}),define(re[91],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtensionRecommendationNotificationService=e.RecommendationsNotificationResult=e.RecommendationSourceToString=e.RecommendationSource=void 0;var n;(function(A){A[A.FILE=1]="FILE",A[A.WORKSPACE=2]="WORKSPACE",A[A.EXE=3]="EXE"})(n=e.RecommendationSource||(e.RecommendationSource={}));function k(A){switch(A){case 1:return"file";case 2:return"workspace";case 3:return"exe"}}e.RecommendationSourceToString=k;var L;(function(A){A.Ignored="ignored",A.Cancelled="cancelled",A.TooMany="toomany",A.IncompatibleWindow="incompatibleWindow",A.Accepted="reacted"})(L=e.RecommendationsNotificationResult||(e.RecommendationsNotificationResult={})),e.IExtensionRecommendationNotificationService=(0,D.createDecorator)("IExtensionRecommendationNotificationService")}),define(re[13],se([0,1,34,10,26,15,7,147,5]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,P.createDecorator)("fileService");function I($){return $.create===!0}e.isFileOpenForWriteOptions=I;var E;(function($){$[$.Unknown=0]="Unknown",$[$.File=1]="File",$[$.Directory=2]="Directory",$[$.SymbolicLink=64]="SymbolicLink"})(E=e.FileType||(e.FileType={}));var w;(function($){$[$.Readonly=1]="Readonly"})(w=e.FilePermission||(e.FilePermission={}));var v;(function($){$[$.FileReadWrite=2]="FileReadWrite",$[$.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",$[$.FileReadStream=16]="FileReadStream",$[$.FileFolderCopy=8]="FileFolderCopy",$[$.PathCaseSensitive=1024]="PathCaseSensitive",$[$.Readonly=2048]="Readonly",$[$.Trash=4096]="Trash",$[$.FileWriteUnlock=8192]="FileWriteUnlock",$[$.FileAtomicRead=16384]="FileAtomicRead",$[$.FileClone=32768]="FileClone"})(v=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function y($){return!!($.capabilities&2)}e.hasReadWriteCapability=y;function f($){return!!($.capabilities&8)}e.hasFileFolderCopyCapability=f;function S($){return!!($.capabilities&32768)}e.hasFileCloneCapability=S;function C($){return!!($.capabilities&4)}e.hasOpenReadWriteCloseCapability=C;function m($){return!!($.capabilities&16)}e.hasFileReadStreamCapability=m;function g($){return y($)?!!($.capabilities&16384):!1}e.hasFileAtomicReadCapability=g;var c;(function($){$.FileExists="EntryExists",$.FileNotFound="EntryNotFound",$.FileNotADirectory="EntryNotADirectory",$.FileIsADirectory="EntryIsADirectory",$.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",$.FileTooLarge="EntryTooLarge",$.FileWriteLocked="EntryWriteLocked",$.NoPermissions="NoPermissions",$.Unavailable="Unavailable",$.Unknown="Unknown"})(c=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class d extends Error{constructor(J,H){super(J);this.code=H}}e.FileSystemProviderError=d;function u($,J){const H=new d($.toString(),J);return r(H,J),H}e.createFileSystemProviderError=u;function s($){return $||u((0,b.localize)(0,null),c.Unknown)}e.ensureFileSystemProviderError=s;function r($,J){return $.name=J?`${J} (FileSystemError)`:"FileSystemError",$}e.markAsFileSystemProviderError=r;function t($){if(!$)return c.Unknown;if($ instanceof d)return $.code;const J=/^(.+) \(FileSystemError\)$/.exec($.name);if(!J)return c.Unknown;switch(J[1]){case c.FileExists:return c.FileExists;case c.FileIsADirectory:return c.FileIsADirectory;case c.FileNotADirectory:return c.FileNotADirectory;case c.FileNotFound:return c.FileNotFound;case c.FileExceedsMemoryLimit:return c.FileExceedsMemoryLimit;case c.FileTooLarge:return c.FileTooLarge;case c.FileWriteLocked:return c.FileWriteLocked;case c.NoPermissions:return c.NoPermissions;case c.Unavailable:return c.Unavailable}return c.Unknown}e.toFileSystemProviderErrorCode=t;function i($){if($ instanceof R)return $.fileOperationResult;switch(t($)){case c.FileNotFound:return 1;case c.FileIsADirectory:return 0;case c.FileNotADirectory:return 10;case c.FileWriteLocked:return 5;case c.NoPermissions:return 6;case c.FileExists:return 4;case c.FileExceedsMemoryLimit:return 9;case c.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var o;(function($){$[$.CREATE=0]="CREATE",$[$.DELETE=1]="DELETE",$[$.MOVE=2]="MOVE",$[$.COPY=3]="COPY",$[$.WRITE=4]="WRITE"})(o=e.FileOperation||(e.FileOperation={}));class l{constructor(J,H,B){this.resource=J,this.operation=H,this.target=B}isOperation(J){return this.operation===J}}e.FileOperationEvent=l;var a;(function($){$[$.UPDATED=0]="UPDATED",$[$.ADDED=1]="ADDED",$[$.DELETED=2]="DELETED"})(a=e.FileChangeType||(e.FileChangeType={}));class h{constructor(J,H){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=J;const B=new Map;for(const K of J){const ie=B.get(K.type);switch(ie?ie.push([K.resource,K]):B.set(K.type,[[K.resource,K]]),K.type){case 1:this.rawAdded.push(K.resource);break;case 0:this.rawUpdated.push(K.resource);break;case 2:this.rawDeleted.push(K.resource);break}}for(const[K,ie]of B)switch(K){case 1:this.added=D.TernarySearchTree.forUris(()=>H),this.added.fill(ie);break;case 0:this.updated=D.TernarySearchTree.forUris(()=>H),this.updated.fill(ie);break;case 2:this.deleted=D.TernarySearchTree.forUris(()=>H),this.deleted.fill(ie);break}}contains(J,...H){return this.doContains(J,{includeChildren:!1},...H)}affects(J,...H){return this.doContains(J,{includeChildren:!0},...H)}doContains(J,H,...B){if(!J)return!1;const K=B.length>0;return!!((!K||B.includes(1))&&(this.added?.get(J)||H.includeChildren&&this.added?.findSuperstr(J))||(!K||B.includes(0))&&(this.updated?.get(J)||H.includeChildren&&this.updated?.findSuperstr(J))||(!K||B.includes(2))&&(this.deleted?.findSubstr(J)||H.includeChildren&&this.deleted?.findSuperstr(J)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=h;function p($,J,H){return!$||!J||$===J||J.length>$.length?!1:(J.charAt(J.length-1)!==n.sep&&(J+=n.sep),H?(0,k.startsWithIgnoreCase)($,J):$.indexOf(J)===0)}e.isParent=p;class R extends Error{constructor(J,H,B){super(J);this.fileOperationResult=H,this.options=B}}e.FileOperationError=R;class M extends R{constructor(J,H,B){super(J,2,B);this.stat=H}}e.NotModifiedSinceFileOperationError=M;var O;(function($){$[$.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",$[$.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",$[$.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",$[$.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",$[$.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",$[$.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",$[$.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",$[$.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",$[$.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",$[$.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",$[$.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",$[$.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(O=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var F;(function($){$[$.FILE=0]="FILE",$[$.FOLDER=1]="FOLDER",$[$.ROOT_FOLDER=2]="ROOT_FOLDER"})(F=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function T($){if(!(typeof $.size!="number"||typeof $.mtime!="number"))return $.mtime.toString(29)+$.size.toString(31)}e.etag=T;async function N($,J){if(!J.hasProvider(A.URI.from({scheme:$.scheme})))return new Promise(H=>{const B=J.onDidChangeFileSystemProviderRegistrations(K=>{K.scheme===$.scheme&&K.added&&(B.dispose(),H())})})}e.whenProviderRegistered=N,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class W{static formatSize(J){return(0,L.isNumber)(J)||(J=0),J<W.KB?(0,b.localize)(1,null,J.toFixed(0)):J<W.MB?(0,b.localize)(2,null,(J/W.KB).toFixed(2)):J<W.GB?(0,b.localize)(3,null,(J/W.MB).toFixed(2)):J<W.TB?(0,b.localize)(4,null,(J/W.GB).toFixed(2)):(0,b.localize)(5,null,(J/W.TB).toFixed(2))}}e.ByteSize=W,W.KB=1024,W.MB=W.KB*W.KB,W.GB=W.MB*W.KB,W.TB=W.GB*W.KB;var V;(function($){$[$.IA32=0]="IA32",$[$.OTHER=1]="OTHER"})(V=e.Arch||(e.Arch={}));function Y($){return{maxFileSize:$===0?300*W.MB:16*W.GB,maxHeapSize:$===0?700*W.MB:2*700*W.MB}}e.getPlatformLimits=Y});var G=this&&this.__param||function(X,e){return function(D,n){e(D,n,X)}};define(re[174],se([0,1,175,41,13]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ChecksumService=void 0;let L=class{constructor(b){this.fileService=b}async checksum(b){const P=(await this.fileService.readFileStream(b)).value;return new Promise((I,E)=>{const w=(0,D.createHash)("md5");(0,n.listenStream)(P,{onData:v=>w.update(v.buffer),onError:v=>E(v),onEnd:()=>I(w.digest("base64").replace(/=+$/,""))})})}};L=me([G(0,k.IFileService)],L),e.ChecksumService=L}),define(re[176],se([0,1,16,38,9,3,2,41,7,30,13]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProviderClient=e.LOCAL_FILE_SYSTEM_CHANNEL_NAME=void 0,e.LOCAL_FILE_SYSTEM_CHANNEL_NAME="localFilesystem";class w extends A.Disposable{constructor(y,f){super();this.channel=y,this.extraCapabilities=f,this.onDidChangeCapabilities=L.Event.None,this._onDidChange=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChange.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.sessionId=(0,I.generateUuid)(),this.registerFileChangeListeners()}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,this.extraCapabilities.pathCaseSensitive&&(this._capabilities|=1024),this.extraCapabilities.trash&&(this._capabilities|=4096)),this._capabilities}stat(y){return this.channel.call("stat",[y])}readdir(y){return this.channel.call("readdir",[y])}async readFile(y,f){const{buffer:S}=await this.channel.call("readFile",[y,f]);return S}readFileStream(y,f,S){const C=(0,b.newWriteableStream)(g=>D.VSBuffer.concat(g.map(c=>D.VSBuffer.wrap(c))).buffer),m=this.channel.listen("readFileStream",[y,f])(g=>{if(g instanceof D.VSBuffer)C.write(g.buffer);else{if(g==="end")C.end();else{let c=g;c instanceof Error||(c=(0,E.createFileSystemProviderError)((0,n.toErrorMessage)(c),E.FileSystemProviderErrorCode.Unknown)),C.error(c),C.end()}m.dispose()}});return S.onCancellationRequested(()=>{C.error((0,k.canceled)()),C.end(),m.dispose()}),C}writeFile(y,f,S){return this.channel.call("writeFile",[y,D.VSBuffer.wrap(f),S])}open(y,f){return this.channel.call("open",[y,f])}close(y){return this.channel.call("close",[y])}async read(y,f,S,C,m){const[g,c]=await this.channel.call("read",[y,f,m]);return S.set(g.buffer.slice(0,c),C),c}write(y,f,S,C,m){return this.channel.call("write",[y,f,D.VSBuffer.wrap(S),C,m])}mkdir(y){return this.channel.call("mkdir",[y])}delete(y,f){return this.channel.call("delete",[y,f])}rename(y,f,S){return this.channel.call("rename",[y,f,S])}copy(y,f,S){return this.channel.call("copy",[y,f,S])}cloneFile(y,f){return this.channel.call("cloneFile",[y,f])}registerFileChangeListeners(){this._register(this.channel.listen("fileChange",[this.sessionId])(y=>{if(Array.isArray(y)){const f=y;this._onDidChange.fire(f.map(S=>({resource:P.URI.revive(S.resource),type:S.type})))}else{const f=y;this._onDidWatchError.fire(f)}}))}watch(y,f){const S=(0,I.generateUuid)();return this.channel.call("watch",[this.sessionId,S,y,f]),(0,A.toDisposable)(()=>this.channel.call("unwatch",[this.sessionId,S]))}}e.DiskFileSystemProviderClient=w}),define(re[92],se([0,1,16,9,148,13]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.readFileIntoStream=void 0;async function A(E,w,v,y,f,S){let C;try{await b(E,w,v,y,f,S)}catch(m){C=m}finally{C&&f.errorTransformer&&(C=f.errorTransformer(C)),typeof C!="undefined"&&v.error(C),v.end()}}e.readFileIntoStream=A;async function b(E,w,v,y,f,S){P(S);const C=await E.open(w,{create:!1});try{P(S);let m=0,g=0,c=f&&typeof f.length=="number"?f.length:void 0,d=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),u=f&&typeof f.position=="number"?f.position:0,s=0;do g=await E.read(C,u,d.buffer,s,d.byteLength-s),u+=g,s+=g,m+=g,typeof c=="number"&&(c-=g),s===d.byteLength&&(await v.write(y(d)),d=D.VSBuffer.alloc(Math.min(f.bufferSize,typeof c=="number"?c:f.bufferSize)),s=0);while(g>0&&(typeof c!="number"||c>0)&&P(S)&&I(m,f));if(s>0){let r=s;typeof c=="number"&&(r=Math.min(s,c)),v.write(y(d.slice(0,r)))}}catch(m){throw(0,L.ensureFileSystemProviderError)(m)}finally{await E.close(C)}}function P(E){if(E.isCancellationRequested)throw(0,n.canceled)();return!0}function I(E,w){if(w?.limits){if(typeof w.limits.memory=="number"&&E>w.limits.memory)throw(0,L.createFileSystemProviderError)((0,k.localize)(0,null),L.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof w.limits.size=="number"&&E>w.limits.size)throw(0,L.createFileSystemProviderError)((0,k.localize)(1,null),L.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(re[57],se([0,1,81,2,10,4,7,13]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseWatcherPatterns=e.normalizeWatcherPattern=e.coalesceEvents=e.toFileChanges=e.AbstractUniversalWatcherClient=e.AbstractNonRecursiveWatcherClient=e.AbstractWatcherClient=e.isRecursiveWatchRequest=void 0;function P(m){return m.recursive===!0}e.isRecursiveWatchRequest=P;class I extends n.Disposable{constructor(g,c,d,u){super();this.onFileChanges=g,this.onLogMessage=c,this.verboseLogging=d,this.options=u,this.watcherDisposables=this._register(new n.MutableDisposable),this.requests=void 0,this.restartCounter=0}init(){const g=new n.DisposableStore;this.watcherDisposables.value=g,this.watcher=this.createWatcher(g),this.watcher.setVerboseLogging(this.verboseLogging),g.add(this.watcher.onDidChangeFile(c=>this.onFileChanges(c))),g.add(this.watcher.onDidLogMessage(c=>this.onLogMessage(c))),g.add(this.watcher.onDidError(c=>this.onError(c)))}onError(g){this.options.restartOnError?this.restartCounter<I.MAX_RESTARTS&&this.requests?(this.error(`restarting watcher after error: ${g}`),this.restart(this.requests)):this.error(`gave up attempting to restart watcher after error: ${g}`):this.error(g)}restart(g){this.restartCounter++,this.init(),this.watch(g)}async watch(g){this.requests=g,await this.watcher?.watch(g)}async setVerboseLogging(g){this.verboseLogging=g,await this.watcher?.setVerboseLogging(g)}error(g){this.onLogMessage({type:"error",message:`[File Watcher (${this.options.type})] ${g}`})}dispose(){return this.watcher=void 0,super.dispose()}}e.AbstractWatcherClient=I,I.MAX_RESTARTS=5;class E extends I{constructor(g,c,d){super(g,c,d,{type:"node.js",restartOnError:!1})}}e.AbstractNonRecursiveWatcherClient=E;class w extends I{constructor(g,c,d){super(g,c,d,{type:"universal",restartOnError:!0})}}e.AbstractUniversalWatcherClient=w;function v(m){return m.map(g=>({type:g.type,resource:A.URI.file(g.path)}))}e.toFileChanges=v;function y(m){const g=new C;for(const c of m)g.processEvent(c);return g.coalesce()}e.coalesceEvents=y;function f(m,g){return typeof g=="string"&&!g.startsWith(D.GLOBSTAR)&&!(0,k.isAbsolute)(g)?{base:m,pattern:g}:g}e.normalizeWatcherPattern=f;function S(m,g){const c=[];for(const d of g)c.push((0,D.parse)(f(m,d)));return c}e.parseWatcherPatterns=S;class C{constructor(){this.coalesced=new Set,this.mapPathToChange=new Map}toKey(g){return L.isLinux?g.path:g.path.toLowerCase()}processEvent(g){const c=this.mapPathToChange.get(this.toKey(g));let d=!1;if(c){const u=c.type,s=g.type;c.path!==g.path&&(g.type===2||g.type===1)?d=!0:u===1&&s===2?(this.mapPathToChange.delete(this.toKey(g)),this.coalesced.delete(c)):u===2&&s===1?c.type=0:u===1&&s===0||(c.type=s)}else d=!0;d&&(this.coalesced.add(g),this.mapPathToChange.set(this.toKey(g),g))}coalesce(){const g=[],c=[];return Array.from(this.coalesced).filter(d=>d.type!==2?(g.push(d),!1):!0).sort((d,u)=>d.path.length-u.path.length).filter(d=>c.some(u=>(0,b.isParent)(d.path,u,!L.isLinux))?!1:(c.push(d.path),!0)).concat(g)}}}),define(re[177],se([0,1,53,6,21,47,2,79,10,4,129,27,57]),function(X,e,D,n,k,L,A,b,P,I,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.watchFileContents=e.NodeJSFileWatcherLibrary=void 0;class y extends A.Disposable{constructor(C,m,g,c){super();this.request=C,this.onDidFilesChange=m,this.onLogMessage=g,this.verboseLogging=c,this.throttledFileChangesWorker=new n.ThrottledWorker({maxWorkChunkSize:100,throttleDelay:200,maxBufferedWork:1e4},d=>this.onDidFilesChange(d)),this.fileChangesDelayer=this._register(new n.ThrottledDelayer(y.FILE_CHANGES_HANDLER_DELAY)),this.fileChangesBuffer=[],this.excludes=(0,v.parseWatcherPatterns)(this.request.path,this.request.excludes),this.includes=this.request.includes?(0,v.parseWatcherPatterns)(this.request.path,this.request.includes):void 0,this.cts=new k.CancellationTokenSource,this.ready=this.watch()}async watch(){try{const C=await this.normalizePath(this.request);if(this.cts.token.isCancellationRequested)return;const m=await w.Promises.stat(C);this._register(await this.doWatch(C,m.isDirectory()))}catch(C){C.code!=="ENOENT"?this.error(C):this.trace(C)}}async normalizePath(C){let m=C.path;try{m=await w.Promises.realpath(C.path),C.path===m&&(m=await(0,E.realcase)(C.path)??C.path),C.path!==m&&this.trace(`correcting a path to watch that seems to be a symbolic link or wrong casing (original: ${C.path}, real: ${m})`)}catch{}return m}async doWatch(C,m){if(I.isMacintosh&&(0,L.isEqualOrParent)(C,"/Volumes/",!0))return this.error(`Refusing to watch ${C} for changes using fs.watch() for possibly being a network share where watching is unreliable and unstable.`),A.Disposable.None;const g=new k.CancellationTokenSource(this.cts.token),c=new A.DisposableStore;try{const d=(0,P.basename)(C),u=(0,D.watch)(C);c.add((0,A.toDisposable)(()=>{u.removeAllListeners(),u.close()})),this.trace(`Started watching: '${C}'`);const s=new Set;if(m)try{for(const t of await w.Promises.readdir(C))s.add(t)}catch(t){this.error(t)}const r=new Map;c.add((0,A.toDisposable)(()=>{for(const[,t]of r)t.dispose();r.clear()})),u.on("error",(t,i)=>{this.error(`Failed to watch ${C} for changes using fs.watch() (${t}, ${i})`),this.dispose()}),u.on("change",(t,i)=>{if(g.token.isCancellationRequested)return;this.trace(`[raw] ["${t}"] ${i}`);let o="";if(i&&(o=i.toString(),I.isMacintosh&&(o=(0,b.normalizeNFC)(o))),!(!o||t!=="change"&&t!=="rename"))if(m)if(t==="rename"){r.get(o)?.dispose();const l=setTimeout(async()=>{if(r.delete(o),o===d&&!await w.Promises.exists(C)){this.warn("Watcher shutdown because watched path got deleted"),this.dispose();return}const a=await this.existsChildStrictCase((0,P.join)(C,o));if(g.token.isCancellationRequested)return;let h;a?s.has(o)?h=0:(h=1,s.add(o)):(s.delete(o),h=2),this.onFileChange({path:(0,P.join)(this.request.path,o),type:h})},y.FILE_DELETE_HANDLER_DELAY);r.set(o,(0,A.toDisposable)(()=>clearTimeout(l)))}else{let l;s.has(o)?l=0:(l=1,s.add(o)),this.onFileChange({path:(0,P.join)(this.request.path,o),type:l})}else if(t==="rename"||o!==d){const l=setTimeout(async()=>{const a=await w.Promises.exists(C);g.token.isCancellationRequested||(a?(this.onFileChange({path:this.request.path,type:0},!0),c.add(await this.doWatch(C,!1))):(await this.onFileChange({path:this.request.path,type:2},!0),this.dispose()))},y.FILE_DELETE_HANDLER_DELAY);c.clear(),c.add((0,A.toDisposable)(()=>clearTimeout(l)))}else this.onFileChange({path:this.request.path,type:0},!0)})}catch(d){await w.Promises.exists(C)&&!g.token.isCancellationRequested&&this.error(`Failed to watch ${C} for changes using fs.watch() (${d.toString()})`)}return(0,A.toDisposable)(()=>{g.dispose(!0),c.dispose()})}async onFileChange(C,m=!1){if(!this.cts.token.isCancellationRequested){this.verboseLogging&&this.trace(`${C.type===1?"[ADDED]":C.type===2?"[DELETED]":"[CHANGED]"} ${C.path}`),!m&&this.excludes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (excluded) ${C.path}`):!m&&this.includes&&this.includes.length>0&&!this.includes.some(g=>g(C.path))?this.verboseLogging&&this.trace(` >> ignored (not included) ${C.path}`):this.fileChangesBuffer.push(C);try{await this.fileChangesDelayer.trigger(async()=>{const g=this.fileChangesBuffer;this.fileChangesBuffer=[];const c=(0,v.coalesceEvents)(g);if(c.length>0){if(this.verboseLogging)for(const u of c)this.trace(`>> normalized ${u.type===1?"[ADDED]":u.type===2?"[DELETED]":"[CHANGED]"} ${u.path}`);this.throttledFileChangesWorker.work(c)?this.throttledFileChangesWorker.pending>0&&this.trace(`started throttling events due to large amount of file change events at once (pending: ${this.throttledFileChangesWorker.pending}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`):this.warn(`started ignoring events due to too many file change events at once (incoming: ${c.length}, most recent change: ${c[0].path}). Use 'files.watcherExclude' setting to exclude folders with lots of changing files (e.g. compilation output).`)}})}catch{}}}async existsChildStrictCase(C){if(I.isLinux)return w.Promises.exists(C);try{const m=(0,P.basename)(C);return(await w.Promises.readdir((0,P.dirname)(C))).some(c=>c===m)}catch(m){return this.trace(m),!1}}setVerboseLogging(C){this.verboseLogging=C}error(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"error",message:`[File Watcher (node.js)] ${C}`})}warn(C){this.cts.token.isCancellationRequested||this.onLogMessage?.({type:"warn",message:`[File Watcher (node.js)] ${C}`})}trace(C){!this.cts.token.isCancellationRequested&&this.verboseLogging&&this.onLogMessage?.({type:"trace",message:`[File Watcher (node.js)] ${C}`})}dispose(){this.trace(`stopping file watcher on ${this.request.path}`),this.cts.dispose(!0),super.dispose()}}e.NodeJSFileWatcherLibrary=y,y.FILE_DELETE_HANDLER_DELAY=100,y.FILE_CHANGES_HANDLER_DELAY=50;async function f(S,C,m,g,c=512){const d=await w.Promises.open(S,"r"),u=Buffer.allocUnsafe(c),s=new k.CancellationTokenSource(g);let r,t=!1;const i={path:S,excludes:[],recursive:!1},o=new y(i,l=>{(async()=>{for(const{type:a}of l)if(a===0){if(t)return;t=!0;try{for(;!s.token.isCancellationRequested;){const{bytesRead:h}=await w.Promises.read(d,u,0,c,null);if(!h||s.token.isCancellationRequested)break;C(u.slice(0,h))}}catch(h){r=new Error(h),s.dispose(!0)}finally{t=!1}}})()});return await o.ready,m(),new Promise((l,a)=>{s.token.onCancellationRequested(async()=>{o.dispose();try{await w.Promises.close(d)}catch(h){r=new Error(h)}r?a(r):l()})})}e.watchFileContents=f}),define(re[178],se([0,1,3,81,2,4,177]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcher=void 0;class b extends k.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new D.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=D.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(I){const E=this.normalizeRequests(I),w=E.filter(y=>{const f=this.watchers.get(y.path);return f?!(0,n.patternsEquals)(f.request.excludes,y.excludes)||!(0,n.patternsEquals)(f.request.includes,y.includes):!0}),v=Array.from(this.watchers.values()).filter(({request:y})=>!E.find(f=>f.path===y.path&&(0,n.patternsEquals)(f.excludes,y.excludes)&&(0,n.patternsEquals)(f.includes,y.includes))).map(({request:y})=>y.path);w.length&&this.trace(`Request to start watching: ${w.map(y=>`${y.path} (excludes: ${y.excludes.length>0?y.excludes:"<none>"}, includes: ${y.includes&&y.includes.length>0?JSON.stringify(y.includes):"<all>"})`).join(",")}`),v.length&&this.trace(`Request to stop watching: ${v.join(",")}`);for(const y of v)this.stopWatching(y);for(const y of w)this.startWatching(y)}startWatching(I){const E=new A.NodeJSFileWatcherLibrary(I,v=>this._onDidChangeFile.fire(v),v=>this._onDidLogMessage.fire(v),this.verboseLogging),w={request:I,instance:E};this.watchers.set(I.path,w)}async stop(){for(const[I]of this.watchers)this.stopWatching(I);this.watchers.clear()}stopWatching(I){const E=this.watchers.get(I);E&&(this.watchers.delete(I),E.instance.dispose())}normalizeRequests(I){const E=new Map;for(const w of I){const v=L.isLinux?w.path:w.path.toLowerCase();E.set(v,w)}return Array.from(E.values())}async setVerboseLogging(I){this.verboseLogging=I;for(const[,E]of this.watchers)E.instance.setVerboseLogging(I)}trace(I){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(I)})}toMessage(I,E){return E?`[File Watcher (node.js)] ${I} (path: ${E.request.path})`:`[File Watcher (node.js)] ${I}`}}e.NodeJSWatcher=b}),define(re[179],se([0,1,57,178]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NodeJSWatcherClient=void 0;class k extends D.AbstractNonRecursiveWatcherClient{constructor(A,b,P){super(A,b,P);this.init()}createWatcher(){return new n.NodeJSWatcher}}e.NodeJSWatcherClient=k}),define(re[180],se([0,1,20,39,64,57]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UniversalWatcherClient=void 0;class A extends L.AbstractUniversalWatcherClient{constructor(P,I,E){super(P,I,E);this.init()}createWatcher(P){const I=P.add(new k.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return P.add(I.onDidProcessExit(({code:E,signal:w})=>this.onError(`terminated by itself with code ${E}, signal: ${w}`))),n.ProxyChannel.toService((0,n.getNextTickChannel)(I.getChannel("watcher")))}}e.UniversalWatcherClient=A}),define(re[93],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class D{constructor(...k){this._entries=new Map;for(const[L,A]of k)this.set(L,A)}set(k,L){const A=this._entries.get(k);return this._entries.set(k,L),A}has(k){return this._entries.has(k)}get(k){return this._entries.get(k)}}e.ServiceCollection=D}),define(re[181],se([0,1,6,9,56,170,5,93]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const P=!1;class I extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class E{constructor(f=new b.ServiceCollection,S=!1,C){this._activeInstantiations=new Set,this._services=f,this._strict=S,this._parent=C,this._services.set(A.IInstantiationService,this)}createChild(f){return new E(f,this._strict,this)}invokeFunction(f,...S){const C=v.traceInvocation(f);let m=!1;try{return f({get:c=>{if(m)throw(0,n.illegalState)("service accessor is only valid during the invocation of its target method");const d=this._getOrCreateServiceInstance(c,C);if(!d)throw new Error(`[invokeFunction] unknown service '${c}'`);return d}},...S)}finally{m=!0,C.stop()}}createInstance(f,...S){let C,m;return f instanceof k.SyncDescriptor?(C=v.traceCreation(f.ctor),m=this._createInstance(f.ctor,f.staticArguments.concat(S),C)):(C=v.traceCreation(f),m=this._createInstance(f,S,C)),C.stop(),m}_createInstance(f,S=[],C){const m=A._util.getServiceDependencies(f).sort((d,u)=>d.index-u.index),g=[];for(const d of m){const u=this._getOrCreateServiceInstance(d.id,C);u||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${d.id}.`,!1),g.push(u)}const c=m.length>0?m[0].index:S.length;if(S.length!==c){console.trace(`[createInstance] First service dependency of ${f.name} at position ${c+1} conflicts with ${S.length} static arguments`);const d=c-S.length;d>0?S=S.concat(new Array(d)):S=S.slice(0,c)}return new f(...[...S,...g])}_setServiceInstance(f,S){if(this._services.get(f)instanceof k.SyncDescriptor)this._services.set(f,S);else if(this._parent)this._parent._setServiceInstance(f,S);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const S=this._services.get(f);return!S&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):S}_getOrCreateServiceInstance(f,S){const C=this._getServiceInstanceOrDescriptor(f);return C instanceof k.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,C,S.branch(f,!0)):(S.branch(f,!1),C)}_safeCreateAndCacheServiceInstance(f,S,C){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,S,C)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,S,C){const m=new L.Graph(d=>d.id.toString());let g=0;const c=[{id:f,desc:S,_trace:C}];for(;c.length;){const d=c.pop();if(m.lookupOrInsertNode(d),g++>1e3)throw new I(m);for(const u of A._util.getServiceDependencies(d.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(u.id);if(s||this._throwIfStrict(`[createInstance] ${f} depends on ${u.id} which is NOT registered.`,!0),s instanceof k.SyncDescriptor){const r={id:u.id,desc:s,_trace:d._trace.branch(u.id,!0)};m.insertEdge(d,r),c.push(r)}}}for(;;){const d=m.roots();if(d.length===0){if(!m.isEmpty())throw new I(m);break}for(const{data:u}of d){if(this._getServiceInstanceOrDescriptor(u.id)instanceof k.SyncDescriptor){const r=this._createServiceInstanceWithOwner(u.id,u.desc.ctor,u.desc.staticArguments,u.desc.supportsDelayedInstantiation,u._trace);this._setServiceInstance(u.id,r)}m.removeNode(u)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,S,C=[],m,g){if(this._services.get(f)instanceof k.SyncDescriptor)return this._createServiceInstance(S,C,m,g);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,S,C,m,g);throw new Error(`illegalState - creating UNKNOWN service instance ${S.name}`)}_createServiceInstance(f,S=[],C,m){if(C){const g=new D.IdleValue(()=>this._createInstance(f,S,m));return new Proxy(Object.create(null),{get(c,d){if(d in c)return c[d];const u=g.value;let s=u[d];return typeof s!="function"||(s=s.bind(u),c[d]=s),s},set(c,d,u){return g.value[d]=u,!0}})}else return this._createInstance(f,S,m)}_throwIfStrict(f,S){if(S&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=E;var w;(function(y){y[y.Creation=0]="Creation",y[y.Invocation=1]="Invocation",y[y.Branch=2]="Branch"})(w||(w={}));class v{constructor(f,S){this.type=f,this.name=S,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return P?new v(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):v._None}static traceCreation(f){return P?new v(0,f.name):v._None}branch(f,S){const C=new v(2,f.toString());return this._dep.push([f,S,C]),C}stop(){const f=Date.now()-this._start;v._totals+=f;let S=!1;function C(g,c){const d=[],u=new Array(g+1).join("	");for(const[s,r,t]of c._dep)if(r&&t){S=!0,d.push(`${u}CREATES -> ${s}`);const i=C(g+1,t);i&&d.push(i)}else d.push(`${u}uses -> ${s}`);return d.join(`
`)}const m=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${C(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${v._totals.toFixed(2)}ms)`];(f>2||S)&&console.log(m.join(`
`))}}e.Trace=v,v._None=new class extends v{constructor(){super(-1,null)}stop(){}branch(){return this}},v._totals=0}),define(re[182],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.MessagePortMainProcessService=void 0;class D{constructor(k,L){this.server=k,this.router=L}getChannel(k){return this.server.getChannel(k,this.router)}registerChannel(k,L){this.server.registerChannel(k,L)}}e.MessagePortMainProcessService=D}),define(re[94],se([0,1,39,56,88,5]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerSharedProcessRemoteService=e.ISharedProcessService=e.registerMainProcessRemoteService=e.IMainProcessService=void 0;class A{constructor(y,f,S){const C=S.getChannel(y);return b(f)?new f.channelClientCtor(C):D.ProxyChannel.toService(C,f?.proxyOptions)}}function b(v){return!!v?.channelClientCtor}e.IMainProcessService=(0,L.createDecorator)("mainProcessService");let P=class extends A{constructor(y,f,S){super(y,f,S)}};P=me([G(2,e.IMainProcessService)],P);function I(v,y,f){(0,k.registerSingleton)(v,new n.SyncDescriptor(P,[y,f],f?.supportsDelayedInstantiation))}e.registerMainProcessRemoteService=I,e.ISharedProcessService=(0,L.createDecorator)("sharedProcessService");let E=class extends A{constructor(y,f,S){super(y,f,S)}};E=me([G(2,e.ISharedProcessService)],E);function w(v,y,f){(0,k.registerSingleton)(v,new n.SyncDescriptor(E,[y,f],f?.supportsDelayedInstantiation))}e.registerSharedProcessRemoteService=w}),define(re[66],se([0,1,21,2,4,150,28,5]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackBaseService=e.ILanguagePackService=void 0,e.ILanguagePackService=(0,b.createDecorator)("languagePackService");let P=class extends n.Disposable{constructor(E){super();this.extensionGalleryService=E}async getAvailableLanguages(){const E=new D.CancellationTokenSource;setTimeout(()=>E.cancel(),1e3);let w;try{w=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},E.token)}catch{return[]}const y=w.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(S=>S.startsWith("lp-"))).map(f=>{const S=f.properties.localizedLanguages?.[0],C=this.getLocale(f);return{...this.createQuickPickItem(C,S,f),extensionId:f.identifier.id,galleryExtension:f}});return y.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),y}getLocale(E){return E.tags.find(w=>w.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(E,w,v){const y=w??E;let f;if(y!==E&&(f=`(${E})`),E.toLowerCase()===k.language.toLowerCase()&&(f??(f=""),f+=(0,L.localize)(0,null)),v?.installCount){f??(f="");const S=v.installCount;let C;S>1e6?C=`${Math.floor(S/1e5)/10}M`:S>1e3?C=`${Math.floor(S/1e3)}K`:C=String(S),f+=` $(cloud-download) ${C}`}return{id:E,label:y,description:f}}};P=me([G(0,A.IExtensionGalleryService)],P),e.LanguagePackBaseService=P}),define(re[183],se([0,1,2,66]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LocalizationsUpdater=void 0;let k=class extends D.Disposable{constructor(A){super();this.localizationsService=A,this.updateLocalizations()}updateLocalizations(){this.localizationsService.update()}};k=me([G(0,n.ILanguagePackService)],k),e.LocalizationsUpdater=k}),define(re[8],se([0,1,38,3,2,4,5]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,A.createDecorator)("logService"),e.ILoggerService=(0,A.createDecorator)("loggerService");function b(){return new Date().toISOString()}var P;(function(r){r[r.Trace=0]="Trace",r[r.Debug=1]="Debug",r[r.Info=2]="Info",r[r.Warning=3]="Warning",r[r.Error=4]="Error",r[r.Critical=5]="Critical",r[r.Off=6]="Off"})(P=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=P.Info;function I(r,t,i){switch(t){case P.Trace:r.trace(i);break;case P.Debug:r.debug(i);break;case P.Info:r.info(i);break;case P.Warning:r.warn(i);break;case P.Error:r.error(i);break;case P.Critical:r.critical(i);break;default:throw new Error("Invalid log level")}}e.log=I;function E(r){let t="";for(let i=0;i<r.length;i++){let o=r[i];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}t+=(i>0?" ":"")+o}return t}e.format=E;class w extends k.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new n.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(t){this.level!==t&&(this.level=t,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=w;class v extends w{constructor(t){super();this.logAlways=t}checkLogLevel(t){return this.logAlways||this.getLevel()<=t}trace(t,...i){this.checkLogLevel(P.Trace)&&this.log(P.Trace,E([t,...i]))}debug(t,...i){this.checkLogLevel(P.Debug)&&this.log(P.Debug,E([t,...i]))}info(t,...i){this.checkLogLevel(P.Info)&&this.log(P.Info,E([t,...i]))}warn(t,...i){this.checkLogLevel(P.Warning)&&this.log(P.Warning,E([t,...i]))}error(t,...i){if(this.checkLogLevel(P.Error))if(t instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=t.stack,this.log(P.Error,E(o))}else this.log(P.Error,E([t,...i]))}critical(t,...i){this.checkLogLevel(P.Critical)&&this.log(P.Critical,E([t,...i]))}flush(){}}e.AbstractMessageLogger=v;class y extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t),this.useColors=!L.isWindows}trace(t,...i){this.getLevel()<=P.Trace&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}debug(t,...i){this.getLevel()<=P.Debug&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}info(t,...i){this.getLevel()<=P.Info&&(this.useColors?console.log(`[90m[main ${b()}][0m`,t,...i):console.log(`[main ${b()}]`,t,...i))}warn(t,...i){this.getLevel()<=P.Warning&&(this.useColors?console.warn(`[93m[main ${b()}][0m`,t,...i):console.warn(`[main ${b()}]`,t,...i))}error(t,...i){this.getLevel()<=P.Error&&(this.useColors?console.error(`[91m[main ${b()}][0m`,t,...i):console.error(`[main ${b()}]`,t,...i))}critical(t,...i){this.getLevel()<=P.Critical&&(this.useColors?console.error(`[90m[main ${b()}][0m`,t,...i):console.error(`[main ${b()}]`,t,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=y;class f extends w{constructor(t=e.DEFAULT_LOG_LEVEL){super();this.setLevel(t)}trace(t,...i){this.getLevel()<=P.Trace&&console.log("%cTRACE","color: #888",t,...i)}debug(t,...i){this.getLevel()<=P.Debug&&console.log("%cDEBUG","background: #eee; color: #888",t,...i)}info(t,...i){this.getLevel()<=P.Info&&console.log("%c INFO","color: #33f",t,...i)}warn(t,...i){this.getLevel()<=P.Warning&&console.log("%c WARN","color: #993",t,...i)}error(t,...i){this.getLevel()<=P.Error&&console.log("%c  ERR","color: #f33",t,...i)}critical(t,...i){this.getLevel()<=P.Critical&&console.log("%cCRITI","background: #f33; color: white",t,...i)}dispose(){}flush(){}}e.ConsoleLogger=f;class S extends w{constructor(t,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=t,this.setLevel(i)}trace(t,...i){this.getLevel()<=P.Trace&&this.adapter.log(P.Trace,[this.extractMessage(t),...i])}debug(t,...i){this.getLevel()<=P.Debug&&this.adapter.log(P.Debug,[this.extractMessage(t),...i])}info(t,...i){this.getLevel()<=P.Info&&this.adapter.log(P.Info,[this.extractMessage(t),...i])}warn(t,...i){this.getLevel()<=P.Warning&&this.adapter.log(P.Warning,[this.extractMessage(t),...i])}error(t,...i){this.getLevel()<=P.Error&&this.adapter.log(P.Error,[this.extractMessage(t),...i])}critical(t,...i){this.getLevel()<=P.Critical&&this.adapter.log(P.Critical,[this.extractMessage(t),...i])}extractMessage(t){return typeof t=="string"?t:(0,D.toErrorMessage)(t,this.getLevel()<=P.Trace)}dispose(){}flush(){}}e.AdapterLogger=S;class C extends w{constructor(t){super();this.logServices=t,t.length&&this.setLevel(t[0].getLevel())}setLevel(t){for(const i of this.logServices)i.setLevel(t);super.setLevel(t)}trace(t,...i){for(const o of this.logServices)o.trace(t,...i)}debug(t,...i){for(const o of this.logServices)o.debug(t,...i)}info(t,...i){for(const o of this.logServices)o.info(t,...i)}warn(t,...i){for(const o of this.logServices)o.warn(t,...i)}error(t,...i){for(const o of this.logServices)o.error(t,...i)}critical(t,...i){for(const o of this.logServices)o.critical(t,...i)}flush(){for(const t of this.logServices)t.flush()}dispose(){for(const t of this.logServices)t.dispose()}}e.MultiplexLogService=C;class m extends k.Disposable{constructor(t){super();this.logger=t,this._register(t)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(t){this.logger.setLevel(t)}getLevel(){return this.logger.getLevel()}trace(t,...i){this.logger.trace(t,...i)}debug(t,...i){this.logger.debug(t,...i)}info(t,...i){this.logger.info(t,...i)}warn(t,...i){this.logger.warn(t,...i)}error(t,...i){this.logger.error(t,...i)}critical(t,...i){this.logger.critical(t,...i)}flush(){this.logger.flush()}}e.LogService=m;class g extends k.Disposable{constructor(t,i){super();this.logLevel=t,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(l=>l.setLevel(o))}))}getLogger(t){return this.loggers.get(t.toString())}createLogger(t,i){let o=this.loggers.get(t.toString());return o||(o=this.doCreateLogger(t,i?.always?P.Trace:this.logLevel,i),this.loggers.set(t.toString(),o),i?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(t=>t.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=g;class c{constructor(){this.onDidChangeLogLevel=new n.Emitter().event}setLevel(t){}getLevel(){return P.Info}trace(t,...i){}debug(t,...i){}info(t,...i){}warn(t,...i){}error(t,...i){}critical(t,...i){}dispose(){}flush(){}}e.NullLogService=c;function d(r){if(r.verbose)return P.Trace;if(typeof r.logLevel=="string"){const t=u(r.logLevel.toLowerCase());if(t!==void 0)return t}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=d;function u(r){switch(r){case"trace":return P.Trace;case"debug":return P.Debug;case"info":return P.Info;case"warn":return P.Warning;case"error":return P.Error;case"critical":return P.Critical;case"off":return P.Off}}e.parseLogLevel=u;function s(r){switch(r){case P.Trace:return"trace";case P.Debug:return"debug";case P.Info:return"info";case P.Warning:return"warn";case P.Error:return"error";case P.Critical:return"critical";case P.Off:return"off"}}e.LogLevelToString=s}),define(re[184],se([0,1,6,9,2,10,27,14,8]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogsDataCleaner=void 0;let I=class extends k.Disposable{constructor(w,v){super();this.environmentService=w,this.logService=v,this._register(new D.RunOnceScheduler(()=>{this.cleanUpOldLogs()},10*1e3)).schedule()}async cleanUpOldLogs(){this.logService.trace("[logs cleanup]: Starting to clean up old logs.");try{const w=(0,L.basename)(this.environmentService.logsPath),v=(0,L.dirname)(this.environmentService.logsPath),S=(await A.Promises.readdir(v)).filter(m=>/^\d{8}T\d{6}$/.test(m)).sort().filter(m=>m!==w),C=S.slice(0,Math.max(0,S.length-9));C.length>0&&(this.logService.trace(`[logs cleanup]: Removing log folders '${C.join(", ")}'`),await Promise.all(C.map(m=>A.Promises.rm((0,L.join)(v,m)))))}catch(w){(0,n.onUnexpectedError)(w)}}};I=me([G(0,b.IEnvironmentService),G(1,P.ILogService)],I),e.LogsDataCleaner=I}),define(re[185],se([0,1,6,9,2,10,27,14,8]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageDataCleaner=void 0;let I=class ft extends k.Disposable{constructor(w,v,y){super();this.backupWorkspacesPath=w,this.environmentService=v,this.logService=y,this._register(new D.RunOnceScheduler(()=>{this.cleanUpStorage()},30*1e3)).schedule()}async cleanUpStorage(){this.logService.trace("[storage cleanup]: Starting to clean up storage folders.");try{const w=await A.Promises.readFile(this.backupWorkspacesPath,"utf8"),y=JSON.parse(w).emptyWorkspaceInfos.map(S=>S.backupFolder),f=await A.Promises.readdir(this.environmentService.workspaceStorageHome.fsPath);await Promise.all(f.map(async S=>{S.length===ft.NON_EMPTY_WORKSPACE_ID_LENGTH||S===ft.EXTENSION_DEV_EMPTY_WINDOW_ID||y.indexOf(S)>=0||(this.logService.trace(`[storage cleanup]: Deleting workspace storage folder ${S}.`),await A.Promises.rm((0,L.join)(this.environmentService.workspaceStorageHome.fsPath,S)))}))}catch(w){(0,n.onUnexpectedError)(w)}}};I.NON_EMPTY_WORKSPACE_ID_LENGTH=128/4,I.EXTENSION_DEV_EMPTY_WINDOW_ID="ext-dev",I=me([G(1,b.INativeEnvironmentService),G(2,P.ILogService)],I),e.StorageDataCleaner=I}),define(re[186],se([0,1,18,6,9,3,2,10,57,8]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDiskFileSystemProvider=void 0;class E extends A.Disposable{constructor(v,y){super();this.logService=v,this.options=y,this._onDidChangeFile=this._register(new L.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new L.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new n.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new n.ThrottledDelayer(0))}watch(v,y){return y.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(v,y):this.watchNonRecursive(v,y)}watchUniversal(v,y){const f={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:y.recursive},S=(0,D.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(y=>this._onDidChangeFile.fire((0,P.toFileChanges)(y)),y=>this.onWatcherLogMessage(y),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)})));const v=this.options?.watcher?.recursive?.usePolling;if(v===!0)for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(v))for(const y of this.universalPathsToWatch)(0,P.isRecursiveWatchRequest)(y)&&v.includes(y.path)&&(y.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(v,y){const f={path:this.toFilePath(v),excludes:y.excludes,includes:y.includes,recursive:!1},S=(0,D.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{S(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(v=>(0,k.onUnexpectedError)(v))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(v=>this._onDidChangeFile.fire((0,P.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===I.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===I.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(v){v.type==="error"&&this._onDidWatchError.fire(v.message),this.logService[v.type](v.message)}toFilePath(v){return(0,b.normalize)(v.fsPath)}}e.AbstractDiskFileSystemProvider=E}),define(re[187],se([0,1,18,6,16,21,3,62,51,2,34,20,188,17,41,146,13,92,8]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileService=void 0;let c=class extends I.Disposable{constructor(u){super();this.logService=u,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new n.ResourceQueue)}registerProvider(u,s){if(this.provider.has(u))throw new Error(`A filesystem provider for the scheme '${u}' is already registered.`);(0,v.mark)(`code/registerFilesystem/${u}`);const r=new I.DisposableStore;return this.provider.set(u,s),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:u,provider:s}),r.add(s.onDidChangeFile(t=>this._onDidFilesChange.fire(new C.FileChangesEvent(t,!this.isPathCaseSensitive(s))))),typeof s.onDidWatchError=="function"&&r.add(s.onDidWatchError(t=>this._onDidWatchError.fire(new Error(t)))),r.add(s.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:s,scheme:u}))),(0,I.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:u,provider:s}),this.provider.delete(u),(0,I.dispose)(r)})}getProvider(u){return this.provider.get(u)}async activateProvider(u){const s=[];this._onWillActivateFileSystemProvider.fire({scheme:u,join(r){s.push(r)}}),!this.provider.has(u)&&await n.Promises.settled(s)}async canHandleResource(u){return await this.activateProvider(u.scheme),this.hasProvider(u)}hasProvider(u){return this.provider.has(u.scheme)}hasCapability(u,s){const r=this.provider.get(u.scheme);return!!(r&&r.capabilities&s)}listCapabilities(){return P.Iterable.map(this.provider,([u,s])=>({scheme:u,capabilities:s.capabilities}))}async withProvider(u){if(!(0,y.isAbsolutePath)(u))throw new C.FileOperationError((0,S.localize)(0,null,this.resourceForError(u)),8);await this.activateProvider(u.scheme);const s=this.provider.get(u.scheme);if(!s){const r=new Error;throw r.name="ENOPRO",r.message=(0,S.localize)(1,null,u.toString()),r}return s}async withReadProvider(u){const s=await this.withProvider(u);if((0,C.hasOpenReadWriteCloseCapability)(s)||(0,C.hasReadWriteCapability)(s)||(0,C.hasFileReadStreamCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(u){const s=await this.withProvider(u);if((0,C.hasOpenReadWriteCloseCapability)(s)||(0,C.hasReadWriteCapability)(s))return s;throw new Error(`Filesystem provider for scheme '${u.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(u,s){try{return await this.doResolveFile(u,s)}catch(r){throw(0,C.toFileSystemProviderErrorCode)(r)===C.FileSystemProviderErrorCode.FileNotFound?new C.FileOperationError((0,S.localize)(2,null,this.resourceForError(u)),1):(0,C.ensureFileSystemProviderError)(r)}}async doResolveFile(u,s){const r=await this.withProvider(u),t=this.isPathCaseSensitive(r),i=s?.resolveTo,o=s?.resolveSingleChildDescendants,l=s?.resolveMetadata,a=await r.stat(u);let h;return this.toFileStat(r,u,a,void 0,!!l,(p,R)=>(h||(h=E.TernarySearchTree.forUris(()=>!t),h.set(u,!0),i&&h.fill(!0,i)),h.get(p.resource)||h.findSuperstr(p.resource.with({query:null,fragment:null}))?!0:p.isDirectory&&o?R===1:!1))}async toFileStat(u,s,r,t,i,o){const{providerExtUri:l}=this.getExtUri(u),a={resource:s,name:l.basename(s),isFile:(r.type&C.FileType.File)!=0,isDirectory:(r.type&C.FileType.Directory)!=0,isSymbolicLink:(r.type&C.FileType.SymbolicLink)!=0,mtime:r.mtime,ctime:r.ctime,size:r.size,readonly:Boolean((r.permissions??0)&C.FilePermission.Readonly)||Boolean(u.capabilities&2048),etag:(0,C.etag)({mtime:r.mtime,size:r.size}),children:void 0};if(a.isDirectory&&o(a,t)){try{const h=await u.readdir(s),p=await n.Promises.settled(h.map(async([R,M])=>{try{const O=l.joinPath(s,R),F=i?await u.stat(O):{type:M};return await this.toFileStat(u,O,F,h.length,i,o)}catch(O){return this.logService.trace(O),null}}));a.children=(0,D.coalesce)(p)}catch(h){this.logService.trace(h),a.children=[]}return a}return a}async resolveAll(u){return n.Promises.settled(u.map(async s=>{try{return{stat:await this.doResolveFile(s.resource,s.options),success:!0}}catch(r){return this.logService.trace(r),{stat:void 0,success:!1}}}))}async stat(u){const s=await this.withProvider(u),r=await s.stat(u);return this.toFileStat(s,u,r,void 0,!0,()=>!1)}async exists(u){const s=await this.withProvider(u);try{return!!await s.stat(u)}catch{return!1}}async canCreateFile(u,s){try{await this.doValidateCreateFile(u,s)}catch(r){return r}return!0}async doValidateCreateFile(u,s){if(!s?.overwrite&&await this.exists(u))throw new C.FileOperationError((0,S.localize)(3,null,this.resourceForError(u)),3,s)}async createFile(u,s=k.VSBuffer.fromString(""),r){await this.doValidateCreateFile(u,r);const t=await this.writeFile(u,s);return this._onDidRunOperation.fire(new C.FileOperationEvent(u,0,t)),t}async writeFile(u,s,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),{providerExtUri:i}=this.getExtUri(t);try{await this.validateWriteFile(t,u,r)||await this.mkdirp(t,i.dirname(u));let l;if((0,C.hasReadWriteCapability)(t)&&!(s instanceof k.VSBuffer))if((0,f.isReadableStream)(s)){const a=await(0,f.peekStream)(s,3);a.ended?l=k.VSBuffer.concat(a.buffer):l=a}else l=(0,f.peekReadable)(s,a=>k.VSBuffer.concat(a),3);else l=s;!(0,C.hasOpenReadWriteCloseCapability)(t)||(0,C.hasReadWriteCapability)(t)&&l instanceof k.VSBuffer?await this.doWriteUnbuffered(t,u,r,l):await this.doWriteBuffered(t,u,r,l instanceof k.VSBuffer?(0,k.bufferToReadable)(l):l),this._onDidRunOperation.fire(new C.FileOperationEvent(u,4))}catch(o){throw new C.FileOperationError((0,S.localize)(4,null,this.resourceForError(u),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),r)}return this.resolve(u,{resolveMetadata:!0})}async validateWriteFile(u,s,r){if(!!r?.unlock&&!(u.capabilities&8192))throw new Error((0,S.localize)(5,null,this.resourceForError(s)));let i;try{i=await u.stat(s)}catch{return}if((i.type&C.FileType.Directory)!=0)throw new C.FileOperationError((0,S.localize)(6,null,this.resourceForError(s)),0,r);if(this.throwIfFileIsReadonly(s,i),typeof r?.mtime=="number"&&typeof r.etag=="string"&&r.etag!==C.ETAG_DISABLED&&typeof i.mtime=="number"&&typeof i.size=="number"&&r.mtime<i.mtime&&r.etag!==(0,C.etag)({mtime:r.mtime,size:i.size}))throw new C.FileOperationError((0,S.localize)(7,null),3,r);return i}async readFile(u,s,r){const t=await this.withReadProvider(u);return s?.atomic?this.doReadFileAtomic(t,u,s,r):this.doReadFile(t,u,s,r)}async doReadFileAtomic(u,s,r,t){return new Promise((i,o)=>{this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(async()=>{try{const l=await this.doReadFile(u,s,r,t);i(l)}catch(l){o(l)}})})}async doReadFile(u,s,r,t){const i=await this.doReadFileStream(u,s,{...r,preferUnbuffered:!0},t);return{...i,value:await(0,k.streamToBuffer)(i.value)}}async readFileStream(u,s,r){const t=await this.withReadProvider(u);return this.doReadFileStream(t,u,s,r)}async doReadFileStream(u,s,r,t){const i=new L.CancellationTokenSource(t),o=this.validateReadFile(s,r).then(a=>a,a=>{throw i.cancel(),a});let l;try{return typeof r?.etag=="string"&&r.etag!==C.ETAG_DISABLED&&await o,r?.atomic&&(0,C.hasFileAtomicReadCapability)(u)||!((0,C.hasOpenReadWriteCloseCapability)(u)||(0,C.hasFileReadStreamCapability)(u))||(0,C.hasReadWriteCapability)(u)&&r?.preferUnbuffered?l=this.readFileUnbuffered(u,s,r):(0,C.hasFileReadStreamCapability)(u)?l=this.readFileStreamed(u,s,i.token,r):l=this.readFileBuffered(u,s,i.token,r),{...await o,value:l}}catch(a){l&&await(0,f.consumeStream)(l);const h=(0,S.localize)(8,null,this.resourceForError(s),(0,C.ensureFileSystemProviderError)(a).toString());throw a instanceof C.NotModifiedSinceFileOperationError?new C.NotModifiedSinceFileOperationError(h,a.stat,r):new C.FileOperationError(h,(0,C.toFileOperationResult)(a),r)}}readFileStreamed(u,s,r,t=Object.create(null)){const i=u.readFileStream(s,t,r);return(0,f.transform)(i,{data:o=>o instanceof k.VSBuffer?o:k.VSBuffer.wrap(o),error:o=>new C.FileOperationError((0,S.localize)(9,null,this.resourceForError(s),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},o=>k.VSBuffer.concat(o))}readFileBuffered(u,s,r,t=Object.create(null)){const i=(0,k.newWriteableBufferStream)();return(0,m.readFileIntoStream)(u,s,i,o=>o,{...t,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new C.FileOperationError((0,S.localize)(10,null,this.resourceForError(s),(0,C.ensureFileSystemProviderError)(o).toString()),(0,C.toFileOperationResult)(o),t)},r),i}readFileUnbuffered(u,s,r){const t=(0,f.newWriteableStream)(i=>k.VSBuffer.concat(i));return(async()=>{try{let i;r?.atomic&&(0,C.hasFileAtomicReadCapability)(u)?i=await u.readFile(s,{atomic:!0}):i=await u.readFile(s),typeof r?.position=="number"&&(i=i.slice(r.position)),typeof r?.length=="number"&&(i=i.slice(0,r.length)),this.validateReadFileLimits(s,i.byteLength,r),t.end(k.VSBuffer.wrap(i))}catch(i){t.error(i),t.end()}})(),t}async validateReadFile(u,s){const r=await this.resolve(u,{resolveMetadata:!0});if(r.isDirectory)throw new C.FileOperationError((0,S.localize)(11,null,this.resourceForError(u)),0,s);if(typeof s?.etag=="string"&&s.etag!==C.ETAG_DISABLED&&s.etag===r.etag)throw new C.NotModifiedSinceFileOperationError((0,S.localize)(12,null),r,s);return this.validateReadFileLimits(u,r.size,s),r}validateReadFileLimits(u,s,r){if(r?.limits){let t;if(typeof r.limits.memory=="number"&&s>r.limits.memory&&(t=9),typeof r.limits.size=="number"&&s>r.limits.size&&(t=7),typeof t=="number")throw new C.FileOperationError((0,S.localize)(13,null,this.resourceForError(u)),t)}}async canMove(u,s,r){return this.doCanMoveCopy(u,s,"move",r)}async canCopy(u,s,r){return this.doCanMoveCopy(u,s,"copy",r)}async doCanMoveCopy(u,s,r,t){if(u.toString()!==s.toString())try{const i=r==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u):await this.withReadProvider(u),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);await this.doValidateMoveCopy(i,u,o,s,r,t)}catch(i){return i}return!0}async move(u,s,r){const t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(u),u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(t,u,i,s,"move",!!r),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(u,o==="move"?2:3,l)),l}async copy(u,s,r){const t=await this.withReadProvider(u),i=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),o=await this.doMoveCopy(t,u,i,s,"copy",!!r),l=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(u,o==="copy"?3:2,l)),l}async doMoveCopy(u,s,r,t,i,o){if(s.toString()===t.toString())return i;const{exists:l,isSameResourceWithDifferentPathCase:a}=await this.doValidateMoveCopy(u,s,r,t,i,o);if(l&&!a&&o&&await this.del(t,{recursive:!0}),await this.mkdirp(r,this.getExtUri(r).providerExtUri.dirname(t)),i==="copy"){if(u===r&&(0,C.hasFileFolderCopyCapability)(u))await u.copy(s,t,{overwrite:o});else{const h=await this.resolve(s);h.isDirectory?await this.doCopyFolder(u,h,r,t):await this.doCopyFile(u,s,r,t)}return i}else return u===r?(await u.rename(s,t,{overwrite:o}),i):(await this.doMoveCopy(u,s,r,t,"copy",o),await this.del(s,{recursive:!0}),"copy")}async doCopyFile(u,s,r,t){if((0,C.hasOpenReadWriteCloseCapability)(u)&&(0,C.hasOpenReadWriteCloseCapability)(r))return this.doPipeBuffered(u,s,r,t);if((0,C.hasOpenReadWriteCloseCapability)(u)&&(0,C.hasReadWriteCapability)(r))return this.doPipeBufferedToUnbuffered(u,s,r,t);if((0,C.hasReadWriteCapability)(u)&&(0,C.hasOpenReadWriteCloseCapability)(r))return this.doPipeUnbufferedToBuffered(u,s,r,t);if((0,C.hasReadWriteCapability)(u)&&(0,C.hasReadWriteCapability)(r))return this.doPipeUnbuffered(u,s,r,t)}async doCopyFolder(u,s,r,t){await r.mkdir(t),Array.isArray(s.children)&&await n.Promises.settled(s.children.map(async i=>{const o=this.getExtUri(r).providerExtUri.joinPath(t,i.name);return i.isDirectory?this.doCopyFolder(u,await this.resolve(i.resource),r,o):this.doCopyFile(u,i.resource,r,o)}))}async doValidateMoveCopy(u,s,r,t,i,o){let l=!1;if(u===r){const{providerExtUri:h,isPathCaseSensitive:p}=this.getExtUri(u);if(p||(l=h.isEqual(s,t)),l&&i==="copy")throw new Error((0,S.localize)(14,null,this.resourceForError(s),this.resourceForError(t)));if(!l&&h.isEqualOrParent(t,s))throw new Error((0,S.localize)(15,null,this.resourceForError(s),this.resourceForError(t)))}const a=await this.exists(t);if(a&&!l){if(!o)throw new C.FileOperationError((0,S.localize)(16,null,this.resourceForError(s),this.resourceForError(t)),4);if(u===r){const{providerExtUri:h}=this.getExtUri(u);if(h.isEqualOrParent(s,t))throw new Error((0,S.localize)(17,null,this.resourceForError(s),this.resourceForError(t)))}}return{exists:a,isSameResourceWithDifferentPathCase:l}}getExtUri(u){const s=this.isPathCaseSensitive(u);return{providerExtUri:s?y.extUri:y.extUriIgnorePathCase,isPathCaseSensitive:s}}isPathCaseSensitive(u){return!!(u.capabilities&1024)}async createFolder(u){const s=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);await this.mkdirp(s,u);const r=await this.resolve(u,{resolveMetadata:!0});return this._onDidRunOperation.fire(new C.FileOperationEvent(u,0,r)),r}async mkdirp(u,s){const r=[],{providerExtUri:t}=this.getExtUri(u);for(;!t.isEqual(s,t.dirname(s));)try{if(((await u.stat(s)).type&C.FileType.Directory)==0)throw new Error((0,S.localize)(18,null,this.resourceForError(s)));break}catch(i){if((0,C.toFileSystemProviderErrorCode)(i)!==C.FileSystemProviderErrorCode.FileNotFound)throw i;r.push(t.basename(s)),s=t.dirname(s)}for(let i=r.length-1;i>=0;i--){s=t.joinPath(s,r[i]);try{await u.mkdir(s)}catch(o){if((0,C.toFileSystemProviderErrorCode)(o)!==C.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(u,s){try{await this.doValidateDelete(u,s)}catch(r){return r}return!0}async doValidateDelete(u,s){const r=this.throwIfFileSystemIsReadonly(await this.withProvider(u),u);if(!!s?.useTrash&&!(r.capabilities&4096))throw new Error((0,S.localize)(19,null,this.resourceForError(u)));let i;try{i=await r.stat(u)}catch{}if(i)this.throwIfFileIsReadonly(u,i);else throw new C.FileOperationError((0,S.localize)(20,null,this.resourceForError(u)),1);if(!!!s?.recursive){const l=await this.resolve(u);if(l.isDirectory&&Array.isArray(l.children)&&l.children.length>0)throw new Error((0,S.localize)(21,null,this.resourceForError(u)))}return r}async del(u,s){const r=await this.doValidateDelete(u,s),t=!!s?.useTrash,i=!!s?.recursive;await r.delete(u,{recursive:i,useTrash:t}),this._onDidRunOperation.fire(new C.FileOperationEvent(u,1))}async cloneFile(u,s){const r=await this.withProvider(u),t=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s);if(r===t&&this.getExtUri(r).providerExtUri.isEqual(u,s))return;if(r===t&&(0,C.hasFileCloneCapability)(r))return r.cloneFile(u,s);await this.mkdirp(t,this.getExtUri(t).providerExtUri.dirname(s));const i=this.writeQueue.queueFor(u,this.getExtUri(r).providerExtUri);return r===t&&(0,C.hasFileFolderCopyCapability)(r)?i.queue(()=>r.copy(u,s,{overwrite:!0})):i.queue(()=>this.doCopyFile(r,u,t,s))}watch(u,s={recursive:!1,excludes:[]}){const r=new I.DisposableStore;let t=!1,i=()=>{t=!0};return r.add((0,I.toDisposable)(()=>i())),(async()=>{try{const o=await this.doWatch(u,s);t?(0,I.dispose)(o):i=()=>(0,I.dispose)(o)}catch(o){this.logService.error(o)}})(),r}async doWatch(u,s){const r=await this.withProvider(u),t=(0,b.hash)([this.getExtUri(r).providerExtUri.getComparisonKey(u),s]);let i=this.activeWatchers.get(t);return i||(i={count:0,disposable:r.watch(u,s)},this.activeWatchers.set(t,i)),i.count+=1,(0,I.toDisposable)(()=>{i&&(i.count--,i.count===0&&((0,I.dispose)(i.disposable),this.activeWatchers.delete(t)))})}dispose(){super.dispose();for(const[,u]of this.activeWatchers)(0,I.dispose)(u.disposable);this.activeWatchers.clear()}async doWriteBuffered(u,s,r,t){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(async()=>{const i=await u.open(s,{create:!0,unlock:r?.unlock??!1});try{(0,f.isReadableStream)(t)||(0,f.isReadableBufferedStream)(t)?await this.doWriteStreamBufferedQueued(u,i,t):await this.doWriteReadableBufferedQueued(u,i,t)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await u.close(i)}})}async doWriteStreamBufferedQueued(u,s,r){let t=0,i;if((0,f.isReadableBufferedStream)(r)){if(r.buffer.length>0){const o=k.VSBuffer.concat(r.buffer);await this.doWriteBuffer(u,s,o,o.byteLength,t,0),t+=o.byteLength}if(r.ended)return;i=r.stream}else i=r;return new Promise((o,l)=>{(0,f.listenStream)(i,{onData:async a=>{i.pause();try{await this.doWriteBuffer(u,s,a,a.byteLength,t,0)}catch(h){return l(h)}t+=a.byteLength,setTimeout(()=>i.resume())},onError:a=>l(a),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(u,s,r){let t=0,i;for(;(i=r.read())!==null;)await this.doWriteBuffer(u,s,i,i.byteLength,t,0),t+=i.byteLength}async doWriteBuffer(u,s,r,t,i,o){let l=0;for(;l<t;)l+=await u.write(s,i+l,r.buffer,o+l,t-l)}async doWriteUnbuffered(u,s,r,t){return this.writeQueue.queueFor(s,this.getExtUri(u).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(u,s,r,t))}async doWriteUnbufferedQueued(u,s,r,t){let i;t instanceof k.VSBuffer?i=t:(0,f.isReadableStream)(t)?i=await(0,k.streamToBuffer)(t):(0,f.isReadableBufferedStream)(t)?i=await(0,k.bufferedStreamToBuffer)(t):i=(0,k.readableToBuffer)(t),await u.writeFile(s,i.buffer,{create:!0,overwrite:!0,unlock:r?.unlock??!1})}async doPipeBuffered(u,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeBufferedQueued(u,s,r,t))}async doPipeBufferedQueued(u,s,r,t){let i,o;try{i=await u.open(s,{create:!1}),o=await r.open(t,{create:!0,unlock:!1});const l=k.VSBuffer.alloc(this.BUFFER_SIZE);let a=0,h=0,p=0;do p=await u.read(i,a,l.buffer,h,l.byteLength-h),await this.doWriteBuffer(r,o,l,p,a,h),a+=p,h+=p,h===l.byteLength&&(h=0);while(p>0)}catch(l){throw(0,C.ensureFileSystemProviderError)(l)}finally{await n.Promises.settled([typeof i=="number"?u.close(i):Promise.resolve(),typeof o=="number"?r.close(o):Promise.resolve()])}}async doPipeUnbuffered(u,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(u,s,r,t))}async doPipeUnbufferedQueued(u,s,r,t){return r.writeFile(t,await u.readFile(s),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(u,s,r,t){return this.writeQueue.queueFor(t,this.getExtUri(r).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(u,s,r,t))}async doPipeUnbufferedToBufferedQueued(u,s,r,t){const i=await r.open(t,{create:!0,unlock:!1});try{const o=await u.readFile(s);await this.doWriteBuffer(r,i,k.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,C.ensureFileSystemProviderError)(o)}finally{await r.close(i)}}async doPipeBufferedToUnbuffered(u,s,r,t){const i=await(0,k.streamToBuffer)(this.readFileBuffered(u,s,L.CancellationToken.None));await this.doWriteUnbuffered(r,t,void 0,i)}throwIfFileSystemIsReadonly(u,s){if(u.capabilities&2048)throw new C.FileOperationError((0,S.localize)(22,null,this.resourceForError(s)),6);return u}throwIfFileIsReadonly(u,s){if((s.permissions??0)&C.FilePermission.Readonly)throw new C.FileOperationError((0,S.localize)(23,null,this.resourceForError(u)),6)}resourceForError(u){return u.scheme===w.Schemas.file?u.fsPath:u.toString(!0)}};c=me([G(0,g.ILogService)],c),e.FileService=c}),define(re[189],se([0,1,53,271,6,34,16,3,47,2,10,4,17,41,27,149,13,92,186,38,180,179]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiskFileSystemProvider=void 0,(()=>{try{(0,n.gracefulify)(D)}catch(r){console.error(`Error enabling graceful-fs: ${(0,c.toErrorMessage)(r)}`)}})();class s extends g.AbstractDiskFileSystemProvider{constructor(t,i){super(t,i);this.onDidChangeCapabilities=b.Event.None,this.resourceLocks=new L.ResourceMap(o=>v.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,w.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(t){try{const{stat:i,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(t));return{type:this.toType(i,o),ctime:i.birthtime.getTime(),mtime:i.mtime.getTime(),size:i.size}}catch(i){throw this.toFileSystemProviderError(i)}}async readdir(t){try{const i=await f.Promises.readdir(this.toFilePath(t),{withFileTypes:!0}),o=[];return await Promise.all(i.map(async l=>{try{let a;l.isSymbolicLink()?a=(await this.stat((0,v.joinPath)(t,l.name))).type:a=this.toType(l),o.push([l.name,a])}catch(a){this.logService.trace(a)}})),o}catch(i){throw this.toFileSystemProviderError(i)}}toType(t,i){let o;return i?.dangling?o=C.FileType.Unknown:t.isFile()?o=C.FileType.File:t.isDirectory()?o=C.FileType.Directory:o=C.FileType.Unknown,i&&(o|=C.FileType.SymbolicLink),o}async createResourceLock(t){const i=this.toFilePath(t);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${i})`);let o;for(;o=this.resourceLocks.get(t);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${i})`),await o.wait();const l=new k.Barrier;return this.resourceLocks.set(t,l),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${i})`),(0,I.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${i})`),this.resourceLocks.get(t)===l&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${i})`),this.resourceLocks.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${i})`),l.open()})}async readFile(t,i){let o;try{i?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(t)})`),o=await this.createResourceLock(t));const l=this.toFilePath(t);return await f.Promises.readFile(l)}catch(l){throw this.toFileSystemProviderError(l)}finally{o?.dispose()}}readFileStream(t,i,o){const l=(0,y.newWriteableStream)(a=>A.VSBuffer.concat(a.map(h=>A.VSBuffer.wrap(h))).buffer);return(0,m.readFileIntoStream)(this,t,l,a=>a.buffer,{...i,bufferSize:256*1024},o),l}async writeFile(t,i,o){let l;try{const a=this.toFilePath(t);if(!o.create||!o.overwrite){if(await f.Promises.exists(a)){if(!o.overwrite)throw(0,C.createFileSystemProviderError)((0,S.localize)(0,null),C.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,C.createFileSystemProviderError)((0,S.localize)(1,null),C.FileSystemProviderErrorCode.FileNotFound)}l=await this.open(t,{create:!0,unlock:o.unlock}),await this.write(l,0,i,0,i.byteLength)}catch(a){throw await this.toFileSystemProviderWriteError(t,a)}finally{typeof l=="number"&&await this.close(l)}}static configureFlushOnWrite(t){s.canFlush=t}async open(t,i){const o=this.toFilePath(t);let l;(0,C.isFileOpenForWriteOptions)(i)&&(l=await this.createResourceLock(t));let a;try{if((0,C.isFileOpenForWriteOptions)(i)&&i.unlock)try{const{stat:p}=await f.SymlinkSupport.stat(o);p.mode&128||await f.Promises.chmod(o,p.mode|128)}catch(p){this.logService.trace(p)}let h;if((0,C.isFileOpenForWriteOptions)(i)){if(w.isWindows)try{await f.Promises.truncate(o,0),h="r+"}catch(p){p.code!=="ENOENT"&&this.logService.trace(p)}h||(h="w")}else h="r";a=await f.Promises.open(o,h)}catch(h){throw l?.dispose(),(0,C.isFileOpenForWriteOptions)(i)?await this.toFileSystemProviderWriteError(t,h):this.toFileSystemProviderError(h)}if(this.mapHandleToPos.set(a,0),(0,C.isFileOpenForWriteOptions)(i)&&this.writeHandles.set(a,t),l){const h=this.mapHandleToLock.get(a);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${a} (${o})`),this.mapHandleToLock.set(a,l),h&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${a} (${o})`),h.dispose())}return a}async close(t){const i=this.mapHandleToLock.get(t);try{if(this.mapHandleToPos.delete(t),this.writeHandles.delete(t)&&s.canFlush)try{await f.Promises.fdatasync(t)}catch(o){s.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(t)}catch(o){throw this.toFileSystemProviderError(o)}finally{i&&(this.mapHandleToLock.get(t)===i&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${t}`),this.mapHandleToLock.delete(t)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${t}`),i.dispose())}}async read(t,i,o,l,a){const h=this.normalizePos(t,i);let p=null;try{p=(await f.Promises.read(t,o,l,a,h)).bytesRead}catch(R){throw this.toFileSystemProviderError(R)}finally{this.updatePos(t,h,p)}return p}normalizePos(t,i){return i===this.mapHandleToPos.get(t)?null:i}updatePos(t,i,o){const l=this.mapHandleToPos.get(t);typeof l=="number"&&(typeof i=="number"||(typeof o=="number"?this.mapHandleToPos.set(t,l+o):this.mapHandleToPos.delete(t)))}async write(t,i,o,l,a){return(0,k.retry)(()=>this.doWrite(t,i,o,l,a),100,3)}async doWrite(t,i,o,l,a){const h=this.normalizePos(t,i);let p=null;try{p=(await f.Promises.write(t,o,l,a,h)).bytesWritten}catch(R){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(t),R)}finally{this.updatePos(t,h,p)}return p}async mkdir(t){try{await f.Promises.mkdir(this.toFilePath(t))}catch(i){throw this.toFileSystemProviderError(i)}}async delete(t,i){try{const o=this.toFilePath(t);i.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(t,i,o){const l=this.toFilePath(t),a=this.toFilePath(i);if(l!==a)try{await this.validateTargetDeleted(t,i,"move",o.overwrite),await f.Promises.move(l,a)}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(2,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async copy(t,i,o){const l=this.toFilePath(t),a=this.toFilePath(i);if(l!==a)try{await this.validateTargetDeleted(t,i,"copy",o.overwrite),await f.Promises.copy(l,a,{preserveSymlinks:!0})}catch(h){throw(h.code==="EINVAL"||h.code==="EBUSY"||h.code==="ENAMETOOLONG")&&(h=new Error((0,S.localize)(3,null,(0,E.basename)(l),(0,E.basename)((0,E.dirname)(a)),h.toString()))),this.toFileSystemProviderError(h)}}async validateTargetDeleted(t,i,o,l){const a=this.toFilePath(t),h=this.toFilePath(i);let p=!1;if(!!(this.capabilities&1024)||(p=(0,P.isEqual)(a,h,!0)),p&&o==="copy")throw(0,C.createFileSystemProviderError)((0,S.localize)(4,null),C.FileSystemProviderErrorCode.FileExists);if(!p&&await f.Promises.exists(h)){if(!l)throw(0,C.createFileSystemProviderError)((0,S.localize)(5,null),C.FileSystemProviderErrorCode.FileExists);await this.delete(i,{recursive:!0,useTrash:!1})}}async cloneFile(t,i){return this.doCloneFile(t,i,!1)}async doCloneFile(t,i,o){const l=this.toFilePath(t),a=this.toFilePath(i),h=!!(this.capabilities&1024);if((0,P.isEqual)(l,a,!h))return;const p=new I.DisposableStore;try{const[R,M]=await Promise.all([this.createResourceLock(t),this.createResourceLock(i)]);p.add(R),p.add(M),o&&await f.Promises.mkdir((0,E.dirname)(a),{recursive:!0}),await f.Promises.copyFile(l,a)}catch(R){if(R.code==="ENOENT"&&!o)return this.doCloneFile(t,i,!0);throw this.toFileSystemProviderError(R)}finally{p.dispose()}}createUniversalWatcher(t,i,o){return new d.UniversalWatcherClient(l=>t(l),l=>i(l),o)}createNonRecursiveWatcher(t,i,o){return new u.NodeJSWatcherClient(l=>t(l),l=>i(l),o)}toFileSystemProviderError(t){if(t instanceof C.FileSystemProviderError)return t;let i;switch(t.code){case"ENOENT":i=C.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":i=C.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":i=C.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":i=C.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":i=C.FileSystemProviderErrorCode.NoPermissions;break;default:i=C.FileSystemProviderErrorCode.Unknown}return(0,C.createFileSystemProviderError)(t,i)}async toFileSystemProviderWriteError(t,i){let o=this.toFileSystemProviderError(i);if(t&&o.code===C.FileSystemProviderErrorCode.NoPermissions)try{const{stat:l}=await f.SymlinkSupport.stat(this.toFilePath(t));l.mode&128||(o=(0,C.createFileSystemProviderError)(i,C.FileSystemProviderErrorCode.FileWriteLocked))}catch(l){this.logService.trace(l)}return o}}e.DiskFileSystemProvider=s,s.canFlush=!0}),define(re[95],se([0,1,3,7,8]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FollowerLogService=e.LoggerChannelClient=e.LoggerChannel=e.LogLevelChannelClient=e.LogLevelChannel=void 0;class L{constructor(v){this.service=v,this.onDidChangeLogLevel=D.Event.buffer(v.onDidChangeLogLevel,!0)}listen(v,y){switch(y){case"onDidChangeLogLevel":return this.onDidChangeLogLevel}throw new Error(`Event not found: ${y}`)}async call(v,y,f){switch(y){case"setLevel":return this.service.setLevel(f)}throw new Error(`Call not found: ${y}`)}}e.LogLevelChannel=L;class A{constructor(v){this.channel=v}get onDidChangeLogLevel(){return this.channel.listen("onDidChangeLogLevel")}setLevel(v){A.setLevel(this.channel,v)}static setLevel(v,y){return v.call("setLevel",y)}}e.LogLevelChannelClient=A;class b{constructor(v){this.loggerService=v,this.loggers=new Map}listen(v,y){throw new Error(`Event not found: ${y}`)}async call(v,y,f){switch(y){case"createLogger":this.createLogger(n.URI.revive(f[0]),f[1]);return;case"log":return this.log(n.URI.revive(f[0]),f[1]);case"consoleLog":return this.consoleLog(f[0],f[1])}throw new Error(`Call not found: ${y}`)}createLogger(v,y){this.loggers.set(v.toString(),this.loggerService.createLogger(v,y))}consoleLog(v,y){let f=console.log;switch(v){case k.LogLevel.Error:f=console.error;break;case k.LogLevel.Warning:f=console.warn;break;case k.LogLevel.Info:f=console.info;break}f.call(console,...y)}log(v,y){const f=this.loggers.get(v.toString());if(!f)throw new Error("Create the logger before logging");for(const[S,C]of y)(0,k.log)(f,S,C)}}e.LoggerChannel=b;class P extends k.AbstractLoggerService{constructor(v,y,f){super(v,y);this.channel=f}createConsoleMainLogger(){return new k.AdapterLogger({log:(v,y)=>{this.channel.call("consoleLog",[v,y])}})}doCreateLogger(v,y,f){return new I(this.channel,v,y,f)}}e.LoggerChannelClient=P;class I extends k.AbstractMessageLogger{constructor(v,y,f,S){super(S?.always);this.channel=v,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(f),this.channel.call("createLogger",[y,S]).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(v,y){const f=[[v,y]];this.isLoggerCreated?this.doLog(f):this.buffer.push(...f)}doLog(v){this.channel.call("log",[this.file,v])}}class E extends k.LogService{constructor(v,y){super(y);this.parent=v,this._register(v.onDidChangeLogLevel(f=>y.setLevel(f)))}setLevel(v){super.setLevel(v),this.parent.setLevel(v)}}e.FollowerLogService=E}),define(re[67],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeHostService=void 0,e.INativeHostService=(0,D.createDecorator)("nativeHostService")}),define(re[58],se([0,1,3,51,2,5]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullPolicyService=e.AbstractPolicyService=e.IPolicyService=void 0,e.IPolicyService=(0,L.createDecorator)("policy");class A extends k.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(I){const E=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...I,...this.policyDefinitions},E!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(I),n.Iterable.reduce(this.policies.entries(),(w,[v,y])=>({...w,[v]:y}),{})}getPolicyValue(I){return this.policies.get(I)}serialize(){return n.Iterable.reduce(Object.entries(this.policyDefinitions),(I,[E,w])=>({...I,[E]:{definition:w,value:this.policies.get(E)}}),{})}}e.AbstractPolicyService=A;class b{constructor(){this.onDidChange=D.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}e.NullPolicyService=b}),define(re[190],se([0,1,3,2,58]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyChannelClient=e.PolicyChannel=void 0;class L{constructor(P){this.service=P,this.disposables=new n.DisposableStore}listen(P,I){switch(I){case"onDidChange":return D.Event.map(this.service.onDidChange,E=>E.reduce((w,v)=>({...w,[v]:this.service.getPolicyValue(v)??null}),{}),this.disposables)}throw new Error(`Event not found: ${I}`)}call(P,I,E){switch(I){case"registerPolicyDefinitions":return this.service.registerPolicyDefinitions(E)}throw new Error(`Call not found: ${I}`)}dispose(){this.disposables.dispose()}}e.PolicyChannel=L;class A extends k.AbstractPolicyService{constructor(P,I){super();this.channel=I;for(const E in P){const{definition:w,value:v}=P[E];this.policyDefinitions[E]=w,v!==void 0&&this.policies.set(E,v)}this.channel.listen("onDidChange")(E=>{for(const w in E){const v=E[w];v===null?this.policies.delete(w):this.policies.set(w,v)}this._onDidChange.fire(Object.keys(E))})}async initializePolicies(P){const I=await this.channel.call("registerPolicyDefinitions",P);for(const E in I)this.policies.set(E,I[E])}}e.PolicyChannelClient=A}),define(re[96],se([0,1,20,4,36,17]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0});let A;if(typeof n.globals.vscode!="undefined"&&typeof n.globals.vscode.context!="undefined"){const b=n.globals.vscode.context.configuration();if(b)A=b.product;else throw new Error("Sandbox: unable to resolve product configuration from preload script.")}else if(typeof X?.__$__nodeRequire=="function"){const b=(0,L.dirname)(D.FileAccess.asFileUri("",X));A=X.__$__nodeRequire((0,L.joinPath)(b,"product.json").fsPath);const P=X.__$__nodeRequire((0,L.joinPath)(b,"package.json").fsPath);k.env.VSCODE_DEV&&Object.assign(A,{nameShort:`${A.nameShort} Dev`,nameLong:`${A.nameLong} Dev`,dataFolderName:`${A.dataFolderName}-dev`,serverDataFolderName:A.serverDataFolderName?`${A.serverDataFolderName}-dev`:void 0}),Object.assign(A,{version:P.version})}else A={},Object.keys(A).length===0&&Object.assign(A,{version:"1.67.0-dev",nameShort:"Code - OSS Dev",nameLong:"Code - OSS Dev",applicationName:"code-oss",dataFolderName:".vscode-oss",urlProtocol:"code-oss",reportIssueUrl:"https://github.com/microsoft/vscode/issues/new",licenseName:"MIT",licenseUrl:"https://github.com/microsoft/vscode/blob/main/LICENSE.txt"});e.default=A}),define(re[24],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,D.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"}),define(re[191],se([0,1,6,9,2,10,27,8,24]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CodeCacheCleaner=void 0;let I=class extends k.Disposable{constructor(w,v,y){super();this.productService=v,this.logService=y,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,w&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpCodeCaches(w)},30*1e3)).schedule()}async cleanUpCodeCaches(w){this.logService.trace("[code cache cleanup]: Starting to clean up old code cache folders.");try{const v=Date.now(),y=(0,L.dirname)(w),f=(0,L.basename)(w),S=await A.Promises.readdir(y);await Promise.all(S.map(async C=>{if(C===f)return;const m=(0,L.join)(y,C),g=await A.Promises.stat(m);if(g.isDirectory()&&v-g.mtime.getTime()>this._DataMaxAge)return this.logService.trace(`[code cache cleanup]: Removing code cache folder ${C}.`),A.Promises.rm(m)}))}catch(v){(0,n.onUnexpectedError)(v)}}};I=me([G(1,P.IProductService),G(2,b.ILogService)],I),e.CodeCacheCleaner=I}),define(re[192],se([0,1,6,9,2,10,27,14,8,24]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LanguagePackCachedDataCleaner=void 0;let E=class extends k.Disposable{constructor(v,y,f){super();this.environmentService=v,this.logService=y,this.productService=f,this._DataMaxAge=this.productService.quality!=="stable"?1e3*60*60*24*7:1e3*60*60*24*30*3,this.environmentService.isBuilt&&this._register(new D.RunOnceScheduler(()=>{this.cleanUpLanguagePackCache()},40*1e3)).schedule()}async cleanUpLanguagePackCache(){this.logService.trace("[language pack cache cleanup]: Starting to clean up unused language packs.");try{const v=Object.create(null),y=JSON.parse(await A.Promises.readFile((0,L.join)(this.environmentService.userDataPath,"languagepacks.json"),"utf8"));for(const g of Object.keys(y)){const c=y[g];v[`${c.hash}.${g}`]=!0}const f=(0,L.join)(this.environmentService.userDataPath,"clp");if(!await A.Promises.exists(f))return;const C=await A.Promises.readdir(f);for(const g of C){if(v[g]){this.logService.trace(`[language pack cache cleanup]: Skipping folder ${g}. Language pack still in use.`);continue}this.logService.trace(`[language pack cache cleanup]: Removing unused language pack: ${g}`),await A.Promises.rm((0,L.join)(f,g))}const m=Date.now();for(const g of Object.keys(v)){const c=(0,L.join)(f,g),d=await A.Promises.readdir(c);for(const u of d){if(u==="tcf.json")continue;const s=(0,L.join)(c,u),r=await A.Promises.stat(s);r.isDirectory()&&m-r.mtime.getTime()>this._DataMaxAge&&(this.logService.trace(`[language pack cache cleanup]: Removing language pack cache folder: ${(0,L.join)(g,u)}`),await A.Promises.rm(s))}}}catch(v){(0,n.onUnexpectedError)(v)}}};E=me([G(0,b.INativeEnvironmentService),G(1,P.ILogService),G(2,I.IProductService)],E),e.LanguagePackCachedDataCleaner=E}),define(re[193],se([0,1,10,5]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Utils=e.IV8InspectProfilingService=void 0,e.IV8InspectProfilingService=(0,n.createDecorator)("IV8InspectProfilingService");var k;(function(L){function A(b,P="noAbsolutePaths"){for(const I of b.nodes)I.callFrame&&I.callFrame.url&&((0,D.isAbsolute)(I.callFrame.url)||/^\w[\w\d+.-]*:\/\/\//.test(I.callFrame.url))&&(I.callFrame.url=(0,D.join)(P,(0,D.basename)(I.callFrame.url)));return b}L.rewriteAbsolutePaths=A})(k=e.Utils||(e.Utils={}))}),define(re[194],se([0,1,30]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.InspectProfilingService=void 0;class n{constructor(){this._sessions=new Map}async startProfiling(L){const b=await(await new Promise((I,E)=>{X(["v8-inspect-profiler"],I,E)})).startProfiling({port:L.port,checkForPaused:!0}),P=(0,D.generateUuid)();return this._sessions.set(P,b),P}async stopProfiling(L){const A=this._sessions.get(L);if(!A)throw new Error(`UNKNOWN session '${L}'`);const b=await A.stop();return this._sessions.delete(L),b.profile}}e.InspectProfilingService=n}),define(re[40],se([0,1,110,15]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class k{constructor(){this.data=new Map}add(A,b){D.ok(n.isString(A)),D.ok(n.isObject(b)),D.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,b)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}e.Registry=new k}),define(re[97],se([0,1,3,40]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function k(b){return b.length>0&&b.charAt(b.length-1)==="#"?b.substring(0,b.length-1):b}class L{constructor(){this._onDidChangeSchema=new D.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(P,I){this.schemasById[k(P)]=I,this._onDidChangeSchema.fire(P)}notifySchemaChanged(P){this._onDidChangeSchema.fire(P)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new L;n.Registry.add(e.Extensions.JSONContribution,A)}),define(re[42],se([0,1,18,3,15,136,19,97,40]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var I;(function(u){u.Multiline="multilineText",u.Singleline="singlelineText"})(I=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var E;(function(u){u[u.APPLICATION=1]="APPLICATION",u[u.MACHINE=2]="MACHINE",u[u.WINDOW=3]="WINDOW",u[u.RESOURCE=4]="RESOURCE",u[u.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",u[u.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(E=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const w=P.Registry.as(b.Extensions.JSONContribution);class v{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new n.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new n.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,r=!0){this.registerConfigurations([s],r)}registerConfigurations(s,r=!0){const t=this.doRegisterConfigurations(s,r);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:t})}deregisterConfigurations(s){const r=this.doDeregisterConfigurations(s);w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r})}updateConfigurations({add:s,remove:r}){const t=[];t.push(...this.doDeregisterConfigurations(r)),t.push(...this.doRegisterConfigurations(s,!1)),w.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,D.distinct)(t)})}registerDefaultConfigurations(s){const r=[],t=[];for(const{overrides:i,source:o}of s)for(const l in i)if(r.push(l),e.OVERRIDE_PROPERTY_REGEX.test(l)){const a=this.configurationDefaultsOverrides.get(l),h=a?.valuesSources??new Map;if(o)for(const O of Object.keys(i[l]))h.set(O,o);const p={...a?.value||{},...i[l]};this.configurationDefaultsOverrides.set(l,{source:o,value:p,valuesSources:h});const R=(0,A.getLanguageTagSettingPlainKey)(l),M={type:"object",default:p,description:L.localize(1,null,R),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:p,source:k.isString(o)?void 0:o,defaultValueSource:o};t.push(...S(l)),this.configurationProperties[l]=M,this.defaultLanguageConfigurationOverridesNode.properties[l]=M}else{this.configurationDefaultsOverrides.set(l,{value:i[l],source:o});const a=this.configurationProperties[l];a&&(this.updatePropertyDefaultValue(l,a),this.updateSchema(l,a))}this.registerOverrideIdentifiers(t),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const r=[];for(const{overrides:t,source:i}of s)for(const o in t){const l=this.configurationDefaultsOverrides.get(o),a=k.isString(i)?i:i?.id,h=k.isString(l?.source)?l?.source:l?.source?.id;if(a===h)if(r.push(o),this.configurationDefaultsOverrides.delete(o),e.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const p=this.configurationProperties[o];p&&(this.updatePropertyDefaultValue(o,p),this.updateSchema(o,p))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:r,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const r of s)this.overrideIdentifiers.add(r);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,r){const t=[];return s.forEach(i=>{t.push(...this.validateAndRegisterProperties(i,r,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),t}doDeregisterConfigurations(s){const r=[],t=i=>{if(i.properties)for(const o in i.properties){r.push(o);const l=this.configurationProperties[o];l?.policy?.name&&this.policyConfigurations.delete(l.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,i.properties[o])}i.allOf?.forEach(o=>t(o))};for(const i of s){t(i);const o=this.configurationContributors.indexOf(i);o!==-1&&this.configurationContributors.splice(o,1)}return r}validateAndRegisterProperties(s,r=!0,t,i,o=3){o=k.isUndefinedOrNull(s.scope)?o:s.scope;const l=[],a=s.properties;if(a)for(const p in a){const R=a[p];if(r&&c(p,R)){delete a[p];continue}if(R.source=t,R.defaultDefaultValue=a[p].default,this.updatePropertyDefaultValue(p,R),e.OVERRIDE_PROPERTY_REGEX.test(p)?R.scope=void 0:(R.scope=k.isUndefinedOrNull(R.scope)?o:R.scope,R.restricted=k.isUndefinedOrNull(R.restricted)?!!i?.includes(p):R.restricted),a[p].hasOwnProperty("included")&&!a[p].included){this.excludedConfigurationProperties[p]=a[p],delete a[p];continue}else this.configurationProperties[p]=a[p],a[p].policy?.name&&this.policyConfigurations.set(a[p].policy.name,p);!a[p].deprecationMessage&&a[p].markdownDeprecationMessage&&(a[p].deprecationMessage=a[p].markdownDeprecationMessage),l.push(p)}const h=s.allOf;if(h)for(const p of h)l.push(...this.validateAndRegisterProperties(p,r,t,i,o));return l}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const r=t=>{const i=t.properties;if(i)for(const l in i)this.updateSchema(l,i[l]);t.allOf?.forEach(r)};r(s)}updateSchema(s,r){switch(e.allSettings.properties[s]=r,r.scope){case 1:e.applicationSettings.properties[s]=r;break;case 2:e.machineSettings.properties[s]=r;break;case 6:e.machineOverridableSettings.properties[s]=r;break;case 3:e.windowSettings.properties[s]=r;break;case 4:e.resourceSettings.properties[s]=r;break;case 5:e.resourceSettings.properties[s]=r,this.resourceLanguageSettingsSchema.properties[s]=r;break}}removeFromSchema(s,r){switch(delete e.allSettings.properties[s],r.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const r=`[${s}]`,t={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(r,t),e.allSettings.properties[r]=t,e.applicationSettings.properties[r]=t,e.machineSettings.properties[r]=t,e.machineOverridableSettings.properties[r]=t,e.windowSettings.properties[r]=t,e.resourceSettings.properties[r]=t}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,r){const t=this.configurationDefaultsOverrides.get(s);let i=t?.value,o=t?.source;k.isUndefined(i)&&(i=r.defaultDefaultValue,o=void 0),k.isUndefined(i)&&(i=m(r.type)),r.default=i,r.defaultValueSource=o}}const y="\\[([^\\]]+)\\]",f=new RegExp(y,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${y})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function S(u){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(u)){let r=f.exec(u);for(;r?.length;){const t=r[1].trim();t&&s.push(t),r=f.exec(u)}}return(0,D.distinct)(s)}e.overrideIdentifiersFromKey=S;function C(u){return u.reduce((s,r)=>`${s}[${r}]`,"")}e.keyFromOverrideIdentifiers=C;function m(u){switch(Array.isArray(u)?u[0]:u){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=m;const g=new v;P.Registry.add(e.Extensions.Configuration,g);function c(u,s){return u.trim()?e.OVERRIDE_PROPERTY_REGEX.test(u)?L.localize(7,null,u):g.getConfigurationProperties()[u]!==void 0?L.localize(8,null,u):s.policy?.name&&g.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,u,s.policy?.name,g.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.validateProperty=c;function d(){const u=[],s=g.getConfigurationProperties();for(const r of Object.keys(s))u.push([r,s[r].scope]);return u.push(["launch",4]),u.push(["task",4]),u}e.getScopes=d}),define(re[68],se([0,1,18,3,35,2,34,31,15,7,19,42,40]),function(X,e,D,n,k,L,A,b,P,I,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class y{constructor(r={},t=[],i=[]){this._contents=r,this._keys=t,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(r){return r?(0,E.getConfigurationValue)(this.contents,r):this.contents}getOverrideValue(r,t){const i=this.getContentsForOverrideIdentifer(t);return i?r?(0,E.getConfigurationValue)(i,r):i:void 0}getKeysForOverrideIdentifier(r){const t=[];for(const i of this.overrides)i.identifiers.includes(r)&&t.push(...i.keys);return D.distinct(t)}getAllOverrideIdentifiers(){const r=[];for(const t of this.overrides)r.push(...t.identifiers);return D.distinct(r)}override(r){let t=this.overrideConfigurations.get(r);return t||(t=this.createOverrideConfigurationModel(r),this.overrideConfigurations.set(r,t)),t}merge(...r){const t=b.deepClone(this.contents),i=b.deepClone(this.overrides),o=[...this.keys];for(const l of r)if(!l.isEmpty()){this.mergeContents(t,l.contents);for(const a of l.overrides){const[h]=i.filter(p=>D.equals(p.identifiers,a.identifiers));h?(this.mergeContents(h.contents,a.contents),h.keys.push(...a.keys),h.keys=D.distinct(h.keys)):i.push(b.deepClone(a))}for(const a of l.keys)o.indexOf(a)===-1&&o.push(a)}return new y(t,o,i)}freeze(){return this.frozen=!0,this}clone(){return new y(b.deepClone(this.contents),[...this.keys],b.deepClone(this.overrides))}createOverrideConfigurationModel(r){const t=this.getContentsForOverrideIdentifer(r);if(!t||typeof t!="object"||!Object.keys(t).length)return this;const i={};for(const o of D.distinct([...Object.keys(this.contents),...Object.keys(t)])){let l=this.contents[o];const a=t[o];a&&(typeof l=="object"&&typeof a=="object"?(l=b.deepClone(l),this.mergeContents(l,a)):l=a),i[o]=l}return new y(i,this.keys,this.overrides)}mergeContents(r,t){for(const i of Object.keys(t)){if(i in r&&P.isObject(r[i])&&P.isObject(t[i])){this.mergeContents(r[i],t[i]);continue}r[i]=b.deepClone(t[i])}}checkAndFreeze(r){return this.frozen&&!Object.isFrozen(r)?b.deepFreeze(r):r}getContentsForOverrideIdentifer(r){let t=null,i=null;const o=l=>{l&&(i?this.mergeContents(i,l):i=b.deepClone(l))};for(const l of this.overrides)D.equals(l.identifiers,[r])?t=l.contents:l.identifiers.includes(r)&&o(l.contents);return o(t),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(r,t){this.addKey(r),(0,E.addToValueTree)(this.contents,r,t,i=>{throw new Error(i)})}removeValue(r){this.removeKey(r)&&(0,E.removeFromValueTree)(this.contents,r)}addKey(r){let t=this.keys.length;for(let i=0;i<t;i++)r.indexOf(this.keys[i])===0&&(t=i);this.keys.splice(t,1,r)}removeKey(r){const t=this.keys.indexOf(r);return t!==-1?(this.keys.splice(t,1),!0):!1}}e.ConfigurationModel=y;class f{constructor(r){this._name=r,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new y}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(r,t){if(!P.isUndefinedOrNull(r)){const i=this.doParseContent(r);this.parseRaw(i,t)}}reparse(r){this._raw&&this.parseRaw(this._raw,r)}parseRaw(r,t){this._raw=r;const{contents:i,keys:o,overrides:l,restricted:a}=this.doParseRaw(r,t);this._configurationModel=new y(i,o,l),this._restrictedConfigurations=a||[]}doParseContent(r){let t={},i=null,o=[];const l=[],a=[];function h(R){Array.isArray(o)?o.push(R):i!==null&&(o[i]=R)}const p={onObjectBegin:()=>{const R={};h(R),l.push(o),o=R,i=null},onObjectProperty:R=>{i=R},onObjectEnd:()=>{o=l.pop()},onArrayBegin:()=>{const R=[];h(R),l.push(o),o=R,i=null},onArrayEnd:()=>{o=l.pop()},onLiteralValue:h,onError:(R,M,O)=>{a.push({error:R,offset:M,length:O})}};if(r)try{k.visit(r,p),t=o[0]||{}}catch(R){console.error(`Error while parsing settings file ${this._name}: ${R}`),this._parseErrors=[R]}return t}doParseRaw(r,t){const i=v.Registry.as(w.Extensions.Configuration).getConfigurationProperties(),o=this.filter(r,i,!0,t);r=o.raw;const l=(0,E.toValuesTree)(r,p=>console.error(`Conflict in settings file ${this._name}: ${p}`)),a=Object.keys(r),h=this.toOverrides(r,p=>console.error(`Conflict in settings file ${this._name}: ${p}`));return{contents:l,keys:a,overrides:h,restricted:o.restricted}}filter(r,t,i,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:r,restricted:[]};const l={},a=[];for(const h in r)if(w.OVERRIDE_PROPERTY_REGEX.test(h)&&i){const p=this.filter(r[h],t,!1,o);l[h]=p.raw,a.push(...p.restricted)}else{const p=t[h],R=p?typeof p.scope!="undefined"?p.scope:3:void 0;p?.restricted&&a.push(h),(R===void 0||o.scopes===void 0||o.scopes.includes(R))&&(o.skipRestricted&&p?.restricted||(l[h]=r[h]))}return{raw:l,restricted:a}}toOverrides(r,t){const i=[];for(const o of Object.keys(r))if(w.OVERRIDE_PROPERTY_REGEX.test(o)){const l={};for(const a in r[o])l[a]=r[o][a];i.push({identifiers:(0,w.overrideIdentifiersFromKey)(o),keys:Object.keys(l),contents:(0,E.toValuesTree)(l,t)})}return i}}e.ConfigurationModelParser=f;class S extends L.Disposable{constructor(r,t,i,o){super();this.userSettingsResource=r,this.scopes=t,this.fileService=o,this._onDidChange=this._register(new n.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(n.Event.any(n.Event.filter(this.fileService.onDidFilesChange,l=>l.contains(this.userSettingsResource)),n.Event.filter(this.fileService.onDidRunOperation,l=>(l.isOperation(0)||l.isOperation(3)||l.isOperation(1)||l.isOperation(4))&&i.isEqual(l.resource,r)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const r=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(r.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new y}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=S;class C{constructor(r,t,i,o,l=new y,a=new y,h=new A.ResourceMap,p=new y,R=new A.ResourceMap,M=!0){this._defaultConfiguration=r,this._policyConfiguration=t,this._applicationConfiguration=i,this._localUserConfiguration=o,this._remoteUserConfiguration=l,this._workspaceConfiguration=a,this._folderConfigurations=h,this._memoryConfiguration=p,this._memoryConfigurationByResource=R,this._freeze=M,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(r,t,i){return this.getConsolidatedConfigurationModel(r,t,i).getValue(r)}updateValue(r,t,i={}){let o;i.resource?(o=this._memoryConfigurationByResource.get(i.resource),o||(o=new y,this._memoryConfigurationByResource.set(i.resource,o))):o=this._memoryConfiguration,t===void 0?o.removeValue(r):o.setValue(r,t),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(r,t,i){const o=this.getConsolidatedConfigurationModel(r,t,i),l=this.getFolderConfigurationModelForResource(t.resource,i),a=t.resource?this._memoryConfigurationByResource.get(t.resource)||this._memoryConfiguration:this._memoryConfiguration,h=t.overrideIdentifier?this._defaultConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._defaultConfiguration.freeze().getValue(r),p=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(r),R=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(r),M=t.overrideIdentifier?this.userConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.userConfiguration.freeze().getValue(r),O=t.overrideIdentifier?this.localUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.localUserConfiguration.freeze().getValue(r),F=t.overrideIdentifier?this.remoteUserConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this.remoteUserConfiguration.freeze().getValue(r),T=i?t.overrideIdentifier?this._workspaceConfiguration.freeze().override(t.overrideIdentifier).getValue(r):this._workspaceConfiguration.freeze().getValue(r):void 0,N=l?t.overrideIdentifier?l.freeze().override(t.overrideIdentifier).getValue(r):l.freeze().getValue(r):void 0,W=t.overrideIdentifier?a.override(t.overrideIdentifier).getValue(r):a.getValue(r),V=o.getValue(r),Y=D.distinct(o.overrides.map($=>$.identifiers).flat()).filter($=>o.getOverrideValue(r,$)!==void 0);return{defaultValue:h,policyValue:p,applicationValue:R,userValue:M,userLocalValue:O,userRemoteValue:F,workspaceValue:T,workspaceFolderValue:N,memoryValue:W,value:V,default:h!==void 0?{value:this._defaultConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,policy:p!==void 0?{value:p}:void 0,application:R!==void 0?{value:R,override:t.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,user:M!==void 0?{value:this.userConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userLocal:O!==void 0?{value:this.localUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,userRemote:F!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspace:T!==void 0?{value:this._workspaceConfiguration.freeze().getValue(r),override:t.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,workspaceFolder:N!==void 0?{value:l?.freeze().getValue(r),override:t.overrideIdentifier?l?.freeze().getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,memory:W!==void 0?{value:a.getValue(r),override:t.overrideIdentifier?a.getOverrideValue(r,t.overrideIdentifier):void 0}:void 0,overrideIdentifiers:Y.length?Y:void 0}}keys(r){const t=this.getFolderConfigurationModelForResource(void 0,r);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:t?t.freeze().keys:[]}}updateDefaultConfiguration(r){this._defaultConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(r){this._policyConfiguration=r}updateApplicationConfiguration(r){this._applicationConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(r){this._localUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(r){this._remoteUserConfiguration=r,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(r){this._workspaceConfiguration=r,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(r,t){this._folderConfigurations.set(r,t),this._foldersConsolidatedConfigurations.delete(r)}deleteFolderConfiguration(r){this.folderConfigurations.delete(r),this._foldersConsolidatedConfigurations.delete(r)}compareAndUpdateDefaultConfiguration(r,t){const i=[];if(!t){const{added:o,updated:l,removed:a}=d(this._defaultConfiguration,r);t=[...o,...l,...a]}for(const o of t)for(const l of(0,w.overrideIdentifiersFromKey)(o)){const a=this._defaultConfiguration.getKeysForOverrideIdentifier(l),h=r.getKeysForOverrideIdentifier(l),p=[...h.filter(R=>a.indexOf(R)===-1),...a.filter(R=>h.indexOf(R)===-1),...a.filter(R=>!b.equals(this._defaultConfiguration.override(l).getValue(R),r.override(l).getValue(R)))];i.push([l,p])}return this.updateDefaultConfiguration(r),{keys:t,overrides:i}}compareAndUpdatePolicyConfiguration(r){const{added:t,updated:i,removed:o}=d(this._policyConfiguration,r),l=[...t,...i,...o];return l.length&&this.updatePolicyConfiguration(r),{keys:l,overrides:[]}}compareAndUpdateApplicationConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=d(this.applicationConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateApplicationConfiguration(r),{keys:a,overrides:l}}compareAndUpdateLocalUserConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=d(this.localUserConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateLocalUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateRemoteUserConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=d(this.remoteUserConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateRemoteUserConfiguration(r),{keys:a,overrides:l}}compareAndUpdateWorkspaceConfiguration(r){const{added:t,updated:i,removed:o,overrides:l}=d(this.workspaceConfiguration,r),a=[...t,...i,...o];return a.length&&this.updateWorkspaceConfiguration(r),{keys:a,overrides:l}}compareAndUpdateFolderConfiguration(r,t){const i=this.folderConfigurations.get(r),{added:o,updated:l,removed:a,overrides:h}=d(i,t),p=[...o,...l,...a];return(p.length||!i)&&this.updateFolderConfiguration(r,t),{keys:p,overrides:h}}compareAndDeleteFolderConfiguration(r){const t=this.folderConfigurations.get(r);if(!t)throw new Error("Unknown folder");this.deleteFolderConfiguration(r);const{added:i,updated:o,removed:l,overrides:a}=d(t,void 0);return{keys:[...i,...o,...l],overrides:a}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(r,t,i){let o=this.getConsolidatedConfigurationModelForResource(t,i);return t.overrideIdentifier&&(o=o.override(t.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(r)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:r},t){let i=this.getWorkspaceConsolidatedConfiguration();if(t&&r){const o=t.getFolder(r);o&&(i=this.getFolderConsolidatedConfiguration(o.uri)||i);const l=this._memoryConfigurationByResource.get(r);l&&(i=i.merge(l))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(r){let t=this._foldersConsolidatedConfigurations.get(r);if(!t){const i=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(r);o?(t=i.merge(o),this._freeze&&(t=t.freeze()),this._foldersConsolidatedConfigurations.set(r,t)):t=i}return t}getFolderConfigurationModelForResource(r,t){if(t&&r){const i=t.getFolder(r);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((r,t)=>{const{contents:i,overrides:o,keys:l}=this._folderConfigurations.get(t);return r.push([t,{contents:i,overrides:o,keys:l}]),r},[])}}allKeys(){const r=new Set;return this._defaultConfiguration.freeze().keys.forEach(t=>r.add(t)),this.userConfiguration.freeze().keys.forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().keys.forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().keys.forEach(i=>r.add(i))),[...r.values()]}allOverrideIdentifiers(){const r=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(t=>r.add(t)),this._folderConfigurations.forEach(t=>t.freeze().getAllOverrideIdentifiers().forEach(i=>r.add(i))),[...r.values()]}getAllKeysForOverrideIdentifier(r){const t=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(r).forEach(i=>t.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(r).forEach(o=>t.add(o))),[...t.values()]}static parse(r){const t=this.parseConfigurationModel(r.defaults),i=this.parseConfigurationModel(r.policy),o=this.parseConfigurationModel(r.application),l=this.parseConfigurationModel(r.user),a=this.parseConfigurationModel(r.workspace),h=r.folders.reduce((p,R)=>(p.set(I.URI.revive(R[0]),this.parseConfigurationModel(R[1])),p),new A.ResourceMap);return new C(t,i,o,l,new y,a,h,new y,new A.ResourceMap,!1)}static parseConfigurationModel(r){return new y(r.contents,r.keys,r.overrides).freeze()}}e.Configuration=C;function m(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const r=new Set,t=new Map;for(const o of s)o.keys.forEach(l=>r.add(l)),o.overrides.forEach(([l,a])=>{const h=(0,A.getOrSet)(t,l,new Set);a.forEach(p=>h.add(p))});const i=[];return t.forEach((o,l)=>i.push([l,[...o.values()]])),{keys:[...r.values()],overrides:i}}e.mergeChanges=m;class g{constructor(r,t,i,o){this.change=r,this.previous=t,this.currentConfiguraiton=i,this.currentWorkspace=o,this._previousConfiguration=void 0;const l=new Set;r.keys.forEach(h=>l.add(h)),r.overrides.forEach(([,h])=>h.forEach(p=>l.add(p))),this.affectedKeys=[...l.values()];const a=new y;this.affectedKeys.forEach(h=>a.setValue(h,{})),this.affectedKeysTree=a.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=C.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(r,t){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,r)){if(t){const i=this.previousConfiguration?this.previousConfiguration.getValue(r,t,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(r,t,this.currentWorkspace);return!b.equals(i,o)}return!0}return!1}doesAffectedKeysTreeContains(r,t){let i=(0,E.toValuesTree)({[t]:!0},()=>{}),o;for(;typeof i=="object"&&(o=Object.keys(i)[0]);){if(r=r[o],!r)return!1;i=i[o]}return!0}}e.ConfigurationChangeEvent=g;class c extends g{constructor(r,t,i,o){super({keys:r.allKeys(),overrides:[]},void 0,r,t);this.source=i,this.sourceConfig=o}}e.AllKeysConfigurationChangeEvent=c;function d(s,r){const{added:t,removed:i,updated:o}=u(r,s),l=[],a=s?.getAllOverrideIdentifiers()||[],h=r?.getAllOverrideIdentifiers()||[];if(r){const p=h.filter(R=>!a.includes(R));for(const R of p)l.push([R,r.getKeysForOverrideIdentifier(R)])}if(s){const p=a.filter(R=>!h.includes(R));for(const R of p)l.push([R,s.getKeysForOverrideIdentifier(R)])}if(r&&s){for(const p of a)if(h.includes(p)){const R=u({contents:s.getOverrideValue(void 0,p)||{},keys:s.getKeysForOverrideIdentifier(p)},{contents:r.getOverrideValue(void 0,p)||{},keys:r.getKeysForOverrideIdentifier(p)});l.push([p,[...R.added,...R.removed,...R.updated]])}}return{added:t,removed:i,updated:o,overrides:l}}function u(s,r){const t=s?r?s.keys.filter(l=>r.keys.indexOf(l)===-1):[...s.keys]:[],i=r?s?r.keys.filter(l=>s.keys.indexOf(l)===-1):[...r.keys]:[],o=[];if(s&&r){for(const l of r.keys)if(s.keys.indexOf(l)!==-1){const a=(0,E.getConfigurationValue)(r.contents,l),h=(0,E.getConfigurationValue)(s.contents,l);b.equals(a,h)||o.push(l)}}return{added:t,removed:i,updated:o}}}),define(re[195],se([0,1,18,3,2,31,15,19,68,42,8,58,40]),function(X,e,D,n,k,L,A,b,P,I,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PolicyConfiguration=e.NullPolicyConfiguration=e.DefaultConfigurationModel=e.DefaultConfiguration=void 0;class y extends k.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(v.Registry.as(I.Extensions.Configuration).onDidUpdateConfiguration(({properties:g,defaultsOverrides:c})=>this.onDidUpdateConfiguration(g,c))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(g,c){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:g})}getConfigurationDefaultOverrides(){return{}}}e.DefaultConfiguration=y;class f extends P.ConfigurationModel{constructor(g={}){const c=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),d=Object.keys(c),u=Object.create(null),s=[];for(const r in c){const t=g[r],i=t!==void 0?t:c[r].default;(0,b.addToValueTree)(u,r,i,o=>console.error(`Conflict in default settings: ${o}`))}for(const r of Object.keys(u))I.OVERRIDE_PROPERTY_REGEX.test(r)&&s.push({identifiers:(0,I.overrideIdentifiersFromKey)(r),keys:Object.keys(u[r]),contents:(0,b.toValuesTree)(u[r],t=>console.error(`Conflict in default settings file: ${t}`))});super(u,d,s)}}e.DefaultConfigurationModel=f;class S{constructor(){this.onDidChangeConfiguration=n.Event.None,this.configurationModel=new P.ConfigurationModel}async initialize(){return this.configurationModel}}e.NullPolicyConfiguration=S;let C=class extends k.Disposable{constructor(g,c,d){super();this.defaultConfiguration=g,this.policyService=c,this.logService=d,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new P.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(g=>this.onDidChangePolicies(g))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:g})=>this.update(await this.registerPolicyDefinitions(g),!0))),this._configurationModel}async registerPolicyDefinitions(g){const c={},d=[],u=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties();for(const s of g){const r=u[s];if(!r){d.push(s);continue}if(r.policy){if(r.type!=="string"&&r.type!=="number"){this.logService.warn(`Policy ${r.policy.name} has unsupported type ${r.type}`);continue}d.push(s),c[r.policy.name]={type:r.type}}}return(0,A.isEmptyObject)(c)||await this.policyService.registerPolicyDefinitions(c),d}onDidChangePolicies(g){const c=v.Registry.as(I.Extensions.Configuration).getPolicyConfigurations(),d=(0,D.coalesce)(g.map(u=>c.get(u)));this.update(d,!0)}update(g,c){const d=v.Registry.as(I.Extensions.Configuration).getConfigurationProperties(),u=[],s=this._configurationModel.isEmpty();for(const r of g){const t=d[r]?.policy?.name;if(t){const i=this.policyService.getPolicyValue(t);(s?i!==void 0:!(0,L.equals)(this._configurationModel.getValue(r),i))&&u.push([r,i])}else this._configurationModel.getValue(r)!==void 0&&u.push([r,void 0])}if(u.length){const r=this._configurationModel;this._configurationModel=new P.ConfigurationModel;for(const t of r.keys)this._configurationModel.setValue(t,r.getValue(t));for(const[t,i]of u)i===void 0?this._configurationModel.removeValue(t):this._configurationModel.setValue(t,i);c&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};C=me([G(1,w.IPolicyService),G(2,E.ILogService)],C),e.PolicyConfiguration=C}),define(re[196],se([0,1,6,3,2,17,19,68,195,58]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ConfigurationService=void 0;class E extends k.Disposable{constructor(v,y,f,S){super();this.settingsResource=v,this._onDidChangeConfiguration=this._register(new n.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new P.DefaultConfiguration),this.policyConfiguration=f instanceof I.NullPolicyService?new P.NullPolicyConfiguration:this._register(new P.PolicyConfiguration(this.defaultConfiguration,f,S)),this.userConfiguration=this._register(new b.UserSettings(this.settingsResource,void 0,L.extUriBiasedIgnorePathCase,y)),this.configuration=new b.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new b.ConfigurationModel,new b.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new D.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:C,properties:m})=>this.onDidDefaultConfigurationChange(C,m))),this._register(this.policyConfiguration.onDidChangeConfiguration(C=>this.onDidPolicyConfigurationChange(C))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[v,y,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new b.Configuration(v,y,new b.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(v,y){const f=typeof v=="string"?v:void 0,S=(0,A.isConfigurationOverrides)(v)?v:(0,A.isConfigurationOverrides)(y)?y:{};return this.configuration.getValue(f,S,void 0)}updateValue(v,y,f,S){return Promise.reject(new Error("not supported"))}inspect(v){return this.configuration.inspect(v,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const v=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(v)}onDidChangeUserConfiguration(v){const y=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(v);this.trigger(f,y,2)}onDidDefaultConfigurationChange(v,y){const f=this.configuration.toData(),S=this.configuration.compareAndUpdateDefaultConfiguration(v,y);this.trigger(S,f,7)}onDidPolicyConfigurationChange(v){const y=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(v);this.trigger(f,y,7)}trigger(v,y,f){const S=new b.ConfigurationChangeEvent(v,{data:y},this.configuration);S.source=f,S.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(S)}getTargetConfiguration(v){switch(v){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}e.ConfigurationService=E}),define(re[197],se([0,1,9,5]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,n.createDecorator)("remoteAuthorityResolverService");var k;(function(A){A.Unknown="Unknown",A.NotAvailable="NotAvailable",A.TemporarilyNotAvailable="TemporarilyNotAvailable",A.NoResolverFound="NoResolverFound"})(k=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends D.ErrorNoTelemetry{constructor(b,P=k.Unknown,I){super(b);this._message=b,this._code=P,this._detail=I,this.isHandled=P===k.NotAvailable&&I===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(b){return b instanceof L&&b._code===k.TemporarilyNotAvailable}static isNoResolverFound(b){return b instanceof L&&b._code===k.NoResolverFound}static isHandled(b){return b instanceof L&&b.isHandled}}e.RemoteAuthorityResolverError=L}),define(re[98],se([0,1,20]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function n(I){return I.scheme===D.Schemas.vscodeRemote?I.authority:void 0}e.getRemoteAuthority=n;function k(I){if(!I)return;const E=I.indexOf("+");return E<0?I:I.substr(0,E)}e.getRemoteName=k;function L(I){return`/${I.quality??"oss"}-${I.commit??"dev"}`}e.getRemoteServerRootPath=L;function A(I){const{host:E,port:w}=P(I);if(typeof w=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:E,port:w}}e.parseAuthorityWithPort=A;function b(I,E){let{host:w,port:v}=P(I);return typeof v=="undefined"&&(v=E),{host:w,port:v}}e.parseAuthorityWithOptionalPort=b;function P(I){const E=I.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(E)return{host:E[1],port:parseInt(E[2],10)};const w=I.match(/^(\[[0-9a-z:]+\])$/);if(w)return{host:w[1],port:void 0};const v=I.match(/(.*):(\d+)$/);return v?{host:v[1],port:parseInt(v[2],10)}:{host:I,port:void 0}}}),define(re[43],se([0,1,26,5,98]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=A,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var b;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(b=e.ExtensionType||(e.ExtensionType={}));var P;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(P=e.TargetPlatform||(e.TargetPlatform={}));class I{constructor(S){this.value=S,this._lower=S.toLowerCase()}static equals(S,C){if(typeof S=="undefined"||S===null)return typeof C=="undefined"||C===null;if(typeof C=="undefined"||C===null)return!1;if(typeof S=="string"||typeof C=="string"){const m=typeof S=="string"?S:S.value,g=typeof C=="string"?C:C.value;return D.equalsIgnoreCase(m,g)}return S._lower===C._lower}static toKey(S){return typeof S=="string"?S.toLowerCase():S._lower}}e.ExtensionIdentifier=I;function E(f){return w(f)}e.isApplicationScopedExtension=E;function w(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=w;function v(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=v;function y(f,S){if(S){const C=`onResolveRemoteAuthority:${(0,k.getRemoteName)(S)}`;return f.activationEvents?.indexOf(C)!==-1}return!1}e.isResolverExtension=y,e.IBuiltinExtensionsScannerService=(0,n.createDecorator)("IBuiltinExtensionsScannerService")}),define(re[32],se([0,1,26,28,43,4,7,9,36]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function I(r,t){return r.uuid&&t.uuid?r.uuid===t.uuid:r.id===t.id?!0:(0,D.compareIgnoreCase)(r.id,t.id)===0}e.areSameExtensions=I;const E=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class w{constructor(t,i,o="undefined"){this.version=i,this.targetPlatform=o,this.id=t.id}static create(t){const i=t.manifest?t.manifest.version:t.version,o=t.manifest?t.targetPlatform:t.properties.targetPlatform;return new w(t.identifier,i,o)}static parse(t){const i=E.exec(t);return i&&i[1]&&i[2]?new w({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(t){return t instanceof w?I(this,t)&&this.version===t.version&&this.targetPlatform===t.targetPlatform:!1}}e.ExtensionKey=w;const v=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function y(r){const t=v.exec(r);return t&&t[1]?[S(t[1]),t[2]]:[S(r),void 0]}e.getIdAndVersion=y;function f(r,t){return`${r}.${t}`}e.getExtensionId=f;function S(r){return r.toLocaleLowerCase()}e.adoptToGalleryExtensionId=S;function C(r,t){return S(f(r,t))}e.getGalleryExtensionId=C;function m(r,t){const i=[],o=l=>{for(const a of i)if(a.some(h=>I(t(h),t(l))))return a;return null};for(const l of r){const a=o(l);a?a.push(l):i.push([l])}return i}e.groupByExtension=m;function g(r){return{id:r.identifier.id,name:r.manifest.name,galleryId:null,publisherId:r.publisherId,publisherName:r.manifest.publisher,publisherDisplayName:r.publisherDisplayName,dependencies:r.manifest.extensionDependencies&&r.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=g;function c(r){return{id:r.identifier.id,name:r.name,galleryId:r.identifier.uuid,publisherId:r.publisherId,publisherName:r.publisher,publisherDisplayName:r.publisherDisplayName,isPreReleaseVersion:r.properties.isPreReleaseVersion,dependencies:!!(r.properties.dependencies&&r.properties.dependencies.length>0),...r.telemetryData}}e.getGalleryExtensionTelemetryData=c,e.BetterMergeId=new k.ExtensionIdentifier("pprice.better-merge");function d(r,t){const i=[],o=t.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const l=o.shift();if(l&&i.every(a=>!I(a.identifier,{id:l}))){const a=r.filter(h=>I(h.identifier,{id:l}));a.length===1&&(i.push(a[0]),o.push(...a[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=d;async function u(r,t){if(!L.isLinux)return!1;let i;try{i=(await r.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await r.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(l){t.debug("Error while getting the os-release file.",(0,b.getErrorMessage)(l))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=u;async function s(r,t){const i=await u(r,t),o=(0,n.getTargetPlatform)(i?"alpine":L.platform,P.arch);return t.debug("ComputeTargetPlatform:",o),o}e.computeTargetPlatform=s}),define(re[44],se([0,1,6,16,2,34,7,32,13,5,8]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsProfileScannerService=e.IExtensionsProfileScannerService=void 0,e.IExtensionsProfileScannerService=(0,I.createDecorator)("IExtensionsProfileScannerService");let w=class extends k.Disposable{constructor(y,f){super();this.fileService=y,this.logService=f,this.resourcesAccessQueueMap=new L.ResourceMap}scanProfileExtensions(y){return this.withProfileExtensions(y)}addExtensionsToProfile(y,f){return this.withProfileExtensions(f,S=>(S=S.filter(C=>y.some(([m])=>!(0,b.areSameExtensions)(C.identifier,m.identifier))),S.push(...y.map(([C,m])=>({identifier:C.identifier,version:C.manifest.version,location:C.location,metadata:m}))),S))}removeExtensionFromProfile(y,f){return this.withProfileExtensions(f,S=>S.filter(C=>!(0,b.areSameExtensions)(C.identifier,y)))}async withProfileExtensions(y,f){return this.getResourceAccessQueue(y).queue(async()=>{let S=[];try{const C=await this.fileService.readFile(y),m=JSON.parse(C.value.toString());for(const g of m){if(!g.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",g);continue}if(!g.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",g);continue}if(!g.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",g);continue}S.push({identifier:g.identifier,location:A.URI.revive(g.location),version:g.version,metadata:g.metadata})}}catch(C){C.fileOperationResult!==1&&this.logService.error(C)}if(f){S=f(S);const C=S.map(m=>({identifier:m.identifier,version:m.version,location:m.location.toJSON(),metadata:m.metadata}));await this.fileService.writeFile(y,n.VSBuffer.fromString(JSON.stringify(C)))}return S})}getResourceAccessQueue(y){let f=this.resourcesAccessQueueMap.get(y);return f||(f=new D.Queue,this.resourcesAccessQueueMap.set(y,f)),f}};w=me([G(0,P.IFileService),G(1,E.ILogService)],w),e.ExtensionsProfileScannerService=w}),define(re[198],se([0,1,21,32]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.migrateUnsupportedExtensions=void 0;async function k(L,A,b,P,I){try{const E=await L.getExtensionsControlManifest();if(!E.deprecated)return;const w=await L.getInstalled(1);for(const[v,y]of Object.entries(E.deprecated)){if(!y?.extension)continue;const{id:f,autoMigrate:S,preRelease:C}=y.extension;if(!S)continue;const m=w.find(c=>(0,n.areSameExtensions)(c.identifier,{id:v}));if(!m)continue;const g=(await A.getExtensions([{id:f,preRelease:C}],{targetPlatform:await L.getTargetPlatform(),compatible:!0},D.CancellationToken.None))[0];if(!g){I.info(`Skipping migrating '${m.identifier.id}' extension because, the comaptible target '${f}' extension is not found`);continue}try{I.info(`Migrating '${m.identifier.id}' extension to '${f}' extension...`);const c=!P.getDisabledExtensions().some(u=>(0,n.areSameExtensions)(u,m.identifier));await L.uninstall(m),I.info(`Uninstalled the unsupported extension '${m.identifier.id}'`);let d=w.find(u=>(0,n.areSameExtensions)(u.identifier,{id:f}));(!d||!d.isPreReleaseVersion&&c)&&(d=await L.installFromGallery(g,{installPreReleaseVersion:!0,isMachineScoped:m.isMachineScoped,operation:4}),I.info(`Installed the pre-release extension '${d.identifier.id}'`),c||(await P.disableExtension(d.identifier),I.info(`Disabled the pre-release extension '${d.identifier.id}' because the unsupported extension '${m.identifier.id}' is disabled`)),S.storage&&(b.addToMigrationList((0,n.getExtensionId)(m.manifest.publisher,m.manifest.name),(0,n.getExtensionId)(d.manifest.publisher,d.manifest.name)),I.info("Added pre-release extension to the storage migration list"))),I.info(`Migrated '${m.identifier.id}' extension to '${f}' extension.`)}catch(c){I.error(c)}}}catch(E){I.error(E)}}e.migrateUnsupportedExtensions=k}),define(re[199],se([0,1,6,9,2,4,17,55,7,30,27,14,28,32,13,8]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsDownloader=void 0;let C=class extends k.Disposable{constructor(g,c,d,u){super();this.fileService=c,this.extensionGalleryService=d,this.logService=u,this.extensionsDownloadDir=P.URI.file(g.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(g,c){await this.cleanUpPromise;const d=this.getName(g),u=(0,A.joinPath)(this.extensionsDownloadDir,d);if(!await this.fileService.exists(u)){const s=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,I.generateUuid)()}`);await this.fileService.exists(s)||await this.extensionGalleryService.download(g,s,c);try{await this.rename(s,u,Date.now()+2*60*1e3)}catch(r){try{await this.fileService.del(s)}catch{}if(r.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",g.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,n.getErrorMessage)(r)}. Deleted the vsix from downloaded location`,s.path),r}}return u}async delete(g){await this.cleanUpPromise,await this.fileService.del(g)}async rename(g,c,d){try{await E.Promises.rename(g.fsPath,c.fsPath)}catch(u){if(L.isWindows&&u&&u.code==="EPERM"&&Date.now()<d)return this.logService.info(`Failed renaming ${g} to ${c} with 'EPERM' error. Trying again...`),this.rename(g,c,d);throw u}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const g=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(g.children){const c=[],d=[];for(const r of g.children){const t=y.ExtensionKey.parse(r.name);t&&d.push([t,r])}const u=(0,y.groupByExtension)(d,([r])=>r),s=[];for(const r of u)r.sort((t,i)=>b.rcompare(t[0].version,i[0].version)),c.push(...r.slice(1).map(t=>t[1].resource)),s.push(r[0][1]);s.sort((r,t)=>r.mtime-t.mtime),c.push(...s.slice(0,Math.max(0,s.length-this.cache)).map(r=>r.resource)),await D.Promises.settled(c.map(r=>(this.logService.trace("Deleting vsix from cache",r.path),this.fileService.del(r))))}}catch(g){this.logService.error(g)}}getName(g){return this.cache?y.ExtensionKey.create(g).toString().toLowerCase():(0,I.generateUuid)()}};C=me([G(0,w.INativeEnvironmentService),G(1,f.IFileService),G(2,v.IExtensionGalleryService),G(3,S.ILogService)],C),e.ExtensionsDownloader=C}),define(re[200],se([0,1,2,10,27,43]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsManifestCache=void 0;class A extends D.Disposable{constructor(P,I){super();this.environmentService=P,this.extensionsManifestCache=(0,n.join)(this.environmentService.userDataPath,L.MANIFEST_CACHE_FOLDER,L.USER_MANIFEST_CACHE_FILE),this._register(I.onDidInstallExtensions(E=>this.onDidInstallExtensions(E))),this._register(I.onDidUninstallExtension(E=>this.onDidUnInstallExtension(E)))}onDidInstallExtensions(P){P.some(I=>!!I.local)&&this.invalidate()}onDidUnInstallExtension(P){P.error||this.invalidate()}invalidate(){k.Promises.rm(this.extensionsManifestCache,k.RimRafMode.MOVE).then(()=>{},()=>{})}}e.ExtensionsManifestCache=A}),define(re[201],se([0,1,175,18,6,2,20,10,27,14,28,32,8,66]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLanguagePackService=void 0;let f=class extends y.LanguagePackBaseService{constructor(g,c,d,u){super(d);this.extensionManagementService=g,this.logService=u,this.cache=this._register(new S(c,u)),this.extensionManagementService.registerParticipant({postInstall:async s=>this.postInstallExtension(s),postUninstall:async s=>this.postUninstallExtension(s)})}async getInstalledLanguages(){const g=await this.cache.getLanguagePacks(),c=Object.keys(g).map(d=>{const u=g[d];return{...this.createQuickPickItem(d,u.label),extensionId:u.extensions[0].extensionIdentifier.id}});return c.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),c.sort((d,u)=>d.label.localeCompare(u.label)),c}async postInstallExtension(g){g&&g.manifest&&g.manifest.contributes&&g.manifest.contributes.localizations&&g.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",g.identifier.id),await this.update())}async postUninstallExtension(g){const c=await this.cache.getLanguagePacks();Object.keys(c).some(d=>c[d]&&c[d].extensions.some(u=>(0,w.areSameExtensions)(u.extensionIdentifier,g.identifier)))&&(this.logService.info("Removing language packs from the extension",g.identifier.id),await this.update())}async update(){const[g,c]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),d=await this.cache.update(c);return!(0,n.equals)(Object.keys(g),Object.keys(d))}};f=me([G(0,E.IExtensionManagementService),G(1,I.INativeEnvironmentService),G(2,E.IExtensionGalleryService),G(3,v.ILogService)],f),e.NativeLanguagePackService=f;let S=class extends L.Disposable{constructor(g,c){super();this.logService=c,this.languagePacks={},this.languagePacksFilePath=(0,b.join)(g.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new k.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(g){return this.withLanguagePacks(c=>{Object.keys(c).forEach(d=>delete c[d]),this.createLanguagePacksFromExtensions(c,...g)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(g,...c){for(const d of c)d&&d.manifest&&d.manifest.contributes&&d.manifest.contributes.localizations&&d.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(g,d);Object.keys(g).forEach(d=>this.updateHash(g[d]))}createLanguagePacksFromExtension(g,c){const d=c.identifier,u=c.manifest.contributes&&c.manifest.contributes.localizations?c.manifest.contributes.localizations:[];for(const s of u)if(c.location.scheme===A.Schemas.file&&C(s)){let r=g[s.languageId];r||(r={hash:"",extensions:[],translations:{},label:s.localizedLanguageName??s.languageName},g[s.languageId]=r);const t=r.extensions.filter(i=>(0,w.areSameExtensions)(i.extensionIdentifier,d))[0];t?t.version=c.manifest.version:r.extensions.push({extensionIdentifier:d,version:c.manifest.version});for(const i of s.translations)r.translations[i.id]=(0,b.join)(c.location.fsPath,i.path)}}updateHash(g){if(g){const c=(0,D.createHash)("md5");for(const d of g.extensions)c.update(d.extensionIdentifier.uuid||d.extensionIdentifier.id).update(d.version);g.hash=c.digest("hex")}}withLanguagePacks(g=()=>null){return this.languagePacksFileLimiter.queue(()=>{let c=null;return P.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,d=>d.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(d)).then(d=>{try{return JSON.parse(d)}catch{return{}}}).then(d=>(c=g(d),d)).then(d=>{for(const s of Object.keys(d))d[s]||delete d[s];this.languagePacks=d,this.initializedCache=!0;const u=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",u),P.Promises.writeFile(this.languagePacksFilePath,u)}).then(()=>c,d=>this.logService.error(d))})}};S=me([G(0,I.INativeEnvironmentService),G(1,v.ILogService)],S);function C(m){if(typeof m.languageId!="string"||!Array.isArray(m.translations)||m.translations.length===0)return!1;for(const g of m.translations)if(typeof g.id!="string"||typeof g.path!="string")return!1;return!(m.languageName&&typeof m.languageName!="string"||m.localizedLanguageName&&typeof m.localizedLanguageName!="string")}}),define(re[202],se([0,1,6,16,21,9,3,2,30,84,197,98]),function(X,e,D,n,k,L,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostPersistentConnection=e.ManagementPersistentConnection=e.PersistentConnection=e.ReconnectionPermanentFailureEvent=e.ConnectionGainEvent=e.ReconnectionRunningEvent=e.ReconnectionWaitEvent=e.ConnectionLostEvent=e.PersistentConnectionEventType=e.connectRemoteAgentTunnel=e.connectRemoteAgentExtensionHost=e.connectRemoteAgentManagement=e.ConnectionType=void 0;const v=30*1e3;var y;(function(z){z[z.Management=1]="Management",z[z.ExtensionHost=2]="ExtensionHost",z[z.Tunnel=3]="Tunnel"})(y=e.ConnectionType||(e.ConnectionType={}));function f(z){switch(z){case 1:return"Management";case 2:return"ExtensionHost";case 3:return"Tunnel"}}function S(z){const x=new k.CancellationTokenSource;return setTimeout(()=>x.cancel(),z),x.token}function C(z,x){if(z.isCancellationRequested||x.isCancellationRequested)return k.CancellationToken.Cancelled;const _=new k.CancellationTokenSource;return z.onCancellationRequested(()=>_.cancel()),x.onCancellationRequested(()=>_.cancel()),_.token}class m{constructor(x){this._state="pending",this._disposables=new b.DisposableStore,this.promise=new Promise((_,U)=>{this._resolvePromise=_,this._rejectPromise=U}),x.isCancellationRequested?this._timeout():this._disposables.add(x.onCancellationRequested(()=>this._timeout()))}get didTimeout(){return this._state==="timedout"}registerDisposable(x){this._state==="pending"?this._disposables.add(x):x.dispose()}_timeout(){this._state==="pending"&&(this._disposables.dispose(),this._state="timedout",this._rejectPromise(this._createTimeoutError()))}_createTimeoutError(){const x=new Error("Time limit reached");return x.code="ETIMEDOUT",x.syscall="connect",x}resolve(x){this._state==="pending"&&(this._disposables.dispose(),this._state="resolved",this._resolvePromise(x))}reject(x){this._state==="pending"&&(this._disposables.dispose(),this._state="rejected",this._rejectPromise(x))}}function g(z,x){const _=new m(x);return _.registerDisposable(z.onControlMessage(U=>{const q=JSON.parse(U.toString()),j=H(q);j?_.reject(j):_.resolve(q)})),_.promise}function c(z,x,_,U,q,j,Z,oe){const Q=new m(oe);return x.connect(_,U,q,j,Z,(te,ne)=>{Q.didTimeout?(te&&z.error(te),ne?.dispose()):te||!ne?Q.reject(te):Q.resolve(ne)}),Q.promise}function d(z,x){const _=new m(x);return z.then(U=>{_.didTimeout||_.resolve(U)},U=>{_.didTimeout||_.reject(U)}),_.promise}async function u(z,x,_,U){const q=ie(z,x);z.logService.trace(`${q} 1/6. invoking socketFactory.connect().`);let j;try{j=await c(z.logService,z.socketFactory,z.host,z.port,(0,w.getRemoteServerRootPath)(z),`reconnectionToken=${z.reconnectionToken}&reconnection=${z.reconnectionProtocol?"true":"false"}`,`renderer-${f(x)}-${z.reconnectionToken}`,U)}catch(ne){throw z.logService.error(`${q} socketFactory.connect() failed or timed out. Error:`),z.logService.error(ne),ne}z.logService.trace(`${q} 2/6. socketFactory.connect() was successful.`);let Z,oe;z.reconnectionProtocol?(z.reconnectionProtocol.beginAcceptReconnection(j,null),Z=z.reconnectionProtocol,oe=!1):(Z=new I.PersistentProtocol(j,null),oe=!0),z.logService.trace(`${q} 3/6. sending AuthRequest control message.`);const Q=await d(z.signService.createNewMessage((0,P.generateUuid)()),U),te={type:"auth",auth:z.connectionToken||"00000000000000000000",data:Q.data};Z.sendControl(n.VSBuffer.fromString(JSON.stringify(te)));try{const ne=await g(Z,C(U,S(1e4)));if(ne.type!=="sign"||typeof ne.data!="string"){const we=new Error("Unexpected handshake message");throw we.code="VSCODE_CONNECTION_ERROR",we}if(z.logService.trace(`${q} 4/6. received SignRequest control message.`),!await d(z.signService.validate(Q,ne.signedData),U)){const we=new Error("Refused to connect to unsupported server");throw we.code="VSCODE_CONNECTION_ERROR",we}const he=await d(z.signService.sign(ne.data),U),pe={type:"connectionType",commit:z.commit,signedData:he,desiredConnectionType:x};return _&&(pe.args=_),z.logService.trace(`${q} 5/6. sending ConnectionTypeRequest control message.`),Z.sendControl(n.VSBuffer.fromString(JSON.stringify(pe))),{protocol:Z,ownsProtocol:oe}}catch(ne){throw ne&&ne.code==="ETIMEDOUT"&&(z.logService.error(`${q} the handshake timed out. Error:`),z.logService.error(ne)),ne&&ne.code==="VSCODE_CONNECTION_ERROR"&&(z.logService.error(`${q} received error control message when negotiating connection. Error:`),z.logService.error(ne)),oe&&J(Z),ne}}async function s(z,x,_,U){const q=Date.now(),j=ie(z,x),{protocol:Z,ownsProtocol:oe}=await u(z,x,_,U),Q=new m(U);return Q.registerDisposable(Z.onControlMessage(te=>{const ne=JSON.parse(te.toString()),ue=H(ne);ue?(z.logService.error(`${j} received error control message when negotiating connection. Error:`),z.logService.error(ue),oe&&J(Z),Q.reject(ue)):(z.reconnectionProtocol?.endAcceptReconnection(),z.logService.trace(`${j} 6/6. handshake finished, connection is up and running after ${ce(q)}!`),Q.resolve({protocol:Z,firstMessage:ne}))})),Q.promise}async function r(z,x){const{protocol:_}=await s(z,1,void 0,x);return{protocol:_}}async function t(z,x,_){const{protocol:U,firstMessage:q}=await s(z,2,x,_),j=q&&q.debugPort;return{protocol:U,debugPort:j}}async function i(z,x,_){const U=Date.now(),q=ie(z,3),{protocol:j}=await u(z,3,x,_);return z.logService.trace(`${q} 6/6. handshake finished, connection is up and running after ${ce(U)}!`),j}async function o(z,x,_){const{host:U,port:q,connectionToken:j}=await z.addressProvider.getAddress();return{commit:z.commit,quality:z.quality,host:U,port:q,connectionToken:j,reconnectionToken:x,reconnectionProtocol:_,socketFactory:z.socketFactory,signService:z.signService,logService:z.logService}}async function l(z,x,_){return h(z,async U=>{const{protocol:q}=await r(U,k.CancellationToken.None);return new Y(z,x,_,U.reconnectionToken,q)})}e.connectRemoteAgentManagement=l;async function a(z,x){return h(z,async _=>{const{protocol:U,debugPort:q}=await t(_,x,k.CancellationToken.None);return new $(z,x,_.reconnectionToken,U,q)})}e.connectRemoteAgentExtensionHost=a;async function h(z,x){const _=5;for(let U=1;;U++)try{const q=(0,P.generateUuid)(),j=await o(z,q,null);return await x(j)}catch(q){if(U<_)z.logService.error(`[remote-connection][attempt ${U}] An error occurred in initial connection! Will retry... Error:`),z.logService.error(q);else throw z.logService.error(`[remote-connection][attempt ${U}]  An error occurred in initial connection! It will be treated as a permanent error. Error:`),z.logService.error(q),V.triggerPermanentFailure(0,0,E.RemoteAuthorityResolverError.isHandled(q)),q}}async function p(z,x,_){const U=await o(z,(0,P.generateUuid)(),null);return await i(U,{host:x,port:_},k.CancellationToken.None)}e.connectRemoteAgentTunnel=p;function R(z){return(0,D.createCancelablePromise)(x=>new Promise((_,U)=>{const q=setTimeout(_,z*1e3);x.onCancellationRequested(()=>{clearTimeout(q),_()})}))}var M;(function(z){z[z.ConnectionLost=0]="ConnectionLost",z[z.ReconnectionWait=1]="ReconnectionWait",z[z.ReconnectionRunning=2]="ReconnectionRunning",z[z.ReconnectionPermanentFailure=3]="ReconnectionPermanentFailure",z[z.ConnectionGain=4]="ConnectionGain"})(M=e.PersistentConnectionEventType||(e.PersistentConnectionEventType={}));class O{constructor(x,_){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.type=0}}e.ConnectionLostEvent=O;class F{constructor(x,_,U,q){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.durationSeconds=U,this.cancellableTimer=q,this.type=1}skipWait(){this.cancellableTimer.cancel()}}e.ReconnectionWaitEvent=F;class T{constructor(x,_,U){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=U,this.type=2}}e.ReconnectionRunningEvent=T;class N{constructor(x,_,U){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=U,this.type=4}}e.ConnectionGainEvent=N;class W{constructor(x,_,U,q){this.reconnectionToken=x,this.millisSinceLastIncomingData=_,this.attempt=U,this.handled=q,this.type=3}}e.ReconnectionPermanentFailureEvent=W;class V extends b.Disposable{constructor(x,_,U,q,j){super();this._connectionType=x,this._options=_,this.reconnectionToken=U,this.protocol=q,this._reconnectionFailureIsFatal=j,this._onDidStateChange=this._register(new A.Emitter),this.onDidStateChange=this._onDidStateChange.event,this._permanentFailure=!1,this._isReconnecting=!1,this._onDidStateChange.fire(new N(this.reconnectionToken,0,0)),this._register(q.onSocketClose(Z=>{const oe=K(this._connectionType,this.reconnectionToken,!0);Z?Z.type===0?(this._options.logService.info(`${oe} received socket close event (hadError: ${Z.hadError}).`),Z.error&&this._options.logService.error(Z.error)):(this._options.logService.info(`${oe} received socket close event (wasClean: ${Z.wasClean}, code: ${Z.code}, reason: ${Z.reason}).`),Z.event&&this._options.logService.error(Z.event)):this._options.logService.info(`${oe} received socket close event.`),this._beginReconnecting()})),this._register(q.onSocketTimeout(Z=>{const oe=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${oe} received socket timeout event (unacknowledgedMsgCount: ${Z.unacknowledgedMsgCount}, timeSinceOldestUnacknowledgedMsg: ${Z.timeSinceOldestUnacknowledgedMsg}, timeSinceLastReceivedSomeData: ${Z.timeSinceLastReceivedSomeData}).`),this._beginReconnecting()})),V._instances.push(this),this._register((0,b.toDisposable)(()=>{const Z=V._instances.indexOf(this);Z>=0&&V._instances.splice(Z,1)})),this._isPermanentFailure&&this._gotoPermanentFailure(V._permanentFailureMillisSinceLastIncomingData,V._permanentFailureAttempt,V._permanentFailureHandled)}static triggerPermanentFailure(x,_,U){this._permanentFailure=!0,this._permanentFailureMillisSinceLastIncomingData=x,this._permanentFailureAttempt=_,this._permanentFailureHandled=U,this._instances.forEach(q=>q._gotoPermanentFailure(this._permanentFailureMillisSinceLastIncomingData,this._permanentFailureAttempt,this._permanentFailureHandled))}static debugTriggerReconnection(){this._instances.forEach(x=>x._beginReconnecting())}static debugPauseSocketWriting(){this._instances.forEach(x=>x._pauseSocketWriting())}get _isPermanentFailure(){return this._permanentFailure||V._permanentFailure}async _beginReconnecting(){if(!this._isReconnecting)try{this._isReconnecting=!0,await this._runReconnectingLoop()}finally{this._isReconnecting=!1}}async _runReconnectingLoop(){if(this._isPermanentFailure)return;const x=K(this._connectionType,this.reconnectionToken,!0);this._options.logService.info(`${x} starting reconnecting loop. You can get more information with the trace log level.`),this._onDidStateChange.fire(new O(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData()));const _=[0,5,5,10,10,10,10,10,30];let U=-1;do{U++;const q=U<_.length?_[U]:_[_.length-1];try{if(q>0){const Z=R(q);this._onDidStateChange.fire(new F(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),q,Z)),this._options.logService.info(`${x} waiting for ${q} seconds before reconnecting...`);try{await Z}catch{}}if(this._isPermanentFailure){this._options.logService.error(`${x} permanent failure occurred while running the reconnecting loop.`);break}this._onDidStateChange.fire(new T(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1)),this._options.logService.info(`${x} resolving connection...`);const j=await o(this._options,this.reconnectionToken,this.protocol);this._options.logService.info(`${x} connecting to ${j.host}:${j.port}...`),await this._reconnect(j,S(v)),this._options.logService.info(`${x} reconnected!`),this._onDidStateChange.fire(new N(this.reconnectionToken,this.protocol.getMillisSinceLastIncomingData(),U+1));break}catch(j){if(j.code==="VSCODE_CONNECTION_ERROR"){this._options.logService.error(`${x} A permanent error occurred in the reconnecting loop! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(U>360){this._options.logService.error(`${x} An error occurred while reconnecting, but it will be treated as a permanent error because the reconnection grace time has expired! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}if(E.RemoteAuthorityResolverError.isTemporarilyNotAvailable(j)){this._options.logService.info(`${x} A temporarily not available error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((j.code==="ETIMEDOUT"||j.code==="ENETUNREACH"||j.code==="ECONNREFUSED"||j.code==="ECONNRESET")&&j.syscall==="connect"){this._options.logService.info(`${x} A network error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if((0,L.isCancellationError)(j)){this._options.logService.info(`${x} A promise cancelation error occurred while trying to reconnect, will try again...`),this._options.logService.trace(j);continue}if(j instanceof E.RemoteAuthorityResolverError){this._options.logService.error(`${x} A RemoteAuthorityResolverError occurred while trying to reconnect. Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,E.RemoteAuthorityResolverError.isHandled(j));break}this._options.logService.error(`${x} An unknown error occurred while trying to reconnect, since this is an unknown case, it will be treated as a permanent error! Will give up now! Error:`),this._options.logService.error(j),this._onReconnectionPermanentFailure(this.protocol.getMillisSinceLastIncomingData(),U+1,!1);break}}while(!this._isPermanentFailure)}_onReconnectionPermanentFailure(x,_,U){this._reconnectionFailureIsFatal?V.triggerPermanentFailure(x,_,U):this._gotoPermanentFailure(x,_,U)}_gotoPermanentFailure(x,_,U){this._onDidStateChange.fire(new W(this.reconnectionToken,x,_,U)),J(this.protocol)}_pauseSocketWriting(){this.protocol.pauseSocketWriting()}}e.PersistentConnection=V,V._permanentFailure=!1,V._permanentFailureMillisSinceLastIncomingData=0,V._permanentFailureAttempt=0,V._permanentFailureHandled=!1,V._instances=[];class Y extends V{constructor(x,_,U,q,j){super(1,x,q,j,!0);this.client=this._register(new I.Client(j,{remoteAuthority:_,clientId:U},x.ipcLogger))}async _reconnect(x,_){await r(x,_)}}e.ManagementPersistentConnection=Y;class $ extends V{constructor(x,_,U,q,j){super(2,x,U,q,!1);this._startArguments=_,this.debugPort=j}async _reconnect(x,_){await t(x,this._startArguments,_)}}e.ExtensionHostPersistentConnection=$;function J(z){try{z.acceptDisconnect();const x=z.getSocket();z.dispose(),x.dispose()}catch(x){(0,L.onUnexpectedError)(x)}}function H(z){if(z&&z.type==="error"){const x=new Error(`Connection error: ${z.reason}`);return x.code="VSCODE_CONNECTION_ERROR",x}return null}function B(z,x){for(;z.length<x;)z+=" ";return z}function K(z,x,_){return`[remote-connection][${B(f(z),13)}][${x.substr(0,5)}\u2026][${_?"reconnect":"initial"}]`}function ie(z,x){return`${K(x,z.reconnectionToken,!!z.reconnectionProtocol)}[${z.host}:${z.port}]`}function ce(z){return`${Date.now()-z} ms`}}),define(re[203],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessTunnelChannelName=e.ISharedProcessTunnelService=void 0,e.ISharedProcessTunnelService=(0,D.createDecorator)("sharedProcessTunnelService"),e.ipcSharedProcessTunnelChannelName="sharedProcessTunnel"}),define(re[204],se([0,1,76,134]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.nodeSocketFactory=void 0,e.nodeSocketFactory=new class{connect(k,L,A,b,P,I){const E=v=>I(v,void 0),w=D.createConnection({host:k,port:L},()=>{w.removeListener("error",E);const v=Buffer.alloc(16);for(let C=0;C<16;C++)v[C]=Math.round(Math.random()*256);const y=v.toString("base64"),f=[`GET ws://${/:/.test(k)?`[${k}]`:k}:${L}${A}?${b}&skipWebSocketFrames=true HTTP/1.1`,"Connection: Upgrade","Upgrade: websocket",`Sec-WebSocket-Key: ${y}`];w.write(f.join(`\r
`)+`\r
\r
`);const S=C=>{C.toString().indexOf(`\r
\r
`)>=0&&(w.off("data",S),I(void 0,new n.NodeSocket(w,P)))};w.on("data",S)});w.setNoDelay(!0),w.once("error",E)}}}),define(re[205],se([0,1,117,19,8]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestService=void 0;let L=class{constructor(b,P){this.configurationService=b,this.logService=P}async request(b,P){this.logService.trace("RequestService#request (browser) - begin",b.url),b.proxyAuthorization||(b.proxyAuthorization=this.configurationService.getValue("http.proxyAuthorization"));try{const I=await(0,D.request)(b,P);return this.logService.trace("RequestService#request (browser) - success",b.url),I}catch(I){throw this.logService.error("RequestService#request (browser) - error",b.url,I),I}}async resolveProxy(b){}};L=me([G(0,n.IConfigurationService),G(1,k.ILogService)],L),e.RequestService=L}),define(re[45],se([0,1,16,151,42,5,40]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.updateProxyConfigurationsScope=e.asJson=e.asTextOrError=e.asText=e.isSuccess=e.IRequestService=void 0,e.IRequestService=(0,L.createDecorator)("requestService");function b(S){return S.res.statusCode&&S.res.statusCode>=200&&S.res.statusCode<300||S.res.statusCode===1223}e.isSuccess=b;function P(S){return S.res.statusCode===204}async function I(S){return P(S)?null:(await(0,D.streamToBuffer)(S.stream)).toString()}e.asText=I;async function E(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);return I(S)}e.asTextOrError=E;async function w(S){if(!b(S))throw new Error("Server returned "+S.res.statusCode);if(P(S))return null;const m=(await(0,D.streamToBuffer)(S.stream)).toString();try{return JSON.parse(m)}catch(g){throw g.message+=`:
`+m,g}}e.asJson=w;function v(S){f(S)}e.updateProxyConfigurationsScope=v;let y;function f(S){const C=A.Registry.as(k.Extensions.Configuration),m=y;y={id:"http",order:15,title:(0,n.localize)(0,null),type:"object",scope:S,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,n.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,n.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,n.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,n.localize)(4,null),(0,n.localize)(5,null),(0,n.localize)(6,null),(0,n.localize)(7,null)],default:"override",description:(0,n.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,n.localize)(9,null),restricted:!0}}},C.updateConfigurations({add:[y],remove:m?[m]:[]})}f(2)}),define(re[206],se([0,1,21,20,13,45]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DownloadService=void 0;let A=class{constructor(P,I){this.requestService=P,this.fileService=I}async download(P,I,E=D.CancellationToken.None){if(P.scheme===n.Schemas.file||P.scheme===n.Schemas.vscodeRemote){await this.fileService.copy(P,I);return}const w={type:"GET",url:P.toString(!0)},v=await this.requestService.request(w,E);if(v.res.statusCode===200)await this.fileService.writeFile(I,v.stream);else{const y=await(0,L.asTextOrError)(v);throw new Error(`Expected 200, got back ${v.res.statusCode} instead.

${y}`)}}};A=me([G(0,L.IRequestService),G(1,k.IFileService)],A),e.DownloadService=A}),define(re[207],se([0,1,18,21,2,17,168,13,8,24,45]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;let w=class extends k.Disposable{constructor(y,f,S,C){super();this.fileService=y,this.productService=f,this.requestService=S,this.logService=C,this.allConfigBasedTips=new Map,this.productService.configBasedExtensionTips&&Object.entries(this.productService.configBasedExtensionTips).forEach(([,m])=>this.allConfigBasedTips.set(m.configPath,m))}getConfigBasedTips(y){return this.getValidConfigBasedTips(y)}getAllWorkspacesTips(){return this.fetchWorkspacesTips()}async getImportantExecutableBasedTips(){return[]}async getOtherExecutableBasedTips(){return[]}async getValidConfigBasedTips(y){const f=[];for(const[S,C]of this.allConfigBasedTips)if(!(C.configScheme&&C.configScheme!==y.scheme))try{const m=await this.fileService.readFile((0,L.joinPath)(y,S)),g=new Map;Object.entries(C.recommendations).forEach(([d,u])=>{if((0,D.isNonEmptyArray)(u.remotes))for(const s of u.remotes)g.set(s,{extensionId:d,extensionName:u.name,configName:C.configName,important:!!u.important,isExtensionPack:!!u.isExtensionPack,whenNotInstalled:u.whenNotInstalled});else f.push({extensionId:d,extensionName:u.name,configName:C.configName,important:!!u.important,isExtensionPack:!!u.isExtensionPack,whenNotInstalled:u.whenNotInstalled})});const c=(0,A.getDomainsOfRemotes)(m.value.toString(),[...g.keys()]);for(const d of c){const u=g.get(d);u&&f.push(u)}}catch{}return f}async fetchWorkspacesTips(){if(!this.productService.extensionsGallery?.recommendationsUrl)return[];try{const y=await this.requestService.request({type:"GET",url:this.productService.extensionsGallery?.recommendationsUrl},n.CancellationToken.None);if(y.res.statusCode!==200)return[];const f=await(0,E.asJson)(y);return f?f.workspaceRecommendations||[]:[]}catch(y){return this.logService.error(y),[]}}};w=me([G(0,b.IFileService),G(1,I.IProductService),G(2,E.IRequestService),G(3,P.ILogService)],w),e.ExtensionTipsService=w}),define(re[208],se([0,1,16,21]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestChannelClient=e.RequestChannel=void 0;class k{constructor(b){this.service=b}listen(b,P){throw new Error("Invalid listen")}call(b,P,I,E=n.CancellationToken.None){switch(P){case"request":return this.service.request(I[0],E).then(async({res:w,stream:v})=>{const y=await(0,D.streamToBuffer)(v);return[{statusCode:w.statusCode,headers:w.headers},y]});case"resolveProxy":return this.service.resolveProxy(I[0])}throw new Error("Invalid call")}}e.RequestChannel=k;class L{constructor(b){this.channel=b}async request(b,P){const[I,E]=await this.channel.call("request",[b],P);return{res:I,stream:(0,D.bufferToStream)(E)}}async resolveProxy(b){return this.channel.call("resolveProxy",[b])}}e.RequestChannelClient=L}),define(re[209],se([0,1,205,208]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessRequestService=void 0;class k{constructor(A,b,P){this.configurationService=b,this.logService=P,this.browserRequestService=new D.RequestService(b,P),this.mainRequestService=new n.RequestChannelClient(A.getChannel("request"))}request(A,b){return this.getRequestService().request(A,b)}async resolveProxy(A){return this.getRequestService().resolveProxy(A)}getRequestService(){return this.configurationService.getValue("developer.sharedProcess.redirectRequestsToMain")===!0?(this.logService.trace("Using main request service"),this.mainRequestService):(this.logService.trace("Using browser request service"),this.browserRequestService)}}e.SharedProcessRequestService=k}),define(re[99],se([0,1,62,5]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ipcSharedProcessWorkerChannelName=e.ISharedProcessWorkerService=e.hash=void 0;function k(L){return(0,D.hash)({moduleId:L.process.moduleId,windowId:L.reply.windowId})}e.hash=k,e.ISharedProcessWorkerService=(0,n.createDecorator)("sharedProcessWorkerService"),e.ipcSharedProcessWorkerChannelName="sharedProcessWorker"}),define(re[210],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerMessages=void 0;var D;(function(n){n.Spawn="vscode:shared-process->shared-process-worker=spawn",n.Terminate="vscode:shared-process->shared-process-worker=terminate",n.SelfTerminated="vscode:shared-process-worker->shared-process=selfTerminated",n.Ready="vscode:shared-process-worker->shared-process=ready",n.Ack="vscode:shared-process-worker->shared-process=ack",n.Trace="vscode:shared-process-worker->shared-process=trace",n.Info="vscode:shared-process-worker->shared-process=info",n.Warn="vscode:shared-process-worker->shared-process=warn",n.Error="vscode:shared-process-worker->shared-process=error"})(D=e.SharedProcessWorkerMessages||(e.SharedProcessWorkerMessages={}))}),define(re[211],se([0,1,85,6,21,3,2,20,30,8,99,210]),function(X,e,D,n,k,L,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessWorkerService=void 0;let v=class{constructor(S){this.logService=S,this.workers=new Map,this.processeDisposables=new Map,this.processResolvers=new Map}async createWorker(S){const C=`window: ${S.reply.windowId}, moduleId: ${S.process.moduleId}`;this.logService.trace(`SharedProcess: createWorker (${C})`);const m=(0,E.hash)(S);this.processeDisposables.has(m)&&(this.logService.warn(`SharedProcess: createWorker found an existing worker that will be terminated (${C})`),this.doDisposeWorker(S));const g=new k.CancellationTokenSource;let c,d,u;this.processeDisposables.set(m,i=>{g.dispose(!0),c?.terminate(S,k.CancellationToken.None),d?.close(),u?.close(),this.processeDisposables.delete(m);const o=this.processResolvers.get(m);o&&(this.processResolvers.delete(m),o({reason:i}))}),c=await this.getOrCreateWebWorker(S);const s=new Promise(i=>{this.processResolvers.set(m,i)});if(g.token.isCancellationRequested)return s;const{port1:r,port2:t}=new MessageChannel;return d=r,u=t,await c.spawn(S,u,g.token),g.token.isCancellationRequested||(this.logService.trace(`SharedProcess: createWorker sending message port back to window (${C})`),D.ipcRenderer.postMessage("vscode:relaySharedProcessWorkerMessageChannel",S,[d])),s}getOrCreateWebWorker(S){let C=this.workers.get(S.process.moduleId);if(!C){this.logService.trace(`SharedProcess: creating new web worker (${S.process.moduleId})`);const m=new y(S.process.type,this.logService);C=m.init(),m.onDidProcessSelfTerminate(({configuration:g,reason:c})=>{this.doDisposeWorker(g,c)}),this.workers.set(S.process.moduleId,C)}return C}async disposeWorker(S){return this.doDisposeWorker(S)}doDisposeWorker(S,C){const m=this.processeDisposables.get((0,E.hash)(S));m&&(this.logService.trace(`SharedProcess: disposeWorker (window: ${S.reply.windowId}, moduleId: ${S.process.moduleId})`),m(C))}};v=me([G(0,I.ILogService)],v),e.SharedProcessWorkerService=v;class y extends A.Disposable{constructor(S,C){super();this.type=S,this.logService=C,this._onDidProcessSelfTerminate=this._register(new L.Emitter),this.onDidProcessSelfTerminate=this._onDidProcessSelfTerminate.event,this.workerReady=this.doInit(),this.mapMessageNonceToPendingMessageResolve=new Map}async init(){return await this.workerReady,this}doInit(){const S=new n.DeferredPromise,C=new Worker("../../../base/worker/workerMain.js",{name:`Shared Process Worker (${this.type})`});return C.onerror=m=>{this.logService.error(`SharedProcess: worker error (${this.type})`,m.message)},C.onmessageerror=m=>{this.logService.error(`SharedProcess: worker message error (${this.type})`,m)},C.onmessage=m=>{const{id:g,message:c,configuration:d,nonce:u}=m.data;switch(g){case w.SharedProcessWorkerMessages.Ready:S.complete(C);break;case w.SharedProcessWorkerMessages.Ack:if(u){const s=this.mapMessageNonceToPendingMessageResolve.get(u);s&&(this.mapMessageNonceToPendingMessageResolve.delete(u),s())}break;case w.SharedProcessWorkerMessages.SelfTerminated:d&&c&&this._onDidProcessSelfTerminate.fire({configuration:d,reason:JSON.parse(c)});break;case w.SharedProcessWorkerMessages.Trace:this.logService.trace(`SharedProcess (worker, ${this.type}):`,c);break;case w.SharedProcessWorkerMessages.Info:c&&this.logService.info(c);break;case w.SharedProcessWorkerMessages.Warn:this.logService.warn(`SharedProcess (worker, ${this.type}):`,c);break;case w.SharedProcessWorkerMessages.Error:this.logService.error(`SharedProcess (worker, ${this.type}):`,c);break;default:this.logService.warn(`SharedProcess: unexpected worker message (${this.type})`,m)}},C.postMessage("vs/platform/sharedProcess/electron-browser/sharedProcessWorkerMain"),S.p}async send(S,C,m){const g=await this.workerReady;if(!C.isCancellationRequested)return new Promise(c=>{const d=(0,P.generateUuid)();this.mapMessageNonceToPendingMessageResolve.set(d,c);const u={...S,nonce:d};m?g.postMessage(u,[m]):g.postMessage(u),C.onCancellationRequested(()=>{this.mapMessageNonceToPendingMessageResolve.delete(d)&&c()})})}spawn(S,C,m){const g={id:w.SharedProcessWorkerMessages.Spawn,configuration:S,environment:{bootstrapPath:b.FileAccess.asFileUri("bootstrap-fork",X).fsPath}};return this.send(g,m,C)}terminate(S,C){const m={id:w.SharedProcessWorkerMessages.Terminate,configuration:S};return this.send(m,C)}}}),define(re[212],se([0,1,60,20,167]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessEnvironmentService=void 0;class L extends k.NativeEnvironmentService{get userRoamingDataHome(){return this.appSettingsHome.with({scheme:n.Schemas.vscodeUserData})}}me([D.memoize],L.prototype,"userRoamingDataHome",null),e.SharedProcessEnvironmentService=L}),define(re[213],se([0,1,54,10,152,21,38,9,4,30,131,165,6]),function(X,e,D,n,k,L,A,b,P,I,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getResolvedShellEnv=void 0;const y=1e4;let f;async function S(m,g,c){return g["force-disable-user-env"]?(m.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):P.isWindows?(m.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,w.isLaunchedFromCli)(c)&&!g["force-user-env"]?(m.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,w.isLaunchedFromCli)(c)?m.trace("resolveShellEnv(): running (--force-user-env)"):m.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=v.Promises.withAsyncBody(async(d,u)=>{const s=new L.CancellationTokenSource,r=setTimeout(()=>{s.dispose(!0),u(new Error((0,k.localize)(0,null)))},y);try{d(await C(m,s.token))}catch(t){!(0,b.isCancellationError)(t)&&!s.token.isCancellationRequested?u(new Error((0,k.localize)(1,null,(0,A.toErrorMessage)(t)))):d({})}finally{clearTimeout(r),s.dispose()}})),f)}e.getResolvedShellEnv=S;async function C(m,g){const c=process.env.ELECTRON_RUN_AS_NODE;m.trace("getUnixShellEnvironment#runAsNode",c);const d=process.env.ELECTRON_NO_ATTACH_CONSOLE;m.trace("getUnixShellEnvironment#noAttach",d);const u=(0,I.generateUuid)().replace(/-/g,"").substr(0,12),s=new RegExp(u+"(.*)"+u),r={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};m.trace("getUnixShellEnvironment#env",r);const t=await(0,E.getSystemShell)(P.OS,r);return m.trace("getUnixShellEnvironment#shell",t),new Promise((i,o)=>{if(g.isCancellationRequested)return o((0,b.canceled)());const l=(0,n.basename)(t);let a,h;const p=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(l)?(a=`& '${process.execPath}' ${p} -p '''${u}'' + JSON.stringify(process.env) + ''${u}'''`,h=["-Login","-Command"]):(a=`'${process.execPath}' ${p} -p '"${u}" + JSON.stringify(process.env) + "${u}"'`,l==="tcsh"?h=["-ic"]:h=["-ilc"]),m.trace("getUnixShellEnvironment#spawn",JSON.stringify(h),a);const R=(0,D.spawn)(t,[...h,a],{detached:!0,stdio:["ignore","pipe","pipe"],env:r});g.onCancellationRequested(()=>(R.kill(),o((0,b.canceled)()))),R.on("error",F=>{m.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(F)),o(F)});const M=[];R.stdout.on("data",F=>M.push(F));const O=[];R.stderr.on("data",F=>O.push(F)),R.on("close",(F,T)=>{const N=Buffer.concat(M).toString("utf8");m.trace("getUnixShellEnvironment#raw",N);const W=Buffer.concat(O).toString("utf8");if(W.trim()&&m.trace("getUnixShellEnvironment#stderr",W),F||T)return o(new Error((0,k.localize)(2,null,F,T)));const V=s.exec(N),Y=V?V[1]:"{}";try{const $=JSON.parse(Y);c?$.ELECTRON_RUN_AS_NODE=c:delete $.ELECTRON_RUN_AS_NODE,d?$.ELECTRON_NO_ATTACH_CONSOLE=d:delete $.ELECTRON_NO_ATTACH_CONSOLE,delete $.XDG_RUNTIME_DIR,m.trace("getUnixShellEnvironment#result",$),i($)}catch($){m.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)($)),o($)}})})}}),define(re[100],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ISignService=e.SIGN_SERVICE_ID=void 0,e.SIGN_SERVICE_ID="signService",e.ISignService=(0,D.createDecorator)(e.SIGN_SERVICE_ID)}),define(re[214],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SignService=void 0;class D{constructor(){this.validators=new Map}vsda(){return new Promise((k,L)=>X(["vsda"],k,L))}async createNewMessage(k){try{const L=await this.vsda(),A=new L.validator;if(A){const b=String(D._nextId++);return this.validators.set(b,A),{id:b,data:A.createNewMessage(k)}}}catch{}return{id:"",data:k}}async validate(k,L){if(!k.id)return!0;const A=this.validators.get(k.id);if(!A)return!1;this.validators.delete(k.id);try{return A.validate(L)==="ok"}catch{return!1}}async sign(k){try{const L=await this.vsda(),A=new L.signer;if(A)return A.sign(k)}catch{}return k}}e.SignService=D,D._nextId=1}),define(re[215],se([0,1,3,2]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkspaceStorageDatabaseClient=e.ProfileStorageDatabaseClient=e.ApplicationStorageDatabaseClient=void 0;class k extends n.Disposable{constructor(E,w,v){super();this.channel=E,this.profile=w,this.workspace=v}async getItems(){const E={profile:this.profile,workspace:this.workspace},w=await this.channel.call("getItems",E);return new Map(w)}updateItems(E){const w={profile:this.profile,workspace:this.workspace};return E.insert&&(w.insert=Array.from(E.insert.entries())),E.delete&&(w.delete=Array.from(E.delete.values())),this.channel.call("updateItems",w)}}class L extends k{constructor(E,w){super(E,w,void 0);this._onDidChangeItemsExternal=this._register(new D.Emitter),this.onDidChangeItemsExternal=this._onDidChangeItemsExternal.event,this.registerListeners()}registerListeners(){this._register(this.channel.listen("onDidChangeStorage",{profile:this.profile})(E=>this.onDidChangeStorage(E)))}onDidChangeStorage(E){(Array.isArray(E.changed)||Array.isArray(E.deleted))&&this._onDidChangeItemsExternal.fire({changed:E.changed?new Map(E.changed):void 0,deleted:E.deleted?new Set(E.deleted):void 0})}}class A extends L{constructor(E){super(E,void 0)}async close(){this.dispose()}}e.ApplicationStorageDatabaseClient=A;class b extends L{constructor(E,w){super(E,w)}async close(){this.dispose()}}e.ProfileStorageDatabaseClient=b;class P extends k{constructor(E,w){super(E,void 0,w);this.onDidChangeItemsExternal=D.Event.None}async close(){this.dispose()}}e.WorkspaceStorageDatabaseClient=P}),define(re[101],se([0,1,4,36,7,30]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.verifyMicrosoftInternalDomain=e.resolveCommonProperties=void 0;function A(I){if(D.platform===2&&/^penguin(\.|$)/i.test(I))return"chromebook"}async function b(I,E,w,v,y,f,S,C,m,g){const c=Object.create(null);c["common.machineId"]=S,c.sessionID=(0,L.generateUuid)()+Date.now(),c.commitHash=y,c.version=f,c["common.platformVersion"]=(E||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),c["common.platform"]=(0,D.PlatformToString)(D.platform),c["common.nodePlatform"]=n.platform,c["common.nodeArch"]=v,c["common.product"]=g||"desktop",C&&(c["common.msftInternal"]=C);let d=0;const u=Date.now();Object.defineProperties(c,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-u,enumerable:!0},"common.sequence":{get:()=>d++,enumerable:!0}}),D.isLinuxSnap&&(c["common.snap"]="true");const s=A(w);s&&(c["common.platformDetail"]=s);try{const r=await I.readFile(k.URI.file(m));c["common.source"]=r.value.toString().slice(0,30)}catch{}return c}e.resolveCommonProperties=b;function P(I){const E=n.env.USERDNSDOMAIN;if(!E)return!1;const w=E.toLowerCase();return I.some(v=>w===v)}e.verifyMicrosoftInternalDomain=P}),define(re[22],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryConfiguration=e.TelemetryLevel=e.TELEMETRY_OLD_SETTING_ID=e.TELEMETRY_SETTING_ID=e.TELEMETRY_SECTION_ID=e.machineIdKey=e.lastSessionDateStorageKey=e.firstSessionDateStorageKey=e.currentSessionDateStorageKey=e.ICustomEndpointTelemetryService=e.ITelemetryService=void 0,e.ITelemetryService=(0,D.createDecorator)("telemetryService"),e.ICustomEndpointTelemetryService=(0,D.createDecorator)("customEndpointTelemetryService"),e.currentSessionDateStorageKey="telemetry.currentSessionDate",e.firstSessionDateStorageKey="telemetry.firstSessionDate",e.lastSessionDateStorageKey="telemetry.lastSessionDate",e.machineIdKey="telemetry.machineId",e.TELEMETRY_SECTION_ID="telemetry",e.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",e.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var n;(function(L){L[L.NONE=0]="NONE",L[L.CRASH=1]="CRASH",L[L.ERROR=2]="ERROR",L[L.USAGE=3]="USAGE"})(n=e.TelemetryLevel||(e.TelemetryLevel={}));var k;(function(L){L.OFF="off",L.CRASH="crash",L.ERROR="error",L.ON="all"})(k=e.TelemetryConfiguration||(e.TelemetryConfiguration={}))}),define(re[216],se([0,1,37,51,6,35,20,10,4,7,128,27,130,89,13,24,22]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DiagnosticsService=e.collectLaunchConfigs=e.getMachineInfo=e.collectWorkspaceStats=void 0;const m=new Map;async function g(r,t){const i=`${r}::${t.join(":")}`,o=m.get(i);if(o)return o;const l=[{tag:"grunt.js",filePattern:/^gruntfile\.js$/i},{tag:"gulp.js",filePattern:/^gulpfile\.js$/i},{tag:"tsconfig.json",filePattern:/^tsconfig\.json$/i},{tag:"package.json",filePattern:/^package\.json$/i},{tag:"jsconfig.json",filePattern:/^jsconfig\.json$/i},{tag:"tslint.json",filePattern:/^tslint\.json$/i},{tag:"eslint.json",filePattern:/^eslint\.json$/i},{tag:"tasks.json",filePattern:/^tasks\.json$/i},{tag:"launch.json",filePattern:/^launch\.json$/i},{tag:"settings.json",filePattern:/^settings\.json$/i},{tag:"webpack.config.js",filePattern:/^webpack\.config\.js$/i},{tag:"project.json",filePattern:/^project\.json$/i},{tag:"makefile",filePattern:/^makefile$/i},{tag:"sln",filePattern:/^.+\.sln$/i},{tag:"csproj",filePattern:/^.+\.csproj$/i},{tag:"cmake",filePattern:/^.+\.cmake$/i},{tag:"github-actions",filePattern:/^.+\.ya?ml$/i,relativePathPattern:/^\.github(?:\/|\\)workflows$/i},{tag:"devcontainer.json",filePattern:/^devcontainer\.json$/i},{tag:"dockerfile",filePattern:/^(dockerfile|docker\-compose\.ya?ml)$/i}],a=new Map,h=new Map,p=2e4;function R(O,F,T,N){const W=F.substring(O.length+1);return k.Promises.withAsyncBody(async V=>{let Y;try{Y=await w.Promises.readdir(F,{withFileTypes:!0})}catch{V();return}if(N.count>=p){N.count+=Y.length,N.maxReached=!0,V();return}let $=Y.length;if($===0){V();return}let J=Y;N.count+Y.length>p&&(N.maxReached=!0,$=p-N.count,J=Y.slice(0,$)),N.count+=Y.length;for(const H of J)if(H.isDirectory()){if(T.includes(H.name)||await R(O,(0,b.join)(F,H.name),T,N),--$==0){V();return}}else{const B=H.name.lastIndexOf(".");if(B>=0){const K=H.name.substring(B+1);K&&a.set(K,(a.get(K)??0)+1)}for(const K of l)K.relativePathPattern?.test(W)!==!1&&K.filePattern.test(H.name)&&h.set(K.tag,(h.get(K.tag)??0)+1);if(--$==0){V();return}}})}const M=k.Promises.withAsyncBody(async O=>{const F={count:0,maxReached:!1};await R(r,r,t,F);const T=await u(r);O({configFiles:c(h),fileTypes:c(a),fileCount:F.count,maxFilesReached:F.maxReached,launchConfigFiles:T})});return m.set(i,M),M}e.collectWorkspaceStats=g;function c(r){return[...n.Iterable.map(r.entries(),([t,i])=>({name:t,count:i}))].sort((t,i)=>i.count-t.count)}function d(){const r={os:`${D.type()} ${D.arch()} ${D.release()}`,memory:`${(D.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`,vmHint:`${Math.round(E.virtualMachineHint.value()*100)}%`},t=D.cpus();return t&&t.length>0&&(r.cpus=`${t[0].model} (${t.length} x ${t[0].speed})`),r}e.getMachineInfo=d;async function u(r){try{const t=new Map,i=(0,b.join)(r,".vscode","launch.json"),o=await w.Promises.readFile(i),l=[],a=(0,L.parse)(o.toString(),l);if(l.length)return console.log(`Unable to parse ${i}`),[];if((0,L.getNodeType)(a)==="object"&&a.configurations)for(const h of a.configurations){const p=h.type;p&&(t.has(p)?t.set(p,t.get(p)+1):t.set(p,1))}return c(t)}catch{return[]}}e.collectLaunchConfigs=u;let s=class{constructor(t,i){this.telemetryService=t,this.productService=i}formatMachineInfo(t){const i=[];return i.push(`OS Version:       ${t.os}`),i.push(`CPUs:             ${t.cpus}`),i.push(`Memory (System):  ${t.memory}`),i.push(`VM:               ${t.vmHint}`),i.join(`
`)}formatEnvironment(t){const i=[];i.push(`Version:          ${this.productService.nameShort} ${this.productService.version} (${this.productService.commit||"Commit unknown"}, ${this.productService.date||"Date unknown"})`),i.push(`OS Version:       ${D.type()} ${D.arch()} ${D.release()}`);const o=D.cpus();return o&&o.length>0&&i.push(`CPUs:             ${o[0].model} (${o.length} x ${o[0].speed})`),i.push(`Memory (System):  ${(D.totalmem()/f.ByteSize.GB).toFixed(2)}GB (${(D.freemem()/f.ByteSize.GB).toFixed(2)}GB free)`),P.isWindows||i.push(`Load (avg):       ${D.loadavg().map(l=>Math.round(l)).join(", ")}`),i.push(`VM:               ${Math.round(E.virtualMachineHint.value()*100)}%`),i.push(`Screen Reader:    ${t.screenReader?"yes":"no"}`),i.push(`Process Argv:     ${t.mainArguments.join(" ")}`),i.push(`GPU Status:       ${this.expandGPUFeatures(t.gpuFeatureStatus)}`),i.join(`
`)}async getPerformanceInfo(t,i){return Promise.all([(0,v.listProcesses)(t.mainPID),this.formatWorkspaceMetadata(t)]).then(async o=>{let[l,a]=o,h=this.formatProcessList(t,l);return i.forEach(p=>{if((0,y.isRemoteDiagnosticError)(p))h+=`
${p.errorMessage}`,a+=`
${p.errorMessage}`;else if(h+=`

Remote: ${p.hostName}`,p.processes&&(h+=`
${this.formatProcessList(t,p.processes)}`),p.workspaceMetadata){a+=`
|  Remote: ${p.hostName}`;for(const R of Object.keys(p.workspaceMetadata)){const M=p.workspaceMetadata[R];let O=`${M.fileCount} files`;M.maxFilesReached&&(O=`more than ${O}`),a+=`|    Folder (${R}): ${O}`,a+=this.formatWorkspaceStats(M)}}}),{processInfo:h,workspaceInfo:a}})}async getSystemInfo(t,i){const{memory:o,vmHint:l,os:a,cpus:h}=d(),p={os:a,memory:o,cpus:h,vmHint:l,processArgs:`${t.mainArguments.join(" ")}`,gpuStatus:t.gpuFeatureStatus,screenReader:`${t.screenReader?"yes":"no"}`,remoteData:i};return P.isWindows||(p.load=`${D.loadavg().map(R=>Math.round(R)).join(", ")}`),P.isLinux&&(p.linuxEnv={desktopSession:process.env.DESKTOP_SESSION,xdgSessionDesktop:process.env.XDG_SESSION_DESKTOP,xdgCurrentDesktop:process.env.XDG_CURRENT_DESKTOP,xdgSessionType:process.env.XDG_SESSION_TYPE}),Promise.resolve(p)}async getDiagnostics(t,i){const o=[];return(0,v.listProcesses)(t.mainPID).then(async l=>(o.push(""),o.push(this.formatEnvironment(t)),o.push(""),o.push(this.formatProcessList(t,l)),t.windows.some(a=>a.folderURIs&&a.folderURIs.length>0&&!a.remoteAuthority)&&(o.push(""),o.push("Workspace Stats: "),o.push(await this.formatWorkspaceMetadata(t))),i.forEach(a=>{if((0,y.isRemoteDiagnosticError)(a))o.push(`
${a.errorMessage}`);else if(o.push(`

`),o.push(`Remote:           ${a.hostName}`),o.push(this.formatMachineInfo(a.machineInfo)),a.processes&&o.push(this.formatProcessList(t,a.processes)),a.workspaceMetadata)for(const h of Object.keys(a.workspaceMetadata)){const p=a.workspaceMetadata[h];let R=`${p.fileCount} files`;p.maxFilesReached&&(R=`more than ${R}`),o.push(`Folder (${h}): ${R}`),o.push(this.formatWorkspaceStats(p))}}),o.push(""),o.push(""),o.join(`
`)))}formatWorkspaceStats(t){const i=[],o=60;let l=0;const a=(M,O)=>{const F=` ${M}(${O})`;l+F.length>o?(i.push(h),h="|                 ",l=h.length):l+=F.length,h+=F};let h="|      File types:";const p=10,R=t.fileTypes.length>p?p:t.fileTypes.length;for(let M=0;M<R;M++){const O=t.fileTypes[M];a(O.name,O.count)}if(i.push(h),t.configFiles.length>=0&&(h="|      Conf files:",l=0,t.configFiles.forEach(M=>{a(M.name,M.count)}),i.push(h)),t.launchConfigFiles.length>0){let M="|      Launch Configs:";t.launchConfigFiles.forEach(O=>{M+=O.count>1?` ${O.name}(${O.count})`:` ${O.name}`}),i.push(M)}return i.join(`
`)}expandGPUFeatures(t){const i=Math.max(...Object.keys(t).map(o=>o.length));return Object.keys(t).map(o=>`${o}:  ${" ".repeat(i-o.length)}  ${t[o]}`).join(`
                  `)}formatWorkspaceMetadata(t){const i=[],o=[];return t.windows.forEach(l=>{l.folderURIs.length===0||!!l.remoteAuthority||(i.push(`|  Window (${l.title})`),l.folderURIs.forEach(a=>{const h=I.URI.revive(a);if(h.scheme===A.Schemas.file){const p=h.fsPath;o.push(g(p,["node_modules",".git"]).then(R=>{let M=`${R.fileCount} files`;R.maxFilesReached&&(M=`more than ${M}`),i.push(`|    Folder (${(0,b.basename)(p)}): ${M}`),i.push(this.formatWorkspaceStats(R))}).catch(R=>{i.push(`|      Error: Unable to collect workspace stats for folder ${p} (${R.toString()})`)}))}else i.push(`|    Folder (${h.toString()}): Workspace stats not available.`)}))}),Promise.all(o).then(l=>i.join(`
`)).catch(l=>`Unable to collect workspace stats: ${l}`)}formatProcessList(t,i){const o=new Map;t.windows.forEach(a=>o.set(a.pid,a.title));const l=[];return l.push("CPU %	Mem MB	   PID	Process"),i&&this.formatProcessItem(t.mainPID,o,l,i,0),l.join(`
`)}formatProcessItem(t,i,o,l,a){const h=a===0;let p;h?p=l.pid===t?`${this.productService.applicationName} main`:"remote agent":(p=`${"  ".repeat(a)} ${l.name}`,l.name==="window"&&(p=`${p} (${i.get(l.pid)})`));const R=process.platform==="win32"?l.mem:D.totalmem()*(l.mem/100);o.push(`${l.load.toFixed(0).padStart(5," ")}	${(R/f.ByteSize.MB).toFixed(0).padStart(6," ")}	${l.pid.toFixed(0).padStart(6," ")}	${p}`),Array.isArray(l.children)&&l.children.forEach(M=>this.formatProcessItem(t,i,o,M,a+1))}async getWorkspaceFileExtensions(t){const i=new Set;for(const{uri:o}of t.folders){const l=I.URI.revive(o);if(l.scheme!==A.Schemas.file)continue;const a=l.fsPath;try{(await g(a,["node_modules",".git"])).fileTypes.forEach(p=>i.add(p.name))}catch{}}return{extensions:[...i]}}async reportWorkspaceStats(t){for(const{uri:i}of t.folders){const o=I.URI.revive(i);if(o.scheme!==A.Schemas.file)continue;const l=o.fsPath;try{const a=await g(l,["node_modules",".git"]);this.telemetryService.publicLog2("workspace.stats",{"workspace.id":t.telemetryId,rendererSessionId:t.rendererSessionId}),a.fileTypes.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.file",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})}),a.launchConfigFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.launchConfigFile",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})}),a.configFiles.forEach(h=>{this.telemetryService.publicLog2("workspace.stats.configFiles",{rendererSessionId:t.rendererSessionId,type:h.name,count:h.count})})}catch{}}}};s=me([G(0,C.ITelemetryService),G(1,S.IProductService)],s),e.DiagnosticsService=s}),define(re[102],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryAppenderClient=e.TelemetryAppenderChannel=void 0;class D{constructor(L){this.appenders=L}listen(L,A){throw new Error(`Event not found: ${A}`)}call(L,A,{eventName:b,data:P}){return this.appenders.forEach(I=>I.log(b,P)),Promise.resolve(null)}}e.TelemetryAppenderChannel=D;class n{constructor(L){this.channel=L}log(L,A){return this.channel.call("log",{eventName:L,data:A}).then(void 0,b=>`Failed to log telemetry: ${console.warn(b)}`),Promise.resolve(null)}flush(){return Promise.resolve()}}e.TelemetryAppenderClient=n}),define(re[49],se([0,1,31,78,15,19,101,22]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPiiPathsFromEnvironment=e.isInternalTelemetry=e.cleanRemoteAuthority=e.validateTelemetryData=e.getTelemetryLevel=e.supportsTelemetry=e.configurationTelemetry=e.NullAppender=e.NullEndpointTelemetryService=e.NullTelemetryService=e.NullTelemetryServiceShape=void 0;class P{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,n.staticObservableValue)(0)}publicLog(s,r){return Promise.resolve(void 0)}publicLog2(s,r){return this.publicLog(s,r)}publicLogError(s,r){return Promise.resolve(void 0)}publicLogError2(s,r){return this.publicLogError(s,r)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}e.NullTelemetryServiceShape=P,e.NullTelemetryService=new P;class I{async publicLog(s,r,t){}async publicLogError(s,r,t){}}e.NullEndpointTelemetryService=I,e.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function E(u,s){return s.onDidChangeConfiguration(r=>{r.source!==7&&u.publicLog2("updateConfiguration",{configurationSource:(0,L.ConfigurationTargetToString)(r.source),configurationKeys:m(r.sourceConfig)})})}e.configurationTelemetry=E;function w(u,s){return!(s.disableTelemetry||!u.enableTelemetry||s.extensionTestsLocationURI)}e.supportsTelemetry=w;function v(u){const s=u.getValue(b.TELEMETRY_SETTING_ID),r=u.getValue("telemetry.enableCrashReporter");if(u.getValue(b.TELEMETRY_OLD_SETTING_ID)===!1||r===!1)return 0;switch(s??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}e.getTelemetryLevel=v;function y(u){const s={},r={},t={};C(u,t);for(let i in t){i=i.length>150?i.substr(i.length-149):i;const o=t[i];typeof o=="number"?r[i]=o:typeof o=="boolean"?r[i]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${i} has been trimmed to 8192, the original length is ${o.length}`),s[i]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(s[i]=o)}return{properties:s,measurements:r}}e.validateTelemetryData=y;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function S(u){if(!u)return"none";for(const s of f)if(u.startsWith(`${s}+`))return s;return"other"}e.cleanRemoteAuthority=S;function C(u,s,r=0,t){if(!!u)for(const i of Object.getOwnPropertyNames(u)){const o=u[i],l=t?t+i:i;Array.isArray(o)?s[l]=(0,D.safeStringify)(o):o instanceof Date?s[l]=o.toISOString():(0,k.isObject)(o)?r<2?C(o,s,r+1,l+"."):s[l]=(0,D.safeStringify)(o):s[l]=o}}function m(u){if(!u)return[];const s=[];return g(s,"",u),s}function g(u,s,r){r&&typeof r=="object"&&!Array.isArray(r)?Object.keys(r).forEach(t=>g(u,s?`${s}.${t}`:t,r[t])):u.push(s)}function c(u,s){const r=u.msftInternalDomains||[],t=s.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(r)||t}e.isInternalTelemetry=c;function d(u){return[u.appRoot,u.extensionsPath,u.userHome.fsPath,u.tmpDir.fsPath,u.userDataPath]}e.getPiiPathsFromEnvironment=d}),define(re[217],se([0,1,48,49]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveMarketplaceHeaders=void 0;async function k(L,A,b,P,I,E,w){const v={"X-Market-Client-Id":`VSCode ${L}`,"User-Agent":`VSCode ${L} (${A.nameShort})`},y=await(0,D.getServiceMachineId)(b,I,E),{sessionId:f}=await w.getTelemetryInfo();return(0,n.supportsTelemetry)(A,b)&&(0,n.getTelemetryLevel)(P)===3&&(v["X-Market-User-Id"]=y,v["VSCode-SessionId"]=f),v}e.resolveMarketplaceHeaders=k}),define(re[218],se([0,1,9,31,49]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractOneDataSystemAppender=void 0;const L="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(P,I,E){const w=await new Promise((C,m)=>{X(["@microsoft/1ds-core-js"],C,m)}),v=await new Promise((C,m)=>{X(["@microsoft/1ds-post-js"],C,m)}),y=new w.AppInsightsCore,f=new v.PostChannel,S={instrumentationKey:P,endpointUrl:L,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(E){S.extensionConfig={};const C={alwaysUseXhrOverride:!0,httpXHROverride:E};S.extensionConfig[f.identifier]=C}return y.initialize(S,[]),y.addTelemetryInitializer(C=>{I&&(C.ext=C.ext??{},C.ext.utc=C.ext.utc??{},C.ext.utc.flags=8462029)}),y}class b{constructor(I,E,w,v,y){this._isInternalTelemetry=I,this._eventPrefix=E,this._defaultData=w,this._xhrOverride=y,this.endPointUrl=L,this._defaultData||(this._defaultData={}),typeof v=="function"?this._aiCoreOrKey=v():this._aiCoreOrKey=v,this._asyncAiCore=null}_withAIClient(I){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){I(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(E=>{I(E)},E=>{(0,D.onUnexpectedError)(E),console.error(E)})}}log(I,E){if(!this._aiCoreOrKey)return;E=(0,n.mixin)(E,this._defaultData),E=(0,k.validateTelemetryData)(E);const w=this._eventPrefix+"/"+I;try{this._withAIClient(v=>{v.pluginVersionString=E?.properties.version??"Unknown",v.track({name:w,baseData:{name:w,properties:E?.properties,measurements:E?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(I=>{this._withAIClient(E=>{E.unload(!0,()=>{this._aiCoreOrKey=void 0,I(void 0)})})}):Promise.resolve(void 0)}}e.AbstractOneDataSystemAppender=b}),define(re[219],se([0,1,218]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.OneDataSystemWebAppender=void 0;class n extends D.AbstractOneDataSystemAppender{constructor(L,A,b,P){super(L,A,b,P);fetch(this.endPointUrl,{method:"POST"}).catch(I=>{this._aiCoreOrKey=void 0})}}e.OneDataSystemWebAppender=n}),define(re[103],se([0,1,2,14,8,49]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryLogAppender=void 0;let A=class extends D.Disposable{constructor(P,I,E=""){super();this.prefix=E;const w=P.getLogger(I.telemetryLogResource);w?this.logger=this._register(w):(this.logger=this._register(P.createLogger(I.telemetryLogResource)),this.logger.info("The below are logs for every telemetry event sent from VS Code once the log level is set to trace."),this.logger.info("==========================================================="))}flush(){return Promise.resolve(void 0)}log(P,I){this.logger.trace(`${this.prefix}telemetry/${P}`,(0,L.validateTelemetryData)(I))}};A=me([G(0,k.ILoggerService),G(1,n.IEnvironmentService)],A),e.TelemetryLogAppender=A}),define(re[104],se([0,1,2,31,78,4,26,153,19,42,96,24,40,22,49]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TelemetryService=void 0;let S=class{constructor(g,c,d){this._configurationService=c,this._productService=d,this._experimentProperties={},this.telemetryLevel=new k.MutableObservableValue(3),this._disposables=new D.DisposableStore,this._cleanupPatterns=[],this._appenders=g.appenders,this._commonProperties=g.commonProperties||Promise.resolve({}),this._piiPaths=g.piiPaths||[],this._sendErrorTelemetry=!!g.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const u of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(u),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(g,c){this._experimentProperties[g]=c}_updateTelemetryLevel(){let g=(0,f.getTelemetryLevel)(this._configurationService);const c=this._productService.enabledTelemetryLevels;if(c){this._sendErrorTelemetry=this.sendErrorTelemetry?c.error:!1;const d=c.usage?3:c.error?2:0;g=Math.min(g,d)}this.telemetryLevel.value=g}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const g=await this._commonProperties,c=g.sessionID,d=g["common.machineId"],u=g["common.firstSessionDate"],s=g["common.msftInternal"];return{sessionId:c,machineId:d,firstSessionDate:u,msftInternal:s}}dispose(){this._disposables.dispose()}_log(g,c,d,u){return this.telemetryLevel.value<c?Promise.resolve(void 0):this._commonProperties.then(s=>{d=(0,n.mixin)(d,s),d=(0,n.mixin)(d,this._experimentProperties),d=(0,n.cloneAndChange)(d,r=>{if(typeof r=="string")return this._cleanupInfo(r,u)}),this._appenders.forEach(r=>r.log(g,d))},s=>{console.error(s)})}publicLog(g,c,d){return this._log(g,3,c,d)}publicLog2(g,c,d){return this.publicLog(g,c,d)}publicLogError(g,c){return this._sendErrorTelemetry?this._log(g,2,c,!0):Promise.resolve(void 0)}publicLogError2(g,c){return this.publicLogError(g,c)}_anonymizeFilePaths(g){let c=g;const d=[];for(const t of this._cleanupPatterns)for(;;){const i=t.exec(g);if(!i)break;d.push([i.index,t.lastIndex])}const u=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,s=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let r=0;for(c="";;){const t=s.exec(g);if(!t)break;!u.test(t[0])&&d.every(([i,o])=>t.index<i||t.index>=o)&&(c+=g.substring(r,t.index)+"<REDACTED: user-file-path>",r=s.lastIndex)}return r<g.length&&(c+=g.substr(r)),c}_removePropertiesWithPossibleUserInfo(g){if(!g)return g;const c=g.toLowerCase(),d=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const u of d)if(u.regex.test(c))return`<REDACTED: ${u.label}>`;return g}_cleanupInfo(g,c){let d=g;c&&(d=this._anonymizeFilePaths(d));for(const u of this._cleanupPatterns)d=d.replace(u,"");return d=this._removePropertiesWithPossibleUserInfo(d),d}};S.IDLE_START_EVENT_NAME="UserIdleStart",S.IDLE_STOP_EVENT_NAME="UserIdleStop",S=me([G(1,P.IConfigurationService),G(2,w.IProductService)],S),e.TelemetryService=S;function C(){const m=(0,b.localize)(0,null,E.default.nameLong),g=E.default.privacyStatementUrl?(0,b.localize)(2,null,"https://aka.ms/vscode-telemetry",E.default.privacyStatementUrl):(0,b.localize)(1,null,"https://aka.ms/vscode-telemetry"),c=L.isWeb?"":(0,b.localize)(3,null),d=(0,b.localize)(4,null),u=(0,b.localize)(5,null),s=(0,b.localize)(6,null),r=(0,b.localize)(7,null),t=`
|       | ${d} | ${u} | ${s} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,i=(0,b.localize)(8,null);return`
${m} ${g} ${c}

&nbsp;

${r}
${t}

&nbsp;

${i}
`}v.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(9,null),properties:{[y.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,b.localize)(10,null),(0,b.localize)(11,null),(0,b.localize)(12,null),(0,b.localize)(13,null)],markdownDescription:C(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),v.Registry.as(I.Extensions.Configuration).registerConfiguration({id:y.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,b.localize)(14,null),properties:{[y.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:E.default.privacyStatementUrl?(0,b.localize)(16,null,E.default.nameLong,E.default.privacyStatementUrl):(0,b.localize)(15,null,E.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,b.localize)(17,null,`\`#${y.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(re[220],se([0,1,20,64,19,14,8,24,22,102,103,104]),function(X,e,D,n,k,L,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CustomEndpointTelemetryService=void 0;let v=class{constructor(f,S,C,m,g){this.configurationService=f,this.telemetryService=S,this.loggerService=C,this.environmentService=m,this.productService=g,this.customTelemetryServices=new Map}async getCustomTelemetryService(f){if(!this.customTelemetryServices.has(f.id)){const{machineId:S,sessionId:C}=await this.telemetryService.getTelemetryInfo(),m=Object.create(null);m["common.vscodemachineid"]=S,m["common.vscodesessionid"]=C;const g=[f.id,JSON.stringify(m),f.aiKey],d=new n.Client(D.FileAccess.asFileUri("bootstrap-fork",X).fsPath,{serverName:"Debug Telemetry",timeout:1e3*60*5,args:g,env:{ELECTRON_RUN_AS_NODE:1,VSCODE_PIPE_LOGGING:"true",VSCODE_AMD_ENTRYPOINT:"vs/workbench/contrib/debug/node/telemetryApp"}}).getChannel("telemetryAppender"),u=[new I.TelemetryAppenderClient(d),new E.TelemetryLogAppender(this.loggerService,this.environmentService,`[${f.id}] `)];this.customTelemetryServices.set(f.id,new w.TelemetryService({appenders:u,sendErrorTelemetry:f.sendErrorTelemetry},this.configurationService,this.productService))}return this.customTelemetryServices.get(f.id)}async publicLog(f,S,C){await(await this.getCustomTelemetryService(f)).publicLog(S,C)}async publicLogError(f,S,C){await(await this.getCustomTelemetryService(f)).publicLogError(S,C)}};v=me([G(0,k.IConfigurationService),G(1,P.ITelemetryService),G(2,A.ILoggerService),G(3,L.IEnvironmentService),G(4,b.IProductService)],v),e.CustomEndpointTelemetryService=v}),define(re[221],se([0,1,6,21,3,2,8]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestStore=void 0;let b=class extends L.Disposable{constructor(I,E){super();this._logService=E,this._lastRequestId=0,this._pendingRequests=new Map,this._pendingRequestDisposables=new Map,this._onCreateRequest=this._register(new k.Emitter),this.onCreateRequest=this._onCreateRequest.event,this._timeout=I===void 0?15e3:I}createRequest(I){return new Promise((E,w)=>{const v=++this._lastRequestId;this._pendingRequests.set(v,E),this._onCreateRequest.fire({requestId:v,...I});const y=new n.CancellationTokenSource;(0,D.timeout)(this._timeout,y.token).then(()=>w(`Request ${v} timed out (${this._timeout}ms)`)),this._pendingRequestDisposables.set(v,[(0,L.toDisposable)(()=>y.cancel())])})}acceptReply(I,E){const w=this._pendingRequests.get(I);w?(this._pendingRequests.delete(I),(0,L.dispose)(this._pendingRequestDisposables.get(I)||[]),this._pendingRequestDisposables.delete(I),w(E)):this._logService.warn(`RequestStore#acceptReply was called without receiving a matching request ${I}`)}};b=me([G(1,A.ILogService)],b),e.RequestStore=b}),define(re[105],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalExitReason=e.ShellIntegrationStatus=e.ProfileSource=e.FlowControlConstants=e.LocalReconnectConstants=e.TerminalLocationString=e.TerminalLocation=e.HeartbeatConstants=e.ProcessPropertyType=e.IPtyService=e.TerminalIpcChannels=e.TitleEventSource=e.WindowsShellType=e.PosixShellType=e.TerminalLogConstants=e.TerminalSettingId=e.TerminalSettingPrefix=void 0;var n;(function(c){c.Shell="terminal.integrated.shell.",c.ShellArgs="terminal.integrated.shellArgs.",c.DefaultProfile="terminal.integrated.defaultProfile.",c.Profiles="terminal.integrated.profiles."})(n=e.TerminalSettingPrefix||(e.TerminalSettingPrefix={}));var k;(function(c){c.ShellLinux="terminal.integrated.shell.linux",c.ShellMacOs="terminal.integrated.shell.osx",c.ShellWindows="terminal.integrated.shell.windows",c.SendKeybindingsToShell="terminal.integrated.sendKeybindingsToShell",c.AutomationShellLinux="terminal.integrated.automationShell.linux",c.AutomationShellMacOs="terminal.integrated.automationShell.osx",c.AutomationShellWindows="terminal.integrated.automationShell.windows",c.AutomationProfileLinux="terminal.integrated.automationProfile.linux",c.AutomationProfileMacOs="terminal.integrated.automationProfile.osx",c.AutomationProfileWindows="terminal.integrated.automationProfile.windows",c.ShellArgsLinux="terminal.integrated.shellArgs.linux",c.ShellArgsMacOs="terminal.integrated.shellArgs.osx",c.ShellArgsWindows="terminal.integrated.shellArgs.windows",c.ProfilesWindows="terminal.integrated.profiles.windows",c.ProfilesMacOs="terminal.integrated.profiles.osx",c.ProfilesLinux="terminal.integrated.profiles.linux",c.DefaultProfileLinux="terminal.integrated.defaultProfile.linux",c.DefaultProfileMacOs="terminal.integrated.defaultProfile.osx",c.DefaultProfileWindows="terminal.integrated.defaultProfile.windows",c.UseWslProfiles="terminal.integrated.useWslProfiles",c.TabsDefaultColor="terminal.integrated.tabs.defaultColor",c.TabsDefaultIcon="terminal.integrated.tabs.defaultIcon",c.TabsEnabled="terminal.integrated.tabs.enabled",c.TabsEnableAnimation="terminal.integrated.tabs.enableAnimation",c.TabsHideCondition="terminal.integrated.tabs.hideCondition",c.TabsShowActiveTerminal="terminal.integrated.tabs.showActiveTerminal",c.TabsShowActions="terminal.integrated.tabs.showActions",c.TabsLocation="terminal.integrated.tabs.location",c.TabsFocusMode="terminal.integrated.tabs.focusMode",c.MacOptionIsMeta="terminal.integrated.macOptionIsMeta",c.MacOptionClickForcesSelection="terminal.integrated.macOptionClickForcesSelection",c.AltClickMovesCursor="terminal.integrated.altClickMovesCursor",c.CopyOnSelection="terminal.integrated.copyOnSelection",c.EnableMultiLinePasteWarning="terminal.integrated.enableMultiLinePasteWarning",c.DrawBoldTextInBrightColors="terminal.integrated.drawBoldTextInBrightColors",c.FontFamily="terminal.integrated.fontFamily",c.FontSize="terminal.integrated.fontSize",c.LetterSpacing="terminal.integrated.letterSpacing",c.LineHeight="terminal.integrated.lineHeight",c.MinimumContrastRatio="terminal.integrated.minimumContrastRatio",c.FastScrollSensitivity="terminal.integrated.fastScrollSensitivity",c.MouseWheelScrollSensitivity="terminal.integrated.mouseWheelScrollSensitivity",c.BellDuration="terminal.integrated.bellDuration",c.FontWeight="terminal.integrated.fontWeight",c.FontWeightBold="terminal.integrated.fontWeightBold",c.CursorBlinking="terminal.integrated.cursorBlinking",c.CursorStyle="terminal.integrated.cursorStyle",c.CursorWidth="terminal.integrated.cursorWidth",c.Scrollback="terminal.integrated.scrollback",c.DetectLocale="terminal.integrated.detectLocale",c.DefaultLocation="terminal.integrated.defaultLocation",c.GpuAcceleration="terminal.integrated.gpuAcceleration",c.TerminalTitleSeparator="terminal.integrated.tabs.separator",c.TerminalTitle="terminal.integrated.tabs.title",c.TerminalDescription="terminal.integrated.tabs.description",c.RightClickBehavior="terminal.integrated.rightClickBehavior",c.Cwd="terminal.integrated.cwd",c.ConfirmOnExit="terminal.integrated.confirmOnExit",c.ConfirmOnKill="terminal.integrated.confirmOnKill",c.EnableBell="terminal.integrated.enableBell",c.CommandsToSkipShell="terminal.integrated.commandsToSkipShell",c.AllowChords="terminal.integrated.allowChords",c.AllowMnemonics="terminal.integrated.allowMnemonics",c.EnvMacOs="terminal.integrated.env.osx",c.EnvLinux="terminal.integrated.env.linux",c.EnvWindows="terminal.integrated.env.windows",c.EnvironmentChangesIndicator="terminal.integrated.environmentChangesIndicator",c.EnvironmentChangesRelaunch="terminal.integrated.environmentChangesRelaunch",c.ShowExitAlert="terminal.integrated.showExitAlert",c.SplitCwd="terminal.integrated.splitCwd",c.WindowsEnableConpty="terminal.integrated.windowsEnableConpty",c.WordSeparators="terminal.integrated.wordSeparators",c.EnableFileLinks="terminal.integrated.enableFileLinks",c.UnicodeVersion="terminal.integrated.unicodeVersion",c.LocalEchoLatencyThreshold="terminal.integrated.localEchoLatencyThreshold",c.LocalEchoEnabled="terminal.integrated.localEchoEnabled",c.LocalEchoExcludePrograms="terminal.integrated.localEchoExcludePrograms",c.LocalEchoStyle="terminal.integrated.localEchoStyle",c.EnablePersistentSessions="terminal.integrated.enablePersistentSessions",c.PersistentSessionReviveProcess="terminal.integrated.persistentSessionReviveProcess",c.CustomGlyphs="terminal.integrated.customGlyphs",c.PersistentSessionScrollback="terminal.integrated.persistentSessionScrollback",c.InheritEnv="terminal.integrated.inheritEnv",c.ShowLinkHover="terminal.integrated.showLinkHover",c.IgnoreProcessNames="terminal.integrated.ignoreProcessNames",c.AutoReplies="terminal.integrated.autoReplies",c.ShellIntegrationEnabled="terminal.integrated.shellIntegration.enabled",c.ShellIntegrationShowWelcome="terminal.integrated.shellIntegration.showWelcome",c.ShellIntegrationDecorationsEnabled="terminal.integrated.shellIntegration.decorationsEnabled",c.ShellIntegrationCommandHistory="terminal.integrated.shellIntegration.history",c.SmoothScrolling="terminal.integrated.smoothScrolling"})(k=e.TerminalSettingId||(e.TerminalSettingId={}));var L;(function(c){c.FileName="ptyhost"})(L=e.TerminalLogConstants||(e.TerminalLogConstants={}));var A;(function(c){c.PowerShell="pwsh",c.Bash="bash",c.Fish="fish",c.Sh="sh",c.Csh="csh",c.Ksh="ksh",c.Zsh="zsh"})(A=e.PosixShellType||(e.PosixShellType={}));var b;(function(c){c.CommandPrompt="cmd",c.PowerShell="pwsh",c.Wsl="wsl",c.GitBash="gitbash"})(b=e.WindowsShellType||(e.WindowsShellType={}));var P;(function(c){c[c.Api=0]="Api",c[c.Process=1]="Process",c[c.Sequence=2]="Sequence",c[c.Config=3]="Config"})(P=e.TitleEventSource||(e.TitleEventSource={}));var I;(function(c){c.LocalPty="localPty",c.PtyHost="ptyHost",c.Log="log",c.Heartbeat="heartbeat"})(I=e.TerminalIpcChannels||(e.TerminalIpcChannels={})),e.IPtyService=(0,D.createDecorator)("ptyService");var E;(function(c){c.Cwd="cwd",c.InitialCwd="initialCwd",c.FixedDimensions="fixedDimensions",c.Title="title",c.ShellType="shellType",c.HasChildProcesses="hasChildProcesses",c.ResolvedShellLaunchConfig="resolvedShellLaunchConfig",c.OverrideDimensions="overrideDimensions",c.FailedShellIntegrationActivation="failedShellIntegrationActivation",c.UsedShellIntegrationInjection="usedShellIntegrationInjection"})(E=e.ProcessPropertyType||(e.ProcessPropertyType={}));var w;(function(c){c[c.BeatInterval=5e3]="BeatInterval",c[c.FirstWaitMultiplier=1.2]="FirstWaitMultiplier",c[c.SecondWaitMultiplier=1]="SecondWaitMultiplier",c[c.CreateProcessTimeout=5e3]="CreateProcessTimeout"})(w=e.HeartbeatConstants||(e.HeartbeatConstants={}));var v;(function(c){c[c.Panel=1]="Panel",c[c.Editor=2]="Editor"})(v=e.TerminalLocation||(e.TerminalLocation={}));var y;(function(c){c.TerminalView="view",c.Editor="editor"})(y=e.TerminalLocationString||(e.TerminalLocationString={}));var f;(function(c){c[c.GraceTime=6e4]="GraceTime",c[c.ShortGraceTime=6e3]="ShortGraceTime"})(f=e.LocalReconnectConstants||(e.LocalReconnectConstants={}));var S;(function(c){c[c.HighWatermarkChars=1e5]="HighWatermarkChars",c[c.LowWatermarkChars=5e3]="LowWatermarkChars",c[c.CharCountAckSize=5e3]="CharCountAckSize"})(S=e.FlowControlConstants||(e.FlowControlConstants={}));var C;(function(c){c.GitBash="Git Bash",c.Pwsh="PowerShell"})(C=e.ProfileSource||(e.ProfileSource={}));var m;(function(c){c[c.Off=0]="Off",c[c.FinalTerm=1]="FinalTerm",c[c.VSCode=2]="VSCode"})(m=e.ShellIntegrationStatus||(e.ShellIntegrationStatus={}));var g;(function(c){c[c.Unknown=0]="Unknown",c[c.Shutdown=1]="Shutdown",c[c.Process=2]="Process",c[c.User=3]="User",c[c.Extension=4]="Extension"})(g=e.TerminalExitReason||(e.TerminalExitReason={}))}),define(re[222],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ILocalPtyService=void 0,e.ILocalPtyService=(0,D.createDecorator)("localPtyService")}),define(re[223],se([0,1,37,20,31,10,4,36,26,15,27]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.shellIntegrationArgs=e.ShellIntegrationExecutable=e.getShellIntegrationInjection=e.findExecutable=e.getWindowsBuildNumber=void 0;function w(){const d=/(\d+)\.(\d+)\.(\d+)/g.exec(D.release());let u=0;return d&&d.length===4&&(u=parseInt(d[3])),u}e.getWindowsBuildNumber=w;async function v(d,u,s,r=b.env,t=E.Promises.exists){if(L.isAbsolute(d))return await t(d)?d:void 0;if(u===void 0&&(u=b.cwd()),L.dirname(d)!=="."){const a=L.join(u,d);return await t(a)?a:void 0}const o=(0,k.getCaseInsensitive)(r,"PATH");if(s===void 0&&(0,I.isString)(o)&&(s=o.split(L.delimiter)),s===void 0||s.length===0){const a=L.join(u,d);return await t(a)?a:void 0}for(const a of s){let h;if(L.isAbsolute(a)?h=L.join(a,d):h=L.join(u,a,d),await t(h))return h;if(A.isWindows){let p=h+".com";if(await t(p)||(p=h+".exe",await t(p)))return p}}const l=L.join(u,d);return await t(l)?l:void 0}e.findExecutable=v;function y(d,u,s){if(!u.enabled||!d.executable||d.isFeatureTerminal||d.hideFromUser||d.ignoreShellIntegration)return;const r=d.args,t=b.platform==="win32"?L.basename(d.executable).toLowerCase():L.basename(d.executable),i=L.dirname(n.FileAccess.asFileUri("",X).fsPath);let o;const l={VSCODE_INJECTION:"1"};if(A.isWindows){if(t==="pwsh.exe")return!r||g(r)?o=e.shellIntegrationArgs.get(f.WindowsPwsh):m(r)&&(o=e.shellIntegrationArgs.get(f.WindowsPwshLogin)),o?(o&&(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,"")),{newArgs:o,envMixin:l}):void 0;s.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args);return}switch(t){case"bash":return!r||r.length===0?o=e.shellIntegrationArgs.get(f.Bash):c(r)&&(l.VSCODE_SHELL_LOGIN="1",o=e.shellIntegrationArgs.get(f.Bash)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i),{newArgs:o,envMixin:l}):void 0;case"pwsh":return!r||g(r)?o=e.shellIntegrationArgs.get(f.Pwsh):m(r)&&(o=e.shellIntegrationArgs.get(f.PwshLogin)),o?(o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i,""),{newArgs:o,envMixin:l}):void 0;case"zsh":{if(!r||r.length===0?o=e.shellIntegrationArgs.get(f.Zsh):c(r)?o=e.shellIntegrationArgs.get(f.ZshLogin):(r===e.shellIntegrationArgs.get(f.Zsh)||r===e.shellIntegrationArgs.get(f.ZshLogin))&&(o=r),!o)return;o=[...o],o[o.length-1]=(0,P.format)(o[o.length-1],i);const a=L.join(D.tmpdir(),"vscode-zsh");l.ZDOTDIR=a;const h=[];return h.push({source:L.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-rc.zsh"),dest:L.join(a,".zshrc")}),h.push({source:L.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-profile.zsh"),dest:L.join(a,".zprofile")}),h.push({source:L.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-env.zsh"),dest:L.join(a,".zshenv")}),h.push({source:L.join(i,"out/vs/workbench/contrib/terminal/browser/media/shellIntegration-login.zsh"),dest:L.join(a,".zlogin")}),{newArgs:o,envMixin:l,filesToCopy:h}}}s.warn(`Shell integration cannot be enabled for executable "${d.executable}" and args`,d.args)}e.getShellIntegrationInjection=y;var f;(function(d){d.WindowsPwsh="windows-pwsh",d.WindowsPwshLogin="windows-pwsh-login",d.Pwsh="pwsh",d.PwshLogin="pwsh-login",d.Zsh="zsh",d.ZshLogin="zsh-login",d.Bash="bash"})(f=e.ShellIntegrationExecutable||(e.ShellIntegrationExecutable={})),e.shellIntegrationArgs=new Map,e.shellIntegrationArgs.set(f.WindowsPwsh,["-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.WindowsPwshLogin,["-l","-noexit","-command",'. "{0}\\out\\vs\\workbench\\contrib\\terminal\\browser\\media\\shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.Pwsh,["-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"{1}']),e.shellIntegrationArgs.set(f.PwshLogin,["-l","-noexit","-command",'. "{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration.ps1"']),e.shellIntegrationArgs.set(f.Zsh,["-i"]),e.shellIntegrationArgs.set(f.ZshLogin,["-il"]),e.shellIntegrationArgs.set(f.Bash,["--init-file","{0}/out/vs/workbench/contrib/terminal/browser/media/shellIntegration-bash.sh"]);const S=["-login","-l"],C=["-nol","-nologo"];function m(d){return typeof d=="string"?S.includes(d.toLowerCase()):d.length===1&&S.includes(d[0].toLowerCase())||d.length===2&&(S.includes(d[0].toLowerCase())||S.includes(d[1].toLowerCase()))&&(C.includes(d[0].toLowerCase())||C.includes(d[1].toLowerCase()))}function g(d){return typeof d=="string"?C.includes(d.toLowerCase()):d.length===0||d?.length===1&&C.includes(d[0].toLowerCase())}function c(d){return d==="string"&&S.includes(d.toLowerCase())||typeof d!="string"&&d.length===1&&S.includes(d[0].toLowerCase())}}),define(re[224],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var D;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(D=e.ColorScheme||(e.ColorScheme={}));function n(L){return L===D.HIGH_CONTRAST_DARK||L===D.HIGH_CONTRAST_LIGHT}e.isHighContrast=n;function k(L){return L===D.DARK||L===D.HIGH_CONTRAST_DARK}e.isDark=k}),define(re[106],se([0,1,50,3,2,5,40,224]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var P;(function(C){function m(g){return g&&typeof g=="object"&&typeof g.id=="string"}C.isThemeColor=m})(P=e.ThemeColor||(e.ThemeColor={}));function I(C){return{id:C}}e.themeColorFromId=I;var E;(function(C){function m(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||P.isThemeColor(i.color))}C.isThemeIcon=m;const g=new RegExp(`^\\$\\((${D.CSSIcon.iconNameExpression}(?:${D.CSSIcon.iconModifierExpression})?)\\)$`);function c(i){const o=g.exec(i);if(!o)return;const[,l]=o;return{id:l}}C.fromString=c;function d(i){return{id:i}}C.fromId=d;function u(i,o){let l=i.id;const a=l.lastIndexOf("~");return a!==-1&&(l=l.substring(0,a)),o&&(l=`${l}~${o}`),{id:l}}C.modify=u;function s(i){const o=i.id.lastIndexOf("~");if(o!==-1)return i.id.substring(o+1)}C.getModifier=s;function r(i,o){return i.id===o.id&&i.color?.id===o.color?.id}C.isEqual=r;function t(i,o){return{id:i.id,color:o?I(o):void 0}}C.asThemeIcon=t,C.asClassNameArray=D.CSSIcon.asClassNameArray,C.asClassName=D.CSSIcon.asClassName,C.asCSSSelector=D.CSSIcon.asCSSSelector})(E=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=D.Codicon.file,e.FolderThemeIcon=D.Codicon.folder;function w(C){switch(C){case b.ColorScheme.DARK:return"vs-dark";case b.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case b.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=w,e.Extensions={ThemingContribution:"base.contributions.theming"};class v{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new n.Emitter}onColorThemeChange(m){return this.themingParticipants.push(m),this.onThemingParticipantAddedEmitter.fire(m),(0,k.toDisposable)(()=>{const g=this.themingParticipants.indexOf(m);this.themingParticipants.splice(g,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const y=new v;A.Registry.add(e.Extensions.ThemingContribution,y);function f(C){return y.onColorThemeChange(C)}e.registerThemingParticipant=f;class S extends k.Disposable{constructor(m){super();this.themeService=m,this.theme=m.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(g=>this.onThemeChange(g)))}onThemeChange(m){this.theme=m,this.updateStyles()}updateStyles(){}getColor(m,g){let c=this.theme.getColor(m);return c&&g&&(c=g(c,this.theme)),c?c.toString():null}}e.Themable=S}),define(re[225],se([0,1,50,7,155,106]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isUriComponents=e.terminalIconsEqual=e.terminalProfileArgsMatch=e.createProfileSchemaEnums=void 0;function A(v,y){const f=[{name:null,description:(0,k.localize)(0,null)}];return f.push(...v.map(S=>({name:S.profileName,description:b(S)}))),y&&f.push(...y.map(S=>({name:S.title,description:P(S)}))),{values:f.map(S=>S.name),markdownDescriptions:f.map(S=>S.description)}}e.createProfileSchemaEnums=A;function b(v){let y=`$(${L.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.profileName}
- path: ${v.path}`;return v.args&&(typeof v.args=="string"?y+=`
- args: "${v.args}"`:y+=`
- args: [${v.args.length===0?"":`'${v.args.join("','")}'`}]`),v.overrideName!==void 0&&(y+=`
- overrideName: ${v.overrideName}`),v.color&&(y+=`
- color: ${v.color}`),v.env&&(y+=`
- env: ${JSON.stringify(v.env)}`),y}function P(v){return`$(${L.ThemeIcon.isThemeIcon(v.icon)?v.icon.id:v.icon?v.icon:D.Codicon.terminal.id}) ${v.title}
- extensionIdentifier: ${v.extensionIdentifier}`}function I(v,y){if(!v&&!y)return!0;if(typeof v=="string"&&typeof y=="string")return v===y;if(Array.isArray(v)&&Array.isArray(y)){if(v.length!==y.length)return!1;for(let f=0;f<v.length;f++)if(v[f]!==y[f])return!1;return!0}return!1}e.terminalProfileArgsMatch=I;function E(v,y){if(!v&&!y)return!0;if(!v||!y)return!1;if(L.ThemeIcon.isThemeIcon(v)&&L.ThemeIcon.isThemeIcon(y))return v.id===y.id&&v.color===y.color;if(typeof v=="object"&&v&&"light"in v&&"dark"in v&&typeof y=="object"&&y&&"light"in y&&"dark"in y){const f=v,S=y;if((n.URI.isUri(f.light)||w(f.light))&&(n.URI.isUri(f.dark)||w(f.dark))&&(n.URI.isUri(S.light)||w(S.light))&&(n.URI.isUri(S.dark)||w(S.dark)))return f.light.path===S.light.path&&f.dark.path===S.dark.path}if(n.URI.isUri(v)&&n.URI.isUri(y)||w(v)||w(y)){const f=v,S=y;return f.path===S.path&&f.scheme===S.scheme}return!1}e.terminalIconsEqual=E;function w(v){return v?typeof v.path=="string"&&typeof v.scheme=="string":!1}e.isUriComponents=w}),define(re[226],se([0,1,50,154,42,40,225]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerTerminalDefaultProfileConfiguration=e.registerTerminalPlatformConfiguration=e.terminalIconSchema=e.terminalColorSchema=void 0,e.terminalColorSchema={type:["string","null"],enum:["terminal.ansiBlack","terminal.ansiRed","terminal.ansiGreen","terminal.ansiYellow","terminal.ansiBlue","terminal.ansiMagenta","terminal.ansiCyan","terminal.ansiWhite"],default:null},e.terminalIconSchema={type:"string",enum:Array.from(D.Codicon.getAll(),d=>d.id),markdownEnumDescriptions:Array.from(D.Codicon.getAll(),d=>`$(${d.id})`)};const b={args:{description:(0,n.localize)(0,null),type:"array",items:{type:"string"}},overrideName:{description:(0,n.localize)(1,null),type:"boolean"},icon:{description:(0,n.localize)(2,null),...e.terminalIconSchema},color:{description:(0,n.localize)(3,null),...e.terminalColorSchema},env:{markdownDescription:(0,n.localize)(4,null),type:"object",additionalProperties:{type:["string","null"]},default:{}}},P={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(5,null),type:["string","array"],items:{type:"string"}},...b}},I={type:"object",required:["path"],properties:{path:{description:(0,n.localize)(6,null),type:["string"],items:{type:"string"}},...b}},E=(0,n.localize)(7,null,"`#terminal.integrated.profiles.linux#`","`#terminal.integrated.defaultProfile.linux#`"),w=(0,n.localize)(8,null,"`#terminal.integrated.profiles.osx#`","`#terminal.integrated.defaultProfile.osx#`"),v=(0,n.localize)(9,null,"`#terminal.integrated.profiles.windows#`","`#terminal.integrated.defaultProfile.windows#`"),y=(0,n.localize)(10,null,"`#terminal.integrated.automationProfile.linux#`"),f=(0,n.localize)(11,null,"`#terminal.integrated.automationProfile.osx#`"),S=(0,n.localize)(12,null,"`#terminal.integrated.automationProfile.windows#`"),C={id:"terminal",order:100,title:(0,n.localize)(13,null),type:"object",properties:{["terminal.integrated.automationShell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(14,null,"`terminal.integrated.shell.linux`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:y},["terminal.integrated.automationShell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(15,null,"`terminal.integrated.shell.osx`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:f},["terminal.integrated.automationShell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(16,null,"`terminal.integrated.shell.windows`","`shellArgs`"),type:["string","null"],default:null,markdownDeprecationMessage:S},["terminal.integrated.automationProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(17,null,"`#terminal.integrated.automationShell.linux#`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(18,null,"`#terminal.integrated.automationShell.osx#`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.automationProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(19,null,"`#terminal.integrated.automationShell.windows#`"),type:["object","null"],default:null,anyOf:[{type:"null"},I],defaultSnippets:[{body:{path:"${1}",icon:"${2}"}}]},["terminal.integrated.shell.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(20,null),type:["string","null"],default:null,markdownDeprecationMessage:E},["terminal.integrated.shell.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(21,null),type:["string","null"],default:null,markdownDeprecationMessage:w},["terminal.integrated.shell.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(22,null),type:["string","null"],default:null,markdownDeprecationMessage:v},["terminal.integrated.shellArgs.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(23,null),type:"array",items:{type:"string"},default:[],markdownDeprecationMessage:E},["terminal.integrated.shellArgs.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(24,null),type:"array",items:{type:"string"},default:["-l"],markdownDeprecationMessage:w},["terminal.integrated.shellArgs.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(25,null),anyOf:[{type:"array",items:{type:"string",markdownDescription:(0,n.localize)(26,null)}},{type:"string",markdownDescription:(0,n.localize)(27,null)}],default:[],markdownDeprecationMessage:v},["terminal.integrated.profiles.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(28,null,"`source`","`path`","`args`","`null`",'`"Ubuntu-20.04 (WSL)": null`'),type:"object",default:{PowerShell:{source:"PowerShell",icon:"terminal-powershell"},"Command Prompt":{path:["${env:windir}\\Sysnative\\cmd.exe","${env:windir}\\System32\\cmd.exe"],args:[],icon:"terminal-cmd"},"Git Bash":{source:"Git Bash"}},additionalProperties:{anyOf:[{type:"object",required:["source"],properties:{source:{description:(0,n.localize)(29,null),enum:["PowerShell","Git Bash"]},...b}},{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(30,null),type:"string"},id:{description:(0,n.localize)(31,null),type:"string"},title:{description:(0,n.localize)(32,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.profiles.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(33,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",args:["-l"],icon:"terminal-bash"},zsh:{path:"zsh",args:["-l"]},fish:{path:"fish",args:["-l"]},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(34,null),type:"string"},id:{description:(0,n.localize)(35,null),type:"string"},title:{description:(0,n.localize)(36,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.profiles.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(37,null,"`path`","`args`","`null`",'`"bash": null`'),type:"object",default:{bash:{path:"bash",icon:"terminal-bash"},zsh:{path:"zsh"},fish:{path:"fish"},tmux:{path:"tmux",icon:"terminal-tmux"},pwsh:{path:"pwsh",icon:"terminal-powershell"}},additionalProperties:{anyOf:[{type:"object",required:["extensionIdentifier","id","title"],properties:{extensionIdentifier:{description:(0,n.localize)(38,null),type:"string"},id:{description:(0,n.localize)(39,null),type:"string"},title:{description:(0,n.localize)(40,null),type:"string"},...b}},{type:"null"},P]}},["terminal.integrated.useWslProfiles"]:{description:(0,n.localize)(41,null),type:"boolean",default:!0},["terminal.integrated.inheritEnv"]:{scope:1,description:(0,n.localize)(42,null),type:"boolean",default:!0},["terminal.integrated.persistentSessionScrollback"]:{scope:1,markdownDescription:(0,n.localize)(43,null),type:"number",default:100},["terminal.integrated.showLinkHover"]:{scope:1,description:(0,n.localize)(44,null),type:"boolean",default:!0},["terminal.integrated.ignoreProcessNames"]:{description:(0,n.localize)(45,null,"`terminal.integrated.confirmOnKill`"),type:"array",items:{type:"string",uniqueItems:!0},default:["starship","oh-my-posh","bash","zsh"]}}};function m(){L.Registry.as(k.Extensions.Configuration).registerConfiguration(C),c()}e.registerTerminalPlatformConfiguration=m;let g;function c(d,u){const s=L.Registry.as(k.Extensions.Configuration);let r;d&&(r=(0,A.createProfileSchemaEnums)(d?.profiles,u));const t=g;g={id:"terminal",order:100,title:(0,n.localize)(46,null),type:"object",properties:{["terminal.integrated.defaultProfile.linux"]:{restricted:!0,markdownDescription:(0,n.localize)(47,null,"`terminal.integrated.shell.linux`","`terminal.integrated.shellArgs.linux`"),type:["string","null"],default:null,enum:d?.os===3?r?.values:void 0,markdownEnumDescriptions:d?.os===3?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.osx"]:{restricted:!0,markdownDescription:(0,n.localize)(48,null,"`terminal.integrated.shell.osx`","`terminal.integrated.shellArgs.osx`"),type:["string","null"],default:null,enum:d?.os===2?r?.values:void 0,markdownEnumDescriptions:d?.os===2?r?.markdownDescriptions:void 0},["terminal.integrated.defaultProfile.windows"]:{restricted:!0,markdownDescription:(0,n.localize)(49,null,"`terminal.integrated.shell.windows`","`terminal.integrated.shellArgs.windows`"),type:["string","null"],default:null,enum:d?.os===1?r?.values:void 0,markdownEnumDescriptions:d?.os===1?r?.markdownDescriptions:void 0}}},s.updateConfigurations({add:[g],remove:t?[t]:[]})}e.registerTerminalDefaultProfileConfiguration=c}),define(re[227],se([0,1,54,50,10,4,27,82,223,106]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.detectAvailableProfiles=void 0;let E,w=!0;function v(r,t,i,o,l=process.env,a,h,p,R){return a=a||{existsFile:A.SymlinkSupport.existsFile,readFile:A.Promises.readFile},L.isWindows?y(i,a,l,h,o.getValue("terminal.integrated.useWslProfiles")!==!1,r&&typeof r=="object"?{...r}:o.getValue("terminal.integrated.profiles.windows"),typeof t=="string"?t:o.getValue("terminal.integrated.defaultProfile.windows"),R,p):d(a,h,i,r&&typeof r=="object"?{...r}:o.getValue(L.isLinux?"terminal.integrated.profiles.linux":"terminal.integrated.profiles.osx"),typeof t=="string"?t:o.getValue(L.isLinux?"terminal.integrated.defaultProfile.linux":"terminal.integrated.defaultProfile.osx"),R,p,l)}e.detectAvailableProfiles=v;async function y(r,t,i,o,l,a,h,p,R){const M=process.env.hasOwnProperty("PROCESSOR_ARCHITEW6432"),O=`${process.env.windir}\\${M?"Sysnative":"System32"}`;let F=!1;(0,P.getWindowsBuildNumber)()>=16299&&(F=!0),await C(p);const T=new Map;r&&(T.set("PowerShell",{source:"PowerShell",icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Windows PowerShell",{path:`${O}\\WindowsPowerShell\\v1.0\\powershell.exe`,icon:n.Codicon.terminalPowershell,isAutoDetected:!0}),T.set("Git Bash",{source:"Git Bash",isAutoDetected:!0}),T.set("Cygwin",{path:[`${process.env.HOMEDRIVE}\\cygwin64\\bin\\bash.exe`,`${process.env.HOMEDRIVE}\\cygwin\\bin\\bash.exe`],args:["--login"],isAutoDetected:!0}),T.set("Command Prompt",{path:`${O}\\cmd.exe`,icon:n.Codicon.terminalCmd,isAutoDetected:!0})),u(a,T);const N=await f(T.entries(),h,t,i,o,R);if(r||!r&&l)try{const W=await g(`${O}\\${F?"wsl":"bash"}.exe`,h);for(const V of W)(!a||!(V.profileName in a))&&N.push(V)}catch{w&&(o?.info("WSL is not installed, so could not detect WSL profiles"),w=!1)}return N}async function f(r,t,i,o=process.env,l,a){const h=[];for(const[p,R]of r){if(R===null)continue;let M,O,F;if("source"in R){const W=E?.get(R.source);if(!W)continue;M=W.paths,O=R.args||W.args,R.icon?F=S(R.icon):W.icon&&(F=W.icon)}else M=Array.isArray(R.path)?R.path:[R.path],O=L.isWindows||Array.isArray(R.args)?R.args:void 0,F=S(R.icon);const T=await a?.(M)||M.slice(),N=await s(p,t,T,i,o,O,R.env,R.overrideName,R.isAutoDetected,l);N?(N.isAutoDetected=R.isAutoDetected,N.icon=F,N.color=R.color,h.push(N)):l?.debug("Terminal profile not validated",p,M)}return l?.debug("Validated terminal profiles",h),h}function S(r){return typeof r=="string"?{id:r}:r}async function C(r){E&&!r||(E=new Map,E.set("Git Bash",{profileName:"Git Bash",paths:[`${process.env.ProgramW6432}\\Git\\bin\\bash.exe`,`${process.env.ProgramW6432}\\Git\\usr\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\bin\\bash.exe`,`${process.env.ProgramFiles}\\Git\\usr\\bin\\bash.exe`,`${process.env.LocalAppData}\\Programs\\Git\\bin\\bash.exe`,`${process.env.UserProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`,`${process.env.AllUsersProfile}\\scoop\\apps\\git-with-openssh\\current\\bin\\bash.exe`],args:["--login"]}),E.set("PowerShell",{profileName:"PowerShell",paths:r||await m(),icon:I.ThemeIcon.asThemeIcon(n.Codicon.terminalPowershell)}))}async function m(){const r=[];for await(const t of(0,b.enumeratePowerShellInstallations)())r.push(t.exePath);return r}async function g(r,t){const i=[],o=await new Promise((h,p)=>{D.exec("wsl.exe -l -q",{encoding:"utf16le",timeout:1e3},(R,M)=>{if(R)return p("Problem occurred when getting wsl distros");h(M)})});if(!o)return[];const l=new RegExp(/[\r?\n]/),a=o.split(l).filter(h=>h.trim().length>0&&h!=="");for(const h of a){if(h===""||h.startsWith("docker-desktop"))continue;const p=`${h} (WSL)`,R={profileName:p,path:r,args:["-d",`${h}`],isDefault:p===t,icon:c(h),isAutoDetected:!1};i.push(R)}return i}function c(r){return r.includes("Ubuntu")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalUbuntu):r.includes("Debian")?I.ThemeIcon.asThemeIcon(n.Codicon.terminalDebian):I.ThemeIcon.asThemeIcon(n.Codicon.terminalLinux)}async function d(r,t,i,o,l,a,h,p){const R=new Map;if(i){const M=(await r.readFile("/etc/shells")).toString(),O=a||M.split(`
`).filter(T=>T.trim().indexOf("#")!==0&&T.trim().length>0),F=new Map;for(const T of O){let N=(0,k.basename)(T),W=F.get(N)||0;W++,W>1&&(N=`${N} (${W})`),F.set(N,W),R.set(N,{path:T,isAutoDetected:!0})}}return u(o,R),await f(R.entries(),l,r,p,t,h)}function u(r,t){if(!!r)for(const[i,o]of Object.entries(r))o===null||!("path"in o)&&!("source"in o)?t.delete(i):(o.icon=o.icon||t.get(i)?.icon,t.set(i,o))}async function s(r,t,i,o,l,a,h,p,R,M){if(i.length===0)return Promise.resolve(void 0);const O=i.shift();if(O==="")return s(r,t,i,o,l,a,h,p,R);const F={profileName:r,path:O,args:a,env:h,overrideName:p,isAutoDetected:R,isDefault:r===t};if((0,k.basename)(O)===O){const N=l.PATH?l.PATH.split(k.delimiter):void 0,W=await(0,P.findExecutable)(O,void 0,N,void 0,o.existsFile);return W?(F.path=W,F.isFromPath=!0,F):s(r,t,i,o,l,a)}return await o.existsFile((0,k.normalize)(O))?F:s(r,t,i,o,l,a,h,p,R)}}),define(re[228],se([0,1,3,2,20,4,39,64,19,14,87,213,8,95,221,105,226,227]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.PtyHostService=void 0;var g;(function(u){u[u.MaxRestarts=5]="MaxRestarts"})(g||(g={}));let c=0,d=class extends n.Disposable{constructor(s,r,t,i){super();this._reconnectConstants=s,this._configurationService=r,this._environmentService=t,this._logService=i,this._restartCount=0,this._isResponsive=!0,this._isDisposed=!1,this._onPtyHostExit=this._register(new D.Emitter),this.onPtyHostExit=this._onPtyHostExit.event,this._onPtyHostStart=this._register(new D.Emitter),this.onPtyHostStart=this._onPtyHostStart.event,this._onPtyHostUnresponsive=this._register(new D.Emitter),this.onPtyHostUnresponsive=this._onPtyHostUnresponsive.event,this._onPtyHostResponsive=this._register(new D.Emitter),this.onPtyHostResponsive=this._onPtyHostResponsive.event,this._onPtyHostRequestResolveVariables=this._register(new D.Emitter),this.onPtyHostRequestResolveVariables=this._onPtyHostRequestResolveVariables.event,this._onProcessData=this._register(new D.Emitter),this.onProcessData=this._onProcessData.event,this._onProcessReady=this._register(new D.Emitter),this.onProcessReady=this._onProcessReady.event,this._onProcessReplay=this._register(new D.Emitter),this.onProcessReplay=this._onProcessReplay.event,this._onProcessOrphanQuestion=this._register(new D.Emitter),this.onProcessOrphanQuestion=this._onProcessOrphanQuestion.event,this._onDidRequestDetach=this._register(new D.Emitter),this.onDidRequestDetach=this._onDidRequestDetach.event,this._onDidChangeProperty=this._register(new D.Emitter),this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=this._register(new D.Emitter),this.onProcessExit=this._onProcessExit.event,(0,C.registerTerminalPlatformConfiguration)(),this._shellEnv=this._resolveShellEnv(),this._register((0,n.toDisposable)(()=>this._disposePtyHost())),this._resolveVariablesRequestStore=this._register(new f.RequestStore(void 0,this._logService)),this._resolveVariablesRequestStore.onCreateRequest(this._onPtyHostRequestResolveVariables.fire,this._onPtyHostRequestResolveVariables),[this._client,this._proxy]=this._startPtyHost(),this._register(this._configurationService.onDidChangeConfiguration(async o=>{o.affectsConfiguration("terminal.integrated.ignoreProcessNames")&&await this._refreshIgnoreProcessNames()}))}initialize(){this._refreshIgnoreProcessNames()}get _ignoreProcessNames(){return this._configurationService.getValue("terminal.integrated.ignoreProcessNames")}async _refreshIgnoreProcessNames(){return this._proxy.refreshIgnoreProcessNames?.(this._ignoreProcessNames)}async _resolveShellEnv(){if(L.isWindows)return process.env;try{return await(0,w.getResolvedShellEnv)(this._logService,{_:[]},process.env)}catch(s){return this._logService.error("ptyHost was unable to resolve shell environment",s),{}}}_startPtyHost(){const s={serverName:"Pty Host",args:["--type=ptyHost","--logsPath",this._environmentService.logsPath],env:{VSCODE_LAST_PTY_ID:c,VSCODE_AMD_ENTRYPOINT:"vs/platform/terminal/node/ptyHostMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true",VSCODE_RECONNECT_GRACE_TIME:this._reconnectConstants.graceTime,VSCODE_RECONNECT_SHORT_GRACE_TIME:this._reconnectConstants.shortGraceTime,VSCODE_RECONNECT_SCROLLBACK:this._reconnectConstants.scrollback}},r=(0,E.parsePtyHostPort)(this._environmentService.args,this._environmentService.isBuilt);r&&(r.break&&r.port?s.debugBrk=r.port:!r.break&&r.port&&(s.debug=r.port));const t=new b.Client(k.FileAccess.asFileUri("bootstrap-fork",X).fsPath,s);this._onPtyHostStart.fire(),A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.Heartbeat)).onBeat(()=>this._handleHeartbeat()),this._handleHeartbeat(),this._register(t.onDidProcessExit(a=>{this._onPtyHostExit.fire(a.code),this._isDisposed||(this._restartCount<=g.MaxRestarts?(this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}`),this._restartCount++,this.restartPtyHost()):this._logService.error(`ptyHost terminated unexpectedly with code ${a.code}, giving up`))}));const o=t.getChannel(S.TerminalIpcChannels.Log);y.LogLevelChannelClient.setLevel(o,this._logService.getLevel()),this._register(this._logService.onDidChangeLogLevel(()=>{y.LogLevelChannelClient.setLevel(o,this._logService.getLevel())}));const l=A.ProxyChannel.toService(t.getChannel(S.TerminalIpcChannels.PtyHost));return this._register(l.onProcessData(a=>this._onProcessData.fire(a))),this._register(l.onProcessReady(a=>this._onProcessReady.fire(a))),this._register(l.onProcessExit(a=>this._onProcessExit.fire(a))),this._register(l.onDidChangeProperty(a=>this._onDidChangeProperty.fire(a))),this._register(l.onProcessReplay(a=>this._onProcessReplay.fire(a))),this._register(l.onProcessOrphanQuestion(a=>this._onProcessOrphanQuestion.fire(a))),this._register(l.onDidRequestDetach(a=>this._onDidRequestDetach.fire(a))),[t,l]}dispose(){this._isDisposed=!0,super.dispose()}async createProcess(s,r,t,i,o,l,a,h,p,R,M){const O=setTimeout(()=>this._handleUnresponsiveCreateProcess(),S.HeartbeatConstants.CreateProcessTimeout),F=await this._proxy.createProcess(s,r,t,i,o,l,a,h,p,R,M);return clearTimeout(O),c=Math.max(c,F),F}updateTitle(s,r,t){return this._proxy.updateTitle(s,r,t)}updateIcon(s,r,t){return this._proxy.updateIcon(s,r,t)}attachToProcess(s){return this._proxy.attachToProcess(s)}detachFromProcess(s){return this._proxy.detachFromProcess(s)}listProcesses(){return this._proxy.listProcesses()}reduceConnectionGraceTime(){return this._proxy.reduceConnectionGraceTime()}start(s){return this._proxy.start(s)}shutdown(s,r){return this._proxy.shutdown(s,r)}input(s,r){return this._proxy.input(s,r)}processBinary(s,r){return this._proxy.processBinary(s,r)}resize(s,r,t){return this._proxy.resize(s,r,t)}acknowledgeDataEvent(s,r){return this._proxy.acknowledgeDataEvent(s,r)}setUnicodeVersion(s,r){return this._proxy.setUnicodeVersion(s,r)}getInitialCwd(s){return this._proxy.getInitialCwd(s)}getCwd(s){return this._proxy.getCwd(s)}getLatency(s){return this._proxy.getLatency(s)}orphanQuestionReply(s){return this._proxy.orphanQuestionReply(s)}installAutoReply(s,r){return this._proxy.installAutoReply(s,r)}uninstallAllAutoReplies(){return this._proxy.uninstallAllAutoReplies()}uninstallAutoReply(s){return this._proxy.uninstallAutoReply(s)}getDefaultSystemShell(s){return this._proxy.getDefaultSystemShell(s)}async getProfiles(s,r,t,i=!1){const o=await this._shellEnv;return(0,m.detectAvailableProfiles)(r,t,i,this._configurationService,o,void 0,this._logService,this._resolveVariables.bind(this,s))}getEnvironment(){return this._proxy.getEnvironment()}getWslPath(s){return this._proxy.getWslPath(s)}getRevivedPtyNewId(s){return this._proxy.getRevivedPtyNewId(s)}setTerminalLayoutInfo(s){return this._proxy.setTerminalLayoutInfo(s)}async getTerminalLayoutInfo(s){return await this._proxy.getTerminalLayoutInfo(s)}async requestDetachInstance(s,r){return this._proxy.requestDetachInstance(s,r)}async acceptDetachInstanceReply(s,r){return this._proxy.acceptDetachInstanceReply(s,r)}async serializeTerminalState(s){return this._proxy.serializeTerminalState(s)}async reviveTerminalProcesses(s,r){return this._proxy.reviveTerminalProcesses(s,r)}async refreshProperty(s,r){return this._proxy.refreshProperty(s,r)}async updateProperty(s,r,t){return this._proxy.updateProperty(s,r,t)}async restartPtyHost(){this._isResponsive=!0,this._disposePtyHost(),[this._client,this._proxy]=this._startPtyHost()}_disposePtyHost(){this._proxy.shutdownAll?.(),this._client.dispose()}_handleHeartbeat(){this._clearHeartbeatTimeouts(),this._heartbeatFirstTimeout=setTimeout(()=>this._handleHeartbeatFirstTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier),this._isResponsive||(this._isResponsive=!0,this._onPtyHostResponsive.fire())}_handleHeartbeatFirstTimeout(){this._logService.warn(`No ptyHost heartbeat after ${S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier/1e3} seconds`),this._heartbeatFirstTimeout=void 0,this._heartbeatSecondTimeout=setTimeout(()=>this._handleHeartbeatSecondTimeout(),S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.SecondWaitMultiplier)}_handleHeartbeatSecondTimeout(){this._logService.error(`No ptyHost heartbeat after ${(S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier+S.HeartbeatConstants.BeatInterval*S.HeartbeatConstants.FirstWaitMultiplier)/1e3} seconds`),this._heartbeatSecondTimeout=void 0,this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_handleUnresponsiveCreateProcess(){this._clearHeartbeatTimeouts(),this._logService.error(`No ptyHost response to createProcess after ${S.HeartbeatConstants.CreateProcessTimeout/1e3} seconds`),this._isResponsive&&(this._isResponsive=!1,this._onPtyHostUnresponsive.fire())}_clearHeartbeatTimeouts(){this._heartbeatFirstTimeout&&(clearTimeout(this._heartbeatFirstTimeout),this._heartbeatFirstTimeout=void 0),this._heartbeatSecondTimeout&&(clearTimeout(this._heartbeatSecondTimeout),this._heartbeatSecondTimeout=void 0)}_resolveVariables(s,r){return this._resolveVariablesRequestStore.createRequest({workspaceId:s,originalText:r})}async acceptPtyHostResolvedVariables(s,r){this._resolveVariablesRequestStore.acceptReply(s,r)}};d=me([G(1,P.IConfigurationService),G(2,I.IEnvironmentService),G(3,v.ILogService)],d),e.PtyHostService=d}),define(re[69],se([0,1,3,4,5,8]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,k.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,k.createDecorator)("sharedTunnelsService");var A;(function(S){S.Http="http",S.Https="https"})(A=e.TunnelProtocol||(e.TunnelProtocol={}));var b;(function(S){S.ConstantPrivate="constantPrivate",S.Private="private",S.Public="public"})(b=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var P;(function(S){S[S.Notify=1]="Notify",S[S.OpenBrowser=2]="OpenBrowser",S[S.OpenPreview=3]="OpenPreview",S[S.Silent=4]="Silent",S[S.Ignore=5]="Ignore",S[S.OpenBrowserOnce=6]="OpenBrowserOnce"})(P=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function I(S){if(S.scheme!=="http"&&S.scheme!=="https")return;const C=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(S.authority);if(!!C)return{address:C[1],port:+C[2]}}e.extractLocalHostUriMetaDataForPortMapping=I,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function E(S){return e.LOCALHOST_ADDRESSES.indexOf(S)>=0}e.isLocalhost=E,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function w(S){return e.ALL_INTERFACES_ADDRESSES.indexOf(S)>=0}e.isAllInterfaces=w;function v(S,C){return C?C!==1&&S<1024:!n.isWindows&&S<1024}e.isPortPrivileged=v;class y{constructor(C,m,g){this.remoteAddress=C,this.localAddress=m,this._dispose=g,this._onDispose=new D.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=y;let f=class{constructor(C){this.logService=C,this._onTunnelOpened=new D.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new D.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new D.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(C){return this._tunnelProvider=C,C?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(C){this._canElevate=C.elevation,this._privacyOptions=C.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const C=[],m=Array.from(this._tunnels.values());for(const g of m){const c=Array.from(g.values());for(const d of c){const u=await d.value;u&&C.push(u)}}return C}async dispose(){for(const C of this._tunnels.values()){for(const{value:m}of C.values())await m.then(g=>g?.dispose());C.clear()}this._tunnels.clear()}openTunnel(C,m,g,c,d=!1,u,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${m}:${g} on local port ${c}.`),!C)return;if(m||(m="localhost"),this._tunnelProvider&&this._factoryInProgress.has(g)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const r=this.retainOrCreateTunnel(C,m,g,c,d,u,s);return r?r.then(t=>{if(!t){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(m,g);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(t);return(t.tunnelRemoteHost!==m||t.tunnelRemotePort!==g)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),r)}makeTunnel(C){return{tunnelRemotePort:C.tunnelRemotePort,tunnelRemoteHost:C.tunnelRemoteHost,tunnelLocalPort:C.tunnelLocalPort,localAddress:C.localAddress,privacy:C.privacy,protocol:C.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${C.tunnelRemoteHost}:${C.tunnelRemotePort} `);const m=this._tunnels.get(C.tunnelRemoteHost);if(m){const g=m.get(C.tunnelRemotePort);g&&(g.refcount--,await this.tryDisposeTunnel(C.tunnelRemoteHost,C.tunnelRemotePort,g))}}}}async tryDisposeTunnel(C,m,g){if(g.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${C}:${m}.`);const c=g.value.then(async d=>{d&&(await d.dispose(!0),this._onTunnelClosed.fire({host:d.tunnelRemoteHost,port:d.tunnelRemotePort}))});return this._tunnels.has(C)&&this._tunnels.get(C).delete(m),c}}async closeTunnel(C,m){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${C}:${m} `);const g=this._tunnels.get(C);if(g&&g.has(m)){const c=g.get(m);c.refcount=0,await this.tryDisposeTunnel(C,m,c)}}addTunnelToMap(C,m,g){this._tunnels.has(C)||this._tunnels.set(C,new Map),this._tunnels.get(C).set(m,{refcount:1,value:g})}async removeEmptyTunnelFromMap(C,m){const g=this._tunnels.get(C);g&&(await g.get(m)||g.delete(m),g.size===0&&this._tunnels.delete(C))}getTunnelFromMap(C,m){const g=[C];E(C)?(g.push(...e.LOCALHOST_ADDRESSES),g.push(...e.ALL_INTERFACES_ADDRESSES)):w(C)&&g.push(...e.ALL_INTERFACES_ADDRESSES);const c=g.map(d=>this._tunnels.get(d));for(const d of c){const u=d?.get(m);if(u)return u}}canTunnel(C){return!!I(C)}createWithProvider(C,m,g,c,d,u,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${m}:${g} on local port ${c}.`);const r=g;this._factoryInProgress.add(r);const i={elevationRequired:d?v(c===void 0?g:c):!1},o={remoteAddress:{host:m,port:g},localAddressPort:c,privacy:u,public:u?u!==b.Private:void 0,protocol:s},l=C.forwardPort(o,i);return l?(this.addTunnelToMap(m,g,l),l.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(r)})):this._factoryInProgress.delete(r),l}};f=me([G(0,L.ILogService)],f),e.AbstractTunnelService=f}),define(re[229],se([0,1,8,69,2,9,6]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedProcessTunnelService=void 0;class b extends k.Disposable{constructor(){super();this._address=null,this._addressPromise=null}async getAddress(){return this._address?this._address:(this._addressPromise||(this._addressPromise=new A.DeferredPromise),this._addressPromise.p)}setAddress(E){this._address=E,this._addressPromise&&(this._addressPromise.complete(E),this._addressPromise=null)}setTunnel(E){this._register(E)}}let P=class Ct extends k.Disposable{constructor(E,w){super();this._tunnelService=E,this._logService=w,this._tunnels=new Map,this._disposedTunnels=new Set}dispose(){super.dispose(),this._tunnels.forEach(E=>E.dispose())}async createTunnel(){return{id:String(++Ct._lastId)}}async startTunnel(E,w,v,y,f,S){const C=new b,m=await Promise.resolve(this._tunnelService.openTunnel(E,C,v,y,f,S));if(!m)throw this._logService.info(`[SharedProcessTunnelService] Could not create a tunnel to ${v}:${y} (remote).`),C.dispose(),new Error("Could not create tunnel");if(this._disposedTunnels.has(w))throw this._disposedTunnels.delete(w),C.dispose(),await m.dispose(),(0,L.canceled)();return C.setTunnel(m),this._tunnels.set(w,C),this._logService.info(`[SharedProcessTunnelService] Created tunnel ${w}: ${m.localAddress} (local) to ${v}:${y} (remote).`),{tunnelLocalPort:m.tunnelLocalPort,localAddress:m.localAddress}}async setAddress(E,w){const v=this._tunnels.get(E);!v||v.setAddress(w)}async destroyTunnel(E){const w=this._tunnels.get(E);if(w){this._logService.info(`[SharedProcessTunnelService] Disposing tunnel ${E}.`),this._tunnels.delete(E),await w.dispose();return}this._disposedTunnels.add(E)}};P._lastId=0,P=me([G(0,n.ISharedTunnelsService),G(1,D.ILogService)],P),e.SharedProcessTunnelService=P}),define(re[230],se([0,1,76,115,204,6,2,19,8,24,202,69,100]),function(X,e,D,n,k,L,A,b,P,I,E,w,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SharedTunnelsService=e.TunnelService=e.BaseTunnelService=void 0;async function y(g,c,d,u,s){let r;for(let t=3;t&&(r?.dispose(),r=await new f(g,c,d,u,s).waitForReady(),!(s&&n.BROWSER_RESTRICTED_PORTS[s]||!n.BROWSER_RESTRICTED_PORTS[r.tunnelLocalPort]));t--);return r}class f extends A.Disposable{constructor(c,d,u,s,r){super();this.defaultTunnelHost=d,this.suggestedLocalPort=r,this.privacy=w.TunnelPrivacyId.Private,this._socketsDispose=new Map,this._options=c,this._server=D.createServer(),this._barrier=new L.Barrier,this._listeningListener=()=>this._barrier.open(),this._server.on("listening",this._listeningListener),this._connectionListener=t=>this._onConnection(t),this._server.on("connection",this._connectionListener),this._errorListener=()=>{},this._server.on("error",this._errorListener),this.tunnelRemotePort=s,this.tunnelRemoteHost=u}async dispose(){super.dispose(),this._server.removeListener("listening",this._listeningListener),this._server.removeListener("connection",this._connectionListener),this._server.removeListener("error",this._errorListener),this._server.close(),Array.from(this._socketsDispose.values()).forEach(d=>{d()})}async waitForReady(){let c=await(0,n.findFreePortFaster)(this.suggestedLocalPort??this.tunnelRemotePort,2,1e3),d=null;return this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address(),d||(c=0,this._server.listen(c,this.defaultTunnelHost),await this._barrier.wait(),d=this._server.address()),this.tunnelLocalPort=d.port,this.localAddress=`${this.tunnelRemoteHost==="127.0.0.1"?"127.0.0.1":"localhost"}:${d.port}`,this}async _onConnection(c){c.pause();const d=(0,w.isLocalhost)(this.tunnelRemoteHost)||(0,w.isAllInterfaces)(this.tunnelRemoteHost)?"localhost":this.tunnelRemoteHost,u=await(0,E.connectRemoteAgentTunnel)(this._options,d,this.tunnelRemotePort),s=u.getSocket().socket,r=u.readEntireBuffer();u.dispose(),r.byteLength>0&&c.write(r.buffer),c.on("end",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),s.end()}),c.on("close",()=>s.end()),c.on("error",()=>{c.localAddress&&this._socketsDispose.delete(c.localAddress),s.destroy()}),s.on("end",()=>c.end()),s.on("close",()=>c.end()),s.on("error",()=>{c.destroy()}),c.pipe(s),s.pipe(c),c.localAddress&&this._socketsDispose.set(c.localAddress,()=>{c.end(),s.end()})}}let S=class extends w.AbstractTunnelService{constructor(c,d,u,s,r){super(d);this.socketFactory=c,this.signService=u,this.productService=s,this.configurationService=r}get defaultTunnelHost(){const c=this.configurationService.getValue("remote.localPortHost");return!c||c==="localhost"?"127.0.0.1":"0.0.0.0"}retainOrCreateTunnel(c,d,u,s,r,t,i){const o=this.getTunnelFromMap(d,u);if(o)return++o.refcount,o.value;if(this._tunnelProvider)return this.createWithProvider(this._tunnelProvider,d,u,s,r,t,i);{this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel without provider ${d}:${u} on local port ${s}.`);const l={commit:this.productService.commit,quality:this.productService.quality,socketFactory:this.socketFactory,addressProvider:c,signService:this.signService,logService:this.logService,ipcLogger:null},a=y(l,this.defaultTunnelHost,d,u,s);return this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created without provider."),this.addTunnelToMap(d,u,a),a}}};S=me([G(1,P.ILogService),G(2,v.ISignService),G(3,I.IProductService),G(4,b.IConfigurationService)],S),e.BaseTunnelService=S;let C=class extends S{constructor(c,d,u,s){super(k.nodeSocketFactory,c,d,u,s)}};C=me([G(0,P.ILogService),G(1,v.ISignService),G(2,I.IProductService),G(3,b.IConfigurationService)],C),e.TunnelService=C;let m=class extends A.Disposable{constructor(c,d,u,s){super();this.logService=c,this.productService=d,this.signService=u,this.configurationService=s,this._tunnelServices=new Map}async openTunnel(c,d,u,s,r,t,i,o){if(this.logService.trace(`ForwardedPorts: (SharedTunnelService) openTunnel request for ${u}:${s} on local port ${r}.`),!this._tunnelServices.has(c)){const l=new C(this.logService,this.signService,this.productService,this.configurationService);this._register(l),this._tunnelServices.set(c,l),l.onTunnelClosed(async()=>{(await l.tunnels).length===0&&(l.dispose(),this._tunnelServices.delete(c))})}return this._tunnelServices.get(c).openTunnel(d,u,s,r,t,i,o)}};m=me([G(0,P.ILogService),G(1,I.IProductService),G(2,v.ISignService),G(3,b.IConfigurationService)],m),e.SharedTunnelsService=m}),define(re[33],se([0,1,5]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IUriIdentityService=void 0,e.IUriIdentityService=(0,D.createDecorator)("IUriIdentityService")}),define(re[231],se([0,1,3,2,7,14,32,13,8,33]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsWatcher=void 0;let E=class extends n.Disposable{constructor(v,y,f,S,C){super();this.extensionsManagementService=v,this.logService=S,this.uriIdentityService=C,this._onDidChangeExtensionsByAnotherSource=this._register(new D.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(g=>{this.installedExtensions=g.map(c=>c.identifier),this.startTimestamp=Date.now()}),this._register(v.onInstallExtension(g=>this.onInstallExtension(g))),this._register(v.onDidInstallExtensions(g=>this.onDidInstallExtensions(g))),this._register(v.onDidUninstallExtension(g=>this.onDidUninstallExtension(g)));const m=k.URI.file(f.extensionsPath);this._register(y.watch(m)),this._register(D.Event.filter(y.onDidFilesChange,g=>g.rawChanges.some(c=>this.doesChangeAffects(c,m)))(()=>this.onDidChange()))}doesChangeAffects(v,y){return v.type!==1&&v.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(v.resource),y)?!1:this.uriIdentityService.extUri.isEqual(v.resource,this.uriIdentityService.extUri.joinPath(y,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(v.resource).startsWith(".")}onInstallExtension(v){this.addInstallingExtension(v.identifier)}onDidInstallExtensions(v){for(const y of v)this.removeInstallingExtension(y.identifier),y.local&&this.addInstalledExtension(y.identifier)}onDidUninstallExtension(v){v.error||this.removeInstalledExtension(v.identifier)}addInstallingExtension(v){this.removeInstallingExtension(v),this.installingExtensions.push(v)}removeInstallingExtension(v){this.installingExtensions=this.installingExtensions.filter(y=>!(0,A.areSameExtensions)(y,v))}addInstalledExtension(v){this.installedExtensions&&(this.removeInstalledExtension(v),this.installedExtensions.push(v))}removeInstalledExtension(v){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(y=>!(0,A.areSameExtensions)(y,v)))}async onDidChange(){if(this.installedExtensions){const v=await this.extensionsManagementService.getInstalled(),y=v.filter(S=>[...this.installingExtensions,...this.installedExtensions].some(C=>(0,A.areSameExtensions)(C,S.identifier))?!1:S.installedTimestamp&&S.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",S.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",S.identifier.id),!1)),f=this.installedExtensions.filter(S=>this.installingExtensions.some(C=>(0,A.areSameExtensions)(C,S))?!1:v.every(C=>!(0,A.areSameExtensions)(C.identifier,S))?(this.logService.info("Detected extension removed from another source",S.id),!0):!1);this.installedExtensions=v.map(S=>S.identifier),(y.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:y,removed:f})}}};E=me([G(1,b.IFileService),G(2,L.INativeEnvironmentService),G(3,P.ILogService),G(4,I.IUriIdentityService)],E),e.ExtensionsWatcher=E}),define(re[232],se([0,1,33,88,13,17,113,3,2]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UriIdentityService=void 0;class I{constructor(v){this.uri=v,this.time=I._clock++}touch(){return this.time=I._clock++,this}}I._clock=0;let E=class{constructor(v){this._fileService=v,this._dispooables=new P.DisposableStore,this._limit=2**16;const y=new Map,f=S=>{let C=y.get(S.scheme);return C===void 0&&(C=v.hasProvider(S)&&!this._fileService.hasCapability(S,1024),y.set(S.scheme,C)),C};this._dispooables.add(b.Event.any(v.onDidChangeFileSystemProviderRegistrations,v.onDidChangeFileSystemProviderCapabilities)(S=>{y.delete(S.scheme)})),this.extUri=new L.ExtUri(f),this._canonicalUris=new A.SkipList((S,C)=>this.extUri.compare(S,C,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(v){this._fileService.hasProvider(v)&&(v=(0,L.normalizePath)(v));const y=this._canonicalUris.get(v);return y?y.touch().uri.with({fragment:v.fragment}):(this._canonicalUris.set(v,new I(v)),this._checkTrim(),v)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const v=[...this._canonicalUris.entries()].sort((f,S)=>f[1].touch<S[1].touch?1:f[1].touch>S[1].touch?-1:0);I._clock=0,this._canonicalUris.clear();const y=this._limit*.5;for(let f=0;f<y;f++)this._canonicalUris.set(v[f][0],v[f][1].touch())}};E=me([G(0,k.IFileService)],E),e.UriIdentityService=E,(0,n.registerSingleton)(D.IUriIdentityService,E,!0)}),define(re[233],se([0,1,3,2,13,41,34,16]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileUserDataProvider=void 0;class P extends n.Disposable{constructor(E,w,v,y){super();this.fileSystemScheme=E,this.fileSystemProvider=w,this.userDataScheme=v,this.logService=y,this.onDidChangeCapabilities=this.fileSystemProvider.onDidChangeCapabilities,this._onDidChangeFile=this._register(new D.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this.watchResources=A.TernarySearchTree.forUris(()=>!(this.capabilities&1024)),this._register(this.fileSystemProvider.onDidChangeFile(f=>this.handleFileChanges(f)))}get capabilities(){return this.fileSystemProvider.capabilities&~4}watch(E,w){this.watchResources.set(E,E);const v=this.fileSystemProvider.watch(this.toFileSystemResource(E),w);return(0,n.toDisposable)(()=>{this.watchResources.delete(E),v.dispose()})}stat(E){return this.fileSystemProvider.stat(this.toFileSystemResource(E))}mkdir(E){return this.fileSystemProvider.mkdir(this.toFileSystemResource(E))}rename(E,w,v){return this.fileSystemProvider.rename(this.toFileSystemResource(E),this.toFileSystemResource(w),v)}readFile(E){return this.fileSystemProvider.readFile(this.toFileSystemResource(E),{atomic:!0})}readFileStream(E,w,v){const y=(0,L.newWriteableStream)(f=>b.VSBuffer.concat(f.map(S=>b.VSBuffer.wrap(S))).buffer);return(async()=>{try{const f=await this.readFile(E);y.end(f)}catch(f){y.error(f),y.end()}})(),y}readdir(E){return this.fileSystemProvider.readdir(this.toFileSystemResource(E))}writeFile(E,w,v){return this.fileSystemProvider.writeFile(this.toFileSystemResource(E),w,v)}delete(E,w){return this.fileSystemProvider.delete(this.toFileSystemResource(E),w)}copy(E,w,v){if((0,k.hasFileFolderCopyCapability)(this.fileSystemProvider))return this.fileSystemProvider.copy(this.toFileSystemResource(E),this.toFileSystemResource(w),v);throw new Error("copy not supported")}handleFileChanges(E){const w=[];for(const v of E){if(v.resource.scheme!==this.fileSystemScheme)continue;const y=this.toUserDataResource(v.resource);this.watchResources.findSubstr(y)&&w.push({resource:y,type:v.type})}w.length&&(this.logService.debug("User data changed"),this._onDidChangeFile.fire(w))}toFileSystemResource(E){return E.with({scheme:this.fileSystemScheme})}toUserDataResource(E){return E.with({scheme:this.userDataScheme})}}e.FileUserDataProvider=P}),define(re[59],se([0,1,75]),function(X,e,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLineEndOffset=e.getLineStartOffset=e.edit=void 0;function n(A,b,P,I){const E=(0,D.setProperty)(A,b,P,I)[0];return E&&(A=A.substring(0,E.offset)+E.content+A.substring(E.offset+E.length)),A}e.edit=n;function k(A,b,P){let I=P;for(;I>=0;){if(A.charAt(I)===b.charAt(b.length-1)&&b.length===1)return I+1;if(I--,b.length===2&&I>=0&&A.charAt(I)===b.charAt(0))return I+2}return 0}e.getLineStartOffset=k;function L(A,b,P){let I=P;for(;I>=0;)if(A.charAt(I)===b.charAt(b.length-1)&&b.length===1||(I++,b.length===2&&I>=0&&A.charAt(I)===b.charAt(1)))return I;return A.length-1}e.getLineEndOffset=L}),define(re[234],se([0,1,31,55,15]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function L(v,y,f,S,C){const m=[],g=[],c=[];if(!y){const O=v.filter(({identifier:F})=>C.every(T=>T.toLowerCase()!==F.id.toLowerCase()));return{local:{added:m,removed:g,updated:c},remote:O.length>0?{added:O,updated:[],removed:[],all:O}:null}}v=v.map(E),y=y.map(E),f=f?f.map(E):null;const d=new Map,u=O=>{O.uuid&&d.set(O.id.toLowerCase(),O.uuid)};v.forEach(({identifier:O})=>u(O)),y.forEach(({identifier:O})=>u(O)),f?.forEach(({identifier:O})=>u(O));const s=O=>{const F=O.identifier.uuid||d.get(O.identifier.id.toLowerCase());return F?`uuid:${F}`:`id:${O.identifier.id.toLowerCase()}`},r=(O,F)=>(O.set(s(F),F),O),t=v.reduce(r,new Map),i=y.reduce(r,new Map),o=y.reduce((O,F)=>{const T=s(F);F=(0,D.deepClone)(F);const N=t.get(T);return N&&(N.installed&&(F.installed=!0),F.version||(F.version=N.version)),r(O,F)},new Map),l=f?f.reduce(r,new Map):null,a=S.reduce(r,new Map),h=C.reduce((O,F)=>{const T=d.get(F.toLowerCase());return O.add(T?`uuid:${T}`:`id:${F.toLowerCase()}`)},new Set),p=A(t,i,h);if(p.added.size>0||p.removed.size>0||p.updated.size>0){const O=A(l,t,h),F=A(l,i,h),T=(N,W)=>{const V=t.get(N);if(V){const Y=i.get(N),$=W?Y:V;return{...$,version:Y.version&&(!V.installed||n.gt(Y.version,V.version))?Y.version:V.version,state:b(V,Y,l?.get(N)),preRelease:(0,k.isUndefined)($.preRelease)?V.preRelease:V.installed?$.preRelease:Y.preRelease}}};for(const N of F.removed.values()){const W=t.get(N);W&&g.push(W.identifier)}for(const N of F.added.values())if(O.added.has(N)){if(p.updated.has(N)){const W=T(N,!0);W&&(c.push(w(W,N)),o.set(N,W))}}else{const W=i.get(N);W.installed&&m.push(w(W,N))}for(const N of F.updated.values()){const W=T(N,!0);W&&(c.push(w(W,N)),o.set(N,W))}for(const N of O.added.values())F.added.has(N)||o.set(N,t.get(N));for(const N of O.updated.values())if(!F.removed.has(N)&&!F.updated.has(N)){const W=T(N,!1);W&&(o.get(N)?.installed&&(W.installed=!0),o.set(N,W))}for(const N of O.removed.values())!a.has(N)&&!F.updated.has(N)&&l?.get(N)?.installed&&o.delete(N)}const R=[],M=A(i,o,new Set,{checkInstalledProperty:!0,checkVersionProperty:!0});return(M.added.size>0||M.updated.size>0||M.removed.size>0)&&o.forEach((O,F)=>R.push(w(O,F))),{local:{added:m,removed:g,updated:c},remote:R.length?{added:[...M.added].map(O=>o.get(O)),updated:[...M.updated].map(O=>o.get(O)),removed:[...M.removed].map(O=>i.get(O)),all:R}:null}}e.merge=L;function A(v,y,f,{checkInstalledProperty:S,checkVersionProperty:C}={checkInstalledProperty:!1,checkVersionProperty:!1}){const m=v?[...v.keys()].filter(s=>!f.has(s)):[],g=[...y.keys()].filter(s=>!f.has(s)),c=g.filter(s=>m.indexOf(s)===-1).reduce((s,r)=>(s.add(r),s),new Set),d=m.filter(s=>g.indexOf(s)===-1).reduce((s,r)=>(s.add(r),s),new Set),u=new Set;for(const s of m){if(d.has(s))continue;const r=v.get(s),t=y.get(s);(!t||r.disabled!==t.disabled||r.installed&&t.installed&&r.preRelease!==t.preRelease||!I(r.state,t.state)||C&&r.version!==t.version||S&&r.installed!==t.installed)&&u.add(s)}return{added:c,removed:d,updated:u}}function b(v,y,f){const S=v.state,C=y.state,m=f?.state;if(!y.version||S&&n.gt(v.version,y.version))return S;if(C&&n.gt(y.version,v.version)||!S)return C;if(!C)return S;const g=(0,D.deepClone)(S),c=m?P(m,C):{added:Object.keys(C).reduce((u,s)=>(u.add(s),u),new Set),removed:new Set,updated:new Set},d=m?P(m,S):{added:Object.keys(S).reduce((u,s)=>(u.add(s),u),new Set),removed:new Set,updated:new Set};for(const u of[...c.added.values(),...c.updated.values()])g[u]=C[u];for(const u of c.removed.values())d.updated.has(u)||delete g[u];return g}function P(v,y){const f=Object.keys(v),S=Object.keys(y),C=S.filter(c=>f.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),m=f.filter(c=>S.indexOf(c)===-1).reduce((c,d)=>(c.add(d),c),new Set),g=new Set;for(const c of f){if(m.has(c))continue;const d=v[c],u=y[c];(0,D.equals)(d,u)||g.add(c)}return{added:C,removed:m,updated:g}}function I(v={},y={}){const{added:f,removed:S,updated:C}=P(v,y);return f.size===0&&S.size===0&&C.size===0}function E(v){return{...v,disabled:!!v.disabled,installed:!!v.installed}}function w(v,y){const f={identifier:{id:v.identifier.id,uuid:y.startsWith("uuid:")?y.substring("uuid:".length):void 0},preRelease:!!v.preRelease};return v.version&&(f.version=v.version),v.disabled&&(f.disabled=!0),v.installed&&(f.installed=!0),v.state&&(f.state=v.state),f}}),define(re[107],se([0,1,18,19,5]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IgnoredExtensionsManagementService=e.IIgnoredExtensionsManagementService=void 0,e.IIgnoredExtensionsManagementService=(0,k.createDecorator)("IIgnoredExtensionsManagementService");let L=class{constructor(b){this.configurationService=b}hasToNeverSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(b.toLowerCase())}hasToAlwaysSyncExtension(b){return this.getConfiguredIgnoredExtensions().includes(`-${b.toLowerCase()}`)}updateIgnoredExtensions(b,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==b&&E!==`-${b}`),P&&I.push(b.toLowerCase()),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}updateSynchronizedExtensions(b,P){let I=[...this.configurationService.getValue("settingsSync.ignoredExtensions")].map(E=>E.toLowerCase());return I=I.filter(E=>E!==b&&E!==`-${b}`),P&&I.push(`-${b.toLowerCase()}`),this.configurationService.updateValue("settingsSync.ignoredExtensions",I.length?I:void 0,2)}getIgnoredExtensions(b){const P=b.filter(v=>v.isMachineScoped).map(v=>v.identifier.id.toLowerCase()),I=this.getConfiguredIgnoredExtensions().map(v=>v.toLowerCase()),E=[],w=[];if(Array.isArray(I))for(const v of I)v.startsWith("-")?w.push(v.substring(1)):E.push(v);return(0,D.distinct)([...P,...E].filter(v=>w.indexOf(v)===-1))}getConfiguredIgnoredExtensions(){let b=this.configurationService.inspect("settingsSync.ignoredExtensions").userValue;return b!==void 0||(b=this.configurationService.inspect("sync.ignoredExtensions").userValue,b!==void 0)?b:(this.configurationService.getValue("settingsSync.ignoredExtensions")||[]).map(P=>P.toLowerCase())}};L=me([G(0,n.IConfigurationService)],L),e.IgnoredExtensionsManagementService=L}),define(re[235],se([0,1,18,35,31,172,59]),function(X,e,D,n,k,L,A){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=e.parseKeybindings=void 0;function b(d){return(0,n.parse)(d)||[]}e.parseKeybindings=b;async function P(d,u,s,r,t){const i=b(d),o=b(u),l=s?b(s):null,a=[...i,...o,...l||[]].map(Y=>Y.key),h=await t.resolveUserBindings(a),p=E(i,o,l,h);if(!p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:d,hasChanges:!1,hasConflicts:!1};if(!p.hasLocalForwarded&&p.hasRemoteForwarded)return{mergeContent:u,hasChanges:!0,hasConflicts:!1};if(p.hasLocalForwarded&&!p.hasRemoteForwarded)return{mergeContent:d,hasChanges:!0,hasConflicts:!1};const R=v(i),M=v(o),O=l?v(l):null,F=f(R,M,h),T=O?f(O,R,h):{added:[...R.keys()].reduce((Y,$)=>(Y.add($),Y),new Set),removed:new Set,updated:new Set},N=O?f(O,M,h):{added:[...M.keys()].reduce((Y,$)=>(Y.add($),Y),new Set),removed:new Set,updated:new Set},W=I(F,T,N);let V=d;for(const Y of W.removed.values())W.conflicts.has(Y)||(V=g(V,Y,r));for(const Y of W.added.values()){if(W.conflicts.has(Y))continue;const $=M.get(Y);if($.some(J=>J.command!==`-${Y}`&&p.conflicts.has(h[J.key]))){W.conflicts.add(Y);continue}V=m(V,$,r)}for(const Y of W.updated.values()){if(W.conflicts.has(Y))continue;const $=M.get(Y);if($.some(J=>J.command!==`-${Y}`&&p.conflicts.has(h[J.key]))){W.conflicts.add(Y);continue}V=c(V,Y,$,r)}return{mergeContent:V,hasChanges:!0,hasConflicts:W.conflicts.size>0}}e.merge=P;function I(d,u,s){const r=new Set,t=new Set,i=new Set,o=new Set;for(const l of u.removed.values())s.updated.has(l)&&o.add(l);for(const l of s.removed.values())o.has(l)||(u.updated.has(l)?o.add(l):t.add(l));for(const l of u.added.values())o.has(l)||s.added.has(l)&&d.updated.has(l)&&o.add(l);for(const l of s.added.values())o.has(l)||(u.added.has(l)?d.updated.has(l)&&o.add(l):r.add(l));for(const l of u.updated.values())o.has(l)||s.updated.has(l)&&d.updated.has(l)&&o.add(l);for(const l of s.updated.values())o.has(l)||(u.updated.has(l)?d.updated.has(l)&&o.add(l):i.add(l));return{added:r,removed:t,updated:i,conflicts:o}}function E(d,u,s,r){const t=new Set,i=w(d,r),o=w(u,r),l=s?w(s,r):null,a=y(i,o);if(a.added.size===0&&a.removed.size===0&&a.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const h=l?y(l,i):{added:[...i.keys()].reduce((T,N)=>(T.add(N),T),new Set),removed:new Set,updated:new Set};if(h.added.size===0&&h.removed.size===0&&h.updated.size===0)return{hasLocalForwarded:!1,hasRemoteForwarded:!0,added:t,removed:t,updated:t,conflicts:t};const p=l?y(l,o):{added:[...o.keys()].reduce((T,N)=>(T.add(N),T),new Set),removed:new Set,updated:new Set};if(p.added.size===0&&p.removed.size===0&&p.updated.size===0)return{hasLocalForwarded:!0,hasRemoteForwarded:!1,added:t,removed:t,updated:t,conflicts:t};const{added:R,removed:M,updated:O,conflicts:F}=I(a,h,p);return{hasLocalForwarded:!0,hasRemoteForwarded:!0,added:R,removed:M,updated:O,conflicts:F}}function w(d,u){const s=new Map;for(const r of d){const t=u[r.key];let i=s.get(t);i||(i=[],s.set(t,i)),i.push(r)}return s}function v(d){const u=new Map;for(const s of d){const r=s.command[0]==="-"?s.command.substring(1):s.command;let t=u.get(r);t||(t=[],u.set(r,t)),t.push(s)}return u}function y(d,u){const s=[...d.keys()],r=[...u.keys()],t=r.filter(l=>s.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),i=s.filter(l=>r.indexOf(l)===-1).reduce((l,a)=>(l.add(a),l),new Set),o=new Set;for(const l of s){if(i.has(l))continue;const a=d.get(l).map(p=>({...p,key:l})),h=u.get(l).map(p=>({...p,key:l}));(0,D.equals)(a,h,(p,R)=>C(p,R))||o.add(l)}return{added:t,removed:i,updated:o}}function f(d,u,s){const r=[...d.keys()],t=[...u.keys()],i=t.filter(a=>r.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),o=r.filter(a=>t.indexOf(a)===-1).reduce((a,h)=>(a.add(h),a),new Set),l=new Set;for(const a of r){if(o.has(a))continue;const h=d.get(a).map(R=>({...R,key:s[R.key]})),p=u.get(a).map(R=>({...R,key:s[R.key]}));S(h,p)||l.add(a)}return{added:i,removed:o,updated:l}}function S(d,u){return!(!(0,D.equals)(d.filter(({command:s})=>s[0]!=="-"),u.filter(({command:s})=>s[0]!=="-"),(s,r)=>C(s,r))||!(0,D.equals)(d.filter(({command:s})=>s[0]==="-"),u.filter(({command:s})=>s[0]==="-"),(s,r)=>C(s,r)))}function C(d,u){if(d.command!==u.command||d.key!==u.key)return!1;const s=L.ContextKeyExpr.deserialize(d.when),r=L.ContextKeyExpr.deserialize(u.when);return!(s&&!r||!s&&r||s&&r&&!s.equals(r)||!k.equals(d.args,u.args))}function m(d,u,s){for(const r of u)d=A.edit(d,[-1],r,s);return d}function g(d,u,s){const r=b(d);for(let t=r.length-1;t>=0;t--)(r[t].command===u||r[t].command===`-${u}`)&&(d=A.edit(d,[t],void 0,s));return d}function c(d,u,s,r){const t=b(d),i=t.findIndex(o=>o.command===u||o.command===`-${u}`);for(let o=t.length-1;o>=0;o--)(t[o].command===u||t[o].command===`-${u}`)&&(d=A.edit(d,[o],void 0,r));for(let o=s.length-1;o>=0;o--)d=A.edit(d,[i],s[o],r);return d}}),define(re[236],se([0,1]),function(X,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.areSame=e.merge=void 0;function D(L,A,b){const P={},I={},E=new Set;if(!A)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:L,updated:{},removed:[]},conflicts:[]};const w=n(L,A);if(w.added.size===0&&w.removed.size===0&&w.updated.size===0)return{local:{added:P,updated:I,removed:[...E.values()]},remote:{added:{},updated:{},removed:[]},conflicts:[]};const v=n(b,L),y=n(b,A),f={},S={},C=new Set,m=new Set;for(const g of v.removed.values())y.updated.has(g)?P[g]=A[g]:C.add(g);for(const g of y.removed.values())m.has(g)||(v.updated.has(g)?m.add(g):E.add(g));for(const g of v.updated.values())m.has(g)||(y.updated.has(g)?w.updated.has(g)&&m.add(g):S[g]=L[g]);for(const g of y.updated.values())m.has(g)||(v.updated.has(g)?w.updated.has(g)&&m.add(g):L[g]!==void 0&&(I[g]=A[g]));for(const g of v.added.values())m.has(g)||(y.added.has(g)?w.updated.has(g)&&m.add(g):f[g]=L[g]);for(const g of y.added.values())m.has(g)||(v.added.has(g)?w.updated.has(g)&&m.add(g):P[g]=A[g]);return{local:{added:P,removed:[...E.values()],updated:I},remote:{added:f,removed:[...C.values()],updated:S},conflicts:[...m.values()]}}e.merge=D;function n(L,A){const b=L?Object.keys(L):[],P=A?Object.keys(A):[],I=P.filter(v=>b.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),E=b.filter(v=>P.indexOf(v)===-1).reduce((v,y)=>(v.add(y),v),new Set),w=new Set;for(const v of b){if(E.has(v))continue;const y=L[v],f=A[v];y!==f&&w.add(v)}return{added:I,removed:E,updated:w}}function k(L,A){const{added:b,removed:P,updated:I}=n(L,A);return b.size===0&&P.size===0&&I.size===0}e.areSame=k}),define(re[25],se([0,1,18,17,15,161,42,28,5,97,40]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSyncResourceFromLocalPreview=e.PREVIEW_DIR_NAME=e.USER_DATA_SYNC_SCHEME=e.IUserDataSyncLogService=e.IUserDataSyncUtilService=e.IUserDataAutoSyncService=e.IUserDataSyncService=e.IUserDataSyncEnablementService=e.getEnablementKey=e.SYNC_SERVICE_URL_TYPE=e.MergeState=e.Change=e.SyncStatus=e.UserDataAutoSyncError=e.UserDataSyncStoreError=e.UserDataSyncError=e.UserDataSyncErrorCode=e.createSyncHeaders=e.HEADER_EXECUTION_ID=e.HEADER_OPERATION_ID=e.IUserDataSyncBackupStoreService=e.IUserDataSyncStoreService=e.IUserDataSyncStoreManagementService=e.getLastSyncResourceUri=e.ALL_SYNC_RESOURCES=e.SyncResource=e.isAuthenticationProvider=e.registerConfiguration=e.USER_DATA_SYNC_CONFIGURATION_SCOPE=e.getDefaultIgnoredSettings=e.getDisallowedIgnoredSettings=e.CONFIGURATION_SYNC_STORE_KEY=void 0,e.CONFIGURATION_SYNC_STORE_KEY="configurationSync.store";function w(){const l=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties();return Object.keys(l).filter(a=>!!l[a].disallowSyncIgnore)}e.getDisallowedIgnoredSettings=w;function v(){const l=E.Registry.as(A.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(l).filter(R=>!!l[R].ignoreSync),h=Object.keys(l).filter(R=>l[R].scope===2||l[R].scope===6),p=w();return(0,D.distinct)([e.CONFIGURATION_SYNC_STORE_KEY,...a,...h,...p])}e.getDefaultIgnoredSettings=v,e.USER_DATA_SYNC_CONFIGURATION_SCOPE="settingsSync";function y(){const l="vscode://schemas/ignoredSettings",a=E.Registry.as(A.Extensions.Configuration);a.registerConfiguration({id:"settingsSync",order:30,title:(0,L.localize)(0,null),type:"object",properties:{"settingsSync.keybindingsPerPlatform":{type:"boolean",description:(0,L.localize)(1,null),default:!0,scope:1,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredExtensions":{type:"array",markdownDescription:(0,L.localize)(2,null),items:[{type:"string",pattern:b.EXTENSION_IDENTIFIER_PATTERN,errorMessage:(0,L.localize)(3,null)}],default:[],scope:1,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]},"settingsSync.ignoredSettings":{type:"array",description:(0,L.localize)(4,null),default:[],scope:1,$ref:l,additionalProperties:!0,uniqueItems:!0,disallowSyncIgnore:!0,tags:["sync","usesOnlineServices"]}}});const h=E.Registry.as(I.Extensions.JSONContribution),p=()=>{const R=w(),M=v().filter(N=>N!==e.CONFIGURATION_SYNC_STORE_KEY),O=Object.keys(A.allSettings.properties).filter(N=>M.indexOf(N)===-1),F=M.filter(N=>R.indexOf(N)===-1),T={items:{type:"string",enum:[...O,...F.map(N=>`-${N}`)]}};h.registerSchema(l,T)};return a.onDidUpdateConfiguration(()=>p())}e.registerConfiguration=y;function f(l){return l&&(0,k.isObject)(l)&&(0,k.isString)(l.id)&&Array.isArray(l.scopes)}e.isAuthenticationProvider=f;var S;(function(l){l.Settings="settings",l.Keybindings="keybindings",l.Snippets="snippets",l.Tasks="tasks",l.Extensions="extensions",l.GlobalState="globalState"})(S=e.SyncResource||(e.SyncResource={})),e.ALL_SYNC_RESOURCES=["settings","keybindings","snippets","tasks","extensions","globalState"];function C(l,a,h){return h.joinPath(a.userDataSyncHome,l,`lastSync${l}.json`)}e.getLastSyncResourceUri=C,e.IUserDataSyncStoreManagementService=(0,P.createDecorator)("IUserDataSyncStoreManagementService"),e.IUserDataSyncStoreService=(0,P.createDecorator)("IUserDataSyncStoreService"),e.IUserDataSyncBackupStoreService=(0,P.createDecorator)("IUserDataSyncBackupStoreService"),e.HEADER_OPERATION_ID="x-operation-id",e.HEADER_EXECUTION_ID="X-Execution-Id";function m(l){const a={};return a[e.HEADER_EXECUTION_ID]=l,a}e.createSyncHeaders=m;var g;(function(l){l.Unauthorized="Unauthorized",l.Conflict="Conflict",l.Gone="Gone",l.PreconditionFailed="PreconditionFailed",l.TooLarge="TooLarge",l.UpgradeRequired="UpgradeRequired",l.PreconditionRequired="PreconditionRequired",l.TooManyRequests="RemoteTooManyRequests",l.TooManyRequestsAndRetryAfter="TooManyRequestsAndRetryAfter",l.RequestFailed="RequestFailed",l.RequestCanceled="RequestCanceled",l.RequestTimeout="RequestTimeout",l.RequestProtocolNotSupported="RequestProtocolNotSupported",l.RequestPathNotEscaped="RequestPathNotEscaped",l.RequestHeadersNotObject="RequestHeadersNotObject",l.NoRef="NoRef",l.EmptyResponse="EmptyResponse",l.TurnedOff="TurnedOff",l.SessionExpired="SessionExpired",l.ServiceChanged="ServiceChanged",l.DefaultServiceChanged="DefaultServiceChanged",l.LocalTooManyRequests="LocalTooManyRequests",l.LocalPreconditionFailed="LocalPreconditionFailed",l.LocalInvalidContent="LocalInvalidContent",l.LocalError="LocalError",l.IncompatibleLocalContent="IncompatibleLocalContent",l.IncompatibleRemoteContent="IncompatibleRemoteContent",l.UnresolvedConflicts="UnresolvedConflicts",l.Unknown="Unknown"})(g=e.UserDataSyncErrorCode||(e.UserDataSyncErrorCode={}));class c extends Error{constructor(a,h,p,R){super(a);this.code=h,this.resource=p,this.operationId=R,this.name=`${this.code} (UserDataSyncError) syncResource:${this.resource||"unknown"} operationId:${this.operationId||"unknown"}`}}e.UserDataSyncError=c;class d extends c{constructor(a,h,p,R,M){super(a,p,void 0,M);this.url=h,this.serverCode=R}}e.UserDataSyncStoreError=d;class u extends c{constructor(a,h){super(a,h)}}e.UserDataAutoSyncError=u,function(l){function a(h){if(h instanceof l)return h;const p=/^(.+) \(UserDataSyncError\) syncResource:(.+) operationId:(.+)$/.exec(h.name);if(p&&p[1]){const R=p[2]==="unknown"?void 0:p[2],M=p[3]==="unknown"?void 0:p[3];return new l(h.message,p[1],R,M)}return new l(h.message,"Unknown")}l.toUserDataSyncError=a}(c=e.UserDataSyncError||(e.UserDataSyncError={}));var s;(function(l){l.Uninitialized="uninitialized",l.Idle="idle",l.Syncing="syncing",l.HasConflicts="hasConflicts"})(s=e.SyncStatus||(e.SyncStatus={}));var r;(function(l){l[l.None=0]="None",l[l.Added=1]="Added",l[l.Modified=2]="Modified",l[l.Deleted=3]="Deleted"})(r=e.Change||(e.Change={}));var t;(function(l){l.Preview="preview",l.Conflict="conflict",l.Accepted="accepted"})(t=e.MergeState||(e.MergeState={})),e.SYNC_SERVICE_URL_TYPE="sync.store.url.type";function i(l){return`sync.enable.${l}`}e.getEnablementKey=i,e.IUserDataSyncEnablementService=(0,P.createDecorator)("IUserDataSyncEnablementService"),e.IUserDataSyncService=(0,P.createDecorator)("IUserDataSyncService"),e.IUserDataAutoSyncService=(0,P.createDecorator)("IUserDataAutoSyncService"),e.IUserDataSyncUtilService=(0,P.createDecorator)("IUserDataSyncUtilService"),e.IUserDataSyncLogService=(0,P.createDecorator)("IUserDataSyncLogService"),e.USER_DATA_SYNC_SCHEME="vscode-userdata-sync",e.PREVIEW_DIR_NAME="preview";function o(l,a){if(l.scheme!==e.USER_DATA_SYNC_SCHEME)return l=l.with({scheme:a.userDataSyncHome.scheme}),e.ALL_SYNC_RESOURCES.filter(h=>(0,n.isEqualOrParent)(l,(0,n.joinPath)(a.userDataSyncHome,h,e.PREVIEW_DIR_NAME)))[0]}e.getSyncResourceFromLocalPreview=o}),define(re[237],se([0,1,31,25]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.merge=void 0;function k(b,P,I,E,w){if(!P)return{remote:Object.keys(b).length>0?b:null,local:{added:{},removed:[],updated:{}}};const v=L(b,P);if(v.added.size===0&&v.removed.size===0&&v.updated.size===0)return{remote:null,local:{added:{},removed:[],updated:{}}};const y=I?L(I,P):{added:Object.keys(P).reduce((g,c)=>(g.add(c),g),new Set),removed:new Set,updated:new Set},f=I?L(I,b):{added:Object.keys(b).reduce((g,c)=>(g.add(c),g),new Set),removed:new Set,updated:new Set},S={added:{},removed:[],updated:{}},C=D.deepClone(P),m=!I;for(const g of f.added.values())g!==n.SYNC_SERVICE_URL_TYPE&&m&&y.added.has(g)||(C[g]=b[g]);for(const g of f.updated.values())C[g]=b[g];for(const g of f.removed.values())E.unregistered.includes(g)||delete C[g];for(const g of y.added.values()){const c=P[g];if(E.machine.includes(g)){w.info(`GlobalState: Skipped adding ${g} in local storage because it is declared as machine scoped.`);continue}if(I&&f.added.has(g))continue;const d=b[g];d&&d.value===c.value||g===n.SYNC_SERVICE_URL_TYPE&&m&&f.added.has(g)||(d?S.updated[g]=c:S.added[g]=c)}for(const g of y.updated.values()){const c=P[g];if(E.machine.includes(g)){w.info(`GlobalState: Skipped updating ${g} in local storage because it is declared as machine scoped.`);continue}if(f.updated.has(g)||f.removed.has(g))continue;const d=b[g];d&&d.value===c.value||(S.updated[g]=c)}for(const g of y.removed.values()){if(E.machine.includes(g)){w.trace(`GlobalState: Skipped removing ${g} in local storage because it is declared as machine scoped.`);continue}f.updated.has(g)||f.removed.has(g)||S.removed.push(g)}return{local:S,remote:A(C,P)?null:C}}e.merge=k;function L(b,P){const I=Object.keys(b),E=Object.keys(P),w=E.filter(f=>I.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),v=I.filter(f=>E.indexOf(f)===-1).reduce((f,S)=>(f.add(S),f),new Set),y=new Set;for(const f of I){if(v.has(f))continue;const S=b[f],C=P[f];D.equals(S,C)||y.add(f)}return{added:w,removed:v,updated:y}}function A(b,P){const{added:I,removed:E,updated:w}=L(b,P);return I.size===0&&E.size===0&&w.size===0}}),define(re[238],se([0,1,18,35,75,52,31,59,25]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.addSetting=e.isEmpty=e.areSame=e.merge=e.updateIgnoredSettings=e.removeComments=e.getIgnoredSettings=void 0;function I(a,h,p){let R=[];p?R=w(p):R=E(h);const M=[],O=[...(0,P.getDisallowedIgnoredSettings)()];if(Array.isArray(R))for(const F of R)F.startsWith("-")?O.push(F.substring(1)):M.push(F);return(0,D.distinct)([...a,...M].filter(F=>O.indexOf(F)===-1))}e.getIgnoredSettings=I;function E(a){let h=a.inspect("settingsSync.ignoredSettings").userValue;return h!==void 0||(h=a.inspect("sync.ignoredSettings").userValue,h!==void 0)?h:a.getValue("settingsSync.ignoredSettings")||[]}function w(a){const h=(0,n.parse)(a);return h?h["settingsSync.ignoredSettings"]||h["sync.ignoredSettings"]||[]:[]}function v(a,h){const p=(0,n.parse)(a)||{};let R="{}";for(const M of Object.keys(p)){const O=(0,k.setProperty)(R,[M],p[M],h);R=(0,k.applyEdits)(R,O)}return R}e.removeComments=v;function y(a,h,p,R){if(p.length){const M=l(h),O=(0,n.parse)(h)||{},F=(0,n.parse)(a);if(!F)return a;const T=[];for(const N of p){const W=O[N],V=F[N];W===void 0?a=b.edit(a,[N],void 0,R):V!==void 0?a=b.edit(a,[N],W,R):T.push(s(N,M))}T.sort((N,W)=>N.startOffset-W.startOffset),T.forEach(N=>a=g(N.setting.key,h,a,R))}return a}e.updateIgnoredSettings=y;function f(a,h,p,R,M,O){const F=y(a,h,R,O),T=p!==F,N=p!==h;if(!T&&!N)return{conflictsSettings:[],localContent:null,remoteContent:null,hasConflicts:!1};if(T&&!N)return{conflictsSettings:[],localContent:null,remoteContent:F,hasConflicts:!1};if(N&&!T)return{conflictsSettings:[],localContent:y(h,a,R,O),remoteContent:null,hasConflicts:!1};if(p===null&&C(a)){const j=S(a,h,R)?null:y(h,a,R,O);return{conflictsSettings:[],localContent:j,remoteContent:null,hasConflicts:!1}}let W=a,V=h;const Y=(0,n.parse)(a),$=(0,n.parse)(h),J=p?(0,n.parse)(p):null,H=R.reduce((j,Z)=>(j.add(Z),j),new Set),B=m(Y,$,H),K=m(J,Y,H),ie=m(J,$,H),ce=new Map,z=new Set,x=j=>{z.add(j);const Z=M.filter(({key:oe})=>oe===j)[0];Z?(W=b.edit(W,[j],Z.value,O),V=b.edit(V,[j],Z.value,O)):ce.set(j,{key:j,localValue:Y[j],remoteValue:$[j]})};for(const j of K.removed.values())ie.updated.has(j)?x(j):V=b.edit(V,[j],void 0,O);for(const j of ie.removed.values())z.has(j)||(K.updated.has(j)?x(j):W=b.edit(W,[j],void 0,O));for(const j of K.updated.values())z.has(j)||(ie.updated.has(j)?B.updated.has(j)&&x(j):V=b.edit(V,[j],Y[j],O));for(const j of ie.updated.values())z.has(j)||(K.updated.has(j)?B.updated.has(j)&&x(j):W=b.edit(W,[j],$[j],O));for(const j of K.added.values())z.has(j)||(ie.added.has(j)?B.updated.has(j)&&x(j):V=g(j,W,V,O));for(const j of ie.added.values())z.has(j)||(K.added.has(j)?B.updated.has(j)&&x(j):W=g(j,V,W,O));const _=ce.size>0||!S(W,V,R),U=_||!S(W,a,[]),q=_||!S(V,h,[]);return{localContent:U?W:null,remoteContent:q?V:null,conflictsSettings:[...ce.values()],hasConflicts:_}}e.merge=f;function S(a,h,p){if(a===h)return!0;const R=(0,n.parse)(a),M=(0,n.parse)(h),O=p.reduce((N,W)=>(N.add(W),N),new Set),F=l(a).filter(N=>!(N.setting&&O.has(N.setting.key))),T=l(h).filter(N=>!(N.setting&&O.has(N.setting.key)));if(F.length!==T.length)return!1;for(let N=0;N<F.length;N++){const W=F[N],V=T[N];if(W.setting&&V.setting){if(W.setting.key!==V.setting.key||!A.equals(R[W.setting.key],M[W.setting.key]))return!1}else if(!W.setting&&!V.setting){if(W.value!==V.value)return!1}else return!1}return!0}e.areSame=S;function C(a){return a?l(a).length===0:!0}e.isEmpty=C;function m(a,h,p){const R=a?Object.keys(a).filter(N=>!p.has(N)):[],M=Object.keys(h).filter(N=>!p.has(N)),O=M.filter(N=>R.indexOf(N)===-1).reduce((N,W)=>(N.add(W),N),new Set),F=R.filter(N=>M.indexOf(N)===-1).reduce((N,W)=>(N.add(W),N),new Set),T=new Set;if(a)for(const N of R){if(F.has(N))continue;const W=a[N],V=h[N];A.equals(W,V)||T.add(N)}return{added:O,removed:F,updated:T}}function g(a,h,p,R){const M=(0,n.parse)(h),O=l(h),F=l(p),T=c(a,O,F);return d(p,a,M[a],T,F,R)}e.addSetting=g;function c(a,h,p){const R=h.findIndex(O=>O.setting?.key===a),M=h[R-1];if(M){if(M.setting){const F=s(M.setting.key,p);if(F)return{index:p.indexOf(F),insertAfter:!0}}else{const F=r(R,h);if(F){const T=s(F.setting.key,p);if(T){const N=t(p.indexOf(T),p),W=i(h,F,h[R]);if(N){const V=i(p,T,N),Y=o(W,V);return Y?{index:p.indexOf(Y),insertAfter:!0}:{index:p.indexOf(N),insertAfter:!1}}else{const V=i(p,T,p[p.length-1]),Y=o(W,V);return Y?{index:p.indexOf(Y),insertAfter:!0}:{index:p.length-1,insertAfter:!0}}}}}const O=h[R+1];if(O)if(O.setting){const F=s(O.setting.key,p);if(F)return{index:p.indexOf(F),insertAfter:!1}}else{const F=t(R,h);if(F){const T=s(F.setting.key,p);if(T){const N=r(p.indexOf(T),p),W=i(h,h[R],F);if(N){const V=i(p,N,T),Y=o(W.reverse(),V.reverse());return Y?{index:p.indexOf(Y),insertAfter:!1}:{index:p.indexOf(N),insertAfter:!0}}else{const V=i(p,p[0],T),Y=o(W.reverse(),V.reverse());return Y?{index:p.indexOf(Y),insertAfter:!1}:{index:0,insertAfter:!1}}}}}}return{index:p.length-1,insertAfter:!0}}function d(a,h,p,R,M,O){let F;return R.index===-1?F=(0,k.setProperty)(a,[h],p,O):F=u(a,h,p,R,M,O).map(T=>(0,k.withFormatting)(a,T,O)[0]),(0,k.applyEdits)(a,F)}function u(a,h,p,R,M,O){const F=`${JSON.stringify(h)}: ${JSON.stringify(p)}`,T=(0,L.getEOL)(O,a),N=M[R.index];if(R.insertAfter){const W=[];if(N.setting)W.push({offset:N.endOffset,length:0,content:","+F});else{const V=t(R.index,M),Y=r(R.index,M),$=Y?.setting?.commaOffset;Y&&$===void 0&&W.push({offset:Y.endOffset,length:0,content:","});const J=$!==void 0&&$>N.endOffset;W.push({offset:J?$+1:N.endOffset,length:0,content:V?T+F+",":T+F})}return W}else{if(N.setting)return[{offset:N.startOffset,length:0,content:F+","}];const W=(M[R.index-1]&&!M[R.index-1].setting?T:"")+F+(t(R.index,M)?",":"")+T;return[{offset:N.startOffset,length:0,content:W}]}}function s(a,h){return h.filter(p=>p.setting?.key===a)[0]}function r(a,h){for(let p=a-1;p>=0;p--)if(h[p].setting)return h[p]}function t(a,h){for(let p=a+1;p<h.length;p++)if(h[p].setting)return h[p]}function i(a,h,p){const R=a.indexOf(h),M=a.indexOf(p);return a.filter((O,F)=>R<F&&F<M)}function o(a,h){if(a.length&&h.length){let p=0;for(;p<h.length&&p<a.length;p++)if(a[p].value!==h[p].value)return h[p-1];return h[p-1]}}function l(a){const h=[];let p=-1,R,M;const O={onObjectBegin:F=>{p++},onObjectProperty:(F,T,N)=>{p===0&&(R=T,M=F)},onObjectEnd:(F,T)=>{p--,p===0&&h.push({startOffset:R,endOffset:F+T,value:a.substring(R,F+T),setting:{key:M,commaOffset:void 0}})},onArrayBegin:(F,T)=>{p++},onArrayEnd:(F,T)=>{p--,p===0&&h.push({startOffset:R,endOffset:F+T,value:a.substring(R,F+T),setting:{key:M,commaOffset:void 0}})},onLiteralValue:(F,T,N)=>{p===0&&h.push({startOffset:R,endOffset:T+N,value:a.substring(R,T+N),setting:{key:M,commaOffset:void 0}})},onSeparator:(F,T,N)=>{if(p===0&&F===","){let W=h.length-1;for(;W>=0&&!h[W].setting;W--);const V=h[W];V&&h.splice(W,1,{startOffset:V.startOffset,endOffset:V.endOffset,value:V.value,setting:{key:V.setting.key,commaOffset:T}})}},onComment:(F,T)=>{p===0&&h.push({startOffset:F,endOffset:F+T,value:a.substring(F,F+T)})}};return(0,n.visit)(a,O),h}}),define(re[70],se([0,1,3,2,5,25]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncAccountService=e.IUserDataSyncAccountService=void 0,e.IUserDataSyncAccountService=(0,k.createDecorator)("IUserDataSyncAccountService");let A=class extends n.Disposable{constructor(P,I){super();this.userDataSyncStoreService=P,this.logService=I,this._onDidChangeAccount=this._register(new D.Emitter),this.onDidChangeAccount=this._onDidChangeAccount.event,this._onTokenFailed=this._register(new D.Emitter),this.onTokenFailed=this._onTokenFailed.event,this.wasTokenFailed=!1,this._register(P.onTokenFailed(()=>{this.logService.info("Settings Sync auth token failed",this.account?.authenticationProviderId,this.wasTokenFailed),this.updateAccount(void 0),this._onTokenFailed.fire(this.wasTokenFailed),this.wasTokenFailed=!0})),this._register(P.onTokenSucceed(()=>this.wasTokenFailed=!1))}get account(){return this._account}async updateAccount(P){(P&&this._account?P.token!==this._account.token||P.authenticationProviderId!==this._account.authenticationProviderId:P!==this._account)&&(this._account=P,this._account&&this.userDataSyncStoreService.setAuthToken(this._account.token,this._account.authenticationProviderId),this._onDidChangeAccount.fire(P))}};A=me([G(0,L.IUserDataSyncStoreService),G(1,L.IUserDataSyncLogService)],A),e.UserDataSyncAccountService=A}),define(re[239],se([0,1,6,16,61,2,17,19,14,13,25]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncBackupStoreService=void 0;let w=class extends L.Disposable{constructor(y,f,S,C){super();this.environmentService=y,this.fileService=f,this.configurationService=S,this.logService=C,E.ALL_SYNC_RESOURCES.forEach(m=>this.cleanUpBackup(m))}async getAllRefs(y){const f=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),S=await this.fileService.resolve(f);return S.children?S.children.filter(m=>m.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(m.name)).sort().reverse().map(m=>({ref:m.name,created:this.getCreationTime(m)})):[]}async resolveContent(y,f){if(!f){const S=await this.getAllRefs(y);S.length&&(f=S[S.length-1].ref)}if(f){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y,f);return(await this.fileService.readFile(S)).value.toString()}return null}async backup(y,f){const S=(0,A.joinPath)(this.environmentService.userDataSyncHome,y),C=(0,A.joinPath)(S,`${(0,k.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}.json`);try{await this.fileService.writeFile(C,n.VSBuffer.fromString(f))}catch(m){this.logService.error(m)}try{this.cleanUpBackup(y)}catch{}}async cleanUpBackup(y){const f=(0,A.joinPath)(this.environmentService.userDataSyncHome,y);try{try{if(!await this.fileService.exists(f))return}catch{return}const S=await this.fileService.resolve(f);if(S.children){const C=S.children.filter(d=>d.isFile&&/^\d{8}T\d{6}(\.json)?$/.test(d.name)).sort(),m=1e3*60*60*24*(this.configurationService.getValue("sync.localBackupDuration")||30);let g=C.filter(d=>Date.now()-this.getCreationTime(d)>m);const c=C.length-g.length;c<10&&(g=g.slice(10-c)),await D.Promises.settled(g.map(async d=>{this.logService.info("Deleting from backup",d.resource.path),await this.fileService.del(d.resource)}))}}catch(S){this.logService.error(S)}}getCreationTime(y){return y.ctime||new Date(parseInt(y.name.substring(0,4)),parseInt(y.name.substring(4,6))-1,parseInt(y.name.substring(6,8)),parseInt(y.name.substring(9,11)),parseInt(y.name.substring(11,13)),parseInt(y.name.substring(13,15))).getTime()}};w=me([G(0,P.IEnvironmentService),G(1,I.IFileService),G(2,b.IConfigurationService),G(3,E.IUserDataSyncLogService)],w),e.UserDataSyncBackupStoreService=w}),define(re[240],se([0,1,2,7]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreManagementServiceChannelClient=e.UserDataSyncStoreManagementServiceChannel=e.UserDataSyncAccountServiceChannel=e.UserDataSyncMachinesServiceChannel=e.UserDataSyncUtilServiceClient=e.UserDataSycnUtilServiceChannel=e.UserDataAutoSyncChannel=void 0;class k{constructor(v){this.service=v}listen(v,y){switch(y){case"onError":return this.service.onError}throw new Error(`Event not found: ${y}`)}call(v,y,f){switch(y){case"triggerSync":return this.service.triggerSync(f[0],f[1],f[2]);case"turnOn":return this.service.turnOn();case"turnOff":return this.service.turnOff(f[0])}throw new Error("Invalid call")}}e.UserDataAutoSyncChannel=k;class L{constructor(v){this.service=v}listen(v,y){throw new Error(`Event not found: ${y}`)}call(v,y,f){switch(y){case"resolveDefaultIgnoredSettings":return this.service.resolveDefaultIgnoredSettings();case"resolveUserKeybindings":return this.service.resolveUserBindings(f[0]);case"resolveFormattingOptions":return this.service.resolveFormattingOptions(n.URI.revive(f[0]))}throw new Error("Invalid call")}}e.UserDataSycnUtilServiceChannel=L;class A{constructor(v){this.channel=v}async resolveDefaultIgnoredSettings(){return this.channel.call("resolveDefaultIgnoredSettings")}async resolveUserBindings(v){return this.channel.call("resolveUserKeybindings",[v])}async resolveFormattingOptions(v){return this.channel.call("resolveFormattingOptions",[v])}}e.UserDataSyncUtilServiceClient=A;class b{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChange":return this.service.onDidChange}throw new Error(`Event not found: ${y}`)}async call(v,y,f){switch(y){case"getMachines":return this.service.getMachines();case"addCurrentMachine":return this.service.addCurrentMachine();case"removeCurrentMachine":return this.service.removeCurrentMachine();case"renameMachine":return this.service.renameMachine(f[0],f[1]);case"setEnablements":return this.service.setEnablements(f)}throw new Error("Invalid call")}}e.UserDataSyncMachinesServiceChannel=b;class P{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeAccount":return this.service.onDidChangeAccount;case"onTokenFailed":return this.service.onTokenFailed}throw new Error(`Event not found: ${y}`)}call(v,y,f){switch(y){case"_getInitialData":return Promise.resolve(this.service.account);case"updateAccount":return this.service.updateAccount(f)}throw new Error("Invalid call")}}e.UserDataSyncAccountServiceChannel=P;class I{constructor(v){this.service=v}listen(v,y){switch(y){case"onDidChangeUserDataSyncStore":return this.service.onDidChangeUserDataSyncStore}throw new Error(`Event not found: ${y}`)}call(v,y,f){switch(y){case"switch":return this.service.switch(f[0]);case"getPreviousUserDataSyncStore":return this.service.getPreviousUserDataSyncStore()}throw new Error("Invalid call")}}e.UserDataSyncStoreManagementServiceChannel=I;class E extends D.Disposable{constructor(v){super();this.channel=v,this.onDidChangeUserDataSyncStore=this.channel.listen("onDidChangeUserDataSyncStore")}async switch(v){return this.channel.call("switch",[v])}async getPreviousUserDataSyncStore(){const v=await this.channel.call("getPreviousUserDataSyncStore");return this.revive(v)}revive(v){return{url:n.URI.revive(v.url),type:v.type,defaultUrl:n.URI.revive(v.defaultUrl),insidersUrl:n.URI.revive(v.insidersUrl),stableUrl:n.URI.revive(v.stableUrl),canSwitch:v.canSwitch,authenticationProviders:v.authenticationProviders}}}e.UserDataSyncStoreManagementServiceChannelClient=E}),define(re[241],se([0,1,14,8]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncLogService=void 0;let k=class extends n.AbstractLogger{constructor(A,b){super();this.logger=this._register(A.createLogger(b.userDataSyncLogResource,{name:"settingssync"}))}trace(A,...b){this.logger.trace(A,...b)}debug(A,...b){this.logger.debug(A,...b)}info(A,...b){this.logger.info(A,...b)}warn(A,...b){this.logger.warn(A,...b)}error(A,...b){this.logger.error(A,...b)}critical(A,...b){this.logger.critical(A,...b)}flush(){this.logger.flush()}};k=me([G(0,n.ILoggerService),G(1,D.IEnvironmentService)],k),e.UserDataSyncLogService=k}),define(re[242],se([0,1,3,2,7,25]),function(X,e,D,n,k,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncChannelClient=e.UserDataSyncChannel=void 0;class A{constructor(E,w){this.service=E,this.logService=w,this.manualSyncTasks=new Map,this.onManualSynchronizeResources=new D.Emitter}listen(E,w){switch(w){case"onDidChangeStatus":return this.service.onDidChangeStatus;case"onDidChangeConflicts":return this.service.onDidChangeConflicts;case"onDidChangeLocal":return this.service.onDidChangeLocal;case"onDidChangeLastSyncTime":return this.service.onDidChangeLastSyncTime;case"onSyncErrors":return this.service.onSyncErrors;case"onDidResetLocal":return this.service.onDidResetLocal;case"onDidResetRemote":return this.service.onDidResetRemote;case"manualSync/onSynchronizeResources":return this.onManualSynchronizeResources.event}throw new Error(`Event not found: ${w}`)}async call(E,w,v){try{return await this._call(E,w,v)}catch(y){throw this.logService.error(y),y}}async _call(E,w,v){switch(w){case"_getInitialData":return Promise.resolve([this.service.status,this.service.conflicts,this.service.lastSyncTime]);case"replace":return this.service.replace(k.URI.revive(v[0]));case"reset":return this.service.reset();case"resetRemote":return this.service.resetRemote();case"resetLocal":return this.service.resetLocal();case"hasPreviouslySynced":return this.service.hasPreviouslySynced();case"hasLocalData":return this.service.hasLocalData();case"accept":return this.service.accept(v[0],k.URI.revive(v[1]),v[2],v[3]);case"resolveContent":return this.service.resolveContent(k.URI.revive(v[0]));case"getLocalSyncResourceHandles":return this.service.getLocalSyncResourceHandles(v[0]);case"getRemoteSyncResourceHandles":return this.service.getRemoteSyncResourceHandles(v[0]);case"getAssociatedResources":return this.service.getAssociatedResources(v[0],{created:v[1].created,uri:k.URI.revive(v[1].uri)});case"getMachineId":return this.service.getMachineId(v[0],{created:v[1].created,uri:k.URI.revive(v[1].uri)});case"createManualSyncTask":return this.createManualSyncTask()}if(w.startsWith("manualSync/")){const y=w.substring("manualSync/".length),f=v[0],S=this.getManualSyncTask(f);switch(v=v.slice(1),y){case"preview":return S.preview();case"accept":return S.accept(k.URI.revive(v[0]),v[1]);case"merge":return S.merge(k.URI.revive(v[0]));case"discard":return S.discard(k.URI.revive(v[0]));case"discardConflicts":return S.discardConflicts();case"apply":return S.apply();case"pull":return S.pull();case"push":return S.push();case"stop":return S.stop();case"_getStatus":return S.status;case"dispose":return this.disposeManualSyncTask(S)}}throw new Error("Invalid call")}getManualSyncTask(E){const w=this.manualSyncTasks.get(this.createKey(E));if(!w)throw new Error(`Manual sync taks not found: ${E}`);return w.manualSyncTask}async createManualSyncTask(){const E=new n.DisposableStore,w=E.add(await this.service.createManualSyncTask());return E.add(w.onSynchronizeResources(v=>this.onManualSynchronizeResources.fire({manualSyncTaskId:w.id,data:v}))),this.manualSyncTasks.set(this.createKey(w.id),{manualSyncTask:w,disposables:E}),{id:w.id,manifest:w.manifest,status:w.status}}disposeManualSyncTask(E){E.dispose();const w=this.createKey(E.id);this.manualSyncTasks.get(w)?.disposables.dispose(),this.manualSyncTasks.delete(w)}createKey(E){return`manualSyncTask-${E}`}}e.UserDataSyncChannel=A;class b extends n.Disposable{constructor(E){super();this._status="uninitialized",this._onDidChangeStatus=this._register(new D.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new D.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new D.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onSyncErrors=this._register(new D.Emitter),this.onSyncErrors=this._onSyncErrors.event,this.channel={call(w,v,y){return E.call(w,v,y).then(null,f=>{throw L.UserDataSyncError.toUserDataSyncError(f)})},listen(w,v){return E.listen(w,v)}},this.channel.call("_getInitialData").then(([w,v,y])=>{this.updateStatus(w),this.updateConflicts(v),y&&this.updateLastSyncTime(y),this._register(this.channel.listen("onDidChangeStatus")(f=>this.updateStatus(f))),this._register(this.channel.listen("onDidChangeLastSyncTime")(f=>this.updateLastSyncTime(f)))}),this._register(this.channel.listen("onDidChangeConflicts")(w=>this.updateConflicts(w))),this._register(this.channel.listen("onSyncErrors")(w=>this._onSyncErrors.fire(w.map(([v,y])=>[v,L.UserDataSyncError.toUserDataSyncError(y)]))))}get status(){return this._status}get onDidChangeLocal(){return this.channel.listen("onDidChangeLocal")}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}get onDidResetLocal(){return this.channel.listen("onDidResetLocal")}get onDidResetRemote(){return this.channel.listen("onDidResetRemote")}createSyncTask(){throw new Error("not supported")}async createManualSyncTask(){const{id:E,manifest:w,status:v}=await this.channel.call("createManualSyncTask"),y=this,f=new P(E,w,v,{async call(S,C,m){return y.channel.call(`manualSync/${S}`,[E,...Array.isArray(C)?C:[C]],m)},listen(S,C){return D.Event.map(D.Event.filter(y.channel.listen(`manualSync/${S}`,C),m=>!f.isDiposed()&&m.manualSyncTaskId===E),m=>m.data)}});return f}replace(E){return this.channel.call("replace",[E])}reset(){return this.channel.call("reset")}resetRemote(){return this.channel.call("resetRemote")}resetLocal(){return this.channel.call("resetLocal")}hasPreviouslySynced(){return this.channel.call("hasPreviouslySynced")}hasLocalData(){return this.channel.call("hasLocalData")}accept(E,w,v,y){return this.channel.call("accept",[E,w,v,y])}resolveContent(E){return this.channel.call("resolveContent",[E])}async getLocalSyncResourceHandles(E){return(await this.channel.call("getLocalSyncResourceHandles",[E])).map(({created:v,uri:y})=>({created:v,uri:k.URI.revive(y)}))}async getRemoteSyncResourceHandles(E){return(await this.channel.call("getRemoteSyncResourceHandles",[E])).map(({created:v,uri:y})=>({created:v,uri:k.URI.revive(y)}))}async getAssociatedResources(E,w){return(await this.channel.call("getAssociatedResources",[E,w])).map(({resource:y,comparableResource:f})=>({resource:k.URI.revive(y),comparableResource:k.URI.revive(f)}))}async getMachineId(E,w){return this.channel.call("getMachineId",[E,w])}async updateStatus(E){this._status=E,this._onDidChangeStatus.fire(E)}async updateConflicts(E){this._conflicts=E.map(([w,v])=>[w,v.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource)}))]),this._onDidChangeConflicts.fire(this._conflicts)}updateLastSyncTime(E){this._lastSyncTime!==E&&(this._lastSyncTime=E,this._onDidChangeLastSyncTime.fire(E))}}e.UserDataSyncChannelClient=b;class P extends n.Disposable{constructor(E,w,v,y){super();this.id=E,this.manifest=w,this._disposed=!1,this._status=v;const f=this;this.channel={async call(S,C,m){try{const g=await y.call(S,C,m);return f.isDiposed()||(f._status=await y.call("_getStatus")),g}catch(g){throw L.UserDataSyncError.toUserDataSyncError(g)}},listen(S,C){return y.listen(S,C)}}}get onSynchronizeResources(){return this.channel.listen("onSynchronizeResources")}get status(){return this._status}async preview(){const E=await this.channel.call("preview");return this.deserializePreviews(E)}async accept(E,w){const v=await this.channel.call("accept",[E,w]);return this.deserializePreviews(v)}async merge(E){const w=await this.channel.call("merge",[E]);return this.deserializePreviews(w)}async discard(E){const w=await this.channel.call("discard",[E]);return this.deserializePreviews(w)}async discardConflicts(){const E=await this.channel.call("discardConflicts");return this.deserializePreviews(E)}async apply(){const E=await this.channel.call("apply");return this.deserializePreviews(E)}pull(){return this.channel.call("pull")}push(){return this.channel.call("push")}stop(){return this.channel.call("stop")}isDiposed(){return this._disposed}dispose(){this._disposed=!0,this.channel.call("dispose")}deserializePreviews(E){return E.map(([w,v])=>[w,{isLastSyncFromCurrentMachine:v.isLastSyncFromCurrentMachine,resourcePreviews:v.resourcePreviews.map(y=>({...y,baseResource:k.URI.revive(y.baseResource),localResource:k.URI.revive(y.localResource),remoteResource:k.URI.revive(y.remoteResource),previewResource:k.URI.revive(y.previewResource),acceptedResource:k.URI.revive(y.acceptedResource)}))}])}}}),define(re[243],se([0,1,6,3,2]),function(X,e,D,n,k){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ActiveWindowManager=void 0;class L extends k.Disposable{constructor({onDidOpenWindow:b,onDidFocusWindow:P,getActiveWindowId:I}){super();this.disposables=this._register(new k.DisposableStore),n.Event.latch(n.Event.any(b,P))(this.setActiveWindow,this,this.disposables),this.firstActiveWindowIdPromise=(0,D.createCancelablePromise)(()=>I()),(async()=>{try{const w=await this.firstActiveWindowIdPromise;this.activeWindowId=typeof this.activeWindowId=="number"?this.activeWindowId:w}catch{}finally{this.firstActiveWindowIdPromise=void 0}})()}setActiveWindow(b){this.firstActiveWindowIdPromise&&(this.firstActiveWindowIdPromise.cancel(),this.firstActiveWindowIdPromise=void 0),this.activeWindowId=b}async getActiveClientId(){return`window:${this.firstActiveWindowIdPromise?await this.firstActiveWindowIdPromise:this.activeWindowId}`}}e.ActiveWindowManager=L}),define(re[244],se([0,1,163,10,34,17,7,5,20]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,b.createDecorator)("contextService");function I(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=I;function E(t){if(t.configuration)return{id:t.id,configPath:t.configuration};if(t.folders.length===1)return{id:t.id,uri:t.folders[0].uri}}e.toWorkspaceIdentifier=E;function w(t){const i=t;return typeof i?.id=="string"&&A.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=w;function v(t){const i=t;if(i?.uri)return{id:i.id,uri:A.URI.revive(i.uri)};const o=t;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(t?.id)return{id:t.id}}e.reviveIdentifier=v;var y;(function(t){t[t.EMPTY=1]="EMPTY",t[t.FOLDER=2]="FOLDER",t[t.WORKSPACE=3]="WORKSPACE"})(y=e.WorkbenchState||(e.WorkbenchState={}));function f(t){const i=t;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function S(t){const i=t;return!!(i&&typeof i=="object"&&A.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=S;class C{constructor(i,o,l,a,h){this._id=i,this._transient=l,this._configuration=a,this._ignorePathCasing=h,this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=k.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=C;class m{constructor(i,o){this.raw=o,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=m;function g(t){return new m({uri:t,index:0,name:(0,L.basenameOrAuthority)(t)},{uri:t.toString()})}e.toWorkspaceFolder=g,e.WORKSPACE_EXTENSION="code-workspace";const c=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,D.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function d(t,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(t,i.untitledWorkspacesHome)}e.isUntitledWorkspace=d;function u(t){let i;return A.URI.isUri(t)?i=t:i=t.configuration,i?.scheme===P.Schemas.tmp}e.isTemporaryWorkspace=u;function s(t,i){return!d(t,i)&&!u(t)}e.isSavedWorkspace=s;function r(t){return(typeof t=="string"?(0,n.extname)(t):(0,L.extname)(t))===c}e.hasWorkspaceFileExtension=r}),define(re[29],se([0,1,62,3,2,17,15,7,156,14,13,5,8,244,34,33,6,30]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesService=e.toUserDataProfile=e.EXTENSIONS_RESOURCE_NAME=e.reviveProfile=e.IUserDataProfilesService=e.PROFILES_ENABLEMENT_CONFIG=e.isUserDataProfile=void 0;function g(s){const r=s;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&typeof r.isDefault=="boolean"&&typeof r.name=="string"&&b.URI.isUri(r.location)&&b.URI.isUri(r.globalStorageHome)&&b.URI.isUri(r.settingsResource)&&b.URI.isUri(r.keybindingsResource)&&b.URI.isUri(r.tasksResource)&&b.URI.isUri(r.snippetsHome)&&((0,A.isUndefined)(r.extensionsResource)||b.URI.isUri(r.extensionsResource)))}e.isUserDataProfile=g,e.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",e.IUserDataProfilesService=(0,w.createDecorator)("IUserDataProfilesService");function c(s,r){return{id:s.id,isDefault:s.isDefault,name:s.name,location:b.URI.revive(s.location).with({scheme:r}),globalStorageHome:b.URI.revive(s.globalStorageHome).with({scheme:r}),settingsResource:b.URI.revive(s.settingsResource).with({scheme:r}),keybindingsResource:b.URI.revive(s.keybindingsResource).with({scheme:r}),tasksResource:b.URI.revive(s.tasksResource).with({scheme:r}),snippetsHome:b.URI.revive(s.snippetsHome).with({scheme:r}),extensionsResource:b.URI.revive(s.extensionsResource)?.with({scheme:r})}}e.reviveProfile=c,e.EXTENSIONS_RESOURCE_NAME="extensions.json";function d(s,r,t){return{id:(0,D.hash)(r.path).toString(16),name:s,location:r,isDefault:!1,globalStorageHome:(0,L.joinPath)(r,"globalStorage"),settingsResource:(0,L.joinPath)(r,"settings.json"),keybindingsResource:(0,L.joinPath)(r,"keybindings.json"),tasksResource:(0,L.joinPath)(r,"tasks.json"),snippetsHome:(0,L.joinPath)(r,"snippets"),extensionsResource:(0,L.joinPath)(r,e.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:t}}e.toUserDataProfile=d;let u=class extends k.Disposable{constructor(r,t,i,o){super();this.environmentService=r,this.fileService=t,this.uriIdentityService=i,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new n.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new n.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new n.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new n.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profilesHome=(0,L.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(r){this.enabled!==r&&(this._profilesObject=void 0,this.enabled=r)}get profilesObject(){if(!this._profilesObject){const r=this.enabled?this.getStoredProfiles().map(l=>d(l.name,l.location,l.useDefaultFlags)):[];let t;const i=new f.ResourceMap,o=d((0,P.localize)(0,null),this.environmentService.userRoamingDataHome);if(r.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||r.length>0?o.extensionsResource:void 0}),r.length){const l=this.getStoredProfileAssociations();if(l.workspaces)for(const[a,h]of Object.entries(l.workspaces)){const p=b.URI.parse(a),R=b.URI.parse(h),M=r.find(O=>this.uriIdentityService.extUri.isEqual(O.location,R));M&&i.set(p,M)}if(l.emptyWindow){const a=b.URI.parse(l.emptyWindow);t=r.find(h=>this.uriIdentityService.extUri.isEqual(h.location,a))}}this._profilesObject={profiles:r,workspaces:i,emptyWindow:t}}return this._profilesObject}getProfile(r,t){if(!this.enabled)return this.defaultProfile;const i=this.getWorkspace(r);let o=b.URI.isUri(i)?this.profilesObject.workspaces.get(i):this.profilesObject.emptyWindow;return o||(o=t,this.profiles.length>1&&this.updateWorkspaceAssociation(r,o)),o}getWorkspace(r){return(0,y.isSingleFolderWorkspaceIdentifier)(r)?r.uri:(0,y.isWorkspaceIdentifier)(r)?r.configPath:"empty-window"}async createProfile(r,t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(a=>a.name===r))throw new Error(`Profile with name ${r} already exists`);const o=d(r,(0,L.joinPath)(this.profilesHome,(0,D.hash)((0,m.generateUuid)()).toString(16)),t);await this.fileService.createFolder(o.location);const l=[];return this._onWillCreateProfile.fire({profile:o,join(a){l.push(a)}}),await C.Promises.settled(l),this.updateProfiles([o],[],[]),i&&await this.setProfileForWorkspace(o,i),o}async updateProfile(r,t,i){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(l=>l.id===r.id);if(!o)throw new Error(`Profile '${r.name}' does not exist`);return o=d(t,o.location,i),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(r,t){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);const i=this.profiles.find(o=>o.id===r.id);if(!i)throw new Error(`Profile '${r.name}' does not exist`);this.updateWorkspaceAssociation(t,i)}async unsetWorkspace(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(r)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${e.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(r.isDefault)throw new Error("Cannot remove default profile");const t=this.profiles.find(o=>o.id===r.id);if(!t)throw new Error(`Profile '${r.name}' does not exist`);const i=[];this._onWillRemoveProfile.fire({profile:t,join(o){i.push(o)}}),await C.Promises.settled(i),t.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])t.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[t],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(t.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(r,t,i){const o=[];for(let l of[...this.profilesObject.profiles,...r])l.isDefault||t.some(a=>l.id===a.id)||(l=i.find(a=>l.id===a.id)??l,o.push({location:l.location,name:l.name,useDefaultFlags:l.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(r,t,i)}triggerProfilesChanges(r,t,i){this._onDidChangeProfiles.fire({added:r,removed:t,updated:i,all:this.profiles})}updateWorkspaceAssociation(r,t){const i=this.getWorkspace(r);b.URI.isUri(i)?(this.profilesObject.workspaces.delete(i),t&&this.profilesObject.workspaces.set(i,t)):this.profilesObject.emptyWindow=t,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const r={};for(const[i,o]of this.profilesObject.workspaces.entries())r[i.toString()]=o.location.toString();const t=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:r,emptyWindow:t}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(r){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(r){throw new Error("not implemented")}};u.PROFILES_KEY="userDataProfiles",u.PROFILE_ASSOCIATIONS_KEY="profileAssociations",u=me([G(0,I.IEnvironmentService),G(1,E.IFileService),G(2,S.IUriIdentityService),G(3,v.ILogService)],u),e.UserDataProfilesService=u}),define(re[245],se([0,1,18,6,21,9,3,2,4,7,139,28,32,43,8,24,22,29]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionTask=e.reportTelemetry=e.joinErrors=e.AbstractExtensionManagementService=void 0;let g=class extends b.Disposable{constructor(t,i,o,l,a){super();this.galleryService=t,this.telemetryService=i,this.logService=o,this.productService=l,this.userDataProfilesService=a,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,b.toDisposable)(()=>{this.installingExtensions.forEach(h=>h.cancel()),this.uninstallingExtensions.forEach(h=>h.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(t){const i=await this.getTargetPlatform();return t.allTargetPlatforms.some(o=>(0,w.isTargetPlatformCompatible)(o,t.allTargetPlatforms,i))}async installFromGallery(t,i={}){try{if(!this.galleryService.isEnabled())throw new w.ExtensionManagementError(E.localize(0,null),w.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(t,!!i.installGivenVersion,!!i.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,i)}catch(o){throw u(this.telemetryService,"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(t),error:o}),this.logService.error("Failed to install extension.",t.identifier.id),this.logService.error(o),d(o)}}async uninstall(t,i={}){return this.logService.trace("ExtensionManagementService#uninstall",t.identifier.id),this.uninstallExtension(t,i)}async reinstallFromGallery(t){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",t.identifier.id),!this.galleryService.isEnabled())throw new Error(E.localize(1,null));const i=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...t.identifier,preRelease:t.preRelease}],{targetPlatform:i,compatible:!0},k.CancellationToken.None);if(!o)throw new Error(E.localize(2,null));await this.createUninstallExtensionTask(t,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const t=new Date().getTime();return(!this.extensionsControlManifest||t-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=t),this.extensionsControlManifest}registerParticipant(t){this.participants.push(t)}async installExtension(t,i,o){const l=M=>`${v.ExtensionKey.create(M).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!I.URI.isUri(i)){const M=this.installingExtensions.get(l(i));if(M){this.logService.info("Extensions is already requested to install",i.identifier.id);const{local:O}=await M.waitUntilTaskIsFinished();return O}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const a=[],h=[],p=this.createInstallExtensionTask(t,i,o);I.URI.isUri(i)||this.installingExtensions.set(l(i),p),this._onInstallExtension.fire({identifier:p.identifier,source:i,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",p.identifier.id),a.push({task:p,manifest:t});let R=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",p.identifier.id);else try{const O=await this.getAllDepsAndPackExtensionsToInstall(p.identifier,t,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:F,manifest:T}of O){R=R||!!T.extensionDependencies?.some(W=>(0,v.areSameExtensions)({id:W},p.identifier));const N=l(F);if(this.installingExtensions.has(N))this.logService.info("Extension is already requested to install",F.identifier.id);else{const W=this.createInstallExtensionTask(T,F,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(N,W),this._onInstallExtension.fire({identifier:W.identifier,source:F,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",W.identifier.id),a.push({task:W,manifest:T})}}}catch(O){if(I.URI.isUri(p.source))(0,D.isNonEmptyArray)(t.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",p.identifier.id,O.message),(0,D.isNonEmptyArray)(t.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",p.identifier.id,O.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",p.identifier.id),O}const M=a.reduce((O,{task:F,manifest:T})=>(O.set(F.identifier.id.toLowerCase(),{task:F,manifest:T}),O),new Map);for(;M.size;){let O;const F=[...M.values()].filter(({manifest:T})=>!T.extensionDependencies?.some(N=>M.has(N.toLowerCase())));F.length?O=M.size===1?F:F.filter(({task:T})=>!(T===p&&!R)):(this.logService.info("Found extensions with circular dependencies",F.map(({task:T})=>T.identifier.id)),O=[...M.values()]),await this.joinAllSettled(O.map(async({task:T})=>{const N=new Date().getTime();try{const{local:W}=await T.run();if(await this.joinAllSettled(this.participants.map(V=>V.postInstall(W,T.source,o,k.CancellationToken.None))),!I.URI.isUri(T.source)){const V=T.operation===3,Y=V?void 0:(new Date().getTime()-T.source.lastUpdated)/1e3;if(u(this.telemetryService,V?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(T.source),duration:new Date().getTime()-N,durationSinceUpdate:Y}),P.isWeb&&T.operation!==3)try{await this.galleryService.reportStatistic(W.manifest.publisher,W.manifest.name,W.manifest.version,"install")}catch{}}h.push({local:W,identifier:T.identifier,operation:T.operation,source:T.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:W.isApplicationScoped})}catch(W){throw I.URI.isUri(T.source)||u(this.telemetryService,T.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,v.getGalleryExtensionTelemetryData)(T.source),duration:new Date().getTime()-N,error:W}),this.logService.error("Error while installing the extension:",T.identifier.id),W}finally{M.delete(T.identifier.id.toLowerCase())}}))}return h.forEach(({identifier:O})=>this.logService.info("Extension installed successfully:",O.id)),this._onDidInstallExtensions.fire(h),h.filter(({identifier:O})=>(0,v.areSameExtensions)(O,p.identifier))[0].local}catch(M){if(a.forEach(({task:O})=>O.cancel()),h.length)try{const O=await Promise.allSettled(h.map(({local:F})=>this.createUninstallExtensionTask(F,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let F=0;F<O.length;F++){const T=O[F],{identifier:N}=h[F];T.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",N.id):this.logService.warn("Rollback: Error while uninstalling extension",N.id,(0,L.getErrorMessage)(T.reason))}}catch(O){this.logService.warn("Error while rolling back extensions",(0,L.getErrorMessage)(O),h.map(({identifier:F})=>F.id))}throw this._onDidInstallExtensions.fire(a.map(({task:O})=>({identifier:O.identifier,operation:2,source:O.source,context:o.context,profileLocation:o.profileLocation}))),M}finally{for(const{task:M}of a)if(!I.URI.isUri(M.source)){const O=l(M.source);this.installingExtensions.delete(O)||this.logService.warn("Installation task is not found in the cache",O)}}}async joinAllSettled(t){const i=[],o=[],l=await Promise.allSettled(t);for(const a of l)a.status==="fulfilled"?i.push(a.value):o.push(a.reason);if(o.length)throw c(o);return i}async getAllDepsAndPackExtensionsToInstall(t,i,o,l,a){if(!this.galleryService.isEnabled())return[];let h=await this.getInstalled(void 0,a);const p=[t,...h.map(O=>O.identifier)],R=[],M=async(O,F)=>{const T=F.extensionDependencies||[],N=[...T];if(F.extensionPack){const W=o?h.find(V=>(0,v.areSameExtensions)(V.identifier,O)):void 0;for(const V of F.extensionPack)W&&W.manifest.extensionPack&&W.manifest.extensionPack.some(Y=>(0,v.areSameExtensions)({id:Y},{id:V}))||N.every(Y=>!(0,v.areSameExtensions)({id:Y},{id:V}))&&N.push(V)}if(N.length){const W=[...p,...R.map(Y=>Y.gallery.identifier)],V=N.filter(Y=>W.every($=>!(0,v.areSameExtensions)($,{id:Y})));if(V.length){const Y=await this.galleryService.getExtensions(V.map($=>({id:$,preRelease:l})),k.CancellationToken.None);for(const $ of Y){if(W.find(B=>(0,v.areSameExtensions)(B,$.identifier)))continue;const J=T.some(B=>(0,v.areSameExtensions)({id:B},$.identifier));let H;try{H=await this.checkAndGetCompatibleVersion($,!1,l)}catch(B){if(B instanceof w.ExtensionManagementError&&B.code===w.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!J){this.logService.info("Skipping the packed extension as it cannot be installed",$.identifier.id);continue}else throw B}R.push({gallery:H.extension,manifest:H.manifest}),await M(H.extension.identifier,H.manifest)}}}};return await M(t,i),h=await this.getInstalled(void 0,a),R.filter(O=>!h.some(F=>(0,v.areSameExtensions)(F.identifier,O.gallery.identifier)))}async checkAndGetCompatibleVersion(t,i,o){if((await this.getExtensionsControlManifest()).malicious.some(p=>(0,v.areSameExtensions)(t.identifier,p)))throw new w.ExtensionManagementError(E.localize(3,null,t.identifier.id),w.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(t)){const p=await this.getTargetPlatform();throw new w.ExtensionManagementError(E.localize(4,null,t.identifier.id,this.productService.nameLong,(0,w.TargetPlatformToString)(p)),w.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const a=await this.getCompatibleVersion(t,i,o);if(a){if(o&&!i&&t.hasPreReleaseVersion&&!a.properties.isPreReleaseVersion)throw new w.ExtensionManagementError(E.localize(5,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&t.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([t.identifier],k.CancellationToken.None))[0]?new w.ExtensionManagementError(E.localize(6,null,t.identifier.id),w.ExtensionManagementErrorCode.ReleaseVersionNotFound):new w.ExtensionManagementError(E.localize(7,null,t.identifier.id,this.productService.nameLong,this.productService.version),w.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",a.identifier.id);const h=await this.galleryService.getManifest(a,k.CancellationToken.None);if(h===null)throw new w.ExtensionManagementError(`Missing manifest for extension ${t.identifier.id}`,w.ExtensionManagementErrorCode.Invalid);if(h.version!==a.version)throw new w.ExtensionManagementError(`Cannot install '${t.identifier.id}' extension because of version mismatch in Marketplace`,w.ExtensionManagementErrorCode.Invalid);return{extension:a,manifest:h}}async getCompatibleVersion(t,i,o){const l=await this.getTargetPlatform();let a=null;return!i&&t.hasPreReleaseVersion&&t.properties.isPreReleaseVersion!==o&&(a=(await this.galleryService.getExtensions([{...t.identifier,preRelease:o}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null),!a&&await this.galleryService.isExtensionCompatible(t,o,l)&&(a=t),a||(i?a=(await this.galleryService.getExtensions([{...t.identifier,version:t.version}],{targetPlatform:l,compatible:!0},k.CancellationToken.None))[0]||null:a=await this.galleryService.getCompatibleExtension(t,o,l)),a}async uninstallExtension(t,i){const o=M=>`${M.id.toLowerCase()}${i.versionOnly?`-${t.manifest.version}`:""}${i.profileLocation?`@${i.profileLocation.toString()}`:""}`,l=this.uninstallingExtensions.get(o(t.identifier));if(l)return this.logService.info("Extensions is already requested to uninstall",t.identifier.id),l.waitUntilTaskIsFinished();const a=(M,O)=>{const F=this.createUninstallExtensionTask(M,O);return this.uninstallingExtensions.set(o(F.extension.identifier),F),i.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${M.identifier.id}@${M.manifest.version}`),this._onUninstallExtension.fire({identifier:M.identifier,profileLocation:i.profileLocation,applicationScoped:M.isApplicationScoped}),F},h=(M,O)=>{O?i.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString(),O.message):this.logService.error("Failed to uninstall extension:",`${M.identifier.id}@${M.manifest.version}`,O.message):i.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${M.identifier.id}@${M.manifest.version}`,i.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${M.identifier.id}@${M.manifest.version}`),u(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,v.getLocalExtensionTelemetryData)(M),error:O}),this._onDidUninstallExtension.fire({identifier:M.identifier,version:M.manifest.version,error:O?.code,profileLocation:i.profileLocation,applicationScoped:M.isApplicationScoped})},p=[],R=[];try{p.push(a(t,i));const M=await this.getInstalled(1,i.profileLocation);if(i.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${t.identifier.id}@${t.manifest.version}`);else{const O=this.getAllPackExtensionsToUninstall(t,M);for(const F of O)this.uninstallingExtensions.has(o(F.identifier))?this.logService.info("Extensions is already requested to uninstall",F.identifier.id):p.push(a(F,i))}i.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${t.identifier.id}@${t.manifest.version}`):this.checkForDependents(p.map(O=>O.extension),M,t),await this.joinAllSettled(p.map(async O=>{try{if(await O.run(),await this.joinAllSettled(this.participants.map(F=>F.postUninstall(O.extension,i,k.CancellationToken.None))),O.extension.identifier.uuid)try{await this.galleryService.reportStatistic(O.extension.manifest.publisher,O.extension.manifest.name,O.extension.manifest.version,"uninstall")}catch{}h(O.extension)}catch(F){const T=F instanceof w.ExtensionManagementError?F:new w.ExtensionManagementError((0,L.getErrorMessage)(F),w.ExtensionManagementErrorCode.Internal);throw h(O.extension,T),T}finally{R.push(O)}}))}catch(M){const O=M instanceof w.ExtensionManagementError?M:new w.ExtensionManagementError((0,L.getErrorMessage)(M),w.ExtensionManagementErrorCode.Internal);for(const F of p){try{F.cancel()}catch{}R.includes(F)||h(F.extension,O)}throw O}finally{for(const M of p)this.uninstallingExtensions.delete(o(M.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",M.extension.identifier.id)}}checkForDependents(t,i,o){for(const l of t){const a=this.getDependents(l,i);if(a.length){const h=a.filter(p=>!t.some(R=>(0,v.areSameExtensions)(R.identifier,p.identifier)));if(h.length)throw new Error(this.getDependentsErrorMessage(l,h,o))}}}getDependentsErrorMessage(t,i,o){return o===t?i.length===1?E.localize(8,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(9,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(10,null,o.manifest.displayName||o.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):i.length===1?E.localize(11,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name):i.length===2?E.localize(12,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name):E.localize(13,null,o.manifest.displayName||o.manifest.name,t.manifest.displayName||t.manifest.name,i[0].manifest.displayName||i[0].manifest.name,i[1].manifest.displayName||i[1].manifest.name)}getAllPackExtensionsToUninstall(t,i,o=[]){if(o.indexOf(t)!==-1)return[];o.push(t);const l=t.manifest.extensionPack?t.manifest.extensionPack:[];if(l.length){const a=i.filter(p=>!p.isBuiltin&&l.some(R=>(0,v.areSameExtensions)({id:R},p.identifier))),h=[];for(const p of a)h.push(...this.getAllPackExtensionsToUninstall(p,i,o));return[...a,...h]}return[]}getDependents(t,i){return i.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(l=>(0,v.areSameExtensions)({id:l},t.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const t=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",t),t}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(t,i,o){return o.profileLocation&&(0,y.isApplicationScopedExtension)(t)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(t,i,o)}createUninstallExtensionTask(t,i){return i.profileLocation&&t.isApplicationScoped&&(i={...i,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(t,i)}};g=me([G(0,w.IExtensionGalleryService),G(1,C.ITelemetryService),G(2,f.ILogService),G(3,S.IProductService),G(4,m.IUserDataProfilesService)],g),e.AbstractExtensionManagementService=g;function c(r){const t=Array.isArray(r)?r:[r];return t.length===1?t[0]instanceof Error?t[0]:new Error(t[0]):t.reduce((i,o)=>new Error(`${i.message}${i.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}e.joinErrors=c;function d(r){if(r instanceof w.ExtensionManagementError)return r;const t=new w.ExtensionManagementError(r.message,w.ExtensionManagementErrorCode.Internal);return t.stack=r.stack,t}function u(r,t,{extensionData:i,duration:o,error:l,durationSinceUpdate:a}){const h=l?l instanceof w.ExtensionManagementError?l.code:w.ExtensionManagementErrorCode.Internal:void 0;r.publicLog(t,{...i,success:!l,duration:o,errorcode:h,durationSinceUpdate:a})}e.reportTelemetry=u;class s{constructor(){this.barrier=new n.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>this.doRun(t))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,n.createCancelablePromise)(t=>new Promise((i,o)=>{const l=t.onCancellationRequested(()=>{l.dispose(),o(new L.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}e.AbstractExtensionTask=s}),define(re[71],se([0,1,18,6,31,16,9,35,121,2,20,10,4,17,55,80,15,7,141,14,32,43,65,13,5,8,24,3,63,44,29,33]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u,s,r,t,i,o,l,a,h,p,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeExtensionsScannerService=e.toExtensionDescription=e.AbstractExtensionsScannerService=e.IExtensionsScannerService=e.Translations=void 0;var M;(function(Y){function $(J,H){if(J===H)return!0;const B=Object.keys(J),K=new Set;for(const ie of Object.keys(H))K.add(ie);if(B.length!==K.size)return!1;for(const ie of B){if(J[ie]!==H[ie])return!1;K.delete(ie)}return K.size===0}Y.equals=$})(M=e.Translations||(e.Translations={})),e.IExtensionsScannerService=(0,t.createDecorator)("IExtensionsScannerService");let O=class extends I.Disposable{constructor($,J,H,B,K,ie,ce,z,x,_,U){super();this.systemExtensionsLocation=$,this.userExtensionsLocation=J,this.extensionsControlLocation=H,this.cacheLocation=B,this.userDataProfilesService=K,this.extensionsProfileScannerService=ie,this.fileService=ce,this.logService=z,this.environmentService=x,this.productService=_,this.instantiationService=U,this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,y.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(N,(0,y.joinPath)(this.cacheLocation,u.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(N,(0,y.joinPath)(this.cacheLocation,u.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(T,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,d.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions($,J){const[H,B]=await Promise.all([this.scanSystemExtensions($),this.scanUserExtensions(J)]),K=await this.scanExtensionsUnderDevelopment($,[...H,...B]);return this.dedupExtensions(H,B,K,await this.getTargetPlatform(),!0)}async scanSystemExtensions($){const J=[];J.push(this.scanDefaultSystemExtensions(!!$.useCache,$.language)),J.push(this.scanDevSystemExtensions($.language,!!$.checkControlFile));const[H,B]=await Promise.all(J);return this.applyScanOptions([...H,...B],0,$,!1)}async scanUserExtensions($){this.logService.trace("Started scanning user extensions");const J=await this.createExtensionScannerInput($.profileLocation??this.userExtensionsLocation,!!$.profileLocation,1,!$.includeUninstalled,$.language);let B=await($.useCache&&!J.devMode&&J.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(J);return B=await this.applyScanOptions(B,1,$,!0),this.logService.trace("Scanned user extensions:",B.length),B}async scanExtensionsUnderDevelopment($,J){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const H=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(B=>B.scheme===E.Schemas.file).map(async B=>{const K=await this.createExtensionScannerInput(B,!1,1,!0,$.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(K)).map(ce=>(ce.type=J.find(z=>(0,d.areSameExtensions)(z.identifier,ce.identifier))?.type??ce.type,this.extensionsScanner.validate(ce,K)))}))).flat();return this.applyScanOptions(H,"development",$,!0)}return[]}async scanExistingExtension($,J,H){const B=await this.createExtensionScannerInput($,!1,J,!0,H.language),K=await this.extensionsScanner.scanExtension(B);return!K||!H.includeInvalid&&!K.isValid?null:K}async scanOneOrMultipleExtensions($,J,H){const B=await this.createExtensionScannerInput($,!1,J,!0,H.language),K=await this.extensionsScanner.scanOneOrMultipleExtensions(B);return this.applyScanOptions(K,J,H,!0)}async scanMetadata($){const J=(0,y.joinPath)($,"package.json"),H=(await this.fileService.readFile(J)).value.toString();return JSON.parse(H).__metadata}async updateMetadata($,J){const H=(0,y.joinPath)($,"package.json"),B=(await this.fileService.readFile(H)).value.toString(),K=JSON.parse(B);J.isMachineScoped=J.isMachineScoped||void 0,J.isBuiltin=J.isBuiltin||void 0,J.installedTimestamp=J.installedTimestamp||void 0,K.__metadata={...K.__metadata,...J},await this.fileService.writeFile((0,y.joinPath)($,"package.json"),L.VSBuffer.fromString(JSON.stringify(K,null,"	")))}async applyScanOptions($,J,H,B){return H.includeAllVersions||($=this.dedupExtensions(J===0?$:void 0,J===1?$:void 0,J==="development"?$:void 0,await this.getTargetPlatform(),B)),H.includeInvalid||($=$.filter(K=>K.isValid)),$.sort((K,ie)=>{const ce=w.basename(K.location.fsPath),z=w.basename(ie.location.fsPath);return ce<z?-1:ce>z?1:0})}dedupExtensions($,J,H,B,K){const ie=(z,x,_)=>{if(z.isValid&&!x.isValid)return!1;if(z.isValid===x.isValid){if(K&&f.gt(z.manifest.version,x.manifest.version))return this.logService.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${z.location.path} with version ${z.manifest.version}`),!1;if(f.eq(z.manifest.version,x.manifest.version)){if(z.type===0)return this.logService.debug(`Skipping extension ${x.location.path} in favour of system extension ${z.location.path} with same version`),!1;if(z.targetPlatform===B)return this.logService.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return _?this.logService.warn(`Overwriting user extension ${z.location.path} with ${x.location.path}.`):this.logService.debug(`Overwriting user extension ${z.location.path} with ${x.location.path}.`),!0},ce=new Map;return $?.forEach(z=>{const x=u.ExtensionIdentifier.toKey(z.identifier.id),_=ce.get(x);(!_||ie(_,z,!1))&&ce.set(x,z)}),J?.forEach(z=>{const x=u.ExtensionIdentifier.toKey(z.identifier.id),_=ce.get(x);if(!_&&$&&z.type===0){this.logService.debug(`Skipping obsolete system extension ${z.location.path}.`);return}(!_||ie(_,z,!1))&&ce.set(x,z)}),H?.forEach(z=>{const x=u.ExtensionIdentifier.toKey(z.identifier.id),_=ce.get(x);(!_||ie(_,z,!0))&&ce.set(x,z),ce.set(x,z)}),[...ce.values()]}async scanDefaultSystemExtensions($,J){this.logService.trace("Started scanning system extensions");const H=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,J),K=await($&&!H.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(H);return this.logService.trace("Scanned system extensions:",K.length),K}async scanDevSystemExtensions($,J){const H=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!H?.length)return[];this.logService.trace("Started scanning dev system extensions");const B=J?await this.getBuiltInExtensionControl():{},K=[],ie=m.URI.file(w.normalize(w.join(E.FileAccess.asFileUri("",X).fsPath,"..",".build","builtInExtensions")));for(const z of H){const x=B[z.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":K.push((0,y.joinPath)(ie,z.name));break;default:K.push(m.URI.file(x));break}}const ce=await Promise.all(K.map(async z=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(z,!1,0,!0,$))));return this.logService.trace("Scanned dev system extensions:",ce.length),(0,D.coalesce)(ce)}async getBuiltInExtensionControl(){try{const $=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse($.value.toString())}catch{return{}}}async createExtensionScannerInput($,J,H,B,K,ie=!0){const ce=await this.getTranslations(K??v.language),z=await this.getMtime($),x=J?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,_=x?await this.getMtime(x):void 0;return new F($,z,x,_,J,H,B,ie,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,K,ce)}async getMtime($){try{const J=await this.fileService.stat($);if(typeof J.mtime=="number")return J.mtime}catch{}}};O=me([G(4,p.IUserDataProfilesService),G(5,h.IExtensionsProfileScannerService),G(6,r.IFileService),G(7,i.ILogService),G(8,c.IEnvironmentService),G(9,o.IProductService),G(10,t.IInstantiationService)],O),e.AbstractExtensionsScannerService=O;class F{constructor($,J,H,B,K,ie,ce,z,x,_,U,q,j,Z){this.location=$,this.mtime=J,this.applicationExtensionslocation=H,this.applicationExtensionslocationMtime=B,this.profile=K,this.type=ie,this.excludeObsolete=ce,this.validate=z,this.productVersion=x,this.productDate=_,this.productCommit=U,this.devMode=q,this.language=j,this.translations=Z}static createNlsConfiguration($){return{language:$.language,pseudo:$.language==="pseudo",devMode:$.devMode,translations:$.translations}}static equals($,J){return(0,y.isEqual)($.location,J.location)&&$.mtime===J.mtime&&(0,y.isEqual)($.applicationExtensionslocation,J.applicationExtensionslocation)&&$.applicationExtensionslocationMtime===J.applicationExtensionslocationMtime&&$.profile===J.profile&&$.type===J.type&&$.excludeObsolete===J.excludeObsolete&&$.validate===J.validate&&$.productVersion===J.productVersion&&$.productDate===J.productDate&&$.productCommit===J.productCommit&&$.devMode===J.devMode&&$.language===J.language&&M.equals($.translations,J.translations)}}let T=class extends I.Disposable{constructor($,J,H,B,K){super();this.obsoleteFile=$,this.extensionsProfileScannerService=J,this.uriIdentityService=H,this.fileService=B,this.logService=K}async scanExtensions($){const J=$.profile?await this.scanExtensionsFromProfile($):await this.scanExtensionsFromLocation($);let H={};if($.excludeObsolete&&$.type===1)try{const B=(await this.fileService.readFile(this.obsoleteFile)).value.toString();H=JSON.parse(B)}catch{}return(0,C.isEmptyObject)(H)?J:J.filter(B=>!H[d.ExtensionKey.create(B).toString()])}async scanExtensionsFromLocation($){const J=await this.fileService.resolve($.location);if(!J.children?.length)return[];const H=await Promise.all(J.children.map(async B=>{if(!B.isDirectory||$.type===1&&(0,y.basename)(B.resource).indexOf(".")===0)return null;const K=new F(B.resource,$.mtime,$.applicationExtensionslocation,$.applicationExtensionslocationMtime,$.profile,$.type,$.excludeObsolete,$.validate,$.productVersion,$.productDate,$.productCommit,$.devMode,$.language,$.translations);return this.scanExtension(K)}));return(0,D.coalesce)(H).sort((B,K)=>B.location.path<K.location.path?-1:1)}async scanExtensionsFromProfile($){let J=await this.scanExtensionsFromProfileResource($.location,()=>!0,$);if($.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual($.location,$.applicationExtensionslocation)){J=J.filter(B=>!B.metadata?.isApplicationScoped);const H=await this.scanExtensionsFromProfileResource($.applicationExtensionslocation,B=>!!B.metadata?.isApplicationScoped,$);J.push(...H)}return J}async scanExtensionsFromProfileResource($,J,H){const B=await this.extensionsProfileScannerService.scanProfileExtensions($);if(!B.length)return[];const K=await Promise.all(B.map(async ie=>{if(J(ie)){const ce=new F(ie.location,H.mtime,H.applicationExtensionslocation,H.applicationExtensionslocationMtime,H.profile,H.type,H.excludeObsolete,H.validate,H.productVersion,H.productDate,H.productCommit,H.devMode,H.language,H.translations);return this.scanExtension(ce,ie.metadata)}return null}));return(0,D.coalesce)(K)}async scanOneOrMultipleExtensions($){try{if(await this.fileService.exists((0,y.joinPath)($.location,"package.json"))){const J=await this.scanExtension($);return J?[J]:[]}else return await this.scanExtensions($)}catch(J){return this.logService.error(`Error scanning extensions at ${$.location.path}:`,(0,A.getErrorMessage)(J)),[]}}async scanExtension($,J){try{let H=await this.scanExtensionManifest($.location);if(H){H.publisher||(H.publisher=u.UNDEFINED_PUBLISHER),J=J??H.__metadata,delete H.__metadata;const B=(0,d.getGalleryExtensionId)(H.publisher,H.name),K=J?.id?{id:B,uuid:J.id}:{id:B},ie=J?.isSystem?0:$.type,ce=ie===0||!!J?.isBuiltin;H=await this.translateManifest($.location,H,F.createNlsConfiguration($));const z={type:ie,identifier:K,manifest:H,location:$.location,isBuiltin:ce,targetPlatform:J?.targetPlatform??"undefined",metadata:J,isValid:!0,validations:[]};return $.validate?this.validate(z,$):z}}catch(H){$.type!==0&&this.logService.error(H)}return null}validate($,J){let H=!0;const B=(0,s.validateExtensionManifest)(J.productVersion,J.productDate,J.location,$.manifest,$.isBuiltin);for(const[K,ie]of B)K===S.default.Error&&(H=!1,this.logService.error(this.formatMessage(J.location,ie)));return $.isValid=H,$.validations=B,$}async scanExtensionManifest($){const J=(0,y.joinPath)($,"package.json");let H;try{H=(await this.fileService.readFile(J)).value.toString()}catch(K){return(0,r.toFileOperationResult)(K)!==1&&this.logService.error(this.formatMessage($,(0,g.localize)(0,null,J.path,K.message))),null}let B;try{B=JSON.parse(H)}catch{const ie=[];(0,b.parse)(H,ie);for(const ce of ie)this.logService.error(this.formatMessage($,(0,g.localize)(1,null,J.path,ce.offset,ce.length,(0,P.getParseErrorMessage)(ce.error))));return null}return(0,b.getNodeType)(B)!=="object"?(this.logService.error(this.formatMessage($,(0,g.localize)(2,null,J.path))),null):B}async translateManifest($,J,H){const B=await this.getLocalizedMessages($,J,H);if(B)try{const K=[],ie=await this.resolveOriginalMessageBundle(B.default,K);if(K.length>0)return K.forEach(z=>{this.logService.error(this.formatMessage($,(0,g.localize)(3,null,B.default?.path,(0,P.getParseErrorMessage)(z.error))))}),J;if((0,b.getNodeType)(B)!=="object")return this.logService.error(this.formatMessage($,(0,g.localize)(4,null,B.default?.path))),J;const ce=B.values||Object.create(null);this.replaceNLStrings(H.pseudo,J,ce,ie,$)}catch{}return J}async getLocalizedMessages($,J,H){const B=(0,y.joinPath)($,"package.nls.json"),K=(x,_)=>{_.forEach(U=>{this.logService.error(this.formatMessage($,(0,g.localize)(5,null,x?.path,(0,P.getParseErrorMessage)(U.error))))})},ie=x=>{this.logService.error(this.formatMessage($,(0,g.localize)(6,null,x?.path)))},ce=`${J.publisher}.${J.name}`,z=H.translations[ce];if(z)try{const x=m.URI.file(z),_=(await this.fileService.readFile(x)).value.toString(),U=[],q=(0,b.parse)(_,U);return U.length>0?(K(x,U),{values:void 0,default:B}):(0,b.getNodeType)(q)!=="object"?(ie(x),{values:void 0,default:B}):{values:q.contents?q.contents.package:void 0,default:B}}catch{return{values:void 0,default:B}}else{if(!await this.fileService.exists(B))return;let _;try{_=await this.findMessageBundles($,H)}catch{return}if(!_.localized)return{values:void 0,default:_.original};try{const U=(await this.fileService.readFile(_.localized)).value.toString(),q=[],j=(0,b.parse)(U,q);return q.length>0?(K(_.localized,q),{values:void 0,default:_.original}):(0,b.getNodeType)(j)!=="object"?(ie(_.localized),{values:void 0,default:_.original}):{values:j,default:_.original}}catch{return{values:void 0,default:_.original}}}}async resolveOriginalMessageBundle($,J){if($)try{const H=(await this.fileService.readFile($)).value.toString();return(0,b.parse)(H,J)}catch{return null}else return null}findMessageBundles($,J){return new Promise((H,B)=>{const K=ie=>{const ce=(0,y.joinPath)($,`package.nls.${ie}.json`);this.fileService.exists(ce).then(z=>{z&&H({localized:ce,original:(0,y.joinPath)($,"package.nls.json")});const x=ie.lastIndexOf("-");x===-1?H({localized:(0,y.joinPath)($,"package.nls.json"),original:null}):(ie=ie.substring(0,x),K(ie))})};if(J.devMode||J.pseudo||!J.language)return H({localized:(0,y.joinPath)($,"package.nls.json"),original:null});K(J.language)})}replaceNLStrings($,J,H,B,K){const ie=(ce,z,x)=>{const _=ce[z];if((0,C.isString)(_)){const U=_,q=U.length;if(q>1&&U[0]==="%"&&U[q-1]==="%"){const j=U.substr(1,q-2);let Z=H[j];Z===void 0&&B&&(Z=B[j]);let oe=typeof Z=="string"?Z:Z.message;if(oe!==void 0)if($&&(oe="\uFF3B"+oe.replace(/[aouei]/g,"$&$&")+"\uFF3D"),x&&B&&(z==="title"||z==="category")){const Q=B[j],te={value:oe,original:typeof Q=="string"?Q:Q?.message};ce[z]=te}else ce[z]=oe;else this.logService.warn(this.formatMessage(K,(0,g.localize)(7,null,j)))}}else if((0,C.isObject)(_))for(const U in _)_.hasOwnProperty(U)&&(U==="commands"?ie(_,U,!0):ie(_,U,x));else if(Array.isArray(_))for(let U=0;U<_.length;U++)ie(_,U,x)};for(const ce in J)J.hasOwnProperty(ce)&&ie(J,ce)}formatMessage($,J){return`[${$.path}]: ${J}`}};T=me([G(1,h.IExtensionsProfileScannerService),G(2,R.IUriIdentityService),G(3,r.IFileService),G(4,i.ILogService)],T);let N=class extends T{constructor($,J,H,B,K,ie){super(J,H,B,K,ie);this.cacheFile=$,this.cacheValidatorThrottler=this._register(new n.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new l.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions($){const J=await this.readExtensionCache();if(this.input=$,J&&J.input&&F.equals(J.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),J.result.map(B=>(B.location=m.URI.revive(B.location),B));const H=await super.scanExtensions($);return await this.writeExtensionCache({input:$,result:H}),H}async readExtensionCache(){try{const $=await this.fileService.readFile(this.cacheFile),J=JSON.parse($.value.toString());return{result:J.result,input:(0,a.revive)(J.input)}}catch($){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)($))}return null}async writeExtensionCache($){try{await this.fileService.writeFile(this.cacheFile,L.VSBuffer.fromString(JSON.stringify($)))}catch(J){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(J))}}async validateCache(){if(!this.input)return;const $=await this.readExtensionCache();if(!$)return;const J=$.result,H=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!k.equals(H,J))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(B){this.logService.error(B)}}};N=me([G(2,h.IExtensionsProfileScannerService),G(3,R.IUriIdentityService),G(4,r.IFileService),G(5,i.ILogService)],N);function W(Y,$){const J=(0,d.getExtensionId)(Y.manifest.publisher,Y.manifest.name);return{id:J,identifier:new u.ExtensionIdentifier(J),isBuiltin:Y.type===0,isUserBuiltin:Y.type===1&&Y.isBuiltin,isUnderDevelopment:$,extensionLocation:Y.location,uuid:Y.identifier.uuid,targetPlatform:Y.targetPlatform,...Y.manifest}}e.toExtensionDescription=W;class V extends O{constructor($,J,H,B,K,ie,ce,z,x,_,U){super($,J,(0,y.joinPath)(H,".vscode-oss-dev","extensions","control.json"),(0,y.joinPath)(B,u.MANIFEST_CACHE_FOLDER),K,ie,ce,z,x,_,U);this.translationsPromise=(async()=>{if(v.translationsConfigFile)try{const q=await this.fileService.readFile(m.URI.file(v.translationsConfigFile));return JSON.parse(q.value.toString())}catch{}return Object.create(null)})()}getTranslations($){return this.translationsPromise}}e.NativeExtensionsScannerService=V}),define(re[246],se([0,1,2,17,28,44,13,29]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DefaultExtensionsProfileInitService=void 0;let P=class extends D.Disposable{constructor(E,w,v,y){super();this.userDataProfilesService=E,this.fileService=w,this.extensionManagementService=v,this.extensionsProfileScannerService=y}async initialize(){const E=this.getDefaultExtensionsProfileResource();try{await this.fileService.del(E)}catch{}const w=await this.extensionManagementService.getInstalled(1),v=await Promise.all(w.map(async y=>[y,await this.extensionManagementService.getMetadata(y)]));await this.extensionsProfileScannerService.addExtensionsToProfile(v,E)}async uninitialize(){try{await this.fileService.del(this.getDefaultExtensionsProfileResource())}catch{}}getDefaultExtensionsProfileResource(){return this.userDataProfilesService.defaultProfile.extensionsResource??(0,n.joinPath)(this.userDataProfilesService.defaultProfile.location,b.EXTENSIONS_RESOURCE_NAME)}};P=me([G(0,b.IUserDataProfilesService),G(1,A.IFileService),G(2,k.IExtensionManagementService),G(3,L.IExtensionsProfileScannerService)],P),e.DefaultExtensionsProfileInitService=P}),define(re[247],se([0,1,54,6,38,3,2,20,10,27,8,29]),function(X,e,D,n,k,L,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsLifecycle=void 0;let v=class extends A.Disposable{constructor(f,S){super();this.userDataProfilesService=f,this.logService=S,this.processesLimiter=new n.Limiter(5)}async postUninstall(f){const S=this.parseScript(f,"uninstall");return S&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(S.script,"uninstall",S.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),C=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${C}`)))),I.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,C=>this.logService.error("Error while removing extension storage path",C))}parseScript(f,S){const C=`vscode:${S}`;if(f.location.scheme===b.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[C]=="string"){const m=f.manifest.scripts[C].split(" ");return m.length<2||m[0]!=="node"||!m[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${C} should be a node script`),null):{script:(0,P.join)(f.location.fsPath,m[1]),args:m.slice(2)||[]}}return null}runLifecycleHook(f,S,C,m,g){return new Promise((c,d)=>{const u=this.start(f,S,C,g);let s;const r=t=>{s&&(clearTimeout(s),s=null),t?d(t):c(void 0)};u.on("error",t=>{r((0,k.toErrorMessage)(t)||"Unknown")}),u.on("exit",(t,i)=>{r(t?`post-${S} process exited with code ${t}`:void 0)}),m&&(s=setTimeout(()=>{s=null,u.kill(),d("timed out")},5e3))})}start(f,S,C,m){const g={silent:!0,execArgv:void 0},c=(0,D.fork)(f,[`--type=extension-post-${S}`,...C],g);c.stdout.setEncoding("utf8"),c.stderr.setEncoding("utf8");const d=L.Event.fromNodeEventEmitter(c.stdout,"data"),u=L.Event.fromNodeEventEmitter(c.stderr,"data");d(t=>this.logService.info(m.identifier.id,m.manifest.version,`post-${S}`,t)),u(t=>this.logService.error(m.identifier.id,m.manifest.version,`post-${S}`,t));const s=L.Event.any(L.Event.map(d,t=>({data:`%c${t}`,format:[""]})),L.Event.map(u,t=>({data:`%c${t}`,format:["color: red"]})));return L.Event.debounce(s,(t,i)=>t?{data:t.data+i.data,format:[...t.format,...i.format]}:{data:i.data,format:i.format},100)(t=>{console.group(m.identifier.id),console.log(t.data,...t.format),console.groupEnd()}),c}getExtensionStoragePath(f){return(0,P.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};v=me([G(0,w.IUserDataProfilesService),G(1,E.ILogService)],v),e.ExtensionsLifecycle=v}),define(re[248],se([0,1,7,14,44,71,13,5,8,24,29]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsScannerService=void 0;let w=class extends L.NativeExtensionsScannerService{constructor(y,f,S,C,m,g,c){super(D.URI.file(m.builtinExtensionsPath),D.URI.file(m.extensionsPath),m.userHome,D.URI.file(m.userDataPath),y,f,S,C,m,g,c)}};w=me([G(0,E.IUserDataProfilesService),G(1,k.IExtensionsProfileScannerService),G(2,A.IFileService),G(3,P.ILogService),G(4,n.INativeEnvironmentService),G(5,I.IProductService),G(6,b.IInstantiationService)],w),e.ExtensionsScannerService=w}),define(re[23],se([0,1,6,3,2,188,15,86,5,29]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.logStorage=e.InMemoryStorageService=e.isProfileUsingDefaultStorage=e.AbstractStorageService=e.StorageTarget=e.StorageScope=e.WillSaveStateReason=e.IStorageService=e.IS_NEW_KEY=void 0,e.IS_NEW_KEY="__$__isNewStorageMarker";const E="__$__targetStorageMarker";e.IStorageService=(0,P.createDecorator)("storageService");var w;(function(g){g[g.NONE=0]="NONE",g[g.SHUTDOWN=1]="SHUTDOWN"})(w=e.WillSaveStateReason||(e.WillSaveStateReason={}));var v;(function(g){g[g.APPLICATION=-1]="APPLICATION",g[g.PROFILE=0]="PROFILE",g[g.WORKSPACE=1]="WORKSPACE"})(v=e.StorageScope||(e.StorageScope={}));var y;(function(g){g[g.USER=0]="USER",g[g.MACHINE=1]="MACHINE"})(y=e.StorageTarget||(e.StorageTarget={}));class f extends k.Disposable{constructor(c={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=c,this._onDidChangeValue=this._register(new n.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new n.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new n.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new D.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new k.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,D.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,k.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,L.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,L.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(c,d){if(d===E){switch(c){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:c})}else this._onDidChangeValue.fire({scope:c,key:d,target:this.getKeyTargets(c)[d]})}emitWillSaveState(c){this._onWillSaveState.fire({reason:c})}get(c,d,u){return this.getStorage(d)?.get(c,u)}getBoolean(c,d,u){return this.getStorage(d)?.getBoolean(c,u)}getNumber(c,d,u){return this.getStorage(d)?.getNumber(c,u)}store(c,d,u,s){if((0,A.isUndefinedOrNull)(d)){this.remove(c,u);return}this.withPausedEmitters(()=>{this.updateKeyTarget(c,u,s),this.getStorage(u)?.set(c,d)})}remove(c,d){this.withPausedEmitters(()=>{this.updateKeyTarget(c,d,void 0),this.getStorage(d)?.delete(c)})}withPausedEmitters(c){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{c()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(c,d){const u=[],s=this.getKeyTargets(c);for(const r of Object.keys(s))s[r]===d&&u.push(r);return u}updateKeyTarget(c,d,u){const s=this.getKeyTargets(d);typeof u=="number"?s[c]!==u&&(s[c]=u,this.getStorage(d)?.set(E,JSON.stringify(s))):typeof s[c]=="number"&&(delete s[c],this.getStorage(d)?.set(E,JSON.stringify(s)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(c){switch(c){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(c){const d=this.get(E,c);if(d)try{return JSON.parse(d)}catch{}return Object.create(null)}isNew(c){return this.getBoolean(e.IS_NEW_KEY,c)===!0}async flush(c=w.NONE){this._onWillSaveState.fire({reason:c});const d=this.getStorage(-1),u=this.getStorage(0),s=this.getStorage(1);switch(c){case w.NONE:await D.Promises.settled([d?.whenFlushed()??Promise.resolve(),u?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve()]);break;case w.SHUTDOWN:await D.Promises.settled([d?.flush(0)??Promise.resolve(),u?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve()]);break}}async log(){const c=this.getStorage(-1)?.items??new Map,d=this.getStorage(0)?.items??new Map,u=this.getStorage(1)?.items??new Map;return m(c,d,u,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(c,d){return this.emitWillSaveState(w.NONE),(0,I.isUserDataProfile)(c)?this.switchToProfile(c,d):this.switchToWorkspace(c,d)}canSwitchProfile(c,d){return!(c.id===d.id||S(d)&&S(c))}switchData(c,d,u,s){this.withPausedEmitters(()=>{if(s)for(const[r,t]of c)d.set(r,t);else{const r=new Set;for(const[t,i]of c)r.add(t),d.get(t)!==i&&this.emitDidChangeValue(u,t);for(const[t]of d.items)r.has(t)||this.emitDidChangeValue(u,t)}})}}e.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function S(g){return g.isDefault||!!g.useDefaultFlags?.uiState}e.isProfileUsingDefaultStorage=S;class C extends f{constructor(){super();this.applicationStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.profileStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new b.Storage(new b.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(c=>this.emitDidChangeValue(1,c))),this._register(this.profileStorage.onDidChangeStorage(c=>this.emitDidChangeValue(0,c))),this._register(this.applicationStorage.onDidChangeStorage(c=>this.emitDidChangeValue(-1,c)))}getStorage(c){switch(c){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(c){switch(c){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}e.InMemoryStorageService=C;async function m(g,c,d,u,s,r){const t=O=>{try{return JSON.parse(O)}catch{return O}},i=new Map,o=new Map;g.forEach((O,F)=>{i.set(F,O),o.set(F,t(O))});const l=new Map,a=new Map;c.forEach((O,F)=>{l.set(F,O),a.set(F,t(O))});const h=new Map,p=new Map;d.forEach((O,F)=>{h.set(F,O),p.set(F,t(O))}),console.group(u!==s?`Storage: Application (path: ${u})`:`Storage: Application & Profile (path: ${u}, default profile)`);const R=[];if(i.forEach((O,F)=>{R.push({key:F,value:O})}),console.table(R),console.groupEnd(),console.log(o),u!==s){console.group(`Storage: Profile (path: ${s}, profile specific)`);const O=[];l.forEach((F,T)=>{O.push({key:T,value:F})}),console.table(O),console.groupEnd(),console.log(a)}console.group(`Storage: Workspace (path: ${r})`);const M=[];h.forEach((O,F)=>{M.push({key:F,value:O})}),console.table(M),console.groupEnd(),console.log(p)}e.logStorage=m}),define(re[249],se([0,1,3,2,15,28,32,23]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.StorageManager=e.GlobalExtensionEnablementService=void 0;let P=class extends n.Disposable{constructor(w,v){super();this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this.storageManger=this._register(new I(w)),this._register(this.storageManger.onDidChange(y=>this._onDidChangeEnablement.fire({extensions:y,source:"storage"}))),this._register(v.onDidInstallExtensions(y=>y.forEach(({local:f,operation:S})=>{f&&S===4&&this._removeFromDisabledExtensions(f.identifier)})))}async enableExtension(w,v){return this._removeFromDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:v}),!0):!1}async disableExtension(w,v){return this._addToDisabledExtensions(w)?(this._onDidChangeEnablement.fire({extensions:[w],source:v}),!0):!1}getDisabledExtensions(){return this._getExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH)}async getDisabledExtensionsAsync(){return this.getDisabledExtensions()}_addToDisabledExtensions(w){const v=this.getDisabledExtensions();return v.every(y=>!(0,A.areSameExtensions)(y,w))?(v.push(w),this._setDisabledExtensions(v),!0):!1}_removeFromDisabledExtensions(w){const v=this.getDisabledExtensions();for(let y=0;y<v.length;y++){const f=v[y];if((0,A.areSameExtensions)(f,w))return v.splice(y,1),this._setDisabledExtensions(v),!0}return!1}_setDisabledExtensions(w){this._setExtensions(L.DISABLED_EXTENSIONS_STORAGE_PATH,w)}_getExtensions(w){return this.storageManger.get(w,0)}_setExtensions(w,v){this.storageManger.set(w,v,0)}};P=me([G(0,b.IStorageService),G(1,L.IExtensionManagementService)],P),e.GlobalExtensionEnablementService=P;class I extends n.Disposable{constructor(w){super();this.storageService=w,this.storage=Object.create(null),this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this._register(w.onDidChangeValue(v=>this.onDidStorageChange(v)))}get(w,v){let y;return v===0?((0,k.isUndefinedOrNull)(this.storage[w])&&(this.storage[w]=this._get(w,v)),y=this.storage[w]):y=this._get(w,v),JSON.parse(y)}set(w,v,y){const f=JSON.stringify(v.map(({id:C,uuid:m})=>({id:C,uuid:m})));this._get(w,y)!==f&&(y===0&&(v.length?this.storage[w]=f:delete this.storage[w]),this._set(w,v.length?f:void 0,y))}onDidStorageChange(w){if(w.scope===0&&!(0,k.isUndefinedOrNull)(this.storage[w.key])&&this._get(w.key,w.scope)!==this.storage[w.key]){const y=this.get(w.key,w.scope);delete this.storage[w.key];const f=this.get(w.key,w.scope),S=y.filter(m=>!f.some(g=>(0,A.areSameExtensions)(m,g))),C=f.filter(m=>!y.some(g=>(0,A.areSameExtensions)(g,m)));(S.length||C.length)&&this._onDidChange.fire([...S,...C])}}_get(w,v){return this.storageService.get(w,v,"[]")}_set(w,v,y){v?this.storageService.store(w,v,y,1):this.storageService.remove(w,y)}}e.StorageManager=I}),define(re[250],se([0,1,18,21,9,4,36,15,7,19,14,28,32,65,13,8,24,45,217,23,22]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGalleryServiceWithNoStorageService=e.ExtensionGalleryService=e.sortExtensionVersions=void 0;const u=L.isWeb?"web":(0,w.getTargetPlatform)(L.platform,A.arch);var s;(function(_){_[_.None=0]="None",_[_.IncludeVersions=1]="IncludeVersions",_[_.IncludeFiles=2]="IncludeFiles",_[_.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",_[_.IncludeSharedAccounts=8]="IncludeSharedAccounts",_[_.IncludeVersionProperties=16]="IncludeVersionProperties",_[_.ExcludeNonValidated=32]="ExcludeNonValidated",_[_.IncludeInstallationTargets=64]="IncludeInstallationTargets",_[_.IncludeAssetUri=128]="IncludeAssetUri",_[_.IncludeStatistics=256]="IncludeStatistics",_[_.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",_[_.Unpublished=4096]="Unpublished",_[_.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(s||(s={}));function r(..._){return String(_.reduce((U,q)=>U|q,0))}var t;(function(_){_[_.Tag=1]="Tag",_[_.ExtensionId=4]="ExtensionId",_[_.Category=5]="Category",_[_.ExtensionName=7]="ExtensionName",_[_.Target=8]="Target",_[_.Featured=9]="Featured",_[_.SearchText=10]="SearchText",_[_.ExcludeWithFlags=12]="ExcludeWithFlags"})(t||(t={}));const i={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},a={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:s.None,criteria:[],assetTypes:[]};class h{constructor(U=a){this.state=U}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(U,q=this.state.pageSize){return new h({...this.state,pageNumber:U,pageSize:q})}withFilter(U,...q){const j=[...this.state.criteria,...q.length?q.map(Z=>({filterType:U,value:Z})):[{filterType:U}]];return new h({...this.state,criteria:j})}withSortBy(U){return new h({...this.state,sortBy:U})}withSortOrder(U){return new h({...this.state,sortOrder:U})}withFlags(...U){return new h({...this.state,flags:U.reduce((q,j)=>q|j,0)})}withAssetTypes(...U){return new h({...this.state,assetTypes:U})}withSource(U){return new h({...this.state,source:U})}get raw(){const{criteria:U,pageNumber:q,pageSize:j,sortBy:Z,sortOrder:oe,flags:Q,assetTypes:te}=this.state;return{filters:[{criteria:U,pageNumber:q,pageSize:j,sortBy:Z,sortOrder:oe}],assetTypes:te,flags:Q}}get searchText(){const U=this.state.criteria.filter(q=>q.filterType===t.SearchText)[0];return U&&U.value?U.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(U=>String(U.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function p(_,U){const q=(_||[]).filter(j=>j.statisticName===U)[0];return q?q.value:0}function R(_){const U="Microsoft.VisualStudio.Code.Translation.";return _.files.filter(j=>j.assetType.indexOf(U)===0).reduce((j,Z)=>{const oe=F(_,Z.assetType);return oe&&j.push([Z.assetType.substring(U.length),oe]),j},[])}function M(_){if(_.properties){const U=_.properties.filter(Z=>Z.key===i.Repository),q=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=U.filter(Z=>q.test(Z.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return F(_,i.Repository)}function O(_){return{uri:`${_.fallbackAssetUri}/${i.VSIX}?redirect=true${_.targetPlatform?`&targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${i.VSIX}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}}function F(_,U){return _.files.filter(j=>j.assetType===U)[0]?{uri:`${_.assetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`,fallbackUri:`${_.fallbackAssetUri}/${U}${_.targetPlatform?`?targetPlatform=${_.targetPlatform}`:""}`}:null}function T(_,U){const q=_.properties?_.properties.filter(Z=>Z.key===U):[],j=q.length>0&&q[0].value;return j?j.split(",").map(Z=>(0,v.adoptToGalleryExtensionId)(Z)):[]}function N(_){const U=_.properties?_.properties.filter(q=>q.key===o.Engine):[];return U.length>0&&U[0].value||""}function W(_){const U=_.properties?_.properties.filter(q=>q.key===o.PreRelease):[];return U.length>0&&U[0].value==="true"}function V(_){const U=_.properties?_.properties.filter(j=>j.key===o.LocalizedLanguages):[],q=U.length>0&&U[0].value||"";return q?q.split(","):[]}function Y(_){return _.properties?.find(U=>U.key===o.SponsorLink)?.value}function $(_){return _.indexOf("preview")!==-1}function J(_){return _.targetPlatform?(0,w.toTargetPlatform)(_.targetPlatform):"undefined"}function H(_){const U=(0,D.distinct)(_.versions.map(J)),q=!!_.tags?.includes(w.WEB_EXTENSION_TAG),j=U.indexOf("web");return q?j===-1&&U.push("web"):j!==-1&&U.splice(j,1),U}function B(_,U){const q=(0,w.getFallbackTargetPlarforms)(U);for(let j=0;j<_.length;j++){const Z=_[j];if(Z.version===_[j-1]?.version){let oe=j;const Q=J(Z);if(Q===U)for(;oe>0&&_[oe-1].version===Z.version;)oe--;else if(q.includes(Q))for(;oe>0&&_[oe-1].version===Z.version&&J(_[oe-1])!==U;)oe--;oe!==j&&(_.splice(j,1),_.splice(oe,0,Z))}}return _}e.sortExtensionVersions=B;function K(_,U,q){_.telemetryData={index:U,querySource:q}}function ie(_,U,q){const j=_.versions[0],Z={manifest:F(U,i.Manifest),readme:F(U,i.Details),changelog:F(U,i.Changelog),license:F(U,i.License),repository:M(U),download:O(U),icon:F(U,i.Icon),coreTranslations:R(U)};return{identifier:{id:(0,v.getGalleryExtensionId)(_.publisher.publisherName,_.extensionName),uuid:_.extensionId},name:_.extensionName,version:U.version,displayName:_.displayName,publisherId:_.publisher.publisherId,publisher:_.publisher.publisherName,publisherDisplayName:_.publisher.displayName,publisherDomain:_.publisher.domain?{link:_.publisher.domain,verified:!!_.publisher.isDomainVerified}:void 0,publisherSponsorLink:Y(j),description:_.shortDescription||"",installCount:p(_.statistics,"install"),rating:p(_.statistics,"averagerating"),ratingCount:p(_.statistics,"ratingcount"),categories:_.categories||[],tags:_.tags||[],releaseDate:Date.parse(_.releaseDate),lastUpdated:Date.parse(_.lastUpdated),allTargetPlatforms:q,assets:Z,properties:{dependencies:T(U,o.Dependency),extensionPack:T(U,o.ExtensionPack),engine:N(U),localizedLanguages:V(U),targetPlatform:J(U),isPreReleaseVersion:W(U)},hasPreReleaseVersion:W(j),hasReleaseVersion:!0,preview:$(_.flags)}}let ce=class{constructor(U,q,j,Z,oe,Q,te,ne){this.requestService=q,this.logService=j,this.environmentService=Z,this.telemetryService=oe,this.fileService=Q,this.productService=te,this.configurationService=ne;const ue=te.extensionsGallery;this.extensionsGalleryUrl=ue&&ue.serviceUrl,this.extensionsControlUrl=ue&&ue.controlUrl,this.commonHeadersPromise=(0,g.resolveMarketplaceHeaders)(te.version,te,this.environmentService,this.configurationService,this.fileService,U,this.telemetryService)}api(U=""){return`${this.extensionsGalleryUrl}${U}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(U,q,j){const Z=n.CancellationToken.isCancellationToken(q)?{}:q,oe=n.CancellationToken.isCancellationToken(q)?q:j,Q=[],te=[],ne=[],ue=[];let he=!0;for(const Ce of U){Ce.uuid?te.push(Ce.uuid):Q.push(Ce.id);const Pe=!!(Ce.version||Ce.preRelease);ne.push({id:Ce.id,uuid:Ce.uuid,includePreRelease:Pe}),Ce.version&&ue.push({id:Ce.id,uuid:Ce.uuid,version:Ce.version}),he=he&&!!Ce.hasPreRelease&&!Pe}if(!te.length&&!Q.length)return[];let pe=new h().withPage(1,U.length);te.length&&(pe=pe.withFilter(t.ExtensionId,...te)),Q.length&&(pe=pe.withFilter(t.ExtensionName,...Q)),(Z.queryAllVersions||he)&&(pe=pe.withFlags(pe.flags,s.IncludeVersions)),Z.source&&(pe=pe.withSource(Z.source));const{extensions:we}=await this.queryGalleryExtensions(pe,{targetPlatform:Z.targetPlatform??u,includePreRelease:ne,versions:ue,compatible:!!Z.compatible},oe);return Z.source&&we.forEach((Ce,Pe)=>K(Ce,Pe,Z.source)),we}async getCompatibleExtension(U,q,j){if((0,w.isNotWebExtensionInWebTargetPlatform)(U.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(U,q,j))return U;const Z=new h().withFlags(s.IncludeVersions).withPage(1,1).withFilter(t.ExtensionId,U.identifier.uuid),{extensions:oe}=await this.queryGalleryExtensions(Z,{targetPlatform:j,compatible:!0,includePreRelease:q},n.CancellationToken.None);return oe[0]||null}async isExtensionCompatible(U,q,j){if(!(0,w.isTargetPlatformCompatible)(U.properties.targetPlatform,U.allTargetPlatforms,j)||!q&&U.properties.isPreReleaseVersion)return!1;let Z=U.properties.engine;if(!Z){const oe=await this.getManifest(U,n.CancellationToken.None);if(!oe)throw new Error("Manifest was not found");Z=oe.engines.vscode}return(0,y.isEngineValid)(Z,this.productService.version,this.productService.date)}async isValidVersion(U,q,j,Z,oe){if(!(0,w.isTargetPlatformCompatible)(J(U),Z,oe)||q!=="any"&&W(U)!==(q==="prerelease"))return!1;if(j)try{const Q=await this.getEngine(U);if(!(0,y.isEngineValid)(Q,this.productService.version,this.productService.date))return!1}catch(Q){return this.logService.error(`Error while getting the engine for the version ${U.version}.`,(0,k.getErrorMessage)(Q)),!1}return!0}async query(U,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=U.text||"";const Z=U.pageSize??50;let oe=new h().withPage(1,Z);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,we)=>(oe=oe.withFilter(t.Category,we||pe),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(he,pe,we)=>(oe=oe.withFilter(t.Tag,we||pe),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(oe=oe.withFilter(t.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),oe=oe.withFilter(t.SearchText,j)),oe=oe.withSortBy(0)):U.ids?oe=oe.withFilter(t.ExtensionId,...U.ids):U.names?oe=oe.withFilter(t.ExtensionName,...U.names):oe=oe.withSortBy(4),typeof U.sortBy=="number"&&(oe=oe.withSortBy(U.sortBy)),typeof U.sortOrder=="number"&&(oe=oe.withSortOrder(U.sortOrder)),U.source&&(oe=oe.withSource(U.source));const Q=async(he,pe)=>{const{extensions:we,total:Ce}=await this.queryGalleryExtensions(he,{targetPlatform:u,compatible:!1,includePreRelease:!!U.includePreRelease},pe);return we.forEach((Pe,Ue)=>K(Pe,(he.pageNumber-1)*he.pageSize+Ue,U.source)),{extensions:we,total:Ce}},{extensions:te,total:ne}=await Q(oe,q),ue=async(he,pe)=>{if(pe.isCancellationRequested)throw new k.CancellationError;const{extensions:we}=await Q(oe.withPage(he+1),pe);return we};return{firstPage:te,total:ne,pageSize:oe.pageSize,getPage:ue}}async queryGalleryExtensions(U,q,j){const Z=U.flags;!!(U.flags&s.IncludeLatestVersionOnly)&&!!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags&~s.IncludeVersions,s.IncludeLatestVersionOnly)),!(U.flags&s.IncludeLatestVersionOnly)&&!(U.flags&s.IncludeVersions)&&(U=U.withFlags(U.flags,s.IncludeLatestVersionOnly)),q.versions?.length&&(U=U.withFlags(U.flags&~s.IncludeLatestVersionOnly,s.IncludeVersions)),U=U.withFlags(U.flags,s.IncludeAssetUri,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeStatistics,s.IncludeVersionProperties);const{galleryExtensions:oe,total:Q}=await this.queryRawGalleryExtensions(U,j);if(!(U.flags&s.IncludeLatestVersionOnly)){const he=[];for(const pe of oe){const we=await this.toGalleryExtensionWithCriteria(pe,q);we&&he.push(we)}return{extensions:he,total:Q}}const ne=[],ue=new Map;for(let he=0;he<oe.length;he++){const pe=oe[he],we={id:(0,v.getGalleryExtensionId)(pe.publisher.publisherName,pe.extensionName),uuid:pe.extensionId},Ce=(0,b.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(Ue=>(0,v.areSameExtensions)(Ue,we))?.includePreRelease;if(q.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(H(pe),q.targetPlatform))continue;const Pe=await this.toGalleryExtensionWithCriteria(pe,q);!Pe||Pe.properties.isPreReleaseVersion&&(!Ce||!Pe.hasReleaseVersion)||!Pe.properties.isPreReleaseVersion&&Pe.properties.targetPlatform!==q.targetPlatform&&Pe.hasPreReleaseVersion?ue.set(pe.extensionId,he):ne.push([he,Pe])}if(ue.size){const he=new Date().getTime(),pe=new h().withFlags(Z&~s.IncludeLatestVersionOnly,s.IncludeVersions).withPage(1,ue.size).withFilter(t.ExtensionId,...ue.keys()),{extensions:we}=await this.queryGalleryExtensions(pe,q,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-he,count:ue.size});for(const Ce of we){const Pe=ue.get(Ce.identifier.uuid);ne.push([Pe,Ce])}}return{extensions:ne.sort((he,pe)=>he[0]-pe[0]).map(([,he])=>he),total:Q}}async toGalleryExtensionWithCriteria(U,q){const j={id:(0,v.getGalleryExtensionId)(U.publisher.publisherName,U.extensionName),uuid:U.extensionId},Z=q.versions?.find(ne=>(0,v.areSameExtensions)(ne,j))?.version,oe=(0,b.isBoolean)(q.includePreRelease)?q.includePreRelease:!!q.includePreRelease.find(ne=>(0,v.areSameExtensions)(ne,j))?.includePreRelease,Q=H(U),te=B(U.versions,q.targetPlatform);if(q.compatible&&(0,w.isNotWebExtensionInWebTargetPlatform)(Q,q.targetPlatform))return null;for(let ne=0;ne<te.length;ne++){const ue=te[ne];if(!(Z&&ue.version!==Z)){if(await this.isValidVersion(ue,oe?"any":"release",q.compatible,Q,q.targetPlatform))return ie(U,ue,Q);if(Z&&ue.version===Z)return null}}return Z||q.compatible?null:ie(U,U.versions[0],Q)}async queryRawGalleryExtensions(U,q){if(!this.isEnabled())throw new Error("No extension gallery service configured.");U=U.withFlags(U.flags,s.ExcludeNonValidated).withFilter(t.Target,"Microsoft.VisualStudio.Code").withFilter(t.ExcludeWithFlags,r(s.Unpublished));const j=await this.commonHeadersPromise,Z=JSON.stringify(U.raw),oe={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(Z.length)},Q=new Date().getTime();let te,ne,ue=0;try{if(te=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:Z,headers:oe},q),te.res.statusCode&&te.res.statusCode>=400&&te.res.statusCode<500)return{galleryExtensions:[],total:ue};const he=await(0,m.asJson)(te);if(he){const pe=he.results[0],we=pe.extensions,Ce=pe.resultMetadata&&pe.resultMetadata.filter(Pe=>Pe.metadataType==="ResultCount")[0];return ue=Ce&&Ce.metadataItems.filter(Pe=>Pe.name==="TotalCount")[0].count||0,{galleryExtensions:we,total:ue}}return{galleryExtensions:[],total:ue}}catch(he){throw ne=he,he}finally{this.telemetryService.publicLog2("galleryService:query",{...U.telemetryData,requestBodySize:String(Z.length),duration:new Date().getTime()-Q,success:!!te&&(0,m.isSuccess)(te),responseBodySize:te?.res.headers["Content-Length"],statusCode:te?String(te.res.statusCode):void 0,errorCode:ne?(0,k.isCancellationError)(ne)?"canceled":(0,k.getErrorMessage)(ne).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ue)})}}async reportStatistic(U,q,j,Z){if(!this.isEnabled())return;const oe=L.isWeb?this.api(`/itemName/${U}.${q}/version/${j}/statType/${Z==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${U}/extensions/${q}/${j}/stats?statType=${Z}`),Q=L.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",ne={...await this.commonHeadersPromise,Accept:Q};try{await this.requestService.request({type:"POST",url:oe,headers:ne},n.CancellationToken.None)}catch{}}async download(U,q,j){this.logService.trace("ExtensionGalleryService#download",U.identifier.id);const Z=(0,v.getGalleryExtensionTelemetryData)(U),oe=new Date().getTime(),Q=he=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...Z,duration:he}),te=j===2?"install":j===3?"update":"",ne=te?{uri:`${U.assets.download.uri}${P.URI.parse(U.assets.download.uri).query?"&":"?"}${te}=true`,fallbackUri:`${U.assets.download.fallbackUri}${P.URI.parse(U.assets.download.fallbackUri).query?"&":"?"}${te}=true`}:U.assets.download,ue=await this.getAsset(ne);await this.fileService.writeFile(q,ue.stream),Q(new Date().getTime()-oe)}async getReadme(U,q){if(U.assets.readme){const j=await this.getAsset(U.assets.readme,{},q);return await(0,m.asTextOrError)(j)||""}return""}async getManifest(U,q){if(U.assets.manifest){const j=await this.getAsset(U.assets.manifest,{},q),Z=await(0,m.asTextOrError)(j);return Z?JSON.parse(Z):null}return null}async getManifestFromRawExtensionVersion(U,q){const j=F(U,i.Manifest);if(!j)throw new Error("Manifest was not found");const Z={"Accept-Encoding":"gzip"},oe=await this.getAsset(j,{headers:Z});return await(0,m.asJson)(oe)}async getCoreTranslation(U,q){const j=U.assets.coreTranslations.filter(Z=>Z[0]===q.toUpperCase())[0];if(j){const Z=await this.getAsset(j[1]),oe=await(0,m.asTextOrError)(Z);return oe?JSON.parse(oe):null}return null}async getChangelog(U,q){if(U.assets.changelog){const j=await this.getAsset(U.assets.changelog,{},q);return await(0,m.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(U,q,j){let Z=new h().withFlags(s.IncludeVersions,s.IncludeCategoryAndTags,s.IncludeFiles,s.IncludeVersionProperties).withPage(1,1);U.identifier.uuid?Z=Z.withFilter(t.ExtensionId,U.identifier.uuid):Z=Z.withFilter(t.ExtensionName,U.identifier.id);const{galleryExtensions:oe}=await this.queryRawGalleryExtensions(Z,n.CancellationToken.None);if(!oe.length)return[];const Q=H(oe[0]);if((0,w.isNotWebExtensionInWebTargetPlatform)(Q,j))return[];const te=[];await Promise.all(oe[0].versions.map(async he=>{try{await this.isValidVersion(he,q?"any":"release",!0,Q,j)&&te.push(he)}catch{}}));const ne=[],ue=new Set;for(const he of B(te,j))ue.has(he.version)||(ue.add(he.version),ne.push({version:he.version,date:he.lastUpdated,isPreReleaseVersion:W(he)}));return ne}async getAsset(U,q={},j=n.CancellationToken.None){const Z=await this.commonHeadersPromise,oe={type:"GET"},Q={...Z,...q.headers||{}};q={...q,...oe,headers:Q};const te=U.uri,ne=U.fallbackUri,ue={...q,url:te};try{const he=await this.requestService.request(ue,j);if(he.res.statusCode===200)return he;const pe=await(0,m.asTextOrError)(he);throw new Error(`Expected 200, got back ${he.res.statusCode} instead.

${pe}`)}catch(he){if((0,k.isCancellationError)(he))throw he;const pe=(0,k.getErrorMessage)(he);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:te,message:pe});const we={...q,url:ne};return this.requestService.request(we,j)}}async getEngine(U){let q=N(U);if(!q){const j=await this.getManifestFromRawExtensionVersion(U,n.CancellationToken.None);if(!j)throw new Error("Manifest was not found");q=j.engines.vscode}return q}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const U=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},n.CancellationToken.None);if(U.res.statusCode!==200)throw new Error("Could not get extensions report.");const q=await(0,m.asJson)(U),j=[],Z={};if(q){for(const oe of q.malicious)j.push({id:oe});if(q.migrateToPreRelease)for(const[oe,Q]of Object.entries(q.migrateToPreRelease))(!Q.engine||(0,y.isEngineValid)(Q.engine,this.productService.version,this.productService.date))&&(Z[oe.toLowerCase()]={disallowInstall:!0,extension:{id:Q.id,displayName:Q.displayName,autoMigrate:{storage:!!Q.migrateStorage},preRelease:!0}});if(q.deprecated)for(const[oe,Q]of Object.entries(q.deprecated))Q&&(Z[oe.toLowerCase()]=(0,b.isBoolean)(Q)?{}:Q)}return{malicious:j,deprecated:Z}}};ce=me([G(1,m.IRequestService),G(2,S.ILogService),G(3,E.IEnvironmentService),G(4,d.ITelemetryService),G(5,f.IFileService),G(6,C.IProductService),G(7,I.IConfigurationService)],ce);let z=class extends ce{constructor(U,q,j,Z,oe,Q,te,ne){super(U,q,j,Z,oe,Q,te,ne)}};z=me([G(0,c.IStorageService),G(1,m.IRequestService),G(2,S.ILogService),G(3,E.IEnvironmentService),G(4,d.ITelemetryService),G(5,f.IFileService),G(6,C.IProductService),G(7,I.IConfigurationService)],z),e.ExtensionGalleryService=z;let x=class extends ce{constructor(U,q,j,Z,oe,Q,te){super(void 0,U,q,j,Z,oe,Q,te)}};x=me([G(0,m.IRequestService),G(1,S.ILogService),G(2,E.IEnvironmentService),G(3,d.ITelemetryService),G(4,f.IFileService),G(5,C.IProductService),G(6,I.IConfigurationService)],x),e.ExtensionGalleryServiceWithNoStorageService=x}),define(re[72],se([0,1,5,3,2,23,32,24,18,8,15]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStorageService=e.IExtensionStorageService=void 0,e.IExtensionStorageService=(0,D.createDecorator)("IExtensionStorageService");const w=/^extensionKeys\/([^.]+\..+)@(\d+\.\d+\.\d+(-.*)?)$/;let v=class Je extends k.Disposable{constructor(f,S,C){super();this.storageService=f,this.productService=S,this.logService=C,this._onDidChangeExtensionStorageToSync=this._register(new n.Emitter),this.onDidChangeExtensionStorageToSync=this._onDidChangeExtensionStorageToSync.event,this.extensionsWithKeysForSync=Je.readAllExtensionsWithKeysForSync(f),this._register(this.storageService.onDidChangeValue(m=>this.onDidChangeStorageValue(m)))}static toKey(f){return`extensionKeys/${(0,A.adoptToGalleryExtensionId)(f.id)}@${f.version}`}static fromKey(f){const S=w.exec(f);if(S&&S[1])return{id:S[1],version:S[2]}}static async removeOutdatedExtensionVersions(f,S){const C=await f.getInstalled(),m=[];for(const[g,c]of Je.readAllExtensionsWithKeysForSync(S)){const d=C.find(u=>(0,A.areSameExtensions)(u.identifier,{id:g}))?.manifest.version;for(const u of c)d!==u&&m.push(Je.toKey({id:g,version:u}))}for(const g of m)S.remove(g,0)}static readAllExtensionsWithKeysForSync(f){const S=new Map,C=f.keys(0,1);for(const m of C){const g=Je.fromKey(m);if(g){let c=S.get(g.id.toLowerCase());c||S.set(g.id.toLowerCase(),c=[]),c.push(g.version)}}return S}onDidChangeStorageValue(f){if(f.scope!==0)return;if(this.extensionsWithKeysForSync.has(f.key.toLowerCase())){this._onDidChangeExtensionStorageToSync.fire();return}const S=Je.fromKey(f.key);if(S){if(this.storageService.get(f.key,0)===void 0)this.extensionsWithKeysForSync.delete(S.id.toLowerCase());else{let C=this.extensionsWithKeysForSync.get(S.id.toLowerCase());C||this.extensionsWithKeysForSync.set(S.id.toLowerCase(),C=[]),C.push(S.version),this._onDidChangeExtensionStorageToSync.fire()}return}}getExtensionId(f){if((0,E.isString)(f))return f;const S=f.manifest?f.manifest.publisher:f.publisher,C=f.manifest?f.manifest.name:f.name;return(0,A.getExtensionId)(S,C)}getExtensionState(f,S){const C=this.getExtensionId(f),m=this.storageService.get(C,S?0:1);if(m)try{return JSON.parse(m)}catch(g){this.logService.error(`[mainThreadStorage] unexpected error parsing storage contents (extensionId: ${C}, global: ${S}): ${g}`)}}setExtensionState(f,S,C){const m=this.getExtensionId(f);S===void 0?this.storageService.remove(m,C?0:1):this.storageService.store(m,JSON.stringify(S),C?0:1,1)}setKeysForSync(f,S){this.storageService.store(Je.toKey(f),JSON.stringify(S),0,1)}getKeysForSync(f){const S=this.productService.extensionSyncedKeys?.[f.id.toLowerCase()],C=this.storageService.get(Je.toKey(f),0),m=C?JSON.parse(C):void 0;return m&&S?(0,P.distinct)([...m,...S]):m||S}addToMigrationList(f,S){if(f!==S){const C=this.migrationList.filter(m=>!m.includes(f)&&!m.includes(S));C.push([f,S]),this.migrationList=C}}getSourceExtensionToMigrate(f){const S=this.migrationList.find(([,C])=>f===C);return S?S[0]:void 0}get migrationList(){const f=this.storageService.get("extensionStorage.migrationList",-1,"[]");try{const S=JSON.parse(f);if(Array.isArray(S))return S}catch{}return[]}set migrationList(f){f.length?this.storageService.store("extensionStorage.migrationList",JSON.stringify(f),-1,1):this.storageService.remove("extensionStorage.migrationList",-1)}};v=me([G(0,L.IStorageService),G(1,b.IProductService),G(2,I.ILogService)],v),e.ExtensionStorageService=v}),define(re[251],se([0,1,18,6,3,10,4,36,7,142,14,28,32,207,91,13,8,67,24,45,23,22]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionTipsService=void 0;const s="extensionTips/promptedExecutableTips",r="extensionTips/lastPromptedMediumImpExeTime";let t=class extends y.ExtensionTipsService{constructor(o,l,a,h,p,R,M,O,F,T){super(M,O,F,T);this.environmentService=o,this.telemetryService=l,this.extensionManagementService=a,this.storageService=h,this.nativeHostService=p,this.extensionRecommendationNotificationService=R,this.highImportanceExecutableTips=new Map,this.mediumImportanceExecutableTips=new Map,this.allOtherExecutableTips=new Map,this.highImportanceTipsByExe=new Map,this.mediumImportanceTipsByExe=new Map,O.exeBasedExtensionTips&&Object.entries(O.exeBasedExtensionTips).forEach(([N,W])=>{const V=[],Y=[],$=[];Object.entries(W.recommendations).forEach(([J,H])=>{H.important?W.important?V.push({extensionId:J,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):Y.push({extensionId:J,extensionName:H.name,isExtensionPack:!!H.isExtensionPack}):$.push({extensionId:J,extensionName:H.name,isExtensionPack:!!H.isExtensionPack})}),V.length&&this.highImportanceExecutableTips.set(N,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:V}),Y.length&&this.mediumImportanceExecutableTips.set(N,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:Y}),$.length&&this.allOtherExecutableTips.set(N,{exeFriendlyName:W.friendlyName,windowsPath:W.windowsPath,recommendations:$})}),(0,n.timeout)(3e3).then(async()=>{await this.collectTips(),this.promptHighImportanceExeBasedTip(),this.promptMediumImportanceExeBasedTip()})}async getImportantExecutableBasedTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips);return[...o,...l]}getOtherExecutableBasedTips(){return this.getValidExecutableBasedExtensionTips(this.allOtherExecutableTips)}async collectTips(){const o=await this.getValidExecutableBasedExtensionTips(this.highImportanceExecutableTips),l=await this.getValidExecutableBasedExtensionTips(this.mediumImportanceExecutableTips),a=await this.extensionManagementService.getInstalled();this.highImportanceTipsByExe=this.groupImportantTipsByExe(o,a),this.mediumImportanceTipsByExe=this.groupImportantTipsByExe(l,a)}groupImportantTipsByExe(o,l){const a=new Map;o.forEach(O=>a.set(O.extensionId.toLowerCase(),O));const{installed:h,uninstalled:p}=this.groupByInstalled([...a.keys()],l);for(const O of h){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:alreadyInstalled",{extensionId:O,exeName:F.exeName})}for(const O of p){const F=a.get(O);F&&this.telemetryService.publicLog2("exeExtensionRecommendations:notInstalled",{extensionId:O,exeName:F.exeName})}const R=this.getPromptedExecutableTips(),M=new Map;for(const O of p){const F=a.get(O);if(F&&(!R[F.exeName]||!R[F.exeName].includes(F.extensionId))){let T=M.get(F.exeName);T||(T=[],M.set(F.exeName,T)),T.push(F)}}return M}promptHighImportanceExeBasedTip(){if(this.highImportanceTipsByExe.size===0)return;const[o,l]=[...this.highImportanceTipsByExe.entries()][0];this.promptExeRecommendations(l).then(a=>{switch(a){case"reacted":this.addToRecommendedExecutables(l[0].exeName,l);break;case"ignored":this.highImportanceTipsByExe.delete(o);break;case"incompatibleWindow":{const h=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(h(()=>this.promptHighImportanceExeBasedTip()));break}case"toomany":{const h=this._register((0,n.disposableTimeout)(()=>{h.dispose(),this.promptHighImportanceExeBasedTip()},60*60*1e3));break}}})}promptMediumImportanceExeBasedTip(){if(this.mediumImportanceTipsByExe.size===0)return;const o=this.getLastPromptedMediumExeTime(),l=Date.now()-o,a=7*24*60*60*1e3;if(l<a){const R=this._register((0,n.disposableTimeout)(()=>{R.dispose(),this.promptMediumImportanceExeBasedTip()},a-l));return}const[h,p]=[...this.mediumImportanceTipsByExe.entries()][0];this.promptExeRecommendations(p).then(R=>{switch(R){case"reacted":{this.updateLastPromptedMediumExeTime(Date.now()),this.mediumImportanceTipsByExe.delete(h),this.addToRecommendedExecutables(p[0].exeName,p);const M=this._register((0,n.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},a));break}case"ignored":this.mediumImportanceTipsByExe.delete(h),this.promptMediumImportanceExeBasedTip();break;case"incompatibleWindow":{const M=k.Event.once(k.Event.latch(k.Event.any(this.nativeHostService.onDidOpenWindow,this.nativeHostService.onDidFocusWindow)));this._register(M(()=>this.promptMediumImportanceExeBasedTip()));break}case"toomany":{const M=this._register((0,n.disposableTimeout)(()=>{M.dispose(),this.promptMediumImportanceExeBasedTip()},60*60*1e3));break}}})}async promptExeRecommendations(o){const l=await this.extensionManagementService.getInstalled(1),a=o.filter(p=>!p.whenNotInstalled||p.whenNotInstalled.every(R=>l.every(M=>!(0,v.areSameExtensions)(M.identifier,{id:R})))).map(({extensionId:p})=>p.toLowerCase()),h=(0,I.localize)(0,null,o[0].exeFriendlyName);return this.extensionRecommendationNotificationService.promptImportantExtensionsInstallNotification(a,h,`@exe:"${o[0].exeName}"`,3)}getLastPromptedMediumExeTime(){let o=this.storageService.getNumber(r,-1);return o||(o=Date.now(),this.updateLastPromptedMediumExeTime(o)),o}updateLastPromptedMediumExeTime(o){this.storageService.store(r,o,-1,1)}getPromptedExecutableTips(){return JSON.parse(this.storageService.get(s,-1,"{}"))}addToRecommendedExecutables(o,l){const a=this.getPromptedExecutableTips();a[o]=l.map(({extensionId:h})=>h.toLowerCase()),this.storageService.store(s,JSON.stringify(a),-1,0)}groupByInstalled(o,l){const a=[],h=[],p=l.reduce((R,M)=>(R.add(M.identifier.id.toLowerCase()),R),new Set);return o.forEach(R=>{p.has(R.toLowerCase())?a.push(R):h.push(R)}),{installed:a,uninstalled:h}}async getValidExecutableBasedExtensionTips(o){const l=[],a=new Map;for(const h of o.keys()){const p=o.get(h);if(!p||!(0,D.isNonEmptyArray)(p.recommendations))continue;const R=[];A.isWindows?p.windowsPath&&R.push(p.windowsPath.replace("%USERPROFILE%",b.env.USERPROFILE).replace("%ProgramFiles(x86)%",b.env["ProgramFiles(x86)"]).replace("%ProgramFiles%",b.env.ProgramFiles).replace("%APPDATA%",b.env.APPDATA).replace("%WINDIR%",b.env.WINDIR)):(R.push((0,L.join)("/usr/local/bin",h)),R.push((0,L.join)("/usr/bin",h)),R.push((0,L.join)(this.environmentService.userHome.fsPath,h)));for(const M of R){let O=a.get(M);if(O===void 0&&(O=await this.fileService.exists(P.URI.file(M)),a.set(M,O)),O)for(const{extensionId:F,extensionName:T,isExtensionPack:N,whenNotInstalled:W}of p.recommendations)l.push({extensionId:F,extensionName:T,isExtensionPack:N,exeName:h,exeFriendlyName:p.exeFriendlyName,windowsPath:p.windowsPath,whenNotInstalled:W})}}return l}};t=me([G(0,E.INativeEnvironmentService),G(1,u.ITelemetryService),G(2,w.IExtensionManagementService),G(3,d.IStorageService),G(4,m.INativeHostService),G(5,f.IExtensionRecommendationNotificationService),G(6,S.IFileService),G(7,g.IProductService),G(8,c.IRequestService),G(9,C.ILogService)],t),e.ExtensionTipsService=t}),define(re[252],se([0,1,6,2,17,86,23,215]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeStorageService=void 0;class P extends A.AbstractStorageService{constructor(E,w,v,y){super();this.initialWorkspace=E,this.initialProfiles=w,this.mainProcessService=v,this.environmentService=y,this.applicationStorageProfile=this.initialProfiles.defaultProfile,this.applicationStorage=this.createApplicationStorage(),this.profileStorageProfile=this.initialProfiles.currentProfile,this.profileStorageDisposables=this._register(new n.DisposableStore),this.profileStorage=this.createProfileStorage(this.profileStorageProfile),this.workspaceStorageId=this.initialWorkspace?.id,this.workspaceStorageDisposables=this._register(new n.DisposableStore),this.workspaceStorage=this.createWorkspaceStorage(this.initialWorkspace)}createApplicationStorage(){const E=this._register(new b.ApplicationStorageDatabaseClient(this.mainProcessService.getChannel("storage"))),w=this._register(new L.Storage(E));return this._register(w.onDidChangeStorage(v=>this.emitDidChangeValue(-1,v))),w}createProfileStorage(E){this.profileStorageDisposables.clear(),this.profileStorageProfile=E;let w;if((0,A.isProfileUsingDefaultStorage)(E))w=this.applicationStorage;else{const v=this.profileStorageDisposables.add(new b.ProfileStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));w=this.profileStorageDisposables.add(new L.Storage(v))}return this.profileStorageDisposables.add(w.onDidChangeStorage(v=>this.emitDidChangeValue(0,v))),w}createWorkspaceStorage(E){this.workspaceStorageDisposables.clear(),this.workspaceStorageId=E?.id;let w;if(E){const v=this.workspaceStorageDisposables.add(new b.WorkspaceStorageDatabaseClient(this.mainProcessService.getChannel("storage"),E));w=this.workspaceStorageDisposables.add(new L.Storage(v)),this.workspaceStorageDisposables.add(w.onDidChangeStorage(y=>this.emitDidChangeValue(1,y)))}return w}async doInitialize(){await D.Promises.settled([this.applicationStorage.init(),this.profileStorage.init(),this.workspaceStorage?.init()??Promise.resolve()])}getStorage(E){switch(E){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(E){switch(E){case-1:return this.applicationStorageProfile.globalStorageHome.fsPath;case 0:return this.profileStorageProfile?.globalStorageHome.fsPath;default:return this.workspaceStorageId?`${(0,k.joinPath)(this.environmentService.workspaceStorageHome,this.workspaceStorageId,"state.vscdb").fsPath}`:void 0}}async close(){this.stopFlushWhenIdle(),this.emitWillSaveState(A.WillSaveStateReason.SHUTDOWN),await D.Promises.settled([this.applicationStorage.close(),this.profileStorage.close(),this.workspaceStorage?.close()??Promise.resolve()])}async switchToProfile(E,w){if(!this.canSwitchProfile(this.profileStorageProfile,E))return;const v=this.profileStorage,y=v.items;v!==this.applicationStorage&&await v.close(),this.profileStorage=this.createProfileStorage(E),await this.profileStorage.init(),this.switchData(y,this.profileStorage,0,w)}async switchToWorkspace(E,w){const v=this.workspaceStorage,y=v?.items??new Map;await v?.close(),this.workspaceStorage=this.createWorkspaceStorage(E),await this.workspaceStorage.init(),this.switchData(y,this.workspaceStorage,1,w)}}e.NativeStorageService=P}),define(re[253],se([0,1,3,2,17,14,94,29]),function(X,e,D,n,k,L,A,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataProfilesNativeService=void 0;let P=class extends n.Disposable{constructor(E,w,v){super();this._profiles=[],this._onDidChangeProfiles=this._register(new D.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this.channel=w.getChannel("userDataProfiles"),this.profilesHome=(0,k.joinPath)(v.userRoamingDataHome,"profiles"),this._profiles=E.map(y=>(0,b.reviveProfile)(y,this.profilesHome.scheme)),this._register(this.channel.listen("onDidChangeProfiles")(y=>{const f=y.added.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme)),S=y.removed.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme)),C=y.updated.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme));this._profiles=y.all.map(m=>(0,b.reviveProfile)(m,this.profilesHome.scheme)),this._onDidChangeProfiles.fire({added:f,removed:S,updated:C,all:this.profiles})})),this.onDidResetWorkspaces=this.channel.listen("onDidResetWorkspaces")}get defaultProfile(){return this.profiles[0]}get profiles(){return this._profiles}async createProfile(E,w,v){const y=await this.channel.call("createProfile",[E,w,v]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}async setProfileForWorkspace(E,w){await this.channel.call("setProfileForWorkspace",[E,w])}removeProfile(E){return this.channel.call("removeProfile",[E])}async updateProfile(E,w,v){const y=await this.channel.call("updateProfile",[E,w,v]);return(0,b.reviveProfile)(y,this.profilesHome.scheme)}resetWorkspaces(){return this.channel.call("resetWorkspaces")}getProfile(E,w){throw new Error("Not implemented")}};P=me([G(1,A.IMainProcessService),G(2,L.IEnvironmentService)],P),e.UserDataProfilesNativeService=P}),define(re[46],se([0,1,18,6,16,21,3,35,2,26,15,7,157,19,14,13,8,48,23,22,33,25,29]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractInitializer=e.AbstractJsonFileSynchroniser=e.AbstractFileSynchroniser=e.AbstractSynchroniser=e.isSyncData=void 0;function r(a){return!!(a&&a.version!==void 0&&typeof a.version=="number"&&a.content!==void 0&&typeof a.content=="string"&&(Object.keys(a).length===2||Object.keys(a).length===3&&a.machineId!==void 0&&typeof a.machineId=="string"))}e.isSyncData=r;let t=class extends P.Disposable{constructor(h,p,R,M,O,F,T,N,W,V,Y){super();this.resource=h,this.fileService=p,this.environmentService=R,this.userDataSyncStoreService=O,this.userDataSyncBackupStoreService=F,this.userDataSyncEnablementService=T,this.telemetryService=N,this.logService=W,this.configurationService=V,this.syncPreviewPromise=null,this._status="idle",this._onDidChangStatus=this._register(new A.Emitter),this.onDidChangeStatus=this._onDidChangStatus.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new A.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this.localChangeTriggerThrottler=new n.ThrottledDelayer(50),this._onDidChangeLocal=this._register(new A.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this.hasSyncResourceStateVersionChanged=!1,this.syncHeaders={},this.syncResourceLogLabel=(0,I.uppercaseFirstLetter)(this.resource),this.extUri=Y.extUri,this.syncFolder=this.extUri.joinPath(R.userDataSyncHome,h),this.syncPreviewFolder=this.extUri.joinPath(this.syncFolder,u.PREVIEW_DIR_NAME),this.lastSyncResource=(0,u.getLastSyncResourceUri)(h,R,this.extUri),this.currentMachineIdPromise=(0,m.getServiceMachineId)(R,p,M)}get status(){return this._status}get conflicts(){return this._conflicts}triggerLocalChange(){this.localChangeTriggerThrottler.trigger(()=>this.doTriggerLocalChange())}async doTriggerLocalChange(){if(this.status==="hasConflicts"){this.logService.info(`${this.syncResourceLogLabel}: In conflicts state and local change detected. Syncing again...`);const h=await this.syncPreviewPromise;this.syncPreviewPromise=null;const p=await this.performSync(h.remoteUserData,h.lastSyncUserData,!0,this.getUserDataSyncConfiguration());this.setStatus(p)}else{this.logService.trace(`${this.syncResourceLogLabel}: Checking for local changes...`);const h=await this.getLastSyncUserData();(h?await this.hasRemoteChanged(h):!0)&&this._onDidChangeLocal.fire()}}setStatus(h){this._status!==h&&(this._status=h,this._onDidChangStatus.fire(h))}async sync(h,p={}){await this._sync(h,!0,this.getUserDataSyncConfiguration(),p)}async preview(h,p,R={}){return this._sync(h,!1,p,R)}async apply(h,p={}){try{this.syncHeaders={...p};const R=await this.doApply(h);return this.setStatus(R),this.syncPreviewPromise}finally{this.syncHeaders={}}}async _sync(h,p,R,M){try{if(this.syncHeaders={...M},this.status==="hasConflicts")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as there are conflicts.`),this.syncPreviewPromise;if(this.status==="syncing")return this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing ${this.resource.toLowerCase()} as it is running already.`),this.syncPreviewPromise;this.logService.trace(`${this.syncResourceLogLabel}: Started synchronizing ${this.resource.toLowerCase()}...`),this.setStatus("syncing");let O="idle";try{const F=await this.getLastSyncUserData(),T=await this.getLatestRemoteUserData(h,F);return O=await this.performSync(T,F,p,R),O==="hasConflicts"?this.logService.info(`${this.syncResourceLogLabel}: Detected conflicts while synchronizing ${this.resource.toLowerCase()}.`):O==="idle"&&this.logService.trace(`${this.syncResourceLogLabel}: Finished synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise||null}finally{this.setStatus(O)}}finally{this.syncHeaders={}}}async replace(h){const p=await this.resolveContent(h);if(!p)return!1;const R=this.parseSyncData(p);if(!R)return!1;await this.stop();try{this.logService.trace(`${this.syncResourceLogLabel}: Started resetting ${this.resource.toLowerCase()}...`),this.setStatus("syncing");const M=await this.getLastSyncUserData(),O=await this.getLatestRemoteUserData(null,M),F=await this.isRemoteDataFromCurrentMachine(O),T=await this.generateSyncPreview({ref:O.ref,syncData:R},M,F,this.getUserDataSyncConfiguration(),L.CancellationToken.None),N=[];for(const W of T){const V=await this.getAcceptResult(W,W.remoteResource,void 0,L.CancellationToken.None),{remoteChange:Y}=await this.getAcceptResult(W,W.previewResource,W.remoteContent,L.CancellationToken.None);N.push([W,{...V,remoteChange:Y!==0?Y:2}])}await this.applyResult(O,M,N,!1),this.logService.info(`${this.syncResourceLogLabel}: Finished resetting ${this.resource.toLowerCase()}.`)}finally{this.setStatus("idle")}return!0}async isRemoteDataFromCurrentMachine(h){const p=await this.currentMachineIdPromise;return!!h.syncData?.machineId&&h.syncData.machineId===p}async getLatestRemoteUserData(h,p){if(p){const R=h&&h.latest?h.latest[this.resource]:void 0;if(p.ref===R||R===void 0&&p.syncData===null)return p}return this.getRemoteUserData(p)}async performSync(h,p,R,M){if(h.syncData&&h.syncData.version>this.version)throw this.telemetryService.publicLog2("sync/incompatible",{source:this.resource}),new u.UserDataSyncError((0,v.localize)(0,null,this.resource,this.version,h.syncData.version),"IncompatibleLocalContent",this.resource);try{return await this.doSync(h,p,R,M)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"LocalPreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize ${this.syncResourceLogLabel} as there is a new local version available. Synchronizing again...`),this.performSync(h,p,R,M);case"Conflict":case"PreconditionFailed":return this.logService.info(`${this.syncResourceLogLabel}: Failed to synchronize as there is a new remote version available. Synchronizing again...`),h=await this.getRemoteUserData(null),p=await this.getLastSyncUserData(),this.performSync(h,p,R,M)}throw O}}async doSync(h,p,R,M){try{this.syncPreviewPromise||(this.syncPreviewPromise=(0,n.createCancelablePromise)(F=>this.doGenerateSyncResourcePreview(h,p,R,M,F)));const O=await this.syncPreviewPromise;return this.updateConflicts(O.resourcePreviews),O.resourcePreviews.some(({mergeState:F})=>F==="conflict")?"hasConflicts":R?await this.doApply(!1):"syncing"}catch(O){throw this.syncPreviewPromise=null,O}}async merge(h){return await this.updateSyncResourcePreview(h,async p=>{const R=await this.getMergeResult(p,L.CancellationToken.None);await this.fileService.writeFile(p.previewResource,k.VSBuffer.fromString(R?.content||""));const M=R&&!R.hasConflicts?await this.getAcceptResult(p,p.previewResource,void 0,L.CancellationToken.None):void 0;return p.acceptResult=M,p.mergeState=R.hasConflicts?"conflict":M?"accepted":"preview",p.localChange=M?M.localChange:R.localChange,p.remoteChange=M?M.remoteChange:R.remoteChange,p}),this.syncPreviewPromise}async accept(h,p){return await this.updateSyncResourcePreview(h,async R=>{const M=await this.getAcceptResult(R,h,p,L.CancellationToken.None);return R.acceptResult=M,R.mergeState="accepted",R.localChange=M.localChange,R.remoteChange=M.remoteChange,R}),this.syncPreviewPromise}async discard(h){return await this.updateSyncResourcePreview(h,async p=>{const R=await this.getMergeResult(p,L.CancellationToken.None);return await this.fileService.writeFile(p.previewResource,k.VSBuffer.fromString(R.content||"")),p.acceptResult=void 0,p.mergeState="preview",p.localChange=R.localChange,p.remoteChange=R.remoteChange,p}),this.syncPreviewPromise}async updateSyncResourcePreview(h,p){if(!this.syncPreviewPromise)return;let R=await this.syncPreviewPromise;const M=R.resourcePreviews.findIndex(({localResource:O,remoteResource:F,previewResource:T})=>this.extUri.isEqual(O,h)||this.extUri.isEqual(F,h)||this.extUri.isEqual(T,h));M!==-1&&(this.syncPreviewPromise=(0,n.createCancelablePromise)(async O=>{const F=[...R.resourcePreviews];return F[M]=await p(F[M]),{...R,resourcePreviews:F}}),R=await this.syncPreviewPromise,this.updateConflicts(R.resourcePreviews),R.resourcePreviews.some(({mergeState:O})=>O==="conflict")?this.setStatus("hasConflicts"):this.setStatus("syncing"))}async doApply(h){if(!this.syncPreviewPromise)return"idle";const p=await this.syncPreviewPromise;return p.resourcePreviews.some(({mergeState:R})=>R==="conflict")?"hasConflicts":p.resourcePreviews.some(({mergeState:R})=>R!=="accepted")?"syncing":(await this.applyResult(p.remoteUserData,p.lastSyncUserData,p.resourcePreviews.map(R=>[R,R.acceptResult]),h),this.syncPreviewPromise=null,await this.clearPreviewFolder(),"idle")}async clearPreviewFolder(){try{await this.fileService.del(this.syncPreviewFolder,{recursive:!0})}catch{}}updateConflicts(h){const p=h.filter(({mergeState:R})=>R==="conflict");(0,D.equals)(this._conflicts,p,(R,M)=>this.extUri.isEqual(R.previewResource,M.previewResource))||(this._conflicts=p,this._onDidChangeConflicts.fire(p))}async hasPreviouslySynced(){const h=await this.getLastSyncUserData();return!!h&&h.syncData!==null}async getRemoteSyncResourceHandles(){return(await this.userDataSyncStoreService.getAllRefs(this.resource)).map(({created:p,ref:R})=>({created:p,uri:this.toRemoteBackupResource(R)}))}async getLocalSyncResourceHandles(){return(await this.userDataSyncBackupStoreService.getAllRefs(this.resource)).map(({created:p,ref:R})=>({created:p,uri:this.toLocalBackupResource(R)}))}toRemoteBackupResource(h){return w.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote-backup",path:`/${this.resource}/${h}`})}toLocalBackupResource(h){return w.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local-backup",path:`/${this.resource}/${h}`})}async getMachineId({uri:h}){const p=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(p))){const{content:R}=await this.getUserData(p);if(R)return this.parseSyncData(R)?.machineId}}async resolveContent(h){const p=this.extUri.basename(h);if(this.extUri.isEqual(h,this.toRemoteBackupResource(p))){const{content:R}=await this.getUserData(p);return R}return this.extUri.isEqual(h,this.toLocalBackupResource(p))?this.userDataSyncBackupStoreService.resolveContent(this.resource,p):null}async resolvePreviewContent(h){const p=this.syncPreviewPromise?await this.syncPreviewPromise:null;if(p)for(const R of p.resourcePreviews){if(this.extUri.isEqual(R.acceptedResource,h))return R.acceptResult?R.acceptResult.content:null;if(this.extUri.isEqual(R.remoteResource,h))return R.remoteContent;if(this.extUri.isEqual(R.localResource,h))return R.localContent;if(this.extUri.isEqual(R.baseResource,h))return R.baseContent}return null}async resetLocal(){try{await this.fileService.del(this.lastSyncResource)}catch{}}async doGenerateSyncResourcePreview(h,p,R,M,O){const F=await this.isRemoteDataFromCurrentMachine(h),T=await this.generateSyncPreview(h,p,F,M,O),N=[];for(const W of T){const V=W.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"});if(W.localChange===0&&W.remoteChange===0)N.push({...W,acceptedResource:V,acceptResult:{content:null,localChange:0,remoteChange:0},mergeState:"accepted"});else{const Y=R?await this.getMergeResult(W,O):void 0;if(O.isCancellationRequested)break;await this.fileService.writeFile(W.previewResource,k.VSBuffer.fromString(Y?.content||""));const $=Y&&!Y.hasConflicts?await this.getAcceptResult(W,W.previewResource,void 0,O):void 0;N.push({...W,acceptResult:$,mergeState:Y?.hasConflicts?"conflict":$?"accepted":"preview",localChange:$?$.localChange:Y?Y.localChange:W.localChange,remoteChange:$?$.remoteChange:Y?Y.remoteChange:W.remoteChange})}}return{remoteUserData:h,lastSyncUserData:p,resourcePreviews:N,isLastSyncFromCurrentMachine:F}}async getLastSyncUserData(){try{const h=await this.fileService.readFile(this.lastSyncResource),p=JSON.parse(h.value.toString()),R=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource);if(this.hasSyncResourceStateVersionChanged=p.version&&R&&p.version!==R,this.hasSyncResourceStateVersionChanged)return this.logService.info(`${this.syncResourceLogLabel}: Reset last sync state because last sync state version ${p.version} is not compatible with current sync state version ${R}.`),await this.resetLocal(),null;const M=p;if(M.content===null)return{ref:p.ref,syncData:null};const O=JSON.parse(M.content);if(r(O))return{...p,syncData:O,content:void 0}}catch(h){h instanceof S.FileOperationError&&h.fileOperationResult===1||this.logService.error(h)}return null}async updateLastSyncUserData(h,p={}){if(p.ref||p.content||p.version)throw new Error("Cannot have core properties as additional");const R=this.userDataSyncEnablementService.getResourceSyncStateVersion(this.resource),M={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,version:R,...p};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(M)))}async getRemoteUserData(h){const{ref:p,content:R}=await this.getUserData(h);let M=null;return R!==null&&(M=this.parseSyncData(R)),{ref:p,syncData:M}}parseSyncData(h){try{const p=JSON.parse(h);if(r(p))return p}catch(p){this.logService.error(p)}throw new u.UserDataSyncError((0,v.localize)(1,null),"IncompatibleRemoteContent",this.resource)}async getUserData(h){if((0,E.isString)(h)){const p=await this.userDataSyncStoreService.resolveContent(this.resource,h);return{ref:h,content:p}}else{const p=h?{ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null}:null;return this.userDataSyncStoreService.read(this.resource,p,this.syncHeaders)}}async updateRemoteUserData(h,p){const R=await this.currentMachineIdPromise,M={version:this.version,machineId:R,content:h};return p=await this.userDataSyncStoreService.write(this.resource,JSON.stringify(M),p,this.syncHeaders),{ref:p,syncData:M}}async backupLocal(h){const p={version:this.version,content:h};return this.userDataSyncBackupStoreService.backup(this.resource,JSON.stringify(p))}async stop(){this.status!=="idle"&&(this.logService.trace(`${this.syncResourceLogLabel}: Stopping synchronizing ${this.resource.toLowerCase()}.`),this.syncPreviewPromise&&(this.syncPreviewPromise.cancel(),this.syncPreviewPromise=null),this.updateConflicts([]),await this.clearPreviewFolder(),this.setStatus("idle"),this.logService.info(`${this.syncResourceLogLabel}: Stopped synchronizing ${this.resource.toLowerCase()}.`))}getUserDataSyncConfiguration(){return this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE)}};t=me([G(1,S.IFileService),G(2,f.IEnvironmentService),G(3,g.IStorageService),G(4,u.IUserDataSyncStoreService),G(5,u.IUserDataSyncBackupStoreService),G(6,u.IUserDataSyncEnablementService),G(7,c.ITelemetryService),G(8,u.IUserDataSyncLogService),G(9,y.IConfigurationService),G(10,d.IUriIdentityService)],t),e.AbstractSynchroniser=t;let i=class extends t{constructor(h,p,R,M,O,F,T,N,W,V,Y,$){super(p,R,M,O,F,T,N,W,V,Y,$);this.file=h,this._register(this.fileService.watch(this.extUri.dirname(h))),this._register(this.fileService.onDidFilesChange(J=>this.onFileChanges(J)))}async getLocalFileContent(){try{return await this.fileService.readFile(this.file)}catch{return null}}async updateLocalFileContent(h,p,R){try{p?await this.fileService.writeFile(this.file,k.VSBuffer.fromString(h),R?void 0:p):await this.fileService.createFile(this.file,k.VSBuffer.fromString(h),{overwrite:R})}catch(M){throw M instanceof S.FileOperationError&&M.fileOperationResult===1||M instanceof S.FileOperationError&&M.fileOperationResult===3?new u.UserDataSyncError(M.message,"LocalPreconditionFailed"):M}}onFileChanges(h){!h.contains(this.file)||this.triggerLocalChange()}};i=me([G(2,S.IFileService),G(3,f.IEnvironmentService),G(4,g.IStorageService),G(5,u.IUserDataSyncStoreService),G(6,u.IUserDataSyncBackupStoreService),G(7,u.IUserDataSyncEnablementService),G(8,c.ITelemetryService),G(9,u.IUserDataSyncLogService),G(10,y.IConfigurationService),G(11,d.IUriIdentityService)],i),e.AbstractFileSynchroniser=i;let o=class extends i{constructor(h,p,R,M,O,F,T,N,W,V,Y,$,J){super(h,p,R,M,O,F,T,N,W,V,$,J);this.userDataSyncUtilService=Y,this._formattingOptions=void 0}hasErrors(h,p){const R=[],M=(0,b.parse)(h,R,{allowEmptyContent:!0,allowTrailingComma:!0});return R.length>0||!(0,E.isUndefined)(M)&&p!==Array.isArray(M)}getFormattingOptions(){return this._formattingOptions||(this._formattingOptions=this.userDataSyncUtilService.resolveFormattingOptions(this.file)),this._formattingOptions}};o=me([G(2,S.IFileService),G(3,f.IEnvironmentService),G(4,g.IStorageService),G(5,u.IUserDataSyncStoreService),G(6,u.IUserDataSyncBackupStoreService),G(7,u.IUserDataSyncEnablementService),G(8,c.ITelemetryService),G(9,u.IUserDataSyncLogService),G(10,u.IUserDataSyncUtilService),G(11,y.IConfigurationService),G(12,d.IUriIdentityService)],o),e.AbstractJsonFileSynchroniser=o;let l=class{constructor(h,p,R,M,O,F){this.resource=h,this.userDataProfilesService=p,this.environmentService=R,this.logService=M,this.fileService=O,this.extUri=F.extUri,this.lastSyncResource=(0,u.getLastSyncResourceUri)(this.resource,R,this.extUri)}async initialize({ref:h,content:p}){if(!p){this.logService.info("Remote content does not exist.",this.resource);return}const R=this.parseSyncData(p);if(!!R)try{await this.doInitialize({ref:h,syncData:R})}catch(M){this.logService.error(M)}}parseSyncData(h){try{const p=JSON.parse(h);if(r(p))return p}catch(p){this.logService.error(p)}this.logService.info("Cannot parse sync data as it is not compatible with the current version.",this.resource)}async updateLastSyncUserData(h,p={}){const R={ref:h.ref,content:h.syncData?JSON.stringify(h.syncData):null,...p};await this.fileService.writeFile(this.lastSyncResource,k.VSBuffer.fromString(JSON.stringify(R)))}};l=me([G(1,s.IUserDataProfilesService),G(2,f.IEnvironmentService),G(3,C.ILogService),G(4,S.IFileService),G(5,d.IUriIdentityService)],l),e.AbstractInitializer=l}),define(re[254],se([0,1,6,21,9,3,52,26,7,19,14,28,32,72,13,8,23,22,33,29,46,234,107,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u,s,r){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtensionsInitializer=e.ExtensionsSynchroniser=void 0;async function t(l,a){const h=JSON.parse(l.content);if(l.version===1||l.version===2){const p=(await a.getInstalled(0)).filter(R=>R.isBuiltin);for(const R of h)l.version===1&&(R.enabled===!1&&(R.disabled=!0),delete R.enabled),l.version===2&&p.every(M=>!(0,v.areSameExtensions)(M.identifier,R.identifier))&&(R.installed=!0)}return h}let i=class gt extends d.AbstractSynchroniser{constructor(a,h,p,R,M,O,F,T,N,W,V,Y,$,J,H){super("extensions",h,a,p,R,M,Y,$,N,V,H);this.extensionManagementService=O,this.extensionEnablementService=F,this.ignoredExtensionsManagementService=T,this.extensionGalleryService=W,this.extensionStorageService=J,this.version=5,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"extensions.json"),this.baseResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:r.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(L.Event.any(L.Event.filter(this.extensionManagementService.onDidInstallExtensions,B=>B.some(({local:K})=>!!K)),L.Event.filter(this.extensionManagementService.onDidUninstallExtension,B=>!B.error),this.extensionEnablementService.onDidChangeEnablement,this.extensionStorageService.onDidChangeExtensionStorageToSync)(()=>this.triggerLocalChange()))}async generateSyncPreview(a,h){const p=a.syncData?await t(a.syncData,this.extensionManagementService):null,R=h?.skippedExtensions||[],M=h?.syncData?await t(h.syncData,this.extensionManagementService):null,O=await this.extensionManagementService.getInstalled(void 0),F=this.getLocalExtensions(O),T=this.ignoredExtensionsManagementService.getIgnoredExtensions(O);p?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote extensions with local extensions...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote extensions does not exist. Synchronizing extensions for the first time.`);const{local:N,remote:W}=(0,u.merge)(F,p,M,R,T),V={local:N,remote:W,content:this.getPreviewContent(F,N.added,N.updated,N.removed),localChange:N.added.length>0||N.removed.length>0||N.updated.length>0?2:0,remoteChange:W!==null?2:0},Y=this.stringify(F,!1);return[{skippedExtensions:R,baseResource:this.baseResource,baseContent:M?this.stringify(M,!1):Y,localResource:this.localResource,localContent:Y,localExtensions:F,remoteResource:this.remoteResource,remoteContent:p?this.stringify(p,!1):null,previewResource:this.previewResource,previewResult:V,localChange:V.localChange,remoteChange:V.remoteChange,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(a){const h=a.syncData?await t(a.syncData,this.extensionManagementService):null,p=await this.extensionManagementService.getInstalled(void 0),R=this.getLocalExtensions(p),M=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),{remote:O}=(0,u.merge)(R,h,h,a.skippedExtensions||[],M);return O!==null}getPreviewContent(a,h,p,R){const M=[...h,...p],O=new Set,F=T=>{O.add(T.id.toLowerCase()),T.uuid&&O.add(T.uuid)};M.forEach(({identifier:T})=>F(T)),R.forEach(F);for(const T of a)O.has(T.identifier.id.toLowerCase())||T.identifier.uuid&&O.has(T.identifier.uuid)||M.push(T);return this.stringify(M,!1)}async getMergeResult(a,h){return{...a.previewResult,hasConflicts:!1}}async getAcceptResult(a,h,p,R){if(this.extUri.isEqual(h,this.localResource))return this.acceptLocal(a);if(this.extUri.isEqual(h,this.remoteResource))return this.acceptRemote(a);if(this.extUri.isEqual(h,this.previewResource))return a.previewResult;throw new Error(`Invalid Resource: ${h.toString()}`)}async acceptLocal(a){const h=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),R=(0,u.merge)(a.localExtensions,null,null,a.skippedExtensions,p),{local:M,remote:O}=R;return{content:a.localContent,local:M,remote:O,localChange:M.added.length>0||M.removed.length>0||M.updated.length>0?2:0,remoteChange:O!==null?2:0}}async acceptRemote(a){const h=await this.extensionManagementService.getInstalled(),p=this.ignoredExtensionsManagementService.getIgnoredExtensions(h),R=a.remoteContent?JSON.parse(a.remoteContent):null;if(R!==null){const M=(0,u.merge)(a.localExtensions,R,a.localExtensions,[],p),{local:O,remote:F}=M;return{content:a.remoteContent,local:O,remote:F,localChange:O.added.length>0||O.removed.length>0||O.updated.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:a.remoteContent,local:{added:[],removed:[],updated:[]},remote:null,localChange:0,remoteChange:0}}async applyResult(a,h,p,R){let{skippedExtensions:M,localExtensions:O}=p[0][0];const{local:F,remote:T,localChange:N,remoteChange:W}=p[0][1];if(N===0&&W===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing extensions.`),N!==0&&(await this.backupLocal(JSON.stringify(O)),M=await this.updateLocalExtensions(F.added,F.removed,F.updated,M)),T){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote extensions...`);const V=JSON.stringify(T.all);a=await this.updateRemoteUserData(V,R?null:a.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote extensions.${T.added.length?` Added: ${JSON.stringify(T.added.map(Y=>Y.identifier.id))}.`:""}${T.updated.length?` Updated: ${JSON.stringify(T.updated.map(Y=>Y.identifier.id))}.`:""}${T.removed.length?` Removed: ${JSON.stringify(T.removed.map(Y=>Y.identifier.id))}.`:""}`)}h?.ref!==a.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized extensions...`),await this.updateLastSyncUserData(a,{skippedExtensions:M}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized extensions.${M.length?` Skipped: ${JSON.stringify(M.map(V=>V.identifier.id))}.`:""}`))}async getAssociatedResources({uri:a}){return[{resource:this.extUri.joinPath(a,"extensions.json"),comparableResource:gt.EXTENSIONS_DATA_URI}]}async resolveContent(a){if(this.extUri.isEqual(a,gt.EXTENSIONS_DATA_URI)){const p=await this.extensionManagementService.getInstalled(),R=this.ignoredExtensionsManagementService.getIgnoredExtensions(p),M=this.getLocalExtensions(p).filter(O=>!R.some(F=>(0,v.areSameExtensions)({id:F},O.identifier)));return this.stringify(M,!0)}if(this.extUri.isEqual(this.remoteResource,a)||this.extUri.isEqual(this.baseResource,a)||this.extUri.isEqual(this.localResource,a)||this.extUri.isEqual(this.acceptedResource,a)){const p=await this.resolvePreviewContent(a);return p&&this.stringify(JSON.parse(p),!0)}let h=await super.resolveContent(a);if(h)return h;if(h=await super.resolveContent(this.extUri.dirname(a)),h){const p=this.parseSyncData(h);if(p)switch(this.extUri.basename(a)){case"extensions.json":return this.stringify(this.parseExtensions(p),!0)}}return null}stringify(a,h){return a.sort((p,R)=>!p.identifier.uuid&&R.identifier.uuid?-1:p.identifier.uuid&&!R.identifier.uuid?1:(0,b.compare)(p.identifier.id,R.identifier.id)),h?(0,A.toFormattedString)(a,{}):JSON.stringify(a)}async hasLocalData(){try{const a=await this.extensionManagementService.getInstalled();if(this.getLocalExtensions(a).some(p=>p.installed||p.disabled))return!0}catch{}return!1}async updateLocalExtensions(a,h,p,R){const M=[],O=[],F=await this.extensionManagementService.getInstalled();if(h.length){const N=F.filter(({identifier:W,isBuiltin:V})=>!V&&h.some(Y=>(0,v.areSameExtensions)(W,Y)));await D.Promises.settled(N.map(async W=>{this.logService.trace(`${this.syncResourceLogLabel}: Uninstalling local extension...`,W.identifier.id),await this.extensionManagementService.uninstall(W,{donotIncludePack:!0,donotCheckDependents:!0}),this.logService.info(`${this.syncResourceLogLabel}: Uninstalled local extension.`,W.identifier.id),M.push(W.identifier)}))}(a.length||p.length)&&await D.Promises.settled([...a,...p].map(async N=>{const W=F.find(Y=>(0,v.areSameExtensions)(Y.identifier,N.identifier));if(W&&W.isBuiltin){N.state&&W.manifest.version===N.version&&this.updateExtensionState(N.state,W,W.manifest.version),this.extensionEnablementService.getDisabledExtensions().some($=>(0,v.areSameExtensions)($,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id),await this.extensionEnablementService.disableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id),await this.extensionEnablementService.enableExtension(N.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id))),M.push(N.identifier);return}const V=(await this.extensionGalleryService.getExtensions([{...N.identifier,preRelease:N.preRelease}],n.CancellationToken.None))[0];if(N.state&&(W?W.manifest.version===N.version:!!V)&&this.updateExtensionState(N.state,W||V,W?.manifest.version),V)try{this.extensionEnablementService.getDisabledExtensions().some($=>(0,v.areSameExtensions)($,N.identifier))!==!!N.disabled&&(N.disabled?(this.logService.trace(`${this.syncResourceLogLabel}: Disabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.disableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Disabled extension`,N.identifier.id,V.version)):(this.logService.trace(`${this.syncResourceLogLabel}: Enabling extension...`,N.identifier.id,V.version),await this.extensionEnablementService.enableExtension(V.identifier),this.logService.info(`${this.syncResourceLogLabel}: Enabled extension`,N.identifier.id,V.version))),(!W||W.preRelease!==N.preRelease)&&(await this.extensionManagementService.canInstall(V)?(this.logService.trace(`${this.syncResourceLogLabel}: Installing extension...`,N.identifier.id,V.version),await this.extensionManagementService.installFromGallery(V,{isMachineScoped:!1,donotIncludePackAndDependencies:!0,installPreReleaseVersion:N.preRelease}),this.logService.info(`${this.syncResourceLogLabel}: Installed extension.`,N.identifier.id,V.version),M.push(V.identifier)):(this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because it cannot be installed.`,V.displayName||V.identifier.id),O.push(N)))}catch(Y){O.push(N),Y instanceof w.ExtensionManagementError&&[w.ExtensionManagementErrorCode.Incompatible,w.ExtensionManagementErrorCode.IncompatiblePreRelease,w.ExtensionManagementErrorCode.IncompatibleTargetPlatform].includes(Y.code)?this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the compatible extension is not found.`,V.displayName||V.identifier.id):(this.logService.error(Y),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension`,V.displayName||V.identifier.id))}else O.push(N),this.logService.info(`${this.syncResourceLogLabel}: Skipped synchronizing extension because the extension is not found.`,N.identifier.id)}));const T=[];for(const N of R)M.some(W=>(0,v.areSameExtensions)(W,N.identifier))||T.push(N);for(const N of O)T.some(W=>(0,v.areSameExtensions)(W.identifier,N.identifier))||T.push(N);return T}updateExtensionState(a,h,p){const R=this.extensionStorageService.getExtensionState(h,!0)||{},M=p?this.extensionStorageService.getKeysForSync({id:h.identifier.id,version:p}):void 0;M?M.forEach(O=>{R[O]=a[O]}):Object.keys(a).forEach(O=>R[O]=a[O]),this.extensionStorageService.setExtensionState(h,R,!0)}parseExtensions(a){return JSON.parse(a.content)}getLocalExtensions(a){const h=this.extensionEnablementService.getDisabledExtensions();return a.map(p=>{const{identifier:R,isBuiltin:M,manifest:O,preRelease:F}=p,T={identifier:R,preRelease:F,version:O.version};h.some(N=>(0,v.areSameExtensions)(N,R))&&(T.disabled=!0),M||(T.installed=!0);try{const N=this.extensionStorageService.getKeysForSync({id:R.id,version:O.version});if(N){const W=this.extensionStorageService.getExtensionState(p,!0)||{};T.state=Object.keys(W).reduce((V,Y)=>(N.includes(Y)&&(V[Y]=W[Y]),V),{})}}catch(N){this.logService.info(`${this.syncResourceLogLabel}: Error while parsing extension state`,(0,k.getErrorMessage)(N))}return T})}};i.EXTENSIONS_DATA_URI=P.URI.from({scheme:r.USER_DATA_SYNC_SCHEME,authority:"extensions",path:"/extensions.json"}),i=me([G(0,E.IEnvironmentService),G(1,f.IFileService),G(2,C.IStorageService),G(3,r.IUserDataSyncStoreService),G(4,r.IUserDataSyncBackupStoreService),G(5,w.IExtensionManagementService),G(6,w.IGlobalExtensionEnablementService),G(7,s.IIgnoredExtensionsManagementService),G(8,r.IUserDataSyncLogService),G(9,w.IExtensionGalleryService),G(10,I.IConfigurationService),G(11,r.IUserDataSyncEnablementService),G(12,m.ITelemetryService),G(13,y.IExtensionStorageService),G(14,g.IUriIdentityService)],i),e.ExtensionsSynchroniser=i;let o=class extends d.AbstractInitializer{constructor(a,h,p,R,M,O,F){super("extensions",R,M,O,p,F);this.extensionManagementService=a,this.ignoredExtensionsManagementService=h}async parseExtensions(a){return a.syncData?await t(a.syncData,this.extensionManagementService):null}generatePreview(a,h){const p=[],R=[],M=[];for(const O of a){if(this.ignoredExtensionsManagementService.hasToNeverSyncExtension(O.identifier.id))continue;const F=h.find(T=>(0,v.areSameExtensions)(T.identifier,O.identifier));F?(p.push(F),O.disabled&&M.push(O.identifier)):O.installed&&(R.push({...O.identifier,preRelease:!!O.preRelease}),O.disabled&&M.push(O.identifier))}return{installedExtensions:p,newExtensions:R,disabledExtensions:M,remoteExtensions:a}}};o=me([G(0,w.IExtensionManagementService),G(1,s.IIgnoredExtensionsManagementService),G(2,f.IFileService),G(3,c.IUserDataProfilesService),G(4,E.IEnvironmentService),G(5,S.ILogService),G(6,g.IUriIdentityService)],o),e.AbstractExtensionsInitializer=o}),define(re[255],se([0,1,16,9,3,35,52,4,7,30,19,14,13,8,48,23,22,33,46,59,237,25,29]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u,s){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncStoreTypeSynchronizer=e.GlobalStateInitializer=e.GlobalStateSynchroniser=void 0;const r="globalState.argv.",t=["locale"];function i(p,R){const M=p.storage?Object.keys(p.storage).sort():[],O={};return M.forEach(F=>O[F]=p.storage[F]),p.storage=O,R?(0,A.toFormattedString)(p,{}):JSON.stringify(p)}const o=1;let l=class mt extends g.AbstractSynchroniser{constructor(R,M,O,F,T,N,W,V,Y,$){super("globalState",R,T,Y,M,O,N,W,F,V,$);this.storageService=Y,this.version=o,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"globalState.json"),this.baseResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:u.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(R.watch(this.extUri.dirname(this.environmentService.argvResource))),this._register(k.Event.any(k.Event.filter(R.onDidFilesChange,J=>J.contains(this.environmentService.argvResource)),k.Event.filter(Y.onDidChangeValue,J=>J.scope===0&&J.target!==void 0?J.target===0:Y.keys(0,0).includes(J.key)),this.storageService.onDidChangeTarget)(()=>this.triggerLocalChange()))}async generateSyncPreview(R,M,O){const F=R.syncData?JSON.parse(R.syncData.content):null;M=M===null&&O?R:M;const T=M&&M.syncData?JSON.parse(M.syncData.content):null,N=await this.getLocalGlobalState();F?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote ui state with local ui state...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote ui state does not exist. Synchronizing ui state for the first time.`);const W=this.getStorageKeys(T),{local:V,remote:Y}=(0,d.merge)(N.storage,F?F.storage:null,T?T.storage:null,W,this.logService),$={content:null,local:V,remote:Y,localChange:Object.keys(V.added).length>0||Object.keys(V.updated).length>0||V.removed.length>0?2:0,remoteChange:Y!==null?2:0},J=i(N,!1);return[{baseResource:this.baseResource,baseContent:T?i(T,!1):J,localResource:this.localResource,localContent:J,localUserData:N,remoteResource:this.remoteResource,remoteContent:F?i(F,!1):null,previewResource:this.previewResource,previewResult:$,localChange:$.localChange,remoteChange:$.remoteChange,acceptedResource:this.acceptedResource,storageKeys:W}]}async hasRemoteChanged(R){const M=R.syncData?JSON.parse(R.syncData.content):null;if(M===null)return!0;const O=await this.getLocalGlobalState(),F=this.getStorageKeys(M),{remote:T}=(0,d.merge)(O.storage,M.storage,M.storage,F,this.logService);return T!==null}async getMergeResult(R,M){return{...R.previewResult,hasConflicts:!1}}async getAcceptResult(R,M,O,F){if(this.extUri.isEqual(M,this.localResource))return this.acceptLocal(R);if(this.extUri.isEqual(M,this.remoteResource))return this.acceptRemote(R);if(this.extUri.isEqual(M,this.previewResource))return R.previewResult;throw new Error(`Invalid Resource: ${M.toString()}`)}async acceptLocal(R){return{content:R.localContent,local:{added:{},removed:[],updated:{}},remote:R.localUserData.storage,localChange:0,remoteChange:2}}async acceptRemote(R){if(R.remoteContent!==null){const M=JSON.parse(R.remoteContent),{local:O,remote:F}=(0,d.merge)(R.localUserData.storage,M.storage,null,R.storageKeys,this.logService);return{content:R.remoteContent,local:O,remote:F,localChange:Object.keys(O.added).length>0||Object.keys(O.updated).length>0||O.removed.length>0?2:0,remoteChange:F!==null?2:0}}else return{content:R.remoteContent,local:{added:{},removed:[],updated:{}},remote:null,localChange:0,remoteChange:0}}async applyResult(R,M,O,F){const{localUserData:T}=O[0][0],{local:N,remote:W,localChange:V,remoteChange:Y}=O[0][1];if(V===0&&Y===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing ui state.`),V!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local ui state...`),await this.backupLocal(JSON.stringify(T)),await this.writeLocalGlobalState(N),this.logService.info(`${this.syncResourceLogLabel}: Updated local ui state`)),Y!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote ui state...`);const $=JSON.stringify({storage:W});R=await this.updateRemoteUserData($,F?null:R.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote ui state`)}M?.ref!==R.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized ui state...`),await this.updateLastSyncUserData(R),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized ui state`))}async getAssociatedResources({uri:R}){return[{resource:this.extUri.joinPath(R,"globalState.json"),comparableResource:mt.GLOBAL_STATE_DATA_URI}]}async resolveContent(R){if(this.extUri.isEqual(R,mt.GLOBAL_STATE_DATA_URI)){const O=await this.getLocalGlobalState();return i(O,!0)}if(this.extUri.isEqual(this.remoteResource,R)||this.extUri.isEqual(this.baseResource,R)||this.extUri.isEqual(this.localResource,R)||this.extUri.isEqual(this.acceptedResource,R)){const O=await this.resolvePreviewContent(R);return O&&i(JSON.parse(O),!0)}let M=await super.resolveContent(R);if(M)return M;if(M=await super.resolveContent(this.extUri.dirname(R)),M){const O=this.parseSyncData(M);if(O)switch(this.extUri.basename(R)){case"globalState.json":return i(JSON.parse(O.content),!0)}}return null}async hasLocalData(){try{const{storage:R}=await this.getLocalGlobalState();if(Object.keys(R).length>1||R[`${r}.locale`]?.value!=="en")return!0}catch{}return!1}async getLocalGlobalState(){const R={},M=await this.getLocalArgvContent(),O=(0,L.parse)(M);for(const F of t)O[F]!==void 0&&(R[`${r}${F}`]={version:1,value:O[F]});for(const F of this.storageService.keys(0,0)){const T=this.storageService.get(F,0);T&&(R[F]={version:1,value:T})}return{storage:R}}async getLocalArgvContent(){try{this.logService.debug("GlobalStateSync#getLocalArgvContent",this.environmentService.argvResource);const R=await this.fileService.readFile(this.environmentService.argvResource);return this.logService.debug("GlobalStateSync#getLocalArgvContent - Resolved",this.environmentService.argvResource),R.value.toString()}catch(R){this.logService.debug((0,n.getErrorMessage)(R))}return"{}"}async writeLocalGlobalState({added:R,removed:M,updated:O}){const F={},T={},N=(V,Y)=>{for(const $ of V){if($.startsWith(r)){F[$.substring(r.length)]=Y?Y[$].value:void 0;continue}if(Y){const J=Y[$];J.value!==String(this.storageService.get($,0))&&(T[$]=J.value)}else this.storageService.get($,0)!==void 0&&(T[$]=void 0)}};if(N(Object.keys(R),R),N(Object.keys(O),O),N(M),Object.keys(F).length&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.updateArgv(F),this.logService.info(`${this.syncResourceLogLabel}: Updated locale`)),Object.keys(T).length){this.logService.trace(`${this.syncResourceLogLabel}: Updating global state...`);for(const V of Object.keys(T))this.storageService.store(V,T[V],0,0);this.logService.info(`${this.syncResourceLogLabel}: Updated global state`,Object.keys(T))}}async updateArgv(R){const M=await this.getLocalArgvContent();let O=M;for(const F of Object.keys(R))O=(0,c.edit)(O,[F],R[F],{});M!==O&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating locale...`),await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(O)),this.logService.info(`${this.syncResourceLogLabel}: Updated locale.`))}getStorageKeys(R){const M=this.storageService.keys(0,0),O=this.storageService.keys(0,1),F=[...M,...O],T=R?.storage?Object.keys(R.storage).filter(N=>!N.startsWith(r)&&!F.includes(N)&&this.storageService.get(N,0)!==void 0):[];if(!b.isWeb){const N=[...u.ALL_SYNC_RESOURCES.map(W=>(0,u.getEnablementKey)(W)),u.SYNC_SERVICE_URL_TYPE];T.push(...N),O.push(...N)}return{user:M,machine:O,unregistered:T}}};l.GLOBAL_STATE_DATA_URI=P.URI.from({scheme:u.USER_DATA_SYNC_SCHEME,authority:"globalState",path:"/globalState.json"}),l=me([G(0,v.IFileService),G(1,u.IUserDataSyncStoreService),G(2,u.IUserDataSyncBackupStoreService),G(3,u.IUserDataSyncLogService),G(4,w.IEnvironmentService),G(5,u.IUserDataSyncEnablementService),G(6,C.ITelemetryService),G(7,E.IConfigurationService),G(8,S.IStorageService),G(9,m.IUriIdentityService)],l),e.GlobalStateSynchroniser=l;let a=class extends g.AbstractInitializer{constructor(R,M,O,F,T,N){super("globalState",O,F,T,M,N);this.storageService=R}async doInitialize(R){const M=R.syncData?JSON.parse(R.syncData.content):null;if(!M){this.logService.info("Skipping initializing global state because remote global state does not exist.");return}const O={},F={};for(const T of Object.keys(M.storage))T.startsWith(r)?O[T.substring(r.length)]=M.storage[T].value:this.storageService.get(T,0)===void 0&&(F[T]=M.storage[T].value);if(Object.keys(O).length){let T="{}";try{T=(await this.fileService.readFile(this.environmentService.argvResource)).value.toString()}catch{}for(const N of Object.keys(O))T=(0,c.edit)(T,[N],O[N],{});await this.fileService.writeFile(this.environmentService.argvResource,D.VSBuffer.fromString(T))}if(Object.keys(F).length)for(const T of Object.keys(F))this.storageService.store(T,F[T],0,0)}};a=me([G(0,S.IStorageService),G(1,v.IFileService),G(2,s.IUserDataProfilesService),G(3,w.IEnvironmentService),G(4,u.IUserDataSyncLogService),G(5,m.IUriIdentityService)],a),e.GlobalStateInitializer=a;let h=class{constructor(R,M,O,F,T){this.userDataSyncStoreClient=R,this.storageService=M,this.environmentService=O,this.fileService=F,this.logService=T}getSyncStoreType(R){return this.parseGlobalState(R)?.storage[u.SYNC_SERVICE_URL_TYPE]?.value}async sync(R){const M=(0,u.createSyncHeaders)((0,I.generateUuid)());try{return await this.doSync(R,M)}catch(O){if(O instanceof u.UserDataSyncError)switch(O.code){case"PreconditionFailed":return this.logService.info("Failed to synchronize UserDataSyncStoreType as there is a new remote version available. Synchronizing again..."),this.doSync(R,M)}throw O}}async doSync(R,M){const O=await this.userDataSyncStoreClient.read("globalState",null,M),F=this.parseGlobalState(O)||{storage:{}};F.storage[u.SYNC_SERVICE_URL_TYPE]={value:R,version:o};const T=await(0,f.getServiceMachineId)(this.environmentService,this.fileService,this.storageService),N={version:o,machineId:T,content:i(F,!1)};await this.userDataSyncStoreClient.write("globalState",JSON.stringify(N),O.ref,M)}parseGlobalState({content:R}){if(!R)return null;const M=JSON.parse(R);if((0,g.isSyncData)(M))return M?JSON.parse(M.content):null;throw new Error("Invalid remote data")}};h=me([G(1,S.IStorageService),G(2,w.IEnvironmentService),G(3,v.IFileService),G(4,y.ILogService)],h),e.UserDataSyncStoreTypeSynchronizer=h}),define(re[256],se([0,1,18,16,3,35,4,15,158,19,14,13,23,22,33,29,46,235,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.KeybindingsInitializer=e.KeybindingsSynchroniser=e.getKeybindingsContentFromSyncContent=void 0;function c(s,r,t){try{const i=JSON.parse(s);if(!r)return(0,b.isUndefined)(i.all)?null:i.all;switch(A.OS){case 2:return(0,b.isUndefined)(i.mac)?null:i.mac;case 3:return(0,b.isUndefined)(i.linux)?null:i.linux;case 1:return(0,b.isUndefined)(i.windows)?null:i.windows}}catch(i){return t.error(i),null}}e.getKeybindingsContentFromSyncContent=c;let d=class extends C.AbstractJsonFileSynchroniser{constructor(r,t,i,o,l,a,h,p,R,M,O,F){super(h.defaultProfile.keybindingsResource,"keybindings",a,p,R,r,t,l,O,i,M,o,F);this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"keybindings.json"),this.baseResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:g.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._register(k.Event.filter(o.onDidChangeConfiguration,T=>T.affectsConfiguration("settingsSync.keybindingsPerPlatform"))(()=>this.triggerLocalChange()))}async generateSyncPreview(r,t,i,o){const l=r.syncData?c(r.syncData.content,o.keybindingsPerPlatform??this.syncKeybindingsPerPlatform(),this.logService):null;t=t===null&&i?r:t;const a=t?this.getKeybindingsContentFromLastSyncUserData(t):null,h=await this.getLocalFileContent(),p=await this.getFormattingOptions();let R=null,M=!1,O=!1,F=!1;if(l){let W=h?h.value.toString():"[]";if(W=W||"[]",this.hasErrors(W,!0))throw new g.UserDataSyncError((0,P.localize)(0,null),"LocalInvalidContent",this.resource);if(!a||a!==W||a!==l){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote keybindings with local keybindings...`);const V=await(0,m.merge)(W,l,a,p,this.userDataSyncUtilService);V.hasChanges&&(R=V.mergeContent,F=V.hasConflicts,M=F||V.mergeContent!==W,O=F||V.mergeContent!==l)}}else h&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote keybindings does not exist. Synchronizing keybindings for the first time.`),R=h.value.toString(),O=!0);const T={content:R,localChange:M?h?2:1:0,remoteChange:O?2:0,hasConflicts:F},N=h?h.value.toString():null;return[{fileContent:h,baseResource:this.baseResource,baseContent:a!==null?a:N,localResource:this.localResource,localContent:N,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:l,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getKeybindingsContentFromLastSyncUserData(r);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString():"",l=await this.getFormattingOptions(),a=await(0,m.merge)(o||"[]",t,t,l,this.userDataSyncUtilService);return a.hasConflicts||a.mergeContent!==t}async getMergeResult(r,t){return r.previewResult}async getAcceptResult(r,t,i,o){if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?r.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,o){const{fileContent:l}=i[0][0];let{content:a,localChange:h,remoteChange:p}=i[0][1];if(h===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing keybindings.`),a!==null&&(a=a.trim(),a=a||"[]",this.hasErrors(a,!0)))throw new g.UserDataSyncError((0,P.localize)(1,null),"LocalInvalidContent",this.resource);if(h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local keybindings...`),l&&await this.backupLocal(this.toSyncContent(l.value.toString())),await this.updateLocalFileContent(a||"[]",l,o),this.logService.info(`${this.syncResourceLogLabel}: Updated local keybindings`)),p!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote keybindings...`);const R=this.toSyncContent(a||"[]",r.syncData?.content);r=await this.updateRemoteUserData(R,o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote keybindings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized keybindings...`),await this.updateLastSyncUserData(r,{platformSpecific:this.syncKeybindingsPerPlatform()}),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized keybindings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=(0,L.parse)(r.value.toString());if((0,D.isNonEmptyArray)(t))return!0}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"keybindings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.baseResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i)switch(this.extUri.basename(r)){case"keybindings.json":return c(i.content,this.syncKeybindingsPerPlatform(),this.logService)}}return null}getKeybindingsContentFromLastSyncUserData(r){return!r.syncData||r.platformSpecific!==void 0&&r.platformSpecific!==this.syncKeybindingsPerPlatform()?null:c(r.syncData.content,this.syncKeybindingsPerPlatform(),this.logService)}toSyncContent(r,t){let i={};try{i=JSON.parse(t||"{}")}catch(o){this.logService.error(o)}switch(this.syncKeybindingsPerPlatform()?delete i.all:i.all=r,A.OS){case 2:i.mac=r;break;case 3:i.linux=r;break;case 1:i.windows=r;break}return JSON.stringify(i)}syncKeybindingsPerPlatform(){return!!this.configurationService.getValue("settingsSync.keybindingsPerPlatform")}};d=me([G(0,g.IUserDataSyncStoreService),G(1,g.IUserDataSyncBackupStoreService),G(2,g.IUserDataSyncLogService),G(3,I.IConfigurationService),G(4,g.IUserDataSyncEnablementService),G(5,w.IFileService),G(6,S.IUserDataProfilesService),G(7,E.IEnvironmentService),G(8,v.IStorageService),G(9,g.IUserDataSyncUtilService),G(10,y.ITelemetryService),G(11,f.IUriIdentityService)],d),e.KeybindingsSynchroniser=d;let u=class extends C.AbstractInitializer{constructor(r,t,i,o,l){super("keybindings",t,i,o,r,l)}async doInitialize(r){const t=r.syncData?this.getKeybindingsContentFromSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing keybindings because remote keybindings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing keybindings because local keybindings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.keybindingsResource,n.VSBuffer.fromString(t)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource),t=(0,L.parse)(r.value.toString());return!(0,D.isNonEmptyArray)(t)}catch(r){return r.fileOperationResult===1}}getKeybindingsContentFromSyncContent(r){try{return c(r,!0,this.logService)}catch(t){return this.logService.error(t),null}}};u=me([G(0,w.IFileService),G(1,S.IUserDataProfilesService),G(2,E.IEnvironmentService),G(3,g.IUserDataSyncLogService),G(4,f.IUriIdentityService)],u),e.KeybindingsInitializer=u}),define(re[257],se([0,1,16,3,159,19,68,14,28,13,23,22,33,29,46,59,238,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SettingsInitializer=e.SettingsSynchroniser=e.parseSettingsSyncContent=void 0;function g(s){return s&&s.settings&&typeof s.settings=="string"&&Object.keys(s).length===1}function c(s){const r=JSON.parse(s);return g(r)?r:{settings:s}}e.parseSettingsSyncContent=c;let d=class extends f.AbstractJsonFileSynchroniser{constructor(r,t,i,o,l,a,h,p,R,M,O,F,T){super(t.defaultProfile.settingsResource,"settings",r,i,o,l,a,M,O,h,p,R,T);this.extensionManagementService=F,this.version=2,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"settings.json"),this.baseResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:m.USER_DATA_SYNC_SCHEME,authority:"accepted"}),this._defaultIgnoredSettings=void 0}async getRemoteUserDataSyncConfiguration(r){const t=await this.getLastSyncUserData(),i=await this.getLatestRemoteUserData(r,t),o=this.getSettingsSyncContent(i),l=new A.ConfigurationModelParser(m.USER_DATA_SYNC_CONFIGURATION_SCOPE);return o?.settings&&l.parse(o.settings),l.configurationModel.getValue(m.USER_DATA_SYNC_CONFIGURATION_SCOPE)||{}}async generateSyncPreview(r,t,i){const o=await this.getLocalFileContent(),l=await this.getFormattingOptions(),a=this.getSettingsSyncContent(r);t=t===null&&i?r:t;const h=t?this.getSettingsSyncContent(t):null,p=await this.getIgnoredSettings();let R=null,M=!1,O=!1,F=!1;if(a){let W=o?o.value.toString().trim():"{}";W=W||"{}",this.validateContent(W),this.logService.trace(`${this.syncResourceLogLabel}: Merging remote settings with local settings...`);const V=(0,C.merge)(W,a.settings,h?h.settings:null,p,[],l);R=V.localContent||V.remoteContent,M=V.localContent!==null,O=V.remoteContent!==null,F=V.hasConflicts}else o&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote settings does not exist. Synchronizing settings for the first time.`),R=o.value.toString().trim()||"{}",this.validateContent(R),O=!0);const T={content:R,localChange:M?2:0,remoteChange:O?2:0,hasConflicts:F},N=o?o.value.toString():null;return[{fileContent:o,baseResource:this.baseResource,baseContent:h?h.settings:N,localResource:this.localResource,localContent:N,localChange:T.localChange,remoteResource:this.remoteResource,remoteContent:a?a.settings:null,remoteChange:T.remoteChange,previewResource:this.previewResource,previewResult:T,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(r){const t=this.getSettingsSyncContent(r);if(t===null)return!0;const i=await this.getLocalFileContent(),o=i?i.value.toString().trim():"",l=await this.getIgnoredSettings(),a=await this.getFormattingOptions();return(0,C.merge)(o||"{}",t.settings,t.settings,l,[],a).remoteContent!==null}async getMergeResult(r,t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();return{...r.previewResult,content:r.previewResult.content?(0,C.updateIgnoredSettings)(r.previewResult.content,"{}",o,i):null}}async getAcceptResult(r,t,i,o){const l=await this.getFormattingOptions(),a=await this.getIgnoredSettings();if(this.extUri.isEqual(t,this.localResource))return{content:r.fileContent?(0,C.updateIgnoredSettings)(r.fileContent.value.toString(),"{}",a,l):null,localChange:0,remoteChange:2};if(this.extUri.isEqual(t,this.remoteResource))return{content:r.remoteContent!==null?(0,C.updateIgnoredSettings)(r.remoteContent,r.fileContent?r.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:0};if(this.extUri.isEqual(t,this.previewResource))return i===void 0?{content:r.previewResult.content,localChange:r.previewResult.localChange,remoteChange:r.previewResult.remoteChange}:{content:i!==null?(0,C.updateIgnoredSettings)(i,r.fileContent?r.fileContent.value.toString():"{}",a,l):null,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${t.toString()}`)}async applyResult(r,t,i,o){const{fileContent:l}=i[0][0];let{content:a,localChange:h,remoteChange:p}=i[0][1];if(h===0&&p===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing settings.`),a=a?a.trim():"{}",a=a||"{}",this.validateContent(a),h!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local settings...`),l&&await this.backupLocal(JSON.stringify(this.toSettingsSyncContent(l.value.toString()))),await this.updateLocalFileContent(a,l,o),await this.configurationService.reloadConfiguration(3),this.logService.info(`${this.syncResourceLogLabel}: Updated local settings`)),p!==0){const R=await this.getFormattingOptions(),M=this.getSettingsSyncContent(r),O=await this.getIgnoredSettings(a);a=(0,C.updateIgnoredSettings)(a,M?M.settings:"{}",O,R),this.logService.trace(`${this.syncResourceLogLabel}: Updating remote settings...`),r=await this.updateRemoteUserData(JSON.stringify(this.toSettingsSyncContent(a)),o?null:r.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote settings`)}try{await this.fileService.del(this.previewResource)}catch{}t?.ref!==r.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized settings...`),await this.updateLastSyncUserData(r),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized settings`))}async hasLocalData(){try{const r=await this.getLocalFileContent();if(r){const t=await this.getFormattingOptions(),i=(0,S.edit)(r.value.toString(),[m.CONFIGURATION_SYNC_STORE_KEY],void 0,t);return!(0,C.isEmpty)(i)}}catch(r){if(r.fileOperationResult!==1)return!0}return!1}async getAssociatedResources({uri:r}){const t=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(r,"settings.json"),comparableResource:t}]}async resolveContent(r){if(this.extUri.isEqual(this.remoteResource,r)||this.extUri.isEqual(this.localResource,r)||this.extUri.isEqual(this.acceptedResource,r)||this.extUri.isEqual(this.baseResource,r))return this.resolvePreviewContent(r);let t=await super.resolveContent(r);if(t)return t;if(t=await super.resolveContent(this.extUri.dirname(r)),t){const i=this.parseSyncData(t);if(i){const o=this.parseSettingsSyncContent(i.content);if(o)switch(this.extUri.basename(r)){case"settings.json":return o.settings}}}return null}async resolvePreviewContent(r){let t=await super.resolvePreviewContent(r);if(t){const i=await this.getFormattingOptions(),o=await this.getIgnoredSettings();t=(0,C.updateIgnoredSettings)(t,"{}",o,i)}return t}getSettingsSyncContent(r){return r.syncData?this.parseSettingsSyncContent(r.syncData.content):null}parseSettingsSyncContent(r){try{return c(r)}catch(t){this.logService.error(t)}return null}toSettingsSyncContent(r){return{settings:r}}async getIgnoredSettings(r){if(!this._defaultIgnoredSettings){this._defaultIgnoredSettings=this.userDataSyncUtilService.resolveDefaultIgnoredSettings();const i=n.Event.any(n.Event.filter(this.extensionManagementService.onDidInstallExtensions,o=>o.some(({local:l})=>!!l)),n.Event.filter(this.extensionManagementService.onDidUninstallExtension,o=>!o.error))(()=>{i.dispose(),this._defaultIgnoredSettings=void 0})}const t=await this._defaultIgnoredSettings;return(0,C.getIgnoredSettings)(t,this.configurationService,r)}validateContent(r){if(this.hasErrors(r,!1))throw new m.UserDataSyncError((0,k.localize)(0,null),"LocalInvalidContent",this.resource)}};d=me([G(0,I.IFileService),G(1,y.IUserDataProfilesService),G(2,b.IEnvironmentService),G(3,E.IStorageService),G(4,m.IUserDataSyncStoreService),G(5,m.IUserDataSyncBackupStoreService),G(6,m.IUserDataSyncLogService),G(7,m.IUserDataSyncUtilService),G(8,L.IConfigurationService),G(9,m.IUserDataSyncEnablementService),G(10,w.ITelemetryService),G(11,P.IExtensionManagementService),G(12,v.IUriIdentityService)],d),e.SettingsSynchroniser=d;let u=class extends f.AbstractInitializer{constructor(r,t,i,o,l){super("settings",t,i,o,r,l)}async doInitialize(r){const t=r.syncData?this.parseSettingsSyncContent(r.syncData.content):null;if(!t){this.logService.info("Skipping initializing settings because remote settings does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing settings because local settings exist.");return}await this.fileService.writeFile(this.userDataProfilesService.defaultProfile.settingsResource,D.VSBuffer.fromString(t.settings)),await this.updateLastSyncUserData(r)}async isEmpty(){try{const r=await this.fileService.readFile(this.userDataProfilesService.defaultProfile.settingsResource);return(0,C.isEmpty)(r.value.toString().trim())}catch(r){return r.fileOperationResult===1}}parseSettingsSyncContent(r){try{return c(r)}catch(t){this.logService.error(t)}return null}};u=me([G(0,I.IFileService),G(1,y.IUserDataProfilesService),G(2,b.IEnvironmentService),G(3,m.IUserDataSyncLogService),G(4,v.IUriIdentityService)],u),e.SettingsInitializer=u}),define(re[258],se([0,1,16,3,31,19,14,13,23,22,33,29,46,236,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SnippetsInitializer=e.SnippetsSynchroniser=void 0;let S=class extends v.AbstractSynchroniser{constructor(g,c,d,u,s,r,t,i,o,l,a){super("snippets",c,g,u,s,r,o,l,t,i,a);this.version=1,this.snippetsFolder=d.defaultProfile.snippetsHome,this._register(this.fileService.watch(g.userRoamingDataHome)),this._register(this.fileService.watch(this.snippetsFolder)),this._register(n.Event.filter(this.fileService.onDidFilesChange,h=>h.affects(this.snippetsFolder))(()=>this.triggerLocalChange()))}async generateSyncPreview(g,c,d){const u=await this.getSnippetsFileContents(),s=this.toSnippetsContents(u),r=g.syncData?this.parseSnippets(g.syncData):null;c=c===null&&d?g:c;const t=c&&c.syncData?this.parseSnippets(c.syncData):null;r?this.logService.trace(`${this.syncResourceLogLabel}: Merging remote snippets with local snippets...`):this.logService.trace(`${this.syncResourceLogLabel}: Remote snippets does not exist. Synchronizing snippets for the first time.`);const i=(0,y.merge)(s,r,t);return this.getResourcePreviews(i,u,r||{},t||{})}async hasRemoteChanged(g){const c=g.syncData?this.parseSnippets(g.syncData):null;if(c===null)return!0;const d=await this.getSnippetsFileContents(),u=this.toSnippetsContents(d),s=(0,y.merge)(u,c,c);return Object.keys(s.remote.added).length>0||Object.keys(s.remote.updated).length>0||s.remote.removed.length>0||s.conflicts.length>0}async getMergeResult(g,c){return g.previewResult}async getAcceptResult(g,c,d,u){if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})))return{content:g.fileContent?g.fileContent.value.toString():null,localChange:0,remoteChange:g.fileContent?g.remoteContent!==null?2:1:3};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"})))return{content:g.remoteContent,localChange:g.remoteContent!==null?g.fileContent?2:1:3,remoteChange:0};if(this.extUri.isEqualOrParent(c,this.syncPreviewFolder))return d===void 0?{content:g.previewResult.content,localChange:g.previewResult.localChange,remoteChange:g.previewResult.remoteChange}:{content:d,localChange:d===null?g.fileContent!==null?3:0:2,remoteChange:d===null?g.remoteContent!==null?3:0:2};throw new Error(`Invalid Resource: ${c.toString()}`)}async applyResult(g,c,d,u){const s=d.map(([r,t])=>({...r,acceptResult:t}));s.every(({localChange:r,remoteChange:t})=>r===0&&t===0)&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing snippets.`),s.some(({localChange:r})=>r!==0)&&(await this.updateLocalBackup(s),await this.updateLocalSnippets(s,u)),s.some(({remoteChange:r})=>r!==0)&&(g=await this.updateRemoteSnippets(s,g,u)),c?.ref!==g.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized snippets...`),await this.updateLastSyncUserData(g),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized snippets`));for(const{previewResource:r}of s)try{await this.fileService.del(r)}catch{}}getResourcePreviews(g,c,d,u){const s=new Map;for(const r of Object.keys(g.local.added)){const t={content:g.local.added[r],hasConflicts:!1,localChange:1,remoteChange:0};s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:null,fileContent:null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.local.updated)){const t={content:g.local.updated[r],hasConflicts:!1,localChange:2,remoteChange:0},i=c[r]?c[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.local.removed){const t={content:null,hasConflicts:!1,localChange:3,remoteChange:0},i=c[r]?c[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.added)){const t={content:g.remote.added[r],hasConflicts:!1,localChange:0,remoteChange:1},i=c[r]?c[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(g.remote.updated)){const t={content:g.remote.updated[r],hasConflicts:!1,localChange:0,remoteChange:2},i=c[r]?c[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r],localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.remote.removed){const t={content:null,hasConflicts:!1,localChange:0,remoteChange:3};s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??null,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:null,localContent:null,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r],previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of g.conflicts){const t={content:c[r]?c[r].value.toString():null,hasConflicts:!0,localChange:c[r]?2:1,remoteChange:d[r]?2:1},i=c[r]?c[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}for(const r of Object.keys(c))if(!s.has(r)){const t={content:c[r]?c[r].value.toString():null,hasConflicts:!1,localChange:0,remoteChange:0},i=c[r]?c[r].value.toString():null;s.set(r,{baseResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}),baseContent:u[r]??i,localResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}),fileContent:c[r]||null,localContent:i,remoteResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}),remoteContent:d[r]||null,previewResource:this.extUri.joinPath(this.syncPreviewFolder,r),previewResult:t,localChange:t.localChange,remoteChange:t.remoteChange,acceptedResource:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})})}return[...s.values()]}async getAssociatedResources({uri:g}){const c=await super.resolveContent(g);if(c){const d=this.parseSyncData(c);if(d){const u=this.parseSnippets(d),s=[];for(const r of Object.keys(u)){const t=this.extUri.joinPath(g,r),i=this.extUri.joinPath(this.snippetsFolder,r),o=await this.fileService.exists(i);s.push({resource:t,comparableResource:o?i:this.extUri.joinPath(this.syncPreviewFolder,r).with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"})})}return s}}return[]}async resolveContent(g){if(this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"remote"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"local"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"base"}))||this.extUri.isEqualOrParent(g,this.syncPreviewFolder.with({scheme:f.USER_DATA_SYNC_SCHEME,authority:"accepted"})))return this.resolvePreviewContent(g);let c=await super.resolveContent(g);if(c)return c;if(c=await super.resolveContent(this.extUri.dirname(g)),c){const d=this.parseSyncData(c);if(d)return this.parseSnippets(d)[this.extUri.basename(g)]||null}return null}async hasLocalData(){try{const g=await this.getSnippetsFileContents();if(Object.keys(g).length)return!0}catch{}return!1}async updateLocalBackup(g){const c={};for(const d of g)d.fileContent&&(c[this.extUri.basename(d.localResource)]=d.fileContent);await this.backupLocal(JSON.stringify(this.toSnippetsContents(c)))}async updateLocalSnippets(g,c){for(const{fileContent:d,acceptResult:u,localResource:s,remoteResource:r,localChange:t}of g)if(t!==0){const i=r?this.extUri.basename(r):this.extUri.basename(s),o=this.extUri.joinPath(this.snippetsFolder,i);t===3?(this.logService.trace(`${this.syncResourceLogLabel}: Deleting snippet...`,this.extUri.basename(o)),await this.fileService.del(o),this.logService.info(`${this.syncResourceLogLabel}: Deleted snippet`,this.extUri.basename(o))):t===1?(this.logService.trace(`${this.syncResourceLogLabel}: Creating snippet...`,this.extUri.basename(o)),await this.fileService.createFile(o,D.VSBuffer.fromString(u.content),{overwrite:c}),this.logService.info(`${this.syncResourceLogLabel}: Created snippet`,this.extUri.basename(o))):(this.logService.trace(`${this.syncResourceLogLabel}: Updating snippet...`,this.extUri.basename(o)),await this.fileService.writeFile(o,D.VSBuffer.fromString(u.content),c?void 0:d),this.logService.info(`${this.syncResourceLogLabel}: Updated snippet`,this.extUri.basename(o)))}}async updateRemoteSnippets(g,c,d){const u=c.syncData?this.parseSnippets(c.syncData):{},s=(0,k.deepClone)(u);for(const{acceptResult:r,localResource:t,remoteResource:i,remoteChange:o}of g)if(o!==0){const l=t?this.extUri.basename(t):this.extUri.basename(i);o===3?delete s[l]:s[l]=r.content}return(0,y.areSame)(u,s)||(this.logService.trace(`${this.syncResourceLogLabel}: Updating remote snippets...`),c=await this.updateRemoteUserData(JSON.stringify(s),d?null:c.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote snippets`)),c}parseSnippets(g){return JSON.parse(g.content)}toSnippetsContents(g){const c={};for(const d of Object.keys(g))c[d]=g[d].value.toString();return c}async getSnippetsFileContents(){const g={};let c;try{c=await this.fileService.resolve(this.snippetsFolder)}catch(d){if(d instanceof b.FileOperationError&&d.fileOperationResult===1)return g;throw d}for(const d of c.children||[]){const u=d.resource,s=this.extUri.extname(u);if(s===".json"||s===".code-snippets"){const r=this.extUri.relativePath(this.snippetsFolder,u),t=await this.fileService.readFile(u);g[r]=t}}return g}};S=me([G(0,A.IEnvironmentService),G(1,b.IFileService),G(2,w.IUserDataProfilesService),G(3,P.IStorageService),G(4,f.IUserDataSyncStoreService),G(5,f.IUserDataSyncBackupStoreService),G(6,f.IUserDataSyncLogService),G(7,L.IConfigurationService),G(8,f.IUserDataSyncEnablementService),G(9,I.ITelemetryService),G(10,E.IUriIdentityService)],S),e.SnippetsSynchroniser=S;let C=class extends v.AbstractInitializer{constructor(g,c,d,u,s){super("snippets",c,d,u,g,s)}async doInitialize(g){const c=g.syncData?JSON.parse(g.syncData.content):null;if(!c){this.logService.info("Skipping initializing snippets because remote snippets does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing snippets because local snippets exist.");return}for(const u of Object.keys(c)){const s=c[u];if(s){const r=this.extUri.joinPath(this.userDataProfilesService.defaultProfile.snippetsHome,u);await this.fileService.createFile(r,D.VSBuffer.fromString(s)),this.logService.info("Created snippet",this.extUri.basename(r))}}await this.updateLastSyncUserData(g)}async isEmpty(){try{return!(await this.fileService.resolve(this.userDataProfilesService.defaultProfile.snippetsHome)).children?.length}catch(g){return g.fileOperationResult===1}}};C=me([G(0,b.IFileService),G(1,w.IUserDataProfilesService),G(2,A.IEnvironmentService),G(3,f.IUserDataSyncLogService),G(4,E.IUriIdentityService)],C),e.SnippetsInitializer=C}),define(re[259],se([0,1,16,19,14,13,23,22,33,29,46,25]),function(X,e,D,n,k,L,A,b,P,I,E,w){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TasksInitializer=e.TasksSynchroniser=e.getTasksContentFromSyncContent=void 0;function v(C,m){try{return JSON.parse(C).tasks}catch(g){return m.error(g),null}}e.getTasksContentFromSyncContent=v;let y=class extends E.AbstractFileSynchroniser{constructor(m,g,c,d,u,s,r,t,i,o,l){super(l.defaultProfile.tasksResource,"tasks",s,r,t,m,g,u,i,c,d,o);this.version=1,this.previewResource=this.extUri.joinPath(this.syncPreviewFolder,"tasks.json"),this.baseResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"base"}),this.localResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"local"}),this.remoteResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"remote"}),this.acceptedResource=this.previewResource.with({scheme:w.USER_DATA_SYNC_SCHEME,authority:"accepted"})}async generateSyncPreview(m,g,c,d){const u=m.syncData?v(m.syncData.content,this.logService):null;g=g===null&&c?m:g;const s=g?.syncData?v(g.syncData.content,this.logService):null,r=await this.getLocalFileContent();let t=null,i=!1,o=!1,l=!1;if(u){const p=r?r.value.toString():null;if(!s||s!==p||s!==u){this.logService.trace(`${this.syncResourceLogLabel}: Merging remote tasks with local tasks...`);const R=S(p,u,s);t=R.content,l=R.hasConflicts,i=R.hasLocalChanged,o=R.hasRemoteChanged}}else r&&(this.logService.trace(`${this.syncResourceLogLabel}: Remote tasks does not exist. Synchronizing tasks for the first time.`),t=r.value.toString(),o=!0);const a={content:t,localChange:i?r?2:1:0,remoteChange:o?2:0,hasConflicts:l},h=r?r.value.toString():null;return[{fileContent:r,baseResource:this.baseResource,baseContent:s!==null?s:h,localResource:this.localResource,localContent:h,localChange:a.localChange,remoteResource:this.remoteResource,remoteContent:u,remoteChange:a.remoteChange,previewResource:this.previewResource,previewResult:a,acceptedResource:this.acceptedResource}]}async hasRemoteChanged(m){const g=m?.syncData?v(m.syncData.content,this.logService):null;if(g===null)return!0;const c=await this.getLocalFileContent(),d=c?c.value.toString():null,u=S(d,g,g);return u.hasLocalChanged||u.hasRemoteChanged}async getMergeResult(m,g){return m.previewResult}async getAcceptResult(m,g,c,d){if(this.extUri.isEqual(g,this.localResource))return{content:m.fileContent?m.fileContent.value.toString():null,localChange:0,remoteChange:2};if(this.extUri.isEqual(g,this.remoteResource))return{content:m.remoteContent,localChange:2,remoteChange:0};if(this.extUri.isEqual(g,this.previewResource))return c===void 0?{content:m.previewResult.content,localChange:m.previewResult.localChange,remoteChange:m.previewResult.remoteChange}:{content:c,localChange:2,remoteChange:2};throw new Error(`Invalid Resource: ${g.toString()}`)}async applyResult(m,g,c,d){const{fileContent:u}=c[0][0],{content:s,localChange:r,remoteChange:t}=c[0][1];if(r===0&&t===0&&this.logService.info(`${this.syncResourceLogLabel}: No changes found during synchronizing tasks.`),r!==0&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating local tasks...`),u&&await this.backupLocal(JSON.stringify(this.toTasksSyncContent(u.value.toString()))),await this.updateLocalFileContent(s||"{}",u,d),this.logService.info(`${this.syncResourceLogLabel}: Updated local tasks`)),t!==0){this.logService.trace(`${this.syncResourceLogLabel}: Updating remote tasks...`);const i=JSON.stringify(this.toTasksSyncContent(s||"{}"));m=await this.updateRemoteUserData(i,d?null:m.ref),this.logService.info(`${this.syncResourceLogLabel}: Updated remote tasks`)}try{await this.fileService.del(this.previewResource)}catch{}g?.ref!==m.ref&&(this.logService.trace(`${this.syncResourceLogLabel}: Updating last synchronized tasks...`),await this.updateLastSyncUserData(m),this.logService.info(`${this.syncResourceLogLabel}: Updated last synchronized tasks`))}async hasLocalData(){return this.fileService.exists(this.file)}async getAssociatedResources({uri:m}){const g=await this.fileService.exists(this.file)?this.file:this.localResource;return[{resource:this.extUri.joinPath(m,"tasks.json"),comparableResource:g}]}async resolveContent(m){if(this.extUri.isEqual(this.remoteResource,m)||this.extUri.isEqual(this.baseResource,m)||this.extUri.isEqual(this.localResource,m)||this.extUri.isEqual(this.acceptedResource,m))return this.resolvePreviewContent(m);let g=await super.resolveContent(m);if(g)return g;if(g=await super.resolveContent(this.extUri.dirname(m)),g){const c=this.parseSyncData(g);if(c)switch(this.extUri.basename(m)){case"tasks.json":return v(c.content,this.logService)}}return null}toTasksSyncContent(m){return{tasks:m}}};y=me([G(0,w.IUserDataSyncStoreService),G(1,w.IUserDataSyncBackupStoreService),G(2,w.IUserDataSyncLogService),G(3,n.IConfigurationService),G(4,w.IUserDataSyncEnablementService),G(5,L.IFileService),G(6,k.IEnvironmentService),G(7,A.IStorageService),G(8,b.ITelemetryService),G(9,P.IUriIdentityService),G(10,I.IUserDataProfilesService)],y),e.TasksSynchroniser=y;let f=class extends E.AbstractInitializer{constructor(m,g,c,d,u){super("tasks",g,c,d,m,u);this.tasksResource=this.userDataProfilesService.defaultProfile.tasksResource}async doInitialize(m){const g=m.syncData?v(m.syncData.content,this.logService):null;if(!g){this.logService.info("Skipping initializing tasks because remote tasks does not exist.");return}if(!await this.isEmpty()){this.logService.info("Skipping initializing tasks because local tasks exist.");return}await this.fileService.writeFile(this.tasksResource,D.VSBuffer.fromString(g)),await this.updateLastSyncUserData(m)}async isEmpty(){return this.fileService.exists(this.tasksResource)}};f=me([G(0,L.IFileService),G(1,I.IUserDataProfilesService),G(2,k.IEnvironmentService),G(3,w.IUserDataSyncLogService),G(4,P.IUriIdentityService)],f),e.TasksInitializer=f;function S(C,m,g){if(C===null&&m===null&&g===null)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};if(C===m)return{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1};const c=g!==C,d=g!==m;return!c&&!d?{content:null,hasLocalChanged:!1,hasRemoteChanged:!1,hasConflicts:!1}:c&&!d?{content:C,hasRemoteChanged:!0,hasLocalChanged:!1,hasConflicts:!1}:d&&!c?{content:m,hasLocalChanged:!0,hasRemoteChanged:!1,hasConflicts:!1}:{content:C,hasLocalChanged:!0,hasRemoteChanged:!0,hasConflicts:!0}}}),define(re[260],se([0,1,3,2,4,14,23,22,25]),function(X,e,D,n,k,L,A,b,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncEnablementService=void 0;const I="sync.enable";let E=class extends n.Disposable{constructor(v,y,f,S){super();this.storageService=v,this.telemetryService=y,this.environmentService=f,this.userDataSyncStoreManagementService=S,this._onDidChangeEnablement=new D.Emitter,this.onDidChangeEnablement=this._onDidChangeEnablement.event,this._onDidChangeResourceEnablement=new D.Emitter,this.onDidChangeResourceEnablement=this._onDidChangeResourceEnablement.event,this._register(v.onDidChangeValue(C=>this.onDidStorageChange(C)))}isEnabled(){switch(this.environmentService.sync){case"on":return!0;case"off":return!1}return this.storageService.getBoolean(I,-1,!1)}canToggleEnablement(){return this.userDataSyncStoreManagementService.userDataSyncStore!==void 0&&this.environmentService.sync===void 0}setEnablement(v){v&&!this.canToggleEnablement()||(this.telemetryService.publicLog2(I,{enabled:v}),this.storageService.store(I,v,-1,1))}isResourceEnabled(v){return this.storageService.getBoolean((0,P.getEnablementKey)(v),-1,!0)}setResourceEnablement(v,y){if(this.isResourceEnabled(v)!==y){const f=(0,P.getEnablementKey)(v);this.storeResourceEnablement(f,y)}}getResourceSyncStateVersion(v){}storeResourceEnablement(v,y){this.storageService.store(v,y,-1,k.isWeb?0:1)}onDidStorageChange(v){if(v.scope!==-1)return;if(I===v.key){this._onDidChangeEnablement.fire(this.isEnabled());return}const y=P.ALL_SYNC_RESOURCES.filter(f=>(0,P.getEnablementKey)(f)===v.key)[0];if(y){this._onDidChangeResourceEnablement.fire([y,this.isResourceEnabled(y)]);return}}};E=me([G(0,A.IStorageService),G(1,b.ITelemetryService),G(2,L.IEnvironmentService),G(3,P.IUserDataSyncStoreManagementService)],E),e.UserDataSyncEnablementService=E}),define(re[73],se([0,1,3,2,4,26,162,14,13,5,24,48,23,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncMachinesService=e.isWebPlatform=e.IUserDataSyncMachinesService=void 0,e.IUserDataSyncMachinesService=(0,I.createDecorator)("IUserDataSyncMachinesService");const f="sync.currentMachineName",S="Safari",C="Chrome",m="Edge",g="Firefox",c="Android";function d(r){switch(r){case S:case C:case m:case g:case c:case(0,k.PlatformToString)(0):return!0}return!1}e.isWebPlatform=d;function u(){return k.isSafari?S:k.isChrome?C:k.isEdge?m:k.isFirefox?g:k.isAndroid?c:(0,k.PlatformToString)(k.isWeb?0:k.platform)}let s=class tt extends n.Disposable{constructor(t,i,o,l,a,h){super();this.storageService=o,this.userDataSyncStoreService=l,this.logService=a,this.productService=h,this._onDidChange=this._register(new D.Emitter),this.onDidChange=this._onDidChange.event,this.userData=null,this.currentMachineIdPromise=(0,w.getServiceMachineId)(t,i,o)}async getMachines(t){const i=await this.currentMachineIdPromise;return(await this.readMachinesData(t)).machines.map(l=>({...l,isCurrent:l.id===i}))}async addCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t);o.machines.some(({id:l})=>l===i)||(o.machines.push({id:i,name:this.computeCurrentMachineName(o.machines),platform:u()}),await this.writeMachinesData(o))}async removeCurrentMachine(t){const i=await this.currentMachineIdPromise,o=await this.readMachinesData(t),l=o.machines.filter(({id:a})=>a!==i);l.length!==o.machines.length&&(o.machines=l,await this.writeMachinesData(o))}async renameMachine(t,i,o){const l=await this.readMachinesData(o),a=l.machines.find(({id:h})=>h===t);if(a){a.name=i,await this.writeMachinesData(l);const h=await this.currentMachineIdPromise;t===h&&this.storageService.store(f,i,-1,1)}}async setEnablements(t){const i=await this.readMachinesData();for(const[o,l]of t){const a=i.machines.find(h=>h.id===o);a&&(a.disabled=l?void 0:!0)}await this.writeMachinesData(i)}computeCurrentMachineName(t){const i=this.storageService.get(f,-1);if(i)return i;const o=`${this.productService.embedderIdentifier?`${this.productService.embedderIdentifier} - `:""}${u()} (${this.productService.nameShort})`,l=new RegExp(`${(0,L.escapeRegExpCharacters)(o)}\\s#(\\d+)`);let a=0;for(const h of t){const p=l.exec(h.name),R=p?parseInt(p[1]):0;a=R>a?R:a}return`${o} #${a+1}`}async readMachinesData(t){this.userData=await this.readUserData(t);const i=this.parse(this.userData);if(i.version!==tt.VERSION)throw new Error((0,A.localize)(0,null,this.productService.nameLong));return i}async writeMachinesData(t){const i=JSON.stringify(t),o=await this.userDataSyncStoreService.write(tt.RESOURCE,i,this.userData?.ref||null);this.userData={ref:o,content:i},this._onDidChange.fire()}async readUserData(t){if(this.userData){const i=t&&t.latest?t.latest[tt.RESOURCE]:void 0;if(this.userData.ref===i)return this.userData;if(i===void 0&&this.userData.content===null)return this.userData}return this.userDataSyncStoreService.read(tt.RESOURCE,this.userData)}parse(t){if(t.content!==null)try{return JSON.parse(t.content)}catch(i){this.logService.error(i)}return{version:tt.VERSION,machines:[]}}};s.VERSION=1,s.RESOURCE="machines",s=me([G(0,b.IEnvironmentService),G(1,P.IFileService),G(2,v.IStorageService),G(3,y.IUserDataSyncStoreService),G(4,y.IUserDataSyncLogService),G(5,E.IProductService)],s),e.UserDataSyncMachinesService=s}),define(re[261],se([0,1,6,61,38,9,3,2,4,17,7,160,24,23,22,25,70,73]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;const g="sync.disableMachineEventually",c="sync.sessionId",d="sync.storeUrl",u="sync.productQuality";let s=class extends b.Disposable{constructor(i,o,l,a,h,p,R,M,O,F){super();this.userDataSyncStoreManagementService=o,this.userDataSyncStoreService=l,this.userDataSyncEnablementService=a,this.userDataSyncService=h,this.logService=p,this.userDataSyncAccountService=R,this.telemetryService=M,this.userDataSyncMachinesService=O,this.storageService=F,this.autoSync=this._register(new b.MutableDisposable),this.successiveFailures=0,this.lastSyncTriggerTime=void 0,this.suspendUntilRestart=!1,this._onError=this._register(new A.Emitter),this.onError=this._onError.event,this.sources=[],this.syncTriggerDelayer=this._register(new D.ThrottledDelayer(this.getSyncTriggerDelayTime())),this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.previousProductQuality=this.productQuality,this.productQuality=i.quality,this.syncUrl&&(this.logService.info("Using settings sync service",this.syncUrl.toString()),this._register(o.onDidChangeUserDataSyncStore(()=>{(0,I.isEqual)(this.syncUrl,o.userDataSyncStore?.url)||(this.lastSyncUrl=this.syncUrl,this.syncUrl=o.userDataSyncStore?.url,this.syncUrl&&this.logService.info("Using settings sync service",this.syncUrl.toString()))})),this.userDataSyncEnablementService.isEnabled()?this.logService.info("Auto Sync is enabled."):this.logService.info("Auto Sync is disabled."),this.updateAutoSync(),this.hasToDisableMachineEventually()&&this.disableMachineEventually(),this._register(R.onDidChangeAccount(()=>this.updateAutoSync())),this._register(l.onDidChangeDonotMakeRequestsUntil(()=>this.updateAutoSync())),this._register(h.onDidChangeLocal(T=>this.triggerSync([T],!1,!1))),this._register(A.Event.filter(this.userDataSyncEnablementService.onDidChangeResourceEnablement,([,T])=>T)(()=>this.triggerSync(["resourceEnablement"],!1,!1))),this._register(this.userDataSyncStoreManagementService.onDidChangeUserDataSyncStore(()=>this.triggerSync(["userDataSyncStoreChanged"],!1,!1))))}get syncUrl(){const i=this.storageService.get(d,-1);return i?E.URI.parse(i):void 0}set syncUrl(i){i?this.storageService.store(d,i.toString(),-1,1):this.storageService.remove(d,-1)}get productQuality(){return this.storageService.get(u,-1)}set productQuality(i){i?this.storageService.store(u,i,-1,1):this.storageService.remove(u,-1)}updateAutoSync(){const{enabled:i,message:o}=this.isAutoSyncEnabled();i?this.autoSync.value===void 0&&(this.autoSync.value=new r(this.lastSyncUrl,1e3*60*5,this.userDataSyncStoreManagementService,this.userDataSyncStoreService,this.userDataSyncService,this.userDataSyncMachinesService,this.logService,this.storageService),this.autoSync.value.register(this.autoSync.value.onDidStartSync(()=>this.lastSyncTriggerTime=new Date().getTime())),this.autoSync.value.register(this.autoSync.value.onDidFinishSync(l=>this.onDidFinishSync(l))),this.startAutoSync()&&this.autoSync.value.start()):(this.syncTriggerDelayer.cancel(),this.autoSync.value!==void 0?(o&&this.logService.info(o),this.autoSync.clear()):o&&this.userDataSyncEnablementService.isEnabled()&&this.logService.info(o))}startAutoSync(){return!0}isAutoSyncEnabled(){return this.userDataSyncEnablementService.isEnabled()?this.userDataSyncAccountService.account?this.userDataSyncStoreService.donotMakeRequestsUntil?{enabled:!1,message:`Auto Sync: Suspended until ${(0,n.toLocalISOString)(this.userDataSyncStoreService.donotMakeRequestsUntil)} because server is not accepting requests until then.`}:this.suspendUntilRestart?{enabled:!1,message:"Auto Sync: Suspended until restart."}:{enabled:!0}:{enabled:!1,message:"Auto Sync: Suspended until auth token is available."}:{enabled:!1,message:"Auto Sync: Disabled."}}async turnOn(){this.stopDisableMachineEventually(),this.lastSyncUrl=this.syncUrl,this.updateEnablement(!0)}async turnOff(i,o,l){try{this.userDataSyncAccountService.account&&!l&&await this.userDataSyncMachinesService.removeCurrentMachine(),this.updateEnablement(!1),this.storageService.remove(c,-1),i?(this.telemetryService.publicLog2("sync/turnOffEveryWhere"),await this.userDataSyncService.reset()):await this.userDataSyncService.resetLocal()}catch(a){if(o)this.logService.error(a),this.updateEnablement(!1);else throw a}}updateEnablement(i){this.userDataSyncEnablementService.isEnabled()!==i&&(this.userDataSyncEnablementService.setEnablement(i),this.updateAutoSync())}hasProductQualityChanged(){return!!this.previousProductQuality&&!!this.productQuality&&this.previousProductQuality!==this.productQuality}async onDidFinishSync(i){if(!i){this.successiveFailures=0;return}const o=S.UserDataSyncError.toUserDataSyncError(i);o instanceof S.UserDataAutoSyncError&&this.telemetryService.publicLog2("autosync/error",{code:o.code,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()}),o.code==="SessionExpired"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because current session is expired")):o.code==="TurnedOff"?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because sync is turned off in the cloud")):o.code==="LocalTooManyRequests"?(this.suspendUntilRestart=!0,this.logService.info("Auto Sync: Suspended sync because of making too many requests to server"),this.updateAutoSync()):o.code==="RemoteTooManyRequests"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because of making too many requests to server")):o.code==="UpgradeRequired"||o.code==="Gone"?(await this.turnOff(!1,!0,!0),this.disableMachineEventually(),this.logService.info("Auto Sync: Turned off sync because current client is not compatible with server. Requires client upgrade.")):o.code==="IncompatibleLocalContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with newer version than of client. Requires client upgrade.`)):o.code==="IncompatibleRemoteContent"?(await this.turnOff(!1,!0),this.logService.info(`Auto Sync: Turned off sync because server has ${o.resource} content with older version than of client. Requires server reset.`)):o.code==="ServiceChanged"||o.code==="DefaultServiceChanged"?P.isWeb&&o.code==="DefaultServiceChanged"&&!this.hasProductQualityChanged()?(await this.turnOff(!1,!0),this.logService.info("Auto Sync: Turned off sync because default sync service is changed.")):(await this.turnOff(!1,!0,!0),await this.turnOn(),this.logService.info("Auto Sync: Sync Service changed. Turned off auto sync, reset local state and turned on auto sync.")):(this.logService.error(o),this.successiveFailures++),this._onError.fire(o)}async disableMachineEventually(){this.storageService.store(g,!0,-1,1),await(0,D.timeout)(1e3*60*10),!!this.hasToDisableMachineEventually()&&(this.stopDisableMachineEventually(),!this.userDataSyncEnablementService.isEnabled()&&this.userDataSyncAccountService.account&&await this.userDataSyncMachinesService.removeCurrentMachine())}hasToDisableMachineEventually(){return this.storageService.getBoolean(g,-1,!1)}stopDisableMachineEventually(){this.storageService.remove(g,-1)}async triggerSync(i,o,l){if(this.autoSync.value===void 0)return this.syncTriggerDelayer.cancel();if(o&&this.lastSyncTriggerTime&&Math.round((new Date().getTime()-this.lastSyncTriggerTime)/1e3)<10){this.logService.debug("Auto Sync: Skipped. Limited to once per 10 seconds.");return}return this.sources.push(...i),this.syncTriggerDelayer.trigger(async()=>{this.logService.trace("activity sources",...this.sources),this.telemetryService.publicLog2("sync/triggered",{sources:this.sources}),this.sources=[],this.autoSync.value&&await this.autoSync.value.sync("Activity",l)},this.successiveFailures?this.getSyncTriggerDelayTime()*1*Math.min(Math.pow(2,this.successiveFailures),60):this.getSyncTriggerDelayTime())}getSyncTriggerDelayTime(){return 2e3}};s=me([G(0,v.IProductService),G(1,S.IUserDataSyncStoreManagementService),G(2,S.IUserDataSyncStoreService),G(3,S.IUserDataSyncEnablementService),G(4,S.IUserDataSyncService),G(5,S.IUserDataSyncLogService),G(6,C.IUserDataSyncAccountService),G(7,f.ITelemetryService),G(8,m.IUserDataSyncMachinesService),G(9,y.IStorageService)],s),e.UserDataAutoSyncService=s;class r extends b.Disposable{constructor(i,o,l,a,h,p,R,M){super();this.lastSyncUrl=i,this.interval=o,this.userDataSyncStoreManagementService=l,this.userDataSyncStoreService=a,this.userDataSyncService=h,this.userDataSyncMachinesService=p,this.logService=R,this.storageService=M,this.intervalHandler=this._register(new b.MutableDisposable),this._onDidStartSync=this._register(new A.Emitter),this.onDidStartSync=this._onDidStartSync.event,this._onDidFinishSync=this._register(new A.Emitter),this.onDidFinishSync=this._onDidFinishSync.event,this.manifest=null}start(){this._register(this.onDidFinishSync(()=>this.waitUntilNextIntervalAndSync())),this._register((0,b.toDisposable)(()=>{this.syncPromise&&(this.syncPromise.cancel(),this.logService.info("Auto sync: Cancelled sync that is in progress"),this.syncPromise=void 0),this.syncTask?.stop(),this.logService.info("Auto Sync: Stopped")})),this.logService.info("Auto Sync: Started"),this.sync(r.INTERVAL_SYNCING,!1)}waitUntilNextIntervalAndSync(){this.intervalHandler.value=(0,D.disposableTimeout)(()=>this.sync(r.INTERVAL_SYNCING,!1),this.interval)}sync(i,o){const l=(0,D.createCancelablePromise)(async a=>{if(this.syncPromise)try{this.logService.debug("Auto Sync: Waiting until sync is finished."),await this.syncPromise}catch(h){if((0,L.isCancellationError)(h))return}return this.doSync(i,o,a)});return this.syncPromise=l,this.syncPromise.finally(()=>this.syncPromise=void 0),this.syncPromise}hasSyncServiceChanged(){return this.lastSyncUrl!==void 0&&!(0,I.isEqual)(this.lastSyncUrl,this.userDataSyncStoreManagementService.userDataSyncStore?.url)}async hasDefaultServiceChanged(){const i=await this.userDataSyncStoreManagementService.getPreviousUserDataSyncStore(),o=this.userDataSyncStoreManagementService.userDataSyncStore;return!!o&&!!i&&(!(0,I.isEqual)(o.defaultUrl,i.defaultUrl)||!(0,I.isEqual)(o.insidersUrl,i.insidersUrl)||!(0,I.isEqual)(o.stableUrl,i.stableUrl))}async doSync(i,o,l){this.logService.info(`Auto Sync: Triggered by ${i}`),this._onDidStartSync.fire();let a;try{if(this.syncTask=await this.userDataSyncService.createSyncTask(this.manifest,o),l.isCancellationRequested)return;if(this.manifest=this.syncTask.manifest,this.manifest===null&&await this.userDataSyncService.hasPreviouslySynced())throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(0,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(1,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(2,null),"TurnedOff");const h=this.storageService.get(c,-1);if(h&&this.manifest&&h!==this.manifest.session)throw this.hasSyncServiceChanged()?await this.hasDefaultServiceChanged()?new S.UserDataAutoSyncError((0,w.localize)(3,null),"DefaultServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(4,null),"ServiceChanged"):new S.UserDataAutoSyncError((0,w.localize)(5,null),"SessionExpired");const p=await this.userDataSyncMachinesService.getMachines(this.manifest||void 0);if(l.isCancellationRequested)return;const R=p.find(M=>M.isCurrent);if(R?.disabled)throw new S.UserDataAutoSyncError((0,w.localize)(6,null),"TurnedOff");if(await this.syncTask.run(),this.manifest===null)try{this.manifest=await this.userDataSyncStoreService.manifest(null)}catch(M){throw new S.UserDataAutoSyncError((0,k.toErrorMessage)(M),M instanceof S.UserDataSyncError?M.code:"Unknown")}if(this.manifest&&this.manifest.session!==h&&this.storageService.store(c,this.manifest.session,-1,1),l.isCancellationRequested)return;R||await this.userDataSyncMachinesService.addCurrentMachine(this.manifest||void 0)}catch(h){this.logService.error(h),a=h}this._onDidFinishSync.fire(a)}register(i){return super._register(i)}}r.INTERVAL_SYNCING="Interval"}),define(re[262],se([0,1,18,6,38,3,2,17,15,30,19,28,5,23,22,254,255,256,257,258,259,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataSyncService=void 0;const s="sync.lastSyncTime";let r=class extends A.Disposable{constructor(a,h,p,R,M,O,F,T){super();this.userDataSyncStoreService=a,this.userDataSyncStoreManagementService=h,this.instantiationService=p,this.configurationService=R,this.logService=M,this.telemetryService=O,this.storageService=F,this.userDataSyncEnablementService=T,this._status="uninitialized",this._onDidChangeStatus=this._register(new L.Emitter),this.onDidChangeStatus=this._onDidChangeStatus.event,this._onDidChangeLocal=this._register(new L.Emitter),this.onDidChangeLocal=this._onDidChangeLocal.event,this._conflicts=[],this._onDidChangeConflicts=this._register(new L.Emitter),this.onDidChangeConflicts=this._onDidChangeConflicts.event,this._syncErrors=[],this._onSyncErrors=this._register(new L.Emitter),this.onSyncErrors=this._onSyncErrors.event,this._lastSyncTime=void 0,this._onDidChangeLastSyncTime=this._register(new L.Emitter),this.onDidChangeLastSyncTime=this._onDidChangeLastSyncTime.event,this._onDidResetLocal=this._register(new L.Emitter),this.onDidResetLocal=this._onDidResetLocal.event,this._onDidResetRemote=this._register(new L.Emitter),this.onDidResetRemote=this._onDidResetRemote.event,this.synchronizers=this._register(new A.MutableDisposable),this.updateStatus([]),this._lastSyncTime=this.storageService.getNumber(s,-1,void 0)}get status(){return this._status}get conflicts(){return this._conflicts}get lastSyncTime(){return this._lastSyncTime}async createSyncTask(a,h){this.checkEnablement();const p=(0,I.generateUuid)();try{const T=(0,u.createSyncHeaders)(p);h&&(T["Cache-Control"]="no-cache"),a=await this.userDataSyncStoreService.manifest(a,T)}catch(T){const N=u.UserDataSyncError.toUserDataSyncError(T);throw this.reportUserDataSyncError(N,p),N}const R=!1,M=this,O=this.getEnabledSynchronizers();let F;return{manifest:a,async run(){if(R)throw new Error("Can run a task only once");return F=(0,n.createCancelablePromise)(T=>M.sync(O,a,p,T)),F.finally(()=>F=void 0)},async stop(){if(F?.cancel(),M.status!=="idle")return M.stop(O)}}}async createManualSyncTask(){if(this.checkEnablement(),this.userDataSyncEnablementService.isEnabled())throw new u.UserDataSyncError("Cannot start manual sync when sync is enabled","LocalError");const a=(0,I.generateUuid)(),h=(0,u.createSyncHeaders)(a);let p;try{p=await this.userDataSyncStoreService.manifest(null,h)}catch(O){const F=u.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(F,a),F}await this.resetLocal();const R=this.getEnabledSynchronizers(),M=async()=>{await this.stop(R),await this.resetLocal()};return new t(a,p,h,R,M,this.configurationService,this.logService)}async sync(a,h,p,R){if(R.isCancellationRequested||!a.length)return;const M=new Date().getTime();this._syncErrors=[];try{this.logService.trace("Sync started."),this.status!=="hasConflicts"&&this.setStatus("syncing");const O=(0,u.createSyncHeaders)(p);for(const F of a){if(R.isCancellationRequested||!this.userDataSyncEnablementService.isResourceEnabled(F.resource))return;try{await F.sync(h,O)}catch(T){let N=!1;if(T instanceof u.UserDataSyncError)switch(T.code){case"TooLarge":T=new u.UserDataSyncError(T.message,T.code,F.resource),N=!0;break;case"RemoteTooManyRequests":case"TooManyRequestsAndRetryAfter":case"LocalTooManyRequests":case"Gone":case"UpgradeRequired":case"IncompatibleRemoteContent":case"IncompatibleLocalContent":N=!0;break}const W=u.UserDataSyncError.toUserDataSyncError(T);if(this.reportUserDataSyncError(W,p),N)throw W;this.logService.error(T),this.logService.error(`${F.resource}: ${(0,k.toErrorMessage)(T)}`),this._syncErrors.push([F.resource,W])}}this.logService.info(`Sync done. Took ${new Date().getTime()-M}ms`),this.updateLastSyncTime()}catch(O){const F=u.UserDataSyncError.toUserDataSyncError(O);throw this.reportUserDataSyncError(F,p),F}finally{this.updateStatus(a),this._onSyncErrors.fire(this._syncErrors)}}async stop(a){if(this.status!=="idle")for(const h of a)try{h.status!=="idle"&&await h.stop()}catch(p){this.logService.error(p)}}async replace(a){this.checkEnablement(),await this.performSynchronizerAction(async h=>{if(await h.replace(a))return!0})}async accept(a,h,p,R){this.checkEnablement(),await this.performSynchronizerAction(async M=>{if(M.resource===a)return await M.accept(h,p),R&&await M.apply(!1,(0,u.createSyncHeaders)((0,I.generateUuid)())),!0})}async resolveContent(a){return this.performSynchronizerAction(async h=>{const p=await h.resolveContent(a);if(p)return p})}async getRemoteSyncResourceHandles(a){return await this.performSynchronizerAction(async p=>{if(p.resource===a)return p.getRemoteSyncResourceHandles()})||[]}async getLocalSyncResourceHandles(a){return await this.performSynchronizerAction(async p=>{if(p.resource===a)return p.getLocalSyncResourceHandles()})||[]}async getAssociatedResources(a,h){return await this.performSynchronizerAction(async R=>{if(R.resource===a)return R.getAssociatedResources(h)})||[]}async getMachineId(a,h){return await this.performSynchronizerAction(async R=>{if(R.resource===a)return await R.getMachineId(h)||null})||void 0}async hasLocalData(){return!!await this.performSynchronizerAction(async h=>{if(h.resource!=="globalState"&&await h.hasLocalData())return!0})}async hasPreviouslySynced(){return!!await this.performSynchronizerAction(async h=>{if(await h.hasPreviouslySynced())return!0})}async reset(){this.checkEnablement(),await this.resetRemote(),await this.resetLocal()}async resetRemote(){this.checkEnablement();try{await this.userDataSyncStoreService.clear(),this.logService.info("Cleared data on server")}catch(a){this.logService.error(a)}this._onDidResetRemote.fire()}async resetLocal(){if(this.checkEnablement(),this.storageService.remove(s,-1),this.synchronizers.value){for(const a of this.synchronizers.value.enabled)try{await a.resetLocal()}catch(h){this.logService.error(`${a.resource}: ${(0,k.toErrorMessage)(h)}`),this.logService.error(h)}this.synchronizers.value=void 0}this._onDidResetLocal.fire(),this.logService.info("Did reset the local sync state.")}async performSynchronizerAction(a){const h=new A.DisposableStore;try{const p=this.synchronizers.value||h.add(this.instantiationService.createInstance(i,()=>{},()=>{},()=>{})),R=[...p.enabled,...p.disabled.map(M=>h.add(p.createSynchronizer(M)))];for(const M of R){const O=await a(M);if(!(0,P.isUndefined)(O))return O}return null}finally{h.dispose()}}setStatus(a){const h=this._status;this._status!==a&&(this._status=a,this._onDidChangeStatus.fire(a),h==="hasConflicts"&&this.updateLastSyncTime())}updateStatus(a){this.updateConflicts(a);const h=this.computeStatus(a);this.setStatus(h)}updateConflicts(a){const h=this.computeConflicts(a);(0,D.equals)(this._conflicts,h,([p,R],[M,O])=>p===p&&(0,D.equals)(R,O,(F,T)=>(0,b.isEqual)(F.previewResource,T.previewResource)))||(this._conflicts=this.computeConflicts(a),this._onDidChangeConflicts.fire(h))}computeConflicts(a){return a.filter(h=>h.status==="hasConflicts").map(h=>[h.resource,h.conflicts.map(o)])}computeStatus(a){return this.userDataSyncStoreManagementService.userDataSyncStore?a.some(h=>h.status==="hasConflicts")?"hasConflicts":a.some(h=>h.status==="syncing")?"syncing":"idle":"uninitialized"}updateLastSyncTime(){this.status==="idle"&&(this._lastSyncTime=new Date().getTime(),this.storageService.store(s,this._lastSyncTime,-1,1),this._onDidChangeLastSyncTime.fire(this._lastSyncTime))}reportUserDataSyncError(a,h){this.telemetryService.publicLog2("sync/error",{code:a.code,serverCode:a instanceof u.UserDataSyncStoreError?String(a.serverCode):void 0,url:a instanceof u.UserDataSyncStoreError?a.url:void 0,resource:a.resource,executionId:h,service:this.userDataSyncStoreManagementService.userDataSyncStore.url.toString()})}getEnabledSynchronizers(){return this.synchronizers.value||(this.synchronizers.value=this.instantiationService.createInstance(i,a=>this.updateStatus(a),a=>this.updateConflicts(a),a=>this._onDidChangeLocal.fire(a))),this.synchronizers.value.enabled}checkEnablement(){if(!this.userDataSyncStoreManagementService.userDataSyncStore)throw new Error("Not enabled")}};r=me([G(0,u.IUserDataSyncStoreService),G(1,u.IUserDataSyncStoreManagementService),G(2,v.IInstantiationService),G(3,E.IConfigurationService),G(4,u.IUserDataSyncLogService),G(5,f.ITelemetryService),G(6,y.IStorageService),G(7,u.IUserDataSyncEnablementService)],r),e.UserDataSyncService=r;class t extends A.Disposable{constructor(a,h,p,R,M,O,F){super();this.id=a,this.manifest=h,this.syncHeaders=p,this.synchronisers=R,this.onStop=M,this.configurationService=O,this.logService=F,this.synchronizingResources=[],this._onSynchronizeResources=this._register(new L.Emitter),this.onSynchronizeResources=this._onSynchronizeResources.event,this.isDisposed=!1}get status(){return this.synchronisers.some(a=>a.status==="hasConflicts")?"hasConflicts":this.synchronisers.some(a=>a.status==="syncing")?"syncing":"idle"}async preview(){try{if(this.isDisposed)throw new Error("Disposed");return this.previewsPromise||(this.previewsPromise=(0,n.createCancelablePromise)(a=>this.getPreviews(a))),this.previews||(this.previews=await this.previewsPromise),this.previews}catch(a){throw this.logService.error(a),a}}async accept(a,h){try{return await this.performAction(a,p=>p.accept(a,h))}catch(p){throw this.logService.error(p),p}}async merge(a){try{return a?await this.performAction(a,h=>h.merge(a)):await this.mergeAll()}catch(h){throw this.logService.error(h),h}}async discard(a){try{return await this.performAction(a,h=>h.discard(a))}catch(h){throw this.logService.error(h),h}}async discardConflicts(){try{if(!this.previews)throw new Error("Missing preview. Create preview and try again.");if(this.synchronizingResources.length)throw new Error("Cannot discard while synchronizing resources");const a=[];for(const[,h]of this.previews)for(const p of h.resourcePreviews)p.mergeState==="conflict"&&a.push(p.previewResource);for(const h of a)await this.discard(h);return this.previews}catch(a){throw this.logService.error(a),a}}async apply(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");const a=[];for(const[h,p]of this.previews){this.synchronizingResources.push([h,p.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const R=this.synchronisers.find(O=>O.resource===h);for(const O of p.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&await R.merge(O.previewResource);const M=await R.apply(!1,this.syncHeaders);M&&a.push(this.toSyncResourcePreview(R.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===h),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}catch(a){throw this.logService.error(a),a}}async pull(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(R=>R.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const p=this.synchronisers.find(R=>R.resource===a);for(const R of h.resourcePreviews)await p.accept(R.remoteResource);await p.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(R=>R[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async push(){try{if(!this.previews)throw new Error("You need to create preview before applying");if(this.synchronizingResources.length)throw new Error("Cannot pull while synchronizing resources");for(const[a,h]of this.previews){this.synchronizingResources.push([a,h.resourcePreviews.map(R=>R.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const p=this.synchronisers.find(R=>R.resource===a);for(const R of h.resourcePreviews)await p.accept(R.localResource);await p.apply(!0,this.syncHeaders),this.synchronizingResources.splice(this.synchronizingResources.findIndex(R=>R[0]===a),1),this._onSynchronizeResources.fire(this.synchronizingResources)}this.previews=[]}catch(a){throw this.logService.error(a),a}}async stop(){await this.onStop(),this.reset()}async performAction(a,h){if(!this.previews)throw new Error("Missing preview. Create preview and try again.");const p=this.previews.findIndex(([,V])=>V.resourcePreviews.some(({localResource:Y,previewResource:$,remoteResource:J})=>(0,b.isEqual)(a,Y)||(0,b.isEqual)(a,$)||(0,b.isEqual)(a,J)));if(p===-1)return this.previews;const[R,M]=this.previews[p],O=M.resourcePreviews.find(({localResource:V,remoteResource:Y,previewResource:$})=>(0,b.isEqual)(V,a)||(0,b.isEqual)(Y,a)||(0,b.isEqual)($,a));if(!O)return this.previews;let F=this.synchronizingResources.find(V=>V[0]===R);F||(F=[R,[]],this.synchronizingResources.push(F)),F[1].some(V=>(0,b.isEqual)(V,O.localResource))||(F[1].push(O.localResource),this._onSynchronizeResources.fire(this.synchronizingResources));const T=this.synchronisers.find(V=>V.resource===this.previews[p][0]),N=await h(T);N?this.previews.splice(p,1,this.toSyncResourcePreview(T.resource,N)):this.previews.splice(p,1);const W=this.synchronizingResources.findIndex(V=>V[0]===R);return this.synchronizingResources[W][1].splice(F[1].findIndex(V=>(0,b.isEqual)(V,O.localResource)),1),F[1].length||(this.synchronizingResources.splice(W,1),this._onSynchronizeResources.fire(this.synchronizingResources)),this.previews}async mergeAll(){if(!this.previews)throw new Error("You need to create preview before merging or applying");if(this.synchronizingResources.length)throw new Error("Cannot merge or apply while synchronizing resources");const a=[];for(const[h,p]of this.previews){this.synchronizingResources.push([h,p.resourcePreviews.map(O=>O.localResource)]),this._onSynchronizeResources.fire(this.synchronizingResources);const R=this.synchronisers.find(O=>O.resource===h);let M=p;for(const O of p.resourcePreviews)(O.localChange!==0||O.remoteChange!==0)&&O.mergeState==="preview"&&(M=await R.merge(O.previewResource));M&&a.push(this.toSyncResourcePreview(R.resource,M)),this.synchronizingResources.splice(this.synchronizingResources.findIndex(O=>O[0]===h),1),this._onSynchronizeResources.fire(this.synchronizingResources)}return this.previews=a,this.previews}async getPreviews(a){const h=[],p=await this.getUserDataSyncConfiguration();for(const R of this.synchronisers){if(a.isCancellationRequested)return[];const M=await R.preview(this.manifest,p,this.syncHeaders);M&&h.push(this.toSyncResourcePreview(R.resource,M))}return h}async getUserDataSyncConfiguration(){const a=this.configurationService.getValue(u.USER_DATA_SYNC_CONFIGURATION_SCOPE),h=this.synchronisers.find(p=>p instanceof g.SettingsSynchroniser);if(h){const p=await h.getRemoteUserDataSyncConfiguration(this.manifest);return{...a,...p}}return a}toSyncResourcePreview(a,h){return[a,{isLastSyncFromCurrentMachine:h.isLastSyncFromCurrentMachine,resourcePreviews:h.resourcePreviews.map(o)}]}reset(){this.previewsPromise&&(this.previewsPromise.cancel(),this.previewsPromise=void 0),this.previews=void 0,this.synchronizingResources=[]}dispose(){this.reset(),this.isDisposed=!0}}let i=class extends A.Disposable{constructor(a,h,p,R,M,O,F){super();this.onDidChangeStatus=a,this.onDidChangeConflicts=h,this.onDidChangeLocal=p,this.userDataSyncEnablementService=R,this.instantiationService=M,this.extensionGalleryService=O,this.logService=F,this._enabled=[],this._register(R.onDidChangeResourceEnablement(([T,N])=>this.onDidChangeResourceEnablement(T,N))),this._register((0,A.toDisposable)(()=>this._enabled.splice(0,this._enabled.length).forEach(([,,T])=>T.dispose())));for(const T of u.ALL_SYNC_RESOURCES)R.isResourceEnabled(T)&&this.registerSynchronizer(T)}get enabled(){return this._enabled.sort((a,h)=>a[1]-h[1]).map(([a])=>a)}get disabled(){return u.ALL_SYNC_RESOURCES.filter(a=>!this.userDataSyncEnablementService.isResourceEnabled(a))}onDidChangeResourceEnablement(a,h){h?this.registerSynchronizer(a):this.deRegisterSynchronizer(a)}registerSynchronizer(a){if(this._enabled.some(([M])=>M.resource===a))return;if(a==="extensions"&&!this.extensionGalleryService.isEnabled()){this.logService.info("Skipping extensions sync because gallery is not configured");return}const h=new A.DisposableStore,p=h.add(this.createSynchronizer(a));h.add(p.onDidChangeStatus(()=>this.onDidChangeStatus(this.enabled))),h.add(p.onDidChangeConflicts(()=>this.onDidChangeConflicts(this.enabled))),h.add(p.onDidChangeLocal(()=>this.onDidChangeLocal(a)));const R=this.getOrder(a);this._enabled.push([p,R,h])}deRegisterSynchronizer(a){const h=this._enabled.findIndex(([p])=>p.resource===a);if(h!==-1){const p=this._enabled.splice(h,1);for(const[R,,M]of p){if(R.status!=="idle"){const O=R.conflicts.length>0;R.stop(),O&&this.onDidChangeConflicts(this.enabled),this.onDidChangeStatus(this.enabled)}M.dispose()}}}createSynchronizer(a){switch(a){case"settings":return this.instantiationService.createInstance(g.SettingsSynchroniser);case"keybindings":return this.instantiationService.createInstance(m.KeybindingsSynchroniser);case"snippets":return this.instantiationService.createInstance(c.SnippetsSynchroniser);case"tasks":return this.instantiationService.createInstance(d.TasksSynchroniser);case"globalState":return this.instantiationService.createInstance(C.GlobalStateSynchroniser);case"extensions":return this.instantiationService.createInstance(S.ExtensionsSynchroniser)}}getOrder(a){switch(a){case"settings":return 0;case"keybindings":return 1;case"snippets":return 2;case"tasks":return 3;case"globalState":return 4;case"extensions":return 5}}};i=me([G(3,u.IUserDataSyncEnablementService),G(4,v.IInstantiationService),G(5,w.IExtensionGalleryService),G(6,u.IUserDataSyncLogService)],i);function o(l){return{baseResource:l.baseResource,localResource:l.localResource,previewResource:l.previewResource,remoteResource:l.remoteResource,acceptedResource:l.acceptedResource,localChange:l.localChange,remoteChange:l.remoteChange,mergeState:l.mergeState}}}),define(re[263],se([0,1,6,21,9,3,2,123,4,17,15,7,30,19,14,13,24,45,48,23,25]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequestsSession=e.UserDataSyncStoreService=e.UserDataSyncStoreClient=e.UserDataSyncStoreManagementService=e.AbstractUserDataSyncStoreManagementService=void 0;const u="sync.previous.store",s="sync.donot-make-requests-until",r="sync.user-session-id",t="sync.machine-session-id",i=100,o=1e3*60*5;let l=class extends A.Disposable{constructor(O,F,T){super();this.productService=O,this.configurationService=F,this.storageService=T,this._onDidChangeUserDataSyncStore=this._register(new L.Emitter),this.onDidChangeUserDataSyncStore=this._onDidChangeUserDataSyncStore.event,this.updateUserDataSyncStore(),this._register(L.Event.filter(T.onDidChangeValue,N=>N.key===d.SYNC_SERVICE_URL_TYPE&&N.scope===-1&&this.userDataSyncStoreType!==this.userDataSyncStore?.type)(()=>this.updateUserDataSyncStore()))}get userDataSyncStore(){return this._userDataSyncStore}get userDataSyncStoreType(){return this.storageService.get(d.SYNC_SERVICE_URL_TYPE,-1)}set userDataSyncStoreType(O){this.storageService.store(d.SYNC_SERVICE_URL_TYPE,O,-1,P.isWeb?0:1)}updateUserDataSyncStore(){this._userDataSyncStore=this.toUserDataSyncStore(this.productService[d.CONFIGURATION_SYNC_STORE_KEY],this.configurationService.getValue(d.CONFIGURATION_SYNC_STORE_KEY)),this._onDidChangeUserDataSyncStore.fire()}toUserDataSyncStore(O,F){O=P.isWeb&&O?.web?{...O,...O.web}:O;const T={...O||{},...F||{}};if(T&&(0,E.isString)(T.url)&&(0,E.isObject)(T.authenticationProviders)&&Object.keys(T.authenticationProviders).every(N=>Array.isArray(T.authenticationProviders[N].scopes))){const N=T,W=!!N.canSwitch&&!F?.url,V=N.url===N.insidersUrl?"insiders":"stable",Y=(W?this.userDataSyncStoreType:void 0)||V,$=F?.url||(Y==="insiders"?N.insidersUrl:Y==="stable"?N.stableUrl:N.url);return{url:w.URI.parse($),type:Y,defaultType:V,defaultUrl:w.URI.parse(N.url),stableUrl:w.URI.parse(N.stableUrl),insidersUrl:w.URI.parse(N.insidersUrl),canSwitch:W,authenticationProviders:Object.keys(N.authenticationProviders).reduce((J,H)=>(J.push({id:H,scopes:N.authenticationProviders[H].scopes}),J),[])}}}};l=me([G(0,C.IProductService),G(1,y.IConfigurationService),G(2,c.IStorageService)],l),e.AbstractUserDataSyncStoreManagementService=l;let a=class extends l{constructor(O,F,T){super(O,F,T);const N=this.storageService.get(u,-1);N&&(this.previousConfigurationSyncStore=JSON.parse(N));const W=this.productService[d.CONFIGURATION_SYNC_STORE_KEY];W?this.storageService.store(u,JSON.stringify(W),-1,1):this.storageService.remove(u,-1)}async switch(O){O!==this.userDataSyncStoreType&&(this.userDataSyncStoreType=O,this.updateUserDataSyncStore())}async getPreviousUserDataSyncStore(){return this.toUserDataSyncStore(this.previousConfigurationSyncStore)}};a=me([G(0,C.IProductService),G(1,y.IConfigurationService),G(2,c.IStorageService)],a),e.UserDataSyncStoreManagementService=a;let h=class extends A.Disposable{constructor(O,F,T,N,W,V,Y){super();this.requestService=T,this.logService=N,this.storageService=Y,this._onTokenFailed=this._register(new L.Emitter),this.onTokenFailed=this._onTokenFailed.event,this._onTokenSucceed=this._register(new L.Emitter),this.onTokenSucceed=this._onTokenSucceed.event,this._donotMakeRequestsUntil=void 0,this._onDidChangeDonotMakeRequestsUntil=this._register(new L.Emitter),this.onDidChangeDonotMakeRequestsUntil=this._onDidChangeDonotMakeRequestsUntil.event,this.resetDonotMakeRequestsUntilPromise=void 0,this.updateUserDataSyncStoreUrl(O),this.commonHeadersPromise=(0,g.getServiceMachineId)(W,V,Y).then($=>{const J={"X-Client-Name":`${F.applicationName}${P.isWeb?"-web":""}`,"X-Client-Version":F.version};return F.commit&&(J["X-Client-Commit"]=F.commit),J}),this.session=new R(i,o,this.requestService,this.logService),this.initDonotMakeRequestsUntil(),this._register((0,A.toDisposable)(()=>{this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0)}))}get donotMakeRequestsUntil(){return this._donotMakeRequestsUntil}setAuthToken(O,F){this.authToken={token:O,type:F}}updateUserDataSyncStoreUrl(O){this.userDataSyncStoreUrl=O?(0,I.joinPath)(O,"v1"):void 0}initDonotMakeRequestsUntil(){const O=this.storageService.getNumber(s,-1);O&&Date.now()<O&&this.setDonotMakeRequestsUntil(new Date(O))}setDonotMakeRequestsUntil(O){this._donotMakeRequestsUntil?.getTime()!==O?.getTime()&&(this._donotMakeRequestsUntil=O,this.resetDonotMakeRequestsUntilPromise&&(this.resetDonotMakeRequestsUntilPromise.cancel(),this.resetDonotMakeRequestsUntilPromise=void 0),this._donotMakeRequestsUntil?(this.storageService.store(s,this._donotMakeRequestsUntil.getTime(),-1,1),this.resetDonotMakeRequestsUntilPromise=(0,D.createCancelablePromise)(F=>(0,D.timeout)(this._donotMakeRequestsUntil.getTime()-Date.now(),F).then(()=>this.setDonotMakeRequestsUntil(void 0))),this.resetDonotMakeRequestsUntilPromise.then(null,F=>null)):this.storageService.remove(s,-1),this._onDidChangeDonotMakeRequestsUntil.fire())}async getAllRefs(O){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const F=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O),T={},N=await this.request(F.toString(),{type:"GET",headers:T},[],n.CancellationToken.None);return(await(0,m.asJson)(N)||[]).map(({url:V,created:Y})=>({ref:(0,I.relativePath)(F,F.with({path:V})),created:Y*1e3}))}async resolveContent(O,F,T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString();T={...T},T["Cache-Control"]="no-cache";const W=await this.request(N,{type:"GET",headers:T},[],n.CancellationToken.None);return await(0,m.asTextOrError)(W)}async delete(O,F){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=F!==null?(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,F).toString():(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString(),N={};await this.request(T,{type:"DELETE",headers:N},[],n.CancellationToken.None)}async read(O,F,T={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const N=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O,"latest").toString();T={...T},T["Cache-Control"]="no-cache",F&&(T["If-None-Match"]=F.ref);const W=await this.request(N,{type:"GET",headers:T},[304],n.CancellationToken.None);let V=null;if(W.res.statusCode===304&&(V=F),V===null){const Y=W.res.headers.etag;if(!Y)throw new d.UserDataSyncStoreError("Server did not return the ref",N,"NoRef",W.res.statusCode,W.res.headers[d.HEADER_OPERATION_ID]);const $=await(0,m.asTextOrError)(W);if(!$&&W.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",N,"EmptyResponse",W.res.statusCode,W.res.headers[d.HEADER_OPERATION_ID]);V={ref:Y,content:$}}return V}async write(O,F,T,N={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const W=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource",O).toString();N={...N},N["Content-Type"]=b.Mimes.text,T&&(N["If-Match"]=T);const V=await this.request(W,{type:"POST",data:F,headers:N},[],n.CancellationToken.None),Y=V.res.headers.etag;if(!Y)throw new d.UserDataSyncStoreError("Server did not return the ref",W,"NoRef",V.res.statusCode,V.res.headers[d.HEADER_OPERATION_ID]);return Y}async manifest(O,F={}){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const T=(0,I.joinPath)(this.userDataSyncStoreUrl,"manifest").toString();F={...F},F["Content-Type"]="application/json",O&&(F["If-None-Match"]=O.ref);const N=await this.request(T,{type:"GET",headers:F},[304],n.CancellationToken.None);let W=null;if(N.res.statusCode===304&&(W=O),!W){const Y=N.res.headers.etag;if(!Y)throw new d.UserDataSyncStoreError("Server did not return the ref",T,"NoRef",N.res.statusCode,N.res.headers[d.HEADER_OPERATION_ID]);const $=await(0,m.asTextOrError)(N);if(!$&&N.res.statusCode===304)throw new d.UserDataSyncStoreError("Empty response",T,"EmptyResponse",N.res.statusCode,N.res.headers[d.HEADER_OPERATION_ID]);$&&(W={...JSON.parse($),ref:Y})}const V=this.storageService.get(r,-1);return V&&W&&V!==W.session&&this.clearSession(),W===null&&V&&this.clearSession(),W&&this.storageService.store(r,W.session,-1,1),W}async clear(){if(!this.userDataSyncStoreUrl)throw new Error("No settings sync store url configured.");const O=(0,I.joinPath)(this.userDataSyncStoreUrl,"resource").toString(),F={"Content-Type":b.Mimes.text};await this.request(O,{type:"DELETE",headers:F},[],n.CancellationToken.None),this.clearSession()}clearSession(){this.storageService.remove(r,-1),this.storageService.remove(t,-1)}async request(O,F,T,N){if(!this.authToken)throw new d.UserDataSyncStoreError("No Auth Token Available",O,"Unauthorized",void 0,void 0);if(this._donotMakeRequestsUntil&&Date.now()<this._donotMakeRequestsUntil.getTime())throw new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",void 0,void 0);this.setDonotMakeRequestsUntil(void 0);const W=await this.commonHeadersPromise;F.headers={...F.headers||{},...W,"X-Account-Type":this.authToken.type,authorization:`Bearer ${this.authToken.token}`},this.addSessionHeaders(F.headers),this.logService.trace("Sending request to server",{url:O,type:F.type,headers:{...F.headers,authorization:void 0}});let V;try{V=await this.session.request(O,F,N)}catch(H){if(!(H instanceof d.UserDataSyncStoreError)){let B="RequestFailed";const K=(0,k.getErrorMessage)(H).toLowerCase();K.includes("xhr timeout")?B="RequestTimeout":K.includes("protocol")&&K.includes("not supported")?B="RequestProtocolNotSupported":K.includes("request path contains unescaped characters")?B="RequestPathNotEscaped":K.includes("headers must be an object")?B="RequestHeadersNotObject":(0,k.isCancellationError)(H)&&(B="RequestCanceled"),H=new d.UserDataSyncStoreError(`Connection refused for the request '${O}'.`,O,B,void 0,void 0)}throw this.logService.info("Request failed",O),H}const Y=V.res.headers[d.HEADER_OPERATION_ID],$={url:O,status:V.res.statusCode,"execution-id":F.headers[d.HEADER_EXECUTION_ID],"operation-id":Y},J=(0,m.isSuccess)(V)||V.res.statusCode&&T.indexOf(V.res.statusCode)!==-1;if(J?this.logService.trace("Request succeeded",$):this.logService.info("Request failed",$),V.res.statusCode===401)throw this.authToken=void 0,this._onTokenFailed.fire(),new d.UserDataSyncStoreError(`Request '${O}' failed because of Unauthorized (401).`,O,"Unauthorized",V.res.statusCode,Y);if(this._onTokenSucceed.fire(),V.res.statusCode===409)throw new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Conflict (409). There is new data for this resource. Make the request again with latest data.`,O,"Conflict",V.res.statusCode,Y);if(V.res.statusCode===410)throw new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because the requested resource is not longer available (410).`,O,"Gone",V.res.statusCode,Y);if(V.res.statusCode===412)throw new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because of Precondition Failed (412). There is new data for this resource. Make the request again with latest data.`,O,"PreconditionFailed",V.res.statusCode,Y);if(V.res.statusCode===413)throw new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too large payload (413).`,O,"TooLarge",V.res.statusCode,Y);if(V.res.statusCode===426)throw new d.UserDataSyncStoreError(`${F.type} request '${O}' failed with status Upgrade Required (426). Please upgrade the client and try again.`,O,"UpgradeRequired",V.res.statusCode,Y);if(V.res.statusCode===429){const H=V.res.headers["retry-after"];throw H?(this.setDonotMakeRequestsUntil(new Date(Date.now()+parseInt(H)*1e3)),new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"TooManyRequestsAndRetryAfter",V.res.statusCode,Y)):new d.UserDataSyncStoreError(`${F.type} request '${O}' failed because of too many requests (429).`,O,"RemoteTooManyRequests",V.res.statusCode,Y)}if(!J)throw new d.UserDataSyncStoreError("Server returned "+V.res.statusCode,O,"Unknown",V.res.statusCode,Y);return V}addSessionHeaders(O){let F=this.storageService.get(t,-1);F===void 0&&(F=(0,v.generateUuid)(),this.storageService.store(t,F,-1,1)),O["X-Machine-Session-Id"]=F;const T=this.storageService.get(r,-1);T!==void 0&&(O["X-User-Session-Id"]=T)}};h=me([G(1,C.IProductService),G(2,m.IRequestService),G(3,d.IUserDataSyncLogService),G(4,f.IEnvironmentService),G(5,S.IFileService),G(6,c.IStorageService)],h),e.UserDataSyncStoreClient=h;let p=class extends h{constructor(O,F,T,N,W,V,Y){super(O.userDataSyncStore?.url,F,T,N,W,V,Y);this._register(O.onDidChangeUserDataSyncStore(()=>this.updateUserDataSyncStoreUrl(O.userDataSyncStore?.url)))}};p=me([G(0,d.IUserDataSyncStoreManagementService),G(1,C.IProductService),G(2,m.IRequestService),G(3,d.IUserDataSyncLogService),G(4,f.IEnvironmentService),G(5,S.IFileService),G(6,c.IStorageService)],p),e.UserDataSyncStoreService=p;class R{constructor(O,F,T,N){this.limit=O,this.interval=F,this.requestService=T,this.logService=N,this.requests=[],this.startTime=void 0}request(O,F,T){if(this.isExpired()&&this.reset(),F.url=O,this.requests.length>=this.limit)throw this.logService.info("Too many requests",...this.requests),new d.UserDataSyncStoreError(`Too many requests. Only ${this.limit} requests allowed in ${this.interval/(1e3*60)} minutes.`,O,"LocalTooManyRequests",void 0,void 0);return this.startTime=this.startTime||new Date,this.requests.push(O),this.requestService.request(F,T)}isExpired(){return this.startTime!==void 0&&new Date().getTime()-this.startTime.getTime()>this.interval}reset(){this.requests=[],this.startTime=void 0}}e.RequestsSession=R}),define(re[264],se([0,1,3,67,24,23,22,261,25,70,73]),function(X,e,D,n,k,L,A,b,P,I,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.UserDataAutoSyncService=void 0;let w=class extends b.UserDataAutoSyncService{constructor(y,f,S,C,m,g,c,d,u,s,r){super(y,f,S,C,m,c,d,u,s,r);this._register(D.Event.debounce(D.Event.any(D.Event.map(g.onDidFocusWindow,()=>"windowFocus"),D.Event.map(g.onDidOpenWindow,()=>"windowOpen")),(t,i)=>t?[...t,i]:[i],1e3)(t=>this.triggerSync(t,!0,!1)))}};w=me([G(0,k.IProductService),G(1,P.IUserDataSyncStoreManagementService),G(2,P.IUserDataSyncStoreService),G(3,P.IUserDataSyncEnablementService),G(4,P.IUserDataSyncService),G(5,n.INativeHostService),G(6,P.IUserDataSyncLogService),G(7,I.IUserDataSyncAccountService),G(8,A.ITelemetryService),G(9,E.IUserDataSyncMachinesService),G(10,L.IStorageService)],w),e.UserDataAutoSyncService=w}),define(re[108],se([0,1,53,6,10,15,27,135,272,273]),function(X,e,D,n,k,L,A,b,P,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.buffer=e.extract=e.zip=e.ExtractError=void 0;class E extends Error{constructor(s,r){let t=r.message;switch(s){case"CorruptZip":t=`Corrupt ZIP: ${t}`;break}super(t);this.type=s,this.cause=r}}e.ExtractError=E;function w(u){const s=u.externalFileAttributes>>16||33188;return[448,56,7].map(r=>s&r).reduce((r,t)=>r+t,s&61440)}function v(u){if(u instanceof E)return u;let s;return/end of central directory record signature not found/.test(u.message)&&(s="CorruptZip"),new E(s,u)}function y(u,s,r,t,i,o){const l=k.dirname(s),a=k.join(t,l);if(!a.startsWith(t))return Promise.reject(new Error(b.localize(0,null,s)));const h=k.join(t,s);let p;return o.onCancellationRequested(()=>{p?.destroy()}),Promise.resolve(A.Promises.mkdir(a,{recursive:!0})).then(()=>new Promise((R,M)=>{if(!o.isCancellationRequested)try{p=(0,D.createWriteStream)(h,{mode:r}),p.once("close",()=>R()),p.once("error",M),u.once("error",M),u.pipe(p)}catch(O){M(O)}}))}function f(u,s,r,t){let i=(0,n.createCancelablePromise)(()=>Promise.resolve()),o=0;return t.onCancellationRequested(()=>{i.cancel(),u.close()}),new Promise((l,a)=>{const h=new n.Sequencer,p=R=>{R.isCancellationRequested||(o++,u.readEntry())};u.once("error",a),u.once("close",()=>i.then(()=>{t.isCancellationRequested||u.entryCount===o?l():a(new E("Incomplete",new Error(b.localize(1,null,o,u.entryCount))))},a)),u.readEntry(),u.on("entry",R=>{if(t.isCancellationRequested)return;if(!r.sourcePathRegex.test(R.fileName)){p(t);return}const M=R.fileName.replace(r.sourcePathRegex,"");if(/\/$/.test(M)){const T=k.join(s,M);i=(0,n.createCancelablePromise)(N=>A.Promises.mkdir(T,{recursive:!0}).then(()=>p(N)).then(void 0,a));return}const O=C(u,R),F=w(R);i=(0,n.createCancelablePromise)(T=>h.queue(()=>O.then(N=>y(N,M,F,s,r,T).then(()=>p(T)))).then(null,a))})})}function S(u,s=!1){return new Promise((r,t)=>{(0,P.open)(u,s?{lazyEntries:!0}:void 0,(i,o)=>{i?t(v(i)):r((0,L.assertIsDefined)(o))})})}function C(u,s){return new Promise((r,t)=>{u.openReadStream(s,(i,o)=>{i?t(v(i)):r((0,L.assertIsDefined)(o))})})}function m(u,s){return new Promise((r,t)=>{const i=new I.ZipFile;s.forEach(l=>{l.contents?i.addBuffer(typeof l.contents=="string"?Buffer.from(l.contents,"utf8"):l.contents,l.path):l.localPath&&i.addFile(l.localPath,l.path)}),i.end();const o=(0,D.createWriteStream)(u);i.outputStream.pipe(o),i.outputStream.once("error",t),o.once("error",t),o.once("finish",()=>r(u))})}e.zip=m;function g(u,s,r={},t){const i=new RegExp(r.sourcePath?`^${r.sourcePath}`:"");let o=S(u,!0);return r.overwrite&&(o=o.then(l=>A.Promises.rm(s).then(()=>l))),o.then(l=>f(l,s,{sourcePathRegex:i},t))}e.extract=g;function c(u,s){return S(u).then(r=>new Promise((t,i)=>{r.on("entry",o=>{o.fileName===s&&C(r,o).then(l=>t(l),l=>i(l))}),r.once("close",()=>i(new Error(b.localize(2,null,s))))}))}function d(u,s){return c(u,s).then(r=>new Promise((t,i)=>{const o=[];r.once("error",i),r.on("data",l=>o.push(l)),r.on("end",()=>t(Buffer.concat(o)))}))}e.buffer=d}),define(re[265],se([0,1,108,144]),function(X,e,D,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getManifest=void 0;function k(L){return(0,D.buffer)(L,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,n.localize)(0,null))}})}e.getManifest=k}),define(re[109],se([0,1,6,38,9,2,20,10,4,17,55,15,7,30,27,108,143,90,14,245,28,32,44,71,199,247,265,200,231,43,65,13,5,8,24,22,33,29]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u,s,r,t,i,o,l,a,h,p,R,M,O,F,T,N,W){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionManagementService=e.INativeServerExtensionManagementService=void 0,e.INativeServerExtensionManagementService=(0,M.refineServiceDecorator)(d.IServerExtensionManagementService);let V=class extends c.AbstractExtensionManagementService{constructor(z,x,_,U,q,j,Z,oe,Q,te,ne,ue){super(z,x,_,te,ue);this.extensionsScannerService=q,this.extensionsProfileScannerService=j,this.downloadService=Z,this.fileService=Q,this.installGalleryExtensionsTasks=new Map;const he=this._register(oe.createInstance(i.ExtensionsLifecycle));this.extensionsScanner=this._register(oe.createInstance(Y,we=>he.postUninstall(we))),this.manifestCache=this._register(new l.ExtensionsManifestCache(U,this)),this.extensionsDownloader=this._register(oe.createInstance(t.ExtensionsDownloader));const pe=this._register(new a.ExtensionsWatcher(this,Q,U,_,ne));this._register(pe.onDidChangeExtensionsByAnotherSource(({added:we,removed:Ce})=>{we.length&&this._onDidInstallExtensions.fire(we.map(Pe=>({identifier:Pe.identifier,operation:1,local:Pe}))),Ce.forEach(Pe=>this._onDidUninstallExtension.fire({identifier:Pe}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,u.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(z){this.logService.trace("ExtensionManagementService#zip",z.identifier.id);const x=await this.collectFiles(z),_=await(0,S.zip)((0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)()).fsPath,x);return v.URI.file(_)}async unzip(z){return this.logService.trace("ExtensionManagementService#unzip",z.toString()),(await this.install(z)).identifier}async getManifest(z){const{location:x,cleanup:_}=await this.downloadVsix(z),U=b.resolve(x.fsPath);try{return await(0,o.getManifest)(U)}finally{await _()}}getInstalled(z,x){return this.extensionsScanner.scanExtensions(z??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(z,x={}){this.logService.trace("ExtensionManagementService#install",z.toString());const{location:_,cleanup:U}=await this.downloadVsix(z);try{const q=await(0,o.getManifest)(b.resolve(_.fsPath));if(q.engines&&q.engines.vscode&&!(0,p.isEngineValid)(q.engines.vscode,this.productService.version,this.productService.date))throw new Error(C.localize(0,null,(0,u.getGalleryExtensionId)(q.publisher,q.name),this.productService.version));return await this.installExtension(q,_,x)}finally{await U()}}getMetadata(z){return this.extensionsScannerService.scanMetadata(z.location)}async updateMetadata(z,x){this.logService.trace("ExtensionManagementService#updateMetadata",z.identifier.id);const _={...x};return x.isPreReleaseVersion&&(_.preRelease=!0),z=await this.extensionsScanner.updateMetadata(z,_),this.manifestCache.invalidate(),z}async updateExtensionScope(z,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",z.identifier.id),z=await this.extensionsScanner.updateMetadata(z,{isMachineScoped:x}),this.manifestCache.invalidate(),z}removeUninstalledExtensions(z){return this.extensionsScanner.cleanUp(z)}async downloadVsix(z){if(z.scheme===A.Schemas.file)return{location:z,async cleanup(){}};this.logService.trace("Downloading extension from",z.toString());const x=(0,I.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,y.generateUuid)());return await this.downloadService.download(z,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(U){this.logService.error(U)}}}}doCreateInstallExtensionTask(z,x,_){let U;if(v.URI.isUri(x))U=new H(z,x,_,this.galleryService,this.extensionsScanner,this.logService);else{const q=u.ExtensionKey.create(x).toString();U=this.installGalleryExtensionsTasks.get(q),U||(this.installGalleryExtensionsTasks.set(q,U=new J(z,x,_,this.extensionsDownloader,this.extensionsScanner,this.logService)),U.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(q)))}return _.profileLocation?new B(U,_.profileLocation,this.extensionsProfileScannerService):U}doCreateUninstallExtensionTask(z,x){return x.profileLocation?new ie(z,x.profileLocation,this.extensionsProfileScannerService):new K(z,x,this.extensionsScanner)}async collectFiles(z){const x=async U=>{let q=await f.Promises.readdir(U);q=q.map(oe=>b.join(U,oe));const j=await Promise.all(q.map(oe=>f.Promises.stat(oe)));let Z=Promise.resolve([]);return j.forEach((oe,Q)=>{const te=q[Q];oe.isFile()&&(Z=Z.then(ne=>[...ne,te])),oe.isDirectory()&&(Z=Z.then(ne=>x(te).then(ue=>[...ne,...ue])))}),Z};return(await x(z.location.fsPath)).map(U=>({path:`extension/${b.relative(z.location.fsPath,U)}`,localPath:U}))}};V=me([G(0,d.IExtensionGalleryService),G(1,T.ITelemetryService),G(2,O.ILogService),G(3,g.INativeEnvironmentService),G(4,r.IExtensionsScannerService),G(5,s.IExtensionsProfileScannerService),G(6,m.IDownloadService),G(7,M.IInstantiationService),G(8,R.IFileService),G(9,F.IProductService),G(10,N.IUriIdentityService),G(11,W.IUserDataProfilesService)],V),e.ExtensionManagementService=V;let Y=class extends L.Disposable{constructor(z,x,_,U){super();this.beforeRemovingExtension=z,this.fileService=x,this.extensionsScannerService=_,this.logService=U,this.uninstalledPath=(0,I.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new D.Queue}async cleanUp(z){await this.removeUninstalledExtensions(),z&&await this.removeOutdatedExtensions()}async scanExtensions(z,x){const _={includeInvalid:!0,profileLocation:x};let U=[];return z===null||z===0?U.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},_)):z===1&&U.push(...await this.extensionsScannerService.scanUserExtensions(_)),U=z!==null?U.filter(q=>q.type===z):U,Promise.all(U.map(q=>this.toLocalExtension(q)))}async scanUserExtensions(z){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!z,includeInvalid:!0});return Promise.all(x.map(_=>this.toLocalExtension(_)))}async extractUserExtension(z,x,_,U){const q=z.toString(),j=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,y.generateUuid)()}`),Z=b.join(this.extensionsScannerService.userExtensionsLocation.fsPath,q);try{await f.Promises.rm(Z)}catch{throw new d.ExtensionManagementError(C.localize(1,null,Z,z.id),d.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(z,x,j,U),_={..._,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(v.URI.file(j),_);try{await this.rename(z,j,Z,Date.now()+2*60*1e3),this.logService.info("Renamed to",Z)}catch(oe){try{await f.Promises.rm(j)}catch{}if(oe.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",z.id);else throw this.logService.info(`Rename failed because of ${(0,k.getErrorMessage)(oe)}. Deleted from extracted location`,j),oe}return this.scanLocalExtension(v.URI.file(Z),1)}async updateMetadata(z,x){return await this.extensionsScannerService.updateMetadata(z.location,x),this.scanLocalExtension(z.location,z.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...z){const x=z.map(_=>u.ExtensionKey.create(_));await this.withUninstalledExtensions(_=>{x.forEach(U=>_[U.toString()]=!0)})}async setInstalled(z){await this.withUninstalledExtensions(U=>delete U[z.toString()]);const _=(await this.scanUserExtensions(!0)).find(U=>u.ExtensionKey.create(U).equals(z))||null;return _?this.updateMetadata(_,{installedTimestamp:Date.now()}):null}async removeExtension(z,x){this.logService.trace(`Deleting ${x} extension from disk`,z.identifier.id,z.location.fsPath),await f.Promises.rm(z.location.fsPath),this.logService.info("Deleted from disk",z.identifier.id,z.location.fsPath)}async removeUninstalledExtension(z){await this.removeExtension(z,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[u.ExtensionKey.create(z).toString()])}async withUninstalledExtensions(z){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(U){if(U.code!=="ENOENT")throw U}let _={};if(x)try{_=JSON.parse(x)}catch{}return z&&(z(_),Object.keys(_).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(_)):await f.Promises.rm(this.uninstalledPath)),_})}async extractAtLocation(z,x,_,U){this.logService.trace(`Started extracting the extension from ${x} to ${_}`);try{await f.Promises.rm(_)}catch(q){throw new d.ExtensionManagementError(this.joinErrors(q).message,d.ExtensionManagementErrorCode.Delete)}try{await(0,S.extract)(x,_,{sourcePath:"extension",overwrite:!0},U),this.logService.info(`Extracted extension to ${_}:`,z.id)}catch(q){try{await f.Promises.rm(_)}catch{}let j=d.ExtensionManagementErrorCode.Extract;throw q instanceof S.ExtractError&&(q.type==="CorruptZip"?j=d.ExtensionManagementErrorCode.CorruptZip:q.type==="Incomplete"&&(j=d.ExtensionManagementErrorCode.IncompleteZip)),new d.ExtensionManagementError(q.message,j)}}async rename(z,x,_,U){try{await f.Promises.rename(x,_)}catch(q){if(P.isWindows&&q&&q.code==="EPERM"&&Date.now()<U)return this.logService.info(`Failed renaming ${x} to ${_} with 'EPERM' error. Trying again...`,z.id),this.rename(z,x,_,U);throw new d.ExtensionManagementError(q.message||C.localize(2,null,x,_),q.code||d.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(z,x){const _=await this.extensionsScannerService.scanExistingExtension(z,x,{includeInvalid:!0});if(_)return this.toLocalExtension(_);throw new Error(C.localize(3,null,z.path))}async toLocalExtension(z){const x=await this.fileService.resolve(z.location);let _,U;return x.children&&(_=x.children.find(({name:q})=>/^readme(\.txt|\.md|)$/i.test(q))?.resource,U=x.children.find(({name:q})=>/^changelog(\.txt|\.md|)$/i.test(q))?.resource),{identifier:z.identifier,type:z.type,isBuiltin:z.isBuiltin||!!z.metadata?.isBuiltin,location:z.location,manifest:z.manifest,targetPlatform:z.targetPlatform,validations:z.validations,isValid:z.isValid,readmeUrl:_,changelogUrl:U,publisherDisplayName:z.metadata?.publisherDisplayName||null,publisherId:z.metadata?.publisherId||null,isApplicationScoped:!!z.metadata?.isApplicationScoped,isMachineScoped:!!z.metadata?.isMachineScoped,isPreReleaseVersion:!!z.metadata?.isPreReleaseVersion,preRelease:!!z.metadata?.preRelease,installedTimestamp:z.metadata?.installedTimestamp,updated:!!z.metadata?.updated}}async removeUninstalledExtensions(){const z=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=new Set;for(const j of x)z[u.ExtensionKey.create(j).toString()]||_.add(j.identifier.id.toLowerCase());const U=(0,u.groupByExtension)(x,j=>j.identifier);await D.Promises.settled(U.map(async j=>{const Z=j.sort((oe,Q)=>E.rcompare(oe.manifest.version,Q.manifest.version))[0];_.has(Z.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(Z))}));const q=x.filter(j=>z[u.ExtensionKey.create(j).toString()]);await D.Promises.settled(q.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const z=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),_=[],U=await this.extensionsScannerService.getTargetPlatform(),q=(0,u.groupByExtension)(x,j=>j.identifier);for(const j of q)if(j.length>1&&_.push(...j.sort((Z,oe)=>{const Q=E.rcompare(Z.manifest.version,oe.manifest.version);return Q!==0?Q:Z.targetPlatform===U?-1:1}).slice(1)),j[0].type===0){const Z=z.find(oe=>(0,u.areSameExtensions)(oe.identifier,j[0].identifier));(!Z||E.gte(Z.manifest.version,j[0].manifest.version))&&_.push(j[0])}await D.Promises.settled(_.map(j=>this.removeExtension(j,"outdated")))}joinErrors(z){const x=Array.isArray(z)?z:[z];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((_,U)=>new Error(`${_.message}${_.message?",":""}${U instanceof Error?U.message:U}`),new Error(""))}};Y=me([G(1,R.IFileService),G(2,r.IExtensionsScannerService),G(3,O.ILogService)],Y);class $ extends c.AbstractExtensionTask{constructor(z,x,_,U,q){super();this.identifier=z,this.source=x,this.options=_,this.extensionsScanner=U,this.logService=q,this._operation=2}get operation(){return(0,w.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(z,x){try{const _=await this.unsetUninstalledAndGetLocal(z.key);if(_)return z.metadata?this.extensionsScanner.updateMetadata(_,z.metadata):_}catch{throw P.isMacintosh?new d.ExtensionManagementError(C.localize(4,null),d.ExtensionManagementErrorCode.Internal):new d.ExtensionManagementError(C.localize(5,null),d.ExtensionManagementErrorCode.Internal)}return this.extract(z,x)}async unsetUninstalledAndGetLocal(z){if(!await this.isUninstalled(z))return null;this.logService.trace("Removing the extension from uninstalled list:",z.id);const _=await this.extensionsScanner.setInstalled(z);return this.logService.info("Removed the extension from uninstalled list:",z.id),_}async isUninstalled(z){return!!(await this.extensionsScanner.getUninstalledExtensions())[z.toString()]}async extract({zipPath:z,key:x,metadata:_},U){const q=await this.extensionsScanner.extractUserExtension(x,z,_,U);return this.logService.info("Extracting completed.",x.id),q}}class J extends ${constructor(z,x,_,U,q,j){super(x.identifier,x,_,q,j);this.manifest=z,this.gallery=x,this.extensionsDownloader=U}async doRun(z){const _=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,u.areSameExtensions)(j.identifier,this.gallery.identifier));_&&(this._operation=3);const U={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,h.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||_?.isMachineScoped,isBuiltin:this.options.isBuiltin||_?.isBuiltin,isSystem:_?.type===0?!0:void 0,updated:!!_,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,w.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:_?.preRelease)};if(_?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(_,U),metadata:U};const q=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:q,key:u.ExtensionKey.create(this.gallery),metadata:U},z);return _&&!this.options.profileLocation&&(_.targetPlatform!==j.targetPlatform||E.neq(_.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(_),{local:j,metadata:U}}catch(j){throw await this.deleteDownloadedVSIX(q),j}}async deleteDownloadedVSIX(z){try{await this.extensionsDownloader.delete(v.URI.file(z))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",z.toString(),(0,k.getErrorMessage)(x))}}async downloadExtension(z,x){let _;try{this.logService.trace("Started downloading extension:",z.identifier.id),_=(await this.extensionsDownloader.downloadExtension(z,x)).fsPath,this.logService.info("Downloaded extension:",z.identifier.id,_)}catch(U){throw new d.ExtensionManagementError((0,c.joinErrors)(U).message,d.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(_),_}catch(U){throw await this.deleteDownloadedVSIX(_),new d.ExtensionManagementError((0,c.joinErrors)(U).message,d.ExtensionManagementErrorCode.Invalid)}}}class H extends ${constructor(z,x,_,U,q,j){super({id:(0,u.getGalleryExtensionId)(z.publisher,z.name)},x,_,q,j);this.manifest=z,this.location=x,this.galleryService=U}async doRun(z){const x=new u.ExtensionKey(this.identifier,this.manifest.version),U=(await this.extensionsScanner.scanExtensions(1,void 0)).find(Z=>(0,u.areSameExtensions)(this.identifier,Z.identifier)),q=await this.getMetadata(this.identifier.id,this.manifest.version,z);if(q.isApplicationScoped=(0,h.isApplicationScopedExtension)(this.manifest),q.isMachineScoped=this.options.isMachineScoped||U?.isMachineScoped,q.isBuiltin=this.options.isBuiltin||U?.isBuiltin,U)if(this._operation=3,x.equals(new u.ExtensionKey(U.identifier,U.manifest.version)))try{await this.extensionsScanner.removeExtension(U,"existing")}catch{throw new Error(C.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&E.gt(U.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(U);else{const Z=await this.unsetUninstalledAndGetLocal(x);if(Z)try{await this.extensionsScanner.removeExtension(Z,"existing")}catch{throw new Error(C.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:b.resolve(this.location.fsPath),key:x,metadata:q},z),metadata:q}}async getMetadata(z,x,_){try{let[U]=await this.galleryService.getExtensions([{id:z,version:x}],_);if(U||([U]=await this.galleryService.getExtensions([{id:z}],_)),U)return{id:U.identifier.uuid,publisherDisplayName:U.publisherDisplayName,publisherId:U.publisherId,isPreReleaseVersion:U.properties.isPreReleaseVersion,preRelease:U.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class B{constructor(z,x,_){this.task=z,this.profileLocation=x,this.extensionsProfileScannerService=_,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const z=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[z.local,z.metadata]],this.profileLocation),z}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class K extends c.AbstractExtensionTask{constructor(z,x,_){super();this.extension=z,this.options=x,this.extensionsScanner=_}async doRun(z){const x=[],_=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const U=u.ExtensionKey.create(this.extension);x.push(..._.filter(q=>U.equals(u.ExtensionKey.create(q))))}else x.push(..._.filter(U=>(0,u.areSameExtensions)(U.identifier,this.extension.identifier)));if(!x.length)throw new Error(C.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const U of x)try{z.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(U)}catch(q){throw new Error(C.localize(9,null,(0,n.toErrorMessage)(q)))}}}class ie extends c.AbstractExtensionTask{constructor(z,x,_){super();this.extension=z,this.profileLocation=x,this.extensionsProfileScannerService=_}async doRun(z){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(re[266],se([0,1,2,28,32,44,72,198,109,43,5,8,23,33,29]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsCleaner=void 0;const S={versionOnly:!0,donotIncludePack:!0,donotCheckDependents:!0};let C=class extends D.Disposable{constructor(c,d,u,s,r,t,i,o){super();this.userDataProfilesService=d,c.removeUninstalledExtensions(this.userDataProfilesService.profiles.length===1),(0,b.migrateUnsupportedExtensions)(c,u,s,r,o),A.ExtensionStorageService.removeOutdatedExtensionVersions(c,i),this._register(t.createInstance(m))}};C=me([G(0,P.INativeServerExtensionManagementService),G(1,f.IUserDataProfilesService),G(2,n.IExtensionGalleryService),G(3,A.IExtensionStorageService),G(4,n.IGlobalExtensionEnablementService),G(5,E.IInstantiationService),G(6,v.IStorageService),G(7,w.ILogService)],C),e.ExtensionsCleaner=C;let m=class extends D.Disposable{constructor(c,d,u,s,r){super();this.extensionManagementService=c,this.userDataProfilesService=d,this.extensionsProfileScannerService=u,this.uriIdentityService=s,this.logService=r,this.profileExtensionsLocations=new Map,this.profileModeDisposables=this._register(new D.MutableDisposable),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}async onDidChangeProfiles({added:c,removed:d,all:u}){try{await Promise.all(d.map(s=>s.extensionsResource?this.removeExtensionsFromProfile(s.extensionsResource):Promise.resolve()))}catch(s){this.logService.error(s)}if(u.length===1){this.profileModeDisposables.clear();const s=this._register(this.userDataProfilesService.onDidChangeProfiles(()=>{s.dispose(),this.onDidChangeProfiles({added:this.userDataProfilesService.profiles,removed:[],all:this.userDataProfilesService.profiles})}));return}try{c.length&&(await Promise.all(c.map(s=>s.extensionsResource?this.populateExtensionsFromProfile(s.extensionsResource):Promise.resolve())),this.profileModeDisposables.value||(this.profileModeDisposables.value=new D.DisposableStore,this.profileModeDisposables.value.add((0,D.toDisposable)(()=>this.profileExtensionsLocations.clear())),this.profileModeDisposables.value.add(this.userDataProfilesService.onDidChangeProfiles(s=>this.onDidChangeProfiles(s))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidInstallExtensions(s=>this.onDidInstallExtensions(s))),this.profileModeDisposables.value.add(this.extensionManagementService.onDidUninstallExtension(s=>this.onDidUninstallExtension(s))),await this.uninstallExtensionsNotInProfiles()))}catch(s){this.logService.error(s)}}async uninstallExtensionsNotInProfiles(){const d=(await this.extensionManagementService.getAllUserInstalled()).filter(u=>!this.profileExtensionsLocations.has(this.getKey(u.identifier,u.manifest.version)));d.length&&await Promise.all(d.map(u=>this.extensionManagementService.uninstall(u,S)))}async onDidInstallExtensions(c){for(const{local:d,profileLocation:u}of c)!d||!u||this.addExtensionWithKey(this.getKey(d.identifier,d.manifest.version),u)}async onDidUninstallExtension(c){!c.profileLocation||!c.version||this.removeExtensionWithKey(this.getKey(c.identifier,c.version),c.profileLocation)&&await this.uninstallExtensions([{identifier:c.identifier,version:c.version}])}async populateExtensionsFromProfile(c){const d=await this.extensionsProfileScannerService.scanProfileExtensions(c);for(const u of d)this.addExtensionWithKey(this.getKey(u.identifier,u.version),c)}async removeExtensionsFromProfile(c){const d=[];for(const u of[...this.profileExtensionsLocations.keys()]){if(!this.removeExtensionWithKey(u,c))continue;const s=this.fromKey(u);s&&d.push(s)}d.length&&await this.uninstallExtensions(d)}addExtensionWithKey(c,d){let u=this.profileExtensionsLocations.get(c);u||(u=[],this.profileExtensionsLocations.set(c,u)),u.push(d)}removeExtensionWithKey(c,d){const u=this.profileExtensionsLocations.get(c);if(u){const s=u.findIndex(r=>this.uriIdentityService.extUri.isEqual(r,d));s>-1&&u.splice(s,1)}return u?.length?!1:(this.profileExtensionsLocations.delete(c),!0)}async uninstallExtensions(c){const u=(await this.extensionManagementService.getAllUserInstalled()).filter(s=>c.some(r=>this.getKey(s.identifier,s.manifest.version)===this.getKey(r.identifier,r.version)));u.length&&await Promise.all(u.map(s=>this.extensionManagementService.uninstall(s,S)))}getKey(c,d){return`${I.ExtensionIdentifier.toKey(c.id)}@${d}`}fromKey(c){const[d,u]=(0,k.getIdAndVersion)(c);return u?{identifier:{id:d},version:u}:void 0}};m=me([G(0,P.INativeServerExtensionManagementService),G(1,f.IUserDataProfilesService),G(2,L.IExtensionsProfileScannerService),G(3,y.IUriIdentityService),G(4,w.ILogService)],m)}),define(re[274],se([0,1,85,37,38,9,2,20,17,7,39,133,191,266,192,183,184,185,171,174,19,196,89,216,90,206,14,212,249,250,28,173,251,109,91,169,13,187,189,56,5,181,93,182,94,66,201,8,95,67,96,24,45,23,252,101,22,102,103,104,49,220,105,222,228,72,107,25,70,239,240,241,73,260,262,242,263,264,243,100,214,69,230,203,229,99,211,33,232,4,233,176,194,193,71,248,29,44,190,58,253,219,246,209]),function(X,e,D,n,k,L,A,b,P,I,E,w,v,y,f,S,C,m,g,c,d,u,s,r,t,i,o,l,a,h,p,R,M,O,F,T,N,W,V,Y,$,J,H,B,K,ie,ce,z,x,_,U,q,j,Z,oe,Q,te,ne,ue,he,pe,we,Ce,Pe,Ue,We,Be,qe,ae,de,fe,be,Ie,Me,De,$e,Ae,Te,Ne,ee,le,ge,Se,ve,Ee,Re,ke,Le,_e,Fe,ze,Qe,it,vt,Pt,It,Rt,pt,Dt,St,kt,Lt,Tt,At){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.main=void 0;class _t extends A.Disposable{constructor(ye){super();this.configuration=ye,this.server=this._register(new w.Server),this.sharedProcessWorkerService=void 0,this.registerListeners()}registerListeners(){const ye=()=>this.dispose();process.once("exit",ye),D.ipcRenderer.once("vscode:electron-main->shared-process=exit",ye);const Oe="vscode:electron-main->shared-process=disposeWorker",je=(Ve,Xe)=>this.onDisposeWorker(Xe);D.ipcRenderer.on(Oe,je),this._register((0,A.toDisposable)(()=>D.ipcRenderer.removeListener(Oe,je)))}onDisposeWorker(ye){this.sharedProcessWorkerService?.disposeWorker(ye)}async open(){const ye=await this.initServices();(0,qe.registerConfiguration)(),ye.invokeFunction(Oe=>{const je=Oe.get(z.ILogService);je.trace("sharedProcess configuration",JSON.stringify(this.configuration)),this.initChannels(Oe),this.registerErrorHandler(je)}),this._register((0,A.combinedDisposable)(ye.createInstance(v.CodeCacheCleaner,this.configuration.codeCachePath),ye.createInstance(f.LanguagePackCachedDataCleaner),ye.createInstance(m.StorageDataCleaner,this.configuration.backupWorkspacesPath),ye.createInstance(C.LogsDataCleaner),ye.createInstance(S.LocalizationsUpdater),ye.createInstance(y.ExtensionsCleaner)))}async initServices(){const ye=new H.ServiceCollection,Oe={_serviceBrand:void 0,...U.default};ye.set(q.IProductService,Oe);const je=new E.StaticRouter(Ke=>Ke==="main"),Ve=new B.MessagePortMainProcessService(this.server,je);ye.set(K.IMainProcessService,Ve);const Xe=this.configuration.policiesData?new Dt.PolicyChannelClient(this.configuration.policiesData,Ve.getChannel("policy")):new St.NullPolicyService;ye.set(St.IPolicyService,Xe);const xe=new l.SharedProcessEnvironmentService(this.configuration.args,Oe);ye.set(o.INativeEnvironmentService,xe);const st=new x.LogLevelChannelClient(this.server.getChannel("logLevel",je)),Ze=new x.LoggerChannelClient(this.configuration.logLevel,st.onDidChangeLogLevel,Ve.getChannel("logger"));ye.set(z.ILoggerService,Ze);const ct=this._register(new z.MultiplexLogService([this._register(new z.ConsoleLogger(this.configuration.logLevel)),this._register(Ze.createLogger((0,P.joinPath)(I.URI.file(xe.logsPath),"sharedprocess.log"),{name:"sharedprocess"}))])),He=this._register(new x.FollowerLogService(st,ct));ye.set(z.ILogService,He),this.sharedProcessWorkerService=new ke.SharedProcessWorkerService(He),ye.set(Re.ISharedProcessWorkerService,this.sharedProcessWorkerService);const Ye=this._register(new W.FileService(He));ye.set(N.IFileService,Ye);const lt=this._register(new V.DiskFileSystemProvider(He));Ye.registerProvider(b.Schemas.file,lt);const ut=this._register(new ze.FileUserDataProvider(b.Schemas.file,this._register(new Qe.DiskFileSystemProviderClient(Ve.getChannel(Qe.LOCAL_FILE_SYSTEM_CHANNEL_NAME),{pathCaseSensitive:Fe.isLinux})),b.Schemas.vscodeUserData,He));Ye.registerProvider(b.Schemas.vscodeUserData,ut);const et=this._register(new kt.UserDataProfilesNativeService(this.configuration.profiles,Ve,xe));ye.set(Rt.IUserDataProfilesService,et);const Ge=this._register(new u.ConfigurationService(et.defaultProfile.settingsResource,Ye,Xe,He));ye.set(d.IConfigurationService,Ge);const nt=new oe.NativeStorageService(void 0,{defaultProfile:et.defaultProfile,currentProfile:et.defaultProfile},Ve,xe);ye.set(Z.IStorageService,nt),this._register((0,A.toDisposable)(()=>nt.flush())),await Promise.all([Ge.initialize(),nt.initialize()]),ye.set(Le.IUriIdentityService,new _e.UriIdentityService(Ye)),ye.set(j.IRequestService,new At.SharedProcessRequestService(Ve,Ge,He)),ye.set(g.IChecksumService,new Y.SyncDescriptor(c.ChecksumService)),ye.set(vt.IV8InspectProfilingService,new Y.SyncDescriptor(it.InspectProfilingService));const ot=E.ProxyChannel.toService(Ve.getChannel("nativeHost"),{context:this.configuration.windowId});ye.set(_.INativeHostService,ot),ye.set(t.IDownloadService,new Y.SyncDescriptor(i.DownloadService));const ht=this._register(new Ne.ActiveWindowManager(ot)),Ut=new E.StaticRouter(Ke=>ht.getActiveClientId().then(dt=>Ke===dt));ye.set(F.IExtensionRecommendationNotificationService,new T.ExtensionRecommendationNotificationServiceChannelClient(this.server.getChannel("extensionRecommendationNotification",Ut)));let at;const rt=[],wt=(0,pe.isInternalTelemetry)(Oe,Ge);if((0,pe.supportsTelemetry)(Oe,xe)){const Ke=new ue.TelemetryLogAppender(Ze,xe);rt.push(Ke);const{installSourcePath:dt}=xe;if(Oe.aiConfig?.ariaKey){const bt=new Lt.OneDataSystemWebAppender(wt,"monacoworkbench",null,Oe.aiConfig.ariaKey);this._register((0,A.toDisposable)(()=>bt.flush())),rt.push(bt)}at=new he.TelemetryService({appenders:rt,commonProperties:(0,Q.resolveCommonProperties)(Ye,(0,n.release)(),(0,n.hostname)(),process.arch,Oe.commit,Oe.version,this.configuration.machineId,wt,dt),sendErrorTelemetry:!0,piiPaths:(0,pe.getPiiPathsFromEnvironment)(xe)},Ge,Oe)}else{at=pe.NullTelemetryService;const Ke=pe.NullAppender;rt.push(Ke)}this.server.registerChannel("telemetryAppender",new ne.TelemetryAppenderChannel(rt)),ye.set(te.ITelemetryService,at);const Mt=new we.CustomEndpointTelemetryService(Ge,at,Ze,xe,Oe);ye.set(te.ICustomEndpointTelemetryService,Mt),ye.set(pt.IExtensionsProfileScannerService,new Y.SyncDescriptor(pt.ExtensionsProfileScannerService)),ye.set(Pt.IExtensionsScannerService,new Y.SyncDescriptor(It.ExtensionsScannerService)),ye.set(O.INativeServerExtensionManagementService,new Y.SyncDescriptor(O.ExtensionManagementService)),ye.set(p.IDefaultExtensionsProfileInitService,new Y.SyncDescriptor(Tt.DefaultExtensionsProfileInitService)),ye.set(p.IExtensionGalleryService,new Y.SyncDescriptor(h.ExtensionGalleryService)),ye.set(p.IExtensionTipsService,new Y.SyncDescriptor(M.ExtensionTipsService)),ye.set(ie.ILanguagePackService,new Y.SyncDescriptor(ce.NativeLanguagePackService)),ye.set(s.IDiagnosticsService,new Y.SyncDescriptor(r.DiagnosticsService)),ye.set(ae.IUserDataSyncAccountService,new Y.SyncDescriptor(ae.UserDataSyncAccountService)),ye.set(qe.IUserDataSyncLogService,new Y.SyncDescriptor(be.UserDataSyncLogService)),ye.set(qe.IUserDataSyncUtilService,new fe.UserDataSyncUtilServiceClient(this.server.getChannel("userDataSyncUtil",Ke=>Ke.ctx!=="main"))),ye.set(p.IGlobalExtensionEnablementService,new Y.SyncDescriptor(a.GlobalExtensionEnablementService)),ye.set(Be.IIgnoredExtensionsManagementService,new Y.SyncDescriptor(Be.IgnoredExtensionsManagementService)),ye.set(We.IExtensionStorageService,new Y.SyncDescriptor(We.ExtensionStorageService)),ye.set(qe.IUserDataSyncStoreManagementService,new Y.SyncDescriptor(Ae.UserDataSyncStoreManagementService)),ye.set(qe.IUserDataSyncStoreService,new Y.SyncDescriptor(Ae.UserDataSyncStoreService)),ye.set(Ie.IUserDataSyncMachinesService,new Y.SyncDescriptor(Ie.UserDataSyncMachinesService)),ye.set(qe.IUserDataSyncBackupStoreService,new Y.SyncDescriptor(de.UserDataSyncBackupStoreService)),ye.set(qe.IUserDataSyncEnablementService,new Y.SyncDescriptor(Me.UserDataSyncEnablementService)),ye.set(qe.IUserDataSyncService,new Y.SyncDescriptor(De.UserDataSyncService));const Et=new Ue.PtyHostService({graceTime:6e4,shortGraceTime:6e3,scrollback:Ge.getValue("terminal.integrated.persistentSessionScrollback")??100},Ge,xe,He);return Et.initialize(),ye.set(Pe.ILocalPtyService,this._register(Et)),ye.set(ee.ISignService,new Y.SyncDescriptor(le.SignService)),ye.set(ge.ISharedTunnelsService,new Y.SyncDescriptor(Se.SharedTunnelsService)),ye.set(ve.ISharedProcessTunnelService,new Y.SyncDescriptor(Ee.SharedProcessTunnelService)),new J.InstantiationService(ye)}initChannels(ye){const Oe=new R.ExtensionManagementChannel(ye.get(p.IExtensionManagementService),()=>null);this.server.registerChannel("extensions",Oe);const je=E.ProxyChannel.fromService(ye.get(ie.ILanguagePackService));this.server.registerChannel("languagePacks",je);const Ve=E.ProxyChannel.fromService(ye.get(s.IDiagnosticsService));this.server.registerChannel("diagnostics",Ve);const Xe=new R.ExtensionTipsChannel(ye.get(p.IExtensionTipsService));this.server.registerChannel("extensionTipsService",Xe);const xe=E.ProxyChannel.fromService(ye.get(g.IChecksumService));this.server.registerChannel("checksum",xe);const st=E.ProxyChannel.fromService(ye.get(vt.IV8InspectProfilingService));this.server.registerChannel("v8InspectProfiling",st);const Ze=new fe.UserDataSyncMachinesServiceChannel(ye.get(Ie.IUserDataSyncMachinesService));this.server.registerChannel("userDataSyncMachines",Ze);const ct=E.ProxyChannel.fromService(ye.get(te.ICustomEndpointTelemetryService));this.server.registerChannel("customEndpointTelemetry",ct);const He=new fe.UserDataSyncAccountServiceChannel(ye.get(ae.IUserDataSyncAccountService));this.server.registerChannel("userDataSyncAccount",He);const Ye=new fe.UserDataSyncStoreManagementServiceChannel(ye.get(qe.IUserDataSyncStoreManagementService));this.server.registerChannel("userDataSyncStoreManagement",Ye);const lt=new $e.UserDataSyncChannel(ye.get(qe.IUserDataSyncService),ye.get(z.ILogService));this.server.registerChannel("userDataSync",lt);const ut=this._register(ye.get($.IInstantiationService).createInstance(Te.UserDataAutoSyncService)),et=new fe.UserDataAutoSyncChannel(ut);this.server.registerChannel("userDataAutoSync",et);const Ge=ye.get(Pe.ILocalPtyService),nt=E.ProxyChannel.fromService(Ge);this.server.registerChannel(Ce.TerminalIpcChannels.LocalPty,nt);const ot=E.ProxyChannel.fromService(ye.get(ve.ISharedProcessTunnelService));this.server.registerChannel(ve.ipcSharedProcessTunnelChannelName,ot);const ht=E.ProxyChannel.fromService(ye.get(Re.ISharedProcessWorkerService));this.server.registerChannel(Re.ipcSharedProcessWorkerChannelName,ht),this.server.registerChannel("IDefaultExtensionsProfileInitService",E.ProxyChannel.fromService(ye.get(p.IDefaultExtensionsProfileInitService)))}registerErrorHandler(ye){window.addEventListener("unhandledrejection",Oe=>{(0,L.onUnexpectedError)(Oe.reason),Oe.preventDefault()}),(0,L.setUnexpectedErrorHandler)(Oe=>{const je=(0,k.toErrorMessage)(Oe,!0);!je||ye.error(`[uncaught exception in sharedProcess]: ${je}`)})}}async function Ot(yt){const ye=new _t(yt);D.ipcRenderer.send("vscode:shared-process->electron-main=ipc-ready"),await ye.open(),D.ipcRenderer.send("vscode:shared-process->electron-main=init-done")}e.main=Ot})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/73fd3f11032e7b83c2ae011b5516e6ddd19e3db2/core/vs/code/electron-browser/sharedProcess/sharedProcessMain.js.map
