/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var me=["exports","require","vs/base/common/lifecycle","vs/base/common/event","vs/base/browser/dom","vs/base/common/platform","vs/base/common/types","vs/css!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/async","vs/nls!vs/code/electron-sandbox/processExplorer/processExplorerMain","vs/base/common/strings","vs/base/common/codicons","vs/nls","vs/base/common/errors","vs/base/common/arrays","vs/base/browser/browser","vs/base/common/uri","vs/base/browser/ui/widget","vs/base/browser/event","vs/base/browser/keyboardEvent","vs/base/browser/mouseEvent","vs/base/common/path","vs/base/browser/touch","vs/base/browser/ui/tree/tree","vs/base/common/color","vs/base/common/decorators","vs/base/common/iterator","vs/base/common/objects","vs/base/common/cancellation","vs/base/parts/sandbox/electron-sandbox/globals","vs/platform/instantiation/common/instantiation","vs/base/common/buffer","vs/base/common/actions","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/network","vs/base/common/resources","vs/base/browser/ui/scrollbar/scrollbarArrow","vs/base/parts/ipc/common/ipc","vs/platform/registry/common/platform","vs/base/browser/fastDomNode","vs/base/browser/ui/scrollbar/scrollbarState","vs/base/common/functional","vs/base/common/keyCodes","vs/base/common/numbers","vs/base/common/range","vs/css!vs/base/browser/ui/actionbar/actionbar","vs/base/common/scrollable","vs/base/common/map","vs/base/common/marshalling","vs/base/browser/dnd","vs/base/browser/formattedTextRenderer","vs/base/browser/globalPointerMoveMonitor","vs/base/browser/ui/aria/aria","vs/base/browser/ui/tree/indexTreeModel","vs/base/browser/ui/scrollbar/abstractScrollbar","vs/base/browser/ui/scrollbar/scrollableElement","vs/base/browser/ui/list/listView","vs/base/browser/ui/list/listWidget","vs/base/common/htmlContent","vs/base/browser/ui/actionbar/actionViewItems","vs/base/browser/ui/actionbar/actionbar","vs/base/browser/ui/toggle/toggle","vs/platform/instantiation/common/descriptors","vs/platform/theme/common/themeService","vs/base/browser/iframe","vs/base/browser/ui/list/list","vs/base/browser/ui/list/splice","vs/base/common/assert","vs/base/common/collections","vs/base/common/diff/diffChange","vs/base/common/idGenerator","vs/base/common/keybindings","vs/base/common/lazy","vs/base/common/linkedList","vs/base/common/marked/marked","vs/base/common/navigator","vs/base/common/history","vs/base/browser/ui/list/rangeMap","vs/base/common/stream","vs/base/parts/contextmenu/common/contextmenu","vs/base/parts/ipc/common/ipc.electron","vs/css!vs/base/browser/ui/aria/aria","vs/css!vs/base/browser/ui/codicons/codicon/codicon","vs/css!vs/base/browser/ui/codicons/codicon/codicon-modifiers","vs/base/browser/ui/codicons/codiconStyles","vs/css!vs/base/browser/ui/findinput/findInput","vs/css!vs/base/browser/ui/inputbox/inputBox","vs/css!vs/base/browser/ui/list/list","vs/css!vs/base/browser/ui/scrollbar/media/scrollbars","vs/css!vs/base/browser/ui/selectBox/selectBox","vs/css!vs/base/browser/ui/selectBox/selectBoxCustom","vs/css!vs/base/browser/ui/toggle/toggle","vs/css!vs/base/browser/ui/tree/media/tree","vs/css!vs/code/electron-sandbox/processExplorer/media/processExplorer","vs/nls!vs/base/browser/ui/actionbar/actionViewItems","vs/nls!vs/base/browser/ui/findinput/findInput","vs/nls!vs/base/browser/ui/findinput/findInputToggles","vs/nls!vs/base/browser/ui/iconLabel/iconLabelHover","vs/nls!vs/base/browser/ui/inputbox/inputBox","vs/nls!vs/base/browser/ui/selectBox/selectBoxCustom","vs/nls!vs/base/browser/ui/tree/abstractTree","vs/nls!vs/base/common/actions","vs/nls!vs/base/common/platform","vs/base/common/process","vs/base/common/mime","vs/base/common/stopwatch","vs/base/browser/canIUse","vs/base/common/cache","vs/base/common/extpath","vs/base/common/hash","vs/base/common/diff/diff","vs/base/browser/dompurify/dompurify","vs/base/browser/ui/iconLabel/iconLabels","vs/base/browser/ui/list/rowCache","vs/base/browser/ui/scrollbar/scrollbarVisibilityController","vs/base/browser/ui/selectBox/selectBoxNative","vs/base/browser/ui/tree/objectTreeModel","vs/base/browser/ui/scrollbar/horizontalScrollbar","vs/base/browser/ui/scrollbar/verticalScrollbar","vs/base/browser/markdownRenderer","vs/base/browser/ui/iconLabel/iconLabelHover","vs/base/browser/ui/selectBox/selectBoxCustom","vs/base/browser/ui/selectBox/selectBox","vs/base/browser/ui/inputbox/inputBox","vs/base/browser/ui/findinput/findInputToggles","vs/base/browser/ui/findinput/findInput","vs/base/browser/ui/tree/abstractTree","vs/base/browser/ui/tree/dataTree","vs/base/parts/contextmenu/electron-sandbox/contextmenu","vs/base/parts/ipc/electron-sandbox/ipc.electron","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/theme/common/iconRegistry","vs/platform/instantiation/common/extensions","vs/platform/diagnostics/common/diagnostics","vs/platform/files/common/files","vs/platform/ipc/electron-sandbox/mainProcessService","vs/platform/ipc/electron-sandbox/services","vs/platform/native/electron-sandbox/nativeHostService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/theme/common/theme","vs/platform/theme/common/iconRegistry","vs/platform/theme/browser/iconsStyleSheet","vs/platform/window/common/window","vs/platform/window/electron-sandbox/window","vs/code/electron-sandbox/processExplorer/processExplorerMain"],pe=function(Z){for(var t=[],E=0,i=Z.length;E<i;E++)t[E]=me[Z[E]];return t};/*! @license DOMPurify 2.3.1 | (c) Cure53 and other contributors | Released under the Apache license 2.0 and Mozilla Public License 2.0 | github.com/cure53/DOMPurify/blob/2.3.1/LICENSE */function $t(Z){if(Array.isArray(Z)){for(var t=0,E=Array(Z.length);t<Z.length;t++)E[t]=Z[t];return E}else return Array.from(Z)}var Kt=Object.hasOwnProperty,Lt=Object.setPrototypeOf,qt=Object.isFrozen,xt=Object.getPrototypeOf,jt=Object.getOwnPropertyDescriptor,it=Object.freeze,ot=Object.seal,Gt=Object.create,Nt=typeof Reflect!="undefined"&&Reflect,bt=Nt.apply,Et=Nt.construct;bt||(bt=function(t,E,i){return t.apply(E,i)}),it||(it=function(t){return t}),ot||(ot=function(t){return t}),Et||(Et=function(t,E){return new(Function.prototype.bind.apply(t,[null].concat($t(E))))});var Yt=nt(Array.prototype.forEach),kt=nt(Array.prototype.pop),mt=nt(Array.prototype.push),ut=nt(String.prototype.toLowerCase),Pt=nt(String.prototype.match),lt=nt(String.prototype.replace),Xt=nt(String.prototype.indexOf),Zt=nt(String.prototype.trim),at=nt(RegExp.prototype.test),Rt=Qt(TypeError);function nt(Z){return function(t){for(var E=arguments.length,i=Array(E>1?E-1:0),M=1;M<E;M++)i[M-1]=arguments[M];return bt(Z,t,i)}}function Qt(Z){return function(){for(var t=arguments.length,E=Array(t),i=0;i<t;i++)E[i]=arguments[i];return Et(Z,E)}}function Be(Z,t){Lt&&Lt(Z,null);for(var E=t.length;E--;){var i=t[E];if(typeof i=="string"){var M=ut(i);M!==i&&(qt(t)||(t[E]=M),i=M)}Z[i]=!0}return Z}function ct(Z){var t=Gt(null),E=void 0;for(E in Z)bt(Kt,Z,[E])&&(t[E]=Z[E]);return t}function wt(Z,t){for(;Z!==null;){var E=jt(Z,t);if(E){if(E.get)return nt(E.get);if(typeof E.value=="function")return nt(E.value)}Z=xt(Z)}function i(M){return console.warn("fallback value for",M),null}return i}var Mt=it(["a","abbr","acronym","address","area","article","aside","audio","b","bdi","bdo","big","blink","blockquote","body","br","button","canvas","caption","center","cite","code","col","colgroup","content","data","datalist","dd","decorator","del","details","dfn","dialog","dir","div","dl","dt","element","em","fieldset","figcaption","figure","font","footer","form","h1","h2","h3","h4","h5","h6","head","header","hgroup","hr","html","i","img","input","ins","kbd","label","legend","li","main","map","mark","marquee","menu","menuitem","meter","nav","nobr","ol","optgroup","option","output","p","picture","pre","progress","q","rp","rt","ruby","s","samp","section","select","shadow","small","source","spacer","span","strike","strong","style","sub","summary","sup","table","tbody","td","template","textarea","tfoot","th","thead","time","tr","track","tt","u","ul","var","video","wbr"]),_t=it(["svg","a","altglyph","altglyphdef","altglyphitem","animatecolor","animatemotion","animatetransform","circle","clippath","defs","desc","ellipse","filter","font","g","glyph","glyphref","hkern","image","line","lineargradient","marker","mask","metadata","mpath","path","pattern","polygon","polyline","radialgradient","rect","stop","style","switch","symbol","text","textpath","title","tref","tspan","view","vkern"]),Ct=it(["feBlend","feColorMatrix","feComponentTransfer","feComposite","feConvolveMatrix","feDiffuseLighting","feDisplacementMap","feDistantLight","feFlood","feFuncA","feFuncB","feFuncG","feFuncR","feGaussianBlur","feMerge","feMergeNode","feMorphology","feOffset","fePointLight","feSpecularLighting","feSpotLight","feTile","feTurbulence"]),Jt=it(["animate","color-profile","cursor","discard","fedropshadow","feimage","font-face","font-face-format","font-face-name","font-face-src","font-face-uri","foreignobject","hatch","hatchpath","mesh","meshgradient","meshpatch","meshrow","missing-glyph","script","set","solidcolor","unknown","use"]),St=it(["math","menclose","merror","mfenced","mfrac","mglyph","mi","mlabeledtr","mmultiscripts","mn","mo","mover","mpadded","mphantom","mroot","mrow","ms","mspace","msqrt","mstyle","msub","msup","msubsup","mtable","mtd","mtext","mtr","munder","munderover"]),ei=it(["maction","maligngroup","malignmark","mlongdiv","mscarries","mscarry","msgroup","mstack","msline","msrow","semantics","annotation","annotation-xml","mprescripts","none"]),Ot=it(["#text"]),Bt=it(["accept","action","align","alt","autocapitalize","autocomplete","autopictureinpicture","autoplay","background","bgcolor","border","capture","cellpadding","cellspacing","checked","cite","class","clear","color","cols","colspan","controls","controlslist","coords","crossorigin","datetime","decoding","default","dir","disabled","disablepictureinpicture","disableremoteplayback","download","draggable","enctype","enterkeyhint","face","for","headers","height","hidden","high","href","hreflang","id","inputmode","integrity","ismap","kind","label","lang","list","loading","loop","low","max","maxlength","media","method","min","minlength","multiple","muted","name","noshade","novalidate","nowrap","open","optimum","pattern","placeholder","playsinline","poster","preload","pubdate","radiogroup","readonly","rel","required","rev","reversed","role","rows","rowspan","spellcheck","scope","selected","shape","size","sizes","span","srclang","start","src","srcset","step","style","summary","tabindex","title","translate","type","usemap","valign","value","width","xmlns","slot"]),At=it(["accent-height","accumulate","additive","alignment-baseline","ascent","attributename","attributetype","azimuth","basefrequency","baseline-shift","begin","bias","by","class","clip","clippathunits","clip-path","clip-rule","color","color-interpolation","color-interpolation-filters","color-profile","color-rendering","cx","cy","d","dx","dy","diffuseconstant","direction","display","divisor","dur","edgemode","elevation","end","fill","fill-opacity","fill-rule","filter","filterunits","flood-color","flood-opacity","font-family","font-size","font-size-adjust","font-stretch","font-style","font-variant","font-weight","fx","fy","g1","g2","glyph-name","glyphref","gradientunits","gradienttransform","height","href","id","image-rendering","in","in2","k","k1","k2","k3","k4","kerning","keypoints","keysplines","keytimes","lang","lengthadjust","letter-spacing","kernelmatrix","kernelunitlength","lighting-color","local","marker-end","marker-mid","marker-start","markerheight","markerunits","markerwidth","maskcontentunits","maskunits","max","mask","media","method","mode","min","name","numoctaves","offset","operator","opacity","order","orient","orientation","origin","overflow","paint-order","path","pathlength","patterncontentunits","patterntransform","patternunits","points","preservealpha","preserveaspectratio","primitiveunits","r","rx","ry","radius","refx","refy","repeatcount","repeatdur","restart","result","rotate","scale","seed","shape-rendering","specularconstant","specularexponent","spreadmethod","startoffset","stddeviation","stitchtiles","stop-color","stop-opacity","stroke-dasharray","stroke-dashoffset","stroke-linecap","stroke-linejoin","stroke-miterlimit","stroke-opacity","stroke","stroke-width","style","surfacescale","systemlanguage","tabindex","targetx","targety","transform","text-anchor","text-decoration","text-rendering","textlength","type","u1","u2","unicode","values","viewbox","visibility","version","vert-adv-y","vert-origin-x","vert-origin-y","width","word-spacing","wrap","writing-mode","xchannelselector","ychannelselector","x","x1","x2","xmlns","y","y1","y2","z","zoomandpan"]),Ht=it(["accent","accentunder","align","bevelled","close","columnsalign","columnlines","columnspan","denomalign","depth","dir","display","displaystyle","encoding","fence","frame","height","href","id","largeop","length","linethickness","lspace","lquote","mathbackground","mathcolor","mathsize","mathvariant","maxsize","minsize","movablelimits","notation","numalign","open","rowalign","rowlines","rowspacing","rowspan","rspace","rquote","scriptlevel","scriptminsize","scriptsizemultiplier","selection","separator","separators","stretchy","subscriptshift","supscriptshift","symmetric","voffset","width","xmlns"]),vt=it(["xlink:href","xml:id","xlink:title","xml:space","xmlns:xlink"]),ti=ot(/\{\{[\s\S]*|[\s\S]*\}\}/gm),ii=ot(/<%[\s\S]*|[\s\S]*%>/gm),ni=ot(/^data-[\-\w.\u00B7-\uFFFF]/),si=ot(/^aria-[\-\w]+$/),ri=ot(/^(?:(?:(?:f|ht)tps?|mailto|tel|callto|cid|xmpp):|[^a-z]|[a-z+.\-]+(?:[^a-z+.\-:]|$))/i),oi=ot(/^(?:\w+script|data):/i),ai=ot(/[\u0000-\u0020\u00A0\u1680\u180E\u2000-\u2029\u205F\u3000]/g),pt=typeof Symbol=="function"&&typeof Symbol.iterator=="symbol"?function(Z){return typeof Z}:function(Z){return Z&&typeof Symbol=="function"&&Z.constructor===Symbol&&Z!==Symbol.prototype?"symbol":typeof Z};function rt(Z){if(Array.isArray(Z)){for(var t=0,E=Array(Z.length);t<Z.length;t++)E[t]=Z[t];return E}else return Array.from(Z)}var li=function(){return typeof window=="undefined"?null:window},ui=function(t,E){if((typeof t=="undefined"?"undefined":pt(t))!=="object"||typeof t.createPolicy!="function")return null;var i=null,M="data-tt-policy-suffix";E.currentScript&&E.currentScript.hasAttribute(M)&&(i=E.currentScript.getAttribute(M));var O="dompurify"+(i?"#"+i:"");try{return t.createPolicy(O,{createHTML:function(w){return w}})}catch{return console.warn("TrustedTypes policy "+O+" could not be created."),null}};function Wt(){var Z=arguments.length>0&&arguments[0]!==void 0?arguments[0]:li(),t=function(le){return Wt(le)};if(t.version="2.3.1",t.removed=[],!Z||!Z.document||Z.document.nodeType!==9)return t.isSupported=!1,t;var E=Z.document,i=Z.document,M=Z.DocumentFragment,O=Z.HTMLTemplateElement,_=Z.Node,w=Z.Element,g=Z.NodeFilter,d=Z.NamedNodeMap,f=d===void 0?Z.NamedNodeMap||Z.MozNamedAttrMap:d,F=Z.Text,l=Z.Comment,s=Z.DOMParser,e=Z.trustedTypes,p=w.prototype,v=wt(p,"cloneNode"),D=wt(p,"nextSibling"),y=wt(p,"childNodes"),o=wt(p,"parentNode");if(typeof O=="function"){var c=i.createElement("template");c.content&&c.content.ownerDocument&&(i=c.content.ownerDocument)}var b=ui(e,E),S=b&&Q?b.createHTML(""):"",A=i,C=A.implementation,r=A.createNodeIterator,n=A.createDocumentFragment,a=A.getElementsByTagName,u=E.importNode,m={};try{m=ct(i).documentMode?i.documentMode:{}}catch{}var W={};t.isSupported=typeof o=="function"&&C&&typeof C.createHTMLDocument!="undefined"&&m!==9;var V=ti,ne=ii,re=ni,we=si,ae=oi,ve=ai,ue=ri,ge=null,ye=Be({},[].concat(rt(Mt),rt(_t),rt(Ct),rt(St),rt(Ot))),ee=null,fe=Be({},[].concat(rt(Bt),rt(At),rt(Ht),rt(vt))),te=null,X=null,se=!0,ie=!0,L=!1,$=!1,G=!1,B=!1,h=!1,I=!1,U=!1,K=!0,Q=!1,N=!0,R=!0,z=!1,T={},H=null,k=Be({},["annotation-xml","audio","colgroup","desc","foreignobject","head","iframe","math","mi","mn","mo","ms","mtext","noembed","noframes","noscript","plaintext","script","style","svg","template","thead","title","video","xmp"]),P=null,x=Be({},["audio","video","img","source","image","track"]),J=null,he=Be({},["alt","class","for","id","label","name","pattern","placeholder","role","summary","title","value","style","xmlns"]),de="http://www.w3.org/1998/Math/MathML",Ee="http://www.w3.org/2000/svg",_e="http://www.w3.org/1999/xhtml",ke=_e,Ie=!1,De=null,Pe=i.createElement("form"),Me=function(le){De&&De===le||((!le||(typeof le=="undefined"?"undefined":pt(le))!=="object")&&(le={}),le=ct(le),ge="ALLOWED_TAGS"in le?Be({},le.ALLOWED_TAGS):ye,ee="ALLOWED_ATTR"in le?Be({},le.ALLOWED_ATTR):fe,J="ADD_URI_SAFE_ATTR"in le?Be(ct(he),le.ADD_URI_SAFE_ATTR):he,P="ADD_DATA_URI_TAGS"in le?Be(ct(x),le.ADD_DATA_URI_TAGS):x,H="FORBID_CONTENTS"in le?Be({},le.FORBID_CONTENTS):k,te="FORBID_TAGS"in le?Be({},le.FORBID_TAGS):{},X="FORBID_ATTR"in le?Be({},le.FORBID_ATTR):{},T="USE_PROFILES"in le?le.USE_PROFILES:!1,se=le.ALLOW_ARIA_ATTR!==!1,ie=le.ALLOW_DATA_ATTR!==!1,L=le.ALLOW_UNKNOWN_PROTOCOLS||!1,$=le.SAFE_FOR_TEMPLATES||!1,G=le.WHOLE_DOCUMENT||!1,I=le.RETURN_DOM||!1,U=le.RETURN_DOM_FRAGMENT||!1,K=le.RETURN_DOM_IMPORT!==!1,Q=le.RETURN_TRUSTED_TYPE||!1,h=le.FORCE_BODY||!1,N=le.SANITIZE_DOM!==!1,R=le.KEEP_CONTENT!==!1,z=le.IN_PLACE||!1,ue=le.ALLOWED_URI_REGEXP||ue,ke=le.NAMESPACE||_e,$&&(ie=!1),U&&(I=!0),T&&(ge=Be({},[].concat(rt(Ot))),ee=[],T.html===!0&&(Be(ge,Mt),Be(ee,Bt)),T.svg===!0&&(Be(ge,_t),Be(ee,At),Be(ee,vt)),T.svgFilters===!0&&(Be(ge,Ct),Be(ee,At),Be(ee,vt)),T.mathMl===!0&&(Be(ge,St),Be(ee,Ht),Be(ee,vt))),le.ADD_TAGS&&(ge===ye&&(ge=ct(ge)),Be(ge,le.ADD_TAGS)),le.ADD_ATTR&&(ee===fe&&(ee=ct(ee)),Be(ee,le.ADD_ATTR)),le.ADD_URI_SAFE_ATTR&&Be(J,le.ADD_URI_SAFE_ATTR),le.FORBID_CONTENTS&&(H===k&&(H=ct(H)),Be(H,le.FORBID_CONTENTS)),R&&(ge["#text"]=!0),G&&Be(ge,["html","head","body"]),ge.table&&(Be(ge,["tbody"]),delete te.tbody),it&&it(le),De=le)},Ge=Be({},["mi","mo","mn","ms","mtext"]),He=Be({},["foreignobject","desc","title","annotation-xml"]),Ue=Be({},_t);Be(Ue,Ct),Be(Ue,Jt);var Qe=Be({},St);Be(Qe,ei);var je=function(le){var Se=o(le);(!Se||!Se.tagName)&&(Se={namespaceURI:_e,tagName:"template"});var Ne=ut(le.tagName),Ve=ut(Se.tagName);if(le.namespaceURI===Ee)return Se.namespaceURI===_e?Ne==="svg":Se.namespaceURI===de?Ne==="svg"&&(Ve==="annotation-xml"||Ge[Ve]):Boolean(Ue[Ne]);if(le.namespaceURI===de)return Se.namespaceURI===_e?Ne==="math":Se.namespaceURI===Ee?Ne==="math"&&He[Ve]:Boolean(Qe[Ne]);if(le.namespaceURI===_e){if(Se.namespaceURI===Ee&&!He[Ve]||Se.namespaceURI===de&&!Ge[Ve])return!1;var Ze=Be({},["title","style","font","a","script"]);return!Qe[Ne]&&(Ze[Ne]||!Ue[Ne])}return!1},Oe=function(le){mt(t.removed,{element:le});try{le.parentNode.removeChild(le)}catch{try{le.outerHTML=S}catch{le.remove()}}},q=function(le,Se){try{mt(t.removed,{attribute:Se.getAttributeNode(le),from:Se})}catch{mt(t.removed,{attribute:null,from:Se})}if(Se.removeAttribute(le),le==="is"&&!ee[le])if(I||U)try{Oe(Se)}catch{}else try{Se.setAttribute(le,"")}catch{}},oe=function(le){var Se=void 0,Ne=void 0;if(h)le="<remove></remove>"+le;else{var Ve=Pt(le,/^[\r\n\t ]+/);Ne=Ve&&Ve[0]}var Ze=b?b.createHTML(le):le;if(ke===_e)try{Se=new s().parseFromString(Ze,"text/html")}catch{}if(!Se||!Se.documentElement){Se=C.createDocument(ke,"template",null);try{Se.documentElement.innerHTML=Ie?"":Ze}catch{}}var Je=Se.body||Se.documentElement;return le&&Ne&&Je.insertBefore(i.createTextNode(Ne),Je.childNodes[0]||null),ke===_e?a.call(Se,G?"html":"body")[0]:G?Se.documentElement:Je},be=function(le){return r.call(le.ownerDocument||le,le,g.SHOW_ELEMENT|g.SHOW_COMMENT|g.SHOW_TEXT,null,!1)},Ce=function(le){return le instanceof F||le instanceof l?!1:typeof le.nodeName!="string"||typeof le.textContent!="string"||typeof le.removeChild!="function"||!(le.attributes instanceof f)||typeof le.removeAttribute!="function"||typeof le.setAttribute!="function"||typeof le.namespaceURI!="string"||typeof le.insertBefore!="function"},Te=function(le){return(typeof _=="undefined"?"undefined":pt(_))==="object"?le instanceof _:le&&(typeof le=="undefined"?"undefined":pt(le))==="object"&&typeof le.nodeType=="number"&&typeof le.nodeName=="string"},Re=function(le,Se,Ne){!W[le]||Yt(W[le],function(Ve){Ve.call(t,Se,Ne,De)})},$e=function(le){var Se=void 0;if(Re("beforeSanitizeElements",le,null),Ce(le)||Pt(le.nodeName,/[\u0080-\uFFFF]/))return Oe(le),!0;var Ne=ut(le.nodeName);if(Re("uponSanitizeElement",le,{tagName:Ne,allowedTags:ge}),!Te(le.firstElementChild)&&(!Te(le.content)||!Te(le.content.firstElementChild))&&at(/<[/\w]/g,le.innerHTML)&&at(/<[/\w]/g,le.textContent)||Ne==="select"&&at(/<template/i,le.innerHTML))return Oe(le),!0;if(!ge[Ne]||te[Ne]){if(R&&!H[Ne]){var Ve=o(le)||le.parentNode,Ze=y(le)||le.childNodes;if(Ze&&Ve)for(var Je=Ze.length,et=Je-1;et>=0;--et)Ve.insertBefore(v(Ze[et],!0),D(le))}return Oe(le),!0}return le instanceof w&&!je(le)||(Ne==="noscript"||Ne==="noembed")&&at(/<\/no(script|embed)/i,le.innerHTML)?(Oe(le),!0):($&&le.nodeType===3&&(Se=le.textContent,Se=lt(Se,V," "),Se=lt(Se,ne," "),le.textContent!==Se&&(mt(t.removed,{element:le.cloneNode()}),le.textContent=Se)),Re("afterSanitizeElements",le,null),!1)},tt=function(le,Se,Ne){if(N&&(Se==="id"||Se==="name")&&(Ne in i||Ne in Pe))return!1;if(!(ie&&!X[Se]&&at(re,Se))){if(!(se&&at(we,Se))){if(!ee[Se]||X[Se])return!1;if(!J[Se]){if(!at(ue,lt(Ne,ve,""))){if(!((Se==="src"||Se==="xlink:href"||Se==="href")&&le!=="script"&&Xt(Ne,"data:")===0&&P[le])){if(!(L&&!at(ae,lt(Ne,ve,"")))){if(Ne)return!1}}}}}}return!0},Xe=function(le){var Se=void 0,Ne=void 0,Ve=void 0,Ze=void 0;Re("beforeSanitizeAttributes",le,null);var Je=le.attributes;if(!!Je){var et={attrName:"",attrValue:"",keepAttr:!0,allowedAttributes:ee};for(Ze=Je.length;Ze--;){Se=Je[Ze];var st=Se,ht=st.name,Dt=st.namespaceURI;if(Ne=Zt(Se.value),Ve=ut(ht),et.attrName=Ve,et.attrValue=Ne,et.keepAttr=!0,et.forceKeepAttr=void 0,Re("uponSanitizeAttribute",le,et),Ne=et.attrValue,!et.forceKeepAttr&&(q(ht,le),!!et.keepAttr)){if(at(/\/>/i,Ne)){q(ht,le);continue}$&&(Ne=lt(Ne,V," "),Ne=lt(Ne,ne," "));var Ft=le.nodeName.toLowerCase();if(!!tt(Ft,Ve,Ne))try{Dt?le.setAttributeNS(Dt,ht,Ne):le.setAttribute(ht,Ne),kt(t.removed)}catch{}}}Re("afterSanitizeAttributes",le,null)}},qe=function Le(le){var Se=void 0,Ne=be(le);for(Re("beforeSanitizeShadowDOM",le,null);Se=Ne.nextNode();)Re("uponSanitizeShadowNode",Se,null),!$e(Se)&&(Se.content instanceof M&&Le(Se.content),Xe(Se));Re("afterSanitizeShadowDOM",le,null)};return t.sanitize=function(Le,le){var Se=void 0,Ne=void 0,Ve=void 0,Ze=void 0,Je=void 0;if(Ie=!Le,Ie&&(Le="<!-->"),typeof Le!="string"&&!Te(Le)){if(typeof Le.toString!="function")throw Rt("toString is not a function");if(Le=Le.toString(),typeof Le!="string")throw Rt("dirty is not a string, aborting")}if(!t.isSupported){if(pt(Z.toStaticHTML)==="object"||typeof Z.toStaticHTML=="function"){if(typeof Le=="string")return Z.toStaticHTML(Le);if(Te(Le))return Z.toStaticHTML(Le.outerHTML)}return Le}if(B||Me(le),t.removed=[],typeof Le=="string"&&(z=!1),!z)if(Le instanceof _)Se=oe("<!---->"),Ne=Se.ownerDocument.importNode(Le,!0),Ne.nodeType===1&&Ne.nodeName==="BODY"||Ne.nodeName==="HTML"?Se=Ne:Se.appendChild(Ne);else{if(!I&&!$&&!G&&Le.indexOf("<")===-1)return b&&Q?b.createHTML(Le):Le;if(Se=oe(Le),!Se)return I?null:S}Se&&h&&Oe(Se.firstChild);for(var et=be(z?Le:Se);Ve=et.nextNode();)Ve.nodeType===3&&Ve===Ze||$e(Ve)||(Ve.content instanceof M&&qe(Ve.content),Xe(Ve),Ze=Ve);if(Ze=null,z)return Le;if(I){if(U)for(Je=n.call(Se.ownerDocument);Se.firstChild;)Je.appendChild(Se.firstChild);else Je=Se;return K&&(Je=u.call(E,Je,!0)),Je}var st=G?Se.outerHTML:Se.innerHTML;return $&&(st=lt(st,V," "),st=lt(st,ne," ")),b&&Q?b.createHTML(st):st},t.setConfig=function(Le){Me(Le),B=!0},t.clearConfig=function(){De=null,B=!1},t.isValidAttribute=function(Le,le,Se){De||Me({});var Ne=ut(Le),Ve=ut(le);return tt(Ne,Ve,Se)},t.addHook=function(Le,le){typeof le=="function"&&(W[Le]=W[Le]||[],mt(W[Le],le))},t.removeHook=function(Le){W[Le]&&kt(W[Le])},t.removeHooks=function(Le){W[Le]&&(W[Le]=[])},t.removeAllHooks=function(){W={}},t}var ci=Wt();define("vs/base/browser/dompurify/dompurify",function(){return ci}),define(me[40],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createFastDomNode=t.FastDomNode=void 0;class E{constructor(_){this.domNode=_,this._maxWidth="",this._width="",this._height="",this._top="",this._left="",this._bottom="",this._right="",this._fontFamily="",this._fontWeight="",this._fontSize="",this._fontStyle="",this._fontFeatureSettings="",this._textDecoration="",this._lineHeight="",this._letterSpacing="",this._className="",this._display="",this._position="",this._visibility="",this._color="",this._backgroundColor="",this._layerHint=!1,this._contain="none",this._boxShadow=""}setMaxWidth(_){const w=i(_);this._maxWidth!==w&&(this._maxWidth=w,this.domNode.style.maxWidth=this._maxWidth)}setWidth(_){const w=i(_);this._width!==w&&(this._width=w,this.domNode.style.width=this._width)}setHeight(_){const w=i(_);this._height!==w&&(this._height=w,this.domNode.style.height=this._height)}setTop(_){const w=i(_);this._top!==w&&(this._top=w,this.domNode.style.top=this._top)}setLeft(_){const w=i(_);this._left!==w&&(this._left=w,this.domNode.style.left=this._left)}setBottom(_){const w=i(_);this._bottom!==w&&(this._bottom=w,this.domNode.style.bottom=this._bottom)}setRight(_){const w=i(_);this._right!==w&&(this._right=w,this.domNode.style.right=this._right)}setFontFamily(_){this._fontFamily!==_&&(this._fontFamily=_,this.domNode.style.fontFamily=this._fontFamily)}setFontWeight(_){this._fontWeight!==_&&(this._fontWeight=_,this.domNode.style.fontWeight=this._fontWeight)}setFontSize(_){const w=i(_);this._fontSize!==w&&(this._fontSize=w,this.domNode.style.fontSize=this._fontSize)}setFontStyle(_){this._fontStyle!==_&&(this._fontStyle=_,this.domNode.style.fontStyle=this._fontStyle)}setFontFeatureSettings(_){this._fontFeatureSettings!==_&&(this._fontFeatureSettings=_,this.domNode.style.fontFeatureSettings=this._fontFeatureSettings)}setTextDecoration(_){this._textDecoration!==_&&(this._textDecoration=_,this.domNode.style.textDecoration=this._textDecoration)}setLineHeight(_){const w=i(_);this._lineHeight!==w&&(this._lineHeight=w,this.domNode.style.lineHeight=this._lineHeight)}setLetterSpacing(_){const w=i(_);this._letterSpacing!==w&&(this._letterSpacing=w,this.domNode.style.letterSpacing=this._letterSpacing)}setClassName(_){this._className!==_&&(this._className=_,this.domNode.className=this._className)}toggleClassName(_,w){this.domNode.classList.toggle(_,w),this._className=this.domNode.className}setDisplay(_){this._display!==_&&(this._display=_,this.domNode.style.display=this._display)}setPosition(_){this._position!==_&&(this._position=_,this.domNode.style.position=this._position)}setVisibility(_){this._visibility!==_&&(this._visibility=_,this.domNode.style.visibility=this._visibility)}setColor(_){this._color!==_&&(this._color=_,this.domNode.style.color=this._color)}setBackgroundColor(_){this._backgroundColor!==_&&(this._backgroundColor=_,this.domNode.style.backgroundColor=this._backgroundColor)}setLayerHinting(_){this._layerHint!==_&&(this._layerHint=_,this.domNode.style.transform=this._layerHint?"translate3d(0px, 0px, 0px)":"")}setBoxShadow(_){this._boxShadow!==_&&(this._boxShadow=_,this.domNode.style.boxShadow=_)}setContain(_){this._contain!==_&&(this._contain=_,this.domNode.style.contain=this._contain)}setAttribute(_,w){this.domNode.setAttribute(_,w)}removeAttribute(_){this.domNode.removeAttribute(_)}appendChild(_){this.domNode.appendChild(_.domNode)}removeChild(_){this.domNode.removeChild(_.domNode)}}t.FastDomNode=E;function i(O){return typeof O=="number"?`${O}px`:O}function M(O){return new E(O)}t.createFastDomNode=M}),define(me[65],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IframeUtils=void 0;let E=!1,i=null;function M(_){if(!_.parent||_.parent===_)return null;try{const w=_.location,g=_.parent.location;if(w.origin!=="null"&&g.origin!=="null"&&w.origin!==g.origin)return E=!0,null}catch{return E=!0,null}return _.parent}class O{static getSameOriginWindowChain(){if(!i){i=[];let w=window,g;do g=M(w),g?i.push({window:w,iframeElement:w.frameElement||null}):i.push({window:w,iframeElement:null}),w=g;while(w)}return i.slice(0)}static hasDifferentOriginAncestor(){return i||this.getSameOriginWindowChain(),E}static getPositionOfChildWindowRelativeToAncestorWindow(w,g){if(!g||w===g)return{top:0,left:0};let d=0,f=0;const F=this.getSameOriginWindowChain();for(const l of F){if(d+=l.window.scrollY,f+=l.window.scrollX,l.window===g||!l.iframeElement)break;const s=l.iframeElement.getBoundingClientRect();d+=s.top,f+=s.left}return{top:d,left:f}}}t.IframeUtils=O}),define(me[66],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedListVirtualDelegate=t.ListError=t.ListDragOverReactions=t.ListDragOverEffect=void 0;var E;(function(O){O[O.Copy=0]="Copy",O[O.Move=1]="Move"})(E=t.ListDragOverEffect||(t.ListDragOverEffect={})),t.ListDragOverReactions={reject(){return{accept:!1}},accept(){return{accept:!0}}};class i extends Error{constructor(_,w){super(`ListError [${_}] ${w}`)}}t.ListError=i;class M{constructor(){this.cache=new WeakMap}getHeight(_){return this.cache.get(_)??this.estimateHeight(_)}setDynamicHeight(_,w){w>0&&this.cache.set(_,w)}}t.CachedListVirtualDelegate=M}),define(me[67],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CombinedSpliceable=void 0;class E{constructor(M){this.spliceables=M}splice(M,O,_){this.spliceables.forEach(w=>w.splice(M,O,_))}}t.CombinedSpliceable=E}),define(me[41],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarState=void 0;const E=20;class i{constructor(O,_,w,g,d,f){this._scrollbarSize=Math.round(_),this._oppositeScrollbarSize=Math.round(w),this._arrowSize=Math.round(O),this._visibleSize=g,this._scrollSize=d,this._scrollPosition=f,this._computedAvailableSize=0,this._computedIsNeeded=!1,this._computedSliderSize=0,this._computedSliderRatio=0,this._computedSliderPosition=0,this._refreshComputedValues()}clone(){return new i(this._arrowSize,this._scrollbarSize,this._oppositeScrollbarSize,this._visibleSize,this._scrollSize,this._scrollPosition)}setVisibleSize(O){const _=Math.round(O);return this._visibleSize!==_?(this._visibleSize=_,this._refreshComputedValues(),!0):!1}setScrollSize(O){const _=Math.round(O);return this._scrollSize!==_?(this._scrollSize=_,this._refreshComputedValues(),!0):!1}setScrollPosition(O){const _=Math.round(O);return this._scrollPosition!==_?(this._scrollPosition=_,this._refreshComputedValues(),!0):!1}setScrollbarSize(O){this._scrollbarSize=Math.round(O)}setOppositeScrollbarSize(O){this._oppositeScrollbarSize=Math.round(O)}static _computeValues(O,_,w,g,d){const f=Math.max(0,w-O),F=Math.max(0,f-2*_),l=g>0&&g>w;if(!l)return{computedAvailableSize:Math.round(f),computedIsNeeded:l,computedSliderSize:Math.round(F),computedSliderRatio:0,computedSliderPosition:0};const s=Math.round(Math.max(E,Math.floor(w*F/g))),e=(F-s)/(g-w),p=d*e;return{computedAvailableSize:Math.round(f),computedIsNeeded:l,computedSliderSize:Math.round(s),computedSliderRatio:e,computedSliderPosition:Math.round(p)}}_refreshComputedValues(){const O=i._computeValues(this._oppositeScrollbarSize,this._arrowSize,this._visibleSize,this._scrollSize,this._scrollPosition);this._computedAvailableSize=O.computedAvailableSize,this._computedIsNeeded=O.computedIsNeeded,this._computedSliderSize=O.computedSliderSize,this._computedSliderRatio=O.computedSliderRatio,this._computedSliderPosition=O.computedSliderPosition}getArrowSize(){return this._arrowSize}getScrollPosition(){return this._scrollPosition}getRectangleLargeSize(){return this._computedAvailableSize}getRectangleSmallSize(){return this._scrollbarSize}isNeeded(){return this._computedIsNeeded}getSliderSize(){return this._computedSliderSize}getSliderPosition(){return this._computedSliderPosition}getDesiredScrollPositionFromOffset(O){if(!this._computedIsNeeded)return 0;const _=O-this._arrowSize-this._computedSliderSize/2;return Math.round(_/this._computedSliderRatio)}getDesiredScrollPositionFromOffsetPaged(O){if(!this._computedIsNeeded)return 0;const _=O-this._arrowSize;let w=this._scrollPosition;return _<this._computedSliderPosition?w-=this._visibleSize:w+=this._visibleSize,w}getDesiredScrollPositionFromDelta(O){if(!this._computedIsNeeded)return 0;const _=this._computedSliderPosition+O;return Math.round(_/this._computedSliderRatio)}}t.ScrollbarState=i}),define(me[23],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.WeakMapper=t.TreeError=t.TreeDragOverReactions=t.TreeDragOverBubble=t.TreeMouseEventTarget=t.TreeVisibility=void 0;var E;(function(w){w[w.Hidden=0]="Hidden",w[w.Visible=1]="Visible",w[w.Recurse=2]="Recurse"})(E=t.TreeVisibility||(t.TreeVisibility={}));var i;(function(w){w[w.Unknown=0]="Unknown",w[w.Twistie=1]="Twistie",w[w.Element=2]="Element",w[w.Filter=3]="Filter"})(i=t.TreeMouseEventTarget||(t.TreeMouseEventTarget={}));var M;(function(w){w[w.Down=0]="Down",w[w.Up=1]="Up"})(M=t.TreeDragOverBubble||(t.TreeDragOverBubble={})),t.TreeDragOverReactions={acceptBubbleUp(){return{accept:!0,bubble:1}},acceptBubbleDown(w=!1){return{accept:!0,bubble:0,autoExpand:w}},acceptCopyBubbleUp(){return{accept:!0,bubble:1,effect:0}},acceptCopyBubbleDown(w=!1){return{accept:!0,bubble:0,effect:0,autoExpand:w}}};class O extends Error{constructor(g,d){super(`TreeError [${g}] ${d}`)}}t.TreeError=O;class _{constructor(g){this.fn=g,this._map=new WeakMap}map(g){let d=this._map.get(g);return d||(d=this.fn(g),this._map.set(g,d)),d}}t.WeakMapper=_}),define(me[68],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.ok=void 0;function E(M,O){if(!M)throw new Error(O?`Assertion failed (${O})`:"Assertion Failed")}t.ok=E;function i(M,O="Unreachable"){throw new Error(O)}t.assertNever=i}),define(me[11],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CSSIcon=t.getClassNamesArray=t.Codicon=t.getCodiconAriaLabel=void 0;function E(_){return _?_.replace(/\$\((.*?)\)/g,(w,g)=>` ${g} `).trim():""}t.getCodiconAriaLabel=E;class i{constructor(w,g,d){this.id=w,this.definition=g,this.description=d,i._allCodicons.push(this)}get classNames(){return"codicon codicon-"+this.id}get classNamesArray(){return["codicon","codicon-"+this.id]}get cssSelector(){return".codicon.codicon-"+this.id}static getAll(){return i._allCodicons}}t.Codicon=i,i._allCodicons=[],i.add=new i("add",{fontCharacter:"\\ea60"}),i.plus=new i("plus",i.add.definition),i.gistNew=new i("gist-new",i.add.definition),i.repoCreate=new i("repo-create",i.add.definition),i.lightbulb=new i("lightbulb",{fontCharacter:"\\ea61"}),i.lightBulb=new i("light-bulb",{fontCharacter:"\\ea61"}),i.repo=new i("repo",{fontCharacter:"\\ea62"}),i.repoDelete=new i("repo-delete",{fontCharacter:"\\ea62"}),i.gistFork=new i("gist-fork",{fontCharacter:"\\ea63"}),i.repoForked=new i("repo-forked",{fontCharacter:"\\ea63"}),i.gitPullRequest=new i("git-pull-request",{fontCharacter:"\\ea64"}),i.gitPullRequestAbandoned=new i("git-pull-request-abandoned",{fontCharacter:"\\ea64"}),i.recordKeys=new i("record-keys",{fontCharacter:"\\ea65"}),i.keyboard=new i("keyboard",{fontCharacter:"\\ea65"}),i.tag=new i("tag",{fontCharacter:"\\ea66"}),i.tagAdd=new i("tag-add",{fontCharacter:"\\ea66"}),i.tagRemove=new i("tag-remove",{fontCharacter:"\\ea66"}),i.person=new i("person",{fontCharacter:"\\ea67"}),i.personFollow=new i("person-follow",{fontCharacter:"\\ea67"}),i.personOutline=new i("person-outline",{fontCharacter:"\\ea67"}),i.personFilled=new i("person-filled",{fontCharacter:"\\ea67"}),i.gitBranch=new i("git-branch",{fontCharacter:"\\ea68"}),i.gitBranchCreate=new i("git-branch-create",{fontCharacter:"\\ea68"}),i.gitBranchDelete=new i("git-branch-delete",{fontCharacter:"\\ea68"}),i.sourceControl=new i("source-control",{fontCharacter:"\\ea68"}),i.mirror=new i("mirror",{fontCharacter:"\\ea69"}),i.mirrorPublic=new i("mirror-public",{fontCharacter:"\\ea69"}),i.star=new i("star",{fontCharacter:"\\ea6a"}),i.starAdd=new i("star-add",{fontCharacter:"\\ea6a"}),i.starDelete=new i("star-delete",{fontCharacter:"\\ea6a"}),i.starEmpty=new i("star-empty",{fontCharacter:"\\ea6a"}),i.comment=new i("comment",{fontCharacter:"\\ea6b"}),i.commentAdd=new i("comment-add",{fontCharacter:"\\ea6b"}),i.alert=new i("alert",{fontCharacter:"\\ea6c"}),i.warning=new i("warning",{fontCharacter:"\\ea6c"}),i.search=new i("search",{fontCharacter:"\\ea6d"}),i.searchSave=new i("search-save",{fontCharacter:"\\ea6d"}),i.logOut=new i("log-out",{fontCharacter:"\\ea6e"}),i.signOut=new i("sign-out",{fontCharacter:"\\ea6e"}),i.logIn=new i("log-in",{fontCharacter:"\\ea6f"}),i.signIn=new i("sign-in",{fontCharacter:"\\ea6f"}),i.eye=new i("eye",{fontCharacter:"\\ea70"}),i.eyeUnwatch=new i("eye-unwatch",{fontCharacter:"\\ea70"}),i.eyeWatch=new i("eye-watch",{fontCharacter:"\\ea70"}),i.circleFilled=new i("circle-filled",{fontCharacter:"\\ea71"}),i.primitiveDot=new i("primitive-dot",i.circleFilled.definition),i.closeDirty=new i("close-dirty",i.circleFilled.definition),i.terminalDecorationSuccess=new i("terminal-decoration-success",i.circleFilled.definition),i.debugBreakpoint=new i("debug-breakpoint",i.circleFilled.definition),i.debugBreakpointDisabled=new i("debug-breakpoint-disabled",i.circleFilled.definition),i.debugHint=new i("debug-hint",i.circleFilled.definition),i.primitiveSquare=new i("primitive-square",{fontCharacter:"\\ea72"}),i.edit=new i("edit",{fontCharacter:"\\ea73"}),i.pencil=new i("pencil",{fontCharacter:"\\ea73"}),i.info=new i("info",{fontCharacter:"\\ea74"}),i.issueOpened=new i("issue-opened",{fontCharacter:"\\ea74"}),i.gistPrivate=new i("gist-private",{fontCharacter:"\\ea75"}),i.gitForkPrivate=new i("git-fork-private",{fontCharacter:"\\ea75"}),i.lock=new i("lock",{fontCharacter:"\\ea75"}),i.mirrorPrivate=new i("mirror-private",{fontCharacter:"\\ea75"}),i.close=new i("close",{fontCharacter:"\\ea76"}),i.removeClose=new i("remove-close",{fontCharacter:"\\ea76"}),i.x=new i("x",{fontCharacter:"\\ea76"}),i.repoSync=new i("repo-sync",{fontCharacter:"\\ea77"}),i.sync=new i("sync",{fontCharacter:"\\ea77"}),i.clone=new i("clone",{fontCharacter:"\\ea78"}),i.desktopDownload=new i("desktop-download",{fontCharacter:"\\ea78"}),i.beaker=new i("beaker",{fontCharacter:"\\ea79"}),i.microscope=new i("microscope",{fontCharacter:"\\ea79"}),i.vm=new i("vm",{fontCharacter:"\\ea7a"}),i.deviceDesktop=new i("device-desktop",{fontCharacter:"\\ea7a"}),i.file=new i("file",{fontCharacter:"\\ea7b"}),i.fileText=new i("file-text",{fontCharacter:"\\ea7b"}),i.more=new i("more",{fontCharacter:"\\ea7c"}),i.ellipsis=new i("ellipsis",{fontCharacter:"\\ea7c"}),i.kebabHorizontal=new i("kebab-horizontal",{fontCharacter:"\\ea7c"}),i.mailReply=new i("mail-reply",{fontCharacter:"\\ea7d"}),i.reply=new i("reply",{fontCharacter:"\\ea7d"}),i.organization=new i("organization",{fontCharacter:"\\ea7e"}),i.organizationFilled=new i("organization-filled",{fontCharacter:"\\ea7e"}),i.organizationOutline=new i("organization-outline",{fontCharacter:"\\ea7e"}),i.newFile=new i("new-file",{fontCharacter:"\\ea7f"}),i.fileAdd=new i("file-add",{fontCharacter:"\\ea7f"}),i.newFolder=new i("new-folder",{fontCharacter:"\\ea80"}),i.fileDirectoryCreate=new i("file-directory-create",{fontCharacter:"\\ea80"}),i.trash=new i("trash",{fontCharacter:"\\ea81"}),i.trashcan=new i("trashcan",{fontCharacter:"\\ea81"}),i.history=new i("history",{fontCharacter:"\\ea82"}),i.clock=new i("clock",{fontCharacter:"\\ea82"}),i.folder=new i("folder",{fontCharacter:"\\ea83"}),i.fileDirectory=new i("file-directory",{fontCharacter:"\\ea83"}),i.symbolFolder=new i("symbol-folder",{fontCharacter:"\\ea83"}),i.logoGithub=new i("logo-github",{fontCharacter:"\\ea84"}),i.markGithub=new i("mark-github",{fontCharacter:"\\ea84"}),i.github=new i("github",{fontCharacter:"\\ea84"}),i.terminal=new i("terminal",{fontCharacter:"\\ea85"}),i.console=new i("console",{fontCharacter:"\\ea85"}),i.repl=new i("repl",{fontCharacter:"\\ea85"}),i.zap=new i("zap",{fontCharacter:"\\ea86"}),i.symbolEvent=new i("symbol-event",{fontCharacter:"\\ea86"}),i.error=new i("error",{fontCharacter:"\\ea87"}),i.stop=new i("stop",{fontCharacter:"\\ea87"}),i.variable=new i("variable",{fontCharacter:"\\ea88"}),i.symbolVariable=new i("symbol-variable",{fontCharacter:"\\ea88"}),i.array=new i("array",{fontCharacter:"\\ea8a"}),i.symbolArray=new i("symbol-array",{fontCharacter:"\\ea8a"}),i.symbolModule=new i("symbol-module",{fontCharacter:"\\ea8b"}),i.symbolPackage=new i("symbol-package",{fontCharacter:"\\ea8b"}),i.symbolNamespace=new i("symbol-namespace",{fontCharacter:"\\ea8b"}),i.symbolObject=new i("symbol-object",{fontCharacter:"\\ea8b"}),i.symbolMethod=new i("symbol-method",{fontCharacter:"\\ea8c"}),i.symbolFunction=new i("symbol-function",{fontCharacter:"\\ea8c"}),i.symbolConstructor=new i("symbol-constructor",{fontCharacter:"\\ea8c"}),i.symbolBoolean=new i("symbol-boolean",{fontCharacter:"\\ea8f"}),i.symbolNull=new i("symbol-null",{fontCharacter:"\\ea8f"}),i.symbolNumeric=new i("symbol-numeric",{fontCharacter:"\\ea90"}),i.symbolNumber=new i("symbol-number",{fontCharacter:"\\ea90"}),i.symbolStructure=new i("symbol-structure",{fontCharacter:"\\ea91"}),i.symbolStruct=new i("symbol-struct",{fontCharacter:"\\ea91"}),i.symbolParameter=new i("symbol-parameter",{fontCharacter:"\\ea92"}),i.symbolTypeParameter=new i("symbol-type-parameter",{fontCharacter:"\\ea92"}),i.symbolKey=new i("symbol-key",{fontCharacter:"\\ea93"}),i.symbolText=new i("symbol-text",{fontCharacter:"\\ea93"}),i.symbolReference=new i("symbol-reference",{fontCharacter:"\\ea94"}),i.goToFile=new i("go-to-file",{fontCharacter:"\\ea94"}),i.symbolEnum=new i("symbol-enum",{fontCharacter:"\\ea95"}),i.symbolValue=new i("symbol-value",{fontCharacter:"\\ea95"}),i.symbolRuler=new i("symbol-ruler",{fontCharacter:"\\ea96"}),i.symbolUnit=new i("symbol-unit",{fontCharacter:"\\ea96"}),i.activateBreakpoints=new i("activate-breakpoints",{fontCharacter:"\\ea97"}),i.archive=new i("archive",{fontCharacter:"\\ea98"}),i.arrowBoth=new i("arrow-both",{fontCharacter:"\\ea99"}),i.arrowDown=new i("arrow-down",{fontCharacter:"\\ea9a"}),i.arrowLeft=new i("arrow-left",{fontCharacter:"\\ea9b"}),i.arrowRight=new i("arrow-right",{fontCharacter:"\\ea9c"}),i.arrowSmallDown=new i("arrow-small-down",{fontCharacter:"\\ea9d"}),i.arrowSmallLeft=new i("arrow-small-left",{fontCharacter:"\\ea9e"}),i.arrowSmallRight=new i("arrow-small-right",{fontCharacter:"\\ea9f"}),i.arrowSmallUp=new i("arrow-small-up",{fontCharacter:"\\eaa0"}),i.arrowUp=new i("arrow-up",{fontCharacter:"\\eaa1"}),i.bell=new i("bell",{fontCharacter:"\\eaa2"}),i.bold=new i("bold",{fontCharacter:"\\eaa3"}),i.book=new i("book",{fontCharacter:"\\eaa4"}),i.bookmark=new i("bookmark",{fontCharacter:"\\eaa5"}),i.debugBreakpointConditionalUnverified=new i("debug-breakpoint-conditional-unverified",{fontCharacter:"\\eaa6"}),i.debugBreakpointConditional=new i("debug-breakpoint-conditional",{fontCharacter:"\\eaa7"}),i.debugBreakpointConditionalDisabled=new i("debug-breakpoint-conditional-disabled",{fontCharacter:"\\eaa7"}),i.debugBreakpointDataUnverified=new i("debug-breakpoint-data-unverified",{fontCharacter:"\\eaa8"}),i.debugBreakpointData=new i("debug-breakpoint-data",{fontCharacter:"\\eaa9"}),i.debugBreakpointDataDisabled=new i("debug-breakpoint-data-disabled",{fontCharacter:"\\eaa9"}),i.debugBreakpointLogUnverified=new i("debug-breakpoint-log-unverified",{fontCharacter:"\\eaaa"}),i.debugBreakpointLog=new i("debug-breakpoint-log",{fontCharacter:"\\eaab"}),i.debugBreakpointLogDisabled=new i("debug-breakpoint-log-disabled",{fontCharacter:"\\eaab"}),i.briefcase=new i("briefcase",{fontCharacter:"\\eaac"}),i.broadcast=new i("broadcast",{fontCharacter:"\\eaad"}),i.browser=new i("browser",{fontCharacter:"\\eaae"}),i.bug=new i("bug",{fontCharacter:"\\eaaf"}),i.calendar=new i("calendar",{fontCharacter:"\\eab0"}),i.caseSensitive=new i("case-sensitive",{fontCharacter:"\\eab1"}),i.check=new i("check",{fontCharacter:"\\eab2"}),i.checklist=new i("checklist",{fontCharacter:"\\eab3"}),i.chevronDown=new i("chevron-down",{fontCharacter:"\\eab4"}),i.dropDownButton=new i("drop-down-button",i.chevronDown.definition),i.chevronLeft=new i("chevron-left",{fontCharacter:"\\eab5"}),i.chevronRight=new i("chevron-right",{fontCharacter:"\\eab6"}),i.chevronUp=new i("chevron-up",{fontCharacter:"\\eab7"}),i.chromeClose=new i("chrome-close",{fontCharacter:"\\eab8"}),i.chromeMaximize=new i("chrome-maximize",{fontCharacter:"\\eab9"}),i.chromeMinimize=new i("chrome-minimize",{fontCharacter:"\\eaba"}),i.chromeRestore=new i("chrome-restore",{fontCharacter:"\\eabb"}),i.circle=new i("circle",{fontCharacter:"\\eabc"}),i.circleOutline=new i("circle-outline",i.circle.definition),i.terminalDecorationIncomplete=new i("terminal-decoration-incomplete",i.circle.definition),i.debugBreakpointUnverified=new i("debug-breakpoint-unverified",i.circle.definition),i.circleSlash=new i("circle-slash",{fontCharacter:"\\eabd"}),i.circuitBoard=new i("circuit-board",{fontCharacter:"\\eabe"}),i.clearAll=new i("clear-all",{fontCharacter:"\\eabf"}),i.clippy=new i("clippy",{fontCharacter:"\\eac0"}),i.closeAll=new i("close-all",{fontCharacter:"\\eac1"}),i.cloudDownload=new i("cloud-download",{fontCharacter:"\\eac2"}),i.cloudUpload=new i("cloud-upload",{fontCharacter:"\\eac3"}),i.code=new i("code",{fontCharacter:"\\eac4"}),i.collapseAll=new i("collapse-all",{fontCharacter:"\\eac5"}),i.colorMode=new i("color-mode",{fontCharacter:"\\eac6"}),i.commentDiscussion=new i("comment-discussion",{fontCharacter:"\\eac7"}),i.compareChanges=new i("compare-changes",{fontCharacter:"\\eafd"}),i.creditCard=new i("credit-card",{fontCharacter:"\\eac9"}),i.dash=new i("dash",{fontCharacter:"\\eacc"}),i.dashboard=new i("dashboard",{fontCharacter:"\\eacd"}),i.database=new i("database",{fontCharacter:"\\eace"}),i.debugContinue=new i("debug-continue",{fontCharacter:"\\eacf"}),i.debugDisconnect=new i("debug-disconnect",{fontCharacter:"\\ead0"}),i.debugPause=new i("debug-pause",{fontCharacter:"\\ead1"}),i.debugRestart=new i("debug-restart",{fontCharacter:"\\ead2"}),i.debugStart=new i("debug-start",{fontCharacter:"\\ead3"}),i.debugStepInto=new i("debug-step-into",{fontCharacter:"\\ead4"}),i.debugStepOut=new i("debug-step-out",{fontCharacter:"\\ead5"}),i.debugStepOver=new i("debug-step-over",{fontCharacter:"\\ead6"}),i.debugStop=new i("debug-stop",{fontCharacter:"\\ead7"}),i.debug=new i("debug",{fontCharacter:"\\ead8"}),i.deviceCameraVideo=new i("device-camera-video",{fontCharacter:"\\ead9"}),i.deviceCamera=new i("device-camera",{fontCharacter:"\\eada"}),i.deviceMobile=new i("device-mobile",{fontCharacter:"\\eadb"}),i.diffAdded=new i("diff-added",{fontCharacter:"\\eadc"}),i.diffIgnored=new i("diff-ignored",{fontCharacter:"\\eadd"}),i.diffModified=new i("diff-modified",{fontCharacter:"\\eade"}),i.diffRemoved=new i("diff-removed",{fontCharacter:"\\eadf"}),i.diffRenamed=new i("diff-renamed",{fontCharacter:"\\eae0"}),i.diff=new i("diff",{fontCharacter:"\\eae1"}),i.discard=new i("discard",{fontCharacter:"\\eae2"}),i.editorLayout=new i("editor-layout",{fontCharacter:"\\eae3"}),i.emptyWindow=new i("empty-window",{fontCharacter:"\\eae4"}),i.exclude=new i("exclude",{fontCharacter:"\\eae5"}),i.extensions=new i("extensions",{fontCharacter:"\\eae6"}),i.eyeClosed=new i("eye-closed",{fontCharacter:"\\eae7"}),i.fileBinary=new i("file-binary",{fontCharacter:"\\eae8"}),i.fileCode=new i("file-code",{fontCharacter:"\\eae9"}),i.fileMedia=new i("file-media",{fontCharacter:"\\eaea"}),i.filePdf=new i("file-pdf",{fontCharacter:"\\eaeb"}),i.fileSubmodule=new i("file-submodule",{fontCharacter:"\\eaec"}),i.fileSymlinkDirectory=new i("file-symlink-directory",{fontCharacter:"\\eaed"}),i.fileSymlinkFile=new i("file-symlink-file",{fontCharacter:"\\eaee"}),i.fileZip=new i("file-zip",{fontCharacter:"\\eaef"}),i.files=new i("files",{fontCharacter:"\\eaf0"}),i.filter=new i("filter",{fontCharacter:"\\eaf1"}),i.flame=new i("flame",{fontCharacter:"\\eaf2"}),i.foldDown=new i("fold-down",{fontCharacter:"\\eaf3"}),i.foldUp=new i("fold-up",{fontCharacter:"\\eaf4"}),i.fold=new i("fold",{fontCharacter:"\\eaf5"}),i.folderActive=new i("folder-active",{fontCharacter:"\\eaf6"}),i.folderOpened=new i("folder-opened",{fontCharacter:"\\eaf7"}),i.gear=new i("gear",{fontCharacter:"\\eaf8"}),i.gift=new i("gift",{fontCharacter:"\\eaf9"}),i.gistSecret=new i("gist-secret",{fontCharacter:"\\eafa"}),i.gist=new i("gist",{fontCharacter:"\\eafb"}),i.gitCommit=new i("git-commit",{fontCharacter:"\\eafc"}),i.gitCompare=new i("git-compare",{fontCharacter:"\\eafd"}),i.gitMerge=new i("git-merge",{fontCharacter:"\\eafe"}),i.githubAction=new i("github-action",{fontCharacter:"\\eaff"}),i.githubAlt=new i("github-alt",{fontCharacter:"\\eb00"}),i.globe=new i("globe",{fontCharacter:"\\eb01"}),i.grabber=new i("grabber",{fontCharacter:"\\eb02"}),i.graph=new i("graph",{fontCharacter:"\\eb03"}),i.gripper=new i("gripper",{fontCharacter:"\\eb04"}),i.heart=new i("heart",{fontCharacter:"\\eb05"}),i.home=new i("home",{fontCharacter:"\\eb06"}),i.horizontalRule=new i("horizontal-rule",{fontCharacter:"\\eb07"}),i.hubot=new i("hubot",{fontCharacter:"\\eb08"}),i.inbox=new i("inbox",{fontCharacter:"\\eb09"}),i.issueClosed=new i("issue-closed",{fontCharacter:"\\eba4"}),i.issueReopened=new i("issue-reopened",{fontCharacter:"\\eb0b"}),i.issues=new i("issues",{fontCharacter:"\\eb0c"}),i.italic=new i("italic",{fontCharacter:"\\eb0d"}),i.jersey=new i("jersey",{fontCharacter:"\\eb0e"}),i.json=new i("json",{fontCharacter:"\\eb0f"}),i.kebabVertical=new i("kebab-vertical",{fontCharacter:"\\eb10"}),i.key=new i("key",{fontCharacter:"\\eb11"}),i.law=new i("law",{fontCharacter:"\\eb12"}),i.lightbulbAutofix=new i("lightbulb-autofix",{fontCharacter:"\\eb13"}),i.linkExternal=new i("link-external",{fontCharacter:"\\eb14"}),i.link=new i("link",{fontCharacter:"\\eb15"}),i.listOrdered=new i("list-ordered",{fontCharacter:"\\eb16"}),i.listUnordered=new i("list-unordered",{fontCharacter:"\\eb17"}),i.liveShare=new i("live-share",{fontCharacter:"\\eb18"}),i.loading=new i("loading",{fontCharacter:"\\eb19"}),i.location=new i("location",{fontCharacter:"\\eb1a"}),i.mailRead=new i("mail-read",{fontCharacter:"\\eb1b"}),i.mail=new i("mail",{fontCharacter:"\\eb1c"}),i.markdown=new i("markdown",{fontCharacter:"\\eb1d"}),i.megaphone=new i("megaphone",{fontCharacter:"\\eb1e"}),i.mention=new i("mention",{fontCharacter:"\\eb1f"}),i.milestone=new i("milestone",{fontCharacter:"\\eb20"}),i.mortarBoard=new i("mortar-board",{fontCharacter:"\\eb21"}),i.move=new i("move",{fontCharacter:"\\eb22"}),i.multipleWindows=new i("multiple-windows",{fontCharacter:"\\eb23"}),i.mute=new i("mute",{fontCharacter:"\\eb24"}),i.noNewline=new i("no-newline",{fontCharacter:"\\eb25"}),i.note=new i("note",{fontCharacter:"\\eb26"}),i.octoface=new i("octoface",{fontCharacter:"\\eb27"}),i.openPreview=new i("open-preview",{fontCharacter:"\\eb28"}),i.package_=new i("package",{fontCharacter:"\\eb29"}),i.paintcan=new i("paintcan",{fontCharacter:"\\eb2a"}),i.pin=new i("pin",{fontCharacter:"\\eb2b"}),i.play=new i("play",{fontCharacter:"\\eb2c"}),i.run=new i("run",{fontCharacter:"\\eb2c"}),i.plug=new i("plug",{fontCharacter:"\\eb2d"}),i.preserveCase=new i("preserve-case",{fontCharacter:"\\eb2e"}),i.preview=new i("preview",{fontCharacter:"\\eb2f"}),i.project=new i("project",{fontCharacter:"\\eb30"}),i.pulse=new i("pulse",{fontCharacter:"\\eb31"}),i.question=new i("question",{fontCharacter:"\\eb32"}),i.quote=new i("quote",{fontCharacter:"\\eb33"}),i.radioTower=new i("radio-tower",{fontCharacter:"\\eb34"}),i.reactions=new i("reactions",{fontCharacter:"\\eb35"}),i.references=new i("references",{fontCharacter:"\\eb36"}),i.refresh=new i("refresh",{fontCharacter:"\\eb37"}),i.regex=new i("regex",{fontCharacter:"\\eb38"}),i.remoteExplorer=new i("remote-explorer",{fontCharacter:"\\eb39"}),i.remote=new i("remote",{fontCharacter:"\\eb3a"}),i.remove=new i("remove",{fontCharacter:"\\eb3b"}),i.replaceAll=new i("replace-all",{fontCharacter:"\\eb3c"}),i.replace=new i("replace",{fontCharacter:"\\eb3d"}),i.repoClone=new i("repo-clone",{fontCharacter:"\\eb3e"}),i.repoForcePush=new i("repo-force-push",{fontCharacter:"\\eb3f"}),i.repoPull=new i("repo-pull",{fontCharacter:"\\eb40"}),i.repoPush=new i("repo-push",{fontCharacter:"\\eb41"}),i.report=new i("report",{fontCharacter:"\\eb42"}),i.requestChanges=new i("request-changes",{fontCharacter:"\\eb43"}),i.rocket=new i("rocket",{fontCharacter:"\\eb44"}),i.rootFolderOpened=new i("root-folder-opened",{fontCharacter:"\\eb45"}),i.rootFolder=new i("root-folder",{fontCharacter:"\\eb46"}),i.rss=new i("rss",{fontCharacter:"\\eb47"}),i.ruby=new i("ruby",{fontCharacter:"\\eb48"}),i.saveAll=new i("save-all",{fontCharacter:"\\eb49"}),i.saveAs=new i("save-as",{fontCharacter:"\\eb4a"}),i.save=new i("save",{fontCharacter:"\\eb4b"}),i.screenFull=new i("screen-full",{fontCharacter:"\\eb4c"}),i.screenNormal=new i("screen-normal",{fontCharacter:"\\eb4d"}),i.searchStop=new i("search-stop",{fontCharacter:"\\eb4e"}),i.server=new i("server",{fontCharacter:"\\eb50"}),i.settingsGear=new i("settings-gear",{fontCharacter:"\\eb51"}),i.settings=new i("settings",{fontCharacter:"\\eb52"}),i.shield=new i("shield",{fontCharacter:"\\eb53"}),i.smiley=new i("smiley",{fontCharacter:"\\eb54"}),i.sortPrecedence=new i("sort-precedence",{fontCharacter:"\\eb55"}),i.splitHorizontal=new i("split-horizontal",{fontCharacter:"\\eb56"}),i.splitVertical=new i("split-vertical",{fontCharacter:"\\eb57"}),i.squirrel=new i("squirrel",{fontCharacter:"\\eb58"}),i.starFull=new i("star-full",{fontCharacter:"\\eb59"}),i.starHalf=new i("star-half",{fontCharacter:"\\eb5a"}),i.symbolClass=new i("symbol-class",{fontCharacter:"\\eb5b"}),i.symbolColor=new i("symbol-color",{fontCharacter:"\\eb5c"}),i.symbolCustomColor=new i("symbol-customcolor",{fontCharacter:"\\eb5c"}),i.symbolConstant=new i("symbol-constant",{fontCharacter:"\\eb5d"}),i.symbolEnumMember=new i("symbol-enum-member",{fontCharacter:"\\eb5e"}),i.symbolField=new i("symbol-field",{fontCharacter:"\\eb5f"}),i.symbolFile=new i("symbol-file",{fontCharacter:"\\eb60"}),i.symbolInterface=new i("symbol-interface",{fontCharacter:"\\eb61"}),i.symbolKeyword=new i("symbol-keyword",{fontCharacter:"\\eb62"}),i.symbolMisc=new i("symbol-misc",{fontCharacter:"\\eb63"}),i.symbolOperator=new i("symbol-operator",{fontCharacter:"\\eb64"}),i.symbolProperty=new i("symbol-property",{fontCharacter:"\\eb65"}),i.wrench=new i("wrench",{fontCharacter:"\\eb65"}),i.wrenchSubaction=new i("wrench-subaction",{fontCharacter:"\\eb65"}),i.symbolSnippet=new i("symbol-snippet",{fontCharacter:"\\eb66"}),i.tasklist=new i("tasklist",{fontCharacter:"\\eb67"}),i.telescope=new i("telescope",{fontCharacter:"\\eb68"}),i.textSize=new i("text-size",{fontCharacter:"\\eb69"}),i.threeBars=new i("three-bars",{fontCharacter:"\\eb6a"}),i.thumbsdown=new i("thumbsdown",{fontCharacter:"\\eb6b"}),i.thumbsup=new i("thumbsup",{fontCharacter:"\\eb6c"}),i.tools=new i("tools",{fontCharacter:"\\eb6d"}),i.triangleDown=new i("triangle-down",{fontCharacter:"\\eb6e"}),i.triangleLeft=new i("triangle-left",{fontCharacter:"\\eb6f"}),i.triangleRight=new i("triangle-right",{fontCharacter:"\\eb70"}),i.triangleUp=new i("triangle-up",{fontCharacter:"\\eb71"}),i.twitter=new i("twitter",{fontCharacter:"\\eb72"}),i.unfold=new i("unfold",{fontCharacter:"\\eb73"}),i.unlock=new i("unlock",{fontCharacter:"\\eb74"}),i.unmute=new i("unmute",{fontCharacter:"\\eb75"}),i.unverified=new i("unverified",{fontCharacter:"\\eb76"}),i.verified=new i("verified",{fontCharacter:"\\eb77"}),i.versions=new i("versions",{fontCharacter:"\\eb78"}),i.vmActive=new i("vm-active",{fontCharacter:"\\eb79"}),i.vmOutline=new i("vm-outline",{fontCharacter:"\\eb7a"}),i.vmRunning=new i("vm-running",{fontCharacter:"\\eb7b"}),i.watch=new i("watch",{fontCharacter:"\\eb7c"}),i.whitespace=new i("whitespace",{fontCharacter:"\\eb7d"}),i.wholeWord=new i("whole-word",{fontCharacter:"\\eb7e"}),i.window=new i("window",{fontCharacter:"\\eb7f"}),i.wordWrap=new i("word-wrap",{fontCharacter:"\\eb80"}),i.zoomIn=new i("zoom-in",{fontCharacter:"\\eb81"}),i.zoomOut=new i("zoom-out",{fontCharacter:"\\eb82"}),i.listFilter=new i("list-filter",{fontCharacter:"\\eb83"}),i.listFlat=new i("list-flat",{fontCharacter:"\\eb84"}),i.listSelection=new i("list-selection",{fontCharacter:"\\eb85"}),i.selection=new i("selection",{fontCharacter:"\\eb85"}),i.listTree=new i("list-tree",{fontCharacter:"\\eb86"}),i.debugBreakpointFunctionUnverified=new i("debug-breakpoint-function-unverified",{fontCharacter:"\\eb87"}),i.debugBreakpointFunction=new i("debug-breakpoint-function",{fontCharacter:"\\eb88"}),i.debugBreakpointFunctionDisabled=new i("debug-breakpoint-function-disabled",{fontCharacter:"\\eb88"}),i.debugStackframeActive=new i("debug-stackframe-active",{fontCharacter:"\\eb89"}),i.circleSmallFilled=new i("circle-small-filled",{fontCharacter:"\\eb8a"}),i.debugStackframeDot=new i("debug-stackframe-dot",i.circleSmallFilled.definition),i.terminalDecorationMark=new i("terminal-decoration-mark",i.circleSmallFilled.definition),i.debugStackframe=new i("debug-stackframe",{fontCharacter:"\\eb8b"}),i.debugStackframeFocused=new i("debug-stackframe-focused",{fontCharacter:"\\eb8b"}),i.debugBreakpointUnsupported=new i("debug-breakpoint-unsupported",{fontCharacter:"\\eb8c"}),i.symbolString=new i("symbol-string",{fontCharacter:"\\eb8d"}),i.debugReverseContinue=new i("debug-reverse-continue",{fontCharacter:"\\eb8e"}),i.debugStepBack=new i("debug-step-back",{fontCharacter:"\\eb8f"}),i.debugRestartFrame=new i("debug-restart-frame",{fontCharacter:"\\eb90"}),i.callIncoming=new i("call-incoming",{fontCharacter:"\\eb92"}),i.callOutgoing=new i("call-outgoing",{fontCharacter:"\\eb93"}),i.menu=new i("menu",{fontCharacter:"\\eb94"}),i.expandAll=new i("expand-all",{fontCharacter:"\\eb95"}),i.feedback=new i("feedback",{fontCharacter:"\\eb96"}),i.groupByRefType=new i("group-by-ref-type",{fontCharacter:"\\eb97"}),i.ungroupByRefType=new i("ungroup-by-ref-type",{fontCharacter:"\\eb98"}),i.account=new i("account",{fontCharacter:"\\eb99"}),i.bellDot=new i("bell-dot",{fontCharacter:"\\eb9a"}),i.debugConsole=new i("debug-console",{fontCharacter:"\\eb9b"}),i.library=new i("library",{fontCharacter:"\\eb9c"}),i.output=new i("output",{fontCharacter:"\\eb9d"}),i.runAll=new i("run-all",{fontCharacter:"\\eb9e"}),i.syncIgnored=new i("sync-ignored",{fontCharacter:"\\eb9f"}),i.pinned=new i("pinned",{fontCharacter:"\\eba0"}),i.githubInverted=new i("github-inverted",{fontCharacter:"\\eba1"}),i.debugAlt=new i("debug-alt",{fontCharacter:"\\eb91"}),i.serverProcess=new i("server-process",{fontCharacter:"\\eba2"}),i.serverEnvironment=new i("server-environment",{fontCharacter:"\\eba3"}),i.pass=new i("pass",{fontCharacter:"\\eba4"}),i.stopCircle=new i("stop-circle",{fontCharacter:"\\eba5"}),i.playCircle=new i("play-circle",{fontCharacter:"\\eba6"}),i.record=new i("record",{fontCharacter:"\\eba7"}),i.debugAltSmall=new i("debug-alt-small",{fontCharacter:"\\eba8"}),i.vmConnect=new i("vm-connect",{fontCharacter:"\\eba9"}),i.cloud=new i("cloud",{fontCharacter:"\\ebaa"}),i.merge=new i("merge",{fontCharacter:"\\ebab"}),i.exportIcon=new i("export",{fontCharacter:"\\ebac"}),i.graphLeft=new i("graph-left",{fontCharacter:"\\ebad"}),i.magnet=new i("magnet",{fontCharacter:"\\ebae"}),i.notebook=new i("notebook",{fontCharacter:"\\ebaf"}),i.redo=new i("redo",{fontCharacter:"\\ebb0"}),i.checkAll=new i("check-all",{fontCharacter:"\\ebb1"}),i.pinnedDirty=new i("pinned-dirty",{fontCharacter:"\\ebb2"}),i.passFilled=new i("pass-filled",{fontCharacter:"\\ebb3"}),i.circleLargeFilled=new i("circle-large-filled",{fontCharacter:"\\ebb4"}),i.circleLarge=new i("circle-large",{fontCharacter:"\\ebb5"}),i.circleLargeOutline=new i("circle-large-outline",i.circleLarge.definition),i.combine=new i("combine",{fontCharacter:"\\ebb6"}),i.gather=new i("gather",{fontCharacter:"\\ebb6"}),i.table=new i("table",{fontCharacter:"\\ebb7"}),i.variableGroup=new i("variable-group",{fontCharacter:"\\ebb8"}),i.typeHierarchy=new i("type-hierarchy",{fontCharacter:"\\ebb9"}),i.typeHierarchySub=new i("type-hierarchy-sub",{fontCharacter:"\\ebba"}),i.typeHierarchySuper=new i("type-hierarchy-super",{fontCharacter:"\\ebbb"}),i.gitPullRequestCreate=new i("git-pull-request-create",{fontCharacter:"\\ebbc"}),i.runAbove=new i("run-above",{fontCharacter:"\\ebbd"}),i.runBelow=new i("run-below",{fontCharacter:"\\ebbe"}),i.notebookTemplate=new i("notebook-template",{fontCharacter:"\\ebbf"}),i.debugRerun=new i("debug-rerun",{fontCharacter:"\\ebc0"}),i.workspaceTrusted=new i("workspace-trusted",{fontCharacter:"\\ebc1"}),i.workspaceUntrusted=new i("workspace-untrusted",{fontCharacter:"\\ebc2"}),i.workspaceUnspecified=new i("workspace-unspecified",{fontCharacter:"\\ebc3"}),i.terminalCmd=new i("terminal-cmd",{fontCharacter:"\\ebc4"}),i.terminalDebian=new i("terminal-debian",{fontCharacter:"\\ebc5"}),i.terminalLinux=new i("terminal-linux",{fontCharacter:"\\ebc6"}),i.terminalPowershell=new i("terminal-powershell",{fontCharacter:"\\ebc7"}),i.terminalTmux=new i("terminal-tmux",{fontCharacter:"\\ebc8"}),i.terminalUbuntu=new i("terminal-ubuntu",{fontCharacter:"\\ebc9"}),i.terminalBash=new i("terminal-bash",{fontCharacter:"\\ebca"}),i.arrowSwap=new i("arrow-swap",{fontCharacter:"\\ebcb"}),i.copy=new i("copy",{fontCharacter:"\\ebcc"}),i.personAdd=new i("person-add",{fontCharacter:"\\ebcd"}),i.filterFilled=new i("filter-filled",{fontCharacter:"\\ebce"}),i.wand=new i("wand",{fontCharacter:"\\ebcf"}),i.debugLineByLine=new i("debug-line-by-line",{fontCharacter:"\\ebd0"}),i.inspect=new i("inspect",{fontCharacter:"\\ebd1"}),i.layers=new i("layers",{fontCharacter:"\\ebd2"}),i.layersDot=new i("layers-dot",{fontCharacter:"\\ebd3"}),i.layersActive=new i("layers-active",{fontCharacter:"\\ebd4"}),i.compass=new i("compass",{fontCharacter:"\\ebd5"}),i.compassDot=new i("compass-dot",{fontCharacter:"\\ebd6"}),i.compassActive=new i("compass-active",{fontCharacter:"\\ebd7"}),i.azure=new i("azure",{fontCharacter:"\\ebd8"}),i.issueDraft=new i("issue-draft",{fontCharacter:"\\ebd9"}),i.gitPullRequestClosed=new i("git-pull-request-closed",{fontCharacter:"\\ebda"}),i.gitPullRequestDraft=new i("git-pull-request-draft",{fontCharacter:"\\ebdb"}),i.debugAll=new i("debug-all",{fontCharacter:"\\ebdc"}),i.debugCoverage=new i("debug-coverage",{fontCharacter:"\\ebdd"}),i.runErrors=new i("run-errors",{fontCharacter:"\\ebde"}),i.folderLibrary=new i("folder-library",{fontCharacter:"\\ebdf"}),i.debugContinueSmall=new i("debug-continue-small",{fontCharacter:"\\ebe0"}),i.beakerStop=new i("beaker-stop",{fontCharacter:"\\ebe1"}),i.graphLine=new i("graph-line",{fontCharacter:"\\ebe2"}),i.graphScatter=new i("graph-scatter",{fontCharacter:"\\ebe3"}),i.pieChart=new i("pie-chart",{fontCharacter:"\\ebe4"}),i.bracket=new i("bracket",i.json.definition),i.bracketDot=new i("bracket-dot",{fontCharacter:"\\ebe5"}),i.bracketError=new i("bracket-error",{fontCharacter:"\\ebe6"}),i.lockSmall=new i("lock-small",{fontCharacter:"\\ebe7"}),i.azureDevops=new i("azure-devops",{fontCharacter:"\\ebe8"}),i.verifiedFilled=new i("verified-filled",{fontCharacter:"\\ebe9"}),i.newLine=new i("newline",{fontCharacter:"\\ebea"}),i.layout=new i("layout",{fontCharacter:"\\ebeb"}),i.layoutActivitybarLeft=new i("layout-activitybar-left",{fontCharacter:"\\ebec"}),i.layoutActivitybarRight=new i("layout-activitybar-right",{fontCharacter:"\\ebed"}),i.layoutPanelLeft=new i("layout-panel-left",{fontCharacter:"\\ebee"}),i.layoutPanelCenter=new i("layout-panel-center",{fontCharacter:"\\ebef"}),i.layoutPanelJustify=new i("layout-panel-justify",{fontCharacter:"\\ebf0"}),i.layoutPanelRight=new i("layout-panel-right",{fontCharacter:"\\ebf1"}),i.layoutPanel=new i("layout-panel",{fontCharacter:"\\ebf2"}),i.layoutSidebarLeft=new i("layout-sidebar-left",{fontCharacter:"\\ebf3"}),i.layoutSidebarRight=new i("layout-sidebar-right",{fontCharacter:"\\ebf4"}),i.layoutStatusbar=new i("layout-statusbar",{fontCharacter:"\\ebf5"}),i.layoutMenubar=new i("layout-menubar",{fontCharacter:"\\ebf6"}),i.layoutCentered=new i("layout-centered",{fontCharacter:"\\ebf7"}),i.layoutSidebarRightOff=new i("layout-sidebar-right-off",{fontCharacter:"\\ec00"}),i.layoutPanelOff=new i("layout-panel-off",{fontCharacter:"\\ec01"}),i.layoutSidebarLeftOff=new i("layout-sidebar-left-off",{fontCharacter:"\\ec02"}),i.target=new i("target",{fontCharacter:"\\ebf8"}),i.indent=new i("indent",{fontCharacter:"\\ebf9"}),i.recordSmall=new i("record-small",{fontCharacter:"\\ebfa"}),i.errorSmall=new i("error-small",{fontCharacter:"\\ebfb"}),i.terminalDecorationError=new i("terminal-decoration-error",i.errorSmall.definition),i.arrowCircleDown=new i("arrow-circle-down",{fontCharacter:"\\ebfc"}),i.arrowCircleLeft=new i("arrow-circle-left",{fontCharacter:"\\ebfd"}),i.arrowCircleRight=new i("arrow-circle-right",{fontCharacter:"\\ebfe"}),i.arrowCircleUp=new i("arrow-circle-up",{fontCharacter:"\\ebff"}),i.heartFilled=new i("heart-filled",{fontCharacter:"\\ec04"}),i.map=new i("map",{fontCharacter:"\\ec05"}),i.mapFilled=new i("map-filled",{fontCharacter:"\\ec06"}),i.circleSmall=new i("circle-small",{fontCharacter:"\\ec07"}),i.bellSlash=new i("bell-slash",{fontCharacter:"\\ec08"}),i.bellSlashDot=new i("bell-slash-dot",{fontCharacter:"\\ec09"}),i.commentUnresolved=new i("comment-unresolved",{fontCharacter:"\\ec0a"}),i.gitPullRequestGoToChanges=new i("git-pull-request-go-to-changes",{fontCharacter:"\\ec0b"}),i.gitPullRequestNewChanges=new i("git-pull-request-new-changes",{fontCharacter:"\\ec0c"}),i.dialogError=new i("dialog-error",i.error.definition),i.dialogWarning=new i("dialog-warning",i.warning.definition),i.dialogInfo=new i("dialog-info",i.info.definition),i.dialogClose=new i("dialog-close",i.close.definition),i.treeItemExpanded=new i("tree-item-expanded",i.chevronDown.definition),i.treeFilterOnTypeOn=new i("tree-filter-on-type-on",i.listFilter.definition),i.treeFilterOnTypeOff=new i("tree-filter-on-type-off",i.listSelection.definition),i.treeFilterClear=new i("tree-filter-clear",i.close.definition),i.treeItemLoading=new i("tree-item-loading",i.loading.definition),i.menuSelection=new i("menu-selection",i.check.definition),i.menuSubmenu=new i("menu-submenu",i.chevronRight.definition),i.menuBarMore=new i("menubar-more",i.more.definition),i.scrollbarButtonLeft=new i("scrollbar-button-left",i.triangleLeft.definition),i.scrollbarButtonRight=new i("scrollbar-button-right",i.triangleRight.definition),i.scrollbarButtonUp=new i("scrollbar-button-up",i.triangleUp.definition),i.scrollbarButtonDown=new i("scrollbar-button-down",i.triangleDown.definition),i.toolBarMore=new i("toolbar-more",i.more.definition),i.quickInputBack=new i("quick-input-back",i.arrowLeft.definition);function M(_,w){const g=["codicon","codicon-"+_];return w&&g.push("codicon-modifier-"+w),g}t.getClassNamesArray=M;var O;(function(_){_.iconNameSegment="[A-Za-z0-9]+",_.iconNameExpression="[A-Za-z0-9-]+",_.iconModifierExpression="~[A-Za-z]+",_.iconNameCharacter="[A-Za-z0-9~-]";const w=new RegExp(`^(${_.iconNameExpression})(${_.iconModifierExpression})?$`);function g(F){if(F instanceof i)return["codicon","codicon-"+F.id];const l=w.exec(F.id);if(!l)return g(i.error);const[,s,e]=l,p=["codicon","codicon-"+s];return e&&p.push("codicon-modifier-"+e.substr(1)),p}_.asClassNameArray=g;function d(F){return g(F).join(" ")}_.asClassName=d;function f(F){return"."+g(F).join(".")}_.asCSSSelector=f})(O=t.CSSIcon||(t.CSSIcon={}))}),define(me[69],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SetMap=t.diffMaps=t.diffSets=t.groupBy=void 0;function E(_,w){const g=Object.create(null);for(const d of _){const f=w(d);let F=g[f];F||(F=g[f]=[]),F.push(d)}return g}t.groupBy=E;function i(_,w){const g=[],d=[];for(const f of _)w.has(f)||g.push(f);for(const f of w)_.has(f)||d.push(f);return{removed:g,added:d}}t.diffSets=i;function M(_,w){const g=[],d=[];for(const[f,F]of _)w.has(f)||g.push(F);for(const[f,F]of w)_.has(f)||d.push(F);return{removed:g,added:d}}t.diffMaps=M;class O{constructor(){this.map=new Map}add(w,g){let d=this.map.get(w);d||(d=new Set,this.map.set(w,d)),d.add(g)}delete(w,g){const d=this.map.get(w);!d||(d.delete(g),d.size===0&&this.map.delete(w))}forEach(w,g){const d=this.map.get(w);!d||d.forEach(g)}}t.SetMap=O}),define(me[24],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Color=t.HSVA=t.HSLA=t.RGBA=void 0;function E(w,g){const d=Math.pow(10,g);return Math.round(w*d)/d}class i{constructor(g,d,f,F=1){this._rgbaBrand=void 0,this.r=Math.min(255,Math.max(0,g))|0,this.g=Math.min(255,Math.max(0,d))|0,this.b=Math.min(255,Math.max(0,f))|0,this.a=E(Math.max(Math.min(1,F),0),3)}static equals(g,d){return g.r===d.r&&g.g===d.g&&g.b===d.b&&g.a===d.a}}t.RGBA=i;class M{constructor(g,d,f,F){this._hslaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,d),0),3),this.l=E(Math.max(Math.min(1,f),0),3),this.a=E(Math.max(Math.min(1,F),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.l===d.l&&g.a===d.a}static fromRGBA(g){const d=g.r/255,f=g.g/255,F=g.b/255,l=g.a,s=Math.max(d,f,F),e=Math.min(d,f,F);let p=0,v=0;const D=(e+s)/2,y=s-e;if(y>0){switch(v=Math.min(D<=.5?y/(2*D):y/(2-2*D),1),s){case d:p=(f-F)/y+(f<F?6:0);break;case f:p=(F-d)/y+2;break;case F:p=(d-f)/y+4;break}p*=60,p=Math.round(p)}return new M(p,v,D,l)}static _hue2rgb(g,d,f){return f<0&&(f+=1),f>1&&(f-=1),f<1/6?g+(d-g)*6*f:f<1/2?d:f<2/3?g+(d-g)*(2/3-f)*6:g}static toRGBA(g){const d=g.h/360,{s:f,l:F,a:l}=g;let s,e,p;if(f===0)s=e=p=F;else{const v=F<.5?F*(1+f):F+f-F*f,D=2*F-v;s=M._hue2rgb(D,v,d+1/3),e=M._hue2rgb(D,v,d),p=M._hue2rgb(D,v,d-1/3)}return new i(Math.round(s*255),Math.round(e*255),Math.round(p*255),l)}}t.HSLA=M;class O{constructor(g,d,f,F){this._hsvaBrand=void 0,this.h=Math.max(Math.min(360,g),0)|0,this.s=E(Math.max(Math.min(1,d),0),3),this.v=E(Math.max(Math.min(1,f),0),3),this.a=E(Math.max(Math.min(1,F),0),3)}static equals(g,d){return g.h===d.h&&g.s===d.s&&g.v===d.v&&g.a===d.a}static fromRGBA(g){const d=g.r/255,f=g.g/255,F=g.b/255,l=Math.max(d,f,F),s=Math.min(d,f,F),e=l-s,p=l===0?0:e/l;let v;return e===0?v=0:l===d?v=((f-F)/e%6+6)%6:l===f?v=(F-d)/e+2:v=(d-f)/e+4,new O(Math.round(v*60),p,l,g.a)}static toRGBA(g){const{h:d,s:f,v:F,a:l}=g,s=F*f,e=s*(1-Math.abs(d/60%2-1)),p=F-s;let[v,D,y]=[0,0,0];return d<60?(v=s,D=e):d<120?(v=e,D=s):d<180?(D=s,y=e):d<240?(D=e,y=s):d<300?(v=e,y=s):d<=360&&(v=s,y=e),v=Math.round((v+p)*255),D=Math.round((D+p)*255),y=Math.round((y+p)*255),new i(v,D,y,l)}}t.HSVA=O;class _{constructor(g){if(g)if(g instanceof i)this.rgba=g;else if(g instanceof M)this._hsla=g,this.rgba=M.toRGBA(g);else if(g instanceof O)this._hsva=g,this.rgba=O.toRGBA(g);else throw new Error("Invalid color ctor argument");else throw new Error("Color needs a value")}static fromHex(g){return _.Format.CSS.parseHex(g)||_.red}get hsla(){return this._hsla?this._hsla:M.fromRGBA(this.rgba)}get hsva(){return this._hsva?this._hsva:O.fromRGBA(this.rgba)}equals(g){return!!g&&i.equals(this.rgba,g.rgba)&&M.equals(this.hsla,g.hsla)&&O.equals(this.hsva,g.hsva)}getRelativeLuminance(){const g=_._relativeLuminanceForComponent(this.rgba.r),d=_._relativeLuminanceForComponent(this.rgba.g),f=_._relativeLuminanceForComponent(this.rgba.b),F=.2126*g+.7152*d+.0722*f;return E(F,4)}static _relativeLuminanceForComponent(g){const d=g/255;return d<=.03928?d/12.92:Math.pow((d+.055)/1.055,2.4)}getContrastRatio(g){const d=this.getRelativeLuminance(),f=g.getRelativeLuminance();return d>f?(d+.05)/(f+.05):(f+.05)/(d+.05)}isDarker(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3<128}isLighter(){return(this.rgba.r*299+this.rgba.g*587+this.rgba.b*114)/1e3>=128}isLighterThan(g){const d=this.getRelativeLuminance(),f=g.getRelativeLuminance();return d>f}isDarkerThan(g){const d=this.getRelativeLuminance(),f=g.getRelativeLuminance();return d<f}lighten(g){return new _(new M(this.hsla.h,this.hsla.s,this.hsla.l+this.hsla.l*g,this.hsla.a))}darken(g){return new _(new M(this.hsla.h,this.hsla.s,this.hsla.l-this.hsla.l*g,this.hsla.a))}transparent(g){const{r:d,g:f,b:F,a:l}=this.rgba;return new _(new i(d,f,F,l*g))}isTransparent(){return this.rgba.a===0}isOpaque(){return this.rgba.a===1}opposite(){return new _(new i(255-this.rgba.r,255-this.rgba.g,255-this.rgba.b,this.rgba.a))}blend(g){const d=g.rgba,f=this.rgba.a,F=d.a,l=f+F*(1-f);if(l<1e-6)return _.transparent;const s=this.rgba.r*f/l+d.r*F*(1-f)/l,e=this.rgba.g*f/l+d.g*F*(1-f)/l,p=this.rgba.b*f/l+d.b*F*(1-f)/l;return new _(new i(s,e,p,l))}makeOpaque(g){if(this.isOpaque()||g.rgba.a!==1)return this;const{r:d,g:f,b:F,a:l}=this.rgba;return new _(new i(g.rgba.r-l*(g.rgba.r-d),g.rgba.g-l*(g.rgba.g-f),g.rgba.b-l*(g.rgba.b-F),1))}flatten(...g){const d=g.reduceRight((f,F)=>_._flatten(F,f));return _._flatten(this,d)}static _flatten(g,d){const f=1-g.rgba.a;return new _(new i(f*d.rgba.r+g.rgba.a*g.rgba.r,f*d.rgba.g+g.rgba.a*g.rgba.g,f*d.rgba.b+g.rgba.a*g.rgba.b))}toString(){return this._toString||(this._toString=_.Format.CSS.format(this)),this._toString}static getLighterColor(g,d,f){if(g.isLighterThan(d))return g;f=f||.5;const F=g.getRelativeLuminance(),l=d.getRelativeLuminance();return f=f*(l-F)/l,g.lighten(f)}static getDarkerColor(g,d,f){if(g.isDarkerThan(d))return g;f=f||.5;const F=g.getRelativeLuminance(),l=d.getRelativeLuminance();return f=f*(F-l)/F,g.darken(f)}}t.Color=_,_.white=new _(new i(255,255,255,1)),_.black=new _(new i(0,0,0,1)),_.red=new _(new i(255,0,0,1)),_.blue=new _(new i(0,0,255,1)),_.green=new _(new i(0,255,0,1)),_.cyan=new _(new i(0,255,255,1)),_.lightgrey=new _(new i(211,211,211,1)),_.transparent=new _(new i(0,0,0,0)),function(w){let g;(function(d){let f;(function(F){function l(S){return S.rgba.a===1?`rgb(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b})`:w.Format.CSS.formatRGBA(S)}F.formatRGB=l;function s(S){return`rgba(${S.rgba.r}, ${S.rgba.g}, ${S.rgba.b}, ${+S.rgba.a.toFixed(2)})`}F.formatRGBA=s;function e(S){return S.hsla.a===1?`hsl(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%)`:w.Format.CSS.formatHSLA(S)}F.formatHSL=e;function p(S){return`hsla(${S.hsla.h}, ${(S.hsla.s*100).toFixed(2)}%, ${(S.hsla.l*100).toFixed(2)}%, ${S.hsla.a.toFixed(2)})`}F.formatHSLA=p;function v(S){const A=S.toString(16);return A.length!==2?"0"+A:A}function D(S){return`#${v(S.rgba.r)}${v(S.rgba.g)}${v(S.rgba.b)}`}F.formatHex=D;function y(S,A=!1){return A&&S.rgba.a===1?w.Format.CSS.formatHex(S):`#${v(S.rgba.r)}${v(S.rgba.g)}${v(S.rgba.b)}${v(Math.round(S.rgba.a*255))}`}F.formatHexA=y;function o(S){return S.isOpaque()?w.Format.CSS.formatHex(S):w.Format.CSS.formatRGBA(S)}F.format=o;function c(S){const A=S.length;if(A===0||S.charCodeAt(0)!==35)return null;if(A===7){const C=16*b(S.charCodeAt(1))+b(S.charCodeAt(2)),r=16*b(S.charCodeAt(3))+b(S.charCodeAt(4)),n=16*b(S.charCodeAt(5))+b(S.charCodeAt(6));return new w(new i(C,r,n,1))}if(A===9){const C=16*b(S.charCodeAt(1))+b(S.charCodeAt(2)),r=16*b(S.charCodeAt(3))+b(S.charCodeAt(4)),n=16*b(S.charCodeAt(5))+b(S.charCodeAt(6)),a=16*b(S.charCodeAt(7))+b(S.charCodeAt(8));return new w(new i(C,r,n,a/255))}if(A===4){const C=b(S.charCodeAt(1)),r=b(S.charCodeAt(2)),n=b(S.charCodeAt(3));return new w(new i(16*C+C,16*r+r,16*n+n))}if(A===5){const C=b(S.charCodeAt(1)),r=b(S.charCodeAt(2)),n=b(S.charCodeAt(3)),a=b(S.charCodeAt(4));return new w(new i(16*C+C,16*r+r,16*n+n,(16*a+a)/255))}return null}F.parseHex=c;function b(S){switch(S){case 48:return 0;case 49:return 1;case 50:return 2;case 51:return 3;case 52:return 4;case 53:return 5;case 54:return 6;case 55:return 7;case 56:return 8;case 57:return 9;case 97:return 10;case 65:return 10;case 98:return 11;case 66:return 11;case 99:return 12;case 67:return 12;case 100:return 13;case 68:return 13;case 101:return 14;case 69:return 14;case 102:return 15;case 70:return 15}return 0}})(f=d.CSS||(d.CSS={}))})(g=w.Format||(w.Format={}))}(_=t.Color||(t.Color={}))}),define(me[25],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function E(_){return(w,g,d)=>{let f=null,F=null;if(typeof d.value=="function"?(f="value",F=d.value):typeof d.get=="function"&&(f="get",F=d.get),!F)throw new Error("not supported");d[f]=_(F,g)}}t.createDecorator=E;function i(_,w,g){let d=null,f=null;if(typeof g.value=="function"?(d="value",f=g.value,f.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof g.get=="function"&&(d="get",f=g.get),!f)throw new Error("not supported");const F=`$memoize$${w}`;g[d]=function(...l){return this.hasOwnProperty(F)||Object.defineProperty(this,F,{configurable:!1,enumerable:!1,writable:!1,value:f.apply(this,l)}),this[F]}}t.memoize=i;function M(_,w,g){return E((d,f)=>{const F=`$debounce$${f}`,l=`$debounce$result$${f}`;return function(...s){this[l]||(this[l]=g?g():void 0),clearTimeout(this[F]),w&&(this[l]=w(this[l],...s),s=[this[l]]),this[F]=setTimeout(()=>{d.apply(this,s),this[l]=g?g():void 0},_)}})}t.debounce=M;function O(_,w,g){return E((d,f)=>{const F=`$throttle$timer$${f}`,l=`$throttle$result$${f}`,s=`$throttle$lastRun$${f}`,e=`$throttle$pending$${f}`;return function(...p){if(this[l]||(this[l]=g?g():void 0),(this[s]===null||this[s]===void 0)&&(this[s]=-Number.MAX_VALUE),w&&(this[l]=w(this[l],...p)),this[e])return;const v=this[s]+_;v<=Date.now()?(this[s]=Date.now(),d.apply(this,[this[l]]),this[l]=g?g():void 0):(this[e]=!0,this[F]=setTimeout(()=>{this[e]=!1,this[s]=Date.now(),d.apply(this,[this[l]]),this[l]=g?g():void 0},v-Date.now()))}})}t.throttle=O}),define(me[70],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiffChange=void 0;class E{constructor(M,O,_,w){this.originalStart=M,this.originalLength=O,this.modifiedStart=_,this.modifiedLength=w}getOriginalEnd(){return this.originalStart+this.originalLength}getModifiedEnd(){return this.modifiedStart+this.modifiedLength}}t.DiffChange=E}),define(me[13],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BugIndicatingError=t.ErrorNoTelemetry=t.ExpectedError=t.NotSupportedError=t.NotImplementedError=t.getErrorMessage=t.disposed=t.readonly=t.illegalState=t.illegalArgument=t.canceled=t.CancellationError=t.isCancellationError=t.transformErrorForSerialization=t.onUnexpectedExternalError=t.onUnexpectedError=t.setUnexpectedErrorHandler=t.errorHandler=t.ErrorHandler=void 0;class E{constructor(){this.listeners=[],this.unexpectedErrorHandler=function(S){setTimeout(()=>{throw S.stack?o.isErrorNoTelemetry(S)?new o(S.message+`

`+S.stack):new Error(S.message+`

`+S.stack):S},0)}}addListener(S){return this.listeners.push(S),()=>{this._removeListener(S)}}emit(S){this.listeners.forEach(A=>{A(S)})}_removeListener(S){this.listeners.splice(this.listeners.indexOf(S),1)}setUnexpectedErrorHandler(S){this.unexpectedErrorHandler=S}getUnexpectedErrorHandler(){return this.unexpectedErrorHandler}onUnexpectedError(S){this.unexpectedErrorHandler(S),this.emit(S)}onUnexpectedExternalError(S){this.unexpectedErrorHandler(S)}}t.ErrorHandler=E,t.errorHandler=new E;function i(b){t.errorHandler.setUnexpectedErrorHandler(b)}t.setUnexpectedErrorHandler=i;function M(b){g(b)||t.errorHandler.onUnexpectedError(b)}t.onUnexpectedError=M;function O(b){g(b)||t.errorHandler.onUnexpectedExternalError(b)}t.onUnexpectedExternalError=O;function _(b){if(b instanceof Error){const{name:S,message:A}=b,C=b.stacktrace||b.stack;return{$isError:!0,name:S,message:A,stack:C,noTelemetry:o.isErrorNoTelemetry(b)}}return b}t.transformErrorForSerialization=_;const w="Canceled";function g(b){return b instanceof d?!0:b instanceof Error&&b.name===w&&b.message===w}t.isCancellationError=g;class d extends Error{constructor(){super(w);this.name=this.message}}t.CancellationError=d;function f(){const b=new Error(w);return b.name=b.message,b}t.canceled=f;function F(b){return b?new Error(`Illegal argument: ${b}`):new Error("Illegal argument")}t.illegalArgument=F;function l(b){return b?new Error(`Illegal state: ${b}`):new Error("Illegal state")}t.illegalState=l;function s(b){return b?new Error(`readonly property '${b} cannot be changed'`):new Error("readonly property cannot be changed")}t.readonly=s;function e(b){const S=new Error(`${b} has been disposed`);return S.name="DISPOSED",S}t.disposed=e;function p(b){return b?b.message?b.message:b.stack?b.stack.split(`
`)[0]:String(b):"Error"}t.getErrorMessage=p;class v extends Error{constructor(S){super("NotImplemented");S&&(this.message=S)}}t.NotImplementedError=v;class D extends Error{constructor(S){super("NotSupported");S&&(this.message=S)}}t.NotSupportedError=D;class y extends Error{constructor(){super(...arguments);this.isExpected=!0}}t.ExpectedError=y;class o extends Error{constructor(S){super(S);this.name="ErrorNoTelemetry"}static fromError(S){if(S instanceof o)return S;const A=new o;return A.message=S.message,A.stack=S.stack,A}static isErrorNoTelemetry(S){return S.name==="ErrorNoTelemetry"}}t.ErrorNoTelemetry=o;class c extends Error{constructor(S){super(S||"An unexpected bug occurred.");Object.setPrototypeOf(this,c.prototype);debugger}}t.BugIndicatingError=c}),define(me[14],pe([1,0,13]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CallbackIterable=t.ArrayQueue=t.findMinBy=t.findLastMaxBy=t.findMaxBy=t.numberComparator=t.tieBreakComparators=t.compareBy=t.CompareResult=t.splice=t.insertInto=t.mapFind=t.getRandomElement=t.asArray=t.mapArrayOrNot=t.pushMany=t.pushToEnd=t.pushToStart=t.shuffle=t.arrayInsert=t.remove=t.insert=t.index=t.range=t.flatten=t.commonPrefixLength=t.lastOrDefault=t.firstOrDefault=t.lastIndex=t.findLast=t.uniqueFilter=t.distinct=t.isNonEmptyArray=t.isFalsyOrEmpty=t.move=t.coalesceInPlace=t.coalesce=t.topAsync=t.top=t.delta=t.sortedDiff=t.groupBy=t.quickSelect=t.findFirstInSorted=t.binarySearch2=t.binarySearch=t.removeFastWithoutKeepingOrder=t.equals=t.tail2=t.tail=void 0;function i(N,R=0){return N[N.length-(1+R)]}t.tail=i;function M(N){if(N.length===0)throw new Error("Invalid tail call");return[N.slice(0,N.length-1),N[N.length-1]]}t.tail2=M;function O(N,R,z=(T,H)=>T===H){if(N===R)return!0;if(!N||!R||N.length!==R.length)return!1;for(let T=0,H=N.length;T<H;T++)if(!z(N[T],R[T]))return!1;return!0}t.equals=O;function _(N,R){const z=N.length-1;R<z&&(N[R]=N[z]),N.pop()}t.removeFastWithoutKeepingOrder=_;function w(N,R,z){return g(N.length,T=>z(N[T],R))}t.binarySearch=w;function g(N,R){let z=0,T=N-1;for(;z<=T;){const H=(z+T)/2|0,k=R(H);if(k<0)z=H+1;else if(k>0)T=H-1;else return H}return-(z+1)}t.binarySearch2=g;function d(N,R){let z=0,T=N.length;if(T===0)return 0;for(;z<T;){const H=Math.floor((z+T)/2);R(N[H])?T=H:z=H+1}return z}t.findFirstInSorted=d;function f(N,R,z){if(N=N|0,N>=R.length)throw new TypeError("invalid index");const T=R[Math.floor(R.length*Math.random())],H=[],k=[],P=[];for(const x of R){const J=z(x,T);J<0?H.push(x):J>0?k.push(x):P.push(x)}return N<H.length?f(N,H,z):N<H.length+P.length?P[0]:f(N-(H.length+P.length),k,z)}t.quickSelect=f;function F(N,R){const z=[];let T;for(const H of N.slice(0).sort(R))!T||R(T[0],H)!==0?(T=[H],z.push(T)):T.push(H);return z}t.groupBy=F;function l(N,R,z){const T=[];function H(x,J,he){if(J===0&&he.length===0)return;const de=T[T.length-1];de&&de.start+de.deleteCount===x?(de.deleteCount+=J,de.toInsert.push(...he)):T.push({start:x,deleteCount:J,toInsert:he})}let k=0,P=0;for(;;){if(k===N.length){H(k,0,R.slice(P));break}if(P===R.length){H(k,N.length-k,[]);break}const x=N[k],J=R[P],he=z(x,J);he===0?(k+=1,P+=1):he<0?(H(k,1,[]),k+=1):he>0&&(H(k,0,[J]),P+=1)}return T}t.sortedDiff=l;function s(N,R,z){const T=l(N,R,z),H=[],k=[];for(const P of T)H.push(...N.slice(P.start,P.start+P.deleteCount)),k.push(...P.toInsert);return{removed:H,added:k}}t.delta=s;function e(N,R,z){if(z===0)return[];const T=N.slice(0,z).sort(R);return v(N,R,T,z,N.length),T}t.top=e;function p(N,R,z,T,H){return z===0?Promise.resolve([]):new Promise((k,P)=>{(async()=>{const x=N.length,J=N.slice(0,z).sort(R);for(let he=z,de=Math.min(z+T,x);he<x;he=de,de=Math.min(de+T,x)){if(he>z&&await new Promise(Ee=>setTimeout(Ee)),H&&H.isCancellationRequested)throw new E.CancellationError;v(N,R,J,he,de)}return J})().then(k,P)})}t.topAsync=p;function v(N,R,z,T,H){for(const k=z.length;T<H;T++){const P=N[T];if(R(P,z[k-1])<0){z.pop();const x=d(z,J=>R(P,J)<0);z.splice(x,0,P)}}}function D(N){return N.filter(R=>!!R)}t.coalesce=D;function y(N){let R=0;for(let z=0;z<N.length;z++)N[z]&&(N[R]=N[z],R+=1);N.length=R}t.coalesceInPlace=y;function o(N,R,z){N.splice(z,0,N.splice(R,1)[0])}t.move=o;function c(N){return!Array.isArray(N)||N.length===0}t.isFalsyOrEmpty=c;function b(N){return Array.isArray(N)&&N.length>0}t.isNonEmptyArray=b;function S(N,R=z=>z){const z=new Set;return N.filter(T=>{const H=R(T);return z.has(H)?!1:(z.add(H),!0)})}t.distinct=S;function A(N){const R=new Set;return z=>{const T=N(z);return R.has(T)?!1:(R.add(T),!0)}}t.uniqueFilter=A;function C(N,R){const z=r(N,R);if(z!==-1)return N[z]}t.findLast=C;function r(N,R){for(let z=N.length-1;z>=0;z--){const T=N[z];if(R(T))return z}return-1}t.lastIndex=r;function n(N,R){return N.length>0?N[0]:R}t.firstOrDefault=n;function a(N,R){return N.length>0?N[N.length-1]:R}t.lastOrDefault=a;function u(N,R,z=(T,H)=>T===H){let T=0;for(let H=0,k=Math.min(N.length,R.length);H<k&&z(N[H],R[H]);H++)T++;return T}t.commonPrefixLength=u;function m(N){return[].concat(...N)}t.flatten=m;function W(N,R){let z=typeof R=="number"?N:0;typeof R=="number"?z=N:(z=0,R=N);const T=[];if(z<=R)for(let H=z;H<R;H++)T.push(H);else for(let H=z;H>R;H--)T.push(H);return T}t.range=W;function V(N,R,z){return N.reduce((T,H)=>(T[R(H)]=z?z(H):H,T),Object.create(null))}t.index=V;function ne(N,R){return N.push(R),()=>re(N,R)}t.insert=ne;function re(N,R){const z=N.indexOf(R);if(z>-1)return N.splice(z,1),R}t.remove=re;function we(N,R,z){const T=N.slice(0,R),H=N.slice(R);return T.concat(z,H)}t.arrayInsert=we;function ae(N,R){let z;if(typeof R=="number"){let T=R;z=()=>{const H=Math.sin(T++)*179426549;return H-Math.floor(H)}}else z=Math.random;for(let T=N.length-1;T>0;T-=1){const H=Math.floor(z()*(T+1)),k=N[T];N[T]=N[H],N[H]=k}}t.shuffle=ae;function ve(N,R){const z=N.indexOf(R);z>-1&&(N.splice(z,1),N.unshift(R))}t.pushToStart=ve;function ue(N,R){const z=N.indexOf(R);z>-1&&(N.splice(z,1),N.push(R))}t.pushToEnd=ue;function ge(N,R){for(const z of R)N.push(z)}t.pushMany=ge;function ye(N,R){return Array.isArray(N)?N.map(R):R(N)}t.mapArrayOrNot=ye;function ee(N){return Array.isArray(N)?N:[N]}t.asArray=ee;function fe(N){return N[Math.floor(Math.random()*N.length)]}t.getRandomElement=fe;function te(N,R){for(const z of N){const T=R(z);if(T!==void 0)return T}}t.mapFind=te;function X(N,R,z){const T=ie(N,R),H=N.length,k=z.length;N.length=H+k;for(let P=H-1;P>=T;P--)N[P+k]=N[P];for(let P=0;P<k;P++)N[P+T]=z[P]}t.insertInto=X;function se(N,R,z,T){const H=ie(N,R),k=N.splice(H,z);return X(N,H,T),k}t.splice=se;function ie(N,R){return R<0?Math.max(R+N.length,0):Math.min(R,N.length)}var L;(function(N){function R(H){return H<0}N.isLessThan=R;function z(H){return H>0}N.isGreaterThan=z;function T(H){return H===0}N.isNeitherLessOrGreaterThan=T,N.greaterThan=1,N.lessThan=-1,N.neitherLessOrGreaterThan=0})(L=t.CompareResult||(t.CompareResult={}));function $(N,R){return(z,T)=>R(N(z),N(T))}t.compareBy=$;function G(...N){return(R,z)=>{for(const T of N){const H=T(R,z);if(!L.isNeitherLessOrGreaterThan(H))return H}return L.neitherLessOrGreaterThan}}t.tieBreakComparators=G;const B=(N,R)=>N-R;t.numberComparator=B;function h(N,R){if(N.length===0)return;let z=N[0];for(let T=1;T<N.length;T++){const H=N[T];R(H,z)>0&&(z=H)}return z}t.findMaxBy=h;function I(N,R){if(N.length===0)return;let z=N[0];for(let T=1;T<N.length;T++){const H=N[T];R(H,z)>=0&&(z=H)}return z}t.findLastMaxBy=I;function U(N,R){return h(N,(z,T)=>-R(z,T))}t.findMinBy=U;class K{constructor(R){this.items=R,this.firstIdx=0,this.lastIdx=this.items.length-1}get length(){return this.lastIdx-this.firstIdx+1}takeWhile(R){let z=this.firstIdx;for(;z<this.items.length&&R(this.items[z]);)z++;const T=z===this.firstIdx?null:this.items.slice(this.firstIdx,z);return this.firstIdx=z,T}takeFromEndWhile(R){let z=this.lastIdx;for(;z>=0&&R(this.items[z]);)z--;const T=z===this.lastIdx?null:this.items.slice(z+1,this.lastIdx+1);return this.lastIdx=z,T}peek(){if(this.length!==0)return this.items[this.firstIdx]}peekLast(){if(this.length!==0)return this.items[this.lastIdx]}dequeue(){const R=this.items[this.firstIdx];return this.firstIdx++,R}removeLast(){const R=this.items[this.lastIdx];return this.lastIdx--,R}takeCount(R){const z=this.items.slice(this.firstIdx,this.firstIdx+R);return this.firstIdx+=R,z}}t.ArrayQueue=K;class Q{constructor(R){this.iterate=R}forEach(R){this.iterate(z=>(R(z),!0))}toArray(){const R=[];return this.iterate(z=>(R.push(z),!0)),R}filter(R){return new Q(z=>this.iterate(T=>R(T)?z(T):!0))}map(R){return new Q(z=>this.iterate(T=>z(R(T))))}some(R){let z=!1;return this.iterate(T=>(z=R(T),!z)),z}findFirst(R){let z;return this.iterate(T=>R(T)?(z=T,!1):!0),z}findLast(R){let z;return this.iterate(T=>(R(T)&&(z=T),!0)),z}findLastMaxBy(R){let z,T=!0;return this.iterate(H=>((T||L.isGreaterThan(R(H,z)))&&(T=!1,z=H),!0)),z}}t.CallbackIterable=Q,Q.empty=new Q(N=>{})}),define(me[42],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.once=void 0;function E(i){const M=this;let O=!1,_;return function(){return O||(O=!0,_=i.apply(M,arguments)),_}}t.once=E}),define(me[71],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.defaultGenerator=t.IdGenerator=void 0;class E{constructor(M){this._prefix=M,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}t.IdGenerator=E,t.defaultGenerator=new E("id#")}),define(me[26],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Iterable=void 0;var E;(function(i){function M(A){return A&&typeof A=="object"&&typeof A[Symbol.iterator]=="function"}i.is=M;const O=Object.freeze([]);function _(){return O}i.empty=_;function*w(A){yield A}i.single=w;function g(A){return A||O}i.from=g;function d(A){return!A||A[Symbol.iterator]().next().done===!0}i.isEmpty=d;function f(A){return A[Symbol.iterator]().next().value}i.first=f;function F(A,C){for(const r of A)if(C(r))return!0;return!1}i.some=F;function l(A,C){for(const r of A)if(C(r))return r}i.find=l;function*s(A,C){for(const r of A)C(r)&&(yield r)}i.filter=s;function*e(A,C){let r=0;for(const n of A)yield C(n,r++)}i.map=e;function*p(...A){for(const C of A)for(const r of C)yield r}i.concat=p;function*v(A){for(const C of A)for(const r of C)yield r}i.concatNested=v;function D(A,C,r){let n=r;for(const a of A)n=C(n,a);return n}i.reduce=D;function y(A,C){let r=0;for(const n of A)C(n,r++)}i.forEach=y;function*o(A,C,r=A.length){for(C<0&&(C+=A.length),r<0?r+=A.length:r>A.length&&(r=A.length);C<r;C++)yield A[C]}i.slice=o;function c(A,C=Number.POSITIVE_INFINITY){const r=[];if(C===0)return[r,A];const n=A[Symbol.iterator]();for(let a=0;a<C;a++){const u=n.next();if(u.done)return[r,i.empty()];r.push(u.value)}return[r,{[Symbol.iterator](){return n}}]}i.consume=c;function b(A){return c(A)[0]}i.collect=b;function S(A,C,r=(n,a)=>n===a){const n=A[Symbol.iterator](),a=C[Symbol.iterator]();for(;;){const u=n.next(),m=a.next();if(u.done!==m.done)return!1;if(u.done)return!0;if(!r(u.value,m.value))return!1}}i.equals=S})(E=t.Iterable||(t.Iterable={}))}),define(me[43],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.KeyChord=t.KeyMod=t.KeyCodeUtils=t.IMMUTABLE_KEY_CODE_TO_CODE=t.IMMUTABLE_CODE_TO_KEY_CODE=t.ScanCodeUtils=t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE=t.EVENT_KEY_CODE_MAP=t.ScanCode=t.KeyCode=void 0;var E;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.Unknown=0]="Unknown",e[e.Backspace=1]="Backspace",e[e.Tab=2]="Tab",e[e.Enter=3]="Enter",e[e.Shift=4]="Shift",e[e.Ctrl=5]="Ctrl",e[e.Alt=6]="Alt",e[e.PauseBreak=7]="PauseBreak",e[e.CapsLock=8]="CapsLock",e[e.Escape=9]="Escape",e[e.Space=10]="Space",e[e.PageUp=11]="PageUp",e[e.PageDown=12]="PageDown",e[e.End=13]="End",e[e.Home=14]="Home",e[e.LeftArrow=15]="LeftArrow",e[e.UpArrow=16]="UpArrow",e[e.RightArrow=17]="RightArrow",e[e.DownArrow=18]="DownArrow",e[e.Insert=19]="Insert",e[e.Delete=20]="Delete",e[e.Digit0=21]="Digit0",e[e.Digit1=22]="Digit1",e[e.Digit2=23]="Digit2",e[e.Digit3=24]="Digit3",e[e.Digit4=25]="Digit4",e[e.Digit5=26]="Digit5",e[e.Digit6=27]="Digit6",e[e.Digit7=28]="Digit7",e[e.Digit8=29]="Digit8",e[e.Digit9=30]="Digit9",e[e.KeyA=31]="KeyA",e[e.KeyB=32]="KeyB",e[e.KeyC=33]="KeyC",e[e.KeyD=34]="KeyD",e[e.KeyE=35]="KeyE",e[e.KeyF=36]="KeyF",e[e.KeyG=37]="KeyG",e[e.KeyH=38]="KeyH",e[e.KeyI=39]="KeyI",e[e.KeyJ=40]="KeyJ",e[e.KeyK=41]="KeyK",e[e.KeyL=42]="KeyL",e[e.KeyM=43]="KeyM",e[e.KeyN=44]="KeyN",e[e.KeyO=45]="KeyO",e[e.KeyP=46]="KeyP",e[e.KeyQ=47]="KeyQ",e[e.KeyR=48]="KeyR",e[e.KeyS=49]="KeyS",e[e.KeyT=50]="KeyT",e[e.KeyU=51]="KeyU",e[e.KeyV=52]="KeyV",e[e.KeyW=53]="KeyW",e[e.KeyX=54]="KeyX",e[e.KeyY=55]="KeyY",e[e.KeyZ=56]="KeyZ",e[e.Meta=57]="Meta",e[e.ContextMenu=58]="ContextMenu",e[e.F1=59]="F1",e[e.F2=60]="F2",e[e.F3=61]="F3",e[e.F4=62]="F4",e[e.F5=63]="F5",e[e.F6=64]="F6",e[e.F7=65]="F7",e[e.F8=66]="F8",e[e.F9=67]="F9",e[e.F10=68]="F10",e[e.F11=69]="F11",e[e.F12=70]="F12",e[e.F13=71]="F13",e[e.F14=72]="F14",e[e.F15=73]="F15",e[e.F16=74]="F16",e[e.F17=75]="F17",e[e.F18=76]="F18",e[e.F19=77]="F19",e[e.NumLock=78]="NumLock",e[e.ScrollLock=79]="ScrollLock",e[e.Semicolon=80]="Semicolon",e[e.Equal=81]="Equal",e[e.Comma=82]="Comma",e[e.Minus=83]="Minus",e[e.Period=84]="Period",e[e.Slash=85]="Slash",e[e.Backquote=86]="Backquote",e[e.BracketLeft=87]="BracketLeft",e[e.Backslash=88]="Backslash",e[e.BracketRight=89]="BracketRight",e[e.Quote=90]="Quote",e[e.OEM_8=91]="OEM_8",e[e.IntlBackslash=92]="IntlBackslash",e[e.Numpad0=93]="Numpad0",e[e.Numpad1=94]="Numpad1",e[e.Numpad2=95]="Numpad2",e[e.Numpad3=96]="Numpad3",e[e.Numpad4=97]="Numpad4",e[e.Numpad5=98]="Numpad5",e[e.Numpad6=99]="Numpad6",e[e.Numpad7=100]="Numpad7",e[e.Numpad8=101]="Numpad8",e[e.Numpad9=102]="Numpad9",e[e.NumpadMultiply=103]="NumpadMultiply",e[e.NumpadAdd=104]="NumpadAdd",e[e.NUMPAD_SEPARATOR=105]="NUMPAD_SEPARATOR",e[e.NumpadSubtract=106]="NumpadSubtract",e[e.NumpadDecimal=107]="NumpadDecimal",e[e.NumpadDivide=108]="NumpadDivide",e[e.KEY_IN_COMPOSITION=109]="KEY_IN_COMPOSITION",e[e.ABNT_C1=110]="ABNT_C1",e[e.ABNT_C2=111]="ABNT_C2",e[e.AudioVolumeMute=112]="AudioVolumeMute",e[e.AudioVolumeUp=113]="AudioVolumeUp",e[e.AudioVolumeDown=114]="AudioVolumeDown",e[e.BrowserSearch=115]="BrowserSearch",e[e.BrowserHome=116]="BrowserHome",e[e.BrowserBack=117]="BrowserBack",e[e.BrowserForward=118]="BrowserForward",e[e.MediaTrackNext=119]="MediaTrackNext",e[e.MediaTrackPrevious=120]="MediaTrackPrevious",e[e.MediaStop=121]="MediaStop",e[e.MediaPlayPause=122]="MediaPlayPause",e[e.LaunchMediaPlayer=123]="LaunchMediaPlayer",e[e.LaunchMail=124]="LaunchMail",e[e.LaunchApp2=125]="LaunchApp2",e[e.Clear=126]="Clear",e[e.MAX_VALUE=127]="MAX_VALUE"})(E=t.KeyCode||(t.KeyCode={}));var i;(function(e){e[e.DependsOnKbLayout=-1]="DependsOnKbLayout",e[e.None=0]="None",e[e.Hyper=1]="Hyper",e[e.Super=2]="Super",e[e.Fn=3]="Fn",e[e.FnLock=4]="FnLock",e[e.Suspend=5]="Suspend",e[e.Resume=6]="Resume",e[e.Turbo=7]="Turbo",e[e.Sleep=8]="Sleep",e[e.WakeUp=9]="WakeUp",e[e.KeyA=10]="KeyA",e[e.KeyB=11]="KeyB",e[e.KeyC=12]="KeyC",e[e.KeyD=13]="KeyD",e[e.KeyE=14]="KeyE",e[e.KeyF=15]="KeyF",e[e.KeyG=16]="KeyG",e[e.KeyH=17]="KeyH",e[e.KeyI=18]="KeyI",e[e.KeyJ=19]="KeyJ",e[e.KeyK=20]="KeyK",e[e.KeyL=21]="KeyL",e[e.KeyM=22]="KeyM",e[e.KeyN=23]="KeyN",e[e.KeyO=24]="KeyO",e[e.KeyP=25]="KeyP",e[e.KeyQ=26]="KeyQ",e[e.KeyR=27]="KeyR",e[e.KeyS=28]="KeyS",e[e.KeyT=29]="KeyT",e[e.KeyU=30]="KeyU",e[e.KeyV=31]="KeyV",e[e.KeyW=32]="KeyW",e[e.KeyX=33]="KeyX",e[e.KeyY=34]="KeyY",e[e.KeyZ=35]="KeyZ",e[e.Digit1=36]="Digit1",e[e.Digit2=37]="Digit2",e[e.Digit3=38]="Digit3",e[e.Digit4=39]="Digit4",e[e.Digit5=40]="Digit5",e[e.Digit6=41]="Digit6",e[e.Digit7=42]="Digit7",e[e.Digit8=43]="Digit8",e[e.Digit9=44]="Digit9",e[e.Digit0=45]="Digit0",e[e.Enter=46]="Enter",e[e.Escape=47]="Escape",e[e.Backspace=48]="Backspace",e[e.Tab=49]="Tab",e[e.Space=50]="Space",e[e.Minus=51]="Minus",e[e.Equal=52]="Equal",e[e.BracketLeft=53]="BracketLeft",e[e.BracketRight=54]="BracketRight",e[e.Backslash=55]="Backslash",e[e.IntlHash=56]="IntlHash",e[e.Semicolon=57]="Semicolon",e[e.Quote=58]="Quote",e[e.Backquote=59]="Backquote",e[e.Comma=60]="Comma",e[e.Period=61]="Period",e[e.Slash=62]="Slash",e[e.CapsLock=63]="CapsLock",e[e.F1=64]="F1",e[e.F2=65]="F2",e[e.F3=66]="F3",e[e.F4=67]="F4",e[e.F5=68]="F5",e[e.F6=69]="F6",e[e.F7=70]="F7",e[e.F8=71]="F8",e[e.F9=72]="F9",e[e.F10=73]="F10",e[e.F11=74]="F11",e[e.F12=75]="F12",e[e.PrintScreen=76]="PrintScreen",e[e.ScrollLock=77]="ScrollLock",e[e.Pause=78]="Pause",e[e.Insert=79]="Insert",e[e.Home=80]="Home",e[e.PageUp=81]="PageUp",e[e.Delete=82]="Delete",e[e.End=83]="End",e[e.PageDown=84]="PageDown",e[e.ArrowRight=85]="ArrowRight",e[e.ArrowLeft=86]="ArrowLeft",e[e.ArrowDown=87]="ArrowDown",e[e.ArrowUp=88]="ArrowUp",e[e.NumLock=89]="NumLock",e[e.NumpadDivide=90]="NumpadDivide",e[e.NumpadMultiply=91]="NumpadMultiply",e[e.NumpadSubtract=92]="NumpadSubtract",e[e.NumpadAdd=93]="NumpadAdd",e[e.NumpadEnter=94]="NumpadEnter",e[e.Numpad1=95]="Numpad1",e[e.Numpad2=96]="Numpad2",e[e.Numpad3=97]="Numpad3",e[e.Numpad4=98]="Numpad4",e[e.Numpad5=99]="Numpad5",e[e.Numpad6=100]="Numpad6",e[e.Numpad7=101]="Numpad7",e[e.Numpad8=102]="Numpad8",e[e.Numpad9=103]="Numpad9",e[e.Numpad0=104]="Numpad0",e[e.NumpadDecimal=105]="NumpadDecimal",e[e.IntlBackslash=106]="IntlBackslash",e[e.ContextMenu=107]="ContextMenu",e[e.Power=108]="Power",e[e.NumpadEqual=109]="NumpadEqual",e[e.F13=110]="F13",e[e.F14=111]="F14",e[e.F15=112]="F15",e[e.F16=113]="F16",e[e.F17=114]="F17",e[e.F18=115]="F18",e[e.F19=116]="F19",e[e.F20=117]="F20",e[e.F21=118]="F21",e[e.F22=119]="F22",e[e.F23=120]="F23",e[e.F24=121]="F24",e[e.Open=122]="Open",e[e.Help=123]="Help",e[e.Select=124]="Select",e[e.Again=125]="Again",e[e.Undo=126]="Undo",e[e.Cut=127]="Cut",e[e.Copy=128]="Copy",e[e.Paste=129]="Paste",e[e.Find=130]="Find",e[e.AudioVolumeMute=131]="AudioVolumeMute",e[e.AudioVolumeUp=132]="AudioVolumeUp",e[e.AudioVolumeDown=133]="AudioVolumeDown",e[e.NumpadComma=134]="NumpadComma",e[e.IntlRo=135]="IntlRo",e[e.KanaMode=136]="KanaMode",e[e.IntlYen=137]="IntlYen",e[e.Convert=138]="Convert",e[e.NonConvert=139]="NonConvert",e[e.Lang1=140]="Lang1",e[e.Lang2=141]="Lang2",e[e.Lang3=142]="Lang3",e[e.Lang4=143]="Lang4",e[e.Lang5=144]="Lang5",e[e.Abort=145]="Abort",e[e.Props=146]="Props",e[e.NumpadParenLeft=147]="NumpadParenLeft",e[e.NumpadParenRight=148]="NumpadParenRight",e[e.NumpadBackspace=149]="NumpadBackspace",e[e.NumpadMemoryStore=150]="NumpadMemoryStore",e[e.NumpadMemoryRecall=151]="NumpadMemoryRecall",e[e.NumpadMemoryClear=152]="NumpadMemoryClear",e[e.NumpadMemoryAdd=153]="NumpadMemoryAdd",e[e.NumpadMemorySubtract=154]="NumpadMemorySubtract",e[e.NumpadClear=155]="NumpadClear",e[e.NumpadClearEntry=156]="NumpadClearEntry",e[e.ControlLeft=157]="ControlLeft",e[e.ShiftLeft=158]="ShiftLeft",e[e.AltLeft=159]="AltLeft",e[e.MetaLeft=160]="MetaLeft",e[e.ControlRight=161]="ControlRight",e[e.ShiftRight=162]="ShiftRight",e[e.AltRight=163]="AltRight",e[e.MetaRight=164]="MetaRight",e[e.BrightnessUp=165]="BrightnessUp",e[e.BrightnessDown=166]="BrightnessDown",e[e.MediaPlay=167]="MediaPlay",e[e.MediaRecord=168]="MediaRecord",e[e.MediaFastForward=169]="MediaFastForward",e[e.MediaRewind=170]="MediaRewind",e[e.MediaTrackNext=171]="MediaTrackNext",e[e.MediaTrackPrevious=172]="MediaTrackPrevious",e[e.MediaStop=173]="MediaStop",e[e.Eject=174]="Eject",e[e.MediaPlayPause=175]="MediaPlayPause",e[e.MediaSelect=176]="MediaSelect",e[e.LaunchMail=177]="LaunchMail",e[e.LaunchApp2=178]="LaunchApp2",e[e.LaunchApp1=179]="LaunchApp1",e[e.SelectTask=180]="SelectTask",e[e.LaunchScreenSaver=181]="LaunchScreenSaver",e[e.BrowserSearch=182]="BrowserSearch",e[e.BrowserHome=183]="BrowserHome",e[e.BrowserBack=184]="BrowserBack",e[e.BrowserForward=185]="BrowserForward",e[e.BrowserStop=186]="BrowserStop",e[e.BrowserRefresh=187]="BrowserRefresh",e[e.BrowserFavorites=188]="BrowserFavorites",e[e.ZoomToggle=189]="ZoomToggle",e[e.MailReply=190]="MailReply",e[e.MailForward=191]="MailForward",e[e.MailSend=192]="MailSend",e[e.MAX_VALUE=193]="MAX_VALUE"})(i=t.ScanCode||(t.ScanCode={}));class M{constructor(){this._keyCodeToStr=[],this._strToKeyCode=Object.create(null)}define(p,v){this._keyCodeToStr[p]=v,this._strToKeyCode[v.toLowerCase()]=p}keyCodeToStr(p){return this._keyCodeToStr[p]}strToKeyCode(p){return this._strToKeyCode[p.toLowerCase()]||0}}const O=new M,_=new M,w=new M;t.EVENT_KEY_CODE_MAP=new Array(230),t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE={};const g=[],d=Object.create(null),f=Object.create(null);t.ScanCodeUtils={lowerCaseToEnum:e=>f[e]||0,toEnum:e=>d[e]||0,toString:e=>g[e]||"None"},t.IMMUTABLE_CODE_TO_KEY_CODE=[],t.IMMUTABLE_KEY_CODE_TO_CODE=[];for(let e=0;e<=193;e++)t.IMMUTABLE_CODE_TO_KEY_CODE[e]=-1;for(let e=0;e<=127;e++)t.IMMUTABLE_KEY_CODE_TO_CODE[e]=-1;(function(){const e="",p=[[0,1,0,"None",0,"unknown",0,"VK_UNKNOWN",e,e],[0,1,1,"Hyper",0,e,0,e,e,e],[0,1,2,"Super",0,e,0,e,e,e],[0,1,3,"Fn",0,e,0,e,e,e],[0,1,4,"FnLock",0,e,0,e,e,e],[0,1,5,"Suspend",0,e,0,e,e,e],[0,1,6,"Resume",0,e,0,e,e,e],[0,1,7,"Turbo",0,e,0,e,e,e],[0,1,8,"Sleep",0,e,0,"VK_SLEEP",e,e],[0,1,9,"WakeUp",0,e,0,e,e,e],[31,0,10,"KeyA",31,"A",65,"VK_A",e,e],[32,0,11,"KeyB",32,"B",66,"VK_B",e,e],[33,0,12,"KeyC",33,"C",67,"VK_C",e,e],[34,0,13,"KeyD",34,"D",68,"VK_D",e,e],[35,0,14,"KeyE",35,"E",69,"VK_E",e,e],[36,0,15,"KeyF",36,"F",70,"VK_F",e,e],[37,0,16,"KeyG",37,"G",71,"VK_G",e,e],[38,0,17,"KeyH",38,"H",72,"VK_H",e,e],[39,0,18,"KeyI",39,"I",73,"VK_I",e,e],[40,0,19,"KeyJ",40,"J",74,"VK_J",e,e],[41,0,20,"KeyK",41,"K",75,"VK_K",e,e],[42,0,21,"KeyL",42,"L",76,"VK_L",e,e],[43,0,22,"KeyM",43,"M",77,"VK_M",e,e],[44,0,23,"KeyN",44,"N",78,"VK_N",e,e],[45,0,24,"KeyO",45,"O",79,"VK_O",e,e],[46,0,25,"KeyP",46,"P",80,"VK_P",e,e],[47,0,26,"KeyQ",47,"Q",81,"VK_Q",e,e],[48,0,27,"KeyR",48,"R",82,"VK_R",e,e],[49,0,28,"KeyS",49,"S",83,"VK_S",e,e],[50,0,29,"KeyT",50,"T",84,"VK_T",e,e],[51,0,30,"KeyU",51,"U",85,"VK_U",e,e],[52,0,31,"KeyV",52,"V",86,"VK_V",e,e],[53,0,32,"KeyW",53,"W",87,"VK_W",e,e],[54,0,33,"KeyX",54,"X",88,"VK_X",e,e],[55,0,34,"KeyY",55,"Y",89,"VK_Y",e,e],[56,0,35,"KeyZ",56,"Z",90,"VK_Z",e,e],[22,0,36,"Digit1",22,"1",49,"VK_1",e,e],[23,0,37,"Digit2",23,"2",50,"VK_2",e,e],[24,0,38,"Digit3",24,"3",51,"VK_3",e,e],[25,0,39,"Digit4",25,"4",52,"VK_4",e,e],[26,0,40,"Digit5",26,"5",53,"VK_5",e,e],[27,0,41,"Digit6",27,"6",54,"VK_6",e,e],[28,0,42,"Digit7",28,"7",55,"VK_7",e,e],[29,0,43,"Digit8",29,"8",56,"VK_8",e,e],[30,0,44,"Digit9",30,"9",57,"VK_9",e,e],[21,0,45,"Digit0",21,"0",48,"VK_0",e,e],[3,1,46,"Enter",3,"Enter",13,"VK_RETURN",e,e],[9,1,47,"Escape",9,"Escape",27,"VK_ESCAPE",e,e],[1,1,48,"Backspace",1,"Backspace",8,"VK_BACK",e,e],[2,1,49,"Tab",2,"Tab",9,"VK_TAB",e,e],[10,1,50,"Space",10,"Space",32,"VK_SPACE",e,e],[83,0,51,"Minus",83,"-",189,"VK_OEM_MINUS","-","OEM_MINUS"],[81,0,52,"Equal",81,"=",187,"VK_OEM_PLUS","=","OEM_PLUS"],[87,0,53,"BracketLeft",87,"[",219,"VK_OEM_4","[","OEM_4"],[89,0,54,"BracketRight",89,"]",221,"VK_OEM_6","]","OEM_6"],[88,0,55,"Backslash",88,"\\",220,"VK_OEM_5","\\","OEM_5"],[0,0,56,"IntlHash",0,e,0,e,e,e],[80,0,57,"Semicolon",80,";",186,"VK_OEM_1",";","OEM_1"],[90,0,58,"Quote",90,"'",222,"VK_OEM_7","'","OEM_7"],[86,0,59,"Backquote",86,"`",192,"VK_OEM_3","`","OEM_3"],[82,0,60,"Comma",82,",",188,"VK_OEM_COMMA",",","OEM_COMMA"],[84,0,61,"Period",84,".",190,"VK_OEM_PERIOD",".","OEM_PERIOD"],[85,0,62,"Slash",85,"/",191,"VK_OEM_2","/","OEM_2"],[8,1,63,"CapsLock",8,"CapsLock",20,"VK_CAPITAL",e,e],[59,1,64,"F1",59,"F1",112,"VK_F1",e,e],[60,1,65,"F2",60,"F2",113,"VK_F2",e,e],[61,1,66,"F3",61,"F3",114,"VK_F3",e,e],[62,1,67,"F4",62,"F4",115,"VK_F4",e,e],[63,1,68,"F5",63,"F5",116,"VK_F5",e,e],[64,1,69,"F6",64,"F6",117,"VK_F6",e,e],[65,1,70,"F7",65,"F7",118,"VK_F7",e,e],[66,1,71,"F8",66,"F8",119,"VK_F8",e,e],[67,1,72,"F9",67,"F9",120,"VK_F9",e,e],[68,1,73,"F10",68,"F10",121,"VK_F10",e,e],[69,1,74,"F11",69,"F11",122,"VK_F11",e,e],[70,1,75,"F12",70,"F12",123,"VK_F12",e,e],[0,1,76,"PrintScreen",0,e,0,e,e,e],[79,1,77,"ScrollLock",79,"ScrollLock",145,"VK_SCROLL",e,e],[7,1,78,"Pause",7,"PauseBreak",19,"VK_PAUSE",e,e],[19,1,79,"Insert",19,"Insert",45,"VK_INSERT",e,e],[14,1,80,"Home",14,"Home",36,"VK_HOME",e,e],[11,1,81,"PageUp",11,"PageUp",33,"VK_PRIOR",e,e],[20,1,82,"Delete",20,"Delete",46,"VK_DELETE",e,e],[13,1,83,"End",13,"End",35,"VK_END",e,e],[12,1,84,"PageDown",12,"PageDown",34,"VK_NEXT",e,e],[17,1,85,"ArrowRight",17,"RightArrow",39,"VK_RIGHT","Right",e],[15,1,86,"ArrowLeft",15,"LeftArrow",37,"VK_LEFT","Left",e],[18,1,87,"ArrowDown",18,"DownArrow",40,"VK_DOWN","Down",e],[16,1,88,"ArrowUp",16,"UpArrow",38,"VK_UP","Up",e],[78,1,89,"NumLock",78,"NumLock",144,"VK_NUMLOCK",e,e],[108,1,90,"NumpadDivide",108,"NumPad_Divide",111,"VK_DIVIDE",e,e],[103,1,91,"NumpadMultiply",103,"NumPad_Multiply",106,"VK_MULTIPLY",e,e],[106,1,92,"NumpadSubtract",106,"NumPad_Subtract",109,"VK_SUBTRACT",e,e],[104,1,93,"NumpadAdd",104,"NumPad_Add",107,"VK_ADD",e,e],[3,1,94,"NumpadEnter",3,e,0,e,e,e],[94,1,95,"Numpad1",94,"NumPad1",97,"VK_NUMPAD1",e,e],[95,1,96,"Numpad2",95,"NumPad2",98,"VK_NUMPAD2",e,e],[96,1,97,"Numpad3",96,"NumPad3",99,"VK_NUMPAD3",e,e],[97,1,98,"Numpad4",97,"NumPad4",100,"VK_NUMPAD4",e,e],[98,1,99,"Numpad5",98,"NumPad5",101,"VK_NUMPAD5",e,e],[99,1,100,"Numpad6",99,"NumPad6",102,"VK_NUMPAD6",e,e],[100,1,101,"Numpad7",100,"NumPad7",103,"VK_NUMPAD7",e,e],[101,1,102,"Numpad8",101,"NumPad8",104,"VK_NUMPAD8",e,e],[102,1,103,"Numpad9",102,"NumPad9",105,"VK_NUMPAD9",e,e],[93,1,104,"Numpad0",93,"NumPad0",96,"VK_NUMPAD0",e,e],[107,1,105,"NumpadDecimal",107,"NumPad_Decimal",110,"VK_DECIMAL",e,e],[92,0,106,"IntlBackslash",92,"OEM_102",226,"VK_OEM_102",e,e],[58,1,107,"ContextMenu",58,"ContextMenu",93,e,e,e],[0,1,108,"Power",0,e,0,e,e,e],[0,1,109,"NumpadEqual",0,e,0,e,e,e],[71,1,110,"F13",71,"F13",124,"VK_F13",e,e],[72,1,111,"F14",72,"F14",125,"VK_F14",e,e],[73,1,112,"F15",73,"F15",126,"VK_F15",e,e],[74,1,113,"F16",74,"F16",127,"VK_F16",e,e],[75,1,114,"F17",75,"F17",128,"VK_F17",e,e],[76,1,115,"F18",76,"F18",129,"VK_F18",e,e],[77,1,116,"F19",77,"F19",130,"VK_F19",e,e],[0,1,117,"F20",0,e,0,"VK_F20",e,e],[0,1,118,"F21",0,e,0,"VK_F21",e,e],[0,1,119,"F22",0,e,0,"VK_F22",e,e],[0,1,120,"F23",0,e,0,"VK_F23",e,e],[0,1,121,"F24",0,e,0,"VK_F24",e,e],[0,1,122,"Open",0,e,0,e,e,e],[0,1,123,"Help",0,e,0,e,e,e],[0,1,124,"Select",0,e,0,e,e,e],[0,1,125,"Again",0,e,0,e,e,e],[0,1,126,"Undo",0,e,0,e,e,e],[0,1,127,"Cut",0,e,0,e,e,e],[0,1,128,"Copy",0,e,0,e,e,e],[0,1,129,"Paste",0,e,0,e,e,e],[0,1,130,"Find",0,e,0,e,e,e],[0,1,131,"AudioVolumeMute",112,"AudioVolumeMute",173,"VK_VOLUME_MUTE",e,e],[0,1,132,"AudioVolumeUp",113,"AudioVolumeUp",175,"VK_VOLUME_UP",e,e],[0,1,133,"AudioVolumeDown",114,"AudioVolumeDown",174,"VK_VOLUME_DOWN",e,e],[105,1,134,"NumpadComma",105,"NumPad_Separator",108,"VK_SEPARATOR",e,e],[110,0,135,"IntlRo",110,"ABNT_C1",193,"VK_ABNT_C1",e,e],[0,1,136,"KanaMode",0,e,0,e,e,e],[0,0,137,"IntlYen",0,e,0,e,e,e],[0,1,138,"Convert",0,e,0,e,e,e],[0,1,139,"NonConvert",0,e,0,e,e,e],[0,1,140,"Lang1",0,e,0,e,e,e],[0,1,141,"Lang2",0,e,0,e,e,e],[0,1,142,"Lang3",0,e,0,e,e,e],[0,1,143,"Lang4",0,e,0,e,e,e],[0,1,144,"Lang5",0,e,0,e,e,e],[0,1,145,"Abort",0,e,0,e,e,e],[0,1,146,"Props",0,e,0,e,e,e],[0,1,147,"NumpadParenLeft",0,e,0,e,e,e],[0,1,148,"NumpadParenRight",0,e,0,e,e,e],[0,1,149,"NumpadBackspace",0,e,0,e,e,e],[0,1,150,"NumpadMemoryStore",0,e,0,e,e,e],[0,1,151,"NumpadMemoryRecall",0,e,0,e,e,e],[0,1,152,"NumpadMemoryClear",0,e,0,e,e,e],[0,1,153,"NumpadMemoryAdd",0,e,0,e,e,e],[0,1,154,"NumpadMemorySubtract",0,e,0,e,e,e],[0,1,155,"NumpadClear",126,"Clear",12,"VK_CLEAR",e,e],[0,1,156,"NumpadClearEntry",0,e,0,e,e,e],[5,1,0,e,5,"Ctrl",17,"VK_CONTROL",e,e],[4,1,0,e,4,"Shift",16,"VK_SHIFT",e,e],[6,1,0,e,6,"Alt",18,"VK_MENU",e,e],[57,1,0,e,57,"Meta",0,"VK_COMMAND",e,e],[5,1,157,"ControlLeft",5,e,0,"VK_LCONTROL",e,e],[4,1,158,"ShiftLeft",4,e,0,"VK_LSHIFT",e,e],[6,1,159,"AltLeft",6,e,0,"VK_LMENU",e,e],[57,1,160,"MetaLeft",57,e,0,"VK_LWIN",e,e],[5,1,161,"ControlRight",5,e,0,"VK_RCONTROL",e,e],[4,1,162,"ShiftRight",4,e,0,"VK_RSHIFT",e,e],[6,1,163,"AltRight",6,e,0,"VK_RMENU",e,e],[57,1,164,"MetaRight",57,e,0,"VK_RWIN",e,e],[0,1,165,"BrightnessUp",0,e,0,e,e,e],[0,1,166,"BrightnessDown",0,e,0,e,e,e],[0,1,167,"MediaPlay",0,e,0,e,e,e],[0,1,168,"MediaRecord",0,e,0,e,e,e],[0,1,169,"MediaFastForward",0,e,0,e,e,e],[0,1,170,"MediaRewind",0,e,0,e,e,e],[114,1,171,"MediaTrackNext",119,"MediaTrackNext",176,"VK_MEDIA_NEXT_TRACK",e,e],[115,1,172,"MediaTrackPrevious",120,"MediaTrackPrevious",177,"VK_MEDIA_PREV_TRACK",e,e],[116,1,173,"MediaStop",121,"MediaStop",178,"VK_MEDIA_STOP",e,e],[0,1,174,"Eject",0,e,0,e,e,e],[117,1,175,"MediaPlayPause",122,"MediaPlayPause",179,"VK_MEDIA_PLAY_PAUSE",e,e],[0,1,176,"MediaSelect",123,"LaunchMediaPlayer",181,"VK_MEDIA_LAUNCH_MEDIA_SELECT",e,e],[0,1,177,"LaunchMail",124,"LaunchMail",180,"VK_MEDIA_LAUNCH_MAIL",e,e],[0,1,178,"LaunchApp2",125,"LaunchApp2",183,"VK_MEDIA_LAUNCH_APP2",e,e],[0,1,179,"LaunchApp1",0,e,0,"VK_MEDIA_LAUNCH_APP1",e,e],[0,1,180,"SelectTask",0,e,0,e,e,e],[0,1,181,"LaunchScreenSaver",0,e,0,e,e,e],[0,1,182,"BrowserSearch",115,"BrowserSearch",170,"VK_BROWSER_SEARCH",e,e],[0,1,183,"BrowserHome",116,"BrowserHome",172,"VK_BROWSER_HOME",e,e],[112,1,184,"BrowserBack",117,"BrowserBack",166,"VK_BROWSER_BACK",e,e],[113,1,185,"BrowserForward",118,"BrowserForward",167,"VK_BROWSER_FORWARD",e,e],[0,1,186,"BrowserStop",0,e,0,"VK_BROWSER_STOP",e,e],[0,1,187,"BrowserRefresh",0,e,0,"VK_BROWSER_REFRESH",e,e],[0,1,188,"BrowserFavorites",0,e,0,"VK_BROWSER_FAVORITES",e,e],[0,1,189,"ZoomToggle",0,e,0,e,e,e],[0,1,190,"MailReply",0,e,0,e,e,e],[0,1,191,"MailForward",0,e,0,e,e,e],[0,1,192,"MailSend",0,e,0,e,e,e],[109,1,0,e,109,"KeyInComposition",229,e,e,e],[111,1,0,e,111,"ABNT_C2",194,"VK_ABNT_C2",e,e],[91,1,0,e,91,"OEM_8",223,"VK_OEM_8",e,e],[0,1,0,e,0,e,0,"VK_KANA",e,e],[0,1,0,e,0,e,0,"VK_HANGUL",e,e],[0,1,0,e,0,e,0,"VK_JUNJA",e,e],[0,1,0,e,0,e,0,"VK_FINAL",e,e],[0,1,0,e,0,e,0,"VK_HANJA",e,e],[0,1,0,e,0,e,0,"VK_KANJI",e,e],[0,1,0,e,0,e,0,"VK_CONVERT",e,e],[0,1,0,e,0,e,0,"VK_NONCONVERT",e,e],[0,1,0,e,0,e,0,"VK_ACCEPT",e,e],[0,1,0,e,0,e,0,"VK_MODECHANGE",e,e],[0,1,0,e,0,e,0,"VK_SELECT",e,e],[0,1,0,e,0,e,0,"VK_PRINT",e,e],[0,1,0,e,0,e,0,"VK_EXECUTE",e,e],[0,1,0,e,0,e,0,"VK_SNAPSHOT",e,e],[0,1,0,e,0,e,0,"VK_HELP",e,e],[0,1,0,e,0,e,0,"VK_APPS",e,e],[0,1,0,e,0,e,0,"VK_PROCESSKEY",e,e],[0,1,0,e,0,e,0,"VK_PACKET",e,e],[0,1,0,e,0,e,0,"VK_DBE_SBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_DBE_DBCSCHAR",e,e],[0,1,0,e,0,e,0,"VK_ATTN",e,e],[0,1,0,e,0,e,0,"VK_CRSEL",e,e],[0,1,0,e,0,e,0,"VK_EXSEL",e,e],[0,1,0,e,0,e,0,"VK_EREOF",e,e],[0,1,0,e,0,e,0,"VK_PLAY",e,e],[0,1,0,e,0,e,0,"VK_ZOOM",e,e],[0,1,0,e,0,e,0,"VK_NONAME",e,e],[0,1,0,e,0,e,0,"VK_PA1",e,e],[0,1,0,e,0,e,0,"VK_OEM_CLEAR",e,e]],v=[],D=[];for(const y of p){const[o,c,b,S,A,C,r,n,a,u]=y;if(D[b]||(D[b]=!0,g[b]=S,d[S]=b,f[S.toLowerCase()]=b,c&&(t.IMMUTABLE_CODE_TO_KEY_CODE[b]=A,A!==0&&A!==3&&A!==5&&A!==4&&A!==6&&A!==57&&(t.IMMUTABLE_KEY_CODE_TO_CODE[A]=b))),!v[A]){if(v[A]=!0,!C)throw new Error(`String representation missing for key code ${A} around scan code ${S}`);O.define(A,C),_.define(A,a||C),w.define(A,u||a||C)}r&&(t.EVENT_KEY_CODE_MAP[r]=A),n&&(t.NATIVE_WINDOWS_KEY_CODE_TO_KEY_CODE[n]=A)}t.IMMUTABLE_KEY_CODE_TO_CODE[3]=46})();var F;(function(e){function p(b){return O.keyCodeToStr(b)}e.toString=p;function v(b){return O.strToKeyCode(b)}e.fromString=v;function D(b){return _.keyCodeToStr(b)}e.toUserSettingsUS=D;function y(b){return w.keyCodeToStr(b)}e.toUserSettingsGeneral=y;function o(b){return _.strToKeyCode(b)||w.strToKeyCode(b)}e.fromUserSettings=o;function c(b){if(b>=93&&b<=108)return null;switch(b){case 16:return"Up";case 18:return"Down";case 15:return"Left";case 17:return"Right"}return O.keyCodeToStr(b)}e.toElectronAccelerator=c})(F=t.KeyCodeUtils||(t.KeyCodeUtils={}));var l;(function(e){e[e.CtrlCmd=2048]="CtrlCmd",e[e.Shift=1024]="Shift",e[e.Alt=512]="Alt",e[e.WinCtrl=256]="WinCtrl"})(l=t.KeyMod||(t.KeyMod={}));function s(e,p){const v=(p&65535)<<16>>>0;return(e|v)>>>0}t.KeyChord=s}),define(me[72],pe([1,0,13]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ResolvedKeybinding=t.ResolvedKeybindingPart=t.ScanCodeBinding=t.ChordKeybinding=t.SimpleKeybinding=t.createSimpleKeybinding=t.createKeybinding=void 0;var i;(function(F){F[F.CtrlCmd=2048]="CtrlCmd",F[F.Shift=1024]="Shift",F[F.Alt=512]="Alt",F[F.WinCtrl=256]="WinCtrl",F[F.KeyCode=255]="KeyCode"})(i||(i={}));function M(F,l){if(F===0)return null;const s=(F&65535)>>>0,e=(F&4294901760)>>>16;return e!==0?new w([O(s,l),O(e,l)]):new w([O(s,l)])}t.createKeybinding=M;function O(F,l){const s=!!(F&2048),e=!!(F&256),p=l===2?e:s,v=!!(F&1024),D=!!(F&512),y=l===2?s:e,o=F&255;return new _(p,v,D,y,o)}t.createSimpleKeybinding=O;class _{constructor(l,s,e,p,v){this.ctrlKey=l,this.shiftKey=s,this.altKey=e,this.metaKey=p,this.keyCode=v}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.keyCode===l.keyCode}getHashCode(){const l=this.ctrlKey?"1":"0",s=this.shiftKey?"1":"0",e=this.altKey?"1":"0",p=this.metaKey?"1":"0";return`${l}${s}${e}${p}${this.keyCode}`}isModifierKey(){return this.keyCode===0||this.keyCode===5||this.keyCode===57||this.keyCode===6||this.keyCode===4}toChord(){return new w([this])}isDuplicateModifierCase(){return this.ctrlKey&&this.keyCode===5||this.shiftKey&&this.keyCode===4||this.altKey&&this.keyCode===6||this.metaKey&&this.keyCode===57}}t.SimpleKeybinding=_;class w{constructor(l){if(l.length===0)throw(0,E.illegalArgument)("parts");this.parts=l}getHashCode(){let l="";for(let s=0,e=this.parts.length;s<e;s++)s!==0&&(l+=";"),l+=this.parts[s].getHashCode();return l}equals(l){if(l===null||this.parts.length!==l.parts.length)return!1;for(let s=0;s<this.parts.length;s++)if(!this.parts[s].equals(l.parts[s]))return!1;return!0}}t.ChordKeybinding=w;class g{constructor(l,s,e,p,v){this.ctrlKey=l,this.shiftKey=s,this.altKey=e,this.metaKey=p,this.scanCode=v}equals(l){return this.ctrlKey===l.ctrlKey&&this.shiftKey===l.shiftKey&&this.altKey===l.altKey&&this.metaKey===l.metaKey&&this.scanCode===l.scanCode}isDuplicateModifierCase(){return this.ctrlKey&&(this.scanCode===157||this.scanCode===161)||this.shiftKey&&(this.scanCode===158||this.scanCode===162)||this.altKey&&(this.scanCode===159||this.scanCode===163)||this.metaKey&&(this.scanCode===160||this.scanCode===164)}}t.ScanCodeBinding=g;class d{constructor(l,s,e,p,v,D){this.ctrlKey=l,this.shiftKey=s,this.altKey=e,this.metaKey=p,this.keyLabel=v,this.keyAriaLabel=D}}t.ResolvedKeybindingPart=d;class f{}t.ResolvedKeybinding=f}),define(me[73],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Lazy=void 0;class E{constructor(M){this.executor=M,this._didRun=!1}hasValue(){return this._didRun}getValue(){if(!this._didRun)try{this._value=this.executor()}catch(M){this._error=M}finally{this._didRun=!0}if(this._error)throw this._error;return this._value}get rawValue(){return this._value}map(M){return new E(()=>M(this.getValue()))}}t.Lazy=E}),define(me[2],pe([1,0,42,26]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.disposeOnReturn=t.ImmortalReference=t.AsyncReferenceCollection=t.ReferenceCollection=t.SafeDisposable=t.RefCountedDisposable=t.MutableDisposable=t.Disposable=t.DisposableStore=t.toDisposable=t.combinedDisposable=t.dispose=t.isDisposable=t.MultiDisposeError=t.markAsSingleton=t.setDisposableTracker=void 0;const M=!1;let O=null;function _(n){O=n}if(t.setDisposableTracker=_,M){const n="__is_disposable_tracked__";_(new class{trackDisposable(a){const u=new Error("Potentially leaked disposable").stack;setTimeout(()=>{a[n]||console.log(u)},3e3)}setParent(a,u){if(a&&a!==y.None)try{a[n]=!0}catch{}}markAsDisposed(a){if(a&&a!==y.None)try{a[n]=!0}catch{}}markAsSingleton(a){}})}function w(n){return O?.trackDisposable(n),n}function g(n){O?.markAsDisposed(n)}function d(n,a){O?.setParent(n,a)}function f(n,a){if(!!O)for(const u of n)O.setParent(u,a)}function F(n){return O?.markAsSingleton(n),n}t.markAsSingleton=F;class l extends Error{constructor(a){super(`Encountered errors while disposing of store. Errors: [${a.join(", ")}]`);this.errors=a}}t.MultiDisposeError=l;function s(n){return typeof n.dispose=="function"&&n.dispose.length===0}t.isDisposable=s;function e(n){if(i.Iterable.is(n)){const a=[];for(const u of n)if(u)try{u.dispose()}catch(m){a.push(m)}if(a.length===1)throw a[0];if(a.length>1)throw new l(a);return Array.isArray(n)?[]:n}else if(n)return n.dispose(),n}t.dispose=e;function p(...n){const a=v(()=>e(n));return f(n,a),a}t.combinedDisposable=p;function v(n){const a=w({dispose:(0,E.once)(()=>{g(a),n()})});return a}t.toDisposable=v;class D{constructor(){this._toDispose=new Set,this._isDisposed=!1,w(this)}dispose(){this._isDisposed||(g(this),this._isDisposed=!0,this.clear())}get isDisposed(){return this._isDisposed}clear(){try{e(this._toDispose.values())}finally{this._toDispose.clear()}}add(a){if(!a)return a;if(a===this)throw new Error("Cannot register a disposable on itself!");return d(a,this),this._isDisposed?D.DISABLE_DISPOSED_WARNING||console.warn(new Error("Trying to add a disposable to a DisposableStore that has already been disposed of. The added object will be leaked!").stack):this._toDispose.add(a),a}}t.DisposableStore=D,D.DISABLE_DISPOSED_WARNING=!1;class y{constructor(){this._store=new D,w(this),d(this._store,this)}dispose(){g(this),this._store.dispose()}_register(a){if(a===this)throw new Error("Cannot register a disposable on itself!");return this._store.add(a)}}t.Disposable=y,y.None=Object.freeze({dispose(){}});class o{constructor(){this._isDisposed=!1,w(this)}get value(){return this._isDisposed?void 0:this._value}set value(a){this._isDisposed||a===this._value||(this._value?.dispose(),a&&d(a,this),this._value=a)}clear(){this.value=void 0}dispose(){this._isDisposed=!0,g(this),this._value?.dispose(),this._value=void 0}clearAndLeak(){const a=this._value;return this._value=void 0,a&&d(a,null),a}}t.MutableDisposable=o;class c{constructor(a){this._disposable=a,this._counter=1}acquire(){return this._counter++,this}release(){return--this._counter==0&&this._disposable.dispose(),this}}t.RefCountedDisposable=c;class b{constructor(){this.dispose=()=>{},this.unset=()=>{},this.isset=()=>!1,w(this)}set(a){let u=a;return this.unset=()=>u=void 0,this.isset=()=>u!==void 0,this.dispose=()=>{u&&(u(),u=void 0,g(this))},this}}t.SafeDisposable=b;class S{constructor(){this.references=new Map}acquire(a,...u){let m=this.references.get(a);m||(m={counter:0,object:this.createReferencedObject(a,...u)},this.references.set(a,m));const{object:W}=m,V=(0,E.once)(()=>{--m.counter==0&&(this.destroyReferencedObject(a,m.object),this.references.delete(a))});return m.counter++,{object:W,dispose:V}}}t.ReferenceCollection=S;class A{constructor(a){this.referenceCollection=a}async acquire(a,...u){const m=this.referenceCollection.acquire(a,...u);try{return{object:await m.object,dispose:()=>m.dispose()}}catch(W){throw m.dispose(),W}}}t.AsyncReferenceCollection=A;class C{constructor(a){this.object=a}dispose(){}}t.ImmortalReference=C;function r(n){const a=new D;try{n(a)}finally{a.dispose()}}t.disposeOnReturn=r}),define(me[74],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LinkedList=void 0;class E{constructor(O){this.element=O,this.next=E.Undefined,this.prev=E.Undefined}}E.Undefined=new E(void 0);class i{constructor(){this._first=E.Undefined,this._last=E.Undefined,this._size=0}get size(){return this._size}isEmpty(){return this._first===E.Undefined}clear(){let O=this._first;for(;O!==E.Undefined;){const _=O.next;O.prev=E.Undefined,O.next=E.Undefined,O=_}this._first=E.Undefined,this._last=E.Undefined,this._size=0}unshift(O){return this._insert(O,!1)}push(O){return this._insert(O,!0)}_insert(O,_){const w=new E(O);if(this._first===E.Undefined)this._first=w,this._last=w;else if(_){const d=this._last;this._last=w,w.prev=d,d.next=w}else{const d=this._first;this._first=w,w.next=d,d.prev=w}this._size+=1;let g=!1;return()=>{g||(g=!0,this._remove(w))}}shift(){if(this._first!==E.Undefined){const O=this._first.element;return this._remove(this._first),O}}pop(){if(this._last!==E.Undefined){const O=this._last.element;return this._remove(this._last),O}}_remove(O){if(O.prev!==E.Undefined&&O.next!==E.Undefined){const _=O.prev;_.next=O.next,O.next.prev=_}else O.prev===E.Undefined&&O.next===E.Undefined?(this._first=E.Undefined,this._last=E.Undefined):O.next===E.Undefined?(this._last=this._last.prev,this._last.next=E.Undefined):O.prev===E.Undefined&&(this._first=this._first.next,this._first.prev=E.Undefined);this._size-=1}*[Symbol.iterator](){let O=this._first;for(;O!==E.Undefined;)yield O.element,O=O.next}}t.LinkedList=i}),function(Z,t){typeof exports=="object"&&typeof module!="undefined"?t(exports):typeof define=="function"&&define.amd?define(me[75],pe([0]),t):(Z=typeof globalThis!="undefined"?globalThis:Z||self,t(Z.marked={}))}(this,function(Z){"use strict";function t(N,R){for(var z=0;z<R.length;z++){var T=R[z];T.enumerable=T.enumerable||!1,T.configurable=!0,"value"in T&&(T.writable=!0),Object.defineProperty(N,T.key,T)}}function E(N,R,z){return R&&t(N.prototype,R),z&&t(N,z),Object.defineProperty(N,"prototype",{writable:!1}),N}function i(N,R){if(!!N){if(typeof N=="string")return M(N,R);var z=Object.prototype.toString.call(N).slice(8,-1);if(z==="Object"&&N.constructor&&(z=N.constructor.name),z==="Map"||z==="Set")return Array.from(N);if(z==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(z))return M(N,R)}}function M(N,R){(R==null||R>N.length)&&(R=N.length);for(var z=0,T=new Array(R);z<R;z++)T[z]=N[z];return T}function O(N,R){var z=typeof Symbol!="undefined"&&N[Symbol.iterator]||N["@@iterator"];if(z)return(z=z.call(N)).next.bind(z);if(Array.isArray(N)||(z=i(N))||R&&N&&typeof N.length=="number"){z&&(N=z);var T=0;return function(){return T>=N.length?{done:!0}:{done:!1,value:N[T++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function _(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}Z.defaults=_();function w(N){Z.defaults=N}var g=/[&<>"']/,d=/[&<>"']/g,f=/[<>"']|&(?!#?\w+;)/,F=/[<>"']|&(?!#?\w+;)/g,l={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},s=function(R){return l[R]};function e(N,R){if(R){if(g.test(N))return N.replace(d,s)}else if(f.test(N))return N.replace(F,s);return N}var p=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function v(N){return N.replace(p,function(R,z){return z=z.toLowerCase(),z==="colon"?":":z.charAt(0)==="#"?z.charAt(1)==="x"?String.fromCharCode(parseInt(z.substring(2),16)):String.fromCharCode(+z.substring(1)):""})}var D=/(^|[^\[])\^/g;function y(N,R){N=typeof N=="string"?N:N.source,R=R||"";var z={replace:function(H,k){return k=k.source||k,k=k.replace(D,"$1"),N=N.replace(H,k),z},getRegex:function(){return new RegExp(N,R)}};return z}var o=/[^\w:]/g,c=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function b(N,R,z){if(N){var T;try{T=decodeURIComponent(v(z)).replace(o,"").toLowerCase()}catch{return null}if(T.indexOf("javascript:")===0||T.indexOf("vbscript:")===0||T.indexOf("data:")===0)return null}R&&!c.test(z)&&(z=n(R,z));try{z=encodeURI(z).replace(/%25/g,"%")}catch{return null}return z}var S={},A=/^[^:]+:\/*[^/]*$/,C=/^([^:]+:)[\s\S]*$/,r=/^([^:]+:\/*[^/]*)[\s\S]*$/;function n(N,R){S[" "+N]||(A.test(N)?S[" "+N]=N+"/":S[" "+N]=W(N,"/",!0)),N=S[" "+N];var z=N.indexOf(":")===-1;return R.substring(0,2)==="//"?z?R:N.replace(C,"$1")+R:R.charAt(0)==="/"?z?R:N.replace(r,"$1")+R:N+R}var a={exec:function(){}};function u(N){for(var R=1,z,T;R<arguments.length;R++){z=arguments[R];for(T in z)Object.prototype.hasOwnProperty.call(z,T)&&(N[T]=z[T])}return N}function m(N,R){var z=N.replace(/\|/g,function(k,P,x){for(var J=!1,he=P;--he>=0&&x[he]==="\\";)J=!J;return J?"|":" |"}),T=z.split(/ \|/),H=0;if(T[0].trim()||T.shift(),T.length>0&&!T[T.length-1].trim()&&T.pop(),T.length>R)T.splice(R);else for(;T.length<R;)T.push("");for(;H<T.length;H++)T[H]=T[H].trim().replace(/\\\|/g,"|");return T}function W(N,R,z){var T=N.length;if(T===0)return"";for(var H=0;H<T;){var k=N.charAt(T-H-1);if(k===R&&!z)H++;else if(k!==R&&z)H++;else break}return N.slice(0,T-H)}function V(N,R){if(N.indexOf(R[1])===-1)return-1;for(var z=N.length,T=0,H=0;H<z;H++)if(N[H]==="\\")H++;else if(N[H]===R[0])T++;else if(N[H]===R[1]&&(T--,T<0))return H;return-1}function ne(N){N&&N.sanitize&&!N.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function re(N,R){if(R<1)return"";for(var z="";R>1;)R&1&&(z+=N),R>>=1,N+=N;return z+N}function we(N,R,z,T){var H=R.href,k=R.title?e(R.title):null,P=N[1].replace(/\\([\[\]])/g,"$1");if(N[0].charAt(0)!=="!"){T.state.inLink=!0;var x={type:"link",raw:z,href:H,title:k,text:P,tokens:T.inlineTokens(P,[])};return T.state.inLink=!1,x}return{type:"image",raw:z,href:H,title:k,text:e(P)}}function ae(N,R){var z=N.match(/^(\s+)(?:```)/);if(z===null)return R;var T=z[1];return R.split(`
`).map(function(H){var k=H.match(/^\s+/);if(k===null)return H;var P=k[0];return P.length>=T.length?H.slice(T.length):H}).join(`
`)}var ve=function(){function N(z){this.options=z||Z.defaults}var R=N.prototype;return R.space=function(T){var H=this.rules.block.newline.exec(T);if(H&&H[0].length>0)return{type:"space",raw:H[0]}},R.code=function(T){var H=this.rules.block.code.exec(T);if(H){var k=H[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:H[0],codeBlockStyle:"indented",text:this.options.pedantic?k:W(k,`
`)}}},R.fences=function(T){var H=this.rules.block.fences.exec(T);if(H){var k=H[0],P=ae(k,H[3]||"");return{type:"code",raw:k,lang:H[2]?H[2].trim():H[2],text:P}}},R.heading=function(T){var H=this.rules.block.heading.exec(T);if(H){var k=H[2].trim();if(/#$/.test(k)){var P=W(k,"#");(this.options.pedantic||!P||/ $/.test(P))&&(k=P.trim())}var x={type:"heading",raw:H[0],depth:H[1].length,text:k,tokens:[]};return this.lexer.inline(x.text,x.tokens),x}},R.hr=function(T){var H=this.rules.block.hr.exec(T);if(H)return{type:"hr",raw:H[0]}},R.blockquote=function(T){var H=this.rules.block.blockquote.exec(T);if(H){var k=H[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:H[0],tokens:this.lexer.blockTokens(k,[]),text:k}}},R.list=function(T){var H=this.rules.block.list.exec(T);if(H){var k,P,x,J,he,de,Ee,_e,ke,Ie,De,Pe,Me=H[1].trim(),Ge=Me.length>1,He={type:"list",raw:"",ordered:Ge,start:Ge?+Me.slice(0,-1):"",loose:!1,items:[]};Me=Ge?"\\d{1,9}\\"+Me.slice(-1):"\\"+Me,this.options.pedantic&&(Me=Ge?Me:"[*+-]");for(var Ue=new RegExp("^( {0,3}"+Me+")((?:[	 ][^\\n]*)?(?:\\n|$))");T&&(Pe=!1,!(!(H=Ue.exec(T))||this.rules.block.hr.test(T)));){if(k=H[0],T=T.substring(k.length),_e=H[2].split(`
`,1)[0],ke=T.split(`
`,1)[0],this.options.pedantic?(J=2,De=_e.trimLeft()):(J=H[2].search(/[^ ]/),J=J>4?1:J,De=_e.slice(J),J+=H[1].length),de=!1,!_e&&/^ *$/.test(ke)&&(k+=ke+`
`,T=T.substring(ke.length+1),Pe=!0),!Pe)for(var Qe=new RegExp("^ {0,"+Math.min(3,J-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),je=new RegExp("^ {0,"+Math.min(3,J-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");T&&(Ie=T.split(`
`,1)[0],_e=Ie,this.options.pedantic&&(_e=_e.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(Qe.test(_e)||je.test(T)));){if(_e.search(/[^ ]/)>=J||!_e.trim())De+=`
`+_e.slice(J);else if(!de)De+=`
`+_e;else break;!de&&!_e.trim()&&(de=!0),k+=Ie+`
`,T=T.substring(Ie.length+1)}He.loose||(Ee?He.loose=!0:/\n *\n *$/.test(k)&&(Ee=!0)),this.options.gfm&&(P=/^\[[ xX]\] /.exec(De),P&&(x=P[0]!=="[ ] ",De=De.replace(/^\[[ xX]\] +/,""))),He.items.push({type:"list_item",raw:k,task:!!P,checked:x,loose:!1,text:De}),He.raw+=k}He.items[He.items.length-1].raw=k.trimRight(),He.items[He.items.length-1].text=De.trimRight(),He.raw=He.raw.trimRight();var Oe=He.items.length;for(he=0;he<Oe;he++){this.lexer.state.top=!1,He.items[he].tokens=this.lexer.blockTokens(He.items[he].text,[]);var q=He.items[he].tokens.filter(function(be){return be.type==="space"}),oe=q.every(function(be){for(var Ce=be.raw.split(""),Te=0,Re=O(Ce),$e;!($e=Re()).done;){var tt=$e.value;if(tt===`
`&&(Te+=1),Te>1)return!0}return!1});!He.loose&&q.length&&oe&&(He.loose=!0,He.items[he].loose=!0)}return He}},R.html=function(T){var H=this.rules.block.html.exec(T);if(H){var k={type:"html",raw:H[0],pre:!this.options.sanitizer&&(H[1]==="pre"||H[1]==="script"||H[1]==="style"),text:H[0]};return this.options.sanitize&&(k.type="paragraph",k.text=this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]),k.tokens=[],this.lexer.inline(k.text,k.tokens)),k}},R.def=function(T){var H=this.rules.block.def.exec(T);if(H){H[3]&&(H[3]=H[3].substring(1,H[3].length-1));var k=H[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:k,raw:H[0],href:H[2],title:H[3]}}},R.table=function(T){var H=this.rules.block.table.exec(T);if(H){var k={type:"table",header:m(H[1]).map(function(Ee){return{text:Ee}}),align:H[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:H[3]&&H[3].trim()?H[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(k.header.length===k.align.length){k.raw=H[0];var P=k.align.length,x,J,he,de;for(x=0;x<P;x++)/^ *-+: *$/.test(k.align[x])?k.align[x]="right":/^ *:-+: *$/.test(k.align[x])?k.align[x]="center":/^ *:-+ *$/.test(k.align[x])?k.align[x]="left":k.align[x]=null;for(P=k.rows.length,x=0;x<P;x++)k.rows[x]=m(k.rows[x],k.header.length).map(function(Ee){return{text:Ee}});for(P=k.header.length,J=0;J<P;J++)k.header[J].tokens=[],this.lexer.inline(k.header[J].text,k.header[J].tokens);for(P=k.rows.length,J=0;J<P;J++)for(de=k.rows[J],he=0;he<de.length;he++)de[he].tokens=[],this.lexer.inline(de[he].text,de[he].tokens);return k}}},R.lheading=function(T){var H=this.rules.block.lheading.exec(T);if(H){var k={type:"heading",raw:H[0],depth:H[2].charAt(0)==="="?1:2,text:H[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},R.paragraph=function(T){var H=this.rules.block.paragraph.exec(T);if(H){var k={type:"paragraph",raw:H[0],text:H[1].charAt(H[1].length-1)===`
`?H[1].slice(0,-1):H[1],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},R.text=function(T){var H=this.rules.block.text.exec(T);if(H){var k={type:"text",raw:H[0],text:H[0],tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},R.escape=function(T){var H=this.rules.inline.escape.exec(T);if(H)return{type:"escape",raw:H[0],text:e(H[1])}},R.tag=function(T){var H=this.rules.inline.tag.exec(T);if(H)return!this.lexer.state.inLink&&/^<a /i.test(H[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(H[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(H[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(H[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:H[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(H[0]):e(H[0]):H[0]}},R.link=function(T){var H=this.rules.inline.link.exec(T);if(H){var k=H[2].trim();if(!this.options.pedantic&&/^</.test(k)){if(!/>$/.test(k))return;var P=W(k.slice(0,-1),"\\");if((k.length-P.length)%2==0)return}else{var x=V(H[2],"()");if(x>-1){var J=H[0].indexOf("!")===0?5:4,he=J+H[1].length+x;H[2]=H[2].substring(0,x),H[0]=H[0].substring(0,he).trim(),H[3]=""}}var de=H[2],Ee="";if(this.options.pedantic){var _e=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(de);_e&&(de=_e[1],Ee=_e[3])}else Ee=H[3]?H[3].slice(1,-1):"";return de=de.trim(),/^</.test(de)&&(this.options.pedantic&&!/>$/.test(k)?de=de.slice(1):de=de.slice(1,-1)),we(H,{href:de&&de.replace(this.rules.inline._escapes,"$1"),title:Ee&&Ee.replace(this.rules.inline._escapes,"$1")},H[0],this.lexer)}},R.reflink=function(T,H){var k;if((k=this.rules.inline.reflink.exec(T))||(k=this.rules.inline.nolink.exec(T))){var P=(k[2]||k[1]).replace(/\s+/g," ");if(P=H[P.toLowerCase()],!P||!P.href){var x=k[0].charAt(0);return{type:"text",raw:x,text:x}}return we(k,P,k[0],this.lexer)}},R.emStrong=function(T,H,k){k===void 0&&(k="");var P=this.rules.inline.emStrong.lDelim.exec(T);if(!!P&&!(P[3]&&k.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var x=P[1]||P[2]||"";if(!x||x&&(k===""||this.rules.inline.punctuation.exec(k))){var J=P[0].length-1,he,de,Ee=J,_e=0,ke=P[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(ke.lastIndex=0,H=H.slice(-1*T.length+J);(P=ke.exec(H))!=null;)if(he=P[1]||P[2]||P[3]||P[4]||P[5]||P[6],!!he){if(de=he.length,P[3]||P[4]){Ee+=de;continue}else if((P[5]||P[6])&&J%3&&!((J+de)%3)){_e+=de;continue}if(Ee-=de,!(Ee>0)){if(de=Math.min(de,de+Ee+_e),Math.min(J,de)%2){var Ie=T.slice(1,J+P.index+de);return{type:"em",raw:T.slice(0,J+P.index+de+1),text:Ie,tokens:this.lexer.inlineTokens(Ie,[])}}var De=T.slice(2,J+P.index+de-1);return{type:"strong",raw:T.slice(0,J+P.index+de+1),text:De,tokens:this.lexer.inlineTokens(De,[])}}}}}},R.codespan=function(T){var H=this.rules.inline.code.exec(T);if(H){var k=H[2].replace(/\n/g," "),P=/[^ ]/.test(k),x=/^ /.test(k)&&/ $/.test(k);return P&&x&&(k=k.substring(1,k.length-1)),k=e(k,!0),{type:"codespan",raw:H[0],text:k}}},R.br=function(T){var H=this.rules.inline.br.exec(T);if(H)return{type:"br",raw:H[0]}},R.del=function(T){var H=this.rules.inline.del.exec(T);if(H)return{type:"del",raw:H[0],text:H[2],tokens:this.lexer.inlineTokens(H[2],[])}},R.autolink=function(T,H){var k=this.rules.inline.autolink.exec(T);if(k){var P,x;return k[2]==="@"?(P=e(this.options.mangle?H(k[1]):k[1]),x="mailto:"+P):(P=e(k[1]),x=P),{type:"link",raw:k[0],text:P,href:x,tokens:[{type:"text",raw:P,text:P}]}}},R.url=function(T,H){var k;if(k=this.rules.inline.url.exec(T)){var P,x;if(k[2]==="@")P=e(this.options.mangle?H(k[0]):k[0]),x="mailto:"+P;else{var J;do J=k[0],k[0]=this.rules.inline._backpedal.exec(k[0])[0];while(J!==k[0]);P=e(k[0]),k[1]==="www."?x="http://"+P:x=P}return{type:"link",raw:k[0],text:P,href:x,tokens:[{type:"text",raw:P,text:P}]}}},R.inlineText=function(T,H){var k=this.rules.inline.text.exec(T);if(k){var P;return this.lexer.state.inRawBlock?P=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(k[0]):e(k[0]):k[0]:P=e(this.options.smartypants?H(k[0]):k[0]),{type:"text",raw:k[0],text:P}}},N}(),ue={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:a,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};ue._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,ue._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,ue.def=y(ue.def).replace("label",ue._label).replace("title",ue._title).getRegex(),ue.bullet=/(?:[*+-]|\d{1,9}[.)])/,ue.listItemStart=y(/^( *)(bull) */).replace("bull",ue.bullet).getRegex(),ue.list=y(ue.list).replace(/bull/g,ue.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+ue.def.source+")").getRegex(),ue._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",ue._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,ue.html=y(ue.html,"i").replace("comment",ue._comment).replace("tag",ue._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),ue.paragraph=y(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.blockquote=y(ue.blockquote).replace("paragraph",ue.paragraph).getRegex(),ue.normal=u({},ue),ue.gfm=u({},ue.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),ue.gfm.table=y(ue.gfm.table).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.gfm.paragraph=y(ue._paragraph).replace("hr",ue.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",ue.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",ue._tag).getRegex(),ue.pedantic=u({},ue.normal,{html:y(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",ue._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:a,paragraph:y(ue.normal._paragraph).replace("hr",ue.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",ue.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var ge={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:a,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:a,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};ge._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",ge.punctuation=y(ge.punctuation).replace(/punctuation/g,ge._punctuation).getRegex(),ge.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,ge.escapedEmSt=/\\\*|\\_/g,ge._comment=y(ue._comment).replace("(?:-->|$)","-->").getRegex(),ge.emStrong.lDelim=y(ge.emStrong.lDelim).replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimAst=y(ge.emStrong.rDelimAst,"g").replace(/punct/g,ge._punctuation).getRegex(),ge.emStrong.rDelimUnd=y(ge.emStrong.rDelimUnd,"g").replace(/punct/g,ge._punctuation).getRegex(),ge._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,ge._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,ge._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,ge.autolink=y(ge.autolink).replace("scheme",ge._scheme).replace("email",ge._email).getRegex(),ge._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,ge.tag=y(ge.tag).replace("comment",ge._comment).replace("attribute",ge._attribute).getRegex(),ge._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,ge._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,ge._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,ge.link=y(ge.link).replace("label",ge._label).replace("href",ge._href).replace("title",ge._title).getRegex(),ge.reflink=y(ge.reflink).replace("label",ge._label).replace("ref",ue._label).getRegex(),ge.nolink=y(ge.nolink).replace("ref",ue._label).getRegex(),ge.reflinkSearch=y(ge.reflinkSearch,"g").replace("reflink",ge.reflink).replace("nolink",ge.nolink).getRegex(),ge.normal=u({},ge),ge.pedantic=u({},ge.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:y(/^!?\[(label)\]\((.*?)\)/).replace("label",ge._label).getRegex(),reflink:y(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",ge._label).getRegex()}),ge.gfm=u({},ge.normal,{escape:y(ge.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),ge.gfm.url=y(ge.gfm.url,"i").replace("email",ge.gfm._extended_email).getRegex(),ge.breaks=u({},ge.gfm,{br:y(ge.br).replace("{2,}","*").getRegex(),text:y(ge.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function ye(N){return N.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function ee(N){var R="",z,T,H=N.length;for(z=0;z<H;z++)T=N.charCodeAt(z),Math.random()>.5&&(T="x"+T.toString(16)),R+="&#"+T+";";return R}var fe=function(){function N(z){this.tokens=[],this.tokens.links=Object.create(null),this.options=z||Z.defaults,this.options.tokenizer=this.options.tokenizer||new ve,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var T={block:ue.normal,inline:ge.normal};this.options.pedantic?(T.block=ue.pedantic,T.inline=ge.pedantic):this.options.gfm&&(T.block=ue.gfm,this.options.breaks?T.inline=ge.breaks:T.inline=ge.gfm),this.tokenizer.rules=T}N.lex=function(T,H){var k=new N(H);return k.lex(T)},N.lexInline=function(T,H){var k=new N(H);return k.inlineTokens(T)};var R=N.prototype;return R.lex=function(T){T=T.replace(/\r\n|\r/g,`
`),this.blockTokens(T,this.tokens);for(var H;H=this.inlineQueue.shift();)this.inlineTokens(H.src,H.tokens);return this.tokens},R.blockTokens=function(T,H){var k=this;H===void 0&&(H=[]),this.options.pedantic?T=T.replace(/\t/g,"    ").replace(/^ +$/gm,""):T=T.replace(/^( *)(\t+)/gm,function(Ee,_e,ke){return _e+"    ".repeat(ke.length)});for(var P,x,J,he;T;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(Ee){return(P=Ee.call({lexer:k},T,H))?(T=T.substring(P.raw.length),H.push(P),!0):!1}))){if(P=this.tokenizer.space(T)){T=T.substring(P.raw.length),P.raw.length===1&&H.length>0?H[H.length-1].raw+=`
`:H.push(P);continue}if(P=this.tokenizer.code(T)){T=T.substring(P.raw.length),x=H[H.length-1],x&&(x.type==="paragraph"||x.type==="text")?(x.raw+=`
`+P.raw,x.text+=`
`+P.text,this.inlineQueue[this.inlineQueue.length-1].src=x.text):H.push(P);continue}if(P=this.tokenizer.fences(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.heading(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.hr(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.blockquote(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.list(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.html(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.def(T)){T=T.substring(P.raw.length),x=H[H.length-1],x&&(x.type==="paragraph"||x.type==="text")?(x.raw+=`
`+P.raw,x.text+=`
`+P.raw,this.inlineQueue[this.inlineQueue.length-1].src=x.text):this.tokens.links[P.tag]||(this.tokens.links[P.tag]={href:P.href,title:P.title});continue}if(P=this.tokenizer.table(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.lheading(T)){T=T.substring(P.raw.length),H.push(P);continue}if(J=T,this.options.extensions&&this.options.extensions.startBlock&&function(){var Ee=1/0,_e=T.slice(1),ke=void 0;k.options.extensions.startBlock.forEach(function(Ie){ke=Ie.call({lexer:this},_e),typeof ke=="number"&&ke>=0&&(Ee=Math.min(Ee,ke))}),Ee<1/0&&Ee>=0&&(J=T.substring(0,Ee+1))}(),this.state.top&&(P=this.tokenizer.paragraph(J))){x=H[H.length-1],he&&x.type==="paragraph"?(x.raw+=`
`+P.raw,x.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=x.text):H.push(P),he=J.length!==T.length,T=T.substring(P.raw.length);continue}if(P=this.tokenizer.text(T)){T=T.substring(P.raw.length),x=H[H.length-1],x&&x.type==="text"?(x.raw+=`
`+P.raw,x.text+=`
`+P.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=x.text):H.push(P);continue}if(T){var de="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(de);break}else throw new Error(de)}}return this.state.top=!0,H},R.inline=function(T,H){this.inlineQueue.push({src:T,tokens:H})},R.inlineTokens=function(T,H){var k=this;H===void 0&&(H=[]);var P,x,J,he=T,de,Ee,_e;if(this.tokens.links){var ke=Object.keys(this.tokens.links);if(ke.length>0)for(;(de=this.tokenizer.rules.inline.reflinkSearch.exec(he))!=null;)ke.includes(de[0].slice(de[0].lastIndexOf("[")+1,-1))&&(he=he.slice(0,de.index)+"["+re("a",de[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(de=this.tokenizer.rules.inline.blockSkip.exec(he))!=null;)he=he.slice(0,de.index)+"["+re("a",de[0].length-2)+"]"+he.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(de=this.tokenizer.rules.inline.escapedEmSt.exec(he))!=null;)he=he.slice(0,de.index)+"++"+he.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;T;)if(Ee||(_e=""),Ee=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(De){return(P=De.call({lexer:k},T,H))?(T=T.substring(P.raw.length),H.push(P),!0):!1}))){if(P=this.tokenizer.escape(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.tag(T)){T=T.substring(P.raw.length),x=H[H.length-1],x&&P.type==="text"&&x.type==="text"?(x.raw+=P.raw,x.text+=P.text):H.push(P);continue}if(P=this.tokenizer.link(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.reflink(T,this.tokens.links)){T=T.substring(P.raw.length),x=H[H.length-1],x&&P.type==="text"&&x.type==="text"?(x.raw+=P.raw,x.text+=P.text):H.push(P);continue}if(P=this.tokenizer.emStrong(T,he,_e)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.codespan(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.br(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.del(T)){T=T.substring(P.raw.length),H.push(P);continue}if(P=this.tokenizer.autolink(T,ee)){T=T.substring(P.raw.length),H.push(P);continue}if(!this.state.inLink&&(P=this.tokenizer.url(T,ee))){T=T.substring(P.raw.length),H.push(P);continue}if(J=T,this.options.extensions&&this.options.extensions.startInline&&function(){var De=1/0,Pe=T.slice(1),Me=void 0;k.options.extensions.startInline.forEach(function(Ge){Me=Ge.call({lexer:this},Pe),typeof Me=="number"&&Me>=0&&(De=Math.min(De,Me))}),De<1/0&&De>=0&&(J=T.substring(0,De+1))}(),P=this.tokenizer.inlineText(J,ye)){T=T.substring(P.raw.length),P.raw.slice(-1)!=="_"&&(_e=P.raw.slice(-1)),Ee=!0,x=H[H.length-1],x&&x.type==="text"?(x.raw+=P.raw,x.text+=P.text):H.push(P);continue}if(T){var Ie="Infinite loop on byte: "+T.charCodeAt(0);if(this.options.silent){console.error(Ie);break}else throw new Error(Ie)}}return H},E(N,null,[{key:"rules",get:function(){return{block:ue,inline:ge}}}]),N}(),te=function(){function N(z){this.options=z||Z.defaults}var R=N.prototype;return R.code=function(T,H,k){var P=(H||"").match(/\S*/)[0];if(this.options.highlight){var x=this.options.highlight(T,P);x!=null&&x!==T&&(k=!0,T=x)}return T=T.replace(/\n$/,"")+`
`,P?'<pre><code class="'+this.options.langPrefix+e(P,!0)+'">'+(k?T:e(T,!0))+`</code></pre>
`:"<pre><code>"+(k?T:e(T,!0))+`</code></pre>
`},R.blockquote=function(T){return`<blockquote>
`+T+`</blockquote>
`},R.html=function(T){return T},R.heading=function(T,H,k,P){if(this.options.headerIds){var x=this.options.headerPrefix+P.slug(k);return"<h"+H+' id="'+x+'">'+T+"</h"+H+`>
`}return"<h"+H+">"+T+"</h"+H+`>
`},R.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},R.list=function(T,H,k){var P=H?"ol":"ul",x=H&&k!==1?' start="'+k+'"':"";return"<"+P+x+`>
`+T+"</"+P+`>
`},R.listitem=function(T){return"<li>"+T+`</li>
`},R.checkbox=function(T){return"<input "+(T?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},R.paragraph=function(T){return"<p>"+T+`</p>
`},R.table=function(T,H){return H&&(H="<tbody>"+H+"</tbody>"),`<table>
<thead>
`+T+`</thead>
`+H+`</table>
`},R.tablerow=function(T){return`<tr>
`+T+`</tr>
`},R.tablecell=function(T,H){var k=H.header?"th":"td",P=H.align?"<"+k+' align="'+H.align+'">':"<"+k+">";return P+T+("</"+k+`>
`)},R.strong=function(T){return"<strong>"+T+"</strong>"},R.em=function(T){return"<em>"+T+"</em>"},R.codespan=function(T){return"<code>"+T+"</code>"},R.br=function(){return this.options.xhtml?"<br/>":"<br>"},R.del=function(T){return"<del>"+T+"</del>"},R.link=function(T,H,k){if(T=b(this.options.sanitize,this.options.baseUrl,T),T===null)return k;var P='<a href="'+e(T)+'"';return H&&(P+=' title="'+H+'"'),P+=">"+k+"</a>",P},R.image=function(T,H,k){if(T=b(this.options.sanitize,this.options.baseUrl,T),T===null)return k;var P='<img src="'+T+'" alt="'+k+'"';return H&&(P+=' title="'+H+'"'),P+=this.options.xhtml?"/>":">",P},R.text=function(T){return T},N}(),X=function(){function N(){}var R=N.prototype;return R.strong=function(T){return T},R.em=function(T){return T},R.codespan=function(T){return T},R.del=function(T){return T},R.html=function(T){return T},R.text=function(T){return T},R.link=function(T,H,k){return""+k},R.image=function(T,H,k){return""+k},R.br=function(){return""},N}(),se=function(){function N(){this.seen={}}var R=N.prototype;return R.serialize=function(T){return T.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},R.getNextSafeSlug=function(T,H){var k=T,P=0;if(this.seen.hasOwnProperty(k)){P=this.seen[T];do P++,k=T+"-"+P;while(this.seen.hasOwnProperty(k))}return H||(this.seen[T]=P,this.seen[k]=0),k},R.slug=function(T,H){H===void 0&&(H={});var k=this.serialize(T);return this.getNextSafeSlug(k,H.dryrun)},N}(),ie=function(){function N(z){this.options=z||Z.defaults,this.options.renderer=this.options.renderer||new te,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new X,this.slugger=new se}N.parse=function(T,H){var k=new N(H);return k.parse(T)},N.parseInline=function(T,H){var k=new N(H);return k.parseInline(T)};var R=N.prototype;return R.parse=function(T,H){H===void 0&&(H=!0);var k="",P,x,J,he,de,Ee,_e,ke,Ie,De,Pe,Me,Ge,He,Ue,Qe,je,Oe,q,oe=T.length;for(P=0;P<oe;P++){if(De=T[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[De.type]&&(q=this.options.extensions.renderers[De.type].call({parser:this},De),q!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(De.type))){k+=q||"";continue}switch(De.type){case"space":continue;case"hr":{k+=this.renderer.hr();continue}case"heading":{k+=this.renderer.heading(this.parseInline(De.tokens),De.depth,v(this.parseInline(De.tokens,this.textRenderer)),this.slugger);continue}case"code":{k+=this.renderer.code(De.text,De.lang,De.escaped);continue}case"table":{for(ke="",_e="",he=De.header.length,x=0;x<he;x++)_e+=this.renderer.tablecell(this.parseInline(De.header[x].tokens),{header:!0,align:De.align[x]});for(ke+=this.renderer.tablerow(_e),Ie="",he=De.rows.length,x=0;x<he;x++){for(Ee=De.rows[x],_e="",de=Ee.length,J=0;J<de;J++)_e+=this.renderer.tablecell(this.parseInline(Ee[J].tokens),{header:!1,align:De.align[J]});Ie+=this.renderer.tablerow(_e)}k+=this.renderer.table(ke,Ie);continue}case"blockquote":{Ie=this.parse(De.tokens),k+=this.renderer.blockquote(Ie);continue}case"list":{for(Pe=De.ordered,Me=De.start,Ge=De.loose,he=De.items.length,Ie="",x=0;x<he;x++)Ue=De.items[x],Qe=Ue.checked,je=Ue.task,He="",Ue.task&&(Oe=this.renderer.checkbox(Qe),Ge?Ue.tokens.length>0&&Ue.tokens[0].type==="paragraph"?(Ue.tokens[0].text=Oe+" "+Ue.tokens[0].text,Ue.tokens[0].tokens&&Ue.tokens[0].tokens.length>0&&Ue.tokens[0].tokens[0].type==="text"&&(Ue.tokens[0].tokens[0].text=Oe+" "+Ue.tokens[0].tokens[0].text)):Ue.tokens.unshift({type:"text",text:Oe}):He+=Oe),He+=this.parse(Ue.tokens,Ge),Ie+=this.renderer.listitem(He,je,Qe);k+=this.renderer.list(Ie,Pe,Me);continue}case"html":{k+=this.renderer.html(De.text);continue}case"paragraph":{k+=this.renderer.paragraph(this.parseInline(De.tokens));continue}case"text":{for(Ie=De.tokens?this.parseInline(De.tokens):De.text;P+1<oe&&T[P+1].type==="text";)De=T[++P],Ie+=`
`+(De.tokens?this.parseInline(De.tokens):De.text);k+=H?this.renderer.paragraph(Ie):Ie;continue}default:{var be='Token with "'+De.type+'" type was not found.';if(this.options.silent){console.error(be);return}else throw new Error(be)}}}return k},R.parseInline=function(T,H){H=H||this.renderer;var k="",P,x,J,he=T.length;for(P=0;P<he;P++){if(x=T[P],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[x.type]&&(J=this.options.extensions.renderers[x.type].call({parser:this},x),J!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(x.type))){k+=J||"";continue}switch(x.type){case"escape":{k+=H.text(x.text);break}case"html":{k+=H.html(x.text);break}case"link":{k+=H.link(x.href,x.title,this.parseInline(x.tokens,H));break}case"image":{k+=H.image(x.href,x.title,x.text);break}case"strong":{k+=H.strong(this.parseInline(x.tokens,H));break}case"em":{k+=H.em(this.parseInline(x.tokens,H));break}case"codespan":{k+=H.codespan(x.text);break}case"br":{k+=H.br();break}case"del":{k+=H.del(this.parseInline(x.tokens,H));break}case"text":{k+=H.text(x.text);break}default:{var de='Token with "'+x.type+'" type was not found.';if(this.options.silent){console.error(de);return}else throw new Error(de)}}}return k},N}();function L(N,R,z){if(typeof N=="undefined"||N===null)throw new Error("marked(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");if(typeof R=="function"&&(z=R,R=null),R=u({},L.defaults,R||{}),ne(R),z){var T=R.highlight,H;try{H=fe.lex(N,R)}catch(J){return z(J)}var k=function(he){var de;if(!he)try{R.walkTokens&&L.walkTokens(H,R.walkTokens),de=ie.parse(H,R)}catch(Ee){he=Ee}return R.highlight=T,he?z(he):z(null,de)};if(!T||T.length<3||(delete R.highlight,!H.length))return k();var P=0;L.walkTokens(H,function(J){J.type==="code"&&(P++,setTimeout(function(){T(J.text,J.lang,function(he,de){if(he)return k(he);de!=null&&de!==J.text&&(J.text=de,J.escaped=!0),P--,P===0&&k()})},0))}),P===0&&k();return}try{var x=fe.lex(N,R);return R.walkTokens&&L.walkTokens(x,R.walkTokens),ie.parse(x,R)}catch(J){if(J.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(J.message+"",!0)+"</pre>";throw J}}L.options=L.setOptions=function(N){return u(L.defaults,N),w(L.defaults),L},L.getDefaults=_,L.defaults=Z.defaults,L.use=function(){for(var N=arguments.length,R=new Array(N),z=0;z<N;z++)R[z]=arguments[z];var T=u.apply(void 0,[{}].concat(R)),H=L.defaults.extensions||{renderers:{},childTokens:{}},k;R.forEach(function(P){if(P.extensions&&(k=!0,P.extensions.forEach(function(J){if(!J.name)throw new Error("extension name required");if(J.renderer){var he=H.renderers?H.renderers[J.name]:null;he?H.renderers[J.name]=function(){for(var de=arguments.length,Ee=new Array(de),_e=0;_e<de;_e++)Ee[_e]=arguments[_e];var ke=J.renderer.apply(this,Ee);return ke===!1&&(ke=he.apply(this,Ee)),ke}:H.renderers[J.name]=J.renderer}if(J.tokenizer){if(!J.level||J.level!=="block"&&J.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");H[J.level]?H[J.level].unshift(J.tokenizer):H[J.level]=[J.tokenizer],J.start&&(J.level==="block"?H.startBlock?H.startBlock.push(J.start):H.startBlock=[J.start]:J.level==="inline"&&(H.startInline?H.startInline.push(J.start):H.startInline=[J.start]))}J.childTokens&&(H.childTokens[J.name]=J.childTokens)})),P.renderer&&function(){var J=L.defaults.renderer||new te,he=function(_e){var ke=J[_e];J[_e]=function(){for(var Ie=arguments.length,De=new Array(Ie),Pe=0;Pe<Ie;Pe++)De[Pe]=arguments[Pe];var Me=P.renderer[_e].apply(J,De);return Me===!1&&(Me=ke.apply(J,De)),Me}};for(var de in P.renderer)he(de);T.renderer=J}(),P.tokenizer&&function(){var J=L.defaults.tokenizer||new ve,he=function(_e){var ke=J[_e];J[_e]=function(){for(var Ie=arguments.length,De=new Array(Ie),Pe=0;Pe<Ie;Pe++)De[Pe]=arguments[Pe];var Me=P.tokenizer[_e].apply(J,De);return Me===!1&&(Me=ke.apply(J,De)),Me}};for(var de in P.tokenizer)he(de);T.tokenizer=J}(),P.walkTokens){var x=L.defaults.walkTokens;T.walkTokens=function(J){P.walkTokens.call(this,J),x&&x.call(this,J)}}k&&(T.extensions=H),L.setOptions(T)})},L.walkTokens=function(N,R){for(var z=function(){var P=H.value;switch(R.call(L,P),P.type){case"table":{for(var x=O(P.header),J;!(J=x()).done;){var he=J.value;L.walkTokens(he.tokens,R)}for(var de=O(P.rows),Ee;!(Ee=de()).done;)for(var _e=Ee.value,ke=O(_e),Ie;!(Ie=ke()).done;){var De=Ie.value;L.walkTokens(De.tokens,R)}break}case"list":{L.walkTokens(P.items,R);break}default:L.defaults.extensions&&L.defaults.extensions.childTokens&&L.defaults.extensions.childTokens[P.type]?L.defaults.extensions.childTokens[P.type].forEach(function(Pe){L.walkTokens(P[Pe],R)}):P.tokens&&L.walkTokens(P.tokens,R)}},T=O(N),H;!(H=T()).done;)z()},L.parseInline=function(N,R){if(typeof N=="undefined"||N===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof N!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(N)+", string expected");R=u({},L.defaults,R||{}),ne(R);try{var z=fe.lexInline(N,R);return R.walkTokens&&L.walkTokens(z,R.walkTokens),ie.parseInline(z,R)}catch(T){if(T.message+=`
Please report this to https://github.com/markedjs/marked.`,R.silent)return"<p>An error occurred:</p><pre>"+e(T.message+"",!0)+"</pre>";throw T}},L.Parser=ie,L.parser=ie.parse,L.Renderer=te,L.TextRenderer=X,L.Lexer=fe,L.lexer=fe.lex,L.Tokenizer=ve,L.Slugger=se,L.parse=L;var $=L.options,G=L.setOptions,B=L.use,h=L.walkTokens,I=L.parseInline,U=L,K=ie.parse,Q=fe.lex;Z.Lexer=fe,Z.Parser=ie,Z.Renderer=te,Z.Slugger=se,Z.TextRenderer=X,Z.Tokenizer=ve,Z.getDefaults=_,Z.lexer=Q,Z.marked=L,Z.options=$,Z.parse=U,Z.parseInline=I,Z.parser=K,Z.setOptions=G,Z.use=B,Z.walkTokens=h,Object.defineProperty(Z,"__esModule",{value:!0})}),define(me[76],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ArrayNavigator=void 0;class E{constructor(M,O=0,_=M.length,w=O-1){this.items=M,this.start=O,this.end=_,this.index=w}current(){return this.index===this.start-1||this.index===this.end?null:this.items[this.index]}next(){return this.index=Math.min(this.index+1,this.end),this.current()}previous(){return this.index=Math.max(this.index-1,this.start-1),this.current()}first(){return this.index=this.start,this.current()}last(){return this.index=this.end-1,this.current()}}t.ArrayNavigator=E}),define(me[77],pe([1,0,76]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryNavigator2=t.HistoryNavigator=void 0;class i{constructor(_=[],w=10){this._initialize(_),this._limit=w,this._onChange()}getHistory(){return this._elements}add(_){this._history.delete(_),this._history.add(_),this._onChange()}next(){return this._currentPosition()!==this._elements.length-1?this._navigator.next():null}previous(){return this._currentPosition()!==0?this._navigator.previous():null}current(){return this._navigator.current()}first(){return this._navigator.first()}last(){return this._navigator.last()}has(_){return this._history.has(_)}clear(){this._initialize([]),this._onChange()}_onChange(){this._reduceToLimit();const _=this._elements;this._navigator=new E.ArrayNavigator(_,0,_.length,_.length)}_reduceToLimit(){const _=this._elements;_.length>this._limit&&this._initialize(_.slice(_.length-this._limit))}_currentPosition(){const _=this._navigator.current();return _?this._elements.indexOf(_):-1}_initialize(_){this._history=new Set;for(const w of _)this._history.add(w)}get _elements(){const _=[];return this._history.forEach(w=>_.push(w)),_}}t.HistoryNavigator=i;class M{constructor(_,w=10){if(this.capacity=w,_.length<1)throw new Error("not supported");this.size=1,this.head=this.tail=this.cursor={value:_[0],previous:void 0,next:void 0};for(let g=1;g<_.length;g++)this.add(_[g])}add(_){const w={value:_,previous:this.tail,next:void 0};for(this.tail.next=w,this.tail=w,this.cursor=this.tail,this.size++;this.size>this.capacity;)this.head=this.head.next,this.head.previous=void 0,this.size--}replaceLast(_){const w=this.tail.value;return this.tail.value=_,w}isAtEnd(){return this.cursor===this.tail}current(){return this.cursor.value}previous(){return this.cursor.previous&&(this.cursor=this.cursor.previous),this.cursor.value}next(){return this.cursor.next&&(this.cursor=this.cursor.next),this.cursor.value}has(_){let w=this.head;for(;w;){if(w.value===_)return!0;w=w.next}return!1}resetCursor(){return this.cursor=this.tail,this.cursor.value}*[Symbol.iterator](){let _=this.head;for(;_;)yield _.value,_=_.next}}t.HistoryNavigator2=M}),define(me[44],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SlidingWindowAverage=t.MovingAverage=t.Counter=t.rot=t.clamp=void 0;function E(w,g,d){return Math.min(Math.max(w,g),d)}t.clamp=E;function i(w,g){return(g+w%g)%g}t.rot=i;class M{constructor(){this._next=0}getNext(){return this._next++}}t.Counter=M;class O{constructor(){this._n=1,this._val=0}update(g){return this._val=this._val+(g-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}t.MovingAverage=O;class _{constructor(g){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(g),this._values.fill(0,0,g)}update(g){const d=this._values[this._index];return this._values[this._index]=g,this._index=(this._index+1)%this._values.length,this._sum-=d,this._sum+=g,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}t.SlidingWindowAverage=_}),define(me[45],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Range=void 0;var E;(function(i){function M(g,d){if(g.start>=d.end||d.start>=g.end)return{start:0,end:0};const f=Math.max(g.start,d.start),F=Math.min(g.end,d.end);return F-f<=0?{start:0,end:0}:{start:f,end:F}}i.intersect=M;function O(g){return g.end-g.start<=0}i.isEmpty=O;function _(g,d){return!O(M(g,d))}i.intersects=_;function w(g,d){const f=[],F={start:g.start,end:Math.min(d.start,g.end)},l={start:Math.max(d.end,g.start),end:g.end};return O(F)||f.push(F),O(l)||f.push(l),f}i.relativeComplement=w})(E=t.Range||(t.Range={}))}),define(me[78],pe([1,0,45]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RangeMap=t.consolidate=t.shift=t.groupIntersect=void 0;function i(g,d){const f=[];for(const F of d){if(g.start>=F.range.end)continue;if(g.end<F.range.start)break;const l=E.Range.intersect(g,F.range);E.Range.isEmpty(l)||f.push({range:l,size:F.size})}return f}t.groupIntersect=i;function M({start:g,end:d},f){return{start:g+f,end:d+f}}t.shift=M;function O(g){const d=[];let f=null;for(const F of g){const l=F.range.start,s=F.range.end,e=F.size;if(f&&e===f.size){f.range.end=s;continue}f={range:{start:l,end:s},size:e},d.push(f)}return d}t.consolidate=O;function _(...g){return O(g.reduce((d,f)=>d.concat(f),[]))}class w{constructor(){this.groups=[],this._size=0}splice(d,f,F=[]){const l=F.length-f,s=i({start:0,end:d},this.groups),e=i({start:d+f,end:Number.POSITIVE_INFINITY},this.groups).map(v=>({range:M(v.range,l),size:v.size})),p=F.map((v,D)=>({range:{start:d+D,end:d+D+1},size:v.size}));this.groups=_(s,p,e),this._size=this.groups.reduce((v,D)=>v+D.size*(D.range.end-D.range.start),0)}get count(){const d=this.groups.length;return d?this.groups[d-1].range.end:0}get size(){return this._size}indexAt(d){if(d<0)return-1;let f=0,F=0;for(const l of this.groups){const s=l.range.end-l.range.start,e=F+s*l.size;if(d<e)return f+Math.floor((d-F)/l.size);f+=s,F=e}return f}indexAfter(d){return Math.min(this.indexAt(d)+1,this.count)}positionAt(d){if(d<0)return-1;let f=0,F=0;for(const l of this.groups){const s=l.range.end-l.range.start,e=F+s;if(d<e)return f+(d-F)*l.size;f+=s*l.size,F=e}return-1}}t.RangeMap=w}),define(me[79],pe([1,0,13,2]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function M(c){const b=c;return b?typeof b.read=="function":!1}t.isReadable=M;function O(c){const b=c;return b?[b.on,b.pause,b.resume,b.destroy].every(S=>typeof S=="function"):!1}t.isReadableStream=O;function _(c){const b=c;return b?O(b.stream)&&Array.isArray(b.buffer)&&typeof b.ended=="boolean":!1}t.isReadableBufferedStream=_;function w(c,b){return new g(c,b)}t.newWriteableStream=w;class g{constructor(b,S){this.reducer=b,this.options=S,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(b){if(!this.state.destroyed){if(this.state.flowing)this.emitData(b);else if(this.buffer.data.push(b),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(S=>this.pendingWritePromises.push(S))}}error(b){this.state.destroyed||(this.state.flowing?this.emitError(b):this.buffer.error.push(b))}end(b){this.state.destroyed||(typeof b!="undefined"&&this.write(b),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(b){this.listeners.data.slice(0).forEach(S=>S(b))}emitError(b){this.listeners.error.length===0?(0,E.onUnexpectedError)(b):this.listeners.error.slice(0).forEach(S=>S(b))}emitEnd(){this.listeners.end.slice(0).forEach(b=>b())}on(b,S){if(!this.state.destroyed)switch(b){case"data":this.listeners.data.push(S),this.resume();break;case"end":this.listeners.end.push(S),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(S),this.state.flowing&&this.flowErrors();break}}removeListener(b,S){if(this.state.destroyed)return;let A;switch(b){case"data":A=this.listeners.data;break;case"end":A=this.listeners.end;break;case"error":A=this.listeners.error;break}if(A){const C=A.indexOf(S);C>=0&&A.splice(C,1)}}flowData(){if(this.buffer.data.length>0){const b=this.reducer(this.buffer.data);this.emitData(b),this.buffer.data.length=0;const S=[...this.pendingWritePromises];this.pendingWritePromises.length=0,S.forEach(A=>A())}}flowErrors(){if(this.listeners.error.length>0){for(const b of this.buffer.error)this.emitError(b);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(c,b){const S=[];let A;for(;(A=c.read())!==null;)S.push(A);return b(S)}t.consumeReadable=d;function f(c,b,S){const A=[];let C;for(;(C=c.read())!==null&&A.length<S;)A.push(C);return C===null&&A.length>0?b(A):{read:()=>{if(A.length>0)return A.shift();if(typeof C!="undefined"){const r=C;return C=void 0,r}return c.read()}}}t.peekReadable=f;function F(c,b){return new Promise((S,A)=>{const C=[];l(c,{onData:r=>{b&&C.push(r)},onError:r=>{b?A(r):S(void 0)},onEnd:()=>{S(b?b(C):void 0)}})})}t.consumeStream=F;function l(c,b){let S=!1;return c.on("error",A=>{S||b.onError(A)}),c.on("end",()=>{S||b.onEnd()}),c.on("data",A=>{S||b.onData(A)}),(0,i.toDisposable)(()=>S=!0)}t.listenStream=l;function s(c,b){return new Promise((S,A)=>{const C=new i.DisposableStore,r=[],n=m=>{if(r.push(m),r.length>b)return C.dispose(),c.pause(),S({stream:c,buffer:r,ended:!1})},a=m=>A(m),u=()=>S({stream:c,buffer:r,ended:!0});C.add((0,i.toDisposable)(()=>c.removeListener("error",a))),c.on("error",a),C.add((0,i.toDisposable)(()=>c.removeListener("end",u))),c.on("end",u),C.add((0,i.toDisposable)(()=>c.removeListener("data",n))),c.on("data",n)})}t.peekStream=s;function e(c,b){const S=w(b);return S.end(c),S}t.toStream=e;function p(){const c=w(()=>{throw new Error("not supported")});return c.end(),c}t.emptyStream=p;function v(c){let b=!1;return{read:()=>b?null:(b=!0,c)}}t.toReadable=v;function D(c,b,S){const A=w(S);return l(c,{onData:C=>A.write(b.data(C)),onError:C=>A.error(b.error?b.error(C):C),onEnd:()=>A.end()}),A}t.transform=D;function y(c,b,S){let A=!1;return{read:()=>{const C=b.read();return A?C:(A=!0,C!==null?S([c,C]):c)}}}t.prefixedReadable=y;function o(c,b,S){let A=!1;const C=w(S);return l(b,{onData:r=>A?C.write(r):(A=!0,C.write(S([c,r]))),onError:r=>C.error(r),onEnd:()=>{A||(A=!0,C.write(c)),C.end()}}),C}t.prefixedStream=o}),define(me[31],pe([1,0,79]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const i=typeof Buffer!="undefined";let M,O;class _{constructor(m){this.buffer=m,this.byteLength=this.buffer.byteLength}static alloc(m){return i?new _(Buffer.allocUnsafe(m)):new _(new Uint8Array(m))}static wrap(m){return i&&!Buffer.isBuffer(m)&&(m=Buffer.from(m.buffer,m.byteOffset,m.byteLength)),new _(m)}static fromString(m,W){return!(W?.dontUseNodeBuffer||!1)&&i?new _(Buffer.from(m)):(M||(M=new TextEncoder),new _(M.encode(m)))}static fromByteArray(m){const W=_.alloc(m.length);for(let V=0,ne=m.length;V<ne;V++)W.buffer[V]=m[V];return W}static concat(m,W){if(typeof W=="undefined"){W=0;for(let re=0,we=m.length;re<we;re++)W+=m[re].byteLength}const V=_.alloc(W);let ne=0;for(let re=0,we=m.length;re<we;re++){const ae=m[re];V.set(ae,ne),ne+=ae.byteLength}return V}clone(){const m=_.alloc(this.byteLength);return m.set(this),m}toString(){return i?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(m,W){return new _(this.buffer.subarray(m,W))}set(m,W){if(m instanceof _)this.buffer.set(m.buffer,W);else if(m instanceof Uint8Array)this.buffer.set(m,W);else if(m instanceof ArrayBuffer)this.buffer.set(new Uint8Array(m),W);else if(ArrayBuffer.isView(m))this.buffer.set(new Uint8Array(m.buffer,m.byteOffset,m.byteLength),W);else throw new Error("Unknown argument 'array'")}readUInt32BE(m){return d(this.buffer,m)}writeUInt32BE(m,W){f(this.buffer,m,W)}readUInt32LE(m){return F(this.buffer,m)}writeUInt32LE(m,W){l(this.buffer,m,W)}readUInt8(m){return s(this.buffer,m)}writeUInt8(m,W){e(this.buffer,m,W)}}t.VSBuffer=_;function w(u,m){return u[m+0]<<0>>>0|u[m+1]<<8>>>0}t.readUInt16LE=w;function g(u,m,W){u[W+0]=m&255,m=m>>>8,u[W+1]=m&255}t.writeUInt16LE=g;function d(u,m){return u[m]*2**24+u[m+1]*2**16+u[m+2]*2**8+u[m+3]}t.readUInt32BE=d;function f(u,m,W){u[W+3]=m,m=m>>>8,u[W+2]=m,m=m>>>8,u[W+1]=m,m=m>>>8,u[W]=m}t.writeUInt32BE=f;function F(u,m){return u[m+0]<<0>>>0|u[m+1]<<8>>>0|u[m+2]<<16>>>0|u[m+3]<<24>>>0}t.readUInt32LE=F;function l(u,m,W){u[W+0]=m&255,m=m>>>8,u[W+1]=m&255,m=m>>>8,u[W+2]=m&255,m=m>>>8,u[W+3]=m&255}t.writeUInt32LE=l;function s(u,m){return u[m]}t.readUInt8=s;function e(u,m,W){u[W]=m}t.writeUInt8=e;function p(u){return E.consumeReadable(u,m=>_.concat(m))}t.readableToBuffer=p;function v(u){return E.toReadable(u)}t.bufferToReadable=v;function D(u){return E.consumeStream(u,m=>_.concat(m))}t.streamToBuffer=D;async function y(u){return u.ended?_.concat(u.buffer):_.concat([...u.buffer,await D(u.stream)])}t.bufferedStreamToBuffer=y;function o(u){return E.toStream(u,m=>_.concat(m))}t.bufferToStream=o;function c(u){return E.transform(u,{data:m=>typeof m=="string"?_.fromString(m):_.wrap(m)},m=>_.concat(m))}t.streamToBufferReadableStream=c;function b(u){return E.newWriteableStream(m=>_.concat(m),u)}t.newWriteableBufferStream=b;function S(u,m){return E.prefixedReadable(u,m,W=>_.concat(W))}t.prefixedBufferReadable=S;function A(u,m){return E.prefixedStream(u,m,W=>_.concat(W))}t.prefixedBufferStream=A;function C(u){let m=0,W=0,V=0;const ne=new Uint8Array(Math.floor(u.length/4*3)),re=ae=>{switch(W){case 3:ne[V++]=m|ae,W=0;break;case 2:ne[V++]=m|ae>>>2,m=ae<<6,W=3;break;case 1:ne[V++]=m|ae>>>4,m=ae<<4,W=2;break;default:m=ae<<2,W=1}};for(let ae=0;ae<u.length;ae++){const ve=u.charCodeAt(ae);if(ve>=65&&ve<=90)re(ve-65);else if(ve>=97&&ve<=122)re(ve-97+26);else if(ve>=48&&ve<=57)re(ve-48+52);else if(ve===43||ve===45)re(62);else if(ve===47||ve===95)re(63);else{if(ve===61)break;throw new SyntaxError(`Unexpected base64 character ${u[ae]}`)}}const we=V;for(;W>0;)re(0);return _.wrap(ne).slice(0,we)}t.decodeBase64=C;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function a({buffer:u},m=!0,W=!1){const V=W?n:r;let ne="";const re=u.byteLength%3;let we=0;for(;we<u.byteLength-re;we+=3){const ae=u[we+0],ve=u[we+1],ue=u[we+2];ne+=V[ae>>>2],ne+=V[(ae<<4|ve>>>4)&63],ne+=V[(ve<<2|ue>>>6)&63],ne+=V[ue&63]}if(re===1){const ae=u[we+0];ne+=V[ae>>>2],ne+=V[ae<<4&63],m&&(ne+="==")}else if(re===2){const ae=u[we+0],ve=u[we+1];ne+=V[ae>>>2],ne+=V[(ae<<4|ve>>>4)&63],ne+=V[ve<<2&63],m&&(ne+="=")}return ne}t.encodeBase64=a}),define(me[6],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.withUndefinedAsNull=t.withNullAsUndefined=t.validateConstraint=t.validateConstraints=t.areFunctions=t.isFunction=t.isEmptyObject=t.assertAllDefined=t.assertIsDefined=t.assertType=t.isUndefinedOrNull=t.isDefined=t.isUndefined=t.isBoolean=t.isIterable=t.isNumber=t.isTypedArray=t.isObject=t.isStringArray=t.isString=void 0;function E(A){return typeof A=="string"}t.isString=E;function i(A){return Array.isArray(A)&&A.every(C=>E(C))}t.isStringArray=i;function M(A){return typeof A=="object"&&A!==null&&!Array.isArray(A)&&!(A instanceof RegExp)&&!(A instanceof Date)}t.isObject=M;function O(A){const C=Object.getPrototypeOf(Uint8Array);return typeof A=="object"&&A instanceof C}t.isTypedArray=O;function _(A){return typeof A=="number"&&!isNaN(A)}t.isNumber=_;function w(A){return!!A&&typeof A[Symbol.iterator]=="function"}t.isIterable=w;function g(A){return A===!0||A===!1}t.isBoolean=g;function d(A){return typeof A=="undefined"}t.isUndefined=d;function f(A){return!F(A)}t.isDefined=f;function F(A){return d(A)||A===null}t.isUndefinedOrNull=F;function l(A,C){if(!A)throw new Error(C?`Unexpected type, expected '${C}'`:"Unexpected type")}t.assertType=l;function s(A){if(F(A))throw new Error("Assertion Failed: argument is undefined or null");return A}t.assertIsDefined=s;function e(...A){const C=[];for(let r=0;r<A.length;r++){const n=A[r];if(F(n))throw new Error(`Assertion Failed: argument at index ${r} is undefined or null`);C.push(n)}return C}t.assertAllDefined=e;const p=Object.prototype.hasOwnProperty;function v(A){if(!M(A))return!1;for(const C in A)if(p.call(A,C))return!1;return!0}t.isEmptyObject=v;function D(A){return typeof A=="function"}t.isFunction=D;function y(...A){return A.length>0&&A.every(D)}t.areFunctions=y;function o(A,C){const r=Math.min(A.length,C.length);for(let n=0;n<r;n++)c(A[n],C[n])}t.validateConstraints=o;function c(A,C){if(E(C)){if(typeof A!==C)throw new Error(`argument does not match constraint: typeof ${C}`)}else if(D(C)){try{if(A instanceof C)return}catch{}if(!F(A)&&A.constructor===C||C.length===1&&C.call(void 0,A)===!0)return;throw new Error("argument does not match one of these constraints: arg instanceof constraint, arg.constructor === constraint, nor constraint(arg) === true")}}t.validateConstraint=c;function b(A){return A===null?void 0:A}t.withNullAsUndefined=b;function S(A){return typeof A=="undefined"?null:A}t.withUndefinedAsNull=S}),define(me[27],pe([1,0,6]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function i(D){if(!D||typeof D!="object"||D instanceof RegExp)return D;const y=Array.isArray(D)?[]:{};return Object.keys(D).forEach(o=>{D[o]&&typeof D[o]=="object"?y[o]=i(D[o]):y[o]=D[o]}),y}t.deepClone=i;function M(D){if(!D||typeof D!="object")return D;const y=[D];for(;y.length>0;){const o=y.shift();Object.freeze(o);for(const c in o)if(O.call(o,c)){const b=o[c];typeof b=="object"&&!Object.isFrozen(b)&&!(0,E.isTypedArray)(b)&&y.push(b)}}return D}t.deepFreeze=M;const O=Object.prototype.hasOwnProperty;function _(D,y){return w(D,y,new Set)}t.cloneAndChange=_;function w(D,y,o){if((0,E.isUndefinedOrNull)(D))return D;const c=y(D);if(typeof c!="undefined")return c;if(Array.isArray(D)){const b=[];for(const S of D)b.push(w(S,y,o));return b}if((0,E.isObject)(D)){if(o.has(D))throw new Error("Cannot clone recursive data-structure");o.add(D);const b={};for(const S in D)O.call(D,S)&&(b[S]=w(D[S],y,o));return o.delete(D),b}return D}function g(D,y,o=!0){return(0,E.isObject)(D)?((0,E.isObject)(y)&&Object.keys(y).forEach(c=>{c in D?o&&((0,E.isObject)(D[c])&&(0,E.isObject)(y[c])?g(D[c],y[c],o):D[c]=y[c]):D[c]=y[c]}),D):y}t.mixin=g;function d(D,y){if(D===y)return!0;if(D==null||y===null||y===void 0||typeof D!=typeof y||typeof D!="object"||Array.isArray(D)!==Array.isArray(y))return!1;let o,c;if(Array.isArray(D)){if(D.length!==y.length)return!1;for(o=0;o<D.length;o++)if(!d(D[o],y[o]))return!1}else{const b=[];for(c in D)b.push(c);b.sort();const S=[];for(c in y)S.push(c);if(S.sort(),!d(b,S))return!1;for(o=0;o<b.length;o++)if(!d(D[b[o]],y[b[o]]))return!1}return!0}t.equals=d;function f(D){const y=new Set;return JSON.stringify(D,(o,c)=>{if((0,E.isObject)(c)||Array.isArray(c)){if(y.has(c))return"[Circular]";y.add(c)}return c})}t.safeStringify=f;function F(D,y){const o=Object.create(null);return!D||!y||Object.keys(y).forEach(b=>{const S=D[b],A=y[b];d(S,A)||(o[b]=A)}),o}t.distinct=F;function l(D,y){const o=y.toLowerCase(),c=Object.keys(D).find(b=>b.toLowerCase()===o);return c?D[c]:D[y]}t.getCaseInsensitive=l;function s(D,y){const o=Object.create(null);for(const[c,b]of Object.entries(D))y(c,b)&&(o[c]=b);return o}t.filter=s;function e(D){let y=[],o=Object.getPrototypeOf(D);for(;Object.prototype!==o;)y=y.concat(Object.getOwnPropertyNames(o)),o=Object.getPrototypeOf(o);return y}t.getAllPropertyNames=e;function p(D){const y=[];for(const o of e(D))typeof D[o]=="function"&&y.push(o);return y}t.getAllMethodNames=p;function v(D,y){const o=b=>function(){const S=Array.prototype.slice.call(arguments,0);return y(b,S)},c={};for(const b of D)c[b]=o(b);return c}t.createProxyObject=v}),define(me[80],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CONTEXT_MENU_CLOSE_CHANNEL=t.CONTEXT_MENU_CHANNEL=void 0,t.CONTEXT_MENU_CHANNEL="vscode:contextmenu",t.CONTEXT_MENU_CLOSE_CHANNEL="vscode:onCloseContextMenu"}),define(me[81],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Protocol=void 0;class E{constructor(M,O){this.sender=M,this.onMessage=O}send(M){try{this.sender.send("vscode:message",M.buffer)}catch{}}disconnect(){this.sender.send("vscode:disconnect",null)}}t.Protocol=E}),define(me[46],pe([7]),{}),define(me[82],pe([7]),{}),define(me[83],pe([7]),{}),define(me[84],pe([7]),{}),define(me[85],pe([1,0,11,83,84]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.formatRule=void 0;function i(M){let O=M.definition;for(;O instanceof E.Codicon;)O=O.definition;return`.codicon-${M.id}:before { content: '${O.fontCharacter}'; }`}t.formatRule=i}),define(me[86],pe([7]),{}),define(me[87],pe([7]),{}),define(me[88],pe([7]),{}),define(me[89],pe([7]),{}),define(me[90],pe([7]),{}),define(me[91],pe([7]),{}),define(me[92],pe([7]),{}),define(me[93],pe([7]),{}),define(me[94],pe([7]),{}),define(me[95],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/actionbar/actionViewItems",t)}),define(me[96],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInput",t)}),define(me[97],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/findinput/findInputToggles",t)}),define(me[98],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/iconLabel/iconLabelHover",t)}),define(me[99],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/inputbox/inputBox",t)}),define(me[100],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/selectBox/selectBoxCustom",t)}),define(me[101],pe([12,9]),function(Z,t){return Z.create("vs/base/browser/ui/tree/abstractTree",t)}),define(me[102],pe([12,9]),function(Z,t){return Z.create("vs/base/common/actions",t)}),define(me[103],pe([12,9]),function(Z,t){return Z.create("vs/base/common/platform",t)}),define(me[5],pe([1,0,103]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isAndroid=t.isEdge=t.isSafari=t.isFirefox=t.isChrome=t.isLittleEndian=t.OS=t.OperatingSystem=t.setTimeout0=t.setTimeout0IsFaster=t.translationsConfigFile=t.locale=t.Language=t.language=t.userAgent=t.platform=t.isCI=t.isIOS=t.isWebWorker=t.isWeb=t.isElectron=t.isNative=t.isLinuxSnap=t.isLinux=t.isMacintosh=t.isWindows=t.PlatformToString=t.Platform=t.globals=void 0;const i="en";let M=!1,O=!1,_=!1,w=!1,g=!1,d=!1,f=!1,F=!1,l=!1,s,e=i,p,v;t.globals=typeof self=="object"?self:typeof global=="object"?global:{};let D;typeof t.globals.vscode!="undefined"&&typeof t.globals.vscode.process!="undefined"?D=t.globals.vscode.process:typeof process!="undefined"&&(D=process);const y=typeof D?.versions?.electron=="string",o=y&&D?.type==="renderer";if(typeof navigator=="object"&&!o)v=navigator.userAgent,M=v.indexOf("Windows")>=0,O=v.indexOf("Macintosh")>=0,F=(v.indexOf("Macintosh")>=0||v.indexOf("iPad")>=0||v.indexOf("iPhone")>=0)&&!!navigator.maxTouchPoints&&navigator.maxTouchPoints>0,_=v.indexOf("Linux")>=0,d=!0,s=E.getConfiguredDefaultLocale(E.localize(0,null))||i,e=s;else if(typeof D=="object"){M=D.platform==="win32",O=D.platform==="darwin",_=D.platform==="linux",w=_&&!!D.env.SNAP&&!!D.env.SNAP_REVISION,f=y,l=!!D.env.CI||!!D.env.BUILD_ARTIFACTSTAGINGDIRECTORY,s=i,e=i;const u=D.env.VSCODE_NLS_CONFIG;if(u)try{const m=JSON.parse(u),W=m.availableLanguages["*"];s=m.locale,e=W||i,p=m._translationsConfigFile}catch{}g=!0}else console.error("Unable to resolve platform.");var c;(function(u){u[u.Web=0]="Web",u[u.Mac=1]="Mac",u[u.Linux=2]="Linux",u[u.Windows=3]="Windows"})(c=t.Platform||(t.Platform={}));function b(u){switch(u){case 0:return"Web";case 1:return"Mac";case 2:return"Linux";case 3:return"Windows"}}t.PlatformToString=b;let S=0;O?S=1:M?S=3:_&&(S=2),t.isWindows=M,t.isMacintosh=O,t.isLinux=_,t.isLinuxSnap=w,t.isNative=g,t.isElectron=f,t.isWeb=d,t.isWebWorker=d&&typeof t.globals.importScripts=="function",t.isIOS=F,t.isCI=l,t.platform=S,t.userAgent=v,t.language=e;var A;(function(u){function m(){return t.language}u.value=m;function W(){return t.language.length===2?t.language==="en":t.language.length>=3?t.language[0]==="e"&&t.language[1]==="n"&&t.language[2]==="-":!1}u.isDefaultVariant=W;function V(){return t.language==="en"}u.isDefault=V})(A=t.Language||(t.Language={})),t.locale=s,t.translationsConfigFile=p,t.setTimeout0IsFaster=typeof t.globals.postMessage=="function"&&!t.globals.importScripts,t.setTimeout0=(()=>{if(t.setTimeout0IsFaster){const u=[];t.globals.addEventListener("message",W=>{if(W.data&&W.data.vscodeScheduleAsyncWork)for(let V=0,ne=u.length;V<ne;V++){const re=u[V];if(re.id===W.data.vscodeScheduleAsyncWork){u.splice(V,1),re.callback();return}}});let m=0;return W=>{const V=++m;u.push({id:V,callback:W}),t.globals.postMessage({vscodeScheduleAsyncWork:V},"*")}}return u=>setTimeout(u)})();var C;(function(u){u[u.Windows=1]="Windows",u[u.Macintosh=2]="Macintosh",u[u.Linux=3]="Linux"})(C=t.OperatingSystem||(t.OperatingSystem={})),t.OS=O||F?2:M?1:3;let r=!0,n=!1;function a(){if(!n){n=!0;const u=new Uint8Array(2);u[0]=1,u[1]=2,r=new Uint16Array(u.buffer)[0]===(2<<8)+1}return r}t.isLittleEndian=a,t.isChrome=!!(t.userAgent&&t.userAgent.indexOf("Chrome")>=0),t.isFirefox=!!(t.userAgent&&t.userAgent.indexOf("Firefox")>=0),t.isSafari=!!(!t.isChrome&&t.userAgent&&t.userAgent.indexOf("Safari")>=0),t.isEdge=!!(t.userAgent&&t.userAgent.indexOf("Edg/")>=0),t.isAndroid=!!(t.userAgent&&t.userAgent.indexOf("Android")>=0)}),define(me[104],pe([1,0,5]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.arch=t.platform=t.env=t.cwd=void 0;let i;if(typeof E.globals.vscode!="undefined"&&typeof E.globals.vscode.process!="undefined"){const M=E.globals.vscode.process;i={get platform(){return M.platform},get arch(){return M.arch},get env(){return M.env},cwd(){return M.cwd()}}}else typeof process!="undefined"?i={get platform(){return process.platform},get arch(){return process.arch},get env(){return process.env},cwd(){return process.env.VSCODE_CWD||process.cwd()}}:i={get platform(){return E.isWindows?"win32":E.isMacintosh?"darwin":"linux"},get arch(){},get env(){return{}},cwd(){return"/"}};t.cwd=i.cwd,t.env=i.env,t.platform=i.platform,t.arch=i.arch}),define(me[21],pe([1,0,104]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.delimiter=t.sep=t.toNamespacedPath=t.parse=t.format=t.extname=t.basename=t.dirname=t.relative=t.resolve=t.join=t.isAbsolute=t.normalize=t.posix=t.win32=void 0;const i=65,M=97,O=90,_=122,w=46,g=47,d=92,f=58,F=63;class l extends Error{constructor(c,b,S){let A;typeof b=="string"&&b.indexOf("not ")===0?(A="must not be",b=b.replace(/^not /,"")):A="must be";const C=c.indexOf(".")!==-1?"property":"argument";let r=`The "${c}" ${C} ${A} of type ${b}`;r+=`. Received type ${typeof S}`;super(r);this.code="ERR_INVALID_ARG_TYPE"}}function s(o,c){if(typeof o!="string")throw new l(c,"string",o)}function e(o){return o===g||o===d}function p(o){return o===g}function v(o){return o>=i&&o<=O||o>=M&&o<=_}function D(o,c,b,S){let A="",C=0,r=-1,n=0,a=0;for(let u=0;u<=o.length;++u){if(u<o.length)a=o.charCodeAt(u);else{if(S(a))break;a=g}if(S(a)){if(!(r===u-1||n===1))if(n===2){if(A.length<2||C!==2||A.charCodeAt(A.length-1)!==w||A.charCodeAt(A.length-2)!==w){if(A.length>2){const m=A.lastIndexOf(b);m===-1?(A="",C=0):(A=A.slice(0,m),C=A.length-1-A.lastIndexOf(b)),r=u,n=0;continue}else if(A.length!==0){A="",C=0,r=u,n=0;continue}}c&&(A+=A.length>0?`${b}..`:"..",C=2)}else A.length>0?A+=`${b}${o.slice(r+1,u)}`:A=o.slice(r+1,u),C=u-r-1;r=u,n=0}else a===w&&n!==-1?++n:n=-1}return A}function y(o,c){if(c===null||typeof c!="object")throw new l("pathObject","Object",c);const b=c.dir||c.root,S=c.base||`${c.name||""}${c.ext||""}`;return b?b===c.root?`${b}${S}`:`${b}${o}${S}`:S}t.win32={resolve(...o){let c="",b="",S=!1;for(let A=o.length-1;A>=-1;A--){let C;if(A>=0){if(C=o[A],s(C,"path"),C.length===0)continue}else c.length===0?C=E.cwd():(C=E.env[`=${c}`]||E.cwd(),(C===void 0||C.slice(0,2).toLowerCase()!==c.toLowerCase()&&C.charCodeAt(2)===d)&&(C=`${c}\\`));const r=C.length;let n=0,a="",u=!1;const m=C.charCodeAt(0);if(r===1)e(m)&&(n=1,u=!0);else if(e(m))if(u=!0,e(C.charCodeAt(1))){let W=2,V=W;for(;W<r&&!e(C.charCodeAt(W));)W++;if(W<r&&W!==V){const ne=C.slice(V,W);for(V=W;W<r&&e(C.charCodeAt(W));)W++;if(W<r&&W!==V){for(V=W;W<r&&!e(C.charCodeAt(W));)W++;(W===r||W!==V)&&(a=`\\\\${ne}\\${C.slice(V,W)}`,n=W)}}}else n=1;else v(m)&&C.charCodeAt(1)===f&&(a=C.slice(0,2),n=2,r>2&&e(C.charCodeAt(2))&&(u=!0,n=3));if(a.length>0)if(c.length>0){if(a.toLowerCase()!==c.toLowerCase())continue}else c=a;if(S){if(c.length>0)break}else if(b=`${C.slice(n)}\\${b}`,S=u,u&&c.length>0)break}return b=D(b,!S,"\\",e),S?`${c}\\${b}`:`${c}${b}`||"."},normalize(o){s(o,"path");const c=o.length;if(c===0)return".";let b=0,S,A=!1;const C=o.charCodeAt(0);if(c===1)return p(C)?"\\":o;if(e(C))if(A=!0,e(o.charCodeAt(1))){let n=2,a=n;for(;n<c&&!e(o.charCodeAt(n));)n++;if(n<c&&n!==a){const u=o.slice(a,n);for(a=n;n<c&&e(o.charCodeAt(n));)n++;if(n<c&&n!==a){for(a=n;n<c&&!e(o.charCodeAt(n));)n++;if(n===c)return`\\\\${u}\\${o.slice(a)}\\`;n!==a&&(S=`\\\\${u}\\${o.slice(a,n)}`,b=n)}}}else b=1;else v(C)&&o.charCodeAt(1)===f&&(S=o.slice(0,2),b=2,c>2&&e(o.charCodeAt(2))&&(A=!0,b=3));let r=b<c?D(o.slice(b),!A,"\\",e):"";return r.length===0&&!A&&(r="."),r.length>0&&e(o.charCodeAt(c-1))&&(r+="\\"),S===void 0?A?`\\${r}`:r:A?`${S}\\${r}`:`${S}${r}`},isAbsolute(o){s(o,"path");const c=o.length;if(c===0)return!1;const b=o.charCodeAt(0);return e(b)||c>2&&v(b)&&o.charCodeAt(1)===f&&e(o.charCodeAt(2))},join(...o){if(o.length===0)return".";let c,b;for(let C=0;C<o.length;++C){const r=o[C];s(r,"path"),r.length>0&&(c===void 0?c=b=r:c+=`\\${r}`)}if(c===void 0)return".";let S=!0,A=0;if(typeof b=="string"&&e(b.charCodeAt(0))){++A;const C=b.length;C>1&&e(b.charCodeAt(1))&&(++A,C>2&&(e(b.charCodeAt(2))?++A:S=!1))}if(S){for(;A<c.length&&e(c.charCodeAt(A));)A++;A>=2&&(c=`\\${c.slice(A)}`)}return t.win32.normalize(c)},relative(o,c){if(s(o,"from"),s(c,"to"),o===c)return"";const b=t.win32.resolve(o),S=t.win32.resolve(c);if(b===S||(o=b.toLowerCase(),c=S.toLowerCase(),o===c))return"";let A=0;for(;A<o.length&&o.charCodeAt(A)===d;)A++;let C=o.length;for(;C-1>A&&o.charCodeAt(C-1)===d;)C--;const r=C-A;let n=0;for(;n<c.length&&c.charCodeAt(n)===d;)n++;let a=c.length;for(;a-1>n&&c.charCodeAt(a-1)===d;)a--;const u=a-n,m=r<u?r:u;let W=-1,V=0;for(;V<m;V++){const re=o.charCodeAt(A+V);if(re!==c.charCodeAt(n+V))break;re===d&&(W=V)}if(V!==m){if(W===-1)return S}else{if(u>m){if(c.charCodeAt(n+V)===d)return S.slice(n+V+1);if(V===2)return S.slice(n+V)}r>m&&(o.charCodeAt(A+V)===d?W=V:V===2&&(W=3)),W===-1&&(W=0)}let ne="";for(V=A+W+1;V<=C;++V)(V===C||o.charCodeAt(V)===d)&&(ne+=ne.length===0?"..":"\\..");return n+=W,ne.length>0?`${ne}${S.slice(n,a)}`:(S.charCodeAt(n)===d&&++n,S.slice(n,a))},toNamespacedPath(o){if(typeof o!="string")return o;if(o.length===0)return"";const c=t.win32.resolve(o);if(c.length<=2)return o;if(c.charCodeAt(0)===d){if(c.charCodeAt(1)===d){const b=c.charCodeAt(2);if(b!==F&&b!==w)return`\\\\?\\UNC\\${c.slice(2)}`}}else if(v(c.charCodeAt(0))&&c.charCodeAt(1)===f&&c.charCodeAt(2)===d)return`\\\\?\\${c}`;return o},dirname(o){s(o,"path");const c=o.length;if(c===0)return".";let b=-1,S=0;const A=o.charCodeAt(0);if(c===1)return e(A)?o:".";if(e(A)){if(b=S=1,e(o.charCodeAt(1))){let n=2,a=n;for(;n<c&&!e(o.charCodeAt(n));)n++;if(n<c&&n!==a){for(a=n;n<c&&e(o.charCodeAt(n));)n++;if(n<c&&n!==a){for(a=n;n<c&&!e(o.charCodeAt(n));)n++;if(n===c)return o;n!==a&&(b=S=n+1)}}}}else v(A)&&o.charCodeAt(1)===f&&(b=c>2&&e(o.charCodeAt(2))?3:2,S=b);let C=-1,r=!0;for(let n=c-1;n>=S;--n)if(e(o.charCodeAt(n))){if(!r){C=n;break}}else r=!1;if(C===-1){if(b===-1)return".";C=b}return o.slice(0,C)},basename(o,c){c!==void 0&&s(c,"ext"),s(o,"path");let b=0,S=-1,A=!0,C;if(o.length>=2&&v(o.charCodeAt(0))&&o.charCodeAt(1)===f&&(b=2),c!==void 0&&c.length>0&&c.length<=o.length){if(c===o)return"";let r=c.length-1,n=-1;for(C=o.length-1;C>=b;--C){const a=o.charCodeAt(C);if(e(a)){if(!A){b=C+1;break}}else n===-1&&(A=!1,n=C+1),r>=0&&(a===c.charCodeAt(r)?--r==-1&&(S=C):(r=-1,S=n))}return b===S?S=n:S===-1&&(S=o.length),o.slice(b,S)}for(C=o.length-1;C>=b;--C)if(e(o.charCodeAt(C))){if(!A){b=C+1;break}}else S===-1&&(A=!1,S=C+1);return S===-1?"":o.slice(b,S)},extname(o){s(o,"path");let c=0,b=-1,S=0,A=-1,C=!0,r=0;o.length>=2&&o.charCodeAt(1)===f&&v(o.charCodeAt(0))&&(c=S=2);for(let n=o.length-1;n>=c;--n){const a=o.charCodeAt(n);if(e(a)){if(!C){S=n+1;break}continue}A===-1&&(C=!1,A=n+1),a===w?b===-1?b=n:r!==1&&(r=1):b!==-1&&(r=-1)}return b===-1||A===-1||r===0||r===1&&b===A-1&&b===S+1?"":o.slice(b,A)},format:y.bind(null,"\\"),parse(o){s(o,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return c;const b=o.length;let S=0,A=o.charCodeAt(0);if(b===1)return e(A)?(c.root=c.dir=o,c):(c.base=c.name=o,c);if(e(A)){if(S=1,e(o.charCodeAt(1))){let W=2,V=W;for(;W<b&&!e(o.charCodeAt(W));)W++;if(W<b&&W!==V){for(V=W;W<b&&e(o.charCodeAt(W));)W++;if(W<b&&W!==V){for(V=W;W<b&&!e(o.charCodeAt(W));)W++;W===b?S=W:W!==V&&(S=W+1)}}}}else if(v(A)&&o.charCodeAt(1)===f){if(b<=2)return c.root=c.dir=o,c;if(S=2,e(o.charCodeAt(2))){if(b===3)return c.root=c.dir=o,c;S=3}}S>0&&(c.root=o.slice(0,S));let C=-1,r=S,n=-1,a=!0,u=o.length-1,m=0;for(;u>=S;--u){if(A=o.charCodeAt(u),e(A)){if(!a){r=u+1;break}continue}n===-1&&(a=!1,n=u+1),A===w?C===-1?C=u:m!==1&&(m=1):C!==-1&&(m=-1)}return n!==-1&&(C===-1||m===0||m===1&&C===n-1&&C===r+1?c.base=c.name=o.slice(r,n):(c.name=o.slice(r,C),c.base=o.slice(r,n),c.ext=o.slice(C,n))),r>0&&r!==S?c.dir=o.slice(0,r-1):c.dir=c.root,c},sep:"\\",delimiter:";",win32:null,posix:null},t.posix={resolve(...o){let c="",b=!1;for(let S=o.length-1;S>=-1&&!b;S--){const A=S>=0?o[S]:E.cwd();s(A,"path"),A.length!==0&&(c=`${A}/${c}`,b=A.charCodeAt(0)===g)}return c=D(c,!b,"/",p),b?`/${c}`:c.length>0?c:"."},normalize(o){if(s(o,"path"),o.length===0)return".";const c=o.charCodeAt(0)===g,b=o.charCodeAt(o.length-1)===g;return o=D(o,!c,"/",p),o.length===0?c?"/":b?"./":".":(b&&(o+="/"),c?`/${o}`:o)},isAbsolute(o){return s(o,"path"),o.length>0&&o.charCodeAt(0)===g},join(...o){if(o.length===0)return".";let c;for(let b=0;b<o.length;++b){const S=o[b];s(S,"path"),S.length>0&&(c===void 0?c=S:c+=`/${S}`)}return c===void 0?".":t.posix.normalize(c)},relative(o,c){if(s(o,"from"),s(c,"to"),o===c||(o=t.posix.resolve(o),c=t.posix.resolve(c),o===c))return"";const b=1,S=o.length,A=S-b,C=1,r=c.length-C,n=A<r?A:r;let a=-1,u=0;for(;u<n;u++){const W=o.charCodeAt(b+u);if(W!==c.charCodeAt(C+u))break;W===g&&(a=u)}if(u===n)if(r>n){if(c.charCodeAt(C+u)===g)return c.slice(C+u+1);if(u===0)return c.slice(C+u)}else A>n&&(o.charCodeAt(b+u)===g?a=u:u===0&&(a=0));let m="";for(u=b+a+1;u<=S;++u)(u===S||o.charCodeAt(u)===g)&&(m+=m.length===0?"..":"/..");return`${m}${c.slice(C+a)}`},toNamespacedPath(o){return o},dirname(o){if(s(o,"path"),o.length===0)return".";const c=o.charCodeAt(0)===g;let b=-1,S=!0;for(let A=o.length-1;A>=1;--A)if(o.charCodeAt(A)===g){if(!S){b=A;break}}else S=!1;return b===-1?c?"/":".":c&&b===1?"//":o.slice(0,b)},basename(o,c){c!==void 0&&s(c,"ext"),s(o,"path");let b=0,S=-1,A=!0,C;if(c!==void 0&&c.length>0&&c.length<=o.length){if(c===o)return"";let r=c.length-1,n=-1;for(C=o.length-1;C>=0;--C){const a=o.charCodeAt(C);if(a===g){if(!A){b=C+1;break}}else n===-1&&(A=!1,n=C+1),r>=0&&(a===c.charCodeAt(r)?--r==-1&&(S=C):(r=-1,S=n))}return b===S?S=n:S===-1&&(S=o.length),o.slice(b,S)}for(C=o.length-1;C>=0;--C)if(o.charCodeAt(C)===g){if(!A){b=C+1;break}}else S===-1&&(A=!1,S=C+1);return S===-1?"":o.slice(b,S)},extname(o){s(o,"path");let c=-1,b=0,S=-1,A=!0,C=0;for(let r=o.length-1;r>=0;--r){const n=o.charCodeAt(r);if(n===g){if(!A){b=r+1;break}continue}S===-1&&(A=!1,S=r+1),n===w?c===-1?c=r:C!==1&&(C=1):c!==-1&&(C=-1)}return c===-1||S===-1||C===0||C===1&&c===S-1&&c===b+1?"":o.slice(c,S)},format:y.bind(null,"/"),parse(o){s(o,"path");const c={root:"",dir:"",base:"",ext:"",name:""};if(o.length===0)return c;const b=o.charCodeAt(0)===g;let S;b?(c.root="/",S=1):S=0;let A=-1,C=0,r=-1,n=!0,a=o.length-1,u=0;for(;a>=S;--a){const m=o.charCodeAt(a);if(m===g){if(!n){C=a+1;break}continue}r===-1&&(n=!1,r=a+1),m===w?A===-1?A=a:u!==1&&(u=1):A!==-1&&(u=-1)}if(r!==-1){const m=C===0&&b?1:C;A===-1||u===0||u===1&&A===r-1&&A===C+1?c.base=c.name=o.slice(m,r):(c.name=o.slice(m,A),c.base=o.slice(m,r),c.ext=o.slice(A,r))}return C>0?c.dir=o.slice(0,C-1):b&&(c.dir="/"),c},sep:"/",delimiter:":",win32:null,posix:null},t.posix.win32=t.win32.win32=t.win32,t.posix.posix=t.win32.posix=t.posix,t.normalize=E.platform==="win32"?t.win32.normalize:t.posix.normalize,t.isAbsolute=E.platform==="win32"?t.win32.isAbsolute:t.posix.isAbsolute,t.join=E.platform==="win32"?t.win32.join:t.posix.join,t.resolve=E.platform==="win32"?t.win32.resolve:t.posix.resolve,t.relative=E.platform==="win32"?t.win32.relative:t.posix.relative,t.dirname=E.platform==="win32"?t.win32.dirname:t.posix.dirname,t.basename=E.platform==="win32"?t.win32.basename:t.posix.basename,t.extname=E.platform==="win32"?t.win32.extname:t.posix.extname,t.format=E.platform==="win32"?t.win32.format:t.posix.format,t.parse=E.platform==="win32"?t.win32.parse:t.posix.parse,t.toNamespacedPath=E.platform==="win32"?t.win32.toNamespacedPath:t.posix.toNamespacedPath,t.sep=E.platform==="win32"?t.win32.sep:t.posix.sep,t.delimiter=E.platform==="win32"?t.win32.delimiter:t.posix.delimiter}),define(me[105],pe([1,0,21]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.normalizeMimeType=t.getExtensionForMimeType=t.getMediaMime=t.getMediaOrTextMime=t.Mimes=void 0,t.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const i={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},M={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function O(f){const F=(0,E.extname)(f),l=i[F.toLowerCase()];return l!==void 0?l:_(f)}t.getMediaOrTextMime=O;function _(f){const F=(0,E.extname)(f);return M[F.toLowerCase()]}t.getMediaMime=_;function w(f){for(const F in M)if(M[F]===f)return F}t.getExtensionForMimeType=w;const g=/^(.+)\/(.+?)(;.+)?$/;function d(f,F){const l=g.exec(f);return l?`${l[1].toLowerCase()}/${l[2].toLowerCase()}${l[3]??""}`:F?void 0:f}t.normalizeMimeType=d}),define(me[106],pe([1,0,5]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StopWatch=void 0;const i=E.globals.performance&&typeof E.globals.performance.now=="function";class M{constructor(_){this._highResolution=i&&_,this._startTime=this._now(),this._stopTime=-1}static create(_=!0){return new M(_)}stop(){this._stopTime=this._now()}elapsed(){return this._stopTime!==-1?this._stopTime-this._startTime:this._now()-this._startTime}_now(){return this._highResolution?E.globals.performance.now():Date.now()}}t.StopWatch=M}),define(me[3],pe([1,0,13,42,2,74,106]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Relay=t.EventBufferer=t.EventMultiplexer=t.MicrotaskEmitter=t.DebounceEmitter=t.PauseableEmitter=t.AsyncEmitter=t.EventDeliveryQueue=t.Emitter=t.setGlobalLeakWarningThreshold=t.Event=void 0;const w=!1,g=!1;var d;(function(a){a.None=()=>M.Disposable.None;function u(h){if(g){const{onListenerDidAdd:I}=h,U=e.create();let K=0;h.onListenerDidAdd=()=>{++K==2&&(console.warn("snapshotted emitter LIKELY used public and SHOULD HAVE BEEN created with DisposableStore. snapshotted here"),U.print()),I?.()}}}function m(h){return(I,U=null,K)=>{let Q=!1,N;return N=h(R=>{if(!Q)return N?N.dispose():Q=!0,I.call(U,R)},null,K),Q&&N.dispose(),N}}a.once=m;function W(h,I,U){return ve((K,Q=null,N)=>h(R=>K.call(Q,I(R)),null,N),U)}a.map=W;function V(h,I,U){return ve((K,Q=null,N)=>h(R=>{I(R),K.call(Q,R)},null,N),U)}a.forEach=V;function ne(h,I,U){return ve((K,Q=null,N)=>h(R=>I(R)&&K.call(Q,R),null,N),U)}a.filter=ne;function re(h){return h}a.signal=re;function we(...h){return(I,U=null,K)=>(0,M.combinedDisposable)(...h.map(Q=>Q(N=>I.call(U,N),null,K)))}a.any=we;function ae(h,I,U,K){let Q=U;return W(h,N=>(Q=I(Q,N),Q),K)}a.reduce=ae;function ve(h,I){let U;const K={onFirstListenerAdd(){U=h(Q.fire,Q)},onLastListenerRemove(){U?.dispose()}};I||u(K);const Q=new v(K);return I?.add(Q),Q.event}function ue(h,I,U=100,K=!1,Q,N){let R,z,T,H=0;const k={leakWarningThreshold:Q,onFirstListenerAdd(){R=h(x=>{H++,z=I(z,x),K&&!T&&(P.fire(z),z=void 0),clearTimeout(T),T=setTimeout(()=>{const J=z;z=void 0,T=void 0,(!K||H>1)&&P.fire(J),H=0},U)})},onLastListenerRemove(){R.dispose()}};N||u(k);const P=new v(k);return N?.add(P),P.event}a.debounce=ue;function ge(h,I=(K,Q)=>K===Q,U){let K=!0,Q;return ne(h,N=>{const R=K||!I(N,Q);return K=!1,Q=N,R},U)}a.latch=ge;function ye(h,I,U){return[a.filter(h,I,U),a.filter(h,K=>!I(K),U)]}a.split=ye;function ee(h,I=!1,U=[]){let K=U.slice(),Q=h(z=>{K?K.push(z):R.fire(z)});const N=()=>{K?.forEach(z=>R.fire(z)),K=null},R=new v({onFirstListenerAdd(){Q||(Q=h(z=>R.fire(z)))},onFirstListenerDidAdd(){K&&(I?setTimeout(N):N())},onLastListenerRemove(){Q&&Q.dispose(),Q=null}});return R.event}a.buffer=ee;class fe{constructor(I){this.event=I,this.disposables=new M.DisposableStore}map(I){return new fe(W(this.event,I,this.disposables))}forEach(I){return new fe(V(this.event,I,this.disposables))}filter(I){return new fe(ne(this.event,I,this.disposables))}reduce(I,U){return new fe(ae(this.event,I,U,this.disposables))}latch(){return new fe(ge(this.event,void 0,this.disposables))}debounce(I,U=100,K=!1,Q){return new fe(ue(this.event,I,U,K,Q,this.disposables))}on(I,U,K){return this.event(I,U,K)}once(I,U,K){return m(this.event)(I,U,K)}dispose(){this.disposables.dispose()}}function te(h){return new fe(h)}a.chain=te;function X(h,I,U=K=>K){const K=(...z)=>R.fire(U(...z)),Q=()=>h.on(I,K),N=()=>h.removeListener(I,K),R=new v({onFirstListenerAdd:Q,onLastListenerRemove:N});return R.event}a.fromNodeEventEmitter=X;function se(h,I,U=K=>K){const K=(...z)=>R.fire(U(...z)),Q=()=>h.addEventListener(I,K),N=()=>h.removeEventListener(I,K),R=new v({onFirstListenerAdd:Q,onLastListenerRemove:N});return R.event}a.fromDOMEventEmitter=se;function ie(h){return new Promise(I=>m(h)(I))}a.toPromise=ie;function L(h,I){return I(void 0),h(U=>I(U))}a.runAndSubscribe=L;function $(h,I){let U=null;function K(N){U?.dispose(),U=new M.DisposableStore,I(N,U)}K(void 0);const Q=h(N=>K(N));return(0,M.toDisposable)(()=>{Q.dispose(),U?.dispose()})}a.runAndSubscribeWithStore=$;class G{constructor(I,U){this.obs=I,this._counter=0,this._hasChanged=!1;const K={onFirstListenerAdd:()=>{I.addObserver(this)},onLastListenerRemove:()=>{I.removeObserver(this)}};U||u(K),this.emitter=new v(K),U&&U.add(this.emitter)}beginUpdate(I){this._counter++}handleChange(I,U){this._hasChanged=!0}endUpdate(I){--this._counter==0&&this._hasChanged&&(this._hasChanged=!1,this.emitter.fire(this.obs.get()))}}function B(h,I){return new G(h,I).emitter.event}a.fromObservable=B})(d=t.Event||(t.Event={}));class f{constructor(u){this._listenerCount=0,this._invocationCount=0,this._elapsedOverall=0,this._name=`${u}_${f._idPool++}`}start(u){this._stopWatch=new _.StopWatch(!0),this._listenerCount=u}stop(){if(this._stopWatch){const u=this._stopWatch.elapsed();this._elapsedOverall+=u,this._invocationCount+=1,console.info(`did FIRE ${this._name}: elapsed_ms: ${u.toFixed(5)}, listener: ${this._listenerCount} (elapsed_overall: ${this._elapsedOverall.toFixed(2)}, invocations: ${this._invocationCount})`),this._stopWatch=void 0}}}f._idPool=0;let F=-1;function l(a){const u=F;return F=a,{dispose(){F=u}}}t.setGlobalLeakWarningThreshold=l;class s{constructor(u,m=Math.random().toString(18).slice(2,5)){this.customThreshold=u,this.name=m,this._warnCountdown=0}dispose(){this._stacks&&this._stacks.clear()}check(u,m){let W=F;if(typeof this.customThreshold=="number"&&(W=this.customThreshold),W<=0||m<W)return;this._stacks||(this._stacks=new Map);const V=this._stacks.get(u.value)||0;if(this._stacks.set(u.value,V+1),this._warnCountdown-=1,this._warnCountdown<=0){this._warnCountdown=W*.5;let ne,re=0;for(const[we,ae]of this._stacks)(!ne||re<ae)&&(ne=we,re=ae);console.warn(`[${this.name}] potential listener LEAK detected, having ${m} listeners already. MOST frequent listener (${re}):`),console.warn(ne)}return()=>{const ne=this._stacks.get(u.value)||0;this._stacks.set(u.value,ne-1)}}}class e{constructor(u){this.value=u}static create(){return new e(new Error().stack??"")}print(){console.warn(this.value.split(`
`).slice(2).join(`
`))}}class p{constructor(u,m,W){this.callback=u,this.callbackThis=m,this.stack=W,this.subscription=new M.SafeDisposable}invoke(u){this.callback.call(this.callbackThis,u)}}class v{constructor(u){this._disposed=!1,this._options=u,this._leakageMon=F>0?new s(this._options&&this._options.leakWarningThreshold):void 0,this._perfMon=this._options?._profName?new f(this._options._profName):void 0,this._deliveryQueue=this._options?.deliveryQueue}dispose(){if(!this._disposed){if(this._disposed=!0,this._listeners){if(w){const u=Array.from(this._listeners);queueMicrotask(()=>{for(const m of u)m.subscription.isset()&&(m.subscription.unset(),m.stack?.print())})}this._listeners.clear()}this._deliveryQueue?.clear(this),this._options?.onLastListenerRemove?.(),this._leakageMon?.dispose()}}get event(){return this._event||(this._event=(u,m,W)=>{this._listeners||(this._listeners=new O.LinkedList);const V=this._listeners.isEmpty();V&&this._options?.onFirstListenerAdd&&this._options.onFirstListenerAdd(this);let ne,re;this._leakageMon&&this._listeners.size>=30&&(re=e.create(),ne=this._leakageMon.check(re,this._listeners.size+1)),w&&(re=re??e.create());const we=new p(u,m,re),ae=this._listeners.push(we);V&&this._options?.onFirstListenerDidAdd&&this._options.onFirstListenerDidAdd(this),this._options?.onListenerDidAdd&&this._options.onListenerDidAdd(this,u,m);const ve=we.subscription.set(()=>{ne?.(),this._disposed||(ae(),this._options&&this._options.onLastListenerRemove&&(this._listeners&&!this._listeners.isEmpty()||this._options.onLastListenerRemove(this)))});return W instanceof M.DisposableStore?W.add(ve):Array.isArray(W)&&W.push(ve),ve}),this._event}fire(u){if(this._listeners){this._deliveryQueue||(this._deliveryQueue=new y);for(const m of this._listeners)this._deliveryQueue.push(this,m,u);this._perfMon?.start(this._deliveryQueue.size),this._deliveryQueue.deliver(),this._perfMon?.stop()}}hasListeners(){return this._listeners?!this._listeners.isEmpty():!1}}t.Emitter=v;class D{constructor(){this._queue=new O.LinkedList}get size(){return this._queue.size}push(u,m,W){this._queue.push(new o(u,m,W))}clear(u){const m=new O.LinkedList;for(const W of this._queue)W.emitter!==u&&m.push(W);this._queue=m}deliver(){for(;this._queue.size>0;){const u=this._queue.shift();try{u.listener.invoke(u.event)}catch(m){(0,E.onUnexpectedError)(m)}}}}t.EventDeliveryQueue=D;class y extends D{clear(u){this._queue.clear()}}class o{constructor(u,m,W){this.emitter=u,this.listener=m,this.event=W}}class c extends v{async fireAsync(u,m,W){if(!!this._listeners){this._asyncDeliveryQueue||(this._asyncDeliveryQueue=new O.LinkedList);for(const V of this._listeners)this._asyncDeliveryQueue.push([V,u]);for(;this._asyncDeliveryQueue.size>0&&!m.isCancellationRequested;){const[V,ne]=this._asyncDeliveryQueue.shift(),re=[],we={...ne,token:m,waitUntil:ae=>{if(Object.isFrozen(re))throw new Error("waitUntil can NOT be called asynchronous");W&&(ae=W(ae,V.callback)),re.push(ae)}};try{V.invoke(we)}catch(ae){(0,E.onUnexpectedError)(ae);continue}Object.freeze(re),await Promise.allSettled(re).then(ae=>{for(const ve of ae)ve.status==="rejected"&&(0,E.onUnexpectedError)(ve.reason)})}}}}t.AsyncEmitter=c;class b extends v{constructor(u){super(u);this._isPaused=0,this._eventQueue=new O.LinkedList,this._mergeFn=u?.merge}pause(){this._isPaused++}resume(){if(this._isPaused!==0&&--this._isPaused==0)if(this._mergeFn){const u=Array.from(this._eventQueue);this._eventQueue.clear(),super.fire(this._mergeFn(u))}else for(;!this._isPaused&&this._eventQueue.size!==0;)super.fire(this._eventQueue.shift())}fire(u){this._listeners&&(this._isPaused!==0?this._eventQueue.push(u):super.fire(u))}}t.PauseableEmitter=b;class S extends b{constructor(u){super(u);this._delay=u.delay??100}fire(u){this._handle||(this.pause(),this._handle=setTimeout(()=>{this._handle=void 0,this.resume()},this._delay)),super.fire(u)}}t.DebounceEmitter=S;class A extends v{constructor(u){super(u);this._queuedEvents=[],this._mergeFn=u?.merge}fire(u){this._queuedEvents.push(u),this._queuedEvents.length===1&&queueMicrotask(()=>{this._mergeFn?super.fire(this._mergeFn(this._queuedEvents)):this._queuedEvents.forEach(m=>super.fire(m)),this._queuedEvents=[]})}}t.MicrotaskEmitter=A;class C{constructor(){this.hasListeners=!1,this.events=[],this.emitter=new v({onFirstListenerAdd:()=>this.onFirstListenerAdd(),onLastListenerRemove:()=>this.onLastListenerRemove()})}get event(){return this.emitter.event}add(u){const m={event:u,listener:null};this.events.push(m),this.hasListeners&&this.hook(m);const W=()=>{this.hasListeners&&this.unhook(m);const V=this.events.indexOf(m);this.events.splice(V,1)};return(0,M.toDisposable)((0,i.once)(W))}onFirstListenerAdd(){this.hasListeners=!0,this.events.forEach(u=>this.hook(u))}onLastListenerRemove(){this.hasListeners=!1,this.events.forEach(u=>this.unhook(u))}hook(u){u.listener=u.event(m=>this.emitter.fire(m))}unhook(u){u.listener&&u.listener.dispose(),u.listener=null}dispose(){this.emitter.dispose()}}t.EventMultiplexer=C;class r{constructor(){this.buffers=[]}wrapEvent(u){return(m,W,V)=>u(ne=>{const re=this.buffers[this.buffers.length-1];re?re.push(()=>m.call(W,ne)):m.call(W,ne)},void 0,V)}bufferEvents(u){const m=[];this.buffers.push(m);const W=u();return this.buffers.pop(),m.forEach(V=>V()),W}}t.EventBufferer=r;class n{constructor(){this.listening=!1,this.inputEvent=d.None,this.inputEventListener=M.Disposable.None,this.emitter=new v({onFirstListenerDidAdd:()=>{this.listening=!0,this.inputEventListener=this.inputEvent(this.emitter.fire,this.emitter)},onLastListenerRemove:()=>{this.listening=!1,this.inputEventListener.dispose()}}),this.event=this.emitter.event}set input(u){this.inputEvent=u,this.listening&&(this.inputEventListener.dispose(),this.inputEventListener=u(this.emitter.fire,this.emitter))}dispose(){this.inputEventListener.dispose(),this.emitter.dispose()}}t.Relay=n}),define(me[15],pe([1,0,3,2]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isStandalone=t.isAndroid=t.isElectron=t.isWebkitWebView=t.isSafari=t.isChrome=t.isWebKit=t.isFirefox=t.onDidChangeFullscreen=t.isFullscreen=t.setFullscreen=t.setZoomFactor=t.getZoomFactor=t.getZoomLevel=t.setZoomLevel=t.PixelRatio=t.addMatchMediaChangeListener=void 0;class M{constructor(){this._zoomLevel=0,this._zoomFactor=1,this._fullscreen=!1,this._onDidChangeFullscreen=new E.Emitter,this.onDidChangeFullscreen=this._onDidChangeFullscreen.event}getZoomLevel(){return this._zoomLevel}setZoomLevel(o,c){this._zoomLevel!==o&&(this._zoomLevel=o)}getZoomFactor(){return this._zoomFactor}setZoomFactor(o){this._zoomFactor=o}setFullscreen(o){this._fullscreen!==o&&(this._fullscreen=o,this._onDidChangeFullscreen.fire())}isFullscreen(){return this._fullscreen}}M.INSTANCE=new M;class O extends i.Disposable{constructor(){super();this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._listener=()=>this._handleChange(!0),this._mediaQueryList=null,this._handleChange(!1)}_handleChange(o){this._mediaQueryList?.removeEventListener("change",this._listener),this._mediaQueryList=matchMedia(`(resolution: ${window.devicePixelRatio}dppx)`),this._mediaQueryList.addEventListener("change",this._listener),o&&this._onDidChange.fire()}}class _ extends i.Disposable{constructor(){super();this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._value=this._getPixelRatio();const o=this._register(new O);this._register(o.onDidChange(()=>{this._value=this._getPixelRatio(),this._onDidChange.fire(this._value)}))}get value(){return this._value}_getPixelRatio(){const o=document.createElement("canvas").getContext("2d"),c=window.devicePixelRatio||1,b=o.webkitBackingStorePixelRatio||o.mozBackingStorePixelRatio||o.msBackingStorePixelRatio||o.oBackingStorePixelRatio||o.backingStorePixelRatio||1;return c/b}}class w{constructor(){this._pixelRatioMonitor=null}_getOrCreatePixelRatioMonitor(){return this._pixelRatioMonitor||(this._pixelRatioMonitor=(0,i.markAsSingleton)(new _)),this._pixelRatioMonitor}get value(){return this._getOrCreatePixelRatioMonitor().value}get onDidChange(){return this._getOrCreatePixelRatioMonitor().onDidChange}}function g(y,o){typeof y=="string"&&(y=window.matchMedia(y)),y.addEventListener("change",o)}t.addMatchMediaChangeListener=g,t.PixelRatio=new w;function d(y,o){M.INSTANCE.setZoomLevel(y,o)}t.setZoomLevel=d;function f(){return M.INSTANCE.getZoomLevel()}t.getZoomLevel=f;function F(){return M.INSTANCE.getZoomFactor()}t.getZoomFactor=F;function l(y){M.INSTANCE.setZoomFactor(y)}t.setZoomFactor=l;function s(y){M.INSTANCE.setFullscreen(y)}t.setFullscreen=s;function e(){return M.INSTANCE.isFullscreen()}t.isFullscreen=e,t.onDidChangeFullscreen=M.INSTANCE.onDidChangeFullscreen;const p=navigator.userAgent;t.isFirefox=p.indexOf("Firefox")>=0,t.isWebKit=p.indexOf("AppleWebKit")>=0,t.isChrome=p.indexOf("Chrome")>=0,t.isSafari=!t.isChrome&&p.indexOf("Safari")>=0,t.isWebkitWebView=!t.isChrome&&!t.isSafari&&t.isWebKit,t.isElectron=p.indexOf("Electron/")>=0,t.isAndroid=p.indexOf("Android")>=0;let v=!1;if(window.matchMedia){const y=window.matchMedia("(display-mode: standalone)"),o=window.matchMedia("(display-mode: fullscreen)");v=y.matches,g(y,({matches:c})=>{v&&o.matches||(v=c)})}function D(){return v}t.isStandalone=D}),define(me[107],pe([1,0,15,5]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.BrowserFeatures=t.KeyboardSupport=void 0;var M;(function(O){O[O.Always=0]="Always",O[O.FullScreen=1]="FullScreen",O[O.None=2]="None"})(M=t.KeyboardSupport||(t.KeyboardSupport={})),t.BrowserFeatures={clipboard:{writeText:i.isNative||document.queryCommandSupported&&document.queryCommandSupported("copy")||!!(navigator&&navigator.clipboard&&navigator.clipboard.writeText),readText:i.isNative||!!(navigator&&navigator.clipboard&&navigator.clipboard.readText)},keyboard:(()=>i.isNative||E.isStandalone()?0:navigator.keyboard||E.isSafari?1:2)(),touch:"ontouchstart"in window||navigator.maxTouchPoints>0,pointerEvents:window.PointerEvent&&("ontouchstart"in window||window.navigator.maxTouchPoints>0||navigator.maxTouchPoints>0)}}),define(me[18],pe([1,0,3]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.stop=t.stopEvent=t.DomEmitter=void 0;class i{constructor(w,g,d){const f=F=>this.emitter.fire(F);this.emitter=new E.Emitter({onFirstListenerAdd:()=>w.addEventListener(g,f,d),onLastListenerRemove:()=>w.removeEventListener(g,f,d)})}get event(){return this.emitter.event}dispose(){this.emitter.dispose()}}t.DomEmitter=i;function M(_){return _.preventDefault(),_.stopPropagation(),_}t.stopEvent=M;function O(_){return E.Event.map(_,M)}t.stop=O}),define(me[19],pe([1,0,15,43,72,5]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardKeyboardEvent=t.printStandardKeyboardEvent=t.printKeyboardEvent=void 0;function _(e){if(e.charCode){const v=String.fromCharCode(e.charCode).toUpperCase();return i.KeyCodeUtils.fromString(v)}const p=e.keyCode;if(p===3)return 7;if(E.isFirefox){if(p===59)return 80;if(p===107)return 81;if(p===109)return 83;if(O.isMacintosh&&p===224)return 57}else if(E.isWebKit){if(p===91)return 57;if(O.isMacintosh&&p===93)return 57;if(!O.isMacintosh&&p===92)return 57}return i.EVENT_KEY_CODE_MAP[p]||0}const w=O.isMacintosh?256:2048,g=512,d=1024,f=O.isMacintosh?2048:256;function F(e){const p=[];return e.ctrlKey&&p.push("ctrl"),e.shiftKey&&p.push("shift"),e.altKey&&p.push("alt"),e.metaKey&&p.push("meta"),`modifiers: [${p.join(",")}], code: ${e.code}, keyCode: ${e.keyCode}, key: ${e.key}`}t.printKeyboardEvent=F;function l(e){const p=[];return e.ctrlKey&&p.push("ctrl"),e.shiftKey&&p.push("shift"),e.altKey&&p.push("alt"),e.metaKey&&p.push("meta"),`modifiers: [${p.join(",")}], code: ${e.code}, keyCode: ${e.keyCode} ('${i.KeyCodeUtils.toString(e.keyCode)}')`}t.printStandardKeyboardEvent=l;class s{constructor(p){this._standardKeyboardEventBrand=!0;const v=p;this.browserEvent=v,this.target=v.target,this.ctrlKey=v.ctrlKey,this.shiftKey=v.shiftKey,this.altKey=v.altKey,this.metaKey=v.metaKey,this.keyCode=_(v),this.code=v.code,this.ctrlKey=this.ctrlKey||this.keyCode===5,this.altKey=this.altKey||this.keyCode===6,this.shiftKey=this.shiftKey||this.keyCode===4,this.metaKey=this.metaKey||this.keyCode===57,this._asKeybinding=this._computeKeybinding(),this._asRuntimeKeybinding=this._computeRuntimeKeybinding()}preventDefault(){this.browserEvent&&this.browserEvent.preventDefault&&this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent&&this.browserEvent.stopPropagation&&this.browserEvent.stopPropagation()}toKeybinding(){return this._asRuntimeKeybinding}equals(p){return this._asKeybinding===p}_computeKeybinding(){let p=0;this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(p=this.keyCode);let v=0;return this.ctrlKey&&(v|=w),this.altKey&&(v|=g),this.shiftKey&&(v|=d),this.metaKey&&(v|=f),v|=p,v}_computeRuntimeKeybinding(){let p=0;return this.keyCode!==5&&this.keyCode!==4&&this.keyCode!==6&&this.keyCode!==57&&(p=this.keyCode),new M.SimpleKeybinding(this.ctrlKey,this.shiftKey,this.altKey,this.metaKey,p)}}t.StandardKeyboardEvent=s}),define(me[20],pe([1,0,15,65,5]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StandardWheelEvent=t.DragMouseEvent=t.StandardMouseEvent=void 0;class O{constructor(d){this.timestamp=Date.now(),this.browserEvent=d,this.leftButton=d.button===0,this.middleButton=d.button===1,this.rightButton=d.button===2,this.buttons=d.buttons,this.target=d.target,this.detail=d.detail||1,d.type==="dblclick"&&(this.detail=2),this.ctrlKey=d.ctrlKey,this.shiftKey=d.shiftKey,this.altKey=d.altKey,this.metaKey=d.metaKey,typeof d.pageX=="number"?(this.posx=d.pageX,this.posy=d.pageY):(this.posx=d.clientX+document.body.scrollLeft+document.documentElement.scrollLeft,this.posy=d.clientY+document.body.scrollTop+document.documentElement.scrollTop);const f=i.IframeUtils.getPositionOfChildWindowRelativeToAncestorWindow(self,d.view);this.posx-=f.left,this.posy-=f.top}preventDefault(){this.browserEvent.preventDefault()}stopPropagation(){this.browserEvent.stopPropagation()}}t.StandardMouseEvent=O;class _ extends O{constructor(d){super(d);this.dataTransfer=d.dataTransfer}}t.DragMouseEvent=_;class w{constructor(d,f=0,F=0){if(this.browserEvent=d||null,this.target=d?d.target||d.targetNode||d.srcElement:null,this.deltaY=F,this.deltaX=f,d){const l=d,s=d;if(typeof l.wheelDeltaY!="undefined")this.deltaY=l.wheelDeltaY/120;else if(typeof s.VERTICAL_AXIS!="undefined"&&s.axis===s.VERTICAL_AXIS)this.deltaY=-s.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!M.isMacintosh?this.deltaY=-d.deltaY/3:this.deltaY=-d.deltaY:this.deltaY=-d.deltaY/40}if(typeof l.wheelDeltaX!="undefined")E.isSafari&&M.isWindows?this.deltaX=-(l.wheelDeltaX/120):this.deltaX=l.wheelDeltaX/120;else if(typeof s.HORIZONTAL_AXIS!="undefined"&&s.axis===s.HORIZONTAL_AXIS)this.deltaX=-d.detail/3;else if(d.type==="wheel"){const e=d;e.deltaMode===e.DOM_DELTA_LINE?E.isFirefox&&!M.isMacintosh?this.deltaX=-d.deltaX/3:this.deltaX=-d.deltaX:this.deltaX=-d.deltaX/40}this.deltaY===0&&this.deltaX===0&&d.wheelDelta&&(this.deltaY=d.wheelDelta/120)}}preventDefault(){this.browserEvent?.preventDefault()}stopPropagation(){this.browserEvent?.stopPropagation()}}t.StandardWheelEvent=w}),define(me[32],pe([1,0,3,2,102]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toAction=t.EmptySubmenuAction=t.SubmenuAction=t.Separator=t.ActionRunner=t.Action=void 0;class O extends i.Disposable{constructor(l,s="",e="",p=!0,v){super();this._onDidChange=this._register(new E.Emitter),this.onDidChange=this._onDidChange.event,this._enabled=!0,this._id=l,this._label=s,this._cssClass=e,this._enabled=p,this._actionCallback=v}get id(){return this._id}get label(){return this._label}set label(l){this._setLabel(l)}_setLabel(l){this._label!==l&&(this._label=l,this._onDidChange.fire({label:l}))}get tooltip(){return this._tooltip||""}set tooltip(l){this._setTooltip(l)}_setTooltip(l){this._tooltip!==l&&(this._tooltip=l,this._onDidChange.fire({tooltip:l}))}get class(){return this._cssClass}set class(l){this._setClass(l)}_setClass(l){this._cssClass!==l&&(this._cssClass=l,this._onDidChange.fire({class:l}))}get enabled(){return this._enabled}set enabled(l){this._setEnabled(l)}_setEnabled(l){this._enabled!==l&&(this._enabled=l,this._onDidChange.fire({enabled:l}))}get checked(){return this._checked}set checked(l){this._setChecked(l)}_setChecked(l){this._checked!==l&&(this._checked=l,this._onDidChange.fire({checked:l}))}async run(l,s){this._actionCallback&&await this._actionCallback(l)}}t.Action=O;class _ extends i.Disposable{constructor(){super(...arguments);this._onBeforeRun=this._register(new E.Emitter),this.onBeforeRun=this._onBeforeRun.event,this._onDidRun=this._register(new E.Emitter),this.onDidRun=this._onDidRun.event}async run(l,s){if(!l.enabled)return;this._onBeforeRun.fire({action:l});let e;try{await this.runAction(l,s)}catch(p){e=p}this._onDidRun.fire({action:l,error:e})}async runAction(l,s){await l.run(s)}}t.ActionRunner=_;class w extends O{constructor(l){super(w.ID,l,l?"separator text":"separator");this.checked=!1,this.enabled=!1}static join(...l){let s=[];for(const e of l)e.length&&(s.length?s=[...s,new w,...e]:s=e);return s}}t.Separator=w,w.ID="vs.actions.separator";class g{constructor(l,s,e,p){this.tooltip="",this.enabled=!0,this.checked=void 0,this.id=l,this.label=s,this.class=p,this._actions=e}get actions(){return this._actions}dispose(){}async run(){}}t.SubmenuAction=g;class d extends O{constructor(){super(d.ID,M.localize(0,null),void 0,!1)}}t.EmptySubmenuAction=d,d.ID="vs.actions.empty";function f(F){return{id:F.id,label:F.label,class:void 0,enabled:F.enabled??!0,checked:F.checked??!1,run:async()=>F.run(),tooltip:F.label,dispose:()=>{}}}t.toAction=f}),define(me[28],pe([1,0,3]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CancellationTokenSource=t.CancellationToken=void 0;const i=Object.freeze(function(w,g){const d=setTimeout(w.bind(g),0);return{dispose(){clearTimeout(d)}}});var M;(function(w){function g(d){return d===w.None||d===w.Cancelled||d instanceof O?!0:!d||typeof d!="object"?!1:typeof d.isCancellationRequested=="boolean"&&typeof d.onCancellationRequested=="function"}w.isCancellationToken=g,w.None=Object.freeze({isCancellationRequested:!1,onCancellationRequested:E.Event.None}),w.Cancelled=Object.freeze({isCancellationRequested:!0,onCancellationRequested:i})})(M=t.CancellationToken||(t.CancellationToken={}));class O{constructor(){this._isCancelled=!1,this._emitter=null}cancel(){this._isCancelled||(this._isCancelled=!0,this._emitter&&(this._emitter.fire(void 0),this.dispose()))}get isCancellationRequested(){return this._isCancelled}get onCancellationRequested(){return this._isCancelled?i:(this._emitter||(this._emitter=new E.Emitter),this._emitter.event)}dispose(){this._emitter&&(this._emitter.dispose(),this._emitter=null)}}class _{constructor(g){this._token=void 0,this._parentListener=void 0,this._parentListener=g&&g.onCancellationRequested(this.cancel,this)}get token(){return this._token||(this._token=new O),this._token}cancel(){this._token?this._token instanceof O&&this._token.cancel():this._token=M.Cancelled}dispose(g=!1){g&&this.cancel(),this._parentListener?.dispose(),this._token?this._token instanceof O&&this._token.dispose():this._token=M.None}}t.CancellationTokenSource=_}),define(me[108],pe([1,0,28]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.CachedFunction=t.LRUCachedFunction=t.Cache=void 0;class i{constructor(w){this.task=w,this.result=null}get(){if(this.result)return this.result;const w=new E.CancellationTokenSource,g=this.task(w.token);return this.result={promise:g,dispose:()=>{this.result=null,w.cancel(),w.dispose()}},this.result}}t.Cache=i;class M{constructor(w){this.fn=w,this.lastCache=void 0,this.lastArgKey=void 0}get(w){const g=JSON.stringify(w);return this.lastArgKey!==g&&(this.lastArgKey=g,this.lastCache=this.fn(w)),this.lastCache}}t.LRUCachedFunction=M;class O{constructor(w){this.fn=w,this._map=new Map}get cachedValues(){return this._map}get(w){if(this._map.has(w))return this._map.get(w);const g=this.fn(w);return this._map.set(w,g),g}}t.CachedFunction=O}),define(me[47],pe([1,0,3,2]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SmoothScrollingOperation=t.SmoothScrollingUpdate=t.Scrollable=t.ScrollState=t.ScrollbarVisibility=void 0;var M;(function(s){s[s.Auto=1]="Auto",s[s.Hidden=2]="Hidden",s[s.Visible=3]="Visible"})(M=t.ScrollbarVisibility||(t.ScrollbarVisibility={}));class O{constructor(e,p,v,D,y,o,c){this._forceIntegerValues=e,this._scrollStateBrand=void 0,this._forceIntegerValues&&(p=p|0,v=v|0,D=D|0,y=y|0,o=o|0,c=c|0),this.rawScrollLeft=D,this.rawScrollTop=c,p<0&&(p=0),D+p>v&&(D=v-p),D<0&&(D=0),y<0&&(y=0),c+y>o&&(c=o-y),c<0&&(c=0),this.width=p,this.scrollWidth=v,this.scrollLeft=D,this.height=y,this.scrollHeight=o,this.scrollTop=c}equals(e){return this.rawScrollLeft===e.rawScrollLeft&&this.rawScrollTop===e.rawScrollTop&&this.width===e.width&&this.scrollWidth===e.scrollWidth&&this.scrollLeft===e.scrollLeft&&this.height===e.height&&this.scrollHeight===e.scrollHeight&&this.scrollTop===e.scrollTop}withScrollDimensions(e,p){return new O(this._forceIntegerValues,typeof e.width!="undefined"?e.width:this.width,typeof e.scrollWidth!="undefined"?e.scrollWidth:this.scrollWidth,p?this.rawScrollLeft:this.scrollLeft,typeof e.height!="undefined"?e.height:this.height,typeof e.scrollHeight!="undefined"?e.scrollHeight:this.scrollHeight,p?this.rawScrollTop:this.scrollTop)}withScrollPosition(e){return new O(this._forceIntegerValues,this.width,this.scrollWidth,typeof e.scrollLeft!="undefined"?e.scrollLeft:this.rawScrollLeft,this.height,this.scrollHeight,typeof e.scrollTop!="undefined"?e.scrollTop:this.rawScrollTop)}createScrollEvent(e,p){const v=this.width!==e.width,D=this.scrollWidth!==e.scrollWidth,y=this.scrollLeft!==e.scrollLeft,o=this.height!==e.height,c=this.scrollHeight!==e.scrollHeight,b=this.scrollTop!==e.scrollTop;return{inSmoothScrolling:p,oldWidth:e.width,oldScrollWidth:e.scrollWidth,oldScrollLeft:e.scrollLeft,width:this.width,scrollWidth:this.scrollWidth,scrollLeft:this.scrollLeft,oldHeight:e.height,oldScrollHeight:e.scrollHeight,oldScrollTop:e.scrollTop,height:this.height,scrollHeight:this.scrollHeight,scrollTop:this.scrollTop,widthChanged:v,scrollWidthChanged:D,scrollLeftChanged:y,heightChanged:o,scrollHeightChanged:c,scrollTopChanged:b}}}t.ScrollState=O;class _ extends i.Disposable{constructor(e){super();this._scrollableBrand=void 0,this._onScroll=this._register(new E.Emitter),this.onScroll=this._onScroll.event,this._smoothScrollDuration=e.smoothScrollDuration,this._scheduleAtNextAnimationFrame=e.scheduleAtNextAnimationFrame,this._state=new O(e.forceIntegerValues,0,0,0,0,0,0),this._smoothScrolling=null}dispose(){this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),super.dispose()}setSmoothScrollDuration(e){this._smoothScrollDuration=e}validateScrollPosition(e){return this._state.withScrollPosition(e)}getScrollDimensions(){return this._state}setScrollDimensions(e,p){const v=this._state.withScrollDimensions(e,p);this._setState(v,Boolean(this._smoothScrolling)),this._smoothScrolling?.acceptScrollDimensions(this._state)}getFutureScrollPosition(){return this._smoothScrolling?this._smoothScrolling.to:this._state}getCurrentScrollPosition(){return this._state}setScrollPositionNow(e){const p=this._state.withScrollPosition(e);this._smoothScrolling&&(this._smoothScrolling.dispose(),this._smoothScrolling=null),this._setState(p,!1)}setScrollPositionSmooth(e,p){if(this._smoothScrollDuration===0)return this.setScrollPositionNow(e);if(this._smoothScrolling){e={scrollLeft:typeof e.scrollLeft=="undefined"?this._smoothScrolling.to.scrollLeft:e.scrollLeft,scrollTop:typeof e.scrollTop=="undefined"?this._smoothScrolling.to.scrollTop:e.scrollTop};const v=this._state.withScrollPosition(e);if(this._smoothScrolling.to.scrollLeft===v.scrollLeft&&this._smoothScrolling.to.scrollTop===v.scrollTop)return;let D;p?D=new f(this._smoothScrolling.from,v,this._smoothScrolling.startTime,this._smoothScrolling.duration):D=this._smoothScrolling.combine(this._state,v,this._smoothScrollDuration),this._smoothScrolling.dispose(),this._smoothScrolling=D}else{const v=this._state.withScrollPosition(e);this._smoothScrolling=f.start(this._state,v,this._smoothScrollDuration)}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}_performSmoothScrolling(){if(!this._smoothScrolling)return;const e=this._smoothScrolling.tick(),p=this._state.withScrollPosition(e);if(this._setState(p,!0),!!this._smoothScrolling){if(e.isDone){this._smoothScrolling.dispose(),this._smoothScrolling=null;return}this._smoothScrolling.animationFrameDisposable=this._scheduleAtNextAnimationFrame(()=>{!this._smoothScrolling||(this._smoothScrolling.animationFrameDisposable=null,this._performSmoothScrolling())})}}_setState(e,p){const v=this._state;v.equals(e)||(this._state=e,this._onScroll.fire(this._state.createScrollEvent(v,p)))}}t.Scrollable=_;class w{constructor(e,p,v){this.scrollLeft=e,this.scrollTop=p,this.isDone=v}}t.SmoothScrollingUpdate=w;function g(s,e){const p=e-s;return function(v){return s+p*l(v)}}function d(s,e,p){return function(v){return v<p?s(v/p):e((v-p)/(1-p))}}class f{constructor(e,p,v,D){this.from=e,this.to=p,this.duration=D,this.startTime=v,this.animationFrameDisposable=null,this._initAnimations()}_initAnimations(){this.scrollLeft=this._initAnimation(this.from.scrollLeft,this.to.scrollLeft,this.to.width),this.scrollTop=this._initAnimation(this.from.scrollTop,this.to.scrollTop,this.to.height)}_initAnimation(e,p,v){if(Math.abs(e-p)>2.5*v){let y,o;return e<p?(y=e+.75*v,o=p-.75*v):(y=e-.75*v,o=p+.75*v),d(g(e,y),g(o,p),.33)}return g(e,p)}dispose(){this.animationFrameDisposable!==null&&(this.animationFrameDisposable.dispose(),this.animationFrameDisposable=null)}acceptScrollDimensions(e){this.to=e.withScrollPosition(this.to),this._initAnimations()}tick(){return this._tick(Date.now())}_tick(e){const p=(e-this.startTime)/this.duration;if(p<1){const v=this.scrollLeft(p),D=this.scrollTop(p);return new w(v,D,!1)}return new w(this.to.scrollLeft,this.to.scrollTop,!0)}combine(e,p,v){return f.start(e,p,v)}static start(e,p,v){v=v+10;const D=Date.now()-10;return new f(e,p,D,v)}}t.SmoothScrollingOperation=f;function F(s){return Math.pow(s,3)}function l(s){return 1-F(1-s)}}),define(me[10],pe([1,0,108,73]),function(Z,t,E,i){"use strict";var M;Object.defineProperty(t,"__esModule",{value:!0}),t.InvisibleCharacters=t.AmbiguousCharacters=t.noBreakWhitespace=t.getLeftDeleteOffset=t.GraphemeBreakType=t.getGraphemeBreakType=t.singleLetterHash=t.getNLines=t.uppercaseFirstLetter=t.containsUppercaseCharacter=t.fuzzyContains=t.stripUTF8BOM=t.startsWithUTF8BOM=t.UTF8_BOM_CHARACTER=t.removeAnsiEscapeCodes=t.lcut=t.isEmojiImprecise=t.isFullWidthCharacter=t.containsUnusualLineTerminators=t.UNUSUAL_LINE_TERMINATORS=t.isBasicASCII=t.containsRTL=t.getCharContainingOffset=t.prevCharLength=t.nextCharLength=t.GraphemeIterator=t.CodePointIterator=t.getNextCodePoint=t.computeCodePoint=t.isLowSurrogate=t.isHighSurrogate=t.commonSuffixLength=t.commonPrefixLength=t.startsWithIgnoreCase=t.equalsIgnoreCase=t.isUpperAsciiLetter=t.isLowerAsciiLetter=t.isAsciiDigit=t.compareSubstringIgnoreCase=t.compareIgnoreCase=t.compareSubstring=t.compare=t.replaceAsync=t.lastNonWhitespaceIndex=t.getLeadingWhitespace=t.firstNonWhitespaceIndex=t.splitLines=t.regExpFlags=t.regExpContainsBackreference=t.regExpLeadsToEndlessLoop=t.createRegExp=t.stripWildcards=t.convertSimple2RegExpPattern=t.rtrim=t.ltrim=t.trim=t.truncate=t.count=t.escapeRegExpCharacters=t.escape=t.format2=t.format=t.isFalsyOrWhitespace=void 0;function O(q){return!q||typeof q!="string"?!0:q.trim().length===0}t.isFalsyOrWhitespace=O;const _=/{(\d+)}/g;function w(q,...oe){return oe.length===0?q:q.replace(_,function(be,Ce){const Te=parseInt(Ce,10);return isNaN(Te)||Te<0||Te>=oe.length?be:oe[Te]})}t.format=w;const g=/{([^}]+)}/g;function d(q,oe){return q.replace(g,(be,Ce)=>oe[Ce]??be)}t.format2=d;function f(q){return q.replace(/[<>&]/g,function(oe){switch(oe){case"<":return"&lt;";case">":return"&gt;";case"&":return"&amp;";default:return oe}})}t.escape=f;function F(q){return q.replace(/[\\\{\}\*\+\?\|\^\$\.\[\]\(\)]/g,"\\$&")}t.escapeRegExpCharacters=F;function l(q,oe){let be=0;const Ce=oe.charCodeAt(0);for(let Te=q.length-1;Te>=0;Te--)q.charCodeAt(Te)===Ce&&be++;return be}t.count=l;function s(q,oe,be="\u2026"){return q.length<=oe?q:`${q.substr(0,oe)}${be}`}t.truncate=s;function e(q,oe=" "){const be=p(q,oe);return v(be,oe)}t.trim=e;function p(q,oe){if(!q||!oe)return q;const be=oe.length;if(be===0||q.length===0)return q;let Ce=0;for(;q.indexOf(oe,Ce)===Ce;)Ce=Ce+be;return q.substring(Ce)}t.ltrim=p;function v(q,oe){if(!q||!oe)return q;const be=oe.length,Ce=q.length;if(be===0||Ce===0)return q;let Te=Ce,Re=-1;for(;Re=q.lastIndexOf(oe,Te-1),!(Re===-1||Re+be!==Te);){if(Re===0)return"";Te=Re}return q.substring(0,Te)}t.rtrim=v;function D(q){return q.replace(/[\-\\\{\}\+\?\|\^\$\.\,\[\]\(\)\#\s]/g,"\\$&").replace(/[\*]/g,".*")}t.convertSimple2RegExpPattern=D;function y(q){return q.replace(/\*/g,"")}t.stripWildcards=y;function o(q,oe,be={}){if(!q)throw new Error("Cannot create regex from empty string");oe||(q=F(q)),be.wholeWord&&(/\B/.test(q.charAt(0))||(q="\\b"+q),/\B/.test(q.charAt(q.length-1))||(q=q+"\\b"));let Ce="";return be.global&&(Ce+="g"),be.matchCase||(Ce+="i"),be.multiline&&(Ce+="m"),be.unicode&&(Ce+="u"),new RegExp(q,Ce)}t.createRegExp=o;function c(q){return q.source==="^"||q.source==="^$"||q.source==="$"||q.source==="^\\s*$"?!1:!!(q.exec("")&&q.lastIndex===0)}t.regExpLeadsToEndlessLoop=c;function b(q){return!!q.match(/([^\\]|^)(\\\\)*\\\d+/)}t.regExpContainsBackreference=b;function S(q){return(q.global?"g":"")+(q.ignoreCase?"i":"")+(q.multiline?"m":"")+(q.unicode?"u":"")}t.regExpFlags=S;function A(q){return q.split(/\r\n|\r|\n/)}t.splitLines=A;function C(q){for(let oe=0,be=q.length;oe<be;oe++){const Ce=q.charCodeAt(oe);if(Ce!==32&&Ce!==9)return oe}return-1}t.firstNonWhitespaceIndex=C;function r(q,oe=0,be=q.length){for(let Ce=oe;Ce<be;Ce++){const Te=q.charCodeAt(Ce);if(Te!==32&&Te!==9)return q.substring(oe,Ce)}return q.substring(oe,be)}t.getLeadingWhitespace=r;function n(q,oe=q.length-1){for(let be=oe;be>=0;be--){const Ce=q.charCodeAt(be);if(Ce!==32&&Ce!==9)return be}return-1}t.lastNonWhitespaceIndex=n;function a(q,oe,be){const Ce=[];let Te=0;for(const Re of q.matchAll(oe)){if(Ce.push(q.slice(Te,Re.index)),Re.index===void 0)throw new Error("match.index should be defined");Te=Re.index+Re[0].length,Ce.push(be(Re[0],...Re.slice(1),Re.index,q,Re.groups))}return Ce.push(q.slice(Te)),Promise.all(Ce).then(Re=>Re.join(""))}t.replaceAsync=a;function u(q,oe){return q<oe?-1:q>oe?1:0}t.compare=u;function m(q,oe,be=0,Ce=q.length,Te=0,Re=oe.length){for(;be<Ce&&Te<Re;be++,Te++){const Xe=q.charCodeAt(be),qe=oe.charCodeAt(Te);if(Xe<qe)return-1;if(Xe>qe)return 1}const $e=Ce-be,tt=Re-Te;return $e<tt?-1:$e>tt?1:0}t.compareSubstring=m;function W(q,oe){return V(q,oe,0,q.length,0,oe.length)}t.compareIgnoreCase=W;function V(q,oe,be=0,Ce=q.length,Te=0,Re=oe.length){for(;be<Ce&&Te<Re;be++,Te++){let Xe=q.charCodeAt(be),qe=oe.charCodeAt(Te);if(Xe===qe)continue;if(Xe>=128||qe>=128)return m(q.toLowerCase(),oe.toLowerCase(),be,Ce,Te,Re);re(Xe)&&(Xe-=32),re(qe)&&(qe-=32);const Le=Xe-qe;if(Le!==0)return Le}const $e=Ce-be,tt=Re-Te;return $e<tt?-1:$e>tt?1:0}t.compareSubstringIgnoreCase=V;function ne(q){return q>=48&&q<=57}t.isAsciiDigit=ne;function re(q){return q>=97&&q<=122}t.isLowerAsciiLetter=re;function we(q){return q>=65&&q<=90}t.isUpperAsciiLetter=we;function ae(q,oe){return q.length===oe.length&&V(q,oe)===0}t.equalsIgnoreCase=ae;function ve(q,oe){const be=oe.length;return oe.length>q.length?!1:V(q,oe,0,be)===0}t.startsWithIgnoreCase=ve;function ue(q,oe){const be=Math.min(q.length,oe.length);let Ce;for(Ce=0;Ce<be;Ce++)if(q.charCodeAt(Ce)!==oe.charCodeAt(Ce))return Ce;return be}t.commonPrefixLength=ue;function ge(q,oe){const be=Math.min(q.length,oe.length);let Ce;const Te=q.length-1,Re=oe.length-1;for(Ce=0;Ce<be;Ce++)if(q.charCodeAt(Te-Ce)!==oe.charCodeAt(Re-Ce))return Ce;return be}t.commonSuffixLength=ge;function ye(q){return 55296<=q&&q<=56319}t.isHighSurrogate=ye;function ee(q){return 56320<=q&&q<=57343}t.isLowSurrogate=ee;function fe(q,oe){return(q-55296<<10)+(oe-56320)+65536}t.computeCodePoint=fe;function te(q,oe,be){const Ce=q.charCodeAt(be);if(ye(Ce)&&be+1<oe){const Te=q.charCodeAt(be+1);if(ee(Te))return fe(Ce,Te)}return Ce}t.getNextCodePoint=te;function X(q,oe){const be=q.charCodeAt(oe-1);if(ee(be)&&oe>1){const Ce=q.charCodeAt(oe-2);if(ye(Ce))return fe(Ce,be)}return be}class se{constructor(oe,be=0){this._str=oe,this._len=oe.length,this._offset=be}get offset(){return this._offset}setOffset(oe){this._offset=oe}prevCodePoint(){const oe=X(this._str,this._offset);return this._offset-=oe>=65536?2:1,oe}nextCodePoint(){const oe=te(this._str,this._len,this._offset);return this._offset+=oe>=65536?2:1,oe}eol(){return this._offset>=this._len}}t.CodePointIterator=se;class ie{constructor(oe,be=0){this._iterator=new se(oe,be)}get offset(){return this._iterator.offset}nextGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ce=be.offset;let Te=oe.getGraphemeBreakType(be.nextCodePoint());for(;!be.eol();){const Re=be.offset,$e=oe.getGraphemeBreakType(be.nextCodePoint());if(Ie(Te,$e)){be.setOffset(Re);break}Te=$e}return be.offset-Ce}prevGraphemeLength(){const oe=Pe.getInstance(),be=this._iterator,Ce=be.offset;let Te=oe.getGraphemeBreakType(be.prevCodePoint());for(;be.offset>0;){const Re=be.offset,$e=oe.getGraphemeBreakType(be.prevCodePoint());if(Ie($e,Te)){be.setOffset(Re);break}Te=$e}return Ce-be.offset}eol(){return this._iterator.eol()}}t.GraphemeIterator=ie;function L(q,oe){return new ie(q,oe).nextGraphemeLength()}t.nextCharLength=L;function $(q,oe){return new ie(q,oe).prevGraphemeLength()}t.prevCharLength=$;function G(q,oe){oe>0&&ee(q.charCodeAt(oe))&&oe--;const be=oe+L(q,oe);return[be-$(q,be),be]}t.getCharContainingOffset=G;const B=/(?:[\u05BE\u05C0\u05C3\u05C6\u05D0-\u05F4\u0608\u060B\u060D\u061B-\u064A\u066D-\u066F\u0671-\u06D5\u06E5\u06E6\u06EE\u06EF\u06FA-\u0710\u0712-\u072F\u074D-\u07A5\u07B1-\u07EA\u07F4\u07F5\u07FA\u07FE-\u0815\u081A\u0824\u0828\u0830-\u0858\u085E-\u088E\u08A0-\u08C9\u200F\uFB1D\uFB1F-\uFB28\uFB2A-\uFD3D\uFD50-\uFDC7\uFDF0-\uFDFC\uFE70-\uFEFC]|\uD802[\uDC00-\uDD1B\uDD20-\uDE00\uDE10-\uDE35\uDE40-\uDEE4\uDEEB-\uDF35\uDF40-\uDFFF]|\uD803[\uDC00-\uDD23\uDE80-\uDEA9\uDEAD-\uDF45\uDF51-\uDF81\uDF86-\uDFF6]|\uD83A[\uDC00-\uDCCF\uDD00-\uDD43\uDD4B-\uDFFF]|\uD83B[\uDC00-\uDEBB])/;function h(q){return B.test(q)}t.containsRTL=h;const I=/^[\t\n\r\x20-\x7E]*$/;function U(q){return I.test(q)}t.isBasicASCII=U,t.UNUSUAL_LINE_TERMINATORS=/[\u2028\u2029]/;function K(q){return t.UNUSUAL_LINE_TERMINATORS.test(q)}t.containsUnusualLineTerminators=K;function Q(q){return q>=11904&&q<=55215||q>=63744&&q<=64255||q>=65281&&q<=65374}t.isFullWidthCharacter=Q;function N(q){return q>=127462&&q<=127487||q===8986||q===8987||q===9200||q===9203||q>=9728&&q<=10175||q===11088||q===11093||q>=127744&&q<=128591||q>=128640&&q<=128764||q>=128992&&q<=129008||q>=129280&&q<=129535||q>=129648&&q<=129782}t.isEmojiImprecise=N;function R(q,oe){if(q.length<oe)return q;const be=/\b/g;let Ce=0;for(;be.test(q)&&!(q.length-be.lastIndex<oe);)Ce=be.lastIndex,be.lastIndex+=1;return q.substring(Ce).replace(/^\s/,"")}t.lcut=R;const z=/\x1B\x5B[12]?K/g,T=/\x1b\[\d+m/g,H=/\x1b\[0?m/g;function k(q){return q&&(q=q.replace(z,""),q=q.replace(T,""),q=q.replace(H,"")),q}t.removeAnsiEscapeCodes=k,t.UTF8_BOM_CHARACTER=String.fromCharCode(65279);function P(q){return!!(q&&q.length>0&&q.charCodeAt(0)===65279)}t.startsWithUTF8BOM=P;function x(q){return P(q)?q.substr(1):q}t.stripUTF8BOM=x;function J(q,oe){if(!q||!oe||q.length<oe.length)return!1;const be=oe.length,Ce=q.toLowerCase();let Te=0,Re=-1;for(;Te<be;){const $e=Ce.indexOf(oe[Te],Re+1);if($e<0)return!1;Re=$e,Te++}return!0}t.fuzzyContains=J;function he(q,oe=!1){return q?(oe&&(q=q.replace(/\\./g,"")),q.toLowerCase()!==q):!1}t.containsUppercaseCharacter=he;function de(q){return q.charAt(0).toUpperCase()+q.slice(1)}t.uppercaseFirstLetter=de;function Ee(q,oe=1){if(oe===0)return"";let be=-1;do be=q.indexOf(`
`,be+1),oe--;while(oe>0&&be>=0);return be===-1?q:(q[be-1]==="\r"&&be--,q.substr(0,be))}t.getNLines=Ee;function _e(q){const oe=90-65+1;return q=q%(2*oe),q<oe?String.fromCharCode(97+q):String.fromCharCode(65+q-oe)}t.singleLetterHash=_e;function ke(q){return Pe.getInstance().getGraphemeBreakType(q)}t.getGraphemeBreakType=ke;function Ie(q,oe){return q===0?oe!==5&&oe!==7:q===2&&oe===3?!1:q===4||q===2||q===3||oe===4||oe===2||oe===3?!0:!(q===8&&(oe===8||oe===9||oe===11||oe===12)||(q===11||q===9)&&(oe===9||oe===10)||(q===12||q===10)&&oe===10||oe===5||oe===13||oe===7||q===1||q===13&&oe===14||q===6&&oe===6)}var De;(function(q){q[q.Other=0]="Other",q[q.Prepend=1]="Prepend",q[q.CR=2]="CR",q[q.LF=3]="LF",q[q.Control=4]="Control",q[q.Extend=5]="Extend",q[q.Regional_Indicator=6]="Regional_Indicator",q[q.SpacingMark=7]="SpacingMark",q[q.L=8]="L",q[q.V=9]="V",q[q.T=10]="T",q[q.LV=11]="LV",q[q.LVT=12]="LVT",q[q.ZWJ=13]="ZWJ",q[q.Extended_Pictographic=14]="Extended_Pictographic"})(De=t.GraphemeBreakType||(t.GraphemeBreakType={}));class Pe{constructor(){this._data=Me()}static getInstance(){return Pe._INSTANCE||(Pe._INSTANCE=new Pe),Pe._INSTANCE}getGraphemeBreakType(oe){if(oe<32)return oe===10?3:oe===13?2:4;if(oe<127)return 0;const be=this._data,Ce=be.length/3;let Te=1;for(;Te<=Ce;)if(oe<be[3*Te])Te=2*Te;else if(oe>be[3*Te+1])Te=2*Te+1;else return be[3*Te+2];return 0}}Pe._INSTANCE=null;function Me(){return JSON.parse("[0,0,0,51229,51255,12,44061,44087,12,127462,127487,6,7083,7085,5,47645,47671,12,54813,54839,12,128678,128678,14,3270,3270,5,9919,9923,14,45853,45879,12,49437,49463,12,53021,53047,12,71216,71218,7,128398,128399,14,129360,129374,14,2519,2519,5,4448,4519,9,9742,9742,14,12336,12336,14,44957,44983,12,46749,46775,12,48541,48567,12,50333,50359,12,52125,52151,12,53917,53943,12,69888,69890,5,73018,73018,5,127990,127990,14,128558,128559,14,128759,128760,14,129653,129655,14,2027,2035,5,2891,2892,7,3761,3761,5,6683,6683,5,8293,8293,4,9825,9826,14,9999,9999,14,43452,43453,5,44509,44535,12,45405,45431,12,46301,46327,12,47197,47223,12,48093,48119,12,48989,49015,12,49885,49911,12,50781,50807,12,51677,51703,12,52573,52599,12,53469,53495,12,54365,54391,12,65279,65279,4,70471,70472,7,72145,72147,7,119173,119179,5,127799,127818,14,128240,128244,14,128512,128512,14,128652,128652,14,128721,128722,14,129292,129292,14,129445,129450,14,129734,129743,14,1476,1477,5,2366,2368,7,2750,2752,7,3076,3076,5,3415,3415,5,4141,4144,5,6109,6109,5,6964,6964,5,7394,7400,5,9197,9198,14,9770,9770,14,9877,9877,14,9968,9969,14,10084,10084,14,43052,43052,5,43713,43713,5,44285,44311,12,44733,44759,12,45181,45207,12,45629,45655,12,46077,46103,12,46525,46551,12,46973,46999,12,47421,47447,12,47869,47895,12,48317,48343,12,48765,48791,12,49213,49239,12,49661,49687,12,50109,50135,12,50557,50583,12,51005,51031,12,51453,51479,12,51901,51927,12,52349,52375,12,52797,52823,12,53245,53271,12,53693,53719,12,54141,54167,12,54589,54615,12,55037,55063,12,69506,69509,5,70191,70193,5,70841,70841,7,71463,71467,5,72330,72342,5,94031,94031,5,123628,123631,5,127763,127765,14,127941,127941,14,128043,128062,14,128302,128317,14,128465,128467,14,128539,128539,14,128640,128640,14,128662,128662,14,128703,128703,14,128745,128745,14,129004,129007,14,129329,129330,14,129402,129402,14,129483,129483,14,129686,129704,14,130048,131069,14,173,173,4,1757,1757,1,2200,2207,5,2434,2435,7,2631,2632,5,2817,2817,5,3008,3008,5,3201,3201,5,3387,3388,5,3542,3542,5,3902,3903,7,4190,4192,5,6002,6003,5,6439,6440,5,6765,6770,7,7019,7027,5,7154,7155,7,8205,8205,13,8505,8505,14,9654,9654,14,9757,9757,14,9792,9792,14,9852,9853,14,9890,9894,14,9937,9937,14,9981,9981,14,10035,10036,14,11035,11036,14,42654,42655,5,43346,43347,7,43587,43587,5,44006,44007,7,44173,44199,12,44397,44423,12,44621,44647,12,44845,44871,12,45069,45095,12,45293,45319,12,45517,45543,12,45741,45767,12,45965,45991,12,46189,46215,12,46413,46439,12,46637,46663,12,46861,46887,12,47085,47111,12,47309,47335,12,47533,47559,12,47757,47783,12,47981,48007,12,48205,48231,12,48429,48455,12,48653,48679,12,48877,48903,12,49101,49127,12,49325,49351,12,49549,49575,12,49773,49799,12,49997,50023,12,50221,50247,12,50445,50471,12,50669,50695,12,50893,50919,12,51117,51143,12,51341,51367,12,51565,51591,12,51789,51815,12,52013,52039,12,52237,52263,12,52461,52487,12,52685,52711,12,52909,52935,12,53133,53159,12,53357,53383,12,53581,53607,12,53805,53831,12,54029,54055,12,54253,54279,12,54477,54503,12,54701,54727,12,54925,54951,12,55149,55175,12,68101,68102,5,69762,69762,7,70067,70069,7,70371,70378,5,70720,70721,7,71087,71087,5,71341,71341,5,71995,71996,5,72249,72249,7,72850,72871,5,73109,73109,5,118576,118598,5,121505,121519,5,127245,127247,14,127568,127569,14,127777,127777,14,127872,127891,14,127956,127967,14,128015,128016,14,128110,128172,14,128259,128259,14,128367,128368,14,128424,128424,14,128488,128488,14,128530,128532,14,128550,128551,14,128566,128566,14,128647,128647,14,128656,128656,14,128667,128673,14,128691,128693,14,128715,128715,14,128728,128732,14,128752,128752,14,128765,128767,14,129096,129103,14,129311,129311,14,129344,129349,14,129394,129394,14,129413,129425,14,129466,129471,14,129511,129535,14,129664,129666,14,129719,129722,14,129760,129767,14,917536,917631,5,13,13,2,1160,1161,5,1564,1564,4,1807,1807,1,2085,2087,5,2307,2307,7,2382,2383,7,2497,2500,5,2563,2563,7,2677,2677,5,2763,2764,7,2879,2879,5,2914,2915,5,3021,3021,5,3142,3144,5,3263,3263,5,3285,3286,5,3398,3400,7,3530,3530,5,3633,3633,5,3864,3865,5,3974,3975,5,4155,4156,7,4229,4230,5,5909,5909,7,6078,6085,7,6277,6278,5,6451,6456,7,6744,6750,5,6846,6846,5,6972,6972,5,7074,7077,5,7146,7148,7,7222,7223,5,7416,7417,5,8234,8238,4,8417,8417,5,9000,9000,14,9203,9203,14,9730,9731,14,9748,9749,14,9762,9763,14,9776,9783,14,9800,9811,14,9831,9831,14,9872,9873,14,9882,9882,14,9900,9903,14,9929,9933,14,9941,9960,14,9974,9974,14,9989,9989,14,10006,10006,14,10062,10062,14,10160,10160,14,11647,11647,5,12953,12953,14,43019,43019,5,43232,43249,5,43443,43443,5,43567,43568,7,43696,43696,5,43765,43765,7,44013,44013,5,44117,44143,12,44229,44255,12,44341,44367,12,44453,44479,12,44565,44591,12,44677,44703,12,44789,44815,12,44901,44927,12,45013,45039,12,45125,45151,12,45237,45263,12,45349,45375,12,45461,45487,12,45573,45599,12,45685,45711,12,45797,45823,12,45909,45935,12,46021,46047,12,46133,46159,12,46245,46271,12,46357,46383,12,46469,46495,12,46581,46607,12,46693,46719,12,46805,46831,12,46917,46943,12,47029,47055,12,47141,47167,12,47253,47279,12,47365,47391,12,47477,47503,12,47589,47615,12,47701,47727,12,47813,47839,12,47925,47951,12,48037,48063,12,48149,48175,12,48261,48287,12,48373,48399,12,48485,48511,12,48597,48623,12,48709,48735,12,48821,48847,12,48933,48959,12,49045,49071,12,49157,49183,12,49269,49295,12,49381,49407,12,49493,49519,12,49605,49631,12,49717,49743,12,49829,49855,12,49941,49967,12,50053,50079,12,50165,50191,12,50277,50303,12,50389,50415,12,50501,50527,12,50613,50639,12,50725,50751,12,50837,50863,12,50949,50975,12,51061,51087,12,51173,51199,12,51285,51311,12,51397,51423,12,51509,51535,12,51621,51647,12,51733,51759,12,51845,51871,12,51957,51983,12,52069,52095,12,52181,52207,12,52293,52319,12,52405,52431,12,52517,52543,12,52629,52655,12,52741,52767,12,52853,52879,12,52965,52991,12,53077,53103,12,53189,53215,12,53301,53327,12,53413,53439,12,53525,53551,12,53637,53663,12,53749,53775,12,53861,53887,12,53973,53999,12,54085,54111,12,54197,54223,12,54309,54335,12,54421,54447,12,54533,54559,12,54645,54671,12,54757,54783,12,54869,54895,12,54981,55007,12,55093,55119,12,55243,55291,10,66045,66045,5,68325,68326,5,69688,69702,5,69817,69818,5,69957,69958,7,70089,70092,5,70198,70199,5,70462,70462,5,70502,70508,5,70750,70750,5,70846,70846,7,71100,71101,5,71230,71230,7,71351,71351,5,71737,71738,5,72000,72000,7,72160,72160,5,72273,72278,5,72752,72758,5,72882,72883,5,73031,73031,5,73461,73462,7,94192,94193,7,119149,119149,7,121403,121452,5,122915,122916,5,126980,126980,14,127358,127359,14,127535,127535,14,127759,127759,14,127771,127771,14,127792,127793,14,127825,127867,14,127897,127899,14,127945,127945,14,127985,127986,14,128000,128007,14,128021,128021,14,128066,128100,14,128184,128235,14,128249,128252,14,128266,128276,14,128335,128335,14,128379,128390,14,128407,128419,14,128444,128444,14,128481,128481,14,128499,128499,14,128526,128526,14,128536,128536,14,128543,128543,14,128556,128556,14,128564,128564,14,128577,128580,14,128643,128645,14,128649,128649,14,128654,128654,14,128660,128660,14,128664,128664,14,128675,128675,14,128686,128689,14,128695,128696,14,128705,128709,14,128717,128719,14,128725,128725,14,128736,128741,14,128747,128748,14,128755,128755,14,128762,128762,14,128981,128991,14,129009,129023,14,129160,129167,14,129296,129304,14,129320,129327,14,129340,129342,14,129356,129356,14,129388,129392,14,129399,129400,14,129404,129407,14,129432,129442,14,129454,129455,14,129473,129474,14,129485,129487,14,129648,129651,14,129659,129660,14,129671,129679,14,129709,129711,14,129728,129730,14,129751,129753,14,129776,129782,14,917505,917505,4,917760,917999,5,10,10,3,127,159,4,768,879,5,1471,1471,5,1536,1541,1,1648,1648,5,1767,1768,5,1840,1866,5,2070,2073,5,2137,2139,5,2274,2274,1,2363,2363,7,2377,2380,7,2402,2403,5,2494,2494,5,2507,2508,7,2558,2558,5,2622,2624,7,2641,2641,5,2691,2691,7,2759,2760,5,2786,2787,5,2876,2876,5,2881,2884,5,2901,2902,5,3006,3006,5,3014,3016,7,3072,3072,5,3134,3136,5,3157,3158,5,3260,3260,5,3266,3266,5,3274,3275,7,3328,3329,5,3391,3392,7,3405,3405,5,3457,3457,5,3536,3537,7,3551,3551,5,3636,3642,5,3764,3772,5,3895,3895,5,3967,3967,7,3993,4028,5,4146,4151,5,4182,4183,7,4226,4226,5,4253,4253,5,4957,4959,5,5940,5940,7,6070,6070,7,6087,6088,7,6158,6158,4,6432,6434,5,6448,6449,7,6679,6680,5,6742,6742,5,6754,6754,5,6783,6783,5,6912,6915,5,6966,6970,5,6978,6978,5,7042,7042,7,7080,7081,5,7143,7143,7,7150,7150,7,7212,7219,5,7380,7392,5,7412,7412,5,8203,8203,4,8232,8232,4,8265,8265,14,8400,8412,5,8421,8432,5,8617,8618,14,9167,9167,14,9200,9200,14,9410,9410,14,9723,9726,14,9733,9733,14,9745,9745,14,9752,9752,14,9760,9760,14,9766,9766,14,9774,9774,14,9786,9786,14,9794,9794,14,9823,9823,14,9828,9828,14,9833,9850,14,9855,9855,14,9875,9875,14,9880,9880,14,9885,9887,14,9896,9897,14,9906,9916,14,9926,9927,14,9935,9935,14,9939,9939,14,9962,9962,14,9972,9972,14,9978,9978,14,9986,9986,14,9997,9997,14,10002,10002,14,10017,10017,14,10055,10055,14,10071,10071,14,10133,10135,14,10548,10549,14,11093,11093,14,12330,12333,5,12441,12442,5,42608,42610,5,43010,43010,5,43045,43046,5,43188,43203,7,43302,43309,5,43392,43394,5,43446,43449,5,43493,43493,5,43571,43572,7,43597,43597,7,43703,43704,5,43756,43757,5,44003,44004,7,44009,44010,7,44033,44059,12,44089,44115,12,44145,44171,12,44201,44227,12,44257,44283,12,44313,44339,12,44369,44395,12,44425,44451,12,44481,44507,12,44537,44563,12,44593,44619,12,44649,44675,12,44705,44731,12,44761,44787,12,44817,44843,12,44873,44899,12,44929,44955,12,44985,45011,12,45041,45067,12,45097,45123,12,45153,45179,12,45209,45235,12,45265,45291,12,45321,45347,12,45377,45403,12,45433,45459,12,45489,45515,12,45545,45571,12,45601,45627,12,45657,45683,12,45713,45739,12,45769,45795,12,45825,45851,12,45881,45907,12,45937,45963,12,45993,46019,12,46049,46075,12,46105,46131,12,46161,46187,12,46217,46243,12,46273,46299,12,46329,46355,12,46385,46411,12,46441,46467,12,46497,46523,12,46553,46579,12,46609,46635,12,46665,46691,12,46721,46747,12,46777,46803,12,46833,46859,12,46889,46915,12,46945,46971,12,47001,47027,12,47057,47083,12,47113,47139,12,47169,47195,12,47225,47251,12,47281,47307,12,47337,47363,12,47393,47419,12,47449,47475,12,47505,47531,12,47561,47587,12,47617,47643,12,47673,47699,12,47729,47755,12,47785,47811,12,47841,47867,12,47897,47923,12,47953,47979,12,48009,48035,12,48065,48091,12,48121,48147,12,48177,48203,12,48233,48259,12,48289,48315,12,48345,48371,12,48401,48427,12,48457,48483,12,48513,48539,12,48569,48595,12,48625,48651,12,48681,48707,12,48737,48763,12,48793,48819,12,48849,48875,12,48905,48931,12,48961,48987,12,49017,49043,12,49073,49099,12,49129,49155,12,49185,49211,12,49241,49267,12,49297,49323,12,49353,49379,12,49409,49435,12,49465,49491,12,49521,49547,12,49577,49603,12,49633,49659,12,49689,49715,12,49745,49771,12,49801,49827,12,49857,49883,12,49913,49939,12,49969,49995,12,50025,50051,12,50081,50107,12,50137,50163,12,50193,50219,12,50249,50275,12,50305,50331,12,50361,50387,12,50417,50443,12,50473,50499,12,50529,50555,12,50585,50611,12,50641,50667,12,50697,50723,12,50753,50779,12,50809,50835,12,50865,50891,12,50921,50947,12,50977,51003,12,51033,51059,12,51089,51115,12,51145,51171,12,51201,51227,12,51257,51283,12,51313,51339,12,51369,51395,12,51425,51451,12,51481,51507,12,51537,51563,12,51593,51619,12,51649,51675,12,51705,51731,12,51761,51787,12,51817,51843,12,51873,51899,12,51929,51955,12,51985,52011,12,52041,52067,12,52097,52123,12,52153,52179,12,52209,52235,12,52265,52291,12,52321,52347,12,52377,52403,12,52433,52459,12,52489,52515,12,52545,52571,12,52601,52627,12,52657,52683,12,52713,52739,12,52769,52795,12,52825,52851,12,52881,52907,12,52937,52963,12,52993,53019,12,53049,53075,12,53105,53131,12,53161,53187,12,53217,53243,12,53273,53299,12,53329,53355,12,53385,53411,12,53441,53467,12,53497,53523,12,53553,53579,12,53609,53635,12,53665,53691,12,53721,53747,12,53777,53803,12,53833,53859,12,53889,53915,12,53945,53971,12,54001,54027,12,54057,54083,12,54113,54139,12,54169,54195,12,54225,54251,12,54281,54307,12,54337,54363,12,54393,54419,12,54449,54475,12,54505,54531,12,54561,54587,12,54617,54643,12,54673,54699,12,54729,54755,12,54785,54811,12,54841,54867,12,54897,54923,12,54953,54979,12,55009,55035,12,55065,55091,12,55121,55147,12,55177,55203,12,65024,65039,5,65520,65528,4,66422,66426,5,68152,68154,5,69291,69292,5,69633,69633,5,69747,69748,5,69811,69814,5,69826,69826,5,69932,69932,7,70016,70017,5,70079,70080,7,70095,70095,5,70196,70196,5,70367,70367,5,70402,70403,7,70464,70464,5,70487,70487,5,70709,70711,7,70725,70725,7,70833,70834,7,70843,70844,7,70849,70849,7,71090,71093,5,71103,71104,5,71227,71228,7,71339,71339,5,71344,71349,5,71458,71461,5,71727,71735,5,71985,71989,7,71998,71998,5,72002,72002,7,72154,72155,5,72193,72202,5,72251,72254,5,72281,72283,5,72344,72345,5,72766,72766,7,72874,72880,5,72885,72886,5,73023,73029,5,73104,73105,5,73111,73111,5,92912,92916,5,94095,94098,5,113824,113827,4,119142,119142,7,119155,119162,4,119362,119364,5,121476,121476,5,122888,122904,5,123184,123190,5,125252,125258,5,127183,127183,14,127340,127343,14,127377,127386,14,127491,127503,14,127548,127551,14,127744,127756,14,127761,127761,14,127769,127769,14,127773,127774,14,127780,127788,14,127796,127797,14,127820,127823,14,127869,127869,14,127894,127895,14,127902,127903,14,127943,127943,14,127947,127950,14,127972,127972,14,127988,127988,14,127992,127994,14,128009,128011,14,128019,128019,14,128023,128041,14,128064,128064,14,128102,128107,14,128174,128181,14,128238,128238,14,128246,128247,14,128254,128254,14,128264,128264,14,128278,128299,14,128329,128330,14,128348,128359,14,128371,128377,14,128392,128393,14,128401,128404,14,128421,128421,14,128433,128434,14,128450,128452,14,128476,128478,14,128483,128483,14,128495,128495,14,128506,128506,14,128519,128520,14,128528,128528,14,128534,128534,14,128538,128538,14,128540,128542,14,128544,128549,14,128552,128555,14,128557,128557,14,128560,128563,14,128565,128565,14,128567,128576,14,128581,128591,14,128641,128642,14,128646,128646,14,128648,128648,14,128650,128651,14,128653,128653,14,128655,128655,14,128657,128659,14,128661,128661,14,128663,128663,14,128665,128666,14,128674,128674,14,128676,128677,14,128679,128685,14,128690,128690,14,128694,128694,14,128697,128702,14,128704,128704,14,128710,128714,14,128716,128716,14,128720,128720,14,128723,128724,14,128726,128727,14,128733,128735,14,128742,128744,14,128746,128746,14,128749,128751,14,128753,128754,14,128756,128758,14,128761,128761,14,128763,128764,14,128884,128895,14,128992,129003,14,129008,129008,14,129036,129039,14,129114,129119,14,129198,129279,14,129293,129295,14,129305,129310,14,129312,129319,14,129328,129328,14,129331,129338,14,129343,129343,14,129351,129355,14,129357,129359,14,129375,129387,14,129393,129393,14,129395,129398,14,129401,129401,14,129403,129403,14,129408,129412,14,129426,129431,14,129443,129444,14,129451,129453,14,129456,129465,14,129472,129472,14,129475,129482,14,129484,129484,14,129488,129510,14,129536,129647,14,129652,129652,14,129656,129658,14,129661,129663,14,129667,129670,14,129680,129685,14,129705,129708,14,129712,129718,14,129723,129727,14,129731,129733,14,129744,129750,14,129754,129759,14,129768,129775,14,129783,129791,14,917504,917504,4,917506,917535,4,917632,917759,4,918000,921599,4,0,9,4,11,12,4,14,31,4,169,169,14,174,174,14,1155,1159,5,1425,1469,5,1473,1474,5,1479,1479,5,1552,1562,5,1611,1631,5,1750,1756,5,1759,1764,5,1770,1773,5,1809,1809,5,1958,1968,5,2045,2045,5,2075,2083,5,2089,2093,5,2192,2193,1,2250,2273,5,2275,2306,5,2362,2362,5,2364,2364,5,2369,2376,5,2381,2381,5,2385,2391,5,2433,2433,5,2492,2492,5,2495,2496,7,2503,2504,7,2509,2509,5,2530,2531,5,2561,2562,5,2620,2620,5,2625,2626,5,2635,2637,5,2672,2673,5,2689,2690,5,2748,2748,5,2753,2757,5,2761,2761,7,2765,2765,5,2810,2815,5,2818,2819,7,2878,2878,5,2880,2880,7,2887,2888,7,2893,2893,5,2903,2903,5,2946,2946,5,3007,3007,7,3009,3010,7,3018,3020,7,3031,3031,5,3073,3075,7,3132,3132,5,3137,3140,7,3146,3149,5,3170,3171,5,3202,3203,7,3262,3262,7,3264,3265,7,3267,3268,7,3271,3272,7,3276,3277,5,3298,3299,5,3330,3331,7,3390,3390,5,3393,3396,5,3402,3404,7,3406,3406,1,3426,3427,5,3458,3459,7,3535,3535,5,3538,3540,5,3544,3550,7,3570,3571,7,3635,3635,7,3655,3662,5,3763,3763,7,3784,3789,5,3893,3893,5,3897,3897,5,3953,3966,5,3968,3972,5,3981,3991,5,4038,4038,5,4145,4145,7,4153,4154,5,4157,4158,5,4184,4185,5,4209,4212,5,4228,4228,7,4237,4237,5,4352,4447,8,4520,4607,10,5906,5908,5,5938,5939,5,5970,5971,5,6068,6069,5,6071,6077,5,6086,6086,5,6089,6099,5,6155,6157,5,6159,6159,5,6313,6313,5,6435,6438,7,6441,6443,7,6450,6450,5,6457,6459,5,6681,6682,7,6741,6741,7,6743,6743,7,6752,6752,5,6757,6764,5,6771,6780,5,6832,6845,5,6847,6862,5,6916,6916,7,6965,6965,5,6971,6971,7,6973,6977,7,6979,6980,7,7040,7041,5,7073,7073,7,7078,7079,7,7082,7082,7,7142,7142,5,7144,7145,5,7149,7149,5,7151,7153,5,7204,7211,7,7220,7221,7,7376,7378,5,7393,7393,7,7405,7405,5,7415,7415,7,7616,7679,5,8204,8204,5,8206,8207,4,8233,8233,4,8252,8252,14,8288,8292,4,8294,8303,4,8413,8416,5,8418,8420,5,8482,8482,14,8596,8601,14,8986,8987,14,9096,9096,14,9193,9196,14,9199,9199,14,9201,9202,14,9208,9210,14,9642,9643,14,9664,9664,14,9728,9729,14,9732,9732,14,9735,9741,14,9743,9744,14,9746,9746,14,9750,9751,14,9753,9756,14,9758,9759,14,9761,9761,14,9764,9765,14,9767,9769,14,9771,9773,14,9775,9775,14,9784,9785,14,9787,9791,14,9793,9793,14,9795,9799,14,9812,9822,14,9824,9824,14,9827,9827,14,9829,9830,14,9832,9832,14,9851,9851,14,9854,9854,14,9856,9861,14,9874,9874,14,9876,9876,14,9878,9879,14,9881,9881,14,9883,9884,14,9888,9889,14,9895,9895,14,9898,9899,14,9904,9905,14,9917,9918,14,9924,9925,14,9928,9928,14,9934,9934,14,9936,9936,14,9938,9938,14,9940,9940,14,9961,9961,14,9963,9967,14,9970,9971,14,9973,9973,14,9975,9977,14,9979,9980,14,9982,9985,14,9987,9988,14,9992,9996,14,9998,9998,14,10000,10001,14,10004,10004,14,10013,10013,14,10024,10024,14,10052,10052,14,10060,10060,14,10067,10069,14,10083,10083,14,10085,10087,14,10145,10145,14,10175,10175,14,11013,11015,14,11088,11088,14,11503,11505,5,11744,11775,5,12334,12335,5,12349,12349,14,12951,12951,14,42607,42607,5,42612,42621,5,42736,42737,5,43014,43014,5,43043,43044,7,43047,43047,7,43136,43137,7,43204,43205,5,43263,43263,5,43335,43345,5,43360,43388,8,43395,43395,7,43444,43445,7,43450,43451,7,43454,43456,7,43561,43566,5,43569,43570,5,43573,43574,5,43596,43596,5,43644,43644,5,43698,43700,5,43710,43711,5,43755,43755,7,43758,43759,7,43766,43766,5,44005,44005,5,44008,44008,5,44012,44012,7,44032,44032,11,44060,44060,11,44088,44088,11,44116,44116,11,44144,44144,11,44172,44172,11,44200,44200,11,44228,44228,11,44256,44256,11,44284,44284,11,44312,44312,11,44340,44340,11,44368,44368,11,44396,44396,11,44424,44424,11,44452,44452,11,44480,44480,11,44508,44508,11,44536,44536,11,44564,44564,11,44592,44592,11,44620,44620,11,44648,44648,11,44676,44676,11,44704,44704,11,44732,44732,11,44760,44760,11,44788,44788,11,44816,44816,11,44844,44844,11,44872,44872,11,44900,44900,11,44928,44928,11,44956,44956,11,44984,44984,11,45012,45012,11,45040,45040,11,45068,45068,11,45096,45096,11,45124,45124,11,45152,45152,11,45180,45180,11,45208,45208,11,45236,45236,11,45264,45264,11,45292,45292,11,45320,45320,11,45348,45348,11,45376,45376,11,45404,45404,11,45432,45432,11,45460,45460,11,45488,45488,11,45516,45516,11,45544,45544,11,45572,45572,11,45600,45600,11,45628,45628,11,45656,45656,11,45684,45684,11,45712,45712,11,45740,45740,11,45768,45768,11,45796,45796,11,45824,45824,11,45852,45852,11,45880,45880,11,45908,45908,11,45936,45936,11,45964,45964,11,45992,45992,11,46020,46020,11,46048,46048,11,46076,46076,11,46104,46104,11,46132,46132,11,46160,46160,11,46188,46188,11,46216,46216,11,46244,46244,11,46272,46272,11,46300,46300,11,46328,46328,11,46356,46356,11,46384,46384,11,46412,46412,11,46440,46440,11,46468,46468,11,46496,46496,11,46524,46524,11,46552,46552,11,46580,46580,11,46608,46608,11,46636,46636,11,46664,46664,11,46692,46692,11,46720,46720,11,46748,46748,11,46776,46776,11,46804,46804,11,46832,46832,11,46860,46860,11,46888,46888,11,46916,46916,11,46944,46944,11,46972,46972,11,47000,47000,11,47028,47028,11,47056,47056,11,47084,47084,11,47112,47112,11,47140,47140,11,47168,47168,11,47196,47196,11,47224,47224,11,47252,47252,11,47280,47280,11,47308,47308,11,47336,47336,11,47364,47364,11,47392,47392,11,47420,47420,11,47448,47448,11,47476,47476,11,47504,47504,11,47532,47532,11,47560,47560,11,47588,47588,11,47616,47616,11,47644,47644,11,47672,47672,11,47700,47700,11,47728,47728,11,47756,47756,11,47784,47784,11,47812,47812,11,47840,47840,11,47868,47868,11,47896,47896,11,47924,47924,11,47952,47952,11,47980,47980,11,48008,48008,11,48036,48036,11,48064,48064,11,48092,48092,11,48120,48120,11,48148,48148,11,48176,48176,11,48204,48204,11,48232,48232,11,48260,48260,11,48288,48288,11,48316,48316,11,48344,48344,11,48372,48372,11,48400,48400,11,48428,48428,11,48456,48456,11,48484,48484,11,48512,48512,11,48540,48540,11,48568,48568,11,48596,48596,11,48624,48624,11,48652,48652,11,48680,48680,11,48708,48708,11,48736,48736,11,48764,48764,11,48792,48792,11,48820,48820,11,48848,48848,11,48876,48876,11,48904,48904,11,48932,48932,11,48960,48960,11,48988,48988,11,49016,49016,11,49044,49044,11,49072,49072,11,49100,49100,11,49128,49128,11,49156,49156,11,49184,49184,11,49212,49212,11,49240,49240,11,49268,49268,11,49296,49296,11,49324,49324,11,49352,49352,11,49380,49380,11,49408,49408,11,49436,49436,11,49464,49464,11,49492,49492,11,49520,49520,11,49548,49548,11,49576,49576,11,49604,49604,11,49632,49632,11,49660,49660,11,49688,49688,11,49716,49716,11,49744,49744,11,49772,49772,11,49800,49800,11,49828,49828,11,49856,49856,11,49884,49884,11,49912,49912,11,49940,49940,11,49968,49968,11,49996,49996,11,50024,50024,11,50052,50052,11,50080,50080,11,50108,50108,11,50136,50136,11,50164,50164,11,50192,50192,11,50220,50220,11,50248,50248,11,50276,50276,11,50304,50304,11,50332,50332,11,50360,50360,11,50388,50388,11,50416,50416,11,50444,50444,11,50472,50472,11,50500,50500,11,50528,50528,11,50556,50556,11,50584,50584,11,50612,50612,11,50640,50640,11,50668,50668,11,50696,50696,11,50724,50724,11,50752,50752,11,50780,50780,11,50808,50808,11,50836,50836,11,50864,50864,11,50892,50892,11,50920,50920,11,50948,50948,11,50976,50976,11,51004,51004,11,51032,51032,11,51060,51060,11,51088,51088,11,51116,51116,11,51144,51144,11,51172,51172,11,51200,51200,11,51228,51228,11,51256,51256,11,51284,51284,11,51312,51312,11,51340,51340,11,51368,51368,11,51396,51396,11,51424,51424,11,51452,51452,11,51480,51480,11,51508,51508,11,51536,51536,11,51564,51564,11,51592,51592,11,51620,51620,11,51648,51648,11,51676,51676,11,51704,51704,11,51732,51732,11,51760,51760,11,51788,51788,11,51816,51816,11,51844,51844,11,51872,51872,11,51900,51900,11,51928,51928,11,51956,51956,11,51984,51984,11,52012,52012,11,52040,52040,11,52068,52068,11,52096,52096,11,52124,52124,11,52152,52152,11,52180,52180,11,52208,52208,11,52236,52236,11,52264,52264,11,52292,52292,11,52320,52320,11,52348,52348,11,52376,52376,11,52404,52404,11,52432,52432,11,52460,52460,11,52488,52488,11,52516,52516,11,52544,52544,11,52572,52572,11,52600,52600,11,52628,52628,11,52656,52656,11,52684,52684,11,52712,52712,11,52740,52740,11,52768,52768,11,52796,52796,11,52824,52824,11,52852,52852,11,52880,52880,11,52908,52908,11,52936,52936,11,52964,52964,11,52992,52992,11,53020,53020,11,53048,53048,11,53076,53076,11,53104,53104,11,53132,53132,11,53160,53160,11,53188,53188,11,53216,53216,11,53244,53244,11,53272,53272,11,53300,53300,11,53328,53328,11,53356,53356,11,53384,53384,11,53412,53412,11,53440,53440,11,53468,53468,11,53496,53496,11,53524,53524,11,53552,53552,11,53580,53580,11,53608,53608,11,53636,53636,11,53664,53664,11,53692,53692,11,53720,53720,11,53748,53748,11,53776,53776,11,53804,53804,11,53832,53832,11,53860,53860,11,53888,53888,11,53916,53916,11,53944,53944,11,53972,53972,11,54000,54000,11,54028,54028,11,54056,54056,11,54084,54084,11,54112,54112,11,54140,54140,11,54168,54168,11,54196,54196,11,54224,54224,11,54252,54252,11,54280,54280,11,54308,54308,11,54336,54336,11,54364,54364,11,54392,54392,11,54420,54420,11,54448,54448,11,54476,54476,11,54504,54504,11,54532,54532,11,54560,54560,11,54588,54588,11,54616,54616,11,54644,54644,11,54672,54672,11,54700,54700,11,54728,54728,11,54756,54756,11,54784,54784,11,54812,54812,11,54840,54840,11,54868,54868,11,54896,54896,11,54924,54924,11,54952,54952,11,54980,54980,11,55008,55008,11,55036,55036,11,55064,55064,11,55092,55092,11,55120,55120,11,55148,55148,11,55176,55176,11,55216,55238,9,64286,64286,5,65056,65071,5,65438,65439,5,65529,65531,4,66272,66272,5,68097,68099,5,68108,68111,5,68159,68159,5,68900,68903,5,69446,69456,5,69632,69632,7,69634,69634,7,69744,69744,5,69759,69761,5,69808,69810,7,69815,69816,7,69821,69821,1,69837,69837,1,69927,69931,5,69933,69940,5,70003,70003,5,70018,70018,7,70070,70078,5,70082,70083,1,70094,70094,7,70188,70190,7,70194,70195,7,70197,70197,7,70206,70206,5,70368,70370,7,70400,70401,5,70459,70460,5,70463,70463,7,70465,70468,7,70475,70477,7,70498,70499,7,70512,70516,5,70712,70719,5,70722,70724,5,70726,70726,5,70832,70832,5,70835,70840,5,70842,70842,5,70845,70845,5,70847,70848,5,70850,70851,5,71088,71089,7,71096,71099,7,71102,71102,7,71132,71133,5,71219,71226,5,71229,71229,5,71231,71232,5,71340,71340,7,71342,71343,7,71350,71350,7,71453,71455,5,71462,71462,7,71724,71726,7,71736,71736,7,71984,71984,5,71991,71992,7,71997,71997,7,71999,71999,1,72001,72001,1,72003,72003,5,72148,72151,5,72156,72159,7,72164,72164,7,72243,72248,5,72250,72250,1,72263,72263,5,72279,72280,7,72324,72329,1,72343,72343,7,72751,72751,7,72760,72765,5,72767,72767,5,72873,72873,7,72881,72881,7,72884,72884,7,73009,73014,5,73020,73021,5,73030,73030,1,73098,73102,7,73107,73108,7,73110,73110,7,73459,73460,5,78896,78904,4,92976,92982,5,94033,94087,7,94180,94180,5,113821,113822,5,118528,118573,5,119141,119141,5,119143,119145,5,119150,119154,5,119163,119170,5,119210,119213,5,121344,121398,5,121461,121461,5,121499,121503,5,122880,122886,5,122907,122913,5,122918,122922,5,123566,123566,5,125136,125142,5,126976,126979,14,126981,127182,14,127184,127231,14,127279,127279,14,127344,127345,14,127374,127374,14,127405,127461,14,127489,127490,14,127514,127514,14,127538,127546,14,127561,127567,14,127570,127743,14,127757,127758,14,127760,127760,14,127762,127762,14,127766,127768,14,127770,127770,14,127772,127772,14,127775,127776,14,127778,127779,14,127789,127791,14,127794,127795,14,127798,127798,14,127819,127819,14,127824,127824,14,127868,127868,14,127870,127871,14,127892,127893,14,127896,127896,14,127900,127901,14,127904,127940,14,127942,127942,14,127944,127944,14,127946,127946,14,127951,127955,14,127968,127971,14,127973,127984,14,127987,127987,14,127989,127989,14,127991,127991,14,127995,127999,5,128008,128008,14,128012,128014,14,128017,128018,14,128020,128020,14,128022,128022,14,128042,128042,14,128063,128063,14,128065,128065,14,128101,128101,14,128108,128109,14,128173,128173,14,128182,128183,14,128236,128237,14,128239,128239,14,128245,128245,14,128248,128248,14,128253,128253,14,128255,128258,14,128260,128263,14,128265,128265,14,128277,128277,14,128300,128301,14,128326,128328,14,128331,128334,14,128336,128347,14,128360,128366,14,128369,128370,14,128378,128378,14,128391,128391,14,128394,128397,14,128400,128400,14,128405,128406,14,128420,128420,14,128422,128423,14,128425,128432,14,128435,128443,14,128445,128449,14,128453,128464,14,128468,128475,14,128479,128480,14,128482,128482,14,128484,128487,14,128489,128494,14,128496,128498,14,128500,128505,14,128507,128511,14,128513,128518,14,128521,128525,14,128527,128527,14,128529,128529,14,128533,128533,14,128535,128535,14,128537,128537,14]")}function Ge(q,oe){if(q===0)return 0;const be=He(q,oe);if(be!==void 0)return be;const Ce=new se(oe,q);return Ce.prevCodePoint(),Ce.offset}t.getLeftDeleteOffset=Ge;function He(q,oe){const be=new se(oe,q);let Ce=be.prevCodePoint();for(;Ue(Ce)||Ce===65039||Ce===8419;){if(be.offset===0)return;Ce=be.prevCodePoint()}if(!N(Ce))return;let Te=be.offset;return Te>0&&be.prevCodePoint()===8205&&(Te=be.offset),Te}function Ue(q){return 127995<=q&&q<=127999}var Qe;(function(q){q[q.zwj=8205]="zwj",q[q.emojiVariantSelector=65039]="emojiVariantSelector",q[q.enclosingKeyCap=8419]="enclosingKeyCap"})(Qe||(Qe={})),t.noBreakWhitespace="\xA0";class je{constructor(oe){this.confusableDictionary=oe}static getInstance(oe){return je.cache.get(Array.from(oe))}static getLocales(){return je._locales.getValue()}isAmbiguous(oe){return this.confusableDictionary.has(oe)}getPrimaryConfusable(oe){return this.confusableDictionary.get(oe)}getConfusableCodePoints(){return new Set(this.confusableDictionary.keys())}}t.AmbiguousCharacters=je,M=je,je.ambiguousCharacterData=new i.Lazy(()=>JSON.parse('{"_common":[8232,32,8233,32,5760,32,8192,32,8193,32,8194,32,8195,32,8196,32,8197,32,8198,32,8200,32,8201,32,8202,32,8287,32,8199,32,8239,32,2042,95,65101,95,65102,95,65103,95,8208,45,8209,45,8210,45,65112,45,1748,45,8259,45,727,45,8722,45,10134,45,11450,45,1549,44,1643,44,8218,44,184,44,42233,44,894,59,2307,58,2691,58,1417,58,1795,58,1796,58,5868,58,65072,58,6147,58,6153,58,8282,58,1475,58,760,58,42889,58,8758,58,720,58,42237,58,451,33,11601,33,660,63,577,63,2429,63,5038,63,42731,63,119149,46,8228,46,1793,46,1794,46,42510,46,68176,46,1632,46,1776,46,42232,46,1373,96,65287,96,8219,96,8242,96,1370,96,1523,96,8175,96,65344,96,900,96,8189,96,8125,96,8127,96,8190,96,697,96,884,96,712,96,714,96,715,96,756,96,699,96,701,96,700,96,702,96,42892,96,1497,96,2036,96,2037,96,5194,96,5836,96,94033,96,94034,96,65339,91,10088,40,10098,40,12308,40,64830,40,65341,93,10089,41,10099,41,12309,41,64831,41,10100,123,119060,123,10101,125,65342,94,8270,42,1645,42,8727,42,66335,42,5941,47,8257,47,8725,47,8260,47,9585,47,10187,47,10744,47,119354,47,12755,47,12339,47,11462,47,20031,47,12035,47,65340,92,65128,92,8726,92,10189,92,10741,92,10745,92,119311,92,119355,92,12756,92,20022,92,12034,92,42872,38,708,94,710,94,5869,43,10133,43,66203,43,8249,60,10094,60,706,60,119350,60,5176,60,5810,60,5120,61,11840,61,12448,61,42239,61,8250,62,10095,62,707,62,119351,62,5171,62,94015,62,8275,126,732,126,8128,126,8764,126,65372,124,65293,45,120784,50,120794,50,120804,50,120814,50,120824,50,130034,50,42842,50,423,50,1000,50,42564,50,5311,50,42735,50,119302,51,120785,51,120795,51,120805,51,120815,51,120825,51,130035,51,42923,51,540,51,439,51,42858,51,11468,51,1248,51,94011,51,71882,51,120786,52,120796,52,120806,52,120816,52,120826,52,130036,52,5070,52,71855,52,120787,53,120797,53,120807,53,120817,53,120827,53,130037,53,444,53,71867,53,120788,54,120798,54,120808,54,120818,54,120828,54,130038,54,11474,54,5102,54,71893,54,119314,55,120789,55,120799,55,120809,55,120819,55,120829,55,130039,55,66770,55,71878,55,2819,56,2538,56,2666,56,125131,56,120790,56,120800,56,120810,56,120820,56,120830,56,130040,56,547,56,546,56,66330,56,2663,57,2920,57,2541,57,3437,57,120791,57,120801,57,120811,57,120821,57,120831,57,130041,57,42862,57,11466,57,71884,57,71852,57,71894,57,9082,97,65345,97,119834,97,119886,97,119938,97,119990,97,120042,97,120094,97,120146,97,120198,97,120250,97,120302,97,120354,97,120406,97,120458,97,593,97,945,97,120514,97,120572,97,120630,97,120688,97,120746,97,65313,65,119808,65,119860,65,119912,65,119964,65,120016,65,120068,65,120120,65,120172,65,120224,65,120276,65,120328,65,120380,65,120432,65,913,65,120488,65,120546,65,120604,65,120662,65,120720,65,5034,65,5573,65,42222,65,94016,65,66208,65,119835,98,119887,98,119939,98,119991,98,120043,98,120095,98,120147,98,120199,98,120251,98,120303,98,120355,98,120407,98,120459,98,388,98,5071,98,5234,98,5551,98,65314,66,8492,66,119809,66,119861,66,119913,66,120017,66,120069,66,120121,66,120173,66,120225,66,120277,66,120329,66,120381,66,120433,66,42932,66,914,66,120489,66,120547,66,120605,66,120663,66,120721,66,5108,66,5623,66,42192,66,66178,66,66209,66,66305,66,65347,99,8573,99,119836,99,119888,99,119940,99,119992,99,120044,99,120096,99,120148,99,120200,99,120252,99,120304,99,120356,99,120408,99,120460,99,7428,99,1010,99,11429,99,43951,99,66621,99,128844,67,71922,67,71913,67,65315,67,8557,67,8450,67,8493,67,119810,67,119862,67,119914,67,119966,67,120018,67,120174,67,120226,67,120278,67,120330,67,120382,67,120434,67,1017,67,11428,67,5087,67,42202,67,66210,67,66306,67,66581,67,66844,67,8574,100,8518,100,119837,100,119889,100,119941,100,119993,100,120045,100,120097,100,120149,100,120201,100,120253,100,120305,100,120357,100,120409,100,120461,100,1281,100,5095,100,5231,100,42194,100,8558,68,8517,68,119811,68,119863,68,119915,68,119967,68,120019,68,120071,68,120123,68,120175,68,120227,68,120279,68,120331,68,120383,68,120435,68,5024,68,5598,68,5610,68,42195,68,8494,101,65349,101,8495,101,8519,101,119838,101,119890,101,119942,101,120046,101,120098,101,120150,101,120202,101,120254,101,120306,101,120358,101,120410,101,120462,101,43826,101,1213,101,8959,69,65317,69,8496,69,119812,69,119864,69,119916,69,120020,69,120072,69,120124,69,120176,69,120228,69,120280,69,120332,69,120384,69,120436,69,917,69,120492,69,120550,69,120608,69,120666,69,120724,69,11577,69,5036,69,42224,69,71846,69,71854,69,66182,69,119839,102,119891,102,119943,102,119995,102,120047,102,120099,102,120151,102,120203,102,120255,102,120307,102,120359,102,120411,102,120463,102,43829,102,42905,102,383,102,7837,102,1412,102,119315,70,8497,70,119813,70,119865,70,119917,70,120021,70,120073,70,120125,70,120177,70,120229,70,120281,70,120333,70,120385,70,120437,70,42904,70,988,70,120778,70,5556,70,42205,70,71874,70,71842,70,66183,70,66213,70,66853,70,65351,103,8458,103,119840,103,119892,103,119944,103,120048,103,120100,103,120152,103,120204,103,120256,103,120308,103,120360,103,120412,103,120464,103,609,103,7555,103,397,103,1409,103,119814,71,119866,71,119918,71,119970,71,120022,71,120074,71,120126,71,120178,71,120230,71,120282,71,120334,71,120386,71,120438,71,1292,71,5056,71,5107,71,42198,71,65352,104,8462,104,119841,104,119945,104,119997,104,120049,104,120101,104,120153,104,120205,104,120257,104,120309,104,120361,104,120413,104,120465,104,1211,104,1392,104,5058,104,65320,72,8459,72,8460,72,8461,72,119815,72,119867,72,119919,72,120023,72,120179,72,120231,72,120283,72,120335,72,120387,72,120439,72,919,72,120494,72,120552,72,120610,72,120668,72,120726,72,11406,72,5051,72,5500,72,42215,72,66255,72,731,105,9075,105,65353,105,8560,105,8505,105,8520,105,119842,105,119894,105,119946,105,119998,105,120050,105,120102,105,120154,105,120206,105,120258,105,120310,105,120362,105,120414,105,120466,105,120484,105,618,105,617,105,953,105,8126,105,890,105,120522,105,120580,105,120638,105,120696,105,120754,105,1110,105,42567,105,1231,105,43893,105,5029,105,71875,105,65354,106,8521,106,119843,106,119895,106,119947,106,119999,106,120051,106,120103,106,120155,106,120207,106,120259,106,120311,106,120363,106,120415,106,120467,106,1011,106,1112,106,65322,74,119817,74,119869,74,119921,74,119973,74,120025,74,120077,74,120129,74,120181,74,120233,74,120285,74,120337,74,120389,74,120441,74,42930,74,895,74,1032,74,5035,74,5261,74,42201,74,119844,107,119896,107,119948,107,120000,107,120052,107,120104,107,120156,107,120208,107,120260,107,120312,107,120364,107,120416,107,120468,107,8490,75,65323,75,119818,75,119870,75,119922,75,119974,75,120026,75,120078,75,120130,75,120182,75,120234,75,120286,75,120338,75,120390,75,120442,75,922,75,120497,75,120555,75,120613,75,120671,75,120729,75,11412,75,5094,75,5845,75,42199,75,66840,75,1472,108,8739,73,9213,73,65512,73,1633,108,1777,73,66336,108,125127,108,120783,73,120793,73,120803,73,120813,73,120823,73,130033,73,65321,73,8544,73,8464,73,8465,73,119816,73,119868,73,119920,73,120024,73,120128,73,120180,73,120232,73,120284,73,120336,73,120388,73,120440,73,65356,108,8572,73,8467,108,119845,108,119897,108,119949,108,120001,108,120053,108,120105,73,120157,73,120209,73,120261,73,120313,73,120365,73,120417,73,120469,73,448,73,120496,73,120554,73,120612,73,120670,73,120728,73,11410,73,1030,73,1216,73,1493,108,1503,108,1575,108,126464,108,126592,108,65166,108,65165,108,1994,108,11599,73,5825,73,42226,73,93992,73,66186,124,66313,124,119338,76,8556,76,8466,76,119819,76,119871,76,119923,76,120027,76,120079,76,120131,76,120183,76,120235,76,120287,76,120339,76,120391,76,120443,76,11472,76,5086,76,5290,76,42209,76,93974,76,71843,76,71858,76,66587,76,66854,76,65325,77,8559,77,8499,77,119820,77,119872,77,119924,77,120028,77,120080,77,120132,77,120184,77,120236,77,120288,77,120340,77,120392,77,120444,77,924,77,120499,77,120557,77,120615,77,120673,77,120731,77,1018,77,11416,77,5047,77,5616,77,5846,77,42207,77,66224,77,66321,77,119847,110,119899,110,119951,110,120003,110,120055,110,120107,110,120159,110,120211,110,120263,110,120315,110,120367,110,120419,110,120471,110,1400,110,1404,110,65326,78,8469,78,119821,78,119873,78,119925,78,119977,78,120029,78,120081,78,120185,78,120237,78,120289,78,120341,78,120393,78,120445,78,925,78,120500,78,120558,78,120616,78,120674,78,120732,78,11418,78,42208,78,66835,78,3074,111,3202,111,3330,111,3458,111,2406,111,2662,111,2790,111,3046,111,3174,111,3302,111,3430,111,3664,111,3792,111,4160,111,1637,111,1781,111,65359,111,8500,111,119848,111,119900,111,119952,111,120056,111,120108,111,120160,111,120212,111,120264,111,120316,111,120368,111,120420,111,120472,111,7439,111,7441,111,43837,111,959,111,120528,111,120586,111,120644,111,120702,111,120760,111,963,111,120532,111,120590,111,120648,111,120706,111,120764,111,11423,111,4351,111,1413,111,1505,111,1607,111,126500,111,126564,111,126596,111,65259,111,65260,111,65258,111,65257,111,1726,111,64428,111,64429,111,64427,111,64426,111,1729,111,64424,111,64425,111,64423,111,64422,111,1749,111,3360,111,4125,111,66794,111,71880,111,71895,111,66604,111,1984,79,2534,79,2918,79,12295,79,70864,79,71904,79,120782,79,120792,79,120802,79,120812,79,120822,79,130032,79,65327,79,119822,79,119874,79,119926,79,119978,79,120030,79,120082,79,120134,79,120186,79,120238,79,120290,79,120342,79,120394,79,120446,79,927,79,120502,79,120560,79,120618,79,120676,79,120734,79,11422,79,1365,79,11604,79,4816,79,2848,79,66754,79,42227,79,71861,79,66194,79,66219,79,66564,79,66838,79,9076,112,65360,112,119849,112,119901,112,119953,112,120005,112,120057,112,120109,112,120161,112,120213,112,120265,112,120317,112,120369,112,120421,112,120473,112,961,112,120530,112,120544,112,120588,112,120602,112,120646,112,120660,112,120704,112,120718,112,120762,112,120776,112,11427,112,65328,80,8473,80,119823,80,119875,80,119927,80,119979,80,120031,80,120083,80,120187,80,120239,80,120291,80,120343,80,120395,80,120447,80,929,80,120504,80,120562,80,120620,80,120678,80,120736,80,11426,80,5090,80,5229,80,42193,80,66197,80,119850,113,119902,113,119954,113,120006,113,120058,113,120110,113,120162,113,120214,113,120266,113,120318,113,120370,113,120422,113,120474,113,1307,113,1379,113,1382,113,8474,81,119824,81,119876,81,119928,81,119980,81,120032,81,120084,81,120188,81,120240,81,120292,81,120344,81,120396,81,120448,81,11605,81,119851,114,119903,114,119955,114,120007,114,120059,114,120111,114,120163,114,120215,114,120267,114,120319,114,120371,114,120423,114,120475,114,43847,114,43848,114,7462,114,11397,114,43905,114,119318,82,8475,82,8476,82,8477,82,119825,82,119877,82,119929,82,120033,82,120189,82,120241,82,120293,82,120345,82,120397,82,120449,82,422,82,5025,82,5074,82,66740,82,5511,82,42211,82,94005,82,65363,115,119852,115,119904,115,119956,115,120008,115,120060,115,120112,115,120164,115,120216,115,120268,115,120320,115,120372,115,120424,115,120476,115,42801,115,445,115,1109,115,43946,115,71873,115,66632,115,65331,83,119826,83,119878,83,119930,83,119982,83,120034,83,120086,83,120138,83,120190,83,120242,83,120294,83,120346,83,120398,83,120450,83,1029,83,1359,83,5077,83,5082,83,42210,83,94010,83,66198,83,66592,83,119853,116,119905,116,119957,116,120009,116,120061,116,120113,116,120165,116,120217,116,120269,116,120321,116,120373,116,120425,116,120477,116,8868,84,10201,84,128872,84,65332,84,119827,84,119879,84,119931,84,119983,84,120035,84,120087,84,120139,84,120191,84,120243,84,120295,84,120347,84,120399,84,120451,84,932,84,120507,84,120565,84,120623,84,120681,84,120739,84,11430,84,5026,84,42196,84,93962,84,71868,84,66199,84,66225,84,66325,84,119854,117,119906,117,119958,117,120010,117,120062,117,120114,117,120166,117,120218,117,120270,117,120322,117,120374,117,120426,117,120478,117,42911,117,7452,117,43854,117,43858,117,651,117,965,117,120534,117,120592,117,120650,117,120708,117,120766,117,1405,117,66806,117,71896,117,8746,85,8899,85,119828,85,119880,85,119932,85,119984,85,120036,85,120088,85,120140,85,120192,85,120244,85,120296,85,120348,85,120400,85,120452,85,1357,85,4608,85,66766,85,5196,85,42228,85,94018,85,71864,85,8744,118,8897,118,65366,118,8564,118,119855,118,119907,118,119959,118,120011,118,120063,118,120115,118,120167,118,120219,118,120271,118,120323,118,120375,118,120427,118,120479,118,7456,118,957,118,120526,118,120584,118,120642,118,120700,118,120758,118,1141,118,1496,118,71430,118,43945,118,71872,118,119309,86,1639,86,1783,86,8548,86,119829,86,119881,86,119933,86,119985,86,120037,86,120089,86,120141,86,120193,86,120245,86,120297,86,120349,86,120401,86,120453,86,1140,86,11576,86,5081,86,5167,86,42719,86,42214,86,93960,86,71840,86,66845,86,623,119,119856,119,119908,119,119960,119,120012,119,120064,119,120116,119,120168,119,120220,119,120272,119,120324,119,120376,119,120428,119,120480,119,7457,119,1121,119,1309,119,1377,119,71434,119,71438,119,71439,119,43907,119,71919,87,71910,87,119830,87,119882,87,119934,87,119986,87,120038,87,120090,87,120142,87,120194,87,120246,87,120298,87,120350,87,120402,87,120454,87,1308,87,5043,87,5076,87,42218,87,5742,120,10539,120,10540,120,10799,120,65368,120,8569,120,119857,120,119909,120,119961,120,120013,120,120065,120,120117,120,120169,120,120221,120,120273,120,120325,120,120377,120,120429,120,120481,120,5441,120,5501,120,5741,88,9587,88,66338,88,71916,88,65336,88,8553,88,119831,88,119883,88,119935,88,119987,88,120039,88,120091,88,120143,88,120195,88,120247,88,120299,88,120351,88,120403,88,120455,88,42931,88,935,88,120510,88,120568,88,120626,88,120684,88,120742,88,11436,88,11613,88,5815,88,42219,88,66192,88,66228,88,66327,88,66855,88,611,121,7564,121,65369,121,119858,121,119910,121,119962,121,120014,121,120066,121,120118,121,120170,121,120222,121,120274,121,120326,121,120378,121,120430,121,120482,121,655,121,7935,121,43866,121,947,121,8509,121,120516,121,120574,121,120632,121,120690,121,120748,121,1199,121,4327,121,71900,121,65337,89,119832,89,119884,89,119936,89,119988,89,120040,89,120092,89,120144,89,120196,89,120248,89,120300,89,120352,89,120404,89,120456,89,933,89,978,89,120508,89,120566,89,120624,89,120682,89,120740,89,11432,89,1198,89,5033,89,5053,89,42220,89,94019,89,71844,89,66226,89,119859,122,119911,122,119963,122,120015,122,120067,122,120119,122,120171,122,120223,122,120275,122,120327,122,120379,122,120431,122,120483,122,7458,122,43923,122,71876,122,66293,90,71909,90,65338,90,8484,90,8488,90,119833,90,119885,90,119937,90,119989,90,120041,90,120197,90,120249,90,120301,90,120353,90,120405,90,120457,90,918,90,120493,90,120551,90,120609,90,120667,90,120725,90,5059,90,42204,90,71849,90,65282,34,65284,36,65285,37,65286,38,65290,42,65291,43,65294,46,65295,47,65296,48,65297,49,65298,50,65299,51,65300,52,65301,53,65302,54,65303,55,65304,56,65305,57,65308,60,65309,61,65310,62,65312,64,65316,68,65318,70,65319,71,65324,76,65329,81,65330,82,65333,85,65334,86,65335,87,65343,95,65346,98,65348,100,65350,102,65355,107,65357,109,65358,110,65361,113,65362,114,65364,116,65365,117,65367,119,65370,122,65371,123,65373,125],"_default":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"cs":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"de":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"es":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"fr":[65374,126,65306,58,65281,33,8216,96,8245,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"it":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ja":[8211,45,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65292,44,65307,59],"ko":[8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pl":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"pt-BR":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"qps-ploc":[160,32,8211,45,65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"ru":[65374,126,65306,58,65281,33,8216,96,8217,96,8245,96,180,96,12494,47,305,105,921,73,1009,112,215,120,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"tr":[160,32,8211,45,65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65288,40,65289,41,65292,44,65307,59,65311,63],"zh-hans":[65374,126,65306,58,65281,33,8245,96,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65288,40,65289,41],"zh-hant":[8211,45,65374,126,180,96,12494,47,1047,51,1073,54,1072,97,1040,65,1068,98,1042,66,1089,99,1057,67,1077,101,1045,69,1053,72,305,105,1050,75,921,73,1052,77,1086,111,1054,79,1009,112,1088,112,1056,80,1075,114,1058,84,215,120,1093,120,1061,88,1091,121,1059,89,65283,35,65307,59]}')),je.cache=new E.LRUCachedFunction(q=>{function oe(qe){const Le=new Map;for(let le=0;le<qe.length;le+=2)Le.set(qe[le],qe[le+1]);return Le}function be(qe,Le){const le=new Map(qe);for(const[Se,Ne]of Le)le.set(Se,Ne);return le}function Ce(qe,Le){if(!qe)return Le;const le=new Map;for(const[Se,Ne]of qe)Le.has(Se)&&le.set(Se,Ne);return le}const Te=M.ambiguousCharacterData.getValue();let Re=q.filter(qe=>!qe.startsWith("_")&&qe in Te);Re.length===0&&(Re=["_default"]);let $e;for(const qe of Re){const Le=oe(Te[qe]);$e=Ce($e,Le)}const tt=oe(Te._common),Xe=be(tt,$e);return new je(Xe)}),je._locales=new i.Lazy(()=>Object.keys(je.ambiguousCharacterData.getValue()).filter(q=>!q.startsWith("_")));class Oe{static getRawData(){return JSON.parse("[9,10,11,12,13,32,127,160,173,847,1564,4447,4448,6068,6069,6155,6156,6157,6158,7355,7356,8192,8193,8194,8195,8196,8197,8198,8199,8200,8201,8202,8203,8204,8205,8206,8207,8234,8235,8236,8237,8238,8239,8287,8288,8289,8290,8291,8292,8293,8294,8295,8296,8297,8298,8299,8300,8301,8302,8303,10240,12288,12644,65024,65025,65026,65027,65028,65029,65030,65031,65032,65033,65034,65035,65036,65037,65038,65039,65279,65440,65520,65521,65522,65523,65524,65525,65526,65527,65528,65532,78844,119155,119156,119157,119158,119159,119160,119161,119162,917504,917505,917506,917507,917508,917509,917510,917511,917512,917513,917514,917515,917516,917517,917518,917519,917520,917521,917522,917523,917524,917525,917526,917527,917528,917529,917530,917531,917532,917533,917534,917535,917536,917537,917538,917539,917540,917541,917542,917543,917544,917545,917546,917547,917548,917549,917550,917551,917552,917553,917554,917555,917556,917557,917558,917559,917560,917561,917562,917563,917564,917565,917566,917567,917568,917569,917570,917571,917572,917573,917574,917575,917576,917577,917578,917579,917580,917581,917582,917583,917584,917585,917586,917587,917588,917589,917590,917591,917592,917593,917594,917595,917596,917597,917598,917599,917600,917601,917602,917603,917604,917605,917606,917607,917608,917609,917610,917611,917612,917613,917614,917615,917616,917617,917618,917619,917620,917621,917622,917623,917624,917625,917626,917627,917628,917629,917630,917631,917760,917761,917762,917763,917764,917765,917766,917767,917768,917769,917770,917771,917772,917773,917774,917775,917776,917777,917778,917779,917780,917781,917782,917783,917784,917785,917786,917787,917788,917789,917790,917791,917792,917793,917794,917795,917796,917797,917798,917799,917800,917801,917802,917803,917804,917805,917806,917807,917808,917809,917810,917811,917812,917813,917814,917815,917816,917817,917818,917819,917820,917821,917822,917823,917824,917825,917826,917827,917828,917829,917830,917831,917832,917833,917834,917835,917836,917837,917838,917839,917840,917841,917842,917843,917844,917845,917846,917847,917848,917849,917850,917851,917852,917853,917854,917855,917856,917857,917858,917859,917860,917861,917862,917863,917864,917865,917866,917867,917868,917869,917870,917871,917872,917873,917874,917875,917876,917877,917878,917879,917880,917881,917882,917883,917884,917885,917886,917887,917888,917889,917890,917891,917892,917893,917894,917895,917896,917897,917898,917899,917900,917901,917902,917903,917904,917905,917906,917907,917908,917909,917910,917911,917912,917913,917914,917915,917916,917917,917918,917919,917920,917921,917922,917923,917924,917925,917926,917927,917928,917929,917930,917931,917932,917933,917934,917935,917936,917937,917938,917939,917940,917941,917942,917943,917944,917945,917946,917947,917948,917949,917950,917951,917952,917953,917954,917955,917956,917957,917958,917959,917960,917961,917962,917963,917964,917965,917966,917967,917968,917969,917970,917971,917972,917973,917974,917975,917976,917977,917978,917979,917980,917981,917982,917983,917984,917985,917986,917987,917988,917989,917990,917991,917992,917993,917994,917995,917996,917997,917998,917999]")}static getData(){return this._data||(this._data=new Set(Oe.getRawData())),this._data}static isInvisibleCharacter(oe){return Oe.getData().has(oe)}static get codePoints(){return Oe.getData()}}t.InvisibleCharacters=Oe,Oe._data=void 0}),define(me[109],pe([1,0,21,5,10,6]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.randomPath=t.parseLineAndColumnAware=t.indexOfPath=t.getDriveLetter=t.hasDriveLetter=t.isRootOrDriveLetter=t.sanitizeFilePath=t.isWindowsDriveLetter=t.isEqualOrParent=t.isEqual=t.isValidBasename=t.isUNC=t.getRoot=t.toPosixPath=t.toSlashes=t.isPathSeparator=void 0;function _(n){return n===47||n===92}t.isPathSeparator=_;function w(n){return n.replace(/[\\/]/g,E.posix.sep)}t.toSlashes=w;function g(n){return n.indexOf("/")===-1&&(n=w(n)),/^[a-zA-Z]:(\/|$)/.test(n)&&(n="/"+n),n}t.toPosixPath=g;function d(n,a=E.posix.sep){if(!n)return"";const u=n.length,m=n.charCodeAt(0);if(_(m)){if(_(n.charCodeAt(1))&&!_(n.charCodeAt(2))){let V=3;const ne=V;for(;V<u&&!_(n.charCodeAt(V));V++);if(ne!==V&&!_(n.charCodeAt(V+1))){for(V+=1;V<u;V++)if(_(n.charCodeAt(V)))return n.slice(0,V+1).replace(/[\\/]/g,a)}}return a}else if(D(m)&&n.charCodeAt(1)===58)return _(n.charCodeAt(2))?n.slice(0,2)+a:n.slice(0,2);let W=n.indexOf("://");if(W!==-1){for(W+=3;W<u;W++)if(_(n.charCodeAt(W)))return n.slice(0,W+1)}return""}t.getRoot=d;function f(n){if(!i.isWindows||!n||n.length<5)return!1;let a=n.charCodeAt(0);if(a!==92||(a=n.charCodeAt(1),a!==92))return!1;let u=2;const m=u;for(;u<n.length&&(a=n.charCodeAt(u),a!==92);u++);return!(m===u||(a=n.charCodeAt(u+1),isNaN(a)||a===92))}t.isUNC=f;const F=/[\\/:\*\?"<>\|]/g,l=/[\\/]/g,s=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function e(n,a=i.isWindows){const u=a?F:l;return!(!n||n.length===0||/^\s+$/.test(n)||(u.lastIndex=0,u.test(n))||a&&s.test(n)||n==="."||n===".."||a&&n[n.length-1]==="."||a&&n.length!==n.trim().length||n.length>255)}t.isValidBasename=e;function p(n,a,u){const m=n===a;return!u||m?m:!n||!a?!1:(0,M.equalsIgnoreCase)(n,a)}t.isEqual=p;function v(n,a,u,m=E.sep){if(n===a)return!0;if(!n||!a||a.length>n.length)return!1;if(u){if(!(0,M.startsWithIgnoreCase)(n,a))return!1;if(a.length===n.length)return!0;let V=a.length;return a.charAt(a.length-1)===m&&V--,n.charAt(V)===m}return a.charAt(a.length-1)!==m&&(a+=m),n.indexOf(a)===0}t.isEqualOrParent=v;function D(n){return n>=65&&n<=90||n>=97&&n<=122}t.isWindowsDriveLetter=D;function y(n,a){return i.isWindows&&n.endsWith(":")&&(n+=E.sep),(0,E.isAbsolute)(n)||(n=(0,E.join)(a,n)),n=(0,E.normalize)(n),i.isWindows?(n=(0,M.rtrim)(n,E.sep),n.endsWith(":")&&(n+=E.sep)):(n=(0,M.rtrim)(n,E.sep),n||(n=E.sep)),n}t.sanitizeFilePath=y;function o(n){const a=(0,E.normalize)(n);return i.isWindows?n.length>3?!1:c(a)&&(n.length===2||a.charCodeAt(2)===92):a===E.posix.sep}t.isRootOrDriveLetter=o;function c(n,a=i.isWindows){return a?D(n.charCodeAt(0))&&n.charCodeAt(1)===58:!1}t.hasDriveLetter=c;function b(n){return c(n)?n[0]:void 0}t.getDriveLetter=b;function S(n,a,u){return a.length>n.length?-1:n===a?0:(u&&(n=n.toLowerCase(),a=a.toLowerCase()),n.indexOf(a))}t.indexOfPath=S;function A(n){const a=n.split(":");let u,m,W;for(const V of a){const ne=Number(V);(0,O.isNumber)(ne)?m===void 0?m=ne:W===void 0&&(W=ne):u=u?[u,V].join(":"):V}if(!u)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:u,line:m!==void 0?m:void 0,column:W!==void 0?W:m!==void 0?1:void 0}}t.parseLineAndColumnAware=A;const C="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function r(n,a,u=8){let m="";for(let V=0;V<u;V++)m+=C.charAt(Math.floor(Math.random()*C.length));let W;return a?W=`${a}-${m}`:W=m,n?(0,E.join)(n,W):W}t.randomPath=r}),define(me[110],pe([1,0,10]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function i(D){return M(D,0)}t.hash=i;function M(D,y){switch(typeof D){case"object":return D===null?O(349,y):Array.isArray(D)?g(D,y):d(D,y);case"string":return w(D,y);case"boolean":return _(D,y);case"number":return O(D,y);case"undefined":return O(937,y);default:return O(617,y)}}t.doHash=M;function O(D,y){return(y<<5)-y+D|0}t.numberHash=O;function _(D,y){return O(D?433:863,y)}function w(D,y){y=O(149417,y);for(let o=0,c=D.length;o<c;o++)y=O(D.charCodeAt(o),y);return y}t.stringHash=w;function g(D,y){return y=O(104579,y),D.reduce((o,c)=>M(c,o),y)}function d(D,y){return y=O(181387,y),Object.keys(D).sort().reduce((o,c)=>(o=w(c,o),M(D[c],o)),y)}class f{constructor(){this._value=0}get value(){return this._value}hash(y){return this._value=M(y,this._value),this._value}}t.Hasher=f;var F;(function(D){D[D.BLOCK_SIZE=64]="BLOCK_SIZE",D[D.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(F||(F={}));function l(D,y,o=32){const c=o-y,b=~((1<<c)-1);return(D<<y|(b&D)>>>c)>>>0}function s(D,y=0,o=D.byteLength,c=0){for(let b=0;b<o;b++)D[y+b]=c}function e(D,y,o="0"){for(;D.length<y;)D=o+D;return D}function p(D,y=32){return D instanceof ArrayBuffer?Array.from(new Uint8Array(D)).map(o=>o.toString(16).padStart(2,"0")).join(""):e((D>>>0).toString(16),y/4)}t.toHexString=p;class v{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(y){const o=y.length;if(o===0)return;const c=this._buff;let b=this._buffLen,S=this._leftoverHighSurrogate,A,C;for(S!==0?(A=S,C=-1,S=0):(A=y.charCodeAt(0),C=0);;){let r=A;if(E.isHighSurrogate(A))if(C+1<o){const n=y.charCodeAt(C+1);E.isLowSurrogate(n)?(C++,r=E.computeCodePoint(A,n)):r=65533}else{S=A;break}else E.isLowSurrogate(A)&&(r=65533);if(b=this._push(c,b,r),C++,C<o)A=y.charCodeAt(C);else break}this._buffLen=b,this._leftoverHighSurrogate=S}_push(y,o,c){return c<128?y[o++]=c:c<2048?(y[o++]=192|(c&1984)>>>6,y[o++]=128|(c&63)>>>0):c<65536?(y[o++]=224|(c&61440)>>>12,y[o++]=128|(c&4032)>>>6,y[o++]=128|(c&63)>>>0):(y[o++]=240|(c&1835008)>>>18,y[o++]=128|(c&258048)>>>12,y[o++]=128|(c&4032)>>>6,y[o++]=128|(c&63)>>>0),o>=64&&(this._step(),o-=64,this._totalLen+=64,y[0]=y[64+0],y[1]=y[64+1],y[2]=y[64+2]),o}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),p(this._h0)+p(this._h1)+p(this._h2)+p(this._h3)+p(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,s(this._buff,this._buffLen),this._buffLen>56&&(this._step(),s(this._buff));const y=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(y/4294967296),!1),this._buffDV.setUint32(60,y%4294967296,!1),this._step()}_step(){const y=v._bigBlock32,o=this._buffDV;for(let u=0;u<64;u+=4)y.setUint32(u,o.getUint32(u,!1),!1);for(let u=64;u<320;u+=4)y.setUint32(u,l(y.getUint32(u-12,!1)^y.getUint32(u-32,!1)^y.getUint32(u-56,!1)^y.getUint32(u-64,!1),1),!1);let c=this._h0,b=this._h1,S=this._h2,A=this._h3,C=this._h4,r,n,a;for(let u=0;u<80;u++)u<20?(r=b&S|~b&A,n=1518500249):u<40?(r=b^S^A,n=1859775393):u<60?(r=b&S|b&A|S&A,n=2400959708):(r=b^S^A,n=3395469782),a=l(c,5)+r+C+n+y.getUint32(u*4,!1)&4294967295,C=A,A=S,S=l(b,30),b=c,c=a;this._h0=this._h0+c&4294967295,this._h1=this._h1+b&4294967295,this._h2=this._h2+S&4294967295,this._h3=this._h3+A&4294967295,this._h4=this._h4+C&4294967295}}t.StringSHA1=v,v._bigBlock32=new DataView(new ArrayBuffer(320))}),define(me[111],pe([1,0,70,110]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LcsDiff=t.MyArray=t.Debug=t.stringDiff=t.StringDiffSequence=void 0;class M{constructor(l){this.source=l}getElements(){const l=this.source,s=new Int32Array(l.length);for(let e=0,p=l.length;e<p;e++)s[e]=l.charCodeAt(e);return s}}t.StringDiffSequence=M;function O(F,l,s){return new f(new M(F),new M(l)).ComputeDiff(s).changes}t.stringDiff=O;class _{static Assert(l,s){if(!l)throw new Error(s)}}t.Debug=_;class w{static Copy(l,s,e,p,v){for(let D=0;D<v;D++)e[p+D]=l[s+D]}static Copy2(l,s,e,p,v){for(let D=0;D<v;D++)e[p+D]=l[s+D]}}t.MyArray=w;var g;(function(F){F[F.MaxDifferencesHistory=1447]="MaxDifferencesHistory"})(g||(g={}));class d{constructor(){this.m_changes=[],this.m_originalStart=1073741824,this.m_modifiedStart=1073741824,this.m_originalCount=0,this.m_modifiedCount=0}MarkNextChange(){(this.m_originalCount>0||this.m_modifiedCount>0)&&this.m_changes.push(new E.DiffChange(this.m_originalStart,this.m_originalCount,this.m_modifiedStart,this.m_modifiedCount)),this.m_originalCount=0,this.m_modifiedCount=0,this.m_originalStart=1073741824,this.m_modifiedStart=1073741824}AddOriginalElement(l,s){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_originalCount++}AddModifiedElement(l,s){this.m_originalStart=Math.min(this.m_originalStart,l),this.m_modifiedStart=Math.min(this.m_modifiedStart,s),this.m_modifiedCount++}getChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes}getReverseChanges(){return(this.m_originalCount>0||this.m_modifiedCount>0)&&this.MarkNextChange(),this.m_changes.reverse(),this.m_changes}}class f{constructor(l,s,e=null){this.ContinueProcessingPredicate=e,this._originalSequence=l,this._modifiedSequence=s;const[p,v,D]=f._getElements(l),[y,o,c]=f._getElements(s);this._hasStrings=D&&c,this._originalStringElements=p,this._originalElementsOrHash=v,this._modifiedStringElements=y,this._modifiedElementsOrHash=o,this.m_forwardHistory=[],this.m_reverseHistory=[]}static _isStringArray(l){return l.length>0&&typeof l[0]=="string"}static _getElements(l){const s=l.getElements();if(f._isStringArray(s)){const e=new Int32Array(s.length);for(let p=0,v=s.length;p<v;p++)e[p]=(0,i.stringHash)(s[p],0);return[s,e,!0]}return s instanceof Int32Array?[[],s,!1]:[[],new Int32Array(s),!1]}ElementsAreEqual(l,s){return this._originalElementsOrHash[l]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[l]===this._modifiedStringElements[s]:!0}ElementsAreStrictEqual(l,s){if(!this.ElementsAreEqual(l,s))return!1;const e=f._getStrictElement(this._originalSequence,l),p=f._getStrictElement(this._modifiedSequence,s);return e===p}static _getStrictElement(l,s){return typeof l.getStrictElement=="function"?l.getStrictElement(s):null}OriginalElementsAreEqual(l,s){return this._originalElementsOrHash[l]!==this._originalElementsOrHash[s]?!1:this._hasStrings?this._originalStringElements[l]===this._originalStringElements[s]:!0}ModifiedElementsAreEqual(l,s){return this._modifiedElementsOrHash[l]!==this._modifiedElementsOrHash[s]?!1:this._hasStrings?this._modifiedStringElements[l]===this._modifiedStringElements[s]:!0}ComputeDiff(l){return this._ComputeDiff(0,this._originalElementsOrHash.length-1,0,this._modifiedElementsOrHash.length-1,l)}_ComputeDiff(l,s,e,p,v){const D=[!1];let y=this.ComputeDiffRecursive(l,s,e,p,D);return v&&(y=this.PrettifyChanges(y)),{quitEarly:D[0],changes:y}}ComputeDiffRecursive(l,s,e,p,v){for(v[0]=!1;l<=s&&e<=p&&this.ElementsAreEqual(l,e);)l++,e++;for(;s>=l&&p>=e&&this.ElementsAreEqual(s,p);)s--,p--;if(l>s||e>p){let S;return e<=p?(_.Assert(l===s+1,"originalStart should only be one more than originalEnd"),S=[new E.DiffChange(l,0,e,p-e+1)]):l<=s?(_.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),S=[new E.DiffChange(l,s-l+1,e,0)]):(_.Assert(l===s+1,"originalStart should only be one more than originalEnd"),_.Assert(e===p+1,"modifiedStart should only be one more than modifiedEnd"),S=[]),S}const D=[0],y=[0],o=this.ComputeRecursionPoint(l,s,e,p,D,y,v),c=D[0],b=y[0];if(o!==null)return o;if(!v[0]){const S=this.ComputeDiffRecursive(l,c,e,b,v);let A=[];return v[0]?A=[new E.DiffChange(c+1,s-(c+1)+1,b+1,p-(b+1)+1)]:A=this.ComputeDiffRecursive(c+1,s,b+1,p,v),this.ConcatenateChanges(S,A)}return[new E.DiffChange(l,s-l+1,e,p-e+1)]}WALKTRACE(l,s,e,p,v,D,y,o,c,b,S,A,C,r,n,a,u,m){let W=null,V=null,ne=new d,re=s,we=e,ae=C[0]-a[0]-p,ve=-1073741824,ue=this.m_forwardHistory.length-1;do{const ge=ae+l;ge===re||ge<we&&c[ge-1]<c[ge+1]?(S=c[ge+1],r=S-ae-p,S<ve&&ne.MarkNextChange(),ve=S,ne.AddModifiedElement(S+1,r),ae=ge+1-l):(S=c[ge-1]+1,r=S-ae-p,S<ve&&ne.MarkNextChange(),ve=S-1,ne.AddOriginalElement(S,r+1),ae=ge-1-l),ue>=0&&(c=this.m_forwardHistory[ue],l=c[0],re=1,we=c.length-1)}while(--ue>=-1);if(W=ne.getReverseChanges(),m[0]){let ge=C[0]+1,ye=a[0]+1;if(W!==null&&W.length>0){const ee=W[W.length-1];ge=Math.max(ge,ee.getOriginalEnd()),ye=Math.max(ye,ee.getModifiedEnd())}V=[new E.DiffChange(ge,A-ge+1,ye,n-ye+1)]}else{ne=new d,re=D,we=y,ae=C[0]-a[0]-o,ve=1073741824,ue=u?this.m_reverseHistory.length-1:this.m_reverseHistory.length-2;do{const ge=ae+v;ge===re||ge<we&&b[ge-1]>=b[ge+1]?(S=b[ge+1]-1,r=S-ae-o,S>ve&&ne.MarkNextChange(),ve=S+1,ne.AddOriginalElement(S+1,r+1),ae=ge+1-v):(S=b[ge-1],r=S-ae-o,S>ve&&ne.MarkNextChange(),ve=S,ne.AddModifiedElement(S+1,r+1),ae=ge-1-v),ue>=0&&(b=this.m_reverseHistory[ue],v=b[0],re=1,we=b.length-1)}while(--ue>=-1);V=ne.getChanges()}return this.ConcatenateChanges(W,V)}ComputeRecursionPoint(l,s,e,p,v,D,y){let o=0,c=0,b=0,S=0,A=0,C=0;l--,e--,v[0]=0,D[0]=0,this.m_forwardHistory=[],this.m_reverseHistory=[];const r=s-l+(p-e),n=r+1,a=new Int32Array(n),u=new Int32Array(n),m=p-e,W=s-l,V=l-e,ne=s-p,we=(W-m)%2==0;a[m]=l,u[W]=s,y[0]=!1;for(let ae=1;ae<=r/2+1;ae++){let ve=0,ue=0;b=this.ClipDiagonalBound(m-ae,ae,m,n),S=this.ClipDiagonalBound(m+ae,ae,m,n);for(let ye=b;ye<=S;ye+=2){ye===b||ye<S&&a[ye-1]<a[ye+1]?o=a[ye+1]:o=a[ye-1]+1,c=o-(ye-m)-V;const ee=o;for(;o<s&&c<p&&this.ElementsAreEqual(o+1,c+1);)o++,c++;if(a[ye]=o,o+c>ve+ue&&(ve=o,ue=c),!we&&Math.abs(ye-W)<=ae-1&&o>=u[ye])return v[0]=o,D[0]=c,ee<=u[ye]&&1447>0&&ae<=1447+1?this.WALKTRACE(m,b,S,V,W,A,C,ne,a,u,o,s,v,c,p,D,we,y):null}const ge=(ve-l+(ue-e)-ae)/2;if(this.ContinueProcessingPredicate!==null&&!this.ContinueProcessingPredicate(ve,ge))return y[0]=!0,v[0]=ve,D[0]=ue,ge>0&&1447>0&&ae<=1447+1?this.WALKTRACE(m,b,S,V,W,A,C,ne,a,u,o,s,v,c,p,D,we,y):(l++,e++,[new E.DiffChange(l,s-l+1,e,p-e+1)]);A=this.ClipDiagonalBound(W-ae,ae,W,n),C=this.ClipDiagonalBound(W+ae,ae,W,n);for(let ye=A;ye<=C;ye+=2){ye===A||ye<C&&u[ye-1]>=u[ye+1]?o=u[ye+1]-1:o=u[ye-1],c=o-(ye-W)-ne;const ee=o;for(;o>l&&c>e&&this.ElementsAreEqual(o,c);)o--,c--;if(u[ye]=o,we&&Math.abs(ye-m)<=ae&&o<=a[ye])return v[0]=o,D[0]=c,ee>=a[ye]&&1447>0&&ae<=1447+1?this.WALKTRACE(m,b,S,V,W,A,C,ne,a,u,o,s,v,c,p,D,we,y):null}if(ae<=1447){let ye=new Int32Array(S-b+2);ye[0]=m-b+1,w.Copy2(a,b,ye,1,S-b+1),this.m_forwardHistory.push(ye),ye=new Int32Array(C-A+2),ye[0]=W-A+1,w.Copy2(u,A,ye,1,C-A+1),this.m_reverseHistory.push(ye)}}return this.WALKTRACE(m,b,S,V,W,A,C,ne,a,u,o,s,v,c,p,D,we,y)}PrettifyChanges(l){for(let s=0;s<l.length;s++){const e=l[s],p=s<l.length-1?l[s+1].originalStart:this._originalElementsOrHash.length,v=s<l.length-1?l[s+1].modifiedStart:this._modifiedElementsOrHash.length,D=e.originalLength>0,y=e.modifiedLength>0;for(;e.originalStart+e.originalLength<p&&e.modifiedStart+e.modifiedLength<v&&(!D||this.OriginalElementsAreEqual(e.originalStart,e.originalStart+e.originalLength))&&(!y||this.ModifiedElementsAreEqual(e.modifiedStart,e.modifiedStart+e.modifiedLength));){const c=this.ElementsAreStrictEqual(e.originalStart,e.modifiedStart);if(this.ElementsAreStrictEqual(e.originalStart+e.originalLength,e.modifiedStart+e.modifiedLength)&&!c)break;e.originalStart++,e.modifiedStart++}const o=[null];if(s<l.length-1&&this.ChangesOverlap(l[s],l[s+1],o)){l[s]=o[0],l.splice(s+1,1),s--;continue}}for(let s=l.length-1;s>=0;s--){const e=l[s];let p=0,v=0;if(s>0){const S=l[s-1];p=S.originalStart+S.originalLength,v=S.modifiedStart+S.modifiedLength}const D=e.originalLength>0,y=e.modifiedLength>0;let o=0,c=this._boundaryScore(e.originalStart,e.originalLength,e.modifiedStart,e.modifiedLength);for(let S=1;;S++){const A=e.originalStart-S,C=e.modifiedStart-S;if(A<p||C<v||D&&!this.OriginalElementsAreEqual(A,A+e.originalLength)||y&&!this.ModifiedElementsAreEqual(C,C+e.modifiedLength))break;const n=(A===p&&C===v?5:0)+this._boundaryScore(A,e.originalLength,C,e.modifiedLength);n>c&&(c=n,o=S)}e.originalStart-=o,e.modifiedStart-=o;const b=[null];if(s>0&&this.ChangesOverlap(l[s-1],l[s],b)){l[s-1]=b[0],l.splice(s,1),s++;continue}}if(this._hasStrings)for(let s=1,e=l.length;s<e;s++){const p=l[s-1],v=l[s],D=v.originalStart-p.originalStart-p.originalLength,y=p.originalStart,o=v.originalStart+v.originalLength,c=o-y,b=p.modifiedStart,S=v.modifiedStart+v.modifiedLength,A=S-b;if(D<5&&c<20&&A<20){const C=this._findBetterContiguousSequence(y,c,b,A,D);if(C){const[r,n]=C;(r!==p.originalStart+p.originalLength||n!==p.modifiedStart+p.modifiedLength)&&(p.originalLength=r-p.originalStart,p.modifiedLength=n-p.modifiedStart,v.originalStart=r+D,v.modifiedStart=n+D,v.originalLength=o-v.originalStart,v.modifiedLength=S-v.modifiedStart)}}}return l}_findBetterContiguousSequence(l,s,e,p,v){if(s<v||p<v)return null;const D=l+s-v+1,y=e+p-v+1;let o=0,c=0,b=0;for(let S=l;S<D;S++)for(let A=e;A<y;A++){const C=this._contiguousSequenceScore(S,A,v);C>0&&C>o&&(o=C,c=S,b=A)}return o>0?[c,b]:null}_contiguousSequenceScore(l,s,e){let p=0;for(let v=0;v<e;v++){if(!this.ElementsAreEqual(l+v,s+v))return 0;p+=this._originalStringElements[l+v].length}return p}_OriginalIsBoundary(l){return l<=0||l>=this._originalElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._originalStringElements[l])}_OriginalRegionIsBoundary(l,s){if(this._OriginalIsBoundary(l)||this._OriginalIsBoundary(l-1))return!0;if(s>0){const e=l+s;if(this._OriginalIsBoundary(e-1)||this._OriginalIsBoundary(e))return!0}return!1}_ModifiedIsBoundary(l){return l<=0||l>=this._modifiedElementsOrHash.length-1?!0:this._hasStrings&&/^\s*$/.test(this._modifiedStringElements[l])}_ModifiedRegionIsBoundary(l,s){if(this._ModifiedIsBoundary(l)||this._ModifiedIsBoundary(l-1))return!0;if(s>0){const e=l+s;if(this._ModifiedIsBoundary(e-1)||this._ModifiedIsBoundary(e))return!0}return!1}_boundaryScore(l,s,e,p){const v=this._OriginalRegionIsBoundary(l,s)?1:0,D=this._ModifiedRegionIsBoundary(e,p)?1:0;return v+D}ConcatenateChanges(l,s){const e=[];if(l.length===0||s.length===0)return s.length>0?s:l;if(this.ChangesOverlap(l[l.length-1],s[0],e)){const p=new Array(l.length+s.length-1);return w.Copy(l,0,p,0,l.length-1),p[l.length-1]=e[0],w.Copy(s,1,p,l.length,s.length-1),p}else{const p=new Array(l.length+s.length);return w.Copy(l,0,p,0,l.length),w.Copy(s,0,p,l.length,s.length),p}}ChangesOverlap(l,s,e){if(_.Assert(l.originalStart<=s.originalStart,"Left change is not less than or equal to right change"),_.Assert(l.modifiedStart<=s.modifiedStart,"Left change is not less than or equal to right change"),l.originalStart+l.originalLength>=s.originalStart||l.modifiedStart+l.modifiedLength>=s.modifiedStart){const p=l.originalStart;let v=l.originalLength;const D=l.modifiedStart;let y=l.modifiedLength;return l.originalStart+l.originalLength>=s.originalStart&&(v=s.originalStart+s.originalLength-l.originalStart),l.modifiedStart+l.modifiedLength>=s.modifiedStart&&(y=s.modifiedStart+s.modifiedLength-l.modifiedStart),e[0]=new E.DiffChange(p,v,D,y),!0}else return e[0]=null,!1}ClipDiagonalBound(l,s,e,p){if(l>=0&&l<p)return l;const v=e,D=p-e-1,y=s%2==0;if(l<0){const o=v%2==0;return y===o?0:1}else{const o=D%2==0;return y===o?p-1:p-2}}}t.LcsDiff=f}),define(me[48],pe([1,0,14,10]),function(Z,t,E,i){"use strict";var M,O,_;Object.defineProperty(t,"__esModule",{value:!0}),t.LRUCache=t.LinkedMap=t.Touch=t.ResourceSet=t.ResourceMap=t.TernarySearchTree=t.UriIterator=t.PathIterator=t.ConfigKeysIterator=t.StringIterator=t.setToString=t.mapToString=t.getOrSet=void 0;function w(C,r,n){let a=C.get(r);return a===void 0&&(a=n,C.set(r,a)),a}t.getOrSet=w;function g(C){const r=[];return C.forEach((n,a)=>{r.push(`${a} => ${n}`)}),`Map(${C.size}) {${r.join(", ")}}`}t.mapToString=g;function d(C){const r=[];return C.forEach(n=>{r.push(n)}),`Set(${C.size}) {${r.join(", ")}}`}t.setToString=d;class f{constructor(){this._value="",this._pos=0}reset(r){return this._value=r,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(r){const n=r.charCodeAt(0),a=this._value.charCodeAt(this._pos);return n-a}value(){return this._value[this._pos]}}t.StringIterator=f;class F{constructor(r=!0){this._caseSensitive=r}reset(r){return this._value=r,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let r=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(r)this._from++;else break;else r=!1;return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.ConfigKeysIterator=F;class l{constructor(r=!0,n=!0){this._splitOnBackslash=r,this._caseSensitive=n}reset(r){this._from=0,this._to=0,this._value=r,this._valueLen=r.length;for(let n=r.length-1;n>=0;n--,this._valueLen--){const a=this._value.charCodeAt(n);if(!(a===47||this._splitOnBackslash&&a===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let r=!0;for(;this._to<this._valueLen;this._to++){const n=this._value.charCodeAt(this._to);if(n===47||this._splitOnBackslash&&n===92)if(r)this._from++;else break;else r=!1}return this}cmp(r){return this._caseSensitive?(0,i.compareSubstring)(r,this._value,0,r.length,this._from,this._to):(0,i.compareSubstringIgnoreCase)(r,this._value,0,r.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}t.PathIterator=l;var s;(function(C){C[C.Scheme=1]="Scheme",C[C.Authority=2]="Authority",C[C.Path=3]="Path",C[C.Query=4]="Query",C[C.Fragment=5]="Fragment"})(s||(s={}));class e{constructor(r,n){this._ignorePathCasing=r,this._ignoreQueryAndFragment=n,this._states=[],this._stateIdx=0}reset(r){return this._value=r,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new l(!1,!this._ignorePathCasing(r)),this._pathIterator.reset(r.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(r)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(r){if(this._states[this._stateIdx]===1)return(0,i.compareIgnoreCase)(r,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,i.compareIgnoreCase)(r,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(r);if(this._states[this._stateIdx]===4)return(0,i.compare)(r,this._value.query);if(this._states[this._stateIdx]===5)return(0,i.compare)(r,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}t.UriIterator=e;class p{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const r=this.right;return this.right=r.left,r.left=this,this.updateHeight(),r.updateHeight(),r}rotateRight(){const r=this.left;return this.left=r.right,r.right=this,this.updateHeight(),r.updateHeight(),r}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var v;(function(C){C[C.Left=-1]="Left",C[C.Mid=0]="Mid",C[C.Right=1]="Right"})(v||(v={}));class D{constructor(r){this._iter=r}static forUris(r=()=>!1,n=()=>!1){return new D(new e(r,n))}static forPaths(r=!1){return new D(new l(void 0,!r))}static forStrings(){return new D(new f)}static forConfigKeys(){return new D(new F)}clear(){this._root=void 0}fill(r,n){if(n){const a=n.slice(0);(0,E.shuffle)(a);for(const u of a)this.set(u,r)}else{const a=r.slice(0);(0,E.shuffle)(a);for(const u of a)this.set(u[0],u[1])}}set(r,n){const a=this._iter.reset(r);let u;this._root||(this._root=new p,this._root.segment=a.value());const m=[];for(u=this._root;;){const V=a.cmp(u.segment);if(V>0)u.left||(u.left=new p,u.left.segment=a.value()),m.push([-1,u]),u=u.left;else if(V<0)u.right||(u.right=new p,u.right.segment=a.value()),m.push([1,u]),u=u.right;else if(a.hasNext())a.next(),u.mid||(u.mid=new p,u.mid.segment=a.value()),m.push([0,u]),u=u.mid;else break}const W=u.value;u.value=n,u.key=r;for(let V=m.length-1;V>=0;V--){const ne=m[V][1];ne.updateHeight();const re=ne.balanceFactor();if(re<-1||re>1){const we=m[V][0],ae=m[V+1][0];if(we===1&&ae===1)m[V][1]=ne.rotateLeft();else if(we===-1&&ae===-1)m[V][1]=ne.rotateRight();else if(we===1&&ae===-1)ne.right=m[V+1][1]=m[V+1][1].rotateRight(),m[V][1]=ne.rotateLeft();else if(we===-1&&ae===1)ne.left=m[V+1][1]=m[V+1][1].rotateLeft(),m[V][1]=ne.rotateRight();else throw new Error;if(V>0)switch(m[V-1][0]){case-1:m[V-1][1].left=m[V][1];break;case 1:m[V-1][1].right=m[V][1];break;case 0:m[V-1][1].mid=m[V][1];break}else this._root=m[0][1]}}return W}get(r){return this._getNode(r)?.value}_getNode(r){const n=this._iter.reset(r);let a=this._root;for(;a;){const u=n.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(n.hasNext())n.next(),a=a.mid;else break}return a}has(r){const n=this._getNode(r);return!(n?.value===void 0&&n?.mid===void 0)}delete(r){return this._delete(r,!1)}deleteSuperstr(r){return this._delete(r,!0)}_delete(r,n){const a=this._iter.reset(r),u=[];let m=this._root;for(;m;){const W=a.cmp(m.segment);if(W>0)u.push([-1,m]),m=m.left;else if(W<0)u.push([1,m]),m=m.right;else if(a.hasNext())a.next(),u.push([0,m]),m=m.mid;else break}if(!!m){if(n?(m.left=void 0,m.mid=void 0,m.right=void 0,m.height=1):(m.key=void 0,m.value=void 0),!m.mid&&!m.value)if(m.left&&m.right){const W=this._min(m.right),{key:V,value:ne,segment:re}=W;this._delete(W.key,!1),m.key=V,m.value=ne,m.segment=re}else{const W=m.left??m.right;if(u.length>0){const[V,ne]=u[u.length-1];switch(V){case-1:ne.left=W;break;case 0:ne.mid=W;break;case 1:ne.right=W;break}}else this._root=W}for(let W=u.length-1;W>=0;W--){const V=u[W][1];V.updateHeight();const ne=V.balanceFactor();if(ne>1?(V.right.balanceFactor()>=0||(V.right=V.right.rotateRight()),u[W][1]=V.rotateLeft()):ne<-1&&(V.left.balanceFactor()<=0||(V.left=V.left.rotateLeft()),u[W][1]=V.rotateRight()),W>0)switch(u[W-1][0]){case-1:u[W-1][1].left=u[W][1];break;case 1:u[W-1][1].right=u[W][1];break;case 0:u[W-1][1].mid=u[W][1];break}else this._root=u[0][1]}}}_min(r){for(;r.left;)r=r.left;return r}findSubstr(r){const n=this._iter.reset(r);let a=this._root,u;for(;a;){const m=n.cmp(a.segment);if(m>0)a=a.left;else if(m<0)a=a.right;else if(n.hasNext())n.next(),u=a.value||u,a=a.mid;else break}return a&&a.value||u}findSuperstr(r){const n=this._iter.reset(r);let a=this._root;for(;a;){const u=n.cmp(a.segment);if(u>0)a=a.left;else if(u<0)a=a.right;else if(n.hasNext())n.next(),a=a.mid;else return a.mid?this._entries(a.mid):void 0}}forEach(r){for(const[n,a]of this)r(a,n)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(r){const n=[];return this._dfsEntries(r,n),n[Symbol.iterator]()}_dfsEntries(r,n){!r||(r.left&&this._dfsEntries(r.left,n),r.value&&n.push([r.key,r.value]),r.mid&&this._dfsEntries(r.mid,n),r.right&&this._dfsEntries(r.right,n))}_isBalanced(){const r=n=>{if(!n)return!0;const a=n.balanceFactor();return a<-1||a>1?!1:r(n.left)&&r(n.right)};return r(this._root)}}t.TernarySearchTree=D;class y{constructor(r,n){this.uri=r,this.value=n}}class o{constructor(r,n){this[M]="ResourceMap",r instanceof o?(this.map=new Map(r.map),this.toKey=n??o.defaultToKey):(this.map=new Map,this.toKey=r??o.defaultToKey)}set(r,n){return this.map.set(this.toKey(r),new y(r,n)),this}get(r){return this.map.get(this.toKey(r))?.value}has(r){return this.map.has(this.toKey(r))}get size(){return this.map.size}clear(){this.map.clear()}delete(r){return this.map.delete(this.toKey(r))}forEach(r,n){typeof n!="undefined"&&(r=r.bind(n));for(const[a,u]of this.map)r(u.value,u.uri,this)}*values(){for(const r of this.map.values())yield r.value}*keys(){for(const r of this.map.values())yield r.uri}*entries(){for(const r of this.map.values())yield[r.uri,r.value]}*[(M=Symbol.toStringTag,Symbol.iterator)](){for(const[,r]of this.map)yield[r.uri,r.value]}}t.ResourceMap=o,o.defaultToKey=C=>C.toString();class c{constructor(r,n){this[O]="ResourceSet",!r||typeof r=="function"?this._map=new o(r):(this._map=new o(n),r.forEach(this.add,this))}get size(){return this._map.size}add(r){return this._map.set(r,r),this}clear(){this._map.clear()}delete(r){return this._map.delete(r)}forEach(r,n){this._map.forEach((a,u)=>r.call(n,u,u,this))}has(r){return this._map.has(r)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(O=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}t.ResourceSet=c;var b;(function(C){C[C.None=0]="None",C[C.AsOld=1]="AsOld",C[C.AsNew=2]="AsNew"})(b=t.Touch||(t.Touch={}));class S{constructor(){this[_]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(r){return this._map.has(r)}get(r,n=0){const a=this._map.get(r);if(!!a)return n!==0&&this.touch(a,n),a.value}set(r,n,a=0){let u=this._map.get(r);if(u)u.value=n,a!==0&&this.touch(u,a);else{switch(u={key:r,value:n,next:void 0,previous:void 0},a){case 0:this.addItemLast(u);break;case 1:this.addItemFirst(u);break;case 2:this.addItemLast(u);break;default:this.addItemLast(u);break}this._map.set(r,u),this._size++}return this}delete(r){return!!this.remove(r)}remove(r){const n=this._map.get(r);if(!!n)return this._map.delete(r),this.removeItem(n),this._size--,n.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const r=this._head;return this._map.delete(r.key),this.removeItem(r),this._size--,r.value}forEach(r,n){const a=this._state;let u=this._head;for(;u;){if(n?r.bind(n)(u.value,u.key,this):r(u.value,u.key,this),this._state!==a)throw new Error("LinkedMap got modified during iteration.");u=u.next}}keys(){const r=this,n=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.key,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return u}values(){const r=this,n=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:a.value,done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return u}entries(){const r=this,n=this._state;let a=this._head;const u={[Symbol.iterator](){return u},next(){if(r._state!==n)throw new Error("LinkedMap got modified during iteration.");if(a){const m={value:[a.key,a.value],done:!1};return a=a.next,m}else return{value:void 0,done:!0}}};return u}[(_=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(r){if(r>=this.size)return;if(r===0){this.clear();return}let n=this._head,a=this.size;for(;n&&a>r;)this._map.delete(n.key),n=n.next,a--;this._head=n,this._size=a,n&&(n.previous=void 0),this._state++}addItemFirst(r){if(!this._head&&!this._tail)this._tail=r;else if(this._head)r.next=this._head,this._head.previous=r;else throw new Error("Invalid list");this._head=r,this._state++}addItemLast(r){if(!this._head&&!this._tail)this._head=r;else if(this._tail)r.previous=this._tail,this._tail.next=r;else throw new Error("Invalid list");this._tail=r,this._state++}removeItem(r){if(r===this._head&&r===this._tail)this._head=void 0,this._tail=void 0;else if(r===this._head){if(!r.next)throw new Error("Invalid list");r.next.previous=void 0,this._head=r.next}else if(r===this._tail){if(!r.previous)throw new Error("Invalid list");r.previous.next=void 0,this._tail=r.previous}else{const n=r.next,a=r.previous;if(!n||!a)throw new Error("Invalid list");n.previous=a,a.next=n}r.next=void 0,r.previous=void 0,this._state++}touch(r,n){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(n!==1&&n!==2)){if(n===1){if(r===this._head)return;const a=r.next,u=r.previous;r===this._tail?(u.next=void 0,this._tail=u):(a.previous=u,u.next=a),r.previous=void 0,r.next=this._head,this._head.previous=r,this._head=r,this._state++}else if(n===2){if(r===this._tail)return;const a=r.next,u=r.previous;r===this._head?(a.previous=void 0,this._head=a):(a.previous=u,u.next=a),r.next=void 0,r.previous=this._tail,this._tail.next=r,this._tail=r,this._state++}}}toJSON(){const r=[];return this.forEach((n,a)=>{r.push([a,n])}),r}fromJSON(r){this.clear();for(const[n,a]of r)this.set(n,a)}}t.LinkedMap=S;class A extends S{constructor(r,n=1){super();this._limit=r,this._ratio=Math.min(Math.max(0,n),1)}get limit(){return this._limit}set limit(r){this._limit=r,this.checkTrim()}get ratio(){return this._ratio}set ratio(r){this._ratio=Math.min(Math.max(0,r),1),this.checkTrim()}get(r,n=2){return super.get(r,n)}peek(r){return super.get(r,0)}set(r,n){return super.set(r,n,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}t.LRUCache=A}),define(me[33],pe([1,0,48,10]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.fuzzyScoreGraceful=t.fuzzyScoreGracefulAggressive=t.fuzzyScore=t.FuzzyScoreOptions=t.FuzzyScore=t.isPatternInWord=t.createMatches=t.anyScore=t.matchesFuzzy2=t.matchesFuzzy=t.matchesWords=t.matchesCamelCase=t.isUpper=t.matchesSubString=t.matchesContiguousSubString=t.matchesPrefix=t.matchesStrictPrefix=t.or=void 0;function M(...k){return function(P,x){for(let J=0,he=k.length;J<he;J++){const de=k[J](P,x);if(de)return de}return null}}t.or=M,t.matchesStrictPrefix=O.bind(void 0,!1),t.matchesPrefix=O.bind(void 0,!0);function O(k,P,x){if(!x||x.length<P.length)return null;let J;return k?J=i.startsWithIgnoreCase(x,P):J=x.indexOf(P)===0,J?P.length>0?[{start:0,end:P.length}]:[]:null}function _(k,P){const x=P.toLowerCase().indexOf(k.toLowerCase());return x===-1?null:[{start:x,end:x+k.length}]}t.matchesContiguousSubString=_;function w(k,P){return g(k.toLowerCase(),P.toLowerCase(),0,0)}t.matchesSubString=w;function g(k,P,x,J){if(x===k.length)return[];if(J===P.length)return null;if(k[x]===P[J]){let he=null;return(he=g(k,P,x+1,J+1))?D({start:J,end:J+1},he):null}return g(k,P,x,J+1)}function d(k){return 97<=k&&k<=122}function f(k){return 65<=k&&k<=90}t.isUpper=f;function F(k){return 48<=k&&k<=57}function l(k){return k===32||k===9||k===10||k===13}const s=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(k=>s.add(k.charCodeAt(0)));function e(k){return l(k)||s.has(k)}function p(k,P){return k===P||e(k)&&e(P)}function v(k){return d(k)||f(k)||F(k)}function D(k,P){return P.length===0?P=[k]:k.end===P[0].start?P[0].start=k.start:P.unshift(k),P}function y(k,P){for(let x=P;x<k.length;x++){const J=k.charCodeAt(x);if(f(J)||F(J)||x>0&&!v(k.charCodeAt(x-1)))return x}return k.length}function o(k,P,x,J){if(x===k.length)return[];if(J===P.length)return null;if(k[x]!==P[J].toLowerCase())return null;{let he=null,de=J+1;for(he=o(k,P,x+1,J+1);!he&&(de=y(P,de))<P.length;)he=o(k,P,x+1,de),de++;return he===null?null:D({start:J,end:J+1},he)}}function c(k){let P=0,x=0,J=0,he=0,de=0;for(let De=0;De<k.length;De++)de=k.charCodeAt(De),f(de)&&P++,d(de)&&x++,v(de)&&J++,F(de)&&he++;const Ee=P/k.length,_e=x/k.length,ke=J/k.length,Ie=he/k.length;return{upperPercent:Ee,lowerPercent:_e,alphaPercent:ke,numericPercent:Ie}}function b(k){const{upperPercent:P,lowerPercent:x}=k;return x===0&&P>.6}function S(k){const{upperPercent:P,lowerPercent:x,alphaPercent:J,numericPercent:he}=k;return x>.2&&P<.8&&J>.6&&he<.2}function A(k){let P=0,x=0,J=0,he=0;for(let de=0;de<k.length;de++)J=k.charCodeAt(de),f(J)&&P++,d(J)&&x++,l(J)&&he++;return(P===0||x===0)&&he===0?k.length<=30:P<=5}function C(k,P){if(!P||(P=P.trim(),P.length===0)||!A(k)||P.length>60)return null;const x=c(P);if(!S(x)){if(!b(x))return null;P=P.toLowerCase()}let J=null,he=0;for(k=k.toLowerCase();he<P.length&&(J=o(k,P,0,he))===null;)he=y(P,he+1);return J}t.matchesCamelCase=C;function r(k,P,x=!1){if(!P||P.length===0)return null;let J=null,he=0;for(k=k.toLowerCase(),P=P.toLowerCase();he<P.length&&(J=n(k,P,0,he,x))===null;)he=a(P,he+1);return J}t.matchesWords=r;function n(k,P,x,J,he){if(x===k.length)return[];if(J===P.length)return null;if(p(k.charCodeAt(x),P.charCodeAt(J))){let de=null,Ee=J+1;if(de=n(k,P,x+1,J+1,he),!he)for(;!de&&(Ee=a(P,Ee))<P.length;)de=n(k,P,x+1,Ee,he),Ee++;return de?k.charCodeAt(x)!==P.charCodeAt(J)?de:D({start:J,end:J+1},de):null}else return null}function a(k,P){for(let x=P;x<k.length;x++)if(e(k.charCodeAt(x))||x>0&&e(k.charCodeAt(x-1)))return x;return k.length}const u=M(t.matchesPrefix,C,_),m=M(t.matchesPrefix,C,w),W=new E.LRUCache(1e4);function V(k,P,x=!1){if(typeof k!="string"||typeof P!="string")return null;let J=W.get(k);J||(J=new RegExp(i.convertSimple2RegExpPattern(k),"i"),W.set(k,J));const he=J.exec(P);return he?[{start:he.index,end:he.index+he[0].length}]:x?m(k,P):u(k,P)}t.matchesFuzzy=V;function ne(k,P){const x=K(k,k.toLowerCase(),0,P,P.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return x?we(x):null}t.matchesFuzzy2=ne;function re(k,P,x,J,he,de){const Ee=Math.min(13,k.length);for(;x<Ee;x++){const _e=K(k,P,x,J,he,de,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(_e)return _e}return[0,de]}t.anyScore=re;function we(k){if(typeof k=="undefined")return[];const P=[],x=k[1];for(let J=k.length-1;J>1;J--){const he=k[J]+x,de=P[P.length-1];de&&de.end===he?de.end=he+1:P.push({start:he,end:he+1})}return P}t.createMatches=we;const ae=128;function ve(){const k=[],P=[];for(let x=0;x<=ae;x++)P[x]=0;for(let x=0;x<=ae;x++)k.push(P.slice(0));return k}function ue(k){const P=[];for(let x=0;x<=k;x++)P[x]=0;return P}const ge=ue(2*ae),ye=ue(2*ae),ee=ve(),fe=ve(),te=ve(),X=!1;function se(k,P,x,J,he){function de(_e,ke,Ie=" "){for(;_e.length<ke;)_e=Ie+_e;return _e}let Ee=` |   |${J.split("").map(_e=>de(_e,3)).join("|")}
`;for(let _e=0;_e<=x;_e++)_e===0?Ee+=" |":Ee+=`${P[_e-1]}|`,Ee+=k[_e].slice(0,he+1).map(ke=>de(ke.toString(),3)).join("|")+`
`;return Ee}function ie(k,P,x,J){k=k.substr(P),x=x.substr(J),console.log(se(fe,k,k.length,x,x.length)),console.log(se(te,k,k.length,x,x.length)),console.log(se(ee,k,k.length,x,x.length))}function L(k,P){if(P<0||P>=k.length)return!1;const x=k.codePointAt(P);switch(x){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!i.isEmojiImprecise(x)}}function $(k,P){if(P<0||P>=k.length)return!1;switch(k.charCodeAt(P)){case 32:case 9:return!0;default:return!1}}function G(k,P,x){return P[k]!==x[k]}function B(k,P,x,J,he,de,Ee=!1){for(;P<x&&he<de;)k[P]===J[he]&&(Ee&&(ge[P]=he),P+=1),he+=1;return P===x}t.isPatternInWord=B;var h;(function(k){k[k.Diag=1]="Diag",k[k.Left=2]="Left",k[k.LeftLeft=3]="LeftLeft"})(h||(h={}));var I;(function(k){k.Default=[-100,0];function P(x){return!x||x.length===2&&x[0]===-100&&x[1]===0}k.isDefault=P})(I=t.FuzzyScore||(t.FuzzyScore={}));class U{constructor(P,x){this.firstMatchCanBeWeak=P,this.boostFullMatch=x}}t.FuzzyScoreOptions=U,U.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function K(k,P,x,J,he,de,Ee=U.default){const _e=k.length>ae?ae:k.length,ke=J.length>ae?ae:J.length;if(x>=_e||de>=ke||_e-x>ke-de||!B(P,x,_e,he,de,ke,!0))return;Q(_e,ke,x,de,P,he);let Ie=1,De=1,Pe=x,Me=de;const Ge=[!1];for(Ie=1,Pe=x;Pe<_e;Ie++,Pe++){const Oe=ge[Pe],q=ye[Pe],oe=Pe+1<_e?ye[Pe+1]:ke;for(De=Oe-de+1,Me=Oe;Me<oe;De++,Me++){let be=Number.MIN_SAFE_INTEGER,Ce=!1;Me<=q&&(be=N(k,P,Pe,x,J,he,Me,ke,de,ee[Ie-1][De-1]===0,Ge));let Te=0;be!==Number.MAX_SAFE_INTEGER&&(Ce=!0,Te=be+fe[Ie-1][De-1]);const Re=Me>Oe,$e=Re?fe[Ie][De-1]+(ee[Ie][De-1]>0?-5:0):0,tt=Me>Oe+1&&ee[Ie][De-1]>0,Xe=tt?fe[Ie][De-2]+(ee[Ie][De-2]>0?-5:0):0;if(tt&&(!Re||Xe>=$e)&&(!Ce||Xe>=Te))fe[Ie][De]=Xe,te[Ie][De]=3,ee[Ie][De]=0;else if(Re&&(!Ce||$e>=Te))fe[Ie][De]=$e,te[Ie][De]=2,ee[Ie][De]=0;else if(Ce)fe[Ie][De]=Te,te[Ie][De]=1,ee[Ie][De]=ee[Ie-1][De-1]+1;else throw new Error("not possible")}}if(X&&ie(k,x,J,de),!Ge[0]&&!Ee.firstMatchCanBeWeak)return;Ie--,De--;const He=[fe[Ie][De],de];let Ue=0,Qe=0;for(;Ie>=1;){let Oe=De;do{const q=te[Ie][Oe];if(q===3)Oe=Oe-2;else if(q===2)Oe=Oe-1;else break}while(Oe>=1);Ue>1&&P[x+Ie-1]===he[de+De-1]&&!G(Oe+de-1,J,he)&&Ue+1>ee[Ie][Oe]&&(Oe=De),Oe===De?Ue++:Ue=1,Qe||(Qe=Oe),Ie--,De=Oe-1,He.push(De)}ke===_e&&Ee.boostFullMatch&&(He[0]+=2);const je=Qe-_e;return He[0]-=je,He}t.fuzzyScore=K;function Q(k,P,x,J,he,de){let Ee=k-1,_e=P-1;for(;Ee>=x&&_e>=J;)he[Ee]===de[_e]&&(ye[Ee]=_e,Ee--),_e--}function N(k,P,x,J,he,de,Ee,_e,ke,Ie,De){if(P[x]!==de[Ee])return Number.MIN_SAFE_INTEGER;let Pe=1,Me=!1;return Ee===x-J?Pe=k[x]===he[Ee]?7:5:G(Ee,he,de)&&(Ee===0||!G(Ee-1,he,de))?(Pe=k[x]===he[Ee]?7:5,Me=!0):L(de,Ee)&&(Ee===0||!L(de,Ee-1))?Pe=5:(L(de,Ee-1)||$(de,Ee-1))&&(Pe=5,Me=!0),Pe>1&&x===J&&(De[0]=!0),Me||(Me=G(Ee,he,de)||L(de,Ee-1)||$(de,Ee-1)),x===J?Ee>ke&&(Pe-=Me?3:5):Ie?Pe+=Me?2:0:Pe+=Me?0:1,Ee+1===_e&&(Pe-=Me?3:5),Pe}function R(k,P,x,J,he,de,Ee){return T(k,P,x,J,he,de,!0,Ee)}t.fuzzyScoreGracefulAggressive=R;function z(k,P,x,J,he,de,Ee){return T(k,P,x,J,he,de,!1,Ee)}t.fuzzyScoreGraceful=z;function T(k,P,x,J,he,de,Ee,_e){let ke=K(k,P,x,J,he,de,_e);if(ke&&!Ee)return ke;if(k.length>=3){const Ie=Math.min(7,k.length-1);for(let De=x+1;De<Ie;De++){const Pe=H(k,De);if(Pe){const Me=K(Pe,Pe.toLowerCase(),x,J,he,de,_e);Me&&(Me[0]-=3,(!ke||Me[0]>ke[0])&&(ke=Me))}}}return ke}function H(k,P){if(P+1>=k.length)return;const x=k[P],J=k[P+1];if(x!==J)return k.slice(0,P)+J+x+k.slice(P+2)}}),define(me[34],pe([1,0,11,33,10]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.matchesFuzzyIconAware=t.parseLabelWithIcons=t.stripIcons=t.markdownEscapeEscapedIcons=t.escapeIcons=t.iconStartMarker=void 0,t.iconStartMarker="$(";const O=new RegExp(`\\$\\(${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?\\)`,"g"),_=new RegExp(E.CSSIcon.iconNameCharacter),w=new RegExp(`(\\\\)?${O.source}`,"g");function g(v){return v.replace(w,(D,y)=>y?D:`\\${D}`)}t.escapeIcons=g;const d=new RegExp(`\\\\${O.source}`,"g");function f(v){return v.replace(d,D=>`\\${D}`)}t.markdownEscapeEscapedIcons=f;const F=new RegExp(`(\\s)?(\\\\)?${O.source}(\\s)?`,"g");function l(v){return v.indexOf(t.iconStartMarker)===-1?v:v.replace(F,(D,y,o,c)=>o?D:y||c||"")}t.stripIcons=l;function s(v){const D=v.indexOf(t.iconStartMarker);return D===-1?{text:v}:e(v,D)}t.parseLabelWithIcons=s;function e(v,D){const y=[];let o="";function c(u){if(u){o+=u;for(const m of u)y.push(A)}}let b=-1,S="",A=0,C,r,n=D;const a=v.length;for(c(v.substr(0,D));n<a;)C=v[n],r=v[n+1],C===t.iconStartMarker[0]&&r===t.iconStartMarker[1]?(b=n,c(S),S=t.iconStartMarker,n++):C===")"&&b!==-1?(A+=n-b+1,b=-1,S=""):b!==-1?_.test(C)?S+=C:(c(S),b=-1,S=""):c(C),n++;return c(S),{text:o,iconOffsets:y}}function p(v,D,y=!1){const{text:o,iconOffsets:c}=D;if(!c||c.length===0)return(0,i.matchesFuzzy)(v,o,y);const b=(0,M.ltrim)(o," "),S=o.length-b.length,A=(0,i.matchesFuzzy)(v,b,y);if(A)for(const C of A){const r=c[C.start+S]+S;C.start+=r,C.end+=r}return A}t.matchesFuzzyIconAware=p}),define(me[16],pe([1,0,21,5]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.uriToFsPath=t.URI=void 0;const M=/^\w[\w\d+.-]*$/,O=/^\//,_=/^\/\//;function w(C,r){if(!C.scheme&&r)throw new Error(`[UriError]: Scheme is missing: {scheme: "", authority: "${C.authority}", path: "${C.path}", query: "${C.query}", fragment: "${C.fragment}"}`);if(C.scheme&&!M.test(C.scheme))throw new Error("[UriError]: Scheme contains illegal characters.");if(C.path){if(C.authority){if(!O.test(C.path))throw new Error('[UriError]: If a URI contains an authority component, then the path component must either be empty or begin with a slash ("/") character')}else if(_.test(C.path))throw new Error('[UriError]: If a URI does not contain an authority component, then the path cannot begin with two slash characters ("//")')}}function g(C,r){return!C&&!r?"file":C}function d(C,r){switch(C){case"https":case"http":case"file":r?r[0]!==F&&(r=F+r):r=F;break}return r}const f="",F="/",l=/^(([^:/?#]+?):)?(\/\/([^/?#]*))?([^?#]*)(\?([^#]*))?(#(.*))?/;class s{constructor(r,n,a,u,m,W=!1){typeof r=="object"?(this.scheme=r.scheme||f,this.authority=r.authority||f,this.path=r.path||f,this.query=r.query||f,this.fragment=r.fragment||f):(this.scheme=g(r,W),this.authority=n||f,this.path=d(this.scheme,a||f),this.query=u||f,this.fragment=m||f,w(this,W))}static isUri(r){return r instanceof s?!0:r?typeof r.authority=="string"&&typeof r.fragment=="string"&&typeof r.path=="string"&&typeof r.query=="string"&&typeof r.scheme=="string"&&typeof r.fsPath=="string"&&typeof r.with=="function"&&typeof r.toString=="function":!1}get fsPath(){return o(this,!1)}with(r){if(!r)return this;let{scheme:n,authority:a,path:u,query:m,fragment:W}=r;return n===void 0?n=this.scheme:n===null&&(n=f),a===void 0?a=this.authority:a===null&&(a=f),u===void 0?u=this.path:u===null&&(u=f),m===void 0?m=this.query:m===null&&(m=f),W===void 0?W=this.fragment:W===null&&(W=f),n===this.scheme&&a===this.authority&&u===this.path&&m===this.query&&W===this.fragment?this:new p(n,a,u,m,W)}static parse(r,n=!1){const a=l.exec(r);return a?new p(a[2]||f,A(a[4]||f),A(a[5]||f),A(a[7]||f),A(a[9]||f),n):new p(f,f,f,f,f)}static file(r){let n=f;if(i.isWindows&&(r=r.replace(/\\/g,F)),r[0]===F&&r[1]===F){const a=r.indexOf(F,2);a===-1?(n=r.substring(2),r=F):(n=r.substring(2,a),r=r.substring(a)||F)}return new p("file",n,r,f,f)}static from(r){const n=new p(r.scheme,r.authority,r.path,r.query,r.fragment);return w(n,!0),n}static joinPath(r,...n){if(!r.path)throw new Error("[UriError]: cannot call joinPath on URI without path");let a;return i.isWindows&&r.scheme==="file"?a=s.file(E.win32.join(o(r,!0),...n)).path:a=E.posix.join(r.path,...n),r.with({path:a})}toString(r=!1){return c(this,r)}toJSON(){return this}static revive(r){if(r){if(r instanceof s)return r;{const n=new p(r);return n._formatted=r.external,n._fsPath=r._sep===e?r.fsPath:null,n}}else return r}}t.URI=s;const e=i.isWindows?1:void 0;class p extends s{constructor(){super(...arguments);this._formatted=null,this._fsPath=null}get fsPath(){return this._fsPath||(this._fsPath=o(this,!1)),this._fsPath}toString(r=!1){return r?c(this,!0):(this._formatted||(this._formatted=c(this,!1)),this._formatted)}toJSON(){const r={$mid:1};return this._fsPath&&(r.fsPath=this._fsPath,r._sep=e),this._formatted&&(r.external=this._formatted),this.path&&(r.path=this.path),this.scheme&&(r.scheme=this.scheme),this.authority&&(r.authority=this.authority),this.query&&(r.query=this.query),this.fragment&&(r.fragment=this.fragment),r}}const v={[58]:"%3A",[47]:"%2F",[63]:"%3F",[35]:"%23",[91]:"%5B",[93]:"%5D",[64]:"%40",[33]:"%21",[36]:"%24",[38]:"%26",[39]:"%27",[40]:"%28",[41]:"%29",[42]:"%2A",[43]:"%2B",[44]:"%2C",[59]:"%3B",[61]:"%3D",[32]:"%20"};function D(C,r){let n,a=-1;for(let u=0;u<C.length;u++){const m=C.charCodeAt(u);if(m>=97&&m<=122||m>=65&&m<=90||m>=48&&m<=57||m===45||m===46||m===95||m===126||r&&m===47)a!==-1&&(n+=encodeURIComponent(C.substring(a,u)),a=-1),n!==void 0&&(n+=C.charAt(u));else{n===void 0&&(n=C.substr(0,u));const W=v[m];W!==void 0?(a!==-1&&(n+=encodeURIComponent(C.substring(a,u)),a=-1),n+=W):a===-1&&(a=u)}}return a!==-1&&(n+=encodeURIComponent(C.substring(a))),n!==void 0?n:C}function y(C){let r;for(let n=0;n<C.length;n++){const a=C.charCodeAt(n);a===35||a===63?(r===void 0&&(r=C.substr(0,n)),r+=v[a]):r!==void 0&&(r+=C[n])}return r!==void 0?r:C}function o(C,r){let n;return C.authority&&C.path.length>1&&C.scheme==="file"?n=`//${C.authority}${C.path}`:C.path.charCodeAt(0)===47&&(C.path.charCodeAt(1)>=65&&C.path.charCodeAt(1)<=90||C.path.charCodeAt(1)>=97&&C.path.charCodeAt(1)<=122)&&C.path.charCodeAt(2)===58?r?n=C.path.substr(1):n=C.path[1].toLowerCase()+C.path.substr(2):n=C.path,i.isWindows&&(n=n.replace(/\//g,"\\")),n}t.uriToFsPath=o;function c(C,r){const n=r?y:D;let a="",{scheme:u,authority:m,path:W,query:V,fragment:ne}=C;if(u&&(a+=u,a+=":"),(m||u==="file")&&(a+=F,a+=F),m){let re=m.indexOf("@");if(re!==-1){const we=m.substr(0,re);m=m.substr(re+1),re=we.indexOf(":"),re===-1?a+=n(we,!1):(a+=n(we.substr(0,re),!1),a+=":",a+=n(we.substr(re+1),!1)),a+="@"}m=m.toLowerCase(),re=m.indexOf(":"),re===-1?a+=n(m,!1):(a+=n(m.substr(0,re),!1),a+=m.substr(re))}if(W){if(W.length>=3&&W.charCodeAt(0)===47&&W.charCodeAt(2)===58){const re=W.charCodeAt(1);re>=65&&re<=90&&(W=`/${String.fromCharCode(re+32)}:${W.substr(3)}`)}else if(W.length>=2&&W.charCodeAt(1)===58){const re=W.charCodeAt(0);re>=65&&re<=90&&(W=`${String.fromCharCode(re+32)}:${W.substr(2)}`)}a+=n(W,!0)}return V&&(a+="?",a+=n(V,!1)),ne&&(a+="#",a+=r?ne:D(ne,!1)),a}function b(C){try{return decodeURIComponent(C)}catch{return C.length>3?C.substr(0,3)+b(C.substr(3)):C}}const S=/(%[0-9A-Za-z][0-9A-Za-z])+/g;function A(C){return C.match(S)?C.replace(S,r=>b(r)):C}}),define(me[49],pe([1,0,31,10,16]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function O(d){return JSON.stringify(d,w)}t.stringify=O;function _(d){let f=JSON.parse(d);return f=g(f),f}t.parse=_;function w(d,f){return f instanceof RegExp?{$mid:2,source:f.source,flags:(0,i.regExpFlags)(f)}:f}function g(d,f=0){if(!d||f>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return M.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof E.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let F=0;F<d.length;++F)d[F]=g(d[F],f+1);else for(const F in d)Object.hasOwnProperty.call(d,F)&&(d[F]=g(d[F],f+1))}return d}t.revive=g}),define(me[35],pe([1,0,5,16]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileAccess=t.RemoteAuthorities=t.connectionTokenQueryName=t.connectionTokenCookieName=t.Schemas=void 0;var M;(function(w){w.inMemory="inmemory",w.vscode="vscode",w.internal="private",w.walkThrough="walkThrough",w.walkThroughSnippet="walkThroughSnippet",w.http="http",w.https="https",w.file="file",w.mailto="mailto",w.untitled="untitled",w.data="data",w.command="command",w.vscodeRemote="vscode-remote",w.vscodeRemoteResource="vscode-remote-resource",w.vscodeUserData="vscode-userdata",w.vscodeCustomEditor="vscode-custom-editor",w.vscodeNotebook="vscode-notebook",w.vscodeNotebookCell="vscode-notebook-cell",w.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",w.vscodeNotebookCellOutput="vscode-notebook-cell-output",w.vscodeInteractive="vscode-interactive",w.vscodeInteractiveInput="vscode-interactive-input",w.vscodeSettings="vscode-settings",w.vscodeWorkspaceTrust="vscode-workspace-trust",w.vscodeTerminal="vscode-terminal",w.webviewPanel="webview-panel",w.vscodeWebview="vscode-webview",w.extension="extension",w.vscodeFileResource="vscode-file",w.tmp="tmp",w.vsls="vsls",w.vscodeSourceControl="vscode-scm"})(M=t.Schemas||(t.Schemas={})),t.connectionTokenCookieName="vscode-tkn",t.connectionTokenQueryName="tkn";class O{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${M.vscodeRemoteResource}`}setPreferredWebSchema(g){this._preferredWebSchema=g}setDelegate(g){this._delegate=g}setServerRootPath(g){this._remoteResourcesPath=`${g}/${M.vscodeRemoteResource}`}set(g,d,f){this._hosts[g]=d,this._ports[g]=f}setConnectionToken(g,d){this._connectionTokens[g]=d}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(g){if(this._delegate)return this._delegate(g);const d=g.authority;let f=this._hosts[d];f&&f.indexOf(":")!==-1&&(f=`[${f}]`);const F=this._ports[d],l=this._connectionTokens[d];let s=`path=${encodeURIComponent(g.path)}`;return typeof l=="string"&&(s+=`&${t.connectionTokenQueryName}=${encodeURIComponent(l)}`),i.URI.from({scheme:E.isWeb?this._preferredWebSchema:M.vscodeRemoteResource,authority:`${f}:${F}`,path:this._remoteResourcesPath,query:s})}}t.RemoteAuthorities=new O;class _{asBrowserUri(g,d){const f=this.toUri(g,d);return f.scheme===M.vscodeRemote?t.RemoteAuthorities.rewrite(f):f.scheme===M.file&&(E.isNative||E.isWebWorker&&E.globals.origin===`${M.vscodeFileResource}://${_.FALLBACK_AUTHORITY}`)?f.with({scheme:M.vscodeFileResource,authority:f.authority||_.FALLBACK_AUTHORITY,query:null,fragment:null}):f}asFileUri(g,d){const f=this.toUri(g,d);return f.scheme===M.vscodeFileResource?f.with({scheme:M.file,authority:f.authority!==_.FALLBACK_AUTHORITY?f.authority:null,query:null,fragment:null}):f}toUri(g,d){return i.URI.isUri(g)?g:i.URI.parse(d.toUrl(g))}}_.FALLBACK_AUTHORITY="vscode-app",t.FileAccess=new _}),define(me[36],pe([1,0,109,35,21,5,10,16]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalResource=t.DataUri=t.distinctParents=t.addTrailingPathSeparator=t.removeTrailingPathSeparator=t.hasTrailingPathSeparator=t.isEqualAuthority=t.isAbsolutePath=t.resolvePath=t.relativePath=t.normalizePath=t.joinPath=t.dirname=t.extname=t.basename=t.basenameOrAuthority=t.getComparisonKey=t.isEqualOrParent=t.isEqual=t.extUriIgnorePathCase=t.extUriBiasedIgnorePathCase=t.extUri=t.ExtUri=t.originalFSPath=void 0;function g(s){return(0,w.uriToFsPath)(s,!0)}t.originalFSPath=g;class d{constructor(e){this._ignorePathCasing=e}compare(e,p,v=!1){return e===p?0:(0,_.compare)(this.getComparisonKey(e,v),this.getComparisonKey(p,v))}isEqual(e,p,v=!1){return e===p?!0:!e||!p?!1:this.getComparisonKey(e,v)===this.getComparisonKey(p,v)}getComparisonKey(e,p=!1){return e.with({path:this._ignorePathCasing(e)?e.path.toLowerCase():void 0,fragment:p?null:void 0}).toString()}ignorePathCasing(e){return this._ignorePathCasing(e)}isEqualOrParent(e,p,v=!1){if(e.scheme===p.scheme){if(e.scheme===i.Schemas.file)return E.isEqualOrParent(g(e),g(p),this._ignorePathCasing(e))&&e.query===p.query&&(v||e.fragment===p.fragment);if((0,t.isEqualAuthority)(e.authority,p.authority))return E.isEqualOrParent(e.path,p.path,this._ignorePathCasing(e),"/")&&e.query===p.query&&(v||e.fragment===p.fragment)}return!1}joinPath(e,...p){return w.URI.joinPath(e,...p)}basenameOrAuthority(e){return(0,t.basename)(e)||e.authority}basename(e){return M.posix.basename(e.path)}extname(e){return M.posix.extname(e.path)}dirname(e){if(e.path.length===0)return e;let p;return e.scheme===i.Schemas.file?p=w.URI.file(M.dirname(g(e))).path:(p=M.posix.dirname(e.path),e.authority&&p.length&&p.charCodeAt(0)!==47&&(console.error(`dirname("${e.toString})) resulted in a relative path`),p="/")),e.with({path:p})}normalizePath(e){if(!e.path.length)return e;let p;return e.scheme===i.Schemas.file?p=w.URI.file(M.normalize(g(e))).path:p=M.posix.normalize(e.path),e.with({path:p})}relativePath(e,p){if(e.scheme!==p.scheme||!(0,t.isEqualAuthority)(e.authority,p.authority))return;if(e.scheme===i.Schemas.file){const y=M.relative(g(e),g(p));return O.isWindows?E.toSlashes(y):y}let v=e.path||"/";const D=p.path||"/";if(this._ignorePathCasing(e)){let y=0;for(const o=Math.min(v.length,D.length);y<o&&!(v.charCodeAt(y)!==D.charCodeAt(y)&&v.charAt(y).toLowerCase()!==D.charAt(y).toLowerCase());y++);v=D.substr(0,y)+v.substr(y)}return M.posix.relative(v,D)}resolvePath(e,p){if(e.scheme===i.Schemas.file){const v=w.URI.file(M.resolve(g(e),p));return e.with({authority:v.authority,path:v.path})}return p=E.toPosixPath(p),e.with({path:M.posix.resolve(e.path,p)})}isAbsolutePath(e){return!!e.path&&e.path[0]==="/"}isEqualAuthority(e,p){return e===p||e!==void 0&&p!==void 0&&(0,_.equalsIgnoreCase)(e,p)}hasTrailingPathSeparator(e,p=M.sep){if(e.scheme===i.Schemas.file){const v=g(e);return v.length>E.getRoot(v).length&&v[v.length-1]===p}else{const v=e.path;return v.length>1&&v.charCodeAt(v.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(e.fsPath)}}removeTrailingPathSeparator(e,p=M.sep){return(0,t.hasTrailingPathSeparator)(e,p)?e.with({path:e.path.substr(0,e.path.length-1)}):e}addTrailingPathSeparator(e,p=M.sep){let v=!1;if(e.scheme===i.Schemas.file){const D=g(e);v=D!==void 0&&D.length===E.getRoot(D).length&&D[D.length-1]===p}else{p="/";const D=e.path;v=D.length===1&&D.charCodeAt(D.length-1)===47}return!v&&!(0,t.hasTrailingPathSeparator)(e,p)?e.with({path:e.path+"/"}):e}}t.ExtUri=d,t.extUri=new d(()=>!1),t.extUriBiasedIgnorePathCase=new d(s=>s.scheme===i.Schemas.file?!O.isLinux:!0),t.extUriIgnorePathCase=new d(s=>!0),t.isEqual=t.extUri.isEqual.bind(t.extUri),t.isEqualOrParent=t.extUri.isEqualOrParent.bind(t.extUri),t.getComparisonKey=t.extUri.getComparisonKey.bind(t.extUri),t.basenameOrAuthority=t.extUri.basenameOrAuthority.bind(t.extUri),t.basename=t.extUri.basename.bind(t.extUri),t.extname=t.extUri.extname.bind(t.extUri),t.dirname=t.extUri.dirname.bind(t.extUri),t.joinPath=t.extUri.joinPath.bind(t.extUri),t.normalizePath=t.extUri.normalizePath.bind(t.extUri),t.relativePath=t.extUri.relativePath.bind(t.extUri),t.resolvePath=t.extUri.resolvePath.bind(t.extUri),t.isAbsolutePath=t.extUri.isAbsolutePath.bind(t.extUri),t.isEqualAuthority=t.extUri.isEqualAuthority.bind(t.extUri),t.hasTrailingPathSeparator=t.extUri.hasTrailingPathSeparator.bind(t.extUri),t.removeTrailingPathSeparator=t.extUri.removeTrailingPathSeparator.bind(t.extUri),t.addTrailingPathSeparator=t.extUri.addTrailingPathSeparator.bind(t.extUri);function f(s,e){const p=[];for(let v=0;v<s.length;v++){const D=e(s[v]);s.some((y,o)=>o===v?!1:(0,t.isEqualOrParent)(D,e(y)))||p.push(s[v])}return p}t.distinctParents=f;var F;(function(s){s.META_DATA_LABEL="label",s.META_DATA_DESCRIPTION="description",s.META_DATA_SIZE="size",s.META_DATA_MIME="mime";function e(p){const v=new Map;p.path.substring(p.path.indexOf(";")+1,p.path.lastIndexOf(";")).split(";").forEach(o=>{const[c,b]=o.split(":");c&&b&&v.set(c,b)});const y=p.path.substring(0,p.path.indexOf(";"));return y&&v.set(s.META_DATA_MIME,y),v}s.parseMetaData=e})(F=t.DataUri||(t.DataUri={}));function l(s,e,p){if(e){let v=s.path;return v&&v[0]!==M.posix.sep&&(v=M.posix.sep+v),s.with({scheme:p,authority:e,path:v})}return s.with({scheme:p})}t.toLocalResource=l}),define(me[8],pe([1,0,28,13,3,2,36,5]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createCancelableAsyncIterable=t.CancelableAsyncIterableObject=t.AsyncIterableObject=t.Promises=t.DeferredPromise=t.IntervalCounter=t.TaskSequentializer=t.retry=t.IdleValue=t.runWhenIdle=t.ThrottledWorker=t.RunOnceWorker=t.ProcessTimeRunOnceScheduler=t.RunOnceScheduler=t.IntervalTimer=t.TimeoutTimer=t.ResourceQueue=t.Queue=t.Limiter=t.firstParallel=t.first=t.sequence=t.disposableTimeout=t.timeout=t.AutoOpenBarrier=t.Barrier=t.ThrottledDelayer=t.Delayer=t.MicrotaskDelay=t.SequencerByKey=t.Sequencer=t.Throttler=t.asPromise=t.raceTimeout=t.raceCancellablePromises=t.raceCancellationError=t.raceCancellation=t.createCancelablePromise=t.isThenable=void 0;function g(G){return!!G&&typeof G.then=="function"}t.isThenable=g;function d(G){const B=new E.CancellationTokenSource,h=G(B.token),I=new Promise((U,K)=>{const Q=B.token.onCancellationRequested(()=>{Q.dispose(),B.dispose(),K(new i.CancellationError)});Promise.resolve(h).then(N=>{Q.dispose(),B.dispose(),U(N)},N=>{Q.dispose(),B.dispose(),K(N)})});return new class{cancel(){B.cancel()}then(U,K){return I.then(U,K)}catch(U){return this.then(void 0,U)}finally(U){return I.finally(U)}}}t.createCancelablePromise=d;function f(G,B,h){return new Promise((I,U)=>{const K=B.onCancellationRequested(()=>{K.dispose(),I(h)});G.then(I,U).finally(()=>K.dispose())})}t.raceCancellation=f;function F(G,B){return new Promise((h,I)=>{const U=B.onCancellationRequested(()=>{U.dispose(),I(new i.CancellationError)});G.then(h,I).finally(()=>U.dispose())})}t.raceCancellationError=F;async function l(G){let B=-1;const h=G.map((U,K)=>U.then(Q=>(B=K,Q))),I=await Promise.race(h);return G.forEach((U,K)=>{K!==B&&U.cancel()}),I}t.raceCancellablePromises=l;function s(G,B,h){let I;const U=setTimeout(()=>{I?.(void 0),h?.()},B);return Promise.race([G.finally(()=>clearTimeout(U)),new Promise(K=>I=K)])}t.raceTimeout=s;function e(G){return new Promise((B,h)=>{const I=G();g(I)?I.then(B,h):B(I)})}t.asPromise=e;class p{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(B){if(this.activePromise){if(this.queuedPromiseFactory=B,!this.queuedPromise){const h=()=>{this.queuedPromise=null;const I=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,I};this.queuedPromise=new Promise(I=>{this.activePromise.then(h,h).then(I)})}return new Promise((h,I)=>{this.queuedPromise.then(h,I)})}return this.activePromise=B(),new Promise((h,I)=>{this.activePromise.then(U=>{this.activePromise=null,h(U)},U=>{this.activePromise=null,I(U)})})}}t.Throttler=p;class v{constructor(){this.current=Promise.resolve(null)}queue(B){return this.current=this.current.then(()=>B(),()=>B())}}t.Sequencer=v;class D{constructor(){this.promiseMap=new Map}queue(B,h){const U=(this.promiseMap.get(B)??Promise.resolve()).catch(()=>{}).then(h).finally(()=>{this.promiseMap.get(B)===U&&this.promiseMap.delete(B)});return this.promiseMap.set(B,U),U}}t.SequencerByKey=D;const y=(G,B)=>{let h=!0;const I=setTimeout(()=>{h=!1,B()},G);return{isTriggered:()=>h,dispose:()=>{clearTimeout(I),h=!1}}},o=G=>{let B=!0;return queueMicrotask(()=>{B&&(B=!1,G())}),{isTriggered:()=>B,dispose:()=>{B=!1}}};t.MicrotaskDelay=Symbol("MicrotaskDelay");class c{constructor(B){this.defaultDelay=B,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(B,h=this.defaultDelay){this.task=B,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((U,K)=>{this.doResolve=U,this.doReject=K}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const U=this.task;return this.task=null,U()}}));const I=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=h===t.MicrotaskDelay?o(I):y(h,I),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new i.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}t.Delayer=c;class b{constructor(B){this.delayer=new c(B),this.throttler=new p}trigger(B,h){return this.delayer.trigger(()=>this.throttler.queue(B),h)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}t.ThrottledDelayer=b;class S{constructor(){this._isOpen=!1,this._promise=new Promise((B,h)=>{this._completePromise=B})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}t.Barrier=S;class A extends S{constructor(B){super();this._timeout=setTimeout(()=>this.open(),B)}open(){clearTimeout(this._timeout),super.open()}}t.AutoOpenBarrier=A;function C(G,B){return B?new Promise((h,I)=>{const U=setTimeout(()=>{K.dispose(),h()},G),K=B.onCancellationRequested(()=>{clearTimeout(U),K.dispose(),I(new i.CancellationError)})}):d(h=>C(G,h))}t.timeout=C;function r(G,B=0){const h=setTimeout(G,B);return(0,O.toDisposable)(()=>clearTimeout(h))}t.disposableTimeout=r;function n(G){const B=[];let h=0;const I=G.length;function U(){return h<I?G[h++]():null}function K(Q){Q!=null&&B.push(Q);const N=U();return N?N.then(K):Promise.resolve(B)}return Promise.resolve(null).then(K)}t.sequence=n;function a(G,B=I=>!!I,h=null){let I=0;const U=G.length,K=()=>{if(I>=U)return Promise.resolve(h);const Q=G[I++];return Promise.resolve(Q()).then(R=>B(R)?Promise.resolve(R):K())};return K()}t.first=a;function u(G,B=I=>!!I,h=null){if(G.length===0)return Promise.resolve(h);let I=G.length;const U=()=>{I=-1;for(const K of G)K.cancel?.()};return new Promise((K,Q)=>{for(const N of G)N.then(R=>{--I>=0&&B(R)?(U(),K(R)):I===0&&K(h)}).catch(R=>{--I>=0&&(U(),Q(R))})})}t.firstParallel=u;class m{constructor(B){this._size=0,this.maxDegreeOfParalellism=B,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new M.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(B){return this._size++,new Promise((h,I)=>{this.outstandingPromises.push({factory:B,c:h,e:I}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const B=this.outstandingPromises.shift();this.runningPromises++;const h=B.factory();h.then(B.c,B.e),h.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}t.Limiter=m;class W extends m{constructor(){super(1)}}t.Queue=W;class V{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const B=new te;return this.drainers.add(B),B.p}isDrained(){for(const[,B]of this.queues)if(B.size>0)return!1;return!0}queueFor(B,h=_.extUri){const I=h.getComparisonKey(B);let U=this.queues.get(I);return U||(U=new W,M.Event.once(U.onDrained)(()=>{U?.dispose(),this.queues.delete(I),this.onDidQueueDrain()}),this.queues.set(I,U)),U}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const B of this.drainers)B.complete();this.drainers.clear()}dispose(){for(const[,B]of this.queues)B.dispose();this.queues.clear(),this.releaseDrainers()}}t.ResourceQueue=V;class ne{constructor(B,h){this._token=-1,typeof B=="function"&&typeof h=="number"&&this.setIfNotSet(B,h)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(B,h){this.cancel(),this._token=setTimeout(()=>{this._token=-1,B()},h)}setIfNotSet(B,h){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,B()},h))}}t.TimeoutTimer=ne;class re{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(B,h){this.cancel(),this._token=setInterval(()=>{B()},h)}}t.IntervalTimer=re;class we{constructor(B,h){this.timeoutToken=-1,this.runner=B,this.timeout=h,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(B=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,B)}get delay(){return this.timeout}set delay(B){this.timeout=B}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}t.RunOnceScheduler=we;class ae{constructor(B,h){h%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${h}ms is not a multiple of 1000ms.`),this.runner=B,this.timeout=h,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(B=this.timeout){B%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${B}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(B/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}t.ProcessTimeRunOnceScheduler=ae;class ve extends we{constructor(B,h){super(B,h);this.units=[]}work(B){this.units.push(B),this.isScheduled()||this.schedule()}doRun(){const B=this.units;this.units=[],this.runner?.(B)}dispose(){this.units=[],super.dispose()}}t.RunOnceWorker=ve;class ue extends O.Disposable{constructor(B,h){super();this.options=B,this.handler=h,this.pendingWork=[],this.throttler=this._register(new O.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(B){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+B.length>this.options.maxBufferedWork)return!1}else if(this.pending+B.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...B),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new we(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}t.ThrottledWorker=ue,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?t.runWhenIdle=G=>{(0,w.setTimeout0)(()=>{if(B)return;const h=Date.now()+15;G(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,h-Date.now())}}))});let B=!1;return{dispose(){B||(B=!0)}}}:t.runWhenIdle=(G,B)=>{const h=requestIdleCallback(G,typeof B=="number"?{timeout:B}:void 0);let I=!1;return{dispose(){I||(I=!0,cancelIdleCallback(h))}}}}();class ge{constructor(B){this._didRun=!1,this._executor=()=>{try{this._value=B()}catch(h){this._error=h}finally{this._didRun=!0}},this._handle=(0,t.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}t.IdleValue=ge;async function ye(G,B,h){let I;for(let U=0;U<h;U++)try{return await G()}catch(K){I=K,await C(B)}throw I}t.retry=ye;class ee{hasPending(B){return this._pending?typeof B=="number"?this._pending.taskId===B:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(B,h,I){return this._pending={taskId:B,cancel:()=>I?.(),promise:h},h.then(()=>this.donePending(B),()=>this.donePending(B)),h}donePending(B){this._pending&&B===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const B=this._next;this._next=void 0,B.run().then(B.promiseResolve,B.promiseReject)}}setNext(B){if(this._next)this._next.run=B;else{let h,I;const U=new Promise((K,Q)=>{h=K,I=Q});this._next={run:B,promise:U,promiseResolve:h,promiseReject:I}}return this._next.promise}}t.TaskSequentializer=ee;class fe{constructor(B,h=()=>Date.now()){this.interval=B,this.nowFn=h,this.lastIncrementTime=0,this.value=0}increment(){const B=this.nowFn();return B-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=B,this.value=0),this.value++,this.value}}t.IntervalCounter=fe;class te{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((B,h)=>{this.completeCallback=B,this.errorCallback=h})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(B){return new Promise(h=>{this.completeCallback(B),this.resolved=!0,h()})}error(B){return new Promise(h=>{this.errorCallback(B),this.rejected=!0,h()})}cancel(){new Promise(B=>{this.errorCallback(new i.CancellationError),this.rejected=!0,B()})}}t.DeferredPromise=te;var X;(function(G){async function B(I){let U;const K=await Promise.all(I.map(Q=>Q.then(N=>N,N=>{U||(U=N)})));if(typeof U!="undefined")throw U;return K}G.settled=B;function h(I){return new Promise(async(U,K)=>{try{await I(U,K)}catch(Q){K(Q)}})}G.withAsyncBody=h})(X=t.Promises||(t.Promises={}));var se;(function(G){G[G.Initial=0]="Initial",G[G.DoneOK=1]="DoneOK",G[G.DoneError=2]="DoneError"})(se||(se={}));class ie{constructor(B){this._state=0,this._results=[],this._error=null,this._onStateChanged=new M.Emitter,queueMicrotask(async()=>{const h={emitOne:I=>this.emitOne(I),emitMany:I=>this.emitMany(I),reject:I=>this.reject(I)};try{await Promise.resolve(B(h)),this.resolve()}catch(I){this.reject(I)}finally{h.emitOne=void 0,h.emitMany=void 0,h.reject=void 0}})}static fromArray(B){return new ie(h=>{h.emitMany(B)})}static fromPromise(B){return new ie(async h=>{h.emitMany(await B)})}static fromPromises(B){return new ie(async h=>{await Promise.all(B.map(async I=>h.emitOne(await I)))})}static merge(B){return new ie(async h=>{await Promise.all(B.map(async I=>{for await(const U of I)h.emitOne(U)}))})}[Symbol.asyncIterator](){let B=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(B<this._results.length)return{done:!1,value:this._results[B++]};if(this._state===1)return{done:!0,value:void 0};await M.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(B,h){return new ie(async I=>{for await(const U of B)I.emitOne(h(U))})}map(B){return ie.map(this,B)}static filter(B,h){return new ie(async I=>{for await(const U of B)h(U)&&I.emitOne(U)})}filter(B){return ie.filter(this,B)}static coalesce(B){return ie.filter(B,h=>!!h)}coalesce(){return ie.coalesce(this)}static async toPromise(B){const h=[];for await(const I of B)h.push(I);return h}toPromise(){return ie.toPromise(this)}emitOne(B){this._state===0&&(this._results.push(B),this._onStateChanged.fire())}emitMany(B){this._state===0&&(this._results=this._results.concat(B),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(B){this._state===0&&(this._state=2,this._error=B,this._onStateChanged.fire())}}t.AsyncIterableObject=ie,ie.EMPTY=ie.fromArray([]);class L extends ie{constructor(B,h){super(h);this._source=B}cancel(){this._source.cancel()}}t.CancelableAsyncIterableObject=L;function $(G){const B=new E.CancellationTokenSource,h=G(B.token);return new L(B,async I=>{const U=B.token.onCancellationRequested(()=>{U.dispose(),B.dispose(),I.reject(new i.CancellationError)});try{for await(const K of h){if(B.token.isCancellationRequested)return;I.emitOne(K)}U.dispose(),B.dispose()}catch(K){U.dispose(),B.dispose(),I.reject(K)}})}t.createCancelableAsyncIterable=$}),define(me[4],pe([1,0,15,107,19,20,8,13,3,112,2,35,5,6,16]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s,e){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.h=t.computeClippingRect=t.DragAndDropObserver=t.getCookieValue=t.ModifierKeyEmitter=t.multibyteAwareBtoa=t.safeInnerHtml=t.hookDomPurifyHrefAndSrcSanitizer=t.detectFullscreen=t.DetectedFullscreenMode=t.triggerUpload=t.triggerDownload=t.asCSSPropertyValue=t.asCSSUrl=t.animate=t.windowOpenWithSuccess=t.windowOpenPopup=t.windowOpenNoOpener=t.computeScreenAwareSize=t.domContentLoaded=t.finalHandler=t.removeTabIndexAndUpdateFocus=t.hide=t.show=t.join=t.$=t.Namespace=t.reset=t.prepend=t.append=t.after=t.trackFocus=t.restoreParentsScrollTop=t.saveParentsScrollTop=t.EventHelper=t.EventType=t.isHTMLElement=t.removeCSSRulesContainingSelector=t.createCSSRule=t.createMetaElement=t.createStyleSheet=t.getActiveElement=t.getShadowRoot=t.isInShadowDOM=t.isShadowRoot=t.hasParentWithClass=t.findParentWithClass=t.isAncestorUsingFlowTo=t.setParentFlowTo=t.isAncestor=t.getLargestChildWidth=t.getTotalHeight=t.getContentHeight=t.getTotalScrollWidth=t.getContentWidth=t.getTotalWidth=t.getDomNodeZoomLevel=t.getDomNodePagePosition=t.position=t.size=t.getTopLeftOffset=t.Dimension=t.getClientArea=t.getComputedStyle=t.addDisposableThrottledListener=t.modify=t.measure=t.scheduleAtNextAnimationFrame=t.runAtThisOrScheduleAtNextAnimationFrame=t.createEventEmitter=t.addDisposableGenericMouseUpListener=t.addDisposableGenericMouseMoveListener=t.addDisposableGenericMouseDownListener=t.addStandardDisposableGenericMouseUpListener=t.addStandardDisposableGenericMouseDownListener=t.addStandardDisposableListener=t.addDisposableListener=t.isInDOM=t.clearNode=void 0;function p(Y){Y.replaceChildren()}t.clearNode=p;function v(Y){return Y?.isConnected??!1}t.isInDOM=v;class D{constructor(j,ce,Ae,Fe){this._node=j,this._type=ce,this._handler=Ae,this._options=Fe||!1,this._node.addEventListener(this._type,this._handler,this._options)}dispose(){!this._handler||(this._node.removeEventListener(this._type,this._handler,this._options),this._node=null,this._handler=null)}}function y(Y,j,ce,Ae){return new D(Y,j,ce,Ae)}t.addDisposableListener=y;function o(Y){return function(j){return Y(new O.StandardMouseEvent(j))}}function c(Y){return function(j){return Y(new M.StandardKeyboardEvent(j))}}const b=function(j,ce,Ae,Fe){let ze=Ae;return ce==="click"||ce==="mousedown"?ze=o(Ae):(ce==="keydown"||ce==="keypress"||ce==="keyup")&&(ze=c(Ae)),y(j,ce,ze,Fe)};t.addStandardDisposableListener=b;const S=function(j,ce,Ae){const Fe=o(ce);return C(j,Fe,Ae)};t.addStandardDisposableGenericMouseDownListener=S;const A=function(j,ce,Ae){const Fe=o(ce);return n(j,Fe,Ae)};t.addStandardDisposableGenericMouseUpListener=A;function C(Y,j,ce){return y(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_DOWN:t.EventType.MOUSE_DOWN,j,ce)}t.addDisposableGenericMouseDownListener=C;function r(Y,j,ce){return y(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_MOVE:t.EventType.MOUSE_MOVE,j,ce)}t.addDisposableGenericMouseMoveListener=r;function n(Y,j,ce){return y(Y,l.isIOS&&i.BrowserFeatures.pointerEvents?t.EventType.POINTER_UP:t.EventType.MOUSE_UP,j,ce)}t.addDisposableGenericMouseUpListener=n;function a(Y,j,ce){let Ae=null;const Fe=Ye=>xe.fire(Ye),ze=()=>{Ae||(Ae=new D(Y,j,Fe,ce))},We=()=>{Ae&&(Ae.dispose(),Ae=null)},xe=new g.Emitter({onFirstListenerAdd:ze,onLastListenerRemove:We});return xe}t.createEventEmitter=a;let u=null;function m(Y){if(!u){const j=ce=>setTimeout(()=>ce(new Date().getTime()),0);u=self.requestAnimationFrame||self.msRequestAnimationFrame||self.webkitRequestAnimationFrame||self.mozRequestAnimationFrame||self.oRequestAnimationFrame||j}return u.call(self,Y)}class W{constructor(j,ce=0){this._runner=j,this.priority=ce,this._canceled=!1}dispose(){this._canceled=!0}execute(){if(!this._canceled)try{this._runner()}catch(j){(0,w.onUnexpectedError)(j)}}static sort(j,ce){return ce.priority-j.priority}}(function(){let Y=[],j=null,ce=!1,Ae=!1;const Fe=()=>{for(ce=!1,j=Y,Y=[],Ae=!0;j.length>0;)j.sort(W.sort),j.shift().execute();Ae=!1};t.scheduleAtNextAnimationFrame=(ze,We=0)=>{const xe=new W(ze,We);return Y.push(xe),ce||(ce=!0,m(Fe)),xe},t.runAtThisOrScheduleAtNextAnimationFrame=(ze,We)=>{if(Ae){const xe=new W(ze,We);return j.push(xe),xe}else return(0,t.scheduleAtNextAnimationFrame)(ze,We)}})();function V(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,1e4)}t.measure=V;function ne(Y){return(0,t.scheduleAtNextAnimationFrame)(Y,-1e4)}t.modify=ne;const re=8,we=function(Y,j){return j};class ae extends f.Disposable{constructor(j,ce,Ae,Fe=we,ze=re){super();let We=null,xe=0;const Ye=this._register(new _.TimeoutTimer),ft=()=>{xe=new Date().getTime(),Ae(We),We=null};this._register(y(j,ce,It=>{We=Fe(We,It);const gt=new Date().getTime()-xe;gt>=ze?(Ye.cancel(),ft()):Ye.setIfNotSet(ft,ze-gt)}))}}function ve(Y,j,ce,Ae,Fe){return new ae(Y,j,ce,Ae,Fe)}t.addDisposableThrottledListener=ve;function ue(Y){return document.defaultView.getComputedStyle(Y,null)}t.getComputedStyle=ue;function ge(Y){if(Y!==document.body)return new ee(Y.clientWidth,Y.clientHeight);if(l.isIOS&&window.visualViewport)return new ee(window.visualViewport.width,window.visualViewport.height);if(window.innerWidth&&window.innerHeight)return new ee(window.innerWidth,window.innerHeight);if(document.body&&document.body.clientWidth&&document.body.clientHeight)return new ee(document.body.clientWidth,document.body.clientHeight);if(document.documentElement&&document.documentElement.clientWidth&&document.documentElement.clientHeight)return new ee(document.documentElement.clientWidth,document.documentElement.clientHeight);throw new Error("Unable to figure out browser width and height")}t.getClientArea=ge;class ye{static convertToPixels(j,ce){return parseFloat(ce)||0}static getDimension(j,ce,Ae){const Fe=ue(j),ze=Fe?Fe.getPropertyValue(ce):"0";return ye.convertToPixels(j,ze)}static getBorderLeftWidth(j){return ye.getDimension(j,"border-left-width","borderLeftWidth")}static getBorderRightWidth(j){return ye.getDimension(j,"border-right-width","borderRightWidth")}static getBorderTopWidth(j){return ye.getDimension(j,"border-top-width","borderTopWidth")}static getBorderBottomWidth(j){return ye.getDimension(j,"border-bottom-width","borderBottomWidth")}static getPaddingLeft(j){return ye.getDimension(j,"padding-left","paddingLeft")}static getPaddingRight(j){return ye.getDimension(j,"padding-right","paddingRight")}static getPaddingTop(j){return ye.getDimension(j,"padding-top","paddingTop")}static getPaddingBottom(j){return ye.getDimension(j,"padding-bottom","paddingBottom")}static getMarginLeft(j){return ye.getDimension(j,"margin-left","marginLeft")}static getMarginTop(j){return ye.getDimension(j,"margin-top","marginTop")}static getMarginRight(j){return ye.getDimension(j,"margin-right","marginRight")}static getMarginBottom(j){return ye.getDimension(j,"margin-bottom","marginBottom")}}class ee{constructor(j,ce){this.width=j,this.height=ce}with(j=this.width,ce=this.height){return j!==this.width||ce!==this.height?new ee(j,ce):this}static is(j){return typeof j=="object"&&typeof j.height=="number"&&typeof j.width=="number"}static lift(j){return j instanceof ee?j:new ee(j.width,j.height)}static equals(j,ce){return j===ce?!0:!j||!ce?!1:j.width===ce.width&&j.height===ce.height}}t.Dimension=ee,ee.None=new ee(0,0);function fe(Y){let j=Y.offsetParent,ce=Y.offsetTop,Ae=Y.offsetLeft;for(;(Y=Y.parentNode)!==null&&Y!==document.body&&Y!==document.documentElement;){ce-=Y.scrollTop;const Fe=k(Y)?null:ue(Y);Fe&&(Ae-=Fe.direction!=="rtl"?Y.scrollLeft:-Y.scrollLeft),Y===j&&(Ae+=ye.getBorderLeftWidth(Y),ce+=ye.getBorderTopWidth(Y),ce+=Y.offsetTop,Ae+=Y.offsetLeft,j=Y.offsetParent)}return{left:Ae,top:ce}}t.getTopLeftOffset=fe;function te(Y,j,ce){typeof j=="number"&&(Y.style.width=`${j}px`),typeof ce=="number"&&(Y.style.height=`${ce}px`)}t.size=te;function X(Y,j,ce,Ae,Fe,ze="absolute"){typeof j=="number"&&(Y.style.top=`${j}px`),typeof ce=="number"&&(Y.style.right=`${ce}px`),typeof Ae=="number"&&(Y.style.bottom=`${Ae}px`),typeof Fe=="number"&&(Y.style.left=`${Fe}px`),Y.style.position=ze}t.position=X;function se(Y){const j=Y.getBoundingClientRect();return{left:j.left+window.scrollX,top:j.top+window.scrollY,width:j.width,height:j.height}}t.getDomNodePagePosition=se;function ie(Y){let j=Y,ce=1;do{const Ae=ue(j).zoom;Ae!=null&&Ae!=="1"&&(ce*=Ae),j=j.parentElement}while(j!==null&&j!==document.documentElement);return ce}t.getDomNodeZoomLevel=ie;function L(Y){const j=ye.getMarginLeft(Y)+ye.getMarginRight(Y);return Y.offsetWidth+j}t.getTotalWidth=L;function $(Y){const j=ye.getBorderLeftWidth(Y)+ye.getBorderRightWidth(Y),ce=ye.getPaddingLeft(Y)+ye.getPaddingRight(Y);return Y.offsetWidth-j-ce}t.getContentWidth=$;function G(Y){const j=ye.getMarginLeft(Y)+ye.getMarginRight(Y);return Y.scrollWidth+j}t.getTotalScrollWidth=G;function B(Y){const j=ye.getBorderTopWidth(Y)+ye.getBorderBottomWidth(Y),ce=ye.getPaddingTop(Y)+ye.getPaddingBottom(Y);return Y.offsetHeight-j-ce}t.getContentHeight=B;function h(Y){const j=ye.getMarginTop(Y)+ye.getMarginBottom(Y);return Y.offsetHeight+j}t.getTotalHeight=h;function I(Y,j){if(Y===null)return 0;const ce=fe(Y),Ae=fe(j);return ce.left-Ae.left}function U(Y,j){const ce=j.map(Fe=>Math.max(G(Fe),L(Fe))+I(Fe,Y)||0);return Math.max(...ce)}t.getLargestChildWidth=U;function K(Y,j){for(;Y;){if(Y===j)return!0;Y=Y.parentNode}return!1}t.isAncestor=K;const Q="parentFlowToElementId";function N(Y,j){Y.dataset[Q]=j.id}t.setParentFlowTo=N;function R(Y){const j=Y.dataset[Q];return typeof j=="string"?document.getElementById(j):null}function z(Y,j){let ce=Y;for(;ce;){if(ce===j)return!0;if(ce instanceof HTMLElement){const Ae=R(ce);if(Ae){ce=Ae;continue}}ce=ce.parentNode}return!1}t.isAncestorUsingFlowTo=z;function T(Y,j,ce){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y.classList.contains(j))return Y;if(ce){if(typeof ce=="string"){if(Y.classList.contains(ce))return null}else if(Y===ce)return null}Y=Y.parentNode}return null}t.findParentWithClass=T;function H(Y,j,ce){return!!T(Y,j,ce)}t.hasParentWithClass=H;function k(Y){return Y&&!!Y.host&&!!Y.mode}t.isShadowRoot=k;function P(Y){return!!x(Y)}t.isInShadowDOM=P;function x(Y){for(;Y.parentNode;){if(Y===document.body)return null;Y=Y.parentNode}return k(Y)?Y:null}t.getShadowRoot=x;function J(){let Y=document.activeElement;for(;Y?.shadowRoot;)Y=Y.shadowRoot.activeElement;return Y}t.getActiveElement=J;function he(Y=document.getElementsByTagName("head")[0]){const j=document.createElement("style");return j.type="text/css",j.media="screen",Y.appendChild(j),j}t.createStyleSheet=he;function de(Y=document.getElementsByTagName("head")[0]){const j=document.createElement("meta");return Y.appendChild(j),j}t.createMetaElement=de;let Ee=null;function _e(){return Ee||(Ee=he()),Ee}function ke(Y){return Y?.sheet?.rules?Y.sheet.rules:Y?.sheet?.cssRules?Y.sheet.cssRules:[]}function Ie(Y,j,ce=_e()){!ce||!j||ce.sheet.insertRule(Y+"{"+j+"}",0)}t.createCSSRule=Ie;function De(Y,j=_e()){if(!j)return;const ce=ke(j),Ae=[];for(let Fe=0;Fe<ce.length;Fe++)ce[Fe].selectorText.indexOf(Y)!==-1&&Ae.push(Fe);for(let Fe=Ae.length-1;Fe>=0;Fe--)j.sheet.deleteRule(Ae[Fe])}t.removeCSSRulesContainingSelector=De;function Pe(Y){return typeof HTMLElement=="object"?Y instanceof HTMLElement:Y&&typeof Y=="object"&&Y.nodeType===1&&typeof Y.nodeName=="string"}t.isHTMLElement=Pe,t.EventType={CLICK:"click",AUXCLICK:"auxclick",DBLCLICK:"dblclick",MOUSE_UP:"mouseup",MOUSE_DOWN:"mousedown",MOUSE_OVER:"mouseover",MOUSE_MOVE:"mousemove",MOUSE_OUT:"mouseout",MOUSE_ENTER:"mouseenter",MOUSE_LEAVE:"mouseleave",MOUSE_WHEEL:"wheel",POINTER_UP:"pointerup",POINTER_DOWN:"pointerdown",POINTER_MOVE:"pointermove",POINTER_LEAVE:"pointerleave",CONTEXT_MENU:"contextmenu",WHEEL:"wheel",KEY_DOWN:"keydown",KEY_PRESS:"keypress",KEY_UP:"keyup",LOAD:"load",BEFORE_UNLOAD:"beforeunload",UNLOAD:"unload",PAGE_SHOW:"pageshow",PAGE_HIDE:"pagehide",ABORT:"abort",ERROR:"error",RESIZE:"resize",SCROLL:"scroll",FULLSCREEN_CHANGE:"fullscreenchange",WK_FULLSCREEN_CHANGE:"webkitfullscreenchange",SELECT:"select",CHANGE:"change",SUBMIT:"submit",RESET:"reset",FOCUS:"focus",FOCUS_IN:"focusin",FOCUS_OUT:"focusout",BLUR:"blur",INPUT:"input",STORAGE:"storage",DRAG_START:"dragstart",DRAG:"drag",DRAG_ENTER:"dragenter",DRAG_LEAVE:"dragleave",DRAG_OVER:"dragover",DROP:"drop",DRAG_END:"dragend",ANIMATION_START:E.isWebKit?"webkitAnimationStart":"animationstart",ANIMATION_END:E.isWebKit?"webkitAnimationEnd":"animationend",ANIMATION_ITERATION:E.isWebKit?"webkitAnimationIteration":"animationiteration"},t.EventHelper={stop:function(Y,j){Y.preventDefault(),j&&Y.stopPropagation()}};function Me(Y){const j=[];for(let ce=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ce++)j[ce]=Y.scrollTop,Y=Y.parentNode;return j}t.saveParentsScrollTop=Me;function Ge(Y,j){for(let ce=0;Y&&Y.nodeType===Y.ELEMENT_NODE;ce++)Y.scrollTop!==j[ce]&&(Y.scrollTop=j[ce]),Y=Y.parentNode}t.restoreParentsScrollTop=Ge;class He extends f.Disposable{constructor(j){super();this._onDidFocus=this._register(new g.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new g.Emitter),this.onDidBlur=this._onDidBlur.event;let ce=He.hasFocusWithin(j),Ae=!1;const Fe=()=>{Ae=!1,ce||(ce=!0,this._onDidFocus.fire())},ze=()=>{ce&&(Ae=!0,window.setTimeout(()=>{Ae&&(Ae=!1,ce=!1,this._onDidBlur.fire())},0))};this._refreshStateHandler=()=>{He.hasFocusWithin(j)!==ce&&(ce?ze():Fe())},this._register(y(j,t.EventType.FOCUS,Fe,!0)),this._register(y(j,t.EventType.BLUR,ze,!0)),this._register(y(j,t.EventType.FOCUS_IN,()=>this._refreshStateHandler())),this._register(y(j,t.EventType.FOCUS_OUT,()=>this._refreshStateHandler()))}static hasFocusWithin(j){const ce=x(j),Ae=ce?ce.activeElement:document.activeElement;return K(Ae,j)}refreshState(){this._refreshStateHandler()}}function Ue(Y){return new He(Y)}t.trackFocus=Ue;function Qe(Y,j){return Y.after(j),j}t.after=Qe;function je(Y,...j){if(Y.append(...j),j.length===1&&typeof j[0]!="string")return j[0]}t.append=je;function Oe(Y,j){return Y.insertBefore(j,Y.firstChild),j}t.prepend=Oe;function q(Y,...j){Y.innerText="",je(Y,...j)}t.reset=q;const oe=/([\w\-]+)?(#([\w\-]+))?((\.([\w\-]+))*)/;var be;(function(Y){Y.HTML="http://www.w3.org/1999/xhtml",Y.SVG="http://www.w3.org/2000/svg"})(be=t.Namespace||(t.Namespace={}));function Ce(Y,j,ce,...Ae){const Fe=oe.exec(j);if(!Fe)throw new Error("Bad use of emmet");ce={...ce||{}};const ze=Fe[1]||"div";let We;return Y!==be.HTML?We=document.createElementNS(Y,ze):We=document.createElement(ze),Fe[3]&&(We.id=Fe[3]),Fe[4]&&(We.className=Fe[4].replace(/\./g," ").trim()),Object.keys(ce).forEach(xe=>{const Ye=ce[xe];typeof Ye!="undefined"&&(/^on\w+$/.test(xe)?We[xe]=Ye:xe==="selected"?Ye&&We.setAttribute(xe,"true"):We.setAttribute(xe,Ye))}),We.append(...Ae),We}function Te(Y,j,...ce){return Ce(be.HTML,Y,j,...ce)}t.$=Te,Te.SVG=function(Y,j,...ce){return Ce(be.SVG,Y,j,...ce)};function Re(Y,j){const ce=[];return Y.forEach((Ae,Fe)=>{Fe>0&&(j instanceof Node?ce.push(j.cloneNode()):ce.push(document.createTextNode(j))),ce.push(Ae)}),ce}t.join=Re;function $e(...Y){for(const j of Y)j.style.display="",j.removeAttribute("aria-hidden")}t.show=$e;function tt(...Y){for(const j of Y)j.style.display="none",j.setAttribute("aria-hidden","true")}t.hide=tt;function Xe(Y,j){for(;Y&&Y.nodeType===Y.ELEMENT_NODE;){if(Y instanceof HTMLElement&&Y.hasAttribute(j))return Y;Y=Y.parentNode}return null}function qe(Y){!Y||!Y.hasAttribute("tabIndex")||(document.activeElement===Y&&Xe(Y.parentElement,"tabIndex")?.focus(),Y.removeAttribute("tabindex"))}t.removeTabIndexAndUpdateFocus=qe;function Le(Y){return j=>{j.preventDefault(),j.stopPropagation(),Y(j)}}t.finalHandler=Le;function le(){return new Promise(Y=>{document.readyState==="complete"||document&&document.body!==null?Y(void 0):window.addEventListener("DOMContentLoaded",Y,!1)})}t.domContentLoaded=le;function Se(Y){const j=window.devicePixelRatio*Y;return Math.max(1,Math.floor(j))/window.devicePixelRatio}t.computeScreenAwareSize=Se;function Ne(Y){window.open(Y,"_blank","noopener")}t.windowOpenNoOpener=Ne;const Ve=780,Ze=640;function Je(Y){const j=Math.floor(window.screenLeft+window.innerWidth/2-Ve/2),ce=Math.floor(window.screenTop+window.innerHeight/2-Ze/2);window.open(Y,"_blank",`width=${Ve},height=${Ze},top=${ce},left=${j}`)}t.windowOpenPopup=Je;function et(Y,j=!0){const ce=window.open();return ce?(j&&(ce.opener=null),ce.location.href=Y,!0):!1}t.windowOpenWithSuccess=et;function st(Y){const j=()=>{Y(),ce=(0,t.scheduleAtNextAnimationFrame)(j)};let ce=(0,t.scheduleAtNextAnimationFrame)(j);return(0,f.toDisposable)(()=>ce.dispose())}t.animate=st,F.RemoteAuthorities.setPreferredWebSchema(/^https:/.test(window.location.href)?"https":"http");function ht(Y){return Y?`url('${F.FileAccess.asBrowserUri(Y).toString(!0).replace(/'/g,"%27")}')`:"url('')"}t.asCSSUrl=ht;function Dt(Y){return`'${Y.replace(/'/g,"%27")}'`}t.asCSSPropertyValue=Dt;function Ft(Y,j){let ce;if(e.URI.isUri(Y))ce=Y.toString(!0);else{const Fe=new Blob([Y]);ce=URL.createObjectURL(Fe),setTimeout(()=>URL.revokeObjectURL(ce))}const Ae=document.createElement("a");document.body.appendChild(Ae),Ae.download=j,Ae.href=ce,Ae.click(),setTimeout(()=>document.body.removeChild(Ae))}t.triggerDownload=Ft;function zt(){return new Promise(Y=>{const j=document.createElement("input");document.body.appendChild(j),j.type="file",j.multiple=!0,g.Event.once(g.Event.fromDOMEventEmitter(j,"input"))(()=>{Y((0,s.withNullAsUndefined)(j.files))}),j.click(),setTimeout(()=>document.body.removeChild(j))})}t.triggerUpload=zt;var yt;(function(Y){Y[Y.DOCUMENT=1]="DOCUMENT",Y[Y.BROWSER=2]="BROWSER"})(yt=t.DetectedFullscreenMode||(t.DetectedFullscreenMode={}));function hi(){return document.fullscreenElement||document.webkitFullscreenElement||document.webkitIsFullScreen?{mode:yt.DOCUMENT,guess:!1}:window.innerHeight===screen.height?{mode:yt.BROWSER,guess:!1}:(l.isMacintosh||l.isLinux)&&window.outerHeight===screen.height&&window.outerWidth===screen.width?{mode:yt.BROWSER,guess:!0}:null}t.detectFullscreen=hi;function Ut(Y,j=!1){const ce=document.createElement("a");return d.addHook("afterSanitizeAttributes",Ae=>{for(const Fe of["href","src"])if(Ae.hasAttribute(Fe)){const ze=Ae.getAttribute(Fe);if(Fe==="href"&&ze.startsWith("#"))continue;if(ce.href=ze,!Y.includes(ce.protocol.replace(/:$/,""))){if(j&&Fe==="src"&&ce.href.startsWith("data:"))continue;Ae.removeAttribute(Fe)}}}),(0,f.toDisposable)(()=>{d.removeHook("afterSanitizeAttributes")})}t.hookDomPurifyHrefAndSrcSanitizer=Ut;const di=[F.Schemas.http,F.Schemas.https,F.Schemas.command];function fi(Y,j){const ce={ALLOWED_TAGS:["a","button","blockquote","code","div","h1","h2","h3","h4","h5","h6","hr","input","label","li","p","pre","select","small","span","strong","textarea","ul","ol"],ALLOWED_ATTR:["href","data-href","data-command","target","title","name","src","alt","class","id","role","tabindex","style","data-code","width","height","align","x-dispatch","required","checked","placeholder","type"],RETURN_DOM:!1,RETURN_DOM_FRAGMENT:!1},Ae=Ut(di);try{const Fe=d.sanitize(j,{...ce,RETURN_TRUSTED_TYPE:!0});Y.innerHTML=Fe}finally{Ae.dispose()}}t.safeInnerHtml=fi;function gi(Y){const j=new Uint16Array(Y.length);for(let Fe=0;Fe<j.length;Fe++)j[Fe]=Y.charCodeAt(Fe);let ce="";const Ae=new Uint8Array(j.buffer);for(let Fe=0;Fe<Ae.length;Fe++)ce+=String.fromCharCode(Ae[Fe]);return ce}function mi(Y){return btoa(gi(Y))}t.multibyteAwareBtoa=mi;class dt extends g.Emitter{constructor(){super();this._subscriptions=new f.DisposableStore,this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1},this._subscriptions.add(y(window,"keydown",j=>{if(j.defaultPrevented)return;const ce=new M.StandardKeyboardEvent(j);if(!(ce.keyCode===6&&j.repeat)){if(j.altKey&&!this._keyStatus.altKey)this._keyStatus.lastKeyPressed="alt";else if(j.ctrlKey&&!this._keyStatus.ctrlKey)this._keyStatus.lastKeyPressed="ctrl";else if(j.metaKey&&!this._keyStatus.metaKey)this._keyStatus.lastKeyPressed="meta";else if(j.shiftKey&&!this._keyStatus.shiftKey)this._keyStatus.lastKeyPressed="shift";else if(ce.keyCode!==6)this._keyStatus.lastKeyPressed=void 0;else return;this._keyStatus.altKey=j.altKey,this._keyStatus.ctrlKey=j.ctrlKey,this._keyStatus.metaKey=j.metaKey,this._keyStatus.shiftKey=j.shiftKey,this._keyStatus.lastKeyPressed&&(this._keyStatus.event=j,this.fire(this._keyStatus))}},!0)),this._subscriptions.add(y(window,"keyup",j=>{j.defaultPrevented||(!j.altKey&&this._keyStatus.altKey?this._keyStatus.lastKeyReleased="alt":!j.ctrlKey&&this._keyStatus.ctrlKey?this._keyStatus.lastKeyReleased="ctrl":!j.metaKey&&this._keyStatus.metaKey?this._keyStatus.lastKeyReleased="meta":!j.shiftKey&&this._keyStatus.shiftKey?this._keyStatus.lastKeyReleased="shift":this._keyStatus.lastKeyReleased=void 0,this._keyStatus.lastKeyPressed!==this._keyStatus.lastKeyReleased&&(this._keyStatus.lastKeyPressed=void 0),this._keyStatus.altKey=j.altKey,this._keyStatus.ctrlKey=j.ctrlKey,this._keyStatus.metaKey=j.metaKey,this._keyStatus.shiftKey=j.shiftKey,this._keyStatus.lastKeyReleased&&(this._keyStatus.event=j,this.fire(this._keyStatus)))},!0)),this._subscriptions.add(y(document.body,"mousedown",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(y(document.body,"mouseup",()=>{this._keyStatus.lastKeyPressed=void 0},!0)),this._subscriptions.add(y(document.body,"mousemove",j=>{j.buttons&&(this._keyStatus.lastKeyPressed=void 0)},!0)),this._subscriptions.add(y(window,"blur",()=>{this.resetKeyStatus()}))}get keyStatus(){return this._keyStatus}get isModifierPressed(){return this._keyStatus.altKey||this._keyStatus.ctrlKey||this._keyStatus.metaKey||this._keyStatus.shiftKey}resetKeyStatus(){this.doResetKeyStatus(),this.fire(this._keyStatus)}doResetKeyStatus(){this._keyStatus={altKey:!1,shiftKey:!1,ctrlKey:!1,metaKey:!1}}static getInstance(){return dt.instance||(dt.instance=new dt),dt.instance}dispose(){super.dispose(),this._subscriptions.dispose()}}t.ModifierKeyEmitter=dt;function pi(Y){const j=document.cookie.match("(^|[^;]+)\\s*"+Y+"\\s*=\\s*([^;]+)");return j?j.pop():void 0}t.getCookieValue=pi;class bi extends f.Disposable{constructor(j,ce){super();this.element=j,this.callbacks=ce,this.counter=0,this.dragStartTime=0,this.registerListeners()}registerListeners(){this._register(y(this.element,t.EventType.DRAG_ENTER,j=>{this.counter++,this.dragStartTime=j.timeStamp,this.callbacks.onDragEnter(j)})),this._register(y(this.element,t.EventType.DRAG_OVER,j=>{j.preventDefault(),this.callbacks.onDragOver?.(j,j.timeStamp-this.dragStartTime)})),this._register(y(this.element,t.EventType.DRAG_LEAVE,j=>{this.counter--,this.counter===0&&(this.dragStartTime=0,this.callbacks.onDragLeave(j))})),this._register(y(this.element,t.EventType.DRAG_END,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDragEnd(j)})),this._register(y(this.element,t.EventType.DROP,j=>{this.counter=0,this.dragStartTime=0,this.callbacks.onDrop(j)}))}}t.DragAndDropObserver=bi;function wi(Y,j){const ce=Y instanceof HTMLElement?Y.getBoundingClientRect():Y,Ae=j.getBoundingClientRect(),Fe=Math.max(Ae.top-ce.top,0),ze=Math.max(ce.width-(ce.right-Ae.right),0),We=Math.max(ce.height-(ce.bottom-Ae.bottom),0),xe=Math.max(Ae.left-ce.left,0);return{top:Fe,right:ze,bottom:We,left:xe}}t.computeClippingRect=wi;const vi=/(?<tag>[\w\-]+)?(?:#(?<id>[\w\-]+))?(?<class>(?:\.(?:[\w\-]+))*)(?:@(?<name>(?:[\w\_])+))?/;function Di(Y,...j){let ce,Ae;Array.isArray(j[0])?(ce={},Ae=j[0]):(ce=j[0]||{},Ae=j[1]);const Fe=vi.exec(Y);if(!Fe||!Fe.groups)throw new Error("Bad use of h");const ze=Fe.groups.tag||"div",We=document.createElement(ze);Fe.groups.id&&(We.id=Fe.groups.id),Fe.groups.class&&(We.className=Fe.groups.class.replace(/\./g," ").trim());const xe={};if(Fe.groups.name&&(xe[Fe.groups.name]=We),Ae)for(const Ye of Ae)Ye instanceof HTMLElement?We.appendChild(Ye):typeof Ye=="string"?We.append(Ye):(Object.assign(xe,Ye),We.appendChild(Ye.root));for(const[Ye,ft]of Object.entries(ce))if(Ye==="style")for(const[It,gt]of Object.entries(ft))We.style.setProperty(Vt(It),typeof gt=="number"?gt+"px":""+gt);else Ye==="tabIndex"?We.tabIndex=ft:We.setAttribute(Vt(Ye),ft.toString());return xe.root=We,xe}t.h=Di;function Vt(Y){return Y.replace(/([a-z])([A-Z])/g,"$1-$2").toLowerCase()}}),define(me[50],pe([1,0,4,2,105]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.applyDragImage=t.DataTransfers=t.DelayedDragHandler=void 0;class O extends i.Disposable{constructor(g,d){super();this._register((0,E.addDisposableListener)(g,"dragover",f=>{f.preventDefault(),this.timeout||(this.timeout=setTimeout(()=>{d(),this.timeout=null},800))})),["dragleave","drop","dragend"].forEach(f=>{this._register((0,E.addDisposableListener)(g,f,()=>{this.clearDragTimeout()}))})}clearDragTimeout(){this.timeout&&(clearTimeout(this.timeout),this.timeout=null)}dispose(){super.dispose(),this.clearDragTimeout()}}t.DelayedDragHandler=O,t.DataTransfers={RESOURCES:"ResourceURLs",DOWNLOAD_URL:"DownloadURL",FILES:"Files",TEXT:M.Mimes.text};function _(w,g,d){const f=document.createElement("div");f.className=d,f.textContent=g,w.dataTransfer&&(document.body.appendChild(f),w.dataTransfer.setDragImage(f,-10,-10),setTimeout(()=>document.body.removeChild(f),0))}t.applyDragImage=_}),define(me[51],pe([1,0,4]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createElement=t.renderFormattedText=t.renderText=void 0;function i(l,s={}){const e=O(s);return e.textContent=l,e}t.renderText=i;function M(l,s={}){const e=O(s);return g(e,d(l,!!s.renderCodeSegments),s.actionHandler,s.renderCodeSegments),e}t.renderFormattedText=M;function O(l){const s=l.inline?"span":"div",e=document.createElement(s);return l.className&&(e.className=l.className),e}t.createElement=O;class _{constructor(s){this.source=s,this.index=0}eos(){return this.index>=this.source.length}next(){const s=this.peek();return this.advance(),s}peek(){return this.source[this.index]}advance(){this.index++}}var w;(function(l){l[l.Invalid=0]="Invalid",l[l.Root=1]="Root",l[l.Text=2]="Text",l[l.Bold=3]="Bold",l[l.Italics=4]="Italics",l[l.Action=5]="Action",l[l.ActionClose=6]="ActionClose",l[l.Code=7]="Code",l[l.NewLine=8]="NewLine"})(w||(w={}));function g(l,s,e,p){let v;if(s.type===2)v=document.createTextNode(s.content||"");else if(s.type===3)v=document.createElement("b");else if(s.type===4)v=document.createElement("i");else if(s.type===7&&p)v=document.createElement("code");else if(s.type===5&&e){const D=document.createElement("a");e.disposables.add(E.addStandardDisposableListener(D,"click",y=>{e.callback(String(s.index),y)})),v=D}else s.type===8?v=document.createElement("br"):s.type===1&&(v=l);v&&l!==v&&l.appendChild(v),v&&Array.isArray(s.children)&&s.children.forEach(D=>{g(v,D,e,p)})}function d(l,s){const e={type:1,children:[]};let p=0,v=e;const D=[],y=new _(l);for(;!y.eos();){let o=y.next();const c=o==="\\"&&F(y.peek(),s)!==0;if(c&&(o=y.next()),!c&&f(o,s)&&o===y.peek()){y.advance(),v.type===2&&(v=D.pop());const b=F(o,s);if(v.type===b||v.type===5&&b===6)v=D.pop();else{const S={type:b,children:[]};b===5&&(S.index=p,p++),v.children.push(S),D.push(v),v=S}}else if(o===`
`)v.type===2&&(v=D.pop()),v.children.push({type:8});else if(v.type!==2){const b={type:2,content:o};v.children.push(b),D.push(v),v=b}else v.content+=o}return v.type===2&&(v=D.pop()),D.length,e}function f(l,s){return F(l,s)!==0}function F(l,s){switch(l){case"*":return 3;case"_":return 4;case"[":return 5;case"]":return 6;case"`":return s?7:0;default:return 0}}}),define(me[52],pe([1,0,4,2]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.GlobalPointerMoveMonitor=void 0;class M{constructor(){this._hooks=new i.DisposableStore,this._pointerMoveCallback=null,this._onStopCallback=null}dispose(){this.stopMonitoring(!1),this._hooks.dispose()}stopMonitoring(_,w){if(!this.isMonitoring())return;this._hooks.clear(),this._pointerMoveCallback=null;const g=this._onStopCallback;this._onStopCallback=null,_&&g&&g(w)}isMonitoring(){return!!this._pointerMoveCallback}startMonitoring(_,w,g,d,f){this.isMonitoring()&&this.stopMonitoring(!1),this._pointerMoveCallback=d,this._onStopCallback=f;let F=_;try{_.setPointerCapture(w),this._hooks.add((0,i.toDisposable)(()=>{_.releasePointerCapture(w)}))}catch{F=window}this._hooks.add(E.addDisposableListener(F,E.EventType.POINTER_MOVE,l=>{if(l.buttons!==g){this.stopMonitoring(!0);return}l.preventDefault(),this._pointerMoveCallback(l)})),this._hooks.add(E.addDisposableListener(F,E.EventType.POINTER_UP,l=>this.stopMonitoring(!0)))}}t.GlobalPointerMoveMonitor=M});var Ke=this&&this.__decorate||function(Z,t,E,i){var M=arguments.length,O=M<3?t:i===null?i=Object.getOwnPropertyDescriptor(t,E):i,_;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate(Z,t,E,i);else for(var w=Z.length-1;w>=0;w--)(_=Z[w])&&(O=(M<3?_(O):M>3?_(t,E,O):_(t,E))||O);return M>3&&O&&Object.defineProperty(t,E,O),O};define(me[22],pe([1,0,4,14,25,2]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Gesture=t.EventType=void 0;var _;(function(g){g.Tap="-monaco-gesturetap",g.Change="-monaco-gesturechange",g.Start="-monaco-gesturestart",g.End="-monaco-gesturesend",g.Contextmenu="-monaco-gesturecontextmenu"})(_=t.EventType||(t.EventType={}));class w extends O.Disposable{constructor(){super();this.dispatched=!1,this.activeTouches={},this.handle=null,this.targets=[],this.ignoreTargets=[],this._lastSetTapCountTime=0,this._register(E.addDisposableListener(document,"touchstart",d=>this.onTouchStart(d),{passive:!1})),this._register(E.addDisposableListener(document,"touchend",d=>this.onTouchEnd(d))),this._register(E.addDisposableListener(document,"touchmove",d=>this.onTouchMove(d),{passive:!1}))}static addTarget(d){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.targets.push(d),{dispose:()=>{w.INSTANCE.targets=w.INSTANCE.targets.filter(f=>f!==d)}}):O.Disposable.None}static ignoreTarget(d){return w.isTouchDevice()?(w.INSTANCE||(w.INSTANCE=new w),w.INSTANCE.ignoreTargets.push(d),{dispose:()=>{w.INSTANCE.ignoreTargets=w.INSTANCE.ignoreTargets.filter(f=>f!==d)}}):O.Disposable.None}static isTouchDevice(){return"ontouchstart"in window||navigator.maxTouchPoints>0}dispose(){this.handle&&(this.handle.dispose(),this.handle=null),super.dispose()}onTouchStart(d){const f=Date.now();this.handle&&(this.handle.dispose(),this.handle=null);for(let F=0,l=d.targetTouches.length;F<l;F++){const s=d.targetTouches.item(F);this.activeTouches[s.identifier]={id:s.identifier,initialTarget:s.target,initialTimeStamp:f,initialPageX:s.pageX,initialPageY:s.pageY,rollingTimestamps:[f],rollingPageX:[s.pageX],rollingPageY:[s.pageY]};const e=this.newGestureEvent(_.Start,s.target);e.pageX=s.pageX,e.pageY=s.pageY,this.dispatchEvent(e)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}onTouchEnd(d){const f=Date.now(),F=Object.keys(this.activeTouches).length;for(let l=0,s=d.changedTouches.length;l<s;l++){const e=d.changedTouches.item(l);if(!this.activeTouches.hasOwnProperty(String(e.identifier))){console.warn("move of an UNKNOWN touch",e);continue}const p=this.activeTouches[e.identifier],v=Date.now()-p.initialTimeStamp;if(v<w.HOLD_DELAY&&Math.abs(p.initialPageX-i.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-i.tail(p.rollingPageY))<30){const D=this.newGestureEvent(_.Tap,p.initialTarget);D.pageX=i.tail(p.rollingPageX),D.pageY=i.tail(p.rollingPageY),this.dispatchEvent(D)}else if(v>=w.HOLD_DELAY&&Math.abs(p.initialPageX-i.tail(p.rollingPageX))<30&&Math.abs(p.initialPageY-i.tail(p.rollingPageY))<30){const D=this.newGestureEvent(_.Contextmenu,p.initialTarget);D.pageX=i.tail(p.rollingPageX),D.pageY=i.tail(p.rollingPageY),this.dispatchEvent(D)}else if(F===1){const D=i.tail(p.rollingPageX),y=i.tail(p.rollingPageY),o=i.tail(p.rollingTimestamps)-p.rollingTimestamps[0],c=D-p.rollingPageX[0],b=y-p.rollingPageY[0],S=this.targets.filter(A=>p.initialTarget instanceof Node&&A.contains(p.initialTarget));this.inertia(S,f,Math.abs(c)/o,c>0?1:-1,D,Math.abs(b)/o,b>0?1:-1,y)}this.dispatchEvent(this.newGestureEvent(_.End,p.initialTarget)),delete this.activeTouches[e.identifier]}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}newGestureEvent(d,f){const F=document.createEvent("CustomEvent");return F.initEvent(d,!1,!0),F.initialTarget=f,F.tapCount=0,F}dispatchEvent(d){if(d.type===_.Tap){const f=new Date().getTime();let F=0;f-this._lastSetTapCountTime>w.CLEAR_TAP_COUNT_TIME?F=1:F=2,this._lastSetTapCountTime=f,d.tapCount=F}else(d.type===_.Change||d.type===_.Contextmenu)&&(this._lastSetTapCountTime=0);for(let f=0;f<this.ignoreTargets.length;f++)if(d.initialTarget instanceof Node&&this.ignoreTargets[f].contains(d.initialTarget))return;this.targets.forEach(f=>{d.initialTarget instanceof Node&&f.contains(d.initialTarget)&&(f.dispatchEvent(d),this.dispatched=!0)})}inertia(d,f,F,l,s,e,p,v){this.handle=E.scheduleAtNextAnimationFrame(()=>{const D=Date.now(),y=D-f;let o=0,c=0,b=!0;F+=w.SCROLL_FRICTION*y,e+=w.SCROLL_FRICTION*y,F>0&&(b=!1,o=l*F*y),e>0&&(b=!1,c=p*e*y);const S=this.newGestureEvent(_.Change);S.translationX=o,S.translationY=c,d.forEach(A=>A.dispatchEvent(S)),b||this.inertia(d,D,F,l,s+o,e,p,v+c)})}onTouchMove(d){const f=Date.now();for(let F=0,l=d.changedTouches.length;F<l;F++){const s=d.changedTouches.item(F);if(!this.activeTouches.hasOwnProperty(String(s.identifier))){console.warn("end of an UNKNOWN touch",s);continue}const e=this.activeTouches[s.identifier],p=this.newGestureEvent(_.Change,e.initialTarget);p.translationX=s.pageX-i.tail(e.rollingPageX),p.translationY=s.pageY-i.tail(e.rollingPageY),p.pageX=s.pageX,p.pageY=s.pageY,this.dispatchEvent(p),e.rollingPageX.length>3&&(e.rollingPageX.shift(),e.rollingPageY.shift(),e.rollingTimestamps.shift()),e.rollingPageX.push(s.pageX),e.rollingPageY.push(s.pageY),e.rollingTimestamps.push(f)}this.dispatched&&(d.preventDefault(),d.stopPropagation(),this.dispatched=!1)}}w.SCROLL_FRICTION=-.005,w.HOLD_DELAY=700,w.CLEAR_TAP_COUNT_TIME=400,Ke([M.memoize],w,"isTouchDevice",null),t.Gesture=w}),define(me[53],pe([1,0,4,5,82]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.status=t.alert=t.setARIAContainer=void 0;const M=2e4;let O,_,w,g,d;function f(e){O=document.createElement("div"),O.className="monaco-aria-container";const p=()=>{const D=document.createElement("div");return D.className="monaco-alert",D.setAttribute("role","alert"),D.setAttribute("aria-atomic","true"),O.appendChild(D),D};_=p(),w=p();const v=()=>{const D=document.createElement("div");return D.className="monaco-status",D.setAttribute("role","complementary"),D.setAttribute("aria-live","polite"),D.setAttribute("aria-atomic","true"),O.appendChild(D),D};g=v(),d=v(),e.appendChild(O)}t.setARIAContainer=f;function F(e){!O||(_.textContent!==e?(E.clearNode(w),s(_,e)):(E.clearNode(_),s(w,e)))}t.alert=F;function l(e){!O||(i.isMacintosh?F(e):g.textContent!==e?(E.clearNode(d),s(g,e)):(E.clearNode(g),s(d,e)))}t.status=l;function s(e,p){E.clearNode(e),p.length>M&&(p=p.substr(0,M)),e.textContent=p,e.style.visibility="hidden",e.style.visibility="visible"}}),define(me[113],pe([1,0,4,11]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderIcon=t.renderLabelWithIcons=void 0;const M=new RegExp(`(\\\\)?\\$\\((${i.CSSIcon.iconNameExpression}(?:${i.CSSIcon.iconModifierExpression})?)\\)`,"g");function O(w){const g=new Array;let d,f=0,F=0;for(;(d=M.exec(w))!==null;){F=d.index||0,g.push(w.substring(f,F)),f=(d.index||0)+d[0].length;const[,l,s]=d;g.push(l?`$(${s})`:_({id:s}))}return f<w.length&&g.push(w.substring(f)),g}t.renderLabelWithIcons=O;function _(w){const g=E.$("span");return g.classList.add(...i.CSSIcon.asClassNameArray(w)),g}t.renderIcon=_}),define(me[114],pe([1,0,4]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RowCache=void 0;function i(O){try{O.parentElement?.removeChild(O)}catch{}}class M{constructor(_){this.renderers=_,this.cache=new Map}alloc(_){let w=this.getTemplateCache(_).pop();if(!w){const g=(0,E.$)(".monaco-list-row"),f=this.getRenderer(_).renderTemplate(g);w={domNode:g,templateId:_,templateData:f}}return w}release(_){!_||this.releaseRow(_)}releaseRow(_){const{domNode:w,templateId:g}=_;w&&(w.classList.remove("scrolling"),i(w)),this.getTemplateCache(g).push(_)}getTemplateCache(_){let w=this.cache.get(_);return w||(w=[],this.cache.set(_,w)),w}dispose(){this.cache.forEach((_,w)=>{for(const g of _)this.getRenderer(w).disposeTemplate(g.templateData),g.templateData=null}),this.cache.clear()}getRenderer(_){const w=this.renderers.get(_);if(!w)throw new Error(`No renderer found for ${_}`);return w}}t.RowCache=M}),define(me[115],pe([1,0,8,2]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarVisibilityController=void 0;class M extends i.Disposable{constructor(_,w,g){super();this._visibility=_,this._visibleClassName=w,this._invisibleClassName=g,this._domNode=null,this._isVisible=!1,this._isNeeded=!1,this._rawShouldBeVisible=!1,this._shouldBeVisible=!1,this._revealTimer=this._register(new E.TimeoutTimer)}setVisibility(_){this._visibility!==_&&(this._visibility=_,this._updateShouldBeVisible())}setShouldBeVisible(_){this._rawShouldBeVisible=_,this._updateShouldBeVisible()}_applyVisibilitySetting(){return this._visibility===2?!1:this._visibility===3?!0:this._rawShouldBeVisible}_updateShouldBeVisible(){const _=this._applyVisibilitySetting();this._shouldBeVisible!==_&&(this._shouldBeVisible=_,this.ensureVisibility())}setIsNeeded(_){this._isNeeded!==_&&(this._isNeeded=_,this.ensureVisibility())}setDomNode(_){this._domNode=_,this._domNode.setClassName(this._invisibleClassName),this.setShouldBeVisible(!1)}ensureVisibility(){if(!this._isNeeded){this._hide(!1);return}this._shouldBeVisible?this._reveal():this._hide(!0)}_reveal(){this._isVisible||(this._isVisible=!0,this._revealTimer.setIfNotSet(()=>{this._domNode?.setClassName(this._visibleClassName)},0))}_hide(_){this._revealTimer.cancel(),!!this._isVisible&&(this._isVisible=!1,this._domNode?.setClassName(this._invisibleClassName+(_?" fade":"")))}}t.ScrollbarVisibilityController=M}),define(me[116],pe([1,0,4,22,14,3,2,5]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxNative=void 0;class g extends _.Disposable{constructor(f,F,l,s){super();this.selected=0,this.selectBoxOptions=s||Object.create(null),this.options=[],this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=this._register(new O.Emitter),this.styles=l,this.registerListeners(),this.setOptions(f,F)}registerListeners(){this._register(i.Gesture.addTarget(this.selectElement)),[i.EventType.Tap].forEach(f=>{this._register(E.addDisposableListener(this.selectElement,f,F=>{this.selectElement.focus()}))}),this._register(E.addStandardDisposableListener(this.selectElement,"click",f=>{E.EventHelper.stop(f,!0)})),this._register(E.addStandardDisposableListener(this.selectElement,"change",f=>{this.selectElement.title=f.target.value,this._onDidSelect.fire({index:f.target.selectedIndex,selected:f.target.value})})),this._register(E.addStandardDisposableListener(this.selectElement,"keydown",f=>{let F=!1;w.isMacintosh?(f.keyCode===18||f.keyCode===16||f.keyCode===10)&&(F=!0):(f.keyCode===18&&f.altKey||f.keyCode===10||f.keyCode===3)&&(F=!0),F&&f.stopPropagation()}))}get onDidSelect(){return this._onDidSelect.event}setOptions(f,F){(!this.options||!M.equals(this.options,f))&&(this.options=f,this.selectElement.options.length=0,this.options.forEach((l,s)=>{this.selectElement.add(this.createOption(l.text,s,l.isDisabled))})),F!==void 0&&this.select(F)}select(f){this.options.length===0?this.selected=0:f>=0&&f<this.options.length?this.selected=f:f>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,this.selected<this.options.length&&typeof this.options[this.selected].text=="string"?this.selectElement.title=this.options[this.selected].text:this.selectElement.title=""}setAriaLabel(f){this.selectBoxOptions.ariaLabel=f,this.selectElement.setAttribute("aria-label",f)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(f){this.selectElement.tabIndex=f?0:-1}render(f){f.classList.add("select-container"),f.appendChild(this.selectElement),this.setOptions(this.options,this.selected),this.applyStyles()}style(f){this.styles=f,this.applyStyles()}applyStyles(){if(this.selectElement){const f=this.styles.selectBackground?this.styles.selectBackground.toString():"",F=this.styles.selectForeground?this.styles.selectForeground.toString():"",l=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=f,this.selectElement.style.color=F,this.selectElement.style.borderColor=l}}createOption(f,F,l){const s=document.createElement("option");return s.value=f,s.text=f,s.disabled=!!l,s}}t.SelectBoxNative=g}),define(me[54],pe([1,0,23,14,8,111,3,26]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IndexTreeModel=t.getVisibleState=t.isFilterResult=void 0;function g(l){return typeof l=="object"&&"visibility"in l&&"data"in l}t.isFilterResult=g;function d(l){switch(l){case!0:return 1;case!1:return 0;default:return l}}t.getVisibleState=d;function f(l){return typeof l.collapsible=="boolean"}class F{constructor(s,e,p,v={}){this.user=s,this.list=e,this.rootRef=[],this.eventBufferer=new _.EventBufferer,this._onDidChangeCollapseState=new _.Emitter,this.onDidChangeCollapseState=this.eventBufferer.wrapEvent(this._onDidChangeCollapseState.event),this._onDidChangeRenderNodeCount=new _.Emitter,this.onDidChangeRenderNodeCount=this.eventBufferer.wrapEvent(this._onDidChangeRenderNodeCount.event),this._onDidSplice=new _.Emitter,this.onDidSplice=this._onDidSplice.event,this.refilterDelayer=new M.Delayer(M.MicrotaskDelay),this.collapseByDefault=typeof v.collapseByDefault=="undefined"?!1:v.collapseByDefault,this.filter=v.filter,this.autoExpandSingleChildren=typeof v.autoExpandSingleChildren=="undefined"?!1:v.autoExpandSingleChildren,this.root={parent:void 0,element:p,children:[],depth:0,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:!1,collapsed:!1,renderNodeCount:0,visibility:1,visible:!0,filterData:void 0}}splice(s,e,p=w.Iterable.empty(),v={}){if(s.length===0)throw new E.TreeError(this.user,"Invalid tree location");v.diffIdentityProvider?this.spliceSmart(v.diffIdentityProvider,s,e,p,v):this.spliceSimple(s,e,p,v)}spliceSmart(s,e,p,v=w.Iterable.empty(),D,y=D.diffDepth??0){const{parentNode:o}=this.getParentNodeWithListIndex(e);if(!o.lastDiffIds)return this.spliceSimple(e,p,v,D);const c=[...v],b=e[e.length-1],S=new O.LcsDiff({getElements:()=>o.lastDiffIds},{getElements:()=>[...o.children.slice(0,b),...c,...o.children.slice(b+p)].map(a=>s.getId(a.element).toString())}).ComputeDiff(!1);if(S.quitEarly)return o.lastDiffIds=void 0,this.spliceSimple(e,p,c,D);const A=e.slice(0,-1),C=(a,u,m)=>{if(y>0)for(let W=0;W<m;W++)a--,u--,this.spliceSmart(s,[...A,a,0],Number.MAX_SAFE_INTEGER,c[u].children,D,y-1)};let r=Math.min(o.children.length,b+p),n=c.length;for(const a of S.changes.sort((u,m)=>m.originalStart-u.originalStart))C(r,n,r-(a.originalStart+a.originalLength)),r=a.originalStart,n=a.modifiedStart-b,this.spliceSimple([...A,r],a.originalLength,w.Iterable.slice(c,n,n+a.modifiedLength),D);C(r,n,r)}spliceSimple(s,e,p=w.Iterable.empty(),{onDidCreateNode:v,onDidDeleteNode:D,diffIdentityProvider:y}){const{parentNode:o,listIndex:c,revealed:b,visible:S}=this.getParentNodeWithListIndex(s),A=[],C=w.Iterable.map(p,ae=>this.createTreeNode(ae,o,o.visible?1:0,b,A,v)),r=s[s.length-1],n=o.children.length>0;let a=0;for(let ae=r;ae>=0&&ae<o.children.length;ae--){const ve=o.children[ae];if(ve.visible){a=ve.visibleChildIndex;break}}const u=[];let m=0,W=0;for(const ae of C)u.push(ae),W+=ae.renderNodeCount,ae.visible&&(ae.visibleChildIndex=a+m++);const V=(0,i.splice)(o.children,r,e,u);y?o.lastDiffIds?(0,i.splice)(o.lastDiffIds,r,e,u.map(ae=>y.getId(ae.element).toString())):o.lastDiffIds=o.children.map(ae=>y.getId(ae.element).toString()):o.lastDiffIds=void 0;let ne=0;for(const ae of V)ae.visible&&ne++;if(ne!==0)for(let ae=r+u.length;ae<o.children.length;ae++){const ve=o.children[ae];ve.visible&&(ve.visibleChildIndex-=ne)}if(o.visibleChildrenCount+=m-ne,b&&S){const ae=V.reduce((ve,ue)=>ve+(ue.visible?ue.renderNodeCount:0),0);this._updateAncestorsRenderNodeCount(o,W-ae),this.list.splice(c,ae,A)}if(V.length>0&&D){const ae=ve=>{D(ve),ve.children.forEach(ae)};V.forEach(ae)}this._onDidSplice.fire({insertedNodes:u,deletedNodes:V});const re=o.children.length>0;n!==re&&this.setCollapsible(s.slice(0,-1),re);let we=o;for(;we;){if(we.visibility===2){this.refilterDelayer.trigger(()=>this.refilter());break}we=we.parent}}rerender(s){if(s.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{node:e,listIndex:p,revealed:v}=this.getTreeNodeWithListIndex(s);e.visible&&v&&this.list.splice(p,1,[e])}updateElementHeight(s,e){if(s.length===0)throw new E.TreeError(this.user,"Invalid tree location");const{listIndex:p}=this.getTreeNodeWithListIndex(s);this.list.updateElementHeight(p,e)}has(s){return this.hasTreeNode(s)}getListIndex(s){const{listIndex:e,visible:p,revealed:v}=this.getTreeNodeWithListIndex(s);return p&&v?e:-1}getListRenderCount(s){return this.getTreeNode(s).renderNodeCount}isCollapsible(s){return this.getTreeNode(s).collapsible}setCollapsible(s,e){const p=this.getTreeNode(s);typeof e=="undefined"&&(e=!p.collapsible);const v={collapsible:e};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,v))}isCollapsed(s){return this.getTreeNode(s).collapsed}setCollapsed(s,e,p){const v=this.getTreeNode(s);typeof e=="undefined"&&(e=!v.collapsed);const D={collapsed:e,recursive:p||!1};return this.eventBufferer.bufferEvents(()=>this._setCollapseState(s,D))}_setCollapseState(s,e){const{node:p,listIndex:v,revealed:D}=this.getTreeNodeWithListIndex(s),y=this._setListNodeCollapseState(p,v,D,e);if(p!==this.root&&this.autoExpandSingleChildren&&y&&!f(e)&&p.collapsible&&!p.collapsed&&!e.recursive){let o=-1;for(let c=0;c<p.children.length;c++)if(p.children[c].visible)if(o>-1){o=-1;break}else o=c;o>-1&&this._setCollapseState([...s,o],e)}return y}_setListNodeCollapseState(s,e,p,v){const D=this._setNodeCollapseState(s,v,!1);if(!p||!s.visible||!D)return D;const y=s.renderNodeCount,o=this.updateNodeAfterCollapseChange(s),c=y-(e===-1?0:1);return this.list.splice(e+1,c,o.slice(1)),D}_setNodeCollapseState(s,e,p){let v;if(s===this.root?v=!1:(f(e)?(v=s.collapsible!==e.collapsible,s.collapsible=e.collapsible):s.collapsible?(v=s.collapsed!==e.collapsed,s.collapsed=e.collapsed):v=!1,v&&this._onDidChangeCollapseState.fire({node:s,deep:p})),!f(e)&&e.recursive)for(const D of s.children)v=this._setNodeCollapseState(D,e,!0)||v;return v}expandTo(s){this.eventBufferer.bufferEvents(()=>{let e=this.getTreeNode(s);for(;e.parent;)e=e.parent,s=s.slice(0,s.length-1),e.collapsed&&this._setCollapseState(s,{collapsed:!1,recursive:!1})})}refilter(){const s=this.root.renderNodeCount,e=this.updateNodeAfterFilterChange(this.root);this.list.splice(0,s,e),this.refilterDelayer.cancel()}createTreeNode(s,e,p,v,D,y){const o={parent:e,element:s.element,children:[],depth:e.depth+1,visibleChildrenCount:0,visibleChildIndex:-1,collapsible:typeof s.collapsible=="boolean"?s.collapsible:typeof s.collapsed!="undefined",collapsed:typeof s.collapsed=="undefined"?this.collapseByDefault:s.collapsed,renderNodeCount:1,visibility:1,visible:!0,filterData:void 0},c=this._filterNode(o,p);o.visibility=c,v&&D.push(o);const b=s.children||w.Iterable.empty(),S=v&&c!==0&&!o.collapsed,A=w.Iterable.map(b,n=>this.createTreeNode(n,o,c,S,D,y));let C=0,r=1;for(const n of A)o.children.push(n),r+=n.renderNodeCount,n.visible&&(n.visibleChildIndex=C++);return o.collapsible=o.collapsible||o.children.length>0,o.visibleChildrenCount=C,o.visible=c===2?C>0:c===1,o.visible?o.collapsed||(o.renderNodeCount=r):(o.renderNodeCount=0,v&&D.pop()),y?.(o),o}updateNodeAfterCollapseChange(s){const e=s.renderNodeCount,p=[];return this._updateNodeAfterCollapseChange(s,p),this._updateAncestorsRenderNodeCount(s.parent,p.length-e),p}_updateNodeAfterCollapseChange(s,e){if(s.visible===!1)return 0;if(e.push(s),s.renderNodeCount=1,!s.collapsed)for(const p of s.children)s.renderNodeCount+=this._updateNodeAfterCollapseChange(p,e);return this._onDidChangeRenderNodeCount.fire(s),s.renderNodeCount}updateNodeAfterFilterChange(s){const e=s.renderNodeCount,p=[];return this._updateNodeAfterFilterChange(s,s.visible?1:0,p),this._updateAncestorsRenderNodeCount(s.parent,p.length-e),p}_updateNodeAfterFilterChange(s,e,p,v=!0){let D;if(s!==this.root){if(D=this._filterNode(s,e),D===0)return s.visible=!1,s.renderNodeCount=0,!1;v&&p.push(s)}const y=p.length;s.renderNodeCount=s===this.root?0:1;let o=!1;if(!s.collapsed||D!==0){let c=0;for(const b of s.children)o=this._updateNodeAfterFilterChange(b,D,p,v&&!s.collapsed)||o,b.visible&&(b.visibleChildIndex=c++);s.visibleChildrenCount=c}else s.visibleChildrenCount=0;return s!==this.root&&(s.visible=D===2?o:D===1,s.visibility=D),s.visible?s.collapsed||(s.renderNodeCount+=p.length-y):(s.renderNodeCount=0,v&&p.pop()),this._onDidChangeRenderNodeCount.fire(s),s.visible}_updateAncestorsRenderNodeCount(s,e){if(e!==0)for(;s;)s.renderNodeCount+=e,this._onDidChangeRenderNodeCount.fire(s),s=s.parent}_filterNode(s,e){const p=this.filter?this.filter.filter(s.element,e):1;return typeof p=="boolean"?(s.filterData=void 0,p?1:0):g(p)?(s.filterData=p.data,d(p.visibility)):(s.filterData=void 0,d(p))}hasTreeNode(s,e=this.root){if(!s||s.length===0)return!0;const[p,...v]=s;return p<0||p>e.children.length?!1:this.hasTreeNode(v,e.children[p])}getTreeNode(s,e=this.root){if(!s||s.length===0)return e;const[p,...v]=s;if(p<0||p>e.children.length)throw new E.TreeError(this.user,"Invalid tree location");return this.getTreeNode(v,e.children[p])}getTreeNodeWithListIndex(s){if(s.length===0)return{node:this.root,listIndex:-1,revealed:!0,visible:!1};const{parentNode:e,listIndex:p,revealed:v,visible:D}=this.getParentNodeWithListIndex(s),y=s[s.length-1];if(y<0||y>e.children.length)throw new E.TreeError(this.user,"Invalid tree location");const o=e.children[y];return{node:o,listIndex:p,revealed:v,visible:D&&o.visible}}getParentNodeWithListIndex(s,e=this.root,p=0,v=!0,D=!0){const[y,...o]=s;if(y<0||y>e.children.length)throw new E.TreeError(this.user,"Invalid tree location");for(let c=0;c<y;c++)p+=e.children[c].renderNodeCount;return v=v&&!e.collapsed,D=D&&e.visible,o.length===0?{parentNode:e,listIndex:p,revealed:v,visible:D}:this.getParentNodeWithListIndex(o,e.children[y],p+1,v,D)}getNode(s=[]){return this.getTreeNode(s)}getNodeLocation(s){const e=[];let p=s;for(;p.parent;)e.push(p.parent.children.indexOf(p)),p=p.parent;return e.reverse()}getParentNodeLocation(s){if(s.length!==0)return s.length===1?[]:(0,i.tail2)(s)[0]}getFirstElementChild(s){const e=this.getTreeNode(s);if(e.children.length!==0)return e.children[0].element}getLastElementAncestor(s=[]){const e=this.getTreeNode(s);if(e.children.length!==0)return this._getLastElementAncestor(e)}_getLastElementAncestor(s){return s.children.length===0?s.element:this._getLastElementAncestor(s.children[s.children.length-1])}}t.IndexTreeModel=F}),define(me[117],pe([1,0,54,23,26]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ObjectTreeModel=void 0;class O{constructor(w,g,d={}){this.user=w,this.rootRef=null,this.nodes=new Map,this.nodesByIdentity=new Map,this.model=new E.IndexTreeModel(w,g,null,d),this.onDidSplice=this.model.onDidSplice,this.onDidChangeCollapseState=this.model.onDidChangeCollapseState,this.onDidChangeRenderNodeCount=this.model.onDidChangeRenderNodeCount,d.sorter&&(this.sorter={compare(f,F){return d.sorter.compare(f.element,F.element)}}),this.identityProvider=d.identityProvider}get size(){return this.nodes.size}setChildren(w,g=M.Iterable.empty(),d={}){const f=this.getElementLocation(w);this._setChildren(f,this.preserveCollapseState(g),d)}_setChildren(w,g=M.Iterable.empty(),d){const f=new Set,F=new Set,l=e=>{if(e.element===null)return;const p=e;if(f.add(p.element),this.nodes.set(p.element,p),this.identityProvider){const v=this.identityProvider.getId(p.element).toString();F.add(v),this.nodesByIdentity.set(v,p)}d.onDidCreateNode?.(p)},s=e=>{if(e.element===null)return;const p=e;if(f.has(p.element)||this.nodes.delete(p.element),this.identityProvider){const v=this.identityProvider.getId(p.element).toString();F.has(v)||this.nodesByIdentity.delete(v)}d.onDidDeleteNode?.(p)};this.model.splice([...w,0],Number.MAX_VALUE,g,{...d,onDidCreateNode:l,onDidDeleteNode:s})}preserveCollapseState(w=M.Iterable.empty()){return this.sorter&&(w=[...w].sort(this.sorter.compare.bind(this.sorter))),M.Iterable.map(w,g=>{let d=this.nodes.get(g.element);if(!d&&this.identityProvider){const l=this.identityProvider.getId(g.element).toString();d=this.nodesByIdentity.get(l)}if(!d)return{...g,children:this.preserveCollapseState(g.children)};const f=typeof g.collapsible=="boolean"?g.collapsible:d.collapsible,F=typeof g.collapsed!="undefined"?g.collapsed:d.collapsed;return{...g,collapsible:f,collapsed:F,children:this.preserveCollapseState(g.children)}})}rerender(w){const g=this.getElementLocation(w);this.model.rerender(g)}updateElementHeight(w,g){const d=this.getElementLocation(w);this.model.updateElementHeight(d,g)}resort(w=null,g=!0){if(!this.sorter)return;const d=this.getElementLocation(w),f=this.model.getNode(d);this._setChildren(d,this.resortChildren(f,g),{})}resortChildren(w,g,d=!0){let f=[...w.children];return(g||d)&&(f=f.sort(this.sorter.compare.bind(this.sorter))),M.Iterable.map(f,F=>({element:F.element,collapsible:F.collapsible,collapsed:F.collapsed,children:this.resortChildren(F,g,!1)}))}getFirstElementChild(w=null){const g=this.getElementLocation(w);return this.model.getFirstElementChild(g)}getLastElementAncestor(w=null){const g=this.getElementLocation(w);return this.model.getLastElementAncestor(g)}has(w){return this.nodes.has(w)}getListIndex(w){const g=this.getElementLocation(w);return this.model.getListIndex(g)}getListRenderCount(w){const g=this.getElementLocation(w);return this.model.getListRenderCount(g)}isCollapsible(w){const g=this.getElementLocation(w);return this.model.isCollapsible(g)}setCollapsible(w,g){const d=this.getElementLocation(w);return this.model.setCollapsible(d,g)}isCollapsed(w){const g=this.getElementLocation(w);return this.model.isCollapsed(g)}setCollapsed(w,g,d){const f=this.getElementLocation(w);return this.model.setCollapsed(f,g,d)}expandTo(w){const g=this.getElementLocation(w);this.model.expandTo(g)}refilter(){this.model.refilter()}getNode(w=null){if(w===null)return this.model.getNode(this.model.rootRef);const g=this.nodes.get(w);if(!g)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return g}getNodeLocation(w){return w.element}getParentNodeLocation(w){if(w===null)throw new i.TreeError(this.user,"Invalid getParentNodeLocation call");const g=this.nodes.get(w);if(!g)throw new i.TreeError(this.user,`Tree element not found: ${w}`);const d=this.model.getNodeLocation(g),f=this.model.getParentNodeLocation(d);return this.model.getNode(f).element}getElementLocation(w){if(w===null)return[];const g=this.nodes.get(w);if(!g)throw new i.TreeError(this.user,`Tree element not found: ${w}`);return this.model.getNodeLocation(g)}}t.ObjectTreeModel=O}),define(me[17],pe([1,0,4,19,20,22,2]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Widget=void 0;class w extends _.Disposable{onclick(d,f){this._register(E.addDisposableListener(d,E.EventType.CLICK,F=>f(new M.StandardMouseEvent(F))))}onmousedown(d,f){this._register(E.addDisposableListener(d,E.EventType.MOUSE_DOWN,F=>f(new M.StandardMouseEvent(F))))}onmouseover(d,f){this._register(E.addDisposableListener(d,E.EventType.MOUSE_OVER,F=>f(new M.StandardMouseEvent(F))))}onmouseleave(d,f){this._register(E.addDisposableListener(d,E.EventType.MOUSE_LEAVE,F=>f(new M.StandardMouseEvent(F))))}onkeydown(d,f){this._register(E.addDisposableListener(d,E.EventType.KEY_DOWN,F=>f(new i.StandardKeyboardEvent(F))))}onkeyup(d,f){this._register(E.addDisposableListener(d,E.EventType.KEY_UP,F=>f(new i.StandardKeyboardEvent(F))))}oninput(d,f){this._register(E.addDisposableListener(d,E.EventType.INPUT,f))}onblur(d,f){this._register(E.addDisposableListener(d,E.EventType.BLUR,f))}onfocus(d,f){this._register(E.addDisposableListener(d,E.EventType.FOCUS,f))}onchange(d,f){this._register(E.addDisposableListener(d,E.EventType.CHANGE,f))}ignoreGesture(d){O.Gesture.ignoreTarget(d)}}t.Widget=w}),define(me[37],pe([1,0,52,17,8,4]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ScrollbarArrow=t.ARROW_IMG_SIZE=void 0,t.ARROW_IMG_SIZE=11;class _ extends i.Widget{constructor(g){super();this._onActivate=g.onActivate,this.bgDomNode=document.createElement("div"),this.bgDomNode.className="arrow-background",this.bgDomNode.style.position="absolute",this.bgDomNode.style.width=g.bgWidth+"px",this.bgDomNode.style.height=g.bgHeight+"px",typeof g.top!="undefined"&&(this.bgDomNode.style.top="0px"),typeof g.left!="undefined"&&(this.bgDomNode.style.left="0px"),typeof g.bottom!="undefined"&&(this.bgDomNode.style.bottom="0px"),typeof g.right!="undefined"&&(this.bgDomNode.style.right="0px"),this.domNode=document.createElement("div"),this.domNode.className=g.className,this.domNode.classList.add(...g.icon.classNamesArray),this.domNode.style.position="absolute",this.domNode.style.width=t.ARROW_IMG_SIZE+"px",this.domNode.style.height=t.ARROW_IMG_SIZE+"px",typeof g.top!="undefined"&&(this.domNode.style.top=g.top+"px"),typeof g.left!="undefined"&&(this.domNode.style.left=g.left+"px"),typeof g.bottom!="undefined"&&(this.domNode.style.bottom=g.bottom+"px"),typeof g.right!="undefined"&&(this.domNode.style.right=g.right+"px"),this._pointerMoveMonitor=this._register(new E.GlobalPointerMoveMonitor),this._register(O.addStandardDisposableListener(this.bgDomNode,O.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._register(O.addStandardDisposableListener(this.domNode,O.EventType.POINTER_DOWN,d=>this._arrowPointerDown(d))),this._pointerdownRepeatTimer=this._register(new M.IntervalTimer),this._pointerdownScheduleRepeatTimer=this._register(new M.TimeoutTimer)}_arrowPointerDown(g){if(!g.target||!(g.target instanceof Element))return;const d=()=>{this._pointerdownRepeatTimer.cancelAndSet(()=>this._onActivate(),1e3/24)};this._onActivate(),this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancelAndSet(d,200),this._pointerMoveMonitor.startMonitoring(g.target,g.pointerId,g.buttons,f=>{},()=>{this._pointerdownRepeatTimer.cancel(),this._pointerdownScheduleRepeatTimer.cancel()}),g.preventDefault()}}t.ScrollbarArrow=_}),define(me[55],pe([1,0,4,40,52,37,115,17,5]),function(Z,t,E,i,M,O,_,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractScrollbar=void 0;const d=140;class f extends w.Widget{constructor(l){super();this._lazyRender=l.lazyRender,this._host=l.host,this._scrollable=l.scrollable,this._scrollByPage=l.scrollByPage,this._scrollbarState=l.scrollbarState,this._visibilityController=this._register(new _.ScrollbarVisibilityController(l.visibility,"visible scrollbar "+l.extraScrollbarClassName,"invisible scrollbar "+l.extraScrollbarClassName)),this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._pointerMoveMonitor=this._register(new M.GlobalPointerMoveMonitor),this._shouldRender=!0,this.domNode=(0,i.createFastDomNode)(document.createElement("div")),this.domNode.setAttribute("role","presentation"),this.domNode.setAttribute("aria-hidden","true"),this._visibilityController.setDomNode(this.domNode),this.domNode.setPosition("absolute"),this._register(E.addDisposableListener(this.domNode.domNode,E.EventType.POINTER_DOWN,s=>this._domNodePointerDown(s)))}_createArrow(l){const s=this._register(new O.ScrollbarArrow(l));this.domNode.domNode.appendChild(s.bgDomNode),this.domNode.domNode.appendChild(s.domNode)}_createSlider(l,s,e,p){this.slider=(0,i.createFastDomNode)(document.createElement("div")),this.slider.setClassName("slider"),this.slider.setPosition("absolute"),this.slider.setTop(l),this.slider.setLeft(s),typeof e=="number"&&this.slider.setWidth(e),typeof p=="number"&&this.slider.setHeight(p),this.slider.setLayerHinting(!0),this.slider.setContain("strict"),this.domNode.domNode.appendChild(this.slider.domNode),this._register(E.addDisposableListener(this.slider.domNode,E.EventType.POINTER_DOWN,v=>{v.button===0&&(v.preventDefault(),this._sliderPointerDown(v))})),this.onclick(this.slider.domNode,v=>{v.leftButton&&v.stopPropagation()})}_onElementSize(l){return this._scrollbarState.setVisibleSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollSize(l){return this._scrollbarState.setScrollSize(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}_onElementScrollPosition(l){return this._scrollbarState.setScrollPosition(l)&&(this._visibilityController.setIsNeeded(this._scrollbarState.isNeeded()),this._shouldRender=!0,this._lazyRender||this.render()),this._shouldRender}beginReveal(){this._visibilityController.setShouldBeVisible(!0)}beginHide(){this._visibilityController.setShouldBeVisible(!1)}render(){!this._shouldRender||(this._shouldRender=!1,this._renderDomNode(this._scrollbarState.getRectangleLargeSize(),this._scrollbarState.getRectangleSmallSize()),this._updateSlider(this._scrollbarState.getSliderSize(),this._scrollbarState.getArrowSize()+this._scrollbarState.getSliderPosition()))}_domNodePointerDown(l){l.target===this.domNode.domNode&&this._onPointerDown(l)}delegatePointerDown(l){const s=this.domNode.domNode.getClientRects()[0].top,e=s+this._scrollbarState.getSliderPosition(),p=s+this._scrollbarState.getSliderPosition()+this._scrollbarState.getSliderSize(),v=this._sliderPointerPosition(l);e<=v&&v<=p?l.button===0&&(l.preventDefault(),this._sliderPointerDown(l)):this._onPointerDown(l)}_onPointerDown(l){let s,e;if(l.target===this.domNode.domNode&&typeof l.offsetX=="number"&&typeof l.offsetY=="number")s=l.offsetX,e=l.offsetY;else{const v=E.getDomNodePagePosition(this.domNode.domNode);s=l.pageX-v.left,e=l.pageY-v.top}const p=this._pointerDownRelativePosition(s,e);this._setDesiredScrollPositionNow(this._scrollByPage?this._scrollbarState.getDesiredScrollPositionFromOffsetPaged(p):this._scrollbarState.getDesiredScrollPositionFromOffset(p)),l.button===0&&(l.preventDefault(),this._sliderPointerDown(l))}_sliderPointerDown(l){if(!l.target||!(l.target instanceof Element))return;const s=this._sliderPointerPosition(l),e=this._sliderOrthogonalPointerPosition(l),p=this._scrollbarState.clone();this.slider.toggleClassName("active",!0),this._pointerMoveMonitor.startMonitoring(l.target,l.pointerId,l.buttons,v=>{const D=this._sliderOrthogonalPointerPosition(v),y=Math.abs(D-e);if(g.isWindows&&y>d){this._setDesiredScrollPositionNow(p.getScrollPosition());return}const c=this._sliderPointerPosition(v)-s;this._setDesiredScrollPositionNow(p.getDesiredScrollPositionFromDelta(c))},()=>{this.slider.toggleClassName("active",!1),this._host.onDragEnd()}),this._host.onDragStart()}_setDesiredScrollPositionNow(l){const s={};this.writeScrollPosition(s,l),this._scrollable.setScrollPositionNow(s)}updateScrollbarSize(l){this._updateScrollbarSize(l),this._scrollbarState.setScrollbarSize(l),this._shouldRender=!0,this._lazyRender||this.render()}isNeeded(){return this._scrollbarState.isNeeded()}}t.AbstractScrollbar=f}),define(me[118],pe([1,0,20,55,37,41,11]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HorizontalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(d,f,F){const l=d.getScrollDimensions(),s=d.getCurrentScrollPosition();super({lazyRender:f.lazyRender,host:F,scrollbarState:new O.ScrollbarState(f.horizontalHasArrows?f.arrowSize:0,f.horizontal===2?0:f.horizontalScrollbarSize,f.vertical===2?0:f.verticalScrollbarSize,l.width,l.scrollWidth,s.scrollLeft),visibility:f.horizontal,extraScrollbarClassName:"horizontal",scrollable:d,scrollByPage:f.scrollByPage});if(f.horizontalHasArrows){const e=(f.arrowSize-M.ARROW_IMG_SIZE)/2,p=(f.horizontalScrollbarSize-M.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonLeft,top:p,left:e,bottom:void 0,right:void 0,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,1,0))}),this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonRight,top:p,left:void 0,bottom:void 0,right:e,bgWidth:f.arrowSize,bgHeight:f.horizontalScrollbarSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,-1,0))})}this._createSlider(Math.floor((f.horizontalScrollbarSize-f.horizontalSliderSize)/2),0,void 0,f.horizontalSliderSize)}_updateSlider(d,f){this.slider.setWidth(d),this.slider.setLeft(f)}_renderDomNode(d,f){this.domNode.setWidth(d),this.domNode.setHeight(f),this.domNode.setLeft(0),this.domNode.setBottom(0)}onDidScroll(d){return this._shouldRender=this._onElementScrollSize(d.scrollWidth)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(d.scrollLeft)||this._shouldRender,this._shouldRender=this._onElementSize(d.width)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(d,f){return d}_sliderPointerPosition(d){return d.pageX}_sliderOrthogonalPointerPosition(d){return d.pageY}_updateScrollbarSize(d){this.slider.setHeight(d)}writeScrollPosition(d,f){d.scrollLeft=f}updateOptions(d){this.updateScrollbarSize(d.horizontal===2?0:d.horizontalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this._visibilityController.setVisibility(d.horizontal),this._scrollByPage=d.scrollByPage}}t.HorizontalScrollbar=w}),define(me[119],pe([1,0,20,55,37,41,11]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.VerticalScrollbar=void 0;class w extends i.AbstractScrollbar{constructor(d,f,F){const l=d.getScrollDimensions(),s=d.getCurrentScrollPosition();super({lazyRender:f.lazyRender,host:F,scrollbarState:new O.ScrollbarState(f.verticalHasArrows?f.arrowSize:0,f.vertical===2?0:f.verticalScrollbarSize,0,l.height,l.scrollHeight,s.scrollTop),visibility:f.vertical,extraScrollbarClassName:"vertical",scrollable:d,scrollByPage:f.scrollByPage});if(f.verticalHasArrows){const e=(f.arrowSize-M.ARROW_IMG_SIZE)/2,p=(f.verticalScrollbarSize-M.ARROW_IMG_SIZE)/2;this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonUp,top:e,left:p,bottom:void 0,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,1))}),this._createArrow({className:"scra",icon:_.Codicon.scrollbarButtonDown,top:void 0,left:p,bottom:e,right:void 0,bgWidth:f.verticalScrollbarSize,bgHeight:f.arrowSize,onActivate:()=>this._host.onMouseWheel(new E.StandardWheelEvent(null,0,-1))})}this._createSlider(0,Math.floor((f.verticalScrollbarSize-f.verticalSliderSize)/2),f.verticalSliderSize,void 0)}_updateSlider(d,f){this.slider.setHeight(d),this.slider.setTop(f)}_renderDomNode(d,f){this.domNode.setWidth(f),this.domNode.setHeight(d),this.domNode.setRight(0),this.domNode.setTop(0)}onDidScroll(d){return this._shouldRender=this._onElementScrollSize(d.scrollHeight)||this._shouldRender,this._shouldRender=this._onElementScrollPosition(d.scrollTop)||this._shouldRender,this._shouldRender=this._onElementSize(d.height)||this._shouldRender,this._shouldRender}_pointerDownRelativePosition(d,f){return f}_sliderPointerPosition(d){return d.pageY}_sliderOrthogonalPointerPosition(d){return d.pageX}_updateScrollbarSize(d){this.slider.setWidth(d)}writeScrollPosition(d,f){d.scrollTop=f}updateOptions(d){this.updateScrollbarSize(d.vertical===2?0:d.verticalScrollbarSize),this._scrollbarState.setOppositeScrollbarSize(0),this._visibilityController.setVisibility(d.vertical),this._scrollByPage=d.scrollByPage}}t.VerticalScrollbar=w}),define(me[56],pe([1,0,15,4,40,20,118,119,17,8,3,2,5,47,89]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DomScrollableElement=t.SmoothScrollableElement=t.ScrollableElement=t.AbstractScrollableElement=t.MouseWheelClassifier=void 0;const e=500,p=50,v=!0;class D{constructor(r,n,a){this.timestamp=r,this.deltaX=n,this.deltaY=a,this.score=0}}class y{constructor(){this._capacity=5,this._memory=[],this._front=-1,this._rear=-1}isPhysicalMouseWheel(){if(this._front===-1&&this._rear===-1)return!1;let r=1,n=0,a=1,u=this._rear;do{const m=u===this._front?r:Math.pow(2,-a);if(r-=m,n+=this._memory[u].score*m,u===this._front)break;u=(this._capacity+u-1)%this._capacity,a++}while(!0);return n<=.5}accept(r,n,a){const u=new D(r,n,a);u.score=this._computeScore(u),this._front===-1&&this._rear===-1?(this._memory[0]=u,this._front=0,this._rear=0):(this._rear=(this._rear+1)%this._capacity,this._rear===this._front&&(this._front=(this._front+1)%this._capacity),this._memory[this._rear]=u)}_computeScore(r){if(Math.abs(r.deltaX)>0&&Math.abs(r.deltaY)>0)return 1;let n=.5;const a=this._front===-1&&this._rear===-1?null:this._memory[this._rear];return(!this._isAlmostInt(r.deltaX)||!this._isAlmostInt(r.deltaY))&&(n+=.25),Math.min(Math.max(n,0),1)}_isAlmostInt(r){return Math.abs(Math.round(r)-r)<.01}}t.MouseWheelClassifier=y,y.INSTANCE=new y;class o extends g.Widget{constructor(r,n,a){super();this._onScroll=this._register(new f.Emitter),this.onScroll=this._onScroll.event,this._onWillScroll=this._register(new f.Emitter),this.onWillScroll=this._onWillScroll.event,r.style.overflow="hidden",this._options=A(n),this._scrollable=a,this._register(this._scrollable.onScroll(m=>{this._onWillScroll.fire(m),this._onDidScroll(m),this._onScroll.fire(m)}));const u={onMouseWheel:m=>this._onMouseWheel(m),onDragStart:()=>this._onDragStart(),onDragEnd:()=>this._onDragEnd()};this._verticalScrollbar=this._register(new w.VerticalScrollbar(this._scrollable,this._options,u)),this._horizontalScrollbar=this._register(new _.HorizontalScrollbar(this._scrollable,this._options,u)),this._domNode=document.createElement("div"),this._domNode.className="monaco-scrollable-element "+this._options.className,this._domNode.setAttribute("role","presentation"),this._domNode.style.position="relative",this._domNode.style.overflow="hidden",this._domNode.appendChild(r),this._domNode.appendChild(this._horizontalScrollbar.domNode.domNode),this._domNode.appendChild(this._verticalScrollbar.domNode.domNode),this._options.useShadows?(this._leftShadowDomNode=(0,M.createFastDomNode)(document.createElement("div")),this._leftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._leftShadowDomNode.domNode),this._topShadowDomNode=(0,M.createFastDomNode)(document.createElement("div")),this._topShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topShadowDomNode.domNode),this._topLeftShadowDomNode=(0,M.createFastDomNode)(document.createElement("div")),this._topLeftShadowDomNode.setClassName("shadow"),this._domNode.appendChild(this._topLeftShadowDomNode.domNode)):(this._leftShadowDomNode=null,this._topShadowDomNode=null,this._topLeftShadowDomNode=null),this._listenOnDomNode=this._options.listenOnDomNode||this._domNode,this._mouseWheelToDispose=[],this._setListeningToMouseWheel(this._options.handleMouseWheel),this.onmouseover(this._listenOnDomNode,m=>this._onMouseOver(m)),this.onmouseleave(this._listenOnDomNode,m=>this._onMouseLeave(m)),this._hideTimeout=this._register(new d.TimeoutTimer),this._isDragging=!1,this._mouseIsOver=!1,this._shouldRender=!0,this._revealOnScroll=!0}get options(){return this._options}dispose(){this._mouseWheelToDispose=(0,F.dispose)(this._mouseWheelToDispose),super.dispose()}getDomNode(){return this._domNode}getOverviewRulerLayoutInfo(){return{parent:this._domNode,insertBefore:this._verticalScrollbar.domNode.domNode}}delegateVerticalScrollbarPointerDown(r){this._verticalScrollbar.delegatePointerDown(r)}getScrollDimensions(){return this._scrollable.getScrollDimensions()}setScrollDimensions(r){this._scrollable.setScrollDimensions(r,!1)}updateClassName(r){this._options.className=r,l.isMacintosh&&(this._options.className+=" mac"),this._domNode.className="monaco-scrollable-element "+this._options.className}updateOptions(r){typeof r.handleMouseWheel!="undefined"&&(this._options.handleMouseWheel=r.handleMouseWheel,this._setListeningToMouseWheel(this._options.handleMouseWheel)),typeof r.mouseWheelScrollSensitivity!="undefined"&&(this._options.mouseWheelScrollSensitivity=r.mouseWheelScrollSensitivity),typeof r.fastScrollSensitivity!="undefined"&&(this._options.fastScrollSensitivity=r.fastScrollSensitivity),typeof r.scrollPredominantAxis!="undefined"&&(this._options.scrollPredominantAxis=r.scrollPredominantAxis),typeof r.horizontal!="undefined"&&(this._options.horizontal=r.horizontal),typeof r.vertical!="undefined"&&(this._options.vertical=r.vertical),typeof r.horizontalScrollbarSize!="undefined"&&(this._options.horizontalScrollbarSize=r.horizontalScrollbarSize),typeof r.verticalScrollbarSize!="undefined"&&(this._options.verticalScrollbarSize=r.verticalScrollbarSize),typeof r.scrollByPage!="undefined"&&(this._options.scrollByPage=r.scrollByPage),this._horizontalScrollbar.updateOptions(this._options),this._verticalScrollbar.updateOptions(this._options),this._options.lazyRender||this._render()}setRevealOnScroll(r){this._revealOnScroll=r}triggerScrollFromMouseWheelEvent(r){this._onMouseWheel(new O.StandardWheelEvent(r))}_setListeningToMouseWheel(r){if(this._mouseWheelToDispose.length>0!==r&&(this._mouseWheelToDispose=(0,F.dispose)(this._mouseWheelToDispose),r)){const a=u=>{this._onMouseWheel(new O.StandardWheelEvent(u))};this._mouseWheelToDispose.push(i.addDisposableListener(this._listenOnDomNode,i.EventType.MOUSE_WHEEL,a,{passive:!1}))}}_onMouseWheel(r){const n=y.INSTANCE;if(v){const m=window.devicePixelRatio/(0,E.getZoomFactor)();l.isWindows||l.isLinux?n.accept(Date.now(),r.deltaX/m,r.deltaY/m):n.accept(Date.now(),r.deltaX,r.deltaY)}let a=!1;if(r.deltaY||r.deltaX){let m=r.deltaY*this._options.mouseWheelScrollSensitivity,W=r.deltaX*this._options.mouseWheelScrollSensitivity;this._options.scrollPredominantAxis&&(Math.abs(m)>=Math.abs(W)?W=0:m=0),this._options.flipAxes&&([m,W]=[W,m]);const V=!l.isMacintosh&&r.browserEvent&&r.browserEvent.shiftKey;(this._options.scrollYToX||V)&&!W&&(W=m,m=0),r.browserEvent&&r.browserEvent.altKey&&(W=W*this._options.fastScrollSensitivity,m=m*this._options.fastScrollSensitivity);const ne=this._scrollable.getFutureScrollPosition();let re={};if(m){const we=p*m,ae=ne.scrollTop-(we<0?Math.floor(we):Math.ceil(we));this._verticalScrollbar.writeScrollPosition(re,ae)}if(W){const we=p*W,ae=ne.scrollLeft-(we<0?Math.floor(we):Math.ceil(we));this._horizontalScrollbar.writeScrollPosition(re,ae)}re=this._scrollable.validateScrollPosition(re),(ne.scrollLeft!==re.scrollLeft||ne.scrollTop!==re.scrollTop)&&(v&&this._options.mouseWheelSmoothScroll&&n.isPhysicalMouseWheel()?this._scrollable.setScrollPositionSmooth(re):this._scrollable.setScrollPositionNow(re),a=!0)}let u=a;!u&&this._options.alwaysConsumeMouseWheel&&(u=!0),!u&&this._options.consumeMouseWheelIfScrollbarIsNeeded&&(this._verticalScrollbar.isNeeded()||this._horizontalScrollbar.isNeeded())&&(u=!0),u&&(r.preventDefault(),r.stopPropagation())}_onDidScroll(r){this._shouldRender=this._horizontalScrollbar.onDidScroll(r)||this._shouldRender,this._shouldRender=this._verticalScrollbar.onDidScroll(r)||this._shouldRender,this._options.useShadows&&(this._shouldRender=!0),this._revealOnScroll&&this._reveal(),this._options.lazyRender||this._render()}renderNow(){if(!this._options.lazyRender)throw new Error("Please use `lazyRender` together with `renderNow`!");this._render()}_render(){if(!!this._shouldRender&&(this._shouldRender=!1,this._horizontalScrollbar.render(),this._verticalScrollbar.render(),this._options.useShadows)){const r=this._scrollable.getCurrentScrollPosition(),n=r.scrollTop>0,a=r.scrollLeft>0,u=a?" left":"",m=n?" top":"",W=a||n?" top-left-corner":"";this._leftShadowDomNode.setClassName(`shadow${u}`),this._topShadowDomNode.setClassName(`shadow${m}`),this._topLeftShadowDomNode.setClassName(`shadow${W}${m}${u}`)}}_onDragStart(){this._isDragging=!0,this._reveal()}_onDragEnd(){this._isDragging=!1,this._hide()}_onMouseLeave(r){this._mouseIsOver=!1,this._hide()}_onMouseOver(r){this._mouseIsOver=!0,this._reveal()}_reveal(){this._verticalScrollbar.beginReveal(),this._horizontalScrollbar.beginReveal(),this._scheduleHide()}_hide(){!this._mouseIsOver&&!this._isDragging&&(this._verticalScrollbar.beginHide(),this._horizontalScrollbar.beginHide())}_scheduleHide(){!this._mouseIsOver&&!this._isDragging&&this._hideTimeout.cancelAndSet(()=>this._hide(),e)}}t.AbstractScrollableElement=o;class c extends o{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const a=new s.Scrollable({forceIntegerValues:!0,smoothScrollDuration:0,scheduleAtNextAnimationFrame:u=>i.scheduleAtNextAnimationFrame(u)});super(r,n,a);this._register(a)}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.ScrollableElement=c;class b extends o{constructor(r,n,a){super(r,n,a)}setScrollPosition(r){r.reuseAnimation?this._scrollable.setScrollPositionSmooth(r,r.reuseAnimation):this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}}t.SmoothScrollableElement=b;class S extends o{constructor(r,n){n=n||{},n.mouseWheelSmoothScroll=!1;const a=new s.Scrollable({forceIntegerValues:!1,smoothScrollDuration:0,scheduleAtNextAnimationFrame:u=>i.scheduleAtNextAnimationFrame(u)});super(r,n,a);this._register(a),this._element=r,this.onScroll(u=>{u.scrollTopChanged&&(this._element.scrollTop=u.scrollTop),u.scrollLeftChanged&&(this._element.scrollLeft=u.scrollLeft)}),this.scanDomNode()}setScrollPosition(r){this._scrollable.setScrollPositionNow(r)}getScrollPosition(){return this._scrollable.getCurrentScrollPosition()}scanDomNode(){this.setScrollDimensions({width:this._element.clientWidth,scrollWidth:this._element.scrollWidth,height:this._element.clientHeight,scrollHeight:this._element.scrollHeight}),this.setScrollPosition({scrollLeft:this._element.scrollLeft,scrollTop:this._element.scrollTop})}}t.DomScrollableElement=S;function A(C){const r={lazyRender:typeof C.lazyRender!="undefined"?C.lazyRender:!1,className:typeof C.className!="undefined"?C.className:"",useShadows:typeof C.useShadows!="undefined"?C.useShadows:!0,handleMouseWheel:typeof C.handleMouseWheel!="undefined"?C.handleMouseWheel:!0,flipAxes:typeof C.flipAxes!="undefined"?C.flipAxes:!1,consumeMouseWheelIfScrollbarIsNeeded:typeof C.consumeMouseWheelIfScrollbarIsNeeded!="undefined"?C.consumeMouseWheelIfScrollbarIsNeeded:!1,alwaysConsumeMouseWheel:typeof C.alwaysConsumeMouseWheel!="undefined"?C.alwaysConsumeMouseWheel:!1,scrollYToX:typeof C.scrollYToX!="undefined"?C.scrollYToX:!1,mouseWheelScrollSensitivity:typeof C.mouseWheelScrollSensitivity!="undefined"?C.mouseWheelScrollSensitivity:1,fastScrollSensitivity:typeof C.fastScrollSensitivity!="undefined"?C.fastScrollSensitivity:5,scrollPredominantAxis:typeof C.scrollPredominantAxis!="undefined"?C.scrollPredominantAxis:!0,mouseWheelSmoothScroll:typeof C.mouseWheelSmoothScroll!="undefined"?C.mouseWheelSmoothScroll:!0,arrowSize:typeof C.arrowSize!="undefined"?C.arrowSize:11,listenOnDomNode:typeof C.listenOnDomNode!="undefined"?C.listenOnDomNode:null,horizontal:typeof C.horizontal!="undefined"?C.horizontal:1,horizontalScrollbarSize:typeof C.horizontalScrollbarSize!="undefined"?C.horizontalScrollbarSize:10,horizontalSliderSize:typeof C.horizontalSliderSize!="undefined"?C.horizontalSliderSize:0,horizontalHasArrows:typeof C.horizontalHasArrows!="undefined"?C.horizontalHasArrows:!1,vertical:typeof C.vertical!="undefined"?C.vertical:1,verticalScrollbarSize:typeof C.verticalScrollbarSize!="undefined"?C.verticalScrollbarSize:10,verticalHasArrows:typeof C.verticalHasArrows!="undefined"?C.verticalHasArrows:!1,verticalSliderSize:typeof C.verticalSliderSize!="undefined"?C.verticalSliderSize:0,scrollByPage:typeof C.scrollByPage!="undefined"?C.scrollByPage:!1};return r.horizontalSliderSize=typeof C.horizontalSliderSize!="undefined"?C.horizontalSliderSize:r.horizontalScrollbarSize,r.verticalSliderSize=typeof C.verticalSliderSize!="undefined"?C.verticalSliderSize:r.verticalScrollbarSize,l.isMacintosh&&(r.className+=" mac"),r}}),define(me[57],pe([1,0,15,50,4,18,22,56,14,8,25,3,2,45,47,78,114]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s,e,p,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ListView=t.NativeDragAndDropData=t.ExternalElementsDragAndDropData=t.ElementsDragAndDropData=void 0;const D={CurrentDragAndDropData:void 0},y={useShadows:!0,verticalScrollMode:1,setRowLineHeight:!0,setRowHeight:!0,supportDynamicHeights:!1,dnd:{getDragElements(r){return[r]},getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}},horizontalScrolling:!1,transformOptimization:!0,alwaysConsumeMouseWheel:!0};class o{constructor(n){this.elements=n}get context(){return this._context}set context(n){this._context=n}update(){}getData(){return this.elements}}t.ElementsDragAndDropData=o;class c{constructor(n){this.elements=n}update(){}getData(){return this.elements}}t.ExternalElementsDragAndDropData=c;class b{constructor(){this.types=[],this.files=[]}update(n){if(n.types&&this.types.splice(0,this.types.length,...n.types),n.files){this.files.splice(0,this.files.length);for(let a=0;a<n.files.length;a++){const u=n.files.item(a);u&&(u.size||u.type)&&this.files.push(u)}}}getData(){return{types:this.types,files:this.files}}}t.NativeDragAndDropData=b;function S(r,n){return Array.isArray(r)&&Array.isArray(n)?(0,g.equals)(r,n):r===n}class A{constructor(n){n?.getSetSize?this.getSetSize=n.getSetSize.bind(n):this.getSetSize=(a,u,m)=>m,n?.getPosInSet?this.getPosInSet=n.getPosInSet.bind(n):this.getPosInSet=(a,u)=>u+1,n?.getRole?this.getRole=n.getRole.bind(n):this.getRole=a=>"listitem",n?.isChecked?this.isChecked=n.isChecked.bind(n):this.isChecked=a=>{}}}class C{constructor(n,a,u,m=y){if(this.virtualDelegate=a,this.domId=`list_id_${++C.InstanceCount}`,this.renderers=new Map,this.renderWidth=0,this._scrollHeight=0,this.scrollableElementUpdateDisposable=null,this.scrollableElementWidthDelayer=new d.Delayer(50),this.splicing=!1,this.dragOverAnimationStopDisposable=l.Disposable.None,this.dragOverMouseY=0,this.canDrop=!1,this.currentDragFeedbackDisposable=l.Disposable.None,this.onDragLeaveTimeout=l.Disposable.None,this.disposables=new l.DisposableStore,this._onDidChangeContentHeight=new F.Emitter,this.onDidChangeContentHeight=F.Event.latch(this._onDidChangeContentHeight.event,void 0,this.disposables),this._horizontalScrolling=!1,m.horizontalScrolling&&m.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");this.items=[],this.itemId=0,this.rangeMap=new p.RangeMap;for(const V of u)this.renderers.set(V.templateId,V);this.cache=this.disposables.add(new v.RowCache(this.renderers)),this.lastRenderTop=0,this.lastRenderHeight=0,this.domNode=document.createElement("div"),this.domNode.className="monaco-list",this.domNode.classList.add(this.domId),this.domNode.tabIndex=0,this.domNode.classList.toggle("mouse-support",typeof m.mouseSupport=="boolean"?m.mouseSupport:!0),this._horizontalScrolling=m.horizontalScrolling??y.horizontalScrolling,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this.additionalScrollHeight=typeof m.additionalScrollHeight=="undefined"?0:m.additionalScrollHeight,this.accessibilityProvider=new A(m.accessibilityProvider),this.rowsContainer=document.createElement("div"),this.rowsContainer.className="monaco-list-rows",(m.transformOptimization??y.transformOptimization)&&(this.rowsContainer.style.transform="translate3d(0px, 0px, 0px)"),this.disposables.add(_.Gesture.addTarget(this.rowsContainer)),this.scrollable=new e.Scrollable({forceIntegerValues:!0,smoothScrollDuration:m.smoothScrolling??!1?125:0,scheduleAtNextAnimationFrame:V=>(0,M.scheduleAtNextAnimationFrame)(V)}),this.scrollableElement=this.disposables.add(new w.SmoothScrollableElement(this.rowsContainer,{alwaysConsumeMouseWheel:m.alwaysConsumeMouseWheel??y.alwaysConsumeMouseWheel,horizontal:1,vertical:m.verticalScrollMode??y.verticalScrollMode,useShadows:m.useShadows??y.useShadows,mouseWheelScrollSensitivity:m.mouseWheelScrollSensitivity,fastScrollSensitivity:m.fastScrollSensitivity},this.scrollable)),this.domNode.appendChild(this.scrollableElement.getDomNode()),n.appendChild(this.domNode),this.scrollableElement.onScroll(this.onScroll,this,this.disposables),this.disposables.add((0,M.addDisposableListener)(this.rowsContainer,_.EventType.Change,V=>this.onTouchChange(V))),this.disposables.add((0,M.addDisposableListener)(this.scrollableElement.getDomNode(),"scroll",V=>V.target.scrollTop=0)),this.disposables.add((0,M.addDisposableListener)(this.domNode,"dragover",V=>this.onDragOver(this.toDragEvent(V)))),this.disposables.add((0,M.addDisposableListener)(this.domNode,"drop",V=>this.onDrop(this.toDragEvent(V)))),this.disposables.add((0,M.addDisposableListener)(this.domNode,"dragleave",V=>this.onDragLeave(this.toDragEvent(V)))),this.disposables.add((0,M.addDisposableListener)(this.domNode,"dragend",V=>this.onDragEnd(V))),this.setRowLineHeight=m.setRowLineHeight??y.setRowLineHeight,this.setRowHeight=m.setRowHeight??y.setRowHeight,this.supportDynamicHeights=m.supportDynamicHeights??y.supportDynamicHeights,this.dnd=m.dnd??y.dnd,this.layout()}get contentHeight(){return this.rangeMap.size}get onDidScroll(){return this.scrollableElement.onScroll}get onWillScroll(){return this.scrollableElement.onWillScroll}get containerDomNode(){return this.rowsContainer}get scrollableElementDomNode(){return this.scrollableElement.getDomNode()}get horizontalScrolling(){return this._horizontalScrolling}set horizontalScrolling(n){if(n!==this._horizontalScrolling){if(n&&this.supportDynamicHeights)throw new Error("Horizontal scrolling and dynamic heights not supported simultaneously");if(this._horizontalScrolling=n,this.domNode.classList.toggle("horizontal-scrolling",this._horizontalScrolling),this._horizontalScrolling){for(const a of this.items)this.measureItemWidth(a);this.updateScrollWidth(),this.scrollableElement.setScrollDimensions({width:(0,M.getContentWidth)(this.domNode)}),this.rowsContainer.style.width=`${Math.max(this.scrollWidth||0,this.renderWidth)}px`}else this.scrollableElementWidthDelayer.cancel(),this.scrollableElement.setScrollDimensions({width:this.renderWidth,scrollWidth:this.renderWidth}),this.rowsContainer.style.width=""}}updateOptions(n){n.additionalScrollHeight!==void 0&&(this.additionalScrollHeight=n.additionalScrollHeight,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),n.smoothScrolling!==void 0&&this.scrollable.setSmoothScrollDuration(n.smoothScrolling?125:0),n.horizontalScrolling!==void 0&&(this.horizontalScrolling=n.horizontalScrolling),n.mouseWheelScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({mouseWheelScrollSensitivity:n.mouseWheelScrollSensitivity}),n.fastScrollSensitivity!==void 0&&this.scrollableElement.updateOptions({fastScrollSensitivity:n.fastScrollSensitivity})}triggerScrollFromMouseWheelEvent(n){this.scrollableElement.triggerScrollFromMouseWheelEvent(n)}updateElementHeight(n,a,u){if(n<0||n>=this.items.length)return;const m=this.items[n].size;if(typeof a=="undefined"){if(!this.supportDynamicHeights){console.warn("Dynamic heights not supported");return}this.items[n].lastDynamicHeightWidth=void 0,a=m+this.probeDynamicHeight(n)}if(m===a)return;const W=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);let V=0;n<W.start||u!==null&&u>n&&u<=W.end?V=a-m:V=0,this.rangeMap.splice(n,1,[{size:a}]),this.items[n].size=a,this.render(W,Math.max(0,this.lastRenderTop+V),this.lastRenderHeight,void 0,void 0,!0),this.setScrollTop(this.lastRenderTop),this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.lastRenderTop,this.lastRenderHeight)}splice(n,a,u=[]){if(this.splicing)throw new Error("Can't run recursive splices.");this.splicing=!0;try{return this._splice(n,a,u)}finally{this.splicing=!1,this._onDidChangeContentHeight.fire(this.contentHeight)}}_splice(n,a,u=[]){const m=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),W={start:n,end:n+a},V=s.Range.intersect(m,W),ne=new Map;for(let $=V.end-1;$>=V.start;$--){const G=this.items[$];if(G.dragStartDisposable.dispose(),G.checkedDisposable.dispose(),G.row){let B=ne.get(G.templateId);B||(B=[],ne.set(G.templateId,B));const h=this.renderers.get(G.templateId);h&&h.disposeElement&&h.disposeElement(G.element,$,G.row.templateData,G.size),B.push(G.row)}G.row=null}const re={start:n+a,end:this.items.length},we=s.Range.intersect(re,m),ae=s.Range.relativeComplement(re,m),ve=u.map($=>({id:String(this.itemId++),element:$,templateId:this.virtualDelegate.getTemplateId($),size:this.virtualDelegate.getHeight($),width:void 0,hasDynamicHeight:!!this.virtualDelegate.hasDynamicHeight&&this.virtualDelegate.hasDynamicHeight($),lastDynamicHeightWidth:void 0,row:null,uri:void 0,dropTarget:!1,dragStartDisposable:l.Disposable.None,checkedDisposable:l.Disposable.None}));let ue;n===0&&a>=this.items.length?(this.rangeMap=new p.RangeMap,this.rangeMap.splice(0,0,ve),ue=this.items,this.items=ve):(this.rangeMap.splice(n,a,ve),ue=this.items.splice(n,a,...ve));const ge=u.length-a,ye=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),ee=(0,p.shift)(we,ge),fe=s.Range.intersect(ye,ee);for(let $=fe.start;$<fe.end;$++)this.updateItemInDOM(this.items[$],$);const te=s.Range.relativeComplement(ee,ye);for(const $ of te)for(let G=$.start;G<$.end;G++)this.removeItemFromDOM(G);const X=ae.map($=>(0,p.shift)($,ge)),ie=[{start:n,end:n+u.length},...X].map($=>s.Range.intersect(ye,$)),L=this.getNextToLastElement(ie);for(const $ of ie)for(let G=$.start;G<$.end;G++){const B=this.items[G],I=ne.get(B.templateId)?.pop();this.insertItemInDOM(G,L,I)}for(const $ of ne.values())for(const G of $)this.cache.release(G);return this.eventuallyUpdateScrollDimensions(),this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight),ue.map($=>$.element)}eventuallyUpdateScrollDimensions(){this._scrollHeight=this.contentHeight,this.rowsContainer.style.height=`${this._scrollHeight}px`,this.scrollableElementUpdateDisposable||(this.scrollableElementUpdateDisposable=(0,M.scheduleAtNextAnimationFrame)(()=>{this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight}),this.updateScrollWidth(),this.scrollableElementUpdateDisposable=null}))}eventuallyUpdateScrollWidth(){if(!this.horizontalScrolling){this.scrollableElementWidthDelayer.cancel();return}this.scrollableElementWidthDelayer.trigger(()=>this.updateScrollWidth())}updateScrollWidth(){if(!this.horizontalScrolling)return;let n=0;for(const a of this.items)typeof a.width!="undefined"&&(n=Math.max(n,a.width));this.scrollWidth=n,this.scrollableElement.setScrollDimensions({scrollWidth:n===0?0:n+10})}updateWidth(n){if(!this.horizontalScrolling||typeof this.scrollWidth=="undefined")return;const a=this.items[n];this.measureItemWidth(a),typeof a.width!="undefined"&&a.width>this.scrollWidth&&(this.scrollWidth=a.width,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth+10}))}rerender(){if(!!this.supportDynamicHeights){for(const n of this.items)n.lastDynamicHeightWidth=void 0;this._rerender(this.lastRenderTop,this.lastRenderHeight)}}get length(){return this.items.length}get renderHeight(){return this.scrollableElement.getScrollDimensions().height}get firstVisibleIndex(){const n=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight),a=this.rangeMap.positionAt(n.start),u=this.rangeMap.positionAt(n.start+1);return u!==-1&&(u-a)/2+a<this.scrollTop?n.start+1:n.start}get lastVisibleIndex(){return this.getRenderRange(this.lastRenderTop,this.lastRenderHeight).end-1}element(n){return this.items[n].element}indexOf(n){return this.items.findIndex(a=>a.element===n)}domElement(n){const a=this.items[n].row;return a&&a.domNode}elementHeight(n){return this.items[n].size}elementTop(n){return this.rangeMap.positionAt(n)}indexAt(n){return this.rangeMap.indexAt(n)}indexAfter(n){return this.rangeMap.indexAfter(n)}layout(n,a){const u={height:typeof n=="number"?n:(0,M.getContentHeight)(this.domNode)};this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,u.scrollHeight=this.scrollHeight),this.scrollableElement.setScrollDimensions(u),typeof a!="undefined"&&(this.renderWidth=a,this.supportDynamicHeights&&this._rerender(this.scrollTop,this.renderHeight)),this.horizontalScrolling&&this.scrollableElement.setScrollDimensions({width:typeof a=="number"?a:(0,M.getContentWidth)(this.domNode)})}render(n,a,u,m,W,V=!1){const ne=this.getRenderRange(a,u),re=s.Range.relativeComplement(ne,n),we=s.Range.relativeComplement(n,ne),ae=this.getNextToLastElement(re);if(V){const ve=s.Range.intersect(n,ne);for(let ue=ve.start;ue<ve.end;ue++)this.updateItemInDOM(this.items[ue],ue)}for(const ve of re)for(let ue=ve.start;ue<ve.end;ue++)this.insertItemInDOM(ue,ae);for(const ve of we)for(let ue=ve.start;ue<ve.end;ue++)this.removeItemFromDOM(ue);m!==void 0&&(this.rowsContainer.style.left=`-${m}px`),this.rowsContainer.style.top=`-${a}px`,this.horizontalScrolling&&W!==void 0&&(this.rowsContainer.style.width=`${Math.max(W,this.renderWidth)}px`),this.lastRenderTop=a,this.lastRenderHeight=u}insertItemInDOM(n,a,u){const m=this.items[n];m.row||(m.row=u??this.cache.alloc(m.templateId));const W=this.accessibilityProvider.getRole(m.element)||"listitem";m.row.domNode.setAttribute("role",W);const V=this.accessibilityProvider.isChecked(m.element);if(typeof V=="boolean")m.row.domNode.setAttribute("aria-checked",String(!!V));else if(V){const we=ae=>m.row.domNode.setAttribute("aria-checked",String(!!ae));we(V.value),m.checkedDisposable=V.onDidChange(we)}m.row.domNode.parentElement||(a?this.rowsContainer.insertBefore(m.row.domNode,a):this.rowsContainer.appendChild(m.row.domNode)),this.updateItemInDOM(m,n);const ne=this.renderers.get(m.templateId);if(!ne)throw new Error(`No renderer found for template id ${m.templateId}`);ne?.renderElement(m.element,n,m.row.templateData,m.size);const re=this.dnd.getDragURI(m.element);m.dragStartDisposable.dispose(),m.row.domNode.draggable=!!re,re&&(m.dragStartDisposable=(0,M.addDisposableListener)(m.row.domNode,"dragstart",we=>this.onDragStart(m.element,re,we))),this.horizontalScrolling&&(this.measureItemWidth(m),this.eventuallyUpdateScrollWidth())}measureItemWidth(n){if(!n.row||!n.row.domNode)return;n.row.domNode.style.width=E.isFirefox?"-moz-fit-content":"fit-content",n.width=(0,M.getContentWidth)(n.row.domNode);const a=window.getComputedStyle(n.row.domNode);a.paddingLeft&&(n.width+=parseFloat(a.paddingLeft)),a.paddingRight&&(n.width+=parseFloat(a.paddingRight)),n.row.domNode.style.width=""}updateItemInDOM(n,a){n.row.domNode.style.top=`${this.elementTop(a)}px`,this.setRowHeight&&(n.row.domNode.style.height=`${n.size}px`),this.setRowLineHeight&&(n.row.domNode.style.lineHeight=`${n.size}px`),n.row.domNode.setAttribute("data-index",`${a}`),n.row.domNode.setAttribute("data-last-element",a===this.length-1?"true":"false"),n.row.domNode.setAttribute("data-parity",a%2==0?"even":"odd"),n.row.domNode.setAttribute("aria-setsize",String(this.accessibilityProvider.getSetSize(n.element,a,this.length))),n.row.domNode.setAttribute("aria-posinset",String(this.accessibilityProvider.getPosInSet(n.element,a))),n.row.domNode.setAttribute("id",this.getElementDomId(a)),n.row.domNode.classList.toggle("drop-target",n.dropTarget)}removeItemFromDOM(n){const a=this.items[n];if(a.dragStartDisposable.dispose(),a.checkedDisposable.dispose(),a.row){const u=this.renderers.get(a.templateId);u&&u.disposeElement&&u.disposeElement(a.element,n,a.row.templateData,a.size),this.cache.release(a.row),a.row=null}this.horizontalScrolling&&this.eventuallyUpdateScrollWidth()}getScrollTop(){return this.scrollableElement.getScrollPosition().scrollTop}setScrollTop(n,a){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollHeight:this.scrollHeight})),this.scrollableElement.setScrollPosition({scrollTop:n,reuseAnimation:a})}getScrollLeft(){return this.scrollableElement.getScrollPosition().scrollLeft}setScrollLeft(n){this.scrollableElementUpdateDisposable&&(this.scrollableElementUpdateDisposable.dispose(),this.scrollableElementUpdateDisposable=null,this.scrollableElement.setScrollDimensions({scrollWidth:this.scrollWidth})),this.scrollableElement.setScrollPosition({scrollLeft:n})}get scrollTop(){return this.getScrollTop()}set scrollTop(n){this.setScrollTop(n)}get scrollHeight(){return this._scrollHeight+(this.horizontalScrolling?10:0)+this.additionalScrollHeight}get onMouseClick(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"click")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDblClick(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"dblclick")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMiddleClick(){return F.Event.filter(F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"auxclick")).event,n=>this.toMouseEvent(n),this.disposables),n=>n.browserEvent.button===1,this.disposables)}get onMouseUp(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseup")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseDown(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousedown")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOver(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseover")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseMove(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mousemove")).event,n=>this.toMouseEvent(n),this.disposables)}get onMouseOut(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"mouseout")).event,n=>this.toMouseEvent(n),this.disposables)}get onContextMenu(){return F.Event.any(F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"contextmenu")).event,n=>this.toMouseEvent(n),this.disposables),F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,_.EventType.Contextmenu)).event,n=>this.toGestureEvent(n),this.disposables))}get onTouchStart(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.domNode,"touchstart")).event,n=>this.toTouchEvent(n),this.disposables)}get onTap(){return F.Event.map(this.disposables.add(new O.DomEmitter(this.rowsContainer,_.EventType.Tap)).event,n=>this.toGestureEvent(n),this.disposables)}toMouseEvent(n){const a=this.getItemIndexFromEventTarget(n.target||null),u=typeof a=="undefined"?void 0:this.items[a],m=u&&u.element;return{browserEvent:n,index:a,element:m}}toTouchEvent(n){const a=this.getItemIndexFromEventTarget(n.target||null),u=typeof a=="undefined"?void 0:this.items[a],m=u&&u.element;return{browserEvent:n,index:a,element:m}}toGestureEvent(n){const a=this.getItemIndexFromEventTarget(n.initialTarget||null),u=typeof a=="undefined"?void 0:this.items[a],m=u&&u.element;return{browserEvent:n,index:a,element:m}}toDragEvent(n){const a=this.getItemIndexFromEventTarget(n.target||null),u=typeof a=="undefined"?void 0:this.items[a],m=u&&u.element;return{browserEvent:n,index:a,element:m}}onScroll(n){try{const a=this.getRenderRange(this.lastRenderTop,this.lastRenderHeight);this.render(a,n.scrollTop,n.height,n.scrollLeft,n.scrollWidth),this.supportDynamicHeights&&this._rerender(n.scrollTop,n.height,n.inSmoothScrolling)}catch(a){throw console.error("Got bad scroll event:",n),a}}onTouchChange(n){n.preventDefault(),n.stopPropagation(),this.scrollTop-=n.translationY}onDragStart(n,a,u){if(!u.dataTransfer)return;const m=this.dnd.getDragElements(n);if(u.dataTransfer.effectAllowed="copyMove",u.dataTransfer.setData(i.DataTransfers.TEXT,a),u.dataTransfer.setDragImage){let W;this.dnd.getDragLabel&&(W=this.dnd.getDragLabel(m,u)),typeof W=="undefined"&&(W=String(m.length));const V=(0,M.$)(".monaco-drag-image");V.textContent=W,document.body.appendChild(V),u.dataTransfer.setDragImage(V,-10,-10),setTimeout(()=>document.body.removeChild(V),0)}this.currentDragData=new o(m),D.CurrentDragAndDropData=new c(m),this.dnd.onDragStart?.(this.currentDragData,u)}onDragOver(n){if(n.browserEvent.preventDefault(),this.onDragLeaveTimeout.dispose(),D.CurrentDragAndDropData&&D.CurrentDragAndDropData.getData()==="vscode-ui"||(this.setupDragAndDropScrollTopAnimation(n.browserEvent),!n.browserEvent.dataTransfer))return!1;if(!this.currentDragData)if(D.CurrentDragAndDropData)this.currentDragData=D.CurrentDragAndDropData;else{if(!n.browserEvent.dataTransfer.types)return!1;this.currentDragData=new b}const a=this.dnd.onDragOver(this.currentDragData,n.element,n.index,n.browserEvent);if(this.canDrop=typeof a=="boolean"?a:a.accept,!this.canDrop)return this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),!1;n.browserEvent.dataTransfer.dropEffect=typeof a!="boolean"&&a.effect===0?"copy":"move";let u;if(typeof a!="boolean"&&a.feedback?u=a.feedback:typeof n.index=="undefined"?u=[-1]:u=[n.index],u=(0,g.distinct)(u).filter(m=>m>=-1&&m<this.length).sort((m,W)=>m-W),u=u[0]===-1?[-1]:u,S(this.currentDragFeedback,u))return!0;if(this.currentDragFeedback=u,this.currentDragFeedbackDisposable.dispose(),u[0]===-1)this.domNode.classList.add("drop-target"),this.rowsContainer.classList.add("drop-target"),this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{this.domNode.classList.remove("drop-target"),this.rowsContainer.classList.remove("drop-target")});else{for(const m of u){const W=this.items[m];W.dropTarget=!0,W.row?.domNode.classList.add("drop-target")}this.currentDragFeedbackDisposable=(0,l.toDisposable)(()=>{for(const m of u){const W=this.items[m];W.dropTarget=!1,W.row?.domNode.classList.remove("drop-target")}})}return!0}onDragLeave(n){this.onDragLeaveTimeout.dispose(),this.onDragLeaveTimeout=(0,d.disposableTimeout)(()=>this.clearDragOverFeedback(),100),this.currentDragData&&this.dnd.onDragLeave?.(this.currentDragData,n.element,n.index,n.browserEvent)}onDrop(n){if(!this.canDrop)return;const a=this.currentDragData;this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,D.CurrentDragAndDropData=void 0,!(!a||!n.browserEvent.dataTransfer)&&(n.browserEvent.preventDefault(),a.update(n.browserEvent.dataTransfer),this.dnd.drop(a,n.element,n.index,n.browserEvent))}onDragEnd(n){this.canDrop=!1,this.teardownDragAndDropScrollTopAnimation(),this.clearDragOverFeedback(),this.currentDragData=void 0,D.CurrentDragAndDropData=void 0,this.dnd.onDragEnd?.(n)}clearDragOverFeedback(){this.currentDragFeedback=void 0,this.currentDragFeedbackDisposable.dispose(),this.currentDragFeedbackDisposable=l.Disposable.None}setupDragAndDropScrollTopAnimation(n){if(!this.dragOverAnimationDisposable){const a=(0,M.getTopLeftOffset)(this.domNode).top;this.dragOverAnimationDisposable=(0,M.animate)(this.animateDragAndDropScrollTop.bind(this,a))}this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationStopDisposable=(0,d.disposableTimeout)(()=>{this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)},1e3),this.dragOverMouseY=n.pageY}animateDragAndDropScrollTop(n){if(this.dragOverMouseY===void 0)return;const a=this.dragOverMouseY-n,u=this.renderHeight-35;a<35?this.scrollTop+=Math.max(-14,Math.floor(.3*(a-35))):a>u&&(this.scrollTop+=Math.min(14,Math.floor(.3*(a-u))))}teardownDragAndDropScrollTopAnimation(){this.dragOverAnimationStopDisposable.dispose(),this.dragOverAnimationDisposable&&(this.dragOverAnimationDisposable.dispose(),this.dragOverAnimationDisposable=void 0)}getItemIndexFromEventTarget(n){const a=this.scrollableElement.getDomNode();let u=n;for(;u instanceof HTMLElement&&u!==this.rowsContainer&&a.contains(u);){const m=u.getAttribute("data-index");if(m){const W=Number(m);if(!isNaN(W))return W}u=u.parentElement}}getRenderRange(n,a){return{start:this.rangeMap.indexAt(n),end:this.rangeMap.indexAfter(n+a-1)}}_rerender(n,a,u){const m=this.getRenderRange(n,a);let W,V;n===this.elementTop(m.start)?(W=m.start,V=0):m.end-m.start>1&&(W=m.start+1,V=this.elementTop(W)-n);let ne=0;for(;;){const re=this.getRenderRange(n,a);let we=!1;for(let ae=re.start;ae<re.end;ae++){const ve=this.probeDynamicHeight(ae);ve!==0&&this.rangeMap.splice(ae,1,[this.items[ae]]),ne+=ve,we=we||ve!==0}if(!we){ne!==0&&this.eventuallyUpdateScrollDimensions();const ae=s.Range.relativeComplement(m,re);for(const ue of ae)for(let ge=ue.start;ge<ue.end;ge++)this.items[ge].row&&this.removeItemFromDOM(ge);const ve=s.Range.relativeComplement(re,m);for(const ue of ve)for(let ge=ue.start;ge<ue.end;ge++){const ye=ge+1,ee=ye<this.items.length?this.items[ye].row:null,fe=ee?ee.domNode:null;this.insertItemInDOM(ge,fe)}for(let ue=re.start;ue<re.end;ue++)this.items[ue].row&&this.updateItemInDOM(this.items[ue],ue);if(typeof W=="number"){const ue=this.scrollable.getFutureScrollPosition().scrollTop-n,ge=this.elementTop(W)-V+ue;this.setScrollTop(ge,u)}this._onDidChangeContentHeight.fire(this.contentHeight);return}}}probeDynamicHeight(n){const a=this.items[n];if(this.virtualDelegate.getDynamicHeight){const V=this.virtualDelegate.getDynamicHeight(a.element);if(V!==null){const ne=a.size;return a.size=V,a.lastDynamicHeightWidth=this.renderWidth,V-ne}}if(!a.hasDynamicHeight||a.lastDynamicHeightWidth===this.renderWidth||!!this.virtualDelegate.hasDynamicHeight&&!this.virtualDelegate.hasDynamicHeight(a.element))return 0;const u=a.size;if(!this.setRowHeight&&a.row){const V=a.row.domNode.offsetHeight;return a.size=V,a.lastDynamicHeightWidth=this.renderWidth,V-u}const m=this.cache.alloc(a.templateId);m.domNode.style.height="",this.rowsContainer.appendChild(m.domNode);const W=this.renderers.get(a.templateId);return W&&(W.renderElement(a.element,n,m.templateData,void 0),W.disposeElement?.(a.element,n,m.templateData,void 0)),a.size=m.domNode.offsetHeight,this.virtualDelegate.setDynamicHeight?.(a.element,a.size),a.lastDynamicHeightWidth=this.renderWidth,this.rowsContainer.removeChild(m.domNode),this.cache.release(m),a.size-u}getNextToLastElement(n){const a=n[n.length-1];if(!a)return null;const u=this.items[a.end];return!u||!u.row?null:u.row.domNode}getElementDomId(n){return`${this.domId}_${n}`}dispose(){if(this.items){for(const n of this.items)if(n.row){const a=this.renderers.get(n.row.templateId);a&&(a.disposeElement?.(n.element,-1,n.row.templateData,void 0),a.disposeTemplate(n.row.templateData))}this.items=[]}this.domNode&&this.domNode.parentNode&&this.domNode.parentNode.removeChild(this.domNode),(0,l.dispose)(this.disposables)}}C.InstanceCount=0,Ke([f.memoize],C.prototype,"onMouseClick",null),Ke([f.memoize],C.prototype,"onMouseDblClick",null),Ke([f.memoize],C.prototype,"onMouseMiddleClick",null),Ke([f.memoize],C.prototype,"onMouseUp",null),Ke([f.memoize],C.prototype,"onMouseDown",null),Ke([f.memoize],C.prototype,"onMouseOver",null),Ke([f.memoize],C.prototype,"onMouseMove",null),Ke([f.memoize],C.prototype,"onMouseOut",null),Ke([f.memoize],C.prototype,"onContextMenu",null),Ke([f.memoize],C.prototype,"onTouchStart",null),Ke([f.memoize],C.prototype,"onTap",null),t.ListView=C}),define(me[58],pe([1,0,4,18,19,22,53,67,14,8,24,25,3,33,2,44,27,5,6,66,57,88]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s,e,p,v,D,y,o,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.List=t.DefaultStyleController=t.MouseController=t.isSelectionRangeChangeEvent=t.isSelectionSingleChangeEvent=t.DefaultKeyboardNavigationDelegate=t.TypeNavigationMode=t.isButton=t.isMonacoEditor=t.isInputElement=void 0;class b{constructor(h){this.trait=h,this.renderedElements=[]}get templateId(){return`template:${this.trait.name}`}renderTemplate(h){return h}renderElement(h,I,U){const K=this.renderedElements.findIndex(Q=>Q.templateData===U);if(K>=0){const Q=this.renderedElements[K];this.trait.unrender(U),Q.index=I}else{const Q={index:I,templateData:U};this.renderedElements.push(Q)}this.trait.renderIndex(I,U)}splice(h,I,U){const K=[];for(const Q of this.renderedElements)Q.index<h?K.push(Q):Q.index>=h+I&&K.push({index:Q.index+U-I,templateData:Q.templateData});this.renderedElements=K}renderIndexes(h){for(const{index:I,templateData:U}of this.renderedElements)h.indexOf(I)>-1&&this.trait.renderIndex(I,U)}disposeTemplate(h){const I=this.renderedElements.findIndex(U=>U.templateData===h);I<0||this.renderedElements.splice(I,1)}}class S{constructor(h){this._trait=h,this.length=0,this.indexes=[],this.sortedIndexes=[],this._onChange=new l.Emitter,this.onChange=this._onChange.event}get name(){return this._trait}get renderer(){return new b(this)}splice(h,I,U){I=Math.max(0,Math.min(I,this.length-h));const K=U.length-I,Q=h+I,N=[...this.sortedIndexes.filter(z=>z<h),...U.map((z,T)=>z?T+h:-1).filter(z=>z!==-1),...this.sortedIndexes.filter(z=>z>=Q).map(z=>z+K)],R=this.length+K;if(this.sortedIndexes.length>0&&N.length===0&&R>0){const z=this.sortedIndexes.find(T=>T>=h)??R-1;N.push(Math.min(z,R-1))}this.renderer.splice(h,I,U.length),this._set(N,N),this.length=R}renderIndex(h,I){I.classList.toggle(this._trait,this.contains(h))}unrender(h){h.classList.remove(this._trait)}set(h,I){return this._set(h,[...h].sort(se),I)}_set(h,I,U){const K=this.indexes,Q=this.sortedIndexes;this.indexes=h,this.sortedIndexes=I;const N=te(Q,h);return this.renderer.renderIndexes(N),this._onChange.fire({indexes:h,browserEvent:U}),K}get(){return this.indexes}contains(h){return(0,g.binarySearch)(this.sortedIndexes,h,se)>=0}dispose(){(0,e.dispose)(this._onChange)}}Ke([F.memoize],S.prototype,"renderer",null);class A extends S{constructor(h){super("selected");this.setAriaSelected=h}renderIndex(h,I){super.renderIndex(h,I),this.setAriaSelected&&(this.contains(h)?I.setAttribute("aria-selected","true"):I.setAttribute("aria-selected","false"))}}class C{constructor(h,I,U){this.trait=h,this.view=I,this.identityProvider=U}splice(h,I,U){if(!this.identityProvider)return this.trait.splice(h,I,U.map(()=>!1));const K=this.trait.get().map(N=>this.identityProvider.getId(this.view.element(N)).toString()),Q=U.map(N=>K.indexOf(this.identityProvider.getId(N).toString())>-1);this.trait.splice(h,I,Q)}}function r(B){return B.tagName==="INPUT"||B.tagName==="TEXTAREA"}t.isInputElement=r;function n(B){return B.classList.contains("monaco-editor")?!0:B.classList.contains("monaco-list")||!B.parentElement?!1:n(B.parentElement)}t.isMonacoEditor=n;function a(B){return B.tagName==="A"&&B.classList.contains("monaco-button")||B.tagName==="DIV"&&B.classList.contains("monaco-button-dropdown")?!0:B.classList.contains("monaco-list")||!B.parentElement?!1:a(B.parentElement)}t.isButton=a;class u{constructor(h,I,U){this.list=h,this.view=I,this.disposables=new e.DisposableStore,this.multipleSelectionDisposables=new e.DisposableStore,this.onKeyDown.filter(K=>K.keyCode===3).on(this.onEnter,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===16).on(this.onUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===18).on(this.onDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===11).on(this.onPageUpArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===12).on(this.onPageDownArrow,this,this.disposables),this.onKeyDown.filter(K=>K.keyCode===9).on(this.onEscape,this,this.disposables),U.multipleSelectionSupport!==!1&&this.onKeyDown.filter(K=>(D.isMacintosh?K.metaKey:K.ctrlKey)&&K.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables)}get onKeyDown(){return this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event).filter(h=>!r(h.target)).map(h=>new M.StandardKeyboardEvent(h)))}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionDisposables.clear(),h.multipleSelectionSupport&&this.onKeyDown.filter(I=>(D.isMacintosh?I.metaKey:I.ctrlKey)&&I.keyCode===31).on(this.onCtrlA,this,this.multipleSelectionDisposables))}onEnter(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection(this.list.getFocus(),h.browserEvent)}onUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPrevious(1,!1,h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNext(1,!1,h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageUpArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusPreviousPage(h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onPageDownArrow(h){h.preventDefault(),h.stopPropagation(),this.list.focusNextPage(h.browserEvent);const I=this.list.getFocus()[0];this.list.setAnchor(I),this.list.reveal(I),this.view.domNode.focus()}onCtrlA(h){h.preventDefault(),h.stopPropagation(),this.list.setSelection((0,g.range)(this.list.length),h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus()}onEscape(h){this.list.getSelection().length&&(h.preventDefault(),h.stopPropagation(),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0),this.view.domNode.focus())}dispose(){this.disposables.dispose(),this.multipleSelectionDisposables.dispose()}}Ke([F.memoize],u.prototype,"onKeyDown",null);var m;(function(B){B[B.Automatic=0]="Automatic",B[B.Trigger=1]="Trigger"})(m=t.TypeNavigationMode||(t.TypeNavigationMode={}));var W;(function(B){B[B.Idle=0]="Idle",B[B.Typing=1]="Typing"})(W||(W={})),t.DefaultKeyboardNavigationDelegate=new class{mightProducePrintableCharacter(B){return B.ctrlKey||B.metaKey||B.altKey?!1:B.keyCode>=31&&B.keyCode<=56||B.keyCode>=21&&B.keyCode<=30||B.keyCode>=93&&B.keyCode<=102||B.keyCode>=80&&B.keyCode<=90}};class V{constructor(h,I,U,K,Q){this.list=h,this.view=I,this.keyboardNavigationLabelProvider=U,this.keyboardNavigationEventFilter=K,this.delegate=Q,this.enabled=!1,this.state=W.Idle,this.mode=m.Automatic,this.triggered=!1,this.previouslyFocused=-1,this.enabledDisposables=new e.DisposableStore,this.disposables=new e.DisposableStore,this.updateOptions(h.options)}updateOptions(h){h.typeNavigationEnabled??!0?this.enable():this.disable(),this.mode=h.typeNavigationMode??m.Automatic}trigger(){this.triggered=!this.triggered}enable(){if(this.enabled)return;let h=!1;const I=this.enabledDisposables.add(l.Event.chain(this.enabledDisposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).filter(Q=>!r(Q.target)).filter(()=>this.mode===m.Automatic||this.triggered).map(Q=>new M.StandardKeyboardEvent(Q)).filter(Q=>h||this.keyboardNavigationEventFilter(Q)).filter(Q=>this.delegate.mightProducePrintableCharacter(Q)).forEach(i.stopEvent).map(Q=>Q.browserEvent.key).event,U=l.Event.debounce(I,()=>null,800,void 0,void 0,this.enabledDisposables);l.Event.reduce(l.Event.any(I,U),(Q,N)=>N===null?null:(Q||"")+N,void 0,this.enabledDisposables)(this.onInput,this,this.enabledDisposables),U(this.onClear,this,this.enabledDisposables),I(()=>h=!0,void 0,this.enabledDisposables),U(()=>h=!1,void 0,this.enabledDisposables),this.enabled=!0,this.triggered=!1}disable(){!this.enabled||(this.enabledDisposables.clear(),this.enabled=!1,this.triggered=!1)}onClear(){const h=this.list.getFocus();if(h.length>0&&h[0]===this.previouslyFocused){const I=this.list.options.accessibilityProvider?.getAriaLabel(this.list.element(h[0]));I&&(0,_.alert)(I)}this.previouslyFocused=-1}onInput(h){if(!h){this.state=W.Idle,this.triggered=!1;return}const I=this.list.getFocus(),U=I.length>0?I[0]:0,K=this.state===W.Idle?1:0;this.state=W.Typing;for(let Q=0;Q<this.list.length;Q++){const N=(U+Q+K)%this.list.length,R=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(this.view.element(N)),z=R&&R.toString();if(typeof z=="undefined"||(0,s.matchesPrefix)(h,z)){this.previouslyFocused=U,this.list.setFocus([N]),this.list.reveal(N);return}}}dispose(){this.disable(),this.enabledDisposables.dispose(),this.disposables.dispose()}}class ne{constructor(h,I){this.list=h,this.view=I,this.disposables=new e.DisposableStore,this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(I.domNode,"keydown")).event)).filter(K=>!r(K.target)).map(K=>new M.StandardKeyboardEvent(K)).filter(K=>K.keyCode===2&&!K.ctrlKey&&!K.metaKey&&!K.shiftKey&&!K.altKey).on(this.onTab,this,this.disposables)}onTab(h){if(h.target!==this.view.domNode)return;const I=this.list.getFocus();if(I.length===0)return;const U=this.view.domElement(I[0]);if(!U)return;const K=U.querySelector("[tabIndex]");if(!K||!(K instanceof HTMLElement)||K.tabIndex===-1)return;const Q=window.getComputedStyle(K);Q.visibility==="hidden"||Q.display==="none"||(h.preventDefault(),h.stopPropagation(),K.focus())}dispose(){this.disposables.dispose()}}function re(B){return D.isMacintosh?B.browserEvent.metaKey:B.browserEvent.ctrlKey}t.isSelectionSingleChangeEvent=re;function we(B){return B.browserEvent.shiftKey}t.isSelectionRangeChangeEvent=we;function ae(B){return B instanceof MouseEvent&&B.button===2}const ve={isSelectionSingleChangeEvent:re,isSelectionRangeChangeEvent:we};class ue{constructor(h){this.list=h,this.disposables=new e.DisposableStore,this._onPointer=new l.Emitter,this.onPointer=this._onPointer.event,h.options.multipleSelectionSupport!==!1&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ve),this.mouseSupport=typeof h.options.mouseSupport=="undefined"||!!h.options.mouseSupport,this.mouseSupport&&(h.onMouseDown(this.onMouseDown,this,this.disposables),h.onContextMenu(this.onContextMenu,this,this.disposables),h.onMouseDblClick(this.onDoubleClick,this,this.disposables),h.onTouchStart(this.onMouseDown,this,this.disposables),this.disposables.add(O.Gesture.addTarget(h.getHTMLElement()))),l.Event.any(h.onMouseClick,h.onMouseMiddleClick,h.onTap)(this.onViewPointer,this,this.disposables)}updateOptions(h){h.multipleSelectionSupport!==void 0&&(this.multipleSelectionController=void 0,h.multipleSelectionSupport&&(this.multipleSelectionController=this.list.options.multipleSelectionController||ve))}isSelectionSingleChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionSingleChangeEvent(h):!1}isSelectionRangeChangeEvent(h){return this.multipleSelectionController?this.multipleSelectionController.isSelectionRangeChangeEvent(h):!1}isSelectionChangeEvent(h){return this.isSelectionSingleChangeEvent(h)||this.isSelectionRangeChangeEvent(h)}onMouseDown(h){n(h.browserEvent.target)||document.activeElement!==h.browserEvent.target&&this.list.domFocus()}onContextMenu(h){if(n(h.browserEvent.target))return;const I=typeof h.index=="undefined"?[]:[h.index];this.list.setFocus(I,h.browserEvent)}onViewPointer(h){if(!this.mouseSupport||r(h.browserEvent.target)||n(h.browserEvent.target))return;const I=h.index;if(typeof I=="undefined"){this.list.setFocus([],h.browserEvent),this.list.setSelection([],h.browserEvent),this.list.setAnchor(void 0);return}if(this.isSelectionRangeChangeEvent(h))return this.changeSelection(h);if(this.isSelectionChangeEvent(h))return this.changeSelection(h);this.list.setFocus([I],h.browserEvent),this.list.setAnchor(I),ae(h.browserEvent)||this.list.setSelection([I],h.browserEvent),this._onPointer.fire(h)}onDoubleClick(h){if(r(h.browserEvent.target)||n(h.browserEvent.target)||this.isSelectionChangeEvent(h))return;const I=this.list.getFocus();this.list.setSelection(I,h.browserEvent)}changeSelection(h){const I=h.index;let U=this.list.getAnchor();if(this.isSelectionRangeChangeEvent(h)){typeof U=="undefined"&&(U=this.list.getFocus()[0]??I,this.list.setAnchor(U));const K=Math.min(U,I),Q=Math.max(U,I),N=(0,g.range)(K,Q+1),R=this.list.getSelection(),z=fe(te(R,[U]),U);if(z.length===0)return;const T=te(N,X(R,z));this.list.setSelection(T,h.browserEvent),this.list.setFocus([I],h.browserEvent)}else if(this.isSelectionSingleChangeEvent(h)){const K=this.list.getSelection(),Q=K.filter(N=>N!==I);this.list.setFocus([I]),this.list.setAnchor(I),K.length===Q.length?this.list.setSelection([...Q,I],h.browserEvent):this.list.setSelection(Q,h.browserEvent)}}dispose(){this.disposables.dispose()}}t.MouseController=ue;class ge{constructor(h,I){this.styleElement=h,this.selectorSuffix=I}style(h){const I=this.selectorSuffix&&`.${this.selectorSuffix}`,U=[];h.listBackground&&(h.listBackground.isOpaque()?U.push(`.monaco-list${I} .monaco-list-rows { background: ${h.listBackground}; }`):D.isMacintosh||console.warn(`List with id '${this.selectorSuffix}' was styled with a non-opaque background color. This will break sub-pixel antialiasing.`)),h.listFocusBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.focused { background-color: ${h.listFocusBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.focused:hover { background-color: ${h.listFocusBackground}; }`)),h.listFocusForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.focused { color: ${h.listFocusForeground}; }`),h.listActiveSelectionBackground&&(U.push(`.monaco-list${I}:focus .monaco-list-row.selected { background-color: ${h.listActiveSelectionBackground}; }`),U.push(`.monaco-list${I}:focus .monaco-list-row.selected:hover { background-color: ${h.listActiveSelectionBackground}; }`)),h.listActiveSelectionForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { color: ${h.listActiveSelectionForeground}; }`),h.listActiveSelectionIconForeground&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected .codicon { color: ${h.listActiveSelectionIconForeground}; }`),h.listFocusAndSelectionOutline&&U.push(`.monaco-list${I}:focus .monaco-list-row.selected { outline-color: ${h.listFocusAndSelectionOutline} !important; }`),h.listFocusAndSelectionBackground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { background-color: ${h.listFocusAndSelectionBackground}; }
			`),h.listFocusAndSelectionForeground&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.selected.focused { color: ${h.listFocusAndSelectionForeground}; }
			`),h.listInactiveFocusForeground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { color:  ${h.listInactiveFocusForeground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { color:  ${h.listInactiveFocusForeground}; }`)),h.listInactiveSelectionIconForeground&&U.push(`.monaco-list${I} .monaco-list-row.focused .codicon { color:  ${h.listInactiveSelectionIconForeground}; }`),h.listInactiveFocusBackground&&(U.push(`.monaco-list${I} .monaco-list-row.focused { background-color:  ${h.listInactiveFocusBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.focused:hover { background-color:  ${h.listInactiveFocusBackground}; }`)),h.listInactiveSelectionBackground&&(U.push(`.monaco-list${I} .monaco-list-row.selected { background-color:  ${h.listInactiveSelectionBackground}; }`),U.push(`.monaco-list${I} .monaco-list-row.selected:hover { background-color:  ${h.listInactiveSelectionBackground}; }`)),h.listInactiveSelectionForeground&&U.push(`.monaco-list${I} .monaco-list-row.selected { color: ${h.listInactiveSelectionForeground}; }`),h.listHoverBackground&&U.push(`.monaco-list${I}:not(.drop-target) .monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${h.listHoverBackground}; }`),h.listHoverForeground&&U.push(`.monaco-list${I} .monaco-list-row:hover:not(.selected):not(.focused) { color:  ${h.listHoverForeground}; }`),h.listSelectionOutline&&U.push(`.monaco-list${I} .monaco-list-row.selected { outline: 1px dotted ${h.listSelectionOutline}; outline-offset: -1px; }`),h.listFocusOutline&&U.push(`
				.monaco-drag-image,
				.monaco-list${I}:focus .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
				.monaco-workbench.context-menu-visible .monaco-list${I}.last-focused .monaco-list-row.focused { outline: 1px solid ${h.listFocusOutline}; outline-offset: -1px; }
			`),h.listInactiveFocusOutline&&U.push(`.monaco-list${I} .monaco-list-row.focused { outline: 1px dotted ${h.listInactiveFocusOutline}; outline-offset: -1px; }`),h.listHoverOutline&&U.push(`.monaco-list${I} .monaco-list-row:hover { outline: 1px dashed ${h.listHoverOutline}; outline-offset: -1px; }`),h.listDropBackground&&U.push(`
				.monaco-list${I}.drop-target,
				.monaco-list${I} .monaco-list-rows.drop-target,
				.monaco-list${I} .monaco-list-row.drop-target { background-color: ${h.listDropBackground} !important; color: inherit !important; }
			`),h.tableColumnsBorder&&U.push(`
				.monaco-table:hover > .monaco-split-view2,
				.monaco-table:hover > .monaco-split-view2 .monaco-sash.vertical::before {
					border-color: ${h.tableColumnsBorder};
			}`),h.tableOddRowsBackgroundColor&&U.push(`
				.monaco-table .monaco-list-row[data-parity=odd]:not(.focused):not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(:focus) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr,
				.monaco-table .monaco-list:not(.focused) .monaco-list-row[data-parity=odd].focused:not(.selected):not(:hover) .monaco-table-tr {
					background-color: ${h.tableOddRowsBackgroundColor};
				}
			`),this.styleElement.textContent=U.join(`
`)}}t.DefaultStyleController=ge;const ye={listFocusBackground:f.Color.fromHex("#7FB0D0"),listActiveSelectionBackground:f.Color.fromHex("#0E639C"),listActiveSelectionForeground:f.Color.fromHex("#FFFFFF"),listActiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listFocusAndSelectionOutline:f.Color.fromHex("#90C2F9"),listFocusAndSelectionBackground:f.Color.fromHex("#094771"),listFocusAndSelectionForeground:f.Color.fromHex("#FFFFFF"),listInactiveSelectionBackground:f.Color.fromHex("#3F3F46"),listInactiveSelectionIconForeground:f.Color.fromHex("#FFFFFF"),listHoverBackground:f.Color.fromHex("#2A2D2E"),listDropBackground:f.Color.fromHex("#383B3D"),treeIndentGuidesStroke:f.Color.fromHex("#a9a9a9"),tableColumnsBorder:f.Color.fromHex("#cccccc").transparent(.2),tableOddRowsBackgroundColor:f.Color.fromHex("#cccccc").transparent(.04)},ee={keyboardSupport:!0,mouseSupport:!0,multipleSelectionSupport:!0,dnd:{getDragURI(){return null},onDragStart(){},onDragOver(){return!1},drop(){}}};function fe(B,h){const I=B.indexOf(h);if(I===-1)return[];const U=[];let K=I-1;for(;K>=0&&B[K]===h-(I-K);)U.push(B[K--]);for(U.reverse(),K=I;K<B.length&&B[K]===h+(K-I);)U.push(B[K++]);return U}function te(B,h){const I=[];let U=0,K=0;for(;U<B.length||K<h.length;)if(U>=B.length)I.push(h[K++]);else if(K>=h.length)I.push(B[U++]);else if(B[U]===h[K]){I.push(B[U]),U++,K++;continue}else B[U]<h[K]?I.push(B[U++]):I.push(h[K++]);return I}function X(B,h){const I=[];let U=0,K=0;for(;U<B.length||K<h.length;)if(U>=B.length)I.push(h[K++]);else if(K>=h.length)I.push(B[U++]);else if(B[U]===h[K]){U++,K++;continue}else B[U]<h[K]?I.push(B[U++]):K++;return I}const se=(B,h)=>B-h;class ie{constructor(h,I){this._templateId=h,this.renderers=I}get templateId(){return this._templateId}renderTemplate(h){return this.renderers.map(I=>I.renderTemplate(h))}renderElement(h,I,U,K){let Q=0;for(const N of this.renderers)N.renderElement(h,I,U[Q++],K)}disposeElement(h,I,U,K){let Q=0;for(const N of this.renderers)N.disposeElement?.(h,I,U[Q],K),Q+=1}disposeTemplate(h){let I=0;for(const U of this.renderers)U.disposeTemplate(h[I++])}}class L{constructor(h){this.accessibilityProvider=h,this.templateId="a18n"}renderTemplate(h){return h}renderElement(h,I,U){const K=this.accessibilityProvider.getAriaLabel(h);K?U.setAttribute("aria-label",K):U.removeAttribute("aria-label");const Q=this.accessibilityProvider.getAriaLevel&&this.accessibilityProvider.getAriaLevel(h);typeof Q=="number"?U.setAttribute("aria-level",`${Q}`):U.removeAttribute("aria-level")}disposeTemplate(h){}}class ${constructor(h,I){this.list=h,this.dnd=I}getDragElements(h){const I=this.list.getSelectedElements();return I.indexOf(h)>-1?I:[h]}getDragURI(h){return this.dnd.getDragURI(h)}getDragLabel(h,I){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(h,I)}onDragStart(h,I){this.dnd.onDragStart?.(h,I)}onDragOver(h,I,U,K){return this.dnd.onDragOver(h,I,U,K)}onDragLeave(h,I,U,K){this.dnd.onDragLeave?.(h,I,U,K)}onDragEnd(h){this.dnd.onDragEnd?.(h)}drop(h,I,U,K){this.dnd.drop(h,I,U,K)}}class G{constructor(h,I,U,K,Q=ee){this.user=h,this._options=Q,this.focus=new S("focused"),this.anchor=new S("anchor"),this.eventBufferer=new l.EventBufferer,this._ariaLabel="",this.disposables=new e.DisposableStore,this._onDidDispose=new l.Emitter,this.onDidDispose=this._onDidDispose.event;const N=this._options.accessibilityProvider&&this._options.accessibilityProvider.getWidgetRole?this._options.accessibilityProvider?.getWidgetRole():"list";this.selection=new A(N!=="listbox"),(0,v.mixin)(Q,ye,!1);const R=[this.focus.renderer,this.selection.renderer];this.accessibilityProvider=Q.accessibilityProvider,this.accessibilityProvider&&(R.push(new L(this.accessibilityProvider)),this.accessibilityProvider.onDidChangeActiveDescendant?.(this.onDidChangeActiveDescendant,this,this.disposables)),K=K.map(T=>new ie(T.templateId,[...R,T]));const z={...Q,dnd:Q.dnd&&new $(this,Q.dnd)};if(this.view=new c.ListView(I,U,K,z),this.view.domNode.setAttribute("role",N),Q.styleController)this.styleController=Q.styleController(this.view.domId);else{const T=(0,E.createStyleSheet)(this.view.domNode);this.styleController=new ge(T,this.view.domId)}if(this.spliceable=new w.CombinedSpliceable([new C(this.focus,this.view,Q.identityProvider),new C(this.selection,this.view,Q.identityProvider),new C(this.anchor,this.view,Q.identityProvider),this.view]),this.disposables.add(this.focus),this.disposables.add(this.selection),this.disposables.add(this.anchor),this.disposables.add(this.view),this.disposables.add(this._onDidDispose),this.disposables.add(new ne(this,this.view)),(typeof Q.keyboardSupport!="boolean"||Q.keyboardSupport)&&(this.keyboardController=new u(this,this.view,Q),this.disposables.add(this.keyboardController)),Q.keyboardNavigationLabelProvider){const T=Q.keyboardNavigationDelegate||t.DefaultKeyboardNavigationDelegate;this.typeNavigationController=new V(this,this.view,Q.keyboardNavigationLabelProvider,Q.keyboardNavigationEventFilter??(()=>!0),T),this.disposables.add(this.typeNavigationController)}this.mouseController=this.createMouseController(Q),this.disposables.add(this.mouseController),this.onDidChangeFocus(this._onFocusChange,this,this.disposables),this.onDidChangeSelection(this._onSelectionChange,this,this.disposables),this.accessibilityProvider&&(this.ariaLabel=this.accessibilityProvider.getWidgetAriaLabel()),this._options.multipleSelectionSupport!==!1&&this.view.domNode.setAttribute("aria-multiselectable","true")}get onDidChangeFocus(){return l.Event.map(this.eventBufferer.wrapEvent(this.focus.onChange),h=>this.toListEvent(h),this.disposables)}get onDidChangeSelection(){return l.Event.map(this.eventBufferer.wrapEvent(this.selection.onChange),h=>this.toListEvent(h),this.disposables)}get domId(){return this.view.domId}get onDidScroll(){return this.view.onDidScroll}get onMouseClick(){return this.view.onMouseClick}get onMouseDblClick(){return this.view.onMouseDblClick}get onMouseMiddleClick(){return this.view.onMouseMiddleClick}get onPointer(){return this.mouseController.onPointer}get onMouseUp(){return this.view.onMouseUp}get onMouseDown(){return this.view.onMouseDown}get onMouseOver(){return this.view.onMouseOver}get onMouseMove(){return this.view.onMouseMove}get onMouseOut(){return this.view.onMouseOut}get onTouchStart(){return this.view.onTouchStart}get onTap(){return this.view.onTap}get onContextMenu(){let h=!1;const I=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event)).map(Q=>new M.StandardKeyboardEvent(Q)).filter(Q=>h=Q.keyCode===58||Q.shiftKey&&Q.keyCode===68).map(i.stopEvent).filter(()=>!1).event,U=this.disposables.add(l.Event.chain(this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event)).forEach(()=>h=!1).map(Q=>new M.StandardKeyboardEvent(Q)).filter(Q=>Q.keyCode===58||Q.shiftKey&&Q.keyCode===68).map(i.stopEvent).map(({browserEvent:Q})=>{const N=this.getFocus(),R=N.length?N[0]:void 0,z=typeof R!="undefined"?this.view.element(R):void 0,T=typeof R!="undefined"?this.view.domElement(R):this.view.domNode;return{index:R,element:z,anchor:T,browserEvent:Q}}).event,K=this.disposables.add(l.Event.chain(this.view.onContextMenu)).filter(Q=>!h).map(({element:Q,index:N,browserEvent:R})=>({element:Q,index:N,anchor:{x:R.pageX+1,y:R.pageY},browserEvent:R})).event;return l.Event.any(I,U,K)}get onKeyDown(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keydown")).event}get onKeyUp(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keyup")).event}get onKeyPress(){return this.disposables.add(new i.DomEmitter(this.view.domNode,"keypress")).event}get onDidFocus(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"focus",!0)).event)}get onDidBlur(){return l.Event.signal(this.disposables.add(new i.DomEmitter(this.view.domNode,"blur",!0)).event)}createMouseController(h){return new ue(this)}updateOptions(h={}){this._options={...this._options,...h},this.typeNavigationController?.updateOptions(this._options),this._options.multipleSelectionController!==void 0&&(this._options.multipleSelectionSupport?this.view.domNode.setAttribute("aria-multiselectable","true"):this.view.domNode.removeAttribute("aria-multiselectable")),this.mouseController.updateOptions(h),this.keyboardController?.updateOptions(h),this.view.updateOptions(h)}get options(){return this._options}splice(h,I,U=[]){if(h<0||h>this.view.length)throw new o.ListError(this.user,`Invalid start index: ${h}`);if(I<0)throw new o.ListError(this.user,`Invalid delete count: ${I}`);I===0&&U.length===0||this.eventBufferer.bufferEvents(()=>this.spliceable.splice(h,I,U))}updateWidth(h){this.view.updateWidth(h)}updateElementHeight(h,I){this.view.updateElementHeight(h,I,null)}rerender(){this.view.rerender()}element(h){return this.view.element(h)}indexOf(h){return this.view.indexOf(h)}get length(){return this.view.length}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.getScrollTop()}set scrollTop(h){this.view.setScrollTop(h)}get scrollLeft(){return this.view.getScrollLeft()}set scrollLeft(h){this.view.setScrollLeft(h)}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleIndex(){return this.view.firstVisibleIndex}get lastVisibleIndex(){return this.view.lastVisibleIndex}get ariaLabel(){return this._ariaLabel}set ariaLabel(h){this._ariaLabel=h,this.view.domNode.setAttribute("aria-label",h)}domFocus(){this.view.domNode.focus({preventScroll:!0})}layout(h,I){this.view.layout(h,I)}triggerTypeNavigation(){this.typeNavigationController?.trigger()}setSelection(h,I){for(const U of h)if(U<0||U>=this.length)throw new o.ListError(this.user,`Invalid index ${U}`);this.selection.set(h,I)}getSelection(){return this.selection.get()}getSelectedElements(){return this.getSelection().map(h=>this.view.element(h))}setAnchor(h){if(typeof h=="undefined"){this.anchor.set([]);return}if(h<0||h>=this.length)throw new o.ListError(this.user,`Invalid index ${h}`);this.anchor.set([h])}getAnchor(){return(0,g.firstOrDefault)(this.anchor.get(),void 0)}getAnchorElement(){const h=this.getAnchor();return typeof h=="undefined"?void 0:this.element(h)}setFocus(h,I){for(const U of h)if(U<0||U>=this.length)throw new o.ListError(this.user,`Invalid index ${U}`);this.focus.set(h,I)}focusNext(h=1,I=!1,U,K){if(this.length===0)return;const Q=this.focus.get(),N=this.findNextIndex(Q.length>0?Q[0]+h:0,I,K);N>-1&&this.setFocus([N],U)}focusPrevious(h=1,I=!1,U,K){if(this.length===0)return;const Q=this.focus.get(),N=this.findPreviousIndex(Q.length>0?Q[0]-h:0,I,K);N>-1&&this.setFocus([N],U)}async focusNextPage(h,I){let U=this.view.indexAt(this.view.getScrollTop()+this.view.renderHeight);U=U===0?0:U-1;const K=this.getFocus()[0];if(K!==U&&(K===void 0||U>K)){const Q=this.findPreviousIndex(U,!1,I);Q>-1&&K!==Q?this.setFocus([Q],h):this.setFocus([U],h)}else{const Q=this.view.getScrollTop();let N=Q+this.view.renderHeight;U>K&&(N-=this.view.elementHeight(U)),this.view.setScrollTop(N),this.view.getScrollTop()!==Q&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusNextPage(h,I))}}async focusPreviousPage(h,I){let U;const K=this.view.getScrollTop();K===0?U=this.view.indexAt(K):U=this.view.indexAfter(K-1);const Q=this.getFocus()[0];if(Q!==U&&(Q===void 0||Q>=U)){const N=this.findNextIndex(U,!1,I);N>-1&&Q!==N?this.setFocus([N],h):this.setFocus([U],h)}else{const N=K;this.view.setScrollTop(K-this.view.renderHeight),this.view.getScrollTop()!==N&&(this.setFocus([]),await(0,d.timeout)(0),await this.focusPreviousPage(h,I))}}focusLast(h,I){if(this.length===0)return;const U=this.findPreviousIndex(this.length-1,!1,I);U>-1&&this.setFocus([U],h)}focusFirst(h,I){this.focusNth(0,h,I)}focusNth(h,I,U){if(this.length===0)return;const K=this.findNextIndex(h,!1,U);K>-1&&this.setFocus([K],I)}findNextIndex(h,I=!1,U){for(let K=0;K<this.length;K++){if(h>=this.length&&!I)return-1;if(h=h%this.length,!U||U(this.element(h)))return h;h++}return-1}findPreviousIndex(h,I=!1,U){for(let K=0;K<this.length;K++){if(h<0&&!I)return-1;if(h=(this.length+h%this.length)%this.length,!U||U(this.element(h)))return h;h--}return-1}getFocus(){return this.focus.get()}getFocusedElements(){return this.getFocus().map(h=>this.view.element(h))}reveal(h,I){if(h<0||h>=this.length)throw new o.ListError(this.user,`Invalid index ${h}`);const U=this.view.getScrollTop(),K=this.view.elementTop(h),Q=this.view.elementHeight(h);if((0,y.isNumber)(I)){const N=Q-this.view.renderHeight;this.view.setScrollTop(N*(0,p.clamp)(I,0,1)+K)}else{const N=K+Q,R=U+this.view.renderHeight;K<U&&N>=R||(K<U||N>=R&&Q>=this.view.renderHeight?this.view.setScrollTop(K):N>=R&&this.view.setScrollTop(N-this.view.renderHeight))}}getRelativeTop(h){if(h<0||h>=this.length)throw new o.ListError(this.user,`Invalid index ${h}`);const I=this.view.getScrollTop(),U=this.view.elementTop(h),K=this.view.elementHeight(h);if(U<I||U+K>I+this.view.renderHeight)return null;const Q=K-this.view.renderHeight;return Math.abs((I-U)/Q)}isDOMFocused(){return this.view.domNode===document.activeElement}getHTMLElement(){return this.view.domNode}getElementID(h){return this.view.getElementDomId(h)}style(h){this.styleController.style(h)}toListEvent({indexes:h,browserEvent:I}){return{indexes:h,elements:h.map(U=>this.view.element(U)),browserEvent:I}}_onFocusChange(){const h=this.focus.get();this.view.domNode.classList.toggle("element-focused",h.length>0),this.onDidChangeActiveDescendant()}onDidChangeActiveDescendant(){const h=this.focus.get();if(h.length>0){let I;this.accessibilityProvider?.getActiveDescendantId&&(I=this.accessibilityProvider.getActiveDescendantId(this.view.element(h[0]))),this.view.domNode.setAttribute("aria-activedescendant",I||this.view.getElementDomId(h[0]))}else this.view.domNode.removeAttribute("aria-activedescendant")}_onSelectionChange(){const h=this.selection.get();this.view.domNode.classList.toggle("selection-none",h.length===0),this.view.domNode.classList.toggle("selection-single",h.length===1),this.view.domNode.classList.toggle("selection-multiple",h.length>1)}dispose(){this._onDidDispose.fire(),this.disposables.dispose(),this._onDidDispose.dispose()}}Ke([F.memoize],G.prototype,"onDidChangeFocus",null),Ke([F.memoize],G.prototype,"onDidChangeSelection",null),Ke([F.memoize],G.prototype,"onContextMenu",null),Ke([F.memoize],G.prototype,"onKeyDown",null),Ke([F.memoize],G.prototype,"onKeyUp",null),Ke([F.memoize],G.prototype,"onKeyPress",null),Ke([F.memoize],G.prototype,"onDidFocus",null),Ke([F.memoize],G.prototype,"onDidBlur",null),t.List=G}),define(me[59],pe([1,0,13,34,36,10,16]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseHrefAndDimensions=t.removeMarkdownEscapes=t.escapeDoubleQuotes=t.escapeMarkdownSyntaxTokens=t.markdownStringEqual=t.isMarkdownString=t.isEmptyMarkdownString=t.MarkdownString=t.MarkdownStringTextNewlineStyle=void 0;var w;(function(v){v[v.Paragraph=0]="Paragraph",v[v.Break=1]="Break"})(w=t.MarkdownStringTextNewlineStyle||(t.MarkdownStringTextNewlineStyle={}));class g{constructor(D="",y=!1){if(this.value=D,typeof this.value!="string")throw(0,E.illegalArgument)("value");typeof y=="boolean"?(this.isTrusted=y,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=y.isTrusted??void 0,this.supportThemeIcons=y.supportThemeIcons??!1,this.supportHtml=y.supportHtml??!1)}appendText(D,y=0){return this.value+=l(this.supportThemeIcons?(0,i.escapeIcons)(D):D).replace(/([ \t]+)/g,(o,c)=>"&nbsp;".repeat(c.length)).replace(/\>/gm,"\\>").replace(/\n/g,y===1?`\\
`:`

`),this}appendMarkdown(D){return this.value+=D,this}appendCodeblock(D,y){return this.value+="\n```",this.value+=D,this.value+=`
`,this.value+=y,this.value+="\n```\n",this}appendLink(D,y,o){return this.value+="[",this.value+=this._escape(y,"]"),this.value+="](",this.value+=this._escape(String(D),")"),o&&(this.value+=` "${this._escape(this._escape(o,'"'),")")}"`),this.value+=")",this}_escape(D,y){const o=new RegExp((0,O.escapeRegExpCharacters)(y),"g");return D.replace(o,(c,b)=>D.charAt(b-1)!=="\\"?`\\${c}`:c)}}t.MarkdownString=g;function d(v){return f(v)?!v.value:Array.isArray(v)?v.every(d):!0}t.isEmptyMarkdownString=d;function f(v){return v instanceof g?!0:v&&typeof v=="object"?typeof v.value=="string"&&(typeof v.isTrusted=="boolean"||v.isTrusted===void 0)&&(typeof v.supportThemeIcons=="boolean"||v.supportThemeIcons===void 0):!1}t.isMarkdownString=f;function F(v,D){return v===D?!0:!v||!D?!1:v.value===D.value&&v.isTrusted===D.isTrusted&&v.supportThemeIcons===D.supportThemeIcons&&v.supportHtml===D.supportHtml&&(v.baseUri===D.baseUri||!!v.baseUri&&!!D.baseUri&&(0,M.isEqual)(_.URI.from(v.baseUri),_.URI.from(D.baseUri)))}t.markdownStringEqual=F;function l(v){return v.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}t.escapeMarkdownSyntaxTokens=l;function s(v){return v.replace(/"/g,"&quot;")}t.escapeDoubleQuotes=s;function e(v){return v&&v.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}t.removeMarkdownEscapes=e;function p(v){const D=[],y=v.split("|").map(c=>c.trim());v=y[0];const o=y[1];if(o){const c=/height=(\d+)/.exec(o),b=/width=(\d+)/.exec(o),S=c?c[1]:"",A=b?b[1]:"",C=isFinite(parseInt(A)),r=isFinite(parseInt(S));C&&D.push(`width="${A}"`),r&&D.push(`height="${S}"`)}return{href:v,dimensions:D}}t.parseHrefAndDimensions=p}),define(me[120],pe([1,0,4,112,18,51,20,113,13,3,59,34,71,2,75,49,35,27,36,10,16]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s,e,p,v,D,y,o,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.renderMarkdownAsPlaintext=t.renderStringAsPlaintext=t.renderMarkdown=void 0;function b(a,u={},m={}){const W=new s.DisposableStore;let V=!1;const ne=(0,O.createElement)(u),re=function(fe){let te;try{te=(0,p.parse)(decodeURIComponent(fe))}catch{}return te?(te=(0,D.cloneAndChange)(te,X=>{if(a.uris&&a.uris[X])return c.URI.revive(a.uris[X])}),encodeURIComponent(JSON.stringify(te))):fe},we=function(fe,te){const X=a.uris&&a.uris[fe];let se=c.URI.revive(X);return te?fe.startsWith(v.Schemas.data+":")?fe:(se||(se=c.URI.parse(fe)),v.FileAccess.asBrowserUri(se).toString(!0)):!se||c.URI.parse(fe).toString()===se.toString()?fe:(se.query&&(se=se.with({query:re(se.query)})),se.toString())},ae=new e.marked.Renderer;ae.image=(fe,te,X)=>{let se=[],ie=[];return fe&&({href:fe,dimensions:se}=(0,f.parseHrefAndDimensions)(fe),ie.push(`src="${(0,f.escapeDoubleQuotes)(fe)}"`)),X&&ie.push(`alt="${(0,f.escapeDoubleQuotes)(X)}"`),te&&ie.push(`title="${(0,f.escapeDoubleQuotes)(te)}"`),se.length&&(ie=ie.concat(se)),"<img "+ie.join(" ")+">"},ae.link=(fe,te,X)=>typeof fe!="string"?"":(fe===X&&(X=(0,f.removeMarkdownEscapes)(X)),te=typeof te=="string"?(0,f.escapeDoubleQuotes)((0,f.removeMarkdownEscapes)(te)):"",fe=(0,f.removeMarkdownEscapes)(fe),fe=fe.replace(/&/g,"&amp;").replace(/</g,"&lt;").replace(/>/g,"&gt;").replace(/"/g,"&quot;").replace(/'/g,"&#39;"),`<a href="${fe}" title="${te||fe}">${X}</a>`),ae.paragraph=fe=>`<p>${fe}</p>`;const ve=[];if(u.codeBlockRenderer&&(ae.code=(fe,te)=>{const X=l.defaultGenerator.nextId(),se=u.codeBlockRenderer(te??"",fe);return ve.push(se.then(ie=>[X,ie])),`<div class="code" data-code="${X}">${(0,o.escape)(fe)}</div>`}),u.actionHandler){const fe=u.actionHandler.disposables.add(new M.DomEmitter(ne,"click")),te=u.actionHandler.disposables.add(new M.DomEmitter(ne,"auxclick"));u.actionHandler.disposables.add(d.Event.any(fe.event,te.event)(X=>{const se=new _.StandardMouseEvent(X);if(!se.leftButton&&!se.middleButton)return;let ie=se.target;if(!(ie.tagName!=="A"&&(ie=ie.parentElement,!ie||ie.tagName!=="A")))try{let L=ie.dataset.href;L&&(a.baseUri&&(L=S(c.URI.from(a.baseUri),L)),u.actionHandler.callback(L,se))}catch(L){(0,g.onUnexpectedError)(L)}finally{se.preventDefault()}}))}a.supportHtml||(m.sanitizer=fe=>(a.isTrusted?fe.match(/^(<span[^>]+>)|(<\/\s*span>)$/):void 0)?fe:"",m.sanitize=!0,m.silent=!0),m.renderer=ae;let ue=a.value??"";ue.length>1e5&&(ue=`${ue.substr(0,1e5)}\u2026`),a.supportThemeIcons&&(ue=(0,F.markdownEscapeEscapedIcons)(ue));let ge=e.marked.parse(ue,m);a.supportThemeIcons&&(ge=(0,w.renderLabelWithIcons)(ge).map(te=>typeof te=="string"?te:te.outerHTML).join(""));const ee=new DOMParser().parseFromString(A(a,ge),"text/html");if(ee.body.querySelectorAll("img").forEach(fe=>{const te=fe.getAttribute("src");if(te){let X=te;try{a.baseUri&&(X=S(c.URI.from(a.baseUri),X))}catch{}fe.src=we(X,!0)}}),ee.body.querySelectorAll("a").forEach(fe=>{const te=fe.getAttribute("href");if(fe.setAttribute("href",""),!te||/^data:|javascript:/i.test(te)||/^command:/i.test(te)&&!a.isTrusted||/^command:(\/\/\/)?_workbench\.downloadResource/i.test(te))fe.replaceWith(...fe.childNodes);else{let X=we(te,!1);a.baseUri&&(X=S(c.URI.from(a.baseUri),te)),fe.dataset.href=X}}),ne.innerHTML=A(a,ee.body.innerHTML),ve.length>0&&Promise.all(ve).then(fe=>{if(V)return;const te=new Map(fe),X=ne.querySelectorAll("div[data-code]");for(const se of X){const ie=te.get(se.dataset.code??"");ie&&E.reset(se,ie)}u.asyncRenderCallback?.()}),u.asyncRenderCallback)for(const fe of ne.getElementsByTagName("img")){const te=W.add(E.addDisposableListener(fe,"load",()=>{te.dispose(),u.asyncRenderCallback()}))}return{element:ne,dispose:()=>{V=!0,W.dispose()}}}t.renderMarkdown=b;function S(a,u){return/^\w[\w\d+.-]*:/.test(u)?u:a.path.endsWith("/")?(0,y.resolvePath)(a,u).toString():(0,y.resolvePath)((0,y.dirname)(a),u).toString()}function A(a,u){const{config:m,allowedSchemes:W}=C(a);i.addHook("uponSanitizeAttribute",(ne,re)=>{if(re.attrName==="style"||re.attrName==="class"){if(ne.tagName==="SPAN"){if(re.attrName==="style"){re.keepAttr=/^(color\:#[0-9a-fA-F]+;)?(background-color\:#[0-9a-fA-F]+;)?$/.test(re.attrValue);return}else if(re.attrName==="class"){re.keepAttr=/^codicon codicon-[a-z\-]+( codicon-modifier-[a-z\-]+)?$/.test(re.attrValue);return}}re.keepAttr=!1;return}});const V=E.hookDomPurifyHrefAndSrcSanitizer(W);try{return i.sanitize(u,{...m,RETURN_TRUSTED_TYPE:!0})}finally{i.removeHook("uponSanitizeAttribute"),V.dispose()}}function C(a){const u=[v.Schemas.http,v.Schemas.https,v.Schemas.mailto,v.Schemas.data,v.Schemas.file,v.Schemas.vscodeFileResource,v.Schemas.vscodeRemote,v.Schemas.vscodeRemoteResource];return a.isTrusted&&u.push(v.Schemas.command),{config:{ALLOWED_TAGS:["ul","li","p","b","i","code","blockquote","ol","h1","h2","h3","h4","h5","h6","hr","em","pre","table","thead","tbody","tr","th","td","div","del","a","strong","br","img","span"],ALLOWED_ATTR:["href","data-href","target","title","src","alt","class","style","data-code","width","height","align"],ALLOW_UNKNOWN_PROTOCOLS:!0},allowedSchemes:u}}function r(a){return typeof a=="string"?a:n(a)}t.renderStringAsPlaintext=r;function n(a){const u=new e.marked.Renderer;u.code=ne=>ne,u.blockquote=ne=>ne,u.html=ne=>"",u.heading=(ne,re,we)=>ne+`
`,u.hr=()=>"",u.list=(ne,re)=>ne,u.listitem=ne=>ne+`
`,u.paragraph=ne=>ne+`
`,u.table=(ne,re)=>ne+re+`
`,u.tablerow=ne=>ne,u.tablecell=(ne,re)=>ne+" ",u.strong=ne=>ne,u.em=ne=>ne,u.codespan=ne=>ne,u.br=()=>`
`,u.del=ne=>ne,u.image=(ne,re,we)=>"",u.text=ne=>ne,u.link=(ne,re,we)=>we;let m=a.value??"";m.length>1e5&&(m=`${m.substr(0,1e5)}\u2026`);const W=new Map([["&quot;",'"'],["&nbsp;"," "],["&amp;","&"],["&#39;","'"],["&lt;","<"],["&gt;",">"]]),V=e.marked.parse(m,{renderer:u}).replace(/&(#\d+|[a-zA-Z]+);/g,ne=>W.get(ne)??ne);return A({isTrusted:!1},V).toString()}t.renderMarkdownAsPlaintext=n}),define(me[121],pe([1,0,4,8,28,59,34,2,6,98]),function(Z,t,E,i,M,O,_,w,g,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.setupCustomHover=t.setupNativeHover=void 0;function f(s,e){(0,g.isString)(e)?s.title=(0,_.stripIcons)(e):e?.markdownNotSupportedFallback?s.title=e.markdownNotSupportedFallback:s.removeAttribute("title")}t.setupNativeHover=f;class F{constructor(e,p,v){this.hoverDelegate=e,this.target=p,this.fadeInAnimation=v}async update(e,p,v){if(this._cancellationTokenSource&&(this._cancellationTokenSource.dispose(!0),this._cancellationTokenSource=void 0),this.isDisposed)return;let D;if(e===void 0||(0,g.isString)(e)||e instanceof HTMLElement)D=e;else if(!(0,g.isFunction)(e.markdown))D=e.markdown??e.markdownNotSupportedFallback;else{this._hoverWidget||this.show((0,d.localize)(0,null),p),this._cancellationTokenSource=new M.CancellationTokenSource;const y=this._cancellationTokenSource.token;if(D=await e.markdown(y),D===void 0&&(D=e.markdownNotSupportedFallback),this.isDisposed||y.isCancellationRequested)return}this.show(D,p,v)}show(e,p,v){const D=this._hoverWidget;if(this.hasContent(e)){const y={content:e,target:this.target,showPointer:this.hoverDelegate.placement==="element",hoverPosition:2,skipFadeInAnimation:!this.fadeInAnimation||!!D,...v};this._hoverWidget=this.hoverDelegate.showHover(y,p)}D?.dispose()}hasContent(e){return e?(0,O.isMarkdownString)(e)?!!e.value:!0:!1}get isDisposed(){return this._hoverWidget?.isDisposed}dispose(){this._hoverWidget?.dispose(),this._cancellationTokenSource?.dispose(!0),this._cancellationTokenSource=void 0}}function l(s,e,p,v){let D,y;const o=(C,r)=>{C&&(y?.dispose(),y=void 0),r&&(D?.dispose(),D=void 0),s.onDidHideHover?.()},c=(C,r,n)=>new i.TimeoutTimer(async()=>{(!y||y.isDisposed)&&(y=new F(s,n||e,C>0),await y.update(p,r,v))},C),b=()=>{if(D)return;const C=new w.DisposableStore,r=u=>o(!1,u.fromElement===e);C.add(E.addDisposableListener(e,E.EventType.MOUSE_LEAVE,r,!0));const n=()=>o(!0,!0);C.add(E.addDisposableListener(e,E.EventType.MOUSE_DOWN,n,!0));const a={targetElements:[e],dispose:()=>{}};if(s.placement===void 0||s.placement==="mouse"){const u=m=>{a.x=m.x+10,m.target instanceof HTMLElement&&m.target.classList.contains("action-label")&&o(!0,!0)};C.add(E.addDisposableListener(e,E.EventType.MOUSE_MOVE,u,!0))}C.add(c(s.delay,!1,a)),D=C},S=E.addDisposableListener(e,E.EventType.MOUSE_OVER,b,!0);return{show:C=>{o(!1,!0),c(0,C)},hide:()=>{o(!0,!0)},update:async(C,r)=>{p=C,await y?.update(p,void 0,r)},dispose:()=>{S.dispose(),o(!0,!0)}}}t.setupCustomHover=l}),define(me[122],pe([1,0,4,18,19,120,58,14,3,43,2,5,100,91]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBoxList=void 0;const s=E.$,e="selectOption.entry.template";class p{get templateId(){return e}renderTemplate(y){const o=Object.create(null);return o.disposables=[],o.root=y,o.text=E.append(y,s(".option-text")),o.detail=E.append(y,s(".option-detail")),o.decoratorRight=E.append(y,s(".option-decorator-right")),o}renderElement(y,o,c){const b=c,S=y.text,A=y.detail,C=y.decoratorRight,r=y.isDisabled;b.text.textContent=S,b.detail.textContent=A||"",b.decoratorRight.innerText=C||"",r?b.root.classList.add("option-disabled"):b.root.classList.remove("option-disabled")}disposeTemplate(y){y.disposables=(0,f.dispose)(y.disposables)}}class v extends f.Disposable{constructor(y,o,c,b,S){super();this.options=[],this._currentSelection=0,this._hasDetails=!1,this._skipLayout=!1,this._sticky=!1,this._isVisible=!1,this.selectBoxOptions=S||Object.create(null),typeof this.selectBoxOptions.minBottomMargin!="number"?this.selectBoxOptions.minBottomMargin=v.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN:this.selectBoxOptions.minBottomMargin<0&&(this.selectBoxOptions.minBottomMargin=0),this.selectElement=document.createElement("select"),this.selectElement.className="monaco-select-box monaco-select-box-dropdown-padding",typeof this.selectBoxOptions.ariaLabel=="string"&&this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel),typeof this.selectBoxOptions.ariaDescription=="string"&&this.selectElement.setAttribute("aria-description",this.selectBoxOptions.ariaDescription),this._onDidSelect=new g.Emitter,this._register(this._onDidSelect),this.styles=b,this.registerListeners(),this.constructSelectDropDown(c),this.selected=o||0,y&&this.setOptions(y,o)}getHeight(){return 18}getTemplateId(){return e}constructSelectDropDown(y){this.contextViewProvider=y,this.selectDropDownContainer=E.$(".monaco-select-box-dropdown-container"),this.selectDropDownContainer.classList.add("monaco-select-box-dropdown-padding"),this.selectionDetailsPane=E.append(this.selectDropDownContainer,s(".select-box-details-pane"));const o=E.append(this.selectDropDownContainer,s(".select-box-dropdown-container-width-control")),c=E.append(o,s(".width-control-div"));this.widthControlElement=document.createElement("span"),this.widthControlElement.className="option-text-width-control",E.append(c,this.widthControlElement),this._dropDownPosition=0,this.styleElement=E.createStyleSheet(this.selectDropDownContainer),this.selectDropDownContainer.setAttribute("draggable","true"),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.DRAG_START,b=>{E.EventHelper.stop(b,!0)}))}registerListeners(){this._register(E.addStandardDisposableListener(this.selectElement,"change",o=>{this.selected=o.target.selectedIndex,this._onDidSelect.fire({index:o.target.selectedIndex,selected:o.target.value}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)})),this._register(E.addDisposableListener(this.selectElement,E.EventType.CLICK,o=>{E.EventHelper.stop(o),this._isVisible?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.MOUSE_DOWN,o=>{E.EventHelper.stop(o)}));let y;this._register(E.addDisposableListener(this.selectElement,"touchstart",o=>{y=this._isVisible})),this._register(E.addDisposableListener(this.selectElement,"touchend",o=>{E.EventHelper.stop(o),y?this.hideSelectDropDown(!0):this.showSelectDropDown()})),this._register(E.addDisposableListener(this.selectElement,E.EventType.KEY_DOWN,o=>{const c=new M.StandardKeyboardEvent(o);let b=!1;F.isMacintosh?(c.keyCode===18||c.keyCode===16||c.keyCode===10||c.keyCode===3)&&(b=!0):(c.keyCode===18&&c.altKey||c.keyCode===16&&c.altKey||c.keyCode===10||c.keyCode===3)&&(b=!0),b&&(this.showSelectDropDown(),E.EventHelper.stop(o,!0))}))}get onDidSelect(){return this._onDidSelect.event}setOptions(y,o){w.equals(this.options,y)||(this.options=y,this.selectElement.options.length=0,this._hasDetails=!1,this.options.forEach((c,b)=>{this.selectElement.add(this.createOption(c.text,b,c.isDisabled)),typeof c.description=="string"&&(this._hasDetails=!0)})),o!==void 0&&(this.select(o),this._currentSelection=this.selected)}setOptionsList(){this.selectList?.splice(0,this.selectList.length,this.options)}select(y){y>=0&&y<this.options.length?this.selected=y:y>this.options.length-1?this.select(this.options.length-1):this.selected<0&&(this.selected=0),this.selectElement.selectedIndex=this.selected,!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)}setAriaLabel(y){this.selectBoxOptions.ariaLabel=y,this.selectElement.setAttribute("aria-label",this.selectBoxOptions.ariaLabel)}focus(){this.selectElement&&(this.selectElement.tabIndex=0,this.selectElement.focus())}blur(){this.selectElement&&(this.selectElement.tabIndex=-1,this.selectElement.blur())}setFocusable(y){this.selectElement.tabIndex=y?0:-1}render(y){this.container=y,y.classList.add("select-container"),y.appendChild(this.selectElement),this.applyStyles()}style(y){const o=[];this.styles=y,this.styles.listFocusBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { background-color: ${this.styles.listFocusBackground} !important; }`),this.styles.listFocusForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { color: ${this.styles.listFocusForeground} !important; }`),this.styles.decoratorRightForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.focused) .option-decorator-right { color: ${this.styles.decoratorRightForeground}; }`),this.styles.selectBackground&&this.styles.selectBorder&&!this.styles.selectBorder.equals(this.styles.selectBackground)?(o.push(`.monaco-select-box-dropdown-container { border: 1px solid ${this.styles.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectBorder} } `)):this.styles.selectListBorder&&(o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-top { border-top: 1px solid ${this.styles.selectListBorder} } `),o.push(`.monaco-select-box-dropdown-container > .select-box-details-pane.border-bottom { border-bottom: 1px solid ${this.styles.selectListBorder} } `)),this.styles.listHoverForeground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { color: ${this.styles.listHoverForeground} !important; }`),this.styles.listHoverBackground&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { background-color: ${this.styles.listHoverBackground} !important; }`),this.styles.listFocusOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.focused { outline: 1.6px dotted ${this.styles.listFocusOutline} !important; outline-offset: -1.6px !important; }`),this.styles.listHoverOutline&&o.push(`.monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row:not(.option-disabled):not(.focused):hover { outline: 1.6px dashed ${this.styles.listHoverOutline} !important; outline-offset: -1.6px !important; }`),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled.focused { background-color: transparent !important; color: inherit !important; outline: none !important; }"),o.push(".monaco-select-box-dropdown-container > .select-box-dropdown-list-container .monaco-list .monaco-list-row.option-disabled:hover { background-color: transparent !important; color: inherit !important; outline: none !important; }"),this.styleElement.textContent=o.join(`
`),this.applyStyles()}applyStyles(){if(this.selectElement){const y=this.styles.selectBackground?this.styles.selectBackground.toString():"",o=this.styles.selectForeground?this.styles.selectForeground.toString():"",c=this.styles.selectBorder?this.styles.selectBorder.toString():"";this.selectElement.style.backgroundColor=y,this.selectElement.style.color=o,this.selectElement.style.borderColor=c}this.selectList&&this.styleList()}styleList(){if(this.selectList){const y=this.styles.selectBackground?this.styles.selectBackground.toString():"";this.selectList.style({});const o=this.styles.selectListBackground?this.styles.selectListBackground.toString():y;this.selectDropDownListContainer.style.backgroundColor=o,this.selectionDetailsPane.style.backgroundColor=o;const c=this.styles.focusBorder?this.styles.focusBorder.toString():"";this.selectDropDownContainer.style.outlineColor=c,this.selectDropDownContainer.style.outlineOffset="-1px"}}createOption(y,o,c){const b=document.createElement("option");return b.value=y,b.text=y,b.disabled=!!c,b}showSelectDropDown(){this.selectionDetailsPane.innerText="",!(!this.contextViewProvider||this._isVisible)&&(this.createSelectList(this.selectDropDownContainer),this.setOptionsList(),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:y=>this.renderSelectDropDown(y,!0),layout:()=>{this.layoutSelectDropDown()},onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._isVisible=!0,this.hideSelectDropDown(!1),this.contextViewProvider.showContextView({getAnchor:()=>this.selectElement,render:y=>this.renderSelectDropDown(y),layout:()=>this.layoutSelectDropDown(),onHide:()=>{this.selectDropDownContainer.classList.remove("visible"),this.selectElement.classList.remove("synthetic-focus")},anchorPosition:this._dropDownPosition},this.selectBoxOptions.optionsAsChildren?this.container:void 0),this._currentSelection=this.selected,this._isVisible=!0,this.selectElement.setAttribute("aria-expanded","true"))}hideSelectDropDown(y){!this.contextViewProvider||!this._isVisible||(this._isVisible=!1,this.selectElement.setAttribute("aria-expanded","false"),y&&this.selectElement.focus(),this.contextViewProvider.hideContextView())}renderSelectDropDown(y,o){return y.appendChild(this.selectDropDownContainer),this.layoutSelectDropDown(o),{dispose:()=>{try{y.removeChild(this.selectDropDownContainer)}catch{}}}}measureMaxDetailsHeight(){let y=0;return this.options.forEach((o,c)=>{this.updateDetail(c),this.selectionDetailsPane.offsetHeight>y&&(y=this.selectionDetailsPane.offsetHeight)}),y}layoutSelectDropDown(y){if(this._skipLayout)return!1;if(this.selectList){this.selectDropDownContainer.classList.add("visible");const o=E.getDomNodePagePosition(this.selectElement),c=getComputedStyle(this.selectElement),b=parseFloat(c.getPropertyValue("--dropdown-padding-top"))+parseFloat(c.getPropertyValue("--dropdown-padding-bottom")),S=window.innerHeight-o.top-o.height-(this.selectBoxOptions.minBottomMargin||0),A=o.top-v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN,C=this.selectElement.offsetWidth,r=this.setWidthControlElement(this.widthControlElement),n=Math.max(r,Math.round(C)).toString()+"px";this.selectDropDownContainer.style.width=n,this.selectList.getHTMLElement().style.height="",this.selectList.layout();let a=this.selectList.contentHeight;const u=this._hasDetails?this.measureMaxDetailsHeight():0,m=a+b+u,W=Math.floor((S-b-u)/this.getHeight()),V=Math.floor((A-b-u)/this.getHeight());if(y)return o.top+o.height>window.innerHeight-22||o.top<v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||W<1&&V<1?!1:(W<v.DEFAULT_MINIMUM_VISIBLE_OPTIONS&&V>W&&this.options.length>W?(this._dropDownPosition=1,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectionDetailsPane.classList.remove("border-top"),this.selectionDetailsPane.classList.add("border-bottom")):(this._dropDownPosition=0,this.selectDropDownContainer.removeChild(this.selectDropDownListContainer),this.selectDropDownContainer.removeChild(this.selectionDetailsPane),this.selectDropDownContainer.appendChild(this.selectDropDownListContainer),this.selectDropDownContainer.appendChild(this.selectionDetailsPane),this.selectionDetailsPane.classList.remove("border-bottom"),this.selectionDetailsPane.classList.add("border-top")),!0);if(o.top+o.height>window.innerHeight-22||o.top<v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN||this._dropDownPosition===0&&W<1||this._dropDownPosition===1&&V<1)return this.hideSelectDropDown(!0),!1;if(this._dropDownPosition===0){if(this._isVisible&&W+V<1)return this.hideSelectDropDown(!0),!1;m>S&&(a=W*this.getHeight())}else m>A&&(a=V*this.getHeight());return this.selectList.layout(a),this.selectList.domFocus(),this.selectList.length>0&&(this.selectList.setFocus([this.selected||0]),this.selectList.reveal(this.selectList.getFocus()[0]||0)),this._hasDetails?(this.selectList.getHTMLElement().style.height=a+b+"px",this.selectDropDownContainer.style.height=""):this.selectDropDownContainer.style.height=a+b+"px",this.updateDetail(this.selected),this.selectDropDownContainer.style.width=n,this.selectDropDownListContainer.setAttribute("tabindex","0"),this.selectElement.classList.add("synthetic-focus"),this.selectDropDownContainer.classList.add("synthetic-focus"),!0}else return!1}setWidthControlElement(y){let o=0;if(y){let c=0,b=0;this.options.forEach((S,A)=>{const C=S.detail?S.detail.length:0,r=S.decoratorRight?S.decoratorRight.length:0,n=S.text.length+C+r;n>b&&(c=A,b=n)}),y.textContent=this.options[c].text+(this.options[c].decoratorRight?this.options[c].decoratorRight+" ":""),o=E.getTotalWidth(y)}return o}createSelectList(y){if(this.selectList)return;this.selectDropDownListContainer=E.append(y,s(".select-box-dropdown-list-container")),this.listRenderer=new p,this.selectList=new _.List("SelectBoxCustom",this.selectDropDownListContainer,this,[this.listRenderer],{useShadows:!1,verticalScrollMode:3,keyboardSupport:!1,mouseSupport:!1,accessibilityProvider:{getAriaLabel:b=>{let S=b.text;return b.detail&&(S+=`. ${b.detail}`),b.decoratorRight&&(S+=`. ${b.decoratorRight}`),b.description&&(S+=`. ${b.description}`),S},getWidgetAriaLabel:()=>(0,l.localize)(0,null),getRole:()=>"option",getWidgetRole:()=>"listbox"}}),this.selectBoxOptions.ariaLabel&&(this.selectList.ariaLabel=this.selectBoxOptions.ariaLabel);const o=this._register(new i.DomEmitter(this.selectDropDownListContainer,"keydown")),c=g.Event.chain(o.event).filter(()=>this.selectList.length>0).map(b=>new M.StandardKeyboardEvent(b));this._register(c.filter(b=>b.keyCode===3).on(b=>this.onEnter(b),this)),this._register(c.filter(b=>b.keyCode===2).on(b=>this.onEnter(b),this)),this._register(c.filter(b=>b.keyCode===9).on(b=>this.onEscape(b),this)),this._register(c.filter(b=>b.keyCode===16).on(b=>this.onUpArrow(b),this)),this._register(c.filter(b=>b.keyCode===18).on(b=>this.onDownArrow(b),this)),this._register(c.filter(b=>b.keyCode===12).on(this.onPageDown,this)),this._register(c.filter(b=>b.keyCode===11).on(this.onPageUp,this)),this._register(c.filter(b=>b.keyCode===14).on(this.onHome,this)),this._register(c.filter(b=>b.keyCode===13).on(this.onEnd,this)),this._register(c.filter(b=>b.keyCode>=21&&b.keyCode<=56||b.keyCode>=80&&b.keyCode<=108).on(this.onCharacter,this)),this._register(E.addDisposableListener(this.selectList.getHTMLElement(),E.EventType.POINTER_UP,b=>this.onPointerUp(b))),this._register(this.selectList.onMouseOver(b=>typeof b.index!="undefined"&&this.selectList.setFocus([b.index]))),this._register(this.selectList.onDidChangeFocus(b=>this.onListFocus(b))),this._register(E.addDisposableListener(this.selectDropDownContainer,E.EventType.FOCUS_OUT,b=>{!this._isVisible||E.isAncestor(b.relatedTarget,this.selectDropDownContainer)||this.onListBlur()})),this.selectList.getHTMLElement().setAttribute("aria-label",this.selectBoxOptions.ariaLabel||""),this.selectList.getHTMLElement().setAttribute("aria-expanded","true"),this.styleList()}onPointerUp(y){if(!this.selectList.length)return;E.EventHelper.stop(y);const o=y.target;if(!o||o.classList.contains("slider"))return;const c=o.closest(".monaco-list-row");if(!c)return;const b=Number(c.getAttribute("data-index")),S=c.classList.contains("option-disabled");b>=0&&b<this.options.length&&!S&&(this.selected=b,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0))}onListBlur(){this._sticky||(this.selected!==this._currentSelection&&this.select(this._currentSelection),this.hideSelectDropDown(!1))}renderDescriptionMarkdown(y,o){const c=S=>{for(let A=0;A<S.childNodes.length;A++){const C=S.childNodes.item(A);(C.tagName&&C.tagName.toLowerCase())==="img"?S.removeChild(C):c(C)}},b=(0,O.renderMarkdown)({value:y},{actionHandler:o});return b.element.classList.add("select-box-description-markdown"),c(b.element),b.element}onListFocus(y){!this._isVisible||!this._hasDetails||this.updateDetail(y.indexes[0])}updateDetail(y){this.selectionDetailsPane.innerText="";const o=this.options[y],c=o?.description??"",b=o?.descriptionIsMarkdown??!1;if(c){if(b){const S=o.descriptionMarkdownActionHandler;this.selectionDetailsPane.appendChild(this.renderDescriptionMarkdown(c,S))}else this.selectionDetailsPane.innerText=c;this.selectionDetailsPane.style.display="block"}else this.selectionDetailsPane.style.display="none";this._skipLayout=!0,this.contextViewProvider.layout(),this._skipLayout=!1}onEscape(y){E.EventHelper.stop(y),this.select(this._currentSelection),this.hideSelectDropDown(!0)}onEnter(y){E.EventHelper.stop(y),this.selected!==this._currentSelection&&(this._currentSelection=this.selected,this._onDidSelect.fire({index:this.selectElement.selectedIndex,selected:this.options[this.selected].text}),!!this.options[this.selected]&&!!this.options[this.selected].text&&(this.selectElement.title=this.options[this.selected].text)),this.hideSelectDropDown(!0)}onDownArrow(y){if(this.selected<this.options.length-1){E.EventHelper.stop(y,!0);const o=this.options[this.selected+1].isDisabled;if(o&&this.options.length>this.selected+2)this.selected+=2;else{if(o)return;this.selected++}this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0])}}onUpArrow(y){this.selected>0&&(E.EventHelper.stop(y,!0),this.options[this.selected-1].isDisabled&&this.selected>1?this.selected-=2:this.selected--,this.select(this.selected),this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selectList.getFocus()[0]))}onPageUp(y){E.EventHelper.stop(y),this.selectList.focusPreviousPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected<this.options.length-1&&(this.selected++,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onPageDown(y){E.EventHelper.stop(y),this.selectList.focusNextPage(),setTimeout(()=>{this.selected=this.selectList.getFocus()[0],this.options[this.selected].isDisabled&&this.selected>0&&(this.selected--,this.selectList.setFocus([this.selected])),this.selectList.reveal(this.selected),this.select(this.selected)},1)}onHome(y){E.EventHelper.stop(y),!(this.options.length<2)&&(this.selected=0,this.options[this.selected].isDisabled&&this.selected>1&&this.selected++,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onEnd(y){E.EventHelper.stop(y),!(this.options.length<2)&&(this.selected=this.options.length-1,this.options[this.selected].isDisabled&&this.selected>1&&this.selected--,this.selectList.setFocus([this.selected]),this.selectList.reveal(this.selected),this.select(this.selected))}onCharacter(y){const o=d.KeyCodeUtils.toString(y.keyCode);let c=-1;for(let b=0;b<this.options.length-1;b++)if(c=(b+this.selected+1)%this.options.length,this.options[c].text.charAt(0).toUpperCase()===o&&!this.options[c].isDisabled){this.select(c),this.selectList.setFocus([c]),this.selectList.reveal(this.selectList.getFocus()[0]),E.EventHelper.stop(y);break}}dispose(){this.hideSelectDropDown(!1),super.dispose()}}t.SelectBoxList=v,v.DEFAULT_DROPDOWN_MINIMUM_BOTTOM_MARGIN=32,v.DEFAULT_DROPDOWN_MINIMUM_TOP_MARGIN=2,v.DEFAULT_MINIMUM_VISIBLE_OPTIONS=3}),define(me[123],pe([1,0,122,116,17,24,27,5,90]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectBox=t.defaultStyles=void 0,t.defaultStyles={selectBackground:O.Color.fromHex("#3C3C3C"),selectForeground:O.Color.fromHex("#F0F0F0"),selectBorder:O.Color.fromHex("#3C3C3C")};class g extends M.Widget{constructor(f,F,l,s=(0,_.deepClone)(t.defaultStyles),e){super();w.isMacintosh&&!e?.useCustomDrawn?this.selectBoxDelegate=new i.SelectBoxNative(f,F,s,e):this.selectBoxDelegate=new E.SelectBoxList(f,F,l,s,e),this._register(this.selectBoxDelegate)}get onDidSelect(){return this.selectBoxDelegate.onDidSelect}setOptions(f,F){this.selectBoxDelegate.setOptions(f,F)}select(f){this.selectBoxDelegate.select(f)}setAriaLabel(f){this.selectBoxDelegate.setAriaLabel(f)}focus(){this.selectBoxDelegate.focus()}blur(){this.selectBoxDelegate.blur()}setFocusable(f){this.selectBoxDelegate.setFocusable(f)}render(f){this.selectBoxDelegate.render(f)}style(f){this.selectBoxDelegate.style(f)}applyStyles(){this.selectBoxDelegate.applyStyles()}}t.SelectBox=g}),define(me[60],pe([1,0,15,50,4,22,121,123,32,2,5,6,95,46]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SelectActionViewItem=t.ActionViewItem=t.BaseActionViewItem=void 0;class s extends d.Disposable{constructor(D,y,o={}){super();this.options=o,this._context=D||this,this._action=y,y instanceof g.Action&&this._register(y.onDidChange(c=>{!this.element||this.handleActionChangeEvent(c)}))}get action(){return this._action}handleActionChangeEvent(D){D.enabled!==void 0&&this.updateEnabled(),D.checked!==void 0&&this.updateChecked(),D.class!==void 0&&this.updateClass(),D.label!==void 0&&(this.updateLabel(),this.updateTooltip()),D.tooltip!==void 0&&this.updateTooltip()}get actionRunner(){return this._actionRunner||(this._actionRunner=this._register(new g.ActionRunner)),this._actionRunner}set actionRunner(D){this._actionRunner=D}isEnabled(){return this._action.enabled}setActionContext(D){this._context=D}render(D){const y=this.element=D;this._register(O.Gesture.addTarget(D));const o=this.options&&this.options.draggable;o&&(D.draggable=!0,E.isFirefox&&this._register((0,M.addDisposableListener)(D,M.EventType.DRAG_START,c=>c.dataTransfer?.setData(i.DataTransfers.TEXT,this._action.label)))),this._register((0,M.addDisposableListener)(y,O.EventType.Tap,c=>this.onClick(c,!0))),this._register((0,M.addDisposableListener)(y,M.EventType.MOUSE_DOWN,c=>{o||M.EventHelper.stop(c,!0),this._action.enabled&&c.button===0&&y.classList.add("active")})),f.isMacintosh&&this._register((0,M.addDisposableListener)(y,M.EventType.CONTEXT_MENU,c=>{c.button===0&&c.ctrlKey===!0&&this.onClick(c)})),this._register((0,M.addDisposableListener)(y,M.EventType.CLICK,c=>{M.EventHelper.stop(c,!0),this.options&&this.options.isMenu||this.onClick(c)})),this._register((0,M.addDisposableListener)(y,M.EventType.DBLCLICK,c=>{M.EventHelper.stop(c,!0)})),[M.EventType.MOUSE_UP,M.EventType.MOUSE_OUT].forEach(c=>{this._register((0,M.addDisposableListener)(y,c,b=>{M.EventHelper.stop(b),y.classList.remove("active")}))})}onClick(D,y=!1){M.EventHelper.stop(D,!0);const o=F.isUndefinedOrNull(this._context)?this.options?.useEventAsContext?D:{preserveFocus:y}:this._context;this.actionRunner.run(this._action,o)}focus(){this.element&&(this.element.tabIndex=0,this.element.focus(),this.element.classList.add("focused"))}isFocused(){return!!this.element?.classList.contains("focused")}blur(){this.element&&(this.element.blur(),this.element.tabIndex=-1,this.element.classList.remove("focused"))}setFocusable(D){this.element&&(this.element.tabIndex=D?0:-1)}get trapsArrowNavigation(){return!1}updateEnabled(){}updateLabel(){}getTooltip(){return this.action.tooltip}updateTooltip(){if(!this.element)return;const D=this.getTooltip()??"";this.element.setAttribute("aria-label",D),this.options.hoverDelegate?(this.element.title="",this.customHover?this.customHover.update(D):(this.customHover=(0,_.setupCustomHover)(this.options.hoverDelegate,this.element,D),this._store.add(this.customHover))):this.element.title=D}updateClass(){}updateChecked(){}dispose(){this.element&&(this.element.remove(),this.element=void 0),super.dispose()}}t.BaseActionViewItem=s;class e extends s{constructor(D,y,o={}){super(D,y,o);this.options=o,this.options.icon=o.icon!==void 0?o.icon:!1,this.options.label=o.label!==void 0?o.label:!0,this.cssClass=""}render(D){super.render(D),this.element&&(this.label=(0,M.append)(this.element,(0,M.$)("a.action-label"))),this.label&&(this._action.id===g.Separator.ID?this.label.setAttribute("role","presentation"):this.options.isMenu?this.label.setAttribute("role","menuitem"):this.label.setAttribute("role","button")),this.options.label&&this.options.keybinding&&this.element&&((0,M.append)(this.element,(0,M.$)("span.keybinding")).textContent=this.options.keybinding),this.updateClass(),this.updateLabel(),this.updateTooltip(),this.updateEnabled(),this.updateChecked()}focus(){this.label&&(this.label.tabIndex=0,this.label.focus())}isFocused(){return!!this.label&&this.label?.tabIndex===0}blur(){this.label&&(this.label.tabIndex=-1)}setFocusable(D){this.label&&(this.label.tabIndex=D?0:-1)}updateLabel(){this.options.label&&this.label&&(this.label.textContent=this.action.label)}getTooltip(){let D=null;return this.action.tooltip?D=this.action.tooltip:!this.options.label&&this.action.label&&this.options.icon&&(D=this.action.label,this.options.keybinding&&(D=l.localize(0,null,D,this.options.keybinding))),D??void 0}updateClass(){this.cssClass&&this.label&&this.label.classList.remove(...this.cssClass.split(" ")),this.options.icon?(this.cssClass=this.action.class,this.label&&(this.label.classList.add("codicon"),this.cssClass&&this.label.classList.add(...this.cssClass.split(" "))),this.updateEnabled()):this.label?.classList.remove("codicon")}updateEnabled(){this.action.enabled?(this.label&&(this.label.removeAttribute("aria-disabled"),this.label.classList.remove("disabled")),this.element?.classList.remove("disabled")):(this.label&&(this.label.setAttribute("aria-disabled","true"),this.label.classList.add("disabled")),this.element?.classList.add("disabled"))}updateChecked(){this.label&&(this.action.checked?this.label.classList.add("checked"):this.label.classList.remove("checked"))}}t.ActionViewItem=e;class p extends s{constructor(D,y,o,c,b,S){super(D,y);this.selectBox=new w.SelectBox(o,c,b,void 0,S),this.selectBox.setFocusable(!1),this._register(this.selectBox),this.registerListeners()}setOptions(D,y){this.selectBox.setOptions(D,y)}select(D){this.selectBox.select(D)}registerListeners(){this._register(this.selectBox.onDidSelect(D=>{this.actionRunner.run(this._action,this.getActionContext(D.selected,D.index))}))}getActionContext(D,y){return D}setFocusable(D){this.selectBox.setFocusable(D)}focus(){this.selectBox?.focus()}blur(){this.selectBox?.blur()}render(D){this.selectBox.render(D)}}t.SelectActionViewItem=p}),define(me[61],pe([1,0,4,19,60,32,3,2,6,46]),function(Z,t,E,i,M,O,_,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prepareActions=t.ActionBar=t.ActionsOrientation=void 0;var d;(function(l){l[l.HORIZONTAL=0]="HORIZONTAL",l[l.VERTICAL=1]="VERTICAL"})(d=t.ActionsOrientation||(t.ActionsOrientation={}));class f extends w.Disposable{constructor(s,e={}){super();this.triggerKeyDown=!1,this.focusable=!0,this._onDidBlur=this._register(new _.Emitter),this.onDidBlur=this._onDidBlur.event,this._onDidCancel=this._register(new _.Emitter({onFirstListenerAdd:()=>this.cancelHasListener=!0})),this.onDidCancel=this._onDidCancel.event,this.cancelHasListener=!1,this._onDidRun=this._register(new _.Emitter),this.onDidRun=this._onDidRun.event,this._onBeforeRun=this._register(new _.Emitter),this.onBeforeRun=this._onBeforeRun.event,this.options=e,this._context=e.context??null,this._orientation=this.options.orientation??0,this._triggerKeys={keyDown:this.options.triggerKeys?.keyDown??!1,keys:this.options.triggerKeys?.keys??[3,10]},this.options.actionRunner?this._actionRunner=this.options.actionRunner:(this._actionRunner=new O.ActionRunner,this._register(this._actionRunner)),this._register(this._actionRunner.onDidRun(D=>this._onDidRun.fire(D))),this._register(this._actionRunner.onBeforeRun(D=>this._onBeforeRun.fire(D))),this._actionIds=[],this.viewItems=[],this.viewItemDisposables=new Map,this.focusedItem=void 0,this.domNode=document.createElement("div"),this.domNode.className="monaco-action-bar",e.animated!==!1&&this.domNode.classList.add("animated");let p,v;switch(this._orientation){case 0:p=[15],v=[17];break;case 1:p=[16],v=[18],this.domNode.className+=" vertical";break}this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_DOWN,D=>{const y=new i.StandardKeyboardEvent(D);let o=!0;const c=typeof this.focusedItem=="number"?this.viewItems[this.focusedItem]:void 0;p&&(y.equals(p[0])||y.equals(p[1]))?o=this.focusPrevious():v&&(y.equals(v[0])||y.equals(v[1]))?o=this.focusNext():y.equals(9)&&this.cancelHasListener?this._onDidCancel.fire():y.equals(14)?o=this.focusFirst():y.equals(13)?o=this.focusLast():y.equals(2)&&c instanceof M.BaseActionViewItem&&c.trapsArrowNavigation?o=this.focusNext():this.isTriggerKeyEvent(y)?this._triggerKeys.keyDown?this.doTrigger(y):this.triggerKeyDown=!0:o=!1,o&&(y.preventDefault(),y.stopPropagation())})),this._register(E.addDisposableListener(this.domNode,E.EventType.KEY_UP,D=>{const y=new i.StandardKeyboardEvent(D);this.isTriggerKeyEvent(y)?(!this._triggerKeys.keyDown&&this.triggerKeyDown&&(this.triggerKeyDown=!1,this.doTrigger(y)),y.preventDefault(),y.stopPropagation()):(y.equals(2)||y.equals(1024|2))&&this.updateFocusedItem()})),this.focusTracker=this._register(E.trackFocus(this.domNode)),this._register(this.focusTracker.onDidBlur(()=>{(E.getActiveElement()===this.domNode||!E.isAncestor(E.getActiveElement(),this.domNode))&&(this._onDidBlur.fire(),this.focusedItem=void 0,this.previouslyFocusedItem=void 0,this.triggerKeyDown=!1)})),this._register(this.focusTracker.onDidFocus(()=>this.updateFocusedItem())),this.actionsList=document.createElement("ul"),this.actionsList.className="actions-container",this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"),this.options.ariaLabel&&this.actionsList.setAttribute("aria-label",this.options.ariaLabel),this.domNode.appendChild(this.actionsList),s.appendChild(this.domNode)}refreshRole(){this.length()>=2?this.actionsList.setAttribute("role",this.options.ariaRole||"toolbar"):this.actionsList.setAttribute("role","presentation")}setAriaLabel(s){s?this.actionsList.setAttribute("aria-label",s):this.actionsList.removeAttribute("aria-label")}setFocusable(s){if(this.focusable=s,this.focusable){const e=this.viewItems.find(p=>p instanceof M.BaseActionViewItem&&p.isEnabled());e instanceof M.BaseActionViewItem&&e.setFocusable(!0)}else this.viewItems.forEach(e=>{e instanceof M.BaseActionViewItem&&e.setFocusable(!1)})}isTriggerKeyEvent(s){let e=!1;return this._triggerKeys.keys.forEach(p=>{e=e||s.equals(p)}),e}updateFocusedItem(){for(let s=0;s<this.actionsList.children.length;s++){const e=this.actionsList.children[s];if(E.isAncestor(E.getActiveElement(),e)){this.focusedItem=s;break}}}get context(){return this._context}set context(s){this._context=s,this.viewItems.forEach(e=>e.setActionContext(s))}get actionRunner(){return this._actionRunner}set actionRunner(s){s&&(this._actionRunner=s,this.viewItems.forEach(e=>e.actionRunner=s))}getContainer(){return this.domNode}hasAction(s){return this._actionIds.includes(s.id)}getAction(s){return this.viewItems[s].action}push(s,e={}){const p=Array.isArray(s)?s:[s];let v=g.isNumber(e.index)?e.index:null;p.forEach(D=>{const y=document.createElement("li");y.className="action-item",y.setAttribute("role","presentation");let o;this.options.actionViewItemProvider&&(o=this.options.actionViewItemProvider(D)),o||(o=new M.ActionViewItem(this.context,D,{hoverDelegate:this.options.hoverDelegate,...e})),this.options.allowContextMenu||this.viewItemDisposables.set(o,E.addDisposableListener(y,E.EventType.CONTEXT_MENU,c=>{E.EventHelper.stop(c,!0)})),o.actionRunner=this._actionRunner,o.setActionContext(this.context),o.render(y),this.focusable&&o instanceof M.BaseActionViewItem&&this.viewItems.length===0&&o.setFocusable(!0),v===null||v<0||v>=this.actionsList.children.length?(this.actionsList.appendChild(y),this.viewItems.push(o),this._actionIds.push(D.id)):(this.actionsList.insertBefore(y,this.actionsList.children[v]),this.viewItems.splice(v,0,o),this._actionIds.splice(v,0,D.id),v++)}),typeof this.focusedItem=="number"&&this.focus(this.focusedItem),this.refreshRole()}getWidth(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientWidth}return 0}getHeight(s){if(s>=0&&s<this.actionsList.children.length){const e=this.actionsList.children.item(s);if(e)return e.clientHeight}return 0}pull(s){s>=0&&s<this.viewItems.length&&(this.actionsList.removeChild(this.actionsList.childNodes[s]),this.viewItemDisposables.get(this.viewItems[s])?.dispose(),this.viewItemDisposables.delete(this.viewItems[s]),(0,w.dispose)(this.viewItems.splice(s,1)),this._actionIds.splice(s,1),this.refreshRole())}clear(){(0,w.dispose)(this.viewItems),this.viewItemDisposables.forEach(s=>s.dispose()),this.viewItemDisposables.clear(),this.viewItems=[],this._actionIds=[],E.clearNode(this.actionsList),this.refreshRole()}length(){return this.viewItems.length}isEmpty(){return this.viewItems.length===0}focus(s){let e=!1,p;if(s===void 0?e=!0:typeof s=="number"?p=s:typeof s=="boolean"&&(e=s),e&&typeof this.focusedItem=="undefined"){const v=this.viewItems.findIndex(D=>D.isEnabled());this.focusedItem=v===-1?void 0:v,this.updateFocus(void 0,void 0,!0)}else p!==void 0&&(this.focusedItem=p),this.updateFocus(void 0,void 0,!0)}focusFirst(){return this.focusedItem=this.length()-1,this.focusNext(!0)}focusLast(){return this.focusedItem=0,this.focusPrevious(!0)}focusNext(s){if(typeof this.focusedItem=="undefined")this.focusedItem=this.viewItems.length-1;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let p;do{if(!s&&this.options.preventLoopNavigation&&this.focusedItem+1>=this.viewItems.length)return this.focusedItem=e,!1;this.focusedItem=(this.focusedItem+1)%this.viewItems.length,p=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!p.isEnabled()||p.action.id===O.Separator.ID));return this.updateFocus(),!0}focusPrevious(s){if(typeof this.focusedItem=="undefined")this.focusedItem=0;else if(this.viewItems.length<=1)return!1;const e=this.focusedItem;let p;do{if(this.focusedItem=this.focusedItem-1,this.focusedItem<0){if(!s&&this.options.preventLoopNavigation)return this.focusedItem=e,!1;this.focusedItem=this.viewItems.length-1}p=this.viewItems[this.focusedItem]}while(this.focusedItem!==e&&(this.options.focusOnlyEnabledItems&&!p.isEnabled()||p.action.id===O.Separator.ID));return this.updateFocus(!0),!0}updateFocus(s,e,p=!1){typeof this.focusedItem=="undefined"&&this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem!==void 0&&this.previouslyFocusedItem!==this.focusedItem&&this.viewItems[this.previouslyFocusedItem]?.blur();const v=this.focusedItem!==void 0&&this.viewItems[this.focusedItem];if(v){let D=!0;g.isFunction(v.focus)||(D=!1),this.options.focusOnlyEnabledItems&&g.isFunction(v.isEnabled)&&!v.isEnabled()&&(D=!1),v.action.id===O.Separator.ID&&(D=!1),D?(p||this.previouslyFocusedItem!==this.focusedItem)&&(v.focus(s),this.previouslyFocusedItem=this.focusedItem):(this.actionsList.focus({preventScroll:e}),this.previouslyFocusedItem=void 0)}}doTrigger(s){if(typeof this.focusedItem=="undefined")return;const e=this.viewItems[this.focusedItem];if(e instanceof M.BaseActionViewItem){const p=e._context===null||e._context===void 0?s:e._context;this.run(e._action,p)}}async run(s,e){await this._actionRunner.run(s,e)}dispose(){(0,w.dispose)(this.viewItems),this.viewItems=[],this._actionIds=[],this.getContainer().remove(),super.dispose()}}t.ActionBar=f;function F(l){if(!l.length)return l;let s=-1;for(let p=0;p<l.length;p++)if(l[p].id!==O.Separator.ID){s=p;break}if(s===-1)return[];l=l.slice(s);for(let p=l.length-1;p>=0&&l[p].id===O.Separator.ID;p--)l.splice(p,1);let e=!1;for(let p=l.length-1;p>=0;p--){const v=l[p].id===O.Separator.ID;v&&!e?l.splice(p,1):v?v&&(e=!1):e=!0}return l}t.prepareActions=F}),define(me[124],pe([1,0,4,18,51,61,53,56,17,24,3,77,27,99,87]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.HistoryInputBox=t.InputBox=t.MessageType=void 0;const e=E.$;var p;(function(o){o[o.INFO=1]="INFO",o[o.WARNING=2]="WARNING",o[o.ERROR=3]="ERROR"})(p=t.MessageType||(t.MessageType={}));const v={inputBackground:d.Color.fromHex("#3C3C3C"),inputForeground:d.Color.fromHex("#CCCCCC"),inputValidationInfoBorder:d.Color.fromHex("#55AAFF"),inputValidationInfoBackground:d.Color.fromHex("#063B49"),inputValidationWarningBorder:d.Color.fromHex("#B89500"),inputValidationWarningBackground:d.Color.fromHex("#352A05"),inputValidationErrorBorder:d.Color.fromHex("#BE1100"),inputValidationErrorBackground:d.Color.fromHex("#5A1D1D")};class D extends g.Widget{constructor(c,b,S){super();this.state="idle",this.maxHeight=Number.POSITIVE_INFINITY,this._onDidChange=this._register(new f.Emitter),this.onDidChange=this._onDidChange.event,this._onDidHeightChange=this._register(new f.Emitter),this.onDidHeightChange=this._onDidHeightChange.event,this.contextViewProvider=b,this.options=S||Object.create(null),(0,l.mixin)(this.options,v,!1),this.message=null,this.placeholder=this.options.placeholder||"",this.tooltip=this.options.tooltip??(this.placeholder||""),this.ariaLabel=this.options.ariaLabel||"",this.inputBackground=this.options.inputBackground,this.inputForeground=this.options.inputForeground,this.inputBorder=this.options.inputBorder,this.inputValidationInfoBorder=this.options.inputValidationInfoBorder,this.inputValidationInfoBackground=this.options.inputValidationInfoBackground,this.inputValidationInfoForeground=this.options.inputValidationInfoForeground,this.inputValidationWarningBorder=this.options.inputValidationWarningBorder,this.inputValidationWarningBackground=this.options.inputValidationWarningBackground,this.inputValidationWarningForeground=this.options.inputValidationWarningForeground,this.inputValidationErrorBorder=this.options.inputValidationErrorBorder,this.inputValidationErrorBackground=this.options.inputValidationErrorBackground,this.inputValidationErrorForeground=this.options.inputValidationErrorForeground,this.options.validationOptions&&(this.validation=this.options.validationOptions.validation),this.element=E.append(c,e(".monaco-inputbox.idle"));const A=this.options.flexibleHeight?"textarea":"input",C=E.append(this.element,e(".ibwrapper"));if(this.input=E.append(C,e(A+".input.empty")),this.input.setAttribute("autocorrect","off"),this.input.setAttribute("autocapitalize","off"),this.input.setAttribute("spellcheck","false"),this.onfocus(this.input,()=>this.element.classList.add("synthetic-focus")),this.onblur(this.input,()=>this.element.classList.remove("synthetic-focus")),this.options.flexibleHeight){this.maxHeight=typeof this.options.flexibleMaxHeight=="number"?this.options.flexibleMaxHeight:Number.POSITIVE_INFINITY,this.mirror=E.append(C,e("div.mirror")),this.mirror.innerText="\xA0",this.scrollableElement=new w.ScrollableElement(this.element,{vertical:1}),this.options.flexibleWidth&&(this.input.setAttribute("wrap","off"),this.mirror.style.whiteSpace="pre",this.mirror.style.wordWrap="initial"),E.append(c,this.scrollableElement.getDomNode()),this._register(this.scrollableElement),this._register(this.scrollableElement.onScroll(a=>this.input.scrollTop=a.scrollTop));const r=this._register(new i.DomEmitter(document,"selectionchange")),n=f.Event.filter(r.event,()=>document.getSelection()?.anchorNode===C);this._register(n(this.updateScrollDimensions,this)),this._register(this.onDidHeightChange(this.updateScrollDimensions,this))}else this.input.type=this.options.type||"text",this.input.setAttribute("wrap","off");this.ariaLabel&&this.input.setAttribute("aria-label",this.ariaLabel),this.placeholder&&!this.options.showPlaceholderOnFocus&&this.setPlaceHolder(this.placeholder),this.tooltip&&this.setTooltip(this.tooltip),this.oninput(this.input,()=>this.onValueChange()),this.onblur(this.input,()=>this.onBlur()),this.onfocus(this.input,()=>this.onFocus()),this.ignoreGesture(this.input),setTimeout(()=>this.updateMirror(),0),this.options.actions&&(this.actionbar=this._register(new O.ActionBar(this.element)),this.actionbar.push(this.options.actions,{icon:!0,label:!1})),this.applyStyles()}onBlur(){this._hideMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder","")}onFocus(){this._showMessage(),this.options.showPlaceholderOnFocus&&this.input.setAttribute("placeholder",this.placeholder||"")}setPlaceHolder(c){this.placeholder=c,this.input.setAttribute("placeholder",c)}setTooltip(c){this.tooltip=c,this.input.title=c}setAriaLabel(c){this.ariaLabel=c,c?this.input.setAttribute("aria-label",this.ariaLabel):this.input.removeAttribute("aria-label")}getAriaLabel(){return this.ariaLabel}get mirrorElement(){return this.mirror}get inputElement(){return this.input}get value(){return this.input.value}set value(c){this.input.value!==c&&(this.input.value=c,this.onValueChange())}get height(){return typeof this.cachedHeight=="number"?this.cachedHeight:E.getTotalHeight(this.element)}focus(){this.input.focus()}blur(){this.input.blur()}hasFocus(){return document.activeElement===this.input}select(c=null){this.input.select(),c&&(this.input.setSelectionRange(c.start,c.end),c.end===this.input.value.length&&(this.input.scrollLeft=this.input.scrollWidth))}isSelectionAtEnd(){return this.input.selectionEnd===this.input.value.length&&this.input.selectionStart===this.input.selectionEnd}enable(){this.input.removeAttribute("disabled")}disable(){this.blur(),this.input.disabled=!0,this._hideMessage()}setEnabled(c){c?this.enable():this.disable()}get width(){return E.getTotalWidth(this.input)}set width(c){if(this.options.flexibleHeight&&this.options.flexibleWidth){let b=0;if(this.mirror){const S=parseFloat(this.mirror.style.paddingLeft||"")||0,A=parseFloat(this.mirror.style.paddingRight||"")||0;b=S+A}this.input.style.width=c-b+"px"}else this.input.style.width=c+"px";this.mirror&&(this.mirror.style.width=c+"px")}set paddingRight(c){this.input.style.width=`calc(100% - ${c}px)`,this.mirror&&(this.mirror.style.paddingRight=c+"px")}updateScrollDimensions(){if(typeof this.cachedContentHeight!="number"||typeof this.cachedHeight!="number"||!this.scrollableElement)return;const c=this.cachedContentHeight,b=this.cachedHeight,S=this.input.scrollTop;this.scrollableElement.setScrollDimensions({scrollHeight:c,height:b}),this.scrollableElement.setScrollPosition({scrollTop:S})}showMessage(c,b){this.message=c,this.element.classList.remove("idle"),this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add(this.classForType(c.type));const S=this.stylesForType(this.message.type);this.element.style.border=S.border?`1px solid ${S.border}`:"",(this.hasFocus()||b)&&this._showMessage()}hideMessage(){this.message=null,this.element.classList.remove("info"),this.element.classList.remove("warning"),this.element.classList.remove("error"),this.element.classList.add("idle"),this._hideMessage(),this.applyStyles()}isInputValid(){return!!this.validation&&!this.validation(this.value)}validate(){let c=null;return this.validation&&(c=this.validation(this.value),c?(this.inputElement.setAttribute("aria-invalid","true"),this.showMessage(c)):this.inputElement.hasAttribute("aria-invalid")&&(this.inputElement.removeAttribute("aria-invalid"),this.hideMessage())),c?.type}stylesForType(c){switch(c){case 1:return{border:this.inputValidationInfoBorder,background:this.inputValidationInfoBackground,foreground:this.inputValidationInfoForeground};case 2:return{border:this.inputValidationWarningBorder,background:this.inputValidationWarningBackground,foreground:this.inputValidationWarningForeground};default:return{border:this.inputValidationErrorBorder,background:this.inputValidationErrorBackground,foreground:this.inputValidationErrorForeground}}}classForType(c){switch(c){case 1:return"info";case 2:return"warning";default:return"error"}}_showMessage(){if(!this.contextViewProvider||!this.message)return;let c;const b=()=>c.style.width=E.getTotalWidth(this.element)+"px";this.contextViewProvider.showContextView({getAnchor:()=>this.element,anchorAlignment:1,render:A=>{if(!this.message)return null;c=E.append(A,e(".monaco-inputbox-container")),b();const C={inline:!0,className:"monaco-inputbox-message"},r=this.message.formatContent?(0,M.renderFormattedText)(this.message.content,C):(0,M.renderText)(this.message.content,C);r.classList.add(this.classForType(this.message.type));const n=this.stylesForType(this.message.type);return r.style.backgroundColor=n.background?n.background.toString():"",r.style.color=n.foreground?n.foreground.toString():"",r.style.border=n.border?`1px solid ${n.border}`:"",E.append(c,r),null},onHide:()=>{this.state="closed"},layout:b});let S;this.message.type===3?S=s.localize(0,null,this.message.content):this.message.type===2?S=s.localize(1,null,this.message.content):S=s.localize(2,null,this.message.content),_.alert(S),this.state="open"}_hideMessage(){!this.contextViewProvider||(this.state==="open"&&this.contextViewProvider.hideContextView(),this.state="idle")}onValueChange(){this._onDidChange.fire(this.value),this.validate(),this.updateMirror(),this.input.classList.toggle("empty",!this.value),this.state==="open"&&this.contextViewProvider&&this.contextViewProvider.layout()}updateMirror(){if(!this.mirror)return;const c=this.value,S=c.charCodeAt(c.length-1)===10?" ":"";(c+S).replace(/\u000c/g,"")?this.mirror.textContent=c+S:this.mirror.innerText="\xA0",this.layout()}style(c){this.inputBackground=c.inputBackground,this.inputForeground=c.inputForeground,this.inputBorder=c.inputBorder,this.inputValidationInfoBackground=c.inputValidationInfoBackground,this.inputValidationInfoForeground=c.inputValidationInfoForeground,this.inputValidationInfoBorder=c.inputValidationInfoBorder,this.inputValidationWarningBackground=c.inputValidationWarningBackground,this.inputValidationWarningForeground=c.inputValidationWarningForeground,this.inputValidationWarningBorder=c.inputValidationWarningBorder,this.inputValidationErrorBackground=c.inputValidationErrorBackground,this.inputValidationErrorForeground=c.inputValidationErrorForeground,this.inputValidationErrorBorder=c.inputValidationErrorBorder,this.applyStyles()}applyStyles(){const c=this.inputBackground?this.inputBackground.toString():"",b=this.inputForeground?this.inputForeground.toString():"",S=this.inputBorder?this.inputBorder.toString():"";this.element.style.backgroundColor=c,this.element.style.color=b,this.input.style.backgroundColor="inherit",this.input.style.color=b,this.element.style.borderWidth=S?"1px":"",this.element.style.borderStyle=S?"solid":"",this.element.style.borderColor=S}layout(){if(!this.mirror)return;const c=this.cachedContentHeight;this.cachedContentHeight=E.getTotalHeight(this.mirror),c!==this.cachedContentHeight&&(this.cachedHeight=Math.min(this.cachedContentHeight,this.maxHeight),this.input.style.height=this.cachedHeight+"px",this._onDidHeightChange.fire(this.cachedContentHeight))}insertAtCursor(c){const b=this.inputElement,S=b.selectionStart,A=b.selectionEnd,C=b.value;S!==null&&A!==null&&(this.value=C.substr(0,S)+c+C.substr(A),b.setSelectionRange(S+1,S+1),this.layout())}dispose(){this._hideMessage(),this.message=null,this.actionbar?.dispose(),super.dispose()}}t.InputBox=D;class y extends D{constructor(c,b,S){const A=s.localize(3,null),C=` or \u21C5 ${A}`,r=` (\u21C5 ${A})`;super(c,b,S);this._onDidFocus=this._register(new f.Emitter),this.onDidFocus=this._onDidFocus.event,this._onDidBlur=this._register(new f.Emitter),this.onDidBlur=this._onDidBlur.event,this.history=new F.HistoryNavigator(S.history,100);const n=()=>{if(S.showHistoryHint&&S.showHistoryHint()&&!this.placeholder.endsWith(C)&&!this.placeholder.endsWith(r)&&this.history.getHistory().length){const a=this.placeholder.endsWith(")")?C:r,u=this.placeholder+a;S.showPlaceholderOnFocus&&document.activeElement!==this.input?this.placeholder=u:this.setPlaceHolder(u)}};this.observer=new MutationObserver((a,u)=>{a.forEach(m=>{m.target.textContent||n()})}),this.observer.observe(this.input,{attributeFilter:["class"]}),this.onfocus(this.input,()=>n()),this.onblur(this.input,()=>{const a=u=>{if(this.placeholder.endsWith(u)){const m=this.placeholder.slice(0,this.placeholder.length-u.length);return S.showPlaceholderOnFocus?this.placeholder=m:this.setPlaceHolder(m),!0}else return!1};a(r)||a(C)})}dispose(){super.dispose(),this.observer&&(this.observer.disconnect(),this.observer=void 0)}addToHistory(){this.value&&this.value!==this.getCurrentValue()&&this.history.add(this.value)}getHistory(){return this.history.getHistory()}showNextValue(){this.history.has(this.value)||this.addToHistory();let c=this.getNextValue();c&&(c=c===this.value?this.getNextValue():c),c&&(this.value=c,_.status(this.value))}showPreviousValue(){this.history.has(this.value)||this.addToHistory();let c=this.getPreviousValue();c&&(c=c===this.value?this.getPreviousValue():c),c&&(this.value=c,_.status(this.value))}clearHistory(){this.history.clear()}onBlur(){super.onBlur(),this._onDidBlur.fire()}onFocus(){super.onFocus(),this._onDidFocus.fire()}getCurrentValue(){let c=this.history.current();return c||(c=this.history.last(),this.history.next()),c}getPreviousValue(){return this.history.previous()||this.history.first()}getNextValue(){return this.history.next()||this.history.last()}}t.HistoryInputBox=y}),define(me[62],pe([1,0,60,17,11,24,3,92]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Checkbox=t.Toggle=t.ToggleActionViewItem=void 0;const w={inputActiveOptionBorder:O.Color.fromHex("#007ACC00"),inputActiveOptionForeground:O.Color.fromHex("#FFFFFF"),inputActiveOptionBackground:O.Color.fromHex("#0E639C50")};class g extends E.BaseActionViewItem{constructor(l,s,e){super(l,s,e);this.toggle=this._register(new d({actionClassName:this._action.class,isChecked:!!this._action.checked,title:this.options.keybinding?`${this._action.label} (${this.options.keybinding})`:this._action.label,notFocusable:!0})),this._register(this.toggle.onChange(()=>this._action.checked=!!this.toggle&&this.toggle.checked))}render(l){this.element=l,this.element.appendChild(this.toggle.domNode)}updateEnabled(){this.toggle&&(this.isEnabled()?this.toggle.enable():this.toggle.disable())}updateChecked(){this.toggle.checked=!!this._action.checked}focus(){this.toggle.domNode.tabIndex=0,this.toggle.focus()}blur(){this.toggle.domNode.tabIndex=-1,this.toggle.domNode.blur()}setFocusable(l){this.toggle.domNode.tabIndex=l?0:-1}}t.ToggleActionViewItem=g;class d extends i.Widget{constructor(l){super();this._onChange=this._register(new _.Emitter),this.onChange=this._onChange.event,this._onKeyDown=this._register(new _.Emitter),this.onKeyDown=this._onKeyDown.event,this._opts={...w,...l},this._checked=this._opts.isChecked;const s=["monaco-custom-toggle"];this._opts.icon&&(this._icon=this._opts.icon,s.push(...M.CSSIcon.asClassNameArray(this._icon))),this._opts.actionClassName&&s.push(...this._opts.actionClassName.split(" ")),this._checked&&s.push("checked"),this.domNode=document.createElement("div"),this.domNode.title=this._opts.title,this.domNode.classList.add(...s),this._opts.notFocusable||(this.domNode.tabIndex=0),this.domNode.setAttribute("role","checkbox"),this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.setAttribute("aria-label",this._opts.title),this.applyStyles(),this.onclick(this.domNode,e=>{this.enabled&&(this.checked=!this._checked,this._onChange.fire(!1),e.preventDefault())}),this.ignoreGesture(this.domNode),this.onkeydown(this.domNode,e=>{if(e.keyCode===10||e.keyCode===3){this.checked=!this._checked,this._onChange.fire(!0),e.preventDefault(),e.stopPropagation();return}this._onKeyDown.fire(e)})}get enabled(){return this.domNode.getAttribute("aria-disabled")!=="true"}focus(){this.domNode.focus()}get checked(){return this._checked}set checked(l){this._checked=l,this.domNode.setAttribute("aria-checked",String(this._checked)),this.domNode.classList.toggle("checked",this._checked),this.applyStyles()}setIcon(l){this._icon&&this.domNode.classList.remove(...M.CSSIcon.asClassNameArray(this._icon)),this._icon=l,this._icon&&this.domNode.classList.add(...M.CSSIcon.asClassNameArray(this._icon))}width(){return 2+2+2+16}style(l){l.inputActiveOptionBorder&&(this._opts.inputActiveOptionBorder=l.inputActiveOptionBorder),l.inputActiveOptionForeground&&(this._opts.inputActiveOptionForeground=l.inputActiveOptionForeground),l.inputActiveOptionBackground&&(this._opts.inputActiveOptionBackground=l.inputActiveOptionBackground),this.applyStyles()}applyStyles(){this.domNode&&(this.domNode.style.borderColor=this._checked&&this._opts.inputActiveOptionBorder?this._opts.inputActiveOptionBorder.toString():"",this.domNode.style.color=this._checked&&this._opts.inputActiveOptionForeground?this._opts.inputActiveOptionForeground.toString():"inherit",this.domNode.style.backgroundColor=this._checked&&this._opts.inputActiveOptionBackground?this._opts.inputActiveOptionBackground.toString():"")}enable(){this.domNode.setAttribute("aria-disabled",String(!1))}disable(){this.domNode.setAttribute("aria-disabled",String(!0))}setTitle(l){this.domNode.title=l,this.domNode.setAttribute("aria-label",l)}}t.Toggle=d;class f extends i.Widget{constructor(l,s){super();this.title=l,this.isChecked=s,this.checkbox=new d({title:this.title,isChecked:this.isChecked,icon:M.Codicon.check,actionClassName:"monaco-checkbox"}),this.domNode=this.checkbox.domNode,this.styles={},this.checkbox.onChange(()=>{this.applyStyles()})}get checked(){return this.checkbox.checked}set checked(l){this.checkbox.checked=l,this.applyStyles()}focus(){this.domNode.focus()}hasFocus(){return this.domNode===document.activeElement}style(l){this.styles=l,this.applyStyles()}applyStyles(){this.domNode.style.color=this.styles.checkboxForeground?this.styles.checkboxForeground.toString():"",this.domNode.style.backgroundColor=this.styles.checkboxBackground?this.styles.checkboxBackground.toString():"",this.domNode.style.borderColor=this.styles.checkboxBorder?this.styles.checkboxBorder.toString():""}}t.Checkbox=f}),define(me[125],pe([1,0,62,11,97]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RegexToggle=t.WholeWordsToggle=t.CaseSensitiveToggle=void 0;const O=M.localize(0,null),_=M.localize(1,null),w=M.localize(2,null);class g extends E.Toggle{constructor(l){super({icon:i.Codicon.caseSensitive,title:O+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.CaseSensitiveToggle=g;class d extends E.Toggle{constructor(l){super({icon:i.Codicon.wholeWord,title:_+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.WholeWordsToggle=d;class f extends E.Toggle{constructor(l){super({icon:i.Codicon.regex,title:w+l.appendTitle,isChecked:l.isChecked,inputActiveOptionBorder:l.inputActiveOptionBorder,inputActiveOptionForeground:l.inputActiveOptionForeground,inputActiveOptionBackground:l.inputActiveOptionBackground})}}t.RegexToggle=f}),define(me[126],pe([1,0,4,125,124,17,3,96,86]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FindInput=void 0;const g=w.localize(0,null);class d extends O.Widget{constructor(F,l,s,e){super();this._showOptionButtons=s,this.fixFocusOnOptionClickEnabled=!0,this.imeSessionInProgress=!1,this.additionalToggles=[],this._onDidOptionChange=this._register(new _.Emitter),this.onDidOptionChange=this._onDidOptionChange.event,this._onKeyDown=this._register(new _.Emitter),this.onKeyDown=this._onKeyDown.event,this._onMouseDown=this._register(new _.Emitter),this.onMouseDown=this._onMouseDown.event,this._onInput=this._register(new _.Emitter),this.onInput=this._onInput.event,this._onKeyUp=this._register(new _.Emitter),this.onKeyUp=this._onKeyUp.event,this._onCaseSensitiveKeyDown=this._register(new _.Emitter),this.onCaseSensitiveKeyDown=this._onCaseSensitiveKeyDown.event,this._onRegexKeyDown=this._register(new _.Emitter),this.onRegexKeyDown=this._onRegexKeyDown.event,this._lastHighlightFindOptions=0,this.contextViewProvider=l,this.placeholder=e.placeholder||"",this.validation=e.validation,this.label=e.label||g,this.inputActiveOptionBorder=e.inputActiveOptionBorder,this.inputActiveOptionForeground=e.inputActiveOptionForeground,this.inputActiveOptionBackground=e.inputActiveOptionBackground,this.inputBackground=e.inputBackground,this.inputForeground=e.inputForeground,this.inputBorder=e.inputBorder,this.inputValidationInfoBorder=e.inputValidationInfoBorder,this.inputValidationInfoBackground=e.inputValidationInfoBackground,this.inputValidationInfoForeground=e.inputValidationInfoForeground,this.inputValidationWarningBorder=e.inputValidationWarningBorder,this.inputValidationWarningBackground=e.inputValidationWarningBackground,this.inputValidationWarningForeground=e.inputValidationWarningForeground,this.inputValidationErrorBorder=e.inputValidationErrorBorder,this.inputValidationErrorBackground=e.inputValidationErrorBackground,this.inputValidationErrorForeground=e.inputValidationErrorForeground;const p=e.appendCaseSensitiveLabel||"",v=e.appendWholeWordsLabel||"",D=e.appendRegexLabel||"",y=e.history||[],o=!!e.flexibleHeight,c=!!e.flexibleWidth,b=e.flexibleMaxHeight;this.domNode=document.createElement("div"),this.domNode.classList.add("monaco-findInput"),this.inputBox=this._register(new M.HistoryInputBox(this.domNode,this.contextViewProvider,{placeholder:this.placeholder||"",ariaLabel:this.label||"",validationOptions:{validation:this.validation},inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder,history:y,showHistoryHint:e.showHistoryHint,flexibleHeight:o,flexibleWidth:c,flexibleMaxHeight:b})),this.regex=this._register(new i.RegexToggle({appendTitle:D,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.regex.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.regex.onKeyDown(A=>{this._onRegexKeyDown.fire(A)})),this.wholeWords=this._register(new i.WholeWordsToggle({appendTitle:v,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.wholeWords.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this.caseSensitive=this._register(new i.CaseSensitiveToggle({appendTitle:p,isChecked:!1,inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground})),this._register(this.caseSensitive.onChange(A=>{this._onDidOptionChange.fire(A),!A&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus(),this.validate()})),this._register(this.caseSensitive.onKeyDown(A=>{this._onCaseSensitiveKeyDown.fire(A)}));const S=[this.caseSensitive.domNode,this.wholeWords.domNode,this.regex.domNode];this.onkeydown(this.domNode,A=>{if(A.equals(15)||A.equals(17)||A.equals(9)){const C=S.indexOf(document.activeElement);if(C>=0){let r=-1;A.equals(17)?r=(C+1)%S.length:A.equals(15)&&(C===0?r=S.length-1:r=C-1),A.equals(9)?(S[C].blur(),this.inputBox.focus()):r>=0&&S[r].focus(),E.EventHelper.stop(A,!0)}}}),this.controls=document.createElement("div"),this.controls.className="controls",this.controls.style.display=this._showOptionButtons?"block":"none",this.controls.appendChild(this.caseSensitive.domNode),this.controls.appendChild(this.wholeWords.domNode),this.controls.appendChild(this.regex.domNode),this._showOptionButtons||(this.caseSensitive.domNode.style.display="none",this.wholeWords.domNode.style.display="none",this.regex.domNode.style.display="none");for(const A of e?.additionalToggles??[])this._register(A),this.controls.appendChild(A.domNode),this._register(A.onChange(C=>{this._onDidOptionChange.fire(C),!C&&this.fixFocusOnOptionClickEnabled&&this.inputBox.focus()})),this.additionalToggles.push(A);this.additionalToggles.length>0&&(this.controls.style.display="block"),this.inputBox.paddingRight=(this._showOptionButtons?this.caseSensitive.width()+this.wholeWords.width()+this.regex.width():0)+this.additionalToggles.reduce((A,C)=>A+C.width(),0),this.domNode.appendChild(this.controls),F?.appendChild(this.domNode),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionstart",A=>{this.imeSessionInProgress=!0})),this._register(E.addDisposableListener(this.inputBox.inputElement,"compositionend",A=>{this.imeSessionInProgress=!1,this._onInput.fire()})),this.onkeydown(this.inputBox.inputElement,A=>this._onKeyDown.fire(A)),this.onkeyup(this.inputBox.inputElement,A=>this._onKeyUp.fire(A)),this.oninput(this.inputBox.inputElement,A=>this._onInput.fire()),this.onmousedown(this.inputBox.inputElement,A=>this._onMouseDown.fire(A))}get isImeSessionInProgress(){return this.imeSessionInProgress}get onDidChange(){return this.inputBox.onDidChange}enable(){this.domNode.classList.remove("disabled"),this.inputBox.enable(),this.regex.enable(),this.wholeWords.enable(),this.caseSensitive.enable();for(const F of this.additionalToggles)F.enable()}disable(){this.domNode.classList.add("disabled"),this.inputBox.disable(),this.regex.disable(),this.wholeWords.disable(),this.caseSensitive.disable();for(const F of this.additionalToggles)F.disable()}setFocusInputOnOptionClick(F){this.fixFocusOnOptionClickEnabled=F}setEnabled(F){F?this.enable():this.disable()}clear(){this.clearValidation(),this.setValue(""),this.focus()}getValue(){return this.inputBox.value}setValue(F){this.inputBox.value!==F&&(this.inputBox.value=F)}onSearchSubmit(){this.inputBox.addToHistory()}style(F){this.inputActiveOptionBorder=F.inputActiveOptionBorder,this.inputActiveOptionForeground=F.inputActiveOptionForeground,this.inputActiveOptionBackground=F.inputActiveOptionBackground,this.inputBackground=F.inputBackground,this.inputForeground=F.inputForeground,this.inputBorder=F.inputBorder,this.inputValidationInfoBackground=F.inputValidationInfoBackground,this.inputValidationInfoForeground=F.inputValidationInfoForeground,this.inputValidationInfoBorder=F.inputValidationInfoBorder,this.inputValidationWarningBackground=F.inputValidationWarningBackground,this.inputValidationWarningForeground=F.inputValidationWarningForeground,this.inputValidationWarningBorder=F.inputValidationWarningBorder,this.inputValidationErrorBackground=F.inputValidationErrorBackground,this.inputValidationErrorForeground=F.inputValidationErrorForeground,this.inputValidationErrorBorder=F.inputValidationErrorBorder,this.applyStyles()}applyStyles(){if(this.domNode){const F={inputActiveOptionBorder:this.inputActiveOptionBorder,inputActiveOptionForeground:this.inputActiveOptionForeground,inputActiveOptionBackground:this.inputActiveOptionBackground};this.regex.style(F),this.wholeWords.style(F),this.caseSensitive.style(F);for(const s of this.additionalToggles)s.style(F);const l={inputBackground:this.inputBackground,inputForeground:this.inputForeground,inputBorder:this.inputBorder,inputValidationInfoBackground:this.inputValidationInfoBackground,inputValidationInfoForeground:this.inputValidationInfoForeground,inputValidationInfoBorder:this.inputValidationInfoBorder,inputValidationWarningBackground:this.inputValidationWarningBackground,inputValidationWarningForeground:this.inputValidationWarningForeground,inputValidationWarningBorder:this.inputValidationWarningBorder,inputValidationErrorBackground:this.inputValidationErrorBackground,inputValidationErrorForeground:this.inputValidationErrorForeground,inputValidationErrorBorder:this.inputValidationErrorBorder};this.inputBox.style(l)}}select(){this.inputBox.select()}focus(){this.inputBox.focus()}getCaseSensitive(){return this.caseSensitive.checked}setCaseSensitive(F){this.caseSensitive.checked=F}getWholeWords(){return this.wholeWords.checked}setWholeWords(F){this.wholeWords.checked=F}getRegex(){return this.regex.checked}setRegex(F){this.regex.checked=F,this.validate()}focusOnCaseSensitive(){this.caseSensitive.focus()}focusOnRegex(){this.regex.focus()}highlightFindOptions(){this.domNode.classList.remove("highlight-"+this._lastHighlightFindOptions),this._lastHighlightFindOptions=1-this._lastHighlightFindOptions,this.domNode.classList.add("highlight-"+this._lastHighlightFindOptions)}validate(){this.inputBox.validate()}showMessage(F){this.inputBox.showMessage(F)}clearMessage(){this.inputBox.hideMessage()}clearValidation(){this.inputBox.hideMessage()}}t.FindInput=d,d.OPTION_CHANGE="optionChange"}),define(me[127],pe([1,0,4,18,19,61,126,57,58,62,54,23,32,14,8,11,69,3,33,2,44,6,101,93]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s,e,p,v,D,y,o,c,b,S){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractTree=t.TreeFindMode=t.ModeToggle=t.RenderIndentGuides=t.AbstractTreeViewState=t.ComposedTreeDelegate=void 0;class A extends w.ElementsDragAndDropData{constructor(L){super(L.elements.map($=>$.element));this.data=L}set context(L){this.data.context=L}get context(){return this.data.context}}function C(ie){return ie instanceof w.ElementsDragAndDropData?new A(ie):ie}class r{constructor(L,$){this.modelProvider=L,this.dnd=$,this.autoExpandDisposable=o.Disposable.None}getDragURI(L){return this.dnd.getDragURI(L.element)}getDragLabel(L,$){if(this.dnd.getDragLabel)return this.dnd.getDragLabel(L.map(G=>G.element),$)}onDragStart(L,$){this.dnd.onDragStart?.(C(L),$)}onDragOver(L,$,G,B,h=!0){const I=this.dnd.onDragOver(C(L),$&&$.element,G,B),U=this.autoExpandNode!==$;if(U&&(this.autoExpandDisposable.dispose(),this.autoExpandNode=$),typeof $=="undefined")return I;if(U&&typeof I!="boolean"&&I.autoExpand&&(this.autoExpandDisposable=(0,e.disposableTimeout)(()=>{const z=this.modelProvider(),T=z.getNodeLocation($);z.isCollapsed(T)&&z.setCollapsed(T,!1),this.autoExpandNode=void 0},500)),typeof I=="boolean"||!I.accept||typeof I.bubble=="undefined"||I.feedback){if(!h){const z=typeof I=="boolean"?I:I.accept,T=typeof I=="boolean"?void 0:I.effect;return{accept:z,effect:T,feedback:[G]}}return I}if(I.bubble===1){const z=this.modelProvider(),T=z.getNodeLocation($),H=z.getParentNodeLocation(T),k=z.getNode(H),P=H&&z.getListIndex(H);return this.onDragOver(L,k,P,B,!1)}const K=this.modelProvider(),Q=K.getNodeLocation($),N=K.getListIndex(Q),R=K.getListRenderCount(Q);return{...I,feedback:(0,s.range)(N,N+R)}}drop(L,$,G,B){this.autoExpandDisposable.dispose(),this.autoExpandNode=void 0,this.dnd.drop(C(L),$&&$.element,G,B)}onDragEnd(L){this.dnd.onDragEnd?.(L)}}function n(ie,L){return L&&{...L,identityProvider:L.identityProvider&&{getId($){return L.identityProvider.getId($.element)}},dnd:L.dnd&&new r(ie,L.dnd),multipleSelectionController:L.multipleSelectionController&&{isSelectionSingleChangeEvent($){return L.multipleSelectionController.isSelectionSingleChangeEvent({...$,element:$.element})},isSelectionRangeChangeEvent($){return L.multipleSelectionController.isSelectionRangeChangeEvent({...$,element:$.element})}},accessibilityProvider:L.accessibilityProvider&&{...L.accessibilityProvider,getSetSize($){const G=ie(),B=G.getNodeLocation($),h=G.getParentNodeLocation(B);return G.getNode(h).visibleChildrenCount},getPosInSet($){return $.visibleChildIndex+1},isChecked:L.accessibilityProvider&&L.accessibilityProvider.isChecked?$=>L.accessibilityProvider.isChecked($.element):void 0,getRole:L.accessibilityProvider&&L.accessibilityProvider.getRole?$=>L.accessibilityProvider.getRole($.element):()=>"treeitem",getAriaLabel($){return L.accessibilityProvider.getAriaLabel($.element)},getWidgetAriaLabel(){return L.accessibilityProvider.getWidgetAriaLabel()},getWidgetRole:L.accessibilityProvider&&L.accessibilityProvider.getWidgetRole?()=>L.accessibilityProvider.getWidgetRole():()=>"tree",getAriaLevel:L.accessibilityProvider&&L.accessibilityProvider.getAriaLevel?$=>L.accessibilityProvider.getAriaLevel($.element):$=>$.depth,getActiveDescendantId:L.accessibilityProvider.getActiveDescendantId&&($=>L.accessibilityProvider.getActiveDescendantId($.element))},keyboardNavigationLabelProvider:L.keyboardNavigationLabelProvider&&{...L.keyboardNavigationLabelProvider,getKeyboardNavigationLabel($){return L.keyboardNavigationLabelProvider.getKeyboardNavigationLabel($.element)}}}}class a{constructor(L){this.delegate=L}getHeight(L){return this.delegate.getHeight(L.element)}getTemplateId(L){return this.delegate.getTemplateId(L.element)}hasDynamicHeight(L){return!!this.delegate.hasDynamicHeight&&this.delegate.hasDynamicHeight(L.element)}setDynamicHeight(L,$){this.delegate.setDynamicHeight?.(L.element,$)}}t.ComposedTreeDelegate=a;class u{constructor(L){if(this.focus=new Set(L.focus),this.selection=new Set(L.selection),L.expanded instanceof Array){this.expanded=Object.create(null);for(const $ of L.expanded)this.expanded[$]=1}else this.expanded=L.expanded;this.expanded=L.expanded,this.scrollTop=L.scrollTop}static lift(L){return L instanceof u?L:new u(L)}static empty(L=0){return new u({focus:[],selection:[],expanded:Object.create(null),scrollTop:L})}toJSON(){return{focus:Array.from(this.focus),selection:Array.from(this.selection),expanded:this.expanded,scrollTop:this.scrollTop}}}t.AbstractTreeViewState=u;var m;(function(ie){ie.None="none",ie.OnHover="onHover",ie.Always="always"})(m=t.RenderIndentGuides||(t.RenderIndentGuides={}));class W{constructor(L,$=[]){this._elements=$,this.disposables=new o.DisposableStore,this.onDidChange=D.Event.forEach(L,G=>this._elements=G,this.disposables)}get elements(){return this._elements}dispose(){this.disposables.dispose()}}class V{constructor(L,$,G,B,h={}){this.renderer=L,this.modelProvider=$,this.activeNodes=B,this.renderedElements=new Map,this.renderedNodes=new Map,this.indent=V.DefaultIndent,this.hideTwistiesOfChildlessElements=!1,this.shouldRenderIndentGuides=!1,this.renderedIndentGuides=new v.SetMap,this.activeIndentNodes=new Set,this.indentGuidesDisposable=o.Disposable.None,this.disposables=new o.DisposableStore,this.templateId=L.templateId,this.updateOptions(h),D.Event.map(G,I=>I.node)(this.onDidChangeNodeTwistieState,this,this.disposables),L.onDidChangeTwistieState?.(this.onDidChangeTwistieState,this,this.disposables)}updateOptions(L={}){if(typeof L.indent!="undefined"&&(this.indent=(0,c.clamp)(L.indent,0,40)),typeof L.renderIndentGuides!="undefined"){const $=L.renderIndentGuides!==m.None;if($!==this.shouldRenderIndentGuides&&(this.shouldRenderIndentGuides=$,this.indentGuidesDisposable.dispose(),$)){const G=new o.DisposableStore;this.activeNodes.onDidChange(this._onDidChangeActiveNodes,this,G),this.indentGuidesDisposable=G,this._onDidChangeActiveNodes(this.activeNodes.elements)}}typeof L.hideTwistiesOfChildlessElements!="undefined"&&(this.hideTwistiesOfChildlessElements=L.hideTwistiesOfChildlessElements)}renderTemplate(L){const $=(0,E.append)(L,(0,E.$)(".monaco-tl-row")),G=(0,E.append)($,(0,E.$)(".monaco-tl-indent")),B=(0,E.append)($,(0,E.$)(".monaco-tl-twistie")),h=(0,E.append)($,(0,E.$)(".monaco-tl-contents")),I=this.renderer.renderTemplate(h);return{container:L,indent:G,twistie:B,indentGuidesDisposable:o.Disposable.None,templateData:I}}renderElement(L,$,G,B){typeof B=="number"&&(this.renderedNodes.set(L,{templateData:G,height:B}),this.renderedElements.set(L.element,L));const h=V.DefaultIndent+(L.depth-1)*this.indent;G.twistie.style.paddingLeft=`${h}px`,G.indent.style.width=`${h+this.indent-16}px`,this.renderTwistie(L,G),typeof B=="number"&&this.renderIndentGuides(L,G),this.renderer.renderElement(L,$,G.templateData,B)}disposeElement(L,$,G,B){G.indentGuidesDisposable.dispose(),this.renderer.disposeElement?.(L,$,G.templateData,B),typeof B=="number"&&(this.renderedNodes.delete(L),this.renderedElements.delete(L.element))}disposeTemplate(L){this.renderer.disposeTemplate(L.templateData)}onDidChangeTwistieState(L){const $=this.renderedElements.get(L);!$||this.onDidChangeNodeTwistieState($)}onDidChangeNodeTwistieState(L){const $=this.renderedNodes.get(L);!$||(this.renderTwistie(L,$.templateData),this._onDidChangeActiveNodes(this.activeNodes.elements),this.renderIndentGuides(L,$.templateData))}renderTwistie(L,$){$.twistie.classList.remove(...p.Codicon.treeItemExpanded.classNamesArray);let G=!1;this.renderer.renderTwistie&&(G=this.renderer.renderTwistie(L.element,$.twistie)),L.collapsible&&(!this.hideTwistiesOfChildlessElements||L.visibleChildrenCount>0)?(G||$.twistie.classList.add(...p.Codicon.treeItemExpanded.classNamesArray),$.twistie.classList.add("collapsible"),$.twistie.classList.toggle("collapsed",L.collapsed)):$.twistie.classList.remove("collapsible","collapsed"),L.collapsible?$.container.setAttribute("aria-expanded",String(!L.collapsed)):$.container.removeAttribute("aria-expanded")}renderIndentGuides(L,$){if((0,E.clearNode)($.indent),$.indentGuidesDisposable.dispose(),!this.shouldRenderIndentGuides)return;const G=new o.DisposableStore,B=this.modelProvider();let h=L;for(;;){const I=B.getNodeLocation(h),U=B.getParentNodeLocation(I);if(!U)break;const K=B.getNode(U),Q=(0,E.$)(".indent-guide",{style:`width: ${this.indent}px`});this.activeIndentNodes.has(K)&&Q.classList.add("active"),$.indent.childElementCount===0?$.indent.appendChild(Q):$.indent.insertBefore(Q,$.indent.firstElementChild),this.renderedIndentGuides.add(K,Q),G.add((0,o.toDisposable)(()=>this.renderedIndentGuides.delete(K,Q))),h=K}$.indentGuidesDisposable=G}_onDidChangeActiveNodes(L){if(!this.shouldRenderIndentGuides)return;const $=new Set,G=this.modelProvider();L.forEach(B=>{const h=G.getNodeLocation(B);try{const I=G.getParentNodeLocation(h);B.collapsible&&B.children.length>0&&!B.collapsed?$.add(B):I&&$.add(G.getNode(I))}catch{}}),this.activeIndentNodes.forEach(B=>{$.has(B)||this.renderedIndentGuides.forEach(B,h=>h.classList.remove("active"))}),$.forEach(B=>{this.activeIndentNodes.has(B)||this.renderedIndentGuides.forEach(B,h=>h.classList.add("active"))}),this.activeIndentNodes=$}dispose(){this.renderedNodes.clear(),this.renderedElements.clear(),this.indentGuidesDisposable.dispose(),(0,o.dispose)(this.disposables)}}V.DefaultIndent=8;class ne{constructor(L,$,G){this.tree=L,this.keyboardNavigationLabelProvider=$,this._filter=G,this._totalCount=0,this._matchCount=0,this._pattern="",this._lowercasePattern="",this.disposables=new o.DisposableStore,L.onWillRefilter(this.reset,this,this.disposables)}get totalCount(){return this._totalCount}get matchCount(){return this._matchCount}set pattern(L){this._pattern=L,this._lowercasePattern=L.toLowerCase()}filter(L,$){let G=1;if(this._filter){const I=this._filter.filter(L,$);if(typeof I=="boolean"?G=I?1:0:(0,f.isFilterResult)(I)?G=(0,f.getVisibleState)(I.visibility):G=I,G===0)return!1}if(this._totalCount++,!this._pattern)return this._matchCount++,{data:y.FuzzyScore.Default,visibility:G};const B=this.keyboardNavigationLabelProvider.getKeyboardNavigationLabel(L),h=Array.isArray(B)?B:[B];for(const I of h){const U=I&&I.toString();if(typeof U=="undefined")return{data:y.FuzzyScore.Default,visibility:G};const K=(0,y.fuzzyScore)(this._pattern,this._lowercasePattern,0,U,U.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});if(K)return this._matchCount++,h.length===1?{data:K,visibility:G}:{data:{label:U,score:K},visibility:G}}return this.tree.findMode===we.Filter?2:{data:y.FuzzyScore.Default,visibility:G}}reset(){this._totalCount=0,this._matchCount=0}dispose(){(0,o.dispose)(this.disposables)}}class re extends d.Toggle{constructor(L){super({icon:p.Codicon.filter,title:(0,S.localize)(0,null),isChecked:L?.isChecked??!1,inputActiveOptionBorder:L?.inputActiveOptionBorder,inputActiveOptionForeground:L?.inputActiveOptionForeground,inputActiveOptionBackground:L?.inputActiveOptionBackground})}}t.ModeToggle=re;var we;(function(ie){ie[ie.Highlight=0]="Highlight",ie[ie.Filter=1]="Filter"})(we=t.TreeFindMode||(t.TreeFindMode={}));class ae extends o.Disposable{constructor(L,$,G,B,h){super();this.tree=$,this.elements=(0,E.h)(".monaco-tree-type-filter",[(0,E.h)(".monaco-tree-type-filter-grab.codicon.codicon-debug-gripper@grab",{tabIndex:0}),(0,E.h)(".monaco-tree-type-filter-input@findInput"),(0,E.h)(".monaco-tree-type-filter-actionbar@actionbar")]),this.width=0,this.right=0,this._onDidDisable=new D.Emitter,this.onDidDisable=this._onDidDisable.event,L.appendChild(this.elements.root),this._register((0,o.toDisposable)(()=>L.removeChild(this.elements.root))),this.modeToggle=this._register(new re({...h,isChecked:B===we.Filter})),this.onDidChangeMode=D.Event.map(this.modeToggle.onChange,()=>this.modeToggle.checked?we.Filter:we.Highlight,this._store),this.findInput=this._register(new _.FindInput(this.elements.findInput,G,!1,{label:(0,S.localize)(3,null),additionalToggles:[this.modeToggle]})),this.actionbar=this._register(new O.ActionBar(this.elements.actionbar)),this.mode=B;const I=this._register(new i.DomEmitter(this.findInput.inputBox.inputElement,"keydown")),U=this._register(D.Event.chain(I.event)).map(R=>new M.StandardKeyboardEvent(R)).event;this._register(U(R=>{switch(R.keyCode){case 18:R.preventDefault(),R.stopPropagation(),this.tree.domFocus();return}}));const K=this._register(new l.Action("close",(0,S.localize)(4,null),"codicon codicon-close",!0,()=>this.dispose()));this.actionbar.push(K,{icon:!0,label:!1});const Q=this._register(new i.DomEmitter(this.elements.grab,"mousedown"));this._register(Q.event(R=>{const z=new o.DisposableStore,T=z.add(new i.DomEmitter(window,"mousemove")),H=z.add(new i.DomEmitter(window,"mouseup")),k=this.right,P=R.pageX;this.elements.grab.classList.add("grabbing");const x=J=>{const he=J.pageX-P;this.right=k-he,this.layout()};z.add(T.event(x)),z.add(H.event(J=>{x(J),this.elements.grab.classList.remove("grabbing"),z.dispose()}))}));const N=this._register(D.Event.chain(this._register(new i.DomEmitter(this.elements.grab,"keydown")).event)).map(R=>new M.StandardKeyboardEvent(R)).event;this._register(N(R=>{let z;R.keyCode===15?z=Number.POSITIVE_INFINITY:R.keyCode===17?z=0:R.keyCode===10&&(z=this.right===0?Number.POSITIVE_INFINITY:0),z!==void 0&&(R.preventDefault(),R.stopPropagation(),this.right=z,this.layout())})),this.onDidChangeValue=this.findInput.onDidChange,this.style(h??{})}set mode(L){this.modeToggle.checked=L===we.Filter,this.findInput.inputBox.setPlaceHolder(L===we.Filter?(0,S.localize)(1,null):(0,S.localize)(2,null))}style(L){this.findInput.style(L),L.listFilterWidgetBackground&&(this.elements.root.style.backgroundColor=L.listFilterWidgetBackground.toString()),L.listFilterWidgetShadow&&(this.elements.root.style.boxShadow=`0 0 8px 2px ${L.listFilterWidgetShadow}`)}focus(){this.findInput.focus()}select(){this.findInput.select()}layout(L=this.width){this.width=L,this.right=(0,c.clamp)(this.right,0,Math.max(0,L-212)),this.elements.root.style.right=`${this.right}px`}showMessage(L){this.findInput.showMessage(L)}clearMessage(){this.findInput.clearMessage()}async dispose(){this._onDidDisable.fire(),this.elements.root.classList.add("disabled"),await(0,e.timeout)(300),super.dispose()}}class ve{constructor(L,$,G,B,h){this.tree=L,this.view=G,this.filter=B,this.contextViewProvider=h,this._pattern="",this.width=0,this._onDidChangeMode=new D.Emitter,this.onDidChangeMode=this._onDidChangeMode.event,this._onDidChangePattern=new D.Emitter,this.onDidChangePattern=this._onDidChangePattern.event,this._onDidChangeOpenState=new D.Emitter,this.onDidChangeOpenState=this._onDidChangeOpenState.event,this.enabledDisposables=new o.DisposableStore,this.disposables=new o.DisposableStore,this._mode=L.options.defaultFindMode??we.Highlight,$.onDidSplice(this.onDidSpliceModel,this,this.disposables)}get pattern(){return this._pattern}get mode(){return this._mode}set mode(L){L!==this._mode&&(this._mode=L,this.widget&&(this.widget.mode=this._mode),this.tree.refilter(),this.render(),this._onDidChangeMode.fire(L))}open(){if(this.widget){this.widget.focus(),this.widget.select();return}this.mode=this.tree.options.defaultFindMode??we.Highlight,this.widget=new ae(this.view.getHTMLElement(),this.tree,this.contextViewProvider,this.mode,this.styles),this.enabledDisposables.add(this.widget),this.widget.onDidChangeValue(this.onDidChangeValue,this,this.enabledDisposables),this.widget.onDidChangeMode(L=>this.mode=L,void 0,this.enabledDisposables),this.widget.onDidDisable(this.close,this,this.enabledDisposables),this.widget.layout(this.width),this.widget.focus(),this._onDidChangeOpenState.fire(!0)}close(){!this.widget||(this.widget=void 0,this.enabledDisposables.dispose(),this.enabledDisposables=new o.DisposableStore,this.onDidChangeValue(""),this.tree.domFocus(),this._onDidChangeOpenState.fire(!1))}onDidChangeValue(L){this._pattern=L,this._onDidChangePattern.fire(L),this.filter.pattern=L,this.tree.refilter(),L&&this.tree.focusNext(0,!0,void 0,G=>!y.FuzzyScore.isDefault(G.filterData));const $=this.tree.getFocus();if($.length>0){const G=$[0];this.tree.getRelativeTop(G)===null&&this.tree.reveal(G,.5)}this.render()}onDidSpliceModel(){!this.widget||this.pattern.length===0||(this.tree.refilter(),this.render())}render(){const L=this.filter.totalCount>0&&this.filter.matchCount===0;this.pattern&&L?this.widget?.showMessage({type:2,content:(0,S.localize)(5,null)}):this.widget?.clearMessage()}shouldAllowFocus(L){return!this.widget||!this.pattern||this._mode===we.Filter||this.filter.totalCount>0&&this.filter.matchCount<=1?!0:!y.FuzzyScore.isDefault(L.filterData)}style(L){this.styles=L,this.widget?.style(L)}layout(L){this.width=L,this.widget?.layout(L)}dispose(){this._onDidChangePattern.dispose(),this.enabledDisposables.dispose(),this.disposables.dispose()}}function ue(ie){let L=F.TreeMouseEventTarget.Unknown;return(0,E.hasParentWithClass)(ie.browserEvent.target,"monaco-tl-twistie","monaco-tl-row")?L=F.TreeMouseEventTarget.Twistie:(0,E.hasParentWithClass)(ie.browserEvent.target,"monaco-tl-contents","monaco-tl-row")?L=F.TreeMouseEventTarget.Element:(0,E.hasParentWithClass)(ie.browserEvent.target,"monaco-tree-type-filter","monaco-list")&&(L=F.TreeMouseEventTarget.Filter),{browserEvent:ie.browserEvent,element:ie.element?ie.element.element:null,target:L}}function ge(ie){return{element:ie.element?ie.element.element:null,browserEvent:ie.browserEvent,anchor:ie.anchor}}function ye(ie,L){L(ie),ie.children.forEach($=>ye($,L))}class ee{constructor(L,$){this.getFirstViewElementWithTrait=L,this.identityProvider=$,this.nodes=[],this._onDidChange=new D.Emitter,this.onDidChange=this._onDidChange.event}get nodeSet(){return this._nodeSet||(this._nodeSet=this.createNodeSet()),this._nodeSet}set(L,$){!$?.__forceEvent&&(0,s.equals)(this.nodes,L)||this._set(L,!1,$)}_set(L,$,G){if(this.nodes=[...L],this.elements=void 0,this._nodeSet=void 0,!$){const B=this;this._onDidChange.fire({get elements(){return B.get()},browserEvent:G})}}get(){return this.elements||(this.elements=this.nodes.map(L=>L.element)),[...this.elements]}getNodes(){return this.nodes}has(L){return this.nodeSet.has(L)}onDidModelSplice({insertedNodes:L,deletedNodes:$}){if(!this.identityProvider){const K=this.createNodeSet(),Q=N=>K.delete(N);$.forEach(N=>ye(N,Q)),this.set([...K.values()]);return}const G=new Set,B=K=>G.add(this.identityProvider.getId(K.element).toString());$.forEach(K=>ye(K,B));const h=new Map,I=K=>h.set(this.identityProvider.getId(K.element).toString(),K);L.forEach(K=>ye(K,I));const U=[];for(const K of this.nodes){const Q=this.identityProvider.getId(K.element).toString();if(!G.has(Q))U.push(K);else{const R=h.get(Q);R&&U.push(R)}}if(this.nodes.length>0&&U.length===0){const K=this.getFirstViewElementWithTrait();K&&U.push(K)}this._set(U,!0)}createNodeSet(){const L=new Set;for(const $ of this.nodes)L.add($);return L}}class fe extends g.MouseController{constructor(L,$){super(L);this.tree=$}onViewPointer(L){if((0,g.isButton)(L.browserEvent.target)||(0,g.isInputElement)(L.browserEvent.target)||(0,g.isMonacoEditor)(L.browserEvent.target))return;const $=L.element;if(!$)return super.onViewPointer(L);if(this.isSelectionRangeChangeEvent(L)||this.isSelectionSingleChangeEvent(L))return super.onViewPointer(L);const G=L.browserEvent.target,B=G.classList.contains("monaco-tl-twistie")||G.classList.contains("monaco-icon-label")&&G.classList.contains("folder-icon")&&L.browserEvent.offsetX<16;let h=!1;if(typeof this.tree.expandOnlyOnTwistieClick=="function"?h=this.tree.expandOnlyOnTwistieClick($.element):h=!!this.tree.expandOnlyOnTwistieClick,h&&!B&&L.browserEvent.detail!==2)return super.onViewPointer(L);if(!this.tree.expandOnDoubleClick&&L.browserEvent.detail===2)return super.onViewPointer(L);if($.collapsible){const I=this.tree.model,U=I.getNodeLocation($),K=L.browserEvent.altKey;if(this.tree.setFocus([U]),I.setCollapsed(U,void 0,K),h&&B)return}super.onViewPointer(L)}onDoubleClick(L){L.browserEvent.target.classList.contains("monaco-tl-twistie")||!this.tree.expandOnDoubleClick||super.onDoubleClick(L)}}class te extends g.List{constructor(L,$,G,B,h,I,U,K){super(L,$,G,B,K);this.focusTrait=h,this.selectionTrait=I,this.anchorTrait=U}createMouseController(L){return new fe(this,L.tree)}splice(L,$,G=[]){if(super.splice(L,$,G),G.length===0)return;const B=[],h=[];let I;G.forEach((U,K)=>{this.focusTrait.has(U)&&B.push(L+K),this.selectionTrait.has(U)&&h.push(L+K),this.anchorTrait.has(U)&&(I=L+K)}),B.length>0&&super.setFocus((0,s.distinct)([...super.getFocus(),...B])),h.length>0&&super.setSelection((0,s.distinct)([...super.getSelection(),...h])),typeof I=="number"&&super.setAnchor(I)}setFocus(L,$,G=!1){super.setFocus(L,$),G||this.focusTrait.set(L.map(B=>this.element(B)),$)}setSelection(L,$,G=!1){super.setSelection(L,$),G||this.selectionTrait.set(L.map(B=>this.element(B)),$)}setAnchor(L,$=!1){super.setAnchor(L),$||(typeof L=="undefined"?this.anchorTrait.set([]):this.anchorTrait.set([this.element(L)]))}}class X{constructor(L,$,G,B,h={}){this._user=L,this._options=h,this.eventBufferer=new D.EventBufferer,this.onDidChangeFindOpenState=D.Event.None,this.disposables=new o.DisposableStore,this._onWillRefilter=new D.Emitter,this.onWillRefilter=this._onWillRefilter.event,this._onDidUpdateOptions=new D.Emitter,this.onDidUpdateOptions=this._onDidUpdateOptions.event;const I=new a(G),U=new D.Relay,K=new D.Relay,Q=this.disposables.add(new W(K.event));this.renderers=B.map(z=>new V(z,()=>this.model,U.event,Q,h));for(const z of this.renderers)this.disposables.add(z);let N;h.keyboardNavigationLabelProvider&&(N=new ne(this,h.keyboardNavigationLabelProvider,h.filter),h={...h,filter:N},this.disposables.add(N)),this.focus=new ee(()=>this.view.getFocusedElements()[0],h.identityProvider),this.selection=new ee(()=>this.view.getSelectedElements()[0],h.identityProvider),this.anchor=new ee(()=>this.view.getAnchorElement(),h.identityProvider),this.view=new te(L,$,I,this.renderers,this.focus,this.selection,this.anchor,{...n(()=>this.model,h),tree:this}),this.model=this.createModel(L,this.view,h),U.input=this.model.onDidChangeCollapseState;const R=D.Event.forEach(this.model.onDidSplice,z=>{this.eventBufferer.bufferEvents(()=>{this.focus.onDidModelSplice(z),this.selection.onDidModelSplice(z)})},this.disposables);if(R(()=>null,null,this.disposables),K.input=D.Event.chain(D.Event.any(R,this.focus.onDidChange,this.selection.onDidChange)).debounce(()=>null,0).map(()=>{const z=new Set;for(const T of this.focus.getNodes())z.add(T);for(const T of this.selection.getNodes())z.add(T);return[...z.values()]}).event,h.keyboardSupport!==!1){const z=D.Event.chain(this.view.onKeyDown).filter(T=>!(0,g.isInputElement)(T.target)).map(T=>new M.StandardKeyboardEvent(T));z.filter(T=>T.keyCode===15).on(this.onLeftArrow,this,this.disposables),z.filter(T=>T.keyCode===17).on(this.onRightArrow,this,this.disposables),z.filter(T=>T.keyCode===10).on(this.onSpace,this,this.disposables)}(h.findWidgetEnabled??!0)&&h.keyboardNavigationLabelProvider&&h.contextViewProvider?(this.findController=new ve(this,this.model,this.view,N,h.contextViewProvider),this.focusNavigationFilter=z=>this.findController.shouldAllowFocus(z),this.onDidChangeFindOpenState=this.findController.onDidChangeOpenState,this.disposables.add(this.findController),this.onDidChangeFindMode=this.findController.onDidChangeMode):this.onDidChangeFindMode=D.Event.None,this.styleElement=(0,E.createStyleSheet)(this.view.getHTMLElement()),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===m.Always)}get onDidScroll(){return this.view.onDidScroll}get onDidChangeFocus(){return this.eventBufferer.wrapEvent(this.focus.onDidChange)}get onDidChangeSelection(){return this.eventBufferer.wrapEvent(this.selection.onDidChange)}get onMouseClick(){return D.Event.map(this.view.onMouseClick,ue)}get onMouseDblClick(){return D.Event.filter(D.Event.map(this.view.onMouseDblClick,ue),L=>L.target!==F.TreeMouseEventTarget.Filter)}get onContextMenu(){return D.Event.map(this.view.onContextMenu,ge)}get onTap(){return D.Event.map(this.view.onTap,ue)}get onPointer(){return D.Event.map(this.view.onPointer,ue)}get onKeyDown(){return this.view.onKeyDown}get onKeyUp(){return this.view.onKeyUp}get onKeyPress(){return this.view.onKeyPress}get onDidFocus(){return this.view.onDidFocus}get onDidBlur(){return this.view.onDidBlur}get onDidChangeModel(){return D.Event.signal(this.model.onDidSplice)}get onDidChangeCollapseState(){return this.model.onDidChangeCollapseState}get onDidChangeRenderNodeCount(){return this.model.onDidChangeRenderNodeCount}get findMode(){return this.findController?.mode??we.Highlight}set findMode(L){this.findController&&(this.findController.mode=L)}get onDidChangeFindPattern(){return this.findController?this.findController.onDidChangePattern:D.Event.None}get expandOnDoubleClick(){return typeof this._options.expandOnDoubleClick=="undefined"?!0:this._options.expandOnDoubleClick}get expandOnlyOnTwistieClick(){return typeof this._options.expandOnlyOnTwistieClick=="undefined"?!0:this._options.expandOnlyOnTwistieClick}get onDidDispose(){return this.view.onDidDispose}updateOptions(L={}){this._options={...this._options,...L};for(const $ of this.renderers)$.updateOptions(L);this.view.updateOptions(this._options),this._onDidUpdateOptions.fire(this._options),this.getHTMLElement().classList.toggle("always",this._options.renderIndentGuides===m.Always)}get options(){return this._options}updateWidth(L){const $=this.model.getListIndex(L);$!==-1&&this.view.updateWidth($)}getHTMLElement(){return this.view.getHTMLElement()}get contentHeight(){return this.view.contentHeight}get onDidChangeContentHeight(){return this.view.onDidChangeContentHeight}get scrollTop(){return this.view.scrollTop}set scrollTop(L){this.view.scrollTop=L}get scrollLeft(){return this.view.scrollLeft}set scrollLeft(L){this.view.scrollLeft=L}get scrollHeight(){return this.view.scrollHeight}get renderHeight(){return this.view.renderHeight}get firstVisibleElement(){const L=this.view.firstVisibleIndex;return L<0||L>=this.view.length?void 0:this.view.element(L).element}get lastVisibleElement(){const L=this.view.lastVisibleIndex;return this.view.element(L).element}get ariaLabel(){return this.view.ariaLabel}set ariaLabel(L){this.view.ariaLabel=L}domFocus(){this.view.domFocus()}isDOMFocused(){return this.getHTMLElement()===document.activeElement}layout(L,$){this.view.layout(L,$),(0,b.isNumber)($)&&this.findController?.layout($)}style(L){const $=`.${this.view.domId}`,G=[];L.treeIndentGuidesStroke&&(G.push(`.monaco-list${$}:hover .monaco-tl-indent > .indent-guide, .monaco-list${$}.always .monaco-tl-indent > .indent-guide  { border-color: ${L.treeIndentGuidesStroke.transparent(.4)}; }`),G.push(`.monaco-list${$} .monaco-tl-indent > .indent-guide.active { border-color: ${L.treeIndentGuidesStroke}; }`)),this.styleElement.textContent=G.join(`
`),this.findController?.style(L),this.view.style(L)}getParentElement(L){const $=this.model.getParentNodeLocation(L);return this.model.getNode($).element}getFirstElementChild(L){return this.model.getFirstElementChild(L)}getNode(L){return this.model.getNode(L)}collapse(L,$=!1){return this.model.setCollapsed(L,!0,$)}expand(L,$=!1){return this.model.setCollapsed(L,!1,$)}toggleCollapsed(L,$=!1){return this.model.setCollapsed(L,void 0,$)}expandAll(){this.model.setCollapsed(this.model.rootRef,!1,!0)}collapseAll(){this.model.setCollapsed(this.model.rootRef,!0,!0)}isCollapsible(L){return this.model.isCollapsible(L)}setCollapsible(L,$){return this.model.setCollapsible(L,$)}isCollapsed(L){return this.model.isCollapsed(L)}triggerTypeNavigation(){this.view.triggerTypeNavigation()}openFind(){this.findController?.open()}closeFind(){this.findController?.close()}refilter(){this._onWillRefilter.fire(void 0),this.model.refilter()}setAnchor(L){if(typeof L=="undefined")return this.view.setAnchor(void 0);const $=this.model.getNode(L);this.anchor.set([$]);const G=this.model.getListIndex(L);G>-1&&this.view.setAnchor(G,!0)}getAnchor(){return(0,s.firstOrDefault)(this.anchor.get(),void 0)}setSelection(L,$){const G=L.map(h=>this.model.getNode(h));this.selection.set(G,$);const B=L.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setSelection(B,$,!0)}getSelection(){return this.selection.get()}setFocus(L,$){const G=L.map(h=>this.model.getNode(h));this.focus.set(G,$);const B=L.map(h=>this.model.getListIndex(h)).filter(h=>h>-1);this.view.setFocus(B,$,!0)}focusNext(L=1,$=!1,G,B=this.focusNavigationFilter){this.view.focusNext(L,$,G,B)}focusPrevious(L=1,$=!1,G,B=this.focusNavigationFilter){this.view.focusPrevious(L,$,G,B)}focusNextPage(L,$=this.focusNavigationFilter){return this.view.focusNextPage(L,$)}focusPreviousPage(L,$=this.focusNavigationFilter){return this.view.focusPreviousPage(L,$)}focusLast(L,$=this.focusNavigationFilter){this.view.focusLast(L,$)}focusFirst(L,$=this.focusNavigationFilter){this.view.focusFirst(L,$)}getFocus(){return this.focus.get()}reveal(L,$){this.model.expandTo(L);const G=this.model.getListIndex(L);G!==-1&&this.view.reveal(G,$)}getRelativeTop(L){const $=this.model.getListIndex(L);return $===-1?null:this.view.getRelativeTop($)}getViewState(L=this.options.identityProvider){if(!L)throw new F.TreeError(this._user,"Can't get tree view state without an identity provider");const $=I=>L.getId(I).toString(),G=u.empty(this.scrollTop);for(const I of this.getFocus())G.focus.add($(I));for(const I of this.getSelection())G.selection.add($(I));const B=this.model.getNode(),h=[B];for(;h.length>0;){const I=h.shift();I!==B&&I.collapsible&&(G.expanded[$(I.element)]=I.collapsed?0:1),h.push(...I.children)}return G}onLeftArrow(L){L.preventDefault(),L.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const G=$[0],B=this.model.getNodeLocation(G);if(!this.model.setCollapsed(B,!0)){const I=this.model.getParentNodeLocation(B);if(!I)return;const U=this.model.getListIndex(I);this.view.reveal(U),this.view.setFocus([U])}}onRightArrow(L){L.preventDefault(),L.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const G=$[0],B=this.model.getNodeLocation(G);if(!this.model.setCollapsed(B,!1)){if(!G.children.some(K=>K.visible))return;const[I]=this.view.getFocus(),U=I+1;this.view.reveal(U),this.view.setFocus([U])}}onSpace(L){L.preventDefault(),L.stopPropagation();const $=this.view.getFocusedElements();if($.length===0)return;const G=$[0],B=this.model.getNodeLocation(G),h=L.browserEvent.altKey;this.model.setCollapsed(B,void 0,h)}navigate(L){return new se(this.view,this.model,L)}dispose(){(0,o.dispose)(this.disposables),this.view.dispose()}}t.AbstractTree=X;class se{constructor(L,$,G){this.view=L,this.model=$,G?this.index=this.model.getListIndex(G):this.index=-1}current(){return this.index<0||this.index>=this.view.length?null:this.view.element(this.index).element}previous(){return this.index--,this.current()}next(){return this.index++,this.current()}first(){return this.index=0,this.current()}last(){return this.index=this.view.length-1,this.current()}}}),define(me[128],pe([1,0,127,117,23,26]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DataTree=void 0;class _ extends E.AbstractTree{constructor(g,d,f,F,l,s={}){super(g,d,f,F,s);this.user=g,this.dataSource=l,this.nodesByIdentity=new Map,this.identityProvider=s.identityProvider}getInput(){return this.input}setInput(g,d){if(d&&!this.identityProvider)throw new M.TreeError(this.user,"Can't restore tree view state without an identity provider");if(this.input=g,!g){this.nodesByIdentity.clear(),this.model.setChildren(null,O.Iterable.empty());return}if(!d){this._refresh(g);return}const f=[],F=[],l=e=>{const p=this.identityProvider.getId(e).toString();return!d.expanded[p]},s=e=>{const p=this.identityProvider.getId(e.element).toString();d.focus.has(p)&&f.push(e.element),d.selection.has(p)&&F.push(e.element)};this._refresh(g,l,s),this.setFocus(f),this.setSelection(F),d&&typeof d.scrollTop=="number"&&(this.scrollTop=d.scrollTop)}updateChildren(g=this.input){if(typeof this.input=="undefined")throw new M.TreeError(this.user,"Tree input not set");let d;this.identityProvider&&(d=f=>{const F=this.identityProvider.getId(f).toString(),l=this.nodesByIdentity.get(F);if(!!l)return l.collapsed}),this._refresh(g,d)}resort(g=this.input,d=!0){this.model.resort(g===this.input?null:g,d)}refresh(g){if(g===void 0){this.view.rerender();return}this.model.rerender(g)}_refresh(g,d,f){let F;if(this.identityProvider){const l=new Set,s=f;f=e=>{const p=this.identityProvider.getId(e.element).toString();l.add(p),this.nodesByIdentity.set(p,e),s?.(e)},F=e=>{const p=this.identityProvider.getId(e.element).toString();l.has(p)||this.nodesByIdentity.delete(p)}}this.model.setChildren(g===this.input?null:g,this.iterate(g,d).elements,{onDidCreateNode:f,onDidDeleteNode:F})}iterate(g,d){const f=[...this.dataSource.getChildren(g)];return{elements:O.Iterable.map(f,l=>{const{elements:s,size:e}=this.iterate(l,d),p=this.dataSource.hasChildren?this.dataSource.hasChildren(l):void 0,v=e===0?void 0:d&&d(l);return{element:l,children:s,collapsible:p,collapsed:v}}),size:f.length}}createModel(g,d,f){return new i.ObjectTreeModel(g,d,f)}}t.DataTree=_}),define(me[38],pe([1,0,14,8,31,28,25,13,3,2,49,10,6]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var s;(function(te){te[te.Promise=100]="Promise",te[te.PromiseCancel=101]="PromiseCancel",te[te.EventListen=102]="EventListen",te[te.EventDispose=103]="EventDispose"})(s=t.RequestType||(t.RequestType={}));function e(te){switch(te){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var p;(function(te){te[te.Initialize=200]="Initialize",te[te.PromiseSuccess=201]="PromiseSuccess",te[te.PromiseError=202]="PromiseError",te[te.PromiseErrorObj=203]="PromiseErrorObj",te[te.EventFire=204]="EventFire"})(p=t.ResponseType||(t.ResponseType={}));function v(te){switch(te){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var D;(function(te){te[te.Uninitialized=0]="Uninitialized",te[te.Idle=1]="Idle"})(D||(D={}));class y{constructor(X){this.buffer=X,this.pos=0}read(X){const se=this.buffer.slice(this.pos,this.pos+X);return this.pos+=se.byteLength,se}}class o{constructor(){this.buffers=[]}get buffer(){return M.VSBuffer.concat(this.buffers)}write(X){this.buffers.push(X)}}var c;(function(te){te[te.Undefined=0]="Undefined",te[te.String=1]="String",te[te.Buffer=2]="Buffer",te[te.VSBuffer=3]="VSBuffer",te[te.Array=4]="Array",te[te.Object=5]="Object"})(c||(c={}));function b(te){const X=M.VSBuffer.alloc(4);return X.writeUInt32BE(te,0),X}function S(te){return te.read(4).readUInt32BE(0)}function A(te){const X=M.VSBuffer.alloc(1);return X.writeUInt8(te,0),X}const C={Undefined:A(c.Undefined),String:A(c.String),Buffer:A(c.Buffer),VSBuffer:A(c.VSBuffer),Array:A(c.Array),Object:A(c.Object)},r=typeof Buffer!="undefined";function n(te,X){if(typeof X=="undefined")te.write(C.Undefined);else if(typeof X=="string"){const se=M.VSBuffer.fromString(X);te.write(C.String),te.write(b(se.byteLength)),te.write(se)}else if(r&&Buffer.isBuffer(X)){const se=M.VSBuffer.wrap(X);te.write(C.Buffer),te.write(b(se.byteLength)),te.write(se)}else if(X instanceof M.VSBuffer)te.write(C.VSBuffer),te.write(b(X.byteLength)),te.write(X);else if(Array.isArray(X)){te.write(C.Array),te.write(b(X.length));for(const se of X)n(te,se)}else{const se=M.VSBuffer.fromString(JSON.stringify(X));te.write(C.Object),te.write(b(se.byteLength)),te.write(se)}}function a(te){switch(te.read(1).readUInt8(0)){case c.Undefined:return;case c.String:return te.read(S(te)).toString();case c.Buffer:return te.read(S(te)).buffer;case c.VSBuffer:return te.read(S(te));case c.Array:{const se=S(te),ie=[];for(let L=0;L<se;L++)ie.push(a(te));return ie}case c.Object:return JSON.parse(te.read(S(te)).toString())}}class u{constructor(X,se,ie=null,L=1e3){this.protocol=X,this.ctx=se,this.logger=ie,this.timeoutDelay=L,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage($=>this.onRawMessage($)),this.sendResponse({type:200})}registerChannel(X,se){this.channels.set(X,se),setTimeout(()=>this.flushPendingRequests(X),0)}sendResponse(X){switch(X.type){case 200:{const se=this.send([X.type]);this.logger?.logOutgoing(se,0,1,v(X.type));return}case 201:case 202:case 204:case 203:{const se=this.send([X.type,X.id],X.data);this.logger?.logOutgoing(se,X.id,1,v(X.type),X.data);return}}}send(X,se=void 0){const ie=new o;return n(ie,X),n(ie,se),this.sendBuffer(ie.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onRawMessage(X){const se=new y(X),ie=a(se),L=a(se),$=ie[0];switch($){case 100:return this.logger?.logIncoming(X.byteLength,ie[1],1,`${e($)}: ${ie[2]}.${ie[3]}`,L),this.onPromise({type:$,id:ie[1],channelName:ie[2],name:ie[3],arg:L});case 102:return this.logger?.logIncoming(X.byteLength,ie[1],1,`${e($)}: ${ie[2]}.${ie[3]}`,L),this.onEventListen({type:$,id:ie[1],channelName:ie[2],name:ie[3],arg:L});case 101:return this.logger?.logIncoming(X.byteLength,ie[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:ie[1]});case 103:return this.logger?.logIncoming(X.byteLength,ie[1],1,`${e($)}`),this.disposeActiveRequest({type:$,id:ie[1]})}}onPromise(X){const se=this.channels.get(X.channelName);if(!se){this.collectPendingRequest(X);return}const ie=new O.CancellationTokenSource;let L;try{L=se.call(this.ctx,X.name,X.arg,ie.token)}catch(B){L=Promise.reject(B)}const $=X.id;L.then(B=>{this.sendResponse({id:$,data:B,type:201}),this.activeRequests.delete(X.id)},B=>{B instanceof Error?this.sendResponse({id:$,data:{message:B.message,name:B.name,stack:B.stack?B.stack.split?B.stack.split(`
`):B.stack:void 0},type:202}):this.sendResponse({id:$,data:B,type:203}),this.activeRequests.delete(X.id)});const G=(0,d.toDisposable)(()=>ie.cancel());this.activeRequests.set(X.id,G)}onEventListen(X){const se=this.channels.get(X.channelName);if(!se){this.collectPendingRequest(X);return}const ie=X.id,$=se.listen(this.ctx,X.name,X.arg)(G=>this.sendResponse({id:ie,data:G,type:204}));this.activeRequests.set(X.id,$)}disposeActiveRequest(X){const se=this.activeRequests.get(X.id);se&&(se.dispose(),this.activeRequests.delete(X.id))}collectPendingRequest(X){let se=this.pendingRequests.get(X.channelName);se||(se=[],this.pendingRequests.set(X.channelName,se));const ie=setTimeout(()=>{console.error(`Unknown channel: ${X.channelName}`),X.type===100&&this.sendResponse({id:X.id,data:{name:"Unknown channel",message:`Channel name '${X.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);se.push({request:X,timeoutTimer:ie})}flushPendingRequests(X){const se=this.pendingRequests.get(X);if(se){for(const ie of se)switch(clearTimeout(ie.timeoutTimer),ie.request.type){case 100:this.onPromise(ie.request);break;case 102:this.onEventListen(ie.request);break}this.pendingRequests.delete(X)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=u;var m;(function(te){te[te.LocalSide=0]="LocalSide",te[te.OtherSide=1]="OtherSide"})(m=t.RequestInitiator||(t.RequestInitiator={}));class W{constructor(X,se=null){this.protocol=X,this.isDisposed=!1,this.state=D.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new g.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(ie=>this.onBuffer(ie)),this.logger=se}getChannel(X){const se=this;return{call(ie,L,$){return se.isDisposed?Promise.reject(w.canceled()):se.requestPromise(X,ie,L,$)},listen(ie,L){return se.isDisposed?g.Event.None:se.requestEvent(X,ie,L)}}}requestPromise(X,se,ie,L=O.CancellationToken.None){const $=this.lastRequestId++,B={id:$,type:100,channelName:X,name:se,arg:ie};if(L.isCancellationRequested)return Promise.reject(w.canceled());let h;return new Promise((U,K)=>{if(L.isCancellationRequested)return K(w.canceled());const Q=()=>{const T=H=>{switch(H.type){case 201:this.handlers.delete($),U(H.data);break;case 202:{this.handlers.delete($);const k=new Error(H.data.message);k.stack=H.data.stack,k.name=H.data.name,K(k);break}case 203:this.handlers.delete($),K(H.data);break}};this.handlers.set($,T),this.sendRequest(B)};let N=null;this.state===D.Idle?Q():(N=(0,i.createCancelablePromise)(T=>this.whenInitialized()),N.then(()=>{N=null,Q()}));const R=()=>{N?(N.cancel(),N=null):this.sendRequest({id:$,type:101}),K(w.canceled())},z=L.onCancellationRequested(R);h=(0,d.combinedDisposable)((0,d.toDisposable)(R),z),this.activeRequests.add(h)}).finally(()=>{this.activeRequests.delete(h)})}requestEvent(X,se,ie){const L=this.lastRequestId++,G={id:L,type:102,channelName:X,name:se,arg:ie};let B=null;const h=new g.Emitter({onFirstListenerAdd:()=>{B=(0,i.createCancelablePromise)(U=>this.whenInitialized()),B.then(()=>{B=null,this.activeRequests.add(h),this.sendRequest(G)})},onLastListenerRemove:()=>{B?(B.cancel(),B=null):(this.activeRequests.delete(h),this.sendRequest({id:L,type:103}))}}),I=U=>h.fire(U.data);return this.handlers.set(L,I),h.event}sendRequest(X){switch(X.type){case 100:case 102:{const se=this.send([X.type,X.id,X.channelName,X.name],X.arg);this.logger?.logOutgoing(se,X.id,0,`${e(X.type)}: ${X.channelName}.${X.name}`,X.arg);return}case 101:case 103:{const se=this.send([X.type,X.id]);this.logger?.logOutgoing(se,X.id,0,e(X.type));return}}}send(X,se=void 0){const ie=new o;return n(ie,X),n(ie,se),this.sendBuffer(ie.buffer)}sendBuffer(X){try{return this.protocol.send(X),X.byteLength}catch{return 0}}onBuffer(X){const se=new y(X),ie=a(se),L=a(se),$=ie[0];switch($){case 200:return this.logger?.logIncoming(X.byteLength,0,0,v($)),this.onResponse({type:ie[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(X.byteLength,ie[1],0,v($),L),this.onResponse({type:ie[0],id:ie[1],data:L})}}onResponse(X){if(X.type===200){this.state=D.Idle,this._onDidInitialize.fire();return}this.handlers.get(X.id)?.(X)}get onDidInitializePromise(){return g.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===D.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}Ke([_.memoize],W.prototype,"onDidInitializePromise",null),t.ChannelClient=W;class V{constructor(X){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new g.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new g.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,X(({protocol:se,onDidClientDisconnect:ie})=>{g.Event.once(se.onMessage)($=>{const G=new y($),B=a(G),h=new u(se,B),I=new W(se);this.channels.forEach((K,Q)=>h.registerChannel(Q,K));const U={channelServer:h,channelClient:I,ctx:B};this._connections.add(U),this._onDidAddConnection.fire(U),ie(()=>{h.dispose(),I.dispose(),this._connections.delete(U),this._onDidRemoveConnection.fire(U)})})})}get connections(){const X=[];return this._connections.forEach(se=>X.push(se)),X}getChannel(X,se){const ie=this;return{call(L,$,G){let B;if((0,l.isFunction)(se)){const I=(0,E.getRandomElement)(ie.connections.filter(se));B=I?Promise.resolve(I):g.Event.toPromise(g.Event.filter(ie.onDidAddConnection,se))}else B=se.routeCall(ie,L,$);const h=B.then(I=>I.channelClient.getChannel(X));return re(h).call(L,$,G)},listen(L,$){if((0,l.isFunction)(se))return ie.getMulticastEvent(X,se,L,$);const G=se.routeEvent(ie,L,$).then(B=>B.channelClient.getChannel(X));return re(G).listen(L,$)}}}getMulticastEvent(X,se,ie,L){const $=this;let G=new d.DisposableStore;const B=new g.Emitter({onFirstListenerAdd:()=>{G=new d.DisposableStore;const h=new g.EventMultiplexer,I=new Map,U=Q=>{const R=Q.channelClient.getChannel(X).listen(ie,L),z=h.add(R);I.set(Q,z)},K=Q=>{const N=I.get(Q);!N||(N.dispose(),I.delete(Q))};$.connections.filter(se).forEach(U),g.Event.filter($.onDidAddConnection,se)(U,void 0,G),$.onDidRemoveConnection(K,void 0,G),h.event(B.fire,B,G),G.add(h)},onLastListenerRemove:()=>{G.dispose()}});return B.event}registerChannel(X,se){this.channels.set(X,se),this._connections.forEach(ie=>{ie.channelServer.registerChannel(X,se)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=V;class ne{constructor(X,se,ie=null){const L=new o;n(L,se),X.send(L.buffer),this.channelClient=new W(X,ie),this.channelServer=new u(X,se,ie)}getChannel(X){return this.channelClient.getChannel(X)}registerChannel(X,se){this.channelServer.registerChannel(X,se)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=ne;function re(te){return{call(X,se,ie){return te.then(L=>L.call(X,se,ie))},listen(X,se){const ie=new g.Relay;return te.then(L=>ie.input=L.listen(X,se)),ie.event}}}t.getDelayedChannel=re;function we(te){let X=!1;return{call(se,ie,L){return X?te.call(se,ie,L):(0,i.timeout)(0).then(()=>X=!0).then(()=>te.call(se,ie,L))},listen(se,ie){if(X)return te.listen(se,ie);const L=new g.Relay;return(0,i.timeout)(0).then(()=>X=!0).then(()=>L.input=te.listen(se,ie)),L.event}}}t.getNextTickChannel=we;class ae{constructor(X){this.fn=X}routeCall(X){return this.route(X)}routeEvent(X){return this.route(X)}async route(X){for(const se of X.connections)if(await Promise.resolve(this.fn(se.ctx)))return Promise.resolve(se);return await g.Event.toPromise(X.onDidAddConnection),await this.route(X)}}t.StaticRouter=ae;var ve;(function(te){function X($,G){const B=$,h=G&&G.disableMarshalling,I=new Map;for(const U in B)ie(U)&&I.set(U,g.Event.buffer(B[U],!0));return new class{listen(U,K,Q){const N=I.get(K);if(N)return N;if(L(K)){const R=B[K];if(typeof R=="function")return R.call(B,Q)}throw new Error(`Event not found: ${K}`)}call(U,K,Q){const N=B[K];if(typeof N=="function"){if(!h&&Array.isArray(Q))for(let R=0;R<Q.length;R++)Q[R]=(0,f.revive)(Q[R]);return N.apply(B,Q)}throw new Error(`Method not found: ${K}`)}}}te.fromService=X;function se($,G){const B=G&&G.disableMarshalling;return new Proxy({},{get(h,I){if(typeof I=="string")return G?.properties?.has(I)?G.properties.get(I):L(I)?function(U){return $.listen(I,U)}:ie(I)?$.listen(I):async function(...U){let K;G&&!(0,l.isUndefinedOrNull)(G.context)?K=[G.context,...U]:K=U;const Q=await $.call(I,K);return B?Q:(0,f.revive)(Q)};throw new Error(`Property not found: ${String(I)}`)}})}te.toService=se;function ie($){return $[0]==="o"&&$[1]==="n"&&F.isUpperAsciiLetter($.charCodeAt(2))}function L($){return/^onDynamic/.test($)&&F.isUpperAsciiLetter($.charCodeAt(9))}})(ve=t.ProxyChannel||(t.ProxyChannel={}));const ue=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(te){if(Array.isArray(te))return te;if(te&&typeof te=="object"&&typeof te.toString=="function"){const X=te.toString();if(X!=="[object Object]")return X}return te}function ye(te){return Array.isArray(te)?te.map(ge):ge(te)}function ee(te,X,se,ie,L,$,G){G=ye(G);const B=ue[L],h=B[ie%B.length];let I=[`%c[${te}]%c[${String(X).padStart(7," ")}]%c[len: ${String(se).padStart(5," ")}]%c${String(ie).padStart(5," ")} - ${$}`,"color: darkgreen","color: grey","color: grey",`color: ${h}`];/\($/.test($)?(I=I.concat(G),I.push(")")):I.push(G),console.log.apply(console,I)}t.logWithColors=ee;class fe{constructor(X,se){this._outgoingPrefix=X,this._incomingPrefix=se,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(X,se,ie,L,$){this._totalOutgoing+=X,ee(this._outgoingPrefix,this._totalOutgoing,X,se,ie,L,$)}logIncoming(X,se,ie,L,$){this._totalIncoming+=X,ee(this._incomingPrefix,this._totalIncoming,X,se,ie,L,$)}}t.IPCLogger=fe}),define(me[29],pe([1,0,5]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.context=t.process=t.webFrame=t.ipcMessagePort=t.ipcRenderer=void 0,t.ipcRenderer=E.globals.vscode.ipcRenderer,t.ipcMessagePort=E.globals.vscode.ipcMessagePort,t.webFrame=E.globals.vscode.webFrame,t.process=E.globals.vscode.process,t.context=E.globals.vscode.context}),define(me[129],pe([1,0,80,29]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.popup=void 0;let M=0;function O(w,g,d){const f=[],F=M++,l=`vscode:onContextMenu${F}`,s=(e,p,v)=>{f[p].click?.(v)};i.ipcRenderer.once(l,s),i.ipcRenderer.once(E.CONTEXT_MENU_CLOSE_CHANNEL,(e,p)=>{p===F&&(i.ipcRenderer.removeListener(l,s),d?.())}),i.ipcRenderer.send(E.CONTEXT_MENU_CHANNEL,F,w.map(e=>_(e,f)),l,g)}t.popup=O;function _(w,g){const d={id:g.length,label:w.label,type:w.type,accelerator:w.accelerator,checked:w.checked,enabled:typeof w.enabled=="boolean"?w.enabled:!0,visible:typeof w.visible=="boolean"?w.visible:!0};return g.push(w),Array.isArray(w.submenu)&&(d.submenu=w.submenu.map(f=>_(f,g))),d}}),define(me[130],pe([1,0,31,3,38,81,29]),function(Z,t,E,i,M,O,_){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=void 0;class w extends M.IPCClient{constructor(d){const f=w.createProtocol();super(f,d);this.protocol=f}static createProtocol(){const d=i.Event.fromNodeEventEmitter(_.ipcRenderer,"vscode:message",(f,F)=>E.VSBuffer.wrap(F));return _.ipcRenderer.send("vscode:hello"),new O.Protocol(_.ipcRenderer,d)}dispose(){this.protocol.disconnect()}}t.Client=w}),define(me[131],pe([12,9]),function(Z,t){return Z.create("vs/platform/files/common/files",t)}),define(me[132],pe([12,9]),function(Z,t){return Z.create("vs/platform/theme/common/iconRegistry",t)}),define(me[63],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class E{constructor(M,O=[],_=!1){this.ctor=M,this.staticArguments=O,this.supportsDelayedInstantiation=_}}t.SyncDescriptor=E}),define(me[133],pe([1,0,63]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const i=[];function M(_,w,g){w instanceof E.SyncDescriptor||(w=new E.SyncDescriptor(w,[],g)),i.push([_,w])}t.registerSingleton=M;function O(){return i}t.getSingletonServiceDescriptors=O}),define(me[30],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.refineServiceDecorator=t.createDecorator=t.IInstantiationService=t._util=void 0;var E;(function(_){_.serviceIds=new Map,_.DI_TARGET="$di$target",_.DI_DEPENDENCIES="$di$dependencies";function w(g){return g[_.DI_DEPENDENCIES]||[]}_.getServiceDependencies=w})(E=t._util||(t._util={})),t.IInstantiationService=M("instantiationService");function i(_,w,g){w[E.DI_TARGET]===w?w[E.DI_DEPENDENCIES].push({id:_,index:g}):(w[E.DI_DEPENDENCIES]=[{id:_,index:g}],w[E.DI_TARGET]=w)}function M(_){if(E.serviceIds.has(_))return E.serviceIds.get(_);const w=function(g,d,f){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");i(w,g,f)};return w.toString=()=>_,E.serviceIds.set(_,w),w}t.createDecorator=M;function O(_){return _}t.refineServiceDecorator=O}),define(me[134],pe([1,0,30]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullDiagnosticsService=t.isRemoteDiagnosticError=t.IDiagnosticsService=t.ID=void 0,t.ID="diagnosticsService",t.IDiagnosticsService=(0,E.createDecorator)(t.ID);function i(O){return!!O.hostName&&!!O.errorMessage}t.isRemoteDiagnosticError=i;class M{async getPerformanceInfo(_,w){return{}}async getSystemInfo(_,w){return{processArgs:"nullProcessArgs",gpuStatus:"nullGpuStatus",screenReader:"nullScreenReader",remoteData:[],os:"nullOs",memory:"nullMemory",vmHint:"nullVmHint"}}async getDiagnostics(_,w){return""}async getWorkspaceFileExtensions(_){return{extensions:[]}}async reportWorkspaceStats(_){}}t.NullDiagnosticsService=M}),define(me[135],pe([1,0,48,21,10,6,16,131,30]),function(Z,t,E,i,M,O,_,w,g){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPlatformLimits=t.Arch=t.ByteSize=t.FALLBACK_MAX_MEMORY_SIZE_MB=t.MIN_MAX_MEMORY_SIZE_MB=t.whenProviderRegistered=t.etag=t.ETAG_DISABLED=t.FileKind=t.FILES_EXCLUDE_CONFIG=t.FILES_ASSOCIATIONS_CONFIG=t.HotExitConfiguration=t.AutoSaveConfiguration=t.FileOperationResult=t.NotModifiedSinceFileOperationError=t.FileOperationError=t.isParent=t.FileChangesEvent=t.FileChangeType=t.FileOperationEvent=t.FileOperation=t.toFileOperationResult=t.toFileSystemProviderErrorCode=t.markAsFileSystemProviderError=t.ensureFileSystemProviderError=t.createFileSystemProviderError=t.FileSystemProviderError=t.FileSystemProviderErrorCode=t.hasFileAtomicReadCapability=t.hasFileReadStreamCapability=t.hasOpenReadWriteCloseCapability=t.hasFileCloneCapability=t.hasFileFolderCopyCapability=t.hasReadWriteCapability=t.FileSystemProviderCapabilities=t.FilePermission=t.FileType=t.isFileOpenForWriteOptions=t.IFileService=void 0,t.IFileService=(0,g.createDecorator)("fileService");function d(ee){return ee.create===!0}t.isFileOpenForWriteOptions=d;var f;(function(ee){ee[ee.Unknown=0]="Unknown",ee[ee.File=1]="File",ee[ee.Directory=2]="Directory",ee[ee.SymbolicLink=64]="SymbolicLink"})(f=t.FileType||(t.FileType={}));var F;(function(ee){ee[ee.Readonly=1]="Readonly"})(F=t.FilePermission||(t.FilePermission={}));var l;(function(ee){ee[ee.FileReadWrite=2]="FileReadWrite",ee[ee.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",ee[ee.FileReadStream=16]="FileReadStream",ee[ee.FileFolderCopy=8]="FileFolderCopy",ee[ee.PathCaseSensitive=1024]="PathCaseSensitive",ee[ee.Readonly=2048]="Readonly",ee[ee.Trash=4096]="Trash",ee[ee.FileWriteUnlock=8192]="FileWriteUnlock",ee[ee.FileAtomicRead=16384]="FileAtomicRead",ee[ee.FileClone=32768]="FileClone"})(l=t.FileSystemProviderCapabilities||(t.FileSystemProviderCapabilities={}));function s(ee){return!!(ee.capabilities&2)}t.hasReadWriteCapability=s;function e(ee){return!!(ee.capabilities&8)}t.hasFileFolderCopyCapability=e;function p(ee){return!!(ee.capabilities&32768)}t.hasFileCloneCapability=p;function v(ee){return!!(ee.capabilities&4)}t.hasOpenReadWriteCloseCapability=v;function D(ee){return!!(ee.capabilities&16)}t.hasFileReadStreamCapability=D;function y(ee){return s(ee)?!!(ee.capabilities&16384):!1}t.hasFileAtomicReadCapability=y;var o;(function(ee){ee.FileExists="EntryExists",ee.FileNotFound="EntryNotFound",ee.FileNotADirectory="EntryNotADirectory",ee.FileIsADirectory="EntryIsADirectory",ee.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",ee.FileTooLarge="EntryTooLarge",ee.FileWriteLocked="EntryWriteLocked",ee.NoPermissions="NoPermissions",ee.Unavailable="Unavailable",ee.Unknown="Unknown"})(o=t.FileSystemProviderErrorCode||(t.FileSystemProviderErrorCode={}));class c extends Error{constructor(fe,te){super(fe);this.code=te}}t.FileSystemProviderError=c;function b(ee,fe){const te=new c(ee.toString(),fe);return A(te,fe),te}t.createFileSystemProviderError=b;function S(ee){return ee||b((0,w.localize)(0,null),o.Unknown)}t.ensureFileSystemProviderError=S;function A(ee,fe){return ee.name=fe?`${fe} (FileSystemError)`:"FileSystemError",ee}t.markAsFileSystemProviderError=A;function C(ee){if(!ee)return o.Unknown;if(ee instanceof c)return ee.code;const fe=/^(.+) \(FileSystemError\)$/.exec(ee.name);if(!fe)return o.Unknown;switch(fe[1]){case o.FileExists:return o.FileExists;case o.FileIsADirectory:return o.FileIsADirectory;case o.FileNotADirectory:return o.FileNotADirectory;case o.FileNotFound:return o.FileNotFound;case o.FileExceedsMemoryLimit:return o.FileExceedsMemoryLimit;case o.FileTooLarge:return o.FileTooLarge;case o.FileWriteLocked:return o.FileWriteLocked;case o.NoPermissions:return o.NoPermissions;case o.Unavailable:return o.Unavailable}return o.Unknown}t.toFileSystemProviderErrorCode=C;function r(ee){if(ee instanceof V)return ee.fileOperationResult;switch(C(ee)){case o.FileNotFound:return 1;case o.FileIsADirectory:return 0;case o.FileNotADirectory:return 10;case o.FileWriteLocked:return 5;case o.NoPermissions:return 6;case o.FileExists:return 4;case o.FileExceedsMemoryLimit:return 9;case o.FileTooLarge:return 7;default:return 11}}t.toFileOperationResult=r;var n;(function(ee){ee[ee.CREATE=0]="CREATE",ee[ee.DELETE=1]="DELETE",ee[ee.MOVE=2]="MOVE",ee[ee.COPY=3]="COPY",ee[ee.WRITE=4]="WRITE"})(n=t.FileOperation||(t.FileOperation={}));class a{constructor(fe,te,X){this.resource=fe,this.operation=te,this.target=X}isOperation(fe){return this.operation===fe}}t.FileOperationEvent=a;var u;(function(ee){ee[ee.UPDATED=0]="UPDATED",ee[ee.ADDED=1]="ADDED",ee[ee.DELETED=2]="DELETED"})(u=t.FileChangeType||(t.FileChangeType={}));class m{constructor(fe,te){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=fe;const X=new Map;for(const se of fe){const ie=X.get(se.type);switch(ie?ie.push([se.resource,se]):X.set(se.type,[[se.resource,se]]),se.type){case 1:this.rawAdded.push(se.resource);break;case 0:this.rawUpdated.push(se.resource);break;case 2:this.rawDeleted.push(se.resource);break}}for(const[se,ie]of X)switch(se){case 1:this.added=E.TernarySearchTree.forUris(()=>te),this.added.fill(ie);break;case 0:this.updated=E.TernarySearchTree.forUris(()=>te),this.updated.fill(ie);break;case 2:this.deleted=E.TernarySearchTree.forUris(()=>te),this.deleted.fill(ie);break}}contains(fe,...te){return this.doContains(fe,{includeChildren:!1},...te)}affects(fe,...te){return this.doContains(fe,{includeChildren:!0},...te)}doContains(fe,te,...X){if(!fe)return!1;const se=X.length>0;return!!((!se||X.includes(1))&&(this.added?.get(fe)||te.includeChildren&&this.added?.findSuperstr(fe))||(!se||X.includes(0))&&(this.updated?.get(fe)||te.includeChildren&&this.updated?.findSuperstr(fe))||(!se||X.includes(2))&&(this.deleted?.findSubstr(fe)||te.includeChildren&&this.deleted?.findSuperstr(fe)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}t.FileChangesEvent=m;function W(ee,fe,te){return!ee||!fe||ee===fe||fe.length>ee.length?!1:(fe.charAt(fe.length-1)!==i.sep&&(fe+=i.sep),te?(0,M.startsWithIgnoreCase)(ee,fe):ee.indexOf(fe)===0)}t.isParent=W;class V extends Error{constructor(fe,te,X){super(fe);this.fileOperationResult=te,this.options=X}}t.FileOperationError=V;class ne extends V{constructor(fe,te,X){super(fe,2,X);this.stat=te}}t.NotModifiedSinceFileOperationError=ne;var re;(function(ee){ee[ee.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",ee[ee.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",ee[ee.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",ee[ee.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",ee[ee.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",ee[ee.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",ee[ee.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",ee[ee.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",ee[ee.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",ee[ee.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",ee[ee.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",ee[ee.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(re=t.FileOperationResult||(t.FileOperationResult={})),t.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},t.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},t.FILES_ASSOCIATIONS_CONFIG="files.associations",t.FILES_EXCLUDE_CONFIG="files.exclude";var we;(function(ee){ee[ee.FILE=0]="FILE",ee[ee.FOLDER=1]="FOLDER",ee[ee.ROOT_FOLDER=2]="ROOT_FOLDER"})(we=t.FileKind||(t.FileKind={})),t.ETAG_DISABLED="";function ae(ee){if(!(typeof ee.size!="number"||typeof ee.mtime!="number"))return ee.mtime.toString(29)+ee.size.toString(31)}t.etag=ae;async function ve(ee,fe){if(!fe.hasProvider(_.URI.from({scheme:ee.scheme})))return new Promise(te=>{const X=fe.onDidChangeFileSystemProviderRegistrations(se=>{se.scheme===ee.scheme&&se.added&&(X.dispose(),te())})})}t.whenProviderRegistered=ve,t.MIN_MAX_MEMORY_SIZE_MB=2048,t.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ue{static formatSize(fe){return(0,O.isNumber)(fe)||(fe=0),fe<ue.KB?(0,w.localize)(1,null,fe.toFixed(0)):fe<ue.MB?(0,w.localize)(2,null,(fe/ue.KB).toFixed(2)):fe<ue.GB?(0,w.localize)(3,null,(fe/ue.MB).toFixed(2)):fe<ue.TB?(0,w.localize)(4,null,(fe/ue.GB).toFixed(2)):(0,w.localize)(5,null,(fe/ue.TB).toFixed(2))}}t.ByteSize=ue,ue.KB=1024,ue.MB=ue.KB*ue.KB,ue.GB=ue.MB*ue.KB,ue.TB=ue.GB*ue.KB;var ge;(function(ee){ee[ee.IA32=0]="IA32",ee[ee.OTHER=1]="OTHER"})(ge=t.Arch||(t.Arch={}));function ye(ee){return{maxFileSize:ee===0?300*ue.MB:16*ue.GB,maxHeapSize:ee===0?700*ue.MB:2*700*ue.MB}}t.getPlatformLimits=ye}),define(me[136],pe([1,0,2,130]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ElectronIPCMainProcessService=void 0;class M extends E.Disposable{constructor(_){super();this.mainProcessConnection=this._register(new i.Client(`window:${_}`))}getChannel(_){return this.mainProcessConnection.getChannel(_)}registerChannel(_,w){this.mainProcessConnection.registerChannel(_,w)}}t.ElectronIPCMainProcessService=M});var Tt=this&&this.__param||function(Z,t){return function(E,i){t(E,i,Z)}};define(me[137],pe([1,0,38,63,133,30]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.registerSharedProcessRemoteService=t.ISharedProcessService=t.registerMainProcessRemoteService=t.IMainProcessService=void 0;class _{constructor(s,e,p){const v=p.getChannel(s);return w(e)?new e.channelClientCtor(v):E.ProxyChannel.toService(v,e?.proxyOptions)}}function w(l){return!!l?.channelClientCtor}t.IMainProcessService=(0,O.createDecorator)("mainProcessService");let g=class extends _{constructor(s,e,p){super(s,e,p)}};g=Ke([Tt(2,t.IMainProcessService)],g);function d(l,s,e){(0,M.registerSingleton)(l,new i.SyncDescriptor(g,[s,e],e?.supportsDelayedInstantiation))}t.registerMainProcessRemoteService=d,t.ISharedProcessService=(0,O.createDecorator)("sharedProcessService");let f=class extends _{constructor(s,e,p){super(s,e,p)}};f=Ke([Tt(2,t.ISharedProcessService)],f);function F(l,s,e){(0,M.registerSingleton)(l,new i.SyncDescriptor(f,[s,e],e?.supportsDelayedInstantiation))}t.registerSharedProcessRemoteService=F}),define(me[138],pe([1,0,38,137]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeHostService=void 0;let M=class{constructor(_,w){return this.windowId=_,E.ProxyChannel.toService(w.getChannel("nativeHost"),{context:_,properties:(()=>{const g=new Map;return g.set("windowId",_),g})()})}};M=Ke([Tt(1,i.IMainProcessService)],M),t.NativeHostService=M}),define(me[39],pe([1,0,68,6]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class M{constructor(){this.data=new Map}add(_,w){E.ok(i.isString(_)),E.ok(i.isObject(w)),E.ok(!this.data.has(_),"There is already an extension with this id"),this.data.set(_,w)}knows(_){return this.data.has(_)}as(_){return this.data.get(_)||null}}t.Registry=new M}),define(me[139],pe([1,0,3,39]),function(Z,t,E,i){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function M(w){return w.length>0&&w.charAt(w.length-1)==="#"?w.substring(0,w.length-1):w}class O{constructor(){this._onDidChangeSchema=new E.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(g,d){this.schemasById[M(g)]=d,this._onDidChangeSchema.fire(g)}notifySchemaChanged(g){this._onDidChangeSchema.fire(g)}getSchemaContributions(){return{schemas:this.schemasById}}}const _=new O;i.Registry.add(t.Extensions.JSONContribution,_)}),define(me[140],pe([1,0]),function(Z,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isDark=t.isHighContrast=t.ColorScheme=void 0;var E;(function(O){O.DARK="dark",O.LIGHT="light",O.HIGH_CONTRAST_DARK="hcDark",O.HIGH_CONTRAST_LIGHT="hcLight"})(E=t.ColorScheme||(t.ColorScheme={}));function i(O){return O===E.HIGH_CONTRAST_DARK||O===E.HIGH_CONTRAST_LIGHT}t.isHighContrast=i;function M(O){return O===E.DARK||O===E.HIGH_CONTRAST_DARK}t.isDark=M}),define(me[64],pe([1,0,11,3,2,30,39,140]),function(Z,t,E,i,M,O,_,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Themable=t.registerThemingParticipant=t.Extensions=t.getThemeTypeSelector=t.FolderThemeIcon=t.FileThemeIcon=t.ThemeIcon=t.themeColorFromId=t.ThemeColor=t.IThemeService=void 0,t.IThemeService=(0,O.createDecorator)("themeService");var g;(function(v){function D(y){return y&&typeof y=="object"&&typeof y.id=="string"}v.isThemeColor=D})(g=t.ThemeColor||(t.ThemeColor={}));function d(v){return{id:v}}t.themeColorFromId=d;var f;(function(v){function D(r){return r&&typeof r=="object"&&typeof r.id=="string"&&(typeof r.color=="undefined"||g.isThemeColor(r.color))}v.isThemeIcon=D;const y=new RegExp(`^\\$\\((${E.CSSIcon.iconNameExpression}(?:${E.CSSIcon.iconModifierExpression})?)\\)$`);function o(r){const n=y.exec(r);if(!n)return;const[,a]=n;return{id:a}}v.fromString=o;function c(r){return{id:r}}v.fromId=c;function b(r,n){let a=r.id;const u=a.lastIndexOf("~");return u!==-1&&(a=a.substring(0,u)),n&&(a=`${a}~${n}`),{id:a}}v.modify=b;function S(r){const n=r.id.lastIndexOf("~");if(n!==-1)return r.id.substring(n+1)}v.getModifier=S;function A(r,n){return r.id===n.id&&r.color?.id===n.color?.id}v.isEqual=A;function C(r,n){return{id:r.id,color:n?d(n):void 0}}v.asThemeIcon=C,v.asClassNameArray=E.CSSIcon.asClassNameArray,v.asClassName=E.CSSIcon.asClassName,v.asCSSSelector=E.CSSIcon.asCSSSelector})(f=t.ThemeIcon||(t.ThemeIcon={})),t.FileThemeIcon=E.Codicon.file,t.FolderThemeIcon=E.Codicon.folder;function F(v){switch(v){case w.ColorScheme.DARK:return"vs-dark";case w.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case w.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}t.getThemeTypeSelector=F,t.Extensions={ThemingContribution:"base.contributions.theming"};class l{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new i.Emitter}onColorThemeChange(D){return this.themingParticipants.push(D),this.onThemingParticipantAddedEmitter.fire(D),(0,M.toDisposable)(()=>{const y=this.themingParticipants.indexOf(D);this.themingParticipants.splice(y,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const s=new l;_.Registry.add(t.Extensions.ThemingContribution,s);function e(v){return s.onColorThemeChange(v)}t.registerThemingParticipant=e;class p extends M.Disposable{constructor(D){super();this.themeService=D,this.theme=D.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(y=>this.onThemeChange(y)))}onThemeChange(D){this.theme=D,this.updateStyles()}updateStyles(){}getColor(D,y){let o=this.theme.getColor(D);return o&&y&&(o=y(o,this.theme)),o?o.toString():null}}t.Themable=p}),define(me[141],pe([1,0,8,11,3,6,16,132,139,39,64]),function(Z,t,E,i,M,O,_,w,g,d,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.spinningLoading=t.syncing=t.gotoNextLocation=t.gotoPreviousLocation=t.widgetClose=t.iconsSchemaId=t.getIconRegistry=t.registerIcon=t.IconFontDefinition=t.IconContribution=t.Extensions=void 0,t.Extensions={IconContribution:"base.contributions.icons"};var F;(function(c){function b(S,A){let C=S.defaults;for(;f.ThemeIcon.isThemeIcon(C);){const r=e.getIcon(C.id);if(!r)return;C=r.defaults}return C}c.getDefinition=b})(F=t.IconContribution||(t.IconContribution={}));var l;(function(c){function b(A){return{weight:A.weight,style:A.style,src:A.src.map(C=>({format:C.format,location:C.location.toString()}))}}c.toJSONObject=b;function S(A){const C=r=>(0,O.isString)(r)?r:void 0;if(A&&Array.isArray(A.src)&&A.src.every(r=>(0,O.isString)(r.format)&&(0,O.isString)(r.location)))return{weight:C(A.weight),style:C(A.style),src:A.src.map(r=>({format:r.format,location:_.URI.parse(r.location)}))}}c.fromJSONObject=S})(l=t.IconFontDefinition||(t.IconFontDefinition={}));class s{constructor(){this._onDidChange=new M.Emitter,this.onDidChange=this._onDidChange.event,this.iconSchema={definitions:{icons:{type:"object",properties:{fontId:{type:"string",description:(0,w.localize)(0,null)},fontCharacter:{type:"string",description:(0,w.localize)(1,null)}},additionalProperties:!1,defaultSnippets:[{body:{fontCharacter:"\\\\e030"}}]}},type:"object",properties:{}},this.iconReferenceSchema={type:"string",pattern:`^${i.CSSIcon.iconNameExpression}$`,enum:[],enumDescriptions:[]},this.iconsById={},this.iconFontsById={}}registerIcon(b,S,A,C){const r=this.iconsById[b];if(r){if(A&&!r.description){r.description=A,this.iconSchema.properties[b].markdownDescription=`${A} $(${b})`;const u=this.iconReferenceSchema.enum.indexOf(b);u!==-1&&(this.iconReferenceSchema.enumDescriptions[u]=A),this._onDidChange.fire()}return r}const n={id:b,description:A,defaults:S,deprecationMessage:C};this.iconsById[b]=n;const a={$ref:"#/definitions/icons"};return C&&(a.deprecationMessage=C),A&&(a.markdownDescription=`${A}: $(${b})`),this.iconSchema.properties[b]=a,this.iconReferenceSchema.enum.push(b),this.iconReferenceSchema.enumDescriptions.push(A||""),this._onDidChange.fire(),{id:b}}deregisterIcon(b){delete this.iconsById[b],delete this.iconSchema.properties[b];const S=this.iconReferenceSchema.enum.indexOf(b);S!==-1&&(this.iconReferenceSchema.enum.splice(S,1),this.iconReferenceSchema.enumDescriptions.splice(S,1)),this._onDidChange.fire()}getIcons(){return Object.keys(this.iconsById).map(b=>this.iconsById[b])}getIcon(b){return this.iconsById[b]}getIconSchema(){return this.iconSchema}getIconReferenceSchema(){return this.iconReferenceSchema}registerIconFont(b,S){const A=this.iconFontsById[b];return A||(this.iconFontsById[b]=S,this._onDidChange.fire(),S)}deregisterIconFont(b){delete this.iconFontsById[b]}getIconFont(b){return this.iconFontsById[b]}toString(){const b=(r,n)=>r.id.localeCompare(n.id),S=r=>{for(;f.ThemeIcon.isThemeIcon(r.defaults);)r=this.iconsById[r.defaults.id];return`codicon codicon-${r?r.id:""}`},A=[];A.push("| preview     | identifier                        | default codicon ID                | description"),A.push("| ----------- | --------------------------------- | --------------------------------- | --------------------------------- |");const C=Object.keys(this.iconsById).map(r=>this.iconsById[r]);for(const r of C.filter(n=>!!n.description).sort(b))A.push(`|<i class="${S(r)}"></i>|${r.id}|${f.ThemeIcon.isThemeIcon(r.defaults)?r.defaults.id:r.id}|${r.description||""}|`);A.push("| preview     | identifier                        "),A.push("| ----------- | --------------------------------- |");for(const r of C.filter(n=>!f.ThemeIcon.isThemeIcon(n.defaults)).sort(b))A.push(`|<i class="${S(r)}"></i>|${r.id}|`);return A.join(`
`)}}const e=new s;d.Registry.add(t.Extensions.IconContribution,e);function p(c,b,S,A){return e.registerIcon(c,b,S,A)}t.registerIcon=p;function v(){return e}t.getIconRegistry=v;function D(){for(const c of i.Codicon.getAll())e.registerIcon(c.id,c.definition,c.description)}D(),t.iconsSchemaId="vscode://schemas/icons";const y=d.Registry.as(g.Extensions.JSONContribution);y.registerSchema(t.iconsSchemaId,e.getIconSchema());const o=new E.RunOnceScheduler(()=>y.notifySchemaChanged(t.iconsSchemaId),200);e.onDidChange(()=>{o.isScheduled()||o.schedule()}),t.widgetClose=p("widget-close",i.Codicon.close,(0,w.localize)(2,null)),t.gotoPreviousLocation=p("goto-previous-location",i.Codicon.arrowUp,(0,w.localize)(3,null)),t.gotoNextLocation=p("goto-next-location",i.Codicon.arrowDown,(0,w.localize)(4,null)),t.syncing=f.ThemeIcon.modify(i.Codicon.sync,"spin"),t.spinningLoading=f.ThemeIcon.modify(i.Codicon.loading,"spin")}),define(me[142],pe([1,0,4,3,141,64]),function(Z,t,E,i,M,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UnthemedProductIconTheme=t.getIconsStyleSheet=void 0;function _(g){const d=new i.Emitter,f=(0,M.getIconRegistry)();return f.onDidChange(()=>d.fire()),g?.onDidProductIconThemeChange(()=>d.fire()),{onDidChange:d.event,getCSS(){const F=g?g.getProductIconTheme():new w,l={},s=p=>{const v=F.getIcon(p);if(!v)return;const D=v.font;return D?(l[D.id]=D.definition,`.codicon-${p.id}:before { content: '${v.fontCharacter}'; font-family: ${(0,E.asCSSPropertyValue)(D.id)}; }`):`.codicon-${p.id}:before { content: '${v.fontCharacter}'; }`},e=[];for(const p of f.getIcons()){const v=s(p);v&&e.push(v)}for(const p in l){const v=l[p],D=v.weight?`font-weight: ${v.weight};`:"",y=v.style?`font-style: ${v.style};`:"",o=v.src.map(c=>`${(0,E.asCSSUrl)(c.location)} format('${c.format}')`).join(", ");e.push(`@font-face { src: ${o}; font-family: ${(0,E.asCSSPropertyValue)(p)};${D}${y} font-display: block; }`)}return e.join(`
`)}}}t.getIconsStyleSheet=_;class w{getIcon(d){const f=(0,M.getIconRegistry)();let F=d.defaults;for(;O.ThemeIcon.isThemeIcon(F);){const l=f.getIcon(F.id);if(!l)return;F=l.defaults}return F}}t.UnthemedProductIconTheme=w}),define(me[143],pe([1,0,5]),function(Z,t,E){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomLevelToZoomFactor=t.useWindowControlsOverlay=t.getTitleBarStyle=t.getMenuBarVisibility=t.isFileToOpen=t.isFolderToOpen=t.isWorkspaceToOpen=t.WindowMinimumSize=void 0,t.WindowMinimumSize={WIDTH:400,WIDTH_WITH_VERTICAL_PANEL:600,HEIGHT:270};function i(f){return!!f.workspaceUri}t.isWorkspaceToOpen=i;function M(f){return!!f.folderUri}t.isFolderToOpen=M;function O(f){return!!f.fileUri}t.isFileToOpen=O;function _(f){const F=w(f),l=f.getValue("window.menuBarVisibility");return l==="default"||F==="native"&&l==="compact"||E.isMacintosh&&E.isNative?"classic":l}t.getMenuBarVisibility=_;function w(f){if(E.isWeb)return"custom";const F=f.getValue("window");if(F){if(E.isMacintosh&&F.nativeTabs===!0||E.isMacintosh&&F.nativeFullScreen===!1)return"native";const e=f.getValue("workbench.colorCustomizations");if(e?.["window.activeBorder"]||e?.["window.inactiveBorder"])return"custom";const p=F.titleBarStyle;if(p==="native"||p==="custom")return p}return E.isLinux?"native":"custom"}t.getTitleBarStyle=w;function g(f,F){return!E.isWindows||E.isWeb||!F.isBuilt||w(f)==="native"?!1:f.getValue("window.experimental.windowControlsOverlay.enabled")}t.useWindowControlsOverlay=g;function d(f=0){return Math.pow(1.2,f)}t.zoomLevelToZoomFactor=d}),define(me[144],pe([1,0,15,29,143]),function(Z,t,E,i,M){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.zoomOut=t.zoomIn=t.applyZoom=void 0;function O(g){i.webFrame.setZoomLevel(g),(0,E.setZoomFactor)((0,M.zoomLevelToZoomFactor)(g)),(0,E.setZoomLevel)(g,!1)}t.applyZoom=O;function _(){O((0,E.getZoomLevel)()+1)}t.zoomIn=_;function w(){O((0,E.getZoomLevel)()-1)}t.zoomOut=w}),define(me[145],pe([1,0,9,4,128,8,129,29,134,135,136,138,142,144,94,85]),function(Z,t,E,i,M,O,_,w,g,d,f,F,l,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.startup=void 0;const e=/\s--(inspect|debug)(-brk|port)?=(\d+)?/,p=/\s--(inspect|debug)-port=(\d+)/;class v{getHeight(m){return 22}getTemplateId(m){return C(m)?"process":S(m)?"machine":(0,g.isRemoteDiagnosticError)(m)?"error":A(m)?"header":""}}class D{hasChildren(m){return(0,g.isRemoteDiagnosticError)(m)?!1:C(m)?!!m.children?.length:!0}getChildren(m){return C(m)?m.children?m.children:[]:(0,g.isRemoteDiagnosticError)(m)?[]:A(m)?m.processRoots.length>1?m.processRoots:[m.processRoots[0].rootProcess]:S(m)?[m.rootProcess]:[m.processes]}}class y{constructor(){this.templateId="header"}renderTemplate(m){const W=Object.create(null),V=(0,i.append)(m,(0,i.$)(".row"));return W.name=(0,i.append)(V,(0,i.$)(".nameLabel")),W.CPU=(0,i.append)(V,(0,i.$)(".cpu")),W.memory=(0,i.append)(V,(0,i.$)(".memory")),W.PID=(0,i.append)(V,(0,i.$)(".pid")),W}renderElement(m,W,V,ne){V.name.textContent=(0,E.localize)(0,null),V.CPU.textContent=(0,E.localize)(1,null),V.PID.textContent=(0,E.localize)(2,null),V.memory.textContent=(0,E.localize)(3,null)}disposeTemplate(m){}}class o{constructor(){this.templateId="machine"}renderTemplate(m){const W=Object.create(null),V=(0,i.append)(m,(0,i.$)(".row"));return W.name=(0,i.append)(V,(0,i.$)(".nameLabel")),W}renderElement(m,W,V,ne){V.name.textContent=m.element.name}disposeTemplate(m){}}class c{constructor(){this.templateId="error"}renderTemplate(m){const W=Object.create(null),V=(0,i.append)(m,(0,i.$)(".row"));return W.name=(0,i.append)(V,(0,i.$)(".nameLabel")),W}renderElement(m,W,V,ne){V.name.textContent=m.element.errorMessage}disposeTemplate(m){}}class b{constructor(m,W,V){this.platform=m,this.totalMem=W,this.mapPidToWindowTitle=V,this.templateId="process"}renderTemplate(m){const W=Object.create(null),V=(0,i.append)(m,(0,i.$)(".row"));return W.name=(0,i.append)(V,(0,i.$)(".nameLabel")),W.CPU=(0,i.append)(V,(0,i.$)(".cpu")),W.memory=(0,i.append)(V,(0,i.$)(".memory")),W.PID=(0,i.append)(V,(0,i.$)(".pid")),W}renderElement(m,W,V,ne){const{element:re}=m;let we=re.name;we==="window"&&(we=this.mapPidToWindowTitle.get(re.pid)!==void 0?`${we} (${this.mapPidToWindowTitle.get(re.pid)})`:we);const ae=re.pid.toFixed(0);V.name.textContent=we,V.name.title=re.cmd,V.CPU.textContent=re.load.toFixed(0),V.PID.textContent=ae,V.PID.parentElement.id=`pid-${ae}`;const ve=this.platform==="win32"?re.mem:this.totalMem*(re.mem/100);V.memory.textContent=(ve/d.ByteSize.MB).toFixed(0)}disposeTemplate(m){}}function S(u){return!!u.name&&!!u.rootProcess}function A(u){return!!u.processRoots}function C(u){return!!u.pid}class r{constructor(m,W){this.data=W,this.mapPidToWindowTitle=new Map;const V=new f.ElectronIPCMainProcessService(m);this.nativeHostService=new F.NativeHostService(m,V),this.applyStyles(W.styles),this.setEventHandlers(W),w.ipcRenderer.on("vscode:windowsInfoResponse",(ne,re)=>{this.mapPidToWindowTitle=new Map,re.forEach(we=>this.mapPidToWindowTitle.set(we.pid,we.title))}),w.ipcRenderer.on("vscode:listProcessesResponse",async(ne,re)=>{re.forEach((we,ae)=>{C(we.rootProcess)&&(we.rootProcess.name=ae===0?`${this.data.applicationName} main`:"remote agent")}),this.tree?this.tree.setInput({processes:{processRoots:re}}):await this.createProcessTree(re),this.requestProcessList(0)}),this.lastRequestTime=Date.now(),w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")}setEventHandlers(m){document.onkeydown=W=>{const V=m.platform==="darwin"?W.metaKey:W.ctrlKey;V&&W.keyCode===87&&(W.stopPropagation(),W.preventDefault(),w.ipcRenderer.send("vscode:closeProcessExplorer")),V&&W.keyCode===187&&(0,s.zoomIn)(),V&&W.keyCode===189&&(0,s.zoomOut)()}}async createProcessTree(m){const W=document.getElementById("process-list");if(!W)return;const{totalmem:V}=await this.nativeHostService.getOSStatistics(),ne=[new b(this.data.platform,V,this.mapPidToWindowTitle),new y,new o,new c];this.tree=new M.DataTree("processExplorer",W,new v,ne,new D,{identityProvider:{getId:re=>C(re)?re.pid.toString():(0,g.isRemoteDiagnosticError)(re)?re.hostName:A(re)?"processes":S(re)?re.name:"header"}}),this.tree.setInput({processes:{processRoots:m}}),this.tree.layout(window.innerHeight,window.innerWidth),this.tree.onContextMenu(re=>{C(re.element)&&this.showContextMenu(re.element,!0)})}isDebuggable(m){const W=e.exec(m);return W&&W.length>=2||m.indexOf("node ")>=0||m.indexOf("node.exe")>=0}attachTo(m){const W={type:"node",request:"attach",name:`process ${m.pid}`};let V=e.exec(m.cmd);V&&V.length>=2?(V.length===4&&V[3]&&(W.port=parseInt(V[3])),W.protocol=V[1]==="debug"?"legacy":"inspector"):W.processId=String(m.pid),V=p.exec(m.cmd),V&&V.length===3&&(W.port=parseInt(V[2])),w.ipcRenderer.send("vscode:workbenchCommand",{id:"debug.startFromConfig",from:"processExplorer",args:[W]})}applyStyles(m){const W=(0,i.createStyleSheet)(),V=[];m.listFocusBackground&&(V.push(`.monaco-list:focus .monaco-list-row.focused { background-color: ${m.listFocusBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.focused:hover { background-color: ${m.listFocusBackground}; }`)),m.listFocusForeground&&V.push(`.monaco-list:focus .monaco-list-row.focused { color: ${m.listFocusForeground}; }`),m.listActiveSelectionBackground&&(V.push(`.monaco-list:focus .monaco-list-row.selected { background-color: ${m.listActiveSelectionBackground}; }`),V.push(`.monaco-list:focus .monaco-list-row.selected:hover { background-color: ${m.listActiveSelectionBackground}; }`)),m.listActiveSelectionForeground&&V.push(`.monaco-list:focus .monaco-list-row.selected { color: ${m.listActiveSelectionForeground}; }`),m.listHoverBackground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { background-color: ${m.listHoverBackground}; }`),m.listHoverForeground&&V.push(`.monaco-list-row:hover:not(.selected):not(.focused) { color: ${m.listHoverForeground}; }`),m.listFocusOutline&&V.push(`.monaco-list:focus .monaco-list-row.focused { outline: 1px solid ${m.listFocusOutline}; outline-offset: -1px; }`),m.listHoverOutline&&V.push(`.monaco-list-row:hover { outline: 1px dashed ${m.listHoverOutline}; outline-offset: -1px; }`),W.textContent=V.join(`
`),m.color&&(document.body.style.color=m.color)}showContextMenu(m,W){const V=[],ne=Number(m.pid);W&&(V.push({label:(0,E.localize)(4,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGTERM")}}),V.push({label:(0,E.localize)(5,null),click:()=>{this.nativeHostService.killProcess(ne,"SIGKILL")}}),V.push({type:"separator"})),V.push({label:(0,E.localize)(6,null),click:()=>{const re=this.tree?.getSelection()?.map(ae=>{if(!(!ae||!("pid"in ae)))return ae.pid}).filter(ae=>!!ae);re?.includes(ne)||(re.length=0,re.push(ne));const we=re?.map(ae=>document.getElementById(`pid-${ae}`)).filter(ae=>!!ae);if(we){const ae=we.map(ve=>ve.innerText).filter(ve=>!!ve);this.nativeHostService.writeClipboardText(ae.join(`
`))}}}),V.push({label:(0,E.localize)(7,null),click:()=>{const re=document.getElementById("process-list");re&&this.nativeHostService.writeClipboardText(re.innerText)}}),m&&W&&this.isDebuggable(m.cmd)&&(V.push({type:"separator"}),V.push({label:(0,E.localize)(8,null),click:()=>{this.attachTo(m)}})),(0,_.popup)(V)}requestProcessList(m){setTimeout(()=>{const W=Date.now(),V=m+W-this.lastRequestTime;this.lastRequestTime=W,V>1e3?(w.ipcRenderer.send("vscode:windowsInfoRequest"),w.ipcRenderer.send("vscode:listProcesses")):this.requestProcessList(V)},200)}}function n(){const u=(0,i.createStyleSheet)();u.id="codiconStyles";const m=(0,l.getIconsStyleSheet)(void 0);function W(){u.textContent=m.getCSS()}const V=new O.RunOnceScheduler(W,0);m.onDidChange(()=>V.schedule()),V.schedule()}function a(u){const m=u.data.platform==="win32"?"windows":u.data.platform==="linux"?"linux":"mac";document.body.classList.add(m),n(),(0,s.applyZoom)(u.data.zoomLevel),new r(u.windowId,u.data)}t.startup=a})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/73fd3f11032e7b83c2ae011b5516e6ddd19e3db2/core/vs/code/electron-sandbox/processExplorer/processExplorerMain.js.map
