/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var Z=["require","exports","vs/base/common/lifecycle","vs/base/common/async","vs/base/common/event","vs/base/common/types","vs/nls","vs/nls!vs/code/node/cliProcessMain","vs/platform/instantiation/common/instantiation","vs/platform/log/common/log","vs/base/common/uri","vs/platform/files/common/files","vs/base/common/errors","vs/base/common/platform","vs/base/common/path","vs/base/common/buffer","vs/base/common/network","vs/base/common/resources","vs/platform/environment/common/environment","vs/base/common/arrays","vs/base/node/pfs","vs/platform/configuration/common/configuration","vs/platform/extensionManagement/common/extensionManagement","vs/platform/extensionManagement/common/extensionManagementUtil","vs/base/common/cancellation","vs/platform/userDataProfile/common/userDataProfile","vs/base/common/objects","vs/platform/product/common/productService","vs/platform/uriIdentity/common/uriIdentity","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/strings","vs/base/common/process","vs/platform/registry/common/platform","vs/platform/extensions/common/extensions","vs/platform/telemetry/common/telemetry","vs/base/common/map","vs/platform/policy/common/policy","os","vs/base/common/semver/semver","vs/platform/configuration/common/configurationRegistry","vs/platform/extensionManagement/common/extensionsProfileScannerService","vs/platform/telemetry/common/telemetryUtils","vs/base/common/stream","vs/base/common/marshalling","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/descriptors","vs/platform/request/common/request","vs/platform/extensionManagement/common/extensionsScannerService","vs/base/common/decorators","vs/base/common/json","vs/base/common/processes","vs/base/common/observableValue","vs/base/common/hash","vs/base/common/severity","vs/base/node/processes","vs/base/parts/ipc/common/ipc","child_process","vs/platform/download/common/download","vs/platform/files/common/io","vs/platform/files/common/watcher","vs/platform/instantiation/common/serviceCollection","vs/platform/languagePacks/common/languagePacks","vs/base/common/iterator","vs/platform/configuration/common/configurationModels","vs/platform/state/node/state","vs/platform/telemetry/common/commonProperties","vs/base/node/zip","vs/base/common/assert","vs/base/common/skipList","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/nls!vs/base/common/jsonErrorMessages","vs/base/common/jsonErrorMessages","vs/base/common/console","vs/base/node/powershell","vs/base/node/shell","vs/base/parts/ipc/node/ipc.cp","vs/base/parts/storage/common/storage","vs/nls!vs/base/node/zip","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensionManagement/common/extensionManagementCLIService","vs/nls!vs/platform/extensionManagement/common/extensionsScannerService","vs/nls!vs/platform/extensionManagement/node/extensionManagementService","vs/nls!vs/platform/extensionManagement/node/extensionManagementUtil","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/fileService","vs/nls!vs/platform/files/common/io","vs/nls!vs/platform/files/node/diskFileSystemProvider","vs/nls!vs/platform/languagePacks/common/languagePacks","vs/nls!vs/platform/request/common/request","vs/nls!vs/platform/shell/node/shellEnv","vs/nls!vs/platform/telemetry/common/telemetryService","vs/nls!vs/platform/userDataProfile/common/userDataProfile","vs/nls!vs/platform/workspace/common/workspace","vs/platform/environment/common/environmentService","vs/platform/environment/node/userDataPath","vs/platform/environment/node/environmentService","vs/platform/externalServices/common/serviceMachineId","vs/platform/instantiation/common/extensions","vs/platform/instantiation/common/graph","vs/platform/files/node/watcher/nodejs/nodejsWatcher","vs/platform/files/node/watcher/nodejs/nodejsClient","vs/platform/files/node/watcher/watcherClient","vs/platform/instantiation/common/instantiationService","vs/platform/files/common/diskFileSystemProvider","vs/platform/files/common/fileService","vs/base/common/performance","vs/platform/files/node/diskFileSystemProvider","fs","vs/platform/log/node/spdlogLog","vs/platform/policy/common/filePolicyService","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurations","vs/platform/configuration/common/configurationService","vs/platform/remote/common/remoteHosts","vs/platform/extensionManagement/common/extensionManagementCLIService","vs/platform/extensionManagement/node/extensionDownloader","vs/platform/extensionManagement/node/extensionsManifestCache","vs/platform/languagePacks/node/languagePacks","vs/platform/download/common/downloadService","vs/platform/request/node/proxy","url","vs/platform/shell/node/shellEnv","vs/platform/state/node/stateService","vs/platform/externalServices/common/marketplace","vs/platform/telemetry/common/1dsAppender","vs/platform/telemetry/common/telemetryService","vs/platform/product/common/product","vs/platform/telemetry/node/1dsAppender","vs/platform/telemetry/node/telemetry","vs/platform/extensionManagement/node/extensionsWatcher","vs/platform/uriIdentity/common/uriIdentityService","vs/platform/workspace/common/workspace","vs/platform/extensionManagement/common/abstractExtensionManagementService","vs/platform/extensionManagement/node/extensionLifecycle","vs/platform/extensionManagement/node/extensionsScannerService","vs/platform/storage/common/storage","vs/platform/extensionManagement/common/extensionGalleryService","vs/platform/userDataProfile/node/userDataProfile","vs/platform/policy/node/nativePolicyService","vs/platform/extensionManagement/node/extensionManagementUtil","vs/platform/extensionManagement/node/extensionManagementService","vs/platform/request/node/requestService","path","vs/base/common/glob","vs/platform/files/node/watcher/nodejs/nodejsWatcherLib","graceful-fs","vs/base/common/extpath","crypto","vs/platform/environment/node/argvHelper","https","vscode-policy-watcher","yauzl","yazl","zlib","vs/code/node/cliProcessMain"],ee=function($){for(var t=[],I=0,b=$.length;I<b;I++)t[I]=Z[$[I]];return t};define(Z[68],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.assertNever=t.ok=void 0;function I(w,O){if(!w)throw new Error(O?`Assertion failed (${O})`:"Assertion Failed")}t.ok=I;function b(w,O="Unreachable"){throw new Error(O)}t.assertNever=b}),define(Z[49],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.throttle=t.debounce=t.memoize=t.createDecorator=void 0;function I(A){return(p,c,d)=>{let C=null,P=null;if(typeof d.value=="function"?(C="value",P=d.value):typeof d.get=="function"&&(C="get",P=d.get),!P)throw new Error("not supported");d[C]=A(P,c)}}t.createDecorator=I;function b(A,p,c){let d=null,C=null;if(typeof c.value=="function"?(d="value",C=c.value,C.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof c.get=="function"&&(d="get",C=c.get),!C)throw new Error("not supported");const P=`$memoize$${p}`;c[d]=function(...h){return this.hasOwnProperty(P)||Object.defineProperty(this,P,{configurable:!1,enumerable:!1,writable:!1,value:C.apply(this,h)}),this[P]}}t.memoize=b;function w(A,p,c){return I((d,C)=>{const P=`$debounce$${C}`,h=`$debounce$result$${C}`;return function(...v){this[h]||(this[h]=c?c():void 0),clearTimeout(this[P]),p&&(this[h]=p(this[h],...v),v=[this[h]]),this[P]=setTimeout(()=>{d.apply(this,v),this[h]=c?c():void 0},A)}})}t.debounce=w;function O(A,p,c){return I((d,C)=>{const P=`$throttle$timer$${C}`,h=`$throttle$result$${C}`,v=`$throttle$lastRun$${C}`,f=`$throttle$pending$${C}`;return function(...m){if(this[h]||(this[h]=c?c():void 0),(this[v]===null||this[v]===void 0)&&(this[v]=-Number.MAX_VALUE),p&&(this[h]=p(this[h],...m)),this[f])return;const y=this[v]+A;y<=Date.now()?(this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0):(this[f]=!0,this[P]=setTimeout(()=>{this[f]=!1,this[v]=Date.now(),d.apply(this,[this[h]]),this[h]=c?c():void 0},y-Date.now()))}})}t.throttle=O}),define(Z[50],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getNodeType=t.stripComments=t.visit=t.findNodeAtOffset=t.contains=t.getNodeValue=t.getNodePath=t.findNodeAtLocation=t.parseTree=t.parse=t.getLocation=t.createScanner=t.ParseOptions=t.ParseErrorCode=t.SyntaxKind=t.ScanError=void 0;var I;(function(i){i[i.None=0]="None",i[i.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=2]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",i[i.InvalidUnicode=4]="InvalidUnicode",i[i.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",i[i.InvalidCharacter=6]="InvalidCharacter"})(I=t.ScanError||(t.ScanError={}));var b;(function(i){i[i.OpenBraceToken=1]="OpenBraceToken",i[i.CloseBraceToken=2]="CloseBraceToken",i[i.OpenBracketToken=3]="OpenBracketToken",i[i.CloseBracketToken=4]="CloseBracketToken",i[i.CommaToken=5]="CommaToken",i[i.ColonToken=6]="ColonToken",i[i.NullKeyword=7]="NullKeyword",i[i.TrueKeyword=8]="TrueKeyword",i[i.FalseKeyword=9]="FalseKeyword",i[i.StringLiteral=10]="StringLiteral",i[i.NumericLiteral=11]="NumericLiteral",i[i.LineCommentTrivia=12]="LineCommentTrivia",i[i.BlockCommentTrivia=13]="BlockCommentTrivia",i[i.LineBreakTrivia=14]="LineBreakTrivia",i[i.Trivia=15]="Trivia",i[i.Unknown=16]="Unknown",i[i.EOF=17]="EOF"})(b=t.SyntaxKind||(t.SyntaxKind={}));var w;(function(i){i[i.InvalidSymbol=1]="InvalidSymbol",i[i.InvalidNumberFormat=2]="InvalidNumberFormat",i[i.PropertyNameExpected=3]="PropertyNameExpected",i[i.ValueExpected=4]="ValueExpected",i[i.ColonExpected=5]="ColonExpected",i[i.CommaExpected=6]="CommaExpected",i[i.CloseBraceExpected=7]="CloseBraceExpected",i[i.CloseBracketExpected=8]="CloseBracketExpected",i[i.EndOfFileExpected=9]="EndOfFileExpected",i[i.InvalidCommentToken=10]="InvalidCommentToken",i[i.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",i[i.UnexpectedEndOfString=12]="UnexpectedEndOfString",i[i.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",i[i.InvalidUnicode=14]="InvalidUnicode",i[i.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",i[i.InvalidCharacter=16]="InvalidCharacter"})(w=t.ParseErrorCode||(t.ParseErrorCode={}));var O;(function(i){i.DEFAULT={allowTrailingComma:!0}})(O=t.ParseOptions||(t.ParseOptions={}));function A(i,n=!1){let e=0;const r=i.length;let o="",S=0,E=16,D=0;function k(re){let ge=0,ae=0;for(;ge<re;){const N=i.charCodeAt(e);if(N>=48&&N<=57)ae=ae*16+N-48;else if(N>=65&&N<=70)ae=ae*16+N-65+10;else if(N>=97&&N<=102)ae=ae*16+N-97+10;else break;e++,ge++}return ge<re&&(ae=-1),ae}function V(re){e=re,o="",S=0,E=16,D=0}function _(){const re=e;if(i.charCodeAt(e)===48)e++;else for(e++;e<i.length&&d(i.charCodeAt(e));)e++;if(e<i.length&&i.charCodeAt(e)===46)if(e++,e<i.length&&d(i.charCodeAt(e)))for(e++;e<i.length&&d(i.charCodeAt(e));)e++;else return D=3,i.substring(re,e);let ge=e;if(e<i.length&&(i.charCodeAt(e)===69||i.charCodeAt(e)===101))if(e++,(e<i.length&&i.charCodeAt(e)===43||i.charCodeAt(e)===45)&&e++,e<i.length&&d(i.charCodeAt(e))){for(e++;e<i.length&&d(i.charCodeAt(e));)e++;ge=e}else D=3;return i.substring(re,ge)}function G(){let re="",ge=e;for(;;){if(e>=r){re+=i.substring(ge,e),D=2;break}const ae=i.charCodeAt(e);if(ae===34){re+=i.substring(ge,e),e++;break}if(ae===92){if(re+=i.substring(ge,e),e++,e>=r){D=2;break}switch(i.charCodeAt(e++)){case 34:re+='"';break;case 92:re+="\\";break;case 47:re+="/";break;case 98:re+="\b";break;case 102:re+="\f";break;case 110:re+=`
`;break;case 114:re+="\r";break;case 116:re+="	";break;case 117:{const B=k(4);B>=0?re+=String.fromCharCode(B):D=4;break}default:D=5}ge=e;continue}if(ae>=0&&ae<=31)if(c(ae)){re+=i.substring(ge,e),D=2;break}else D=6;e++}return re}function Q(){if(o="",D=0,S=e,e>=r)return S=r,E=17;let re=i.charCodeAt(e);if(p(re)){do e++,o+=String.fromCharCode(re),re=i.charCodeAt(e);while(p(re));return E=15}if(c(re))return e++,o+=String.fromCharCode(re),re===13&&i.charCodeAt(e)===10&&(e++,o+=`
`),E=14;switch(re){case 123:return e++,E=1;case 125:return e++,E=2;case 91:return e++,E=3;case 93:return e++,E=4;case 58:return e++,E=6;case 44:return e++,E=5;case 34:return e++,o=G(),E=10;case 47:{const ge=e-1;if(i.charCodeAt(e+1)===47){for(e+=2;e<r&&!c(i.charCodeAt(e));)e++;return o=i.substring(ge,e),E=12}if(i.charCodeAt(e+1)===42){e+=2;const ae=r-1;let N=!1;for(;e<ae;){if(i.charCodeAt(e)===42&&i.charCodeAt(e+1)===47){e+=2,N=!0;break}e++}return N||(e++,D=1),o=i.substring(ge,e),E=13}return o+=String.fromCharCode(re),e++,E=16}case 45:if(o+=String.fromCharCode(re),e++,e===r||!d(i.charCodeAt(e)))return E=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return o+=_(),E=11;default:for(;e<r&&ne(re);)e++,re=i.charCodeAt(e);if(S!==e){switch(o=i.substring(S,e),o){case"true":return E=8;case"false":return E=9;case"null":return E=7}return E=16}return o+=String.fromCharCode(re),e++,E=16}}function ne(re){if(p(re)||c(re))return!1;switch(re){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function ce(){let re;do re=Q();while(re>=12&&re<=15);return re}return{setPosition:V,getPosition:()=>e,scan:n?ce:Q,getToken:()=>E,getTokenValue:()=>o,getTokenOffset:()=>S,getTokenLength:()=>e-S,getTokenError:()=>D}}t.createScanner=A;function p(i){return i===32||i===9||i===11||i===12||i===160||i===5760||i>=8192&&i<=8203||i===8239||i===8287||i===12288||i===65279}function c(i){return i===10||i===13||i===8232||i===8233}function d(i){return i>=48&&i<=57}var C;(function(i){i[i.nullCharacter=0]="nullCharacter",i[i.maxAsciiCharacter=127]="maxAsciiCharacter",i[i.lineFeed=10]="lineFeed",i[i.carriageReturn=13]="carriageReturn",i[i.lineSeparator=8232]="lineSeparator",i[i.paragraphSeparator=8233]="paragraphSeparator",i[i.nextLine=133]="nextLine",i[i.space=32]="space",i[i.nonBreakingSpace=160]="nonBreakingSpace",i[i.enQuad=8192]="enQuad",i[i.emQuad=8193]="emQuad",i[i.enSpace=8194]="enSpace",i[i.emSpace=8195]="emSpace",i[i.threePerEmSpace=8196]="threePerEmSpace",i[i.fourPerEmSpace=8197]="fourPerEmSpace",i[i.sixPerEmSpace=8198]="sixPerEmSpace",i[i.figureSpace=8199]="figureSpace",i[i.punctuationSpace=8200]="punctuationSpace",i[i.thinSpace=8201]="thinSpace",i[i.hairSpace=8202]="hairSpace",i[i.zeroWidthSpace=8203]="zeroWidthSpace",i[i.narrowNoBreakSpace=8239]="narrowNoBreakSpace",i[i.ideographicSpace=12288]="ideographicSpace",i[i.mathematicalSpace=8287]="mathematicalSpace",i[i.ogham=5760]="ogham",i[i._=95]="_",i[i.$=36]="$",i[i._0=48]="_0",i[i._1=49]="_1",i[i._2=50]="_2",i[i._3=51]="_3",i[i._4=52]="_4",i[i._5=53]="_5",i[i._6=54]="_6",i[i._7=55]="_7",i[i._8=56]="_8",i[i._9=57]="_9",i[i.a=97]="a",i[i.b=98]="b",i[i.c=99]="c",i[i.d=100]="d",i[i.e=101]="e",i[i.f=102]="f",i[i.g=103]="g",i[i.h=104]="h",i[i.i=105]="i",i[i.j=106]="j",i[i.k=107]="k",i[i.l=108]="l",i[i.m=109]="m",i[i.n=110]="n",i[i.o=111]="o",i[i.p=112]="p",i[i.q=113]="q",i[i.r=114]="r",i[i.s=115]="s",i[i.t=116]="t",i[i.u=117]="u",i[i.v=118]="v",i[i.w=119]="w",i[i.x=120]="x",i[i.y=121]="y",i[i.z=122]="z",i[i.A=65]="A",i[i.B=66]="B",i[i.C=67]="C",i[i.D=68]="D",i[i.E=69]="E",i[i.F=70]="F",i[i.G=71]="G",i[i.H=72]="H",i[i.I=73]="I",i[i.J=74]="J",i[i.K=75]="K",i[i.L=76]="L",i[i.M=77]="M",i[i.N=78]="N",i[i.O=79]="O",i[i.P=80]="P",i[i.Q=81]="Q",i[i.R=82]="R",i[i.S=83]="S",i[i.T=84]="T",i[i.U=85]="U",i[i.V=86]="V",i[i.W=87]="W",i[i.X=88]="X",i[i.Y=89]="Y",i[i.Z=90]="Z",i[i.ampersand=38]="ampersand",i[i.asterisk=42]="asterisk",i[i.at=64]="at",i[i.backslash=92]="backslash",i[i.bar=124]="bar",i[i.caret=94]="caret",i[i.closeBrace=125]="closeBrace",i[i.closeBracket=93]="closeBracket",i[i.closeParen=41]="closeParen",i[i.colon=58]="colon",i[i.comma=44]="comma",i[i.dot=46]="dot",i[i.doubleQuote=34]="doubleQuote",i[i.equals=61]="equals",i[i.exclamation=33]="exclamation",i[i.greaterThan=62]="greaterThan",i[i.lessThan=60]="lessThan",i[i.minus=45]="minus",i[i.openBrace=123]="openBrace",i[i.openBracket=91]="openBracket",i[i.openParen=40]="openParen",i[i.percent=37]="percent",i[i.plus=43]="plus",i[i.question=63]="question",i[i.semicolon=59]="semicolon",i[i.singleQuote=39]="singleQuote",i[i.slash=47]="slash",i[i.tilde=126]="tilde",i[i.backspace=8]="backspace",i[i.formFeed=12]="formFeed",i[i.byteOrderMark=65279]="byteOrderMark",i[i.tab=9]="tab",i[i.verticalTab=11]="verticalTab"})(C||(C={}));function P(i,n){const e=[],r=new Object;let o;const S={value:{},offset:0,length:0,type:"object",parent:void 0};let E=!1;function D(k,V,_,G){S.value=k,S.offset=V,S.length=_,S.type=G,S.colonOffset=void 0,o=S}try{g(i,{onObjectBegin:(k,V)=>{if(n<=k)throw r;o=void 0,E=n>k,e.push("")},onObjectProperty:(k,V,_)=>{if(n<V||(D(k,V,_,"property"),e[e.length-1]=k,n<=V+_))throw r},onObjectEnd:(k,V)=>{if(n<=k)throw r;o=void 0,e.pop()},onArrayBegin:(k,V)=>{if(n<=k)throw r;o=void 0,e.push(0)},onArrayEnd:(k,V)=>{if(n<=k)throw r;o=void 0,e.pop()},onLiteralValue:(k,V,_)=>{if(n<V||(D(k,V,_,s(k)),n<=V+_))throw r},onSeparator:(k,V,_)=>{if(n<=V)throw r;if(k===":"&&o&&o.type==="property")o.colonOffset=V,E=!1,o=void 0;else if(k===","){const G=e[e.length-1];typeof G=="number"?e[e.length-1]=G+1:(E=!0,e[e.length-1]=""),o=void 0}}})}catch(k){if(k!==r)throw k}return{path:e,previousNode:o,isAtPropertyKey:E,matches:k=>{let V=0;for(let _=0;V<k.length&&_<e.length;_++)if(k[V]===e[_]||k[V]==="*")V++;else if(k[V]!=="**")return!1;return V===k.length}}}t.getLocation=P;function h(i,n=[],e=O.DEFAULT){let r=null,o=[];const S=[];function E(k){Array.isArray(o)?o.push(k):r!==null&&(o[r]=k)}return g(i,{onObjectBegin:()=>{const k={};E(k),S.push(o),o=k,r=null},onObjectProperty:k=>{r=k},onObjectEnd:()=>{o=S.pop()},onArrayBegin:()=>{const k=[];E(k),S.push(o),o=k,r=null},onArrayEnd:()=>{o=S.pop()},onLiteralValue:E,onError:(k,V,_)=>{n.push({error:k,offset:V,length:_})}},e),o[0]}t.parse=h;function v(i,n=[],e=O.DEFAULT){let r={type:"array",offset:-1,length:-1,children:[],parent:void 0};function o(k){r.type==="property"&&(r.length=k-r.offset,r=r.parent)}function S(k){return r.children.push(k),k}g(i,{onObjectBegin:k=>{r=S({type:"object",offset:k,length:-1,parent:r,children:[]})},onObjectProperty:(k,V,_)=>{r=S({type:"property",offset:V,length:-1,parent:r,children:[]}),r.children.push({type:"string",value:k,offset:V,length:_,parent:r})},onObjectEnd:(k,V)=>{r.length=k+V-r.offset,r=r.parent,o(k+V)},onArrayBegin:(k,V)=>{r=S({type:"array",offset:k,length:-1,parent:r,children:[]})},onArrayEnd:(k,V)=>{r.length=k+V-r.offset,r=r.parent,o(k+V)},onLiteralValue:(k,V,_)=>{S({type:s(k),offset:V,length:_,parent:r,value:k}),o(V+_)},onSeparator:(k,V,_)=>{r.type==="property"&&(k===":"?r.colonOffset=V:k===","&&o(V))},onError:(k,V,_)=>{n.push({error:k,offset:V,length:_})}},e);const D=r.children[0];return D&&delete D.parent,D}t.parseTree=v;function f(i,n){if(!i)return;let e=i;for(const r of n)if(typeof r=="string"){if(e.type!=="object"||!Array.isArray(e.children))return;let o=!1;for(const S of e.children)if(Array.isArray(S.children)&&S.children[0].value===r){e=S.children[1],o=!0;break}if(!o)return}else{const o=r;if(e.type!=="array"||o<0||!Array.isArray(e.children)||o>=e.children.length)return;e=e.children[o]}return e}t.findNodeAtLocation=f;function m(i){if(!i.parent||!i.parent.children)return[];const n=m(i.parent);if(i.parent.type==="property"){const e=i.parent.children[0].value;n.push(e)}else if(i.parent.type==="array"){const e=i.parent.children.indexOf(i);e!==-1&&n.push(e)}return n}t.getNodePath=m;function y(i){switch(i.type){case"array":return i.children.map(y);case"object":{const n=Object.create(null);for(const e of i.children){const r=e.children[1];r&&(n[e.children[0].value]=y(r))}return n}case"null":case"string":case"number":case"boolean":return i.value;default:return}}t.getNodeValue=y;function l(i,n,e=!1){return n>=i.offset&&n<i.offset+i.length||e&&n===i.offset+i.length}t.contains=l;function u(i,n,e=!1){if(l(i,n,e)){const r=i.children;if(Array.isArray(r))for(let o=0;o<r.length&&r[o].offset<=n;o++){const S=u(r[o],n,e);if(S)return S}return i}}t.findNodeAtOffset=u;function g(i,n,e=O.DEFAULT){const r=A(i,!1);function o(T){return T?()=>T(r.getTokenOffset(),r.getTokenLength()):()=>!0}function S(T){return T?x=>T(x,r.getTokenOffset(),r.getTokenLength()):()=>!0}const E=o(n.onObjectBegin),D=S(n.onObjectProperty),k=o(n.onObjectEnd),V=o(n.onArrayBegin),_=o(n.onArrayEnd),G=S(n.onLiteralValue),Q=S(n.onSeparator),ne=o(n.onComment),ce=S(n.onError),re=e&&e.disallowComments,ge=e&&e.allowTrailingComma;function ae(){for(;;){const T=r.scan();switch(r.getTokenError()){case 4:N(14);break;case 5:N(15);break;case 3:N(13);break;case 1:re||N(11);break;case 2:N(12);break;case 6:N(16);break}switch(T){case 12:case 13:re?N(10):ne();break;case 16:N(1);break;case 15:case 14:break;default:return T}}}function N(T,x=[],R=[]){if(ce(T),x.length+R.length>0){let L=r.getToken();for(;L!==17;){if(x.indexOf(L)!==-1){ae();break}else if(R.indexOf(L)!==-1)break;L=ae()}}}function B(T){const x=r.getTokenValue();return T?G(x):D(x),ae(),!0}function M(){switch(r.getToken()){case 11:{let T=0;try{T=JSON.parse(r.getTokenValue()),typeof T!="number"&&(N(2),T=0)}catch{N(2)}G(T);break}case 7:G(null);break;case 8:G(!0);break;case 9:G(!1);break;default:return!1}return ae(),!0}function F(){return r.getToken()!==10?(N(3,[],[2,5]),!1):(B(!1),r.getToken()===6?(Q(":"),ae(),Y()||N(4,[],[2,5])):N(5,[],[2,5]),!0)}function W(){E(),ae();let T=!1;for(;r.getToken()!==2&&r.getToken()!==17;){if(r.getToken()===5){if(T||N(4,[],[]),Q(","),ae(),r.getToken()===2&&ge)break}else T&&N(6,[],[]);F()||N(4,[],[2,5]),T=!0}return k(),r.getToken()!==2?N(7,[2],[]):ae(),!0}function q(){V(),ae();let T=!1;for(;r.getToken()!==4&&r.getToken()!==17;){if(r.getToken()===5){if(T||N(4,[],[]),Q(","),ae(),r.getToken()===4&&ge)break}else T&&N(6,[],[]);Y()||N(4,[],[4,5]),T=!0}return _(),r.getToken()!==4?N(8,[4],[]):ae(),!0}function Y(){switch(r.getToken()){case 3:return q();case 1:return W();case 10:return B(!0);default:return M()}}return ae(),r.getToken()===17?e.allowEmptyContent?!0:(N(4,[],[]),!1):Y()?(r.getToken()!==17&&N(9,[],[]),!0):(N(4,[],[]),!1)}t.visit=g;function a(i,n){const e=A(i),r=[];let o,S=0,E;do switch(E=e.getPosition(),o=e.scan(),o){case 12:case 13:case 17:S!==E&&r.push(i.substring(S,E)),n!==void 0&&r.push(e.getTokenValue().replace(/[^\r\n]/g,n)),S=e.getPosition();break}while(o!==17);return r.join("")}t.stripComments=a;function s(i){switch(typeof i){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(i){if(Array.isArray(i))return"array"}else return"null";return"object"}default:return"null"}}t.getNodeType=s}),function(){function $(w){const O=[];typeof w=="number"&&O.push("code/timeOrigin",w);function A(c){O.push(c,Date.now())}function p(){const c=[];for(let d=0;d<O.length;d+=2)c.push({name:O[d],startTime:O[d+1]});return c}return{mark:A,getMarks:p}}function t(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?$():{mark(w){performance.mark(w)},getMarks(){let w=performance.timeOrigin;typeof w!="number"&&(w=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const O=[{name:"code/timeOrigin",startTime:Math.round(w)}];for(const A of performance.getEntriesByType("mark"))O.push({name:A.name,startTime:Math.round(w+A.startTime)});return O}};if(typeof process=="object"){const w=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return $(w)}else return console.trace("perf-util loaded in UNKNOWN environment"),$()}function I(w){return w.MonacoPerformanceMarks||(w.MonacoPerformanceMarks=t()),w.MonacoPerformanceMarks}var b;typeof global=="object"?b=global:typeof self=="object"?b=self:b={},typeof define=="function"?define("vs/base/common/performance",[],function(){return I(b)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=I(b):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),b.perf=I(b))}(),function($,t){if(typeof exports=="object"&&typeof module=="object")module.exports=t();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],t);else{var I=t();for(var b in I)(typeof exports=="object"?exports:$)[b]=I[b]}}(typeof self!="undefined"?self:this,function(){return function($){var t={};function I(b){if(t[b])return t[b].exports;var w=t[b]={i:b,l:!1,exports:{}};return $[b].call(w.exports,w,w.exports,I),w.l=!0,w.exports}return I.m=$,I.c=t,I.d=function(b,w,O){I.o(b,w)||Object.defineProperty(b,w,{enumerable:!0,get:O})},I.r=function(b){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(b,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(b,"__esModule",{value:!0})},I.t=function(b,w){if(1&w&&(b=I(b)),8&w||4&w&&typeof b=="object"&&b&&b.__esModule)return b;var O=Object.create(null);if(I.r(O),Object.defineProperty(O,"default",{enumerable:!0,value:b}),2&w&&typeof b!="string")for(var A in b)I.d(O,A,function(p){return b[p]}.bind(null,A));return O},I.n=function(b){var w=b&&b.__esModule?function(){return b.default}:function(){return b};return I.d(w,"a",w),w},I.o=function(b,w){return Object.prototype.hasOwnProperty.call(b,w)},I.p="",I(I.s=0)}([function($,t,I){(function(b){var w;t=$.exports=R,w=typeof b=="object"&&b.env&&b.env.NODE_DEBUG&&/\bsemver\b/i.test(b.env.NODE_DEBUG)?function(){var z=Array.prototype.slice.call(arguments,0);z.unshift("SEMVER"),console.log.apply(console,z)}:function(){},t.SEMVER_SPEC_VERSION="2.0.0";var O=256,A=Number.MAX_SAFE_INTEGER||9007199254740991,p=t.re=[],c=t.src=[],d=0,C=d++;c[C]="0|[1-9]\\d*";var P=d++;c[P]="[0-9]+";var h=d++;c[h]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var v=d++;c[v]="("+c[C]+")\\.("+c[C]+")\\.("+c[C]+")";var f=d++;c[f]="("+c[P]+")\\.("+c[P]+")\\.("+c[P]+")";var m=d++;c[m]="(?:"+c[C]+"|"+c[h]+")";var y=d++;c[y]="(?:"+c[P]+"|"+c[h]+")";var l=d++;c[l]="(?:-("+c[m]+"(?:\\."+c[m]+")*))";var u=d++;c[u]="(?:-?("+c[y]+"(?:\\."+c[y]+")*))";var g=d++;c[g]="[0-9A-Za-z-]+";var a=d++;c[a]="(?:\\+("+c[g]+"(?:\\."+c[g]+")*))";var s=d++,i="v?"+c[v]+c[l]+"?"+c[a]+"?";c[s]="^"+i+"$";var n="[v=\\s]*"+c[f]+c[u]+"?"+c[a]+"?",e=d++;c[e]="^"+n+"$";var r=d++;c[r]="((?:<|>)?=?)";var o=d++;c[o]=c[P]+"|x|X|\\*";var S=d++;c[S]=c[C]+"|x|X|\\*";var E=d++;c[E]="[v=\\s]*("+c[S]+")(?:\\.("+c[S]+")(?:\\.("+c[S]+")(?:"+c[l]+")?"+c[a]+"?)?)?";var D=d++;c[D]="[v=\\s]*("+c[o]+")(?:\\.("+c[o]+")(?:\\.("+c[o]+")(?:"+c[u]+")?"+c[a]+"?)?)?";var k=d++;c[k]="^"+c[r]+"\\s*"+c[E]+"$";var V=d++;c[V]="^"+c[r]+"\\s*"+c[D]+"$";var _=d++;c[_]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var G=d++;c[G]="(?:~>?)";var Q=d++;c[Q]="(\\s*)"+c[G]+"\\s+",p[Q]=new RegExp(c[Q],"g");var ne=d++;c[ne]="^"+c[G]+c[E]+"$";var ce=d++;c[ce]="^"+c[G]+c[D]+"$";var re=d++;c[re]="(?:\\^)";var ge=d++;c[ge]="(\\s*)"+c[re]+"\\s+",p[ge]=new RegExp(c[ge],"g");var ae=d++;c[ae]="^"+c[re]+c[E]+"$";var N=d++;c[N]="^"+c[re]+c[D]+"$";var B=d++;c[B]="^"+c[r]+"\\s*("+n+")$|^$";var M=d++;c[M]="^"+c[r]+"\\s*("+i+")$|^$";var F=d++;c[F]="(\\s*)"+c[r]+"\\s*("+n+"|"+c[E]+")",p[F]=new RegExp(c[F],"g");var W=d++;c[W]="^\\s*("+c[E]+")\\s+-\\s+("+c[E]+")\\s*$";var q=d++;c[q]="^\\s*("+c[D]+")\\s+-\\s+("+c[D]+")\\s*$";var Y=d++;c[Y]="(<|>)?=?\\s*\\*";for(var T=0;T<35;T++)w(T,c[T]),p[T]||(p[T]=new RegExp(c[T]));function x(z,K){if(z instanceof R)return z;if(typeof z!="string"||z.length>O||!(K?p[e]:p[s]).test(z))return null;try{return new R(z,K)}catch{return null}}function R(z,K){if(z instanceof R){if(z.loose===K)return z;z=z.version}else if(typeof z!="string")throw new TypeError("Invalid Version: "+z);if(z.length>O)throw new TypeError("version is longer than "+O+" characters");if(!(this instanceof R))return new R(z,K);w("SemVer",z,K),this.loose=K;var J=z.trim().match(K?p[e]:p[s]);if(!J)throw new TypeError("Invalid Version: "+z);if(this.raw=z,this.major=+J[1],this.minor=+J[2],this.patch=+J[3],this.major>A||this.major<0)throw new TypeError("Invalid major version");if(this.minor>A||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>A||this.patch<0)throw new TypeError("Invalid patch version");J[4]?this.prerelease=J[4].split(".").map(function(ue){if(/^[0-9]+$/.test(ue)){var me=+ue;if(me>=0&&me<A)return me}return ue}):this.prerelease=[],this.build=J[5]?J[5].split("."):[],this.format()}t.parse=x,t.valid=function(z,K){var J=x(z,K);return J?J.version:null},t.clean=function(z,K){var J=x(z.trim().replace(/^[=v]+/,""),K);return J?J.version:null},t.SemVer=R,R.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},R.prototype.toString=function(){return this.version},R.prototype.compare=function(z){return w("SemVer.compare",this.version,this.loose,z),z instanceof R||(z=new R(z,this.loose)),this.compareMain(z)||this.comparePre(z)},R.prototype.compareMain=function(z){return z instanceof R||(z=new R(z,this.loose)),U(this.major,z.major)||U(this.minor,z.minor)||U(this.patch,z.patch)},R.prototype.comparePre=function(z){if(z instanceof R||(z=new R(z,this.loose)),this.prerelease.length&&!z.prerelease.length)return-1;if(!this.prerelease.length&&z.prerelease.length)return 1;if(!this.prerelease.length&&!z.prerelease.length)return 0;var K=0;do{var J=this.prerelease[K],ue=z.prerelease[K];if(w("prerelease compare",K,J,ue),J===void 0&&ue===void 0)return 0;if(ue===void 0)return 1;if(J===void 0)return-1;if(J!==ue)return U(J,ue)}while(++K)},R.prototype.inc=function(z,K){switch(z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",K);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",K);break;case"prepatch":this.prerelease.length=0,this.inc("patch",K),this.inc("pre",K);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",K),this.inc("pre",K);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var J=this.prerelease.length;--J>=0;)typeof this.prerelease[J]=="number"&&(this.prerelease[J]++,J=-2);J===-1&&this.prerelease.push(0)}K&&(this.prerelease[0]===K?isNaN(this.prerelease[1])&&(this.prerelease=[K,0]):this.prerelease=[K,0]);break;default:throw new Error("invalid increment argument: "+z)}return this.format(),this.raw=this.version,this},t.inc=function(z,K,J,ue){typeof J=="string"&&(ue=J,J=void 0);try{return new R(z,J).inc(K,ue).version}catch{return null}},t.diff=function(z,K){if(oe(z,K))return null;var J=x(z),ue=x(K);if(J.prerelease.length||ue.prerelease.length){for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return"pre"+me;return"prerelease"}for(var me in J)if((me==="major"||me==="minor"||me==="patch")&&J[me]!==ue[me])return me},t.compareIdentifiers=U;var L=/^[0-9]+$/;function U(z,K){var J=L.test(z),ue=L.test(K);return J&&ue&&(z=+z,K=+K),J&&!ue?-1:ue&&!J?1:z<K?-1:z>K?1:0}function j(z,K,J){return new R(z,J).compare(new R(K,J))}function H(z,K,J){return j(z,K,J)>0}function X(z,K,J){return j(z,K,J)<0}function oe(z,K,J){return j(z,K,J)===0}function le(z,K,J){return j(z,K,J)!==0}function pe(z,K,J){return j(z,K,J)>=0}function ve(z,K,J){return j(z,K,J)<=0}function ie(z,K,J,ue){var me;switch(K){case"===":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z===J;break;case"!==":typeof z=="object"&&(z=z.version),typeof J=="object"&&(J=J.version),me=z!==J;break;case"":case"=":case"==":me=oe(z,J,ue);break;case"!=":me=le(z,J,ue);break;case">":me=H(z,J,ue);break;case">=":me=pe(z,J,ue);break;case"<":me=X(z,J,ue);break;case"<=":me=ve(z,J,ue);break;default:throw new TypeError("Invalid operator: "+K)}return me}function se(z,K){if(z instanceof se){if(z.loose===K)return z;z=z.value}if(!(this instanceof se))return new se(z,K);w("comparator",z,K),this.loose=K,this.parse(z),this.semver===he?this.value="":this.value=this.operator+this.semver.version,w("comp",this)}t.rcompareIdentifiers=function(z,K){return U(K,z)},t.major=function(z,K){return new R(z,K).major},t.minor=function(z,K){return new R(z,K).minor},t.patch=function(z,K){return new R(z,K).patch},t.compare=j,t.compareLoose=function(z,K){return j(z,K,!0)},t.rcompare=function(z,K,J){return j(K,z,J)},t.sort=function(z,K){return z.sort(function(J,ue){return t.compare(J,ue,K)})},t.rsort=function(z,K){return z.sort(function(J,ue){return t.rcompare(J,ue,K)})},t.gt=H,t.lt=X,t.eq=oe,t.neq=le,t.gte=pe,t.lte=ve,t.cmp=ie,t.Comparator=se;var he={};function de(z,K){if(z instanceof de)return z.loose===K?z:new de(z.raw,K);if(z instanceof se)return new de(z.value,K);if(!(this instanceof de))return new de(z,K);if(this.loose=K,this.raw=z,this.set=z.split(/\s*\|\|\s*/).map(function(J){return this.parseRange(J.trim())},this).filter(function(J){return J.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+z);this.format()}function Se(z){return!z||z.toLowerCase()==="x"||z==="*"}function ke(z,K,J,ue,me,Ce,we,Te,be,De,Me,Re,Oe){return((K=Se(J)?"":Se(ue)?">="+J+".0.0":Se(me)?">="+J+"."+ue+".0":">="+K)+" "+(Te=Se(be)?"":Se(De)?"<"+(+be+1)+".0.0":Se(Me)?"<"+be+"."+(+De+1)+".0":Re?"<="+be+"."+De+"."+Me+"-"+Re:"<="+Te)).trim()}function Fe(z,K){for(var J=0;J<z.length;J++)if(!z[J].test(K))return!1;if(K.prerelease.length){for(J=0;J<z.length;J++)if(w(z[J].semver),z[J].semver!==he&&z[J].semver.prerelease.length>0){var ue=z[J].semver;if(ue.major===K.major&&ue.minor===K.minor&&ue.patch===K.patch)return!0}return!1}return!0}function Ue(z,K,J){try{K=new de(K,J)}catch{return!1}return K.test(z)}function xe(z,K,J,ue){var me,Ce,we,Te,be;switch(z=new R(z,ue),K=new de(K,ue),J){case">":me=H,Ce=ve,we=X,Te=">",be=">=";break;case"<":me=X,Ce=pe,we=H,Te="<",be="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(Ue(z,K,ue))return!1;for(var De=0;De<K.set.length;++De){var Me=K.set[De],Re=null,Oe=null;if(Me.forEach(function(Ae){Ae.semver===he&&(Ae=new se(">=0.0.0")),Re=Re||Ae,Oe=Oe||Ae,me(Ae.semver,Re.semver,ue)?Re=Ae:we(Ae.semver,Oe.semver,ue)&&(Oe=Ae)}),Re.operator===Te||Re.operator===be||(!Oe.operator||Oe.operator===Te)&&Ce(z,Oe.semver)||Oe.operator===be&&we(z,Oe.semver))return!1}return!0}se.prototype.parse=function(z){var K=this.loose?p[B]:p[M],J=z.match(K);if(!J)throw new TypeError("Invalid comparator: "+z);this.operator=J[1],this.operator==="="&&(this.operator=""),J[2]?this.semver=new R(J[2],this.loose):this.semver=he},se.prototype.toString=function(){return this.value},se.prototype.test=function(z){return w("Comparator.test",z,this.loose),this.semver===he||(typeof z=="string"&&(z=new R(z,this.loose)),ie(z,this.operator,this.semver,this.loose))},se.prototype.intersects=function(z,K){if(!(z instanceof se))throw new TypeError("a Comparator is required");var J;if(this.operator==="")return J=new de(z.value,K),Ue(this.value,J,K);if(z.operator==="")return J=new de(this.value,K),Ue(z.semver,J,K);var ue=!(this.operator!==">="&&this.operator!==">"||z.operator!==">="&&z.operator!==">"),me=!(this.operator!=="<="&&this.operator!=="<"||z.operator!=="<="&&z.operator!=="<"),Ce=this.semver.version===z.semver.version,we=!(this.operator!==">="&&this.operator!=="<="||z.operator!==">="&&z.operator!=="<="),Te=ie(this.semver,"<",z.semver,K)&&(this.operator===">="||this.operator===">")&&(z.operator==="<="||z.operator==="<"),be=ie(this.semver,">",z.semver,K)&&(this.operator==="<="||this.operator==="<")&&(z.operator===">="||z.operator===">");return ue||me||Ce&&we||Te||be},t.Range=de,de.prototype.format=function(){return this.range=this.set.map(function(z){return z.join(" ").trim()}).join("||").trim(),this.range},de.prototype.toString=function(){return this.range},de.prototype.parseRange=function(z){var K=this.loose;z=z.trim(),w("range",z,K);var J=K?p[q]:p[W];z=z.replace(J,ke),w("hyphen replace",z),z=z.replace(p[F],"$1$2$3"),w("comparator trim",z,p[F]),z=(z=(z=z.replace(p[Q],"$1~")).replace(p[ge],"$1^")).split(/\s+/).join(" ");var ue=K?p[B]:p[M],me=z.split(" ").map(function(Ce){return function(we,Te){return w("comp",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){w("caret",Re,Oe);var Ae=Oe?p[N]:p[ae];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Le;return w("caret",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?Le="":Se(Ee)?Le=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?Le=ye==="0"?">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+".0 <"+(+ye+1)+".0.0":Ie?(w("replaceCaret pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+Ie+" <"+(+ye+1)+".0.0"):(w("no pr"),Le=ye==="0"?Ee==="0"?">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+Ee+"."+(+Pe+1):">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0":">="+ye+"."+Ee+"."+Pe+" <"+(+ye+1)+".0.0"),w("caret return",Le),Le})}(Me,De)}).join(" ")}(we,Te),w("caret",we),we=function(be,De){return be.trim().split(/\s+/).map(function(Me){return function(Re,Oe){var Ae=Oe?p[ce]:p[ne];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie){var Le;return w("tilde",Re,Ne,ye,Ee,Pe,Ie),Se(ye)?Le="":Se(Ee)?Le=">="+ye+".0.0 <"+(+ye+1)+".0.0":Se(Pe)?Le=">="+ye+"."+Ee+".0 <"+ye+"."+(+Ee+1)+".0":Ie?(w("replaceTilde pr",Ie),Ie.charAt(0)!=="-"&&(Ie="-"+Ie),Le=">="+ye+"."+Ee+"."+Pe+Ie+" <"+ye+"."+(+Ee+1)+".0"):Le=">="+ye+"."+Ee+"."+Pe+" <"+ye+"."+(+Ee+1)+".0",w("tilde return",Le),Le})}(Me,De)}).join(" ")}(we,Te),w("tildes",we),we=function(be,De){return w("replaceXRanges",be,De),be.split(/\s+/).map(function(Me){return function(Re,Oe){Re=Re.trim();var Ae=Oe?p[V]:p[k];return Re.replace(Ae,function(Ne,ye,Ee,Pe,Ie,Le){w("xRange",Re,Ne,ye,Ee,Pe,Ie,Le);var We=Se(Ee),ze=We||Se(Pe),Ve=ze||Se(Ie);return ye==="="&&Ve&&(ye=""),We?Ne=ye===">"||ye==="<"?"<0.0.0":"*":ye&&Ve?(ze&&(Pe=0),Ve&&(Ie=0),ye===">"?(ye=">=",ze?(Ee=+Ee+1,Pe=0,Ie=0):Ve&&(Pe=+Pe+1,Ie=0)):ye==="<="&&(ye="<",ze?Ee=+Ee+1:Pe=+Pe+1),Ne=ye+Ee+"."+Pe+"."+Ie):ze?Ne=">="+Ee+".0.0 <"+(+Ee+1)+".0.0":Ve&&(Ne=">="+Ee+"."+Pe+".0 <"+Ee+"."+(+Pe+1)+".0"),w("xRange return",Ne),Ne})}(Me,De)}).join(" ")}(we,Te),w("xrange",we),we=function(be,De){return w("replaceStars",be,De),be.trim().replace(p[Y],"")}(we,Te),w("stars",we),we}(Ce,K)}).join(" ").split(/\s+/);return this.loose&&(me=me.filter(function(Ce){return!!Ce.match(ue)})),me=me.map(function(Ce){return new se(Ce,K)})},de.prototype.intersects=function(z,K){if(!(z instanceof de))throw new TypeError("a Range is required");return this.set.some(function(J){return J.every(function(ue){return z.set.some(function(me){return me.every(function(Ce){return ue.intersects(Ce,K)})})})})},t.toComparators=function(z,K){return new de(z,K).set.map(function(J){return J.map(function(ue){return ue.value}).join(" ").trim().split(" ")})},de.prototype.test=function(z){if(!z)return!1;typeof z=="string"&&(z=new R(z,this.loose));for(var K=0;K<this.set.length;K++)if(Fe(this.set[K],z))return!0;return!1},t.satisfies=Ue,t.maxSatisfying=function(z,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return z.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==-1||(me=new R(ue=we,J)))}),ue},t.minSatisfying=function(z,K,J){var ue=null,me=null;try{var Ce=new de(K,J)}catch{return null}return z.forEach(function(we){Ce.test(we)&&(ue&&me.compare(we)!==1||(me=new R(ue=we,J)))}),ue},t.validRange=function(z,K){try{return new de(z,K).range||"*"}catch{return null}},t.ltr=function(z,K,J){return xe(z,K,"<",J)},t.gtr=function(z,K,J){return xe(z,K,">",J)},t.outside=xe,t.prerelease=function(z,K){var J=x(z,K);return J&&J.prerelease.length?J.prerelease:null},t.intersects=function(z,K,J){return z=new de(z,J),K=new de(K,J),z.intersects(K)},t.coerce=function(z){if(z instanceof R)return z;if(typeof z!="string")return null;var K=z.match(p[_]);return K==null?null:x((K[1]||"0")+"."+(K[2]||"0")+"."+(K[3]||"0"))}}).call(this,I(1))},function($,t){var I,b,w=$.exports={};function O(){throw new Error("setTimeout has not been defined")}function A(){throw new Error("clearTimeout has not been defined")}function p(y){if(I===setTimeout)return setTimeout(y,0);if((I===O||!I)&&setTimeout)return I=setTimeout,setTimeout(y,0);try{return I(y,0)}catch{try{return I.call(null,y,0)}catch{return I.call(this,y,0)}}}(function(){try{I=typeof setTimeout=="function"?setTimeout:O}catch{I=O}try{b=typeof clearTimeout=="function"?clearTimeout:A}catch{b=A}})();var c,d=[],C=!1,P=-1;function h(){C&&c&&(C=!1,c.length?d=c.concat(d):P=-1,d.length&&v())}function v(){if(!C){var y=p(h);C=!0;for(var l=d.length;l;){for(c=d,d=[];++P<l;)c&&c[P].run();P=-1,l=d.length}c=null,C=!1,function(u){if(b===clearTimeout)return clearTimeout(u);if((b===A||!b)&&clearTimeout)return b=clearTimeout,clearTimeout(u);try{b(u)}catch{try{return b.call(null,u)}catch{return b.call(this,u)}}}(y)}}function f(y,l){this.fun=y,this.array=l}function m(){}w.nextTick=function(y){var l=new Array(arguments.length-1);if(arguments.length>1)for(var u=1;u<arguments.length;u++)l[u-1]=arguments[u];d.push(new f(y,l)),d.length!==1||C||p(v)},f.prototype.run=function(){this.fun.apply(null,this.array)},w.title="browser",w.browser=!0,w.env={},w.argv=[],w.version="",w.versions={},w.on=m,w.addListener=m,w.once=m,w.off=m,w.removeListener=m,w.removeAllListeners=m,w.emit=m,w.prependListener=m,w.prependOnceListener=m,w.listeners=function(y){return[]},w.binding=function(y){throw new Error("process.binding is not supported")},w.cwd=function(){return"/"},w.chdir=function(y){throw new Error("process.chdir is not supported")},w.umask=function(){return 0}}])}),define(Z[69],ee([0,1]),function($,t){"use strict";var I;Object.defineProperty(t,"__esModule",{value:!0}),t.SkipList=void 0;class b{constructor(p,c,d){this.level=p,this.key=c,this.value=d,this.forward=[]}}const w=void 0;class O{constructor(p,c=2**16){this.comparator=p,this[I]="SkipList",this._level=0,this._size=0,this._maxLevel=Math.max(1,Math.log2(c)|0),this._header=new b(this._maxLevel,w,w)}get size(){return this._size}clear(){this._header=new b(this._maxLevel,w,w)}has(p){return Boolean(O._search(this,p,this.comparator))}get(p){return O._search(this,p,this.comparator)?.value}set(p,c){return O._insert(this,p,c,this.comparator)&&(this._size+=1),this}delete(p){const c=O._delete(this,p,this.comparator);return c&&(this._size-=1),c}forEach(p,c){let d=this._header.forward[0];for(;d;)p.call(c,d.value,d.key,this),d=d.forward[0]}[(I=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}*entries(){let p=this._header.forward[0];for(;p;)yield[p.key,p.value],p=p.forward[0]}*keys(){let p=this._header.forward[0];for(;p;)yield p.key,p=p.forward[0]}*values(){let p=this._header.forward[0];for(;p;)yield p.value,p=p.forward[0]}toString(){let p="[SkipList]:",c=this._header.forward[0];for(;c;)p+=`node(${c.key}, ${c.value}, lvl:${c.level})`,c=c.forward[0];return p}static _search(p,c,d){let C=p._header;for(let P=p._level-1;P>=0;P--)for(;C.forward[P]&&d(C.forward[P].key,c)<0;)C=C.forward[P];if(C=C.forward[0],C&&d(C.key,c)===0)return C}static _insert(p,c,d,C){const P=[];let h=p._header;for(let v=p._level-1;v>=0;v--){for(;h.forward[v]&&C(h.forward[v].key,c)<0;)h=h.forward[v];P[v]=h}if(h=h.forward[0],h&&C(h.key,c)===0)return h.value=d,!1;{const v=O._randomLevel(p);if(v>p._level){for(let f=p._level;f<v;f++)P[f]=p._header;p._level=v}h=new b(v,c,d);for(let f=0;f<v;f++)h.forward[f]=P[f].forward[f],P[f].forward[f]=h;return!0}}static _randomLevel(p,c=.5){let d=1;for(;Math.random()<c&&d<p._maxLevel;)d+=1;return d}static _delete(p,c,d){const C=[];let P=p._header;for(let h=p._level-1;h>=0;h--){for(;P.forward[h]&&d(P.forward[h].key,c)<0;)P=P.forward[h];C[h]=P}if(P=P.forward[0],!P||d(P.key,c)!==0)return!1;for(let h=0;h<p._level&&C[h].forward[h]===P;h++)C[h].forward[h]=P.forward[h];for(;p._level>0&&p._header.forward[p._level-1]===w;)p._level-=1;return!0}}t.SkipList=O}),define(Z[43],ee([0,1,12,2]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.prefixedStream=t.prefixedReadable=t.transform=t.toReadable=t.emptyStream=t.toStream=t.peekStream=t.listenStream=t.consumeStream=t.peekReadable=t.consumeReadable=t.newWriteableStream=t.isReadableBufferedStream=t.isReadableStream=t.isReadable=void 0;function w(a){const s=a;return s?typeof s.read=="function":!1}t.isReadable=w;function O(a){const s=a;return s?[s.on,s.pause,s.resume,s.destroy].every(i=>typeof i=="function"):!1}t.isReadableStream=O;function A(a){const s=a;return s?O(s.stream)&&Array.isArray(s.buffer)&&typeof s.ended=="boolean":!1}t.isReadableBufferedStream=A;function p(a,s){return new c(a,s)}t.newWriteableStream=p;class c{constructor(s,i){this.reducer=s,this.options=i,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(s){if(!this.state.destroyed){if(this.state.flowing)this.emitData(s);else if(this.buffer.data.push(s),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(i=>this.pendingWritePromises.push(i))}}error(s){this.state.destroyed||(this.state.flowing?this.emitError(s):this.buffer.error.push(s))}end(s){this.state.destroyed||(typeof s!="undefined"&&this.write(s),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(s){this.listeners.data.slice(0).forEach(i=>i(s))}emitError(s){this.listeners.error.length===0?(0,I.onUnexpectedError)(s):this.listeners.error.slice(0).forEach(i=>i(s))}emitEnd(){this.listeners.end.slice(0).forEach(s=>s())}on(s,i){if(!this.state.destroyed)switch(s){case"data":this.listeners.data.push(i),this.resume();break;case"end":this.listeners.end.push(i),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(i),this.state.flowing&&this.flowErrors();break}}removeListener(s,i){if(this.state.destroyed)return;let n;switch(s){case"data":n=this.listeners.data;break;case"end":n=this.listeners.end;break;case"error":n=this.listeners.error;break}if(n){const e=n.indexOf(i);e>=0&&n.splice(e,1)}}flowData(){if(this.buffer.data.length>0){const s=this.reducer(this.buffer.data);this.emitData(s),this.buffer.data.length=0;const i=[...this.pendingWritePromises];this.pendingWritePromises.length=0,i.forEach(n=>n())}}flowErrors(){if(this.listeners.error.length>0){for(const s of this.buffer.error)this.emitError(s);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function d(a,s){const i=[];let n;for(;(n=a.read())!==null;)i.push(n);return s(i)}t.consumeReadable=d;function C(a,s,i){const n=[];let e;for(;(e=a.read())!==null&&n.length<i;)n.push(e);return e===null&&n.length>0?s(n):{read:()=>{if(n.length>0)return n.shift();if(typeof e!="undefined"){const r=e;return e=void 0,r}return a.read()}}}t.peekReadable=C;function P(a,s){return new Promise((i,n)=>{const e=[];h(a,{onData:r=>{s&&e.push(r)},onError:r=>{s?n(r):i(void 0)},onEnd:()=>{i(s?s(e):void 0)}})})}t.consumeStream=P;function h(a,s){let i=!1;return a.on("error",n=>{i||s.onError(n)}),a.on("end",()=>{i||s.onEnd()}),a.on("data",n=>{i||s.onData(n)}),(0,b.toDisposable)(()=>i=!0)}t.listenStream=h;function v(a,s){return new Promise((i,n)=>{const e=new b.DisposableStore,r=[],o=D=>{if(r.push(D),r.length>s)return e.dispose(),a.pause(),i({stream:a,buffer:r,ended:!1})},S=D=>n(D),E=()=>i({stream:a,buffer:r,ended:!0});e.add((0,b.toDisposable)(()=>a.removeListener("error",S))),a.on("error",S),e.add((0,b.toDisposable)(()=>a.removeListener("end",E))),a.on("end",E),e.add((0,b.toDisposable)(()=>a.removeListener("data",o))),a.on("data",o)})}t.peekStream=v;function f(a,s){const i=p(s);return i.end(a),i}t.toStream=f;function m(){const a=p(()=>{throw new Error("not supported")});return a.end(),a}t.emptyStream=m;function y(a){let s=!1;return{read:()=>s?null:(s=!0,a)}}t.toReadable=y;function l(a,s,i){const n=p(i);return h(a,{onData:e=>n.write(s.data(e)),onError:e=>n.error(s.error?s.error(e):e),onEnd:()=>n.end()}),n}t.transform=l;function u(a,s,i){let n=!1;return{read:()=>{const e=s.read();return n?e:(n=!0,e!==null?i([a,e]):a)}}}t.prefixedReadable=u;function g(a,s,i){let n=!1;const e=p(i);return h(s,{onData:r=>n?e.write(r):(n=!0,e.write(i([a,r]))),onError:r=>e.error(r),onEnd:()=>{n||(n=!0,e.write(a)),e.end()}}),e}t.prefixedStream=g}),define(Z[15],ee([0,1,43]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.encodeBase64=t.decodeBase64=t.prefixedBufferStream=t.prefixedBufferReadable=t.newWriteableBufferStream=t.streamToBufferReadableStream=t.bufferToStream=t.bufferedStreamToBuffer=t.streamToBuffer=t.bufferToReadable=t.readableToBuffer=t.writeUInt8=t.readUInt8=t.writeUInt32LE=t.readUInt32LE=t.writeUInt32BE=t.readUInt32BE=t.writeUInt16LE=t.readUInt16LE=t.VSBuffer=void 0;const b=typeof Buffer!="undefined";let w,O;class A{constructor(D){this.buffer=D,this.byteLength=this.buffer.byteLength}static alloc(D){return b?new A(Buffer.allocUnsafe(D)):new A(new Uint8Array(D))}static wrap(D){return b&&!Buffer.isBuffer(D)&&(D=Buffer.from(D.buffer,D.byteOffset,D.byteLength)),new A(D)}static fromString(D,k){return!(k?.dontUseNodeBuffer||!1)&&b?new A(Buffer.from(D)):(w||(w=new TextEncoder),new A(w.encode(D)))}static fromByteArray(D){const k=A.alloc(D.length);for(let V=0,_=D.length;V<_;V++)k.buffer[V]=D[V];return k}static concat(D,k){if(typeof k=="undefined"){k=0;for(let G=0,Q=D.length;G<Q;G++)k+=D[G].byteLength}const V=A.alloc(k);let _=0;for(let G=0,Q=D.length;G<Q;G++){const ne=D[G];V.set(ne,_),_+=ne.byteLength}return V}clone(){const D=A.alloc(this.byteLength);return D.set(this),D}toString(){return b?this.buffer.toString():(O||(O=new TextDecoder),O.decode(this.buffer))}slice(D,k){return new A(this.buffer.subarray(D,k))}set(D,k){if(D instanceof A)this.buffer.set(D.buffer,k);else if(D instanceof Uint8Array)this.buffer.set(D,k);else if(D instanceof ArrayBuffer)this.buffer.set(new Uint8Array(D),k);else if(ArrayBuffer.isView(D))this.buffer.set(new Uint8Array(D.buffer,D.byteOffset,D.byteLength),k);else throw new Error("Unknown argument 'array'")}readUInt32BE(D){return d(this.buffer,D)}writeUInt32BE(D,k){C(this.buffer,D,k)}readUInt32LE(D){return P(this.buffer,D)}writeUInt32LE(D,k){h(this.buffer,D,k)}readUInt8(D){return v(this.buffer,D)}writeUInt8(D,k){f(this.buffer,D,k)}}t.VSBuffer=A;function p(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0}t.readUInt16LE=p;function c(E,D,k){E[k+0]=D&255,D=D>>>8,E[k+1]=D&255}t.writeUInt16LE=c;function d(E,D){return E[D]*2**24+E[D+1]*2**16+E[D+2]*2**8+E[D+3]}t.readUInt32BE=d;function C(E,D,k){E[k+3]=D,D=D>>>8,E[k+2]=D,D=D>>>8,E[k+1]=D,D=D>>>8,E[k]=D}t.writeUInt32BE=C;function P(E,D){return E[D+0]<<0>>>0|E[D+1]<<8>>>0|E[D+2]<<16>>>0|E[D+3]<<24>>>0}t.readUInt32LE=P;function h(E,D,k){E[k+0]=D&255,D=D>>>8,E[k+1]=D&255,D=D>>>8,E[k+2]=D&255,D=D>>>8,E[k+3]=D&255}t.writeUInt32LE=h;function v(E,D){return E[D]}t.readUInt8=v;function f(E,D,k){E[k]=D}t.writeUInt8=f;function m(E){return I.consumeReadable(E,D=>A.concat(D))}t.readableToBuffer=m;function y(E){return I.toReadable(E)}t.bufferToReadable=y;function l(E){return I.consumeStream(E,D=>A.concat(D))}t.streamToBuffer=l;async function u(E){return E.ended?A.concat(E.buffer):A.concat([...E.buffer,await l(E.stream)])}t.bufferedStreamToBuffer=u;function g(E){return I.toStream(E,D=>A.concat(D))}t.bufferToStream=g;function a(E){return I.transform(E,{data:D=>typeof D=="string"?A.fromString(D):A.wrap(D)},D=>A.concat(D))}t.streamToBufferReadableStream=a;function s(E){return I.newWriteableStream(D=>A.concat(D),E)}t.newWriteableBufferStream=s;function i(E,D){return I.prefixedReadable(E,D,k=>A.concat(k))}t.prefixedBufferReadable=i;function n(E,D){return I.prefixedStream(E,D,k=>A.concat(k))}t.prefixedBufferStream=n;function e(E){let D=0,k=0,V=0;const _=new Uint8Array(Math.floor(E.length/4*3)),G=ne=>{switch(k){case 3:_[V++]=D|ne,k=0;break;case 2:_[V++]=D|ne>>>2,D=ne<<6,k=3;break;case 1:_[V++]=D|ne>>>4,D=ne<<4,k=2;break;default:D=ne<<2,k=1}};for(let ne=0;ne<E.length;ne++){const ce=E.charCodeAt(ne);if(ce>=65&&ce<=90)G(ce-65);else if(ce>=97&&ce<=122)G(ce-97+26);else if(ce>=48&&ce<=57)G(ce-48+52);else if(ce===43||ce===45)G(62);else if(ce===47||ce===95)G(63);else{if(ce===61)break;throw new SyntaxError(`Unexpected base64 character ${E[ne]}`)}}const Q=V;for(;k>0;)G(0);return A.wrap(_).slice(0,Q)}t.decodeBase64=e;const r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",o="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function S({buffer:E},D=!0,k=!1){const V=k?o:r;let _="";const G=E.byteLength%3;let Q=0;for(;Q<E.byteLength-G;Q+=3){const ne=E[Q+0],ce=E[Q+1],re=E[Q+2];_+=V[ne>>>2],_+=V[(ne<<4|ce>>>4)&63],_+=V[(ce<<2|re>>>6)&63],_+=V[re&63]}if(G===1){const ne=E[Q+0];_+=V[ne>>>2],_+=V[ne<<4&63],D&&(_+="==")}else if(G===2){const ne=E[Q+0],ce=E[Q+1];_+=V[ne>>>2],_+=V[(ne<<4|ce>>>4)&63],_+=V[ce<<2&63],D&&(_+="=")}return _}t.encodeBase64=S}),define(Z[26],ee([0,1,5]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createProxyObject=t.getAllMethodNames=t.getAllPropertyNames=t.filter=t.getCaseInsensitive=t.distinct=t.safeStringify=t.equals=t.mixin=t.cloneAndChange=t.deepFreeze=t.deepClone=void 0;function b(l){if(!l||typeof l!="object"||l instanceof RegExp)return l;const u=Array.isArray(l)?[]:{};return Object.keys(l).forEach(g=>{l[g]&&typeof l[g]=="object"?u[g]=b(l[g]):u[g]=l[g]}),u}t.deepClone=b;function w(l){if(!l||typeof l!="object")return l;const u=[l];for(;u.length>0;){const g=u.shift();Object.freeze(g);for(const a in g)if(O.call(g,a)){const s=g[a];typeof s=="object"&&!Object.isFrozen(s)&&!(0,I.isTypedArray)(s)&&u.push(s)}}return l}t.deepFreeze=w;const O=Object.prototype.hasOwnProperty;function A(l,u){return p(l,u,new Set)}t.cloneAndChange=A;function p(l,u,g){if((0,I.isUndefinedOrNull)(l))return l;const a=u(l);if(typeof a!="undefined")return a;if(Array.isArray(l)){const s=[];for(const i of l)s.push(p(i,u,g));return s}if((0,I.isObject)(l)){if(g.has(l))throw new Error("Cannot clone recursive data-structure");g.add(l);const s={};for(const i in l)O.call(l,i)&&(s[i]=p(l[i],u,g));return g.delete(l),s}return l}function c(l,u,g=!0){return(0,I.isObject)(l)?((0,I.isObject)(u)&&Object.keys(u).forEach(a=>{a in l?g&&((0,I.isObject)(l[a])&&(0,I.isObject)(u[a])?c(l[a],u[a],g):l[a]=u[a]):l[a]=u[a]}),l):u}t.mixin=c;function d(l,u){if(l===u)return!0;if(l==null||u===null||u===void 0||typeof l!=typeof u||typeof l!="object"||Array.isArray(l)!==Array.isArray(u))return!1;let g,a;if(Array.isArray(l)){if(l.length!==u.length)return!1;for(g=0;g<l.length;g++)if(!d(l[g],u[g]))return!1}else{const s=[];for(a in l)s.push(a);s.sort();const i=[];for(a in u)i.push(a);if(i.sort(),!d(s,i))return!1;for(g=0;g<s.length;g++)if(!d(l[s[g]],u[s[g]]))return!1}return!0}t.equals=d;function C(l){const u=new Set;return JSON.stringify(l,(g,a)=>{if((0,I.isObject)(a)||Array.isArray(a)){if(u.has(a))return"[Circular]";u.add(a)}return a})}t.safeStringify=C;function P(l,u){const g=Object.create(null);return!l||!u||Object.keys(u).forEach(s=>{const i=l[s],n=u[s];d(i,n)||(g[s]=n)}),g}t.distinct=P;function h(l,u){const g=u.toLowerCase(),a=Object.keys(l).find(s=>s.toLowerCase()===g);return a?l[a]:l[u]}t.getCaseInsensitive=h;function v(l,u){const g=Object.create(null);for(const[a,s]of Object.entries(l))u(a,s)&&(g[a]=s);return g}t.filter=v;function f(l){let u=[],g=Object.getPrototypeOf(l);for(;Object.prototype!==g;)u=u.concat(Object.getOwnPropertyNames(g)),g=Object.getPrototypeOf(g);return u}t.getAllPropertyNames=f;function m(l){const u=[];for(const g of f(l))typeof l[g]=="function"&&u.push(g);return u}t.getAllMethodNames=m;function y(l,u){const g=s=>function(){const i=Array.prototype.slice.call(arguments,0);return u(s,i)},a={};for(const s of l)a[s]=g(s);return a}t.createProxyObject=y}),define(Z[29],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.generateUuid=t.isUUID=void 0;const I=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function b(w){return I.test(w)}t.isUUID=b,t.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let w;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?w=crypto.getRandomValues.bind(crypto):w=function(p){for(let c=0;c<p.length;c++)p[c]=Math.floor(Math.random()*256);return p};const O=new Uint8Array(16),A=[];for(let p=0;p<256;p++)A.push(p.toString(16).padStart(2,"0"));return function(){w(O),O[6]=O[6]&15|64,O[8]=O[8]&63|128;let c=0,d="";return d+=A[O[c++]],d+=A[O[c++]],d+=A[O[c++]],d+=A[O[c++]],d+="-",d+=A[O[c++]],d+=A[O[c++]],d+="-",d+=A[O[c++]],d+=A[O[c++]],d+="-",d+=A[O[c++]],d+=A[O[c++]],d+="-",d+=A[O[c++]],d+=A[O[c++]],d+=A[O[c++]],d+=A[O[c++]],d+=A[O[c++]],d+=A[O[c++]],d}}()}),define(Z[70],ee([6,7]),function($,t){return $.create("vs/base/common/date",t)}),define(Z[71],ee([0,1,70]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.toLocalISOString=t.fromNow=void 0;const b=60,w=b*60,O=w*24,A=O*7,p=O*30,c=O*365;function d(P,h,v){typeof P!="number"&&(P=P.getTime());const f=Math.round((new Date().getTime()-P)/1e3);if(f<-30)return(0,I.localize)(0,null,d(new Date().getTime()+f*1e3,!1));if(f<30)return(0,I.localize)(1,null);let m;return f<b?(m=f,h?m===1?v?(0,I.localize)(2,null,m):(0,I.localize)(3,null,m):v?(0,I.localize)(4,null,m):(0,I.localize)(5,null,m):m===1?v?(0,I.localize)(6,null,m):(0,I.localize)(7,null,m):v?(0,I.localize)(8,null,m):(0,I.localize)(9,null,m)):f<w?(m=Math.floor(f/b),h?m===1?v?(0,I.localize)(10,null,m):(0,I.localize)(11,null,m):v?(0,I.localize)(12,null,m):(0,I.localize)(13,null,m):m===1?v?(0,I.localize)(14,null,m):(0,I.localize)(15,null,m):v?(0,I.localize)(16,null,m):(0,I.localize)(17,null,m)):f<O?(m=Math.floor(f/w),h?m===1?v?(0,I.localize)(18,null,m):(0,I.localize)(19,null,m):v?(0,I.localize)(20,null,m):(0,I.localize)(21,null,m):m===1?v?(0,I.localize)(22,null,m):(0,I.localize)(23,null,m):v?(0,I.localize)(24,null,m):(0,I.localize)(25,null,m)):f<A?(m=Math.floor(f/O),h?m===1?(0,I.localize)(26,null,m):(0,I.localize)(27,null,m):m===1?(0,I.localize)(28,null,m):(0,I.localize)(29,null,m)):f<p?(m=Math.floor(f/A),h?m===1?v?(0,I.localize)(30,null,m):(0,I.localize)(31,null,m):v?(0,I.localize)(32,null,m):(0,I.localize)(33,null,m):m===1?v?(0,I.localize)(34,null,m):(0,I.localize)(35,null,m):v?(0,I.localize)(36,null,m):(0,I.localize)(37,null,m)):f<c?(m=Math.floor(f/p),h?m===1?v?(0,I.localize)(38,null,m):(0,I.localize)(39,null,m):v?(0,I.localize)(40,null,m):(0,I.localize)(41,null,m):m===1?v?(0,I.localize)(42,null,m):(0,I.localize)(43,null,m):v?(0,I.localize)(44,null,m):(0,I.localize)(45,null,m)):(m=Math.floor(f/c),h?m===1?v?(0,I.localize)(46,null,m):(0,I.localize)(47,null,m):v?(0,I.localize)(48,null,m):(0,I.localize)(49,null,m):m===1?v?(0,I.localize)(50,null,m):(0,I.localize)(51,null,m):v?(0,I.localize)(52,null,m):(0,I.localize)(53,null,m))}t.fromNow=d;function C(P){return P.getFullYear()+"-"+String(P.getMonth()+1).padStart(2,"0")+"-"+String(P.getDate()).padStart(2,"0")+"T"+String(P.getHours()).padStart(2,"0")+":"+String(P.getMinutes()).padStart(2,"0")+":"+String(P.getSeconds()).padStart(2,"0")+"."+(P.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}t.toLocalISOString=C}),define(Z[72],ee([6,7]),function($,t){return $.create("vs/base/common/errorMessage",t)}),define(Z[30],ee([0,1,19,5,72]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.createErrorWithActions=t.isErrorWithActions=t.toErrorMessage=void 0;function O(P,h){return h&&(P.stack||P.stacktrace)?w.localize(0,null,p(P),A(P.stack)||A(P.stacktrace)):p(P)}function A(P){return Array.isArray(P)?P.join(`
`):P}function p(P){return typeof P.code=="string"&&typeof P.errno=="number"&&typeof P.syscall=="string"?w.localize(1,null,P.message):P.message||w.localize(2,null)}function c(P=null,h=!1){if(!P)return w.localize(3,null);if(Array.isArray(P)){const v=I.coalesce(P),f=c(v[0],h);return v.length>1?w.localize(4,null,f,v.length):f}if(b.isString(P))return P;if(P.detail){const v=P.detail;if(v.error)return O(v.error,h);if(v.exception)return O(v.exception,h)}return P.stack?O(P,h):P.message?P.message:w.localize(5,null)}t.toErrorMessage=c;function d(P){const h=P;return h instanceof Error&&Array.isArray(h.actions)}t.isErrorWithActions=d;function C(P,h){let v;return typeof P=="string"?v=new Error(P):v=P,v.actions=h,v}t.createErrorWithActions=C}),define(Z[73],ee([6,7]),function($,t){return $.create("vs/base/common/jsonErrorMessages",t)}),define(Z[74],ee([0,1,73]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getParseErrorMessage=void 0;function b(w){switch(w){case 1:return(0,I.localize)(0,null);case 2:return(0,I.localize)(1,null);case 3:return(0,I.localize)(2,null);case 4:return(0,I.localize)(3,null);case 5:return(0,I.localize)(4,null);case 6:return(0,I.localize)(5,null);case 7:return(0,I.localize)(6,null);case 8:return(0,I.localize)(7,null);case 9:return(0,I.localize)(8,null);default:return""}}t.getParseErrorMessage=b}),define(Z[51],ee([0,1,13]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.removeDangerousEnvVariables=t.sanitizeProcessEnvironment=t.TerminateResponseCode=t.Source=void 0;var b;(function(p){p[p.stdout=0]="stdout",p[p.stderr=1]="stderr"})(b=t.Source||(t.Source={}));var w;(function(p){p[p.Success=0]="Success",p[p.Unknown=1]="Unknown",p[p.AccessDenied=2]="AccessDenied",p[p.ProcessNotFound=3]="ProcessNotFound"})(w=t.TerminateResponseCode||(t.TerminateResponseCode={}));function O(p,...c){const d=c.reduce((h,v)=>(h[v]=!0,h),{}),C=[/^ELECTRON_.+$/,/^VSCODE_(?!SHELL_LOGIN).+$/,/^SNAP(|_.*)$/,/^GDK_PIXBUF_.+$/];Object.keys(p).filter(h=>!d[h]).forEach(h=>{for(let v=0;v<C.length;v++)if(h.search(C[v])!==-1){delete p[h];break}})}t.sanitizeProcessEnvironment=O;function A(p){!p||(delete p.DEBUG,I.isMacintosh&&delete p.DYLD_LIBRARY_PATH,I.isLinux&&delete p.LD_PRELOAD)}t.removeDangerousEnvVariables=A}),define(Z[52],ee([0,1,4,2]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.MutableObservableValue=t.staticObservableValue=void 0;const w=A=>({onDidChange:I.Event.None,value:A});t.staticObservableValue=w;class O extends b.Disposable{constructor(p){super();this._value=p,this.changeEmitter=this._register(new I.Emitter),this.onDidChange=this.changeEmitter.event}get value(){return this._value}set value(p){p!==this._value&&(this._value=p,this.changeEmitter.fire(p))}}t.MutableObservableValue=O}),define(Z[53],ee([0,1,31]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StringSHA1=t.toHexString=t.Hasher=t.stringHash=t.numberHash=t.doHash=t.hash=void 0;function b(l){return w(l,0)}t.hash=b;function w(l,u){switch(typeof l){case"object":return l===null?O(349,u):Array.isArray(l)?c(l,u):d(l,u);case"string":return p(l,u);case"boolean":return A(l,u);case"number":return O(l,u);case"undefined":return O(937,u);default:return O(617,u)}}t.doHash=w;function O(l,u){return(u<<5)-u+l|0}t.numberHash=O;function A(l,u){return O(l?433:863,u)}function p(l,u){u=O(149417,u);for(let g=0,a=l.length;g<a;g++)u=O(l.charCodeAt(g),u);return u}t.stringHash=p;function c(l,u){return u=O(104579,u),l.reduce((g,a)=>w(a,g),u)}function d(l,u){return u=O(181387,u),Object.keys(l).sort().reduce((g,a)=>(g=p(a,g),w(l[a],g)),u)}class C{constructor(){this._value=0}get value(){return this._value}hash(u){return this._value=w(u,this._value),this._value}}t.Hasher=C;var P;(function(l){l[l.BLOCK_SIZE=64]="BLOCK_SIZE",l[l.UNICODE_REPLACEMENT=65533]="UNICODE_REPLACEMENT"})(P||(P={}));function h(l,u,g=32){const a=g-u,s=~((1<<a)-1);return(l<<u|(s&l)>>>a)>>>0}function v(l,u=0,g=l.byteLength,a=0){for(let s=0;s<g;s++)l[u+s]=a}function f(l,u,g="0"){for(;l.length<u;)l=g+l;return l}function m(l,u=32){return l instanceof ArrayBuffer?Array.from(new Uint8Array(l)).map(g=>g.toString(16).padStart(2,"0")).join(""):f((l>>>0).toString(16),u/4)}t.toHexString=m;class y{constructor(){this._h0=1732584193,this._h1=4023233417,this._h2=2562383102,this._h3=271733878,this._h4=3285377520,this._buff=new Uint8Array(64+3),this._buffDV=new DataView(this._buff.buffer),this._buffLen=0,this._totalLen=0,this._leftoverHighSurrogate=0,this._finished=!1}update(u){const g=u.length;if(g===0)return;const a=this._buff;let s=this._buffLen,i=this._leftoverHighSurrogate,n,e;for(i!==0?(n=i,e=-1,i=0):(n=u.charCodeAt(0),e=0);;){let r=n;if(I.isHighSurrogate(n))if(e+1<g){const o=u.charCodeAt(e+1);I.isLowSurrogate(o)?(e++,r=I.computeCodePoint(n,o)):r=65533}else{i=n;break}else I.isLowSurrogate(n)&&(r=65533);if(s=this._push(a,s,r),e++,e<g)n=u.charCodeAt(e);else break}this._buffLen=s,this._leftoverHighSurrogate=i}_push(u,g,a){return a<128?u[g++]=a:a<2048?(u[g++]=192|(a&1984)>>>6,u[g++]=128|(a&63)>>>0):a<65536?(u[g++]=224|(a&61440)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0):(u[g++]=240|(a&1835008)>>>18,u[g++]=128|(a&258048)>>>12,u[g++]=128|(a&4032)>>>6,u[g++]=128|(a&63)>>>0),g>=64&&(this._step(),g-=64,this._totalLen+=64,u[0]=u[64+0],u[1]=u[64+1],u[2]=u[64+2]),g}digest(){return this._finished||(this._finished=!0,this._leftoverHighSurrogate&&(this._leftoverHighSurrogate=0,this._buffLen=this._push(this._buff,this._buffLen,65533)),this._totalLen+=this._buffLen,this._wrapUp()),m(this._h0)+m(this._h1)+m(this._h2)+m(this._h3)+m(this._h4)}_wrapUp(){this._buff[this._buffLen++]=128,v(this._buff,this._buffLen),this._buffLen>56&&(this._step(),v(this._buff));const u=8*this._totalLen;this._buffDV.setUint32(56,Math.floor(u/4294967296),!1),this._buffDV.setUint32(60,u%4294967296,!1),this._step()}_step(){const u=y._bigBlock32,g=this._buffDV;for(let E=0;E<64;E+=4)u.setUint32(E,g.getUint32(E,!1),!1);for(let E=64;E<320;E+=4)u.setUint32(E,h(u.getUint32(E-12,!1)^u.getUint32(E-32,!1)^u.getUint32(E-56,!1)^u.getUint32(E-64,!1),1),!1);let a=this._h0,s=this._h1,i=this._h2,n=this._h3,e=this._h4,r,o,S;for(let E=0;E<80;E++)E<20?(r=s&i|~s&n,o=1518500249):E<40?(r=s^i^n,o=1859775393):E<60?(r=s&i|s&n|i&n,o=2400959708):(r=s^i^n,o=3395469782),S=h(a,5)+r+e+o+u.getUint32(E*4,!1)&4294967295,e=n,n=i,i=h(s,30),s=a,a=S;this._h0=this._h0+a&4294967295,this._h1=this._h1+s&4294967295,this._h2=this._h2+i&4294967295,this._h3=this._h3+n&4294967295,this._h4=this._h4+e&4294967295}}t.StringSHA1=y,y._bigBlock32=new DataView(new ArrayBuffer(320))}),define(Z[54],ee([0,1,31]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0});var b;(function(w){w[w.Ignore=0]="Ignore",w[w.Info=1]="Info",w[w.Warning=2]="Warning",w[w.Error=3]="Error"})(b||(b={})),function(w){const O="error",A="warning",p="warn",c="info",d="ignore";function C(h){return h?I.equalsIgnoreCase(O,h)?w.Error:I.equalsIgnoreCase(A,h)||I.equalsIgnoreCase(p,h)?w.Warning:I.equalsIgnoreCase(c,h)?w.Info:w.Ignore:w.Ignore}w.fromValue=C;function P(h){switch(h){case w.Error:return O;case w.Warning:return A;case w.Info:return c;default:return d}}w.toString=P}(b||(b={})),t.default=b}),define(Z[75],ee([0,1,10]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.log=t.getFirstFrame=t.parse=t.isRemoteConsoleLog=void 0;function b(d){const C=d;return C&&typeof C.type=="string"&&typeof C.severity=="string"}t.isRemoteConsoleLog=b;function w(d){const C=[];let P;try{const h=JSON.parse(d.arguments),v=h[h.length-1];v&&v.__$stack&&(h.pop(),P=v.__$stack),C.push(...h)}catch{C.push("Unable to log remote console arguments",d.arguments)}return{args:C,stack:P}}t.parse=w;function O(d){if(typeof d!="string")return O(w(d).stack);const C=d;if(C){const P=A(C),h=/at [^\/]*((?:(?:[a-zA-Z]+:)|(?:[\/])|(?:\\\\))(?:.+)):(\d+):(\d+)/.exec(P||"");if(h&&h.length===4)return{uri:I.URI.file(h[1]),line:Number(h[2]),column:Number(h[3])}}}t.getFirstFrame=O;function A(d){if(!d)return d;const C=d.indexOf(`
`);return C===-1?d:d.substring(0,C)}function p(d,C){const{args:P,stack:h}=w(d),v=typeof P[0]=="string"&&P.length===1;let f=A(h);f&&(f=`(${f.trim()})`);let m=[];if(typeof P[0]=="string"?f&&v?m=[`%c[${C}] %c${P[0]} %c${f}`,c("blue"),c(""),c("grey")]:m=[`%c[${C}] %c${P[0]}`,c("blue"),c(""),...P.slice(1)]:m=[`%c[${C}]%`,c("blue"),...P],f&&!v&&m.push(f),typeof console[d.severity]!="function")throw new Error("Unknown console method");console[d.severity].apply(console,m)}t.log=p;function c(d){return`color: ${d}`}}),define(Z[44],ee([0,1,15,31,10]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.revive=t.parse=t.stringify=void 0;function O(d){return JSON.stringify(d,p)}t.stringify=O;function A(d){let C=JSON.parse(d);return C=c(C),C}t.parse=A;function p(d,C){return C instanceof RegExp?{$mid:2,source:C.source,flags:(0,b.regExpFlags)(C)}:C}function c(d,C=0){if(!d||C>200)return d;if(typeof d=="object"){switch(d.$mid){case 1:return w.URI.revive(d);case 2:return new RegExp(d.source,d.flags);case 14:return new Date(d.source)}if(d instanceof I.VSBuffer||d instanceof Uint8Array)return d;if(Array.isArray(d))for(let P=0;P<d.length;++P)d[P]=c(d[P],C+1);else for(const P in d)Object.hasOwnProperty.call(d,P)&&(d[P]=c(d[P],C+1))}return d}t.revive=c}),define(Z[76],ee([0,1,38,14,20]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getFirstAvailablePowerShellInstallation=t.enumeratePowerShellInstallations=void 0;const O=/^\d+$/,A=/^Microsoft.PowerShell_.*/,p=/^Microsoft.PowerShellPreview_.*/;var c;(function(a){a[a.x64=0]="x64",a[a.x86=1]="x86",a[a.ARM=2]="ARM"})(c||(c={}));let d;switch(process.arch){case"ia32":case"x32":d=1;break;case"arm":case"arm64":d=2;break;default:d=0;break}let C;process.env.PROCESSOR_ARCHITEW6432?C=process.env.PROCESSOR_ARCHITEW6432==="ARM64"?2:0:process.env.PROCESSOR_ARCHITECTURE==="ARM64"?C=2:process.env.PROCESSOR_ARCHITECTURE==="X86"?C=1:C=0;class P{constructor(s,i,n){this.exePath=s,this.displayName=i,this.knownToExist=n}async exists(){return this.knownToExist===void 0&&(this.knownToExist=await w.SymlinkSupport.existsFile(this.exePath)),this.knownToExist}}function h({useAlternateBitness:a=!1}={}){return a?d===0?process.env["ProgramFiles(x86)"]||null:C===0&&process.env.ProgramW6432||null:process.env.ProgramFiles||null}async function v({useAlternateBitness:a=!1,findPreview:s=!1}={}){const i=h({useAlternateBitness:a});if(!i)return null;const n=b.join(i,"PowerShell");if(!await w.SymlinkSupport.existsDirectory(n))return null;let e=-1,r=null;for(const E of await w.Promises.readdir(n)){let D=-1;if(s){const V=E.indexOf("-");if(V<0)continue;const _=E.substring(0,V);if(!O.test(_)||E.substring(V+1)!=="preview")continue;D=parseInt(_,10)}else{if(!O.test(E))continue;D=parseInt(E,10)}if(D<=e)continue;const k=b.join(n,E,"pwsh.exe");!await w.SymlinkSupport.existsFile(k)||(r=k,e=D)}if(!r)return null;const o=i.includes("x86")?" (x86)":"",S=s?" Preview":"";return new P(r,`PowerShell${S}${o}`,!0)}async function f({findPreview:a}={}){if(!process.env.LOCALAPPDATA)return null;const s=b.join(process.env.LOCALAPPDATA,"Microsoft","WindowsApps");if(!await w.SymlinkSupport.existsDirectory(s))return null;const{pwshMsixDirRegex:i,pwshMsixName:n}=a?{pwshMsixDirRegex:p,pwshMsixName:"PowerShell Preview (Store)"}:{pwshMsixDirRegex:A,pwshMsixName:"PowerShell (Store)"};for(const e of await w.Promises.readdir(s))if(i.test(e)){const r=b.join(s,e,"pwsh.exe");return new P(r,n)}return null}function m(){const a=b.join(I.homedir(),".dotnet","tools","pwsh.exe");return new P(a,".NET Core PowerShell Global Tool")}function y(){const a=b.join(process.env.windir,d===1&&C!==1?"SysNative":"System32","WindowsPowerShell","v1.0","powershell.exe");return new P(a,"Windows PowerShell",!0)}async function*l(){let a=await v();a&&(yield a),a=await v({useAlternateBitness:!0}),a&&(yield a),a=await f(),a&&(yield a),a=m(),a&&(yield a),a=await v({findPreview:!0}),a&&(yield a),a=await f({findPreview:!0}),a&&(yield a),a=await v({useAlternateBitness:!0,findPreview:!0}),a&&(yield a),a=y(),a&&(yield a)}async function*u(){for await(const a of l())await a.exists()&&(yield a)}t.enumeratePowerShellInstallations=u;async function g(){for await(const a of u())return a;return null}t.getFirstAvailablePowerShellInstallation=g}),define(Z[55],ee([0,1,14,13,32,51,5,20]),function($,t,I,b,w,O,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.win32=t.createQueuedSender=t.getWindowsShell=t.TerminateResponseCode=t.Source=void 0,Object.defineProperty(t,"Source",{enumerable:!0,get:function(){return O.Source}}),Object.defineProperty(t,"TerminateResponseCode",{enumerable:!0,get:function(){return O.TerminateResponseCode}});function c(P=w.env){return P.comspec||"cmd.exe"}t.getWindowsShell=c;function d(P){let h=[],v=!1;const f=function(m){if(v){h.push(m);return}(!P.send(m,l=>{if(l&&console.error(l),v=!1,h.length>0){const u=h.slice(0);h=[],u.forEach(g=>f(g))}})||b.isWindows)&&(v=!0)};return{send:f}}t.createQueuedSender=d;var C;(function(P){async function h(v,f,m){if(I.isAbsolute(v))return v;if(f===void 0&&(f=w.cwd()),I.dirname(v)!=="."||(m===void 0&&A.isString(w.env.PATH)&&(m=w.env.PATH.split(I.delimiter)),m===void 0||m.length===0))return I.join(f,v);async function l(u){if(await p.Promises.exists(u)){let g;try{g=await p.Promises.stat(u)}catch(a){a.message.startsWith("EACCES")&&(g=await p.Promises.lstat(u))}return g?!g.isDirectory():!1}return!1}for(const u of m){let g;if(I.isAbsolute(u)?g=I.join(u,v):g=I.join(f,u,v),await l(g))return g;let a=g+".com";if(await l(a)||(a=g+".exe",await l(a)))return a}return I.join(f,v)}P.findExecutable=h})(C=t.win32||(t.win32={}))}),define(Z[77],ee([0,1,38,13,76,55]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSystemShellSync=t.getSystemShell=void 0;async function A(v,f){return v===1?b.isWindows?P():O.getWindowsShell(f):d(v,f)}t.getSystemShell=A;function p(v,f){return v===1?b.isWindows?h(f):O.getWindowsShell(f):d(v,f)}t.getSystemShellSync=p;let c=null;function d(v,f){if(b.isLinux&&v===2||b.isMacintosh&&v===3)return"/bin/bash";if(!c){let m;if(b.isWindows)m="/bin/bash";else{if(m=f.SHELL,!m)try{m=(0,I.userInfo)().shell}catch{}m||(m="sh"),m==="/bin/false"&&(m="/bin/bash")}c=m}return c}let C=null;async function P(){return C||(C=(await(0,w.getFirstAvailablePowerShellInstallation)()).exePath),C}function h(v){if(C)return C;const f=b.isWindows&&parseFloat((0,I.release)())>=10,m=v.hasOwnProperty("PROCESSOR_ARCHITEW6432"),y=`${v.windir}\\${m?"Sysnative":"System32"}\\WindowsPowerShell\\v1.0\\powershell.exe`;return f?y:O.getWindowsShell(v)}});var fe=this&&this.__decorate||function($,t,I,b){var w=arguments.length,O=w<3?t:b===null?b=Object.getOwnPropertyDescriptor(t,I):b,A;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")O=Reflect.decorate($,t,I,b);else for(var p=$.length-1;p>=0;p--)(A=$[p])&&(O=(w<3?A(O):w>3?A(t,I,O):A(t,I))||O);return w>3&&O&&Object.defineProperty(t,I,O),O};define(Z[56],ee([0,1,19,3,15,24,49,12,4,2,44,31,5]),function($,t,I,b,w,O,A,p,c,d,C,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IPCLogger=t.logWithColors=t.ProxyChannel=t.StaticRouter=t.getNextTickChannel=t.getDelayedChannel=t.IPCClient=t.IPCServer=t.ChannelClient=t.RequestInitiator=t.ChannelServer=t.ResponseType=t.RequestType=void 0;var v;(function(M){M[M.Promise=100]="Promise",M[M.PromiseCancel=101]="PromiseCancel",M[M.EventListen=102]="EventListen",M[M.EventDispose=103]="EventDispose"})(v=t.RequestType||(t.RequestType={}));function f(M){switch(M){case 100:return"req";case 101:return"cancel";case 102:return"subscribe";case 103:return"unsubscribe"}}var m;(function(M){M[M.Initialize=200]="Initialize",M[M.PromiseSuccess=201]="PromiseSuccess",M[M.PromiseError=202]="PromiseError",M[M.PromiseErrorObj=203]="PromiseErrorObj",M[M.EventFire=204]="EventFire"})(m=t.ResponseType||(t.ResponseType={}));function y(M){switch(M){case 200:return"init";case 201:return"reply:";case 202:case 203:return"replyErr:";case 204:return"event:"}}var l;(function(M){M[M.Uninitialized=0]="Uninitialized",M[M.Idle=1]="Idle"})(l||(l={}));class u{constructor(F){this.buffer=F,this.pos=0}read(F){const W=this.buffer.slice(this.pos,this.pos+F);return this.pos+=W.byteLength,W}}class g{constructor(){this.buffers=[]}get buffer(){return w.VSBuffer.concat(this.buffers)}write(F){this.buffers.push(F)}}var a;(function(M){M[M.Undefined=0]="Undefined",M[M.String=1]="String",M[M.Buffer=2]="Buffer",M[M.VSBuffer=3]="VSBuffer",M[M.Array=4]="Array",M[M.Object=5]="Object"})(a||(a={}));function s(M){const F=w.VSBuffer.alloc(4);return F.writeUInt32BE(M,0),F}function i(M){return M.read(4).readUInt32BE(0)}function n(M){const F=w.VSBuffer.alloc(1);return F.writeUInt8(M,0),F}const e={Undefined:n(a.Undefined),String:n(a.String),Buffer:n(a.Buffer),VSBuffer:n(a.VSBuffer),Array:n(a.Array),Object:n(a.Object)},r=typeof Buffer!="undefined";function o(M,F){if(typeof F=="undefined")M.write(e.Undefined);else if(typeof F=="string"){const W=w.VSBuffer.fromString(F);M.write(e.String),M.write(s(W.byteLength)),M.write(W)}else if(r&&Buffer.isBuffer(F)){const W=w.VSBuffer.wrap(F);M.write(e.Buffer),M.write(s(W.byteLength)),M.write(W)}else if(F instanceof w.VSBuffer)M.write(e.VSBuffer),M.write(s(F.byteLength)),M.write(F);else if(Array.isArray(F)){M.write(e.Array),M.write(s(F.length));for(const W of F)o(M,W)}else{const W=w.VSBuffer.fromString(JSON.stringify(F));M.write(e.Object),M.write(s(W.byteLength)),M.write(W)}}function S(M){switch(M.read(1).readUInt8(0)){case a.Undefined:return;case a.String:return M.read(i(M)).toString();case a.Buffer:return M.read(i(M)).buffer;case a.VSBuffer:return M.read(i(M));case a.Array:{const W=i(M),q=[];for(let Y=0;Y<W;Y++)q.push(S(M));return q}case a.Object:return JSON.parse(M.read(i(M)).toString())}}class E{constructor(F,W,q=null,Y=1e3){this.protocol=F,this.ctx=W,this.logger=q,this.timeoutDelay=Y,this.channels=new Map,this.activeRequests=new Map,this.pendingRequests=new Map,this.protocolListener=this.protocol.onMessage(T=>this.onRawMessage(T)),this.sendResponse({type:200})}registerChannel(F,W){this.channels.set(F,W),setTimeout(()=>this.flushPendingRequests(F),0)}sendResponse(F){switch(F.type){case 200:{const W=this.send([F.type]);this.logger?.logOutgoing(W,0,1,y(F.type));return}case 201:case 202:case 204:case 203:{const W=this.send([F.type,F.id],F.data);this.logger?.logOutgoing(W,F.id,1,y(F.type),F.data);return}}}send(F,W=void 0){const q=new g;return o(q,F),o(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onRawMessage(F){const W=new u(F),q=S(W),Y=S(W),T=q[0];switch(T){case 100:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}: ${q[2]}.${q[3]}`,Y),this.onPromise({type:T,id:q[1],channelName:q[2],name:q[3],arg:Y});case 102:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}: ${q[2]}.${q[3]}`,Y),this.onEventListen({type:T,id:q[1],channelName:q[2],name:q[3],arg:Y});case 101:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}`),this.disposeActiveRequest({type:T,id:q[1]});case 103:return this.logger?.logIncoming(F.byteLength,q[1],1,`${f(T)}`),this.disposeActiveRequest({type:T,id:q[1]})}}onPromise(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=new O.CancellationTokenSource;let Y;try{Y=W.call(this.ctx,F.name,F.arg,q.token)}catch(R){Y=Promise.reject(R)}const T=F.id;Y.then(R=>{this.sendResponse({id:T,data:R,type:201}),this.activeRequests.delete(F.id)},R=>{R instanceof Error?this.sendResponse({id:T,data:{message:R.message,name:R.name,stack:R.stack?R.stack.split?R.stack.split(`
`):R.stack:void 0},type:202}):this.sendResponse({id:T,data:R,type:203}),this.activeRequests.delete(F.id)});const x=(0,d.toDisposable)(()=>q.cancel());this.activeRequests.set(F.id,x)}onEventListen(F){const W=this.channels.get(F.channelName);if(!W){this.collectPendingRequest(F);return}const q=F.id,T=W.listen(this.ctx,F.name,F.arg)(x=>this.sendResponse({id:q,data:x,type:204}));this.activeRequests.set(F.id,T)}disposeActiveRequest(F){const W=this.activeRequests.get(F.id);W&&(W.dispose(),this.activeRequests.delete(F.id))}collectPendingRequest(F){let W=this.pendingRequests.get(F.channelName);W||(W=[],this.pendingRequests.set(F.channelName,W));const q=setTimeout(()=>{console.error(`Unknown channel: ${F.channelName}`),F.type===100&&this.sendResponse({id:F.id,data:{name:"Unknown channel",message:`Channel name '${F.channelName}' timed out after ${this.timeoutDelay}ms`,stack:void 0},type:202})},this.timeoutDelay);W.push({request:F,timeoutTimer:q})}flushPendingRequests(F){const W=this.pendingRequests.get(F);if(W){for(const q of W)switch(clearTimeout(q.timeoutTimer),q.request.type){case 100:this.onPromise(q.request);break;case 102:this.onEventListen(q.request);break}this.pendingRequests.delete(F)}}dispose(){this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}t.ChannelServer=E;var D;(function(M){M[M.LocalSide=0]="LocalSide",M[M.OtherSide=1]="OtherSide"})(D=t.RequestInitiator||(t.RequestInitiator={}));class k{constructor(F,W=null){this.protocol=F,this.isDisposed=!1,this.state=l.Uninitialized,this.activeRequests=new Set,this.handlers=new Map,this.lastRequestId=0,this._onDidInitialize=new c.Emitter,this.onDidInitialize=this._onDidInitialize.event,this.protocolListener=this.protocol.onMessage(q=>this.onBuffer(q)),this.logger=W}getChannel(F){const W=this;return{call(q,Y,T){return W.isDisposed?Promise.reject(p.canceled()):W.requestPromise(F,q,Y,T)},listen(q,Y){return W.isDisposed?c.Event.None:W.requestEvent(F,q,Y)}}}requestPromise(F,W,q,Y=O.CancellationToken.None){const T=this.lastRequestId++,R={id:T,type:100,channelName:F,name:W,arg:q};if(Y.isCancellationRequested)return Promise.reject(p.canceled());let L;return new Promise((j,H)=>{if(Y.isCancellationRequested)return H(p.canceled());const X=()=>{const ve=ie=>{switch(ie.type){case 201:this.handlers.delete(T),j(ie.data);break;case 202:{this.handlers.delete(T);const se=new Error(ie.data.message);se.stack=ie.data.stack,se.name=ie.data.name,H(se);break}case 203:this.handlers.delete(T),H(ie.data);break}};this.handlers.set(T,ve),this.sendRequest(R)};let oe=null;this.state===l.Idle?X():(oe=(0,b.createCancelablePromise)(ve=>this.whenInitialized()),oe.then(()=>{oe=null,X()}));const le=()=>{oe?(oe.cancel(),oe=null):this.sendRequest({id:T,type:101}),H(p.canceled())},pe=Y.onCancellationRequested(le);L=(0,d.combinedDisposable)((0,d.toDisposable)(le),pe),this.activeRequests.add(L)}).finally(()=>{this.activeRequests.delete(L)})}requestEvent(F,W,q){const Y=this.lastRequestId++,x={id:Y,type:102,channelName:F,name:W,arg:q};let R=null;const L=new c.Emitter({onFirstListenerAdd:()=>{R=(0,b.createCancelablePromise)(j=>this.whenInitialized()),R.then(()=>{R=null,this.activeRequests.add(L),this.sendRequest(x)})},onLastListenerRemove:()=>{R?(R.cancel(),R=null):(this.activeRequests.delete(L),this.sendRequest({id:Y,type:103}))}}),U=j=>L.fire(j.data);return this.handlers.set(Y,U),L.event}sendRequest(F){switch(F.type){case 100:case 102:{const W=this.send([F.type,F.id,F.channelName,F.name],F.arg);this.logger?.logOutgoing(W,F.id,0,`${f(F.type)}: ${F.channelName}.${F.name}`,F.arg);return}case 101:case 103:{const W=this.send([F.type,F.id]);this.logger?.logOutgoing(W,F.id,0,f(F.type));return}}}send(F,W=void 0){const q=new g;return o(q,F),o(q,W),this.sendBuffer(q.buffer)}sendBuffer(F){try{return this.protocol.send(F),F.byteLength}catch{return 0}}onBuffer(F){const W=new u(F),q=S(W),Y=S(W),T=q[0];switch(T){case 200:return this.logger?.logIncoming(F.byteLength,0,0,y(T)),this.onResponse({type:q[0]});case 201:case 202:case 204:case 203:return this.logger?.logIncoming(F.byteLength,q[1],0,y(T),Y),this.onResponse({type:q[0],id:q[1],data:Y})}}onResponse(F){if(F.type===200){this.state=l.Idle,this._onDidInitialize.fire();return}this.handlers.get(F.id)?.(F)}get onDidInitializePromise(){return c.Event.toPromise(this.onDidInitialize)}whenInitialized(){return this.state===l.Idle?Promise.resolve():this.onDidInitializePromise}dispose(){this.isDisposed=!0,this.protocolListener&&(this.protocolListener.dispose(),this.protocolListener=null),(0,d.dispose)(this.activeRequests.values()),this.activeRequests.clear()}}fe([A.memoize],k.prototype,"onDidInitializePromise",null),t.ChannelClient=k;class V{constructor(F){this.channels=new Map,this._connections=new Set,this._onDidAddConnection=new c.Emitter,this.onDidAddConnection=this._onDidAddConnection.event,this._onDidRemoveConnection=new c.Emitter,this.onDidRemoveConnection=this._onDidRemoveConnection.event,F(({protocol:W,onDidClientDisconnect:q})=>{c.Event.once(W.onMessage)(T=>{const x=new u(T),R=S(x),L=new E(W,R),U=new k(W);this.channels.forEach((H,X)=>L.registerChannel(X,H));const j={channelServer:L,channelClient:U,ctx:R};this._connections.add(j),this._onDidAddConnection.fire(j),q(()=>{L.dispose(),U.dispose(),this._connections.delete(j),this._onDidRemoveConnection.fire(j)})})})}get connections(){const F=[];return this._connections.forEach(W=>F.push(W)),F}getChannel(F,W){const q=this;return{call(Y,T,x){let R;if((0,h.isFunction)(W)){const U=(0,I.getRandomElement)(q.connections.filter(W));R=U?Promise.resolve(U):c.Event.toPromise(c.Event.filter(q.onDidAddConnection,W))}else R=W.routeCall(q,Y,T);const L=R.then(U=>U.channelClient.getChannel(F));return G(L).call(Y,T,x)},listen(Y,T){if((0,h.isFunction)(W))return q.getMulticastEvent(F,W,Y,T);const x=W.routeEvent(q,Y,T).then(R=>R.channelClient.getChannel(F));return G(x).listen(Y,T)}}}getMulticastEvent(F,W,q,Y){const T=this;let x=new d.DisposableStore;const R=new c.Emitter({onFirstListenerAdd:()=>{x=new d.DisposableStore;const L=new c.EventMultiplexer,U=new Map,j=X=>{const le=X.channelClient.getChannel(F).listen(q,Y),pe=L.add(le);U.set(X,pe)},H=X=>{const oe=U.get(X);!oe||(oe.dispose(),U.delete(X))};T.connections.filter(W).forEach(j),c.Event.filter(T.onDidAddConnection,W)(j,void 0,x),T.onDidRemoveConnection(H,void 0,x),L.event(R.fire,R,x),x.add(L)},onLastListenerRemove:()=>{x.dispose()}});return R.event}registerChannel(F,W){this.channels.set(F,W),this._connections.forEach(q=>{q.channelServer.registerChannel(F,W)})}dispose(){this.channels.clear(),this._connections.clear(),this._onDidAddConnection.dispose(),this._onDidRemoveConnection.dispose()}}t.IPCServer=V;class _{constructor(F,W,q=null){const Y=new g;o(Y,W),F.send(Y.buffer),this.channelClient=new k(F,q),this.channelServer=new E(F,W,q)}getChannel(F){return this.channelClient.getChannel(F)}registerChannel(F,W){this.channelServer.registerChannel(F,W)}dispose(){this.channelClient.dispose(),this.channelServer.dispose()}}t.IPCClient=_;function G(M){return{call(F,W,q){return M.then(Y=>Y.call(F,W,q))},listen(F,W){const q=new c.Relay;return M.then(Y=>q.input=Y.listen(F,W)),q.event}}}t.getDelayedChannel=G;function Q(M){let F=!1;return{call(W,q,Y){return F?M.call(W,q,Y):(0,b.timeout)(0).then(()=>F=!0).then(()=>M.call(W,q,Y))},listen(W,q){if(F)return M.listen(W,q);const Y=new c.Relay;return(0,b.timeout)(0).then(()=>F=!0).then(()=>Y.input=M.listen(W,q)),Y.event}}}t.getNextTickChannel=Q;class ne{constructor(F){this.fn=F}routeCall(F){return this.route(F)}routeEvent(F){return this.route(F)}async route(F){for(const W of F.connections)if(await Promise.resolve(this.fn(W.ctx)))return Promise.resolve(W);return await c.Event.toPromise(F.onDidAddConnection),await this.route(F)}}t.StaticRouter=ne;var ce;(function(M){function F(T,x){const R=T,L=x&&x.disableMarshalling,U=new Map;for(const j in R)q(j)&&U.set(j,c.Event.buffer(R[j],!0));return new class{listen(j,H,X){const oe=U.get(H);if(oe)return oe;if(Y(H)){const le=R[H];if(typeof le=="function")return le.call(R,X)}throw new Error(`Event not found: ${H}`)}call(j,H,X){const oe=R[H];if(typeof oe=="function"){if(!L&&Array.isArray(X))for(let le=0;le<X.length;le++)X[le]=(0,C.revive)(X[le]);return oe.apply(R,X)}throw new Error(`Method not found: ${H}`)}}}M.fromService=F;function W(T,x){const R=x&&x.disableMarshalling;return new Proxy({},{get(L,U){if(typeof U=="string")return x?.properties?.has(U)?x.properties.get(U):Y(U)?function(j){return T.listen(U,j)}:q(U)?T.listen(U):async function(...j){let H;x&&!(0,h.isUndefinedOrNull)(x.context)?H=[x.context,...j]:H=j;const X=await T.call(U,H);return R?X:(0,C.revive)(X)};throw new Error(`Property not found: ${String(U)}`)}})}M.toService=W;function q(T){return T[0]==="o"&&T[1]==="n"&&P.isUpperAsciiLetter(T.charCodeAt(2))}function Y(T){return/^onDynamic/.test(T)&&P.isUpperAsciiLetter(T.charCodeAt(9))}})(ce=t.ProxyChannel||(t.ProxyChannel={}));const re=[["#2977B1","#FC802D","#34A13A","#D3282F","#9366BA"],["#8B564C","#E177C0","#7F7F7F","#BBBE3D","#2EBECD"]];function ge(M){if(Array.isArray(M))return M;if(M&&typeof M=="object"&&typeof M.toString=="function"){const F=M.toString();if(F!=="[object Object]")return F}return M}function ae(M){return Array.isArray(M)?M.map(ge):ge(M)}function N(M,F,W,q,Y,T,x){x=ae(x);const R=re[Y],L=R[q%R.length];let U=[`%c[${M}]%c[${String(F).padStart(7," ")}]%c[len: ${String(W).padStart(5," ")}]%c${String(q).padStart(5," ")} - ${T}`,"color: darkgreen","color: grey","color: grey",`color: ${L}`];/\($/.test(T)?(U=U.concat(x),U.push(")")):U.push(x),console.log.apply(console,U)}t.logWithColors=N;class B{constructor(F,W){this._outgoingPrefix=F,this._incomingPrefix=W,this._totalIncoming=0,this._totalOutgoing=0}logOutgoing(F,W,q,Y,T){this._totalOutgoing+=F,N(this._outgoingPrefix,this._totalOutgoing,F,W,q,Y,T)}logIncoming(F,W,q,Y,T){this._totalIncoming+=F,N(this._incomingPrefix,this._totalIncoming,F,W,q,Y,T)}}t.IPCLogger=B}),define(Z[78],ee([0,1,57,3,15,24,75,12,4,2,26,55,51,56]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Client=t.Server=void 0;class f extends v.ChannelServer{constructor(l){super({send:u=>{try{process.send?.(u.buffer.toString("base64"))}catch{}},onMessage:c.Event.fromNodeEventEmitter(process,"message",u=>w.VSBuffer.wrap(Buffer.from(u,"base64")))},l);process.once("disconnect",()=>this.dispose())}}t.Server=f;class m{constructor(l,u){this.modulePath=l,this.options=u,this.activeRequests=new Set,this.channels=new Map,this._onDidProcessExit=new c.Emitter,this.onDidProcessExit=this._onDidProcessExit.event;const g=u&&u.timeout?u.timeout:6e4;this.disposeDelayer=new b.Delayer(g),this.child=null,this._client=null}getChannel(l){const u=this;return{call(g,a,s){return u.requestPromise(l,g,a,s)},listen(g,a){return u.requestEvent(l,g,a)}}}requestPromise(l,u,g,a=O.CancellationToken.None){if(!this.disposeDelayer)return Promise.reject(new Error("disposed"));if(a.isCancellationRequested)return Promise.reject(p.canceled());this.disposeDelayer.cancel();const s=this.getCachedChannel(l),i=(0,b.createCancelablePromise)(r=>s.call(u,g,r)),n=a.onCancellationRequested(()=>i.cancel()),e=(0,d.toDisposable)(()=>i.cancel());return this.activeRequests.add(e),i.finally(()=>{n.dispose(),this.activeRequests.delete(e),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}),i}requestEvent(l,u,g){if(!this.disposeDelayer)return c.Event.None;this.disposeDelayer.cancel();let a;const s=new c.Emitter({onFirstListenerAdd:()=>{a=this.getCachedChannel(l).listen(u,g)(s.fire,s),this.activeRequests.add(a)},onLastListenerRemove:()=>{this.activeRequests.delete(a),a.dispose(),this.activeRequests.size===0&&this.disposeDelayer&&this.disposeDelayer.trigger(()=>this.disposeClient())}});return s.event}get client(){if(!this._client){const l=this.options&&this.options.args?this.options.args:[],u=Object.create(null);u.env={...(0,C.deepClone)(process.env),VSCODE_PARENT_PID:String(process.pid)},this.options&&this.options.env&&(u.env={...u.env,...this.options.env}),this.options&&this.options.freshExecArgv&&(u.execArgv=[]),this.options&&typeof this.options.debug=="number"&&(u.execArgv=["--nolazy","--inspect="+this.options.debug]),this.options&&typeof this.options.debugBrk=="number"&&(u.execArgv=["--nolazy","--inspect-brk="+this.options.debugBrk]),u.execArgv===void 0&&(u.execArgv=process.execArgv.filter(o=>!/^--inspect(-brk)?=/.test(o))),(0,h.removeDangerousEnvVariables)(u.env),this.child=(0,I.fork)(this.modulePath,l,u);const g=new c.Emitter;c.Event.fromNodeEventEmitter(this.child,"message",o=>o)(o=>{if((0,A.isRemoteConsoleLog)(o)){(0,A.log)(o,`IPC Library: ${this.options.serverName}`);return}g.fire(w.VSBuffer.wrap(Buffer.from(o,"base64")))});const s=this.options.useQueue?(0,P.createQueuedSender)(this.child):this.child,i=o=>this.child&&this.child.connected&&s.send(o.buffer.toString("base64")),n=g.event,e={send:i,onMessage:n};this._client=new v.ChannelClient(e);const r=()=>this.disposeClient();process.once("exit",r),this.child.on("error",o=>console.warn('IPC "'+this.options.serverName+'" errored with '+o)),this.child.on("exit",(o,S)=>{process.removeListener("exit",r),this.activeRequests.forEach(E=>(0,d.dispose)(E)),this.activeRequests.clear(),o!==0&&S!=="SIGTERM"&&console.warn('IPC "'+this.options.serverName+'" crashed with exit code '+o+" and signal "+S),this.disposeDelayer?.cancel(),this.disposeClient(),this._onDidProcessExit.fire({code:o,signal:S})})}return this._client}getCachedChannel(l){let u=this.channels.get(l);return u||(u=this.client.getChannel(l),this.channels.set(l,u)),u}disposeClient(){this._client&&(this.child&&(this.child.kill(),this.child=null),this._client=null,this.channels.clear())}dispose(){this._onDidProcessExit.dispose(),this.disposeDelayer&&(this.disposeDelayer.cancel(),this.disposeDelayer=void 0),this.disposeClient(),this.activeRequests.clear()}}t.Client=m}),define(Z[79],ee([0,1,3,4,2,5]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.InMemoryStorageDatabase=t.Storage=t.StorageState=t.isStorageItemsChangeEvent=t.StorageHint=void 0;var A;(function(P){P[P.STORAGE_DOES_NOT_EXIST=0]="STORAGE_DOES_NOT_EXIST"})(A=t.StorageHint||(t.StorageHint={}));function p(P){const h=P;return h?.changed instanceof Map||h?.deleted instanceof Set}t.isStorageItemsChangeEvent=p;var c;(function(P){P[P.None=0]="None",P[P.Initialized=1]="Initialized",P[P.Closed=2]="Closed"})(c=t.StorageState||(t.StorageState={}));class d extends w.Disposable{constructor(h,v=Object.create(null)){super();this.database=h,this.options=v,this._onDidChangeStorage=this._register(new b.Emitter),this.onDidChangeStorage=this._onDidChangeStorage.event,this.state=c.None,this.cache=new Map,this.flushDelayer=new I.ThrottledDelayer(d.DEFAULT_FLUSH_DELAY),this.pendingDeletes=new Set,this.pendingInserts=new Map,this.pendingClose=void 0,this.whenFlushedCallbacks=[],this.registerListeners()}registerListeners(){this._register(this.database.onDidChangeItemsExternal(h=>this.onDidChangeItemsExternal(h)))}onDidChangeItemsExternal(h){h.changed?.forEach((v,f)=>this.accept(f,v)),h.deleted?.forEach(v=>this.accept(v,void 0))}accept(h,v){if(this.state===c.Closed)return;let f=!1;(0,O.isUndefinedOrNull)(v)?f=this.cache.delete(h):this.cache.get(h)!==v&&(this.cache.set(h,v),f=!0),f&&this._onDidChangeStorage.fire(h)}get items(){return this.cache}get size(){return this.cache.size}async init(){this.state===c.None&&(this.state=c.Initialized,this.options.hint!==A.STORAGE_DOES_NOT_EXIST&&(this.cache=await this.database.getItems()))}get(h,v){const f=this.cache.get(h);return(0,O.isUndefinedOrNull)(f)?v:f}getBoolean(h,v){const f=this.get(h);return(0,O.isUndefinedOrNull)(f)?v:f==="true"}getNumber(h,v){const f=this.get(h);return(0,O.isUndefinedOrNull)(f)?v:parseInt(f,10)}async set(h,v){if(this.state===c.Closed)return;if((0,O.isUndefinedOrNull)(v))return this.delete(h);const f=String(v);if(this.cache.get(h)!==f)return this.cache.set(h,f),this.pendingInserts.set(h,f),this.pendingDeletes.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async delete(h){if(!(this.state===c.Closed||!this.cache.delete(h)))return this.pendingDeletes.has(h)||this.pendingDeletes.add(h),this.pendingInserts.delete(h),this._onDidChangeStorage.fire(h),this.doFlush()}async close(){return this.pendingClose||(this.pendingClose=this.doClose()),this.pendingClose}async doClose(){this.state=c.Closed;try{await this.doFlush(0)}catch{}await this.database.close(()=>this.cache)}get hasPending(){return this.pendingInserts.size>0||this.pendingDeletes.size>0}async flushPending(){if(!this.hasPending)return;const h={insert:this.pendingInserts,delete:this.pendingDeletes};return this.pendingDeletes=new Set,this.pendingInserts=new Map,this.database.updateItems(h).finally(()=>{if(!this.hasPending)for(;this.whenFlushedCallbacks.length;)this.whenFlushedCallbacks.pop()?.()})}async flush(h){if(!!this.hasPending)return this.doFlush(h)}async doFlush(h){return this.flushDelayer.trigger(()=>this.flushPending(),h)}async whenFlushed(){if(!!this.hasPending)return new Promise(h=>this.whenFlushedCallbacks.push(h))}dispose(){this.flushDelayer.dispose(),super.dispose()}}t.Storage=d,d.DEFAULT_FLUSH_DELAY=100;class C{constructor(){this.onDidChangeItemsExternal=b.Event.None,this.items=new Map}async getItems(){return this.items}async updateItems(h){h.insert?.forEach((v,f)=>this.items.set(f,v)),h.delete?.forEach(v=>this.items.delete(v))}async close(){}}t.InMemoryStorageDatabase=C}),define(Z[80],ee([6,7]),function($,t){return $.create("vs/base/node/zip",t)}),define(Z[81],ee([6,7]),function($,t){return $.create("vs/platform/configuration/common/configurationRegistry",t)}),define(Z[82],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/abstractExtensionManagementService",t)}),define(Z[83],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagement",t)}),define(Z[84],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionManagementCLIService",t)}),define(Z[85],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/common/extensionsScannerService",t)}),define(Z[86],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementService",t)}),define(Z[87],ee([6,7]),function($,t){return $.create("vs/platform/extensionManagement/node/extensionManagementUtil",t)}),define(Z[88],ee([6,7]),function($,t){return $.create("vs/platform/extensions/common/extensionValidator",t)}),define(Z[89],ee([6,7]),function($,t){return $.create("vs/platform/files/common/fileService",t)}),define(Z[90],ee([6,7]),function($,t){return $.create("vs/platform/files/common/io",t)}),define(Z[91],ee([6,7]),function($,t){return $.create("vs/platform/files/node/diskFileSystemProvider",t)}),define(Z[92],ee([6,7]),function($,t){return $.create("vs/platform/languagePacks/common/languagePacks",t)}),define(Z[93],ee([6,7]),function($,t){return $.create("vs/platform/request/common/request",t)}),define(Z[94],ee([6,7]),function($,t){return $.create("vs/platform/shell/node/shellEnv",t)}),define(Z[95],ee([6,7]),function($,t){return $.create("vs/platform/telemetry/common/telemetryService",t)}),define(Z[96],ee([6,7]),function($,t){return $.create("vs/platform/userDataProfile/common/userDataProfile",t)}),define(Z[97],ee([6,7]),function($,t){return $.create("vs/platform/workspace/common/workspace",t)}),define(Z[98],ee([0,1,71,49,16,14,32,17,10]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parsePtyHostPort=t.parseSearchPort=t.parseExtensionHostPort=t.AbstractNativeEnvironmentService=void 0;class d{constructor(m,y,l){this._args=m,this.paths=y,this.productService=l,this.editSessionId=this.args.editSessionId}get appRoot(){return(0,O.dirname)(w.FileAccess.asFileUri("",$).fsPath)}get userHome(){return c.URI.file(this.paths.homeDir)}get userDataPath(){return this.paths.userDataDir}get appSettingsHome(){return c.URI.file((0,O.join)(this.userDataPath,"User"))}get tmpDir(){return c.URI.file(this.paths.tmpDir)}get cacheHome(){return c.URI.file(this.userDataPath)}get stateResource(){return(0,p.joinPath)(this.appSettingsHome,"globalStorage","storage.json")}get userRoamingDataHome(){return this.appSettingsHome}get userDataSyncHome(){return(0,p.joinPath)(this.userRoamingDataHome,"sync")}get logsPath(){if(!this.args.logsPath){const m=(0,I.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"");this.args.logsPath=(0,O.join)(this.userDataPath,"logs",m)}return this.args.logsPath}get userDataSyncLogResource(){return c.URI.file((0,O.join)(this.logsPath,"userDataSync.log"))}get editSessionsLogResource(){return c.URI.file((0,O.join)(this.logsPath,"editSessions.log"))}get sync(){return this.args.sync}get machineSettingsResource(){return(0,p.joinPath)(c.URI.file((0,O.join)(this.userDataPath,"Machine")),"settings.json")}get workspaceStorageHome(){return(0,p.joinPath)(this.appSettingsHome,"workspaceStorage")}get localHistoryHome(){return(0,p.joinPath)(this.appSettingsHome,"History")}get keyboardLayoutResource(){return(0,p.joinPath)(this.userRoamingDataHome,"keyboardLayout.json")}get argvResource(){const m=A.env.VSCODE_PORTABLE;return m?c.URI.file((0,O.join)(m,"argv.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"argv.json")}get isExtensionDevelopment(){return!!this.args.extensionDevelopmentPath}get untitledWorkspacesHome(){return c.URI.file((0,O.join)(this.userDataPath,"Workspaces"))}get installSourcePath(){return(0,O.join)(this.userDataPath,"installSource")}get builtinExtensionsPath(){const m=this.args["builtin-extensions-dir"];return m?(0,O.resolve)(m):(0,O.normalize)((0,O.join)(w.FileAccess.asFileUri("",$).fsPath,"..","extensions"))}get extensionsDownloadPath(){const m=this.args["extensions-download-dir"];return m?(0,O.resolve)(m):(0,O.join)(this.userDataPath,"CachedExtensionVSIXs")}get extensionsPath(){const m=this.args["extensions-dir"];if(m)return(0,O.resolve)(m);const y=A.env.VSCODE_EXTENSIONS;if(y)return y;const l=A.env.VSCODE_PORTABLE;return l?(0,O.join)(l,"extensions"):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"extensions").fsPath}get extensionDevelopmentLocationURI(){const m=this.args.extensionDevelopmentPath;if(Array.isArray(m))return m.map(y=>/^[^:/?#]+?:\/\//.test(y)?c.URI.parse(y):c.URI.file((0,O.normalize)(y)))}get extensionDevelopmentKind(){return this.args.extensionDevelopmentKind?.map(m=>m==="ui"||m==="workspace"||m==="web"?m:"workspace")}get extensionTestsLocationURI(){const m=this.args.extensionTestsPath;if(m)return/^[^:/?#]+?:\/\//.test(m)?c.URI.parse(m):c.URI.file((0,O.normalize)(m))}get disableExtensions(){if(this.args["disable-extensions"])return!0;const m=this.args["disable-extension"];if(m){if(typeof m=="string")return[m];if(Array.isArray(m)&&m.length>0)return m}return!1}get debugExtensionHost(){return C(this.args,this.isBuilt)}get debugRenderer(){return!!this.args.debugRenderer}get isBuilt(){return!A.env.VSCODE_DEV}get verbose(){return!!this.args.verbose}get logLevel(){return this.args.log}get serviceMachineIdResource(){return(0,p.joinPath)(c.URI.file(this.userDataPath),"machineid")}get crashReporterId(){return this.args["crash-reporter-id"]}get crashReporterDirectory(){return this.args["crash-reporter-directory"]}get telemetryLogResource(){return c.URI.file((0,O.join)(this.logsPath,"telemetry.log"))}get disableTelemetry(){return!!this.args["disable-telemetry"]}get disableWorkspaceTrust(){return!!this.args["disable-workspace-trust"]}get policyFile(){if(this.args["__enable-file-policy"]){const m=A.env.VSCODE_PORTABLE;return m?c.URI.file((0,O.join)(m,"policy.json")):(0,p.joinPath)(this.userHome,this.productService.dataFolderName,"policy.json")}}get args(){return this._args}}fe([b.memoize],d.prototype,"appRoot",null),fe([b.memoize],d.prototype,"userHome",null),fe([b.memoize],d.prototype,"userDataPath",null),fe([b.memoize],d.prototype,"appSettingsHome",null),fe([b.memoize],d.prototype,"tmpDir",null),fe([b.memoize],d.prototype,"cacheHome",null),fe([b.memoize],d.prototype,"stateResource",null),fe([b.memoize],d.prototype,"userRoamingDataHome",null),fe([b.memoize],d.prototype,"userDataSyncHome",null),fe([b.memoize],d.prototype,"userDataSyncLogResource",null),fe([b.memoize],d.prototype,"editSessionsLogResource",null),fe([b.memoize],d.prototype,"sync",null),fe([b.memoize],d.prototype,"machineSettingsResource",null),fe([b.memoize],d.prototype,"workspaceStorageHome",null),fe([b.memoize],d.prototype,"localHistoryHome",null),fe([b.memoize],d.prototype,"keyboardLayoutResource",null),fe([b.memoize],d.prototype,"argvResource",null),fe([b.memoize],d.prototype,"isExtensionDevelopment",null),fe([b.memoize],d.prototype,"untitledWorkspacesHome",null),fe([b.memoize],d.prototype,"installSourcePath",null),fe([b.memoize],d.prototype,"builtinExtensionsPath",null),fe([b.memoize],d.prototype,"extensionsPath",null),fe([b.memoize],d.prototype,"extensionDevelopmentLocationURI",null),fe([b.memoize],d.prototype,"extensionDevelopmentKind",null),fe([b.memoize],d.prototype,"extensionTestsLocationURI",null),fe([b.memoize],d.prototype,"debugExtensionHost",null),fe([b.memoize],d.prototype,"serviceMachineIdResource",null),fe([b.memoize],d.prototype,"telemetryLogResource",null),fe([b.memoize],d.prototype,"disableWorkspaceTrust",null),fe([b.memoize],d.prototype,"policyFile",null),t.AbstractNativeEnvironmentService=d;function C(f,m){return v(f["inspect-extensions"],f["inspect-brk-extensions"],5870,m,f.debugId,f.extensionEnvironment)}t.parseExtensionHostPort=C;function P(f,m){return v(f["inspect-search"],f["inspect-brk-search"],5876,m,f.extensionEnvironment)}t.parseSearchPort=P;function h(f,m){return v(f["inspect-ptyhost"],f["inspect-brk-ptyhost"],5877,m,f.extensionEnvironment)}t.parsePtyHostPort=h;function v(f,m,y,l,u,g){const s=Number(m||f)||(l?null:y),i=s?Boolean(!!m):!1;let n;if(g)try{n=JSON.parse(g)}catch{}return{port:s,break:i,debugId:u,env:n}}}),function(){"use strict";function $(t,I,b,w){function O(p){const c=A(p),d=[c];return t.isAbsolute(c)||d.unshift(w),t.resolve(...d)}function A(p){const c=process.env.VSCODE_PORTABLE;if(c)return t.join(c,"user-data");let d=process.env.VSCODE_APPDATA;if(d)return t.join(d,b);const C=p["user-data-dir"];if(C)return C;switch(process.platform){case"win32":if(d=process.env.APPDATA,!d){const P=process.env.USERPROFILE;if(typeof P!="string")throw new Error("Windows: Unexpected undefined %USERPROFILE% environment variable");d=t.join(P,"AppData","Roaming")}break;case"darwin":d=t.join(I.homedir(),"Library","Application Support");break;case"linux":d=process.env.XDG_CONFIG_HOME||t.join(I.homedir(),".config");break;default:throw new Error("Platform not supported")}return t.join(d,b)}return{getUserDataPath:O}}if(typeof define=="function")define(Z[99],ee([0,147,38,16,17,32]),function(t,I,b,w,O,A){const p=O.dirname(w.FileAccess.asFileUri("",t)),c=t.__$__nodeRequire(O.joinPath(p,"package.json").fsPath);return $(I,b,c.name,A.cwd())});else if(typeof module=="object"&&typeof module.exports=="object"){const t=require("../../../../../package.json"),I=require("path"),b=require("os");module.exports=$(I,b,t.name,process.env.VSCODE_CWD||process.cwd())}else throw new Error("Unknown context")}(),define(Z[100],ee([0,1,38,98,99]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeEnvironmentService=void 0;class O extends b.AbstractNativeEnvironmentService{constructor(p,c){super(p,{homeDir:(0,I.homedir)(),tmpDir:(0,I.tmpdir)(),userDataDir:(0,w.getUserDataPath)(p)},c)}}t.NativeEnvironmentService=O}),define(Z[45],ee([0,1,17,54,88,39]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.isEngineValid=t.isValidExtensionVersion=t.validateExtensionManifest=t.isValidVersion=t.normalizeVersion=t.parseVersion=t.isValidVersionStr=void 0;const A=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,p=/^-(\d{4})(\d{2})(\d{2})$/;function c(l){return l=l.trim(),l==="*"||A.test(l)}t.isValidVersionStr=c;function d(l){if(!c(l))return null;if(l=l.trim(),l==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const u=l.match(A);return u?{hasCaret:u[1]==="^",hasGreaterEquals:u[1]===">=",majorBase:u[2]==="x"?0:parseInt(u[2],10),majorMustEqual:u[2]!=="x",minorBase:u[4]==="x"?0:parseInt(u[4],10),minorMustEqual:u[4]!=="x",patchBase:u[6]==="x"?0:parseInt(u[6],10),patchMustEqual:u[6]!=="x",preRelease:u[8]||null}:null}t.parseVersion=d;function C(l){if(!l)return null;const u=l.majorBase,g=l.majorMustEqual,a=l.minorBase;let s=l.minorMustEqual;const i=l.patchBase;let n=l.patchMustEqual;l.hasCaret&&(u===0||(s=!1),n=!1);let e=0;if(l.preRelease){const r=p.exec(l.preRelease);if(r){const[,o,S,E]=r;e=Date.UTC(Number(o),Number(S)-1,Number(E))}}return{majorBase:u,majorMustEqual:g,minorBase:a,minorMustEqual:s,patchBase:i,patchMustEqual:n,isMinimum:l.hasGreaterEquals,notBefore:e}}t.normalizeVersion=C;function P(l,u,g){let a;typeof l=="string"?a=C(d(l)):a=l;let s;u instanceof Date?s=u.getTime():typeof u=="string"&&(s=new Date(u).getTime());let i;if(typeof g=="string"?i=C(d(g)):i=g,!a||!i)return!1;const n=a.majorBase,e=a.minorBase,r=a.patchBase;let o=i.majorBase,S=i.minorBase,E=i.patchBase;const D=i.notBefore;let k=i.majorMustEqual,V=i.minorMustEqual,_=i.patchMustEqual;return i.isMinimum?n>o?!0:n<o?!1:e>S?!0:e<S||s&&s<D?!1:r>=E:(n===1&&o===0&&(!k||!V||!_)&&(o=1,S=0,E=0,k=!0,V=!1,_=!1),n<o?!1:n>o?!k:e<S?!1:e>S?!V:r<E?!1:r>E?!_:!(s&&s<D))}t.isValidVersion=P;function h(l,u,g,a,s){const i=[];if(typeof a.publisher!="undefined"&&typeof a.publisher!="string")return i.push([b.default.Error,w.localize(0,null)]),i;if(typeof a.name!="string")return i.push([b.default.Error,w.localize(1,null,"name")]),i;if(typeof a.version!="string")return i.push([b.default.Error,w.localize(2,null,"version")]),i;if(!a.engines)return i.push([b.default.Error,w.localize(3,null,"engines")]),i;if(typeof a.engines.vscode!="string")return i.push([b.default.Error,w.localize(4,null,"engines.vscode")]),i;if(typeof a.extensionDependencies!="undefined"&&!y(a.extensionDependencies))return i.push([b.default.Error,w.localize(5,null,"extensionDependencies")]),i;if(typeof a.activationEvents!="undefined"){if(!y(a.activationEvents))return i.push([b.default.Error,w.localize(6,null,"activationEvents")]),i;if(typeof a.main=="undefined"&&typeof a.browser=="undefined")return i.push([b.default.Error,w.localize(7,null,"activationEvents","main")]),i}if(typeof a.extensionKind!="undefined"&&typeof a.main=="undefined"&&i.push([b.default.Warning,w.localize(8,null,"extensionKind")]),typeof a.main!="undefined"){if(typeof a.main!="string")return i.push([b.default.Error,w.localize(9,null,"main")]),i;{const r=(0,I.joinPath)(g,a.main);(0,I.isEqualOrParent)(r,g)||i.push([b.default.Warning,w.localize(10,null,r.path,g.path)])}if(typeof a.activationEvents=="undefined")return i.push([b.default.Error,w.localize(11,null,"activationEvents","main")]),i}if(typeof a.browser!="undefined"){if(typeof a.browser!="string")return i.push([b.default.Error,w.localize(12,null,"browser")]),i;{const r=(0,I.joinPath)(g,a.browser);(0,I.isEqualOrParent)(r,g)||i.push([b.default.Warning,w.localize(13,null,r.path,g.path)])}if(typeof a.activationEvents=="undefined")return i.push([b.default.Error,w.localize(14,null,"activationEvents","browser")]),i}if(!O.valid(a.version))return i.push([b.default.Error,w.localize(15,null)]),i;const n=[];if(!v(l,u,a,s,n))for(const r of n)i.push([b.default.Error,r]);return i}t.validateExtensionManifest=h;function v(l,u,g,a,s){return a||typeof g.main=="undefined"&&typeof g.browser=="undefined"?!0:m(l,u,g.engines.vscode,s)}t.isValidExtensionVersion=v;function f(l,u,g){return l==="*"||m(u,g,l)}t.isEngineValid=f;function m(l,u,g,a=[]){const s=C(d(g));if(!s)return a.push(w.localize(16,null,g)),!1;if(s.majorBase===0){if(!s.majorMustEqual||!s.minorMustEqual)return a.push(w.localize(17,null,g)),!1}else if(!s.majorMustEqual)return a.push(w.localize(18,null,g)),!1;return P(l,u,s)?!0:(a.push(w.localize(19,null,l,g)),!1)}function y(l){if(!Array.isArray(l))return!1;for(let u=0,g=l.length;u<g;u++)if(typeof l[u]!="string")return!1;return!0}}),define(Z[101],ee([0,1,15,29]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getServiceMachineId=void 0;async function w(O,A,p){let c=p&&p.get("storage.serviceMachineId",-1)||null;if(c)return c;try{const C=(await A.readFile(O.serviceMachineIdResource)).value.toString();c=(0,b.isUUID)(C)?C:null}catch{c=null}if(!c){c=(0,b.generateUuid)();try{await A.writeFile(O.serviceMachineIdResource,I.VSBuffer.fromString(c))}catch{}}return p?.store("storage.serviceMachineId",c,-1,1),c}t.getServiceMachineId=w}),define(Z[46],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SyncDescriptor=void 0;class I{constructor(w,O=[],A=!1){this.ctor=w,this.staticArguments=O,this.supportsDelayedInstantiation=A}}t.SyncDescriptor=I}),define(Z[102],ee([0,1,46]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getSingletonServiceDescriptors=t.registerSingleton=void 0;const b=[];function w(A,p,c){p instanceof I.SyncDescriptor||(p=new I.SyncDescriptor(p,[],c)),b.push([A,p])}t.registerSingleton=w;function O(){return b}t.getSingletonServiceDescriptors=O}),define(Z[103],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Graph=t.Node=void 0;class I{constructor(O){this.incoming=new Map,this.outgoing=new Map,this.data=O}}t.Node=I;class b{constructor(O){this._hashFn=O,this._nodes=new Map}roots(){const O=[];for(const A of this._nodes.values())A.outgoing.size===0&&O.push(A);return O}insertEdge(O,A){const p=this.lookupOrInsertNode(O),c=this.lookupOrInsertNode(A);p.outgoing.set(this._hashFn(A),c),c.incoming.set(this._hashFn(O),p)}removeNode(O){const A=this._hashFn(O);this._nodes.delete(A);for(const p of this._nodes.values())p.outgoing.delete(A),p.incoming.delete(A)}lookupOrInsertNode(O){const A=this._hashFn(O);let p=this._nodes.get(A);return p||(p=new I(O),this._nodes.set(A,p)),p}lookup(O){return this._nodes.get(this._hashFn(O))}isEmpty(){return this._nodes.size===0}toString(){const O=[];for(const[A,p]of this._nodes)O.push(`${A}, (incoming)[${[...p.incoming.keys()].join(", ")}], (outgoing)[${[...p.outgoing.keys()].join(",")}]`);return O.join(`
`)}findCycleSlow(){for(const[O,A]of this._nodes){const p=new Set([O]),c=this._findCycle(A,p);if(c)return c}}_findCycle(O,A){for(const[p,c]of O.outgoing){if(A.has(p))return[...A,p].join(" -> ");A.add(p);const d=this._findCycle(c,A);if(d)return d;A.delete(p)}}}t.Graph=b}),define(Z[21],ee([0,1,5,10,8]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getLanguageTagSettingPlainKey=t.getMigratedSettingValue=t.merge=t.getConfigurationValue=t.removeFromValueTree=t.addToValueTree=t.toValuesTree=t.ConfigurationTargetToString=t.ConfigurationTarget=t.isConfigurationUpdateOverrides=t.isConfigurationOverrides=t.IConfigurationService=void 0,t.IConfigurationService=(0,w.createDecorator)("configurationService");function O(l){return l&&typeof l=="object"&&(!l.overrideIdentifier||typeof l.overrideIdentifier=="string")&&(!l.resource||l.resource instanceof b.URI)}t.isConfigurationOverrides=O;function A(l){return l&&typeof l=="object"&&(!l.overrideIdentifiers||Array.isArray(l.overrideIdentifiers))&&!l.overrideIdentifier&&(!l.resource||l.resource instanceof b.URI)}t.isConfigurationUpdateOverrides=A;var p;(function(l){l[l.APPLICATION=1]="APPLICATION",l[l.USER=2]="USER",l[l.USER_LOCAL=3]="USER_LOCAL",l[l.USER_REMOTE=4]="USER_REMOTE",l[l.WORKSPACE=5]="WORKSPACE",l[l.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",l[l.DEFAULT=7]="DEFAULT",l[l.MEMORY=8]="MEMORY"})(p=t.ConfigurationTarget||(t.ConfigurationTarget={}));function c(l){switch(l){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}t.ConfigurationTargetToString=c;function d(l,u){const g=Object.create(null);for(const a in l)C(g,a,l[a],u);return g}t.toValuesTree=d;function C(l,u,g,a){const s=u.split("."),i=s.pop();let n=l;for(let e=0;e<s.length;e++){const r=s[e];let o=n[r];switch(typeof o){case"undefined":o=n[r]=Object.create(null);break;case"object":break;default:a(`Ignoring ${u} as ${s.slice(0,e+1).join(".")} is ${JSON.stringify(o)}`);return}n=o}if(typeof n=="object"&&n!==null)try{n[i]=g}catch{a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}else a(`Ignoring ${u} as ${s.join(".")} is ${JSON.stringify(n)}`)}t.addToValueTree=C;function P(l,u){const g=u.split(".");h(l,g)}t.removeFromValueTree=P;function h(l,u){const g=u.shift();if(u.length===0){delete l[g];return}if(Object.keys(l).indexOf(g)!==-1){const a=l[g];typeof a=="object"&&!Array.isArray(a)&&(h(a,u),Object.keys(a).length===0&&delete l[g])}}function v(l,u,g){function a(n,e){let r=n;for(const o of e){if(typeof r!="object"||r===null)return;r=r[o]}return r}const s=u.split("."),i=a(l,s);return typeof i=="undefined"?g:i}t.getConfigurationValue=v;function f(l,u,g){Object.keys(u).forEach(a=>{a!=="__proto__"&&(a in l?I.isObject(l[a])&&I.isObject(u[a])?f(l[a],u[a],g):g&&(l[a]=u[a]):l[a]=u[a])})}t.merge=f;function m(l,u,g){const a=l.inspect(u),s=l.inspect(g);return typeof a.userValue!="undefined"||typeof a.workspaceValue!="undefined"||typeof a.workspaceFolderValue!="undefined"?a.value:typeof s.userValue!="undefined"||typeof s.workspaceValue!="undefined"||typeof s.workspaceFolderValue!="undefined"?s.value:a.defaultValue}t.getMigratedSettingValue=m;function y(l){return l.replace(/[\[\]]/g,"")}t.getLanguageTagSettingPlainKey=y}),define(Z[58],ee([0,1,8]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDownloadService=void 0,t.IDownloadService=(0,I.createDecorator)("downloadService")}),define(Z[18],ee([0,1,8]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.INativeEnvironmentService=t.IEnvironmentService=void 0,t.IEnvironmentService=(0,I.createDecorator)("environmentService"),t.INativeEnvironmentService=(0,I.refineServiceDecorator)(t.IEnvironmentService)}),define(Z[22],ee([0,1,83,8]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IDefaultExtensionsProfileInitService=t.IExtensionManagementCLIService=t.PreferencesLocalizedLabel=t.PreferencesLabel=t.ExtensionsChannelId=t.ExtensionsLocalizedLabel=t.ExtensionsLabel=t.IExtensionTipsService=t.IGlobalExtensionEnablementService=t.ENABLED_EXTENSIONS_STORAGE_PATH=t.DISABLED_EXTENSIONS_STORAGE_PATH=t.IServerExtensionManagementService=t.IExtensionManagementService=t.ExtensionManagementError=t.ExtensionManagementErrorCode=t.IExtensionGalleryService=t.InstallOperation=t.StatisticType=t.SortOrder=t.SortBy=t.isIExtensionIdentifier=t.getFallbackTargetPlarforms=t.isTargetPlatformCompatible=t.isNotWebExtensionInWebTargetPlatform=t.getTargetPlatform=t.toTargetPlatform=t.TargetPlatformToString=t.WEB_EXTENSION_TAG=t.EXTENSION_IDENTIFIER_REGEX=t.EXTENSION_IDENTIFIER_PATTERN=void 0,t.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",t.EXTENSION_IDENTIFIER_REGEX=new RegExp(t.EXTENSION_IDENTIFIER_PATTERN),t.WEB_EXTENSION_TAG="__web_extension";function w(l){switch(l){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}t.TargetPlatformToString=w;function O(l){switch(l){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}t.toTargetPlatform=O;function A(l,u){switch(l){case 3:return u==="x64"?"win32-x64":u==="ia32"?"win32-ia32":u==="arm64"?"win32-arm64":"unknown";case 2:return u==="x64"?"linux-x64":u==="arm64"?"linux-arm64":u==="arm"?"linux-armhf":"unknown";case"alpine":return u==="x64"?"alpine-x64":u==="arm64"?"alpine-arm64":"unknown";case 1:return u==="x64"?"darwin-x64":u==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}t.getTargetPlatform=A;function p(l,u){return u==="web"&&!l.includes("web")}t.isNotWebExtensionInWebTargetPlatform=p;function c(l,u,g){return p(u,g)?!1:l==="undefined"||l==="universal"?!0:l==="unknown"?!1:l===g?!0:d(g).includes(l)}t.isTargetPlatformCompatible=c;function d(l){switch(l){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}t.getFallbackTargetPlarforms=d;function C(l){return l&&typeof l=="object"&&typeof l.id=="string"&&(!l.uuid||typeof l.uuid=="string")}t.isIExtensionIdentifier=C;var P;(function(l){l[l.NoneOrRelevance=0]="NoneOrRelevance",l[l.LastUpdatedDate=1]="LastUpdatedDate",l[l.Title=2]="Title",l[l.PublisherName=3]="PublisherName",l[l.InstallCount=4]="InstallCount",l[l.PublishedDate=10]="PublishedDate",l[l.AverageRating=6]="AverageRating",l[l.WeightedRating=12]="WeightedRating"})(P=t.SortBy||(t.SortBy={}));var h;(function(l){l[l.Default=0]="Default",l[l.Ascending=1]="Ascending",l[l.Descending=2]="Descending"})(h=t.SortOrder||(t.SortOrder={}));var v;(function(l){l.Install="install",l.Uninstall="uninstall"})(v=t.StatisticType||(t.StatisticType={}));var f;(function(l){l[l.None=1]="None",l[l.Install=2]="Install",l[l.Update=3]="Update",l[l.Migrate=4]="Migrate"})(f=t.InstallOperation||(t.InstallOperation={})),t.IExtensionGalleryService=(0,b.createDecorator)("extensionGalleryService");var m;(function(l){l.Unsupported="Unsupported",l.Deprecated="Deprecated",l.Malicious="Malicious",l.Incompatible="Incompatible",l.IncompatiblePreRelease="IncompatiblePreRelease",l.IncompatibleTargetPlatform="IncompatibleTargetPlatform",l.ReleaseVersionNotFound="ReleaseVersionNotFound",l.Invalid="Invalid",l.Download="Download",l.Extract="Extract",l.Delete="Delete",l.Rename="Rename",l.CorruptZip="CorruptZip",l.IncompleteZip="IncompleteZip",l.Internal="Internal"})(m=t.ExtensionManagementErrorCode||(t.ExtensionManagementErrorCode={}));class y extends Error{constructor(u,g){super(u);this.code=g,this.name=g}}t.ExtensionManagementError=y,t.IExtensionManagementService=(0,b.createDecorator)("extensionManagementService"),t.IServerExtensionManagementService=(0,b.refineServiceDecorator)(t.IExtensionManagementService),t.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",t.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",t.IGlobalExtensionEnablementService=(0,b.createDecorator)("IGlobalExtensionEnablementService"),t.IExtensionTipsService=(0,b.createDecorator)("IExtensionTipsService"),t.ExtensionsLabel=(0,I.localize)(0,null),t.ExtensionsLocalizedLabel={value:t.ExtensionsLabel,original:"Extensions"},t.ExtensionsChannelId="extensions",t.PreferencesLabel=(0,I.localize)(1,null),t.PreferencesLocalizedLabel={value:t.PreferencesLabel,original:"Preferences"},t.IExtensionManagementCLIService=(0,b.createDecorator)("IExtensionManagementCLIService"),t.IDefaultExtensionsProfileInitService=(0,b.createDecorator)("IDefaultExtensionsProfileInitService")}),define(Z[59],ee([0,1,15,12,90,11]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.readFileIntoStream=void 0;async function A(C,P,h,v,f,m){let y;try{await p(C,P,h,v,f,m)}catch(l){y=l}finally{y&&f.errorTransformer&&(y=f.errorTransformer(y)),typeof y!="undefined"&&h.error(y),h.end()}}t.readFileIntoStream=A;async function p(C,P,h,v,f,m){c(m);const y=await C.open(P,{create:!1});try{c(m);let l=0,u=0,g=f&&typeof f.length=="number"?f.length:void 0,a=I.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),s=f&&typeof f.position=="number"?f.position:0,i=0;do u=await C.read(y,s,a.buffer,i,a.byteLength-i),s+=u,i+=u,l+=u,typeof g=="number"&&(g-=u),i===a.byteLength&&(await h.write(v(a)),a=I.VSBuffer.alloc(Math.min(f.bufferSize,typeof g=="number"?g:f.bufferSize)),i=0);while(u>0&&(typeof g!="number"||g>0)&&c(m)&&d(l,f));if(i>0){let n=i;typeof g=="number"&&(n=Math.min(i,g)),h.write(v(a.slice(0,n)))}}catch(l){throw(0,O.ensureFileSystemProviderError)(l)}finally{await C.close(y)}}function c(C){if(C.isCancellationRequested)throw(0,b.canceled)();return!0}function d(C,P){if(P?.limits){if(typeof P.limits.memory=="number"&&C>P.limits.memory)throw(0,O.createFileSystemProviderError)((0,w.localize)(0,null),O.FileSystemProviderErrorCode.FileExceedsMemoryLimit);if(typeof P.limits.size=="number"&&C>P.limits.size)throw(0,O.createFileSystemProviderError)((0,w.localize)(1,null),O.FileSystemProviderErrorCode.FileTooLarge)}return!0}}),define(Z[104],ee([0,1,4,148,2,13,149]),function($,t,I,b,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcher=void 0;class p extends w.Disposable{constructor(){super(...arguments);this._onDidChangeFile=this._register(new I.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidLogMessage=this._register(new I.Emitter),this.onDidLogMessage=this._onDidLogMessage.event,this.onDidError=I.Event.None,this.watchers=new Map,this.verboseLogging=!1}async watch(d){const C=this.normalizeRequests(d),P=C.filter(v=>{const f=this.watchers.get(v.path);return f?!(0,b.patternsEquals)(f.request.excludes,v.excludes)||!(0,b.patternsEquals)(f.request.includes,v.includes):!0}),h=Array.from(this.watchers.values()).filter(({request:v})=>!C.find(f=>f.path===v.path&&(0,b.patternsEquals)(f.excludes,v.excludes)&&(0,b.patternsEquals)(f.includes,v.includes))).map(({request:v})=>v.path);P.length&&this.trace(`Request to start watching: ${P.map(v=>`${v.path} (excludes: ${v.excludes.length>0?v.excludes:"<none>"}, includes: ${v.includes&&v.includes.length>0?JSON.stringify(v.includes):"<all>"})`).join(",")}`),h.length&&this.trace(`Request to stop watching: ${h.join(",")}`);for(const v of h)this.stopWatching(v);for(const v of P)this.startWatching(v)}startWatching(d){const C=new A.NodeJSFileWatcherLibrary(d,h=>this._onDidChangeFile.fire(h),h=>this._onDidLogMessage.fire(h),this.verboseLogging),P={request:d,instance:C};this.watchers.set(d.path,P)}async stop(){for(const[d]of this.watchers)this.stopWatching(d);this.watchers.clear()}stopWatching(d){const C=this.watchers.get(d);C&&(this.watchers.delete(d),C.instance.dispose())}normalizeRequests(d){const C=new Map;for(const P of d){const h=O.isLinux?P.path:P.path.toLowerCase();C.set(h,P)}return Array.from(C.values())}async setVerboseLogging(d){this.verboseLogging=d;for(const[,C]of this.watchers)C.instance.setVerboseLogging(d)}trace(d){this.verboseLogging&&this._onDidLogMessage.fire({type:"trace",message:this.toMessage(d)})}toMessage(d,C){return C?`[File Watcher (node.js)] ${d} (path: ${C.request.path})`:`[File Watcher (node.js)] ${d}`}}t.NodeJSWatcher=p}),define(Z[105],ee([0,1,60,104]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NodeJSWatcherClient=void 0;class w extends I.AbstractNonRecursiveWatcherClient{constructor(A,p,c){super(A,p,c);this.init()}createWatcher(){return new b.NodeJSWatcher}}t.NodeJSWatcherClient=w}),define(Z[106],ee([0,1,16,56,78,60]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UniversalWatcherClient=void 0;class A extends O.AbstractUniversalWatcherClient{constructor(c,d,C){super(c,d,C);this.init()}createWatcher(c){const d=c.add(new w.Client(I.FileAccess.asFileUri("bootstrap-fork",$).fsPath,{serverName:"File Watcher",args:["--type=fileWatcher"],env:{VSCODE_AMD_ENTRYPOINT:"vs/platform/files/node/watcher/watcherMain",VSCODE_PIPE_LOGGING:"true",VSCODE_VERBOSE_LOGGING:"true"}}));return c.add(d.onDidProcessExit(({code:C,signal:P})=>this.onError(`terminated by itself with code ${C}, signal: ${P}`))),b.ProxyChannel.toService((0,b.getNextTickChannel)(d.getChannel("watcher")))}}t.UniversalWatcherClient=A}),define(Z[61],ee([0,1]),function($,t){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ServiceCollection=void 0;class I{constructor(...w){this._entries=new Map;for(const[O,A]of w)this.set(O,A)}set(w,O){const A=this._entries.get(w);return this._entries.set(w,O),A}has(w){return this._entries.has(w)}get(w){return this._entries.get(w)}}t.ServiceCollection=I}),define(Z[107],ee([0,1,3,12,46,103,8,61]),function($,t,I,b,w,O,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Trace=t.InstantiationService=void 0;const c=!1;class d extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class C{constructor(f=new p.ServiceCollection,m=!1,y){this._activeInstantiations=new Set,this._services=f,this._strict=m,this._parent=y,this._services.set(A.IInstantiationService,this)}createChild(f){return new C(f,this._strict,this)}invokeFunction(f,...m){const y=h.traceInvocation(f);let l=!1;try{return f({get:g=>{if(l)throw(0,b.illegalState)("service accessor is only valid during the invocation of its target method");const a=this._getOrCreateServiceInstance(g,y);if(!a)throw new Error(`[invokeFunction] unknown service '${g}'`);return a}},...m)}finally{l=!0,y.stop()}}createInstance(f,...m){let y,l;return f instanceof w.SyncDescriptor?(y=h.traceCreation(f.ctor),l=this._createInstance(f.ctor,f.staticArguments.concat(m),y)):(y=h.traceCreation(f),l=this._createInstance(f,m,y)),y.stop(),l}_createInstance(f,m=[],y){const l=A._util.getServiceDependencies(f).sort((a,s)=>a.index-s.index),u=[];for(const a of l){const s=this._getOrCreateServiceInstance(a.id,y);s||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${a.id}.`,!1),u.push(s)}const g=l.length>0?l[0].index:m.length;if(m.length!==g){console.trace(`[createInstance] First service dependency of ${f.name} at position ${g+1} conflicts with ${m.length} static arguments`);const a=g-m.length;a>0?m=m.concat(new Array(a)):m=m.slice(0,g)}return new f(...[...m,...u])}_setServiceInstance(f,m){if(this._services.get(f)instanceof w.SyncDescriptor)this._services.set(f,m);else if(this._parent)this._parent._setServiceInstance(f,m);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const m=this._services.get(f);return!m&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):m}_getOrCreateServiceInstance(f,m){const y=this._getServiceInstanceOrDescriptor(f);return y instanceof w.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,y,m.branch(f,!0)):(m.branch(f,!1),y)}_safeCreateAndCacheServiceInstance(f,m,y){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,m,y)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,m,y){const l=new O.Graph(a=>a.id.toString());let u=0;const g=[{id:f,desc:m,_trace:y}];for(;g.length;){const a=g.pop();if(l.lookupOrInsertNode(a),u++>1e3)throw new d(l);for(const s of A._util.getServiceDependencies(a.desc.ctor)){const i=this._getServiceInstanceOrDescriptor(s.id);if(i||this._throwIfStrict(`[createInstance] ${f} depends on ${s.id} which is NOT registered.`,!0),i instanceof w.SyncDescriptor){const n={id:s.id,desc:i,_trace:a._trace.branch(s.id,!0)};l.insertEdge(a,n),g.push(n)}}}for(;;){const a=l.roots();if(a.length===0){if(!l.isEmpty())throw new d(l);break}for(const{data:s}of a){if(this._getServiceInstanceOrDescriptor(s.id)instanceof w.SyncDescriptor){const n=this._createServiceInstanceWithOwner(s.id,s.desc.ctor,s.desc.staticArguments,s.desc.supportsDelayedInstantiation,s._trace);this._setServiceInstance(s.id,n)}l.removeNode(s)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,m,y=[],l,u){if(this._services.get(f)instanceof w.SyncDescriptor)return this._createServiceInstance(m,y,l,u);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,m,y,l,u);throw new Error(`illegalState - creating UNKNOWN service instance ${m.name}`)}_createServiceInstance(f,m=[],y,l){if(y){const u=new I.IdleValue(()=>this._createInstance(f,m,l));return new Proxy(Object.create(null),{get(g,a){if(a in g)return g[a];const s=u.value;let i=s[a];return typeof i!="function"||(i=i.bind(s),g[a]=i),i},set(g,a,s){return u.value[a]=s,!0}})}else return this._createInstance(f,m,l)}_throwIfStrict(f,m){if(m&&console.warn(f),this._strict)throw new Error(f)}}t.InstantiationService=C;var P;(function(v){v[v.Creation=0]="Creation",v[v.Invocation=1]="Invocation",v[v.Branch=2]="Branch"})(P||(P={}));class h{constructor(f,m){this.type=f,this.name=m,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return c?new h(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):h._None}static traceCreation(f){return c?new h(0,f.name):h._None}branch(f,m){const y=new h(2,f.toString());return this._dep.push([f,m,y]),y}stop(){const f=Date.now()-this._start;h._totals+=f;let m=!1;function y(u,g){const a=[],s=new Array(u+1).join("	");for(const[i,n,e]of g._dep)if(n&&e){m=!0,a.push(`${s}CREATES -> ${i}`);const r=y(u+1,e);r&&a.push(r)}else a.push(`${s}uses -> ${i}`);return a.join(`
`)}const l=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${y(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${h._totals.toFixed(2)}ms)`];(f>2||m)&&console.log(l.join(`
`))}}t.Trace=h,h._None=new class extends h{constructor(){super(-1,null)}stop(){}branch(){return this}},h._totals=0});var te=this&&this.__param||function($,t){return function(I,b){t(I,b,$)}};define(Z[62],ee([0,1,24,2,13,92,22,8]),function($,t,I,b,w,O,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LanguagePackBaseService=t.ILanguagePackService=void 0,t.ILanguagePackService=(0,p.createDecorator)("languagePackService");let c=class extends b.Disposable{constructor(C){super();this.extensionGalleryService=C}async getAvailableLanguages(){const C=new I.CancellationTokenSource;setTimeout(()=>C.cancel(),1e3);let P;try{P=await this.extensionGalleryService.query({text:'category:"language packs"',pageSize:20},C.token)}catch{return[]}const v=P.firstPage.filter(f=>f.properties.localizedLanguages?.length&&f.tags.some(m=>m.startsWith("lp-"))).map(f=>{const m=f.properties.localizedLanguages?.[0],y=this.getLocale(f);return{...this.createQuickPickItem(y,m,f),extensionId:f.identifier.id,galleryExtension:f}});return v.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),v}getLocale(C){return C.tags.find(P=>P.startsWith("lp-"))?.split("lp-")[1]}createQuickPickItem(C,P,h){const v=P??C;let f;if(v!==C&&(f=`(${C})`),C.toLowerCase()===w.language.toLowerCase()&&(f??(f=""),f+=(0,O.localize)(0,null)),h?.installCount){f??(f="");const m=h.installCount;let y;m>1e6?y=`${Math.floor(m/1e5)/10}M`:m>1e3?y=`${Math.floor(m/1e3)}K`:y=String(m),f+=` $(cloud-download) ${y}`}return{id:C,label:v,description:f}}};c=fe([te(0,A.IExtensionGalleryService)],c),t.LanguagePackBaseService=c}),define(Z[9],ee([0,1,30,4,2,13,8]),function($,t,I,b,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.LogLevelToString=t.parseLogLevel=t.getLogLevel=t.NullLogService=t.AbstractLoggerService=t.LogService=t.MultiplexLogService=t.AdapterLogger=t.ConsoleLogger=t.ConsoleMainLogger=t.AbstractMessageLogger=t.AbstractLogger=t.format=t.log=t.DEFAULT_LOG_LEVEL=t.LogLevel=t.ILoggerService=t.ILogService=void 0,t.ILogService=(0,A.createDecorator)("logService"),t.ILoggerService=(0,A.createDecorator)("loggerService");function p(){return new Date().toISOString()}var c;(function(n){n[n.Trace=0]="Trace",n[n.Debug=1]="Debug",n[n.Info=2]="Info",n[n.Warning=3]="Warning",n[n.Error=4]="Error",n[n.Critical=5]="Critical",n[n.Off=6]="Off"})(c=t.LogLevel||(t.LogLevel={})),t.DEFAULT_LOG_LEVEL=c.Info;function d(n,e,r){switch(e){case c.Trace:n.trace(r);break;case c.Debug:n.debug(r);break;case c.Info:n.info(r);break;case c.Warning:n.warn(r);break;case c.Error:n.error(r);break;case c.Critical:n.critical(r);break;default:throw new Error("Invalid log level")}}t.log=d;function C(n){let e="";for(let r=0;r<n.length;r++){let o=n[r];if(typeof o=="object")try{o=JSON.stringify(o)}catch{}e+=(r>0?" ":"")+o}return e}t.format=C;class P extends w.Disposable{constructor(){super(...arguments);this.level=t.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new b.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(e){this.level!==e&&(this.level=e,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}t.AbstractLogger=P;class h extends P{constructor(e){super();this.logAlways=e}checkLogLevel(e){return this.logAlways||this.getLevel()<=e}trace(e,...r){this.checkLogLevel(c.Trace)&&this.log(c.Trace,C([e,...r]))}debug(e,...r){this.checkLogLevel(c.Debug)&&this.log(c.Debug,C([e,...r]))}info(e,...r){this.checkLogLevel(c.Info)&&this.log(c.Info,C([e,...r]))}warn(e,...r){this.checkLogLevel(c.Warning)&&this.log(c.Warning,C([e,...r]))}error(e,...r){if(this.checkLogLevel(c.Error))if(e instanceof Error){const o=Array.prototype.slice.call(arguments);o[0]=e.stack,this.log(c.Error,C(o))}else this.log(c.Error,C([e,...r]))}critical(e,...r){this.checkLogLevel(c.Critical)&&this.log(c.Critical,C([e,...r]))}flush(){}}t.AbstractMessageLogger=h;class v extends P{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e),this.useColors=!O.isWindows}trace(e,...r){this.getLevel()<=c.Trace&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}debug(e,...r){this.getLevel()<=c.Debug&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}info(e,...r){this.getLevel()<=c.Info&&(this.useColors?console.log(`[90m[main ${p()}][0m`,e,...r):console.log(`[main ${p()}]`,e,...r))}warn(e,...r){this.getLevel()<=c.Warning&&(this.useColors?console.warn(`[93m[main ${p()}][0m`,e,...r):console.warn(`[main ${p()}]`,e,...r))}error(e,...r){this.getLevel()<=c.Error&&(this.useColors?console.error(`[91m[main ${p()}][0m`,e,...r):console.error(`[main ${p()}]`,e,...r))}critical(e,...r){this.getLevel()<=c.Critical&&(this.useColors?console.error(`[90m[main ${p()}][0m`,e,...r):console.error(`[main ${p()}]`,e,...r))}dispose(){}flush(){}}t.ConsoleMainLogger=v;class f extends P{constructor(e=t.DEFAULT_LOG_LEVEL){super();this.setLevel(e)}trace(e,...r){this.getLevel()<=c.Trace&&console.log("%cTRACE","color: #888",e,...r)}debug(e,...r){this.getLevel()<=c.Debug&&console.log("%cDEBUG","background: #eee; color: #888",e,...r)}info(e,...r){this.getLevel()<=c.Info&&console.log("%c INFO","color: #33f",e,...r)}warn(e,...r){this.getLevel()<=c.Warning&&console.log("%c WARN","color: #993",e,...r)}error(e,...r){this.getLevel()<=c.Error&&console.log("%c  ERR","color: #f33",e,...r)}critical(e,...r){this.getLevel()<=c.Critical&&console.log("%cCRITI","background: #f33; color: white",e,...r)}dispose(){}flush(){}}t.ConsoleLogger=f;class m extends P{constructor(e,r=t.DEFAULT_LOG_LEVEL){super();this.adapter=e,this.setLevel(r)}trace(e,...r){this.getLevel()<=c.Trace&&this.adapter.log(c.Trace,[this.extractMessage(e),...r])}debug(e,...r){this.getLevel()<=c.Debug&&this.adapter.log(c.Debug,[this.extractMessage(e),...r])}info(e,...r){this.getLevel()<=c.Info&&this.adapter.log(c.Info,[this.extractMessage(e),...r])}warn(e,...r){this.getLevel()<=c.Warning&&this.adapter.log(c.Warning,[this.extractMessage(e),...r])}error(e,...r){this.getLevel()<=c.Error&&this.adapter.log(c.Error,[this.extractMessage(e),...r])}critical(e,...r){this.getLevel()<=c.Critical&&this.adapter.log(c.Critical,[this.extractMessage(e),...r])}extractMessage(e){return typeof e=="string"?e:(0,I.toErrorMessage)(e,this.getLevel()<=c.Trace)}dispose(){}flush(){}}t.AdapterLogger=m;class y extends P{constructor(e){super();this.logServices=e,e.length&&this.setLevel(e[0].getLevel())}setLevel(e){for(const r of this.logServices)r.setLevel(e);super.setLevel(e)}trace(e,...r){for(const o of this.logServices)o.trace(e,...r)}debug(e,...r){for(const o of this.logServices)o.debug(e,...r)}info(e,...r){for(const o of this.logServices)o.info(e,...r)}warn(e,...r){for(const o of this.logServices)o.warn(e,...r)}error(e,...r){for(const o of this.logServices)o.error(e,...r)}critical(e,...r){for(const o of this.logServices)o.critical(e,...r)}flush(){for(const e of this.logServices)e.flush()}dispose(){for(const e of this.logServices)e.dispose()}}t.MultiplexLogService=y;class l extends w.Disposable{constructor(e){super();this.logger=e,this._register(e)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(e){this.logger.setLevel(e)}getLevel(){return this.logger.getLevel()}trace(e,...r){this.logger.trace(e,...r)}debug(e,...r){this.logger.debug(e,...r)}info(e,...r){this.logger.info(e,...r)}warn(e,...r){this.logger.warn(e,...r)}error(e,...r){this.logger.error(e,...r)}critical(e,...r){this.logger.critical(e,...r)}flush(){this.logger.flush()}}t.LogService=l;class u extends w.Disposable{constructor(e,r){super();this.logLevel=e,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(r(o=>{this.logLevel=o,this.logLevelChangeableLoggers.forEach(S=>S.setLevel(o))}))}getLogger(e){return this.loggers.get(e.toString())}createLogger(e,r){let o=this.loggers.get(e.toString());return o||(o=this.doCreateLogger(e,r?.always?c.Trace:this.logLevel,r),this.loggers.set(e.toString(),o),r?.always||this.logLevelChangeableLoggers.push(o)),o}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(e=>e.dispose()),this.loggers.clear(),super.dispose()}}t.AbstractLoggerService=u;class g{constructor(){this.onDidChangeLogLevel=new b.Emitter().event}setLevel(e){}getLevel(){return c.Info}trace(e,...r){}debug(e,...r){}info(e,...r){}warn(e,...r){}error(e,...r){}critical(e,...r){}dispose(){}flush(){}}t.NullLogService=g;function a(n){if(n.verbose)return c.Trace;if(typeof n.logLevel=="string"){const e=s(n.logLevel.toLowerCase());if(e!==void 0)return e}return t.DEFAULT_LOG_LEVEL}t.getLogLevel=a;function s(n){switch(n){case"trace":return c.Trace;case"debug":return c.Debug;case"info":return c.Info;case"warn":return c.Warning;case"error":return c.Error;case"critical":return c.Critical;case"off":return c.Off}}t.parseLogLevel=s;function i(n){switch(n){case c.Trace:return"trace";case c.Debug:return"debug";case c.Info:return"info";case c.Warning:return"warn";case c.Error:return"error";case c.Critical:return"critical";case c.Off:return"off"}}t.LogLevelToString=i}),define(Z[108],ee([0,1,19,3,12,4,2,14,60,9]),function($,t,I,b,w,O,A,p,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractDiskFileSystemProvider=void 0;class C extends A.Disposable{constructor(h,v){super();this.logService=h,this.options=v,this._onDidChangeFile=this._register(new O.Emitter),this.onDidChangeFile=this._onDidChangeFile.event,this._onDidWatchError=this._register(new O.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.universalPathsToWatch=[],this.universalWatchRequestDelayer=this._register(new b.ThrottledDelayer(0)),this.nonRecursivePathsToWatch=[],this.nonRecursiveWatchRequestDelayer=this._register(new b.ThrottledDelayer(0))}watch(h,v){return v.recursive||this.options?.watcher?.forceUniversal?this.watchUniversal(h,v):this.watchNonRecursive(h,v)}watchUniversal(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:v.recursive},m=(0,I.insert)(this.universalPathsToWatch,f);return this.refreshUniversalWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshUniversalWatchers()})}refreshUniversalWatchers(){this.universalWatchRequestDelayer.trigger(()=>this.doRefreshUniversalWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshUniversalWatchers(){this.universalWatcher||(this.universalWatcher=this._register(this.createUniversalWatcher(v=>this._onDidChangeFile.fire((0,c.toFileChanges)(v)),v=>this.onWatcherLogMessage(v),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.universalWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)})));const h=this.options?.watcher?.recursive?.usePolling;if(h===!0)for(const v of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(v)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);else if(Array.isArray(h))for(const v of this.universalPathsToWatch)(0,c.isRecursiveWatchRequest)(v)&&h.includes(v.path)&&(v.pollingInterval=this.options?.watcher?.recursive?.pollingInterval??5e3);return this.universalWatcher.watch(this.universalPathsToWatch)}watchNonRecursive(h,v){const f={path:this.toFilePath(h),excludes:v.excludes,includes:v.includes,recursive:!1},m=(0,I.insert)(this.nonRecursivePathsToWatch,f);return this.refreshNonRecursiveWatchers(),(0,A.toDisposable)(()=>{m(),this.refreshNonRecursiveWatchers()})}refreshNonRecursiveWatchers(){this.nonRecursiveWatchRequestDelayer.trigger(()=>this.doRefreshNonRecursiveWatchers()).catch(h=>(0,w.onUnexpectedError)(h))}doRefreshNonRecursiveWatchers(){return this.nonRecursiveWatcher||(this.nonRecursiveWatcher=this._register(this.createNonRecursiveWatcher(h=>this._onDidChangeFile.fire((0,c.toFileChanges)(h)),h=>this.onWatcherLogMessage(h),this.logService.getLevel()===d.LogLevel.Trace)),this._register(this.logService.onDidChangeLogLevel(()=>{this.nonRecursiveWatcher?.setVerboseLogging(this.logService.getLevel()===d.LogLevel.Trace)}))),this.nonRecursiveWatcher.watch(this.nonRecursivePathsToWatch)}onWatcherLogMessage(h){h.type==="error"&&this._onDidWatchError.fire(h.message),this.logService[h.type](h.message)}toFilePath(h){return(0,p.normalize)(h.fsPath)}}t.AbstractDiskFileSystemProvider=C}),define(Z[109],ee([0,1,19,3,15,24,4,53,63,2,36,16,110,17,43,89,11,59,9]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l,u){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FileService=void 0;let g=class extends d.Disposable{constructor(s){super();this.logService=s,this.BUFFER_SIZE=256*1024,this._onDidChangeFileSystemProviderRegistrations=this._register(new A.Emitter),this.onDidChangeFileSystemProviderRegistrations=this._onDidChangeFileSystemProviderRegistrations.event,this._onWillActivateFileSystemProvider=this._register(new A.Emitter),this.onWillActivateFileSystemProvider=this._onWillActivateFileSystemProvider.event,this._onDidChangeFileSystemProviderCapabilities=this._register(new A.Emitter),this.onDidChangeFileSystemProviderCapabilities=this._onDidChangeFileSystemProviderCapabilities.event,this.provider=new Map,this._onDidRunOperation=this._register(new A.Emitter),this.onDidRunOperation=this._onDidRunOperation.event,this._onDidFilesChange=this._register(new A.Emitter),this.onDidFilesChange=this._onDidFilesChange.event,this._onDidWatchError=this._register(new A.Emitter),this.onDidWatchError=this._onDidWatchError.event,this.activeWatchers=new Map,this.writeQueue=this._register(new b.ResourceQueue)}registerProvider(s,i){if(this.provider.has(s))throw new Error(`A filesystem provider for the scheme '${s}' is already registered.`);(0,h.mark)(`code/registerFilesystem/${s}`);const n=new d.DisposableStore;return this.provider.set(s,i),this._onDidChangeFileSystemProviderRegistrations.fire({added:!0,scheme:s,provider:i}),n.add(i.onDidChangeFile(e=>this._onDidFilesChange.fire(new y.FileChangesEvent(e,!this.isPathCaseSensitive(i))))),typeof i.onDidWatchError=="function"&&n.add(i.onDidWatchError(e=>this._onDidWatchError.fire(new Error(e)))),n.add(i.onDidChangeCapabilities(()=>this._onDidChangeFileSystemProviderCapabilities.fire({provider:i,scheme:s}))),(0,d.toDisposable)(()=>{this._onDidChangeFileSystemProviderRegistrations.fire({added:!1,scheme:s,provider:i}),this.provider.delete(s),(0,d.dispose)(n)})}getProvider(s){return this.provider.get(s)}async activateProvider(s){const i=[];this._onWillActivateFileSystemProvider.fire({scheme:s,join(n){i.push(n)}}),!this.provider.has(s)&&await b.Promises.settled(i)}async canHandleResource(s){return await this.activateProvider(s.scheme),this.hasProvider(s)}hasProvider(s){return this.provider.has(s.scheme)}hasCapability(s,i){const n=this.provider.get(s.scheme);return!!(n&&n.capabilities&i)}listCapabilities(){return c.Iterable.map(this.provider,([s,i])=>({scheme:s,capabilities:i.capabilities}))}async withProvider(s){if(!(0,v.isAbsolutePath)(s))throw new y.FileOperationError((0,m.localize)(0,null,this.resourceForError(s)),8);await this.activateProvider(s.scheme);const i=this.provider.get(s.scheme);if(!i){const n=new Error;throw n.name="ENOPRO",n.message=(0,m.localize)(1,null,s.toString()),n}return i}async withReadProvider(s){const i=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i)||(0,y.hasFileReadStreamCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite, FileReadStream nor FileOpenReadWriteClose capability which is needed for the read operation.`)}async withWriteProvider(s){const i=await this.withProvider(s);if((0,y.hasOpenReadWriteCloseCapability)(i)||(0,y.hasReadWriteCapability)(i))return i;throw new Error(`Filesystem provider for scheme '${s.scheme}' neither has FileReadWrite nor FileOpenReadWriteClose capability which is needed for the write operation.`)}async resolve(s,i){try{return await this.doResolveFile(s,i)}catch(n){throw(0,y.toFileSystemProviderErrorCode)(n)===y.FileSystemProviderErrorCode.FileNotFound?new y.FileOperationError((0,m.localize)(2,null,this.resourceForError(s)),1):(0,y.ensureFileSystemProviderError)(n)}}async doResolveFile(s,i){const n=await this.withProvider(s),e=this.isPathCaseSensitive(n),r=i?.resolveTo,o=i?.resolveSingleChildDescendants,S=i?.resolveMetadata,E=await n.stat(s);let D;return this.toFileStat(n,s,E,void 0,!!S,(k,V)=>(D||(D=C.TernarySearchTree.forUris(()=>!e),D.set(s,!0),r&&D.fill(!0,r)),D.get(k.resource)||D.findSuperstr(k.resource.with({query:null,fragment:null}))?!0:k.isDirectory&&o?V===1:!1))}async toFileStat(s,i,n,e,r,o){const{providerExtUri:S}=this.getExtUri(s),E={resource:i,name:S.basename(i),isFile:(n.type&y.FileType.File)!=0,isDirectory:(n.type&y.FileType.Directory)!=0,isSymbolicLink:(n.type&y.FileType.SymbolicLink)!=0,mtime:n.mtime,ctime:n.ctime,size:n.size,readonly:Boolean((n.permissions??0)&y.FilePermission.Readonly)||Boolean(s.capabilities&2048),etag:(0,y.etag)({mtime:n.mtime,size:n.size}),children:void 0};if(E.isDirectory&&o(E,e)){try{const D=await s.readdir(i),k=await b.Promises.settled(D.map(async([V,_])=>{try{const G=S.joinPath(i,V),Q=r?await s.stat(G):{type:_};return await this.toFileStat(s,G,Q,D.length,r,o)}catch(G){return this.logService.trace(G),null}}));E.children=(0,I.coalesce)(k)}catch(D){this.logService.trace(D),E.children=[]}return E}return E}async resolveAll(s){return b.Promises.settled(s.map(async i=>{try{return{stat:await this.doResolveFile(i.resource,i.options),success:!0}}catch(n){return this.logService.trace(n),{stat:void 0,success:!1}}}))}async stat(s){const i=await this.withProvider(s),n=await i.stat(s);return this.toFileStat(i,s,n,void 0,!0,()=>!1)}async exists(s){const i=await this.withProvider(s);try{return!!await i.stat(s)}catch{return!1}}async canCreateFile(s,i){try{await this.doValidateCreateFile(s,i)}catch(n){return n}return!0}async doValidateCreateFile(s,i){if(!i?.overwrite&&await this.exists(s))throw new y.FileOperationError((0,m.localize)(3,null,this.resourceForError(s)),3,i)}async createFile(s,i=w.VSBuffer.fromString(""),n){await this.doValidateCreateFile(s,n);const e=await this.writeFile(s,i);return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,e)),e}async writeFile(s,i,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),{providerExtUri:r}=this.getExtUri(e);try{await this.validateWriteFile(e,s,n)||await this.mkdirp(e,r.dirname(s));let S;if((0,y.hasReadWriteCapability)(e)&&!(i instanceof w.VSBuffer))if((0,f.isReadableStream)(i)){const E=await(0,f.peekStream)(i,3);E.ended?S=w.VSBuffer.concat(E.buffer):S=E}else S=(0,f.peekReadable)(i,E=>w.VSBuffer.concat(E),3);else S=i;!(0,y.hasOpenReadWriteCloseCapability)(e)||(0,y.hasReadWriteCapability)(e)&&S instanceof w.VSBuffer?await this.doWriteUnbuffered(e,s,n,S):await this.doWriteBuffered(e,s,n,S instanceof w.VSBuffer?(0,w.bufferToReadable)(S):S),this._onDidRunOperation.fire(new y.FileOperationEvent(s,4))}catch(o){throw new y.FileOperationError((0,m.localize)(4,null,this.resourceForError(s),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),n)}return this.resolve(s,{resolveMetadata:!0})}async validateWriteFile(s,i,n){if(!!n?.unlock&&!(s.capabilities&8192))throw new Error((0,m.localize)(5,null,this.resourceForError(i)));let r;try{r=await s.stat(i)}catch{return}if((r.type&y.FileType.Directory)!=0)throw new y.FileOperationError((0,m.localize)(6,null,this.resourceForError(i)),0,n);if(this.throwIfFileIsReadonly(i,r),typeof n?.mtime=="number"&&typeof n.etag=="string"&&n.etag!==y.ETAG_DISABLED&&typeof r.mtime=="number"&&typeof r.size=="number"&&n.mtime<r.mtime&&n.etag!==(0,y.etag)({mtime:n.mtime,size:r.size}))throw new y.FileOperationError((0,m.localize)(7,null),3,n);return r}async readFile(s,i,n){const e=await this.withReadProvider(s);return i?.atomic?this.doReadFileAtomic(e,s,i,n):this.doReadFile(e,s,i,n)}async doReadFileAtomic(s,i,n,e){return new Promise((r,o)=>{this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{try{const S=await this.doReadFile(s,i,n,e);r(S)}catch(S){o(S)}})})}async doReadFile(s,i,n,e){const r=await this.doReadFileStream(s,i,{...n,preferUnbuffered:!0},e);return{...r,value:await(0,w.streamToBuffer)(r.value)}}async readFileStream(s,i,n){const e=await this.withReadProvider(s);return this.doReadFileStream(e,s,i,n)}async doReadFileStream(s,i,n,e){const r=new O.CancellationTokenSource(e),o=this.validateReadFile(i,n).then(E=>E,E=>{throw r.cancel(),E});let S;try{return typeof n?.etag=="string"&&n.etag!==y.ETAG_DISABLED&&await o,n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)||!((0,y.hasOpenReadWriteCloseCapability)(s)||(0,y.hasFileReadStreamCapability)(s))||(0,y.hasReadWriteCapability)(s)&&n?.preferUnbuffered?S=this.readFileUnbuffered(s,i,n):(0,y.hasFileReadStreamCapability)(s)?S=this.readFileStreamed(s,i,r.token,n):S=this.readFileBuffered(s,i,r.token,n),{...await o,value:S}}catch(E){S&&await(0,f.consumeStream)(S);const D=(0,m.localize)(8,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(E).toString());throw E instanceof y.NotModifiedSinceFileOperationError?new y.NotModifiedSinceFileOperationError(D,E.stat,n):new y.FileOperationError(D,(0,y.toFileOperationResult)(E),n)}}readFileStreamed(s,i,n,e=Object.create(null)){const r=s.readFileStream(i,e,n);return(0,f.transform)(r,{data:o=>o instanceof w.VSBuffer?o:w.VSBuffer.wrap(o),error:o=>new y.FileOperationError((0,m.localize)(9,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),e)},o=>w.VSBuffer.concat(o))}readFileBuffered(s,i,n,e=Object.create(null)){const r=(0,w.newWriteableBufferStream)();return(0,l.readFileIntoStream)(s,i,r,o=>o,{...e,bufferSize:this.BUFFER_SIZE,errorTransformer:o=>new y.FileOperationError((0,m.localize)(10,null,this.resourceForError(i),(0,y.ensureFileSystemProviderError)(o).toString()),(0,y.toFileOperationResult)(o),e)},n),r}readFileUnbuffered(s,i,n){const e=(0,f.newWriteableStream)(r=>w.VSBuffer.concat(r));return(async()=>{try{let r;n?.atomic&&(0,y.hasFileAtomicReadCapability)(s)?r=await s.readFile(i,{atomic:!0}):r=await s.readFile(i),typeof n?.position=="number"&&(r=r.slice(n.position)),typeof n?.length=="number"&&(r=r.slice(0,n.length)),this.validateReadFileLimits(i,r.byteLength,n),e.end(w.VSBuffer.wrap(r))}catch(r){e.error(r),e.end()}})(),e}async validateReadFile(s,i){const n=await this.resolve(s,{resolveMetadata:!0});if(n.isDirectory)throw new y.FileOperationError((0,m.localize)(11,null,this.resourceForError(s)),0,i);if(typeof i?.etag=="string"&&i.etag!==y.ETAG_DISABLED&&i.etag===n.etag)throw new y.NotModifiedSinceFileOperationError((0,m.localize)(12,null),n,i);return this.validateReadFileLimits(s,n.size,i),n}validateReadFileLimits(s,i,n){if(n?.limits){let e;if(typeof n.limits.memory=="number"&&i>n.limits.memory&&(e=9),typeof n.limits.size=="number"&&i>n.limits.size&&(e=7),typeof e=="number")throw new y.FileOperationError((0,m.localize)(13,null,this.resourceForError(s)),e)}}async canMove(s,i,n){return this.doCanMoveCopy(s,i,"move",n)}async canCopy(s,i,n){return this.doCanMoveCopy(s,i,"copy",n)}async doCanMoveCopy(s,i,n,e){if(s.toString()!==i.toString())try{const r=n==="move"?this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s):await this.withReadProvider(s),o=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);await this.doValidateMoveCopy(r,s,o,i,n,e)}catch(r){return r}return!0}async move(s,i,n){const e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(s),s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,r,i,"move",!!n),S=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="move"?2:3,S)),S}async copy(s,i,n){const e=await this.withReadProvider(s),r=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i),o=await this.doMoveCopy(e,s,r,i,"copy",!!n),S=await this.resolve(i,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,o==="copy"?3:2,S)),S}async doMoveCopy(s,i,n,e,r,o){if(i.toString()===e.toString())return r;const{exists:S,isSameResourceWithDifferentPathCase:E}=await this.doValidateMoveCopy(s,i,n,e,r,o);if(S&&!E&&o&&await this.del(e,{recursive:!0}),await this.mkdirp(n,this.getExtUri(n).providerExtUri.dirname(e)),r==="copy"){if(s===n&&(0,y.hasFileFolderCopyCapability)(s))await s.copy(i,e,{overwrite:o});else{const D=await this.resolve(i);D.isDirectory?await this.doCopyFolder(s,D,n,e):await this.doCopyFile(s,i,n,e)}return r}else return s===n?(await s.rename(i,e,{overwrite:o}),r):(await this.doMoveCopy(s,i,n,e,"copy",o),await this.del(i,{recursive:!0}),"copy")}async doCopyFile(s,i,n,e){if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeBuffered(s,i,n,e);if((0,y.hasOpenReadWriteCloseCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeBufferedToUnbuffered(s,i,n,e);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasOpenReadWriteCloseCapability)(n))return this.doPipeUnbufferedToBuffered(s,i,n,e);if((0,y.hasReadWriteCapability)(s)&&(0,y.hasReadWriteCapability)(n))return this.doPipeUnbuffered(s,i,n,e)}async doCopyFolder(s,i,n,e){await n.mkdir(e),Array.isArray(i.children)&&await b.Promises.settled(i.children.map(async r=>{const o=this.getExtUri(n).providerExtUri.joinPath(e,r.name);return r.isDirectory?this.doCopyFolder(s,await this.resolve(r.resource),n,o):this.doCopyFile(s,r.resource,n,o)}))}async doValidateMoveCopy(s,i,n,e,r,o){let S=!1;if(s===n){const{providerExtUri:D,isPathCaseSensitive:k}=this.getExtUri(s);if(k||(S=D.isEqual(i,e)),S&&r==="copy")throw new Error((0,m.localize)(14,null,this.resourceForError(i),this.resourceForError(e)));if(!S&&D.isEqualOrParent(e,i))throw new Error((0,m.localize)(15,null,this.resourceForError(i),this.resourceForError(e)))}const E=await this.exists(e);if(E&&!S){if(!o)throw new y.FileOperationError((0,m.localize)(16,null,this.resourceForError(i),this.resourceForError(e)),4);if(s===n){const{providerExtUri:D}=this.getExtUri(s);if(D.isEqualOrParent(i,e))throw new Error((0,m.localize)(17,null,this.resourceForError(i),this.resourceForError(e)))}}return{exists:E,isSameResourceWithDifferentPathCase:S}}getExtUri(s){const i=this.isPathCaseSensitive(s);return{providerExtUri:i?v.extUri:v.extUriIgnorePathCase,isPathCaseSensitive:i}}isPathCaseSensitive(s){return!!(s.capabilities&1024)}async createFolder(s){const i=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);await this.mkdirp(i,s);const n=await this.resolve(s,{resolveMetadata:!0});return this._onDidRunOperation.fire(new y.FileOperationEvent(s,0,n)),n}async mkdirp(s,i){const n=[],{providerExtUri:e}=this.getExtUri(s);for(;!e.isEqual(i,e.dirname(i));)try{if(((await s.stat(i)).type&y.FileType.Directory)==0)throw new Error((0,m.localize)(18,null,this.resourceForError(i)));break}catch(r){if((0,y.toFileSystemProviderErrorCode)(r)!==y.FileSystemProviderErrorCode.FileNotFound)throw r;n.push(e.basename(i)),i=e.dirname(i)}for(let r=n.length-1;r>=0;r--){i=e.joinPath(i,n[r]);try{await s.mkdir(i)}catch(o){if((0,y.toFileSystemProviderErrorCode)(o)!==y.FileSystemProviderErrorCode.FileExists)throw o}}}async canDelete(s,i){try{await this.doValidateDelete(s,i)}catch(n){return n}return!0}async doValidateDelete(s,i){const n=this.throwIfFileSystemIsReadonly(await this.withProvider(s),s);if(!!i?.useTrash&&!(n.capabilities&4096))throw new Error((0,m.localize)(19,null,this.resourceForError(s)));let r;try{r=await n.stat(s)}catch{}if(r)this.throwIfFileIsReadonly(s,r);else throw new y.FileOperationError((0,m.localize)(20,null,this.resourceForError(s)),1);if(!!!i?.recursive){const S=await this.resolve(s);if(S.isDirectory&&Array.isArray(S.children)&&S.children.length>0)throw new Error((0,m.localize)(21,null,this.resourceForError(s)))}return n}async del(s,i){const n=await this.doValidateDelete(s,i),e=!!i?.useTrash,r=!!i?.recursive;await n.delete(s,{recursive:r,useTrash:e}),this._onDidRunOperation.fire(new y.FileOperationEvent(s,1))}async cloneFile(s,i){const n=await this.withProvider(s),e=this.throwIfFileSystemIsReadonly(await this.withWriteProvider(i),i);if(n===e&&this.getExtUri(n).providerExtUri.isEqual(s,i))return;if(n===e&&(0,y.hasFileCloneCapability)(n))return n.cloneFile(s,i);await this.mkdirp(e,this.getExtUri(e).providerExtUri.dirname(i));const r=this.writeQueue.queueFor(s,this.getExtUri(n).providerExtUri);return n===e&&(0,y.hasFileFolderCopyCapability)(n)?r.queue(()=>n.copy(s,i,{overwrite:!0})):r.queue(()=>this.doCopyFile(n,s,e,i))}watch(s,i={recursive:!1,excludes:[]}){const n=new d.DisposableStore;let e=!1,r=()=>{e=!0};return n.add((0,d.toDisposable)(()=>r())),(async()=>{try{const o=await this.doWatch(s,i);e?(0,d.dispose)(o):r=()=>(0,d.dispose)(o)}catch(o){this.logService.error(o)}})(),n}async doWatch(s,i){const n=await this.withProvider(s),e=(0,p.hash)([this.getExtUri(n).providerExtUri.getComparisonKey(s),i]);let r=this.activeWatchers.get(e);return r||(r={count:0,disposable:n.watch(s,i)},this.activeWatchers.set(e,r)),r.count+=1,(0,d.toDisposable)(()=>{r&&(r.count--,r.count===0&&((0,d.dispose)(r.disposable),this.activeWatchers.delete(e)))})}dispose(){super.dispose();for(const[,s]of this.activeWatchers)(0,d.dispose)(s.disposable);this.activeWatchers.clear()}async doWriteBuffered(s,i,n,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(async()=>{const r=await s.open(i,{create:!0,unlock:n?.unlock??!1});try{(0,f.isReadableStream)(e)||(0,f.isReadableBufferedStream)(e)?await this.doWriteStreamBufferedQueued(s,r,e):await this.doWriteReadableBufferedQueued(s,r,e)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await s.close(r)}})}async doWriteStreamBufferedQueued(s,i,n){let e=0,r;if((0,f.isReadableBufferedStream)(n)){if(n.buffer.length>0){const o=w.VSBuffer.concat(n.buffer);await this.doWriteBuffer(s,i,o,o.byteLength,e,0),e+=o.byteLength}if(n.ended)return;r=n.stream}else r=n;return new Promise((o,S)=>{(0,f.listenStream)(r,{onData:async E=>{r.pause();try{await this.doWriteBuffer(s,i,E,E.byteLength,e,0)}catch(D){return S(D)}e+=E.byteLength,setTimeout(()=>r.resume())},onError:E=>S(E),onEnd:()=>o()})})}async doWriteReadableBufferedQueued(s,i,n){let e=0,r;for(;(r=n.read())!==null;)await this.doWriteBuffer(s,i,r,r.byteLength,e,0),e+=r.byteLength}async doWriteBuffer(s,i,n,e,r,o){let S=0;for(;S<e;)S+=await s.write(i,r+S,n.buffer,o+S,e-S)}async doWriteUnbuffered(s,i,n,e){return this.writeQueue.queueFor(i,this.getExtUri(s).providerExtUri).queue(()=>this.doWriteUnbufferedQueued(s,i,n,e))}async doWriteUnbufferedQueued(s,i,n,e){let r;e instanceof w.VSBuffer?r=e:(0,f.isReadableStream)(e)?r=await(0,w.streamToBuffer)(e):(0,f.isReadableBufferedStream)(e)?r=await(0,w.bufferedStreamToBuffer)(e):r=(0,w.readableToBuffer)(e),await s.writeFile(i,r.buffer,{create:!0,overwrite:!0,unlock:n?.unlock??!1})}async doPipeBuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeBufferedQueued(s,i,n,e))}async doPipeBufferedQueued(s,i,n,e){let r,o;try{r=await s.open(i,{create:!1}),o=await n.open(e,{create:!0,unlock:!1});const S=w.VSBuffer.alloc(this.BUFFER_SIZE);let E=0,D=0,k=0;do k=await s.read(r,E,S.buffer,D,S.byteLength-D),await this.doWriteBuffer(n,o,S,k,E,D),E+=k,D+=k,D===S.byteLength&&(D=0);while(k>0)}catch(S){throw(0,y.ensureFileSystemProviderError)(S)}finally{await b.Promises.settled([typeof r=="number"?s.close(r):Promise.resolve(),typeof o=="number"?n.close(o):Promise.resolve()])}}async doPipeUnbuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedQueued(s,i,n,e))}async doPipeUnbufferedQueued(s,i,n,e){return n.writeFile(e,await s.readFile(i),{create:!0,overwrite:!0,unlock:!1})}async doPipeUnbufferedToBuffered(s,i,n,e){return this.writeQueue.queueFor(e,this.getExtUri(n).providerExtUri).queue(()=>this.doPipeUnbufferedToBufferedQueued(s,i,n,e))}async doPipeUnbufferedToBufferedQueued(s,i,n,e){const r=await n.open(e,{create:!0,unlock:!1});try{const o=await s.readFile(i);await this.doWriteBuffer(n,r,w.VSBuffer.wrap(o),o.byteLength,0,0)}catch(o){throw(0,y.ensureFileSystemProviderError)(o)}finally{await n.close(r)}}async doPipeBufferedToUnbuffered(s,i,n,e){const r=await(0,w.streamToBuffer)(this.readFileBuffered(s,i,O.CancellationToken.None));await this.doWriteUnbuffered(n,e,void 0,r)}throwIfFileSystemIsReadonly(s,i){if(s.capabilities&2048)throw new y.FileOperationError((0,m.localize)(22,null,this.resourceForError(i)),6);return s}throwIfFileIsReadonly(s,i){if((i.permissions??0)&y.FilePermission.Readonly)throw new y.FileOperationError((0,m.localize)(23,null,this.resourceForError(s)),6)}resourceForError(s){return s.scheme===P.Schemas.file?s.fsPath:s.toString(!0)}};g=fe([te(0,u.ILogService)],g),t.FileService=g}),define(Z[111],ee([0,1,112,150,3,36,15,4,151,2,14,13,17,43,20,91,11,59,108,30,106,105]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l,u,g,a,s){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DiskFileSystemProvider=void 0,(()=>{try{(0,b.gracefulify)(I)}catch(n){console.error(`Error enabling graceful-fs: ${(0,g.toErrorMessage)(n)}`)}})();class i extends u.AbstractDiskFileSystemProvider{constructor(e,r){super(e,r);this.onDidChangeCapabilities=p.Event.None,this.resourceLocks=new O.ResourceMap(o=>h.extUriBiasedIgnorePathCase.getComparisonKey(o)),this.mapHandleToPos=new Map,this.mapHandleToLock=new Map,this.writeHandles=new Map}get capabilities(){return this._capabilities||(this._capabilities=2|4|16|8|8192|16384|32768,P.isLinux&&(this._capabilities|=1024)),this._capabilities}async stat(e){try{const{stat:r,symbolicLink:o}=await f.SymlinkSupport.stat(this.toFilePath(e));return{type:this.toType(r,o),ctime:r.birthtime.getTime(),mtime:r.mtime.getTime(),size:r.size}}catch(r){throw this.toFileSystemProviderError(r)}}async readdir(e){try{const r=await f.Promises.readdir(this.toFilePath(e),{withFileTypes:!0}),o=[];return await Promise.all(r.map(async S=>{try{let E;S.isSymbolicLink()?E=(await this.stat((0,h.joinPath)(e,S.name))).type:E=this.toType(S),o.push([S.name,E])}catch(E){this.logService.trace(E)}})),o}catch(r){throw this.toFileSystemProviderError(r)}}toType(e,r){let o;return r?.dangling?o=y.FileType.Unknown:e.isFile()?o=y.FileType.File:e.isDirectory()?o=y.FileType.Directory:o=y.FileType.Unknown,r&&(o|=y.FileType.SymbolicLink),o}async createResourceLock(e){const r=this.toFilePath(e);this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - request to acquire resource lock (${r})`);let o;for(;o=this.resourceLocks.get(e);)this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - waiting for resource lock to be released (${r})`),await o.wait();const S=new w.Barrier;return this.resourceLocks.set(e,S),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - new resource lock created (${r})`),(0,d.toDisposable)(()=>{this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock dispose() (${r})`),this.resourceLocks.get(e)===S&&(this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock removed from resource-lock map (${r})`),this.resourceLocks.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: createResourceLock() - resource lock barrier open() (${r})`),S.open()})}async readFile(e,r){let o;try{r?.atomic&&(this.logService.trace(`[Disk FileSystemProvider]: atomic read operation started (${this.toFilePath(e)})`),o=await this.createResourceLock(e));const S=this.toFilePath(e);return await f.Promises.readFile(S)}catch(S){throw this.toFileSystemProviderError(S)}finally{o?.dispose()}}readFileStream(e,r,o){const S=(0,v.newWriteableStream)(E=>A.VSBuffer.concat(E.map(D=>A.VSBuffer.wrap(D))).buffer);return(0,l.readFileIntoStream)(this,e,S,E=>E.buffer,{...r,bufferSize:256*1024},o),S}async writeFile(e,r,o){let S;try{const E=this.toFilePath(e);if(!o.create||!o.overwrite){if(await f.Promises.exists(E)){if(!o.overwrite)throw(0,y.createFileSystemProviderError)((0,m.localize)(0,null),y.FileSystemProviderErrorCode.FileExists)}else if(!o.create)throw(0,y.createFileSystemProviderError)((0,m.localize)(1,null),y.FileSystemProviderErrorCode.FileNotFound)}S=await this.open(e,{create:!0,unlock:o.unlock}),await this.write(S,0,r,0,r.byteLength)}catch(E){throw await this.toFileSystemProviderWriteError(e,E)}finally{typeof S=="number"&&await this.close(S)}}static configureFlushOnWrite(e){i.canFlush=e}async open(e,r){const o=this.toFilePath(e);let S;(0,y.isFileOpenForWriteOptions)(r)&&(S=await this.createResourceLock(e));let E;try{if((0,y.isFileOpenForWriteOptions)(r)&&r.unlock)try{const{stat:k}=await f.SymlinkSupport.stat(o);k.mode&128||await f.Promises.chmod(o,k.mode|128)}catch(k){this.logService.trace(k)}let D;if((0,y.isFileOpenForWriteOptions)(r)){if(P.isWindows)try{await f.Promises.truncate(o,0),D="r+"}catch(k){k.code!=="ENOENT"&&this.logService.trace(k)}D||(D="w")}else D="r";E=await f.Promises.open(o,D)}catch(D){throw S?.dispose(),(0,y.isFileOpenForWriteOptions)(r)?await this.toFileSystemProviderWriteError(e,D):this.toFileSystemProviderError(D)}if(this.mapHandleToPos.set(E,0),(0,y.isFileOpenForWriteOptions)(r)&&this.writeHandles.set(E,e),S){const D=this.mapHandleToLock.get(E);this.logService.trace(`[Disk FileSystemProvider]: open() - storing lock for handle ${E} (${o})`),this.mapHandleToLock.set(E,S),D&&(this.logService.trace(`[Disk FileSystemProvider]: open() - disposing a previous lock that was still stored on same handle ${E} (${o})`),D.dispose())}return E}async close(e){const r=this.mapHandleToLock.get(e);try{if(this.mapHandleToPos.delete(e),this.writeHandles.delete(e)&&i.canFlush)try{await f.Promises.fdatasync(e)}catch(o){i.configureFlushOnWrite(!1),this.logService.error(o)}return await f.Promises.close(e)}catch(o){throw this.toFileSystemProviderError(o)}finally{r&&(this.mapHandleToLock.get(e)===r&&(this.logService.trace(`[Disk FileSystemProvider]: close() - resource lock removed from handle-lock map ${e}`),this.mapHandleToLock.delete(e)),this.logService.trace(`[Disk FileSystemProvider]: close() - disposing lock for handle ${e}`),r.dispose())}}async read(e,r,o,S,E){const D=this.normalizePos(e,r);let k=null;try{k=(await f.Promises.read(e,o,S,E,D)).bytesRead}catch(V){throw this.toFileSystemProviderError(V)}finally{this.updatePos(e,D,k)}return k}normalizePos(e,r){return r===this.mapHandleToPos.get(e)?null:r}updatePos(e,r,o){const S=this.mapHandleToPos.get(e);typeof S=="number"&&(typeof r=="number"||(typeof o=="number"?this.mapHandleToPos.set(e,S+o):this.mapHandleToPos.delete(e)))}async write(e,r,o,S,E){return(0,w.retry)(()=>this.doWrite(e,r,o,S,E),100,3)}async doWrite(e,r,o,S,E){const D=this.normalizePos(e,r);let k=null;try{k=(await f.Promises.write(e,o,S,E,D)).bytesWritten}catch(V){throw await this.toFileSystemProviderWriteError(this.writeHandles.get(e),V)}finally{this.updatePos(e,D,k)}return k}async mkdir(e){try{await f.Promises.mkdir(this.toFilePath(e))}catch(r){throw this.toFileSystemProviderError(r)}}async delete(e,r){try{const o=this.toFilePath(e);r.recursive?await f.Promises.rm(o,f.RimRafMode.MOVE):await f.Promises.unlink(o)}catch(o){throw this.toFileSystemProviderError(o)}}async rename(e,r,o){const S=this.toFilePath(e),E=this.toFilePath(r);if(S!==E)try{await this.validateTargetDeleted(e,r,"move",o.overwrite),await f.Promises.move(S,E)}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,m.localize)(2,null,(0,C.basename)(S),(0,C.basename)((0,C.dirname)(E)),D.toString()))),this.toFileSystemProviderError(D)}}async copy(e,r,o){const S=this.toFilePath(e),E=this.toFilePath(r);if(S!==E)try{await this.validateTargetDeleted(e,r,"copy",o.overwrite),await f.Promises.copy(S,E,{preserveSymlinks:!0})}catch(D){throw(D.code==="EINVAL"||D.code==="EBUSY"||D.code==="ENAMETOOLONG")&&(D=new Error((0,m.localize)(3,null,(0,C.basename)(S),(0,C.basename)((0,C.dirname)(E)),D.toString()))),this.toFileSystemProviderError(D)}}async validateTargetDeleted(e,r,o,S){const E=this.toFilePath(e),D=this.toFilePath(r);let k=!1;if(!!(this.capabilities&1024)||(k=(0,c.isEqual)(E,D,!0)),k&&o==="copy")throw(0,y.createFileSystemProviderError)((0,m.localize)(4,null),y.FileSystemProviderErrorCode.FileExists);if(!k&&await f.Promises.exists(D)){if(!S)throw(0,y.createFileSystemProviderError)((0,m.localize)(5,null),y.FileSystemProviderErrorCode.FileExists);await this.delete(r,{recursive:!0,useTrash:!1})}}async cloneFile(e,r){return this.doCloneFile(e,r,!1)}async doCloneFile(e,r,o){const S=this.toFilePath(e),E=this.toFilePath(r),D=!!(this.capabilities&1024);if((0,c.isEqual)(S,E,!D))return;const k=new d.DisposableStore;try{const[V,_]=await Promise.all([this.createResourceLock(e),this.createResourceLock(r)]);k.add(V),k.add(_),o&&await f.Promises.mkdir((0,C.dirname)(E),{recursive:!0}),await f.Promises.copyFile(S,E)}catch(V){if(V.code==="ENOENT"&&!o)return this.doCloneFile(e,r,!0);throw this.toFileSystemProviderError(V)}finally{k.dispose()}}createUniversalWatcher(e,r,o){return new a.UniversalWatcherClient(S=>e(S),S=>r(S),o)}createNonRecursiveWatcher(e,r,o){return new s.NodeJSWatcherClient(S=>e(S),S=>r(S),o)}toFileSystemProviderError(e){if(e instanceof y.FileSystemProviderError)return e;let r;switch(e.code){case"ENOENT":r=y.FileSystemProviderErrorCode.FileNotFound;break;case"EISDIR":r=y.FileSystemProviderErrorCode.FileIsADirectory;break;case"ENOTDIR":r=y.FileSystemProviderErrorCode.FileNotADirectory;break;case"EEXIST":r=y.FileSystemProviderErrorCode.FileExists;break;case"EPERM":case"EACCES":r=y.FileSystemProviderErrorCode.NoPermissions;break;default:r=y.FileSystemProviderErrorCode.Unknown}return(0,y.createFileSystemProviderError)(e,r)}async toFileSystemProviderWriteError(e,r){let o=this.toFileSystemProviderError(r);if(e&&o.code===y.FileSystemProviderErrorCode.NoPermissions)try{const{stat:S}=await f.SymlinkSupport.stat(this.toFilePath(e));S.mode&128||(o=(0,y.createFileSystemProviderError)(r,y.FileSystemProviderErrorCode.FileWriteLocked))}catch(S){this.logService.trace(S)}return o}}t.DiskFileSystemProvider=i,i.canFlush=!0}),define(Z[113],ee([0,1,11,9]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.SpdLogLogger=void 0;async function w(p,c,d,C,P){try{const h=await new Promise((f,m)=>{$(["spdlog"],f,m)});h.setFlushOn(b.LogLevel.Trace);const v=await h.createAsyncRotatingLogger(p,c,d,C);return P&&v.clearFormatters(),v}catch(h){console.error(h)}return null}function O(p,c,d){switch(c){case b.LogLevel.Trace:p.trace(d);break;case b.LogLevel.Debug:p.debug(d);break;case b.LogLevel.Info:p.info(d);break;case b.LogLevel.Warning:p.warn(d);break;case b.LogLevel.Error:p.error(d);break;case b.LogLevel.Critical:p.critical(d);break;default:throw new Error("Invalid log level")}}class A extends b.AbstractMessageLogger{constructor(c,d,C,P,h){super();this.buffer=[],this.setLevel(h),this._loggerCreationPromise=this._createSpdLogLogger(c,d,C,P),this._register(this.onDidChangeLogLevel(v=>{this._logger?.setLevel(v)}))}async _createSpdLogLogger(c,d,C,P){const h=C?6:1,v=30/h*I.ByteSize.MB,f=await w(c,d,v,h,P);if(f){this._logger=f,this._logger.setLevel(this.getLevel());for(const{level:m,message:y}of this.buffer)O(this._logger,m,y);this.buffer=[]}}log(c,d){this._logger?O(this._logger,c,d):this.getLevel()<=c&&this.buffer.push({level:c,message:d})}flush(){this._logger?this._logger.flush():this._loggerCreationPromise.then(()=>this.flush())}dispose(){this._logger?this.disposeLogger():this._loggerCreationPromise.then(()=>this.disposeLogger())}disposeLogger(){this._logger&&(this._logger.drop(),this._logger=void 0)}}t.SpdLogLogger=A}),define(Z[37],ee([0,1,4,63,2,8]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NullPolicyService=t.AbstractPolicyService=t.IPolicyService=void 0,t.IPolicyService=(0,O.createDecorator)("policy");class A extends w.Disposable{constructor(){super(...arguments);this.policyDefinitions={},this.policies=new Map,this._onDidChange=this._register(new I.Emitter),this.onDidChange=this._onDidChange.event}async registerPolicyDefinitions(d){const C=Object.keys(this.policyDefinitions).length;return this.policyDefinitions={...d,...this.policyDefinitions},C!==Object.keys(this.policyDefinitions).length&&await this.initializePolicies(d),b.Iterable.reduce(this.policies.entries(),(P,[h,v])=>({...P,[h]:v}),{})}getPolicyValue(d){return this.policies.get(d)}serialize(){return b.Iterable.reduce(Object.entries(this.policyDefinitions),(d,[C,P])=>({...d,[C]:{definition:P,value:this.policies.get(C)}}),{})}}t.AbstractPolicyService=A;class p{constructor(){this.onDidChange=I.Event.None}async registerPolicyDefinitions(){return{}}getPolicyValue(){}serialize(){}}t.NullPolicyService=p}),define(Z[114],ee([0,1,3,4,63,5,11,9,37]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.FilePolicyService=void 0;function d(P,h){const v=[];for(const f of w.Iterable.concat(P.keys(),h.keys()))P.get(f)!==h.get(f)&&v.push(f);return v}let C=class extends c.AbstractPolicyService{constructor(h,v,f){super();this.file=h,this.fileService=v,this.logService=f,this.throttledDelayer=this._register(new I.ThrottledDelayer(500));const m=b.Event.filter(v.onDidFilesChange,y=>y.affects(h));this._register(v.watch(h)),this._register(m(()=>this.throttledDelayer.trigger(()=>this.refresh())))}async initializePolicies(h){await this.refresh()}async read(){const h=new Map;try{const v=await this.fileService.readFile(this.file),f=JSON.parse(v.value.toString());if(!(0,O.isObject)(f))throw new Error("Policy file isn't a JSON object");for(const m of Object.keys(f))this.policyDefinitions[m]&&h.set(m,f[m])}catch(v){v.fileOperationResult!==1&&this.logService.error("[FilePolicyService] Failed to read policies",v)}return h}async refresh(){const h=await this.read(),v=d(this.policies,h);this.policies=h,v.length>0&&this._onDidChange.fire(v)}};C=fe([te(1,A.IFileService),te(2,p.ILogService)],C),t.FilePolicyService=C}),define(Z[27],ee([0,1,8]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.productSchemaId=t.IProductService=void 0,t.IProductService=(0,I.createDecorator)("productService"),t.productSchemaId="vscode://schemas/vscode-product"}),define(Z[33],ee([0,1,68,5]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Registry=void 0;class w{constructor(){this.data=new Map}add(A,p){I.ok(b.isString(A)),I.ok(b.isObject(p)),I.ok(!this.data.has(A),"There is already an extension with this id"),this.data.set(A,p)}knows(A){return this.data.has(A)}as(A){return this.data.get(A)||null}}t.Registry=new w}),define(Z[115],ee([0,1,4,33]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.Extensions=void 0,t.Extensions={JSONContribution:"base.contributions.json"};function w(p){return p.length>0&&p.charAt(p.length-1)==="#"?p.substring(0,p.length-1):p}class O{constructor(){this._onDidChangeSchema=new I.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(c,d){this.schemasById[w(c)]=d,this._onDidChangeSchema.fire(c)}notifySchemaChanged(c){this._onDidChangeSchema.fire(c)}getSchemaContributions(){return{schemas:this.schemasById}}}const A=new O;b.Registry.add(t.Extensions.JSONContribution,A)}),define(Z[40],ee([0,1,19,4,5,81,21,115,33]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getScopes=t.validateProperty=t.getDefaultValue=t.keyFromOverrideIdentifiers=t.overrideIdentifiersFromKey=t.OVERRIDE_PROPERTY_REGEX=t.OVERRIDE_PROPERTY_PATTERN=t.configurationDefaultsSchemaId=t.resourceLanguageSettingsSchemaId=t.resourceSettings=t.windowSettings=t.machineOverridableSettings=t.machineSettings=t.applicationSettings=t.allSettings=t.ConfigurationScope=t.Extensions=t.EditPresentationTypes=void 0;var d;(function(s){s.Multiline="multilineText",s.Singleline="singlelineText"})(d=t.EditPresentationTypes||(t.EditPresentationTypes={})),t.Extensions={Configuration:"base.contributions.configuration"};var C;(function(s){s[s.APPLICATION=1]="APPLICATION",s[s.MACHINE=2]="MACHINE",s[s.WINDOW=3]="WINDOW",s[s.RESOURCE=4]="RESOURCE",s[s.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",s[s.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(C=t.ConfigurationScope||(t.ConfigurationScope={})),t.allSettings={properties:{},patternProperties:{}},t.applicationSettings={properties:{},patternProperties:{}},t.machineSettings={properties:{},patternProperties:{}},t.machineOverridableSettings={properties:{},patternProperties:{}},t.windowSettings={properties:{},patternProperties:{}},t.resourceSettings={properties:{},patternProperties:{}},t.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",t.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const P=c.Registry.as(p.Extensions.JSONContribution);class h{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new b.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new b.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:O.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(i,n=!0){this.registerConfigurations([i],n)}registerConfigurations(i,n=!0){const e=this.doRegisterConfigurations(i,n);P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:e})}deregisterConfigurations(i){const n=this.doDeregisterConfigurations(i);P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}updateConfigurations({add:i,remove:n}){const e=[];e.push(...this.doDeregisterConfigurations(n)),e.push(...this.doRegisterConfigurations(i,!1)),P.registerSchema(t.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,I.distinct)(e)})}registerDefaultConfigurations(i){const n=[],e=[];for(const{overrides:r,source:o}of i)for(const S in r)if(n.push(S),t.OVERRIDE_PROPERTY_REGEX.test(S)){const E=this.configurationDefaultsOverrides.get(S),D=E?.valuesSources??new Map;if(o)for(const G of Object.keys(r[S]))D.set(G,o);const k={...E?.value||{},...r[S]};this.configurationDefaultsOverrides.set(S,{source:o,value:k,valuesSources:D});const V=(0,A.getLanguageTagSettingPlainKey)(S),_={type:"object",default:k,description:O.localize(1,null,V),$ref:t.resourceLanguageSettingsSchemaId,defaultDefaultValue:k,source:w.isString(o)?void 0:o,defaultValueSource:o};e.push(...m(S)),this.configurationProperties[S]=_,this.defaultLanguageConfigurationOverridesNode.properties[S]=_}else{this.configurationDefaultsOverrides.set(S,{value:r[S],source:o});const E=this.configurationProperties[S];E&&(this.updatePropertyDefaultValue(S,E),this.updateSchema(S,E))}this.registerOverrideIdentifiers(e),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}deregisterDefaultConfigurations(i){const n=[];for(const{overrides:e,source:r}of i)for(const o in e){const S=this.configurationDefaultsOverrides.get(o),E=w.isString(r)?r:r?.id,D=w.isString(S?.source)?S?.source:S?.source?.id;if(E===D)if(n.push(o),this.configurationDefaultsOverrides.delete(o),t.OVERRIDE_PROPERTY_REGEX.test(o))delete this.configurationProperties[o],delete this.defaultLanguageConfigurationOverridesNode.properties[o];else{const k=this.configurationProperties[o];k&&(this.updatePropertyDefaultValue(o,k),this.updateSchema(o,k))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...i){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(i){for(const n of i)this.overrideIdentifiers.add(n);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(i,n){const e=[];return i.forEach(r=>{e.push(...this.validateAndRegisterProperties(r,n,r.extensionInfo,r.restrictedProperties)),this.configurationContributors.push(r),this.registerJSONConfiguration(r)}),e}doDeregisterConfigurations(i){const n=[],e=r=>{if(r.properties)for(const o in r.properties){n.push(o);const S=this.configurationProperties[o];S?.policy?.name&&this.policyConfigurations.delete(S.policy.name),delete this.configurationProperties[o],this.removeFromSchema(o,r.properties[o])}r.allOf?.forEach(o=>e(o))};for(const r of i){e(r);const o=this.configurationContributors.indexOf(r);o!==-1&&this.configurationContributors.splice(o,1)}return n}validateAndRegisterProperties(i,n=!0,e,r,o=3){o=w.isUndefinedOrNull(i.scope)?o:i.scope;const S=[],E=i.properties;if(E)for(const k in E){const V=E[k];if(n&&g(k,V)){delete E[k];continue}if(V.source=e,V.defaultDefaultValue=E[k].default,this.updatePropertyDefaultValue(k,V),t.OVERRIDE_PROPERTY_REGEX.test(k)?V.scope=void 0:(V.scope=w.isUndefinedOrNull(V.scope)?o:V.scope,V.restricted=w.isUndefinedOrNull(V.restricted)?!!r?.includes(k):V.restricted),E[k].hasOwnProperty("included")&&!E[k].included){this.excludedConfigurationProperties[k]=E[k],delete E[k];continue}else this.configurationProperties[k]=E[k],E[k].policy?.name&&this.policyConfigurations.set(E[k].policy.name,k);!E[k].deprecationMessage&&E[k].markdownDeprecationMessage&&(E[k].deprecationMessage=E[k].markdownDeprecationMessage),S.push(k)}const D=i.allOf;if(D)for(const k of D)S.push(...this.validateAndRegisterProperties(k,n,e,r,o));return S}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(i){const n=e=>{const r=e.properties;if(r)for(const S in r)this.updateSchema(S,r[S]);e.allOf?.forEach(n)};n(i)}updateSchema(i,n){switch(t.allSettings.properties[i]=n,n.scope){case 1:t.applicationSettings.properties[i]=n;break;case 2:t.machineSettings.properties[i]=n;break;case 6:t.machineOverridableSettings.properties[i]=n;break;case 3:t.windowSettings.properties[i]=n;break;case 4:t.resourceSettings.properties[i]=n;break;case 5:t.resourceSettings.properties[i]=n,this.resourceLanguageSettingsSchema.properties[i]=n;break}}removeFromSchema(i,n){switch(delete t.allSettings.properties[i],n.scope){case 1:delete t.applicationSettings.properties[i];break;case 2:delete t.machineSettings.properties[i];break;case 6:delete t.machineOverridableSettings.properties[i];break;case 3:delete t.windowSettings.properties[i];break;case 4:case 5:delete t.resourceSettings.properties[i],delete this.resourceLanguageSettingsSchema.properties[i];break}}updateOverridePropertyPatternKey(){for(const i of this.overrideIdentifiers.values()){const n=`[${i}]`,e={type:"object",description:O.localize(2,null),errorMessage:O.localize(3,null),$ref:t.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(n,e),t.allSettings.properties[n]=e,t.applicationSettings.properties[n]=e,t.machineSettings.properties[n]=e,t.machineOverridableSettings.properties[n]=e,t.windowSettings.properties[n]=e,t.resourceSettings.properties[n]=e}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const i={type:"object",description:O.localize(4,null),errorMessage:O.localize(5,null),$ref:t.resourceLanguageSettingsSchemaId};t.allSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.applicationSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.machineOverridableSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.windowSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,t.resourceSettings.patternProperties[t.OVERRIDE_PROPERTY_PATTERN]=i,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(i,n){const e=this.configurationDefaultsOverrides.get(i);let r=e?.value,o=e?.source;w.isUndefined(r)&&(r=n.defaultDefaultValue,o=void 0),w.isUndefined(r)&&(r=l(n.type)),n.default=r,n.defaultValueSource=o}}const v="\\[([^\\]]+)\\]",f=new RegExp(v,"g");t.OVERRIDE_PROPERTY_PATTERN=`^(${v})+$`,t.OVERRIDE_PROPERTY_REGEX=new RegExp(t.OVERRIDE_PROPERTY_PATTERN);function m(s){const i=[];if(t.OVERRIDE_PROPERTY_REGEX.test(s)){let n=f.exec(s);for(;n?.length;){const e=n[1].trim();e&&i.push(e),n=f.exec(s)}}return(0,I.distinct)(i)}t.overrideIdentifiersFromKey=m;function y(s){return s.reduce((i,n)=>`${i}[${n}]`,"")}t.keyFromOverrideIdentifiers=y;function l(s){switch(Array.isArray(s)?s[0]:s){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}t.getDefaultValue=l;const u=new h;c.Registry.add(t.Extensions.Configuration,u);function g(s,i){return s.trim()?t.OVERRIDE_PROPERTY_REGEX.test(s)?O.localize(7,null,s):u.getConfigurationProperties()[s]!==void 0?O.localize(8,null,s):i.policy?.name&&u.getPolicyConfigurations().get(i.policy?.name)!==void 0?O.localize(9,null,s,i.policy?.name,u.getPolicyConfigurations().get(i.policy?.name)):null:O.localize(6,null)}t.validateProperty=g;function a(){const s=[],i=u.getConfigurationProperties();for(const n of Object.keys(i))s.push([n,i[n].scope]);return s.push(["launch",4]),s.push(["task",4]),s}t.getScopes=a}),define(Z[64],ee([0,1,19,4,50,2,36,26,5,10,21,40,33]),function($,t,I,b,w,O,A,p,c,d,C,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AllKeysConfigurationChangeEvent=t.ConfigurationChangeEvent=t.mergeChanges=t.Configuration=t.UserSettings=t.ConfigurationModelParser=t.ConfigurationModel=void 0;class v{constructor(n={},e=[],r=[]){this._contents=n,this._keys=e,this._overrides=r,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(n){return n?(0,C.getConfigurationValue)(this.contents,n):this.contents}getOverrideValue(n,e){const r=this.getContentsForOverrideIdentifer(e);return r?n?(0,C.getConfigurationValue)(r,n):r:void 0}getKeysForOverrideIdentifier(n){const e=[];for(const r of this.overrides)r.identifiers.includes(n)&&e.push(...r.keys);return I.distinct(e)}getAllOverrideIdentifiers(){const n=[];for(const e of this.overrides)n.push(...e.identifiers);return I.distinct(n)}override(n){let e=this.overrideConfigurations.get(n);return e||(e=this.createOverrideConfigurationModel(n),this.overrideConfigurations.set(n,e)),e}merge(...n){const e=p.deepClone(this.contents),r=p.deepClone(this.overrides),o=[...this.keys];for(const S of n)if(!S.isEmpty()){this.mergeContents(e,S.contents);for(const E of S.overrides){const[D]=r.filter(k=>I.equals(k.identifiers,E.identifiers));D?(this.mergeContents(D.contents,E.contents),D.keys.push(...E.keys),D.keys=I.distinct(D.keys)):r.push(p.deepClone(E))}for(const E of S.keys)o.indexOf(E)===-1&&o.push(E)}return new v(e,o,r)}freeze(){return this.frozen=!0,this}clone(){return new v(p.deepClone(this.contents),[...this.keys],p.deepClone(this.overrides))}createOverrideConfigurationModel(n){const e=this.getContentsForOverrideIdentifer(n);if(!e||typeof e!="object"||!Object.keys(e).length)return this;const r={};for(const o of I.distinct([...Object.keys(this.contents),...Object.keys(e)])){let S=this.contents[o];const E=e[o];E&&(typeof S=="object"&&typeof E=="object"?(S=p.deepClone(S),this.mergeContents(S,E)):S=E),r[o]=S}return new v(r,this.keys,this.overrides)}mergeContents(n,e){for(const r of Object.keys(e)){if(r in n&&c.isObject(n[r])&&c.isObject(e[r])){this.mergeContents(n[r],e[r]);continue}n[r]=p.deepClone(e[r])}}checkAndFreeze(n){return this.frozen&&!Object.isFrozen(n)?p.deepFreeze(n):n}getContentsForOverrideIdentifer(n){let e=null,r=null;const o=S=>{S&&(r?this.mergeContents(r,S):r=p.deepClone(S))};for(const S of this.overrides)I.equals(S.identifiers,[n])?e=S.contents:S.identifiers.includes(n)&&o(S.contents);return o(e),r}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(n,e){this.addKey(n),(0,C.addToValueTree)(this.contents,n,e,r=>{throw new Error(r)})}removeValue(n){this.removeKey(n)&&(0,C.removeFromValueTree)(this.contents,n)}addKey(n){let e=this.keys.length;for(let r=0;r<e;r++)n.indexOf(this.keys[r])===0&&(e=r);this.keys.splice(e,1,n)}removeKey(n){const e=this.keys.indexOf(n);return e!==-1?(this.keys.splice(e,1),!0):!1}}t.ConfigurationModel=v;class f{constructor(n){this._name=n,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new v}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(n,e){if(!c.isUndefinedOrNull(n)){const r=this.doParseContent(n);this.parseRaw(r,e)}}reparse(n){this._raw&&this.parseRaw(this._raw,n)}parseRaw(n,e){this._raw=n;const{contents:r,keys:o,overrides:S,restricted:E}=this.doParseRaw(n,e);this._configurationModel=new v(r,o,S),this._restrictedConfigurations=E||[]}doParseContent(n){let e={},r=null,o=[];const S=[],E=[];function D(V){Array.isArray(o)?o.push(V):r!==null&&(o[r]=V)}const k={onObjectBegin:()=>{const V={};D(V),S.push(o),o=V,r=null},onObjectProperty:V=>{r=V},onObjectEnd:()=>{o=S.pop()},onArrayBegin:()=>{const V=[];D(V),S.push(o),o=V,r=null},onArrayEnd:()=>{o=S.pop()},onLiteralValue:D,onError:(V,_,G)=>{E.push({error:V,offset:_,length:G})}};if(n)try{w.visit(n,k),e=o[0]||{}}catch(V){console.error(`Error while parsing settings file ${this._name}: ${V}`),this._parseErrors=[V]}return e}doParseRaw(n,e){const r=h.Registry.as(P.Extensions.Configuration).getConfigurationProperties(),o=this.filter(n,r,!0,e);n=o.raw;const S=(0,C.toValuesTree)(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`)),E=Object.keys(n),D=this.toOverrides(n,k=>console.error(`Conflict in settings file ${this._name}: ${k}`));return{contents:S,keys:E,overrides:D,restricted:o.restricted}}filter(n,e,r,o){if(!o?.scopes&&!o?.skipRestricted)return{raw:n,restricted:[]};const S={},E=[];for(const D in n)if(P.OVERRIDE_PROPERTY_REGEX.test(D)&&r){const k=this.filter(n[D],e,!1,o);S[D]=k.raw,E.push(...k.restricted)}else{const k=e[D],V=k?typeof k.scope!="undefined"?k.scope:3:void 0;k?.restricted&&E.push(D),(V===void 0||o.scopes===void 0||o.scopes.includes(V))&&(o.skipRestricted&&k?.restricted||(S[D]=n[D]))}return{raw:S,restricted:E}}toOverrides(n,e){const r=[];for(const o of Object.keys(n))if(P.OVERRIDE_PROPERTY_REGEX.test(o)){const S={};for(const E in n[o])S[E]=n[o][E];r.push({identifiers:(0,P.overrideIdentifiersFromKey)(o),keys:Object.keys(S),contents:(0,C.toValuesTree)(S,e)})}return r}}t.ConfigurationModelParser=f;class m extends O.Disposable{constructor(n,e,r,o){super();this.userSettingsResource=n,this.scopes=e,this.fileService=o,this._onDidChange=this._register(new b.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(r.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(b.Event.any(b.Event.filter(this.fileService.onDidFilesChange,S=>S.contains(this.userSettingsResource)),b.Event.filter(this.fileService.onDidRunOperation,S=>(S.isOperation(0)||S.isOperation(3)||S.isOperation(1)||S.isOperation(4))&&r.isEqual(S.resource,n)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const n=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(n.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new v}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}t.UserSettings=m;class y{constructor(n,e,r,o,S=new v,E=new v,D=new A.ResourceMap,k=new v,V=new A.ResourceMap,_=!0){this._defaultConfiguration=n,this._policyConfiguration=e,this._applicationConfiguration=r,this._localUserConfiguration=o,this._remoteUserConfiguration=S,this._workspaceConfiguration=E,this._folderConfigurations=D,this._memoryConfiguration=k,this._memoryConfigurationByResource=V,this._freeze=_,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new A.ResourceMap,this._userConfiguration=null}getValue(n,e,r){return this.getConsolidatedConfigurationModel(n,e,r).getValue(n)}updateValue(n,e,r={}){let o;r.resource?(o=this._memoryConfigurationByResource.get(r.resource),o||(o=new v,this._memoryConfigurationByResource.set(r.resource,o))):o=this._memoryConfiguration,e===void 0?o.removeValue(n):o.setValue(n,e),r.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(n,e,r){const o=this.getConsolidatedConfigurationModel(n,e,r),S=this.getFolderConfigurationModelForResource(e.resource,r),E=e.resource?this._memoryConfigurationByResource.get(e.resource)||this._memoryConfiguration:this._memoryConfiguration,D=e.overrideIdentifier?this._defaultConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._defaultConfiguration.freeze().getValue(n),k=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(n),V=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(n),_=e.overrideIdentifier?this.userConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.userConfiguration.freeze().getValue(n),G=e.overrideIdentifier?this.localUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.localUserConfiguration.freeze().getValue(n),Q=e.overrideIdentifier?this.remoteUserConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this.remoteUserConfiguration.freeze().getValue(n),ne=r?e.overrideIdentifier?this._workspaceConfiguration.freeze().override(e.overrideIdentifier).getValue(n):this._workspaceConfiguration.freeze().getValue(n):void 0,ce=S?e.overrideIdentifier?S.freeze().override(e.overrideIdentifier).getValue(n):S.freeze().getValue(n):void 0,re=e.overrideIdentifier?E.override(e.overrideIdentifier).getValue(n):E.getValue(n),ge=o.getValue(n),ae=I.distinct(o.overrides.map(N=>N.identifiers).flat()).filter(N=>o.getOverrideValue(n,N)!==void 0);return{defaultValue:D,policyValue:k,applicationValue:V,userValue:_,userLocalValue:G,userRemoteValue:Q,workspaceValue:ne,workspaceFolderValue:ce,memoryValue:re,value:ge,default:D!==void 0?{value:this._defaultConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,policy:k!==void 0?{value:k}:void 0,application:V!==void 0?{value:V,override:e.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,user:_!==void 0?{value:this.userConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userLocal:G!==void 0?{value:this.localUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,userRemote:Q!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspace:ne!==void 0?{value:this._workspaceConfiguration.freeze().getValue(n),override:e.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,workspaceFolder:ce!==void 0?{value:S?.freeze().getValue(n),override:e.overrideIdentifier?S?.freeze().getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,memory:re!==void 0?{value:E.getValue(n),override:e.overrideIdentifier?E.getOverrideValue(n,e.overrideIdentifier):void 0}:void 0,overrideIdentifiers:ae.length?ae:void 0}}keys(n){const e=this.getFolderConfigurationModelForResource(void 0,n);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:e?e.freeze().keys:[]}}updateDefaultConfiguration(n){this._defaultConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(n){this._policyConfiguration=n}updateApplicationConfiguration(n){this._applicationConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(n){this._localUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(n){this._remoteUserConfiguration=n,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(n){this._workspaceConfiguration=n,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(n,e){this._folderConfigurations.set(n,e),this._foldersConsolidatedConfigurations.delete(n)}deleteFolderConfiguration(n){this.folderConfigurations.delete(n),this._foldersConsolidatedConfigurations.delete(n)}compareAndUpdateDefaultConfiguration(n,e){const r=[];if(!e){const{added:o,updated:S,removed:E}=a(this._defaultConfiguration,n);e=[...o,...S,...E]}for(const o of e)for(const S of(0,P.overrideIdentifiersFromKey)(o)){const E=this._defaultConfiguration.getKeysForOverrideIdentifier(S),D=n.getKeysForOverrideIdentifier(S),k=[...D.filter(V=>E.indexOf(V)===-1),...E.filter(V=>D.indexOf(V)===-1),...E.filter(V=>!p.equals(this._defaultConfiguration.override(S).getValue(V),n.override(S).getValue(V)))];r.push([S,k])}return this.updateDefaultConfiguration(n),{keys:e,overrides:r}}compareAndUpdatePolicyConfiguration(n){const{added:e,updated:r,removed:o}=a(this._policyConfiguration,n),S=[...e,...r,...o];return S.length&&this.updatePolicyConfiguration(n),{keys:S,overrides:[]}}compareAndUpdateApplicationConfiguration(n){const{added:e,updated:r,removed:o,overrides:S}=a(this.applicationConfiguration,n),E=[...e,...r,...o];return E.length&&this.updateApplicationConfiguration(n),{keys:E,overrides:S}}compareAndUpdateLocalUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:S}=a(this.localUserConfiguration,n),E=[...e,...r,...o];return E.length&&this.updateLocalUserConfiguration(n),{keys:E,overrides:S}}compareAndUpdateRemoteUserConfiguration(n){const{added:e,updated:r,removed:o,overrides:S}=a(this.remoteUserConfiguration,n),E=[...e,...r,...o];return E.length&&this.updateRemoteUserConfiguration(n),{keys:E,overrides:S}}compareAndUpdateWorkspaceConfiguration(n){const{added:e,updated:r,removed:o,overrides:S}=a(this.workspaceConfiguration,n),E=[...e,...r,...o];return E.length&&this.updateWorkspaceConfiguration(n),{keys:E,overrides:S}}compareAndUpdateFolderConfiguration(n,e){const r=this.folderConfigurations.get(n),{added:o,updated:S,removed:E,overrides:D}=a(r,e),k=[...o,...S,...E];return(k.length||!r)&&this.updateFolderConfiguration(n,e),{keys:k,overrides:D}}compareAndDeleteFolderConfiguration(n){const e=this.folderConfigurations.get(n);if(!e)throw new Error("Unknown folder");this.deleteFolderConfiguration(n);const{added:r,updated:o,removed:S,overrides:E}=a(e,void 0);return{keys:[...r,...o,...S],overrides:E}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(n,e,r){let o=this.getConsolidatedConfigurationModelForResource(e,r);return e.overrideIdentifier&&(o=o.override(e.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(n)!==void 0&&(o=o.merge(this._policyConfiguration)),o}getConsolidatedConfigurationModelForResource({resource:n},e){let r=this.getWorkspaceConsolidatedConfiguration();if(e&&n){const o=e.getFolder(n);o&&(r=this.getFolderConsolidatedConfiguration(o.uri)||r);const S=this._memoryConfigurationByResource.get(n);S&&(r=r.merge(S))}return r}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(n){let e=this._foldersConsolidatedConfigurations.get(n);if(!e){const r=this.getWorkspaceConsolidatedConfiguration(),o=this._folderConfigurations.get(n);o?(e=r.merge(o),this._freeze&&(e=e.freeze()),this._foldersConsolidatedConfigurations.set(n,e)):e=r}return e}getFolderConfigurationModelForResource(n,e){if(e&&n){const r=e.getFolder(n);if(r)return this._folderConfigurations.get(r.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((n,e)=>{const{contents:r,overrides:o,keys:S}=this._folderConfigurations.get(e);return n.push([e,{contents:r,overrides:o,keys:S}]),n},[])}}allKeys(){const n=new Set;return this._defaultConfiguration.freeze().keys.forEach(e=>n.add(e)),this.userConfiguration.freeze().keys.forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().keys.forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().keys.forEach(r=>n.add(r))),[...n.values()]}allOverrideIdentifiers(){const n=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(e=>n.add(e)),this._folderConfigurations.forEach(e=>e.freeze().getAllOverrideIdentifiers().forEach(r=>n.add(r))),[...n.values()]}getAllKeysForOverrideIdentifier(n){const e=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this.userConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._workspaceConfiguration.getKeysForOverrideIdentifier(n).forEach(r=>e.add(r)),this._folderConfigurations.forEach(r=>r.getKeysForOverrideIdentifier(n).forEach(o=>e.add(o))),[...e.values()]}static parse(n){const e=this.parseConfigurationModel(n.defaults),r=this.parseConfigurationModel(n.policy),o=this.parseConfigurationModel(n.application),S=this.parseConfigurationModel(n.user),E=this.parseConfigurationModel(n.workspace),D=n.folders.reduce((k,V)=>(k.set(d.URI.revive(V[0]),this.parseConfigurationModel(V[1])),k),new A.ResourceMap);return new y(e,r,o,S,new v,E,D,new v,new A.ResourceMap,!1)}static parseConfigurationModel(n){return new v(n.contents,n.keys,n.overrides).freeze()}}t.Configuration=y;function l(...i){if(i.length===0)return{keys:[],overrides:[]};if(i.length===1)return i[0];const n=new Set,e=new Map;for(const o of i)o.keys.forEach(S=>n.add(S)),o.overrides.forEach(([S,E])=>{const D=(0,A.getOrSet)(e,S,new Set);E.forEach(k=>D.add(k))});const r=[];return e.forEach((o,S)=>r.push([S,[...o.values()]])),{keys:[...n.values()],overrides:r}}t.mergeChanges=l;class u{constructor(n,e,r,o){this.change=n,this.previous=e,this.currentConfiguraiton=r,this.currentWorkspace=o,this._previousConfiguration=void 0;const S=new Set;n.keys.forEach(D=>S.add(D)),n.overrides.forEach(([,D])=>D.forEach(k=>S.add(k))),this.affectedKeys=[...S.values()];const E=new v;this.affectedKeys.forEach(D=>E.setValue(D,{})),this.affectedKeysTree=E.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=y.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(n,e){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,n)){if(e){const r=this.previousConfiguration?this.previousConfiguration.getValue(n,e,this.previous?.workspace):void 0,o=this.currentConfiguraiton.getValue(n,e,this.currentWorkspace);return!p.equals(r,o)}return!0}return!1}doesAffectedKeysTreeContains(n,e){let r=(0,C.toValuesTree)({[e]:!0},()=>{}),o;for(;typeof r=="object"&&(o=Object.keys(r)[0]);){if(n=n[o],!n)return!1;r=r[o]}return!0}}t.ConfigurationChangeEvent=u;class g extends u{constructor(n,e,r,o){super({keys:n.allKeys(),overrides:[]},void 0,n,e);this.source=r,this.sourceConfig=o}}t.AllKeysConfigurationChangeEvent=g;function a(i,n){const{added:e,removed:r,updated:o}=s(n,i),S=[],E=i?.getAllOverrideIdentifiers()||[],D=n?.getAllOverrideIdentifiers()||[];if(n){const k=D.filter(V=>!E.includes(V));for(const V of k)S.push([V,n.getKeysForOverrideIdentifier(V)])}if(i){const k=E.filter(V=>!D.includes(V));for(const V of k)S.push([V,i.getKeysForOverrideIdentifier(V)])}if(n&&i){for(const k of E)if(D.includes(k)){const V=s({contents:i.getOverrideValue(void 0,k)||{},keys:i.getKeysForOverrideIdentifier(k)},{contents:n.getOverrideValue(void 0,k)||{},keys:n.getKeysForOverrideIdentifier(k)});S.push([k,[...V.added,...V.removed,...V.updated]])}}return{added:e,removed:r,updated:o,overrides:S}}function s(i,n){const e=i?n?i.keys.filter(S=>n.keys.indexOf(S)===-1):[...i.keys]:[],r=n?i?n.keys.filter(S=>i.keys.indexOf(S)===-1):[...n.keys]:[],o=[];if(i&&n){for(const S of n.keys)if(i.keys.indexOf(S)!==-1){const E=(0,C.getConfigurationValue)(n.contents,S),D=(0,C.getConfigurationValue)(i.contents,S);p.equals(E,D)||o.push(S)}}return{added:e,removed:r,updated:o}}}),define(Z[116],ee([0,1,19,4,2,26,5,21,64,40,9,37,33]),function($,t,I,b,w,O,A,p,c,d,C,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.PolicyConfiguration=t.NullPolicyConfiguration=t.DefaultConfigurationModel=t.DefaultConfiguration=void 0;class v extends w.Disposable{constructor(){super(...arguments);this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event}get configurationModel(){return this._configurationModel||(this._configurationModel=new f(this.getConfigurationDefaultOverrides())),this._configurationModel}async initialize(){return this._configurationModel=void 0,this._register(h.Registry.as(d.Extensions.Configuration).onDidUpdateConfiguration(({properties:u,defaultsOverrides:g})=>this.onDidUpdateConfiguration(u,g))),this.configurationModel}reload(){return this._configurationModel=void 0,this.configurationModel}onDidUpdateConfiguration(u,g){this._configurationModel=void 0,this._onDidChangeConfiguration.fire({defaults:this.configurationModel,properties:u})}getConfigurationDefaultOverrides(){return{}}}t.DefaultConfiguration=v;class f extends c.ConfigurationModel{constructor(u={}){const g=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),a=Object.keys(g),s=Object.create(null),i=[];for(const n in g){const e=u[n],r=e!==void 0?e:g[n].default;(0,p.addToValueTree)(s,n,r,o=>console.error(`Conflict in default settings: ${o}`))}for(const n of Object.keys(s))d.OVERRIDE_PROPERTY_REGEX.test(n)&&i.push({identifiers:(0,d.overrideIdentifiersFromKey)(n),keys:Object.keys(s[n]),contents:(0,p.toValuesTree)(s[n],e=>console.error(`Conflict in default settings file: ${e}`))});super(s,a,i)}}t.DefaultConfigurationModel=f;class m{constructor(){this.onDidChangeConfiguration=b.Event.None,this.configurationModel=new c.ConfigurationModel}async initialize(){return this.configurationModel}}t.NullPolicyConfiguration=m;let y=class extends w.Disposable{constructor(u,g,a){super();this.defaultConfiguration=u,this.policyService=g,this.logService=a,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this._configurationModel=new c.ConfigurationModel}get configurationModel(){return this._configurationModel}async initialize(){return this.update(await this.registerPolicyDefinitions(this.defaultConfiguration.configurationModel.keys),!1),this._register(this.policyService.onDidChange(u=>this.onDidChangePolicies(u))),this._register(this.defaultConfiguration.onDidChangeConfiguration(async({properties:u})=>this.update(await this.registerPolicyDefinitions(u),!0))),this._configurationModel}async registerPolicyDefinitions(u){const g={},a=[],s=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties();for(const i of u){const n=s[i];if(!n){a.push(i);continue}if(n.policy){if(n.type!=="string"&&n.type!=="number"){this.logService.warn(`Policy ${n.policy.name} has unsupported type ${n.type}`);continue}a.push(i),g[n.policy.name]={type:n.type}}}return(0,A.isEmptyObject)(g)||await this.policyService.registerPolicyDefinitions(g),a}onDidChangePolicies(u){const g=h.Registry.as(d.Extensions.Configuration).getPolicyConfigurations(),a=(0,I.coalesce)(u.map(s=>g.get(s)));this.update(a,!0)}update(u,g){const a=h.Registry.as(d.Extensions.Configuration).getConfigurationProperties(),s=[],i=this._configurationModel.isEmpty();for(const n of u){const e=a[n]?.policy?.name;if(e){const r=this.policyService.getPolicyValue(e);(i?r!==void 0:!(0,O.equals)(this._configurationModel.getValue(n),r))&&s.push([n,r])}else this._configurationModel.getValue(n)!==void 0&&s.push([n,void 0])}if(s.length){const n=this._configurationModel;this._configurationModel=new c.ConfigurationModel;for(const e of n.keys)this._configurationModel.setValue(e,n.getValue(e));for(const[e,r]of s)r===void 0?this._configurationModel.removeValue(e):this._configurationModel.setValue(e,r);g&&this._onDidChangeConfiguration.fire(this._configurationModel)}}};y=fe([te(1,P.IPolicyService),te(2,C.ILogService)],y),t.PolicyConfiguration=y}),define(Z[117],ee([0,1,3,4,2,17,21,64,116,37]),function($,t,I,b,w,O,A,p,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ConfigurationService=void 0;class C extends w.Disposable{constructor(h,v,f,m){super();this.settingsResource=h,this._onDidChangeConfiguration=this._register(new b.Emitter),this.onDidChangeConfiguration=this._onDidChangeConfiguration.event,this.defaultConfiguration=this._register(new c.DefaultConfiguration),this.policyConfiguration=f instanceof d.NullPolicyService?new c.NullPolicyConfiguration:this._register(new c.PolicyConfiguration(this.defaultConfiguration,f,m)),this.userConfiguration=this._register(new p.UserSettings(this.settingsResource,void 0,O.extUriBiasedIgnorePathCase,v)),this.configuration=new p.Configuration(this.defaultConfiguration.configurationModel,this.policyConfiguration.configurationModel,new p.ConfigurationModel,new p.ConfigurationModel),this.reloadConfigurationScheduler=this._register(new I.RunOnceScheduler(()=>this.reloadConfiguration(),50)),this._register(this.defaultConfiguration.onDidChangeConfiguration(({defaults:y,properties:l})=>this.onDidDefaultConfigurationChange(y,l))),this._register(this.policyConfiguration.onDidChangeConfiguration(y=>this.onDidPolicyConfigurationChange(y))),this._register(this.userConfiguration.onDidChange(()=>this.reloadConfigurationScheduler.schedule()))}async initialize(){const[h,v,f]=await Promise.all([this.defaultConfiguration.initialize(),this.policyConfiguration.initialize(),this.userConfiguration.loadConfiguration()]);this.configuration=new p.Configuration(h,v,new p.ConfigurationModel,f)}getConfigurationData(){return this.configuration.toData()}getValue(h,v){const f=typeof h=="string"?h:void 0,m=(0,A.isConfigurationOverrides)(h)?h:(0,A.isConfigurationOverrides)(v)?v:{};return this.configuration.getValue(f,m,void 0)}updateValue(h,v,f,m){return Promise.reject(new Error("not supported"))}inspect(h){return this.configuration.inspect(h,{},void 0)}keys(){return this.configuration.keys(void 0)}async reloadConfiguration(){const h=await this.userConfiguration.loadConfiguration();this.onDidChangeUserConfiguration(h)}onDidChangeUserConfiguration(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdateLocalUserConfiguration(h);this.trigger(f,v,2)}onDidDefaultConfigurationChange(h,v){const f=this.configuration.toData(),m=this.configuration.compareAndUpdateDefaultConfiguration(h,v);this.trigger(m,f,7)}onDidPolicyConfigurationChange(h){const v=this.configuration.toData(),f=this.configuration.compareAndUpdatePolicyConfiguration(h);this.trigger(f,v,7)}trigger(h,v,f){const m=new p.ConfigurationChangeEvent(h,{data:v},this.configuration);m.source=f,m.sourceConfig=this.getTargetConfiguration(f),this._onDidChangeConfiguration.fire(m)}getTargetConfiguration(h){switch(h){case 7:return this.configuration.defaults.contents;case 2:return this.configuration.localUserConfiguration.contents}return{}}}t.ConfigurationService=C}),define(Z[118],ee([0,1,16]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.parseAuthorityWithOptionalPort=t.parseAuthorityWithPort=t.getRemoteServerRootPath=t.getRemoteName=t.getRemoteAuthority=void 0;function b(d){return d.scheme===I.Schemas.vscodeRemote?d.authority:void 0}t.getRemoteAuthority=b;function w(d){if(!d)return;const C=d.indexOf("+");return C<0?d:d.substr(0,C)}t.getRemoteName=w;function O(d){return`/${d.quality??"oss"}-${d.commit??"dev"}`}t.getRemoteServerRootPath=O;function A(d){const{host:C,port:P}=c(d);if(typeof P=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:C,port:P}}t.parseAuthorityWithPort=A;function p(d,C){let{host:P,port:h}=c(d);return typeof h=="undefined"&&(h=C),{host:P,port:h}}t.parseAuthorityWithOptionalPort=p;function c(d){const C=d.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(C)return{host:C[1],port:parseInt(C[2],10)};const P=d.match(/^(\[[0-9a-z:]+\])$/);if(P)return{host:P[1],port:void 0};const h=d.match(/(.*):(\d+)$/);return h?{host:h[1],port:parseInt(h[2],10)}:{host:d,port:void 0}}}),define(Z[34],ee([0,1,31,8,118]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IBuiltinExtensionsScannerService=t.isResolverExtension=t.isAuthenticationProviderExtension=t.isLanguagePackExtension=t.isApplicationScopedExtension=t.ExtensionIdentifier=t.TargetPlatform=t.ExtensionType=t.EXTENSION_CATEGORIES=t.isIExtensionIdentifier=t.getWorkspaceSupportTypeMessage=t.ALL_EXTENSION_KINDS=t.UNDEFINED_PUBLISHER=t.BUILTIN_MANIFEST_CACHE_FILE=t.USER_MANIFEST_CACHE_FILE=t.MANIFEST_CACHE_FOLDER=void 0,t.MANIFEST_CACHE_FOLDER="CachedExtensions",t.USER_MANIFEST_CACHE_FILE="user",t.BUILTIN_MANIFEST_CACHE_FILE="builtin",t.UNDEFINED_PUBLISHER="undefined_publisher",t.ALL_EXTENSION_KINDS=["ui","workspace","web"];function O(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}t.getWorkspaceSupportTypeMessage=O;function A(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}t.isIExtensionIdentifier=A,t.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var p;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(p=t.ExtensionType||(t.ExtensionType={}));var c;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(c=t.TargetPlatform||(t.TargetPlatform={}));class d{constructor(m){this.value=m,this._lower=m.toLowerCase()}static equals(m,y){if(typeof m=="undefined"||m===null)return typeof y=="undefined"||y===null;if(typeof y=="undefined"||y===null)return!1;if(typeof m=="string"||typeof y=="string"){const l=typeof m=="string"?m:m.value,u=typeof y=="string"?y:y.value;return I.equalsIgnoreCase(l,u)}return m._lower===y._lower}static toKey(m){return typeof m=="string"?m.toLowerCase():m._lower}}t.ExtensionIdentifier=d;function C(f){return P(f)}t.isApplicationScopedExtension=C;function P(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}t.isLanguagePackExtension=P;function h(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}t.isAuthenticationProviderExtension=h;function v(f,m){if(m){const y=`onResolveRemoteAuthority:${(0,w.getRemoteName)(m)}`;return f.activationEvents?.indexOf(y)!==-1}return!1}t.isResolverExtension=v,t.IBuiltinExtensionsScannerService=(0,b.createDecorator)("IBuiltinExtensionsScannerService")}),define(Z[23],ee([0,1,31,22,34,13,10,12,32]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.computeTargetPlatform=t.isAlpineLinux=t.getExtensionDependencies=t.BetterMergeId=t.getGalleryExtensionTelemetryData=t.getLocalExtensionTelemetryData=t.groupByExtension=t.getGalleryExtensionId=t.adoptToGalleryExtensionId=t.getExtensionId=t.getIdAndVersion=t.ExtensionKey=t.areSameExtensions=void 0;function d(n,e){return n.uuid&&e.uuid?n.uuid===e.uuid:n.id===e.id?!0:(0,I.compareIgnoreCase)(n.id,e.id)===0}t.areSameExtensions=d;const C=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class P{constructor(e,r,o="undefined"){this.version=r,this.targetPlatform=o,this.id=e.id}static create(e){const r=e.manifest?e.manifest.version:e.version,o=e.manifest?e.targetPlatform:e.properties.targetPlatform;return new P(e.identifier,r,o)}static parse(e){const r=C.exec(e);return r&&r[1]&&r[2]?new P({id:r[1]},r[2],r[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(e){return e instanceof P?d(this,e)&&this.version===e.version&&this.targetPlatform===e.targetPlatform:!1}}t.ExtensionKey=P;const h=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function v(n){const e=h.exec(n);return e&&e[1]?[m(e[1]),e[2]]:[m(n),void 0]}t.getIdAndVersion=v;function f(n,e){return`${n}.${e}`}t.getExtensionId=f;function m(n){return n.toLocaleLowerCase()}t.adoptToGalleryExtensionId=m;function y(n,e){return m(f(n,e))}t.getGalleryExtensionId=y;function l(n,e){const r=[],o=S=>{for(const E of r)if(E.some(D=>d(e(D),e(S))))return E;return null};for(const S of n){const E=o(S);E?E.push(S):r.push([S])}return r}t.groupByExtension=l;function u(n){return{id:n.identifier.id,name:n.manifest.name,galleryId:null,publisherId:n.publisherId,publisherName:n.manifest.publisher,publisherDisplayName:n.publisherDisplayName,dependencies:n.manifest.extensionDependencies&&n.manifest.extensionDependencies.length>0}}t.getLocalExtensionTelemetryData=u;function g(n){return{id:n.identifier.id,name:n.name,galleryId:n.identifier.uuid,publisherId:n.publisherId,publisherName:n.publisher,publisherDisplayName:n.publisherDisplayName,isPreReleaseVersion:n.properties.isPreReleaseVersion,dependencies:!!(n.properties.dependencies&&n.properties.dependencies.length>0),...n.telemetryData}}t.getGalleryExtensionTelemetryData=g,t.BetterMergeId=new w.ExtensionIdentifier("pprice.better-merge");function a(n,e){const r=[],o=e.manifest.extensionDependencies?.slice(0)??[];for(;o.length;){const S=o.shift();if(S&&r.every(E=>!d(E.identifier,{id:S}))){const E=n.filter(D=>d(D.identifier,{id:S}));E.length===1&&(r.push(E[0]),o.push(...E[0].manifest.extensionDependencies?.slice(0)??[]))}}return r}t.getExtensionDependencies=a;async function s(n,e){if(!O.isLinux)return!1;let r;try{r=(await n.readFile(A.URI.file("/etc/os-release"))).value.toString()}catch{try{r=(await n.readFile(A.URI.file("/usr/lib/os-release"))).value.toString()}catch(S){e.debug("Error while getting the os-release file.",(0,p.getErrorMessage)(S))}}return!!r&&(r.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}t.isAlpineLinux=s;async function i(n,e){const r=await s(n,e),o=(0,b.getTargetPlatform)(r?"alpine":O.platform,c.arch);return e.debug("ComputeTargetPlatform:",o),o}t.computeTargetPlatform=i}),define(Z[119],ee([0,1,24,12,16,17,39,10,84,22,23,34]),function($,t,I,b,w,O,A,p,c,d,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementCLIService=void 0;const h=y=>(0,c.localize)(0,null,y),v=(0,c.localize)(1,null,"ms-dotnettools.csharp");function f(y,l){return l?`${y.publisher}.${y.name}@${y.version}`:`${y.publisher}.${y.name}`}let m=class{constructor(l,u){this.extensionManagementService=l,this.extensionGalleryService=u}get location(){}async listExtensions(l,u,g=console){let a=await this.extensionManagementService.getInstalled(1);const s=P.EXTENSION_CATEGORIES.map(n=>n.toLowerCase());if(u&&u!==""){if(s.indexOf(u.toLowerCase())<0){g.log("Invalid category please enter a valid category. To list valid categories run --category without a category specified");return}a=a.filter(n=>n.manifest.categories?n.manifest.categories.map(r=>r.toLowerCase()).indexOf(u.toLowerCase())>-1:!1)}else if(u===""){g.log("Possible Categories: "),s.forEach(n=>{g.log(n)});return}this.location&&g.log((0,c.localize)(2,null,this.location)),a=a.sort((n,e)=>n.identifier.id.localeCompare(e.identifier.id));let i;for(const n of a)i!==n.identifier.id&&(i=n.identifier.id,g.log(f(n.manifest,l)))}async installExtensions(l,u,g,a,s=console){const i=[],n=[];l.length&&s.log(this.location?(0,c.localize)(3,null,this.location):(0,c.localize)(4,null));const e=await this.extensionManagementService.getInstalled(1),r=(D,k)=>{const V=e.find(_=>(0,C.areSameExtensions)(_.identifier,{id:D}));if(V){if(!a&&(!k||k==="prerelease"&&V.preRelease))return s.log((0,c.localize)(5,null,D,V.manifest.version,D)),!1;if(k&&V.manifest.version===k)return s.log((0,c.localize)(6,null,`${D}@${k}`)),!1}return!0},o=(D,k,V)=>{E.push({id:D,version:k!=="prerelease"?k:void 0,installOptions:{...g,isBuiltin:V,installPreReleaseVersion:k==="prerelease"||g.installPreReleaseVersion}})},S=[],E=[];for(const D of l)if(D instanceof p.URI)S.push(D);else{const[k,V]=(0,C.getIdAndVersion)(D);r(k,V)&&o(k,V,!1)}for(const D of u){const[k,V]=(0,C.getIdAndVersion)(D);r(k,V)&&o(k,V,!0)}if(S.length&&await Promise.all(S.map(async D=>{try{const k=await this.installVSIX(D,{...g,isBuiltin:!1},a,s);k&&n.push(k)}catch(k){s.error(k.message||k.stack||k),i.push(D.toString())}})),E.length){const D=await this.getGalleryExtensions(E);await Promise.all(E.map(async k=>{const V=D.get(k.id.toLowerCase());if(V)try{const _=await this.installFromGallery(k,V,e,a,s);_&&n.push(_)}catch(_){s.error(_.message||_.stack||_),i.push(k.id)}else s.error(`${h(k.version?`${k.id}@${k.version}`:k.id)}
${v}`),i.push(k.id)}))}if(i.length)throw new Error((0,c.localize)(7,null,i.join(", ")))}async installVSIX(l,u,g,a){const s=await this.extensionManagementService.getManifest(l);if(!s)throw new Error("Invalid vsix");if(await this.validateVSIX(s,g,a))try{return await this.extensionManagementService.install(l,u),a.log((0,c.localize)(8,null,(0,O.basename)(l))),s}catch(n){if((0,b.isCancellationError)(n))return a.log((0,c.localize)(9,null,(0,O.basename)(l))),null;throw n}return null}async getGalleryExtensions(l){const u=new Map,g=l.some(s=>s.installOptions.installPreReleaseVersion),a=await this.extensionGalleryService.getExtensions(l.map(s=>({...s,preRelease:g})),I.CancellationToken.None);for(const s of a)u.set(s.identifier.id.toLowerCase(),s);return u}async installFromGallery({id:l,version:u,installOptions:g},a,s,i,n){const e=await this.extensionGalleryService.getManifest(a,I.CancellationToken.None);if(e&&!this.validateExtensionKind(e,n))return null;const r=s.find(o=>(0,C.areSameExtensions)(o.identifier,a.identifier));if(r){if(a.version===r.manifest.version)return n.log((0,c.localize)(10,null,u?`${l}@${u}`:l)),null;n.log((0,c.localize)(11,null,l,a.version))}try{g.isBuiltin?n.log(u?(0,c.localize)(12,null,l,u):(0,c.localize)(13,null,l)):n.log(u?(0,c.localize)(14,null,l,u):(0,c.localize)(15,null,l));const o=await this.extensionManagementService.installFromGallery(a,{...g,installGivenVersion:!!u});return n.log((0,c.localize)(16,null,l,o.manifest.version)),e}catch(o){if((0,b.isCancellationError)(o))return n.log((0,c.localize)(17,null,l)),null;throw o}}validateExtensionKind(l,u){return!0}async validateVSIX(l,u,g){const a={id:(0,C.getGalleryExtensionId)(l.publisher,l.name)},i=(await this.extensionManagementService.getInstalled(1)).find(n=>(0,C.areSameExtensions)(a,n.identifier)&&(0,A.gt)(n.manifest.version,l.version));return i&&!u?(g.log((0,c.localize)(18,null,i.identifier.id,i.manifest.version,l.version)),!1):this.validateExtensionKind(l,g)}async uninstallExtensions(l,u,g=console){const a=async i=>{if(i instanceof p.URI){const n=await this.extensionManagementService.getManifest(i);return f(n)}return i},s=[];for(const i of l){const n=await a(i),r=(await this.extensionManagementService.getInstalled()).filter(o=>(0,C.areSameExtensions)(o.identifier,{id:n}));if(!r.length)throw new Error(`${this.notInstalled(n)}
${v}`);if(r.some(o=>o.type===0)){g.log((0,c.localize)(19,null,n));return}if(!u&&r.some(o=>o.isBuiltin)){g.log((0,c.localize)(20,null,n));return}g.log((0,c.localize)(21,null,n));for(const o of r)await this.extensionManagementService.uninstall(o),s.push(o);this.location?g.log((0,c.localize)(22,null,n,this.location)):g.log((0,c.localize)(23,null,n))}}async locateExtension(l,u=console){const g=await this.extensionManagementService.getInstalled();l.forEach(a=>{g.forEach(s=>{if(s.identifier.id===a&&s.location.scheme===w.Schemas.file){u.log(s.location.fsPath);return}})})}notInstalled(l){return this.location?(0,c.localize)(24,null,l,this.location):(0,c.localize)(25,null,l)}};m=fe([te(0,d.IExtensionManagementService),te(1,d.IExtensionGalleryService)],m),t.ExtensionManagementCLIService=m}),define(Z[41],ee([0,1,3,15,2,36,10,23,11,8,9]),function($,t,I,b,w,O,A,p,c,d,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsProfileScannerService=t.IExtensionsProfileScannerService=void 0,t.IExtensionsProfileScannerService=(0,d.createDecorator)("IExtensionsProfileScannerService");let P=class extends w.Disposable{constructor(v,f){super();this.fileService=v,this.logService=f,this.resourcesAccessQueueMap=new O.ResourceMap}scanProfileExtensions(v){return this.withProfileExtensions(v)}addExtensionsToProfile(v,f){return this.withProfileExtensions(f,m=>(m=m.filter(y=>v.some(([l])=>!(0,p.areSameExtensions)(y.identifier,l.identifier))),m.push(...v.map(([y,l])=>({identifier:y.identifier,version:y.manifest.version,location:y.location,metadata:l}))),m))}removeExtensionFromProfile(v,f){return this.withProfileExtensions(f,m=>m.filter(y=>!(0,p.areSameExtensions)(y.identifier,v)))}async withProfileExtensions(v,f){return this.getResourceAccessQueue(v).queue(async()=>{let m=[];try{const y=await this.fileService.readFile(v),l=JSON.parse(y.value.toString());for(const u of l){if(!u.identifier){this.logService.info("Ignoring invalid extension while scanning. Identifier does not exist.",u);continue}if(!u.location){this.logService.info("Ignoring invalid extension while scanning. Location does not exist.",u);continue}if(!u.version){this.logService.info("Ignoring invalid extension while scanning. Version does not exist.",u);continue}m.push({identifier:u.identifier,location:A.URI.revive(u.location),version:u.version,metadata:u.metadata})}}catch(y){y.fileOperationResult!==1&&this.logService.error(y)}if(f){m=f(m);const y=m.map(l=>({identifier:l.identifier,version:l.version,location:l.location.toJSON(),metadata:l.metadata}));await this.fileService.writeFile(v,b.VSBuffer.fromString(JSON.stringify(y)))}return m})}getResourceAccessQueue(v){let f=this.resourcesAccessQueueMap.get(v);return f||(f=new I.Queue,this.resourcesAccessQueueMap.set(v,f)),f}};P=fe([te(0,c.IFileService),te(1,C.ILogService)],P),t.ExtensionsProfileScannerService=P}),define(Z[120],ee([0,1,3,12,2,13,17,39,10,29,20,18,22,23,11,9]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsDownloader=void 0;let y=class extends w.Disposable{constructor(u,g,a,s){super();this.fileService=g,this.extensionGalleryService=a,this.logService=s,this.extensionsDownloadDir=c.URI.file(u.extensionsDownloadPath),this.cache=20,this.cleanUpPromise=this.cleanUp()}async downloadExtension(u,g){await this.cleanUpPromise;const a=this.getName(u),s=(0,A.joinPath)(this.extensionsDownloadDir,a);if(!await this.fileService.exists(s)){const i=(0,A.joinPath)(this.extensionsDownloadDir,`.${(0,d.generateUuid)()}`);await this.fileService.exists(i)||await this.extensionGalleryService.download(u,i,g);try{await this.rename(i,s,Date.now()+2*60*1e3)}catch(n){try{await this.fileService.del(i)}catch{}if(n.code==="ENOTEMPTY")this.logService.info("Rename failed because vsix was downloaded by another source. So ignoring renaming.",u.identifier.id);else throw this.logService.info(`Rename failed because of ${(0,b.getErrorMessage)(n)}. Deleted the vsix from downloaded location`,i.path),n}}return s}async delete(u){await this.cleanUpPromise,await this.fileService.del(u)}async rename(u,g,a){try{await C.Promises.rename(u.fsPath,g.fsPath)}catch(s){if(O.isWindows&&s&&s.code==="EPERM"&&Date.now()<a)return this.logService.info(`Failed renaming ${u} to ${g} with 'EPERM' error. Trying again...`),this.rename(u,g,a);throw s}}async cleanUp(){try{if(!await this.fileService.exists(this.extensionsDownloadDir)){this.logService.trace("Extension VSIX downlads cache dir does not exist");return}const u=await this.fileService.resolve(this.extensionsDownloadDir,{resolveMetadata:!0});if(u.children){const g=[],a=[];for(const n of u.children){const e=v.ExtensionKey.parse(n.name);e&&a.push([e,n])}const s=(0,v.groupByExtension)(a,([n])=>n),i=[];for(const n of s)n.sort((e,r)=>p.rcompare(e[0].version,r[0].version)),g.push(...n.slice(1).map(e=>e[1].resource)),i.push(n[0][1]);i.sort((n,e)=>n.mtime-e.mtime),g.push(...i.slice(0,Math.max(0,i.length-this.cache)).map(n=>n.resource)),await I.Promises.settled(g.map(n=>(this.logService.trace("Deleting vsix from cache",n.path),this.fileService.del(n))))}}catch(u){this.logService.error(u)}}getName(u){return this.cache?v.ExtensionKey.create(u).toString().toLowerCase():(0,d.generateUuid)()}};y=fe([te(0,P.INativeEnvironmentService),te(1,f.IFileService),te(2,h.IExtensionGalleryService),te(3,m.ILogService)],y),t.ExtensionsDownloader=y}),define(Z[121],ee([0,1,2,14,20,34]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsManifestCache=void 0;class A extends I.Disposable{constructor(c,d){super();this.environmentService=c,this.extensionsManifestCache=(0,b.join)(this.environmentService.userDataPath,O.MANIFEST_CACHE_FOLDER,O.USER_MANIFEST_CACHE_FILE),this._register(d.onDidInstallExtensions(C=>this.onDidInstallExtensions(C))),this._register(d.onDidUninstallExtension(C=>this.onDidUnInstallExtension(C)))}onDidInstallExtensions(c){c.some(d=>!!d.local)&&this.invalidate()}onDidUnInstallExtension(c){c.error||this.invalidate()}invalidate(){w.Promises.rm(this.extensionsManifestCache,w.RimRafMode.MOVE).then(()=>{},()=>{})}}t.ExtensionsManifestCache=A}),define(Z[122],ee([0,1,152,19,3,2,16,14,20,18,22,23,9,62]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeLanguagePackService=void 0;let f=class extends v.LanguagePackBaseService{constructor(u,g,a,s){super(a);this.extensionManagementService=u,this.logService=s,this.cache=this._register(new m(g,s)),this.extensionManagementService.registerParticipant({postInstall:async i=>this.postInstallExtension(i),postUninstall:async i=>this.postUninstallExtension(i)})}async getInstalledLanguages(){const u=await this.cache.getLanguagePacks(),g=Object.keys(u).map(a=>{const s=u[a];return{...this.createQuickPickItem(a,s.label),extensionId:s.extensions[0].extensionIdentifier.id}});return g.push({...this.createQuickPickItem("en","English"),extensionId:"default"}),g.sort((a,s)=>a.label.localeCompare(s.label)),g}async postInstallExtension(u){u&&u.manifest&&u.manifest.contributes&&u.manifest.contributes.localizations&&u.manifest.contributes.localizations.length&&(this.logService.info("Adding language packs from the extension",u.identifier.id),await this.update())}async postUninstallExtension(u){const g=await this.cache.getLanguagePacks();Object.keys(g).some(a=>g[a]&&g[a].extensions.some(s=>(0,P.areSameExtensions)(s.extensionIdentifier,u.identifier)))&&(this.logService.info("Removing language packs from the extension",u.identifier.id),await this.update())}async update(){const[u,g]=await Promise.all([this.cache.getLanguagePacks(),this.extensionManagementService.getInstalled()]),a=await this.cache.update(g);return!(0,b.equals)(Object.keys(u),Object.keys(a))}};f=fe([te(0,C.IExtensionManagementService),te(1,d.INativeEnvironmentService),te(2,C.IExtensionGalleryService),te(3,h.ILogService)],f),t.NativeLanguagePackService=f;let m=class extends O.Disposable{constructor(u,g){super();this.logService=g,this.languagePacks={},this.languagePacksFilePath=(0,p.join)(u.userDataPath,"languagepacks.json"),this.languagePacksFileLimiter=new w.Queue}getLanguagePacks(){return this.languagePacksFileLimiter.size||!this.initializedCache?this.withLanguagePacks().then(()=>this.languagePacks):Promise.resolve(this.languagePacks)}update(u){return this.withLanguagePacks(g=>{Object.keys(g).forEach(a=>delete g[a]),this.createLanguagePacksFromExtensions(g,...u)}).then(()=>this.languagePacks)}createLanguagePacksFromExtensions(u,...g){for(const a of g)a&&a.manifest&&a.manifest.contributes&&a.manifest.contributes.localizations&&a.manifest.contributes.localizations.length&&this.createLanguagePacksFromExtension(u,a);Object.keys(u).forEach(a=>this.updateHash(u[a]))}createLanguagePacksFromExtension(u,g){const a=g.identifier,s=g.manifest.contributes&&g.manifest.contributes.localizations?g.manifest.contributes.localizations:[];for(const i of s)if(g.location.scheme===A.Schemas.file&&y(i)){let n=u[i.languageId];n||(n={hash:"",extensions:[],translations:{},label:i.localizedLanguageName??i.languageName},u[i.languageId]=n);const e=n.extensions.filter(r=>(0,P.areSameExtensions)(r.extensionIdentifier,a))[0];e?e.version=g.manifest.version:n.extensions.push({extensionIdentifier:a,version:g.manifest.version});for(const r of i.translations)n.translations[r.id]=(0,p.join)(g.location.fsPath,r.path)}}updateHash(u){if(u){const g=(0,I.createHash)("md5");for(const a of u.extensions)g.update(a.extensionIdentifier.uuid||a.extensionIdentifier.id).update(a.version);u.hash=g.digest("hex")}}withLanguagePacks(u=()=>null){return this.languagePacksFileLimiter.queue(()=>{let g=null;return c.Promises.readFile(this.languagePacksFilePath,"utf8").then(void 0,a=>a.code==="ENOENT"?Promise.resolve("{}"):Promise.reject(a)).then(a=>{try{return JSON.parse(a)}catch{return{}}}).then(a=>(g=u(a),a)).then(a=>{for(const i of Object.keys(a))a[i]||delete a[i];this.languagePacks=a,this.initializedCache=!0;const s=JSON.stringify(this.languagePacks);return this.logService.debug("Writing language packs",s),c.Promises.writeFile(this.languagePacksFilePath,s)}).then(()=>g,a=>this.logService.error(a))})}};m=fe([te(0,d.INativeEnvironmentService),te(1,h.ILogService)],m);function y(l){if(typeof l.languageId!="string"||!Array.isArray(l.translations)||l.translations.length===0)return!1;for(const u of l.translations)if(typeof u.id!="string"||typeof u.path!="string")return!1;return!(l.languageName&&typeof l.languageName!="string"||l.localizedLanguageName&&typeof l.localizedLanguageName!="string")}}),define(Z[47],ee([0,1,15,93,40,8,33]),function($,t,I,b,w,O,A){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.updateProxyConfigurationsScope=t.asJson=t.asTextOrError=t.asText=t.isSuccess=t.IRequestService=void 0,t.IRequestService=(0,O.createDecorator)("requestService");function p(m){return m.res.statusCode&&m.res.statusCode>=200&&m.res.statusCode<300||m.res.statusCode===1223}t.isSuccess=p;function c(m){return m.res.statusCode===204}async function d(m){return c(m)?null:(await(0,I.streamToBuffer)(m.stream)).toString()}t.asText=d;async function C(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);return d(m)}t.asTextOrError=C;async function P(m){if(!p(m))throw new Error("Server returned "+m.res.statusCode);if(c(m))return null;const l=(await(0,I.streamToBuffer)(m.stream)).toString();try{return JSON.parse(l)}catch(u){throw u.message+=`:
`+l,u}}t.asJson=P;function h(m){f(m)}t.updateProxyConfigurationsScope=h;let v;function f(m){const y=A.Registry.as(w.Extensions.Configuration),l=v;v={id:"http",order:15,title:(0,b.localize)(0,null),type:"object",scope:m,properties:{"http.proxy":{type:"string",pattern:"^(https?|socks5?)://([^:]*(:[^@]*)?@)?([^:]+|\\[[:0-9a-fA-F]+\\])(:\\d+)?/?$|^$",markdownDescription:(0,b.localize)(1,null),restricted:!0},"http.proxyStrictSSL":{type:"boolean",default:!0,description:(0,b.localize)(2,null),restricted:!0},"http.proxyAuthorization":{type:["null","string"],default:null,markdownDescription:(0,b.localize)(3,null),restricted:!0},"http.proxySupport":{type:"string",enum:["off","on","fallback","override"],enumDescriptions:[(0,b.localize)(4,null),(0,b.localize)(5,null),(0,b.localize)(6,null),(0,b.localize)(7,null)],default:"override",description:(0,b.localize)(8,null),restricted:!0},"http.systemCertificates":{type:"boolean",default:!0,description:(0,b.localize)(9,null),restricted:!0}}},y.updateConfigurations({add:[v],remove:l?[l]:[]})}f(2)}),define(Z[123],ee([0,1,24,16,11,47]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.DownloadService=void 0;let A=class{constructor(c,d){this.requestService=c,this.fileService=d}async download(c,d,C=I.CancellationToken.None){if(c.scheme===b.Schemas.file||c.scheme===b.Schemas.vscodeRemote){await this.fileService.copy(c,d);return}const P={type:"GET",url:c.toString(!0)},h=await this.requestService.request(P,C);if(h.res.statusCode===200)await this.fileService.writeFile(d,h.stream);else{const v=await(0,O.asTextOrError)(h);throw new Error(`Expected 200, got back ${h.res.statusCode} instead.

${v}`)}}};A=fe([te(0,O.IRequestService),te(1,w.IFileService)],A),t.DownloadService=A}),define(Z[124],ee([0,1,125,5]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getProxyAgent=void 0;function w(A,p){return A.protocol==="http:"?p.HTTP_PROXY||p.http_proxy||null:A.protocol==="https:"&&(p.HTTPS_PROXY||p.https_proxy||p.HTTP_PROXY||p.http_proxy)||null}async function O(A,p,c={}){const d=(0,I.parse)(A),C=c.proxyUrl||w(d,p);if(!C)return null;const P=(0,I.parse)(C);if(!/^https?:$/.test(P.protocol||""))return null;const h={host:P.hostname||"",port:P.port||(P.protocol==="https"?"443":"80"),auth:P.auth,rejectUnauthorized:(0,b.isBoolean)(c.strictSSL)?c.strictSSL:!0};return d.protocol==="http:"?new(await new Promise((v,f)=>{$(["http-proxy-agent"],v,f)}))(h):new(await new Promise((v,f)=>{$(["https-proxy-agent"],v,f)}))(h)}t.getProxyAgent=O}),define(Z[126],ee([0,1,57,14,94,24,30,12,13,29,77,153,3]),function($,t,I,b,w,O,A,p,c,d,C,P,h){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getResolvedShellEnv=void 0;const v=1e4;let f;async function m(l,u,g){return u["force-disable-user-env"]?(l.trace("resolveShellEnv(): skipped (--force-disable-user-env)"),{}):c.isWindows?(l.trace("resolveShellEnv(): skipped (Windows)"),{}):(0,P.isLaunchedFromCli)(g)&&!u["force-user-env"]?(l.trace("resolveShellEnv(): skipped (VSCODE_CLI is set)"),{}):((0,P.isLaunchedFromCli)(g)?l.trace("resolveShellEnv(): running (--force-user-env)"):l.trace("resolveShellEnv(): running (macOS/Linux)"),f||(f=h.Promises.withAsyncBody(async(a,s)=>{const i=new O.CancellationTokenSource,n=setTimeout(()=>{i.dispose(!0),s(new Error((0,w.localize)(0,null)))},v);try{a(await y(l,i.token))}catch(e){!(0,p.isCancellationError)(e)&&!i.token.isCancellationRequested?s(new Error((0,w.localize)(1,null,(0,A.toErrorMessage)(e)))):a({})}finally{clearTimeout(n),i.dispose()}})),f)}t.getResolvedShellEnv=m;async function y(l,u){const g=process.env.ELECTRON_RUN_AS_NODE;l.trace("getUnixShellEnvironment#runAsNode",g);const a=process.env.ELECTRON_NO_ATTACH_CONSOLE;l.trace("getUnixShellEnvironment#noAttach",a);const s=(0,d.generateUuid)().replace(/-/g,"").substr(0,12),i=new RegExp(s+"(.*)"+s),n={...process.env,ELECTRON_RUN_AS_NODE:"1",ELECTRON_NO_ATTACH_CONSOLE:"1"};l.trace("getUnixShellEnvironment#env",n);const e=await(0,C.getSystemShell)(c.OS,n);return l.trace("getUnixShellEnvironment#shell",e),new Promise((r,o)=>{if(u.isCancellationRequested)return o((0,p.canceled)());const S=(0,b.basename)(e);let E,D;const k=process.versions.electron&&process.versions["microsoft-build"]?"--ms-enable-electron-run-as-node":"";/^pwsh(-preview)?$/.test(S)?(E=`& '${process.execPath}' ${k} -p '''${s}'' + JSON.stringify(process.env) + ''${s}'''`,D=["-Login","-Command"]):(E=`'${process.execPath}' ${k} -p '"${s}" + JSON.stringify(process.env) + "${s}"'`,S==="tcsh"?D=["-ic"]:D=["-ilc"]),l.trace("getUnixShellEnvironment#spawn",JSON.stringify(D),E);const V=(0,I.spawn)(e,[...D,E],{detached:!0,stdio:["ignore","pipe","pipe"],env:n});u.onCancellationRequested(()=>(V.kill(),o((0,p.canceled)()))),V.on("error",Q=>{l.error("getUnixShellEnvironment#errorChildProcess",(0,A.toErrorMessage)(Q)),o(Q)});const _=[];V.stdout.on("data",Q=>_.push(Q));const G=[];V.stderr.on("data",Q=>G.push(Q)),V.on("close",(Q,ne)=>{const ce=Buffer.concat(_).toString("utf8");l.trace("getUnixShellEnvironment#raw",ce);const re=Buffer.concat(G).toString("utf8");if(re.trim()&&l.trace("getUnixShellEnvironment#stderr",re),Q||ne)return o(new Error((0,w.localize)(2,null,Q,ne)));const ge=i.exec(ce),ae=ge?ge[1]:"{}";try{const N=JSON.parse(ae);g?N.ELECTRON_RUN_AS_NODE=g:delete N.ELECTRON_RUN_AS_NODE,a?N.ELECTRON_NO_ATTACH_CONSOLE=a:delete N.ELECTRON_NO_ATTACH_CONSOLE,delete N.XDG_RUNTIME_DIR,l.trace("getUnixShellEnvironment#result",N),r(N)}catch(N){l.error("getUnixShellEnvironment#errorCaught",(0,A.toErrorMessage)(N)),o(N)}})})}}),define(Z[65],ee([0,1,8]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IStateService=void 0,t.IStateService=(0,I.createDecorator)("stateService")}),define(Z[127],ee([0,1,3,15,5,18,11,9]),function($,t,I,b,w,O,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.StateService=t.FileStorage=void 0;class c{constructor(P,h,v){this.storagePath=P,this.logService=h,this.fileService=v,this.storage=Object.create(null),this.lastSavedStorageContents="",this.flushDelayer=new I.ThrottledDelayer(100),this.initializing=void 0,this.closing=void 0}init(){return this.initializing||(this.initializing=this.doInit()),this.initializing}async doInit(){try{this.lastSavedStorageContents=(await this.fileService.readFile(this.storagePath)).value.toString(),this.storage=JSON.parse(this.lastSavedStorageContents)}catch(P){P.fileOperationResult!==1&&this.logService.error(P)}}getItem(P,h){const v=this.storage[P];return(0,w.isUndefinedOrNull)(v)?h:v}setItem(P,h){this.setItems([{key:P,data:h}])}setItems(P){let h=!1;for(const{key:v,data:f}of P)this.storage[v]!==f&&((0,w.isUndefinedOrNull)(f)?(0,w.isUndefined)(this.storage[v])||(this.storage[v]=void 0,h=!0):(this.storage[v]=f,h=!0));h&&this.save()}removeItem(P){(0,w.isUndefined)(this.storage[P])||(this.storage[P]=void 0,this.save())}async save(P){if(!this.closing)return this.flushDelayer.trigger(()=>this.doSave(),P)}async doSave(){if(!this.initializing)return;await this.initializing;const P=JSON.stringify(this.storage,null,4);if(P!==this.lastSavedStorageContents)try{await this.fileService.writeFile(this.storagePath,b.VSBuffer.fromString(P)),this.lastSavedStorageContents=P}catch(h){this.logService.error(h)}}async close(){return this.closing||(this.closing=this.flushDelayer.trigger(()=>this.doSave(),0)),this.closing}}t.FileStorage=c;let d=class{constructor(P,h,v){this.fileStorage=new c(P.stateResource,h,v)}async init(){await this.fileStorage.init()}getItem(P,h){return this.fileStorage.getItem(P,h)}};d=fe([te(0,O.IEnvironmentService),te(1,p.ILogService),te(2,A.IFileService)],d),t.StateService=d}),define(Z[66],ee([0,1,13,32,10,29]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.verifyMicrosoftInternalDomain=t.resolveCommonProperties=void 0;function A(d){if(I.platform===2&&/^penguin(\.|$)/i.test(d))return"chromebook"}async function p(d,C,P,h,v,f,m,y,l,u){const g=Object.create(null);g["common.machineId"]=m,g.sessionID=(0,O.generateUuid)()+Date.now(),g.commitHash=v,g.version=f,g["common.platformVersion"]=(C||"").replace(/^(\d+)(\.\d+)?(\.\d+)?(.*)/,"$1$2$3"),g["common.platform"]=(0,I.PlatformToString)(I.platform),g["common.nodePlatform"]=b.platform,g["common.nodeArch"]=h,g["common.product"]=u||"desktop",y&&(g["common.msftInternal"]=y);let a=0;const s=Date.now();Object.defineProperties(g,{timestamp:{get:()=>new Date,enumerable:!0},"common.timesincesessionstart":{get:()=>Date.now()-s,enumerable:!0},"common.sequence":{get:()=>a++,enumerable:!0}}),I.isLinuxSnap&&(g["common.snap"]="true");const i=A(P);i&&(g["common.platformDetail"]=i);try{const n=await d.readFile(w.URI.file(l));g["common.source"]=n.value.toString().slice(0,30)}catch{}return g}t.resolveCommonProperties=p;function c(d){const C=b.env.USERDNSDOMAIN;if(!C)return!1;const P=C.toLowerCase();return d.some(h=>P===h)}t.verifyMicrosoftInternalDomain=c}),define(Z[35],ee([0,1,8]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryConfiguration=t.TelemetryLevel=t.TELEMETRY_OLD_SETTING_ID=t.TELEMETRY_SETTING_ID=t.TELEMETRY_SECTION_ID=t.machineIdKey=t.lastSessionDateStorageKey=t.firstSessionDateStorageKey=t.currentSessionDateStorageKey=t.ICustomEndpointTelemetryService=t.ITelemetryService=void 0,t.ITelemetryService=(0,I.createDecorator)("telemetryService"),t.ICustomEndpointTelemetryService=(0,I.createDecorator)("customEndpointTelemetryService"),t.currentSessionDateStorageKey="telemetry.currentSessionDate",t.firstSessionDateStorageKey="telemetry.firstSessionDate",t.lastSessionDateStorageKey="telemetry.lastSessionDate",t.machineIdKey="telemetry.machineId",t.TELEMETRY_SECTION_ID="telemetry",t.TELEMETRY_SETTING_ID="telemetry.telemetryLevel",t.TELEMETRY_OLD_SETTING_ID="telemetry.enableTelemetry";var b;(function(O){O[O.NONE=0]="NONE",O[O.CRASH=1]="CRASH",O[O.ERROR=2]="ERROR",O[O.USAGE=3]="USAGE"})(b=t.TelemetryLevel||(t.TelemetryLevel={}));var w;(function(O){O.OFF="off",O.CRASH="crash",O.ERROR="error",O.ON="all"})(w=t.TelemetryConfiguration||(t.TelemetryConfiguration={}))}),define(Z[42],ee([0,1,26,52,5,21,66,35]),function($,t,I,b,w,O,A,p){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getPiiPathsFromEnvironment=t.isInternalTelemetry=t.cleanRemoteAuthority=t.validateTelemetryData=t.getTelemetryLevel=t.supportsTelemetry=t.configurationTelemetry=t.NullAppender=t.NullEndpointTelemetryService=t.NullTelemetryService=t.NullTelemetryServiceShape=void 0;class c{constructor(){this.sendErrorTelemetry=!1,this.telemetryLevel=(0,b.staticObservableValue)(0)}publicLog(i,n){return Promise.resolve(void 0)}publicLog2(i,n){return this.publicLog(i,n)}publicLogError(i,n){return Promise.resolve(void 0)}publicLogError2(i,n){return this.publicLogError(i,n)}setExperimentProperty(){}getTelemetryInfo(){return Promise.resolve({instanceId:"someValue.instanceId",sessionId:"someValue.sessionId",machineId:"someValue.machineId",firstSessionDate:"someValue.firstSessionDate"})}}t.NullTelemetryServiceShape=c,t.NullTelemetryService=new c;class d{async publicLog(i,n,e){}async publicLogError(i,n,e){}}t.NullEndpointTelemetryService=d,t.NullAppender={log:()=>null,flush:()=>Promise.resolve(null)};function C(s,i){return i.onDidChangeConfiguration(n=>{n.source!==7&&s.publicLog2("updateConfiguration",{configurationSource:(0,O.ConfigurationTargetToString)(n.source),configurationKeys:l(n.sourceConfig)})})}t.configurationTelemetry=C;function P(s,i){return!(i.disableTelemetry||!s.enableTelemetry||i.extensionTestsLocationURI)}t.supportsTelemetry=P;function h(s){const i=s.getValue(p.TELEMETRY_SETTING_ID),n=s.getValue("telemetry.enableCrashReporter");if(s.getValue(p.TELEMETRY_OLD_SETTING_ID)===!1||n===!1)return 0;switch(i??"all"){case"all":return 3;case"error":return 2;case"crash":return 1;case"off":return 0}}t.getTelemetryLevel=h;function v(s){const i={},n={},e={};y(s,e);for(let r in e){r=r.length>150?r.substr(r.length-149):r;const o=e[r];typeof o=="number"?n[r]=o:typeof o=="boolean"?n[r]=o?1:0:typeof o=="string"?(o.length>8192&&console.warn(`Telemetry property: ${r} has been trimmed to 8192, the original length is ${o.length}`),i[r]=o.substring(0,8191)):typeof o!="undefined"&&o!==null&&(i[r]=o)}return{properties:i,measurements:n}}t.validateTelemetryData=v;const f=["ssh-remote","dev-container","attached-container","wsl","tunneling"];function m(s){if(!s)return"none";for(const i of f)if(s.startsWith(`${i}+`))return i;return"other"}t.cleanRemoteAuthority=m;function y(s,i,n=0,e){if(!!s)for(const r of Object.getOwnPropertyNames(s)){const o=s[r],S=e?e+r:r;Array.isArray(o)?i[S]=(0,I.safeStringify)(o):o instanceof Date?i[S]=o.toISOString():(0,w.isObject)(o)?n<2?y(o,i,n+1,S+"."):i[S]=(0,I.safeStringify)(o):i[S]=o}}function l(s){if(!s)return[];const i=[];return u(i,"",s),i}function u(s,i,n){n&&typeof n=="object"&&!Array.isArray(n)?Object.keys(n).forEach(e=>u(s,i?`${i}.${e}`:e,n[e])):s.push(i)}function g(s,i){const n=s.msftInternalDomains||[],e=i.getValue("telemetry.internalTesting");return(0,A.verifyMicrosoftInternalDomain)(n)||e}t.isInternalTelemetry=g;function a(s){return[s.appRoot,s.extensionsPath,s.userHome.fsPath,s.tmpDir.fsPath,s.userDataPath]}t.getPiiPathsFromEnvironment=a}),define(Z[128],ee([0,1,101,42]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.resolveMarketplaceHeaders=void 0;async function w(O,A,p,c,d,C,P){const h={"X-Market-Client-Id":`VSCode ${O}`,"User-Agent":`VSCode ${O} (${A.nameShort})`},v=await(0,I.getServiceMachineId)(p,d,C),{sessionId:f}=await P.getTelemetryInfo();return(0,b.supportsTelemetry)(A,p)&&(0,b.getTelemetryLevel)(c)===3&&(h["X-Market-User-Id"]=v,h["VSCode-SessionId"]=f),h}t.resolveMarketplaceHeaders=w}),define(Z[129],ee([0,1,12,26,42]),function($,t,I,b,w){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractOneDataSystemAppender=void 0;const O="https://mobile.events.data.microsoft.com/OneCollector/1.0";async function A(c,d,C){const P=await new Promise((y,l)=>{$(["@microsoft/1ds-core-js"],y,l)}),h=await new Promise((y,l)=>{$(["@microsoft/1ds-post-js"],y,l)}),v=new P.AppInsightsCore,f=new h.PostChannel,m={instrumentationKey:c,endpointUrl:O,loggingLevelTelemetry:0,loggingLevelConsole:0,disableCookiesUsage:!0,disableDbgExt:!0,disableInstrumentationKeyValidation:!0,channels:[[f]]};if(C){m.extensionConfig={};const y={alwaysUseXhrOverride:!0,httpXHROverride:C};m.extensionConfig[f.identifier]=y}return v.initialize(m,[]),v.addTelemetryInitializer(y=>{d&&(y.ext=y.ext??{},y.ext.utc=y.ext.utc??{},y.ext.utc.flags=8462029)}),v}class p{constructor(d,C,P,h,v){this._isInternalTelemetry=d,this._eventPrefix=C,this._defaultData=P,this._xhrOverride=v,this.endPointUrl=O,this._defaultData||(this._defaultData={}),typeof h=="function"?this._aiCoreOrKey=h():this._aiCoreOrKey=h,this._asyncAiCore=null}_withAIClient(d){if(!!this._aiCoreOrKey){if(typeof this._aiCoreOrKey!="string"){d(this._aiCoreOrKey);return}this._asyncAiCore||(this._asyncAiCore=A(this._aiCoreOrKey,this._isInternalTelemetry,this._xhrOverride)),this._asyncAiCore.then(C=>{d(C)},C=>{(0,I.onUnexpectedError)(C),console.error(C)})}}log(d,C){if(!this._aiCoreOrKey)return;C=(0,b.mixin)(C,this._defaultData),C=(0,w.validateTelemetryData)(C);const P=this._eventPrefix+"/"+d;try{this._withAIClient(h=>{h.pluginVersionString=C?.properties.version??"Unknown",h.track({name:P,baseData:{name:P,properties:C?.properties,measurements:C?.measurements}})})}catch{}}flush(){return this._aiCoreOrKey?new Promise(d=>{this._withAIClient(C=>{C.unload(!0,()=>{this._aiCoreOrKey=void 0,d(void 0)})})}):Promise.resolve(void 0)}}t.AbstractOneDataSystemAppender=p}),define(Z[130],ee([0,1,2,26,52,13,31,95,21,40,131,27,33,35,42]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.TelemetryService=void 0;let m=class{constructor(u,g,a){this._configurationService=g,this._productService=a,this._experimentProperties={},this.telemetryLevel=new w.MutableObservableValue(3),this._disposables=new I.DisposableStore,this._cleanupPatterns=[],this._appenders=u.appenders,this._commonProperties=u.commonProperties||Promise.resolve({}),this._piiPaths=u.piiPaths||[],this._sendErrorTelemetry=!!u.sendErrorTelemetry,this._cleanupPatterns=[/file:\/\/\/.*?\/resources\/app\//gi];for(const s of this._piiPaths)this._cleanupPatterns.push(new RegExp((0,A.escapeRegExpCharacters)(s),"gi"));this._updateTelemetryLevel(),this._configurationService.onDidChangeConfiguration(this._updateTelemetryLevel,this,this._disposables)}setExperimentProperty(u,g){this._experimentProperties[u]=g}_updateTelemetryLevel(){let u=(0,f.getTelemetryLevel)(this._configurationService);const g=this._productService.enabledTelemetryLevels;if(g){this._sendErrorTelemetry=this.sendErrorTelemetry?g.error:!1;const a=g.usage?3:g.error?2:0;u=Math.min(u,a)}this.telemetryLevel.value=u}get sendErrorTelemetry(){return this._sendErrorTelemetry}async getTelemetryInfo(){const u=await this._commonProperties,g=u.sessionID,a=u["common.machineId"],s=u["common.firstSessionDate"],i=u["common.msftInternal"];return{sessionId:g,machineId:a,firstSessionDate:s,msftInternal:i}}dispose(){this._disposables.dispose()}_log(u,g,a,s){return this.telemetryLevel.value<g?Promise.resolve(void 0):this._commonProperties.then(i=>{a=(0,b.mixin)(a,i),a=(0,b.mixin)(a,this._experimentProperties),a=(0,b.cloneAndChange)(a,n=>{if(typeof n=="string")return this._cleanupInfo(n,s)}),this._appenders.forEach(n=>n.log(u,a))},i=>{console.error(i)})}publicLog(u,g,a){return this._log(u,3,g,a)}publicLog2(u,g,a){return this.publicLog(u,g,a)}publicLogError(u,g){return this._sendErrorTelemetry?this._log(u,2,g,!0):Promise.resolve(void 0)}publicLogError2(u,g){return this.publicLogError(u,g)}_anonymizeFilePaths(u){let g=u;const a=[];for(const e of this._cleanupPatterns)for(;;){const r=e.exec(u);if(!r)break;a.push([r.index,e.lastIndex])}const s=/^[\\\/]?(node_modules|node_modules\.asar)[\\\/]/,i=/(file:\/\/)?([a-zA-Z]:(\\\\|\\|\/)|(\\\\|\\|\/))?([\w-\._]+(\\\\|\\|\/))+[\w-\._]*/g;let n=0;for(g="";;){const e=i.exec(u);if(!e)break;!s.test(e[0])&&a.every(([r,o])=>e.index<r||e.index>=o)&&(g+=u.substring(n,e.index)+"<REDACTED: user-file-path>",n=i.lastIndex)}return n<u.length&&(g+=u.substr(n)),g}_removePropertiesWithPossibleUserInfo(u){if(!u)return u;const g=u.toLowerCase(),a=[{label:"Google API Key",regex:/AIza[A-Za-z0-9_\\\-]{35}/},{label:"Slack Token",regex:/xox[pbar]\-[A-Za-z0-9]/},{label:"Generic Secret",regex:/(key|token|sig|secret|signature|password|passwd|pwd|android:value)[^a-zA-Z0-9]/},{label:"Email",regex:/@[a-zA-Z0-9-.]+/}];for(const s of a)if(s.regex.test(g))return`<REDACTED: ${s.label}>`;return u}_cleanupInfo(u,g){let a=u;g&&(a=this._anonymizeFilePaths(a));for(const s of this._cleanupPatterns)a=a.replace(s,"");return a=this._removePropertiesWithPossibleUserInfo(a),a}};m.IDLE_START_EVENT_NAME="UserIdleStart",m.IDLE_STOP_EVENT_NAME="UserIdleStop",m=fe([te(1,c.IConfigurationService),te(2,P.IProductService)],m),t.TelemetryService=m;function y(){const l=(0,p.localize)(0,null,C.default.nameLong),u=C.default.privacyStatementUrl?(0,p.localize)(2,null,"https://aka.ms/vscode-telemetry",C.default.privacyStatementUrl):(0,p.localize)(1,null,"https://aka.ms/vscode-telemetry"),g=O.isWeb?"":(0,p.localize)(3,null),a=(0,p.localize)(4,null),s=(0,p.localize)(5,null),i=(0,p.localize)(6,null),n=(0,p.localize)(7,null),e=`
|       | ${a} | ${s} | ${i} |
|:------|:---------------------:|:---------------:|:--------------:|
| all   |            \u2713          |        \u2713        |        \u2713       |
| error |            \u2713          |        \u2713        |        -       |
| crash |            \u2713          |        -        |        -       |
| off   |            -          |        -        |        -       |
`,r=(0,p.localize)(8,null);return`
${l} ${u} ${g}

&nbsp;

${n}
${e}

&nbsp;

${r}
`}h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(9,null),properties:{[v.TELEMETRY_SETTING_ID]:{type:"string",enum:["all","error","crash","off"],enumDescriptions:[(0,p.localize)(10,null),(0,p.localize)(11,null),(0,p.localize)(12,null),(0,p.localize)(13,null)],markdownDescription:y(),default:"all",restricted:!0,scope:1,tags:["usesOnlineServices","telemetry"]}}}),h.Registry.as(d.Extensions.Configuration).registerConfiguration({id:v.TELEMETRY_SECTION_ID,order:110,type:"object",title:(0,p.localize)(14,null),properties:{[v.TELEMETRY_OLD_SETTING_ID]:{type:"boolean",markdownDescription:C.default.privacyStatementUrl?(0,p.localize)(16,null,C.default.nameLong,C.default.privacyStatementUrl):(0,p.localize)(15,null,C.default.nameLong),default:!0,restricted:!0,markdownDeprecationMessage:(0,p.localize)(17,null,`\`#${v.TELEMETRY_SETTING_ID}#\``),scope:1,tags:["usesOnlineServices","telemetry"]}}})}),define(Z[132],ee([0,1,154,129]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.OneDataSystemAppender=void 0;class w extends b.AbstractOneDataSystemAppender{constructor(A,p,c,d){const C={sendPOST:(P,h)=>{const v={method:"POST",headers:{...P.headers,"Content-Type":"application/json","Content-Length":Buffer.byteLength(P.data)}};try{const f=I.request(P.urlString,v,m=>{m.on("data",function(y){h(m.statusCode??200,m.headers,y.toString())}),m.on("error",function(y){h(0,{})})});f.write(P.data),f.end()}catch{h(0,{})}}};super(A,p,c,d,C)}}t.OneDataSystemAppender=w}),define(Z[133],ee([0,1,14,20]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buildTelemetryMessage=void 0;async function w(O,A){const p=Object.create(null),c=(C,P)=>{const h=JSON.parse(C);p[P]=h};if(A){const C=[],P=await b.Promises.readdir(A);for(const v of P)try{(await b.Promises.stat((0,I.join)(A,v))).isDirectory()&&C.push(v)}catch{}const h=[];for(const v of C)(await b.Promises.readdir((0,I.join)(A,v))).filter(m=>m==="telemetry.json").length===1&&h.push(v);for(const v of h){const f=(await b.Promises.readFile((0,I.join)(A,v,"telemetry.json"))).toString();c(f,v)}}let d=(await b.Promises.readFile((0,I.join)(O,"telemetry-core.json"))).toString();return c(d,"vscode-core"),d=(await b.Promises.readFile((0,I.join)(O,"telemetry-extensions.json"))).toString(),c(d,"vscode-extensions"),JSON.stringify(p,null,4)}t.buildTelemetryMessage=w}),define(Z[28],ee([0,1,8]),function($,t,I){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.IUriIdentityService=void 0,t.IUriIdentityService=(0,I.createDecorator)("IUriIdentityService")}),define(Z[134],ee([0,1,4,2,10,18,23,11,9,28]),function($,t,I,b,w,O,A,p,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsWatcher=void 0;let C=class extends b.Disposable{constructor(h,v,f,m,y){super();this.extensionsManagementService=h,this.logService=m,this.uriIdentityService=y,this._onDidChangeExtensionsByAnotherSource=this._register(new I.Emitter),this.onDidChangeExtensionsByAnotherSource=this._onDidChangeExtensionsByAnotherSource.event,this.startTimestamp=0,this.installingExtensions=[],this.extensionsManagementService.getInstalled().then(u=>{this.installedExtensions=u.map(g=>g.identifier),this.startTimestamp=Date.now()}),this._register(h.onInstallExtension(u=>this.onInstallExtension(u))),this._register(h.onDidInstallExtensions(u=>this.onDidInstallExtensions(u))),this._register(h.onDidUninstallExtension(u=>this.onDidUninstallExtension(u)));const l=w.URI.file(f.extensionsPath);this._register(v.watch(l)),this._register(I.Event.filter(v.onDidFilesChange,u=>u.rawChanges.some(g=>this.doesChangeAffects(g,l)))(()=>this.onDidChange()))}doesChangeAffects(h,v){return h.type!==1&&h.type!==2||!this.uriIdentityService.extUri.isEqual(this.uriIdentityService.extUri.dirname(h.resource),v)?!1:this.uriIdentityService.extUri.isEqual(h.resource,this.uriIdentityService.extUri.joinPath(v,".obsolete"))?!0:!this.uriIdentityService.extUri.basename(h.resource).startsWith(".")}onInstallExtension(h){this.addInstallingExtension(h.identifier)}onDidInstallExtensions(h){for(const v of h)this.removeInstallingExtension(v.identifier),v.local&&this.addInstalledExtension(v.identifier)}onDidUninstallExtension(h){h.error||this.removeInstalledExtension(h.identifier)}addInstallingExtension(h){this.removeInstallingExtension(h),this.installingExtensions.push(h)}removeInstallingExtension(h){this.installingExtensions=this.installingExtensions.filter(v=>!(0,A.areSameExtensions)(v,h))}addInstalledExtension(h){this.installedExtensions&&(this.removeInstalledExtension(h),this.installedExtensions.push(h))}removeInstalledExtension(h){this.installedExtensions&&(this.installedExtensions=this.installedExtensions.filter(v=>!(0,A.areSameExtensions)(v,h)))}async onDidChange(){if(this.installedExtensions){const h=await this.extensionsManagementService.getInstalled(),v=h.filter(m=>[...this.installingExtensions,...this.installedExtensions].some(y=>(0,A.areSameExtensions)(y,m.identifier))?!1:m.installedTimestamp&&m.installedTimestamp>this.startTimestamp?(this.logService.info("Detected extension installed from another source",m.identifier.id),!0):(this.logService.info("Ignored extension installed by another source because of invalid timestamp",m.identifier.id),!1)),f=this.installedExtensions.filter(m=>this.installingExtensions.some(y=>(0,A.areSameExtensions)(y,m))?!1:h.every(y=>!(0,A.areSameExtensions)(y.identifier,m))?(this.logService.info("Detected extension removed from another source",m.id),!0):!1);this.installedExtensions=h.map(m=>m.identifier),(v.length||f.length)&&this._onDidChangeExtensionsByAnotherSource.fire({added:v,removed:f})}}};C=fe([te(1,p.IFileService),te(2,O.INativeEnvironmentService),te(3,c.ILogService),te(4,d.IUriIdentityService)],C),t.ExtensionsWatcher=C}),define(Z[135],ee([0,1,28,102,11,17,69,4,2]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UriIdentityService=void 0;class d{constructor(h){this.uri=h,this.time=d._clock++}touch(){return this.time=d._clock++,this}}d._clock=0;let C=class{constructor(h){this._fileService=h,this._dispooables=new c.DisposableStore,this._limit=2**16;const v=new Map,f=m=>{let y=v.get(m.scheme);return y===void 0&&(y=h.hasProvider(m)&&!this._fileService.hasCapability(m,1024),v.set(m.scheme,y)),y};this._dispooables.add(p.Event.any(h.onDidChangeFileSystemProviderRegistrations,h.onDidChangeFileSystemProviderCapabilities)(m=>{v.delete(m.scheme)})),this.extUri=new O.ExtUri(f),this._canonicalUris=new A.SkipList((m,y)=>this.extUri.compare(m,y,!0),this._limit)}dispose(){this._dispooables.dispose(),this._canonicalUris.clear()}asCanonicalUri(h){this._fileService.hasProvider(h)&&(h=(0,O.normalizePath)(h));const v=this._canonicalUris.get(h);return v?v.touch().uri.with({fragment:h.fragment}):(this._canonicalUris.set(h,new d(h)),this._checkTrim(),h)}_checkTrim(){if(this._canonicalUris.size<this._limit)return;const h=[...this._canonicalUris.entries()].sort((f,m)=>f[1].touch<m[1].touch?1:f[1].touch>m[1].touch?-1:0);d._clock=0,this._canonicalUris.clear();const v=this._limit*.5;for(let f=0;f<v;f++)this._canonicalUris.set(h[f][0],h[f][1].touch())}};C=fe([te(0,w.IFileService)],C),t.UriIdentityService=C,(0,b.registerSingleton)(I.IUriIdentityService,C,!0)}),define(Z[136],ee([0,1,97,14,36,17,10,8,16]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.hasWorkspaceFileExtension=t.isSavedWorkspace=t.isTemporaryWorkspace=t.isUntitledWorkspace=t.UNTITLED_WORKSPACE_NAME=t.WORKSPACE_FILTER=t.WORKSPACE_EXTENSION=t.toWorkspaceFolder=t.WorkspaceFolder=t.Workspace=t.isWorkspaceFolder=t.isWorkspace=t.WorkbenchState=t.reviveIdentifier=t.isWorkspaceIdentifier=t.toWorkspaceIdentifier=t.isSingleFolderWorkspaceIdentifier=t.IWorkspaceContextService=void 0,t.IWorkspaceContextService=(0,p.createDecorator)("contextService");function d(e){const r=e;return typeof r?.id=="string"&&A.URI.isUri(r.uri)}t.isSingleFolderWorkspaceIdentifier=d;function C(e){if(e.configuration)return{id:e.id,configPath:e.configuration};if(e.folders.length===1)return{id:e.id,uri:e.folders[0].uri}}t.toWorkspaceIdentifier=C;function P(e){const r=e;return typeof r?.id=="string"&&A.URI.isUri(r.configPath)}t.isWorkspaceIdentifier=P;function h(e){const r=e;if(r?.uri)return{id:r.id,uri:A.URI.revive(r.uri)};const o=e;if(o?.configPath)return{id:o.id,configPath:A.URI.revive(o.configPath)};if(e?.id)return{id:e.id}}t.reviveIdentifier=h;var v;(function(e){e[e.EMPTY=1]="EMPTY",e[e.FOLDER=2]="FOLDER",e[e.WORKSPACE=3]="WORKSPACE"})(v=t.WorkbenchState||(t.WorkbenchState={}));function f(e){const r=e;return!!(r&&typeof r=="object"&&typeof r.id=="string"&&Array.isArray(r.folders))}t.isWorkspace=f;function m(e){const r=e;return!!(r&&typeof r=="object"&&A.URI.isUri(r.uri)&&typeof r.name=="string"&&typeof r.toResource=="function")}t.isWorkspaceFolder=m;class y{constructor(r,o,S,E,D){this._id=r,this._transient=S,this._configuration=E,this._ignorePathCasing=D,this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=o}update(r){this._id=r.id,this._configuration=r.configuration,this._transient=r.transient,this._ignorePathCasing=r._ignorePathCasing,this.folders=r.folders}get folders(){return this._folders}set folders(r){this._folders=r,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(r){this._configuration=r}getFolder(r){return r&&this._foldersMap.findSubstr(r)||null}updateFoldersMap(){this._foldersMap=w.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const r of this.folders)this._foldersMap.set(r.uri,r)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}t.Workspace=y;class l{constructor(r,o){this.raw=o,this.uri=r.uri,this.index=r.index,this.name=r.name}toResource(r){return(0,O.joinPath)(this.uri,r)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}t.WorkspaceFolder=l;function u(e){return new l({uri:e,index:0,name:(0,O.basenameOrAuthority)(e)},{uri:e.toString()})}t.toWorkspaceFolder=u,t.WORKSPACE_EXTENSION="code-workspace";const g=`.${t.WORKSPACE_EXTENSION}`;t.WORKSPACE_FILTER=[{name:(0,I.localize)(0,null),extensions:[t.WORKSPACE_EXTENSION]}],t.UNTITLED_WORKSPACE_NAME="workspace.json";function a(e,r){return O.extUriBiasedIgnorePathCase.isEqualOrParent(e,r.untitledWorkspacesHome)}t.isUntitledWorkspace=a;function s(e){let r;return A.URI.isUri(e)?r=e:r=e.configuration,r?.scheme===c.Schemas.tmp}t.isTemporaryWorkspace=s;function i(e,r){return!a(e,r)&&!s(e)}t.isSavedWorkspace=i;function n(e){return(typeof e=="string"?(0,b.extname)(e):(0,O.extname)(e))===g}t.hasWorkspaceFileExtension=n}),define(Z[25],ee([0,1,53,4,2,17,5,10,96,18,11,8,9,136,36,28,3,29]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=t.toUserDataProfile=t.EXTENSIONS_RESOURCE_NAME=t.reviveProfile=t.IUserDataProfilesService=t.PROFILES_ENABLEMENT_CONFIG=t.isUserDataProfile=void 0;function u(i){const n=i;return!!(n&&typeof n=="object"&&typeof n.id=="string"&&typeof n.isDefault=="boolean"&&typeof n.name=="string"&&p.URI.isUri(n.location)&&p.URI.isUri(n.globalStorageHome)&&p.URI.isUri(n.settingsResource)&&p.URI.isUri(n.keybindingsResource)&&p.URI.isUri(n.tasksResource)&&p.URI.isUri(n.snippetsHome)&&((0,A.isUndefined)(n.extensionsResource)||p.URI.isUri(n.extensionsResource)))}t.isUserDataProfile=u,t.PROFILES_ENABLEMENT_CONFIG="workbench.experimental.settingsProfiles.enabled",t.IUserDataProfilesService=(0,P.createDecorator)("IUserDataProfilesService");function g(i,n){return{id:i.id,isDefault:i.isDefault,name:i.name,location:p.URI.revive(i.location).with({scheme:n}),globalStorageHome:p.URI.revive(i.globalStorageHome).with({scheme:n}),settingsResource:p.URI.revive(i.settingsResource).with({scheme:n}),keybindingsResource:p.URI.revive(i.keybindingsResource).with({scheme:n}),tasksResource:p.URI.revive(i.tasksResource).with({scheme:n}),snippetsHome:p.URI.revive(i.snippetsHome).with({scheme:n}),extensionsResource:p.URI.revive(i.extensionsResource)?.with({scheme:n})}}t.reviveProfile=g,t.EXTENSIONS_RESOURCE_NAME="extensions.json";function a(i,n,e){return{id:(0,I.hash)(n.path).toString(16),name:i,location:n,isDefault:!1,globalStorageHome:(0,O.joinPath)(n,"globalStorage"),settingsResource:(0,O.joinPath)(n,"settings.json"),keybindingsResource:(0,O.joinPath)(n,"keybindings.json"),tasksResource:(0,O.joinPath)(n,"tasks.json"),snippetsHome:(0,O.joinPath)(n,"snippets"),extensionsResource:(0,O.joinPath)(n,t.EXTENSIONS_RESOURCE_NAME),useDefaultFlags:e}}t.toUserDataProfile=a;let s=class extends w.Disposable{constructor(n,e,r,o){super();this.environmentService=n,this.fileService=e,this.uriIdentityService=r,this.logService=o,this.enabled=!1,this.defaultProfileShouldIncludeExtensionsResourceAlways=!1,this._onDidChangeProfiles=this._register(new b.Emitter),this.onDidChangeProfiles=this._onDidChangeProfiles.event,this._onWillCreateProfile=this._register(new b.Emitter),this.onWillCreateProfile=this._onWillCreateProfile.event,this._onWillRemoveProfile=this._register(new b.Emitter),this.onWillRemoveProfile=this._onWillRemoveProfile.event,this._onDidResetWorkspaces=this._register(new b.Emitter),this.onDidResetWorkspaces=this._onDidResetWorkspaces.event,this.profilesHome=(0,O.joinPath)(this.environmentService.userRoamingDataHome,"profiles")}get defaultProfile(){return this.profiles[0]}get profiles(){return this.profilesObject.profiles}setEnablement(n){this.enabled!==n&&(this._profilesObject=void 0,this.enabled=n)}get profilesObject(){if(!this._profilesObject){const n=this.enabled?this.getStoredProfiles().map(S=>a(S.name,S.location,S.useDefaultFlags)):[];let e;const r=new f.ResourceMap,o=a((0,c.localize)(0,null),this.environmentService.userRoamingDataHome);if(n.unshift({...o,isDefault:!0,extensionsResource:this.defaultProfileShouldIncludeExtensionsResourceAlways||n.length>0?o.extensionsResource:void 0}),n.length){const S=this.getStoredProfileAssociations();if(S.workspaces)for(const[E,D]of Object.entries(S.workspaces)){const k=p.URI.parse(E),V=p.URI.parse(D),_=n.find(G=>this.uriIdentityService.extUri.isEqual(G.location,V));_&&r.set(k,_)}if(S.emptyWindow){const E=p.URI.parse(S.emptyWindow);e=n.find(D=>this.uriIdentityService.extUri.isEqual(D.location,E))}}this._profilesObject={profiles:n,workspaces:r,emptyWindow:e}}return this._profilesObject}getProfile(n,e){if(!this.enabled)return this.defaultProfile;const r=this.getWorkspace(n);let o=p.URI.isUri(r)?this.profilesObject.workspaces.get(r):this.profilesObject.emptyWindow;return o||(o=e,this.profiles.length>1&&this.updateWorkspaceAssociation(n,o)),o}getWorkspace(n){return(0,v.isSingleFolderWorkspaceIdentifier)(n)?n.uri:(0,v.isWorkspaceIdentifier)(n)?n.configPath:"empty-window"}async createProfile(n,e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(this.getStoredProfiles().some(E=>E.name===n))throw new Error(`Profile with name ${n} already exists`);const o=a(n,(0,O.joinPath)(this.profilesHome,(0,I.hash)((0,l.generateUuid)()).toString(16)),e);await this.fileService.createFolder(o.location);const S=[];return this._onWillCreateProfile.fire({profile:o,join(E){S.push(E)}}),await y.Promises.settled(S),this.updateProfiles([o],[],[]),r&&await this.setProfileForWorkspace(o,r),o}async updateProfile(n,e,r){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);let o=this.profiles.find(S=>S.id===n.id);if(!o)throw new Error(`Profile '${n.name}' does not exist`);return o=a(e,o.location,r),this.updateProfiles([],[],[o]),o}async setProfileForWorkspace(n,e){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);const r=this.profiles.find(o=>o.id===n.id);if(!r)throw new Error(`Profile '${n.name}' does not exist`);this.updateWorkspaceAssociation(e,r)}async unsetWorkspace(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);this.updateWorkspaceAssociation(n)}async resetWorkspaces(){this.profilesObject.workspaces.clear(),this.profilesObject.emptyWindow=void 0,this.updateStoredProfileAssociations(),this._onDidResetWorkspaces.fire()}async removeProfile(n){if(!this.enabled)throw new Error(`Settings Profiles are disabled. Enable them via the '${t.PROFILES_ENABLEMENT_CONFIG}' setting.`);if(n.isDefault)throw new Error("Cannot remove default profile");const e=this.profiles.find(o=>o.id===n.id);if(!e)throw new Error(`Profile '${n.name}' does not exist`);const r=[];this._onWillRemoveProfile.fire({profile:e,join(o){r.push(o)}}),await y.Promises.settled(r),e.id===this.profilesObject.emptyWindow?.id&&(this.profilesObject.emptyWindow=void 0);for(const o of[...this.profilesObject.workspaces.keys()])e.id===this.profilesObject.workspaces.get(o)?.id&&this.profilesObject.workspaces.delete(o);this.updateStoredProfileAssociations(),this.updateProfiles([],[e],[]);try{this.profiles.length===1?await this.fileService.del(this.profilesHome,{recursive:!0}):await this.fileService.del(e.location,{recursive:!0})}catch(o){this.logService.error(o)}}updateProfiles(n,e,r){const o=[];for(let S of[...this.profilesObject.profiles,...n])S.isDefault||e.some(E=>S.id===E.id)||(S=r.find(E=>S.id===E.id)??S,o.push({location:S.location,name:S.name,useDefaultFlags:S.useDefaultFlags}));this.saveStoredProfiles(o),this._profilesObject=void 0,this.triggerProfilesChanges(n,e,r)}triggerProfilesChanges(n,e,r){this._onDidChangeProfiles.fire({added:n,removed:e,updated:r,all:this.profiles})}updateWorkspaceAssociation(n,e){const r=this.getWorkspace(n);p.URI.isUri(r)?(this.profilesObject.workspaces.delete(r),e&&this.profilesObject.workspaces.set(r,e)):this.profilesObject.emptyWindow=e,this.updateStoredProfileAssociations()}updateStoredProfileAssociations(){const n={};for(const[r,o]of this.profilesObject.workspaces.entries())n[r.toString()]=o.location.toString();const e=this.profilesObject.emptyWindow?.location.toString();this.saveStoredProfileAssociations({workspaces:n,emptyWindow:e}),this._profilesObject=void 0}getStoredProfiles(){return[]}saveStoredProfiles(n){throw new Error("not implemented")}getStoredProfileAssociations(){return{}}saveStoredProfileAssociations(n){throw new Error("not implemented")}};s.PROFILES_KEY="userDataProfiles",s.PROFILE_ASSOCIATIONS_KEY="profileAssociations",s=fe([te(0,d.IEnvironmentService),te(1,C.IFileService),te(2,m.IUriIdentityService),te(3,h.ILogService)],s),t.UserDataProfilesService=s}),define(Z[137],ee([0,1,19,3,24,12,4,2,13,10,82,22,23,34,9,27,35,25]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.AbstractExtensionTask=t.reportTelemetry=t.joinErrors=t.AbstractExtensionManagementService=void 0;let u=class extends p.Disposable{constructor(e,r,o,S,E){super();this.galleryService=e,this.telemetryService=r,this.logService=o,this.productService=S,this.userDataProfilesService=E,this.lastReportTimestamp=0,this.installingExtensions=new Map,this.uninstallingExtensions=new Map,this._onInstallExtension=this._register(new A.Emitter),this.onInstallExtension=this._onInstallExtension.event,this._onDidInstallExtensions=this._register(new A.Emitter),this.onDidInstallExtensions=this._onDidInstallExtensions.event,this._onUninstallExtension=this._register(new A.Emitter),this.onUninstallExtension=this._onUninstallExtension.event,this._onDidUninstallExtension=this._register(new A.Emitter),this.onDidUninstallExtension=this._onDidUninstallExtension.event,this.participants=[],this._register((0,p.toDisposable)(()=>{this.installingExtensions.forEach(D=>D.cancel()),this.uninstallingExtensions.forEach(D=>D.cancel()),this.installingExtensions.clear(),this.uninstallingExtensions.clear()}))}async canInstall(e){const r=await this.getTargetPlatform();return e.allTargetPlatforms.some(o=>(0,P.isTargetPlatformCompatible)(o,e.allTargetPlatforms,r))}async installFromGallery(e,r={}){try{if(!this.galleryService.isEnabled())throw new P.ExtensionManagementError(C.localize(0,null),P.ExtensionManagementErrorCode.Internal);const o=await this.checkAndGetCompatibleVersion(e,!!r.installGivenVersion,!!r.installPreReleaseVersion);return await this.installExtension(o.manifest,o.extension,r)}catch(o){throw s(this.telemetryService,"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(e),error:o}),this.logService.error("Failed to install extension.",e.identifier.id),this.logService.error(o),a(o)}}async uninstall(e,r={}){return this.logService.trace("ExtensionManagementService#uninstall",e.identifier.id),this.uninstallExtension(e,r)}async reinstallFromGallery(e){if(this.logService.trace("ExtensionManagementService#reinstallFromGallery",e.identifier.id),!this.galleryService.isEnabled())throw new Error(C.localize(1,null));const r=await this.getTargetPlatform(),[o]=await this.galleryService.getExtensions([{...e.identifier,preRelease:e.preRelease}],{targetPlatform:r,compatible:!0},w.CancellationToken.None);if(!o)throw new Error(C.localize(2,null));await this.createUninstallExtensionTask(e,{remove:!0,versionOnly:!0}).run(),await this.installFromGallery(o)}getExtensionsControlManifest(){const e=new Date().getTime();return(!this.extensionsControlManifest||e-this.lastReportTimestamp>1e3*60*5)&&(this.extensionsControlManifest=this.updateControlCache(),this.lastReportTimestamp=e),this.extensionsControlManifest}registerParticipant(e){this.participants.push(e)}async installExtension(e,r,o){const S=_=>`${h.ExtensionKey.create(_).toString()}${o.profileLocation?`-${o.profileLocation.toString()}`:""}`;if(!d.URI.isUri(r)){const _=this.installingExtensions.get(S(r));if(_){this.logService.info("Extensions is already requested to install",r.identifier.id);const{local:G}=await _.waitUntilTaskIsFinished();return G}o={...o,installOnlyNewlyAddedFromExtensionPack:!0}}const E=[],D=[],k=this.createInstallExtensionTask(e,r,o);d.URI.isUri(r)||this.installingExtensions.set(S(r),k),this._onInstallExtension.fire({identifier:k.identifier,source:r,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",k.identifier.id),E.push({task:k,manifest:e});let V=!1;try{if(o.donotIncludePackAndDependencies)this.logService.info("Installing the extension without checking dependencies and pack",k.identifier.id);else try{const G=await this.getAllDepsAndPackExtensionsToInstall(k.identifier,e,!!o.installOnlyNewlyAddedFromExtensionPack,!!o.installPreReleaseVersion,o.profileLocation);for(const{gallery:Q,manifest:ne}of G){V=V||!!ne.extensionDependencies?.some(re=>(0,h.areSameExtensions)({id:re},k.identifier));const ce=S(Q);if(this.installingExtensions.has(ce))this.logService.info("Extension is already requested to install",Q.identifier.id);else{const re=this.createInstallExtensionTask(ne,Q,{...o,donotIncludePackAndDependencies:!0});this.installingExtensions.set(ce,re),this._onInstallExtension.fire({identifier:re.identifier,source:Q,profileLocation:o.profileLocation}),this.logService.info("Installing extension:",re.identifier.id),E.push({task:re,manifest:ne})}}}catch(G){if(d.URI.isUri(k.source))(0,I.isNonEmptyArray)(e.extensionDependencies)&&this.logService.warn("Cannot install dependencies of extension:",k.identifier.id,G.message),(0,I.isNonEmptyArray)(e.extensionPack)&&this.logService.warn("Cannot install packed extensions of extension:",k.identifier.id,G.message);else throw this.logService.error("Error while preparing to install dependencies and extension packs of the extension:",k.identifier.id),G}const _=E.reduce((G,{task:Q,manifest:ne})=>(G.set(Q.identifier.id.toLowerCase(),{task:Q,manifest:ne}),G),new Map);for(;_.size;){let G;const Q=[..._.values()].filter(({manifest:ne})=>!ne.extensionDependencies?.some(ce=>_.has(ce.toLowerCase())));Q.length?G=_.size===1?Q:Q.filter(({task:ne})=>!(ne===k&&!V)):(this.logService.info("Found extensions with circular dependencies",Q.map(({task:ne})=>ne.identifier.id)),G=[..._.values()]),await this.joinAllSettled(G.map(async({task:ne})=>{const ce=new Date().getTime();try{const{local:re}=await ne.run();if(await this.joinAllSettled(this.participants.map(ge=>ge.postInstall(re,ne.source,o,w.CancellationToken.None))),!d.URI.isUri(ne.source)){const ge=ne.operation===3,ae=ge?void 0:(new Date().getTime()-ne.source.lastUpdated)/1e3;if(s(this.telemetryService,ge?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,durationSinceUpdate:ae}),c.isWeb&&ne.operation!==3)try{await this.galleryService.reportStatistic(re.manifest.publisher,re.manifest.name,re.manifest.version,"install")}catch{}}D.push({local:re,identifier:ne.identifier,operation:ne.operation,source:ne.source,context:o.context,profileLocation:o.profileLocation,applicationScoped:re.isApplicationScoped})}catch(re){throw d.URI.isUri(ne.source)||s(this.telemetryService,ne.operation===3?"extensionGallery:update":"extensionGallery:install",{extensionData:(0,h.getGalleryExtensionTelemetryData)(ne.source),duration:new Date().getTime()-ce,error:re}),this.logService.error("Error while installing the extension:",ne.identifier.id),re}finally{_.delete(ne.identifier.id.toLowerCase())}}))}return D.forEach(({identifier:G})=>this.logService.info("Extension installed successfully:",G.id)),this._onDidInstallExtensions.fire(D),D.filter(({identifier:G})=>(0,h.areSameExtensions)(G,k.identifier))[0].local}catch(_){if(E.forEach(({task:G})=>G.cancel()),D.length)try{const G=await Promise.allSettled(D.map(({local:Q})=>this.createUninstallExtensionTask(Q,{versionOnly:!0,profileLocation:o.profileLocation}).run()));for(let Q=0;Q<G.length;Q++){const ne=G[Q],{identifier:ce}=D[Q];ne.status==="fulfilled"?this.logService.info("Rollback: Uninstalled extension",ce.id):this.logService.warn("Rollback: Error while uninstalling extension",ce.id,(0,O.getErrorMessage)(ne.reason))}}catch(G){this.logService.warn("Error while rolling back extensions",(0,O.getErrorMessage)(G),D.map(({identifier:Q})=>Q.id))}throw this._onDidInstallExtensions.fire(E.map(({task:G})=>({identifier:G.identifier,operation:2,source:G.source,context:o.context,profileLocation:o.profileLocation}))),_}finally{for(const{task:_}of E)if(!d.URI.isUri(_.source)){const G=S(_.source);this.installingExtensions.delete(G)||this.logService.warn("Installation task is not found in the cache",G)}}}async joinAllSettled(e){const r=[],o=[],S=await Promise.allSettled(e);for(const E of S)E.status==="fulfilled"?r.push(E.value):o.push(E.reason);if(o.length)throw g(o);return r}async getAllDepsAndPackExtensionsToInstall(e,r,o,S,E){if(!this.galleryService.isEnabled())return[];let D=await this.getInstalled(void 0,E);const k=[e,...D.map(G=>G.identifier)],V=[],_=async(G,Q)=>{const ne=Q.extensionDependencies||[],ce=[...ne];if(Q.extensionPack){const re=o?D.find(ge=>(0,h.areSameExtensions)(ge.identifier,G)):void 0;for(const ge of Q.extensionPack)re&&re.manifest.extensionPack&&re.manifest.extensionPack.some(ae=>(0,h.areSameExtensions)({id:ae},{id:ge}))||ce.every(ae=>!(0,h.areSameExtensions)({id:ae},{id:ge}))&&ce.push(ge)}if(ce.length){const re=[...k,...V.map(ae=>ae.gallery.identifier)],ge=ce.filter(ae=>re.every(N=>!(0,h.areSameExtensions)(N,{id:ae})));if(ge.length){const ae=await this.galleryService.getExtensions(ge.map(N=>({id:N,preRelease:S})),w.CancellationToken.None);for(const N of ae){if(re.find(F=>(0,h.areSameExtensions)(F,N.identifier)))continue;const B=ne.some(F=>(0,h.areSameExtensions)({id:F},N.identifier));let M;try{M=await this.checkAndGetCompatibleVersion(N,!1,S)}catch(F){if(F instanceof P.ExtensionManagementError&&F.code===P.ExtensionManagementErrorCode.IncompatibleTargetPlatform&&!B){this.logService.info("Skipping the packed extension as it cannot be installed",N.identifier.id);continue}else throw F}V.push({gallery:M.extension,manifest:M.manifest}),await _(M.extension.identifier,M.manifest)}}}};return await _(e,r),D=await this.getInstalled(void 0,E),V.filter(G=>!D.some(Q=>(0,h.areSameExtensions)(Q.identifier,G.gallery.identifier)))}async checkAndGetCompatibleVersion(e,r,o){if((await this.getExtensionsControlManifest()).malicious.some(k=>(0,h.areSameExtensions)(e.identifier,k)))throw new P.ExtensionManagementError(C.localize(3,null,e.identifier.id),P.ExtensionManagementErrorCode.Malicious);if(!await this.canInstall(e)){const k=await this.getTargetPlatform();throw new P.ExtensionManagementError(C.localize(4,null,e.identifier.id,this.productService.nameLong,(0,P.TargetPlatformToString)(k)),P.ExtensionManagementErrorCode.IncompatibleTargetPlatform)}const E=await this.getCompatibleVersion(e,r,o);if(E){if(o&&!r&&e.hasPreReleaseVersion&&!E.properties.isPreReleaseVersion)throw new P.ExtensionManagementError(C.localize(5,null,e.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.IncompatiblePreRelease)}else throw!o&&e.properties.isPreReleaseVersion&&(await this.galleryService.getExtensions([e.identifier],w.CancellationToken.None))[0]?new P.ExtensionManagementError(C.localize(6,null,e.identifier.id),P.ExtensionManagementErrorCode.ReleaseVersionNotFound):new P.ExtensionManagementError(C.localize(7,null,e.identifier.id,this.productService.nameLong,this.productService.version),P.ExtensionManagementErrorCode.Incompatible);this.logService.info("Getting Manifest...",E.identifier.id);const D=await this.galleryService.getManifest(E,w.CancellationToken.None);if(D===null)throw new P.ExtensionManagementError(`Missing manifest for extension ${e.identifier.id}`,P.ExtensionManagementErrorCode.Invalid);if(D.version!==E.version)throw new P.ExtensionManagementError(`Cannot install '${e.identifier.id}' extension because of version mismatch in Marketplace`,P.ExtensionManagementErrorCode.Invalid);return{extension:E,manifest:D}}async getCompatibleVersion(e,r,o){const S=await this.getTargetPlatform();let E=null;return!r&&e.hasPreReleaseVersion&&e.properties.isPreReleaseVersion!==o&&(E=(await this.galleryService.getExtensions([{...e.identifier,preRelease:o}],{targetPlatform:S,compatible:!0},w.CancellationToken.None))[0]||null),!E&&await this.galleryService.isExtensionCompatible(e,o,S)&&(E=e),E||(r?E=(await this.galleryService.getExtensions([{...e.identifier,version:e.version}],{targetPlatform:S,compatible:!0},w.CancellationToken.None))[0]||null:E=await this.galleryService.getCompatibleExtension(e,o,S)),E}async uninstallExtension(e,r){const o=_=>`${_.id.toLowerCase()}${r.versionOnly?`-${e.manifest.version}`:""}${r.profileLocation?`@${r.profileLocation.toString()}`:""}`,S=this.uninstallingExtensions.get(o(e.identifier));if(S)return this.logService.info("Extensions is already requested to uninstall",e.identifier.id),S.waitUntilTaskIsFinished();const E=(_,G)=>{const Q=this.createUninstallExtensionTask(_,G);return this.uninstallingExtensions.set(o(Q.extension.identifier),Q),r.profileLocation?this.logService.info("Uninstalling extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Uninstalling extension:",`${_.identifier.id}@${_.manifest.version}`),this._onUninstallExtension.fire({identifier:_.identifier,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped}),Q},D=(_,G)=>{G?r.profileLocation?this.logService.error("Failed to uninstall extension from the profile:",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString(),G.message):this.logService.error("Failed to uninstall extension:",`${_.identifier.id}@${_.manifest.version}`,G.message):r.profileLocation?this.logService.info("Successfully uninstalled extension from the profile",`${_.identifier.id}@${_.manifest.version}`,r.profileLocation.toString()):this.logService.info("Successfully uninstalled extension:",`${_.identifier.id}@${_.manifest.version}`),s(this.telemetryService,"extensionGallery:uninstall",{extensionData:(0,h.getLocalExtensionTelemetryData)(_),error:G}),this._onDidUninstallExtension.fire({identifier:_.identifier,version:_.manifest.version,error:G?.code,profileLocation:r.profileLocation,applicationScoped:_.isApplicationScoped})},k=[],V=[];try{k.push(E(e,r));const _=await this.getInstalled(1,r.profileLocation);if(r.donotIncludePack)this.logService.info("Uninstalling the extension without including packed extension",`${e.identifier.id}@${e.manifest.version}`);else{const G=this.getAllPackExtensionsToUninstall(e,_);for(const Q of G)this.uninstallingExtensions.has(o(Q.identifier))?this.logService.info("Extensions is already requested to uninstall",Q.identifier.id):k.push(E(Q,r))}r.donotCheckDependents?this.logService.info("Uninstalling the extension without checking dependents",`${e.identifier.id}@${e.manifest.version}`):this.checkForDependents(k.map(G=>G.extension),_,e),await this.joinAllSettled(k.map(async G=>{try{if(await G.run(),await this.joinAllSettled(this.participants.map(Q=>Q.postUninstall(G.extension,r,w.CancellationToken.None))),G.extension.identifier.uuid)try{await this.galleryService.reportStatistic(G.extension.manifest.publisher,G.extension.manifest.name,G.extension.manifest.version,"uninstall")}catch{}D(G.extension)}catch(Q){const ne=Q instanceof P.ExtensionManagementError?Q:new P.ExtensionManagementError((0,O.getErrorMessage)(Q),P.ExtensionManagementErrorCode.Internal);throw D(G.extension,ne),ne}finally{V.push(G)}}))}catch(_){const G=_ instanceof P.ExtensionManagementError?_:new P.ExtensionManagementError((0,O.getErrorMessage)(_),P.ExtensionManagementErrorCode.Internal);for(const Q of k){try{Q.cancel()}catch{}V.includes(Q)||D(Q.extension,G)}throw G}finally{for(const _ of k)this.uninstallingExtensions.delete(o(_.extension.identifier))||this.logService.warn("Uninstallation task is not found in the cache",_.extension.identifier.id)}}checkForDependents(e,r,o){for(const S of e){const E=this.getDependents(S,r);if(E.length){const D=E.filter(k=>!e.some(V=>(0,h.areSameExtensions)(V.identifier,k.identifier)));if(D.length)throw new Error(this.getDependentsErrorMessage(S,D,o))}}}getDependentsErrorMessage(e,r,o){return o===e?r.length===1?C.localize(8,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(9,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(10,null,o.manifest.displayName||o.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):r.length===1?C.localize(11,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name):r.length===2?C.localize(12,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name):C.localize(13,null,o.manifest.displayName||o.manifest.name,e.manifest.displayName||e.manifest.name,r[0].manifest.displayName||r[0].manifest.name,r[1].manifest.displayName||r[1].manifest.name)}getAllPackExtensionsToUninstall(e,r,o=[]){if(o.indexOf(e)!==-1)return[];o.push(e);const S=e.manifest.extensionPack?e.manifest.extensionPack:[];if(S.length){const E=r.filter(k=>!k.isBuiltin&&S.some(V=>(0,h.areSameExtensions)({id:V},k.identifier))),D=[];for(const k of E)D.push(...this.getAllPackExtensionsToUninstall(k,r,o));return[...E,...D]}return[]}getDependents(e,r){return r.filter(o=>o.manifest.extensionDependencies&&o.manifest.extensionDependencies.some(S=>(0,h.areSameExtensions)({id:S},e.identifier)))}async updateControlCache(){try{this.logService.trace("ExtensionManagementService.refreshReportedCache");const e=await this.galleryService.getExtensionsControlManifest();return this.logService.trace("ExtensionManagementService.refreshControlCache",e),e}catch{return this.logService.trace("ExtensionManagementService.refreshControlCache - failed to get extension control manifest"),{malicious:[],deprecated:{}}}}createInstallExtensionTask(e,r,o){return o.profileLocation&&(0,v.isApplicationScopedExtension)(e)&&(o={...o,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateInstallExtensionTask(e,r,o)}createUninstallExtensionTask(e,r){return r.profileLocation&&e.isApplicationScoped&&(r={...r,profileLocation:this.userDataProfilesService.defaultProfile.extensionsResource}),this.doCreateUninstallExtensionTask(e,r)}};u=fe([te(0,P.IExtensionGalleryService),te(1,y.ITelemetryService),te(2,f.ILogService),te(3,m.IProductService),te(4,l.IUserDataProfilesService)],u),t.AbstractExtensionManagementService=u;function g(n){const e=Array.isArray(n)?n:[n];return e.length===1?e[0]instanceof Error?e[0]:new Error(e[0]):e.reduce((r,o)=>new Error(`${r.message}${r.message?",":""}${o instanceof Error?o.message:o}`),new Error(""))}t.joinErrors=g;function a(n){if(n instanceof P.ExtensionManagementError)return n;const e=new P.ExtensionManagementError(n.message,P.ExtensionManagementErrorCode.Internal);return e.stack=n.stack,e}function s(n,e,{extensionData:r,duration:o,error:S,durationSinceUpdate:E}){const D=S?S instanceof P.ExtensionManagementError?S.code:P.ExtensionManagementErrorCode.Internal:void 0;n.publicLog(e,{...r,success:!S,duration:o,errorcode:D,durationSinceUpdate:E})}t.reportTelemetry=s;class i{constructor(){this.barrier=new b.Barrier}async waitUntilTaskIsFinished(){return await this.barrier.wait(),this.cancellablePromise}async run(){return this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(e=>this.doRun(e))),this.barrier.open(),this.cancellablePromise}cancel(){this.cancellablePromise||(this.cancellablePromise=(0,b.createCancelablePromise)(e=>new Promise((r,o)=>{const S=e.onCancellationRequested(()=>{S.dispose(),o(new O.CancellationError)})})),this.barrier.open()),this.cancellablePromise.cancel()}}t.AbstractExtensionTask=i}),define(Z[48],ee([0,1,19,3,26,15,12,50,74,2,16,14,13,17,39,54,5,10,85,18,23,34,45,11,8,9,27,4,44,41,25,28]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l,u,g,a,s,i,n,e,r,o,S,E,D,k,V){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativeExtensionsScannerService=t.toExtensionDescription=t.AbstractExtensionsScannerService=t.IExtensionsScannerService=t.Translations=void 0;var _;(function(ae){function N(B,M){if(B===M)return!0;const F=Object.keys(B),W=new Set;for(const q of Object.keys(M))W.add(q);if(F.length!==W.size)return!1;for(const q of F){if(B[q]!==M[q])return!1;W.delete(q)}return W.size===0}ae.equals=N})(_=t.Translations||(t.Translations={})),t.IExtensionsScannerService=(0,e.createDecorator)("IExtensionsScannerService");let G=class extends d.Disposable{constructor(N,B,M,F,W,q,Y,T,x,R,L){super();this.systemExtensionsLocation=N,this.userExtensionsLocation=B,this.extensionsControlLocation=M,this.cacheLocation=F,this.userDataProfilesService=W,this.extensionsProfileScannerService=q,this.fileService=Y,this.logService=T,this.environmentService=x,this.productService=R,this.instantiationService=L,this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event,this.obsoleteFile=(0,v.joinPath)(this.userExtensionsLocation,".obsolete"),this.systemExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,v.joinPath)(this.cacheLocation,s.BUILTIN_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.userExtensionsCachedScanner=this._register(this.instantiationService.createInstance(ce,(0,v.joinPath)(this.cacheLocation,s.USER_MANIFEST_CACHE_FILE),this.obsoleteFile)),this.extensionsScanner=this._register(this.instantiationService.createInstance(ne,this.obsoleteFile)),this._register(this.systemExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(0))),this._register(this.userExtensionsCachedScanner.onDidChangeCache(()=>this._onDidChangeCache.fire(1)))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,a.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async scanAllExtensions(N,B){const[M,F]=await Promise.all([this.scanSystemExtensions(N),this.scanUserExtensions(B)]),W=await this.scanExtensionsUnderDevelopment(N,[...M,...F]);return this.dedupExtensions(M,F,W,await this.getTargetPlatform(),!0)}async scanSystemExtensions(N){const B=[];B.push(this.scanDefaultSystemExtensions(!!N.useCache,N.language)),B.push(this.scanDevSystemExtensions(N.language,!!N.checkControlFile));const[M,F]=await Promise.all(B);return this.applyScanOptions([...M,...F],0,N,!1)}async scanUserExtensions(N){this.logService.trace("Started scanning user extensions");const B=await this.createExtensionScannerInput(N.profileLocation??this.userExtensionsLocation,!!N.profileLocation,1,!N.includeUninstalled,N.language);let F=await(N.useCache&&!B.devMode&&B.excludeObsolete?this.userExtensionsCachedScanner:this.extensionsScanner).scanExtensions(B);return F=await this.applyScanOptions(F,1,N,!0),this.logService.trace("Scanned user extensions:",F.length),F}async scanExtensionsUnderDevelopment(N,B){if(this.environmentService.isExtensionDevelopment&&this.environmentService.extensionDevelopmentLocationURI){const M=(await Promise.all(this.environmentService.extensionDevelopmentLocationURI.filter(F=>F.scheme===C.Schemas.file).map(async F=>{const W=await this.createExtensionScannerInput(F,!1,1,!0,N.language,!1);return(await this.extensionsScanner.scanOneOrMultipleExtensions(W)).map(Y=>(Y.type=B.find(T=>(0,a.areSameExtensions)(T.identifier,Y.identifier))?.type??Y.type,this.extensionsScanner.validate(Y,W)))}))).flat();return this.applyScanOptions(M,"development",N,!0)}return[]}async scanExistingExtension(N,B,M){const F=await this.createExtensionScannerInput(N,!1,B,!0,M.language),W=await this.extensionsScanner.scanExtension(F);return!W||!M.includeInvalid&&!W.isValid?null:W}async scanOneOrMultipleExtensions(N,B,M){const F=await this.createExtensionScannerInput(N,!1,B,!0,M.language),W=await this.extensionsScanner.scanOneOrMultipleExtensions(F);return this.applyScanOptions(W,B,M,!0)}async scanMetadata(N){const B=(0,v.joinPath)(N,"package.json"),M=(await this.fileService.readFile(B)).value.toString();return JSON.parse(M).__metadata}async updateMetadata(N,B){const M=(0,v.joinPath)(N,"package.json"),F=(await this.fileService.readFile(M)).value.toString(),W=JSON.parse(F);B.isMachineScoped=B.isMachineScoped||void 0,B.isBuiltin=B.isBuiltin||void 0,B.installedTimestamp=B.installedTimestamp||void 0,W.__metadata={...W.__metadata,...B},await this.fileService.writeFile((0,v.joinPath)(N,"package.json"),O.VSBuffer.fromString(JSON.stringify(W,null,"	")))}async applyScanOptions(N,B,M,F){return M.includeAllVersions||(N=this.dedupExtensions(B===0?N:void 0,B===1?N:void 0,B==="development"?N:void 0,await this.getTargetPlatform(),F)),M.includeInvalid||(N=N.filter(W=>W.isValid)),N.sort((W,q)=>{const Y=P.basename(W.location.fsPath),T=P.basename(q.location.fsPath);return Y<T?-1:Y>T?1:0})}dedupExtensions(N,B,M,F,W){const q=(T,x,R)=>{if(T.isValid&&!x.isValid)return!1;if(T.isValid===x.isValid){if(W&&f.gt(T.manifest.version,x.manifest.version))return this.logService.debug(`Skipping extension ${x.location.path} with lower version ${x.manifest.version} in favour of ${T.location.path} with version ${T.manifest.version}`),!1;if(f.eq(T.manifest.version,x.manifest.version)){if(T.type===0)return this.logService.debug(`Skipping extension ${x.location.path} in favour of system extension ${T.location.path} with same version`),!1;if(T.targetPlatform===F)return this.logService.debug(`Skipping extension ${x.location.path} from different target platform ${x.targetPlatform}`),!1}}return R?this.logService.warn(`Overwriting user extension ${T.location.path} with ${x.location.path}.`):this.logService.debug(`Overwriting user extension ${T.location.path} with ${x.location.path}.`),!0},Y=new Map;return N?.forEach(T=>{const x=s.ExtensionIdentifier.toKey(T.identifier.id),R=Y.get(x);(!R||q(R,T,!1))&&Y.set(x,T)}),B?.forEach(T=>{const x=s.ExtensionIdentifier.toKey(T.identifier.id),R=Y.get(x);if(!R&&N&&T.type===0){this.logService.debug(`Skipping obsolete system extension ${T.location.path}.`);return}(!R||q(R,T,!1))&&Y.set(x,T)}),M?.forEach(T=>{const x=s.ExtensionIdentifier.toKey(T.identifier.id),R=Y.get(x);(!R||q(R,T,!0))&&Y.set(x,T),Y.set(x,T)}),[...Y.values()]}async scanDefaultSystemExtensions(N,B){this.logService.trace("Started scanning system extensions");const M=await this.createExtensionScannerInput(this.systemExtensionsLocation,!1,0,!0,B),W=await(N&&!M.devMode?this.systemExtensionsCachedScanner:this.extensionsScanner).scanExtensions(M);return this.logService.trace("Scanned system extensions:",W.length),W}async scanDevSystemExtensions(N,B){const M=this.environmentService.isBuilt?[]:this.productService.builtInExtensions;if(!M?.length)return[];this.logService.trace("Started scanning dev system extensions");const F=B?await this.getBuiltInExtensionControl():{},W=[],q=l.URI.file(P.normalize(P.join(C.FileAccess.asFileUri("",$).fsPath,"..",".build","builtInExtensions")));for(const T of M){const x=F[T.name]||"marketplace";switch(x){case"disabled":break;case"marketplace":W.push((0,v.joinPath)(q,T.name));break;default:W.push(l.URI.file(x));break}}const Y=await Promise.all(W.map(async T=>this.extensionsScanner.scanExtension(await this.createExtensionScannerInput(T,!1,0,!0,N))));return this.logService.trace("Scanned dev system extensions:",Y.length),(0,I.coalesce)(Y)}async getBuiltInExtensionControl(){try{const N=await this.fileService.readFile(this.extensionsControlLocation);return JSON.parse(N.value.toString())}catch{return{}}}async createExtensionScannerInput(N,B,M,F,W,q=!0){const Y=await this.getTranslations(W??h.language),T=await this.getMtime(N),x=B?this.userDataProfilesService.defaultProfile.extensionsResource:void 0,R=x?await this.getMtime(x):void 0;return new Q(N,T,x,R,B,M,F,q,this.productService.version,this.productService.date,this.productService.commit,!this.environmentService.isBuilt,W,Y)}async getMtime(N){try{const B=await this.fileService.stat(N);if(typeof B.mtime=="number")return B.mtime}catch{}}};G=fe([te(4,k.IUserDataProfilesService),te(5,D.IExtensionsProfileScannerService),te(6,n.IFileService),te(7,r.ILogService),te(8,g.IEnvironmentService),te(9,o.IProductService),te(10,e.IInstantiationService)],G),t.AbstractExtensionsScannerService=G;class Q{constructor(N,B,M,F,W,q,Y,T,x,R,L,U,j,H){this.location=N,this.mtime=B,this.applicationExtensionslocation=M,this.applicationExtensionslocationMtime=F,this.profile=W,this.type=q,this.excludeObsolete=Y,this.validate=T,this.productVersion=x,this.productDate=R,this.productCommit=L,this.devMode=U,this.language=j,this.translations=H}static createNlsConfiguration(N){return{language:N.language,pseudo:N.language==="pseudo",devMode:N.devMode,translations:N.translations}}static equals(N,B){return(0,v.isEqual)(N.location,B.location)&&N.mtime===B.mtime&&(0,v.isEqual)(N.applicationExtensionslocation,B.applicationExtensionslocation)&&N.applicationExtensionslocationMtime===B.applicationExtensionslocationMtime&&N.profile===B.profile&&N.type===B.type&&N.excludeObsolete===B.excludeObsolete&&N.validate===B.validate&&N.productVersion===B.productVersion&&N.productDate===B.productDate&&N.productCommit===B.productCommit&&N.devMode===B.devMode&&N.language===B.language&&_.equals(N.translations,B.translations)}}let ne=class extends d.Disposable{constructor(N,B,M,F,W){super();this.obsoleteFile=N,this.extensionsProfileScannerService=B,this.uriIdentityService=M,this.fileService=F,this.logService=W}async scanExtensions(N){const B=N.profile?await this.scanExtensionsFromProfile(N):await this.scanExtensionsFromLocation(N);let M={};if(N.excludeObsolete&&N.type===1)try{const F=(await this.fileService.readFile(this.obsoleteFile)).value.toString();M=JSON.parse(F)}catch{}return(0,y.isEmptyObject)(M)?B:B.filter(F=>!M[a.ExtensionKey.create(F).toString()])}async scanExtensionsFromLocation(N){const B=await this.fileService.resolve(N.location);if(!B.children?.length)return[];const M=await Promise.all(B.children.map(async F=>{if(!F.isDirectory||N.type===1&&(0,v.basename)(F.resource).indexOf(".")===0)return null;const W=new Q(F.resource,N.mtime,N.applicationExtensionslocation,N.applicationExtensionslocationMtime,N.profile,N.type,N.excludeObsolete,N.validate,N.productVersion,N.productDate,N.productCommit,N.devMode,N.language,N.translations);return this.scanExtension(W)}));return(0,I.coalesce)(M).sort((F,W)=>F.location.path<W.location.path?-1:1)}async scanExtensionsFromProfile(N){let B=await this.scanExtensionsFromProfileResource(N.location,()=>!0,N);if(N.applicationExtensionslocation&&!this.uriIdentityService.extUri.isEqual(N.location,N.applicationExtensionslocation)){B=B.filter(F=>!F.metadata?.isApplicationScoped);const M=await this.scanExtensionsFromProfileResource(N.applicationExtensionslocation,F=>!!F.metadata?.isApplicationScoped,N);B.push(...M)}return B}async scanExtensionsFromProfileResource(N,B,M){const F=await this.extensionsProfileScannerService.scanProfileExtensions(N);if(!F.length)return[];const W=await Promise.all(F.map(async q=>{if(B(q)){const Y=new Q(q.location,M.mtime,M.applicationExtensionslocation,M.applicationExtensionslocationMtime,M.profile,M.type,M.excludeObsolete,M.validate,M.productVersion,M.productDate,M.productCommit,M.devMode,M.language,M.translations);return this.scanExtension(Y,q.metadata)}return null}));return(0,I.coalesce)(W)}async scanOneOrMultipleExtensions(N){try{if(await this.fileService.exists((0,v.joinPath)(N.location,"package.json"))){const B=await this.scanExtension(N);return B?[B]:[]}else return await this.scanExtensions(N)}catch(B){return this.logService.error(`Error scanning extensions at ${N.location.path}:`,(0,A.getErrorMessage)(B)),[]}}async scanExtension(N,B){try{let M=await this.scanExtensionManifest(N.location);if(M){M.publisher||(M.publisher=s.UNDEFINED_PUBLISHER),B=B??M.__metadata,delete M.__metadata;const F=(0,a.getGalleryExtensionId)(M.publisher,M.name),W=B?.id?{id:F,uuid:B.id}:{id:F},q=B?.isSystem?0:N.type,Y=q===0||!!B?.isBuiltin;M=await this.translateManifest(N.location,M,Q.createNlsConfiguration(N));const T={type:q,identifier:W,manifest:M,location:N.location,isBuiltin:Y,targetPlatform:B?.targetPlatform??"undefined",metadata:B,isValid:!0,validations:[]};return N.validate?this.validate(T,N):T}}catch(M){N.type!==0&&this.logService.error(M)}return null}validate(N,B){let M=!0;const F=(0,i.validateExtensionManifest)(B.productVersion,B.productDate,B.location,N.manifest,N.isBuiltin);for(const[W,q]of F)W===m.default.Error&&(M=!1,this.logService.error(this.formatMessage(B.location,q)));return N.isValid=M,N.validations=F,N}async scanExtensionManifest(N){const B=(0,v.joinPath)(N,"package.json");let M;try{M=(await this.fileService.readFile(B)).value.toString()}catch(W){return(0,n.toFileOperationResult)(W)!==1&&this.logService.error(this.formatMessage(N,(0,u.localize)(0,null,B.path,W.message))),null}let F;try{F=JSON.parse(M)}catch{const q=[];(0,p.parse)(M,q);for(const Y of q)this.logService.error(this.formatMessage(N,(0,u.localize)(1,null,B.path,Y.offset,Y.length,(0,c.getParseErrorMessage)(Y.error))));return null}return(0,p.getNodeType)(F)!=="object"?(this.logService.error(this.formatMessage(N,(0,u.localize)(2,null,B.path))),null):F}async translateManifest(N,B,M){const F=await this.getLocalizedMessages(N,B,M);if(F)try{const W=[],q=await this.resolveOriginalMessageBundle(F.default,W);if(W.length>0)return W.forEach(T=>{this.logService.error(this.formatMessage(N,(0,u.localize)(3,null,F.default?.path,(0,c.getParseErrorMessage)(T.error))))}),B;if((0,p.getNodeType)(F)!=="object")return this.logService.error(this.formatMessage(N,(0,u.localize)(4,null,F.default?.path))),B;const Y=F.values||Object.create(null);this.replaceNLStrings(M.pseudo,B,Y,q,N)}catch{}return B}async getLocalizedMessages(N,B,M){const F=(0,v.joinPath)(N,"package.nls.json"),W=(x,R)=>{R.forEach(L=>{this.logService.error(this.formatMessage(N,(0,u.localize)(5,null,x?.path,(0,c.getParseErrorMessage)(L.error))))})},q=x=>{this.logService.error(this.formatMessage(N,(0,u.localize)(6,null,x?.path)))},Y=`${B.publisher}.${B.name}`,T=M.translations[Y];if(T)try{const x=l.URI.file(T),R=(await this.fileService.readFile(x)).value.toString(),L=[],U=(0,p.parse)(R,L);return L.length>0?(W(x,L),{values:void 0,default:F}):(0,p.getNodeType)(U)!=="object"?(q(x),{values:void 0,default:F}):{values:U.contents?U.contents.package:void 0,default:F}}catch{return{values:void 0,default:F}}else{if(!await this.fileService.exists(F))return;let R;try{R=await this.findMessageBundles(N,M)}catch{return}if(!R.localized)return{values:void 0,default:R.original};try{const L=(await this.fileService.readFile(R.localized)).value.toString(),U=[],j=(0,p.parse)(L,U);return U.length>0?(W(R.localized,U),{values:void 0,default:R.original}):(0,p.getNodeType)(j)!=="object"?(q(R.localized),{values:void 0,default:R.original}):{values:j,default:R.original}}catch{return{values:void 0,default:R.original}}}}async resolveOriginalMessageBundle(N,B){if(N)try{const M=(await this.fileService.readFile(N)).value.toString();return(0,p.parse)(M,B)}catch{return null}else return null}findMessageBundles(N,B){return new Promise((M,F)=>{const W=q=>{const Y=(0,v.joinPath)(N,`package.nls.${q}.json`);this.fileService.exists(Y).then(T=>{T&&M({localized:Y,original:(0,v.joinPath)(N,"package.nls.json")});const x=q.lastIndexOf("-");x===-1?M({localized:(0,v.joinPath)(N,"package.nls.json"),original:null}):(q=q.substring(0,x),W(q))})};if(B.devMode||B.pseudo||!B.language)return M({localized:(0,v.joinPath)(N,"package.nls.json"),original:null});W(B.language)})}replaceNLStrings(N,B,M,F,W){const q=(Y,T,x)=>{const R=Y[T];if((0,y.isString)(R)){const L=R,U=L.length;if(U>1&&L[0]==="%"&&L[U-1]==="%"){const j=L.substr(1,U-2);let H=M[j];H===void 0&&F&&(H=F[j]);let X=typeof H=="string"?H:H.message;if(X!==void 0)if(N&&(X="\uFF3B"+X.replace(/[aouei]/g,"$&$&")+"\uFF3D"),x&&F&&(T==="title"||T==="category")){const oe=F[j],le={value:X,original:typeof oe=="string"?oe:oe?.message};Y[T]=le}else Y[T]=X;else this.logService.warn(this.formatMessage(W,(0,u.localize)(7,null,j)))}}else if((0,y.isObject)(R))for(const L in R)R.hasOwnProperty(L)&&(L==="commands"?q(R,L,!0):q(R,L,x));else if(Array.isArray(R))for(let L=0;L<R.length;L++)q(R,L,x)};for(const Y in B)B.hasOwnProperty(Y)&&q(B,Y)}formatMessage(N,B){return`[${N.path}]: ${B}`}};ne=fe([te(1,D.IExtensionsProfileScannerService),te(2,V.IUriIdentityService),te(3,n.IFileService),te(4,r.ILogService)],ne);let ce=class extends ne{constructor(N,B,M,F,W,q){super(B,M,F,W,q);this.cacheFile=N,this.cacheValidatorThrottler=this._register(new b.ThrottledDelayer(3e3)),this._onDidChangeCache=this._register(new S.Emitter),this.onDidChangeCache=this._onDidChangeCache.event}async scanExtensions(N){const B=await this.readExtensionCache();if(this.input=N,B&&B.input&&Q.equals(B.input,this.input))return this.cacheValidatorThrottler.trigger(()=>this.validateCache()),B.result.map(F=>(F.location=l.URI.revive(F.location),F));const M=await super.scanExtensions(N);return await this.writeExtensionCache({input:N,result:M}),M}async readExtensionCache(){try{const N=await this.fileService.readFile(this.cacheFile),B=JSON.parse(N.value.toString());return{result:B.result,input:(0,E.revive)(B.input)}}catch(N){this.logService.debug("Error while reading the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(N))}return null}async writeExtensionCache(N){try{await this.fileService.writeFile(this.cacheFile,O.VSBuffer.fromString(JSON.stringify(N)))}catch(B){this.logService.debug("Error while writing the extension cache file:",this.cacheFile.path,(0,A.getErrorMessage)(B))}}async validateCache(){if(!this.input)return;const N=await this.readExtensionCache();if(!N)return;const B=N.result,M=JSON.parse(JSON.stringify(await super.scanExtensions(this.input)));if(!w.equals(M,B))try{await this.fileService.del(this.cacheFile),this._onDidChangeCache.fire()}catch(F){this.logService.error(F)}}};ce=fe([te(2,D.IExtensionsProfileScannerService),te(3,V.IUriIdentityService),te(4,n.IFileService),te(5,r.ILogService)],ce);function re(ae,N){const B=(0,a.getExtensionId)(ae.manifest.publisher,ae.manifest.name);return{id:B,identifier:new s.ExtensionIdentifier(B),isBuiltin:ae.type===0,isUserBuiltin:ae.type===1&&ae.isBuiltin,isUnderDevelopment:N,extensionLocation:ae.location,uuid:ae.identifier.uuid,targetPlatform:ae.targetPlatform,...ae.manifest}}t.toExtensionDescription=re;class ge extends G{constructor(N,B,M,F,W,q,Y,T,x,R,L){super(N,B,(0,v.joinPath)(M,".vscode-oss-dev","extensions","control.json"),(0,v.joinPath)(F,s.MANIFEST_CACHE_FOLDER),W,q,Y,T,x,R,L);this.translationsPromise=(async()=>{if(h.translationsConfigFile)try{const U=await this.fileService.readFile(l.URI.file(h.translationsConfigFile));return JSON.parse(U.value.toString())}catch{}return Object.create(null)})()}getTranslations(N){return this.translationsPromise}}t.NativeExtensionsScannerService=ge}),define(Z[138],ee([0,1,57,3,30,4,2,16,14,20,9,25]),function($,t,I,b,w,O,A,p,c,d,C,P){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsLifecycle=void 0;let h=class extends A.Disposable{constructor(f,m){super();this.userDataProfilesService=f,this.logService=m,this.processesLimiter=new b.Limiter(5)}async postUninstall(f){const m=this.parseScript(f,"uninstall");return m&&(this.logService.info(f.identifier.id,f.manifest.version,"Running post uninstall script"),await this.processesLimiter.queue(()=>this.runLifecycleHook(m.script,"uninstall",m.args,!0,f).then(()=>this.logService.info(f.identifier.id,f.manifest.version,"Finished running post uninstall script"),y=>this.logService.error(f.identifier.id,f.manifest.version,`Failed to run post uninstall script: ${y}`)))),d.Promises.rm(this.getExtensionStoragePath(f)).then(void 0,y=>this.logService.error("Error while removing extension storage path",y))}parseScript(f,m){const y=`vscode:${m}`;if(f.location.scheme===p.Schemas.file&&f.manifest&&f.manifest.scripts&&typeof f.manifest.scripts[y]=="string"){const l=f.manifest.scripts[y].split(" ");return l.length<2||l[0]!=="node"||!l[1]?(this.logService.warn(f.identifier.id,f.manifest.version,`${y} should be a node script`),null):{script:(0,c.join)(f.location.fsPath,l[1]),args:l.slice(2)||[]}}return null}runLifecycleHook(f,m,y,l,u){return new Promise((g,a)=>{const s=this.start(f,m,y,u);let i;const n=e=>{i&&(clearTimeout(i),i=null),e?a(e):g(void 0)};s.on("error",e=>{n((0,w.toErrorMessage)(e)||"Unknown")}),s.on("exit",(e,r)=>{n(e?`post-${m} process exited with code ${e}`:void 0)}),l&&(i=setTimeout(()=>{i=null,s.kill(),a("timed out")},5e3))})}start(f,m,y,l){const u={silent:!0,execArgv:void 0},g=(0,I.fork)(f,[`--type=extension-post-${m}`,...y],u);g.stdout.setEncoding("utf8"),g.stderr.setEncoding("utf8");const a=O.Event.fromNodeEventEmitter(g.stdout,"data"),s=O.Event.fromNodeEventEmitter(g.stderr,"data");a(e=>this.logService.info(l.identifier.id,l.manifest.version,`post-${m}`,e)),s(e=>this.logService.error(l.identifier.id,l.manifest.version,`post-${m}`,e));const i=O.Event.any(O.Event.map(a,e=>({data:`%c${e}`,format:[""]})),O.Event.map(s,e=>({data:`%c${e}`,format:["color: red"]})));return O.Event.debounce(i,(e,r)=>e?{data:e.data+r.data,format:[...e.format,...r.format]}:{data:r.data,format:r.format},100)(e=>{console.group(l.identifier.id),console.log(e.data,...e.format),console.groupEnd()}),g}getExtensionStoragePath(f){return(0,c.join)(this.userDataProfilesService.defaultProfile.globalStorageHome.fsPath,f.identifier.id.toLowerCase())}};h=fe([te(0,P.IUserDataProfilesService),te(1,C.ILogService)],h),t.ExtensionsLifecycle=h}),define(Z[139],ee([0,1,10,18,41,48,11,8,9,27,25]),function($,t,I,b,w,O,A,p,c,d,C){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionsScannerService=void 0;let P=class extends O.NativeExtensionsScannerService{constructor(v,f,m,y,l,u,g){super(I.URI.file(l.builtinExtensionsPath),I.URI.file(l.extensionsPath),l.userHome,I.URI.file(l.userDataPath),v,f,m,y,l,u,g)}};P=fe([te(0,C.IUserDataProfilesService),te(1,w.IExtensionsProfileScannerService),te(2,A.IFileService),te(3,c.ILogService),te(4,b.INativeEnvironmentService),te(5,d.IProductService),te(6,p.IInstantiationService)],P),t.ExtensionsScannerService=P}),define(Z[140],ee([0,1,3,4,2,110,5,79,8,25]),function($,t,I,b,w,O,A,p,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.logStorage=t.InMemoryStorageService=t.isProfileUsingDefaultStorage=t.AbstractStorageService=t.StorageTarget=t.StorageScope=t.WillSaveStateReason=t.IStorageService=t.IS_NEW_KEY=void 0,t.IS_NEW_KEY="__$__isNewStorageMarker";const C="__$__targetStorageMarker";t.IStorageService=(0,c.createDecorator)("storageService");var P;(function(u){u[u.NONE=0]="NONE",u[u.SHUTDOWN=1]="SHUTDOWN"})(P=t.WillSaveStateReason||(t.WillSaveStateReason={}));var h;(function(u){u[u.APPLICATION=-1]="APPLICATION",u[u.PROFILE=0]="PROFILE",u[u.WORKSPACE=1]="WORKSPACE"})(h=t.StorageScope||(t.StorageScope={}));var v;(function(u){u[u.USER=0]="USER",u[u.MACHINE=1]="MACHINE"})(v=t.StorageTarget||(t.StorageTarget={}));class f extends w.Disposable{constructor(g={flushInterval:f.DEFAULT_FLUSH_INTERVAL}){super();this.options=g,this._onDidChangeValue=this._register(new b.PauseableEmitter),this.onDidChangeValue=this._onDidChangeValue.event,this._onDidChangeTarget=this._register(new b.PauseableEmitter),this.onDidChangeTarget=this._onDidChangeTarget.event,this._onWillSaveState=this._register(new b.Emitter),this.onWillSaveState=this._onWillSaveState.event,this.flushWhenIdleScheduler=this._register(new I.RunOnceScheduler(()=>this.doFlushWhenIdle(),this.options.flushInterval)),this.runFlushWhenIdle=this._register(new w.MutableDisposable),this._workspaceKeyTargets=void 0,this._profileKeyTargets=void 0,this._applicationKeyTargets=void 0}doFlushWhenIdle(){this.runFlushWhenIdle.value=(0,I.runWhenIdle)(()=>{this.shouldFlushWhenIdle()&&this.flush(),this.flushWhenIdleScheduler.schedule()})}shouldFlushWhenIdle(){return!0}stopFlushWhenIdle(){(0,w.dispose)([this.runFlushWhenIdle,this.flushWhenIdleScheduler])}initialize(){return this.initializationPromise||(this.initializationPromise=(async()=>{(0,O.mark)("code/willInitStorage");try{await this.doInitialize()}finally{(0,O.mark)("code/didInitStorage")}this.flushWhenIdleScheduler.schedule()})()),this.initializationPromise}emitDidChangeValue(g,a){if(a===C){switch(g){case-1:this._applicationKeyTargets=void 0;break;case 0:this._profileKeyTargets=void 0;break;case 1:this._workspaceKeyTargets=void 0;break}this._onDidChangeTarget.fire({scope:g})}else this._onDidChangeValue.fire({scope:g,key:a,target:this.getKeyTargets(g)[a]})}emitWillSaveState(g){this._onWillSaveState.fire({reason:g})}get(g,a,s){return this.getStorage(a)?.get(g,s)}getBoolean(g,a,s){return this.getStorage(a)?.getBoolean(g,s)}getNumber(g,a,s){return this.getStorage(a)?.getNumber(g,s)}store(g,a,s,i){if((0,A.isUndefinedOrNull)(a)){this.remove(g,s);return}this.withPausedEmitters(()=>{this.updateKeyTarget(g,s,i),this.getStorage(s)?.set(g,a)})}remove(g,a){this.withPausedEmitters(()=>{this.updateKeyTarget(g,a,void 0),this.getStorage(a)?.delete(g)})}withPausedEmitters(g){this._onDidChangeValue.pause(),this._onDidChangeTarget.pause();try{g()}finally{this._onDidChangeValue.resume(),this._onDidChangeTarget.resume()}}keys(g,a){const s=[],i=this.getKeyTargets(g);for(const n of Object.keys(i))i[n]===a&&s.push(n);return s}updateKeyTarget(g,a,s){const i=this.getKeyTargets(a);typeof s=="number"?i[g]!==s&&(i[g]=s,this.getStorage(a)?.set(C,JSON.stringify(i))):typeof i[g]=="number"&&(delete i[g],this.getStorage(a)?.set(C,JSON.stringify(i)))}get workspaceKeyTargets(){return this._workspaceKeyTargets||(this._workspaceKeyTargets=this.loadKeyTargets(1)),this._workspaceKeyTargets}get profileKeyTargets(){return this._profileKeyTargets||(this._profileKeyTargets=this.loadKeyTargets(0)),this._profileKeyTargets}get applicationKeyTargets(){return this._applicationKeyTargets||(this._applicationKeyTargets=this.loadKeyTargets(-1)),this._applicationKeyTargets}getKeyTargets(g){switch(g){case-1:return this.applicationKeyTargets;case 0:return this.profileKeyTargets;default:return this.workspaceKeyTargets}}loadKeyTargets(g){const a=this.get(C,g);if(a)try{return JSON.parse(a)}catch{}return Object.create(null)}isNew(g){return this.getBoolean(t.IS_NEW_KEY,g)===!0}async flush(g=P.NONE){this._onWillSaveState.fire({reason:g});const a=this.getStorage(-1),s=this.getStorage(0),i=this.getStorage(1);switch(g){case P.NONE:await I.Promises.settled([a?.whenFlushed()??Promise.resolve(),s?.whenFlushed()??Promise.resolve(),i?.whenFlushed()??Promise.resolve()]);break;case P.SHUTDOWN:await I.Promises.settled([a?.flush(0)??Promise.resolve(),s?.flush(0)??Promise.resolve(),i?.flush(0)??Promise.resolve()]);break}}async log(){const g=this.getStorage(-1)?.items??new Map,a=this.getStorage(0)?.items??new Map,s=this.getStorage(1)?.items??new Map;return l(g,a,s,this.getLogDetails(-1)??"",this.getLogDetails(0)??"",this.getLogDetails(1)??"")}async switch(g,a){return this.emitWillSaveState(P.NONE),(0,d.isUserDataProfile)(g)?this.switchToProfile(g,a):this.switchToWorkspace(g,a)}canSwitchProfile(g,a){return!(g.id===a.id||m(a)&&m(g))}switchData(g,a,s,i){this.withPausedEmitters(()=>{if(i)for(const[n,e]of g)a.set(n,e);else{const n=new Set;for(const[e,r]of g)n.add(e),a.get(e)!==r&&this.emitDidChangeValue(s,e);for(const[e]of a.items)n.has(e)||this.emitDidChangeValue(s,e)}})}}t.AbstractStorageService=f,f.DEFAULT_FLUSH_INTERVAL=60*1e3;function m(u){return u.isDefault||!!u.useDefaultFlags?.uiState}t.isProfileUsingDefaultStorage=m;class y extends f{constructor(){super();this.applicationStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.profileStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this.workspaceStorage=this._register(new p.Storage(new p.InMemoryStorageDatabase)),this._register(this.workspaceStorage.onDidChangeStorage(g=>this.emitDidChangeValue(1,g))),this._register(this.profileStorage.onDidChangeStorage(g=>this.emitDidChangeValue(0,g))),this._register(this.applicationStorage.onDidChangeStorage(g=>this.emitDidChangeValue(-1,g)))}getStorage(g){switch(g){case-1:return this.applicationStorage;case 0:return this.profileStorage;default:return this.workspaceStorage}}getLogDetails(g){switch(g){case-1:return"inMemory (application)";case 0:return"inMemory (profile)";default:return"inMemory (workspace)"}}async doInitialize(){}async switchToProfile(){}async switchToWorkspace(){}}t.InMemoryStorageService=y;async function l(u,g,a,s,i,n){const e=G=>{try{return JSON.parse(G)}catch{return G}},r=new Map,o=new Map;u.forEach((G,Q)=>{r.set(Q,G),o.set(Q,e(G))});const S=new Map,E=new Map;g.forEach((G,Q)=>{S.set(Q,G),E.set(Q,e(G))});const D=new Map,k=new Map;a.forEach((G,Q)=>{D.set(Q,G),k.set(Q,e(G))}),console.group(s!==i?`Storage: Application (path: ${s})`:`Storage: Application & Profile (path: ${s}, default profile)`);const V=[];if(r.forEach((G,Q)=>{V.push({key:Q,value:G})}),console.table(V),console.groupEnd(),console.log(o),s!==i){console.group(`Storage: Profile (path: ${i}, profile specific)`);const G=[];S.forEach((Q,ne)=>{G.push({key:ne,value:Q})}),console.table(G),console.groupEnd(),console.log(E)}console.group(`Storage: Workspace (path: ${n})`);const _=[];D.forEach((G,Q)=>{_.push({key:Q,value:G})}),console.table(_),console.groupEnd(),console.log(k)}t.logStorage=l}),define(Z[141],ee([0,1,19,24,12,13,32,5,10,21,18,22,23,45,11,9,27,47,128,140,35]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l,u,g,a){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionGalleryServiceWithNoStorageService=t.ExtensionGalleryService=t.sortExtensionVersions=void 0;const s=O.isWeb?"web":(0,P.getTargetPlatform)(O.platform,A.arch);var i;(function(R){R[R.None=0]="None",R[R.IncludeVersions=1]="IncludeVersions",R[R.IncludeFiles=2]="IncludeFiles",R[R.IncludeCategoryAndTags=4]="IncludeCategoryAndTags",R[R.IncludeSharedAccounts=8]="IncludeSharedAccounts",R[R.IncludeVersionProperties=16]="IncludeVersionProperties",R[R.ExcludeNonValidated=32]="ExcludeNonValidated",R[R.IncludeInstallationTargets=64]="IncludeInstallationTargets",R[R.IncludeAssetUri=128]="IncludeAssetUri",R[R.IncludeStatistics=256]="IncludeStatistics",R[R.IncludeLatestVersionOnly=512]="IncludeLatestVersionOnly",R[R.Unpublished=4096]="Unpublished",R[R.IncludeNameConflictInfo=32768]="IncludeNameConflictInfo"})(i||(i={}));function n(...R){return String(R.reduce((L,U)=>L|U,0))}var e;(function(R){R[R.Tag=1]="Tag",R[R.ExtensionId=4]="ExtensionId",R[R.Category=5]="Category",R[R.ExtensionName=7]="ExtensionName",R[R.Target=8]="Target",R[R.Featured=9]="Featured",R[R.SearchText=10]="SearchText",R[R.ExcludeWithFlags=12]="ExcludeWithFlags"})(e||(e={}));const r={Icon:"Microsoft.VisualStudio.Services.Icons.Default",Details:"Microsoft.VisualStudio.Services.Content.Details",Changelog:"Microsoft.VisualStudio.Services.Content.Changelog",Manifest:"Microsoft.VisualStudio.Code.Manifest",VSIX:"Microsoft.VisualStudio.Services.VSIXPackage",License:"Microsoft.VisualStudio.Services.Content.License",Repository:"Microsoft.VisualStudio.Services.Links.Source"},o={Dependency:"Microsoft.VisualStudio.Code.ExtensionDependencies",ExtensionPack:"Microsoft.VisualStudio.Code.ExtensionPack",Engine:"Microsoft.VisualStudio.Code.Engine",PreRelease:"Microsoft.VisualStudio.Code.PreRelease",LocalizedLanguages:"Microsoft.VisualStudio.Code.LocalizedLanguages",WebExtension:"Microsoft.VisualStudio.Code.WebExtension",SponsorLink:"Microsoft.VisualStudio.Code.SponsorLink"},E={pageNumber:1,pageSize:10,sortBy:0,sortOrder:0,flags:i.None,criteria:[],assetTypes:[]};class D{constructor(L=E){this.state=L}get pageNumber(){return this.state.pageNumber}get pageSize(){return this.state.pageSize}get sortBy(){return this.state.sortBy}get sortOrder(){return this.state.sortOrder}get flags(){return this.state.flags}withPage(L,U=this.state.pageSize){return new D({...this.state,pageNumber:L,pageSize:U})}withFilter(L,...U){const j=[...this.state.criteria,...U.length?U.map(H=>({filterType:L,value:H})):[{filterType:L}]];return new D({...this.state,criteria:j})}withSortBy(L){return new D({...this.state,sortBy:L})}withSortOrder(L){return new D({...this.state,sortOrder:L})}withFlags(...L){return new D({...this.state,flags:L.reduce((U,j)=>U|j,0)})}withAssetTypes(...L){return new D({...this.state,assetTypes:L})}withSource(L){return new D({...this.state,source:L})}get raw(){const{criteria:L,pageNumber:U,pageSize:j,sortBy:H,sortOrder:X,flags:oe,assetTypes:le}=this.state;return{filters:[{criteria:L,pageNumber:U,pageSize:j,sortBy:H,sortOrder:X}],assetTypes:le,flags:oe}}get searchText(){const L=this.state.criteria.filter(U=>U.filterType===e.SearchText)[0];return L&&L.value?L.value:""}get telemetryData(){return{filterTypes:this.state.criteria.map(L=>String(L.filterType)),flags:this.state.flags,sortBy:String(this.sortBy),sortOrder:String(this.sortOrder),pageNumber:String(this.pageNumber),source:this.state.source,searchTextLength:this.searchText.length}}}function k(R,L){const U=(R||[]).filter(j=>j.statisticName===L)[0];return U?U.value:0}function V(R){const L="Microsoft.VisualStudio.Code.Translation.";return R.files.filter(j=>j.assetType.indexOf(L)===0).reduce((j,H)=>{const X=Q(R,H.assetType);return X&&j.push([H.assetType.substring(L.length),X]),j},[])}function _(R){if(R.properties){const L=R.properties.filter(H=>H.key===r.Repository),U=new RegExp("((git|ssh|http(s)?)|(git@[\\w.]+))(:(//)?)([\\w.@:/\\-~]+)(.git)(/)?"),j=L.filter(H=>U.test(H.value))[0];return j?{uri:j.value,fallbackUri:j.value}:null}return Q(R,r.Repository)}function G(R){return{uri:`${R.fallbackAssetUri}/${r.VSIX}?redirect=true${R.targetPlatform?`&targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${r.VSIX}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}}function Q(R,L){return R.files.filter(j=>j.assetType===L)[0]?{uri:`${R.assetUri}/${L}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`,fallbackUri:`${R.fallbackAssetUri}/${L}${R.targetPlatform?`?targetPlatform=${R.targetPlatform}`:""}`}:null}function ne(R,L){const U=R.properties?R.properties.filter(H=>H.key===L):[],j=U.length>0&&U[0].value;return j?j.split(",").map(H=>(0,h.adoptToGalleryExtensionId)(H)):[]}function ce(R){const L=R.properties?R.properties.filter(U=>U.key===o.Engine):[];return L.length>0&&L[0].value||""}function re(R){const L=R.properties?R.properties.filter(U=>U.key===o.PreRelease):[];return L.length>0&&L[0].value==="true"}function ge(R){const L=R.properties?R.properties.filter(j=>j.key===o.LocalizedLanguages):[],U=L.length>0&&L[0].value||"";return U?U.split(","):[]}function ae(R){return R.properties?.find(L=>L.key===o.SponsorLink)?.value}function N(R){return R.indexOf("preview")!==-1}function B(R){return R.targetPlatform?(0,P.toTargetPlatform)(R.targetPlatform):"undefined"}function M(R){const L=(0,I.distinct)(R.versions.map(B)),U=!!R.tags?.includes(P.WEB_EXTENSION_TAG),j=L.indexOf("web");return U?j===-1&&L.push("web"):j!==-1&&L.splice(j,1),L}function F(R,L){const U=(0,P.getFallbackTargetPlarforms)(L);for(let j=0;j<R.length;j++){const H=R[j];if(H.version===R[j-1]?.version){let X=j;const oe=B(H);if(oe===L)for(;X>0&&R[X-1].version===H.version;)X--;else if(U.includes(oe))for(;X>0&&R[X-1].version===H.version&&B(R[X-1])!==L;)X--;X!==j&&(R.splice(j,1),R.splice(X,0,H))}}return R}t.sortExtensionVersions=F;function W(R,L,U){R.telemetryData={index:L,querySource:U}}function q(R,L,U){const j=R.versions[0],H={manifest:Q(L,r.Manifest),readme:Q(L,r.Details),changelog:Q(L,r.Changelog),license:Q(L,r.License),repository:_(L),download:G(L),icon:Q(L,r.Icon),coreTranslations:V(L)};return{identifier:{id:(0,h.getGalleryExtensionId)(R.publisher.publisherName,R.extensionName),uuid:R.extensionId},name:R.extensionName,version:L.version,displayName:R.displayName,publisherId:R.publisher.publisherId,publisher:R.publisher.publisherName,publisherDisplayName:R.publisher.displayName,publisherDomain:R.publisher.domain?{link:R.publisher.domain,verified:!!R.publisher.isDomainVerified}:void 0,publisherSponsorLink:ae(j),description:R.shortDescription||"",installCount:k(R.statistics,"install"),rating:k(R.statistics,"averagerating"),ratingCount:k(R.statistics,"ratingcount"),categories:R.categories||[],tags:R.tags||[],releaseDate:Date.parse(R.releaseDate),lastUpdated:Date.parse(R.lastUpdated),allTargetPlatforms:U,assets:H,properties:{dependencies:ne(L,o.Dependency),extensionPack:ne(L,o.ExtensionPack),engine:ce(L),localizedLanguages:ge(L),targetPlatform:B(L),isPreReleaseVersion:re(L)},hasPreReleaseVersion:re(j),hasReleaseVersion:!0,preview:N(R.flags)}}let Y=class{constructor(L,U,j,H,X,oe,le,pe){this.requestService=U,this.logService=j,this.environmentService=H,this.telemetryService=X,this.fileService=oe,this.productService=le,this.configurationService=pe;const ve=le.extensionsGallery;this.extensionsGalleryUrl=ve&&ve.serviceUrl,this.extensionsControlUrl=ve&&ve.controlUrl,this.commonHeadersPromise=(0,u.resolveMarketplaceHeaders)(le.version,le,this.environmentService,this.configurationService,this.fileService,L,this.telemetryService)}api(L=""){return`${this.extensionsGalleryUrl}${L}`}isEnabled(){return!!this.extensionsGalleryUrl}async getExtensions(L,U,j){const H=b.CancellationToken.isCancellationToken(U)?{}:U,X=b.CancellationToken.isCancellationToken(U)?U:j,oe=[],le=[],pe=[],ve=[];let ie=!0;for(const de of L){de.uuid?le.push(de.uuid):oe.push(de.id);const Se=!!(de.version||de.preRelease);pe.push({id:de.id,uuid:de.uuid,includePreRelease:Se}),de.version&&ve.push({id:de.id,uuid:de.uuid,version:de.version}),ie=ie&&!!de.hasPreRelease&&!Se}if(!le.length&&!oe.length)return[];let se=new D().withPage(1,L.length);le.length&&(se=se.withFilter(e.ExtensionId,...le)),oe.length&&(se=se.withFilter(e.ExtensionName,...oe)),(H.queryAllVersions||ie)&&(se=se.withFlags(se.flags,i.IncludeVersions)),H.source&&(se=se.withSource(H.source));const{extensions:he}=await this.queryGalleryExtensions(se,{targetPlatform:H.targetPlatform??s,includePreRelease:pe,versions:ve,compatible:!!H.compatible},X);return H.source&&he.forEach((de,Se)=>W(de,Se,H.source)),he}async getCompatibleExtension(L,U,j){if((0,P.isNotWebExtensionInWebTargetPlatform)(L.allTargetPlatforms,j))return null;if(await this.isExtensionCompatible(L,U,j))return L;const H=new D().withFlags(i.IncludeVersions).withPage(1,1).withFilter(e.ExtensionId,L.identifier.uuid),{extensions:X}=await this.queryGalleryExtensions(H,{targetPlatform:j,compatible:!0,includePreRelease:U},b.CancellationToken.None);return X[0]||null}async isExtensionCompatible(L,U,j){if(!(0,P.isTargetPlatformCompatible)(L.properties.targetPlatform,L.allTargetPlatforms,j)||!U&&L.properties.isPreReleaseVersion)return!1;let H=L.properties.engine;if(!H){const X=await this.getManifest(L,b.CancellationToken.None);if(!X)throw new Error("Manifest was not found");H=X.engines.vscode}return(0,v.isEngineValid)(H,this.productService.version,this.productService.date)}async isValidVersion(L,U,j,H,X){if(!(0,P.isTargetPlatformCompatible)(B(L),H,X)||U!=="any"&&re(L)!==(U==="prerelease"))return!1;if(j)try{const oe=await this.getEngine(L);if(!(0,v.isEngineValid)(oe,this.productService.version,this.productService.date))return!1}catch(oe){return this.logService.error(`Error while getting the engine for the version ${L.version}.`,(0,w.getErrorMessage)(oe)),!1}return!0}async query(L,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");let j=L.text||"";const H=L.pageSize??50;let X=new D().withPage(1,H);j?(j=j.replace(/\bcategory:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Category,he||se),"")),j=j.replace(/\btag:("([^"]*)"|([^"]\S*))(\s+|\b|$)/g,(ie,se,he)=>(X=X.withFilter(e.Tag,he||se),"")),j=j.replace(/\bfeatured(\s+|\b|$)/g,()=>(X=X.withFilter(e.Featured),"")),j=j.trim(),j&&(j=j.length<200?j:j.substring(0,200),X=X.withFilter(e.SearchText,j)),X=X.withSortBy(0)):L.ids?X=X.withFilter(e.ExtensionId,...L.ids):L.names?X=X.withFilter(e.ExtensionName,...L.names):X=X.withSortBy(4),typeof L.sortBy=="number"&&(X=X.withSortBy(L.sortBy)),typeof L.sortOrder=="number"&&(X=X.withSortOrder(L.sortOrder)),L.source&&(X=X.withSource(L.source));const oe=async(ie,se)=>{const{extensions:he,total:de}=await this.queryGalleryExtensions(ie,{targetPlatform:s,compatible:!1,includePreRelease:!!L.includePreRelease},se);return he.forEach((Se,ke)=>W(Se,(ie.pageNumber-1)*ie.pageSize+ke,L.source)),{extensions:he,total:de}},{extensions:le,total:pe}=await oe(X,U),ve=async(ie,se)=>{if(se.isCancellationRequested)throw new w.CancellationError;const{extensions:he}=await oe(X.withPage(ie+1),se);return he};return{firstPage:le,total:pe,pageSize:X.pageSize,getPage:ve}}async queryGalleryExtensions(L,U,j){const H=L.flags;!!(L.flags&i.IncludeLatestVersionOnly)&&!!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags&~i.IncludeVersions,i.IncludeLatestVersionOnly)),!(L.flags&i.IncludeLatestVersionOnly)&&!(L.flags&i.IncludeVersions)&&(L=L.withFlags(L.flags,i.IncludeLatestVersionOnly)),U.versions?.length&&(L=L.withFlags(L.flags&~i.IncludeLatestVersionOnly,i.IncludeVersions)),L=L.withFlags(L.flags,i.IncludeAssetUri,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeStatistics,i.IncludeVersionProperties);const{galleryExtensions:X,total:oe}=await this.queryRawGalleryExtensions(L,j);if(!(L.flags&i.IncludeLatestVersionOnly)){const ie=[];for(const se of X){const he=await this.toGalleryExtensionWithCriteria(se,U);he&&ie.push(he)}return{extensions:ie,total:oe}}const pe=[],ve=new Map;for(let ie=0;ie<X.length;ie++){const se=X[ie],he={id:(0,h.getGalleryExtensionId)(se.publisher.publisherName,se.extensionName),uuid:se.extensionId},de=(0,p.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(ke=>(0,h.areSameExtensions)(ke,he))?.includePreRelease;if(U.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(M(se),U.targetPlatform))continue;const Se=await this.toGalleryExtensionWithCriteria(se,U);!Se||Se.properties.isPreReleaseVersion&&(!de||!Se.hasReleaseVersion)||!Se.properties.isPreReleaseVersion&&Se.properties.targetPlatform!==U.targetPlatform&&Se.hasPreReleaseVersion?ve.set(se.extensionId,ie):pe.push([ie,Se])}if(ve.size){const ie=new Date().getTime(),se=new D().withFlags(H&~i.IncludeLatestVersionOnly,i.IncludeVersions).withPage(1,ve.size).withFilter(e.ExtensionId,...ve.keys()),{extensions:he}=await this.queryGalleryExtensions(se,U,j);this.telemetryService.publicLog2("galleryService:additionalQuery",{duration:new Date().getTime()-ie,count:ve.size});for(const de of he){const Se=ve.get(de.identifier.uuid);pe.push([Se,de])}}return{extensions:pe.sort((ie,se)=>ie[0]-se[0]).map(([,ie])=>ie),total:oe}}async toGalleryExtensionWithCriteria(L,U){const j={id:(0,h.getGalleryExtensionId)(L.publisher.publisherName,L.extensionName),uuid:L.extensionId},H=U.versions?.find(pe=>(0,h.areSameExtensions)(pe,j))?.version,X=(0,p.isBoolean)(U.includePreRelease)?U.includePreRelease:!!U.includePreRelease.find(pe=>(0,h.areSameExtensions)(pe,j))?.includePreRelease,oe=M(L),le=F(L.versions,U.targetPlatform);if(U.compatible&&(0,P.isNotWebExtensionInWebTargetPlatform)(oe,U.targetPlatform))return null;for(let pe=0;pe<le.length;pe++){const ve=le[pe];if(!(H&&ve.version!==H)){if(await this.isValidVersion(ve,X?"any":"release",U.compatible,oe,U.targetPlatform))return q(L,ve,oe);if(H&&ve.version===H)return null}}return H||U.compatible?null:q(L,L.versions[0],oe)}async queryRawGalleryExtensions(L,U){if(!this.isEnabled())throw new Error("No extension gallery service configured.");L=L.withFlags(L.flags,i.ExcludeNonValidated).withFilter(e.Target,"Microsoft.VisualStudio.Code").withFilter(e.ExcludeWithFlags,n(i.Unpublished));const j=await this.commonHeadersPromise,H=JSON.stringify(L.raw),X={...j,"Content-Type":"application/json",Accept:"application/json;api-version=3.0-preview.1","Accept-Encoding":"gzip","Content-Length":String(H.length)},oe=new Date().getTime();let le,pe,ve=0;try{if(le=await this.requestService.request({type:"POST",url:this.api("/extensionquery"),data:H,headers:X},U),le.res.statusCode&&le.res.statusCode>=400&&le.res.statusCode<500)return{galleryExtensions:[],total:ve};const ie=await(0,l.asJson)(le);if(ie){const se=ie.results[0],he=se.extensions,de=se.resultMetadata&&se.resultMetadata.filter(Se=>Se.metadataType==="ResultCount")[0];return ve=de&&de.metadataItems.filter(Se=>Se.name==="TotalCount")[0].count||0,{galleryExtensions:he,total:ve}}return{galleryExtensions:[],total:ve}}catch(ie){throw pe=ie,ie}finally{this.telemetryService.publicLog2("galleryService:query",{...L.telemetryData,requestBodySize:String(H.length),duration:new Date().getTime()-oe,success:!!le&&(0,l.isSuccess)(le),responseBodySize:le?.res.headers["Content-Length"],statusCode:le?String(le.res.statusCode):void 0,errorCode:pe?(0,w.isCancellationError)(pe)?"canceled":(0,w.getErrorMessage)(pe).startsWith("XHR timeout")?"timeout":"failed":void 0,count:String(ve)})}}async reportStatistic(L,U,j,H){if(!this.isEnabled())return;const X=O.isWeb?this.api(`/itemName/${L}.${U}/version/${j}/statType/${H==="install"?"1":"3"}/vscodewebextension`):this.api(`/publishers/${L}/extensions/${U}/${j}/stats?statType=${H}`),oe=O.isWeb?"api-version=6.1-preview.1":"*/*;api-version=4.0-preview.1",pe={...await this.commonHeadersPromise,Accept:oe};try{await this.requestService.request({type:"POST",url:X,headers:pe},b.CancellationToken.None)}catch{}}async download(L,U,j){this.logService.trace("ExtensionGalleryService#download",L.identifier.id);const H=(0,h.getGalleryExtensionTelemetryData)(L),X=new Date().getTime(),oe=ie=>this.telemetryService.publicLog("galleryService:downloadVSIX",{...H,duration:ie}),le=j===2?"install":j===3?"update":"",pe=le?{uri:`${L.assets.download.uri}${c.URI.parse(L.assets.download.uri).query?"&":"?"}${le}=true`,fallbackUri:`${L.assets.download.fallbackUri}${c.URI.parse(L.assets.download.fallbackUri).query?"&":"?"}${le}=true`}:L.assets.download,ve=await this.getAsset(pe);await this.fileService.writeFile(U,ve.stream),oe(new Date().getTime()-X)}async getReadme(L,U){if(L.assets.readme){const j=await this.getAsset(L.assets.readme,{},U);return await(0,l.asTextOrError)(j)||""}return""}async getManifest(L,U){if(L.assets.manifest){const j=await this.getAsset(L.assets.manifest,{},U),H=await(0,l.asTextOrError)(j);return H?JSON.parse(H):null}return null}async getManifestFromRawExtensionVersion(L,U){const j=Q(L,r.Manifest);if(!j)throw new Error("Manifest was not found");const H={"Accept-Encoding":"gzip"},X=await this.getAsset(j,{headers:H});return await(0,l.asJson)(X)}async getCoreTranslation(L,U){const j=L.assets.coreTranslations.filter(H=>H[0]===U.toUpperCase())[0];if(j){const H=await this.getAsset(j[1]),X=await(0,l.asTextOrError)(H);return X?JSON.parse(X):null}return null}async getChangelog(L,U){if(L.assets.changelog){const j=await this.getAsset(L.assets.changelog,{},U);return await(0,l.asTextOrError)(j)||""}return""}async getAllCompatibleVersions(L,U,j){let H=new D().withFlags(i.IncludeVersions,i.IncludeCategoryAndTags,i.IncludeFiles,i.IncludeVersionProperties).withPage(1,1);L.identifier.uuid?H=H.withFilter(e.ExtensionId,L.identifier.uuid):H=H.withFilter(e.ExtensionName,L.identifier.id);const{galleryExtensions:X}=await this.queryRawGalleryExtensions(H,b.CancellationToken.None);if(!X.length)return[];const oe=M(X[0]);if((0,P.isNotWebExtensionInWebTargetPlatform)(oe,j))return[];const le=[];await Promise.all(X[0].versions.map(async ie=>{try{await this.isValidVersion(ie,U?"any":"release",!0,oe,j)&&le.push(ie)}catch{}}));const pe=[],ve=new Set;for(const ie of F(le,j))ve.has(ie.version)||(ve.add(ie.version),pe.push({version:ie.version,date:ie.lastUpdated,isPreReleaseVersion:re(ie)}));return pe}async getAsset(L,U={},j=b.CancellationToken.None){const H=await this.commonHeadersPromise,X={type:"GET"},oe={...H,...U.headers||{}};U={...U,...X,headers:oe};const le=L.uri,pe=L.fallbackUri,ve={...U,url:le};try{const ie=await this.requestService.request(ve,j);if(ie.res.statusCode===200)return ie;const se=await(0,l.asTextOrError)(ie);throw new Error(`Expected 200, got back ${ie.res.statusCode} instead.

${se}`)}catch(ie){if((0,w.isCancellationError)(ie))throw ie;const se=(0,w.getErrorMessage)(ie);this.telemetryService.publicLog2("galleryService:cdnFallback",{url:le,message:se});const he={...U,url:pe};return this.requestService.request(he,j)}}async getEngine(L){let U=ce(L);if(!U){const j=await this.getManifestFromRawExtensionVersion(L,b.CancellationToken.None);if(!j)throw new Error("Manifest was not found");U=j.engines.vscode}return U}async getExtensionsControlManifest(){if(!this.isEnabled())throw new Error("No extension gallery service configured.");if(!this.extensionsControlUrl)return{malicious:[],deprecated:{}};const L=await this.requestService.request({type:"GET",url:this.extensionsControlUrl},b.CancellationToken.None);if(L.res.statusCode!==200)throw new Error("Could not get extensions report.");const U=await(0,l.asJson)(L),j=[],H={};if(U){for(const X of U.malicious)j.push({id:X});if(U.migrateToPreRelease)for(const[X,oe]of Object.entries(U.migrateToPreRelease))(!oe.engine||(0,v.isEngineValid)(oe.engine,this.productService.version,this.productService.date))&&(H[X.toLowerCase()]={disallowInstall:!0,extension:{id:oe.id,displayName:oe.displayName,autoMigrate:{storage:!!oe.migrateStorage},preRelease:!0}});if(U.deprecated)for(const[X,oe]of Object.entries(U.deprecated))oe&&(H[X.toLowerCase()]=(0,p.isBoolean)(oe)?{}:oe)}return{malicious:j,deprecated:H}}};Y=fe([te(1,l.IRequestService),te(2,m.ILogService),te(3,C.IEnvironmentService),te(4,a.ITelemetryService),te(5,f.IFileService),te(6,y.IProductService),te(7,d.IConfigurationService)],Y);let T=class extends Y{constructor(L,U,j,H,X,oe,le,pe){super(L,U,j,H,X,oe,le,pe)}};T=fe([te(0,g.IStorageService),te(1,l.IRequestService),te(2,m.ILogService),te(3,C.IEnvironmentService),te(4,a.ITelemetryService),te(5,f.IFileService),te(6,y.IProductService),te(7,d.IConfigurationService)],T),t.ExtensionGalleryService=T;let x=class extends Y{constructor(L,U,j,H,X,oe,le){super(void 0,L,U,j,H,X,oe,le)}};x=fe([te(0,l.IRequestService),te(1,m.ILogService),te(2,C.IEnvironmentService),te(3,a.ITelemetryService),te(4,f.IFileService),te(5,y.IProductService),te(6,d.IConfigurationService)],x),t.ExtensionGalleryServiceWithNoStorageService=x}),define(Z[142],ee([0,1,44,18,11,9,65,28,25]),function($,t,I,b,w,O,A,p,c){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.UserDataProfilesService=void 0;let d=class je extends c.UserDataProfilesService{constructor(P,h,v,f,m){super(v,f,h,m);this.stateService=P}getStoredProfiles(){return(0,I.revive)(this.stateService.getItem(je.PROFILES_KEY,[]))}getStoredProfileAssociations(){return(0,I.revive)(this.stateService.getItem(je.PROFILE_ASSOCIATIONS_KEY,{}))}};d=fe([te(0,A.IStateService),te(1,p.IUriIdentityService),te(2,b.IEnvironmentService),te(3,w.IFileService),te(4,O.ILogService)],d),t.UserDataProfilesService=d}),define(Z[143],ee([0,1,37,3,155,2]),function($,t,I,b,w,O){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.NativePolicyService=void 0;class A extends I.AbstractPolicyService{constructor(c){super();this.productName=c,this.throttler=new b.Throttler,this.watcher=this._register(new O.MutableDisposable)}async initializePolicies(c){await this.throttler.queue(()=>new Promise((d,C)=>{try{this.watcher.value=(0,w.createWatcher)(this.productName,c,P=>{for(const h in P){const v=P[h];v===void 0?this.policies.delete(h):this.policies.set(h,v)}this._onDidChange.fire(Object.keys(P)),d()})}catch(P){C(P)}}))}}t.NativePolicyService=A}),define(Z[67],ee([0,1,112,3,14,5,20,80,156,157]),function($,t,I,b,w,O,A,p,c,d){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.buffer=t.extract=t.zip=t.ExtractError=void 0;class C extends Error{constructor(i,n){let e=n.message;switch(i){case"CorruptZip":e=`Corrupt ZIP: ${e}`;break}super(e);this.type=i,this.cause=n}}t.ExtractError=C;function P(s){const i=s.externalFileAttributes>>16||33188;return[448,56,7].map(n=>i&n).reduce((n,e)=>n+e,i&61440)}function h(s){if(s instanceof C)return s;let i;return/end of central directory record signature not found/.test(s.message)&&(i="CorruptZip"),new C(i,s)}function v(s,i,n,e,r,o){const S=w.dirname(i),E=w.join(e,S);if(!E.startsWith(e))return Promise.reject(new Error(p.localize(0,null,i)));const D=w.join(e,i);let k;return o.onCancellationRequested(()=>{k?.destroy()}),Promise.resolve(A.Promises.mkdir(E,{recursive:!0})).then(()=>new Promise((V,_)=>{if(!o.isCancellationRequested)try{k=(0,I.createWriteStream)(D,{mode:n}),k.once("close",()=>V()),k.once("error",_),s.once("error",_),s.pipe(k)}catch(G){_(G)}}))}function f(s,i,n,e){let r=(0,b.createCancelablePromise)(()=>Promise.resolve()),o=0;return e.onCancellationRequested(()=>{r.cancel(),s.close()}),new Promise((S,E)=>{const D=new b.Sequencer,k=V=>{V.isCancellationRequested||(o++,s.readEntry())};s.once("error",E),s.once("close",()=>r.then(()=>{e.isCancellationRequested||s.entryCount===o?S():E(new C("Incomplete",new Error(p.localize(1,null,o,s.entryCount))))},E)),s.readEntry(),s.on("entry",V=>{if(e.isCancellationRequested)return;if(!n.sourcePathRegex.test(V.fileName)){k(e);return}const _=V.fileName.replace(n.sourcePathRegex,"");if(/\/$/.test(_)){const ne=w.join(i,_);r=(0,b.createCancelablePromise)(ce=>A.Promises.mkdir(ne,{recursive:!0}).then(()=>k(ce)).then(void 0,E));return}const G=y(s,V),Q=P(V);r=(0,b.createCancelablePromise)(ne=>D.queue(()=>G.then(ce=>v(ce,_,Q,i,n,ne).then(()=>k(ne)))).then(null,E))})})}function m(s,i=!1){return new Promise((n,e)=>{(0,c.open)(s,i?{lazyEntries:!0}:void 0,(r,o)=>{r?e(h(r)):n((0,O.assertIsDefined)(o))})})}function y(s,i){return new Promise((n,e)=>{s.openReadStream(i,(r,o)=>{r?e(h(r)):n((0,O.assertIsDefined)(o))})})}function l(s,i){return new Promise((n,e)=>{const r=new d.ZipFile;i.forEach(S=>{S.contents?r.addBuffer(typeof S.contents=="string"?Buffer.from(S.contents,"utf8"):S.contents,S.path):S.localPath&&r.addFile(S.localPath,S.path)}),r.end();const o=(0,I.createWriteStream)(s);r.outputStream.pipe(o),r.outputStream.once("error",e),o.once("error",e),o.once("finish",()=>n(s))})}t.zip=l;function u(s,i,n={},e){const r=new RegExp(n.sourcePath?`^${n.sourcePath}`:"");let o=m(s,!0);return n.overwrite&&(o=o.then(S=>A.Promises.rm(i).then(()=>S))),o.then(S=>f(S,i,{sourcePathRegex:r},e))}t.extract=u;function g(s,i){return m(s).then(n=>new Promise((e,r)=>{n.on("entry",o=>{o.fileName===i&&y(n,o).then(S=>e(S),S=>r(S))}),n.once("close",()=>r(new Error(p.localize(2,null,i))))}))}function a(s,i){return g(s,i).then(n=>new Promise((e,r)=>{const o=[];n.once("error",r),n.on("data",S=>o.push(S)),n.on("end",()=>e(Buffer.concat(o)))}))}t.buffer=a}),define(Z[144],ee([0,1,67,87]),function($,t,I,b){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.getManifest=void 0;function w(O){return(0,I.buffer)(O,"extension/package.json").then(A=>{try{return JSON.parse(A.toString("utf8"))}catch{throw new Error((0,b.localize)(0,null))}})}t.getManifest=w}),define(Z[145],ee([0,1,3,30,12,2,16,14,13,17,39,5,10,29,20,67,86,58,18,137,22,23,41,48,120,138,144,121,134,34,45,11,8,9,27,35,28,25]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l,u,g,a,s,i,n,e,r,o,S,E,D,k,V,_,G,Q,ne,ce,re){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.ExtensionManagementService=t.INativeServerExtensionManagementService=void 0,t.INativeServerExtensionManagementService=(0,_.refineServiceDecorator)(a.IServerExtensionManagementService);let ge=class extends g.AbstractExtensionManagementService{constructor(T,x,R,L,U,j,H,X,oe,le,pe,ve){super(T,x,R,le,ve);this.extensionsScannerService=U,this.extensionsProfileScannerService=j,this.downloadService=H,this.fileService=oe,this.installGalleryExtensionsTasks=new Map;const ie=this._register(X.createInstance(r.ExtensionsLifecycle));this.extensionsScanner=this._register(X.createInstance(ae,he=>ie.postUninstall(he))),this.manifestCache=this._register(new S.ExtensionsManifestCache(L,this)),this.extensionsDownloader=this._register(X.createInstance(e.ExtensionsDownloader));const se=this._register(new E.ExtensionsWatcher(this,oe,L,R,pe));this._register(se.onDidChangeExtensionsByAnotherSource(({added:he,removed:de})=>{he.length&&this._onDidInstallExtensions.fire(he.map(Se=>({identifier:Se.identifier,operation:1,local:Se}))),de.forEach(Se=>this._onDidUninstallExtension.fire({identifier:Se}))}))}getTargetPlatform(){return this._targetPlatformPromise||(this._targetPlatformPromise=(0,s.computeTargetPlatform)(this.fileService,this.logService)),this._targetPlatformPromise}async zip(T){this.logService.trace("ExtensionManagementService#zip",T.identifier.id);const x=await this.collectFiles(T),R=await(0,m.zip)((0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)()).fsPath,x);return h.URI.file(R)}async unzip(T){return this.logService.trace("ExtensionManagementService#unzip",T.toString()),(await this.install(T)).identifier}async getManifest(T){const{location:x,cleanup:R}=await this.downloadVsix(T),L=p.resolve(x.fsPath);try{return await(0,o.getManifest)(L)}finally{await R()}}getInstalled(T,x){return this.extensionsScanner.scanExtensions(T??null,x)}getAllUserInstalled(){return this.extensionsScanner.scanUserExtensions(!1)}async install(T,x={}){this.logService.trace("ExtensionManagementService#install",T.toString());const{location:R,cleanup:L}=await this.downloadVsix(T);try{const U=await(0,o.getManifest)(p.resolve(R.fsPath));if(U.engines&&U.engines.vscode&&!(0,k.isEngineValid)(U.engines.vscode,this.productService.version,this.productService.date))throw new Error(y.localize(0,null,(0,s.getGalleryExtensionId)(U.publisher,U.name),this.productService.version));return await this.installExtension(U,R,x)}finally{await L()}}getMetadata(T){return this.extensionsScannerService.scanMetadata(T.location)}async updateMetadata(T,x){this.logService.trace("ExtensionManagementService#updateMetadata",T.identifier.id);const R={...x};return x.isPreReleaseVersion&&(R.preRelease=!0),T=await this.extensionsScanner.updateMetadata(T,R),this.manifestCache.invalidate(),T}async updateExtensionScope(T,x){return this.logService.trace("ExtensionManagementService#updateExtensionScope",T.identifier.id),T=await this.extensionsScanner.updateMetadata(T,{isMachineScoped:x}),this.manifestCache.invalidate(),T}removeUninstalledExtensions(T){return this.extensionsScanner.cleanUp(T)}async downloadVsix(T){if(T.scheme===A.Schemas.file)return{location:T,async cleanup(){}};this.logService.trace("Downloading extension from",T.toString());const x=(0,d.joinPath)(this.extensionsDownloader.extensionsDownloadDir,(0,v.generateUuid)());return await this.downloadService.download(T,x),this.logService.info("Downloaded extension to",x.toString()),{location:x,cleanup:async()=>{try{await this.fileService.del(x)}catch(L){this.logService.error(L)}}}}doCreateInstallExtensionTask(T,x,R){let L;if(h.URI.isUri(x))L=new M(T,x,R,this.galleryService,this.extensionsScanner,this.logService);else{const U=s.ExtensionKey.create(x).toString();L=this.installGalleryExtensionsTasks.get(U),L||(this.installGalleryExtensionsTasks.set(U,L=new B(T,x,R,this.extensionsDownloader,this.extensionsScanner,this.logService)),L.waitUntilTaskIsFinished().then(()=>this.installGalleryExtensionsTasks.delete(U)))}return R.profileLocation?new F(L,R.profileLocation,this.extensionsProfileScannerService):L}doCreateUninstallExtensionTask(T,x){return x.profileLocation?new q(T,x.profileLocation,this.extensionsProfileScannerService):new W(T,x,this.extensionsScanner)}async collectFiles(T){const x=async L=>{let U=await f.Promises.readdir(L);U=U.map(X=>p.join(L,X));const j=await Promise.all(U.map(X=>f.Promises.stat(X)));let H=Promise.resolve([]);return j.forEach((X,oe)=>{const le=U[oe];X.isFile()&&(H=H.then(pe=>[...pe,le])),X.isDirectory()&&(H=H.then(pe=>x(le).then(ve=>[...pe,...ve])))}),H};return(await x(T.location.fsPath)).map(L=>({path:`extension/${p.relative(T.location.fsPath,L)}`,localPath:L}))}};ge=fe([te(0,a.IExtensionGalleryService),te(1,ne.ITelemetryService),te(2,G.ILogService),te(3,u.INativeEnvironmentService),te(4,n.IExtensionsScannerService),te(5,i.IExtensionsProfileScannerService),te(6,l.IDownloadService),te(7,_.IInstantiationService),te(8,V.IFileService),te(9,Q.IProductService),te(10,ce.IUriIdentityService),te(11,re.IUserDataProfilesService)],ge),t.ExtensionManagementService=ge;let ae=class extends O.Disposable{constructor(T,x,R,L){super();this.beforeRemovingExtension=T,this.fileService=x,this.extensionsScannerService=R,this.logService=L,this.uninstalledPath=(0,d.joinPath)(this.extensionsScannerService.userExtensionsLocation,".obsolete").fsPath,this.uninstalledFileLimiter=new I.Queue}async cleanUp(T){await this.removeUninstalledExtensions(),T&&await this.removeOutdatedExtensions()}async scanExtensions(T,x){const R={includeInvalid:!0,profileLocation:x};let L=[];return T===null||T===0?L.push(...await this.extensionsScannerService.scanAllExtensions({includeInvalid:!0},R)):T===1&&L.push(...await this.extensionsScannerService.scanUserExtensions(R)),L=T!==null?L.filter(U=>U.type===T):L,Promise.all(L.map(U=>this.toLocalExtension(U)))}async scanUserExtensions(T){const x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!T,includeInvalid:!0});return Promise.all(x.map(R=>this.toLocalExtension(R)))}async extractUserExtension(T,x,R,L){const U=T.toString(),j=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,`.${(0,v.generateUuid)()}`),H=p.join(this.extensionsScannerService.userExtensionsLocation.fsPath,U);try{await f.Promises.rm(H)}catch{throw new a.ExtensionManagementError(y.localize(1,null,H,T.id),a.ExtensionManagementErrorCode.Delete)}await this.extractAtLocation(T,x,j,L),R={...R,installedTimestamp:Date.now()},await this.extensionsScannerService.updateMetadata(h.URI.file(j),R);try{await this.rename(T,j,H,Date.now()+2*60*1e3),this.logService.info("Renamed to",H)}catch(X){try{await f.Promises.rm(j)}catch{}if(X.code==="ENOTEMPTY")this.logService.info("Rename failed because extension was installed by another source. So ignoring renaming.",T.id);else throw this.logService.info(`Rename failed because of ${(0,w.getErrorMessage)(X)}. Deleted from extracted location`,j),X}return this.scanLocalExtension(h.URI.file(H),1)}async updateMetadata(T,x){return await this.extensionsScannerService.updateMetadata(T.location,x),this.scanLocalExtension(T.location,T.type)}getUninstalledExtensions(){return this.withUninstalledExtensions()}async setUninstalled(...T){const x=T.map(R=>s.ExtensionKey.create(R));await this.withUninstalledExtensions(R=>{x.forEach(L=>R[L.toString()]=!0)})}async setInstalled(T){await this.withUninstalledExtensions(L=>delete L[T.toString()]);const R=(await this.scanUserExtensions(!0)).find(L=>s.ExtensionKey.create(L).equals(T))||null;return R?this.updateMetadata(R,{installedTimestamp:Date.now()}):null}async removeExtension(T,x){this.logService.trace(`Deleting ${x} extension from disk`,T.identifier.id,T.location.fsPath),await f.Promises.rm(T.location.fsPath),this.logService.info("Deleted from disk",T.identifier.id,T.location.fsPath)}async removeUninstalledExtension(T){await this.removeExtension(T,"uninstalled"),await this.withUninstalledExtensions(x=>delete x[s.ExtensionKey.create(T).toString()])}async withUninstalledExtensions(T){return this.uninstalledFileLimiter.queue(async()=>{let x;try{x=await f.Promises.readFile(this.uninstalledPath,"utf8")}catch(L){if(L.code!=="ENOENT")throw L}let R={};if(x)try{R=JSON.parse(x)}catch{}return T&&(T(R),Object.keys(R).length?await f.Promises.writeFile(this.uninstalledPath,JSON.stringify(R)):await f.Promises.rm(this.uninstalledPath)),R})}async extractAtLocation(T,x,R,L){this.logService.trace(`Started extracting the extension from ${x} to ${R}`);try{await f.Promises.rm(R)}catch(U){throw new a.ExtensionManagementError(this.joinErrors(U).message,a.ExtensionManagementErrorCode.Delete)}try{await(0,m.extract)(x,R,{sourcePath:"extension",overwrite:!0},L),this.logService.info(`Extracted extension to ${R}:`,T.id)}catch(U){try{await f.Promises.rm(R)}catch{}let j=a.ExtensionManagementErrorCode.Extract;throw U instanceof m.ExtractError&&(U.type==="CorruptZip"?j=a.ExtensionManagementErrorCode.CorruptZip:U.type==="Incomplete"&&(j=a.ExtensionManagementErrorCode.IncompleteZip)),new a.ExtensionManagementError(U.message,j)}}async rename(T,x,R,L){try{await f.Promises.rename(x,R)}catch(U){if(c.isWindows&&U&&U.code==="EPERM"&&Date.now()<L)return this.logService.info(`Failed renaming ${x} to ${R} with 'EPERM' error. Trying again...`,T.id),this.rename(T,x,R,L);throw new a.ExtensionManagementError(U.message||y.localize(2,null,x,R),U.code||a.ExtensionManagementErrorCode.Rename)}}async scanLocalExtension(T,x){const R=await this.extensionsScannerService.scanExistingExtension(T,x,{includeInvalid:!0});if(R)return this.toLocalExtension(R);throw new Error(y.localize(3,null,T.path))}async toLocalExtension(T){const x=await this.fileService.resolve(T.location);let R,L;return x.children&&(R=x.children.find(({name:U})=>/^readme(\.txt|\.md|)$/i.test(U))?.resource,L=x.children.find(({name:U})=>/^changelog(\.txt|\.md|)$/i.test(U))?.resource),{identifier:T.identifier,type:T.type,isBuiltin:T.isBuiltin||!!T.metadata?.isBuiltin,location:T.location,manifest:T.manifest,targetPlatform:T.targetPlatform,validations:T.validations,isValid:T.isValid,readmeUrl:R,changelogUrl:L,publisherDisplayName:T.metadata?.publisherDisplayName||null,publisherId:T.metadata?.publisherId||null,isApplicationScoped:!!T.metadata?.isApplicationScoped,isMachineScoped:!!T.metadata?.isMachineScoped,isPreReleaseVersion:!!T.metadata?.isPreReleaseVersion,preRelease:!!T.metadata?.preRelease,installedTimestamp:T.metadata?.installedTimestamp,updated:!!T.metadata?.updated}}async removeUninstalledExtensions(){const T=await this.getUninstalledExtensions(),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=new Set;for(const j of x)T[s.ExtensionKey.create(j).toString()]||R.add(j.identifier.id.toLowerCase());const L=(0,s.groupByExtension)(x,j=>j.identifier);await I.Promises.settled(L.map(async j=>{const H=j.sort((X,oe)=>C.rcompare(X.manifest.version,oe.manifest.version))[0];R.has(H.identifier.id.toLowerCase())||await this.beforeRemovingExtension(await this.toLocalExtension(H))}));const U=x.filter(j=>T[s.ExtensionKey.create(j).toString()]);await I.Promises.settled(U.map(j=>this.removeUninstalledExtension(j)))}async removeOutdatedExtensions(){const T=await this.extensionsScannerService.scanSystemExtensions({}),x=await this.extensionsScannerService.scanUserExtensions({includeAllVersions:!0,includeUninstalled:!0,includeInvalid:!0}),R=[],L=await this.extensionsScannerService.getTargetPlatform(),U=(0,s.groupByExtension)(x,j=>j.identifier);for(const j of U)if(j.length>1&&R.push(...j.sort((H,X)=>{const oe=C.rcompare(H.manifest.version,X.manifest.version);return oe!==0?oe:H.targetPlatform===L?-1:1}).slice(1)),j[0].type===0){const H=T.find(X=>(0,s.areSameExtensions)(X.identifier,j[0].identifier));(!H||C.gte(H.manifest.version,j[0].manifest.version))&&R.push(j[0])}await I.Promises.settled(R.map(j=>this.removeExtension(j,"outdated")))}joinErrors(T){const x=Array.isArray(T)?T:[T];return x.length===1?x[0]instanceof Error?x[0]:new Error(x[0]):x.reduce((R,L)=>new Error(`${R.message}${R.message?",":""}${L instanceof Error?L.message:L}`),new Error(""))}};ae=fe([te(1,V.IFileService),te(2,n.IExtensionsScannerService),te(3,G.ILogService)],ae);class N extends g.AbstractExtensionTask{constructor(T,x,R,L,U){super();this.identifier=T,this.source=x,this.options=R,this.extensionsScanner=L,this.logService=U,this._operation=2}get operation(){return(0,P.isUndefined)(this.options.operation)?this._operation:this.options.operation}async installExtension(T,x){try{const R=await this.unsetUninstalledAndGetLocal(T.key);if(R)return T.metadata?this.extensionsScanner.updateMetadata(R,T.metadata):R}catch{throw c.isMacintosh?new a.ExtensionManagementError(y.localize(4,null),a.ExtensionManagementErrorCode.Internal):new a.ExtensionManagementError(y.localize(5,null),a.ExtensionManagementErrorCode.Internal)}return this.extract(T,x)}async unsetUninstalledAndGetLocal(T){if(!await this.isUninstalled(T))return null;this.logService.trace("Removing the extension from uninstalled list:",T.id);const R=await this.extensionsScanner.setInstalled(T);return this.logService.info("Removed the extension from uninstalled list:",T.id),R}async isUninstalled(T){return!!(await this.extensionsScanner.getUninstalledExtensions())[T.toString()]}async extract({zipPath:T,key:x,metadata:R},L){const U=await this.extensionsScanner.extractUserExtension(x,T,R,L);return this.logService.info("Extracting completed.",x.id),U}}class B extends N{constructor(T,x,R,L,U,j){super(x.identifier,x,R,U,j);this.manifest=T,this.gallery=x,this.extensionsDownloader=L}async doRun(T){const R=(await this.extensionsScanner.scanExtensions(null,void 0)).find(j=>(0,s.areSameExtensions)(j.identifier,this.gallery.identifier));R&&(this._operation=3);const L={id:this.gallery.identifier.uuid,publisherId:this.gallery.publisherId,publisherDisplayName:this.gallery.publisherDisplayName,targetPlatform:this.gallery.properties.targetPlatform,isApplicationScoped:(0,D.isApplicationScopedExtension)(this.manifest),isMachineScoped:this.options.isMachineScoped||R?.isMachineScoped,isBuiltin:this.options.isBuiltin||R?.isBuiltin,isSystem:R?.type===0?!0:void 0,updated:!!R,isPreReleaseVersion:this.gallery.properties.isPreReleaseVersion,preRelease:this.gallery.properties.isPreReleaseVersion||((0,P.isBoolean)(this.options.installPreReleaseVersion)?this.options.installPreReleaseVersion:R?.preRelease)};if(R?.manifest.version===this.gallery.version)return{local:await this.extensionsScanner.updateMetadata(R,L),metadata:L};const U=await this.downloadExtension(this.gallery,this._operation);try{const j=await this.installExtension({zipPath:U,key:s.ExtensionKey.create(this.gallery),metadata:L},T);return R&&!this.options.profileLocation&&(R.targetPlatform!==j.targetPlatform||C.neq(R.manifest.version,j.manifest.version))&&await this.extensionsScanner.setUninstalled(R),{local:j,metadata:L}}catch(j){throw await this.deleteDownloadedVSIX(U),j}}async deleteDownloadedVSIX(T){try{await this.extensionsDownloader.delete(h.URI.file(T))}catch(x){this.logService.warn("Error while deleting the downloaded vsix",T.toString(),(0,w.getErrorMessage)(x))}}async downloadExtension(T,x){let R;try{this.logService.trace("Started downloading extension:",T.identifier.id),R=(await this.extensionsDownloader.downloadExtension(T,x)).fsPath,this.logService.info("Downloaded extension:",T.identifier.id,R)}catch(L){throw new a.ExtensionManagementError((0,g.joinErrors)(L).message,a.ExtensionManagementErrorCode.Download)}try{return await(0,o.getManifest)(R),R}catch(L){throw await this.deleteDownloadedVSIX(R),new a.ExtensionManagementError((0,g.joinErrors)(L).message,a.ExtensionManagementErrorCode.Invalid)}}}class M extends N{constructor(T,x,R,L,U,j){super({id:(0,s.getGalleryExtensionId)(T.publisher,T.name)},x,R,U,j);this.manifest=T,this.location=x,this.galleryService=L}async doRun(T){const x=new s.ExtensionKey(this.identifier,this.manifest.version),L=(await this.extensionsScanner.scanExtensions(1,void 0)).find(H=>(0,s.areSameExtensions)(this.identifier,H.identifier)),U=await this.getMetadata(this.identifier.id,this.manifest.version,T);if(U.isApplicationScoped=(0,D.isApplicationScopedExtension)(this.manifest),U.isMachineScoped=this.options.isMachineScoped||L?.isMachineScoped,U.isBuiltin=this.options.isBuiltin||L?.isBuiltin,L)if(this._operation=3,x.equals(new s.ExtensionKey(L.identifier,L.manifest.version)))try{await this.extensionsScanner.removeExtension(L,"existing")}catch{throw new Error(y.localize(6,null,this.manifest.displayName||this.manifest.name))}else!this.options.profileLocation&&C.gt(L.manifest.version,this.manifest.version)&&await this.extensionsScanner.setUninstalled(L);else{const H=await this.unsetUninstalledAndGetLocal(x);if(H)try{await this.extensionsScanner.removeExtension(H,"existing")}catch{throw new Error(y.localize(7,null,this.manifest.displayName||this.manifest.name))}}return{local:await this.installExtension({zipPath:p.resolve(this.location.fsPath),key:x,metadata:U},T),metadata:U}}async getMetadata(T,x,R){try{let[L]=await this.galleryService.getExtensions([{id:T,version:x}],R);if(L||([L]=await this.galleryService.getExtensions([{id:T}],R)),L)return{id:L.identifier.uuid,publisherDisplayName:L.publisherDisplayName,publisherId:L.publisherId,isPreReleaseVersion:L.properties.isPreReleaseVersion,preRelease:L.properties.isPreReleaseVersion||this.options.installPreReleaseVersion}}catch{}return{}}}class F{constructor(T,x,R){this.task=T,this.profileLocation=x,this.extensionsProfileScannerService=R,this.identifier=this.task.identifier,this.source=this.task.source,this.operation=this.task.operation,this.promise=this.waitAndAddExtensionToProfile()}async waitAndAddExtensionToProfile(){const T=await this.task.waitUntilTaskIsFinished();return await this.extensionsProfileScannerService.addExtensionsToProfile([[T.local,T.metadata]],this.profileLocation),T}async run(){return await this.task.run(),this.promise}waitUntilTaskIsFinished(){return this.promise}cancel(){return this.task.cancel()}}class W extends g.AbstractExtensionTask{constructor(T,x,R){super();this.extension=T,this.options=x,this.extensionsScanner=R}async doRun(T){const x=[],R=await this.extensionsScanner.scanUserExtensions(!1);if(this.options.versionOnly){const L=s.ExtensionKey.create(this.extension);x.push(...R.filter(U=>L.equals(s.ExtensionKey.create(U))))}else x.push(...R.filter(L=>(0,s.areSameExtensions)(L.identifier,this.extension.identifier)));if(!x.length)throw new Error(y.localize(8,null,this.extension.manifest.displayName||this.extension.manifest.name));if(await this.extensionsScanner.setUninstalled(...x),this.options.remove)for(const L of x)try{T.isCancellationRequested||await this.extensionsScanner.removeUninstalledExtension(L)}catch(U){throw new Error(y.localize(9,null,(0,b.toErrorMessage)(U)))}}}class q extends g.AbstractExtensionTask{constructor(T,x,R){super();this.extension=T,this.profileLocation=x,this.extensionsProfileScannerService=R}async doRun(T){await this.extensionsProfileScannerService.removeExtensionFromProfile(this.extension.identifier,this.profileLocation)}}}),define(Z[146],ee([0,1,125,3,15,12,2,5,21,18,126,9,124,158]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.RequestService=void 0;let f=class extends A.Disposable{constructor(y,l,u){super();this.environmentService=l,this.logService=u,this.configure(y.getValue()),this._register(y.onDidChangeConfiguration(()=>this.configure(y.getValue()),this))}configure(y){this.proxyUrl=y.http&&y.http.proxy,this.strictSSL=!!(y.http&&y.http.proxyStrictSSL),this.authorization=y.http&&y.http.proxyAuthorization}async request(y,l){this.logService.trace("RequestService#request (node) - begin",y.url);const{proxyUrl:u,strictSSL:g}=this;let a;try{a=await(0,C.getResolvedShellEnv)(this.logService,this.environmentService.args,process.env)}catch(n){this.shellEnvErrorLogged||(this.shellEnvErrorLogged=!0,this.logService.error("RequestService#request (node) resolving shell environment failed",n))}const s={...process.env,...a},i=y.agent?y.agent:await(0,h.getProxyAgent)(y.url||"",s,{proxyUrl:u,strictSSL:g});y.agent=i,y.strictSSL=g,this.authorization&&(y.headers={...y.headers||{},"Proxy-Authorization":this.authorization});try{const n=await this._request(y,l);return this.logService.trace("RequestService#request (node) - success",y.url),n}catch(n){throw this.logService.trace("RequestService#request (node) - error",y.url,n),n}}async getNodeRequest(y){return((0,I.parse)(y.url).protocol==="https:"?await new Promise((g,a)=>{$(["https"],g,a)}):await new Promise((g,a)=>{$(["http"],g,a)})).request}_request(y,l){return b.Promises.withAsyncBody(async(u,g)=>{const a=(0,I.parse)(y.url),s=y.getRawRequest?y.getRawRequest(y):await this.getNodeRequest(y),i={hostname:a.hostname,port:a.port?parseInt(a.port):a.protocol==="https:"?443:80,protocol:a.protocol,path:a.path,method:y.type||"GET",headers:y.headers,agent:y.agent,rejectUnauthorized:(0,p.isBoolean)(y.strictSSL)?y.strictSSL:!0};y.user&&y.password&&(i.auth=y.user+":"+y.password);const n=s(i,e=>{const r=(0,p.isNumber)(y.followRedirects)?y.followRedirects:3;if(e.statusCode&&e.statusCode>=300&&e.statusCode<400&&r>0&&e.headers.location)this._request({...y,url:e.headers.location,followRedirects:r-1},l).then(u,g);else{let o=e;e.headers["content-encoding"]==="gzip"&&(o=e.pipe((0,v.createGunzip)())),u({res:e,stream:(0,w.streamToBufferReadableStream)(o)})}});n.on("error",g),y.timeout&&n.setTimeout(y.timeout),y.data&&typeof y.data=="string"&&n.write(y.data),n.end(),l.onCancellationRequested(()=>{n.abort(),g(new O.CancellationError)})})}async resolveProxy(y){}};f=fe([te(0,c.IConfigurationService),te(1,d.INativeEnvironmentService),te(2,P.ILogService)],f),t.RequestService=f}),define(Z[159],ee([0,1,38,3,15,30,12,2,16,14,13,32,10,20,21,117,58,123,18,100,141,22,119,41,48,145,139,11,109,111,46,107,61,62,122,9,113,114,37,143,131,27,47,146,65,127,66,35,130,42,132,133,28,135,25,142]),function($,t,I,b,w,O,A,p,c,d,C,P,h,v,f,m,y,l,u,g,a,s,i,n,e,r,o,S,E,D,k,V,_,G,Q,ne,ce,re,ge,ae,N,B,M,F,W,q,Y,T,x,R,L,U,j,H,X,oe){"use strict";Object.defineProperty(t,"__esModule",{value:!0}),t.main=void 0;class le extends p.Disposable{constructor(ie){super();this.argv=ie,this.registerListeners()}registerListeners(){process.once("exit",()=>this.dispose())}async run(){const[ie,se]=await this.initServices();return ie.invokeFunction(async he=>{const de=he.get(ne.ILogService),Se=he.get(S.IFileService),ke=he.get(u.INativeEnvironmentService),Fe=he.get(s.IExtensionManagementCLIService);de.info("CLI main",this.argv),this.registerErrorHandler(de),await this.doRun(ke,Fe,Se),await Promise.all(se.map(Ue=>{(0,b.raceTimeout)(Ue.flush(),1e3)}))})}async initServices(){const ie=new _.ServiceCollection,se={_serviceBrand:void 0,...N.default};ie.set(B.IProductService,se);const he=new g.NativeEnvironmentService(this.argv,se);ie.set(u.INativeEnvironmentService,he),await Promise.all([he.appSettingsHome.fsPath,he.extensionsPath].map(we=>we?v.Promises.mkdir(we,{recursive:!0}):void 0));const de=(0,ne.getLogLevel)(he),Se=[];Se.push(new ce.SpdLogLogger("cli",(0,d.join)(he.logsPath,"cli.log"),!0,!1,de)),de===ne.LogLevel.Trace&&Se.push(new ne.ConsoleLogger(de));const ke=this._register(new ne.MultiplexLogService(Se));ie.set(ne.ILogService,ke);const Fe=this._register(new E.FileService(ke));ie.set(S.IFileService,Fe);const Ue=this._register(new D.DiskFileSystemProvider(ke));Fe.registerProvider(c.Schemas.file,Ue);const xe=new q.StateService(he,ke,Fe);ie.set(W.IStateService,xe);const z=new H.UriIdentityService(Fe);ie.set(j.IUriIdentityService,z);const K=new oe.UserDataProfilesService(xe,z,he,Fe,ke);ie.set(X.IUserDataProfilesService,K);const J=C.isWindows&&se.win32RegValueName?this._register(new ae.NativePolicyService(se.win32RegValueName)):he.policyFile?this._register(new re.FilePolicyService(he.policyFile,Fe,ke)):new ge.NullPolicyService;ie.set(ge.IPolicyService,J);const ue=this._register(new m.ConfigurationService(K.defaultProfile.settingsResource,Fe,J,ke));ie.set(f.IConfigurationService,ue),await Promise.all([xe.init(),ue.initialize()]),K.setEnablement(!!ue.getValue(X.PROFILES_ENABLEMENT_CONFIG)),ie.set(j.IUriIdentityService,new H.UriIdentityService(Fe)),ie.set(M.IRequestService,new k.SyncDescriptor(F.RequestService)),ie.set(y.IDownloadService,new k.SyncDescriptor(l.DownloadService)),ie.set(n.IExtensionsProfileScannerService,new k.SyncDescriptor(n.ExtensionsProfileScannerService)),ie.set(e.IExtensionsScannerService,new k.SyncDescriptor(o.ExtensionsScannerService)),ie.set(r.INativeServerExtensionManagementService,new k.SyncDescriptor(r.ExtensionManagementService)),ie.set(s.IExtensionGalleryService,new k.SyncDescriptor(a.ExtensionGalleryServiceWithNoStorageService)),ie.set(s.IExtensionManagementCLIService,new k.SyncDescriptor(i.ExtensionManagementCLIService)),ie.set(G.ILanguagePackService,new k.SyncDescriptor(Q.NativeLanguagePackService));const me=[],Ce=(0,R.isInternalTelemetry)(se,ue);if((0,R.supportsTelemetry)(se,he)){se.aiConfig&&se.aiConfig.ariaKey&&me.push(new L.OneDataSystemAppender(Ce,"monacoworkbench",null,se.aiConfig.ariaKey));const{installSourcePath:we}=he,Te={appenders:me,sendErrorTelemetry:!1,commonProperties:(async()=>{let be;try{const De=await v.Promises.readFile(he.stateResource.fsPath);be=JSON.parse(De.toString())[T.machineIdKey]}catch(De){De.code!=="ENOENT"&&ke.error(De)}return(0,Y.resolveCommonProperties)(Fe,(0,I.release)(),(0,I.hostname)(),process.arch,se.commit,se.version,be,Ce,we)})(),piiPaths:(0,R.getPiiPathsFromEnvironment)(he)};ie.set(T.ITelemetryService,new k.SyncDescriptor(x.TelemetryService,[Te]))}else ie.set(T.ITelemetryService,R.NullTelemetryService);return[new V.InstantiationService(ie),me]}registerErrorHandler(ie){(0,A.setUnexpectedErrorHandler)(se=>{const he=(0,O.toErrorMessage)(se,!0);!he||ie.error(`[uncaught exception in CLI]: ${he}`)}),process.on("uncaughtException",se=>(0,A.onUnexpectedError)(se)),process.on("unhandledRejection",se=>(0,A.onUnexpectedError)(se))}async doRun(ie,se,he){if(this.argv["install-source"])return this.setInstallSource(ie,he,this.argv["install-source"]);if(this.argv["list-extensions"])return se.listExtensions(!!this.argv["show-versions"],this.argv.category);if(this.argv["install-extension"]||this.argv["install-builtin-extension"]){const de={isMachineScoped:!!this.argv["do-not-sync"],installPreReleaseVersion:!!this.argv["pre-release"]};return se.installExtensions(this.asExtensionIdOrVSIX(this.argv["install-extension"]||[]),this.argv["install-builtin-extension"]||[],de,!!this.argv.force)}else{if(this.argv["uninstall-extension"])return se.uninstallExtensions(this.asExtensionIdOrVSIX(this.argv["uninstall-extension"]),!!this.argv.force);if(this.argv["locate-extension"])return se.locateExtension(this.argv["locate-extension"]);this.argv.telemetry&&console.log(await(0,U.buildTelemetryMessage)(ie.appRoot,ie.extensionsPath))}}asExtensionIdOrVSIX(ie){return ie.map(se=>/\.vsix$/i.test(se)?h.URI.file((0,d.isAbsolute)(se)?se:(0,d.join)((0,P.cwd)(),se)):se)}async setInstallSource(ie,se,he){await se.writeFile(h.URI.file(ie.installSourcePath),w.VSBuffer.fromString(he.slice(0,30)))}}async function pe(ve){const ie=new le(ve);try{await ie.run()}finally{ie.dispose()}}t.main=pe})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/73fd3f11032e7b83c2ae011b5516e6ddd19e3db2/core/vs/code/node/cliProcessMain.js.map
