/*!--------------------------------------------------------
 * Copyright (C) Microsoft Corporation. All rights reserved.
 *--------------------------------------------------------*/(function(){var De=["exports","require","vs/base/common/uri","vs/platform/instantiation/common/instantiation","vs/base/common/event","vs/workbench/api/common/extHost.protocol","vs/workbench/api/common/extHostTypes","vs/base/common/lifecycle","vs/workbench/api/common/extHostTypeConverters","vs/base/common/strings","vs/base/common/types","vs/base/common/errors","vs/base/common/network","vs/base/common/async","vs/platform/log/common/log","vs/workbench/api/common/extHostRpcService","vs/base/common/arrays","vs/nls","vs/nls!vs/workbench/api/worker/extensionHostWorker","vs/base/common/path","vs/base/common/cancellation","vs/base/common/resources","vs/base/common/buffer","vs/base/common/platform","vs/workbench/services/extensions/common/extensions","vs/base/common/map","vs/base/common/objects","vs/platform/extensions/common/extensions","vs/workbench/api/common/extHostInitDataService","vs/base/common/severity","vs/platform/registry/common/platform","vs/workbench/api/common/extHostWorkspace","vs/workbench/api/common/extHostConfiguration","vs/workbench/api/common/extHostExtensionService","vs/base/common/glob","vs/workbench/api/common/extHostFileSystemInfo","vs/workbench/api/common/extHostCommands","vs/base/common/extpath","vs/platform/contextkey/common/contextkey","vs/platform/files/common/files","vs/workbench/services/extensions/common/proxyIdentifier","vs/workbench/services/search/common/search","vs/base/common/uuid","vs/base/common/errorMessage","vs/base/common/assert","vs/platform/workspace/common/workspace","vs/workbench/contrib/testing/common/testId","vs/workbench/contrib/testing/common/testTypes","vs/editor/common/core/range","vs/workbench/api/common/extHostDocumentsAndEditors","vs/workbench/api/common/extHostEditorTabs","vs/workbench/api/common/extHostFileSystemConsumer","vs/workbench/api/common/extHostTerminalService","vs/workbench/api/common/extHostWebview","vs/base/common/decorators","vs/base/common/marshalling","vs/platform/instantiation/common/extensions","vs/platform/configuration/common/configuration","vs/platform/instantiation/common/serviceCollection","vs/base/common/process","vs/platform/theme/common/themeService","vs/workbench/api/common/cache","vs/workbench/api/common/extHostTunnelService","vs/workbench/api/common/extHostUriTransformerService","vs/workbench/common/webview","vs/workbench/contrib/testing/common/testItemCollection","vs/editor/common/languages","vs/workbench/api/common/exHostSecretState","vs/workbench/api/common/extHostApiDeprecationService","vs/workbench/api/common/extHostStorage","vs/workbench/api/common/extHostStoragePaths","vs/base/common/performance","vs/base/common/collections","vs/base/common/idGenerator","vs/base/common/mime","vs/base/common/htmlContent","vs/base/common/labels","vs/editor/common/services/semanticTokensDto","vs/platform/instantiation/common/descriptors","vs/platform/extensionManagement/common/extensionManagement","vs/platform/markers/common/markers","vs/platform/opener/common/opener","vs/platform/jsonschemas/common/jsonContributionRegistry","vs/platform/configuration/common/configurationRegistry","vs/platform/remote/common/remoteAuthorityResolver","vs/platform/remote/common/remoteHosts","vs/workbench/api/common/extHostTelemetry","vs/workbench/api/common/extHostDocumentData","vs/workbench/contrib/notebook/common/notebookCommon","vs/workbench/api/common/extHostTestingPrivateApi","vs/workbench/services/editor/common/editorGroupsService","vs/workbench/api/common/extHostNotebookEditor","vs/workbench/api/common/extHostTestItem","vs/workbench/api/common/extHostTextEditor","vs/workbench/services/extensions/common/extensionHostProtocol","vs/workbench/api/common/extHostDecorations","vs/base/common/hash","vs/workbench/api/common/extHostWindow","vs/workbench/api/common/extHostOutput","vs/workbench/services/search/common/searchExtTypes","vs/workbench/api/common/extHostTask","vs/workbench/api/common/extHostVariableResolverService","vs/workbench/api/common/extHostDebugService","vs/workbench/api/common/extHostSearch","vs/base/common/json","vs/base/common/marked/marked","vs/base/common/numbers","vs/base/common/stream","vs/editor/common/core/textModelDefaults","vs/editor/common/languages/languageConfiguration","vs/nls!vs/base/common/date","vs/base/common/date","vs/nls!vs/base/common/errorMessage","vs/base/common/filters","vs/base/common/iconLabels","vs/base/common/codicons","vs/base/common/comparers","vs/base/common/uriIpc","vs/editor/common/languageSelector","vs/nls!vs/editor/common/config/editorOptions","vs/editor/common/config/editorOptions","vs/editor/common/core/wordHelper","vs/nls!vs/platform/configuration/common/configurationRegistry","vs/nls!vs/platform/extensionManagement/common/extensionManagement","vs/nls!vs/platform/extensions/common/extensionValidator","vs/nls!vs/platform/files/common/files","vs/nls!vs/platform/markers/common/markers","vs/nls!vs/platform/workspace/common/workspace","vs/nls!vs/workbench/api/common/extHostDiagnostics","vs/nls!vs/workbench/api/common/extHostExtensionService","vs/nls!vs/workbench/api/common/extHostProgress","vs/nls!vs/workbench/api/common/extHostStatusBar","vs/nls!vs/workbench/api/common/extHostTerminalService","vs/nls!vs/workbench/api/common/extHostTreeViews","vs/nls!vs/workbench/api/common/extHostWorkspace","vs/nls!vs/workbench/common/editor","vs/nls!vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/nls!vs/workbench/contrib/debug/common/debug","vs/nls!vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/nls!vs/workbench/contrib/tasks/common/tasks","vs/nls!vs/workbench/services/configurationResolver/common/variableResolver","vs/nls!vs/workbench/services/extensions/common/extensionsRegistry","vs/nls!vs/workbench/services/search/common/queryBuilder","vs/platform/editor/common/editor","vs/platform/extensions/common/extensionValidator","vs/platform/instantiation/common/graph","vs/platform/environment/common/environment","vs/platform/instantiation/common/instantiationService","vs/platform/notification/common/notification","vs/platform/product/common/productService","vs/platform/progress/common/progress","vs/platform/configuration/common/configurationModels","vs/platform/extensionManagement/common/extensionManagementUtil","vs/platform/terminal/common/terminalDataBuffering","vs/platform/theme/common/theme","vs/platform/tunnel/common/tunnel","vs/platform/workspace/common/virtualWorkspace","vs/workbench/api/common/extHostMemento","vs/workbench/api/common/extHostNotebookDocuments","vs/workbench/api/common/extHostSecrets","vs/workbench/api/common/extHostTheming","vs/workbench/api/common/extHostWebviewMessaging","vs/workbench/common/editor","vs/workbench/api/common/extHostCodeInsets","vs/workbench/contrib/debug/common/abstractDebugAdapter","vs/workbench/contrib/debug/common/debug","vs/workbench/contrib/debug/common/debugUtils","vs/base/common/iterator","vs/workbench/contrib/notebook/common/notebookExecutionService","vs/workbench/contrib/terminal/common/environmentVariableShared","vs/workbench/services/configurationResolver/common/variableResolver","vs/workbench/services/editor/common/editorService","vs/base/common/functional","vs/workbench/api/common/extHostDocumentSaveParticipant","vs/workbench/api/common/extHostNotebookDocument","vs/workbench/api/common/extHostNotebookEditors","vs/workbench/api/common/extHostProgress","vs/workbench/services/environment/common/environmentService","vs/workbench/services/extensions/common/extensionDescriptionRegistry","vs/workbench/api/common/extHostExtensionActivator","vs/workbench/api/common/extHostLogService","vs/workbench/services/extensions/common/extensionsApiProposals","vs/workbench/services/extensions/common/extensionsRegistry","vs/workbench/contrib/tasks/common/taskDefinitionRegistry","vs/workbench/contrib/tasks/common/tasks","vs/workbench/services/extensions/common/lazyPromise","vs/workbench/api/common/extHostAuthentication","vs/workbench/api/common/extHostBulkEdits","vs/workbench/api/common/extHostClipboard","vs/workbench/api/common/extHostApiCommands","vs/workbench/api/common/extHostComments","vs/workbench/api/common/extHostConsoleForwarder","vs/workbench/api/common/extHostDiagnostics","vs/workbench/api/common/extHostDialogs","vs/workbench/api/common/extHostDocumentContentProviders","vs/workbench/api/common/extHostDocuments","vs/base/common/lazy","vs/workbench/api/common/extHostFileSystem","vs/workbench/api/common/extHostFileSystemEventService","vs/workbench/api/common/extHostInteractive","vs/workbench/api/common/extHostLabelService","vs/workbench/api/common/extHostLanguageFeatures","vs/base/common/stopwatch","vs/workbench/api/common/extHostLanguages","vs/workbench/api/common/extHostLoggerService","vs/workbench/api/common/extHostMessageService","vs/workbench/api/common/extHostNotebook","vs/workbench/api/common/extHostNotebookKernels","vs/workbench/api/common/extHostNotebookRenderers","vs/workbench/api/common/extHostQuickOpen","vs/workbench/api/common/extHostSCM","vs/workbench/api/common/extHostStatusBar","vs/workbench/api/common/extHostTesting","vs/workbench/api/common/extHostTextEditors","vs/workbench/api/common/extHostTimeline","vs/workbench/api/common/extHostUriOpener","vs/workbench/api/common/extHostUrls","vs/workbench/api/common/extHostCustomEditors","vs/workbench/api/common/extHostWebviewPanels","vs/workbench/api/common/extHostWebviewView","vs/workbench/api/worker/extHostConsoleForwarder","vs/workbench/services/extensions/common/rpcProtocol","vs/workbench/services/extensions/worker/polyfillNestedWorker","vs/workbench/services/output/common/output","vs/workbench/services/remote/common/remoteAgentService","vs/workbench/services/path/common/pathService","vs/workbench/services/search/common/fileSearchManager","vs/workbench/services/search/common/queryBuilder","vs/workbench/services/extensions/common/workspaceContains","vs/workbench/api/common/extHostRequireInterceptor","vs/workbench/api/common/extensionHostMain","vs/workbench/services/search/common/textSearchManager","vs/workbench/api/common/extHost.common.services","vs/workbench/services/views/common/treeViewsService","vs/workbench/api/common/extHostTreeViews","vs/workbench/api/common/extHost.api.impl","vs/workbench/api/worker/extHostExtensionService","vs/workbench/api/worker/extHost.worker.services","vs/base/common/semver/semver","vs/editor/common/model/mirrorTextModel","vs/base/common/linkedList","vs/editor/common/core/position","vs/editor/common/languages/linkComputer","vs/editor/common/core/selection","vs/editor/common/model/textModelSearch","vs/editor/common/model","vs/workbench/api/worker/extensionHostWorker"],Ce=function(te){for(var e=[],o=0,p=te.length;o<p;o++)e[o]=De[te[o]];return e};define(De[72],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SetMap=e.diffMaps=e.diffSets=e.groupBy=void 0;function o(D,T){const E=Object.create(null);for(const P of D){const R=T(P);let y=E[R];y||(y=E[R]=[]),y.push(P)}return E}e.groupBy=o;function p(D,T){const E=[],P=[];for(const R of D)T.has(R)||E.push(R);for(const R of T)D.has(R)||P.push(R);return{removed:E,added:P}}e.diffSets=p;function b(D,T){const E=[],P=[];for(const[R,y]of D)T.has(R)||E.push(y);for(const[R,y]of T)D.has(R)||P.push(y);return{removed:E,added:P}}e.diffMaps=b;class L{constructor(){this.map=new Map}add(T,E){let P=this.map.get(T);P||(P=new Set,this.map.set(T,P)),P.add(E)}delete(T,E){const P=this.map.get(T);!P||(P.delete(E),P.size===0&&this.map.delete(T))}forEach(T,E){const P=this.map.get(T);!P||P.forEach(E)}}e.SetMap=L}),define(De[54],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.throttle=e.debounce=e.memoize=e.createDecorator=void 0;function o(D){return(T,E,P)=>{let R=null,y=null;if(typeof P.value=="function"?(R="value",y=P.value):typeof P.get=="function"&&(R="get",y=P.get),!y)throw new Error("not supported");P[R]=D(y,E)}}e.createDecorator=o;function p(D,T,E){let P=null,R=null;if(typeof E.value=="function"?(P="value",R=E.value,R.length!==0&&console.warn("Memoize should only be used in functions with zero parameters")):typeof E.get=="function"&&(P="get",R=E.get),!R)throw new Error("not supported");const y=`$memoize$${T}`;E[P]=function(...m){return this.hasOwnProperty(y)||Object.defineProperty(this,y,{configurable:!1,enumerable:!1,writable:!1,value:R.apply(this,m)}),this[y]}}e.memoize=p;function b(D,T,E){return o((P,R)=>{const y=`$debounce$${R}`,m=`$debounce$result$${R}`;return function(...I){this[m]||(this[m]=E?E():void 0),clearTimeout(this[y]),T&&(this[m]=T(this[m],...I),I=[this[m]]),this[y]=setTimeout(()=>{P.apply(this,I),this[m]=E?E():void 0},D)}})}e.debounce=b;function L(D,T,E){return o((P,R)=>{const y=`$throttle$timer$${R}`,m=`$throttle$result$${R}`,I=`$throttle$lastRun$${R}`,f=`$throttle$pending$${R}`;return function(...h){if(this[m]||(this[m]=E?E():void 0),(this[I]===null||this[I]===void 0)&&(this[I]=-Number.MAX_VALUE),T&&(this[m]=T(this[m],...h)),this[f])return;const d=this[I]+D;d<=Date.now()?(this[I]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0):(this[f]=!0,this[y]=setTimeout(()=>{this[f]=!1,this[I]=Date.now(),P.apply(this,[this[m]]),this[m]=E?E():void 0},d-Date.now()))}})}e.throttle=L}),define(De[73],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.defaultGenerator=e.IdGenerator=void 0;class o{constructor(b){this._prefix=b,this._lastId=0}nextId(){return this._prefix+ ++this._lastId}}e.IdGenerator=o,e.defaultGenerator=new o("id#")}),define(De[104],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getNodeType=e.stripComments=e.visit=e.findNodeAtOffset=e.contains=e.getNodeValue=e.getNodePath=e.findNodeAtLocation=e.parseTree=e.parse=e.getLocation=e.createScanner=e.ParseOptions=e.ParseErrorCode=e.SyntaxKind=e.ScanError=void 0;var o;(function(s){s[s.None=0]="None",s[s.UnexpectedEndOfComment=1]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=2]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=3]="UnexpectedEndOfNumber",s[s.InvalidUnicode=4]="InvalidUnicode",s[s.InvalidEscapeCharacter=5]="InvalidEscapeCharacter",s[s.InvalidCharacter=6]="InvalidCharacter"})(o=e.ScanError||(e.ScanError={}));var p;(function(s){s[s.OpenBraceToken=1]="OpenBraceToken",s[s.CloseBraceToken=2]="CloseBraceToken",s[s.OpenBracketToken=3]="OpenBracketToken",s[s.CloseBracketToken=4]="CloseBracketToken",s[s.CommaToken=5]="CommaToken",s[s.ColonToken=6]="ColonToken",s[s.NullKeyword=7]="NullKeyword",s[s.TrueKeyword=8]="TrueKeyword",s[s.FalseKeyword=9]="FalseKeyword",s[s.StringLiteral=10]="StringLiteral",s[s.NumericLiteral=11]="NumericLiteral",s[s.LineCommentTrivia=12]="LineCommentTrivia",s[s.BlockCommentTrivia=13]="BlockCommentTrivia",s[s.LineBreakTrivia=14]="LineBreakTrivia",s[s.Trivia=15]="Trivia",s[s.Unknown=16]="Unknown",s[s.EOF=17]="EOF"})(p=e.SyntaxKind||(e.SyntaxKind={}));var b;(function(s){s[s.InvalidSymbol=1]="InvalidSymbol",s[s.InvalidNumberFormat=2]="InvalidNumberFormat",s[s.PropertyNameExpected=3]="PropertyNameExpected",s[s.ValueExpected=4]="ValueExpected",s[s.ColonExpected=5]="ColonExpected",s[s.CommaExpected=6]="CommaExpected",s[s.CloseBraceExpected=7]="CloseBraceExpected",s[s.CloseBracketExpected=8]="CloseBracketExpected",s[s.EndOfFileExpected=9]="EndOfFileExpected",s[s.InvalidCommentToken=10]="InvalidCommentToken",s[s.UnexpectedEndOfComment=11]="UnexpectedEndOfComment",s[s.UnexpectedEndOfString=12]="UnexpectedEndOfString",s[s.UnexpectedEndOfNumber=13]="UnexpectedEndOfNumber",s[s.InvalidUnicode=14]="InvalidUnicode",s[s.InvalidEscapeCharacter=15]="InvalidEscapeCharacter",s[s.InvalidCharacter=16]="InvalidCharacter"})(b=e.ParseErrorCode||(e.ParseErrorCode={}));var L;(function(s){s.DEFAULT={allowTrailingComma:!0}})(L=e.ParseOptions||(e.ParseOptions={}));function D(s,u=!1){let n=0;const i=s.length;let r="",t=0,c=16,w=0;function g($){let N=0,K=0;for(;N<$;){const V=s.charCodeAt(n);if(V>=48&&V<=57)K=K*16+V-48;else if(V>=65&&V<=70)K=K*16+V-65+10;else if(V>=97&&V<=102)K=K*16+V-97+10;else break;n++,N++}return N<$&&(K=-1),K}function C($){n=$,r="",t=0,c=16,w=0}function U(){const $=n;if(s.charCodeAt(n)===48)n++;else for(n++;n<s.length&&P(s.charCodeAt(n));)n++;if(n<s.length&&s.charCodeAt(n)===46)if(n++,n<s.length&&P(s.charCodeAt(n)))for(n++;n<s.length&&P(s.charCodeAt(n));)n++;else return w=3,s.substring($,n);let N=n;if(n<s.length&&(s.charCodeAt(n)===69||s.charCodeAt(n)===101))if(n++,(n<s.length&&s.charCodeAt(n)===43||s.charCodeAt(n)===45)&&n++,n<s.length&&P(s.charCodeAt(n))){for(n++;n<s.length&&P(s.charCodeAt(n));)n++;N=n}else w=3;return s.substring($,N)}function W(){let $="",N=n;for(;;){if(n>=i){$+=s.substring(N,n),w=2;break}const K=s.charCodeAt(n);if(K===34){$+=s.substring(N,n),n++;break}if(K===92){if($+=s.substring(N,n),n++,n>=i){w=2;break}switch(s.charCodeAt(n++)){case 34:$+='"';break;case 92:$+="\\";break;case 47:$+="/";break;case 98:$+="\b";break;case 102:$+="\f";break;case 110:$+=`
`;break;case 114:$+="\r";break;case 116:$+="	";break;case 117:{const F=g(4);F>=0?$+=String.fromCharCode(F):w=4;break}default:w=5}N=n;continue}if(K>=0&&K<=31)if(E(K)){$+=s.substring(N,n),w=2;break}else w=6;n++}return $}function M(){if(r="",w=0,t=n,n>=i)return t=i,c=17;let $=s.charCodeAt(n);if(T($)){do n++,r+=String.fromCharCode($),$=s.charCodeAt(n);while(T($));return c=15}if(E($))return n++,r+=String.fromCharCode($),$===13&&s.charCodeAt(n)===10&&(n++,r+=`
`),c=14;switch($){case 123:return n++,c=1;case 125:return n++,c=2;case 91:return n++,c=3;case 93:return n++,c=4;case 58:return n++,c=6;case 44:return n++,c=5;case 34:return n++,r=W(),c=10;case 47:{const N=n-1;if(s.charCodeAt(n+1)===47){for(n+=2;n<i&&!E(s.charCodeAt(n));)n++;return r=s.substring(N,n),c=12}if(s.charCodeAt(n+1)===42){n+=2;const K=i-1;let V=!1;for(;n<K;){if(s.charCodeAt(n)===42&&s.charCodeAt(n+1)===47){n+=2,V=!0;break}n++}return V||(n++,w=1),r=s.substring(N,n),c=13}return r+=String.fromCharCode($),n++,c=16}case 45:if(r+=String.fromCharCode($),n++,n===i||!P(s.charCodeAt(n)))return c=16;case 48:case 49:case 50:case 51:case 52:case 53:case 54:case 55:case 56:case 57:return r+=U(),c=11;default:for(;n<i&&S($);)n++,$=s.charCodeAt(n);if(t!==n){switch(r=s.substring(t,n),r){case"true":return c=8;case"false":return c=9;case"null":return c=7}return c=16}return r+=String.fromCharCode($),n++,c=16}}function S($){if(T($)||E($))return!1;switch($){case 125:case 93:case 123:case 91:case 34:case 58:case 44:case 47:return!1}return!0}function z(){let $;do $=M();while($>=12&&$<=15);return $}return{setPosition:C,getPosition:()=>n,scan:u?z:M,getToken:()=>c,getTokenValue:()=>r,getTokenOffset:()=>t,getTokenLength:()=>n-t,getTokenError:()=>w}}e.createScanner=D;function T(s){return s===32||s===9||s===11||s===12||s===160||s===5760||s>=8192&&s<=8203||s===8239||s===8287||s===12288||s===65279}function E(s){return s===10||s===13||s===8232||s===8233}function P(s){return s>=48&&s<=57}var R;(function(s){s[s.nullCharacter=0]="nullCharacter",s[s.maxAsciiCharacter=127]="maxAsciiCharacter",s[s.lineFeed=10]="lineFeed",s[s.carriageReturn=13]="carriageReturn",s[s.lineSeparator=8232]="lineSeparator",s[s.paragraphSeparator=8233]="paragraphSeparator",s[s.nextLine=133]="nextLine",s[s.space=32]="space",s[s.nonBreakingSpace=160]="nonBreakingSpace",s[s.enQuad=8192]="enQuad",s[s.emQuad=8193]="emQuad",s[s.enSpace=8194]="enSpace",s[s.emSpace=8195]="emSpace",s[s.threePerEmSpace=8196]="threePerEmSpace",s[s.fourPerEmSpace=8197]="fourPerEmSpace",s[s.sixPerEmSpace=8198]="sixPerEmSpace",s[s.figureSpace=8199]="figureSpace",s[s.punctuationSpace=8200]="punctuationSpace",s[s.thinSpace=8201]="thinSpace",s[s.hairSpace=8202]="hairSpace",s[s.zeroWidthSpace=8203]="zeroWidthSpace",s[s.narrowNoBreakSpace=8239]="narrowNoBreakSpace",s[s.ideographicSpace=12288]="ideographicSpace",s[s.mathematicalSpace=8287]="mathematicalSpace",s[s.ogham=5760]="ogham",s[s._=95]="_",s[s.$=36]="$",s[s._0=48]="_0",s[s._1=49]="_1",s[s._2=50]="_2",s[s._3=51]="_3",s[s._4=52]="_4",s[s._5=53]="_5",s[s._6=54]="_6",s[s._7=55]="_7",s[s._8=56]="_8",s[s._9=57]="_9",s[s.a=97]="a",s[s.b=98]="b",s[s.c=99]="c",s[s.d=100]="d",s[s.e=101]="e",s[s.f=102]="f",s[s.g=103]="g",s[s.h=104]="h",s[s.i=105]="i",s[s.j=106]="j",s[s.k=107]="k",s[s.l=108]="l",s[s.m=109]="m",s[s.n=110]="n",s[s.o=111]="o",s[s.p=112]="p",s[s.q=113]="q",s[s.r=114]="r",s[s.s=115]="s",s[s.t=116]="t",s[s.u=117]="u",s[s.v=118]="v",s[s.w=119]="w",s[s.x=120]="x",s[s.y=121]="y",s[s.z=122]="z",s[s.A=65]="A",s[s.B=66]="B",s[s.C=67]="C",s[s.D=68]="D",s[s.E=69]="E",s[s.F=70]="F",s[s.G=71]="G",s[s.H=72]="H",s[s.I=73]="I",s[s.J=74]="J",s[s.K=75]="K",s[s.L=76]="L",s[s.M=77]="M",s[s.N=78]="N",s[s.O=79]="O",s[s.P=80]="P",s[s.Q=81]="Q",s[s.R=82]="R",s[s.S=83]="S",s[s.T=84]="T",s[s.U=85]="U",s[s.V=86]="V",s[s.W=87]="W",s[s.X=88]="X",s[s.Y=89]="Y",s[s.Z=90]="Z",s[s.ampersand=38]="ampersand",s[s.asterisk=42]="asterisk",s[s.at=64]="at",s[s.backslash=92]="backslash",s[s.bar=124]="bar",s[s.caret=94]="caret",s[s.closeBrace=125]="closeBrace",s[s.closeBracket=93]="closeBracket",s[s.closeParen=41]="closeParen",s[s.colon=58]="colon",s[s.comma=44]="comma",s[s.dot=46]="dot",s[s.doubleQuote=34]="doubleQuote",s[s.equals=61]="equals",s[s.exclamation=33]="exclamation",s[s.greaterThan=62]="greaterThan",s[s.lessThan=60]="lessThan",s[s.minus=45]="minus",s[s.openBrace=123]="openBrace",s[s.openBracket=91]="openBracket",s[s.openParen=40]="openParen",s[s.percent=37]="percent",s[s.plus=43]="plus",s[s.question=63]="question",s[s.semicolon=59]="semicolon",s[s.singleQuote=39]="singleQuote",s[s.slash=47]="slash",s[s.tilde=126]="tilde",s[s.backspace=8]="backspace",s[s.formFeed=12]="formFeed",s[s.byteOrderMark=65279]="byteOrderMark",s[s.tab=9]="tab",s[s.verticalTab=11]="verticalTab"})(R||(R={}));function y(s,u){const n=[],i=new Object;let r;const t={value:{},offset:0,length:0,type:"object",parent:void 0};let c=!1;function w(g,C,U,W){t.value=g,t.offset=C,t.length=U,t.type=W,t.colonOffset=void 0,r=t}try{A(s,{onObjectBegin:(g,C)=>{if(u<=g)throw i;r=void 0,c=u>g,n.push("")},onObjectProperty:(g,C,U)=>{if(u<C||(w(g,C,U,"property"),n[n.length-1]=g,u<=C+U))throw i},onObjectEnd:(g,C)=>{if(u<=g)throw i;r=void 0,n.pop()},onArrayBegin:(g,C)=>{if(u<=g)throw i;r=void 0,n.push(0)},onArrayEnd:(g,C)=>{if(u<=g)throw i;r=void 0,n.pop()},onLiteralValue:(g,C,U)=>{if(u<C||(w(g,C,U,_(g)),u<=C+U))throw i},onSeparator:(g,C,U)=>{if(u<=C)throw i;if(g===":"&&r&&r.type==="property")r.colonOffset=C,c=!1,r=void 0;else if(g===","){const W=n[n.length-1];typeof W=="number"?n[n.length-1]=W+1:(c=!0,n[n.length-1]=""),r=void 0}}})}catch(g){if(g!==i)throw g}return{path:n,previousNode:r,isAtPropertyKey:c,matches:g=>{let C=0;for(let U=0;C<g.length&&U<n.length;U++)if(g[C]===n[U]||g[C]==="*")C++;else if(g[C]!=="**")return!1;return C===g.length}}}e.getLocation=y;function m(s,u=[],n=L.DEFAULT){let i=null,r=[];const t=[];function c(g){Array.isArray(r)?r.push(g):i!==null&&(r[i]=g)}return A(s,{onObjectBegin:()=>{const g={};c(g),t.push(r),r=g,i=null},onObjectProperty:g=>{i=g},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const g=[];c(g),t.push(r),r=g,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:c,onError:(g,C,U)=>{u.push({error:g,offset:C,length:U})}},n),r[0]}e.parse=m;function I(s,u=[],n=L.DEFAULT){let i={type:"array",offset:-1,length:-1,children:[],parent:void 0};function r(g){i.type==="property"&&(i.length=g-i.offset,i=i.parent)}function t(g){return i.children.push(g),g}A(s,{onObjectBegin:g=>{i=t({type:"object",offset:g,length:-1,parent:i,children:[]})},onObjectProperty:(g,C,U)=>{i=t({type:"property",offset:C,length:-1,parent:i,children:[]}),i.children.push({type:"string",value:g,offset:C,length:U,parent:i})},onObjectEnd:(g,C)=>{i.length=g+C-i.offset,i=i.parent,r(g+C)},onArrayBegin:(g,C)=>{i=t({type:"array",offset:g,length:-1,parent:i,children:[]})},onArrayEnd:(g,C)=>{i.length=g+C-i.offset,i=i.parent,r(g+C)},onLiteralValue:(g,C,U)=>{t({type:_(g),offset:C,length:U,parent:i,value:g}),r(C+U)},onSeparator:(g,C,U)=>{i.type==="property"&&(g===":"?i.colonOffset=C:g===","&&r(C))},onError:(g,C,U)=>{u.push({error:g,offset:C,length:U})}},n);const w=i.children[0];return w&&delete w.parent,w}e.parseTree=I;function f(s,u){if(!s)return;let n=s;for(const i of u)if(typeof i=="string"){if(n.type!=="object"||!Array.isArray(n.children))return;let r=!1;for(const t of n.children)if(Array.isArray(t.children)&&t.children[0].value===i){n=t.children[1],r=!0;break}if(!r)return}else{const r=i;if(n.type!=="array"||r<0||!Array.isArray(n.children)||r>=n.children.length)return;n=n.children[r]}return n}e.findNodeAtLocation=f;function h(s){if(!s.parent||!s.parent.children)return[];const u=h(s.parent);if(s.parent.type==="property"){const n=s.parent.children[0].value;u.push(n)}else if(s.parent.type==="array"){const n=s.parent.children.indexOf(s);n!==-1&&u.push(n)}return u}e.getNodePath=h;function d(s){switch(s.type){case"array":return s.children.map(d);case"object":{const u=Object.create(null);for(const n of s.children){const i=n.children[1];i&&(u[n.children[0].value]=d(i))}return u}case"null":case"string":case"number":case"boolean":return s.value;default:return}}e.getNodeValue=d;function a(s,u,n=!1){return u>=s.offset&&u<s.offset+s.length||n&&u===s.offset+s.length}e.contains=a;function v(s,u,n=!1){if(a(s,u,n)){const i=s.children;if(Array.isArray(i))for(let r=0;r<i.length&&i[r].offset<=u;r++){const t=v(i[r],u,n);if(t)return t}return s}}e.findNodeAtOffset=v;function A(s,u,n=L.DEFAULT){const i=D(s,!1);function r(Ee){return Ee?()=>Ee(i.getTokenOffset(),i.getTokenLength()):()=>!0}function t(Ee){return Ee?be=>Ee(be,i.getTokenOffset(),i.getTokenLength()):()=>!0}const c=r(u.onObjectBegin),w=t(u.onObjectProperty),g=r(u.onObjectEnd),C=r(u.onArrayBegin),U=r(u.onArrayEnd),W=t(u.onLiteralValue),M=t(u.onSeparator),S=r(u.onComment),z=t(u.onError),$=n&&n.disallowComments,N=n&&n.allowTrailingComma;function K(){for(;;){const Ee=i.scan();switch(i.getTokenError()){case 4:V(14);break;case 5:V(15);break;case 3:V(13);break;case 1:$||V(11);break;case 2:V(12);break;case 6:V(16);break}switch(Ee){case 12:case 13:$?V(10):S();break;case 16:V(1);break;case 15:case 14:break;default:return Ee}}}function V(Ee,be=[],ee=[]){if(z(Ee),be.length+ee.length>0){let ve=i.getToken();for(;ve!==17;){if(be.indexOf(ve)!==-1){K();break}else if(ee.indexOf(ve)!==-1)break;ve=K()}}}function F(Ee){const be=i.getTokenValue();return Ee?W(be):w(be),K(),!0}function ne(){switch(i.getToken()){case 11:{let Ee=0;try{Ee=JSON.parse(i.getTokenValue()),typeof Ee!="number"&&(V(2),Ee=0)}catch{V(2)}W(Ee);break}case 7:W(null);break;case 8:W(!0);break;case 9:W(!1);break;default:return!1}return K(),!0}function ce(){return i.getToken()!==10?(V(3,[],[2,5]),!1):(F(!1),i.getToken()===6?(M(":"),K(),ie()||V(4,[],[2,5])):V(5,[],[2,5]),!0)}function re(){c(),K();let Ee=!1;for(;i.getToken()!==2&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||V(4,[],[]),M(","),K(),i.getToken()===2&&N)break}else Ee&&V(6,[],[]);ce()||V(4,[],[2,5]),Ee=!0}return g(),i.getToken()!==2?V(7,[2],[]):K(),!0}function fe(){C(),K();let Ee=!1;for(;i.getToken()!==4&&i.getToken()!==17;){if(i.getToken()===5){if(Ee||V(4,[],[]),M(","),K(),i.getToken()===4&&N)break}else Ee&&V(6,[],[]);ie()||V(4,[],[4,5]),Ee=!0}return U(),i.getToken()!==4?V(8,[4],[]):K(),!0}function ie(){switch(i.getToken()){case 3:return fe();case 1:return re();case 10:return F(!0);default:return ne()}}return K(),i.getToken()===17?n.allowEmptyContent?!0:(V(4,[],[]),!1):ie()?(i.getToken()!==17&&V(9,[],[]),!0):(V(4,[],[]),!1)}e.visit=A;function l(s,u){const n=D(s),i=[];let r,t=0,c;do switch(c=n.getPosition(),r=n.scan(),r){case 12:case 13:case 17:t!==c&&i.push(s.substring(t,c)),u!==void 0&&i.push(n.getTokenValue().replace(/[^\r\n]/g,u)),t=n.getPosition();break}while(r!==17);return i.join("")}e.stripComments=l;function _(s){switch(typeof s){case"boolean":return"boolean";case"number":return"number";case"string":return"string";case"object":{if(s){if(Array.isArray(s))return"array"}else return"null";return"object"}default:return"null"}}e.getNodeType=_}),function(te,e){typeof exports=="object"&&typeof module!="undefined"?e(exports):typeof define=="function"&&define.amd?define(De[105],Ce([0]),e):(te=typeof globalThis!="undefined"?globalThis:te||self,e(te.marked={}))}(this,function(te){"use strict";function e(Ie,Se){for(var Te=0;Te<Se.length;Te++){var ae=Se[Te];ae.enumerable=ae.enumerable||!1,ae.configurable=!0,"value"in ae&&(ae.writable=!0),Object.defineProperty(Ie,ae.key,ae)}}function o(Ie,Se,Te){return Se&&e(Ie.prototype,Se),Te&&e(Ie,Te),Object.defineProperty(Ie,"prototype",{writable:!1}),Ie}function p(Ie,Se){if(!!Ie){if(typeof Ie=="string")return b(Ie,Se);var Te=Object.prototype.toString.call(Ie).slice(8,-1);if(Te==="Object"&&Ie.constructor&&(Te=Ie.constructor.name),Te==="Map"||Te==="Set")return Array.from(Ie);if(Te==="Arguments"||/^(?:Ui|I)nt(?:8|16|32)(?:Clamped)?Array$/.test(Te))return b(Ie,Se)}}function b(Ie,Se){(Se==null||Se>Ie.length)&&(Se=Ie.length);for(var Te=0,ae=new Array(Se);Te<Se;Te++)ae[Te]=Ie[Te];return ae}function L(Ie,Se){var Te=typeof Symbol!="undefined"&&Ie[Symbol.iterator]||Ie["@@iterator"];if(Te)return(Te=Te.call(Ie)).next.bind(Te);if(Array.isArray(Ie)||(Te=p(Ie))||Se&&Ie&&typeof Ie.length=="number"){Te&&(Ie=Te);var ae=0;return function(){return ae>=Ie.length?{done:!0}:{done:!1,value:Ie[ae++]}}}throw new TypeError(`Invalid attempt to iterate non-iterable instance.
In order to be iterable, non-array objects must have a [Symbol.iterator]() method.`)}function D(){return{baseUrl:null,breaks:!1,extensions:null,gfm:!0,headerIds:!0,headerPrefix:"",highlight:null,langPrefix:"language-",mangle:!0,pedantic:!1,renderer:null,sanitize:!1,sanitizer:null,silent:!1,smartLists:!1,smartypants:!1,tokenizer:null,walkTokens:null,xhtml:!1}}te.defaults=D();function T(Ie){te.defaults=Ie}var E=/[&<>"']/,P=/[&<>"']/g,R=/[<>"']|&(?!#?\w+;)/,y=/[<>"']|&(?!#?\w+;)/g,m={"&":"&amp;","<":"&lt;",">":"&gt;",'"':"&quot;","'":"&#39;"},I=function(Se){return m[Se]};function f(Ie,Se){if(Se){if(E.test(Ie))return Ie.replace(P,I)}else if(R.test(Ie))return Ie.replace(y,I);return Ie}var h=/&(#(?:\d+)|(?:#x[0-9A-Fa-f]+)|(?:\w+));?/ig;function d(Ie){return Ie.replace(h,function(Se,Te){return Te=Te.toLowerCase(),Te==="colon"?":":Te.charAt(0)==="#"?Te.charAt(1)==="x"?String.fromCharCode(parseInt(Te.substring(2),16)):String.fromCharCode(+Te.substring(1)):""})}var a=/(^|[^\[])\^/g;function v(Ie,Se){Ie=typeof Ie=="string"?Ie:Ie.source,Se=Se||"";var Te={replace:function(le,X){return X=X.source||X,X=X.replace(a,"$1"),Ie=Ie.replace(le,X),Te},getRegex:function(){return new RegExp(Ie,Se)}};return Te}var A=/[^\w:]/g,l=/^$|^[a-z][a-z0-9+.-]*:|^[?#]/i;function _(Ie,Se,Te){if(Ie){var ae;try{ae=decodeURIComponent(d(Te)).replace(A,"").toLowerCase()}catch{return null}if(ae.indexOf("javascript:")===0||ae.indexOf("vbscript:")===0||ae.indexOf("data:")===0)return null}Se&&!l.test(Te)&&(Te=r(Se,Te));try{Te=encodeURI(Te).replace(/%25/g,"%")}catch{return null}return Te}var s={},u=/^[^:]+:\/*[^/]*$/,n=/^([^:]+:)[\s\S]*$/,i=/^([^:]+:\/*[^/]*)[\s\S]*$/;function r(Ie,Se){s[" "+Ie]||(u.test(Ie)?s[" "+Ie]=Ie+"/":s[" "+Ie]=g(Ie,"/",!0)),Ie=s[" "+Ie];var Te=Ie.indexOf(":")===-1;return Se.substring(0,2)==="//"?Te?Se:Ie.replace(n,"$1")+Se:Se.charAt(0)==="/"?Te?Se:Ie.replace(i,"$1")+Se:Ie+Se}var t={exec:function(){}};function c(Ie){for(var Se=1,Te,ae;Se<arguments.length;Se++){Te=arguments[Se];for(ae in Te)Object.prototype.hasOwnProperty.call(Te,ae)&&(Ie[ae]=Te[ae])}return Ie}function w(Ie,Se){var Te=Ie.replace(/\|/g,function(X,Y,k){for(var B=!1,H=Y;--H>=0&&k[H]==="\\";)B=!B;return B?"|":" |"}),ae=Te.split(/ \|/),le=0;if(ae[0].trim()||ae.shift(),ae.length>0&&!ae[ae.length-1].trim()&&ae.pop(),ae.length>Se)ae.splice(Se);else for(;ae.length<Se;)ae.push("");for(;le<ae.length;le++)ae[le]=ae[le].trim().replace(/\\\|/g,"|");return ae}function g(Ie,Se,Te){var ae=Ie.length;if(ae===0)return"";for(var le=0;le<ae;){var X=Ie.charAt(ae-le-1);if(X===Se&&!Te)le++;else if(X!==Se&&Te)le++;else break}return Ie.slice(0,ae-le)}function C(Ie,Se){if(Ie.indexOf(Se[1])===-1)return-1;for(var Te=Ie.length,ae=0,le=0;le<Te;le++)if(Ie[le]==="\\")le++;else if(Ie[le]===Se[0])ae++;else if(Ie[le]===Se[1]&&(ae--,ae<0))return le;return-1}function U(Ie){Ie&&Ie.sanitize&&!Ie.silent&&console.warn("marked(): sanitize and sanitizer parameters are deprecated since version 0.7.0, should not be used and will be removed in the future. Read more here: https://marked.js.org/#/USING_ADVANCED.md#options")}function W(Ie,Se){if(Se<1)return"";for(var Te="";Se>1;)Se&1&&(Te+=Ie),Se>>=1,Ie+=Ie;return Te+Ie}function M(Ie,Se,Te,ae){var le=Se.href,X=Se.title?f(Se.title):null,Y=Ie[1].replace(/\\([\[\]])/g,"$1");if(Ie[0].charAt(0)!=="!"){ae.state.inLink=!0;var k={type:"link",raw:Te,href:le,title:X,text:Y,tokens:ae.inlineTokens(Y,[])};return ae.state.inLink=!1,k}return{type:"image",raw:Te,href:le,title:X,text:f(Y)}}function S(Ie,Se){var Te=Ie.match(/^(\s+)(?:```)/);if(Te===null)return Se;var ae=Te[1];return Se.split(`
`).map(function(le){var X=le.match(/^\s+/);if(X===null)return le;var Y=X[0];return Y.length>=ae.length?le.slice(ae.length):le}).join(`
`)}var z=function(){function Ie(Te){this.options=Te||te.defaults}var Se=Ie.prototype;return Se.space=function(ae){var le=this.rules.block.newline.exec(ae);if(le&&le[0].length>0)return{type:"space",raw:le[0]}},Se.code=function(ae){var le=this.rules.block.code.exec(ae);if(le){var X=le[0].replace(/^ {1,4}/gm,"");return{type:"code",raw:le[0],codeBlockStyle:"indented",text:this.options.pedantic?X:g(X,`
`)}}},Se.fences=function(ae){var le=this.rules.block.fences.exec(ae);if(le){var X=le[0],Y=S(X,le[3]||"");return{type:"code",raw:X,lang:le[2]?le[2].trim():le[2],text:Y}}},Se.heading=function(ae){var le=this.rules.block.heading.exec(ae);if(le){var X=le[2].trim();if(/#$/.test(X)){var Y=g(X,"#");(this.options.pedantic||!Y||/ $/.test(Y))&&(X=Y.trim())}var k={type:"heading",raw:le[0],depth:le[1].length,text:X,tokens:[]};return this.lexer.inline(k.text,k.tokens),k}},Se.hr=function(ae){var le=this.rules.block.hr.exec(ae);if(le)return{type:"hr",raw:le[0]}},Se.blockquote=function(ae){var le=this.rules.block.blockquote.exec(ae);if(le){var X=le[0].replace(/^ *>[ \t]?/gm,"");return{type:"blockquote",raw:le[0],tokens:this.lexer.blockTokens(X,[]),text:X}}},Se.list=function(ae){var le=this.rules.block.list.exec(ae);if(le){var X,Y,k,B,H,j,oe,ue,Z,pe,ge,Ne,Be=le[1].trim(),Ze=Be.length>1,Ge={type:"list",raw:"",ordered:Ze,start:Ze?+Be.slice(0,-1):"",loose:!1,items:[]};Be=Ze?"\\d{1,9}\\"+Be.slice(-1):"\\"+Be,this.options.pedantic&&(Be=Ze?Be:"[*+-]");for(var ke=new RegExp("^( {0,3}"+Be+")((?:[	 ][^\\n]*)?(?:\\n|$))");ae&&(Ne=!1,!(!(le=ke.exec(ae))||this.rules.block.hr.test(ae)));){if(X=le[0],ae=ae.substring(X.length),ue=le[2].split(`
`,1)[0],Z=ae.split(`
`,1)[0],this.options.pedantic?(B=2,ge=ue.trimLeft()):(B=le[2].search(/[^ ]/),B=B>4?1:B,ge=ue.slice(B),B+=le[1].length),j=!1,!ue&&/^ *$/.test(Z)&&(X+=Z+`
`,ae=ae.substring(Z.length+1),Ne=!0),!Ne)for(var nt=new RegExp("^ {0,"+Math.min(3,B-1)+"}(?:[*+-]|\\d{1,9}[.)])((?: [^\\n]*)?(?:\\n|$))"),G=new RegExp("^ {0,"+Math.min(3,B-1)+"}((?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$)");ae&&(pe=ae.split(`
`,1)[0],ue=pe,this.options.pedantic&&(ue=ue.replace(/^ {1,4}(?=( {4})*[^ ])/g,"  ")),!(nt.test(ue)||G.test(ae)));){if(ue.search(/[^ ]/)>=B||!ue.trim())ge+=`
`+ue.slice(B);else if(!j)ge+=`
`+ue;else break;!j&&!ue.trim()&&(j=!0),X+=pe+`
`,ae=ae.substring(pe.length+1)}Ge.loose||(oe?Ge.loose=!0:/\n *\n *$/.test(X)&&(oe=!0)),this.options.gfm&&(Y=/^\[[ xX]\] /.exec(ge),Y&&(k=Y[0]!=="[ ] ",ge=ge.replace(/^\[[ xX]\] +/,""))),Ge.items.push({type:"list_item",raw:X,task:!!Y,checked:k,loose:!1,text:ge}),Ge.raw+=X}Ge.items[Ge.items.length-1].raw=X.trimRight(),Ge.items[Ge.items.length-1].text=ge.trimRight(),Ge.raw=Ge.raw.trimRight();var Q=Ge.items.length;for(H=0;H<Q;H++){this.lexer.state.top=!1,Ge.items[H].tokens=this.lexer.blockTokens(Ge.items[H].text,[]);var he=Ge.items[H].tokens.filter(function(We){return We.type==="space"}),Ue=he.every(function(We){for(var et=We.raw.split(""),je=0,He=L(et),it;!(it=He()).done;){var rt=it.value;if(rt===`
`&&(je+=1),je>1)return!0}return!1});!Ge.loose&&he.length&&Ue&&(Ge.loose=!0,Ge.items[H].loose=!0)}return Ge}},Se.html=function(ae){var le=this.rules.block.html.exec(ae);if(le){var X={type:"html",raw:le[0],pre:!this.options.sanitizer&&(le[1]==="pre"||le[1]==="script"||le[1]==="style"),text:le[0]};return this.options.sanitize&&(X.type="paragraph",X.text=this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]),X.tokens=[],this.lexer.inline(X.text,X.tokens)),X}},Se.def=function(ae){var le=this.rules.block.def.exec(ae);if(le){le[3]&&(le[3]=le[3].substring(1,le[3].length-1));var X=le[1].toLowerCase().replace(/\s+/g," ");return{type:"def",tag:X,raw:le[0],href:le[2],title:le[3]}}},Se.table=function(ae){var le=this.rules.block.table.exec(ae);if(le){var X={type:"table",header:w(le[1]).map(function(oe){return{text:oe}}),align:le[2].replace(/^ *|\| *$/g,"").split(/ *\| */),rows:le[3]&&le[3].trim()?le[3].replace(/\n[ \t]*$/,"").split(`
`):[]};if(X.header.length===X.align.length){X.raw=le[0];var Y=X.align.length,k,B,H,j;for(k=0;k<Y;k++)/^ *-+: *$/.test(X.align[k])?X.align[k]="right":/^ *:-+: *$/.test(X.align[k])?X.align[k]="center":/^ *:-+ *$/.test(X.align[k])?X.align[k]="left":X.align[k]=null;for(Y=X.rows.length,k=0;k<Y;k++)X.rows[k]=w(X.rows[k],X.header.length).map(function(oe){return{text:oe}});for(Y=X.header.length,B=0;B<Y;B++)X.header[B].tokens=[],this.lexer.inline(X.header[B].text,X.header[B].tokens);for(Y=X.rows.length,B=0;B<Y;B++)for(j=X.rows[B],H=0;H<j.length;H++)j[H].tokens=[],this.lexer.inline(j[H].text,j[H].tokens);return X}}},Se.lheading=function(ae){var le=this.rules.block.lheading.exec(ae);if(le){var X={type:"heading",raw:le[0],depth:le[2].charAt(0)==="="?1:2,text:le[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.paragraph=function(ae){var le=this.rules.block.paragraph.exec(ae);if(le){var X={type:"paragraph",raw:le[0],text:le[1].charAt(le[1].length-1)===`
`?le[1].slice(0,-1):le[1],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.text=function(ae){var le=this.rules.block.text.exec(ae);if(le){var X={type:"text",raw:le[0],text:le[0],tokens:[]};return this.lexer.inline(X.text,X.tokens),X}},Se.escape=function(ae){var le=this.rules.inline.escape.exec(ae);if(le)return{type:"escape",raw:le[0],text:f(le[1])}},Se.tag=function(ae){var le=this.rules.inline.tag.exec(ae);if(le)return!this.lexer.state.inLink&&/^<a /i.test(le[0])?this.lexer.state.inLink=!0:this.lexer.state.inLink&&/^<\/a>/i.test(le[0])&&(this.lexer.state.inLink=!1),!this.lexer.state.inRawBlock&&/^<(pre|code|kbd|script)(\s|>)/i.test(le[0])?this.lexer.state.inRawBlock=!0:this.lexer.state.inRawBlock&&/^<\/(pre|code|kbd|script)(\s|>)/i.test(le[0])&&(this.lexer.state.inRawBlock=!1),{type:this.options.sanitize?"text":"html",raw:le[0],inLink:this.lexer.state.inLink,inRawBlock:this.lexer.state.inRawBlock,text:this.options.sanitize?this.options.sanitizer?this.options.sanitizer(le[0]):f(le[0]):le[0]}},Se.link=function(ae){var le=this.rules.inline.link.exec(ae);if(le){var X=le[2].trim();if(!this.options.pedantic&&/^</.test(X)){if(!/>$/.test(X))return;var Y=g(X.slice(0,-1),"\\");if((X.length-Y.length)%2==0)return}else{var k=C(le[2],"()");if(k>-1){var B=le[0].indexOf("!")===0?5:4,H=B+le[1].length+k;le[2]=le[2].substring(0,k),le[0]=le[0].substring(0,H).trim(),le[3]=""}}var j=le[2],oe="";if(this.options.pedantic){var ue=/^([^'"]*[^\s])\s+(['"])(.*)\2/.exec(j);ue&&(j=ue[1],oe=ue[3])}else oe=le[3]?le[3].slice(1,-1):"";return j=j.trim(),/^</.test(j)&&(this.options.pedantic&&!/>$/.test(X)?j=j.slice(1):j=j.slice(1,-1)),M(le,{href:j&&j.replace(this.rules.inline._escapes,"$1"),title:oe&&oe.replace(this.rules.inline._escapes,"$1")},le[0],this.lexer)}},Se.reflink=function(ae,le){var X;if((X=this.rules.inline.reflink.exec(ae))||(X=this.rules.inline.nolink.exec(ae))){var Y=(X[2]||X[1]).replace(/\s+/g," ");if(Y=le[Y.toLowerCase()],!Y||!Y.href){var k=X[0].charAt(0);return{type:"text",raw:k,text:k}}return M(X,Y,X[0],this.lexer)}},Se.emStrong=function(ae,le,X){X===void 0&&(X="");var Y=this.rules.inline.emStrong.lDelim.exec(ae);if(!!Y&&!(Y[3]&&X.match(/(?:[0-9A-Za-z\xAA\xB2\xB3\xB5\xB9\xBA\xBC-\xBE\xC0-\xD6\xD8-\xF6\xF8-\u02C1\u02C6-\u02D1\u02E0-\u02E4\u02EC\u02EE\u0370-\u0374\u0376\u0377\u037A-\u037D\u037F\u0386\u0388-\u038A\u038C\u038E-\u03A1\u03A3-\u03F5\u03F7-\u0481\u048A-\u052F\u0531-\u0556\u0559\u0560-\u0588\u05D0-\u05EA\u05EF-\u05F2\u0620-\u064A\u0660-\u0669\u066E\u066F\u0671-\u06D3\u06D5\u06E5\u06E6\u06EE-\u06FC\u06FF\u0710\u0712-\u072F\u074D-\u07A5\u07B1\u07C0-\u07EA\u07F4\u07F5\u07FA\u0800-\u0815\u081A\u0824\u0828\u0840-\u0858\u0860-\u086A\u0870-\u0887\u0889-\u088E\u08A0-\u08C9\u0904-\u0939\u093D\u0950\u0958-\u0961\u0966-\u096F\u0971-\u0980\u0985-\u098C\u098F\u0990\u0993-\u09A8\u09AA-\u09B0\u09B2\u09B6-\u09B9\u09BD\u09CE\u09DC\u09DD\u09DF-\u09E1\u09E6-\u09F1\u09F4-\u09F9\u09FC\u0A05-\u0A0A\u0A0F\u0A10\u0A13-\u0A28\u0A2A-\u0A30\u0A32\u0A33\u0A35\u0A36\u0A38\u0A39\u0A59-\u0A5C\u0A5E\u0A66-\u0A6F\u0A72-\u0A74\u0A85-\u0A8D\u0A8F-\u0A91\u0A93-\u0AA8\u0AAA-\u0AB0\u0AB2\u0AB3\u0AB5-\u0AB9\u0ABD\u0AD0\u0AE0\u0AE1\u0AE6-\u0AEF\u0AF9\u0B05-\u0B0C\u0B0F\u0B10\u0B13-\u0B28\u0B2A-\u0B30\u0B32\u0B33\u0B35-\u0B39\u0B3D\u0B5C\u0B5D\u0B5F-\u0B61\u0B66-\u0B6F\u0B71-\u0B77\u0B83\u0B85-\u0B8A\u0B8E-\u0B90\u0B92-\u0B95\u0B99\u0B9A\u0B9C\u0B9E\u0B9F\u0BA3\u0BA4\u0BA8-\u0BAA\u0BAE-\u0BB9\u0BD0\u0BE6-\u0BF2\u0C05-\u0C0C\u0C0E-\u0C10\u0C12-\u0C28\u0C2A-\u0C39\u0C3D\u0C58-\u0C5A\u0C5D\u0C60\u0C61\u0C66-\u0C6F\u0C78-\u0C7E\u0C80\u0C85-\u0C8C\u0C8E-\u0C90\u0C92-\u0CA8\u0CAA-\u0CB3\u0CB5-\u0CB9\u0CBD\u0CDD\u0CDE\u0CE0\u0CE1\u0CE6-\u0CEF\u0CF1\u0CF2\u0D04-\u0D0C\u0D0E-\u0D10\u0D12-\u0D3A\u0D3D\u0D4E\u0D54-\u0D56\u0D58-\u0D61\u0D66-\u0D78\u0D7A-\u0D7F\u0D85-\u0D96\u0D9A-\u0DB1\u0DB3-\u0DBB\u0DBD\u0DC0-\u0DC6\u0DE6-\u0DEF\u0E01-\u0E30\u0E32\u0E33\u0E40-\u0E46\u0E50-\u0E59\u0E81\u0E82\u0E84\u0E86-\u0E8A\u0E8C-\u0EA3\u0EA5\u0EA7-\u0EB0\u0EB2\u0EB3\u0EBD\u0EC0-\u0EC4\u0EC6\u0ED0-\u0ED9\u0EDC-\u0EDF\u0F00\u0F20-\u0F33\u0F40-\u0F47\u0F49-\u0F6C\u0F88-\u0F8C\u1000-\u102A\u103F-\u1049\u1050-\u1055\u105A-\u105D\u1061\u1065\u1066\u106E-\u1070\u1075-\u1081\u108E\u1090-\u1099\u10A0-\u10C5\u10C7\u10CD\u10D0-\u10FA\u10FC-\u1248\u124A-\u124D\u1250-\u1256\u1258\u125A-\u125D\u1260-\u1288\u128A-\u128D\u1290-\u12B0\u12B2-\u12B5\u12B8-\u12BE\u12C0\u12C2-\u12C5\u12C8-\u12D6\u12D8-\u1310\u1312-\u1315\u1318-\u135A\u1369-\u137C\u1380-\u138F\u13A0-\u13F5\u13F8-\u13FD\u1401-\u166C\u166F-\u167F\u1681-\u169A\u16A0-\u16EA\u16EE-\u16F8\u1700-\u1711\u171F-\u1731\u1740-\u1751\u1760-\u176C\u176E-\u1770\u1780-\u17B3\u17D7\u17DC\u17E0-\u17E9\u17F0-\u17F9\u1810-\u1819\u1820-\u1878\u1880-\u1884\u1887-\u18A8\u18AA\u18B0-\u18F5\u1900-\u191E\u1946-\u196D\u1970-\u1974\u1980-\u19AB\u19B0-\u19C9\u19D0-\u19DA\u1A00-\u1A16\u1A20-\u1A54\u1A80-\u1A89\u1A90-\u1A99\u1AA7\u1B05-\u1B33\u1B45-\u1B4C\u1B50-\u1B59\u1B83-\u1BA0\u1BAE-\u1BE5\u1C00-\u1C23\u1C40-\u1C49\u1C4D-\u1C7D\u1C80-\u1C88\u1C90-\u1CBA\u1CBD-\u1CBF\u1CE9-\u1CEC\u1CEE-\u1CF3\u1CF5\u1CF6\u1CFA\u1D00-\u1DBF\u1E00-\u1F15\u1F18-\u1F1D\u1F20-\u1F45\u1F48-\u1F4D\u1F50-\u1F57\u1F59\u1F5B\u1F5D\u1F5F-\u1F7D\u1F80-\u1FB4\u1FB6-\u1FBC\u1FBE\u1FC2-\u1FC4\u1FC6-\u1FCC\u1FD0-\u1FD3\u1FD6-\u1FDB\u1FE0-\u1FEC\u1FF2-\u1FF4\u1FF6-\u1FFC\u2070\u2071\u2074-\u2079\u207F-\u2089\u2090-\u209C\u2102\u2107\u210A-\u2113\u2115\u2119-\u211D\u2124\u2126\u2128\u212A-\u212D\u212F-\u2139\u213C-\u213F\u2145-\u2149\u214E\u2150-\u2189\u2460-\u249B\u24EA-\u24FF\u2776-\u2793\u2C00-\u2CE4\u2CEB-\u2CEE\u2CF2\u2CF3\u2CFD\u2D00-\u2D25\u2D27\u2D2D\u2D30-\u2D67\u2D6F\u2D80-\u2D96\u2DA0-\u2DA6\u2DA8-\u2DAE\u2DB0-\u2DB6\u2DB8-\u2DBE\u2DC0-\u2DC6\u2DC8-\u2DCE\u2DD0-\u2DD6\u2DD8-\u2DDE\u2E2F\u3005-\u3007\u3021-\u3029\u3031-\u3035\u3038-\u303C\u3041-\u3096\u309D-\u309F\u30A1-\u30FA\u30FC-\u30FF\u3105-\u312F\u3131-\u318E\u3192-\u3195\u31A0-\u31BF\u31F0-\u31FF\u3220-\u3229\u3248-\u324F\u3251-\u325F\u3280-\u3289\u32B1-\u32BF\u3400-\u4DBF\u4E00-\uA48C\uA4D0-\uA4FD\uA500-\uA60C\uA610-\uA62B\uA640-\uA66E\uA67F-\uA69D\uA6A0-\uA6EF\uA717-\uA71F\uA722-\uA788\uA78B-\uA7CA\uA7D0\uA7D1\uA7D3\uA7D5-\uA7D9\uA7F2-\uA801\uA803-\uA805\uA807-\uA80A\uA80C-\uA822\uA830-\uA835\uA840-\uA873\uA882-\uA8B3\uA8D0-\uA8D9\uA8F2-\uA8F7\uA8FB\uA8FD\uA8FE\uA900-\uA925\uA930-\uA946\uA960-\uA97C\uA984-\uA9B2\uA9CF-\uA9D9\uA9E0-\uA9E4\uA9E6-\uA9FE\uAA00-\uAA28\uAA40-\uAA42\uAA44-\uAA4B\uAA50-\uAA59\uAA60-\uAA76\uAA7A\uAA7E-\uAAAF\uAAB1\uAAB5\uAAB6\uAAB9-\uAABD\uAAC0\uAAC2\uAADB-\uAADD\uAAE0-\uAAEA\uAAF2-\uAAF4\uAB01-\uAB06\uAB09-\uAB0E\uAB11-\uAB16\uAB20-\uAB26\uAB28-\uAB2E\uAB30-\uAB5A\uAB5C-\uAB69\uAB70-\uABE2\uABF0-\uABF9\uAC00-\uD7A3\uD7B0-\uD7C6\uD7CB-\uD7FB\uF900-\uFA6D\uFA70-\uFAD9\uFB00-\uFB06\uFB13-\uFB17\uFB1D\uFB1F-\uFB28\uFB2A-\uFB36\uFB38-\uFB3C\uFB3E\uFB40\uFB41\uFB43\uFB44\uFB46-\uFBB1\uFBD3-\uFD3D\uFD50-\uFD8F\uFD92-\uFDC7\uFDF0-\uFDFB\uFE70-\uFE74\uFE76-\uFEFC\uFF10-\uFF19\uFF21-\uFF3A\uFF41-\uFF5A\uFF66-\uFFBE\uFFC2-\uFFC7\uFFCA-\uFFCF\uFFD2-\uFFD7\uFFDA-\uFFDC]|\uD800[\uDC00-\uDC0B\uDC0D-\uDC26\uDC28-\uDC3A\uDC3C\uDC3D\uDC3F-\uDC4D\uDC50-\uDC5D\uDC80-\uDCFA\uDD07-\uDD33\uDD40-\uDD78\uDD8A\uDD8B\uDE80-\uDE9C\uDEA0-\uDED0\uDEE1-\uDEFB\uDF00-\uDF23\uDF2D-\uDF4A\uDF50-\uDF75\uDF80-\uDF9D\uDFA0-\uDFC3\uDFC8-\uDFCF\uDFD1-\uDFD5]|\uD801[\uDC00-\uDC9D\uDCA0-\uDCA9\uDCB0-\uDCD3\uDCD8-\uDCFB\uDD00-\uDD27\uDD30-\uDD63\uDD70-\uDD7A\uDD7C-\uDD8A\uDD8C-\uDD92\uDD94\uDD95\uDD97-\uDDA1\uDDA3-\uDDB1\uDDB3-\uDDB9\uDDBB\uDDBC\uDE00-\uDF36\uDF40-\uDF55\uDF60-\uDF67\uDF80-\uDF85\uDF87-\uDFB0\uDFB2-\uDFBA]|\uD802[\uDC00-\uDC05\uDC08\uDC0A-\uDC35\uDC37\uDC38\uDC3C\uDC3F-\uDC55\uDC58-\uDC76\uDC79-\uDC9E\uDCA7-\uDCAF\uDCE0-\uDCF2\uDCF4\uDCF5\uDCFB-\uDD1B\uDD20-\uDD39\uDD80-\uDDB7\uDDBC-\uDDCF\uDDD2-\uDE00\uDE10-\uDE13\uDE15-\uDE17\uDE19-\uDE35\uDE40-\uDE48\uDE60-\uDE7E\uDE80-\uDE9F\uDEC0-\uDEC7\uDEC9-\uDEE4\uDEEB-\uDEEF\uDF00-\uDF35\uDF40-\uDF55\uDF58-\uDF72\uDF78-\uDF91\uDFA9-\uDFAF]|\uD803[\uDC00-\uDC48\uDC80-\uDCB2\uDCC0-\uDCF2\uDCFA-\uDD23\uDD30-\uDD39\uDE60-\uDE7E\uDE80-\uDEA9\uDEB0\uDEB1\uDF00-\uDF27\uDF30-\uDF45\uDF51-\uDF54\uDF70-\uDF81\uDFB0-\uDFCB\uDFE0-\uDFF6]|\uD804[\uDC03-\uDC37\uDC52-\uDC6F\uDC71\uDC72\uDC75\uDC83-\uDCAF\uDCD0-\uDCE8\uDCF0-\uDCF9\uDD03-\uDD26\uDD36-\uDD3F\uDD44\uDD47\uDD50-\uDD72\uDD76\uDD83-\uDDB2\uDDC1-\uDDC4\uDDD0-\uDDDA\uDDDC\uDDE1-\uDDF4\uDE00-\uDE11\uDE13-\uDE2B\uDE80-\uDE86\uDE88\uDE8A-\uDE8D\uDE8F-\uDE9D\uDE9F-\uDEA8\uDEB0-\uDEDE\uDEF0-\uDEF9\uDF05-\uDF0C\uDF0F\uDF10\uDF13-\uDF28\uDF2A-\uDF30\uDF32\uDF33\uDF35-\uDF39\uDF3D\uDF50\uDF5D-\uDF61]|\uD805[\uDC00-\uDC34\uDC47-\uDC4A\uDC50-\uDC59\uDC5F-\uDC61\uDC80-\uDCAF\uDCC4\uDCC5\uDCC7\uDCD0-\uDCD9\uDD80-\uDDAE\uDDD8-\uDDDB\uDE00-\uDE2F\uDE44\uDE50-\uDE59\uDE80-\uDEAA\uDEB8\uDEC0-\uDEC9\uDF00-\uDF1A\uDF30-\uDF3B\uDF40-\uDF46]|\uD806[\uDC00-\uDC2B\uDCA0-\uDCF2\uDCFF-\uDD06\uDD09\uDD0C-\uDD13\uDD15\uDD16\uDD18-\uDD2F\uDD3F\uDD41\uDD50-\uDD59\uDDA0-\uDDA7\uDDAA-\uDDD0\uDDE1\uDDE3\uDE00\uDE0B-\uDE32\uDE3A\uDE50\uDE5C-\uDE89\uDE9D\uDEB0-\uDEF8]|\uD807[\uDC00-\uDC08\uDC0A-\uDC2E\uDC40\uDC50-\uDC6C\uDC72-\uDC8F\uDD00-\uDD06\uDD08\uDD09\uDD0B-\uDD30\uDD46\uDD50-\uDD59\uDD60-\uDD65\uDD67\uDD68\uDD6A-\uDD89\uDD98\uDDA0-\uDDA9\uDEE0-\uDEF2\uDFB0\uDFC0-\uDFD4]|\uD808[\uDC00-\uDF99]|\uD809[\uDC00-\uDC6E\uDC80-\uDD43]|\uD80B[\uDF90-\uDFF0]|[\uD80C\uD81C-\uD820\uD822\uD840-\uD868\uD86A-\uD86C\uD86F-\uD872\uD874-\uD879\uD880-\uD883][\uDC00-\uDFFF]|\uD80D[\uDC00-\uDC2E]|\uD811[\uDC00-\uDE46]|\uD81A[\uDC00-\uDE38\uDE40-\uDE5E\uDE60-\uDE69\uDE70-\uDEBE\uDEC0-\uDEC9\uDED0-\uDEED\uDF00-\uDF2F\uDF40-\uDF43\uDF50-\uDF59\uDF5B-\uDF61\uDF63-\uDF77\uDF7D-\uDF8F]|\uD81B[\uDE40-\uDE96\uDF00-\uDF4A\uDF50\uDF93-\uDF9F\uDFE0\uDFE1\uDFE3]|\uD821[\uDC00-\uDFF7]|\uD823[\uDC00-\uDCD5\uDD00-\uDD08]|\uD82B[\uDFF0-\uDFF3\uDFF5-\uDFFB\uDFFD\uDFFE]|\uD82C[\uDC00-\uDD22\uDD50-\uDD52\uDD64-\uDD67\uDD70-\uDEFB]|\uD82F[\uDC00-\uDC6A\uDC70-\uDC7C\uDC80-\uDC88\uDC90-\uDC99]|\uD834[\uDEE0-\uDEF3\uDF60-\uDF78]|\uD835[\uDC00-\uDC54\uDC56-\uDC9C\uDC9E\uDC9F\uDCA2\uDCA5\uDCA6\uDCA9-\uDCAC\uDCAE-\uDCB9\uDCBB\uDCBD-\uDCC3\uDCC5-\uDD05\uDD07-\uDD0A\uDD0D-\uDD14\uDD16-\uDD1C\uDD1E-\uDD39\uDD3B-\uDD3E\uDD40-\uDD44\uDD46\uDD4A-\uDD50\uDD52-\uDEA5\uDEA8-\uDEC0\uDEC2-\uDEDA\uDEDC-\uDEFA\uDEFC-\uDF14\uDF16-\uDF34\uDF36-\uDF4E\uDF50-\uDF6E\uDF70-\uDF88\uDF8A-\uDFA8\uDFAA-\uDFC2\uDFC4-\uDFCB\uDFCE-\uDFFF]|\uD837[\uDF00-\uDF1E]|\uD838[\uDD00-\uDD2C\uDD37-\uDD3D\uDD40-\uDD49\uDD4E\uDE90-\uDEAD\uDEC0-\uDEEB\uDEF0-\uDEF9]|\uD839[\uDFE0-\uDFE6\uDFE8-\uDFEB\uDFED\uDFEE\uDFF0-\uDFFE]|\uD83A[\uDC00-\uDCC4\uDCC7-\uDCCF\uDD00-\uDD43\uDD4B\uDD50-\uDD59]|\uD83B[\uDC71-\uDCAB\uDCAD-\uDCAF\uDCB1-\uDCB4\uDD01-\uDD2D\uDD2F-\uDD3D\uDE00-\uDE03\uDE05-\uDE1F\uDE21\uDE22\uDE24\uDE27\uDE29-\uDE32\uDE34-\uDE37\uDE39\uDE3B\uDE42\uDE47\uDE49\uDE4B\uDE4D-\uDE4F\uDE51\uDE52\uDE54\uDE57\uDE59\uDE5B\uDE5D\uDE5F\uDE61\uDE62\uDE64\uDE67-\uDE6A\uDE6C-\uDE72\uDE74-\uDE77\uDE79-\uDE7C\uDE7E\uDE80-\uDE89\uDE8B-\uDE9B\uDEA1-\uDEA3\uDEA5-\uDEA9\uDEAB-\uDEBB]|\uD83C[\uDD00-\uDD0C]|\uD83E[\uDFF0-\uDFF9]|\uD869[\uDC00-\uDEDF\uDF00-\uDFFF]|\uD86D[\uDC00-\uDF38\uDF40-\uDFFF]|\uD86E[\uDC00-\uDC1D\uDC20-\uDFFF]|\uD873[\uDC00-\uDEA1\uDEB0-\uDFFF]|\uD87A[\uDC00-\uDFE0]|\uD87E[\uDC00-\uDE1D]|\uD884[\uDC00-\uDF4A])/))){var k=Y[1]||Y[2]||"";if(!k||k&&(X===""||this.rules.inline.punctuation.exec(X))){var B=Y[0].length-1,H,j,oe=B,ue=0,Z=Y[0][0]==="*"?this.rules.inline.emStrong.rDelimAst:this.rules.inline.emStrong.rDelimUnd;for(Z.lastIndex=0,le=le.slice(-1*ae.length+B);(Y=Z.exec(le))!=null;)if(H=Y[1]||Y[2]||Y[3]||Y[4]||Y[5]||Y[6],!!H){if(j=H.length,Y[3]||Y[4]){oe+=j;continue}else if((Y[5]||Y[6])&&B%3&&!((B+j)%3)){ue+=j;continue}if(oe-=j,!(oe>0)){if(j=Math.min(j,j+oe+ue),Math.min(B,j)%2){var pe=ae.slice(1,B+Y.index+j);return{type:"em",raw:ae.slice(0,B+Y.index+j+1),text:pe,tokens:this.lexer.inlineTokens(pe,[])}}var ge=ae.slice(2,B+Y.index+j-1);return{type:"strong",raw:ae.slice(0,B+Y.index+j+1),text:ge,tokens:this.lexer.inlineTokens(ge,[])}}}}}},Se.codespan=function(ae){var le=this.rules.inline.code.exec(ae);if(le){var X=le[2].replace(/\n/g," "),Y=/[^ ]/.test(X),k=/^ /.test(X)&&/ $/.test(X);return Y&&k&&(X=X.substring(1,X.length-1)),X=f(X,!0),{type:"codespan",raw:le[0],text:X}}},Se.br=function(ae){var le=this.rules.inline.br.exec(ae);if(le)return{type:"br",raw:le[0]}},Se.del=function(ae){var le=this.rules.inline.del.exec(ae);if(le)return{type:"del",raw:le[0],text:le[2],tokens:this.lexer.inlineTokens(le[2],[])}},Se.autolink=function(ae,le){var X=this.rules.inline.autolink.exec(ae);if(X){var Y,k;return X[2]==="@"?(Y=f(this.options.mangle?le(X[1]):X[1]),k="mailto:"+Y):(Y=f(X[1]),k=Y),{type:"link",raw:X[0],text:Y,href:k,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.url=function(ae,le){var X;if(X=this.rules.inline.url.exec(ae)){var Y,k;if(X[2]==="@")Y=f(this.options.mangle?le(X[0]):X[0]),k="mailto:"+Y;else{var B;do B=X[0],X[0]=this.rules.inline._backpedal.exec(X[0])[0];while(B!==X[0]);Y=f(X[0]),X[1]==="www."?k="http://"+Y:k=Y}return{type:"link",raw:X[0],text:Y,href:k,tokens:[{type:"text",raw:Y,text:Y}]}}},Se.inlineText=function(ae,le){var X=this.rules.inline.text.exec(ae);if(X){var Y;return this.lexer.state.inRawBlock?Y=this.options.sanitize?this.options.sanitizer?this.options.sanitizer(X[0]):f(X[0]):X[0]:Y=f(this.options.smartypants?le(X[0]):X[0]),{type:"text",raw:X[0],text:Y}}},Ie}(),$={newline:/^(?: *(?:\n|$))+/,code:/^( {4}[^\n]+(?:\n(?: *(?:\n|$))*)?)+/,fences:/^ {0,3}(`{3,}(?=[^`\n]*\n)|~{3,})([^\n]*)\n(?:|([\s\S]*?)\n)(?: {0,3}\1[~`]* *(?=\n|$)|$)/,hr:/^ {0,3}((?:-[\t ]*){3,}|(?:_[ \t]*){3,}|(?:\*[ \t]*){3,})(?:\n+|$)/,heading:/^ {0,3}(#{1,6})(?=\s|$)(.*)(?:\n+|$)/,blockquote:/^( {0,3}> ?(paragraph|[^\n]*)(?:\n|$))+/,list:/^( {0,3}bull)([ \t][^\n]+?)?(?:\n|$)/,html:"^ {0,3}(?:<(script|pre|style|textarea)[\\s>][\\s\\S]*?(?:</\\1>[^\\n]*\\n+|$)|comment[^\\n]*(\\n+|$)|<\\?[\\s\\S]*?(?:\\?>\\n*|$)|<![A-Z][\\s\\S]*?(?:>\\n*|$)|<!\\[CDATA\\[[\\s\\S]*?(?:\\]\\]>\\n*|$)|</?(tag)(?: +|\\n|/?>)[\\s\\S]*?(?:(?:\\n *)+\\n|$)|<(?!script|pre|style|textarea)([a-z][\\w-]*)(?:attribute)*? */?>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$)|</(?!script|pre|style|textarea)[a-z][\\w-]*\\s*>(?=[ \\t]*(?:\\n|$))[\\s\\S]*?(?:(?:\\n *)+\\n|$))",def:/^ {0,3}\[(label)\]: *(?:\n *)?<?([^\s>]+)>?(?:(?: +(?:\n *)?| *\n *)(title))? *(?:\n+|$)/,table:t,lheading:/^([^\n]+)\n {0,3}(=+|-+) *(?:\n+|$)/,_paragraph:/^([^\n]+(?:\n(?!hr|heading|lheading|blockquote|fences|list|html|table| +\n)[^\n]+)*)/,text:/^[^\n]+/};$._label=/(?!\s*\])(?:\\.|[^\[\]\\])+/,$._title=/(?:"(?:\\"?|[^"\\])*"|'[^'\n]*(?:\n[^'\n]+)*\n?'|\([^()]*\))/,$.def=v($.def).replace("label",$._label).replace("title",$._title).getRegex(),$.bullet=/(?:[*+-]|\d{1,9}[.)])/,$.listItemStart=v(/^( *)(bull) */).replace("bull",$.bullet).getRegex(),$.list=v($.list).replace(/bull/g,$.bullet).replace("hr","\\n+(?=\\1?(?:(?:- *){3,}|(?:_ *){3,}|(?:\\* *){3,})(?:\\n+|$))").replace("def","\\n+(?="+$.def.source+")").getRegex(),$._tag="address|article|aside|base|basefont|blockquote|body|caption|center|col|colgroup|dd|details|dialog|dir|div|dl|dt|fieldset|figcaption|figure|footer|form|frame|frameset|h[1-6]|head|header|hr|html|iframe|legend|li|link|main|menu|menuitem|meta|nav|noframes|ol|optgroup|option|p|param|section|source|summary|table|tbody|td|tfoot|th|thead|title|tr|track|ul",$._comment=/<!--(?!-?>)[\s\S]*?(?:-->|$)/,$.html=v($.html,"i").replace("comment",$._comment).replace("tag",$._tag).replace("attribute",/ +[a-zA-Z:_][\w.:-]*(?: *= *"[^"\n]*"| *= *'[^'\n]*'| *= *[^\s"'=<>`]+)?/).getRegex(),$.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("|table","").replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.blockquote=v($.blockquote).replace("paragraph",$.paragraph).getRegex(),$.normal=c({},$),$.gfm=c({},$.normal,{table:"^ *([^\\n ].*\\|.*)\\n {0,3}(?:\\| *)?(:?-+:? *(?:\\| *:?-+:? *)*)(?:\\| *)?(?:\\n((?:(?! *\\n|hr|heading|blockquote|code|fences|list|html).*(?:\\n|$))*)\\n*|$)"}),$.gfm.table=v($.gfm.table).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("blockquote"," {0,3}>").replace("code"," {4}[^\\n]").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.gfm.paragraph=v($._paragraph).replace("hr",$.hr).replace("heading"," {0,3}#{1,6} ").replace("|lheading","").replace("table",$.gfm.table).replace("blockquote"," {0,3}>").replace("fences"," {0,3}(?:`{3,}(?=[^`\\n]*\\n)|~{3,})[^\\n]*\\n").replace("list"," {0,3}(?:[*+-]|1[.)]) ").replace("html","</?(?:tag)(?: +|\\n|/?>)|<(?:script|pre|style|textarea|!--)").replace("tag",$._tag).getRegex(),$.pedantic=c({},$.normal,{html:v(`^ *(?:comment *(?:\\n|\\s*$)|<(tag)[\\s\\S]+?</\\1> *(?:\\n{2,}|\\s*$)|<tag(?:"[^"]*"|'[^']*'|\\s[^'"/>\\s]*)*?/?> *(?:\\n{2,}|\\s*$))`).replace("comment",$._comment).replace(/tag/g,"(?!(?:a|em|strong|small|s|cite|q|dfn|abbr|data|time|code|var|samp|kbd|sub|sup|i|b|u|mark|ruby|rt|rp|bdi|bdo|span|br|wbr|ins|del|img)\\b)\\w+(?!:|[^\\w\\s@]*@)\\b").getRegex(),def:/^ *\[([^\]]+)\]: *<?([^\s>]+)>?(?: +(["(][^\n]+[")]))? *(?:\n+|$)/,heading:/^(#{1,6})(.*)(?:\n+|$)/,fences:t,paragraph:v($.normal._paragraph).replace("hr",$.hr).replace("heading",` *#{1,6} *[^
]`).replace("lheading",$.lheading).replace("blockquote"," {0,3}>").replace("|fences","").replace("|list","").replace("|html","").getRegex()});var N={escape:/^\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/,autolink:/^<(scheme:[^\s\x00-\x1f<>]*|email)>/,url:t,tag:"^comment|^</[a-zA-Z][\\w:-]*\\s*>|^<[a-zA-Z][\\w-]*(?:attribute)*?\\s*/?>|^<\\?[\\s\\S]*?\\?>|^<![a-zA-Z]+\\s[\\s\\S]*?>|^<!\\[CDATA\\[[\\s\\S]*?\\]\\]>",link:/^!?\[(label)\]\(\s*(href)(?:\s+(title))?\s*\)/,reflink:/^!?\[(label)\]\[(ref)\]/,nolink:/^!?\[(ref)\](?:\[\])?/,reflinkSearch:"reflink|nolink(?!\\()",emStrong:{lDelim:/^(?:\*+(?:([punct_])|[^\s*]))|^_+(?:([punct*])|([^\s_]))/,rDelimAst:/^[^_*]*?\_\_[^_*]*?\*[^_*]*?(?=\_\_)|[^*]+(?=[^*])|[punct_](\*+)(?=[\s]|$)|[^punct*_\s](\*+)(?=[punct_\s]|$)|[punct_\s](\*+)(?=[^punct*_\s])|[\s](\*+)(?=[punct_])|[punct_](\*+)(?=[punct_])|[^punct*_\s](\*+)(?=[^punct*_\s])/,rDelimUnd:/^[^_*]*?\*\*[^_*]*?\_[^_*]*?(?=\*\*)|[^_]+(?=[^_])|[punct*](\_+)(?=[\s]|$)|[^punct*_\s](\_+)(?=[punct*\s]|$)|[punct*\s](\_+)(?=[^punct*_\s])|[\s](\_+)(?=[punct*])|[punct*](\_+)(?=[punct*])/},code:/^(`+)([^`]|[^`][\s\S]*?[^`])\1(?!`)/,br:/^( {2,}|\\)\n(?!\s*$)/,del:t,text:/^(`+|[^`])(?:(?= {2,}\n)|[\s\S]*?(?:(?=[\\<!\[`*_]|\b_|$)|[^ ](?= {2,}\n)))/,punctuation:/^([\spunctuation])/};N._punctuation="!\"#$%&'()+\\-.,/:;<=>?@\\[\\]`^{|}~",N.punctuation=v(N.punctuation).replace(/punctuation/g,N._punctuation).getRegex(),N.blockSkip=/\[[^\]]*?\]\([^\)]*?\)|`[^`]*?`|<[^>]*?>/g,N.escapedEmSt=/\\\*|\\_/g,N._comment=v($._comment).replace("(?:-->|$)","-->").getRegex(),N.emStrong.lDelim=v(N.emStrong.lDelim).replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimAst=v(N.emStrong.rDelimAst,"g").replace(/punct/g,N._punctuation).getRegex(),N.emStrong.rDelimUnd=v(N.emStrong.rDelimUnd,"g").replace(/punct/g,N._punctuation).getRegex(),N._escapes=/\\([!"#$%&'()*+,\-./:;<=>?@\[\]\\^_`{|}~])/g,N._scheme=/[a-zA-Z][a-zA-Z0-9+.-]{1,31}/,N._email=/[a-zA-Z0-9.!#$%&'*+/=?^_`{|}~-]+(@)[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?(?:\.[a-zA-Z0-9](?:[a-zA-Z0-9-]{0,61}[a-zA-Z0-9])?)+(?![-_])/,N.autolink=v(N.autolink).replace("scheme",N._scheme).replace("email",N._email).getRegex(),N._attribute=/\s+[a-zA-Z:_][\w.:-]*(?:\s*=\s*"[^"]*"|\s*=\s*'[^']*'|\s*=\s*[^\s"'=<>`]+)?/,N.tag=v(N.tag).replace("comment",N._comment).replace("attribute",N._attribute).getRegex(),N._label=/(?:\[(?:\\.|[^\[\]\\])*\]|\\.|`[^`]*`|[^\[\]\\`])*?/,N._href=/<(?:\\.|[^\n<>\\])+>|[^\s\x00-\x1f]*/,N._title=/"(?:\\"?|[^"\\])*"|'(?:\\'?|[^'\\])*'|\((?:\\\)?|[^)\\])*\)/,N.link=v(N.link).replace("label",N._label).replace("href",N._href).replace("title",N._title).getRegex(),N.reflink=v(N.reflink).replace("label",N._label).replace("ref",$._label).getRegex(),N.nolink=v(N.nolink).replace("ref",$._label).getRegex(),N.reflinkSearch=v(N.reflinkSearch,"g").replace("reflink",N.reflink).replace("nolink",N.nolink).getRegex(),N.normal=c({},N),N.pedantic=c({},N.normal,{strong:{start:/^__|\*\*/,middle:/^__(?=\S)([\s\S]*?\S)__(?!_)|^\*\*(?=\S)([\s\S]*?\S)\*\*(?!\*)/,endAst:/\*\*(?!\*)/g,endUnd:/__(?!_)/g},em:{start:/^_|\*/,middle:/^()\*(?=\S)([\s\S]*?\S)\*(?!\*)|^_(?=\S)([\s\S]*?\S)_(?!_)/,endAst:/\*(?!\*)/g,endUnd:/_(?!_)/g},link:v(/^!?\[(label)\]\((.*?)\)/).replace("label",N._label).getRegex(),reflink:v(/^!?\[(label)\]\s*\[([^\]]*)\]/).replace("label",N._label).getRegex()}),N.gfm=c({},N.normal,{escape:v(N.escape).replace("])","~|])").getRegex(),_extended_email:/[A-Za-z0-9._+-]+(@)[a-zA-Z0-9-_]+(?:\.[a-zA-Z0-9-_]*[a-zA-Z0-9])+(?![-_])/,url:/^((?:ftp|https?):\/\/|www\.)(?:[a-zA-Z0-9\-]+\.?)+[^\s<]*|^email/,_backpedal:/(?:[^?!.,:;*_~()&]+|\([^)]*\)|&(?![a-zA-Z0-9]+;$)|[?!.,:;*_~)]+(?!$))+/,del:/^(~~?)(?=[^\s~])([\s\S]*?[^\s~])\1(?=[^~]|$)/,text:/^([`~]+|[^`~])(?:(?= {2,}\n)|(?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)|[\s\S]*?(?:(?=[\\<!\[`*~_]|\b_|https?:\/\/|ftp:\/\/|www\.|$)|[^ ](?= {2,}\n)|[^a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-](?=[a-zA-Z0-9.!#$%&'*+\/=?_`{\|}~-]+@)))/}),N.gfm.url=v(N.gfm.url,"i").replace("email",N.gfm._extended_email).getRegex(),N.breaks=c({},N.gfm,{br:v(N.br).replace("{2,}","*").getRegex(),text:v(N.gfm.text).replace("\\b_","\\b_| {2,}\\n").replace(/\{2,\}/g,"*").getRegex()});function K(Ie){return Ie.replace(/---/g,"\u2014").replace(/--/g,"\u2013").replace(/(^|[-\u2014/(\[{"\s])'/g,"$1\u2018").replace(/'/g,"\u2019").replace(/(^|[-\u2014/(\[{\u2018\s])"/g,"$1\u201C").replace(/"/g,"\u201D").replace(/\.{3}/g,"\u2026")}function V(Ie){var Se="",Te,ae,le=Ie.length;for(Te=0;Te<le;Te++)ae=Ie.charCodeAt(Te),Math.random()>.5&&(ae="x"+ae.toString(16)),Se+="&#"+ae+";";return Se}var F=function(){function Ie(Te){this.tokens=[],this.tokens.links=Object.create(null),this.options=Te||te.defaults,this.options.tokenizer=this.options.tokenizer||new z,this.tokenizer=this.options.tokenizer,this.tokenizer.options=this.options,this.tokenizer.lexer=this,this.inlineQueue=[],this.state={inLink:!1,inRawBlock:!1,top:!0};var ae={block:$.normal,inline:N.normal};this.options.pedantic?(ae.block=$.pedantic,ae.inline=N.pedantic):this.options.gfm&&(ae.block=$.gfm,this.options.breaks?ae.inline=N.breaks:ae.inline=N.gfm),this.tokenizer.rules=ae}Ie.lex=function(ae,le){var X=new Ie(le);return X.lex(ae)},Ie.lexInline=function(ae,le){var X=new Ie(le);return X.inlineTokens(ae)};var Se=Ie.prototype;return Se.lex=function(ae){ae=ae.replace(/\r\n|\r/g,`
`),this.blockTokens(ae,this.tokens);for(var le;le=this.inlineQueue.shift();)this.inlineTokens(le.src,le.tokens);return this.tokens},Se.blockTokens=function(ae,le){var X=this;le===void 0&&(le=[]),this.options.pedantic?ae=ae.replace(/\t/g,"    ").replace(/^ +$/gm,""):ae=ae.replace(/^( *)(\t+)/gm,function(oe,ue,Z){return ue+"    ".repeat(Z.length)});for(var Y,k,B,H;ae;)if(!(this.options.extensions&&this.options.extensions.block&&this.options.extensions.block.some(function(oe){return(Y=oe.call({lexer:X},ae,le))?(ae=ae.substring(Y.raw.length),le.push(Y),!0):!1}))){if(Y=this.tokenizer.space(ae)){ae=ae.substring(Y.raw.length),Y.raw.length===1&&le.length>0?le[le.length-1].raw+=`
`:le.push(Y);continue}if(Y=this.tokenizer.code(ae)){ae=ae.substring(Y.raw.length),k=le[le.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Y.raw,k.text+=`
`+Y.text,this.inlineQueue[this.inlineQueue.length-1].src=k.text):le.push(Y);continue}if(Y=this.tokenizer.fences(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.heading(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.hr(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.blockquote(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.list(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.html(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.def(ae)){ae=ae.substring(Y.raw.length),k=le[le.length-1],k&&(k.type==="paragraph"||k.type==="text")?(k.raw+=`
`+Y.raw,k.text+=`
`+Y.raw,this.inlineQueue[this.inlineQueue.length-1].src=k.text):this.tokens.links[Y.tag]||(this.tokens.links[Y.tag]={href:Y.href,title:Y.title});continue}if(Y=this.tokenizer.table(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.lheading(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(B=ae,this.options.extensions&&this.options.extensions.startBlock&&function(){var oe=1/0,ue=ae.slice(1),Z=void 0;X.options.extensions.startBlock.forEach(function(pe){Z=pe.call({lexer:this},ue),typeof Z=="number"&&Z>=0&&(oe=Math.min(oe,Z))}),oe<1/0&&oe>=0&&(B=ae.substring(0,oe+1))}(),this.state.top&&(Y=this.tokenizer.paragraph(B))){k=le[le.length-1],H&&k.type==="paragraph"?(k.raw+=`
`+Y.raw,k.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):le.push(Y),H=B.length!==ae.length,ae=ae.substring(Y.raw.length);continue}if(Y=this.tokenizer.text(ae)){ae=ae.substring(Y.raw.length),k=le[le.length-1],k&&k.type==="text"?(k.raw+=`
`+Y.raw,k.text+=`
`+Y.text,this.inlineQueue.pop(),this.inlineQueue[this.inlineQueue.length-1].src=k.text):le.push(Y);continue}if(ae){var j="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(j);break}else throw new Error(j)}}return this.state.top=!0,le},Se.inline=function(ae,le){this.inlineQueue.push({src:ae,tokens:le})},Se.inlineTokens=function(ae,le){var X=this;le===void 0&&(le=[]);var Y,k,B,H=ae,j,oe,ue;if(this.tokens.links){var Z=Object.keys(this.tokens.links);if(Z.length>0)for(;(j=this.tokenizer.rules.inline.reflinkSearch.exec(H))!=null;)Z.includes(j[0].slice(j[0].lastIndexOf("[")+1,-1))&&(H=H.slice(0,j.index)+"["+W("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.reflinkSearch.lastIndex))}for(;(j=this.tokenizer.rules.inline.blockSkip.exec(H))!=null;)H=H.slice(0,j.index)+"["+W("a",j[0].length-2)+"]"+H.slice(this.tokenizer.rules.inline.blockSkip.lastIndex);for(;(j=this.tokenizer.rules.inline.escapedEmSt.exec(H))!=null;)H=H.slice(0,j.index)+"++"+H.slice(this.tokenizer.rules.inline.escapedEmSt.lastIndex);for(;ae;)if(oe||(ue=""),oe=!1,!(this.options.extensions&&this.options.extensions.inline&&this.options.extensions.inline.some(function(ge){return(Y=ge.call({lexer:X},ae,le))?(ae=ae.substring(Y.raw.length),le.push(Y),!0):!1}))){if(Y=this.tokenizer.escape(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.tag(ae)){ae=ae.substring(Y.raw.length),k=le[le.length-1],k&&Y.type==="text"&&k.type==="text"?(k.raw+=Y.raw,k.text+=Y.text):le.push(Y);continue}if(Y=this.tokenizer.link(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.reflink(ae,this.tokens.links)){ae=ae.substring(Y.raw.length),k=le[le.length-1],k&&Y.type==="text"&&k.type==="text"?(k.raw+=Y.raw,k.text+=Y.text):le.push(Y);continue}if(Y=this.tokenizer.emStrong(ae,H,ue)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.codespan(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.br(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.del(ae)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(Y=this.tokenizer.autolink(ae,V)){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(!this.state.inLink&&(Y=this.tokenizer.url(ae,V))){ae=ae.substring(Y.raw.length),le.push(Y);continue}if(B=ae,this.options.extensions&&this.options.extensions.startInline&&function(){var ge=1/0,Ne=ae.slice(1),Be=void 0;X.options.extensions.startInline.forEach(function(Ze){Be=Ze.call({lexer:this},Ne),typeof Be=="number"&&Be>=0&&(ge=Math.min(ge,Be))}),ge<1/0&&ge>=0&&(B=ae.substring(0,ge+1))}(),Y=this.tokenizer.inlineText(B,K)){ae=ae.substring(Y.raw.length),Y.raw.slice(-1)!=="_"&&(ue=Y.raw.slice(-1)),oe=!0,k=le[le.length-1],k&&k.type==="text"?(k.raw+=Y.raw,k.text+=Y.text):le.push(Y);continue}if(ae){var pe="Infinite loop on byte: "+ae.charCodeAt(0);if(this.options.silent){console.error(pe);break}else throw new Error(pe)}}return le},o(Ie,null,[{key:"rules",get:function(){return{block:$,inline:N}}}]),Ie}(),ne=function(){function Ie(Te){this.options=Te||te.defaults}var Se=Ie.prototype;return Se.code=function(ae,le,X){var Y=(le||"").match(/\S*/)[0];if(this.options.highlight){var k=this.options.highlight(ae,Y);k!=null&&k!==ae&&(X=!0,ae=k)}return ae=ae.replace(/\n$/,"")+`
`,Y?'<pre><code class="'+this.options.langPrefix+f(Y,!0)+'">'+(X?ae:f(ae,!0))+`</code></pre>
`:"<pre><code>"+(X?ae:f(ae,!0))+`</code></pre>
`},Se.blockquote=function(ae){return`<blockquote>
`+ae+`</blockquote>
`},Se.html=function(ae){return ae},Se.heading=function(ae,le,X,Y){if(this.options.headerIds){var k=this.options.headerPrefix+Y.slug(X);return"<h"+le+' id="'+k+'">'+ae+"</h"+le+`>
`}return"<h"+le+">"+ae+"</h"+le+`>
`},Se.hr=function(){return this.options.xhtml?`<hr/>
`:`<hr>
`},Se.list=function(ae,le,X){var Y=le?"ol":"ul",k=le&&X!==1?' start="'+X+'"':"";return"<"+Y+k+`>
`+ae+"</"+Y+`>
`},Se.listitem=function(ae){return"<li>"+ae+`</li>
`},Se.checkbox=function(ae){return"<input "+(ae?'checked="" ':"")+'disabled="" type="checkbox"'+(this.options.xhtml?" /":"")+"> "},Se.paragraph=function(ae){return"<p>"+ae+`</p>
`},Se.table=function(ae,le){return le&&(le="<tbody>"+le+"</tbody>"),`<table>
<thead>
`+ae+`</thead>
`+le+`</table>
`},Se.tablerow=function(ae){return`<tr>
`+ae+`</tr>
`},Se.tablecell=function(ae,le){var X=le.header?"th":"td",Y=le.align?"<"+X+' align="'+le.align+'">':"<"+X+">";return Y+ae+("</"+X+`>
`)},Se.strong=function(ae){return"<strong>"+ae+"</strong>"},Se.em=function(ae){return"<em>"+ae+"</em>"},Se.codespan=function(ae){return"<code>"+ae+"</code>"},Se.br=function(){return this.options.xhtml?"<br/>":"<br>"},Se.del=function(ae){return"<del>"+ae+"</del>"},Se.link=function(ae,le,X){if(ae=_(this.options.sanitize,this.options.baseUrl,ae),ae===null)return X;var Y='<a href="'+f(ae)+'"';return le&&(Y+=' title="'+le+'"'),Y+=">"+X+"</a>",Y},Se.image=function(ae,le,X){if(ae=_(this.options.sanitize,this.options.baseUrl,ae),ae===null)return X;var Y='<img src="'+ae+'" alt="'+X+'"';return le&&(Y+=' title="'+le+'"'),Y+=this.options.xhtml?"/>":">",Y},Se.text=function(ae){return ae},Ie}(),ce=function(){function Ie(){}var Se=Ie.prototype;return Se.strong=function(ae){return ae},Se.em=function(ae){return ae},Se.codespan=function(ae){return ae},Se.del=function(ae){return ae},Se.html=function(ae){return ae},Se.text=function(ae){return ae},Se.link=function(ae,le,X){return""+X},Se.image=function(ae,le,X){return""+X},Se.br=function(){return""},Ie}(),re=function(){function Ie(){this.seen={}}var Se=Ie.prototype;return Se.serialize=function(ae){return ae.toLowerCase().trim().replace(/<[!\/a-z].*?>/ig,"").replace(/[\u2000-\u206F\u2E00-\u2E7F\\'!"#$%&()*+,./:;<=>?@[\]^`{|}~]/g,"").replace(/\s/g,"-")},Se.getNextSafeSlug=function(ae,le){var X=ae,Y=0;if(this.seen.hasOwnProperty(X)){Y=this.seen[ae];do Y++,X=ae+"-"+Y;while(this.seen.hasOwnProperty(X))}return le||(this.seen[ae]=Y,this.seen[X]=0),X},Se.slug=function(ae,le){le===void 0&&(le={});var X=this.serialize(ae);return this.getNextSafeSlug(X,le.dryrun)},Ie}(),fe=function(){function Ie(Te){this.options=Te||te.defaults,this.options.renderer=this.options.renderer||new ne,this.renderer=this.options.renderer,this.renderer.options=this.options,this.textRenderer=new ce,this.slugger=new re}Ie.parse=function(ae,le){var X=new Ie(le);return X.parse(ae)},Ie.parseInline=function(ae,le){var X=new Ie(le);return X.parseInline(ae)};var Se=Ie.prototype;return Se.parse=function(ae,le){le===void 0&&(le=!0);var X="",Y,k,B,H,j,oe,ue,Z,pe,ge,Ne,Be,Ze,Ge,ke,nt,G,Q,he,Ue=ae.length;for(Y=0;Y<Ue;Y++){if(ge=ae[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[ge.type]&&(he=this.options.extensions.renderers[ge.type].call({parser:this},ge),he!==!1||!["space","hr","heading","code","table","blockquote","list","html","paragraph","text"].includes(ge.type))){X+=he||"";continue}switch(ge.type){case"space":continue;case"hr":{X+=this.renderer.hr();continue}case"heading":{X+=this.renderer.heading(this.parseInline(ge.tokens),ge.depth,d(this.parseInline(ge.tokens,this.textRenderer)),this.slugger);continue}case"code":{X+=this.renderer.code(ge.text,ge.lang,ge.escaped);continue}case"table":{for(Z="",ue="",H=ge.header.length,k=0;k<H;k++)ue+=this.renderer.tablecell(this.parseInline(ge.header[k].tokens),{header:!0,align:ge.align[k]});for(Z+=this.renderer.tablerow(ue),pe="",H=ge.rows.length,k=0;k<H;k++){for(oe=ge.rows[k],ue="",j=oe.length,B=0;B<j;B++)ue+=this.renderer.tablecell(this.parseInline(oe[B].tokens),{header:!1,align:ge.align[B]});pe+=this.renderer.tablerow(ue)}X+=this.renderer.table(Z,pe);continue}case"blockquote":{pe=this.parse(ge.tokens),X+=this.renderer.blockquote(pe);continue}case"list":{for(Ne=ge.ordered,Be=ge.start,Ze=ge.loose,H=ge.items.length,pe="",k=0;k<H;k++)ke=ge.items[k],nt=ke.checked,G=ke.task,Ge="",ke.task&&(Q=this.renderer.checkbox(nt),Ze?ke.tokens.length>0&&ke.tokens[0].type==="paragraph"?(ke.tokens[0].text=Q+" "+ke.tokens[0].text,ke.tokens[0].tokens&&ke.tokens[0].tokens.length>0&&ke.tokens[0].tokens[0].type==="text"&&(ke.tokens[0].tokens[0].text=Q+" "+ke.tokens[0].tokens[0].text)):ke.tokens.unshift({type:"text",text:Q}):Ge+=Q),Ge+=this.parse(ke.tokens,Ze),pe+=this.renderer.listitem(Ge,G,nt);X+=this.renderer.list(pe,Ne,Be);continue}case"html":{X+=this.renderer.html(ge.text);continue}case"paragraph":{X+=this.renderer.paragraph(this.parseInline(ge.tokens));continue}case"text":{for(pe=ge.tokens?this.parseInline(ge.tokens):ge.text;Y+1<Ue&&ae[Y+1].type==="text";)ge=ae[++Y],pe+=`
`+(ge.tokens?this.parseInline(ge.tokens):ge.text);X+=le?this.renderer.paragraph(pe):pe;continue}default:{var We='Token with "'+ge.type+'" type was not found.';if(this.options.silent){console.error(We);return}else throw new Error(We)}}}return X},Se.parseInline=function(ae,le){le=le||this.renderer;var X="",Y,k,B,H=ae.length;for(Y=0;Y<H;Y++){if(k=ae[Y],this.options.extensions&&this.options.extensions.renderers&&this.options.extensions.renderers[k.type]&&(B=this.options.extensions.renderers[k.type].call({parser:this},k),B!==!1||!["escape","html","link","image","strong","em","codespan","br","del","text"].includes(k.type))){X+=B||"";continue}switch(k.type){case"escape":{X+=le.text(k.text);break}case"html":{X+=le.html(k.text);break}case"link":{X+=le.link(k.href,k.title,this.parseInline(k.tokens,le));break}case"image":{X+=le.image(k.href,k.title,k.text);break}case"strong":{X+=le.strong(this.parseInline(k.tokens,le));break}case"em":{X+=le.em(this.parseInline(k.tokens,le));break}case"codespan":{X+=le.codespan(k.text);break}case"br":{X+=le.br();break}case"del":{X+=le.del(this.parseInline(k.tokens,le));break}case"text":{X+=le.text(k.text);break}default:{var j='Token with "'+k.type+'" type was not found.';if(this.options.silent){console.error(j);return}else throw new Error(j)}}}return X},Ie}();function ie(Ie,Se,Te){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");if(typeof Se=="function"&&(Te=Se,Se=null),Se=c({},ie.defaults,Se||{}),U(Se),Te){var ae=Se.highlight,le;try{le=F.lex(Ie,Se)}catch(B){return Te(B)}var X=function(H){var j;if(!H)try{Se.walkTokens&&ie.walkTokens(le,Se.walkTokens),j=fe.parse(le,Se)}catch(oe){H=oe}return Se.highlight=ae,H?Te(H):Te(null,j)};if(!ae||ae.length<3||(delete Se.highlight,!le.length))return X();var Y=0;ie.walkTokens(le,function(B){B.type==="code"&&(Y++,setTimeout(function(){ae(B.text,B.lang,function(H,j){if(H)return X(H);j!=null&&j!==B.text&&(B.text=j,B.escaped=!0),Y--,Y===0&&X()})},0))}),Y===0&&X();return}try{var k=F.lex(Ie,Se);return Se.walkTokens&&ie.walkTokens(k,Se.walkTokens),fe.parse(k,Se)}catch(B){if(B.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(B.message+"",!0)+"</pre>";throw B}}ie.options=ie.setOptions=function(Ie){return c(ie.defaults,Ie),T(ie.defaults),ie},ie.getDefaults=D,ie.defaults=te.defaults,ie.use=function(){for(var Ie=arguments.length,Se=new Array(Ie),Te=0;Te<Ie;Te++)Se[Te]=arguments[Te];var ae=c.apply(void 0,[{}].concat(Se)),le=ie.defaults.extensions||{renderers:{},childTokens:{}},X;Se.forEach(function(Y){if(Y.extensions&&(X=!0,Y.extensions.forEach(function(B){if(!B.name)throw new Error("extension name required");if(B.renderer){var H=le.renderers?le.renderers[B.name]:null;H?le.renderers[B.name]=function(){for(var j=arguments.length,oe=new Array(j),ue=0;ue<j;ue++)oe[ue]=arguments[ue];var Z=B.renderer.apply(this,oe);return Z===!1&&(Z=H.apply(this,oe)),Z}:le.renderers[B.name]=B.renderer}if(B.tokenizer){if(!B.level||B.level!=="block"&&B.level!=="inline")throw new Error("extension level must be 'block' or 'inline'");le[B.level]?le[B.level].unshift(B.tokenizer):le[B.level]=[B.tokenizer],B.start&&(B.level==="block"?le.startBlock?le.startBlock.push(B.start):le.startBlock=[B.start]:B.level==="inline"&&(le.startInline?le.startInline.push(B.start):le.startInline=[B.start]))}B.childTokens&&(le.childTokens[B.name]=B.childTokens)})),Y.renderer&&function(){var B=ie.defaults.renderer||new ne,H=function(ue){var Z=B[ue];B[ue]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Y.renderer[ue].apply(B,ge);return Be===!1&&(Be=Z.apply(B,ge)),Be}};for(var j in Y.renderer)H(j);ae.renderer=B}(),Y.tokenizer&&function(){var B=ie.defaults.tokenizer||new z,H=function(ue){var Z=B[ue];B[ue]=function(){for(var pe=arguments.length,ge=new Array(pe),Ne=0;Ne<pe;Ne++)ge[Ne]=arguments[Ne];var Be=Y.tokenizer[ue].apply(B,ge);return Be===!1&&(Be=Z.apply(B,ge)),Be}};for(var j in Y.tokenizer)H(j);ae.tokenizer=B}(),Y.walkTokens){var k=ie.defaults.walkTokens;ae.walkTokens=function(B){Y.walkTokens.call(this,B),k&&k.call(this,B)}}X&&(ae.extensions=le),ie.setOptions(ae)})},ie.walkTokens=function(Ie,Se){for(var Te=function(){var Y=le.value;switch(Se.call(ie,Y),Y.type){case"table":{for(var k=L(Y.header),B;!(B=k()).done;){var H=B.value;ie.walkTokens(H.tokens,Se)}for(var j=L(Y.rows),oe;!(oe=j()).done;)for(var ue=oe.value,Z=L(ue),pe;!(pe=Z()).done;){var ge=pe.value;ie.walkTokens(ge.tokens,Se)}break}case"list":{ie.walkTokens(Y.items,Se);break}default:ie.defaults.extensions&&ie.defaults.extensions.childTokens&&ie.defaults.extensions.childTokens[Y.type]?ie.defaults.extensions.childTokens[Y.type].forEach(function(Ne){ie.walkTokens(Y[Ne],Se)}):Y.tokens&&ie.walkTokens(Y.tokens,Se)}},ae=L(Ie),le;!(le=ae()).done;)Te()},ie.parseInline=function(Ie,Se){if(typeof Ie=="undefined"||Ie===null)throw new Error("marked.parseInline(): input parameter is undefined or null");if(typeof Ie!="string")throw new Error("marked.parseInline(): input parameter is of type "+Object.prototype.toString.call(Ie)+", string expected");Se=c({},ie.defaults,Se||{}),U(Se);try{var Te=F.lexInline(Ie,Se);return Se.walkTokens&&ie.walkTokens(Te,Se.walkTokens),fe.parseInline(Te,Se)}catch(ae){if(ae.message+=`
Please report this to https://github.com/markedjs/marked.`,Se.silent)return"<p>An error occurred:</p><pre>"+f(ae.message+"",!0)+"</pre>";throw ae}},ie.Parser=fe,ie.parser=fe.parse,ie.Renderer=ne,ie.TextRenderer=ce,ie.Lexer=F,ie.lexer=F.lex,ie.Tokenizer=z,ie.Slugger=re,ie.parse=ie;var Ee=ie.options,be=ie.setOptions,ee=ie.use,ve=ie.walkTokens,Ae=ie.parseInline,Fe=ie,$e=fe.parse,Qe=F.lex;te.Lexer=F,te.Parser=fe,te.Renderer=ne,te.Slugger=re,te.TextRenderer=ce,te.Tokenizer=z,te.getDefaults=D,te.lexer=Qe,te.marked=ie,te.options=Ee,te.parse=Fe,te.parseInline=Ae,te.parser=$e,te.setOptions=be,te.use=ee,te.walkTokens=ve,Object.defineProperty(te,"__esModule",{value:!0})}),define(De[106],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SlidingWindowAverage=e.MovingAverage=e.Counter=e.rot=e.clamp=void 0;function o(T,E,P){return Math.min(Math.max(T,E),P)}e.clamp=o;function p(T,E){return(E+T%E)%E}e.rot=p;class b{constructor(){this._next=0}getNext(){return this._next++}}e.Counter=b;class L{constructor(){this._n=1,this._val=0}update(E){return this._val=this._val+(E-this._val)/this._n,this._n+=1,this._val}get value(){return this._val}}e.MovingAverage=L;class D{constructor(E){this._n=0,this._val=0,this._values=[],this._index=0,this._sum=0,this._values=new Array(E),this._values.fill(0,0,E)}update(E){const P=this._values[this._index];return this._values[this._index]=E,this._index=(this._index+1)%this._values.length,this._sum-=P,this._sum+=E,this._n<this._values.length&&(this._n+=1),this._val=this._sum/this._n,this._val}get value(){return this._val}}e.SlidingWindowAverage=D}),function(){function te(b){const L=[];typeof b=="number"&&L.push("code/timeOrigin",b);function D(E){L.push(E,Date.now())}function T(){const E=[];for(let P=0;P<L.length;P+=2)E.push({name:L[P],startTime:L[P+1]});return E}return{mark:D,getMarks:T}}function e(){if(typeof performance=="object"&&typeof performance.mark=="function"&&!performance.nodeTiming)return typeof performance.timeOrigin!="number"&&!performance.timing?te():{mark(b){performance.mark(b)},getMarks(){let b=performance.timeOrigin;typeof b!="number"&&(b=performance.timing.navigationStart||performance.timing.redirectStart||performance.timing.fetchStart);const L=[{name:"code/timeOrigin",startTime:Math.round(b)}];for(const D of performance.getEntriesByType("mark"))L.push({name:D.name,startTime:Math.round(b+D.startTime)});return L}};if(typeof process=="object"){const b=Math.round((require.nodeRequire||require)("perf_hooks").performance.timeOrigin);return te(b)}else return console.trace("perf-util loaded in UNKNOWN environment"),te()}function o(b){return b.MonacoPerformanceMarks||(b.MonacoPerformanceMarks=e()),b.MonacoPerformanceMarks}var p;typeof global=="object"?p=global:typeof self=="object"?p=self:p={},typeof define=="function"?define("vs/base/common/performance",[],function(){return o(p)}):typeof module=="object"&&typeof module.exports=="object"?module.exports=o(p):(console.trace("perf-util defined in UNKNOWN context (neither requirejs or commonjs)"),p.perf=o(p))}(),function(te,e){if(typeof exports=="object"&&typeof module=="object")module.exports=e();else if(typeof define=="function"&&define.amd)define("vs/base/common/semver/semver",[],e);else{var o=e();for(var p in o)(typeof exports=="object"?exports:te)[p]=o[p]}}(typeof self!="undefined"?self:this,function(){return function(te){var e={};function o(p){if(e[p])return e[p].exports;var b=e[p]={i:p,l:!1,exports:{}};return te[p].call(b.exports,b,b.exports,o),b.l=!0,b.exports}return o.m=te,o.c=e,o.d=function(p,b,L){o.o(p,b)||Object.defineProperty(p,b,{enumerable:!0,get:L})},o.r=function(p){typeof Symbol!="undefined"&&Symbol.toStringTag&&Object.defineProperty(p,Symbol.toStringTag,{value:"Module"}),Object.defineProperty(p,"__esModule",{value:!0})},o.t=function(p,b){if(1&b&&(p=o(p)),8&b||4&b&&typeof p=="object"&&p&&p.__esModule)return p;var L=Object.create(null);if(o.r(L),Object.defineProperty(L,"default",{enumerable:!0,value:p}),2&b&&typeof p!="string")for(var D in p)o.d(L,D,function(T){return p[T]}.bind(null,D));return L},o.n=function(p){var b=p&&p.__esModule?function(){return p.default}:function(){return p};return o.d(b,"a",b),b},o.o=function(p,b){return Object.prototype.hasOwnProperty.call(p,b)},o.p="",o(o.s=0)}([function(te,e,o){(function(p){var b;e=te.exports=ee,b=typeof p=="object"&&p.env&&p.env.NODE_DEBUG&&/\bsemver\b/i.test(p.env.NODE_DEBUG)?function(){var Z=Array.prototype.slice.call(arguments,0);Z.unshift("SEMVER"),console.log.apply(console,Z)}:function(){},e.SEMVER_SPEC_VERSION="2.0.0";var L=256,D=Number.MAX_SAFE_INTEGER||9007199254740991,T=e.re=[],E=e.src=[],P=0,R=P++;E[R]="0|[1-9]\\d*";var y=P++;E[y]="[0-9]+";var m=P++;E[m]="\\d*[a-zA-Z-][a-zA-Z0-9-]*";var I=P++;E[I]="("+E[R]+")\\.("+E[R]+")\\.("+E[R]+")";var f=P++;E[f]="("+E[y]+")\\.("+E[y]+")\\.("+E[y]+")";var h=P++;E[h]="(?:"+E[R]+"|"+E[m]+")";var d=P++;E[d]="(?:"+E[y]+"|"+E[m]+")";var a=P++;E[a]="(?:-("+E[h]+"(?:\\."+E[h]+")*))";var v=P++;E[v]="(?:-?("+E[d]+"(?:\\."+E[d]+")*))";var A=P++;E[A]="[0-9A-Za-z-]+";var l=P++;E[l]="(?:\\+("+E[A]+"(?:\\."+E[A]+")*))";var _=P++,s="v?"+E[I]+E[a]+"?"+E[l]+"?";E[_]="^"+s+"$";var u="[v=\\s]*"+E[f]+E[v]+"?"+E[l]+"?",n=P++;E[n]="^"+u+"$";var i=P++;E[i]="((?:<|>)?=?)";var r=P++;E[r]=E[y]+"|x|X|\\*";var t=P++;E[t]=E[R]+"|x|X|\\*";var c=P++;E[c]="[v=\\s]*("+E[t]+")(?:\\.("+E[t]+")(?:\\.("+E[t]+")(?:"+E[a]+")?"+E[l]+"?)?)?";var w=P++;E[w]="[v=\\s]*("+E[r]+")(?:\\.("+E[r]+")(?:\\.("+E[r]+")(?:"+E[v]+")?"+E[l]+"?)?)?";var g=P++;E[g]="^"+E[i]+"\\s*"+E[c]+"$";var C=P++;E[C]="^"+E[i]+"\\s*"+E[w]+"$";var U=P++;E[U]="(?:^|[^\\d])(\\d{1,16})(?:\\.(\\d{1,16}))?(?:\\.(\\d{1,16}))?(?:$|[^\\d])";var W=P++;E[W]="(?:~>?)";var M=P++;E[M]="(\\s*)"+E[W]+"\\s+",T[M]=new RegExp(E[M],"g");var S=P++;E[S]="^"+E[W]+E[c]+"$";var z=P++;E[z]="^"+E[W]+E[w]+"$";var $=P++;E[$]="(?:\\^)";var N=P++;E[N]="(\\s*)"+E[$]+"\\s+",T[N]=new RegExp(E[N],"g");var K=P++;E[K]="^"+E[$]+E[c]+"$";var V=P++;E[V]="^"+E[$]+E[w]+"$";var F=P++;E[F]="^"+E[i]+"\\s*("+u+")$|^$";var ne=P++;E[ne]="^"+E[i]+"\\s*("+s+")$|^$";var ce=P++;E[ce]="(\\s*)"+E[i]+"\\s*("+u+"|"+E[c]+")",T[ce]=new RegExp(E[ce],"g");var re=P++;E[re]="^\\s*("+E[c]+")\\s+-\\s+("+E[c]+")\\s*$";var fe=P++;E[fe]="^\\s*("+E[w]+")\\s+-\\s+("+E[w]+")\\s*$";var ie=P++;E[ie]="(<|>)?=?\\s*\\*";for(var Ee=0;Ee<35;Ee++)b(Ee,E[Ee]),T[Ee]||(T[Ee]=new RegExp(E[Ee]));function be(Z,pe){if(Z instanceof ee)return Z;if(typeof Z!="string"||Z.length>L||!(pe?T[n]:T[_]).test(Z))return null;try{return new ee(Z,pe)}catch{return null}}function ee(Z,pe){if(Z instanceof ee){if(Z.loose===pe)return Z;Z=Z.version}else if(typeof Z!="string")throw new TypeError("Invalid Version: "+Z);if(Z.length>L)throw new TypeError("version is longer than "+L+" characters");if(!(this instanceof ee))return new ee(Z,pe);b("SemVer",Z,pe),this.loose=pe;var ge=Z.trim().match(pe?T[n]:T[_]);if(!ge)throw new TypeError("Invalid Version: "+Z);if(this.raw=Z,this.major=+ge[1],this.minor=+ge[2],this.patch=+ge[3],this.major>D||this.major<0)throw new TypeError("Invalid major version");if(this.minor>D||this.minor<0)throw new TypeError("Invalid minor version");if(this.patch>D||this.patch<0)throw new TypeError("Invalid patch version");ge[4]?this.prerelease=ge[4].split(".").map(function(Ne){if(/^[0-9]+$/.test(Ne)){var Be=+Ne;if(Be>=0&&Be<D)return Be}return Ne}):this.prerelease=[],this.build=ge[5]?ge[5].split("."):[],this.format()}e.parse=be,e.valid=function(Z,pe){var ge=be(Z,pe);return ge?ge.version:null},e.clean=function(Z,pe){var ge=be(Z.trim().replace(/^[=v]+/,""),pe);return ge?ge.version:null},e.SemVer=ee,ee.prototype.format=function(){return this.version=this.major+"."+this.minor+"."+this.patch,this.prerelease.length&&(this.version+="-"+this.prerelease.join(".")),this.version},ee.prototype.toString=function(){return this.version},ee.prototype.compare=function(Z){return b("SemVer.compare",this.version,this.loose,Z),Z instanceof ee||(Z=new ee(Z,this.loose)),this.compareMain(Z)||this.comparePre(Z)},ee.prototype.compareMain=function(Z){return Z instanceof ee||(Z=new ee(Z,this.loose)),Ae(this.major,Z.major)||Ae(this.minor,Z.minor)||Ae(this.patch,Z.patch)},ee.prototype.comparePre=function(Z){if(Z instanceof ee||(Z=new ee(Z,this.loose)),this.prerelease.length&&!Z.prerelease.length)return-1;if(!this.prerelease.length&&Z.prerelease.length)return 1;if(!this.prerelease.length&&!Z.prerelease.length)return 0;var pe=0;do{var ge=this.prerelease[pe],Ne=Z.prerelease[pe];if(b("prerelease compare",pe,ge,Ne),ge===void 0&&Ne===void 0)return 0;if(Ne===void 0)return 1;if(ge===void 0)return-1;if(ge!==Ne)return Ae(ge,Ne)}while(++pe)},ee.prototype.inc=function(Z,pe){switch(Z){case"premajor":this.prerelease.length=0,this.patch=0,this.minor=0,this.major++,this.inc("pre",pe);break;case"preminor":this.prerelease.length=0,this.patch=0,this.minor++,this.inc("pre",pe);break;case"prepatch":this.prerelease.length=0,this.inc("patch",pe),this.inc("pre",pe);break;case"prerelease":this.prerelease.length===0&&this.inc("patch",pe),this.inc("pre",pe);break;case"major":this.minor===0&&this.patch===0&&this.prerelease.length!==0||this.major++,this.minor=0,this.patch=0,this.prerelease=[];break;case"minor":this.patch===0&&this.prerelease.length!==0||this.minor++,this.patch=0,this.prerelease=[];break;case"patch":this.prerelease.length===0&&this.patch++,this.prerelease=[];break;case"pre":if(this.prerelease.length===0)this.prerelease=[0];else{for(var ge=this.prerelease.length;--ge>=0;)typeof this.prerelease[ge]=="number"&&(this.prerelease[ge]++,ge=-2);ge===-1&&this.prerelease.push(0)}pe&&(this.prerelease[0]===pe?isNaN(this.prerelease[1])&&(this.prerelease=[pe,0]):this.prerelease=[pe,0]);break;default:throw new Error("invalid increment argument: "+Z)}return this.format(),this.raw=this.version,this},e.inc=function(Z,pe,ge,Ne){typeof ge=="string"&&(Ne=ge,ge=void 0);try{return new ee(Z,ge).inc(pe,Ne).version}catch{return null}},e.diff=function(Z,pe){if(Ie(Z,pe))return null;var ge=be(Z),Ne=be(pe);if(ge.prerelease.length||Ne.prerelease.length){for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return"pre"+Be;return"prerelease"}for(var Be in ge)if((Be==="major"||Be==="minor"||Be==="patch")&&ge[Be]!==Ne[Be])return Be},e.compareIdentifiers=Ae;var ve=/^[0-9]+$/;function Ae(Z,pe){var ge=ve.test(Z),Ne=ve.test(pe);return ge&&Ne&&(Z=+Z,pe=+pe),ge&&!Ne?-1:Ne&&!ge?1:Z<pe?-1:Z>pe?1:0}function Fe(Z,pe,ge){return new ee(Z,ge).compare(new ee(pe,ge))}function $e(Z,pe,ge){return Fe(Z,pe,ge)>0}function Qe(Z,pe,ge){return Fe(Z,pe,ge)<0}function Ie(Z,pe,ge){return Fe(Z,pe,ge)===0}function Se(Z,pe,ge){return Fe(Z,pe,ge)!==0}function Te(Z,pe,ge){return Fe(Z,pe,ge)>=0}function ae(Z,pe,ge){return Fe(Z,pe,ge)<=0}function le(Z,pe,ge,Ne){var Be;switch(pe){case"===":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Be=Z===ge;break;case"!==":typeof Z=="object"&&(Z=Z.version),typeof ge=="object"&&(ge=ge.version),Be=Z!==ge;break;case"":case"=":case"==":Be=Ie(Z,ge,Ne);break;case"!=":Be=Se(Z,ge,Ne);break;case">":Be=$e(Z,ge,Ne);break;case">=":Be=Te(Z,ge,Ne);break;case"<":Be=Qe(Z,ge,Ne);break;case"<=":Be=ae(Z,ge,Ne);break;default:throw new TypeError("Invalid operator: "+pe)}return Be}function X(Z,pe){if(Z instanceof X){if(Z.loose===pe)return Z;Z=Z.value}if(!(this instanceof X))return new X(Z,pe);b("comparator",Z,pe),this.loose=pe,this.parse(Z),this.semver===Y?this.value="":this.value=this.operator+this.semver.version,b("comp",this)}e.rcompareIdentifiers=function(Z,pe){return Ae(pe,Z)},e.major=function(Z,pe){return new ee(Z,pe).major},e.minor=function(Z,pe){return new ee(Z,pe).minor},e.patch=function(Z,pe){return new ee(Z,pe).patch},e.compare=Fe,e.compareLoose=function(Z,pe){return Fe(Z,pe,!0)},e.rcompare=function(Z,pe,ge){return Fe(pe,Z,ge)},e.sort=function(Z,pe){return Z.sort(function(ge,Ne){return e.compare(ge,Ne,pe)})},e.rsort=function(Z,pe){return Z.sort(function(ge,Ne){return e.rcompare(ge,Ne,pe)})},e.gt=$e,e.lt=Qe,e.eq=Ie,e.neq=Se,e.gte=Te,e.lte=ae,e.cmp=le,e.Comparator=X;var Y={};function k(Z,pe){if(Z instanceof k)return Z.loose===pe?Z:new k(Z.raw,pe);if(Z instanceof X)return new k(Z.value,pe);if(!(this instanceof k))return new k(Z,pe);if(this.loose=pe,this.raw=Z,this.set=Z.split(/\s*\|\|\s*/).map(function(ge){return this.parseRange(ge.trim())},this).filter(function(ge){return ge.length}),!this.set.length)throw new TypeError("Invalid SemVer Range: "+Z);this.format()}function B(Z){return!Z||Z.toLowerCase()==="x"||Z==="*"}function H(Z,pe,ge,Ne,Be,Ze,Ge,ke,nt,G,Q,he,Ue){return((pe=B(ge)?"":B(Ne)?">="+ge+".0.0":B(Be)?">="+ge+"."+Ne+".0":">="+pe)+" "+(ke=B(nt)?"":B(G)?"<"+(+nt+1)+".0.0":B(Q)?"<"+nt+"."+(+G+1)+".0":he?"<="+nt+"."+G+"."+Q+"-"+he:"<="+ke)).trim()}function j(Z,pe){for(var ge=0;ge<Z.length;ge++)if(!Z[ge].test(pe))return!1;if(pe.prerelease.length){for(ge=0;ge<Z.length;ge++)if(b(Z[ge].semver),Z[ge].semver!==Y&&Z[ge].semver.prerelease.length>0){var Ne=Z[ge].semver;if(Ne.major===pe.major&&Ne.minor===pe.minor&&Ne.patch===pe.patch)return!0}return!1}return!0}function oe(Z,pe,ge){try{pe=new k(pe,ge)}catch{return!1}return pe.test(Z)}function ue(Z,pe,ge,Ne){var Be,Ze,Ge,ke,nt;switch(Z=new ee(Z,Ne),pe=new k(pe,Ne),ge){case">":Be=$e,Ze=ae,Ge=Qe,ke=">",nt=">=";break;case"<":Be=Qe,Ze=Te,Ge=$e,ke="<",nt="<=";break;default:throw new TypeError('Must provide a hilo val of "<" or ">"')}if(oe(Z,pe,Ne))return!1;for(var G=0;G<pe.set.length;++G){var Q=pe.set[G],he=null,Ue=null;if(Q.forEach(function(We){We.semver===Y&&(We=new X(">=0.0.0")),he=he||We,Ue=Ue||We,Be(We.semver,he.semver,Ne)?he=We:Ge(We.semver,Ue.semver,Ne)&&(Ue=We)}),he.operator===ke||he.operator===nt||(!Ue.operator||Ue.operator===ke)&&Ze(Z,Ue.semver)||Ue.operator===nt&&Ge(Z,Ue.semver))return!1}return!0}X.prototype.parse=function(Z){var pe=this.loose?T[F]:T[ne],ge=Z.match(pe);if(!ge)throw new TypeError("Invalid comparator: "+Z);this.operator=ge[1],this.operator==="="&&(this.operator=""),ge[2]?this.semver=new ee(ge[2],this.loose):this.semver=Y},X.prototype.toString=function(){return this.value},X.prototype.test=function(Z){return b("Comparator.test",Z,this.loose),this.semver===Y||(typeof Z=="string"&&(Z=new ee(Z,this.loose)),le(Z,this.operator,this.semver,this.loose))},X.prototype.intersects=function(Z,pe){if(!(Z instanceof X))throw new TypeError("a Comparator is required");var ge;if(this.operator==="")return ge=new k(Z.value,pe),oe(this.value,ge,pe);if(Z.operator==="")return ge=new k(this.value,pe),oe(Z.semver,ge,pe);var Ne=!(this.operator!==">="&&this.operator!==">"||Z.operator!==">="&&Z.operator!==">"),Be=!(this.operator!=="<="&&this.operator!=="<"||Z.operator!=="<="&&Z.operator!=="<"),Ze=this.semver.version===Z.semver.version,Ge=!(this.operator!==">="&&this.operator!=="<="||Z.operator!==">="&&Z.operator!=="<="),ke=le(this.semver,"<",Z.semver,pe)&&(this.operator===">="||this.operator===">")&&(Z.operator==="<="||Z.operator==="<"),nt=le(this.semver,">",Z.semver,pe)&&(this.operator==="<="||this.operator==="<")&&(Z.operator===">="||Z.operator===">");return Ne||Be||Ze&&Ge||ke||nt},e.Range=k,k.prototype.format=function(){return this.range=this.set.map(function(Z){return Z.join(" ").trim()}).join("||").trim(),this.range},k.prototype.toString=function(){return this.range},k.prototype.parseRange=function(Z){var pe=this.loose;Z=Z.trim(),b("range",Z,pe);var ge=pe?T[fe]:T[re];Z=Z.replace(ge,H),b("hyphen replace",Z),Z=Z.replace(T[ce],"$1$2$3"),b("comparator trim",Z,T[ce]),Z=(Z=(Z=Z.replace(T[M],"$1~")).replace(T[N],"$1^")).split(/\s+/).join(" ");var Ne=pe?T[F]:T[ne],Be=Z.split(" ").map(function(Ze){return function(Ge,ke){return b("comp",Ge),Ge=function(nt,G){return nt.trim().split(/\s+/).map(function(Q){return function(he,Ue){b("caret",he,Ue);var We=Ue?T[V]:T[K];return he.replace(We,function(et,je,He,it,rt){var dt;return b("caret",he,et,je,He,it,rt),B(je)?dt="":B(He)?dt=">="+je+".0.0 <"+(+je+1)+".0.0":B(it)?dt=je==="0"?">="+je+"."+He+".0 <"+je+"."+(+He+1)+".0":">="+je+"."+He+".0 <"+(+je+1)+".0.0":rt?(b("replaceCaret pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),dt=je==="0"?He==="0"?">="+je+"."+He+"."+it+rt+" <"+je+"."+He+"."+(+it+1):">="+je+"."+He+"."+it+rt+" <"+je+"."+(+He+1)+".0":">="+je+"."+He+"."+it+rt+" <"+(+je+1)+".0.0"):(b("no pr"),dt=je==="0"?He==="0"?">="+je+"."+He+"."+it+" <"+je+"."+He+"."+(+it+1):">="+je+"."+He+"."+it+" <"+je+"."+(+He+1)+".0":">="+je+"."+He+"."+it+" <"+(+je+1)+".0.0"),b("caret return",dt),dt})}(Q,G)}).join(" ")}(Ge,ke),b("caret",Ge),Ge=function(nt,G){return nt.trim().split(/\s+/).map(function(Q){return function(he,Ue){var We=Ue?T[z]:T[S];return he.replace(We,function(et,je,He,it,rt){var dt;return b("tilde",he,et,je,He,it,rt),B(je)?dt="":B(He)?dt=">="+je+".0.0 <"+(+je+1)+".0.0":B(it)?dt=">="+je+"."+He+".0 <"+je+"."+(+He+1)+".0":rt?(b("replaceTilde pr",rt),rt.charAt(0)!=="-"&&(rt="-"+rt),dt=">="+je+"."+He+"."+it+rt+" <"+je+"."+(+He+1)+".0"):dt=">="+je+"."+He+"."+it+" <"+je+"."+(+He+1)+".0",b("tilde return",dt),dt})}(Q,G)}).join(" ")}(Ge,ke),b("tildes",Ge),Ge=function(nt,G){return b("replaceXRanges",nt,G),nt.split(/\s+/).map(function(Q){return function(he,Ue){he=he.trim();var We=Ue?T[C]:T[g];return he.replace(We,function(et,je,He,it,rt,dt){b("xRange",he,et,je,He,it,rt,dt);var lt=B(He),st=lt||B(it),yt=st||B(rt);return je==="="&&yt&&(je=""),lt?et=je===">"||je==="<"?"<0.0.0":"*":je&&yt?(st&&(it=0),yt&&(rt=0),je===">"?(je=">=",st?(He=+He+1,it=0,rt=0):yt&&(it=+it+1,rt=0)):je==="<="&&(je="<",st?He=+He+1:it=+it+1),et=je+He+"."+it+"."+rt):st?et=">="+He+".0.0 <"+(+He+1)+".0.0":yt&&(et=">="+He+"."+it+".0 <"+He+"."+(+it+1)+".0"),b("xRange return",et),et})}(Q,G)}).join(" ")}(Ge,ke),b("xrange",Ge),Ge=function(nt,G){return b("replaceStars",nt,G),nt.trim().replace(T[ie],"")}(Ge,ke),b("stars",Ge),Ge}(Ze,pe)}).join(" ").split(/\s+/);return this.loose&&(Be=Be.filter(function(Ze){return!!Ze.match(Ne)})),Be=Be.map(function(Ze){return new X(Ze,pe)})},k.prototype.intersects=function(Z,pe){if(!(Z instanceof k))throw new TypeError("a Range is required");return this.set.some(function(ge){return ge.every(function(Ne){return Z.set.some(function(Be){return Be.every(function(Ze){return Ne.intersects(Ze,pe)})})})})},e.toComparators=function(Z,pe){return new k(Z,pe).set.map(function(ge){return ge.map(function(Ne){return Ne.value}).join(" ").trim().split(" ")})},k.prototype.test=function(Z){if(!Z)return!1;typeof Z=="string"&&(Z=new ee(Z,this.loose));for(var pe=0;pe<this.set.length;pe++)if(j(this.set[pe],Z))return!0;return!1},e.satisfies=oe,e.maxSatisfying=function(Z,pe,ge){var Ne=null,Be=null;try{var Ze=new k(pe,ge)}catch{return null}return Z.forEach(function(Ge){Ze.test(Ge)&&(Ne&&Be.compare(Ge)!==-1||(Be=new ee(Ne=Ge,ge)))}),Ne},e.minSatisfying=function(Z,pe,ge){var Ne=null,Be=null;try{var Ze=new k(pe,ge)}catch{return null}return Z.forEach(function(Ge){Ze.test(Ge)&&(Ne&&Be.compare(Ge)!==1||(Be=new ee(Ne=Ge,ge)))}),Ne},e.validRange=function(Z,pe){try{return new k(Z,pe).range||"*"}catch{return null}},e.ltr=function(Z,pe,ge){return ue(Z,pe,"<",ge)},e.gtr=function(Z,pe,ge){return ue(Z,pe,">",ge)},e.outside=ue,e.prerelease=function(Z,pe){var ge=be(Z,pe);return ge&&ge.prerelease.length?ge.prerelease:null},e.intersects=function(Z,pe,ge){return Z=new k(Z,ge),pe=new k(pe,ge),Z.intersects(pe)},e.coerce=function(Z){if(Z instanceof ee)return Z;if(typeof Z!="string")return null;var pe=Z.match(T[U]);return pe==null?null:be((pe[1]||"0")+"."+(pe[2]||"0")+"."+(pe[3]||"0"))}}).call(this,o(1))},function(te,e){var o,p,b=te.exports={};function L(){throw new Error("setTimeout has not been defined")}function D(){throw new Error("clearTimeout has not been defined")}function T(d){if(o===setTimeout)return setTimeout(d,0);if((o===L||!o)&&setTimeout)return o=setTimeout,setTimeout(d,0);try{return o(d,0)}catch{try{return o.call(null,d,0)}catch{return o.call(this,d,0)}}}(function(){try{o=typeof setTimeout=="function"?setTimeout:L}catch{o=L}try{p=typeof clearTimeout=="function"?clearTimeout:D}catch{p=D}})();var E,P=[],R=!1,y=-1;function m(){R&&E&&(R=!1,E.length?P=E.concat(P):y=-1,P.length&&I())}function I(){if(!R){var d=T(m);R=!0;for(var a=P.length;a;){for(E=P,P=[];++y<a;)E&&E[y].run();y=-1,a=P.length}E=null,R=!1,function(v){if(p===clearTimeout)return clearTimeout(v);if((p===D||!p)&&clearTimeout)return p=clearTimeout,clearTimeout(v);try{p(v)}catch{try{return p.call(null,v)}catch{return p.call(this,v)}}}(d)}}function f(d,a){this.fun=d,this.array=a}function h(){}b.nextTick=function(d){var a=new Array(arguments.length-1);if(arguments.length>1)for(var v=1;v<arguments.length;v++)a[v-1]=arguments[v];P.push(new f(d,a)),P.length!==1||R||T(I)},f.prototype.run=function(){this.fun.apply(null,this.array)},b.title="browser",b.browser=!0,b.env={},b.argv=[],b.version="",b.versions={},b.on=h,b.addListener=h,b.once=h,b.off=h,b.removeListener=h,b.removeAllListeners=h,b.emit=h,b.prependListener=h,b.prependOnceListener=h,b.listeners=function(d){return[]},b.binding=function(d){throw new Error("process.binding is not supported")},b.cwd=function(){return"/"},b.chdir=function(d){throw new Error("process.chdir is not supported")},b.umask=function(){return 0}}])}),define(De[107],Ce([1,0,11,7]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.prefixedStream=e.prefixedReadable=e.transform=e.toReadable=e.emptyStream=e.toStream=e.peekStream=e.listenStream=e.consumeStream=e.peekReadable=e.consumeReadable=e.newWriteableStream=e.isReadableBufferedStream=e.isReadableStream=e.isReadable=void 0;function b(l){const _=l;return _?typeof _.read=="function":!1}e.isReadable=b;function L(l){const _=l;return _?[_.on,_.pause,_.resume,_.destroy].every(s=>typeof s=="function"):!1}e.isReadableStream=L;function D(l){const _=l;return _?L(_.stream)&&Array.isArray(_.buffer)&&typeof _.ended=="boolean":!1}e.isReadableBufferedStream=D;function T(l,_){return new E(l,_)}e.newWriteableStream=T;class E{constructor(_,s){this.reducer=_,this.options=s,this.state={flowing:!1,ended:!1,destroyed:!1},this.buffer={data:[],error:[]},this.listeners={data:[],error:[],end:[]},this.pendingWritePromises=[]}pause(){this.state.destroyed||(this.state.flowing=!1)}resume(){this.state.destroyed||this.state.flowing||(this.state.flowing=!0,this.flowData(),this.flowErrors(),this.flowEnd())}write(_){if(!this.state.destroyed){if(this.state.flowing)this.emitData(_);else if(this.buffer.data.push(_),typeof this.options?.highWaterMark=="number"&&this.buffer.data.length>this.options.highWaterMark)return new Promise(s=>this.pendingWritePromises.push(s))}}error(_){this.state.destroyed||(this.state.flowing?this.emitError(_):this.buffer.error.push(_))}end(_){this.state.destroyed||(typeof _!="undefined"&&this.write(_),this.state.flowing?(this.emitEnd(),this.destroy()):this.state.ended=!0)}emitData(_){this.listeners.data.slice(0).forEach(s=>s(_))}emitError(_){this.listeners.error.length===0?(0,o.onUnexpectedError)(_):this.listeners.error.slice(0).forEach(s=>s(_))}emitEnd(){this.listeners.end.slice(0).forEach(_=>_())}on(_,s){if(!this.state.destroyed)switch(_){case"data":this.listeners.data.push(s),this.resume();break;case"end":this.listeners.end.push(s),this.state.flowing&&this.flowEnd()&&this.destroy();break;case"error":this.listeners.error.push(s),this.state.flowing&&this.flowErrors();break}}removeListener(_,s){if(this.state.destroyed)return;let u;switch(_){case"data":u=this.listeners.data;break;case"end":u=this.listeners.end;break;case"error":u=this.listeners.error;break}if(u){const n=u.indexOf(s);n>=0&&u.splice(n,1)}}flowData(){if(this.buffer.data.length>0){const _=this.reducer(this.buffer.data);this.emitData(_),this.buffer.data.length=0;const s=[...this.pendingWritePromises];this.pendingWritePromises.length=0,s.forEach(u=>u())}}flowErrors(){if(this.listeners.error.length>0){for(const _ of this.buffer.error)this.emitError(_);this.buffer.error.length=0}}flowEnd(){return this.state.ended?(this.emitEnd(),this.listeners.end.length>0):!1}destroy(){this.state.destroyed||(this.state.destroyed=!0,this.state.ended=!0,this.buffer.data.length=0,this.buffer.error.length=0,this.listeners.data.length=0,this.listeners.error.length=0,this.listeners.end.length=0,this.pendingWritePromises.length=0)}}function P(l,_){const s=[];let u;for(;(u=l.read())!==null;)s.push(u);return _(s)}e.consumeReadable=P;function R(l,_,s){const u=[];let n;for(;(n=l.read())!==null&&u.length<s;)u.push(n);return n===null&&u.length>0?_(u):{read:()=>{if(u.length>0)return u.shift();if(typeof n!="undefined"){const i=n;return n=void 0,i}return l.read()}}}e.peekReadable=R;function y(l,_){return new Promise((s,u)=>{const n=[];m(l,{onData:i=>{_&&n.push(i)},onError:i=>{_?u(i):s(void 0)},onEnd:()=>{s(_?_(n):void 0)}})})}e.consumeStream=y;function m(l,_){let s=!1;return l.on("error",u=>{s||_.onError(u)}),l.on("end",()=>{s||_.onEnd()}),l.on("data",u=>{s||_.onData(u)}),(0,p.toDisposable)(()=>s=!0)}e.listenStream=m;function I(l,_){return new Promise((s,u)=>{const n=new p.DisposableStore,i=[],r=w=>{if(i.push(w),i.length>_)return n.dispose(),l.pause(),s({stream:l,buffer:i,ended:!1})},t=w=>u(w),c=()=>s({stream:l,buffer:i,ended:!0});n.add((0,p.toDisposable)(()=>l.removeListener("error",t))),l.on("error",t),n.add((0,p.toDisposable)(()=>l.removeListener("end",c))),l.on("end",c),n.add((0,p.toDisposable)(()=>l.removeListener("data",r))),l.on("data",r)})}e.peekStream=I;function f(l,_){const s=T(_);return s.end(l),s}e.toStream=f;function h(){const l=T(()=>{throw new Error("not supported")});return l.end(),l}e.emptyStream=h;function d(l){let _=!1;return{read:()=>_?null:(_=!0,l)}}e.toReadable=d;function a(l,_,s){const u=T(s);return m(l,{onData:n=>u.write(_.data(n)),onError:n=>u.error(_.error?_.error(n):n),onEnd:()=>u.end()}),u}e.transform=a;function v(l,_,s){let u=!1;return{read:()=>{const n=_.read();return u?n:(u=!0,n!==null?s([l,n]):l)}}}e.prefixedReadable=v;function A(l,_,s){let u=!1;const n=T(s);return m(_,{onData:i=>u?n.write(i):(u=!0,n.write(s([l,i]))),onError:i=>n.error(i),onEnd:()=>{u||(u=!0,n.write(l)),n.end()}}),n}e.prefixedStream=A}),define(De[22],Ce([1,0,107]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.encodeBase64=e.decodeBase64=e.prefixedBufferStream=e.prefixedBufferReadable=e.newWriteableBufferStream=e.streamToBufferReadableStream=e.bufferToStream=e.bufferedStreamToBuffer=e.streamToBuffer=e.bufferToReadable=e.readableToBuffer=e.writeUInt8=e.readUInt8=e.writeUInt32LE=e.readUInt32LE=e.writeUInt32BE=e.readUInt32BE=e.writeUInt16LE=e.readUInt16LE=e.VSBuffer=void 0;const p=typeof Buffer!="undefined";let b,L;class D{constructor(w){this.buffer=w,this.byteLength=this.buffer.byteLength}static alloc(w){return p?new D(Buffer.allocUnsafe(w)):new D(new Uint8Array(w))}static wrap(w){return p&&!Buffer.isBuffer(w)&&(w=Buffer.from(w.buffer,w.byteOffset,w.byteLength)),new D(w)}static fromString(w,g){return!(g?.dontUseNodeBuffer||!1)&&p?new D(Buffer.from(w)):(b||(b=new TextEncoder),new D(b.encode(w)))}static fromByteArray(w){const g=D.alloc(w.length);for(let C=0,U=w.length;C<U;C++)g.buffer[C]=w[C];return g}static concat(w,g){if(typeof g=="undefined"){g=0;for(let W=0,M=w.length;W<M;W++)g+=w[W].byteLength}const C=D.alloc(g);let U=0;for(let W=0,M=w.length;W<M;W++){const S=w[W];C.set(S,U),U+=S.byteLength}return C}clone(){const w=D.alloc(this.byteLength);return w.set(this),w}toString(){return p?this.buffer.toString():(L||(L=new TextDecoder),L.decode(this.buffer))}slice(w,g){return new D(this.buffer.subarray(w,g))}set(w,g){if(w instanceof D)this.buffer.set(w.buffer,g);else if(w instanceof Uint8Array)this.buffer.set(w,g);else if(w instanceof ArrayBuffer)this.buffer.set(new Uint8Array(w),g);else if(ArrayBuffer.isView(w))this.buffer.set(new Uint8Array(w.buffer,w.byteOffset,w.byteLength),g);else throw new Error("Unknown argument 'array'")}readUInt32BE(w){return P(this.buffer,w)}writeUInt32BE(w,g){R(this.buffer,w,g)}readUInt32LE(w){return y(this.buffer,w)}writeUInt32LE(w,g){m(this.buffer,w,g)}readUInt8(w){return I(this.buffer,w)}writeUInt8(w,g){f(this.buffer,w,g)}}e.VSBuffer=D;function T(c,w){return c[w+0]<<0>>>0|c[w+1]<<8>>>0}e.readUInt16LE=T;function E(c,w,g){c[g+0]=w&255,w=w>>>8,c[g+1]=w&255}e.writeUInt16LE=E;function P(c,w){return c[w]*2**24+c[w+1]*2**16+c[w+2]*2**8+c[w+3]}e.readUInt32BE=P;function R(c,w,g){c[g+3]=w,w=w>>>8,c[g+2]=w,w=w>>>8,c[g+1]=w,w=w>>>8,c[g]=w}e.writeUInt32BE=R;function y(c,w){return c[w+0]<<0>>>0|c[w+1]<<8>>>0|c[w+2]<<16>>>0|c[w+3]<<24>>>0}e.readUInt32LE=y;function m(c,w,g){c[g+0]=w&255,w=w>>>8,c[g+1]=w&255,w=w>>>8,c[g+2]=w&255,w=w>>>8,c[g+3]=w&255}e.writeUInt32LE=m;function I(c,w){return c[w]}e.readUInt8=I;function f(c,w,g){c[g]=w}e.writeUInt8=f;function h(c){return o.consumeReadable(c,w=>D.concat(w))}e.readableToBuffer=h;function d(c){return o.toReadable(c)}e.bufferToReadable=d;function a(c){return o.consumeStream(c,w=>D.concat(w))}e.streamToBuffer=a;async function v(c){return c.ended?D.concat(c.buffer):D.concat([...c.buffer,await a(c.stream)])}e.bufferedStreamToBuffer=v;function A(c){return o.toStream(c,w=>D.concat(w))}e.bufferToStream=A;function l(c){return o.transform(c,{data:w=>typeof w=="string"?D.fromString(w):D.wrap(w)},w=>D.concat(w))}e.streamToBufferReadableStream=l;function _(c){return o.newWriteableStream(w=>D.concat(w),c)}e.newWriteableBufferStream=_;function s(c,w){return o.prefixedReadable(c,w,g=>D.concat(g))}e.prefixedBufferReadable=s;function u(c,w){return o.prefixedStream(c,w,g=>D.concat(g))}e.prefixedBufferStream=u;function n(c){let w=0,g=0,C=0;const U=new Uint8Array(Math.floor(c.length/4*3)),W=S=>{switch(g){case 3:U[C++]=w|S,g=0;break;case 2:U[C++]=w|S>>>2,w=S<<6,g=3;break;case 1:U[C++]=w|S>>>4,w=S<<4,g=2;break;default:w=S<<2,g=1}};for(let S=0;S<c.length;S++){const z=c.charCodeAt(S);if(z>=65&&z<=90)W(z-65);else if(z>=97&&z<=122)W(z-97+26);else if(z>=48&&z<=57)W(z-48+52);else if(z===43||z===45)W(62);else if(z===47||z===95)W(63);else{if(z===61)break;throw new SyntaxError(`Unexpected base64 character ${c[S]}`)}}const M=C;for(;g>0;)W(0);return D.wrap(U).slice(0,M)}e.decodeBase64=n;const i="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",r="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789-_";function t({buffer:c},w=!0,g=!1){const C=g?r:i;let U="";const W=c.byteLength%3;let M=0;for(;M<c.byteLength-W;M+=3){const S=c[M+0],z=c[M+1],$=c[M+2];U+=C[S>>>2],U+=C[(S<<4|z>>>4)&63],U+=C[(z<<2|$>>>6)&63],U+=C[$&63]}if(W===1){const S=c[M+0];U+=C[S>>>2],U+=C[S<<4&63],w&&(U+="==")}else if(W===2){const S=c[M+0],z=c[M+1];U+=C[S>>>2],U+=C[(S<<4|z>>>4)&63],U+=C[z<<2&63],w&&(U+="=")}return U}e.encodeBase64=t}),define(De[42],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.generateUuid=e.isUUID=void 0;const o=/^[0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12}$/i;function p(b){return o.test(b)}e.isUUID=p,e.generateUuid=function(){if(typeof crypto=="object"&&typeof crypto.randomUUID=="function")return crypto.randomUUID.bind(crypto);let b;typeof crypto=="object"&&typeof crypto.getRandomValues=="function"?b=crypto.getRandomValues.bind(crypto):b=function(T){for(let E=0;E<T.length;E++)T[E]=Math.floor(Math.random()*256);return T};const L=new Uint8Array(16),D=[];for(let T=0;T<256;T++)D.push(T.toString(16).padStart(2,"0"));return function(){b(L),L[6]=L[6]&15|64,L[8]=L[8]&63|128;let E=0,P="";return P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+="-",P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P+=D[L[E++]],P}}()}),define(De[108],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EDITOR_MODEL_DEFAULTS=void 0,e.EDITOR_MODEL_DEFAULTS={tabSize:4,indentSize:4,insertSpaces:!0,detectIndentation:!0,trimAutoWhitespace:!0,largeFileOptimizations:!0,bracketPairColorizationOptions:{enabled:!0,independentColorPoolPerBracketType:!1}}}),define(De[109],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AutoClosingPairs=e.StandardAutoClosingPairConditional=e.IndentAction=void 0;var o;(function(D){D[D.None=0]="None",D[D.Indent=1]="Indent",D[D.IndentOutdent=2]="IndentOutdent",D[D.Outdent=3]="Outdent"})(o=e.IndentAction||(e.IndentAction={}));class p{constructor(T){if(this._neutralCharacter=null,this._neutralCharacterSearched=!1,this.open=T.open,this.close=T.close,this._inString=!0,this._inComment=!0,this._inRegEx=!0,Array.isArray(T.notIn))for(let E=0,P=T.notIn.length;E<P;E++)switch(T.notIn[E]){case"string":this._inString=!1;break;case"comment":this._inComment=!1;break;case"regex":this._inRegEx=!1;break}}isOK(T){switch(T){case 0:return!0;case 1:return this._inComment;case 2:return this._inString;case 3:return this._inRegEx}}shouldAutoClose(T,E){if(T.getTokenCount()===0)return!0;const P=T.findTokenIndexAtOffset(E-2),R=T.getStandardTokenType(P);return this.isOK(R)}_findNeutralCharacterInRange(T,E){for(let P=T;P<=E;P++){const R=String.fromCharCode(P);if(!this.open.includes(R)&&!this.close.includes(R))return R}return null}findNeutralCharacter(){return this._neutralCharacterSearched||(this._neutralCharacterSearched=!0,this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(48,57)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(97,122)),this._neutralCharacter||(this._neutralCharacter=this._findNeutralCharacterInRange(65,90))),this._neutralCharacter}}e.StandardAutoClosingPairConditional=p;class b{constructor(T){this.autoClosingPairsOpenByStart=new Map,this.autoClosingPairsOpenByEnd=new Map,this.autoClosingPairsCloseByStart=new Map,this.autoClosingPairsCloseByEnd=new Map,this.autoClosingPairsCloseSingleChar=new Map;for(const E of T)L(this.autoClosingPairsOpenByStart,E.open.charAt(0),E),L(this.autoClosingPairsOpenByEnd,E.open.charAt(E.open.length-1),E),L(this.autoClosingPairsCloseByStart,E.close.charAt(0),E),L(this.autoClosingPairsCloseByEnd,E.close.charAt(E.close.length-1),E),E.close.length===1&&E.open.length===1&&L(this.autoClosingPairsCloseSingleChar,E.close,E)}}e.AutoClosingPairs=b;function L(D,T,E){D.has(T)?D.get(T).push(E):D.set(T,[E])}}),define(De[110],Ce([17,18]),function(te,e){return te.create("vs/base/common/date",e)}),define(De[111],Ce([1,0,110]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalISOString=e.fromNow=void 0;const p=60,b=p*60,L=b*24,D=L*7,T=L*30,E=L*365;function P(y,m,I){typeof y!="number"&&(y=y.getTime());const f=Math.round((new Date().getTime()-y)/1e3);if(f<-30)return(0,o.localize)(0,null,P(new Date().getTime()+f*1e3,!1));if(f<30)return(0,o.localize)(1,null);let h;return f<p?(h=f,m?h===1?I?(0,o.localize)(2,null,h):(0,o.localize)(3,null,h):I?(0,o.localize)(4,null,h):(0,o.localize)(5,null,h):h===1?I?(0,o.localize)(6,null,h):(0,o.localize)(7,null,h):I?(0,o.localize)(8,null,h):(0,o.localize)(9,null,h)):f<b?(h=Math.floor(f/p),m?h===1?I?(0,o.localize)(10,null,h):(0,o.localize)(11,null,h):I?(0,o.localize)(12,null,h):(0,o.localize)(13,null,h):h===1?I?(0,o.localize)(14,null,h):(0,o.localize)(15,null,h):I?(0,o.localize)(16,null,h):(0,o.localize)(17,null,h)):f<L?(h=Math.floor(f/b),m?h===1?I?(0,o.localize)(18,null,h):(0,o.localize)(19,null,h):I?(0,o.localize)(20,null,h):(0,o.localize)(21,null,h):h===1?I?(0,o.localize)(22,null,h):(0,o.localize)(23,null,h):I?(0,o.localize)(24,null,h):(0,o.localize)(25,null,h)):f<D?(h=Math.floor(f/L),m?h===1?(0,o.localize)(26,null,h):(0,o.localize)(27,null,h):h===1?(0,o.localize)(28,null,h):(0,o.localize)(29,null,h)):f<T?(h=Math.floor(f/D),m?h===1?I?(0,o.localize)(30,null,h):(0,o.localize)(31,null,h):I?(0,o.localize)(32,null,h):(0,o.localize)(33,null,h):h===1?I?(0,o.localize)(34,null,h):(0,o.localize)(35,null,h):I?(0,o.localize)(36,null,h):(0,o.localize)(37,null,h)):f<E?(h=Math.floor(f/T),m?h===1?I?(0,o.localize)(38,null,h):(0,o.localize)(39,null,h):I?(0,o.localize)(40,null,h):(0,o.localize)(41,null,h):h===1?I?(0,o.localize)(42,null,h):(0,o.localize)(43,null,h):I?(0,o.localize)(44,null,h):(0,o.localize)(45,null,h)):(h=Math.floor(f/E),m?h===1?I?(0,o.localize)(46,null,h):(0,o.localize)(47,null,h):I?(0,o.localize)(48,null,h):(0,o.localize)(49,null,h):h===1?I?(0,o.localize)(50,null,h):(0,o.localize)(51,null,h):I?(0,o.localize)(52,null,h):(0,o.localize)(53,null,h))}e.fromNow=P;function R(y){return y.getFullYear()+"-"+String(y.getMonth()+1).padStart(2,"0")+"-"+String(y.getDate()).padStart(2,"0")+"T"+String(y.getHours()).padStart(2,"0")+":"+String(y.getMinutes()).padStart(2,"0")+":"+String(y.getSeconds()).padStart(2,"0")+"."+(y.getMilliseconds()/1e3).toFixed(3).slice(2,5)+"Z"}e.toLocalISOString=R}),define(De[112],Ce([17,18]),function(te,e){return te.create("vs/base/common/errorMessage",e)}),define(De[43],Ce([1,0,16,10,112]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createErrorWithActions=e.isErrorWithActions=e.toErrorMessage=void 0;function L(y,m){return m&&(y.stack||y.stacktrace)?b.localize(0,null,T(y),D(y.stack)||D(y.stacktrace)):T(y)}function D(y){return Array.isArray(y)?y.join(`
`):y}function T(y){return typeof y.code=="string"&&typeof y.errno=="number"&&typeof y.syscall=="string"?b.localize(1,null,y.message):y.message||b.localize(2,null)}function E(y=null,m=!1){if(!y)return b.localize(3,null);if(Array.isArray(y)){const I=o.coalesce(y),f=E(I[0],m);return I.length>1?b.localize(4,null,f,I.length):f}if(p.isString(y))return y;if(y.detail){const I=y.detail;if(I.error)return L(I.error,m);if(I.exception)return L(I.exception,m)}return y.stack?L(y,m):y.message?y.message:b.localize(5,null)}e.toErrorMessage=E;function P(y){const m=y;return m instanceof Error&&Array.isArray(m.actions)}e.isErrorWithActions=P;function R(y,m){let I;return typeof y=="string"?I=new Error(y):I=y,I.actions=m,I}e.createErrorWithActions=R}),define(De[74],Ce([1,0,19]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.normalizeMimeType=e.getExtensionForMimeType=e.getMediaMime=e.getMediaOrTextMime=e.Mimes=void 0,e.Mimes=Object.freeze({text:"text/plain",binary:"application/octet-stream",unknown:"application/unknown",markdown:"text/markdown",latex:"text/latex",uriList:"text/uri-list"});const p={".css":"text/css",".csv":"text/csv",".htm":"text/html",".html":"text/html",".ics":"text/calendar",".js":"text/javascript",".mjs":"text/javascript",".txt":"text/plain",".xml":"text/xml"},b={".aac":"audio/x-aac",".avi":"video/x-msvideo",".bmp":"image/bmp",".flv":"video/x-flv",".gif":"image/gif",".ico":"image/x-icon",".jpe":"image/jpg",".jpeg":"image/jpg",".jpg":"image/jpg",".m1v":"video/mpeg",".m2a":"audio/mpeg",".m2v":"video/mpeg",".m3a":"audio/mpeg",".mid":"audio/midi",".midi":"audio/midi",".mk3d":"video/x-matroska",".mks":"video/x-matroska",".mkv":"video/x-matroska",".mov":"video/quicktime",".movie":"video/x-sgi-movie",".mp2":"audio/mpeg",".mp2a":"audio/mpeg",".mp3":"audio/mpeg",".mp4":"video/mp4",".mp4a":"audio/mp4",".mp4v":"video/mp4",".mpe":"video/mpeg",".mpeg":"video/mpeg",".mpg":"video/mpeg",".mpg4":"video/mp4",".mpga":"audio/mpeg",".oga":"audio/ogg",".ogg":"audio/ogg",".opus":"audio/opus",".ogv":"video/ogg",".png":"image/png",".psd":"image/vnd.adobe.photoshop",".qt":"video/quicktime",".spx":"audio/ogg",".svg":"image/svg+xml",".tga":"image/x-tga",".tif":"image/tiff",".tiff":"image/tiff",".wav":"audio/x-wav",".webm":"video/webm",".webp":"image/webp",".wma":"audio/x-ms-wma",".wmv":"video/x-ms-wmv",".woff":"application/font-woff"};function L(R){const y=(0,o.extname)(R),m=p[y.toLowerCase()];return m!==void 0?m:D(R)}e.getMediaOrTextMime=L;function D(R){const y=(0,o.extname)(R);return b[y.toLowerCase()]}e.getMediaMime=D;function T(R){for(const y in b)if(b[y]===R)return y}e.getExtensionForMimeType=T;const E=/^(.+)\/(.+?)(;.+)?$/;function P(R,y){const m=E.exec(R);return m?`${m[1].toLowerCase()}/${m[2].toLowerCase()}${m[3]??""}`:y?void 0:R}e.normalizeMimeType=P}),define(De[37],Ce([1,0,19,23,9,10]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.randomPath=e.parseLineAndColumnAware=e.indexOfPath=e.getDriveLetter=e.hasDriveLetter=e.isRootOrDriveLetter=e.sanitizeFilePath=e.isWindowsDriveLetter=e.isEqualOrParent=e.isEqual=e.isValidBasename=e.isUNC=e.getRoot=e.toPosixPath=e.toSlashes=e.isPathSeparator=void 0;function D(r){return r===47||r===92}e.isPathSeparator=D;function T(r){return r.replace(/[\\/]/g,o.posix.sep)}e.toSlashes=T;function E(r){return r.indexOf("/")===-1&&(r=T(r)),/^[a-zA-Z]:(\/|$)/.test(r)&&(r="/"+r),r}e.toPosixPath=E;function P(r,t=o.posix.sep){if(!r)return"";const c=r.length,w=r.charCodeAt(0);if(D(w)){if(D(r.charCodeAt(1))&&!D(r.charCodeAt(2))){let C=3;const U=C;for(;C<c&&!D(r.charCodeAt(C));C++);if(U!==C&&!D(r.charCodeAt(C+1))){for(C+=1;C<c;C++)if(D(r.charCodeAt(C)))return r.slice(0,C+1).replace(/[\\/]/g,t)}}return t}else if(a(w)&&r.charCodeAt(1)===58)return D(r.charCodeAt(2))?r.slice(0,2)+t:r.slice(0,2);let g=r.indexOf("://");if(g!==-1){for(g+=3;g<c;g++)if(D(r.charCodeAt(g)))return r.slice(0,g+1)}return""}e.getRoot=P;function R(r){if(!p.isWindows||!r||r.length<5)return!1;let t=r.charCodeAt(0);if(t!==92||(t=r.charCodeAt(1),t!==92))return!1;let c=2;const w=c;for(;c<r.length&&(t=r.charCodeAt(c),t!==92);c++);return!(w===c||(t=r.charCodeAt(c+1),isNaN(t)||t===92))}e.isUNC=R;const y=/[\\/:\*\?"<>\|]/g,m=/[\\/]/g,I=/^(con|prn|aux|clock\$|nul|lpt[0-9]|com[0-9])(\.(.*?))?$/i;function f(r,t=p.isWindows){const c=t?y:m;return!(!r||r.length===0||/^\s+$/.test(r)||(c.lastIndex=0,c.test(r))||t&&I.test(r)||r==="."||r===".."||t&&r[r.length-1]==="."||t&&r.length!==r.trim().length||r.length>255)}e.isValidBasename=f;function h(r,t,c){const w=r===t;return!c||w?w:!r||!t?!1:(0,b.equalsIgnoreCase)(r,t)}e.isEqual=h;function d(r,t,c,w=o.sep){if(r===t)return!0;if(!r||!t||t.length>r.length)return!1;if(c){if(!(0,b.startsWithIgnoreCase)(r,t))return!1;if(t.length===r.length)return!0;let C=t.length;return t.charAt(t.length-1)===w&&C--,r.charAt(C)===w}return t.charAt(t.length-1)!==w&&(t+=w),r.indexOf(t)===0}e.isEqualOrParent=d;function a(r){return r>=65&&r<=90||r>=97&&r<=122}e.isWindowsDriveLetter=a;function v(r,t){return p.isWindows&&r.endsWith(":")&&(r+=o.sep),(0,o.isAbsolute)(r)||(r=(0,o.join)(t,r)),r=(0,o.normalize)(r),p.isWindows?(r=(0,b.rtrim)(r,o.sep),r.endsWith(":")&&(r+=o.sep)):(r=(0,b.rtrim)(r,o.sep),r||(r=o.sep)),r}e.sanitizeFilePath=v;function A(r){const t=(0,o.normalize)(r);return p.isWindows?r.length>3?!1:l(t)&&(r.length===2||t.charCodeAt(2)===92):t===o.posix.sep}e.isRootOrDriveLetter=A;function l(r,t=p.isWindows){return t?a(r.charCodeAt(0))&&r.charCodeAt(1)===58:!1}e.hasDriveLetter=l;function _(r){return l(r)?r[0]:void 0}e.getDriveLetter=_;function s(r,t,c){return t.length>r.length?-1:r===t?0:(c&&(r=r.toLowerCase(),t=t.toLowerCase()),r.indexOf(t))}e.indexOfPath=s;function u(r){const t=r.split(":");let c,w,g;for(const C of t){const U=Number(C);(0,L.isNumber)(U)?w===void 0?w=U:g===void 0&&(g=U):c=c?[c,C].join(":"):C}if(!c)throw new Error("Format for `--goto` should be: `FILE:LINE(:COLUMN)`");return{path:c,line:w!==void 0?w:void 0,column:g!==void 0?g:w!==void 0?1:void 0}}e.parseLineAndColumnAware=u;const n="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789";function i(r,t,c=8){let w="";for(let C=0;C<c;C++)w+=n.charAt(Math.floor(Math.random()*n.length));let g;return t?g=`${t}-${w}`:g=w,r?(0,o.join)(r,g):g}e.randomPath=i}),define(De[25],Ce([1,0,16,9]),function(te,e,o,p){"use strict";var b,L,D;Object.defineProperty(e,"__esModule",{value:!0}),e.LRUCache=e.LinkedMap=e.Touch=e.ResourceSet=e.ResourceMap=e.TernarySearchTree=e.UriIterator=e.PathIterator=e.ConfigKeysIterator=e.StringIterator=e.setToString=e.mapToString=e.getOrSet=void 0;function T(n,i,r){let t=n.get(i);return t===void 0&&(t=r,n.set(i,t)),t}e.getOrSet=T;function E(n){const i=[];return n.forEach((r,t)=>{i.push(`${t} => ${r}`)}),`Map(${n.size}) {${i.join(", ")}}`}e.mapToString=E;function P(n){const i=[];return n.forEach(r=>{i.push(r)}),`Set(${n.size}) {${i.join(", ")}}`}e.setToString=P;class R{constructor(){this._value="",this._pos=0}reset(i){return this._value=i,this._pos=0,this}next(){return this._pos+=1,this}hasNext(){return this._pos<this._value.length-1}cmp(i){const r=i.charCodeAt(0),t=this._value.charCodeAt(this._pos);return r-t}value(){return this._value[this._pos]}}e.StringIterator=R;class y{constructor(i=!0){this._caseSensitive=i}reset(i){return this._value=i,this._from=0,this._to=0,this.next()}hasNext(){return this._to<this._value.length}next(){this._from=this._to;let i=!0;for(;this._to<this._value.length;this._to++)if(this._value.charCodeAt(this._to)===46)if(i)this._from++;else break;else i=!1;return this}cmp(i){return this._caseSensitive?(0,p.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,p.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.ConfigKeysIterator=y;class m{constructor(i=!0,r=!0){this._splitOnBackslash=i,this._caseSensitive=r}reset(i){this._from=0,this._to=0,this._value=i,this._valueLen=i.length;for(let r=i.length-1;r>=0;r--,this._valueLen--){const t=this._value.charCodeAt(r);if(!(t===47||this._splitOnBackslash&&t===92))break}return this.next()}hasNext(){return this._to<this._valueLen}next(){this._from=this._to;let i=!0;for(;this._to<this._valueLen;this._to++){const r=this._value.charCodeAt(this._to);if(r===47||this._splitOnBackslash&&r===92)if(i)this._from++;else break;else i=!1}return this}cmp(i){return this._caseSensitive?(0,p.compareSubstring)(i,this._value,0,i.length,this._from,this._to):(0,p.compareSubstringIgnoreCase)(i,this._value,0,i.length,this._from,this._to)}value(){return this._value.substring(this._from,this._to)}}e.PathIterator=m;var I;(function(n){n[n.Scheme=1]="Scheme",n[n.Authority=2]="Authority",n[n.Path=3]="Path",n[n.Query=4]="Query",n[n.Fragment=5]="Fragment"})(I||(I={}));class f{constructor(i,r){this._ignorePathCasing=i,this._ignoreQueryAndFragment=r,this._states=[],this._stateIdx=0}reset(i){return this._value=i,this._states=[],this._value.scheme&&this._states.push(1),this._value.authority&&this._states.push(2),this._value.path&&(this._pathIterator=new m(!1,!this._ignorePathCasing(i)),this._pathIterator.reset(i.path),this._pathIterator.value()&&this._states.push(3)),this._ignoreQueryAndFragment(i)||(this._value.query&&this._states.push(4),this._value.fragment&&this._states.push(5)),this._stateIdx=0,this}next(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()?this._pathIterator.next():this._stateIdx+=1,this}hasNext(){return this._states[this._stateIdx]===3&&this._pathIterator.hasNext()||this._stateIdx<this._states.length-1}cmp(i){if(this._states[this._stateIdx]===1)return(0,p.compareIgnoreCase)(i,this._value.scheme);if(this._states[this._stateIdx]===2)return(0,p.compareIgnoreCase)(i,this._value.authority);if(this._states[this._stateIdx]===3)return this._pathIterator.cmp(i);if(this._states[this._stateIdx]===4)return(0,p.compare)(i,this._value.query);if(this._states[this._stateIdx]===5)return(0,p.compare)(i,this._value.fragment);throw new Error}value(){if(this._states[this._stateIdx]===1)return this._value.scheme;if(this._states[this._stateIdx]===2)return this._value.authority;if(this._states[this._stateIdx]===3)return this._pathIterator.value();if(this._states[this._stateIdx]===4)return this._value.query;if(this._states[this._stateIdx]===5)return this._value.fragment;throw new Error}}e.UriIterator=f;class h{constructor(){this.height=1}isEmpty(){return!this.left&&!this.mid&&!this.right&&!this.value}rotateLeft(){const i=this.right;return this.right=i.left,i.left=this,this.updateHeight(),i.updateHeight(),i}rotateRight(){const i=this.left;return this.left=i.right,i.right=this,this.updateHeight(),i.updateHeight(),i}updateHeight(){this.height=1+Math.max(this.heightLeft,this.heightRight)}balanceFactor(){return this.heightRight-this.heightLeft}get heightLeft(){return this.left?.height??0}get heightRight(){return this.right?.height??0}}var d;(function(n){n[n.Left=-1]="Left",n[n.Mid=0]="Mid",n[n.Right=1]="Right"})(d||(d={}));class a{constructor(i){this._iter=i}static forUris(i=()=>!1,r=()=>!1){return new a(new f(i,r))}static forPaths(i=!1){return new a(new m(void 0,!i))}static forStrings(){return new a(new R)}static forConfigKeys(){return new a(new y)}clear(){this._root=void 0}fill(i,r){if(r){const t=r.slice(0);(0,o.shuffle)(t);for(const c of t)this.set(c,i)}else{const t=i.slice(0);(0,o.shuffle)(t);for(const c of t)this.set(c[0],c[1])}}set(i,r){const t=this._iter.reset(i);let c;this._root||(this._root=new h,this._root.segment=t.value());const w=[];for(c=this._root;;){const C=t.cmp(c.segment);if(C>0)c.left||(c.left=new h,c.left.segment=t.value()),w.push([-1,c]),c=c.left;else if(C<0)c.right||(c.right=new h,c.right.segment=t.value()),w.push([1,c]),c=c.right;else if(t.hasNext())t.next(),c.mid||(c.mid=new h,c.mid.segment=t.value()),w.push([0,c]),c=c.mid;else break}const g=c.value;c.value=r,c.key=i;for(let C=w.length-1;C>=0;C--){const U=w[C][1];U.updateHeight();const W=U.balanceFactor();if(W<-1||W>1){const M=w[C][0],S=w[C+1][0];if(M===1&&S===1)w[C][1]=U.rotateLeft();else if(M===-1&&S===-1)w[C][1]=U.rotateRight();else if(M===1&&S===-1)U.right=w[C+1][1]=w[C+1][1].rotateRight(),w[C][1]=U.rotateLeft();else if(M===-1&&S===1)U.left=w[C+1][1]=w[C+1][1].rotateLeft(),w[C][1]=U.rotateRight();else throw new Error;if(C>0)switch(w[C-1][0]){case-1:w[C-1][1].left=w[C][1];break;case 1:w[C-1][1].right=w[C][1];break;case 0:w[C-1][1].mid=w[C][1];break}else this._root=w[0][1]}}return g}get(i){return this._getNode(i)?.value}_getNode(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const c=r.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else break}return t}has(i){const r=this._getNode(i);return!(r?.value===void 0&&r?.mid===void 0)}delete(i){return this._delete(i,!1)}deleteSuperstr(i){return this._delete(i,!0)}_delete(i,r){const t=this._iter.reset(i),c=[];let w=this._root;for(;w;){const g=t.cmp(w.segment);if(g>0)c.push([-1,w]),w=w.left;else if(g<0)c.push([1,w]),w=w.right;else if(t.hasNext())t.next(),c.push([0,w]),w=w.mid;else break}if(!!w){if(r?(w.left=void 0,w.mid=void 0,w.right=void 0,w.height=1):(w.key=void 0,w.value=void 0),!w.mid&&!w.value)if(w.left&&w.right){const g=this._min(w.right),{key:C,value:U,segment:W}=g;this._delete(g.key,!1),w.key=C,w.value=U,w.segment=W}else{const g=w.left??w.right;if(c.length>0){const[C,U]=c[c.length-1];switch(C){case-1:U.left=g;break;case 0:U.mid=g;break;case 1:U.right=g;break}}else this._root=g}for(let g=c.length-1;g>=0;g--){const C=c[g][1];C.updateHeight();const U=C.balanceFactor();if(U>1?(C.right.balanceFactor()>=0||(C.right=C.right.rotateRight()),c[g][1]=C.rotateLeft()):U<-1&&(C.left.balanceFactor()<=0||(C.left=C.left.rotateLeft()),c[g][1]=C.rotateRight()),g>0)switch(c[g-1][0]){case-1:c[g-1][1].left=c[g][1];break;case 1:c[g-1][1].right=c[g][1];break;case 0:c[g-1][1].mid=c[g][1];break}else this._root=c[0][1]}}}_min(i){for(;i.left;)i=i.left;return i}findSubstr(i){const r=this._iter.reset(i);let t=this._root,c;for(;t;){const w=r.cmp(t.segment);if(w>0)t=t.left;else if(w<0)t=t.right;else if(r.hasNext())r.next(),c=t.value||c,t=t.mid;else break}return t&&t.value||c}findSuperstr(i){const r=this._iter.reset(i);let t=this._root;for(;t;){const c=r.cmp(t.segment);if(c>0)t=t.left;else if(c<0)t=t.right;else if(r.hasNext())r.next(),t=t.mid;else return t.mid?this._entries(t.mid):void 0}}forEach(i){for(const[r,t]of this)i(t,r)}*[Symbol.iterator](){yield*this._entries(this._root)}_entries(i){const r=[];return this._dfsEntries(i,r),r[Symbol.iterator]()}_dfsEntries(i,r){!i||(i.left&&this._dfsEntries(i.left,r),i.value&&r.push([i.key,i.value]),i.mid&&this._dfsEntries(i.mid,r),i.right&&this._dfsEntries(i.right,r))}_isBalanced(){const i=r=>{if(!r)return!0;const t=r.balanceFactor();return t<-1||t>1?!1:i(r.left)&&i(r.right)};return i(this._root)}}e.TernarySearchTree=a;class v{constructor(i,r){this.uri=i,this.value=r}}class A{constructor(i,r){this[b]="ResourceMap",i instanceof A?(this.map=new Map(i.map),this.toKey=r??A.defaultToKey):(this.map=new Map,this.toKey=i??A.defaultToKey)}set(i,r){return this.map.set(this.toKey(i),new v(i,r)),this}get(i){return this.map.get(this.toKey(i))?.value}has(i){return this.map.has(this.toKey(i))}get size(){return this.map.size}clear(){this.map.clear()}delete(i){return this.map.delete(this.toKey(i))}forEach(i,r){typeof r!="undefined"&&(i=i.bind(r));for(const[t,c]of this.map)i(c.value,c.uri,this)}*values(){for(const i of this.map.values())yield i.value}*keys(){for(const i of this.map.values())yield i.uri}*entries(){for(const i of this.map.values())yield[i.uri,i.value]}*[(b=Symbol.toStringTag,Symbol.iterator)](){for(const[,i]of this.map)yield[i.uri,i.value]}}e.ResourceMap=A,A.defaultToKey=n=>n.toString();class l{constructor(i,r){this[L]="ResourceSet",!i||typeof i=="function"?this._map=new A(i):(this._map=new A(r),i.forEach(this.add,this))}get size(){return this._map.size}add(i){return this._map.set(i,i),this}clear(){this._map.clear()}delete(i){return this._map.delete(i)}forEach(i,r){this._map.forEach((t,c)=>i.call(r,c,c,this))}has(i){return this._map.has(i)}entries(){return this._map.entries()}keys(){return this._map.keys()}values(){return this._map.keys()}[(L=Symbol.toStringTag,Symbol.iterator)](){return this.keys()}}e.ResourceSet=l;var _;(function(n){n[n.None=0]="None",n[n.AsOld=1]="AsOld",n[n.AsNew=2]="AsNew"})(_=e.Touch||(e.Touch={}));class s{constructor(){this[D]="LinkedMap",this._map=new Map,this._head=void 0,this._tail=void 0,this._size=0,this._state=0}clear(){this._map.clear(),this._head=void 0,this._tail=void 0,this._size=0,this._state++}isEmpty(){return!this._head&&!this._tail}get size(){return this._size}get first(){return this._head?.value}get last(){return this._tail?.value}has(i){return this._map.has(i)}get(i,r=0){const t=this._map.get(i);if(!!t)return r!==0&&this.touch(t,r),t.value}set(i,r,t=0){let c=this._map.get(i);if(c)c.value=r,t!==0&&this.touch(c,t);else{switch(c={key:i,value:r,next:void 0,previous:void 0},t){case 0:this.addItemLast(c);break;case 1:this.addItemFirst(c);break;case 2:this.addItemLast(c);break;default:this.addItemLast(c);break}this._map.set(i,c),this._size++}return this}delete(i){return!!this.remove(i)}remove(i){const r=this._map.get(i);if(!!r)return this._map.delete(i),this.removeItem(r),this._size--,r.value}shift(){if(!this._head&&!this._tail)return;if(!this._head||!this._tail)throw new Error("Invalid list");const i=this._head;return this._map.delete(i.key),this.removeItem(i),this._size--,i.value}forEach(i,r){const t=this._state;let c=this._head;for(;c;){if(r?i.bind(r)(c.value,c.key,this):i(c.value,c.key,this),this._state!==t)throw new Error("LinkedMap got modified during iteration.");c=c.next}}keys(){const i=this,r=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const w={value:t.key,done:!1};return t=t.next,w}else return{value:void 0,done:!0}}};return c}values(){const i=this,r=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const w={value:t.value,done:!1};return t=t.next,w}else return{value:void 0,done:!0}}};return c}entries(){const i=this,r=this._state;let t=this._head;const c={[Symbol.iterator](){return c},next(){if(i._state!==r)throw new Error("LinkedMap got modified during iteration.");if(t){const w={value:[t.key,t.value],done:!1};return t=t.next,w}else return{value:void 0,done:!0}}};return c}[(D=Symbol.toStringTag,Symbol.iterator)](){return this.entries()}trimOld(i){if(i>=this.size)return;if(i===0){this.clear();return}let r=this._head,t=this.size;for(;r&&t>i;)this._map.delete(r.key),r=r.next,t--;this._head=r,this._size=t,r&&(r.previous=void 0),this._state++}addItemFirst(i){if(!this._head&&!this._tail)this._tail=i;else if(this._head)i.next=this._head,this._head.previous=i;else throw new Error("Invalid list");this._head=i,this._state++}addItemLast(i){if(!this._head&&!this._tail)this._head=i;else if(this._tail)i.previous=this._tail,this._tail.next=i;else throw new Error("Invalid list");this._tail=i,this._state++}removeItem(i){if(i===this._head&&i===this._tail)this._head=void 0,this._tail=void 0;else if(i===this._head){if(!i.next)throw new Error("Invalid list");i.next.previous=void 0,this._head=i.next}else if(i===this._tail){if(!i.previous)throw new Error("Invalid list");i.previous.next=void 0,this._tail=i.previous}else{const r=i.next,t=i.previous;if(!r||!t)throw new Error("Invalid list");r.previous=t,t.next=r}i.next=void 0,i.previous=void 0,this._state++}touch(i,r){if(!this._head||!this._tail)throw new Error("Invalid list");if(!(r!==1&&r!==2)){if(r===1){if(i===this._head)return;const t=i.next,c=i.previous;i===this._tail?(c.next=void 0,this._tail=c):(t.previous=c,c.next=t),i.previous=void 0,i.next=this._head,this._head.previous=i,this._head=i,this._state++}else if(r===2){if(i===this._tail)return;const t=i.next,c=i.previous;i===this._head?(t.previous=void 0,this._head=t):(t.previous=c,c.next=t),i.next=void 0,i.previous=this._tail,this._tail.next=i,this._tail=i,this._state++}}}toJSON(){const i=[];return this.forEach((r,t)=>{i.push([t,r])}),i}fromJSON(i){this.clear();for(const[r,t]of i)this.set(r,t)}}e.LinkedMap=s;class u extends s{constructor(i,r=1){super();this._limit=i,this._ratio=Math.min(Math.max(0,r),1)}get limit(){return this._limit}set limit(i){this._limit=i,this.checkTrim()}get ratio(){return this._ratio}set ratio(i){this._ratio=Math.min(Math.max(0,i),1),this.checkTrim()}get(i,r=2){return super.get(i,r)}peek(i){return super.get(i,0)}set(i,r){return super.set(i,r,2),this.checkTrim(),this}checkTrim(){this.size>this._limit&&this.trimOld(Math.round(this._limit*this._ratio))}}e.LRUCache=u}),define(De[113],Ce([1,0,25,9]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.fuzzyScoreGraceful=e.fuzzyScoreGracefulAggressive=e.fuzzyScore=e.FuzzyScoreOptions=e.FuzzyScore=e.isPatternInWord=e.createMatches=e.anyScore=e.matchesFuzzy2=e.matchesFuzzy=e.matchesWords=e.matchesCamelCase=e.isUpper=e.matchesSubString=e.matchesContiguousSubString=e.matchesPrefix=e.matchesStrictPrefix=e.or=void 0;function b(...X){return function(Y,k){for(let B=0,H=X.length;B<H;B++){const j=X[B](Y,k);if(j)return j}return null}}e.or=b,e.matchesStrictPrefix=L.bind(void 0,!1),e.matchesPrefix=L.bind(void 0,!0);function L(X,Y,k){if(!k||k.length<Y.length)return null;let B;return X?B=p.startsWithIgnoreCase(k,Y):B=k.indexOf(Y)===0,B?Y.length>0?[{start:0,end:Y.length}]:[]:null}function D(X,Y){const k=Y.toLowerCase().indexOf(X.toLowerCase());return k===-1?null:[{start:k,end:k+X.length}]}e.matchesContiguousSubString=D;function T(X,Y){return E(X.toLowerCase(),Y.toLowerCase(),0,0)}e.matchesSubString=T;function E(X,Y,k,B){if(k===X.length)return[];if(B===Y.length)return null;if(X[k]===Y[B]){let H=null;return(H=E(X,Y,k+1,B+1))?a({start:B,end:B+1},H):null}return E(X,Y,k,B+1)}function P(X){return 97<=X&&X<=122}function R(X){return 65<=X&&X<=90}e.isUpper=R;function y(X){return 48<=X&&X<=57}function m(X){return X===32||X===9||X===10||X===13}const I=new Set;"()[]{}<>`'\"-/;:,.?!".split("").forEach(X=>I.add(X.charCodeAt(0)));function f(X){return m(X)||I.has(X)}function h(X,Y){return X===Y||f(X)&&f(Y)}function d(X){return P(X)||R(X)||y(X)}function a(X,Y){return Y.length===0?Y=[X]:X.end===Y[0].start?Y[0].start=X.start:Y.unshift(X),Y}function v(X,Y){for(let k=Y;k<X.length;k++){const B=X.charCodeAt(k);if(R(B)||y(B)||k>0&&!d(X.charCodeAt(k-1)))return k}return X.length}function A(X,Y,k,B){if(k===X.length)return[];if(B===Y.length)return null;if(X[k]!==Y[B].toLowerCase())return null;{let H=null,j=B+1;for(H=A(X,Y,k+1,B+1);!H&&(j=v(Y,j))<Y.length;)H=A(X,Y,k+1,j),j++;return H===null?null:a({start:B,end:B+1},H)}}function l(X){let Y=0,k=0,B=0,H=0,j=0;for(let ge=0;ge<X.length;ge++)j=X.charCodeAt(ge),R(j)&&Y++,P(j)&&k++,d(j)&&B++,y(j)&&H++;const oe=Y/X.length,ue=k/X.length,Z=B/X.length,pe=H/X.length;return{upperPercent:oe,lowerPercent:ue,alphaPercent:Z,numericPercent:pe}}function _(X){const{upperPercent:Y,lowerPercent:k}=X;return k===0&&Y>.6}function s(X){const{upperPercent:Y,lowerPercent:k,alphaPercent:B,numericPercent:H}=X;return k>.2&&Y<.8&&B>.6&&H<.2}function u(X){let Y=0,k=0,B=0,H=0;for(let j=0;j<X.length;j++)B=X.charCodeAt(j),R(B)&&Y++,P(B)&&k++,m(B)&&H++;return(Y===0||k===0)&&H===0?X.length<=30:Y<=5}function n(X,Y){if(!Y||(Y=Y.trim(),Y.length===0)||!u(X)||Y.length>60)return null;const k=l(Y);if(!s(k)){if(!_(k))return null;Y=Y.toLowerCase()}let B=null,H=0;for(X=X.toLowerCase();H<Y.length&&(B=A(X,Y,0,H))===null;)H=v(Y,H+1);return B}e.matchesCamelCase=n;function i(X,Y,k=!1){if(!Y||Y.length===0)return null;let B=null,H=0;for(X=X.toLowerCase(),Y=Y.toLowerCase();H<Y.length&&(B=r(X,Y,0,H,k))===null;)H=t(Y,H+1);return B}e.matchesWords=i;function r(X,Y,k,B,H){if(k===X.length)return[];if(B===Y.length)return null;if(h(X.charCodeAt(k),Y.charCodeAt(B))){let j=null,oe=B+1;if(j=r(X,Y,k+1,B+1,H),!H)for(;!j&&(oe=t(Y,oe))<Y.length;)j=r(X,Y,k+1,oe,H),oe++;return j?X.charCodeAt(k)!==Y.charCodeAt(B)?j:a({start:B,end:B+1},j):null}else return null}function t(X,Y){for(let k=Y;k<X.length;k++)if(f(X.charCodeAt(k))||k>0&&f(X.charCodeAt(k-1)))return k;return X.length}const c=b(e.matchesPrefix,n,D),w=b(e.matchesPrefix,n,T),g=new o.LRUCache(1e4);function C(X,Y,k=!1){if(typeof X!="string"||typeof Y!="string")return null;let B=g.get(X);B||(B=new RegExp(p.convertSimple2RegExpPattern(X),"i"),g.set(X,B));const H=B.exec(Y);return H?[{start:H.index,end:H.index+H[0].length}]:k?w(X,Y):c(X,Y)}e.matchesFuzzy=C;function U(X,Y){const k=$e(X,X.toLowerCase(),0,Y,Y.toLowerCase(),0,{firstMatchCanBeWeak:!0,boostFullMatch:!0});return k?M(k):null}e.matchesFuzzy2=U;function W(X,Y,k,B,H,j){const oe=Math.min(13,X.length);for(;k<oe;k++){const ue=$e(X,Y,k,B,H,j,{firstMatchCanBeWeak:!1,boostFullMatch:!0});if(ue)return ue}return[0,j]}e.anyScore=W;function M(X){if(typeof X=="undefined")return[];const Y=[],k=X[1];for(let B=X.length-1;B>1;B--){const H=X[B]+k,j=Y[Y.length-1];j&&j.end===H?j.end=H+1:Y.push({start:H,end:H+1})}return Y}e.createMatches=M;const S=128;function z(){const X=[],Y=[];for(let k=0;k<=S;k++)Y[k]=0;for(let k=0;k<=S;k++)X.push(Y.slice(0));return X}function $(X){const Y=[];for(let k=0;k<=X;k++)Y[k]=0;return Y}const N=$(2*S),K=$(2*S),V=z(),F=z(),ne=z(),ce=!1;function re(X,Y,k,B,H){function j(ue,Z,pe=" "){for(;ue.length<Z;)ue=pe+ue;return ue}let oe=` |   |${B.split("").map(ue=>j(ue,3)).join("|")}
`;for(let ue=0;ue<=k;ue++)ue===0?oe+=" |":oe+=`${Y[ue-1]}|`,oe+=X[ue].slice(0,H+1).map(Z=>j(Z.toString(),3)).join("|")+`
`;return oe}function fe(X,Y,k,B){X=X.substr(Y),k=k.substr(B),console.log(re(F,X,X.length,k,k.length)),console.log(re(ne,X,X.length,k,k.length)),console.log(re(V,X,X.length,k,k.length))}function ie(X,Y){if(Y<0||Y>=X.length)return!1;const k=X.codePointAt(Y);switch(k){case 95:case 45:case 46:case 32:case 47:case 92:case 39:case 34:case 58:case 36:case 60:case 62:case 40:case 41:case 91:case 93:case 123:case 125:return!0;case void 0:return!1;default:return!!p.isEmojiImprecise(k)}}function Ee(X,Y){if(Y<0||Y>=X.length)return!1;switch(X.charCodeAt(Y)){case 32:case 9:return!0;default:return!1}}function be(X,Y,k){return Y[X]!==k[X]}function ee(X,Y,k,B,H,j,oe=!1){for(;Y<k&&H<j;)X[Y]===B[H]&&(oe&&(N[Y]=H),Y+=1),H+=1;return Y===k}e.isPatternInWord=ee;var ve;(function(X){X[X.Diag=1]="Diag",X[X.Left=2]="Left",X[X.LeftLeft=3]="LeftLeft"})(ve||(ve={}));var Ae;(function(X){X.Default=[-100,0];function Y(k){return!k||k.length===2&&k[0]===-100&&k[1]===0}X.isDefault=Y})(Ae=e.FuzzyScore||(e.FuzzyScore={}));class Fe{constructor(Y,k){this.firstMatchCanBeWeak=Y,this.boostFullMatch=k}}e.FuzzyScoreOptions=Fe,Fe.default={boostFullMatch:!0,firstMatchCanBeWeak:!1};function $e(X,Y,k,B,H,j,oe=Fe.default){const ue=X.length>S?S:X.length,Z=B.length>S?S:B.length;if(k>=ue||j>=Z||ue-k>Z-j||!ee(Y,k,ue,H,j,Z,!0))return;Qe(ue,Z,k,j,Y,H);let pe=1,ge=1,Ne=k,Be=j;const Ze=[!1];for(pe=1,Ne=k;Ne<ue;pe++,Ne++){const Q=N[Ne],he=K[Ne],Ue=Ne+1<ue?K[Ne+1]:Z;for(ge=Q-j+1,Be=Q;Be<Ue;ge++,Be++){let We=Number.MIN_SAFE_INTEGER,et=!1;Be<=he&&(We=Ie(X,Y,Ne,k,B,H,Be,Z,j,V[pe-1][ge-1]===0,Ze));let je=0;We!==Number.MAX_SAFE_INTEGER&&(et=!0,je=We+F[pe-1][ge-1]);const He=Be>Q,it=He?F[pe][ge-1]+(V[pe][ge-1]>0?-5:0):0,rt=Be>Q+1&&V[pe][ge-1]>0,dt=rt?F[pe][ge-2]+(V[pe][ge-2]>0?-5:0):0;if(rt&&(!He||dt>=it)&&(!et||dt>=je))F[pe][ge]=dt,ne[pe][ge]=3,V[pe][ge]=0;else if(He&&(!et||it>=je))F[pe][ge]=it,ne[pe][ge]=2,V[pe][ge]=0;else if(et)F[pe][ge]=je,ne[pe][ge]=1,V[pe][ge]=V[pe-1][ge-1]+1;else throw new Error("not possible")}}if(ce&&fe(X,k,B,j),!Ze[0]&&!oe.firstMatchCanBeWeak)return;pe--,ge--;const Ge=[F[pe][ge],j];let ke=0,nt=0;for(;pe>=1;){let Q=ge;do{const he=ne[pe][Q];if(he===3)Q=Q-2;else if(he===2)Q=Q-1;else break}while(Q>=1);ke>1&&Y[k+pe-1]===H[j+ge-1]&&!be(Q+j-1,B,H)&&ke+1>V[pe][Q]&&(Q=ge),Q===ge?ke++:ke=1,nt||(nt=Q),pe--,ge=Q-1,Ge.push(ge)}Z===ue&&oe.boostFullMatch&&(Ge[0]+=2);const G=nt-ue;return Ge[0]-=G,Ge}e.fuzzyScore=$e;function Qe(X,Y,k,B,H,j){let oe=X-1,ue=Y-1;for(;oe>=k&&ue>=B;)H[oe]===j[ue]&&(K[oe]=ue,oe--),ue--}function Ie(X,Y,k,B,H,j,oe,ue,Z,pe,ge){if(Y[k]!==j[oe])return Number.MIN_SAFE_INTEGER;let Ne=1,Be=!1;return oe===k-B?Ne=X[k]===H[oe]?7:5:be(oe,H,j)&&(oe===0||!be(oe-1,H,j))?(Ne=X[k]===H[oe]?7:5,Be=!0):ie(j,oe)&&(oe===0||!ie(j,oe-1))?Ne=5:(ie(j,oe-1)||Ee(j,oe-1))&&(Ne=5,Be=!0),Ne>1&&k===B&&(ge[0]=!0),Be||(Be=be(oe,H,j)||ie(j,oe-1)||Ee(j,oe-1)),k===B?oe>Z&&(Ne-=Be?3:5):pe?Ne+=Be?2:0:Ne+=Be?0:1,oe+1===ue&&(Ne-=Be?3:5),Ne}function Se(X,Y,k,B,H,j,oe){return ae(X,Y,k,B,H,j,!0,oe)}e.fuzzyScoreGracefulAggressive=Se;function Te(X,Y,k,B,H,j,oe){return ae(X,Y,k,B,H,j,!1,oe)}e.fuzzyScoreGraceful=Te;function ae(X,Y,k,B,H,j,oe,ue){let Z=$e(X,Y,k,B,H,j,ue);if(Z&&!oe)return Z;if(X.length>=3){const pe=Math.min(7,X.length-1);for(let ge=k+1;ge<pe;ge++){const Ne=le(X,ge);if(Ne){const Be=$e(Ne,Ne.toLowerCase(),k,B,H,j,ue);Be&&(Be[0]-=3,(!Z||Be[0]>Z[0])&&(Z=Be))}}}return Z}function le(X,Y){if(Y+1>=X.length)return;const k=X[Y],B=X[Y+1];if(k!==B)return X.slice(0,Y)+B+k+X.slice(Y+2)}}),define(De[114],Ce([1,0,115,113,9]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.matchesFuzzyIconAware=e.parseLabelWithIcons=e.stripIcons=e.markdownEscapeEscapedIcons=e.escapeIcons=e.iconStartMarker=void 0,e.iconStartMarker="$(";const L=new RegExp(`\\$\\(${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?\\)`,"g"),D=new RegExp(o.CSSIcon.iconNameCharacter),T=new RegExp(`(\\\\)?${L.source}`,"g");function E(d){return d.replace(T,(a,v)=>v?a:`\\${a}`)}e.escapeIcons=E;const P=new RegExp(`\\\\${L.source}`,"g");function R(d){return d.replace(P,a=>`\\${a}`)}e.markdownEscapeEscapedIcons=R;const y=new RegExp(`(\\s)?(\\\\)?${L.source}(\\s)?`,"g");function m(d){return d.indexOf(e.iconStartMarker)===-1?d:d.replace(y,(a,v,A,l)=>A?a:v||l||"")}e.stripIcons=m;function I(d){const a=d.indexOf(e.iconStartMarker);return a===-1?{text:d}:f(d,a)}e.parseLabelWithIcons=I;function f(d,a){const v=[];let A="";function l(c){if(c){A+=c;for(const w of c)v.push(u)}}let _=-1,s="",u=0,n,i,r=a;const t=d.length;for(l(d.substr(0,a));r<t;)n=d[r],i=d[r+1],n===e.iconStartMarker[0]&&i===e.iconStartMarker[1]?(_=r,l(s),s=e.iconStartMarker,r++):n===")"&&_!==-1?(u+=r-_+1,_=-1,s=""):_!==-1?D.test(n)?s+=n:(l(s),_=-1,s=""):l(n),r++;return l(s),{text:A,iconOffsets:v}}function h(d,a,v=!1){const{text:A,iconOffsets:l}=a;if(!l||l.length===0)return(0,p.matchesFuzzy)(d,A,v);const _=(0,b.ltrim)(A," "),s=A.length-_.length,u=(0,p.matchesFuzzy)(d,_,v);if(u)for(const n of u){const i=l[n.start+s]+s;n.start+=i,n.end+=i}return u}e.matchesFuzzyIconAware=h}),define(De[29],Ce([1,0,9]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0});var p;(function(b){b[b.Ignore=0]="Ignore",b[b.Info=1]="Info",b[b.Warning=2]="Warning",b[b.Error=3]="Error"})(p||(p={})),function(b){const L="error",D="warning",T="warn",E="info",P="ignore";function R(m){return m?o.equalsIgnoreCase(L,m)?b.Error:o.equalsIgnoreCase(D,m)||o.equalsIgnoreCase(T,m)?b.Warning:o.equalsIgnoreCase(E,m)?b.Info:b.Ignore:b.Ignore}b.fromValue=R;function y(m){switch(m){case b.Error:return L;case b.Warning:return D;case b.Info:return E;default:return P}}b.toString=y}(p||(p={})),e.default=p}),define(De[55],Ce([1,0,22,9,2]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.revive=e.parse=e.stringify=void 0;function L(P){return JSON.stringify(P,T)}e.stringify=L;function D(P){let R=JSON.parse(P);return R=E(R),R}e.parse=D;function T(P,R){return R instanceof RegExp?{$mid:2,source:R.source,flags:(0,p.regExpFlags)(R)}:R}function E(P,R=0){if(!P||R>200)return P;if(typeof P=="object"){switch(P.$mid){case 1:return b.URI.revive(P);case 2:return new RegExp(P.source,P.flags);case 14:return new Date(P.source)}if(P instanceof o.VSBuffer||P instanceof Uint8Array)return P;if(Array.isArray(P))for(let y=0;y<P.length;++y)P[y]=E(P[y],R+1);else for(const y in P)Object.hasOwnProperty.call(P,y)&&(P[y]=E(P[y],R+1))}return P}e.revive=E}),define(De[12],Ce([1,0,23,2]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileAccess=e.RemoteAuthorities=e.connectionTokenQueryName=e.connectionTokenCookieName=e.Schemas=void 0;var b;(function(T){T.inMemory="inmemory",T.vscode="vscode",T.internal="private",T.walkThrough="walkThrough",T.walkThroughSnippet="walkThroughSnippet",T.http="http",T.https="https",T.file="file",T.mailto="mailto",T.untitled="untitled",T.data="data",T.command="command",T.vscodeRemote="vscode-remote",T.vscodeRemoteResource="vscode-remote-resource",T.vscodeUserData="vscode-userdata",T.vscodeCustomEditor="vscode-custom-editor",T.vscodeNotebook="vscode-notebook",T.vscodeNotebookCell="vscode-notebook-cell",T.vscodeNotebookCellMetadata="vscode-notebook-cell-metadata",T.vscodeNotebookCellOutput="vscode-notebook-cell-output",T.vscodeInteractive="vscode-interactive",T.vscodeInteractiveInput="vscode-interactive-input",T.vscodeSettings="vscode-settings",T.vscodeWorkspaceTrust="vscode-workspace-trust",T.vscodeTerminal="vscode-terminal",T.webviewPanel="webview-panel",T.vscodeWebview="vscode-webview",T.extension="extension",T.vscodeFileResource="vscode-file",T.tmp="tmp",T.vsls="vsls",T.vscodeSourceControl="vscode-scm"})(b=e.Schemas||(e.Schemas={})),e.connectionTokenCookieName="vscode-tkn",e.connectionTokenQueryName="tkn";class L{constructor(){this._hosts=Object.create(null),this._ports=Object.create(null),this._connectionTokens=Object.create(null),this._preferredWebSchema="http",this._delegate=null,this._remoteResourcesPath=`/${b.vscodeRemoteResource}`}setPreferredWebSchema(E){this._preferredWebSchema=E}setDelegate(E){this._delegate=E}setServerRootPath(E){this._remoteResourcesPath=`${E}/${b.vscodeRemoteResource}`}set(E,P,R){this._hosts[E]=P,this._ports[E]=R}setConnectionToken(E,P){this._connectionTokens[E]=P}getPreferredWebSchema(){return this._preferredWebSchema}rewrite(E){if(this._delegate)return this._delegate(E);const P=E.authority;let R=this._hosts[P];R&&R.indexOf(":")!==-1&&(R=`[${R}]`);const y=this._ports[P],m=this._connectionTokens[P];let I=`path=${encodeURIComponent(E.path)}`;return typeof m=="string"&&(I+=`&${e.connectionTokenQueryName}=${encodeURIComponent(m)}`),p.URI.from({scheme:o.isWeb?this._preferredWebSchema:b.vscodeRemoteResource,authority:`${R}:${y}`,path:this._remoteResourcesPath,query:I})}}e.RemoteAuthorities=new L;class D{asBrowserUri(E,P){const R=this.toUri(E,P);return R.scheme===b.vscodeRemote?e.RemoteAuthorities.rewrite(R):R.scheme===b.file&&(o.isNative||o.isWebWorker&&o.globals.origin===`${b.vscodeFileResource}://${D.FALLBACK_AUTHORITY}`)?R.with({scheme:b.vscodeFileResource,authority:R.authority||D.FALLBACK_AUTHORITY,query:null,fragment:null}):R}asFileUri(E,P){const R=this.toUri(E,P);return R.scheme===b.vscodeFileResource?R.with({scheme:b.file,authority:R.authority!==D.FALLBACK_AUTHORITY?R.authority:null,query:null,fragment:null}):R}toUri(E,P){return p.URI.isUri(E)?E:p.URI.parse(P.toUrl(E))}}D.FALLBACK_AUTHORITY="vscode-app",e.FileAccess=new D}),define(De[21],Ce([1,0,37,12,19,23,9,2]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.toLocalResource=e.DataUri=e.distinctParents=e.addTrailingPathSeparator=e.removeTrailingPathSeparator=e.hasTrailingPathSeparator=e.isEqualAuthority=e.isAbsolutePath=e.resolvePath=e.relativePath=e.normalizePath=e.joinPath=e.dirname=e.extname=e.basename=e.basenameOrAuthority=e.getComparisonKey=e.isEqualOrParent=e.isEqual=e.extUriIgnorePathCase=e.extUriBiasedIgnorePathCase=e.extUri=e.ExtUri=e.originalFSPath=void 0;function E(I){return(0,T.uriToFsPath)(I,!0)}e.originalFSPath=E;class P{constructor(f){this._ignorePathCasing=f}compare(f,h,d=!1){return f===h?0:(0,D.compare)(this.getComparisonKey(f,d),this.getComparisonKey(h,d))}isEqual(f,h,d=!1){return f===h?!0:!f||!h?!1:this.getComparisonKey(f,d)===this.getComparisonKey(h,d)}getComparisonKey(f,h=!1){return f.with({path:this._ignorePathCasing(f)?f.path.toLowerCase():void 0,fragment:h?null:void 0}).toString()}ignorePathCasing(f){return this._ignorePathCasing(f)}isEqualOrParent(f,h,d=!1){if(f.scheme===h.scheme){if(f.scheme===p.Schemas.file)return o.isEqualOrParent(E(f),E(h),this._ignorePathCasing(f))&&f.query===h.query&&(d||f.fragment===h.fragment);if((0,e.isEqualAuthority)(f.authority,h.authority))return o.isEqualOrParent(f.path,h.path,this._ignorePathCasing(f),"/")&&f.query===h.query&&(d||f.fragment===h.fragment)}return!1}joinPath(f,...h){return T.URI.joinPath(f,...h)}basenameOrAuthority(f){return(0,e.basename)(f)||f.authority}basename(f){return b.posix.basename(f.path)}extname(f){return b.posix.extname(f.path)}dirname(f){if(f.path.length===0)return f;let h;return f.scheme===p.Schemas.file?h=T.URI.file(b.dirname(E(f))).path:(h=b.posix.dirname(f.path),f.authority&&h.length&&h.charCodeAt(0)!==47&&(console.error(`dirname("${f.toString})) resulted in a relative path`),h="/")),f.with({path:h})}normalizePath(f){if(!f.path.length)return f;let h;return f.scheme===p.Schemas.file?h=T.URI.file(b.normalize(E(f))).path:h=b.posix.normalize(f.path),f.with({path:h})}relativePath(f,h){if(f.scheme!==h.scheme||!(0,e.isEqualAuthority)(f.authority,h.authority))return;if(f.scheme===p.Schemas.file){const v=b.relative(E(f),E(h));return L.isWindows?o.toSlashes(v):v}let d=f.path||"/";const a=h.path||"/";if(this._ignorePathCasing(f)){let v=0;for(const A=Math.min(d.length,a.length);v<A&&!(d.charCodeAt(v)!==a.charCodeAt(v)&&d.charAt(v).toLowerCase()!==a.charAt(v).toLowerCase());v++);d=a.substr(0,v)+d.substr(v)}return b.posix.relative(d,a)}resolvePath(f,h){if(f.scheme===p.Schemas.file){const d=T.URI.file(b.resolve(E(f),h));return f.with({authority:d.authority,path:d.path})}return h=o.toPosixPath(h),f.with({path:b.posix.resolve(f.path,h)})}isAbsolutePath(f){return!!f.path&&f.path[0]==="/"}isEqualAuthority(f,h){return f===h||f!==void 0&&h!==void 0&&(0,D.equalsIgnoreCase)(f,h)}hasTrailingPathSeparator(f,h=b.sep){if(f.scheme===p.Schemas.file){const d=E(f);return d.length>o.getRoot(d).length&&d[d.length-1]===h}else{const d=f.path;return d.length>1&&d.charCodeAt(d.length-1)===47&&!/^[a-zA-Z]:(\/$|\\$)/.test(f.fsPath)}}removeTrailingPathSeparator(f,h=b.sep){return(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path.substr(0,f.path.length-1)}):f}addTrailingPathSeparator(f,h=b.sep){let d=!1;if(f.scheme===p.Schemas.file){const a=E(f);d=a!==void 0&&a.length===o.getRoot(a).length&&a[a.length-1]===h}else{h="/";const a=f.path;d=a.length===1&&a.charCodeAt(a.length-1)===47}return!d&&!(0,e.hasTrailingPathSeparator)(f,h)?f.with({path:f.path+"/"}):f}}e.ExtUri=P,e.extUri=new P(()=>!1),e.extUriBiasedIgnorePathCase=new P(I=>I.scheme===p.Schemas.file?!L.isLinux:!0),e.extUriIgnorePathCase=new P(I=>!0),e.isEqual=e.extUri.isEqual.bind(e.extUri),e.isEqualOrParent=e.extUri.isEqualOrParent.bind(e.extUri),e.getComparisonKey=e.extUri.getComparisonKey.bind(e.extUri),e.basenameOrAuthority=e.extUri.basenameOrAuthority.bind(e.extUri),e.basename=e.extUri.basename.bind(e.extUri),e.extname=e.extUri.extname.bind(e.extUri),e.dirname=e.extUri.dirname.bind(e.extUri),e.joinPath=e.extUri.joinPath.bind(e.extUri),e.normalizePath=e.extUri.normalizePath.bind(e.extUri),e.relativePath=e.extUri.relativePath.bind(e.extUri),e.resolvePath=e.extUri.resolvePath.bind(e.extUri),e.isAbsolutePath=e.extUri.isAbsolutePath.bind(e.extUri),e.isEqualAuthority=e.extUri.isEqualAuthority.bind(e.extUri),e.hasTrailingPathSeparator=e.extUri.hasTrailingPathSeparator.bind(e.extUri),e.removeTrailingPathSeparator=e.extUri.removeTrailingPathSeparator.bind(e.extUri),e.addTrailingPathSeparator=e.extUri.addTrailingPathSeparator.bind(e.extUri);function R(I,f){const h=[];for(let d=0;d<I.length;d++){const a=f(I[d]);I.some((v,A)=>A===d?!1:(0,e.isEqualOrParent)(a,f(v)))||h.push(I[d])}return h}e.distinctParents=R;var y;(function(I){I.META_DATA_LABEL="label",I.META_DATA_DESCRIPTION="description",I.META_DATA_SIZE="size",I.META_DATA_MIME="mime";function f(h){const d=new Map;h.path.substring(h.path.indexOf(";")+1,h.path.lastIndexOf(";")).split(";").forEach(A=>{const[l,_]=A.split(":");l&&_&&d.set(l,_)});const v=h.path.substring(0,h.path.indexOf(";"));return v&&d.set(I.META_DATA_MIME,v),d}I.parseMetaData=f})(y=e.DataUri||(e.DataUri={}));function m(I,f,h){if(f){let d=I.path;return d&&d[0]!==b.posix.sep&&(d=b.posix.sep+d),I.with({scheme:h,authority:f,path:d})}return I.with({scheme:h})}e.toLocalResource=m}),define(De[13],Ce([1,0,20,11,4,7,21,23]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createCancelableAsyncIterable=e.CancelableAsyncIterableObject=e.AsyncIterableObject=e.Promises=e.DeferredPromise=e.IntervalCounter=e.TaskSequentializer=e.retry=e.IdleValue=e.runWhenIdle=e.ThrottledWorker=e.RunOnceWorker=e.ProcessTimeRunOnceScheduler=e.RunOnceScheduler=e.IntervalTimer=e.TimeoutTimer=e.ResourceQueue=e.Queue=e.Limiter=e.firstParallel=e.first=e.sequence=e.disposableTimeout=e.timeout=e.AutoOpenBarrier=e.Barrier=e.ThrottledDelayer=e.Delayer=e.MicrotaskDelay=e.SequencerByKey=e.Sequencer=e.Throttler=e.asPromise=e.raceTimeout=e.raceCancellablePromises=e.raceCancellationError=e.raceCancellation=e.createCancelablePromise=e.isThenable=void 0;function E(be){return!!be&&typeof be.then=="function"}e.isThenable=E;function P(be){const ee=new o.CancellationTokenSource,ve=be(ee.token),Ae=new Promise((Fe,$e)=>{const Qe=ee.token.onCancellationRequested(()=>{Qe.dispose(),ee.dispose(),$e(new p.CancellationError)});Promise.resolve(ve).then(Ie=>{Qe.dispose(),ee.dispose(),Fe(Ie)},Ie=>{Qe.dispose(),ee.dispose(),$e(Ie)})});return new class{cancel(){ee.cancel()}then(Fe,$e){return Ae.then(Fe,$e)}catch(Fe){return this.then(void 0,Fe)}finally(Fe){return Ae.finally(Fe)}}}e.createCancelablePromise=P;function R(be,ee,ve){return new Promise((Ae,Fe)=>{const $e=ee.onCancellationRequested(()=>{$e.dispose(),Ae(ve)});be.then(Ae,Fe).finally(()=>$e.dispose())})}e.raceCancellation=R;function y(be,ee){return new Promise((ve,Ae)=>{const Fe=ee.onCancellationRequested(()=>{Fe.dispose(),Ae(new p.CancellationError)});be.then(ve,Ae).finally(()=>Fe.dispose())})}e.raceCancellationError=y;async function m(be){let ee=-1;const ve=be.map((Fe,$e)=>Fe.then(Qe=>(ee=$e,Qe))),Ae=await Promise.race(ve);return be.forEach((Fe,$e)=>{$e!==ee&&Fe.cancel()}),Ae}e.raceCancellablePromises=m;function I(be,ee,ve){let Ae;const Fe=setTimeout(()=>{Ae?.(void 0),ve?.()},ee);return Promise.race([be.finally(()=>clearTimeout(Fe)),new Promise($e=>Ae=$e)])}e.raceTimeout=I;function f(be){return new Promise((ee,ve)=>{const Ae=be();E(Ae)?Ae.then(ee,ve):ee(Ae)})}e.asPromise=f;class h{constructor(){this.activePromise=null,this.queuedPromise=null,this.queuedPromiseFactory=null}queue(ee){if(this.activePromise){if(this.queuedPromiseFactory=ee,!this.queuedPromise){const ve=()=>{this.queuedPromise=null;const Ae=this.queue(this.queuedPromiseFactory);return this.queuedPromiseFactory=null,Ae};this.queuedPromise=new Promise(Ae=>{this.activePromise.then(ve,ve).then(Ae)})}return new Promise((ve,Ae)=>{this.queuedPromise.then(ve,Ae)})}return this.activePromise=ee(),new Promise((ve,Ae)=>{this.activePromise.then(Fe=>{this.activePromise=null,ve(Fe)},Fe=>{this.activePromise=null,Ae(Fe)})})}}e.Throttler=h;class d{constructor(){this.current=Promise.resolve(null)}queue(ee){return this.current=this.current.then(()=>ee(),()=>ee())}}e.Sequencer=d;class a{constructor(){this.promiseMap=new Map}queue(ee,ve){const Fe=(this.promiseMap.get(ee)??Promise.resolve()).catch(()=>{}).then(ve).finally(()=>{this.promiseMap.get(ee)===Fe&&this.promiseMap.delete(ee)});return this.promiseMap.set(ee,Fe),Fe}}e.SequencerByKey=a;const v=(be,ee)=>{let ve=!0;const Ae=setTimeout(()=>{ve=!1,ee()},be);return{isTriggered:()=>ve,dispose:()=>{clearTimeout(Ae),ve=!1}}},A=be=>{let ee=!0;return queueMicrotask(()=>{ee&&(ee=!1,be())}),{isTriggered:()=>ee,dispose:()=>{ee=!1}}};e.MicrotaskDelay=Symbol("MicrotaskDelay");class l{constructor(ee){this.defaultDelay=ee,this.deferred=null,this.completionPromise=null,this.doResolve=null,this.doReject=null,this.task=null}trigger(ee,ve=this.defaultDelay){this.task=ee,this.cancelTimeout(),this.completionPromise||(this.completionPromise=new Promise((Fe,$e)=>{this.doResolve=Fe,this.doReject=$e}).then(()=>{if(this.completionPromise=null,this.doResolve=null,this.task){const Fe=this.task;return this.task=null,Fe()}}));const Ae=()=>{this.deferred=null,this.doResolve?.(null)};return this.deferred=ve===e.MicrotaskDelay?A(Ae):v(ve,Ae),this.completionPromise}isTriggered(){return!!this.deferred?.isTriggered()}cancel(){this.cancelTimeout(),this.completionPromise&&(this.doReject?.(new p.CancellationError),this.completionPromise=null)}cancelTimeout(){this.deferred?.dispose(),this.deferred=null}dispose(){this.cancel()}}e.Delayer=l;class _{constructor(ee){this.delayer=new l(ee),this.throttler=new h}trigger(ee,ve){return this.delayer.trigger(()=>this.throttler.queue(ee),ve)}isTriggered(){return this.delayer.isTriggered()}cancel(){this.delayer.cancel()}dispose(){this.delayer.dispose()}}e.ThrottledDelayer=_;class s{constructor(){this._isOpen=!1,this._promise=new Promise((ee,ve)=>{this._completePromise=ee})}isOpen(){return this._isOpen}open(){this._isOpen=!0,this._completePromise(!0)}wait(){return this._promise}}e.Barrier=s;class u extends s{constructor(ee){super();this._timeout=setTimeout(()=>this.open(),ee)}open(){clearTimeout(this._timeout),super.open()}}e.AutoOpenBarrier=u;function n(be,ee){return ee?new Promise((ve,Ae)=>{const Fe=setTimeout(()=>{$e.dispose(),ve()},be),$e=ee.onCancellationRequested(()=>{clearTimeout(Fe),$e.dispose(),Ae(new p.CancellationError)})}):P(ve=>n(be,ve))}e.timeout=n;function i(be,ee=0){const ve=setTimeout(be,ee);return(0,L.toDisposable)(()=>clearTimeout(ve))}e.disposableTimeout=i;function r(be){const ee=[];let ve=0;const Ae=be.length;function Fe(){return ve<Ae?be[ve++]():null}function $e(Qe){Qe!=null&&ee.push(Qe);const Ie=Fe();return Ie?Ie.then($e):Promise.resolve(ee)}return Promise.resolve(null).then($e)}e.sequence=r;function t(be,ee=Ae=>!!Ae,ve=null){let Ae=0;const Fe=be.length,$e=()=>{if(Ae>=Fe)return Promise.resolve(ve);const Qe=be[Ae++];return Promise.resolve(Qe()).then(Se=>ee(Se)?Promise.resolve(Se):$e())};return $e()}e.first=t;function c(be,ee=Ae=>!!Ae,ve=null){if(be.length===0)return Promise.resolve(ve);let Ae=be.length;const Fe=()=>{Ae=-1;for(const $e of be)$e.cancel?.()};return new Promise(($e,Qe)=>{for(const Ie of be)Ie.then(Se=>{--Ae>=0&&ee(Se)?(Fe(),$e(Se)):Ae===0&&$e(ve)}).catch(Se=>{--Ae>=0&&(Fe(),Qe(Se))})})}e.firstParallel=c;class w{constructor(ee){this._size=0,this.maxDegreeOfParalellism=ee,this.outstandingPromises=[],this.runningPromises=0,this._onDrained=new b.Emitter}get onDrained(){return this._onDrained.event}get size(){return this._size}queue(ee){return this._size++,new Promise((ve,Ae)=>{this.outstandingPromises.push({factory:ee,c:ve,e:Ae}),this.consume()})}consume(){for(;this.outstandingPromises.length&&this.runningPromises<this.maxDegreeOfParalellism;){const ee=this.outstandingPromises.shift();this.runningPromises++;const ve=ee.factory();ve.then(ee.c,ee.e),ve.then(()=>this.consumed(),()=>this.consumed())}}consumed(){this._size--,this.runningPromises--,this.outstandingPromises.length>0?this.consume():this._onDrained.fire()}dispose(){this._onDrained.dispose()}}e.Limiter=w;class g extends w{constructor(){super(1)}}e.Queue=g;class C{constructor(){this.queues=new Map,this.drainers=new Set}async whenDrained(){if(this.isDrained())return;const ee=new ne;return this.drainers.add(ee),ee.p}isDrained(){for(const[,ee]of this.queues)if(ee.size>0)return!1;return!0}queueFor(ee,ve=D.extUri){const Ae=ve.getComparisonKey(ee);let Fe=this.queues.get(Ae);return Fe||(Fe=new g,b.Event.once(Fe.onDrained)(()=>{Fe?.dispose(),this.queues.delete(Ae),this.onDidQueueDrain()}),this.queues.set(Ae,Fe)),Fe}onDidQueueDrain(){!this.isDrained()||this.releaseDrainers()}releaseDrainers(){for(const ee of this.drainers)ee.complete();this.drainers.clear()}dispose(){for(const[,ee]of this.queues)ee.dispose();this.queues.clear(),this.releaseDrainers()}}e.ResourceQueue=C;class U{constructor(ee,ve){this._token=-1,typeof ee=="function"&&typeof ve=="number"&&this.setIfNotSet(ee,ve)}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearTimeout(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setTimeout(()=>{this._token=-1,ee()},ve)}setIfNotSet(ee,ve){this._token===-1&&(this._token=setTimeout(()=>{this._token=-1,ee()},ve))}}e.TimeoutTimer=U;class W{constructor(){this._token=-1}dispose(){this.cancel()}cancel(){this._token!==-1&&(clearInterval(this._token),this._token=-1)}cancelAndSet(ee,ve){this.cancel(),this._token=setInterval(()=>{ee()},ve)}}e.IntervalTimer=W;class M{constructor(ee,ve){this.timeoutToken=-1,this.runner=ee,this.timeout=ve,this.timeoutHandler=this.onTimeout.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearTimeout(this.timeoutToken),this.timeoutToken=-1)}schedule(ee=this.timeout){this.cancel(),this.timeoutToken=setTimeout(this.timeoutHandler,ee)}get delay(){return this.timeout}set delay(ee){this.timeout=ee}isScheduled(){return this.timeoutToken!==-1}onTimeout(){this.timeoutToken=-1,this.runner&&this.doRun()}doRun(){this.runner?.()}}e.RunOnceScheduler=M;class S{constructor(ee,ve){ve%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ve}ms is not a multiple of 1000ms.`),this.runner=ee,this.timeout=ve,this.counter=0,this.intervalToken=-1,this.intervalHandler=this.onInterval.bind(this)}dispose(){this.cancel(),this.runner=null}cancel(){this.isScheduled()&&(clearInterval(this.intervalToken),this.intervalToken=-1)}schedule(ee=this.timeout){ee%1e3!=0&&console.warn(`ProcessTimeRunOnceScheduler resolution is 1s, ${ee}ms is not a multiple of 1000ms.`),this.cancel(),this.counter=Math.ceil(ee/1e3),this.intervalToken=setInterval(this.intervalHandler,1e3)}isScheduled(){return this.intervalToken!==-1}onInterval(){this.counter--,!(this.counter>0)&&(clearInterval(this.intervalToken),this.intervalToken=-1,this.runner?.())}}e.ProcessTimeRunOnceScheduler=S;class z extends M{constructor(ee,ve){super(ee,ve);this.units=[]}work(ee){this.units.push(ee),this.isScheduled()||this.schedule()}doRun(){const ee=this.units;this.units=[],this.runner?.(ee)}dispose(){this.units=[],super.dispose()}}e.RunOnceWorker=z;class $ extends L.Disposable{constructor(ee,ve){super();this.options=ee,this.handler=ve,this.pendingWork=[],this.throttler=this._register(new L.MutableDisposable),this.disposed=!1}get pending(){return this.pendingWork.length}work(ee){if(this.disposed)return!1;if(typeof this.options.maxBufferedWork=="number"){if(this.throttler.value){if(this.pending+ee.length>this.options.maxBufferedWork)return!1}else if(this.pending+ee.length-this.options.maxWorkChunkSize>this.options.maxBufferedWork)return!1}return this.pendingWork.push(...ee),this.throttler.value||this.doWork(),!0}doWork(){this.handler(this.pendingWork.splice(0,this.options.maxWorkChunkSize)),this.pendingWork.length>0&&(this.throttler.value=new M(()=>{this.throttler.clear(),this.doWork()},this.options.throttleDelay),this.throttler.value.schedule())}dispose(){super.dispose(),this.disposed=!0}}e.ThrottledWorker=$,function(){typeof requestIdleCallback!="function"||typeof cancelIdleCallback!="function"?e.runWhenIdle=be=>{(0,T.setTimeout0)(()=>{if(ee)return;const ve=Date.now()+15;be(Object.freeze({didTimeout:!0,timeRemaining(){return Math.max(0,ve-Date.now())}}))});let ee=!1;return{dispose(){ee||(ee=!0)}}}:e.runWhenIdle=(be,ee)=>{const ve=requestIdleCallback(be,typeof ee=="number"?{timeout:ee}:void 0);let Ae=!1;return{dispose(){Ae||(Ae=!0,cancelIdleCallback(ve))}}}}();class N{constructor(ee){this._didRun=!1,this._executor=()=>{try{this._value=ee()}catch(ve){this._error=ve}finally{this._didRun=!0}},this._handle=(0,e.runWhenIdle)(()=>this._executor())}dispose(){this._handle.dispose()}get value(){if(this._didRun||(this._handle.dispose(),this._executor()),this._error)throw this._error;return this._value}get isInitialized(){return this._didRun}}e.IdleValue=N;async function K(be,ee,ve){let Ae;for(let Fe=0;Fe<ve;Fe++)try{return await be()}catch($e){Ae=$e,await n(ee)}throw Ae}e.retry=K;class V{hasPending(ee){return this._pending?typeof ee=="number"?this._pending.taskId===ee:!!this._pending:!1}get pending(){return this._pending?this._pending.promise:void 0}cancelPending(){this._pending?.cancel()}setPending(ee,ve,Ae){return this._pending={taskId:ee,cancel:()=>Ae?.(),promise:ve},ve.then(()=>this.donePending(ee),()=>this.donePending(ee)),ve}donePending(ee){this._pending&&ee===this._pending.taskId&&(this._pending=void 0,this.triggerNext())}triggerNext(){if(this._next){const ee=this._next;this._next=void 0,ee.run().then(ee.promiseResolve,ee.promiseReject)}}setNext(ee){if(this._next)this._next.run=ee;else{let ve,Ae;const Fe=new Promise(($e,Qe)=>{ve=$e,Ae=Qe});this._next={run:ee,promise:Fe,promiseResolve:ve,promiseReject:Ae}}return this._next.promise}}e.TaskSequentializer=V;class F{constructor(ee,ve=()=>Date.now()){this.interval=ee,this.nowFn=ve,this.lastIncrementTime=0,this.value=0}increment(){const ee=this.nowFn();return ee-this.lastIncrementTime>this.interval&&(this.lastIncrementTime=ee,this.value=0),this.value++,this.value}}e.IntervalCounter=F;class ne{constructor(){this.rejected=!1,this.resolved=!1,this.p=new Promise((ee,ve)=>{this.completeCallback=ee,this.errorCallback=ve})}get isRejected(){return this.rejected}get isResolved(){return this.resolved}get isSettled(){return this.rejected||this.resolved}complete(ee){return new Promise(ve=>{this.completeCallback(ee),this.resolved=!0,ve()})}error(ee){return new Promise(ve=>{this.errorCallback(ee),this.rejected=!0,ve()})}cancel(){new Promise(ee=>{this.errorCallback(new p.CancellationError),this.rejected=!0,ee()})}}e.DeferredPromise=ne;var ce;(function(be){async function ee(Ae){let Fe;const $e=await Promise.all(Ae.map(Qe=>Qe.then(Ie=>Ie,Ie=>{Fe||(Fe=Ie)})));if(typeof Fe!="undefined")throw Fe;return $e}be.settled=ee;function ve(Ae){return new Promise(async(Fe,$e)=>{try{await Ae(Fe,$e)}catch(Qe){$e(Qe)}})}be.withAsyncBody=ve})(ce=e.Promises||(e.Promises={}));var re;(function(be){be[be.Initial=0]="Initial",be[be.DoneOK=1]="DoneOK",be[be.DoneError=2]="DoneError"})(re||(re={}));class fe{constructor(ee){this._state=0,this._results=[],this._error=null,this._onStateChanged=new b.Emitter,queueMicrotask(async()=>{const ve={emitOne:Ae=>this.emitOne(Ae),emitMany:Ae=>this.emitMany(Ae),reject:Ae=>this.reject(Ae)};try{await Promise.resolve(ee(ve)),this.resolve()}catch(Ae){this.reject(Ae)}finally{ve.emitOne=void 0,ve.emitMany=void 0,ve.reject=void 0}})}static fromArray(ee){return new fe(ve=>{ve.emitMany(ee)})}static fromPromise(ee){return new fe(async ve=>{ve.emitMany(await ee)})}static fromPromises(ee){return new fe(async ve=>{await Promise.all(ee.map(async Ae=>ve.emitOne(await Ae)))})}static merge(ee){return new fe(async ve=>{await Promise.all(ee.map(async Ae=>{for await(const Fe of Ae)ve.emitOne(Fe)}))})}[Symbol.asyncIterator](){let ee=0;return{next:async()=>{do{if(this._state===2)throw this._error;if(ee<this._results.length)return{done:!1,value:this._results[ee++]};if(this._state===1)return{done:!0,value:void 0};await b.Event.toPromise(this._onStateChanged.event)}while(!0)}}}static map(ee,ve){return new fe(async Ae=>{for await(const Fe of ee)Ae.emitOne(ve(Fe))})}map(ee){return fe.map(this,ee)}static filter(ee,ve){return new fe(async Ae=>{for await(const Fe of ee)ve(Fe)&&Ae.emitOne(Fe)})}filter(ee){return fe.filter(this,ee)}static coalesce(ee){return fe.filter(ee,ve=>!!ve)}coalesce(){return fe.coalesce(this)}static async toPromise(ee){const ve=[];for await(const Ae of ee)ve.push(Ae);return ve}toPromise(){return fe.toPromise(this)}emitOne(ee){this._state===0&&(this._results.push(ee),this._onStateChanged.fire())}emitMany(ee){this._state===0&&(this._results=this._results.concat(ee),this._onStateChanged.fire())}resolve(){this._state===0&&(this._state=1,this._onStateChanged.fire())}reject(ee){this._state===0&&(this._state=2,this._error=ee,this._onStateChanged.fire())}}e.AsyncIterableObject=fe,fe.EMPTY=fe.fromArray([]);class ie extends fe{constructor(ee,ve){super(ve);this._source=ee}cancel(){this._source.cancel()}}e.CancelableAsyncIterableObject=ie;function Ee(be){const ee=new o.CancellationTokenSource,ve=be(ee.token);return new ie(ee,async Ae=>{const Fe=ee.token.onCancellationRequested(()=>{Fe.dispose(),ee.dispose(),Ae.reject(new p.CancellationError)});try{for await(const $e of ve){if(ee.token.isCancellationRequested)return;Ae.emitOne($e)}Fe.dispose(),ee.dispose()}catch($e){Fe.dispose(),ee.dispose(),Ae.reject($e)}})}e.createCancelableAsyncIterable=Ee}),define(De[116],Ce([1,0,13,19]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.compareByPrefix=e.compareAnything=e.comparePaths=e.compareFileExtensionsUnicode=e.compareFileExtensionsLower=e.compareFileExtensionsUpper=e.compareFileExtensionsDefault=e.compareFileExtensions=e.noIntlCompareFileNames=e.compareFileNamesUnicode=e.compareFileNamesLower=e.compareFileNamesUpper=e.compareFileNamesDefault=e.compareFileNames=void 0;const b=new o.IdleValue(()=>{const g=new Intl.Collator(void 0,{numeric:!0,sensitivity:"base"});return{collator:g,collatorIsNumeric:g.resolvedOptions().numeric}}),L=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0})})),D=new o.IdleValue(()=>({collator:new Intl.Collator(void 0,{numeric:!0,sensitivity:"accent"})}));function T(g,C,U=!1){const W=g||"",M=C||"",S=b.value.collator.compare(W,M);return b.value.collatorIsNumeric&&S===0&&W!==M?W<M?-1:1:S}e.compareFileNames=T;function E(g,C){const U=L.value.collator;return g=g||"",C=C||"",_(U,g,C)}e.compareFileNamesDefault=E;function P(g,C){const U=L.value.collator;return g=g||"",C=C||"",i(g,C)||_(U,g,C)}e.compareFileNamesUpper=P;function R(g,C){const U=L.value.collator;return g=g||"",C=C||"",n(g,C)||_(U,g,C)}e.compareFileNamesLower=R;function y(g,C){return g=g||"",C=C||"",g===C?0:g<C?-1:1}e.compareFileNamesUnicode=y;function m(g,C,U=!1){U||(g=g&&g.toLowerCase(),C=C&&C.toLowerCase());const[W,M]=A(g),[S,z]=A(C);return W!==S?W<S?-1:1:M===z?0:M<z?-1:1}e.noIntlCompareFileNames=m;function I(g,C){const[U,W]=A(g),[M,S]=A(C);let z=b.value.collator.compare(W,S);if(z===0){if(b.value.collatorIsNumeric&&W!==S)return W<S?-1:1;if(z=b.value.collator.compare(U,M),b.value.collatorIsNumeric&&z===0&&U!==M)return U<M?-1:1}return z}e.compareFileExtensions=I;function f(g,C){g=g||"",C=C||"";const U=l(g),W=l(C),M=L.value.collator,S=D.value.collator;return _(S,U,W)||_(M,g,C)}e.compareFileExtensionsDefault=f;function h(g,C){g=g||"",C=C||"";const U=l(g),W=l(C),M=L.value.collator,S=D.value.collator;return _(S,U,W)||i(g,C)||_(M,g,C)}e.compareFileExtensionsUpper=h;function d(g,C){g=g||"",C=C||"";const U=l(g),W=l(C),M=L.value.collator,S=D.value.collator;return _(S,U,W)||n(g,C)||_(M,g,C)}e.compareFileExtensionsLower=d;function a(g,C){g=g||"",C=C||"";const U=l(g).toLowerCase(),W=l(C).toLowerCase();return U!==W?U<W?-1:1:g!==C?g<C?-1:1:0}e.compareFileExtensionsUnicode=a;const v=/^(.*?)(\.([^.]*))?$/;function A(g,C=!1){const U=g?v.exec(g):[];let W=[U&&U[1]||"",U&&U[3]||""];return C&&(!W[0]&&W[1]||W[0]&&W[0].charAt(0)===".")&&(W=[W[0]+"."+W[1],""]),W}function l(g){const C=g?v.exec(g):[];return C&&C[1]&&C[1].charAt(0)!=="."&&C[3]||""}function _(g,C,U){const W=g.compare(C,U);return W!==0?W:C.length!==U.length?C.length<U.length?-1:1:0}function s(g){const C=g.charAt(0);return C.toLocaleUpperCase()!==C}function u(g){const C=g.charAt(0);return C.toLocaleLowerCase()!==C}function n(g,C){return s(g)&&u(C)?-1:u(g)&&s(C)?1:0}function i(g,C){return u(g)&&s(C)?-1:s(g)&&u(C)?1:0}function r(g,C,U=!1){return U||(g=g&&g.toLowerCase(),C=C&&C.toLowerCase()),g===C?0:g<C?-1:1}function t(g,C,U=!1){const W=g.split(p.sep),M=C.split(p.sep),S=W.length-1,z=M.length-1;let $,N;for(let K=0;;K++){if($=S===K,N=z===K,$&&N)return T(W[K],M[K],U);if($)return-1;if(N)return 1;const V=r(W[K],M[K],U);if(V!==0)return V}}e.comparePaths=t;function c(g,C,U){const W=g.toLowerCase(),M=C.toLowerCase(),S=w(g,C,U);if(S)return S;const z=W.endsWith(U),$=M.endsWith(U);if(z!==$)return z?-1:1;const N=T(W,M);return N!==0?N:W.localeCompare(M)}e.compareAnything=c;function w(g,C,U){const W=g.toLowerCase(),M=C.toLowerCase(),S=W.startsWith(U),z=M.startsWith(U);if(S!==z)return S?-1:1;if(S&&z){if(W.length<M.length)return-1;if(W.length>M.length)return 1}return 0}e.compareByPrefix=w}),define(De[34],Ce([1,0,16,13,37,25,19,23,9]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.patternsEquals=e.getPathTerms=e.getBasenameTerms=e.isRelativePattern=e.parse=e.match=e.splitGlobAware=e.GLOB_SPLIT=e.GLOBSTAR=e.getEmptyExpression=void 0;function P(){return Object.create(null)}e.getEmptyExpression=P,e.GLOBSTAR="**",e.GLOB_SPLIT="/";const R="[/\\\\]",y="[^/\\\\]",m=/\//g;function I(ne,ce){switch(ne){case 0:return"";case 1:return`${y}*?`;default:return`(?:${R}|${y}+${R}${ce?`|${R}${y}+`:""})*?`}}function f(ne,ce){if(!ne)return[];const re=[];let fe=!1,ie=!1,Ee="";for(const be of ne){switch(be){case ce:if(!fe&&!ie){re.push(Ee),Ee="";continue}break;case"{":fe=!0;break;case"}":fe=!1;break;case"[":ie=!0;break;case"]":ie=!1;break}Ee+=be}return Ee&&re.push(Ee),re}e.splitGlobAware=f;function h(ne){if(!ne)return"";let ce="";const re=f(ne,e.GLOB_SPLIT);if(re.every(fe=>fe===e.GLOBSTAR))ce=".*";else{let fe=!1;re.forEach((ie,Ee)=>{if(ie===e.GLOBSTAR){if(fe)return;ce+=I(2,Ee===re.length-1)}else{let be=!1,ee="",ve=!1,Ae="";for(const Fe of ie){if(Fe!=="}"&&be){ee+=Fe;continue}if(ve&&(Fe!=="]"||!Ae)){let $e;Fe==="-"?$e=Fe:(Fe==="^"||Fe==="!")&&!Ae?$e="^":Fe===e.GLOB_SPLIT?$e="":$e=(0,E.escapeRegExpCharacters)(Fe),Ae+=$e;continue}switch(Fe){case"{":be=!0;continue;case"[":ve=!0;continue;case"}":{ce+=`(?:${f(ee,",").map(Ie=>h(Ie)).join("|")})`,be=!1,ee="";break}case"]":{ce+="["+Ae+"]",ve=!1,Ae="";break}case"?":ce+=y;continue;case"*":ce+=I(1);continue;default:ce+=(0,E.escapeRegExpCharacters)(Fe)}}Ee<re.length-1&&(re[Ee+1]!==e.GLOBSTAR||Ee+2<re.length)&&(ce+=R)}fe=ie===e.GLOBSTAR})}return ce}const d=/^\*\*\/\*\.[\w\.-]+$/,a=/^\*\*\/([\w\.-]+)\/?$/,v=/^{\*\*\/\*?[\w\.-]+\/?(,\*\*\/\*?[\w\.-]+\/?)*}$/,A=/^{\*\*\/\*?[\w\.-]+(\/(\*\*)?)?(,\*\*\/\*?[\w\.-]+(\/(\*\*)?)?)*}$/,l=/^\*\*((\/[\w\.-]+)+)\/?$/,_=/^([\w\.-]+(\/[\w\.-]+)*)\/?$/,s=new L.LRUCache(1e4),u=function(){return!1},n=function(){return null};function i(ne,ce){if(!ne)return n;let re;typeof ne!="string"?re=ne.pattern:re=ne,re=re.trim();const fe=`${re}_${!!ce.trimForExclusions}`;let ie=s.get(fe);if(ie)return r(ie,ne);let Ee;return d.test(re)?ie=c(re.substr(4),re):(Ee=a.exec(t(re,ce)))?ie=w(Ee[1],re):(ce.trimForExclusions?A:v).test(re)?ie=g(re,ce):(Ee=l.exec(t(re,ce)))?ie=C(Ee[1].substr(1),re,!0):(Ee=_.exec(t(re,ce)))?ie=C(Ee[1],re,!1):ie=U(re),s.set(fe,ie),r(ie,ne)}function r(ne,ce){if(typeof ce=="string")return ne;const re=function(fe,ie){return(0,b.isEqualOrParent)(fe,ce.base,!T.isLinux)?ne(fe.substr(ce.base.length+1),ie):null};return re.allBasenames=ne.allBasenames,re.allPaths=ne.allPaths,re.basenames=ne.basenames,re.patterns=ne.patterns,re}function t(ne,ce){return ce.trimForExclusions&&ne.endsWith("/**")?ne.substr(0,ne.length-2):ne}function c(ne,ce){return function(re,fe){return typeof re=="string"&&re.endsWith(ne)?ce:null}}function w(ne,ce){const re=`/${ne}`,fe=`\\${ne}`,ie=function(be,ee){return typeof be!="string"?null:ee?ee===ne?ce:null:be===ne||be.endsWith(re)||be.endsWith(fe)?ce:null},Ee=[ne];return ie.basenames=Ee,ie.patterns=[ce],ie.allBasenames=Ee,ie}function g(ne,ce){const re=V(ne.slice(1,-1).split(",").map(ee=>i(ee,ce)).filter(ee=>ee!==n),ne),fe=re.length;if(!fe)return n;if(fe===1)return re[0];const ie=function(ee,ve){for(let Ae=0,Fe=re.length;Ae<Fe;Ae++)if(re[Ae](ee,ve))return ne;return null},Ee=re.find(ee=>!!ee.allBasenames);Ee&&(ie.allBasenames=Ee.allBasenames);const be=re.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(ie.allPaths=be),ie}function C(ne,ce,re){const fe=D.sep===D.posix.sep,ie=fe?ne:ne.replace(m,D.sep),Ee=D.sep+ie,be=D.posix.sep+ne;let ee;return re?ee=function(ve,Ae){return typeof ve=="string"&&(ve===ie||ve.endsWith(Ee)||!fe&&(ve===ne||ve.endsWith(be)))?ce:null}:ee=function(ve,Ae){return typeof ve=="string"&&(ve===ie||!fe&&ve===ne)?ce:null},ee.allPaths=[(re?"*/":"./")+ne],ee}function U(ne){try{const ce=new RegExp(`^${h(ne)}$`);return function(re){return ce.lastIndex=0,typeof re=="string"&&ce.test(re)?ne:null}}catch{return n}}function W(ne,ce,re){return!ne||typeof ce!="string"?!1:M(ne)(ce,void 0,re)}e.match=W;function M(ne,ce={}){if(!ne)return u;if(typeof ne=="string"||S(ne)){const re=i(ne,ce);if(re===n)return u;const fe=function(ie,Ee){return!!re(ie,Ee)};return re.allBasenames&&(fe.allBasenames=re.allBasenames),re.allPaths&&(fe.allPaths=re.allPaths),fe}return N(ne,ce)}e.parse=M;function S(ne){const ce=ne;return ce?typeof ce.base=="string"&&typeof ce.pattern=="string":!1}e.isRelativePattern=S;function z(ne){return ne.allBasenames||[]}e.getBasenameTerms=z;function $(ne){return ne.allPaths||[]}e.getPathTerms=$;function N(ne,ce){const re=V(Object.getOwnPropertyNames(ne).map(ee=>K(ee,ne[ee],ce)).filter(ee=>ee!==n)),fe=re.length;if(!fe)return n;if(!re.some(ee=>!!ee.requiresSiblings)){if(fe===1)return re[0];const ee=function(Fe,$e){let Qe;for(let Ie=0,Se=re.length;Ie<Se;Ie++){const Te=re[Ie](Fe,$e);if(typeof Te=="string")return Te;(0,p.isThenable)(Te)&&(Qe||(Qe=[]),Qe.push(Te))}return Qe?(async()=>{for(const Ie of Qe){const Se=await Ie;if(typeof Se=="string")return Se}return null})():null},ve=re.find(Fe=>!!Fe.allBasenames);ve&&(ee.allBasenames=ve.allBasenames);const Ae=re.reduce((Fe,$e)=>$e.allPaths?Fe.concat($e.allPaths):Fe,[]);return Ae.length&&(ee.allPaths=Ae),ee}const ie=function(ee,ve,Ae){let Fe,$e;for(let Qe=0,Ie=re.length;Qe<Ie;Qe++){const Se=re[Qe];Se.requiresSiblings&&Ae&&(ve||(ve=(0,D.basename)(ee)),Fe||(Fe=ve.substr(0,ve.length-(0,D.extname)(ee).length)));const Te=Se(ee,ve,Fe,Ae);if(typeof Te=="string")return Te;(0,p.isThenable)(Te)&&($e||($e=[]),$e.push(Te))}return $e?(async()=>{for(const Qe of $e){const Ie=await Qe;if(typeof Ie=="string")return Ie}return null})():null},Ee=re.find(ee=>!!ee.allBasenames);Ee&&(ie.allBasenames=Ee.allBasenames);const be=re.reduce((ee,ve)=>ve.allPaths?ee.concat(ve.allPaths):ee,[]);return be.length&&(ie.allPaths=be),ie}function K(ne,ce,re){if(ce===!1)return n;const fe=i(ne,re);if(fe===n)return n;if(typeof ce=="boolean")return fe;if(ce){const ie=ce.when;if(typeof ie=="string"){const Ee=(be,ee,ve,Ae)=>{if(!Ae||!fe(be,ee))return null;const Fe=ie.replace("$(basename)",ve),$e=Ae(Fe);return(0,p.isThenable)($e)?$e.then(Qe=>Qe?ne:null):$e?ne:null};return Ee.requiresSiblings=!0,Ee}}return fe}function V(ne,ce){const re=ne.filter(ee=>!!ee.basenames);if(re.length<2)return ne;const fe=re.reduce((ee,ve)=>{const Ae=ve.basenames;return Ae?ee.concat(Ae):ee},[]);let ie;if(ce){ie=[];for(let ee=0,ve=fe.length;ee<ve;ee++)ie.push(ce)}else ie=re.reduce((ee,ve)=>{const Ae=ve.patterns;return Ae?ee.concat(Ae):ee},[]);const Ee=function(ee,ve){if(typeof ee!="string")return null;if(!ve){let Fe;for(Fe=ee.length;Fe>0;Fe--){const $e=ee.charCodeAt(Fe-1);if($e===47||$e===92)break}ve=ee.substr(Fe)}const Ae=fe.indexOf(ve);return Ae!==-1?ie[Ae]:null};Ee.basenames=fe,Ee.patterns=ie,Ee.allBasenames=fe;const be=ne.filter(ee=>!ee.basenames);return be.push(Ee),be}function F(ne,ce){return(0,o.equals)(ne,ce,(re,fe)=>typeof re=="string"&&typeof fe=="string"?re===fe:typeof re!="string"&&typeof fe!="string"?re.base===fe.base&&re.pattern===fe.pattern:!1)}e.patternsEquals=F}),define(De[75],Ce([1,0,11,114,21,9,2]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseHrefAndDimensions=e.removeMarkdownEscapes=e.escapeDoubleQuotes=e.escapeMarkdownSyntaxTokens=e.markdownStringEqual=e.isMarkdownString=e.isEmptyMarkdownString=e.MarkdownString=e.MarkdownStringTextNewlineStyle=void 0;var T;(function(d){d[d.Paragraph=0]="Paragraph",d[d.Break=1]="Break"})(T=e.MarkdownStringTextNewlineStyle||(e.MarkdownStringTextNewlineStyle={}));class E{constructor(a="",v=!1){if(this.value=a,typeof this.value!="string")throw(0,o.illegalArgument)("value");typeof v=="boolean"?(this.isTrusted=v,this.supportThemeIcons=!1,this.supportHtml=!1):(this.isTrusted=v.isTrusted??void 0,this.supportThemeIcons=v.supportThemeIcons??!1,this.supportHtml=v.supportHtml??!1)}appendText(a,v=0){return this.value+=m(this.supportThemeIcons?(0,p.escapeIcons)(a):a).replace(/([ \t]+)/g,(A,l)=>"&nbsp;".repeat(l.length)).replace(/\>/gm,"\\>").replace(/\n/g,v===1?`\\
`:`

`),this}appendMarkdown(a){return this.value+=a,this}appendCodeblock(a,v){return this.value+="\n```",this.value+=a,this.value+=`
`,this.value+=v,this.value+="\n```\n",this}appendLink(a,v,A){return this.value+="[",this.value+=this._escape(v,"]"),this.value+="](",this.value+=this._escape(String(a),")"),A&&(this.value+=` "${this._escape(this._escape(A,'"'),")")}"`),this.value+=")",this}_escape(a,v){const A=new RegExp((0,L.escapeRegExpCharacters)(v),"g");return a.replace(A,(l,_)=>a.charAt(_-1)!=="\\"?`\\${l}`:l)}}e.MarkdownString=E;function P(d){return R(d)?!d.value:Array.isArray(d)?d.every(P):!0}e.isEmptyMarkdownString=P;function R(d){return d instanceof E?!0:d&&typeof d=="object"?typeof d.value=="string"&&(typeof d.isTrusted=="boolean"||d.isTrusted===void 0)&&(typeof d.supportThemeIcons=="boolean"||d.supportThemeIcons===void 0):!1}e.isMarkdownString=R;function y(d,a){return d===a?!0:!d||!a?!1:d.value===a.value&&d.isTrusted===a.isTrusted&&d.supportThemeIcons===a.supportThemeIcons&&d.supportHtml===a.supportHtml&&(d.baseUri===a.baseUri||!!d.baseUri&&!!a.baseUri&&(0,b.isEqual)(D.URI.from(d.baseUri),D.URI.from(a.baseUri)))}e.markdownStringEqual=y;function m(d){return d.replace(/[\\`*_{}[\]()#+\-!]/g,"\\$&")}e.escapeMarkdownSyntaxTokens=m;function I(d){return d.replace(/"/g,"&quot;")}e.escapeDoubleQuotes=I;function f(d){return d&&d.replace(/\\([\\`*_{}[\]()#+\-.!])/g,"$1")}e.removeMarkdownEscapes=f;function h(d){const a=[],v=d.split("|").map(l=>l.trim());d=v[0];const A=v[1];if(A){const l=/height=(\d+)/.exec(A),_=/width=(\d+)/.exec(A),s=l?l[1]:"",u=_?_[1]:"",n=isFinite(parseInt(u)),i=isFinite(parseInt(s));n&&a.push(`width="${u}"`),i&&a.push(`height="${s}"`)}return{href:d,dimensions:a}}e.parseHrefAndDimensions=h}),define(De[76],Ce([1,0,16,37,19,23,21,9]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.splitName=e.unmnemonicLabel=e.mnemonicButtonLabel=e.mnemonicMenuLabel=e.template=e.shorten=e.untildify=e.tildify=e.normalizeDriveLetter=e.getPathLabel=void 0;function E(n,i){const{os:r,tildify:t,relative:c}=i;if(c){const C=P(n,c,r);if(typeof C=="string")return C}let w=n.fsPath;if(r===1&&!L.isWindows?w=w.replace(/\//g,"\\"):r!==1&&L.isWindows&&(w=w.replace(/\\/g,"/")),r!==1&&t?.userHome){const C=t.userHome.fsPath;let U;n.scheme!==t.userHome.scheme&&n.path.startsWith(b.posix.sep)?U=t.userHome.with({path:n.path}).fsPath:U=n.fsPath,w=m(U,C,r)}return(r===1?b.win32:b.posix).normalize(R(w,r===1))}e.getPathLabel=E;function P(n,i,r){const t=r===1?b.win32:b.posix,c=r===3?D.extUri:D.extUriIgnorePathCase,w=i.getWorkspace(),g=(0,o.firstOrDefault)(w.folders);if(!g)return;n.scheme!==g.uri.scheme&&n.path.startsWith(b.posix.sep)&&(n=g.uri.with({path:n.path}));const C=i.getWorkspaceFolder(n);if(!C)return;let U;if(c.isEqual(C.uri,n)?U="":U=c.relativePath(C.uri,n)??"",U&&(U=t.normalize(U)),w.folders.length>1&&!i.noPrefix){const W=C.name?C.name:c.basenameOrAuthority(C.uri);U=U?`${W} \u2022 ${U}`:W}return U}function R(n,i=L.isWindows){return(0,p.hasDriveLetter)(n,i)?n.charAt(0).toUpperCase()+n.slice(1):n}e.normalizeDriveLetter=R;let y=Object.create(null);function m(n,i,r=L.OS){if(r===1||!n||!i)return n;let t=y.original===i?y.normalized:void 0;t||(t=i,L.isWindows&&(t=(0,p.toSlashes)(t)),t=`${(0,T.rtrim)(t,b.posix.sep)}${b.posix.sep}`,y={original:i,normalized:t});let c=n;return L.isWindows&&(c=(0,p.toSlashes)(c)),(r===3?c.startsWith(t):(0,T.startsWithIgnoreCase)(c,t))?`~/${c.substr(t.length)}`:n}e.tildify=m;function I(n,i){return n.replace(/^~($|\/|\\)/,`${i}$1`)}e.untildify=I;const f="\u2026",h="\\\\",d="~";function a(n,i=b.sep){const r=new Array(n.length);let t=!1;for(let c=0;c<n.length;c++){const w=n[c];if(w===""){r[c]=`.${i}`;continue}if(!w){r[c]=w;continue}t=!0;let g="",C=w;C.indexOf(h)===0?(g=C.substr(0,C.indexOf(h)+h.length),C=C.substr(C.indexOf(h)+h.length)):C.indexOf(i)===0?(g=C.substr(0,C.indexOf(i)+i.length),C=C.substr(C.indexOf(i)+i.length)):C.indexOf(d)===0&&(g=C.substr(0,C.indexOf(d)+d.length),C=C.substr(C.indexOf(d)+d.length));const U=C.split(i);for(let W=1;t&&W<=U.length;W++)for(let M=U.length-W;t&&M>=0;M--){t=!1;let S=U.slice(M,M+W).join(i);for(let z=0;!t&&z<n.length;z++)if(z!==c&&n[z]&&n[z].indexOf(S)>-1){const $=M+W===U.length,N=M>0&&n[z].indexOf(i)>-1?i+S:S,K=n[z].endsWith(N);t=!$||K}if(!t){let z="";(U[0].endsWith(":")||g!=="")&&(M===1&&(M=0,W++,S=U[0]+i+S),M>0&&(z=U[0]+i),z=g+z),M>0&&(z=z+f+i),z=z+S,M+W<U.length&&(z=z+i+f),r[c]=z}}t&&(r[c]=w)}return r}e.shorten=a;var v;(function(n){n[n.TEXT=0]="TEXT",n[n.VARIABLE=1]="VARIABLE",n[n.SEPARATOR=2]="SEPARATOR"})(v||(v={}));function A(n,i=Object.create(null)){const r=[];let t=!1,c="";for(const w of n)if(w==="$"||t&&w==="{")c&&r.push({value:c,type:v.TEXT}),c="",t=!0;else if(w==="}"&&t){const g=i[c];if(typeof g=="string")g.length&&r.push({value:g,type:v.VARIABLE});else if(g){const C=r[r.length-1];(!C||C.type!==v.SEPARATOR)&&r.push({value:g.label,type:v.SEPARATOR})}c="",t=!1}else c+=w;return c&&!t&&r.push({value:c,type:v.TEXT}),r.filter((w,g)=>{if(w.type===v.SEPARATOR){const C=r[g-1],U=r[g+1];return[C,U].every(W=>W&&(W.type===v.VARIABLE||W.type===v.TEXT)&&W.value.length>0)}return!0}).map(w=>w.value).join("")}e.template=A;function l(n,i){return L.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,"").replace(/&/g,L.isMacintosh?"&":"&&"):n.replace(/&&|&/g,r=>r==="&"?"&&":"&")}e.mnemonicMenuLabel=l;function _(n,i){return L.isMacintosh||i?n.replace(/\(&&\w\)|&&/g,""):L.isWindows?n.replace(/&&|&/g,r=>r==="&"?"&&":"&"):n.replace(/&&/g,"_")}e.mnemonicButtonLabel=_;function s(n){return n.replace(/&/g,"&&")}e.unmnemonicLabel=s;function u(n){const i=n.indexOf("/")!==-1?b.posix:b.win32,r=i.basename(n),t=i.dirname(n);return r.length?{name:r,parentPath:t}:{name:t,parentPath:""}}e.splitName=u}),define(De[117],Ce([1,0,2]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.transformAndReviveIncomingURIs=e.transformIncomingURIs=e.transformOutgoingURIs=e.DefaultURITransformer=e.URITransformer=void 0;function p(R){return R.toJSON()}class b{constructor(y){this._uriTransformer=y}transformIncoming(y){const m=this._uriTransformer.transformIncoming(y);return m===y?y:p(o.URI.from(m))}transformOutgoing(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:p(o.URI.from(m))}transformOutgoingURI(y){const m=this._uriTransformer.transformOutgoing(y);return m===y?y:o.URI.from(m)}transformOutgoingScheme(y){return this._uriTransformer.transformOutgoingScheme(y)}}e.URITransformer=b,e.DefaultURITransformer=new class{transformIncoming(R){return R}transformOutgoing(R){return R}transformOutgoingURI(R){return R}transformOutgoingScheme(R){return R}};function L(R,y,m){if(!R||m>200)return null;if(typeof R=="object"){if(R instanceof o.URI)return y.transformOutgoing(R);for(const I in R)if(Object.hasOwnProperty.call(R,I)){const f=L(R[I],y,m+1);f!==null&&(R[I]=f)}}return null}function D(R,y){const m=L(R,y,0);return m===null?R:m}e.transformOutgoingURIs=D;function T(R,y,m,I){if(!R||I>200)return null;if(typeof R=="object"){if(R.$mid===1)return m?o.URI.revive(y.transformIncoming(R)):y.transformIncoming(R);for(const f in R)if(Object.hasOwnProperty.call(R,f)){const h=T(R[f],y,m,I+1);h!==null&&(R[f]=h)}}return null}function E(R,y){const m=T(R,y,!1,0);return m===null?R:m}e.transformIncomingURIs=E;function P(R,y){const m=T(R,y,!0,0);return m===null?R:m}e.transformAndReviveIncomingURIs=P}),define(De[118],Ce([1,0,34,19]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.score=void 0;function b(L,D,T,E,P,R){if(Array.isArray(L)){let y=0;for(const m of L){const I=b(m,D,T,E,P,R);if(I===10)return I;I>y&&(y=I)}return y}else{if(typeof L=="string")return E?L==="*"?5:L===T?10:0:0;if(L){const{language:y,pattern:m,scheme:I,hasAccessToAllModels:f,notebookType:h}=L;if(!E&&!f)return 0;h&&P&&(D=P);let d=0;if(I)if(I===D.scheme)d=10;else if(I==="*")d=5;else return 0;if(y)if(y===T)d=10;else if(y==="*")d=Math.max(d,5);else return 0;if(h)if(h===R)d=10;else if(h==="*"&&R!==void 0)d=Math.max(d,5);else return 0;if(m){let a;if(typeof m=="string"?a=m:a={...m,base:(0,p.normalize)(m.base)},a===D.fsPath||(0,o.match)(a,D.fsPath))d=10;else return 0}return d}else return 0}}e.score=b}),define(De[77],Ce([1,0,22,23]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeSemanticTokensDto=e.encodeSemanticTokensDto=void 0;var b;(function(y){y[y.Full=1]="Full",y[y.Delta=2]="Delta"})(b||(b={}));function L(y){for(let m=0,I=y.length;m<I;m+=4){const f=y[m+0],h=y[m+1],d=y[m+2],a=y[m+3];y[m+0]=a,y[m+1]=d,y[m+2]=h,y[m+3]=f}}function D(y){const m=new Uint8Array(y.buffer,y.byteOffset,y.length*4);return p.isLittleEndian()||L(m),o.VSBuffer.wrap(m)}function T(y){const m=y.buffer;if(p.isLittleEndian()||L(m),m.byteOffset%4==0)return new Uint32Array(m.buffer,m.byteOffset,m.length/4);{const I=new Uint8Array(m.byteLength);return I.set(m),new Uint32Array(I.buffer,I.byteOffset,I.length/4)}}function E(y){const m=new Uint32Array(P(y));let I=0;if(m[I++]=y.id,y.type==="full")m[I++]=1,m[I++]=y.data.length,m.set(y.data,I),I+=y.data.length;else{m[I++]=2,m[I++]=y.deltas.length;for(const f of y.deltas)m[I++]=f.start,m[I++]=f.deleteCount,f.data?(m[I++]=f.data.length,m.set(f.data,I),I+=f.data.length):m[I++]=0}return D(m)}e.encodeSemanticTokensDto=E;function P(y){let m=0;if(m+=1+1,y.type==="full")m+=1+y.data.length;else{m+=1,m+=(1+1+1)*y.deltas.length;for(const I of y.deltas)I.data&&(m+=I.data.length)}return m}function R(y){const m=T(y);let I=0;const f=m[I++];if(m[I++]===1){const v=m[I++],A=m.subarray(I,I+v);return I+=v,{id:f,type:"full",data:A}}const d=m[I++],a=[];for(let v=0;v<d;v++){const A=m[I++],l=m[I++],_=m[I++];let s;_>0&&(s=m.subarray(I,I+_),I+=_),a[v]={start:A,deleteCount:l,data:s}}return{id:f,type:"delta",deltas:a}}e.decodeSemanticTokensDto=R}),define(De[119],Ce([17,18]),function(te,e){return te.create("vs/editor/common/config/editorOptions",e)}),define(De[120],Ce([1,0,119,23,121,16,26,108]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.EditorOptions=e.EditorOption=e.editorOptionsRegistry=e.EDITOR_FONT_DEFAULTS=e.WrappingIndent=e.unicodeHighlightConfigKeys=e.inUntrustedWorkspace=e.filterValidationDecorations=e.RenderLineNumbersType=e.EditorLayoutInfoComputer=e.RenderMinimap=e.EditorFontLigatures=e.cursorStyleToString=e.TextEditorCursorStyle=e.TextEditorCursorBlinkingStyle=e.stringSet=e.clampedInt=e.boolean=e.ApplyUpdateResult=e.ComputeOptionsMemory=e.ConfigurationChangedEvent=e.MINIMAP_GUTTER_WIDTH=e.EditorAutoIndentStrategy=void 0;var E;(function(G){G[G.None=0]="None",G[G.Keep=1]="Keep",G[G.Brackets=2]="Brackets",G[G.Advanced=3]="Advanced",G[G.Full=4]="Full"})(E=e.EditorAutoIndentStrategy||(e.EditorAutoIndentStrategy={})),e.MINIMAP_GUTTER_WIDTH=8;class P{constructor(Q){this._values=Q}hasChanged(Q){return this._values[Q]}}e.ConfigurationChangedEvent=P;class R{constructor(){this.stableMinimapLayoutInput=null,this.stableFitMaxMinimapScale=0,this.stableFitRemainingWidth=0}}e.ComputeOptionsMemory=R;class y{constructor(Q,he,Ue,We){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=We}applyUpdate(Q,he){return I(Q,he)}compute(Q,he,Ue){return Ue}}class m{constructor(Q,he){this.newValue=Q,this.didChange=he}}e.ApplyUpdateResult=m;function I(G,Q){if(typeof G!="object"||typeof Q!="object"||!G||!Q)return new m(Q,G!==Q);if(Array.isArray(G)||Array.isArray(Q)){const Ue=Array.isArray(G)&&Array.isArray(Q)&&L.equals(G,Q);return new m(Q,!Ue)}let he=!1;for(const Ue in Q)if(Q.hasOwnProperty(Ue)){const We=I(G[Ue],Q[Ue]);We.didChange&&(G[Ue]=We.newValue,he=!0)}return new m(G,he)}class f{constructor(Q){this.schema=void 0,this.id=Q,this.name="_never_",this.defaultValue=void 0}applyUpdate(Q,he){return I(Q,he)}validate(Q){return this.defaultValue}}class h{constructor(Q,he,Ue,We){this.id=Q,this.name=he,this.defaultValue=Ue,this.schema=We}applyUpdate(Q,he){return I(Q,he)}validate(Q){return typeof Q=="undefined"?this.defaultValue:Q}compute(Q,he,Ue){return Ue}}function d(G,Q){return typeof G=="undefined"?Q:G==="false"?!1:Boolean(G)}e.boolean=d;class a extends h{constructor(Q,he,Ue,We=void 0){typeof We!="undefined"&&(We.type="boolean",We.default=Ue);super(Q,he,Ue,We)}validate(Q){return d(Q,this.defaultValue)}}function v(G,Q,he,Ue){if(typeof G=="undefined")return Q;let We=parseInt(G,10);return isNaN(We)?Q:(We=Math.max(he,We),We=Math.min(Ue,We),We|0)}e.clampedInt=v;class A extends h{constructor(Q,he,Ue,We,et,je=void 0){typeof je!="undefined"&&(je.type="integer",je.default=Ue,je.minimum=We,je.maximum=et);super(Q,he,Ue,je);this.minimum=We,this.maximum=et}static clampedInt(Q,he,Ue,We){return v(Q,he,Ue,We)}validate(Q){return A.clampedInt(Q,this.defaultValue,this.minimum,this.maximum)}}class l extends h{constructor(Q,he,Ue,We,et){typeof et!="undefined"&&(et.type="number",et.default=Ue);super(Q,he,Ue,et);this.validationFn=We}static clamp(Q,he,Ue){return Q<he?he:Q>Ue?Ue:Q}static float(Q,he){if(typeof Q=="number")return Q;if(typeof Q=="undefined")return he;const Ue=parseFloat(Q);return isNaN(Ue)?he:Ue}validate(Q){return this.validationFn(l.float(Q,this.defaultValue))}}class _ extends h{static string(Q,he){return typeof Q!="string"?he:Q}constructor(Q,he,Ue,We=void 0){typeof We!="undefined"&&(We.type="string",We.default=Ue);super(Q,he,Ue,We)}validate(Q){return _.string(Q,this.defaultValue)}}function s(G,Q,he){return typeof G!="string"||he.indexOf(G)===-1?Q:G}e.stringSet=s;class u extends h{constructor(Q,he,Ue,We,et=void 0){typeof et!="undefined"&&(et.type="string",et.enum=We,et.default=Ue);super(Q,he,Ue,et);this._allowedValues=We}validate(Q){return s(Q,this.defaultValue,this._allowedValues)}}class n extends y{constructor(Q,he,Ue,We,et,je,He=void 0){typeof He!="undefined"&&(He.type="string",He.enum=et,He.default=We);super(Q,he,Ue,He);this._allowedValues=et,this._convert=je}validate(Q){return typeof Q!="string"?this.defaultValue:this._allowedValues.indexOf(Q)===-1?this.defaultValue:this._convert(Q)}}function i(G){switch(G){case"none":return 0;case"keep":return 1;case"brackets":return 2;case"advanced":return 3;case"full":return 4}}class r extends y{constructor(){super(2,"accessibilitySupport",0,{type:"string",enum:["auto","on","off"],enumDescriptions:[o.localize(0,null),o.localize(1,null),o.localize(2,null)],default:"auto",description:o.localize(3,null)})}validate(Q){switch(Q){case"auto":return 0;case"off":return 1;case"on":return 2}return this.defaultValue}compute(Q,he,Ue){return Ue===0?Q.accessibilitySupport:Ue}}class t extends y{constructor(){const Q={insertSpace:!0,ignoreEmptyLines:!0};super(19,"comments",Q,{"editor.comments.insertSpace":{type:"boolean",default:Q.insertSpace,description:o.localize(4,null)},"editor.comments.ignoreEmptyLines":{type:"boolean",default:Q.ignoreEmptyLines,description:o.localize(5,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertSpace:d(he.insertSpace,this.defaultValue.insertSpace),ignoreEmptyLines:d(he.ignoreEmptyLines,this.defaultValue.ignoreEmptyLines)}}}var c;(function(G){G[G.Hidden=0]="Hidden",G[G.Blink=1]="Blink",G[G.Smooth=2]="Smooth",G[G.Phase=3]="Phase",G[G.Expand=4]="Expand",G[G.Solid=5]="Solid"})(c=e.TextEditorCursorBlinkingStyle||(e.TextEditorCursorBlinkingStyle={}));function w(G){switch(G){case"blink":return 1;case"smooth":return 2;case"phase":return 3;case"expand":return 4;case"solid":return 5}}var g;(function(G){G[G.Line=1]="Line",G[G.Block=2]="Block",G[G.Underline=3]="Underline",G[G.LineThin=4]="LineThin",G[G.BlockOutline=5]="BlockOutline",G[G.UnderlineThin=6]="UnderlineThin"})(g=e.TextEditorCursorStyle||(e.TextEditorCursorStyle={}));function C(G){switch(G){case g.Line:return"line";case g.Block:return"block";case g.Underline:return"underline";case g.LineThin:return"line-thin";case g.BlockOutline:return"block-outline";case g.UnderlineThin:return"underline-thin"}}e.cursorStyleToString=C;function U(G){switch(G){case"line":return g.Line;case"block":return g.Block;case"underline":return g.Underline;case"line-thin":return g.LineThin;case"block-outline":return g.BlockOutline;case"underline-thin":return g.UnderlineThin}}class W extends f{constructor(){super(130)}compute(Q,he,Ue){const We=["monaco-editor"];return he.get(35)&&We.push(he.get(35)),Q.extraEditorClassName&&We.push(Q.extraEditorClassName),he.get(68)==="default"?We.push("mouse-default"):he.get(68)==="copy"&&We.push("mouse-copy"),he.get(102)&&We.push("showUnused"),he.get(128)&&We.push("showDeprecated"),We.join(" ")}}class M extends a{constructor(){super(33,"emptySelectionClipboard",!0,{description:o.localize(6,null)})}compute(Q,he,Ue){return Ue&&Q.emptySelectionClipboard}}class S extends y{constructor(){const Q={cursorMoveOnType:!0,seedSearchStringFromSelection:"always",autoFindInSelection:"never",globalFindClipboard:!1,addExtraSpaceOnTop:!0,loop:!0};super(37,"find",Q,{"editor.find.cursorMoveOnType":{type:"boolean",default:Q.cursorMoveOnType,description:o.localize(7,null)},"editor.find.seedSearchStringFromSelection":{type:"string",enum:["never","always","selection"],default:Q.seedSearchStringFromSelection,enumDescriptions:[o.localize(8,null),o.localize(9,null),o.localize(10,null)],description:o.localize(11,null)},"editor.find.autoFindInSelection":{type:"string",enum:["never","always","multiline"],default:Q.autoFindInSelection,enumDescriptions:[o.localize(12,null),o.localize(13,null),o.localize(14,null)],description:o.localize(15,null)},"editor.find.globalFindClipboard":{type:"boolean",default:Q.globalFindClipboard,description:o.localize(16,null),included:p.isMacintosh},"editor.find.addExtraSpaceOnTop":{type:"boolean",default:Q.addExtraSpaceOnTop,description:o.localize(17,null)},"editor.find.loop":{type:"boolean",default:Q.loop,description:o.localize(18,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{cursorMoveOnType:d(he.cursorMoveOnType,this.defaultValue.cursorMoveOnType),seedSearchStringFromSelection:typeof Q.seedSearchStringFromSelection=="boolean"?Q.seedSearchStringFromSelection?"always":"never":s(he.seedSearchStringFromSelection,this.defaultValue.seedSearchStringFromSelection,["never","always","selection"]),autoFindInSelection:typeof Q.autoFindInSelection=="boolean"?Q.autoFindInSelection?"always":"never":s(he.autoFindInSelection,this.defaultValue.autoFindInSelection,["never","always","multiline"]),globalFindClipboard:d(he.globalFindClipboard,this.defaultValue.globalFindClipboard),addExtraSpaceOnTop:d(he.addExtraSpaceOnTop,this.defaultValue.addExtraSpaceOnTop),loop:d(he.loop,this.defaultValue.loop)}}}class z extends y{constructor(){super(47,"fontLigatures",z.OFF,{anyOf:[{type:"boolean",description:o.localize(19,null)},{type:"string",description:o.localize(20,null)}],description:o.localize(21,null),default:!1})}validate(Q){return typeof Q=="undefined"?this.defaultValue:typeof Q=="string"?Q==="false"?z.OFF:Q==="true"?z.ON:Q:Boolean(Q)?z.ON:z.OFF}}e.EditorFontLigatures=z,z.OFF='"liga" off, "calt" off',z.ON='"liga" on, "calt" on';class $ extends f{constructor(){super(46)}compute(Q,he,Ue){return Q.fontInfo}}class N extends h{constructor(){super(48,"fontSize",e.EDITOR_FONT_DEFAULTS.fontSize,{type:"number",minimum:6,maximum:100,default:e.EDITOR_FONT_DEFAULTS.fontSize,description:o.localize(22,null)})}validate(Q){const he=l.float(Q,this.defaultValue);return he===0?e.EDITOR_FONT_DEFAULTS.fontSize:l.clamp(he,6,100)}compute(Q,he,Ue){return Q.fontInfo.fontSize}}class K extends y{constructor(){super(49,"fontWeight",e.EDITOR_FONT_DEFAULTS.fontWeight,{anyOf:[{type:"number",minimum:K.MINIMUM_VALUE,maximum:K.MAXIMUM_VALUE,errorMessage:o.localize(23,null)},{type:"string",pattern:"^(normal|bold|1000|[1-9][0-9]{0,2})$"},{enum:K.SUGGESTION_VALUES}],default:e.EDITOR_FONT_DEFAULTS.fontWeight,description:o.localize(24,null)})}validate(Q){return Q==="normal"||Q==="bold"?Q:String(A.clampedInt(Q,e.EDITOR_FONT_DEFAULTS.fontWeight,K.MINIMUM_VALUE,K.MAXIMUM_VALUE))}}K.SUGGESTION_VALUES=["normal","bold","100","200","300","400","500","600","700","800","900"],K.MINIMUM_VALUE=1,K.MAXIMUM_VALUE=1e3;class V extends y{constructor(){const Q={multiple:"peek",multipleDefinitions:"peek",multipleTypeDefinitions:"peek",multipleDeclarations:"peek",multipleImplementations:"peek",multipleReferences:"peek",alternativeDefinitionCommand:"editor.action.goToReferences",alternativeTypeDefinitionCommand:"editor.action.goToReferences",alternativeDeclarationCommand:"editor.action.goToReferences",alternativeImplementationCommand:"",alternativeReferenceCommand:""},he={type:"string",enum:["peek","gotoAndPeek","goto"],default:Q.multiple,enumDescriptions:[o.localize(25,null),o.localize(26,null),o.localize(27,null)]},Ue=["","editor.action.referenceSearch.trigger","editor.action.goToReferences","editor.action.peekImplementation","editor.action.goToImplementation","editor.action.peekTypeDefinition","editor.action.goToTypeDefinition","editor.action.peekDeclaration","editor.action.revealDeclaration","editor.action.peekDefinition","editor.action.revealDefinitionAside","editor.action.revealDefinition"];super(53,"gotoLocation",Q,{"editor.gotoLocation.multiple":{deprecationMessage:o.localize(28,null)},"editor.gotoLocation.multipleDefinitions":{description:o.localize(29,null),...he},"editor.gotoLocation.multipleTypeDefinitions":{description:o.localize(30,null),...he},"editor.gotoLocation.multipleDeclarations":{description:o.localize(31,null),...he},"editor.gotoLocation.multipleImplementations":{description:o.localize(32,null),...he},"editor.gotoLocation.multipleReferences":{description:o.localize(33,null),...he},"editor.gotoLocation.alternativeDefinitionCommand":{type:"string",default:Q.alternativeDefinitionCommand,enum:Ue,description:o.localize(34,null)},"editor.gotoLocation.alternativeTypeDefinitionCommand":{type:"string",default:Q.alternativeTypeDefinitionCommand,enum:Ue,description:o.localize(35,null)},"editor.gotoLocation.alternativeDeclarationCommand":{type:"string",default:Q.alternativeDeclarationCommand,enum:Ue,description:o.localize(36,null)},"editor.gotoLocation.alternativeImplementationCommand":{type:"string",default:Q.alternativeImplementationCommand,enum:Ue,description:o.localize(37,null)},"editor.gotoLocation.alternativeReferenceCommand":{type:"string",default:Q.alternativeReferenceCommand,enum:Ue,description:o.localize(38,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{multiple:s(he.multiple,this.defaultValue.multiple,["peek","gotoAndPeek","goto"]),multipleDefinitions:he.multipleDefinitions??s(he.multipleDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleTypeDefinitions:he.multipleTypeDefinitions??s(he.multipleTypeDefinitions,"peek",["peek","gotoAndPeek","goto"]),multipleDeclarations:he.multipleDeclarations??s(he.multipleDeclarations,"peek",["peek","gotoAndPeek","goto"]),multipleImplementations:he.multipleImplementations??s(he.multipleImplementations,"peek",["peek","gotoAndPeek","goto"]),multipleReferences:he.multipleReferences??s(he.multipleReferences,"peek",["peek","gotoAndPeek","goto"]),alternativeDefinitionCommand:_.string(he.alternativeDefinitionCommand,this.defaultValue.alternativeDefinitionCommand),alternativeTypeDefinitionCommand:_.string(he.alternativeTypeDefinitionCommand,this.defaultValue.alternativeTypeDefinitionCommand),alternativeDeclarationCommand:_.string(he.alternativeDeclarationCommand,this.defaultValue.alternativeDeclarationCommand),alternativeImplementationCommand:_.string(he.alternativeImplementationCommand,this.defaultValue.alternativeImplementationCommand),alternativeReferenceCommand:_.string(he.alternativeReferenceCommand,this.defaultValue.alternativeReferenceCommand)}}}class F extends y{constructor(){const Q={enabled:!0,delay:300,sticky:!0,above:!0};super(55,"hover",Q,{"editor.hover.enabled":{type:"boolean",default:Q.enabled,description:o.localize(39,null)},"editor.hover.delay":{type:"number",default:Q.delay,minimum:0,maximum:1e4,description:o.localize(40,null)},"editor.hover.sticky":{type:"boolean",default:Q.sticky,description:o.localize(41,null)},"editor.hover.above":{type:"boolean",default:Q.above,description:o.localize(42,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),delay:A.clampedInt(he.delay,this.defaultValue.delay,0,1e4),sticky:d(he.sticky,this.defaultValue.sticky),above:d(he.above,this.defaultValue.above)}}}var ne;(function(G){G[G.None=0]="None",G[G.Text=1]="Text",G[G.Blocks=2]="Blocks"})(ne=e.RenderMinimap||(e.RenderMinimap={}));class ce extends f{constructor(){super(133)}compute(Q,he,Ue){return ce.computeLayout(he,{memory:Q.memory,outerWidth:Q.outerWidth,outerHeight:Q.outerHeight,isDominatedByLongLines:Q.isDominatedByLongLines,lineHeight:Q.fontInfo.lineHeight,viewLineCount:Q.viewLineCount,lineNumbersDigitCount:Q.lineNumbersDigitCount,typicalHalfwidthCharacterWidth:Q.fontInfo.typicalHalfwidthCharacterWidth,maxDigitWidth:Q.fontInfo.maxDigitWidth,pixelRatio:Q.pixelRatio})}static computeContainedMinimapLineCount(Q){const he=Q.height/Q.lineHeight,Ue=Q.scrollBeyondLastLine?he-1:0,We=(Q.viewLineCount+Ue)/(Q.pixelRatio*Q.height),et=Math.floor(Q.viewLineCount/We);return{typicalViewportLineCount:he,extraLinesBeyondLastLine:Ue,desiredRatio:We,minimapLineCount:et}}static _computeMinimapLayout(Q,he){const Ue=Q.outerWidth,We=Q.outerHeight,et=Q.pixelRatio;if(!Q.minimap.enabled)return{renderMinimap:0,minimapLeft:0,minimapWidth:0,minimapHeightIsEditorHeight:!1,minimapIsSampling:!1,minimapScale:1,minimapLineHeight:1,minimapCanvasInnerWidth:0,minimapCanvasInnerHeight:Math.floor(et*We),minimapCanvasOuterWidth:0,minimapCanvasOuterHeight:We};const je=he.stableMinimapLayoutInput,He=je&&Q.outerHeight===je.outerHeight&&Q.lineHeight===je.lineHeight&&Q.typicalHalfwidthCharacterWidth===je.typicalHalfwidthCharacterWidth&&Q.pixelRatio===je.pixelRatio&&Q.scrollBeyondLastLine===je.scrollBeyondLastLine&&Q.minimap.enabled===je.minimap.enabled&&Q.minimap.side===je.minimap.side&&Q.minimap.size===je.minimap.size&&Q.minimap.showSlider===je.minimap.showSlider&&Q.minimap.renderCharacters===je.minimap.renderCharacters&&Q.minimap.maxColumn===je.minimap.maxColumn&&Q.minimap.scale===je.minimap.scale&&Q.verticalScrollbarWidth===je.verticalScrollbarWidth&&Q.isViewportWrapping===je.isViewportWrapping,it=Q.lineHeight,rt=Q.typicalHalfwidthCharacterWidth,dt=Q.scrollBeyondLastLine,lt=Q.minimap.renderCharacters;let st=et>=2?Math.round(Q.minimap.scale*2):Q.minimap.scale;const yt=Q.minimap.maxColumn,Ot=Q.minimap.size,Ft=Q.minimap.side,ft=Q.verticalScrollbarWidth,Dt=Q.viewLineCount,Ut=Q.remainingWidth,Nt=Q.isViewportWrapping,Ve=lt?2:3;let Mt=Math.floor(et*We);const At=Mt/et;let Lt=!1,gt=!1,It=Ve*st,we=st/et,ye=1;if(Ot==="fill"||Ot==="fit"){const{typicalViewportLineCount:Ke,extraLinesBeyondLastLine:pt,desiredRatio:bt,minimapLineCount:kt}=ce.computeContainedMinimapLineCount({viewLineCount:Dt,scrollBeyondLastLine:dt,height:We,lineHeight:it,pixelRatio:et});if(Dt/kt>1)Lt=!0,gt=!0,st=1,It=1,we=st/et;else{let ht=!1,Rt=st+1;if(Ot==="fit"){const _t=Math.ceil((Dt+pt)*It);Nt&&He&&Ut<=he.stableFitRemainingWidth?(ht=!0,Rt=he.stableFitMaxMinimapScale):ht=_t>Mt}if(Ot==="fill"||ht){Lt=!0;const _t=st;It=Math.min(it*et,Math.max(1,Math.floor(1/bt))),Nt&&He&&Ut<=he.stableFitRemainingWidth&&(Rt=he.stableFitMaxMinimapScale),st=Math.min(Rt,Math.max(1,Math.floor(It/Ve))),st>_t&&(ye=Math.min(2,st/_t)),we=st/et/ye,Mt=Math.ceil(Math.max(Ke,Dt+pt)*It),Nt?(he.stableMinimapLayoutInput=Q,he.stableFitRemainingWidth=Ut,he.stableFitMaxMinimapScale=st):(he.stableMinimapLayoutInput=null,he.stableFitRemainingWidth=0)}}}const me=Math.floor(yt*we),q=Math.min(me,Math.max(0,Math.floor((Ut-ft-2)*we/(rt+we)))+e.MINIMAP_GUTTER_WIDTH);let Pe=Math.floor(et*q);const Le=Pe/et;Pe=Math.floor(Pe*ye);const Ye=lt?1:2,Xe=Ft==="left"?0:Ue-q-ft;return{renderMinimap:Ye,minimapLeft:Xe,minimapWidth:q,minimapHeightIsEditorHeight:Lt,minimapIsSampling:gt,minimapScale:st,minimapLineHeight:It,minimapCanvasInnerWidth:Pe,minimapCanvasInnerHeight:Mt,minimapCanvasOuterWidth:Le,minimapCanvasOuterHeight:At}}static computeLayout(Q,he){const Ue=he.outerWidth|0,We=he.outerHeight|0,et=he.lineHeight|0,je=he.lineNumbersDigitCount|0,He=he.typicalHalfwidthCharacterWidth,it=he.maxDigitWidth,rt=he.pixelRatio,dt=he.viewLineCount,lt=Q.get(125),st=lt==="inherit"?Q.get(124):lt,yt=st==="inherit"?Q.get(120):st,Ot=Q.get(123),Ft=Q.get(2),ft=he.isDominatedByLongLines,Dt=Q.get(52),Ut=Q.get(62).renderType!==0,Nt=Q.get(63),Ve=Q.get(96),Mt=Q.get(67),At=Q.get(94),Lt=At.verticalScrollbarSize,gt=At.verticalHasArrows,It=At.arrowSize,we=At.horizontalScrollbarSize,ye=Q.get(60),me=Q.get(39),q=Q.get(101)!=="never";let Pe;if(typeof ye=="string"&&/^\d+(\.\d+)?ch$/.test(ye)){const Ht=parseFloat(ye.substr(0,ye.length-2));Pe=A.clampedInt(Ht*He,0,0,1e3)}else Pe=A.clampedInt(ye,0,0,1e3);me&&q&&(Pe+=16);let Le=0;if(Ut){const Ht=Math.max(je,Nt);Le=Math.round(Ht*it)}let Ye=0;Dt&&(Ye=et);let Xe=0,Ke=Xe+Ye,pt=Ke+Le,bt=pt+Pe;const kt=Ue-Ye-Le-Pe;let Et=!1,ht=!1,Rt=-1;Ft!==2&&(st==="inherit"&&ft?(Et=!0,ht=!0):yt==="on"||yt==="bounded"?ht=!0:yt==="wordWrapColumn"&&(Rt=Ot));const _t=ce._computeMinimapLayout({outerWidth:Ue,outerHeight:We,lineHeight:et,typicalHalfwidthCharacterWidth:He,pixelRatio:rt,scrollBeyondLastLine:Ve,minimap:Mt,verticalScrollbarWidth:Lt,viewLineCount:dt,remainingWidth:kt,isViewportWrapping:ht},he.memory||new R);_t.renderMinimap!==0&&_t.minimapLeft===0&&(Xe+=_t.minimapWidth,Ke+=_t.minimapWidth,pt+=_t.minimapWidth,bt+=_t.minimapWidth);const vt=kt-_t.minimapWidth,Gt=Math.max(1,Math.floor((vt-Lt-2)/He)),Xt=gt?It:0;return ht&&(Rt=Math.max(1,Gt),yt==="bounded"&&(Rt=Math.min(Rt,Ot))),{width:Ue,height:We,glyphMarginLeft:Xe,glyphMarginWidth:Ye,lineNumbersLeft:Ke,lineNumbersWidth:Le,decorationsLeft:pt,decorationsWidth:Pe,contentLeft:bt,contentWidth:vt,minimap:_t,viewportColumn:Gt,isWordWrapMinified:Et,isViewportWrapping:ht,wrappingColumn:Rt,verticalScrollbarWidth:Lt,horizontalScrollbarHeight:we,overviewRuler:{top:Xt,width:Lt,height:We-2*Xt,right:0}}}}e.EditorLayoutInfoComputer=ce;class re extends y{constructor(){const Q={enabled:!0};super(59,"lightbulb",Q,{"editor.lightbulb.enabled":{type:"boolean",default:Q.enabled,description:o.localize(43,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}class fe extends y{constructor(){const Q={stickyScroll:{enabled:!1}};super(34,"experimental",Q,{"editor.experimental.stickyScroll.enabled":{type:"boolean",default:Q.stickyScroll.enabled,description:o.localize(44,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{stickyScroll:{enabled:d(Q.stickyScroll?.enabled,this.defaultValue.stickyScroll.enabled)}}}}class ie extends y{constructor(){const Q={enabled:"on",fontSize:0,fontFamily:"",padding:!1};super(129,"inlayHints",Q,{"editor.inlayHints.enabled":{type:"string",default:Q.enabled,description:o.localize(45,null),enum:["on","onUnlessPressed","offUnlessPressed","off"],markdownEnumDescriptions:[o.localize(46,null),o.localize(47,null),o.localize(48,null),o.localize(49,null)]},"editor.inlayHints.fontSize":{type:"number",default:Q.fontSize,markdownDescription:o.localize(50,null,"`#editor.fontSize#`","`5`")},"editor.inlayHints.fontFamily":{type:"string",default:Q.fontFamily,markdownDescription:o.localize(51,null,"`#editor.fontFamily#`")},"editor.inlayHints.padding":{type:"boolean",default:Q.padding,description:o.localize(52,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return typeof he.enabled=="boolean"&&(he.enabled=he.enabled?"on":"off"),{enabled:s(he.enabled,this.defaultValue.enabled,["on","off","offUnlessPressed","onUnlessPressed"]),fontSize:A.clampedInt(he.fontSize,this.defaultValue.fontSize,0,100),fontFamily:_.string(he.fontFamily,this.defaultValue.fontFamily),padding:d(he.padding,this.defaultValue.padding)}}}class Ee extends l{constructor(){super(61,"lineHeight",e.EDITOR_FONT_DEFAULTS.lineHeight,Q=>l.clamp(Q,0,150),{markdownDescription:o.localize(53,null)})}compute(Q,he,Ue){return Q.fontInfo.lineHeight}}class be extends y{constructor(){const Q={enabled:!0,size:"proportional",side:"right",showSlider:"mouseover",autohide:!1,renderCharacters:!0,maxColumn:120,scale:1};super(67,"minimap",Q,{"editor.minimap.enabled":{type:"boolean",default:Q.enabled,description:o.localize(54,null)},"editor.minimap.autohide":{type:"boolean",default:Q.autohide,description:o.localize(55,null)},"editor.minimap.size":{type:"string",enum:["proportional","fill","fit"],enumDescriptions:[o.localize(56,null),o.localize(57,null),o.localize(58,null)],default:Q.size,description:o.localize(59,null)},"editor.minimap.side":{type:"string",enum:["left","right"],default:Q.side,description:o.localize(60,null)},"editor.minimap.showSlider":{type:"string",enum:["always","mouseover"],default:Q.showSlider,description:o.localize(61,null)},"editor.minimap.scale":{type:"number",default:Q.scale,minimum:1,maximum:3,enum:[1,2,3],description:o.localize(62,null)},"editor.minimap.renderCharacters":{type:"boolean",default:Q.renderCharacters,description:o.localize(63,null)},"editor.minimap.maxColumn":{type:"number",default:Q.maxColumn,description:o.localize(64,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),autohide:d(he.autohide,this.defaultValue.autohide),size:s(he.size,this.defaultValue.size,["proportional","fill","fit"]),side:s(he.side,this.defaultValue.side,["right","left"]),showSlider:s(he.showSlider,this.defaultValue.showSlider,["always","mouseover"]),renderCharacters:d(he.renderCharacters,this.defaultValue.renderCharacters),scale:A.clampedInt(he.scale,1,1,3),maxColumn:A.clampedInt(he.maxColumn,this.defaultValue.maxColumn,1,1e4)}}}function ee(G){return G==="ctrlCmd"?p.isMacintosh?"metaKey":"ctrlKey":"altKey"}class ve extends y{constructor(){super(77,"padding",{top:0,bottom:0},{"editor.padding.top":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(65,null)},"editor.padding.bottom":{type:"number",default:0,minimum:0,maximum:1e3,description:o.localize(66,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{top:A.clampedInt(he.top,0,0,1e3),bottom:A.clampedInt(he.bottom,0,0,1e3)}}}class Ae extends y{constructor(){const Q={enabled:!0,cycle:!1};super(78,"parameterHints",Q,{"editor.parameterHints.enabled":{type:"boolean",default:Q.enabled,description:o.localize(67,null)},"editor.parameterHints.cycle":{type:"boolean",default:Q.cycle,description:o.localize(68,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),cycle:d(he.cycle,this.defaultValue.cycle)}}}class Fe extends f{constructor(){super(131)}compute(Q,he,Ue){return Q.pixelRatio}}class $e extends y{constructor(){const Q={other:"on",comments:"off",strings:"off"},he=[{type:"boolean"},{type:"string",enum:["on","inline","off"],enumDescriptions:[o.localize(69,null),o.localize(70,null),o.localize(71,null)]}];super(81,"quickSuggestions",Q,{type:"object",additionalProperties:!1,properties:{strings:{anyOf:he,default:Q.strings,description:o.localize(72,null)},comments:{anyOf:he,default:Q.comments,description:o.localize(73,null)},other:{anyOf:he,default:Q.other,description:o.localize(74,null)}},default:Q,markdownDescription:o.localize(75,null,"#editor.suggestOnTriggerCharacters#")});this.defaultValue=Q}validate(Q){if(typeof Q=="boolean"){const rt=Q?"on":"off";return{comments:rt,strings:rt,other:rt}}if(!Q||typeof Q!="object")return this.defaultValue;const{other:he,comments:Ue,strings:We}=Q,et=["on","inline","off"];let je,He,it;return typeof he=="boolean"?je=he?"on":"off":je=s(he,this.defaultValue.other,et),typeof Ue=="boolean"?He=Ue?"on":"off":He=s(Ue,this.defaultValue.comments,et),typeof We=="boolean"?it=We?"on":"off":it=s(We,this.defaultValue.strings,et),{other:je,comments:He,strings:it}}}var Qe;(function(G){G[G.Off=0]="Off",G[G.On=1]="On",G[G.Relative=2]="Relative",G[G.Interval=3]="Interval",G[G.Custom=4]="Custom"})(Qe=e.RenderLineNumbersType||(e.RenderLineNumbersType={}));class Ie extends y{constructor(){super(62,"lineNumbers",{renderType:1,renderFn:null},{type:"string",enum:["off","on","relative","interval"],enumDescriptions:[o.localize(76,null),o.localize(77,null),o.localize(78,null),o.localize(79,null)],default:"on",description:o.localize(80,null)})}validate(Q){let he=this.defaultValue.renderType,Ue=this.defaultValue.renderFn;return typeof Q!="undefined"&&(typeof Q=="function"?(he=4,Ue=Q):Q==="interval"?he=3:Q==="relative"?he=2:Q==="on"?he=1:he=0),{renderType:he,renderFn:Ue}}}function Se(G){const Q=G.get(89);return Q==="editable"?G.get(83):Q!=="on"}e.filterValidationDecorations=Se;class Te extends y{constructor(){const Q=[],he={type:"number",description:o.localize(81,null)};super(93,"rulers",Q,{type:"array",items:{anyOf:[he,{type:["object"],properties:{column:he,color:{type:"string",description:o.localize(82,null),format:"color-hex"}}}]},default:Q,description:o.localize(83,null)})}validate(Q){if(Array.isArray(Q)){const he=[];for(const Ue of Q)if(typeof Ue=="number")he.push({column:A.clampedInt(Ue,0,0,1e4),color:null});else if(Ue&&typeof Ue=="object"){const We=Ue;he.push({column:A.clampedInt(We.column,0,0,1e4),color:We.color})}return he.sort((Ue,We)=>Ue.column-We.column),he}return this.defaultValue}}function ae(G,Q){if(typeof G!="string")return Q;switch(G){case"hidden":return 2;case"visible":return 3;default:return 1}}class le extends y{constructor(){const Q={vertical:1,horizontal:1,arrowSize:11,useShadows:!0,verticalHasArrows:!1,horizontalHasArrows:!1,horizontalScrollbarSize:12,horizontalSliderSize:12,verticalScrollbarSize:14,verticalSliderSize:14,handleMouseWheel:!0,alwaysConsumeMouseWheel:!0,scrollByPage:!1};super(94,"scrollbar",Q,{"editor.scrollbar.vertical":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(84,null),o.localize(85,null),o.localize(86,null)],default:"auto",description:o.localize(87,null)},"editor.scrollbar.horizontal":{type:"string",enum:["auto","visible","hidden"],enumDescriptions:[o.localize(88,null),o.localize(89,null),o.localize(90,null)],default:"auto",description:o.localize(91,null)},"editor.scrollbar.verticalScrollbarSize":{type:"number",default:Q.verticalScrollbarSize,description:o.localize(92,null)},"editor.scrollbar.horizontalScrollbarSize":{type:"number",default:Q.horizontalScrollbarSize,description:o.localize(93,null)},"editor.scrollbar.scrollByPage":{type:"boolean",default:Q.scrollByPage,description:o.localize(94,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q,Ue=A.clampedInt(he.horizontalScrollbarSize,this.defaultValue.horizontalScrollbarSize,0,1e3),We=A.clampedInt(he.verticalScrollbarSize,this.defaultValue.verticalScrollbarSize,0,1e3);return{arrowSize:A.clampedInt(he.arrowSize,this.defaultValue.arrowSize,0,1e3),vertical:ae(he.vertical,this.defaultValue.vertical),horizontal:ae(he.horizontal,this.defaultValue.horizontal),useShadows:d(he.useShadows,this.defaultValue.useShadows),verticalHasArrows:d(he.verticalHasArrows,this.defaultValue.verticalHasArrows),horizontalHasArrows:d(he.horizontalHasArrows,this.defaultValue.horizontalHasArrows),handleMouseWheel:d(he.handleMouseWheel,this.defaultValue.handleMouseWheel),alwaysConsumeMouseWheel:d(he.alwaysConsumeMouseWheel,this.defaultValue.alwaysConsumeMouseWheel),horizontalScrollbarSize:Ue,horizontalSliderSize:A.clampedInt(he.horizontalSliderSize,Ue,0,1e3),verticalScrollbarSize:We,verticalSliderSize:A.clampedInt(he.verticalSliderSize,We,0,1e3),scrollByPage:d(he.scrollByPage,this.defaultValue.scrollByPage)}}}e.inUntrustedWorkspace="inUntrustedWorkspace",e.unicodeHighlightConfigKeys={allowedCharacters:"editor.unicodeHighlight.allowedCharacters",invisibleCharacters:"editor.unicodeHighlight.invisibleCharacters",nonBasicASCII:"editor.unicodeHighlight.nonBasicASCII",ambiguousCharacters:"editor.unicodeHighlight.ambiguousCharacters",includeComments:"editor.unicodeHighlight.includeComments",includeStrings:"editor.unicodeHighlight.includeStrings",allowedLocales:"editor.unicodeHighlight.allowedLocales"};class X extends y{constructor(){const Q={nonBasicASCII:e.inUntrustedWorkspace,invisibleCharacters:!0,ambiguousCharacters:!0,includeComments:e.inUntrustedWorkspace,includeStrings:!0,allowedCharacters:{},allowedLocales:{_os:!0,_vscode:!0}};super(115,"unicodeHighlight",Q,{[e.unicodeHighlightConfigKeys.nonBasicASCII]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.nonBasicASCII,description:o.localize(95,null)},[e.unicodeHighlightConfigKeys.invisibleCharacters]:{restricted:!0,type:"boolean",default:Q.invisibleCharacters,description:o.localize(96,null)},[e.unicodeHighlightConfigKeys.ambiguousCharacters]:{restricted:!0,type:"boolean",default:Q.ambiguousCharacters,description:o.localize(97,null)},[e.unicodeHighlightConfigKeys.includeComments]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeComments,description:o.localize(98,null)},[e.unicodeHighlightConfigKeys.includeStrings]:{restricted:!0,type:["boolean","string"],enum:[!0,!1,e.inUntrustedWorkspace],default:Q.includeStrings,description:o.localize(99,null)},[e.unicodeHighlightConfigKeys.allowedCharacters]:{restricted:!0,type:"object",default:Q.allowedCharacters,description:o.localize(100,null),additionalProperties:{type:"boolean"}},[e.unicodeHighlightConfigKeys.allowedLocales]:{restricted:!0,type:"object",additionalProperties:{type:"boolean"},default:Q.allowedLocales,description:o.localize(101,null)}})}applyUpdate(Q,he){let Ue=!1;he.allowedCharacters&&Q&&(D.equals(Q.allowedCharacters,he.allowedCharacters)||(Q={...Q,allowedCharacters:he.allowedCharacters},Ue=!0)),he.allowedLocales&&Q&&(D.equals(Q.allowedLocales,he.allowedLocales)||(Q={...Q,allowedLocales:he.allowedLocales},Ue=!0));const We=super.applyUpdate(Q,he);return Ue?new m(We.newValue,!0):We}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{nonBasicASCII:H(he.nonBasicASCII,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),invisibleCharacters:d(he.invisibleCharacters,this.defaultValue.invisibleCharacters),ambiguousCharacters:d(he.ambiguousCharacters,this.defaultValue.ambiguousCharacters),includeComments:H(he.includeComments,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),includeStrings:H(he.includeStrings,e.inUntrustedWorkspace,[!0,!1,e.inUntrustedWorkspace]),allowedCharacters:this.validateBooleanMap(Q.allowedCharacters,this.defaultValue.allowedCharacters),allowedLocales:this.validateBooleanMap(Q.allowedLocales,this.defaultValue.allowedLocales)}}validateBooleanMap(Q,he){if(typeof Q!="object"||!Q)return he;const Ue={};for(const[We,et]of Object.entries(Q))et===!0&&(Ue[We]=!0);return Ue}}class Y extends y{constructor(){const Q={enabled:!0,mode:"subwordSmart"};super(57,"inlineSuggest",Q,{"editor.inlineSuggest.enabled":{type:"boolean",default:Q.enabled,description:o.localize(102,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),mode:s(he.mode,this.defaultValue.mode,["prefix","subword","subwordSmart"])}}}class k extends y{constructor(){const Q={enabled:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.enabled,independentColorPoolPerBracketType:T.EDITOR_MODEL_DEFAULTS.bracketPairColorizationOptions.independentColorPoolPerBracketType};super(12,"bracketPairColorization",Q,{"editor.bracketPairColorization.enabled":{type:"boolean",default:Q.enabled,markdownDescription:o.localize(103,null,"`#workbench.colorCustomizations#`")},"editor.bracketPairColorization.independentColorPoolPerBracketType":{type:"boolean",default:Q.independentColorPoolPerBracketType,description:o.localize(104,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{enabled:d(he.enabled,this.defaultValue.enabled),independentColorPoolPerBracketType:d(he.independentColorPoolPerBracketType,this.defaultValue.independentColorPoolPerBracketType)}}}class B extends y{constructor(){const Q={bracketPairs:!1,bracketPairsHorizontal:"active",highlightActiveBracketPair:!0,indentation:!0,highlightActiveIndentation:!0};super(13,"guides",Q,{"editor.guides.bracketPairs":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(105,null),o.localize(106,null),o.localize(107,null)],default:Q.bracketPairs,description:o.localize(108,null)},"editor.guides.bracketPairsHorizontal":{type:["boolean","string"],enum:[!0,"active",!1],enumDescriptions:[o.localize(109,null),o.localize(110,null),o.localize(111,null)],default:Q.bracketPairsHorizontal,description:o.localize(112,null)},"editor.guides.highlightActiveBracketPair":{type:"boolean",default:Q.highlightActiveBracketPair,description:o.localize(113,null)},"editor.guides.indentation":{type:"boolean",default:Q.indentation,description:o.localize(114,null)},"editor.guides.highlightActiveIndentation":{type:["boolean","string"],enum:[!0,"always",!1],enumDescriptions:[o.localize(115,null),o.localize(116,null),o.localize(117,null)],default:Q.highlightActiveIndentation,description:o.localize(118,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{bracketPairs:H(he.bracketPairs,this.defaultValue.bracketPairs,[!0,!1,"active"]),bracketPairsHorizontal:H(he.bracketPairsHorizontal,this.defaultValue.bracketPairsHorizontal,[!0,!1,"active"]),highlightActiveBracketPair:d(he.highlightActiveBracketPair,this.defaultValue.highlightActiveBracketPair),indentation:d(he.indentation,this.defaultValue.indentation),highlightActiveIndentation:H(he.highlightActiveIndentation,this.defaultValue.highlightActiveIndentation,[!0,!1,"always"])}}}function H(G,Q,he){const Ue=he.indexOf(G);return Ue===-1?Q:he[Ue]}class j extends y{constructor(){const Q={insertMode:"insert",filterGraceful:!0,snippetsPreventQuickSuggestions:!0,localityBonus:!1,shareSuggestSelections:!1,showIcons:!0,showStatusBar:!1,preview:!1,previewMode:"subwordSmart",showInlineDetails:!0,showMethods:!0,showFunctions:!0,showConstructors:!0,showDeprecated:!0,showFields:!0,showVariables:!0,showClasses:!0,showStructs:!0,showInterfaces:!0,showModules:!0,showProperties:!0,showEvents:!0,showOperators:!0,showUnits:!0,showValues:!0,showConstants:!0,showEnums:!0,showEnumMembers:!0,showKeywords:!0,showWords:!0,showColors:!0,showFiles:!0,showReferences:!0,showFolders:!0,showTypeParameters:!0,showSnippets:!0,showUsers:!0,showIssues:!0};super(108,"suggest",Q,{"editor.suggest.insertMode":{type:"string",enum:["insert","replace"],enumDescriptions:[o.localize(119,null),o.localize(120,null)],default:Q.insertMode,description:o.localize(121,null)},"editor.suggest.filterGraceful":{type:"boolean",default:Q.filterGraceful,description:o.localize(122,null)},"editor.suggest.localityBonus":{type:"boolean",default:Q.localityBonus,description:o.localize(123,null)},"editor.suggest.shareSuggestSelections":{type:"boolean",default:Q.shareSuggestSelections,markdownDescription:o.localize(124,null)},"editor.suggest.snippetsPreventQuickSuggestions":{type:"boolean",default:Q.snippetsPreventQuickSuggestions,description:o.localize(125,null)},"editor.suggest.showIcons":{type:"boolean",default:Q.showIcons,description:o.localize(126,null)},"editor.suggest.showStatusBar":{type:"boolean",default:Q.showStatusBar,description:o.localize(127,null)},"editor.suggest.preview":{type:"boolean",default:Q.preview,description:o.localize(128,null)},"editor.suggest.showInlineDetails":{type:"boolean",default:Q.showInlineDetails,description:o.localize(129,null)},"editor.suggest.maxVisibleSuggestions":{type:"number",deprecationMessage:o.localize(130,null)},"editor.suggest.filteredTypes":{type:"object",deprecationMessage:o.localize(131,null)},"editor.suggest.showMethods":{type:"boolean",default:!0,markdownDescription:o.localize(132,null)},"editor.suggest.showFunctions":{type:"boolean",default:!0,markdownDescription:o.localize(133,null)},"editor.suggest.showConstructors":{type:"boolean",default:!0,markdownDescription:o.localize(134,null)},"editor.suggest.showDeprecated":{type:"boolean",default:!0,markdownDescription:o.localize(135,null)},"editor.suggest.showFields":{type:"boolean",default:!0,markdownDescription:o.localize(136,null)},"editor.suggest.showVariables":{type:"boolean",default:!0,markdownDescription:o.localize(137,null)},"editor.suggest.showClasses":{type:"boolean",default:!0,markdownDescription:o.localize(138,null)},"editor.suggest.showStructs":{type:"boolean",default:!0,markdownDescription:o.localize(139,null)},"editor.suggest.showInterfaces":{type:"boolean",default:!0,markdownDescription:o.localize(140,null)},"editor.suggest.showModules":{type:"boolean",default:!0,markdownDescription:o.localize(141,null)},"editor.suggest.showProperties":{type:"boolean",default:!0,markdownDescription:o.localize(142,null)},"editor.suggest.showEvents":{type:"boolean",default:!0,markdownDescription:o.localize(143,null)},"editor.suggest.showOperators":{type:"boolean",default:!0,markdownDescription:o.localize(144,null)},"editor.suggest.showUnits":{type:"boolean",default:!0,markdownDescription:o.localize(145,null)},"editor.suggest.showValues":{type:"boolean",default:!0,markdownDescription:o.localize(146,null)},"editor.suggest.showConstants":{type:"boolean",default:!0,markdownDescription:o.localize(147,null)},"editor.suggest.showEnums":{type:"boolean",default:!0,markdownDescription:o.localize(148,null)},"editor.suggest.showEnumMembers":{type:"boolean",default:!0,markdownDescription:o.localize(149,null)},"editor.suggest.showKeywords":{type:"boolean",default:!0,markdownDescription:o.localize(150,null)},"editor.suggest.showWords":{type:"boolean",default:!0,markdownDescription:o.localize(151,null)},"editor.suggest.showColors":{type:"boolean",default:!0,markdownDescription:o.localize(152,null)},"editor.suggest.showFiles":{type:"boolean",default:!0,markdownDescription:o.localize(153,null)},"editor.suggest.showReferences":{type:"boolean",default:!0,markdownDescription:o.localize(154,null)},"editor.suggest.showCustomcolors":{type:"boolean",default:!0,markdownDescription:o.localize(155,null)},"editor.suggest.showFolders":{type:"boolean",default:!0,markdownDescription:o.localize(156,null)},"editor.suggest.showTypeParameters":{type:"boolean",default:!0,markdownDescription:o.localize(157,null)},"editor.suggest.showSnippets":{type:"boolean",default:!0,markdownDescription:o.localize(158,null)},"editor.suggest.showUsers":{type:"boolean",default:!0,markdownDescription:o.localize(159,null)},"editor.suggest.showIssues":{type:"boolean",default:!0,markdownDescription:o.localize(160,null)}})}validate(Q){if(!Q||typeof Q!="object")return this.defaultValue;const he=Q;return{insertMode:s(he.insertMode,this.defaultValue.insertMode,["insert","replace"]),filterGraceful:d(he.filterGraceful,this.defaultValue.filterGraceful),snippetsPreventQuickSuggestions:d(he.snippetsPreventQuickSuggestions,this.defaultValue.filterGraceful),localityBonus:d(he.localityBonus,this.defaultValue.localityBonus),shareSuggestSelections:d(he.shareSuggestSelections,this.defaultValue.shareSuggestSelections),showIcons:d(he.showIcons,this.defaultValue.showIcons),showStatusBar:d(he.showStatusBar,this.defaultValue.showStatusBar),preview:d(he.preview,this.defaultValue.preview),previewMode:s(he.previewMode,this.defaultValue.previewMode,["prefix","subword","subwordSmart"]),showInlineDetails:d(he.showInlineDetails,this.defaultValue.showInlineDetails),showMethods:d(he.showMethods,this.defaultValue.showMethods),showFunctions:d(he.showFunctions,this.defaultValue.showFunctions),showConstructors:d(he.showConstructors,this.defaultValue.showConstructors),showDeprecated:d(he.showDeprecated,this.defaultValue.showDeprecated),showFields:d(he.showFields,this.defaultValue.showFields),showVariables:d(he.showVariables,this.defaultValue.showVariables),showClasses:d(he.showClasses,this.defaultValue.showClasses),showStructs:d(he.showStructs,this.defaultValue.showStructs),showInterfaces:d(he.showInterfaces,this.defaultValue.showInterfaces),showModules:d(he.showModules,this.defaultValue.showModules),showProperties:d(he.showProperties,this.defaultValue.showProperties),showEvents:d(he.showEvents,this.defaultValue.showEvents),showOperators:d(he.showOperators,this.defaultValue.showOperators),showUnits:d(he.showUnits,this.defaultValue.showUnits),showValues:d(he.showValues,this.defaultValue.showValues),showConstants:d(he.showConstants,this.defaultValue.showConstants),showEnums:d(he.showEnums,this.defaultValue.showEnums),showEnumMembers:d(he.showEnumMembers,this.defaultValue.showEnumMembers),showKeywords:d(he.showKeywords,this.defaultValue.showKeywords),showWords:d(he.showWords,this.defaultValue.showWords),showColors:d(he.showColors,this.defaultValue.showColors),showFiles:d(he.showFiles,this.defaultValue.showFiles),showReferences:d(he.showReferences,this.defaultValue.showReferences),showFolders:d(he.showFolders,this.defaultValue.showFolders),showTypeParameters:d(he.showTypeParameters,this.defaultValue.showTypeParameters),showSnippets:d(he.showSnippets,this.defaultValue.showSnippets),showUsers:d(he.showUsers,this.defaultValue.showUsers),showIssues:d(he.showIssues,this.defaultValue.showIssues)}}}class oe extends y{constructor(){super(104,"smartSelect",{selectLeadingAndTrailingWhitespace:!0},{"editor.smartSelect.selectLeadingAndTrailingWhitespace":{description:o.localize(161,null),default:!0,type:"boolean"}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{selectLeadingAndTrailingWhitespace:d(Q.selectLeadingAndTrailingWhitespace,this.defaultValue.selectLeadingAndTrailingWhitespace)}}}class ue extends f{constructor(){super(132)}compute(Q,he,Ue){return he.get(83)?!0:Q.tabFocusMode}}var Z;(function(G){G[G.None=0]="None",G[G.Same=1]="Same",G[G.Indent=2]="Indent",G[G.DeepIndent=3]="DeepIndent"})(Z=e.WrappingIndent||(e.WrappingIndent={}));function pe(G){switch(G){case"none":return 0;case"same":return 1;case"indent":return 2;case"deepIndent":return 3}}class ge extends f{constructor(){super(134)}compute(Q,he,Ue){const We=he.get(133);return{isDominatedByLongLines:Q.isDominatedByLongLines,isWordWrapMinified:We.isWordWrapMinified,isViewportWrapping:We.isViewportWrapping,wrappingColumn:We.wrappingColumn}}}class Ne extends y{constructor(){const Q={enabled:!0};super(32,"dropIntoEditor",Q,{"editor.dropIntoEditor.enabled":{type:"boolean",default:Q.enabled,markdownDescription:o.localize(162,null)}})}validate(Q){return!Q||typeof Q!="object"?this.defaultValue:{enabled:d(Q.enabled,this.defaultValue.enabled)}}}const Be="Consolas, 'Courier New', monospace",Ze="Menlo, Monaco, 'Courier New', monospace",Ge="'Droid Sans Mono', 'monospace', monospace";e.EDITOR_FONT_DEFAULTS={fontFamily:p.isMacintosh?Ze:p.isLinux?Ge:Be,fontWeight:"normal",fontSize:p.isMacintosh?12:14,lineHeight:0,letterSpacing:0},e.editorOptionsRegistry=[];function ke(G){return e.editorOptionsRegistry[G.id]=G,G}var nt;(function(G){G[G.acceptSuggestionOnCommitCharacter=0]="acceptSuggestionOnCommitCharacter",G[G.acceptSuggestionOnEnter=1]="acceptSuggestionOnEnter",G[G.accessibilitySupport=2]="accessibilitySupport",G[G.accessibilityPageSize=3]="accessibilityPageSize",G[G.ariaLabel=4]="ariaLabel",G[G.autoClosingBrackets=5]="autoClosingBrackets",G[G.autoClosingDelete=6]="autoClosingDelete",G[G.autoClosingOvertype=7]="autoClosingOvertype",G[G.autoClosingQuotes=8]="autoClosingQuotes",G[G.autoIndent=9]="autoIndent",G[G.automaticLayout=10]="automaticLayout",G[G.autoSurround=11]="autoSurround",G[G.bracketPairColorization=12]="bracketPairColorization",G[G.guides=13]="guides",G[G.codeLens=14]="codeLens",G[G.codeLensFontFamily=15]="codeLensFontFamily",G[G.codeLensFontSize=16]="codeLensFontSize",G[G.colorDecorators=17]="colorDecorators",G[G.columnSelection=18]="columnSelection",G[G.comments=19]="comments",G[G.contextmenu=20]="contextmenu",G[G.copyWithSyntaxHighlighting=21]="copyWithSyntaxHighlighting",G[G.cursorBlinking=22]="cursorBlinking",G[G.cursorSmoothCaretAnimation=23]="cursorSmoothCaretAnimation",G[G.cursorStyle=24]="cursorStyle",G[G.cursorSurroundingLines=25]="cursorSurroundingLines",G[G.cursorSurroundingLinesStyle=26]="cursorSurroundingLinesStyle",G[G.cursorWidth=27]="cursorWidth",G[G.disableLayerHinting=28]="disableLayerHinting",G[G.disableMonospaceOptimizations=29]="disableMonospaceOptimizations",G[G.domReadOnly=30]="domReadOnly",G[G.dragAndDrop=31]="dragAndDrop",G[G.dropIntoEditor=32]="dropIntoEditor",G[G.emptySelectionClipboard=33]="emptySelectionClipboard",G[G.experimental=34]="experimental",G[G.extraEditorClassName=35]="extraEditorClassName",G[G.fastScrollSensitivity=36]="fastScrollSensitivity",G[G.find=37]="find",G[G.fixedOverflowWidgets=38]="fixedOverflowWidgets",G[G.folding=39]="folding",G[G.foldingStrategy=40]="foldingStrategy",G[G.foldingHighlight=41]="foldingHighlight",G[G.foldingImportsByDefault=42]="foldingImportsByDefault",G[G.foldingMaximumRegions=43]="foldingMaximumRegions",G[G.unfoldOnClickAfterEndOfLine=44]="unfoldOnClickAfterEndOfLine",G[G.fontFamily=45]="fontFamily",G[G.fontInfo=46]="fontInfo",G[G.fontLigatures=47]="fontLigatures",G[G.fontSize=48]="fontSize",G[G.fontWeight=49]="fontWeight",G[G.formatOnPaste=50]="formatOnPaste",G[G.formatOnType=51]="formatOnType",G[G.glyphMargin=52]="glyphMargin",G[G.gotoLocation=53]="gotoLocation",G[G.hideCursorInOverviewRuler=54]="hideCursorInOverviewRuler",G[G.hover=55]="hover",G[G.inDiffEditor=56]="inDiffEditor",G[G.inlineSuggest=57]="inlineSuggest",G[G.letterSpacing=58]="letterSpacing",G[G.lightbulb=59]="lightbulb",G[G.lineDecorationsWidth=60]="lineDecorationsWidth",G[G.lineHeight=61]="lineHeight",G[G.lineNumbers=62]="lineNumbers",G[G.lineNumbersMinChars=63]="lineNumbersMinChars",G[G.linkedEditing=64]="linkedEditing",G[G.links=65]="links",G[G.matchBrackets=66]="matchBrackets",G[G.minimap=67]="minimap",G[G.mouseStyle=68]="mouseStyle",G[G.mouseWheelScrollSensitivity=69]="mouseWheelScrollSensitivity",G[G.mouseWheelZoom=70]="mouseWheelZoom",G[G.multiCursorMergeOverlapping=71]="multiCursorMergeOverlapping",G[G.multiCursorModifier=72]="multiCursorModifier",G[G.multiCursorPaste=73]="multiCursorPaste",G[G.occurrencesHighlight=74]="occurrencesHighlight",G[G.overviewRulerBorder=75]="overviewRulerBorder",G[G.overviewRulerLanes=76]="overviewRulerLanes",G[G.padding=77]="padding",G[G.parameterHints=78]="parameterHints",G[G.peekWidgetDefaultFocus=79]="peekWidgetDefaultFocus",G[G.definitionLinkOpensInPeek=80]="definitionLinkOpensInPeek",G[G.quickSuggestions=81]="quickSuggestions",G[G.quickSuggestionsDelay=82]="quickSuggestionsDelay",G[G.readOnly=83]="readOnly",G[G.renameOnType=84]="renameOnType",G[G.renderControlCharacters=85]="renderControlCharacters",G[G.renderFinalNewline=86]="renderFinalNewline",G[G.renderLineHighlight=87]="renderLineHighlight",G[G.renderLineHighlightOnlyWhenFocus=88]="renderLineHighlightOnlyWhenFocus",G[G.renderValidationDecorations=89]="renderValidationDecorations",G[G.renderWhitespace=90]="renderWhitespace",G[G.revealHorizontalRightPadding=91]="revealHorizontalRightPadding",G[G.roundedSelection=92]="roundedSelection",G[G.rulers=93]="rulers",G[G.scrollbar=94]="scrollbar",G[G.scrollBeyondLastColumn=95]="scrollBeyondLastColumn",G[G.scrollBeyondLastLine=96]="scrollBeyondLastLine",G[G.scrollPredominantAxis=97]="scrollPredominantAxis",G[G.selectionClipboard=98]="selectionClipboard",G[G.selectionHighlight=99]="selectionHighlight",G[G.selectOnLineNumbers=100]="selectOnLineNumbers",G[G.showFoldingControls=101]="showFoldingControls",G[G.showUnused=102]="showUnused",G[G.snippetSuggestions=103]="snippetSuggestions",G[G.smartSelect=104]="smartSelect",G[G.smoothScrolling=105]="smoothScrolling",G[G.stickyTabStops=106]="stickyTabStops",G[G.stopRenderingLineAfter=107]="stopRenderingLineAfter",G[G.suggest=108]="suggest",G[G.suggestFontSize=109]="suggestFontSize",G[G.suggestLineHeight=110]="suggestLineHeight",G[G.suggestOnTriggerCharacters=111]="suggestOnTriggerCharacters",G[G.suggestSelection=112]="suggestSelection",G[G.tabCompletion=113]="tabCompletion",G[G.tabIndex=114]="tabIndex",G[G.unicodeHighlighting=115]="unicodeHighlighting",G[G.unusualLineTerminators=116]="unusualLineTerminators",G[G.useShadowDOM=117]="useShadowDOM",G[G.useTabStops=118]="useTabStops",G[G.wordSeparators=119]="wordSeparators",G[G.wordWrap=120]="wordWrap",G[G.wordWrapBreakAfterCharacters=121]="wordWrapBreakAfterCharacters",G[G.wordWrapBreakBeforeCharacters=122]="wordWrapBreakBeforeCharacters",G[G.wordWrapColumn=123]="wordWrapColumn",G[G.wordWrapOverride1=124]="wordWrapOverride1",G[G.wordWrapOverride2=125]="wordWrapOverride2",G[G.wrappingIndent=126]="wrappingIndent",G[G.wrappingStrategy=127]="wrappingStrategy",G[G.showDeprecated=128]="showDeprecated",G[G.inlayHints=129]="inlayHints",G[G.editorClassName=130]="editorClassName",G[G.pixelRatio=131]="pixelRatio",G[G.tabFocusMode=132]="tabFocusMode",G[G.layoutInfo=133]="layoutInfo",G[G.wrappingInfo=134]="wrappingInfo"})(nt=e.EditorOption||(e.EditorOption={})),e.EditorOptions={acceptSuggestionOnCommitCharacter:ke(new a(0,"acceptSuggestionOnCommitCharacter",!0,{markdownDescription:o.localize(163,null)})),acceptSuggestionOnEnter:ke(new u(1,"acceptSuggestionOnEnter","on",["on","smart","off"],{markdownEnumDescriptions:["",o.localize(164,null),""],markdownDescription:o.localize(165,null)})),accessibilitySupport:ke(new r),accessibilityPageSize:ke(new A(3,"accessibilityPageSize",10,1,1073741824,{description:o.localize(166,null)})),ariaLabel:ke(new _(4,"ariaLabel",o.localize(167,null))),autoClosingBrackets:ke(new u(5,"autoClosingBrackets","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(168,null),o.localize(169,null),""],description:o.localize(170,null)})),autoClosingDelete:ke(new u(6,"autoClosingDelete","auto",["always","auto","never"],{enumDescriptions:["",o.localize(171,null),""],description:o.localize(172,null)})),autoClosingOvertype:ke(new u(7,"autoClosingOvertype","auto",["always","auto","never"],{enumDescriptions:["",o.localize(173,null),""],description:o.localize(174,null)})),autoClosingQuotes:ke(new u(8,"autoClosingQuotes","languageDefined",["always","languageDefined","beforeWhitespace","never"],{enumDescriptions:["",o.localize(175,null),o.localize(176,null),""],description:o.localize(177,null)})),autoIndent:ke(new n(9,"autoIndent",4,"full",["none","keep","brackets","advanced","full"],i,{enumDescriptions:[o.localize(178,null),o.localize(179,null),o.localize(180,null),o.localize(181,null),o.localize(182,null)],description:o.localize(183,null)})),automaticLayout:ke(new a(10,"automaticLayout",!1)),autoSurround:ke(new u(11,"autoSurround","languageDefined",["languageDefined","quotes","brackets","never"],{enumDescriptions:[o.localize(184,null),o.localize(185,null),o.localize(186,null),""],description:o.localize(187,null)})),bracketPairColorization:ke(new k),bracketPairGuides:ke(new B),stickyTabStops:ke(new a(106,"stickyTabStops",!1,{description:o.localize(188,null)})),codeLens:ke(new a(14,"codeLens",!0,{description:o.localize(189,null)})),codeLensFontFamily:ke(new _(15,"codeLensFontFamily","",{description:o.localize(190,null)})),codeLensFontSize:ke(new A(16,"codeLensFontSize",0,0,100,{type:"number",default:0,minimum:0,maximum:100,markdownDescription:o.localize(191,null)})),colorDecorators:ke(new a(17,"colorDecorators",!0,{description:o.localize(192,null)})),columnSelection:ke(new a(18,"columnSelection",!1,{description:o.localize(193,null)})),comments:ke(new t),contextmenu:ke(new a(20,"contextmenu",!0)),copyWithSyntaxHighlighting:ke(new a(21,"copyWithSyntaxHighlighting",!0,{description:o.localize(194,null)})),cursorBlinking:ke(new n(22,"cursorBlinking",1,"blink",["blink","smooth","phase","expand","solid"],w,{description:o.localize(195,null)})),cursorSmoothCaretAnimation:ke(new a(23,"cursorSmoothCaretAnimation",!1,{description:o.localize(196,null)})),cursorStyle:ke(new n(24,"cursorStyle",g.Line,"line",["line","block","underline","line-thin","block-outline","underline-thin"],U,{description:o.localize(197,null)})),cursorSurroundingLines:ke(new A(25,"cursorSurroundingLines",0,0,1073741824,{description:o.localize(198,null)})),cursorSurroundingLinesStyle:ke(new u(26,"cursorSurroundingLinesStyle","default",["default","all"],{enumDescriptions:[o.localize(199,null),o.localize(200,null)],description:o.localize(201,null)})),cursorWidth:ke(new A(27,"cursorWidth",0,0,1073741824,{markdownDescription:o.localize(202,null)})),disableLayerHinting:ke(new a(28,"disableLayerHinting",!1)),disableMonospaceOptimizations:ke(new a(29,"disableMonospaceOptimizations",!1)),domReadOnly:ke(new a(30,"domReadOnly",!1)),dragAndDrop:ke(new a(31,"dragAndDrop",!0,{description:o.localize(203,null)})),emptySelectionClipboard:ke(new M),dropIntoEditor:ke(new Ne),experimental:ke(new fe),extraEditorClassName:ke(new _(35,"extraEditorClassName","")),fastScrollSensitivity:ke(new l(36,"fastScrollSensitivity",5,G=>G<=0?5:G,{markdownDescription:o.localize(204,null)})),find:ke(new S),fixedOverflowWidgets:ke(new a(38,"fixedOverflowWidgets",!1)),folding:ke(new a(39,"folding",!0,{description:o.localize(205,null)})),foldingStrategy:ke(new u(40,"foldingStrategy","auto",["auto","indentation"],{enumDescriptions:[o.localize(206,null),o.localize(207,null)],description:o.localize(208,null)})),foldingHighlight:ke(new a(41,"foldingHighlight",!0,{description:o.localize(209,null)})),foldingImportsByDefault:ke(new a(42,"foldingImportsByDefault",!1,{description:o.localize(210,null)})),foldingMaximumRegions:ke(new A(43,"foldingMaximumRegions",5e3,10,65e3,{description:o.localize(211,null)})),unfoldOnClickAfterEndOfLine:ke(new a(44,"unfoldOnClickAfterEndOfLine",!1,{description:o.localize(212,null)})),fontFamily:ke(new _(45,"fontFamily",e.EDITOR_FONT_DEFAULTS.fontFamily,{description:o.localize(213,null)})),fontInfo:ke(new $),fontLigatures2:ke(new z),fontSize:ke(new N),fontWeight:ke(new K),formatOnPaste:ke(new a(50,"formatOnPaste",!1,{description:o.localize(214,null)})),formatOnType:ke(new a(51,"formatOnType",!1,{description:o.localize(215,null)})),glyphMargin:ke(new a(52,"glyphMargin",!0,{description:o.localize(216,null)})),gotoLocation:ke(new V),hideCursorInOverviewRuler:ke(new a(54,"hideCursorInOverviewRuler",!1,{description:o.localize(217,null)})),hover:ke(new F),inDiffEditor:ke(new a(56,"inDiffEditor",!1)),letterSpacing:ke(new l(58,"letterSpacing",e.EDITOR_FONT_DEFAULTS.letterSpacing,G=>l.clamp(G,-5,20),{description:o.localize(218,null)})),lightbulb:ke(new re),lineDecorationsWidth:ke(new h(60,"lineDecorationsWidth",10)),lineHeight:ke(new Ee),lineNumbers:ke(new Ie),lineNumbersMinChars:ke(new A(63,"lineNumbersMinChars",5,1,300)),linkedEditing:ke(new a(64,"linkedEditing",!1,{description:o.localize(219,null)})),links:ke(new a(65,"links",!0,{description:o.localize(220,null)})),matchBrackets:ke(new u(66,"matchBrackets","always",["always","near","never"],{description:o.localize(221,null)})),minimap:ke(new be),mouseStyle:ke(new u(68,"mouseStyle","text",["text","default","copy"])),mouseWheelScrollSensitivity:ke(new l(69,"mouseWheelScrollSensitivity",1,G=>G===0?1:G,{markdownDescription:o.localize(222,null)})),mouseWheelZoom:ke(new a(70,"mouseWheelZoom",!1,{markdownDescription:o.localize(223,null)})),multiCursorMergeOverlapping:ke(new a(71,"multiCursorMergeOverlapping",!0,{description:o.localize(224,null)})),multiCursorModifier:ke(new n(72,"multiCursorModifier","altKey","alt",["ctrlCmd","alt"],ee,{markdownEnumDescriptions:[o.localize(225,null),o.localize(226,null)],markdownDescription:o.localize(227,null)})),multiCursorPaste:ke(new u(73,"multiCursorPaste","spread",["spread","full"],{markdownEnumDescriptions:[o.localize(228,null),o.localize(229,null)],markdownDescription:o.localize(230,null)})),occurrencesHighlight:ke(new a(74,"occurrencesHighlight",!0,{description:o.localize(231,null)})),overviewRulerBorder:ke(new a(75,"overviewRulerBorder",!0,{description:o.localize(232,null)})),overviewRulerLanes:ke(new A(76,"overviewRulerLanes",3,0,3)),padding:ke(new ve),parameterHints:ke(new Ae),peekWidgetDefaultFocus:ke(new u(79,"peekWidgetDefaultFocus","tree",["tree","editor"],{enumDescriptions:[o.localize(233,null),o.localize(234,null)],description:o.localize(235,null)})),definitionLinkOpensInPeek:ke(new a(80,"definitionLinkOpensInPeek",!1,{description:o.localize(236,null)})),quickSuggestions:ke(new $e),quickSuggestionsDelay:ke(new A(82,"quickSuggestionsDelay",10,0,1073741824,{description:o.localize(237,null)})),readOnly:ke(new a(83,"readOnly",!1)),renameOnType:ke(new a(84,"renameOnType",!1,{description:o.localize(238,null),markdownDeprecationMessage:o.localize(239,null)})),renderControlCharacters:ke(new a(85,"renderControlCharacters",!0,{description:o.localize(240,null),restricted:!0})),renderFinalNewline:ke(new a(86,"renderFinalNewline",!0,{description:o.localize(241,null)})),renderLineHighlight:ke(new u(87,"renderLineHighlight","line",["none","gutter","line","all"],{enumDescriptions:["","","",o.localize(242,null)],description:o.localize(243,null)})),renderLineHighlightOnlyWhenFocus:ke(new a(88,"renderLineHighlightOnlyWhenFocus",!1,{description:o.localize(244,null)})),renderValidationDecorations:ke(new u(89,"renderValidationDecorations","editable",["editable","on","off"])),renderWhitespace:ke(new u(90,"renderWhitespace","selection",["none","boundary","selection","trailing","all"],{enumDescriptions:["",o.localize(245,null),o.localize(246,null),o.localize(247,null),""],description:o.localize(248,null)})),revealHorizontalRightPadding:ke(new A(91,"revealHorizontalRightPadding",30,0,1e3)),roundedSelection:ke(new a(92,"roundedSelection",!0,{description:o.localize(249,null)})),rulers:ke(new Te),scrollbar:ke(new le),scrollBeyondLastColumn:ke(new A(95,"scrollBeyondLastColumn",4,0,1073741824,{description:o.localize(250,null)})),scrollBeyondLastLine:ke(new a(96,"scrollBeyondLastLine",!0,{description:o.localize(251,null)})),scrollPredominantAxis:ke(new a(97,"scrollPredominantAxis",!0,{description:o.localize(252,null)})),selectionClipboard:ke(new a(98,"selectionClipboard",!0,{description:o.localize(253,null),included:p.isLinux})),selectionHighlight:ke(new a(99,"selectionHighlight",!0,{description:o.localize(254,null)})),selectOnLineNumbers:ke(new a(100,"selectOnLineNumbers",!0)),showFoldingControls:ke(new u(101,"showFoldingControls","mouseover",["always","never","mouseover"],{enumDescriptions:[o.localize(255,null),o.localize(256,null),o.localize(257,null)],description:o.localize(258,null)})),showUnused:ke(new a(102,"showUnused",!0,{description:o.localize(259,null)})),showDeprecated:ke(new a(128,"showDeprecated",!0,{description:o.localize(260,null)})),inlayHints:ke(new ie),snippetSuggestions:ke(new u(103,"snippetSuggestions","inline",["top","bottom","inline","none"],{enumDescriptions:[o.localize(261,null),o.localize(262,null),o.localize(263,null),o.localize(264,null)],description:o.localize(265,null)})),smartSelect:ke(new oe),smoothScrolling:ke(new a(105,"smoothScrolling",!1,{description:o.localize(266,null)})),stopRenderingLineAfter:ke(new A(107,"stopRenderingLineAfter",1e4,-1,1073741824)),suggest:ke(new j),inlineSuggest:ke(new Y),suggestFontSize:ke(new A(109,"suggestFontSize",0,0,1e3,{markdownDescription:o.localize(267,null,"`0`","`#editor.fontSize#`")})),suggestLineHeight:ke(new A(110,"suggestLineHeight",0,0,1e3,{markdownDescription:o.localize(268,null,"`0`","`#editor.lineHeight#`")})),suggestOnTriggerCharacters:ke(new a(111,"suggestOnTriggerCharacters",!0,{description:o.localize(269,null)})),suggestSelection:ke(new u(112,"suggestSelection","first",["first","recentlyUsed","recentlyUsedByPrefix"],{markdownEnumDescriptions:[o.localize(270,null),o.localize(271,null),o.localize(272,null)],description:o.localize(273,null)})),tabCompletion:ke(new u(113,"tabCompletion","off",["on","off","onlySnippets"],{enumDescriptions:[o.localize(274,null),o.localize(275,null),o.localize(276,null)],description:o.localize(277,null)})),tabIndex:ke(new A(114,"tabIndex",0,-1,1073741824)),unicodeHighlight:ke(new X),unusualLineTerminators:ke(new u(116,"unusualLineTerminators","prompt",["auto","off","prompt"],{enumDescriptions:[o.localize(278,null),o.localize(279,null),o.localize(280,null)],description:o.localize(281,null)})),useShadowDOM:ke(new a(117,"useShadowDOM",!0)),useTabStops:ke(new a(118,"useTabStops",!0,{description:o.localize(282,null)})),wordSeparators:ke(new _(119,"wordSeparators",b.USUAL_WORD_SEPARATORS,{description:o.localize(283,null)})),wordWrap:ke(new u(120,"wordWrap","off",["off","on","wordWrapColumn","bounded"],{markdownEnumDescriptions:[o.localize(284,null),o.localize(285,null),o.localize(286,null),o.localize(287,null)],description:o.localize(288,null)})),wordWrapBreakAfterCharacters:ke(new _(121,"wordWrapBreakAfterCharacters"," 	})]?|/&.,;\xA2\xB0\u2032\u2033\u2030\u2103\u3001\u3002\uFF61\uFF64\uFFE0\uFF0C\uFF0E\uFF1A\uFF1B\uFF1F\uFF01\uFF05\u30FB\uFF65\u309D\u309E\u30FD\u30FE\u30FC\u30A1\u30A3\u30A5\u30A7\u30A9\u30C3\u30E3\u30E5\u30E7\u30EE\u30F5\u30F6\u3041\u3043\u3045\u3047\u3049\u3063\u3083\u3085\u3087\u308E\u3095\u3096\u31F0\u31F1\u31F2\u31F3\u31F4\u31F5\u31F6\u31F7\u31F8\u31F9\u31FA\u31FB\u31FC\u31FD\u31FE\u31FF\u3005\u303B\uFF67\uFF68\uFF69\uFF6A\uFF6B\uFF6C\uFF6D\uFF6E\uFF6F\uFF70\u201D\u3009\u300B\u300D\u300F\u3011\u3015\uFF09\uFF3D\uFF5D\uFF63")),wordWrapBreakBeforeCharacters:ke(new _(122,"wordWrapBreakBeforeCharacters","([{\u2018\u201C\u3008\u300A\u300C\u300E\u3010\u3014\uFF08\uFF3B\uFF5B\uFF62\xA3\xA5\uFF04\uFFE1\uFFE5+\uFF0B")),wordWrapColumn:ke(new A(123,"wordWrapColumn",80,1,1073741824,{markdownDescription:o.localize(289,null)})),wordWrapOverride1:ke(new u(124,"wordWrapOverride1","inherit",["off","on","inherit"])),wordWrapOverride2:ke(new u(125,"wordWrapOverride2","inherit",["off","on","inherit"])),wrappingIndent:ke(new n(126,"wrappingIndent",1,"same",["none","same","indent","deepIndent"],pe,{enumDescriptions:[o.localize(290,null),o.localize(291,null),o.localize(292,null),o.localize(293,null)],description:o.localize(294,null)})),wrappingStrategy:ke(new u(127,"wrappingStrategy","simple",["simple","advanced"],{enumDescriptions:[o.localize(295,null),o.localize(296,null)],description:o.localize(297,null)})),editorClassName:ke(new W),pixelRatio:ke(new Fe),tabFocusMode:ke(new ue),layoutInfo:ke(new ce),wrappingInfo:ke(new ge)}}),define(De[122],Ce([17,18]),function(te,e){return te.create("vs/platform/configuration/common/configurationRegistry",e)}),define(De[123],Ce([17,18]),function(te,e){return te.create("vs/platform/extensionManagement/common/extensionManagement",e)}),define(De[124],Ce([17,18]),function(te,e){return te.create("vs/platform/extensions/common/extensionValidator",e)}),define(De[125],Ce([17,18]),function(te,e){return te.create("vs/platform/files/common/files",e)}),define(De[126],Ce([17,18]),function(te,e){return te.create("vs/platform/markers/common/markers",e)}),define(De[127],Ce([17,18]),function(te,e){return te.create("vs/platform/workspace/common/workspace",e)}),define(De[128],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostDiagnostics",e)}),define(De[129],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostExtensionService",e)}),define(De[130],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostProgress",e)}),define(De[131],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostStatusBar",e)}),define(De[132],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTerminalService",e)}),define(De[133],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostTreeViews",e)}),define(De[134],Ce([17,18]),function(te,e){return te.create("vs/workbench/api/common/extHostWorkspace",e)}),define(De[135],Ce([17,18]),function(te,e){return te.create("vs/workbench/common/editor",e)}),define(De[136],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/abstractDebugAdapter",e)}),define(De[137],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/debug/common/debug",e)}),define(De[138],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/taskDefinitionRegistry",e)}),define(De[139],Ce([17,18]),function(te,e){return te.create("vs/workbench/contrib/tasks/common/tasks",e)}),define(De[140],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/configurationResolver/common/variableResolver",e)}),define(De[141],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/extensions/common/extensionsRegistry",e)}),define(De[142],Ce([17,18]),function(te,e){return te.create("vs/workbench/services/search/common/queryBuilder",e)}),define(De[143],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextEditorSelectionSource=e.TextEditorSelectionRevealType=e.EditorOpenSource=e.EditorResolution=e.EditorActivation=void 0;var o;(function(T){T[T.ACTIVATE=1]="ACTIVATE",T[T.RESTORE=2]="RESTORE",T[T.PRESERVE=3]="PRESERVE"})(o=e.EditorActivation||(e.EditorActivation={}));var p;(function(T){T[T.PICK=0]="PICK",T[T.DISABLED=1]="DISABLED",T[T.EXCLUSIVE_ONLY=2]="EXCLUSIVE_ONLY"})(p=e.EditorResolution||(e.EditorResolution={}));var b;(function(T){T[T.API=0]="API",T[T.USER=1]="USER"})(b=e.EditorOpenSource||(e.EditorOpenSource={}));var L;(function(T){T[T.Center=0]="Center",T[T.CenterIfOutsideViewport=1]="CenterIfOutsideViewport",T[T.NearTop=2]="NearTop",T[T.NearTopIfOutsideViewport=3]="NearTopIfOutsideViewport"})(L=e.TextEditorSelectionRevealType||(e.TextEditorSelectionRevealType={}));var D;(function(T){T.PROGRAMMATIC="api",T.NAVIGATION="code.navigation",T.JUMP="code.jump"})(D=e.TextEditorSelectionSource||(e.TextEditorSelectionSource={}))}),define(De[144],Ce([1,0,21,29,124,238]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isEngineValid=e.isValidExtensionVersion=e.validateExtensionManifest=e.isValidVersion=e.normalizeVersion=e.parseVersion=e.isValidVersionStr=void 0;const D=/^(\^|>=)?((\d+)|x)\.((\d+)|x)\.((\d+)|x)(\-.*)?$/,T=/^-(\d{4})(\d{2})(\d{2})$/;function E(a){return a=a.trim(),a==="*"||D.test(a)}e.isValidVersionStr=E;function P(a){if(!E(a))return null;if(a=a.trim(),a==="*")return{hasCaret:!1,hasGreaterEquals:!1,majorBase:0,majorMustEqual:!1,minorBase:0,minorMustEqual:!1,patchBase:0,patchMustEqual:!1,preRelease:null};const v=a.match(D);return v?{hasCaret:v[1]==="^",hasGreaterEquals:v[1]===">=",majorBase:v[2]==="x"?0:parseInt(v[2],10),majorMustEqual:v[2]!=="x",minorBase:v[4]==="x"?0:parseInt(v[4],10),minorMustEqual:v[4]!=="x",patchBase:v[6]==="x"?0:parseInt(v[6],10),patchMustEqual:v[6]!=="x",preRelease:v[8]||null}:null}e.parseVersion=P;function R(a){if(!a)return null;const v=a.majorBase,A=a.majorMustEqual,l=a.minorBase;let _=a.minorMustEqual;const s=a.patchBase;let u=a.patchMustEqual;a.hasCaret&&(v===0||(_=!1),u=!1);let n=0;if(a.preRelease){const i=T.exec(a.preRelease);if(i){const[,r,t,c]=i;n=Date.UTC(Number(r),Number(t)-1,Number(c))}}return{majorBase:v,majorMustEqual:A,minorBase:l,minorMustEqual:_,patchBase:s,patchMustEqual:u,isMinimum:a.hasGreaterEquals,notBefore:n}}e.normalizeVersion=R;function y(a,v,A){let l;typeof a=="string"?l=R(P(a)):l=a;let _;v instanceof Date?_=v.getTime():typeof v=="string"&&(_=new Date(v).getTime());let s;if(typeof A=="string"?s=R(P(A)):s=A,!l||!s)return!1;const u=l.majorBase,n=l.minorBase,i=l.patchBase;let r=s.majorBase,t=s.minorBase,c=s.patchBase;const w=s.notBefore;let g=s.majorMustEqual,C=s.minorMustEqual,U=s.patchMustEqual;return s.isMinimum?u>r?!0:u<r?!1:n>t?!0:n<t||_&&_<w?!1:i>=c:(u===1&&r===0&&(!g||!C||!U)&&(r=1,t=0,c=0,g=!0,C=!1,U=!1),u<r?!1:u>r?!g:n<t?!1:n>t?!C:i<c?!1:i>c?!U:!(_&&_<w))}e.isValidVersion=y;function m(a,v,A,l,_){const s=[];if(typeof l.publisher!="undefined"&&typeof l.publisher!="string")return s.push([p.default.Error,b.localize(0,null)]),s;if(typeof l.name!="string")return s.push([p.default.Error,b.localize(1,null,"name")]),s;if(typeof l.version!="string")return s.push([p.default.Error,b.localize(2,null,"version")]),s;if(!l.engines)return s.push([p.default.Error,b.localize(3,null,"engines")]),s;if(typeof l.engines.vscode!="string")return s.push([p.default.Error,b.localize(4,null,"engines.vscode")]),s;if(typeof l.extensionDependencies!="undefined"&&!d(l.extensionDependencies))return s.push([p.default.Error,b.localize(5,null,"extensionDependencies")]),s;if(typeof l.activationEvents!="undefined"){if(!d(l.activationEvents))return s.push([p.default.Error,b.localize(6,null,"activationEvents")]),s;if(typeof l.main=="undefined"&&typeof l.browser=="undefined")return s.push([p.default.Error,b.localize(7,null,"activationEvents","main")]),s}if(typeof l.extensionKind!="undefined"&&typeof l.main=="undefined"&&s.push([p.default.Warning,b.localize(8,null,"extensionKind")]),typeof l.main!="undefined"){if(typeof l.main!="string")return s.push([p.default.Error,b.localize(9,null,"main")]),s;{const i=(0,o.joinPath)(A,l.main);(0,o.isEqualOrParent)(i,A)||s.push([p.default.Warning,b.localize(10,null,i.path,A.path)])}if(typeof l.activationEvents=="undefined")return s.push([p.default.Error,b.localize(11,null,"activationEvents","main")]),s}if(typeof l.browser!="undefined"){if(typeof l.browser!="string")return s.push([p.default.Error,b.localize(12,null,"browser")]),s;{const i=(0,o.joinPath)(A,l.browser);(0,o.isEqualOrParent)(i,A)||s.push([p.default.Warning,b.localize(13,null,i.path,A.path)])}if(typeof l.activationEvents=="undefined")return s.push([p.default.Error,b.localize(14,null,"activationEvents","browser")]),s}if(!L.valid(l.version))return s.push([p.default.Error,b.localize(15,null)]),s;const u=[];if(!I(a,v,l,_,u))for(const i of u)s.push([p.default.Error,i]);return s}e.validateExtensionManifest=m;function I(a,v,A,l,_){return l||typeof A.main=="undefined"&&typeof A.browser=="undefined"?!0:h(a,v,A.engines.vscode,_)}e.isValidExtensionVersion=I;function f(a,v,A){return a==="*"||h(v,A,a)}e.isEngineValid=f;function h(a,v,A,l=[]){const _=R(P(A));if(!_)return l.push(b.localize(16,null,A)),!1;if(_.majorBase===0){if(!_.majorMustEqual||!_.minorMustEqual)return l.push(b.localize(17,null,A)),!1}else if(!_.majorMustEqual)return l.push(b.localize(18,null,A)),!1;return y(a,v,_)?!0:(l.push(b.localize(19,null,a,A)),!1)}function d(a){if(!Array.isArray(a))return!1;for(let v=0,A=a.length;v<A;v++)if(typeof a[v]!="string")return!1;return!0}}),define(De[78],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SyncDescriptor=void 0;class o{constructor(b,L=[],D=!1){this.ctor=b,this.staticArguments=L,this.supportsDelayedInstantiation=D}}e.SyncDescriptor=o}),define(De[56],Ce([1,0,78]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getSingletonServiceDescriptors=e.registerSingleton=void 0;const p=[];function b(D,T,E){T instanceof o.SyncDescriptor||(T=new o.SyncDescriptor(T,[],E)),p.push([D,T])}e.registerSingleton=b;function L(){return p}e.getSingletonServiceDescriptors=L}),define(De[145],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Graph=e.Node=void 0;class o{constructor(L){this.incoming=new Map,this.outgoing=new Map,this.data=L}}e.Node=o;class p{constructor(L){this._hashFn=L,this._nodes=new Map}roots(){const L=[];for(const D of this._nodes.values())D.outgoing.size===0&&L.push(D);return L}insertEdge(L,D){const T=this.lookupOrInsertNode(L),E=this.lookupOrInsertNode(D);T.outgoing.set(this._hashFn(D),E),E.incoming.set(this._hashFn(L),T)}removeNode(L){const D=this._hashFn(L);this._nodes.delete(D);for(const T of this._nodes.values())T.outgoing.delete(D),T.incoming.delete(D)}lookupOrInsertNode(L){const D=this._hashFn(L);let T=this._nodes.get(D);return T||(T=new o(L),this._nodes.set(D,T)),T}lookup(L){return this._nodes.get(this._hashFn(L))}isEmpty(){return this._nodes.size===0}toString(){const L=[];for(const[D,T]of this._nodes)L.push(`${D}, (incoming)[${[...T.incoming.keys()].join(", ")}], (outgoing)[${[...T.outgoing.keys()].join(",")}]`);return L.join(`
`)}findCycleSlow(){for(const[L,D]of this._nodes){const T=new Set([L]),E=this._findCycle(D,T);if(E)return E}}_findCycle(L,D){for(const[T,E]of L.outgoing){if(D.has(T))return[...D,T].join(" -> ");D.add(T);const P=this._findCycle(E,D);if(P)return P;D.delete(T)}}}e.Graph=p}),define(De[3],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.refineServiceDecorator=e.createDecorator=e.IInstantiationService=e._util=void 0;var o;(function(D){D.serviceIds=new Map,D.DI_TARGET="$di$target",D.DI_DEPENDENCIES="$di$dependencies";function T(E){return E[D.DI_DEPENDENCIES]||[]}D.getServiceDependencies=T})(o=e._util||(e._util={})),e.IInstantiationService=b("instantiationService");function p(D,T,E){T[o.DI_TARGET]===T?T[o.DI_DEPENDENCIES].push({id:D,index:E}):(T[o.DI_DEPENDENCIES]=[{id:D,index:E}],T[o.DI_TARGET]=T)}function b(D){if(o.serviceIds.has(D))return o.serviceIds.get(D);const T=function(E,P,R){if(arguments.length!==3)throw new Error("@IServiceName-decorator can only be used to decorate a parameter");p(T,E,R)};return T.toString=()=>D,o.serviceIds.set(D,T),T}e.createDecorator=b;function L(D){return D}e.refineServiceDecorator=L}),define(De[57],Ce([1,0,10,2,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getLanguageTagSettingPlainKey=e.getMigratedSettingValue=e.merge=e.getConfigurationValue=e.removeFromValueTree=e.addToValueTree=e.toValuesTree=e.ConfigurationTargetToString=e.ConfigurationTarget=e.isConfigurationUpdateOverrides=e.isConfigurationOverrides=e.IConfigurationService=void 0,e.IConfigurationService=(0,b.createDecorator)("configurationService");function L(a){return a&&typeof a=="object"&&(!a.overrideIdentifier||typeof a.overrideIdentifier=="string")&&(!a.resource||a.resource instanceof p.URI)}e.isConfigurationOverrides=L;function D(a){return a&&typeof a=="object"&&(!a.overrideIdentifiers||Array.isArray(a.overrideIdentifiers))&&!a.overrideIdentifier&&(!a.resource||a.resource instanceof p.URI)}e.isConfigurationUpdateOverrides=D;var T;(function(a){a[a.APPLICATION=1]="APPLICATION",a[a.USER=2]="USER",a[a.USER_LOCAL=3]="USER_LOCAL",a[a.USER_REMOTE=4]="USER_REMOTE",a[a.WORKSPACE=5]="WORKSPACE",a[a.WORKSPACE_FOLDER=6]="WORKSPACE_FOLDER",a[a.DEFAULT=7]="DEFAULT",a[a.MEMORY=8]="MEMORY"})(T=e.ConfigurationTarget||(e.ConfigurationTarget={}));function E(a){switch(a){case 1:return"APPLICATION";case 2:return"USER";case 3:return"USER_LOCAL";case 4:return"USER_REMOTE";case 5:return"WORKSPACE";case 6:return"WORKSPACE_FOLDER";case 7:return"DEFAULT";case 8:return"MEMORY"}}e.ConfigurationTargetToString=E;function P(a,v){const A=Object.create(null);for(const l in a)R(A,l,a[l],v);return A}e.toValuesTree=P;function R(a,v,A,l){const _=v.split("."),s=_.pop();let u=a;for(let n=0;n<_.length;n++){const i=_[n];let r=u[i];switch(typeof r){case"undefined":r=u[i]=Object.create(null);break;case"object":break;default:l(`Ignoring ${v} as ${_.slice(0,n+1).join(".")} is ${JSON.stringify(r)}`);return}u=r}if(typeof u=="object"&&u!==null)try{u[s]=A}catch{l(`Ignoring ${v} as ${_.join(".")} is ${JSON.stringify(u)}`)}else l(`Ignoring ${v} as ${_.join(".")} is ${JSON.stringify(u)}`)}e.addToValueTree=R;function y(a,v){const A=v.split(".");m(a,A)}e.removeFromValueTree=y;function m(a,v){const A=v.shift();if(v.length===0){delete a[A];return}if(Object.keys(a).indexOf(A)!==-1){const l=a[A];typeof l=="object"&&!Array.isArray(l)&&(m(l,v),Object.keys(l).length===0&&delete a[A])}}function I(a,v,A){function l(u,n){let i=u;for(const r of n){if(typeof i!="object"||i===null)return;i=i[r]}return i}const _=v.split("."),s=l(a,_);return typeof s=="undefined"?A:s}e.getConfigurationValue=I;function f(a,v,A){Object.keys(v).forEach(l=>{l!=="__proto__"&&(l in a?o.isObject(a[l])&&o.isObject(v[l])?f(a[l],v[l],A):A&&(a[l]=v[l]):a[l]=v[l])})}e.merge=f;function h(a,v,A){const l=a.inspect(v),_=a.inspect(A);return typeof l.userValue!="undefined"||typeof l.workspaceValue!="undefined"||typeof l.workspaceFolderValue!="undefined"?l.value:typeof _.userValue!="undefined"||typeof _.workspaceValue!="undefined"||typeof _.workspaceFolderValue!="undefined"?_.value:l.defaultValue}e.getMigratedSettingValue=h;function d(a){return a.replace(/[\[\]]/g,"")}e.getLanguageTagSettingPlainKey=d}),define(De[38],Ce([1,0,23,9,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.implies=e.SET_CONTEXT_COMMAND_ID=e.IContextKeyService=e.RawContextKey=e.ContextKeyNotRegexExpr=e.ContextKeyRegexExpr=e.ContextKeySmallerEqualsExpr=e.ContextKeySmallerExpr=e.ContextKeyGreaterEqualsExpr=e.ContextKeyGreaterExpr=e.ContextKeyNotExpr=e.ContextKeyNotEqualsExpr=e.ContextKeyNotInExpr=e.ContextKeyInExpr=e.ContextKeyEqualsExpr=e.ContextKeyDefinedExpr=e.ContextKeyTrueExpr=e.ContextKeyFalseExpr=e.expressionsAreEqualWithConstantSubstitution=e.ContextKeyExpr=e.ContextKeyExprType=void 0;const L=new Map;L.set("false",!1),L.set("true",!0),L.set("isMac",o.isMacintosh),L.set("isLinux",o.isLinux),L.set("isWindows",o.isWindows),L.set("isWeb",o.isWeb),L.set("isMacNative",o.isMacintosh&&!o.isWeb),L.set("isEdge",o.isEdge),L.set("isFirefox",o.isFirefox),L.set("isChrome",o.isChrome),L.set("isSafari",o.isSafari);const D=Object.prototype.hasOwnProperty;var T;(function(M){M[M.False=0]="False",M[M.True=1]="True",M[M.Defined=2]="Defined",M[M.Not=3]="Not",M[M.Equals=4]="Equals",M[M.NotEquals=5]="NotEquals",M[M.And=6]="And",M[M.Regex=7]="Regex",M[M.NotRegex=8]="NotRegex",M[M.Or=9]="Or",M[M.In=10]="In",M[M.NotIn=11]="NotIn",M[M.Greater=12]="Greater",M[M.GreaterEquals=13]="GreaterEquals",M[M.Smaller=14]="Smaller",M[M.SmallerEquals=15]="SmallerEquals"})(T=e.ContextKeyExprType||(e.ContextKeyExprType={}));class E{static false(){return y.INSTANCE}static true(){return m.INSTANCE}static has(S){return I.create(S)}static equals(S,z){return f.create(S,z)}static notEquals(S,z){return a.create(S,z)}static regex(S,z){return n.create(S,z)}static in(S,z){return h.create(S,z)}static notIn(S,z){return d.create(S,z)}static not(S){return v.create(S)}static and(...S){return t.create(S,null)}static or(...S){return c.create(S,null,!0)}static greater(S,z){return l.create(S,z)}static greaterEquals(S,z){return _.create(S,z)}static smaller(S,z){return s.create(S,z)}static smallerEquals(S,z){return u.create(S,z)}static deserialize(S,z=!1){if(!!S)return this._deserializeOrExpression(S,z)}static _deserializeOrExpression(S,z){const $=S.split("||");return c.create($.map(N=>this._deserializeAndExpression(N,z)),null,!0)}static _deserializeAndExpression(S,z){const $=S.split("&&");return t.create($.map(N=>this._deserializeOne(N,z)),null)}static _deserializeOne(S,z){if(S=S.trim(),S.indexOf("!=")>=0){const $=S.split("!=");return a.create($[0].trim(),this._deserializeValue($[1],z))}if(S.indexOf("==")>=0){const $=S.split("==");return f.create($[0].trim(),this._deserializeValue($[1],z))}if(S.indexOf("=~")>=0){const $=S.split("=~");return n.create($[0].trim(),this._deserializeRegexValue($[1],z))}if(S.indexOf(" not in ")>=0){const $=S.split(" not in ");return d.create($[0].trim(),$[1].trim())}if(S.indexOf(" in ")>=0){const $=S.split(" in ");return h.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>=[^<=>]+$/.test(S)){const $=S.split(">=");return _.create($[0].trim(),$[1].trim())}if(/^[^<=>]+>[^<=>]+$/.test(S)){const $=S.split(">");return l.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<=[^<=>]+$/.test(S)){const $=S.split("<=");return u.create($[0].trim(),$[1].trim())}if(/^[^<=>]+<[^<=>]+$/.test(S)){const $=S.split("<");return s.create($[0].trim(),$[1].trim())}return/^\!\s*/.test(S)?v.create(S.substr(1).trim()):I.create(S)}static _deserializeValue(S,z){if(S=S.trim(),S==="true")return!0;if(S==="false")return!1;const $=/^'([^']*)'$/.exec(S);return $?$[1].trim():S}static _deserializeRegexValue(S,z){if((0,p.isFalsyOrWhitespace)(S)){if(z)throw new Error("missing regexp-value for =~-expression");return console.warn("missing regexp-value for =~-expression"),null}const $=S.indexOf("/"),N=S.lastIndexOf("/");if($===N||$<0){if(z)throw new Error(`bad regexp-value '${S}', missing /-enclosure`);return console.warn(`bad regexp-value '${S}', missing /-enclosure`),null}const K=S.slice($+1,N),V=S[N+1]==="i"?"i":"";try{return new RegExp(K,V)}catch(F){if(z)throw new Error(`bad regexp-value '${S}', parse error: ${F}`);return console.warn(`bad regexp-value '${S}', parse error: ${F}`),null}}}e.ContextKeyExpr=E;function P(M,S){const z=M?M.substituteConstants():void 0,$=S?S.substituteConstants():void 0;return!z&&!$?!0:!z||!$?!1:z.equals($)}e.expressionsAreEqualWithConstantSubstitution=P;function R(M,S){return M.cmp(S)}class y{constructor(){this.type=0}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!1}serialize(){return"false"}keys(){return[]}map(S){return this}negate(){return m.INSTANCE}}e.ContextKeyFalseExpr=y,y.INSTANCE=new y;class m{constructor(){this.type=1}cmp(S){return this.type-S.type}equals(S){return S.type===this.type}substituteConstants(){return this}evaluate(S){return!0}serialize(){return"true"}keys(){return[]}map(S){return this}negate(){return y.INSTANCE}}e.ContextKeyTrueExpr=m,m.INSTANCE=new m;class I{constructor(S,z){this.key=S,this.negated=z,this.type=2}static create(S,z=null){const $=L.get(S);return typeof $=="boolean"?$?m.INSTANCE:y.INSTANCE:new I(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:g(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=L.get(this.key);return typeof S=="boolean"?S?m.INSTANCE:y.INSTANCE:this}evaluate(S){return!!S.getValue(this.key)}serialize(){return this.key}keys(){return[this.key]}map(S){return S.mapDefined(this.key)}negate(){return this.negated||(this.negated=v.create(this.key,this)),this.negated}}e.ContextKeyDefinedExpr=I;class f{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=4}static create(S,z,$=null){if(typeof z=="boolean")return z?I.create(S,$):v.create(S,$);const N=L.get(S);return typeof N=="boolean"?z===(N?"true":"false")?m.INSTANCE:y.INSTANCE:new f(S,z,$)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=L.get(this.key);if(typeof S=="boolean"){const z=S?"true":"false";return this.value===z?m.INSTANCE:y.INSTANCE}return this}evaluate(S){return S.getValue(this.key)==this.value}serialize(){return`${this.key} == '${this.value}'`}keys(){return[this.key]}map(S){return S.mapEquals(this.key,this.value)}negate(){return this.negated||(this.negated=a.create(this.key,this.value,this)),this.negated}}e.ContextKeyEqualsExpr=f;class h{constructor(S,z){this.key=S,this.valueKey=z,this.type=10,this.negated=null}static create(S,z){return new h(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.valueKey,S.key,S.valueKey)}equals(S){return S.type===this.type?this.key===S.key&&this.valueKey===S.valueKey:!1}substituteConstants(){return this}evaluate(S){const z=S.getValue(this.valueKey),$=S.getValue(this.key);return Array.isArray(z)?z.includes($):typeof $=="string"&&typeof z=="object"&&z!==null?D.call(z,$):!1}serialize(){return`${this.key} in '${this.valueKey}'`}keys(){return[this.key,this.valueKey]}map(S){return S.mapIn(this.key,this.valueKey)}negate(){return this.negated||(this.negated=d.create(this.key,this.valueKey)),this.negated}}e.ContextKeyInExpr=h;class d{constructor(S,z){this.key=S,this.valueKey=z,this.type=11,this._negated=h.create(S,z)}static create(S,z){return new d(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:this._negated.cmp(S._negated)}equals(S){return S.type===this.type?this._negated.equals(S._negated):!1}substituteConstants(){return this}evaluate(S){return!this._negated.evaluate(S)}serialize(){return`${this.key} not in '${this.valueKey}'`}keys(){return this._negated.keys()}map(S){return S.mapNotIn(this.key,this.valueKey)}negate(){return this._negated}}e.ContextKeyNotInExpr=d;class a{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=5}static create(S,z,$=null){if(typeof z=="boolean")return z?v.create(S,$):I.create(S,$);const N=L.get(S);return typeof N=="boolean"?z===(N?"true":"false")?y.INSTANCE:m.INSTANCE:new a(S,z,$)}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){const S=L.get(this.key);if(typeof S=="boolean"){const z=S?"true":"false";return this.value===z?y.INSTANCE:m.INSTANCE}return this}evaluate(S){return S.getValue(this.key)!=this.value}serialize(){return`${this.key} != '${this.value}'`}keys(){return[this.key]}map(S){return S.mapNotEquals(this.key,this.value)}negate(){return this.negated||(this.negated=f.create(this.key,this.value,this)),this.negated}}e.ContextKeyNotEqualsExpr=a;class v{constructor(S,z){this.key=S,this.negated=z,this.type=3}static create(S,z=null){const $=L.get(S);return typeof $=="boolean"?$?y.INSTANCE:m.INSTANCE:new v(S,z)}cmp(S){return S.type!==this.type?this.type-S.type:g(this.key,S.key)}equals(S){return S.type===this.type?this.key===S.key:!1}substituteConstants(){const S=L.get(this.key);return typeof S=="boolean"?S?y.INSTANCE:m.INSTANCE:this}evaluate(S){return!S.getValue(this.key)}serialize(){return`!${this.key}`}keys(){return[this.key]}map(S){return S.mapNot(this.key)}negate(){return this.negated||(this.negated=I.create(this.key,this)),this.negated}}e.ContextKeyNotExpr=v;function A(M,S){if(typeof M=="string"){const z=parseFloat(M);isNaN(z)||(M=z)}return typeof M=="string"||typeof M=="number"?S(M):y.INSTANCE}class l{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=12}static create(S,z,$=null){return A(z,N=>new l(S,N,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>this.value}serialize(){return`${this.key} > ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreater(this.key,this.value)}negate(){return this.negated||(this.negated=u.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterExpr=l;class _{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=13}static create(S,z,$=null){return A(z,N=>new _(S,N,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))>=this.value}serialize(){return`${this.key} >= ${this.value}`}keys(){return[this.key]}map(S){return S.mapGreaterEquals(this.key,this.value)}negate(){return this.negated||(this.negated=s.create(this.key,this.value,this)),this.negated}}e.ContextKeyGreaterEqualsExpr=_;class s{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=14}static create(S,z,$=null){return A(z,N=>new s(S,N,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<this.value}serialize(){return`${this.key} < ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmaller(this.key,this.value)}negate(){return this.negated||(this.negated=_.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerExpr=s;class u{constructor(S,z,$){this.key=S,this.value=z,this.negated=$,this.type=15}static create(S,z,$=null){return A(z,N=>new u(S,N,$))}cmp(S){return S.type!==this.type?this.type-S.type:C(this.key,this.value,S.key,S.value)}equals(S){return S.type===this.type?this.key===S.key&&this.value===S.value:!1}substituteConstants(){return this}evaluate(S){return typeof this.value=="string"?!1:parseFloat(S.getValue(this.key))<=this.value}serialize(){return`${this.key} <= ${this.value}`}keys(){return[this.key]}map(S){return S.mapSmallerEquals(this.key,this.value)}negate(){return this.negated||(this.negated=l.create(this.key,this.value,this)),this.negated}}e.ContextKeySmallerEqualsExpr=u;class n{constructor(S,z){this.key=S,this.regexp=z,this.type=7,this.negated=null}static create(S,z){return new n(S,z)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.key<S.key)return-1;if(this.key>S.key)return 1;const z=this.regexp?this.regexp.source:"",$=S.regexp?S.regexp.source:"";return z<$?-1:z>$?1:0}equals(S){if(S.type===this.type){const z=this.regexp?this.regexp.source:"",$=S.regexp?S.regexp.source:"";return this.key===S.key&&z===$}return!1}substituteConstants(){return this}evaluate(S){const z=S.getValue(this.key);return this.regexp?this.regexp.test(z):!1}serialize(){const S=this.regexp?`/${this.regexp.source}/${this.regexp.ignoreCase?"i":""}`:"/invalid/";return`${this.key} =~ ${S}`}keys(){return[this.key]}map(S){return S.mapRegex(this.key,this.regexp)}negate(){return this.negated||(this.negated=i.create(this)),this.negated}}e.ContextKeyRegexExpr=n;class i{constructor(S){this._actual=S,this.type=8}static create(S){return new i(S)}cmp(S){return S.type!==this.type?this.type-S.type:this._actual.cmp(S._actual)}equals(S){return S.type===this.type?this._actual.equals(S._actual):!1}substituteConstants(){return this}evaluate(S){return!this._actual.evaluate(S)}serialize(){throw new Error("Method not implemented.")}keys(){return this._actual.keys()}map(S){return new i(this._actual.map(S))}negate(){return this._actual}}e.ContextKeyNotRegexExpr=i;function r(M){let S=null;for(let z=0,$=M.length;z<$;z++){const N=M[z].substituteConstants();if(M[z]!==N&&S===null){S=[];for(let K=0;K<z;K++)S[K]=M[K]}S!==null&&(S[z]=N)}return S===null?M:S}class t{constructor(S,z){this.expr=S,this.negated=z,this.type=6}static create(S,z){return t._normalizeArr(S,z)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const N=R(this.expr[z],S.expr[z]);if(N!==0)return N}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(S.expr[z]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:t.create(S,this.negated)}evaluate(S){for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].evaluate(S))return!1;return!0}static _normalizeArr(S,z){const $=[];let N=!1;for(const K of S)if(!!K){if(K.type===1){N=!0;continue}if(K.type===0)return y.INSTANCE;if(K.type===6){$.push(...K.expr);continue}$.push(K)}if($.length===0&&N)return m.INSTANCE;if($.length!==0){if($.length===1)return $[0];$.sort(R);for(let K=1;K<$.length;K++)$[K-1].equals($[K])&&($.splice(K,1),K--);if($.length===1)return $[0];for(;$.length>1;){const K=$[$.length-1];if(K.type!==9)break;$.pop();const V=$.pop(),F=$.length===0,ne=c.create(K.expr.map(ce=>t.create([ce,V],null)),null,F);ne&&($.push(ne),$.sort(R))}return $.length===1?$[0]:new t($,z)}}serialize(){return this.expr.map(S=>S.serialize()).join(" && ")}keys(){const S=[];for(const z of this.expr)S.push(...z.keys());return S}map(S){return new t(this.expr.map(z=>z.map(S)),null)}negate(){if(!this.negated){const S=[];for(const z of this.expr)S.push(z.negate());this.negated=c.create(S,this,!0)}return this.negated}}class c{constructor(S,z){this.expr=S,this.negated=z,this.type=9}static create(S,z,$){return c._normalizeArr(S,z,$)}cmp(S){if(S.type!==this.type)return this.type-S.type;if(this.expr.length<S.expr.length)return-1;if(this.expr.length>S.expr.length)return 1;for(let z=0,$=this.expr.length;z<$;z++){const N=R(this.expr[z],S.expr[z]);if(N!==0)return N}return 0}equals(S){if(S.type===this.type){if(this.expr.length!==S.expr.length)return!1;for(let z=0,$=this.expr.length;z<$;z++)if(!this.expr[z].equals(S.expr[z]))return!1;return!0}return!1}substituteConstants(){const S=r(this.expr);return S===this.expr?this:c.create(S,this.negated,!1)}evaluate(S){for(let z=0,$=this.expr.length;z<$;z++)if(this.expr[z].evaluate(S))return!0;return!1}static _normalizeArr(S,z,$){let N=[],K=!1;if(S){for(let V=0,F=S.length;V<F;V++){const ne=S[V];if(!!ne){if(ne.type===0){K=!0;continue}if(ne.type===1)return m.INSTANCE;if(ne.type===9){N=N.concat(ne.expr);continue}N.push(ne)}}if(N.length===0&&K)return y.INSTANCE;N.sort(R)}if(N.length!==0){if(N.length===1)return N[0];for(let V=1;V<N.length;V++)N[V-1].equals(N[V])&&(N.splice(V,1),V--);if(N.length===1)return N[0];if($){for(let V=0;V<N.length;V++)for(let F=V+1;F<N.length;F++)U(N[V],N[F])&&(N.splice(F,1),F--);if(N.length===1)return N[0]}return new c(N,z)}}serialize(){return this.expr.map(S=>S.serialize()).join(" || ")}keys(){const S=[];for(const z of this.expr)S.push(...z.keys());return S}map(S){return new c(this.expr.map(z=>z.map(S)),null)}negate(){if(!this.negated){const S=[];for(const z of this.expr)S.push(z.negate());for(;S.length>1;){const z=S.shift(),$=S.shift(),N=[];for(const V of W(z))for(const F of W($))N.push(t.create([V,F],null));const K=S.length===0;S.unshift(c.create(N,null,K))}this.negated=S[0]}return this.negated}}class w extends I{constructor(S,z,$){super(S,null);this._defaultValue=z,typeof $=="object"?w._info.push({...$,key:S}):$!==!0&&w._info.push({key:S,description:$,type:z!=null?typeof z:void 0})}static all(){return w._info.values()}bindTo(S){return S.createKey(this.key,this._defaultValue)}getValue(S){return S.getContextKeyValue(this.key)}toNegated(){return this.negate()}isEqualTo(S){return f.create(this.key,S)}notEqualsTo(S){return a.create(this.key,S)}}e.RawContextKey=w,w._info=[],e.IContextKeyService=(0,b.createDecorator)("contextKeyService"),e.SET_CONTEXT_COMMAND_ID="setContext";function g(M,S){return M<S?-1:M>S?1:0}function C(M,S,z,$){return M<z?-1:M>z?1:S<$?-1:S>$?1:0}function U(M,S){if(S.type===6&&M.type!==9&&M.type!==6){for(const N of S.expr)if(M.equals(N))return!0}const z=M.negate(),$=W(z).concat(W(S));$.sort(R);for(let N=0;N<$.length;N++){const V=$[N].negate();for(let F=N+1;F<$.length;F++){const ne=$[F];if(V.equals(ne))return!0}}return!1}e.implies=U;function W(M){return M.type===9?M.expr:[M]}}),define(De[146],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INativeEnvironmentService=e.IEnvironmentService=void 0,e.IEnvironmentService=(0,o.createDecorator)("environmentService"),e.INativeEnvironmentService=(0,o.refineServiceDecorator)(e.IEnvironmentService)}),define(De[79],Ce([1,0,123,3]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IDefaultExtensionsProfileInitService=e.IExtensionManagementCLIService=e.PreferencesLocalizedLabel=e.PreferencesLabel=e.ExtensionsChannelId=e.ExtensionsLocalizedLabel=e.ExtensionsLabel=e.IExtensionTipsService=e.IGlobalExtensionEnablementService=e.ENABLED_EXTENSIONS_STORAGE_PATH=e.DISABLED_EXTENSIONS_STORAGE_PATH=e.IServerExtensionManagementService=e.IExtensionManagementService=e.ExtensionManagementError=e.ExtensionManagementErrorCode=e.IExtensionGalleryService=e.InstallOperation=e.StatisticType=e.SortOrder=e.SortBy=e.isIExtensionIdentifier=e.getFallbackTargetPlarforms=e.isTargetPlatformCompatible=e.isNotWebExtensionInWebTargetPlatform=e.getTargetPlatform=e.toTargetPlatform=e.TargetPlatformToString=e.WEB_EXTENSION_TAG=e.EXTENSION_IDENTIFIER_REGEX=e.EXTENSION_IDENTIFIER_PATTERN=void 0,e.EXTENSION_IDENTIFIER_PATTERN="^([a-z0-9A-Z][a-z0-9-A-Z]*)\\.([a-z0-9A-Z][a-z0-9-A-Z]*)$",e.EXTENSION_IDENTIFIER_REGEX=new RegExp(e.EXTENSION_IDENTIFIER_PATTERN),e.WEB_EXTENSION_TAG="__web_extension";function b(a){switch(a){case"win32-x64":return"Windows 64 bit";case"win32-ia32":return"Windows 32 bit";case"win32-arm64":return"Windows ARM";case"linux-x64":return"Linux 64 bit";case"linux-arm64":return"Linux ARM 64";case"linux-armhf":return"Linux ARM";case"alpine-x64":return"Alpine Linux 64 bit";case"alpine-arm64":return"Alpine ARM 64";case"darwin-x64":return"Mac";case"darwin-arm64":return"Mac Silicon";case"web":return"Web";case"universal":return"universal";case"unknown":return"unknown";case"undefined":return"undefined"}}e.TargetPlatformToString=b;function L(a){switch(a){case"win32-x64":return"win32-x64";case"win32-ia32":return"win32-ia32";case"win32-arm64":return"win32-arm64";case"linux-x64":return"linux-x64";case"linux-arm64":return"linux-arm64";case"linux-armhf":return"linux-armhf";case"alpine-x64":return"alpine-x64";case"alpine-arm64":return"alpine-arm64";case"darwin-x64":return"darwin-x64";case"darwin-arm64":return"darwin-arm64";case"web":return"web";case"universal":return"universal";default:return"unknown"}}e.toTargetPlatform=L;function D(a,v){switch(a){case 3:return v==="x64"?"win32-x64":v==="ia32"?"win32-ia32":v==="arm64"?"win32-arm64":"unknown";case 2:return v==="x64"?"linux-x64":v==="arm64"?"linux-arm64":v==="arm"?"linux-armhf":"unknown";case"alpine":return v==="x64"?"alpine-x64":v==="arm64"?"alpine-arm64":"unknown";case 1:return v==="x64"?"darwin-x64":v==="arm64"?"darwin-arm64":"unknown";case 0:return"web"}}e.getTargetPlatform=D;function T(a,v){return v==="web"&&!a.includes("web")}e.isNotWebExtensionInWebTargetPlatform=T;function E(a,v,A){return T(v,A)?!1:a==="undefined"||a==="universal"?!0:a==="unknown"?!1:a===A?!0:P(A).includes(a)}e.isTargetPlatformCompatible=E;function P(a){switch(a){case"win32-x64":return["win32-ia32"];case"win32-arm64":return["win32-ia32"]}return[]}e.getFallbackTargetPlarforms=P;function R(a){return a&&typeof a=="object"&&typeof a.id=="string"&&(!a.uuid||typeof a.uuid=="string")}e.isIExtensionIdentifier=R;var y;(function(a){a[a.NoneOrRelevance=0]="NoneOrRelevance",a[a.LastUpdatedDate=1]="LastUpdatedDate",a[a.Title=2]="Title",a[a.PublisherName=3]="PublisherName",a[a.InstallCount=4]="InstallCount",a[a.PublishedDate=10]="PublishedDate",a[a.AverageRating=6]="AverageRating",a[a.WeightedRating=12]="WeightedRating"})(y=e.SortBy||(e.SortBy={}));var m;(function(a){a[a.Default=0]="Default",a[a.Ascending=1]="Ascending",a[a.Descending=2]="Descending"})(m=e.SortOrder||(e.SortOrder={}));var I;(function(a){a.Install="install",a.Uninstall="uninstall"})(I=e.StatisticType||(e.StatisticType={}));var f;(function(a){a[a.None=1]="None",a[a.Install=2]="Install",a[a.Update=3]="Update",a[a.Migrate=4]="Migrate"})(f=e.InstallOperation||(e.InstallOperation={})),e.IExtensionGalleryService=(0,p.createDecorator)("extensionGalleryService");var h;(function(a){a.Unsupported="Unsupported",a.Deprecated="Deprecated",a.Malicious="Malicious",a.Incompatible="Incompatible",a.IncompatiblePreRelease="IncompatiblePreRelease",a.IncompatibleTargetPlatform="IncompatibleTargetPlatform",a.ReleaseVersionNotFound="ReleaseVersionNotFound",a.Invalid="Invalid",a.Download="Download",a.Extract="Extract",a.Delete="Delete",a.Rename="Rename",a.CorruptZip="CorruptZip",a.IncompleteZip="IncompleteZip",a.Internal="Internal"})(h=e.ExtensionManagementErrorCode||(e.ExtensionManagementErrorCode={}));class d extends Error{constructor(v,A){super(v);this.code=A,this.name=A}}e.ExtensionManagementError=d,e.IExtensionManagementService=(0,p.createDecorator)("extensionManagementService"),e.IServerExtensionManagementService=(0,p.refineServiceDecorator)(e.IExtensionManagementService),e.DISABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/disabled",e.ENABLED_EXTENSIONS_STORAGE_PATH="extensionsIdentifiers/enabled",e.IGlobalExtensionEnablementService=(0,p.createDecorator)("IGlobalExtensionEnablementService"),e.IExtensionTipsService=(0,p.createDecorator)("IExtensionTipsService"),e.ExtensionsLabel=(0,o.localize)(0,null),e.ExtensionsLocalizedLabel={value:e.ExtensionsLabel,original:"Extensions"},e.ExtensionsChannelId="extensions",e.PreferencesLabel=(0,o.localize)(1,null),e.PreferencesLocalizedLabel={value:e.PreferencesLabel,original:"Preferences"},e.IExtensionManagementCLIService=(0,p.createDecorator)("IExtensionManagementCLIService"),e.IDefaultExtensionsProfileInitService=(0,p.createDecorator)("IDefaultExtensionsProfileInitService")}),define(De[39],Ce([1,0,25,19,9,10,2,125,3]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPlatformLimits=e.Arch=e.ByteSize=e.FALLBACK_MAX_MEMORY_SIZE_MB=e.MIN_MAX_MEMORY_SIZE_MB=e.whenProviderRegistered=e.etag=e.ETAG_DISABLED=e.FileKind=e.FILES_EXCLUDE_CONFIG=e.FILES_ASSOCIATIONS_CONFIG=e.HotExitConfiguration=e.AutoSaveConfiguration=e.FileOperationResult=e.NotModifiedSinceFileOperationError=e.FileOperationError=e.isParent=e.FileChangesEvent=e.FileChangeType=e.FileOperationEvent=e.FileOperation=e.toFileOperationResult=e.toFileSystemProviderErrorCode=e.markAsFileSystemProviderError=e.ensureFileSystemProviderError=e.createFileSystemProviderError=e.FileSystemProviderError=e.FileSystemProviderErrorCode=e.hasFileAtomicReadCapability=e.hasFileReadStreamCapability=e.hasOpenReadWriteCloseCapability=e.hasFileCloneCapability=e.hasFileFolderCopyCapability=e.hasReadWriteCapability=e.FileSystemProviderCapabilities=e.FilePermission=e.FileType=e.isFileOpenForWriteOptions=e.IFileService=void 0,e.IFileService=(0,E.createDecorator)("fileService");function P(V){return V.create===!0}e.isFileOpenForWriteOptions=P;var R;(function(V){V[V.Unknown=0]="Unknown",V[V.File=1]="File",V[V.Directory=2]="Directory",V[V.SymbolicLink=64]="SymbolicLink"})(R=e.FileType||(e.FileType={}));var y;(function(V){V[V.Readonly=1]="Readonly"})(y=e.FilePermission||(e.FilePermission={}));var m;(function(V){V[V.FileReadWrite=2]="FileReadWrite",V[V.FileOpenReadWriteClose=4]="FileOpenReadWriteClose",V[V.FileReadStream=16]="FileReadStream",V[V.FileFolderCopy=8]="FileFolderCopy",V[V.PathCaseSensitive=1024]="PathCaseSensitive",V[V.Readonly=2048]="Readonly",V[V.Trash=4096]="Trash",V[V.FileWriteUnlock=8192]="FileWriteUnlock",V[V.FileAtomicRead=16384]="FileAtomicRead",V[V.FileClone=32768]="FileClone"})(m=e.FileSystemProviderCapabilities||(e.FileSystemProviderCapabilities={}));function I(V){return!!(V.capabilities&2)}e.hasReadWriteCapability=I;function f(V){return!!(V.capabilities&8)}e.hasFileFolderCopyCapability=f;function h(V){return!!(V.capabilities&32768)}e.hasFileCloneCapability=h;function d(V){return!!(V.capabilities&4)}e.hasOpenReadWriteCloseCapability=d;function a(V){return!!(V.capabilities&16)}e.hasFileReadStreamCapability=a;function v(V){return I(V)?!!(V.capabilities&16384):!1}e.hasFileAtomicReadCapability=v;var A;(function(V){V.FileExists="EntryExists",V.FileNotFound="EntryNotFound",V.FileNotADirectory="EntryNotADirectory",V.FileIsADirectory="EntryIsADirectory",V.FileExceedsMemoryLimit="EntryExceedsMemoryLimit",V.FileTooLarge="EntryTooLarge",V.FileWriteLocked="EntryWriteLocked",V.NoPermissions="NoPermissions",V.Unavailable="Unavailable",V.Unknown="Unknown"})(A=e.FileSystemProviderErrorCode||(e.FileSystemProviderErrorCode={}));class l extends Error{constructor(F,ne){super(F);this.code=ne}}e.FileSystemProviderError=l;function _(V,F){const ne=new l(V.toString(),F);return u(ne,F),ne}e.createFileSystemProviderError=_;function s(V){return V||_((0,T.localize)(0,null),A.Unknown)}e.ensureFileSystemProviderError=s;function u(V,F){return V.name=F?`${F} (FileSystemError)`:"FileSystemError",V}e.markAsFileSystemProviderError=u;function n(V){if(!V)return A.Unknown;if(V instanceof l)return V.code;const F=/^(.+) \(FileSystemError\)$/.exec(V.name);if(!F)return A.Unknown;switch(F[1]){case A.FileExists:return A.FileExists;case A.FileIsADirectory:return A.FileIsADirectory;case A.FileNotADirectory:return A.FileNotADirectory;case A.FileNotFound:return A.FileNotFound;case A.FileExceedsMemoryLimit:return A.FileExceedsMemoryLimit;case A.FileTooLarge:return A.FileTooLarge;case A.FileWriteLocked:return A.FileWriteLocked;case A.NoPermissions:return A.NoPermissions;case A.Unavailable:return A.Unavailable}return A.Unknown}e.toFileSystemProviderErrorCode=n;function i(V){if(V instanceof C)return V.fileOperationResult;switch(n(V)){case A.FileNotFound:return 1;case A.FileIsADirectory:return 0;case A.FileNotADirectory:return 10;case A.FileWriteLocked:return 5;case A.NoPermissions:return 6;case A.FileExists:return 4;case A.FileExceedsMemoryLimit:return 9;case A.FileTooLarge:return 7;default:return 11}}e.toFileOperationResult=i;var r;(function(V){V[V.CREATE=0]="CREATE",V[V.DELETE=1]="DELETE",V[V.MOVE=2]="MOVE",V[V.COPY=3]="COPY",V[V.WRITE=4]="WRITE"})(r=e.FileOperation||(e.FileOperation={}));class t{constructor(F,ne,ce){this.resource=F,this.operation=ne,this.target=ce}isOperation(F){return this.operation===F}}e.FileOperationEvent=t;var c;(function(V){V[V.UPDATED=0]="UPDATED",V[V.ADDED=1]="ADDED",V[V.DELETED=2]="DELETED"})(c=e.FileChangeType||(e.FileChangeType={}));class w{constructor(F,ne){this.added=void 0,this.updated=void 0,this.deleted=void 0,this.rawChanges=[],this.rawAdded=[],this.rawUpdated=[],this.rawDeleted=[],this.rawChanges=F;const ce=new Map;for(const re of F){const fe=ce.get(re.type);switch(fe?fe.push([re.resource,re]):ce.set(re.type,[[re.resource,re]]),re.type){case 1:this.rawAdded.push(re.resource);break;case 0:this.rawUpdated.push(re.resource);break;case 2:this.rawDeleted.push(re.resource);break}}for(const[re,fe]of ce)switch(re){case 1:this.added=o.TernarySearchTree.forUris(()=>ne),this.added.fill(fe);break;case 0:this.updated=o.TernarySearchTree.forUris(()=>ne),this.updated.fill(fe);break;case 2:this.deleted=o.TernarySearchTree.forUris(()=>ne),this.deleted.fill(fe);break}}contains(F,...ne){return this.doContains(F,{includeChildren:!1},...ne)}affects(F,...ne){return this.doContains(F,{includeChildren:!0},...ne)}doContains(F,ne,...ce){if(!F)return!1;const re=ce.length>0;return!!((!re||ce.includes(1))&&(this.added?.get(F)||ne.includeChildren&&this.added?.findSuperstr(F))||(!re||ce.includes(0))&&(this.updated?.get(F)||ne.includeChildren&&this.updated?.findSuperstr(F))||(!re||ce.includes(2))&&(this.deleted?.findSubstr(F)||ne.includeChildren&&this.deleted?.findSuperstr(F)))}gotAdded(){return!!this.added}gotDeleted(){return!!this.deleted}gotUpdated(){return!!this.updated}}e.FileChangesEvent=w;function g(V,F,ne){return!V||!F||V===F||F.length>V.length?!1:(F.charAt(F.length-1)!==p.sep&&(F+=p.sep),ne?(0,b.startsWithIgnoreCase)(V,F):V.indexOf(F)===0)}e.isParent=g;class C extends Error{constructor(F,ne,ce){super(F);this.fileOperationResult=ne,this.options=ce}}e.FileOperationError=C;class U extends C{constructor(F,ne,ce){super(F,2,ce);this.stat=ne}}e.NotModifiedSinceFileOperationError=U;var W;(function(V){V[V.FILE_IS_DIRECTORY=0]="FILE_IS_DIRECTORY",V[V.FILE_NOT_FOUND=1]="FILE_NOT_FOUND",V[V.FILE_NOT_MODIFIED_SINCE=2]="FILE_NOT_MODIFIED_SINCE",V[V.FILE_MODIFIED_SINCE=3]="FILE_MODIFIED_SINCE",V[V.FILE_MOVE_CONFLICT=4]="FILE_MOVE_CONFLICT",V[V.FILE_WRITE_LOCKED=5]="FILE_WRITE_LOCKED",V[V.FILE_PERMISSION_DENIED=6]="FILE_PERMISSION_DENIED",V[V.FILE_TOO_LARGE=7]="FILE_TOO_LARGE",V[V.FILE_INVALID_PATH=8]="FILE_INVALID_PATH",V[V.FILE_EXCEEDS_MEMORY_LIMIT=9]="FILE_EXCEEDS_MEMORY_LIMIT",V[V.FILE_NOT_DIRECTORY=10]="FILE_NOT_DIRECTORY",V[V.FILE_OTHER_ERROR=11]="FILE_OTHER_ERROR"})(W=e.FileOperationResult||(e.FileOperationResult={})),e.AutoSaveConfiguration={OFF:"off",AFTER_DELAY:"afterDelay",ON_FOCUS_CHANGE:"onFocusChange",ON_WINDOW_CHANGE:"onWindowChange"},e.HotExitConfiguration={OFF:"off",ON_EXIT:"onExit",ON_EXIT_AND_WINDOW_CLOSE:"onExitAndWindowClose"},e.FILES_ASSOCIATIONS_CONFIG="files.associations",e.FILES_EXCLUDE_CONFIG="files.exclude";var M;(function(V){V[V.FILE=0]="FILE",V[V.FOLDER=1]="FOLDER",V[V.ROOT_FOLDER=2]="ROOT_FOLDER"})(M=e.FileKind||(e.FileKind={})),e.ETAG_DISABLED="";function S(V){if(!(typeof V.size!="number"||typeof V.mtime!="number"))return V.mtime.toString(29)+V.size.toString(31)}e.etag=S;async function z(V,F){if(!F.hasProvider(D.URI.from({scheme:V.scheme})))return new Promise(ne=>{const ce=F.onDidChangeFileSystemProviderRegistrations(re=>{re.scheme===V.scheme&&re.added&&(ce.dispose(),ne())})})}e.whenProviderRegistered=z,e.MIN_MAX_MEMORY_SIZE_MB=2048,e.FALLBACK_MAX_MEMORY_SIZE_MB=4096;class ${static formatSize(F){return(0,L.isNumber)(F)||(F=0),F<$.KB?(0,T.localize)(1,null,F.toFixed(0)):F<$.MB?(0,T.localize)(2,null,(F/$.KB).toFixed(2)):F<$.GB?(0,T.localize)(3,null,(F/$.MB).toFixed(2)):F<$.TB?(0,T.localize)(4,null,(F/$.GB).toFixed(2)):(0,T.localize)(5,null,(F/$.TB).toFixed(2))}}e.ByteSize=$,$.KB=1024,$.MB=$.KB*$.KB,$.GB=$.MB*$.KB,$.TB=$.GB*$.KB;var N;(function(V){V[V.IA32=0]="IA32",V[V.OTHER=1]="OTHER"})(N=e.Arch||(e.Arch={}));function K(V){return{maxFileSize:V===0?300*$.MB:16*$.GB,maxHeapSize:V===0?700*$.MB:2*700*$.MB}}e.getPlatformLimits=K}),define(De[58],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ServiceCollection=void 0;class o{constructor(...b){this._entries=new Map;for(const[L,D]of b)this.set(L,D)}set(b,L){const D=this._entries.get(b);return this._entries.set(b,L),D}has(b){return this._entries.has(b)}get(b){return this._entries.get(b)}}e.ServiceCollection=o}),define(De[147],Ce([1,0,13,11,78,145,3,58]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Trace=e.InstantiationService=void 0;const E=!1;class P extends Error{constructor(f){super("cyclic dependency between services");this.message=f.findCycleSlow()??`UNABLE to detect cycle, dumping graph: 
${f.toString()}`}}class R{constructor(f=new T.ServiceCollection,h=!1,d){this._activeInstantiations=new Set,this._services=f,this._strict=h,this._parent=d,this._services.set(D.IInstantiationService,this)}createChild(f){return new R(f,this._strict,this)}invokeFunction(f,...h){const d=m.traceInvocation(f);let a=!1;try{return f({get:A=>{if(a)throw(0,p.illegalState)("service accessor is only valid during the invocation of its target method");const l=this._getOrCreateServiceInstance(A,d);if(!l)throw new Error(`[invokeFunction] unknown service '${A}'`);return l}},...h)}finally{a=!0,d.stop()}}createInstance(f,...h){let d,a;return f instanceof b.SyncDescriptor?(d=m.traceCreation(f.ctor),a=this._createInstance(f.ctor,f.staticArguments.concat(h),d)):(d=m.traceCreation(f),a=this._createInstance(f,h,d)),d.stop(),a}_createInstance(f,h=[],d){const a=D._util.getServiceDependencies(f).sort((l,_)=>l.index-_.index),v=[];for(const l of a){const _=this._getOrCreateServiceInstance(l.id,d);_||this._throwIfStrict(`[createInstance] ${f.name} depends on UNKNOWN service ${l.id}.`,!1),v.push(_)}const A=a.length>0?a[0].index:h.length;if(h.length!==A){console.trace(`[createInstance] First service dependency of ${f.name} at position ${A+1} conflicts with ${h.length} static arguments`);const l=A-h.length;l>0?h=h.concat(new Array(l)):h=h.slice(0,A)}return new f(...[...h,...v])}_setServiceInstance(f,h){if(this._services.get(f)instanceof b.SyncDescriptor)this._services.set(f,h);else if(this._parent)this._parent._setServiceInstance(f,h);else throw new Error("illegalState - setting UNKNOWN service instance")}_getServiceInstanceOrDescriptor(f){const h=this._services.get(f);return!h&&this._parent?this._parent._getServiceInstanceOrDescriptor(f):h}_getOrCreateServiceInstance(f,h){const d=this._getServiceInstanceOrDescriptor(f);return d instanceof b.SyncDescriptor?this._safeCreateAndCacheServiceInstance(f,d,h.branch(f,!0)):(h.branch(f,!1),d)}_safeCreateAndCacheServiceInstance(f,h,d){if(this._activeInstantiations.has(f))throw new Error(`illegal state - RECURSIVELY instantiating service '${f}'`);this._activeInstantiations.add(f);try{return this._createAndCacheServiceInstance(f,h,d)}finally{this._activeInstantiations.delete(f)}}_createAndCacheServiceInstance(f,h,d){const a=new L.Graph(l=>l.id.toString());let v=0;const A=[{id:f,desc:h,_trace:d}];for(;A.length;){const l=A.pop();if(a.lookupOrInsertNode(l),v++>1e3)throw new P(a);for(const _ of D._util.getServiceDependencies(l.desc.ctor)){const s=this._getServiceInstanceOrDescriptor(_.id);if(s||this._throwIfStrict(`[createInstance] ${f} depends on ${_.id} which is NOT registered.`,!0),s instanceof b.SyncDescriptor){const u={id:_.id,desc:s,_trace:l._trace.branch(_.id,!0)};a.insertEdge(l,u),A.push(u)}}}for(;;){const l=a.roots();if(l.length===0){if(!a.isEmpty())throw new P(a);break}for(const{data:_}of l){if(this._getServiceInstanceOrDescriptor(_.id)instanceof b.SyncDescriptor){const u=this._createServiceInstanceWithOwner(_.id,_.desc.ctor,_.desc.staticArguments,_.desc.supportsDelayedInstantiation,_._trace);this._setServiceInstance(_.id,u)}a.removeNode(_)}}return this._getServiceInstanceOrDescriptor(f)}_createServiceInstanceWithOwner(f,h,d=[],a,v){if(this._services.get(f)instanceof b.SyncDescriptor)return this._createServiceInstance(h,d,a,v);if(this._parent)return this._parent._createServiceInstanceWithOwner(f,h,d,a,v);throw new Error(`illegalState - creating UNKNOWN service instance ${h.name}`)}_createServiceInstance(f,h=[],d,a){if(d){const v=new o.IdleValue(()=>this._createInstance(f,h,a));return new Proxy(Object.create(null),{get(A,l){if(l in A)return A[l];const _=v.value;let s=_[l];return typeof s!="function"||(s=s.bind(_),A[l]=s),s},set(A,l,_){return v.value[l]=_,!0}})}else return this._createInstance(f,h,a)}_throwIfStrict(f,h){if(h&&console.warn(f),this._strict)throw new Error(f)}}e.InstantiationService=R;var y;(function(I){I[I.Creation=0]="Creation",I[I.Invocation=1]="Invocation",I[I.Branch=2]="Branch"})(y||(y={}));class m{constructor(f,h){this.type=f,this.name=h,this._start=Date.now(),this._dep=[]}static traceInvocation(f){return E?new m(1,f.name||f.toString().substring(0,42).replace(/\n/g,"")):m._None}static traceCreation(f){return E?new m(0,f.name):m._None}branch(f,h){const d=new m(2,f.toString());return this._dep.push([f,h,d]),d}stop(){const f=Date.now()-this._start;m._totals+=f;let h=!1;function d(v,A){const l=[],_=new Array(v+1).join("	");for(const[s,u,n]of A._dep)if(u&&n){h=!0,l.push(`${_}CREATES -> ${s}`);const i=d(v+1,n);i&&l.push(i)}else l.push(`${_}uses -> ${s}`);return l.join(`
`)}const a=[`${this.type===0?"CREATE":"CALL"} ${this.name}`,`${d(1,this)}`,`DONE, took ${f.toFixed(2)}ms (grand total ${m._totals.toFixed(2)}ms)`];(f>2||h)&&console.log(a.join(`
`))}}e.Trace=m,m._None=new class extends m{constructor(){super(-1,null)}stop(){}branch(){return this}},m._totals=0}),define(De[14],Ce([1,0,43,4,7,23,3]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.LogLevelToString=e.parseLogLevel=e.getLogLevel=e.NullLogService=e.AbstractLoggerService=e.LogService=e.MultiplexLogService=e.AdapterLogger=e.ConsoleLogger=e.ConsoleMainLogger=e.AbstractMessageLogger=e.AbstractLogger=e.format=e.log=e.DEFAULT_LOG_LEVEL=e.LogLevel=e.ILoggerService=e.ILogService=void 0,e.ILogService=(0,D.createDecorator)("logService"),e.ILoggerService=(0,D.createDecorator)("loggerService");function T(){return new Date().toISOString()}var E;(function(u){u[u.Trace=0]="Trace",u[u.Debug=1]="Debug",u[u.Info=2]="Info",u[u.Warning=3]="Warning",u[u.Error=4]="Error",u[u.Critical=5]="Critical",u[u.Off=6]="Off"})(E=e.LogLevel||(e.LogLevel={})),e.DEFAULT_LOG_LEVEL=E.Info;function P(u,n,i){switch(n){case E.Trace:u.trace(i);break;case E.Debug:u.debug(i);break;case E.Info:u.info(i);break;case E.Warning:u.warn(i);break;case E.Error:u.error(i);break;case E.Critical:u.critical(i);break;default:throw new Error("Invalid log level")}}e.log=P;function R(u){let n="";for(let i=0;i<u.length;i++){let r=u[i];if(typeof r=="object")try{r=JSON.stringify(r)}catch{}n+=(i>0?" ":"")+r}return n}e.format=R;class y extends b.Disposable{constructor(){super(...arguments);this.level=e.DEFAULT_LOG_LEVEL,this._onDidChangeLogLevel=this._register(new p.Emitter),this.onDidChangeLogLevel=this._onDidChangeLogLevel.event}setLevel(n){this.level!==n&&(this.level=n,this._onDidChangeLogLevel.fire(this.level))}getLevel(){return this.level}}e.AbstractLogger=y;class m extends y{constructor(n){super();this.logAlways=n}checkLogLevel(n){return this.logAlways||this.getLevel()<=n}trace(n,...i){this.checkLogLevel(E.Trace)&&this.log(E.Trace,R([n,...i]))}debug(n,...i){this.checkLogLevel(E.Debug)&&this.log(E.Debug,R([n,...i]))}info(n,...i){this.checkLogLevel(E.Info)&&this.log(E.Info,R([n,...i]))}warn(n,...i){this.checkLogLevel(E.Warning)&&this.log(E.Warning,R([n,...i]))}error(n,...i){if(this.checkLogLevel(E.Error))if(n instanceof Error){const r=Array.prototype.slice.call(arguments);r[0]=n.stack,this.log(E.Error,R(r))}else this.log(E.Error,R([n,...i]))}critical(n,...i){this.checkLogLevel(E.Critical)&&this.log(E.Critical,R([n,...i]))}flush(){}}e.AbstractMessageLogger=m;class I extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n),this.useColors=!L.isWindows}trace(n,...i){this.getLevel()<=E.Trace&&(this.useColors?console.log(`[90m[main ${T()}][0m`,n,...i):console.log(`[main ${T()}]`,n,...i))}debug(n,...i){this.getLevel()<=E.Debug&&(this.useColors?console.log(`[90m[main ${T()}][0m`,n,...i):console.log(`[main ${T()}]`,n,...i))}info(n,...i){this.getLevel()<=E.Info&&(this.useColors?console.log(`[90m[main ${T()}][0m`,n,...i):console.log(`[main ${T()}]`,n,...i))}warn(n,...i){this.getLevel()<=E.Warning&&(this.useColors?console.warn(`[93m[main ${T()}][0m`,n,...i):console.warn(`[main ${T()}]`,n,...i))}error(n,...i){this.getLevel()<=E.Error&&(this.useColors?console.error(`[91m[main ${T()}][0m`,n,...i):console.error(`[main ${T()}]`,n,...i))}critical(n,...i){this.getLevel()<=E.Critical&&(this.useColors?console.error(`[90m[main ${T()}][0m`,n,...i):console.error(`[main ${T()}]`,n,...i))}dispose(){}flush(){}}e.ConsoleMainLogger=I;class f extends y{constructor(n=e.DEFAULT_LOG_LEVEL){super();this.setLevel(n)}trace(n,...i){this.getLevel()<=E.Trace&&console.log("%cTRACE","color: #888",n,...i)}debug(n,...i){this.getLevel()<=E.Debug&&console.log("%cDEBUG","background: #eee; color: #888",n,...i)}info(n,...i){this.getLevel()<=E.Info&&console.log("%c INFO","color: #33f",n,...i)}warn(n,...i){this.getLevel()<=E.Warning&&console.log("%c WARN","color: #993",n,...i)}error(n,...i){this.getLevel()<=E.Error&&console.log("%c  ERR","color: #f33",n,...i)}critical(n,...i){this.getLevel()<=E.Critical&&console.log("%cCRITI","background: #f33; color: white",n,...i)}dispose(){}flush(){}}e.ConsoleLogger=f;class h extends y{constructor(n,i=e.DEFAULT_LOG_LEVEL){super();this.adapter=n,this.setLevel(i)}trace(n,...i){this.getLevel()<=E.Trace&&this.adapter.log(E.Trace,[this.extractMessage(n),...i])}debug(n,...i){this.getLevel()<=E.Debug&&this.adapter.log(E.Debug,[this.extractMessage(n),...i])}info(n,...i){this.getLevel()<=E.Info&&this.adapter.log(E.Info,[this.extractMessage(n),...i])}warn(n,...i){this.getLevel()<=E.Warning&&this.adapter.log(E.Warning,[this.extractMessage(n),...i])}error(n,...i){this.getLevel()<=E.Error&&this.adapter.log(E.Error,[this.extractMessage(n),...i])}critical(n,...i){this.getLevel()<=E.Critical&&this.adapter.log(E.Critical,[this.extractMessage(n),...i])}extractMessage(n){return typeof n=="string"?n:(0,o.toErrorMessage)(n,this.getLevel()<=E.Trace)}dispose(){}flush(){}}e.AdapterLogger=h;class d extends y{constructor(n){super();this.logServices=n,n.length&&this.setLevel(n[0].getLevel())}setLevel(n){for(const i of this.logServices)i.setLevel(n);super.setLevel(n)}trace(n,...i){for(const r of this.logServices)r.trace(n,...i)}debug(n,...i){for(const r of this.logServices)r.debug(n,...i)}info(n,...i){for(const r of this.logServices)r.info(n,...i)}warn(n,...i){for(const r of this.logServices)r.warn(n,...i)}error(n,...i){for(const r of this.logServices)r.error(n,...i)}critical(n,...i){for(const r of this.logServices)r.critical(n,...i)}flush(){for(const n of this.logServices)n.flush()}dispose(){for(const n of this.logServices)n.dispose()}}e.MultiplexLogService=d;class a extends b.Disposable{constructor(n){super();this.logger=n,this._register(n)}get onDidChangeLogLevel(){return this.logger.onDidChangeLogLevel}setLevel(n){this.logger.setLevel(n)}getLevel(){return this.logger.getLevel()}trace(n,...i){this.logger.trace(n,...i)}debug(n,...i){this.logger.debug(n,...i)}info(n,...i){this.logger.info(n,...i)}warn(n,...i){this.logger.warn(n,...i)}error(n,...i){this.logger.error(n,...i)}critical(n,...i){this.logger.critical(n,...i)}flush(){this.logger.flush()}}e.LogService=a;class v extends b.Disposable{constructor(n,i){super();this.logLevel=n,this.loggers=new Map,this.logLevelChangeableLoggers=[],this._register(i(r=>{this.logLevel=r,this.logLevelChangeableLoggers.forEach(t=>t.setLevel(r))}))}getLogger(n){return this.loggers.get(n.toString())}createLogger(n,i){let r=this.loggers.get(n.toString());return r||(r=this.doCreateLogger(n,i?.always?E.Trace:this.logLevel,i),this.loggers.set(n.toString(),r),i?.always||this.logLevelChangeableLoggers.push(r)),r}dispose(){this.logLevelChangeableLoggers.splice(0,this.logLevelChangeableLoggers.length),this.loggers.forEach(n=>n.dispose()),this.loggers.clear(),super.dispose()}}e.AbstractLoggerService=v;class A{constructor(){this.onDidChangeLogLevel=new p.Emitter().event}setLevel(n){}getLevel(){return E.Info}trace(n,...i){}debug(n,...i){}info(n,...i){}warn(n,...i){}error(n,...i){}critical(n,...i){}dispose(){}flush(){}}e.NullLogService=A;function l(u){if(u.verbose)return E.Trace;if(typeof u.logLevel=="string"){const n=_(u.logLevel.toLowerCase());if(n!==void 0)return n}return e.DEFAULT_LOG_LEVEL}e.getLogLevel=l;function _(u){switch(u){case"trace":return E.Trace;case"debug":return E.Debug;case"info":return E.Info;case"warn":return E.Warning;case"error":return E.Error;case"critical":return E.Critical;case"off":return E.Off}}e.parseLogLevel=_;function s(u){switch(u){case E.Trace:return"trace";case E.Debug:return"debug";case E.Info:return"info";case E.Warning:return"warn";case E.Error:return"error";case E.Critical:return"critical";case E.Off:return"off"}}e.LogLevelToString=s}),define(De[80],Ce([1,0,29,126,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IMarkerService=e.IMarkerData=e.MarkerSeverity=e.MarkerTag=void 0;var L;(function(E){E[E.Unnecessary=1]="Unnecessary",E[E.Deprecated=2]="Deprecated"})(L=e.MarkerTag||(e.MarkerTag={}));var D;(function(E){E[E.Hint=1]="Hint",E[E.Info=2]="Info",E[E.Warning=4]="Warning",E[E.Error=8]="Error"})(D=e.MarkerSeverity||(e.MarkerSeverity={})),function(E){function P(f,h){return h-f}E.compare=P;const R=Object.create(null);R[E.Error]=(0,p.localize)(0,null),R[E.Warning]=(0,p.localize)(1,null),R[E.Info]=(0,p.localize)(2,null);function y(f){return R[f]||""}E.toString=y;function m(f){switch(f){case o.default.Error:return E.Error;case o.default.Warning:return E.Warning;case o.default.Info:return E.Info;case o.default.Ignore:return E.Hint}}E.fromSeverity=m;function I(f){switch(f){case E.Error:return o.default.Error;case E.Warning:return o.default.Warning;case E.Info:return o.default.Info;case E.Hint:return o.default.Ignore}}E.toSeverity=I}(D=e.MarkerSeverity||(e.MarkerSeverity={}));var T;(function(E){const P="";function R(m){return y(m,!0)}E.makeKey=R;function y(m,I){const f=[P];return m.source?f.push(m.source.replace("\xA6","\\\xA6")):f.push(P),m.code?typeof m.code=="string"?f.push(m.code.replace("\xA6","\\\xA6")):f.push(m.code.value.replace("\xA6","\\\xA6")):f.push(P),m.severity!==void 0&&m.severity!==null?f.push(D.toString(m.severity)):f.push(P),m.message&&I?f.push(m.message.replace("\xA6","\\\xA6")):f.push(P),m.startLineNumber!==void 0&&m.startLineNumber!==null?f.push(m.startLineNumber.toString()):f.push(P),m.startColumn!==void 0&&m.startColumn!==null?f.push(m.startColumn.toString()):f.push(P),m.endLineNumber!==void 0&&m.endLineNumber!==null?f.push(m.endLineNumber.toString()):f.push(P),m.endColumn!==void 0&&m.endColumn!==null?f.push(m.endColumn.toString()):f.push(P),f.push(P),f.join("\xA6")}E.makeKeyOptionalMessage=y})(T=e.IMarkerData||(e.IMarkerData={})),e.IMarkerService=(0,b.createDecorator)("markerService")}),define(De[148],Ce([1,0,4,29,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NoOpProgress=e.NoOpNotification=e.NotificationsFilter=e.NeverShowAgainScope=e.INotificationService=e.Severity=void 0,e.Severity=p.default,e.INotificationService=(0,b.createDecorator)("notificationService");var L;(function(P){P[P.WORKSPACE=0]="WORKSPACE",P[P.PROFILE=1]="PROFILE",P[P.APPLICATION=2]="APPLICATION"})(L=e.NeverShowAgainScope||(e.NeverShowAgainScope={}));var D;(function(P){P[P.OFF=0]="OFF",P[P.SILENT=1]="SILENT",P[P.ERROR=2]="ERROR"})(D=e.NotificationsFilter||(e.NotificationsFilter={}));class T{constructor(){this.progress=new E,this.onDidClose=o.Event.None,this.onDidChangeVisibility=o.Event.None}updateSeverity(R){}updateMessage(R){}updateActions(R){}close(){}}e.NoOpNotification=T;class E{infinite(){}done(){}total(R){}worked(R){}}e.NoOpProgress=E}),define(De[81],Ce([1,0,7,9,2,3]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.extractSelection=e.withSelection=e.matchesSomeScheme=e.matchesScheme=e.NullOpenerService=e.IOpenerService=void 0,e.IOpenerService=(0,L.createDecorator)("openerService"),e.NullOpenerService=Object.freeze({_serviceBrand:void 0,registerOpener(){return o.Disposable.None},registerValidator(){return o.Disposable.None},registerExternalUriResolver(){return o.Disposable.None},setDefaultExternalOpener(){},registerExternalOpener(){return o.Disposable.None},async open(){return!1},async resolveExternalUri(R){return{resolved:R,dispose(){}}}});function D(R,y){return b.URI.isUri(R)?(0,p.equalsIgnoreCase)(R.scheme,y):(0,p.startsWithIgnoreCase)(R,y+":")}e.matchesScheme=D;function T(R,...y){return y.some(m=>D(R,m))}e.matchesSomeScheme=T;function E(R,y){return R.with({fragment:`${y.startLineNumber},${y.startColumn}${y.endLineNumber?`-${y.endLineNumber}${y.endColumn?`,${y.endColumn}`:""}`:""}`})}e.withSelection=E;function P(R){let y;const m=/^L?(\d+)(?:,(\d+))?(-L?(\d+)(?:,(\d+))?)?/.exec(R.fragment);return m&&(y={startLineNumber:parseInt(m[1]),startColumn:m[2]?parseInt(m[2]):1,endLineNumber:m[4]?parseInt(m[4]):void 0,endColumn:m[4]?m[5]?parseInt(m[5]):1:void 0},R=R.with({fragment:""})),{selection:y,uri:R}}e.extractSelection=P}),define(De[149],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.productSchemaId=e.IProductService=void 0,e.IProductService=(0,o.createDecorator)("productService"),e.productSchemaId="vscode://schemas/vscode-product"});var ze=this&&this.__decorate||function(te,e,o,p){var b=arguments.length,L=b<3?e:p===null?p=Object.getOwnPropertyDescriptor(e,o):p,D;if(typeof Reflect=="object"&&typeof Reflect.decorate=="function")L=Reflect.decorate(te,e,o,p);else for(var T=te.length-1;T>=0;T--)(D=te[T])&&(L=(b<3?D(L):b>3?D(e,o,L):D(e,o))||L);return b>3&&L&&Object.defineProperty(e,o,L),L},xe=this&&this.__param||function(te,e){return function(o,p){e(o,p,te)}};define(De[150],Ce([1,0,13,20,7,3]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IEditorProgressService=e.LongRunningOperation=e.UnmanagedProgress=e.Progress=e.emptyProgressRunner=e.ProgressLocation=e.IProgressService=void 0,e.IProgressService=(0,L.createDecorator)("progressService");var D;(function(R){R[R.Explorer=1]="Explorer",R[R.Scm=3]="Scm",R[R.Extensions=5]="Extensions",R[R.Window=10]="Window",R[R.Notification=15]="Notification",R[R.Dialog=20]="Dialog"})(D=e.ProgressLocation||(e.ProgressLocation={})),e.emptyProgressRunner=Object.freeze({total(){},worked(){},done(){}});class T{constructor(y){this.callback=y}get value(){return this._value}report(y){this._value=y,this.callback(this._value)}}e.Progress=T,T.None=Object.freeze({report(){}});let E=class extends b.Disposable{constructor(y,m){super();this.deferred=new o.DeferredPromise,m.withProgress(y,I=>(this.reporter=I,this.lastStep&&I.report(this.lastStep),this.deferred.p)),this._register((0,b.toDisposable)(()=>this.deferred.complete()))}report(y){this.reporter?this.reporter.report(y):this.lastStep=y}};E=ze([xe(1,e.IProgressService)],E),e.UnmanagedProgress=E;class P extends b.Disposable{constructor(y){super();this.progressIndicator=y,this.currentOperationId=0,this.currentOperationDisposables=this._register(new b.DisposableStore)}start(y){this.stop();const m=++this.currentOperationId,I=new p.CancellationTokenSource;return this.currentProgressTimeout=setTimeout(()=>{m===this.currentOperationId&&(this.currentProgressRunner=this.progressIndicator.show(!0))},y),this.currentOperationDisposables.add((0,b.toDisposable)(()=>clearTimeout(this.currentProgressTimeout))),this.currentOperationDisposables.add((0,b.toDisposable)(()=>I.cancel())),this.currentOperationDisposables.add((0,b.toDisposable)(()=>this.currentProgressRunner?this.currentProgressRunner.done():void 0)),{id:m,token:I.token,stop:()=>this.doStop(m),isCurrent:()=>this.currentOperationId===m}}stop(){this.doStop(this.currentOperationId)}doStop(y){this.currentOperationId===y&&this.currentOperationDisposables.clear()}}e.LongRunningOperation=P,e.IEditorProgressService=(0,L.createDecorator)("editorProgressService")}),define(De[30],Ce([1,0,44,10]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Registry=void 0;class b{constructor(){this.data=new Map}add(D,T){o.ok(p.isString(D)),o.ok(p.isObject(T)),o.ok(!this.data.has(D),"There is already an extension with this id"),this.data.set(D,T)}knows(D){return this.data.has(D)}as(D){return this.data.get(D)||null}}e.Registry=new b}),define(De[82],Ce([1,0,4,30]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Extensions=void 0,e.Extensions={JSONContribution:"base.contributions.json"};function b(T){return T.length>0&&T.charAt(T.length-1)==="#"?T.substring(0,T.length-1):T}class L{constructor(){this._onDidChangeSchema=new o.Emitter,this.onDidChangeSchema=this._onDidChangeSchema.event,this.schemasById={}}registerSchema(E,P){this.schemasById[b(E)]=P,this._onDidChangeSchema.fire(E)}notifySchemaChanged(E){this._onDidChangeSchema.fire(E)}getSchemaContributions(){return{schemas:this.schemasById}}}const D=new L;p.Registry.add(e.Extensions.JSONContribution,D)}),define(De[83],Ce([1,0,16,4,10,122,57,82,30]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getScopes=e.validateProperty=e.getDefaultValue=e.keyFromOverrideIdentifiers=e.overrideIdentifiersFromKey=e.OVERRIDE_PROPERTY_REGEX=e.OVERRIDE_PROPERTY_PATTERN=e.configurationDefaultsSchemaId=e.resourceLanguageSettingsSchemaId=e.resourceSettings=e.windowSettings=e.machineOverridableSettings=e.machineSettings=e.applicationSettings=e.allSettings=e.ConfigurationScope=e.Extensions=e.EditPresentationTypes=void 0;var P;(function(_){_.Multiline="multilineText",_.Singleline="singlelineText"})(P=e.EditPresentationTypes||(e.EditPresentationTypes={})),e.Extensions={Configuration:"base.contributions.configuration"};var R;(function(_){_[_.APPLICATION=1]="APPLICATION",_[_.MACHINE=2]="MACHINE",_[_.WINDOW=3]="WINDOW",_[_.RESOURCE=4]="RESOURCE",_[_.LANGUAGE_OVERRIDABLE=5]="LANGUAGE_OVERRIDABLE",_[_.MACHINE_OVERRIDABLE=6]="MACHINE_OVERRIDABLE"})(R=e.ConfigurationScope||(e.ConfigurationScope={})),e.allSettings={properties:{},patternProperties:{}},e.applicationSettings={properties:{},patternProperties:{}},e.machineSettings={properties:{},patternProperties:{}},e.machineOverridableSettings={properties:{},patternProperties:{}},e.windowSettings={properties:{},patternProperties:{}},e.resourceSettings={properties:{},patternProperties:{}},e.resourceLanguageSettingsSchemaId="vscode://schemas/settings/resourceLanguage",e.configurationDefaultsSchemaId="vscode://schemas/settings/configurationDefaults";const y=E.Registry.as(T.Extensions.JSONContribution);class m{constructor(){this.overrideIdentifiers=new Set,this._onDidSchemaChange=new p.Emitter,this.onDidSchemaChange=this._onDidSchemaChange.event,this._onDidUpdateConfiguration=new p.Emitter,this.onDidUpdateConfiguration=this._onDidUpdateConfiguration.event,this.configurationDefaultsOverrides=new Map,this.defaultLanguageConfigurationOverridesNode={id:"defaultOverrides",title:L.localize(0,null),properties:{}},this.configurationContributors=[this.defaultLanguageConfigurationOverridesNode],this.resourceLanguageSettingsSchema={properties:{},patternProperties:{},additionalProperties:!1,errorMessage:"Unknown editor configuration setting",allowTrailingCommas:!0,allowComments:!0},this.configurationProperties={},this.policyConfigurations=new Map,this.excludedConfigurationProperties={},y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this.registerOverridePropertyPatternKey()}registerConfiguration(s,u=!0){this.registerConfigurations([s],u)}registerConfigurations(s,u=!0){const n=this.doRegisterConfigurations(s,u);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:n})}deregisterConfigurations(s){const u=this.doDeregisterConfigurations(s);y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u})}updateConfigurations({add:s,remove:u}){const n=[];n.push(...this.doDeregisterConfigurations(u)),n.push(...this.doRegisterConfigurations(s,!1)),y.registerSchema(e.resourceLanguageSettingsSchemaId,this.resourceLanguageSettingsSchema),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:(0,o.distinct)(n)})}registerDefaultConfigurations(s){const u=[],n=[];for(const{overrides:i,source:r}of s)for(const t in i)if(u.push(t),e.OVERRIDE_PROPERTY_REGEX.test(t)){const c=this.configurationDefaultsOverrides.get(t),w=c?.valuesSources??new Map;if(r)for(const W of Object.keys(i[t]))w.set(W,r);const g={...c?.value||{},...i[t]};this.configurationDefaultsOverrides.set(t,{source:r,value:g,valuesSources:w});const C=(0,D.getLanguageTagSettingPlainKey)(t),U={type:"object",default:g,description:L.localize(1,null,C),$ref:e.resourceLanguageSettingsSchemaId,defaultDefaultValue:g,source:b.isString(r)?void 0:r,defaultValueSource:r};n.push(...h(t)),this.configurationProperties[t]=U,this.defaultLanguageConfigurationOverridesNode.properties[t]=U}else{this.configurationDefaultsOverrides.set(t,{value:i[t],source:r});const c=this.configurationProperties[t];c&&(this.updatePropertyDefaultValue(t,c),this.updateSchema(t,c))}this.registerOverrideIdentifiers(n),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}deregisterDefaultConfigurations(s){const u=[];for(const{overrides:n,source:i}of s)for(const r in n){const t=this.configurationDefaultsOverrides.get(r),c=b.isString(i)?i:i?.id,w=b.isString(t?.source)?t?.source:t?.source?.id;if(c===w)if(u.push(r),this.configurationDefaultsOverrides.delete(r),e.OVERRIDE_PROPERTY_REGEX.test(r))delete this.configurationProperties[r],delete this.defaultLanguageConfigurationOverridesNode.properties[r];else{const g=this.configurationProperties[r];g&&(this.updatePropertyDefaultValue(r,g),this.updateSchema(r,g))}}this.updateOverridePropertyPatternKey(),this._onDidSchemaChange.fire(),this._onDidUpdateConfiguration.fire({properties:u,defaultsOverrides:!0})}notifyConfigurationSchemaUpdated(...s){this._onDidSchemaChange.fire()}registerOverrideIdentifiers(s){for(const u of s)this.overrideIdentifiers.add(u);this.updateOverridePropertyPatternKey()}doRegisterConfigurations(s,u){const n=[];return s.forEach(i=>{n.push(...this.validateAndRegisterProperties(i,u,i.extensionInfo,i.restrictedProperties)),this.configurationContributors.push(i),this.registerJSONConfiguration(i)}),n}doDeregisterConfigurations(s){const u=[],n=i=>{if(i.properties)for(const r in i.properties){u.push(r);const t=this.configurationProperties[r];t?.policy?.name&&this.policyConfigurations.delete(t.policy.name),delete this.configurationProperties[r],this.removeFromSchema(r,i.properties[r])}i.allOf?.forEach(r=>n(r))};for(const i of s){n(i);const r=this.configurationContributors.indexOf(i);r!==-1&&this.configurationContributors.splice(r,1)}return u}validateAndRegisterProperties(s,u=!0,n,i,r=3){r=b.isUndefinedOrNull(s.scope)?r:s.scope;const t=[],c=s.properties;if(c)for(const g in c){const C=c[g];if(u&&A(g,C)){delete c[g];continue}if(C.source=n,C.defaultDefaultValue=c[g].default,this.updatePropertyDefaultValue(g,C),e.OVERRIDE_PROPERTY_REGEX.test(g)?C.scope=void 0:(C.scope=b.isUndefinedOrNull(C.scope)?r:C.scope,C.restricted=b.isUndefinedOrNull(C.restricted)?!!i?.includes(g):C.restricted),c[g].hasOwnProperty("included")&&!c[g].included){this.excludedConfigurationProperties[g]=c[g],delete c[g];continue}else this.configurationProperties[g]=c[g],c[g].policy?.name&&this.policyConfigurations.set(c[g].policy.name,g);!c[g].deprecationMessage&&c[g].markdownDeprecationMessage&&(c[g].deprecationMessage=c[g].markdownDeprecationMessage),t.push(g)}const w=s.allOf;if(w)for(const g of w)t.push(...this.validateAndRegisterProperties(g,u,n,i,r));return t}getConfigurations(){return this.configurationContributors}getConfigurationProperties(){return this.configurationProperties}getPolicyConfigurations(){return this.policyConfigurations}getExcludedConfigurationProperties(){return this.excludedConfigurationProperties}getConfigurationDefaultsOverrides(){return this.configurationDefaultsOverrides}registerJSONConfiguration(s){const u=n=>{const i=n.properties;if(i)for(const t in i)this.updateSchema(t,i[t]);n.allOf?.forEach(u)};u(s)}updateSchema(s,u){switch(e.allSettings.properties[s]=u,u.scope){case 1:e.applicationSettings.properties[s]=u;break;case 2:e.machineSettings.properties[s]=u;break;case 6:e.machineOverridableSettings.properties[s]=u;break;case 3:e.windowSettings.properties[s]=u;break;case 4:e.resourceSettings.properties[s]=u;break;case 5:e.resourceSettings.properties[s]=u,this.resourceLanguageSettingsSchema.properties[s]=u;break}}removeFromSchema(s,u){switch(delete e.allSettings.properties[s],u.scope){case 1:delete e.applicationSettings.properties[s];break;case 2:delete e.machineSettings.properties[s];break;case 6:delete e.machineOverridableSettings.properties[s];break;case 3:delete e.windowSettings.properties[s];break;case 4:case 5:delete e.resourceSettings.properties[s],delete this.resourceLanguageSettingsSchema.properties[s];break}}updateOverridePropertyPatternKey(){for(const s of this.overrideIdentifiers.values()){const u=`[${s}]`,n={type:"object",description:L.localize(2,null),errorMessage:L.localize(3,null),$ref:e.resourceLanguageSettingsSchemaId};this.updatePropertyDefaultValue(u,n),e.allSettings.properties[u]=n,e.applicationSettings.properties[u]=n,e.machineSettings.properties[u]=n,e.machineOverridableSettings.properties[u]=n,e.windowSettings.properties[u]=n,e.resourceSettings.properties[u]=n}this._onDidSchemaChange.fire()}registerOverridePropertyPatternKey(){const s={type:"object",description:L.localize(4,null),errorMessage:L.localize(5,null),$ref:e.resourceLanguageSettingsSchemaId};e.allSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.applicationSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.machineOverridableSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.windowSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,e.resourceSettings.patternProperties[e.OVERRIDE_PROPERTY_PATTERN]=s,this._onDidSchemaChange.fire()}updatePropertyDefaultValue(s,u){const n=this.configurationDefaultsOverrides.get(s);let i=n?.value,r=n?.source;b.isUndefined(i)&&(i=u.defaultDefaultValue,r=void 0),b.isUndefined(i)&&(i=a(u.type)),u.default=i,u.defaultValueSource=r}}const I="\\[([^\\]]+)\\]",f=new RegExp(I,"g");e.OVERRIDE_PROPERTY_PATTERN=`^(${I})+$`,e.OVERRIDE_PROPERTY_REGEX=new RegExp(e.OVERRIDE_PROPERTY_PATTERN);function h(_){const s=[];if(e.OVERRIDE_PROPERTY_REGEX.test(_)){let u=f.exec(_);for(;u?.length;){const n=u[1].trim();n&&s.push(n),u=f.exec(_)}}return(0,o.distinct)(s)}e.overrideIdentifiersFromKey=h;function d(_){return _.reduce((s,u)=>`${s}[${u}]`,"")}e.keyFromOverrideIdentifiers=d;function a(_){switch(Array.isArray(_)?_[0]:_){case"boolean":return!1;case"integer":case"number":return 0;case"string":return"";case"array":return[];case"object":return{};default:return null}}e.getDefaultValue=a;const v=new m;E.Registry.add(e.Extensions.Configuration,v);function A(_,s){return _.trim()?e.OVERRIDE_PROPERTY_REGEX.test(_)?L.localize(7,null,_):v.getConfigurationProperties()[_]!==void 0?L.localize(8,null,_):s.policy?.name&&v.getPolicyConfigurations().get(s.policy?.name)!==void 0?L.localize(9,null,_,s.policy?.name,v.getPolicyConfigurations().get(s.policy?.name)):null:L.localize(6,null)}e.validateProperty=A;function l(){const _=[],s=v.getConfigurationProperties();for(const u of Object.keys(s))_.push([u,s[u].scope]);return _.push(["launch",4]),_.push(["task",4]),_}e.getScopes=l}),define(De[151],Ce([1,0,16,4,104,7,25,26,10,2,57,83,30]),function(te,e,o,p,b,L,D,T,E,P,R,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AllKeysConfigurationChangeEvent=e.ConfigurationChangeEvent=e.mergeChanges=e.Configuration=e.UserSettings=e.ConfigurationModelParser=e.ConfigurationModel=void 0;class I{constructor(u={},n=[],i=[]){this._contents=u,this._keys=n,this._overrides=i,this.frozen=!1,this.overrideConfigurations=new Map}get contents(){return this.checkAndFreeze(this._contents)}get overrides(){return this.checkAndFreeze(this._overrides)}get keys(){return this.checkAndFreeze(this._keys)}isEmpty(){return this._keys.length===0&&Object.keys(this._contents).length===0&&this._overrides.length===0}isFrozen(){return this.frozen}getValue(u){return u?(0,R.getConfigurationValue)(this.contents,u):this.contents}getOverrideValue(u,n){const i=this.getContentsForOverrideIdentifer(n);return i?u?(0,R.getConfigurationValue)(i,u):i:void 0}getKeysForOverrideIdentifier(u){const n=[];for(const i of this.overrides)i.identifiers.includes(u)&&n.push(...i.keys);return o.distinct(n)}getAllOverrideIdentifiers(){const u=[];for(const n of this.overrides)u.push(...n.identifiers);return o.distinct(u)}override(u){let n=this.overrideConfigurations.get(u);return n||(n=this.createOverrideConfigurationModel(u),this.overrideConfigurations.set(u,n)),n}merge(...u){const n=T.deepClone(this.contents),i=T.deepClone(this.overrides),r=[...this.keys];for(const t of u)if(!t.isEmpty()){this.mergeContents(n,t.contents);for(const c of t.overrides){const[w]=i.filter(g=>o.equals(g.identifiers,c.identifiers));w?(this.mergeContents(w.contents,c.contents),w.keys.push(...c.keys),w.keys=o.distinct(w.keys)):i.push(T.deepClone(c))}for(const c of t.keys)r.indexOf(c)===-1&&r.push(c)}return new I(n,r,i)}freeze(){return this.frozen=!0,this}clone(){return new I(T.deepClone(this.contents),[...this.keys],T.deepClone(this.overrides))}createOverrideConfigurationModel(u){const n=this.getContentsForOverrideIdentifer(u);if(!n||typeof n!="object"||!Object.keys(n).length)return this;const i={};for(const r of o.distinct([...Object.keys(this.contents),...Object.keys(n)])){let t=this.contents[r];const c=n[r];c&&(typeof t=="object"&&typeof c=="object"?(t=T.deepClone(t),this.mergeContents(t,c)):t=c),i[r]=t}return new I(i,this.keys,this.overrides)}mergeContents(u,n){for(const i of Object.keys(n)){if(i in u&&E.isObject(u[i])&&E.isObject(n[i])){this.mergeContents(u[i],n[i]);continue}u[i]=T.deepClone(n[i])}}checkAndFreeze(u){return this.frozen&&!Object.isFrozen(u)?T.deepFreeze(u):u}getContentsForOverrideIdentifer(u){let n=null,i=null;const r=t=>{t&&(i?this.mergeContents(i,t):i=T.deepClone(t))};for(const t of this.overrides)o.equals(t.identifiers,[u])?n=t.contents:t.identifiers.includes(u)&&r(t.contents);return r(n),i}toJSON(){return{contents:this.contents,overrides:this.overrides,keys:this.keys}}setValue(u,n){this.addKey(u),(0,R.addToValueTree)(this.contents,u,n,i=>{throw new Error(i)})}removeValue(u){this.removeKey(u)&&(0,R.removeFromValueTree)(this.contents,u)}addKey(u){let n=this.keys.length;for(let i=0;i<n;i++)u.indexOf(this.keys[i])===0&&(n=i);this.keys.splice(n,1,u)}removeKey(u){const n=this.keys.indexOf(u);return n!==-1?(this.keys.splice(n,1),!0):!1}}e.ConfigurationModel=I;class f{constructor(u){this._name=u,this._raw=null,this._configurationModel=null,this._restrictedConfigurations=[],this._parseErrors=[]}get configurationModel(){return this._configurationModel||new I}get restrictedConfigurations(){return this._restrictedConfigurations}get errors(){return this._parseErrors}parse(u,n){if(!E.isUndefinedOrNull(u)){const i=this.doParseContent(u);this.parseRaw(i,n)}}reparse(u){this._raw&&this.parseRaw(this._raw,u)}parseRaw(u,n){this._raw=u;const{contents:i,keys:r,overrides:t,restricted:c}=this.doParseRaw(u,n);this._configurationModel=new I(i,r,t),this._restrictedConfigurations=c||[]}doParseContent(u){let n={},i=null,r=[];const t=[],c=[];function w(C){Array.isArray(r)?r.push(C):i!==null&&(r[i]=C)}const g={onObjectBegin:()=>{const C={};w(C),t.push(r),r=C,i=null},onObjectProperty:C=>{i=C},onObjectEnd:()=>{r=t.pop()},onArrayBegin:()=>{const C=[];w(C),t.push(r),r=C,i=null},onArrayEnd:()=>{r=t.pop()},onLiteralValue:w,onError:(C,U,W)=>{c.push({error:C,offset:U,length:W})}};if(u)try{b.visit(u,g),n=r[0]||{}}catch(C){console.error(`Error while parsing settings file ${this._name}: ${C}`),this._parseErrors=[C]}return n}doParseRaw(u,n){const i=m.Registry.as(y.Extensions.Configuration).getConfigurationProperties(),r=this.filter(u,i,!0,n);u=r.raw;const t=(0,R.toValuesTree)(u,g=>console.error(`Conflict in settings file ${this._name}: ${g}`)),c=Object.keys(u),w=this.toOverrides(u,g=>console.error(`Conflict in settings file ${this._name}: ${g}`));return{contents:t,keys:c,overrides:w,restricted:r.restricted}}filter(u,n,i,r){if(!r?.scopes&&!r?.skipRestricted)return{raw:u,restricted:[]};const t={},c=[];for(const w in u)if(y.OVERRIDE_PROPERTY_REGEX.test(w)&&i){const g=this.filter(u[w],n,!1,r);t[w]=g.raw,c.push(...g.restricted)}else{const g=n[w],C=g?typeof g.scope!="undefined"?g.scope:3:void 0;g?.restricted&&c.push(w),(C===void 0||r.scopes===void 0||r.scopes.includes(C))&&(r.skipRestricted&&g?.restricted||(t[w]=u[w]))}return{raw:t,restricted:c}}toOverrides(u,n){const i=[];for(const r of Object.keys(u))if(y.OVERRIDE_PROPERTY_REGEX.test(r)){const t={};for(const c in u[r])t[c]=u[r][c];i.push({identifiers:(0,y.overrideIdentifiersFromKey)(r),keys:Object.keys(t),contents:(0,R.toValuesTree)(t,n)})}return i}}e.ConfigurationModelParser=f;class h extends L.Disposable{constructor(u,n,i,r){super();this.userSettingsResource=u,this.scopes=n,this.fileService=r,this._onDidChange=this._register(new p.Emitter),this.onDidChange=this._onDidChange.event,this.parser=new f(this.userSettingsResource.toString()),this.parseOptions={scopes:this.scopes},this._register(this.fileService.watch(i.dirname(this.userSettingsResource))),this._register(this.fileService.watch(this.userSettingsResource)),this._register(p.Event.any(p.Event.filter(this.fileService.onDidFilesChange,t=>t.contains(this.userSettingsResource)),p.Event.filter(this.fileService.onDidRunOperation,t=>(t.isOperation(0)||t.isOperation(3)||t.isOperation(1)||t.isOperation(4))&&i.isEqual(t.resource,u)))(()=>this._onDidChange.fire()))}async loadConfiguration(){try{const u=await this.fileService.readFile(this.userSettingsResource);return this.parser.parse(u.value.toString()||"{}",this.parseOptions),this.parser.configurationModel}catch{return new I}}reparse(){return this.parser.reparse(this.parseOptions),this.parser.configurationModel}getRestrictedSettings(){return this.parser.restrictedConfigurations}}e.UserSettings=h;class d{constructor(u,n,i,r,t=new I,c=new I,w=new D.ResourceMap,g=new I,C=new D.ResourceMap,U=!0){this._defaultConfiguration=u,this._policyConfiguration=n,this._applicationConfiguration=i,this._localUserConfiguration=r,this._remoteUserConfiguration=t,this._workspaceConfiguration=c,this._folderConfigurations=w,this._memoryConfiguration=g,this._memoryConfigurationByResource=C,this._freeze=U,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations=new D.ResourceMap,this._userConfiguration=null}getValue(u,n,i){return this.getConsolidatedConfigurationModel(u,n,i).getValue(u)}updateValue(u,n,i={}){let r;i.resource?(r=this._memoryConfigurationByResource.get(i.resource),r||(r=new I,this._memoryConfigurationByResource.set(i.resource,r))):r=this._memoryConfiguration,n===void 0?r.removeValue(u):r.setValue(u,n),i.resource||(this._workspaceConsolidatedConfiguration=null)}inspect(u,n,i){const r=this.getConsolidatedConfigurationModel(u,n,i),t=this.getFolderConfigurationModelForResource(n.resource,i),c=n.resource?this._memoryConfigurationByResource.get(n.resource)||this._memoryConfiguration:this._memoryConfiguration,w=n.overrideIdentifier?this._defaultConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this._defaultConfiguration.freeze().getValue(u),g=this._policyConfiguration.isEmpty()?void 0:this._policyConfiguration.freeze().getValue(u),C=this.applicationConfiguration.isEmpty()?void 0:this.applicationConfiguration.freeze().getValue(u),U=n.overrideIdentifier?this.userConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.userConfiguration.freeze().getValue(u),W=n.overrideIdentifier?this.localUserConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.localUserConfiguration.freeze().getValue(u),M=n.overrideIdentifier?this.remoteUserConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this.remoteUserConfiguration.freeze().getValue(u),S=i?n.overrideIdentifier?this._workspaceConfiguration.freeze().override(n.overrideIdentifier).getValue(u):this._workspaceConfiguration.freeze().getValue(u):void 0,z=t?n.overrideIdentifier?t.freeze().override(n.overrideIdentifier).getValue(u):t.freeze().getValue(u):void 0,$=n.overrideIdentifier?c.override(n.overrideIdentifier).getValue(u):c.getValue(u),N=r.getValue(u),K=o.distinct(r.overrides.map(V=>V.identifiers).flat()).filter(V=>r.getOverrideValue(u,V)!==void 0);return{defaultValue:w,policyValue:g,applicationValue:C,userValue:U,userLocalValue:W,userRemoteValue:M,workspaceValue:S,workspaceFolderValue:z,memoryValue:$,value:N,default:w!==void 0?{value:this._defaultConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this._defaultConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,policy:g!==void 0?{value:g}:void 0,application:C!==void 0?{value:C,override:n.overrideIdentifier?this.applicationConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,user:U!==void 0?{value:this.userConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.userConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,userLocal:W!==void 0?{value:this.localUserConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.localUserConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,userRemote:M!==void 0?{value:this.remoteUserConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this.remoteUserConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,workspace:S!==void 0?{value:this._workspaceConfiguration.freeze().getValue(u),override:n.overrideIdentifier?this._workspaceConfiguration.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,workspaceFolder:z!==void 0?{value:t?.freeze().getValue(u),override:n.overrideIdentifier?t?.freeze().getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,memory:$!==void 0?{value:c.getValue(u),override:n.overrideIdentifier?c.getOverrideValue(u,n.overrideIdentifier):void 0}:void 0,overrideIdentifiers:K.length?K:void 0}}keys(u){const n=this.getFolderConfigurationModelForResource(void 0,u);return{default:this._defaultConfiguration.freeze().keys,user:this.userConfiguration.freeze().keys,workspace:this._workspaceConfiguration.freeze().keys,workspaceFolder:n?n.freeze().keys:[]}}updateDefaultConfiguration(u){this._defaultConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updatePolicyConfiguration(u){this._policyConfiguration=u}updateApplicationConfiguration(u){this._applicationConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateLocalUserConfiguration(u){this._localUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateRemoteUserConfiguration(u){this._remoteUserConfiguration=u,this._userConfiguration=null,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateWorkspaceConfiguration(u){this._workspaceConfiguration=u,this._workspaceConsolidatedConfiguration=null,this._foldersConsolidatedConfigurations.clear()}updateFolderConfiguration(u,n){this._folderConfigurations.set(u,n),this._foldersConsolidatedConfigurations.delete(u)}deleteFolderConfiguration(u){this.folderConfigurations.delete(u),this._foldersConsolidatedConfigurations.delete(u)}compareAndUpdateDefaultConfiguration(u,n){const i=[];if(!n){const{added:r,updated:t,removed:c}=l(this._defaultConfiguration,u);n=[...r,...t,...c]}for(const r of n)for(const t of(0,y.overrideIdentifiersFromKey)(r)){const c=this._defaultConfiguration.getKeysForOverrideIdentifier(t),w=u.getKeysForOverrideIdentifier(t),g=[...w.filter(C=>c.indexOf(C)===-1),...c.filter(C=>w.indexOf(C)===-1),...c.filter(C=>!T.equals(this._defaultConfiguration.override(t).getValue(C),u.override(t).getValue(C)))];i.push([t,g])}return this.updateDefaultConfiguration(u),{keys:n,overrides:i}}compareAndUpdatePolicyConfiguration(u){const{added:n,updated:i,removed:r}=l(this._policyConfiguration,u),t=[...n,...i,...r];return t.length&&this.updatePolicyConfiguration(u),{keys:t,overrides:[]}}compareAndUpdateApplicationConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.applicationConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateApplicationConfiguration(u),{keys:c,overrides:t}}compareAndUpdateLocalUserConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.localUserConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateLocalUserConfiguration(u),{keys:c,overrides:t}}compareAndUpdateRemoteUserConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.remoteUserConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateRemoteUserConfiguration(u),{keys:c,overrides:t}}compareAndUpdateWorkspaceConfiguration(u){const{added:n,updated:i,removed:r,overrides:t}=l(this.workspaceConfiguration,u),c=[...n,...i,...r];return c.length&&this.updateWorkspaceConfiguration(u),{keys:c,overrides:t}}compareAndUpdateFolderConfiguration(u,n){const i=this.folderConfigurations.get(u),{added:r,updated:t,removed:c,overrides:w}=l(i,n),g=[...r,...t,...c];return(g.length||!i)&&this.updateFolderConfiguration(u,n),{keys:g,overrides:w}}compareAndDeleteFolderConfiguration(u){const n=this.folderConfigurations.get(u);if(!n)throw new Error("Unknown folder");this.deleteFolderConfiguration(u);const{added:i,updated:r,removed:t,overrides:c}=l(n,void 0);return{keys:[...i,...r,...t],overrides:c}}get defaults(){return this._defaultConfiguration}get applicationConfiguration(){return this._applicationConfiguration}get userConfiguration(){return this._userConfiguration||(this._userConfiguration=this._remoteUserConfiguration.isEmpty()?this._localUserConfiguration:this._localUserConfiguration.merge(this._remoteUserConfiguration),this._freeze&&this._userConfiguration.freeze()),this._userConfiguration}get localUserConfiguration(){return this._localUserConfiguration}get remoteUserConfiguration(){return this._remoteUserConfiguration}get workspaceConfiguration(){return this._workspaceConfiguration}get folderConfigurations(){return this._folderConfigurations}getConsolidatedConfigurationModel(u,n,i){let r=this.getConsolidatedConfigurationModelForResource(n,i);return n.overrideIdentifier&&(r=r.override(n.overrideIdentifier)),!this._policyConfiguration.isEmpty()&&this._policyConfiguration.getValue(u)!==void 0&&(r=r.merge(this._policyConfiguration)),r}getConsolidatedConfigurationModelForResource({resource:u},n){let i=this.getWorkspaceConsolidatedConfiguration();if(n&&u){const r=n.getFolder(u);r&&(i=this.getFolderConsolidatedConfiguration(r.uri)||i);const t=this._memoryConfigurationByResource.get(u);t&&(i=i.merge(t))}return i}getWorkspaceConsolidatedConfiguration(){return this._workspaceConsolidatedConfiguration||(this._workspaceConsolidatedConfiguration=this._defaultConfiguration.merge(this.applicationConfiguration,this.userConfiguration,this._workspaceConfiguration,this._memoryConfiguration),this._freeze&&(this._workspaceConfiguration=this._workspaceConfiguration.freeze())),this._workspaceConsolidatedConfiguration}getFolderConsolidatedConfiguration(u){let n=this._foldersConsolidatedConfigurations.get(u);if(!n){const i=this.getWorkspaceConsolidatedConfiguration(),r=this._folderConfigurations.get(u);r?(n=i.merge(r),this._freeze&&(n=n.freeze()),this._foldersConsolidatedConfigurations.set(u,n)):n=i}return n}getFolderConfigurationModelForResource(u,n){if(n&&u){const i=n.getFolder(u);if(i)return this._folderConfigurations.get(i.uri)}}toData(){return{defaults:{contents:this._defaultConfiguration.contents,overrides:this._defaultConfiguration.overrides,keys:this._defaultConfiguration.keys},policy:{contents:this._policyConfiguration.contents,overrides:this._policyConfiguration.overrides,keys:this._policyConfiguration.keys},application:{contents:this.applicationConfiguration.contents,overrides:this.applicationConfiguration.overrides,keys:this.applicationConfiguration.keys},user:{contents:this.userConfiguration.contents,overrides:this.userConfiguration.overrides,keys:this.userConfiguration.keys},workspace:{contents:this._workspaceConfiguration.contents,overrides:this._workspaceConfiguration.overrides,keys:this._workspaceConfiguration.keys},folders:[...this._folderConfigurations.keys()].reduce((u,n)=>{const{contents:i,overrides:r,keys:t}=this._folderConfigurations.get(n);return u.push([n,{contents:i,overrides:r,keys:t}]),u},[])}}allKeys(){const u=new Set;return this._defaultConfiguration.freeze().keys.forEach(n=>u.add(n)),this.userConfiguration.freeze().keys.forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().keys.forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().keys.forEach(i=>u.add(i))),[...u.values()]}allOverrideIdentifiers(){const u=new Set;return this._defaultConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this.userConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._workspaceConfiguration.freeze().getAllOverrideIdentifiers().forEach(n=>u.add(n)),this._folderConfigurations.forEach(n=>n.freeze().getAllOverrideIdentifiers().forEach(i=>u.add(i))),[...u.values()]}getAllKeysForOverrideIdentifier(u){const n=new Set;return this._defaultConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this.userConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._workspaceConfiguration.getKeysForOverrideIdentifier(u).forEach(i=>n.add(i)),this._folderConfigurations.forEach(i=>i.getKeysForOverrideIdentifier(u).forEach(r=>n.add(r))),[...n.values()]}static parse(u){const n=this.parseConfigurationModel(u.defaults),i=this.parseConfigurationModel(u.policy),r=this.parseConfigurationModel(u.application),t=this.parseConfigurationModel(u.user),c=this.parseConfigurationModel(u.workspace),w=u.folders.reduce((g,C)=>(g.set(P.URI.revive(C[0]),this.parseConfigurationModel(C[1])),g),new D.ResourceMap);return new d(n,i,r,t,new I,c,w,new I,new D.ResourceMap,!1)}static parseConfigurationModel(u){return new I(u.contents,u.keys,u.overrides).freeze()}}e.Configuration=d;function a(...s){if(s.length===0)return{keys:[],overrides:[]};if(s.length===1)return s[0];const u=new Set,n=new Map;for(const r of s)r.keys.forEach(t=>u.add(t)),r.overrides.forEach(([t,c])=>{const w=(0,D.getOrSet)(n,t,new Set);c.forEach(g=>w.add(g))});const i=[];return n.forEach((r,t)=>i.push([t,[...r.values()]])),{keys:[...u.values()],overrides:i}}e.mergeChanges=a;class v{constructor(u,n,i,r){this.change=u,this.previous=n,this.currentConfiguraiton=i,this.currentWorkspace=r,this._previousConfiguration=void 0;const t=new Set;u.keys.forEach(w=>t.add(w)),u.overrides.forEach(([,w])=>w.forEach(g=>t.add(g))),this.affectedKeys=[...t.values()];const c=new I;this.affectedKeys.forEach(w=>c.setValue(w,{})),this.affectedKeysTree=c.contents}get previousConfiguration(){return!this._previousConfiguration&&this.previous&&(this._previousConfiguration=d.parse(this.previous.data)),this._previousConfiguration}affectsConfiguration(u,n){if(this.doesAffectedKeysTreeContains(this.affectedKeysTree,u)){if(n){const i=this.previousConfiguration?this.previousConfiguration.getValue(u,n,this.previous?.workspace):void 0,r=this.currentConfiguraiton.getValue(u,n,this.currentWorkspace);return!T.equals(i,r)}return!0}return!1}doesAffectedKeysTreeContains(u,n){let i=(0,R.toValuesTree)({[n]:!0},()=>{}),r;for(;typeof i=="object"&&(r=Object.keys(i)[0]);){if(u=u[r],!u)return!1;i=i[r]}return!0}}e.ConfigurationChangeEvent=v;class A extends v{constructor(u,n,i,r){super({keys:u.allKeys(),overrides:[]},void 0,u,n);this.source=i,this.sourceConfig=r}}e.AllKeysConfigurationChangeEvent=A;function l(s,u){const{added:n,removed:i,updated:r}=_(u,s),t=[],c=s?.getAllOverrideIdentifiers()||[],w=u?.getAllOverrideIdentifiers()||[];if(u){const g=w.filter(C=>!c.includes(C));for(const C of g)t.push([C,u.getKeysForOverrideIdentifier(C)])}if(s){const g=c.filter(C=>!w.includes(C));for(const C of g)t.push([C,s.getKeysForOverrideIdentifier(C)])}if(u&&s){for(const g of c)if(w.includes(g)){const C=_({contents:s.getOverrideValue(void 0,g)||{},keys:s.getKeysForOverrideIdentifier(g)},{contents:u.getOverrideValue(void 0,g)||{},keys:u.getKeysForOverrideIdentifier(g)});t.push([g,[...C.added,...C.removed,...C.updated]])}}return{added:n,removed:i,updated:r,overrides:t}}function _(s,u){const n=s?u?s.keys.filter(t=>u.keys.indexOf(t)===-1):[...s.keys]:[],i=u?s?u.keys.filter(t=>s.keys.indexOf(t)===-1):[...u.keys]:[],r=[];if(s&&u){for(const t of u.keys)if(s.keys.indexOf(t)!==-1){const c=(0,R.getConfigurationValue)(u.contents,t),w=(0,R.getConfigurationValue)(s.contents,t);T.equals(c,w)||r.push(t)}}return{added:n,removed:i,updated:r}}}),define(De[84],Ce([1,0,11,3]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RemoteAuthorityResolverError=e.RemoteAuthorityResolverErrorCode=e.IRemoteAuthorityResolverService=void 0,e.IRemoteAuthorityResolverService=(0,p.createDecorator)("remoteAuthorityResolverService");var b;(function(D){D.Unknown="Unknown",D.NotAvailable="NotAvailable",D.TemporarilyNotAvailable="TemporarilyNotAvailable",D.NoResolverFound="NoResolverFound"})(b=e.RemoteAuthorityResolverErrorCode||(e.RemoteAuthorityResolverErrorCode={}));class L extends o.ErrorNoTelemetry{constructor(T,E=b.Unknown,P){super(T);this._message=T,this._code=E,this._detail=P,this.isHandled=E===b.NotAvailable&&P===!0,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,L.prototype)}static isTemporarilyNotAvailable(T){return T instanceof L&&T._code===b.TemporarilyNotAvailable}static isNoResolverFound(T){return T instanceof L&&T._code===b.NoResolverFound}static isHandled(T){return T instanceof L&&T.isHandled}}e.RemoteAuthorityResolverError=L}),define(De[85],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.parseAuthorityWithOptionalPort=e.parseAuthorityWithPort=e.getRemoteServerRootPath=e.getRemoteName=e.getRemoteAuthority=void 0;function p(P){return P.scheme===o.Schemas.vscodeRemote?P.authority:void 0}e.getRemoteAuthority=p;function b(P){if(!P)return;const R=P.indexOf("+");return R<0?P:P.substr(0,R)}e.getRemoteName=b;function L(P){return`/${P.quality??"oss"}-${P.commit??"dev"}`}e.getRemoteServerRootPath=L;function D(P){const{host:R,port:y}=E(P);if(typeof y=="undefined")throw new Error("Remote authority doesn't contain a port!");return{host:R,port:y}}e.parseAuthorityWithPort=D;function T(P,R){let{host:y,port:m}=E(P);return typeof m=="undefined"&&(m=R),{host:y,port:m}}e.parseAuthorityWithOptionalPort=T;function E(P){const R=P.match(/^(\[[0-9a-z:]+\]):(\d+)$/);if(R)return{host:R[1],port:parseInt(R[2],10)};const y=P.match(/^(\[[0-9a-z:]+\])$/);if(y)return{host:y[1],port:void 0};const m=P.match(/(.*):(\d+)$/);return m?{host:m[1],port:parseInt(m[2],10)}:{host:P,port:void 0}}}),define(De[27],Ce([1,0,9,3,85]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IBuiltinExtensionsScannerService=e.isResolverExtension=e.isAuthenticationProviderExtension=e.isLanguagePackExtension=e.isApplicationScopedExtension=e.ExtensionIdentifier=e.TargetPlatform=e.ExtensionType=e.EXTENSION_CATEGORIES=e.isIExtensionIdentifier=e.getWorkspaceSupportTypeMessage=e.ALL_EXTENSION_KINDS=e.UNDEFINED_PUBLISHER=e.BUILTIN_MANIFEST_CACHE_FILE=e.USER_MANIFEST_CACHE_FILE=e.MANIFEST_CACHE_FOLDER=void 0,e.MANIFEST_CACHE_FOLDER="CachedExtensions",e.USER_MANIFEST_CACHE_FILE="user",e.BUILTIN_MANIFEST_CACHE_FILE="builtin",e.UNDEFINED_PUBLISHER="undefined_publisher",e.ALL_EXTENSION_KINDS=["ui","workspace","web"];function L(f){if(typeof f=="object"&&f!==null&&f.supported!==!0)return f.description}e.getWorkspaceSupportTypeMessage=L;function D(f){return f&&typeof f=="object"&&typeof f.id=="string"&&(!f.uuid||typeof f.uuid=="string")}e.isIExtensionIdentifier=D,e.EXTENSION_CATEGORIES=["Azure","Data Science","Debuggers","Extension Packs","Education","Formatters","Keymaps","Language Packs","Linters","Machine Learning","Notebooks","Programming Languages","SCM Providers","Snippets","Testing","Themes","Visualization","Other"];var T;(function(f){f[f.System=0]="System",f[f.User=1]="User"})(T=e.ExtensionType||(e.ExtensionType={}));var E;(function(f){f.WIN32_X64="win32-x64",f.WIN32_IA32="win32-ia32",f.WIN32_ARM64="win32-arm64",f.LINUX_X64="linux-x64",f.LINUX_ARM64="linux-arm64",f.LINUX_ARMHF="linux-armhf",f.ALPINE_X64="alpine-x64",f.ALPINE_ARM64="alpine-arm64",f.DARWIN_X64="darwin-x64",f.DARWIN_ARM64="darwin-arm64",f.WEB="web",f.UNIVERSAL="universal",f.UNKNOWN="unknown",f.UNDEFINED="undefined"})(E=e.TargetPlatform||(e.TargetPlatform={}));class P{constructor(h){this.value=h,this._lower=h.toLowerCase()}static equals(h,d){if(typeof h=="undefined"||h===null)return typeof d=="undefined"||d===null;if(typeof d=="undefined"||d===null)return!1;if(typeof h=="string"||typeof d=="string"){const a=typeof h=="string"?h:h.value,v=typeof d=="string"?d:d.value;return o.equalsIgnoreCase(a,v)}return h._lower===d._lower}static toKey(h){return typeof h=="string"?h.toLowerCase():h._lower}}e.ExtensionIdentifier=P;function R(f){return y(f)}e.isApplicationScopedExtension=R;function y(f){return f.contributes&&f.contributes.localizations?f.contributes.localizations.length>0:!1}e.isLanguagePackExtension=y;function m(f){return f.contributes&&f.contributes.authentication?f.contributes.authentication.length>0:!1}e.isAuthenticationProviderExtension=m;function I(f,h){if(h){const d=`onResolveRemoteAuthority:${(0,b.getRemoteName)(h)}`;return f.activationEvents?.indexOf(d)!==-1}return!1}e.isResolverExtension=I,e.IBuiltinExtensionsScannerService=(0,p.createDecorator)("IBuiltinExtensionsScannerService")}),define(De[152],Ce([1,0,9,79,27,23,2,11,59]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.computeTargetPlatform=e.isAlpineLinux=e.getExtensionDependencies=e.BetterMergeId=e.getGalleryExtensionTelemetryData=e.getLocalExtensionTelemetryData=e.groupByExtension=e.getGalleryExtensionId=e.adoptToGalleryExtensionId=e.getExtensionId=e.getIdAndVersion=e.ExtensionKey=e.areSameExtensions=void 0;function P(u,n){return u.uuid&&n.uuid?u.uuid===n.uuid:u.id===n.id?!0:(0,o.compareIgnoreCase)(u.id,n.id)===0}e.areSameExtensions=P;const R=/^([^.]+\..+)-(\d+\.\d+\.\d+)(-(.+))?$/;class y{constructor(n,i,r="undefined"){this.version=i,this.targetPlatform=r,this.id=n.id}static create(n){const i=n.manifest?n.manifest.version:n.version,r=n.manifest?n.targetPlatform:n.properties.targetPlatform;return new y(n.identifier,i,r)}static parse(n){const i=R.exec(n);return i&&i[1]&&i[2]?new y({id:i[1]},i[2],i[4]||void 0):null}toString(){return`${this.id}-${this.version}${this.targetPlatform!=="undefined"?`-${this.targetPlatform}`:""}`}equals(n){return n instanceof y?P(this,n)&&this.version===n.version&&this.targetPlatform===n.targetPlatform:!1}}e.ExtensionKey=y;const m=/^([^.]+\..+)@((prerelease)|(\d+\.\d+\.\d+(-.*)?))$/;function I(u){const n=m.exec(u);return n&&n[1]?[h(n[1]),n[2]]:[h(u),void 0]}e.getIdAndVersion=I;function f(u,n){return`${u}.${n}`}e.getExtensionId=f;function h(u){return u.toLocaleLowerCase()}e.adoptToGalleryExtensionId=h;function d(u,n){return h(f(u,n))}e.getGalleryExtensionId=d;function a(u,n){const i=[],r=t=>{for(const c of i)if(c.some(w=>P(n(w),n(t))))return c;return null};for(const t of u){const c=r(t);c?c.push(t):i.push([t])}return i}e.groupByExtension=a;function v(u){return{id:u.identifier.id,name:u.manifest.name,galleryId:null,publisherId:u.publisherId,publisherName:u.manifest.publisher,publisherDisplayName:u.publisherDisplayName,dependencies:u.manifest.extensionDependencies&&u.manifest.extensionDependencies.length>0}}e.getLocalExtensionTelemetryData=v;function A(u){return{id:u.identifier.id,name:u.name,galleryId:u.identifier.uuid,publisherId:u.publisherId,publisherName:u.publisher,publisherDisplayName:u.publisherDisplayName,isPreReleaseVersion:u.properties.isPreReleaseVersion,dependencies:!!(u.properties.dependencies&&u.properties.dependencies.length>0),...u.telemetryData}}e.getGalleryExtensionTelemetryData=A,e.BetterMergeId=new b.ExtensionIdentifier("pprice.better-merge");function l(u,n){const i=[],r=n.manifest.extensionDependencies?.slice(0)??[];for(;r.length;){const t=r.shift();if(t&&i.every(c=>!P(c.identifier,{id:t}))){const c=u.filter(w=>P(w.identifier,{id:t}));c.length===1&&(i.push(c[0]),r.push(...c[0].manifest.extensionDependencies?.slice(0)??[]))}}return i}e.getExtensionDependencies=l;async function _(u,n){if(!L.isLinux)return!1;let i;try{i=(await u.readFile(D.URI.file("/etc/os-release"))).value.toString()}catch{try{i=(await u.readFile(D.URI.file("/usr/lib/os-release"))).value.toString()}catch(t){n.debug("Error while getting the os-release file.",(0,T.getErrorMessage)(t))}}return!!i&&(i.match(/^ID=([^\u001b\r\n]*)/m)||[])[1]==="alpine"}e.isAlpineLinux=_;async function s(u,n){const i=await _(u,n),r=(0,p.getTargetPlatform)(i?"alpine":L.platform,E.arch);return n.debug("ComputeTargetPlatform:",r),r}e.computeTargetPlatform=s}),define(De[153],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TerminalDataBufferer=void 0;class o{constructor(b){this._callback=b,this._terminalBufferMap=new Map}dispose(){for(const b of this._terminalBufferMap.values())b.dispose()}startBuffering(b,L,D=5){const T=L(E=>{const P=typeof E=="string"?E:E.data;let R=this._terminalBufferMap.get(b);if(R){R.data.push(P);return}const y=setTimeout(()=>this.flushBuffer(b),D);R={data:[P],timeoutId:y,dispose:()=>{clearTimeout(y),this.flushBuffer(b),T.dispose()}},this._terminalBufferMap.set(b,R)});return T}stopBuffering(b){this._terminalBufferMap.get(b)?.dispose()}flushBuffer(b){const L=this._terminalBufferMap.get(b);L&&(this._terminalBufferMap.delete(b),this._callback(b,L.data.join("")))}}e.TerminalDataBufferer=o}),define(De[154],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isDark=e.isHighContrast=e.ColorScheme=void 0;var o;(function(L){L.DARK="dark",L.LIGHT="light",L.HIGH_CONTRAST_DARK="hcDark",L.HIGH_CONTRAST_LIGHT="hcLight"})(o=e.ColorScheme||(e.ColorScheme={}));function p(L){return L===o.HIGH_CONTRAST_DARK||L===o.HIGH_CONTRAST_LIGHT}e.isHighContrast=p;function b(L){return L===o.DARK||L===o.HIGH_CONTRAST_DARK}e.isDark=b}),define(De[60],Ce([1,0,115,4,7,3,30,154]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Themable=e.registerThemingParticipant=e.Extensions=e.getThemeTypeSelector=e.FolderThemeIcon=e.FileThemeIcon=e.ThemeIcon=e.themeColorFromId=e.ThemeColor=e.IThemeService=void 0,e.IThemeService=(0,L.createDecorator)("themeService");var E;(function(d){function a(v){return v&&typeof v=="object"&&typeof v.id=="string"}d.isThemeColor=a})(E=e.ThemeColor||(e.ThemeColor={}));function P(d){return{id:d}}e.themeColorFromId=P;var R;(function(d){function a(i){return i&&typeof i=="object"&&typeof i.id=="string"&&(typeof i.color=="undefined"||E.isThemeColor(i.color))}d.isThemeIcon=a;const v=new RegExp(`^\\$\\((${o.CSSIcon.iconNameExpression}(?:${o.CSSIcon.iconModifierExpression})?)\\)$`);function A(i){const r=v.exec(i);if(!r)return;const[,t]=r;return{id:t}}d.fromString=A;function l(i){return{id:i}}d.fromId=l;function _(i,r){let t=i.id;const c=t.lastIndexOf("~");return c!==-1&&(t=t.substring(0,c)),r&&(t=`${t}~${r}`),{id:t}}d.modify=_;function s(i){const r=i.id.lastIndexOf("~");if(r!==-1)return i.id.substring(r+1)}d.getModifier=s;function u(i,r){return i.id===r.id&&i.color?.id===r.color?.id}d.isEqual=u;function n(i,r){return{id:i.id,color:r?P(r):void 0}}d.asThemeIcon=n,d.asClassNameArray=o.CSSIcon.asClassNameArray,d.asClassName=o.CSSIcon.asClassName,d.asCSSSelector=o.CSSIcon.asCSSSelector})(R=e.ThemeIcon||(e.ThemeIcon={})),e.FileThemeIcon=o.Codicon.file,e.FolderThemeIcon=o.Codicon.folder;function y(d){switch(d){case T.ColorScheme.DARK:return"vs-dark";case T.ColorScheme.HIGH_CONTRAST_DARK:return"hc-black";case T.ColorScheme.HIGH_CONTRAST_LIGHT:return"hc-light";default:return"vs"}}e.getThemeTypeSelector=y,e.Extensions={ThemingContribution:"base.contributions.theming"};class m{constructor(){this.themingParticipants=[],this.themingParticipants=[],this.onThemingParticipantAddedEmitter=new p.Emitter}onColorThemeChange(a){return this.themingParticipants.push(a),this.onThemingParticipantAddedEmitter.fire(a),(0,b.toDisposable)(()=>{const v=this.themingParticipants.indexOf(a);this.themingParticipants.splice(v,1)})}get onThemingParticipantAdded(){return this.onThemingParticipantAddedEmitter.event}getThemingParticipants(){return this.themingParticipants}}const I=new m;D.Registry.add(e.Extensions.ThemingContribution,I);function f(d){return I.onColorThemeChange(d)}e.registerThemingParticipant=f;class h extends b.Disposable{constructor(a){super();this.themeService=a,this.theme=a.getColorTheme(),this._register(this.themeService.onDidColorThemeChange(v=>this.onThemeChange(v)))}onThemeChange(a){this.theme=a,this.updateStyles()}updateStyles(){}getColor(a,v){let A=this.theme.getColor(a);return A&&v&&(A=v(A,this.theme)),A?A.toString():null}}e.Themable=h}),define(De[155],Ce([1,0,4,23,3,14]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractTunnelService=e.DisposableTunnel=e.isPortPrivileged=e.isAllInterfaces=e.ALL_INTERFACES_ADDRESSES=e.isLocalhost=e.LOCALHOST_ADDRESSES=e.extractLocalHostUriMetaDataForPortMapping=e.ProvidedOnAutoForward=e.TunnelPrivacyId=e.TunnelProtocol=e.ISharedTunnelsService=e.ITunnelService=void 0,e.ITunnelService=(0,b.createDecorator)("tunnelService"),e.ISharedTunnelsService=(0,b.createDecorator)("sharedTunnelsService");var D;(function(h){h.Http="http",h.Https="https"})(D=e.TunnelProtocol||(e.TunnelProtocol={}));var T;(function(h){h.ConstantPrivate="constantPrivate",h.Private="private",h.Public="public"})(T=e.TunnelPrivacyId||(e.TunnelPrivacyId={}));var E;(function(h){h[h.Notify=1]="Notify",h[h.OpenBrowser=2]="OpenBrowser",h[h.OpenPreview=3]="OpenPreview",h[h.Silent=4]="Silent",h[h.Ignore=5]="Ignore",h[h.OpenBrowserOnce=6]="OpenBrowserOnce"})(E=e.ProvidedOnAutoForward||(e.ProvidedOnAutoForward={}));function P(h){if(h.scheme!=="http"&&h.scheme!=="https")return;const d=/^(localhost|127\.0\.0\.1|0\.0\.0\.0):(\d+)$/.exec(h.authority);if(!!d)return{address:d[1],port:+d[2]}}e.extractLocalHostUriMetaDataForPortMapping=P,e.LOCALHOST_ADDRESSES=["localhost","127.0.0.1","0:0:0:0:0:0:0:1","::1"];function R(h){return e.LOCALHOST_ADDRESSES.indexOf(h)>=0}e.isLocalhost=R,e.ALL_INTERFACES_ADDRESSES=["0.0.0.0","0:0:0:0:0:0:0:0","::"];function y(h){return e.ALL_INTERFACES_ADDRESSES.indexOf(h)>=0}e.isAllInterfaces=y;function m(h,d){return d?d!==1&&h<1024:!p.isWindows&&h<1024}e.isPortPrivileged=m;class I{constructor(d,a,v){this.remoteAddress=d,this.localAddress=a,this._dispose=v,this._onDispose=new o.Emitter,this.onDidDispose=this._onDispose.event}dispose(){return this._onDispose.fire(),this._dispose()}}e.DisposableTunnel=I;let f=class{constructor(d){this.logService=d,this._onTunnelOpened=new o.Emitter,this.onTunnelOpened=this._onTunnelOpened.event,this._onTunnelClosed=new o.Emitter,this.onTunnelClosed=this._onTunnelClosed.event,this._onAddedTunnelProvider=new o.Emitter,this.onAddedTunnelProvider=this._onAddedTunnelProvider.event,this._tunnels=new Map,this._canElevate=!1,this._privacyOptions=[],this._factoryInProgress=new Set}get hasTunnelProvider(){return!!this._tunnelProvider}setTunnelProvider(d){return this._tunnelProvider=d,d?(this._onAddedTunnelProvider.fire(),{dispose:()=>{this._tunnelProvider=void 0,this._canElevate=!1,this._privacyOptions=[]}}):(this._canElevate=!1,this._privacyOptions=[],this._onAddedTunnelProvider.fire(),{dispose:()=>{}})}setTunnelFeatures(d){this._canElevate=d.elevation,this._privacyOptions=d.privacyOptions}get canElevate(){return this._canElevate}get canChangePrivacy(){return this._privacyOptions.length>0}get privacyOptions(){return this._privacyOptions}get tunnels(){return this.getTunnels()}async getTunnels(){const d=[],a=Array.from(this._tunnels.values());for(const v of a){const A=Array.from(v.values());for(const l of A){const _=await l.value;_&&d.push(_)}}return d}async dispose(){for(const d of this._tunnels.values()){for(const{value:a}of d.values())await a.then(v=>v?.dispose());d.clear()}this._tunnels.clear()}openTunnel(d,a,v,A,l=!1,_,s){if(this.logService.trace(`ForwardedPorts: (TunnelService) openTunnel request for ${a}:${v} on local port ${A}.`),!d)return;if(a||(a="localhost"),this._tunnelProvider&&this._factoryInProgress.has(v)){this.logService.debug("ForwardedPorts: (TunnelService) Another call to create a tunnel with the same address has occurred before the last one completed. This call will be ignored.");return}const u=this.retainOrCreateTunnel(d,a,v,A,l,_,s);return u?u.then(n=>{if(!n){this.logService.trace("ForwardedPorts: (TunnelService) New tunnel is undefined."),this.removeEmptyTunnelFromMap(a,v);return}this.logService.trace("ForwardedPorts: (TunnelService) New tunnel established.");const i=this.makeTunnel(n);return(n.tunnelRemoteHost!==a||n.tunnelRemotePort!==v)&&this.logService.warn("ForwardedPorts: (TunnelService) Created tunnel does not match requirements of requested tunnel. Host or port mismatch."),this._onTunnelOpened.fire(i),i}):(this.logService.trace("ForwardedPorts: (TunnelService) Tunnel was not created."),u)}makeTunnel(d){return{tunnelRemotePort:d.tunnelRemotePort,tunnelRemoteHost:d.tunnelRemoteHost,tunnelLocalPort:d.tunnelLocalPort,localAddress:d.localAddress,privacy:d.privacy,protocol:d.protocol,dispose:async()=>{this.logService.trace(`ForwardedPorts: (TunnelService) dispose request for ${d.tunnelRemoteHost}:${d.tunnelRemotePort} `);const a=this._tunnels.get(d.tunnelRemoteHost);if(a){const v=a.get(d.tunnelRemotePort);v&&(v.refcount--,await this.tryDisposeTunnel(d.tunnelRemoteHost,d.tunnelRemotePort,v))}}}}async tryDisposeTunnel(d,a,v){if(v.refcount<=0){this.logService.trace(`ForwardedPorts: (TunnelService) Tunnel is being disposed ${d}:${a}.`);const A=v.value.then(async l=>{l&&(await l.dispose(!0),this._onTunnelClosed.fire({host:l.tunnelRemoteHost,port:l.tunnelRemotePort}))});return this._tunnels.has(d)&&this._tunnels.get(d).delete(a),A}}async closeTunnel(d,a){this.logService.trace(`ForwardedPorts: (TunnelService) close request for ${d}:${a} `);const v=this._tunnels.get(d);if(v&&v.has(a)){const A=v.get(a);A.refcount=0,await this.tryDisposeTunnel(d,a,A)}}addTunnelToMap(d,a,v){this._tunnels.has(d)||this._tunnels.set(d,new Map),this._tunnels.get(d).set(a,{refcount:1,value:v})}async removeEmptyTunnelFromMap(d,a){const v=this._tunnels.get(d);v&&(await v.get(a)||v.delete(a),v.size===0&&this._tunnels.delete(d))}getTunnelFromMap(d,a){const v=[d];R(d)?(v.push(...e.LOCALHOST_ADDRESSES),v.push(...e.ALL_INTERFACES_ADDRESSES)):y(d)&&v.push(...e.ALL_INTERFACES_ADDRESSES);const A=v.map(l=>this._tunnels.get(l));for(const l of A){const _=l?.get(a);if(_)return _}}canTunnel(d){return!!P(d)}createWithProvider(d,a,v,A,l,_,s){this.logService.trace(`ForwardedPorts: (TunnelService) Creating tunnel with provider ${a}:${v} on local port ${A}.`);const u=v;this._factoryInProgress.add(u);const i={elevationRequired:l?m(A===void 0?v:A):!1},r={remoteAddress:{host:a,port:v},localAddressPort:A,privacy:_,public:_?_!==T.Private:void 0,protocol:s},t=d.forwardPort(r,i);return t?(this.addTunnelToMap(a,v,t),t.finally(()=>{this.logService.trace("ForwardedPorts: (TunnelService) Tunnel created by provider."),this._factoryInProgress.delete(u)})):this._factoryInProgress.delete(u),t}};f=ze([xe(0,L.ILogService)],f),e.AbstractTunnelService=f}),define(De[156],Ce([1,0,12]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isVirtualWorkspace=e.getVirtualWorkspaceAuthority=e.getVirtualWorkspaceScheme=e.getVirtualWorkspaceLocation=e.isVirtualResource=void 0;function p(E){return E.scheme!==o.Schemas.file&&E.scheme!==o.Schemas.vscodeRemote}e.isVirtualResource=p;function b(E){if(E.folders.length)return E.folders.every(P=>p(P.uri))?E.folders[0].uri:void 0;if(E.configuration&&p(E.configuration))return E.configuration}e.getVirtualWorkspaceLocation=b;function L(E){return b(E)?.scheme}e.getVirtualWorkspaceScheme=L;function D(E){return b(E)?.authority}e.getVirtualWorkspaceAuthority=D;function T(E){return b(E)!==void 0}e.isVirtualWorkspace=T}),define(De[45],Ce([1,0,127,19,25,21,2,3,12]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasWorkspaceFileExtension=e.isSavedWorkspace=e.isTemporaryWorkspace=e.isUntitledWorkspace=e.UNTITLED_WORKSPACE_NAME=e.WORKSPACE_FILTER=e.WORKSPACE_EXTENSION=e.toWorkspaceFolder=e.WorkspaceFolder=e.Workspace=e.isWorkspaceFolder=e.isWorkspace=e.WorkbenchState=e.reviveIdentifier=e.isWorkspaceIdentifier=e.toWorkspaceIdentifier=e.isSingleFolderWorkspaceIdentifier=e.IWorkspaceContextService=void 0,e.IWorkspaceContextService=(0,T.createDecorator)("contextService");function P(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.uri)}e.isSingleFolderWorkspaceIdentifier=P;function R(n){if(n.configuration)return{id:n.id,configPath:n.configuration};if(n.folders.length===1)return{id:n.id,uri:n.folders[0].uri}}e.toWorkspaceIdentifier=R;function y(n){const i=n;return typeof i?.id=="string"&&D.URI.isUri(i.configPath)}e.isWorkspaceIdentifier=y;function m(n){const i=n;if(i?.uri)return{id:i.id,uri:D.URI.revive(i.uri)};const r=n;if(r?.configPath)return{id:r.id,configPath:D.URI.revive(r.configPath)};if(n?.id)return{id:n.id}}e.reviveIdentifier=m;var I;(function(n){n[n.EMPTY=1]="EMPTY",n[n.FOLDER=2]="FOLDER",n[n.WORKSPACE=3]="WORKSPACE"})(I=e.WorkbenchState||(e.WorkbenchState={}));function f(n){const i=n;return!!(i&&typeof i=="object"&&typeof i.id=="string"&&Array.isArray(i.folders))}e.isWorkspace=f;function h(n){const i=n;return!!(i&&typeof i=="object"&&D.URI.isUri(i.uri)&&typeof i.name=="string"&&typeof i.toResource=="function")}e.isWorkspaceFolder=h;class d{constructor(i,r,t,c,w){this._id=i,this._transient=t,this._configuration=c,this._ignorePathCasing=w,this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0),this.folders=r}update(i){this._id=i.id,this._configuration=i.configuration,this._transient=i.transient,this._ignorePathCasing=i._ignorePathCasing,this.folders=i.folders}get folders(){return this._folders}set folders(i){this._folders=i,this.updateFoldersMap()}get id(){return this._id}get transient(){return this._transient}get configuration(){return this._configuration}set configuration(i){this._configuration=i}getFolder(i){return i&&this._foldersMap.findSubstr(i)||null}updateFoldersMap(){this._foldersMap=b.TernarySearchTree.forUris(this._ignorePathCasing,()=>!0);for(const i of this.folders)this._foldersMap.set(i.uri,i)}toJSON(){return{id:this.id,folders:this.folders,transient:this.transient,configuration:this.configuration}}}e.Workspace=d;class a{constructor(i,r){this.raw=r,this.uri=i.uri,this.index=i.index,this.name=i.name}toResource(i){return(0,L.joinPath)(this.uri,i)}toJSON(){return{uri:this.uri,name:this.name,index:this.index}}}e.WorkspaceFolder=a;function v(n){return new a({uri:n,index:0,name:(0,L.basenameOrAuthority)(n)},{uri:n.toString()})}e.toWorkspaceFolder=v,e.WORKSPACE_EXTENSION="code-workspace";const A=`.${e.WORKSPACE_EXTENSION}`;e.WORKSPACE_FILTER=[{name:(0,o.localize)(0,null),extensions:[e.WORKSPACE_EXTENSION]}],e.UNTITLED_WORKSPACE_NAME="workspace.json";function l(n,i){return L.extUriBiasedIgnorePathCase.isEqualOrParent(n,i.untitledWorkspacesHome)}e.isUntitledWorkspace=l;function _(n){let i;return D.URI.isUri(n)?i=n:i=n.configuration,i?.scheme===E.Schemas.tmp}e.isTemporaryWorkspace=_;function s(n,i){return!l(n,i)&&!_(n)}e.isSavedWorkspace=s;function u(n){return(typeof n=="string"?(0,p.extname)(n):(0,L.extname)(n))===A}e.hasWorkspaceFileExtension=u}),define(De[61],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.Cache=void 0;class o{constructor(b){this.id=b,this._data=new Map,this._idPool=1}add(b){const L=this._idPool++;return this._data.set(L,b),this.logDebugInfo(),L}get(b,L){return this._data.has(b)?this._data.get(b)[L]:void 0}delete(b){this._data.delete(b),this.logDebugInfo()}logDebugInfo(){!o.enableDebugLogging||console.log(`${this.id} cache size - ${this._data.size}`)}}e.Cache=o,o.enableDebugLogging=!1}),define(De[35],Ce([1,0,12,21,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostFileSystemInfo=e.ExtHostFileSystemInfo=void 0;class L{constructor(){this._systemSchemes=new Set(Object.keys(o.Schemas)),this._providerInfo=new Map,this.extUri=new p.ExtUri(T=>{const E=this._providerInfo.get(T.scheme);return!(E===void 0||E&1024)})}$acceptProviderInfos(T,E){E===null?this._providerInfo.delete(T.scheme):this._providerInfo.set(T.scheme,E)}isFreeScheme(T){return!this._providerInfo.has(T)&&!this._systemSchemes.has(T)}getCapabilities(T){return this._providerInfo.get(T)}}e.ExtHostFileSystemInfo=L,e.IExtHostFileSystemInfo=(0,b.createDecorator)("IExtHostFileSystemInfo")}),define(De[28],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostInitDataService=void 0,e.IExtHostInitDataService=(0,o.createDecorator)("IExtHostInitDataService")}),define(De[157],Ce([1,0,13]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionGlobalMemento=e.ExtensionMemento=void 0;class p{constructor(D,T,E){this._deferredPromises=new Map,this._id=D,this._shared=T,this._storage=E,this._init=this._storage.initializeExtensionStorage(this._shared,this._id,Object.create(null)).then(P=>(this._value=P,this)),this._storageListener=this._storage.onDidChangeStorage(P=>{P.shared===this._shared&&P.key===this._id&&(this._value=P.value)}),this._scheduler=new o.RunOnceScheduler(()=>{const P=this._deferredPromises;this._deferredPromises=new Map,(async()=>{try{await this._storage.setValue(this._shared,this._id,this._value);for(const R of P.values())R.complete()}catch(R){for(const y of P.values())y.error(R)}})()},0)}keys(){return Object.entries(this._value??{}).filter(([,D])=>D!==void 0).map(([D])=>D)}get whenReady(){return this._init}get(D,T){let E=this._value[D];return typeof E=="undefined"&&(E=T),E}update(D,T){this._value[D]=T;const E=this._deferredPromises.get(D);if(E!==void 0)return E.p;const P=new o.DeferredPromise;return this._deferredPromises.set(D,P),this._scheduler.isScheduled()||this._scheduler.schedule(),P.p}dispose(){this._storageListener.dispose()}}e.ExtensionMemento=p;class b extends p{constructor(D,T){super(D.identifier.value,!0,T);this._extension=D}setKeysForSync(D){this._storage.registerExtensionStorageKeysToSync({id:this._id,version:this._extension.version},D)}}e.ExtensionGlobalMemento=b}),define(De[158],Ce([1,0,4,2]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocuments=void 0;class b{constructor(D){this._notebooksAndEditors=D,this._onDidSaveNotebookDocument=new o.Emitter,this.onDidSaveNotebookDocument=this._onDidSaveNotebookDocument.event,this._onDidChangeNotebookDocument=new o.Emitter,this.onDidChangeNotebookDocument=this._onDidChangeNotebookDocument.event}$acceptModelChanged(D,T,E,P){const y=this._notebooksAndEditors.getNotebookDocument(p.URI.revive(D)).acceptModelChanged(T.value,E,P);this._onDidChangeNotebookDocument.fire(y)}$acceptDirtyStateChanged(D,T){this._notebooksAndEditors.getNotebookDocument(p.URI.revive(D)).acceptDirty(T)}$acceptModelSaved(D){const T=this._notebooksAndEditors.getNotebookDocument(p.URI.revive(D));this._onDidSaveNotebookDocument.fire(T.apiNotebook)}}e.ExtHostNotebookDocuments=b}),define(De[15],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostRpcService=e.IExtHostRpcService=void 0,e.IExtHostRpcService=(0,o.createDecorator)("IExtHostRpcService");class p{constructor(L){this.getProxy=L.getProxy.bind(L),this.set=L.set.bind(L),this.dispose=L.dispose.bind(L),this.assertRegistered=L.assertRegistered.bind(L),this.drain=L.drain.bind(L)}}e.ExtHostRpcService=p});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[159],Ce([1,0,27,4]),function(te,e,o,p){"use strict";var b;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionSecrets=void 0;class L{constructor(T,E){b.set(this,void 0),this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._id=o.ExtensionIdentifier.toKey(T.identifier),Je(this,b,E,"f"),Oe(this,b,"f").onDidChangePassword(P=>{P.extensionId===this._id&&this._onDidChange.fire({key:P.key})})}get(T){return Oe(this,b,"f").get(this._id,T)}store(T,E){return Oe(this,b,"f").store(this._id,T,E)}delete(T){return Oe(this,b,"f").delete(this._id,T)}}e.ExtensionSecrets=L,b=new WeakMap}),define(De[86],Ce([1,0,3,4]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTelemetry=e.ExtHostTelemetry=void 0;class b{constructor(){this._onDidChangeTelemetryEnabled=new p.Emitter,this.onDidChangeTelemetryEnabled=this._onDidChangeTelemetryEnabled.event,this._onDidChangeTelemetryConfiguration=new p.Emitter,this.onDidChangeTelemetryConfiguration=this._onDidChangeTelemetryConfiguration.event,this._productConfig={usage:!0,error:!0},this._level=0}getTelemetryConfiguration(){return this._level===3}getTelemetryDetails(){return{isCrashEnabled:this._level>=1,isErrorsEnabled:this._productConfig.error?this._level>=2:!1,isUsageEnabled:this._productConfig.usage?this._level>=3:!1}}$initializeTelemetryLevel(D,T){this._level=D,this._productConfig=T||{usage:!0,error:!0}}$onDidChangeTelemetryLevel(D){this._oldTelemetryEnablement=this.getTelemetryConfiguration(),this._level=D,this._oldTelemetryEnablement!==this.getTelemetryConfiguration()&&this._onDidChangeTelemetryEnabled.fire(this.getTelemetryConfiguration()),this._onDidChangeTelemetryConfiguration.fire(this.getTelemetryDetails())}}e.ExtHostTelemetry=b,e.IExtHostTelemetry=(0,o.createDecorator)("IExtHostTelemetry")}),define(De[62],Ce([1,0,3,155,4,15]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTunnelService=e.IExtHostTunnelService=e.TunnelDtoConverter=void 0;var D;(function(E){function P(y){return{remoteAddress:y.remoteAddress,localAddress:y.localAddress,public:!!y.public,privacy:y.privacy??(y.public?p.TunnelPrivacyId.Public:p.TunnelPrivacyId.Private),protocol:y.protocol}}E.fromApiTunnel=P;function R(y){return{remoteAddress:{host:y.tunnelRemoteHost,port:y.tunnelRemotePort},localAddress:y.localAddress,public:y.privacy!==p.TunnelPrivacyId.ConstantPrivate&&y.privacy!==p.TunnelPrivacyId.ConstantPrivate,privacy:y.privacy,protocol:y.protocol}}E.fromServiceTunnel=R})(D=e.TunnelDtoConverter||(e.TunnelDtoConverter={})),e.IExtHostTunnelService=(0,o.createDecorator)("IExtHostTunnelService");let T=class{constructor(P){this.onDidChangeTunnels=new b.Emitter().event}async $applyCandidateFilter(P){return P}async openTunnel(P,R){}async getTunnels(){return[]}async setTunnelFactory(P){return{dispose:()=>{}}}registerPortsAttributesProvider(P,R){return{dispose:()=>{}}}async $providePortAttributes(P,R,y,m,I){return[]}async $forwardPort(P,R){}async $closeTunnel(P){}async $onDidTunnelsChange(){}async $registerCandidateFinder(){}};T=ze([xe(0,L.IExtHostRpcService)],T),e.ExtHostTunnelService=T});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[6],Ce([1,0,16,11,75,25,74,9,10,2,42,39,84]),function(te,e,o,p,b,L,D,T,E,P,R,y,m){"use strict";var I,f,h,d,a,v,A,l,_,s,u,n,i,r,t,c,w,g,C,U,W,M,S;Object.defineProperty(e,"__esModule",{value:!0}),e.InteractiveWindowInput=e.TerminalEditorTabInput=e.NotebookDiffEditorTabInput=e.NotebookEditorTabInput=e.WebviewEditorTabInput=e.CustomEditorTabInput=e.TextMergeTabInput=e.TextDiffTabInput=e.TextTabInput=e.TypeHierarchyItem=e.PortAutoForwardAction=e.WorkspaceTrustState=e.ExternalUriOpenerPriority=e.FunctionCoverage=e.BranchCoverage=e.StatementCoverage=e.FileCoverage=e.CoveredCount=e.TestTag=e.TestMessage=e.TestRunRequest=e.TestRunProfileKind=e.TestResultState=e.PortAttributes=e.LinkedEditingRanges=e.StandardTokenType=e.ExtensionRuntime=e.ExtensionMode=e.TimelineItem=e.NotebookRendererScript=e.NotebookControllerAffinity=e.NotebookCellStatusBarItem=e.NotebookEditorRevealType=e.NotebookCellStatusBarAlignment=e.NotebookCellExecutionState=e.NotebookCellKind=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookData=e.NotebookCellData=e.NotebookRange=e.ColorThemeKind=e.ColorTheme=e.FileDecoration=e.ExtensionKind=e.InputBoxValidationSeverity=e.QuickPickItemKind=e.QuickInputButtons=e.DebugConsoleMode=e.SemanticTokensEdits=e.SemanticTokensEdit=e.SemanticTokens=e.SemanticTokensBuilder=e.SemanticTokensLegend=e.CommentThreadState=e.CommentMode=e.CommentThreadCollapsibleState=e.FoldingRangeKind=e.FoldingRange=e.FileSystemError=e.FileChangeType=e.InlineValueContext=e.InlineValueEvaluatableExpression=e.InlineValueVariableLookup=e.InlineValueText=e.InlineCompletionTriggerKindNew=e.InlineCompletionTriggerKind=e.EvaluatableExpression=e.DebugAdapterInlineImplementation=e.DebugAdapterNamedPipeServer=e.DebugAdapterServer=e.DebugAdapterExecutable=e.DataBreakpoint=e.FunctionBreakpoint=e.SourceBreakpoint=e.Breakpoint=e.RelativePattern=e.ConfigurationTarget=e.ThemeColor=e.ThemeIcon=e.DocumentPasteEdit=e.DocumentDropEdit=e.DataTransfer=e.DataTransferItem=e.TreeItemCollapsibleState=e.TreeItem=e.ProgressLocation=e.Task=e.CustomExecution=e.TaskScope=e.ShellQuoting=e.ShellExecution=e.ProcessExecution=e.TaskGroup=e.TaskPanelKind=e.TaskRevealKind=e.TerminalProfile=e.TerminalLocation=e.TerminalLink=e.TerminalExitReason=e.SourceControlInputBoxValidationType=e.ColorFormat=e.ColorPresentation=e.ColorInformation=e.Color=e.DocumentLink=e.DecorationRangeBehavior=e.TextDocumentChangeReason=e.TextEditorSelectionChangeKind=e.TextEditorRevealType=e.TextDocumentSaveReason=e.TextEditorLineNumbersStyle=e.StatusBarAlignment=e.ViewColumn=e.InlineSuggestionsNew=e.InlineSuggestionNew=e.InlineSuggestionList=e.InlineSuggestion=e.CompletionList=e.CompletionItem=e.CompletionItemTag=e.CompletionItemKind=e.CompletionTriggerKind=e.InlayHint=e.InlayHintLabelPart=e.InlayHintKind=e.SignatureHelpTriggerKind=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.MarkdownString=e.CodeLens=e.LanguageStatusSeverity=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.SelectionRange=e.CodeActionKind=e.CodeAction=e.CodeActionTriggerKind=e.DocumentSymbol=e.SymbolInformation=e.SymbolTag=e.SymbolKind=e.DocumentHighlight=e.DocumentHighlightKind=e.Hover=e.Diagnostic=e.DiagnosticRelatedInformation=e.Location=e.DiagnosticSeverity=e.DiagnosticTag=e.SnippetString=e.WorkspaceEdit=e.FileEditType=e.NotebookEdit=e.TextEdit=e.EnvironmentVariableMutatorType=e.EndOfLine=e.RemoteAuthorityResolverError=e.ResolvedAuthority=e.Selection=e.Range=e.Position=e.Disposable=void 0;function z(x){function O(){return Reflect.construct(x,arguments,this.constructor)}return Object.defineProperty(O,"name",Object.getOwnPropertyDescriptor(x,"name")),Object.setPrototypeOf(O,x),Object.setPrototypeOf(O.prototype,x.prototype),O}let $=v=class{constructor(O){I.set(this,void 0),Je(this,I,O,"f")}static from(...O){let J=O;return new v(function(){if(J){for(const _e of J)_e&&typeof _e.dispose=="function"&&_e.dispose();J=void 0}})}dispose(){typeof Oe(this,I,"f")=="function"&&(Oe(this,I,"f").call(this),Je(this,I,void 0,"f"))}};I=new WeakMap,$=v=ze([z],$),e.Disposable=$;let N=A=class{constructor(O,J){if(O<0)throw(0,p.illegalArgument)("line must be non-negative");if(J<0)throw(0,p.illegalArgument)("character must be non-negative");this._line=O,this._character=J}static Min(...O){if(O.length===0)throw new TypeError;let J=O[0];for(let _e=1;_e<O.length;_e++){const qe=O[_e];qe.isBefore(J)&&(J=qe)}return J}static Max(...O){if(O.length===0)throw new TypeError;let J=O[0];for(let _e=1;_e<O.length;_e++){const qe=O[_e];qe.isAfter(J)&&(J=qe)}return J}static isPosition(O){if(!O)return!1;if(O instanceof A)return!0;const{line:J,character:_e}=O;return typeof J=="number"&&typeof _e=="number"}static of(O){if(O instanceof A)return O;if(this.isPosition(O))return new A(O.line,O.character);throw new Error("Invalid argument, is NOT a position-like object")}get line(){return this._line}get character(){return this._character}isBefore(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<O._character}isBeforeOrEqual(O){return this._line<O._line?!0:O._line<this._line?!1:this._character<=O._character}isAfter(O){return!this.isBeforeOrEqual(O)}isAfterOrEqual(O){return!this.isBefore(O)}isEqual(O){return this._line===O._line&&this._character===O._character}compareTo(O){return this._line<O._line?-1:this._line>O.line?1:this._character<O._character?-1:this._character>O._character?1:0}translate(O,J=0){if(O===null||J===null)throw(0,p.illegalArgument)();let _e;return typeof O=="undefined"?_e=0:typeof O=="number"?_e=O:(_e=typeof O.lineDelta=="number"?O.lineDelta:0,J=typeof O.characterDelta=="number"?O.characterDelta:0),_e===0&&J===0?this:new A(this.line+_e,this.character+J)}with(O,J=this.character){if(O===null||J===null)throw(0,p.illegalArgument)();let _e;return typeof O=="undefined"?_e=this.line:typeof O=="number"?_e=O:(_e=typeof O.line=="number"?O.line:this.line,J=typeof O.character=="number"?O.character:this.character),_e===this.line&&J===this.character?this:new A(_e,J)}toJSON(){return{line:this.line,character:this.character}}};N=A=ze([z],N),e.Position=N;let K=l=class{constructor(O,J,_e,qe){let tt,at;if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof qe=="number"?(tt=new N(O,J),at=new N(_e,qe)):N.isPosition(O)&&N.isPosition(J)&&(tt=N.of(O),at=N.of(J)),!tt||!at)throw new Error("Invalid arguments");tt.isBefore(at)?(this._start=tt,this._end=at):(this._start=at,this._end=tt)}static isRange(O){return O instanceof l?!0:O?N.isPosition(O.start)&&N.isPosition(O.end):!1}static of(O){if(O instanceof l)return O;if(this.isRange(O))return new l(O.start,O.end);throw new Error("Invalid argument, is NOT a range-like object")}get start(){return this._start}get end(){return this._end}contains(O){return l.isRange(O)?this.contains(O.start)&&this.contains(O.end):N.isPosition(O)?!(N.of(O).isBefore(this._start)||this._end.isBefore(O)):!1}isEqual(O){return this._start.isEqual(O._start)&&this._end.isEqual(O._end)}intersection(O){const J=N.Max(O.start,this._start),_e=N.Min(O.end,this._end);if(!J.isAfter(_e))return new l(J,_e)}union(O){if(this.contains(O))return this;if(O.contains(this))return O;const J=N.Min(O.start,this._start),_e=N.Max(O.end,this.end);return new l(J,_e)}get isEmpty(){return this._start.isEqual(this._end)}get isSingleLine(){return this._start.line===this._end.line}with(O,J=this.end){if(O===null||J===null)throw(0,p.illegalArgument)();let _e;return O?N.isPosition(O)?_e=O:(_e=O.start||this.start,J=O.end||this.end):_e=this.start,_e.isEqual(this._start)&&J.isEqual(this.end)?this:new l(_e,J)}toJSON(){return[this.start,this.end]}};K=l=ze([z],K),e.Range=K;let V=_=class extends K{constructor(O,J,_e,qe){let tt,at;if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof qe=="number"?(tt=new N(O,J),at=new N(_e,qe)):N.isPosition(O)&&N.isPosition(J)&&(tt=N.of(O),at=N.of(J)),!tt||!at)throw new Error("Invalid arguments");super(tt,at);this._anchor=tt,this._active=at}static isSelection(O){return O instanceof _?!0:O?K.isRange(O)&&N.isPosition(O.anchor)&&N.isPosition(O.active)&&typeof O.isReversed=="boolean":!1}get anchor(){return this._anchor}get active(){return this._active}get isReversed(){return this._anchor===this._end}toJSON(){return{start:this.start,end:this.end,active:this.active,anchor:this.anchor}}};V=_=ze([z],V),e.Selection=V;class F{constructor(O,J,_e){if(typeof O!="string"||O.length===0)throw(0,p.illegalArgument)("host");if(typeof J!="number"||J===0||Math.round(J)!==J)throw(0,p.illegalArgument)("port");if(typeof _e!="undefined"&&(typeof _e!="string"||_e.length===0||!/^[0-9A-Za-z\-]+$/.test(_e)))throw(0,p.illegalArgument)("connectionToken");this.host=O,this.port=Math.round(J),this.connectionToken=_e}}e.ResolvedAuthority=F;class ne extends Error{constructor(O,J=m.RemoteAuthorityResolverErrorCode.Unknown,_e){super(O);this._message=O,this._code=J,this._detail=_e,typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,ne.prototype)}static NotAvailable(O,J){return new ne(O,m.RemoteAuthorityResolverErrorCode.NotAvailable,J)}static TemporarilyNotAvailable(O){return new ne(O,m.RemoteAuthorityResolverErrorCode.TemporarilyNotAvailable)}}e.RemoteAuthorityResolverError=ne;var ce;(function(x){x[x.LF=1]="LF",x[x.CRLF=2]="CRLF"})(ce=e.EndOfLine||(e.EndOfLine={}));var re;(function(x){x[x.Replace=1]="Replace",x[x.Append=2]="Append",x[x.Prepend=3]="Prepend"})(re=e.EnvironmentVariableMutatorType||(e.EnvironmentVariableMutatorType={}));let fe=s=class{constructor(O,J){this._range=O,this._newText=J}static isTextEdit(O){return O instanceof s?!0:O?K.isRange(O)&&typeof O.newText=="string":!1}static replace(O,J){return new s(O,J)}static insert(O,J){return s.replace(new K(O,O),J)}static delete(O){return s.replace(O,"")}static setEndOfLine(O){const J=new s(new K(new N(0,0),new N(0,0)),"");return J.newEol=O,J}get range(){return this._range}set range(O){if(O&&!K.isRange(O))throw(0,p.illegalArgument)("range");this._range=O}get newText(){return this._newText||""}set newText(O){if(O&&typeof O!="string")throw(0,p.illegalArgument)("newText");this._newText=O}get newEol(){return this._newEol}set newEol(O){if(O&&typeof O!="number")throw(0,p.illegalArgument)("newEol");this._newEol=O}toJSON(){return{range:this.range,newText:this.newText,newEol:this._newEol}}};fe=s=ze([z],fe),e.TextEdit=fe;let ie=u=class{constructor(O,J){this.range=O,this.newCells=J}static isNotebookCellEdit(O){return O instanceof u?!0:O?$t.isNotebookRange(O)&&Array.isArray(O.newCells):!1}static replaceCells(O,J){return new u(O,J)}static insertCells(O,J){return new u(new $t(O,O),J)}static deleteCells(O){return new u(O,[])}static updateCellMetadata(O,J){const _e=new u(new $t(O,O),[]);return _e.newCellMetadata=J,_e}static updateNotebookMetadata(O){const J=new u(new $t(0,0),[]);return J.newNotebookMetadata=O,J}};ie=u=ze([z],ie),e.NotebookEdit=ie;var Ee;(function(x){x[x.File=1]="File",x[x.Text=2]="Text",x[x.Cell=3]="Cell",x[x.CellReplace=5]="CellReplace",x[x.Snippet=6]="Snippet"})(Ee=e.FileEditType||(e.FileEditType={}));let be=class{constructor(){this._edits=[]}_allEntries(){return this._edits}renameFile(O,J,_e,qe){this._edits.push({_type:1,from:O,to:J,options:_e,metadata:qe})}createFile(O,J,_e){this._edits.push({_type:1,from:void 0,to:O,options:J,metadata:_e})}deleteFile(O,J,_e){this._edits.push({_type:1,from:O,to:void 0,options:J,metadata:_e})}replaceNotebookMetadata(O,J,_e){this._edits.push({_type:3,metadata:_e,uri:O,edit:{editType:5,metadata:J},notebookMetadata:J})}replaceNotebookCells(O,J,_e,qe,tt){let at,ct,St=[],Pt;if($t.isNotebookRange(J)&&qt.isNotebookCellDataArray(_e)&&!qt.isNotebookCellDataArray(qe)?(at=J.start,ct=J.end,St=_e,Pt=qe):typeof J=="number"&&typeof _e=="number"&&qt.isNotebookCellDataArray(qe)&&(at=J,ct=_e,St=qe,Pt=tt),at===void 0||ct===void 0)throw new Error("Invalid arguments");(at!==ct||St.length>0)&&this._edits.push({_type:5,uri:O,index:at,count:ct-at,cells:St,metadata:Pt})}replaceNotebookCellMetadata(O,J,_e,qe){this._edits.push({_type:3,metadata:qe,uri:O,edit:{editType:8,index:J,metadata:_e}})}replace(O,J,_e,qe){typeof _e=="string"?this._edits.push({_type:2,uri:O,edit:new fe(J,_e),metadata:qe}):this._edits.push({_type:6,uri:O,range:J,edit:_e,metadata:qe})}insert(O,J,_e,qe){this.replace(O,new K(J,J),_e,qe)}delete(O,J,_e){this.replace(O,J,"",_e)}has(O){return this._edits.some(J=>J._type===2&&J.uri.toString()===O.toString())}set(O,J){if(J)for(const _e of J)_e&&(ie.isNotebookCellEdit(_e)?_e.newCellMetadata?this.replaceNotebookCellMetadata(O,_e.range.start,_e.newCellMetadata):_e.newNotebookMetadata?this.replaceNotebookMetadata(O,_e.newNotebookMetadata):this.replaceNotebookCells(O,_e.range,_e.newCells):this._edits.push({_type:2,uri:O,edit:_e}));else{for(let _e=0;_e<this._edits.length;_e++){const qe=this._edits[_e];qe._type===2&&qe.uri.toString()===O.toString()&&(this._edits[_e]=void 0)}(0,o.coalesceInPlace)(this._edits)}}get(O){const J=[];for(const _e of this._edits)_e._type===2&&_e.uri.toString()===O.toString()&&J.push(_e.edit);return J}entries(){const O=new L.ResourceMap;for(const J of this._edits)if(J._type===2){let _e=O.get(J.uri);_e||(_e=[J.uri,[]],O.set(J.uri,_e)),_e[1].push(J.edit)}return[...O.values()]}get size(){return this.entries().length}toJSON(){return this.entries()}};be=ze([z],be),e.WorkspaceEdit=be;let ee=n=class{constructor(O){this._tabstop=1,this.value=O||""}static isSnippetString(O){return O instanceof n?!0:O?typeof O.value=="string":!1}static _escape(O){return O.replace(/\$|}|\\/g,"\\$&")}appendText(O){return this.value+=n._escape(O),this}appendTabstop(O=this._tabstop++){return this.value+="$",this.value+=O,this}appendPlaceholder(O,J=this._tabstop++){if(typeof O=="function"){const _e=new n;_e._tabstop=this._tabstop,O(_e),this._tabstop=_e._tabstop,O=_e.value}else O=n._escape(O);return this.value+="${",this.value+=J,this.value+=":",this.value+=O,this.value+="}",this}appendChoice(O,J=this._tabstop++){const _e=O.map(qe=>qe.replace(/\$|}|\\|,/g,"\\$&")).join(",");return this.value+="${",this.value+=J,this.value+="|",this.value+=_e,this.value+="|}",this}appendVariable(O,J){if(typeof J=="function"){const _e=new n;_e._tabstop=this._tabstop,J(_e),this._tabstop=_e._tabstop,J=_e.value}else typeof J=="string"&&(J=J.replace(/\$|}/g,"\\$&"));return this.value+="${",this.value+=O,J&&(this.value+=":",this.value+=J),this.value+="}",this}};ee=n=ze([z],ee),e.SnippetString=ee;var ve;(function(x){x[x.Unnecessary=1]="Unnecessary",x[x.Deprecated=2]="Deprecated"})(ve=e.DiagnosticTag||(e.DiagnosticTag={}));var Ae;(function(x){x[x.Hint=3]="Hint",x[x.Information=2]="Information",x[x.Warning=1]="Warning",x[x.Error=0]="Error"})(Ae=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));let Fe=i=class{constructor(O,J){if(this.uri=O,J)if(K.isRange(J))this.range=K.of(J);else if(N.isPosition(J))this.range=new K(J,J);else throw new Error("Illegal argument")}static isLocation(O){return O instanceof i?!0:O?K.isRange(O.range)&&P.URI.isUri(O.uri):!1}toJSON(){return{uri:this.uri,range:this.range}}};Fe=i=ze([z],Fe),e.Location=Fe;let $e=class{constructor(O,J){this.location=O,this.message=J}static is(O){return O?typeof O.message=="string"&&O.location&&K.isRange(O.location.range)&&P.URI.isUri(O.location.uri):!1}static isEqual(O,J){return O===J?!0:!O||!J?!1:O.message===J.message&&O.location.range.isEqual(J.location.range)&&O.location.uri.toString()===J.location.uri.toString()}};$e=ze([z],$e),e.DiagnosticRelatedInformation=$e;let Qe=class{constructor(O,J,_e=Ae.Error){if(!K.isRange(O))throw new TypeError("range must be set");if(!J)throw new TypeError("message must be set");this.range=O,this.message=J,this.severity=_e}toJSON(){return{severity:Ae[this.severity],message:this.message,range:this.range,source:this.source,code:this.code}}static isEqual(O,J){return O===J?!0:!O||!J?!1:O.message===J.message&&O.severity===J.severity&&O.code===J.code&&O.severity===J.severity&&O.source===J.source&&O.range.isEqual(J.range)&&(0,o.equals)(O.tags,J.tags)&&(0,o.equals)(O.relatedInformation,J.relatedInformation,$e.isEqual)}};Qe=ze([z],Qe),e.Diagnostic=Qe;let Ie=class{constructor(O,J){if(!O)throw new Error("Illegal argument, contents must be defined");Array.isArray(O)?this.contents=O:this.contents=[O],this.range=J}};Ie=ze([z],Ie),e.Hover=Ie;var Se;(function(x){x[x.Text=0]="Text",x[x.Read=1]="Read",x[x.Write=2]="Write"})(Se=e.DocumentHighlightKind||(e.DocumentHighlightKind={}));let Te=class{constructor(O,J=Se.Text){this.range=O,this.kind=J}toJSON(){return{range:this.range,kind:Se[this.kind]}}};Te=ze([z],Te),e.DocumentHighlight=Te;var ae;(function(x){x[x.File=0]="File",x[x.Module=1]="Module",x[x.Namespace=2]="Namespace",x[x.Package=3]="Package",x[x.Class=4]="Class",x[x.Method=5]="Method",x[x.Property=6]="Property",x[x.Field=7]="Field",x[x.Constructor=8]="Constructor",x[x.Enum=9]="Enum",x[x.Interface=10]="Interface",x[x.Function=11]="Function",x[x.Variable=12]="Variable",x[x.Constant=13]="Constant",x[x.String=14]="String",x[x.Number=15]="Number",x[x.Boolean=16]="Boolean",x[x.Array=17]="Array",x[x.Object=18]="Object",x[x.Key=19]="Key",x[x.Null=20]="Null",x[x.EnumMember=21]="EnumMember",x[x.Struct=22]="Struct",x[x.Event=23]="Event",x[x.Operator=24]="Operator",x[x.TypeParameter=25]="TypeParameter"})(ae=e.SymbolKind||(e.SymbolKind={}));var le;(function(x){x[x.Deprecated=1]="Deprecated"})(le=e.SymbolTag||(e.SymbolTag={}));let X=r=class{constructor(O,J,_e,qe,tt){this.name=O,this.kind=J,this.containerName=tt,typeof _e=="string"&&(this.containerName=_e),qe instanceof Fe?this.location=qe:_e instanceof K&&(this.location=new Fe(qe,_e)),r.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy")}toJSON(){return{name:this.name,kind:ae[this.kind],location:this.location,containerName:this.containerName}}};X=r=ze([z],X),e.SymbolInformation=X;let Y=t=class{constructor(O,J,_e,qe,tt){this.name=O,this.detail=J,this.kind=_e,this.range=qe,this.selectionRange=tt,this.children=[],t.validate(this)}static validate(O){if(!O.name)throw new Error("name must not be falsy");if(!O.range.contains(O.selectionRange))throw new Error("selectionRange must be contained in fullRange");O.children?.forEach(t.validate)}};Y=t=ze([z],Y),e.DocumentSymbol=Y;var k;(function(x){x[x.Invoke=1]="Invoke",x[x.Automatic=2]="Automatic"})(k=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));let B=class{constructor(O,J){this.title=O,this.kind=J}};B=ze([z],B),e.CodeAction=B;let H=c=class{constructor(O){this.value=O}append(O){return new c(this.value?this.value+c.sep+O:O)}intersects(O){return this.contains(O)||O.contains(this)}contains(O){return this.value===O.value||O.value.startsWith(this.value+c.sep)}};H.sep=".",H=c=ze([z],H),e.CodeActionKind=H,H.Empty=new H(""),H.QuickFix=H.Empty.append("quickfix"),H.Refactor=H.Empty.append("refactor"),H.RefactorExtract=H.Refactor.append("extract"),H.RefactorInline=H.Refactor.append("inline"),H.RefactorRewrite=H.Refactor.append("rewrite"),H.Source=H.Empty.append("source"),H.SourceOrganizeImports=H.Source.append("organizeImports"),H.SourceFixAll=H.Source.append("fixAll");let j=class{constructor(O,J){if(this.range=O,this.parent=J,J&&!J.range.contains(this.range))throw new Error("Invalid argument: parent must contain this range")}};j=ze([z],j),e.SelectionRange=j;class oe{constructor(O,J,_e,qe,tt,at){this.kind=O,this.name=J,this.detail=_e,this.uri=qe,this.range=tt,this.selectionRange=at}}e.CallHierarchyItem=oe;class ue{constructor(O,J){this.fromRanges=J,this.from=O}}e.CallHierarchyIncomingCall=ue;class Z{constructor(O,J){this.fromRanges=J,this.to=O}}e.CallHierarchyOutgoingCall=Z;var pe;(function(x){x[x.Information=0]="Information",x[x.Warning=1]="Warning",x[x.Error=2]="Error"})(pe=e.LanguageStatusSeverity||(e.LanguageStatusSeverity={}));let ge=class{constructor(O,J){this.range=O,this.command=J}get isResolved(){return!!this.command}};ge=ze([z],ge),e.CodeLens=ge;let Ne=w=class{constructor(O,J=!1){f.set(this,void 0),Je(this,f,new b.MarkdownString(O,{supportThemeIcons:J}),"f")}static isMarkdownString(O){return O instanceof w?!0:O&&O.appendCodeblock&&O.appendMarkdown&&O.appendText&&O.value!==void 0}get value(){return Oe(this,f,"f").value}set value(O){Oe(this,f,"f").value=O}get isTrusted(){return Oe(this,f,"f").isTrusted}set isTrusted(O){Oe(this,f,"f").isTrusted=O}get supportThemeIcons(){return Oe(this,f,"f").supportThemeIcons}set supportThemeIcons(O){Oe(this,f,"f").supportThemeIcons=O}get supportHtml(){return Oe(this,f,"f").supportHtml}set supportHtml(O){Oe(this,f,"f").supportHtml=O}get baseUri(){return Oe(this,f,"f").baseUri}set baseUri(O){Oe(this,f,"f").baseUri=O}appendText(O){return Oe(this,f,"f").appendText(O),this}appendMarkdown(O){return Oe(this,f,"f").appendMarkdown(O),this}appendCodeblock(O,J){return Oe(this,f,"f").appendCodeblock(J??"",O),this}};f=new WeakMap,Ne=w=ze([z],Ne),e.MarkdownString=Ne;let Be=class{constructor(O,J){this.label=O,this.documentation=J}};Be=ze([z],Be),e.ParameterInformation=Be;let Ze=class{constructor(O,J){this.label=O,this.documentation=J,this.parameters=[]}};Ze=ze([z],Ze),e.SignatureInformation=Ze;let Ge=class{constructor(){this.activeSignature=0,this.activeParameter=0,this.signatures=[]}};Ge=ze([z],Ge),e.SignatureHelp=Ge;var ke;(function(x){x[x.Invoke=1]="Invoke",x[x.TriggerCharacter=2]="TriggerCharacter",x[x.ContentChange=3]="ContentChange"})(ke=e.SignatureHelpTriggerKind||(e.SignatureHelpTriggerKind={}));var nt;(function(x){x[x.Type=1]="Type",x[x.Parameter=2]="Parameter"})(nt=e.InlayHintKind||(e.InlayHintKind={}));let G=class{constructor(O){this.value=O}};G=ze([z],G),e.InlayHintLabelPart=G;let Q=class{constructor(O,J,_e){this.position=O,this.label=J,this.kind=_e}};Q=ze([z],Q),e.InlayHint=Q;var he;(function(x){x[x.Invoke=0]="Invoke",x[x.TriggerCharacter=1]="TriggerCharacter",x[x.TriggerForIncompleteCompletions=2]="TriggerForIncompleteCompletions"})(he=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var Ue;(function(x){x[x.Text=0]="Text",x[x.Method=1]="Method",x[x.Function=2]="Function",x[x.Constructor=3]="Constructor",x[x.Field=4]="Field",x[x.Variable=5]="Variable",x[x.Class=6]="Class",x[x.Interface=7]="Interface",x[x.Module=8]="Module",x[x.Property=9]="Property",x[x.Unit=10]="Unit",x[x.Value=11]="Value",x[x.Enum=12]="Enum",x[x.Keyword=13]="Keyword",x[x.Snippet=14]="Snippet",x[x.Color=15]="Color",x[x.File=16]="File",x[x.Reference=17]="Reference",x[x.Folder=18]="Folder",x[x.EnumMember=19]="EnumMember",x[x.Constant=20]="Constant",x[x.Struct=21]="Struct",x[x.Event=22]="Event",x[x.Operator=23]="Operator",x[x.TypeParameter=24]="TypeParameter",x[x.User=25]="User",x[x.Issue=26]="Issue"})(Ue=e.CompletionItemKind||(e.CompletionItemKind={}));var We;(function(x){x[x.Deprecated=1]="Deprecated"})(We=e.CompletionItemTag||(e.CompletionItemTag={}));let et=class{constructor(O,J){this.label=O,this.kind=J}toJSON(){return{label:this.label,kind:this.kind&&Ue[this.kind],detail:this.detail,documentation:this.documentation,sortText:this.sortText,filterText:this.filterText,preselect:this.preselect,insertText:this.insertText,textEdit:this.textEdit}}};et=ze([z],et),e.CompletionItem=et;let je=class{constructor(O=[],J=!1){this.items=O,this.isIncomplete=J}};je=ze([z],je),e.CompletionList=je;let He=class{constructor(O,J,_e){this.insertText=O,this.range=J,this.command=_e}};He=ze([z],He),e.InlineSuggestion=He;let it=class{constructor(O){this.commands=void 0,this.items=O}};it=ze([z],it),e.InlineSuggestionList=it;let rt=class{constructor(O,J,_e){this.insertText=O,this.range=J,this.command=_e}};rt=ze([z],rt),e.InlineSuggestionNew=rt;let dt=class{constructor(O,J){this.items=O,this.commands=J}};dt=ze([z],dt),e.InlineSuggestionsNew=dt;var lt;(function(x){x[x.Active=-1]="Active",x[x.Beside=-2]="Beside",x[x.One=1]="One",x[x.Two=2]="Two",x[x.Three=3]="Three",x[x.Four=4]="Four",x[x.Five=5]="Five",x[x.Six=6]="Six",x[x.Seven=7]="Seven",x[x.Eight=8]="Eight",x[x.Nine=9]="Nine"})(lt=e.ViewColumn||(e.ViewColumn={}));var st;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(st=e.StatusBarAlignment||(e.StatusBarAlignment={}));var yt;(function(x){x[x.Off=0]="Off",x[x.On=1]="On",x[x.Relative=2]="Relative"})(yt=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ot;(function(x){x[x.Manual=1]="Manual",x[x.AfterDelay=2]="AfterDelay",x[x.FocusOut=3]="FocusOut"})(Ot=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ft;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(Ft=e.TextEditorRevealType||(e.TextEditorRevealType={}));var ft;(function(x){x[x.Keyboard=1]="Keyboard",x[x.Mouse=2]="Mouse",x[x.Command=3]="Command"})(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));var Dt;(function(x){x[x.Undo=1]="Undo",x[x.Redo=2]="Redo"})(Dt=e.TextDocumentChangeReason||(e.TextDocumentChangeReason={}));var Ut;(function(x){x[x.OpenOpen=0]="OpenOpen",x[x.ClosedClosed=1]="ClosedClosed",x[x.OpenClosed=2]="OpenClosed",x[x.ClosedOpen=3]="ClosedOpen"})(Ut=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={})),function(x){function O(J){switch(J){case"keyboard":return x.Keyboard;case"mouse":return x.Mouse;case"api":return x.Command}}x.fromValue=O}(ft=e.TextEditorSelectionChangeKind||(e.TextEditorSelectionChangeKind={}));let Nt=class{constructor(O,J){if(J&&!P.URI.isUri(J))throw(0,p.illegalArgument)("target");if(!K.isRange(O)||O.isEmpty)throw(0,p.illegalArgument)("range");this.range=O,this.target=J}};Nt=ze([z],Nt),e.DocumentLink=Nt;let Ve=class{constructor(O,J,_e,qe){this.red=O,this.green=J,this.blue=_e,this.alpha=qe}};Ve=ze([z],Ve),e.Color=Ve;let Mt=class{constructor(O,J){if(J&&!(J instanceof Ve))throw(0,p.illegalArgument)("color");if(!K.isRange(O)||O.isEmpty)throw(0,p.illegalArgument)("range");this.range=O,this.color=J}};Mt=ze([z],Mt),e.ColorInformation=Mt;let At=class{constructor(O){if(!O||typeof O!="string")throw(0,p.illegalArgument)("label");this.label=O}};At=ze([z],At),e.ColorPresentation=At;var Lt;(function(x){x[x.RGB=0]="RGB",x[x.HEX=1]="HEX",x[x.HSL=2]="HSL"})(Lt=e.ColorFormat||(e.ColorFormat={}));var gt;(function(x){x[x.Error=0]="Error",x[x.Warning=1]="Warning",x[x.Information=2]="Information"})(gt=e.SourceControlInputBoxValidationType||(e.SourceControlInputBoxValidationType={}));var It;(function(x){x[x.Unknown=0]="Unknown",x[x.Shutdown=1]="Shutdown",x[x.Process=2]="Process",x[x.User=3]="User",x[x.Extension=4]="Extension"})(It=e.TerminalExitReason||(e.TerminalExitReason={}));class we{constructor(O,J,_e){if(this.startIndex=O,this.length=J,this.tooltip=_e,typeof O!="number"||O<0)throw(0,p.illegalArgument)("startIndex");if(typeof J!="number"||J<1)throw(0,p.illegalArgument)("length");if(_e!==void 0&&typeof _e!="string")throw(0,p.illegalArgument)("tooltip")}}e.TerminalLink=we;var ye;(function(x){x[x.Panel=1]="Panel",x[x.Editor=2]="Editor"})(ye=e.TerminalLocation||(e.TerminalLocation={}));class me{constructor(O){if(this.options=O,typeof O!="object")throw(0,p.illegalArgument)("options")}}e.TerminalProfile=me;var q;(function(x){x[x.Always=1]="Always",x[x.Silent=2]="Silent",x[x.Never=3]="Never"})(q=e.TaskRevealKind||(e.TaskRevealKind={}));var Pe;(function(x){x[x.Shared=1]="Shared",x[x.Dedicated=2]="Dedicated",x[x.New=3]="New"})(Pe=e.TaskPanelKind||(e.TaskPanelKind={}));let Le=g=class{constructor(O,J){if(this.label=J,typeof O!="string"||typeof J!="string")throw(0,p.illegalArgument)("name");this._id=O}static from(O){switch(O){case"clean":return g.Clean;case"build":return g.Build;case"rebuild":return g.Rebuild;case"test":return g.Test;default:return}}get id(){return this._id}};Le.Clean=new g("clean","Clean"),Le.Build=new g("build","Build"),Le.Rebuild=new g("rebuild","Rebuild"),Le.Test=new g("test","Test"),Le=g=ze([z],Le),e.TaskGroup=Le;function Ye(x){let O="";for(let J=0;J<x.length;J++)O+=x[J].replace(/,/g,",,")+",";return O}let Xe=class{constructor(O,J,_e){if(typeof O!="string")throw(0,p.illegalArgument)("process");this._args=[],this._process=O,J!==void 0&&(Array.isArray(J)?(this._args=J,this._options=_e):this._options=J)}get process(){return this._process}set process(O){if(typeof O!="string")throw(0,p.illegalArgument)("process");this._process=O}get args(){return this._args}set args(O){Array.isArray(O)||(O=[]),this._args=O}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("process"),this._process!==void 0&&O.push(this._process),this._args&&this._args.length>0)for(const J of this._args)O.push(J);return Ye(O)}};Xe=ze([z],Xe),e.ProcessExecution=Xe;let Ke=class{constructor(O,J,_e){if(this._args=[],Array.isArray(J)){if(!O)throw(0,p.illegalArgument)("command can't be undefined or null");if(typeof O!="string"&&typeof O.value!="string")throw(0,p.illegalArgument)("command");this._command=O,this._args=J,this._options=_e}else{if(typeof O!="string")throw(0,p.illegalArgument)("commandLine");this._commandLine=O,this._options=J}}get commandLine(){return this._commandLine}set commandLine(O){if(typeof O!="string")throw(0,p.illegalArgument)("commandLine");this._commandLine=O}get command(){return this._command?this._command:""}set command(O){if(typeof O!="string"&&typeof O.value!="string")throw(0,p.illegalArgument)("command");this._command=O}get args(){return this._args}set args(O){this._args=O||[]}get options(){return this._options}set options(O){this._options=O}computeId(){const O=[];if(O.push("shell"),this._commandLine!==void 0&&O.push(this._commandLine),this._command!==void 0&&O.push(typeof this._command=="string"?this._command:this._command.value),this._args&&this._args.length>0)for(const J of this._args)O.push(typeof J=="string"?J:J.value);return Ye(O)}};Ke=ze([z],Ke),e.ShellExecution=Ke;var pt;(function(x){x[x.Escape=1]="Escape",x[x.Strong=2]="Strong",x[x.Weak=3]="Weak"})(pt=e.ShellQuoting||(e.ShellQuoting={}));var bt;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace"})(bt=e.TaskScope||(e.TaskScope={}));class kt{constructor(O){this._callback=O}computeId(){return"customExecution"+(0,R.generateUuid)()}set callback(O){this._callback=O}get callback(){return this._callback}}e.CustomExecution=kt;let Et=C=class{constructor(O,J,_e,qe,tt,at){this.__deprecated=!1,this._definition=this.definition=O;let ct;typeof J=="string"?(this._name=this.name=J,this._source=this.source=_e,this.execution=qe,ct=tt,this.__deprecated=!0):J===bt.Global||J===bt.Workspace?(this.target=J,this._name=this.name=_e,this._source=this.source=qe,this.execution=tt,ct=at):(this.target=J,this._name=this.name=_e,this._source=this.source=qe,this.execution=tt,ct=at),typeof ct=="string"?(this._problemMatchers=[ct],this._hasDefinedMatchers=!0):Array.isArray(ct)?(this._problemMatchers=ct,this._hasDefinedMatchers=!0):(this._problemMatchers=[],this._hasDefinedMatchers=!1),this._isBackground=!1,this._presentationOptions=Object.create(null),this._runOptions=Object.create(null)}get _id(){return this.__id}set _id(O){this.__id=O}get _deprecated(){return this.__deprecated}clear(){this.__id!==void 0&&(this.__id=void 0,this._scope=void 0,this.computeDefinitionBasedOnExecution())}computeDefinitionBasedOnExecution(){this._execution instanceof Xe?this._definition={type:C.ProcessType,id:this._execution.computeId()}:this._execution instanceof Ke?this._definition={type:C.ShellType,id:this._execution.computeId()}:this._execution instanceof kt?this._definition={type:C.ExtensionCallbackType,id:this._execution.computeId()}:this._definition={type:C.EmptyType,id:(0,R.generateUuid)()}}get definition(){return this._definition}set definition(O){if(O==null)throw(0,p.illegalArgument)("Kind can't be undefined or null");this.clear(),this._definition=O}get scope(){return this._scope}set target(O){this.clear(),this._scope=O}get name(){return this._name}set name(O){if(typeof O!="string")throw(0,p.illegalArgument)("name");this.clear(),this._name=O}get execution(){return this._execution}set execution(O){O===null&&(O=void 0),this.clear(),this._execution=O;const J=this._definition.type;(C.EmptyType===J||C.ProcessType===J||C.ShellType===J||C.ExtensionCallbackType===J)&&this.computeDefinitionBasedOnExecution()}get problemMatchers(){return this._problemMatchers}set problemMatchers(O){if(Array.isArray(O))this.clear(),this._problemMatchers=O,this._hasDefinedMatchers=!0;else{this.clear(),this._problemMatchers=[],this._hasDefinedMatchers=!1;return}}get hasDefinedMatchers(){return this._hasDefinedMatchers}get isBackground(){return this._isBackground}set isBackground(O){O!==!0&&O!==!1&&(O=!1),this.clear(),this._isBackground=O}get source(){return this._source}set source(O){if(typeof O!="string"||O.length===0)throw(0,p.illegalArgument)("source must be a string of length > 0");this.clear(),this._source=O}get group(){return this._group}set group(O){O===null&&(O=void 0),this.clear(),this._group=O}get detail(){return this._detail}set detail(O){O===null&&(O=void 0),this._detail=O}get presentationOptions(){return this._presentationOptions}set presentationOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._presentationOptions=O}get runOptions(){return this._runOptions}set runOptions(O){O==null&&(O=Object.create(null)),this.clear(),this._runOptions=O}};Et.ExtensionCallbackType="customExecution",Et.ProcessType="process",Et.ShellType="shell",Et.EmptyType="$empty",Et=C=ze([z],Et),e.Task=Et;var ht;(function(x){x[x.SourceControl=1]="SourceControl",x[x.Window=10]="Window",x[x.Notification=15]="Notification"})(ht=e.ProgressLocation||(e.ProgressLocation={}));let Rt=U=class{constructor(O,J=_t.None){this.collapsibleState=J,P.URI.isUri(O)?this.resourceUri=O:this.label=O}static isTreeItem(O){if(O instanceof U)return!0;const J=O;return J.label!==void 0&&!(0,E.isString)(J.label)&&!J.label.label?(console.log("INVALID tree item, invalid label",J.label),!1):J.id!==void 0&&!(0,E.isString)(J.id)?(console.log("INVALID tree item, invalid id",J.id),!1):J.iconPath!==void 0&&!(0,E.isString)(J.iconPath)&&!P.URI.isUri(J.iconPath)&&!(0,E.isString)(J.iconPath.id)?(console.log("INVALID tree item, invalid iconPath",J.iconPath),!1):J.description!==void 0&&!(0,E.isString)(J.description)&&typeof J.description!="boolean"?(console.log("INVALID tree item, invalid description",J.description),!1):J.resourceUri!==void 0&&!P.URI.isUri(J.resourceUri)?(console.log("INVALID tree item, invalid resourceUri",J.resourceUri),!1):J.tooltip!==void 0&&!(0,E.isString)(J.tooltip)&&!(J.tooltip instanceof Ne)?(console.log("INVALID tree item, invalid tooltip",J.tooltip),!1):J.command!==void 0&&!J.command.command?(console.log("INVALID tree item, invalid command",J.command),!1):J.collapsibleState!==void 0&&J.collapsibleState<_t.None&&J.collapsibleState>_t.Expanded?(console.log("INVALID tree item, invalid collapsibleState",J.collapsibleState),!1):J.contextValue!==void 0&&!(0,E.isString)(J.contextValue)?(console.log("INVALID tree item, invalid contextValue",J.contextValue),!1):J.accessibilityInformation!==void 0&&!J.accessibilityInformation.label?(console.log("INVALID tree item, invalid accessibilityInformation",J.accessibilityInformation),!1):!0}};Rt=U=ze([z],Rt),e.TreeItem=Rt;var _t;(function(x){x[x.None=0]="None",x[x.Collapsed=1]="Collapsed",x[x.Expanded=2]="Expanded"})(_t=e.TreeItemCollapsibleState||(e.TreeItemCollapsibleState={}));let vt=class{constructor(O){this.value=O}async asString(){return typeof this.value=="string"?this.value:JSON.stringify(this.value)}asFile(){}};vt=ze([z],vt),e.DataTransferItem=vt;let Gt=class{constructor(O){h.set(this,new Map);for(const[J,_e]of O??[]){const qe=Oe(this,h,"f").get(J);qe?qe.push(_e):Oe(this,h,"f").set(J,[_e])}}get(O){return Oe(this,h,"f").get(O)?.[0]}set(O,J){Oe(this,h,"f").set(O,[J])}forEach(O,J){for(const[_e,qe]of Oe(this,h,"f"))for(const tt of qe)O.call(J,tt,_e,this)}*[(h=new WeakMap,Symbol.iterator)](){for(const[O,J]of Oe(this,h,"f"))for(const _e of J)yield[O,_e]}};Gt=ze([z],Gt),e.DataTransfer=Gt;let Xt=class{constructor(O){this.insertText=O}};Xt=ze([z],Xt),e.DocumentDropEdit=Xt;let Ht=class{constructor(O){this.insertText=O}};Ht=ze([z],Ht),e.DocumentPasteEdit=Ht;let Vt=class{constructor(O,J){this.id=O,this.color=J}};Vt=ze([z],Vt),e.ThemeIcon=Vt,Vt.File=new Vt("file"),Vt.Folder=new Vt("folder");let Tt=class{constructor(O){this.id=O}};Tt=ze([z],Tt),e.ThemeColor=Tt;var _i;(function(x){x[x.Global=1]="Global",x[x.Workspace=2]="Workspace",x[x.WorkspaceFolder=3]="WorkspaceFolder"})(_i=e.ConfigurationTarget||(e.ConfigurationTarget={}));let hi=class{constructor(O,J){if(typeof O!="string"&&(!O||!P.URI.isUri(O)&&!P.URI.isUri(O.uri)))throw(0,p.illegalArgument)("base");if(typeof J!="string")throw(0,p.illegalArgument)("pattern");typeof O=="string"?this.baseUri=P.URI.file(O):P.URI.isUri(O)?this.baseUri=O:this.baseUri=O.uri,this.pattern=J}get base(){return this._base}set base(O){this._base=O,this._baseUri=P.URI.file(O)}get baseUri(){return this._baseUri}set baseUri(O){this._baseUri=O,this._base=O.fsPath}toJSON(){return{pattern:this.pattern,base:this.base,baseUri:this.baseUri.toJSON()}}};hi=ze([z],hi),e.RelativePattern=hi;let zt=class{constructor(O,J,_e,qe){this.enabled=typeof O=="boolean"?O:!0,typeof J=="string"&&(this.condition=J),typeof _e=="string"&&(this.hitCondition=_e),typeof qe=="string"&&(this.logMessage=qe)}get id(){return this._id||(this._id=(0,R.generateUuid)()),this._id}};zt=ze([z],zt),e.Breakpoint=zt;let ei=class extends zt{constructor(O,J,_e,qe,tt){super(J,_e,qe,tt);if(O===null)throw(0,p.illegalArgument)("location");this.location=O}};ei=ze([z],ei),e.SourceBreakpoint=ei;let ut=class extends zt{constructor(O,J,_e,qe,tt){super(J,_e,qe,tt);this.functionName=O}};ut=ze([z],ut),e.FunctionBreakpoint=ut;let fi=class extends zt{constructor(O,J,_e,qe,tt,at,ct){super(qe,tt,at,ct);if(!J)throw(0,p.illegalArgument)("dataId");this.label=O,this.dataId=J,this.canPersist=_e}};fi=ze([z],fi),e.DataBreakpoint=fi;let xt=class{constructor(O,J,_e){this.command=O,this.args=J||[],this.options=_e}};xt=ze([z],xt),e.DebugAdapterExecutable=xt;let Qt=class{constructor(O,J){this.port=O,this.host=J}};Qt=ze([z],Qt),e.DebugAdapterServer=Qt;let ri=class{constructor(O){this.path=O}};ri=ze([z],ri),e.DebugAdapterNamedPipeServer=ri;let mi=class{constructor(O){this.implementation=O}};mi=ze([z],mi),e.DebugAdapterInlineImplementation=mi;let si=class{constructor(O,J){this.range=O,this.expression=J}};si=ze([z],si),e.EvaluatableExpression=si;var Ti;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Ti=e.InlineCompletionTriggerKind||(e.InlineCompletionTriggerKind={}));var Si;(function(x){x[x.Invoke=0]="Invoke",x[x.Automatic=1]="Automatic"})(Si=e.InlineCompletionTriggerKindNew||(e.InlineCompletionTriggerKindNew={}));let ti=class{constructor(O,J){this.range=O,this.text=J}};ti=ze([z],ti),e.InlineValueText=ti;let gi=class{constructor(O,J,_e=!0){this.range=O,this.variableName=J,this.caseSensitiveLookup=_e}};gi=ze([z],gi),e.InlineValueVariableLookup=gi;let ii=class{constructor(O,J){this.range=O,this.expression=J}};ii=ze([z],ii),e.InlineValueEvaluatableExpression=ii;let ni=class{constructor(O,J){this.frameId=O,this.stoppedLocation=J}};ni=ze([z],ni),e.InlineValueContext=ni;var Pi;(function(x){x[x.Changed=1]="Changed",x[x.Created=2]="Created",x[x.Deleted=3]="Deleted"})(Pi=e.FileChangeType||(e.FileChangeType={}));let pi=W=class extends Error{constructor(O,J=y.FileSystemProviderErrorCode.Unknown,_e){super(P.URI.isUri(O)?O.toString(!0):O);this.code=_e?.name??"Unknown",(0,y.markAsFileSystemProviderError)(this,J),typeof Object.setPrototypeOf=="function"&&Object.setPrototypeOf(this,W.prototype),typeof Error.captureStackTrace=="function"&&typeof _e=="function"&&Error.captureStackTrace(this,_e)}static FileExists(O){return new W(O,y.FileSystemProviderErrorCode.FileExists,W.FileExists)}static FileNotFound(O){return new W(O,y.FileSystemProviderErrorCode.FileNotFound,W.FileNotFound)}static FileNotADirectory(O){return new W(O,y.FileSystemProviderErrorCode.FileNotADirectory,W.FileNotADirectory)}static FileIsADirectory(O){return new W(O,y.FileSystemProviderErrorCode.FileIsADirectory,W.FileIsADirectory)}static NoPermissions(O){return new W(O,y.FileSystemProviderErrorCode.NoPermissions,W.NoPermissions)}static Unavailable(O){return new W(O,y.FileSystemProviderErrorCode.Unavailable,W.Unavailable)}};pi=W=ze([z],pi),e.FileSystemError=pi;let Yt=class{constructor(O,J,_e){this.start=O,this.end=J,this.kind=_e}};Yt=ze([z],Yt),e.FoldingRange=Yt;var Ai;(function(x){x[x.Comment=1]="Comment",x[x.Imports=2]="Imports",x[x.Region=3]="Region"})(Ai=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Ri;(function(x){x[x.Collapsed=0]="Collapsed",x[x.Expanded=1]="Expanded"})(Ri=e.CommentThreadCollapsibleState||(e.CommentThreadCollapsibleState={}));var Oi;(function(x){x[x.Editing=0]="Editing",x[x.Preview=1]="Preview"})(Oi=e.CommentMode||(e.CommentMode={}));var Fi;(function(x){x[x.Unresolved=0]="Unresolved",x[x.Resolved=1]="Resolved"})(Fi=e.CommentThreadState||(e.CommentThreadState={}));class vi{constructor(O,J=[]){this.tokenTypes=O,this.tokenModifiers=J}}e.SemanticTokensLegend=vi;function yi(x){return typeof x=="undefined"||(0,E.isStringArray)(x)}class oi{constructor(O){if(this._prevLine=0,this._prevChar=0,this._dataIsSortedAndDeltaEncoded=!0,this._data=[],this._dataLen=0,this._tokenTypeStrToInt=new Map,this._tokenModifierStrToInt=new Map,this._hasLegend=!1,O){this._hasLegend=!0;for(let J=0,_e=O.tokenTypes.length;J<_e;J++)this._tokenTypeStrToInt.set(O.tokenTypes[J],J);for(let J=0,_e=O.tokenModifiers.length;J<_e;J++)this._tokenModifierStrToInt.set(O.tokenModifiers[J],J)}}push(O,J,_e,qe,tt){if(typeof O=="number"&&typeof J=="number"&&typeof _e=="number"&&typeof qe=="number"&&(typeof tt=="number"||typeof tt=="undefined"))return typeof tt=="undefined"&&(tt=0),this._pushEncoded(O,J,_e,qe,tt);if(K.isRange(O)&&typeof J=="string"&&yi(_e))return this._push(O,J,_e);throw(0,p.illegalArgument)()}_push(O,J,_e){if(!this._hasLegend)throw new Error("Legend must be provided in constructor");if(O.start.line!==O.end.line)throw new Error("`range` cannot span multiple lines");if(!this._tokenTypeStrToInt.has(J))throw new Error("`tokenType` is not in the provided legend");const qe=O.start.line,tt=O.start.character,at=O.end.character-O.start.character,ct=this._tokenTypeStrToInt.get(J);let St=0;if(_e)for(const Pt of _e){if(!this._tokenModifierStrToInt.has(Pt))throw new Error("`tokenModifier` is not in the provided legend");const Wt=this._tokenModifierStrToInt.get(Pt);St|=1<<Wt>>>0}this._pushEncoded(qe,tt,at,ct,St)}_pushEncoded(O,J,_e,qe,tt){if(this._dataIsSortedAndDeltaEncoded&&(O<this._prevLine||O===this._prevLine&&J<this._prevChar)){this._dataIsSortedAndDeltaEncoded=!1;const St=this._data.length/5|0;let Pt=0,Wt=0;for(let Kt=0;Kt<St;Kt++){let Jt=this._data[5*Kt],bi=this._data[5*Kt+1];Jt===0?(Jt=Pt,bi+=Wt):Jt+=Pt,this._data[5*Kt]=Jt,this._data[5*Kt+1]=bi,Pt=Jt,Wt=bi}}let at=O,ct=J;this._dataIsSortedAndDeltaEncoded&&this._dataLen>0&&(at-=this._prevLine,at===0&&(ct-=this._prevChar)),this._data[this._dataLen++]=at,this._data[this._dataLen++]=ct,this._data[this._dataLen++]=_e,this._data[this._dataLen++]=qe,this._data[this._dataLen++]=tt,this._prevLine=O,this._prevChar=J}static _sortAndDeltaEncode(O){const J=[],_e=O.length/5|0;for(let ct=0;ct<_e;ct++)J[ct]=ct;J.sort((ct,St)=>{const Pt=O[5*ct],Wt=O[5*St];if(Pt===Wt){const Kt=O[5*ct+1],Jt=O[5*St+1];return Kt-Jt}return Pt-Wt});const qe=new Uint32Array(O.length);let tt=0,at=0;for(let ct=0;ct<_e;ct++){const St=5*J[ct],Pt=O[St+0],Wt=O[St+1],Kt=O[St+2],Jt=O[St+3],bi=O[St+4],Gi=Pt-tt,bn=Gi===0?Wt-at:Wt,wi=5*ct;qe[wi+0]=Gi,qe[wi+1]=bn,qe[wi+2]=Kt,qe[wi+3]=Jt,qe[wi+4]=bi,tt=Pt,at=Wt}return qe}build(O){return this._dataIsSortedAndDeltaEncoded?new Me(new Uint32Array(this._data),O):new Me(oi._sortAndDeltaEncode(this._data),O)}}e.SemanticTokensBuilder=oi;class Me{constructor(O,J){this.resultId=J,this.data=O}}e.SemanticTokens=Me;class jt{constructor(O,J,_e){this.start=O,this.deleteCount=J,this.data=_e}}e.SemanticTokensEdit=jt;class Di{constructor(O,J){this.resultId=J,this.edits=O}}e.SemanticTokensEdits=Di;var mt;(function(x){x[x.Separate=0]="Separate",x[x.MergeWithParent=1]="MergeWithParent"})(mt=e.DebugConsoleMode||(e.DebugConsoleMode={}));let ai=class{constructor(){}};ai.Back={iconPath:new Vt("arrow-left")},ai=ze([z],ai),e.QuickInputButtons=ai;var Ni;(function(x){x[x.Separator=-1]="Separator",x[x.Default=0]="Default"})(Ni=e.QuickPickItemKind||(e.QuickPickItemKind={}));var Ci;(function(x){x[x.Info=1]="Info",x[x.Warning=2]="Warning",x[x.Error=3]="Error"})(Ci=e.InputBoxValidationSeverity||(e.InputBoxValidationSeverity={}));var Mi;(function(x){x[x.UI=1]="UI",x[x.Workspace=2]="Workspace"})(Mi=e.ExtensionKind||(e.ExtensionKind={}));class ci{constructor(O,J,_e){this.badge=O,this.tooltip=J,this.color=_e}static validate(O){if(O.badge){let J=(0,T.nextCharLength)(O.badge,0);if(J<O.badge.length&&(J+=(0,T.nextCharLength)(O.badge,J)),O.badge.length>J)throw new Error("The 'badge'-property must be undefined or a short character")}if(!O.color&&!O.badge&&!O.tooltip)throw new Error("The decoration is empty");return!0}}e.FileDecoration=ci;let Ei=class{constructor(O){this.kind=O}};Ei=ze([z],Ei),e.ColorTheme=Ei;var Li;(function(x){x[x.Light=1]="Light",x[x.Dark=2]="Dark",x[x.HighContrast=3]="HighContrast",x[x.HighContrastLight=4]="HighContrastLight"})(Li=e.ColorThemeKind||(e.ColorThemeKind={}));class $t{constructor(O,J){if(O<0)throw(0,p.illegalArgument)("start must be positive");if(J<0)throw(0,p.illegalArgument)("end must be positive");O<=J?(this._start=O,this._end=J):(this._start=J,this._end=O)}static isNotebookRange(O){return O instanceof $t?!0:O?typeof O.start=="number"&&typeof O.end=="number":!1}get start(){return this._start}get end(){return this._end}get isEmpty(){return this._start===this._end}with(O){let J=this._start,_e=this._end;return O.start!==void 0&&(J=O.start),O.end!==void 0&&(_e=O.end),J===this._start&&_e===this._end?this:new $t(J,_e)}}e.NotebookRange=$t;class qt{constructor(O,J,_e,qe,tt,at,ct){this.kind=O,this.value=J,this.languageId=_e,this.mime=qe,this.outputs=tt??[],this.metadata=at,this.executionSummary=ct,qt.validate(this)}static validate(O){if(typeof O.kind!="number")throw new Error("NotebookCellData MUST have 'kind' property");if(typeof O.value!="string")throw new Error("NotebookCellData MUST have 'value' property");if(typeof O.languageId!="string")throw new Error("NotebookCellData MUST have 'languageId' property")}static isNotebookCellDataArray(O){return Array.isArray(O)&&O.every(J=>qt.isNotebookCellData(J))}static isNotebookCellData(O){return!0}}e.NotebookCellData=qt;class Ui{constructor(O){this.cells=O}}e.NotebookData=Ui;class Bt{constructor(O,J){this.data=O,this.mime=J;const _e=(0,D.normalizeMimeType)(J,!0);if(!_e)throw new Error(`INVALID mime type: ${J}. Must be in the format "type/subtype[;optionalparameter]"`);this.mime=_e}static isNotebookCellOutputItem(O){return O instanceof Bt?!0:O?typeof O.mime=="string"&&O.data instanceof Uint8Array:!1}static error(O){const J={name:O.name,message:O.message,stack:O.stack};return Bt.json(J,"application/vnd.code.notebook.error")}static stdout(O){return Bt.text(O,"application/vnd.code.notebook.stdout")}static stderr(O){return Bt.text(O,"application/vnd.code.notebook.stderr")}static bytes(O,J="application/octet-stream"){return new Bt(O,J)}static text(O,J=D.Mimes.text){const _e=Oe(Bt,d,"f",a).encode(String(O));return new Bt(_e,J)}static json(O,J="text/x-json"){const _e=JSON.stringify(O,void 0,"	");return Bt.text(_e,J)}}e.NotebookCellOutputItem=Bt,d=Bt,a={value:new TextEncoder};class li{constructor(O,J,_e){this.items=li.ensureUniqueMimeTypes(O,!0),typeof J=="string"?(this.id=J,this.metadata=_e):(this.id=(0,R.generateUuid)(),this.metadata=J??_e)}static isNotebookCellOutput(O){return O instanceof li?!0:!O||typeof O!="object"?!1:typeof O.id=="string"&&Array.isArray(O.items)}static ensureUniqueMimeTypes(O,J=!1){const _e=new Set,qe=new Set;for(let tt=0;tt<O.length;tt++){const at=O[tt],ct=(0,D.normalizeMimeType)(at.mime);if(!_e.has(ct)){_e.add(ct);continue}qe.add(tt),J&&console.warn(`DUPLICATED mime type '${at.mime}' will be dropped`)}return qe.size===0?O:O.filter((tt,at)=>!qe.has(at))}}e.NotebookCellOutput=li;var Bi;(function(x){x[x.Markup=1]="Markup",x[x.Code=2]="Code"})(Bi=e.NotebookCellKind||(e.NotebookCellKind={}));var zi;(function(x){x[x.Idle=1]="Idle",x[x.Pending=2]="Pending",x[x.Executing=3]="Executing"})(zi=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var se;(function(x){x[x.Left=1]="Left",x[x.Right=2]="Right"})(se=e.NotebookCellStatusBarAlignment||(e.NotebookCellStatusBarAlignment={}));var de;(function(x){x[x.Default=0]="Default",x[x.InCenter=1]="InCenter",x[x.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",x[x.AtTop=3]="AtTop"})(de=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));class Re{constructor(O,J){this.text=O,this.alignment=J}}e.NotebookCellStatusBarItem=Re;var ot;(function(x){x[x.Default=1]="Default",x[x.Preferred=2]="Preferred"})(ot=e.NotebookControllerAffinity||(e.NotebookControllerAffinity={}));class wt{constructor(O,J=[]){this.uri=O,this.provides=(0,o.asArray)(J)}}e.NotebookRendererScript=wt;let Ct=class{constructor(O,J){this.label=O,this.timestamp=J}};Ct=ze([z],Ct),e.TimelineItem=Ct;var Ji;(function(x){x[x.Production=1]="Production",x[x.Development=2]="Development",x[x.Test=3]="Test"})(Ji=e.ExtensionMode||(e.ExtensionMode={}));var Zi;(function(x){x[x.Node=1]="Node",x[x.Webworker=2]="Webworker"})(Zi=e.ExtensionRuntime||(e.ExtensionRuntime={}));var en;(function(x){x[x.Other=0]="Other",x[x.Comment=1]="Comment",x[x.String=2]="String",x[x.RegEx=3]="RegEx"})(en=e.StandardTokenType||(e.StandardTokenType={}));class tn{constructor(O,J){this.ranges=O,this.wordPattern=J}}e.LinkedEditingRanges=tn;class nn{constructor(O,J){this._port=O,this._autoForwardAction=J}get port(){return this._port}get autoForwardAction(){return this._autoForwardAction}}e.PortAttributes=nn;var rn;(function(x){x[x.Queued=1]="Queued",x[x.Running=2]="Running",x[x.Passed=3]="Passed",x[x.Failed=4]="Failed",x[x.Skipped=5]="Skipped",x[x.Errored=6]="Errored"})(rn=e.TestResultState||(e.TestResultState={}));var sn;(function(x){x[x.Run=1]="Run",x[x.Debug=2]="Debug",x[x.Coverage=3]="Coverage"})(sn=e.TestRunProfileKind||(e.TestRunProfileKind={}));let xi=class{constructor(O=void 0,J=void 0,_e=void 0){this.include=O,this.exclude=J,this.profile=_e}};xi=ze([z],xi),e.TestRunRequest=xi;let $i=M=class{constructor(O){this.message=O}static diff(O,J,_e){const qe=new M(O);return qe.expectedOutput=J,qe.actualOutput=_e,qe}};$i=M=ze([z],$i),e.TestMessage=$i;let Wi=class{constructor(O){this.id=O}};Wi=ze([z],Wi),e.TestTag=Wi;let ui=class{constructor(O,J){this.covered=O,this.total=J}};ui=ze([z],ui),e.CoveredCount=ui;let Hi=S=class{constructor(O,J,_e,qe){this.uri=O,this.statementCoverage=J,this.branchCoverage=_e,this.functionCoverage=qe}static fromDetails(O,J){const _e=new ui(0,0),qe=new ui(0,0),tt=new ui(0,0);for(const ct of J)if("branches"in ct){_e.total+=1,_e.covered+=ct.executionCount>0?1:0;for(const St of ct.branches)qe.total+=1,qe.covered+=St.executionCount>0?1:0}else tt.total+=1,tt.covered+=ct.executionCount>0?1:0;const at=new S(O,_e,qe.total>0?qe:void 0,tt.total>0?tt:void 0);return at.detailedCoverage=J,at}};Hi=S=ze([z],Hi),e.FileCoverage=Hi;let Vi=class{constructor(O,J,_e=[]){this.executionCount=O,this.location=J,this.branches=_e}};Vi=ze([z],Vi),e.StatementCoverage=Vi;let ji=class{constructor(O,J){this.executionCount=O,this.location=J}};ji=ze([z],ji),e.BranchCoverage=ji;let qi=class{constructor(O,J){this.executionCount=O,this.location=J}};qi=ze([z],qi),e.FunctionCoverage=qi;var on;(function(x){x[x.None=0]="None",x[x.Option=1]="Option",x[x.Default=2]="Default",x[x.Preferred=3]="Preferred"})(on=e.ExternalUriOpenerPriority||(e.ExternalUriOpenerPriority={}));var an;(function(x){x[x.Untrusted=0]="Untrusted",x[x.Trusted=1]="Trusted",x[x.Unspecified=2]="Unspecified"})(an=e.WorkspaceTrustState||(e.WorkspaceTrustState={}));var cn;(function(x){x[x.Notify=1]="Notify",x[x.OpenBrowser=2]="OpenBrowser",x[x.OpenPreview=3]="OpenPreview",x[x.Silent=4]="Silent",x[x.Ignore=5]="Ignore",x[x.OpenBrowserOnce=6]="OpenBrowserOnce"})(cn=e.PortAutoForwardAction||(e.PortAutoForwardAction={}));class ln{constructor(O,J,_e,qe,tt,at){this.kind=O,this.name=J,this.detail=_e,this.uri=qe,this.range=tt,this.selectionRange=at}}e.TypeHierarchyItem=ln;class un{constructor(O){this.uri=O}}e.TextTabInput=un;class dn{constructor(O,J){this.original=O,this.modified=J}}e.TextDiffTabInput=dn;class hn{constructor(O,J,_e,qe){this.base=O,this.input1=J,this.input2=_e,this.result=qe}}e.TextMergeTabInput=hn;class fn{constructor(O,J){this.uri=O,this.viewType=J}}e.CustomEditorTabInput=fn;class mn{constructor(O){this.viewType=O}}e.WebviewEditorTabInput=mn;class gn{constructor(O,J){this.uri=O,this.notebookType=J}}e.NotebookEditorTabInput=gn;class pn{constructor(O,J,_e){this.original=O,this.modified=J,this.notebookType=_e}}e.NotebookDiffEditorTabInput=pn;class vn{constructor(){}}e.TerminalEditorTabInput=vn;class En{constructor(O,J){this.uri=O,this.inputBoxUri=J}}e.InteractiveWindowInput=En}),define(De[87],Ce([1,0,44,12,9,239,121,6,16]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentLine=e.ExtHostDocumentData=e.getWordDefinitionFor=e.setWordDefinitionFor=void 0;const P=new Map;function R(f,h){h?P.set(f,h):P.delete(f)}e.setWordDefinitionFor=R;function y(f){return P.get(f)}e.getWordDefinitionFor=y;class m extends L.MirrorTextModel{constructor(h,d,a,v,A,l,_,s){super(d,a,v,A);this._proxy=h,this._languageId=l,this._isDirty=_,this.notebook=s,this._isDisposed=!1}dispose(){(0,o.ok)(!this._isDisposed),this._isDisposed=!0,this._isDirty=!1}equalLines(h){return(0,E.equals)(this._lines,h)}get document(){if(!this._document){const h=this;this._document={get uri(){return h._uri},get fileName(){return h._uri.fsPath},get isUntitled(){return h._uri.scheme===p.Schemas.untitled},get languageId(){return h._languageId},get version(){return h._versionId},get isClosed(){return h._isDisposed},get isDirty(){return h._isDirty},save(){return h._save()},getText(d){return d?h._getTextInRange(d):h.getText()},get eol(){return h._eol===`
`?T.EndOfLine.LF:T.EndOfLine.CRLF},get lineCount(){return h._lines.length},lineAt(d){return h._lineAt(d)},offsetAt(d){return h._offsetAt(d)},positionAt(d){return h._positionAt(d)},validateRange(d){return h._validateRange(d)},validatePosition(d){return h._validatePosition(d)},getWordRangeAtPosition(d,a){return h._getWordRangeAtPosition(d,a)}}}return Object.freeze(this._document)}_acceptLanguageId(h){(0,o.ok)(!this._isDisposed),this._languageId=h}_acceptIsDirty(h){(0,o.ok)(!this._isDisposed),this._isDirty=h}_save(){return this._isDisposed?Promise.reject(new Error("Document has been closed")):this._proxy.$trySaveDocument(this._uri)}_getTextInRange(h){const d=this._validateRange(h);if(d.isEmpty)return"";if(d.isSingleLine)return this._lines[d.start.line].substring(d.start.character,d.end.character);const a=this._eol,v=d.start.line,A=d.end.line,l=[];l.push(this._lines[v].substring(d.start.character));for(let _=v+1;_<A;_++)l.push(this._lines[_]);return l.push(this._lines[A].substring(0,d.end.character)),l.join(a)}_lineAt(h){let d;if(h instanceof T.Position?d=h.line:typeof h=="number"&&(d=h),typeof d!="number"||d<0||d>=this._lines.length||Math.floor(d)!==d)throw new Error("Illegal value for `line`");return new I(d,this._lines[d],d===this._lines.length-1)}_offsetAt(h){return h=this._validatePosition(h),this._ensureLineStarts(),this._lineStarts.getPrefixSum(h.line-1)+h.character}_positionAt(h){h=Math.floor(h),h=Math.max(0,h),this._ensureLineStarts();const d=this._lineStarts.getIndexOf(h),a=this._lines[d.index].length;return new T.Position(d.index,Math.min(d.remainder,a))}_validateRange(h){if(!(h instanceof T.Range))throw new Error("Invalid argument");const d=this._validatePosition(h.start),a=this._validatePosition(h.end);return d===h.start&&a===h.end?h:new T.Range(d.line,d.character,a.line,a.character)}_validatePosition(h){if(!(h instanceof T.Position))throw new Error("Invalid argument");if(this._lines.length===0)return h.with(0,0);let{line:d,character:a}=h,v=!1;if(d<0)d=0,a=0,v=!0;else if(d>=this._lines.length)d=this._lines.length-1,a=this._lines[d].length,v=!0;else{const A=this._lines[d].length;a<0?(a=0,v=!0):a>A&&(a=A,v=!0)}return v?new T.Position(d,a):h}_getWordRangeAtPosition(h,d){const a=this._validatePosition(h);if(!d)d=y(this._languageId);else if((0,b.regExpLeadsToEndlessLoop)(d))throw new Error(`[getWordRangeAtPosition]: ignoring custom regexp '${d.source}' because it matches the empty string.`);const v=(0,D.getWordAtText)(a.character+1,(0,D.ensureValidWordDefinition)(d),this._lines[a.line],0);if(v)return new T.Range(a.line,v.startColumn-1,a.line,v.endColumn-1)}}e.ExtHostDocumentData=m;class I{constructor(h,d,a){this._line=h,this._text=d,this._isLastLine=a}get lineNumber(){return this._line}get text(){return this._text}get range(){return new T.Range(this._line,0,this._line,this._text.length)}get rangeIncludingLineBreak(){return this._isLastLine?this.range:new T.Range(this._line,0,this._line+1,0)}get firstNonWhitespaceCharacterIndex(){return/^(\s*)/.exec(this._text)[1].length}get isEmptyOrWhitespace(){return this.firstNonWhitespaceCharacterIndex===this._text.length}}e.ExtHostDocumentLine=I}),define(De[160],Ce([1,0,6,15,4]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTheming=void 0;let L=class{constructor(T){this._actual=new o.ColorTheme(o.ColorThemeKind.Dark),this._onDidChangeActiveColorTheme=new b.Emitter}get activeColorTheme(){return this._actual}$onColorThemeChange(T){let E;switch(T){case"light":E=o.ColorThemeKind.Light;break;case"hcDark":E=o.ColorThemeKind.HighContrast;break;case"hcLight":E=o.ColorThemeKind.HighContrastLight;break;default:E=o.ColorThemeKind.Dark}this._actual=new o.ColorTheme(E),this._onDidChangeActiveColorTheme.fire(this._actual)}get onDidChangeActiveColorTheme(){return this._onDidChangeActiveColorTheme.event}};L=ze([xe(0,p.IExtHostRpcService)],L),e.ExtHostTheming=L}),define(De[63],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.URITransformerService=e.IURITransformerService=void 0,e.IURITransformerService=(0,o.createDecorator)("IURITransformerService");class p{constructor(L){L?(this.transformIncoming=L.transformIncoming.bind(L),this.transformOutgoing=L.transformOutgoing.bind(L),this.transformOutgoingURI=L.transformOutgoingURI.bind(L),this.transformOutgoingScheme=L.transformOutgoingScheme.bind(L)):(this.transformIncoming=D=>D,this.transformOutgoing=D=>D,this.transformOutgoingURI=D=>D,this.transformOutgoingScheme=D=>D)}}e.URITransformerService=p}),define(De[161],Ce([1,0,22]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeWebviewMessage=e.serializeWebviewMessage=void 0;class p{constructor(){this.buffers=[]}add(E){let P=this.buffers.indexOf(E);return P<0&&(P=this.buffers.length,this.buffers.push(E)),P}}function b(T,E){if(E.serializeBuffersForPostMessage){const P=new p,R=(I,f)=>{if(f instanceof ArrayBuffer){const h=P.add(f);return{$$vscode_array_buffer_reference$$:!0,index:h}}else if(ArrayBuffer.isView(f)){const h=L(f);if(h){const d=P.add(f.buffer);return{$$vscode_array_buffer_reference$$:!0,index:d,view:{type:h,byteLength:f.byteLength,byteOffset:f.byteOffset}}}}return f},y=JSON.stringify(T,R),m=P.buffers.map(I=>{const f=new Uint8Array(I);return o.VSBuffer.wrap(f)});return{message:y,buffers:m}}else return{message:JSON.stringify(T),buffers:[]}}e.serializeWebviewMessage=b;function L(T){switch(T.constructor.name){case"Int8Array":return 1;case"Uint8Array":return 2;case"Uint8ClampedArray":return 3;case"Int16Array":return 4;case"Uint16Array":return 5;case"Int32Array":return 6;case"Uint32Array":return 7;case"Float32Array":return 8;case"Float64Array":return 9;case"BigInt64Array":return 10;case"BigUint64Array":return 11}}function D(T,E){const P=E.map(m=>{const I=new ArrayBuffer(m.byteLength);return new Uint8Array(I).set(m.buffer),I}),R=E.length?(m,I)=>{if(I&&typeof I=="object"&&I.$$vscode_array_buffer_reference$$){const f=I,{index:h}=f,d=P[h];if(f.view)switch(f.view.type){case 1:return new Int8Array(d,f.view.byteOffset,f.view.byteLength/Int8Array.BYTES_PER_ELEMENT);case 2:return new Uint8Array(d,f.view.byteOffset,f.view.byteLength/Uint8Array.BYTES_PER_ELEMENT);case 3:return new Uint8ClampedArray(d,f.view.byteOffset,f.view.byteLength/Uint8ClampedArray.BYTES_PER_ELEMENT);case 4:return new Int16Array(d,f.view.byteOffset,f.view.byteLength/Int16Array.BYTES_PER_ELEMENT);case 5:return new Uint16Array(d,f.view.byteOffset,f.view.byteLength/Uint16Array.BYTES_PER_ELEMENT);case 6:return new Int32Array(d,f.view.byteOffset,f.view.byteLength/Int32Array.BYTES_PER_ELEMENT);case 7:return new Uint32Array(d,f.view.byteOffset,f.view.byteLength/Uint32Array.BYTES_PER_ELEMENT);case 8:return new Float32Array(d,f.view.byteOffset,f.view.byteLength/Float32Array.BYTES_PER_ELEMENT);case 9:return new Float64Array(d,f.view.byteOffset,f.view.byteLength/Float64Array.BYTES_PER_ELEMENT);case 10:return new BigInt64Array(d,f.view.byteOffset,f.view.byteLength/BigInt64Array.BYTES_PER_ELEMENT);case 11:return new BigUint64Array(d,f.view.byteOffset,f.view.byteLength/BigUint64Array.BYTES_PER_ELEMENT);default:throw new Error("Unknown array buffer view type")}return d}return I}:void 0;return{message:JSON.parse(T,R),arrayBuffers:P}}e.deserializeWebviewMessage=D}),define(De[162],Ce([1,0,135,10,2,7,3,30,39,16,12]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isTextEditorViewState=e.EditorsOrder=e.pathsToEditors=e.CloseDirection=e.EditorResourceAccessor=e.SideBySideEditor=e.GroupModelChangeKind=e.EditorCloseContext=e.isEditorIdentifier=e.isEditorInputWithOptionsAndGroup=e.isEditorInputWithOptions=e.isDiffEditorInput=e.isSideBySideEditorInput=e.isEditorInput=e.AbstractEditorInput=e.EditorInputCapabilities=e.SaveSourceRegistry=e.SaveReason=e.Verbosity=e.isResourceMergeEditorInput=e.isUntitledResourceEditorInput=e.isResourceSideBySideEditorInput=e.isResourceDiffEditorInput=e.isResourceEditorInput=e.findViewStateForEditor=e.isEditorPaneWithSelection=e.EditorPaneSelectionCompareResult=e.EditorPaneSelectionChangeReason=e.BINARY_DIFF_EDITOR_ID=e.TEXT_DIFF_EDITOR_ID=e.SIDE_BY_SIDE_EDITOR_ID=e.DEFAULT_EDITOR_ASSOCIATION=e.EditorExtensions=void 0,e.EditorExtensions={EditorPane:"workbench.contributions.editors",EditorFactory:"workbench.contributions.editor.inputFactories"},e.DEFAULT_EDITOR_ASSOCIATION={id:"default",displayName:(0,o.localize)(0,null),providerDisplayName:(0,o.localize)(1,null)},e.SIDE_BY_SIDE_EDITOR_ID="workbench.editor.sidebysideEditor",e.TEXT_DIFF_EDITOR_ID="workbench.editors.textDiffEditor",e.BINARY_DIFF_EDITOR_ID="workbench.editors.binaryResourceDiffEditor";var y;(function(F){F[F.PROGRAMMATIC=1]="PROGRAMMATIC",F[F.USER=2]="USER",F[F.EDIT=3]="EDIT",F[F.NAVIGATION=4]="NAVIGATION",F[F.JUMP=5]="JUMP"})(y=e.EditorPaneSelectionChangeReason||(e.EditorPaneSelectionChangeReason={}));var m;(function(F){F[F.IDENTICAL=1]="IDENTICAL",F[F.SIMILAR=2]="SIMILAR",F[F.DIFFERENT=3]="DIFFERENT"})(m=e.EditorPaneSelectionCompareResult||(e.EditorPaneSelectionCompareResult={}));function I(F){const ne=F;return!!ne&&typeof ne.getSelection=="function"&&!!ne.onDidChangeSelection}e.isEditorPaneWithSelection=I;function f(F,ne,ce){for(const re of ce.visibleEditorPanes)if(re.group.id===ne&&F.matches(re.input))return re.getViewState()}e.findViewStateForEditor=f;function h(F){if(i(F))return!1;const ne=F;return b.URI.isUri(ne?.resource)}e.isResourceEditorInput=h;function d(F){if(i(F))return!1;const ne=F;return ne?.original!==void 0&&ne.modified!==void 0}e.isResourceDiffEditorInput=d;function a(F){if(i(F)||d(F))return!1;const ne=F;return ne?.primary!==void 0&&ne.secondary!==void 0}e.isResourceSideBySideEditorInput=a;function v(F){if(i(F))return!1;const ne=F;return ne?ne.resource===void 0||ne.resource.scheme===R.Schemas.untitled||ne.forceUntitled===!0:!1}e.isUntitledResourceEditorInput=v;function A(F){if(i(F))return!1;const ne=F;return b.URI.isUri(ne?.base?.resource)&&b.URI.isUri(ne?.input1?.resource)&&b.URI.isUri(ne?.input2?.resource)&&b.URI.isUri(ne?.result?.resource)}e.isResourceMergeEditorInput=A;var l;(function(F){F[F.SHORT=0]="SHORT",F[F.MEDIUM=1]="MEDIUM",F[F.LONG=2]="LONG"})(l=e.Verbosity||(e.Verbosity={}));var _;(function(F){F[F.EXPLICIT=1]="EXPLICIT",F[F.AUTO=2]="AUTO",F[F.FOCUS_CHANGE=3]="FOCUS_CHANGE",F[F.WINDOW_CHANGE=4]="WINDOW_CHANGE"})(_=e.SaveReason||(e.SaveReason={}));class s{constructor(){this.mapIdToSaveSource=new Map}registerSource(ne,ce){let re=this.mapIdToSaveSource.get(ne);return re||(re={source:ne,label:ce},this.mapIdToSaveSource.set(ne,re)),re.source}getSourceLabel(ne){return this.mapIdToSaveSource.get(ne)?.label??ne}}e.SaveSourceRegistry=new s;var u;(function(F){F[F.None=0]="None",F[F.Readonly=2]="Readonly",F[F.Untitled=4]="Untitled",F[F.Singleton=8]="Singleton",F[F.RequiresTrust=16]="RequiresTrust",F[F.CanSplitInGroup=32]="CanSplitInGroup",F[F.ForceDescription=64]="ForceDescription",F[F.CanDropIntoEditor=128]="CanDropIntoEditor",F[F.MultipleEditors=256]="MultipleEditors"})(u=e.EditorInputCapabilities||(e.EditorInputCapabilities={}));class n extends L.Disposable{}e.AbstractEditorInput=n;function i(F){return F instanceof n}e.isEditorInput=i;function r(F){const ne=F;return b.URI.isUri(ne?.preferredResource)}function t(F){const ne=F;return i(ne?.primary)&&i(ne?.secondary)}e.isSideBySideEditorInput=t;function c(F){const ne=F;return i(ne?.modified)&&i(ne?.original)}e.isDiffEditorInput=c;function w(F){return i(F?.editor)}e.isEditorInputWithOptions=w;function g(F){const ne=F;return w(F)&&ne?.group!==void 0}e.isEditorInputWithOptionsAndGroup=g;function C(F){const ne=F;return typeof ne?.groupId=="number"&&i(ne.editor)}e.isEditorIdentifier=C;var U;(function(F){F[F.UNKNOWN=0]="UNKNOWN",F[F.REPLACE=1]="REPLACE",F[F.MOVE=2]="MOVE",F[F.UNPIN=3]="UNPIN"})(U=e.EditorCloseContext||(e.EditorCloseContext={}));var W;(function(F){F[F.GROUP_ACTIVE=0]="GROUP_ACTIVE",F[F.GROUP_INDEX=1]="GROUP_INDEX",F[F.GROUP_LOCKED=2]="GROUP_LOCKED",F[F.EDITOR_OPEN=3]="EDITOR_OPEN",F[F.EDITOR_CLOSE=4]="EDITOR_CLOSE",F[F.EDITOR_MOVE=5]="EDITOR_MOVE",F[F.EDITOR_ACTIVE=6]="EDITOR_ACTIVE",F[F.EDITOR_LABEL=7]="EDITOR_LABEL",F[F.EDITOR_CAPABILITIES=8]="EDITOR_CAPABILITIES",F[F.EDITOR_PIN=9]="EDITOR_PIN",F[F.EDITOR_STICKY=10]="EDITOR_STICKY",F[F.EDITOR_DIRTY=11]="EDITOR_DIRTY",F[F.EDITOR_WILL_DISPOSE=12]="EDITOR_WILL_DISPOSE"})(W=e.GroupModelChangeKind||(e.GroupModelChangeKind={}));var M;(function(F){F[F.PRIMARY=1]="PRIMARY",F[F.SECONDARY=2]="SECONDARY",F[F.BOTH=3]="BOTH",F[F.ANY=4]="ANY"})(M=e.SideBySideEditor||(e.SideBySideEditor={}));class S{getOriginalUri(ne,ce){if(!ne)return;if(A(ne))return e.EditorResourceAccessor.getOriginalUri(ne.result,ce);if(ce?.supportSideBySide){const{primary:fe,secondary:ie}=this.getSideEditors(ne);if(fe&&ie){if(ce?.supportSideBySide===M.BOTH)return{primary:this.getOriginalUri(fe,{filterByScheme:ce.filterByScheme}),secondary:this.getOriginalUri(ie,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===M.ANY)return this.getOriginalUri(fe,{filterByScheme:ce.filterByScheme})??this.getOriginalUri(ie,{filterByScheme:ce.filterByScheme});ne=ce.supportSideBySide===M.PRIMARY?fe:ie}}if(d(ne)||a(ne)||A(ne))return;const re=r(ne)?ne.preferredResource:ne.resource;return!re||!ce||!ce.filterByScheme?re:this.filterUri(re,ce.filterByScheme)}getSideEditors(ne){return t(ne)||a(ne)?{primary:ne.primary,secondary:ne.secondary}:c(ne)||d(ne)?{primary:ne.modified,secondary:ne.original}:{primary:void 0,secondary:void 0}}getCanonicalUri(ne,ce){if(!ne)return;if(A(ne))return e.EditorResourceAccessor.getCanonicalUri(ne.result,ce);if(ce?.supportSideBySide){const{primary:fe,secondary:ie}=this.getSideEditors(ne);if(fe&&ie){if(ce?.supportSideBySide===M.BOTH)return{primary:this.getCanonicalUri(fe,{filterByScheme:ce.filterByScheme}),secondary:this.getCanonicalUri(ie,{filterByScheme:ce.filterByScheme})};if(ce?.supportSideBySide===M.ANY)return this.getCanonicalUri(fe,{filterByScheme:ce.filterByScheme})??this.getCanonicalUri(ie,{filterByScheme:ce.filterByScheme});ne=ce.supportSideBySide===M.PRIMARY?fe:ie}}if(d(ne)||a(ne)||A(ne))return;const re=ne.resource;return!re||!ce||!ce.filterByScheme?re:this.filterUri(re,ce.filterByScheme)}filterUri(ne,ce){if(Array.isArray(ce)){if(ce.some(re=>ne.scheme===re))return ne}else if(ce===ne.scheme)return ne}}e.EditorResourceAccessor=new S;var z;(function(F){F[F.LEFT=0]="LEFT",F[F.RIGHT=1]="RIGHT"})(z=e.CloseDirection||(e.CloseDirection={}));class ${constructor(){this.editorSerializerConstructors=new Map,this.editorSerializerInstances=new Map}start(ne){const ce=this.instantiationService=ne.get(D.IInstantiationService);for(const[re,fe]of this.editorSerializerConstructors)this.createEditorSerializer(re,fe,ce);this.editorSerializerConstructors.clear()}createEditorSerializer(ne,ce,re){const fe=re.createInstance(ce);this.editorSerializerInstances.set(ne,fe)}registerFileEditorFactory(ne){if(this.fileEditorFactory)throw new Error("Can only register one file editor factory.");this.fileEditorFactory=ne}getFileEditorFactory(){return(0,p.assertIsDefined)(this.fileEditorFactory)}registerEditorSerializer(ne,ce){if(this.editorSerializerConstructors.has(ne)||this.editorSerializerInstances.has(ne))throw new Error(`A editor serializer with type ID '${ne}' was already registered.`);return this.instantiationService?this.createEditorSerializer(ne,ce,this.instantiationService):this.editorSerializerConstructors.set(ne,ce),(0,L.toDisposable)(()=>{this.editorSerializerConstructors.delete(ne),this.editorSerializerInstances.delete(ne)})}getEditorSerializer(ne){return this.editorSerializerInstances.get(typeof ne=="string"?ne:ne.typeId)}}T.Registry.add(e.EditorExtensions.EditorFactory,new $);async function N(F,ne){if(!F||!F.length)return[];const ce=await Promise.all(F.map(async re=>{const fe=b.URI.revive(re.fileUri);if(!fe||!await ne.canHandleResource(fe))return;let Ee=re.exists,be=re.type;if(typeof Ee!="boolean"||typeof be!="number")try{be=(await ne.stat(fe)).isDirectory?E.FileType.Directory:E.FileType.Unknown,Ee=!0}catch{Ee=!1}if(!Ee&&re.openOnlyIfExists||be===E.FileType.Directory)return;const ee={...re.options,pinned:!0};let ve;return Ee?ve={resource:fe,options:ee}:ve={resource:fe,options:ee,forceUntitled:!0},ve}));return(0,P.coalesce)(ce)}e.pathsToEditors=N;var K;(function(F){F[F.MOST_RECENTLY_ACTIVE=0]="MOST_RECENTLY_ACTIVE",F[F.SEQUENTIAL=1]="SEQUENTIAL"})(K=e.EditorsOrder||(e.EditorsOrder={}));function V(F){const ne=F;if(!ne)return!1;const ce=ne;if(ce.modified)return V(ce.modified);const re=ne;return!!(re.contributionsState&&re.viewState&&Array.isArray(re.cursorState))}e.isTextEditorViewState=V}),define(De[64],Ce([1,0,12,2]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.decodeAuthority=e.asWebviewUri=e.webviewGenericCspSource=e.webviewRootResourceAuthority=e.webviewResourceBaseHost=void 0,e.webviewResourceBaseHost="vscode-cdn.net",e.webviewRootResourceAuthority=`vscode-resource.${e.webviewResourceBaseHost}`,e.webviewGenericCspSource=`'self' https://*.${e.webviewResourceBaseHost}`;function b(T,E){return T.scheme===o.Schemas.http||T.scheme===o.Schemas.https?T:(E&&E.authority&&E.isRemote&&T.scheme===o.Schemas.file&&(T=p.URI.from({scheme:o.Schemas.vscodeRemote,authority:E.authority,path:T.path})),p.URI.from({scheme:o.Schemas.https,authority:`${T.scheme}+${L(T.authority)}.${e.webviewRootResourceAuthority}`,path:T.path,fragment:T.fragment,query:T.query}))}e.asWebviewUri=b;function L(T){return T.replace(/./g,E=>{const P=E.charCodeAt(0);return P>=97&&P<=122||P>=65&&P<=90||P>=48&&P<=57?E:"-"+P.toString(16).padStart(4,"0")})}function D(T){return T.replace(/-([0-9a-f]{4})/g,(E,P)=>String.fromCharCode(parseInt(P,16)))}e.decodeAuthority=D}),define(De[163],Ce([1,0,4,7,64]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorInsets=void 0;class L{constructor(T,E,P){this._proxy=T,this._editors=E,this._remoteInfo=P,this._handlePool=0,this._disposables=new p.DisposableStore,this._insets=new Map,this._disposables.add(E.onDidChangeVisibleTextEditors(()=>{const R=E.getVisibleTextEditors();for(const y of this._insets.values())R.indexOf(y.editor)<0&&y.inset.dispose()}))}dispose(){this._insets.forEach(T=>T.inset.dispose()),this._disposables.dispose()}createWebviewEditorInset(T,E,P,R,y){let m;for(const A of this._editors.getVisibleTextEditors(!0))if(A.value===T){m=A;break}if(!m)throw new Error("not a visible editor");const I=this,f=this._handlePool++,h=new o.Emitter,d=new o.Emitter,a=new class{constructor(){this._html="",this._options=Object.create(null)}asWebviewUri(A){return(0,b.asWebviewUri)(A,I._remoteInfo)}get cspSource(){return b.webviewGenericCspSource}set options(A){this._options=A,I._proxy.$setOptions(f,A)}get options(){return this._options}set html(A){this._html=A,I._proxy.$setHtml(f,A)}get html(){return this._html}get onDidReceiveMessage(){return h.event}postMessage(A){return I._proxy.$postMessage(f,A)}},v=new class{constructor(){this.editor=T,this.line=E,this.height=P,this.webview=a,this.onDidDispose=d.event}dispose(){I._insets.has(f)&&(I._insets.delete(f),I._proxy.$disposeEditorInset(f),d.fire(),d.dispose(),h.dispose())}};return this._proxy.$createEditorInset(f,m.id,m.value.document.uri,E+1,P,R||{},y.identifier,y.extensionLocation),this._insets.set(f,{editor:T,inset:v,onDidReceiveMessage:h}),v}$onDidDispose(T){const E=this._insets.get(T);E&&E.inset.dispose()}$onDidReceiveMessage(T,E){this._insets.get(T)?.onDidReceiveMessage.fire(E)}}e.ExtHostEditorInsets=L}),define(De[164],Ce([1,0,4,13,136]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractDebugAdapter=void 0;class L{constructor(){this.pendingRequests=new Map,this.queue=[],this._onError=new o.Emitter,this._onExit=new o.Emitter,this.sequence=1}get onError(){return this._onError.event}get onExit(){return this._onExit.event}onMessage(T){this.messageCallback&&this._onError.fire(new Error("attempt to set more than one 'Message' callback")),this.messageCallback=T}onEvent(T){this.eventCallback&&this._onError.fire(new Error("attempt to set more than one 'Event' callback")),this.eventCallback=T}onRequest(T){this.requestCallback&&this._onError.fire(new Error("attempt to set more than one 'Request' callback")),this.requestCallback=T}sendResponse(T){T.seq>0?this._onError.fire(new Error(`attempt to send more than one response for command ${T.command}`)):this.internalSend("response",T)}sendRequest(T,E,P,R){const y={command:T};if(E&&Object.keys(E).length>0&&(y.arguments=E),this.internalSend("request",y),typeof R=="number"){const m=setTimeout(()=>{clearTimeout(m);const I=this.pendingRequests.get(y.seq);if(I){this.pendingRequests.delete(y.seq);const f={type:"response",seq:0,request_seq:y.seq,success:!1,command:T,message:(0,b.localize)(0,null,R,T)};I(f)}},R)}return P&&this.pendingRequests.set(y.seq,P),y.seq}acceptMessage(T){this.messageCallback?this.messageCallback(T):(this.queue.push(T),this.queue.length===1&&this.processQueue())}needsTaskBoundaryBetween(T,E){return T.type!=="event"||E.type!=="event"}async processQueue(){let T;for(;this.queue.length;){if((!T||this.needsTaskBoundaryBetween(this.queue[0],T))&&await(0,p.timeout)(0),T=this.queue.shift(),!T)return;switch(T.type){case"event":this.eventCallback?.(T);break;case"request":this.requestCallback?.(T);break;case"response":{const E=T,P=this.pendingRequests.get(E.request_seq);P&&(this.pendingRequests.delete(E.request_seq),P(E));break}}}}internalSend(T,E){E.type=T,E.seq=this.sequence++,this.sendMessage(E)}async cancelPendingRequests(){if(this.pendingRequests.size===0)return Promise.resolve();const T=new Map;this.pendingRequests.forEach((E,P)=>T.set(P,E)),await(0,p.timeout)(500),T.forEach((E,P)=>{E({type:"response",seq:0,request_seq:P,success:!1,command:"canceled",message:"canceled"}),this.pendingRequests.delete(P)})}getPendingRequestIds(){return Array.from(this.pendingRequests.keys())}dispose(){this.queue=[]}}e.AbstractDebugAdapter=L}),define(De[165],Ce([1,0,137,38,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BreakpointWidgetContext=e.IDebugService=e.DebuggerUiMessage=e.DebugConfigurationProviderTriggerKind=e.DEBUG_MEMORY_SCHEME=e.MemoryRangeType=e.getStateLabel=e.State=e.INTERNAL_CONSOLE_OPTIONS_SCHEMA=e.DEBUG_SCHEME=e.BREAKPOINT_EDITOR_CONTRIBUTION_ID=e.EDITOR_CONTRIBUTION_ID=e.debuggerDisabledMessage=e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=e.CONTEXT_MULTI_SESSION_DEBUG=e.CONTEXT_MULTI_SESSION_REPL=e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=e.CONTEXT_VARIABLE_IS_READONLY=e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=e.CONTEXT_SET_EXPRESSION_SUPPORTED=e.CONTEXT_SET_VARIABLE_SUPPORTED=e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=e.CONTEXT_DEBUGGERS_AVAILABLE=e.CONTEXT_BREAKPOINTS_EXIST=e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=e.CONTEXT_RESTART_FRAME_SUPPORTED=e.CONTEXT_STEP_BACK_SUPPORTED=e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=e.CONTEXT_BREAKPOINT_ACCESS_TYPE=e.CONTEXT_BREAKPOINT_ITEM_TYPE=e.CONTEXT_CAN_VIEW_MEMORY=e.CONTEXT_WATCH_ITEM_TYPE=e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=e.CONTEXT_CALLSTACK_ITEM_STOPPED=e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=e.CONTEXT_CALLSTACK_ITEM_TYPE=e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=e.CONTEXT_EXPRESSION_SELECTED=e.CONTEXT_VARIABLES_FOCUSED=e.CONTEXT_WATCH_EXPRESSIONS_EXIST=e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=e.CONTEXT_BREAKPOINTS_FOCUSED=e.CONTEXT_IN_BREAKPOINT_WIDGET=e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=e.CONTEXT_IN_DEBUG_REPL=e.CONTEXT_IN_DEBUG_MODE=e.CONTEXT_DEBUG_UX=e.CONTEXT_DEBUG_UX_KEY=e.CONTEXT_DEBUG_STATE=e.CONTEXT_DEBUG_CONFIGURATION_TYPE=e.CONTEXT_DEBUG_TYPE=e.DEBUG_SERVICE_ID=e.REPL_VIEW_ID=e.DEBUG_PANEL_ID=e.DISASSEMBLY_VIEW_ID=e.BREAKPOINTS_VIEW_ID=e.LOADED_SCRIPTS_VIEW_ID=e.CALLSTACK_VIEW_ID=e.WATCH_VIEW_ID=e.VARIABLES_VIEW_ID=e.VIEWLET_ID=void 0,e.VIEWLET_ID="workbench.view.debug",e.VARIABLES_VIEW_ID="workbench.debug.variablesView",e.WATCH_VIEW_ID="workbench.debug.watchExpressionsView",e.CALLSTACK_VIEW_ID="workbench.debug.callStackView",e.LOADED_SCRIPTS_VIEW_ID="workbench.debug.loadedScriptsView",e.BREAKPOINTS_VIEW_ID="workbench.debug.breakPointsView",e.DISASSEMBLY_VIEW_ID="workbench.debug.disassemblyView",e.DEBUG_PANEL_ID="workbench.panel.repl",e.REPL_VIEW_ID="workbench.panel.repl.view",e.DEBUG_SERVICE_ID="debugService",e.CONTEXT_DEBUG_TYPE=new p.RawContextKey("debugType",void 0,{type:"string",description:o.localize(0,null)}),e.CONTEXT_DEBUG_CONFIGURATION_TYPE=new p.RawContextKey("debugConfigurationType",void 0,{type:"string",description:o.localize(1,null)}),e.CONTEXT_DEBUG_STATE=new p.RawContextKey("debugState","inactive",{type:"string",description:o.localize(2,null)}),e.CONTEXT_DEBUG_UX_KEY="debugUx",e.CONTEXT_DEBUG_UX=new p.RawContextKey(e.CONTEXT_DEBUG_UX_KEY,"default",{type:"string",description:o.localize(3,null)}),e.CONTEXT_IN_DEBUG_MODE=new p.RawContextKey("inDebugMode",!1,{type:"boolean",description:o.localize(4,null)}),e.CONTEXT_IN_DEBUG_REPL=new p.RawContextKey("inDebugRepl",!1,{type:"boolean",description:o.localize(5,null)}),e.CONTEXT_BREAKPOINT_WIDGET_VISIBLE=new p.RawContextKey("breakpointWidgetVisible",!1,{type:"boolean",description:o.localize(6,null)}),e.CONTEXT_IN_BREAKPOINT_WIDGET=new p.RawContextKey("inBreakpointWidget",!1,{type:"boolean",description:o.localize(7,null)}),e.CONTEXT_BREAKPOINTS_FOCUSED=new p.RawContextKey("breakpointsFocused",!0,{type:"boolean",description:o.localize(8,null)}),e.CONTEXT_WATCH_EXPRESSIONS_FOCUSED=new p.RawContextKey("watchExpressionsFocused",!0,{type:"boolean",description:o.localize(9,null)}),e.CONTEXT_WATCH_EXPRESSIONS_EXIST=new p.RawContextKey("watchExpressionsExist",!1,{type:"boolean",description:o.localize(10,null)}),e.CONTEXT_VARIABLES_FOCUSED=new p.RawContextKey("variablesFocused",!0,{type:"boolean",description:o.localize(11,null)}),e.CONTEXT_EXPRESSION_SELECTED=new p.RawContextKey("expressionSelected",!1,{type:"boolean",description:o.localize(12,null)}),e.CONTEXT_BREAKPOINT_INPUT_FOCUSED=new p.RawContextKey("breakpointInputFocused",!1,{type:"boolean",description:o.localize(13,null)}),e.CONTEXT_CALLSTACK_ITEM_TYPE=new p.RawContextKey("callStackItemType",void 0,{type:"string",description:o.localize(14,null)}),e.CONTEXT_CALLSTACK_SESSION_IS_ATTACH=new p.RawContextKey("callStackSessionIsAttach",!1,{type:"boolean",description:o.localize(15,null)}),e.CONTEXT_CALLSTACK_ITEM_STOPPED=new p.RawContextKey("callStackItemStopped",!1,{type:"boolean",description:o.localize(16,null)}),e.CONTEXT_CALLSTACK_SESSION_HAS_ONE_THREAD=new p.RawContextKey("callStackSessionHasOneThread",!1,{type:"boolean",description:o.localize(17,null)}),e.CONTEXT_WATCH_ITEM_TYPE=new p.RawContextKey("watchItemType",void 0,{type:"string",description:o.localize(18,null)}),e.CONTEXT_CAN_VIEW_MEMORY=new p.RawContextKey("canViewMemory",void 0,{type:"boolean",description:o.localize(19,null)}),e.CONTEXT_BREAKPOINT_ITEM_TYPE=new p.RawContextKey("breakpointItemType",void 0,{type:"string",description:o.localize(20,null)}),e.CONTEXT_BREAKPOINT_ACCESS_TYPE=new p.RawContextKey("breakpointAccessType",void 0,{type:"string",description:o.localize(21,null)}),e.CONTEXT_BREAKPOINT_SUPPORTS_CONDITION=new p.RawContextKey("breakpointSupportsCondition",!1,{type:"boolean",description:o.localize(22,null)}),e.CONTEXT_LOADED_SCRIPTS_SUPPORTED=new p.RawContextKey("loadedScriptsSupported",!1,{type:"boolean",description:o.localize(23,null)}),e.CONTEXT_LOADED_SCRIPTS_ITEM_TYPE=new p.RawContextKey("loadedScriptsItemType",void 0,{type:"string",description:o.localize(24,null)}),e.CONTEXT_FOCUSED_SESSION_IS_ATTACH=new p.RawContextKey("focusedSessionIsAttach",!1,{type:"boolean",description:o.localize(25,null)}),e.CONTEXT_STEP_BACK_SUPPORTED=new p.RawContextKey("stepBackSupported",!1,{type:"boolean",description:o.localize(26,null)}),e.CONTEXT_RESTART_FRAME_SUPPORTED=new p.RawContextKey("restartFrameSupported",!1,{type:"boolean",description:o.localize(27,null)}),e.CONTEXT_STACK_FRAME_SUPPORTS_RESTART=new p.RawContextKey("stackFrameSupportsRestart",!1,{type:"boolean",description:o.localize(28,null)}),e.CONTEXT_JUMP_TO_CURSOR_SUPPORTED=new p.RawContextKey("jumpToCursorSupported",!1,{type:"boolean",description:o.localize(29,null)}),e.CONTEXT_STEP_INTO_TARGETS_SUPPORTED=new p.RawContextKey("stepIntoTargetsSupported",!1,{type:"boolean",description:o.localize(30,null)}),e.CONTEXT_BREAKPOINTS_EXIST=new p.RawContextKey("breakpointsExist",!1,{type:"boolean",description:o.localize(31,null)}),e.CONTEXT_DEBUGGERS_AVAILABLE=new p.RawContextKey("debuggersAvailable",!1,{type:"boolean",description:o.localize(32,null)}),e.CONTEXT_DEBUG_EXTENSION_AVAILABLE=new p.RawContextKey("debugExtensionAvailable",!1,{type:"boolean",description:o.localize(33,null)}),e.CONTEXT_DEBUG_PROTOCOL_VARIABLE_MENU_CONTEXT=new p.RawContextKey("debugProtocolVariableMenuContext",void 0,{type:"string",description:o.localize(34,null)}),e.CONTEXT_SET_VARIABLE_SUPPORTED=new p.RawContextKey("debugSetVariableSupported",!1,{type:"boolean",description:o.localize(35,null)}),e.CONTEXT_SET_EXPRESSION_SUPPORTED=new p.RawContextKey("debugSetExpressionSupported",!1,{type:"boolean",description:o.localize(36,null)}),e.CONTEXT_BREAK_WHEN_VALUE_CHANGES_SUPPORTED=new p.RawContextKey("breakWhenValueChangesSupported",!1,{type:"boolean",description:o.localize(37,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_ACCESSED_SUPPORTED=new p.RawContextKey("breakWhenValueIsAccessedSupported",!1,{type:"boolean",description:o.localize(38,null)}),e.CONTEXT_BREAK_WHEN_VALUE_IS_READ_SUPPORTED=new p.RawContextKey("breakWhenValueIsReadSupported",!1,{type:"boolean",description:o.localize(39,null)}),e.CONTEXT_TERMINATE_DEBUGGEE_SUPPORTED=new p.RawContextKey("terminateDebuggeeSupported",!1,{type:"boolean",description:o.localize(40,null)}),e.CONTEXT_SUSPEND_DEBUGGEE_SUPPORTED=new p.RawContextKey("suspendDebuggeeSupported",!1,{type:"boolean",description:o.localize(41,null)}),e.CONTEXT_VARIABLE_EVALUATE_NAME_PRESENT=new p.RawContextKey("variableEvaluateNamePresent",!1,{type:"boolean",description:o.localize(42,null)}),e.CONTEXT_VARIABLE_IS_READONLY=new p.RawContextKey("variableIsReadonly",!1,{type:"boolean",description:o.localize(43,null)}),e.CONTEXT_EXCEPTION_WIDGET_VISIBLE=new p.RawContextKey("exceptionWidgetVisible",!1,{type:"boolean",description:o.localize(44,null)}),e.CONTEXT_MULTI_SESSION_REPL=new p.RawContextKey("multiSessionRepl",!1,{type:"boolean",description:o.localize(45,null)}),e.CONTEXT_MULTI_SESSION_DEBUG=new p.RawContextKey("multiSessionDebug",!1,{type:"boolean",description:o.localize(46,null)}),e.CONTEXT_DISASSEMBLE_REQUEST_SUPPORTED=new p.RawContextKey("disassembleRequestSupported",!1,{type:"boolean",description:o.localize(47,null)}),e.CONTEXT_DISASSEMBLY_VIEW_FOCUS=new p.RawContextKey("disassemblyViewFocus",!1,{type:"boolean",description:o.localize(48,null)}),e.CONTEXT_LANGUAGE_SUPPORTS_DISASSEMBLE_REQUEST=new p.RawContextKey("languageSupportsDisassembleRequest",!1,{type:"boolean",description:o.localize(49,null)}),e.CONTEXT_FOCUSED_STACK_FRAME_HAS_INSTRUCTION_POINTER_REFERENCE=new p.RawContextKey("focusedStackFrameHasInstructionReference",!1,{type:"boolean",description:o.localize(50,null)});const L=m=>o.localize(51,null,m);e.debuggerDisabledMessage=L,e.EDITOR_CONTRIBUTION_ID="editor.contrib.debug",e.BREAKPOINT_EDITOR_CONTRIBUTION_ID="editor.contrib.breakpoint",e.DEBUG_SCHEME="debug",e.INTERNAL_CONSOLE_OPTIONS_SCHEMA={enum:["neverOpen","openOnSessionStart","openOnFirstSessionStart"],default:"openOnFirstSessionStart",description:o.localize(52,null)};var D;(function(m){m[m.Inactive=0]="Inactive",m[m.Initializing=1]="Initializing",m[m.Stopped=2]="Stopped",m[m.Running=3]="Running"})(D=e.State||(e.State={}));function T(m){switch(m){case 1:return"initializing";case 2:return"stopped";case 3:return"running";default:return"inactive"}}e.getStateLabel=T;var E;(function(m){m[m.Valid=0]="Valid",m[m.Unreadable=1]="Unreadable",m[m.Error=2]="Error"})(E=e.MemoryRangeType||(e.MemoryRangeType={})),e.DEBUG_MEMORY_SCHEME="vscode-debug-memory";var P;(function(m){m[m.Initial=1]="Initial",m[m.Dynamic=2]="Dynamic"})(P=e.DebugConfigurationProviderTriggerKind||(e.DebugConfigurationProviderTriggerKind={}));var R;(function(m){m.UnverifiedBreakpoints="unverifiedBreakpoints"})(R=e.DebuggerUiMessage||(e.DebuggerUiMessage={})),e.IDebugService=(0,b.createDecorator)(e.DEBUG_SERVICE_ID);var y;(function(m){m[m.CONDITION=0]="CONDITION",m[m.HIT_COUNT=1]="HIT_COUNT",m[m.LOG_MESSAGE=2]="LOG_MESSAGE"})(y=e.BreakpointWidgetContext||(e.BreakpointWidgetContext={}))}),define(De[166],Ce([1,0,9,2,19,26,12]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.saveAllBeforeDebugStart=e.getVisibleAndSorted=e.convertToVSCPaths=e.convertToDAPaths=e.isUri=e.getExactExpressionStartAndEnd=e.isDebuggerMainContribution=e.getExtensionHostDebugSession=e.isSessionAttach=e.filterExceptionsFromTelemetry=e.formatPII=void 0;const T=/{([^}]+)}/g;function E(n,i,r){return n.replace(T,function(t,c){return i&&c.length>0&&c[0]!=="_"?t:r&&r.hasOwnProperty(c)?r[c]:t})}e.formatPII=E;function P(n){const i={};for(const r of Object.keys(n))r.startsWith("!")||(i[r]=n[r]);return i}e.filterExceptionsFromTelemetry=P;function R(n){return n.configuration.request==="attach"&&!y(n)&&(!n.parentSession||R(n.parentSession))}e.isSessionAttach=R;function y(n){let i=n.configuration.type;if(!!i)return i==="vslsShare"&&(i=n.configuration.adapterProxy.configuration.type),(0,o.equalsIgnoreCase)(i,"extensionhost")||(0,o.equalsIgnoreCase)(i,"pwa-extensionhost")?n:n.parentSession?y(n.parentSession):void 0}e.getExtensionHostDebugSession=y;function m(n){return n.type&&(n.label||n.program||n.runtime)}e.isDebuggerMainContribution=m;function I(n,i,r){let t,c=0;const w=/([^()\[\]{}<>\s+\-/%~#^;=|,`!]|\->)+/g;let g=null;for(;g=w.exec(n);){const C=g.index+1,U=C+g[0].length;if(C<=i&&U>=r){t=g[0],c=C;break}}if(t){const C=/\w+/g;let U=null;for(;(U=C.exec(t))&&!(U.index+1+c+U[0].length>=r););U&&(t=t.substring(0,C.lastIndex))}return t?{start:c,end:c+t.length-1}:{start:0,end:0}}e.getExactExpressionStartAndEnd=I;const f=/^[a-zA-Z][a-zA-Z0-9\+\-\.]+:/;function h(n){return!!(n&&n.match(f))}e.isUri=h;function d(n){if(typeof n.path=="string"&&!(typeof n.sourceReference=="number"&&n.sourceReference>0)){if(h(n.path))return p.URI.parse(n.path);if((0,b.isAbsolute)(n.path))return p.URI.file(n.path)}return n.path}function a(n){if(typeof n.path=="object"){const i=p.URI.revive(n.path);if(i)return i.scheme===D.Schemas.file?i.fsPath:i.toString()}return n.path}function v(n,i){const r=i?d:a,t=(0,L.deepClone)(n);return l(t,(c,w)=>{c&&w&&(w.path=r(w))}),t}e.convertToDAPaths=v;function A(n,i){const r=i?d:a,t=(0,L.deepClone)(n);return l(t,(c,w)=>{!c&&w&&(w.path=r(w))}),t}e.convertToVSCPaths=A;function l(n,i){switch(n.type){case"event":{const r=n;switch(r.event){case"output":i(!1,r.body.source);break;case"loadedSource":i(!1,r.body.source);break;case"breakpoint":i(!1,r.body.breakpoint.source);break;default:break}break}case"request":{const r=n;switch(r.command){case"setBreakpoints":i(!0,r.arguments.source);break;case"breakpointLocations":i(!0,r.arguments.source);break;case"source":i(!0,r.arguments.source);break;case"gotoTargets":i(!0,r.arguments.source);break;case"launchVSCode":r.arguments.args.forEach(t=>i(!1,t));break;default:break}break}case"response":{const r=n;if(r.success&&r.body)switch(r.command){case"stackTrace":r.body.stackFrames.forEach(t=>i(!1,t.source));break;case"loadedSources":r.body.sources.forEach(t=>i(!1,t));break;case"scopes":r.body.scopes.forEach(t=>i(!1,t.source));break;case"setFunctionBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"setBreakpoints":r.body.breakpoints.forEach(t=>i(!1,t.source));break;case"disassemble":r.body?.instructions.forEach(c=>i(!1,c.location));break;default:break}break}}}function _(n){return n.filter(i=>!i.presentation?.hidden).sort((i,r)=>i.presentation?r.presentation?i.presentation.group?r.presentation.group?i.presentation.group!==r.presentation.group?i.presentation.group.localeCompare(r.presentation.group):s(i.presentation.order,r.presentation.order):-1:r.presentation.group?1:s(i.presentation.order,r.presentation.order):-1:r.presentation?1:0)}e.getVisibleAndSorted=_;function s(n,i){return typeof n!="number"?typeof i!="number"?0:1:typeof i!="number"?-1:n-i}async function u(n,i){const r=n.getValue("debug.saveBeforeStart",{overrideIdentifier:i.activeTextEditorLanguageId});if(r!=="none"&&(await i.saveAll(),r==="allEditorsInActiveGroup")){const t=i.activeEditorPane;t&&t.input.resource?.scheme===D.Schemas.untitled&&await i.save({editor:t.input,groupId:t.group.id})}await n.reloadConfiguration()}e.saveAllBeforeDebugStart=u}),define(De[88],Ce([1,0,22,34,167,74,12,19,23,38]),function(te,e,o,p,b,L,D,T,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NotebookWorkingCopyTypeIdentifier=e.CellStatusbarAlignment=e.NotebookSetting=e.notebookDocumentFilterMatch=e.isDocumentExcludePattern=e.NotebookEditorPriority=e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=e.diff=e.MimeTypeDisplayOrder=e.CellUri=e.CellEditType=e.SelectionStateType=e.NotebookCellsChangeType=e.RendererMessagingSpec=e.NotebookRendererMatch=e.NotebookCellExecutionState=e.NotebookRunState=e.RENDERER_NOT_AVAILABLE=e.RENDERER_EQUIVALENT_EXTENSIONS=e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=e.NOTEBOOK_DISPLAY_ORDER=e.CellKind=e.NOTEBOOK_DIFF_EDITOR_ID=e.NOTEBOOK_EDITOR_ID=void 0,e.NOTEBOOK_EDITOR_ID="workbench.editor.notebook",e.NOTEBOOK_DIFF_EDITOR_ID="workbench.editor.notebookTextDiffEditor";var R;(function(t){t[t.Markup=1]="Markup",t[t.Code=2]="Code"})(R=e.CellKind||(e.CellKind={})),e.NOTEBOOK_DISPLAY_ORDER=["application/json","application/javascript","text/html","image/svg+xml",L.Mimes.latex,L.Mimes.markdown,"image/png","image/jpeg",L.Mimes.text],e.ACCESSIBLE_NOTEBOOK_DISPLAY_ORDER=[L.Mimes.latex,L.Mimes.markdown,"application/json",L.Mimes.text,"text/html","image/svg+xml","image/png","image/jpeg"],e.RENDERER_EQUIVALENT_EXTENSIONS=new Map([["ms-toolsai.jupyter",new Set(["jupyter-notebook","interactive"])],["ms-toolsai.jupyter-renderers",new Set(["jupyter-notebook","interactive"])]]),e.RENDERER_NOT_AVAILABLE="_notAvailable";var y;(function(t){t[t.Running=1]="Running",t[t.Idle=2]="Idle"})(y=e.NotebookRunState||(e.NotebookRunState={}));var m;(function(t){t[t.Unconfirmed=1]="Unconfirmed",t[t.Pending=2]="Pending",t[t.Executing=3]="Executing"})(m=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var I;(function(t){t[t.WithHardKernelDependency=0]="WithHardKernelDependency",t[t.WithOptionalKernelDependency=1]="WithOptionalKernelDependency",t[t.Pure=2]="Pure",t[t.Never=3]="Never"})(I=e.NotebookRendererMatch||(e.NotebookRendererMatch={}));var f;(function(t){t.Always="always",t.Never="never",t.Optional="optional"})(f=e.RendererMessagingSpec||(e.RendererMessagingSpec={}));var h;(function(t){t[t.ModelChange=1]="ModelChange",t[t.Move=2]="Move",t[t.ChangeCellLanguage=5]="ChangeCellLanguage",t[t.Initialize=6]="Initialize",t[t.ChangeCellMetadata=7]="ChangeCellMetadata",t[t.Output=8]="Output",t[t.OutputItem=9]="OutputItem",t[t.ChangeCellContent=10]="ChangeCellContent",t[t.ChangeDocumentMetadata=11]="ChangeDocumentMetadata",t[t.ChangeCellInternalMetadata=12]="ChangeCellInternalMetadata",t[t.ChangeCellMime=13]="ChangeCellMime",t[t.Unknown=100]="Unknown"})(h=e.NotebookCellsChangeType||(e.NotebookCellsChangeType={}));var d;(function(t){t[t.Handle=0]="Handle",t[t.Index=1]="Index"})(d=e.SelectionStateType||(e.SelectionStateType={}));var a;(function(t){t[t.Replace=1]="Replace",t[t.Output=2]="Output",t[t.Metadata=3]="Metadata",t[t.CellLanguage=4]="CellLanguage",t[t.DocumentMetadata=5]="DocumentMetadata",t[t.Move=6]="Move",t[t.OutputItems=7]="OutputItems",t[t.PartialMetadata=8]="PartialMetadata",t[t.PartialInternalMetadata=9]="PartialInternalMetadata"})(a=e.CellEditType||(e.CellEditType={}));var v;(function(t){t.scheme=D.Schemas.vscodeNotebookCell;const c=["W","X","Y","Z","a","b","c","d","e","f"],w=new RegExp(`^[${c.join("")}]+`),g=7;function C(N,K){const V=K.toString(g),ne=`${V.length<c.length?c[V.length-1]:"z"}${V}s${(0,o.encodeBase64)(o.VSBuffer.fromString(N.scheme),!0,!0)}`;return N.with({scheme:t.scheme,fragment:ne})}t.generate=C;function U(N){if(N.scheme!==t.scheme)return;const K=N.fragment.indexOf("s");if(K<0)return;const V=parseInt(N.fragment.substring(0,K).replace(w,""),g),F=(0,o.decodeBase64)(N.fragment.substring(K+1)).toString();if(!isNaN(V))return{handle:V,notebook:N.with({scheme:F,fragment:null})}}t.parse=U;const W=/^(\d{8,})(\w[\w\d+.-]*)$/;function M(N,K){return N.with({scheme:D.Schemas.vscodeNotebookCellOutput,fragment:`op${K??""},${N.scheme!==D.Schemas.file?N.scheme:""}`})}t.generateCellOutputUri=M;function S(N){if(N.scheme!==D.Schemas.vscodeNotebookCellOutput)return;const K=/^op([0-9a-f]{8}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{4}-[0-9a-f]{12})?\,(.*)$/i.exec(N.fragment);if(!K)return;const V=K[1]&&K[1]!==""?K[1]:void 0,F=K[2];return{outputId:V,notebook:N.with({scheme:F||D.Schemas.file,fragment:null})}}t.parseCellOutputUri=S;function z(N,K,V){return N.with({scheme:V,fragment:`ch${K.toString().padStart(7,"0")}${N.scheme!==D.Schemas.file?N.scheme:""}`})}t.generateCellUri=z;function $(N,K){if(N.scheme!==K)return;const V=W.exec(N.fragment);return V?{handle:Number(V[1]),notebook:N.with({scheme:N.fragment.substring(V[0].length)||D.Schemas.file,fragment:null})}:void 0}t.parseCellUri=$})(v=e.CellUri||(e.CellUri={}));const A=t=>E.isWindows?t.replace(/\//g,"\\"):t;class l{constructor(c=[],w=e.NOTEBOOK_DISPLAY_ORDER){this.defaultOrder=w,this.order=[...new Set(c)].map(g=>({pattern:g,matches:p.parse(A(g))}))}sort(c){const w=new Map(b.Iterable.map(c,C=>[C,A(C)]));let g=[];for(const{matches:C}of this.order)for(const[U,W]of w)if(C(W)){g.push(U),w.delete(U);break}return w.size&&(g=g.concat([...w.keys()].sort((C,U)=>this.defaultOrder.indexOf(C)-this.defaultOrder.indexOf(U)))),g}prioritize(c,w){const g=this.findIndex(c);if(g===-1){this.order.unshift({pattern:c,matches:p.parse(A(c))});return}const C=new Set(w.map(W=>this.findIndex(W,g)));C.delete(-1);const U=Array.from(C).sort();this.order.splice(g+1,0,...U.map(W=>this.order[W]));for(let W=U.length-1;W>=0;W--)this.order.splice(U[W],1)}toArray(){return this.order.map(c=>c.pattern)}findIndex(c,w=this.order.length){const g=A(c);for(let C=0;C<w;C++)if(this.order[C].matches(g))return C;return-1}}e.MimeTypeDisplayOrder=l;function _(t,c,w,g=(C,U)=>C===U){const C=[];function U(S,z,$){if(z===0&&$.length===0)return;const N=C[C.length-1];N&&N.start+N.deleteCount===S?(N.deleteCount+=z,N.toInsert.push(...$)):C.push({start:S,deleteCount:z,toInsert:$})}let W=0,M=0;for(;;){if(W===t.length){U(W,0,c.slice(M));break}if(M===c.length){U(W,t.length-W,[]);break}const S=t[W],z=c[M];if(g(S,z)){W+=1,M+=1;continue}w(z)?(U(W,1,[]),W+=1):(U(W,0,[z]),M+=1)}return C}e.diff=_,e.NOTEBOOK_EDITOR_CURSOR_BOUNDARY=new P.RawContextKey("notebookEditorCursorAtBoundary","none");var s;(function(t){t.default="default",t.option="option"})(s=e.NotebookEditorPriority||(e.NotebookEditorPriority={}));function u(t){const c=t;return!!((typeof c.include=="string"||p.isRelativePattern(c.include))&&(typeof c.exclude=="string"||p.isRelativePattern(c.exclude)))}e.isDocumentExcludePattern=u;function n(t,c,w){if(Array.isArray(t.viewType)&&t.viewType.indexOf(c)>=0||t.viewType===c)return!0;if(t.filenamePattern){const g=u(t.filenamePattern)?t.filenamePattern.include:t.filenamePattern,C=u(t.filenamePattern)?t.filenamePattern.exclude:void 0;if(p.match(g,(0,T.basename)(w.fsPath).toLowerCase()))return!(C&&p.match(C,(0,T.basename)(w.fsPath).toLowerCase()))}return!1}e.notebookDocumentFilterMatch=n,e.NotebookSetting={displayOrder:"notebook.displayOrder",cellToolbarLocation:"notebook.cellToolbarLocation",cellToolbarVisibility:"notebook.cellToolbarVisibility",showCellStatusBar:"notebook.showCellStatusBar",textDiffEditorPreview:"notebook.diff.enablePreview",experimentalInsertToolbarAlignment:"notebook.experimental.insertToolbarAlignment",compactView:"notebook.compactView",focusIndicator:"notebook.cellFocusIndicator",insertToolbarLocation:"notebook.insertToolbarLocation",globalToolbar:"notebook.globalToolbar",undoRedoPerCell:"notebook.undoRedoPerCell",consolidatedOutputButton:"notebook.consolidatedOutputButton",showFoldingControls:"notebook.showFoldingControls",dragAndDropEnabled:"notebook.dragAndDropEnabled",cellEditorOptionsCustomizations:"notebook.editorOptionsCustomizations",consolidatedRunButton:"notebook.consolidatedRunButton",openGettingStarted:"notebook.experimental.openGettingStarted",textOutputLineLimit:"notebook.output.textLineLimit",globalToolbarShowLabel:"notebook.globalToolbarShowLabel",markupFontSize:"notebook.markup.fontSize",interactiveWindowCollapseCodeCells:"interactiveWindow.collapseCellInputCode",outputLineHeight:"notebook.outputLineHeight",outputFontSize:"notebook.outputFontSize",outputFontFamily:"notebook.outputFontFamily"};var i;(function(t){t[t.Left=1]="Left",t[t.Right=2]="Right"})(i=e.CellStatusbarAlignment||(e.CellStatusbarAlignment={}));class r{static create(c){return`${r._prefix}${c}`}static parse(c){if(c.startsWith(r._prefix))return c.substring(r._prefix.length)}}e.NotebookWorkingCopyTypeIdentifier=r,r._prefix="notebook/"}),define(De[168],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.INotebookExecutionService=e.CellExecutionUpdateType=void 0;var p;(function(b){b[b.Output=1]="Output",b[b.OutputItems=2]="OutputItems",b[b.ExecutionState=3]="ExecutionState"})(p=e.CellExecutionUpdateType||(e.CellExecutionUpdateType={})),e.INotebookExecutionService=(0,o.createDecorator)("INotebookExecutionService")}),define(De[169],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.deserializeEnvironmentVariableCollections=e.serializeEnvironmentVariableCollections=e.deserializeEnvironmentVariableCollection=e.serializeEnvironmentVariableCollection=void 0;function o(D){return[...D.entries()]}e.serializeEnvironmentVariableCollection=o;function p(D){return new Map(D)}e.deserializeEnvironmentVariableCollection=p;function b(D){return Array.from(D.entries()).map(T=>[T[0],o(T[1].map)])}e.serializeEnvironmentVariableCollections=b;function L(D){return new Map(D.map(T=>[T[0],{map:p(T[1])}]))}e.deserializeEnvironmentVariableCollections=L}),define(De[46],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TestId=e.TestPosition=e.TestIdPathParts=void 0;var o;(function(L){L.Delimiter="\0"})(o=e.TestIdPathParts||(e.TestIdPathParts={}));var p;(function(L){L[L.IsSame=0]="IsSame",L[L.Disconnected=1]="Disconnected",L[L.IsChild=2]="IsChild",L[L.IsParent=3]="IsParent"})(p=e.TestPosition||(e.TestPosition={}));class b{constructor(D,T=D.length){if(this.path=D,this.viewEnd=T,D.length===0||T<1)throw new Error("cannot create test with empty path")}static fromExtHostTestItem(D,T,E=D.parent){if(D.id===T)return new b([T]);const P=[D.id];for(let R=E;R&&R.id!==T;R=R.parent)P.push(R.id);return P.push(T),new b(P.reverse())}static isRoot(D){return!D.includes("\0")}static root(D){const T=D.indexOf("\0");return T===-1?D:D.slice(0,T)}static fromString(D){return new b(D.split("\0"))}static join(D,T){return new b([...D.path,T])}static joinToString(D,T){return D.toString()+"\0"+T}static compare(D,T){return D===T?0:T.startsWith(D+"\0")?2:D.startsWith(T+"\0")?3:1}get parentId(){return this.viewEnd>1?new b(this.path,this.viewEnd-1):this}get localId(){return this.path[this.viewEnd-1]}get controllerId(){return this.path[0]}get isRoot(){return this.viewEnd===1}*idsFromRoot(){for(let D=1;D<=this.viewEnd;D++)yield new b(this.path,D)}compare(D){if(typeof D=="string")return b.compare(this.toString(),D);for(let T=0;T<D.viewEnd&&T<this.viewEnd;T++)if(D.path[T]!==this.path[T])return 1;return D.viewEnd>this.viewEnd?2:D.viewEnd<this.viewEnd?3:0}toJSON(){return this.toString()}toString(){if(!this.stringifed){this.stringifed=this.path[0];for(let D=1;D<this.viewEnd;D++)this.stringifed+="\0",this.stringifed+=this.path[D]}return this.stringifed}}e.TestId=b}),define(De[47],Ce([1,0,2,48]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractIncrementalTestCollection=e.IncrementalChangeCollector=e.TestsDiffOp=e.TestDiffOpType=e.DetailType=e.TestResultItem=e.applyTestItemUpdate=e.ITestItemUpdate=e.InternalTestItem=e.TestItemExpandState=e.ITestItem=e.denamespaceTestTag=e.namespaceTestTag=e.ITestTaskState=e.ITestMessage=e.ITestOutputMessage=e.ITestErrorMessage=e.TestMessageType=e.IRichLocation=e.testRunProfileBitsetList=e.TestRunProfileBitset=e.TestResultState=void 0;var b;(function(r){r[r.Unset=0]="Unset",r[r.Queued=1]="Queued",r[r.Running=2]="Running",r[r.Passed=3]="Passed",r[r.Failed=4]="Failed",r[r.Skipped=5]="Skipped",r[r.Errored=6]="Errored"})(b=e.TestResultState||(e.TestResultState={}));var L;(function(r){r[r.Run=2]="Run",r[r.Debug=4]="Debug",r[r.Coverage=8]="Coverage",r[r.HasNonDefaultProfile=16]="HasNonDefaultProfile",r[r.HasConfigurable=32]="HasConfigurable"})(L=e.TestRunProfileBitset||(e.TestRunProfileBitset={})),e.testRunProfileBitsetList=[2,4,8,16];var D;(function(r){r.serialize=t=>({range:t.range.toJSON(),uri:t.uri.toJSON()}),r.deserialize=t=>({range:p.Range.lift(t.range),uri:o.URI.revive(t.uri)})})(D=e.IRichLocation||(e.IRichLocation={}));var T;(function(r){r[r.Error=0]="Error",r[r.Output=1]="Output"})(T=e.TestMessageType||(e.TestMessageType={}));var E;(function(r){r.serialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:0,expected:t.expected,actual:t.actual,location:t.location&&D.deserialize(t.location)})})(E=e.ITestErrorMessage||(e.ITestErrorMessage={}));var P;(function(r){r.serialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&D.serialize(t.location)}),r.deserialize=t=>({message:t.message,type:1,offset:t.offset,length:t.length,location:t.location&&D.deserialize(t.location)})})(P=e.ITestOutputMessage||(e.ITestOutputMessage={}));var R;(function(r){r.serialize=t=>t.type===0?E.serialize(t):P.serialize(t),r.deserialize=t=>t.type===0?E.deserialize(t):P.deserialize(t)})(R=e.ITestMessage||(e.ITestMessage={}));var y;(function(r){r.serializeWithoutMessages=t=>({state:t.state,duration:t.duration,messages:[]}),r.serialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.serialize)}),r.deserialize=t=>({state:t.state,duration:t.duration,messages:t.messages.map(R.deserialize)})})(y=e.ITestTaskState||(e.ITestTaskState={}));const m="\0",I=(r,t)=>r+m+t;e.namespaceTestTag=I;const f=r=>{const t=r.indexOf(m);return{ctrlId:r.slice(0,t),tagId:r.slice(t+1)}};e.denamespaceTestTag=f;var h;(function(r){r.serialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?.toJSON(),range:t.range?.toJSON()||null,description:t.description,error:t.error,sortText:t.sortText}),r.deserialize=t=>({extId:t.extId,label:t.label,tags:t.tags,busy:t.busy,children:void 0,uri:t.uri?o.URI.revive(t.uri):void 0,range:t.range?p.Range.lift(t.range):null,description:t.description,error:t.error,sortText:t.sortText})})(h=e.ITestItem||(e.ITestItem={}));var d;(function(r){r[r.NotExpandable=0]="NotExpandable",r[r.Expandable=1]="Expandable",r[r.BusyExpanding=2]="BusyExpanding",r[r.Expanded=3]="Expanded"})(d=e.TestItemExpandState||(e.TestItemExpandState={}));var a;(function(r){r.serialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.serialize(t.item)}),r.deserialize=t=>({controllerId:t.controllerId,expand:t.expand,parent:t.parent,item:h.deserialize(t.item)})})(a=e.InternalTestItem||(e.InternalTestItem={}));var v;(function(r){r.serialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.uri!==void 0&&(c.uri=t.item.uri?.toJSON()),t.item.range!==void 0&&(c.range=t.item.range?.toJSON()),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}},r.deserialize=t=>{let c;return t.item&&(c={},t.item.label!==void 0&&(c.label=t.item.label),t.item.tags!==void 0&&(c.tags=t.item.tags),t.item.busy!==void 0&&(c.busy=t.item.busy),t.item.range!==void 0&&(c.range=t.item.range?p.Range.lift(t.item.range):null),t.item.description!==void 0&&(c.description=t.item.description),t.item.error!==void 0&&(c.error=t.item.error),t.item.sortText!==void 0&&(c.sortText=t.item.sortText)),{extId:t.extId,expand:t.expand,item:c}}})(v=e.ITestItemUpdate||(e.ITestItemUpdate={}));const A=(r,t)=>{t.expand!==void 0&&(r.expand=t.expand),t.item!==void 0&&(r.item=r.item?Object.assign(r.item,t.item):t.item)};e.applyTestItemUpdate=A;var l;(function(r){r.serializeWithoutMessages=t=>({...a.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serializeWithoutMessages),retired:t.retired}),r.serialize=t=>({...a.serialize(t),ownComputedState:t.ownComputedState,computedState:t.computedState,tasks:t.tasks.map(y.serialize),retired:t.retired})})(l=e.TestResultItem||(e.TestResultItem={}));var _;(function(r){r[r.Function=0]="Function",r[r.Statement=1]="Statement"})(_=e.DetailType||(e.DetailType={}));var s;(function(r){r[r.Add=0]="Add",r[r.Update=1]="Update",r[r.Remove=2]="Remove",r[r.IncrementPendingExtHosts=3]="IncrementPendingExtHosts",r[r.Retire=4]="Retire",r[r.AddTag=5]="AddTag",r[r.RemoveTag=6]="RemoveTag"})(s=e.TestDiffOpType||(e.TestDiffOpType={}));var u;(function(r){r.deserialize=t=>t.op===0?{op:t.op,item:a.deserialize(t.item)}:t.op===1?{op:t.op,item:v.deserialize(t.item)}:t,r.serialize=t=>t.op===0?{op:t.op,item:a.serialize(t.item)}:t.op===1?{op:t.op,item:v.serialize(t.item)}:t})(u=e.TestsDiffOp||(e.TestsDiffOp={}));class n{add(t){}update(t){}remove(t,c){}complete(){}}e.IncrementalChangeCollector=n;class i{constructor(){this._tags=new Map,this.items=new Map,this.roots=new Set,this.busyControllerCount=0,this.pendingRootCount=0,this.tags=this._tags}apply(t){const c=this.createChangeCollector();for(const w of t)switch(w.op){case 0:{const g=a.deserialize(w.item);if(g.parent){if(this.items.has(g.parent)){const C=this.items.get(g.parent);C.children.add(g.item.extId);const U=this.createItem(g,C);this.items.set(g.item.extId,U),c.add(U)}}else{const C=this.createItem(g);this.roots.add(C),this.items.set(g.item.extId,C),c.add(C)}g.expand===2&&this.busyControllerCount++;break}case 1:{const g=v.deserialize(w.item),C=this.items.get(g.extId);if(!C)break;g.expand!==void 0&&(C.expand===2&&this.busyControllerCount--,g.expand===2&&this.busyControllerCount++),(0,e.applyTestItemUpdate)(C,g),c.update(C);break}case 2:{const g=this.items.get(w.itemId);if(!g)break;g.parent?this.items.get(g.parent).children.delete(g.item.extId):this.roots.delete(g);const C=[[w.itemId]];for(;C.length;)for(const U of C.pop()){const W=this.items.get(U);W&&(C.push(W.children),this.items.delete(U),c.remove(W,W!==g),W.expand===2&&this.busyControllerCount--)}break}case 4:this.retireTest(w.itemId);break;case 3:this.updatePendingRoots(w.amount);break;case 5:this._tags.set(w.tag.id,w.tag);break;case 6:this._tags.delete(w.id);break}c.complete()}retireTest(t){}updatePendingRoots(t){this.pendingRootCount+=t}createChangeCollector(){return new n}}e.AbstractIncrementalTestCollection=i}),define(De[65],Ce([1,0,13,4,7,44,47,46]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createTestItemChildren=e.MixedTestItemController=e.InvalidTestItemError=e.DuplicateTestItemError=e.TestItemCollection=e.TestItemEventOp=void 0;var E;(function(a){a[a.Upsert=0]="Upsert",a[a.SetTags=1]="SetTags",a[a.UpdateCanResolveChildren=2]="UpdateCanResolveChildren",a[a.RemoveChild=3]="RemoveChild",a[a.SetProp=4]="SetProp",a[a.Bulk=5]="Bulk"})(E=e.TestItemEventOp||(e.TestItemEventOp={}));const P=(a,v)=>a===v,R={range:(a,v)=>a===v?!0:!a||!v?!1:a.equalsRange(v),busy:P,label:P,description:P,error:P,tags:(a,v)=>!(a.length!==v.length||a.some(A=>!v.includes(A)))},y=(a,v)=>{let A;for(const[l,_]of Object.entries(R))_(a[l],v[l])||(A?A[l]=v[l]:A={[l]:v[l]});return A};class m extends b.Disposable{constructor(v){super();this.options=v,this.debounceSendDiff=this._register(new o.RunOnceScheduler(()=>this.flushDiff(),200)),this.diffOpEmitter=this._register(new p.Emitter),this.tree=new Map,this.tags=new Map,this.diff=[],this.onDidGenerateDiff=this.diffOpEmitter.event,this.root.canResolveChildren=!0,this.upsertItem(this.root,void 0)}get root(){return this.options.root}set resolveHandler(v){this._resolveHandler=v;for(const A of this.tree.values())this.updateExpandability(A)}collectDiff(){const v=this.diff;return this.diff=[],v}pushDiff(v){const A=this.diff[this.diff.length-1];if(A&&v.op===1){if(A.op===1&&A.item.extId===v.item.extId){(0,D.applyTestItemUpdate)(A.item,v.item);return}if(A.op===0&&A.item.item.extId===v.item.extId){(0,D.applyTestItemUpdate)(A.item,v.item);return}}this.diff.push(v),this.debounceSendDiff.isScheduled()||this.debounceSendDiff.schedule()}expand(v,A){const l=this.tree.get(v);if(!!l){if((l.expandLevels===void 0||A>l.expandLevels)&&(l.expandLevels=A),l.expand===1){const _=this.resolveChildren(l);return _.isOpen()?this.expandChildren(l,A-1):_.wait().then(()=>this.expandChildren(l,A-1))}else if(l.expand===3)return l.resolveBarrier?.isOpen()===!1?l.resolveBarrier.wait().then(()=>this.expandChildren(l,A-1)):this.expandChildren(l,A-1)}}dispose(){for(const v of this.tree.values())this.options.getApiFor(v.actual).listener=void 0;this.tree.clear(),this.diff=[],super.dispose()}onTestItemEvent(v,A){switch(A.op){case 3:this.removeItem(T.TestId.joinToString(v.fullId,A.id));break;case 0:this.upsertItem(A.item,v);break;case 5:for(const l of A.ops)this.onTestItemEvent(v,l);break;case 1:this.diffTagRefs(A.new,A.old,v.fullId.toString());break;case 2:this.updateExpandability(v);break;case 4:this.pushDiff({op:1,item:{extId:v.fullId.toString(),item:A.update}});break;default:(0,L.assertNever)(A)}}upsertItem(v,A){const l=T.TestId.fromExtHostTestItem(v,this.root.id,A?.actual),_=this.options.getApiFor(v);_.parent&&_.parent!==A?.actual&&this.options.getChildren(_.parent).delete(v.id);let s=this.tree.get(l.toString());if(!s){s={fullId:l,actual:v,parent:A?l.parentId:null,expandLevels:A?.expandLevels?A.expandLevels-1:void 0,expand:0},v.tags.forEach(this.incrementTagRefs,this),this.tree.set(s.fullId.toString(),s),this.setItemParent(v,A),this.pushDiff({op:0,item:{parent:s.parent&&s.parent.toString(),controllerId:this.options.controllerId,expand:s.expand,item:this.options.toITestItem(v)}}),this.connectItemAndChildren(v,s,A);return}if(s.actual===v){this.connectItem(v,s,A);return}const u=this.options.getChildren(s.actual),n=s.actual,i=y(this.options.toITestItem(n),this.options.toITestItem(v));this.options.getApiFor(n).listener=void 0,s.actual=v,s.expand=0,i&&(i.hasOwnProperty("tags")&&(this.diffTagRefs(v.tags,n.tags,l.toString()),delete i.tags),this.onTestItemEvent(s,{op:4,update:i})),this.connectItemAndChildren(v,s,A);for(const[r,t]of u)this.options.getChildren(v).get(t.id)||this.removeItem(T.TestId.joinToString(l,t.id))}diffTagRefs(v,A,l){const _=new Set(A.map(s=>s.id));for(const s of v)_.delete(s.id)||this.incrementTagRefs(s);this.pushDiff({op:1,item:{extId:l,item:{tags:v.map(s=>(0,D.namespaceTestTag)(this.options.controllerId,s.id))}}}),_.forEach(this.decrementTagRefs,this)}incrementTagRefs(v){const A=this.tags.get(v.id);A?A.refCount++:(this.tags.set(v.id,{refCount:1}),this.pushDiff({op:5,tag:{id:(0,D.namespaceTestTag)(this.options.controllerId,v.id)}}))}decrementTagRefs(v){const A=this.tags.get(v);A&&!--A.refCount&&(this.tags.delete(v),this.pushDiff({op:6,id:(0,D.namespaceTestTag)(this.options.controllerId,v)}))}setItemParent(v,A){this.options.getApiFor(v).parent=A&&A.actual!==this.root?A.actual:void 0}connectItem(v,A,l){this.setItemParent(v,l);const _=this.options.getApiFor(v);_.parent=l?.actual,_.listener=s=>this.onTestItemEvent(A,s),this.updateExpandability(A)}connectItemAndChildren(v,A,l){this.connectItem(v,A,l);for(const[_,s]of this.options.getChildren(v))this.upsertItem(s,A)}updateExpandability(v){let A;this._resolveHandler?v.resolveBarrier?A=v.resolveBarrier.isOpen()?3:2:A=v.actual.canResolveChildren?1:0:A=0,A!==v.expand&&(v.expand=A,this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:A}}),A===1&&v.expandLevels!==void 0&&this.resolveChildren(v))}expandChildren(v,A){if(A<0)return;const l=[];for(const[_,s]of this.options.getChildren(v.actual)){const u=this.expand(T.TestId.joinToString(v.fullId,s.id),A);(0,o.isThenable)(u)&&l.push(u)}if(l.length)return Promise.all(l).then(()=>{})}resolveChildren(v){if(v.resolveBarrier)return v.resolveBarrier;if(!this._resolveHandler){const s=new o.Barrier;return s.open(),s}v.expand=2,this.pushExpandStateUpdate(v);const A=v.resolveBarrier=new o.Barrier,l=s=>{console.error(`Unhandled error in resolveHandler of test controller "${this.options.controllerId}"`,s)};let _;try{_=this._resolveHandler(v.actual===this.root?void 0:v.actual)}catch(s){l(s)}return(0,o.isThenable)(_)?_.catch(l).then(()=>{A.open(),this.updateExpandability(v)}):(A.open(),this.updateExpandability(v)),v.resolveBarrier}pushExpandStateUpdate(v){this.pushDiff({op:1,item:{extId:v.fullId.toString(),expand:v.expand}})}removeItem(v){const A=this.tree.get(v);if(!A)throw new Error("attempting to remove non-existent child");this.pushDiff({op:2,itemId:v});const l=[A];for(;l.length;){const _=l.pop();if(!!_){this.options.getApiFor(_.actual).listener=void 0;for(const s of _.actual.tags)this.decrementTagRefs(s.id);this.tree.delete(_.fullId.toString());for(const[s,u]of this.options.getChildren(_.actual))l.push(this.tree.get(T.TestId.joinToString(_.fullId,u.id)))}}}flushDiff(){const v=this.collectDiff();v.length&&this.diffOpEmitter.fire(v)}}e.TestItemCollection=m;class I extends Error{constructor(v){super(`Attempted to insert a duplicate test item ID ${v}`)}}e.DuplicateTestItemError=I;class f extends Error{constructor(v){super(`TestItem with ID "${v}" is invalid. Make sure to create it from the createTestItem method.`)}}e.InvalidTestItemError=f;class h extends Error{constructor(v,A,l){super(`TestItem with ID "${v}" is from controller "${A}" and cannot be added as a child of an item from controller "${l}".`)}}e.MixedTestItemController=h;const d=(a,v,A)=>{let l=new Map;return{get size(){return l.size},forEach(_,s){for(const u of l.values())_.call(s,u,this)},[Symbol.iterator](){return l.entries()},replace(_){const s=new Map,u=new Set(l.keys()),n={op:5,ops:[]};for(const i of _){if(!(i instanceof A))throw new f(i.id);const r=v(i).controllerId;if(r!==a.controllerId)throw new h(i.id,r,a.controllerId);if(s.has(i.id))throw new I(i.id);s.set(i.id,i),u.delete(i.id),n.ops.push({op:0,item:i})}for(const i of u.keys())n.ops.push({op:3,id:i});a.listener?.(n),l=s},add(_){if(!(_ instanceof A))throw new f(_.id);l.set(_.id,_),a.listener?.({op:0,item:_})},delete(_){l.delete(_)&&a.listener?.({op:3,id:_})},get(_){return l.get(_)},toJSON(){return Array.from(l.values())}}};e.createTestItemChildren=d}),define(De[89],Ce([1,0,65]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.getPrivateApiFor=e.createPrivateApiFor=void 0;const p=new WeakMap,b=(D,T)=>{const E={controllerId:T};return p.set(D,E),E};e.createPrivateApiFor=b;const L=D=>{const T=p.get(D);if(!T)throw new o.InvalidTestItemError(D?.id||"<unknown>");return T};e.getPrivateApiFor=L}),define(De[170],Ce([1,0,19,59,10,26,23,76,140,9]),function(te,e,o,p,b,L,D,T,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractVariableResolverService=void 0;class R{constructor(m,I,f,h){this._contributedVariables=new Map,this._context=m,this._labelService=I,this._userHomePromise=f,h&&(this._envVariablesPromise=h.then(d=>this.prepareEnv(d)))}prepareEnv(m){if(D.isWindows){const I=Object.create(null);return Object.keys(m).forEach(f=>{I[f.toLowerCase()]=m[f]}),I}return m}resolveWithEnvironment(m,I,f){return this.recursiveResolve({env:this.prepareEnv(m),userHome:void 0},I?I.uri:void 0,f)}async resolveAsync(m,I){const f={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(f,m?m.uri:void 0,I)}async resolveAnyBase(m,I,f,h){const d=L.deepClone(I);D.isWindows&&d.windows?Object.keys(d.windows).forEach(v=>d[v]=d.windows[v]):D.isMacintosh&&d.osx?Object.keys(d.osx).forEach(v=>d[v]=d.osx[v]):D.isLinux&&d.linux&&Object.keys(d.linux).forEach(v=>d[v]=d.linux[v]),delete d.windows,delete d.osx,delete d.linux;const a={env:await this._envVariablesPromise,userHome:await this._userHomePromise};return this.recursiveResolve(a,m?m.uri:void 0,d,f,h)}async resolveAnyAsync(m,I,f){return this.resolveAnyBase(m,I,f)}async resolveAnyMap(m,I,f){const h=new Map;return{newConfig:await this.resolveAnyBase(m,I,f,h),resolvedVariables:h}}resolveWithInteractionReplace(m,I,f,h){throw new Error("resolveWithInteractionReplace not implemented.")}resolveWithInteraction(m,I,f,h){throw new Error("resolveWithInteraction not implemented.")}contributeVariable(m,I){if(this._contributedVariables.has(m))throw new Error("Variable "+m+" is contributed twice.");this._contributedVariables.set(m,I)}async recursiveResolve(m,I,f,h,d){if(b.isString(f))return this.resolveString(m,I,f,h,d);if(Array.isArray(f))return Promise.all(f.map(a=>this.recursiveResolve(m,I,a,h,d)));if(b.isObject(f)){const a=Object.create(null),v=await Promise.all(Object.keys(f).map(async A=>[await this.resolveString(m,I,A,h,d),await this.recursiveResolve(m,I,f[A],h,d)]));for(const[A,l]of v)a[A]=l;return a}return f}resolveString(m,I,f,h,d){return(0,P.replaceAsync)(f,R.VARIABLE_REGEXP,async(a,v)=>{if(v.includes(R.VARIABLE_LHS))return a;let A=await this.evaluateSingleVariable(m,a,v,I,h);return d?.set(v,A),A!==a&&b.isString(A)&&A.match(R.VARIABLE_REGEXP)&&(A=await this.resolveString(m,I,A,h,d)),A})}fsPath(m){return this._labelService?this._labelService.getUriLabel(m,{noPrefix:!0}):m.fsPath}async evaluateSingleVariable(m,I,f,h,d){let a;const v=f.split(":");v.length>1&&(f=v[0],a=v[1]);const A=()=>{const s=this._context.getFilePath();if(s)return s;throw new Error((0,E.localize)(0,null,I))},l=()=>{const s=A();if(this._context.getWorkspaceFolderPathForFile){const u=this._context.getWorkspaceFolderPathForFile();if(u)return u}throw new Error((0,E.localize)(1,null,I,o.basename(s)))},_=()=>{if(a){const s=this._context.getFolderUri(a);if(s)return s;throw new Error((0,E.localize)(2,null,I,a))}if(h)return h;throw this._context.getWorkspaceFolderCount()>1?new Error((0,E.localize)(3,null,I)):new Error((0,E.localize)(4,null,I))};switch(f){case"env":if(a){if(m.env){const s=m.env[D.isWindows?a.toLowerCase():a];if(b.isString(s))return s}return""}throw new Error((0,E.localize)(5,null,I));case"config":if(a){const s=this._context.getConfigurationValue(h,a);if(b.isUndefinedOrNull(s))throw new Error((0,E.localize)(6,null,I,a));if(b.isObject(s))throw new Error((0,E.localize)(7,null,I,a));return s}throw new Error((0,E.localize)(8,null,I));case"command":return this.resolveFromMap(I,a,d,"command");case"input":return this.resolveFromMap(I,a,d,"input");case"extensionInstallFolder":if(a){const s=await this._context.getExtension(a);if(!s)throw new Error((0,E.localize)(9,null,I,a));return this.fsPath(s.extensionLocation)}throw new Error((0,E.localize)(10,null,I));default:switch(f){case"workspaceRoot":case"workspaceFolder":return(0,T.normalizeDriveLetter)(this.fsPath(_()));case"cwd":return h||a?(0,T.normalizeDriveLetter)(this.fsPath(_())):p.cwd();case"workspaceRootFolderName":case"workspaceFolderBasename":return o.basename(this.fsPath(_()));case"userHome":{if(m.userHome)return m.userHome;throw new Error((0,E.localize)(11,null,I))}case"lineNumber":{const s=this._context.getLineNumber();if(s)return s;throw new Error((0,E.localize)(12,null,I))}case"selectedText":{const s=this._context.getSelectedText();if(s)return s;throw new Error((0,E.localize)(13,null,I))}case"file":return A();case"fileWorkspaceFolder":return l();case"relativeFile":return h||a?o.relative(this.fsPath(_()),A()):A();case"relativeFileDirname":{const s=o.dirname(A());if(h||a){const u=o.relative(this.fsPath(_()),s);return u.length===0?".":u}return s}case"fileDirname":return o.dirname(A());case"fileExtname":return o.extname(A());case"fileBasename":return o.basename(A());case"fileBasenameNoExtension":{const s=o.basename(A());return s.slice(0,s.length-o.extname(s).length)}case"fileDirnameBasename":return o.basename(o.dirname(A()));case"execPath":{const s=this._context.getExecPath();return s||I}case"execInstallFolder":{const s=this._context.getAppRoot();return s||I}case"pathSeparator":return o.sep;default:try{const s=a?`${f}:${a}`:f;return this.resolveFromMap(I,s,d,void 0)}catch{return I}}}}resolveFromMap(m,I,f,h){if(I&&f){const d=h===void 0?f[I]:f[h+":"+I];if(typeof d=="string")return d;throw new Error((0,E.localize)(14,null,m))}return m}}e.AbstractVariableResolverService=R,R.VARIABLE_LHS="${",R.VARIABLE_REGEXP=/\$\{(.*?)\}/g}),define(De[90],Ce([1,0,3,162]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.preferredSideBySideGroupDirection=e.isEditorGroup=e.OpenEditorContext=e.GroupsOrder=e.isEditorReplacement=e.MergeGroupMode=e.GroupsArrangement=e.GroupLocation=e.GroupOrientation=e.GroupDirection=e.IEditorGroupsService=void 0,e.IEditorGroupsService=(0,o.createDecorator)("editorGroupsService");var b;(function(f){f[f.UP=0]="UP",f[f.DOWN=1]="DOWN",f[f.LEFT=2]="LEFT",f[f.RIGHT=3]="RIGHT"})(b=e.GroupDirection||(e.GroupDirection={}));var L;(function(f){f[f.HORIZONTAL=0]="HORIZONTAL",f[f.VERTICAL=1]="VERTICAL"})(L=e.GroupOrientation||(e.GroupOrientation={}));var D;(function(f){f[f.FIRST=0]="FIRST",f[f.LAST=1]="LAST",f[f.NEXT=2]="NEXT",f[f.PREVIOUS=3]="PREVIOUS"})(D=e.GroupLocation||(e.GroupLocation={}));var T;(function(f){f[f.MAXIMIZE=0]="MAXIMIZE",f[f.EVEN=1]="EVEN",f[f.TOGGLE=2]="TOGGLE"})(T=e.GroupsArrangement||(e.GroupsArrangement={}));var E;(function(f){f[f.COPY_EDITORS=0]="COPY_EDITORS",f[f.MOVE_EDITORS=1]="MOVE_EDITORS"})(E=e.MergeGroupMode||(e.MergeGroupMode={}));function P(f){const h=f;return(0,p.isEditorInput)(h?.editor)&&(0,p.isEditorInput)(h?.replacement)}e.isEditorReplacement=P;var R;(function(f){f[f.CREATION_TIME=0]="CREATION_TIME",f[f.MOST_RECENTLY_ACTIVE=1]="MOST_RECENTLY_ACTIVE",f[f.GRID_APPEARANCE=2]="GRID_APPEARANCE"})(R=e.GroupsOrder||(e.GroupsOrder={}));var y;(function(f){f[f.NEW_EDITOR=1]="NEW_EDITOR",f[f.MOVE_EDITOR=2]="MOVE_EDITOR",f[f.COPY_EDITOR=3]="COPY_EDITOR"})(y=e.OpenEditorContext||(e.OpenEditorContext={}));function m(f){const h=f;return!!h&&typeof h.id=="number"&&Array.isArray(h.editors)}e.isEditorGroup=m;function I(f){return f.getValue("workbench.editor.openSideBySideDirection")==="down"?1:3}e.preferredSideBySideGroupDirection=I}),define(De[171],Ce([1,0,3,90]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.isPreferredGroup=e.SIDE_GROUP=e.ACTIVE_GROUP=e.IEditorService=void 0,e.IEditorService=(0,o.createDecorator)("editorService"),e.ACTIVE_GROUP=-1,e.SIDE_GROUP=-2;function b(L){const D=L;return typeof L=="number"||(0,p.isEditorGroup)(D)}e.isPreferredGroup=b}),define(De[8],Ce([1,0,16,22,75,25,105,55,26,10,2,48,66,143,80,89,88,46,47,171,6,172]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.DataTransfer=e.DataTransferItem=e.ViewBadge=e.TypeHierarchyItem=e.CodeActionTriggerKind=e.TestCoverage=e.TestResults=e.TestItem=e.TestTag=e.TestMessage=e.NotebookRendererScript=e.NotebookDocumentContentOptions=e.NotebookStatusBarItem=e.NotebookExclusiveDocumentPattern=e.NotebookCellOutput=e.NotebookCellOutputItem=e.NotebookCellData=e.NotebookData=e.NotebookCellKind=e.NotebookCellExecutionState=e.NotebookCellExecutionSummary=e.NotebookRange=e.LanguageSelector=e.GlobPattern=e.TextEditorOpenOptions=e.FoldingRangeKind=e.FoldingRange=e.ProgressLocation=e.EndOfLine=e.TextEditorLineNumbersStyle=e.TextDocumentSaveReason=e.SelectionRange=e.Color=e.ColorPresentation=e.DocumentLink=e.InlayHintKind=e.InlayHintLabelPart=e.InlayHint=e.SignatureHelp=e.SignatureInformation=e.ParameterInformation=e.CompletionItem=e.CompletionItemKind=e.CompletionItemTag=e.CompletionContext=e.CompletionTriggerKind=e.DocumentHighlight=e.InlineValueContext=e.InlineValue=e.EvaluatableExpression=e.Hover=e.DefinitionLink=e.location=e.CallHierarchyOutgoingCall=e.CallHierarchyIncomingCall=e.CallHierarchyItem=e.DocumentSymbol=e.WorkspaceSymbol=e.SymbolTag=e.SymbolKind=e.WorkspaceEdit=e.TextEdit=e.DecorationRenderOptions=e.DecorationRangeBehavior=e.ThemableDecorationRenderOptions=e.ThemableDecorationAttachmentRenderOptions=e.pathOrURIToURI=e.fromRangeOrRangeWithMessage=e.MarkdownString=e.isDecorationOptionsArr=e.ViewColumn=e.DiagnosticSeverity=e.DiagnosticRelatedInformation=e.Diagnostic=e.DiagnosticTag=e.DocumentSelector=e.Position=e.TokenType=e.Range=e.Selection=void 0;var s;(function(we){function ye(q){const{selectionStartLineNumber:Pe,selectionStartColumn:Le,positionLineNumber:Ye,positionColumn:Xe}=q,Ke=new l.Position(Pe-1,Le-1),pt=new l.Position(Ye-1,Xe-1);return new l.Selection(Ke,pt)}we.to=ye;function me(q){const{anchor:Pe,active:Le}=q;return{selectionStartLineNumber:Pe.line+1,selectionStartColumn:Pe.character+1,positionLineNumber:Le.line+1,positionColumn:Le.character+1}}we.from=me})(s=e.Selection||(e.Selection={}));var u;(function(we){function ye(q){if(!q)return;const{start:Pe,end:Le}=q;return{startLineNumber:Pe.line+1,startColumn:Pe.character+1,endLineNumber:Le.line+1,endColumn:Le.character+1}}we.from=ye;function me(q){if(!q)return;const{startLineNumber:Pe,startColumn:Le,endLineNumber:Ye,endColumn:Xe}=q;return new l.Range(Pe-1,Le-1,Ye-1,Xe-1)}we.to=me})(u=e.Range||(e.Range={}));var n;(function(we){function ye(me){switch(me){case 1:return l.StandardTokenType.Comment;case 0:return l.StandardTokenType.Other;case 3:return l.StandardTokenType.RegEx;case 2:return l.StandardTokenType.String}}we.to=ye})(n=e.TokenType||(e.TokenType={}));var i;(function(we){function ye(q){return new l.Position(q.lineNumber-1,q.column-1)}we.to=ye;function me(q){return{lineNumber:q.line+1,column:q.character+1}}we.from=me})(i=e.Position||(e.Position={}));var r;(function(we){function ye(Pe,Le){return(0,o.coalesce)((0,o.asArray)(Pe).map(Ye=>me(Ye,Le)))}we.from=ye;function me(Pe,Le){if(typeof Pe=="string")return{$serialized:!0,language:Pe};if(Pe)return{$serialized:!0,language:Pe.language,scheme:q(Pe.scheme,Le),pattern:he.from(Pe.pattern)??void 0,exclusive:Pe.exclusive,notebookType:Pe.notebookType}}function q(Pe,Le){return Le&&typeof Pe=="string"?Le.transformOutgoingScheme(Pe):Pe}})(r=e.DocumentSelector||(e.DocumentSelector={}));var t;(function(we){function ye(q){switch(q){case l.DiagnosticTag.Unnecessary:return 1;case l.DiagnosticTag.Deprecated:return 2}}we.from=ye;function me(q){switch(q){case 1:return l.DiagnosticTag.Unnecessary;case 2:return l.DiagnosticTag.Deprecated;default:return}}we.to=me})(t=e.DiagnosticTag||(e.DiagnosticTag={}));var c;(function(we){function ye(q){let Pe;return q.code&&((0,P.isString)(q.code)||(0,P.isNumber)(q.code)?Pe=String(q.code):Pe={value:String(q.code.value),target:q.code.target}),{...u.from(q.range),message:q.message,source:q.source,code:Pe,severity:g.from(q.severity),relatedInformation:q.relatedInformation&&q.relatedInformation.map(w.from),tags:Array.isArray(q.tags)?(0,o.coalesce)(q.tags.map(t.from)):void 0}}we.from=ye;function me(q){const Pe=new l.Diagnostic(u.to(q),q.message,g.to(q.severity));return Pe.source=q.source,Pe.code=(0,P.isString)(q.code)?q.code:q.code?.value,Pe.relatedInformation=q.relatedInformation&&q.relatedInformation.map(w.to),Pe.tags=q.tags&&(0,o.coalesce)(q.tags.map(t.to)),Pe}we.to=me})(c=e.Diagnostic||(e.Diagnostic={}));var w;(function(we){function ye(q){return{...u.from(q.location.range),message:q.message,resource:q.location.uri}}we.from=ye;function me(q){return new l.DiagnosticRelatedInformation(new l.Location(q.resource,u.to(q)),q.message)}we.to=me})(w=e.DiagnosticRelatedInformation||(e.DiagnosticRelatedInformation={}));var g;(function(we){function ye(q){switch(q){case l.DiagnosticSeverity.Error:return f.MarkerSeverity.Error;case l.DiagnosticSeverity.Warning:return f.MarkerSeverity.Warning;case l.DiagnosticSeverity.Information:return f.MarkerSeverity.Info;case l.DiagnosticSeverity.Hint:return f.MarkerSeverity.Hint}return f.MarkerSeverity.Error}we.from=ye;function me(q){switch(q){case f.MarkerSeverity.Info:return l.DiagnosticSeverity.Information;case f.MarkerSeverity.Warning:return l.DiagnosticSeverity.Warning;case f.MarkerSeverity.Error:return l.DiagnosticSeverity.Error;case f.MarkerSeverity.Hint:return l.DiagnosticSeverity.Hint;default:return l.DiagnosticSeverity.Error}}we.to=me})(g=e.DiagnosticSeverity||(e.DiagnosticSeverity={}));var C;(function(we){function ye(q){return typeof q=="number"&&q>=l.ViewColumn.One?q-1:q===l.ViewColumn.Beside?A.SIDE_GROUP:A.ACTIVE_GROUP}we.from=ye;function me(q){if(typeof q=="number"&&q>=0)return q+1;throw new Error("invalid 'EditorGroupColumn'")}we.to=me})(C=e.ViewColumn||(e.ViewColumn={}));function U(we){return typeof we.range!="undefined"}function W(we){return we.length===0?!0:!!U(we[0])}e.isDecorationOptionsArr=W;var M;(function(we){function ye(Xe){return Xe.map(we.from)}we.fromMany=ye;function me(Xe){return Xe&&typeof Xe=="object"&&typeof Xe.language=="string"&&typeof Xe.value=="string"}function q(Xe){let Ke;if(me(Xe)){const{language:Et,value:ht}=Xe;Ke={value:"```"+Et+`
`+ht+"\n```\n"}}else l.MarkdownString.isMarkdownString(Xe)?Ke={value:Xe.value,isTrusted:Xe.isTrusted,supportThemeIcons:Xe.supportThemeIcons,supportHtml:Xe.supportHtml,baseUri:Xe.baseUri}:typeof Xe=="string"?Ke={value:Xe}:Ke={value:""};const pt=Object.create(null);Ke.uris=pt;const bt=Et=>{try{let ht=R.URI.parse(Et,!0);ht=ht.with({query:Pe(ht.query,pt)}),pt[Et]=ht}catch{}return""},kt=new D.marked.Renderer;return kt.link=bt,kt.image=Et=>typeof Et=="string"?bt(b.parseHrefAndDimensions(Et).href):"",(0,D.marked)(Ke.value,{renderer:kt}),Ke}we.from=q;function Pe(Xe,Ke){if(!Xe)return Xe;let pt;try{pt=(0,T.parse)(Xe)}catch{}if(!pt)return Xe;let bt=!1;return pt=(0,E.cloneAndChange)(pt,kt=>{if(R.URI.isUri(kt)){const Et=`__uri_${Math.random().toString(16).slice(2,8)}`;return Ke[Et]=kt,bt=!0,Et}else return}),bt?JSON.stringify(pt):Xe}function Le(Xe){const Ke=new l.MarkdownString(Xe.value,Xe.supportThemeIcons);return Ke.isTrusted=Xe.isTrusted,Ke.supportHtml=Xe.supportHtml,Ke.baseUri=Xe.baseUri?R.URI.from(Xe.baseUri):void 0,Ke}we.to=Le;function Ye(Xe){if(!!Xe)return typeof Xe=="string"?Xe:we.from(Xe)}we.fromStrict=Ye})(M=e.MarkdownString||(e.MarkdownString={}));function S(we){return W(we)?we.map(ye=>({range:u.from(ye.range),hoverMessage:Array.isArray(ye.hoverMessage)?M.fromMany(ye.hoverMessage):ye.hoverMessage?M.from(ye.hoverMessage):void 0,renderOptions:ye.renderOptions})):we.map(ye=>({range:u.from(ye)}))}e.fromRangeOrRangeWithMessage=S;function z(we){return typeof we=="undefined"?we:typeof we=="string"?R.URI.file(we):we}e.pathOrURIToURI=z;var $;(function(we){function ye(me){return typeof me=="undefined"?me:{contentText:me.contentText,contentIconPath:me.contentIconPath?z(me.contentIconPath):void 0,border:me.border,borderColor:me.borderColor,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,color:me.color,backgroundColor:me.backgroundColor,margin:me.margin,width:me.width,height:me.height}}we.from=ye})($=e.ThemableDecorationAttachmentRenderOptions||(e.ThemableDecorationAttachmentRenderOptions={}));var N;(function(we){function ye(me){return typeof me=="undefined"?me:{backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}we.from=ye})(N=e.ThemableDecorationRenderOptions||(e.ThemableDecorationRenderOptions={}));var K;(function(we){function ye(me){if(typeof me=="undefined")return me;switch(me){case l.DecorationRangeBehavior.OpenOpen:return 0;case l.DecorationRangeBehavior.ClosedClosed:return 1;case l.DecorationRangeBehavior.OpenClosed:return 2;case l.DecorationRangeBehavior.ClosedOpen:return 3}}we.from=ye})(K=e.DecorationRangeBehavior||(e.DecorationRangeBehavior={}));var V;(function(we){function ye(me){return{isWholeLine:me.isWholeLine,rangeBehavior:me.rangeBehavior?K.from(me.rangeBehavior):void 0,overviewRulerLane:me.overviewRulerLane,light:me.light?N.from(me.light):void 0,dark:me.dark?N.from(me.dark):void 0,backgroundColor:me.backgroundColor,outline:me.outline,outlineColor:me.outlineColor,outlineStyle:me.outlineStyle,outlineWidth:me.outlineWidth,border:me.border,borderColor:me.borderColor,borderRadius:me.borderRadius,borderSpacing:me.borderSpacing,borderStyle:me.borderStyle,borderWidth:me.borderWidth,fontStyle:me.fontStyle,fontWeight:me.fontWeight,textDecoration:me.textDecoration,cursor:me.cursor,color:me.color,opacity:me.opacity,letterSpacing:me.letterSpacing,gutterIconPath:me.gutterIconPath?z(me.gutterIconPath):void 0,gutterIconSize:me.gutterIconSize,overviewRulerColor:me.overviewRulerColor,before:me.before?$.from(me.before):void 0,after:me.after?$.from(me.after):void 0}}we.from=ye})(V=e.DecorationRenderOptions||(e.DecorationRenderOptions={}));var F;(function(we){function ye(q){return{text:q.newText,eol:q.newEol&&Ge.from(q.newEol),range:u.from(q.range)}}we.from=ye;function me(q){const Pe=new l.TextEdit(u.to(q.range),q.text);return Pe.newEol=typeof q.eol=="undefined"?void 0:Ge.to(q.eol),Pe}we.to=me})(F=e.TextEdit||(e.TextEdit={}));var ne;(function(we){function ye(q,Pe,Le){const Ye={edits:[]};if(q instanceof l.WorkspaceEdit){const Xe=new L.ResourceSet;for(const Ke of q._allEntries())Ke._type===1&&R.URI.isUri(Ke.to)&&Ke.from===void 0&&Xe.add(Ke.to);for(const Ke of q._allEntries())if(Ke._type===1)Ye.edits.push({oldResource:Ke.from,newResource:Ke.to,options:Ke.options,metadata:Ke.metadata});else if(Ke._type===2)Ye.edits.push({resource:Ke.uri,textEdit:F.from(Ke.edit),versionId:Xe.has(Ke.uri)?void 0:Pe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata});else if(Ke._type===6){if(!Le){console.warn("DROPPING snippet text edit because proposal IS NOT ENABLED",Ke);continue}Ye.edits.push({resource:Ke.uri,textEdit:{range:u.from(Ke.range),text:Ke.edit.value,insertAsSnippet:!0},versionId:Xe.has(Ke.uri)?void 0:Pe?.getTextDocumentVersion(Ke.uri),metadata:Ke.metadata})}else Ke._type===3?Ye.edits.push({metadata:Ke.metadata,resource:Ke.uri,cellEdit:Ke.edit,notebookMetadata:Ke.notebookMetadata,notebookVersionId:Pe?.getNotebookDocumentVersion(Ke.uri)}):Ke._type===5&&Ye.edits.push({metadata:Ke.metadata,resource:Ke.uri,notebookVersionId:Pe?.getNotebookDocumentVersion(Ke.uri),cellEdit:{editType:1,index:Ke.index,count:Ke.count,cells:Ke.cells.map(rt.from)}})}return Ye}we.from=ye;function me(q){const Pe=new l.WorkspaceEdit;for(const Le of q.edits)Le.textEdit?Pe.replace(R.URI.revive(Le.resource),u.to(Le.textEdit.range),Le.textEdit.text):Pe.renameFile(R.URI.revive(Le.oldResource),R.URI.revive(Le.newResource),Le.options);return Pe}we.to=me})(ne=e.WorkspaceEdit||(e.WorkspaceEdit={}));var ce;(function(we){const ye=Object.create(null);ye[l.SymbolKind.File]=0,ye[l.SymbolKind.Module]=1,ye[l.SymbolKind.Namespace]=2,ye[l.SymbolKind.Package]=3,ye[l.SymbolKind.Class]=4,ye[l.SymbolKind.Method]=5,ye[l.SymbolKind.Property]=6,ye[l.SymbolKind.Field]=7,ye[l.SymbolKind.Constructor]=8,ye[l.SymbolKind.Enum]=9,ye[l.SymbolKind.Interface]=10,ye[l.SymbolKind.Function]=11,ye[l.SymbolKind.Variable]=12,ye[l.SymbolKind.Constant]=13,ye[l.SymbolKind.String]=14,ye[l.SymbolKind.Number]=15,ye[l.SymbolKind.Boolean]=16,ye[l.SymbolKind.Array]=17,ye[l.SymbolKind.Object]=18,ye[l.SymbolKind.Key]=19,ye[l.SymbolKind.Null]=20,ye[l.SymbolKind.EnumMember]=21,ye[l.SymbolKind.Struct]=22,ye[l.SymbolKind.Event]=23,ye[l.SymbolKind.Operator]=24,ye[l.SymbolKind.TypeParameter]=25;function me(Pe){return typeof ye[Pe]=="number"?ye[Pe]:6}we.from=me;function q(Pe){for(const Le in ye)if(ye[Le]===Pe)return Number(Le);return l.SymbolKind.Property}we.to=q})(ce=e.SymbolKind||(e.SymbolKind={}));var re;(function(we){function ye(q){switch(q){case l.SymbolTag.Deprecated:return 1}}we.from=ye;function me(q){switch(q){case 1:return l.SymbolTag.Deprecated}}we.to=me})(re=e.SymbolTag||(e.SymbolTag={}));var fe;(function(we){function ye(q){return{name:q.name,kind:ce.from(q.kind),tags:q.tags&&q.tags.map(re.from),containerName:q.containerName,location:ve.from(q.location)}}we.from=ye;function me(q){const Pe=new l.SymbolInformation(q.name,ce.to(q.kind),q.containerName,ve.to(q.location));return Pe.tags=q.tags&&q.tags.map(re.to),Pe}we.to=me})(fe=e.WorkspaceSymbol||(e.WorkspaceSymbol={}));var ie;(function(we){function ye(q){const Pe={name:q.name||"!!MISSING: name!!",detail:q.detail,range:u.from(q.range),selectionRange:u.from(q.selectionRange),kind:ce.from(q.kind),tags:q.tags?.map(re.from)??[]};return q.children&&(Pe.children=q.children.map(ye)),Pe}we.from=ye;function me(q){const Pe=new l.DocumentSymbol(q.name,q.detail,ce.to(q.kind),u.to(q.range),u.to(q.selectionRange));return(0,o.isNonEmptyArray)(q.tags)&&(Pe.tags=q.tags.map(re.to)),q.children&&(Pe.children=q.children.map(me)),Pe}we.to=me})(ie=e.DocumentSymbol||(e.DocumentSymbol={}));var Ee;(function(we){function ye(q){const Pe=new l.CallHierarchyItem(ce.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),u.to(q.range),u.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}we.to=ye;function me(q,Pe,Le){if(Pe=Pe??q._sessionId,Le=Le??q._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,name:q.name,detail:q.detail,kind:ce.from(q.kind),uri:q.uri,range:u.from(q.range),selectionRange:u.from(q.selectionRange),tags:q.tags?.map(re.from)}}we.from=me})(Ee=e.CallHierarchyItem||(e.CallHierarchyItem={}));var be;(function(we){function ye(me){return new l.CallHierarchyIncomingCall(Ee.to(me.from),me.fromRanges.map(q=>u.to(q)))}we.to=ye})(be=e.CallHierarchyIncomingCall||(e.CallHierarchyIncomingCall={}));var ee;(function(we){function ye(me){return new l.CallHierarchyOutgoingCall(Ee.to(me.to),me.fromRanges.map(q=>u.to(q)))}we.to=ye})(ee=e.CallHierarchyOutgoingCall||(e.CallHierarchyOutgoingCall={}));var ve;(function(we){function ye(q){return{range:q.range&&u.from(q.range),uri:q.uri}}we.from=ye;function me(q){return new l.Location(R.URI.revive(q.uri),u.to(q.range))}we.to=me})(ve=e.location||(e.location={}));var Ae;(function(we){function ye(q){const Pe=q,Le=q;return{originSelectionRange:Pe.originSelectionRange?u.from(Pe.originSelectionRange):void 0,uri:Pe.targetUri?Pe.targetUri:Le.uri,range:u.from(Pe.targetRange?Pe.targetRange:Le.range),targetSelectionRange:Pe.targetSelectionRange?u.from(Pe.targetSelectionRange):void 0}}we.from=ye;function me(q){return{targetUri:R.URI.revive(q.uri),targetRange:u.to(q.range),targetSelectionRange:q.targetSelectionRange?u.to(q.targetSelectionRange):void 0,originSelectionRange:q.originSelectionRange?u.to(q.originSelectionRange):void 0}}we.to=me})(Ae=e.DefinitionLink||(e.DefinitionLink={}));var Fe;(function(we){function ye(q){return{range:u.from(q.range),contents:M.fromMany(q.contents)}}we.from=ye;function me(q){return new l.Hover(q.contents.map(M.to),u.to(q.range))}we.to=me})(Fe=e.Hover||(e.Hover={}));var $e;(function(we){function ye(q){return{range:u.from(q.range),expression:q.expression}}we.from=ye;function me(q){return new l.EvaluatableExpression(u.to(q.range),q.expression)}we.to=me})($e=e.EvaluatableExpression||(e.EvaluatableExpression={}));var Qe;(function(we){function ye(q){if(q instanceof l.InlineValueText)return{type:"text",range:u.from(q.range),text:q.text};if(q instanceof l.InlineValueVariableLookup)return{type:"variable",range:u.from(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};if(q instanceof l.InlineValueEvaluatableExpression)return{type:"expression",range:u.from(q.range),expression:q.expression};throw new Error("Unknown 'InlineValue' type")}we.from=ye;function me(q){switch(q.type){case"text":return{range:u.to(q.range),text:q.text};case"variable":return{range:u.to(q.range),variableName:q.variableName,caseSensitiveLookup:q.caseSensitiveLookup};case"expression":return{range:u.to(q.range),expression:q.expression}}}we.to=me})(Qe=e.InlineValue||(e.InlineValue={}));var Ie;(function(we){function ye(q){return{frameId:q.frameId,stoppedLocation:u.from(q.stoppedLocation)}}we.from=ye;function me(q){return new l.InlineValueContext(q.frameId,u.to(q.stoppedLocation))}we.to=me})(Ie=e.InlineValueContext||(e.InlineValueContext={}));var Se;(function(we){function ye(q){return{range:u.from(q.range),kind:q.kind}}we.from=ye;function me(q){return new l.DocumentHighlight(u.to(q.range),q.kind)}we.to=me})(Se=e.DocumentHighlight||(e.DocumentHighlight={}));var Te;(function(we){function ye(me){switch(me){case 1:return l.CompletionTriggerKind.TriggerCharacter;case 2:return l.CompletionTriggerKind.TriggerForIncompleteCompletions;case 0:default:return l.CompletionTriggerKind.Invoke}}we.to=ye})(Te=e.CompletionTriggerKind||(e.CompletionTriggerKind={}));var ae;(function(we){function ye(me){return{triggerKind:Te.to(me.triggerKind),triggerCharacter:me.triggerCharacter}}we.to=ye})(ae=e.CompletionContext||(e.CompletionContext={}));var le;(function(we){function ye(q){switch(q){case l.CompletionItemTag.Deprecated:return 1}}we.from=ye;function me(q){switch(q){case 1:return l.CompletionItemTag.Deprecated}}we.to=me})(le=e.CompletionItemTag||(e.CompletionItemTag={}));var X;(function(we){const ye=new Map([[l.CompletionItemKind.Method,0],[l.CompletionItemKind.Function,1],[l.CompletionItemKind.Constructor,2],[l.CompletionItemKind.Field,3],[l.CompletionItemKind.Variable,4],[l.CompletionItemKind.Class,5],[l.CompletionItemKind.Interface,7],[l.CompletionItemKind.Struct,6],[l.CompletionItemKind.Module,8],[l.CompletionItemKind.Property,9],[l.CompletionItemKind.Unit,12],[l.CompletionItemKind.Value,13],[l.CompletionItemKind.Constant,14],[l.CompletionItemKind.Enum,15],[l.CompletionItemKind.EnumMember,16],[l.CompletionItemKind.Keyword,17],[l.CompletionItemKind.Snippet,27],[l.CompletionItemKind.Text,18],[l.CompletionItemKind.Color,19],[l.CompletionItemKind.File,20],[l.CompletionItemKind.Reference,21],[l.CompletionItemKind.Folder,23],[l.CompletionItemKind.Event,10],[l.CompletionItemKind.Operator,11],[l.CompletionItemKind.TypeParameter,24],[l.CompletionItemKind.Issue,26],[l.CompletionItemKind.User,25]]);function me(Le){return ye.get(Le)??9}we.from=me;const q=new Map([[0,l.CompletionItemKind.Method],[1,l.CompletionItemKind.Function],[2,l.CompletionItemKind.Constructor],[3,l.CompletionItemKind.Field],[4,l.CompletionItemKind.Variable],[5,l.CompletionItemKind.Class],[7,l.CompletionItemKind.Interface],[6,l.CompletionItemKind.Struct],[8,l.CompletionItemKind.Module],[9,l.CompletionItemKind.Property],[12,l.CompletionItemKind.Unit],[13,l.CompletionItemKind.Value],[14,l.CompletionItemKind.Constant],[15,l.CompletionItemKind.Enum],[16,l.CompletionItemKind.EnumMember],[17,l.CompletionItemKind.Keyword],[27,l.CompletionItemKind.Snippet],[18,l.CompletionItemKind.Text],[19,l.CompletionItemKind.Color],[20,l.CompletionItemKind.File],[21,l.CompletionItemKind.Reference],[23,l.CompletionItemKind.Folder],[10,l.CompletionItemKind.Event],[11,l.CompletionItemKind.Operator],[24,l.CompletionItemKind.TypeParameter],[25,l.CompletionItemKind.User],[26,l.CompletionItemKind.Issue]]);function Pe(Le){return q.get(Le)??l.CompletionItemKind.Property}we.to=Pe})(X=e.CompletionItemKind||(e.CompletionItemKind={}));var Y;(function(we){function ye(me,q){const Pe=new l.CompletionItem(me.label);return Pe.insertText=me.insertText,Pe.kind=X.to(me.kind),Pe.tags=me.tags?.map(le.to),Pe.detail=me.detail,Pe.documentation=b.isMarkdownString(me.documentation)?M.to(me.documentation):me.documentation,Pe.sortText=me.sortText,Pe.filterText=me.filterText,Pe.preselect=me.preselect,Pe.commitCharacters=me.commitCharacters,y.Range.isIRange(me.range)?Pe.range=u.to(me.range):typeof me.range=="object"&&(Pe.range={inserting:u.to(me.range.insert),replacing:u.to(me.range.replace)}),Pe.keepWhitespace=typeof me.insertTextRules=="undefined"?!1:Boolean(me.insertTextRules&1),typeof me.insertTextRules!="undefined"&&me.insertTextRules&4?Pe.insertText=new l.SnippetString(me.insertText):(Pe.insertText=me.insertText,Pe.textEdit=Pe.range instanceof l.Range?new l.TextEdit(Pe.range,Pe.insertText):void 0),me.additionalTextEdits&&me.additionalTextEdits.length>0&&(Pe.additionalTextEdits=me.additionalTextEdits.map(Le=>F.to(Le))),Pe.command=q&&me.command?q.fromInternal(me.command):void 0,Pe}we.to=ye})(Y=e.CompletionItem||(e.CompletionItem={}));var k;(function(we){function ye(q){return{label:q.label,documentation:M.fromStrict(q.documentation)}}we.from=ye;function me(q){return{label:q.label,documentation:b.isMarkdownString(q.documentation)?M.to(q.documentation):q.documentation}}we.to=me})(k=e.ParameterInformation||(e.ParameterInformation={}));var B;(function(we){function ye(q){return{label:q.label,documentation:M.fromStrict(q.documentation),parameters:Array.isArray(q.parameters)?q.parameters.map(k.from):[],activeParameter:q.activeParameter}}we.from=ye;function me(q){return{label:q.label,documentation:b.isMarkdownString(q.documentation)?M.to(q.documentation):q.documentation,parameters:Array.isArray(q.parameters)?q.parameters.map(k.to):[],activeParameter:q.activeParameter}}we.to=me})(B=e.SignatureInformation||(e.SignatureInformation={}));var H;(function(we){function ye(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.from):[]}}we.from=ye;function me(q){return{activeSignature:q.activeSignature,activeParameter:q.activeParameter,signatures:Array.isArray(q.signatures)?q.signatures.map(B.to):[]}}we.to=me})(H=e.SignatureHelp||(e.SignatureHelp={}));var j;(function(we){function ye(me,q){const Pe=new l.InlayHint(i.to(q.position),typeof q.label=="string"?q.label:q.label.map(oe.to.bind(void 0,me)),q.kind&&ue.to(q.kind));return Pe.textEdits=q.textEdits&&q.textEdits.map(F.to),Pe.tooltip=b.isMarkdownString(q.tooltip)?M.to(q.tooltip):q.tooltip,Pe.paddingLeft=q.paddingLeft,Pe.paddingRight=q.paddingRight,Pe}we.to=ye})(j=e.InlayHint||(e.InlayHint={}));var oe;(function(we){function ye(me,q){const Pe=new l.InlayHintLabelPart(q.label);return Pe.tooltip=b.isMarkdownString(q.tooltip)?M.to(q.tooltip):q.tooltip,m.Command.is(q.command)&&(Pe.command=me.fromInternal(q.command)),q.location&&(Pe.location=ve.to(q.location)),Pe}we.to=ye})(oe=e.InlayHintLabelPart||(e.InlayHintLabelPart={}));var ue;(function(we){function ye(q){return q}we.from=ye;function me(q){return q}we.to=me})(ue=e.InlayHintKind||(e.InlayHintKind={}));var Z;(function(we){function ye(q){return{range:u.from(q.range),url:q.target,tooltip:q.tooltip}}we.from=ye;function me(q){let Pe;if(q.url)try{Pe=typeof q.url=="string"?R.URI.parse(q.url,!0):R.URI.revive(q.url)}catch{}return new l.DocumentLink(u.to(q.range),Pe)}we.to=me})(Z=e.DocumentLink||(e.DocumentLink={}));var pe;(function(we){function ye(q){const Pe=new l.ColorPresentation(q.label);return q.textEdit&&(Pe.textEdit=F.to(q.textEdit)),q.additionalTextEdits&&(Pe.additionalTextEdits=q.additionalTextEdits.map(Le=>F.to(Le))),Pe}we.to=ye;function me(q){return{label:q.label,textEdit:q.textEdit?F.from(q.textEdit):void 0,additionalTextEdits:q.additionalTextEdits?q.additionalTextEdits.map(Pe=>F.from(Pe)):void 0}}we.from=me})(pe=e.ColorPresentation||(e.ColorPresentation={}));var ge;(function(we){function ye(q){return new l.Color(q[0],q[1],q[2],q[3])}we.to=ye;function me(q){return[q.red,q.green,q.blue,q.alpha]}we.from=me})(ge=e.Color||(e.Color={}));var Ne;(function(we){function ye(q){return{range:u.from(q.range)}}we.from=ye;function me(q){return new l.SelectionRange(u.to(q.range))}we.to=me})(Ne=e.SelectionRange||(e.SelectionRange={}));var Be;(function(we){function ye(me){switch(me){case 2:return l.TextDocumentSaveReason.AfterDelay;case 1:return l.TextDocumentSaveReason.Manual;case 3:case 4:return l.TextDocumentSaveReason.FocusOut}}we.to=ye})(Be=e.TextDocumentSaveReason||(e.TextDocumentSaveReason={}));var Ze;(function(we){function ye(q){switch(q){case l.TextEditorLineNumbersStyle.Off:return 0;case l.TextEditorLineNumbersStyle.Relative:return 2;case l.TextEditorLineNumbersStyle.On:default:return 1}}we.from=ye;function me(q){switch(q){case 0:return l.TextEditorLineNumbersStyle.Off;case 2:return l.TextEditorLineNumbersStyle.Relative;case 1:default:return l.TextEditorLineNumbersStyle.On}}we.to=me})(Ze=e.TextEditorLineNumbersStyle||(e.TextEditorLineNumbersStyle={}));var Ge;(function(we){function ye(q){if(q===l.EndOfLine.CRLF)return 1;if(q===l.EndOfLine.LF)return 0}we.from=ye;function me(q){if(q===1)return l.EndOfLine.CRLF;if(q===0)return l.EndOfLine.LF}we.to=me})(Ge=e.EndOfLine||(e.EndOfLine={}));var ke;(function(we){function ye(me){if(typeof me=="object")return me.viewId;switch(me){case l.ProgressLocation.SourceControl:return 3;case l.ProgressLocation.Window:return 10;case l.ProgressLocation.Notification:return 15}throw new Error("Unknown 'ProgressLocation'")}we.from=ye})(ke=e.ProgressLocation||(e.ProgressLocation={}));var nt;(function(we){function ye(me){const q={start:me.start+1,end:me.end+1};return me.kind&&(q.kind=G.from(me.kind)),q}we.from=ye})(nt=e.FoldingRange||(e.FoldingRange={}));var G;(function(we){function ye(me){if(me)switch(me){case l.FoldingRangeKind.Comment:return m.FoldingRangeKind.Comment;case l.FoldingRangeKind.Imports:return m.FoldingRangeKind.Imports;case l.FoldingRangeKind.Region:return m.FoldingRangeKind.Region}}we.from=ye})(G=e.FoldingRangeKind||(e.FoldingRangeKind={}));var Q;(function(we){function ye(me){if(me)return{pinned:typeof me.preview=="boolean"?!me.preview:void 0,inactive:me.background,preserveFocus:me.preserveFocus,selection:typeof me.selection=="object"?u.from(me.selection):void 0,override:typeof me.override=="boolean"?I.EditorResolution.DISABLED:void 0}}we.from=ye})(Q=e.TextEditorOpenOptions||(e.TextEditorOpenOptions={}));var he;(function(we){function ye(Le){return Le instanceof l.RelativePattern?Le.toJSON():typeof Le=="string"?Le:me(Le)||q(Le)?new l.RelativePattern(Le.baseUri??Le.base,Le.pattern).toJSON():Le}we.from=ye;function me(Le){const Ye=Le;return Ye?R.URI.isUri(Ye.baseUri)&&typeof Ye.pattern=="string":!1}function q(Le){const Ye=Le;return Ye?typeof Ye.base=="string"&&typeof Ye.pattern=="string":!1}function Pe(Le){return typeof Le=="string"?Le:new l.RelativePattern(R.URI.revive(Le.baseUri),Le.pattern)}we.to=Pe})(he=e.GlobPattern||(e.GlobPattern={}));var Ue;(function(we){function ye(me){if(me){if(Array.isArray(me))return me.map(ye);if(typeof me=="string")return me;{const q=me;return{language:q.language,scheme:q.scheme,pattern:he.from(q.pattern),exclusive:q.exclusive,notebookType:q.notebookType}}}else return}we.from=ye})(Ue=e.LanguageSelector||(e.LanguageSelector={}));var We;(function(we){function ye(q){return{start:q.start,end:q.end}}we.from=ye;function me(q){return new l.NotebookRange(q.start,q.end)}we.to=me})(We=e.NotebookRange||(e.NotebookRange={}));var et;(function(we){function ye(q){return{timing:typeof q.runStartTime=="number"&&typeof q.runEndTime=="number"?{startTime:q.runStartTime,endTime:q.runEndTime}:void 0,executionOrder:q.executionOrder,success:q.lastRunSuccess}}we.to=ye;function me(q){return{lastRunSuccess:q.success,runStartTime:q.timing?.startTime,runEndTime:q.timing?.endTime,executionOrder:q.executionOrder}}we.from=me})(et=e.NotebookCellExecutionSummary||(e.NotebookCellExecutionSummary={}));var je;(function(we){function ye(me){if(me===d.NotebookCellExecutionState.Executing)return l.NotebookCellExecutionState.Executing;if(me===d.NotebookCellExecutionState.Pending)return l.NotebookCellExecutionState.Pending;if(me===d.NotebookCellExecutionState.Unconfirmed)return l.NotebookCellExecutionState.Pending;throw new Error(`Unknown state: ${me}`)}we.to=ye})(je=e.NotebookCellExecutionState||(e.NotebookCellExecutionState={}));var He;(function(we){function ye(q){switch(q){case l.NotebookCellKind.Markup:return d.CellKind.Markup;case l.NotebookCellKind.Code:default:return d.CellKind.Code}}we.from=ye;function me(q){switch(q){case d.CellKind.Markup:return l.NotebookCellKind.Markup;case d.CellKind.Code:default:return l.NotebookCellKind.Code}}we.to=me})(He=e.NotebookCellKind||(e.NotebookCellKind={}));var it;(function(we){function ye(q){const Pe={metadata:q.metadata??Object.create(null),cells:[]};for(const Le of q.cells)l.NotebookCellData.validate(Le),Pe.cells.push(rt.from(Le));return Pe}we.from=ye;function me(q){const Pe=new l.NotebookData(q.cells.map(rt.to));return(0,P.isEmptyObject)(q.metadata)||(Pe.metadata=q.metadata),Pe}we.to=me})(it=e.NotebookData||(e.NotebookData={}));var rt;(function(we){function ye(q){return{cellKind:He.from(q.kind),language:q.languageId,mime:q.mime,source:q.value,metadata:q.metadata,internalMetadata:et.from(q.executionSummary??{}),outputs:q.outputs?q.outputs.map(lt.from):[]}}we.from=ye;function me(q){return new l.NotebookCellData(He.to(q.cellKind),q.source,q.language,q.mime,q.outputs?q.outputs.map(lt.to):void 0,q.metadata,q.internalMetadata?et.to(q.internalMetadata):void 0)}we.to=me})(rt=e.NotebookCellData||(e.NotebookCellData={}));var dt;(function(we){function ye(q){return{mime:q.mime,valueBytes:p.VSBuffer.wrap(q.data)}}we.from=ye;function me(q){return new l.NotebookCellOutputItem(q.valueBytes.buffer,q.mime)}we.to=me})(dt=e.NotebookCellOutputItem||(e.NotebookCellOutputItem={}));var lt;(function(we){function ye(q){return{outputId:q.id,items:q.items.map(dt.from),metadata:q.metadata}}we.from=ye;function me(q){const Pe=q.items.map(dt.to);return new l.NotebookCellOutput(Pe,q.outputId,q.metadata)}we.to=me})(lt=e.NotebookCellOutput||(e.NotebookCellOutput={}));var st;(function(we){function ye(Pe){return q(Pe)?{include:(0,P.withNullAsUndefined)(he.from(Pe.include)),exclude:(0,P.withNullAsUndefined)(he.from(Pe.exclude))}:(0,P.withNullAsUndefined)(he.from(Pe))}we.from=ye;function me(Pe){return q(Pe)?{include:he.to(Pe.include),exclude:he.to(Pe.exclude)}:he.to(Pe)}we.to=me;function q(Pe){const Le=Pe;return Le?!(0,P.isUndefinedOrNull)(Le.include)&&!(0,P.isUndefinedOrNull)(Le.exclude):!1}})(st=e.NotebookExclusiveDocumentPattern||(e.NotebookExclusiveDocumentPattern={}));var yt;(function(we){function ye(me,q,Pe){const Le=typeof me.command=="string"?{title:"",command:me.command}:me.command;return{alignment:me.alignment===l.NotebookCellStatusBarAlignment.Left?1:2,command:q.toInternal(Le,Pe),text:me.text,tooltip:me.tooltip,accessibilityInformation:me.accessibilityInformation,priority:me.priority}}we.from=ye})(yt=e.NotebookStatusBarItem||(e.NotebookStatusBarItem={}));var Ot;(function(we){function ye(me){return{transientOutputs:me?.transientOutputs??!1,transientCellMetadata:me?.transientCellMetadata??{},transientDocumentMetadata:me?.transientDocumentMetadata??{}}}we.from=ye})(Ot=e.NotebookDocumentContentOptions||(e.NotebookDocumentContentOptions={}));var Ft;(function(we){function ye(q){return{uri:q.uri,provides:q.provides}}we.from=ye;function me(q){return new l.NotebookRendererScript(R.URI.revive(q.uri),q.provides)}we.to=me})(Ft=e.NotebookRendererScript||(e.NotebookRendererScript={}));var ft;(function(we){function ye(q){return{message:M.fromStrict(q.message)||"",type:0,expected:q.expectedOutput,actual:q.actualOutput,location:q.location&&{range:u.from(q.location.range),uri:q.location.uri}}}we.from=ye;function me(q){const Pe=new l.TestMessage(typeof q.message=="string"?q.message:M.to(q.message));return Pe.actualOutput=q.actual,Pe.expectedOutput=q.expected,Pe.location=q.location?ve.to(q.location):void 0,Pe}we.to=me})(ft=e.TestMessage||(e.TestMessage={}));var Dt;(function(we){we.namespace=v.namespaceTestTag,we.denamespace=v.denamespaceTestTag})(Dt=e.TestTag||(e.TestTag={}));var Ut;(function(we){function ye(q){const Pe=(0,h.getPrivateApiFor)(q).controllerId;return{extId:a.TestId.fromExtHostTestItem(q,Pe).toString(),label:q.label,uri:R.URI.revive(q.uri),busy:!1,tags:q.tags.map(Le=>Dt.namespace(Pe,Le.id)),range:y.Range.lift(u.from(q.range)),description:q.description||null,sortText:q.sortText||null,error:q.error&&M.fromStrict(q.error)||null}}we.from=ye;function me(q){return{parent:void 0,error:void 0,id:a.TestId.fromString(q.extId).localId,label:q.label,uri:R.URI.revive(q.uri),tags:(q.tags||[]).map(Pe=>{const{tagId:Le}=Dt.denamespace(Pe);return new l.TestTag(Le)}),children:{add:()=>{},delete:()=>{},forEach:()=>{},*[Symbol.iterator](){},get:()=>{},replace:()=>{},size:0},range:u.to(q.range||void 0),canResolveChildren:!1,busy:!1,description:q.description||void 0,sortText:q.sortText||void 0}}we.toPlain=me})(Ut=e.TestItem||(e.TestItem={})),function(we){function ye(q){return{id:q.id}}we.from=ye;function me(q){return new l.TestTag(q.id)}we.to=me}(Dt=e.TestTag||(e.TestTag={}));var Nt;(function(we){const ye=(q,Pe)=>{const Le=[];for(const[Xe,Ke]of Pe)a.TestId.compare(Ke.item.extId,Xe)===2&&(Pe.delete(Xe),Le.push(Ke));const Ye={...Ut.toPlain(q.item),parent:void 0,taskStates:q.tasks.map(Xe=>({state:Xe.state,duration:Xe.duration,messages:Xe.messages.filter(Ke=>Ke.type===0).map(ft.to)})),children:Le.map(Xe=>ye(Xe,Pe))};for(const Xe of Ye.children)Xe.parent=Ye;return Ye};function me(q){const Pe=[],Le=new Map;for(const Ye of q.items)Le.set(Ye.item.extId,Ye),q.request.targets.some(Xe=>Xe.controllerId===Ye.controllerId&&Xe.testIds.includes(Ye.item.extId))&&Pe.push(Ye);return{completedAt:q.completedAt,results:Pe.map(Ye=>ye(Ye,Le))}}we.to=me})(Nt=e.TestResults||(e.TestResults={}));var Ve;(function(we){function ye(Le){return{covered:Le.covered,total:Le.covered}}function me(Le){return"line"in Le?i.from(Le):u.from(Le)}function q(Le){return"branches"in Le?{count:Le.executionCount,location:me(Le.location),type:1,branches:Le.branches.length?Le.branches.map(Ye=>({count:Ye.executionCount,location:Ye.location&&me(Ye.location)})):void 0}:{type:0,count:Le.executionCount,location:me(Le.location)}}we.fromDetailed=q;function Pe(Le){return{uri:Le.uri,statement:ye(Le.statementCoverage),branch:Le.branchCoverage&&ye(Le.branchCoverage),function:Le.functionCoverage&&ye(Le.functionCoverage),details:Le.detailedCoverage?.map(q)}}we.fromFile=Pe})(Ve=e.TestCoverage||(e.TestCoverage={}));var Mt;(function(we){function ye(me){switch(me){case 1:return l.CodeActionTriggerKind.Invoke;case 2:return l.CodeActionTriggerKind.Automatic}}we.to=ye})(Mt=e.CodeActionTriggerKind||(e.CodeActionTriggerKind={}));var At;(function(we){function ye(q){const Pe=new l.TypeHierarchyItem(ce.to(q.kind),q.name,q.detail||"",R.URI.revive(q.uri),u.to(q.range),u.to(q.selectionRange));return Pe._sessionId=q._sessionId,Pe._itemId=q._itemId,Pe}we.to=ye;function me(q,Pe,Le){if(Pe=Pe??q._sessionId,Le=Le??q._itemId,Pe===void 0||Le===void 0)throw new Error("invalid item");return{_sessionId:Pe,_itemId:Le,kind:ce.from(q.kind),name:q.name,detail:q.detail??"",uri:q.uri,range:u.from(q.range),selectionRange:u.from(q.selectionRange),tags:q.tags?.map(re.from)}}we.from=me})(At=e.TypeHierarchyItem||(e.TypeHierarchyItem={}));var Lt;(function(we){function ye(me){if(!!me)return{value:me.value,tooltip:me.tooltip}}we.from=ye})(Lt=e.ViewBadge||(e.ViewBadge={}));var gt;(function(we){function ye(me,q){const Pe=me.fileData;return Pe?new class extends l.DataTransferItem{asFile(){return{name:Pe.name,uri:R.URI.revive(Pe.uri),data:(0,_.once)(()=>q())}}}(""):new l.DataTransferItem(me.asString)}we.toDataTransferItem=ye})(gt=e.DataTransferItem||(e.DataTransferItem={}));var It;(function(we){function ye(q,Pe){const Le=q.items.map(([Ye,Xe],Ke)=>[Ye,gt.toDataTransferItem(Xe,()=>Pe(Ke))]);return new l.DataTransfer(Le)}we.toDataTransfer=ye;async function me(q){const Pe={items:[]},Le=[];return q.forEach((Ye,Xe)=>{Le.push((async()=>{const Ke=await Ye.asString(),pt=Ye.asFile();Pe.items.push([Xe,{asString:Ke,fileData:pt?{name:pt.name,uri:pt.uri}:void 0}])})())}),await Promise.all(Le),Pe}we.toDataTransferDTO=me})(It=e.DataTransfer||(e.DataTransfer={}))}),define(De[173],Ce([1,0,2,11,6,8,240]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentSaveParticipant=void 0;class T{constructor(P,R,y,m={timeout:1500,errors:3}){this._logService=P,this._documents=R,this._mainThreadBulkEdits=y,this._thresholds=m,this._callbacks=new D.LinkedList,this._badListeners=new WeakMap}dispose(){this._callbacks.clear()}getOnWillSaveTextDocumentEvent(P){return(R,y,m)=>{const f={dispose:this._callbacks.push([R,y,P])};return Array.isArray(m)&&m.push(f),f}}async $participateInSave(P,R){const y=o.URI.revive(P);let m=!1;const I=setTimeout(()=>m=!0,this._thresholds.timeout),f=[];try{for(const h of[...this._callbacks]){if(m)break;const d=this._documents.getDocument(y),a=await this._deliverEventAsyncAndBlameBadListeners(h,{document:d,reason:L.TextDocumentSaveReason.to(R)});f.push(a)}}finally{clearTimeout(I)}return f}_deliverEventAsyncAndBlameBadListeners([P,R,y],m){const I=this._badListeners.get(P);return typeof I=="number"&&I>this._thresholds.errors?Promise.resolve(!1):this._deliverEventAsync(y,P,R,m).then(()=>!0,f=>{if(this._logService.error(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' threw ERROR`),this._logService.error(f),!(f instanceof Error)||f.message!=="concurrent_edits"){const h=this._badListeners.get(P);this._badListeners.set(P,h?h+1:1),typeof h=="number"&&h>this._thresholds.errors&&this._logService.info(`onWillSaveTextDocument-listener from extension '${y.identifier.value}' will now be IGNORED because of timeouts and/or errors`)}return!1})}_deliverEventAsync(P,R,y,m){const I=[],f=Date.now(),{document:h,reason:d}=m,{version:a}=h,v=Object.freeze({document:h,reason:d,waitUntil(A){if(Object.isFrozen(I))throw(0,p.illegalState)("waitUntil can not be called async");I.push(Promise.resolve(A))}});try{R.apply(y,[v])}catch(A){return Promise.reject(A)}return Object.freeze(I),new Promise((A,l)=>{const _=setTimeout(()=>l(new Error("timeout")),this._thresholds.timeout);return Promise.all(I).then(s=>{this._logService.debug(`onWillSaveTextDocument-listener from extension '${P.identifier.value}' finished after ${Date.now()-f}ms`),clearTimeout(_),A(s)}).catch(s=>{clearTimeout(_),l(s)})}).then(A=>{const l={edits:[]};for(const _ of A)if(Array.isArray(_)&&_.every(s=>s instanceof b.TextEdit))for(const{newText:s,newEol:u,range:n}of _)l.edits.push({resource:h.uri,versionId:void 0,textEdit:{range:n&&L.Range.from(n),text:s,eol:u&&L.EndOfLine.from(u)}});if(l.edits.length!==0)return a===h.version?this._mainThreadBulkEdits.$tryApplyWorkspaceEdit(l):Promise.reject(new Error("concurrent_edits"))})}}e.ExtHostDocumentSaveParticipant=T}),define(De[174],Ce([1,0,12,2,8,6,88]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookDocument=e.ExtHostCell=void 0;class T{constructor(y,m,I,f){this.start=y,this.deletedCount=m,this.deletedItems=I,this.items=f}asApiEvent(){return{range:new L.NotebookRange(this.start,this.start+this.deletedCount),addedCells:this.items.map(y=>y.apiCell),removedCells:this.deletedItems}}}class E{constructor(y,m,I){this.notebook=y,this._extHostDocument=m,this._cellData=I,this.handle=I.handle,this.uri=p.URI.revive(I.uri),this.cellKind=I.cellKind,this._outputs=I.outputs.map(b.NotebookCellOutput.to),this._internalMetadata=I.internalMetadata??{},this._metadata=Object.freeze(I.metadata??{}),this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(I.internalMetadata??{}))}static asModelAddData(y,m){return{EOL:m.eol,lines:m.source,languageId:m.language,uri:m.uri,isDirty:!1,versionId:1,notebook:y}}get internalMetadata(){return this._internalMetadata}get apiCell(){if(!this._apiCell){const y=this,m=this._extHostDocument.getDocument(this.uri);if(!m)throw new Error(`MISSING extHostDocument for notebook cell: ${this.uri}`);const I={get index(){return y.notebook.getCellIndex(y)},notebook:y.notebook.apiNotebook,kind:b.NotebookCellKind.to(this._cellData.cellKind),document:m.document,get mime(){return y._mime},set mime(f){y._mime=f},get outputs(){return y._outputs.slice(0)},get metadata(){return y._metadata},get executionSummary(){return y._previousResult}};this._apiCell=Object.freeze(I)}return this._apiCell}setOutputs(y){this._outputs=y.map(b.NotebookCellOutput.to)}setOutputItems(y,m,I){const f=I.map(b.NotebookCellOutputItem.to),h=this._outputs.find(d=>d.id===y);h&&(m||(h.items.length=0),h.items.push(...f))}setMetadata(y){this._metadata=Object.freeze(y)}setInternalMetadata(y){this._internalMetadata=y,this._previousResult=Object.freeze(b.NotebookCellExecutionSummary.to(y))}setMime(y){}}e.ExtHostCell=E;class P{constructor(y,m,I,f,h){this._proxy=y,this._textDocumentsAndEditors=m,this._textDocuments=I,this.uri=f,this.handle=P._handlePool++,this._cells=[],this._versionId=0,this._isDirty=!1,this._disposed=!1,this._notebookType=h.viewType,this._metadata=Object.freeze(h.metadata??Object.create(null)),this._spliceNotebookCells([[0,0,h.cells]],!0,void 0),this._versionId=h.versionId}dispose(){this._disposed=!0}get apiNotebook(){if(!this._notebook){const y=this,m={get uri(){return y.uri},get version(){return y._versionId},get notebookType(){return y._notebookType},get isDirty(){return y._isDirty},get isUntitled(){return y.uri.scheme===o.Schemas.untitled},get isClosed(){return y._disposed},get metadata(){return y._metadata},get cellCount(){return y._cells.length},cellAt(I){return I=y._validateIndex(I),y._cells[I].apiCell},getCells(I){return(I?y._getCells(I):y._cells).map(h=>h.apiCell)},save(){return y._save()}};this._notebook=Object.freeze(m)}return this._notebook}updateBackup(y){this._backup?.delete(),this._backup=y}disposeBackup(){this._backup?.delete(),this._backup=void 0}acceptDocumentPropertiesChanged(y){y.metadata&&(this._metadata=Object.freeze({...this._metadata,...y.metadata}))}acceptDirty(y){this._isDirty=y}acceptModelChanged(y,m,I){this._versionId=y.versionId,this._isDirty=m,this.acceptDocumentPropertiesChanged({metadata:I});const f={notebook:this.apiNotebook,metadata:I,cellChanges:[],contentChanges:[]},h=[];for(const a of y.rawEvents)a.kind===D.NotebookCellsChangeType.ModelChange?this._spliceNotebookCells(a.changes,!1,f.contentChanges):a.kind===D.NotebookCellsChangeType.Move?this._moveCell(a.index,a.newIdx,f.contentChanges):a.kind===D.NotebookCellsChangeType.Output?(this._setCellOutputs(a.index,a.outputs),h.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===D.NotebookCellsChangeType.OutputItem?(this._setCellOutputItems(a.index,a.outputId,a.append,a.outputItems),h.push({cell:this._cells[a.index].apiCell,outputs:this._cells[a.index].apiCell.outputs})):a.kind===D.NotebookCellsChangeType.ChangeCellLanguage?(this._changeCellLanguage(a.index,a.language),h.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document})):a.kind===D.NotebookCellsChangeType.ChangeCellContent?h.push({cell:this._cells[a.index].apiCell,document:this._cells[a.index].apiCell.document}):a.kind===D.NotebookCellsChangeType.ChangeCellMime?this._changeCellMime(a.index,a.mime):a.kind===D.NotebookCellsChangeType.ChangeCellMetadata?(this._changeCellMetadata(a.index,a.metadata),h.push({cell:this._cells[a.index].apiCell,metadata:this._cells[a.index].apiCell.metadata})):a.kind===D.NotebookCellsChangeType.ChangeCellInternalMetadata&&(this._changeCellInternalMetadata(a.index,a.internalMetadata),h.push({cell:this._cells[a.index].apiCell,executionSummary:this._cells[a.index].apiCell.executionSummary}));const d=new Map;for(let a=0;a<h.length;a++){const v=h[a],A=d.get(v.cell);if(A===void 0){const l=f.cellChanges.push({document:void 0,executionSummary:void 0,metadata:void 0,outputs:void 0,...v});d.set(v.cell,l-1)}else f.cellChanges[A]={...f.cellChanges[A],...v}}return Object.freeze(f),Object.freeze(f.cellChanges),Object.freeze(f.contentChanges),f}_validateIndex(y){return y=y|0,y<0?0:y>=this._cells.length?this._cells.length-1:y}_validateRange(y){let m=y.start|0,I=y.end|0;return m<0&&(m=0),I>this._cells.length&&(I=this._cells.length),y.with({start:m,end:I})}_getCells(y){y=this._validateRange(y);const m=[];for(let I=y.start;I<y.end;I++)m.push(this._cells[I]);return m}async _save(){return this._disposed?Promise.reject(new Error("Notebook has been closed")):this._proxy.$trySaveNotebook(this.uri)}_spliceNotebookCells(y,m,I){if(this._disposed)return;const f=[],h=[],d=[];if(y.reverse().forEach(a=>{const A=a[2].map(s=>{const u=new E(this,this._textDocumentsAndEditors,s);return m||h.push(E.asModelAddData(this.apiNotebook,s)),u}),l=new T(a[0],a[1],[],A),_=this._cells.splice(a[0],a[1],...A);for(const s of _)d.push(s.uri),l.deletedItems.push(s.apiCell);f.push(l)}),this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:h,removedDocuments:d}),I)for(const a of f)I.push(a.asApiEvent())}_moveCell(y,m,I){const f=this._cells.splice(y,1);this._cells.splice(m,0,...f);const h=[new T(y,1,f.map(d=>d.apiCell),[]),new T(m,0,[],f)];for(const d of h)I.push(d.asApiEvent())}_setCellOutputs(y,m){this._cells[y].setOutputs(m)}_setCellOutputItems(y,m,I,f){this._cells[y].setOutputItems(m,I,f)}_changeCellLanguage(y,m){const I=this._cells[y];I.apiCell.document.languageId!==m&&this._textDocuments.$acceptModelLanguageChanged(I.uri,m)}_changeCellMime(y,m){const I=this._cells[y];I.apiCell.mime=m}_changeCellMetadata(y,m){this._cells[y].setMetadata(m)}_changeCellInternalMetadata(y,m){this._cells[y].setInternalMetadata(m)}getCellFromApiCell(y){return this._cells.find(m=>m.apiCell===y)}getCellFromIndex(y){return this._cells[y]}getCell(y){return this._cells.find(m=>m.handle===y)}getCellIndex(y){return this._cells.indexOf(y)}}e.ExtHostNotebookDocument=P,P._handlePool=0}),define(De[91],Ce([1,0,6,8,11]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditor=void 0;class L{constructor(E){this._finalized=!1,this._collectedEdits=[],this._documentVersionId=E}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,cellEdits:this._collectedEdits}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replaceMetadata(E){this._throwIfFinalized(),this._collectedEdits.push({editType:5,metadata:E})}replaceCellMetadata(E,P){this._throwIfFinalized(),this._collectedEdits.push({editType:8,index:E,metadata:P})}replaceCells(E,P,R){this._throwIfFinalized(),!(E===P&&R.length===0)&&this._collectedEdits.push({editType:1,index:E,count:P-E,cells:R.map(p.NotebookCellData.from)})}}class D{constructor(E,P,R,y,m,I){this.id=E,this._proxy=P,this.notebookData=R,this._selections=[],this._visibleRanges=[],this._visible=!1,this._selections=m,this._visibleRanges=y,this._viewColumn=I}get apiEditor(){if(!this._editor){const E=this;this._editor={get document(){return E.notebookData.apiNotebook},get notebook(){return E.notebookData.apiNotebook},get selection(){return E._selections[0]},set selection(P){this.selections=[P]},get selections(){return E._selections},set selections(P){if(!Array.isArray(P)||!P.every(o.NotebookRange.isNotebookRange))throw(0,b.illegalArgument)("selections");E._selections=P,E._trySetSelections(P)},get visibleRanges(){return E._visibleRanges},revealRange(P,R){E._proxy.$tryRevealRange(E.id,p.NotebookRange.from(P),R??o.NotebookEditorRevealType.Default)},get viewColumn(){return E._viewColumn},edit(P){const R=new L(this.document.version);return P(R),E._applyEdit(R.finalize())}},D.apiEditorsToExtHost.set(this._editor,this)}return this._editor}get visible(){return this._visible}_acceptVisibility(E){this._visible=E}_acceptVisibleRanges(E){this._visibleRanges=E}_acceptSelections(E){this._selections=E}_trySetSelections(E){this._proxy.$trySetSelections(this.id,E.map(p.NotebookRange.from))}_acceptViewColumn(E){this._viewColumn=E}_applyEdit(E){if(E.cellEdits.length===0)return Promise.resolve(!0);const P=[];let R=-1;for(let y=0;y<E.cellEdits.length;y++){if(R<0){P.push(E.cellEdits[y]),R++;continue}const I=P[R],f=E.cellEdits[y];if(I.editType===1&&f.editType===1&&I.index===f.index){I.cells.push(...E.cellEdits[y].cells),I.count+=E.cellEdits[y].count;continue}P.push(E.cellEdits[y]),R++}return this._proxy.$tryApplyEdits(this.id,E.documentVersionId,P)}}e.ExtHostNotebookEditor=D,D.apiEditorsToExtHost=new WeakMap}),define(De[175],Ce([1,0,4,14,8]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookEditors=void 0;let L=class{constructor(T,E){this._logService=T,this._notebooksAndEditors=E,this._onDidChangeNotebookEditorSelection=new o.Emitter,this._onDidChangeNotebookEditorVisibleRanges=new o.Emitter,this.onDidChangeNotebookEditorSelection=this._onDidChangeNotebookEditorSelection.event,this.onDidChangeNotebookEditorVisibleRanges=this._onDidChangeNotebookEditorVisibleRanges.event}$acceptEditorPropertiesChanged(T,E){this._logService.debug("ExtHostNotebook#$acceptEditorPropertiesChanged",T,E);const P=this._notebooksAndEditors.getEditorById(T);E.visibleRanges&&P._acceptVisibleRanges(E.visibleRanges.ranges.map(b.NotebookRange.to)),E.selections&&P._acceptSelections(E.selections.selections.map(b.NotebookRange.to)),E.visibleRanges&&this._onDidChangeNotebookEditorVisibleRanges.fire({notebookEditor:P.apiEditor,visibleRanges:P.apiEditor.visibleRanges}),E.selections&&this._onDidChangeNotebookEditorSelection.fire(Object.freeze({notebookEditor:P.apiEditor,selections:P.apiEditor.selections}))}$acceptEditorViewColumns(T){for(const E in T)this._notebooksAndEditors.getEditorById(E)._acceptViewColumn(b.ViewColumn.to(T[E]))}};L=ze([xe(0,p.ILogService)],L),e.ExtHostNotebookEditors=L}),define(De[176],Ce([1,0,8,150,130,20,54,11]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostProgress=void 0;class E{constructor(m){this._handles=0,this._mapHandleToCancellationSource=new Map,this._proxy=m}async withProgress(m,I,f){const h=this._handles++,{title:d,location:a,cancellable:v}=I,A={label:(0,b.localize)(0,null,m.displayName||m.name),id:m.identifier.value};return this._proxy.$startProgress(h,{location:o.ProgressLocation.from(a),title:d,source:A,cancellable:v},m.isUnderDevelopment?void 0:m.identifier.value).catch(T.onUnexpectedExternalError),this._withProgress(h,f,!!v)}_withProgress(m,I,f){let h;f&&(h=new L.CancellationTokenSource,this._mapHandleToCancellationSource.set(m,h));const d=v=>{this._proxy.$progressEnd(v),this._mapHandleToCancellationSource.delete(v),h?.dispose()};let a;try{a=I(new R(this._proxy,m),f&&h?h.token:L.CancellationToken.None)}catch(v){throw d(m),v}return a.then(v=>d(m),v=>d(m)),a}$acceptProgressCanceled(m){const I=this._mapHandleToCancellationSource.get(m);I&&(I.cancel(),this._mapHandleToCancellationSource.delete(m))}}e.ExtHostProgress=E;function P(y,m){return y.message=m.message,typeof m.increment=="number"&&(typeof y.increment=="number"?y.increment+=m.increment:y.increment=m.increment),y}class R extends p.Progress{constructor(m,I){super(f=>this.throttledReport(f));this._proxy=m,this._handle=I}throttledReport(m){this._proxy.$progressReport(this._handle,m)}}ze([(0,D.throttle)(100,(y,m)=>P(y,m),()=>Object.create(null))],R.prototype,"throttledReport",null)}),define(De[92],Ce([1,0,48,89,46,65,47,8,2]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTestItemCollection=e.TestItemRootImpl=e.TestItemImpl=e.toItemFromContext=void 0;const P=(A,l,_,s)=>{let u=l;return{enumerable:!0,configurable:!1,get(){return u},set(n){if(!_(u,n)){const i=u;u=n,A.listener?.(s(n,i))}}}},R=(A,l)=>A===l,y={range:(A,l)=>A===l?!0:!A||!l?!1:A.isEqual(l),label:R,description:R,sortText:R,busy:R,error:R,canResolveChildren:R,tags:(A,l)=>!(A.length!==l.length||A.some(_=>!l.find(s=>_.id===s.id)))},m=A=>l=>({op:4,update:A(l)}),I=(A,l)=>({range:P(A,void 0,y.range,m(_=>({range:o.Range.lift(T.Range.from(_))}))),label:P(A,l,y.label,m(_=>({label:_}))),description:P(A,void 0,y.description,m(_=>({description:_}))),sortText:P(A,void 0,y.sortText,m(_=>({sortText:_}))),canResolveChildren:P(A,!1,y.canResolveChildren,_=>({op:2,state:_})),busy:P(A,!1,y.busy,m(_=>({busy:_}))),error:P(A,void 0,y.error,m(_=>({error:T.MarkdownString.fromStrict(_)||null}))),tags:P(A,[],y.tags,(_,s)=>({op:1,new:_.map(T.TestTag.from),old:s.map(T.TestTag.from)}))}),f=A=>{const l=b.TestId.fromString(A.extId),_=new d(l.controllerId,l.localId,A.label,E.URI.revive(A.uri)||void 0);return _.range=T.Range.to(A.range||void 0),_.description=A.description||void 0,_.sortText=A.sortText||void 0,_.tags=A.tags.map(s=>T.TestTag.to({id:(0,D.denamespaceTestTag)(s).tagId})),_},h=A=>{let l;for(const _ of A.tests){const s=f(_.item);(0,p.getPrivateApiFor)(s).parent=l,l=s}return l};e.toItemFromContext=h;class d{constructor(l,_,s,u){if(_.includes("\0"))throw new Error(`Test IDs may not include the ${JSON.stringify(_)} symbol`);const n=(0,p.createPrivateApiFor)(this,l);Object.defineProperties(this,{id:{value:_,enumerable:!0,writable:!1},uri:{value:u,enumerable:!0,writable:!1},parent:{enumerable:!1,get(){return n.parent instanceof a?void 0:n.parent}},children:{value:(0,L.createTestItemChildren)(n,p.getPrivateApiFor,d),enumerable:!0,writable:!1},...I(n,s)})}}e.TestItemImpl=d;class a extends d{constructor(l,_){super(l,l,_,void 0)}}e.TestItemRootImpl=a;class v extends L.TestItemCollection{constructor(l,_){super({controllerId:l,getApiFor:p.getPrivateApiFor,getChildren:s=>s.children,root:new a(l,_),toITestItem:T.TestItem.from})}}e.ExtHostTestItemCollection=v}),define(De[93],Ce([1,0,44,11,73,8,6]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTextEditor=e.ExtHostTextEditorOptions=e.TextEditorEdit=e.TextEditorDecorationType=void 0;class T{constructor(m,I,f){const h=T._Keys.nextId();m.$registerTextEditorDecorationType(I.identifier,h,L.DecorationRenderOptions.from(f)),this.value=Object.freeze({key:h,dispose(){m.$removeTextEditorDecorationType(h)}})}}e.TextEditorDecorationType=T,T._Keys=new b.IdGenerator("TextEditorDecorationType");class E{constructor(m,I){this._collectedEdits=[],this._setEndOfLine=void 0,this._finalized=!1,this._document=m,this._documentVersionId=m.version,this._undoStopBefore=I.undoStopBefore,this._undoStopAfter=I.undoStopAfter}finalize(){return this._finalized=!0,{documentVersionId:this._documentVersionId,edits:this._collectedEdits,setEndOfLine:this._setEndOfLine,undoStopBefore:this._undoStopBefore,undoStopAfter:this._undoStopAfter}}_throwIfFinalized(){if(this._finalized)throw new Error("Edit is only valid while callback runs")}replace(m,I){this._throwIfFinalized();let f=null;if(m instanceof D.Position)f=new D.Range(m,m);else if(m instanceof D.Range)f=m;else throw new Error("Unrecognized location");this._pushEdit(f,I,!1)}insert(m,I){this._throwIfFinalized(),this._pushEdit(new D.Range(m,m),I,!0)}delete(m){this._throwIfFinalized();let I=null;if(m instanceof D.Range)I=m;else throw new Error("Unrecognized location");this._pushEdit(I,null,!0)}_pushEdit(m,I,f){const h=this._document.validateRange(m);this._collectedEdits.push({range:h,text:I,forceMoveMarkers:f})}setEndOfLine(m){if(this._throwIfFinalized(),m!==D.EndOfLine.LF&&m!==D.EndOfLine.CRLF)throw(0,p.illegalArgument)("endOfLine");this._setEndOfLine=m}}e.TextEditorEdit=E;class P{constructor(m,I,f,h){this._proxy=m,this._id=I,this._accept(f),this._logService=h;const d=this;this.value={get tabSize(){return d._tabSize},set tabSize(a){d._setTabSize(a)},get insertSpaces(){return d._insertSpaces},set insertSpaces(a){d._setInsertSpaces(a)},get cursorStyle(){return d._cursorStyle},set cursorStyle(a){d._setCursorStyle(a)},get lineNumbers(){return d._lineNumbers},set lineNumbers(a){d._setLineNumbers(a)}}}_accept(m){this._tabSize=m.tabSize,this._insertSpaces=m.insertSpaces,this._cursorStyle=m.cursorStyle,this._lineNumbers=L.TextEditorLineNumbersStyle.to(m.lineNumbers)}_validateTabSize(m){if(m==="auto")return"auto";if(typeof m=="number"){const I=Math.floor(m);return I>0?I:null}if(typeof m=="string"){const I=parseInt(m,10);return isNaN(I)?null:I>0?I:null}return null}_setTabSize(m){const I=this._validateTabSize(m);if(I!==null){if(typeof I=="number"){if(this._tabSize===I)return;this._tabSize=I}this._warnOnError("setTabSize",this._proxy.$trySetOptions(this._id,{tabSize:I}))}}_validateInsertSpaces(m){return m==="auto"?"auto":m==="false"?!1:Boolean(m)}_setInsertSpaces(m){const I=this._validateInsertSpaces(m);if(typeof I=="boolean"){if(this._insertSpaces===I)return;this._insertSpaces=I}this._warnOnError("setInsertSpaces",this._proxy.$trySetOptions(this._id,{insertSpaces:I}))}_setCursorStyle(m){this._cursorStyle!==m&&(this._cursorStyle=m,this._warnOnError("setCursorStyle",this._proxy.$trySetOptions(this._id,{cursorStyle:m})))}_setLineNumbers(m){this._lineNumbers!==m&&(this._lineNumbers=m,this._warnOnError("setLineNumbers",this._proxy.$trySetOptions(this._id,{lineNumbers:L.TextEditorLineNumbersStyle.from(m)})))}assign(m){const I={};let f=!1;if(typeof m.tabSize!="undefined"){const h=this._validateTabSize(m.tabSize);h==="auto"?(f=!0,I.tabSize=h):typeof h=="number"&&this._tabSize!==h&&(this._tabSize=h,f=!0,I.tabSize=h)}if(typeof m.insertSpaces!="undefined"){const h=this._validateInsertSpaces(m.insertSpaces);h==="auto"?(f=!0,I.insertSpaces=h):this._insertSpaces!==h&&(this._insertSpaces=h,f=!0,I.insertSpaces=h)}typeof m.cursorStyle!="undefined"&&this._cursorStyle!==m.cursorStyle&&(this._cursorStyle=m.cursorStyle,f=!0,I.cursorStyle=m.cursorStyle),typeof m.lineNumbers!="undefined"&&this._lineNumbers!==m.lineNumbers&&(this._lineNumbers=m.lineNumbers,f=!0,I.lineNumbers=L.TextEditorLineNumbersStyle.from(m.lineNumbers)),f&&this._warnOnError("setOptions",this._proxy.$trySetOptions(this._id,I))}_warnOnError(m,I){I.catch(f=>{this._logService.warn(`ExtHostTextEditorOptions '${m}' failed:'`),this._logService.warn(f)})}}e.ExtHostTextEditorOptions=P;class R{constructor(m,I,f,h,d,a,v,A){this.id=m,this._proxy=I,this._logService=f,this._disposed=!1,this._hasDecorationsForKey=new Set,this._selections=d,this._options=new P(this._proxy,this.id,a,f),this._visibleRanges=v,this._viewColumn=A;const l=this;this.value=Object.freeze({get document(){return h.getValue()},set document(_){throw(0,p.readonly)("document")},get selection(){return l._selections&&l._selections[0]},set selection(_){if(!(_ instanceof D.Selection))throw(0,p.illegalArgument)("selection");l._selections=[_],l._trySetSelection()},get selections(){return l._selections},set selections(_){if(!Array.isArray(_)||_.some(s=>!(s instanceof D.Selection)))throw(0,p.illegalArgument)("selections");l._selections=_,l._trySetSelection()},get visibleRanges(){return l._visibleRanges},set visibleRanges(_){throw(0,p.readonly)("visibleRanges")},get options(){return l._options.value},set options(_){l._disposed||l._options.assign(_)},get viewColumn(){return l._viewColumn},set viewColumn(_){throw(0,p.readonly)("viewColumn")},edit(_,s={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#edit not possible on closed editors"));const u=new E(h.getValue(),s);return _(u),l._applyEdit(u)},insertSnippet(_,s,u={undoStopBefore:!0,undoStopAfter:!0}){if(l._disposed)return Promise.reject(new Error("TextEditor#insertSnippet not possible on closed editors"));let n;if(!s||Array.isArray(s)&&s.length===0)n=l._selections.map(i=>L.Range.from(i));else if(s instanceof D.Position){const{lineNumber:i,column:r}=L.Position.from(s);n=[{startLineNumber:i,startColumn:r,endLineNumber:i,endColumn:r}]}else if(s instanceof D.Range)n=[L.Range.from(s)];else{n=[];for(const i of s)if(i instanceof D.Range)n.push(L.Range.from(i));else{const{lineNumber:r,column:t}=L.Position.from(i);n.push({startLineNumber:r,startColumn:t,endLineNumber:r,endColumn:t})}}return I.$tryInsertSnippet(m,h.getValue().version,_.value,n,u)},setDecorations(_,s){const u=s.length===0;u&&!l._hasDecorationsForKey.has(_.key)||(u?l._hasDecorationsForKey.delete(_.key):l._hasDecorationsForKey.add(_.key),l._runOnProxy(()=>{if(L.isDecorationOptionsArr(s))return I.$trySetDecorations(m,_.key,L.fromRangeOrRangeWithMessage(s));{const n=new Array(4*s.length);for(let i=0,r=s.length;i<r;i++){const t=s[i];n[4*i]=t.start.line+1,n[4*i+1]=t.start.character+1,n[4*i+2]=t.end.line+1,n[4*i+3]=t.end.character+1}return I.$trySetDecorationsFast(m,_.key,n)}}))},revealRange(_,s){l._runOnProxy(()=>I.$tryRevealRange(m,L.Range.from(_),s||D.TextEditorRevealType.Default))},show(_){I.$tryShowEditor(m,L.ViewColumn.from(_))},hide(){I.$tryHideEditor(m)}})}dispose(){(0,o.ok)(!this._disposed),this._disposed=!0}_acceptOptions(m){(0,o.ok)(!this._disposed),this._options._accept(m)}_acceptVisibleRanges(m){(0,o.ok)(!this._disposed),this._visibleRanges=m}_acceptViewColumn(m){(0,o.ok)(!this._disposed),this._viewColumn=m}_acceptSelections(m){(0,o.ok)(!this._disposed),this._selections=m}async _trySetSelection(){const m=this._selections.map(L.Selection.from);return await this._runOnProxy(()=>this._proxy.$trySetSelections(this.id,m)),this.value}_applyEdit(m){const I=m.finalize();if(I.edits.length===0&&!I.setEndOfLine)return Promise.resolve(!0);const f=I.edits.map(d=>d.range);f.sort((d,a)=>d.end.line===a.end.line?d.end.character===a.end.character?d.start.line===a.start.line?d.start.character-a.start.character:d.start.line-a.start.line:d.end.character-a.end.character:d.end.line-a.end.line);for(let d=0,a=f.length-1;d<a;d++){const v=f[d].end;if(f[d+1].start.isBefore(v))return Promise.reject(new Error("Overlapping ranges are not allowed!"))}const h=I.edits.map(d=>({range:L.Range.from(d.range),text:d.text,forceMoveMarkers:d.forceMoveMarkers}));return this._proxy.$tryApplyEdits(this.id,I.documentVersionId,h,{setEndOfLine:typeof I.setEndOfLine=="number"?L.EndOfLine.from(I.setEndOfLine):void 0,undoStopBefore:I.undoStopBefore,undoStopAfter:I.undoStopAfter})}_runOnProxy(m){return this._disposed?(this._logService.warn("TextEditor is closed/disposed"),Promise.resolve(void 0)):m().then(()=>this,I=>(I instanceof Error&&I.name==="DISPOSED"||this._logService.warn(I),null))}}e.ExtHostTextEditor=R}),define(De[177],Ce([1,0,3,146]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IWorkbenchEnvironmentService=void 0,e.IWorkbenchEnvironmentService=(0,o.refineServiceDecorator)(p.IEnvironmentService)}),define(De[178],Ce([1,0,27,4,19]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionDescriptionRegistry=e.DeltaExtensionsResult=void 0;class L{constructor(y){this.removedDueToLooping=y}}e.DeltaExtensionsResult=L;class D{constructor(y){this._onDidChange=new p.Emitter,this.onDidChange=this._onDidChange.event,this._extensionDescriptions=y,this._initialize()}_initialize(){this._extensionDescriptions.sort(E),this._extensionsMap=new Map,this._extensionsArr=[],this._activationMap=new Map;for(const y of this._extensionDescriptions){if(this._extensionsMap.has(o.ExtensionIdentifier.toKey(y.identifier))){console.error("Extension `"+y.identifier.value+"` is already registered");continue}if(this._extensionsMap.set(o.ExtensionIdentifier.toKey(y.identifier),y),this._extensionsArr.push(y),Array.isArray(y.activationEvents))for(let m of y.activationEvents)m==="onUri"&&(m=`onUri:${o.ExtensionIdentifier.toKey(y.identifier)}`),this._activationMap.has(m)||this._activationMap.set(m,[]),this._activationMap.get(m).push(y)}}set(y){this._extensionDescriptions=y,this._initialize(),this._onDidChange.fire(void 0)}deltaExtensions(y,m){this._extensionDescriptions=P(this._extensionDescriptions,m),this._extensionDescriptions=this._extensionDescriptions.concat(y);const I=D._findLoopingExtensions(this._extensionDescriptions);return this._extensionDescriptions=P(this._extensionDescriptions,I.map(f=>f.identifier)),this._initialize(),this._onDidChange.fire(void 0),new L(I)}static _findLoopingExtensions(y){const m=new class{constructor(){this._arcs=new Map,this._nodesSet=new Set,this._nodesArr=[]}addNode(a){this._nodesSet.has(a)||(this._nodesSet.add(a),this._nodesArr.push(a))}addArc(a,v){this.addNode(a),this.addNode(v),this._arcs.has(a)?this._arcs.get(a).push(v):this._arcs.set(a,[v])}getArcs(a){return this._arcs.has(a)?this._arcs.get(a):[]}hasOnlyGoodArcs(a,v){const A=m.getArcs(a);for(let l=0;l<A.length;l++)if(!v.has(A[l]))return!1;return!0}getNodes(){return this._nodesArr}},I=new Map;for(const a of y){const v=o.ExtensionIdentifier.toKey(a.identifier);if(I.set(v,a),a.extensionDependencies)for(const A of a.extensionDependencies){const l=o.ExtensionIdentifier.toKey(A);m.addArc(v,l)}}const f=new Set;m.getNodes().filter(a=>m.getArcs(a).length===0).forEach(a=>f.add(a));const h=m.getNodes().filter(a=>!f.has(a));let d;do{d=!1;for(let a=0;a<h.length;a++){const v=h[a];m.hasOnlyGoodArcs(v,f)&&(h.splice(a,1),a--,f.add(v),d=!0)}}while(d);return h.map(a=>I.get(a))}containsActivationEvent(y){return this._activationMap.has(y)}containsExtension(y){return this._extensionsMap.has(o.ExtensionIdentifier.toKey(y))}getExtensionDescriptionsForActivationEvent(y){const m=this._activationMap.get(y);return m?m.slice(0):[]}getAllExtensionDescriptions(){return this._extensionsArr.slice(0)}getExtensionDescription(y){const m=this._extensionsMap.get(o.ExtensionIdentifier.toKey(y));return m||void 0}getExtensionDescriptionByUUID(y){for(const m of this._extensionsArr)if(m.uuid===y)return m}getExtensionDescriptionByIdOrUUID(y,m){return this.getExtensionDescription(y)??(m?this.getExtensionDescriptionByUUID(m):void 0)}}e.ExtensionDescriptionRegistry=D;var T;(function(R){R[R.Builtin=0]="Builtin",R[R.User=1]="User",R[R.Dev=2]="Dev"})(T||(T={}));function E(R,y){const m=R.isBuiltin?0:R.isUnderDevelopment?2:1,I=y.isBuiltin?0:y.isUnderDevelopment?2:1;if(m!==I)return m-I;const f=b.posix.basename(R.extensionLocation.path),h=b.posix.basename(y.extensionLocation.path);return f<h?-1:f>h?1:0}function P(R,y){const m=new Set;return y.forEach(I=>m.add(o.ExtensionIdentifier.toKey(I))),R.filter(I=>!m.has(o.ExtensionIdentifier.toKey(I.identifier)))}}),define(De[94],Ce([1,0,22]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NativeLogMarkers=e.isMessageOfType=e.createMessageOfType=e.MessageType=e.ExtensionHostExitCode=e.UIKind=void 0;var p;(function(P){P[P.Desktop=1]="Desktop",P[P.Web=2]="Web"})(p=e.UIKind||(e.UIKind={}));var b;(function(P){P[P.VersionMismatch=55]="VersionMismatch",P[P.UnexpectedError=81]="UnexpectedError"})(b=e.ExtensionHostExitCode||(e.ExtensionHostExitCode={}));var L;(function(P){P[P.Initialized=0]="Initialized",P[P.Ready=1]="Ready",P[P.Terminate=2]="Terminate"})(L=e.MessageType||(e.MessageType={}));function D(P){const R=o.VSBuffer.alloc(1);switch(P){case 0:R.writeUInt8(1,0);break;case 1:R.writeUInt8(2,0);break;case 2:R.writeUInt8(3,0);break}return R}e.createMessageOfType=D;function T(P,R){if(P.byteLength!==1)return!1;switch(P.readUInt8(0)){case 1:return R===0;case 2:return R===1;case 3:return R===2;default:return!1}}e.isMessageOfType=T;var E;(function(P){P.Start="START_NATIVE_LOG",P.End="END_NATIVE_LOG"})(E=e.NativeLogMarkers||(e.NativeLogMarkers={}))}),define(De[24],Ce([1,0,4,2,3,27,152]),function(te,e,o,p,b,L,D){"use strict";var T;Object.defineProperty(e,"__esModule",{value:!0}),e.NullExtensionService=e.toExtensionDescription=e.toExtension=e.ActivationKind=e.ExtensionHostLogFileName=e.ExtensionPointContribution=e.ActivationTimes=e.checkProposedApiEnabled=e.isProposedApiEnabled=e.extensionIdentifiersArrayToSet=e.ExtensionIdentifierSet=e.ExtensionHostExtensions=e.extensionHostKindToString=e.ExtensionHostKind=e.MissingExtensionDependency=e.RemoteRunningLocation=e.LocalWebWorkerRunningLocation=e.LocalProcessRunningLocation=e.IExtensionService=e.webWorkerExtHostConfig=e.nullExtensionDescription=void 0,e.nullExtensionDescription=Object.freeze({identifier:new L.ExtensionIdentifier("nullExtensionDescription"),name:"Null Extension Description",version:"0.0.0",publisher:"vscode",engines:{vscode:""},extensionLocation:p.URI.parse("void:location"),isBuiltin:!1,targetPlatform:"undefined",isUserBuiltin:!1,isUnderDevelopment:!1}),e.webWorkerExtHostConfig="extensions.webWorker",e.IExtensionService=(0,b.createDecorator)("extensionService");class E{constructor(t){this.affinity=t,this.kind=1}equals(t){return this.kind===t.kind&&this.affinity===t.affinity}asString(){return this.affinity===0?"LocalProcess":`LocalProcess${this.affinity}`}}e.LocalProcessRunningLocation=E;class P{constructor(){this.kind=2,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"LocalWebWorker"}}e.LocalWebWorkerRunningLocation=P;class R{constructor(){this.kind=3,this.affinity=0}equals(t){return this.kind===t.kind}asString(){return"Remote"}}e.RemoteRunningLocation=R;class y{constructor(t){this.dependency=t}}e.MissingExtensionDependency=y;var m;(function(r){r[r.LocalProcess=1]="LocalProcess",r[r.LocalWebWorker=2]="LocalWebWorker",r[r.Remote=3]="Remote"})(m=e.ExtensionHostKind||(e.ExtensionHostKind={}));function I(r){if(r===null)return"None";switch(r){case 1:return"LocalProcess";case 2:return"LocalWebWorker";case 3:return"Remote"}}e.extensionHostKindToString=I;class f{constructor(){this._allExtensions=[],this._myExtensions=[]}toDelta(){return{toRemove:[],toAdd:this._allExtensions,myToRemove:[],myToAdd:this._myExtensions}}set(t,c){const w=[],g=[],C=[],U=[],W=a(this._allExtensions),M=a(t),S=(K,V)=>K.extensionLocation.toString()===V.extensionLocation.toString()||K.isBuiltin===V.isBuiltin||K.isUserBuiltin===V.isUserBuiltin||K.isUnderDevelopment===V.isUnderDevelopment;for(const K of this._allExtensions){const V=M.get(L.ExtensionIdentifier.toKey(K.identifier));if(!V){w.push(K.identifier),W.delete(L.ExtensionIdentifier.toKey(K.identifier));continue}if(!S(K,V)){w.push(K.identifier),W.delete(L.ExtensionIdentifier.toKey(K.identifier));continue}}for(const K of t){const V=W.get(L.ExtensionIdentifier.toKey(K.identifier));if(!V){g.push(K);continue}if(!S(V,K)){w.push(V.identifier),W.delete(L.ExtensionIdentifier.toKey(V.identifier));continue}}const z=d(this._myExtensions),$=d(c);for(const K of this._myExtensions)$.has(L.ExtensionIdentifier.toKey(K))||C.push(K);for(const K of c)z.has(L.ExtensionIdentifier.toKey(K))||U.push(K);const N={toRemove:w,toAdd:g,myToRemove:C,myToAdd:U};return this.delta(N),N}delta(t){const{toRemove:c,toAdd:w,myToRemove:g,myToAdd:C}=t,U=d(c),W=d(g);for(let M=0;M<this._allExtensions.length;M++)U.has(L.ExtensionIdentifier.toKey(this._allExtensions[M].identifier))&&(this._allExtensions.splice(M,1),M--);for(let M=0;M<this._myExtensions.length;M++)W.has(L.ExtensionIdentifier.toKey(this._myExtensions[M]))&&(this._myExtensions.splice(M,1),M--);for(const M of w)this._allExtensions.push(M);for(const M of C)this._myExtensions.push(M)}containsExtension(t){for(const c of this._myExtensions)if(L.ExtensionIdentifier.equals(c,t))return!0;return!1}}e.ExtensionHostExtensions=f;class h{constructor(t){if(this[T]="ExtensionIdentifierSet",this._map=new Map,this._toKey=L.ExtensionIdentifier.toKey,t)for(const c of t)this.add(c)}get size(){return this._map.size}add(t){return this._map.set(this._toKey(t),t),this}clear(){this._map.clear()}delete(t){return this._map.delete(this._toKey(t))}has(t){return this._map.has(this._toKey(t))}forEach(t,c){this._map.forEach(w=>t.call(c,w,w,this))}*entries(){for(const[t,c]of this._map)yield[c,c]}keys(){return this._map.values()}values(){return this._map.values()}[(T=Symbol.toStringTag,Symbol.iterator)](){return this._map.values()}}e.ExtensionIdentifierSet=h;function d(r){const t=new Set;for(const c of r)t.add(L.ExtensionIdentifier.toKey(c));return t}e.extensionIdentifiersArrayToSet=d;function a(r){const t=new Map;for(const c of r)t.set(L.ExtensionIdentifier.toKey(c.identifier),c);return t}function v(r,t){return r.enabledApiProposals?r.enabledApiProposals.includes(t):!1}e.isProposedApiEnabled=v;function A(r,t){if(!v(r,t))throw new Error(`Extension '${r.identifier.value}' CANNOT use API proposal: ${t}.
Its package.json#enabledApiProposals-property declares: ${r.enabledApiProposals?.join(", ")??"[]"} but NOT ${t}.
 The missing proposal MUST be added and you must start in extension development mode or use the following command line switch: --enable-proposed-api ${r.identifier.value}`)}e.checkProposedApiEnabled=A;class l{constructor(t,c,w,g){this.codeLoadingTime=t,this.activateCallTime=c,this.activateResolvedTime=w,this.activationReason=g}}e.ActivationTimes=l;class _{constructor(t,c){this.description=t,this.value=c}}e.ExtensionPointContribution=_,e.ExtensionHostLogFileName="exthost";var s;(function(r){r[r.Normal=0]="Normal",r[r.Immediate=1]="Immediate"})(s=e.ActivationKind||(e.ActivationKind={}));function u(r){return{type:r.isBuiltin?0:1,isBuiltin:r.isBuiltin||r.isUserBuiltin,identifier:{id:(0,D.getGalleryExtensionId)(r.publisher,r.name),uuid:r.uuid},manifest:r,location:r.extensionLocation,targetPlatform:r.targetPlatform,validations:[],isValid:!0}}e.toExtension=u;function n(r,t){return{identifier:new L.ExtensionIdentifier((0,D.getExtensionId)(r.manifest.publisher,r.manifest.name)),isBuiltin:r.type===0,isUserBuiltin:r.type===1&&r.isBuiltin,isUnderDevelopment:!!t,extensionLocation:r.location,...r.manifest,uuid:r.identifier.uuid,targetPlatform:r.targetPlatform}}e.toExtensionDescription=n;class i{constructor(){this.onDidRegisterExtensions=o.Event.None,this.onDidChangeExtensionsStatus=o.Event.None,this.onDidChangeExtensions=o.Event.None,this.onWillActivateByEvent=o.Event.None,this.onDidChangeResponsiveChange=o.Event.None}activateByEvent(t){return Promise.resolve(void 0)}activationEventIsDone(t){return!1}whenInstalledExtensionsRegistered(){return Promise.resolve(!0)}getExtensions(){return Promise.resolve([])}getExtension(){return Promise.resolve(void 0)}readExtensionPointContributions(t){return Promise.resolve(Object.create(null))}getExtensionsStatus(){return Object.create(null)}getInspectPort(t,c){return Promise.resolve(0)}getInspectPorts(t,c){return Promise.resolve([])}stopExtensionHosts(){}async restartExtensionHost(){}async startExtensionHosts(){}async setRemoteEnvironment(t){}canAddExtension(){return!1}canRemoveExtension(){return!1}_activateById(t,c){return Promise.resolve()}}e.NullExtensionService=i}),define(De[179],Ce([1,0,11,27,24,14,13]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsActivator=e.FailedExtension=e.HostExtension=e.EmptyExtension=e.ActivatedExtension=e.ExtensionActivationTimesBuilder=e.ExtensionActivationTimes=void 0;class T{constructor(d,a,v,A){this.startup=d,this.codeLoadingTime=a,this.activateCallTime=v,this.activateResolvedTime=A}}e.ExtensionActivationTimes=T,T.NONE=new T(!1,-1,-1,-1);class E{constructor(d){this._startup=d,this._codeLoadingStart=-1,this._codeLoadingStop=-1,this._activateCallStart=-1,this._activateCallStop=-1,this._activateResolveStart=-1,this._activateResolveStop=-1}_delta(d,a){return d===-1||a===-1?-1:a-d}build(){return new T(this._startup,this._delta(this._codeLoadingStart,this._codeLoadingStop),this._delta(this._activateCallStart,this._activateCallStop),this._delta(this._activateResolveStart,this._activateResolveStop))}codeLoadingStart(){this._codeLoadingStart=Date.now()}codeLoadingStop(){this._codeLoadingStop=Date.now()}activateCallStart(){this._activateCallStart=Date.now()}activateCallStop(){this._activateCallStop=Date.now()}activateResolveStart(){this._activateResolveStart=Date.now()}activateResolveStop(){this._activateResolveStop=Date.now()}}e.ExtensionActivationTimesBuilder=E;class P{constructor(d,a,v,A,l,_){this.activationFailed=d,this.activationFailedError=a,this.activationTimes=v,this.module=A,this.exports=l,this.subscriptions=_}}e.ActivatedExtension=P;class R extends P{constructor(d){super(!1,null,d,{activate:void 0,deactivate:void 0},void 0,[])}}e.EmptyExtension=R;class y extends P{constructor(){super(!1,null,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.HostExtension=y;class m extends P{constructor(d){super(!0,d,T.NONE,{activate:void 0,deactivate:void 0},void 0,[])}}e.FailedExtension=m;let I=class{constructor(d,a,v,A,l){this._logService=l,this._registry=d,this._resolvedExtensionsSet=new Set,a.forEach(_=>this._resolvedExtensionsSet.add(p.ExtensionIdentifier.toKey(_))),this._externalExtensionsMap=new Map,v.forEach(_=>this._externalExtensionsMap.set(p.ExtensionIdentifier.toKey(_),_)),this._host=A,this._operations=new Map,this._alreadyActivatedEvents=Object.create(null)}dispose(){for(const[d,a]of this._operations)a.dispose()}isActivated(d){const a=this._operations.get(p.ExtensionIdentifier.toKey(d));return Boolean(a&&a.value)}getActivatedExtension(d){const a=this._operations.get(p.ExtensionIdentifier.toKey(d));if(!a||!a.value)throw new Error(`Extension '${d.value}' is not known or not activated`);return a.value}async activateByEvent(d,a){if(this._alreadyActivatedEvents[d])return;const v=this._registry.getExtensionDescriptionsForActivationEvent(d);await this._activateExtensions(v.map(A=>({id:A.identifier,reason:{startup:a,extensionId:A.identifier,activationEvent:d}}))),this._alreadyActivatedEvents[d]=!0}activateById(d,a){const v=this._registry.getExtensionDescription(d);if(!v)throw new Error(`Extension '${d}' is not known`);return this._activateExtensions([{id:v.identifier,reason:a}])}async _activateExtensions(d){const a=d.filter(v=>!this.isActivated(v.id)).map(v=>this._handleActivationRequest(v));await Promise.all(a.map(v=>v.wait()))}_handleActivationRequest(d){if(this._operations.has(p.ExtensionIdentifier.toKey(d.id)))return this._operations.get(p.ExtensionIdentifier.toKey(d.id));if(this._externalExtensionsMap.has(p.ExtensionIdentifier.toKey(d.id)))return this._createAndSaveOperation(d,null,[],null);const a=this._registry.getExtensionDescription(d.id);if(!a){const l=new Error(`Cannot activate unknown extension '${d.id.value}'`),_=this._createAndSaveOperation(d,null,[],new m(l));return this._host.onExtensionActivationError(d.id,l,new b.MissingExtensionDependency(d.id.value)),_}const v=[],A=typeof a.extensionDependencies=="undefined"?[]:a.extensionDependencies;for(const l of A){if(this._resolvedExtensionsSet.has(p.ExtensionIdentifier.toKey(l)))continue;const _=this._operations.get(p.ExtensionIdentifier.toKey(l));if(_){v.push(_);continue}if(this._externalExtensionsMap.has(p.ExtensionIdentifier.toKey(l))){v.push(this._handleActivationRequest({id:this._externalExtensionsMap.get(p.ExtensionIdentifier.toKey(l)),reason:d.reason}));continue}const s=this._registry.getExtensionDescription(l);if(s){if(!s.main&&!s.browser)continue;v.push(this._handleActivationRequest({id:s.identifier,reason:d.reason}));continue}const u=a.displayName||a.identifier.value,n=new Error(`Cannot activate the '${u}' extension because it depends on unknown extension '${l}'`),i=this._createAndSaveOperation(d,a.displayName,[],new m(n));return this._host.onExtensionActivationError(a.identifier,n,new b.MissingExtensionDependency(l)),i}return this._createAndSaveOperation(d,a.displayName,v,null)}_createAndSaveOperation(d,a,v,A){const l=new f(d.id,a,d.reason,v,A,this._host,this._logService);return this._operations.set(p.ExtensionIdentifier.toKey(d.id),l),l}};I=ze([xe(4,L.ILogService)],I),e.ExtensionsActivator=I;let f=class{constructor(d,a,v,A,l,_,s){this._id=d,this._displayName=a,this._reason=v,this._deps=A,this._value=l,this._host=_,this._logService=s,this._barrier=new D.Barrier,this._isDisposed=!1,this._initialize()}get value(){return this._value}get friendlyName(){return this._displayName||this._id.value}dispose(){this._isDisposed=!0}wait(){return this._barrier.wait()}async _initialize(){await this._waitForDepsThenActivate(),this._barrier.open()}async _waitForDepsThenActivate(){if(!this._value){for(;this._deps.length>0;){for(let d=0;d<this._deps.length;d++){const a=this._deps[d];if(a.value&&!a.value.activationFailed){this._deps.splice(d,1),d--;continue}if(a.value&&a.value.activationFailed){const v=new Error(`Cannot activate the '${this.friendlyName}' extension because its dependency '${a.friendlyName}' failed to activate`);v.detail=a.value.activationFailedError,this._value=new m(v),this._host.onExtensionActivationError(this._id,v,null);return}}this._deps.length>0&&await Promise.race(this._deps.map(d=>d.wait()))}await this._activate()}}async _activate(){try{this._value=await this._host.actualActivateExtension(this._id,this._reason)}catch(d){const a=new Error;if(d&&d.name&&(a.name=d.name),d&&d.message?a.message=`Activating extension '${this._id.value}' failed: ${d.message}.`:a.message=`Activating extension '${this._id.value}' failed: ${d}.`,d&&d.stack&&(a.stack=d.stack),this._value=new m(a),this._isDisposed&&o.isCancellationError(d))return;this._host.onExtensionActivationError(this._id,a,null),this._logService.error(`Activating extension ${this._id.value} failed due to an error:`),this._logService.error(d)}}};f=ze([xe(6,L.ILogService)],f)}),define(De[180],Ce([1,0,14,28,24]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLogService=void 0;let L=class extends o.LogService{constructor(T,E){super(T.createLogger(E.logFile,{name:b.ExtensionHostLogFileName}))}};L=ze([xe(0,o.ILoggerService),xe(1,p.IExtHostInitDataService)],L),e.ExtHostLogService=L}),define(De[181],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.allApiProposals=void 0,e.allApiProposals=Object.freeze({authSession:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.authSession.d.ts",badges:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.badges.d.ts",commentsResolvedState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.commentsResolvedState.d.ts",contribEditSessions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribEditSessions.d.ts",contribLabelFormatterWorkspaceTooltip:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribLabelFormatterWorkspaceTooltip.d.ts",contribMenuBarHome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMenuBarHome.d.ts",contribMergeEditorToolbar:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribMergeEditorToolbar.d.ts",contribRemoteHelp:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribRemoteHelp.d.ts",contribShareMenu:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribShareMenu.d.ts",contribViewSize:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewSize.d.ts",contribViewsRemote:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsRemote.d.ts",contribViewsWelcome:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribViewsWelcome.d.ts",contribWebviewContext:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.contribWebviewContext.d.ts",customEditorMove:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.customEditorMove.d.ts",diffCommand:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.diffCommand.d.ts",documentFiltersExclusive:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentFiltersExclusive.d.ts",documentPaste:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.documentPaste.d.ts",editorInsets:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.editorInsets.d.ts",extensionRuntime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionRuntime.d.ts",extensionsAny:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.extensionsAny.d.ts",externalUriOpener:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.externalUriOpener.d.ts",fileSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fileSearchProvider.d.ts",findTextInFiles:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.findTextInFiles.d.ts",fsChunks:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.fsChunks.d.ts",idToken:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.idToken.d.ts",inlineCompletionsAdditions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsAdditions.d.ts",inlineCompletionsNew:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.inlineCompletionsNew.d.ts",interactiveWindow:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.interactiveWindow.d.ts",ipc:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.ipc.d.ts",notebookCellExecutionState:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookCellExecutionState.d.ts",notebookContentProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookContentProvider.d.ts",notebookControllerKind:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookControllerKind.d.ts",notebookDebugOptions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDebugOptions.d.ts",notebookDeprecated:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookDeprecated.d.ts",notebookEditor:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditor.d.ts",notebookEditorEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookEditorEdit.d.ts",notebookKernelSource:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookKernelSource.d.ts",notebookLiveShare:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookLiveShare.d.ts",notebookMessaging:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMessaging.d.ts",notebookMime:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookMime.d.ts",notebookWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.notebookWorkspaceEdit.d.ts",portsAttributes:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.portsAttributes.d.ts",quickPickSortByLabel:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.quickPickSortByLabel.d.ts",resolvers:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.resolvers.d.ts",scmActionButton:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmActionButton.d.ts",scmSelectedProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmSelectedProvider.d.ts",scmValidation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.scmValidation.d.ts",snippetWorkspaceEdit:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.snippetWorkspaceEdit.d.ts",tabInputTextMerge:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tabInputTextMerge.d.ts",taskPresentationGroup:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.taskPresentationGroup.d.ts",telemetry:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.telemetry.d.ts",terminalDataWriteEvent:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDataWriteEvent.d.ts",terminalDimensions:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalDimensions.d.ts",terminalExitReason:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.terminalExitReason.d.ts",testCoverage:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testCoverage.d.ts",testObserver:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.testObserver.d.ts",textSearchProvider:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.textSearchProvider.d.ts",timeline:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.timeline.d.ts",tokenInformation:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tokenInformation.d.ts",treeViewReveal:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.treeViewReveal.d.ts",tunnels:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.tunnels.d.ts",workspaceTrust:"https://raw.githubusercontent.com/microsoft/vscode/main/src/vscode-dts/vscode.proposed.workspaceTrust.d.ts"})}),define(De[182],Ce([1,0,141,11,29,79,82,30,27,181,149]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionsRegistry=e.ExtensionsRegistryImpl=e.schema=e.ExtensionPoint=e.ExtensionPointUserDelta=e.ExtensionMessageCollector=void 0;const y=T.Registry.as(D.Extensions.JSONContribution);class m{constructor(l,_,s){this._messageHandler=l,this._extension=_,this._extensionPointId=s}_msg(l,_){this._messageHandler({type:l,message:_,extensionId:this._extension.identifier,extensionPointId:this._extensionPointId})}error(l){this._msg(b.default.Error,l)}warn(l){this._msg(b.default.Warning,l)}info(l){this._msg(b.default.Info,l)}}e.ExtensionMessageCollector=m;class I{constructor(l,_){this.added=l,this.removed=_}static _toSet(l){const _=new Set;for(let s=0,u=l.length;s<u;s++)_.add(E.ExtensionIdentifier.toKey(l[s].description.identifier));return _}static compute(l,_){if(!l||!l.length)return new I(_,[]);if(!_||!_.length)return new I([],l);const s=this._toSet(l),u=this._toSet(_),n=_.filter(r=>!s.has(E.ExtensionIdentifier.toKey(r.description.identifier))),i=l.filter(r=>!u.has(E.ExtensionIdentifier.toKey(r.description.identifier)));return new I(n,i)}}e.ExtensionPointUserDelta=I;class f{constructor(l,_){this.name=l,this.defaultExtensionKind=_,this._handler=null,this._users=null,this._delta=null}setHandler(l){if(this._handler!==null)throw new Error("Handler already set!");this._handler=l,this._handle()}acceptUsers(l){this._delta=I.compute(this._users,l),this._users=l,this._handle()}_handle(){if(!(this._handler===null||this._users===null||this._delta===null))try{this._handler(this._users,this._delta)}catch(l){(0,p.onUnexpectedError)(l)}}}e.ExtensionPoint=f;const h={type:"string",enum:["ui","workspace"],enumDescriptions:[o.localize(0,null),o.localize(1,null)]},d="vscode://schemas/vscode-extensions";e.schema={properties:{engines:{type:"object",description:o.localize(2,null),properties:{vscode:{type:"string",description:o.localize(3,null),default:"^1.22.0"}}},publisher:{description:o.localize(4,null),type:"string"},displayName:{description:o.localize(5,null),type:"string"},categories:{description:o.localize(6,null),type:"array",uniqueItems:!0,items:{oneOf:[{type:"string",enum:E.EXTENSION_CATEGORIES},{type:"string",const:"Languages",deprecationMessage:o.localize(7,null)}]}},galleryBanner:{type:"object",description:o.localize(8,null),properties:{color:{description:o.localize(9,null),type:"string"},theme:{description:o.localize(10,null),type:"string",enum:["dark","light"]}}},contributes:{description:o.localize(11,null),type:"object",properties:{},default:{}},preview:{type:"boolean",description:o.localize(12,null)},enableProposedApi:{type:"boolean",deprecationMessage:o.localize(13,null)},enabledApiProposals:{markdownDescription:o.localize(14,null),type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}},activationEvents:{description:o.localize(15,null),type:"array",items:{type:"string",defaultSnippets:[{label:"onWebviewPanel",description:o.localize(16,null),body:"onWebviewPanel:viewType"},{label:"onLanguage",description:o.localize(17,null),body:"onLanguage:${1:languageId}"},{label:"onCommand",description:o.localize(18,null),body:"onCommand:${2:commandId}"},{label:"onDebug",description:o.localize(19,null),body:"onDebug"},{label:"onDebugInitialConfigurations",description:o.localize(20,null),body:"onDebugInitialConfigurations"},{label:"onDebugDynamicConfigurations",description:o.localize(21,null),body:"onDebugDynamicConfigurations"},{label:"onDebugResolve",description:o.localize(22,null),body:"onDebugResolve:${6:type}"},{label:"onDebugAdapterProtocolTracker",description:o.localize(23,null),body:"onDebugAdapterProtocolTracker:${6:type}"},{label:"workspaceContains",description:o.localize(24,null),body:"workspaceContains:${4:filePattern}"},{label:"onStartupFinished",description:o.localize(25,null),body:"onStartupFinished"},{label:"onTaskType",description:o.localize(26,null),body:"onTaskType:${1:taskType}"},{label:"onFileSystem",description:o.localize(27,null),body:"onFileSystem:${1:scheme}"},{label:"onSearch",description:o.localize(28,null),body:"onSearch:${7:scheme}"},{label:"onView",body:"onView:${5:viewId}",description:o.localize(29,null)},{label:"onIdentity",body:"onIdentity:${8:identity}",description:o.localize(30,null)},{label:"onUri",body:"onUri",description:o.localize(31,null)},{label:"onOpenExternalUri",body:"onOpenExternalUri",description:o.localize(32,null)},{label:"onCustomEditor",body:"onCustomEditor:${9:viewType}",description:o.localize(33,null)},{label:"onNotebook",body:"onNotebook:${1:type}",description:o.localize(34,null)},{label:"onAuthenticationRequest",body:"onAuthenticationRequest:${11:authenticationProviderId}",description:o.localize(35,null)},{label:"onRenderer",description:o.localize(36,null),body:"onRenderer:${11:rendererId}"},{label:"onTerminalProfile",body:"onTerminalProfile:${1:terminalId}",description:o.localize(37,null)},{label:"onWalkthrough",body:"onWalkthrough:${1:walkthroughID}",description:o.localize(38,null)},{label:"*",description:o.localize(39,null),body:"*"}]}},badges:{type:"array",description:o.localize(40,null),items:{type:"object",required:["url","href","description"],properties:{url:{type:"string",description:o.localize(41,null)},href:{type:"string",description:o.localize(42,null)},description:{type:"string",description:o.localize(43,null)}}}},markdown:{type:"string",description:o.localize(44,null),enum:["github","standard"],default:"github"},qna:{default:"marketplace",description:o.localize(45,null),anyOf:[{type:["string","boolean"],enum:["marketplace",!1]},{type:"string"}]},extensionDependencies:{description:o.localize(46,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionPack:{description:o.localize(47,null),type:"array",uniqueItems:!0,items:{type:"string",pattern:L.EXTENSION_IDENTIFIER_PATTERN}},extensionKind:{description:o.localize(48,null),type:"array",items:h,default:["workspace"],defaultSnippets:[{body:["ui"],description:o.localize(49,null)},{body:["workspace"],description:o.localize(50,null)},{body:["ui","workspace"],description:o.localize(51,null)},{body:["workspace","ui"],description:o.localize(52,null)},{body:[],description:o.localize(53,null)}]},capabilities:{description:o.localize(54,null),type:"object",properties:{virtualWorkspaces:{description:o.localize(55,null),type:["boolean","object"],defaultSnippets:[{label:"limited",body:{supported:"${1:limited}",description:"${2}"}},{label:"false",body:{supported:!1,description:"${2}"}}],default:(!0).valueOf,properties:{supported:{markdownDescription:o.localize(56,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(57,null),o.localize(58,null),o.localize(59,null)]},description:{type:"string",markdownDescription:o.localize(60,null)}}},untrustedWorkspaces:{description:o.localize(61,null),type:"object",required:["supported"],defaultSnippets:[{body:{supported:"${1:limited}",description:"${2}"}}],properties:{supported:{markdownDescription:o.localize(62,null),type:["string","boolean"],enum:["limited",!0,!1],enumDescriptions:[o.localize(63,null),o.localize(64,null),o.localize(65,null)]},restrictedConfigurations:{description:o.localize(66,null),type:"array",items:{type:"string"}},description:{type:"string",markdownDescription:o.localize(67,null)}}}}},sponsor:{description:o.localize(68,null),type:"object",defaultSnippets:[{body:{url:"${1:https:}"}}],properties:{url:{description:o.localize(69,null),type:"string"}}},scripts:{type:"object",properties:{"vscode:prepublish":{description:o.localize(70,null),type:"string"},"vscode:uninstall":{description:o.localize(71,null),type:"string"}}},icon:{type:"string",description:o.localize(72,null)}}};class a{constructor(){this._extensionPoints=new Map}registerExtensionPoint(l){if(this._extensionPoints.has(l.extensionPoint))throw new Error("Duplicate extension point: "+l.extensionPoint);const _=new f(l.extensionPoint,l.defaultExtensionKind);return this._extensionPoints.set(l.extensionPoint,_),e.schema.properties.contributes.properties[l.extensionPoint]=l.jsonSchema,y.registerSchema(d,e.schema),_}getExtensionPoints(){return Array.from(this._extensionPoints.values())}}e.ExtensionsRegistryImpl=a;const v={ExtensionsRegistry:"ExtensionsRegistry"};T.Registry.add(v.ExtensionsRegistry,new a),e.ExtensionsRegistry=T.Registry.as(v.ExtensionsRegistry),y.registerSchema(d,e.schema),y.registerSchema(R.productSchemaId,{properties:{extensionEnabledApiProposals:{description:o.localize(73,null),type:"object",properties:{},additionalProperties:{anyOf:[{type:"array",uniqueItems:!0,items:{type:"string",enum:Object.keys(P.allApiProposals),markdownEnumDescriptions:Object.values(P.allApiProposals)}}]}}}})}),define(De[183],Ce([1,0,138,10,26,182,38,4]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinitionRegistry=e.TaskDefinitionRegistryImpl=void 0;const E={type:"object",additionalProperties:!1,properties:{type:{type:"string",description:o.localize(0,null)},required:{type:"array",items:{type:"string"}},properties:{type:"object",description:o.localize(1,null),additionalProperties:{$ref:"http://json-schema.org/draft-07/schema#"}},when:{type:"string",markdownDescription:o.localize(2,null),default:""}}};var P;(function(m){function I(f,h,d){if(!f)return;const a=p.isString(f.type)?f.type:void 0;if(!a||a.length===0){d.error(o.localize(3,null));return}const v=[];if(Array.isArray(f.required))for(const A of f.required)p.isString(A)&&v.push(A);return{extensionId:h.value,taskType:a,required:v,properties:f.properties?b.deepClone(f.properties):{},when:f.when?D.ContextKeyExpr.deserialize(f.when):void 0}}m.from=I})(P||(P={}));const R=L.ExtensionsRegistry.registerExtensionPoint({extensionPoint:"taskDefinitions",jsonSchema:{description:o.localize(4,null),type:"array",items:E}});class y{constructor(){this._onDefinitionsChanged=new T.Emitter,this.onDefinitionsChanged=this._onDefinitionsChanged.event,this.taskTypes=Object.create(null),this.readyPromise=new Promise((I,f)=>{R.setHandler((h,d)=>{this._schema=void 0;try{for(const a of d.removed){const v=a.value;for(const A of v)this.taskTypes&&A.type&&this.taskTypes[A.type]&&delete this.taskTypes[A.type]}for(const a of d.added){const v=a.value;for(const A of v){const l=P.from(A,a.description.identifier,a.collector);l&&(this.taskTypes[l.taskType]=l)}}(d.removed.length>0||d.added.length>0)&&this._onDefinitionsChanged.fire()}catch{}I(void 0)})})}onReady(){return this.readyPromise}get(I){return this.taskTypes[I]}all(){return Object.keys(this.taskTypes).map(I=>this.taskTypes[I])}getJsonSchema(){if(this._schema===void 0){const I=[];for(const f of this.all()){const h={type:"object",additionalProperties:!1};f.required.length>0&&(h.required=f.required.slice(0)),f.properties!==void 0?h.properties=b.deepClone(f.properties):h.properties=Object.create(null),h.properties.type={type:"string",enum:[f.taskType]},I.push(h)}this._schema={oneOf:I}}return this._schema}}e.TaskDefinitionRegistryImpl=y,e.TaskDefinitionRegistry=new y}),define(De[184],Ce([1,0,139,10,21,26,38,183]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TaskDefinition=e.TasksSchemaProperties=e.TaskSettingId=e.KeyedTaskIdentifier=e.TaskEvent=e.TaskRunSource=e.TaskRunType=e.TaskEventKind=e.TaskSorter=e.JsonSchemaVersion=e.ExecutionEngine=e.InMemoryTask=e.ContributedTask=e.ConfiguringTask=e.CustomTask=e.CommonTask=e.RunOptions=e.RunOnOptions=e.DependsOrder=e.TaskSourceKind=e.TaskScope=e.TaskGroup=e.CommandString=e.RuntimeType=e.PresentationOptions=e.PanelKind=e.RevealProblemKind=e.RevealKind=e.CommandOptions=e.CUSTOMIZED_TASK_TYPE=e.ShellQuoting=e.TASKS_CATEGORY=e.TASK_RUNNING_STATE=e.USER_TASKS_GROUP_KEY=void 0,e.USER_TASKS_GROUP_KEY="settings",e.TASK_RUNNING_STATE=new D.RawContextKey("taskRunning",!1,o.localize(0,null)),e.TASKS_CATEGORY={value:o.localize(1,null),original:"Tasks"};var E;(function(N){N[N.Escape=1]="Escape",N[N.Strong=2]="Strong",N[N.Weak=3]="Weak"})(E=e.ShellQuoting||(e.ShellQuoting={})),e.CUSTOMIZED_TASK_TYPE="$customized",function(N){function K(V){if(!V)return N.Strong;switch(V.toLowerCase()){case"escape":return N.Escape;case"strong":return N.Strong;case"weak":return N.Weak;default:return N.Strong}}N.from=K}(E=e.ShellQuoting||(e.ShellQuoting={}));var P;(function(N){N.defaults={cwd:"${workspaceFolder}"}})(P=e.CommandOptions||(e.CommandOptions={}));var R;(function(N){N[N.Always=1]="Always",N[N.Silent=2]="Silent",N[N.Never=3]="Never"})(R=e.RevealKind||(e.RevealKind={})),function(N){function K(V){switch(V.toLowerCase()){case"always":return N.Always;case"silent":return N.Silent;case"never":return N.Never;default:return N.Always}}N.fromString=K}(R=e.RevealKind||(e.RevealKind={}));var y;(function(N){N[N.Never=1]="Never",N[N.OnProblem=2]="OnProblem",N[N.Always=3]="Always"})(y=e.RevealProblemKind||(e.RevealProblemKind={})),function(N){function K(V){switch(V.toLowerCase()){case"always":return N.Always;case"never":return N.Never;case"onproblem":return N.OnProblem;default:return N.OnProblem}}N.fromString=K}(y=e.RevealProblemKind||(e.RevealProblemKind={}));var m;(function(N){N[N.Shared=1]="Shared",N[N.Dedicated=2]="Dedicated",N[N.New=3]="New"})(m=e.PanelKind||(e.PanelKind={})),function(N){function K(V){switch(V.toLowerCase()){case"shared":return N.Shared;case"dedicated":return N.Dedicated;case"new":return N.New;default:return N.Shared}}N.fromString=K}(m=e.PanelKind||(e.PanelKind={}));var I;(function(N){N.defaults={echo:!0,reveal:R.Always,revealProblems:y.Never,focus:!1,panel:m.Shared,showReuseMessage:!0,clear:!1}})(I=e.PresentationOptions||(e.PresentationOptions={}));var f;(function(N){N[N.Shell=1]="Shell",N[N.Process=2]="Process",N[N.CustomExecution=3]="CustomExecution"})(f=e.RuntimeType||(e.RuntimeType={})),function(N){function K(F){switch(F.toLowerCase()){case"shell":return N.Shell;case"process":return N.Process;case"customExecution":return N.CustomExecution;default:return N.Process}}N.fromString=K;function V(F){switch(F){case N.Shell:return"shell";case N.Process:return"process";case N.CustomExecution:return"customExecution";default:return"process"}}N.toString=V}(f=e.RuntimeType||(e.RuntimeType={}));var h;(function(N){function K(V){return p.isString(V)?V:V.value}N.value=K})(h=e.CommandString||(e.CommandString={}));var d;(function(N){N.Clean={_id:"clean",isDefault:!1},N.Build={_id:"build",isDefault:!1},N.Rebuild={_id:"rebuild",isDefault:!1},N.Test={_id:"test",isDefault:!1};function K(F){return F===N.Clean._id||F===N.Build._id||F===N.Rebuild._id||F===N.Test._id}N.is=K;function V(F){if(F!==void 0)return p.isString(F)?K(F)?{_id:F,isDefault:!1}:void 0:F}N.from=V})(d=e.TaskGroup||(e.TaskGroup={}));var a;(function(N){N[N.Global=1]="Global",N[N.Workspace=2]="Workspace",N[N.Folder=3]="Folder"})(a=e.TaskScope||(e.TaskScope={}));var v;(function(N){N.Workspace="workspace",N.Extension="extension",N.InMemory="inMemory",N.WorkspaceFile="workspaceFile",N.User="user";function K(V){switch(V){case N.User:return 2;case N.WorkspaceFile:return 5;default:return 6}}N.toConfigurationTarget=K})(v=e.TaskSourceKind||(e.TaskSourceKind={}));var A;(function(N){N.parallel="parallel",N.sequence="sequence"})(A=e.DependsOrder||(e.DependsOrder={}));var l;(function(N){N[N.default=1]="default",N[N.folderOpen=2]="folderOpen"})(l=e.RunOnOptions||(e.RunOnOptions={}));var _;(function(N){N.defaults={reevaluateOnRerun:!0,runOn:l.default,instanceLimit:1}})(_=e.RunOptions||(e.RunOptions={}));class s{constructor(K,V,F,ne,ce,re){this._label="",this._id=K,V&&(this._label=V),F&&(this.type=F),this.runOptions=ne,this.configurationProperties=ce,this._source=re}getDefinition(K){}getMapKey(){return this._id}getRecentlyUsedKey(){}getCommonTaskId(){const K={folder:this.getFolderId(),id:this._id};return JSON.stringify(K)}clone(){return this.fromObject(Object.assign({},this))}getWorkspaceFolder(){}getWorkspaceFileName(){}getTelemetryKind(){return"unknown"}matches(K,V=!1){if(K===void 0)return!1;if(p.isString(K))return K===this._label||K===this.configurationProperties.identifier||V&&K===this._id;const F=this.getDefinition(!0);return F!==void 0&&F._key===K._key}getQualifiedLabel(){const K=this.getWorkspaceFolder();return K?`${this._label} (${K.name})`:this._label}getTaskExecution(){return{id:this._id,task:this}}addTaskLoadMessages(K){this._taskLoadMessages===void 0&&(this._taskLoadMessages=[]),K&&(this._taskLoadMessages=this._taskLoadMessages.concat(K))}get taskLoadMessages(){return this._taskLoadMessages}}e.CommonTask=s;class u extends s{constructor(K,V,F,ne,ce,re,fe,ie){super(K,F,void 0,fe,ie,V);this.command={},this._source=V,this.hasDefinedMatchers=re,ce&&(this.command=ce)}clone(){return new u(this._id,this._source,this._label,this.type,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}customizes(){if(this._source&&this._source.customizes)return this._source.customizes}getDefinition(K=!1){if(K&&this._source.customizes!==void 0)return this._source.customizes;{let V;switch(this.command?this.command.runtime:void 0){case f.Shell:V="shell";break;case f.Process:V="process";break;case f.CustomExecution:V="customExecution";break;case void 0:V="$composite";break;default:throw new Error("Unexpected task runtime")}return{type:V,_key:this._id,id:this._id}}}static is(K){return K instanceof u}getMapKey(){const K=this._source.config.workspaceFolder;return K?`${K.uri.toString()}|${this._id}|${this.instance}`:`${this._id}|${this.instance}`}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getCommonTaskId(){return this._source.customizes?super.getCommonTaskId():this.getRecentlyUsedKey()??super.getCommonTaskId()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:V};return JSON.stringify(F)}getWorkspaceFolder(){return this._source.config.workspaceFolder}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getTelemetryKind(){return this._source.customizes?"workspace>extension":"workspace"}fromObject(K){return new u(K._id,K._source,K._label,K.type,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.CustomTask=u;class n extends s{constructor(K,V,F,ne,ce,re,fe){super(K,F,ne,re,fe,V);this._source=V,this.configures=ce}static is(K){return K instanceof n}fromObject(K){return K}getDefinition(){return this.configures}getWorkspaceFileName(){return this._source.config.workspace&&this._source.config.workspace.configuration?b.basename(this._source.config.workspace.configuration):void 0}getWorkspaceFolder(){return this._source.config.workspaceFolder}getFolderId(){return this._source.kind===v.User?e.USER_TASKS_GROUP_KEY:this._source.config.workspaceFolder?.uri.toString()}getRecentlyUsedKey(){const K=this.getFolderId();if(!K)return;let V=this.configurationProperties.identifier;this._source.kind!==v.Workspace&&(V+=this._source.kind);const F={type:e.CUSTOMIZED_TASK_TYPE,folder:K,id:V};return JSON.stringify(F)}}e.ConfiguringTask=n;class i extends s{constructor(K,V,F,ne,ce,re,fe,ie,Ee){super(K,F,ne,ie,Ee,V);this.defines=ce,this.hasDefinedMatchers=fe,this.command=re,this.icon=Ee.icon,this.hide=Ee.hide}clone(){return new i(this._id,this._source,this._label,this.type,this.defines,this.command,this.hasDefinedMatchers,this.runOptions,this.configurationProperties)}getDefinition(){return this.defines}static is(K){return K instanceof i}getMapKey(){const K=this._source.workspaceFolder;return K?`${this._source.scope.toString()}|${K.uri.toString()}|${this._id}|${this.instance}`:`${this._source.scope.toString()}|${this._id}|${this.instance}`}getFolderId(){if(this._source.scope===3&&this._source.workspaceFolder)return this._source.workspaceFolder.uri.toString()}getRecentlyUsedKey(){const K={type:"contributed",scope:this._source.scope,id:this._id};return K.folder=this.getFolderId(),JSON.stringify(K)}getWorkspaceFolder(){return this._source.workspaceFolder}getTelemetryKind(){return"extension"}fromObject(K){return new i(K._id,K._source,K._label,K.type,K.defines,K.command,K.hasDefinedMatchers,K.runOptions,K.configurationProperties)}}e.ContributedTask=i;class r extends s{constructor(K,V,F,ne,ce,re){super(K,F,ne,ce,re,V);this._source=V}clone(){return new r(this._id,this._source,this._label,this.type,this.runOptions,this.configurationProperties)}static is(K){return K instanceof r}getTelemetryKind(){return"composite"}getMapKey(){return`${this._id}|${this.instance}`}getFolderId(){}fromObject(K){return new r(K._id,K._source,K._label,K.type,K.runOptions,K.configurationProperties)}}e.InMemoryTask=r;var t;(function(N){N[N.Process=1]="Process",N[N.Terminal=2]="Terminal"})(t=e.ExecutionEngine||(e.ExecutionEngine={})),function(N){N._default=N.Terminal}(t=e.ExecutionEngine||(e.ExecutionEngine={}));var c;(function(N){N[N.V0_1_0=1]="V0_1_0",N[N.V2_0_0=2]="V2_0_0"})(c=e.JsonSchemaVersion||(e.JsonSchemaVersion={}));class w{constructor(K){this._order=new Map;for(let V=0;V<K.length;V++)this._order.set(K[V].uri.toString(),V)}compare(K,V){const F=K.getWorkspaceFolder(),ne=V.getWorkspaceFolder();if(F&&ne){let ce=this._order.get(F.uri.toString());ce=ce===void 0?0:ce+1;let re=this._order.get(ne.uri.toString());return re=re===void 0?0:re+1,ce===re?K._label.localeCompare(V._label):ce-re}else return!F&&ne?-1:F&&!ne?1:0}}e.TaskSorter=w;var g;(function(N){N.DependsOnStarted="dependsOnStarted",N.AcquiredInput="acquiredInput",N.Start="start",N.ProcessStarted="processStarted",N.Active="active",N.Inactive="inactive",N.Changed="changed",N.Terminated="terminated",N.ProcessEnded="processEnded",N.End="end"})(g=e.TaskEventKind||(e.TaskEventKind={}));var C;(function(N){N.SingleRun="singleRun",N.Background="background"})(C=e.TaskRunType||(e.TaskRunType={}));var U;(function(N){N[N.System=0]="System",N[N.User=1]="User",N[N.FolderOpen=2]="FolderOpen",N[N.ConfigurationChange=3]="ConfigurationChange",N[N.Reconnect=4]="Reconnect"})(U=e.TaskRunSource||(e.TaskRunSource={}));var W;(function(N){function K(V,F,ne,ce){if(F){const re={kind:V,taskId:F._id,taskName:F.configurationProperties.name,runType:F.configurationProperties.isBackground?"background":"singleRun",group:F.configurationProperties.group,processId:void 0,exitCode:void 0,terminalId:void 0,__task:F};return V==="start"?(re.terminalId=ne,re.resolvedVariables=ce):V==="processStarted"?re.processId=ne:V==="processEnded"&&(re.exitCode=ne),Object.freeze(re)}else return Object.freeze({kind:"changed"})}N.create=K})(W=e.TaskEvent||(e.TaskEvent={}));var M;(function(N){function K(F){const ne=Object.keys(F).sort();let ce="";for(const re of ne){let fe=F[re];fe instanceof Object?fe=K(fe):typeof fe=="string"&&(fe=fe.replace(/,/g,",,")),ce+=re+","+fe+","}return ce}function V(F){const ce={_key:K(F),type:F.taskType};return Object.assign(ce,F),ce}N.create=V})(M=e.KeyedTaskIdentifier||(e.KeyedTaskIdentifier={}));var S;(function(N){N.AutoDetect="task.autoDetect",N.SaveBeforeRun="task.saveBeforeRun",N.ShowDecorations="task.showDecorations",N.ProblemMatchersNeverPrompt="task.problemMatchers.neverPrompt",N.SlowProviderWarning="task.slowProviderWarning",N.QuickOpenHistory="task.quickOpen.history",N.QuickOpenDetail="task.quickOpen.detail",N.QuickOpenSkip="task.quickOpen.skip",N.QuickOpenShowAll="task.quickOpen.showAll",N.AllowAutomaticTasks="task.allowAutomaticTasks",N.Reconnection="task.experimental.reconnection"})(S=e.TaskSettingId||(e.TaskSettingId={}));var z;(function(N){N.Tasks="tasks",N.SuppressTaskName="tasks.suppressTaskName",N.Windows="tasks.windows",N.Osx="tasks.osx",N.Linux="tasks.linux",N.ShowOutput="tasks.showOutput",N.IsShellCommand="tasks.isShellCommand",N.ServiceTestSetting="tasks.service.testSetting"})(z=e.TasksSchemaProperties||(e.TasksSchemaProperties={}));var $;(function(N){function K(V,F){const ne=T.TaskDefinitionRegistry.get(V.type);if(ne===void 0){const ie=L.deepClone(V);return delete ie._key,M.create(ie)}const ce=Object.create(null);ce.type=ne.taskType;const re=new Set;ne.required.forEach(ie=>re.add(ie));const fe=ne.properties;for(const ie of Object.keys(fe)){const Ee=V[ie];if(Ee!=null)ce[ie]=Ee;else if(re.has(ie)){const be=fe[ie];if(be.default!==void 0)ce[ie]=L.deepClone(be.default);else switch(be.type){case"boolean":ce[ie]=!1;break;case"number":case"integer":ce[ie]=0;break;case"string":ce[ie]="";break;default:F.error(o.localize(2,null,JSON.stringify(V,void 0,0),ie));return}}}return M.create(ce)}N.createTaskIdentifier=K})($=e.TaskDefinition||(e.TaskDefinition={}))}),define(De[185],Ce([1,0,11]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.CanceledLazyPromise=e.LazyPromise=void 0;class p{constructor(){this._actual=null,this._actualOk=null,this._actualErr=null,this._hasValue=!1,this._value=null,this._hasErr=!1,this._err=null}get[Symbol.toStringTag](){return this.toString()}_ensureActual(){return this._actual||(this._actual=new Promise((D,T)=>{this._actualOk=D,this._actualErr=T,this._hasValue&&this._actualOk(this._value),this._hasErr&&this._actualErr(this._err)})),this._actual}resolveOk(D){this._hasValue||this._hasErr||(this._hasValue=!0,this._value=D,this._actual&&this._actualOk(D))}resolveErr(D){this._hasValue||this._hasErr||(this._hasErr=!0,this._err=D,this._actual?this._actualErr(D):(0,o.onUnexpectedError)(D))}then(D,T){return this._ensureActual().then(D,T)}catch(D){return this._ensureActual().then(void 0,D)}finally(D){return this._ensureActual().finally(D)}}e.LazyPromise=p;class b extends p{constructor(){super();this._hasErr=!0,this._err=new o.CancellationError}}e.CanceledLazyPromise=b}),define(De[40],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.SerializableObjectWithBuffers=e.getStringIdentifierForProxy=e.createProxyIdentifier=e.ProxyIdentifier=void 0;class o{constructor(E){this._proxyIdentifierBrand=void 0,this.sid=E,this.nid=++o.count}}e.ProxyIdentifier=o,o.count=0;const p=[];function b(T){const E=new o(T);return p[E.nid]=E,E}e.createProxyIdentifier=b;function L(T){return p[T].sid}e.getStringIdentifierForProxy=L;class D{constructor(E){this.value=E}}e.SerializableObjectWithBuffers=D}),define(De[5],Ce([1,0,55,40]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostContext=e.MainContext=e.ExtHostTestingResource=e.reviveWorkspaceEditDto=e.ISuggestResultDtoField=e.ISuggestDataDtoField=e.IdObject=e.CandidatePortSource=e.NotebookEditorRevealType=e.CellOutputKind=e.WebviewMessageArrayBufferViewType=e.WebviewEditorCapabilities=e.TabModelOperationKind=e.TabInputKind=e.TextEditorRevealType=void 0;var b;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(b=e.TextEditorRevealType||(e.TextEditorRevealType={}));var L;(function(a){a[a.UnknownInput=0]="UnknownInput",a[a.TextInput=1]="TextInput",a[a.TextDiffInput=2]="TextDiffInput",a[a.TextMergeInput=3]="TextMergeInput",a[a.NotebookInput=4]="NotebookInput",a[a.NotebookDiffInput=5]="NotebookDiffInput",a[a.CustomEditorInput=6]="CustomEditorInput",a[a.WebviewEditorInput=7]="WebviewEditorInput",a[a.TerminalEditorInput=8]="TerminalEditorInput",a[a.InteractiveEditorInput=9]="InteractiveEditorInput"})(L=e.TabInputKind||(e.TabInputKind={}));var D;(function(a){a[a.TAB_OPEN=0]="TAB_OPEN",a[a.TAB_CLOSE=1]="TAB_CLOSE",a[a.TAB_UPDATE=2]="TAB_UPDATE",a[a.TAB_MOVE=3]="TAB_MOVE"})(D=e.TabModelOperationKind||(e.TabModelOperationKind={}));var T;(function(a){a[a.Editable=0]="Editable",a[a.SupportsHotExit=1]="SupportsHotExit"})(T=e.WebviewEditorCapabilities||(e.WebviewEditorCapabilities={}));var E;(function(a){a[a.Int8Array=1]="Int8Array",a[a.Uint8Array=2]="Uint8Array",a[a.Uint8ClampedArray=3]="Uint8ClampedArray",a[a.Int16Array=4]="Int16Array",a[a.Uint16Array=5]="Uint16Array",a[a.Int32Array=6]="Int32Array",a[a.Uint32Array=7]="Uint32Array",a[a.Float32Array=8]="Float32Array",a[a.Float64Array=9]="Float64Array",a[a.BigInt64Array=10]="BigInt64Array",a[a.BigUint64Array=11]="BigUint64Array"})(E=e.WebviewMessageArrayBufferViewType||(e.WebviewMessageArrayBufferViewType={}));var P;(function(a){a[a.Text=1]="Text",a[a.Error=2]="Error",a[a.Rich=3]="Rich"})(P=e.CellOutputKind||(e.CellOutputKind={}));var R;(function(a){a[a.Default=0]="Default",a[a.InCenter=1]="InCenter",a[a.InCenterIfOutsideViewport=2]="InCenterIfOutsideViewport",a[a.AtTop=3]="AtTop"})(R=e.NotebookEditorRevealType||(e.NotebookEditorRevealType={}));var y;(function(a){a[a.None=0]="None",a[a.Process=1]="Process",a[a.Output=2]="Output"})(y=e.CandidatePortSource||(e.CandidatePortSource={}));class m{static mixin(v){return v._id=m._n++,v}}e.IdObject=m,m._n=0;var I;(function(a){a.label="a",a.kind="b",a.detail="c",a.documentation="d",a.sortText="e",a.filterText="f",a.preselect="g",a.insertText="h",a.insertTextRules="i",a.range="j",a.commitCharacters="k",a.additionalTextEdits="l",a.command="m",a.kindModifier="n"})(I=e.ISuggestDataDtoField||(e.ISuggestDataDtoField={}));var f;(function(a){a.defaultRanges="a",a.completions="b",a.isIncomplete="c",a.duration="d"})(f=e.ISuggestResultDtoField||(e.ISuggestResultDtoField={}));function h(a){return a&&a.edits&&(0,o.revive)(a),a}e.reviveWorkspaceEditDto=h;var d;(function(a){a[a.Workspace=0]="Workspace",a[a.TextDocument=1]="TextDocument"})(d=e.ExtHostTestingResource||(e.ExtHostTestingResource={})),e.MainContext={MainThreadAuthentication:(0,p.createProxyIdentifier)("MainThreadAuthentication"),MainThreadBulkEdits:(0,p.createProxyIdentifier)("MainThreadBulkEdits"),MainThreadClipboard:(0,p.createProxyIdentifier)("MainThreadClipboard"),MainThreadCommands:(0,p.createProxyIdentifier)("MainThreadCommands"),MainThreadComments:(0,p.createProxyIdentifier)("MainThreadComments"),MainThreadConfiguration:(0,p.createProxyIdentifier)("MainThreadConfiguration"),MainThreadConsole:(0,p.createProxyIdentifier)("MainThreadConsole"),MainThreadDebugService:(0,p.createProxyIdentifier)("MainThreadDebugService"),MainThreadDecorations:(0,p.createProxyIdentifier)("MainThreadDecorations"),MainThreadDiagnostics:(0,p.createProxyIdentifier)("MainThreadDiagnostics"),MainThreadDialogs:(0,p.createProxyIdentifier)("MainThreadDiaglogs"),MainThreadDocuments:(0,p.createProxyIdentifier)("MainThreadDocuments"),MainThreadDocumentContentProviders:(0,p.createProxyIdentifier)("MainThreadDocumentContentProviders"),MainThreadTextEditors:(0,p.createProxyIdentifier)("MainThreadTextEditors"),MainThreadEditorInsets:(0,p.createProxyIdentifier)("MainThreadEditorInsets"),MainThreadEditorTabs:(0,p.createProxyIdentifier)("MainThreadEditorTabs"),MainThreadErrors:(0,p.createProxyIdentifier)("MainThreadErrors"),MainThreadTreeViews:(0,p.createProxyIdentifier)("MainThreadTreeViews"),MainThreadDownloadService:(0,p.createProxyIdentifier)("MainThreadDownloadService"),MainThreadKeytar:(0,p.createProxyIdentifier)("MainThreadKeytar"),MainThreadLanguageFeatures:(0,p.createProxyIdentifier)("MainThreadLanguageFeatures"),MainThreadLanguages:(0,p.createProxyIdentifier)("MainThreadLanguages"),MainThreadLogger:(0,p.createProxyIdentifier)("MainThreadLogger"),MainThreadMessageService:(0,p.createProxyIdentifier)("MainThreadMessageService"),MainThreadOutputService:(0,p.createProxyIdentifier)("MainThreadOutputService"),MainThreadProgress:(0,p.createProxyIdentifier)("MainThreadProgress"),MainThreadQuickOpen:(0,p.createProxyIdentifier)("MainThreadQuickOpen"),MainThreadStatusBar:(0,p.createProxyIdentifier)("MainThreadStatusBar"),MainThreadSecretState:(0,p.createProxyIdentifier)("MainThreadSecretState"),MainThreadStorage:(0,p.createProxyIdentifier)("MainThreadStorage"),MainThreadTelemetry:(0,p.createProxyIdentifier)("MainThreadTelemetry"),MainThreadTerminalService:(0,p.createProxyIdentifier)("MainThreadTerminalService"),MainThreadWebviews:(0,p.createProxyIdentifier)("MainThreadWebviews"),MainThreadWebviewPanels:(0,p.createProxyIdentifier)("MainThreadWebviewPanels"),MainThreadWebviewViews:(0,p.createProxyIdentifier)("MainThreadWebviewViews"),MainThreadCustomEditors:(0,p.createProxyIdentifier)("MainThreadCustomEditors"),MainThreadUrls:(0,p.createProxyIdentifier)("MainThreadUrls"),MainThreadUriOpeners:(0,p.createProxyIdentifier)("MainThreadUriOpeners"),MainThreadWorkspace:(0,p.createProxyIdentifier)("MainThreadWorkspace"),MainThreadFileSystem:(0,p.createProxyIdentifier)("MainThreadFileSystem"),MainThreadExtensionService:(0,p.createProxyIdentifier)("MainThreadExtensionService"),MainThreadSCM:(0,p.createProxyIdentifier)("MainThreadSCM"),MainThreadSearch:(0,p.createProxyIdentifier)("MainThreadSearch"),MainThreadTask:(0,p.createProxyIdentifier)("MainThreadTask"),MainThreadWindow:(0,p.createProxyIdentifier)("MainThreadWindow"),MainThreadLabelService:(0,p.createProxyIdentifier)("MainThreadLabelService"),MainThreadNotebook:(0,p.createProxyIdentifier)("MainThreadNotebook"),MainThreadNotebookDocuments:(0,p.createProxyIdentifier)("MainThreadNotebookDocumentsShape"),MainThreadNotebookEditors:(0,p.createProxyIdentifier)("MainThreadNotebookEditorsShape"),MainThreadNotebookKernels:(0,p.createProxyIdentifier)("MainThreadNotebookKernels"),MainThreadNotebookRenderers:(0,p.createProxyIdentifier)("MainThreadNotebookRenderers"),MainThreadInteractive:(0,p.createProxyIdentifier)("MainThreadInteractive"),MainThreadTheming:(0,p.createProxyIdentifier)("MainThreadTheming"),MainThreadTunnelService:(0,p.createProxyIdentifier)("MainThreadTunnelService"),MainThreadTimeline:(0,p.createProxyIdentifier)("MainThreadTimeline"),MainThreadTesting:(0,p.createProxyIdentifier)("MainThreadTesting")},e.ExtHostContext={ExtHostCommands:(0,p.createProxyIdentifier)("ExtHostCommands"),ExtHostConfiguration:(0,p.createProxyIdentifier)("ExtHostConfiguration"),ExtHostDiagnostics:(0,p.createProxyIdentifier)("ExtHostDiagnostics"),ExtHostDebugService:(0,p.createProxyIdentifier)("ExtHostDebugService"),ExtHostDecorations:(0,p.createProxyIdentifier)("ExtHostDecorations"),ExtHostDocumentsAndEditors:(0,p.createProxyIdentifier)("ExtHostDocumentsAndEditors"),ExtHostDocuments:(0,p.createProxyIdentifier)("ExtHostDocuments"),ExtHostDocumentContentProviders:(0,p.createProxyIdentifier)("ExtHostDocumentContentProviders"),ExtHostDocumentSaveParticipant:(0,p.createProxyIdentifier)("ExtHostDocumentSaveParticipant"),ExtHostEditors:(0,p.createProxyIdentifier)("ExtHostEditors"),ExtHostTreeViews:(0,p.createProxyIdentifier)("ExtHostTreeViews"),ExtHostFileSystem:(0,p.createProxyIdentifier)("ExtHostFileSystem"),ExtHostFileSystemInfo:(0,p.createProxyIdentifier)("ExtHostFileSystemInfo"),ExtHostFileSystemEventService:(0,p.createProxyIdentifier)("ExtHostFileSystemEventService"),ExtHostLanguages:(0,p.createProxyIdentifier)("ExtHostLanguages"),ExtHostLanguageFeatures:(0,p.createProxyIdentifier)("ExtHostLanguageFeatures"),ExtHostQuickOpen:(0,p.createProxyIdentifier)("ExtHostQuickOpen"),ExtHostExtensionService:(0,p.createProxyIdentifier)("ExtHostExtensionService"),ExtHostLogLevelServiceShape:(0,p.createProxyIdentifier)("ExtHostLogLevelServiceShape"),ExtHostTerminalService:(0,p.createProxyIdentifier)("ExtHostTerminalService"),ExtHostSCM:(0,p.createProxyIdentifier)("ExtHostSCM"),ExtHostSearch:(0,p.createProxyIdentifier)("ExtHostSearch"),ExtHostTask:(0,p.createProxyIdentifier)("ExtHostTask"),ExtHostWorkspace:(0,p.createProxyIdentifier)("ExtHostWorkspace"),ExtHostWindow:(0,p.createProxyIdentifier)("ExtHostWindow"),ExtHostWebviews:(0,p.createProxyIdentifier)("ExtHostWebviews"),ExtHostWebviewPanels:(0,p.createProxyIdentifier)("ExtHostWebviewPanels"),ExtHostCustomEditors:(0,p.createProxyIdentifier)("ExtHostCustomEditors"),ExtHostWebviewViews:(0,p.createProxyIdentifier)("ExtHostWebviewViews"),ExtHostEditorInsets:(0,p.createProxyIdentifier)("ExtHostEditorInsets"),ExtHostEditorTabs:(0,p.createProxyIdentifier)("ExtHostEditorTabs"),ExtHostProgress:(0,p.createProxyIdentifier)("ExtHostProgress"),ExtHostComments:(0,p.createProxyIdentifier)("ExtHostComments"),ExtHostSecretState:(0,p.createProxyIdentifier)("ExtHostSecretState"),ExtHostStorage:(0,p.createProxyIdentifier)("ExtHostStorage"),ExtHostUrls:(0,p.createProxyIdentifier)("ExtHostUrls"),ExtHostUriOpeners:(0,p.createProxyIdentifier)("ExtHostUriOpeners"),ExtHostOutputService:(0,p.createProxyIdentifier)("ExtHostOutputService"),ExtHosLabelService:(0,p.createProxyIdentifier)("ExtHostLabelService"),ExtHostNotebook:(0,p.createProxyIdentifier)("ExtHostNotebook"),ExtHostNotebookDocuments:(0,p.createProxyIdentifier)("ExtHostNotebookDocuments"),ExtHostNotebookEditors:(0,p.createProxyIdentifier)("ExtHostNotebookEditors"),ExtHostNotebookKernels:(0,p.createProxyIdentifier)("ExtHostNotebookKernels"),ExtHostNotebookRenderers:(0,p.createProxyIdentifier)("ExtHostNotebookRenderers"),ExtHostInteractive:(0,p.createProxyIdentifier)("ExtHostInteractive"),ExtHostTheming:(0,p.createProxyIdentifier)("ExtHostTheming"),ExtHostTunnelService:(0,p.createProxyIdentifier)("ExtHostTunnelService"),ExtHostAuthentication:(0,p.createProxyIdentifier)("ExtHostAuthentication"),ExtHostTimeline:(0,p.createProxyIdentifier)("ExtHostTimeline"),ExtHostTesting:(0,p.createProxyIdentifier)("ExtHostTesting"),ExtHostTelemetry:(0,p.createProxyIdentifier)("ExtHostTelemetry")}}),define(De[67],Ce([1,0,5,4,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostSecretState=e.ExtHostSecretState=void 0;class L{constructor(T){this._onDidChangePassword=new p.Emitter,this.onDidChangePassword=this._onDidChangePassword.event,this._proxy=T.getProxy(o.MainContext.MainThreadSecretState)}async $onDidChangePassword(T){this._onDidChangePassword.fire(T)}get(T,E){return this._proxy.$getPassword(T,E)}store(T,E,P){return this._proxy.$setPassword(T,E,P)}delete(T,E){return this._proxy.$deletePassword(T,E)}}e.ExtHostSecretState=L,e.IExtHostSecretState=(0,b.createDecorator)("IExtHostSecretState")}),define(De[68],Ce([1,0,3,14,5,15]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NullApiDeprecationService=e.ExtHostApiDeprecationService=e.IExtHostApiDeprecationService=void 0,e.IExtHostApiDeprecationService=(0,o.createDecorator)("IExtHostApiDeprecationService");let D=class{constructor(E,P){this._extHostLogService=P,this._reportedUsages=new Set,this._telemetryShape=E.getProxy(b.MainContext.MainThreadTelemetry)}report(E,P,R){const y=this.getUsageKey(E,P);this._reportedUsages.has(y)||(this._reportedUsages.add(y),P.isUnderDevelopment&&this._extHostLogService.warn(`[Deprecation Warning] '${E}' is deprecated. ${R}`),this._telemetryShape.$publicLog2("extHostDeprecatedApiUsage",{extensionId:P.identifier.value,apiId:E}))}getUsageKey(E,P){return`${E}-${P.identifier.value}`}};D=ze([xe(0,L.IExtHostRpcService),xe(1,p.ILogService)],D),e.ExtHostApiDeprecationService=D,e.NullApiDeprecationService=Object.freeze(new class{report(T,E,P){}})}),define(De[186],Ce([1,0,4,5,6,27]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostAuthentication=void 0;class D{constructor(E){this._authenticationProviders=new Map,this._providers=[],this._onDidChangeSessions=new o.Emitter,this.onDidChangeSessions=this._onDidChangeSessions.event,this._inFlightRequests=new Map,this._proxy=E.getProxy(p.MainContext.MainThreadAuthentication)}$setProviders(E){return this._providers=E,Promise.resolve()}async getSession(E,P,R,y={}){const m=L.ExtensionIdentifier.toKey(E.identifier),I=this._inFlightRequests.get(m)||[],f=[...R].sort().join(" ");let h=I.find(d=>d.providerId===P&&d.scopes===f);if(h)return h.result;{const d=this._getSession(E,m,P,R,y);h={providerId:P,scopes:f,result:d},I.push(h),this._inFlightRequests.set(m,I);try{await d}finally{const a=I.findIndex(v=>v.providerId===P&&v.scopes===f);a>-1&&(I.splice(a),this._inFlightRequests.set(m,I))}return d}}async _getSession(E,P,R,y,m={}){await this._proxy.$ensureProvider(R);const I=E.displayName||E.name;return this._proxy.$getSession(R,y,P,I,m)}async removeSession(E,P){const R=this._authenticationProviders.get(E);return R?R.provider.removeSession(P):this._proxy.$removeSession(E,P)}registerAuthenticationProvider(E,P,R,y){if(this._authenticationProviders.get(E))throw new Error(`An authentication provider with id '${E}' is already registered.`);this._authenticationProviders.set(E,{label:P,provider:R,options:y??{supportsMultipleAccounts:!1}}),this._providers.find(I=>I.id===E)||this._providers.push({id:E,label:P});const m=R.onDidChangeSessions(I=>{this._proxy.$sendDidChangeSessions(E,{added:I.added??[],changed:I.changed??[],removed:I.removed??[]})});return this._proxy.$registerAuthenticationProvider(E,P,y?.supportsMultipleAccounts??!1),new b.Disposable(()=>{m.dispose(),this._authenticationProviders.delete(E);const I=this._providers.findIndex(f=>f.id===E);I>-1&&this._providers.splice(I),this._proxy.$unregisterAuthenticationProvider(E)})}$createSession(E,P){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.createSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$removeSession(E,P){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.removeSession(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$getSessions(E,P){const R=this._authenticationProviders.get(E);if(R)return Promise.resolve(R.provider.getSessions(P));throw new Error(`Unable to find authentication provider with handle: ${E}`)}$onDidChangeAuthenticationSessions(E,P){return this._onDidChangeSessions.fire({provider:{id:E,label:P}}),Promise.resolve()}}e.ExtHostAuthentication=D}),define(De[187],Ce([1,0,5,15,8,24]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostBulkEdits=void 0;let D=class{constructor(E,P){this._proxy=E.getProxy(o.MainContext.MainThreadBulkEdits),this._versionInformationProvider={getTextDocumentVersion:R=>P.getDocument(R)?.version,getNotebookDocumentVersion:()=>{}}}applyWorkspaceEdit(E,P){const R=(0,L.isProposedApiEnabled)(P,"snippetWorkspaceEdit"),y=b.WorkspaceEdit.from(E,this._versionInformationProvider,R);return this._proxy.$tryApplyWorkspaceEdit(y)}};D=ze([xe(0,p.IExtHostRpcService)],D),e.ExtHostBulkEdits=D}),define(De[188],Ce([1,0,5]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostClipboard=void 0;class p{constructor(L){const D=L.getProxy(o.MainContext.MainThreadClipboard);this.value=Object.freeze({readText(){return D.$readText()},writeText(T){return D.$writeText(T)}})}}e.ExtHostClipboard=p});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[36],Ce([1,0,10,6,8,26,5,16,14,55,48,241,2,7,3,15,92,22,40,43]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A){"use strict";var l,_;Object.defineProperty(e,"__esModule",{value:!0}),e.ApiCommand=e.ApiCommandResult=e.ApiCommandArgument=e.CommandsConverter=e.IExtHostCommands=e.ExtHostCommands=void 0;let s=class{constructor(c,w){l.set(this,void 0),this._commands=new Map,this._apiCommands=new Map,_.set(this,void 0),Je(this,l,c.getProxy(D.MainContext.MainThreadCommands),"f"),this._logService=w,Je(this,_,c.getProxy(D.MainContext.MainThreadTelemetry),"f"),this.converter=new u(this,g=>{const C=this._apiCommands.get(g);return C?.result===i.Void?C:void 0},w),this._argumentProcessors=[{processArgument(g){return(0,P.revive)(g)}},{processArgument(g){return(0,L.cloneAndChange)(g,function(C){if(R.Range.isIRange(C))return b.Range.to(C);if(y.Position.isIPosition(C))return b.Position.to(C);if(R.Range.isIRange(C.range)&&m.URI.isUri(C.uri))return b.location.to(C);if(C instanceof a.VSBuffer)return C.buffer.buffer;if(!Array.isArray(C))return C})}}]}registerArgumentProcessor(c){this._argumentProcessors.push(c)}registerApiCommand(c){const w=this.registerCommand(!1,c.id,async(...g)=>{const C=c.args.map((W,M)=>{if(!W.validate(g[M]))throw new Error(`Invalid argument '${W.name}' when running '${c.id}', received: ${g[M]}`);return W.convert(g[M])}),U=await this.executeCommand(c.internalId,...C);return c.result.convert(U,g,this.converter)},void 0,{description:c.description,args:c.args,returns:c.result.description});return this._apiCommands.set(c.id,c),new p.Disposable(()=>{w.dispose(),this._apiCommands.delete(c.id)})}registerCommand(c,w,g,C,U,W){if(this._logService.trace("ExtHostCommands#registerCommand",w),!w.trim().length)throw new Error("invalid id");if(this._commands.has(w))throw new Error(`command '${w}' already exists`);return this._commands.set(w,{callback:g,thisArg:C,description:U,extension:W}),c&&Oe(this,l,"f").$registerCommand(w),new p.Disposable(()=>{this._commands.delete(w)&&c&&Oe(this,l,"f").$unregisterCommand(w)})}executeCommand(c,...w){return this._logService.trace("ExtHostCommands#executeCommand",c),this._doExecuteCommand(c,w,!0)}async _doExecuteCommand(c,w,g){if(this._commands.has(c))return Oe(this,l,"f").$fireCommandActivationEvent(c),this._executeContributedCommand(c,w,!1);{let C=!1;const U=(0,L.cloneAndChange)(w,function(W){if(W instanceof p.Position)return b.Position.from(W);if(W instanceof p.Range)return b.Range.from(W);if(W instanceof p.Location)return b.location.from(W);if(p.NotebookRange.isNotebookRange(W))return b.NotebookRange.from(W);if(W instanceof ArrayBuffer)return C=!0,a.VSBuffer.wrap(new Uint8Array(W));if(W instanceof Uint8Array)return C=!0,a.VSBuffer.wrap(W);if(W instanceof a.VSBuffer)return C=!0,W;if(!Array.isArray(W))return W});try{const W=await Oe(this,l,"f").$executeCommand(c,C?new v.SerializableObjectWithBuffers(U):U,g);return(0,P.revive)(W)}catch(W){if(W instanceof Error&&W.message==="$executeCommand:retry")return this._doExecuteCommand(c,w,!1);throw W}}}async _executeContributedCommand(c,w,g){const C=this._commands.get(c);if(!C)throw new Error("Unknown command");this._reportTelemetry(C,c);const{callback:U,thisArg:W,description:M}=C;if(M)for(let S=0;S<M.args.length;S++)try{(0,o.validateConstraint)(w[S],M.args[S].constraint)}catch{throw new Error(`Running the contributed command: '${c}' failed. Illegal argument '${M.args[S].name}' - ${M.args[S].description}`)}try{return await U.apply(W,w)}catch(S){if(c===this.converter.delegatingCommandId){const z=this.converter.getActualCommand(...w);z&&(c=z.command)}throw this._logService.error(S,c,C.extension?.identifier),g?new class extends Error{constructor(){super((0,A.toErrorMessage)(S));this.id=c,this.source=C.extension?.displayName??C.extension?.name}}:S}}_reportTelemetry(c,w){!c.extension||c.extension.isBuiltin||Oe(this,_,"f").$publicLog2("Extension:ActionExecuted",{extensionId:c.extension.identifier.value,id:w})}$executeContributedCommand(c,...w){return this._logService.trace("ExtHostCommands#$executeContributedCommand",c),this._commands.has(c)?(w=w.map(g=>this._argumentProcessors.reduce((C,U)=>U.processArgument(C),g)),this._executeContributedCommand(c,w,!0)):Promise.reject(new Error(`Contributed command '${c}' does not exist.`))}getCommands(c=!1){return this._logService.trace("ExtHostCommands#getCommands",c),Oe(this,l,"f").$getCommands().then(w=>(c&&(w=w.filter(g=>g[0]!=="_")),w))}$getContributedCommandHandlerDescriptions(){const c=Object.create(null);for(const[w,g]of this._commands){const{description:C}=g;C&&(c[w]=C)}return Promise.resolve(c)}};l=new WeakMap,_=new WeakMap,s=ze([xe(0,h.IExtHostRpcService),xe(1,E.ILogService)],s),e.ExtHostCommands=s,e.IExtHostCommands=(0,f.createDecorator)("IExtHostCommands");class u{constructor(c,w,g){this._commands=c,this._lookupApiCommand=w,this._logService=g,this.delegatingCommandId=`_vscode_delegate_cmd_${Date.now().toString(36)}`,this._cache=new Map,this._cachIdPool=0,this._commands.registerCommand(!0,this.delegatingCommandId,this._executeConvertedCommand,this)}toInternal(c,w){if(!c)return;const g={$ident:void 0,id:c.command,title:c.title,tooltip:c.tooltip};if(!c.command)return g;const C=this._lookupApiCommand(c.command);if(C)g.id=C.internalId,g.arguments=C.args.map((U,W)=>U.convert(c.arguments&&c.arguments[W]));else if((0,T.isNonEmptyArray)(c.arguments)){const U=++this._cachIdPool;this._cache.set(U,c),w.add((0,I.toDisposable)(()=>{this._cache.delete(U),this._logService.trace("CommandsConverter#DISPOSE",U)})),g.$ident=U,g.id=this.delegatingCommandId,g.arguments=[U],this._logService.trace("CommandsConverter#CREATE",c.command,U)}return g}fromInternal(c){return typeof c.$ident=="number"?this._cache.get(c.$ident):{command:c.id,title:c.title,arguments:c.arguments}}getActualCommand(...c){return this._cache.get(c[0])}_executeConvertedCommand(...c){const w=this.getActualCommand(...c);return this._logService.trace("CommandsConverter#EXECUTE",c[0],w?w.command:"MISSING"),w?this._commands.executeCommand(w.command,...w.arguments||[]):Promise.reject("actual command NOT FOUND")}}e.CommandsConverter=u;class n{constructor(c,w,g,C){this.name=c,this.description=w,this.validate=g,this.convert=C}optional(){return new n(this.name,`(optional) ${this.description}`,c=>c==null||this.validate(c),c=>c===void 0?void 0:c===null?null:this.convert(c))}with(c,w){return new n(c??this.name,w??this.description,this.validate,this.convert)}}e.ApiCommandArgument=n,n.Uri=new n("uri","Uri of a text document",t=>m.URI.isUri(t),t=>t),n.Position=new n("position","A position in a text document",t=>p.Position.isPosition(t),b.Position.from),n.Range=new n("range","A range in a text document",t=>p.Range.isRange(t),b.Range.from),n.Selection=new n("selection","A selection in a text document",t=>p.Selection.isSelection(t),b.Selection.from),n.Number=new n("number","",t=>typeof t=="number",t=>t),n.String=new n("string","",t=>typeof t=="string",t=>t),n.CallHierarchyItem=new n("item","A call hierarchy item",t=>t instanceof p.CallHierarchyItem,b.CallHierarchyItem.from),n.TypeHierarchyItem=new n("item","A type hierarchy item",t=>t instanceof p.TypeHierarchyItem,b.TypeHierarchyItem.from),n.TestItem=new n("testItem","A VS Code TestItem",t=>t instanceof d.TestItemImpl,b.TestItem.from);class i{constructor(c,w){this.description=c,this.convert=w}}e.ApiCommandResult=i,i.Void=new i("no result",t=>t);class r{constructor(c,w,g,C,U){this.id=c,this.internalId=w,this.description=g,this.args=C,this.result=U}}e.ApiCommand=r}),define(De[189],Ce([1,0,2,8,6,66,36,16,77,81,12]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostApiCommands=void 0;const y=[new D.ApiCommand("vscode.executeDocumentHighlights","_executeDocumentHighlights","Execute document highlight provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of DocumentHighlight-instances.",I(p.DocumentHighlight.to))),new D.ApiCommand("vscode.executeDocumentSymbolProvider","_executeDocumentSymbolProvider","Execute document symbol provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation and DocumentSymbol instances.",(h,d)=>{if((0,T.isFalsyOrEmpty)(h))return;class a extends b.SymbolInformation{static to(A){const l=new a(A.name,p.SymbolKind.to(A.kind),A.containerName||"",new b.Location(d[0],p.Range.to(A.range)));return l.detail=A.detail,l.range=l.location.range,l.selectionRange=p.Range.to(A.selectionRange),l.children=A.children?A.children.map(a.to):[],l}}return h.map(a.to)})),new D.ApiCommand("vscode.executeFormatDocumentProvider","_executeFormatDocumentProvider","Execute document format provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(p.TextEdit.to))),new D.ApiCommand("vscode.executeFormatRangeProvider","_executeFormatRangeProvider","Execute range format provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range,new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(p.TextEdit.to))),new D.ApiCommand("vscode.executeFormatOnTypeProvider","_executeFormatOnTypeProvider","Execute format on type provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,new D.ApiCommandArgument("ch","Trigger character",h=>typeof h=="string",h=>h),new D.ApiCommandArgument("options","Formatting options",h=>!0,h=>h)],new D.ApiCommandResult("A promise that resolves to an array of TextEdits.",I(p.TextEdit.to))),new D.ApiCommand("vscode.executeDefinitionProvider","_executeDefinitionProvider","Execute all definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeTypeDefinitionProvider","_executeTypeDefinitionProvider","Execute all type definition providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeDeclarationProvider","_executeDeclarationProvider","Execute all declaration providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeImplementationProvider","_executeImplementationProvider","Execute all implementation providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location or LocationLink instances.",f)),new D.ApiCommand("vscode.executeReferenceProvider","_executeReferenceProvider","Execute all reference providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Location-instances.",I(p.location.to))),new D.ApiCommand("vscode.executeHoverProvider","_executeHoverProvider","Execute all hover providers.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to an array of Hover-instances.",I(p.Hover.to))),new D.ApiCommand("vscode.executeSelectionRangeProvider","_executeSelectionRangeProvider","Execute selection range provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("position","A position in a text document",h=>Array.isArray(h)&&h.every(d=>b.Position.isPosition(d)),h=>h.map(p.Position.from))],new D.ApiCommandResult("A promise that resolves to an array of ranges.",h=>h.map(d=>{let a;for(const v of d.reverse())a=new b.SelectionRange(p.Range.to(v),a);return a}))),new D.ApiCommand("vscode.executeWorkspaceSymbolProvider","_executeWorkspaceSymbolProvider","Execute all workspace symbol providers.",[D.ApiCommandArgument.String.with("query","Search string")],new D.ApiCommandResult("A promise that resolves to an array of SymbolInformation-instances.",h=>h.map(p.WorkspaceSymbol.to))),new D.ApiCommand("vscode.prepareCallHierarchy","_executePrepareCallHierarchy","Prepare call hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyItem.to))),new D.ApiCommand("vscode.provideIncomingCalls","_executeProvideIncomingCalls","Compute incoming calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyIncomingCall.to))),new D.ApiCommand("vscode.provideOutgoingCalls","_executeProvideOutgoingCalls","Compute outgoing calls for an item",[D.ApiCommandArgument.CallHierarchyItem],new D.ApiCommandResult("A CallHierarchyItem or undefined",h=>h.map(p.CallHierarchyOutgoingCall.to))),new D.ApiCommand("vscode.prepareRename","_executePrepareRename","Execute the prepareRename of rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A promise that resolves to a range and placeholder text.",h=>{if(!!h)return{range:p.Range.to(h.range),placeholder:h.text}})),new D.ApiCommand("vscode.executeDocumentRenameProvider","_executeDocumentRenameProvider","Execute rename provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("newName","The new symbol name")],new D.ApiCommandResult("A promise that resolves to a WorkspaceEdit.",h=>{if(!!h){if(h.rejectReason)throw new Error(h.rejectReason);return p.WorkspaceEdit.to(h)}})),new D.ApiCommand("vscode.executeLinkProvider","_executeLinkProvider","Execute document link provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("linkResolveCount","Number of links that should be resolved, only when links are unresolved.").optional()],new D.ApiCommandResult("A promise that resolves to an array of DocumentLink-instances.",h=>h.map(p.DocumentLink.to))),new D.ApiCommand("vscode.provideDocumentSemanticTokensLegend","_provideDocumentSemanticTokensLegend","Provide semantic tokens legend for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new b.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentSemanticTokens","_provideDocumentSemanticTokens","Provide semantic tokens for a document",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,E.decodeSemanticTokensDto)(h);if(d.type==="full")return new b.SemanticTokens(d.data,void 0)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokensLegend","_provideDocumentRangeSemanticTokensLegend","Provide semantic tokens legend for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range.optional()],new D.ApiCommandResult("A promise that resolves to SemanticTokensLegend.",h=>{if(!!h)return new b.SemanticTokensLegend(h.tokenTypes,h.tokenModifiers)})),new D.ApiCommand("vscode.provideDocumentRangeSemanticTokens","_provideDocumentRangeSemanticTokens","Provide semantic tokens for a document range",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to SemanticTokens.",h=>{if(!h)return;const d=(0,E.decodeSemanticTokensDto)(h);if(d.type==="full")return new b.SemanticTokens(d.data,void 0)})),new D.ApiCommand("vscode.executeCompletionItemProvider","_executeCompletionItemProvider","Execute completion item provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger completion when the user types the character, like `,` or `(`").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of completions to resolve (too large numbers slow down completions)").optional()],new D.ApiCommandResult("A promise that resolves to a CompletionList-instance.",(h,d,a)=>{if(!h)return new b.CompletionList([]);const v=h.suggestions.map(A=>p.CompletionItem.to(A,a));return new b.CompletionList(v,h.incomplete)})),new D.ApiCommand("vscode.executeSignatureHelpProvider","_executeSignatureHelpProvider","Execute signature help provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position,D.ApiCommandArgument.String.with("triggerCharacter","Trigger signature help when the user types the character, like `,` or `(`").optional()],new D.ApiCommandResult("A promise that resolves to SignatureHelp.",h=>{if(h)return p.SignatureHelp.to(h)})),new D.ApiCommand("vscode.executeCodeLensProvider","_executeCodeLensProvider","Execute code lens provider.",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Number.with("itemResolveCount","Number of lenses that should be resolved and returned. Will only return resolved lenses, will impact performance)").optional()],new D.ApiCommandResult("A promise that resolves to an array of CodeLens-instances.",(h,d,a)=>I(v=>new b.CodeLens(p.Range.to(v.range),v.command&&a.fromInternal(v.command)))(h))),new D.ApiCommand("vscode.executeCodeActionProvider","_executeCodeActionProvider","Execute code action provider.",[D.ApiCommandArgument.Uri,new D.ApiCommandArgument("rangeOrSelection","Range in a text document. Some refactoring provider requires Selection object.",h=>b.Range.isRange(h),h=>b.Selection.isSelection(h)?p.Selection.from(h):p.Range.from(h)),D.ApiCommandArgument.String.with("kind","Code action kind to return code actions for").optional(),D.ApiCommandArgument.Number.with("itemResolveCount","Number of code actions to resolve (too large numbers slow down code actions)").optional()],new D.ApiCommandResult("A promise that resolves to an array of Command-instances.",(h,d,a)=>I(v=>{if(v._isSynthetic){if(!v.command)throw new Error("Synthetic code actions must have a command");return a.fromInternal(v.command)}else{const A=new b.CodeAction(v.title,v.kind?new b.CodeActionKind(v.kind):void 0);return v.edit&&(A.edit=p.WorkspaceEdit.to(v.edit)),v.command&&(A.command=a.fromInternal(v.command)),A.isPreferred=v.isPreferred,A}})(h))),new D.ApiCommand("vscode.executeDocumentColorProvider","_executeDocumentColorProvider","Execute document color provider.",[D.ApiCommandArgument.Uri],new D.ApiCommandResult("A promise that resolves to an array of ColorInformation objects.",h=>h?h.map(d=>new b.ColorInformation(p.Range.to(d.range),p.Color.to(d.color))):[])),new D.ApiCommand("vscode.executeColorPresentationProvider","_executeColorPresentationProvider","Execute color presentation provider.",[new D.ApiCommandArgument("color","The color to show and insert",h=>h instanceof b.Color,p.Color.from),new D.ApiCommandArgument("context","Context object with uri and range",h=>!0,h=>({uri:h.uri,range:p.Range.from(h.range)}))],new D.ApiCommandResult("A promise that resolves to an array of ColorPresentation objects.",h=>h?h.map(p.ColorPresentation.to):[])),new D.ApiCommand("vscode.executeInlayHintProvider","_executeInlayHintProvider","Execute inlay hints provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of Inlay objects",(h,d,a)=>h.map(p.InlayHint.to.bind(void 0,a)))),new D.ApiCommand("vscode.resolveNotebookContentProviders","_resolveNotebookContentProvider","Resolve Notebook Content Providers",[],new D.ApiCommandResult("A promise that resolves to an array of NotebookContentProvider static info objects.",I(h=>({viewType:h.viewType,displayName:h.displayName,options:{transientOutputs:h.options.transientOutputs,transientCellMetadata:h.options.transientCellMetadata,transientDocumentMetadata:h.options.transientDocumentMetadata},filenamePattern:h.filenamePattern.map(d=>p.NotebookExclusiveDocumentPattern.to(d))})))),new D.ApiCommand("vscode.executeInlineValueProvider","_executeInlineValueProvider","Execute inline value provider",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Range],new D.ApiCommandResult("A promise that resolves to an array of InlineValue objects",h=>h.map(p.InlineValue.to))),new D.ApiCommand("vscode.open","_workbench.open","Opens the provided resource in the editor. Can be a text or binary file, or an http(s) URL. If you need more control over the options for opening a text file, use vscode.window.showTextDocument instead.",[new D.ApiCommandArgument("uriOrString","Uri-instance or string (only http/https)",h=>o.URI.isUri(h)||typeof h=="string"&&(0,P.matchesSomeScheme)(h,R.Schemas.http,R.Schemas.https),h=>h),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[p.ViewColumn.from(h),void 0]:[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)])).optional(),D.ApiCommandArgument.String.with("label","").optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.openWith","_workbench.openWith","Opens the provided resource with a specific editor.",[D.ApiCommandArgument.Uri.with("resource","Resource to open"),D.ApiCommandArgument.String.with("viewId","Custom editor view id or 'default' to use VS Code's default editor"),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="number"||typeof h=="object",h=>h&&(typeof h=="number"?[p.ViewColumn.from(h),void 0]:[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)])).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.diff","_workbench.diff","Opens the provided resources in the diff editor to compare their contents.",[D.ApiCommandArgument.Uri.with("left","Left-hand side resource of the diff editor"),D.ApiCommandArgument.Uri.with("right","Right-hand side resource of the diff editor"),D.ApiCommandArgument.String.with("title","Human readable title for the diff editor").optional(),new D.ApiCommandArgument("columnOrOptions","Either the column in which to open or editor options, see vscode.TextDocumentShowOptions",h=>h===void 0||typeof h=="object",h=>h&&[p.ViewColumn.from(h.viewColumn),p.TextEditorOpenOptions.from(h)]).optional()],D.ApiCommandResult.Void),new D.ApiCommand("vscode.prepareTypeHierarchy","_executePrepareTypeHierarchy","Prepare type hierarchy at a position inside a document",[D.ApiCommandArgument.Uri,D.ApiCommandArgument.Position],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSupertypes","_executeProvideSupertypes","Compute supertypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new D.ApiCommand("vscode.provideSubtypes","_executeProvideSubtypes","Compute subtypes for an item",[D.ApiCommandArgument.TypeHierarchyItem],new D.ApiCommandResult("A TypeHierarchyItem or undefined",h=>h.map(p.TypeHierarchyItem.to))),new D.ApiCommand("vscode.revealTestInExplorer","_revealTestInExplorer","Reveals a test instance in the explorer",[D.ApiCommandArgument.TestItem],D.ApiCommandResult.Void),new D.ApiCommand("vscode.experimental.editSession.continue","_workbench.experimental.editSessions.actions.continueEditSession","Continue the current edit session in a different workspace",[D.ApiCommandArgument.Uri.with("workspaceUri","The target workspace to continue the current edit session in")],D.ApiCommandResult.Void)];class m{static register(d){y.forEach(d.registerApiCommand,d)}}e.ExtHostApiCommands=m;function I(h){return d=>{if(Array.isArray(d))return d.map(h)}}function f(h){if(!Array.isArray(h))return;const d=[];for(const a of h)L.isLocationLink(a)?d.push(p.DefinitionLink.to(a)):d.push(p.location.to(a));return d}}),define(De[190],Ce([1,0,13,54,4,7,2,66,27,8,6,24,5]),function(te,e,o,p,b,L,D,T,E,P,R,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostComments=void 0;function I(f,h,d){const a=f.getProxy(m.MainContext.MainThreadComments);class v{constructor(){this._commentControllers=new Map,this._commentControllersByExtension=new Map,h.registerArgumentProcessor({processArgument:t=>{if(t&&t.$mid===6){const c=this._commentControllers.get(t.handle);return c?c.value:t}else if(t&&t.$mid===7){const c=this._commentControllers.get(t.commentControlHandle);if(!c)return t;const w=c.getCommentThread(t.commentThreadHandle);return w?w.value:t}else if(t&&t.$mid===8){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const w=c.getCommentThread(t.thread.commentThreadHandle);return w?{thread:w.value,text:t.text}:t}else if(t&&t.$mid===9){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const w=c.getCommentThread(t.thread.commentThreadHandle);if(!w)return t;const g=t.commentUniqueId,C=w.getCommentByUniqueId(g);return C||t}else if(t&&t.$mid===10){const c=this._commentControllers.get(t.thread.commentControlHandle);if(!c)return t;const w=c.getCommentThread(t.thread.commentThreadHandle);if(!w)return t;const g=t.text,C=t.commentUniqueId,U=w.getCommentByUniqueId(C);return U?(U.body=g,U):t}return t}})}createCommentController(t,c,w){const g=v.handlePool++,C=new l(t,g,c,w);this._commentControllers.set(C.handle,C);const U=this._commentControllersByExtension.get(E.ExtensionIdentifier.toKey(t.identifier))||[];return U.push(C),this._commentControllersByExtension.set(E.ExtensionIdentifier.toKey(t.identifier),U),C.value}$createCommentThreadTemplate(t,c,w){const g=this._commentControllers.get(t);!g||g.$createCommentThreadTemplate(c,w)}async $updateCommentThreadTemplate(t,c,w){const g=this._commentControllers.get(t);!g||g.$updateCommentThreadTemplate(c,w)}$deleteCommentThread(t,c){this._commentControllers.get(t)?.$deleteCommentThread(c)}$provideCommentingRanges(t,c,w){const g=this._commentControllers.get(t);if(!g||!g.commentingRangeProvider)return Promise.resolve(void 0);const C=d.getDocument(D.URI.revive(c));return(0,o.asPromise)(()=>g.commentingRangeProvider.provideCommentingRanges(C,w)).then(U=>U?U.map(W=>P.Range.from(W)):void 0)}$toggleReaction(t,c,w,g,C){const U=this._commentControllers.get(t);return!U||!U.reactionHandler?Promise.resolve(void 0):(0,o.asPromise)(()=>{const W=U.getCommentThread(c);if(W){const M=W.getCommentByUniqueId(g.uniqueIdInThread);if(U!==void 0&&M&&U.reactionHandler)return U.reactionHandler(M,u(C))}return Promise.resolve(void 0)})}dispose(){}}v.handlePool=0;class A{constructor(t,c,w,g,C,U,W,M){this._commentControllerHandle=c,this._id=w,this._uri=g,this._range=C,this._comments=U,this.extensionDescription=W,this._isTemplate=M,this.handle=A._handlePool++,this.commentHandle=0,this.modifications=Object.create(null),this._onDidUpdateCommentThread=new b.Emitter,this.onDidUpdateCommentThread=this._onDidUpdateCommentThread.event,this._canReply=!0,this._commentsMap=new Map,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputDisposables.value=new L.DisposableStore,this._id===void 0&&(this._id=`${t}.${this.handle}`),a.$createCommentThread(c,this.handle,this._id,this._uri,P.Range.from(this._range),W.identifier,this._isTemplate),this._localDisposables=[],this._isDiposed=!1,this._localDisposables.push(this.onDidUpdateCommentThread(()=>{this.eventuallyUpdateCommentThread()})),this.comments=U,this._localDisposables.push({dispose:()=>{a.$deleteCommentThread(c,this.handle)}});const S=this;this.value={get uri(){return S.uri},get range(){return S.range},set range(z){S.range=z},get comments(){return S.comments},set comments(z){S.comments=z},get collapsibleState(){return S.collapsibleState},set collapsibleState(z){S.collapsibleState=z},get canReply(){return S.canReply},set canReply(z){S.canReply=z},get contextValue(){return S.contextValue},set contextValue(z){S.contextValue=z},get label(){return S.label},set label(z){S.label=z},get state(){return S.state},set state(z){S.state=z},dispose:()=>{S.dispose()}}}set threadId(t){this._id=t}get threadId(){return this._id}get id(){return this._id}get resource(){return this._uri}get uri(){return this._uri}set range(t){t.isEqual(this._range)||(this._range=t,this.modifications.range=t,this._onDidUpdateCommentThread.fire())}get range(){return this._range}set canReply(t){this._canReply!==t&&(this._canReply=t,this.modifications.canReply=t,this._onDidUpdateCommentThread.fire())}get canReply(){return this._canReply}get label(){return this._label}set label(t){this._label=t,this.modifications.label=t,this._onDidUpdateCommentThread.fire()}get contextValue(){return this._contextValue}set contextValue(t){this._contextValue=t,this.modifications.contextValue=t,this._onDidUpdateCommentThread.fire()}get comments(){return this._comments}set comments(t){this._comments=t,this.modifications.comments=t,this._onDidUpdateCommentThread.fire()}get collapsibleState(){return this._collapseState}set collapsibleState(t){this._collapseState=t,this.modifications.collapsibleState=t,this._onDidUpdateCommentThread.fire()}get state(){return(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state}set state(t){(0,y.checkProposedApiEnabled)(this.extensionDescription,"commentsResolvedState"),this._state=t,this.modifications.state=t,this._onDidUpdateCommentThread.fire()}get isDisposed(){return this._isDiposed}updateIsTemplate(){this._isTemplate&&(this._isTemplate=!1,this.modifications.isTemplate=!1)}eventuallyUpdateCommentThread(){if(this._isDiposed)return;this.updateIsTemplate(),this._acceptInputDisposables.value||(this._acceptInputDisposables.value=new L.DisposableStore);const t=w=>Object.prototype.hasOwnProperty.call(this.modifications,w),c={};t("range")&&(c.range=P.Range.from(this._range)),t("label")&&(c.label=this.label),t("contextValue")&&(c.contextValue=this.contextValue??null),t("comments")&&(c.comments=this._comments.map(w=>_(this,w,this._commentsMap))),t("collapsibleState")&&(c.collapseState=n(this._collapseState)),t("canReply")&&(c.canReply=this.canReply),t("state")&&(c.state=i(this._state)),t("isTemplate")&&(c.isTemplate=this._isTemplate),this.modifications={},a.$updateCommentThread(this._commentControllerHandle,this.handle,this._id,this._uri,c)}getCommentByUniqueId(t){for(const c of this._commentsMap){const w=c[0],g=c[1];if(t===g)return w}}dispose(){this._isDiposed=!0,this._acceptInputDisposables.dispose(),this._localDisposables.forEach(t=>t.dispose())}}A._handlePool=0,ze([(0,p.debounce)(100)],A.prototype,"eventuallyUpdateCommentThread",null);class l{constructor(t,c,w,g){this._extension=t,this._handle=c,this._id=w,this._label=g,this._threads=new Map,a.$registerCommentController(this.handle,w,g);const C=this;this.value=Object.freeze({id:C.id,label:C.label,get options(){return C.options},set options(U){C.options=U},get commentingRangeProvider(){return C.commentingRangeProvider},set commentingRangeProvider(U){C.commentingRangeProvider=U},get reactionHandler(){return C.reactionHandler},set reactionHandler(U){C.reactionHandler=U},createCommentThread(U,W,M){return C.createCommentThread(U,W,M).value},dispose:()=>{C.dispose()}}),this._localDisposables=[],this._localDisposables.push({dispose:()=>{a.$unregisterCommentController(this.handle)}})}get id(){return this._id}get label(){return this._label}get handle(){return this._handle}get commentingRangeProvider(){return this._commentingRangeProvider}set commentingRangeProvider(t){this._commentingRangeProvider=t,a.$updateCommentingRanges(this.handle)}get reactionHandler(){return this._reactionHandler}set reactionHandler(t){this._reactionHandler=t,a.$updateCommentControllerFeatures(this.handle,{reactionHandler:!!t})}get options(){return this._options}set options(t){this._options=t,a.$updateCommentControllerFeatures(this.handle,{options:this._options})}createCommentThread(t,c,w,g){if(typeof t=="string"){const C=new A(this.id,this.handle,t,c,w,g,this._extension,!1);return this._threads.set(C.handle,C),C}else{const C=new A(this.id,this.handle,void 0,t,c,w,this._extension,!1);return this._threads.set(C.handle,C),C}}$createCommentThreadTemplate(t,c){const w=new A(this.id,this.handle,void 0,D.URI.revive(t),P.Range.to(c),[],this._extension,!0);return w.collapsibleState=T.CommentThreadCollapsibleState.Expanded,this._threads.set(w.handle,w),w}$updateCommentThreadTemplate(t,c){const w=this._threads.get(t);w&&(w.range=P.Range.to(c))}$deleteCommentThread(t){this._threads.get(t)?.dispose(),this._threads.delete(t)}getCommentThread(t){return this._threads.get(t)}dispose(){this._threads.forEach(t=>{t.dispose()}),this._localDisposables.forEach(t=>t.dispose())}}function _(r,t,c){let w=c.get(t);w||(w=++r.commentHandle,c.set(t,w));const g=t.author&&t.author.iconPath?t.author.iconPath.toString():void 0;return{mode:t.mode,contextValue:t.contextValue,uniqueIdInThread:w,body:typeof t.body=="string"?t.body:P.MarkdownString.from(t.body),userName:t.author.name,userIconPath:g,label:t.label,commentReactions:t.reactions?t.reactions.map(C=>s(C)):void 0,timestamp:t.timestamp?.toJSON()}}function s(r){return{label:r.label,iconPath:r.iconPath?P.pathOrURIToURI(r.iconPath):void 0,count:r.count,hasReacted:r.authorHasReacted}}function u(r){return{label:r.label||"",count:r.count||0,iconPath:r.iconPath?D.URI.revive(r.iconPath):"",authorHasReacted:r.hasReacted||!1}}function n(r){if(r!==void 0)switch(r){case R.CommentThreadCollapsibleState.Expanded:return T.CommentThreadCollapsibleState.Expanded;case R.CommentThreadCollapsibleState.Collapsed:return T.CommentThreadCollapsibleState.Collapsed}return T.CommentThreadCollapsibleState.Collapsed}function i(r){if(r!==void 0)switch(r){case R.CommentThreadState.Unresolved:return T.CommentThreadState.Unresolved;case R.CommentThreadState.Resolved:return T.CommentThreadState.Resolved}return T.CommentThreadState.Unresolved}return new v}e.createExtHostComments=I}),define(De[191],Ce([1,0,26,5,28,15]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractExtHostConsoleForwarder=void 0;let D=class{constructor(R,y){this._mainThreadConsole=R.getProxy(p.MainContext.MainThreadConsole),this._includeStack=y.consoleForward.includeStack,this._logNative=y.consoleForward.logNative,this._wrapConsoleMethod("info","log"),this._wrapConsoleMethod("log","log"),this._wrapConsoleMethod("warn","warn"),this._wrapConsoleMethod("error","error")}_wrapConsoleMethod(R,y){const m=this,I=console[R];Object.defineProperty(console,R,{set:()=>{},get:()=>function(){m._handleConsoleCall(R,y,I,arguments)}})}_handleConsoleCall(R,y,m,I){this._mainThreadConsole.$logExtensionHostMessage({type:"__$console",severity:y,arguments:E(I,this._includeStack)}),this._logNative&&this._nativeConsoleLogMessage(R,m,I)}};D=ze([xe(0,L.IExtHostRpcService),xe(1,b.IExtHostInitDataService)],D),e.AbstractExtHostConsoleForwarder=D;const T=1e5;function E(P,R){const y=[];if(P.length)for(let m=0;m<P.length;m++){let I=P[m];if(typeof I=="undefined")I="undefined";else if(I instanceof Error){const f=I;f.stack?I=f.stack:I=f.toString()}y.push(I)}if(R){const m=new Error().stack;m&&y.push({__$stack:m.split(`
`).slice(3).join(`
`)})}try{const m=(0,o.safeStringify)(y);return m.length>T?"Output omitted for a large object that exceeds the limits":m}catch(m){return`Output omitted for an object that cannot be inspected ('${m.toString()}')`}}}),define(De[95],Ce([1,0,2,5,6,3,15,14,16,9,19]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDecorations=e.ExtHostDecorations=void 0;let y=class Ii{constructor(I,f){this._logService=f,this._provider=new Map,this._proxy=I.getProxy(p.MainContext.MainThreadDecorations)}registerFileDecorationProvider(I,f){const h=Ii._handlePool++;this._provider.set(h,{provider:I,extensionId:f}),this._proxy.$registerDecorationProvider(h,f.value);const d=I.onDidChangeFileDecorations&&I.onDidChangeFileDecorations(a=>{if(!a){this._proxy.$onDidChange(h,null);return}const v=(0,E.asArray)(a);if(v.length<=Ii._maxEventSize){this._proxy.$onDidChange(h,v);return}this._logService.warn("[Decorations] CAPPING events from decorations provider",f.value,v.length);const A=v.map(s=>({uri:s,rank:(0,P.count)(s.path,"/")})),l=(0,E.groupBy)(A,(s,u)=>s.rank-u.rank||(0,P.compare)(s.uri.path,u.uri.path)),_=[];e:for(const s of l){let u;for(const n of s){const i=(0,R.dirname)(n.uri.path);if(u!==i&&(u=i,_.push(n.uri)>=Ii._maxEventSize))break e}}this._proxy.$onDidChange(h,_)});return new b.Disposable(()=>{d?.dispose(),this._proxy.$unregisterDecorationProvider(h),this._provider.delete(h)})}async $provideDecorations(I,f,h){if(!this._provider.has(I))return Object.create(null);const d=Object.create(null),{provider:a,extensionId:v}=this._provider.get(I);return await Promise.all(f.map(async A=>{try{const{uri:l,id:_}=A,s=await Promise.resolve(a.provideFileDecoration(o.URI.revive(l),h));if(!s)return;try{b.FileDecoration.validate(s),d[_]=[s.propagate,s.tooltip,s.badge,s.color]}catch(u){this._logService.warn(`INVALID decoration from extension '${v.value}': ${u}`)}}catch(l){this._logService.error(l)}})),d}};y._handlePool=0,y._maxEventSize=250,y=ze([xe(0,D.IExtHostRpcService),xe(1,T.ILogService)],y),e.ExtHostDecorations=y,e.IExtHostDecorations=(0,L.createDecorator)("IExtHostDecorations")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[192],Ce([1,0,128,80,2,5,6,8,4,14,25,35]),function(te,e,o,p,b,L,D,T,E,P,R,y){"use strict";var m,I,f;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDiagnostics=e.DiagnosticCollection=void 0;class h{constructor(v,A,l,_,s,u){this._name=v,this._owner=A,this._maxDiagnosticsPerFile=l,m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),this._isDisposed=!1,Je(this,f,new R.ResourceMap(n=>_.getComparisonKey(n)),"f"),Je(this,m,s,"f"),Je(this,I,u,"f")}dispose(){this._isDisposed||(Oe(this,I,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,m,"f")?.$clear(this._owner),Oe(this,f,"f").clear(),this._isDisposed=!0)}get name(){return this._checkDisposed(),this._name}set(v,A){if(!v){this.clear();return}this._checkDisposed();let l=[];if(b.URI.isUri(v)){if(!A){this.delete(v);return}Oe(this,f,"f").set(v,A.slice()),l=[v]}else if(Array.isArray(v)){l=[];let s;v=[...v].sort(h._compareIndexedTuplesByUri);for(const u of v){const[n,i]=u;if((!s||n.toString()!==s.toString())&&(s&&Oe(this,f,"f").get(s).length===0&&Oe(this,f,"f").delete(s),s=n,l.push(n),Oe(this,f,"f").set(n,[])),i)Oe(this,f,"f").get(n)?.push(...i);else{const r=Oe(this,f,"f").get(n);r&&(r.length=0)}}}if(Oe(this,I,"f").fire(l),!Oe(this,m,"f"))return;const _=[];for(const s of l){let u=[];const n=Oe(this,f,"f").get(s);if(n)if(n.length>this._maxDiagnosticsPerFile){u=[];const i=[D.DiagnosticSeverity.Error,D.DiagnosticSeverity.Warning,D.DiagnosticSeverity.Information,D.DiagnosticSeverity.Hint];e:for(let r=0;r<4;r++)for(const t of n)if(t.severity===i[r]&&u.push(T.Diagnostic.from(t))===this._maxDiagnosticsPerFile)break e;u.push({severity:p.MarkerSeverity.Info,message:(0,o.localize)(0,null,n.length-this._maxDiagnosticsPerFile),startLineNumber:u[u.length-1].startLineNumber,startColumn:u[u.length-1].startColumn,endLineNumber:u[u.length-1].endLineNumber,endColumn:u[u.length-1].endColumn})}else u=n.map(i=>T.Diagnostic.from(i));_.push([s,u])}Oe(this,m,"f").$changeMany(this._owner,_)}delete(v){this._checkDisposed(),Oe(this,I,"f").fire([v]),Oe(this,f,"f").delete(v),Oe(this,m,"f")?.$changeMany(this._owner,[[v,void 0]])}clear(){this._checkDisposed(),Oe(this,I,"f").fire([...Oe(this,f,"f").keys()]),Oe(this,f,"f").clear(),Oe(this,m,"f")?.$clear(this._owner)}forEach(v,A){this._checkDisposed();for(const[l,_]of this)v.call(A,l,_,this)}*[(m=new WeakMap,I=new WeakMap,f=new WeakMap,Symbol.iterator)](){this._checkDisposed();for(const v of Oe(this,f,"f").keys())yield[v,this.get(v)]}get(v){this._checkDisposed();const A=Oe(this,f,"f").get(v);return Array.isArray(A)?Object.freeze(A.slice(0)):[]}has(v){return this._checkDisposed(),Array.isArray(Oe(this,f,"f").get(v))}_checkDisposed(){if(this._isDisposed)throw new Error("illegal state - object is disposed")}static _compareIndexedTuplesByUri(v,A){return v[0].toString()<A[0].toString()?-1:v[0].toString()>A[0].toString()?1:0}}e.DiagnosticCollection=h;let d=class di{constructor(v,A,l){this._logService=A,this._fileSystemInfoService=l,this._collections=new Map,this._onDidChangeDiagnostics=new E.DebounceEmitter({merge:_=>_.flat(),delay:50}),this.onDidChangeDiagnostics=E.Event.map(this._onDidChangeDiagnostics.event,di._mapper),this._proxy=v.getProxy(L.MainContext.MainThreadDiagnostics)}static _mapper(v){const A=new R.ResourceMap;for(const l of v)A.set(l,l);return{uris:Object.freeze(Array.from(A.values()))}}createDiagnosticCollection(v,A){const{_collections:l,_proxy:_,_onDidChangeDiagnostics:s,_logService:u,_fileSystemInfoService:n}=this,i=new class{$changeMany(c,w){_.$changeMany(c,w),u.trace("[DiagnosticCollection] change many (extension, owner, uris)",v.value,c,w.length===0?"CLEARING":w)}$clear(c){_.$clear(c),u.trace("[DiagnosticCollection] remove all (extension, owner)",v.value,c)}dispose(){_.dispose()}};let r;if(!A)A="_generated_diagnostic_collection_name_#"+di._idPool++,r=A;else if(!l.has(A))r=A;else{this._logService.warn(`DiagnosticCollection with name '${A}' does already exist.`);do r=A+di._idPool++;while(l.has(r))}return new class extends h{constructor(){super(A,r,di._maxDiagnosticsPerFile,n.extUri,i,s);l.set(r,this)}dispose(){super.dispose(),l.delete(r)}}}getDiagnostics(v){if(v)return this._getDiagnostics(v);{const A=new Map,l=[];for(const _ of this._collections.values())_.forEach((s,u)=>{let n=A.get(s.toString());typeof n=="undefined"&&(n=l.length,A.set(s.toString(),n),l.push([s,[]])),l[n][1]=l[n][1].concat(...u)});return l}}_getDiagnostics(v){let A=[];for(const l of this._collections.values())l.has(v)&&(A=A.concat(l.get(v)));return A}$acceptMarkersChange(v){if(!this._mirrorCollection){const A="_generated_mirror",l=new h(A,A,di._maxDiagnosticsPerFile,this._fileSystemInfoService.extUri,void 0,this._onDidChangeDiagnostics);this._collections.set(A,l),this._mirrorCollection=l}for(const[A,l]of v)this._mirrorCollection.set(b.URI.revive(A),l.map(T.Diagnostic.to))}};d._idPool=0,d._maxDiagnosticsPerFile=1e3,d=ze([xe(1,P.ILogService),xe(2,y.IExtHostFileSystemInfo)],d),e.ExtHostDiagnostics=d}),define(De[193],Ce([1,0,2,5]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDialogs=void 0;class b{constructor(D){this._proxy=D.getProxy(p.MainContext.MainThreadDialogs)}showOpenDialog(D){return this._proxy.$showOpenDialog(D).then(T=>T?T.map(E=>o.URI.revive(E)):void 0)}showSaveDialog(D){return this._proxy.$showSaveDialog(D).then(T=>T?o.URI.revive(T):void 0)}}e.ExtHostDialogs=b}),define(De[194],Ce([1,0,11,2,6,5,12,20,9]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocumentContentProvider=void 0;class P{constructor(y,m,I){this._documentsAndEditors=m,this._logService=I,this._documentContentProviders=new Map,this._proxy=y.getProxy(L.MainContext.MainThreadDocumentContentProviders)}registerTextDocumentContentProvider(y,m){if(Object.keys(D.Schemas).indexOf(y)>=0)throw new Error(`scheme '${y}' already registered`);const I=P._handlePool++;this._documentContentProviders.set(I,m),this._proxy.$registerTextContentProvider(I,y);let f;return typeof m.onDidChange=="function"&&(f=m.onDidChange(h=>{if(h.scheme!==y){this._logService.warn(`Provider for scheme '${y}' is firing event for schema '${h.scheme}' which will be IGNORED`);return}this._documentsAndEditors.getDocument(h)&&this.$provideTextDocumentContent(I,h).then(d=>{if(!d&&typeof d!="string")return;const a=this._documentsAndEditors.getDocument(h);if(!a)return;const v=(0,E.splitLines)(d);if(!a.equalLines(v))return this._proxy.$onVirtualDocumentChange(h,d)},o.onUnexpectedError)})),new b.Disposable(()=>{this._documentContentProviders.delete(I)&&this._proxy.$unregisterTextContentProvider(I),f&&(f.dispose(),f=void 0)})}$provideTextDocumentContent(y,m){const I=this._documentContentProviders.get(y);return I?Promise.resolve(I.provideTextDocumentContent(p.URI.revive(m),T.CancellationToken.None)):Promise.reject(new Error(`unsupported uri-scheme: ${m.scheme}`))}}e.ExtHostDocumentContentProvider=P,P._handlePool=0}),define(De[195],Ce([1,0,4,7,2,5,87,8,10,26,6]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostDocuments=void 0;class y{constructor(I,f){this._onDidAddDocument=new o.Emitter,this._onDidRemoveDocument=new o.Emitter,this._onDidChangeDocument=new o.Emitter,this._onDidSaveDocument=new o.Emitter,this.onDidAddDocument=this._onDidAddDocument.event,this.onDidRemoveDocument=this._onDidRemoveDocument.event,this.onDidChangeDocument=this._onDidChangeDocument.event,this.onDidSaveDocument=this._onDidSaveDocument.event,this._toDispose=new p.DisposableStore,this._documentLoader=new Map,this._proxy=I.getProxy(L.MainContext.MainThreadDocuments),this._documentsAndEditors=f,this._documentsAndEditors.onDidRemoveDocuments(h=>{for(const d of h)this._onDidRemoveDocument.fire(d.document)},void 0,this._toDispose),this._documentsAndEditors.onDidAddDocuments(h=>{for(const d of h)this._onDidAddDocument.fire(d.document)},void 0,this._toDispose)}dispose(){this._toDispose.dispose()}getAllDocumentData(){return[...this._documentsAndEditors.allDocuments()]}getDocumentData(I){if(!I)return;const f=this._documentsAndEditors.getDocument(I);if(f)return f}getDocument(I){const f=this.getDocumentData(I);if(!f?.document)throw new Error(`Unable to retrieve document from URI '${I}'`);return f.document}ensureDocumentData(I){const f=this._documentsAndEditors.getDocument(I);if(f)return Promise.resolve(f);let h=this._documentLoader.get(I.toString());return h||(h=this._proxy.$tryOpenDocument(I).then(d=>{this._documentLoader.delete(I.toString());const a=b.URI.revive(d);return(0,E.assertIsDefined)(this._documentsAndEditors.getDocument(a))},d=>(this._documentLoader.delete(I.toString()),Promise.reject(d))),this._documentLoader.set(I.toString(),h)),h}createDocumentData(I){return this._proxy.$tryCreateDocument(I).then(f=>b.URI.revive(f))}$acceptModelLanguageChanged(I,f){const h=b.URI.revive(I),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");this._onDidRemoveDocument.fire(d.document),d._acceptLanguageId(f),this._onDidAddDocument.fire(d.document)}$acceptModelSaved(I){const f=b.URI.revive(I),h=this._documentsAndEditors.getDocument(f);if(!h)throw new Error("unknown document");this.$acceptDirtyStateChanged(I,!1),this._onDidSaveDocument.fire(h.document)}$acceptDirtyStateChanged(I,f){const h=b.URI.revive(I),d=this._documentsAndEditors.getDocument(h);if(!d)throw new Error("unknown document");d._acceptIsDirty(f),this._onDidChangeDocument.fire({document:d.document,contentChanges:[],reason:void 0})}$acceptModelChanged(I,f,h){const d=b.URI.revive(I),a=this._documentsAndEditors.getDocument(d);if(!a)throw new Error("unknown document");a._acceptIsDirty(h),a.onEvents(f);let v;f.isUndoing?v=R.TextDocumentChangeReason.Undo:f.isRedoing&&(v=R.TextDocumentChangeReason.Redo),this._onDidChangeDocument.fire((0,P.deepFreeze)({document:a.document,contentChanges:f.changes.map(A=>({range:T.Range.to(A.range),rangeOffset:A.rangeOffset,rangeLength:A.rangeLength,text:A.text})),reason:v}))}setWordDefinitionFor(I,f){(0,D.setWordDefinitionFor)(I,f)}}e.ExtHostDocuments=y}),define(De[49],Ce([1,0,44,4,7,2,3,5,87,15,93,8,14,25,12,167,196]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostDocumentsAndEditors=e.ExtHostDocumentsAndEditors=void 0;class a{constructor(l){this.value=l,this._count=0}ref(){this._count++}unref(){return--this._count==0}}let v=class{constructor(l,_){this._extHostRpc=l,this._logService=_,this._activeEditorId=null,this._editors=new Map,this._documents=new I.ResourceMap,this._onDidAddDocuments=new p.Emitter,this._onDidRemoveDocuments=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this.onDidAddDocuments=this._onDidAddDocuments.event,this.onDidRemoveDocuments=this._onDidRemoveDocuments.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event}$acceptDocumentsAndEditorsDelta(l){this.acceptDocumentsAndEditorsDelta(l)}acceptDocumentsAndEditorsDelta(l){const _=[],s=[],u=[];if(l.removedDocuments)for(const n of l.removedDocuments){const i=L.URI.revive(n),r=this._documents.get(i);r?.unref()&&(this._documents.delete(i),_.push(r.value))}if(l.addedDocuments)for(const n of l.addedDocuments){const i=L.URI.revive(n.uri);let r=this._documents.get(i);if(r&&i.scheme!==f.Schemas.vscodeNotebookCell&&i.scheme!==f.Schemas.vscodeInteractiveInput)throw new Error(`document '${i} already exists!'`);r||(r=new a(new E.ExtHostDocumentData(this._extHostRpc.getProxy(T.MainContext.MainThreadDocuments),i,n.lines,n.EOL,n.versionId,n.languageId,n.isDirty,n.notebook)),this._documents.set(i,r),s.push(r.value)),r.ref()}if(l.removedEditors)for(const n of l.removedEditors){const i=this._editors.get(n);this._editors.delete(n),i&&u.push(i)}if(l.addedEditors)for(const n of l.addedEditors){const i=L.URI.revive(n.documentUri);o.ok(this._documents.has(i),`document '${i}' does not exist`),o.ok(!this._editors.has(n.id),`editor '${n.id}' already exists!`);const r=this._documents.get(i).value,t=new R.ExtHostTextEditor(n.id,this._extHostRpc.getProxy(T.MainContext.MainThreadTextEditors),this._logService,new d.Lazy(()=>r.document),n.selections.map(y.Selection.to),n.options,n.visibleRanges.map(c=>y.Range.to(c)),typeof n.editorPosition=="number"?y.ViewColumn.to(n.editorPosition):void 0);this._editors.set(n.id,t)}l.newActiveEditor!==void 0&&(o.ok(l.newActiveEditor===null||this._editors.has(l.newActiveEditor),`active editor '${l.newActiveEditor}' does not exist`),this._activeEditorId=l.newActiveEditor),(0,b.dispose)(_),(0,b.dispose)(u),l.removedDocuments&&this._onDidRemoveDocuments.fire(_),l.addedDocuments&&this._onDidAddDocuments.fire(s),(l.removedEditors||l.addedEditors)&&this._onDidChangeVisibleTextEditors.fire(this.allEditors().map(n=>n.value)),l.newActiveEditor!==void 0&&this._onDidChangeActiveTextEditor.fire(this.activeEditor())}getDocument(l){return this._documents.get(l)?.value}allDocuments(){return h.Iterable.map(this._documents.values(),l=>l.value)}getEditor(l){return this._editors.get(l)}activeEditor(l){if(!this._activeEditorId)return;const _=this._editors.get(this._activeEditorId);return l?_:_?.value}allEditors(){return[...this._editors.values()]}};v=ze([xe(0,P.IExtHostRpcService),xe(1,m.ILogService)],v),e.ExtHostDocumentsAndEditors=v,e.IExtHostDocumentsAndEditors=(0,D.createDecorator)("IExtHostDocumentsAndEditors")}),define(De[50],Ce([1,0,8,5,2,4,3,6,15,10,72]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditorTabs=e.IExtHostEditorTabs=void 0,e.IExtHostEditorTabs=(0,D.createDecorator)("IExtHostEditorTabs");class y{constructor(d,a,v){this._activeTabIdGetter=v,this._parentGroup=a,this.acceptDtoUpdate(d)}get apiObject(){if(!this._apiObject){const d=this,a={get isActive(){return d._dto.id===d._activeTabIdGetter()},get label(){return d._dto.label},get input(){return d._input},get isDirty(){return d._dto.isDirty},get isPinned(){return d._dto.isPinned},get isPreview(){return d._dto.isPreview},get group(){return d._parentGroup.apiObject}};this._apiObject=Object.freeze(a)}return this._apiObject}get tabId(){return this._dto.id}acceptDtoUpdate(d){this._dto=d,this._input=this._initInput()}_initInput(){switch(this._dto.input.kind){case 1:return new T.TextTabInput(b.URI.revive(this._dto.input.uri));case 2:return new T.TextDiffTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified));case 3:return new T.TextMergeTabInput(b.URI.revive(this._dto.input.base),b.URI.revive(this._dto.input.input1),b.URI.revive(this._dto.input.input2),b.URI.revive(this._dto.input.result));case 6:return new T.CustomEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.viewType);case 7:return new T.WebviewEditorTabInput(this._dto.input.viewType);case 4:return new T.NotebookEditorTabInput(b.URI.revive(this._dto.input.uri),this._dto.input.notebookType);case 5:return new T.NotebookDiffEditorTabInput(b.URI.revive(this._dto.input.original),b.URI.revive(this._dto.input.modified),this._dto.input.notebookType);case 8:return new T.TerminalEditorTabInput;case 9:return new T.InteractiveWindowInput(b.URI.revive(this._dto.input.uri),b.URI.revive(this._dto.input.inputBoxUri));default:return}}}class m{constructor(d,a){this._tabs=[],this._activeTabId="",this._dto=d,this._activeGroupIdGetter=a;for(const v of d.tabs)v.isActive&&(this._activeTabId=v.id),this._tabs.push(new y(v,this,()=>this.activeTabId()))}get apiObject(){if(!this._apiObject){const d=this,a={get isActive(){return d._dto.groupId===d._activeGroupIdGetter()},get viewColumn(){return o.ViewColumn.to(d._dto.viewColumn)},get activeTab(){return d._tabs.find(v=>v.tabId===d._activeTabId)?.apiObject},get tabs(){return Object.freeze(d._tabs.map(v=>v.apiObject))}};this._apiObject=Object.freeze(a)}return this._apiObject}get groupId(){return this._dto.groupId}get tabs(){return this._tabs}acceptGroupDtoUpdate(d){this._dto=d}acceptTabOperation(d){if(d.kind===0){const v=new y(d.tabDto,this,()=>this.activeTabId());return this._tabs.splice(d.index,0,v),d.tabDto.isActive&&(this._activeTabId=v.tabId),v}else if(d.kind===1){const v=this._tabs.splice(d.index,1)[0];if(!v)throw new Error(`Tab close updated received for index ${d.index} which does not exist`);return v.tabId===this._activeTabId&&(this._activeTabId=""),v}else if(d.kind===3){if(d.oldIndex===void 0)throw new Error("Invalid old index on move IPC");const v=this._tabs.splice(d.oldIndex,1)[0];if(!v)throw new Error(`Tab move updated received for index ${d.oldIndex} which does not exist`);return this._tabs.splice(d.index,0,v),v}const a=this._tabs.find(v=>v.tabId===d.tabDto.id);if(!a)throw new Error("INVALID tab");return d.tabDto.isActive?this._activeTabId=d.tabDto.id:this._activeTabId===d.tabDto.id&&!d.tabDto.isActive&&(this._activeTabId=""),a.acceptDtoUpdate(d.tabDto),a}activeTabId(){return this._activeTabId}}let I=class{constructor(d){this._onDidChangeTabs=new L.Emitter,this._onDidChangeTabGroups=new L.Emitter,this._extHostTabGroups=[],this._proxy=d.getProxy(p.MainContext.MainThreadEditorTabs)}get tabGroups(){if(!this._apiObject){const d=this,a={onDidChangeTabGroups:d._onDidChangeTabGroups.event,onDidChangeTabs:d._onDidChangeTabs.event,get all(){return Object.freeze(d._extHostTabGroups.map(v=>v.apiObject))},get activeTabGroup(){const v=d._activeGroupId;return(0,P.assertIsDefined)(d._extHostTabGroups.find(l=>l.groupId===v)?.apiObject)},close:async(v,A)=>{const l=Array.isArray(v)?v:[v];return l.length?f(l[0])?this._closeGroups(l,A):this._closeTabs(l,A):!0}};this._apiObject=Object.freeze(a)}return this._apiObject}$acceptEditorTabModel(d){const a=new Set(this._extHostTabGroups.map(n=>n.groupId)),v=new Set(d.map(n=>n.groupId)),A=(0,R.diffSets)(a,v),l=this._extHostTabGroups.filter(n=>A.removed.includes(n.groupId)).map(n=>n.apiObject),_=[],s=[];this._extHostTabGroups=d.map(n=>{const i=new m(n,()=>this._activeGroupId);return A.added.includes(i.groupId)?_.push(i.apiObject):s.push(i.apiObject),i});const u=(0,P.assertIsDefined)(d.find(n=>n.isActive===!0)?.groupId);u!==void 0&&this._activeGroupId!==u&&(this._activeGroupId=u),this._onDidChangeTabGroups.fire(Object.freeze({opened:_,closed:l,changed:s}))}$acceptTabGroupUpdate(d){const a=this._extHostTabGroups.find(v=>v.groupId===d.groupId);if(!a)throw new Error("Update Group IPC call received before group creation.");a.acceptGroupDtoUpdate(d),d.isActive&&(this._activeGroupId=d.groupId),this._onDidChangeTabGroups.fire(Object.freeze({changed:[a.apiObject],opened:[],closed:[]}))}$acceptTabOperation(d){const a=this._extHostTabGroups.find(A=>A.groupId===d.groupId);if(!a)throw new Error("Update Tabs IPC call received before group creation.");const v=a.acceptTabOperation(d);switch(d.kind){case 0:this._onDidChangeTabs.fire(Object.freeze({opened:[v.apiObject],closed:[],changed:[]}));return;case 1:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[v.apiObject],changed:[]}));return;case 3:case 2:this._onDidChangeTabs.fire(Object.freeze({opened:[],closed:[],changed:[v.apiObject]}));return}}_findExtHostTabFromApi(d){for(const a of this._extHostTabGroups)for(const v of a.tabs)if(v.apiObject===d)return v}_findExtHostTabGroupFromApi(d){return this._extHostTabGroups.find(a=>a.apiObject===d)}async _closeTabs(d,a){const v=[];for(const A of d){const l=this._findExtHostTabFromApi(A);if(!l)throw new Error("Tab close: Invalid tab not found!");v.push(l.tabId)}return this._proxy.$closeTab(v,a)}async _closeGroups(d,a){const v=[];for(const A of d){const l=this._findExtHostTabGroupFromApi(A);if(!l)throw new Error("Group close: Invalid group not found!");v.push(l.groupId)}return this._proxy.$closeGroup(v,a)}};I=ze([xe(0,E.IExtHostRpcService)],I),e.ExtHostEditorTabs=I;function f(h){return h.tabs!==void 0}}),define(De[197],Ce([1,0,2,5,7,6,8,242,9,22,24]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystem=void 0;class y{constructor(){this._schemes=[]}add(f){this._stateMachine=void 0,this._schemes.push(f)}delete(f){const h=this._schemes.indexOf(f);h>=0&&(this._schemes.splice(h,1),this._stateMachine=void 0)}_initStateMachine(){if(!this._stateMachine){const f=this._schemes.sort(),h=[];let d,a,v=14,A=14;for(const l of f){let _=d?(0,E.commonPrefixLength)(d,l):0;for(_===0?a=1:a=A;_<l.length;_++)_+1===l.length?(v=A,A=9):A+=1,h.push([a,l.toUpperCase().charCodeAt(_),A]),h.push([a,l.toLowerCase().charCodeAt(_),A]),a=A;d=l,A=v}h.push([9,58,10]),h.push([10,47,12]),this._stateMachine=new T.StateMachine(h)}}provideDocumentLinks(f){this._initStateMachine();const h=[],d=T.LinkComputer.computeLinks({getLineContent(a){return f.lineAt(a-1).text},getLineCount(){return f.lineCount}},this._stateMachine);for(const a of d){const v=D.DocumentLink.to(a);v.target&&h.push(v)}return h}}class m{constructor(f,h){this._extHostLanguageFeatures=h,this._linkProvider=new y,this._fsProvider=new Map,this._registeredSchemes=new Set,this._watches=new Map,this._handlePool=0,this._proxy=f.getProxy(p.MainContext.MainThreadFileSystem)}dispose(){this._linkProviderRegistration?.dispose()}registerFileSystemProvider(f,h,d,a={}){if(this._registeredSchemes.has(h))throw new Error(`a provider for the scheme '${h}' is already registered`);this._linkProviderRegistration||(this._linkProviderRegistration=this._extHostLanguageFeatures.registerDocumentLinkProvider(f,"*",this._linkProvider));const v=this._handlePool++;this._linkProvider.add(h),this._registeredSchemes.add(h),this._fsProvider.set(v,d);let A=2;a.isCaseSensitive&&(A+=1024),a.isReadonly&&(A+=2048),typeof d.copy=="function"&&(A+=8),typeof d.open=="function"&&typeof d.close=="function"&&typeof d.read=="function"&&typeof d.write=="function"&&((0,R.checkProposedApiEnabled)(f,"fsChunks"),A+=4),this._proxy.$registerFileSystemProvider(v,h,A).catch(_=>{console.error(`FAILED to register filesystem provider of ${f.identifier.value}-extension for the scheme ${h}`),console.error(_)});const l=d.onDidChangeFile(_=>{const s=[];for(const u of _){const{uri:n,type:i}=u;if(n.scheme!==h)continue;let r;switch(i){case L.FileChangeType.Changed:r=0;break;case L.FileChangeType.Created:r=1;break;case L.FileChangeType.Deleted:r=2;break;default:throw new Error("Unknown FileChangeType")}s.push({resource:n,type:r})}this._proxy.$onFileSystemChange(v,s)});return(0,b.toDisposable)(()=>{l.dispose(),this._linkProvider.delete(h),this._registeredSchemes.delete(h),this._fsProvider.delete(v),this._proxy.$unregisterProvider(v)})}static _asIStat(f){const{type:h,ctime:d,mtime:a,size:v,permissions:A}=f;return{type:h,ctime:d,mtime:a,size:v,permissions:A}}$stat(f,h){return Promise.resolve(this._getFsProvider(f).stat(o.URI.revive(h))).then(d=>m._asIStat(d))}$readdir(f,h){return Promise.resolve(this._getFsProvider(f).readDirectory(o.URI.revive(h)))}$readFile(f,h){return Promise.resolve(this._getFsProvider(f).readFile(o.URI.revive(h))).then(d=>P.VSBuffer.wrap(d))}$writeFile(f,h,d,a){return Promise.resolve(this._getFsProvider(f).writeFile(o.URI.revive(h),d.buffer,a))}$delete(f,h,d){return Promise.resolve(this._getFsProvider(f).delete(o.URI.revive(h),d))}$rename(f,h,d,a){return Promise.resolve(this._getFsProvider(f).rename(o.URI.revive(h),o.URI.revive(d),a))}$copy(f,h,d,a){const v=this._getFsProvider(f);if(!v.copy)throw new Error('FileSystemProvider does not implement "copy"');return Promise.resolve(v.copy(o.URI.revive(h),o.URI.revive(d),a))}$mkdir(f,h){return Promise.resolve(this._getFsProvider(f).createDirectory(o.URI.revive(h)))}$watch(f,h,d,a){const v=this._getFsProvider(f).watch(o.URI.revive(d),a);this._watches.set(h,v)}$unwatch(f,h){const d=this._watches.get(h);d&&(d.dispose(),this._watches.delete(h))}$open(f,h,d){const a=this._getFsProvider(f);if(!a.open)throw new Error('FileSystemProvider does not implement "open"');return Promise.resolve(a.open(o.URI.revive(h),d))}$close(f,h){const d=this._getFsProvider(f);if(!d.close)throw new Error('FileSystemProvider does not implement "close"');return Promise.resolve(d.close(h))}$read(f,h,d,a){const v=this._getFsProvider(f);if(!v.read)throw new Error('FileSystemProvider does not implement "read"');const A=P.VSBuffer.alloc(a);return Promise.resolve(v.read(h,d,A.buffer,0,a)).then(l=>A.slice(0,l))}$write(f,h,d,a){const v=this._getFsProvider(f);if(!v.write)throw new Error('FileSystemProvider does not implement "write"');return Promise.resolve(v.write(h,d,a.buffer,0,a.byteLength))}_getFsProvider(f){const h=this._fsProvider.get(f);if(!h){const d=new Error;throw d.name="ENOPRO",d.message="no provider",d}return h}}e.ExtHostFileSystem=m}),define(De[51],Ce([1,0,5,39,6,22,3,15,35,7]),function(te,e,o,p,b,L,D,T,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConsumerFileSystem=e.ExtHostConsumerFileSystem=void 0;let R=class Zt{constructor(m,I){this._fileSystemProvider=new Map,this._proxy=m.getProxy(o.MainContext.MainThreadFileSystem);const f=this;this.value=Object.freeze({async stat(h){try{const d=f._fileSystemProvider.get(h.scheme);if(!d)return await f._proxy.$stat(h);await f._proxy.$ensureActivation(h.scheme);const a=await d.stat(h);return{type:a.type,ctime:a.ctime,mtime:a.mtime,size:a.size,permissions:a.permissions}}catch(d){Zt._handleError(d)}},async readDirectory(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readDirectory(h)).slice()):await f._proxy.$readdir(h)}catch(d){return Zt._handleError(d)}},async createDirectory(h){try{return await f._proxy.$mkdir(h)}catch(d){return Zt._handleError(d)}},async readFile(h){try{const d=f._fileSystemProvider.get(h.scheme);return d?(await f._proxy.$ensureActivation(h.scheme),(await d.readFile(h)).slice()):(await f._proxy.$readFile(h)).buffer}catch(d){return Zt._handleError(d)}},async writeFile(h,d){try{return await f._proxy.$writeFile(h,L.VSBuffer.wrap(d))}catch(a){return Zt._handleError(a)}},async delete(h,d){try{const a=f._fileSystemProvider.get(h.scheme);return a?(await f._proxy.$ensureActivation(h.scheme),await a.delete(h,{recursive:!1,...d})):await f._proxy.$delete(h,{recursive:!1,useTrash:!1,...d})}catch(a){return Zt._handleError(a)}},async rename(h,d,a){try{return await f._proxy.$rename(h,d,{overwrite:!1,...a})}catch(v){return Zt._handleError(v)}},async copy(h,d,a){try{return await f._proxy.$copy(h,d,{overwrite:!1,...a})}catch(v){return Zt._handleError(v)}},isWritableFileSystem(h){const d=I.getCapabilities(h);if(typeof d=="number")return!(d&2048)}})}static _handleError(m){if(m instanceof b.FileSystemError)throw m;if(!(m instanceof Error))throw new b.FileSystemError(String(m));if(m.name==="ENOPRO")throw b.FileSystemError.Unavailable(m.message);switch(m.name){case p.FileSystemProviderErrorCode.FileExists:throw b.FileSystemError.FileExists(m.message);case p.FileSystemProviderErrorCode.FileNotFound:throw b.FileSystemError.FileNotFound(m.message);case p.FileSystemProviderErrorCode.FileNotADirectory:throw b.FileSystemError.FileNotADirectory(m.message);case p.FileSystemProviderErrorCode.FileIsADirectory:throw b.FileSystemError.FileIsADirectory(m.message);case p.FileSystemProviderErrorCode.NoPermissions:throw b.FileSystemError.NoPermissions(m.message);case p.FileSystemProviderErrorCode.Unavailable:throw b.FileSystemError.Unavailable(m.message);default:throw new b.FileSystemError(m.message,m.name)}}addFileSystemProvider(m,I){return this._fileSystemProvider.set(m,I),(0,P.toDisposable)(()=>this._fileSystemProvider.delete(m))}};R=ze([xe(0,T.IExtHostRpcService),xe(1,E.IExtHostFileSystemInfo)],R),e.ExtHostConsumerFileSystem=R,e.IExtHostConsumerFileSystem=(0,D.createDecorator)("IExtHostConsumerFileSystem")}),define(De[198],Ce([1,0,4,34,2,5,8,6,24]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostFileSystemEventService=void 0;class P{constructor(m,I,f,h,d,a,v,A){this._onDidCreate=new o.Emitter,this._onDidChange=new o.Emitter,this._onDidDelete=new o.Emitter;const l=this.ensureWatching(m,f,d);this._config=0,a&&(this._config+=1),v&&(this._config+=2),A&&(this._config+=4);const _=(0,p.parse)(d),s=typeof d=="string",u=h(n=>{if(!a)for(const i of n.created){const r=b.URI.revive(i);_(r.fsPath)&&(!s||I.getWorkspaceFolder(r))&&this._onDidCreate.fire(r)}if(!v)for(const i of n.changed){const r=b.URI.revive(i);_(r.fsPath)&&(!s||I.getWorkspaceFolder(r))&&this._onDidChange.fire(r)}if(!A)for(const i of n.deleted){const r=b.URI.revive(i);_(r.fsPath)&&(!s||I.getWorkspaceFolder(r))&&this._onDidDelete.fire(r)}});this._disposable=T.Disposable.from(l,this._onDidCreate,this._onDidChange,this._onDidDelete,u)}get ignoreCreateEvents(){return Boolean(this._config&1)}get ignoreChangeEvents(){return Boolean(this._config&2)}get ignoreDeleteEvents(){return Boolean(this._config&4)}ensureWatching(m,I,f){const h=T.Disposable.from();if(typeof f=="string")return h;const d=m.getProxy(L.MainContext.MainThreadFileSystem);let a=!1;(f.pattern.includes(p.GLOBSTAR)||f.pattern.includes(p.GLOB_SPLIT))&&(a=!0);const v=Math.random();return d.$watch(I.identifier.value,v,f.baseUri,{recursive:a,excludes:[]}),T.Disposable.from({dispose:()=>d.$unwatch(v)})}dispose(){this._disposable.dispose()}get onDidCreate(){return this._onDidCreate.event}get onDidChange(){return this._onDidChange.event}get onDidDelete(){return this._onDidDelete.event}}class R{constructor(m,I,f){this._mainContext=m,this._logService=I,this._extHostDocumentsAndEditors=f,this._onFileSystemEvent=new o.Emitter,this._onDidRenameFile=new o.Emitter,this._onDidCreateFile=new o.Emitter,this._onDidDeleteFile=new o.Emitter,this._onWillRenameFile=new o.AsyncEmitter,this._onWillCreateFile=new o.AsyncEmitter,this._onWillDeleteFile=new o.AsyncEmitter,this.onDidRenameFile=this._onDidRenameFile.event,this.onDidCreateFile=this._onDidCreateFile.event,this.onDidDeleteFile=this._onDidDeleteFile.event}createFileSystemWatcher(m,I,f,h,d,a){return new P(this._mainContext,m,I,this._onFileSystemEvent.event,D.GlobPattern.from(f),h,d,a)}$onFileEvent(m){this._onFileSystemEvent.fire(m)}$onDidRunFileOperation(m,I){switch(m){case 2:this._onDidRenameFile.fire(Object.freeze({files:I.map(f=>({oldUri:b.URI.revive(f.source),newUri:b.URI.revive(f.target)}))}));break;case 1:this._onDidDeleteFile.fire(Object.freeze({files:I.map(f=>b.URI.revive(f.target))}));break;case 0:case 3:this._onDidCreateFile.fire(Object.freeze({files:I.map(f=>b.URI.revive(f.target))}));break;default:}}getOnWillRenameFileEvent(m){return this._createWillExecuteEvent(m,this._onWillRenameFile)}getOnWillCreateFileEvent(m){return this._createWillExecuteEvent(m,this._onWillCreateFile)}getOnWillDeleteFileEvent(m){return this._createWillExecuteEvent(m,this._onWillDeleteFile)}_createWillExecuteEvent(m,I){return(f,h,d)=>{const a=function(A){f.call(h,A)};return a.extension=m,I.event(a,void 0,d)}}async $onWillRunFileOperation(m,I,f,h){switch(m){case 2:return await this._fireWillEvent(this._onWillRenameFile,{files:I.map(d=>({oldUri:b.URI.revive(d.source),newUri:b.URI.revive(d.target)}))},f,h);case 1:return await this._fireWillEvent(this._onWillDeleteFile,{files:I.map(d=>b.URI.revive(d.target))},f,h);case 0:case 3:return await this._fireWillEvent(this._onWillCreateFile,{files:I.map(d=>b.URI.revive(d.target))},f,h)}}async _fireWillEvent(m,I,f,h){const d=new Set,a=[];if(await m.fireAsync(I,h,async(A,l)=>{const _=Date.now(),s=await Promise.resolve(A);s instanceof T.WorkspaceEdit&&(a.push([l.extension,s]),d.add(l.extension.displayName??l.extension.identifier.value)),Date.now()-_>f&&this._logService.warn("SLOW file-participant",l.extension.identifier)}),h.isCancellationRequested||a.length===0)return;const v={edits:[]};for(const[A,l]of a){const{edits:_}=D.WorkspaceEdit.from(l,{getTextDocumentVersion:s=>this._extHostDocumentsAndEditors.getDocument(s)?.version,getNotebookDocumentVersion:()=>{}},(0,E.isProposedApiEnabled)(A,"snippetWorkspaceEdit"));v.edits=v.edits.concat(_)}return{edit:v,extensionNames:Array.from(d)}}}e.ExtHostFileSystemEventService=R}),define(De[199],Ce([1,0,2,36]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostInteractive=void 0;class b{constructor(D,T,E,P,R){this._extHostNotebooks=T,this._textDocumentsAndEditors=E,this._commands=P;const y=new p.ApiCommand("interactive.open","_interactive.open","Open interactive window and return notebook editor and input URI",[new p.ApiCommandArgument("showOptions","Show Options",m=>!0,m=>m),new p.ApiCommandArgument("resource","Interactive resource Uri",m=>!0,m=>m),new p.ApiCommandArgument("controllerId","Notebook controller Id",m=>!0,m=>m),new p.ApiCommandArgument("title","Interactive editor title",m=>!0,m=>m)],new p.ApiCommandResult("Notebook and input URI",m=>{if(R.debug("[ExtHostInteractive] open iw with notebook editor id",m.notebookEditorId),m.notebookEditorId!==void 0){const I=this._extHostNotebooks.getEditorById(m.notebookEditorId);return R.debug("[ExtHostInteractive] notebook editor found",I.id),{notebookUri:o.URI.revive(m.notebookUri),inputUri:o.URI.revive(m.inputUri),notebookEditor:I.apiEditor}}return R.debug("[ExtHostInteractive] notebook editor not found, uris for the interactive document",m.notebookUri,m.inputUri),{notebookUri:o.URI.revive(m.notebookUri),inputUri:o.URI.revive(m.inputUri)}}));this._commands.registerApiCommand(y)}$willAddInteractiveDocument(D,T,E,P){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({addedDocuments:[{EOL:T,lines:[""],languageId:E,uri:D,isDirty:!1,versionId:1,notebook:this._extHostNotebooks.getNotebookDocument(o.URI.revive(P))?.apiNotebook}]})}$willRemoveInteractiveDocument(D,T){this._textDocumentsAndEditors.acceptDocumentsAndEditorsDelta({removedDocuments:[D]})}}e.ExtHostInteractive=b}),define(De[200],Ce([1,0,7,5]),function(te,e,o,p){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLabelService=void 0;class b{constructor(D){this._handlePool=0,this._proxy=D.getProxy(p.MainContext.MainThreadLabelService)}$registerResourceLabelFormatter(D){const T=this._handlePool++;return this._proxy.$registerResourceLabelFormatter(T,D),(0,o.toDisposable)(()=>{this._proxy.$unregisterResourceLabelFormatter(T)})}}e.ExtHostLabelService=b}),define(De[201],Ce([1,0,2,26,8,6,66,5,9,48,16,10,243,20,7,77,73,61,202,11,13,24]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l,_){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguageFeatures=e.DocumentRangeSemanticTokensAdapter=e.DocumentSemanticTokensAdapter=void 0;class s{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentSymbols(k,B){const H=this._documents.getDocument(k),j=await this._provider.provideDocumentSymbols(H,B);if(!(0,R.isFalsyOrEmpty)(j))return j[0]instanceof L.DocumentSymbol?j.map(b.DocumentSymbol.from):s._asDocumentSymbolTree(j)}static _asDocumentSymbolTree(k){k=k.slice(0).sort((j,oe)=>{let ue=j.location.range.start.compareTo(oe.location.range.start);return ue===0&&(ue=oe.location.range.end.compareTo(j.location.range.end)),ue});const B=[],H=[];for(const j of k){const oe={name:j.name||"!!MISSING: name!!",kind:b.SymbolKind.from(j.kind),tags:j.tags?.map(b.SymbolTag.from)||[],detail:"",containerName:j.containerName,range:b.Range.from(j.location.range),selectionRange:b.Range.from(j.location.range),children:[]};for(;;){if(H.length===0){H.push(oe),B.push(oe);break}const ue=H[H.length-1];if(P.Range.containsRange(ue.range,oe.range)&&!P.Range.equalsRange(ue.range,oe.range)){ue.children?.push(oe),H.push(oe);break}H.pop()}}return B}}class u{constructor(k,B,H){this._documents=k,this._commands=B,this._provider=H,this._cache=new a.Cache("CodeLens"),this._disposables=new Map}async provideCodeLenses(k,B){const H=this._documents.getDocument(k),j=await this._provider.provideCodeLenses(H,B);if(!j||B.isCancellationRequested)return;const oe=this._cache.add(j),ue=new f.DisposableStore;this._disposables.set(oe,ue);const Z={cacheId:oe,lenses:[]};for(let pe=0;pe<j.length;pe++)Z.lenses.push({cacheId:[oe,pe],range:b.Range.from(j[pe].range),command:this._commands.toInternal(j[pe].command,ue)});return Z}async resolveCodeLens(k,B){const H=k.cacheId&&this._cache.get(...k.cacheId);if(!H)return;let j;if(typeof this._provider.resolveCodeLens!="function"||H.isResolved?j=H:j=await this._provider.resolveCodeLens(H,B),j||(j=H),B.isCancellationRequested)return;const oe=k.cacheId&&this._disposables.get(k.cacheId[0]);if(!!oe)return k.command=this._commands.toInternal(j.command??u._badCmd,oe),k}releaseCodeLenses(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}}u._badCmd={command:"missing",title:"!!MISSING: command!!"};function n(Y){return Array.isArray(Y)?Y.map(b.DefinitionLink.from):Y?[b.DefinitionLink.from(Y)]:[]}class i{constructor(k,B){this._documents=k,this._provider=B}async provideDefinition(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideDefinition(j,oe,H);return n(ue)}}class r{constructor(k,B){this._documents=k,this._provider=B}async provideDeclaration(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideDeclaration(j,oe,H);return n(ue)}}class t{constructor(k,B){this._documents=k,this._provider=B}async provideImplementation(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideImplementation(j,oe,H);return n(ue)}}class c{constructor(k,B){this._documents=k,this._provider=B}async provideTypeDefinition(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideTypeDefinition(j,oe,H);return n(ue)}}class w{constructor(k,B){this._documents=k,this._provider=B}async provideHover(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideHover(j,oe,H);if(!(!ue||(0,R.isFalsyOrEmpty)(ue.contents)))return ue.range||(ue.range=j.getWordRangeAtPosition(oe)),ue.range||(ue.range=new L.Range(oe,oe)),b.Hover.from(ue)}}class g{constructor(k,B){this._documents=k,this._provider=B}async provideEvaluatableExpression(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideEvaluatableExpression(j,oe,H);if(ue)return b.EvaluatableExpression.from(ue)}}class C{constructor(k,B){this._documents=k,this._provider=B}async provideInlineValues(k,B,H,j){const oe=this._documents.getDocument(k),ue=await this._provider.provideInlineValues(oe,b.Range.to(B),b.InlineValueContext.to(H),j);if(Array.isArray(ue))return ue.map(Z=>b.InlineValue.from(Z))}}class U{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentHighlights(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideDocumentHighlights(j,oe,H);if(Array.isArray(ue))return ue.map(b.DocumentHighlight.from)}}class W{constructor(k,B){this._documents=k,this._provider=B}async provideLinkedEditingRanges(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.provideLinkedEditingRanges(j,oe,H);if(ue&&Array.isArray(ue.ranges))return{ranges:(0,R.coalesce)(ue.ranges.map(b.Range.from)),wordPattern:ue.wordPattern}}}class M{constructor(k,B){this._documents=k,this._provider=B}async provideReferences(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Position.to(B),Z=await this._provider.provideReferences(oe,ue,H,j);if(Array.isArray(Z))return Z.map(b.location.from)}}class S{constructor(k,B,H,j,oe,ue,Z){this._documents=k,this._commands=B,this._diagnostics=H,this._provider=j,this._logService=oe,this._extension=ue,this._apiDeprecation=Z,this._cache=new a.Cache("CodeAction"),this._disposables=new Map}async provideCodeActions(k,B,H,j){const oe=this._documents.getDocument(k),ue=m.Selection.isISelection(B)?b.Selection.to(B):b.Range.to(B),Z=[];for(const Ge of this._diagnostics.getDiagnostics(k))if(ue.intersection(Ge.range)&&Z.push(Ge)>S._maxCodeActionsPerFile)break;const pe={diagnostics:Z,only:H.only?new L.CodeActionKind(H.only):void 0,triggerKind:b.CodeActionTriggerKind.to(H.trigger)},ge=await this._provider.provideCodeActions(oe,ue,pe,j);if(!(0,R.isNonEmptyArray)(ge)||j.isCancellationRequested)return;const Ne=this._cache.add(ge),Be=new f.DisposableStore;this._disposables.set(Ne,Be);const Ze=[];for(let Ge=0;Ge<ge.length;Ge++){const ke=ge[Ge];!ke||(S._isCommand(ke)?(this._apiDeprecation.report("CodeActionProvider.provideCodeActions - return commands",this._extension,"Return 'CodeAction' instances instead."),Ze.push({_isSynthetic:!0,title:ke.title,command:this._commands.toInternal(ke,Be)})):(pe.only&&(ke.kind?pe.only.contains(ke.kind)||this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action is of kind '${ke.kind.value}'. Code action will be dropped. Please check 'CodeActionContext.only' to only return requested code actions.`):this._logService.warn(`${this._extension.identifier.value} - Code actions of kind '${pe.only.value} 'requested but returned code action does not have a 'kind'. Code action will be dropped. Please set 'CodeAction.kind'.`)),Ze.push({cacheId:[Ne,Ge],title:ke.title,command:ke.command&&this._commands.toInternal(ke.command,Be),diagnostics:ke.diagnostics&&ke.diagnostics.map(b.Diagnostic.from),edit:ke.edit&&b.WorkspaceEdit.from(ke.edit,void 0,(0,_.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")),kind:ke.kind&&ke.kind.value,isPreferred:ke.isPreferred,disabled:ke.disabled?.reason})))}return{cacheId:Ne,actions:Ze}}async resolveCodeAction(k,B){const[H,j]=k,oe=this._cache.get(H,j);if(!oe||S._isCommand(oe)||!this._provider.resolveCodeAction)return;const ue=await this._provider.resolveCodeAction(oe,B)??oe;return ue?.edit?b.WorkspaceEdit.from(ue.edit,void 0,(0,_.isProposedApiEnabled)(this._extension,"snippetWorkspaceEdit")):void 0}releaseCodeActions(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}static _isCommand(k){return typeof k.command=="string"&&typeof k.title=="string"}}S._maxCodeActionsPerFile=1e3;class z{constructor(k,B,H,j){this._proxy=k,this._documents=B,this._provider=H,this._handle=j}async prepareDocumentPaste(k,B,H,j){if(!this._provider.prepareDocumentPaste)return;const oe=this._documents.getDocument(k),ue=B.map(pe=>b.Range.to(pe)),Z=b.DataTransfer.toDataTransfer(H,()=>{throw new A.NotImplementedError});return await this._provider.prepareDocumentPaste(oe,ue,Z,j),b.DataTransfer.toDataTransferDTO(Z)}async providePasteEdits(k,B,H,j,oe){const ue=this._documents.getDocument(B),Z=H.map(Ne=>b.Range.to(Ne)),pe=b.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolvePasteFileData(this._handle,k,Ne)).buffer),ge=await this._provider.provideDocumentPasteEdits(ue,Z,pe,oe);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class ${constructor(k,B){this._documents=k,this._provider=B}async provideDocumentFormattingEdits(k,B,H){const j=this._documents.getDocument(k),oe=await this._provider.provideDocumentFormattingEdits(j,B,H);if(Array.isArray(oe))return oe.map(b.TextEdit.from)}}class N{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeFormattingEdits(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Range.to(B),Z=await this._provider.provideDocumentRangeFormattingEdits(oe,ue,H,j);if(Array.isArray(Z))return Z.map(b.TextEdit.from)}}class K{constructor(k,B){this._documents=k,this._provider=B,this.autoFormatTriggerCharacters=[]}async provideOnTypeFormattingEdits(k,B,H,j,oe){const ue=this._documents.getDocument(k),Z=b.Position.to(B),pe=await this._provider.provideOnTypeFormattingEdits(ue,Z,H,j,oe);if(Array.isArray(pe))return pe.map(b.TextEdit.from)}}class V{constructor(k,B){this._provider=k,this._logService=B,this._cache=new a.Cache("WorkspaceSymbols")}async provideWorkspaceSymbols(k,B){const H=await this._provider.provideWorkspaceSymbols(k,B);if(!(0,R.isNonEmptyArray)(H))return{symbols:[]};const j=this._cache.add(H),oe={cacheId:j,symbols:[]};for(let ue=0;ue<H.length;ue++){const Z=H[ue];if(!Z||!Z.name){this._logService.warn("INVALID SymbolInformation",Z);continue}oe.symbols.push({...b.WorkspaceSymbol.from(Z),cacheId:[j,ue]})}return oe}async resolveWorkspaceSymbol(k,B){if(typeof this._provider.resolveWorkspaceSymbol!="function"||!k.cacheId)return k;const H=this._cache.get(...k.cacheId);if(H){const j=await this._provider.resolveWorkspaceSymbol(H,B);return j&&(0,p.mixin)(k,b.WorkspaceSymbol.from(j),!0)}}releaseWorkspaceSymbols(k){this._cache.delete(k)}}class F{constructor(k,B,H){this._documents=k,this._provider=B,this._logService=H}static supportsResolving(k){return typeof k.prepareRename=="function"}async provideRenameEdits(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Position.to(B);try{const Z=await this._provider.provideRenameEdits(oe,ue,H,j);return Z?b.WorkspaceEdit.from(Z):void 0}catch(Z){const pe=F._asMessage(Z);return pe?{rejectReason:pe,edits:void 0}:Promise.reject(Z)}}async resolveRenameLocation(k,B,H){if(typeof this._provider.prepareRename!="function")return Promise.resolve(void 0);const j=this._documents.getDocument(k),oe=b.Position.to(B);try{const ue=await this._provider.prepareRename(j,oe,H);let Z,pe;if(L.Range.isRange(ue)?(Z=ue,pe=j.getText(ue)):(0,y.isObject)(ue)&&(Z=ue.range,pe=ue.placeholder),!Z||!pe)return;if(Z.start.line>oe.line||Z.end.line<oe.line){this._logService.warn("INVALID rename location: position line must be within range start/end lines");return}return{range:b.Range.from(Z),text:pe}}catch(ue){const Z=F._asMessage(ue);return Z?{rejectReason:Z,range:void 0,text:void 0}:Promise.reject(ue)}}static _asMessage(k){return typeof k=="string"?k:k instanceof Error&&typeof k.message=="string"?k.message:void 0}}class ne{constructor(k,B){this.resultId=k,this.tokens=B}}class ce{constructor(k,B){this._documents=k,this._provider=B,this._nextResultId=1,this._previousResults=new Map}async provideDocumentSemanticTokens(k,B,H){const j=this._documents.getDocument(k),oe=B!==0?this._previousResults.get(B):null;let ue=typeof oe?.resultId=="string"&&typeof this._provider.provideDocumentSemanticTokensEdits=="function"?await this._provider.provideDocumentSemanticTokensEdits(j,oe.resultId,H):await this._provider.provideDocumentSemanticTokens(j,H);return oe&&this._previousResults.delete(B),ue?(ue=ce._fixProvidedSemanticTokens(ue),this._send(ce._convertToEdits(oe,ue),ue)):null}async releaseDocumentSemanticColoring(k){this._previousResults.delete(k)}static _fixProvidedSemanticTokens(k){return ce._isSemanticTokens(k)?ce._isCorrectSemanticTokens(k)?k:new L.SemanticTokens(new Uint32Array(k.data),k.resultId):ce._isSemanticTokensEdits(k)?ce._isCorrectSemanticTokensEdits(k)?k:new L.SemanticTokensEdits(k.edits.map(B=>new L.SemanticTokensEdit(B.start,B.deleteCount,B.data?new Uint32Array(B.data):B.data)),k.resultId):k}static _isSemanticTokens(k){return k&&!!k.data}static _isCorrectSemanticTokens(k){return k.data instanceof Uint32Array}static _isSemanticTokensEdits(k){return k&&Array.isArray(k.edits)}static _isCorrectSemanticTokensEdits(k){for(const B of k.edits)if(!(B.data instanceof Uint32Array))return!1;return!0}static _convertToEdits(k,B){if(!ce._isSemanticTokens(B)||!k||!k.tokens)return B;const H=k.tokens,j=H.length,oe=B.data,ue=oe.length;let Z=0;const pe=Math.min(j,ue);for(;Z<pe&&H[Z]===oe[Z];)Z++;if(Z===j&&Z===ue)return new L.SemanticTokensEdits([],B.resultId);let ge=0;const Ne=pe-Z;for(;ge<Ne&&H[j-ge-1]===oe[ue-ge-1];)ge++;return new L.SemanticTokensEdits([{start:Z,deleteCount:j-Z-ge,data:oe.subarray(Z,ue-ge)}],B.resultId)}_send(k,B){if(ce._isSemanticTokens(k)){const H=this._nextResultId++;return this._previousResults.set(H,new ne(k.resultId,k.data)),(0,h.encodeSemanticTokensDto)({id:H,type:"full",data:k.data})}if(ce._isSemanticTokensEdits(k)){const H=this._nextResultId++;return ce._isSemanticTokens(B)?this._previousResults.set(H,new ne(B.resultId,B.data)):this._previousResults.set(H,new ne(k.resultId)),(0,h.encodeSemanticTokensDto)({id:H,type:"delta",deltas:(k.edits||[]).map(j=>({start:j.start,deleteCount:j.deleteCount,data:j.data}))})}return null}}e.DocumentSemanticTokensAdapter=ce;class re{constructor(k,B){this._documents=k,this._provider=B}async provideDocumentRangeSemanticTokens(k,B,H){const j=this._documents.getDocument(k),oe=await this._provider.provideDocumentRangeSemanticTokens(j,b.Range.to(B),H);return oe?this._send(oe):null}_send(k){return(0,h.encodeSemanticTokensDto)({id:0,type:"full",data:k.data})}}e.DocumentRangeSemanticTokensAdapter=re;class fe{constructor(k,B,H,j,oe){this._documents=k,this._commands=B,this._provider=H,this._apiDeprecation=j,this._extension=oe,this._cache=new a.Cache("CompletionItem"),this._disposables=new Map}static supportsResolving(k){return typeof k.resolveCompletionItem=="function"}async provideCompletionItems(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Position.to(B),Z=oe.getWordRangeAtPosition(ue)||new L.Range(ue,ue),pe=Z.with({end:ue}),ge=new v.StopWatch(!0),Ne=await this._provider.provideCompletionItems(oe,ue,j,b.CompletionContext.to(H));if(!Ne||j.isCancellationRequested)return;const Be=Array.isArray(Ne)?new L.CompletionList(Ne):Ne,Ze=fe.supportsResolving(this._provider)?this._cache.add(Be.items):this._cache.add([]),Ge=new f.DisposableStore;this._disposables.set(Ze,Ge);const ke=[],nt={x:Ze,b:ke,a:{replace:b.Range.from(Z),insert:b.Range.from(pe)},c:Be.isIncomplete||void 0,d:ge.elapsed()};for(let G=0;G<Be.items.length;G++){const Q=Be.items[G],he=this._convertCompletionItem(Q,[Ze,G],pe,Z);ke.push(he)}return nt}async resolveCompletionItem(k,B){if(typeof this._provider.resolveCompletionItem!="function")return;const H=this._cache.get(...k);if(!H)return;const j=await this._provider.resolveCompletionItem(H,B);if(!!j)return this._convertCompletionItem(j,k)}releaseCompletionItems(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_convertCompletionItem(k,B,H,j){const oe=this._disposables.get(B[0]);if(!oe)throw Error("DisposableStore is missing...");const ue={x:B,a:k.label,b:k.kind!==void 0?b.CompletionItemKind.from(k.kind):void 0,n:k.tags&&k.tags.map(b.CompletionItemTag.from),c:k.detail,d:typeof k.documentation=="undefined"?void 0:b.MarkdownString.fromStrict(k.documentation),e:k.sortText!==k.label?k.sortText:void 0,f:k.filterText!==k.label?k.filterText:void 0,g:k.preselect||void 0,i:k.keepWhitespace?1:0,k:k.commitCharacters,l:k.additionalTextEdits&&k.additionalTextEdits.map(b.TextEdit.from),m:this._commands.toInternal(k.command,oe)};k.textEdit?(this._apiDeprecation.report("CompletionItem.textEdit",this._extension,"Use 'CompletionItem.insertText' and 'CompletionItem.range' instead."),ue.h=k.textEdit.newText):typeof k.insertText=="string"?ue.h=k.insertText:k.insertText instanceof L.SnippetString&&(ue.h=k.insertText.value,ue.i|=4);let Z;return k.textEdit?Z=k.textEdit.range:k.range&&(Z=k.range),L.Range.isRange(Z)?ue.j=b.Range.from(Z):Z&&(!H?.isEqual(Z.inserting)||!j?.isEqual(Z.replacing))&&(ue.j={insert:b.Range.from(Z.inserting),replace:b.Range.from(Z.replacing)}),ue}}class ie{async provideInlineCompletions(k,B,H,j){}disposeCompletions(k){}handleDidShowCompletionItem(k,B){}}class Ee extends ie{constructor(k,B,H,j){super();this._extension=k,this._documents=B,this._provider=H,this._commands=j,this._references=new ee,this._isAdditionsProposedApiEnabled=(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKind.Automatic,[D.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKind.Invoke}}get supportsHandleDidShowCompletionItem(){return(0,_.isProposedApiEnabled)(this._extension,"inlineCompletionsAdditions")&&typeof this._provider.handleDidShowCompletionItem=="function"}async provideInlineCompletions(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Position.to(B),Z=await this._provider.provideInlineCompletionItems(oe,ue,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const pe=Array.isArray(Z)?Z:Z.items,ge=this._isAdditionsProposedApiEnabled?Array.isArray(Z)?[]:Z.commands||[]:[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ze,Ge)=>{let ke;Ze.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ze.command,Ne));const nt=Ze.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ze.filterText,range:Ze.range?b.Range.from(Ze.range):void 0,command:ke,idx:Ge,completeBracketPairs:this._isAdditionsProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ge.map(Ze=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ze,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const H=this._references.get(k)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this._isAdditionsProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class be extends ie{constructor(k,B,H,j){super();this.extension=k,this._documents=B,this._provider=H,this._commands=j,this._references=new ee,this.isAdditionProposedApiEnabled=(0,_.isProposedApiEnabled)(this.extension,"inlineCompletionsAdditions"),this.languageTriggerKindToVSCodeTriggerKind={[D.InlineCompletionTriggerKind.Automatic]:L.InlineCompletionTriggerKindNew.Automatic,[D.InlineCompletionTriggerKind.Explicit]:L.InlineCompletionTriggerKindNew.Invoke}}async provideInlineCompletions(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Position.to(B),Z=await this._provider.provideInlineCompletionItems(oe,ue,{selectedCompletionInfo:H.selectedSuggestionInfo?{range:b.Range.to(H.selectedSuggestionInfo.range),text:H.selectedSuggestionInfo.text}:void 0,triggerKind:this.languageTriggerKindToVSCodeTriggerKind[H.triggerKind]},j);if(!Z||j.isCancellationRequested)return;const pe=Array.isArray(Z)?Z:Z.items,ge=Array.isArray(Z)?[]:Z.commands||[];let Ne;return{pid:this._references.createReferenceId({dispose(){Ne?.dispose()},items:pe}),items:pe.map((Ze,Ge)=>{let ke;Ze.command&&(Ne||(Ne=new f.DisposableStore),ke=this._commands.toInternal(Ze.command,Ne));const nt=Ze.insertText;return{insertText:typeof nt=="string"?nt:{snippet:nt.value},filterText:Ze.filterText,range:Ze.range?b.Range.from(Ze.range):void 0,command:ke,idx:Ge,completeBracketPairs:this.isAdditionProposedApiEnabled?Ze.completeBracketPairs:!1}}),commands:ge.map(Ze=>(Ne||(Ne=new f.DisposableStore),this._commands.toInternal(Ze,Ne)))}}disposeCompletions(k){this._references.disposeReferenceId(k)?.dispose()}handleDidShowCompletionItem(k,B){const H=this._references.get(k)?.items[B];H&&this._provider.handleDidShowCompletionItem&&this.isAdditionProposedApiEnabled&&this._provider.handleDidShowCompletionItem(H)}}class ee{constructor(){this._references=new Map,this._idPool=1}createReferenceId(k){const B=this._idPool++;return this._references.set(B,k),B}disposeReferenceId(k){const B=this._references.get(k);return this._references.delete(k),B}get(k){return this._references.get(k)}}class ve{constructor(k,B){this._documents=k,this._provider=B,this._cache=new a.Cache("SignatureHelp")}async provideSignatureHelp(k,B,H,j){const oe=this._documents.getDocument(k),ue=b.Position.to(B),Z=this.reviveContext(H),pe=await this._provider.provideSignatureHelp(oe,ue,j,Z);if(pe){const ge=this._cache.add([pe]);return{...b.SignatureHelp.from(pe),id:ge}}}reviveContext(k){let B;if(k.activeSignatureHelp){const H=b.SignatureHelp.to(k.activeSignatureHelp),j=this._cache.get(k.activeSignatureHelp.id,0);j?(B=j,B.activeSignature=H.activeSignature,B.activeParameter=H.activeParameter):B=H}return{...k,activeSignatureHelp:B}}releaseSignatureHelp(k){this._cache.delete(k)}}class Ae{constructor(k,B,H,j,oe){this._documents=k,this._commands=B,this._provider=H,this._logService=j,this._extension=oe,this._cache=new a.Cache("InlayHints"),this._disposables=new Map}async provideInlayHints(k,B,H){const j=this._documents.getDocument(k),oe=b.Range.to(B),ue=await this._provider.provideInlayHints(j,oe,H);if(!Array.isArray(ue)||ue.length===0){this._logService.trace(`[InlayHints] NO inlay hints from '${this._extension.identifier.value}' for ${B}`);return}if(H.isCancellationRequested)return;const Z=this._cache.add(ue);this._disposables.set(Z,new f.DisposableStore);const pe={hints:[],cacheId:Z};for(let ge=0;ge<ue.length;ge++)this._isValidInlayHint(ue[ge],oe)&&pe.hints.push(this._convertInlayHint(ue[ge],[Z,ge]));return this._logService.trace(`[InlayHints] ${pe.hints.length} inlay hints from '${this._extension.identifier.value}' for ${B}`),pe}async resolveInlayHint(k,B){if(typeof this._provider.resolveInlayHint!="function")return;const H=this._cache.get(...k);if(!H)return;const j=await this._provider.resolveInlayHint(H,B);if(!!j&&!!this._isValidInlayHint(j))return this._convertInlayHint(j,k)}releaseHints(k){this._disposables.get(k)?.dispose(),this._disposables.delete(k),this._cache.delete(k)}_isValidInlayHint(k,B){return k.label.length===0||Array.isArray(k.label)&&k.label.every(H=>H.value.length===0)?(console.log("INVALID inlay hint, empty label",k),!1):!(B&&!B.contains(k.position))}_convertInlayHint(k,B){const H=this._disposables.get(B[0]);if(!H)throw Error("DisposableStore is missing...");const j={label:"",cacheId:B,tooltip:b.MarkdownString.fromStrict(k.tooltip),position:b.Position.from(k.position),textEdits:k.textEdits&&k.textEdits.map(b.TextEdit.from),kind:k.kind&&b.InlayHintKind.from(k.kind),paddingLeft:k.paddingLeft,paddingRight:k.paddingRight};return typeof k.label=="string"?j.label=k.label:j.label=k.label.map(oe=>{const ue={label:oe.value};return ue.tooltip=b.MarkdownString.fromStrict(oe.tooltip),L.Location.isLocation(oe.location)&&(ue.location=b.location.from(oe.location)),oe.command&&(ue.command=this._commands.toInternal(oe.command,H)),ue}),j}}class Fe{constructor(k,B){this._documents=k,this._provider=B,this._cache=new a.Cache("DocumentLink")}async provideLinks(k,B){const H=this._documents.getDocument(k),j=await this._provider.provideDocumentLinks(H,B);if(!(!Array.isArray(j)||j.length===0)&&!B.isCancellationRequested){if(typeof this._provider.resolveDocumentLink!="function")return{links:j.filter(Fe._validateLink).map(b.DocumentLink.from)};{const oe=this._cache.add(j),ue={links:[],cacheId:oe};for(let Z=0;Z<j.length;Z++){if(!Fe._validateLink(j[Z]))continue;const pe=b.DocumentLink.from(j[Z]);pe.cacheId=[oe,Z],ue.links.push(pe)}return ue}}}static _validateLink(k){return k.target&&k.target.path.length>5e4?(console.warn("DROPPING link because it is too long"),!1):!0}async resolveLink(k,B){if(typeof this._provider.resolveDocumentLink!="function")return;const H=this._cache.get(...k);if(!H)return;const j=await this._provider.resolveDocumentLink(H,B);if(!(!j||!Fe._validateLink(j)))return b.DocumentLink.from(j)}releaseLinks(k){this._cache.delete(k)}}class $e{constructor(k,B){this._documents=k,this._provider=B}async provideColors(k,B){const H=this._documents.getDocument(k),j=await this._provider.provideDocumentColors(H,B);return Array.isArray(j)?j.map(ue=>({color:b.Color.from(ue.color),range:b.Range.from(ue.range)})):[]}async provideColorPresentations(k,B,H){const j=this._documents.getDocument(k),oe=b.Range.to(B.range),ue=b.Color.to(B.color),Z=await this._provider.provideColorPresentations(ue,{document:j,range:oe},H);if(!!Array.isArray(Z))return Z.map(b.ColorPresentation.from)}}class Qe{constructor(k,B){this._documents=k,this._provider=B}async provideFoldingRanges(k,B,H){const j=this._documents.getDocument(k),oe=await this._provider.provideFoldingRanges(j,B,H);if(!!Array.isArray(oe))return oe.map(b.FoldingRange.from)}}class Ie{constructor(k,B,H){this._documents=k,this._provider=B,this._logService=H}async provideSelectionRanges(k,B,H){const j=this._documents.getDocument(k),oe=B.map(b.Position.to),ue=await this._provider.provideSelectionRanges(j,oe,H);if(!(0,R.isNonEmptyArray)(ue))return[];if(ue.length!==oe.length)return this._logService.warn("BAD selection ranges, provider must return ranges for each position"),[];const Z=[];for(let pe=0;pe<oe.length;pe++){const ge=[];Z.push(ge);let Ne=oe[pe],Be=ue[pe];for(;;){if(!Be.range.contains(Ne))throw new Error("INVALID selection range, must contain the previous range");if(ge.push(b.SelectionRange.from(Be)),!Be.parent)break;Ne=Be.range,Be=Be.parent}}return Z}}class Se{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.prepareCallHierarchy(j,oe,H);if(!ue)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(ue)?ue.map(pe=>this._cacheAndConvertItem(Z,pe)):[this._cacheAndConvertItem(Z,ue)]}async provideCallsTo(k,B,H){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyIncomingCalls(j,H);if(!!oe)return oe.map(ue=>({from:this._cacheAndConvertItem(k,ue.from),fromRanges:ue.fromRanges.map(Z=>b.Range.from(Z))}))}async provideCallsFrom(k,B,H){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing call hierarchy item");const oe=await this._provider.provideCallHierarchyOutgoingCalls(j,H);if(!!oe)return oe.map(ue=>({to:this._cacheAndConvertItem(k,ue.to),fromRanges:ue.fromRanges.map(Z=>b.Range.from(Z))}))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const H=this._cache.get(k),j=b.CallHierarchyItem.from(B,k,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class Te{constructor(k,B){this._documents=k,this._provider=B,this._idPool=new d.IdGenerator(""),this._cache=new Map}async prepareSession(k,B,H){const j=this._documents.getDocument(k),oe=b.Position.to(B),ue=await this._provider.prepareTypeHierarchy(j,oe,H);if(!ue)return;const Z=this._idPool.nextId();return this._cache.set(Z,new Map),Array.isArray(ue)?ue.map(pe=>this._cacheAndConvertItem(Z,pe)):[this._cacheAndConvertItem(Z,ue)]}async provideSupertypes(k,B,H){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySupertypes(j,H);if(!!oe)return oe.map(ue=>this._cacheAndConvertItem(k,ue))}async provideSubtypes(k,B,H){const j=this._itemFromCache(k,B);if(!j)throw new Error("missing type hierarchy item");const oe=await this._provider.provideTypeHierarchySubtypes(j,H);if(!!oe)return oe.map(ue=>this._cacheAndConvertItem(k,ue))}releaseSession(k){this._cache.delete(k)}_cacheAndConvertItem(k,B){const H=this._cache.get(k),j=b.TypeHierarchyItem.from(B,k,H.size.toString(36));return H.set(j._itemId,B),j}_itemFromCache(k,B){return this._cache.get(k)?.get(B)}}class ae{constructor(k,B,H,j){this._proxy=k,this._documents=B,this._provider=H,this._handle=j}async provideDocumentOnDropEdits(k,B,H,j,oe){const ue=this._documents.getDocument(B),Z=b.Position.to(H),pe=b.DataTransfer.toDataTransfer(j,async Ne=>(await this._proxy.$resolveDocumentOnDropFileData(this._handle,k,Ne)).buffer),ge=await this._provider.provideDocumentDropEdits(ue,Z,pe,oe);if(!!ge)return{insertText:typeof ge.insertText=="string"?ge.insertText:{snippet:ge.insertText.value},additionalEdit:ge.additionalEdit?b.WorkspaceEdit.from(ge.additionalEdit,void 0,!0):void 0}}}class le{constructor(k,B){this.adapter=k,this.extension=B}}class X{constructor(k,B,H,j,oe,ue,Z){this._adapter=new Map,this._uriTransformer=B,this._proxy=k.getProxy(T.MainContext.MainThreadLanguageFeatures),this._documents=H,this._commands=j,this._diagnostics=oe,this._logService=ue,this._apiDeprecation=Z}_transformDocumentSelector(k){return b.DocumentSelector.from(k,this._uriTransformer)}_createDisposable(k){return new L.Disposable(()=>{this._adapter.delete(k),this._proxy.$unregister(k)})}_nextHandle(){return X._handlePool++}async _withAdapter(k,B,H,j,oe,ue=!1){const Z=this._adapter.get(k);if(!Z||!(Z.adapter instanceof B))return j;const pe=Date.now();ue||this._logService.trace(`[${Z.extension.identifier.value}] INVOKE provider '${H.toString().replace(/[\r\n]/g,"")}'`);const ge=H(Z.adapter,Z.extension);return Promise.resolve(ge).catch(Ne=>{(0,A.isCancellationError)(Ne)||(this._logService.error(`[${Z.extension.identifier.value}] provider FAILED`),this._logService.error(Ne))}).finally(()=>{ue||this._logService.trace(`[${Z.extension.identifier.value}] provider DONE after ${Date.now()-pe}ms`)}),I.CancellationToken.isCancellationToken(oe)?(0,l.raceCancellationError)(ge,oe):ge}_addNewAdapter(k,B){const H=this._nextHandle();return this._adapter.set(H,new le(k,B)),H}static _extLabel(k){return k.displayName||k.name}registerDocumentSymbolProvider(k,B,H,j){const oe=this._addNewAdapter(new s(this._documents,H),k),ue=j&&j.label||X._extLabel(k);return this._proxy.$registerDocumentSymbolProvider(oe,this._transformDocumentSelector(B),ue),this._createDisposable(oe)}$provideDocumentSymbols(k,B,H){return this._withAdapter(k,s,j=>j.provideDocumentSymbols(o.URI.revive(B),H),void 0,H)}registerCodeLensProvider(k,B,H){const j=this._nextHandle(),oe=typeof H.onDidChangeCodeLenses=="function"?this._nextHandle():void 0;this._adapter.set(j,new le(new u(this._documents,this._commands.converter,H),k)),this._proxy.$registerCodeLensSupport(j,this._transformDocumentSelector(B),oe);let ue=this._createDisposable(j);if(oe!==void 0){const Z=H.onDidChangeCodeLenses(pe=>this._proxy.$emitCodeLensEvent(oe));ue=L.Disposable.from(ue,Z)}return ue}$provideCodeLenses(k,B,H){return this._withAdapter(k,u,j=>j.provideCodeLenses(o.URI.revive(B),H),void 0,H)}$resolveCodeLens(k,B,H){return this._withAdapter(k,u,j=>j.resolveCodeLens(B,H),void 0,void 0)}$releaseCodeLenses(k,B){this._withAdapter(k,u,H=>Promise.resolve(H.releaseCodeLenses(B)),void 0,void 0)}registerDefinitionProvider(k,B,H){const j=this._addNewAdapter(new i(this._documents,H),k);return this._proxy.$registerDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDefinition(k,B,H,j){return this._withAdapter(k,i,oe=>oe.provideDefinition(o.URI.revive(B),H,j),[],j)}registerDeclarationProvider(k,B,H){const j=this._addNewAdapter(new r(this._documents,H),k);return this._proxy.$registerDeclarationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDeclaration(k,B,H,j){return this._withAdapter(k,r,oe=>oe.provideDeclaration(o.URI.revive(B),H,j),[],j)}registerImplementationProvider(k,B,H){const j=this._addNewAdapter(new t(this._documents,H),k);return this._proxy.$registerImplementationSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideImplementation(k,B,H,j){return this._withAdapter(k,t,oe=>oe.provideImplementation(o.URI.revive(B),H,j),[],j)}registerTypeDefinitionProvider(k,B,H){const j=this._addNewAdapter(new c(this._documents,H),k);return this._proxy.$registerTypeDefinitionSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideTypeDefinition(k,B,H,j){return this._withAdapter(k,c,oe=>oe.provideTypeDefinition(o.URI.revive(B),H,j),[],j)}registerHoverProvider(k,B,H,j){const oe=this._addNewAdapter(new w(this._documents,H),k);return this._proxy.$registerHoverProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideHover(k,B,H,j){return this._withAdapter(k,w,oe=>oe.provideHover(o.URI.revive(B),H,j),void 0,j)}registerEvaluatableExpressionProvider(k,B,H,j){const oe=this._addNewAdapter(new g(this._documents,H),k);return this._proxy.$registerEvaluatableExpressionProvider(oe,this._transformDocumentSelector(B)),this._createDisposable(oe)}$provideEvaluatableExpression(k,B,H,j){return this._withAdapter(k,g,oe=>oe.provideEvaluatableExpression(o.URI.revive(B),H,j),void 0,j)}registerInlineValuesProvider(k,B,H,j){const oe=typeof H.onDidChangeInlineValues=="function"?this._nextHandle():void 0,ue=this._addNewAdapter(new C(this._documents,H),k);this._proxy.$registerInlineValuesProvider(ue,this._transformDocumentSelector(B),oe);let Z=this._createDisposable(ue);if(oe!==void 0){const pe=H.onDidChangeInlineValues(ge=>this._proxy.$emitInlineValuesEvent(oe));Z=L.Disposable.from(Z,pe)}return Z}$provideInlineValues(k,B,H,j,oe){return this._withAdapter(k,C,ue=>ue.provideInlineValues(o.URI.revive(B),H,j,oe),void 0,oe)}registerDocumentHighlightProvider(k,B,H){const j=this._addNewAdapter(new U(this._documents,H),k);return this._proxy.$registerDocumentHighlightProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentHighlights(k,B,H,j){return this._withAdapter(k,U,oe=>oe.provideDocumentHighlights(o.URI.revive(B),H,j),void 0,j)}registerLinkedEditingRangeProvider(k,B,H){const j=this._addNewAdapter(new W(this._documents,H),k);return this._proxy.$registerLinkedEditingRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideLinkedEditingRanges(k,B,H,j){return this._withAdapter(k,W,async oe=>{const ue=await oe.provideLinkedEditingRanges(o.URI.revive(B),H,j);if(ue)return{ranges:ue.ranges,wordPattern:ue.wordPattern?X._serializeRegExp(ue.wordPattern):void 0}},void 0,j)}registerReferenceProvider(k,B,H){const j=this._addNewAdapter(new M(this._documents,H),k);return this._proxy.$registerReferenceSupport(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideReferences(k,B,H,j,oe){return this._withAdapter(k,M,ue=>ue.provideReferences(o.URI.revive(B),H,j,oe),void 0,oe)}registerCodeActionProvider(k,B,H,j){const oe=new f.DisposableStore,ue=this._addNewAdapter(new S(this._documents,this._commands.converter,this._diagnostics,H,this._logService,k,this._apiDeprecation),k);return this._proxy.$registerQuickFixSupport(ue,this._transformDocumentSelector(B),{providedKinds:j?.providedCodeActionKinds?.map(Z=>Z.value),documentation:j?.documentation?.map(Z=>({kind:Z.kind.value,command:this._commands.converter.toInternal(Z.command,oe)}))},X._extLabel(k),Boolean(H.resolveCodeAction)),oe.add(this._createDisposable(ue)),oe}$provideCodeActions(k,B,H,j,oe){return this._withAdapter(k,S,ue=>ue.provideCodeActions(o.URI.revive(B),H,j,oe),void 0,oe)}$resolveCodeAction(k,B,H){return this._withAdapter(k,S,j=>j.resolveCodeAction(B,H),void 0,void 0)}$releaseCodeActions(k,B){this._withAdapter(k,S,H=>Promise.resolve(H.releaseCodeActions(B)),void 0,void 0)}registerDocumentFormattingEditProvider(k,B,H){const j=this._addNewAdapter(new $(this._documents,H),k);return this._proxy.$registerDocumentFormattingSupport(j,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(j)}$provideDocumentFormattingEdits(k,B,H,j){return this._withAdapter(k,$,oe=>oe.provideDocumentFormattingEdits(o.URI.revive(B),H,j),void 0,j)}registerDocumentRangeFormattingEditProvider(k,B,H){const j=this._addNewAdapter(new N(this._documents,H),k);return this._proxy.$registerRangeFormattingSupport(j,this._transformDocumentSelector(B),k.identifier,k.displayName||k.name),this._createDisposable(j)}$provideDocumentRangeFormattingEdits(k,B,H,j,oe){return this._withAdapter(k,N,ue=>ue.provideDocumentRangeFormattingEdits(o.URI.revive(B),H,j,oe),void 0,oe)}registerOnTypeFormattingEditProvider(k,B,H,j){const oe=this._addNewAdapter(new K(this._documents,H),k);return this._proxy.$registerOnTypeFormattingSupport(oe,this._transformDocumentSelector(B),j,k.identifier),this._createDisposable(oe)}$provideOnTypeFormattingEdits(k,B,H,j,oe,ue){return this._withAdapter(k,K,Z=>Z.provideOnTypeFormattingEdits(o.URI.revive(B),H,j,oe,ue),void 0,ue)}registerWorkspaceSymbolProvider(k,B){const H=this._addNewAdapter(new V(B,this._logService),k);return this._proxy.$registerNavigateTypeSupport(H,typeof B.resolveWorkspaceSymbol=="function"),this._createDisposable(H)}$provideWorkspaceSymbols(k,B,H){return this._withAdapter(k,V,j=>j.provideWorkspaceSymbols(B,H),{symbols:[]},H)}$resolveWorkspaceSymbol(k,B,H){return this._withAdapter(k,V,j=>j.resolveWorkspaceSymbol(B,H),void 0,void 0)}$releaseWorkspaceSymbols(k,B){this._withAdapter(k,V,H=>H.releaseWorkspaceSymbols(B),void 0,void 0)}registerRenameProvider(k,B,H){const j=this._addNewAdapter(new F(this._documents,H,this._logService),k);return this._proxy.$registerRenameSupport(j,this._transformDocumentSelector(B),F.supportsResolving(H)),this._createDisposable(j)}$provideRenameEdits(k,B,H,j,oe){return this._withAdapter(k,F,ue=>ue.provideRenameEdits(o.URI.revive(B),H,j,oe),void 0,oe)}$resolveRenameLocation(k,B,H,j){return this._withAdapter(k,F,oe=>oe.resolveRenameLocation(o.URI.revive(B),H,j),void 0,j)}registerDocumentSemanticTokensProvider(k,B,H,j){const oe=this._addNewAdapter(new ce(this._documents,H),k),ue=typeof H.onDidChangeSemanticTokens=="function"?this._nextHandle():void 0;this._proxy.$registerDocumentSemanticTokensProvider(oe,this._transformDocumentSelector(B),j,ue);let Z=this._createDisposable(oe);if(ue){const pe=H.onDidChangeSemanticTokens(ge=>this._proxy.$emitDocumentSemanticTokensEvent(ue));Z=L.Disposable.from(Z,pe)}return Z}$provideDocumentSemanticTokens(k,B,H,j){return this._withAdapter(k,ce,oe=>oe.provideDocumentSemanticTokens(o.URI.revive(B),H,j),null,j)}$releaseDocumentSemanticTokens(k,B){this._withAdapter(k,ce,H=>H.releaseDocumentSemanticColoring(B),void 0,void 0)}registerDocumentRangeSemanticTokensProvider(k,B,H,j){const oe=this._addNewAdapter(new re(this._documents,H),k);return this._proxy.$registerDocumentRangeSemanticTokensProvider(oe,this._transformDocumentSelector(B),j),this._createDisposable(oe)}$provideDocumentRangeSemanticTokens(k,B,H,j){return this._withAdapter(k,re,oe=>oe.provideDocumentRangeSemanticTokens(o.URI.revive(B),H,j),null,j)}registerCompletionItemProvider(k,B,H,j){const oe=this._addNewAdapter(new fe(this._documents,this._commands.converter,H,this._apiDeprecation,k),k);return this._proxy.$registerCompletionsProvider(oe,this._transformDocumentSelector(B),j,fe.supportsResolving(H),`${k.identifier.value}(${j.join("")})`),this._createDisposable(oe)}$provideCompletionItems(k,B,H,j,oe){return this._withAdapter(k,fe,ue=>ue.provideCompletionItems(o.URI.revive(B),H,j,oe),void 0,oe)}$resolveCompletionItem(k,B,H){return this._withAdapter(k,fe,j=>j.resolveCompletionItem(B,H),void 0,H)}$releaseCompletionItems(k,B){this._withAdapter(k,fe,H=>H.releaseCompletionItems(B),void 0,void 0)}registerInlineCompletionsProvider(k,B,H){const j=new Ee(k,this._documents,H,this._commands.converter),oe=this._addNewAdapter(j,k);return this._proxy.$registerInlineCompletionsSupport(oe,this._transformDocumentSelector(B),j.supportsHandleDidShowCompletionItem),this._createDisposable(oe)}registerInlineCompletionsProviderNew(k,B,H){const j=this._addNewAdapter(new be(k,this._documents,H,this._commands.converter),k);return this._proxy.$registerInlineCompletionsSupport(j,this._transformDocumentSelector(B),!0),this._createDisposable(j)}$provideInlineCompletions(k,B,H,j,oe){return this._withAdapter(k,ie,ue=>ue.provideInlineCompletions(o.URI.revive(B),H,j,oe),void 0,oe)}$handleInlineCompletionDidShow(k,B,H){this._withAdapter(k,ie,async j=>{j.handleDidShowCompletionItem(B,H)},void 0,void 0)}$freeInlineCompletionsList(k,B){this._withAdapter(k,ie,async H=>{H.disposeCompletions(B)},void 0,void 0)}registerSignatureHelpProvider(k,B,H,j){const oe=Array.isArray(j)?{triggerCharacters:j,retriggerCharacters:[]}:j,ue=this._addNewAdapter(new ve(this._documents,H),k);return this._proxy.$registerSignatureHelpProvider(ue,this._transformDocumentSelector(B),oe),this._createDisposable(ue)}$provideSignatureHelp(k,B,H,j,oe){return this._withAdapter(k,ve,ue=>ue.provideSignatureHelp(o.URI.revive(B),H,j,oe),void 0,oe)}$releaseSignatureHelp(k,B){this._withAdapter(k,ve,H=>H.releaseSignatureHelp(B),void 0,void 0)}registerInlayHintsProvider(k,B,H){const j=typeof H.onDidChangeInlayHints=="function"?this._nextHandle():void 0,oe=this._addNewAdapter(new Ae(this._documents,this._commands.converter,H,this._logService,k),k);this._proxy.$registerInlayHintsProvider(oe,this._transformDocumentSelector(B),typeof H.resolveInlayHint=="function",j,X._extLabel(k));let ue=this._createDisposable(oe);if(j!==void 0){const Z=H.onDidChangeInlayHints(pe=>this._proxy.$emitInlayHintsEvent(j));ue=L.Disposable.from(ue,Z)}return ue}$provideInlayHints(k,B,H,j){return this._withAdapter(k,Ae,oe=>oe.provideInlayHints(o.URI.revive(B),H,j),void 0,j)}$resolveInlayHint(k,B,H){return this._withAdapter(k,Ae,j=>j.resolveInlayHint(B,H),void 0,H)}$releaseInlayHints(k,B){this._withAdapter(k,Ae,H=>H.releaseHints(B),void 0,void 0)}registerDocumentLinkProvider(k,B,H){const j=this._addNewAdapter(new Fe(this._documents,H),k);return this._proxy.$registerDocumentLinkProvider(j,this._transformDocumentSelector(B),typeof H.resolveDocumentLink=="function"),this._createDisposable(j)}$provideDocumentLinks(k,B,H){return this._withAdapter(k,Fe,j=>j.provideLinks(o.URI.revive(B),H),void 0,H,B.scheme==="output")}$resolveDocumentLink(k,B,H){return this._withAdapter(k,Fe,j=>j.resolveLink(B,H),void 0,void 0,!0)}$releaseDocumentLinks(k,B){this._withAdapter(k,Fe,H=>H.releaseLinks(B),void 0,void 0,!0)}registerColorProvider(k,B,H){const j=this._addNewAdapter(new $e(this._documents,H),k);return this._proxy.$registerDocumentColorProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentColors(k,B,H){return this._withAdapter(k,$e,j=>j.provideColors(o.URI.revive(B),H),[],H)}$provideColorPresentations(k,B,H,j){return this._withAdapter(k,$e,oe=>oe.provideColorPresentations(o.URI.revive(B),H,j),void 0,j)}registerFoldingRangeProvider(k,B,H){const j=this._nextHandle(),oe=typeof H.onDidChangeFoldingRanges=="function"?this._nextHandle():void 0;this._adapter.set(j,new le(new Qe(this._documents,H),k)),this._proxy.$registerFoldingRangeProvider(j,this._transformDocumentSelector(B),oe);let ue=this._createDisposable(j);if(oe!==void 0){const Z=H.onDidChangeFoldingRanges(()=>this._proxy.$emitFoldingRangeEvent(oe));ue=L.Disposable.from(ue,Z)}return ue}$provideFoldingRanges(k,B,H,j){return this._withAdapter(k,Qe,oe=>oe.provideFoldingRanges(o.URI.revive(B),H,j),void 0,j)}registerSelectionRangeProvider(k,B,H){const j=this._addNewAdapter(new Ie(this._documents,H,this._logService),k);return this._proxy.$registerSelectionRangeProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideSelectionRanges(k,B,H,j){return this._withAdapter(k,Ie,oe=>oe.provideSelectionRanges(o.URI.revive(B),H,j),[],j)}registerCallHierarchyProvider(k,B,H){const j=this._addNewAdapter(new Se(this._documents,H),k);return this._proxy.$registerCallHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareCallHierarchy(k,B,H,j){return this._withAdapter(k,Se,oe=>Promise.resolve(oe.prepareSession(o.URI.revive(B),H,j)),void 0,j)}$provideCallHierarchyIncomingCalls(k,B,H,j){return this._withAdapter(k,Se,oe=>oe.provideCallsTo(B,H,j),void 0,j)}$provideCallHierarchyOutgoingCalls(k,B,H,j){return this._withAdapter(k,Se,oe=>oe.provideCallsFrom(B,H,j),void 0,j)}$releaseCallHierarchy(k,B){this._withAdapter(k,Se,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerTypeHierarchyProvider(k,B,H){const j=this._addNewAdapter(new Te(this._documents,H),k);return this._proxy.$registerTypeHierarchyProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$prepareTypeHierarchy(k,B,H,j){return this._withAdapter(k,Te,oe=>Promise.resolve(oe.prepareSession(o.URI.revive(B),H,j)),void 0,j)}$provideTypeHierarchySupertypes(k,B,H,j){return this._withAdapter(k,Te,oe=>oe.provideSupertypes(B,H,j),void 0,j)}$provideTypeHierarchySubtypes(k,B,H,j){return this._withAdapter(k,Te,oe=>oe.provideSubtypes(B,H,j),void 0,j)}$releaseTypeHierarchy(k,B){this._withAdapter(k,Te,H=>Promise.resolve(H.releaseSession(B)),void 0,void 0)}registerDocumentOnDropEditProvider(k,B,H){const j=this._nextHandle();return this._adapter.set(j,new le(new ae(this._proxy,this._documents,H,j),k)),this._proxy.$registerDocumentOnDropEditProvider(j,this._transformDocumentSelector(B)),this._createDisposable(j)}$provideDocumentOnDropEdits(k,B,H,j,oe,ue){return this._withAdapter(k,ae,Z=>Promise.resolve(Z.provideDocumentOnDropEdits(B,o.URI.revive(H),j,oe,ue)),void 0,void 0)}registerDocumentPasteEditProvider(k,B,H,j){const oe=this._nextHandle();return this._adapter.set(oe,new le(new z(this._proxy,this._documents,H,oe),k)),this._proxy.$registerPasteEditProvider(oe,this._transformDocumentSelector(B),!!H.prepareDocumentPaste,j.pasteMimeTypes),this._createDisposable(oe)}$prepareDocumentPaste(k,B,H,j,oe){return this._withAdapter(k,z,ue=>ue.prepareDocumentPaste(o.URI.revive(B),H,j,oe),void 0,oe)}$providePasteEdits(k,B,H,j,oe,ue){return this._withAdapter(k,z,Z=>Z.providePasteEdits(B,o.URI.revive(H),j,oe,ue),void 0,ue)}static _serializeRegExp(k){return{pattern:k.source,flags:(0,E.regExpFlags)(k)}}static _serializeIndentationRule(k){return{decreaseIndentPattern:X._serializeRegExp(k.decreaseIndentPattern),increaseIndentPattern:X._serializeRegExp(k.increaseIndentPattern),indentNextLinePattern:k.indentNextLinePattern?X._serializeRegExp(k.indentNextLinePattern):void 0,unIndentedLinePattern:k.unIndentedLinePattern?X._serializeRegExp(k.unIndentedLinePattern):void 0}}static _serializeOnEnterRule(k){return{beforeText:X._serializeRegExp(k.beforeText),afterText:k.afterText?X._serializeRegExp(k.afterText):void 0,previousLineText:k.previousLineText?X._serializeRegExp(k.previousLineText):void 0,action:k.action}}static _serializeOnEnterRules(k){return k.map(X._serializeOnEnterRule)}setLanguageConfiguration(k,B,H){const{wordPattern:j}=H;if(j&&(0,E.regExpLeadsToEndlessLoop)(j))throw new Error(`Invalid language configuration: wordPattern '${j}' is not allowed to match the empty string.`);j?this._documents.setWordDefinitionFor(B,j):this._documents.setWordDefinitionFor(B,void 0),H.__electricCharacterSupport&&this._apiDeprecation.report("LanguageConfiguration.__electricCharacterSupport",k,"Do not use."),H.__characterPairSupport&&this._apiDeprecation.report("LanguageConfiguration.__characterPairSupport",k,"Do not use.");const oe=this._nextHandle(),ue={comments:H.comments,brackets:H.brackets,wordPattern:H.wordPattern?X._serializeRegExp(H.wordPattern):void 0,indentationRules:H.indentationRules?X._serializeIndentationRule(H.indentationRules):void 0,onEnterRules:H.onEnterRules?X._serializeOnEnterRules(H.onEnterRules):void 0,__electricCharacterSupport:H.__electricCharacterSupport,__characterPairSupport:H.__characterPairSupport};return this._proxy.$setLanguageConfiguration(oe,B,ue),this._createDisposable(oe)}$setWordDefinitions(k){for(const B of k)this._documents.setWordDefinitionFor(B.languageId,new RegExp(B.regexSource,B.regexFlags))}}e.ExtHostLanguageFeatures=X,X._handlePool=0}),define(De[203],Ce([1,0,5,8,6,29,13,7]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLanguages=void 0;class E{constructor(R,y,m,I){this._documents=y,this._commands=m,this._uriTransformer=I,this._languageIds=[],this._handlePool=0,this._ids=new Set,this._proxy=R.getProxy(o.MainContext.MainThreadLanguages)}$acceptLanguageIds(R){this._languageIds=R}async getLanguages(){return this._languageIds.slice(0)}async changeLanguage(R,y){await this._proxy.$changeLanguage(R,y);const m=this._documents.getDocumentData(R);if(!m)throw new Error(`document '${R.toString()}' NOT found`);return m.document}async tokenAtPosition(R,y){const m=R.version,I=p.Position.from(y),f=await this._proxy.$tokensAtPosition(R.uri,I),h={type:b.StandardTokenType.Other,range:R.getWordRangeAtPosition(y)??new b.Range(y.line,y.character,y.line,y.character)};if(!f)return h;const d={range:p.Range.to(f.range),type:p.TokenType.to(f.type)};return!d.range.contains(y)||m!==R.version?h:d}createLanguageStatusItem(R,y,m){const I=this._handlePool++,f=this._proxy,h=this._ids,d=`${R.identifier.value}/${y}`;if(h.has(d))throw new Error(`LanguageStatusItem with id '${y}' ALREADY exists`);h.add(d);const a={selector:m,id:y,name:R.displayName??R.name,severity:b.LanguageStatusSeverity.Information,command:void 0,text:"",detail:"",busy:!1};let v;const A=new T.DisposableStore,l=()=>{v?.dispose(),v=(0,D.disposableTimeout)(()=>{A.clear(),this._proxy.$setLanguageStatus(I,{id:d,name:a.name??R.displayName??R.name,source:R.displayName??R.name,selector:p.DocumentSelector.from(a.selector,this._uriTransformer),label:a.text,detail:a.detail??"",severity:a.severity===b.LanguageStatusSeverity.Error?L.default.Error:a.severity===b.LanguageStatusSeverity.Warning?L.default.Warning:L.default.Info,command:a.command&&this._commands.toInternal(a.command,A),accessibilityInfo:a.accessibilityInformation,busy:a.busy})},0)},_={dispose(){A.dispose(),v?.dispose(),f.$removeLanguageStatus(I),h.delete(d)},get id(){return a.id},get name(){return a.name},set name(s){a.name=s,l()},get selector(){return a.selector},set selector(s){a.selector=s,l()},get text(){return a.text},set text(s){a.text=s,l()},get detail(){return a.detail},set detail(s){a.detail=s,l()},get severity(){return a.severity},set severity(s){a.severity=s,l()},get accessibilityInformation(){return a.accessibilityInformation},set accessibilityInformation(s){a.accessibilityInformation=s,l()},get command(){return a.command},set command(s){a.command=s,l()},get busy(){return a.busy},set busy(s){a.busy=s,l()}};return l(),_}}e.ExtHostLanguages=E}),define(De[204],Ce([1,0,14,5,28,15,4]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostLoggerService=void 0;let T=class extends o.AbstractLoggerService{constructor(R,y){const m=new D.Emitter;super(y.logLevel,m.event);this._proxy=R.getProxy(p.MainContext.MainThreadLogger),this._onDidChangeLogLevel=this._register(m)}$setLevel(R){this._onDidChangeLogLevel.fire(R)}doCreateLogger(R,y,m){return new E(this._proxy,R,y,m)}};T=ze([xe(0,L.IExtHostRpcService),xe(1,b.IExtHostInitDataService)],T),e.ExtHostLoggerService=T;class E extends o.AbstractMessageLogger{constructor(R,y,m,I){super(I?.always);this.proxy=R,this.file=y,this.isLoggerCreated=!1,this.buffer=[],this.setLevel(m),this.proxy.$createLogger(y,I).then(()=>{this.doLog(this.buffer),this.isLoggerCreated=!0})}log(R,y){const m=[[R,y]];this.isLoggerCreated?this.doLog(m):this.buffer.push(...m)}doLog(R){this.proxy.$log(this.file,R)}}}),define(De[205],Ce([1,0,5,14,24]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostMessageService=void 0;function L(T){return T&&T.title}let D=class{constructor(E,P){this._logService=P,this._proxy=E.getProxy(o.MainContext.MainThreadMessageService)}showMessage(E,P,R,y,m){const I={source:{identifier:E.identifier,label:E.displayName||E.name}};let f;typeof y=="string"||L(y)?f=[y,...m]:(I.modal=y?.modal,I.useCustom=y?.useCustom,I.detail=y?.detail,f=m),I.useCustom&&(0,b.checkProposedApiEnabled)(E,"resolvers");const h=[];for(let d=0;d<f.length;d++){const a=f[d];if(typeof a=="string")h.push({title:a,handle:d,isCloseAffordance:!1});else if(typeof a=="object"){const{title:v,isCloseAffordance:A}=a;h.push({title:v,isCloseAffordance:!!A,handle:d})}else this._logService.warn("Invalid message item:",a)}return this._proxy.$showMessage(P,R,I,h).then(d=>{if(typeof d=="number")return f[d]})}};D=ze([xe(1,p.ILogService)],D),e.ExtHostMessageService=D}),define(De[206],Ce([1,0,22,4,96,7,25,9,10,2,61,5,36,8,6,40,174,91]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookController=void 0;class v{constructor(l,_,s,u,n){this._textDocumentsAndEditors=s,this._textDocuments=u,this._extensionStoragePaths=n,this._notebookContentProviders=new Map,this._notebookStatusBarItemProviders=new Map,this._documents=new D.ResourceMap,this._editors=new Map,this._onDidChangeActiveNotebookEditor=new p.Emitter,this.onDidChangeActiveNotebookEditor=this._onDidChangeActiveNotebookEditor.event,this._visibleNotebookEditors=[],this._onDidOpenNotebookDocument=new p.Emitter,this.onDidOpenNotebookDocument=this._onDidOpenNotebookDocument.event,this._onDidCloseNotebookDocument=new p.Emitter,this.onDidCloseNotebookDocument=this._onDidCloseNotebookDocument.event,this._onDidChangeVisibleNotebookEditors=new p.Emitter,this.onDidChangeVisibleNotebookEditors=this._onDidChangeVisibleNotebookEditors.event,this._statusBarCache=new R.Cache("NotebookCellStatusBarCache"),this._handlePool=0,this._notebookSerializer=new Map,this._backupIdPool=0,this._notebookProxy=l.getProxy(y.MainContext.MainThreadNotebook),this._notebookDocumentsProxy=l.getProxy(y.MainContext.MainThreadNotebookDocuments),this._notebookEditorsProxy=l.getProxy(y.MainContext.MainThreadNotebookEditors),this._commandsConverter=_.converter,_.registerArgumentProcessor({processArgument:i=>{if(i&&i.$mid===12){const r=i.notebookEditor?.notebookUri,t=i.cell.handle,w=this._documents.get(r)?.getCell(t);if(w)return w.apiCell}return i}}),v._registerApiCommands(_)}get activeNotebookEditor(){return this._activeNotebookEditor?.apiEditor}get visibleNotebookEditors(){return this._visibleNotebookEditors.map(l=>l.apiEditor)}getEditorById(l){const _=this._editors.get(l);if(!_)throw new Error(`unknown text editor: ${l}. known editors: ${[...this._editors.keys()]} `);return _}getIdByEditor(l){for(const[_,s]of this._editors)if(s.apiEditor===l)return _}get notebookDocuments(){return[...this._documents.values()]}getNotebookDocument(l,_){const s=this._documents.get(l);if(!s&&!_)throw new Error(`NO notebook document for '${l}'`);return s}_getProviderData(l){const _=this._notebookContentProviders.get(l);if(!_)throw new Error(`NO provider for '${l}'`);return _}registerNotebookContentProvider(l,_,s,u,n){if((0,T.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");if(this._notebookContentProviders.has(_))throw new Error(`Notebook provider for '${_}' already registered`);this._notebookContentProviders.set(_,{extension:l,provider:s});let i;return s.onDidChangeNotebookContentOptions&&(i=s.onDidChangeNotebookContentOptions(()=>{const r=I.NotebookDocumentContentOptions.from(s.options);this._notebookProxy.$updateNotebookProviderOptions(_,r)})),this._notebookProxy.$registerNotebookProvider({id:l.identifier,location:l.extensionLocation},_,I.NotebookDocumentContentOptions.from(u),v._convertNotebookRegistrationData(l,n)),new f.Disposable(()=>{i?.dispose(),this._notebookContentProviders.delete(_),this._notebookProxy.$unregisterNotebookProvider(_)})}static _convertNotebookRegistrationData(l,_){if(!_)return;const s=_.filenamePattern.map(u=>I.NotebookExclusiveDocumentPattern.from(u)).filter(u=>u!==void 0);if(_.filenamePattern&&!s){console.warn(`Notebook content provider view options file name pattern is invalid ${_.filenamePattern}`);return}return{extension:l.identifier,providerDisplayName:l.displayName||l.name,displayName:_.displayName,filenamePattern:s,exclusive:_.exclusive||!1}}registerNotebookCellStatusBarItemProvider(l,_,s){const u=v._notebookStatusBarItemProviderHandlePool++,n=typeof s.onDidChangeCellStatusBarItems=="function"?v._notebookStatusBarItemProviderHandlePool++:void 0;this._notebookStatusBarItemProviders.set(u,s),this._notebookProxy.$registerNotebookCellStatusBarItemProvider(u,n,_);let i;return n!==void 0&&(i=s.onDidChangeCellStatusBarItems(r=>this._notebookProxy.$emitCellStatusBarEvent(n))),new f.Disposable(()=>{this._notebookStatusBarItemProviders.delete(u),this._notebookProxy.$unregisterNotebookCellStatusBarItemProvider(u,n),i?.dispose()})}async createNotebookDocument(l){const _=await this._notebookDocumentsProxy.$tryCreateNotebook({viewType:l.viewType,content:l.content&&I.NotebookData.from(l.content)});return P.URI.revive(_)}async openNotebookDocument(l){const _=this._documents.get(l);if(_)return _.apiNotebook;const s=await this._notebookDocumentsProxy.$tryOpenNotebook(l),u=this._documents.get(P.URI.revive(s));return(0,E.assertIsDefined)(u?.apiNotebook)}async showNotebookDocument(l,_){P.URI.isUri(l)&&(l=await this.openNotebookDocument(l));let s;typeof _=="object"?s={position:I.ViewColumn.from(_.viewColumn),preserveFocus:_.preserveFocus,selections:_.selections&&_.selections.map(I.NotebookRange.from),pinned:typeof _.preview=="boolean"?!_.preview:void 0}:s={preserveFocus:!1};const u=await this._notebookEditorsProxy.$tryShowNotebookDocument(l.uri,l.notebookType,s),n=u&&this._editors.get(u)?.apiEditor;if(n)return n;throw u?new Error(`Could NOT open editor for "${l.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${l.uri.toString()}".`)}async $provideNotebookCellStatusBarItems(l,_,s,u){const n=this._notebookStatusBarItemProviders.get(l),i=P.URI.revive(_),r=this._documents.get(i);if(!r||!n)return;const t=r.getCellFromIndex(s);if(!t)return;const c=await n.provideCellStatusBarItems(t.apiCell,u);if(!c)return;const w=new L.DisposableStore,g=this._statusBarCache.add([w]),U=(Array.isArray(c)?c:[c]).map(W=>I.NotebookStatusBarItem.from(W,this._commandsConverter,w));return{cacheId:g,items:U}}$releaseNotebookCellStatusBarItems(l){this._statusBarCache.delete(l)}registerNotebookSerializer(l,_,s,u,n){if((0,T.isFalsyOrWhitespace)(_))throw new Error("viewType cannot be empty or just whitespace");const i=this._handlePool++;return this._notebookSerializer.set(i,s),this._notebookProxy.$registerNotebookSerializer(i,{id:l.identifier,location:l.extensionLocation},_,I.NotebookDocumentContentOptions.from(u),v._convertNotebookRegistrationData(l,n)),(0,L.toDisposable)(()=>{this._notebookProxy.$unregisterNotebookSerializer(i)})}async $dataToNotebook(l,_,s){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const n=await u.deserializeNotebook(_.buffer,s);return new h.SerializableObjectWithBuffers(I.NotebookData.from(n))}async $notebookToData(l,_,s){const u=this._notebookSerializer.get(l);if(!u)throw new Error("NO serializer found");const n=await u.serializeNotebook(I.NotebookData.to(_.value),s);return o.VSBuffer.wrap(n)}async $openNotebook(l,_,s,u,n){const{provider:i}=this._getProviderData(l),r=await i.openNotebook(P.URI.revive(_),{backupId:s,untitledDocumentData:u?.buffer},n);return new h.SerializableObjectWithBuffers({metadata:r.metadata??Object.create(null),cells:r.cells.map(I.NotebookCellData.from)})}async $saveNotebook(l,_,s){const u=this.getNotebookDocument(P.URI.revive(_)),{provider:n}=this._getProviderData(l);return await n.saveNotebook(u.apiNotebook,s),!0}async $saveNotebookAs(l,_,s,u){const n=this.getNotebookDocument(P.URI.revive(_)),{provider:i}=this._getProviderData(l);return await i.saveNotebookAs(P.URI.revive(s),n.apiNotebook,u),!0}async $backupNotebook(l,_,s){const u=this.getNotebookDocument(P.URI.revive(_)),n=this._getProviderData(l),i=this._extensionStoragePaths.workspaceValue(n.extension)??this._extensionStoragePaths.globalValue(n.extension),r=String((0,b.hash)([u.uri.toString(),this._backupIdPool++])),t=P.URI.joinPath(i,r),c=await n.provider.backupNotebook(u.apiNotebook,{destination:t},s);return u.updateBackup(c),c.id}_createExtHostEditor(l,_,s){if(this._editors.has(_))throw new Error(`editor with id ALREADY EXSIST: ${_}`);const u=new a.ExtHostNotebookEditor(_,this._notebookEditorsProxy,l,s.visibleRanges.map(I.NotebookRange.to),s.selections.map(I.NotebookRange.to),typeof s.viewColumn=="number"?I.ViewColumn.to(s.viewColumn):void 0);this._editors.set(_,u)}$acceptDocumentAndEditorsDelta(l){if(l.value.removedDocuments)for(const s of l.value.removedDocuments){const u=P.URI.revive(s),n=this._documents.get(u);n&&(n.dispose(),this._documents.delete(u),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({removedDocuments:n.apiNotebook.getCells().map(i=>i.document.uri)}),this._onDidCloseNotebookDocument.fire(n.apiNotebook));for(const i of this._editors.values())i.notebookData.uri.toString()===u.toString()&&this._editors.delete(i.id)}if(l.value.addedDocuments){const s=[];for(const u of l.value.addedDocuments){const n=P.URI.revive(u.uri);if(this._documents.has(n))throw new Error(`adding EXISTING notebook ${n} `);const i=new d.ExtHostNotebookDocument(this._notebookDocumentsProxy,this._textDocumentsAndEditors,this._textDocuments,n,u);s.push(...u.cells.map(r=>d.ExtHostCell.asModelAddData(i.apiNotebook,r))),this._documents.get(n)?.dispose(),this._documents.set(n,i),this._textDocumentsAndEditors.$acceptDocumentsAndEditorsDelta({addedDocuments:s}),this._onDidOpenNotebookDocument.fire(i.apiNotebook)}}if(l.value.addedEditors)for(const s of l.value.addedEditors){if(this._editors.has(s.id))return;const u=P.URI.revive(s.documentUri),n=this._documents.get(u);n&&this._createExtHostEditor(n,s.id,s)}const _=[];if(l.value.removedEditors)for(const s of l.value.removedEditors){const u=this._editors.get(s);u&&(this._editors.delete(s),this._activeNotebookEditor?.id===u.id&&(this._activeNotebookEditor=void 0),_.push(u))}if(l.value.visibleEditors){this._visibleNotebookEditors=l.value.visibleEditors.map(u=>this._editors.get(u)).filter(u=>!!u);const s=new Set;this._visibleNotebookEditors.forEach(u=>s.add(u.id));for(const u of this._editors.values()){const n=s.has(u.id);u._acceptVisibility(n)}this._visibleNotebookEditors=[...this._editors.values()].map(u=>u).filter(u=>u.visible),this._onDidChangeVisibleNotebookEditors.fire(this.visibleNotebookEditors)}l.value.newActiveEditor===null?this._activeNotebookEditor=void 0:l.value.newActiveEditor&&(this._activeNotebookEditor=this._editors.get(l.value.newActiveEditor)),l.value.newActiveEditor!==void 0&&this._onDidChangeActiveNotebookEditor.fire(this._activeNotebookEditor?.apiEditor)}static _registerApiCommands(l){const _=m.ApiCommandArgument.String.with("notebookType","A notebook type"),s=new m.ApiCommand("vscode.executeDataToNotebook","_executeDataToNotebook","Invoke notebook serializer",[_,new m.ApiCommandArgument("data","Bytes to convert to data",n=>n instanceof Uint8Array,n=>o.VSBuffer.wrap(n))],new m.ApiCommandResult("Notebook Data",n=>I.NotebookData.to(n.value))),u=new m.ApiCommand("vscode.executeNotebookToData","_executeNotebookToData","Invoke notebook serializer",[_,new m.ApiCommandArgument("NotebookData","Notebook data to convert to bytes",n=>!0,n=>new h.SerializableObjectWithBuffers(I.NotebookData.from(n)))],new m.ApiCommandResult("Bytes",n=>n.buffer));l.registerApiCommand(s),l.registerApiCommand(u)}}e.ExtHostNotebookController=v,v._notebookStatusBarItemProviderHandlePool=0}),define(De[207],Ce([1,0,16,13,20,4,7,25,2,27,14,5,36,8,6,64,168,24,40]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createKernelId=e.ExtHostNotebookKernels=void 0;let A=class{constructor(i,r,t,c,w){this._initData=r,this._extHostNotebook=t,this._commands=c,this._logService=w,this._activeExecutions=new T.ResourceMap,this._kernelData=new Map,this._handlePool=0,this._onDidChangeCellExecutionState=new L.Emitter,this.onDidChangeNotebookCellExecutionState=this._onDidChangeCellExecutionState.event,this._proxy=i.getProxy(y.MainContext.MainThreadNotebookKernels);const g=new m.ApiCommand("notebook.selectKernel","_notebook.selectKernel","Trigger kernel picker for specified notebook editor widget",[new m.ApiCommandArgument("options","Select kernel options",C=>!0,C=>{if(C&&"notebookEditor"in C&&"id"in C){const U=this._extHostNotebook.getIdByEditor(C.notebookEditor);return{id:C.id,extension:C.extension,notebookEditorId:U}}else if(C&&"notebookEditor"in C){const U=this._extHostNotebook.getIdByEditor(C.notebookEditor);if(U===void 0)throw new Error(`Cannot invoke 'notebook.selectKernel' for unrecognized notebook editor ${C.notebookEditor.document.uri.toString()}`);return{notebookEditorId:U}}return C})],m.ApiCommandResult.Void);this._commands.registerApiCommand(g)}createNotebookController(i,r,t,c,w,g){for(const fe of this._kernelData.values())if(fe.controller.id===r&&P.ExtensionIdentifier.equals(i.identifier,fe.extensionId))throw new Error(`notebook controller with id '${r}' ALREADY exist`);const C=this._handlePool++,U=this;this._logService.trace(`NotebookController[${C}], CREATED by ${i.identifier.value}, ${r}`);const W=()=>console.warn(`NO execute handler from notebook controller '${N.id}' of extension: '${i.identifier}'`);let M=!1;const S=new D.DisposableStore,z=new L.Emitter,$=new L.Emitter,N={id:u(i.identifier,r),notebookType:t,extensionId:i.identifier,extensionLocation:i.extensionLocation,label:c||i.identifier.value,preloads:g?g.map(I.NotebookRendererScript.from):[]};let K=w??W,V;this._proxy.$addKernel(C,N).catch(fe=>{console.log(fe),M=!0});let F=0;const ne=()=>{if(M)return;const fe=++F;Promise.resolve().then(()=>{fe===F&&this._proxy.$updateKernel(C,N)})},ce=new T.ResourceMap,re={get id(){return r},get notebookType(){return N.notebookType},onDidChangeSelectedNotebooks:z.event,get label(){return N.label},set label(fe){N.label=fe??i.displayName??i.name,ne()},get detail(){return N.detail??""},set detail(fe){N.detail=fe,ne()},get description(){return N.description??""},set description(fe){N.description=fe,ne()},get kind(){return(0,a.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind??""},set kind(fe){(0,a.checkProposedApiEnabled)(i,"notebookControllerKind"),N.kind=fe,ne()},get supportedLanguages(){return N.supportedLanguages},set supportedLanguages(fe){N.supportedLanguages=fe,ne()},get supportsExecutionOrder(){return N.supportsExecutionOrder??!1},set supportsExecutionOrder(fe){N.supportsExecutionOrder=fe,ne()},get rendererScripts(){return N.preloads?N.preloads.map(I.NotebookRendererScript.to):[]},get executeHandler(){return K},set executeHandler(fe){K=fe??W},get interruptHandler(){return V},set interruptHandler(fe){V=fe,N.supportsInterrupt=Boolean(fe),ne()},createNotebookCellExecution(fe){if(M)throw new Error("notebook controller is DISPOSED");if(!ce.has(fe.notebook.uri))throw U._logService.trace(`NotebookController[${C}] NOT associated to notebook, associated to THESE notebooks:`,Array.from(ce.keys()).map(ie=>ie.toString())),new Error(`notebook controller is NOT associated to notebook: ${fe.notebook.uri.toString()}`);return U._createNotebookCellExecution(fe,u(i.identifier,this.id))},dispose:()=>{M||(this._logService.trace(`NotebookController[${C}], DISPOSED`),M=!0,this._kernelData.delete(C),S.dispose(),z.dispose(),$.dispose(),this._proxy.$removeKernel(C))},updateNotebookAffinity(fe,ie){U._proxy.$updateNotebookPriority(C,fe.uri,ie)},onDidReceiveMessage:$.event,postMessage(fe,ie){return(0,a.checkProposedApiEnabled)(i,"notebookMessaging"),U._proxy.$postMessage(C,ie&&U._extHostNotebook.getIdByEditor(ie),fe)},asWebviewUri(fe){return(0,a.checkProposedApiEnabled)(i,"notebookMessaging"),(0,h.asWebviewUri)(fe,U._initData.remote)}};return this._kernelData.set(C,{extensionId:i.identifier,controller:re,onDidReceiveMessage:$,onDidChangeSelection:z,associatedNotebooks:ce}),re}getIdByController(i){for(const[r,t]of this._kernelData)if(t.controller===i)return u(t.extensionId,i.id);return null}$acceptNotebookAssociation(i,r,t){const c=this._kernelData.get(i);if(c){const w=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));t?c.associatedNotebooks.set(w.uri,!0):c.associatedNotebooks.delete(w.uri),this._logService.trace(`NotebookController[${i}] ASSOCIATE notebook`,w.uri.toString(),t),c.onDidChangeSelection.fire({selected:t,notebook:w.apiNotebook})}}async $executeCells(i,r,t){const c=this._kernelData.get(i);if(!c)return;const w=this._extHostNotebook.getNotebookDocument(E.URI.revive(r)),g=[];for(const C of t){const U=w.getCell(C);U&&g.push(U.apiCell)}try{this._logService.trace(`NotebookController[${i}] EXECUTE cells`,w.uri.toString(),g.length),await c.controller.executeHandler.call(c.controller,g,w.apiNotebook,c.controller)}catch(C){this._logService.error(`NotebookController[${i}] execute cells FAILED`,C),console.error(C)}}async $cancelCells(i,r,t){const c=this._kernelData.get(i);if(!c)return;const w=this._extHostNotebook.getNotebookDocument(E.URI.revive(r));if(c.controller.interruptHandler)await c.controller.interruptHandler.call(c.controller,w.apiNotebook);else for(const g of t){const C=w.getCell(g);C&&this._activeExecutions.get(C.uri)?.cancel()}}$acceptKernelMessageFromRenderer(i,r,t){const c=this._kernelData.get(i);if(!c)return;const w=this._extHostNotebook.getEditorById(r);c.onDidReceiveMessage.fire(Object.freeze({editor:w.apiEditor,message:t}))}$cellExecutionChanged(i,r,t){const w=this._extHostNotebook.getNotebookDocument(E.URI.revive(i)).getCell(r);w&&this._onDidChangeCellExecutionState.fire({cell:w.apiCell,state:t?I.NotebookCellExecutionState.to(t):f.NotebookCellExecutionState.Idle})}_createNotebookCellExecution(i,r){if(i.index<0)throw new Error("CANNOT execute cell that has been REMOVED from notebook");const c=this._extHostNotebook.getNotebookDocument(i.notebook.uri).getCellFromApiCell(i);if(!c)throw new Error("invalid cell");if(this._activeExecutions.has(c.uri))throw new Error(`duplicate execution for ${c.uri}`);const w=new _(r,c,this._proxy);this._activeExecutions.set(c.uri,w);const g=w.onDidChangeState(()=>{w.state===l.Resolved&&(w.dispose(),g.dispose(),this._activeExecutions.delete(c.uri))});return w.asApiObject()}};A=ze([xe(4,R.ILogService)],A),e.ExtHostNotebookKernels=A;var l;(function(n){n[n.Init=0]="Init",n[n.Started=1]="Started",n[n.Resolved=2]="Resolved"})(l||(l={}));class _ extends D.Disposable{constructor(i,r,t){super();this._cell=r,this._proxy=t,this._handle=_.HANDLE++,this._onDidChangeState=new L.Emitter,this.onDidChangeState=this._onDidChangeState.event,this._state=l.Init,this._tokenSource=this._register(new b.CancellationTokenSource),this._collector=new s(10,c=>this.update(c)),this._executionOrder=r.internalMetadata.executionOrder,this._proxy.$createExecution(this._handle,i,this._cell.notebook.uri,this._cell.handle)}get state(){return this._state}cancel(){this._tokenSource.cancel()}async updateSoon(i){await this._collector.addItem(i)}async update(i){const r=Array.isArray(i)?i:[i];return this._proxy.$updateExecution(this._handle,new v.SerializableObjectWithBuffers(r))}verifyStateForOutput(){if(this._state===l.Init)throw new Error("Must call start before modifying cell output");if(this._state===l.Resolved)throw new Error("Cannot modify cell output after calling resolve")}cellIndexToHandle(i){let r=this._cell;if(i&&(r=this._cell.notebook.getCellFromApiCell(i)),!r)throw new Error("INVALID cell");return r.handle}validateAndConvertOutputs(i){return i.map(r=>{const t=f.NotebookCellOutput.ensureUniqueMimeTypes(r.items,!0);return t===r.items?I.NotebookCellOutput.from(r):I.NotebookCellOutput.from({items:t,id:r.id,metadata:r.metadata})})}async updateOutputs(i,r,t){const c=this.cellIndexToHandle(r),w=this.validateAndConvertOutputs((0,o.asArray)(i));return this.updateSoon({editType:d.CellExecutionUpdateType.Output,cellHandle:c,append:t,outputs:w})}async updateOutputItems(i,r,t){return i=f.NotebookCellOutput.ensureUniqueMimeTypes((0,o.asArray)(i),!0),this.updateSoon({editType:d.CellExecutionUpdateType.OutputItems,items:i.map(I.NotebookCellOutputItem.from),outputId:r.id,append:t})}asApiObject(){const i=this;return Object.freeze({get token(){return i._tokenSource.token},get cell(){return i._cell.apiCell},get executionOrder(){return i._executionOrder},set executionOrder(t){i._executionOrder=t,i.update([{editType:d.CellExecutionUpdateType.ExecutionState,executionOrder:i._executionOrder}])},start(t){if(i._state===l.Resolved||i._state===l.Started)throw new Error("Cannot call start again");i._state=l.Started,i._onDidChangeState.fire(),i.update({editType:d.CellExecutionUpdateType.ExecutionState,runStartTime:t})},end(t,c){if(i._state===l.Resolved)throw new Error("Cannot call resolve twice");i._state=l.Resolved,i._onDidChangeState.fire(),i._collector.flush(),i._proxy.$completeExecution(i._handle,new v.SerializableObjectWithBuffers({runEndTime:c,lastRunSuccess:t}))},clearOutput(t){return i.verifyStateForOutput(),i.updateOutputs([],t,!1)},appendOutput(t,c){return i.verifyStateForOutput(),i.updateOutputs(t,c,!0)},replaceOutput(t,c){return i.verifyStateForOutput(),i.updateOutputs(t,c,!1)},appendOutputItems(t,c){return i.verifyStateForOutput(),i.updateOutputItems(t,c,!0)},replaceOutputItems(t,c){return i.verifyStateForOutput(),i.updateOutputItems(t,c,!1)}})}}_.HANDLE=0;class s{constructor(i,r){this.delay=i,this.callback=r,this.batch=[],this.startedTimer=Date.now()}addItem(i){return this.batch.push(i),this.currentDeferred||(this.currentDeferred=new p.DeferredPromise,this.startedTimer=Date.now(),(0,p.timeout)(this.delay).then(()=>this.flush())),Date.now()-this.startedTimer>this.delay?this.flush():this.currentDeferred.p}flush(){if(this.batch.length===0||!this.currentDeferred)return Promise.resolve();const i=this.currentDeferred;this.currentDeferred=void 0;const r=this.batch;return this.batch=[],this.callback(r).finally(()=>i.complete())}}function u(n,i){return`${n.value}/${i}`}e.createKernelId=u}),define(De[208],Ce([1,0,4,5,91]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostNotebookRenderers=void 0;class L{constructor(T,E){this._extHostNotebook=E,this._rendererMessageEmitters=new Map,this.proxy=T.getProxy(p.MainContext.MainThreadNotebookRenderers)}$postRendererMessage(T,E,P){const R=this._extHostNotebook.getEditorById(T);this._rendererMessageEmitters.get(E)?.fire({editor:R.apiEditor,message:P})}createRendererMessaging(T,E){if(!T.contributes?.notebookRenderer?.some(R=>R.id===E))throw new Error(`Extensions may only call createRendererMessaging() for renderers they contribute (got ${E})`);return{onDidReceiveMessage:(R,y,m)=>this.getOrCreateEmitterFor(E).event(R,y,m),postMessage:(R,y)=>{b.ExtHostNotebookEditor.apiEditorsToExtHost.has(R)&&([R,y]=[y,R]);const m=y&&b.ExtHostNotebookEditor.apiEditorsToExtHost.get(y);return this.proxy.$postMessage(m?.id,E,R)}}}getOrCreateEmitterFor(T){let E=this._rendererMessageEmitters.get(T);return E||(E=new o.Emitter({onLastListenerRemove:()=>{E?.dispose(),this._rendererMessageEmitters.delete(T)}}),this._rendererMessageEmitters.set(T,E),E)}}e.ExtHostNotebookRenderers=L}),define(De[209],Ce([1,0,20,4,7,5,2,6,11,16,29,60]),function(te,e,o,p,b,L,D,T,E,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createExtHostQuickOpen=void 0;function m(I,f,h){const d=I.getProxy(L.MainContext.MainThreadQuickOpen);class a{constructor(r,t){this._sessions=new Map,this._instances=0,this._workspace=r,this._commands=t}showQuickPick(r,t,c=o.CancellationToken.None){this._onDidSelectItem=void 0;const w=Promise.resolve(r),g=++this._instances,C=d.$show(g,{title:t?.title,placeHolder:t?.placeHolder,matchOnDescription:t?.matchOnDescription,matchOnDetail:t?.matchOnDetail,ignoreFocusLost:t?.ignoreFocusOut,canPickMany:t?.canPickMany},c),U={},W=C.then(()=>U);return Promise.race([W,w]).then(M=>{if(M!==U)return w.then(S=>{const z=[];for(let $=0;$<S.length;$++){const N=S[$];typeof N=="string"?z.push({label:N,handle:$}):N.kind===T.QuickPickItemKind.Separator?z.push({type:"separator",label:N.label}):z.push({label:N.label,description:N.description,detail:N.detail,picked:N.picked,alwaysShow:N.alwaysShow,handle:$})}return t&&typeof t.onDidSelectItem=="function"&&(this._onDidSelectItem=$=>{t.onDidSelectItem(S[$])}),d.$setItems(g,z),C.then($=>{if(typeof $=="number")return S[$];if(Array.isArray($))return $.map(N=>S[N])})})}).then(void 0,M=>{if(!(0,E.isCancellationError)(M))return d.$setError(g,M),Promise.reject(M)})}$onItemSelected(r){this._onDidSelectItem?.(r)}showInput(r,t=o.CancellationToken.None){return this._validateInput=r?.validateInput,d.$input(r,typeof this._validateInput=="function",t).then(void 0,c=>{if(!(0,E.isCancellationError)(c))return Promise.reject(c)})}async $validateInput(r){if(!this._validateInput)return;const t=await this._validateInput(r);if(!t||typeof t=="string")return t;let c;switch(t.severity){case T.InputBoxValidationSeverity.Info:c=R.default.Info;break;case T.InputBoxValidationSeverity.Warning:c=R.default.Warning;break;case T.InputBoxValidationSeverity.Error:c=R.default.Error;break;default:c=t.message?R.default.Error:R.default.Ignore;break}return{content:t.message,severity:c}}async showWorkspaceFolderPick(r,t=o.CancellationToken.None){const c=await this._commands.executeCommand("_workbench.pickWorkspaceFolder",[r]);if(!c)return;const w=await this._workspace.getWorkspaceFolders2();if(!!w)return w.find(g=>g.uri.toString()===c.uri.toString())}createQuickPick(r){const t=new u(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}createInputBox(r){const t=new n(r,()=>this._sessions.delete(t._id));return this._sessions.set(t._id,t),t}$onDidChangeValue(r,t){this._sessions.get(r)?._fireDidChangeValue(t)}$onDidAccept(r){this._sessions.get(r)?._fireDidAccept()}$onDidChangeActive(r,t){const c=this._sessions.get(r);c instanceof u&&c._fireDidChangeActive(t)}$onDidChangeSelection(r,t){const c=this._sessions.get(r);c instanceof u&&c._fireDidChangeSelection(t)}$onDidTriggerButton(r,t){this._sessions.get(r)?._fireDidTriggerButton(t)}$onDidTriggerItemButton(r,t,c){const w=this._sessions.get(r);w instanceof u&&w._fireDidTriggerItemButton(t,c)}$onDidHide(r){this._sessions.get(r)?._fireDidHide()}}class v{constructor(r,t){this._extensionId=r,this._onDidDispose=t,this._id=u._nextId++,this._visible=!1,this._expectingHide=!1,this._enabled=!0,this._busy=!1,this._ignoreFocusOut=!0,this._value="",this._buttons=[],this._handlesToButtons=new Map,this._onDidAcceptEmitter=new p.Emitter,this._onDidChangeValueEmitter=new p.Emitter,this._onDidTriggerButtonEmitter=new p.Emitter,this._onDidHideEmitter=new p.Emitter,this._pendingUpdate={id:this._id},this._disposed=!1,this._disposables=[this._onDidTriggerButtonEmitter,this._onDidHideEmitter,this._onDidAcceptEmitter,this._onDidChangeValueEmitter],this.onDidChangeValue=this._onDidChangeValueEmitter.event,this.onDidAccept=this._onDidAcceptEmitter.event,this.onDidTriggerButton=this._onDidTriggerButtonEmitter.event,this.onDidHide=this._onDidHideEmitter.event}get title(){return this._title}set title(r){this._title=r,this.update({title:r})}get step(){return this._steps}set step(r){this._steps=r,this.update({step:r})}get totalSteps(){return this._totalSteps}set totalSteps(r){this._totalSteps=r,this.update({totalSteps:r})}get enabled(){return this._enabled}set enabled(r){this._enabled=r,this.update({enabled:r})}get busy(){return this._busy}set busy(r){this._busy=r,this.update({busy:r})}get ignoreFocusOut(){return this._ignoreFocusOut}set ignoreFocusOut(r){this._ignoreFocusOut=r,this.update({ignoreFocusOut:r})}get value(){return this._value}set value(r){this._value=r,this.update({value:r})}get placeholder(){return this._placeholder}set placeholder(r){this._placeholder=r,this.update({placeholder:r})}get buttons(){return this._buttons}set buttons(r){this._buttons=r.slice(),this._handlesToButtons.clear(),r.forEach((t,c)=>{const w=t===T.QuickInputButtons.Back?-1:c;this._handlesToButtons.set(w,t)}),this.update({buttons:r.map((t,c)=>({...s(t),tooltip:t.tooltip,handle:t===T.QuickInputButtons.Back?-1:c}))})}show(){this._visible=!0,this._expectingHide=!0,this.update({visible:!0})}hide(){this._visible=!1,this.update({visible:!1})}_fireDidAccept(){this._onDidAcceptEmitter.fire()}_fireDidChangeValue(r){this._value=r,this._onDidChangeValueEmitter.fire(r)}_fireDidTriggerButton(r){const t=this._handlesToButtons.get(r);t&&this._onDidTriggerButtonEmitter.fire(t)}_fireDidHide(){this._expectingHide&&(this._expectingHide=this._visible,this._onDidHideEmitter.fire())}dispose(){this._disposed||(this._disposed=!0,this._fireDidHide(),this._disposables=(0,b.dispose)(this._disposables),this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this._onDidDispose(),d.$dispose(this._id))}update(r){if(!this._disposed){for(const t of Object.keys(r)){const c=r[t];this._pendingUpdate[t]=c===void 0?null:c}"visible"in this._pendingUpdate?(this._updateTimeout&&(clearTimeout(this._updateTimeout),this._updateTimeout=void 0),this.dispatchUpdate()):this._visible&&!this._updateTimeout&&(this._updateTimeout=setTimeout(()=>{this._updateTimeout=void 0,this.dispatchUpdate()},0))}}dispatchUpdate(){d.$createOrUpdate(this._pendingUpdate),this._pendingUpdate={id:this._id}}}v._nextId=1;function A(i){if(i instanceof T.ThemeIcon)return{id:i.id};const r=_(i),t=l(i);return{dark:typeof r=="string"?D.URI.file(r):r,light:typeof t=="string"?D.URI.file(t):t}}function l(i){return typeof i=="object"&&"light"in i?i.light:i}function _(i){return typeof i=="object"&&"dark"in i?i.dark:i}function s(i){const r=A(i.iconPath);let t,c;return"id"in r?c=y.ThemeIcon.asClassName(r):t=r,{iconPath:t,iconClass:c}}class u extends v{constructor(r,t){super(r.identifier,t);this._items=[],this._handlesToItems=new Map,this._itemsToHandles=new Map,this._canSelectMany=!1,this._matchOnDescription=!0,this._matchOnDetail=!0,this._sortByLabel=!0,this._keepScrollPosition=!1,this._activeItems=[],this._onDidChangeActiveEmitter=new p.Emitter,this._selectedItems=[],this._onDidChangeSelectionEmitter=new p.Emitter,this._onDidTriggerItemButtonEmitter=new p.Emitter,this.onDidChangeActive=this._onDidChangeActiveEmitter.event,this.onDidChangeSelection=this._onDidChangeSelectionEmitter.event,this.onDidTriggerItemButton=this._onDidTriggerItemButtonEmitter.event,this._disposables.push(this._onDidChangeActiveEmitter,this._onDidChangeSelectionEmitter,this._onDidTriggerItemButtonEmitter),this.update({type:"quickPick"})}get items(){return this._items}set items(r){this._items=r.slice(),this._handlesToItems.clear(),this._itemsToHandles.clear(),r.forEach((c,w)=>{this._handlesToItems.set(w,c),this._itemsToHandles.set(c,w)});const t=[];for(let c=0;c<r.length;c++){const w=r[c];w.kind===T.QuickPickItemKind.Separator?t.push({type:"separator",label:w.label}):t.push({handle:c,label:w.label,description:w.description,detail:w.detail,picked:w.picked,alwaysShow:w.alwaysShow,buttons:w.buttons?.map((g,C)=>({...s(g),tooltip:g.tooltip,handle:C}))})}this.update({items:t})}get canSelectMany(){return this._canSelectMany}set canSelectMany(r){this._canSelectMany=r,this.update({canSelectMany:r})}get matchOnDescription(){return this._matchOnDescription}set matchOnDescription(r){this._matchOnDescription=r,this.update({matchOnDescription:r})}get matchOnDetail(){return this._matchOnDetail}set matchOnDetail(r){this._matchOnDetail=r,this.update({matchOnDetail:r})}get sortByLabel(){return this._sortByLabel}set sortByLabel(r){this._sortByLabel=r,this.update({sortByLabel:r})}get keepScrollPosition(){return this._keepScrollPosition}set keepScrollPosition(r){this._keepScrollPosition=r,this.update({keepScrollPosition:r})}get activeItems(){return this._activeItems}set activeItems(r){this._activeItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({activeItems:this._activeItems.map(t=>this._itemsToHandles.get(t))})}get selectedItems(){return this._selectedItems}set selectedItems(r){this._selectedItems=r.filter(t=>this._itemsToHandles.has(t)),this.update({selectedItems:this._selectedItems.map(t=>this._itemsToHandles.get(t))})}_fireDidChangeActive(r){const t=(0,P.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._activeItems=t,this._onDidChangeActiveEmitter.fire(t)}_fireDidChangeSelection(r){const t=(0,P.coalesce)(r.map(c=>this._handlesToItems.get(c)));this._selectedItems=t,this._onDidChangeSelectionEmitter.fire(t)}_fireDidTriggerItemButton(r,t){const c=this._handlesToItems.get(r);if(!c||!c.buttons||!c.buttons.length)return;const w=c.buttons[t];w&&this._onDidTriggerItemButtonEmitter.fire({button:w,item:c})}}class n extends v{constructor(r,t){super(r.identifier,t);this._password=!1,this.update({type:"inputBox"})}get password(){return this._password}set password(r){this._password=r,this.update({password:r})}get prompt(){return this._prompt}set prompt(r){this._prompt=r,this.update({prompt:r})}get validationMessage(){return this._validationMessage}set validationMessage(r){this._validationMessage=r,r?typeof r=="string"?this.update({validationMessage:r,severity:R.default.Error}):this.update({validationMessage:r.message,severity:r.severity??R.default.Error}):this.update({validationMessage:void 0,severity:R.default.Ignore})}}return new a(f,h)}e.createExtHostQuickOpen=m});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[210],Ce([1,0,2,4,54,7,13,5,16,116,14,27,60,8,24]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f){"use strict";var h,d;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostSCM=e.ExtHostSCMInputBox=void 0;function a(w){if(w)return typeof w.iconPath=="string"?o.URI.file(w.iconPath):o.URI.isUri(w.iconPath)||m.ThemeIcon.isThemeIcon(w.iconPath)?w.iconPath:void 0}function v(w,g){if(!w.iconPath&&!g.iconPath)return 0;if(w.iconPath){if(!g.iconPath)return 1}else return-1;const C=typeof w.iconPath=="string"?w.iconPath:o.URI.isUri(w.iconPath)?w.iconPath.fsPath:w.iconPath.id,U=typeof g.iconPath=="string"?g.iconPath:o.URI.isUri(g.iconPath)?g.iconPath.fsPath:g.iconPath.id;return(0,P.comparePaths)(C,U)}function A(w,g){let C=0;if(w.strikeThrough!==g.strikeThrough)return w.strikeThrough?1:-1;if(w.faded!==g.faded)return w.faded?1:-1;if(w.tooltip!==g.tooltip)return(w.tooltip||"").localeCompare(g.tooltip||"");if(C=v(w,g),C!==0)return C;if(w.light&&g.light)C=v(w.light,g.light);else{if(w.light)return 1;if(g.light)return-1}if(C!==0)return C;if(w.dark&&g.dark)C=v(w.dark,g.dark);else{if(w.dark)return 1;if(g.dark)return-1}return C}function l(w,g){if(w.command!==g.command)return w.command<g.command?-1:1;if(w.title!==g.title)return w.title<g.title?-1:1;if(w.tooltip!==g.tooltip){if(w.tooltip!==void 0&&g.tooltip!==void 0)return w.tooltip<g.tooltip?-1:1;if(w.tooltip!==void 0)return 1;if(g.tooltip!==void 0)return-1}if(w.arguments===g.arguments)return 0;if(w.arguments)if(g.arguments){if(w.arguments.length!==g.arguments.length)return w.arguments.length-g.arguments.length}else return 1;else return-1;for(let C=0;C<w.arguments.length;C++){const U=w.arguments[C],W=g.arguments[C];if(U!==W)return U<W?-1:1}return 0}function _(w,g){let C=(0,P.comparePaths)(w.resourceUri.fsPath,g.resourceUri.fsPath,!0);if(C!==0)return C;if(w.command&&g.command)C=l(w.command,g.command);else{if(w.command)return 1;if(g.command)return-1}if(C!==0)return C;if(w.decorations&&g.decorations)C=A(w.decorations,g.decorations);else{if(w.decorations)return 1;if(g.decorations)return-1}return C}function s(w,g){for(let C=0;C<w.length;C++)if(w[C]!==g[C])return!1;return!0}function u(w,g){return w.command===g.command&&w.title===g.title&&w.tooltip===g.tooltip&&(w.arguments&&g.arguments?s(w.arguments,g.arguments):w.arguments===g.arguments)}function n(w,g){return(0,E.equals)(w,g,u)}class i{constructor(g,C,U){this._extension=g,this._sourceControlHandle=U,h.set(this,void 0),this._value="",this._onDidChange=new p.Emitter,this._placeholder="",this._enabled=!0,this._visible=!0,Je(this,h,C,"f")}get value(){return this._value}set value(g){g=g??"",Oe(this,h,"f").$setInputBoxValue(this._sourceControlHandle,g),this.updateValue(g)}get onDidChange(){return this._onDidChange.event}get placeholder(){return this._placeholder}set placeholder(g){Oe(this,h,"f").$setInputBoxPlaceholder(this._sourceControlHandle,g),this._placeholder=g}get validateInput(){return(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),this._validateInput}set validateInput(g){if((0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),g&&typeof g!="function")throw new Error(`[${this._extension.identifier.value}]: Invalid SCM input box validation function`);this._validateInput=g,Oe(this,h,"f").$setValidationProviderIsEnabled(this._sourceControlHandle,!!g)}get enabled(){return this._enabled}set enabled(g){g=!!g,this._enabled!==g&&(this._enabled=g,Oe(this,h,"f").$setInputBoxEnablement(this._sourceControlHandle,g))}get visible(){return this._visible}set visible(g){g=!!g,this._visible!==g&&(this._visible=g,Oe(this,h,"f").$setInputBoxVisibility(this._sourceControlHandle,g))}showValidationMessage(g,C){(0,f.checkProposedApiEnabled)(this._extension,"scmValidation"),Oe(this,h,"f").$showValidationMessage(this._sourceControlHandle,g,C)}$onInputBoxValueChange(g){this.updateValue(g)}updateValue(g){this._value=g,this._onDidChange.fire(g)}}e.ExtHostSCMInputBox=i,h=new WeakMap;class r{constructor(g,C,U,W,M){this._proxy=g,this._commands=C,this._sourceControlHandle=U,this._id=W,this._label=M,this._resourceHandlePool=0,this._resourceStates=[],this._resourceStatesMap=new Map,this._resourceStatesCommandsMap=new Map,this._resourceStatesDisposablesMap=new Map,this._onDidUpdateResourceStates=new p.Emitter,this.onDidUpdateResourceStates=this._onDidUpdateResourceStates.event,this._disposed=!1,this._onDidDispose=new p.Emitter,this.onDidDispose=this._onDidDispose.event,this._handlesSnapshot=[],this._resourceSnapshot=[],this._hideWhenEmpty=void 0,this.handle=r._handlePool++}get disposed(){return this._disposed}get id(){return this._id}get label(){return this._label}set label(g){this._label=g,this._proxy.$updateGroupLabel(this._sourceControlHandle,this.handle,g)}get hideWhenEmpty(){return this._hideWhenEmpty}set hideWhenEmpty(g){this._hideWhenEmpty=g,this._proxy.$updateGroup(this._sourceControlHandle,this.handle,this.features)}get features(){return{hideWhenEmpty:this.hideWhenEmpty}}get resourceStates(){return[...this._resourceStates]}set resourceStates(g){this._resourceStates=[...g],this._onDidUpdateResourceStates.fire()}getResourceState(g){return this._resourceStatesMap.get(g)}$executeResourceCommand(g,C){const U=this._resourceStatesCommandsMap.get(g);return U?(0,D.asPromise)(()=>this._commands.executeCommand(U.command,...U.arguments||[],C)):Promise.resolve(void 0)}_takeResourceStateSnapshot(){const g=[...this._resourceStates].sort(_),U=(0,E.sortedDiff)(this._resourceSnapshot,g,_).map(S=>{const z=S.toInsert.map($=>{const N=this._resourceHandlePool++;this._resourceStatesMap.set(N,$);const K=$.resourceUri;let V;if($.command)if($.command.command==="vscode.open"||$.command.command==="vscode.diff"){const ve=new L.DisposableStore;V=this._commands.converter.toInternal($.command,ve),this._resourceStatesDisposablesMap.set(N,ve)}else this._resourceStatesCommandsMap.set(N,$.command);const F=a($.decorations),ne=$.decorations&&a($.decorations.light)||F,ce=$.decorations&&a($.decorations.dark)||F,re=[ne,ce],fe=$.decorations&&$.decorations.tooltip||"",ie=$.decorations&&!!$.decorations.strikeThrough,Ee=$.decorations&&!!$.decorations.faded,be=$.contextValue||"";return{rawResource:[N,K,re,fe,ie,Ee,be,V],handle:N}});return{start:S.start,deleteCount:S.deleteCount,toInsert:z}}),W=U.map(({start:S,deleteCount:z,toInsert:$})=>[S,z,$.map(N=>N.rawResource)]),M=U.reverse();for(const{start:S,deleteCount:z,toInsert:$}of M){const N=$.map(V=>V.handle),K=this._handlesSnapshot.splice(S,z,...N);for(const V of K)this._resourceStatesMap.delete(V),this._resourceStatesCommandsMap.delete(V),this._resourceStatesDisposablesMap.get(V)?.dispose(),this._resourceStatesDisposablesMap.delete(V)}return this._resourceSnapshot=g,W}dispose(){this._disposed=!0,this._onDidDispose.fire()}}r._handlePool=0;class t{constructor(g,C,U,W,M,S){this._extension=g,this._commands=U,this._id=W,this._label=M,this._rootUri=S,d.set(this,void 0),this._groups=new Map,this._count=void 0,this._quickDiffProvider=void 0,this._commitTemplate=void 0,this._acceptInputDisposables=new L.MutableDisposable,this._acceptInputCommand=void 0,this._actionButtonDisposables=new L.MutableDisposable,this._statusBarDisposables=new L.MutableDisposable,this._statusBarCommands=void 0,this._selected=!1,this._onDidChangeSelection=new p.Emitter,this.onDidChangeSelection=this._onDidChangeSelection.event,this.handle=t._handlePool++,this.createdResourceGroups=new Map,this.updatedResourceGroups=new Set,Je(this,d,C,"f"),this._inputBox=new i(g,Oe(this,d,"f"),this.handle),Oe(this,d,"f").$registerSourceControl(this.handle,W,M,S)}get id(){return this._id}get label(){return this._label}get rootUri(){return this._rootUri}get inputBox(){return this._inputBox}get count(){return this._count}set count(g){this._count!==g&&(this._count=g,Oe(this,d,"f").$updateSourceControl(this.handle,{count:g}))}get quickDiffProvider(){return this._quickDiffProvider}set quickDiffProvider(g){this._quickDiffProvider=g,Oe(this,d,"f").$updateSourceControl(this.handle,{hasQuickDiffProvider:!!g})}get commitTemplate(){return this._commitTemplate}set commitTemplate(g){g!==this._commitTemplate&&(this._commitTemplate=g,Oe(this,d,"f").$updateSourceControl(this.handle,{commitTemplate:g}))}get acceptInputCommand(){return this._acceptInputCommand}set acceptInputCommand(g){this._acceptInputDisposables.value=new L.DisposableStore,this._acceptInputCommand=g;const C=this._commands.converter.toInternal(g,this._acceptInputDisposables.value);Oe(this,d,"f").$updateSourceControl(this.handle,{acceptInputCommand:C})}get actionButton(){return(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButton}set actionButton(g){(0,f.checkProposedApiEnabled)(this._extension,"scmActionButton"),this._actionButtonDisposables.value=new L.DisposableStore,this._actionButton=g;const C=g!==void 0?{command:this._commands.converter.toInternal(g.command,this._actionButtonDisposables.value),secondaryCommands:g.secondaryCommands?.map(U=>U.map(W=>this._commands.converter.toInternal(W,this._actionButtonDisposables.value))),description:g.description,enabled:g.enabled}:void 0;Oe(this,d,"f").$updateSourceControl(this.handle,{actionButton:C??null})}get statusBarCommands(){return this._statusBarCommands}set statusBarCommands(g){if(this._statusBarCommands&&g&&n(this._statusBarCommands,g))return;this._statusBarDisposables.value=new L.DisposableStore,this._statusBarCommands=g;const C=(g||[]).map(U=>this._commands.converter.toInternal(U,this._statusBarDisposables.value));Oe(this,d,"f").$updateSourceControl(this.handle,{statusBarCommands:C})}get selected(){return this._selected}createResourceGroup(g,C){const U=new r(Oe(this,d,"f"),this._commands,this.handle,g,C),W=p.Event.once(U.onDidDispose)(()=>this.createdResourceGroups.delete(U));return this.createdResourceGroups.set(U,W),this.eventuallyAddResourceGroups(),U}eventuallyAddResourceGroups(){const g=[],C=[];for(const[U,W]of this.createdResourceGroups){W.dispose();const M=U.onDidUpdateResourceStates(()=>{this.updatedResourceGroups.add(U),this.eventuallyUpdateResourceStates()});p.Event.once(U.onDidDispose)(()=>{this.updatedResourceGroups.delete(U),M.dispose(),this._groups.delete(U.handle),Oe(this,d,"f").$unregisterGroup(this.handle,U.handle)}),g.push([U.handle,U.id,U.label,U.features]);const S=U._takeResourceStateSnapshot();S.length>0&&C.push([U.handle,S]),this._groups.set(U.handle,U)}Oe(this,d,"f").$registerGroups(this.handle,g,C),this.createdResourceGroups.clear()}eventuallyUpdateResourceStates(){const g=[];this.updatedResourceGroups.forEach(C=>{const U=C._takeResourceStateSnapshot();U.length!==0&&g.push([C.handle,U])}),g.length>0&&Oe(this,d,"f").$spliceResourceStates(this.handle,g),this.updatedResourceGroups.clear()}getResourceGroup(g){return this._groups.get(g)}setSelectionState(g){this._selected=g,this._onDidChangeSelection.fire(g)}dispose(){this._acceptInputDisposables.dispose(),this._actionButtonDisposables.dispose(),this._statusBarDisposables.dispose(),this._groups.forEach(g=>g.dispose()),Oe(this,d,"f").$unregisterSourceControl(this.handle)}}d=new WeakMap,t._handlePool=0,ze([(0,b.debounce)(100)],t.prototype,"eventuallyAddResourceGroups",null),ze([(0,b.debounce)(100)],t.prototype,"eventuallyUpdateResourceStates",null);let c=class Xi{constructor(g,C,U){this._commands=C,this.logService=U,this._sourceControls=new Map,this._sourceControlsByExtension=new Map,this._onDidChangeActiveProvider=new p.Emitter,this._proxy=g.getProxy(T.MainContext.MainThreadSCM),this._telemetry=g.getProxy(T.MainContext.MainThreadTelemetry),C.registerArgumentProcessor({processArgument:W=>{if(W&&W.$mid===3){const M=this._sourceControls.get(W.sourceControlHandle);if(!M)return W;const S=M.getResourceGroup(W.groupHandle);return S?S.getResourceState(W.handle):W}else if(W&&W.$mid===4){const M=this._sourceControls.get(W.sourceControlHandle);return M?M.getResourceGroup(W.groupHandle):W}else if(W&&W.$mid===5){const M=this._sourceControls.get(W.handle);return M||W}return W}})}get onDidChangeActiveProvider(){return this._onDidChangeActiveProvider.event}createSourceControl(g,C,U,W){this.logService.trace("ExtHostSCM#createSourceControl",g.identifier.value,C,U,W),this._telemetry.$publicLog2("api/scm/createSourceControl",{extensionId:g.identifier.value});const M=Xi._handlePool++,S=new t(g,this._proxy,this._commands,C,U,W);this._sourceControls.set(M,S);const z=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier))||[];return z.push(S),this._sourceControlsByExtension.set(y.ExtensionIdentifier.toKey(g.identifier),z),S}getLastInputBox(g){this.logService.trace("ExtHostSCM#getLastInputBox",g.identifier.value);const C=this._sourceControlsByExtension.get(y.ExtensionIdentifier.toKey(g.identifier)),U=C&&C[C.length-1];return U&&U.inputBox}$provideOriginalResource(g,C,U){const W=o.URI.revive(C);this.logService.trace("ExtHostSCM#$provideOriginalResource",g,W.toString());const M=this._sourceControls.get(g);return!M||!M.quickDiffProvider||!M.quickDiffProvider.provideOriginalResource?Promise.resolve(null):(0,D.asPromise)(()=>M.quickDiffProvider.provideOriginalResource(W,U)).then(S=>S||null)}$onInputBoxValueChange(g,C){this.logService.trace("ExtHostSCM#$onInputBoxValueChange",g);const U=this._sourceControls.get(g);return U&&U.inputBox.$onInputBoxValueChange(C),Promise.resolve(void 0)}$executeResourceCommand(g,C,U,W){this.logService.trace("ExtHostSCM#$executeResourceCommand",g,C,U);const M=this._sourceControls.get(g);if(!M)return Promise.resolve(void 0);const S=M.getResourceGroup(C);return S?S.$executeResourceCommand(U,W):Promise.resolve(void 0)}$validateInput(g,C,U){this.logService.trace("ExtHostSCM#$validateInput",g);const W=this._sourceControls.get(g);return!W||!W.inputBox.validateInput?Promise.resolve(void 0):(0,D.asPromise)(()=>W.inputBox.validateInput(C,U)).then(M=>{if(!M)return Promise.resolve(void 0);const S=I.MarkdownString.fromStrict(M.message);return S?Promise.resolve([S,M.type]):Promise.resolve(void 0)})}$setSelectedSourceControl(g){return this.logService.trace("ExtHostSCM#$setSelectedSourceControl",g),g!==void 0&&this._sourceControls.get(g)?.setSelectionState(!0),this._selectedSourceControlHandle!==void 0&&this._sourceControls.get(this._selectedSourceControlHandle)?.setSelectionState(!1),this._selectedSourceControlHandle=g,Promise.resolve(void 0)}};c._handlePool=0,c=ze([xe(2,R.ILogService)],c),e.ExtHostSCM=c});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[211],Ce([1,0,6,5,131,7,8,10]),function(te,e,o,p,b,L,D,T){"use strict";var E,P;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostStatusBar=e.ExtHostStatusBarEntry=void 0;class R{constructor(f,h,d,a,v=o.StatusBarAlignment.Left,A){E.set(this,void 0),P.set(this,void 0),this._disposed=!1,this._visible=!1,this._text="",this._internalCommandRegistration=new L.DisposableStore,Je(this,E,f,"f"),Je(this,P,h,"f"),this._entryId=R.ID_GEN++,this._extension=d,this._id=a,this._alignment=v,this._priority=this.validatePriority(A)}validatePriority(f){if(!!(0,T.isNumber)(f))return f===Number.POSITIVE_INFINITY?Number.MAX_VALUE:f===Number.NEGATIVE_INFINITY?-Number.MAX_VALUE:f}get id(){return this._id??this._extension.identifier.value}get alignment(){return this._alignment}get priority(){return this._priority}get text(){return this._text}get name(){return this._name}get tooltip(){return this._tooltip}get color(){return this._color}get backgroundColor(){return this._backgroundColor}get command(){return this._command?.fromApi}get accessibilityInformation(){return this._accessibilityInformation}set text(f){this._text=f,this.update()}set name(f){this._name=f,this.update()}set tooltip(f){this._tooltip=f,this.update()}set color(f){this._color=f,this.update()}set backgroundColor(f){f&&!R.ALLOWED_BACKGROUND_COLORS.has(f.id)&&(f=void 0),this._backgroundColor=f,this.update()}set command(f){this._command?.fromApi!==f&&(this._internalCommandRegistration.clear(),typeof f=="string"?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal({title:"",command:f},this._internalCommandRegistration)}:f?this._command={fromApi:f,internal:Oe(this,P,"f").toInternal(f,this._internalCommandRegistration)}:this._command=void 0,this.update())}set accessibilityInformation(f){this._accessibilityInformation=f,this.update()}show(){this._visible=!0,this.update()}hide(){clearTimeout(this._timeoutHandle),this._visible=!1,Oe(this,E,"f").$dispose(this._entryId)}update(){this._disposed||!this._visible||(clearTimeout(this._timeoutHandle),this._timeoutHandle=setTimeout(()=>{this._timeoutHandle=void 0;let f;this._extension?this._id?f=`${this._extension.identifier.value}.${this._id}`:f=this._extension.identifier.value:f=this._id;let h;this._name?h=this._name:h=(0,b.localize)(0,null,this._extension.displayName||this._extension.name);let d=this._color;this._backgroundColor&&(d=R.ALLOWED_BACKGROUND_COLORS.get(this._backgroundColor.id));const a=D.MarkdownString.fromStrict(this._tooltip);Oe(this,E,"f").$setEntry(this._entryId,f,h,this._text,a,this._command?.internal,d,this._backgroundColor,this._alignment===o.StatusBarAlignment.Left,this._priority,this._accessibilityInformation)},0))}dispose(){this.hide(),this._disposed=!0}}e.ExtHostStatusBarEntry=R,E=new WeakMap,P=new WeakMap,R.ID_GEN=0,R.ALLOWED_BACKGROUND_COLORS=new Map([["statusBarItem.errorBackground",new o.ThemeColor("statusBarItem.errorForeground")],["statusBarItem.warningBackground",new o.ThemeColor("statusBarItem.warningForeground")]]);class y{constructor(f){this._messages=[],this._item=f.createStatusBarEntry(void 0,"status.extensionMessage",o.StatusBarAlignment.Left,Number.MIN_VALUE),this._item.name=(0,b.localize)(1,null)}dispose(){this._messages.length=0,this._item.dispose()}setMessage(f){const h={message:f};return this._messages.unshift(h),this._update(),new o.Disposable(()=>{const d=this._messages.indexOf(h);d>=0&&(this._messages.splice(d,1),this._update())})}_update(){this._messages.length>0?(this._item.text=this._messages[0].message,this._item.show()):this._item.hide()}}class m{constructor(f,h){this._proxy=f.getProxy(p.MainContext.MainThreadStatusBar),this._commands=h,this._statusMessage=new y(this)}createStatusBarEntry(f,h,d,a){return new R(this._proxy,this._commands,f,h,d,a)}setStatusBarMessage(f,h){const d=this._statusMessage.setMessage(f);let a;return typeof h=="number"?a=setTimeout(()=>d.dispose(),h):typeof h!="undefined"&&h.then(()=>d.dispose(),()=>d.dispose()),new o.Disposable(()=>{d.dispose(),clearTimeout(a)})}}e.ExtHostStatusBar=m}),define(De[69],Ce([1,0,5,4,3]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostStorage=e.ExtHostStorage=void 0;class L{constructor(T){this._onDidChangeStorage=new p.Emitter,this.onDidChangeStorage=this._onDidChangeStorage.event,this._proxy=T.getProxy(o.MainContext.MainThreadStorage)}registerExtensionStorageKeysToSync(T,E){this._proxy.$registerExtensionStorageKeysToSync(T,E)}initializeExtensionStorage(T,E,P){return this._proxy.$initializeExtensionStorage(T,E).then(R=>R||P)}setValue(T,E,P){return this._proxy.$setValue(T,E,P)}$acceptValue(T,E,P){this._onDidChangeStorage.fire({shared:T,key:E,value:P})}}e.ExtHostStorage=L,e.IExtHostStorage=(0,b.createDecorator)("IExtHostStorage")}),define(De[70],Ce([1,0,3,28,14,51,2]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionStoragePaths=e.IExtensionStoragePaths=void 0,e.IExtensionStoragePaths=(0,o.createDecorator)("IExtensionStoragePaths");let T=class{constructor(P,R,y){this._logService=R,this._extHostFileSystem=y,this._workspace=P.workspace??void 0,this._environment=P.environment,this.whenReady=this._getOrCreateWorkspaceStoragePath().then(m=>this._value=m)}async _getWorkspaceStorageURI(P){return D.URI.joinPath(this._environment.workspaceStorageHome,P)}async _getOrCreateWorkspaceStoragePath(){if(!this._workspace)return Promise.resolve(void 0);const P=this._workspace.id,R=await this._getWorkspaceStorageURI(P);try{return await this._extHostFileSystem.value.stat(R),this._logService.trace("[ExtHostStorage] storage dir already exists",R),R}catch{}try{return this._logService.trace("[ExtHostStorage] creating dir and metadata-file",R),await this._extHostFileSystem.value.createDirectory(R),await this._extHostFileSystem.value.writeFile(D.URI.joinPath(R,"meta.json"),new TextEncoder().encode(JSON.stringify({id:this._workspace.id,configuration:D.URI.revive(this._workspace.configuration)?.toString(),name:this._workspace.name},void 0,2))),R}catch(y){this._logService.error("[ExtHostStorage]",y);return}}workspaceValue(P){if(this._value)return D.URI.joinPath(this._value,P.identifier.value)}globalValue(P){return D.URI.joinPath(this._environment.globalStorageHome,P.identifier.value.toLowerCase())}onWillDeactivateAll(){}};T=ze([xe(0,p.IExtHostInitDataService),xe(1,b.ILogService),xe(2,L.IExtHostConsumerFileSystem)],T),e.ExtensionStoragePaths=T}),define(De[52],Ce([1,0,4,5,3,2,15,7,6,132,11,169,20,42,153,60,10,13]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostTerminalService=e.EnvironmentVariableCollection=e.BaseExtHostTerminalService=e.ExtHostPseudoterminal=e.ExtHostTerminal=e.IExtHostTerminalService=void 0,e.IExtHostTerminalService=(0,b.createDecorator)("IExtHostTerminalService");class v{constructor(t,c,w,g){this._proxy=t,this._id=c,this._creationOptions=w,this._name=g,this._disposed=!1,this._state={isInteractedWith:!1},this.isOpen=!1,this._creationOptions=Object.freeze(this._creationOptions),this._pidPromise=new Promise(U=>this._pidPromiseComplete=U);const C=this;this.value={get name(){return C._name||""},get processId(){return C._pidPromise},get creationOptions(){return C._creationOptions},get exitStatus(){return C._exitStatus},get state(){return C._state},sendText(U,W=!0){C._checkDisposed(),C._proxy.$sendText(C._id,U,W)},show(U){C._checkDisposed(),C._proxy.$show(C._id,U)},hide(){C._checkDisposed(),C._proxy.$hide(C._id)},dispose(){C._disposed||(C._disposed=!0,C._proxy.$dispose(C._id))},get dimensions(){if(!(C._cols===void 0||C._rows===void 0))return{columns:C._cols,rows:C._rows}}}}async create(t,c){if(typeof this._id!="string")throw new Error("Terminal has already been created");await this._proxy.$createTerminal(this._id,{name:t.name,shellPath:(0,d.withNullAsUndefined)(t.shellPath),shellArgs:(0,d.withNullAsUndefined)(t.shellArgs),cwd:(0,d.withNullAsUndefined)(t.cwd),env:(0,d.withNullAsUndefined)(t.env),icon:(0,d.withNullAsUndefined)(n(t.iconPath)),color:h.ThemeColor.isThemeColor(t.color)?t.color.id:void 0,initialText:(0,d.withNullAsUndefined)(t.message),strictEnv:(0,d.withNullAsUndefined)(t.strictEnv),hideFromUser:(0,d.withNullAsUndefined)(t.hideFromUser),isFeatureTerminal:(0,d.withNullAsUndefined)(c?.isFeatureTerminal),isExtensionOwnedTerminal:!0,useShellEnvironment:(0,d.withNullAsUndefined)(c?.useShellEnvironment),location:c?.location||this._serializeParentTerminal(t.location,c?.resolvedExtHostIdentifier),isTransient:(0,d.withNullAsUndefined)(t.isTransient)})}async createExtensionTerminal(t,c,w,g){if(typeof this._id!="string")throw new Error("Terminal has already been created");if(await this._proxy.$createTerminal(this._id,{name:this._name,isExtensionCustomPtyTerminal:!0,icon:w,color:h.ThemeColor.isThemeColor(g)?g.id:void 0,location:this._serializeParentTerminal(t,c),isTransient:!0}),typeof this._id=="string")throw new Error("Terminal creation failed");return this._id}_serializeParentTerminal(t,c){return typeof t=="object"?"parentTerminal"in t&&t.parentTerminal&&c?{parentTerminal:c}:"viewColumn"in t?{viewColumn:t.viewColumn,preserveFocus:t.preserveFocus}:void 0:t}_checkDisposed(){if(this._disposed)throw new Error("Terminal has already been disposed")}set name(t){this._name=t}setExitStatus(t,c){this._exitStatus=Object.freeze({code:t,reason:c})}setDimensions(t,c){return t===this._cols&&c===this._rows||t===0||c===0?!1:(this._cols=t,this._rows=c,!0)}setInteractedWith(){return this._state.isInteractedWith?!1:(this._state={isInteractedWith:!0},!0)}_setProcessId(t){this._pidPromiseComplete?(this._pidPromiseComplete(t),this._pidPromiseComplete=void 0):this._pidPromise.then(c=>{c!==t&&(this._pidPromise=Promise.resolve(t))})}}e.ExtHostTerminal=v;class A{constructor(t){this._pty=t,this.id=0,this.shouldPersist=!1,this._onProcessData=new o.Emitter,this.onProcessData=this._onProcessData.event,this._onProcessReady=new o.Emitter,this._onDidChangeProperty=new o.Emitter,this.onDidChangeProperty=this._onDidChangeProperty.event,this._onProcessExit=new o.Emitter,this.onProcessExit=this._onProcessExit.event}get onProcessReady(){return this._onProcessReady.event}refreshProperty(t){throw new Error(`refreshProperty is not suppported in extension owned terminals. property: ${t}`)}updateProperty(t,c){throw new Error(`updateProperty is not suppported in extension owned terminals. property: ${t}, value: ${c}`)}async start(){}shutdown(){this._pty.close()}input(t){this._pty.handleInput?.(t)}resize(t,c){this._pty.setDimensions?.({columns:t,rows:c})}async processBinary(t){}acknowledgeDataEvent(t){}async setUnicodeVersion(t){}getInitialCwd(){return Promise.resolve("")}getCwd(){return Promise.resolve("")}getLatency(){return Promise.resolve(0)}startSendingEvents(t){this._pty.onDidWrite(c=>this._onProcessData.fire(c)),this._pty.onDidClose?.((c=void 0)=>{this._onProcessExit.fire(c===void 0?void 0:c)}),this._pty.onDidOverrideDimensions?.(c=>{c&&this._onDidChangeProperty.fire({type:"overrideDimensions",value:{cols:c.columns,rows:c.rows}})}),this._pty.onDidChangeName?.(c=>{this._onDidChangeProperty.fire({type:"title",value:c})}),this._pty.open(t||void 0),t&&this._pty.setDimensions?.(t),this._onProcessReady.fire({pid:-1,cwd:""})}}e.ExtHostPseudoterminal=A;let l=1,_=class extends T.Disposable{constructor(t,c){super();this._terminals=[],this._terminalProcesses=new Map,this._terminalProcessDisposables={},this._extensionTerminalAwaitingStart={},this._getTerminalPromises={},this._environmentVariableCollections=new Map,this._linkProviders=new Set,this._profileProviders=new Map,this._terminalLinkCache=new Map,this._terminalLinkCancellationSource=new Map,this._onDidCloseTerminal=new o.Emitter,this.onDidCloseTerminal=this._onDidCloseTerminal.event,this._onDidOpenTerminal=new o.Emitter,this.onDidOpenTerminal=this._onDidOpenTerminal.event,this._onDidChangeActiveTerminal=new o.Emitter,this.onDidChangeActiveTerminal=this._onDidChangeActiveTerminal.event,this._onDidChangeTerminalDimensions=new o.Emitter,this.onDidChangeTerminalDimensions=this._onDidChangeTerminalDimensions.event,this._onDidChangeTerminalState=new o.Emitter,this.onDidChangeTerminalState=this._onDidChangeTerminalState.event,this._proxy=c.getProxy(p.MainContext.MainThreadTerminalService),this._bufferer=new f.TerminalDataBufferer(this._proxy.$sendProcessData),this._onDidWriteTerminalData=new o.Emitter({onFirstListenerAdd:()=>this._proxy.$startSendingDataEvents(),onLastListenerRemove:()=>this._proxy.$stopSendingDataEvents()}),this._proxy.$registerProcessSupport(t),this._register({dispose:()=>{for(const[w,g]of this._terminalProcesses)g.shutdown(!0)}})}get activeTerminal(){return this._activeTerminal?.value}get terminals(){return this._terminals.map(t=>t.value)}get onDidWriteTerminalData(){return this._onDidWriteTerminalData.event}getDefaultShell(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.path||""}getDefaultShellArgs(t){return(t?this._defaultAutomationProfile:this._defaultProfile)?.args||[]}createExtensionTerminal(t,c){const w=new v(this._proxy,(0,I.generateUuid)(),t,t.name),g=new A(t.pty);return w.createExtensionTerminal(t.location,this._serializeParentTerminal(t,c).resolvedExtHostIdentifier,n(t.iconPath),i(t.color)).then(C=>{const U=this._setupExtHostProcessListeners(C,g);this._terminalProcessDisposables[C]=U}),this._terminals.push(w),w.value}_serializeParentTerminal(t,c){if(c=c||{},t.location&&typeof t.location=="object"&&"parentTerminal"in t.location){const w=t.location.parentTerminal;if(w){const g=this._terminals.find(C=>C.value===w);g&&(c.resolvedExtHostIdentifier=g._id)}}else t.location&&typeof t.location!="object"?c.location=t.location:c.location&&typeof c.location=="object"&&"splitActiveTerminal"in c.location&&(c.location={splitActiveTerminal:!0});return c}attachPtyToTerminal(t,c){if(!this._getTerminalById(t))throw new Error(`Cannot resolve terminal with id ${t} for virtual process`);const g=new A(c),C=this._setupExtHostProcessListeners(t,g);this._terminalProcessDisposables[t]=C}async $acceptActiveTerminalChanged(t){const c=this._activeTerminal;if(t===null){this._activeTerminal=void 0,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal);return}const w=this._getTerminalById(t);w&&(this._activeTerminal=w,c!==this._activeTerminal&&this._onDidChangeActiveTerminal.fire(this._activeTerminal.value))}async $acceptTerminalProcessData(t,c){const w=this._getTerminalById(t);w&&this._onDidWriteTerminalData.fire({terminal:w.value,data:c})}async $acceptTerminalDimensions(t,c,w){const g=this._getTerminalById(t);g&&g.setDimensions(c,w)&&this._onDidChangeTerminalDimensions.fire({terminal:g.value,dimensions:g.value.dimensions})}async $acceptTerminalMaximumDimensions(t,c,w){this._terminalProcesses.get(t)?.resize(c,w)}async $acceptTerminalTitleChange(t,c){const w=this._getTerminalById(t);w&&(w.name=c)}async $acceptTerminalClosed(t,c,w){const g=this._getTerminalObjectIndexById(this._terminals,t);if(g!==null){const C=this._terminals.splice(g,1)[0];C.setExitStatus(c,w),this._onDidCloseTerminal.fire(C.value)}}$acceptTerminalOpened(t,c,w,g){if(c){const W=this._getTerminalObjectIndexById(this._terminals,c);if(W!==null){this._terminals[W]._id=t,this._onDidOpenTerminal.fire(this.terminals[W]),this._terminals[W].isOpen=!0;return}}const C={name:g.name,shellPath:g.executable,shellArgs:g.args,cwd:typeof g.cwd=="string"?g.cwd:L.URI.revive(g.cwd),env:g.env,hideFromUser:g.hideFromUser},U=new v(this._proxy,t,C,w);this._terminals.push(U),this._onDidOpenTerminal.fire(U.value),U.isOpen=!0}async $acceptTerminalProcessId(t,c){this._getTerminalById(t)?._setProcessId(c)}async $startExtensionTerminal(t,c){const w=this._getTerminalById(t);if(!w)return{message:(0,P.localize)(0,null,t)};w.isOpen||await new Promise(C=>{const U=this.onDidOpenTerminal(async W=>{W===w.value&&(U.dispose(),C())})});const g=this._terminalProcesses.get(t);g?g.startSendingEvents(c):this._extensionTerminalAwaitingStart[t]={initialDimensions:c}}_setupExtHostProcessListeners(t,c){const w=new T.DisposableStore;w.add(c.onProcessReady(C=>this._proxy.$sendProcessReady(t,C.pid,C.cwd))),w.add(c.onDidChangeProperty(C=>this._proxy.$sendProcessProperty(t,C))),this._bufferer.startBuffering(t,c.onProcessData),w.add(c.onProcessExit(C=>this._onProcessExit(t,C))),this._terminalProcesses.set(t,c);const g=this._extensionTerminalAwaitingStart[t];return g&&c instanceof A&&(c.startSendingEvents(g.initialDimensions),delete this._extensionTerminalAwaitingStart[t]),w}$acceptProcessAckDataEvent(t,c){this._terminalProcesses.get(t)?.acknowledgeDataEvent(c)}$acceptProcessInput(t,c){this._terminalProcesses.get(t)?.input(c)}$acceptTerminalInteraction(t){const c=this._getTerminalById(t);c?.setInteractedWith()&&this._onDidChangeTerminalState.fire(c.value)}$acceptProcessResize(t,c,w){try{this._terminalProcesses.get(t)?.resize(c,w)}catch(g){if(g.code!=="EPIPE"&&g.code!=="ERR_IPC_CHANNEL_CLOSED")throw g}}$acceptProcessShutdown(t,c){this._terminalProcesses.get(t)?.shutdown(c)}$acceptProcessRequestInitialCwd(t){this._terminalProcesses.get(t)?.getInitialCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"initialCwd",value:c}))}$acceptProcessRequestCwd(t){this._terminalProcesses.get(t)?.getCwd().then(c=>this._proxy.$sendProcessProperty(t,{type:"cwd",value:c}))}$acceptProcessRequestLatency(t){return Promise.resolve(t)}registerLinkProvider(t){return this._linkProviders.add(t),this._linkProviders.size===1&&this._proxy.$startLinkProvider(),new E.Disposable(()=>{this._linkProviders.delete(t),this._linkProviders.size===0&&this._proxy.$stopLinkProvider()})}registerProfileProvider(t,c,w){if(this._profileProviders.has(c))throw new Error(`Terminal profile provider "${c}" already registered`);return this._profileProviders.set(c,w),this._proxy.$registerProfileProvider(c,t.identifier.value),new E.Disposable(()=>{this._profileProviders.delete(c),this._proxy.$unregisterProfileProvider(c)})}async $createContributedProfileTerminal(t,c){const w=new m.CancellationTokenSource().token;let g=await this._profileProviders.get(t)?.provideTerminalProfile(w);if(!w.isCancellationRequested){if(g&&!("options"in g)&&(g={options:g}),!g||!("options"in g))throw new Error(`No terminal profile options provided for id "${t}"`);if("pty"in g.options){this.createExtensionTerminal(g.options,c);return}this.createTerminalFromOptions(g.options,c)}}async $provideLinks(t,c){const w=this._getTerminalById(t);if(!w)return[];this._terminalLinkCache.delete(t),this._terminalLinkCancellationSource.get(t)?.dispose(!0);const C=new m.CancellationTokenSource;this._terminalLinkCancellationSource.set(t,C);const U=[],W={terminal:w.value,line:c},M=[];for(const $ of this._linkProviders)M.push(a.Promises.withAsyncBody(async N=>{C.token.onCancellationRequested(()=>N({provider:$,links:[]}));const K=await $.provideTerminalLinks(W,C.token)||[];C.token.isCancellationRequested||N({provider:$,links:K})}));const S=await Promise.all(M);if(C.token.isCancellationRequested)return[];const z=new Map;for(const $ of S)$&&$.links.length>0&&U.push(...$.links.map(N=>{const K={id:l++,startIndex:N.startIndex,length:N.length,label:N.tooltip};return z.set(K.id,{provider:$.provider,link:N}),K}));return this._terminalLinkCache.set(t,z),U}$activateLink(t,c){const w=this._terminalLinkCache.get(t)?.get(c);!w||w.provider.handleTerminalLink(w.link)}_onProcessExit(t,c){this._bufferer.stopBuffering(t),this._terminalProcesses.delete(t),delete this._extensionTerminalAwaitingStart[t];const w=this._terminalProcessDisposables[t];w&&(w.dispose(),delete this._terminalProcessDisposables[t]),this._proxy.$sendProcessExit(t,c)}_getTerminalById(t){return this._getTerminalObjectById(this._terminals,t)}_getTerminalObjectById(t,c){const w=this._getTerminalObjectIndexById(t,c);return w!==null?t[w]:null}_getTerminalObjectIndexById(t,c){let w=null;return t.some((g,C)=>g._id===c?(w=C,!0):!1),w}getEnvironmentVariableCollection(t){let c=this._environmentVariableCollections.get(t.identifier.value);return c||(c=new s,this._setEnvironmentVariableCollection(t.identifier.value,c)),c}_syncEnvironmentVariableCollection(t,c){const w=(0,y.serializeEnvironmentVariableCollection)(c.map);this._proxy.$setEnvironmentVariableCollection(t,c.persistent,w.length===0?void 0:w)}$initEnvironmentVariableCollections(t){t.forEach(c=>{const w=c[0],g=new s(c[1]);this._setEnvironmentVariableCollection(w,g)})}$acceptDefaultProfile(t,c){this._defaultProfile=t,this._defaultAutomationProfile=c}_setEnvironmentVariableCollection(t,c){this._environmentVariableCollections.set(t,c),c.onDidChangeCollection(()=>{this._syncEnvironmentVariableCollection(t,c)})}};_=ze([xe(1,D.IExtHostRpcService)],_),e.BaseExtHostTerminalService=_;class s{constructor(t){this.map=new Map,this._persistent=!0,this._onDidChangeCollection=new o.Emitter,this.map=new Map(t)}get persistent(){return this._persistent}set persistent(t){this._persistent=t,this._onDidChangeCollection.fire()}get onDidChangeCollection(){return this._onDidChangeCollection&&this._onDidChangeCollection.event}get size(){return this.map.size}replace(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Replace})}append(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Append})}prepend(t,c){this._setIfDiffers(t,{value:c,type:E.EnvironmentVariableMutatorType.Prepend})}_setIfDiffers(t,c){const w=this.map.get(t);(!w||w.value!==c.value||w.type!==c.type)&&(this.map.set(t,c),this._onDidChangeCollection.fire())}get(t){return this.map.get(t)}forEach(t,c){this.map.forEach((w,g)=>t.call(c,g,w,this))}[Symbol.iterator](){return this.map.entries()}delete(t){this.map.delete(t),this._onDidChangeCollection.fire()}clear(){this.map.clear(),this._onDidChangeCollection.fire()}}e.EnvironmentVariableCollection=s;let u=class extends _{constructor(t){super(!1,t)}createTerminal(t,c,w){throw new R.NotSupportedError}createTerminalFromOptions(t,c){throw new R.NotSupportedError}};u=ze([xe(0,D.IExtHostRpcService)],u),e.WorkerExtHostTerminalService=u;function n(r){if(!(!r||typeof r=="string"))return"id"in r?{id:r.id,color:r.color}:r}function i(r){return h.ThemeColor.isThemeColor(r)?r:void 0}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[212],Ce([1,0,16,22,20,4,172,96,7,26,10,42,5,15,92,8,6,46,65,47]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A){"use strict";var l,_;Object.defineProperty(e,"__esModule",{value:!0}),e.TestRunProfileImpl=e.MirroredTestCollection=e.TestRunDto=e.TestRunCoordinator=e.ExtHostTesting=void 0;let s=class{constructor(M,S){this.resultsChangedEmitter=new L.Emitter,this.controllers=new Map,this.onResultsChanged=this.resultsChangedEmitter.event,this.results=[],this.proxy=M.getProxy(m.MainContext.MainThreadTesting),this.observer=new g(this.proxy),this.runTracker=new n(this.proxy),S.registerArgumentProcessor({processArgument:z=>z?.$mid===13?(0,f.toItemFromContext)(z):z})}createTestController(M,S,z){if(this.controllers.has(M))throw new Error(`Attempt to insert a duplicate controller with ID "${M}"`);const $=new E.DisposableStore,N=$.add(new f.ExtHostTestItemCollection(M,S));N.root.label=S;const K=new Map,V=this.proxy,F={items:N.root.children,get label(){return S},set label(ce){S=ce,N.root.label=ce,V.$updateController(M,{label:S})},get refreshHandler(){return z},set refreshHandler(ce){z=ce,V.$updateController(M,{canRefresh:!!ce})},get id(){return M},createRunProfile:(ce,re,fe,ie,Ee)=>{let be=(0,T.hash)(ce);for(;K.has(be);)be++;return new C(this.proxy,K,M,be,ce,re,fe,ie,Ee)},createTestItem(ce,re,fe){return new f.TestItemImpl(M,ce,re,fe)},createTestRun:(ce,re,fe=!0)=>this.runTracker.createTestRun(M,N,ce,re,fe),set resolveHandler(ce){N.resolveHandler=ce},get resolveHandler(){return N.resolveHandler},dispose:()=>{$.dispose()}};V.$registerTestController(M,S,!!z),$.add((0,E.toDisposable)(()=>V.$unregisterTestController(M)));const ne={controller:F,collection:N,profiles:K};return this.controllers.set(M,ne),$.add((0,E.toDisposable)(()=>this.controllers.delete(M))),$.add(N.onDidGenerateDiff(ce=>V.$publishDiff(M,ce.map(A.TestsDiffOp.serialize)))),F}createTestObserver(){return this.observer.checkout()}async runTests(M,S=b.CancellationToken.None){const z=i(M);if(!z)throw new Error("The request passed to `vscode.test.runTests` must include a profile");const $=this.controllers.get(z.controllerId);if(!$)throw new Error("Controller not found");await this.proxy.$runTests({isUiTriggered:!1,targets:[{testIds:M.include?.map(N=>a.TestId.fromExtHostTestItem(N,$.collection.root.id).toString())??[$.collection.root.id],profileGroup:U[z.kind],profileId:z.profileId,controllerId:z.controllerId}],exclude:M.exclude?.map(N=>N.id)},S)}$provideFileCoverage(M,S,z){return(0,o.mapFind)(this.runTracker.trackers,N=>N.id===M?N.getCoverage(S):void 0)?.provideFileCoverage(z)??Promise.resolve([])}$resolveFileCoverage(M,S,z,$){return(0,o.mapFind)(this.runTracker.trackers,K=>K.id===M?K.getCoverage(S):void 0)?.resolveFileCoverage(z,$)??Promise.resolve([])}$configureRunProfile(M,S){this.controllers.get(M)?.profiles.get(S)?.configureHandler?.()}async $refreshTests(M,S){await this.controllers.get(M)?.controller.refreshHandler?.(S)}$publishTestResults(M){this.results=Object.freeze(M.map(S=>(0,P.deepFreeze)(h.TestResults.to(S))).concat(this.results).sort((S,z)=>z.completedAt-S.completedAt).slice(0,32)),this.resultsChangedEmitter.fire()}async $expandTest(M,S){const z=this.controllers.get(a.TestId.fromString(M).controllerId)?.collection;z&&(await z.expand(M,S<0?1/0:S),z.flushDiff())}$acceptDiff(M){this.observer.applyDiff(M.map(A.TestsDiffOp.deserialize))}async $runControllerTests(M,S){const z=this.controllers.get(M.controllerId);if(!z)return;const{collection:$,profiles:N}=z,K=N.get(M.profileId);if(!K)return;const V=M.testIds.map(re=>$.tree.get(re)).filter(R.isDefined),F=M.excludeExtIds.map(re=>z.collection.tree.get(re)).filter(R.isDefined).filter(re=>V.some(fe=>fe.fullId.compare(re.fullId)===2));if(!V.length)return;const ne=new d.TestRunRequest(V.some(re=>re.actual instanceof f.TestItemRootImpl)?void 0:V.map(re=>re.actual),F.map(re=>re.actual),K),ce=this.runTracker.prepareForMainThreadTestRun(ne,r.fromInternal(M,z.collection),S);try{await K.runHandler(ne,S)}finally{ce.isRunning&&!S.isCancellationRequested&&await L.Event.toPromise(ce.onEnd),ce.dispose()}}$cancelExtensionTestRun(M){M===void 0?this.runTracker.cancelAllRuns():this.runTracker.cancelRunById(M)}};s=ze([xe(0,I.IExtHostRpcService)],s),e.ExtHostTesting=s;class u extends E.Disposable{constructor(M,S,z){super();this.dto=M,this.proxy=S,this.tasks=new Map,this.sharedTestIds=new Set,this.endEmitter=this._register(new L.Emitter),this.disposed=!1,this.onEnd=this.endEmitter.event,this.cts=this._register(new b.CancellationTokenSource(z)),this._register(this.cts.token.onCancellationRequested(()=>{for(const{run:$}of this.tasks.values())$.end()}))}get isRunning(){return this.tasks.size>0}get id(){return this.dto.id}getCoverage(M){return this.tasks.get(M)?.coverage}createRun(M){const S=this.dto.id,z=this.dto.controllerId,$=(0,y.generateUuid)(),N=new t(this.proxy,S,$),K=ce=>(re,...fe)=>{if(F){console.warn(`Setting the state of test "${re.id}" is a no-op after the run ends.`);return}!this.dto.isIncluded(re)||(this.ensureTestIsKnown(re),ce(re,...fe))},V=(ce,re)=>{const fe=re instanceof Array?re.map(h.TestMessage.from):[h.TestMessage.from(re)];if(ce.uri&&ce.range){const ie={range:h.Range.from(ce.range),uri:ce.uri};for(const Ee of fe)Ee.location=Ee.location||ie}this.proxy.$appendTestMessagesInRun(S,$,a.TestId.fromExtHostTestItem(ce,z).toString(),fe)};let F=!1;const ne={isPersisted:this.dto.isPersisted,token:this.cts.token,name:M,get coverageProvider(){return N.coverageProvider},set coverageProvider(ce){N.coverageProvider=ce},enqueued:K(ce=>{this.proxy.$updateTestStateInRun(S,$,a.TestId.fromExtHostTestItem(ce,z).toString(),1)}),skipped:K(ce=>{this.proxy.$updateTestStateInRun(S,$,a.TestId.fromExtHostTestItem(ce,z).toString(),5)}),started:K(ce=>{this.proxy.$updateTestStateInRun(S,$,a.TestId.fromExtHostTestItem(ce,z).toString(),2)}),errored:K((ce,re,fe)=>{V(ce,re),this.proxy.$updateTestStateInRun(S,$,a.TestId.fromExtHostTestItem(ce,z).toString(),6,fe)}),failed:K((ce,re,fe)=>{V(ce,re),this.proxy.$updateTestStateInRun(S,$,a.TestId.fromExtHostTestItem(ce,z).toString(),4,fe)}),passed:K((ce,re)=>{this.proxy.$updateTestStateInRun(S,$,a.TestId.fromExtHostTestItem(ce,this.dto.controllerId).toString(),3,re)}),appendOutput:(ce,re,fe)=>{F||(fe&&(this.dto.isIncluded(fe)?this.ensureTestIsKnown(fe):fe=void 0),this.proxy.$appendOutputToRun(S,$,p.VSBuffer.fromString(ce),re&&h.location.from(re),fe&&a.TestId.fromExtHostTestItem(fe,z).toString()))},end:()=>{F||(F=!0,this.proxy.$finishedTestRunTask(S,$),this.tasks.delete($),this.isRunning||this.dispose())}};return this.tasks.set($,{run:ne,coverage:N}),this.proxy.$startedTestRunTask(S,{id:$,name:M,running:!0}),ne}dispose(){this.disposed||(this.disposed=!0,this.endEmitter.fire(),this.cts.cancel(),super.dispose())}ensureTestIsKnown(M){if(!(M instanceof f.TestItemImpl))throw new v.InvalidTestItemError(M.id);if(this.sharedTestIds.has(a.TestId.fromExtHostTestItem(M,this.dto.controllerId).toString()))return;const S=[],z=this.dto.colllection.root;for(;;){const $=h.TestItem.from(M);if(S.unshift($),this.sharedTestIds.has($.extId)||(this.sharedTestIds.add($.extId),M===z))break;M=M.parent||z}this.proxy.$addTestsToRun(this.dto.controllerId,this.dto.id,S)}}class n{constructor(M){this.proxy=M,this.tracked=new Map}get trackers(){return this.tracked.values()}prepareForMainThreadTestRun(M,S,z){return this.getTracker(M,S,z)}cancelRunById(M){for(const S of this.tracked.values())if(S.id===M){S.dispose();return}}cancelAllRuns(){for(const M of this.tracked.values())M.dispose()}createTestRun(M,S,z,$,N){const K=this.tracked.get(z);if(K)return K.createRun($);const V=r.fromPublic(M,S,z,N),F=i(z);this.proxy.$startedExtensionTestRun({controllerId:M,profile:F&&{group:U[F.kind],id:F.profileId},exclude:z.exclude?.map(ce=>a.TestId.fromExtHostTestItem(ce,S.root.id).toString())??[],id:V.id,include:z.include?.map(ce=>a.TestId.fromExtHostTestItem(ce,S.root.id).toString())??[S.root.id],persist:N});const ne=this.getTracker(z,V);return ne.onEnd(()=>this.proxy.$finishedExtensionTestRun(V.id)),ne.createRun($)}getTracker(M,S,z){const $=new u(S,this.proxy,z);return this.tracked.set(M,$),$.onEnd(()=>this.tracked.delete(M)),$}}e.TestRunCoordinator=n;const i=W=>{if(!!W.profile){if(!(W.profile instanceof C))throw new Error("TestRunRequest.profile is not an instance created from TestController.createRunProfile");return W.profile}};class r{constructor(M,S,z,$,N,K){this.controllerId=M,this.id=S,this.isPersisted=N,this.colllection=K,this.includePrefix=z.map(V=>V+"\0"),this.excludePrefix=$.map(V=>V+"\0")}static fromPublic(M,S,z,$){return new r(M,(0,y.generateUuid)(),z.include?.map(N=>a.TestId.fromExtHostTestItem(N,M).toString())??[M],z.exclude?.map(N=>a.TestId.fromExtHostTestItem(N,M).toString())??[],$,S)}static fromInternal(M,S){return new r(M.controllerId,M.runId,M.testIds,M.excludeExtIds,!0,S)}isIncluded(M){const S=a.TestId.fromExtHostTestItem(M,this.controllerId).toString()+"\0";for(const z of this.excludePrefix)if(S===z||S.startsWith(z))return!1;for(const z of this.includePrefix)if(S===z||S.startsWith(z))return!0;return!1}}e.TestRunDto=r;class t{constructor(M,S,z){this.proxy=M,this.runId=S,this.taskId=z}set coverageProvider(M){if(this._coverageProvider)throw new Error("The TestCoverageProvider cannot be replaced after being provided");!M||(this._coverageProvider=M,this.proxy.$signalCoverageAvailable(this.runId,this.taskId))}get coverageProvider(){return this._coverageProvider}async provideFileCoverage(M){if(!this._coverageProvider)return[];this.fileCoverage||(this.fileCoverage=(async()=>this._coverageProvider.provideFileCoverage(M))());try{return(await this.fileCoverage)?.map(h.TestCoverage.fromFile)??[]}catch(S){throw this.fileCoverage=void 0,S}}async resolveFileCoverage(M,S){const z=await this.fileCoverage;let $=z?.[M];return!this._coverageProvider||!z||!$?[]:($.detailedCoverage||($=z[M]=await this._coverageProvider.resolveFileCoverage?.($,S)??$),$.detailedCoverage?.map(h.TestCoverage.fromDetailed)??[])}}class c extends A.IncrementalChangeCollector{constructor(M){super();this.emitter=M,this.added=new Set,this.updated=new Set,this.removed=new Set,this.alreadyRemoved=new Set}get isEmpty(){return this.added.size===0&&this.removed.size===0&&this.updated.size===0}add(M){this.added.add(M)}update(M){Object.assign(M.revived,h.TestItem.toPlain(M.item)),this.added.has(M)||this.updated.add(M)}remove(M){if(this.added.has(M)){this.added.delete(M);return}if(this.updated.delete(M),M.parent&&this.alreadyRemoved.has(M.parent)){this.alreadyRemoved.add(M.item.extId);return}this.removed.add(M)}getChangeEvent(){const{added:M,updated:S,removed:z}=this;return{get added(){return[...M].map($=>$.revived)},get updated(){return[...S].map($=>$.revived)},get removed(){return[...z].map($=>$.revived)}}}complete(){this.isEmpty||this.emitter.fire(this.getChangeEvent())}}class w extends A.AbstractIncrementalTestCollection{constructor(){super(...arguments);this.changeEmitter=new L.Emitter,this.onDidChangeTests=this.changeEmitter.event}get rootTests(){return super.roots}getMirroredTestDataById(M){return this.items.get(M)}getMirroredTestDataByReference(M){return this.items.get(M.id)}createItem(M,S){return{...M,revived:h.TestItem.toPlain(M.item),depth:S?S.depth+1:0,children:new Set}}createChangeCollector(){return new c(this.changeEmitter)}}e.MirroredTestCollection=w;class g{constructor(M){this.proxy=M}checkout(){this.current||(this.current=this.createObserverData());const M=this.current;return M.observers++,{onDidChangeTest:M.tests.onDidChangeTests,get tests(){return[...M.tests.rootTests].map(S=>S.revived)},dispose:(0,D.once)(()=>{--M.observers==0&&(this.proxy.$unsubscribeFromDiffs(),this.current=void 0)})}}getMirroredTestDataByReference(M){return this.current?.tests.getMirroredTestDataByReference(M)}applyDiff(M){this.current?.tests.apply(M)}createObserverData(){const M=new w;return this.proxy.$subscribeToDiffs(),{observers:0,tests:M}}}class C{constructor(M,S,z,$,N,K,V,F=!1,ne=void 0){this.controllerId=z,this.profileId=$,this._label=N,this.kind=K,this.runHandler=V,this._isDefault=F,this._tag=ne,l.set(this,void 0),_.set(this,void 0),Je(this,l,M,"f"),Je(this,_,S,"f"),S.set($,this);const ce=U[K];if(typeof ce!="number")throw new Error(`Unknown TestRunProfile.group ${K}`);Oe(this,l,"f").$publishTestRunProfile({profileId:$,controllerId:z,tag:ne?h.TestTag.namespace(this.controllerId,ne.id):null,label:N,group:ce,isDefault:F,hasConfigurationHandler:!1})}get label(){return this._label}set label(M){M!==this._label&&(this._label=M,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{label:M}))}get isDefault(){return this._isDefault}set isDefault(M){M!==this._isDefault&&(this._isDefault=M,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{isDefault:M}))}get tag(){return this._tag}set tag(M){M?.id!==this._tag?.id&&(this._tag=M,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{tag:M?h.TestTag.namespace(this.controllerId,M.id):null}))}get configureHandler(){return this._configureHandler}set configureHandler(M){M!==this._configureHandler&&(this._configureHandler=M,Oe(this,l,"f").$updateTestRunConfig(this.controllerId,this.profileId,{hasConfigurationHandler:!!M}))}dispose(){Oe(this,_,"f")?.delete(this.profileId)&&(Je(this,_,void 0,"f"),Oe(this,l,"f").$removeTestProfile(this.controllerId,this.profileId))}}e.TestRunProfileImpl=C,l=new WeakMap,_=new WeakMap;const U={[d.TestRunProfileKind.Coverage]:8,[d.TestRunProfileKind.Debug]:4,[d.TestRunProfileKind.Run]:2}}),define(De[213],Ce([1,0,16,4,5,93,8,6]),function(te,e,o,p,b,L,D,T){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostEditors=void 0;class E{constructor(R,y){this._extHostDocumentsAndEditors=y,this._onDidChangeTextEditorSelection=new p.Emitter,this._onDidChangeTextEditorOptions=new p.Emitter,this._onDidChangeTextEditorVisibleRanges=new p.Emitter,this._onDidChangeTextEditorViewColumn=new p.Emitter,this._onDidChangeActiveTextEditor=new p.Emitter,this._onDidChangeVisibleTextEditors=new p.Emitter,this.onDidChangeTextEditorSelection=this._onDidChangeTextEditorSelection.event,this.onDidChangeTextEditorOptions=this._onDidChangeTextEditorOptions.event,this.onDidChangeTextEditorVisibleRanges=this._onDidChangeTextEditorVisibleRanges.event,this.onDidChangeTextEditorViewColumn=this._onDidChangeTextEditorViewColumn.event,this.onDidChangeActiveTextEditor=this._onDidChangeActiveTextEditor.event,this.onDidChangeVisibleTextEditors=this._onDidChangeVisibleTextEditors.event,this._proxy=R.getProxy(b.MainContext.MainThreadTextEditors),this._extHostDocumentsAndEditors.onDidChangeVisibleTextEditors(m=>this._onDidChangeVisibleTextEditors.fire(m)),this._extHostDocumentsAndEditors.onDidChangeActiveTextEditor(m=>this._onDidChangeActiveTextEditor.fire(m))}getActiveTextEditor(){return this._extHostDocumentsAndEditors.activeEditor()}getVisibleTextEditors(R){const y=this._extHostDocumentsAndEditors.allEditors();return R?y:y.map(m=>m.value)}async showTextDocument(R,y,m){let I;typeof y=="number"?I={position:D.ViewColumn.from(y),preserveFocus:m}:typeof y=="object"?I={position:D.ViewColumn.from(y.viewColumn),preserveFocus:y.preserveFocus,selection:typeof y.selection=="object"?D.Range.from(y.selection):void 0,pinned:typeof y.preview=="boolean"?!y.preview:void 0}:I={preserveFocus:!1};const f=await this._proxy.$tryShowTextDocument(R.uri,I),h=f&&this._extHostDocumentsAndEditors.getEditor(f);if(h)return h.value;throw f?new Error(`Could NOT open editor for "${R.uri.toString()}" because another editor opened in the meantime.`):new Error(`Could NOT open editor for "${R.uri.toString()}".`)}createTextEditorDecorationType(R,y){return new L.TextEditorDecorationType(this._proxy,R,y).value}$acceptEditorPropertiesChanged(R,y){const m=this._extHostDocumentsAndEditors.getEditor(R);if(!m)throw new Error("unknown text editor");if(y.options&&m._acceptOptions(y.options),y.selections){const I=y.selections.selections.map(D.Selection.to);m._acceptSelections(I)}if(y.visibleRanges){const I=o.coalesce(y.visibleRanges.map(D.Range.to));m._acceptVisibleRanges(I)}if(y.options&&this._onDidChangeTextEditorOptions.fire({textEditor:m.value,options:{...y.options,lineNumbers:D.TextEditorLineNumbersStyle.to(y.options.lineNumbers)}}),y.selections){const I=T.TextEditorSelectionChangeKind.fromValue(y.selections.source),f=y.selections.selections.map(D.Selection.to);this._onDidChangeTextEditorSelection.fire({textEditor:m.value,selections:f,kind:I})}if(y.visibleRanges){const I=o.coalesce(y.visibleRanges.map(D.Range.to));this._onDidChangeTextEditorVisibleRanges.fire({textEditor:m.value,visibleRanges:I})}}$acceptEditorPositionData(R){for(const y in R){const m=this._extHostDocumentsAndEditors.getEditor(y);if(!m)throw new Error("Unknown text editor");const I=D.ViewColumn.to(R[y]);m.value.viewColumn!==I&&(m._acceptViewColumn(I),this._onDidChangeTextEditorViewColumn.fire({textEditor:m.value,viewColumn:I}))}}getDiffInformation(R){return Promise.resolve(this._proxy.$getDiffInformation(R))}}e.ExtHostEditors=E}),define(De[214],Ce([1,0,2,3,5,7,6,8,10]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTimeline=e.IExtHostTimeline=void 0,e.IExtHostTimeline=(0,p.createDecorator)("IExtHostTimeline");class P{constructor(m,I){this._providers=new Map,this._itemsBySourceAndUriMap=new Map,this._proxy=m.getProxy(b.MainContext.MainThreadTimeline),I.registerArgumentProcessor({processArgument:f=>{if(f&&f.$mid===11){const h=f.uri===void 0?void 0:o.URI.revive(f.uri);return this._itemsBySourceAndUriMap.get(f.source)?.get(R(h))?.get(f.handle)}return f}})}async $getTimeline(m,I,f,h){return this._providers.get(m)?.provideTimeline(o.URI.revive(I),f,h)}registerTimelineProvider(m,I,f,h){const d=new L.DisposableStore,a=this.convertTimelineItem(I.id,h,d).bind(this);let v;I.onDidChange&&(v=I.onDidChange(l=>this._proxy.$emitTimelineChangeEvent({uri:void 0,reset:!0,...l,id:I.id}),this));const A=this._itemsBySourceAndUriMap;return this.registerTimelineProviderCore({...I,scheme:m,onDidChange:void 0,async provideTimeline(l,_,s){_?.resetCache&&(d.clear(),A.get(I.id)?.clear());const u=await I.provideTimeline(l,_,s);if(u==null)return;const n=a(l,_);return{...u,source:I.id,items:u.items.map(n)}},dispose(){for(const l of A.values())l.get(I.id)?.clear();v?.dispose(),d.dispose()}})}convertTimelineItem(m,I,f){return(h,d)=>{let a;if(d?.cacheResults){let v=this._itemsBySourceAndUriMap.get(m);v===void 0&&(v=new Map,this._itemsBySourceAndUriMap.set(m,v));const A=R(h);a=v.get(A),a===void 0&&(a=new Map,v.set(A,a))}return v=>{const{iconPath:A,...l}=v,_=`${m}|${v.id??v.timestamp}`;a?.set(_,v);let s,u,n;v.iconPath&&(A instanceof D.ThemeIcon?n={id:A.id,color:A.color}:o.URI.isUri(A)?(s=A,u=A):{light:s,dark:u}=A);let i;return D.MarkdownString.isMarkdownString(l.tooltip)?i=T.MarkdownString.from(l.tooltip):(0,E.isString)(l.tooltip)?i=l.tooltip:D.MarkdownString.isMarkdownString(l.detail)?(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=T.MarkdownString.from(l.detail)):(0,E.isString)(l.detail)&&(console.warn("Using deprecated TimelineItem.detail, migrate to TimelineItem.tooltip"),i=l.detail),{...l,id:l.id??void 0,handle:_,source:m,command:v.command?I.toInternal(v.command,f):void 0,icon:s,iconDark:u,themeIcon:n,tooltip:i,accessibilityInformation:v.accessibilityInformation}}}}registerTimelineProviderCore(m){if(this._providers.get(m.id))throw new Error(`Timeline Provider ${m.id} already exists.`);return this._proxy.$registerTimelineProvider({id:m.id,label:m.label,scheme:m.scheme}),this._providers.set(m.id,m),(0,L.toDisposable)(()=>{for(const f of this._itemsBySourceAndUriMap.values())f.get(m.id)?.clear();this._providers.delete(m.id),this._proxy.$unregisterTimelineProvider(m.id),m.dispose()})}}e.ExtHostTimeline=P;function R(y){return y?.toString()}}),define(De[215],Ce([1,0,7,12,2,5]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUriOpeners=void 0;class D{constructor(E){this._openers=new Map,this._proxy=E.getProxy(L.MainContext.MainThreadUriOpeners)}registerExternalUriOpener(E,P,R,y){if(this._openers.has(P))throw new Error(`Opener with id '${P}' already registered`);const m=y.schemes.find(I=>!D.supportedSchemes.has(I));if(m)throw new Error(`Scheme '${m}' is not supported. Only http and https are currently supported.`);return this._openers.set(P,R),this._proxy.$registerUriOpener(P,y.schemes,E,y.label),(0,o.toDisposable)(()=>{this._openers.delete(P),this._proxy.$unregisterUriOpener(P)})}async $canOpenUri(E,P,R){const y=this._openers.get(E);if(!y)throw new Error(`Unknown opener with id: ${E}`);const m=b.URI.revive(P);return y.canOpenExternalUri(m,R)}async $openUri(E,P,R){const y=this._openers.get(E);if(!y)throw new Error(`Unknown opener id: '${E}'`);return y.openExternalUri(b.URI.revive(P.resolvedUri),{sourceUri:b.URI.revive(P.sourceUri)},R)}}e.ExtHostUriOpeners=D,D.supportedSchemes=new Set([p.Schemas.http,p.Schemas.https])}),define(De[216],Ce([1,0,5,2,7,11,27]),function(te,e,o,p,b,L,D){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostUrls=void 0;class T{constructor(P){this.handles=new Set,this.handlers=new Map,this._proxy=P.getProxy(o.MainContext.MainThreadUrls)}registerUriHandler(P,R){if(this.handles.has(D.ExtensionIdentifier.toKey(P)))throw new Error(`Protocol handler already registered for extension ${P}`);const y=T.HandlePool++;return this.handles.add(D.ExtensionIdentifier.toKey(P)),this.handlers.set(y,R),this._proxy.$registerUriHandler(y,P),(0,b.toDisposable)(()=>{this.handles.delete(D.ExtensionIdentifier.toKey(P)),this.handlers.delete(y),this._proxy.$unregisterUriHandler(y)})}$handleExternalUri(P,R){const y=this.handlers.get(P);if(!y)return Promise.resolve(void 0);try{y.handleUri(p.URI.revive(R))}catch(m){(0,L.onUnexpectedError)(m)}return Promise.resolve(void 0)}async createAppUri(P){return p.URI.revive(await this._proxy.$createAppUri(P))}}e.ExtHostUrls=T,T.HandlePool=0});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[53],Ce([1,0,4,12,2,144,161,64,5]),function(te,e,o,p,b,L,D,T,E){"use strict";var P,R,y,m,I,f,h,d,a,v,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.reviveOptions=e.serializeWebviewOptions=e.toExtensionData=e.ExtHostWebviews=e.shouldSerializeBuffersForPostMessage=e.ExtHostWebview=void 0;class _{constructor(w,g,C,U,W,M,S){P.set(this,void 0),R.set(this,void 0),y.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),h.set(this,""),d.set(this,void 0),a.set(this,!1),v.set(this,!1),A.set(this,!1),this._onMessageEmitter=new o.Emitter,this.onDidReceiveMessage=this._onMessageEmitter.event,l.set(this,new o.Emitter),this._onDidDispose=Oe(this,l,"f").event,Je(this,P,w,"f"),Je(this,R,g,"f"),Je(this,d,C,"f"),Je(this,m,U,"f"),Je(this,I,W,"f"),Je(this,f,M,"f"),Je(this,A,s(M),"f"),Je(this,y,S,"f")}dispose(){Je(this,a,!0,"f"),Oe(this,l,"f").fire(),Oe(this,l,"f").dispose(),this._onMessageEmitter.dispose()}asWebviewUri(w){return Je(this,v,!0,"f"),(0,T.asWebviewUri)(w,Oe(this,m,"f"))}get cspSource(){const w=Oe(this,f,"f").extensionLocation;if(w.scheme===p.Schemas.https||w.scheme===p.Schemas.http){let g=w.toString();return g.endsWith("/")||(g+="/"),g+" "+T.webviewGenericCspSource}return T.webviewGenericCspSource}get html(){return this.assertNotDisposed(),Oe(this,h,"f")}set html(w){this.assertNotDisposed(),Oe(this,h,"f")!==w&&(Je(this,h,w,"f"),!Oe(this,v,"f")&&/(["'])vscode-resource:([^\s'"]+?)(["'])/i.test(w)&&(Je(this,v,!0,"f"),Oe(this,y,"f").report("Webview vscode-resource: uris",Oe(this,f,"f"),"Please migrate to use the 'webview.asWebviewUri' api instead: https://aka.ms/vscode-webview-use-aswebviewuri")),Oe(this,R,"f").$setHtml(Oe(this,P,"f"),w))}get options(){return this.assertNotDisposed(),Oe(this,d,"f")}set options(w){this.assertNotDisposed(),Oe(this,R,"f").$setOptions(Oe(this,P,"f"),i(Oe(this,f,"f"),Oe(this,I,"f"),w)),Je(this,d,w,"f")}async postMessage(w){if(Oe(this,a,"f"))return!1;const g=(0,D.serializeWebviewMessage)(w,{serializeBuffersForPostMessage:Oe(this,A,"f")});return Oe(this,R,"f").$postMessage(Oe(this,P,"f"),g.message,...g.buffers)}assertNotDisposed(){if(Oe(this,a,"f"))throw new Error("Webview is disposed")}}e.ExtHostWebview=_,P=new WeakMap,R=new WeakMap,y=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,a=new WeakMap,v=new WeakMap,A=new WeakMap,l=new WeakMap;function s(c){try{const w=(0,L.normalizeVersion)((0,L.parseVersion)(c.engines.vscode));return!!w&&w.majorBase>=1&&w.minorBase>=57}catch{return!1}}e.shouldSerializeBuffersForPostMessage=s;class u{constructor(w,g,C,U,W){this.remoteInfo=g,this.workspace=C,this._logService=U,this._deprecationService=W,this._webviews=new Map,this._webviewProxy=w.getProxy(E.MainContext.MainThreadWebviews)}$onMessage(w,g,C){const U=this.getWebview(w);if(U){const{message:W}=(0,D.deserializeWebviewMessage)(g,C.value);U._onMessageEmitter.fire(W)}}$onMissingCsp(w,g){this._logService.warn(`${g} created a webview without a content security policy: https://aka.ms/vscode-webview-missing-csp`)}createNewWebview(w,g,C){const U=new _(w,this._webviewProxy,r(g),this.remoteInfo,this.workspace,C,this._deprecationService);return this._webviews.set(w,U),U._onDidDispose(()=>{this._webviews.delete(w)}),U}deleteWebview(w){this._webviews.delete(w)}getWebview(w){return this._webviews.get(w)}}e.ExtHostWebviews=u;function n(c){return{id:c.identifier,location:c.extensionLocation}}e.toExtensionData=n;function i(c,w,g){return{enableCommandUris:g.enableCommandUris,enableScripts:g.enableScripts,enableForms:g.enableForms,portMapping:g.portMapping,localResourceRoots:g.localResourceRoots||t(c,w)}}e.serializeWebviewOptions=i;function r(c){return{enableCommandUris:c.enableCommandUris,enableScripts:c.enableScripts,enableForms:c.enableForms,portMapping:c.portMapping,localResourceRoots:c.localResourceRoots?.map(w=>b.URI.from(w))}}e.reviveOptions=r;function t(c,w){return[...(w?.getWorkspaceFolders()||[]).map(g=>g.uri),c.extensionLocation]}}),define(De[217],Ce([1,0,20,96,7,12,21,2,8,53,61,5,6]),function(te,e,o,p,b,L,D,T,E,P,R,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostCustomEditors=void 0;class I{constructor(s,u){this.document=s,this._storagePath=u,this._backupCounter=1,this._edits=new R.Cache("custom documents")}addEdit(s){return this._edits.add([s])}async undo(s,u){await this.getEdit(s).undo(),u||this.disposeBackup()}async redo(s,u){await this.getEdit(s).redo(),u||this.disposeBackup()}disposeEdits(s){for(const u of s)this._edits.delete(u)}getNewBackupUri(){if(!this._storagePath)throw new Error("Backup requires a valid storage path");const s=l(this.document.uri)+this._backupCounter++;return(0,D.joinPath)(this._storagePath,s)}updateBackup(s){this._backup?.delete(),this._backup=s}disposeBackup(){this._backup?.delete(),this._backup=void 0}getEdit(s){const u=this._edits.get(s,0);if(!u)throw new Error("No edit found");return u}}class f{constructor(){this._documents=new Map}get(s,u){return this._documents.get(this.key(s,u))}add(s,u,n){const i=this.key(s,u.uri);if(this._documents.has(i))throw new Error(`Document already exists for viewType:${s} resource:${u.uri}`);const r=new I(u,n);return this._documents.set(i,r),r}delete(s,u){const n=this.key(s,u.uri);this._documents.delete(n)}key(s,u){return`${s}@@@${u}`}}var h;(function(_){_[_.Text=0]="Text",_[_.Custom=1]="Custom"})(h||(h={}));class d{constructor(){this._providers=new Map}addTextProvider(s,u,n){return this.add(0,s,u,n)}addCustomProvider(s,u,n){return this.add(1,s,u,n)}get(s){return this._providers.get(s)}add(s,u,n,i){if(this._providers.has(u))throw new Error(`Provider for viewType:${u} already registered`);return this._providers.set(u,{type:s,extension:n,provider:i}),new m.Disposable(()=>this._providers.delete(u))}}class a{constructor(s,u,n,i,r){this._extHostDocuments=u,this._extensionStoragePaths=n,this._extHostWebview=i,this._extHostWebviewPanels=r,this._editorProviders=new d,this._documents=new f,this._proxy=s.getProxy(y.MainContext.MainThreadCustomEditors)}registerCustomEditorProvider(s,u,n,i){const r=new b.DisposableStore;return v(n)?(r.add(this._editorProviders.addTextProvider(u,s,n)),this._proxy.$registerTextEditorProvider((0,P.toExtensionData)(s),u,i.webviewOptions||{},{supportsMove:!!n.moveCustomTextEditor},(0,P.shouldSerializeBuffersForPostMessage)(s))):(r.add(this._editorProviders.addCustomProvider(u,s,n)),this.supportEditing(n)&&r.add(n.onDidChangeCustomDocument(t=>{const c=this.getCustomDocumentEntry(u,t.document.uri);if(A(t)){const w=c.addEdit(t);this._proxy.$onDidEdit(t.document.uri,u,w,t.label)}else this._proxy.$onContentChange(t.document.uri,u)})),this._proxy.$registerCustomEditorProvider((0,P.toExtensionData)(s),u,i.webviewOptions||{},!!i.supportsMultipleEditorsPerDocument,(0,P.shouldSerializeBuffersForPostMessage)(s))),m.Disposable.from(r,new m.Disposable(()=>{this._proxy.$unregisterEditorProvider(u)}))}async $createCustomDocument(s,u,n,i,r){const t=this._editorProviders.get(u);if(!t)throw new Error(`No provider found for '${u}'`);if(t.type!==1)throw new Error(`Invalid provide type for '${u}'`);const c=T.URI.revive(s),w=await t.provider.openCustomDocument(c,{backupId:n,untitledDocumentData:i?.buffer},r);let g;return this.supportEditing(t.provider)&&this._extensionStoragePaths&&(g=this._extensionStoragePaths.workspaceValue(t.extension)??this._extensionStoragePaths.globalValue(t.extension)),this._documents.add(u,w,g),{editable:this.supportEditing(t.provider)}}async $disposeCustomDocument(s,u){const n=this._editorProviders.get(u);if(!n)throw new Error(`No provider found for '${u}'`);if(n.type!==1)throw new Error(`Invalid provider type for '${u}'`);const i=T.URI.revive(s),{document:r}=this.getCustomDocumentEntry(u,i);this._documents.delete(u,r),r.dispose()}async $resolveWebviewEditor(s,u,n,i,r,t){const c=this._editorProviders.get(n);if(!c)throw new Error(`No provider found for '${n}'`);const w=E.ViewColumn.to(r),g=this._extHostWebview.createNewWebview(u,i.webviewOptions,c.extension),C=this._extHostWebviewPanels.createNewWebviewPanel(u,n,i.title,w,i.panelOptions,g,!0),U=T.URI.revive(s);switch(c.type){case 1:{const{document:W}=this.getCustomDocumentEntry(n,U);return c.provider.resolveCustomEditor(W,C,t)}case 0:{const W=this._extHostDocuments.getDocument(U);return c.provider.resolveCustomTextEditor(W,C,t)}default:throw new Error("Unknown webview provider type")}}$disposeEdits(s,u,n){this.getCustomDocumentEntry(u,s).disposeEdits(n)}async $onMoveCustomEditor(s,u,n){const i=this._editorProviders.get(n);if(!i)throw new Error(`No provider found for '${n}'`);if(!i.provider.moveCustomTextEditor)throw new Error(`Provider does not implement move '${n}'`);const r=this._extHostWebviewPanels.getWebviewPanel(s);if(!r)throw new Error("No webview found");const t=T.URI.revive(u),c=this._extHostDocuments.getDocument(t);await i.provider.moveCustomTextEditor(c,r,o.CancellationToken.None)}async $undo(s,u,n,i){return this.getCustomDocumentEntry(u,s).undo(n,i)}async $redo(s,u,n,i){return this.getCustomDocumentEntry(u,s).redo(n,i)}async $revert(s,u,n){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).revertCustomDocument(i.document,n),i.disposeBackup()}async $onSave(s,u,n){const i=this.getCustomDocumentEntry(u,s);await this.getCustomEditorProvider(u).saveCustomDocument(i.document,n),i.disposeBackup()}async $onSaveAs(s,u,n,i){const r=this.getCustomDocumentEntry(u,s);return this.getCustomEditorProvider(u).saveCustomDocumentAs(r.document,T.URI.revive(n),i)}async $backup(s,u,n){const i=this.getCustomDocumentEntry(u,s),t=await this.getCustomEditorProvider(u).backupCustomDocument(i.document,{destination:i.getNewBackupUri()},n);return i.updateBackup(t),t.id}getCustomDocumentEntry(s,u){const n=this._documents.get(s,T.URI.revive(u));if(!n)throw new Error("No custom document found");return n}getCustomEditorProvider(s){const n=this._editorProviders.get(s)?.provider;if(!n||!this.supportEditing(n))throw new Error("Custom document is not editable");return n}supportEditing(s){return!!s.onDidChangeCustomDocument}}e.ExtHostCustomEditors=a;function v(_){return typeof _.resolveCustomTextEditor=="function"}function A(_){return typeof _.undo=="function"&&typeof _.redo=="function"}function l(_){const s=_.scheme===L.Schemas.file||_.scheme===L.Schemas.untitled?_.fsPath:_.toString();return(0,p.hash)(s)+""}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[218],Ce([1,0,4,7,2,42,8,53,5,6]),function(te,e,o,p,b,L,D,T,E,P){"use strict";var R,y,m,I,f,h,d,a,v,A,l,_,s;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewPanels=void 0;class u extends p.Disposable{constructor(t,c,w,g){super();R.set(this,void 0),y.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,void 0),h.set(this,void 0),d.set(this,void 0),a.set(this,void 0),v.set(this,!0),A.set(this,void 0),l.set(this,!1),_.set(this,this._register(new o.Emitter)),this.onDidDispose=Oe(this,_,"f").event,s.set(this,this._register(new o.Emitter)),this.onDidChangeViewState=Oe(this,s,"f").event,Je(this,R,t,"f"),Je(this,y,c,"f"),Je(this,I,w,"f"),Je(this,m,g.viewType,"f"),Je(this,f,g.panelOptions,"f"),Je(this,a,g.viewColumn,"f"),Je(this,h,g.title,"f"),Je(this,A,g.active,"f")}dispose(){Oe(this,l,"f")||(Je(this,l,!0,"f"),Oe(this,_,"f").fire(),Oe(this,y,"f").$disposeWebview(Oe(this,R,"f")),Oe(this,I,"f").dispose(),super.dispose())}get webview(){return this.assertNotDisposed(),Oe(this,I,"f")}get viewType(){return this.assertNotDisposed(),Oe(this,m,"f")}get title(){return this.assertNotDisposed(),Oe(this,h,"f")}set title(t){this.assertNotDisposed(),Oe(this,h,"f")!==t&&(Je(this,h,t,"f"),Oe(this,y,"f").$setTitle(Oe(this,R,"f"),t))}get iconPath(){return this.assertNotDisposed(),Oe(this,d,"f")}set iconPath(t){this.assertNotDisposed(),Oe(this,d,"f")!==t&&(Je(this,d,t,"f"),Oe(this,y,"f").$setIconPath(Oe(this,R,"f"),b.URI.isUri(t)?{light:t,dark:t}:t))}get options(){return Oe(this,f,"f")}get viewColumn(){if(this.assertNotDisposed(),!(typeof Oe(this,a,"f")=="number"&&Oe(this,a,"f")<0))return Oe(this,a,"f")}get active(){return this.assertNotDisposed(),Oe(this,A,"f")}get visible(){return this.assertNotDisposed(),Oe(this,v,"f")}_updateViewState(t){Oe(this,l,"f")||(this.active!==t.active||this.visible!==t.visible||this.viewColumn!==t.viewColumn)&&(Je(this,A,t.active,"f"),Je(this,v,t.visible,"f"),Je(this,a,t.viewColumn,"f"),Oe(this,s,"f").fire({webviewPanel:this}))}reveal(t,c){this.assertNotDisposed(),Oe(this,y,"f").$reveal(Oe(this,R,"f"),{viewColumn:typeof t=="undefined"?void 0:D.ViewColumn.from(t),preserveFocus:!!c})}assertNotDisposed(){if(Oe(this,l,"f"))throw new Error("Webview is disposed")}}R=new WeakMap,y=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,a=new WeakMap,v=new WeakMap,A=new WeakMap,l=new WeakMap,_=new WeakMap,s=new WeakMap;class n{constructor(t,c,w){this.webviews=c,this.workspace=w,this._webviewPanels=new Map,this._serializers=new Map,this._proxy=t.getProxy(E.MainContext.MainThreadWebviewPanels)}static newHandle(){return(0,L.generateUuid)()}createWebviewPanel(t,c,w,g,C={}){const U=typeof g=="object"?g.viewColumn:g,W={viewColumn:D.ViewColumn.from(U),preserveFocus:typeof g=="object"&&!!g.preserveFocus},M=(0,T.shouldSerializeBuffersForPostMessage)(t),S=n.newHandle();this._proxy.$createWebviewPanel((0,T.toExtensionData)(t),S,c,{title:w,panelOptions:i(C),webviewOptions:(0,T.serializeWebviewOptions)(t,this.workspace,C),serializeBuffersForPostMessage:M},W);const z=this.webviews.createNewWebview(S,C,t);return this.createNewWebviewPanel(S,c,w,U,C,z,!0)}$onDidChangeWebviewPanelViewStates(t){const c=Object.keys(t);c.sort((w,g)=>{const C=t[w],U=t[g];return C.active?1:U.active?-1:+C.visible-+U.visible});for(const w of c){const g=this.getWebviewPanel(w);if(!g)continue;const C=t[w];g._updateViewState({active:C.active,visible:C.visible,viewColumn:D.ViewColumn.to(C.position)})}}async $onDidDisposeWebviewPanel(t){this.getWebviewPanel(t)?.dispose(),this._webviewPanels.delete(t),this.webviews.deleteWebview(t)}registerWebviewPanelSerializer(t,c,w){if(this._serializers.has(c))throw new Error(`Serializer for '${c}' already registered`);return this._serializers.set(c,{serializer:w,extension:t}),this._proxy.$registerSerializer(c,{serializeBuffersForPostMessage:(0,T.shouldSerializeBuffersForPostMessage)(t)}),new P.Disposable(()=>{this._serializers.delete(c),this._proxy.$unregisterSerializer(c)})}async $deserializeWebviewPanel(t,c,w,g){const C=this._serializers.get(c);if(!C)throw new Error(`No serializer found for '${c}'`);const{serializer:U,extension:W}=C,M=this.webviews.createNewWebview(t,w.webviewOptions,W),S=this.createNewWebviewPanel(t,c,w.title,g,w.panelOptions,M,w.active);await U.deserializeWebviewPanel(S,w.state)}createNewWebviewPanel(t,c,w,g,C,U,W){const M=new u(t,this._proxy,U,{viewType:c,title:w,viewColumn:g,panelOptions:C,active:W});return this._webviewPanels.set(t,M),M}getWebviewPanel(t){return this._webviewPanels.get(t)}}e.ExtHostWebviewPanels=n;function i(r){return{enableFindWidget:r.enableFindWidget,retainContextWhenHidden:r.retainContextWhenHidden}}});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[219],Ce([1,0,4,7,53,24,8,5,6]),function(te,e,o,p,b,L,D,T,E){"use strict";var P,R,y,m,I,f,h,d,a,v,A,l;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostWebviewViews=void 0;class _ extends p.Disposable{constructor(n,i,r,t,c,w,g){super();P.set(this,void 0),R.set(this,void 0),y.set(this,void 0),m.set(this,void 0),I.set(this,void 0),f.set(this,!1),h.set(this,void 0),d.set(this,void 0),a.set(this,void 0),v.set(this,void 0),A.set(this,this._register(new o.Emitter)),this.onDidChangeVisibility=Oe(this,A,"f").event,l.set(this,this._register(new o.Emitter)),this.onDidDispose=Oe(this,l,"f").event,Je(this,y,r,"f"),Je(this,d,t,"f"),Je(this,P,n,"f"),Je(this,R,i,"f"),Je(this,m,c,"f"),Je(this,I,w,"f"),Je(this,h,g,"f")}dispose(){Oe(this,f,"f")||(Je(this,f,!0,"f"),Oe(this,l,"f").fire(),Oe(this,m,"f").dispose(),super.dispose())}get title(){return this.assertNotDisposed(),Oe(this,d,"f")}set title(n){this.assertNotDisposed(),Oe(this,d,"f")!==n&&(Je(this,d,n,"f"),Oe(this,R,"f").$setWebviewViewTitle(Oe(this,P,"f"),n))}get description(){return this.assertNotDisposed(),Oe(this,a,"f")}set description(n){this.assertNotDisposed(),Oe(this,a,"f")!==n&&(Je(this,a,n,"f"),Oe(this,R,"f").$setWebviewViewDescription(Oe(this,P,"f"),n))}get visible(){return Oe(this,h,"f")}get webview(){return Oe(this,m,"f")}get viewType(){return Oe(this,y,"f")}_setVisible(n){n===Oe(this,h,"f")||Oe(this,f,"f")||(Je(this,h,n,"f"),Oe(this,A,"f").fire())}get badge(){return this.assertNotDisposed(),(0,L.checkProposedApiEnabled)(Oe(this,I,"f"),"badges"),Oe(this,v,"f")}set badge(n){this.assertNotDisposed(),(0,L.checkProposedApiEnabled)(Oe(this,I,"f"),"badges"),!(n?.value===Oe(this,v,"f")?.value&&n?.tooltip===Oe(this,v,"f")?.tooltip)&&(Je(this,v,D.ViewBadge.from(n),"f"),Oe(this,R,"f").$setWebviewViewBadge(Oe(this,P,"f"),n))}show(n){this.assertNotDisposed(),Oe(this,R,"f").$show(Oe(this,P,"f"),!!n)}assertNotDisposed(){if(Oe(this,f,"f"))throw new Error("Webview is disposed")}}P=new WeakMap,R=new WeakMap,y=new WeakMap,m=new WeakMap,I=new WeakMap,f=new WeakMap,h=new WeakMap,d=new WeakMap,a=new WeakMap,v=new WeakMap,A=new WeakMap,l=new WeakMap;class s{constructor(n,i){this._extHostWebview=i,this._viewProviders=new Map,this._webviewViews=new Map,this._proxy=n.getProxy(T.MainContext.MainThreadWebviewViews)}registerWebviewViewProvider(n,i,r,t){if(this._viewProviders.has(i))throw new Error(`View provider for '${i}' already registered`);return this._viewProviders.set(i,{provider:r,extension:n}),this._proxy.$registerWebviewViewProvider((0,b.toExtensionData)(n),i,{retainContextWhenHidden:t?.retainContextWhenHidden,serializeBuffersForPostMessage:(0,b.shouldSerializeBuffersForPostMessage)(n)}),new E.Disposable(()=>{this._viewProviders.delete(i),this._proxy.$unregisterWebviewViewProvider(i)})}async $resolveWebviewView(n,i,r,t,c){const w=this._viewProviders.get(i);if(!w)throw new Error(`No view provider found for '${i}'`);const{provider:g,extension:C}=w,U=this._extHostWebview.createNewWebview(n,{},C),W=new _(n,this._proxy,i,r,U,C,!0);this._webviewViews.set(n,W),await g.resolveWebviewView(W,{state:t},c)}async $onDidChangeWebviewViewVisibility(n,i){this.getWebviewView(n)._setVisible(i)}async $disposeWebviewView(n){const i=this.getWebviewView(n);this._webviewViews.delete(n),i.dispose(),this._extHostWebview.deleteWebview(n)}getWebviewView(n){const i=this._webviewViews.get(n);if(!i)throw new Error("No webview found");return i}}e.ExtHostWebviewViews=s}),define(De[97],Ce([1,0,4,5,2,12,9,3,15]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWindow=e.ExtHostWindow=void 0;let P=class Qi{constructor(y){this._onDidChangeWindowState=new o.Emitter,this.onDidChangeWindowState=this._onDidChangeWindowState.event,this._state=Qi.InitialState,this._proxy=y.getProxy(p.MainContext.MainThreadWindow),this._proxy.$getWindowVisibility().then(m=>this.$onDidChangeWindowFocus(m))}get state(){return this._state}$onDidChangeWindowFocus(y){y!==this._state.focused&&(this._state={...this._state,focused:y},this._onDidChangeWindowState.fire(this._state))}openUri(y,m){let I;if(typeof y=="string"){I=y;try{y=b.URI.parse(y)}catch{return Promise.reject(`Invalid uri - '${y}'`)}}return(0,D.isFalsyOrWhitespace)(y.scheme)?Promise.reject("Invalid scheme - cannot be empty"):y.scheme===L.Schemas.command?Promise.reject(`Invalid scheme '${y.scheme}'`):this._proxy.$openUri(y,I,m)}async asExternalUri(y,m){if((0,D.isFalsyOrWhitespace)(y.scheme))return Promise.reject("Invalid scheme - cannot be empty");const I=await this._proxy.$asExternalUri(y,m);return b.URI.from(I)}};P.InitialState={focused:!0},P=ze([xe(0,E.IExtHostRpcService)],P),e.ExtHostWindow=P,e.IExtHostWindow=(0,T.createDecorator)("IExtHostWindow")}),define(De[220],Ce([1,0,191,28,15]),function(te,e,o,p,b){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostConsoleForwarder=void 0;let L=class extends o.AbstractExtHostConsoleForwarder{constructor(T,E){super(T,E)}_nativeConsoleLogMessage(T,E,P){E.apply(console,P)}};L=ze([xe(0,b.IExtHostRpcService),xe(1,p.IExtHostInitDataService)],L),e.ExtHostConsoleForwarder=L}),define(De[221],Ce([1,0,13,22,20,11,4,7,117,185,40]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";var y;Object.defineProperty(e,"__esModule",{value:!0}),e.RPCProtocol=e.ResponsiveState=e.RequestInitiator=e.parseJsonAndRestoreBufferRefs=e.stringifyJsonWithBufferRefs=void 0;function m(C,U){try{return JSON.stringify(C,U)}catch{return"null"}}const I="$$ref$$",f={[I]:-1};class h{constructor(U,W){this.jsonString=U,this.referencedBuffers=W}}function d(C,U=null,W=!1){const M=[];return{jsonString:(W?m:JSON.stringify)(C,(z,$)=>{if(typeof $=="undefined")return f;if(typeof $=="object"){if($ instanceof p.VSBuffer){const N=M.push($)-1;return{[I]:N}}if(U)return U(z,$)}return $}),referencedBuffers:M}}e.stringifyJsonWithBufferRefs=d;function a(C,U,W){return JSON.parse(C,(M,S)=>{if(S){const z=S[I];if(typeof z=="number")return U[z];if(W&&S.$mid===1)return W.transformIncoming(S)}return S})}e.parseJsonAndRestoreBufferRefs=a;function v(C,U){return JSON.stringify(C,U)}function A(C){return C?(U,W)=>W&&W.$mid===1?C.transformOutgoing(W):W:null}var l;(function(C){C[C.LocalSide=0]="LocalSide",C[C.OtherSide=1]="OtherSide"})(l=e.RequestInitiator||(e.RequestInitiator={}));var _;(function(C){C[C.Responsive=0]="Responsive",C[C.Unresponsive=1]="Unresponsive"})(_=e.ResponsiveState||(e.ResponsiveState={}));const s=()=>{},u=Symbol.for("rpcProtocol"),n=Symbol.for("rpcProxy");class i extends T.Disposable{constructor(U,W=null,M=null){super();this[y]=!0,this._onDidChangeResponsiveState=this._register(new D.Emitter),this.onDidChangeResponsiveState=this._onDidChangeResponsiveState.event,this._protocol=U,this._logger=W,this._uriTransformer=M,this._uriReplacer=A(this._uriTransformer),this._isDisposed=!1,this._locals=[],this._proxies=[];for(let S=0,z=R.ProxyIdentifier.count;S<z;S++)this._locals[S]=null,this._proxies[S]=null;this._lastMessageId=0,this._cancelInvokedHandlers=Object.create(null),this._pendingRPCReplies={},this._responsiveState=0,this._unacknowledgedCount=0,this._unresponsiveTime=0,this._asyncCheckUresponsive=this._register(new o.RunOnceScheduler(()=>this._checkUnresponsive(),1e3)),this._protocol.onMessage(S=>this._receiveOneMessage(S))}dispose(){this._isDisposed=!0,Object.keys(this._pendingRPCReplies).forEach(U=>{this._pendingRPCReplies[U].resolveErr(L.canceled())})}drain(){return typeof this._protocol.drain=="function"?this._protocol.drain():Promise.resolve()}_onWillSendRequest(U){this._unacknowledgedCount===0&&(this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME),this._unacknowledgedCount++,this._asyncCheckUresponsive.isScheduled()||this._asyncCheckUresponsive.schedule()}_onDidReceiveAcknowledge(U){this._unresponsiveTime=Date.now()+i.UNRESPONSIVE_TIME,this._unacknowledgedCount--,this._unacknowledgedCount===0&&this._asyncCheckUresponsive.cancel(),this._setResponsiveState(0)}_checkUnresponsive(){this._unacknowledgedCount!==0&&(Date.now()>this._unresponsiveTime?this._setResponsiveState(1):this._asyncCheckUresponsive.schedule())}_setResponsiveState(U){this._responsiveState!==U&&(this._responsiveState=U,this._onDidChangeResponsiveState.fire(this._responsiveState))}get responsiveState(){return this._responsiveState}transformIncomingURIs(U){return this._uriTransformer?(0,E.transformIncomingURIs)(U,this._uriTransformer):U}getProxy(U){const{nid:W,sid:M}=U;return this._proxies[W]||(this._proxies[W]=this._createProxy(W,M)),this._proxies[W]}_createProxy(U,W){const M={get:(S,z)=>(typeof z=="string"&&!S[z]&&z.charCodeAt(0)===36&&(S[z]=(...$)=>this._remoteCall(U,z,$)),z===n?W:S[z])};return new Proxy(Object.create(null),M)}set(U,W){return this._locals[U.nid]=W,W}assertRegistered(U){for(let W=0,M=U.length;W<M;W++){const S=U[W];if(!this._locals[S.nid])throw new Error(`Missing proxy instance ${S.sid}`)}}_receiveOneMessage(U){if(this._isDisposed)return;const W=U.byteLength,M=r.read(U,0),S=M.readUInt8(),z=M.readUInt32();switch(S){case 1:case 2:{let{rpcId:$,method:N,args:K}=c.deserializeRequestJSONArgs(M);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(W,z,$,N,K,S===2);break}case 3:case 4:{let{rpcId:$,method:N,args:K}=c.deserializeRequestMixedArgs(M);this._uriTransformer&&(K=(0,E.transformIncomingURIs)(K,this._uriTransformer)),this._receiveRequest(W,z,$,N,K,S===4);break}case 5:{this._logger?.logIncoming(W,z,0,"ack"),this._onDidReceiveAcknowledge(z);break}case 6:{this._receiveCancel(W,z);break}case 7:{this._receiveReply(W,z,void 0);break}case 9:{let $=c.deserializeReplyOKJSON(M);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReply(W,z,$);break}case 10:{const $=c.deserializeReplyOKJSONWithBuffers(M,this._uriTransformer);this._receiveReply(W,z,$);break}case 8:{const $=c.deserializeReplyOKVSBuffer(M);this._receiveReply(W,z,$);break}case 11:{let $=c.deserializeReplyErrError(M);this._uriTransformer&&($=(0,E.transformIncomingURIs)($,this._uriTransformer)),this._receiveReplyErr(W,z,$);break}case 12:{this._receiveReplyErr(W,z,void 0);break}default:console.error("received unexpected message"),console.error(U)}}_receiveRequest(U,W,M,S,z,$){this._logger?.logIncoming(U,W,1,`receiveRequest ${(0,R.getStringIdentifierForProxy)(M)}.${S}(`,z);const N=String(W);let K,V;if($){const ne=new b.CancellationTokenSource;z.push(ne.token),K=this._invokeHandler(M,S,z),V=()=>ne.cancel()}else K=this._invokeHandler(M,S,z),V=s;this._cancelInvokedHandlers[N]=V;const F=c.serializeAcknowledged(W);this._logger?.logOutgoing(F.byteLength,W,1,"ack"),this._protocol.send(F),K.then(ne=>{delete this._cancelInvokedHandlers[N];const ce=c.serializeReplyOK(W,ne,this._uriReplacer);this._logger?.logOutgoing(ce.byteLength,W,1,"reply:",ne),this._protocol.send(ce)},ne=>{delete this._cancelInvokedHandlers[N];const ce=c.serializeReplyErr(W,ne);this._logger?.logOutgoing(ce.byteLength,W,1,"replyErr:",ne),this._protocol.send(ce)})}_receiveCancel(U,W){this._logger?.logIncoming(U,W,1,"receiveCancel");const M=String(W);this._cancelInvokedHandlers[M]?.()}_receiveReply(U,W,M){this._logger?.logIncoming(U,W,0,"receiveReply:",M);const S=String(W);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const z=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S],z.resolveOk(M)}_receiveReplyErr(U,W,M){this._logger?.logIncoming(U,W,0,"receiveReplyErr:",M);const S=String(W);if(!this._pendingRPCReplies.hasOwnProperty(S))return;const z=this._pendingRPCReplies[S];delete this._pendingRPCReplies[S];let $;M&&(M.$isError?($=new Error,$.name=M.name,$.message=M.message,$.stack=M.stack):$=M),z.resolveErr($)}_invokeHandler(U,W,M){try{return Promise.resolve(this._doInvokeHandler(U,W,M))}catch(S){return Promise.reject(S)}}_doInvokeHandler(U,W,M){const S=this._locals[U];if(!S)throw new Error("Unknown actor "+(0,R.getStringIdentifierForProxy)(U));const z=S[W];if(typeof z!="function")throw new Error("Unknown method "+W+" on actor "+(0,R.getStringIdentifierForProxy)(U));return z.apply(S,M)}_remoteCall(U,W,M){if(this._isDisposed)return new P.CanceledLazyPromise;let S=null;if(M.length>0&&b.CancellationToken.isCancellationToken(M[M.length-1])&&(S=M.pop()),S&&S.isCancellationRequested)return Promise.reject(L.canceled());const z=c.serializeRequestArguments(M,this._uriReplacer),$=++this._lastMessageId,N=String($),K=new P.LazyPromise;S&&S.onCancellationRequested(()=>{const F=c.serializeCancel($);this._logger?.logOutgoing(F.byteLength,$,0,"cancel"),this._protocol.send(c.serializeCancel($))}),this._pendingRPCReplies[N]=K,this._onWillSendRequest($);const V=c.serializeRequest($,U,W,z,!!S);return this._logger?.logOutgoing(V.byteLength,$,0,`request: ${(0,R.getStringIdentifierForProxy)(U)}.${W}(`,M),this._protocol.send(V),K}}e.RPCProtocol=i,y=u,i.UNRESPONSIVE_TIME=3*1e3;class r{constructor(U,W){this._buff=U,this._offset=W}static alloc(U,W,M){const S=new r(p.VSBuffer.alloc(M+1+4),0);return S.writeUInt8(U),S.writeUInt32(W),S}static read(U,W){return new r(U,W)}get buffer(){return this._buff}static sizeUInt8(){return 1}writeUInt8(U){this._buff.writeUInt8(U,this._offset),this._offset+=1}readUInt8(){const U=this._buff.readUInt8(this._offset);return this._offset+=1,U}writeUInt32(U){this._buff.writeUInt32BE(U,this._offset),this._offset+=4}readUInt32(){const U=this._buff.readUInt32BE(this._offset);return this._offset+=4,U}static sizeShortString(U){return 1+U.byteLength}writeShortString(U){this._buff.writeUInt8(U.byteLength,this._offset),this._offset+=1,this._buff.set(U,this._offset),this._offset+=U.byteLength}readShortString(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const M=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,M}static sizeLongString(U){return 4+U.byteLength}writeLongString(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readLongString(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const M=this._buff.slice(this._offset,this._offset+U).toString();return this._offset+=U,M}writeBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}static sizeVSBuffer(U){return 4+U.byteLength}writeVSBuffer(U){this._buff.writeUInt32BE(U.byteLength,this._offset),this._offset+=4,this._buff.set(U,this._offset),this._offset+=U.byteLength}readVSBuffer(){const U=this._buff.readUInt32BE(this._offset);this._offset+=4;const W=this._buff.slice(this._offset,this._offset+U);return this._offset+=U,W}static sizeMixedArray(U){let W=0;W+=1;for(let M=0,S=U.length;M<S;M++){const z=U[M];switch(W+=1,z.type){case 1:W+=this.sizeLongString(z.value);break;case 2:W+=this.sizeVSBuffer(z.value);break;case 3:W+=this.sizeUInt32,W+=this.sizeLongString(z.value);for(let $=0;$<z.buffers.length;++$)W+=this.sizeVSBuffer(z.buffers[$]);break;case 4:break}}return W}writeMixedArray(U){this._buff.writeUInt8(U.length,this._offset),this._offset+=1;for(let W=0,M=U.length;W<M;W++){const S=U[W];switch(S.type){case 1:this.writeUInt8(1),this.writeLongString(S.value);break;case 2:this.writeUInt8(2),this.writeVSBuffer(S.value);break;case 3:this.writeUInt8(3),this.writeUInt32(S.buffers.length),this.writeLongString(S.value);for(let z=0;z<S.buffers.length;++z)this.writeBuffer(S.buffers[z]);break;case 4:this.writeUInt8(4);break}}}readMixedArray(){const U=this._buff.readUInt8(this._offset);this._offset+=1;const W=new Array(U);for(let M=0;M<U;M++)switch(this.readUInt8()){case 1:W[M]=this.readLongString();break;case 2:W[M]=this.readVSBuffer();break;case 3:{const z=this.readUInt32(),$=this.readLongString(),N=[];for(let K=0;K<z;++K)N.push(this.readVSBuffer());W[M]=new R.SerializableObjectWithBuffers(a($,N,null));break}case 4:W[M]=void 0;break}return W}}r.sizeUInt32=4;var t;(function(C){C[C.Simple=0]="Simple",C[C.Mixed=1]="Mixed"})(t||(t={}));class c{static _useMixedArgSerialization(U){for(let W=0,M=U.length;W<M;W++)if(U[W]instanceof p.VSBuffer||U[W]instanceof R.SerializableObjectWithBuffers||typeof U[W]=="undefined")return!0;return!1}static serializeRequestArguments(U,W){if(this._useMixedArgSerialization(U)){const M=[];for(let S=0,z=U.length;S<z;S++){const $=U[S];if($ instanceof p.VSBuffer)M[S]={type:2,value:$};else if(typeof $=="undefined")M[S]={type:4};else if($ instanceof R.SerializableObjectWithBuffers){const{jsonString:N,referencedBuffers:K}=d($.value,W);M[S]={type:3,value:p.VSBuffer.fromString(N),buffers:K}}else M[S]={type:1,value:p.VSBuffer.fromString(v($,W))}}return{type:1,args:M}}return{type:0,args:v(U,W)}}static serializeRequest(U,W,M,S,z){switch(S.type){case 0:return this._requestJSONArgs(U,W,M,S.args,z);case 1:return this._requestMixedArgs(U,W,M,S.args,z)}}static _requestJSONArgs(U,W,M,S,z){const $=p.VSBuffer.fromString(M),N=p.VSBuffer.fromString(S);let K=0;K+=r.sizeUInt8(),K+=r.sizeShortString($),K+=r.sizeLongString(N);const V=r.alloc(z?2:1,U,K);return V.writeUInt8(W),V.writeShortString($),V.writeLongString(N),V.buffer}static deserializeRequestJSONArgs(U){const W=U.readUInt8(),M=U.readShortString(),S=U.readLongString();return{rpcId:W,method:M,args:JSON.parse(S)}}static _requestMixedArgs(U,W,M,S,z){const $=p.VSBuffer.fromString(M);let N=0;N+=r.sizeUInt8(),N+=r.sizeShortString($),N+=r.sizeMixedArray(S);const K=r.alloc(z?4:3,U,N);return K.writeUInt8(W),K.writeShortString($),K.writeMixedArray(S),K.buffer}static deserializeRequestMixedArgs(U){const W=U.readUInt8(),M=U.readShortString(),S=U.readMixedArray(),z=new Array(S.length);for(let $=0,N=S.length;$<N;$++){const K=S[$];typeof K=="string"?z[$]=JSON.parse(K):z[$]=K}return{rpcId:W,method:M,args:z}}static serializeAcknowledged(U){return r.alloc(5,U,0).buffer}static serializeCancel(U){return r.alloc(6,U,0).buffer}static serializeReplyOK(U,W,M){if(typeof W=="undefined")return this._serializeReplyOKEmpty(U);if(W instanceof p.VSBuffer)return this._serializeReplyOKVSBuffer(U,W);if(W instanceof R.SerializableObjectWithBuffers){const{jsonString:S,referencedBuffers:z}=d(W.value,M,!0);return this._serializeReplyOKJSONWithBuffers(U,S,z)}else return this._serializeReplyOKJSON(U,m(W,M))}static _serializeReplyOKEmpty(U){return r.alloc(7,U,0).buffer}static _serializeReplyOKVSBuffer(U,W){let M=0;M+=r.sizeVSBuffer(W);const S=r.alloc(8,U,M);return S.writeVSBuffer(W),S.buffer}static deserializeReplyOKVSBuffer(U){return U.readVSBuffer()}static _serializeReplyOKJSON(U,W){const M=p.VSBuffer.fromString(W);let S=0;S+=r.sizeLongString(M);const z=r.alloc(9,U,S);return z.writeLongString(M),z.buffer}static _serializeReplyOKJSONWithBuffers(U,W,M){const S=p.VSBuffer.fromString(W);let z=0;z+=r.sizeUInt32,z+=r.sizeLongString(S);for(const N of M)z+=r.sizeVSBuffer(N);const $=r.alloc(10,U,z);$.writeUInt32(M.length),$.writeLongString(S);for(const N of M)$.writeBuffer(N);return $.buffer}static deserializeReplyOKJSON(U){const W=U.readLongString();return JSON.parse(W)}static deserializeReplyOKJSONWithBuffers(U,W){const M=U.readUInt32(),S=U.readLongString(),z=[];for(let $=0;$<M;++$)z.push(U.readVSBuffer());return new R.SerializableObjectWithBuffers(a(S,z,W))}static serializeReplyErr(U,W){const M=W?m(L.transformErrorForSerialization(W),null):void 0;if(typeof M!="string")return this._serializeReplyErrEmpty(U);const S=p.VSBuffer.fromString(M);let z=0;z+=r.sizeLongString(S);const $=r.alloc(11,U,z);return $.writeLongString(S),$.buffer}static deserializeReplyErrError(U){const W=U.readLongString();return JSON.parse(W)}static _serializeReplyErrEmpty(U){return r.alloc(12,U,0).buffer}}var w;(function(C){C[C.RequestJSONArgs=1]="RequestJSONArgs",C[C.RequestJSONArgsWithCancellation=2]="RequestJSONArgsWithCancellation",C[C.RequestMixedArgs=3]="RequestMixedArgs",C[C.RequestMixedArgsWithCancellation=4]="RequestMixedArgsWithCancellation",C[C.Acknowledged=5]="Acknowledged",C[C.Cancel=6]="Cancel",C[C.ReplyOKEmpty=7]="ReplyOKEmpty",C[C.ReplyOKVSBuffer=8]="ReplyOKVSBuffer",C[C.ReplyOKJSON=9]="ReplyOKJSON",C[C.ReplyOKJSONWithBuffers=10]="ReplyOKJSONWithBuffers",C[C.ReplyErrError=11]="ReplyErrError",C[C.ReplyErrEmpty=12]="ReplyErrEmpty"})(w||(w={}));var g;(function(C){C[C.String=1]="String",C[C.VSBuffer=2]="VSBuffer",C[C.SerializedObjectWithBuffers=3]="SerializedObjectWithBuffers",C[C.Undefined=4]="Undefined"})(g||(g={}))}),define(De[222],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.NestedWorker=void 0;const o=function(L){const D=T=>{self.removeEventListener("message",D);const E=T.data;Object.defineProperties(self,{postMessage:{value(P,R){E.postMessage(P,R)}},onmessage:{get(){return E.onmessage},set(P){E.onmessage=P}}}),E.addEventListener("message",P=>{self.dispatchEvent(new MessageEvent("message",{data:P.data}))}),E.start(),self.Worker=class{constructor(){throw new TypeError("Nested workers from within nested worker are NOT supported.")}},importScripts(L)};self.addEventListener("message",D)}.toString();class p extends EventTarget{constructor(L,D,T){super();this.onmessage=null,this.onmessageerror=null,this.onerror=null;const E=`((${o})('${D}'))`,P=new Blob([E],{type:"application/javascript"}),R=URL.createObjectURL(P),y=new MessageChannel,m=R,I={type:"_newWorker",id:m,port:y.port2,url:R,options:T};L(I,[y.port2]),this.postMessage=y.port1.postMessage.bind(y.port1),this.terminate=()=>{L({type:"_terminateWorker",id:m}),URL.revokeObjectURL(R),y.port1.close(),y.port2.close()},Object.defineProperties(this,{onmessage:{get(){return y.port1.onmessage},set(f){y.port1.onmessage=f}},onmessageerror:{get(){return y.port1.onmessageerror},set(f){y.port1.onmessageerror=f}}}),y.port1.addEventListener("messageerror",f=>{const h=new MessageEvent("messageerror",{data:f.data});this.dispatchEvent(h)}),y.port1.addEventListener("message",f=>{const h=new MessageEvent("message",{data:f.data});this.dispatchEvent(h)}),y.port1.start()}}e.NestedWorker=p}),define(De[223],Ce([1,0,4,30,38,3,39,11,13]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.registerLogChannel=e.Extensions=e.OutputChannelUpdateMode=e.IOutputService=e.CONTEXT_OUTPUT_SCROLL_LOCK=e.CONTEXT_ACTIVE_LOG_OUTPUT=e.CONTEXT_IN_OUTPUT=e.MAX_OUTPUT_LENGTH=e.OUTPUT_SERVICE_ID=e.OUTPUT_VIEW_ID=e.LOG_MODE_ID=e.LOG_SCHEME=e.LOG_MIME=e.OUTPUT_MODE_ID=e.OUTPUT_SCHEME=e.OUTPUT_MIME=void 0,e.OUTPUT_MIME="text/x-code-output",e.OUTPUT_SCHEME="output",e.OUTPUT_MODE_ID="Log",e.LOG_MIME="text/x-code-log-output",e.LOG_SCHEME="log",e.LOG_MODE_ID="log",e.OUTPUT_VIEW_ID="workbench.panel.output",e.OUTPUT_SERVICE_ID="outputService",e.MAX_OUTPUT_LENGTH=1e4*100,e.CONTEXT_IN_OUTPUT=new b.RawContextKey("inOutput",!1),e.CONTEXT_ACTIVE_LOG_OUTPUT=new b.RawContextKey("activeLogOutput",!1),e.CONTEXT_OUTPUT_SCROLL_LOCK=new b.RawContextKey("outputView.scrollLock",!1),e.IOutputService=(0,L.createDecorator)(e.OUTPUT_SERVICE_ID);var P;(function(I){I[I.Append=1]="Append",I[I.Replace=2]="Replace",I[I.Clear=3]="Clear"})(P=e.OutputChannelUpdateMode||(e.OutputChannelUpdateMode={})),e.Extensions={OutputChannels:"workbench.contributions.outputChannels"};class R{constructor(){this.channels=new Map,this._onDidRegisterChannel=new o.Emitter,this.onDidRegisterChannel=this._onDidRegisterChannel.event,this._onDidRemoveChannel=new o.Emitter,this.onDidRemoveChannel=this._onDidRemoveChannel.event}registerChannel(f){this.channels.has(f.id)||(this.channels.set(f.id,f),this._onDidRegisterChannel.fire(f.id))}getChannels(){const f=[];return this.channels.forEach(h=>f.push(h)),f}getChannel(f){return this.channels.get(f)}removeChannel(f){this.channels.delete(f),this._onDidRemoveChannel.fire(f)}}p.Registry.add(e.Extensions.OutputChannels,new R);function y(I,f,h,d,a){return(0,E.createCancelablePromise)(async v=>{await(0,D.whenProviderRegistered)(h,d);const A=p.Registry.as(e.Extensions.OutputChannels);try{await m(h,1,d,a,v),A.registerChannel({id:I,label:f,file:h,log:!0})}catch(l){(0,T.isCancellationError)(l)||a.error("Error while registering log channel",h.toString(),(0,T.getErrorMessage)(l))}})}e.registerLogChannel=y;async function m(I,f,h,d,a){if(!await h.exists(I)){if(a.isCancellationRequested)throw new T.CancellationError;if(f>10)throw new Error("Timed out while waiting for file to be created");d.debug("[Registering Log Channel] File does not exist. Waiting for 1s to retry.",I.toString()),await(0,E.timeout)(1e3,a),await m(I,f+1,h,d,a)}}}),define(De[98],Ce([1,0,5,7,3,15,14,223,51,28,35,111,22,10]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostOutputService=e.ExtHostOutputService=e.ExtHostOutputChannel=void 0;class f extends p.Disposable{constructor(a,v,A,l){super();this.id=a,this.name=v,this.logger=A,this.proxy=l,this.offset=0,this.visible=!1,this._disposed=!1}get disposed(){return this._disposed}appendLine(a){this.append(a+`
`)}append(a){this.write(a),this.visible&&(this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Append))}clear(){const a=this.offset;this.logger.flush(),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Clear,a)}replace(a){const v=this.offset;this.write(a),this.proxy.$update(this.id,T.OutputChannelUpdateMode.Replace,v),this.visible&&this.logger.flush()}show(a,v){this.logger.flush(),this.proxy.$reveal(this.id,!!(typeof a=="boolean"?a:v))}hide(){this.proxy.$close(this.id)}write(a){this.offset+=m.VSBuffer.fromString(a).byteLength,this.logger.info(a)}dispose(){super.dispose(),this._disposed||(this.proxy.$dispose(this.id),this._disposed=!0)}}e.ExtHostOutputChannel=f;let h=class{constructor(a,v,A,l,_){this.extHostFileSystem=A,this.extHostFileSystemInfo=l,this.loggerService=_,this.namePool=1,this.channels=new Map,this.visibleChannelId=null,this.proxy=a.getProxy(o.MainContext.MainThreadOutputService),this.outputsLocation=this.extHostFileSystemInfo.extUri.joinPath(v.logsLocation,`output_logging_${(0,y.toLocalISOString)(new Date).replace(/-|:|\.\d+Z$/g,"")}`)}$setVisibleChannel(a){this.visibleChannelId=a;for(const[v,A]of this.channels)A.visible=v===this.visibleChannelId}createOutputChannel(a,v,A){if(a=a.trim(),!a)throw new Error("illegal argument `name`. must not be falsy");if((0,I.isString)(v)&&!v.trim())throw new Error("illegal argument `languageId`. must not be empty");const l=this.doCreateOutputChannel(a,v,A);return l.then(_=>{this.channels.set(_.id,_),_.visible=_.id===this.visibleChannelId}),this.createExtHostOutputChannel(a,l)}async doCreateOutputChannel(a,v,A){const l=await this.createOutputDirectory(),_=this.extHostFileSystemInfo.extUri.joinPath(l,`${this.namePool++}-${a.replace(/[\\/:\*\?"<>\|]/g,"")}.log`),s=this.loggerService.createLogger(_,{always:!0,donotRotate:!0,donotUseFormatters:!0}),u=await this.proxy.$register(a,!1,_,v,A.identifier.value);return new f(u,a,s,this.proxy)}createOutputDirectory(){return this.outputDirectoryPromise||(this.outputDirectoryPromise=this.extHostFileSystem.value.createDirectory(this.outputsLocation).then(()=>this.outputsLocation)),this.outputDirectoryPromise}createExtHostOutputChannel(a,v){let A=!1;const l=()=>{if(A)throw new Error("Channel has been closed")};return{get name(){return a},append(_){l(),v.then(s=>s.append(_))},appendLine(_){l(),v.then(s=>s.appendLine(_))},clear(){l(),v.then(_=>_.clear())},replace(_){l(),v.then(s=>s.replace(_))},show(_,s){l(),v.then(u=>u.show(_,s))},hide(){l(),v.then(_=>_.hide())},dispose(){A=!0,v.then(_=>_.dispose())}}}};h=ze([xe(0,L.IExtHostRpcService),xe(1,P.IExtHostInitDataService),xe(2,E.IExtHostConsumerFileSystem),xe(3,R.IExtHostFileSystemInfo),xe(4,D.ILoggerService)],h),e.ExtHostOutputService=h,e.IExtHostOutputService=(0,b.createDecorator)("IExtHostOutputService")}),define(De[224],Ce([1,0,3]),function(te,e,o){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IRemoteAgentService=e.RemoteExtensionLogFileName=void 0,e.RemoteExtensionLogFileName="remoteagent",e.IRemoteAgentService=(0,o.createDecorator)("remoteAgentService")}),define(De[225],Ce([1,0,37,12,19,23,21,2,3,156,45,177,224]),function(te,e,o,p,b,L,D,T,E,P,R,y,m){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.AbstractPathService=e.IPathService=void 0,e.IPathService=(0,E.createDecorator)("pathService");let I=class Yi{constructor(h,d,a,v){this.localUserHome=h,this.remoteAgentService=d,this.environmentService=a,this.contextService=v,this.resolveOS=(async()=>(await this.remoteAgentService.getEnvironment())?.os||L.OS)(),this.resolveUserHome=(async()=>{const A=await this.remoteAgentService.getEnvironment();return this.maybeUnresolvedUserHome=A?.userHome??h})()}hasValidBasename(h,d,a){return typeof d=="string"||typeof d=="undefined"?this.resolveOS.then(v=>this.doHasValidBasename(h,v,d)):this.doHasValidBasename(h,d,a)}doHasValidBasename(h,d,a){return h.scheme===p.Schemas.file||h.scheme===p.Schemas.vscodeRemote?(0,o.isValidBasename)(a??(0,D.basename)(h),d===1):!0}get defaultUriScheme(){return Yi.findDefaultUriScheme(this.environmentService,this.contextService)}static findDefaultUriScheme(h,d){if(h.remoteAuthority)return p.Schemas.vscodeRemote;const a=(0,P.getVirtualWorkspaceScheme)(d.getWorkspace());if(a)return a;const v=d.getWorkspace().folders[0];if(v)return v.uri.scheme;const A=d.getWorkspace().configuration;return A?A.scheme:p.Schemas.file}userHome(h){return h?.preferLocal?this.localUserHome:this.resolveUserHome}get resolvedUserHome(){return this.maybeUnresolvedUserHome}get path(){return this.resolveOS.then(h=>h===1?b.win32:b.posix)}async fileURI(h){let d="";if(await this.resolveOS===1&&(h=h.replace(/\\/g,"/")),h[0]==="/"&&h[1]==="/"){const v=h.indexOf("/",2);v===-1?(d=h.substring(2),h="/"):(d=h.substring(2,v),h=h.substring(v)||"/")}return T.URI.from({scheme:p.Schemas.file,authority:d,path:h,query:"",fragment:""})}};I=ze([xe(1,m.IRemoteAgentService),xe(2,y.IWorkbenchEnvironmentService),xe(3,R.IWorkspaceContextService)],I),e.AbstractPathService=I}),define(De[99],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TextSearchCompleteMessageType=e.Range=e.Position=void 0;class o{constructor(D,T){this.line=D,this.character=T}isBefore(D){return!1}isBeforeOrEqual(D){return!1}isAfter(D){return!1}isAfterOrEqual(D){return!1}isEqual(D){return!1}compareTo(D){return 0}translate(D,T){return new o(0,0)}with(D){return new o(0,0)}}e.Position=o;class p{constructor(D,T,E,P){this.isEmpty=!1,this.isSingleLine=!1,this.start=new o(D,T),this.end=new o(E,P)}contains(D){return!1}isEqual(D){return!1}intersection(D){}union(D){return new p(0,0,0,0)}with(D){return new p(0,0,0,0)}}e.Range=p;var b;(function(L){L[L.Information=1]="Information",L[L.Warning=2]="Warning"})(b=e.TextSearchCompleteMessageType||(e.TextSearchCompleteMessageType={}))}),define(De[41],Ce([1,0,16,34,26,37,9,3,19,11,99,13]),function(te,e,o,p,b,L,D,T,E,P,R,y){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.hasSiblingFn=e.hasSiblingPromiseFn=e.QueryGlobTester=e.resolvePatternsForProvider=e.SerializableFileMatch=e.isFilePatternMatch=e.isSerializedFileMatch=e.isSerializedSearchSuccess=e.isSerializedSearchComplete=e.serializeSearchError=e.deserializeSearchError=e.SearchError=e.SearchErrorCode=e.pathIncludedInQuery=e.getExcludes=e.SearchSortOrder=e.OneLineRange=e.SearchRange=e.TextSearchMatch=e.FileMatch=e.SearchCompletionExitCode=e.isProgressMessage=e.isFileMatch=e.resultIsMatch=e.QueryType=e.SearchProviderType=e.ISearchService=e.SEARCH_EXCLUDE_CONFIG=e.VIEW_ID=e.PANEL_ID=e.VIEWLET_ID=e.TextSearchCompleteMessageType=void 0,Object.defineProperty(e,"TextSearchCompleteMessageType",{enumerable:!0,get:function(){return R.TextSearchCompleteMessageType}}),e.VIEWLET_ID="workbench.view.search",e.PANEL_ID="workbench.panel.search",e.VIEW_ID="workbench.view.search",e.SEARCH_EXCLUDE_CONFIG="search.exclude";const m="\u27EA ",I=" characters skipped \u27EB",f=(m.length+I.length+5)*2;e.ISearchService=(0,T.createDecorator)("searchService");var h;(function(re){re[re.file=0]="file",re[re.text=1]="text"})(h=e.SearchProviderType||(e.SearchProviderType={}));var d;(function(re){re[re.File=1]="File",re[re.Text=2]="Text"})(d=e.QueryType||(e.QueryType={}));function a(re){return!!re.preview}e.resultIsMatch=a;function v(re){return!!re.resource}e.isFileMatch=v;function A(re){return!!re.message}e.isProgressMessage=A;var l;(function(re){re[re.Normal=0]="Normal",re[re.NewSearchStarted=1]="NewSearchStarted"})(l=e.SearchCompletionExitCode||(e.SearchCompletionExitCode={}));class _{constructor(fe){this.resource=fe,this.results=[]}}e.FileMatch=_;class s{constructor(fe,ie,Ee){this.ranges=ie;const be=Array.isArray(ie)?ie:[ie];if(Ee&&Ee.matchLines===1&&u(be)){fe=(0,D.getNLines)(fe,Ee.matchLines);let ee="",ve=0,Ae=0;const Fe=Math.floor(Ee.charsPerLine/5),$e=[];for(const Qe of be){const Ie=Math.max(Qe.startColumn-Fe,0),Se=Qe.startColumn+Ee.charsPerLine;if(Ie>Ae+Fe+f){const Te=m+(Ie-Ae)+I;ee+=Te+fe.slice(Ie,Se),ve+=Ie-(Ae+Te.length)}else ee+=fe.slice(Ae,Se);$e.push(new i(0,Qe.startColumn-ve,Qe.endColumn-ve)),Ae=Se}this.preview={text:ee,matches:Array.isArray(this.ranges)?$e:$e[0]}}else{const ee=Array.isArray(ie)?ie[0].startLineNumber:ie.startLineNumber;this.preview={text:fe,matches:(0,o.mapArrayOrNot)(ie,ve=>new n(ve.startLineNumber-ee,ve.startColumn,ve.endLineNumber-ee,ve.endColumn))}}}}e.TextSearchMatch=s;function u(re){const fe=re[0].startLineNumber;for(const ie of re)if(ie.startLineNumber!==fe||ie.endLineNumber!==fe)return!1;return!0}class n{constructor(fe,ie,Ee,be){this.startLineNumber=fe,this.startColumn=ie,this.endLineNumber=Ee,this.endColumn=be}}e.SearchRange=n;class i extends n{constructor(fe,ie,Ee){super(fe,ie,fe,Ee)}}e.OneLineRange=i;var r;(function(re){re.Default="default",re.FileNames="fileNames",re.Type="type",re.Modified="modified",re.CountDescending="countDescending",re.CountAscending="countAscending"})(r=e.SearchSortOrder||(e.SearchSortOrder={}));function t(re,fe=!0){const ie=re&&re.files&&re.files.exclude,Ee=fe&&re&&re.search&&re.search.exclude;if(!ie&&!Ee)return;if(!ie||!Ee)return ie||Ee;let be=Object.create(null);return be=b.mixin(be,b.deepClone(ie)),be=b.mixin(be,b.deepClone(Ee),!0),be}e.getExcludes=t;function c(re,fe){return re.excludePattern&&p.match(re.excludePattern,fe)?!1:re.includePattern||re.usingSearchPaths?re.includePattern&&p.match(re.includePattern,fe)?!0:re.usingSearchPaths?!!re.folderQueries&&re.folderQueries.some(ie=>{const Ee=ie.folder.fsPath;if(L.isEqualOrParent(fe,Ee)){const be=E.relative(Ee,fe);return!ie.includePattern||!!p.match(ie.includePattern,be)}else return!1}):!1:!0}e.pathIncludedInQuery=c;var w;(function(re){re[re.unknownEncoding=1]="unknownEncoding",re[re.regexParseError=2]="regexParseError",re[re.globParseError=3]="globParseError",re[re.invalidLiteral=4]="invalidLiteral",re[re.rgProcessError=5]="rgProcessError",re[re.other=6]="other",re[re.canceled=7]="canceled"})(w=e.SearchErrorCode||(e.SearchErrorCode={}));class g extends Error{constructor(fe,ie){super(fe);this.code=ie}}e.SearchError=g;function C(re){const fe=re.message;if((0,P.isCancellationError)(re))return new g(fe,w.canceled);try{const ie=JSON.parse(fe);return new g(ie.message,ie.code)}catch{return new g(fe,w.other)}}e.deserializeSearchError=C;function U(re){const fe={message:re.message,code:re.code};return new Error(JSON.stringify(fe))}e.serializeSearchError=U;function W(re){return re.type==="error"?!0:re.type==="success"}e.isSerializedSearchComplete=W;function M(re){return re.type==="success"}e.isSerializedSearchSuccess=M;function S(re){return!!re.path}e.isSerializedFileMatch=S;function z(re,fe){const ie=re.searchPath?re.searchPath:re.relativePath;return(0,D.fuzzyContains)(ie,fe)}e.isFilePatternMatch=z;class ${constructor(fe){this.path=fe,this.results=[]}addMatch(fe){this.results.push(fe)}serialize(){return{path:this.path,results:this.results,numMatches:this.results.length}}}e.SerializableFileMatch=$;function N(re,fe){const ie={...re||{},...fe||{}};return Object.keys(ie).filter(Ee=>{const be=ie[Ee];return typeof be=="boolean"&&be})}e.resolvePatternsForProvider=N;class K{constructor(fe,ie){this._parsedIncludeExpression=null,this._excludeExpression={...fe.excludePattern||{},...ie.excludePattern||{}},this._parsedExcludeExpression=p.parse(this._excludeExpression);let Ee=fe.includePattern;ie.includePattern&&(Ee?Ee={...Ee,...ie.includePattern}:Ee=ie.includePattern),Ee&&(this._parsedIncludeExpression=p.parse(Ee))}matchesExcludesSync(fe,ie,Ee){return!!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,ie,Ee))}includedInQuerySync(fe,ie,Ee){return!(this._parsedExcludeExpression&&this._parsedExcludeExpression(fe,ie,Ee)||this._parsedIncludeExpression&&!this._parsedIncludeExpression(fe,ie,Ee))}includedInQuery(fe,ie,Ee){const be=this._parsedExcludeExpression(fe,ie,Ee),ee=()=>this._parsedIncludeExpression?!!this._parsedIncludeExpression(fe,ie,Ee):!0;return(0,y.isThenable)(be)?be.then(ve=>ve?!1:ee()):ee()}hasSiblingExcludeClauses(){return V(this._excludeExpression)}}e.QueryGlobTester=K;function V(re){for(const fe in re)if(typeof re[fe]!="boolean")return!0;return!1}function F(re){if(!re)return;let fe;return ie=>(fe||(fe=(re()||Promise.resolve([])).then(Ee=>Ee?ce(Ee):{})),fe.then(Ee=>!!Ee[ie]))}e.hasSiblingPromiseFn=F;function ne(re){if(!re)return;let fe;return ie=>{if(!fe){const Ee=re();fe=Ee?ce(Ee):{}}return!!fe[ie]}}e.hasSiblingFn=ne;function ce(re){const fe={};for(const ie of re)fe[ie]=!0;return fe}}),define(De[31],Ce([1,0,16,13,20,4,25,12,106,21,9,10,2,134,3,14,148,45,35,28,15,8,6,41,5]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l,_,s,u,n){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostWorkspace=e.ExtHostWorkspace=void 0;function i(W,M,S){return new P.ExtUri(z=>w(z,S)).isEqual(W,M)}function r(W,M,S){return i(W.uri,M.uri,S)?0:(0,R.compare)(W.uri.toString(),M.uri.toString())}function t(W,M,S){return W.index!==M.index?W.index<M.index?-1:1:i(W.uri,M.uri,S)?(0,R.compare)(W.name,M.name):(0,R.compare)(W.uri.toString(),M.uri.toString())}function c(W,M,S,z){const $=W.slice(0).sort((K,V)=>S(K,V,z)),N=M.slice(0).sort((K,V)=>S(K,V,z));return(0,o.delta)($,N,(K,V)=>S(K,V,z))}function w(W,M){const S=M.getCapabilities(W.scheme);return!(S&&S&1024)}class g extends a.Workspace{constructor(M,S,z,$,N,K,V){super(M,z.map(F=>new a.WorkspaceFolder(F)),$,N,V);this._name=S,this._isUntitled=K,this._workspaceFolders=[],this._structure=D.TernarySearchTree.forUris(V),z.forEach(F=>{this._workspaceFolders.push(F),this._structure.set(F.uri,F)})}static toExtHostWorkspace(M,S,z,$){if(!M)return{workspace:null,added:[],removed:[]};const{id:N,name:K,folders:V,configuration:F,transient:ne,isUntitled:ce}=M,re=[],fe=S;S?V.forEach((ee,ve)=>{const Ae=m.URI.revive(ee.uri),Fe=g._findFolder(z||S,Ae,$);Fe?(Fe.name=ee.name,Fe.index=ee.index,re.push(Fe)):re.push({uri:Ae,name:ee.name,index:ve})}):re.push(...V.map(({uri:ee,name:ve,index:Ae})=>({uri:m.URI.revive(ee),name:ve,index:Ae}))),re.sort((ee,ve)=>ee.index<ve.index?-1:1);const ie=new g(N,K,re,!!ne,F?m.URI.revive(F):null,!!ce,ee=>w(ee,$)),{added:Ee,removed:be}=c(fe?fe.workspaceFolders:[],ie.workspaceFolders,r,$);return{workspace:ie,added:Ee,removed:be}}static _findFolder(M,S,z){for(let $=0;$<M.folders.length;$++){const N=M.workspaceFolders[$];if(i(N.uri,S,z))return N}}get name(){return this._name}get isUntitled(){return this._isUntitled}get workspaceFolders(){return this._workspaceFolders.slice(0)}getWorkspaceFolder(M,S){return S&&this._structure.get(M)&&(M=(0,P.dirname)(M)),this._structure.findSubstr(M)}resolveWorkspaceFolder(M){return this._structure.get(M)}}let C=class{constructor(M,S,z,$){this._onDidChangeWorkspace=new L.Emitter,this.onDidChangeWorkspace=this._onDidChangeWorkspace.event,this._onDidGrantWorkspaceTrust=new L.Emitter,this.onDidGrantWorkspaceTrust=this._onDidGrantWorkspaceTrust.event,this._activeSearchCallbacks=[],this._trusted=!1,this._logService=$,this._extHostFileSystemInfo=z,this._requestIdProvider=new E.Counter,this._barrier=new p.Barrier,this._proxy=M.getProxy(n.MainContext.MainThreadWorkspace),this._messageService=M.getProxy(n.MainContext.MainThreadMessageService);const N=S.workspace;this._confirmedWorkspace=N?new g(N.id,N.name,[],!!N.transient,N.configuration?m.URI.revive(N.configuration):null,!!N.isUntitled,K=>w(K,z)):void 0}$initializeWorkspace(M,S){this._trusted=S,this.$acceptWorkspaceData(M),this._barrier.open()}waitForInitializeCall(){return this._barrier.wait()}get workspace(){return this._actualWorkspace}get name(){return this._actualWorkspace?this._actualWorkspace.name:void 0}get workspaceFile(){if(this._actualWorkspace&&this._actualWorkspace.configuration)return this._actualWorkspace.isUntitled?m.URI.from({scheme:T.Schemas.untitled,path:(0,P.basename)((0,P.dirname)(this._actualWorkspace.configuration))}):this._actualWorkspace.configuration}get _actualWorkspace(){return this._unconfirmedWorkspace||this._confirmedWorkspace}getWorkspaceFolders(){if(!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}async getWorkspaceFolders2(){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.workspaceFolders.slice(0)}updateWorkspaceFolders(M,S,z,...$){const N=[];if(Array.isArray($)&&$.forEach(ce=>{m.URI.isUri(ce.uri)&&!N.some(re=>i(re.uri,ce.uri,this._extHostFileSystemInfo))&&N.push({uri:ce.uri,name:ce.name||(0,P.basenameOrAuthority)(ce.uri)})}),this._unconfirmedWorkspace||[S,z].some(ce=>typeof ce!="number"||ce<0)||z===0&&N.length===0)return!1;const K=this._actualWorkspace?this._actualWorkspace.workspaceFolders:[];if(S+z>K.length)return!1;const V=K.slice(0);V.splice(S,z,...N.map(ce=>({uri:ce.uri,name:ce.name||(0,P.basenameOrAuthority)(ce.uri),index:void 0})));for(let ce=0;ce<V.length;ce++){const re=V[ce];if(V.some((fe,ie)=>ie!==ce&&i(re.uri,fe.uri,this._extHostFileSystemInfo)))return!1}V.forEach((ce,re)=>ce.index=re);const{added:F,removed:ne}=c(K,V,t,this._extHostFileSystemInfo);if(F.length===0&&ne.length===0)return!1;if(this._proxy){const ce=M.displayName||M.name;this._proxy.$updateWorkspaceFolders(ce,S,z,N).then(void 0,re=>{this._unconfirmedWorkspace=void 0;const fe={source:{identifier:M.identifier,label:M.displayName||M.name}};this._messageService.$showMessage(d.Severity.Error,(0,I.localize)(0,null,ce,re.toString()),fe,[])})}return this.trySetWorkspaceFolders(V),!0}getWorkspaceFolder(M,S){if(!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,S)}async getWorkspaceFolder2(M,S){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.getWorkspaceFolder(M,S)}async resolveWorkspaceFolder(M){if(await this._barrier.wait(),!!this._actualWorkspace)return this._actualWorkspace.resolveWorkspaceFolder(M)}getPath(){if(!this._actualWorkspace)return;const{folders:M}=this._actualWorkspace;if(M.length!==0)return M[0].uri.fsPath}getRelativePath(M,S){let z,$="";if(typeof M=="string"?(z=m.URI.file(M),$=M):typeof M!="undefined"&&(z=M,$=M.fsPath),!z)return $;const N=this.getWorkspaceFolder(z,!0);if(!N)return $;typeof S=="undefined"&&this._actualWorkspace&&(S=this._actualWorkspace.folders.length>1);let K=(0,P.relativePath)(N.uri,z);return S&&N.name&&(K=`${N.name}/${K}`),K}trySetWorkspaceFolders(M){this._actualWorkspace&&(this._unconfirmedWorkspace=g.toExtHostWorkspace({id:this._actualWorkspace.id,name:this._actualWorkspace.name,configuration:this._actualWorkspace.configuration,folders:M,isUntitled:this._actualWorkspace.isUntitled},this._actualWorkspace,void 0,this._extHostFileSystemInfo).workspace||void 0)}$acceptWorkspaceData(M){const{workspace:S,added:z,removed:$}=g.toExtHostWorkspace(M,this._confirmedWorkspace,this._unconfirmedWorkspace,this._extHostFileSystemInfo);this._confirmedWorkspace=S||void 0,this._unconfirmedWorkspace=void 0,this._onDidChangeWorkspace.fire(Object.freeze({added:z,removed:$}))}findFiles(M,S,z,$,N=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findFiles: fileSearch, extension: ${$.value}, entryPoint: findFiles`);let K;if(S===null?K=!1:S&&(typeof S=="string"?K=S:K=S.pattern),N&&N.isCancellationRequested)return Promise.resolve([]);const{includePattern:V,folder:F}=U(_.GlobPattern.from(M));return this._proxy.$startFileSearch((0,y.withUndefinedAsNull)(V),(0,y.withUndefinedAsNull)(F),(0,y.withUndefinedAsNull)(K),(0,y.withUndefinedAsNull)(z),N).then(ne=>Array.isArray(ne)?ne.map(ce=>m.URI.revive(ce)):[])}async findTextInFiles(M,S,z,$,N=b.CancellationToken.None){this._logService.trace(`extHostWorkspace#findTextInFiles: textSearch, extension: ${$.value}, entryPoint: findTextInFiles`);const K=this._requestIdProvider.getNext(),V=typeof S.previewOptions=="undefined"?{matchLines:100,charsPerLine:1e4}:S.previewOptions,{includePattern:F,folder:ne}=U(_.GlobPattern.from(S.include)),ce=typeof S.exclude=="string"?S.exclude:S.exclude?S.exclude.pattern:void 0,re={ignoreSymlinks:typeof S.followSymlinks=="boolean"?!S.followSymlinks:void 0,disregardIgnoreFiles:typeof S.useIgnoreFiles=="boolean"?!S.useIgnoreFiles:void 0,disregardGlobalIgnoreFiles:typeof S.useGlobalIgnoreFiles=="boolean"?!S.useGlobalIgnoreFiles:void 0,disregardParentIgnoreFiles:typeof S.useParentIgnoreFiles=="boolean"?!S.useParentIgnoreFiles:void 0,disregardExcludeSettings:typeof S.useDefaultExcludes=="boolean"?!S.useDefaultExcludes:!0,fileEncoding:S.encoding,maxResults:S.maxResults,previewOptions:V,afterContext:S.afterContext,beforeContext:S.beforeContext,includePattern:F,excludePattern:ce},fe=!1;if(this._activeSearchCallbacks[K]=ie=>{if(fe)return;const Ee=m.URI.revive(ie.resource);ie.results.forEach(be=>{(0,u.resultIsMatch)(be)?z({uri:Ee,preview:{text:be.preview.text,matches:(0,o.mapArrayOrNot)(be.preview.matches,ee=>new s.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))},ranges:(0,o.mapArrayOrNot)(be.ranges,ee=>new s.Range(ee.startLineNumber,ee.startColumn,ee.endLineNumber,ee.endColumn))}):z({uri:Ee,text:be.text,lineNumber:be.lineNumber})})},N.isCancellationRequested)return{};try{const ie=await this._proxy.$startTextSearch(M,(0,y.withUndefinedAsNull)(ne),re,K,N);return delete this._activeSearchCallbacks[K],ie||{}}catch(ie){throw delete this._activeSearchCallbacks[K],ie}}$handleTextSearchResult(M,S){this._activeSearchCallbacks[S]?.(M)}saveAll(M){return this._proxy.$saveAll(M)}resolveProxy(M){return this._proxy.$resolveProxy(M)}get trusted(){return this._trusted}requestWorkspaceTrust(M){return this._proxy.$requestWorkspaceTrust(M)}$onDidGrantWorkspaceTrust(){this._trusted||(this._trusted=!0,this._onDidGrantWorkspaceTrust.fire())}};C=ze([xe(0,l.IExtHostRpcService),xe(1,A.IExtHostInitDataService),xe(2,v.IExtHostFileSystemInfo),xe(3,h.ILogService)],C),e.ExtHostWorkspace=C,e.IExtHostWorkspace=(0,f.createDecorator)("IExtHostWorkspace");function U(W){let M,S;return W&&(typeof W=="string"?M=W:(M=W.pattern,S=m.URI.revive(W.baseUri))),{includePattern:M,folder:S}}}),define(De[32],Ce([1,0,26,4,31,5,6,151,83,10,13,3,15,14,2]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostConfiguration=e.ExtHostConfigProvider=e.ExtHostConfiguration=void 0;function h(u,n){if(n){const i=n.split(".");let r=u;for(let t=0;r&&t<i.length;t++)r=r[i[t]];return r}}function d(u){return u instanceof f.URI}function a(u){return u&&u.uri instanceof f.URI&&u.languageId&&typeof u.languageId=="string"}function v(u){return u&&!u.uri&&u.languageId&&typeof u.languageId=="string"}function A(u){return u&&u.uri instanceof f.URI&&(!u.name||typeof u.name=="string")&&(!u.index||typeof u.index=="number")}function l(u){if(d(u))return{resource:u};if(a(u))return{resource:u.uri,overrideIdentifier:u.languageId};if(v(u))return{overrideIdentifier:u.languageId};if(A(u))return{resource:u.uri};if(u===null)return{resource:null}}let _=class{constructor(n,i,r){this._proxy=n.getProxy(L.MainContext.MainThreadConfiguration),this._extHostWorkspace=i,this._logService=r,this._barrier=new R.Barrier,this._actual=null}getConfigProvider(){return this._barrier.wait().then(n=>this._actual)}$initializeConfiguration(n){this._actual=new s(this._proxy,this._extHostWorkspace,n,this._logService),this._barrier.open()}$acceptConfigurationChanged(n,i){this.getConfigProvider().then(r=>r.$acceptConfigurationChanged(n,i))}};_=ze([xe(0,m.IExtHostRpcService),xe(1,b.IExtHostWorkspace),xe(2,I.ILogService)],_),e.ExtHostConfiguration=_;class s{constructor(n,i,r,t){this._onDidChangeConfiguration=new p.Emitter,this._proxy=n,this._logService=t,this._extHostWorkspace=i,this._configuration=T.Configuration.parse(r),this._configurationScopes=this._toMap(r.configurationScopes)}get onDidChangeConfiguration(){return this._onDidChangeConfiguration&&this._onDidChangeConfiguration.event}$acceptConfigurationChanged(n,i){const r={data:this._configuration.toData(),workspace:this._extHostWorkspace.workspace};this._configuration=T.Configuration.parse(n),this._configurationScopes=this._toMap(n.configurationScopes),this._onDidChangeConfiguration.fire(this._toConfigurationChangeEvent(i,r))}getConfiguration(n,i,r){const t=l(i)||{},c=this._toReadonlyValue(n?h(this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace),n):this._configuration.getValue(void 0,t,this._extHostWorkspace.workspace));n&&this._validateConfigurationAccess(n,t,r?.identifier);function w(C){if(C==null)return null;if(typeof C=="boolean")return C?2:5;switch(C){case D.ConfigurationTarget.Global:return 2;case D.ConfigurationTarget.Workspace:return 5;case D.ConfigurationTarget.WorkspaceFolder:return 6}}const g={has(C){return typeof h(c,C)!="undefined"},get:(C,U)=>{this._validateConfigurationAccess(n?`${n}.${C}`:C,t,r?.identifier);let W=h(c,C);if(typeof W=="undefined")W=U;else{let M;const S=(z,$)=>{let N;const K=()=>{M=M||(0,o.deepClone)(c),N=N||h(M,$)};return(0,P.isObject)(z)?new Proxy(z,{get:(V,F)=>{if(typeof F=="string"&&F.toLowerCase()==="tojson")return K(),()=>N;if(M)return N=N||h(M,$),N[F];const ne=V[F];return typeof F=="string"?S(ne,`${$}.${F}`):ne},set:(V,F,ne)=>(K(),N&&(N[F]=ne),!0),deleteProperty:(V,F)=>(K(),N&&delete N[F],!0),defineProperty:(V,F,ne)=>(K(),N&&Object.defineProperty(N,F,ne),!0)}):z};W=S(W,C)}return W},update:(C,U,W,M)=>{C=n?`${n}.${C}`:C;const S=w(W);return U!==void 0?this._proxy.$updateConfigurationOption(S,C,U,t,M):this._proxy.$removeConfigurationOption(S,C,t,M)},inspect:C=>{C=n?`${n}.${C}`:C;const U=(0,o.deepClone)(this._configuration.inspect(C,t,this._extHostWorkspace.workspace));if(U)return{key:C,defaultValue:U.policy?.value??U.default?.value,globalValue:U.user?.value??U.application?.value,workspaceValue:U.workspace?.value,workspaceFolderValue:U.workspaceFolder?.value,defaultLanguageValue:U.default?.override,globalLanguageValue:U.user?.override??U.application?.override,workspaceLanguageValue:U.workspace?.override,workspaceFolderLanguageValue:U.workspaceFolder?.override,languageIds:U.overrideIdentifiers}}};return typeof c=="object"&&(0,o.mixin)(g,c,!1),Object.freeze(g)}_toReadonlyValue(n){const i=r=>(0,P.isObject)(r)?new Proxy(r,{get:(t,c)=>i(t[c]),set:(t,c,w)=>{throw new Error(`TypeError: Cannot assign to read only property '${String(c)}' of object`)},deleteProperty:(t,c)=>{throw new Error(`TypeError: Cannot delete read only property '${String(c)}' of object`)},defineProperty:(t,c)=>{throw new Error(`TypeError: Cannot define property '${String(c)}' for a readonly object`)},setPrototypeOf:t=>{throw new Error("TypeError: Cannot set prototype for a readonly object")},isExtensible:()=>!1,preventExtensions:()=>!0}):r;return i(n)}_validateConfigurationAccess(n,i,r){const t=E.OVERRIDE_PROPERTY_REGEX.test(n)?4:this._configurationScopes.get(n),c=r?`[${r.value}] `:"";if(t===4){typeof i?.resource=="undefined"&&this._logService.warn(`${c}Accessing a resource scoped configuration without providing a resource is not expected. To get the effective value for '${n}', provide the URI of a resource or 'null' for any resource.`);return}if(t===3){i?.resource&&this._logService.warn(`${c}Accessing a window scoped configuration for a resource is not expected. To associate '${n}' to a resource, define its scope to 'resource' in configuration contributions in 'package.json'.`);return}}_toConfigurationChangeEvent(n,i){const r=new T.ConfigurationChangeEvent(n,i,this._configuration,this._extHostWorkspace.workspace);return Object.freeze({affectsConfiguration:(t,c)=>r.affectsConfiguration(t,l(c))})}_toMap(n){return n.reduce((i,r)=>(i.set(r[0],r[1]),i),new Map)}}e.ExtHostConfigProvider=s,e.IExtHostConfiguration=(0,y.createDecorator)("IExtHostConfiguration")});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[100],Ce([1,0,2,13,4,5,6,31,49,32,20,52,15,28,3,12,23,14,68,184,11]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l){"use strict";var _;Object.defineProperty(e,"__esModule",{value:!0}),e.IExtHostTask=e.WorkerExtHostTask=e.ExtHostTaskBase=e.TaskExecutionDTO=e.TaskFilterDTO=e.TaskDTO=e.TaskGroupDTO=e.TaskHandleDTO=e.CustomExecutionDTO=e.ShellExecutionDTO=e.ShellExecutionOptionsDTO=e.ProcessExecutionDTO=e.ProcessExecutionOptionsDTO=e.TaskPresentationOptionsDTO=e.TaskDefinitionDTO=void 0;var s;(function($){function N(V){if(V!=null)return V}$.from=N;function K(V){if(V!=null)return V}$.to=K})(s=e.TaskDefinitionDTO||(e.TaskDefinitionDTO={}));var u;(function($){function N(V){if(V!=null)return V}$.from=N;function K(V){if(V!=null)return V}$.to=K})(u=e.TaskPresentationOptionsDTO||(e.TaskPresentationOptionsDTO={}));var n;(function($){function N(V){if(V!=null)return V}$.from=N;function K(V){if(V!=null)return V}$.to=K})(n=e.ProcessExecutionOptionsDTO||(e.ProcessExecutionOptionsDTO={}));var i;(function($){function N(F){if(F){const ne=F;return ne&&!!ne.process}else return!1}$.is=N;function K(F){if(F==null)return;const ne={process:F.process,args:F.args};return F.options&&(ne.options=n.from(F.options)),ne}$.from=K;function V(F){if(F!=null)return new D.ProcessExecution(F.process,F.args,F.options)}$.to=V})(i=e.ProcessExecutionDTO||(e.ProcessExecutionDTO={}));var r;(function($){function N(V){if(V!=null)return V}$.from=N;function K(V){if(V!=null)return V}$.to=K})(r=e.ShellExecutionOptionsDTO||(e.ShellExecutionOptionsDTO={}));var t;(function($){function N(F){if(F){const ne=F;return ne&&(!!ne.commandLine||!!ne.command)}else return!1}$.is=N;function K(F){if(F==null)return;const ne={};return F.commandLine!==void 0?ne.commandLine=F.commandLine:(ne.command=F.command,ne.args=F.args),F.options&&(ne.options=r.from(F.options)),ne}$.from=K;function V(F){if(!(F==null||F.command===void 0&&F.commandLine===void 0))return F.commandLine?new D.ShellExecution(F.commandLine,F.options):new D.ShellExecution(F.command,F.args?F.args:[],F.options)}$.to=V})(t=e.ShellExecutionDTO||(e.ShellExecutionDTO={}));var c;(function($){function N(F){if(F){const ne=F;return ne&&ne.customExecution==="customExecution"}else return!1}$.is=N;function K(F){return{customExecution:"customExecution"}}$.from=K;function V(F,ne){return ne.get(F)}$.to=V})(c=e.CustomExecutionDTO||(e.CustomExecutionDTO={}));var w;(function($){function N(K,V){let F;return K.scope!==void 0&&typeof K.scope!="number"?F=K.scope.uri:K.scope!==void 0&&typeof K.scope=="number"&&(K.scope===D.TaskScope.Workspace&&V&&V.workspaceFile?F=V.workspaceFile:F=A.USER_TASKS_GROUP_KEY),{id:K._id,workspaceFolder:F}}$.from=N})(w=e.TaskHandleDTO||(e.TaskHandleDTO={}));var g;(function($){function N(K){if(K!=null)return{_id:K.id,isDefault:K.isDefault}}$.from=N})(g=e.TaskGroupDTO||(e.TaskGroupDTO={}));var C;(function($){function N(F,ne){if(F==null)return[];const ce=[];for(const re of F){const fe=K(re,ne);fe&&ce.push(fe)}return ce}$.fromMany=N;function K(F,ne){if(F==null)return;let ce;F.execution instanceof D.ProcessExecution?ce=i.from(F.execution):F.execution instanceof D.ShellExecution?ce=t.from(F.execution):F.execution&&F.execution instanceof D.CustomExecution&&(ce=c.from(F.execution));const re=s.from(F.definition);let fe;return F.scope?typeof F.scope=="number"?fe=F.scope:fe=F.scope.uri:fe=D.TaskScope.Workspace,!re||!fe?void 0:{_id:F._id,definition:re,name:F.name,source:{extensionId:ne.identifier.value,label:F.source,scope:fe},execution:ce,isBackground:F.isBackground,group:g.from(F.group),presentationOptions:u.from(F.presentationOptions),problemMatchers:F.problemMatchers,hasDefinedMatchers:F.hasDefinedMatchers,runOptions:F.runOptions?F.runOptions:{reevaluateOnRerun:!0},detail:F.detail}}$.from=K;async function V(F,ne,ce){if(F==null)return;let re;i.is(F.execution)?re=i.to(F.execution):t.is(F.execution)?re=t.to(F.execution):c.is(F.execution)&&(re=c.to(F._id,ce));const fe=s.to(F.definition);let ie;if(F.source&&(F.source.scope!==void 0?typeof F.source.scope=="number"?ie=F.source.scope:ie=await ne.resolveWorkspaceFolder(o.URI.revive(F.source.scope)):ie=D.TaskScope.Workspace),!fe||!ie)return;const Ee=new D.Task(fe,ie,F.name,F.source.label,re,F.problemMatchers);return F.isBackground!==void 0&&(Ee.isBackground=F.isBackground),F.group!==void 0&&(Ee.group=D.TaskGroup.from(F.group._id),Ee.group&&F.group.isDefault&&(Ee.group=new D.TaskGroup(Ee.group.id,Ee.group.label),F.group.isDefault===!0&&(Ee.group.isDefault=F.group.isDefault))),F.presentationOptions&&(Ee.presentationOptions=u.to(F.presentationOptions)),F._id&&(Ee._id=F._id),F.detail&&(Ee.detail=F.detail),Ee}$.to=V})(C=e.TaskDTO||(e.TaskDTO={}));var U;(function($){function N(V){return V}$.from=N;function K(V){if(!!V)return Object.assign(Object.create(null),V)}$.to=K})(U=e.TaskFilterDTO||(e.TaskFilterDTO={}));class W{constructor(N,K,V){this._id=K,this._task=V,_.set(this,void 0),Je(this,_,N,"f")}get task(){return this._task}terminate(){Oe(this,_,"f").terminateTask(this)}fireDidStartProcess(N){}fireDidEndProcess(N){}}_=new WeakMap;var M;(function($){function N(K){return{id:K._id,task:void 0}}$.from=N})(M=e.TaskExecutionDTO||(e.TaskExecutionDTO={}));let S=class{constructor(N,K,V,F,ne,ce,re,fe){this._onDidExecuteTask=new b.Emitter,this._onDidTerminateTask=new b.Emitter,this._onDidTaskProcessStarted=new b.Emitter,this._onDidTaskProcessEnded=new b.Emitter,this._proxy=N.getProxy(L.MainContext.MainThreadTask),this._workspaceProvider=V,this._editorService=F,this._configurationService=ne,this._terminalService=ce,this._handleCounter=0,this._handlers=new Map,this._taskExecutions=new Map,this._taskExecutionPromises=new Map,this._providedCustomExecutions2=new Map,this._notProvidedCustomExecutions=new Set,this._activeCustomExecutions2=new Map,this._logService=re,this._deprecationService=fe,this._proxy.$registerSupportedExecutions(!0)}registerTaskProvider(N,K,V){if(!V)return new D.Disposable(()=>{});const F=this.nextHandle();return this._handlers.set(F,{type:K,provider:V,extension:N}),this._proxy.$registerTaskProvider(F,K),new D.Disposable(()=>{this._handlers.delete(F),this._proxy.$unregisterTaskProvider(F)})}registerTaskSystem(N,K){this._proxy.$registerTaskSystem(N,K)}fetchTasks(N){return this._proxy.$fetchTasks(U.from(N)).then(async K=>{const V=[];for(const F of K){const ne=await C.to(F,this._workspaceProvider,this._providedCustomExecutions2);ne&&V.push(ne)}return V})}get taskExecutions(){const N=[];return this._taskExecutions.forEach(K=>N.push(K)),N}terminateTask(N){if(!(N instanceof W))throw new Error("No valid task execution provided");return this._proxy.$terminateTask(N._id)}get onDidStartTask(){return this._onDidExecuteTask.event}async $onDidStartTask(N,K,V){const F=this._providedCustomExecutions2.get(N.id);F&&(this._activeCustomExecutions2.set(N.id,F),this._terminalService.attachPtyToTerminal(K,await F.callback(V))),this._lastStartedTask=N.id,this._onDidExecuteTask.fire({execution:await this.getTaskExecution(N)})}get onDidEndTask(){return this._onDidTerminateTask.event}async $OnDidEndTask(N){const K=await this.getTaskExecution(N);this._taskExecutionPromises.delete(N.id),this._taskExecutions.delete(N.id),this.customExecutionComplete(N),this._onDidTerminateTask.fire({execution:K})}get onDidStartTaskProcess(){return this._onDidTaskProcessStarted.event}async $onDidStartTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessStarted.fire({execution:K,processId:N.processId})}get onDidEndTaskProcess(){return this._onDidTaskProcessEnded.event}async $onDidEndTaskProcess(N){const K=await this.getTaskExecution(N.id);this._onDidTaskProcessEnded.fire({execution:K,exitCode:N.exitCode})}$provideTasks(N,K){const V=this._handlers.get(N);if(!V)return Promise.reject(new Error("no handler found"));const F=[],ne=(0,p.asPromise)(()=>V.provider.provideTasks(R.CancellationToken.None)).then(ce=>this.provideTasksInternal(K,F,V,ce));return new Promise(ce=>{ne.then(re=>{Promise.all(F).then(()=>{ce(re)})})})}async $resolveTask(N,K){const V=this._handlers.get(N);if(!V)return Promise.reject(new Error("no handler found"));if(K.definition.type!==V.type)throw new Error(`Unexpected: Task of type [${K.definition.type}] cannot be resolved by provider of type [${V.type}].`);const F=await C.to(K,this._workspaceProvider,this._providedCustomExecutions2);if(!F)throw new Error("Unexpected: Task cannot be resolved.");const ne=await V.provider.resolveTask(F,R.CancellationToken.None);if(!ne)return;this.checkDeprecation(ne,V);const ce=C.from(ne,V.extension);if(!ce)throw new Error("Unexpected: Task cannot be resolved.");if(ne.definition!==F.definition)throw new Error("Unexpected: The resolved task definition must be the same object as the original task definition. The task definition cannot be changed.");return c.is(ce.execution)&&await this.addCustomExecution(ce,ne,!0),await this.resolveTaskInternal(ce)}nextHandle(){return this._handleCounter++}async addCustomExecution(N,K,V){const F=await this._proxy.$createTaskId(N);!V&&!this._providedCustomExecutions2.has(F)&&(this._notProvidedCustomExecutions.add(F),this._activeCustomExecutions2.set(F,K.execution)),this._providedCustomExecutions2.set(F,K.execution)}async getTaskExecution(N,K){if(typeof N=="string"){const ne=this._taskExecutionPromises.get(N);if(!ne)throw new Error("Unexpected: The specified task is missing an execution");return ne}const V=this._taskExecutionPromises.get(N.id);if(V)return V;const F=new Promise((ne,ce)=>{function re(fe,ie,Ee){Ee?ne(new W(fe,ie.id,Ee)):ce("Unexpected: Task does not exist.")}K?re(this,N,K):C.to(N.task,this._workspaceProvider,this._providedCustomExecutions2).then(fe=>re(this,N,fe))});return this._taskExecutionPromises.set(N.id,F),F.then(ne=>(this._taskExecutions.set(N.id,ne),ne),ne=>Promise.reject(ne))}checkDeprecation(N,K){N._deprecated&&this._deprecationService.report("Task.constructor",K.extension,"Use the Task constructor that takes a `scope` instead.")}customExecutionComplete(N){this._activeCustomExecutions2.get(N.id)&&this._activeCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.has(N.id)&&this._lastStartedTask!==N.id&&(this._providedCustomExecutions2.delete(N.id),this._notProvidedCustomExecutions.delete(N.id));const V=this._notProvidedCustomExecutions.values();let F=V.next();for(;!F.done;)!this._activeCustomExecutions2.has(F.value)&&this._lastStartedTask!==F.value&&(this._providedCustomExecutions2.delete(F.value),this._notProvidedCustomExecutions.delete(F.value)),F=V.next()}};S=ze([xe(0,m.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,T.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,a.ILogService),xe(7,v.IExtHostApiDeprecationService)],S),e.ExtHostTaskBase=S;let z=class extends S{constructor(N,K,V,F,ne,ce,re,fe){super(N,K,V,F,ne,ce,re,fe);this.registerTaskSystem(h.Schemas.vscodeRemote,{scheme:h.Schemas.vscodeRemote,authority:"",platform:d.PlatformToString(0)})}async executeTask(N,K){if(!K.execution)throw new Error("Tasks to execute must include an execution");const V=C.from(K,N);if(V===void 0)throw new Error("Task is not valid");if(c.is(V.execution))await this.addCustomExecution(V,K,!1);else throw new l.NotSupportedError;const F=await this.getTaskExecution(await this._proxy.$getTaskExecution(V),K);return this._proxy.$executeTask(V).catch(ne=>{throw new Error(ne)}),F}provideTasksInternal(N,K,V,F){const ne=[];if(F)for(const ce of F){this.checkDeprecation(ce,V),(!ce.definition||!N[ce.definition.type])&&this._logService.warn(`The task [${ce.source}, ${ce.name}] uses an undefined task type. The task will be ignored in the future.`);const re=C.from(ce,V.extension);re&&c.is(re.execution)?(ne.push(re),K.push(this.addCustomExecution(re,ce,!0))):this._logService.warn("Only custom execution tasks supported.")}return{tasks:ne,extension:V.extension}}async resolveTaskInternal(N){if(c.is(N.execution))return N;this._logService.warn("Only custom execution tasks supported.")}async $resolveVariables(N,K){return{process:void 0,variables:Object.create(null)}}async $jsonTasksSupported(){return!1}async $findExecutable(N,K,V){}};z=ze([xe(0,m.IExtHostRpcService),xe(1,I.IExtHostInitDataService),xe(2,T.IExtHostWorkspace),xe(3,E.IExtHostDocumentsAndEditors),xe(4,P.IExtHostConfiguration),xe(5,y.IExtHostTerminalService),xe(6,a.ILogService),xe(7,v.IExtHostApiDeprecationService)],z),e.WorkerExtHostTask=z,e.IExtHostTask=(0,f.createDecorator)("IExtHostTask")}),define(De[226],Ce([1,0,19,20,43,34,21,202,41]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.FileSearchManager=void 0;class P{constructor(m,I,f){this.config=m,this.provider=I,this.sessionToken=f,this.isLimitHit=!1,this.resultCount=0,this.isCanceled=!1,this.filePattern=m.filePattern,this.includePattern=m.includePattern&&L.parse(m.includePattern),this.maxResults=m.maxResults||void 0,this.exists=m.exists,this.activeCancellationTokens=new Set,this.globalExcludePattern=m.excludePattern&&L.parse(m.excludePattern)}cancel(){this.isCanceled=!0,this.activeCancellationTokens.forEach(m=>m.cancel()),this.activeCancellationTokens=new Set}search(m){const I=this.config.folderQueries||[];return new Promise((f,h)=>{const d=a=>{this.resultCount++,m(a)};if(this.isCanceled)return f({limitHit:this.isLimitHit});this.config.extraFileResources&&this.config.extraFileResources.forEach(a=>{const v=a.toString(),A=o.basename(v);this.globalExcludePattern&&this.globalExcludePattern(v,A)||this.matchFile(d,{base:a,basename:A})}),Promise.all(I.map(a=>this.searchInFolder(a,d))).then(a=>{f({limitHit:this.isLimitHit,stats:a[0]||void 0})},a=>{h(new Error((0,b.toErrorMessage)(a)))})})}async searchInFolder(m,I){const f=new p.CancellationTokenSource,h=this.getSearchOptionsForFolder(m),d=this.initDirectoryTree(),a=new E.QueryGlobTester(this.config,m),v=!a.hasSiblingExcludeClauses();let A;try{this.activeCancellationTokens.add(f),A=T.StopWatch.create();const l=await this.provider.provideFileSearchResults({pattern:this.config.filePattern||""},h,f.token),_=A.elapsed(),s=T.StopWatch.create();return this.isCanceled&&!this.isLimitHit||(l&&l.forEach(u=>{const n=o.posix.relative(m.folder.path,u.path);if(v){const i=o.basename(u.path);this.matchFile(I,{base:m.folder,relativePath:n,basename:i});return}this.addDirectoryEntries(d,m.folder,n,I)}),this.isCanceled&&!this.isLimitHit)?null:(this.matchDirectoryTree(d,a,I),{providerTime:_,postProcessTime:s.elapsed()})}finally{f.dispose(),this.activeCancellationTokens.delete(f)}}getSearchOptionsForFolder(m){const I=(0,E.resolvePatternsForProvider)(this.config.includePattern,m.includePattern),f=(0,E.resolvePatternsForProvider)(this.config.excludePattern,m.excludePattern);return{folder:m.folder,excludes:f,includes:I,useIgnoreFiles:!m.disregardIgnoreFiles,useGlobalIgnoreFiles:!m.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!m.disregardParentIgnoreFiles,followSymlinks:!m.ignoreSymlinks,maxResults:this.config.maxResults,session:this.sessionToken}}initDirectoryTree(){const m={rootEntries:[],pathToEntries:Object.create(null)};return m.pathToEntries["."]=m.rootEntries,m}addDirectoryEntries({pathToEntries:m},I,f,h){if(f===this.filePattern){const a=o.basename(this.filePattern);this.matchFile(h,{base:I,relativePath:this.filePattern,basename:a})}function d(a){const v=o.basename(a),A=o.dirname(a);let l=m[A];l||(l=m[A]=[],d(A)),l.push({base:I,relativePath:a,basename:v})}d(f)}matchDirectoryTree({rootEntries:m,pathToEntries:I},f,h){const d=this,a=this.filePattern;function v(A){const l=(0,E.hasSiblingFn)(()=>A.map(_=>_.basename));for(let _=0,s=A.length;_<s;_++){const u=A[_],{relativePath:n,basename:i}=u;if(f.matchesExcludesSync(n,i,a!==i?l:void 0))continue;const r=I[n];if(r)v(r);else{if(n===a)continue;d.matchFile(h,u)}if(d.isLimitHit)break}}v(m)}matchFile(m,I){(!this.includePattern||I.relativePath&&this.includePattern(I.relativePath,I.basename))&&((this.exists||this.maxResults&&this.resultCount>=this.maxResults)&&(this.isLimitHit=!0,this.cancel()),this.isLimitHit||m(I))}}class R{constructor(){this.sessions=new Map}fileSearch(m,I,f,h){const d=this.getSessionTokenSource(m.cacheKey),a=new P(m,I,d&&d.token);let v=0;const A=l=>{v+=l.length,f(l.map(_=>this.rawMatchToSearchItem(_)))};return this.doSearch(a,R.BATCH_SIZE,A,h).then(l=>({limitHit:l.limitHit,stats:{fromCache:!1,type:"fileSearchProvider",resultCount:v,detailStats:l.stats}}))}clearCache(m){this.getSessionTokenSource(m)?.cancel()}getSessionTokenSource(m){if(!!m)return this.sessions.has(m)||this.sessions.set(m,new p.CancellationTokenSource),this.sessions.get(m)}rawMatchToSearchItem(m){return m.relativePath?{resource:D.joinPath(m.base,m.relativePath)}:{resource:m.base}}doSearch(m,I,f,h){h.onCancellationRequested(()=>{m.cancel()});const d=v=>{v&&(a.push(v),I>0&&a.length>=I&&(f(a),a=[]))};let a=[];return m.search(d).then(v=>(a.length&&f(a),v),v=>(a.length&&f(a),Promise.reject(v)))}}e.FileSearchManager=R,R.BATCH_SIZE=512}),define(De[227],Ce([1,0,16,72,34,76,25,12,19,21,9,10,2,244,142,57,14,45,90,225,41]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.resolveResourcesForSearchIncludes=e.QueryBuilder=void 0;let _=class{constructor(g,C,U,W,M){this.configurationService=g,this.workspaceContextService=C,this.editorGroupsService=U,this.logService=W,this.pathService=M}text(g,C,U={}){g=this.getContentPattern(g,U);const W=this.configurationService.getValue(),M=C&&C.some(z=>!this.configurationService.getValue({resource:z}).search.useRipgrep);return{...this.commonQuery(C?.map(a.toWorkspaceFolder),U),type:2,contentPattern:g,previewOptions:U.previewOptions,maxFileSize:U.maxFileSize,usePCRE2:W.search.usePCRE2||M||!1,beforeContext:U.beforeContext,afterContext:U.afterContext,userDisabledExcludesAndIgnoreFiles:U.disregardExcludeSettings&&U.disregardIgnoreFiles}}getContentPattern(g,C){const U=this.configurationService.getValue();g.isRegExp&&(g.pattern=g.pattern.replace(/\r?\n/g,"\\n"));const W={...g,wordSeparators:U.editor.wordSeparators};return this.isCaseSensitive(g,C)&&(W.isCaseSensitive=!0),this.isMultiline(g)&&(W.isMultiline=!0),W}file(g,C={}){return{...this.commonQuery(g,C),type:1,filePattern:C.filePattern?C.filePattern.trim():C.filePattern,exists:C.exists,sortByScore:C.sortByScore,cacheKey:C.cacheKey}}handleIncludeExclude(g,C){return g?(g=Array.isArray(g)?g.map(r):r(g),C?this.parseSearchPaths(g):{pattern:u(...Array.isArray(g)?g:[g])}):{}}commonQuery(g=[],C={}){const U=this.handleIncludeExclude(C.includePattern,C.expandPatterns),W=this.handleIncludeExclude(C.excludePattern,C.expandPatterns),M=g.length>1,S=(U.searchPaths&&U.searchPaths.length?U.searchPaths.map(N=>this.getFolderQueryForSearchPath(N,C,W)):g.map(N=>this.getFolderQueryForRoot(N,C,W,M))).filter(N=>!!N),z={_reason:C._reason,folderQueries:S,usingSearchPaths:!!(U.searchPaths&&U.searchPaths.length),extraFileResources:C.extraFileResources,excludePattern:W.pattern,includePattern:U.pattern,onlyOpenEditors:C.onlyOpenEditors,maxResults:C.maxResults};if(C.onlyOpenEditors){const N=o.coalesce(o.flatten(this.editorGroupsService.groups.map(F=>F.editors.map(ne=>ne.resource))));this.logService.trace("QueryBuilder#commonQuery - openEditor URIs",JSON.stringify(N));const K=N.filter(F=>(0,l.pathIncludedInQuery)(z,F.fsPath)),V=this.commonQueryFromFileList(K);return this.logService.trace("QueryBuilder#commonQuery - openEditor Query",JSON.stringify(V)),{...z,...V}}const $=C.extraFileResources&&C.extraFileResources.filter(N=>(0,l.pathIncludedInQuery)(z,N.fsPath));return z.extraFileResources=$&&$.length?$:void 0,z}commonQueryFromFileList(g){const C=[],U=new D.ResourceMap,W={};let M=!1;return g.forEach(S=>{if(S.scheme===T.Schemas.walkThrough)return;if((0,P.isAbsolutePath)(S)){const $=this.workspaceContextService.getWorkspaceFolder(S)?.uri??S.with({path:E.dirname(S.fsPath)});let N=U.get($);N||(M=!0,N={folder:$,includePattern:{}},C.push(N),U.set($,N));const K=E.relative($.fsPath,S.fsPath);(0,y.assertIsDefined)(N.includePattern)[K.replace(/\\/g,"/")]=!0}else S.fsPath&&(M=!0,W[S.fsPath]=!0)}),{folderQueries:C,includePattern:W,usingSearchPaths:!0,excludePattern:M?void 0:{"**/*":!0}}}isCaseSensitive(g,C){if(C.isSmartCase){if(g.isRegExp){if(R.containsUppercaseCharacter(g.pattern,!0))return!0}else if(R.containsUppercaseCharacter(g.pattern))return!0}return!!g.isCaseSensitive}isMultiline(g){return g.isMultiline||g.isRegExp&&(0,I.isMultilineRegexSource)(g.pattern)||g.pattern.indexOf(`
`)>=0?!0:!!g.isMultiline}parseSearchPaths(g){const C=V=>E.isAbsolute(V)||/^\.\.?([\/\\]|$)/.test(V),W=(Array.isArray(g)?g:n(g)).map(V=>{const F=this.pathService.resolvedUserHome;return F?(0,L.untildify)(V,F.scheme===T.Schemas.file?F.fsPath:F.path):V}),M=p.groupBy(W,V=>C(V)?"searchPaths":"exprSegments"),S=(M.exprSegments||[]).map(V=>R.rtrim(V,"/")).map(V=>R.rtrim(V,"\\")).map(V=>(V[0]==="."&&(V="*"+V),i(V))),z={},$=this.expandSearchPathPatterns(M.searchPaths||[]);$&&$.length&&(z.searchPaths=$);const N=o.flatten(S),K=u(...N);return K&&(z.pattern=K),z}getExcludesForFolder(g,C){return C.disregardExcludeSettings?void 0:(0,l.getExcludes)(g,!C.disregardSearchExcludeSettings)}expandSearchPathPatterns(g){if(!g||!g.length)return[];const C=o.flatten(g.map(W=>{let{pathPortion:M,globPortion:S}=s(W);S&&(S=t(S));const z=this.expandOneSearchPath(M);return o.flatten(z.map($=>this.resolveOneSearchPathPattern($,S)))})),U=new Map;return C.forEach(W=>{const M=W.searchPath.toString(),S=U.get(M);S?W.pattern&&(S.pattern=S.pattern||{},S.pattern[W.pattern]=!0):U.set(M,{searchPath:W.searchPath,pattern:W.pattern?u(W.pattern):void 0})}),Array.from(U.values())}expandOneSearchPath(g){if(E.isAbsolute(g)){const C=this.workspaceContextService.getWorkspace().folders;return C[0]&&C[0].uri.scheme!==T.Schemas.file?[{searchPath:C[0].uri.with({path:g})}]:[{searchPath:m.URI.file(E.normalize(g))}]}if(this.workspaceContextService.getWorkbenchState()===2){const C=this.workspaceContextService.getWorkspace().folders[0].uri;if(g=r(g),g.startsWith("../")||g===".."){const W=E.posix.resolve(C.path,g);return[{searchPath:C.with({path:W})}]}const U=t(g);return[{searchPath:C,pattern:U}]}else{if(g==="./"||g===".\\")return[];{const C=g.replace(/^\.[\/\\]/,""),W=this.workspaceContextService.getWorkspace().folders.map(M=>{const S=C.match(new RegExp(`^${R.escapeRegExpCharacters(M.name)}(?:/(.*)|$)`));return S?{match:S,folder:M}:null}).filter(y.isDefined);if(W.length)return W.map(M=>{const S=M.match[1];return{searchPath:M.folder.uri,pattern:S&&t(S)}});{const M=g.match(/\.[\/\\](.+)[\/\\]?/),S=M?M[1]:g,z=f.localize(0,null,S);throw new Error(z)}}}}resolveOneSearchPathPattern(g,C){const U=g.pattern&&C?`${g.pattern}/${C}`:g.pattern||C,W=[{searchPath:g.searchPath,pattern:U}];return U&&!U.endsWith("**")&&W.push({searchPath:g.searchPath,pattern:U+"/**"}),W}getFolderQueryForSearchPath(g,C,U){const W=this.getFolderQueryForRoot((0,a.toWorkspaceFolder)(g.searchPath),C,U,!1);return W?{...W,includePattern:g.pattern}:null}getFolderQueryForRoot(g,C,U,W){let M;const S=m.URI.isUri(g)?g:g.uri;if(U.searchPaths){const V=U.searchPaths.filter(F=>(0,P.isEqual)(F.searchPath,S))[0];if(V&&!V.pattern)return null;V&&(M=V.pattern)}const z=this.configurationService.getValue({resource:S}),N={...this.getExcludesForFolder(z,C)||{},...M||{}},K=m.URI.isUri(g)?(0,P.basename)(g):g.name;return{folder:S,folderName:W?K:void 0,excludePattern:Object.keys(N).length>0?N:void 0,fileEncoding:z.files&&z.files.encoding,disregardIgnoreFiles:typeof C.disregardIgnoreFiles=="boolean"?C.disregardIgnoreFiles:!z.search.useIgnoreFiles,disregardGlobalIgnoreFiles:typeof C.disregardGlobalIgnoreFiles=="boolean"?C.disregardGlobalIgnoreFiles:!z.search.useGlobalIgnoreFiles,disregardParentIgnoreFiles:typeof C.disregardParentIgnoreFiles=="boolean"?C.disregardParentIgnoreFiles:!z.search.useParentIgnoreFiles,ignoreSymlinks:typeof C.ignoreSymlinks=="boolean"?C.ignoreSymlinks:!z.search.followSymlinks}}};_=ze([xe(0,h.IConfigurationService),xe(1,a.IWorkspaceContextService),xe(2,v.IEditorGroupsService),xe(3,d.ILogService),xe(4,A.IPathService)],_),e.QueryBuilder=_;function s(w){const g=w.match(/[\*\{\}\(\)\[\]\?]/);if(g){const C=g.index,U=w.substr(0,C).match(/[/|\\][^/\\]*$/);if(U){let W=w.substr(0,U.index);return W.match(/[/\\]/)||(W+="/"),{pathPortion:W,globPortion:w.substr((U.index||0)+1)}}}return{pathPortion:w}}function u(...w){return w.length?w.reduce((g,C)=>(g[C]=!0,g),Object.create(null)):void 0}function n(w){return b.splitGlobAware(w,",").map(g=>g.trim()).filter(g=>!!g.length)}function i(w){return[`**/${w}/**`,`**/${w}`].map(C=>C.replace(/\*\*\/\*\*/g,"**"))}function r(w){return w.replace(/\\/g,"/")}function t(w){return r(w).replace(/^\.\//,"").replace(/\/+$/g,"")}function c(w,g){w=o.distinct(w,W=>W.toString());const C=[],U=g.getWorkspace();return w&&w.forEach(W=>{let M;if(g.getWorkbenchState()===2)M=(0,P.relativePath)(U.folders[0].uri,W),M&&M!=="."&&(M="./"+M);else{const S=g.getWorkspaceFolder(W);if(S){const z=S.name;if(U.folders.filter(N=>N.name===z).length===1){const N=(0,P.relativePath)(S.uri,W);N===""?M=`./${S.name}`:M=`./${S.name}/${N}`}else M=W.fsPath}}M&&C.push(M)}),C}e.resolveResourcesForSearchIncludes=c}),define(De[228],Ce([1,0,21,2,20,11,3,227,41,45]),function(te,e,o,p,b,L,D,T,E,P){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.checkGlobFileExists=e.checkActivateWorkspaceContainsExtension=void 0;const R=7e3;function y(h,d){const a=d.activationEvents;if(!a)return Promise.resolve(void 0);const v=[],A=[];for(const i of a)if(/^workspaceContains:/.test(i)){const r=i.substr("workspaceContains:".length);r.indexOf("*")>=0||r.indexOf("?")>=0||h.forceUsingSearch?A.push(r):v.push(r)}if(v.length===0&&A.length===0)return Promise.resolve(void 0);let l;const _=new Promise((i,r)=>{l=i}),s=i=>l({activationEvent:i}),u=Promise.all(v.map(i=>m(h,i,s))).then(()=>{}),n=I(h,d.identifier,A,s);return Promise.all([u,n]).then(()=>{l(void 0)}),_}e.checkActivateWorkspaceContainsExtension=y;async function m(h,d,a){for(const v of h.folders)if(await h.exists(o.joinPath(p.URI.revive(v),d))){a(`workspaceContains:${d}`);return}}async function I(h,d,a,v){if(a.length===0)return Promise.resolve(void 0);const A=new b.CancellationTokenSource,l=h.checkExists(h.folders,a,A.token),_=setTimeout(async()=>{A.cancel(),h.logService.info(`Not activating extension '${d.value}': Timed out while searching for 'workspaceContains' pattern ${a.join(",")}`)},R);let s=!1;try{s=await l}catch(u){L.isCancellationError(u)||L.onUnexpectedError(u)}A.dispose(),clearTimeout(_),s&&v(`workspaceContains:${a.join(",")}`)}function f(h,d,a,v){const A=h.get(D.IInstantiationService),l=h.get(E.ISearchService),s=A.createInstance(T.QueryBuilder).file(d.map(u=>(0,P.toWorkspaceFolder)(p.URI.revive(u))),{_reason:"checkExists",includePattern:a,exists:!0});return l.fileSearch(s,v).then(u=>!!u.limitHit,u=>L.isCancellationError(u)?!1:Promise.reject(u))}e.checkGlobFileExists=f});var Je=this&&this.__classPrivateFieldSet||function(te,e,o,p,b){if(p==="m")throw new TypeError("Private method is not writable");if(p==="a"&&!b)throw new TypeError("Private accessor was defined without a setter");if(typeof e=="function"?te!==e||!b:!e.has(te))throw new TypeError("Cannot write private member to an object whose class did not declare it");return p==="a"?b.call(te,o):b?b.value=o:e.set(te,o),o},Oe=this&&this.__classPrivateFieldGet||function(te,e,o,p){if(o==="a"&&!p)throw new TypeError("Private accessor was defined without a getter");if(typeof e=="function"?te!==e||!p:!e.has(te))throw new TypeError("Cannot read private member from an object whose class did not declare it");return o==="m"?p:o==="a"?p.call(te):p?p.value:e.get(te)};define(De[33],Ce([1,0,129,19,71,21,13,7,25,2,14,5,32,179,69,31,24,178,11,27,22,157,6,84,3,28,70,15,58,62,52,4,228,67,159,12]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l,_,s,u,n,i,r,t,c,w,g,C,U,W,M,S){"use strict";var z,$,N;Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionPaths=e.Extension=e.IExtHostExtensionService=e.AbstractExtHostExtensionService=e.IHostUtils=void 0,e.IHostUtils=(0,n.createDecorator)("IHostUtils");let K=class ki extends T.Disposable{constructor(ie,Ee,be,ee,ve,Ae,Fe,$e,Qe,Ie){super();this._onDidChangeRemoteConnectionData=this._register(new C.Emitter),this.onDidChangeRemoteConnectionData=this._onDidChangeRemoteConnectionData.event,this._isTerminating=!1,this._hostUtils=Ee,this._extHostContext=be,this._initData=Fe,this._extHostWorkspace=ee,this._extHostConfiguration=ve,this._logService=Ae,this._extHostTunnelService=Qe,this._extHostTerminalService=Ie,this._mainThreadWorkspaceProxy=this._extHostContext.getProxy(y.MainContext.MainThreadWorkspace),this._mainThreadTelemetryProxy=this._extHostContext.getProxy(y.MainContext.MainThreadTelemetry),this._mainThreadExtensionsProxy=this._extHostContext.getProxy(y.MainContext.MainThreadExtensionService),this._almostReadyToRunExtensions=new D.Barrier,this._readyToStartExtensionHost=new D.Barrier,this._readyToRunExtensions=new D.Barrier,this._eagerExtensionsActivated=new D.Barrier,this._globalRegistry=new a.ExtensionDescriptionRegistry(this._initData.allExtensions);const Se=(0,d.extensionIdentifiersArrayToSet)(this._initData.myExtensions);this._myRegistry=new a.ExtensionDescriptionRegistry(ne(this._globalRegistry,Se)),this._storage=new f.ExtHostStorage(this._extHostContext),this._secretState=new W.ExtHostSecretState(this._extHostContext),this._storagePath=$e,this._instaService=ie.createChild(new c.ServiceCollection([f.IExtHostStorage,this._storage],[W.IExtHostSecretState,this._secretState]));let Te=[],ae=[];this._initData.remote.isRemote&&(Te=this._initData.allExtensions.filter(X=>!X.main&&!X.browser).map(X=>X.identifier),ae=this._initData.allExtensions.filter(X=>!Se.has(A.ExtensionIdentifier.toKey(X.identifier.value))).filter(X=>(X.main||X.browser)&&X.api==="none").map(X=>X.identifier));const le=(0,d.extensionIdentifiersArrayToSet)(ae);this._activator=this._register(new I.ExtensionsActivator(this._myRegistry,Te,ae,{onExtensionActivationError:(X,Y,k)=>{this._mainThreadExtensionsProxy.$onExtensionActivationError(X,v.transformErrorForSerialization(Y),k)},actualActivateExtension:async(X,Y)=>{if(le.has(A.ExtensionIdentifier.toKey(X)))return await this._mainThreadExtensionsProxy.$activateExtension(X,Y),new I.HostExtension;const k=this._myRegistry.getExtensionDescription(X);return this._activateExtension(k,Y)}},this._logService)),this._extensionPathIndex=null,this._resolvers=Object.create(null),this._started=!1,this._remoteConnectionData=this._initData.remote.connectionData}getRemoteConnectionData(){return this._remoteConnectionData}async initialize(){try{await this._beforeAlmostReadyToRunExtensions(),this._almostReadyToRunExtensions.open(),await this._extHostWorkspace.waitForInitializeCall(),b.mark("code/extHost/ready"),this._readyToStartExtensionHost.open(),this._initData.autoStart&&this._startExtensionHost()}catch(ie){v.onUnexpectedError(ie)}}async _deactivateAll(){this._storagePath.onWillDeactivateAll();let ie=[];try{ie=this._myRegistry.getAllExtensionDescriptions().map(ve=>ve.identifier).filter(ve=>this.isActivated(ve)).map(ve=>this._deactivate(ve))}catch{}await Promise.all(ie)}terminate(ie,Ee=0){if(this._isTerminating)return;this._isTerminating=!0,this._logService.info(`Extension host terminating: ${ie}`),this._logService.flush(),this._extHostTerminalService.dispose(),this._activator.dispose(),v.setUnexpectedErrorHandler(ee=>{this._logService.error(ee)}),this._extHostContext.dispose();const be=this._deactivateAll();Promise.race([(0,D.timeout)(5e3),be]).finally(()=>{this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} exiting with code ${Ee}`):this._logService.info(`Extension host exiting with code ${Ee}`),this._logService.flush(),this._logService.dispose(),this._hostUtils.exit(Ee)})}isActivated(ie){return this._readyToRunExtensions.isOpen()?this._activator.isActivated(ie):!1}async getExtension(ie){const Ee=await this._mainThreadExtensionsProxy.$getExtension(ie);return Ee&&{...Ee,identifier:new A.ExtensionIdentifier(Ee.identifier.value),extensionLocation:P.URI.revive(Ee.extensionLocation)}}_activateByEvent(ie,Ee){return this._activator.activateByEvent(ie,Ee)}_activateById(ie,Ee){return this._activator.activateById(ie,Ee)}activateByIdWithErrors(ie,Ee){return this._activateById(ie,Ee).then(()=>{const be=this._activator.getActivatedExtension(ie);if(be.activationFailed)return Promise.reject(be.activationFailedError)})}getExtensionRegistry(){return this._readyToRunExtensions.wait().then(ie=>this._myRegistry)}getExtensionExports(ie){return this._readyToRunExtensions.isOpen()?this._activator.getActivatedExtension(ie).exports:null}async _realPathExtensionUri(ie){if(ie.scheme!==S.Schemas.file)return ie;const Ee=await this._hostUtils.realpath(ie.fsPath);return P.URI.file(Ee)}async getExtensionPathIndex(){return this._extensionPathIndex||(this._extensionPathIndex=this._createExtensionPathIndex(this._myRegistry.getAllExtensionDescriptions()).then(ie=>new re(ie))),this._extensionPathIndex}async _createExtensionPathIndex(ie){const Ee=E.TernarySearchTree.forUris(be=>L.extUriBiasedIgnorePathCase.ignorePathCasing(be));return await Promise.all(ie.map(async be=>{if(this._getEntryPoint(be)){const ee=await this._realPathExtensionUri(be.extensionLocation);Ee.set(ee,be)}})),Ee}_deactivate(ie){let Ee=Promise.resolve(void 0);if(!this._readyToRunExtensions.isOpen()||!this._activator.isActivated(ie))return Ee;const be=this._activator.getActivatedExtension(ie);if(!be)return Ee;try{typeof be.module.deactivate=="function"&&(Ee=Promise.resolve(be.module.deactivate()).then(void 0,ee=>(this._logService.error(ee),Promise.resolve(void 0))))}catch(ee){this._logService.error(`An error occurred when deactivating the extension '${ie.value}':`),this._logService.error(ee)}try{(0,T.dispose)(be.subscriptions)}catch(ee){this._logService.error(`An error occurred when deactivating the subscriptions for extension '${ie.value}':`),this._logService.error(ee)}return Ee}async _activateExtension(ie,Ee){return this._initData.remote.isRemote?this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier):await this._mainThreadExtensionsProxy.$onWillActivateExtension(ie.identifier),this._doActivateExtension(ie,Ee).then(be=>{const ee=be.activationTimes;return this._mainThreadExtensionsProxy.$onDidActivateExtension(ie.identifier,ee.codeLoadingTime,ee.activateCallTime,ee.activateResolvedTime,Ee),this._logExtensionActivationTimes(ie,Ee,"success",ee),be},be=>{throw this._logExtensionActivationTimes(ie,Ee,"failure"),be})}_logExtensionActivationTimes(ie,Ee,be,ee){const ve=V(ie,Ee);this._mainThreadTelemetryProxy.$publicLog2("extensionActivationTimes",{...ve,...ee||{},outcome:be})}_doActivateExtension(ie,Ee){const be=V(ie,Ee);this._mainThreadTelemetryProxy.$publicLog2("activatePlugin",be);const ee=this._getEntryPoint(ie);if(!ee)return Promise.resolve(new I.EmptyExtension(I.ExtensionActivationTimes.NONE));this._logService.info(`ExtensionService#_doActivateExtension ${ie.identifier.value}, startup: ${Ee.startup}, activationEvent: '${Ee.activationEvent}'${ie.identifier.value!==Ee.extensionId.value?`, root cause: ${Ee.extensionId.value}`:""}`),this._logService.flush();const ve=new I.ExtensionActivationTimesBuilder(Ee.startup);return Promise.all([this._loadCommonJSModule(ie.identifier,(0,L.joinPath)(ie.extensionLocation,ee),ve),this._loadExtensionContext(ie)]).then(Ae=>(b.mark(`code/extHost/willActivateExtension/${ie.identifier.value}`),ki._callActivate(this._logService,ie.identifier,Ae[0],Ae[1],ve))).then(Ae=>(b.mark(`code/extHost/didActivateExtension/${ie.identifier.value}`),Ae))}_loadExtensionContext(ie){const Ee=new _.ExtensionGlobalMemento(ie,this._storage),be=new _.ExtensionMemento(ie.identifier.value,!1,this._storage),ee=new M.ExtensionSecrets(ie,this._secretState),ve=ie.isUnderDevelopment?this._initData.environment.extensionTestsLocationURI?s.ExtensionMode.Test:s.ExtensionMode.Development:s.ExtensionMode.Production,Ae=this._initData.remote.isRemote?s.ExtensionKind.Workspace:s.ExtensionKind.UI;return this._logService.trace(`ExtensionService#loadExtensionContext ${ie.identifier.value}`),Promise.all([Ee.whenReady,be.whenReady,this._storagePath.whenReady]).then(()=>{const Fe=this;let $e,Qe;const Ie=(0,d.isProposedApiEnabled)(ie,"ipc")?this._initData.messagePorts?.get(A.ExtensionIdentifier.toKey(ie.identifier)):void 0;return Object.freeze({globalState:Ee,workspaceState:be,secrets:ee,subscriptions:[],get extensionUri(){return ie.extensionLocation},get extensionPath(){return ie.extensionLocation.fsPath},asAbsolutePath(Se){return p.join(ie.extensionLocation.fsPath,Se)},get storagePath(){return Fe._storagePath.workspaceValue(ie)?.fsPath},get globalStoragePath(){return Fe._storagePath.globalValue(ie).fsPath},get logPath(){return p.join(Fe._initData.logsLocation.fsPath,ie.identifier.value)},get logUri(){return P.URI.joinPath(Fe._initData.logsLocation,ie.identifier.value)},get storageUri(){return Fe._storagePath.workspaceValue(ie)},get globalStorageUri(){return Fe._storagePath.globalValue(ie)},get extensionMode(){return ve},get extension(){return $e===void 0&&($e=new F(Fe,ie.identifier,ie,Ae,!1)),$e},get extensionRuntime(){return(0,d.checkProposedApiEnabled)(ie,"extensionRuntime"),Fe.extensionRuntime},get environmentVariableCollection(){return Fe._extHostTerminalService.getEnvironmentVariableCollection(ie)},get messagePassingProtocol(){if(!Qe){if(!Ie)return;const Se=C.Event.buffer(C.Event.fromDOMEventEmitter(Ie,"message",Te=>Te.data));Ie.start(),Qe={onDidReceiveMessage:Se,postMessage:Ie.postMessage.bind(Ie)}}return Qe}})})}static _callActivate(ie,Ee,be,ee,ve){return be=be||{activate:void 0,deactivate:void 0},this._callActivateOptional(ie,Ee,be,ee,ve).then(Ae=>new I.ActivatedExtension(!1,null,ve.build(),be,Ae,ee.subscriptions))}static _callActivateOptional(ie,Ee,be,ee,ve){if(typeof be.activate=="function")try{ve.activateCallStart(),ie.trace(`ExtensionService#_callActivateOptional ${Ee.value}`);const Ae=typeof global=="object"?global:self,Fe=be.activate.apply(Ae,[ee]);return ve.activateCallStop(),ve.activateResolveStart(),Promise.resolve(Fe).then($e=>(ve.activateResolveStop(),$e))}catch(Ae){return Promise.reject(Ae)}else return Promise.resolve(be)}_activateOneStartupFinished(ie,Ee){this._activateById(ie.identifier,{startup:!1,extensionId:ie.identifier,activationEvent:Ee}).then(void 0,be=>{this._logService.error(be)})}_activateAllStartupFinished(){this._mainThreadExtensionsProxy.$setPerformanceMarks(b.getMarks());for(const ie of this._myRegistry.getAllExtensionDescriptions())if(ie.activationEvents)for(const Ee of ie.activationEvents)Ee==="onStartupFinished"&&this._activateOneStartupFinished(ie,Ee)}_handleEagerExtensions(){const ie=this._activateByEvent("*",!0).then(void 0,ve=>{this._logService.error(ve)});this._register(this._extHostWorkspace.onDidChangeWorkspace(ve=>this._handleWorkspaceContainsEagerExtensions(ve.added)));const Ee=this._extHostWorkspace.workspace?this._extHostWorkspace.workspace.folders:[],be=this._handleWorkspaceContainsEagerExtensions(Ee),ee=Promise.all([ie,be]).then(()=>{});return Promise.race([ee,(0,D.timeout)(1e4)]).then(()=>{this._activateAllStartupFinished()}),ee}_handleWorkspaceContainsEagerExtensions(ie){return ie.length===0?Promise.resolve(void 0):Promise.all(this._myRegistry.getAllExtensionDescriptions().map(Ee=>this._handleWorkspaceContainsEagerExtension(ie,Ee))).then(()=>{})}async _handleWorkspaceContainsEagerExtension(ie,Ee){if(this.isActivated(Ee.identifier))return;const be=!this._initData.remote.isRemote&&!!this._initData.remote.authority,ee={logService:this._logService,folders:ie.map(Ae=>Ae.uri),forceUsingSearch:be,exists:Ae=>this._hostUtils.exists(Ae.fsPath),checkExists:(Ae,Fe,$e)=>this._mainThreadWorkspaceProxy.$checkExists(Ae,Fe,$e)},ve=await(0,U.checkActivateWorkspaceContainsExtension)(ee,Ee);if(!!ve)return this._activateById(Ee.identifier,{startup:!0,extensionId:Ee.identifier,activationEvent:ve.activationEvent}).then(void 0,Ae=>this._logService.error(Ae))}async $extensionTestsExecute(){await this._eagerExtensionsActivated.wait();try{return await this._doHandleExtensionTests()}catch(ie){throw console.error(ie),ie}}async _doHandleExtensionTests(){const{extensionDevelopmentLocationURI:ie,extensionTestsLocationURI:Ee}=this._initData.environment;if(!ie||!Ee)throw new Error(o.localize(0,null));const be=await this._loadCommonJSModule(null,Ee,new I.ExtensionActivationTimesBuilder(!1));if(!be||typeof be.run!="function")throw new Error(o.localize(1,null,Ee.toString()));return new Promise((ee,ve)=>{const Ae=(Qe,Ie)=>{Qe?ve(Qe):ee(typeof Ie=="number"&&Ie>0?1:0)},Fe=(0,L.originalFSPath)(Ee),$e=be.run(Fe,Ae);$e&&$e.then&&$e.then(()=>{ee(0)}).catch(Qe=>{ve(Qe instanceof Error&&Qe.stack?Qe.stack:String(Qe))})})}_startExtensionHost(){if(this._started)throw new Error("Extension host is already started!");return this._started=!0,this._readyToStartExtensionHost.wait().then(()=>this._readyToRunExtensions.open()).then(()=>this._handleEagerExtensions()).then(()=>{this._eagerExtensionsActivated.open(),this._logService.info("Eager extensions activated")})}registerRemoteAuthorityResolver(ie,Ee){return this._resolvers[ie]=Ee,(0,T.toDisposable)(()=>{delete this._resolvers[ie]})}async _activateAndGetResolver(ie){const Ee=ie.indexOf("+");if(Ee===-1)throw new Error("Not an authority that can be resolved!");const be=ie.substr(0,Ee);return await this._almostReadyToRunExtensions.wait(),await this._activateByEvent(`onResolveRemoteAuthority:${be}`,!1),{authorityPrefix:be,resolver:this._resolvers[be]}}async $resolveAuthority(ie,Ee){this._logService.info(`$resolveAuthority invoked for authority (${ce(ie)})`);const{authorityPrefix:be,resolver:ee}=await this._activateAndGetResolver(ie);if(!ee)return{type:"error",error:{code:u.RemoteAuthorityResolverErrorCode.NoResolverFound,message:`No remote extension installed to resolve ${be}.`,detail:void 0}};try{this._register(await this._extHostTunnelService.setTunnelFactory(ee)),b.mark(`code/extHost/willResolveAuthority/${be}`);const ve=await ee.resolve(ie,{resolveAttempt:Ee});b.mark(`code/extHost/didResolveAuthorityOK/${be}`);const Ae={authority:ie,host:ve.host,port:ve.port,connectionToken:ve.connectionToken},Fe={extensionHostEnv:ve.extensionHostEnv,isTrusted:ve.isTrusted,authenticationSession:ve.authenticationSessionForInitializingExtensions?{id:ve.authenticationSessionForInitializingExtensions.id,providerId:ve.authenticationSessionForInitializingExtensions.providerId}:void 0};return{type:"ok",value:{authority:Ae,options:Fe,tunnelInformation:{environmentTunnels:ve.environmentTunnels,features:ve.tunnelFeatures}}}}catch(ve){if(b.mark(`code/extHost/didResolveAuthorityError/${be}`),ve instanceof s.RemoteAuthorityResolverError)return{type:"error",error:{code:ve._code,message:ve._message,detail:ve._detail}};throw ve}}async $getCanonicalURI(ie,Ee){this._logService.info(`$getCanonicalURI invoked for authority (${ce(ie)})`);const{resolver:be}=await this._activateAndGetResolver(ie);if(!be)return null;const ee=P.URI.revive(Ee);if(typeof be.getCanonicalURI=="undefined")return ee;const ve=await(0,D.asPromise)(()=>be.getCanonicalURI(ee));return ve||ee}static _applyExtensionsDelta(ie,Ee,be){const ee=new a.ExtensionDescriptionRegistry(ie.getAllExtensionDescriptions());ee.deltaExtensions(be.toAdd,be.toRemove);const ve=(0,d.extensionIdentifiersArrayToSet)(Ee.getAllExtensionDescriptions().map(Fe=>Fe.identifier));for(const Fe of be.myToRemove)ve.delete(A.ExtensionIdentifier.toKey(Fe));for(const Fe of be.myToAdd)ve.add(A.ExtensionIdentifier.toKey(Fe));const Ae=ne(ee,ve);return{globalRegistry:ee,myExtensions:Ae}}$startExtensionHost(ie){ie.toAdd.forEach(ee=>ee.extensionLocation=P.URI.revive(ee.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie);return this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),this._startExtensionHost()}$activateByEvent(ie,Ee){return Ee===1?this._activateByEvent(ie,!1):this._readyToRunExtensions.wait().then(be=>this._activateByEvent(ie,!1))}async $activate(ie,Ee){return await this._readyToRunExtensions.wait(),this._myRegistry.getExtensionDescription(ie)?(await this._activateById(ie,Ee),!0):!1}async $deltaExtensions(ie){ie.toAdd.forEach(Ae=>Ae.extensionLocation=P.URI.revive(Ae.extensionLocation));const{globalRegistry:Ee,myExtensions:be}=ki._applyExtensionsDelta(this._globalRegistry,this._myRegistry,ie),ee=await this._createExtensionPathIndex(be);return(await this.getExtensionPathIndex()).setSearchTree(ee),this._globalRegistry.set(Ee.getAllExtensionDescriptions()),this._myRegistry.set(be),Promise.resolve(void 0)}async $test_latency(ie){return ie}async $test_up(ie){return ie.byteLength}async $test_down(ie){const Ee=l.VSBuffer.alloc(ie),be=Math.random()%256;for(let ee=0;ee<ie;ee++)Ee.writeUInt8(be,ee);return Ee}async $updateRemoteConnectionData(ie){this._remoteConnectionData=ie,this._onDidChangeRemoteConnectionData.fire()}};K=ze([xe(0,n.IInstantiationService),xe(1,e.IHostUtils),xe(2,t.IExtHostRpcService),xe(3,h.IExtHostWorkspace),xe(4,m.IExtHostConfiguration),xe(5,R.ILogService),xe(6,i.IExtHostInitDataService),xe(7,r.IExtensionStoragePaths),xe(8,w.IExtHostTunnelService),xe(9,g.IExtHostTerminalService)],K),e.AbstractExtHostExtensionService=K;function V(fe,ie){return{id:fe.identifier.value,name:fe.name,extensionVersion:fe.version,publisherDisplayName:fe.publisher,activationEvents:fe.activationEvents?fe.activationEvents.join(","):null,isBuiltin:fe.isBuiltin,reason:ie.activationEvent,reasonId:ie.extensionId.value}}e.IExtHostExtensionService=(0,n.createDecorator)("IExtHostExtensionService");class F{constructor(ie,Ee,be,ee,ve){z.set(this,void 0),$.set(this,void 0),N.set(this,void 0),Je(this,z,ie,"f"),Je(this,$,Ee,"f"),Je(this,N,be.identifier,"f"),this.id=be.identifier.value,this.extensionUri=be.extensionLocation,this.extensionPath=p.normalize((0,L.originalFSPath)(be.extensionLocation)),this.packageJSON=be,this.extensionKind=ee,this.isFromDifferentExtensionHost=ve}get isActive(){return Oe(this,z,"f").isActivated(Oe(this,N,"f"))}get exports(){if(!(this.packageJSON.api==="none"||this.isFromDifferentExtensionHost))return Oe(this,z,"f").getExtensionExports(Oe(this,N,"f"))}async activate(){if(this.isFromDifferentExtensionHost)throw new Error("Cannot activate foreign extension");return await Oe(this,z,"f").activateByIdWithErrors(Oe(this,N,"f"),{startup:!1,extensionId:Oe(this,$,"f"),activationEvent:"api"}),this.exports}}e.Extension=F,z=new WeakMap,$=new WeakMap,N=new WeakMap;function ne(fe,ie){return fe.getAllExtensionDescriptions().filter(Ee=>ie.has(A.ExtensionIdentifier.toKey(Ee.identifier)))}function ce(fe){const ie=fe.indexOf("+");return ie===-1?fe:fe.substring(0,ie)}class re{constructor(ie){this._searchTree=ie}setSearchTree(ie){this._searchTree=ie}findSubstr(ie){return this._searchTree.findSubstr(ie)}forEach(ie){return this._searchTree.forEach(ie)}}e.ExtensionPaths=re}),define(De[229],Ce([1,0,71,2,5,32,24,27,15,28,3,33,59,14,9]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.RequireInterceptor=void 0;let h=class{constructor(_,s,u,n,i,r,t){this._apiFactory=_,this._extensionRegistry=s,this._instaService=u,this._extHostConfiguration=n,this._extHostExtensionService=i,this._initData=r,this._logService=t,this._factories=new Map,this._alternatives=[]}async install(){this._installInterceptor(),o.mark("code/extHost/willWaitForConfig");const _=await this._extHostConfiguration.getConfigProvider();o.mark("code/extHost/didWaitForConfig");const s=await this._extHostExtensionService.getExtensionPathIndex();this.register(new a(this._apiFactory,s,this._extensionRegistry,_,this._logService)),this.register(this._instaService.createInstance(v,s)),this.register(this._instaService.createInstance(d)),this._initData.remote.isRemote&&this.register(this._instaService.createInstance(A,s,this._initData.environment.appUriScheme))}register(_){if("nodeModuleName"in _)if(Array.isArray(_.nodeModuleName))for(const s of _.nodeModuleName)this._factories.set(s,_);else this._factories.set(_.nodeModuleName,_);typeof _.alternativeModuleName=="function"&&this._alternatives.push(s=>_.alternativeModuleName(s))}};h=ze([xe(2,R.IInstantiationService),xe(3,L.IExtHostConfiguration),xe(4,y.IExtHostExtensionService),xe(5,P.IExtHostInitDataService),xe(6,I.ILogService)],h),e.RequireInterceptor=h;let d=class Ki{constructor(_){if(_.environment.appRoot&&Ki.aliased.size){const s=(0,f.escapeRegExpCharacters)(this.forceForwardSlashes(_.environment.appRoot.fsPath)),u="[a-z0-9_.-]",n=`@${u}+\\/${u}+|${u}+`,i="node_modules|node_modules\\.asar(?:\\.unpacked)?";this.re=new RegExp(`^(${s}/${i}\\/)(${n})(.*)$`,"i")}}alternativeModuleName(_){if(!this.re)return;const s=this.re.exec(this.forceForwardSlashes(_));if(!s)return;const[,u,n,i]=s,r=Ki.aliased.get(n);if(r!==void 0)return console.warn(`${n} as been renamed to ${r}, please update your imports`),u+r+i}forceForwardSlashes(_){return _.replace(/\\/g,"/")}};d.aliased=new Map([["vscode-ripgrep","@vscode/ripgrep"],["vscode-windows-registry","@vscode/windows-registry"]]),d=ze([xe(0,P.IExtHostInitDataService)],d);class a{constructor(_,s,u,n,i){this._apiFactory=_,this._extensionPaths=s,this._extensionRegistry=u,this._configProvider=n,this._logService=i,this.nodeModuleName="vscode",this._extApiImpl=new Map}load(_,s){const u=this._extensionPaths.findSubstr(s);if(u){let n=this._extApiImpl.get(T.ExtensionIdentifier.toKey(u.identifier));return n||(n=this._apiFactory(u,this._extensionRegistry,this._configProvider),this._extApiImpl.set(T.ExtensionIdentifier.toKey(u.identifier),n)),n}if(!this._defaultApiImpl){let n="";this._extensionPaths.forEach((i,r)=>n+=`	${r} -> ${i.identifier.value}
`),this._logService.warn(`Could not identify extension for 'vscode' require call from ${s}. These are the extension path mappings: 
${n}`),this._defaultApiImpl=this._apiFactory(D.nullExtensionDescription,this._extensionRegistry,this._configProvider)}return this._defaultApiImpl}}let v=class{constructor(_,s,u){this._extensionPaths=_,this.nodeModuleName="keytar",this._mainThreadTelemetry=s.getProxy(b.MainContext.MainThreadTelemetry);const{environment:n}=u,i=s.getProxy(b.MainContext.MainThreadKeytar);if(n.appRoot){let r=n.appRoot.fsPath;m.platform==="win32"&&(r=r.replace(/\\/g,"/")),r[r.length-1]==="/"&&(r=r.substr(0,r.length-1)),this.alternativeNames=new Set,this.alternativeNames.add(`${r}/node_modules.asar/keytar`),this.alternativeNames.add(`${r}/node_modules/keytar`)}this._impl={getPassword:(r,t)=>i.$getPassword(r,t),setPassword:(r,t,c)=>i.$setPassword(r,t,c),deletePassword:(r,t)=>i.$deletePassword(r,t),findPassword:r=>i.$findPassword(r),findCredentials(r){return i.$findCredentials(r)}}}load(_,s){const u=this._extensionPaths.findSubstr(s);return this._mainThreadTelemetry.$publicLog2("shimming.keytar",{extension:u?.identifier.value??"unknown_extension"}),this._impl}alternativeModuleName(_){const s=_.length;if(s<=7||!this.alternativeNames)return;const u=s-7;if((_.charAt(u)==="/"||_.charAt(u)==="\\")&&_.endsWith("keytar")&&(_=_.replace(/\\/g,"/"),this.alternativeNames.has(_)))return"keytar"}};v=ze([xe(1,E.IExtHostRpcService),xe(2,P.IExtHostInitDataService)],v);let A=class{constructor(_,s,u){this._extensionPaths=_,this._appUriScheme=s,this.nodeModuleName=["open","opn"],this._mainThreadTelemetry=u.getProxy(b.MainContext.MainThreadTelemetry);const n=u.getProxy(b.MainContext.MainThreadWindow);this._impl=(i,r)=>{const t=p.URI.parse(i);return r?this.callOriginal(i,r):t.scheme==="http"||t.scheme==="https"?n.$openUri(t,i,{allowTunneling:!0}):t.scheme==="mailto"||t.scheme===this._appUriScheme?n.$openUri(t,i,{}):this.callOriginal(i,r)}}load(_,s,u){const n=this._extensionPaths.findSubstr(s);return n&&(this._extensionId=n.identifier.value,this.sendShimmingTelemetry()),this._original=u(_),this._impl}callOriginal(_,s){return this.sendNoForwardTelemetry(),this._original(_,s)}sendShimmingTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open",{extension:this._extensionId})}sendNoForwardTelemetry(){!this._extensionId||this._mainThreadTelemetry.$publicLog2("shimming.open.call.noForward",{extension:this._extensionId})}};A=ze([xe(2,E.IExtHostRpcService)],A)}),define(De[101],Ce([1,0,196,7,19,59,3,49,50,33,6,31,170,32]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostVariableResolverProviderService=e.IExtHostVariableResolverProvider=void 0,e.IExtHostVariableResolverProvider=(0,D.createDecorator)("IExtHostVariableResolverProvider");class f extends m.AbstractVariableResolverService{constructor(a,v,A,l,_,s,u){function n(){if(A){const i=A.activeEditor();if(i)return i.document.uri;const r=l.tabGroups.all.find(t=>t.isActive)?.activeTab;if(r!==void 0){if(r.input instanceof R.TextDiffTabInput||r.input instanceof R.NotebookDiffEditorTabInput)return r.input.modified;if(r.input instanceof R.TextTabInput||r.input instanceof R.NotebookEditorTabInput||r.input instanceof R.CustomEditorTabInput)return r.input.uri}}}super({getFolderUri:i=>{const r=s.folders.filter(t=>t.name===i);if(r&&r.length>0)return r[0].uri},getWorkspaceFolderCount:()=>s.folders.length,getConfigurationValue:(i,r)=>_.getConfiguration(void 0,i).get(r),getAppRoot:()=>L.cwd(),getExecPath:()=>L.env.VSCODE_EXEC_PATH,getFilePath:()=>{const i=n();if(i)return b.normalize(i.fsPath)},getWorkspaceFolderPathForFile:()=>{if(v){const i=n();if(i){const r=v.getWorkspaceFolder(i);if(r)return b.normalize(r.uri.fsPath)}}},getSelectedText:()=>{if(A){const i=A.activeEditor();if(i&&!i.selection.isEmpty)return i.document.getText(i.selection)}},getLineNumber:()=>{if(A){const i=A.activeEditor();if(i)return String(i.selection.end.line+1)}},getExtension:i=>a.getExtension(i)},void 0,u?Promise.resolve(u):void 0,Promise.resolve(L.env))}}let h=class extends p.Disposable{constructor(a,v,A,l,_){super();this.extensionService=a,this.workspaceService=v,this.editorService=A,this.configurationService=l,this.editorTabs=_,this._resolver=new o.Lazy(async()=>{const s=await this.configurationService.getConfigProvider(),n={folders:await this.workspaceService.getWorkspaceFolders2()||[]};return this._register(this.workspaceService.onDidChangeWorkspace(async i=>{n.folders=await this.workspaceService.getWorkspaceFolders2()||[]})),new f(this.extensionService,this.workspaceService,this.editorService,this.editorTabs,s,n,this.homeDir())})}getResolver(){return this._resolver.getValue()}homeDir(){}};h=ze([xe(0,P.IExtHostExtensionService),xe(1,y.IExtHostWorkspace),xe(2,T.IExtHostDocumentsAndEditors),xe(3,I.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs)],h),e.ExtHostVariableResolverProviderService=h}),define(De[102],Ce([1,0,13,4,10,2,3,5,50,33,15,6,31,164,166,32,101]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.WorkerExtHostDebugService=e.ExtHostDebugConsole=e.ExtHostDebugSession=e.ExtHostDebugServiceBase=e.IExtHostDebugService=void 0,e.IExtHostDebugService=(0,D.createDecorator)("IExtHostDebugService");let a=class{constructor(n,i,r,t,c,w){this._workspaceService=i,this._extensionService=r,this._configurationService=t,this._editorTabs=c,this._variableResolver=w,this._debugSessions=new Map,this._configProviderHandleCounter=0,this._configProviders=[],this._adapterFactoryHandleCounter=0,this._adapterFactories=[],this._trackerFactoryHandleCounter=0,this._trackerFactories=[],this._debugAdapters=new Map,this._debugAdaptersTrackers=new Map,this._onDidStartDebugSession=new p.Emitter,this._onDidTerminateDebugSession=new p.Emitter,this._onDidChangeActiveDebugSession=new p.Emitter,this._onDidReceiveDebugSessionCustomEvent=new p.Emitter,this._debugServiceProxy=n.getProxy(T.MainContext.MainThreadDebugService),this._onDidChangeBreakpoints=new p.Emitter({onFirstListenerAdd:()=>{this.startBreakpoints()}}),this._activeDebugConsole=new A(this._debugServiceProxy),this._breakpoints=new Map,this._breakpointEventsActive=!1,this._extensionService.getExtensionRegistry().then(g=>{g.onDidChange(C=>{this.registerAllDebugTypes(g)}),this.registerAllDebugTypes(g)})}get onDidStartDebugSession(){return this._onDidStartDebugSession.event}get onDidTerminateDebugSession(){return this._onDidTerminateDebugSession.event}get onDidChangeActiveDebugSession(){return this._onDidChangeActiveDebugSession.event}get activeDebugSession(){return this._activeDebugSession}get onDidReceiveDebugSessionCustomEvent(){return this._onDidReceiveDebugSessionCustomEvent.event}get activeDebugConsole(){return this._activeDebugConsole.value}asDebugSourceUri(n,i){const r=n;if(typeof r.sourceReference=="number"&&r.sourceReference>0){let t=`debug:${encodeURIComponent(r.path||"")}`,c="?";return i&&(t+=`${c}session=${encodeURIComponent(i.id)}`,c="&"),t+=`${c}ref=${r.sourceReference}`,L.URI.parse(t)}else{if(r.path)return L.URI.file(r.path);throw new Error("cannot create uri from DAP 'source' object; properties 'path' and 'sourceReference' are both missing.")}}registerAllDebugTypes(n){const i=[];for(const r of n.getAllExtensionDescriptions())if(r.contributes){const t=r.contributes.debuggers;if(t&&t.length>0)for(const c of t)(0,f.isDebuggerMainContribution)(c)&&i.push(c.type)}this._debugServiceProxy.$registerDebugTypes(i)}get onDidChangeBreakpoints(){return this._onDidChangeBreakpoints.event}get breakpoints(){this.startBreakpoints();const n=[];return this._breakpoints.forEach(i=>n.push(i)),n}addBreakpoints(n){this.startBreakpoints();const i=n.filter(c=>{const w=c.id;return this._breakpoints.has(w)?!1:(this._breakpoints.set(w,c),!0)});this.fireBreakpointChanges(i,[],[]);const r=[],t=new Map;for(const c of i)if(c instanceof y.SourceBreakpoint){let w=t.get(c.location.uri.toString());w||(w={type:"sourceMulti",uri:c.location.uri,lines:[]},t.set(c.location.uri.toString(),w),r.push(w)),w.lines.push({id:c.id,enabled:c.enabled,condition:c.condition,hitCondition:c.hitCondition,logMessage:c.logMessage,line:c.location.range.start.line,character:c.location.range.start.character})}else c instanceof y.FunctionBreakpoint&&r.push({type:"function",id:c.id,enabled:c.enabled,hitCondition:c.hitCondition,logMessage:c.logMessage,condition:c.condition,functionName:c.functionName});return this._debugServiceProxy.$registerBreakpoints(r)}removeBreakpoints(n){this.startBreakpoints();const i=n.filter(w=>this._breakpoints.delete(w.id));this.fireBreakpointChanges([],i,[]);const r=i.filter(w=>w instanceof y.SourceBreakpoint).map(w=>w.id),t=i.filter(w=>w instanceof y.FunctionBreakpoint).map(w=>w.id),c=i.filter(w=>w instanceof y.DataBreakpoint).map(w=>w.id);return this._debugServiceProxy.$unregisterBreakpoints(r,t,c)}startDebugging(n,i,r){return this._debugServiceProxy.$startDebugging(n?n.uri:void 0,i,{parentSessionID:r.parentSession?r.parentSession.id:void 0,lifecycleManagedByParent:r.lifecycleManagedByParent,repl:r.consoleMode===y.DebugConsoleMode.MergeWithParent?"mergeWithParent":"separate",noDebug:r.noDebug,compact:r.compact,debugUI:r.debugUI,suppressSaveBeforeStart:r.suppressSaveBeforeStart})}stopDebugging(n){return this._debugServiceProxy.$stopDebugging(n?n.id:void 0)}registerDebugConfigurationProvider(n,i,r){if(!i)return new y.Disposable(()=>{});const t=this._configProviderHandleCounter++;return this._configProviders.push({type:n,handle:t,provider:i}),this._debugServiceProxy.$registerDebugConfigurationProvider(n,r,!!i.provideDebugConfigurations,!!i.resolveDebugConfiguration,!!i.resolveDebugConfigurationWithSubstitutedVariables,t),new y.Disposable(()=>{this._configProviders=this._configProviders.filter(c=>c.provider!==i),this._debugServiceProxy.$unregisterDebugConfigurationProvider(t)})}registerDebugAdapterDescriptorFactory(n,i,r){if(!r)return new y.Disposable(()=>{});if(!this.definesDebugType(n,i))throw new Error(`a DebugAdapterDescriptorFactory can only be registered from the extension that defines the '${i}' debugger.`);if(this.getAdapterDescriptorFactoryByType(i))throw new Error("a DebugAdapterDescriptorFactory can only be registered once per a type.");const t=this._adapterFactoryHandleCounter++;return this._adapterFactories.push({type:i,handle:t,factory:r}),this._debugServiceProxy.$registerDebugAdapterDescriptorFactory(i,t),new y.Disposable(()=>{this._adapterFactories=this._adapterFactories.filter(c=>c.factory!==r),this._debugServiceProxy.$unregisterDebugAdapterDescriptorFactory(t)})}registerDebugAdapterTrackerFactory(n,i){if(!i)return new y.Disposable(()=>{});const r=this._trackerFactoryHandleCounter++;return this._trackerFactories.push({type:n,handle:r,factory:i}),new y.Disposable(()=>{this._trackerFactories=this._trackerFactories.filter(t=>t.factory!==i)})}async $runInTerminal(n,i){return Promise.resolve(void 0)}async $substituteVariables(n,i){let r;const t=await this.getFolder(n);return t&&(r={uri:t.uri,name:t.name,index:t.index,toResource:()=>{throw new Error("Not implemented")}}),(await this._variableResolver.getResolver()).resolveAnyAsync(r,i)}createDebugAdapter(n,i){if(n.type==="implementation")return new _(n.implementation)}createSignService(){}async $startDASession(n,i){const r=this,t=await this.getSession(i);return this.getAdapterDescriptor(this.getAdapterDescriptorFactoryByType(t.type),t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}' (extension might have failed to activate)`);const w=this.convertToDto(c),g=this.createDebugAdapter(w,t);if(!g)throw new Error(`Couldn't create a debug adapter for type '${t.type}'.`);const C=g;return this._debugAdapters.set(n,C),this.getDebugAdapterTrackers(t).then(U=>(U&&this._debugAdaptersTrackers.set(n,U),C.onMessage(async W=>{if(W.type==="request"&&W.command==="handshake"){const M=W,S={type:"response",seq:0,command:M.command,request_seq:M.seq,success:!0};this._signService||(this._signService=this.createSignService());try{if(this._signService){const z=await this._signService.sign(M.arguments.value);S.body={signature:z},C.sendResponse(S)}else throw new Error("no signer")}catch(z){S.success=!1,S.message=z.message,C.sendResponse(S)}}else U&&U.onDidSendMessage&&U.onDidSendMessage(W),W=(0,f.convertToVSCPaths)(W,!0),r._debugServiceProxy.$acceptDAMessage(n,W)}),C.onError(W=>{U&&U.onError&&U.onError(W),this._debugServiceProxy.$acceptDAError(n,W.name,W.message,W.stack)}),C.onExit(W=>{U&&U.onExit&&U.onExit((0,b.withNullAsUndefined)(W),void 0),this._debugServiceProxy.$acceptDAExit(n,(0,b.withNullAsUndefined)(W),void 0)}),U&&U.onWillStartSession&&U.onWillStartSession(),C.startSession()))})}$sendDAMessage(n,i){i=(0,f.convertToDAPaths)(i,!1);const r=this._debugAdaptersTrackers.get(n);r&&r.onWillReceiveMessage&&r.onWillReceiveMessage(i),this._debugAdapters.get(n)?.sendMessage(i)}$stopDASession(n){const i=this._debugAdaptersTrackers.get(n);this._debugAdaptersTrackers.delete(n),i&&i.onWillStopSession&&i.onWillStopSession();const r=this._debugAdapters.get(n);return this._debugAdapters.delete(n),r?r.stopSession():Promise.resolve(void 0)}$acceptBreakpointsDelta(n){const i=[],r=[],t=[];if(n.added)for(const c of n.added){const w=c.id;if(w&&!this._breakpoints.has(w)){let g;if(c.type==="function")g=new y.FunctionBreakpoint(c.functionName,c.enabled,c.condition,c.hitCondition,c.logMessage);else if(c.type==="data")g=new y.DataBreakpoint(c.label,c.dataId,c.canPersist,c.enabled,c.hitCondition,c.condition,c.logMessage);else{const C=L.URI.revive(c.uri);g=new y.SourceBreakpoint(new y.Location(C,new y.Position(c.line,c.character)),c.enabled,c.condition,c.hitCondition,c.logMessage)}g._id=w,this._breakpoints.set(w,g),i.push(g)}}if(n.removed)for(const c of n.removed){const w=this._breakpoints.get(c);w&&(this._breakpoints.delete(c),r.push(w))}if(n.changed){for(const c of n.changed)if(c.id){const w=this._breakpoints.get(c.id);if(w){if(w instanceof y.FunctionBreakpoint&&c.type==="function"){const g=w;g.enabled=c.enabled,g.condition=c.condition,g.hitCondition=c.hitCondition,g.logMessage=c.logMessage,g.functionName=c.functionName}else if(w instanceof y.SourceBreakpoint&&c.type==="source"){const g=w;g.enabled=c.enabled,g.condition=c.condition,g.hitCondition=c.hitCondition,g.logMessage=c.logMessage,g.location=new y.Location(L.URI.revive(c.uri),new y.Position(c.line,c.character))}t.push(w)}}}this.fireBreakpointChanges(i,r,t)}$provideDebugConfigurations(n,i,r){return(0,o.asPromise)(async()=>{const t=this.getConfigProviderByHandle(n);if(!t)throw new Error("no DebugConfigurationProvider found");if(!t.provideDebugConfigurations)throw new Error("DebugConfigurationProvider has no method provideDebugConfigurations");const c=await this.getFolder(i);return t.provideDebugConfigurations(c,r)}).then(t=>{if(!t)throw new Error("nothing returned from DebugConfigurationProvider.provideDebugConfigurations");return t})}$resolveDebugConfiguration(n,i,r,t){return(0,o.asPromise)(async()=>{const c=this.getConfigProviderByHandle(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfiguration)throw new Error("DebugConfigurationProvider has no method resolveDebugConfiguration");const w=await this.getFolder(i);return c.resolveDebugConfiguration(w,r,t)})}$resolveDebugConfigurationWithSubstitutedVariables(n,i,r,t){return(0,o.asPromise)(async()=>{const c=this.getConfigProviderByHandle(n);if(!c)throw new Error("no DebugConfigurationProvider found");if(!c.resolveDebugConfigurationWithSubstitutedVariables)throw new Error("DebugConfigurationProvider has no method resolveDebugConfigurationWithSubstitutedVariables");const w=await this.getFolder(i);return c.resolveDebugConfigurationWithSubstitutedVariables(w,r,t)})}async $provideDebugAdapter(n,i){const r=this.getAdapterDescriptorFactoryByHandle(n);if(!r)return Promise.reject(new Error("no adapter descriptor factory found for handle"));const t=await this.getSession(i);return this.getAdapterDescriptor(r,t).then(c=>{if(!c)throw new Error(`Couldn't find a debug adapter descriptor for debug type '${t.type}'`);return this.convertToDto(c)})}async $acceptDebugSessionStarted(n){const i=await this.getSession(n);this._onDidStartDebugSession.fire(i)}async $acceptDebugSessionTerminated(n){const i=await this.getSession(n);i&&(this._onDidTerminateDebugSession.fire(i),this._debugSessions.delete(i.id))}async $acceptDebugSessionActiveChanged(n){this._activeDebugSession=n?await this.getSession(n):void 0,this._onDidChangeActiveDebugSession.fire(this._activeDebugSession)}async $acceptDebugSessionNameChanged(n,i){(await this.getSession(n))?._acceptNameChanged(i)}async $acceptDebugSessionCustomEvent(n,i){const t={session:await this.getSession(n),event:i.event,body:i.body};this._onDidReceiveDebugSessionCustomEvent.fire(t)}convertToDto(n){if(n instanceof y.DebugAdapterExecutable)return{type:"executable",command:n.command,args:n.args,options:n.options};if(n instanceof y.DebugAdapterServer)return{type:"server",port:n.port,host:n.host};if(n instanceof y.DebugAdapterNamedPipeServer)return{type:"pipeServer",path:n.path};if(n instanceof y.DebugAdapterInlineImplementation)return{type:"implementation",implementation:n.implementation};throw new Error("convertToDto unexpected type")}getAdapterDescriptorFactoryByType(n){const i=this._adapterFactories.filter(r=>r.type===n);if(i.length>0)return i[0].factory}getAdapterDescriptorFactoryByHandle(n){const i=this._adapterFactories.filter(r=>r.handle===n);if(i.length>0)return i[0].factory}getConfigProviderByHandle(n){const i=this._configProviders.filter(r=>r.handle===n);if(i.length>0)return i[0].provider}definesDebugType(n,i){if(n.contributes){const r=n.contributes.debuggers;if(r&&r.length>0){for(const t of r)if(t.label&&t.type&&t.type===i)return!0}}return!1}getDebugAdapterTrackers(n){const r=n.configuration.type,t=this._trackerFactories.filter(c=>c.type===r||c.type==="*").map(c=>(0,o.asPromise)(()=>c.factory.createDebugAdapterTracker(n)).then(w=>w,w=>null));return Promise.race([Promise.all(t).then(c=>{const w=c.filter(g=>!!g);if(w.length>0)return new l(w)}),new Promise((c,w)=>{const g=setTimeout(()=>{clearTimeout(g),w(new Error("timeout"))},1e3)})]).catch(c=>{})}async getAdapterDescriptor(n,i){const r=i.configuration.debugServer;if(typeof r=="number")return Promise.resolve(new y.DebugAdapterServer(r));if(n){const c=await this._extensionService.getExtensionRegistry();return(0,o.asPromise)(()=>n.createDebugAdapterDescriptor(i,this.daExecutableFromPackage(i,c))).then(w=>{if(w)return w})}const t=await this._extensionService.getExtensionRegistry();return Promise.resolve(this.daExecutableFromPackage(i,t))}daExecutableFromPackage(n,i){}startBreakpoints(){this._breakpointEventsActive||(this._breakpointEventsActive=!0,this._debugServiceProxy.$startBreakpointEvents())}fireBreakpointChanges(n,i,r){(n.length>0||i.length>0||r.length>0)&&this._onDidChangeBreakpoints.fire(Object.freeze({added:n,removed:i,changed:r}))}async getSession(n){if(n)if(typeof n=="string"){const i=this._debugSessions.get(n);if(i)return i}else{let i=this._debugSessions.get(n.id);if(!i){const r=await this.getFolder(n.folderUri),t=n.parent?this._debugSessions.get(n.parent):void 0;i=new v(this._debugServiceProxy,n.id,n.type,n.name,r,n.configuration,t),this._debugSessions.set(i.id,i),this._debugServiceProxy.$sessionCached(i.id)}return i}throw new Error("cannot find session")}getFolder(n){if(n){const i=L.URI.revive(n);return this._workspaceService.resolveWorkspaceFolder(i)}return Promise.resolve(void 0)}};a=ze([xe(0,R.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,d.IExtHostVariableResolverProvider)],a),e.ExtHostDebugServiceBase=a;class v{constructor(n,i,r,t,c,w,g){this._debugServiceProxy=n,this._id=i,this._type=r,this._name=t,this._workspaceFolder=c,this._configuration=w,this._parentSession=g}get id(){return this._id}get type(){return this._type}get name(){return this._name}set name(n){this._name=n,this._debugServiceProxy.$setDebugSessionName(this._id,n)}get parentSession(){return this._parentSession}_acceptNameChanged(n){this._name=n}get workspaceFolder(){return this._workspaceFolder}get configuration(){return this._configuration}customRequest(n,i){return this._debugServiceProxy.$customDebugAdapterRequest(this._id,n,i)}getDebugProtocolBreakpoint(n){return this._debugServiceProxy.$getDebugProtocolBreakpoint(this._id,n.id)}}e.ExtHostDebugSession=v;class A{constructor(n){this.value=Object.freeze({append(i){n.$appendDebugConsole(i)},appendLine(i){this.append(i+`
`)}})}}e.ExtHostDebugConsole=A;class l{constructor(n){this.trackers=n}onWillStartSession(){this.trackers.forEach(n=>n.onWillStartSession?n.onWillStartSession():void 0)}onWillReceiveMessage(n){this.trackers.forEach(i=>i.onWillReceiveMessage?i.onWillReceiveMessage(n):void 0)}onDidSendMessage(n){this.trackers.forEach(i=>i.onDidSendMessage?i.onDidSendMessage(n):void 0)}onWillStopSession(){this.trackers.forEach(n=>n.onWillStopSession?n.onWillStopSession():void 0)}onError(n){this.trackers.forEach(i=>i.onError?i.onError(n):void 0)}onExit(n,i){this.trackers.forEach(r=>r.onExit?r.onExit(n,i):void 0)}}class _ extends I.AbstractDebugAdapter{constructor(n){super();this.implementation=n,n.onDidSendMessage(i=>{this.acceptMessage(i)})}startSession(){return Promise.resolve(void 0)}sendMessage(n){this.implementation.handleMessage(n)}stopSession(){return this.implementation.dispose(),Promise.resolve(void 0)}}let s=class extends a{constructor(n,i,r,t,c,w){super(n,i,r,t,c,w)}};s=ze([xe(0,R.IExtHostRpcService),xe(1,m.IExtHostWorkspace),xe(2,P.IExtHostExtensionService),xe(3,h.IExtHostConfiguration),xe(4,E.IExtHostEditorTabs),xe(5,d.IExtHostVariableResolverProvider)],s),e.WorkerExtHostDebugService=s}),define(De[230],Ce([1,0,11,71,2,5,221,14,56,58,28,147,15,63,33]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtensionHostMain=void 0;class h{constructor(a,v,A,l,_){this._hostUtils=A,this._rpcProtocol=new D.RPCProtocol(a,null,l),v=h._transform(v,this._rpcProtocol);const s=new P.ServiceCollection(...(0,E.getSingletonServiceDescriptors)());s.set(R.IExtHostInitDataService,{_serviceBrand:void 0,...v,messagePorts:_}),s.set(m.IExtHostRpcService,new m.ExtHostRpcService(this._rpcProtocol)),s.set(I.IURITransformerService,new I.URITransformerService(l)),s.set(f.IHostUtils,A);const u=new y.InstantiationService(s,!0);this._logService=u.invokeFunction(t=>t.get(T.ILogService)),p.mark("code/extHost/didCreateServices"),this._hostUtils.pid?this._logService.info(`Extension host with pid ${this._hostUtils.pid} started`):this._logService.info("Extension host started"),this._logService.trace("initData",v),this._extensionService=u.invokeFunction(t=>t.get(f.IExtHostExtensionService)),this._extensionService.initialize(),Error.stackTraceLimit=100;const n=new WeakMap;this._extensionService.getExtensionPathIndex().then(t=>{Error.prepareStackTrace=(c,w)=>{let g="",C,U;for(const W of w)g+=`
	at ${W.toString()}`,U=W.getFileName(),!C&&U&&(C=t.findSubstr(b.URI.file(U)));return n.set(c,C),`${c.name||"Error"}: ${c.message||""}${g}`}});const i=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService),r=this._rpcProtocol.getProxy(L.MainContext.MainThreadErrors);o.setUnexpectedErrorHandler(t=>{const c=o.transformErrorForSerialization(t),w=n.get(t);w?i.$onExtensionRuntimeError(w.identifier,c):r.$onUnexpectedError(c)})}async asBrowserUri(a){const v=this._rpcProtocol.getProxy(L.MainContext.MainThreadExtensionService);return b.URI.revive(await v.$asBrowserUri(a))}terminate(a){this._extensionService.terminate(a)}static _transform(a,v){a.allExtensions.forEach(l=>l.extensionLocation=b.URI.revive(v.transformIncomingURIs(l.extensionLocation))),a.environment.appRoot=b.URI.revive(v.transformIncomingURIs(a.environment.appRoot));const A=a.environment.extensionDevelopmentLocationURI;return A&&(a.environment.extensionDevelopmentLocationURI=A.map(l=>b.URI.revive(v.transformIncomingURIs(l)))),a.environment.extensionTestsLocationURI=b.URI.revive(v.transformIncomingURIs(a.environment.extensionTestsLocationURI)),a.environment.globalStorageHome=b.URI.revive(v.transformIncomingURIs(a.environment.globalStorageHome)),a.environment.workspaceStorageHome=b.URI.revive(v.transformIncomingURIs(a.environment.workspaceStorageHome)),a.logsLocation=b.URI.revive(v.transformIncomingURIs(a.logsLocation)),a.logFile=b.URI.revive(v.transformIncomingURIs(a.logFile)),a.workspace=v.transformIncomingURIs(a.workspace),a}}e.ExtensionHostMain=h}),define(De[231],Ce([1,0,16,13,20,43,12,19,21,2,41]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.BatchedCollector=e.extensionResultIsMatch=e.TextSearchResultsCollector=e.TextSearchManager=void 0;class y{constructor(v,A,l,_){this.query=v,this.provider=A,this.fileUtils=l,this.processType=_,this.collector=null,this.isLimitHit=!1,this.resultCount=0}search(v,A){const l=this.query.folderQueries||[],_=new b.CancellationTokenSource;return A.onCancellationRequested(()=>_.cancel()),new Promise((s,u)=>{this.collector=new I(v);let n=!1;const i=(r,t)=>{if(!n&&!this.isLimitHit){const c=this.resultSize(r);h(r)&&typeof this.query.maxResults=="number"&&this.resultCount+c>this.query.maxResults&&(this.isLimitHit=!0,n=!0,_.cancel(),r=this.trimResultToSize(r,this.query.maxResults-this.resultCount));const w=this.resultSize(r);this.resultCount+=w,(w>0||!h(r))&&this.collector.add(r,t)}};Promise.all(l.map((r,t)=>this.searchInFolder(r,c=>i(c,t),_.token))).then(r=>{_.dispose(),this.collector.flush();const t=r.some(c=>!!c&&!!c.limitHit);s({limitHit:this.isLimitHit||t,messages:(0,o.flatten)(r.map(c=>c?.message?Array.isArray(c.message)?c.message:[c.message]:[])),stats:{type:this.processType}})},r=>{_.dispose();const t=(0,L.toErrorMessage)(r);u(new Error(t))})})}resultSize(v){return h(v)?Array.isArray(v.ranges)?v.ranges.length:1:0}trimResultToSize(v,A){const l=Array.isArray(v.ranges)?v.ranges:[v.ranges],_=Array.isArray(v.preview.matches)?v.preview.matches:[v.preview.matches];return{ranges:l.slice(0,A),preview:{matches:_.slice(0,A),text:v.preview.text},uri:v.uri}}async searchInFolder(v,A,l){const _=new R.QueryGlobTester(this.query,v),s=[],u={report:r=>{if(!this.validateProviderResult(r))return;const t=v.folder.scheme===D.Schemas.file?(0,R.hasSiblingPromiseFn)(()=>this.fileUtils.readdir(E.dirname(r.uri))):void 0,c=E.relativePath(v.folder,r.uri);if(c){const w=_.includedInQuery(c,T.basename(c),t);(0,p.isThenable)(w)?s.push(w.then(g=>{g&&A(r)})):w&&A(r)}}},n=this.getSearchOptionsForFolder(v),i=await this.provider.provideTextSearchResults(m(this.query.contentPattern),n,u,l);return s.length&&await Promise.all(s),i}validateProviderResult(v){if(h(v)){if(Array.isArray(v.ranges)){if(!Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same type."),!1;if(v.preview.matches.length!==v.ranges.length)return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}else if(Array.isArray(v.preview.matches))return console.warn("INVALID - A text search provider match's`ranges` and`matches` properties must have the same length."),!1}return!0}getSearchOptionsForFolder(v){const A=(0,R.resolvePatternsForProvider)(this.query.includePattern,v.includePattern),l=(0,R.resolvePatternsForProvider)(this.query.excludePattern,v.excludePattern),_={folder:P.URI.from(v.folder),excludes:l,includes:A,useIgnoreFiles:!v.disregardIgnoreFiles,useGlobalIgnoreFiles:!v.disregardGlobalIgnoreFiles,useParentIgnoreFiles:!v.disregardParentIgnoreFiles,followSymlinks:!v.ignoreSymlinks,encoding:v.fileEncoding&&this.fileUtils.toCanonicalName(v.fileEncoding),maxFileSize:this.query.maxFileSize,maxResults:this.query.maxResults,previewOptions:this.query.previewOptions,afterContext:this.query.afterContext,beforeContext:this.query.beforeContext};return _.usePCRE2=this.query.usePCRE2,_}}e.TextSearchManager=y;function m(a){return{isCaseSensitive:a.isCaseSensitive||!1,isRegExp:a.isRegExp||!1,isWordMatch:a.isWordMatch||!1,isMultiline:a.isMultiline||!1,pattern:a.pattern}}class I{constructor(v){this._onResult=v,this._currentFolderIdx=-1,this._currentFileMatch=null,this._batchedCollector=new d(512,A=>this.sendItems(A))}add(v,A){this._currentFileMatch&&(this._currentFolderIdx!==A||!E.isEqual(this._currentUri,v.uri))&&(this.pushToCollector(),this._currentFileMatch=null),this._currentFileMatch||(this._currentFolderIdx=A,this._currentFileMatch={resource:v.uri,results:[]}),this._currentFileMatch.results.push(f(v))}pushToCollector(){const v=this._currentFileMatch&&this._currentFileMatch.results?this._currentFileMatch.results.length:0;this._batchedCollector.addItem(this._currentFileMatch,v)}flush(){this.pushToCollector(),this._batchedCollector.flush()}sendItems(v){this._onResult(v)}}e.TextSearchResultsCollector=I;function f(a){return h(a)?{preview:{matches:(0,o.mapArrayOrNot)(a.preview.matches,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character})),text:a.preview.text},ranges:(0,o.mapArrayOrNot)(a.ranges,v=>({startLineNumber:v.start.line,startColumn:v.start.character,endLineNumber:v.end.line,endColumn:v.end.character}))}:{text:a.text,lineNumber:a.lineNumber}}function h(a){return!!a.preview}e.extensionResultIsMatch=h;class d{constructor(v,A){this.maxBatchSize=v,this.cb=A,this.totalNumberCompleted=0,this.batch=[],this.batchSize=0}addItem(v,A){!v||this.addItemToBatch(v,A)}addItems(v,A){!v||this.addItemsToBatch(v,A)}addItemToBatch(v,A){this.batch.push(v),this.batchSize+=A,this.onUpdate()}addItemsToBatch(v,A){this.batch=this.batch.concat(v),this.batchSize+=A,this.onUpdate()}onUpdate(){this.totalNumberCompleted<d.START_BATCH_AFTER_COUNT?this.flush():this.batchSize>=this.maxBatchSize?this.flush():this.timeoutHandle||(this.timeoutHandle=setTimeout(()=>{this.flush()},d.TIMEOUT))}flush(){this.batchSize&&(this.totalNumberCompleted+=this.batchSize,this.cb(this.batch),this.batch=[],this.batchSize=0,this.timeoutHandle&&(clearTimeout(this.timeoutHandle),this.timeoutHandle=0))}}e.BatchedCollector=d,d.TIMEOUT=4e3,d.START_BATCH_AFTER_COUNT=50}),define(De[103],Ce([1,0,7,5,3,226,15,63,14,2,231]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.reviveQuery=e.ExtHostSearch=e.IExtHostSearch=void 0,e.IExtHostSearch=(0,b.createDecorator)("IExtHostSearch");let y=class{constructor(h,d,a){this.extHostRpc=h,this._uriTransformer=d,this._logService=a,this._proxy=this.extHostRpc.getProxy(p.MainContext.MainThreadSearch),this._handlePool=0,this._textSearchProvider=new Map,this._textSearchUsedSchemes=new Set,this._fileSearchProvider=new Map,this._fileSearchUsedSchemes=new Set,this._fileSearchManager=new L.FileSearchManager}_transformScheme(h){return this._uriTransformer.transformOutgoingScheme(h)}registerTextSearchProvider(h,d){if(this._textSearchUsedSchemes.has(h))throw new Error(`a text search provider for the scheme '${h}' is already registered`);this._textSearchUsedSchemes.add(h);const a=this._handlePool++;return this._textSearchProvider.set(a,d),this._proxy.$registerTextSearchProvider(a,this._transformScheme(h)),(0,o.toDisposable)(()=>{this._textSearchUsedSchemes.delete(h),this._textSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}registerFileSearchProvider(h,d){if(this._fileSearchUsedSchemes.has(h))throw new Error(`a file search provider for the scheme '${h}' is already registered`);this._fileSearchUsedSchemes.add(h);const a=this._handlePool++;return this._fileSearchProvider.set(a,d),this._proxy.$registerFileSearchProvider(a,this._transformScheme(h)),(0,o.toDisposable)(()=>{this._fileSearchUsedSchemes.delete(h),this._fileSearchProvider.delete(a),this._proxy.$unregisterProvider(a)})}$provideFileSearchResults(h,d,a,v){const A=m(a),l=this._fileSearchProvider.get(h);if(l)return this._fileSearchManager.fileSearch(A,l,_=>{this._proxy.$handleFileMatch(h,d,_.map(s=>s.resource))},v);throw new Error("unknown provider: "+h)}$clearCache(h){return this._fileSearchManager.clearCache(h),Promise.resolve(void 0)}$provideTextSearchResults(h,d,a,v){const A=this._textSearchProvider.get(h);if(!A||!A.provideTextSearchResults)throw new Error(`Unknown provider ${h}`);const l=m(a);return this.createTextSearchManager(l,A).search(s=>this._proxy.$handleTextMatch(h,d,s),v)}$enableExtensionHostSearch(){}createTextSearchManager(h,d){return new R.TextSearchManager(h,d,{readdir:a=>Promise.resolve([]),toCanonicalName:a=>a},"textSearchProvider")}};y=ze([xe(0,D.IExtHostRpcService),xe(1,T.IURITransformerService),xe(2,E.ILogService)],y),e.ExtHostSearch=y;function m(f){return{...f,folderQueries:f.folderQueries&&f.folderQueries.map(I),extraFileResources:f.extraFileResources&&f.extraFileResources.map(h=>P.URI.revive(h))}}e.reviveQuery=m;function I(f){return{...f,folder:P.URI.revive(f.folder)}}}),define(De[232],Ce([1,0,56,98,31,95,32,36,49,52,100,102,103,69,62,68,97,51,35,67,86,50,204,14,180,101]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l,_,s,u,n,i){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(u.ILoggerService,s.ExtHostLoggerService),(0,o.registerSingleton)(u.ILogService,n.ExtHostLogService),(0,o.registerSingleton)(h.IExtHostApiDeprecationService,h.ExtHostApiDeprecationService),(0,o.registerSingleton)(T.IExtHostCommands,T.ExtHostCommands),(0,o.registerSingleton)(D.IExtHostConfiguration,D.ExtHostConfiguration),(0,o.registerSingleton)(a.IExtHostConsumerFileSystem,a.ExtHostConsumerFileSystem),(0,o.registerSingleton)(y.IExtHostDebugService,y.WorkerExtHostDebugService),(0,o.registerSingleton)(L.IExtHostDecorations,L.ExtHostDecorations),(0,o.registerSingleton)(E.IExtHostDocumentsAndEditors,E.ExtHostDocumentsAndEditors),(0,o.registerSingleton)(v.IExtHostFileSystemInfo,v.ExtHostFileSystemInfo),(0,o.registerSingleton)(p.IExtHostOutputService,p.ExtHostOutputService),(0,o.registerSingleton)(m.IExtHostSearch,m.ExtHostSearch),(0,o.registerSingleton)(I.IExtHostStorage,I.ExtHostStorage),(0,o.registerSingleton)(R.IExtHostTask,R.WorkerExtHostTask),(0,o.registerSingleton)(P.IExtHostTerminalService,P.WorkerExtHostTerminalService),(0,o.registerSingleton)(f.IExtHostTunnelService,f.ExtHostTunnelService),(0,o.registerSingleton)(d.IExtHostWindow,d.ExtHostWindow),(0,o.registerSingleton)(b.IExtHostWorkspace,b.ExtHostWorkspace),(0,o.registerSingleton)(A.IExtHostSecretState,A.ExtHostSecretState),(0,o.registerSingleton)(l.IExtHostTelemetry,l.ExtHostTelemetry),(0,o.registerSingleton)(_.IExtHostEditorTabs,_.ExtHostEditorTabs),(0,o.registerSingleton)(i.IExtHostVariableResolverProvider,i.ExtHostVariableResolverProviderService)}),define(De[233],Ce([1,0]),function(te,e){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.TreeviewsService=void 0;class o{constructor(){this._dragOperations=new Map,this._renderedElements=new Map}removeDragOperationTransfer(b){if(b&&this._dragOperations.has(b)){const L=this._dragOperations.get(b);return this._dragOperations.delete(b),L}}addDragOperationTransfer(b,L){this._dragOperations.set(b,L)}getRenderedTreeElement(b){if(this._renderedElements.has(b))return this._renderedElements.get(b)}addRenderedTreeItemElement(b,L){this._renderedElements.set(b,L)}removeRenderedTreeItemElement(b){this._renderedElements.has(b)&&this._renderedElements.delete(b)}}e.TreeviewsService=o}),define(De[234],Ce([1,0,133,6,21,2,4,7,13,6,10,16,8,20,233,24]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostTreeViews=void 0;function d(A,l){if((0,R.isString)(A))return{label:A};if(A&&typeof A=="object"&&typeof A.label=="string"){let _;return Array.isArray(A.highlights)&&(_=A.highlights.filter(s=>s.length===2&&typeof s[0]=="number"&&typeof s[1]=="number"),_=_.length?_:void 0),{label:A.label,highlights:_}}}class a{constructor(l,_,s){this._proxy=l,this.commands=_,this.logService=s,this.treeViews=new Map,this.treeDragAndDropService=new f.TreeviewsService;function u(n){return n&&n.$treeViewId&&n.$treeItemHandle}_.registerArgumentProcessor({processArgument:n=>u(n)?this.convertArgument(n):Array.isArray(n)&&n.length>0?n.map(i=>u(i)?this.convertArgument(i):i):n})}registerTreeDataProvider(l,_,s){const u=this.createTreeView(l,{treeDataProvider:_},s);return{dispose:()=>u.dispose()}}createTreeView(l,_,s){if(!_||!_.treeDataProvider)throw new Error("Options with treeDataProvider is mandatory");const u=_.dragAndDropController?.dropMimeTypes??[],n=_.dragAndDropController?.dragMimeTypes??[],i=!!_.dragAndDropController?.handleDrag,r=!!_.dragAndDropController?.handleDrop,t=this._proxy.$registerTreeViewDataProvider(l,{showCollapseAll:!!_.showCollapseAll,canSelectMany:!!_.canSelectMany,dropMimeTypes:u,dragMimeTypes:n,hasHandleDrag:i,hasHandleDrop:r}),c=this.createExtHostTreeView(l,_,s);return{get onDidCollapseElement(){return c.onDidCollapseElement},get onDidExpandElement(){return c.onDidExpandElement},get selection(){return c.selectedElements},get onDidChangeSelection(){return c.onDidChangeSelection},get visible(){return c.visible},get onDidChangeVisibility(){return c.onDidChangeVisibility},get message(){return c.message},set message(w){c.message=w},get title(){return c.title},set title(w){c.title=w},get description(){return c.description},set description(w){c.description=w},get badge(){return(0,h.checkProposedApiEnabled)(s,"badges"),c.badge},set badge(w){(0,h.checkProposedApiEnabled)(s,"badges"),c.badge=w},reveal:(w,g)=>c.reveal(w,g),dispose:async()=>{await t,this.treeViews.delete(l),c.dispose()}}}$getChildren(l,_){const s=this.treeViews.get(l);return s?s.getChildren(_):Promise.reject(new Error((0,o.localize)(0,null,l)))}async $handleDrop(l,_,s,u,n,i,r,t){const c=this.treeViews.get(l);if(!c)return Promise.reject(new Error((0,o.localize)(1,null,l)));const w=m.DataTransfer.toDataTransfer(s,async g=>(await this._proxy.$resolveDropFileData(l,_,g)).buffer);return r===l&&t&&await this.addAdditionalTransferItems(w,c,t,n,i),c.onDrop(w,u,n)}async addAdditionalTransferItems(l,_,s,u,n){const i=this.treeDragAndDropService.removeDragOperationTransfer(n);if(i)(await i)?.forEach((r,t)=>{r&&l.set(t,r)});else if(n&&_.handleDrag){const r=_.handleDrag(s,l,u);this.treeDragAndDropService.addDragOperationTransfer(n,r),await r}return l}async $handleDrag(l,_,s,u){const n=this.treeViews.get(l);if(!n)return Promise.reject(new Error((0,o.localize)(2,null,l)));const i=await this.addAdditionalTransferItems(new p.DataTransfer,n,_,u,s);if(!!i)return m.DataTransfer.toDataTransferDTO(i)}async $hasResolve(l){const _=this.treeViews.get(l);if(!_)throw new Error((0,o.localize)(3,null,l));return _.hasResolve}$resolve(l,_,s){const u=this.treeViews.get(l);if(!u)throw new Error((0,o.localize)(4,null,l));return u.resolveTreeItem(_,s)}$setExpanded(l,_,s){const u=this.treeViews.get(l);if(!u)throw new Error((0,o.localize)(5,null,l));u.setExpanded(_,s)}$setSelection(l,_){const s=this.treeViews.get(l);if(!s)throw new Error((0,o.localize)(6,null,l));s.setSelection(_)}$setVisible(l,_){const s=this.treeViews.get(l);if(!s)throw new Error((0,o.localize)(7,null,l));s.setVisible(_)}createExtHostTreeView(l,_,s){const u=new v(l,_,this._proxy,this.commands.converter,this.logService,s);return this.treeViews.set(l,u),u}convertArgument(l){const _=this.treeViews.get(l.$treeViewId);return _?_.getExtensionElement(l.$treeItemHandle):null}}e.ExtHostTreeViews=a;class v extends T.Disposable{constructor(l,_,s,u,n,i){super();if(this.viewId=l,this.proxy=s,this.commands=u,this.logService=n,this.extension=i,this.roots=void 0,this.elements=new Map,this.nodes=new Map,this._visible=!1,this._selectedHandles=[],this._onDidExpandElement=this._register(new D.Emitter),this.onDidExpandElement=this._onDidExpandElement.event,this._onDidCollapseElement=this._register(new D.Emitter),this.onDidCollapseElement=this._onDidCollapseElement.event,this._onDidChangeSelection=this._register(new D.Emitter),this.onDidChangeSelection=this._onDidChangeSelection.event,this._onDidChangeVisibility=this._register(new D.Emitter),this.onDidChangeVisibility=this._onDidChangeVisibility.event,this._onDidChangeData=this._register(new D.Emitter),this.refreshPromise=Promise.resolve(),this.refreshQueue=Promise.resolve(),this._message="",this._title="",this._refreshCancellationSource=new I.CancellationTokenSource,i.contributes&&i.contributes.views)for(const c in i.contributes.views)for(const w of i.contributes.views[c])w.id===l&&(this._title=w.name);this.dataProvider=_.treeDataProvider,this.dndController=_.dragAndDropController,this.dataProvider.onDidChangeTreeData&&this._register(this.dataProvider.onDidChangeTreeData(c=>this._onDidChangeData.fire({message:!1,element:c})));let r,t;this._register(D.Event.debounce(this._onDidChangeData.event,(c,w)=>(c||(c={message:!1,elements:[]}),w.element!==!1&&(r||(r=new Promise(g=>t=g),this.refreshPromise=this.refreshPromise.then(()=>r)),Array.isArray(w.element)?c.elements.push(...w.element):c.elements.push(w.element)),w.message&&(c.message=!0),c),200,!0)(({message:c,elements:w})=>{w.length&&(this.refreshQueue=this.refreshQueue.then(()=>{const g=t;return r=null,this.refresh(w).then(()=>g())})),c&&this.proxy.$setMessage(this.viewId,this._message)}))}get visible(){return this._visible}get selectedElements(){return this._selectedHandles.map(l=>this.getExtensionElement(l)).filter(l=>!(0,R.isUndefinedOrNull)(l))}async getChildren(l){const _=l?this.getExtensionElement(l):void 0;if(l&&!_)return this.logService.error(`No tree item with id '${l}' found.`),Promise.resolve([]);let s=this.getChildrenNodes(l);return s||(s=await this.fetchChildrenNodes(_)),s?s.map(u=>u.item):void 0}getExtensionElement(l){return this.elements.get(l)}reveal(l,_){_=_||{select:!0,focus:!1};const s=(0,R.isUndefinedOrNull)(_.select)?!0:_.select,u=(0,R.isUndefinedOrNull)(_.focus)?!1:_.focus,n=(0,R.isUndefinedOrNull)(_.expand)?!1:_.expand;return typeof this.dataProvider.getParent!="function"?Promise.reject(new Error("Required registered TreeDataProvider to implement 'getParent' method to access 'reveal' method")):l?this.refreshPromise.then(()=>this.resolveUnknownParentChain(l)).then(i=>this.resolveTreeNode(l,i[i.length-1]).then(r=>this.proxy.$reveal(this.viewId,{item:r.item,parentChain:i.map(t=>t.item)},{select:s,focus:u,expand:n})),i=>this.logService.error(i)):this.proxy.$reveal(this.viewId,void 0,{select:s,focus:u,expand:n})}get message(){return this._message}set message(l){this._message=l,this._onDidChangeData.fire({message:!0,element:!1})}get title(){return this._title}set title(l){this._title=l,this.proxy.$setTitle(this.viewId,l,this._description)}get description(){return this._description}set description(l){this._description=l,this.proxy.$setTitle(this.viewId,this._title,l)}get badge(){return this._badge}set badge(l){this._badge?.value===l?.value&&this._badge?.tooltip===l?.tooltip||(this._badge=m.ViewBadge.from(l),this.proxy.$setBadge(this.viewId,l))}setExpanded(l,_){const s=this.getExtensionElement(l);s&&(_?this._onDidExpandElement.fire(Object.freeze({element:s})):this._onDidCollapseElement.fire(Object.freeze({element:s})))}setSelection(l){(0,y.equals)(this._selectedHandles,l)||(this._selectedHandles=l,this._onDidChangeSelection.fire(Object.freeze({selection:this.selectedElements})))}setVisible(l){l!==this._visible&&(this._visible=l,this._onDidChangeVisibility.fire(Object.freeze({visible:this._visible})))}async handleDrag(l,_,s){const u=[];for(const n of l){const i=this.getExtensionElement(n);i&&u.push(i)}if(!(!this.dndController?.handleDrag||u.length===0))return await this.dndController.handleDrag(u,_,s),_}get hasHandleDrag(){return!!this.dndController?.handleDrag}async onDrop(l,_,s){const u=_?this.getExtensionElement(_):void 0;if(!(!u&&_||!this.dndController?.handleDrop))return(0,E.asPromise)(()=>this.dndController?.handleDrop?this.dndController.handleDrop(u,l,s):void 0)}get hasResolve(){return!!this.dataProvider.resolveTreeItem}async resolveTreeItem(l,_){if(!this.dataProvider.resolveTreeItem)return;const s=this.elements.get(l);if(s){const u=this.nodes.get(s);if(u){const n=await this.dataProvider.resolveTreeItem(u.extensionItem,s,_)??u.extensionItem;return this.validateTreeItem(n),u.item.tooltip=this.getTooltip(n.tooltip),u.item.command=this.getCommand(u.disposableStore,n.command),u.item}}}resolveUnknownParentChain(l){return this.resolveParent(l).then(_=>_?this.resolveUnknownParentChain(_).then(s=>this.resolveTreeNode(_,s[s.length-1]).then(u=>(s.push(u),s))):Promise.resolve([]))}resolveParent(l){const _=this.nodes.get(l);return _?Promise.resolve(_.parent?this.elements.get(_.parent.item.handle):void 0):(0,E.asPromise)(()=>this.dataProvider.getParent(l))}resolveTreeNode(l,_){const s=this.nodes.get(l);return s?Promise.resolve(s):(0,E.asPromise)(()=>this.dataProvider.getTreeItem(l)).then(u=>this.createHandle(l,u,_,!0)).then(u=>this.getChildren(_?_.item.handle:void 0).then(()=>{const n=this.getExtensionElement(u);if(n){const i=this.nodes.get(n);if(i)return Promise.resolve(i)}throw new Error(`Cannot resolve tree item for element ${u}`)}))}getChildrenNodes(l){if(l){let _;if(typeof l=="string"){const s=this.getExtensionElement(l);_=s?this.nodes.get(s):void 0}else _=l;return _&&_.children||void 0}return this.roots}async fetchChildrenNodes(l){this.clearChildren(l);const _=new I.CancellationTokenSource(this._refreshCancellationSource.token);try{const s=l?this.nodes.get(l):void 0,u=await this.dataProvider.getChildren(l);if(_.token.isCancellationRequested)return;const n=await Promise.all((0,y.coalesce)(u||[]).map(async i=>{const r=await this.dataProvider.getTreeItem(i);return r&&!_.token.isCancellationRequested?this.createAndRegisterTreeNode(i,r,s):null}));return _.token.isCancellationRequested?void 0:(0,y.coalesce)(n)}finally{_.dispose()}}refresh(l){if(l.some(s=>!s))return this._refreshCancellationSource.dispose(!0),this._refreshCancellationSource=new I.CancellationTokenSource,this.clearAll(),this.proxy.$refresh(this.viewId);{const s=this.getHandlesToRefresh(l);if(s.length)return this.refreshHandles(s)}return Promise.resolve(void 0)}getHandlesToRefresh(l){const _=new Set,s=l.map(n=>this.nodes.get(n));for(const n of s)if(n&&!_.has(n.item.handle)){let i=n;for(;i&&i.parent&&s.findIndex(r=>i&&i.parent&&r&&r.item.handle===i.parent.item.handle)===-1;){const r=this.elements.get(i.parent.item.handle);i=r?this.nodes.get(r):void 0}i&&!i.parent&&_.add(n.item.handle)}const u=[];return _.forEach(n=>{const i=this.elements.get(n);if(i){const r=this.nodes.get(i);r&&(!r.parent||!_.has(r.parent.item.handle))&&u.push(n)}}),u}refreshHandles(l){const _={};return Promise.all(l.map(s=>this.refreshNode(s).then(u=>{u&&(_[s]=u.item)}))).then(()=>Object.keys(_).length?this.proxy.$refresh(this.viewId,_):void 0)}refreshNode(l){const _=this.getExtensionElement(l);if(_){const s=this.nodes.get(_);if(s)return this.clearChildren(_),(0,E.asPromise)(()=>this.dataProvider.getTreeItem(_)).then(u=>{if(u){const n=this.createTreeNode(_,u,s.parent);return this.updateNodeCache(_,n,s,s.parent),s.dispose(),n}return null})}return Promise.resolve(null)}createAndRegisterTreeNode(l,_,s){const u=this.createTreeNode(l,_,s);if(_.id&&this.elements.has(u.item.handle))throw new Error((0,o.localize)(8,null,_.id));return this.addNodeToCache(l,u),this.addNodeToParentCache(u,s),u}getTooltip(l){return P.MarkdownString.isMarkdownString(l)?m.MarkdownString.from(l):l}getCommand(l,_){return _?this.commands.toInternal(_,l):void 0}validateTreeItem(l){P.TreeItem.isTreeItem(l)||console.log(`Extension ${this.extension.identifier.value} has provided an invalid tree item.`)}createTreeNode(l,_,s){this.validateTreeItem(_);const u=new T.DisposableStore,n=this.createHandle(l,_,s),i=this.getLightIconPath(_);return{item:{handle:n,parentHandle:s?s.item.handle:void 0,label:d(_.label,this.extension),description:_.description,resourceUri:_.resourceUri,tooltip:this.getTooltip(_.tooltip),command:this.getCommand(u,_.command),contextValue:_.contextValue,icon:i,iconDark:this.getDarkIconPath(_)||i,themeIcon:this.getThemeIcon(_),collapsibleState:(0,R.isUndefinedOrNull)(_.collapsibleState)?P.TreeItemCollapsibleState.None:_.collapsibleState,accessibilityInformation:_.accessibilityInformation},extensionItem:_,parent:s,children:void 0,disposableStore:u,dispose(){u.dispose()}}}getThemeIcon(l){return l.iconPath instanceof P.ThemeIcon?l.iconPath:void 0}createHandle(l,{id:_,label:s,resourceUri:u},n,i){if(_)return`${v.ID_HANDLE_PREFIX}/${_}`;const r=d(s,this.extension),t=n?n.item.handle:v.LABEL_HANDLE_PREFIX;let c=r?r.label:u?(0,b.basename)(u):"";c=c.indexOf("/")!==-1?c.replace("/","//"):c;const w=this.nodes.has(l)?this.nodes.get(l).item.handle:void 0,g=this.getChildrenNodes(n)||[];let C,U=0;do{if(C=`${t}/${U}:${c}`,i||!this.elements.has(C)||w===C)break;U++}while(U<=g.length);return C}getLightIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon))return typeof l.iconPath=="string"||L.URI.isUri(l.iconPath)?this.getIconPath(l.iconPath):this.getIconPath(l.iconPath.light)}getDarkIconPath(l){if(l.iconPath&&!(l.iconPath instanceof P.ThemeIcon)&&l.iconPath.dark)return this.getIconPath(l.iconPath.dark)}getIconPath(l){return L.URI.isUri(l)?l:L.URI.file(l)}addNodeToCache(l,_){this.elements.set(_.item.handle,l),this.nodes.set(l,_)}updateNodeCache(l,_,s,u){this.elements.delete(_.item.handle),this.nodes.delete(l),_.item.handle!==s.item.handle&&this.elements.delete(s.item.handle),this.addNodeToCache(l,_);const n=this.getChildrenNodes(u)||[],i=n.filter(r=>r.item.handle===s.item.handle)[0];i&&n.splice(n.indexOf(i),1,_)}addNodeToParentCache(l,_){_?(_.children||(_.children=[]),_.children.push(l)):(this.roots||(this.roots=[]),this.roots.push(l))}clearChildren(l){if(l){const _=this.nodes.get(l);if(_){if(_.children)for(const s of _.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}_.children=void 0}}else this.clearAll()}clear(l){const _=this.nodes.get(l);if(_){if(_.children)for(const s of _.children){const u=this.elements.get(s.item.handle);u&&this.clear(u)}this.nodes.delete(l),this.elements.delete(_.item.handle),_.dispose()}}clearAll(){this.roots=void 0,this.elements.clear(),this.nodes.forEach(l=>l.dispose()),this.nodes.clear()}dispose(){this._refreshCancellationSource.dispose(),this.clearAll()}}v.LABEL_HANDLE_PREFIX="0",v.ID_HANDLE_PREFIX="1"}),define(De[235],Ce([1,0,20,11,4,29,2,120,245,109,118,39,5,94,189,188,36,190,32,192,193,194,173,195,49,33,197,198,201,203,205,98,176,209,210,211,69,52,213,234,8,6,216,53,97,31,163,200,85,95,100,102,103,14,63,15,28,206,160,62,68,186,214,70,51,219,217,218,187,35,212,215,67,50,86,207,99,208,12,81,175,158,199,7,24,165,9]),function(te,e,o,p,b,L,D,T,E,P,R,y,m,I,f,h,d,a,v,A,l,_,s,u,n,i,r,t,c,w,g,C,U,W,M,S,z,$,N,K,V,F,ne,ce,re,fe,ie,Ee,be,ee,ve,Ae,Fe,$e,Qe,Ie,Se,Te,ae,le,X,Y,k,B,H,j,oe,ue,Z,pe,ge,Ne,Be,Ze,Ge,ke,nt,G,Q,he,Ue,We,et,je,He,it,rt){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.createApiFactoryAndRegisterActors=void 0;function dt(lt){const st=lt.get(Se.IExtHostInitDataService),yt=lt.get(pe.IExtHostFileSystemInfo),Ot=lt.get(H.IExtHostConsumerFileSystem),Ft=lt.get(i.IExtHostExtensionService),ft=lt.get(fe.IExtHostWorkspace),Dt=lt.get(Ge.IExtHostTelemetry),Ut=lt.get(v.IExtHostConfiguration),Nt=lt.get(Qe.IURITransformerService),Ve=lt.get(Ie.IExtHostRpcService),Mt=lt.get(z.IExtHostStorage),At=lt.get(B.IExtensionStoragePaths),Lt=lt.get($e.ILoggerService),gt=lt.get($e.ILogService),It=lt.get(le.IExtHostTunnelService),we=lt.get(X.IExtHostApiDeprecationService),ye=lt.get(re.IExtHostWindow),me=lt.get(Be.IExtHostSecretState),q=lt.get(Ze.IExtHostEditorTabs);Ve.set(m.ExtHostContext.ExtHostFileSystemInfo,yt),Ve.set(m.ExtHostContext.ExtHostLogLevelServiceShape,Lt),Ve.set(m.ExtHostContext.ExtHostWorkspace,ft),Ve.set(m.ExtHostContext.ExtHostConfiguration,Ut),Ve.set(m.ExtHostContext.ExtHostExtensionService,Ft),Ve.set(m.ExtHostContext.ExtHostStorage,Mt),Ve.set(m.ExtHostContext.ExtHostTunnelService,It),Ve.set(m.ExtHostContext.ExtHostWindow,ye),Ve.set(m.ExtHostContext.ExtHostSecretState,me),Ve.set(m.ExtHostContext.ExtHostTelemetry,Dt),Ve.set(m.ExtHostContext.ExtHostEditorTabs,q);const Pe=Ve.set(m.ExtHostContext.ExtHostDecorations,lt.get(ee.IExtHostDecorations)),Le=Ve.set(m.ExtHostContext.ExtHostDocumentsAndEditors,lt.get(n.IExtHostDocumentsAndEditors)),Ye=Ve.set(m.ExtHostContext.ExtHostCommands,lt.get(d.IExtHostCommands)),Xe=Ve.set(m.ExtHostContext.ExtHostTerminalService,lt.get($.IExtHostTerminalService)),Ke=Ve.set(m.ExtHostContext.ExtHostDebugService,lt.get(Ae.IExtHostDebugService)),pt=Ve.set(m.ExtHostContext.ExtHostSearch,lt.get(Fe.IExtHostSearch)),bt=Ve.set(m.ExtHostContext.ExtHostTask,lt.get(ve.IExtHostTask)),kt=Ve.set(m.ExtHostContext.ExtHostOutputService,lt.get(C.IExtHostOutputService)),Et=Ve.set(m.ExtHostContext.ExtHostUrls,new ne.ExtHostUrls(Ve)),ht=Ve.set(m.ExtHostContext.ExtHostDocuments,new u.ExtHostDocuments(Ve,Le)),Rt=Ve.set(m.ExtHostContext.ExtHostDocumentContentProviders,new _.ExtHostDocumentContentProvider(Ve,Le,gt)),_t=Ve.set(m.ExtHostContext.ExtHostDocumentSaveParticipant,new s.ExtHostDocumentSaveParticipant(gt,ht,Ve.getProxy(m.MainContext.MainThreadBulkEdits))),vt=Ve.set(m.ExtHostContext.ExtHostNotebook,new Te.ExtHostNotebookController(Ve,Ye,Le,ht,At)),Gt=Ve.set(m.ExtHostContext.ExtHostNotebookDocuments,new We.ExtHostNotebookDocuments(vt)),Xt=Ve.set(m.ExtHostContext.ExtHostNotebookEditors,new Ue.ExtHostNotebookEditors(gt,vt)),Ht=Ve.set(m.ExtHostContext.ExtHostNotebookKernels,new ke.ExtHostNotebookKernels(Ve,st,vt,Ye,gt)),Vt=Ve.set(m.ExtHostContext.ExtHostNotebookRenderers,new G.ExtHostNotebookRenderers(Ve,vt)),Tt=Ve.set(m.ExtHostContext.ExtHostEditors,new N.ExtHostEditors(Ve,Le)),_i=Ve.set(m.ExtHostContext.ExtHostTreeViews,new K.ExtHostTreeViews(Ve.getProxy(m.MainContext.MainThreadTreeViews),Ye,gt)),hi=Ve.set(m.ExtHostContext.ExtHostEditorInsets,new ie.ExtHostEditorInsets(Ve.getProxy(m.MainContext.MainThreadEditorInsets),Tt,st.remote)),zt=Ve.set(m.ExtHostContext.ExtHostDiagnostics,new A.ExtHostDiagnostics(Ve,gt,yt)),ei=Ve.set(m.ExtHostContext.ExtHostLanguages,new w.ExtHostLanguages(Ve,ht,Ye.converter,Nt)),ut=Ve.set(m.ExtHostContext.ExtHostLanguageFeatures,new c.ExtHostLanguageFeatures(Ve,Nt,ht,Ye,zt,gt,we)),fi=Ve.set(m.ExtHostContext.ExtHostFileSystem,new r.ExtHostFileSystem(Ve,ut)),xt=Ve.set(m.ExtHostContext.ExtHostFileSystemEventService,new t.ExtHostFileSystemEventService(Ve,gt,Le)),Qt=Ve.set(m.ExtHostContext.ExtHostQuickOpen,(0,W.createExtHostQuickOpen)(Ve,ft,Ye)),ri=Ve.set(m.ExtHostContext.ExtHostSCM,new M.ExtHostSCM(Ve,Ye,gt)),mi=Ve.set(m.ExtHostContext.ExtHostComments,(0,a.createExtHostComments)(Ve,Ye,ht)),si=Ve.set(m.ExtHostContext.ExtHostProgress,new U.ExtHostProgress(Ve.getProxy(m.MainContext.MainThreadProgress))),Ti=Ve.set(m.ExtHostContext.ExtHosLabelService,new Ee.ExtHostLabelService(Ve)),Si=Ve.set(m.ExtHostContext.ExtHostTheming,new ae.ExtHostTheming(Ve)),ti=Ve.set(m.ExtHostContext.ExtHostAuthentication,new Y.ExtHostAuthentication(Ve)),gi=Ve.set(m.ExtHostContext.ExtHostTimeline,new k.ExtHostTimeline(Ve,Ye)),ii=Ve.set(m.ExtHostContext.ExtHostWebviews,new ce.ExtHostWebviews(Ve,st.remote,ft,gt,we)),ni=Ve.set(m.ExtHostContext.ExtHostWebviewPanels,new ue.ExtHostWebviewPanels(Ve,ii,ft)),Pi=Ve.set(m.ExtHostContext.ExtHostCustomEditors,new oe.ExtHostCustomEditors(Ve,ht,At,ii,ni)),pi=Ve.set(m.ExtHostContext.ExtHostWebviewViews,new j.ExtHostWebviewViews(Ve,ii)),Yt=Ve.set(m.ExtHostContext.ExtHostTesting,new ge.ExtHostTesting(Ve,Ye)),Ai=Ve.set(m.ExtHostContext.ExtHostUriOpeners,new Ne.ExtHostUriOpeners(Ve));Ve.set(m.ExtHostContext.ExtHostInteractive,new et.ExtHostInteractive(Ve,vt,Le,Ye,gt));const Ri=Object.values(m.ExtHostContext);Ve.assertRegistered(Ri);const Oi=new Z.ExtHostBulkEdits(Ve,Le),Fi=new h.ExtHostClipboard(Ve),vi=new g.ExtHostMessageService(Ve,gt),yi=new l.ExtHostDialogs(Ve),oi=new S.ExtHostStatusBar(Ve,Ye.converter);return f.ExtHostApiCommands.register(Ye),function(Me,jt,Di){const mt=function(){let se=!Me.isUnderDevelopment;function de(){se||(gt.info(`Extension '${Me.identifier.value}' uses a document selector without scheme. Learn more about this: https://go.microsoft.com/fwlink/?linkid=872305`),se=!0)}return function Re(ot){if(Array.isArray(ot))ot.forEach(Re);else if(typeof ot=="string")de();else{const wt=ot;typeof wt.scheme=="undefined"&&de(),typeof wt.exclusive=="boolean"&&(0,He.checkProposedApiEnabled)(Me,"documentFiltersExclusive")}return ot}}(),ai={getSession(se,de,Re){return ti.getSession(Me,se,de,Re)},async hasSession(se,de){return(0,He.checkProposedApiEnabled)(Me,"authSession"),!!await ti.getSession(Me,se,de,{silent:!0})},get onDidChangeSessions(){return ti.onDidChangeSessions},registerAuthenticationProvider(se,de,Re,ot){return ti.registerAuthenticationProvider(se,de,Re,ot)}},Ni={registerCommand(se,de,Re){return Ye.registerCommand(!0,se,de,Re,void 0,Me)},registerTextEditorCommand(se,de,Re){return Ye.registerCommand(!0,se,(...ot)=>{const wt=Tt.getActiveTextEditor();if(!wt){gt.warn("Cannot execute "+se+" because there is no active text editor.");return}return wt.edit(Ct=>{de.apply(Re,[wt,Ct,...ot])}).then(Ct=>{Ct||gt.warn("Edits from command "+se+" were not applied.")},Ct=>{gt.warn("An error occurred while running command "+se,Ct)})},void 0,void 0,Me)},registerDiffInformationCommand:(se,de,Re)=>((0,He.checkProposedApiEnabled)(Me,"diffCommand"),Ye.registerCommand(!0,se,async(...ot)=>{const wt=Le.activeEditor(!0);if(!wt){gt.warn("Cannot execute "+se+" because there is no active text editor.");return}const Ct=await Tt.getDiffInformation(wt.id);de.apply(Re,[Ct,...ot])},void 0,void 0,Me)),executeCommand(se,...de){return Ye.executeCommand(se,...de)},getCommands(se=!1){return Ye.getCommands(se)}},Ci={get machineId(){return st.telemetryInfo.machineId},get sessionId(){return st.telemetryInfo.sessionId},get language(){return st.environment.appLanguage},get appName(){return st.environment.appName},get appRoot(){return st.environment.appRoot?.fsPath??""},get appHost(){return st.environment.appHost},get uriScheme(){return st.environment.appUriScheme},get clipboard(){return Fi.value},get shell(){return Xe.getDefaultShell(!1)},get isTelemetryEnabled(){return Dt.getTelemetryConfiguration()},get onDidChangeTelemetryEnabled(){return Dt.onDidChangeTelemetryEnabled},get telemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Me,"telemetry"),Dt.getTelemetryDetails()},get onDidChangeTelemetryConfiguration(){return(0,He.checkProposedApiEnabled)(Me,"telemetry"),Dt.onDidChangeTelemetryConfiguration},get isNewAppInstall(){const se=Date.now()-new Date(st.telemetryInfo.firstSessionDate).getTime();return isNaN(se)?!1:se<1e3*60*60*24},openExternal(se,de){return ye.openUri(se,{allowTunneling:!!st.remote.authority,allowContributedOpeners:de?.allowContributedOpeners})},async asExternalUri(se){if(se.scheme===st.environment.appUriScheme)return Et.createAppUri(se);try{return await ye.asExternalUri(se,{allowTunneling:!!st.remote.authority})}catch(de){if((0,he.matchesScheme)(se,Q.Schemas.http)||(0,he.matchesScheme)(se,Q.Schemas.https))return se;throw de}},get remoteName(){return(0,be.getRemoteName)(st.remote.authority)},get remoteAuthority(){return(0,He.checkProposedApiEnabled)(Me,"resolvers"),st.remote.authority},get uiKind(){return st.uiKind}};st.environment.extensionTestsLocationURI||Object.freeze(Ci);const Mi={createTestController(se,de,Re){return Yt.createTestController(se,de,Re)},createTestObserver(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Yt.createTestObserver()},runTests(se){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Yt.runTests(se)},get onDidChangeTestResults(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Yt.onResultsChanged},get testResults(){return(0,He.checkProposedApiEnabled)(Me,"testObserver"),Yt.results}},ci=st.remote.isRemote?F.ExtensionKind.Workspace:F.ExtensionKind.UI,Ei={getExtension(se,de){(0,rt.equalsIgnoreCase)(se,"ms-vscode.references-view")&&(we.report("The extension 'ms-vscode.references-view' has been renamed.",Me,"Use 'vscode.references-view' instead."),se="vscode.references-view"),(0,He.isProposedApiEnabled)(Me,"extensionsAny")||(de=!1);const Re=jt.mine.getExtensionDescription(se);if(Re)return new i.Extension(Ft,Me.identifier,Re,ci,!1);if(de){const ot=jt.all.getExtensionDescription(se);if(ot)return new i.Extension(Ft,Me.identifier,ot,ci,!0)}},get all(){const se=[];for(const de of jt.mine.getAllExtensionDescriptions())se.push(new i.Extension(Ft,Me.identifier,de,ci,!1));return se},get allAcrossExtensionHosts(){(0,He.checkProposedApiEnabled)(Me,"extensionsAny");const se=new He.ExtensionIdentifierSet(jt.mine.getAllExtensionDescriptions().map(Re=>Re.identifier)),de=[];for(const Re of jt.all.getAllExtensionDescriptions()){const ot=!se.has(Re.identifier);de.push(new i.Extension(Ft,Me.identifier,Re,ci,ot))}return de},get onDidChange(){return(0,He.isProposedApiEnabled)(Me,"extensionsAny")?b.Event.any(jt.mine.onDidChange,jt.all.onDidChange):jt.mine.onDidChange}},Li={createDiagnosticCollection(se){return zt.createDiagnosticCollection(Me.identifier,se)},get onDidChangeDiagnostics(){return zt.onDidChangeDiagnostics},getDiagnostics:se=>zt.getDiagnostics(se),getLanguages(){return ei.getLanguages()},setTextDocumentLanguage(se,de){return ei.changeLanguage(se.uri,de)},match(se,de){const Re=ht.getDocumentData(de.uri)?.notebook;return(0,R.score)(V.LanguageSelector.from(se),de.uri,de.languageId,!0,Re?.uri,Re?.notebookType)},registerCodeActionsProvider(se,de,Re){return ut.registerCodeActionProvider(Me,mt(se),de,Re)},registerDocumentPasteEditProvider(se,de,Re){return(0,He.checkProposedApiEnabled)(Me,"documentPaste"),ut.registerDocumentPasteEditProvider(Me,mt(se),de,Re)},registerCodeLensProvider(se,de){return ut.registerCodeLensProvider(Me,mt(se),de)},registerDefinitionProvider(se,de){return ut.registerDefinitionProvider(Me,mt(se),de)},registerDeclarationProvider(se,de){return ut.registerDeclarationProvider(Me,mt(se),de)},registerImplementationProvider(se,de){return ut.registerImplementationProvider(Me,mt(se),de)},registerTypeDefinitionProvider(se,de){return ut.registerTypeDefinitionProvider(Me,mt(se),de)},registerHoverProvider(se,de){return ut.registerHoverProvider(Me,mt(se),de,Me.identifier)},registerEvaluatableExpressionProvider(se,de){return ut.registerEvaluatableExpressionProvider(Me,mt(se),de,Me.identifier)},registerInlineValuesProvider(se,de){return ut.registerInlineValuesProvider(Me,mt(se),de,Me.identifier)},registerDocumentHighlightProvider(se,de){return ut.registerDocumentHighlightProvider(Me,mt(se),de)},registerLinkedEditingRangeProvider(se,de){return ut.registerLinkedEditingRangeProvider(Me,mt(se),de)},registerReferenceProvider(se,de){return ut.registerReferenceProvider(Me,mt(se),de)},registerRenameProvider(se,de){return ut.registerRenameProvider(Me,mt(se),de)},registerDocumentSymbolProvider(se,de,Re){return ut.registerDocumentSymbolProvider(Me,mt(se),de,Re)},registerWorkspaceSymbolProvider(se){return ut.registerWorkspaceSymbolProvider(Me,se)},registerDocumentFormattingEditProvider(se,de){return ut.registerDocumentFormattingEditProvider(Me,mt(se),de)},registerDocumentRangeFormattingEditProvider(se,de){return ut.registerDocumentRangeFormattingEditProvider(Me,mt(se),de)},registerOnTypeFormattingEditProvider(se,de,Re,...ot){return ut.registerOnTypeFormattingEditProvider(Me,mt(se),de,[Re].concat(ot))},registerDocumentSemanticTokensProvider(se,de,Re){return ut.registerDocumentSemanticTokensProvider(Me,mt(se),de,Re)},registerDocumentRangeSemanticTokensProvider(se,de,Re){return ut.registerDocumentRangeSemanticTokensProvider(Me,mt(se),de,Re)},registerSignatureHelpProvider(se,de,Re,...ot){return typeof Re=="object"?ut.registerSignatureHelpProvider(Me,mt(se),de,Re):ut.registerSignatureHelpProvider(Me,mt(se),de,typeof Re=="undefined"?[]:[Re,...ot])},registerCompletionItemProvider(se,de,...Re){return ut.registerCompletionItemProvider(Me,mt(se),de,Re)},registerInlineCompletionItemProvider(se,de){return de.handleDidShowCompletionItem&&(0,He.checkProposedApiEnabled)(Me,"inlineCompletionsAdditions"),ut.registerInlineCompletionsProvider(Me,mt(se),de)},registerInlineCompletionItemProviderNew(se,de){if((0,He.checkProposedApiEnabled)(Me,"inlineCompletionsNew"),de.handleDidShowCompletionItem&&!(0,He.isProposedApiEnabled)(Me,"inlineCompletionsAdditions"))throw new Error(`When the method "handleDidShowCompletionItem" is implemented on a provider, the usage of the proposed api 'inlineCompletionsAdditions' must be declared!`);return ut.registerInlineCompletionsProviderNew(Me,mt(se),de)},registerDocumentLinkProvider(se,de){return ut.registerDocumentLinkProvider(Me,mt(se),de)},registerColorProvider(se,de){return ut.registerColorProvider(Me,mt(se),de)},registerFoldingRangeProvider(se,de){return ut.registerFoldingRangeProvider(Me,mt(se),de)},registerSelectionRangeProvider(se,de){return ut.registerSelectionRangeProvider(Me,se,de)},registerCallHierarchyProvider(se,de){return ut.registerCallHierarchyProvider(Me,se,de)},registerTypeHierarchyProvider(se,de){return ut.registerTypeHierarchyProvider(Me,se,de)},setLanguageConfiguration:(se,de)=>ut.setLanguageConfiguration(Me,se,de),getTokenInformationAtPosition(se,de){return(0,He.checkProposedApiEnabled)(Me,"tokenInformation"),ei.tokenAtPosition(se,de)},registerInlayHintsProvider(se,de){return ut.registerInlayHintsProvider(Me,se,de)},createLanguageStatusItem(se,de){return ei.createLanguageStatusItem(Me,se,de)},registerDocumentDropEditProvider(se,de){return ut.registerDocumentOnDropEditProvider(Me,se,de)}},$t={get activeTextEditor(){return Tt.getActiveTextEditor()},get visibleTextEditors(){return Tt.getVisibleTextEditors()},get activeTerminal(){return Xe.activeTerminal},get terminals(){return Xe.terminals},async showTextDocument(se,de,Re){const ot=await(D.URI.isUri(se)?Promise.resolve(qt.openTextDocument(se)):Promise.resolve(se));return Tt.showTextDocument(ot,de,Re)},createTextEditorDecorationType(se){return Tt.createTextEditorDecorationType(Me,se)},onDidChangeActiveTextEditor(se,de,Re){return Tt.onDidChangeActiveTextEditor(se,de,Re)},onDidChangeVisibleTextEditors(se,de,Re){return Tt.onDidChangeVisibleTextEditors(se,de,Re)},onDidChangeTextEditorSelection(se,de,Re){return Tt.onDidChangeTextEditorSelection(se,de,Re)},onDidChangeTextEditorOptions(se,de,Re){return Tt.onDidChangeTextEditorOptions(se,de,Re)},onDidChangeTextEditorVisibleRanges(se,de,Re){return Tt.onDidChangeTextEditorVisibleRanges(se,de,Re)},onDidChangeTextEditorViewColumn(se,de,Re){return Tt.onDidChangeTextEditorViewColumn(se,de,Re)},onDidCloseTerminal(se,de,Re){return Xe.onDidCloseTerminal(se,de,Re)},onDidOpenTerminal(se,de,Re){return Xe.onDidOpenTerminal(se,de,Re)},onDidChangeActiveTerminal(se,de,Re){return Xe.onDidChangeActiveTerminal(se,de,Re)},onDidChangeTerminalDimensions(se,de,Re){return(0,He.checkProposedApiEnabled)(Me,"terminalDimensions"),Xe.onDidChangeTerminalDimensions(se,de,Re)},onDidChangeTerminalState(se,de,Re){return Xe.onDidChangeTerminalState(se,de,Re)},onDidWriteTerminalData(se,de,Re){return(0,He.checkProposedApiEnabled)(Me,"terminalDataWriteEvent"),Xe.onDidWriteTerminalData(se,de,Re)},get state(){return ye.state},onDidChangeWindowState(se,de,Re){return ye.onDidChangeWindowState(se,de,Re)},showInformationMessage(se,...de){return vi.showMessage(Me,L.default.Info,se,de[0],de.slice(1))},showWarningMessage(se,...de){return vi.showMessage(Me,L.default.Warning,se,de[0],de.slice(1))},showErrorMessage(se,...de){return vi.showMessage(Me,L.default.Error,se,de[0],de.slice(1))},showQuickPick(se,de,Re){return Qt.showQuickPick(se,de,Re)},showWorkspaceFolderPick(se){return Qt.showWorkspaceFolderPick(se)},showInputBox(se,de){return Qt.showInput(se,de)},showOpenDialog(se){return yi.showOpenDialog(se)},showSaveDialog(se){return yi.showSaveDialog(se)},createStatusBarItem(se,de,Re){let ot,wt,Ct;return typeof se=="string"?(ot=se,wt=de,Ct=Re):(wt=se,Ct=de),oi.createStatusBarEntry(Me,ot,wt,Ct)},setStatusBarMessage(se,de){return oi.setStatusBarMessage(se,de)},withScmProgress(se){return we.report("window.withScmProgress",Me,"Use 'withProgress' instead."),si.withProgress(Me,{location:F.ProgressLocation.SourceControl},(de,Re)=>se({report(ot){}}))},withProgress(se,de){return si.withProgress(Me,se,de)},createOutputChannel(se,de){return kt.createOutputChannel(se,de,Me)},createWebviewPanel(se,de,Re,ot){return ni.createWebviewPanel(Me,se,de,Re,ot)},createWebviewTextEditorInset(se,de,Re,ot){return(0,He.checkProposedApiEnabled)(Me,"editorInsets"),hi.createWebviewEditorInset(se,de,Re,ot,Me)},createTerminal(se,de,Re){return typeof se=="object"?"pty"in se?Xe.createExtensionTerminal(se):Xe.createTerminalFromOptions(se):Xe.createTerminal(se,de,Re)},registerTerminalLinkProvider(se){return Xe.registerLinkProvider(se)},registerTerminalProfileProvider(se,de){return Xe.registerProfileProvider(Me,se,de)},registerTreeDataProvider(se,de){return _i.registerTreeDataProvider(se,de,Me)},createTreeView(se,de){return _i.createTreeView(se,de,Me)},registerWebviewPanelSerializer:(se,de)=>ni.registerWebviewPanelSerializer(Me,se,de),registerCustomEditorProvider:(se,de,Re={})=>Pi.registerCustomEditorProvider(Me,se,de,Re),registerFileDecorationProvider(se){return Pe.registerFileDecorationProvider(se,Me.identifier)},registerUriHandler(se){return Et.registerUriHandler(Me.identifier,se)},createQuickPick(){return Qt.createQuickPick(Me)},createInputBox(){return Qt.createInputBox(Me)},get activeColorTheme(){return Si.activeColorTheme},onDidChangeActiveColorTheme(se,de,Re){return Si.onDidChangeActiveColorTheme(se,de,Re)},registerWebviewViewProvider(se,de,Re){return pi.registerWebviewViewProvider(Me,se,de,Re?.webviewOptions)},get activeNotebookEditor(){return vt.activeNotebookEditor},onDidChangeActiveNotebookEditor(se,de,Re){return vt.onDidChangeActiveNotebookEditor(se,de,Re)},get visibleNotebookEditors(){return vt.visibleNotebookEditors},get onDidChangeVisibleNotebookEditors(){return vt.onDidChangeVisibleNotebookEditors},onDidChangeNotebookEditorSelection(se,de,Re){return Xt.onDidChangeNotebookEditorSelection(se,de,Re)},onDidChangeNotebookEditorVisibleRanges(se,de,Re){return Xt.onDidChangeNotebookEditorVisibleRanges(se,de,Re)},showNotebookDocument(se,de){return D.URI.isUri(se)&&we.report("window.showNotebookDocument(uri)",Me,"Please use 'workspace.openNotebookDocument' and 'window.showNotebookDocument'"),vt.showNotebookDocument(se,de)},registerExternalUriOpener(se,de,Re){return(0,He.checkProposedApiEnabled)(Me,"externalUriOpener"),Ai.registerExternalUriOpener(Me.identifier,se,de,Re)},get tabGroups(){return q.tabGroups}},qt={get rootPath(){return we.report("workspace.rootPath",Me,"Please use 'workspace.workspaceFolders' instead. More details: https://aka.ms/vscode-eliminating-rootpath"),ft.getPath()},set rootPath(se){throw p.readonly()},getWorkspaceFolder(se){return ft.getWorkspaceFolder(se)},get workspaceFolders(){return ft.getWorkspaceFolders()},get name(){return ft.name},set name(se){throw p.readonly()},get workspaceFile(){return ft.workspaceFile},set workspaceFile(se){throw p.readonly()},updateWorkspaceFolders:(se,de,...Re)=>ft.updateWorkspaceFolders(Me,se,de||0,...Re),onDidChangeWorkspaceFolders:function(se,de,Re){return ft.onDidChangeWorkspace(se,de,Re)},asRelativePath:(se,de)=>ft.getRelativePath(se,de),findFiles:(se,de,Re,ot)=>ft.findFiles(se,de,Re,Me.identifier,ot),findTextInFiles:(se,de,Re,ot)=>{(0,He.checkProposedApiEnabled)(Me,"findTextInFiles");let wt,Ct;return typeof de=="object"?(wt=de,Ct=Re):(wt={},Ct=de,ot=Re),ft.findTextInFiles(se,wt||{},Ct,Me.identifier,ot)},saveAll:se=>ft.saveAll(se),applyEdit(se){return Oi.applyWorkspaceEdit(se,Me)},createFileSystemWatcher:(se,de,Re,ot)=>xt.createFileSystemWatcher(ft,Me,se,de,Re,ot),get textDocuments(){return ht.getAllDocumentData().map(se=>se.document)},set textDocuments(se){throw p.readonly()},openTextDocument(se){let de;const Re=se;if(typeof se=="string")de=Promise.resolve(D.URI.file(se));else if(D.URI.isUri(se))de=Promise.resolve(se);else if(!Re||typeof Re=="object")de=ht.createDocumentData(Re);else throw new Error("illegal argument - uriOrFileNameOrOptions");return de.then(ot=>ht.ensureDocumentData(ot).then(wt=>wt.document))},onDidOpenTextDocument:(se,de,Re)=>ht.onDidAddDocument(se,de,Re),onDidCloseTextDocument:(se,de,Re)=>ht.onDidRemoveDocument(se,de,Re),onDidChangeTextDocument:(se,de,Re)=>ht.onDidChangeDocument(se,de,Re),onDidSaveTextDocument:(se,de,Re)=>ht.onDidSaveDocument(se,de,Re),onWillSaveTextDocument:(se,de,Re)=>_t.getOnWillSaveTextDocumentEvent(Me)(se,de,Re),get notebookDocuments(){return vt.notebookDocuments.map(se=>se.apiNotebook)},async openNotebookDocument(se,de){let Re;if(D.URI.isUri(se))Re=se,await vt.openNotebookDocument(se);else if(typeof se=="string")Re=D.URI.revive(await vt.createNotebookDocument({viewType:se,content:de}));else throw new Error("Invalid arguments");return vt.getNotebookDocument(Re).apiNotebook},onDidSaveNotebookDocument(se,de,Re){return Gt.onDidSaveNotebookDocument(se,de,Re)},onDidChangeNotebookDocument(se,de,Re){return Gt.onDidChangeNotebookDocument(se,de,Re)},get onDidOpenNotebookDocument(){return vt.onDidOpenNotebookDocument},get onDidCloseNotebookDocument(){return vt.onDidCloseNotebookDocument},registerNotebookSerializer(se,de,Re,ot){return vt.registerNotebookSerializer(Me,se,de,Re,(0,He.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)},registerNotebookContentProvider:(se,de,Re,ot)=>((0,He.checkProposedApiEnabled)(Me,"notebookContentProvider"),we.report("workspace.registerNotebookContentProvider",Me,"The notebookContentProvider API is not on track for finalization and will be removed."),vt.registerNotebookContentProvider(Me,se,de,Re,(0,He.isProposedApiEnabled)(Me,"notebookLiveShare")?ot:void 0)),onDidChangeConfiguration:(se,de,Re)=>Di.onDidChangeConfiguration(se,de,Re),getConfiguration(se,de){return de=arguments.length===1?void 0:de,Di.getConfiguration(se,de,Me)},registerTextDocumentContentProvider(se,de){return Rt.registerTextDocumentContentProvider(se,de)},registerTaskProvider:(se,de)=>(we.report("window.registerTaskProvider",Me,"Use the corresponding function on the 'tasks' namespace instead"),bt.registerTaskProvider(Me,se,de)),registerFileSystemProvider(se,de,Re){return(0,je.combinedDisposable)(fi.registerFileSystemProvider(Me,se,de,Re),Ot.addFileSystemProvider(se,de))},get fs(){return Ot.value},registerFileSearchProvider:(se,de)=>((0,He.checkProposedApiEnabled)(Me,"fileSearchProvider"),pt.registerFileSearchProvider(se,de)),registerTextSearchProvider:(se,de)=>((0,He.checkProposedApiEnabled)(Me,"textSearchProvider"),pt.registerTextSearchProvider(se,de)),registerRemoteAuthorityResolver:(se,de)=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),Ft.registerRemoteAuthorityResolver(se,de)),registerResourceLabelFormatter:se=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),Ti.$registerResourceLabelFormatter(se)),onDidCreateFiles:(se,de,Re)=>xt.onDidCreateFile(se,de,Re),onDidDeleteFiles:(se,de,Re)=>xt.onDidDeleteFile(se,de,Re),onDidRenameFiles:(se,de,Re)=>xt.onDidRenameFile(se,de,Re),onWillCreateFiles:(se,de,Re)=>xt.getOnWillCreateFileEvent(Me)(se,de,Re),onWillDeleteFiles:(se,de,Re)=>xt.getOnWillDeleteFileEvent(Me)(se,de,Re),onWillRenameFiles:(se,de,Re)=>xt.getOnWillRenameFileEvent(Me)(se,de,Re),openTunnel:se=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),It.openTunnel(Me,se).then(de=>{if(!de)throw new Error("cannot open tunnel");return de})),get tunnels(){return(0,He.checkProposedApiEnabled)(Me,"resolvers"),It.getTunnels()},onDidChangeTunnels:(se,de,Re)=>((0,He.checkProposedApiEnabled)(Me,"resolvers"),It.onDidChangeTunnels(se,de,Re)),registerPortAttributesProvider:(se,de)=>((0,He.checkProposedApiEnabled)(Me,"portsAttributes"),It.registerPortsAttributesProvider(se,de)),registerTimelineProvider:(se,de)=>((0,He.checkProposedApiEnabled)(Me,"timeline"),gi.registerTimelineProvider(se,de,Me.identifier,Ye.converter)),get isTrusted(){return ft.trusted},requestWorkspaceTrust:se=>((0,He.checkProposedApiEnabled)(Me,"workspaceTrust"),ft.requestWorkspaceTrust(se)),onDidGrantWorkspaceTrust:(se,de,Re)=>ft.onDidGrantWorkspaceTrust(se,de,Re)},Ui={get inputBox(){return we.report("scm.inputBox",Me,"Use 'SourceControl.inputBox' instead"),ri.getLastInputBox(Me)},createSourceControl(se,de,Re){return ri.createSourceControl(Me,se,de,Re)}},Bt={createCommentController(se,de){return mi.createCommentController(Me,se,de)}},li={get activeDebugSession(){return Ke.activeDebugSession},get activeDebugConsole(){return Ke.activeDebugConsole},get breakpoints(){return Ke.breakpoints},onDidStartDebugSession(se,de,Re){return Ke.onDidStartDebugSession(se,de,Re)},onDidTerminateDebugSession(se,de,Re){return Ke.onDidTerminateDebugSession(se,de,Re)},onDidChangeActiveDebugSession(se,de,Re){return Ke.onDidChangeActiveDebugSession(se,de,Re)},onDidReceiveDebugSessionCustomEvent(se,de,Re){return Ke.onDidReceiveDebugSessionCustomEvent(se,de,Re)},onDidChangeBreakpoints(se,de,Re){return Ke.onDidChangeBreakpoints(se,de,Re)},registerDebugConfigurationProvider(se,de,Re){return Ke.registerDebugConfigurationProvider(se,de,Re||it.DebugConfigurationProviderTriggerKind.Initial)},registerDebugAdapterDescriptorFactory(se,de){return Ke.registerDebugAdapterDescriptorFactory(Me,se,de)},registerDebugAdapterTrackerFactory(se,de){return Ke.registerDebugAdapterTrackerFactory(se,de)},startDebugging(se,de,Re){return!Re||typeof Re=="object"&&"configuration"in Re?Ke.startDebugging(se,de,{parentSession:Re}):Ke.startDebugging(se,de,Re||{})},stopDebugging(se){return Ke.stopDebugging(se)},addBreakpoints(se){return Ke.addBreakpoints(se)},removeBreakpoints(se){return Ke.removeBreakpoints(se)},asDebugSourceUri(se,de){return Ke.asDebugSourceUri(se,de)}},Bi={registerTaskProvider:(se,de)=>bt.registerTaskProvider(Me,se,de),fetchTasks:se=>bt.fetchTasks(se),executeTask:se=>bt.executeTask(Me,se),get taskExecutions(){return bt.taskExecutions},onDidStartTask:(se,de,Re)=>bt.onDidStartTask(se,de,Re),onDidEndTask:(se,de,Re)=>bt.onDidEndTask(se,de,Re),onDidStartTaskProcess:(se,de,Re)=>bt.onDidStartTaskProcess(se,de,Re),onDidEndTaskProcess:(se,de,Re)=>bt.onDidEndTaskProcess(se,de,Re)},zi={createNotebookController(se,de,Re,ot,wt){return Ht.createNotebookController(Me,se,de,Re,ot,(0,He.isProposedApiEnabled)(Me,"notebookMessaging")?wt:void 0)},registerNotebookCellStatusBarItemProvider:(se,de)=>vt.registerNotebookCellStatusBarItemProvider(Me,se,de),createRendererMessaging(se){return Vt.createRendererMessaging(Me,se)},onDidChangeNotebookCellExecutionState(se,de,Re){return(0,He.checkProposedApiEnabled)(Me,"notebookCellExecutionState"),Ht.onDidChangeNotebookCellExecutionState(se,de,Re)}};return{version:st.version,authentication:ai,commands:Ni,comments:Bt,debug:li,env:Ci,extensions:Ei,languages:Li,notebooks:zi,scm:Ui,tasks:Bi,tests:Mi,window:$t,workspace:qt,Breakpoint:F.Breakpoint,CallHierarchyIncomingCall:F.CallHierarchyIncomingCall,CallHierarchyItem:F.CallHierarchyItem,CallHierarchyOutgoingCall:F.CallHierarchyOutgoingCall,CancellationError:p.CancellationError,CancellationTokenSource:o.CancellationTokenSource,CandidatePortSource:m.CandidatePortSource,CodeAction:F.CodeAction,CodeActionKind:F.CodeActionKind,CodeActionTriggerKind:F.CodeActionTriggerKind,CodeLens:F.CodeLens,Color:F.Color,ColorInformation:F.ColorInformation,ColorPresentation:F.ColorPresentation,ColorThemeKind:F.ColorThemeKind,CommentMode:F.CommentMode,CommentThreadCollapsibleState:F.CommentThreadCollapsibleState,CommentThreadState:F.CommentThreadState,CompletionItem:F.CompletionItem,CompletionItemKind:F.CompletionItemKind,CompletionItemTag:F.CompletionItemTag,CompletionList:F.CompletionList,CompletionTriggerKind:F.CompletionTriggerKind,ConfigurationTarget:F.ConfigurationTarget,CustomExecution:F.CustomExecution,DebugAdapterExecutable:F.DebugAdapterExecutable,DebugAdapterInlineImplementation:F.DebugAdapterInlineImplementation,DebugAdapterNamedPipeServer:F.DebugAdapterNamedPipeServer,DebugAdapterServer:F.DebugAdapterServer,DebugConfigurationProviderTriggerKind:it.DebugConfigurationProviderTriggerKind,DebugConsoleMode:F.DebugConsoleMode,DecorationRangeBehavior:F.DecorationRangeBehavior,Diagnostic:F.Diagnostic,DiagnosticRelatedInformation:F.DiagnosticRelatedInformation,DiagnosticSeverity:F.DiagnosticSeverity,DiagnosticTag:F.DiagnosticTag,Disposable:F.Disposable,DocumentHighlight:F.DocumentHighlight,DocumentHighlightKind:F.DocumentHighlightKind,DocumentLink:F.DocumentLink,DocumentSymbol:F.DocumentSymbol,EndOfLine:F.EndOfLine,EnvironmentVariableMutatorType:F.EnvironmentVariableMutatorType,EvaluatableExpression:F.EvaluatableExpression,InlineValueText:F.InlineValueText,InlineValueVariableLookup:F.InlineValueVariableLookup,InlineValueEvaluatableExpression:F.InlineValueEvaluatableExpression,InlineCompletionTriggerKind:F.InlineCompletionTriggerKind,InlineCompletionTriggerKindNew:F.InlineCompletionTriggerKindNew,EventEmitter:b.Emitter,ExtensionKind:F.ExtensionKind,ExtensionMode:F.ExtensionMode,ExternalUriOpenerPriority:F.ExternalUriOpenerPriority,FileChangeType:F.FileChangeType,FileDecoration:F.FileDecoration,FileSystemError:F.FileSystemError,FileType:y.FileType,FilePermission:y.FilePermission,FoldingRange:F.FoldingRange,FoldingRangeKind:F.FoldingRangeKind,FunctionBreakpoint:F.FunctionBreakpoint,InlineCompletionItem:F.InlineSuggestion,InlineCompletionItemNew:F.InlineSuggestionNew,InlineCompletionList:F.InlineSuggestionList,InlineCompletionListNew:F.InlineSuggestionsNew,Hover:F.Hover,IndentAction:P.IndentAction,Location:F.Location,MarkdownString:F.MarkdownString,OverviewRulerLane:E.OverviewRulerLane,ParameterInformation:F.ParameterInformation,PortAutoForwardAction:F.PortAutoForwardAction,Position:F.Position,ProcessExecution:F.ProcessExecution,ProgressLocation:F.ProgressLocation,QuickInputButtons:F.QuickInputButtons,Range:F.Range,RelativePattern:F.RelativePattern,Selection:F.Selection,SelectionRange:F.SelectionRange,SemanticTokens:F.SemanticTokens,SemanticTokensBuilder:F.SemanticTokensBuilder,SemanticTokensEdit:F.SemanticTokensEdit,SemanticTokensEdits:F.SemanticTokensEdits,SemanticTokensLegend:F.SemanticTokensLegend,ShellExecution:F.ShellExecution,ShellQuoting:F.ShellQuoting,SignatureHelp:F.SignatureHelp,SignatureHelpTriggerKind:F.SignatureHelpTriggerKind,SignatureInformation:F.SignatureInformation,SnippetString:F.SnippetString,SourceBreakpoint:F.SourceBreakpoint,StandardTokenType:F.StandardTokenType,StatusBarAlignment:F.StatusBarAlignment,SymbolInformation:F.SymbolInformation,SymbolKind:F.SymbolKind,SymbolTag:F.SymbolTag,Task:F.Task,TaskGroup:F.TaskGroup,TaskPanelKind:F.TaskPanelKind,TaskRevealKind:F.TaskRevealKind,TaskScope:F.TaskScope,TerminalLink:F.TerminalLink,TerminalLocation:F.TerminalLocation,TerminalProfile:F.TerminalProfile,TextDocumentSaveReason:F.TextDocumentSaveReason,TextEdit:F.TextEdit,TextEditorCursorStyle:T.TextEditorCursorStyle,TextEditorLineNumbersStyle:F.TextEditorLineNumbersStyle,TextEditorRevealType:F.TextEditorRevealType,TextEditorSelectionChangeKind:F.TextEditorSelectionChangeKind,TextDocumentChangeReason:F.TextDocumentChangeReason,ThemeColor:F.ThemeColor,ThemeIcon:F.ThemeIcon,TreeItem:F.TreeItem,TreeItemCollapsibleState:F.TreeItemCollapsibleState,TypeHierarchyItem:F.TypeHierarchyItem,UIKind:I.UIKind,Uri:D.URI,ViewColumn:F.ViewColumn,WorkspaceEdit:F.WorkspaceEdit,DocumentDropEdit:F.DocumentDropEdit,DocumentPasteEdit:F.DocumentPasteEdit,InlayHint:F.InlayHint,InlayHintLabelPart:F.InlayHintLabelPart,InlayHintKind:F.InlayHintKind,RemoteAuthorityResolverError:F.RemoteAuthorityResolverError,ResolvedAuthority:F.ResolvedAuthority,SourceControlInputBoxValidationType:F.SourceControlInputBoxValidationType,ExtensionRuntime:F.ExtensionRuntime,TimelineItem:F.TimelineItem,NotebookRange:F.NotebookRange,NotebookCellKind:F.NotebookCellKind,NotebookCellExecutionState:F.NotebookCellExecutionState,NotebookCellData:F.NotebookCellData,NotebookData:F.NotebookData,NotebookRendererScript:F.NotebookRendererScript,NotebookCellStatusBarAlignment:F.NotebookCellStatusBarAlignment,NotebookEditorRevealType:F.NotebookEditorRevealType,NotebookCellOutput:F.NotebookCellOutput,NotebookCellOutputItem:F.NotebookCellOutputItem,NotebookCellStatusBarItem:F.NotebookCellStatusBarItem,NotebookControllerAffinity:F.NotebookControllerAffinity,NotebookEdit:F.NotebookEdit,PortAttributes:F.PortAttributes,LinkedEditingRanges:F.LinkedEditingRanges,TestResultState:F.TestResultState,TestRunRequest:F.TestRunRequest,TestMessage:F.TestMessage,TestTag:F.TestTag,TestRunProfileKind:F.TestRunProfileKind,TextSearchCompleteMessageType:nt.TextSearchCompleteMessageType,DataTransfer:F.DataTransfer,DataTransferItem:F.DataTransferItem,CoveredCount:F.CoveredCount,FileCoverage:F.FileCoverage,StatementCoverage:F.StatementCoverage,BranchCoverage:F.BranchCoverage,FunctionCoverage:F.FunctionCoverage,WorkspaceTrustState:F.WorkspaceTrustState,LanguageStatusSeverity:F.LanguageStatusSeverity,QuickPickItemKind:F.QuickPickItemKind,InputBoxValidationSeverity:F.InputBoxValidationSeverity,TabInputText:F.TextTabInput,TabInputTextDiff:F.TextDiffTabInput,TabInputTextMerge:F.TextMergeTabInput,TabInputCustom:F.CustomEditorTabInput,TabInputNotebook:F.NotebookEditorTabInput,TabInputNotebookDiff:F.NotebookDiffEditorTabInput,TabInputWebview:F.WebviewEditorTabInput,TabInputTerminal:F.TerminalEditorTabInput,TabInputInteractiveWindow:F.InteractiveWindowInput,TerminalExitReason:F.TerminalExitReason}}}e.createApiFactoryAndRegisterActors=dt}),define(De[236],Ce([1,0,235,33,2,229,6,13,220]),function(te,e,o,p,b,L,D,T,E){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.ExtHostExtensionService=void 0;class P extends L.RequireInterceptor{_installInterceptor(){}getModule(I,f){for(const h of this._alternatives){const d=h(I);if(d){I=d;break}}if(this._factories.has(I))return this._factories.get(I).load(I,f,()=>{throw new Error("CANNOT LOAD MODULE from here.")})}}class R extends p.AbstractExtHostExtensionService{constructor(){super(...arguments);this.extensionRuntime=D.ExtensionRuntime.Webworker}async _beforeAlmostReadyToRunExtensions(){this._instaService.createInstance(E.ExtHostConsoleForwarder);const I=this._instaService.invokeFunction(o.createApiFactoryAndRegisterActors);this._fakeModules=this._instaService.createInstance(P,I,{mine:this._myRegistry,all:this._globalRegistry}),await this._fakeModules.install(),performance.mark("code/extHost/didInitAPI"),await this._waitForDebuggerAttachment()}_getEntryPoint(I){return I.browser}async _loadCommonJSModule(I,f,h){f=f.with({path:y(f.path,".js")}),I&&performance.mark(`code/extHost/willFetchExtensionCode/${I.value}`);const d=b.URI.revive(await this._mainThreadExtensionsProxy.$asBrowserUri(f)),a=await fetch(d.toString(!0));if(I&&performance.mark(`code/extHost/didFetchExtensionCode/${I.value}`),a.status!==200)throw new Error(a.statusText);const v=await a.text(),A=`${f.toString(!0)}#vscode-extension`,l=`${v}
//# sourceURL=${A}`;let _;try{_=new Function("module","exports","require",l)}catch(i){throw console.error(I?`Loading code for extension ${I.value} failed: ${i.message}`:`Loading code failed: ${i.message}`),console.error(`${f.toString(!0)}${typeof i.line=="number"?` line ${i.line}`:""}${typeof i.column=="number"?` column ${i.column}`:""}`),console.error(i),i}const s={},u={exports:s},n=i=>{const r=this._fakeModules.getModule(i,f);if(r===void 0)throw new Error(`Cannot load module '${i}'`);return r};try{return h.codeLoadingStart(),I&&performance.mark(`code/extHost/willLoadExtensionCode/${I.value}`),_(u,s,n),u.exports!==s?u.exports:s}finally{I&&performance.mark(`code/extHost/didLoadExtensionCode/${I.value}`),h.codeLoadingStop()}}async $setRemoteEnvironment(I){}async _waitForDebuggerAttachment(I=5e3){if(!this._initData.environment.isExtensionDevelopmentDebug)return;const f=Date.now()+I;for(;Date.now()<f&&!("__jsDebugIsReady"in globalThis);)await(0,T.timeout)(10)}}e.ExtHostExtensionService=R;function y(m,I){return m.endsWith(I)?m:m+I}}),define(De[237],Ce([1,0,56,33,70,236]),function(te,e,o,p,b,L){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),(0,o.registerSingleton)(p.IExtHostExtensionService,L.ExtHostExtensionService),(0,o.registerSingleton)(b.IExtensionStoragePaths,b.ExtensionStoragePaths)}),define(De[246],Ce([1,0,22,4,94,230,222,19,71,12,2,232,237]),function(te,e,o,p,b,L,D,T,E,P,R){"use strict";Object.defineProperty(e,"__esModule",{value:!0}),e.create=void 0;const y=self.close.bind(self);self.close=()=>console.trace("'close' has been blocked");const m=postMessage.bind(self);self.postMessage=()=>console.trace("'postMessage' has been blocked");function I(s){return/^(file|vscode-remote):/i.test(s)}const f=fetch.bind(self);function h(s){self.fetch=async function(u,n){return u instanceof Request||I(String(u))&&(u=(await s(R.URI.parse(String(u)))).toString(!0)),f(u,n)},self.XMLHttpRequest=class extends XMLHttpRequest{open(u,n,i,r,t){(async()=>{I(n.toString())&&(n=(await s(R.URI.parse(n.toString()))).toString(!0)),super.open(u,n,i??!0,r,t)})()}}}if(self.importScripts=()=>{throw new Error("'importScripts' has been blocked")},self.addEventListener=()=>console.trace("'addEventListener' has been blocked"),self.AMDLoader=void 0,self.NLSLoaderPlugin=void 0,self.define=void 0,self.require=void 0,self.webkitRequestFileSystem=void 0,self.webkitRequestFileSystemSync=void 0,self.webkitResolveLocalFileSystemSyncURL=void 0,self.webkitResolveLocalFileSystemURL=void 0,self.Worker){const s=self.Worker;Worker=function(u,n){if(/^file:/i.test(u.toString()))u=P.FileAccess.asBrowserUri(R.URI.parse(u.toString())).toString(!0);else if(/^vscode-remote:/i.test(u.toString()))throw new Error("Creating workers from remote extensions is currently not supported.");const r=`(${function(g){function C(M){return typeof M=="string"||M instanceof URL?String(M).replace(/^file:\/\//i,"vscode-file://vscode-app"):M}const U=fetch.bind(self);self.fetch=function(M,S){return M instanceof Request?U(M,S):U(C(M),S)},self.XMLHttpRequest=class extends XMLHttpRequest{open(M,S,z,$,N){return super.open(M,C(S),z??!0,$,N)}};const W=importScripts.bind(self);self.importScripts=(...M)=>{W(...M.map(C))},W(g)}.toString()}('${u}'))`;n=n||{},n.name=n.name||T.basename(u.toString());const t=new Blob([r],{type:"application/javascript"}),c=URL.createObjectURL(t);return new s(c,n)}}else self.Worker=class extends D.NestedWorker{constructor(s,u){super(m,s,{name:T.basename(s.toString()),...u})}};const d=new class{constructor(){this.pid=void 0}exit(s){y()}async exists(s){return!0}async realpath(s){return s}};class a{constructor(){const u=new MessageChannel,n=new p.Emitter;let i=!1;m(u.port2,[u.port2]),u.port1.onmessage=r=>{const{data:t}=r;if(!(t instanceof ArrayBuffer)){console.warn("UNKNOWN data received",t);return}const c=o.VSBuffer.wrap(new Uint8Array(t,0,t.byteLength));if((0,b.isMessageOfType)(c,2)){i=!0,A("received terminate message from renderer");return}n.fire(c)},this.protocol={onMessage:n.event,send:r=>{if(!i){const t=r.buffer.buffer.slice(r.buffer.byteOffset,r.buffer.byteOffset+r.buffer.byteLength);u.port1.postMessage(t,[t])}}}}}function v(s){return new Promise(u=>{const n=s.onMessage(i=>{n.dispose();const r=JSON.parse(i.toString());s.send((0,b.createMessageOfType)(0)),u({protocol:s,initData:r})});s.send((0,b.createMessageOfType)(1))})}let A=s=>y();function l(s){return!!s&&typeof s=="object"&&s.type==="vscode.init"&&s.data instanceof Map}function _(){E.mark("code/extHost/willConnectToRenderer");const s=new a;return{onmessage(u){!l(u)||v(s.protocol).then(n=>{E.mark("code/extHost/didWaitForInitData");const i=new L.ExtensionHostMain(n.protocol,n.initData,d,null,u.data);h(r=>i.asBrowserUri(r)),A=r=>i.terminate(r)})}}}e.create=_})}).call(this);

//# sourceMappingURL=https://ticino.blob.core.windows.net/sourcemaps/73fd3f11032e7b83c2ae011b5516e6ddd19e3db2/core/vs/workbench/api/worker/extensionHostWorker.js.map
